/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "ekvdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

int ekvsetup (SMPmatrix *matrix, GENmodel *inModel, CKTcircuit *ckt, int *states)
     /* load the ekv device structure with those pointers needed later 
      * for fast matrix loading 
      */
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;
  
  /*  loop through all the ekv device models */
  for ( ;model != NULL ;model = ekvnextModel(model) )
  {
    if(model->nmos_Given == FALSE) model->nmos=1;
    if(model->pmos_Given == FALSE) model->pmos=1;
    if(model->type_Given == FALSE) model->type=1;
    if(model->tnom_Given == FALSE) model->tnom=27.0;
    if(model->imax_Given == FALSE) model->imax=1.0;
    if(model->tox_Given == FALSE) model->tox=0.0;
    if(model->nsub_Given == FALSE) model->nsub=0.0;
    if(model->vfb_Given == FALSE) model->vfb=(-1.0);
    if(model->uo_Given == FALSE) model->uo=0.0;
    if(model->vmax_Given == FALSE) model->vmax=0.0;
    if(model->theta_Given == FALSE) model->theta=0.0;
    if(model->cox_Given == FALSE) model->cox=0.7e-3;
    if(model->xj_Given == FALSE) model->xj=0.1e-6;
    if(model->dl_Given == FALSE) model->dl=0.0;
    if(model->dw_Given == FALSE) model->dw=0.0;
    if(model->gamma_Given == FALSE) model->gamma=0.7;
    if(model->phi_Given == FALSE) model->phi=0.5;
    if(model->vto_Given == FALSE) model->vto=0.5;
    if(model->kp_Given == FALSE) model->kp=20e-6;
    if(model->ucrit_Given == FALSE) model->ucrit=1.0e+6;
    if(model->e0_Given == FALSE) model->e0=1.0e-9;
    if(model->lambda_Given == FALSE) model->lambda=0.5;
    if(model->weta_Given == FALSE) model->weta=0.25;
    if(model->leta_Given == FALSE) model->leta=0.1;
    if(model->q0_Given == FALSE) model->q0=0.0;
    if(model->lk_Given == FALSE) model->lk=0.29e-6;
    if(model->iba_Given == FALSE) model->iba=0.0;
    if(model->ibb_Given == FALSE) model->ibb=3e8;
    if(model->ibn_Given == FALSE) model->ibn=1.0;
    if(model->tcv_Given == FALSE) model->tcv=1e-3;
    if(model->bex_Given == FALSE) model->bex=(-1.5);
    if(model->ucex_Given == FALSE) model->ucex=0.8;
    if(model->ibbt_Given == FALSE) model->ibbt=9e-4;
    if(model->avto_Given == FALSE) model->avto=0.0;
    if(model->akp_Given == FALSE) model->akp=0.0;
    if(model->agamma_Given == FALSE) model->agamma=0.0;
    if(model->kf_Given == FALSE) model->kf=0.0;
    if(model->af_Given == FALSE) model->af=1.0;
    if(model->hdif_Given == FALSE) model->hdif=0.0;
    if(model->rsh_Given == FALSE) model->rsh=0.0;
    if(model->js_Given == FALSE) model->js=0.0;
    if(model->jsw_Given == FALSE) model->jsw=0.0;
    if(model->xti_Given == FALSE) model->xti=0.0;
    if(model->n_Given == FALSE) model->n=1;
    if(model->cj_Given == FALSE) model->cj=0.0;
    if(model->cjsw_Given == FALSE) model->cjsw=0.0;
    if(model->pb_Given == FALSE) model->pb=0.8;
    if(model->pbsw_Given == FALSE) model->pbsw=model->pb;
    if(model->mj_Given == FALSE) model->mj=0.5;
    if(model->mjsw_Given == FALSE) model->mjsw=0.333;
    if(model->fc_Given == FALSE) model->fc=0.5;
    if(model->fcsw_Given == FALSE) model->fcsw=model->fc;
    if(model->cgso_Given == FALSE) model->cgso=1.5e-10;
    if(model->cgdo_Given == FALSE) model->cgdo=1.5e-10;
    if(model->cgbo_Given == FALSE) model->cgbo=4.0e-10;
    for ( here = ekvinstances(model) ;here != NULL ; here = ekvnextInstance(here) )
    {
    if(here->l_Given == FALSE) here->l=10e-6;
    if(here->w_Given == FALSE) here->w=10e-6;
    if(here->m_Given == FALSE) here->m=1.0;
    if(here->ns_Given == FALSE) here->ns=1.0;
    if(here->dtemp_Given == FALSE) here->dtemp=0.0;
    if(here->ad_Given == FALSE) here->ad=0.0;
    if(here->as_Given == FALSE) here->as=0.0;
    if(here->pd_Given == FALSE) here->pd=0.0;
    if(here->ps_Given == FALSE) here->ps=0.0;
    if(here->nrd_Given == FALSE) here->nrd=0.0;
    if(here->nrs_Given == FALSE) here->nrs=0.0;
      /* External Nodes, connected ? */
      here->dNode_connected = (here->dNode >= 0);
      here->gNode_connected = (here->gNode >= 0);
      here->sNode_connected = (here->sNode >= 0);
      here->bNode_connected = (here->bNode >= 0);
      /* Internal Nodes */
      {
        here->dpNode = -1;
        here->dpNode_mine = 0;
        here->spNode = -1;
        here->spNode_mine = 0;
      }
       ((GENinstance*)here)->GENstate = *states;
       *states += ekvnumStates;
      /* set states */
      here->state_g_dp = *states; *states += 2;
      here->state_g_sp = *states; *states += 2;
      here->state_b_dp = *states; *states += 2;
      here->state_b_sp = *states; *states += 2;
      here->state_g_b = *states; *states += 2;
      here->state_sp_b = *states; *states += 2;
      here->state_dp_b = *states; *states += 2;
      /* set Sparse Matrix Pointers */
      here->PTR_J_dp_sp_required=0;
      here->PTR_J_dp_b_required=0;
      here->PTR_J_sp_sp_required=0;
      here->PTR_J_sp_b_required=0;
      here->PTR_J_dp_dp_required=0;
      here->PTR_J_sp_dp_required=0;
      here->PTR_J_dp_g_required=0;
      here->PTR_J_sp_g_required=0;
      here->PTR_J_b_sp_required=0;
      here->PTR_J_b_b_required=0;
      here->PTR_J_b_dp_required=0;
      here->PTR_J_b_g_required=0;
      here->PTR_J_g_sp_required=0;
      here->PTR_J_g_b_required=0;
      here->PTR_J_g_dp_required=0;
      here->PTR_J_g_g_required=0;
      here->PTR_J_d_d_required=0;
      here->PTR_J_d_dp_required=0;
      here->PTR_J_dp_d_required=0;
      here->PTR_J_s_s_required=0;
      here->PTR_J_s_sp_required=0;
      here->PTR_J_sp_s_required=0;

      ekvguesstopology(matrix,ckt,model,here);

      /* Internal Nodes */
      {
        int error;
        CKTnode *tmp;
        if(here->dNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XdX");
          if(error) return(error);
          here->dNode = tmp->number;
          here->dNode_mine = 1;
        }
        if(here->gNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XgX");
          if(error) return(error);
          here->gNode = tmp->number;
          here->gNode_mine = 1;
        }
        if(here->sNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XsX");
          if(error) return(error);
          here->sNode = tmp->number;
          here->sNode_mine = 1;
        }
        if(here->bNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XbX");
          if(error) return(error);
          here->bNode = tmp->number;
          here->bNode_mine = 1;
        }
        if(here->dpNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XdpX");
          if(error) return(error);
          here->dpNode = tmp->number;
          here->dpNode_mine = 1;
        }
        if(here->spNode == -1)
        {
          error=CKTmkVolt(ckt,&tmp,here->ekvname,"XspX");
          if(error) return(error);
          here->spNode = tmp->number;
          here->spNode_mine = 1;
        }
      }
        if(here->PTR_J_dp_sp_required==1)
        {
          here->PTR_J_dp_sp=SMPmakeElt(matrix,here->dpNode,here->spNode);
        }
        if(here->PTR_J_dp_b_required==1)
        {
          here->PTR_J_dp_b=SMPmakeElt(matrix,here->dpNode,here->bNode);
        }
        if(here->PTR_J_sp_sp_required==1)
        {
          here->PTR_J_sp_sp=SMPmakeElt(matrix,here->spNode,here->spNode);
        }
        if(here->PTR_J_sp_b_required==1)
        {
          here->PTR_J_sp_b=SMPmakeElt(matrix,here->spNode,here->bNode);
        }
        if(here->PTR_J_dp_dp_required==1)
        {
          here->PTR_J_dp_dp=SMPmakeElt(matrix,here->dpNode,here->dpNode);
        }
        if(here->PTR_J_sp_dp_required==1)
        {
          here->PTR_J_sp_dp=SMPmakeElt(matrix,here->spNode,here->dpNode);
        }
        if(here->PTR_J_dp_g_required==1)
        {
          here->PTR_J_dp_g=SMPmakeElt(matrix,here->dpNode,here->gNode);
        }
        if(here->PTR_J_sp_g_required==1)
        {
          here->PTR_J_sp_g=SMPmakeElt(matrix,here->spNode,here->gNode);
        }
        if(here->PTR_J_b_sp_required==1)
        {
          here->PTR_J_b_sp=SMPmakeElt(matrix,here->bNode,here->spNode);
        }
        if(here->PTR_J_b_b_required==1)
        {
          here->PTR_J_b_b=SMPmakeElt(matrix,here->bNode,here->bNode);
        }
        if(here->PTR_J_b_dp_required==1)
        {
          here->PTR_J_b_dp=SMPmakeElt(matrix,here->bNode,here->dpNode);
        }
        if(here->PTR_J_b_g_required==1)
        {
          here->PTR_J_b_g=SMPmakeElt(matrix,here->bNode,here->gNode);
        }
        if(here->PTR_J_g_sp_required==1)
        {
          here->PTR_J_g_sp=SMPmakeElt(matrix,here->gNode,here->spNode);
        }
        if(here->PTR_J_g_b_required==1)
        {
          here->PTR_J_g_b=SMPmakeElt(matrix,here->gNode,here->bNode);
        }
        if(here->PTR_J_g_dp_required==1)
        {
          here->PTR_J_g_dp=SMPmakeElt(matrix,here->gNode,here->dpNode);
        }
        if(here->PTR_J_g_g_required==1)
        {
          here->PTR_J_g_g=SMPmakeElt(matrix,here->gNode,here->gNode);
        }
        if(here->PTR_J_d_d_required==1)
        {
          here->PTR_J_d_d=SMPmakeElt(matrix,here->dNode,here->dNode);
        }
        if(here->PTR_J_d_dp_required==1)
        {
          here->PTR_J_d_dp=SMPmakeElt(matrix,here->dNode,here->dpNode);
        }
        if(here->PTR_J_dp_d_required==1)
        {
          here->PTR_J_dp_d=SMPmakeElt(matrix,here->dpNode,here->dNode);
        }
        if(here->PTR_J_s_s_required==1)
        {
          here->PTR_J_s_s=SMPmakeElt(matrix,here->sNode,here->sNode);
        }
        if(here->PTR_J_s_sp_required==1)
        {
          here->PTR_J_s_sp=SMPmakeElt(matrix,here->sNode,here->spNode);
        }
        if(here->PTR_J_sp_s_required==1)
        {
          here->PTR_J_sp_s=SMPmakeElt(matrix,here->spNode,here->sNode);
        }

    }
  }
  return(OK);
}


int
ekvunsetup(GENmodel *inModel, CKTcircuit *ckt)
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;

  /*  loop through all the ekv device models */
  for ( ;model != NULL ;model = ekvnextModel(model) )
  {
    for ( here = ekvinstances(model) ;here != NULL ; here = ekvnextInstance(here) )
    {
        if (here->dNode_mine) {
            if (here->dNode > 0)
                CKTdltNNum(ckt, here->dNode);
            here->dNode_mine = 0;
        }
        if (!here->dNode_connected)
            here->dNode = -1;
        if (here->gNode_mine) {
            if (here->gNode > 0)
                CKTdltNNum(ckt, here->gNode);
            here->gNode_mine = 0;
        }
        if (!here->gNode_connected)
            here->gNode = -1;
        if (here->sNode_mine) {
            if (here->sNode > 0)
                CKTdltNNum(ckt, here->sNode);
            here->sNode_mine = 0;
        }
        if (!here->sNode_connected)
            here->sNode = -1;
        if (here->bNode_mine) {
            if (here->bNode > 0)
                CKTdltNNum(ckt, here->bNode);
            here->bNode_mine = 0;
        }
        if (!here->bNode_connected)
            here->bNode = -1;
        if (here->spNode_mine)
            if (here->spNode > 0)
                CKTdltNNum(ckt, here->spNode);
        here->spNode = -1;
        here->spNode_mine = 0;
        if (here->dpNode_mine)
            if (here->dpNode > 0)
                CKTdltNNum(ckt, here->dpNode);
        here->dpNode = -1;
        here->dpNode_mine = 0;
    }
  }
  return OK;
}
