/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/

#define NGSPICE_DEBUG_OK


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "r2_cmcdefs.h"
#include "ngspice/const.h"
#include "ngspice/trandefs.h"
#include "ngspice/sperror.h"
#include "ngspice/devdefs.h"
#include "ngspice/suffix.h"

/*fixme: noise not implemented in ngspice*/
#define ngspice_flickernoise(p,n,mag,freq,info)\
{\
}
#define ngspice_whitenoise(p,n,mag,info)\
{\
}

#define NP(p) *(ckt->CKTrhsOld+here->p ## Node)
#define BP(p,n) (NP(p)-NP(n))
#define DBGNODE(p) printf(#p "=%i - v=%e\n",here->p ## Node,NP(p));
static void r2_cmcdebug (CKTcircuit *ckt, r2_cmcmodel *model, r2_cmcinstance *here)
{
  fprintf(stdout,"voltage: n1=%e\n",NP(n1));
  fprintf(stdout,"voltage: n2=%e\n",NP(n2));
  fprintf(stdout,"Parameter: model: m=%e\n",model->m);
  fprintf(stdout,"Parameter: instance: w=%e\n",here->w);
  fprintf(stdout,"Parameter: instance: l=%e\n",here->l);
  fprintf(stdout,"Parameter: instance: r=%e\n",here->r);
  fprintf(stdout,"Parameter: instance: c1=%i\n",here->c1);
  fprintf(stdout,"Parameter: instance: c2=%i\n",here->c2);
  fprintf(stdout,"Parameter: instance: trise=%e\n",here->trise);
  fprintf(stdout,"Parameter: instance: isnoisy=%i\n",here->isnoisy);
  fprintf(stdout,"Parameter: model: version=%e\n",model->version);
  fprintf(stdout,"Parameter: model: revision=%e\n",model->revision);
  fprintf(stdout,"Parameter: model: scale=%e\n",model->scale);
  fprintf(stdout,"Parameter: model: shrink=%e\n",model->shrink);
  fprintf(stdout,"Parameter: model: tmin=%e\n",model->tmin);
  fprintf(stdout,"Parameter: model: tmax=%e\n",model->tmax);
  fprintf(stdout,"Parameter: model: rthresh=%e\n",model->rthresh);
  fprintf(stdout,"Parameter: model: level=%e\n",model->level);
  fprintf(stdout,"Parameter: model: tnom=%e\n",model->tnom);
  fprintf(stdout,"Parameter: model: rsh=%e\n",model->rsh);
  fprintf(stdout,"Parameter: model: lmin=%e\n",model->lmin);
  fprintf(stdout,"Parameter: model: lmax=%e\n",model->lmax);
  fprintf(stdout,"Parameter: model: wmin=%e\n",model->wmin);
  fprintf(stdout,"Parameter: model: wmax=%e\n",model->wmax);
  fprintf(stdout,"Parameter: model: xw=%e\n",model->xw);
  fprintf(stdout,"Parameter: model: xl=%e\n",model->xl);
  fprintf(stdout,"Parameter: model: dxle=%e\n",model->dxle);
  fprintf(stdout,"Parameter: model: sw_efgeo=%i\n",model->sw_efgeo);
  fprintf(stdout,"Parameter: model: q3=%e\n",model->q3);
  fprintf(stdout,"Parameter: model: p3=%e\n",model->p3);
  fprintf(stdout,"Parameter: model: q2=%e\n",model->q2);
  fprintf(stdout,"Parameter: model: p2=%e\n",model->p2);
  fprintf(stdout,"Parameter: model: kfn=%e\n",model->kfn);
  fprintf(stdout,"Parameter: model: afn=%e\n",model->afn);
  fprintf(stdout,"Parameter: model: bfn=%e\n",model->bfn);
  fprintf(stdout,"Parameter: model: sw_fngeo=%i\n",model->sw_fngeo);
  fprintf(stdout,"Parameter: model: jmax=%e\n",model->jmax);
  fprintf(stdout,"Parameter: model: tminclip=%e\n",model->tminclip);
  fprintf(stdout,"Parameter: model: tmaxclip=%e\n",model->tmaxclip);
  fprintf(stdout,"Parameter: model: tc1=%e\n",model->tc1);
  fprintf(stdout,"Parameter: model: tc2=%e\n",model->tc2);
  fprintf(stdout,"Parameter: model: tc1l=%e\n",model->tc1l);
  fprintf(stdout,"Parameter: model: tc2l=%e\n",model->tc2l);
  fprintf(stdout,"Parameter: model: tc1w=%e\n",model->tc1w);
  fprintf(stdout,"Parameter: model: tc2w=%e\n",model->tc2w);
  fprintf(stdout,"Parameter: model: tc1kfn=%e\n",model->tc1kfn);
  fprintf(stdout,"instance: r0=%e\n",here->r0);
  fprintf(stdout,"instance: weff_um=%e\n",here->weff_um);
  fprintf(stdout,"instance: leff_um=%e\n",here->leff_um);
  fprintf(stdout,"instance: tdevK=%e\n",here->tdevK);
  fprintf(stdout,"instance: l_um=%e\n",here->l_um);
  fprintf(stdout,"instance: w_um=%e\n",here->w_um);
  fprintf(stdout,"instance: l_umForE=%e\n",here->l_umForE);
  fprintf(stdout,"instance: g0=%e\n",here->g0);
  fprintf(stdout,"instance: r0_t=%e\n",here->r0_t);
  fprintf(stdout,"instance: g0_t=%e\n",here->g0_t);
  fprintf(stdout,"instance: kfn_t=%e\n",here->kfn_t);
}


#define _STATIC
#define _DYNAMIC
#define _DERIVATE

#define _load_static_residual2(p,n,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;\
  *(ckt->CKTrhs+here->n ## Node)+=v;
#define _load_static_residual1(p,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;

#define _load_static_jacobian4(Sp,Sn,Pp,Pn,v)\
  _load_static_residual2(Sp,Sn,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2s(Sp,Sn,Pp,v)\
  _load_static_residual2(Sp,Sn,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2p(Sp,Pp,Pn,v)\
  _load_static_residual1(Sp,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_static_jacobian1(Sp,Pp,v)\
  _load_static_residual1(Sp,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;

#define _load_dynamic_residual2(p,n,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_##n)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n)=*(ckt->CKTstate0+here->state_##p##_##n);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_##n);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n+1) = *(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->n##Node)+=*(ckt->CKTstate0+here->state_##p##_##n+1);\
}
#define _load_dynamic_residual1(p,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_GND)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND)=*(ckt->CKTstate0+here->state_##p##_GND);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_GND);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND+1) = *(ckt->CKTstate0+here->state_##p##_GND+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_GND+1);\
}

#define _load_dynamic_jacobian4(Sp,Sn,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2s(Sp,Sn,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2p(Sp,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_dynamic_jacobian1(Sp,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
}\
(here->JDVAL_ ## Sp ## _ ## Pp)+=v;

int r2_cmcload(GENmodel *inModel, CKTcircuit *ckt)
     /* actually load the current value into the 
      * sparse matrix previously provided 
      */
{
  r2_cmcmodel *model = (r2_cmcmodel*)inModel;
  r2_cmcinstance *here;
  int ChargeComputationNeeded =  
                 ((ckt->CKTmode & (MODEAC | MODETRAN | MODEINITSMSIG)) ||
                 ((ckt->CKTmode & MODETRANOP) && (ckt->CKTmode & MODEUIC)))
                 ? 1 : 0;

  for ( ; model != NULL; model = r2_cmcnextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = r2_cmcinstances(model); here != NULL ; here = r2_cmcnextInstance(here))
    {
{  here->JSVAL_n1_n1=0.0;
  here->JSVAL_n1_n2=0.0;
  here->JSVAL_n2_n1=0.0;
  here->JSVAL_n2_n2=0.0;

}
{
#include "r2_cmc.hxx"
}
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
