

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
pInst->fpnoise0=0.0; pInst->fenoise0=0.0;
pInst->fpnoise1=0.0; pInst->fenoise1=0.0;
pInst->fpnoise2=0.0; pInst->fenoise2=0.0;
pInst->fpnoise3=0.0; pInst->fenoise3=0.0;
pInst->fpnoise4=0.0; pInst->fenoise4=0.0;
pInst->fpnoise5=0.0; pInst->fenoise5=0.0;
pInst->wnoise0=0.0;
pInst->wnoise1=0.0;
pInst->wnoise2=0.0;
pInst->wnoise3=0.0;
pInst->wnoise4=0.0;
pInst->wnoise5=0.0;
pInst->wnoise6=0.0;
pInst->wnoise7=0.0;
pInst->wnoise8=0.0;
pInst->wnoise9=0.0;
pInst->wnoise10=0.0;
pInst->wnoise11=0.0;
pInst->wnoise12=0.0;
pInst->wnoise13=0.0;
pInst->wnoise14=0.0;
pInst->wnoise15=0.0;
pInst->wnoise16=0.0;
pInst->wnoise17=0.0;
pInst->wnoise18=0.0;
pInst->wnoise19=0.0;
double taut;
double xrex;
double rex;
double rb1b2;
double ry;
double rz;
double rx;
double alpha_ft;
double gbfz;
double gbfy;
double gbfx;
double gammaz;
double gammay;
double gammax;
double gpi;
double dydz;
double dydx;
double powerSubsCS_BS;
#if defined(_DERIVATE)
double powerSubsCS_BS_Vdt_GND;
double powerSubsCS_BS_Vb_c;
double powerSubsCS_BS_Vb_b1;
double powerSubsCS_BS_Vb1_b2;
double powerSubsCS_BS_Vc4_c1;
double powerSubsCS_BS_Vc3_c1;
double powerSubsCS_BS_Vc3_c4;
double powerSubsCS_BS_Vb2_e1;
double powerSubsCS_BS_Vb2_c2;
double powerSubsCS_BS_Vb2_c1;
double powerSubsCS_BS_Vc1_c2;
double powerSubsCS_BS_Vs_c1;
#endif
double powerSubsCS_B1S;
#if defined(_DERIVATE)
double powerSubsCS_B1S_Vdt_GND;
double powerSubsCS_B1S_Vb1_b2;
double powerSubsCS_B1S_Vb2_c2;
double powerSubsCS_B1S_Vc1_c2;
double powerSubsCS_B1S_Vc4_c1;
double powerSubsCS_B1S_Vs_c1;
#endif
double powerExC1fMOD;
#if defined(_DERIVATE)
double powerExC1fMOD_Vdt_GND;
double powerExC1fMOD_Vb_c;
double powerExC1fMOD_Vb_b1;
double powerExC1fMOD_Vb1_b2;
double powerExC1fMOD_Vc4_c1;
double powerExC1fMOD_Vc3_c1;
double powerExC1fMOD_Vc3_c4;
double powerExC1fMOD_Vb2_e1;
double powerExC1fMOD_Vb2_c2;
double powerExC1fMOD_Vb2_c1;
double powerExC1fMOD_Vc1_c2;
double powerExC1fMOD_Vs_c1;
#endif
double powerExCSMOD;
#if defined(_DERIVATE)
double powerExCSMOD_Vdt_GND;
double powerExCSMOD_Vb_c;
double powerExCSMOD_Vb_b1;
double powerExCSMOD_Vb1_b2;
double powerExCSMOD_Vc4_c1;
double powerExCSMOD_Vc3_c1;
double powerExCSMOD_Vc3_c4;
double powerExCSMOD_Vb2_e1;
double powerExCSMOD_Vb2_c2;
double powerExCSMOD_Vb2_c1;
double powerExCSMOD_Vc1_c2;
double powerExCSMOD_Vs_c1;
#endif
double powerExC1f;
#if defined(_DERIVATE)
double powerExC1f_Vdt_GND;
double powerExC1f_Vb1_b2;
double powerExC1f_Vb2_c2;
double powerExC1f_Vc1_c2;
double powerExC1f_Vc4_c1;
#endif
double powerExCS;
#if defined(_DERIVATE)
double powerExCS_Vdt_GND;
double powerExCS_Vb1_b2;
double powerExCS_Vb2_c2;
double powerExCS_Vc1_c2;
double powerExCS_Vc4_c1;
#endif
double powerRBC1f;
#if defined(_DERIVATE)
double powerRBC1f_Vdt_GND;
double powerRBC1f_Vb1_b2;
double powerRBC1f_Vb2_c2;
double powerRBC1f_Vc1_c2;
double powerRBC1f_Vc4_c1;
double powerRBC1f_Vb2_e1;
#endif
double powerRBCS;
#if defined(_DERIVATE)
double powerRBCS_Vdt_GND;
double powerRBCS_Vb1_b2;
double powerRBCS_Vb2_c2;
double powerRBCS_Vc1_c2;
double powerRBCS_Vc4_c1;
double powerRBCS_Vb2_e1;
#endif
double powerEBSC1f;
#if defined(_DERIVATE)
double powerEBSC1f_Vdt_GND;
double powerEBSC1f_Vb1_e1;
#endif
double powerEBSCS;
#if defined(_DERIVATE)
double powerEBSCS_Vdt_GND;
double powerEBSCS_Vb1_e1;
#endif
double powerFBC1fB2;
#if defined(_DERIVATE)
double powerFBC1fB2_Vdt_GND;
double powerFBC1fB2_Vb2_e1;
#endif
double exponentFBC1fB2;
double powerFBC1fB1;
#if defined(_DERIVATE)
double powerFBC1fB1_Vb2_c2;
double powerFBC1fB1_Vb2_c1;
double powerFBC1fB1_Vc1_c2;
double powerFBC1fB1_Vdt_GND;
double powerFBC1fB1_Vb2_e1;
#endif
double powerFBCS;
#if defined(_DERIVATE)
double powerFBCS_Vb2_c2;
double powerFBCS_Vb2_c1;
double powerFBCS_Vc1_c2;
double powerFBCS_Vdt_GND;
double powerFBCS_Vb2_e1;
#endif
#if defined(_DYNAMIC)
double taun;
#if defined(_DERIVATE)
double taun_Vdt_GND;
double taun_Vb2_e1;
double taun_Vb_c;
double taun_Vb_b1;
double taun_Vb1_b2;
double taun_Vc4_c1;
double taun_Vc3_c1;
double taun_Vc3_c4;
double taun_Vb2_c2;
double taun_Vb2_c1;
double taun_Vc1_c2;
#endif
#endif
#if defined(_DYNAMIC)
double Taub_N;
#if defined(_DERIVATE)
double Taub_N_Vdt_GND;
double Taub_N_Vb2_e1;
double Taub_N_Vb_c;
double Taub_N_Vb_b1;
double Taub_N_Vb1_b2;
double Taub_N_Vc4_c1;
double Taub_N_Vc3_c1;
double Taub_N_Vc3_c4;
double Taub_N_Vb2_c2;
double Taub_N_Vb2_c1;
double Taub_N_Vc1_c2;
#endif
#endif
double powerIIS;
#if defined(_DERIVATE)
double powerIIS_Vdt_GND;
double powerIIS_Vb2_c2;
double powerIIS_Vb2_c1;
double powerIIS_Vc1_c2;
double powerIIS_Vb_c;
double powerIIS_Vb_b1;
double powerIIS_Vb1_b2;
double powerIIS_Vc4_c1;
double powerIIS_Vc3_c1;
double powerIIS_Vc3_c4;
double powerIIS_Vb2_e1;
#endif
double Gem_N;
#if defined(_DERIVATE)
double Gem_N_Vdt_GND;
double Gem_N_Vb2_c2;
double Gem_N_Vb2_c1;
double Gem_N_Vc1_c2;
double Gem_N_Vb_c;
double Gem_N_Vb_b1;
double Gem_N_Vb1_b2;
double Gem_N_Vc4_c1;
double Gem_N_Vc3_c1;
double Gem_N_Vc3_c4;
double Gem_N_Vb2_e1;
#endif
double powerCCS;
#if defined(_DERIVATE)
double powerCCS_Vdt_GND;
double powerCCS_Vb2_e1;
double powerCCS_Vb2_c2;
double powerCCS_Vb2_c1;
double powerCCS_Vc1_c2;
#endif
double In_N;
#if defined(_DERIVATE)
double In_N_Vdt_GND;
double In_N_Vb2_e1;
double In_N_Vb2_c2;
double In_N_Vb2_c1;
double In_N_Vc1_c2;
#endif
double powerRBV;
#if defined(_DERIVATE)
double powerRBV_Vdt_GND;
double powerRBV_Vb_c;
double powerRBV_Vb_b1;
double powerRBV_Vb1_b2;
double powerRBV_Vc4_c1;
double powerRBV_Vc3_c1;
double powerRBV_Vc3_c4;
double powerRBV_Vb2_e1;
double powerRBV_Vb2_c2;
double powerRBV_Vb2_c1;
double powerRBV_Vc1_c2;
#endif
double powerRCCin;
#if defined(_DERIVATE)
double powerRCCin_Vdt_GND;
#endif
double powerRCCex;
#if defined(_DERIVATE)
double powerRCCex_Vdt_GND;
#endif
double powerRCCxx;
#if defined(_DERIVATE)
double powerRCCxx_Vdt_GND;
#endif
double powerRBC;
#if defined(_DERIVATE)
double powerRBC_Vdt_GND;
#endif
double powerREC;
#if defined(_DERIVATE)
double powerREC_Vdt_GND;
#endif
double common;
#if defined(_DERIVATE)
double common_Vdt_GND;
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX)
double Qbe_Vdt_GND;
double Qbe_Vb2_e1;
double Qbe_Vb_c;
double Qbe_Vb_b1;
double Qbe_Vb1_b2;
double Qbe_Vc4_c1;
double Qbe_Vc3_c1;
double Qbe_Vc3_c4;
double Qbe_Vb2_c2;
double Qbe_Vb2_c1;
double Qbe_Vc1_c2;
#if defined(_DERIVATE2)
  double Qbe_Vc1_c2_Vdt_GND;
  double Qbe_Vc1_c2_Vb2_e1;
  double Qbe_Vc1_c2_Vb_c;
  double Qbe_Vc1_c2_Vb_b1;
  double Qbe_Vc1_c2_Vb1_b2;
  double Qbe_Vc1_c2_Vc4_c1;
  double Qbe_Vc1_c2_Vc3_c1;
  double Qbe_Vc1_c2_Vc3_c4;
  double Qbe_Vc1_c2_Vb2_c2;
  double Qbe_Vc1_c2_Vb2_c1;
  double Qbe_Vc1_c2_Vc1_c2;
  double Qbe_Vb2_c1_Vdt_GND;
  double Qbe_Vb2_c1_Vb2_e1;
  double Qbe_Vb2_c1_Vb_c;
  double Qbe_Vb2_c1_Vb_b1;
  double Qbe_Vb2_c1_Vb1_b2;
  double Qbe_Vb2_c1_Vc4_c1;
  double Qbe_Vb2_c1_Vc3_c1;
  double Qbe_Vb2_c1_Vc3_c4;
  double Qbe_Vb2_c1_Vb2_c2;
  double Qbe_Vb2_c1_Vb2_c1;
  double Qbe_Vb2_c1_Vc1_c2;
  double Qbe_Vb2_c2_Vdt_GND;
  double Qbe_Vb2_c2_Vb2_e1;
  double Qbe_Vb2_c2_Vb_c;
  double Qbe_Vb2_c2_Vb_b1;
  double Qbe_Vb2_c2_Vb1_b2;
  double Qbe_Vb2_c2_Vc4_c1;
  double Qbe_Vb2_c2_Vc3_c1;
  double Qbe_Vb2_c2_Vc3_c4;
  double Qbe_Vb2_c2_Vb2_c2;
  double Qbe_Vb2_c2_Vb2_c1;
  double Qbe_Vb2_c2_Vc1_c2;
  double Qbe_Vc3_c1_Vdt_GND;
  double Qbe_Vc3_c1_Vb2_e1;
  double Qbe_Vc3_c1_Vb_c;
  double Qbe_Vc3_c1_Vb_b1;
  double Qbe_Vc3_c1_Vb1_b2;
  double Qbe_Vc3_c1_Vc4_c1;
  double Qbe_Vc3_c1_Vc3_c1;
  double Qbe_Vc3_c1_Vc3_c4;
  double Qbe_Vc3_c1_Vb2_c2;
  double Qbe_Vc3_c1_Vb2_c1;
  double Qbe_Vc3_c1_Vc1_c2;
  double Qbe_Vc4_c1_Vdt_GND;
  double Qbe_Vc4_c1_Vb2_e1;
  double Qbe_Vc4_c1_Vb_c;
  double Qbe_Vc4_c1_Vb_b1;
  double Qbe_Vc4_c1_Vb1_b2;
  double Qbe_Vc4_c1_Vc4_c1;
  double Qbe_Vc4_c1_Vc3_c1;
  double Qbe_Vc4_c1_Vc3_c4;
  double Qbe_Vc4_c1_Vb2_c2;
  double Qbe_Vc4_c1_Vb2_c1;
  double Qbe_Vc4_c1_Vc1_c2;
  double Qbe_Vb2_e1_Vdt_GND;
  double Qbe_Vb2_e1_Vb2_e1;
  double Qbe_Vb2_e1_Vb_c;
  double Qbe_Vb2_e1_Vb_b1;
  double Qbe_Vb2_e1_Vb1_b2;
  double Qbe_Vb2_e1_Vc4_c1;
  double Qbe_Vb2_e1_Vc3_c1;
  double Qbe_Vb2_e1_Vc3_c4;
  double Qbe_Vb2_e1_Vb2_c2;
  double Qbe_Vb2_e1_Vb2_c1;
  double Qbe_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX)
double Qbc_Vdt_GND;
double Qbc_Vb2_e1;
double Qbc_Vb_c;
double Qbc_Vb_b1;
double Qbc_Vb1_b2;
double Qbc_Vc4_c1;
double Qbc_Vc3_c1;
double Qbc_Vc3_c4;
double Qbc_Vb2_c2;
double Qbc_Vb2_c1;
double Qbc_Vc1_c2;
#if defined(_DERIVATE2)
  double Qbc_Vc1_c2_Vdt_GND;
  double Qbc_Vc1_c2_Vb2_e1;
  double Qbc_Vc1_c2_Vb_c;
  double Qbc_Vc1_c2_Vb_b1;
  double Qbc_Vc1_c2_Vb1_b2;
  double Qbc_Vc1_c2_Vc4_c1;
  double Qbc_Vc1_c2_Vc3_c1;
  double Qbc_Vc1_c2_Vc3_c4;
  double Qbc_Vc1_c2_Vb2_c2;
  double Qbc_Vc1_c2_Vb2_c1;
  double Qbc_Vc1_c2_Vc1_c2;
  double Qbc_Vb2_c1_Vdt_GND;
  double Qbc_Vb2_c1_Vb2_e1;
  double Qbc_Vb2_c1_Vb_c;
  double Qbc_Vb2_c1_Vb_b1;
  double Qbc_Vb2_c1_Vb1_b2;
  double Qbc_Vb2_c1_Vc4_c1;
  double Qbc_Vb2_c1_Vc3_c1;
  double Qbc_Vb2_c1_Vc3_c4;
  double Qbc_Vb2_c1_Vb2_c2;
  double Qbc_Vb2_c1_Vb2_c1;
  double Qbc_Vb2_c1_Vc1_c2;
  double Qbc_Vb2_c2_Vdt_GND;
  double Qbc_Vb2_c2_Vb2_e1;
  double Qbc_Vb2_c2_Vb_c;
  double Qbc_Vb2_c2_Vb_b1;
  double Qbc_Vb2_c2_Vb1_b2;
  double Qbc_Vb2_c2_Vc4_c1;
  double Qbc_Vb2_c2_Vc3_c1;
  double Qbc_Vb2_c2_Vc3_c4;
  double Qbc_Vb2_c2_Vb2_c2;
  double Qbc_Vb2_c2_Vb2_c1;
  double Qbc_Vb2_c2_Vc1_c2;
  double Qbc_Vc3_c1_Vdt_GND;
  double Qbc_Vc3_c1_Vb2_e1;
  double Qbc_Vc3_c1_Vb_c;
  double Qbc_Vc3_c1_Vb_b1;
  double Qbc_Vc3_c1_Vb1_b2;
  double Qbc_Vc3_c1_Vc4_c1;
  double Qbc_Vc3_c1_Vc3_c1;
  double Qbc_Vc3_c1_Vc3_c4;
  double Qbc_Vc3_c1_Vb2_c2;
  double Qbc_Vc3_c1_Vb2_c1;
  double Qbc_Vc3_c1_Vc1_c2;
  double Qbc_Vc4_c1_Vdt_GND;
  double Qbc_Vc4_c1_Vb2_e1;
  double Qbc_Vc4_c1_Vb_c;
  double Qbc_Vc4_c1_Vb_b1;
  double Qbc_Vc4_c1_Vb1_b2;
  double Qbc_Vc4_c1_Vc4_c1;
  double Qbc_Vc4_c1_Vc3_c1;
  double Qbc_Vc4_c1_Vc3_c4;
  double Qbc_Vc4_c1_Vb2_c2;
  double Qbc_Vc4_c1_Vb2_c1;
  double Qbc_Vc4_c1_Vc1_c2;
  double Qbc_Vb2_e1_Vdt_GND;
  double Qbc_Vb2_e1_Vb2_e1;
  double Qbc_Vb2_e1_Vb_c;
  double Qbc_Vb2_e1_Vb_b1;
  double Qbc_Vb2_e1_Vb1_b2;
  double Qbc_Vb2_e1_Vc4_c1;
  double Qbc_Vb2_e1_Vc3_c1;
  double Qbc_Vb2_e1_Vc3_c4;
  double Qbc_Vb2_e1_Vb2_c2;
  double Qbc_Vb2_e1_Vb2_c1;
  double Qbc_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbe_qs_eff;
#if defined(_DERIVATEFORDDX)
double Qbe_qs_eff_Vdt_GND;
double Qbe_qs_eff_Vb2_e1;
double Qbe_qs_eff_Vb_c;
double Qbe_qs_eff_Vb_b1;
double Qbe_qs_eff_Vb1_b2;
double Qbe_qs_eff_Vc4_c1;
double Qbe_qs_eff_Vc3_c1;
double Qbe_qs_eff_Vc3_c4;
double Qbe_qs_eff_Vb2_c2;
double Qbe_qs_eff_Vb2_c1;
double Qbe_qs_eff_Vc1_c2;
#if defined(_DERIVATE2)
  double Qbe_qs_eff_Vc1_c2_Vdt_GND;
  double Qbe_qs_eff_Vc1_c2_Vb2_e1;
  double Qbe_qs_eff_Vc1_c2_Vb_c;
  double Qbe_qs_eff_Vc1_c2_Vb_b1;
  double Qbe_qs_eff_Vc1_c2_Vb1_b2;
  double Qbe_qs_eff_Vc1_c2_Vc4_c1;
  double Qbe_qs_eff_Vc1_c2_Vc3_c1;
  double Qbe_qs_eff_Vc1_c2_Vc3_c4;
  double Qbe_qs_eff_Vc1_c2_Vb2_c2;
  double Qbe_qs_eff_Vc1_c2_Vb2_c1;
  double Qbe_qs_eff_Vc1_c2_Vc1_c2;
  double Qbe_qs_eff_Vb2_c1_Vdt_GND;
  double Qbe_qs_eff_Vb2_c1_Vb2_e1;
  double Qbe_qs_eff_Vb2_c1_Vb_c;
  double Qbe_qs_eff_Vb2_c1_Vb_b1;
  double Qbe_qs_eff_Vb2_c1_Vb1_b2;
  double Qbe_qs_eff_Vb2_c1_Vc4_c1;
  double Qbe_qs_eff_Vb2_c1_Vc3_c1;
  double Qbe_qs_eff_Vb2_c1_Vc3_c4;
  double Qbe_qs_eff_Vb2_c1_Vb2_c2;
  double Qbe_qs_eff_Vb2_c1_Vb2_c1;
  double Qbe_qs_eff_Vb2_c1_Vc1_c2;
  double Qbe_qs_eff_Vb2_c2_Vdt_GND;
  double Qbe_qs_eff_Vb2_c2_Vb2_e1;
  double Qbe_qs_eff_Vb2_c2_Vb_c;
  double Qbe_qs_eff_Vb2_c2_Vb_b1;
  double Qbe_qs_eff_Vb2_c2_Vb1_b2;
  double Qbe_qs_eff_Vb2_c2_Vc4_c1;
  double Qbe_qs_eff_Vb2_c2_Vc3_c1;
  double Qbe_qs_eff_Vb2_c2_Vc3_c4;
  double Qbe_qs_eff_Vb2_c2_Vb2_c2;
  double Qbe_qs_eff_Vb2_c2_Vb2_c1;
  double Qbe_qs_eff_Vb2_c2_Vc1_c2;
  double Qbe_qs_eff_Vc3_c1_Vdt_GND;
  double Qbe_qs_eff_Vc3_c1_Vb2_e1;
  double Qbe_qs_eff_Vc3_c1_Vb_c;
  double Qbe_qs_eff_Vc3_c1_Vb_b1;
  double Qbe_qs_eff_Vc3_c1_Vb1_b2;
  double Qbe_qs_eff_Vc3_c1_Vc4_c1;
  double Qbe_qs_eff_Vc3_c1_Vc3_c1;
  double Qbe_qs_eff_Vc3_c1_Vc3_c4;
  double Qbe_qs_eff_Vc3_c1_Vb2_c2;
  double Qbe_qs_eff_Vc3_c1_Vb2_c1;
  double Qbe_qs_eff_Vc3_c1_Vc1_c2;
  double Qbe_qs_eff_Vc4_c1_Vdt_GND;
  double Qbe_qs_eff_Vc4_c1_Vb2_e1;
  double Qbe_qs_eff_Vc4_c1_Vb_c;
  double Qbe_qs_eff_Vc4_c1_Vb_b1;
  double Qbe_qs_eff_Vc4_c1_Vb1_b2;
  double Qbe_qs_eff_Vc4_c1_Vc4_c1;
  double Qbe_qs_eff_Vc4_c1_Vc3_c1;
  double Qbe_qs_eff_Vc4_c1_Vc3_c4;
  double Qbe_qs_eff_Vc4_c1_Vb2_c2;
  double Qbe_qs_eff_Vc4_c1_Vb2_c1;
  double Qbe_qs_eff_Vc4_c1_Vc1_c2;
  double Qbe_qs_eff_Vb2_e1_Vdt_GND;
  double Qbe_qs_eff_Vb2_e1_Vb2_e1;
  double Qbe_qs_eff_Vb2_e1_Vb_c;
  double Qbe_qs_eff_Vb2_e1_Vb_b1;
  double Qbe_qs_eff_Vb2_e1_Vb1_b2;
  double Qbe_qs_eff_Vb2_e1_Vc4_c1;
  double Qbe_qs_eff_Vb2_e1_Vc3_c1;
  double Qbe_qs_eff_Vb2_e1_Vc3_c4;
  double Qbe_qs_eff_Vb2_e1_Vb2_c2;
  double Qbe_qs_eff_Vb2_e1_Vb2_c1;
  double Qbe_qs_eff_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qe;
#if defined(_DERIVATEFORDDX)
double Qe_Vdt_GND;
double Qe_Vb1_b2;
double Qe_Vb2_c2;
double Qe_Vc1_c2;
double Qe_Vc4_c1;
double Qe_Vb2_e1;
#if defined(_DERIVATE2)
  double Qe_Vb2_e1_Vdt_GND;
  double Qe_Vb2_e1_Vb1_b2;
  double Qe_Vb2_e1_Vb2_c2;
  double Qe_Vb2_e1_Vc1_c2;
  double Qe_Vb2_e1_Vc4_c1;
  double Qe_Vb2_e1_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dQeVb2e1;
#if defined(_DERIVATEFORDDX)
double dQeVb2e1_Vdt_GND;
double dQeVb2e1_Vb1_b2;
double dQeVb2e1_Vb2_c2;
double dQeVb2e1_Vc1_c2;
double dQeVb2e1_Vc4_c1;
double dQeVb2e1_Vb2_e1;
#if defined(_DERIVATE2)
  double dQeVb2e1_Vb2_e1_Vdt_GND;
  double dQeVb2e1_Vb2_e1_Vb1_b2;
  double dQeVb2e1_Vb2_e1_Vb2_c2;
  double dQeVb2e1_Vb2_e1_Vc1_c2;
  double dQeVb2e1_Vb2_e1_Vc4_c1;
  double dQeVb2e1_Vb2_e1_Vb2_e1;
  double dQeVb2e1_Vc4_c1_Vdt_GND;
  double dQeVb2e1_Vc4_c1_Vb1_b2;
  double dQeVb2e1_Vc4_c1_Vb2_c2;
  double dQeVb2e1_Vc4_c1_Vc1_c2;
  double dQeVb2e1_Vc4_c1_Vc4_c1;
  double dQeVb2e1_Vc4_c1_Vb2_e1;
  double dQeVb2e1_Vc1_c2_Vdt_GND;
  double dQeVb2e1_Vc1_c2_Vb1_b2;
  double dQeVb2e1_Vc1_c2_Vb2_c2;
  double dQeVb2e1_Vc1_c2_Vc1_c2;
  double dQeVb2e1_Vc1_c2_Vc4_c1;
  double dQeVb2e1_Vc1_c2_Vb2_e1;
  double dQeVb2e1_Vb2_c2_Vdt_GND;
  double dQeVb2e1_Vb2_c2_Vb1_b2;
  double dQeVb2e1_Vb2_c2_Vb2_c2;
  double dQeVb2e1_Vb2_c2_Vc1_c2;
  double dQeVb2e1_Vb2_c2_Vc4_c1;
  double dQeVb2e1_Vb2_c2_Vb2_e1;
  double dQeVb2e1_Vb1_b2_Vdt_GND;
  double dQeVb2e1_Vb1_b2_Vb1_b2;
  double dQeVb2e1_Vb1_b2_Vb2_c2;
  double dQeVb2e1_Vb1_b2_Vc1_c2;
  double dQeVb2e1_Vb1_b2_Vc4_c1;
  double dQeVb2e1_Vb1_b2_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dQbeVb2e1;
#if defined(_DERIVATEFORDDX)
double dQbeVb2e1_Vdt_GND;
double dQbeVb2e1_Vb_c;
double dQbeVb2e1_Vb_b1;
double dQbeVb2e1_Vb1_b2;
double dQbeVb2e1_Vc4_c1;
double dQbeVb2e1_Vc3_c1;
double dQbeVb2e1_Vc3_c4;
double dQbeVb2e1_Vb2_e1;
double dQbeVb2e1_Vb2_c2;
double dQbeVb2e1_Vb2_c1;
double dQbeVb2e1_Vc1_c2;
#if defined(_DERIVATE2)
  double dQbeVb2e1_Vc1_c2_Vdt_GND;
  double dQbeVb2e1_Vc1_c2_Vb_c;
  double dQbeVb2e1_Vc1_c2_Vb_b1;
  double dQbeVb2e1_Vc1_c2_Vb1_b2;
  double dQbeVb2e1_Vc1_c2_Vc4_c1;
  double dQbeVb2e1_Vc1_c2_Vc3_c1;
  double dQbeVb2e1_Vc1_c2_Vc3_c4;
  double dQbeVb2e1_Vc1_c2_Vb2_e1;
  double dQbeVb2e1_Vc1_c2_Vb2_c2;
  double dQbeVb2e1_Vc1_c2_Vb2_c1;
  double dQbeVb2e1_Vc1_c2_Vc1_c2;
  double dQbeVb2e1_Vb2_c1_Vdt_GND;
  double dQbeVb2e1_Vb2_c1_Vb_c;
  double dQbeVb2e1_Vb2_c1_Vb_b1;
  double dQbeVb2e1_Vb2_c1_Vb1_b2;
  double dQbeVb2e1_Vb2_c1_Vc4_c1;
  double dQbeVb2e1_Vb2_c1_Vc3_c1;
  double dQbeVb2e1_Vb2_c1_Vc3_c4;
  double dQbeVb2e1_Vb2_c1_Vb2_e1;
  double dQbeVb2e1_Vb2_c1_Vb2_c2;
  double dQbeVb2e1_Vb2_c1_Vb2_c1;
  double dQbeVb2e1_Vb2_c1_Vc1_c2;
  double dQbeVb2e1_Vb2_c2_Vdt_GND;
  double dQbeVb2e1_Vb2_c2_Vb_c;
  double dQbeVb2e1_Vb2_c2_Vb_b1;
  double dQbeVb2e1_Vb2_c2_Vb1_b2;
  double dQbeVb2e1_Vb2_c2_Vc4_c1;
  double dQbeVb2e1_Vb2_c2_Vc3_c1;
  double dQbeVb2e1_Vb2_c2_Vc3_c4;
  double dQbeVb2e1_Vb2_c2_Vb2_e1;
  double dQbeVb2e1_Vb2_c2_Vb2_c2;
  double dQbeVb2e1_Vb2_c2_Vb2_c1;
  double dQbeVb2e1_Vb2_c2_Vc1_c2;
  double dQbeVb2e1_Vb2_e1_Vdt_GND;
  double dQbeVb2e1_Vb2_e1_Vb_c;
  double dQbeVb2e1_Vb2_e1_Vb_b1;
  double dQbeVb2e1_Vb2_e1_Vb1_b2;
  double dQbeVb2e1_Vb2_e1_Vc4_c1;
  double dQbeVb2e1_Vb2_e1_Vc3_c1;
  double dQbeVb2e1_Vb2_e1_Vc3_c4;
  double dQbeVb2e1_Vb2_e1_Vb2_e1;
  double dQbeVb2e1_Vb2_e1_Vb2_c2;
  double dQbeVb2e1_Vb2_e1_Vb2_c1;
  double dQbeVb2e1_Vb2_e1_Vc1_c2;
  double dQbeVb2e1_Vc3_c1_Vdt_GND;
  double dQbeVb2e1_Vc3_c1_Vb_c;
  double dQbeVb2e1_Vc3_c1_Vb_b1;
  double dQbeVb2e1_Vc3_c1_Vb1_b2;
  double dQbeVb2e1_Vc3_c1_Vc4_c1;
  double dQbeVb2e1_Vc3_c1_Vc3_c1;
  double dQbeVb2e1_Vc3_c1_Vc3_c4;
  double dQbeVb2e1_Vc3_c1_Vb2_e1;
  double dQbeVb2e1_Vc3_c1_Vb2_c2;
  double dQbeVb2e1_Vc3_c1_Vb2_c1;
  double dQbeVb2e1_Vc3_c1_Vc1_c2;
  double dQbeVb2e1_Vc4_c1_Vdt_GND;
  double dQbeVb2e1_Vc4_c1_Vb_c;
  double dQbeVb2e1_Vc4_c1_Vb_b1;
  double dQbeVb2e1_Vc4_c1_Vb1_b2;
  double dQbeVb2e1_Vc4_c1_Vc4_c1;
  double dQbeVb2e1_Vc4_c1_Vc3_c1;
  double dQbeVb2e1_Vc4_c1_Vc3_c4;
  double dQbeVb2e1_Vc4_c1_Vb2_e1;
  double dQbeVb2e1_Vc4_c1_Vb2_c2;
  double dQbeVb2e1_Vc4_c1_Vb2_c1;
  double dQbeVb2e1_Vc4_c1_Vc1_c2;
  double dQbeVb2e1_Vb1_b2_Vdt_GND;
  double dQbeVb2e1_Vb1_b2_Vb_c;
  double dQbeVb2e1_Vb1_b2_Vb_b1;
  double dQbeVb2e1_Vb1_b2_Vb1_b2;
  double dQbeVb2e1_Vb1_b2_Vc4_c1;
  double dQbeVb2e1_Vb1_b2_Vc3_c1;
  double dQbeVb2e1_Vb1_b2_Vc3_c4;
  double dQbeVb2e1_Vb1_b2_Vb2_e1;
  double dQbeVb2e1_Vb1_b2_Vb2_c2;
  double dQbeVb2e1_Vb1_b2_Vb2_c1;
  double dQbeVb2e1_Vb1_b2_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dn0Vb2e1;
#if defined(_DERIVATEFORDDX)
double dn0Vb2e1_Vdt_GND;
double dn0Vb2e1_Vb2_e1;
#if defined(_DERIVATE2)
  double dn0Vb2e1_Vb2_e1_Vdt_GND;
  double dn0Vb2e1_Vb2_e1_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dQteVb2e1;
#if defined(_DERIVATEFORDDX)
double dQteVb2e1_Vdt_GND;
double dQteVb2e1_Vb2_e1;
double dQteVb2e1_Vb2_c2;
double dQteVb2e1_Vb2_c1;
double dQteVb2e1_Vc1_c2;
#if defined(_DERIVATE2)
  double dQteVb2e1_Vc1_c2_Vdt_GND;
  double dQteVb2e1_Vc1_c2_Vb2_e1;
  double dQteVb2e1_Vc1_c2_Vb2_c2;
  double dQteVb2e1_Vc1_c2_Vb2_c1;
  double dQteVb2e1_Vc1_c2_Vc1_c2;
  double dQteVb2e1_Vb2_c1_Vdt_GND;
  double dQteVb2e1_Vb2_c1_Vb2_e1;
  double dQteVb2e1_Vb2_c1_Vb2_c2;
  double dQteVb2e1_Vb2_c1_Vb2_c1;
  double dQteVb2e1_Vb2_c1_Vc1_c2;
  double dQteVb2e1_Vb2_c2_Vdt_GND;
  double dQteVb2e1_Vb2_c2_Vb2_e1;
  double dQteVb2e1_Vb2_c2_Vb2_c2;
  double dQteVb2e1_Vb2_c2_Vb2_c1;
  double dQteVb2e1_Vb2_c2_Vc1_c2;
  double dQteVb2e1_Vb2_e1_Vdt_GND;
  double dQteVb2e1_Vb2_e1_Vb2_e1;
  double dQteVb2e1_Vb2_e1_Vb2_c2;
  double dQteVb2e1_Vb2_e1_Vb2_c1;
  double dQteVb2e1_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dVteVb2e1;
#if defined(_DERIVATEFORDDX)
double dVteVb2e1_Vb2_e1;
double dVteVb2e1_Vdt_GND;
double dVteVb2e1_Vb2_c2;
double dVteVb2e1_Vb2_c1;
double dVteVb2e1_Vc1_c2;
#if defined(_DERIVATE2)
  double dVteVb2e1_Vc1_c2_Vb2_e1;
  double dVteVb2e1_Vc1_c2_Vdt_GND;
  double dVteVb2e1_Vc1_c2_Vb2_c2;
  double dVteVb2e1_Vc1_c2_Vb2_c1;
  double dVteVb2e1_Vc1_c2_Vc1_c2;
  double dVteVb2e1_Vb2_c1_Vb2_e1;
  double dVteVb2e1_Vb2_c1_Vdt_GND;
  double dVteVb2e1_Vb2_c1_Vb2_c2;
  double dVteVb2e1_Vb2_c1_Vb2_c1;
  double dVteVb2e1_Vb2_c1_Vc1_c2;
  double dVteVb2e1_Vb2_c2_Vb2_e1;
  double dVteVb2e1_Vb2_c2_Vdt_GND;
  double dVteVb2e1_Vb2_c2_Vb2_c2;
  double dVteVb2e1_Vb2_c2_Vb2_c1;
  double dVteVb2e1_Vb2_c2_Vc1_c2;
  double dVteVb2e1_Vb2_e1_Vb2_e1;
  double dVteVb2e1_Vb2_e1_Vdt_GND;
  double dVteVb2e1_Vb2_e1_Vb2_c2;
  double dVteVb2e1_Vb2_e1_Vb2_c1;
  double dVteVb2e1_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dVjeVb2e1;
#if defined(_DERIVATEFORDDX)
double dVjeVb2e1_Vb2_e1;
double dVjeVb2e1_Vdt_GND;
#if defined(_DERIVATE2)
  double dVjeVb2e1_Vb2_e1_Vb2_e1;
  double dVjeVb2e1_Vb2_e1_Vdt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vb2e1Vfe;
#if defined(_DERIVATEFORDDX)
double Vb2e1Vfe_Vb2_e1;
double Vb2e1Vfe_Vdt_GND;
#if defined(_DERIVATE2)
  double Vb2e1Vfe_Vb2_e1_Vb2_e1;
  double Vb2e1Vfe_Vb2_e1_Vdt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double dVteVje;
#if defined(_DERIVATEFORDDX)
double dVteVje_Vb2_e1;
double dVteVje_Vdt_GND;
double dVteVje_Vb2_c2;
double dVteVje_Vb2_c1;
double dVteVje_Vc1_c2;
#if defined(_DERIVATE2)
  double dVteVje_Vc1_c2_Vb2_e1;
  double dVteVje_Vc1_c2_Vdt_GND;
  double dVteVje_Vc1_c2_Vb2_c2;
  double dVteVje_Vc1_c2_Vb2_c1;
  double dVteVje_Vc1_c2_Vc1_c2;
  double dVteVje_Vb2_c1_Vb2_e1;
  double dVteVje_Vb2_c1_Vdt_GND;
  double dVteVje_Vb2_c1_Vb2_c2;
  double dVteVje_Vb2_c1_Vb2_c1;
  double dVteVje_Vb2_c1_Vc1_c2;
  double dVteVje_Vb2_c2_Vb2_e1;
  double dVteVje_Vb2_c2_Vdt_GND;
  double dVteVje_Vb2_c2_Vb2_c2;
  double dVteVje_Vb2_c2_Vb2_c1;
  double dVteVje_Vb2_c2_Vc1_c2;
  double dVteVje_Vb2_e1_Vb2_e1;
  double dVteVje_Vb2_e1_Vdt_GND;
  double dVteVje_Vb2_e1_Vb2_c2;
  double dVteVje_Vb2_e1_Vb2_c1;
  double dVteVje_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qb1b2;
#if defined(_DERIVATEFORDDX)
double Qb1b2_Vb1_b2;
double Qb1b2_Vdt_GND;
double Qb1b2_Vb2_e1;
double Qb1b2_Vb2_c2;
double Qb1b2_Vb2_c1;
double Qb1b2_Vc1_c2;
double Qb1b2_Vb_c;
double Qb1b2_Vb_b1;
double Qb1b2_Vc4_c1;
double Qb1b2_Vc3_c1;
double Qb1b2_Vc3_c4;
#if defined(_DERIVATE2)
  double Qb1b2_Vc3_c1_Vb1_b2;
  double Qb1b2_Vc3_c1_Vdt_GND;
  double Qb1b2_Vc3_c1_Vb2_e1;
  double Qb1b2_Vc3_c1_Vb2_c2;
  double Qb1b2_Vc3_c1_Vb2_c1;
  double Qb1b2_Vc3_c1_Vc1_c2;
  double Qb1b2_Vc3_c1_Vb_c;
  double Qb1b2_Vc3_c1_Vb_b1;
  double Qb1b2_Vc3_c1_Vc4_c1;
  double Qb1b2_Vc3_c1_Vc3_c1;
  double Qb1b2_Vc3_c1_Vc3_c4;
  double Qb1b2_Vc4_c1_Vb1_b2;
  double Qb1b2_Vc4_c1_Vdt_GND;
  double Qb1b2_Vc4_c1_Vb2_e1;
  double Qb1b2_Vc4_c1_Vb2_c2;
  double Qb1b2_Vc4_c1_Vb2_c1;
  double Qb1b2_Vc4_c1_Vc1_c2;
  double Qb1b2_Vc4_c1_Vb_c;
  double Qb1b2_Vc4_c1_Vb_b1;
  double Qb1b2_Vc4_c1_Vc4_c1;
  double Qb1b2_Vc4_c1_Vc3_c1;
  double Qb1b2_Vc4_c1_Vc3_c4;
  double Qb1b2_Vc1_c2_Vb1_b2;
  double Qb1b2_Vc1_c2_Vdt_GND;
  double Qb1b2_Vc1_c2_Vb2_e1;
  double Qb1b2_Vc1_c2_Vb2_c2;
  double Qb1b2_Vc1_c2_Vb2_c1;
  double Qb1b2_Vc1_c2_Vc1_c2;
  double Qb1b2_Vc1_c2_Vb_c;
  double Qb1b2_Vc1_c2_Vb_b1;
  double Qb1b2_Vc1_c2_Vc4_c1;
  double Qb1b2_Vc1_c2_Vc3_c1;
  double Qb1b2_Vc1_c2_Vc3_c4;
  double Qb1b2_Vb2_c1_Vb1_b2;
  double Qb1b2_Vb2_c1_Vdt_GND;
  double Qb1b2_Vb2_c1_Vb2_e1;
  double Qb1b2_Vb2_c1_Vb2_c2;
  double Qb1b2_Vb2_c1_Vb2_c1;
  double Qb1b2_Vb2_c1_Vc1_c2;
  double Qb1b2_Vb2_c1_Vb_c;
  double Qb1b2_Vb2_c1_Vb_b1;
  double Qb1b2_Vb2_c1_Vc4_c1;
  double Qb1b2_Vb2_c1_Vc3_c1;
  double Qb1b2_Vb2_c1_Vc3_c4;
  double Qb1b2_Vb2_c2_Vb1_b2;
  double Qb1b2_Vb2_c2_Vdt_GND;
  double Qb1b2_Vb2_c2_Vb2_e1;
  double Qb1b2_Vb2_c2_Vb2_c2;
  double Qb1b2_Vb2_c2_Vb2_c1;
  double Qb1b2_Vb2_c2_Vc1_c2;
  double Qb1b2_Vb2_c2_Vb_c;
  double Qb1b2_Vb2_c2_Vb_b1;
  double Qb1b2_Vb2_c2_Vc4_c1;
  double Qb1b2_Vb2_c2_Vc3_c1;
  double Qb1b2_Vb2_c2_Vc3_c4;
  double Qb1b2_Vb2_e1_Vb1_b2;
  double Qb1b2_Vb2_e1_Vdt_GND;
  double Qb1b2_Vb2_e1_Vb2_e1;
  double Qb1b2_Vb2_e1_Vb2_c2;
  double Qb1b2_Vb2_e1_Vb2_c1;
  double Qb1b2_Vb2_e1_Vc1_c2;
  double Qb1b2_Vb2_e1_Vb_c;
  double Qb1b2_Vb2_e1_Vb_b1;
  double Qb1b2_Vb2_e1_Vc4_c1;
  double Qb1b2_Vb2_e1_Vc3_c1;
  double Qb1b2_Vb2_e1_Vc3_c4;
  double Qb1b2_Vb1_b2_Vb1_b2;
  double Qb1b2_Vb1_b2_Vdt_GND;
  double Qb1b2_Vb1_b2_Vb2_e1;
  double Qb1b2_Vb1_b2_Vb2_c2;
  double Qb1b2_Vb1_b2_Vb2_c1;
  double Qb1b2_Vb1_b2_Vc1_c2;
  double Qb1b2_Vb1_b2_Vb_c;
  double Qb1b2_Vb1_b2_Vb_b1;
  double Qb1b2_Vb1_b2_Vc4_c1;
  double Qb1b2_Vb1_b2_Vc3_c1;
  double Qb1b2_Vb1_b2_Vc3_c4;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double XpWex;
#if defined(_DERIVATEFORDDX)
double XpWex_Vb_c;
double XpWex_Vb_b1;
double XpWex_Vb1_b2;
double XpWex_Vb2_c2;
double XpWex_Vc1_c2;
double XpWex_Vc4_c1;
double XpWex_Vc3_c1;
double XpWex_Vc3_c4;
double XpWex_Vdt_GND;
#if defined(_DERIVATE2)
  double XpWex_Vb_b1_Vb_c;
  double XpWex_Vb_b1_Vb_b1;
  double XpWex_Vb_b1_Vb1_b2;
  double XpWex_Vb_b1_Vb2_c2;
  double XpWex_Vb_b1_Vc1_c2;
  double XpWex_Vb_b1_Vc4_c1;
  double XpWex_Vb_b1_Vc3_c1;
  double XpWex_Vb_b1_Vc3_c4;
  double XpWex_Vb_b1_Vdt_GND;
  double XpWex_Vb_c_Vb_c;
  double XpWex_Vb_c_Vb_b1;
  double XpWex_Vb_c_Vb1_b2;
  double XpWex_Vb_c_Vb2_c2;
  double XpWex_Vb_c_Vc1_c2;
  double XpWex_Vb_c_Vc4_c1;
  double XpWex_Vb_c_Vc3_c1;
  double XpWex_Vb_c_Vc3_c4;
  double XpWex_Vb_c_Vdt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Xg2;
#if defined(_DERIVATEFORDDX)
double Xg2_Vb_c;
double Xg2_Vb_b1;
double Xg2_Vb1_b2;
double Xg2_Vb2_c2;
double Xg2_Vc1_c2;
double Xg2_Vc4_c1;
double Xg2_Vc3_c1;
double Xg2_Vc3_c4;
double Xg2_Vdt_GND;
#if defined(_DERIVATE2)
  double Xg2_Vb_b1_Vb_c;
  double Xg2_Vb_b1_Vb_b1;
  double Xg2_Vb_b1_Vb1_b2;
  double Xg2_Vb_b1_Vb2_c2;
  double Xg2_Vb_b1_Vc1_c2;
  double Xg2_Vb_b1_Vc4_c1;
  double Xg2_Vb_b1_Vc3_c1;
  double Xg2_Vb_b1_Vc3_c4;
  double Xg2_Vb_b1_Vdt_GND;
  double Xg2_Vb_c_Vb_c;
  double Xg2_Vb_c_Vb_b1;
  double Xg2_Vb_c_Vb1_b2;
  double Xg2_Vb_c_Vb2_c2;
  double Xg2_Vb_c_Vc1_c2;
  double Xg2_Vb_c_Vc4_c1;
  double Xg2_Vb_c_Vc3_c1;
  double Xg2_Vb_c_Vc3_c4;
  double Xg2_Vb_c_Vdt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double XQex;
#if defined(_DERIVATEFORDDX)
double XQex_Vdt_GND;
double XQex_Vb_c;
double XQex_Vb_b1;
double XQex_Vb1_b2;
double XQex_Vc4_c1;
double XQex_Vc3_c1;
double XQex_Vc3_c4;
double XQex_Vb2_e1;
double XQex_Vb2_c2;
double XQex_Vb2_c1;
double XQex_Vc1_c2;
double XQex_Vs_c1;
#if defined(_DERIVATE2)
  double XQex_Vb_b1_Vdt_GND;
  double XQex_Vb_b1_Vb_c;
  double XQex_Vb_b1_Vb_b1;
  double XQex_Vb_b1_Vb1_b2;
  double XQex_Vb_b1_Vc4_c1;
  double XQex_Vb_b1_Vc3_c1;
  double XQex_Vb_b1_Vc3_c4;
  double XQex_Vb_b1_Vb2_e1;
  double XQex_Vb_b1_Vb2_c2;
  double XQex_Vb_b1_Vb2_c1;
  double XQex_Vb_b1_Vc1_c2;
  double XQex_Vb_b1_Vs_c1;
  double XQex_Vb_c_Vdt_GND;
  double XQex_Vb_c_Vb_c;
  double XQex_Vb_c_Vb_b1;
  double XQex_Vb_c_Vb1_b2;
  double XQex_Vb_c_Vc4_c1;
  double XQex_Vb_c_Vc3_c1;
  double XQex_Vb_c_Vc3_c4;
  double XQex_Vb_c_Vb2_e1;
  double XQex_Vb_c_Vb2_c2;
  double XQex_Vb_c_Vb2_c1;
  double XQex_Vb_c_Vc1_c2;
  double XQex_Vb_c_Vs_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qex;
#if defined(_DERIVATEFORDDX)
double Qex_Vdt_GND;
double Qex_Vb1_b2;
double Qex_Vb2_c2;
double Qex_Vc1_c2;
double Qex_Vc4_c1;
#if defined(_DERIVATE2)
  double Qex_Vc1_c2_Vdt_GND;
  double Qex_Vc1_c2_Vb1_b2;
  double Qex_Vc1_c2_Vb2_c2;
  double Qex_Vc1_c2_Vc1_c2;
  double Qex_Vc1_c2_Vc4_c1;
  double Qex_Vb2_c2_Vdt_GND;
  double Qex_Vb2_c2_Vb1_b2;
  double Qex_Vb2_c2_Vb2_c2;
  double Qex_Vb2_c2_Vc1_c2;
  double Qex_Vb2_c2_Vc4_c1;
  double Qex_Vb1_b2_Vdt_GND;
  double Qex_Vb1_b2_Vb1_b2;
  double Qex_Vb1_b2_Vb2_c2;
  double Qex_Vb1_b2_Vc1_c2;
  double Qex_Vb1_b2_Vc4_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qepi;
#if defined(_DERIVATEFORDDX)
double Qepi_Vdt_GND;
double Qepi_Vb2_c2;
double Qepi_Vb2_c1;
double Qepi_Vc1_c2;
#if defined(_DERIVATE2)
  double Qepi_Vc1_c2_Vdt_GND;
  double Qepi_Vc1_c2_Vb2_c2;
  double Qepi_Vc1_c2_Vb2_c1;
  double Qepi_Vc1_c2_Vc1_c2;
  double Qepi_Vb2_c1_Vdt_GND;
  double Qepi_Vb2_c1_Vb2_c2;
  double Qepi_Vb2_c1_Vb2_c1;
  double Qepi_Vb2_c1_Vc1_c2;
  double Qepi_Vb2_c2_Vdt_GND;
  double Qepi_Vb2_c2_Vb2_c2;
  double Qepi_Vb2_c2_Vb2_c1;
  double Qepi_Vb2_c2_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qepi0;
#if defined(_DERIVATE)
double Qepi0_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qe_qs;
#if defined(_DERIVATEFORDDX)
double Qe_qs_Vdt_GND;
double Qe_qs_Vb1_b2;
double Qe_qs_Vb2_c2;
double Qe_qs_Vc1_c2;
double Qe_qs_Vc4_c1;
double Qe_qs_Vb2_e1;
#if defined(_DERIVATE2)
  double Qe_qs_Vb2_e1_Vdt_GND;
  double Qe_qs_Vb2_e1_Vb1_b2;
  double Qe_qs_Vb2_e1_Vb2_c2;
  double Qe_qs_Vb2_e1_Vc1_c2;
  double Qe_qs_Vb2_e1_Vc4_c1;
  double Qe_qs_Vb2_e1_Vb2_e1;
  double Qe_qs_Vc4_c1_Vdt_GND;
  double Qe_qs_Vc4_c1_Vb1_b2;
  double Qe_qs_Vc4_c1_Vb2_c2;
  double Qe_qs_Vc4_c1_Vc1_c2;
  double Qe_qs_Vc4_c1_Vc4_c1;
  double Qe_qs_Vc4_c1_Vb2_e1;
  double Qe_qs_Vc1_c2_Vdt_GND;
  double Qe_qs_Vc1_c2_Vb1_b2;
  double Qe_qs_Vc1_c2_Vb2_c2;
  double Qe_qs_Vc1_c2_Vc1_c2;
  double Qe_qs_Vc1_c2_Vc4_c1;
  double Qe_qs_Vc1_c2_Vb2_e1;
  double Qe_qs_Vb2_c2_Vdt_GND;
  double Qe_qs_Vb2_c2_Vb1_b2;
  double Qe_qs_Vb2_c2_Vb2_c2;
  double Qe_qs_Vb2_c2_Vc1_c2;
  double Qe_qs_Vb2_c2_Vc4_c1;
  double Qe_qs_Vb2_c2_Vb2_e1;
  double Qe_qs_Vb1_b2_Vdt_GND;
  double Qe_qs_Vb1_b2_Vb1_b2;
  double Qe_qs_Vb1_b2_Vb2_c2;
  double Qe_qs_Vb1_b2_Vc1_c2;
  double Qe_qs_Vb1_b2_Vc4_c1;
  double Qe_qs_Vb1_b2_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qe0;
#if defined(_DERIVATE)
double Qe0_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qts;
#if defined(_DERIVATEFORDDX)
double Qts_Vdt_GND;
double Qts_Vs_c1;
double Qts_Vb_c;
double Qts_Vb_b1;
double Qts_Vc3_c1;
double Qts_Vc3_c4;
double Qts_Vb1_b2;
double Qts_Vc4_c1;
double Qts_Vb1_e1;
double Qts_Vb2_e1;
double Qts_Vb2_c2;
double Qts_Vb2_c1;
double Qts_Vc1_c2;
#if defined(_DERIVATE2)
  double Qts_Vs_c1_Vdt_GND;
  double Qts_Vs_c1_Vs_c1;
  double Qts_Vs_c1_Vb_c;
  double Qts_Vs_c1_Vb_b1;
  double Qts_Vs_c1_Vc3_c1;
  double Qts_Vs_c1_Vc3_c4;
  double Qts_Vs_c1_Vb1_b2;
  double Qts_Vs_c1_Vc4_c1;
  double Qts_Vs_c1_Vb1_e1;
  double Qts_Vs_c1_Vb2_e1;
  double Qts_Vs_c1_Vb2_c2;
  double Qts_Vs_c1_Vb2_c1;
  double Qts_Vs_c1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vjs;
#if defined(_DERIVATEFORDDX)
double Vjs_Vs_c1;
double Vjs_Vdt_GND;
double Vjs_Vb_c;
double Vjs_Vb_b1;
double Vjs_Vc3_c1;
double Vjs_Vc3_c4;
double Vjs_Vb1_b2;
double Vjs_Vc4_c1;
double Vjs_Vb1_e1;
double Vjs_Vb2_e1;
double Vjs_Vb2_c2;
double Vjs_Vb2_c1;
double Vjs_Vc1_c2;
#if defined(_DERIVATE2)
  double Vjs_Vs_c1_Vs_c1;
  double Vjs_Vs_c1_Vdt_GND;
  double Vjs_Vs_c1_Vb_c;
  double Vjs_Vs_c1_Vb_b1;
  double Vjs_Vs_c1_Vc3_c1;
  double Vjs_Vs_c1_Vc3_c4;
  double Vjs_Vs_c1_Vb1_b2;
  double Vjs_Vs_c1_Vc4_c1;
  double Vjs_Vs_c1_Vb1_e1;
  double Vjs_Vs_c1_Vb2_e1;
  double Vjs_Vs_c1_Vb2_c2;
  double Vjs_Vs_c1_Vb2_c1;
  double Vjs_Vs_c1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vfs;
#if defined(_DERIVATE)
double Vfs_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double a_VDS;
#if defined(_DERIVATE)
double a_VDS_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double XQtex;
#if defined(_DERIVATEFORDDX)
double XQtex_Vdt_GND;
double XQtex_Vb_c;
double XQtex_Vb_b1;
double XQtex_Vb1_b2;
double XQtex_Vb2_c2;
double XQtex_Vc1_c2;
double XQtex_Vc4_c1;
double XQtex_Vc3_c1;
double XQtex_Vc3_c4;
double XQtex_Vb1_e1;
double XQtex_Vb2_e1;
double XQtex_Vb2_c1;
#if defined(_DERIVATE2)
  double XQtex_Vb_b1_Vdt_GND;
  double XQtex_Vb_b1_Vb_c;
  double XQtex_Vb_b1_Vb_b1;
  double XQtex_Vb_b1_Vb1_b2;
  double XQtex_Vb_b1_Vb2_c2;
  double XQtex_Vb_b1_Vc1_c2;
  double XQtex_Vb_b1_Vc4_c1;
  double XQtex_Vb_b1_Vc3_c1;
  double XQtex_Vb_b1_Vc3_c4;
  double XQtex_Vb_b1_Vb1_e1;
  double XQtex_Vb_b1_Vb2_e1;
  double XQtex_Vb_b1_Vb2_c1;
  double XQtex_Vb_c_Vdt_GND;
  double XQtex_Vb_c_Vb_c;
  double XQtex_Vb_c_Vb_b1;
  double XQtex_Vb_c_Vb1_b2;
  double XQtex_Vb_c_Vb2_c2;
  double XQtex_Vb_c_Vc1_c2;
  double XQtex_Vb_c_Vc4_c1;
  double XQtex_Vb_c_Vc3_c1;
  double XQtex_Vb_c_Vc3_c4;
  double XQtex_Vb_c_Vb1_e1;
  double XQtex_Vb_c_Vb2_e1;
  double XQtex_Vb_c_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double XVtexv;
#if defined(_DERIVATEFORDDX)
double XVtexv_Vdt_GND;
double XVtexv_Vb_c;
double XVtexv_Vb_b1;
double XVtexv_Vb1_b2;
double XVtexv_Vb2_c2;
double XVtexv_Vc1_c2;
double XVtexv_Vc4_c1;
double XVtexv_Vc3_c1;
double XVtexv_Vc3_c4;
double XVtexv_Vb1_e1;
double XVtexv_Vb2_e1;
double XVtexv_Vb2_c1;
#if defined(_DERIVATE2)
  double XVtexv_Vb_b1_Vdt_GND;
  double XVtexv_Vb_b1_Vb_c;
  double XVtexv_Vb_b1_Vb_b1;
  double XVtexv_Vb_b1_Vb1_b2;
  double XVtexv_Vb_b1_Vb2_c2;
  double XVtexv_Vb_b1_Vc1_c2;
  double XVtexv_Vb_b1_Vc4_c1;
  double XVtexv_Vb_b1_Vc3_c1;
  double XVtexv_Vb_b1_Vc3_c4;
  double XVtexv_Vb_b1_Vb1_e1;
  double XVtexv_Vb_b1_Vb2_e1;
  double XVtexv_Vb_b1_Vb2_c1;
  double XVtexv_Vb_c_Vdt_GND;
  double XVtexv_Vb_c_Vb_c;
  double XVtexv_Vb_c_Vb_b1;
  double XVtexv_Vb_c_Vb1_b2;
  double XVtexv_Vb_c_Vb2_c2;
  double XVtexv_Vb_c_Vc1_c2;
  double XVtexv_Vb_c_Vc4_c1;
  double XVtexv_Vb_c_Vc3_c1;
  double XVtexv_Vb_c_Vc3_c4;
  double XVtexv_Vb_c_Vb1_e1;
  double XVtexv_Vb_c_Vb2_e1;
  double XVtexv_Vb_c_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double XVjcex;
#if defined(_DERIVATEFORDDX)
double XVjcex_Vb_c;
double XVjcex_Vb_b1;
double XVjcex_Vb1_b2;
double XVjcex_Vb2_c2;
double XVjcex_Vc1_c2;
double XVjcex_Vc4_c1;
double XVjcex_Vc3_c1;
double XVjcex_Vc3_c4;
double XVjcex_Vdt_GND;
double XVjcex_Vb1_e1;
double XVjcex_Vb2_e1;
double XVjcex_Vb2_c1;
#if defined(_DERIVATE2)
  double XVjcex_Vb_b1_Vb_c;
  double XVjcex_Vb_b1_Vb_b1;
  double XVjcex_Vb_b1_Vb1_b2;
  double XVjcex_Vb_b1_Vb2_c2;
  double XVjcex_Vb_b1_Vc1_c2;
  double XVjcex_Vb_b1_Vc4_c1;
  double XVjcex_Vb_b1_Vc3_c1;
  double XVjcex_Vb_b1_Vc3_c4;
  double XVjcex_Vb_b1_Vdt_GND;
  double XVjcex_Vb_b1_Vb1_e1;
  double XVjcex_Vb_b1_Vb2_e1;
  double XVjcex_Vb_b1_Vb2_c1;
  double XVjcex_Vb_c_Vb_c;
  double XVjcex_Vb_c_Vb_b1;
  double XVjcex_Vb_c_Vb1_b2;
  double XVjcex_Vb_c_Vb2_c2;
  double XVjcex_Vb_c_Vc1_c2;
  double XVjcex_Vb_c_Vc4_c1;
  double XVjcex_Vb_c_Vc3_c1;
  double XVjcex_Vb_c_Vc3_c4;
  double XVjcex_Vb_c_Vdt_GND;
  double XVjcex_Vb_c_Vb1_e1;
  double XVjcex_Vb_c_Vb2_e1;
  double XVjcex_Vb_c_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qtex;
#if defined(_DERIVATEFORDDX)
double Qtex_Vdt_GND;
double Qtex_Vb1_b2;
double Qtex_Vb2_c2;
double Qtex_Vc1_c2;
double Qtex_Vc4_c1;
double Qtex_Vb1_e1;
double Qtex_Vb2_e1;
double Qtex_Vb2_c1;
#if defined(_DERIVATE2)
  double Qtex_Vb2_c1_Vdt_GND;
  double Qtex_Vb2_c1_Vb1_b2;
  double Qtex_Vb2_c1_Vb2_c2;
  double Qtex_Vb2_c1_Vc1_c2;
  double Qtex_Vb2_c1_Vc4_c1;
  double Qtex_Vb2_c1_Vb1_e1;
  double Qtex_Vb2_c1_Vb2_e1;
  double Qtex_Vb2_c1_Vb2_c1;
  double Qtex_Vb2_e1_Vdt_GND;
  double Qtex_Vb2_e1_Vb1_b2;
  double Qtex_Vb2_e1_Vb2_c2;
  double Qtex_Vb2_e1_Vc1_c2;
  double Qtex_Vb2_e1_Vc4_c1;
  double Qtex_Vb2_e1_Vb1_e1;
  double Qtex_Vb2_e1_Vb2_e1;
  double Qtex_Vb2_e1_Vb2_c1;
  double Qtex_Vb1_e1_Vdt_GND;
  double Qtex_Vb1_e1_Vb1_b2;
  double Qtex_Vb1_e1_Vb2_c2;
  double Qtex_Vb1_e1_Vc1_c2;
  double Qtex_Vb1_e1_Vc4_c1;
  double Qtex_Vb1_e1_Vb1_e1;
  double Qtex_Vb1_e1_Vb2_e1;
  double Qtex_Vb1_e1_Vb2_c1;
  double Qtex_Vc1_c2_Vdt_GND;
  double Qtex_Vc1_c2_Vb1_b2;
  double Qtex_Vc1_c2_Vb2_c2;
  double Qtex_Vc1_c2_Vc1_c2;
  double Qtex_Vc1_c2_Vc4_c1;
  double Qtex_Vc1_c2_Vb1_e1;
  double Qtex_Vc1_c2_Vb2_e1;
  double Qtex_Vc1_c2_Vb2_c1;
  double Qtex_Vb2_c2_Vdt_GND;
  double Qtex_Vb2_c2_Vb1_b2;
  double Qtex_Vb2_c2_Vb2_c2;
  double Qtex_Vb2_c2_Vc1_c2;
  double Qtex_Vb2_c2_Vc4_c1;
  double Qtex_Vb2_c2_Vb1_e1;
  double Qtex_Vb2_c2_Vb2_e1;
  double Qtex_Vb2_c2_Vb2_c1;
  double Qtex_Vb1_b2_Vdt_GND;
  double Qtex_Vb1_b2_Vb1_b2;
  double Qtex_Vb1_b2_Vb2_c2;
  double Qtex_Vb1_b2_Vc1_c2;
  double Qtex_Vb1_b2_Vc4_c1;
  double Qtex_Vb1_b2_Vb1_e1;
  double Qtex_Vb1_b2_Vb2_e1;
  double Qtex_Vb1_b2_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vtexv;
#if defined(_DERIVATEFORDDX)
double Vtexv_Vdt_GND;
double Vtexv_Vb1_b2;
double Vtexv_Vb2_c2;
double Vtexv_Vc1_c2;
double Vtexv_Vc4_c1;
double Vtexv_Vb1_e1;
double Vtexv_Vb2_e1;
double Vtexv_Vb2_c1;
#if defined(_DERIVATE2)
  double Vtexv_Vb2_c1_Vdt_GND;
  double Vtexv_Vb2_c1_Vb1_b2;
  double Vtexv_Vb2_c1_Vb2_c2;
  double Vtexv_Vb2_c1_Vc1_c2;
  double Vtexv_Vb2_c1_Vc4_c1;
  double Vtexv_Vb2_c1_Vb1_e1;
  double Vtexv_Vb2_c1_Vb2_e1;
  double Vtexv_Vb2_c1_Vb2_c1;
  double Vtexv_Vb2_e1_Vdt_GND;
  double Vtexv_Vb2_e1_Vb1_b2;
  double Vtexv_Vb2_e1_Vb2_c2;
  double Vtexv_Vb2_e1_Vc1_c2;
  double Vtexv_Vb2_e1_Vc4_c1;
  double Vtexv_Vb2_e1_Vb1_e1;
  double Vtexv_Vb2_e1_Vb2_e1;
  double Vtexv_Vb2_e1_Vb2_c1;
  double Vtexv_Vb1_e1_Vdt_GND;
  double Vtexv_Vb1_e1_Vb1_b2;
  double Vtexv_Vb1_e1_Vb2_c2;
  double Vtexv_Vb1_e1_Vc1_c2;
  double Vtexv_Vb1_e1_Vc4_c1;
  double Vtexv_Vb1_e1_Vb1_e1;
  double Vtexv_Vb1_e1_Vb2_e1;
  double Vtexv_Vb1_e1_Vb2_c1;
  double Vtexv_Vc1_c2_Vdt_GND;
  double Vtexv_Vc1_c2_Vb1_b2;
  double Vtexv_Vc1_c2_Vb2_c2;
  double Vtexv_Vc1_c2_Vc1_c2;
  double Vtexv_Vc1_c2_Vc4_c1;
  double Vtexv_Vc1_c2_Vb1_e1;
  double Vtexv_Vc1_c2_Vb2_e1;
  double Vtexv_Vc1_c2_Vb2_c1;
  double Vtexv_Vb2_c2_Vdt_GND;
  double Vtexv_Vb2_c2_Vb1_b2;
  double Vtexv_Vb2_c2_Vb2_c2;
  double Vtexv_Vb2_c2_Vc1_c2;
  double Vtexv_Vb2_c2_Vc4_c1;
  double Vtexv_Vb2_c2_Vb1_e1;
  double Vtexv_Vb2_c2_Vb2_e1;
  double Vtexv_Vb2_c2_Vb2_c1;
  double Vtexv_Vb1_b2_Vdt_GND;
  double Vtexv_Vb1_b2_Vb1_b2;
  double Vtexv_Vb1_b2_Vb2_c2;
  double Vtexv_Vb1_b2_Vc1_c2;
  double Vtexv_Vb1_b2_Vc4_c1;
  double Vtexv_Vb1_b2_Vb1_e1;
  double Vtexv_Vb1_b2_Vb2_e1;
  double Vtexv_Vb1_b2_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vjcex;
#if defined(_DERIVATEFORDDX)
double Vjcex_Vb1_b2;
double Vjcex_Vb2_c2;
double Vjcex_Vc1_c2;
double Vjcex_Vc4_c1;
double Vjcex_Vdt_GND;
double Vjcex_Vb1_e1;
double Vjcex_Vb2_e1;
double Vjcex_Vb2_c1;
#if defined(_DERIVATE2)
  double Vjcex_Vb2_c1_Vb1_b2;
  double Vjcex_Vb2_c1_Vb2_c2;
  double Vjcex_Vb2_c1_Vc1_c2;
  double Vjcex_Vb2_c1_Vc4_c1;
  double Vjcex_Vb2_c1_Vdt_GND;
  double Vjcex_Vb2_c1_Vb1_e1;
  double Vjcex_Vb2_c1_Vb2_e1;
  double Vjcex_Vb2_c1_Vb2_c1;
  double Vjcex_Vb2_e1_Vb1_b2;
  double Vjcex_Vb2_e1_Vb2_c2;
  double Vjcex_Vb2_e1_Vc1_c2;
  double Vjcex_Vb2_e1_Vc4_c1;
  double Vjcex_Vb2_e1_Vdt_GND;
  double Vjcex_Vb2_e1_Vb1_e1;
  double Vjcex_Vb2_e1_Vb2_e1;
  double Vjcex_Vb2_e1_Vb2_c1;
  double Vjcex_Vb1_e1_Vb1_b2;
  double Vjcex_Vb1_e1_Vb2_c2;
  double Vjcex_Vb1_e1_Vc1_c2;
  double Vjcex_Vb1_e1_Vc4_c1;
  double Vjcex_Vb1_e1_Vdt_GND;
  double Vjcex_Vb1_e1_Vb1_e1;
  double Vjcex_Vb1_e1_Vb2_e1;
  double Vjcex_Vb1_e1_Vb2_c1;
  double Vjcex_Vc1_c2_Vb1_b2;
  double Vjcex_Vc1_c2_Vb2_c2;
  double Vjcex_Vc1_c2_Vc1_c2;
  double Vjcex_Vc1_c2_Vc4_c1;
  double Vjcex_Vc1_c2_Vdt_GND;
  double Vjcex_Vc1_c2_Vb1_e1;
  double Vjcex_Vc1_c2_Vb2_e1;
  double Vjcex_Vc1_c2_Vb2_c1;
  double Vjcex_Vb2_c2_Vb1_b2;
  double Vjcex_Vb2_c2_Vb2_c2;
  double Vjcex_Vb2_c2_Vc1_c2;
  double Vjcex_Vb2_c2_Vc4_c1;
  double Vjcex_Vb2_c2_Vdt_GND;
  double Vjcex_Vb2_c2_Vb1_e1;
  double Vjcex_Vb2_c2_Vb2_e1;
  double Vjcex_Vb2_c2_Vb2_c1;
  double Vjcex_Vb1_b2_Vb1_b2;
  double Vjcex_Vb1_b2_Vb2_c2;
  double Vjcex_Vb1_b2_Vc1_c2;
  double Vjcex_Vb1_b2_Vc4_c1;
  double Vjcex_Vb1_b2_Vdt_GND;
  double Vjcex_Vb1_b2_Vb1_e1;
  double Vjcex_Vb1_b2_Vb2_e1;
  double Vjcex_Vb1_b2_Vb2_c1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double a_VDC;
#if defined(_DERIVATE)
double a_VDC_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qbc_qs;
#if defined(_DERIVATEFORDDX)
double Qbc_qs_Vdt_GND;
double Qbc_qs_Vb2_c2;
double Qbc_qs_Vb2_c1;
double Qbc_qs_Vc1_c2;
double Qbc_qs_Vb_c;
double Qbc_qs_Vb_b1;
double Qbc_qs_Vb1_b2;
double Qbc_qs_Vc4_c1;
double Qbc_qs_Vc3_c1;
double Qbc_qs_Vc3_c4;
double Qbc_qs_Vb2_e1;
#if defined(_DERIVATE2)
  double Qbc_qs_Vb2_e1_Vdt_GND;
  double Qbc_qs_Vb2_e1_Vb2_c2;
  double Qbc_qs_Vb2_e1_Vb2_c1;
  double Qbc_qs_Vb2_e1_Vc1_c2;
  double Qbc_qs_Vb2_e1_Vb_c;
  double Qbc_qs_Vb2_e1_Vb_b1;
  double Qbc_qs_Vb2_e1_Vb1_b2;
  double Qbc_qs_Vb2_e1_Vc4_c1;
  double Qbc_qs_Vb2_e1_Vc3_c1;
  double Qbc_qs_Vb2_e1_Vc3_c4;
  double Qbc_qs_Vb2_e1_Vb2_e1;
  double Qbc_qs_Vc3_c1_Vdt_GND;
  double Qbc_qs_Vc3_c1_Vb2_c2;
  double Qbc_qs_Vc3_c1_Vb2_c1;
  double Qbc_qs_Vc3_c1_Vc1_c2;
  double Qbc_qs_Vc3_c1_Vb_c;
  double Qbc_qs_Vc3_c1_Vb_b1;
  double Qbc_qs_Vc3_c1_Vb1_b2;
  double Qbc_qs_Vc3_c1_Vc4_c1;
  double Qbc_qs_Vc3_c1_Vc3_c1;
  double Qbc_qs_Vc3_c1_Vc3_c4;
  double Qbc_qs_Vc3_c1_Vb2_e1;
  double Qbc_qs_Vc4_c1_Vdt_GND;
  double Qbc_qs_Vc4_c1_Vb2_c2;
  double Qbc_qs_Vc4_c1_Vb2_c1;
  double Qbc_qs_Vc4_c1_Vc1_c2;
  double Qbc_qs_Vc4_c1_Vb_c;
  double Qbc_qs_Vc4_c1_Vb_b1;
  double Qbc_qs_Vc4_c1_Vb1_b2;
  double Qbc_qs_Vc4_c1_Vc4_c1;
  double Qbc_qs_Vc4_c1_Vc3_c1;
  double Qbc_qs_Vc4_c1_Vc3_c4;
  double Qbc_qs_Vc4_c1_Vb2_e1;
  double Qbc_qs_Vc1_c2_Vdt_GND;
  double Qbc_qs_Vc1_c2_Vb2_c2;
  double Qbc_qs_Vc1_c2_Vb2_c1;
  double Qbc_qs_Vc1_c2_Vc1_c2;
  double Qbc_qs_Vc1_c2_Vb_c;
  double Qbc_qs_Vc1_c2_Vb_b1;
  double Qbc_qs_Vc1_c2_Vb1_b2;
  double Qbc_qs_Vc1_c2_Vc4_c1;
  double Qbc_qs_Vc1_c2_Vc3_c1;
  double Qbc_qs_Vc1_c2_Vc3_c4;
  double Qbc_qs_Vc1_c2_Vb2_e1;
  double Qbc_qs_Vb2_c1_Vdt_GND;
  double Qbc_qs_Vb2_c1_Vb2_c2;
  double Qbc_qs_Vb2_c1_Vb2_c1;
  double Qbc_qs_Vb2_c1_Vc1_c2;
  double Qbc_qs_Vb2_c1_Vb_c;
  double Qbc_qs_Vb2_c1_Vb_b1;
  double Qbc_qs_Vb2_c1_Vb1_b2;
  double Qbc_qs_Vb2_c1_Vc4_c1;
  double Qbc_qs_Vb2_c1_Vc3_c1;
  double Qbc_qs_Vb2_c1_Vc3_c4;
  double Qbc_qs_Vb2_c1_Vb2_e1;
  double Qbc_qs_Vb2_c2_Vdt_GND;
  double Qbc_qs_Vb2_c2_Vb2_c2;
  double Qbc_qs_Vb2_c2_Vb2_c1;
  double Qbc_qs_Vb2_c2_Vc1_c2;
  double Qbc_qs_Vb2_c2_Vb_c;
  double Qbc_qs_Vb2_c2_Vb_b1;
  double Qbc_qs_Vb2_c2_Vb1_b2;
  double Qbc_qs_Vb2_c2_Vc4_c1;
  double Qbc_qs_Vb2_c2_Vc3_c1;
  double Qbc_qs_Vb2_c2_Vc3_c4;
  double Qbc_qs_Vb2_c2_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qbe_qs;
#if defined(_DERIVATEFORDDX)
double Qbe_qs_Vdt_GND;
double Qbe_qs_Vb2_e1;
double Qbe_qs_Vb_c;
double Qbe_qs_Vb_b1;
double Qbe_qs_Vb1_b2;
double Qbe_qs_Vc4_c1;
double Qbe_qs_Vc3_c1;
double Qbe_qs_Vc3_c4;
double Qbe_qs_Vb2_c2;
double Qbe_qs_Vb2_c1;
double Qbe_qs_Vc1_c2;
#if defined(_DERIVATE2)
  double Qbe_qs_Vc1_c2_Vdt_GND;
  double Qbe_qs_Vc1_c2_Vb2_e1;
  double Qbe_qs_Vc1_c2_Vb_c;
  double Qbe_qs_Vc1_c2_Vb_b1;
  double Qbe_qs_Vc1_c2_Vb1_b2;
  double Qbe_qs_Vc1_c2_Vc4_c1;
  double Qbe_qs_Vc1_c2_Vc3_c1;
  double Qbe_qs_Vc1_c2_Vc3_c4;
  double Qbe_qs_Vc1_c2_Vb2_c2;
  double Qbe_qs_Vc1_c2_Vb2_c1;
  double Qbe_qs_Vc1_c2_Vc1_c2;
  double Qbe_qs_Vb2_c1_Vdt_GND;
  double Qbe_qs_Vb2_c1_Vb2_e1;
  double Qbe_qs_Vb2_c1_Vb_c;
  double Qbe_qs_Vb2_c1_Vb_b1;
  double Qbe_qs_Vb2_c1_Vb1_b2;
  double Qbe_qs_Vb2_c1_Vc4_c1;
  double Qbe_qs_Vb2_c1_Vc3_c1;
  double Qbe_qs_Vb2_c1_Vc3_c4;
  double Qbe_qs_Vb2_c1_Vb2_c2;
  double Qbe_qs_Vb2_c1_Vb2_c1;
  double Qbe_qs_Vb2_c1_Vc1_c2;
  double Qbe_qs_Vb2_c2_Vdt_GND;
  double Qbe_qs_Vb2_c2_Vb2_e1;
  double Qbe_qs_Vb2_c2_Vb_c;
  double Qbe_qs_Vb2_c2_Vb_b1;
  double Qbe_qs_Vb2_c2_Vb1_b2;
  double Qbe_qs_Vb2_c2_Vc4_c1;
  double Qbe_qs_Vb2_c2_Vc3_c1;
  double Qbe_qs_Vb2_c2_Vc3_c4;
  double Qbe_qs_Vb2_c2_Vb2_c2;
  double Qbe_qs_Vb2_c2_Vb2_c1;
  double Qbe_qs_Vb2_c2_Vc1_c2;
  double Qbe_qs_Vc3_c1_Vdt_GND;
  double Qbe_qs_Vc3_c1_Vb2_e1;
  double Qbe_qs_Vc3_c1_Vb_c;
  double Qbe_qs_Vc3_c1_Vb_b1;
  double Qbe_qs_Vc3_c1_Vb1_b2;
  double Qbe_qs_Vc3_c1_Vc4_c1;
  double Qbe_qs_Vc3_c1_Vc3_c1;
  double Qbe_qs_Vc3_c1_Vc3_c4;
  double Qbe_qs_Vc3_c1_Vb2_c2;
  double Qbe_qs_Vc3_c1_Vb2_c1;
  double Qbe_qs_Vc3_c1_Vc1_c2;
  double Qbe_qs_Vc4_c1_Vdt_GND;
  double Qbe_qs_Vc4_c1_Vb2_e1;
  double Qbe_qs_Vc4_c1_Vb_c;
  double Qbe_qs_Vc4_c1_Vb_b1;
  double Qbe_qs_Vc4_c1_Vb1_b2;
  double Qbe_qs_Vc4_c1_Vc4_c1;
  double Qbe_qs_Vc4_c1_Vc3_c1;
  double Qbe_qs_Vc4_c1_Vc3_c4;
  double Qbe_qs_Vc4_c1_Vb2_c2;
  double Qbe_qs_Vc4_c1_Vb2_c1;
  double Qbe_qs_Vc4_c1_Vc1_c2;
  double Qbe_qs_Vb2_e1_Vdt_GND;
  double Qbe_qs_Vb2_e1_Vb2_e1;
  double Qbe_qs_Vb2_e1_Vb_c;
  double Qbe_qs_Vb2_e1_Vb_b1;
  double Qbe_qs_Vb2_e1_Vb1_b2;
  double Qbe_qs_Vb2_e1_Vc4_c1;
  double Qbe_qs_Vb2_e1_Vc3_c1;
  double Qbe_qs_Vb2_e1_Vc3_c4;
  double Qbe_qs_Vb2_e1_Vb2_c2;
  double Qbe_qs_Vb2_e1_Vb2_c1;
  double Qbe_qs_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qb0;
#if defined(_DERIVATE)
double Qb0_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qtc;
#if defined(_DERIVATEFORDDX)
double Qtc_Vdt_GND;
double Qtc_Vb2_c2;
double Qtc_Vb2_c1;
double Qtc_Vc1_c2;
double Qtc_Vb2_e1;
#if defined(_DERIVATE2)
  double Qtc_Vc1_c2_Vdt_GND;
  double Qtc_Vc1_c2_Vb2_c2;
  double Qtc_Vc1_c2_Vb2_c1;
  double Qtc_Vc1_c2_Vc1_c2;
  double Qtc_Vc1_c2_Vb2_e1;
  double Qtc_Vb2_c1_Vdt_GND;
  double Qtc_Vb2_c1_Vb2_c2;
  double Qtc_Vb2_c1_Vb2_c1;
  double Qtc_Vb2_c1_Vc1_c2;
  double Qtc_Vb2_c1_Vb2_e1;
  double Qtc_Vb2_c2_Vdt_GND;
  double Qtc_Vb2_c2_Vb2_c2;
  double Qtc_Vb2_c2_Vb2_c1;
  double Qtc_Vb2_c2_Vc1_c2;
  double Qtc_Vb2_c2_Vb2_e1;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qte_s;
#if defined(_DERIVATEFORDDX)
double Qte_s_Vdt_GND;
double Qte_s_Vb1_e1;
double Qte_s_Vb2_e1;
double Qte_s_Vb2_c2;
double Qte_s_Vb2_c1;
double Qte_s_Vc1_c2;
#if defined(_DERIVATE2)
  double Qte_s_Vb2_e1_Vdt_GND;
  double Qte_s_Vb2_e1_Vb1_e1;
  double Qte_s_Vb2_e1_Vb2_e1;
  double Qte_s_Vb2_e1_Vb2_c2;
  double Qte_s_Vb2_e1_Vb2_c1;
  double Qte_s_Vb2_e1_Vc1_c2;
  double Qte_s_Vb1_e1_Vdt_GND;
  double Qte_s_Vb1_e1_Vb1_e1;
  double Qte_s_Vb1_e1_Vb2_e1;
  double Qte_s_Vb1_e1_Vb2_c2;
  double Qte_s_Vb1_e1_Vb2_c1;
  double Qte_s_Vb1_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Vje_s;
#if defined(_DERIVATEFORDDX)
double Vje_s_Vb1_e1;
double Vje_s_Vdt_GND;
double Vje_s_Vb2_e1;
double Vje_s_Vb2_c2;
double Vje_s_Vb2_c1;
double Vje_s_Vc1_c2;
#if defined(_DERIVATE2)
  double Vje_s_Vb2_e1_Vb1_e1;
  double Vje_s_Vb2_e1_Vdt_GND;
  double Vje_s_Vb2_e1_Vb2_e1;
  double Vje_s_Vb2_e1_Vb2_c2;
  double Vje_s_Vb2_e1_Vb2_c1;
  double Vje_s_Vb2_e1_Vc1_c2;
  double Vje_s_Vb1_e1_Vb1_e1;
  double Vje_s_Vb1_e1_Vdt_GND;
  double Vje_s_Vb1_e1_Vb2_e1;
  double Vje_s_Vb1_e1_Vb2_c2;
  double Vje_s_Vb1_e1_Vb2_c1;
  double Vje_s_Vb1_e1_Vc1_c2;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qte;
#if defined(_DERIVATEFORDDX)
double Qte_Vdt_GND;
double Qte_Vb2_e1;
double Qte_Vb2_c2;
double Qte_Vb2_c1;
double Qte_Vc1_c2;
#if defined(_DERIVATE2)
  double Qte_Vb2_e1_Vdt_GND;
  double Qte_Vb2_e1_Vb2_e1;
  double Qte_Vb2_e1_Vb2_c2;
  double Qte_Vb2_e1_Vb2_c1;
  double Qte_Vb2_e1_Vc1_c2;
#endif
#endif
#endif
double power_dis;
#if defined(_DERIVATE)
double power_dis_Vdt_GND;
double power_dis_Vb2_e1;
double power_dis_Vb2_c2;
double power_dis_Vb2_c1;
double power_dis_Vc1_c2;
double power_dis_Vb_c;
double power_dis_Vb_b1;
double power_dis_Vb1_b2;
double power_dis_Vc4_c1;
double power_dis_Vc3_c1;
double power_dis_Vc3_c4;
double power_dis_Ve_e1;
double power_dis_Vb1_e1;
double power_dis_Vs_c1;
#endif
double Vb2c2star;
#if defined(_DERIVATE)
double Vb2c2star_Vdt_GND;
double Vb2c2star_Vb2_c2;
double Vb2c2star_Vb2_c1;
double Vb2c2star_Vc1_c2;
#endif
double Gmax;
#if defined(_DERIVATEFORDDX)
double Gmax_Vdt_GND;
double Gmax_Vb2_c2;
double Gmax_Vb2_c1;
double Gmax_Vc1_c2;
double Gmax_Vb_c;
double Gmax_Vb_b1;
double Gmax_Vb1_b2;
double Gmax_Vc4_c1;
double Gmax_Vc3_c1;
double Gmax_Vc3_c4;
double Gmax_Vb2_e1;
#if defined(_DERIVATE2)
  double Gmax_Vb2_e1_Vdt_GND;
  double Gmax_Vb2_e1_Vb2_c2;
  double Gmax_Vb2_e1_Vb2_c1;
  double Gmax_Vb2_e1_Vc1_c2;
  double Gmax_Vb2_e1_Vb_c;
  double Gmax_Vb2_e1_Vb_b1;
  double Gmax_Vb2_e1_Vb1_b2;
  double Gmax_Vb2_e1_Vc4_c1;
  double Gmax_Vb2_e1_Vc3_c1;
  double Gmax_Vb2_e1_Vc3_c4;
  double Gmax_Vb2_e1_Vb2_e1;
  double Gmax_Vc3_c1_Vdt_GND;
  double Gmax_Vc3_c1_Vb2_c2;
  double Gmax_Vc3_c1_Vb2_c1;
  double Gmax_Vc3_c1_Vc1_c2;
  double Gmax_Vc3_c1_Vb_c;
  double Gmax_Vc3_c1_Vb_b1;
  double Gmax_Vc3_c1_Vb1_b2;
  double Gmax_Vc3_c1_Vc4_c1;
  double Gmax_Vc3_c1_Vc3_c1;
  double Gmax_Vc3_c1_Vc3_c4;
  double Gmax_Vc3_c1_Vb2_e1;
  double Gmax_Vc4_c1_Vdt_GND;
  double Gmax_Vc4_c1_Vb2_c2;
  double Gmax_Vc4_c1_Vb2_c1;
  double Gmax_Vc4_c1_Vc1_c2;
  double Gmax_Vc4_c1_Vb_c;
  double Gmax_Vc4_c1_Vb_b1;
  double Gmax_Vc4_c1_Vb1_b2;
  double Gmax_Vc4_c1_Vc4_c1;
  double Gmax_Vc4_c1_Vc3_c1;
  double Gmax_Vc4_c1_Vc3_c4;
  double Gmax_Vc4_c1_Vb2_e1;
  double Gmax_Vc1_c2_Vdt_GND;
  double Gmax_Vc1_c2_Vb2_c2;
  double Gmax_Vc1_c2_Vb2_c1;
  double Gmax_Vc1_c2_Vc1_c2;
  double Gmax_Vc1_c2_Vb_c;
  double Gmax_Vc1_c2_Vb_b1;
  double Gmax_Vc1_c2_Vb1_b2;
  double Gmax_Vc1_c2_Vc4_c1;
  double Gmax_Vc1_c2_Vc3_c1;
  double Gmax_Vc1_c2_Vc3_c4;
  double Gmax_Vc1_c2_Vb2_e1;
  double Gmax_Vb2_c1_Vdt_GND;
  double Gmax_Vb2_c1_Vb2_c2;
  double Gmax_Vb2_c1_Vb2_c1;
  double Gmax_Vb2_c1_Vc1_c2;
  double Gmax_Vb2_c1_Vb_c;
  double Gmax_Vb2_c1_Vb_b1;
  double Gmax_Vb2_c1_Vb1_b2;
  double Gmax_Vb2_c1_Vc4_c1;
  double Gmax_Vb2_c1_Vc3_c1;
  double Gmax_Vb2_c1_Vc3_c4;
  double Gmax_Vb2_c1_Vb2_e1;
  double Gmax_Vb2_c2_Vdt_GND;
  double Gmax_Vb2_c2_Vb2_c2;
  double Gmax_Vb2_c2_Vb2_c1;
  double Gmax_Vb2_c2_Vc1_c2;
  double Gmax_Vb2_c2_Vb_c;
  double Gmax_Vb2_c2_Vb_b1;
  double Gmax_Vb2_c2_Vb1_b2;
  double Gmax_Vb2_c2_Vc4_c1;
  double Gmax_Vb2_c2_Vc3_c1;
  double Gmax_Vb2_c2_Vc3_c4;
  double Gmax_Vb2_c2_Vb2_e1;
#endif
#endif
double lambda;
#if defined(_DERIVATEFORDDX)
double lambda_Vdt_GND;
double lambda_Vb2_c2;
double lambda_Vb2_c1;
double lambda_Vc1_c2;
#if defined(_DERIVATE2)
  double lambda_Vc1_c2_Vdt_GND;
  double lambda_Vc1_c2_Vb2_c2;
  double lambda_Vc1_c2_Vb2_c1;
  double lambda_Vc1_c2_Vc1_c2;
  double lambda_Vb2_c1_Vdt_GND;
  double lambda_Vb2_c1_Vb2_c2;
  double lambda_Vb2_c1_Vb2_c1;
  double lambda_Vb2_c1_Vc1_c2;
  double lambda_Vb2_c2_Vdt_GND;
  double lambda_Vb2_c2_Vb2_c2;
  double lambda_Vb2_c2_Vb2_c1;
  double lambda_Vb2_c2_Vc1_c2;
#endif
#endif
double EmEav_Em;
#if defined(_DERIVATEFORDDX)
double EmEav_Em_Vdt_GND;
double EmEav_Em_Vb2_c1;
double EmEav_Em_Vb2_c2;
double EmEav_Em_Vc1_c2;
#if defined(_DERIVATE2)
  double EmEav_Em_Vc1_c2_Vdt_GND;
  double EmEav_Em_Vc1_c2_Vb2_c1;
  double EmEav_Em_Vc1_c2_Vb2_c2;
  double EmEav_Em_Vc1_c2_Vc1_c2;
  double EmEav_Em_Vb2_c2_Vdt_GND;
  double EmEav_Em_Vb2_c2_Vb2_c1;
  double EmEav_Em_Vb2_c2_Vb2_c2;
  double EmEav_Em_Vb2_c2_Vc1_c2;
  double EmEav_Em_Vb2_c1_Vdt_GND;
  double EmEav_Em_Vb2_c1_Vb2_c1;
  double EmEav_Em_Vb2_c1_Vb2_c2;
  double EmEav_Em_Vb2_c1_Vc1_c2;
#endif
#endif
double Ew;
#if defined(_DERIVATEFORDDX)
double Ew_Vdt_GND;
double Ew_Vb2_c1;
double Ew_Vb2_c2;
double Ew_Vc1_c2;
#if defined(_DERIVATE2)
  double Ew_Vc1_c2_Vdt_GND;
  double Ew_Vc1_c2_Vb2_c1;
  double Ew_Vc1_c2_Vb2_c2;
  double Ew_Vc1_c2_Vc1_c2;
  double Ew_Vb2_c2_Vdt_GND;
  double Ew_Vb2_c2_Vb2_c1;
  double Ew_Vb2_c2_Vb2_c2;
  double Ew_Vb2_c2_Vc1_c2;
  double Ew_Vb2_c1_Vdt_GND;
  double Ew_Vb2_c1_Vb2_c1;
  double Ew_Vb2_c1_Vb2_c2;
  double Ew_Vb2_c1_Vc1_c2;
#endif
#endif
double Efi;
double SHw;
#if defined(_DERIVATEFORDDX)
double SHw_Vb2_c2;
double SHw_Vb2_c1;
double SHw_Vc1_c2;
double SHw_Vdt_GND;
#if defined(_DERIVATE2)
  double SHw_Vc1_c2_Vb2_c2;
  double SHw_Vc1_c2_Vb2_c1;
  double SHw_Vc1_c2_Vc1_c2;
  double SHw_Vc1_c2_Vdt_GND;
  double SHw_Vb2_c1_Vb2_c2;
  double SHw_Vb2_c1_Vb2_c1;
  double SHw_Vb2_c1_Vc1_c2;
  double SHw_Vb2_c1_Vdt_GND;
  double SHw_Vb2_c2_Vb2_c2;
  double SHw_Vb2_c2_Vb2_c1;
  double SHw_Vb2_c2_Vc1_c2;
  double SHw_Vb2_c2_Vdt_GND;
#endif
#endif
double Em;
#if defined(_DERIVATEFORDDX)
double Em_Vdt_GND;
double Em_Vb2_c1;
double Em_Vb2_c2;
double Em_Vc1_c2;
#if defined(_DERIVATE2)
  double Em_Vc1_c2_Vdt_GND;
  double Em_Vc1_c2_Vb2_c1;
  double Em_Vc1_c2_Vb2_c2;
  double Em_Vc1_c2_Vc1_c2;
  double Em_Vb2_c2_Vdt_GND;
  double Em_Vb2_c2_Vb2_c1;
  double Em_Vb2_c2_Vb2_c2;
  double Em_Vb2_c2_Vc1_c2;
  double Em_Vb2_c1_Vdt_GND;
  double Em_Vb2_c1_Vb2_c1;
  double Em_Vb2_c1_Vb2_c2;
  double Em_Vb2_c1_Vc1_c2;
#endif
#endif
double E0;
#if defined(_DERIVATEFORDDX)
double E0_Vdt_GND;
double E0_Vb2_c1;
double E0_Vb2_c2;
double E0_Vc1_c2;
#if defined(_DERIVATE2)
  double E0_Vc1_c2_Vdt_GND;
  double E0_Vc1_c2_Vb2_c1;
  double E0_Vc1_c2_Vb2_c2;
  double E0_Vc1_c2_Vc1_c2;
  double E0_Vb2_c2_Vdt_GND;
  double E0_Vb2_c2_Vb2_c1;
  double E0_Vb2_c2_Vb2_c2;
  double E0_Vb2_c2_Vc1_c2;
  double E0_Vb2_c1_Vdt_GND;
  double E0_Vb2_c1_Vb2_c1;
  double E0_Vb2_c1_Vb2_c2;
  double E0_Vb2_c1_Vc1_c2;
#endif
#endif
double Eav;
#if defined(_DERIVATEFORDDX)
double Eav_Vdt_GND;
double Eav_Vb2_c1;
double Eav_Vb2_c2;
double Eav_Vc1_c2;
#if defined(_DERIVATE2)
  double Eav_Vc1_c2_Vdt_GND;
  double Eav_Vc1_c2_Vb2_c1;
  double Eav_Vc1_c2_Vb2_c2;
  double Eav_Vc1_c2_Vc1_c2;
  double Eav_Vb2_c2_Vdt_GND;
  double Eav_Vb2_c2_Vb2_c1;
  double Eav_Vb2_c2_Vb2_c2;
  double Eav_Vb2_c2_Vc1_c2;
  double Eav_Vb2_c1_Vdt_GND;
  double Eav_Vb2_c1_Vb2_c1;
  double Eav_Vb2_c1_Vb2_c2;
  double Eav_Vb2_c1_Vc1_c2;
#endif
#endif
double Wd;
#if defined(_DERIVATEFORDDX)
double Wd_Vdt_GND;
double Wd_Vb2_c2;
double Wd_Vb2_c1;
double Wd_Vc1_c2;
#if defined(_DERIVATE2)
  double Wd_Vc1_c2_Vdt_GND;
  double Wd_Vc1_c2_Vb2_c2;
  double Wd_Vc1_c2_Vb2_c1;
  double Wd_Vc1_c2_Vc1_c2;
  double Wd_Vb2_c1_Vdt_GND;
  double Wd_Vb2_c1_Vb2_c2;
  double Wd_Vb2_c1_Vb2_c1;
  double Wd_Vb2_c1_Vc1_c2;
  double Wd_Vb2_c2_Vdt_GND;
  double Wd_Vb2_c2_Vb2_c2;
  double Wd_Vb2_c2_Vb2_c1;
  double Wd_Vb2_c2_Vc1_c2;
#endif
#endif
double xi_w1;
#if defined(_DERIVATEFORDDX)
double xi_w1_Vb2_c2;
double xi_w1_Vb2_c1;
double xi_w1_Vc1_c2;
double xi_w1_Vdt_GND;
#if defined(_DERIVATE2)
  double xi_w1_Vc1_c2_Vb2_c2;
  double xi_w1_Vc1_c2_Vb2_c1;
  double xi_w1_Vc1_c2_Vc1_c2;
  double xi_w1_Vc1_c2_Vdt_GND;
  double xi_w1_Vb2_c1_Vb2_c2;
  double xi_w1_Vb2_c1_Vb2_c1;
  double xi_w1_Vb2_c1_Vc1_c2;
  double xi_w1_Vb2_c1_Vdt_GND;
  double xi_w1_Vb2_c2_Vb2_c2;
  double xi_w1_Vb2_c2_Vb2_c1;
  double xi_w1_Vb2_c2_Vc1_c2;
  double xi_w1_Vb2_c2_Vdt_GND;
#endif
#endif
double Weff;
#if defined(_DERIVATEFORDDX)
double Weff_Vb2_c2;
double Weff_Vb2_c1;
double Weff_Vc1_c2;
double Weff_Vdt_GND;
#if defined(_DERIVATE2)
  double Weff_Vc1_c2_Vb2_c2;
  double Weff_Vc1_c2_Vb2_c1;
  double Weff_Vc1_c2_Vc1_c2;
  double Weff_Vc1_c2_Vdt_GND;
  double Weff_Vb2_c1_Vb2_c2;
  double Weff_Vb2_c1_Vb2_c1;
  double Weff_Vb2_c1_Vc1_c2;
  double Weff_Vb2_c1_Vdt_GND;
  double Weff_Vb2_c2_Vb2_c2;
  double Weff_Vb2_c2_Vb2_c1;
  double Weff_Vb2_c2_Vc1_c2;
  double Weff_Vb2_c2_Vdt_GND;
#endif
#endif
double xd;
#if defined(_DERIVATEFORDDX)
double xd_Vdt_GND;
double xd_Vb2_c2;
double xd_Vb2_c1;
double xd_Vc1_c2;
#if defined(_DERIVATE2)
  double xd_Vc1_c2_Vdt_GND;
  double xd_Vc1_c2_Vb2_c2;
  double xd_Vc1_c2_Vb2_c1;
  double xd_Vc1_c2_Vc1_c2;
  double xd_Vb2_c1_Vdt_GND;
  double xd_Vb2_c1_Vb2_c2;
  double xd_Vb2_c1_Vb2_c1;
  double xd_Vb2_c1_Vc1_c2;
  double xd_Vb2_c2_Vdt_GND;
  double xd_Vb2_c2_Vb2_c2;
  double xd_Vb2_c2_Vb2_c1;
  double xd_Vb2_c2_Vc1_c2;
#endif
#endif
double dEdx0;
double Gem;
#if defined(_DERIVATEFORDDX)
double Gem_Vdt_GND;
double Gem_Vb2_c1;
double Gem_Vb2_c2;
double Gem_Vc1_c2;
#if defined(_DERIVATE2)
  double Gem_Vc1_c2_Vdt_GND;
  double Gem_Vc1_c2_Vb2_c1;
  double Gem_Vc1_c2_Vb2_c2;
  double Gem_Vc1_c2_Vc1_c2;
  double Gem_Vb2_c2_Vdt_GND;
  double Gem_Vb2_c2_Vb2_c1;
  double Gem_Vb2_c2_Vb2_c2;
  double Gem_Vb2_c2_Vc1_c2;
  double Gem_Vb2_c1_Vdt_GND;
  double Gem_Vb2_c1_Vb2_c1;
  double Gem_Vb2_c1_Vb2_c2;
  double Gem_Vb2_c1_Vc1_c2;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Iavl_Vdt_GND;
double Iavl_Vb2_c2;
double Iavl_Vb2_c1;
double Iavl_Vc1_c2;
double Iavl_Vb_c;
double Iavl_Vb_b1;
double Iavl_Vb1_b2;
double Iavl_Vc4_c1;
double Iavl_Vc3_c1;
double Iavl_Vc3_c4;
double Iavl_Vb2_e1;
#if defined(_DERIVATE2)
  double Iavl_Vb2_e1_Vdt_GND;
  double Iavl_Vb2_e1_Vb2_c2;
  double Iavl_Vb2_e1_Vb2_c1;
  double Iavl_Vb2_e1_Vc1_c2;
  double Iavl_Vb2_e1_Vb_c;
  double Iavl_Vb2_e1_Vb_b1;
  double Iavl_Vb2_e1_Vb1_b2;
  double Iavl_Vb2_e1_Vc4_c1;
  double Iavl_Vb2_e1_Vc3_c1;
  double Iavl_Vb2_e1_Vc3_c4;
  double Iavl_Vb2_e1_Vb2_e1;
  double Iavl_Vc3_c1_Vdt_GND;
  double Iavl_Vc3_c1_Vb2_c2;
  double Iavl_Vc3_c1_Vb2_c1;
  double Iavl_Vc3_c1_Vc1_c2;
  double Iavl_Vc3_c1_Vb_c;
  double Iavl_Vc3_c1_Vb_b1;
  double Iavl_Vc3_c1_Vb1_b2;
  double Iavl_Vc3_c1_Vc4_c1;
  double Iavl_Vc3_c1_Vc3_c1;
  double Iavl_Vc3_c1_Vc3_c4;
  double Iavl_Vc3_c1_Vb2_e1;
  double Iavl_Vc4_c1_Vdt_GND;
  double Iavl_Vc4_c1_Vb2_c2;
  double Iavl_Vc4_c1_Vb2_c1;
  double Iavl_Vc4_c1_Vc1_c2;
  double Iavl_Vc4_c1_Vb_c;
  double Iavl_Vc4_c1_Vb_b1;
  double Iavl_Vc4_c1_Vb1_b2;
  double Iavl_Vc4_c1_Vc4_c1;
  double Iavl_Vc4_c1_Vc3_c1;
  double Iavl_Vc4_c1_Vc3_c4;
  double Iavl_Vc4_c1_Vb2_e1;
  double Iavl_Vc1_c2_Vdt_GND;
  double Iavl_Vc1_c2_Vb2_c2;
  double Iavl_Vc1_c2_Vb2_c1;
  double Iavl_Vc1_c2_Vc1_c2;
  double Iavl_Vc1_c2_Vb_c;
  double Iavl_Vc1_c2_Vb_b1;
  double Iavl_Vc1_c2_Vb1_b2;
  double Iavl_Vc1_c2_Vc4_c1;
  double Iavl_Vc1_c2_Vc3_c1;
  double Iavl_Vc1_c2_Vc3_c4;
  double Iavl_Vc1_c2_Vb2_e1;
  double Iavl_Vb2_c1_Vdt_GND;
  double Iavl_Vb2_c1_Vb2_c2;
  double Iavl_Vb2_c1_Vb2_c1;
  double Iavl_Vb2_c1_Vc1_c2;
  double Iavl_Vb2_c1_Vb_c;
  double Iavl_Vb2_c1_Vb_b1;
  double Iavl_Vb2_c1_Vb1_b2;
  double Iavl_Vb2_c1_Vc4_c1;
  double Iavl_Vb2_c1_Vc3_c1;
  double Iavl_Vb2_c1_Vc3_c4;
  double Iavl_Vb2_c1_Vb2_e1;
  double Iavl_Vb2_c2_Vdt_GND;
  double Iavl_Vb2_c2_Vb2_c2;
  double Iavl_Vb2_c2_Vb2_c1;
  double Iavl_Vb2_c2_Vc1_c2;
  double Iavl_Vb2_c2_Vb_c;
  double Iavl_Vb2_c2_Vb_b1;
  double Iavl_Vb2_c2_Vb1_b2;
  double Iavl_Vb2_c2_Vc4_c1;
  double Iavl_Vb2_c2_Vc3_c1;
  double Iavl_Vb2_c2_Vc3_c4;
  double Iavl_Vb2_c2_Vb2_e1;
#endif
#endif
double Ib1b2;
#if defined(_DERIVATEFORDDX)
double Ib1b2_Vdt_GND;
double Ib1b2_Vb1_b2;
double Ib1b2_Vb_c;
double Ib1b2_Vb_b1;
double Ib1b2_Vc4_c1;
double Ib1b2_Vc3_c1;
double Ib1b2_Vc3_c4;
double Ib1b2_Vb2_e1;
double Ib1b2_Vb2_c2;
double Ib1b2_Vb2_c1;
double Ib1b2_Vc1_c2;
#if defined(_DERIVATE2)
  double Ib1b2_Vc1_c2_Vdt_GND;
  double Ib1b2_Vc1_c2_Vb1_b2;
  double Ib1b2_Vc1_c2_Vb_c;
  double Ib1b2_Vc1_c2_Vb_b1;
  double Ib1b2_Vc1_c2_Vc4_c1;
  double Ib1b2_Vc1_c2_Vc3_c1;
  double Ib1b2_Vc1_c2_Vc3_c4;
  double Ib1b2_Vc1_c2_Vb2_e1;
  double Ib1b2_Vc1_c2_Vb2_c2;
  double Ib1b2_Vc1_c2_Vb2_c1;
  double Ib1b2_Vc1_c2_Vc1_c2;
  double Ib1b2_Vb2_c1_Vdt_GND;
  double Ib1b2_Vb2_c1_Vb1_b2;
  double Ib1b2_Vb2_c1_Vb_c;
  double Ib1b2_Vb2_c1_Vb_b1;
  double Ib1b2_Vb2_c1_Vc4_c1;
  double Ib1b2_Vb2_c1_Vc3_c1;
  double Ib1b2_Vb2_c1_Vc3_c4;
  double Ib1b2_Vb2_c1_Vb2_e1;
  double Ib1b2_Vb2_c1_Vb2_c2;
  double Ib1b2_Vb2_c1_Vb2_c1;
  double Ib1b2_Vb2_c1_Vc1_c2;
  double Ib1b2_Vb2_c2_Vdt_GND;
  double Ib1b2_Vb2_c2_Vb1_b2;
  double Ib1b2_Vb2_c2_Vb_c;
  double Ib1b2_Vb2_c2_Vb_b1;
  double Ib1b2_Vb2_c2_Vc4_c1;
  double Ib1b2_Vb2_c2_Vc3_c1;
  double Ib1b2_Vb2_c2_Vc3_c4;
  double Ib1b2_Vb2_c2_Vb2_e1;
  double Ib1b2_Vb2_c2_Vb2_c2;
  double Ib1b2_Vb2_c2_Vb2_c1;
  double Ib1b2_Vb2_c2_Vc1_c2;
  double Ib1b2_Vb2_e1_Vdt_GND;
  double Ib1b2_Vb2_e1_Vb1_b2;
  double Ib1b2_Vb2_e1_Vb_c;
  double Ib1b2_Vb2_e1_Vb_b1;
  double Ib1b2_Vb2_e1_Vc4_c1;
  double Ib1b2_Vb2_e1_Vc3_c1;
  double Ib1b2_Vb2_e1_Vc3_c4;
  double Ib1b2_Vb2_e1_Vb2_e1;
  double Ib1b2_Vb2_e1_Vb2_c2;
  double Ib1b2_Vb2_e1_Vb2_c1;
  double Ib1b2_Vb2_e1_Vc1_c2;
  double Ib1b2_Vc3_c1_Vdt_GND;
  double Ib1b2_Vc3_c1_Vb1_b2;
  double Ib1b2_Vc3_c1_Vb_c;
  double Ib1b2_Vc3_c1_Vb_b1;
  double Ib1b2_Vc3_c1_Vc4_c1;
  double Ib1b2_Vc3_c1_Vc3_c1;
  double Ib1b2_Vc3_c1_Vc3_c4;
  double Ib1b2_Vc3_c1_Vb2_e1;
  double Ib1b2_Vc3_c1_Vb2_c2;
  double Ib1b2_Vc3_c1_Vb2_c1;
  double Ib1b2_Vc3_c1_Vc1_c2;
  double Ib1b2_Vc4_c1_Vdt_GND;
  double Ib1b2_Vc4_c1_Vb1_b2;
  double Ib1b2_Vc4_c1_Vb_c;
  double Ib1b2_Vc4_c1_Vb_b1;
  double Ib1b2_Vc4_c1_Vc4_c1;
  double Ib1b2_Vc4_c1_Vc3_c1;
  double Ib1b2_Vc4_c1_Vc3_c4;
  double Ib1b2_Vc4_c1_Vb2_e1;
  double Ib1b2_Vc4_c1_Vb2_c2;
  double Ib1b2_Vc4_c1_Vb2_c1;
  double Ib1b2_Vc4_c1_Vc1_c2;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Rb2_Vdt_GND;
double Rb2_Vb_c;
double Rb2_Vb_b1;
double Rb2_Vb1_b2;
double Rb2_Vc4_c1;
double Rb2_Vc3_c1;
double Rb2_Vc3_c4;
double Rb2_Vb2_e1;
double Rb2_Vb2_c2;
double Rb2_Vb2_c1;
double Rb2_Vc1_c2;
#if defined(_DERIVATE2)
  double Rb2_Vc1_c2_Vdt_GND;
  double Rb2_Vc1_c2_Vb_c;
  double Rb2_Vc1_c2_Vb_b1;
  double Rb2_Vc1_c2_Vb1_b2;
  double Rb2_Vc1_c2_Vc4_c1;
  double Rb2_Vc1_c2_Vc3_c1;
  double Rb2_Vc1_c2_Vc3_c4;
  double Rb2_Vc1_c2_Vb2_e1;
  double Rb2_Vc1_c2_Vb2_c2;
  double Rb2_Vc1_c2_Vb2_c1;
  double Rb2_Vc1_c2_Vc1_c2;
  double Rb2_Vb2_c1_Vdt_GND;
  double Rb2_Vb2_c1_Vb_c;
  double Rb2_Vb2_c1_Vb_b1;
  double Rb2_Vb2_c1_Vb1_b2;
  double Rb2_Vb2_c1_Vc4_c1;
  double Rb2_Vb2_c1_Vc3_c1;
  double Rb2_Vb2_c1_Vc3_c4;
  double Rb2_Vb2_c1_Vb2_e1;
  double Rb2_Vb2_c1_Vb2_c2;
  double Rb2_Vb2_c1_Vb2_c1;
  double Rb2_Vb2_c1_Vc1_c2;
  double Rb2_Vb2_c2_Vdt_GND;
  double Rb2_Vb2_c2_Vb_c;
  double Rb2_Vb2_c2_Vb_b1;
  double Rb2_Vb2_c2_Vb1_b2;
  double Rb2_Vb2_c2_Vc4_c1;
  double Rb2_Vb2_c2_Vc3_c1;
  double Rb2_Vb2_c2_Vc3_c4;
  double Rb2_Vb2_c2_Vb2_e1;
  double Rb2_Vb2_c2_Vb2_c2;
  double Rb2_Vb2_c2_Vb2_c1;
  double Rb2_Vb2_c2_Vc1_c2;
  double Rb2_Vb2_e1_Vdt_GND;
  double Rb2_Vb2_e1_Vb_c;
  double Rb2_Vb2_e1_Vb_b1;
  double Rb2_Vb2_e1_Vb1_b2;
  double Rb2_Vb2_e1_Vc4_c1;
  double Rb2_Vb2_e1_Vc3_c1;
  double Rb2_Vb2_e1_Vc3_c4;
  double Rb2_Vb2_e1_Vb2_e1;
  double Rb2_Vb2_e1_Vb2_c2;
  double Rb2_Vb2_e1_Vb2_c1;
  double Rb2_Vb2_e1_Vc1_c2;
  double Rb2_Vc3_c1_Vdt_GND;
  double Rb2_Vc3_c1_Vb_c;
  double Rb2_Vc3_c1_Vb_b1;
  double Rb2_Vc3_c1_Vb1_b2;
  double Rb2_Vc3_c1_Vc4_c1;
  double Rb2_Vc3_c1_Vc3_c1;
  double Rb2_Vc3_c1_Vc3_c4;
  double Rb2_Vc3_c1_Vb2_e1;
  double Rb2_Vc3_c1_Vb2_c2;
  double Rb2_Vc3_c1_Vb2_c1;
  double Rb2_Vc3_c1_Vc1_c2;
  double Rb2_Vc4_c1_Vdt_GND;
  double Rb2_Vc4_c1_Vb_c;
  double Rb2_Vc4_c1_Vb_b1;
  double Rb2_Vc4_c1_Vb1_b2;
  double Rb2_Vc4_c1_Vc4_c1;
  double Rb2_Vc4_c1_Vc3_c1;
  double Rb2_Vc4_c1_Vc3_c4;
  double Rb2_Vc4_c1_Vb2_e1;
  double Rb2_Vc4_c1_Vb2_c2;
  double Rb2_Vc4_c1_Vb2_c1;
  double Rb2_Vc4_c1_Vc1_c2;
#endif
#endif
double qBQ;
#if defined(_DERIVATEFORDDX)
double qBQ_Vdt_GND;
double qBQ_Vb_c;
double qBQ_Vb_b1;
double qBQ_Vb1_b2;
double qBQ_Vc4_c1;
double qBQ_Vc3_c1;
double qBQ_Vc3_c4;
double qBQ_Vb2_e1;
double qBQ_Vb2_c2;
double qBQ_Vb2_c1;
double qBQ_Vc1_c2;
#if defined(_DERIVATE2)
  double qBQ_Vc1_c2_Vdt_GND;
  double qBQ_Vc1_c2_Vb_c;
  double qBQ_Vc1_c2_Vb_b1;
  double qBQ_Vc1_c2_Vb1_b2;
  double qBQ_Vc1_c2_Vc4_c1;
  double qBQ_Vc1_c2_Vc3_c1;
  double qBQ_Vc1_c2_Vc3_c4;
  double qBQ_Vc1_c2_Vb2_e1;
  double qBQ_Vc1_c2_Vb2_c2;
  double qBQ_Vc1_c2_Vb2_c1;
  double qBQ_Vc1_c2_Vc1_c2;
  double qBQ_Vb2_c1_Vdt_GND;
  double qBQ_Vb2_c1_Vb_c;
  double qBQ_Vb2_c1_Vb_b1;
  double qBQ_Vb2_c1_Vb1_b2;
  double qBQ_Vb2_c1_Vc4_c1;
  double qBQ_Vb2_c1_Vc3_c1;
  double qBQ_Vb2_c1_Vc3_c4;
  double qBQ_Vb2_c1_Vb2_e1;
  double qBQ_Vb2_c1_Vb2_c2;
  double qBQ_Vb2_c1_Vb2_c1;
  double qBQ_Vb2_c1_Vc1_c2;
  double qBQ_Vb2_c2_Vdt_GND;
  double qBQ_Vb2_c2_Vb_c;
  double qBQ_Vb2_c2_Vb_b1;
  double qBQ_Vb2_c2_Vb1_b2;
  double qBQ_Vb2_c2_Vc4_c1;
  double qBQ_Vb2_c2_Vc3_c1;
  double qBQ_Vb2_c2_Vc3_c4;
  double qBQ_Vb2_c2_Vb2_e1;
  double qBQ_Vb2_c2_Vb2_c2;
  double qBQ_Vb2_c2_Vb2_c1;
  double qBQ_Vb2_c2_Vc1_c2;
  double qBQ_Vb2_e1_Vdt_GND;
  double qBQ_Vb2_e1_Vb_c;
  double qBQ_Vb2_e1_Vb_b1;
  double qBQ_Vb2_e1_Vb1_b2;
  double qBQ_Vb2_e1_Vc4_c1;
  double qBQ_Vb2_e1_Vc3_c1;
  double qBQ_Vb2_e1_Vc3_c4;
  double qBQ_Vb2_e1_Vb2_e1;
  double qBQ_Vb2_e1_Vb2_c2;
  double qBQ_Vb2_e1_Vb2_c1;
  double qBQ_Vb2_e1_Vc1_c2;
  double qBQ_Vc3_c1_Vdt_GND;
  double qBQ_Vc3_c1_Vb_c;
  double qBQ_Vc3_c1_Vb_b1;
  double qBQ_Vc3_c1_Vb1_b2;
  double qBQ_Vc3_c1_Vc4_c1;
  double qBQ_Vc3_c1_Vc3_c1;
  double qBQ_Vc3_c1_Vc3_c4;
  double qBQ_Vc3_c1_Vb2_e1;
  double qBQ_Vc3_c1_Vb2_c2;
  double qBQ_Vc3_c1_Vb2_c1;
  double qBQ_Vc3_c1_Vc1_c2;
  double qBQ_Vc4_c1_Vdt_GND;
  double qBQ_Vc4_c1_Vb_c;
  double qBQ_Vc4_c1_Vb_b1;
  double qBQ_Vc4_c1_Vb1_b2;
  double qBQ_Vc4_c1_Vc4_c1;
  double qBQ_Vc4_c1_Vc3_c1;
  double qBQ_Vc4_c1_Vc3_c4;
  double qBQ_Vc4_c1_Vb2_e1;
  double qBQ_Vc4_c1_Vb2_c2;
  double qBQ_Vc4_c1_Vb2_c1;
  double qBQ_Vc4_c1_Vc1_c2;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double q1Q_Vdt_GND;
double q1Q_Vb_c;
double q1Q_Vb_b1;
double q1Q_Vb1_b2;
double q1Q_Vc4_c1;
double q1Q_Vc3_c1;
double q1Q_Vc3_c4;
double q1Q_Vb2_e1;
double q1Q_Vb2_c2;
double q1Q_Vb2_c1;
double q1Q_Vc1_c2;
#if defined(_DERIVATE2)
  double q1Q_Vc1_c2_Vdt_GND;
  double q1Q_Vc1_c2_Vb_c;
  double q1Q_Vc1_c2_Vb_b1;
  double q1Q_Vc1_c2_Vb1_b2;
  double q1Q_Vc1_c2_Vc4_c1;
  double q1Q_Vc1_c2_Vc3_c1;
  double q1Q_Vc1_c2_Vc3_c4;
  double q1Q_Vc1_c2_Vb2_e1;
  double q1Q_Vc1_c2_Vb2_c2;
  double q1Q_Vc1_c2_Vb2_c1;
  double q1Q_Vc1_c2_Vc1_c2;
  double q1Q_Vb2_c1_Vdt_GND;
  double q1Q_Vb2_c1_Vb_c;
  double q1Q_Vb2_c1_Vb_b1;
  double q1Q_Vb2_c1_Vb1_b2;
  double q1Q_Vb2_c1_Vc4_c1;
  double q1Q_Vb2_c1_Vc3_c1;
  double q1Q_Vb2_c1_Vc3_c4;
  double q1Q_Vb2_c1_Vb2_e1;
  double q1Q_Vb2_c1_Vb2_c2;
  double q1Q_Vb2_c1_Vb2_c1;
  double q1Q_Vb2_c1_Vc1_c2;
  double q1Q_Vb2_c2_Vdt_GND;
  double q1Q_Vb2_c2_Vb_c;
  double q1Q_Vb2_c2_Vb_b1;
  double q1Q_Vb2_c2_Vb1_b2;
  double q1Q_Vb2_c2_Vc4_c1;
  double q1Q_Vb2_c2_Vc3_c1;
  double q1Q_Vb2_c2_Vc3_c4;
  double q1Q_Vb2_c2_Vb2_e1;
  double q1Q_Vb2_c2_Vb2_c2;
  double q1Q_Vb2_c2_Vb2_c1;
  double q1Q_Vb2_c2_Vc1_c2;
  double q1Q_Vb2_e1_Vdt_GND;
  double q1Q_Vb2_e1_Vb_c;
  double q1Q_Vb2_e1_Vb_b1;
  double q1Q_Vb2_e1_Vb1_b2;
  double q1Q_Vb2_e1_Vc4_c1;
  double q1Q_Vb2_e1_Vc3_c1;
  double q1Q_Vb2_e1_Vc3_c4;
  double q1Q_Vb2_e1_Vb2_e1;
  double q1Q_Vb2_e1_Vb2_c2;
  double q1Q_Vb2_e1_Vb2_c1;
  double q1Q_Vb2_e1_Vc1_c2;
  double q1Q_Vc3_c1_Vdt_GND;
  double q1Q_Vc3_c1_Vb_c;
  double q1Q_Vc3_c1_Vb_b1;
  double q1Q_Vc3_c1_Vb1_b2;
  double q1Q_Vc3_c1_Vc4_c1;
  double q1Q_Vc3_c1_Vc3_c1;
  double q1Q_Vc3_c1_Vc3_c4;
  double q1Q_Vc3_c1_Vb2_e1;
  double q1Q_Vc3_c1_Vb2_c2;
  double q1Q_Vc3_c1_Vb2_c1;
  double q1Q_Vc3_c1_Vc1_c2;
  double q1Q_Vc4_c1_Vdt_GND;
  double q1Q_Vc4_c1_Vb_c;
  double q1Q_Vc4_c1_Vb_b1;
  double q1Q_Vc4_c1_Vb1_b2;
  double q1Q_Vc4_c1_Vc4_c1;
  double q1Q_Vc4_c1_Vc3_c1;
  double q1Q_Vc4_c1_Vc3_c4;
  double q1Q_Vc4_c1_Vb2_e1;
  double q1Q_Vc4_c1_Vb2_c2;
  double q1Q_Vc4_c1_Vb2_c1;
  double q1Q_Vc4_c1_Vc1_c2;
  double q1Q_Vb1_b2_Vdt_GND;
  double q1Q_Vb1_b2_Vb_c;
  double q1Q_Vb1_b2_Vb_b1;
  double q1Q_Vb1_b2_Vb1_b2;
  double q1Q_Vb1_b2_Vc4_c1;
  double q1Q_Vb1_b2_Vc3_c1;
  double q1Q_Vb1_b2_Vc3_c4;
  double q1Q_Vb1_b2_Vb2_e1;
  double q1Q_Vb1_b2_Vb2_c2;
  double q1Q_Vb1_b2_Vb2_c1;
  double q1Q_Vb1_b2_Vc1_c2;
#endif
#endif
double q0Q;
#if defined(_DERIVATEFORDDX)
double q0Q_Vdt_GND;
double q0Q_Vb2_e1;
double q0Q_Vb2_c2;
double q0Q_Vb2_c1;
double q0Q_Vc1_c2;
#if defined(_DERIVATE2)
  double q0Q_Vc1_c2_Vdt_GND;
  double q0Q_Vc1_c2_Vb2_e1;
  double q0Q_Vc1_c2_Vb2_c2;
  double q0Q_Vc1_c2_Vb2_c1;
  double q0Q_Vc1_c2_Vc1_c2;
  double q0Q_Vb2_c1_Vdt_GND;
  double q0Q_Vb2_c1_Vb2_e1;
  double q0Q_Vb2_c1_Vb2_c2;
  double q0Q_Vb2_c1_Vb2_c1;
  double q0Q_Vb2_c1_Vc1_c2;
  double q0Q_Vb2_c2_Vdt_GND;
  double q0Q_Vb2_c2_Vb2_e1;
  double q0Q_Vb2_c2_Vb2_c2;
  double q0Q_Vb2_c2_Vb2_c1;
  double q0Q_Vb2_c2_Vc1_c2;
  double q0Q_Vb2_e1_Vdt_GND;
  double q0Q_Vb2_e1_Vb2_e1;
  double q0Q_Vb2_e1_Vb2_c2;
  double q0Q_Vb2_e1_Vb2_c1;
  double q0Q_Vb2_e1_Vc1_c2;
#endif
#endif
double Fex;
#if defined(_DERIVATEFORDDX)
double Fex_Vdt_GND;
double Fex_Vb_c;
double Fex_Vb_b1;
double Fex_Vb1_b2;
double Fex_Vc4_c1;
double Fex_Vc3_c1;
double Fex_Vc3_c4;
double Fex_Vb2_e1;
double Fex_Vb2_c2;
double Fex_Vb2_c1;
double Fex_Vc1_c2;
double Fex_Vs_c1;
#if defined(_DERIVATE2)
  double Fex_Vb_b1_Vdt_GND;
  double Fex_Vb_b1_Vb_c;
  double Fex_Vb_b1_Vb_b1;
  double Fex_Vb_b1_Vb1_b2;
  double Fex_Vb_b1_Vc4_c1;
  double Fex_Vb_b1_Vc3_c1;
  double Fex_Vb_b1_Vc3_c4;
  double Fex_Vb_b1_Vb2_e1;
  double Fex_Vb_b1_Vb2_c2;
  double Fex_Vb_b1_Vb2_c1;
  double Fex_Vb_b1_Vc1_c2;
  double Fex_Vb_b1_Vs_c1;
  double Fex_Vb_c_Vdt_GND;
  double Fex_Vb_c_Vb_c;
  double Fex_Vb_c_Vb_b1;
  double Fex_Vb_c_Vb1_b2;
  double Fex_Vb_c_Vc4_c1;
  double Fex_Vb_c_Vc3_c1;
  double Fex_Vb_c_Vc3_c4;
  double Fex_Vb_c_Vb2_e1;
  double Fex_Vb_c_Vb2_c2;
  double Fex_Vb_c_Vb2_c1;
  double Fex_Vb_c_Vc1_c2;
  double Fex_Vb_c_Vs_c1;
#endif
#endif
double VBex;
#if defined(_DERIVATEFORDDX)
double VBex_Vdt_GND;
double VBex_Vb_c;
double VBex_Vb_b1;
double VBex_Vb1_b2;
double VBex_Vc4_c1;
double VBex_Vc3_c1;
double VBex_Vc3_c4;
double VBex_Vb2_e1;
double VBex_Vb2_c2;
double VBex_Vb2_c1;
double VBex_Vc1_c2;
#if defined(_DERIVATE2)
  double VBex_Vb_b1_Vdt_GND;
  double VBex_Vb_b1_Vb_c;
  double VBex_Vb_b1_Vb_b1;
  double VBex_Vb_b1_Vb1_b2;
  double VBex_Vb_b1_Vc4_c1;
  double VBex_Vb_b1_Vc3_c1;
  double VBex_Vb_b1_Vc3_c4;
  double VBex_Vb_b1_Vb2_e1;
  double VBex_Vb_b1_Vb2_c2;
  double VBex_Vb_b1_Vb2_c1;
  double VBex_Vb_b1_Vc1_c2;
  double VBex_Vb_c_Vdt_GND;
  double VBex_Vb_c_Vb_c;
  double VBex_Vb_c_Vb_b1;
  double VBex_Vb_c_Vb1_b2;
  double VBex_Vb_c_Vc4_c1;
  double VBex_Vb_c_Vc3_c1;
  double VBex_Vb_c_Vc3_c4;
  double VBex_Vb_c_Vb2_e1;
  double VBex_Vb_c_Vb2_c2;
  double VBex_Vb_c_Vb2_c1;
  double VBex_Vb_c_Vc1_c2;
#endif
#endif
double vdif;
#if defined(_DERIVATEFORDDX)
double vdif_Vb_c;
double vdif_Vb_b1;
double vdif_Vb1_b2;
double vdif_Vb2_c2;
double vdif_Vc1_c2;
double vdif_Vc4_c1;
double vdif_Vc3_c1;
double vdif_Vc3_c4;
double vdif_Vdt_GND;
#if defined(_DERIVATE2)
  double vdif_Vc3_c1_Vb_c;
  double vdif_Vc3_c1_Vb_b1;
  double vdif_Vc3_c1_Vb1_b2;
  double vdif_Vc3_c1_Vb2_c2;
  double vdif_Vc3_c1_Vc1_c2;
  double vdif_Vc3_c1_Vc4_c1;
  double vdif_Vc3_c1_Vc3_c1;
  double vdif_Vc3_c1_Vc3_c4;
  double vdif_Vc3_c1_Vdt_GND;
  double vdif_Vc4_c1_Vb_c;
  double vdif_Vc4_c1_Vb_b1;
  double vdif_Vc4_c1_Vb1_b2;
  double vdif_Vc4_c1_Vb2_c2;
  double vdif_Vc4_c1_Vc1_c2;
  double vdif_Vc4_c1_Vc4_c1;
  double vdif_Vc4_c1_Vc3_c1;
  double vdif_Vc4_c1_Vc3_c4;
  double vdif_Vc4_c1_Vdt_GND;
  double vdif_Vc1_c2_Vb_c;
  double vdif_Vc1_c2_Vb_b1;
  double vdif_Vc1_c2_Vb1_b2;
  double vdif_Vc1_c2_Vb2_c2;
  double vdif_Vc1_c2_Vc1_c2;
  double vdif_Vc1_c2_Vc4_c1;
  double vdif_Vc1_c2_Vc3_c1;
  double vdif_Vc1_c2_Vc3_c4;
  double vdif_Vc1_c2_Vdt_GND;
  double vdif_Vb2_c2_Vb_c;
  double vdif_Vb2_c2_Vb_b1;
  double vdif_Vb2_c2_Vb1_b2;
  double vdif_Vb2_c2_Vb2_c2;
  double vdif_Vb2_c2_Vc1_c2;
  double vdif_Vb2_c2_Vc4_c1;
  double vdif_Vb2_c2_Vc3_c1;
  double vdif_Vb2_c2_Vc3_c4;
  double vdif_Vb2_c2_Vdt_GND;
  double vdif_Vb1_b2_Vb_c;
  double vdif_Vb1_b2_Vb_b1;
  double vdif_Vb1_b2_Vb1_b2;
  double vdif_Vb1_b2_Vb2_c2;
  double vdif_Vb1_b2_Vc1_c2;
  double vdif_Vb1_b2_Vc4_c1;
  double vdif_Vb1_b2_Vc3_c1;
  double vdif_Vb1_b2_Vc3_c4;
  double vdif_Vb1_b2_Vdt_GND;
  double vdif_Vb_b1_Vb_c;
  double vdif_Vb_b1_Vb_b1;
  double vdif_Vb_b1_Vb1_b2;
  double vdif_Vb_b1_Vb2_c2;
  double vdif_Vb_b1_Vc1_c2;
  double vdif_Vb_b1_Vc4_c1;
  double vdif_Vb_b1_Vc3_c1;
  double vdif_Vb_b1_Vc3_c4;
  double vdif_Vb_b1_Vdt_GND;
  double vdif_Vb_c_Vb_c;
  double vdif_Vb_c_Vb_b1;
  double vdif_Vb_c_Vb1_b2;
  double vdif_Vb_c_Vb2_c2;
  double vdif_Vb_c_Vc1_c2;
  double vdif_Vb_c_Vc4_c1;
  double vdif_Vb_c_Vc3_c1;
  double vdif_Vb_c_Vc3_c4;
  double vdif_Vb_c_Vdt_GND;
#endif
#endif
double Vex;
#if defined(_DERIVATE)
double Vex_Vdt_GND;
#endif
double Vex_bias;
#if defined(_DERIVATE)
double Vex_bias_Vdt_GND;
#endif
double XIMsub;
#if defined(_DERIVATEFORDDX)
double XIMsub_Vdt_GND;
double XIMsub_Vb_c;
double XIMsub_Vb_b1;
double XIMsub_Vb1_b2;
double XIMsub_Vb2_c2;
double XIMsub_Vc1_c2;
double XIMsub_Vc4_c1;
double XIMsub_Vc3_c1;
double XIMsub_Vc3_c4;
double XIMsub_Vs_c1;
#if defined(_DERIVATE2)
  double XIMsub_Vb_b1_Vdt_GND;
  double XIMsub_Vb_b1_Vb_c;
  double XIMsub_Vb_b1_Vb_b1;
  double XIMsub_Vb_b1_Vb1_b2;
  double XIMsub_Vb_b1_Vb2_c2;
  double XIMsub_Vb_b1_Vc1_c2;
  double XIMsub_Vb_b1_Vc4_c1;
  double XIMsub_Vb_b1_Vc3_c1;
  double XIMsub_Vb_b1_Vc3_c4;
  double XIMsub_Vb_b1_Vs_c1;
  double XIMsub_Vb_c_Vdt_GND;
  double XIMsub_Vb_c_Vb_c;
  double XIMsub_Vb_c_Vb_b1;
  double XIMsub_Vb_c_Vb1_b2;
  double XIMsub_Vb_c_Vb2_c2;
  double XIMsub_Vb_c_Vc1_c2;
  double XIMsub_Vb_c_Vc4_c1;
  double XIMsub_Vb_c_Vc3_c1;
  double XIMsub_Vb_c_Vc3_c4;
  double XIMsub_Vb_c_Vs_c1;
#endif
#endif
double XIMex;
#if defined(_DERIVATEFORDDX)
double XIMex_Vdt_GND;
double XIMex_Vb_c;
double XIMex_Vb_b1;
double XIMex_Vb1_b2;
double XIMex_Vb2_c2;
double XIMex_Vc1_c2;
double XIMex_Vc4_c1;
double XIMex_Vc3_c1;
double XIMex_Vc3_c4;
#if defined(_DERIVATE2)
  double XIMex_Vb_b1_Vdt_GND;
  double XIMex_Vb_b1_Vb_c;
  double XIMex_Vb_b1_Vb_b1;
  double XIMex_Vb_b1_Vb1_b2;
  double XIMex_Vb_b1_Vb2_c2;
  double XIMex_Vb_b1_Vc1_c2;
  double XIMex_Vb_b1_Vc4_c1;
  double XIMex_Vb_b1_Vc3_c1;
  double XIMex_Vb_b1_Vc3_c4;
  double XIMex_Vb_c_Vdt_GND;
  double XIMex_Vb_c_Vb_c;
  double XIMex_Vb_c_Vb_b1;
  double XIMex_Vb_c_Vb1_b2;
  double XIMex_Vb_c_Vb2_c2;
  double XIMex_Vb_c_Vc1_c2;
  double XIMex_Vb_c_Vc4_c1;
  double XIMex_Vb_c_Vc3_c1;
  double XIMex_Vb_c_Vc3_c4;
#endif
#endif
double XnBex;
#if defined(_DERIVATEFORDDX)
double XnBex_Vdt_GND;
double XnBex_Vb_c;
double XnBex_Vb_b1;
double XnBex_Vb1_b2;
double XnBex_Vb2_c2;
double XnBex_Vc1_c2;
double XnBex_Vc4_c1;
double XnBex_Vc3_c1;
double XnBex_Vc3_c4;
#if defined(_DERIVATE2)
  double XnBex_Vb_b1_Vdt_GND;
  double XnBex_Vb_b1_Vb_c;
  double XnBex_Vb_b1_Vb_b1;
  double XnBex_Vb_b1_Vb1_b2;
  double XnBex_Vb_b1_Vb2_c2;
  double XnBex_Vb_b1_Vc1_c2;
  double XnBex_Vb_b1_Vc4_c1;
  double XnBex_Vb_b1_Vc3_c1;
  double XnBex_Vb_b1_Vc3_c4;
  double XnBex_Vb_c_Vdt_GND;
  double XnBex_Vb_c_Vb_c;
  double XnBex_Vb_c_Vb_b1;
  double XnBex_Vb_c_Vb1_b2;
  double XnBex_Vb_c_Vb2_c2;
  double XnBex_Vb_c_Vc1_c2;
  double XnBex_Vb_c_Vc4_c1;
  double XnBex_Vb_c_Vc3_c1;
  double XnBex_Vb_c_Vc3_c4;
#endif
#endif
double Xg1;
#if defined(_DERIVATEFORDDX)
double Xg1_Vdt_GND;
double Xg1_Vb_c;
double Xg1_Vb_b1;
double Xg1_Vb1_b2;
double Xg1_Vb2_c2;
double Xg1_Vc1_c2;
double Xg1_Vc4_c1;
double Xg1_Vc3_c1;
double Xg1_Vc3_c4;
#if defined(_DERIVATE2)
  double Xg1_Vb_b1_Vdt_GND;
  double Xg1_Vb_b1_Vb_c;
  double Xg1_Vb_b1_Vb_b1;
  double Xg1_Vb_b1_Vb1_b2;
  double Xg1_Vb_b1_Vb2_c2;
  double Xg1_Vb_b1_Vc1_c2;
  double Xg1_Vb_b1_Vc4_c1;
  double Xg1_Vb_b1_Vc3_c1;
  double Xg1_Vb_b1_Vc3_c4;
  double Xg1_Vb_c_Vdt_GND;
  double Xg1_Vb_c_Vb_c;
  double Xg1_Vb_c_Vb_b1;
  double Xg1_Vb_c_Vb1_b2;
  double Xg1_Vb_c_Vb2_c2;
  double Xg1_Vb_c_Vc1_c2;
  double Xg1_Vb_c_Vc4_c1;
  double Xg1_Vb_c_Vc3_c1;
  double Xg1_Vb_c_Vc3_c4;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double XIsub_Vdt_GND;
double XIsub_Vb_c;
double XIsub_Vb_b1;
double XIsub_Vb1_b2;
double XIsub_Vc4_c1;
double XIsub_Vc3_c1;
double XIsub_Vc3_c4;
double XIsub_Vb2_e1;
double XIsub_Vb2_c2;
double XIsub_Vb2_c1;
double XIsub_Vc1_c2;
double XIsub_Vs_c1;
#if defined(_DERIVATE2)
  double XIsub_Vb_b1_Vdt_GND;
  double XIsub_Vb_b1_Vb_c;
  double XIsub_Vb_b1_Vb_b1;
  double XIsub_Vb_b1_Vb1_b2;
  double XIsub_Vb_b1_Vc4_c1;
  double XIsub_Vb_b1_Vc3_c1;
  double XIsub_Vb_b1_Vc3_c4;
  double XIsub_Vb_b1_Vb2_e1;
  double XIsub_Vb_b1_Vb2_c2;
  double XIsub_Vb_b1_Vb2_c1;
  double XIsub_Vb_b1_Vc1_c2;
  double XIsub_Vb_b1_Vs_c1;
  double XIsub_Vb_c_Vdt_GND;
  double XIsub_Vb_c_Vb_c;
  double XIsub_Vb_c_Vb_b1;
  double XIsub_Vb_c_Vb1_b2;
  double XIsub_Vb_c_Vc4_c1;
  double XIsub_Vb_c_Vc3_c1;
  double XIsub_Vb_c_Vc3_c4;
  double XIsub_Vb_c_Vb2_e1;
  double XIsub_Vb_c_Vb2_c2;
  double XIsub_Vb_c_Vb2_c1;
  double XIsub_Vb_c_Vc1_c2;
  double XIsub_Vb_c_Vs_c1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double XIex_Vdt_GND;
double XIex_Vb_c;
double XIex_Vb_b1;
double XIex_Vb1_b2;
double XIex_Vc4_c1;
double XIex_Vc3_c1;
double XIex_Vc3_c4;
double XIex_Vb2_e1;
double XIex_Vb2_c2;
double XIex_Vb2_c1;
double XIex_Vc1_c2;
double XIex_Vs_c1;
#if defined(_DERIVATE2)
  double XIex_Vb_b1_Vdt_GND;
  double XIex_Vb_b1_Vb_c;
  double XIex_Vb_b1_Vb_b1;
  double XIex_Vb_b1_Vb1_b2;
  double XIex_Vb_b1_Vc4_c1;
  double XIex_Vb_b1_Vc3_c1;
  double XIex_Vb_b1_Vc3_c4;
  double XIex_Vb_b1_Vb2_e1;
  double XIex_Vb_b1_Vb2_c2;
  double XIex_Vb_b1_Vb2_c1;
  double XIex_Vb_b1_Vc1_c2;
  double XIex_Vb_b1_Vs_c1;
  double XIex_Vb_c_Vdt_GND;
  double XIex_Vb_c_Vb_c;
  double XIex_Vb_c_Vb_b1;
  double XIex_Vb_c_Vb1_b2;
  double XIex_Vb_c_Vc4_c1;
  double XIex_Vb_c_Vc3_c1;
  double XIex_Vb_c_Vc3_c4;
  double XIex_Vb_c_Vb2_e1;
  double XIex_Vb_c_Vb2_c2;
  double XIex_Vb_c_Vb2_c1;
  double XIex_Vb_c_Vc1_c2;
  double XIex_Vb_c_Vs_c1;
#endif
#endif
double Isf;
#if defined(_DERIVATEFORDDX)
double Isf_Vdt_GND;
double Isf_Vs_c1;
#if defined(_DERIVATE2)
  double Isf_Vs_c1_Vdt_GND;
  double Isf_Vs_c1_Vs_c1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Isub_Vdt_GND;
double Isub_Vb1_b2;
double Isub_Vb2_c2;
double Isub_Vc1_c2;
double Isub_Vc4_c1;
double Isub_Vs_c1;
#if defined(_DERIVATE2)
  double Isub_Vb1_b2_Vdt_GND;
  double Isub_Vb1_b2_Vb1_b2;
  double Isub_Vb1_b2_Vb2_c2;
  double Isub_Vb1_b2_Vc1_c2;
  double Isub_Vb1_b2_Vc4_c1;
  double Isub_Vb1_b2_Vs_c1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Iex_Vdt_GND;
double Iex_Vb1_b2;
double Iex_Vb2_c2;
double Iex_Vc1_c2;
double Iex_Vc4_c1;
#if defined(_DERIVATE2)
  double Iex_Vc1_c2_Vdt_GND;
  double Iex_Vc1_c2_Vb1_b2;
  double Iex_Vc1_c2_Vb2_c2;
  double Iex_Vc1_c2_Vc1_c2;
  double Iex_Vc1_c2_Vc4_c1;
  double Iex_Vb2_c2_Vdt_GND;
  double Iex_Vb2_c2_Vb1_b2;
  double Iex_Vb2_c2_Vb2_c2;
  double Iex_Vb2_c2_Vc1_c2;
  double Iex_Vb2_c2_Vc4_c1;
  double Iex_Vb1_b2_Vdt_GND;
  double Iex_Vb1_b2_Vb1_b2;
  double Iex_Vb1_b2_Vb2_c2;
  double Iex_Vb1_b2_Vc1_c2;
  double Iex_Vb1_b2_Vc4_c1;
#endif
#endif
#if defined(_DYNAMIC)
double pWex;
#if defined(_DERIVATEFORDDX)
double pWex_Vb1_b2;
double pWex_Vb2_c2;
double pWex_Vc1_c2;
double pWex_Vc4_c1;
double pWex_Vdt_GND;
#if defined(_DERIVATE2)
  double pWex_Vc1_c2_Vb1_b2;
  double pWex_Vc1_c2_Vb2_c2;
  double pWex_Vc1_c2_Vc1_c2;
  double pWex_Vc1_c2_Vc4_c1;
  double pWex_Vc1_c2_Vdt_GND;
  double pWex_Vb2_c2_Vb1_b2;
  double pWex_Vb2_c2_Vb2_c2;
  double pWex_Vb2_c2_Vc1_c2;
  double pWex_Vb2_c2_Vc4_c1;
  double pWex_Vb2_c2_Vdt_GND;
  double pWex_Vb1_b2_Vb1_b2;
  double pWex_Vb1_b2_Vb2_c2;
  double pWex_Vb1_b2_Vc1_c2;
  double pWex_Vb1_b2_Vc4_c1;
  double pWex_Vb1_b2_Vdt_GND;
#endif
#endif
#endif
double nBex;
#if defined(_DERIVATEFORDDX)
double nBex_Vdt_GND;
double nBex_Vb1_b2;
double nBex_Vb2_c2;
double nBex_Vc1_c2;
double nBex_Vc4_c1;
#if defined(_DERIVATE2)
  double nBex_Vc1_c2_Vdt_GND;
  double nBex_Vc1_c2_Vb1_b2;
  double nBex_Vc1_c2_Vb2_c2;
  double nBex_Vc1_c2_Vc1_c2;
  double nBex_Vc1_c2_Vc4_c1;
  double nBex_Vb2_c2_Vdt_GND;
  double nBex_Vb2_c2_Vb1_b2;
  double nBex_Vb2_c2_Vb2_c2;
  double nBex_Vb2_c2_Vc1_c2;
  double nBex_Vb2_c2_Vc4_c1;
  double nBex_Vb1_b2_Vdt_GND;
  double nBex_Vb1_b2_Vb1_b2;
  double nBex_Vb1_b2_Vb2_c2;
  double nBex_Vb1_b2_Vc1_c2;
  double nBex_Vb1_b2_Vc4_c1;
#endif
#endif
#if defined(_DYNAMIC)
double g2;
#if defined(_DERIVATEFORDDX)
double g2_Vb1_b2;
double g2_Vb2_c2;
double g2_Vc1_c2;
double g2_Vc4_c1;
double g2_Vdt_GND;
#if defined(_DERIVATE2)
  double g2_Vc1_c2_Vb1_b2;
  double g2_Vc1_c2_Vb2_c2;
  double g2_Vc1_c2_Vc1_c2;
  double g2_Vc1_c2_Vc4_c1;
  double g2_Vc1_c2_Vdt_GND;
  double g2_Vb2_c2_Vb1_b2;
  double g2_Vb2_c2_Vb2_c2;
  double g2_Vb2_c2_Vc1_c2;
  double g2_Vb2_c2_Vc4_c1;
  double g2_Vb2_c2_Vdt_GND;
  double g2_Vb1_b2_Vb1_b2;
  double g2_Vb1_b2_Vb2_c2;
  double g2_Vb1_b2_Vc1_c2;
  double g2_Vb1_b2_Vc4_c1;
  double g2_Vb1_b2_Vdt_GND;
#endif
#endif
#endif
double g1;
#if defined(_DERIVATEFORDDX)
double g1_Vdt_GND;
double g1_Vb1_b2;
double g1_Vb2_c2;
double g1_Vc1_c2;
double g1_Vc4_c1;
#if defined(_DERIVATE2)
  double g1_Vc1_c2_Vdt_GND;
  double g1_Vc1_c2_Vb1_b2;
  double g1_Vc1_c2_Vb2_c2;
  double g1_Vc1_c2_Vc1_c2;
  double g1_Vc1_c2_Vc4_c1;
  double g1_Vb2_c2_Vdt_GND;
  double g1_Vb2_c2_Vb1_b2;
  double g1_Vb2_c2_Vb2_c2;
  double g1_Vb2_c2_Vc1_c2;
  double g1_Vb2_c2_Vc4_c1;
  double g1_Vb1_b2_Vdt_GND;
  double g1_Vb1_b2_Vb1_b2;
  double g1_Vb1_b2_Vb2_c2;
  double g1_Vb1_b2_Vc1_c2;
  double g1_Vb1_b2_Vc4_c1;
#endif
#endif
#if defined(_DERIVATE)
double Izteb_Vdt_GND;
double Izteb_Vb2_e1;
double Izteb_Vb2_c2;
double Izteb_Vb2_c1;
double Izteb_Vc1_c2;
#endif
double DZEB;
#if defined(_DERIVATE)
double DZEB_Vb2_e1;
double DZEB_Vdt_GND;
#endif
double edZEB;
#if defined(_DERIVATE)
double edZEB_Vb2_e1;
double edZEB_Vdt_GND;
#endif
double dE0BE;
#if defined(_DERIVATE)
double dE0BE_Vb2_e1;
double dE0BE_Vdt_GND;
#endif
double eZEB;
#if defined(_DERIVATE)
double eZEB_Vdt_GND;
double eZEB_Vb2_e1;
double eZEB_Vb2_c2;
double eZEB_Vb2_c1;
double eZEB_Vc1_c2;
#endif
#if defined(_DERIVATEFORDDX)
double Ib3_Vdt_GND;
double Ib3_Vb1_b2;
double Ib3_Vb2_c2;
double Ib3_Vc1_c2;
double Ib3_Vc4_c1;
double Ib3_Vb2_e1;
#if defined(_DERIVATE2)
  double Ib3_Vb2_e1_Vdt_GND;
  double Ib3_Vb2_e1_Vb1_b2;
  double Ib3_Vb2_e1_Vb2_c2;
  double Ib3_Vb2_e1_Vc1_c2;
  double Ib3_Vb2_e1_Vc4_c1;
  double Ib3_Vb2_e1_Vb2_e1;
  double Ib3_Vc1_c2_Vdt_GND;
  double Ib3_Vc1_c2_Vb1_b2;
  double Ib3_Vc1_c2_Vb2_c2;
  double Ib3_Vc1_c2_Vc1_c2;
  double Ib3_Vc1_c2_Vc4_c1;
  double Ib3_Vc1_c2_Vb2_e1;
  double Ib3_Vb2_c2_Vdt_GND;
  double Ib3_Vb2_c2_Vb1_b2;
  double Ib3_Vb2_c2_Vb2_c2;
  double Ib3_Vb2_c2_Vc1_c2;
  double Ib3_Vb2_c2_Vc4_c1;
  double Ib3_Vb2_c2_Vb2_e1;
  double Ib3_Vb1_b2_Vdt_GND;
  double Ib3_Vb1_b2_Vb1_b2;
  double Ib3_Vb1_b2_Vb2_c2;
  double Ib3_Vb1_b2_Vc1_c2;
  double Ib3_Vb1_b2_Vc4_c1;
  double Ib3_Vb1_b2_Vb2_e1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ib2_Vdt_GND;
double Ib2_Vb2_e1;
#if defined(_DERIVATE2)
  double Ib2_Vb2_e1_Vdt_GND;
  double Ib2_Vb2_e1_Vb2_e1;
#endif
#endif
double tmpExp;
#if defined(_DERIVATEFORDDX)
double tmpExp_Vb1_b2;
double tmpExp_Vb2_c2;
double tmpExp_Vc1_c2;
double tmpExp_Vc4_c1;
double tmpExp_Vb2_e1;
double tmpExp_Vdt_GND;
#if defined(_DERIVATE2)
  double tmpExp_Vb2_e1_Vb1_b2;
  double tmpExp_Vb2_e1_Vb2_c2;
  double tmpExp_Vb2_e1_Vc1_c2;
  double tmpExp_Vb2_e1_Vc4_c1;
  double tmpExp_Vb2_e1_Vb2_e1;
  double tmpExp_Vb2_e1_Vdt_GND;
  double tmpExp_Vc4_c1_Vb1_b2;
  double tmpExp_Vc4_c1_Vb2_c2;
  double tmpExp_Vc4_c1_Vc1_c2;
  double tmpExp_Vc4_c1_Vc4_c1;
  double tmpExp_Vc4_c1_Vb2_e1;
  double tmpExp_Vc4_c1_Vdt_GND;
  double tmpExp_Vc1_c2_Vb1_b2;
  double tmpExp_Vc1_c2_Vb2_c2;
  double tmpExp_Vc1_c2_Vc1_c2;
  double tmpExp_Vc1_c2_Vc4_c1;
  double tmpExp_Vc1_c2_Vb2_e1;
  double tmpExp_Vc1_c2_Vdt_GND;
  double tmpExp_Vb2_c2_Vb1_b2;
  double tmpExp_Vb2_c2_Vb2_c2;
  double tmpExp_Vb2_c2_Vc1_c2;
  double tmpExp_Vb2_c2_Vc4_c1;
  double tmpExp_Vb2_c2_Vb2_e1;
  double tmpExp_Vb2_c2_Vdt_GND;
  double tmpExp_Vb1_b2_Vb1_b2;
  double tmpExp_Vb1_b2_Vb2_c2;
  double tmpExp_Vb1_b2_Vc1_c2;
  double tmpExp_Vb1_b2_Vc4_c1;
  double tmpExp_Vb1_b2_Vb2_e1;
  double tmpExp_Vb1_b2_Vdt_GND;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ib1_s_Vdt_GND;
double Ib1_s_Vb1_e1;
#if defined(_DERIVATE2)
  double Ib1_s_Vb1_e1_Vdt_GND;
  double Ib1_s_Vb1_e1_Vb1_e1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ib1_Vb2_c2;
double Ib1_Vb2_c1;
double Ib1_Vc1_c2;
double Ib1_Vdt_GND;
double Ib1_Vb2_e1;
#if defined(_DERIVATE2)
  double Ib1_Vb2_e1_Vb2_c2;
  double Ib1_Vb2_e1_Vb2_c1;
  double Ib1_Vb2_e1_Vc1_c2;
  double Ib1_Vb2_e1_Vdt_GND;
  double Ib1_Vb2_e1_Vb2_e1;
  double Ib1_Vc1_c2_Vb2_c2;
  double Ib1_Vc1_c2_Vb2_c1;
  double Ib1_Vc1_c2_Vc1_c2;
  double Ib1_Vc1_c2_Vdt_GND;
  double Ib1_Vc1_c2_Vb2_e1;
  double Ib1_Vb2_c1_Vb2_c2;
  double Ib1_Vb2_c1_Vb2_c1;
  double Ib1_Vb2_c1_Vc1_c2;
  double Ib1_Vb2_c1_Vdt_GND;
  double Ib1_Vb2_c1_Vb2_e1;
  double Ib1_Vb2_c2_Vb2_c2;
  double Ib1_Vb2_c2_Vb2_c1;
  double Ib1_Vb2_c2_Vc1_c2;
  double Ib1_Vb2_c2_Vdt_GND;
  double Ib1_Vb2_c2_Vb2_e1;
#endif
#endif
double Ibf0;
#if defined(_DERIVATE)
double Ibf0_Vdt_GND;
#endif
double In;
#if defined(_DERIVATEFORDDX)
double In_Vdt_GND;
double In_Vb2_e1;
double In_Vb2_c2;
double In_Vb2_c1;
double In_Vc1_c2;
#if defined(_DERIVATE2)
  double In_Vc1_c2_Vdt_GND;
  double In_Vc1_c2_Vb2_e1;
  double In_Vc1_c2_Vb2_c2;
  double In_Vc1_c2_Vb2_c1;
  double In_Vc1_c2_Vc1_c2;
  double In_Vb2_c1_Vdt_GND;
  double In_Vb2_c1_Vb2_e1;
  double In_Vb2_c1_Vb2_c2;
  double In_Vb2_c1_Vb2_c1;
  double In_Vb2_c1_Vc1_c2;
  double In_Vb2_c2_Vdt_GND;
  double In_Vb2_c2_Vb2_e1;
  double In_Vb2_c2_Vb2_c2;
  double In_Vb2_c2_Vb2_c1;
  double In_Vb2_c2_Vc1_c2;
  double In_Vb2_e1_Vdt_GND;
  double In_Vb2_e1_Vb2_e1;
  double In_Vb2_e1_Vb2_c2;
  double In_Vb2_e1_Vb2_c1;
  double In_Vb2_e1_Vc1_c2;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double If_Vdt_GND;
double If_Vb2_e1;
#if defined(_DERIVATE2)
  double If_Vb2_e1_Vdt_GND;
  double If_Vb2_e1_Vb2_e1;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double Ir_Vdt_GND;
double Ir_Vb2_c2;
double Ir_Vb2_c1;
double Ir_Vc1_c2;
#if defined(_DERIVATE2)
  double Ir_Vc1_c2_Vdt_GND;
  double Ir_Vc1_c2_Vb2_c2;
  double Ir_Vc1_c2_Vb2_c1;
  double Ir_Vc1_c2_Vc1_c2;
  double Ir_Vb2_c1_Vdt_GND;
  double Ir_Vb2_c1_Vb2_c2;
  double Ir_Vb2_c1_Vb2_c1;
  double Ir_Vb2_c1_Vc1_c2;
  double Ir_Vb2_c2_Vdt_GND;
  double Ir_Vb2_c2_Vb2_c2;
  double Ir_Vb2_c2_Vb2_c1;
  double Ir_Vb2_c2_Vc1_c2;
#endif
#endif
#if defined(_DERIVATEFORDDX)
double qBI_Vdt_GND;
double qBI_Vb2_e1;
double qBI_Vb2_c2;
double qBI_Vb2_c1;
double qBI_Vc1_c2;
#if defined(_DERIVATE2)
  double qBI_Vc1_c2_Vdt_GND;
  double qBI_Vc1_c2_Vb2_e1;
  double qBI_Vc1_c2_Vb2_c2;
  double qBI_Vc1_c2_Vb2_c1;
  double qBI_Vc1_c2_Vc1_c2;
  double qBI_Vb2_c1_Vdt_GND;
  double qBI_Vb2_c1_Vb2_e1;
  double qBI_Vb2_c1_Vb2_c2;
  double qBI_Vb2_c1_Vb2_c1;
  double qBI_Vb2_c1_Vc1_c2;
  double qBI_Vb2_c2_Vdt_GND;
  double qBI_Vb2_c2_Vb2_e1;
  double qBI_Vb2_c2_Vb2_c2;
  double qBI_Vb2_c2_Vb2_c1;
  double qBI_Vb2_c2_Vc1_c2;
  double qBI_Vb2_e1_Vdt_GND;
  double qBI_Vb2_e1_Vb2_e1;
  double qBI_Vb2_e1_Vb2_c2;
  double qBI_Vb2_e1_Vb2_c1;
  double qBI_Vb2_e1_Vc1_c2;
#endif
#endif
double q1I;
#if defined(_DERIVATEFORDDX)
double q1I_Vdt_GND;
double q1I_Vb2_e1;
double q1I_Vb2_c2;
double q1I_Vb2_c1;
double q1I_Vc1_c2;
#if defined(_DERIVATE2)
  double q1I_Vc1_c2_Vdt_GND;
  double q1I_Vc1_c2_Vb2_e1;
  double q1I_Vc1_c2_Vb2_c2;
  double q1I_Vc1_c2_Vb2_c1;
  double q1I_Vc1_c2_Vc1_c2;
  double q1I_Vb2_c1_Vdt_GND;
  double q1I_Vb2_c1_Vb2_e1;
  double q1I_Vb2_c1_Vb2_c2;
  double q1I_Vb2_c1_Vb2_c1;
  double q1I_Vb2_c1_Vc1_c2;
  double q1I_Vb2_c2_Vdt_GND;
  double q1I_Vb2_c2_Vb2_e1;
  double q1I_Vb2_c2_Vb2_c2;
  double q1I_Vb2_c2_Vb2_c1;
  double q1I_Vb2_c2_Vc1_c2;
  double q1I_Vb2_e1_Vdt_GND;
  double q1I_Vb2_e1_Vb2_e1;
  double q1I_Vb2_e1_Vb2_c2;
  double q1I_Vb2_e1_Vb2_c1;
  double q1I_Vb2_e1_Vc1_c2;
#endif
#endif
double termC;
#if defined(_DERIVATEFORDDX)
double termC_Vdt_GND;
double termC_Vb2_c2;
double termC_Vb2_c1;
double termC_Vc1_c2;
double termC_Vb2_e1;
#if defined(_DERIVATE2)
  double termC_Vb2_e1_Vdt_GND;
  double termC_Vb2_e1_Vb2_c2;
  double termC_Vb2_e1_Vb2_c1;
  double termC_Vb2_e1_Vc1_c2;
  double termC_Vb2_e1_Vb2_e1;
  double termC_Vc1_c2_Vdt_GND;
  double termC_Vc1_c2_Vb2_c2;
  double termC_Vc1_c2_Vb2_c1;
  double termC_Vc1_c2_Vc1_c2;
  double termC_Vc1_c2_Vb2_e1;
  double termC_Vb2_c1_Vdt_GND;
  double termC_Vb2_c1_Vb2_c2;
  double termC_Vb2_c1_Vb2_c1;
  double termC_Vb2_c1_Vc1_c2;
  double termC_Vb2_c1_Vb2_e1;
  double termC_Vb2_c2_Vdt_GND;
  double termC_Vb2_c2_Vb2_c2;
  double termC_Vb2_c2_Vb2_c1;
  double termC_Vb2_c2_Vc1_c2;
  double termC_Vb2_c2_Vb2_e1;
#endif
#endif
double termE;
#if defined(_DERIVATEFORDDX)
double termE_Vdt_GND;
double termE_Vb2_e1;
double termE_Vb2_c2;
double termE_Vb2_c1;
double termE_Vc1_c2;
#if defined(_DERIVATE2)
  double termE_Vc1_c2_Vdt_GND;
  double termE_Vc1_c2_Vb2_e1;
  double termE_Vc1_c2_Vb2_c2;
  double termE_Vc1_c2_Vb2_c1;
  double termE_Vc1_c2_Vc1_c2;
  double termE_Vb2_c1_Vdt_GND;
  double termE_Vb2_c1_Vb2_e1;
  double termE_Vb2_c1_Vb2_c2;
  double termE_Vb2_c1_Vb2_c1;
  double termE_Vb2_c1_Vc1_c2;
  double termE_Vb2_c2_Vdt_GND;
  double termE_Vb2_c2_Vb2_e1;
  double termE_Vb2_c2_Vb2_c2;
  double termE_Vb2_c2_Vb2_c1;
  double termE_Vb2_c2_Vc1_c2;
  double termE_Vb2_e1_Vdt_GND;
  double termE_Vb2_e1_Vb2_e1;
  double termE_Vb2_e1_Vb2_c2;
  double termE_Vb2_e1_Vb2_c1;
  double termE_Vb2_e1_Vc1_c2;
#endif
#endif
double q0I;
#if defined(_DERIVATEFORDDX)
double q0I_Vdt_GND;
double q0I_Vb2_e1;
double q0I_Vb2_c2;
double q0I_Vb2_c1;
double q0I_Vc1_c2;
#if defined(_DERIVATE2)
  double q0I_Vc1_c2_Vdt_GND;
  double q0I_Vc1_c2_Vb2_e1;
  double q0I_Vc1_c2_Vb2_c2;
  double q0I_Vc1_c2_Vb2_c1;
  double q0I_Vc1_c2_Vc1_c2;
  double q0I_Vb2_c1_Vdt_GND;
  double q0I_Vb2_c1_Vb2_e1;
  double q0I_Vb2_c1_Vb2_c2;
  double q0I_Vb2_c1_Vb2_c1;
  double q0I_Vb2_c1_Vc1_c2;
  double q0I_Vb2_c2_Vdt_GND;
  double q0I_Vb2_c2_Vb2_e1;
  double q0I_Vb2_c2_Vb2_c2;
  double q0I_Vb2_c2_Vb2_c1;
  double q0I_Vb2_c2_Vc1_c2;
  double q0I_Vb2_e1_Vdt_GND;
  double q0I_Vb2_e1_Vb2_e1;
  double q0I_Vb2_e1_Vb2_c2;
  double q0I_Vb2_e1_Vb2_c1;
  double q0I_Vb2_e1_Vc1_c2;
#endif
#endif
double nB;
#if defined(_DERIVATEFORDDX)
double nB_Vdt_GND;
double nB_Vb2_c2;
double nB_Vb2_c1;
double nB_Vc1_c2;
#if defined(_DERIVATE2)
  double nB_Vc1_c2_Vdt_GND;
  double nB_Vc1_c2_Vb2_c2;
  double nB_Vc1_c2_Vb2_c1;
  double nB_Vc1_c2_Vc1_c2;
  double nB_Vb2_c1_Vdt_GND;
  double nB_Vb2_c1_Vb2_c2;
  double nB_Vb2_c1_Vb2_c1;
  double nB_Vb2_c1_Vc1_c2;
  double nB_Vb2_c2_Vdt_GND;
  double nB_Vb2_c2_Vb2_c2;
  double nB_Vb2_c2_Vb2_c1;
  double nB_Vb2_c2_Vc1_c2;
#endif
#endif
double f2;
#if defined(_DERIVATEFORDDX)
double f2_Vdt_GND;
double f2_Vb2_c2;
double f2_Vb2_c1;
double f2_Vc1_c2;
#if defined(_DERIVATE2)
  double f2_Vc1_c2_Vdt_GND;
  double f2_Vc1_c2_Vb2_c2;
  double f2_Vc1_c2_Vb2_c1;
  double f2_Vc1_c2_Vc1_c2;
  double f2_Vb2_c1_Vdt_GND;
  double f2_Vb2_c1_Vb2_c2;
  double f2_Vb2_c1_Vb2_c1;
  double f2_Vb2_c1_Vc1_c2;
  double f2_Vb2_c2_Vdt_GND;
  double f2_Vb2_c2_Vb2_c2;
  double f2_Vb2_c2_Vb2_c1;
  double f2_Vb2_c2_Vc1_c2;
#endif
#endif
double n0;
#if defined(_DERIVATEFORDDX)
double n0_Vdt_GND;
double n0_Vb2_e1;
#if defined(_DERIVATE2)
  double n0_Vb2_e1_Vdt_GND;
  double n0_Vb2_e1_Vb2_e1;
#endif
#endif
double f1;
#if defined(_DERIVATEFORDDX)
double f1_Vdt_GND;
double f1_Vb2_e1;
#if defined(_DERIVATE2)
  double f1_Vb2_e1_Vdt_GND;
  double f1_Vb2_e1_Vb2_e1;
#endif
#endif
double If0;
#if defined(_DERIVATE)
double If0_Vdt_GND;
#endif
double Vtc;
#if defined(_DERIVATEFORDDX)
double Vtc_Vdt_GND;
double Vtc_Vb2_c2;
double Vtc_Vb2_c1;
double Vtc_Vc1_c2;
double Vtc_Vb2_e1;
#if defined(_DERIVATE2)
  double Vtc_Vb2_e1_Vdt_GND;
  double Vtc_Vb2_e1_Vb2_c2;
  double Vtc_Vb2_e1_Vb2_c1;
  double Vtc_Vb2_e1_Vc1_c2;
  double Vtc_Vb2_e1_Vb2_e1;
  double Vtc_Vc1_c2_Vdt_GND;
  double Vtc_Vc1_c2_Vb2_c2;
  double Vtc_Vc1_c2_Vb2_c1;
  double Vtc_Vc1_c2_Vc1_c2;
  double Vtc_Vc1_c2_Vb2_e1;
  double Vtc_Vb2_c1_Vdt_GND;
  double Vtc_Vb2_c1_Vb2_c2;
  double Vtc_Vb2_c1_Vb2_c1;
  double Vtc_Vb2_c1_Vc1_c2;
  double Vtc_Vb2_c1_Vb2_e1;
  double Vtc_Vb2_c2_Vdt_GND;
  double Vtc_Vb2_c2_Vb2_c2;
  double Vtc_Vb2_c2_Vb2_c1;
  double Vtc_Vb2_c2_Vc1_c2;
  double Vtc_Vb2_c2_Vb2_e1;
#endif
#endif
double Vcv;
#if defined(_DERIVATEFORDDX)
double Vcv_Vdt_GND;
double Vcv_Vb2_c2;
double Vcv_Vb2_c1;
double Vcv_Vc1_c2;
double Vcv_Vb2_e1;
#if defined(_DERIVATE2)
  double Vcv_Vb2_e1_Vdt_GND;
  double Vcv_Vb2_e1_Vb2_c2;
  double Vcv_Vb2_e1_Vb2_c1;
  double Vcv_Vb2_e1_Vc1_c2;
  double Vcv_Vb2_e1_Vb2_e1;
  double Vcv_Vc1_c2_Vdt_GND;
  double Vcv_Vc1_c2_Vb2_c2;
  double Vcv_Vc1_c2_Vb2_c1;
  double Vcv_Vc1_c2_Vc1_c2;
  double Vcv_Vc1_c2_Vb2_e1;
  double Vcv_Vb2_c1_Vdt_GND;
  double Vcv_Vb2_c1_Vb2_c2;
  double Vcv_Vb2_c1_Vb2_c1;
  double Vcv_Vb2_c1_Vc1_c2;
  double Vcv_Vb2_c1_Vb2_e1;
  double Vcv_Vb2_c2_Vdt_GND;
  double Vcv_Vb2_c2_Vb2_c2;
  double Vcv_Vb2_c2_Vb2_c1;
  double Vcv_Vb2_c2_Vc1_c2;
  double Vcv_Vb2_c2_Vb2_e1;
#endif
#endif
double fI;
#if defined(_DERIVATEFORDDX)
double fI_Vdt_GND;
double fI_Vb2_c2;
double fI_Vb2_c1;
double fI_Vc1_c2;
#if defined(_DERIVATE2)
  double fI_Vc1_c2_Vdt_GND;
  double fI_Vc1_c2_Vb2_c2;
  double fI_Vc1_c2_Vb2_c1;
  double fI_Vc1_c2_Vc1_c2;
  double fI_Vb2_c1_Vdt_GND;
  double fI_Vb2_c1_Vb2_c2;
  double fI_Vb2_c1_Vb2_c1;
  double fI_Vb2_c1_Vc1_c2;
  double fI_Vb2_c2_Vdt_GND;
  double fI_Vb2_c2_Vb2_c2;
  double fI_Vb2_c2_Vb2_c1;
  double fI_Vb2_c2_Vc1_c2;
#endif
#endif
double Vjc;
#if defined(_DERIVATEFORDDX)
double Vjc_Vb2_c1;
double Vjc_Vdt_GND;
double Vjc_Vb2_c2;
double Vjc_Vc1_c2;
double Vjc_Vb2_e1;
#if defined(_DERIVATE2)
  double Vjc_Vb2_e1_Vb2_c1;
  double Vjc_Vb2_e1_Vdt_GND;
  double Vjc_Vb2_e1_Vb2_c2;
  double Vjc_Vb2_e1_Vc1_c2;
  double Vjc_Vb2_e1_Vb2_e1;
  double Vjc_Vc1_c2_Vb2_c1;
  double Vjc_Vc1_c2_Vdt_GND;
  double Vjc_Vc1_c2_Vb2_c2;
  double Vjc_Vc1_c2_Vc1_c2;
  double Vjc_Vc1_c2_Vb2_e1;
  double Vjc_Vb2_c2_Vb2_c1;
  double Vjc_Vb2_c2_Vdt_GND;
  double Vjc_Vb2_c2_Vb2_c2;
  double Vjc_Vb2_c2_Vc1_c2;
  double Vjc_Vb2_c2_Vb2_e1;
  double Vjc_Vb2_c1_Vb2_c1;
  double Vjc_Vb2_c1_Vdt_GND;
  double Vjc_Vb2_c1_Vb2_c2;
  double Vjc_Vb2_c1_Vc1_c2;
  double Vjc_Vb2_c1_Vb2_e1;
#endif
#endif
double Vfc;
#if defined(_DERIVATE)
double Vfc_Vdt_GND;
#endif
double bjc;
#if defined(_DERIVATE)
double bjc_Vdt_GND;
#endif
double Vjunc;
#if defined(_DERIVATEFORDDX)
double Vjunc_Vb2_c1;
double Vjunc_Vdt_GND;
double Vjunc_Vb2_c2;
double Vjunc_Vc1_c2;
#if defined(_DERIVATE2)
  double Vjunc_Vc1_c2_Vb2_c1;
  double Vjunc_Vc1_c2_Vdt_GND;
  double Vjunc_Vc1_c2_Vb2_c2;
  double Vjunc_Vc1_c2_Vc1_c2;
  double Vjunc_Vb2_c2_Vb2_c1;
  double Vjunc_Vb2_c2_Vdt_GND;
  double Vjunc_Vb2_c2_Vb2_c2;
  double Vjunc_Vb2_c2_Vc1_c2;
  double Vjunc_Vb2_c1_Vb2_c1;
  double Vjunc_Vb2_c1_Vdt_GND;
  double Vjunc_Vb2_c1_Vb2_c2;
  double Vjunc_Vb2_c1_Vc1_c2;
#endif
#endif
double Vte;
#if defined(_DERIVATEFORDDX)
double Vte_Vdt_GND;
double Vte_Vb2_e1;
double Vte_Vb2_c2;
double Vte_Vb2_c1;
double Vte_Vc1_c2;
#if defined(_DERIVATE2)
  double Vte_Vc1_c2_Vdt_GND;
  double Vte_Vc1_c2_Vb2_e1;
  double Vte_Vc1_c2_Vb2_c2;
  double Vte_Vc1_c2_Vb2_c1;
  double Vte_Vc1_c2_Vc1_c2;
  double Vte_Vb2_c1_Vdt_GND;
  double Vte_Vb2_c1_Vb2_e1;
  double Vte_Vb2_c1_Vb2_c2;
  double Vte_Vb2_c1_Vb2_c1;
  double Vte_Vb2_c1_Vc1_c2;
  double Vte_Vb2_c2_Vdt_GND;
  double Vte_Vb2_c2_Vb2_e1;
  double Vte_Vb2_c2_Vb2_c2;
  double Vte_Vb2_c2_Vb2_c1;
  double Vte_Vb2_c2_Vc1_c2;
  double Vte_Vb2_e1_Vdt_GND;
  double Vte_Vb2_e1_Vb2_e1;
  double Vte_Vb2_e1_Vb2_c2;
  double Vte_Vb2_e1_Vb2_c1;
  double Vte_Vb2_e1_Vc1_c2;
#endif
#endif
double E0BE;
#if defined(_DERIVATEFORDDX)
double E0BE_Vb2_e1;
double E0BE_Vdt_GND;
double E0BE_Vb2_c2;
double E0BE_Vb2_c1;
double E0BE_Vc1_c2;
#if defined(_DERIVATE2)
  double E0BE_Vc1_c2_Vb2_e1;
  double E0BE_Vc1_c2_Vdt_GND;
  double E0BE_Vc1_c2_Vb2_c2;
  double E0BE_Vc1_c2_Vb2_c1;
  double E0BE_Vc1_c2_Vc1_c2;
  double E0BE_Vb2_c1_Vb2_e1;
  double E0BE_Vb2_c1_Vdt_GND;
  double E0BE_Vb2_c1_Vb2_c2;
  double E0BE_Vb2_c1_Vb2_c1;
  double E0BE_Vb2_c1_Vc1_c2;
  double E0BE_Vb2_c2_Vb2_e1;
  double E0BE_Vb2_c2_Vdt_GND;
  double E0BE_Vb2_c2_Vb2_c2;
  double E0BE_Vb2_c2_Vb2_c1;
  double E0BE_Vb2_c2_Vc1_c2;
  double E0BE_Vb2_e1_Vb2_e1;
  double E0BE_Vb2_e1_Vdt_GND;
  double E0BE_Vb2_e1_Vb2_c2;
  double E0BE_Vb2_e1_Vb2_c1;
  double E0BE_Vb2_e1_Vc1_c2;
#endif
#endif
double Vje;
#if defined(_DERIVATEFORDDX)
double Vje_Vb2_e1;
double Vje_Vdt_GND;
double Vje_Vb2_c2;
double Vje_Vb2_c1;
double Vje_Vc1_c2;
#if defined(_DERIVATE2)
  double Vje_Vc1_c2_Vb2_e1;
  double Vje_Vc1_c2_Vdt_GND;
  double Vje_Vc1_c2_Vb2_c2;
  double Vje_Vc1_c2_Vb2_c1;
  double Vje_Vc1_c2_Vc1_c2;
  double Vje_Vb2_c1_Vb2_e1;
  double Vje_Vb2_c1_Vdt_GND;
  double Vje_Vb2_c1_Vb2_c2;
  double Vje_Vb2_c1_Vb2_c1;
  double Vje_Vb2_c1_Vc1_c2;
  double Vje_Vb2_c2_Vb2_e1;
  double Vje_Vb2_c2_Vdt_GND;
  double Vje_Vb2_c2_Vb2_c2;
  double Vje_Vb2_c2_Vb2_c1;
  double Vje_Vb2_c2_Vc1_c2;
  double Vje_Vb2_e1_Vb2_e1;
  double Vje_Vb2_e1_Vdt_GND;
  double Vje_Vb2_e1_Vb2_c2;
  double Vje_Vb2_e1_Vb2_c1;
  double Vje_Vb2_e1_Vc1_c2;
#endif
#endif
double a_VDE;
#if defined(_DERIVATE)
double a_VDE_Vdt_GND;
#endif
double Vfe;
#if defined(_DERIVATE)
double Vfe_Vdt_GND;
#endif
double pav;
#if defined(_DERIVATEFORDDX)
double pav_Vdt_GND;
double pav_Vb2_c2;
double pav_Vb2_c1;
double pav_Vc1_c2;
#if defined(_DERIVATE2)
  double pav_Vc1_c2_Vdt_GND;
  double pav_Vc1_c2_Vb2_c2;
  double pav_Vc1_c2_Vb2_c1;
  double pav_Vc1_c2_Vc1_c2;
  double pav_Vb2_c1_Vdt_GND;
  double pav_Vb2_c1_Vb2_c2;
  double pav_Vb2_c1_Vb2_c1;
  double pav_Vb2_c1_Vc1_c2;
  double pav_Vb2_c2_Vdt_GND;
  double pav_Vb2_c2_Vb2_c2;
  double pav_Vb2_c2_Vb2_c1;
  double pav_Vb2_c2_Vc1_c2;
#endif
#endif
double Icap_IHC;
#if defined(_DERIVATEFORDDX)
double Icap_IHC_Vdt_GND;
double Icap_IHC_Vb2_c2;
double Icap_IHC_Vb2_c1;
double Icap_IHC_Vc1_c2;
#if defined(_DERIVATE2)
  double Icap_IHC_Vc1_c2_Vdt_GND;
  double Icap_IHC_Vc1_c2_Vb2_c2;
  double Icap_IHC_Vc1_c2_Vb2_c1;
  double Icap_IHC_Vc1_c2_Vc1_c2;
  double Icap_IHC_Vb2_c1_Vdt_GND;
  double Icap_IHC_Vb2_c1_Vb2_c2;
  double Icap_IHC_Vb2_c1_Vb2_c1;
  double Icap_IHC_Vb2_c1_Vc1_c2;
  double Icap_IHC_Vb2_c2_Vdt_GND;
  double Icap_IHC_Vb2_c2_Vb2_c2;
  double Icap_IHC_Vb2_c2_Vb2_c1;
  double Icap_IHC_Vb2_c2_Vc1_c2;
#endif
#endif
double Icap;
#if defined(_DERIVATEFORDDX)
double Icap_Vdt_GND;
double Icap_Vb2_c2;
double Icap_Vb2_c1;
double Icap_Vc1_c2;
#if defined(_DERIVATE2)
  double Icap_Vc1_c2_Vdt_GND;
  double Icap_Vc1_c2_Vb2_c2;
  double Icap_Vc1_c2_Vb2_c1;
  double Icap_Vc1_c2_Vc1_c2;
  double Icap_Vb2_c1_Vdt_GND;
  double Icap_Vb2_c1_Vb2_c2;
  double Icap_Vb2_c1_Vb2_c1;
  double Icap_Vb2_c1_Vc1_c2;
  double Icap_Vb2_c2_Vdt_GND;
  double Icap_Vb2_c2_Vb2_c2;
  double Icap_Vb2_c2_Vb2_c1;
  double Icap_Vb2_c2_Vc1_c2;
#endif
#endif
double Vch;
#if defined(_DERIVATEFORDDX)
double Vch_Vdt_GND;
double Vch_Vb2_c2;
double Vch_Vb2_c1;
double Vch_Vc1_c2;
#if defined(_DERIVATE2)
  double Vch_Vc1_c2_Vdt_GND;
  double Vch_Vc1_c2_Vb2_c2;
  double Vch_Vc1_c2_Vb2_c1;
  double Vch_Vc1_c2_Vc1_c2;
  double Vch_Vb2_c1_Vdt_GND;
  double Vch_Vb2_c1_Vb2_c2;
  double Vch_Vb2_c1_Vb2_c1;
  double Vch_Vb2_c1_Vc1_c2;
  double Vch_Vb2_c2_Vdt_GND;
  double Vch_Vb2_c2_Vb2_c2;
  double Vch_Vb2_c2_Vb2_c1;
  double Vch_Vb2_c2_Vc1_c2;
#endif
#endif
double Vxi0;
#if defined(_DERIVATEFORDDX)
double Vxi0_Vdt_GND;
double Vxi0_Vb2_c2;
double Vxi0_Vb2_c1;
double Vxi0_Vc1_c2;
#if defined(_DERIVATE2)
  double Vxi0_Vc1_c2_Vdt_GND;
  double Vxi0_Vc1_c2_Vb2_c2;
  double Vxi0_Vc1_c2_Vb2_c1;
  double Vxi0_Vc1_c2_Vc1_c2;
  double Vxi0_Vb2_c1_Vdt_GND;
  double Vxi0_Vb2_c1_Vb2_c2;
  double Vxi0_Vb2_c1_Vb2_c1;
  double Vxi0_Vb2_c1_Vc1_c2;
  double Vxi0_Vb2_c2_Vdt_GND;
  double Vxi0_Vb2_c2_Vb2_c2;
  double Vxi0_Vb2_c2_Vb2_c1;
  double Vxi0_Vb2_c2_Vc1_c2;
#endif
#endif
double B2;
#if defined(_DERIVATEFORDDX)
double B2_Vdt_GND;
double B2_Vb2_c2;
double B2_Vb2_c1;
double B2_Vc1_c2;
#if defined(_DERIVATE2)
  double B2_Vc1_c2_Vdt_GND;
  double B2_Vc1_c2_Vb2_c2;
  double B2_Vc1_c2_Vb2_c1;
  double B2_Vc1_c2_Vc1_c2;
  double B2_Vb2_c1_Vdt_GND;
  double B2_Vb2_c1_Vb2_c2;
  double B2_Vb2_c1_Vb2_c1;
  double B2_Vb2_c1_Vc1_c2;
  double B2_Vb2_c2_Vdt_GND;
  double B2_Vb2_c2_Vb2_c2;
  double B2_Vb2_c2_Vb2_c1;
  double B2_Vb2_c2_Vc1_c2;
#endif
#endif
double B1;
#if defined(_DERIVATEFORDDX)
double B1_Vdt_GND;
double B1_Vb2_c2;
double B1_Vb2_c1;
double B1_Vc1_c2;
#if defined(_DERIVATE2)
  double B1_Vc1_c2_Vdt_GND;
  double B1_Vc1_c2_Vb2_c2;
  double B1_Vc1_c2_Vb2_c1;
  double B1_Vc1_c2_Vc1_c2;
  double B1_Vb2_c1_Vdt_GND;
  double B1_Vb2_c1_Vb2_c2;
  double B1_Vb2_c1_Vb2_c1;
  double B1_Vb2_c1_Vc1_c2;
  double B1_Vb2_c2_Vdt_GND;
  double B1_Vb2_c2_Vb2_c2;
  double B1_Vb2_c2_Vb2_c1;
  double B1_Vb2_c2_Vc1_c2;
#endif
#endif
double eVb2c2star;
#if defined(_DERIVATEFORDDX)
double eVb2c2star_Vdt_GND;
double eVb2c2star_Vb2_c2;
double eVb2c2star_Vb2_c1;
double eVb2c2star_Vc1_c2;
#if defined(_DERIVATE2)
  double eVb2c2star_Vc1_c2_Vdt_GND;
  double eVb2c2star_Vc1_c2_Vb2_c2;
  double eVb2c2star_Vc1_c2_Vb2_c1;
  double eVb2c2star_Vc1_c2_Vc1_c2;
  double eVb2c2star_Vb2_c1_Vdt_GND;
  double eVb2c2star_Vb2_c1_Vb2_c2;
  double eVb2c2star_Vb2_c1_Vb2_c1;
  double eVb2c2star_Vb2_c1_Vc1_c2;
  double eVb2c2star_Vb2_c2_Vdt_GND;
  double eVb2c2star_Vb2_c2_Vb2_c2;
  double eVb2c2star_Vb2_c2_Vb2_c1;
  double eVb2c2star_Vb2_c2_Vc1_c2;
#endif
#endif
double p0star;
#if defined(_DERIVATEFORDDX)
double p0star_Vdt_GND;
double p0star_Vb2_c2;
double p0star_Vb2_c1;
double p0star_Vc1_c2;
#if defined(_DERIVATE2)
  double p0star_Vc1_c2_Vdt_GND;
  double p0star_Vc1_c2_Vb2_c2;
  double p0star_Vc1_c2_Vb2_c1;
  double p0star_Vc1_c2_Vc1_c2;
  double p0star_Vb2_c1_Vdt_GND;
  double p0star_Vb2_c1_Vb2_c2;
  double p0star_Vb2_c1_Vb2_c1;
  double p0star_Vb2_c1_Vc1_c2;
  double p0star_Vb2_c2_Vdt_GND;
  double p0star_Vb2_c2_Vb2_c2;
  double p0star_Vb2_c2_Vb2_c1;
  double p0star_Vb2_c2_Vc1_c2;
#endif
#endif
double sqr_arg;
#if defined(_DERIVATEFORDDX)
double sqr_arg_Vdt_GND;
double sqr_arg_Vb2_c2;
double sqr_arg_Vb2_c1;
double sqr_arg_Vc1_c2;
#if defined(_DERIVATE2)
  double sqr_arg_Vc1_c2_Vdt_GND;
  double sqr_arg_Vc1_c2_Vb2_c2;
  double sqr_arg_Vc1_c2_Vb2_c1;
  double sqr_arg_Vc1_c2_Vc1_c2;
  double sqr_arg_Vb2_c1_Vdt_GND;
  double sqr_arg_Vb2_c1_Vb2_c2;
  double sqr_arg_Vb2_c1_Vb2_c1;
  double sqr_arg_Vb2_c1_Vc1_c2;
  double sqr_arg_Vb2_c2_Vdt_GND;
  double sqr_arg_Vb2_c2_Vb2_c2;
  double sqr_arg_Vb2_c2_Vb2_c1;
  double sqr_arg_Vb2_c2_Vc1_c2;
#endif
#endif
double gp02;
#if defined(_DERIVATEFORDDX)
double gp02_Vdt_GND;
double gp02_Vb2_c2;
double gp02_Vb2_c1;
double gp02_Vc1_c2;
#if defined(_DERIVATE2)
  double gp02_Vc1_c2_Vdt_GND;
  double gp02_Vc1_c2_Vb2_c2;
  double gp02_Vc1_c2_Vb2_c1;
  double gp02_Vc1_c2_Vc1_c2;
  double gp02_Vb2_c1_Vdt_GND;
  double gp02_Vb2_c1_Vb2_c2;
  double gp02_Vb2_c1_Vb2_c1;
  double gp02_Vb2_c1_Vc1_c2;
  double gp02_Vb2_c2_Vdt_GND;
  double gp02_Vb2_c2_Vb2_c2;
  double gp02_Vb2_c2_Vb2_c1;
  double gp02_Vb2_c2_Vc1_c2;
#endif
#endif
double gp0_help;
#if defined(_DERIVATEFORDDX)
double gp0_help_Vdt_GND;
double gp0_help_Vb2_c2;
double gp0_help_Vb2_c1;
double gp0_help_Vc1_c2;
#if defined(_DERIVATE2)
  double gp0_help_Vc1_c2_Vdt_GND;
  double gp0_help_Vc1_c2_Vb2_c2;
  double gp0_help_Vc1_c2_Vb2_c1;
  double gp0_help_Vc1_c2_Vc1_c2;
  double gp0_help_Vb2_c1_Vdt_GND;
  double gp0_help_Vb2_c1_Vb2_c2;
  double gp0_help_Vb2_c1_Vb2_c1;
  double gp0_help_Vb2_c1_Vc1_c2;
  double gp0_help_Vb2_c2_Vdt_GND;
  double gp0_help_Vb2_c2_Vb2_c2;
  double gp0_help_Vb2_c2_Vb2_c1;
  double gp0_help_Vb2_c2_Vc1_c2;
#endif
#endif
double gp0;
#if defined(_DERIVATEFORDDX)
double gp0_Vdt_GND;
double gp0_Vb2_c2;
double gp0_Vb2_c1;
double gp0_Vc1_c2;
#if defined(_DERIVATE2)
  double gp0_Vc1_c2_Vdt_GND;
  double gp0_Vc1_c2_Vb2_c2;
  double gp0_Vc1_c2_Vb2_c1;
  double gp0_Vc1_c2_Vc1_c2;
  double gp0_Vb2_c1_Vdt_GND;
  double gp0_Vb2_c1_Vb2_c2;
  double gp0_Vb2_c1_Vb2_c1;
  double gp0_Vb2_c1_Vc1_c2;
  double gp0_Vb2_c2_Vdt_GND;
  double gp0_Vb2_c2_Vb2_c2;
  double gp0_Vb2_c2_Vb2_c1;
  double gp0_Vb2_c2_Vc1_c2;
#endif
#endif
double xi_w;
#if defined(_DERIVATEFORDDX)
double xi_w_Vb2_c2;
double xi_w_Vb2_c1;
double xi_w_Vc1_c2;
double xi_w_Vdt_GND;
#if defined(_DERIVATE2)
  double xi_w_Vc1_c2_Vb2_c2;
  double xi_w_Vc1_c2_Vb2_c1;
  double xi_w_Vc1_c2_Vc1_c2;
  double xi_w_Vc1_c2_Vdt_GND;
  double xi_w_Vb2_c1_Vb2_c2;
  double xi_w_Vb2_c1_Vb2_c1;
  double xi_w_Vb2_c1_Vc1_c2;
  double xi_w_Vb2_c1_Vdt_GND;
  double xi_w_Vb2_c2_Vb2_c2;
  double xi_w_Vb2_c2_Vb2_c1;
  double xi_w_Vb2_c2_Vc1_c2;
  double xi_w_Vb2_c2_Vdt_GND;
#endif
#endif
double yi;
#if defined(_DERIVATEFORDDX)
double yi_Vb2_c2;
double yi_Vb2_c1;
double yi_Vc1_c2;
double yi_Vdt_GND;
#if defined(_DERIVATE2)
  double yi_Vc1_c2_Vb2_c2;
  double yi_Vc1_c2_Vb2_c1;
  double yi_Vc1_c2_Vc1_c2;
  double yi_Vc1_c2_Vdt_GND;
  double yi_Vb2_c1_Vb2_c2;
  double yi_Vb2_c1_Vb2_c1;
  double yi_Vb2_c1_Vc1_c2;
  double yi_Vb2_c1_Vdt_GND;
  double yi_Vb2_c2_Vb2_c2;
  double yi_Vb2_c2_Vb2_c1;
  double yi_Vb2_c2_Vc1_c2;
  double yi_Vb2_c2_Vdt_GND;
#endif
#endif
double vyi;
#if defined(_DERIVATEFORDDX)
double vyi_Vdt_GND;
double vyi_Vb2_c2;
double vyi_Vb2_c1;
double vyi_Vc1_c2;
#if defined(_DERIVATE2)
  double vyi_Vc1_c2_Vdt_GND;
  double vyi_Vc1_c2_Vb2_c2;
  double vyi_Vc1_c2_Vb2_c1;
  double vyi_Vc1_c2_Vc1_c2;
  double vyi_Vb2_c1_Vdt_GND;
  double vyi_Vb2_c1_Vb2_c2;
  double vyi_Vb2_c1_Vb2_c1;
  double vyi_Vb2_c1_Vc1_c2;
  double vyi_Vb2_c2_Vdt_GND;
  double vyi_Vb2_c2_Vb2_c2;
  double vyi_Vb2_c2_Vb2_c1;
  double vyi_Vb2_c2_Vc1_c2;
#endif
#endif
double alpha;
#if defined(_DERIVATEFORDDX)
double alpha_Vb2_c2;
double alpha_Vb2_c1;
double alpha_Vc1_c2;
double alpha_Vdt_GND;
#if defined(_DERIVATE2)
  double alpha_Vc1_c2_Vb2_c2;
  double alpha_Vc1_c2_Vb2_c1;
  double alpha_Vc1_c2_Vc1_c2;
  double alpha_Vc1_c2_Vdt_GND;
  double alpha_Vb2_c1_Vb2_c2;
  double alpha_Vb2_c1_Vb2_c1;
  double alpha_Vb2_c1_Vc1_c2;
  double alpha_Vb2_c1_Vdt_GND;
  double alpha_Vb2_c2_Vb2_c2;
  double alpha_Vb2_c2_Vb2_c1;
  double alpha_Vb2_c2_Vc1_c2;
  double alpha_Vb2_c2_Vdt_GND;
#endif
#endif
double alpha1;
#if defined(_DERIVATEFORDDX)
double alpha1_Vb2_c2;
double alpha1_Vb2_c1;
double alpha1_Vc1_c2;
double alpha1_Vdt_GND;
#if defined(_DERIVATE2)
  double alpha1_Vc1_c2_Vb2_c2;
  double alpha1_Vc1_c2_Vb2_c1;
  double alpha1_Vc1_c2_Vc1_c2;
  double alpha1_Vc1_c2_Vdt_GND;
  double alpha1_Vb2_c1_Vb2_c2;
  double alpha1_Vb2_c1_Vb2_c1;
  double alpha1_Vb2_c1_Vc1_c2;
  double alpha1_Vb2_c1_Vdt_GND;
  double alpha1_Vb2_c2_Vb2_c2;
  double alpha1_Vb2_c2_Vb2_c1;
  double alpha1_Vb2_c2_Vc1_c2;
  double alpha1_Vb2_c2_Vdt_GND;
#endif
#endif
double Ic1c2_Iqs;
#if defined(_DERIVATEFORDDX)
double Ic1c2_Iqs_Vdt_GND;
double Ic1c2_Iqs_Vb2_c2;
double Ic1c2_Iqs_Vb2_c1;
double Ic1c2_Iqs_Vc1_c2;
#if defined(_DERIVATE2)
  double Ic1c2_Iqs_Vc1_c2_Vdt_GND;
  double Ic1c2_Iqs_Vc1_c2_Vb2_c2;
  double Ic1c2_Iqs_Vc1_c2_Vb2_c1;
  double Ic1c2_Iqs_Vc1_c2_Vc1_c2;
  double Ic1c2_Iqs_Vb2_c1_Vdt_GND;
  double Ic1c2_Iqs_Vb2_c1_Vb2_c2;
  double Ic1c2_Iqs_Vb2_c1_Vb2_c1;
  double Ic1c2_Iqs_Vb2_c1_Vc1_c2;
  double Ic1c2_Iqs_Vb2_c2_Vdt_GND;
  double Ic1c2_Iqs_Vb2_c2_Vb2_c2;
  double Ic1c2_Iqs_Vb2_c2_Vb2_c1;
  double Ic1c2_Iqs_Vb2_c2_Vc1_c2;
#endif
#endif
double Iqs;
#if defined(_DERIVATEFORDDX)
double Iqs_Vdt_GND;
double Iqs_Vb2_c2;
double Iqs_Vb2_c1;
double Iqs_Vc1_c2;
#if defined(_DERIVATE2)
  double Iqs_Vc1_c2_Vdt_GND;
  double Iqs_Vc1_c2_Vb2_c2;
  double Iqs_Vc1_c2_Vb2_c1;
  double Iqs_Vc1_c2_Vc1_c2;
  double Iqs_Vb2_c1_Vdt_GND;
  double Iqs_Vb2_c1_Vb2_c2;
  double Iqs_Vb2_c1_Vb2_c1;
  double Iqs_Vb2_c1_Vc1_c2;
  double Iqs_Vb2_c2_Vdt_GND;
  double Iqs_Vb2_c2_Vb2_c2;
  double Iqs_Vb2_c2_Vb2_c1;
  double Iqs_Vb2_c2_Vc1_c2;
#endif
#endif
double Vqs;
#if defined(_DERIVATEFORDDX)
double Vqs_Vdt_GND;
double Vqs_Vb2_c2;
double Vqs_Vb2_c1;
double Vqs_Vc1_c2;
#if defined(_DERIVATE2)
  double Vqs_Vc1_c2_Vdt_GND;
  double Vqs_Vc1_c2_Vb2_c2;
  double Vqs_Vc1_c2_Vb2_c1;
  double Vqs_Vc1_c2_Vc1_c2;
  double Vqs_Vb2_c1_Vdt_GND;
  double Vqs_Vb2_c1_Vb2_c2;
  double Vqs_Vb2_c1_Vb2_c1;
  double Vqs_Vb2_c1_Vc1_c2;
  double Vqs_Vb2_c2_Vdt_GND;
  double Vqs_Vb2_c2_Vb2_c2;
  double Vqs_Vb2_c2_Vb2_c1;
  double Vqs_Vb2_c2_Vc1_c2;
#endif
#endif
double x2;
#if defined(_DERIVATEFORDDX)
double x2_Vb_c;
double x2_Vb_b1;
double x2_Vb1_b2;
double x2_Vc4_c1;
double x2_Vc3_c1;
double x2_Vc3_c4;
double x2_Vb2_e1;
double x2_Vdt_GND;
double x2_Vb2_c2;
double x2_Vb2_c1;
double x2_Vc1_c2;
#if defined(_DERIVATE2)
  double x2_Vc1_c2_Vb_c;
  double x2_Vc1_c2_Vb_b1;
  double x2_Vc1_c2_Vb1_b2;
  double x2_Vc1_c2_Vc4_c1;
  double x2_Vc1_c2_Vc3_c1;
  double x2_Vc1_c2_Vc3_c4;
  double x2_Vc1_c2_Vb2_e1;
  double x2_Vc1_c2_Vdt_GND;
  double x2_Vc1_c2_Vb2_c2;
  double x2_Vc1_c2_Vb2_c1;
  double x2_Vc1_c2_Vc1_c2;
  double x2_Vb2_c1_Vb_c;
  double x2_Vb2_c1_Vb_b1;
  double x2_Vb2_c1_Vb1_b2;
  double x2_Vb2_c1_Vc4_c1;
  double x2_Vb2_c1_Vc3_c1;
  double x2_Vb2_c1_Vc3_c4;
  double x2_Vb2_c1_Vb2_e1;
  double x2_Vb2_c1_Vdt_GND;
  double x2_Vb2_c1_Vb2_c2;
  double x2_Vb2_c1_Vb2_c1;
  double x2_Vb2_c1_Vc1_c2;
  double x2_Vb2_c2_Vb_c;
  double x2_Vb2_c2_Vb_b1;
  double x2_Vb2_c2_Vb1_b2;
  double x2_Vb2_c2_Vc4_c1;
  double x2_Vb2_c2_Vc3_c1;
  double x2_Vb2_c2_Vc3_c4;
  double x2_Vb2_c2_Vb2_e1;
  double x2_Vb2_c2_Vdt_GND;
  double x2_Vb2_c2_Vb2_c2;
  double x2_Vb2_c2_Vb2_c1;
  double x2_Vb2_c2_Vc1_c2;
  double x2_Vb2_e1_Vb_c;
  double x2_Vb2_e1_Vb_b1;
  double x2_Vb2_e1_Vb1_b2;
  double x2_Vb2_e1_Vc4_c1;
  double x2_Vb2_e1_Vc3_c1;
  double x2_Vb2_e1_Vc3_c4;
  double x2_Vb2_e1_Vb2_e1;
  double x2_Vb2_e1_Vdt_GND;
  double x2_Vb2_e1_Vb2_c2;
  double x2_Vb2_e1_Vb2_c1;
  double x2_Vb2_e1_Vc1_c2;
  double x2_Vc3_c1_Vb_c;
  double x2_Vc3_c1_Vb_b1;
  double x2_Vc3_c1_Vb1_b2;
  double x2_Vc3_c1_Vc4_c1;
  double x2_Vc3_c1_Vc3_c1;
  double x2_Vc3_c1_Vc3_c4;
  double x2_Vc3_c1_Vb2_e1;
  double x2_Vc3_c1_Vdt_GND;
  double x2_Vc3_c1_Vb2_c2;
  double x2_Vc3_c1_Vb2_c1;
  double x2_Vc3_c1_Vc1_c2;
  double x2_Vc4_c1_Vb_c;
  double x2_Vc4_c1_Vb_b1;
  double x2_Vc4_c1_Vb1_b2;
  double x2_Vc4_c1_Vc4_c1;
  double x2_Vc4_c1_Vc3_c1;
  double x2_Vc4_c1_Vc3_c4;
  double x2_Vc4_c1_Vb2_e1;
  double x2_Vc4_c1_Vdt_GND;
  double x2_Vc4_c1_Vb2_c2;
  double x2_Vc4_c1_Vb2_c1;
  double x2_Vc4_c1_Vc1_c2;
  double x2_Vb1_b2_Vb_c;
  double x2_Vb1_b2_Vb_b1;
  double x2_Vb1_b2_Vb1_b2;
  double x2_Vb1_b2_Vc4_c1;
  double x2_Vb1_b2_Vc3_c1;
  double x2_Vb1_b2_Vc3_c4;
  double x2_Vb1_b2_Vb2_e1;
  double x2_Vb1_b2_Vdt_GND;
  double x2_Vb1_b2_Vb2_c2;
  double x2_Vb1_b2_Vb2_c1;
  double x2_Vb1_b2_Vc1_c2;
  double x2_Vb_b1_Vb_c;
  double x2_Vb_b1_Vb_b1;
  double x2_Vb_b1_Vb1_b2;
  double x2_Vb_b1_Vc4_c1;
  double x2_Vb_b1_Vc3_c1;
  double x2_Vb_b1_Vc3_c4;
  double x2_Vb_b1_Vb2_e1;
  double x2_Vb_b1_Vdt_GND;
  double x2_Vb_b1_Vb2_c2;
  double x2_Vb_b1_Vb2_c1;
  double x2_Vb_b1_Vc1_c2;
  double x2_Vb_c_Vb_c;
  double x2_Vb_c_Vb_b1;
  double x2_Vb_c_Vb1_b2;
  double x2_Vb_c_Vc4_c1;
  double x2_Vb_c_Vc3_c1;
  double x2_Vb_c_Vc3_c4;
  double x2_Vb_c_Vb2_e1;
  double x2_Vb_c_Vdt_GND;
  double x2_Vb_c_Vb2_c2;
  double x2_Vb_c_Vb2_c1;
  double x2_Vb_c_Vc1_c2;
#endif
#endif
double eps2;
#if defined(_DERIVATE)
double eps2_Vdt_GND;
#endif
double eps_VDC;
#if defined(_DERIVATE)
double eps_VDC_Vdt_GND;
#endif
double Vqs_th;
#if defined(_DERIVATEFORDDX)
double Vqs_th_Vdt_GND;
double Vqs_th_Vb2_c2;
double Vqs_th_Vb2_c1;
double Vqs_th_Vc1_c2;
#if defined(_DERIVATE2)
  double Vqs_th_Vc1_c2_Vdt_GND;
  double Vqs_th_Vc1_c2_Vb2_c2;
  double Vqs_th_Vc1_c2_Vb2_c1;
  double Vqs_th_Vc1_c2_Vc1_c2;
  double Vqs_th_Vb2_c1_Vdt_GND;
  double Vqs_th_Vb2_c1_Vb2_c2;
  double Vqs_th_Vb2_c1_Vb2_c1;
  double Vqs_th_Vb2_c1_Vc1_c2;
  double Vqs_th_Vb2_c2_Vdt_GND;
  double Vqs_th_Vb2_c2_Vb2_c2;
  double Vqs_th_Vb2_c2_Vb2_c1;
  double Vqs_th_Vb2_c2_Vc1_c2;
#endif
#endif
double tmpV;
#if defined(_DERIVATEFORDDX)
double tmpV_Vb2_c1;
#if defined(_DERIVATE2)
  double tmpV_Vb2_c1_Vb2_c1;
#endif
#endif
double Ic1c2;
#if defined(_DERIVATEFORDDX)
double Ic1c2_Vdt_GND;
double Ic1c2_Vb2_c2;
double Ic1c2_Vb2_c1;
double Ic1c2_Vc1_c2;
#if defined(_DERIVATE2)
  double Ic1c2_Vc1_c2_Vdt_GND;
  double Ic1c2_Vc1_c2_Vb2_c2;
  double Ic1c2_Vc1_c2_Vb2_c1;
  double Ic1c2_Vc1_c2_Vc1_c2;
  double Ic1c2_Vb2_c1_Vdt_GND;
  double Ic1c2_Vb2_c1_Vb2_c2;
  double Ic1c2_Vb2_c1_Vb2_c1;
  double Ic1c2_Vb2_c1_Vc1_c2;
  double Ic1c2_Vb2_c2_Vdt_GND;
  double Ic1c2_Vb2_c2_Vb2_c2;
  double Ic1c2_Vb2_c2_Vb2_c1;
  double Ic1c2_Vb2_c2_Vc1_c2;
#endif
#endif
double Ec;
#if defined(_DERIVATEFORDDX)
double Ec_Vdt_GND;
double Ec_Vb2_c2;
double Ec_Vb2_c1;
#if defined(_DERIVATE2)
  double Ec_Vb2_c1_Vdt_GND;
  double Ec_Vb2_c1_Vb2_c2;
  double Ec_Vb2_c1_Vb2_c1;
  double Ec_Vb2_c2_Vdt_GND;
  double Ec_Vb2_c2_Vb2_c2;
  double Ec_Vb2_c2_Vb2_c1;
#endif
#endif
double pW;
#if defined(_DERIVATEFORDDX)
double pW_Vb2_c1;
double pW_Vdt_GND;
#if defined(_DERIVATE2)
  double pW_Vb2_c1_Vb2_c1;
  double pW_Vb2_c1_Vdt_GND;
#endif
#endif
double Kw;
#if defined(_DERIVATEFORDDX)
double Kw_Vb2_c1;
double Kw_Vdt_GND;
#if defined(_DERIVATE2)
  double Kw_Vb2_c1_Vb2_c1;
  double Kw_Vb2_c1_Vdt_GND;
#endif
#endif
double K0;
#if defined(_DERIVATEFORDDX)
double K0_Vb2_c2;
double K0_Vdt_GND;
#if defined(_DERIVATE2)
  double K0_Vb2_c2_Vb2_c2;
  double K0_Vb2_c2_Vdt_GND;
#endif
#endif
double eVb2c1VDC;
#if defined(_DERIVATEFORDDX)
double eVb2c1VDC_Vb2_c1;
double eVb2c1VDC_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb2c1VDC_Vb2_c1_Vb2_c1;
  double eVb2c1VDC_Vb2_c1_Vdt_GND;
#endif
#endif
double eVb2c2VDC;
#if defined(_DERIVATEFORDDX)
double eVb2c2VDC_Vb2_c2;
double eVb2c2VDC_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb2c2VDC_Vb2_c2_Vb2_c2;
  double eVb2c2VDC_Vb2_c2_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double eVb1c4VDC;
#if defined(_DERIVATEFORDDX)
double eVb1c4VDC_Vb1_b2;
double eVb1c4VDC_Vb2_c2;
double eVb1c4VDC_Vc1_c2;
double eVb1c4VDC_Vc4_c1;
double eVb1c4VDC_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb1c4VDC_Vc1_c2_Vb1_b2;
  double eVb1c4VDC_Vc1_c2_Vb2_c2;
  double eVb1c4VDC_Vc1_c2_Vc1_c2;
  double eVb1c4VDC_Vc1_c2_Vc4_c1;
  double eVb1c4VDC_Vc1_c2_Vdt_GND;
  double eVb1c4VDC_Vb2_c2_Vb1_b2;
  double eVb1c4VDC_Vb2_c2_Vb2_c2;
  double eVb1c4VDC_Vb2_c2_Vc1_c2;
  double eVb1c4VDC_Vb2_c2_Vc4_c1;
  double eVb1c4VDC_Vb2_c2_Vdt_GND;
  double eVb1c4VDC_Vb1_b2_Vb1_b2;
  double eVb1c4VDC_Vb1_b2_Vb2_c2;
  double eVb1c4VDC_Vb1_b2_Vc1_c2;
  double eVb1c4VDC_Vb1_b2_Vc4_c1;
  double eVb1c4VDC_Vb1_b2_Vdt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double eVbc3VDC;
#if defined(_DERIVATEFORDDX)
double eVbc3VDC_Vb_c;
double eVbc3VDC_Vb_b1;
double eVbc3VDC_Vb1_b2;
double eVbc3VDC_Vb2_c2;
double eVbc3VDC_Vc1_c2;
double eVbc3VDC_Vc4_c1;
double eVbc3VDC_Vc3_c1;
double eVbc3VDC_Vc3_c4;
double eVbc3VDC_Vdt_GND;
#if defined(_DERIVATE2)
  double eVbc3VDC_Vb_b1_Vb_c;
  double eVbc3VDC_Vb_b1_Vb_b1;
  double eVbc3VDC_Vb_b1_Vb1_b2;
  double eVbc3VDC_Vb_b1_Vb2_c2;
  double eVbc3VDC_Vb_b1_Vc1_c2;
  double eVbc3VDC_Vb_b1_Vc4_c1;
  double eVbc3VDC_Vb_b1_Vc3_c1;
  double eVbc3VDC_Vb_b1_Vc3_c4;
  double eVbc3VDC_Vb_b1_Vdt_GND;
  double eVbc3VDC_Vb_c_Vb_c;
  double eVbc3VDC_Vb_c_Vb_b1;
  double eVbc3VDC_Vb_c_Vb1_b2;
  double eVbc3VDC_Vb_c_Vb2_c2;
  double eVbc3VDC_Vb_c_Vc1_c2;
  double eVbc3VDC_Vb_c_Vc4_c1;
  double eVbc3VDC_Vb_c_Vc3_c1;
  double eVbc3VDC_Vb_c_Vc3_c4;
  double eVbc3VDC_Vb_c_Vdt_GND;
#endif
#endif
#endif
double eVsc4;
#if defined(_DERIVATE)
double eVsc4_Vs_c1;
double eVsc4_Vc4_c1;
double eVsc4_Vdt_GND;
#endif
double eVsc3;
#if defined(_DERIVATE)
double eVsc3_Vs_c1;
double eVsc3_Vc4_c1;
double eVsc3_Vc3_c1;
double eVsc3_Vc3_c4;
double eVsc3_Vdt_GND;
#endif
double eVsc1;
#if defined(_DERIVATEFORDDX)
double eVsc1_Vs_c1;
double eVsc1_Vdt_GND;
#if defined(_DERIVATE2)
  double eVsc1_Vs_c1_Vs_c1;
  double eVsc1_Vs_c1_Vdt_GND;
#endif
#endif
double eVbc3;
#if defined(_DERIVATEFORDDX)
double eVbc3_Vb_c;
double eVbc3_Vb_b1;
double eVbc3_Vb1_b2;
double eVbc3_Vb2_c2;
double eVbc3_Vc1_c2;
double eVbc3_Vc4_c1;
double eVbc3_Vc3_c1;
double eVbc3_Vc3_c4;
double eVbc3_Vdt_GND;
#if defined(_DERIVATE2)
  double eVbc3_Vb_b1_Vb_c;
  double eVbc3_Vb_b1_Vb_b1;
  double eVbc3_Vb_b1_Vb1_b2;
  double eVbc3_Vb_b1_Vb2_c2;
  double eVbc3_Vb_b1_Vc1_c2;
  double eVbc3_Vb_b1_Vc4_c1;
  double eVbc3_Vb_b1_Vc3_c1;
  double eVbc3_Vb_b1_Vc3_c4;
  double eVbc3_Vb_b1_Vdt_GND;
  double eVbc3_Vb_c_Vb_c;
  double eVbc3_Vb_c_Vb_b1;
  double eVbc3_Vb_c_Vb1_b2;
  double eVbc3_Vb_c_Vb2_c2;
  double eVbc3_Vb_c_Vc1_c2;
  double eVbc3_Vb_c_Vc4_c1;
  double eVbc3_Vb_c_Vc3_c1;
  double eVbc3_Vb_c_Vc3_c4;
  double eVbc3_Vb_c_Vdt_GND;
#endif
#endif
#if defined(_DERIVATE)
double eVb1b2_Vb1_b2;
double eVb1b2_Vdt_GND;
#endif
double eVb1c4;
#if defined(_DERIVATEFORDDX)
double eVb1c4_Vb1_b2;
double eVb1c4_Vb2_c2;
double eVb1c4_Vc1_c2;
double eVb1c4_Vc4_c1;
double eVb1c4_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb1c4_Vc1_c2_Vb1_b2;
  double eVb1c4_Vc1_c2_Vb2_c2;
  double eVb1c4_Vc1_c2_Vc1_c2;
  double eVb1c4_Vc1_c2_Vc4_c1;
  double eVb1c4_Vc1_c2_Vdt_GND;
  double eVb1c4_Vb2_c2_Vb1_b2;
  double eVb1c4_Vb2_c2_Vb2_c2;
  double eVb1c4_Vb2_c2_Vc1_c2;
  double eVb1c4_Vb2_c2_Vc4_c1;
  double eVb1c4_Vb2_c2_Vdt_GND;
  double eVb1c4_Vb1_b2_Vb1_b2;
  double eVb1c4_Vb1_b2_Vb2_c2;
  double eVb1c4_Vb1_b2_Vc1_c2;
  double eVb1c4_Vb1_b2_Vc4_c1;
  double eVb1c4_Vb1_b2_Vdt_GND;
#endif
#endif
double eVb1e1;
#if defined(_DERIVATEFORDDX)
double eVb1e1_Vb1_e1;
double eVb1e1_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb1e1_Vb1_e1_Vb1_e1;
  double eVb1e1_Vb1_e1_Vdt_GND;
#endif
#endif
double eVb2e1;
#if defined(_DERIVATEFORDDX)
double eVb2e1_Vb2_e1;
double eVb2e1_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb2e1_Vb2_e1_Vb2_e1;
  double eVb2e1_Vb2_e1_Vdt_GND;
#endif
#endif
double expl;
double eVb2c2;
#if defined(_DERIVATEFORDDX)
double eVb2c2_Vb2_c2;
double eVb2c2_Vdt_GND;
#if defined(_DERIVATE2)
  double eVb2c2_Vb2_c2_Vb2_c2;
  double eVb2c2_Vb2_c2_Vdt_GND;
#endif
#endif
double Vsc3;
#if defined(_DERIVATE)
double Vsc3_Vs_c1;
double Vsc3_Vc4_c1;
double Vsc3_Vc3_c1;
double Vsc3_Vc3_c4;
#endif
double Vsc4;
#if defined(_DERIVATE)
double Vsc4_Vs_c1;
double Vsc4_Vc4_c1;
#endif
double Vbc3;
#if defined(_DERIVATEFORDDX)
double Vbc3_Vb_c;
double Vbc3_Vb_b1;
double Vbc3_Vb1_b2;
double Vbc3_Vb2_c2;
double Vbc3_Vc1_c2;
double Vbc3_Vc4_c1;
double Vbc3_Vc3_c1;
double Vbc3_Vc3_c4;
#if defined(_DERIVATE2)
  double Vbc3_Vc3_c1_Vb_c;
  double Vbc3_Vc3_c1_Vb_b1;
  double Vbc3_Vc3_c1_Vb1_b2;
  double Vbc3_Vc3_c1_Vb2_c2;
  double Vbc3_Vc3_c1_Vc1_c2;
  double Vbc3_Vc3_c1_Vc4_c1;
  double Vbc3_Vc3_c1_Vc3_c1;
  double Vbc3_Vc3_c1_Vc3_c4;
  double Vbc3_Vc4_c1_Vb_c;
  double Vbc3_Vc4_c1_Vb_b1;
  double Vbc3_Vc4_c1_Vb1_b2;
  double Vbc3_Vc4_c1_Vb2_c2;
  double Vbc3_Vc4_c1_Vc1_c2;
  double Vbc3_Vc4_c1_Vc4_c1;
  double Vbc3_Vc4_c1_Vc3_c1;
  double Vbc3_Vc4_c1_Vc3_c4;
  double Vbc3_Vc1_c2_Vb_c;
  double Vbc3_Vc1_c2_Vb_b1;
  double Vbc3_Vc1_c2_Vb1_b2;
  double Vbc3_Vc1_c2_Vb2_c2;
  double Vbc3_Vc1_c2_Vc1_c2;
  double Vbc3_Vc1_c2_Vc4_c1;
  double Vbc3_Vc1_c2_Vc3_c1;
  double Vbc3_Vc1_c2_Vc3_c4;
  double Vbc3_Vb2_c2_Vb_c;
  double Vbc3_Vb2_c2_Vb_b1;
  double Vbc3_Vb2_c2_Vb1_b2;
  double Vbc3_Vb2_c2_Vb2_c2;
  double Vbc3_Vb2_c2_Vc1_c2;
  double Vbc3_Vb2_c2_Vc4_c1;
  double Vbc3_Vb2_c2_Vc3_c1;
  double Vbc3_Vb2_c2_Vc3_c4;
  double Vbc3_Vb1_b2_Vb_c;
  double Vbc3_Vb1_b2_Vb_b1;
  double Vbc3_Vb1_b2_Vb1_b2;
  double Vbc3_Vb1_b2_Vb2_c2;
  double Vbc3_Vb1_b2_Vc1_c2;
  double Vbc3_Vb1_b2_Vc4_c1;
  double Vbc3_Vb1_b2_Vc3_c1;
  double Vbc3_Vb1_b2_Vc3_c4;
  double Vbc3_Vb_b1_Vb_c;
  double Vbc3_Vb_b1_Vb_b1;
  double Vbc3_Vb_b1_Vb1_b2;
  double Vbc3_Vb_b1_Vb2_c2;
  double Vbc3_Vb_b1_Vc1_c2;
  double Vbc3_Vb_b1_Vc4_c1;
  double Vbc3_Vb_b1_Vc3_c1;
  double Vbc3_Vb_b1_Vc3_c4;
  double Vbc3_Vb_c_Vb_c;
  double Vbc3_Vb_c_Vb_b1;
  double Vbc3_Vb_c_Vb1_b2;
  double Vbc3_Vb_c_Vb2_c2;
  double Vbc3_Vb_c_Vc1_c2;
  double Vbc3_Vb_c_Vc4_c1;
  double Vbc3_Vb_c_Vc3_c1;
  double Vbc3_Vb_c_Vc3_c4;
#endif
#endif
double Vcc3;
#if defined(_DERIVATEFORDDX)
double Vcc3_Vb_c;
double Vcc3_Vb_b1;
double Vcc3_Vb1_b2;
double Vcc3_Vb2_c2;
double Vcc3_Vc1_c2;
double Vcc3_Vc4_c1;
double Vcc3_Vc3_c1;
double Vcc3_Vc3_c4;
#if defined(_DERIVATE2)
  double Vcc3_Vc3_c1_Vb_c;
  double Vcc3_Vc3_c1_Vb_b1;
  double Vcc3_Vc3_c1_Vb1_b2;
  double Vcc3_Vc3_c1_Vb2_c2;
  double Vcc3_Vc3_c1_Vc1_c2;
  double Vcc3_Vc3_c1_Vc4_c1;
  double Vcc3_Vc3_c1_Vc3_c1;
  double Vcc3_Vc3_c1_Vc3_c4;
  double Vcc3_Vc4_c1_Vb_c;
  double Vcc3_Vc4_c1_Vb_b1;
  double Vcc3_Vc4_c1_Vb1_b2;
  double Vcc3_Vc4_c1_Vb2_c2;
  double Vcc3_Vc4_c1_Vc1_c2;
  double Vcc3_Vc4_c1_Vc4_c1;
  double Vcc3_Vc4_c1_Vc3_c1;
  double Vcc3_Vc4_c1_Vc3_c4;
  double Vcc3_Vc1_c2_Vb_c;
  double Vcc3_Vc1_c2_Vb_b1;
  double Vcc3_Vc1_c2_Vb1_b2;
  double Vcc3_Vc1_c2_Vb2_c2;
  double Vcc3_Vc1_c2_Vc1_c2;
  double Vcc3_Vc1_c2_Vc4_c1;
  double Vcc3_Vc1_c2_Vc3_c1;
  double Vcc3_Vc1_c2_Vc3_c4;
  double Vcc3_Vb2_c2_Vb_c;
  double Vcc3_Vb2_c2_Vb_b1;
  double Vcc3_Vb2_c2_Vb1_b2;
  double Vcc3_Vb2_c2_Vb2_c2;
  double Vcc3_Vb2_c2_Vc1_c2;
  double Vcc3_Vb2_c2_Vc4_c1;
  double Vcc3_Vb2_c2_Vc3_c1;
  double Vcc3_Vb2_c2_Vc3_c4;
  double Vcc3_Vb1_b2_Vb_c;
  double Vcc3_Vb1_b2_Vb_b1;
  double Vcc3_Vb1_b2_Vb1_b2;
  double Vcc3_Vb1_b2_Vb2_c2;
  double Vcc3_Vb1_b2_Vc1_c2;
  double Vcc3_Vb1_b2_Vc4_c1;
  double Vcc3_Vb1_b2_Vc3_c1;
  double Vcc3_Vb1_b2_Vc3_c4;
  double Vcc3_Vb_b1_Vb_c;
  double Vcc3_Vb_b1_Vb_b1;
  double Vcc3_Vb_b1_Vb1_b2;
  double Vcc3_Vb_b1_Vb2_c2;
  double Vcc3_Vb_b1_Vc1_c2;
  double Vcc3_Vb_b1_Vc4_c1;
  double Vcc3_Vb_b1_Vc3_c1;
  double Vcc3_Vb_b1_Vc3_c4;
  double Vcc3_Vb_c_Vb_c;
  double Vcc3_Vb_c_Vb_b1;
  double Vcc3_Vb_c_Vb1_b2;
  double Vcc3_Vb_c_Vb2_c2;
  double Vcc3_Vb_c_Vc1_c2;
  double Vcc3_Vb_c_Vc4_c1;
  double Vcc3_Vb_c_Vc3_c1;
  double Vcc3_Vb_c_Vc3_c4;
#endif
#endif
double Vb1c4;
#if defined(_DERIVATEFORDDX)
double Vb1c4_Vb1_b2;
double Vb1c4_Vb2_c2;
double Vb1c4_Vc1_c2;
double Vb1c4_Vc4_c1;
#if defined(_DERIVATE2)
  double Vb1c4_Vc4_c1_Vb1_b2;
  double Vb1c4_Vc4_c1_Vb2_c2;
  double Vb1c4_Vc4_c1_Vc1_c2;
  double Vb1c4_Vc4_c1_Vc4_c1;
  double Vb1c4_Vc1_c2_Vb1_b2;
  double Vb1c4_Vc1_c2_Vb2_c2;
  double Vb1c4_Vc1_c2_Vc1_c2;
  double Vb1c4_Vc1_c2_Vc4_c1;
  double Vb1c4_Vb2_c2_Vb1_b2;
  double Vb1c4_Vb2_c2_Vb2_c2;
  double Vb1c4_Vb2_c2_Vc1_c2;
  double Vb1c4_Vb2_c2_Vc4_c1;
  double Vb1c4_Vb1_b2_Vb1_b2;
  double Vb1c4_Vb1_b2_Vb2_c2;
  double Vb1c4_Vb1_b2_Vc1_c2;
  double Vb1c4_Vb1_b2_Vc4_c1;
#endif
#endif
double Vc3c4;
#if defined(_DERIVATEFORDDX)
double Vc3c4_Vc3_c1;
double Vc3c4_Vc3_c4;
#if defined(_DERIVATE2)
  double Vc3c4_Vc3_c1_Vc3_c1;
  double Vc3c4_Vc3_c1_Vc3_c4;
#endif
#endif
double Vc4c1;
#if defined(_DERIVATEFORDDX)
double Vc4c1_Vc4_c1;
#if defined(_DERIVATE2)
  double Vc4c1_Vc4_c1_Vc4_c1;
#endif
#endif
double Vbc;
#if defined(_DERIVATEFORDDX)
double Vbc_Vb_c;
#if defined(_DERIVATE2)
  double Vbc_Vb_c_Vb_c;
#endif
#endif
#if defined(_DYNAMIC)
double Vbe;
#if defined(_DERIVATE)
double Vbe_Vb_e;
#endif
#endif
double Vbb1;
#if defined(_DERIVATEFORDDX)
double Vbb1_Vb_b1;
#if defined(_DERIVATE2)
  double Vbb1_Vb_b1_Vb_b1;
#endif
#endif
double Vee1;
#if defined(_DERIVATE)
double Vee1_Ve_e1;
#endif
double Vc1c2;
#if defined(_DERIVATEFORDDX)
double Vc1c2_Vc1_c2;
#if defined(_DERIVATE2)
  double Vc1c2_Vc1_c2_Vc1_c2;
#endif
#endif
double Vsc1;
#if defined(_DERIVATEFORDDX)
double Vsc1_Vs_c1;
#if defined(_DERIVATE2)
  double Vsc1_Vs_c1_Vs_c1;
#endif
#endif
double Vb1b2;
#if defined(_DERIVATEFORDDX)
double Vb1b2_Vb1_b2;
#if defined(_DERIVATE2)
  double Vb1b2_Vb1_b2_Vb1_b2;
#endif
#endif
double Vb1e1;
#if defined(_DERIVATEFORDDX)
double Vb1e1_Vb1_e1;
#if defined(_DERIVATE2)
  double Vb1e1_Vb1_e1_Vb1_e1;
#endif
#endif
double Vb2e1;
#if defined(_DERIVATEFORDDX)
double Vb2e1_Vb2_e1;
#if defined(_DERIVATE2)
  double Vb2e1_Vb2_e1_Vb2_e1;
#endif
#endif
double Vb2c2;
#if defined(_DERIVATEFORDDX)
double Vb2c2_Vb2_c2;
#if defined(_DERIVATE2)
  double Vb2c2_Vb2_c2_Vb2_c2;
#endif
#endif
double Vb2c1;
#if defined(_DERIVATEFORDDX)
double Vb2c1_Vb2_c1;
#if defined(_DERIVATE2)
  double Vb2c1_Vb2_c1_Vb2_c1;
#endif
#endif
double RTH_Tamb_M;
#if defined(_DERIVATE)
double GCCin_TM_Vdt_GND;
#endif
#if defined(_DERIVATE)
double GCCex_TM_Vdt_GND;
#endif
#if defined(_DERIVATE)
double GCCxx_TM_Vdt_GND;
#endif
double RCV_TM;
#if defined(_DERIVATE)
double RCV_TM_Vdt_GND;
#endif
double RCCin_TM;
#if defined(_DERIVATE)
double RCCin_TM_Vdt_GND;
#endif
double RCCex_TM;
#if defined(_DERIVATE)
double RCCex_TM_Vdt_GND;
#endif
double RCCxx_TM;
#if defined(_DERIVATE)
double RCCxx_TM_Vdt_GND;
#endif
double RBV_TM;
#if defined(_DERIVATE)
double RBV_TM_Vdt_GND;
#endif
#if defined(_DERIVATE)
double RBC_TM_Vdt_GND;
#endif
#if defined(_DERIVATE)
double RE_TM_Vdt_GND;
#endif
#if defined(_DYNAMIC)
double CJS_TM;
#if defined(_DERIVATE)
double CJS_TM_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double CJC_TM;
#if defined(_DERIVATE)
double CJC_TM_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double CJE_TM;
#if defined(_DERIVATE)
double CJE_TM_Vdt_GND;
#endif
#endif
double IKS_TM;
#if defined(_DERIVATE)
double IKS_TM_Vdt_GND;
#endif
double ICSS_TM;
#if defined(_DERIVATE)
double ICSS_TM_Vdt_GND;
#endif
double ISS_TM;
#if defined(_DERIVATE)
double ISS_TM_Vdt_GND;
#endif
double IHC_M;
double IZEB_TM;
#if defined(_DERIVATE)
double IZEB_TM_Vdt_GND;
#endif
double IBR_TM;
#if defined(_DERIVATE)
double IBR_TM_Vdt_GND;
#endif
double IBF_TM;
#if defined(_DERIVATE)
double IBF_TM_Vdt_GND;
#endif
double IK_TM;
#if defined(_DERIVATE)
double IK_TM_Vdt_GND;
#endif
double IS_TM;
#if defined(_DERIVATE)
double IS_TM_Vdt_GND;
#endif
double RTH_Tamb;
double DEG_T;
#if defined(_DERIVATE)
double DEG_T_Vdt_GND;
#endif
double BnT;
#if defined(_DERIVATE)
double BnT_Vdt_GND;
#endif
double Tk300;
#if defined(_DERIVATE)
double Tk300_Vdt_GND;
#endif
#if defined(_DYNAMIC)
double TAUR_T;
#if defined(_DERIVATE)
double TAUR_T_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double TEPI_T;
#if defined(_DERIVATE)
double TEPI_T_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE)
double TAUB_T_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double TAUE_T;
#if defined(_DERIVATE)
double TAUE_T_Vdt_GND;
#endif
#endif
double IKS_T;
#if defined(_DERIVATE)
double IKS_T_Vdt_GND;
#endif
double ICSS_T;
#if defined(_DERIVATE)
double ICSS_T_Vdt_GND;
#endif
double ISS_T;
#if defined(_DERIVATE)
double ISS_T_Vdt_GND;
#endif
double VER_T;
#if defined(_DERIVATE)
double VER_T_Vdt_GND;
#endif
double VEF_T;
#if defined(_DERIVATE)
double VEF_T_Vdt_GND;
#endif
double IZEB_T;
#if defined(_DERIVATE)
double IZEB_T_Vdt_GND;
#endif
double nZEB_T;
#if defined(_DERIVATE)
double nZEB_T_Vdt_GND;
#endif
double y;
#if defined(_DERIVATE)
double y_Vdt_GND;
#endif
double x;
#if defined(_DERIVATEFORDDX)
double x_Vb2_e1;
double x_Vdt_GND;
#if defined(_DERIVATE2)
  double x_Vb2_e1_Vb2_e1;
  double x_Vb2_e1_Vdt_GND;
#endif
#endif
double IBR_T;
#if defined(_DERIVATE)
double IBR_T_Vdt_GND;
#endif
double IBF_T;
#if defined(_DERIVATE)
double IBF_T_Vdt_GND;
#endif
double IK_T;
#if defined(_DERIVATE)
double IK_T_Vdt_GND;
#endif
double IS_T;
#if defined(_DERIVATE)
double IS_T_Vdt_GND;
#endif
double BRI_T;
#if defined(_DERIVATE)
double BRI_T_Vdt_GND;
#endif
double BF_T;
#if defined(_DERIVATE)
double BF_T_Vdt_GND;
#endif
double RCV_T;
#if defined(_DERIVATE)
double RCV_T_Vdt_GND;
#endif
double RCCin_T;
#if defined(_DERIVATE)
double RCCin_T_Vdt_GND;
#endif
double RCCex_T;
#if defined(_DERIVATE)
double RCCex_T_Vdt_GND;
#endif
double RCCxx_T;
#if defined(_DERIVATE)
double RCCxx_T_Vdt_GND;
#endif
double RBC_T;
#if defined(_DERIVATE)
double RBC_T_Vdt_GND;
#endif
double RBV_T;
#if defined(_DERIVATE)
double RBV_T_Vdt_GND;
#endif
double RE_T;
#if defined(_DERIVATE)
double RE_T_Vdt_GND;
#endif
double XP_T;
#if defined(_DERIVATE)
double XP_T_Vdt_GND;
#endif
#if defined(_DYNAMIC)
double CJC_T;
#if defined(_DERIVATE)
double CJC_T_Vdt_GND;
#endif
#endif
double CJCscaleINV;
#if defined(_DERIVATE)
double CJCscaleINV_Vdt_GND;
#endif
double CJCscale;
#if defined(_DERIVATE)
double CJCscale_Vdt_GND;
#endif
#if defined(_DYNAMIC)
double CJS_T;
#if defined(_DERIVATE)
double CJS_T_Vdt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double CJE_T;
#if defined(_DERIVATE)
double CJE_T_Vdt_GND;
#endif
#endif
double CJE_T_div_CJE;
#if defined(_DERIVATE)
double CJE_T_div_CJE_Vdt_GND;
#endif
double inv_VDE_T;
#if defined(_DERIVATE)
double inv_VDE_T_Vdt_GND;
#endif
#if defined(_DYNAMIC)
double VDS_T;
#if defined(_DERIVATE)
double VDS_T_Vdt_GND;
#endif
#endif
double UdsT;
#if defined(_DERIVATE)
double UdsT_Vdt_GND;
#endif
double VDC_T;
#if defined(_DERIVATE)
double VDC_T_Vdt_GND;
#endif
double UdcT;
#if defined(_DERIVATE)
double UdcT_Vdt_GND;
#endif
double VDE_T;
#if defined(_DERIVATE)
double VDE_T_Vdt_GND;
#endif
double UdeT;
#if defined(_DERIVATE)
double UdeT_Vdt_GND;
#endif
double VGZEB_T;
#if defined(_DERIVATE)
double VGZEB_T_Vdt_GND;
#endif
double dxa;
#if defined(_DERIVATEFORDDX)
double dxa_Vs_c1;
double dxa_Vb_c;
double dxa_Vb_b1;
double dxa_Vc3_c1;
double dxa_Vc3_c4;
double dxa_Vb1_b2;
double dxa_Vc4_c1;
double dxa_Vb1_e1;
double dxa_Vb2_e1;
double dxa_Vb2_c2;
double dxa_Vb2_c1;
double dxa_Vc1_c2;
double dxa_Vdt_GND;
#if defined(_DERIVATE2)
  double dxa_Vc1_c2_Vs_c1;
  double dxa_Vc1_c2_Vb_c;
  double dxa_Vc1_c2_Vb_b1;
  double dxa_Vc1_c2_Vc3_c1;
  double dxa_Vc1_c2_Vc3_c4;
  double dxa_Vc1_c2_Vb1_b2;
  double dxa_Vc1_c2_Vc4_c1;
  double dxa_Vc1_c2_Vb1_e1;
  double dxa_Vc1_c2_Vb2_e1;
  double dxa_Vc1_c2_Vb2_c2;
  double dxa_Vc1_c2_Vb2_c1;
  double dxa_Vc1_c2_Vc1_c2;
  double dxa_Vc1_c2_Vdt_GND;
  double dxa_Vb2_c1_Vs_c1;
  double dxa_Vb2_c1_Vb_c;
  double dxa_Vb2_c1_Vb_b1;
  double dxa_Vb2_c1_Vc3_c1;
  double dxa_Vb2_c1_Vc3_c4;
  double dxa_Vb2_c1_Vb1_b2;
  double dxa_Vb2_c1_Vc4_c1;
  double dxa_Vb2_c1_Vb1_e1;
  double dxa_Vb2_c1_Vb2_e1;
  double dxa_Vb2_c1_Vb2_c2;
  double dxa_Vb2_c1_Vb2_c1;
  double dxa_Vb2_c1_Vc1_c2;
  double dxa_Vb2_c1_Vdt_GND;
  double dxa_Vb2_c2_Vs_c1;
  double dxa_Vb2_c2_Vb_c;
  double dxa_Vb2_c2_Vb_b1;
  double dxa_Vb2_c2_Vc3_c1;
  double dxa_Vb2_c2_Vc3_c4;
  double dxa_Vb2_c2_Vb1_b2;
  double dxa_Vb2_c2_Vc4_c1;
  double dxa_Vb2_c2_Vb1_e1;
  double dxa_Vb2_c2_Vb2_e1;
  double dxa_Vb2_c2_Vb2_c2;
  double dxa_Vb2_c2_Vb2_c1;
  double dxa_Vb2_c2_Vc1_c2;
  double dxa_Vb2_c2_Vdt_GND;
  double dxa_Vb2_e1_Vs_c1;
  double dxa_Vb2_e1_Vb_c;
  double dxa_Vb2_e1_Vb_b1;
  double dxa_Vb2_e1_Vc3_c1;
  double dxa_Vb2_e1_Vc3_c4;
  double dxa_Vb2_e1_Vb1_b2;
  double dxa_Vb2_e1_Vc4_c1;
  double dxa_Vb2_e1_Vb1_e1;
  double dxa_Vb2_e1_Vb2_e1;
  double dxa_Vb2_e1_Vb2_c2;
  double dxa_Vb2_e1_Vb2_c1;
  double dxa_Vb2_e1_Vc1_c2;
  double dxa_Vb2_e1_Vdt_GND;
  double dxa_Vb1_e1_Vs_c1;
  double dxa_Vb1_e1_Vb_c;
  double dxa_Vb1_e1_Vb_b1;
  double dxa_Vb1_e1_Vc3_c1;
  double dxa_Vb1_e1_Vc3_c4;
  double dxa_Vb1_e1_Vb1_b2;
  double dxa_Vb1_e1_Vc4_c1;
  double dxa_Vb1_e1_Vb1_e1;
  double dxa_Vb1_e1_Vb2_e1;
  double dxa_Vb1_e1_Vb2_c2;
  double dxa_Vb1_e1_Vb2_c1;
  double dxa_Vb1_e1_Vc1_c2;
  double dxa_Vb1_e1_Vdt_GND;
  double dxa_Vc4_c1_Vs_c1;
  double dxa_Vc4_c1_Vb_c;
  double dxa_Vc4_c1_Vb_b1;
  double dxa_Vc4_c1_Vc3_c1;
  double dxa_Vc4_c1_Vc3_c4;
  double dxa_Vc4_c1_Vb1_b2;
  double dxa_Vc4_c1_Vc4_c1;
  double dxa_Vc4_c1_Vb1_e1;
  double dxa_Vc4_c1_Vb2_e1;
  double dxa_Vc4_c1_Vb2_c2;
  double dxa_Vc4_c1_Vb2_c1;
  double dxa_Vc4_c1_Vc1_c2;
  double dxa_Vc4_c1_Vdt_GND;
  double dxa_Vb1_b2_Vs_c1;
  double dxa_Vb1_b2_Vb_c;
  double dxa_Vb1_b2_Vb_b1;
  double dxa_Vb1_b2_Vc3_c1;
  double dxa_Vb1_b2_Vc3_c4;
  double dxa_Vb1_b2_Vb1_b2;
  double dxa_Vb1_b2_Vc4_c1;
  double dxa_Vb1_b2_Vb1_e1;
  double dxa_Vb1_b2_Vb2_e1;
  double dxa_Vb1_b2_Vb2_c2;
  double dxa_Vb1_b2_Vb2_c1;
  double dxa_Vb1_b2_Vc1_c2;
  double dxa_Vb1_b2_Vdt_GND;
  double dxa_Vc3_c1_Vs_c1;
  double dxa_Vc3_c1_Vb_c;
  double dxa_Vc3_c1_Vb_b1;
  double dxa_Vc3_c1_Vc3_c1;
  double dxa_Vc3_c1_Vc3_c4;
  double dxa_Vc3_c1_Vb1_b2;
  double dxa_Vc3_c1_Vc4_c1;
  double dxa_Vc3_c1_Vb1_e1;
  double dxa_Vc3_c1_Vb2_e1;
  double dxa_Vc3_c1_Vb2_c2;
  double dxa_Vc3_c1_Vb2_c1;
  double dxa_Vc3_c1_Vc1_c2;
  double dxa_Vc3_c1_Vdt_GND;
  double dxa_Vb_b1_Vs_c1;
  double dxa_Vb_b1_Vb_c;
  double dxa_Vb_b1_Vb_b1;
  double dxa_Vb_b1_Vc3_c1;
  double dxa_Vb_b1_Vc3_c4;
  double dxa_Vb_b1_Vb1_b2;
  double dxa_Vb_b1_Vc4_c1;
  double dxa_Vb_b1_Vb1_e1;
  double dxa_Vb_b1_Vb2_e1;
  double dxa_Vb_b1_Vb2_c2;
  double dxa_Vb_b1_Vb2_c1;
  double dxa_Vb_b1_Vc1_c2;
  double dxa_Vb_b1_Vdt_GND;
  double dxa_Vb_c_Vs_c1;
  double dxa_Vb_c_Vb_c;
  double dxa_Vb_c_Vb_b1;
  double dxa_Vb_c_Vc3_c1;
  double dxa_Vb_c_Vc3_c4;
  double dxa_Vb_c_Vb1_b2;
  double dxa_Vb_c_Vc4_c1;
  double dxa_Vb_c_Vb1_e1;
  double dxa_Vb_c_Vb2_e1;
  double dxa_Vb_c_Vb2_c2;
  double dxa_Vb_c_Vb2_c1;
  double dxa_Vb_c_Vc1_c2;
  double dxa_Vb_c_Vdt_GND;
  double dxa_Vs_c1_Vs_c1;
  double dxa_Vs_c1_Vb_c;
  double dxa_Vs_c1_Vb_b1;
  double dxa_Vs_c1_Vc3_c1;
  double dxa_Vs_c1_Vc3_c4;
  double dxa_Vs_c1_Vb1_b2;
  double dxa_Vs_c1_Vc4_c1;
  double dxa_Vs_c1_Vb1_e1;
  double dxa_Vs_c1_Vb2_e1;
  double dxa_Vs_c1_Vb2_c2;
  double dxa_Vs_c1_Vb2_c1;
  double dxa_Vs_c1_Vc1_c2;
  double dxa_Vs_c1_Vdt_GND;
#endif
#endif
double lntN;
#if defined(_DERIVATE)
double lntN_Vdt_GND;
#endif
double VdtINV;
#if defined(_DERIVATE)
double VdtINV_Vdt_GND;
#endif
double VtrINV;
double VtINV;
#if defined(_DERIVATE)
double VtINV_Vdt_GND;
#endif
double Vtr;
double Vt;
#if defined(_DERIVATE)
double Vt_Vdt_GND;
#endif
double tN;
#if defined(_DERIVATE)
double tN_Vdt_GND;
#endif
#if defined(_DERIVATE)
double Tk_Vdt_GND;
#endif
double Vdt;
#if defined(_DERIVATE)
double Vdt_Vdt_GND;
#endif
double Tki;
#if defined(_DERIVATE)
double Tki_Vdt_GND;
#endif
double inv_VDE;
double inv_VGZEB_Tr;
double VGZEB_Tr;
double VGZEBOK;
double _dxa;
double _a;
double _x0;
double _x;
double Tamb;
double Trk;
double pow2_PEm2;
double pow2_2mPE;
double SCRCV_M;
double invMULT;
#if defined(_DYNAMIC)
double CBCO_M;
#endif
#if defined(_DYNAMIC)
double CBEO_M;
#endif
#if defined(_DYNAMIC)
double CTH_M;
#endif
double Xext1;
double Bn;
double An;
double my_gmin;
if
((model->GMIN_Given))
{
my_gmin=pModel->GMIN;
EXIT_IF_ISNAN(pModel->GMIN)
}
else
{
my_gmin=_circuit_gmin;
EXIT_IF_ISNAN(_circuit_gmin)
}
{
if
((pModel->TYPE==1))
{
An=7.03e7;
EXIT_IF_ISNAN(7.03e7)
Bn=1.23e8;
EXIT_IF_ISNAN(1.23e8)
}
else
{
An=1.58e8;
EXIT_IF_ISNAN(1.58e8)
Bn=2.04e8;
EXIT_IF_ISNAN(2.04e8)
}
Xext1=(1.0-pModel->XEXT);
EXIT_IF_ISNAN((1.0-pModel->XEXT))
#if defined(_DYNAMIC)
CTH_M=(pModel->CTH*pModel->MULT);
EXIT_IF_ISNAN((pModel->CTH*pModel->MULT))
#endif
#if defined(_DYNAMIC)
CBEO_M=(pModel->CBEO*pModel->MULT);
EXIT_IF_ISNAN((pModel->CBEO*pModel->MULT))
#endif
#if defined(_DYNAMIC)
CBCO_M=(pModel->CBCO*pModel->MULT);
EXIT_IF_ISNAN((pModel->CBCO*pModel->MULT))
#endif
invMULT=(1.0/pModel->MULT);
EXIT_IF_ISNAN((1.0/pModel->MULT))
SCRCV_M=(pModel->SCRCV*invMULT);
EXIT_IF_ISNAN((pModel->SCRCV*invMULT))
{
double m00_pow(d00_pow0,pModel->MULT,(1.0-pModel->AF))
pInst->KF_M=(pModel->KF*d00_pow0);
EXIT_IF_ISNAN((pModel->KF*d00_pow0))
}
{
double m00_pow(d00_pow0,pModel->MULT,(1.0-((2.0*(pModel->MLF-1.0))+(pModel->AF*(2.0-pModel->MLF)))))
pInst->KFN_M=(pModel->KFN*d00_pow0);
EXIT_IF_ISNAN((pModel->KFN*d00_pow0))
}
{
double m00_pow(d00_pow0,2.0,(2.0-pModel->PE))
pow2_2mPE=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
pow2_PEm2=(1.0/pow2_2mPE);
EXIT_IF_ISNAN((1.0/pow2_2mPE))
Trk=(pModel->TREF+273.15);
EXIT_IF_ISNAN((pModel->TREF+273.15))
Tamb=(mint_get_circuit_tempK()+pModel->DTA);
EXIT_IF_ISNAN((mint_get_circuit_tempK()+pModel->DTA))
_x=(pModel->VGZEB+(((pModel->AVGEB*Trk)*Trk)/(Trk+pModel->TVGEB)));
EXIT_IF_ISNAN((pModel->VGZEB+(((pModel->AVGEB*Trk)*Trk)/(Trk+pModel->TVGEB))))
_x0=0.05;
EXIT_IF_ISNAN(0.05)
_a=0.1;
EXIT_IF_ISNAN(0.1)
_dxa=((_x-_x0)/_a);
EXIT_IF_ISNAN(((_x-_x0)/_a))
if
((_x<_x0))
{
{
double m00_exp(d00_exp0,_dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
VGZEBOK=(_x0+(_a*d00_logE1));
EXIT_IF_ISNAN((_x0+(_a*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-_dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
VGZEBOK=(_x+(_a*d00_logE1));
EXIT_IF_ISNAN((_x+(_a*d00_logE1)))
}
}
VGZEB_Tr=pModel->VGZEB;
EXIT_IF_ISNAN(pModel->VGZEB)
inv_VGZEB_Tr=(1.0/VGZEB_Tr);
EXIT_IF_ISNAN((1.0/VGZEB_Tr))
inv_VDE=(1.0/pModel->VDE);
EXIT_IF_ISNAN((1.0/pModel->VDE))
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
Tki_Vdt_GND=1.0;
#endif
Tki=NP(dt);
EXIT_IF_ISNAN(NP(dt))
if
((Tki<0.0))
{
{
double m00_logE(d00_logE0,(1.0-Tki))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(1.0-Tki))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
Tki_Vdt_GND=(-(-Tki_Vdt_GND)*d10_logE0);
#endif
Tki=(-d00_logE0);
EXIT_IF_ISNAN((-d00_logE0))
}
}
if
((Tki<200.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND)V(b1,GND)V(s,GND) */
Vdt_Vdt_GND=Tki_Vdt_GND;
#endif
Vdt=Tki;
EXIT_IF_ISNAN(Tki)
}
else
{
{
double m00_logE(d00_logE0,(1.0+(Tki-200.0)))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(1.0+(Tki-200.0)))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND)V(b1,GND)V(s,GND) */
Vdt_Vdt_GND=Tki_Vdt_GND*d10_logE0;
#endif
Vdt=(200.0+d00_logE0);
EXIT_IF_ISNAN((200.0+d00_logE0))
}
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND)V(b1,GND)V(s,GND) */
Vdt_Vdt_GND=Vdt_Vdt_GND;
#endif
Vdt=Vdt;
EXIT_IF_ISNAN(Vdt)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
Tk_Vdt_GND=Vdt_Vdt_GND;
#endif
pInst->Tk=(Tamb+Vdt);
EXIT_IF_ISNAN((Tamb+Vdt))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(c1,GND)V(b,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
tN_Vdt_GND=(Tk_Vdt_GND/Trk);
#endif
tN=(pInst->Tk/Trk);
EXIT_IF_ISNAN((pInst->Tk/Trk))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b,GND)V(b1,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vt_Vdt_GND=(8.61708691805812512584e-5*Tk_Vdt_GND);
#endif
Vt=(8.61708691805812512584e-5*pInst->Tk);
EXIT_IF_ISNAN((8.61708691805812512584e-5*pInst->Tk))
Vtr=(8.61708691805812512584e-5*Trk);
EXIT_IF_ISNAN((8.61708691805812512584e-5*Trk))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b1,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
VtINV_Vdt_GND=(-Vt_Vdt_GND/Vt/Vt);
#endif
VtINV=(1.0/Vt);
EXIT_IF_ISNAN((1.0/Vt))
VtrINV=(1.0/Vtr);
EXIT_IF_ISNAN((1.0/Vtr))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND)V(s,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
VdtINV_Vdt_GND=VtINV_Vdt_GND;
#endif
VdtINV=(VtINV-VtrINV);
EXIT_IF_ISNAN((VtINV-VtrINV))
{
double m00_logE(d00_logE0,tN)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,tN)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
lntN_Vdt_GND=tN_Vdt_GND*d10_logE0;
#endif
lntN=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=((-(((((pModel->AVGEB*Tk_Vdt_GND)*pInst->Tk)+((pModel->AVGEB*pInst->Tk)*Tk_Vdt_GND))*(pInst->Tk+pModel->TVGEB)-((pModel->AVGEB*pInst->Tk)*pInst->Tk)*Tk_Vdt_GND)/(pInst->Tk+pModel->TVGEB)/(pInst->Tk+pModel->TVGEB)))/0.1);
#endif
#endif
dxa=(((VGZEBOK-(((pModel->AVGEB*pInst->Tk)*pInst->Tk)/(pInst->Tk+pModel->TVGEB)))-0.05)/0.1);
EXIT_IF_ISNAN((((VGZEBOK-(((pModel->AVGEB*pInst->Tk)*pInst->Tk)/(pInst->Tk+pModel->TVGEB)))-0.05)/0.1))
if
(((VGZEBOK-(((pModel->AVGEB*pInst->Tk)*pInst->Tk)/(pInst->Tk+pModel->TVGEB)))<0.05))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
VGZEB_T_Vdt_GND=(0.1*dxa_Vdt_GND*d10_exp0*d10_logE1);
#endif
VGZEB_T=(0.05+(0.1*d00_logE1));
EXIT_IF_ISNAN((0.05+(0.1*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
VGZEB_T_Vdt_GND=((-(((((pModel->AVGEB*Tk_Vdt_GND)*pInst->Tk)+((pModel->AVGEB*pInst->Tk)*Tk_Vdt_GND))*(pInst->Tk+pModel->TVGEB)-((pModel->AVGEB*pInst->Tk)*pInst->Tk)*Tk_Vdt_GND)/(pInst->Tk+pModel->TVGEB)/(pInst->Tk+pModel->TVGEB)))+(0.1*(-dxa_Vdt_GND)*d10_exp0*d10_logE1));
#endif
VGZEB_T=((VGZEBOK-(((pModel->AVGEB*pInst->Tk)*pInst->Tk)/(pInst->Tk+pModel->TVGEB)))+(0.1*d00_logE1));
EXIT_IF_ISNAN(((VGZEBOK-(((pModel->AVGEB*pInst->Tk)*pInst->Tk)/(pInst->Tk+pModel->TVGEB)))+(0.1*d00_logE1)))
}
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
VGZEB_T_Vdt_GND=VGZEB_T_Vdt_GND;
#endif
VGZEB_T=VGZEB_T;
EXIT_IF_ISNAN(VGZEB_T)
{
double m00_logE(d00_logE0,tN)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,tN)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(b,GND)V(c1,GND)V(c2,GND)V(b2,GND)V(s,GND)V(b1,GND) */
UdeT_Vdt_GND=((((((-3.0)*Vt_Vdt_GND)*d00_logE0)+(((-3.0)*Vt)*tN_Vdt_GND*d10_logE0))+(pModel->VDE*tN_Vdt_GND))+(-tN_Vdt_GND)*pModel->VGB);
#endif
UdeT=(((((-3.0)*Vt)*d00_logE0)+(pModel->VDE*tN))+((1.0-tN)*pModel->VGB));
EXIT_IF_ISNAN((((((-3.0)*Vt)*d00_logE0)+(pModel->VDE*tN))+((1.0-tN)*pModel->VGB)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-UdeT_Vdt_GND)*Vt-(0.05-UdeT)*Vt_Vdt_GND)/Vt/Vt);
#endif
#endif
dxa=((0.05-UdeT)/Vt);
EXIT_IF_ISNAN(((0.05-UdeT)/Vt))
if
((0.05<UdeT))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b,GND)V(e1,GND) */
VDE_T_Vdt_GND=(UdeT_Vdt_GND+((Vt_Vdt_GND*d00_logE1)+(Vt*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
VDE_T=(UdeT+(Vt*d00_logE1));
EXIT_IF_ISNAN((UdeT+(Vt*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b,GND)V(e1,GND) */
VDE_T_Vdt_GND=((Vt_Vdt_GND*d00_logE1)+(Vt*(-dxa_Vdt_GND)*d10_exp0*d10_logE1));
#endif
VDE_T=(0.05+(Vt*d00_logE1));
EXIT_IF_ISNAN((0.05+(Vt*d00_logE1)))
}
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b,GND)V(e1,GND) */
VDE_T_Vdt_GND=VDE_T_Vdt_GND;
#endif
VDE_T=VDE_T;
EXIT_IF_ISNAN(VDE_T)
{
double m00_logE(d00_logE0,tN)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,tN)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(s,GND)V(c1,GND) */
UdcT_Vdt_GND=((((((-3.0)*Vt_Vdt_GND)*d00_logE0)+(((-3.0)*Vt)*tN_Vdt_GND*d10_logE0))+(pModel->VDC*tN_Vdt_GND))+(-tN_Vdt_GND)*pModel->VGC);
#endif
UdcT=(((((-3.0)*Vt)*d00_logE0)+(pModel->VDC*tN))+((1.0-tN)*pModel->VGC));
EXIT_IF_ISNAN((((((-3.0)*Vt)*d00_logE0)+(pModel->VDC*tN))+((1.0-tN)*pModel->VGC)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-UdcT_Vdt_GND)*Vt-(0.05-UdcT)*Vt_Vdt_GND)/Vt/Vt);
#endif
#endif
dxa=((0.05-UdcT)/Vt);
EXIT_IF_ISNAN(((0.05-UdcT)/Vt))
if
((0.05<UdcT))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(s,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
VDC_T_Vdt_GND=(UdcT_Vdt_GND+((Vt_Vdt_GND*d00_logE1)+(Vt*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
VDC_T=(UdcT+(Vt*d00_logE1));
EXIT_IF_ISNAN((UdcT+(Vt*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(s,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
VDC_T_Vdt_GND=((Vt_Vdt_GND*d00_logE1)+(Vt*(-dxa_Vdt_GND)*d10_exp0*d10_logE1));
#endif
VDC_T=(0.05+(Vt*d00_logE1));
EXIT_IF_ISNAN((0.05+(Vt*d00_logE1)))
}
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(s,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
VDC_T_Vdt_GND=VDC_T_Vdt_GND;
#endif
VDC_T=VDC_T;
EXIT_IF_ISNAN(VDC_T)
{
double m00_logE(d00_logE0,tN)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,tN)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(c1,GND)V(s,GND) */
UdsT_Vdt_GND=((((((-3.0)*Vt_Vdt_GND)*d00_logE0)+(((-3.0)*Vt)*tN_Vdt_GND*d10_logE0))+(pModel->VDS*tN_Vdt_GND))+(-tN_Vdt_GND)*pModel->VGS);
#endif
UdsT=(((((-3.0)*Vt)*d00_logE0)+(pModel->VDS*tN))+((1.0-tN)*pModel->VGS));
EXIT_IF_ISNAN((((((-3.0)*Vt)*d00_logE0)+(pModel->VDS*tN))+((1.0-tN)*pModel->VGS)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-UdsT_Vdt_GND)*Vt-(0.05-UdsT)*Vt_Vdt_GND)/Vt/Vt);
#endif
#endif
dxa=((0.05-UdsT)/Vt);
EXIT_IF_ISNAN(((0.05-UdsT)/Vt))
#ifdef _DYNAMIC
if
((0.05<UdsT))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
VDS_T_Vdt_GND=(UdsT_Vdt_GND+((Vt_Vdt_GND*d00_logE1)+(Vt*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
VDS_T=(UdsT+(Vt*d00_logE1));
EXIT_IF_ISNAN((UdsT+(Vt*d00_logE1)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
VDS_T_Vdt_GND=((Vt_Vdt_GND*d00_logE1)+(Vt*(-dxa_Vdt_GND)*d10_exp0*d10_logE1));
#endif
VDS_T=(0.05+(Vt*d00_logE1));
EXIT_IF_ISNAN((0.05+(Vt*d00_logE1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
VDS_T_Vdt_GND=VDS_T_Vdt_GND;
#endif
VDS_T=VDS_T;
EXIT_IF_ISNAN(VDS_T)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
inv_VDE_T_Vdt_GND=(-VDE_T_Vdt_GND/VDE_T/VDE_T);
#endif
inv_VDE_T=(1.0/VDE_T);
EXIT_IF_ISNAN((1.0/VDE_T))
{
double m00_pow(d00_pow0,(pModel->VDE*inv_VDE_T),pModel->PE)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(pModel->VDE*inv_VDE_T),pModel->PE)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
CJE_T_div_CJE_Vdt_GND=(d10_pow0*(pModel->VDE*inv_VDE_T_Vdt_GND));
#endif
CJE_T_div_CJE=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
CJE_T_Vdt_GND=(pModel->CJE*CJE_T_div_CJE_Vdt_GND);
#endif
CJE_T=(pModel->CJE*CJE_T_div_CJE);
EXIT_IF_ISNAN((pModel->CJE*CJE_T_div_CJE))
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(pModel->VDS/VDS_T),pModel->PS)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(pModel->VDS/VDS_T),pModel->PS)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
CJS_T_Vdt_GND=(pModel->CJS*(d10_pow0*(-pModel->VDS*VDS_T_Vdt_GND/VDS_T/VDS_T)));
#endif
CJS_T=(pModel->CJS*d00_pow0);
EXIT_IF_ISNAN((pModel->CJS*d00_pow0))
}
#endif
{
double m00_pow(d00_pow0,(pModel->VDC/VDC_T),pModel->PC)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(pModel->VDC/VDC_T),pModel->PC)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
CJCscale_Vdt_GND=((1.0-pModel->XP)*(d10_pow0*(-pModel->VDC*VDC_T_Vdt_GND/VDC_T/VDC_T)));
#endif
CJCscale=(((1.0-pModel->XP)*d00_pow0)+pModel->XP);
EXIT_IF_ISNAN((((1.0-pModel->XP)*d00_pow0)+pModel->XP))
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
CJCscaleINV_Vdt_GND=(-CJCscale_Vdt_GND/CJCscale/CJCscale);
#endif
CJCscaleINV=(1.0/CJCscale);
EXIT_IF_ISNAN((1.0/CJCscale))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(c1,GND) */
CJC_T_Vdt_GND=(pModel->CJC*CJCscale_Vdt_GND);
#endif
CJC_T=(pModel->CJC*CJCscale);
EXIT_IF_ISNAN((pModel->CJC*CJCscale))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
XP_T_Vdt_GND=(pModel->XP*CJCscaleINV_Vdt_GND);
#endif
XP_T=(pModel->XP*CJCscaleINV);
EXIT_IF_ISNAN((pModel->XP*CJCscaleINV))
{
double m00_exp(d00_exp0,(lntN*pModel->AE))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
RE_T_Vdt_GND=(pModel->RE*lntN_Vdt_GND*pModel->AE*d10_exp0);
#endif
RE_T=(pModel->RE*d00_exp0);
EXIT_IF_ISNAN((pModel->RE*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*(pModel->AB-pModel->AQBO)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
RBV_T_Vdt_GND=(pModel->RBV*lntN_Vdt_GND*(pModel->AB-pModel->AQBO)*d10_exp0);
#endif
RBV_T=(pModel->RBV*d00_exp0);
EXIT_IF_ISNAN((pModel->RBV*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->AEX))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
RBC_T_Vdt_GND=(pModel->RBC*lntN_Vdt_GND*pModel->AEX*d10_exp0);
#endif
RBC_T=(pModel->RBC*d00_exp0);
EXIT_IF_ISNAN((pModel->RBC*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->AC))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
RCCxx_T_Vdt_GND=(pModel->RCC*lntN_Vdt_GND*pModel->AC*d10_exp0);
#endif
RCCxx_T=(pModel->RCC*d00_exp0);
EXIT_IF_ISNAN((pModel->RCC*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->ACBL))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
RCCex_T_Vdt_GND=(pModel->RCBLX*lntN_Vdt_GND*pModel->ACBL*d10_exp0);
#endif
RCCex_T=(pModel->RCBLX*d00_exp0);
EXIT_IF_ISNAN((pModel->RCBLX*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->ACBL))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
RCCin_T_Vdt_GND=(pModel->RCBLI*lntN_Vdt_GND*pModel->ACBL*d10_exp0);
#endif
RCCin_T=(pModel->RCBLI*d00_exp0);
EXIT_IF_ISNAN((pModel->RCBLI*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->AEPI))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
RCV_T_Vdt_GND=(pModel->RCV*lntN_Vdt_GND*pModel->AEPI*d10_exp0);
#endif
RCV_T=(pModel->RCV*d00_exp0);
EXIT_IF_ISNAN((pModel->RCV*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*((pModel->AE-pModel->AB)-pModel->AQBO)))
double m00_exp(d00_exp1,((-pModel->DVGBF)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
BF_T_Vdt_GND=(((pModel->BF*lntN_Vdt_GND*((pModel->AE-pModel->AB)-pModel->AQBO)*d10_exp0)*d00_exp1)+((pModel->BF*d00_exp0)*((-pModel->DVGBF)*VdtINV_Vdt_GND)*d10_exp1));
#endif
BF_T=((pModel->BF*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->BF*d00_exp0)*d00_exp1))
}
{
double m00_exp(d00_exp0,((-pModel->DVGBR)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
BRI_T_Vdt_GND=(pModel->BRI*((-pModel->DVGBR)*VdtINV_Vdt_GND)*d10_exp0);
#endif
BRI_T=(pModel->BRI*d00_exp0);
EXIT_IF_ISNAN((pModel->BRI*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*(((4.0-pModel->AB)-pModel->AQBO)+pModel->DAIS)))
double m00_exp(d00_exp1,((-pModel->VGB)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
IS_T_Vdt_GND=(((pModel->IS*lntN_Vdt_GND*(((4.0-pModel->AB)-pModel->AQBO)+pModel->DAIS)*d10_exp0)*d00_exp1)+((pModel->IS*d00_exp0)*((-pModel->VGB)*VdtINV_Vdt_GND)*d10_exp1));
#endif
IS_T=((pModel->IS*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->IS*d00_exp0)*d00_exp1))
}
{
double m00_exp(d00_exp0,(lntN*(1.0-pModel->AB)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
IK_T_Vdt_GND=(pModel->IK*lntN_Vdt_GND*(1.0-pModel->AB)*d10_exp0);
#endif
IK_T=(pModel->IK*d00_exp0);
EXIT_IF_ISNAN((pModel->IK*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*(6.0-(2.0*pModel->MLF))))
double m00_exp(d00_exp1,(((-pModel->VGJ)*VdtINV)/pModel->MLF))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND) */
IBF_T_Vdt_GND=(((pModel->IBF*lntN_Vdt_GND*(6.0-(2.0*pModel->MLF))*d10_exp0)*d00_exp1)+((pModel->IBF*d00_exp0)*(((-pModel->VGJ)*VdtINV_Vdt_GND)/pModel->MLF)*d10_exp1));
#endif
IBF_T=((pModel->IBF*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->IBF*d00_exp0)*d00_exp1))
}
{
double m00_exp(d00_exp0,(((-pModel->VGC)*VdtINV)/2.0))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
IBR_T_Vdt_GND=(((((pModel->IBR*tN_Vdt_GND)*tN)+((pModel->IBR*tN)*tN_Vdt_GND))*d00_exp0)+(((pModel->IBR*tN)*tN)*(((-pModel->VGC)*VdtINV_Vdt_GND)/2.0)*d10_exp0));
#endif
IBR_T=(((pModel->IBR*tN)*tN)*d00_exp0);
EXIT_IF_ISNAN((((pModel->IBR*tN)*tN)*d00_exp0))
}
{
double m00_pow(d00_pow0,(VGZEB_T*inv_VGZEB_Tr),(-0.5))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(VGZEB_T*inv_VGZEB_Tr),(-0.5))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
x_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  x_Vb2_e1_Vb2_e1=0.0;
  x_Vb2_e1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
x_Vdt_GND=(d10_pow0*VGZEB_T_Vdt_GND*inv_VGZEB_Tr);
#endif
#endif
x=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
y_Vdt_GND=(-CJE_T_div_CJE_Vdt_GND/CJE_T_div_CJE/CJE_T_div_CJE);
#endif
y=(1.0/CJE_T_div_CJE);
EXIT_IF_ISNAN((1.0/CJE_T_div_CJE))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
nZEB_T_Vdt_GND=(((((((((pModel->NZEB*VGZEB_T_Vdt_GND)*VGZEB_T)+((pModel->NZEB*VGZEB_T)*VGZEB_T_Vdt_GND))*x)+(((pModel->NZEB*VGZEB_T)*VGZEB_T)*x_Vdt_GND))*y)+((((pModel->NZEB*VGZEB_T)*VGZEB_T)*x)*y_Vdt_GND))*pModel->VDE*inv_VDE_T)+((((((pModel->NZEB*VGZEB_T)*VGZEB_T)*x)*y)*pModel->VDE)*inv_VDE_T_Vdt_GND))*inv_VGZEB_Tr*inv_VGZEB_Tr;
#endif
nZEB_T=((((((((pModel->NZEB*VGZEB_T)*VGZEB_T)*x)*y)*pModel->VDE)*inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr);
EXIT_IF_ISNAN(((((((((pModel->NZEB*VGZEB_T)*VGZEB_T)*x)*y)*pModel->VDE)*inv_VDE_T)*inv_VGZEB_Tr)*inv_VGZEB_Tr))
{
double m00_exp(d00_exp0,(pModel->NZEB-nZEB_T))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
IZEB_T_Vdt_GND=(((((((((pModel->IZEB*x_Vdt_GND)*VDE_T)+((pModel->IZEB*x)*VDE_T_Vdt_GND))*VDE_T)+(((pModel->IZEB*x)*VDE_T)*VDE_T_Vdt_GND))*inv_VDE*inv_VDE*CJE_T_div_CJE)+((((((pModel->IZEB*x)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE_Vdt_GND))*d00_exp0)+(((((((pModel->IZEB*x)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*(-nZEB_T_Vdt_GND)*d10_exp0));
#endif
IZEB_T=(((((((pModel->IZEB*x)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*d00_exp0);
EXIT_IF_ISNAN((((((((pModel->IZEB*x)*VDE_T)*VDE_T)*inv_VDE)*inv_VDE)*CJE_T_div_CJE)*d00_exp0))
}
{
double m00_exp(d00_exp0,(lntN*pModel->AQBO))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
x_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  x_Vb2_e1_Vb2_e1=0.0;
  x_Vb2_e1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
x_Vdt_GND=lntN_Vdt_GND*pModel->AQBO*d10_exp0;
#endif
#endif
x=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
VEF_T_Vdt_GND=(((pModel->VEF*x_Vdt_GND)*CJCscaleINV)+((pModel->VEF*x)*CJCscaleINV_Vdt_GND));
#endif
VEF_T=((pModel->VEF*x)*CJCscaleINV);
EXIT_IF_ISNAN(((pModel->VEF*x)*CJCscaleINV))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
VER_T_Vdt_GND=(((pModel->VER*x_Vdt_GND)*y)+((pModel->VER*x)*y_Vdt_GND));
#endif
VER_T=((pModel->VER*x)*y);
EXIT_IF_ISNAN(((pModel->VER*x)*y))
{
double m00_exp(d00_exp0,(lntN*(4.0-pModel->AS)))
double m00_exp(d00_exp1,((-pModel->VGS)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND)V(b,GND)V(s,GND)V(b1,GND) */
ISS_T_Vdt_GND=(((pModel->ISS*lntN_Vdt_GND*(4.0-pModel->AS)*d10_exp0)*d00_exp1)+((pModel->ISS*d00_exp0)*((-pModel->VGS)*VdtINV_Vdt_GND)*d10_exp1));
#endif
ISS_T=((pModel->ISS*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->ISS*d00_exp0)*d00_exp1))
}
{
double m00_exp(d00_exp0,(lntN*(3.5-(0.5*pModel->ASUB))))
double m00_exp(d00_exp1,((-pModel->VGS)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
ICSS_T_Vdt_GND=(((pModel->ICSS*lntN_Vdt_GND*(3.5-(0.5*pModel->ASUB))*d10_exp0)*d00_exp1)+((pModel->ICSS*d00_exp0)*((-pModel->VGS)*VdtINV_Vdt_GND)*d10_exp1));
#endif
ICSS_T=((pModel->ICSS*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->ICSS*d00_exp0)*d00_exp1))
}
if
((ISS_T>0.0))
{
{
double m00_exp(d00_exp0,(lntN*(1.0-pModel->AS)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND) */
IKS_T_Vdt_GND=(((((pModel->IKS*lntN_Vdt_GND*(1.0-pModel->AS)*d10_exp0)*(IS_T/pModel->IS))+((pModel->IKS*d00_exp0)*(IS_T_Vdt_GND/pModel->IS)))*(pModel->ISS/ISS_T))+(((pModel->IKS*d00_exp0)*(IS_T/pModel->IS))*(-pModel->ISS*ISS_T_Vdt_GND/ISS_T/ISS_T)));
#endif
IKS_T=(((pModel->IKS*d00_exp0)*(IS_T/pModel->IS))*(pModel->ISS/ISS_T));
EXIT_IF_ISNAN((((pModel->IKS*d00_exp0)*(IS_T/pModel->IS))*(pModel->ISS/ISS_T)))
}
}
else
{
{
double m00_exp(d00_exp0,(lntN*(1.0-pModel->AS)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND) */
IKS_T_Vdt_GND=(pModel->IKS*lntN_Vdt_GND*(1.0-pModel->AS)*d10_exp0);
#endif
IKS_T=(pModel->IKS*d00_exp0);
EXIT_IF_ISNAN((pModel->IKS*d00_exp0))
}
}
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(lntN*(pModel->AB-2.0)))
double m00_exp(d00_exp1,((-pModel->DVGTE)*VdtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
TAUE_T_Vdt_GND=(((pModel->TAUE*lntN_Vdt_GND*(pModel->AB-2.0)*d10_exp0)*d00_exp1)+((pModel->TAUE*d00_exp0)*((-pModel->DVGTE)*VdtINV_Vdt_GND)*d10_exp1));
#endif
TAUE_T=((pModel->TAUE*d00_exp0)*d00_exp1);
EXIT_IF_ISNAN(((pModel->TAUE*d00_exp0)*d00_exp1))
}
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(lntN*((pModel->AQBO+pModel->AB)-1.0)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
TAUB_T_Vdt_GND=(pModel->TAUB*lntN_Vdt_GND*((pModel->AQBO+pModel->AB)-1.0)*d10_exp0);
#endif
pInst->TAUB_T=(pModel->TAUB*d00_exp0);
EXIT_IF_ISNAN((pModel->TAUB*d00_exp0))
}
#endif
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(lntN*(pModel->AEPI-1.0)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
TEPI_T_Vdt_GND=(pModel->TEPI*lntN_Vdt_GND*(pModel->AEPI-1.0)*d10_exp0);
#endif
TEPI_T=(pModel->TEPI*d00_exp0);
EXIT_IF_ISNAN((pModel->TEPI*d00_exp0))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
TAUR_T_Vdt_GND=((pModel->TAUR*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND))/(pModel->TAUB+pModel->TEPI));
#endif
TAUR_T=((pModel->TAUR*(pInst->TAUB_T+TEPI_T))/(pModel->TAUB+pModel->TEPI));
EXIT_IF_ISNAN(((pModel->TAUR*(pInst->TAUB_T+TEPI_T))/(pModel->TAUB+pModel->TEPI)))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
Tk300_Vdt_GND=Tk_Vdt_GND;
#endif
Tk300=(pInst->Tk-300.0);
EXIT_IF_ISNAN((pInst->Tk-300.0))
if
((pInst->Tk<525.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
BnT_Vdt_GND=(Bn*((7.2e-4*Tk300_Vdt_GND)-(((1.6e-6*Tk300_Vdt_GND)*Tk300)+((1.6e-6*Tk300)*Tk300_Vdt_GND))));
#endif
BnT=(Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300)));
EXIT_IF_ISNAN((Bn*((1.0+(7.2e-4*Tk300))-((1.6e-6*Tk300)*Tk300))))
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
BnT_Vdt_GND=0.0;
#endif
BnT=(Bn*1.081);
EXIT_IF_ISNAN((Bn*1.081))
}
{
double m00_exp(d00_exp0,(lntN*pModel->AQBO))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND) */
DEG_T_Vdt_GND=(pModel->DEG*lntN_Vdt_GND*pModel->AQBO*d10_exp0);
#endif
DEG_T=(pModel->DEG*d00_exp0);
EXIT_IF_ISNAN((pModel->DEG*d00_exp0))
}
{
double m00_pow(d00_pow0,(Tamb/Trk),pModel->ATH)
RTH_Tamb=(pModel->RTH*d00_pow0);
EXIT_IF_ISNAN((pModel->RTH*d00_pow0))
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND)V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
IS_TM_Vdt_GND=IS_T_Vdt_GND*pModel->MULT;
#endif
IS_TM=(IS_T*pModel->MULT);
EXIT_IF_ISNAN((IS_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(b1,GND)V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
IK_TM_Vdt_GND=IK_T_Vdt_GND*pModel->MULT;
#endif
IK_TM=(IK_T*pModel->MULT);
EXIT_IF_ISNAN((IK_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND) */
IBF_TM_Vdt_GND=IBF_T_Vdt_GND*pModel->MULT;
#endif
IBF_TM=(IBF_T*pModel->MULT);
EXIT_IF_ISNAN((IBF_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
IBR_TM_Vdt_GND=IBR_T_Vdt_GND*pModel->MULT;
#endif
IBR_TM=(IBR_T*pModel->MULT);
EXIT_IF_ISNAN((IBR_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
IZEB_TM_Vdt_GND=IZEB_T_Vdt_GND*pModel->MULT;
#endif
IZEB_TM=(IZEB_T*pModel->MULT);
EXIT_IF_ISNAN((IZEB_T*pModel->MULT))
IHC_M=(pModel->IHC*pModel->MULT);
EXIT_IF_ISNAN((pModel->IHC*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
ISS_TM_Vdt_GND=ISS_T_Vdt_GND*pModel->MULT;
#endif
ISS_TM=(ISS_T*pModel->MULT);
EXIT_IF_ISNAN((ISS_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
ICSS_TM_Vdt_GND=ICSS_T_Vdt_GND*pModel->MULT;
#endif
ICSS_TM=(ICSS_T*pModel->MULT);
EXIT_IF_ISNAN((ICSS_T*pModel->MULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND) */
IKS_TM_Vdt_GND=IKS_T_Vdt_GND*pModel->MULT;
#endif
IKS_TM=(IKS_T*pModel->MULT);
EXIT_IF_ISNAN((IKS_T*pModel->MULT))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
CJE_TM_Vdt_GND=CJE_T_Vdt_GND*pModel->MULT;
#endif
CJE_TM=(CJE_T*pModel->MULT);
EXIT_IF_ISNAN((CJE_T*pModel->MULT))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
CJC_TM_Vdt_GND=CJC_T_Vdt_GND*pModel->MULT;
#endif
CJC_TM=(CJC_T*pModel->MULT);
EXIT_IF_ISNAN((CJC_T*pModel->MULT))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
CJS_TM_Vdt_GND=CJS_T_Vdt_GND*pModel->MULT;
#endif
CJS_TM=(CJS_T*pModel->MULT);
EXIT_IF_ISNAN((CJS_T*pModel->MULT))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
RE_TM_Vdt_GND=RE_T_Vdt_GND*invMULT;
#endif
pInst->RE_TM=(RE_T*invMULT);
EXIT_IF_ISNAN((RE_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
RBC_TM_Vdt_GND=RBC_T_Vdt_GND*invMULT;
#endif
pInst->RBC_TM=(RBC_T*invMULT);
EXIT_IF_ISNAN((RBC_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
RBV_TM_Vdt_GND=RBV_T_Vdt_GND*invMULT;
#endif
RBV_TM=(RBV_T*invMULT);
EXIT_IF_ISNAN((RBV_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
RCCxx_TM_Vdt_GND=RCCxx_T_Vdt_GND*invMULT;
#endif
RCCxx_TM=(RCCxx_T*invMULT);
EXIT_IF_ISNAN((RCCxx_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
RCCex_TM_Vdt_GND=RCCex_T_Vdt_GND*invMULT;
#endif
RCCex_TM=(RCCex_T*invMULT);
EXIT_IF_ISNAN((RCCex_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
RCCin_TM_Vdt_GND=RCCin_T_Vdt_GND*invMULT;
#endif
RCCin_TM=(RCCin_T*invMULT);
EXIT_IF_ISNAN((RCCin_T*invMULT))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(c1,GND) */
RCV_TM_Vdt_GND=RCV_T_Vdt_GND*invMULT;
#endif
RCV_TM=(RCV_T*invMULT);
EXIT_IF_ISNAN((RCV_T*invMULT))
if
((pModel->RCC>0.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCxx_TM_Vdt_GND=(-RCCxx_TM_Vdt_GND/RCCxx_TM/RCCxx_TM);
#endif
pInst->GCCxx_TM=(1.0/RCCxx_TM);
EXIT_IF_ISNAN((1.0/RCCxx_TM))
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCxx_TM_Vdt_GND=0.0;
#endif
pInst->GCCxx_TM=0;
EXIT_IF_ISNAN(0)
}
if
((pModel->RCBLX>0.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCex_TM_Vdt_GND=(-RCCex_TM_Vdt_GND/RCCex_TM/RCCex_TM);
#endif
pInst->GCCex_TM=(1.0/RCCex_TM);
EXIT_IF_ISNAN((1.0/RCCex_TM))
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCex_TM_Vdt_GND=0.0;
#endif
pInst->GCCex_TM=0;
EXIT_IF_ISNAN(0)
}
if
((pModel->RCBLI>0.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCin_TM_Vdt_GND=(-RCCin_TM_Vdt_GND/RCCin_TM/RCCin_TM);
#endif
pInst->GCCin_TM=(1.0/RCCin_TM);
EXIT_IF_ISNAN((1.0/RCCin_TM))
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
GCCin_TM_Vdt_GND=0.0;
#endif
pInst->GCCin_TM=0;
EXIT_IF_ISNAN(0)
}
RTH_Tamb_M=(RTH_Tamb*invMULT);
EXIT_IF_ISNAN((RTH_Tamb*invMULT))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(b,GND)V(e1,GND)V(c2,GND)V(c1,GND) */
Vb2c1_Vb2_c1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vb2c1_Vb2_c1_Vb2_c1=(+0.0*(NP(b2)-NP(c1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vb2c1=(pModel->TYPE*(NP(b2)-NP(c1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b2)-NP(c1))))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
Vb2c2_Vb2_c2=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vb2c2_Vb2_c2_Vb2_c2=(+0.0*(NP(b2)-NP(c2))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vb2c2=(pModel->TYPE*(NP(b2)-NP(c2)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b2)-NP(c2))))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1) ddxprobe=V(s,GND)V(b,GND)V(b1,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
Vb2e1_Vb2_e1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vb2e1_Vb2_e1_Vb2_e1=(+0.0*(NP(b2)-NP(e1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vb2e1=(pModel->TYPE*(NP(b2)-NP(e1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b2)-NP(e1))))
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1) ddxprobe=V(s,GND)V(b,GND)V(c2,GND)V(b2,GND)V(b1,GND)V(e1,GND) */
Vb1e1_Vb1_e1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vb1e1_Vb1_e1_Vb1_e1=(+0.0*(NP(b1)-NP(e1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vb1e1=(pModel->TYPE*(NP(b1)-NP(e1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b1)-NP(e1))))
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2) ddxprobe=V(b1,GND)V(b,GND)V(s,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
Vb1b2_Vb1_b2=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vb1b2_Vb1_b2_Vb1_b2=(+0.0*(NP(b1)-NP(b2))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vb1b2=(pModel->TYPE*(NP(b1)-NP(b2)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b1)-NP(b2))))
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1) ddxprobe=V(b1,GND)V(b,GND)V(s,GND) */
Vsc1_Vs_c1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vsc1_Vs_c1_Vs_c1=(+0.0*(NP(s)-NP(c1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vsc1=(pModel->TYPE*(NP(s)-NP(c1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(s)-NP(c1))))
#if defined(_DERIVATEFORDDX) /* probe=V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
Vc1c2_Vc1_c2=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vc1c2_Vc1_c2_Vc1_c2=(+0.0*(NP(c1)-NP(c2))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vc1c2=(pModel->TYPE*(NP(c1)-NP(c2)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(c1)-NP(c2))))
#if defined(_DERIVATE) /* probe=V(e,e1) ddxprobe= */
Vee1_Ve_e1=(pModel->TYPE);
#endif
Vee1=(pModel->TYPE*(NP(e)-NP(e1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(e)-NP(e1))))
#if defined(_DERIVATEFORDDX) /* probe=V(b,b1) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vbb1_Vb_b1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vbb1_Vb_b1_Vb_b1=(+0.0*(NP(b)-NP(b1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vbb1=(pModel->TYPE*(NP(b)-NP(b1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b)-NP(b1))))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b,e) ddxprobe= */
Vbe_Vb_e=(pModel->TYPE);
#endif
Vbe=(pModel->TYPE*(NP(b)-NP(e)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b)-NP(e))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c) ddxprobe=V(b,GND)V(s,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vbc_Vb_c=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vbc_Vb_c_Vb_c=(+0.0*(NP(b)-NP(c))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vbc=(pModel->TYPE*(NP(b)-NP(c)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(b)-NP(c))))
if
((pModel->RCBLX>0.0))
{
if
((pModel->RCBLI>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(s,GND)V(c1,GND)V(b1,GND)V(b,GND) */
Vc4c1_Vc4_c1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vc4c1_Vc4_c1_Vc4_c1=(+0.0*(NP(c4)-NP(c1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vc4c1=(pModel->TYPE*(NP(c4)-NP(c1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(c4)-NP(c1))))
#if defined(_DERIVATEFORDDX) /* probe=V(c3,c1)V(c3,c4) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vc3c4_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  Vc3c4_Vc3_c1_Vc3_c1=0.0;
  Vc3c4_Vc3_c1_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Vc3c4_Vc3_c4=(pModel->TYPE);
#endif
#endif
Vc3c4=(pModel->TYPE*(NP(c3)-NP(c4)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(c3)-NP(c4))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(s,GND)V(c1,GND)V(b1,GND)V(b,GND) */
Vc4c1_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  Vc4c1_Vc4_c1_Vc4_c1=0.0;
#endif
#endif
Vc4c1=0;
EXIT_IF_ISNAN(0)
#if defined(_DERIVATEFORDDX) /* probe=V(c3,c1)V(c3,c4) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vc3c4_Vc3_c1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vc3c4_Vc3_c1_Vc3_c1=(+0.0*(NP(c3)-NP(c1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
  Vc3c4_Vc3_c1_Vc3_c4=(+0.0*(NP(c3)-NP(c1))+0.0*0.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#if defined(_DERIVATE)
Vc3c4_Vc3_c4=0.0;
#endif
#endif
Vc3c4=(pModel->TYPE*(NP(c3)-NP(c1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(c3)-NP(c1))))
}
}
else
{
if
((pModel->RCBLI>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(s,GND)V(c1,GND)V(b1,GND)V(b,GND) */
Vc4c1_Vc4_c1=(pModel->TYPE);
#if defined(_DERIVATE2)
  Vc4c1_Vc4_c1_Vc4_c1=(+0.0*(NP(c4)-NP(c1))+0.0*1.0+0.0*1.0+pModel->TYPE*0.0);
#endif
#endif
Vc4c1=(pModel->TYPE*(NP(c4)-NP(c1)));
EXIT_IF_ISNAN((pModel->TYPE*(NP(c4)-NP(c1))))
#if defined(_DERIVATEFORDDX) /* probe=V(c3,c1)V(c3,c4) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vc3c4_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  Vc3c4_Vc3_c1_Vc3_c1=0.0;
  Vc3c4_Vc3_c1_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Vc3c4_Vc3_c4=0.0;
#endif
#endif
Vc3c4=0;
EXIT_IF_ISNAN(0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(s,GND)V(c1,GND)V(b1,GND)V(b,GND) */
Vc4c1_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  Vc4c1_Vc4_c1_Vc4_c1=0.0;
#endif
#endif
Vc4c1=0;
EXIT_IF_ISNAN(0)
#if defined(_DERIVATEFORDDX) /* probe=V(c3,c1)V(c3,c4) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vc3c4_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  Vc3c4_Vc3_c1_Vc3_c1=0.0;
  Vc3c4_Vc3_c1_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Vc3c4_Vc3_c4=0.0;
#endif
#endif
Vc3c4=0;
EXIT_IF_ISNAN(0)
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c1,GND)V(s,GND)V(b,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
Vb1c4_Vb1_b2=Vb1b2_Vb1_b2;
#if defined(_DERIVATE2)
  Vb1c4_Vb1_b2_Vb1_b2=(+(+(+Vb1b2_Vb1_b2_Vb1_b2+0.0)-0.0)-0.0);
  Vb1c4_Vb1_b2_Vb2_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vb1_b2_Vc1_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vb1_b2_Vc4_c1=(+(+(+0.0+0.0)-0.0)-0.0);
#endif
Vb1c4_Vb2_c2=Vb2c2_Vb2_c2;
#if defined(_DERIVATE2)
  Vb1c4_Vb2_c2_Vb1_b2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vb2_c2_Vb2_c2=(+(+(+0.0+Vb2c2_Vb2_c2_Vb2_c2)-0.0)-0.0);
  Vb1c4_Vb2_c2_Vc1_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vb2_c2_Vc4_c1=(+(+(+0.0+0.0)-0.0)-0.0);
#endif
Vb1c4_Vc1_c2=(-Vc1c2_Vc1_c2);
#if defined(_DERIVATE2)
  Vb1c4_Vc1_c2_Vb1_b2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vc1_c2_Vb2_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vc1_c2_Vc1_c2=(+(+(+0.0+0.0)-Vc1c2_Vc1_c2_Vc1_c2)-0.0);
  Vb1c4_Vc1_c2_Vc4_c1=(+(+(+0.0+0.0)-0.0)-0.0);
#endif
Vb1c4_Vc4_c1=(-Vc4c1_Vc4_c1);
#if defined(_DERIVATE2)
  Vb1c4_Vc4_c1_Vb1_b2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vc4_c1_Vb2_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vc4_c1_Vc1_c2=(+(+(+0.0+0.0)-0.0)-0.0);
  Vb1c4_Vc4_c1_Vc4_c1=(+(+(+0.0+0.0)-0.0)-Vc4c1_Vc4_c1_Vc4_c1);
#endif
#endif
Vb1c4=(((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1);
EXIT_IF_ISNAN((((Vb1b2+Vb2c2)-Vc1c2)-Vc4c1))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND)V(s,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vcc3_Vb_c=(-Vbc_Vb_c);
#if defined(_DERIVATE2)
  Vcc3_Vb_c_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vb1_b2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vb2_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vc1_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vc4_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_c_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vb_b1=Vbb1_Vb_b1;
#if defined(_DERIVATE2)
  Vcc3_Vb_b1_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vb_b1=(+(+(+0.0+Vbb1_Vb_b1_Vb_b1)+0.0)-0.0);
  Vcc3_Vb_b1_Vb1_b2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vb2_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vc1_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vc4_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb_b1_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vb1_b2=Vb1c4_Vb1_b2;
#if defined(_DERIVATE2)
  Vcc3_Vb1_b2_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb1_b2_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb1_b2_Vb1_b2=(+(+(+0.0+0.0)+Vb1c4_Vb1_b2_Vb1_b2)-0.0);
  Vcc3_Vb1_b2_Vb2_c2=(+(+(+0.0+0.0)+Vb1c4_Vb1_b2_Vb2_c2)-0.0);
  Vcc3_Vb1_b2_Vc1_c2=(+(+(+0.0+0.0)+Vb1c4_Vb1_b2_Vc1_c2)-0.0);
  Vcc3_Vb1_b2_Vc4_c1=(+(+(+0.0+0.0)+Vb1c4_Vb1_b2_Vc4_c1)-0.0);
  Vcc3_Vb1_b2_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb1_b2_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vb2_c2=Vb1c4_Vb2_c2;
#if defined(_DERIVATE2)
  Vcc3_Vb2_c2_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb2_c2_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb2_c2_Vb1_b2=(+(+(+0.0+0.0)+Vb1c4_Vb2_c2_Vb1_b2)-0.0);
  Vcc3_Vb2_c2_Vb2_c2=(+(+(+0.0+0.0)+Vb1c4_Vb2_c2_Vb2_c2)-0.0);
  Vcc3_Vb2_c2_Vc1_c2=(+(+(+0.0+0.0)+Vb1c4_Vb2_c2_Vc1_c2)-0.0);
  Vcc3_Vb2_c2_Vc4_c1=(+(+(+0.0+0.0)+Vb1c4_Vb2_c2_Vc4_c1)-0.0);
  Vcc3_Vb2_c2_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vb2_c2_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vc1_c2=Vb1c4_Vc1_c2;
#if defined(_DERIVATE2)
  Vcc3_Vc1_c2_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc1_c2_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc1_c2_Vb1_b2=(+(+(+0.0+0.0)+Vb1c4_Vc1_c2_Vb1_b2)-0.0);
  Vcc3_Vc1_c2_Vb2_c2=(+(+(+0.0+0.0)+Vb1c4_Vc1_c2_Vb2_c2)-0.0);
  Vcc3_Vc1_c2_Vc1_c2=(+(+(+0.0+0.0)+Vb1c4_Vc1_c2_Vc1_c2)-0.0);
  Vcc3_Vc1_c2_Vc4_c1=(+(+(+0.0+0.0)+Vb1c4_Vc1_c2_Vc4_c1)-0.0);
  Vcc3_Vc1_c2_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc1_c2_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vc4_c1=Vb1c4_Vc4_c1;
#if defined(_DERIVATE2)
  Vcc3_Vc4_c1_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc4_c1_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc4_c1_Vb1_b2=(+(+(+0.0+0.0)+Vb1c4_Vc4_c1_Vb1_b2)-0.0);
  Vcc3_Vc4_c1_Vb2_c2=(+(+(+0.0+0.0)+Vb1c4_Vc4_c1_Vb2_c2)-0.0);
  Vcc3_Vc4_c1_Vc1_c2=(+(+(+0.0+0.0)+Vb1c4_Vc4_c1_Vc1_c2)-0.0);
  Vcc3_Vc4_c1_Vc4_c1=(+(+(+0.0+0.0)+Vb1c4_Vc4_c1_Vc4_c1)-0.0);
  Vcc3_Vc4_c1_Vc3_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc4_c1_Vc3_c4=(+(+(+0.0+0.0)+0.0)-0.0);
#endif
Vcc3_Vc3_c1=(-Vc3c4_Vc3_c1);
#if defined(_DERIVATE2)
  Vcc3_Vc3_c1_Vb_c=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vb_b1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vb1_b2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vb2_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vc1_c2=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vc4_c1=(+(+(+0.0+0.0)+0.0)-0.0);
  Vcc3_Vc3_c1_Vc3_c1=(+(+(+0.0+0.0)+0.0)-Vc3c4_Vc3_c1_Vc3_c1);
  Vcc3_Vc3_c1_Vc3_c4=(+(+(+0.0+0.0)+0.0)-Vc3c4_Vc3_c1_Vc3_c4);
#endif
#if defined(_DERIVATE)
Vcc3_Vc3_c4=(-Vc3c4_Vc3_c4);
#endif
#endif
Vcc3=((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4);
EXIT_IF_ISNAN(((((-Vbc)+Vbb1)+Vb1c4)-Vc3c4))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(s,GND)V(b,GND) */
Vbc3_Vb_c=(Vbc_Vb_c+Vcc3_Vb_c);
#if defined(_DERIVATE2)
  Vbc3_Vb_c_Vb_c=(+Vbc_Vb_c_Vb_c+Vcc3_Vb_c_Vb_c);
  Vbc3_Vb_c_Vb_b1=(+0.0+Vcc3_Vb_c_Vb_b1);
  Vbc3_Vb_c_Vb1_b2=(+0.0+Vcc3_Vb_c_Vb1_b2);
  Vbc3_Vb_c_Vb2_c2=(+0.0+Vcc3_Vb_c_Vb2_c2);
  Vbc3_Vb_c_Vc1_c2=(+0.0+Vcc3_Vb_c_Vc1_c2);
  Vbc3_Vb_c_Vc4_c1=(+0.0+Vcc3_Vb_c_Vc4_c1);
  Vbc3_Vb_c_Vc3_c1=(+0.0+Vcc3_Vb_c_Vc3_c1);
  Vbc3_Vb_c_Vc3_c4=(+0.0+Vcc3_Vb_c_Vc3_c4);
#endif
Vbc3_Vb_b1=Vcc3_Vb_b1;
#if defined(_DERIVATE2)
  Vbc3_Vb_b1_Vb_c=(+0.0+Vcc3_Vb_b1_Vb_c);
  Vbc3_Vb_b1_Vb_b1=(+0.0+Vcc3_Vb_b1_Vb_b1);
  Vbc3_Vb_b1_Vb1_b2=(+0.0+Vcc3_Vb_b1_Vb1_b2);
  Vbc3_Vb_b1_Vb2_c2=(+0.0+Vcc3_Vb_b1_Vb2_c2);
  Vbc3_Vb_b1_Vc1_c2=(+0.0+Vcc3_Vb_b1_Vc1_c2);
  Vbc3_Vb_b1_Vc4_c1=(+0.0+Vcc3_Vb_b1_Vc4_c1);
  Vbc3_Vb_b1_Vc3_c1=(+0.0+Vcc3_Vb_b1_Vc3_c1);
  Vbc3_Vb_b1_Vc3_c4=(+0.0+Vcc3_Vb_b1_Vc3_c4);
#endif
Vbc3_Vb1_b2=Vcc3_Vb1_b2;
#if defined(_DERIVATE2)
  Vbc3_Vb1_b2_Vb_c=(+0.0+Vcc3_Vb1_b2_Vb_c);
  Vbc3_Vb1_b2_Vb_b1=(+0.0+Vcc3_Vb1_b2_Vb_b1);
  Vbc3_Vb1_b2_Vb1_b2=(+0.0+Vcc3_Vb1_b2_Vb1_b2);
  Vbc3_Vb1_b2_Vb2_c2=(+0.0+Vcc3_Vb1_b2_Vb2_c2);
  Vbc3_Vb1_b2_Vc1_c2=(+0.0+Vcc3_Vb1_b2_Vc1_c2);
  Vbc3_Vb1_b2_Vc4_c1=(+0.0+Vcc3_Vb1_b2_Vc4_c1);
  Vbc3_Vb1_b2_Vc3_c1=(+0.0+Vcc3_Vb1_b2_Vc3_c1);
  Vbc3_Vb1_b2_Vc3_c4=(+0.0+Vcc3_Vb1_b2_Vc3_c4);
#endif
Vbc3_Vb2_c2=Vcc3_Vb2_c2;
#if defined(_DERIVATE2)
  Vbc3_Vb2_c2_Vb_c=(+0.0+Vcc3_Vb2_c2_Vb_c);
  Vbc3_Vb2_c2_Vb_b1=(+0.0+Vcc3_Vb2_c2_Vb_b1);
  Vbc3_Vb2_c2_Vb1_b2=(+0.0+Vcc3_Vb2_c2_Vb1_b2);
  Vbc3_Vb2_c2_Vb2_c2=(+0.0+Vcc3_Vb2_c2_Vb2_c2);
  Vbc3_Vb2_c2_Vc1_c2=(+0.0+Vcc3_Vb2_c2_Vc1_c2);
  Vbc3_Vb2_c2_Vc4_c1=(+0.0+Vcc3_Vb2_c2_Vc4_c1);
  Vbc3_Vb2_c2_Vc3_c1=(+0.0+Vcc3_Vb2_c2_Vc3_c1);
  Vbc3_Vb2_c2_Vc3_c4=(+0.0+Vcc3_Vb2_c2_Vc3_c4);
#endif
Vbc3_Vc1_c2=Vcc3_Vc1_c2;
#if defined(_DERIVATE2)
  Vbc3_Vc1_c2_Vb_c=(+0.0+Vcc3_Vc1_c2_Vb_c);
  Vbc3_Vc1_c2_Vb_b1=(+0.0+Vcc3_Vc1_c2_Vb_b1);
  Vbc3_Vc1_c2_Vb1_b2=(+0.0+Vcc3_Vc1_c2_Vb1_b2);
  Vbc3_Vc1_c2_Vb2_c2=(+0.0+Vcc3_Vc1_c2_Vb2_c2);
  Vbc3_Vc1_c2_Vc1_c2=(+0.0+Vcc3_Vc1_c2_Vc1_c2);
  Vbc3_Vc1_c2_Vc4_c1=(+0.0+Vcc3_Vc1_c2_Vc4_c1);
  Vbc3_Vc1_c2_Vc3_c1=(+0.0+Vcc3_Vc1_c2_Vc3_c1);
  Vbc3_Vc1_c2_Vc3_c4=(+0.0+Vcc3_Vc1_c2_Vc3_c4);
#endif
Vbc3_Vc4_c1=Vcc3_Vc4_c1;
#if defined(_DERIVATE2)
  Vbc3_Vc4_c1_Vb_c=(+0.0+Vcc3_Vc4_c1_Vb_c);
  Vbc3_Vc4_c1_Vb_b1=(+0.0+Vcc3_Vc4_c1_Vb_b1);
  Vbc3_Vc4_c1_Vb1_b2=(+0.0+Vcc3_Vc4_c1_Vb1_b2);
  Vbc3_Vc4_c1_Vb2_c2=(+0.0+Vcc3_Vc4_c1_Vb2_c2);
  Vbc3_Vc4_c1_Vc1_c2=(+0.0+Vcc3_Vc4_c1_Vc1_c2);
  Vbc3_Vc4_c1_Vc4_c1=(+0.0+Vcc3_Vc4_c1_Vc4_c1);
  Vbc3_Vc4_c1_Vc3_c1=(+0.0+Vcc3_Vc4_c1_Vc3_c1);
  Vbc3_Vc4_c1_Vc3_c4=(+0.0+Vcc3_Vc4_c1_Vc3_c4);
#endif
Vbc3_Vc3_c1=Vcc3_Vc3_c1;
#if defined(_DERIVATE2)
  Vbc3_Vc3_c1_Vb_c=(+0.0+Vcc3_Vc3_c1_Vb_c);
  Vbc3_Vc3_c1_Vb_b1=(+0.0+Vcc3_Vc3_c1_Vb_b1);
  Vbc3_Vc3_c1_Vb1_b2=(+0.0+Vcc3_Vc3_c1_Vb1_b2);
  Vbc3_Vc3_c1_Vb2_c2=(+0.0+Vcc3_Vc3_c1_Vb2_c2);
  Vbc3_Vc3_c1_Vc1_c2=(+0.0+Vcc3_Vc3_c1_Vc1_c2);
  Vbc3_Vc3_c1_Vc4_c1=(+0.0+Vcc3_Vc3_c1_Vc4_c1);
  Vbc3_Vc3_c1_Vc3_c1=(+0.0+Vcc3_Vc3_c1_Vc3_c1);
  Vbc3_Vc3_c1_Vc3_c4=(+0.0+Vcc3_Vc3_c1_Vc3_c4);
#endif
#if defined(_DERIVATE)
Vbc3_Vc3_c4=Vcc3_Vc3_c4;
#endif
#endif
Vbc3=(Vbc+Vcc3);
EXIT_IF_ISNAN((Vbc+Vcc3))
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1) ddxprobe=V(b,GND)V(b1,GND) */
Vsc4_Vs_c1=Vsc1_Vs_c1;
Vsc4_Vc4_c1=(-Vc4c1_Vc4_c1);
#endif
Vsc4=(Vsc1-Vc4c1);
EXIT_IF_ISNAN((Vsc1-Vc4c1))
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND) */
Vsc3_Vs_c1=Vsc4_Vs_c1;
Vsc3_Vc4_c1=Vsc4_Vc4_c1;
Vsc3_Vc3_c1=(-Vc3c4_Vc3_c1);
Vsc3_Vc3_c4=(-Vc3c4_Vc3_c4);
#endif
Vsc3=(Vsc4-Vc3c4);
EXIT_IF_ISNAN((Vsc4-Vc3c4))
if
(((Vb2c2*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vb2c2*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c2_Vb2_c2=Vb2c2_Vb2_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb2c2_Vb2_c2_Vb2_c2=(m20_exp((Vb2c2*VtINV))*(Vb2c2_Vb2_c2*VtINV)*Vb2c2_Vb2_c2*VtINV+d10_exp0*(+Vb2c2_Vb2_c2_Vb2_c2*VtINV+Vb2c2_Vb2_c2*0.0+Vb2c2_Vb2_c2*0.0+Vb2c2*0.0));
  eVb2c2_Vb2_c2_Vdt_GND=(m20_exp((Vb2c2*VtINV))*((Vb2c2*VtINV_Vdt_GND))*Vb2c2_Vb2_c2*VtINV+d10_exp0*(+0.0*VtINV+Vb2c2_Vb2_c2*VtINV_Vdt_GND+0.0*0.0+Vb2c2*0.0));
#endif
#if defined(_DERIVATE)
eVb2c2_Vdt_GND=(Vb2c2*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVb2c2=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c2_Vb2_c2=(expl*Vb2c2_Vb2_c2*VtINV);
#if defined(_DERIVATE2)
  eVb2c2_Vb2_c2_Vb2_c2=(+0.0*(1.0+((Vb2c2*VtINV)-400.0))+0.0*(Vb2c2_Vb2_c2*VtINV)+0.0*Vb2c2_Vb2_c2*VtINV+expl*(+0.0+(+(+Vb2c2_Vb2_c2_Vb2_c2*VtINV+Vb2c2_Vb2_c2*0.0+Vb2c2_Vb2_c2*0.0+Vb2c2*0.0)-0.0)));
  eVb2c2_Vb2_c2_Vdt_GND=(+0.0*(1.0+((Vb2c2*VtINV)-400.0))+0.0*((Vb2c2*VtINV_Vdt_GND))+0.0*Vb2c2_Vb2_c2*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb2c2_Vb2_c2*VtINV_Vdt_GND+0.0*0.0+Vb2c2*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb2c2_Vdt_GND=(expl*(Vb2c2*VtINV_Vdt_GND));
#endif
#endif
eVb2c2=(expl*(1.0+((Vb2c2*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb2c2*VtINV)-400.0))))
}
if
(((Vb2e1*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vb2e1*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eVb2e1_Vb2_e1=Vb2e1_Vb2_e1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb2e1_Vb2_e1_Vb2_e1=(m20_exp((Vb2e1*VtINV))*(Vb2e1_Vb2_e1*VtINV)*Vb2e1_Vb2_e1*VtINV+d10_exp0*(+Vb2e1_Vb2_e1_Vb2_e1*VtINV+Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+Vb2e1*0.0));
  eVb2e1_Vb2_e1_Vdt_GND=(m20_exp((Vb2e1*VtINV))*((Vb2e1*VtINV_Vdt_GND))*Vb2e1_Vb2_e1*VtINV+d10_exp0*(+0.0*VtINV+Vb2e1_Vb2_e1*VtINV_Vdt_GND+0.0*0.0+Vb2e1*0.0));
#endif
#if defined(_DERIVATE)
eVb2e1_Vdt_GND=(Vb2e1*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVb2e1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eVb2e1_Vb2_e1=(expl*Vb2e1_Vb2_e1*VtINV);
#if defined(_DERIVATE2)
  eVb2e1_Vb2_e1_Vb2_e1=(+0.0*(1.0+((Vb2e1*VtINV)-400.0))+0.0*(Vb2e1_Vb2_e1*VtINV)+0.0*Vb2e1_Vb2_e1*VtINV+expl*(+0.0+(+(+Vb2e1_Vb2_e1_Vb2_e1*VtINV+Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+Vb2e1*0.0)-0.0)));
  eVb2e1_Vb2_e1_Vdt_GND=(+0.0*(1.0+((Vb2e1*VtINV)-400.0))+0.0*((Vb2e1*VtINV_Vdt_GND))+0.0*Vb2e1_Vb2_e1*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb2e1_Vb2_e1*VtINV_Vdt_GND+0.0*0.0+Vb2e1*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb2e1_Vdt_GND=(expl*(Vb2e1*VtINV_Vdt_GND));
#endif
#endif
eVb2e1=(expl*(1.0+((Vb2e1*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb2e1*VtINV)-400.0))))
}
if
(((Vb1e1*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vb1e1*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1)V(dt,GND) ddxprobe=V(e1,GND) */
eVb1e1_Vb1_e1=Vb1e1_Vb1_e1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1e1_Vb1_e1_Vb1_e1=(m20_exp((Vb1e1*VtINV))*(Vb1e1_Vb1_e1*VtINV)*Vb1e1_Vb1_e1*VtINV+d10_exp0*(+Vb1e1_Vb1_e1_Vb1_e1*VtINV+Vb1e1_Vb1_e1*0.0+Vb1e1_Vb1_e1*0.0+Vb1e1*0.0));
  eVb1e1_Vb1_e1_Vdt_GND=(m20_exp((Vb1e1*VtINV))*((Vb1e1*VtINV_Vdt_GND))*Vb1e1_Vb1_e1*VtINV+d10_exp0*(+0.0*VtINV+Vb1e1_Vb1_e1*VtINV_Vdt_GND+0.0*0.0+Vb1e1*0.0));
#endif
#if defined(_DERIVATE)
eVb1e1_Vdt_GND=(Vb1e1*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVb1e1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1)V(dt,GND) ddxprobe=V(e1,GND) */
eVb1e1_Vb1_e1=(expl*Vb1e1_Vb1_e1*VtINV);
#if defined(_DERIVATE2)
  eVb1e1_Vb1_e1_Vb1_e1=(+0.0*(1.0+((Vb1e1*VtINV)-400.0))+0.0*(Vb1e1_Vb1_e1*VtINV)+0.0*Vb1e1_Vb1_e1*VtINV+expl*(+0.0+(+(+Vb1e1_Vb1_e1_Vb1_e1*VtINV+Vb1e1_Vb1_e1*0.0+Vb1e1_Vb1_e1*0.0+Vb1e1*0.0)-0.0)));
  eVb1e1_Vb1_e1_Vdt_GND=(+0.0*(1.0+((Vb1e1*VtINV)-400.0))+0.0*((Vb1e1*VtINV_Vdt_GND))+0.0*Vb1e1_Vb1_e1*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb1e1_Vb1_e1*VtINV_Vdt_GND+0.0*0.0+Vb1e1*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb1e1_Vdt_GND=(expl*(Vb1e1*VtINV_Vdt_GND));
#endif
#endif
eVb1e1=(expl*(1.0+((Vb1e1*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb1e1*VtINV)-400.0))))
}
if
(((Vb1c4*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vb1c4*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(b2,GND)V(e1,GND)V(c2,GND)V(b1,GND) */
eVb1c4_Vb1_b2=Vb1c4_Vb1_b2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4_Vb1_b2_Vb1_b2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+Vb1c4_Vb1_b2_Vb1_b2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0));
  eVb1c4_Vb1_b2_Vb2_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+Vb1c4_Vb1_b2_Vb2_c2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vb1_b2_Vc1_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+Vb1c4_Vb1_b2_Vc1_c2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vb1_b2_Vc4_c1=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+Vb1c4_Vb1_b2_Vc4_c1*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0));
  eVb1c4_Vb1_b2_Vdt_GND=(m20_exp((Vb1c4*VtINV))*((Vb1c4*VtINV_Vdt_GND))*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+0.0*VtINV+Vb1c4_Vb1_b2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0));
#endif
eVb1c4_Vb2_c2=Vb1c4_Vb2_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4_Vb2_c2_Vb1_b2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+Vb1c4_Vb2_c2_Vb1_b2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0));
  eVb1c4_Vb2_c2_Vb2_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+Vb1c4_Vb2_c2_Vb2_c2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vb2_c2_Vc1_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+Vb1c4_Vb2_c2_Vc1_c2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vb2_c2_Vc4_c1=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+Vb1c4_Vb2_c2_Vc4_c1*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0));
  eVb1c4_Vb2_c2_Vdt_GND=(m20_exp((Vb1c4*VtINV))*((Vb1c4*VtINV_Vdt_GND))*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+0.0*VtINV+Vb1c4_Vb2_c2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0));
#endif
eVb1c4_Vc1_c2=Vb1c4_Vc1_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4_Vc1_c2_Vb1_b2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+Vb1c4_Vc1_c2_Vb1_b2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0));
  eVb1c4_Vc1_c2_Vb2_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+Vb1c4_Vc1_c2_Vb2_c2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vc1_c2_Vc1_c2=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+Vb1c4_Vc1_c2_Vc1_c2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0));
  eVb1c4_Vc1_c2_Vc4_c1=(m20_exp((Vb1c4*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+Vb1c4_Vc1_c2_Vc4_c1*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0));
  eVb1c4_Vc1_c2_Vdt_GND=(m20_exp((Vb1c4*VtINV))*((Vb1c4*VtINV_Vdt_GND))*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+0.0*VtINV+Vb1c4_Vc1_c2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0));
#endif
#if defined(_DERIVATE)
eVb1c4_Vc4_c1=Vb1c4_Vc4_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVb1c4_Vdt_GND=(Vb1c4*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVb1c4=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(b2,GND)V(e1,GND)V(c2,GND)V(b1,GND) */
eVb1c4_Vb1_b2=(expl*Vb1c4_Vb1_b2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4_Vb1_b2_Vb1_b2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb1_b2_Vb1_b2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb1_b2_Vb2_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb1_b2_Vb2_c2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb1_b2_Vc1_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb1_b2_Vc1_c2*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb1_b2_Vc4_c1=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb1_b2_Vc4_c1*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb1_b2_Vdt_GND=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*((Vb1c4*VtINV_Vdt_GND))+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb1c4_Vb1_b2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0)-0.0)));
#endif
eVb1c4_Vb2_c2=(expl*Vb1c4_Vb2_c2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4_Vb2_c2_Vb1_b2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb2_c2_Vb1_b2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb2_c2_Vb2_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb2_c2_Vb2_c2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb2_c2_Vc1_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb2_c2_Vc1_c2*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb2_c2_Vc4_c1=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vb2_c2_Vc4_c1*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vb2_c2_Vdt_GND=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*((Vb1c4*VtINV_Vdt_GND))+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb1c4_Vb2_c2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0)-0.0)));
#endif
eVb1c4_Vc1_c2=(expl*Vb1c4_Vc1_c2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4_Vc1_c2_Vb1_b2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vc1_c2_Vb1_b2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb1_b2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vc1_c2_Vb2_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vc1_c2_Vb2_c2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb2_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vc1_c2_Vc1_c2=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vc1_c2_Vc1_c2*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc1_c2*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vc1_c2_Vc4_c1=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+Vb1c4_Vc1_c2_Vc4_c1*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc4_c1*0.0+Vb1c4*0.0)-0.0)));
  eVb1c4_Vc1_c2_Vdt_GND=(+0.0*(1.0+((Vb1c4*VtINV)-400.0))+0.0*((Vb1c4*VtINV_Vdt_GND))+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vb1c4_Vc1_c2*VtINV_Vdt_GND+0.0*0.0+Vb1c4*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb1c4_Vc4_c1=(expl*Vb1c4_Vc4_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVb1c4_Vdt_GND=(expl*(Vb1c4*VtINV_Vdt_GND));
#endif
#endif
eVb1c4=(expl*(1.0+((Vb1c4*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb1c4*VtINV)-400.0))))
}
if
(((Vb1b2*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vb1b2*VtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(b1,b2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
eVb1b2_Vb1_b2=Vb1b2_Vb1_b2*VtINV*d10_exp0;
eVb1b2_Vdt_GND=(Vb1b2*VtINV_Vdt_GND)*d10_exp0;
#endif
pInst->eVb1b2=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(b1,b2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
eVb1b2_Vb1_b2=(expl*Vb1b2_Vb1_b2*VtINV);
eVb1b2_Vdt_GND=(expl*(Vb1b2*VtINV_Vdt_GND));
#endif
pInst->eVb1b2=(expl*(1.0+((Vb1b2*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb1b2*VtINV)-400.0))))
}
if
(((Vbc3*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vbc3*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVbc3_Vb_c=Vbc3_Vb_c*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVbc3_Vb_c_Vb_c=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb_c*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vb_c*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_c*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vb_b1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb_b1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vb_b1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_b1*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vb1_b2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb1_b2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vb1_b2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb1_b2*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vb2_c2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb2_c2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vb2_c2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb2_c2*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vc1_c2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc1_c2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vc1_c2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc1_c2*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vc4_c1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc4_c1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vc4_c1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc4_c1*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vc3_c1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc3_c1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vc3_c1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c1*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vc3_c4=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc3_c4*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+Vbc3_Vb_c_Vc3_c4*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c4*0.0+Vbc3*0.0));
  eVbc3_Vb_c_Vdt_GND=(m20_exp((Vbc3*VtINV))*((Vbc3*VtINV_Vdt_GND))*Vbc3_Vb_c*VtINV+d10_exp0*(+0.0*VtINV+Vbc3_Vb_c*VtINV_Vdt_GND+0.0*0.0+Vbc3*0.0));
#endif
eVbc3_Vb_b1=Vbc3_Vb_b1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVbc3_Vb_b1_Vb_c=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb_c*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vb_c*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_c*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vb_b1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb_b1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vb_b1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_b1*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vb1_b2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb1_b2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vb1_b2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb1_b2*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vb2_c2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vb2_c2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vb2_c2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb2_c2*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vc1_c2=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc1_c2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vc1_c2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc1_c2*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vc4_c1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc4_c1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vc4_c1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc4_c1*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vc3_c1=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc3_c1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vc3_c1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c1*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vc3_c4=(m20_exp((Vbc3*VtINV))*(Vbc3_Vc3_c4*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+Vbc3_Vb_b1_Vc3_c4*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c4*0.0+Vbc3*0.0));
  eVbc3_Vb_b1_Vdt_GND=(m20_exp((Vbc3*VtINV))*((Vbc3*VtINV_Vdt_GND))*Vbc3_Vb_b1*VtINV+d10_exp0*(+0.0*VtINV+Vbc3_Vb_b1*VtINV_Vdt_GND+0.0*0.0+Vbc3*0.0));
#endif
#if defined(_DERIVATE)
eVbc3_Vb1_b2=Vbc3_Vb1_b2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vb2_c2=Vbc3_Vb2_c2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vc1_c2=Vbc3_Vc1_c2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vc4_c1=Vbc3_Vc4_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vc3_c1=Vbc3_Vc3_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vc3_c4=Vbc3_Vc3_c4*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3_Vdt_GND=(Vbc3*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVbc3=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVbc3_Vb_c=(expl*Vbc3_Vb_c*VtINV);
#if defined(_DERIVATE2)
  eVbc3_Vb_c_Vb_c=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb_c*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vb_c*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_c*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vb_b1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb_b1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vb_b1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_b1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vb1_b2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb1_b2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vb1_b2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb1_b2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vb2_c2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb2_c2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vb2_c2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb2_c2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vc1_c2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc1_c2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vc1_c2*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc1_c2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vc4_c1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc4_c1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vc4_c1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc4_c1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vc3_c1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc3_c1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vc3_c1*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vc3_c4=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc3_c4*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+Vbc3_Vb_c_Vc3_c4*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c4*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_c_Vdt_GND=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*((Vbc3*VtINV_Vdt_GND))+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vbc3_Vb_c*VtINV_Vdt_GND+0.0*0.0+Vbc3*0.0)-0.0)));
#endif
eVbc3_Vb_b1=(expl*Vbc3_Vb_b1*VtINV);
#if defined(_DERIVATE2)
  eVbc3_Vb_b1_Vb_c=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb_c*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vb_c*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_c*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vb_b1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb_b1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vb_b1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_b1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vb1_b2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb1_b2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vb1_b2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb1_b2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vb2_c2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vb2_c2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vb2_c2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb2_c2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vc1_c2=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc1_c2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vc1_c2*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc1_c2*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vc4_c1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc4_c1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vc4_c1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc4_c1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vc3_c1=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc3_c1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vc3_c1*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c1*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vc3_c4=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*(Vbc3_Vc3_c4*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+Vbc3_Vb_b1_Vc3_c4*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c4*0.0+Vbc3*0.0)-0.0)));
  eVbc3_Vb_b1_Vdt_GND=(+0.0*(1.0+((Vbc3*VtINV)-400.0))+0.0*((Vbc3*VtINV_Vdt_GND))+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vbc3_Vb_b1*VtINV_Vdt_GND+0.0*0.0+Vbc3*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVbc3_Vb1_b2=(expl*Vbc3_Vb1_b2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vb2_c2=(expl*Vbc3_Vb2_c2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vc1_c2=(expl*Vbc3_Vc1_c2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vc4_c1=(expl*Vbc3_Vc4_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vc3_c1=(expl*Vbc3_Vc3_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vc3_c4=(expl*Vbc3_Vc3_c4*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3_Vdt_GND=(expl*(Vbc3*VtINV_Vdt_GND));
#endif
#endif
eVbc3=(expl*(1.0+((Vbc3*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vbc3*VtINV)-400.0))))
}
if
(((Vsc1*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vsc1*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(dt,GND) ddxprobe=V(s,GND) */
eVsc1_Vs_c1=Vsc1_Vs_c1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVsc1_Vs_c1_Vs_c1=(m20_exp((Vsc1*VtINV))*(Vsc1_Vs_c1*VtINV)*Vsc1_Vs_c1*VtINV+d10_exp0*(+Vsc1_Vs_c1_Vs_c1*VtINV+Vsc1_Vs_c1*0.0+Vsc1_Vs_c1*0.0+Vsc1*0.0));
  eVsc1_Vs_c1_Vdt_GND=(m20_exp((Vsc1*VtINV))*((Vsc1*VtINV_Vdt_GND))*Vsc1_Vs_c1*VtINV+d10_exp0*(+0.0*VtINV+Vsc1_Vs_c1*VtINV_Vdt_GND+0.0*0.0+Vsc1*0.0));
#endif
#if defined(_DERIVATE)
eVsc1_Vdt_GND=(Vsc1*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
eVsc1=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(dt,GND) ddxprobe=V(s,GND) */
eVsc1_Vs_c1=(expl*Vsc1_Vs_c1*VtINV);
#if defined(_DERIVATE2)
  eVsc1_Vs_c1_Vs_c1=(+0.0*(1.0+((Vsc1*VtINV)-400.0))+0.0*(Vsc1_Vs_c1*VtINV)+0.0*Vsc1_Vs_c1*VtINV+expl*(+0.0+(+(+Vsc1_Vs_c1_Vs_c1*VtINV+Vsc1_Vs_c1*0.0+Vsc1_Vs_c1*0.0+Vsc1*0.0)-0.0)));
  eVsc1_Vs_c1_Vdt_GND=(+0.0*(1.0+((Vsc1*VtINV)-400.0))+0.0*((Vsc1*VtINV_Vdt_GND))+0.0*Vsc1_Vs_c1*VtINV+expl*(+0.0+(+(+0.0*VtINV+Vsc1_Vs_c1*VtINV_Vdt_GND+0.0*0.0+Vsc1*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVsc1_Vdt_GND=(expl*(Vsc1*VtINV_Vdt_GND));
#endif
#endif
eVsc1=(expl*(1.0+((Vsc1*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vsc1*VtINV)-400.0))))
}
if
(((Vsc3*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vsc3*VtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVsc3_Vs_c1=Vsc3_Vs_c1*VtINV*d10_exp0;
eVsc3_Vc4_c1=Vsc3_Vc4_c1*VtINV*d10_exp0;
eVsc3_Vc3_c1=Vsc3_Vc3_c1*VtINV*d10_exp0;
eVsc3_Vc3_c4=Vsc3_Vc3_c4*VtINV*d10_exp0;
eVsc3_Vdt_GND=(Vsc3*VtINV_Vdt_GND)*d10_exp0;
#endif
eVsc3=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVsc3_Vs_c1=(expl*Vsc3_Vs_c1*VtINV);
eVsc3_Vc4_c1=(expl*Vsc3_Vc4_c1*VtINV);
eVsc3_Vc3_c1=(expl*Vsc3_Vc3_c1*VtINV);
eVsc3_Vc3_c4=(expl*Vsc3_Vc3_c4*VtINV);
eVsc3_Vdt_GND=(expl*(Vsc3*VtINV_Vdt_GND));
#endif
eVsc3=(expl*(1.0+((Vsc3*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vsc3*VtINV)-400.0))))
}
if
(((Vsc4*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,(Vsc4*VtINV))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1)V(dt,GND) ddxprobe=V(b1,GND) */
eVsc4_Vs_c1=Vsc4_Vs_c1*VtINV*d10_exp0;
eVsc4_Vc4_c1=Vsc4_Vc4_c1*VtINV*d10_exp0;
eVsc4_Vdt_GND=(Vsc4*VtINV_Vdt_GND)*d10_exp0;
#endif
eVsc4=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(s,c1)V(c4,c1)V(dt,GND) ddxprobe=V(b1,GND) */
eVsc4_Vs_c1=(expl*Vsc4_Vs_c1*VtINV);
eVsc4_Vc4_c1=(expl*Vsc4_Vc4_c1*VtINV);
eVsc4_Vdt_GND=(expl*(Vsc4*VtINV_Vdt_GND));
#endif
eVsc4=(expl*(1.0+((Vsc4*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vsc4*VtINV)-400.0))))
}
if
((((Vbc3-VDC_T)*VtINV)<400.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,((Vbc3-VDC_T)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVbc3VDC_Vb_c=Vbc3_Vb_c*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVbc3VDC_Vb_c_Vb_c=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb_c*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vb_c-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_c*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vb_b1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb_b1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vb_b1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_b1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vb1_b2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb1_b2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vb1_b2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vb2_c2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb2_c2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vb2_c2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vc1_c2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc1_c2*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vc1_c2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vc4_c1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc4_c1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vc4_c1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vc3_c1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc3_c1*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vc3_c1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vc3_c4=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc3_c4*VtINV)*Vbc3_Vb_c*VtINV+d10_exp0*(+(+Vbc3_Vb_c_Vc3_c4-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_c_Vdt_GND=(m20_exp(((Vbc3-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND)))*Vbc3_Vb_c*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vbc3_Vb_c*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vbc3-VDC_T)*0.0));
#endif
eVbc3VDC_Vb_b1=Vbc3_Vb_b1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVbc3VDC_Vb_b1_Vb_c=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb_c*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vb_c-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_c*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vb_b1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb_b1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vb_b1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_b1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vb1_b2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb1_b2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vb1_b2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vb2_c2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vb2_c2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vb2_c2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vc1_c2=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc1_c2*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vc1_c2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vc4_c1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc4_c1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vc4_c1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vc3_c1=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc3_c1*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vc3_c1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vc3_c4=(m20_exp(((Vbc3-VDC_T)*VtINV))*(Vbc3_Vc3_c4*VtINV)*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+Vbc3_Vb_b1_Vc3_c4-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-VDC_T)*0.0));
  eVbc3VDC_Vb_b1_Vdt_GND=(m20_exp(((Vbc3-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND)))*Vbc3_Vb_b1*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vbc3_Vb_b1*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vbc3-VDC_T)*0.0));
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vb1_b2=Vbc3_Vb1_b2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vb2_c2=Vbc3_Vb2_c2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc1_c2=Vbc3_Vc1_c2*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc4_c1=Vbc3_Vc4_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc3_c1=Vbc3_Vc3_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc3_c4=Vbc3_Vc3_c4*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vdt_GND=(((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND))*d10_exp0;
#endif
#endif
eVbc3VDC=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
eVbc3VDC_Vb_c=(expl*Vbc3_Vb_c*VtINV);
#if defined(_DERIVATE2)
  eVbc3VDC_Vb_c_Vb_c=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb_c*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vb_c-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_c*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vb_b1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb_b1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vb_b1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb_b1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vb1_b2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb1_b2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vb1_b2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vb2_c2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb2_c2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vb2_c2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vc1_c2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc1_c2*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vc1_c2-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vc4_c1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc4_c1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vc4_c1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vc3_c1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc3_c1*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vc3_c1-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vc3_c4=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc3_c4*VtINV)+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_c_Vc3_c4-0.0)*VtINV+Vbc3_Vb_c*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_c_Vdt_GND=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND)))+0.0*Vbc3_Vb_c*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vbc3_Vb_c*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
#endif
eVbc3VDC_Vb_b1=(expl*Vbc3_Vb_b1*VtINV);
#if defined(_DERIVATE2)
  eVbc3VDC_Vb_b1_Vb_c=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb_c*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vb_c-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_c*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vb_b1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb_b1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vb_b1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb_b1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vb1_b2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb1_b2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vb1_b2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vb2_c2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vb2_c2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vb2_c2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vc1_c2=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc1_c2*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vc1_c2-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vc4_c1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc4_c1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vc4_c1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vc3_c1=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc3_c1*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vc3_c1-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vc3_c4=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*(Vbc3_Vc3_c4*VtINV)+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+Vbc3_Vb_b1_Vc3_c4-0.0)*VtINV+Vbc3_Vb_b1*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
  eVbc3VDC_Vb_b1_Vdt_GND=(+0.0*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND)))+0.0*Vbc3_Vb_b1*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vbc3_Vb_b1*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vbc3-VDC_T)*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vb1_b2=(expl*Vbc3_Vb1_b2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vb2_c2=(expl*Vbc3_Vb2_c2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc1_c2=(expl*Vbc3_Vc1_c2*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc4_c1=(expl*Vbc3_Vc4_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc3_c1=(expl*Vbc3_Vc3_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vc3_c4=(expl*Vbc3_Vc3_c4*VtINV);
#endif
#if defined(_DERIVATE)
eVbc3VDC_Vdt_GND=(expl*(((-VDC_T_Vdt_GND)*VtINV)+((Vbc3-VDC_T)*VtINV_Vdt_GND)));
#endif
#endif
eVbc3VDC=(expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((Vbc3-VDC_T)*VtINV)-400.0))))
#endif
}
if
((((Vb1c4-VDC_T)*VtINV)<400.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,((Vb1c4-VDC_T)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
eVb1c4VDC_Vb1_b2=Vb1c4_Vb1_b2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4VDC_Vb1_b2_Vb1_b2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+(+Vb1c4_Vb1_b2_Vb1_b2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb1_b2_Vb2_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+(+Vb1c4_Vb1_b2_Vb2_c2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb1_b2_Vc1_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+(+Vb1c4_Vb1_b2_Vc1_c2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb1_b2_Vc4_c1=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+(+Vb1c4_Vb1_b2_Vc4_c1-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb1_b2_Vdt_GND=(m20_exp(((Vb1c4-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))*Vb1c4_Vb1_b2*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vb1c4_Vb1_b2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0));
#endif
eVb1c4VDC_Vb2_c2=Vb1c4_Vb2_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4VDC_Vb2_c2_Vb1_b2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+(+Vb1c4_Vb2_c2_Vb1_b2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb2_c2_Vb2_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+(+Vb1c4_Vb2_c2_Vb2_c2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb2_c2_Vc1_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+(+Vb1c4_Vb2_c2_Vc1_c2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb2_c2_Vc4_c1=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+(+Vb1c4_Vb2_c2_Vc4_c1-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vb2_c2_Vdt_GND=(m20_exp(((Vb1c4-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))*Vb1c4_Vb2_c2*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vb1c4_Vb2_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0));
#endif
eVb1c4VDC_Vc1_c2=Vb1c4_Vc1_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb1c4VDC_Vc1_c2_Vb1_b2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb1_b2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+(+Vb1c4_Vc1_c2_Vb1_b2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vc1_c2_Vb2_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vb2_c2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+(+Vb1c4_Vc1_c2_Vb2_c2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vc1_c2_Vc1_c2=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc1_c2*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+(+Vb1c4_Vc1_c2_Vc1_c2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vc1_c2_Vc4_c1=(m20_exp(((Vb1c4-VDC_T)*VtINV))*(Vb1c4_Vc4_c1*VtINV)*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+(+Vb1c4_Vc1_c2_Vc4_c1-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0));
  eVb1c4VDC_Vc1_c2_Vdt_GND=(m20_exp(((Vb1c4-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))*Vb1c4_Vc1_c2*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vb1c4_Vc1_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0));
#endif
#if defined(_DERIVATE)
eVb1c4VDC_Vc4_c1=Vb1c4_Vc4_c1*VtINV*d10_exp0;
#endif
#if defined(_DERIVATE)
eVb1c4VDC_Vdt_GND=(((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND))*d10_exp0;
#endif
#endif
eVb1c4VDC=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
eVb1c4VDC_Vb1_b2=(expl*Vb1c4_Vb1_b2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4VDC_Vb1_b2_Vb1_b2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb1_b2_Vb1_b2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb1_b2_Vb2_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb1_b2_Vb2_c2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb1_b2_Vc1_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb1_b2_Vc1_c2-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb1_b2_Vc4_c1=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb1_b2_Vc4_c1-0.0)*VtINV+Vb1c4_Vb1_b2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb1_b2_Vdt_GND=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))+0.0*Vb1c4_Vb1_b2*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vb1c4_Vb1_b2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
#endif
eVb1c4VDC_Vb2_c2=(expl*Vb1c4_Vb2_c2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4VDC_Vb2_c2_Vb1_b2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb2_c2_Vb1_b2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb2_c2_Vb2_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb2_c2_Vb2_c2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb2_c2_Vc1_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb2_c2_Vc1_c2-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb2_c2_Vc4_c1=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vb2_c2_Vc4_c1-0.0)*VtINV+Vb1c4_Vb2_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vb2_c2_Vdt_GND=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))+0.0*Vb1c4_Vb2_c2*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vb1c4_Vb2_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
#endif
eVb1c4VDC_Vc1_c2=(expl*Vb1c4_Vc1_c2*VtINV);
#if defined(_DERIVATE2)
  eVb1c4VDC_Vc1_c2_Vb1_b2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb1_b2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vc1_c2_Vb1_b2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vc1_c2_Vb2_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vb2_c2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vc1_c2_Vb2_c2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vc1_c2_Vc1_c2=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc1_c2*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vc1_c2_Vc1_c2-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vc1_c2_Vc4_c1=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*(Vb1c4_Vc4_c1*VtINV)+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+(+Vb1c4_Vc1_c2_Vc4_c1-0.0)*VtINV+Vb1c4_Vc1_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
  eVb1c4VDC_Vc1_c2_Vdt_GND=(+0.0*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)))+0.0*Vb1c4_Vc1_c2*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vb1c4_Vc1_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb1c4-VDC_T)*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb1c4VDC_Vc4_c1=(expl*Vb1c4_Vc4_c1*VtINV);
#endif
#if defined(_DERIVATE)
eVb1c4VDC_Vdt_GND=(expl*(((-VDC_T_Vdt_GND)*VtINV)+((Vb1c4-VDC_T)*VtINV_Vdt_GND)));
#endif
#endif
eVb1c4VDC=(expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((Vb1c4-VDC_T)*VtINV)-400.0))))
#endif
}
if
((((Vb2c2-VDC_T)*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,((Vb2c2-VDC_T)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c2VDC_Vb2_c2=Vb2c2_Vb2_c2*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb2c2VDC_Vb2_c2_Vb2_c2=(m20_exp(((Vb2c2-VDC_T)*VtINV))*(Vb2c2_Vb2_c2*VtINV)*Vb2c2_Vb2_c2*VtINV+d10_exp0*(+(+Vb2c2_Vb2_c2_Vb2_c2-0.0)*VtINV+Vb2c2_Vb2_c2*0.0+Vb2c2_Vb2_c2*0.0+(Vb2c2-VDC_T)*0.0));
  eVb2c2VDC_Vb2_c2_Vdt_GND=(m20_exp(((Vb2c2-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vb2c2-VDC_T)*VtINV_Vdt_GND)))*Vb2c2_Vb2_c2*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vb2c2_Vb2_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb2c2-VDC_T)*0.0));
#endif
#if defined(_DERIVATE)
eVb2c2VDC_Vdt_GND=(((-VDC_T_Vdt_GND)*VtINV)+((Vb2c2-VDC_T)*VtINV_Vdt_GND))*d10_exp0;
#endif
#endif
eVb2c2VDC=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c2VDC_Vb2_c2=(expl*Vb2c2_Vb2_c2*VtINV);
#if defined(_DERIVATE2)
  eVb2c2VDC_Vb2_c2_Vb2_c2=(+0.0*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0))+0.0*(Vb2c2_Vb2_c2*VtINV)+0.0*Vb2c2_Vb2_c2*VtINV+expl*(+0.0+(+(+(+Vb2c2_Vb2_c2_Vb2_c2-0.0)*VtINV+Vb2c2_Vb2_c2*0.0+Vb2c2_Vb2_c2*0.0+(Vb2c2-VDC_T)*0.0)-0.0)));
  eVb2c2VDC_Vb2_c2_Vdt_GND=(+0.0*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vb2c2-VDC_T)*VtINV_Vdt_GND)))+0.0*Vb2c2_Vb2_c2*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vb2c2_Vb2_c2*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb2c2-VDC_T)*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb2c2VDC_Vdt_GND=(expl*(((-VDC_T_Vdt_GND)*VtINV)+((Vb2c2-VDC_T)*VtINV_Vdt_GND)));
#endif
#endif
eVb2c2VDC=(expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((Vb2c2-VDC_T)*VtINV)-400.0))))
}
if
((((Vb2c1-VDC_T)*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,((Vb2c1-VDC_T)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c1VDC_Vb2_c1=Vb2c1_Vb2_c1*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  eVb2c1VDC_Vb2_c1_Vb2_c1=(m20_exp(((Vb2c1-VDC_T)*VtINV))*(Vb2c1_Vb2_c1*VtINV)*Vb2c1_Vb2_c1*VtINV+d10_exp0*(+(+Vb2c1_Vb2_c1_Vb2_c1-0.0)*VtINV+Vb2c1_Vb2_c1*0.0+Vb2c1_Vb2_c1*0.0+(Vb2c1-VDC_T)*0.0));
  eVb2c1VDC_Vb2_c1_Vdt_GND=(m20_exp(((Vb2c1-VDC_T)*VtINV))*((((-VDC_T_Vdt_GND)*VtINV)+((Vb2c1-VDC_T)*VtINV_Vdt_GND)))*Vb2c1_Vb2_c1*VtINV+d10_exp0*(+(+0.0-0.0)*VtINV+Vb2c1_Vb2_c1*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb2c1-VDC_T)*0.0));
#endif
#if defined(_DERIVATE)
eVb2c1VDC_Vdt_GND=(((-VDC_T_Vdt_GND)*VtINV)+((Vb2c1-VDC_T)*VtINV_Vdt_GND))*d10_exp0;
#endif
#endif
eVb2c1VDC=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
eVb2c1VDC_Vb2_c1=(expl*Vb2c1_Vb2_c1*VtINV);
#if defined(_DERIVATE2)
  eVb2c1VDC_Vb2_c1_Vb2_c1=(+0.0*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0))+0.0*(Vb2c1_Vb2_c1*VtINV)+0.0*Vb2c1_Vb2_c1*VtINV+expl*(+0.0+(+(+(+Vb2c1_Vb2_c1_Vb2_c1-0.0)*VtINV+Vb2c1_Vb2_c1*0.0+Vb2c1_Vb2_c1*0.0+(Vb2c1-VDC_T)*0.0)-0.0)));
  eVb2c1VDC_Vb2_c1_Vdt_GND=(+0.0*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0))+0.0*((((-VDC_T_Vdt_GND)*VtINV)+((Vb2c1-VDC_T)*VtINV_Vdt_GND)))+0.0*Vb2c1_Vb2_c1*VtINV+expl*(+0.0+(+(+(+0.0-0.0)*VtINV+Vb2c1_Vb2_c1*VtINV_Vdt_GND+(-VDC_T_Vdt_GND)*0.0+(Vb2c1-VDC_T)*0.0)-0.0)));
#endif
#if defined(_DERIVATE)
eVb2c1VDC_Vdt_GND=(expl*(((-VDC_T_Vdt_GND)*VtINV)+((Vb2c1-VDC_T)*VtINV_Vdt_GND)));
#endif
#endif
eVb2c1VDC=(expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((Vb2c1-VDC_T)*VtINV)-400.0))))
}
{
double m00_sqrt(d00_sqrt0,(1.0+(4.0*eVb2c2VDC)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(4.0*eVb2c2VDC)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
K0_Vb2_c2=(4.0*eVb2c2VDC_Vb2_c2)*d10_sqrt0;
#if defined(_DERIVATE2)
  K0_Vb2_c2_Vb2_c2=(m20_sqrt((1.0+(4.0*eVb2c2VDC)))*((4.0*eVb2c2VDC_Vb2_c2))*(4.0*eVb2c2VDC_Vb2_c2)+d10_sqrt0*(+0.0+(+0.0*eVb2c2VDC+0.0*eVb2c2VDC_Vb2_c2+0.0*eVb2c2VDC_Vb2_c2+4.0*eVb2c2VDC_Vb2_c2_Vb2_c2)));
  K0_Vb2_c2_Vdt_GND=(m20_sqrt((1.0+(4.0*eVb2c2VDC)))*((4.0*eVb2c2VDC_Vdt_GND))*(4.0*eVb2c2VDC_Vb2_c2)+d10_sqrt0*(+0.0+(+0.0*eVb2c2VDC+0.0*eVb2c2VDC_Vdt_GND+0.0*eVb2c2VDC_Vb2_c2+4.0*eVb2c2VDC_Vb2_c2_Vdt_GND)));
#endif
#if defined(_DERIVATE)
K0_Vdt_GND=(4.0*eVb2c2VDC_Vdt_GND)*d10_sqrt0;
#endif
#endif
K0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_sqrt(d00_sqrt0,(1.0+(4.0*eVb2c1VDC)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(4.0*eVb2c1VDC)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b1,GND)V(s,GND)V(b2,GND)V(b,GND) */
Kw_Vb2_c1=(4.0*eVb2c1VDC_Vb2_c1)*d10_sqrt0;
#if defined(_DERIVATE2)
  Kw_Vb2_c1_Vb2_c1=(m20_sqrt((1.0+(4.0*eVb2c1VDC)))*((4.0*eVb2c1VDC_Vb2_c1))*(4.0*eVb2c1VDC_Vb2_c1)+d10_sqrt0*(+0.0+(+0.0*eVb2c1VDC+0.0*eVb2c1VDC_Vb2_c1+0.0*eVb2c1VDC_Vb2_c1+4.0*eVb2c1VDC_Vb2_c1_Vb2_c1)));
  Kw_Vb2_c1_Vdt_GND=(m20_sqrt((1.0+(4.0*eVb2c1VDC)))*((4.0*eVb2c1VDC_Vdt_GND))*(4.0*eVb2c1VDC_Vb2_c1)+d10_sqrt0*(+0.0+(+0.0*eVb2c1VDC+0.0*eVb2c1VDC_Vdt_GND+0.0*eVb2c1VDC_Vb2_c1+4.0*eVb2c1VDC_Vb2_c1_Vdt_GND)));
#endif
#if defined(_DERIVATE)
Kw_Vdt_GND=(4.0*eVb2c1VDC_Vdt_GND)*d10_sqrt0;
#endif
#endif
Kw=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
pW_Vb2_c1=(((2.0*eVb2c1VDC_Vb2_c1)*(1.0+Kw)-(2.0*eVb2c1VDC)*Kw_Vb2_c1)/(1.0+Kw)/(1.0+Kw));
#if defined(_DERIVATE2)
  pW_Vb2_c1_Vb2_c1=((+0.0*eVb2c1VDC+0.0*eVb2c1VDC_Vb2_c1+0.0*eVb2c1VDC_Vb2_c1+2.0*eVb2c1VDC_Vb2_c1_Vb2_c1)/(1.0+Kw)-((2.0*eVb2c1VDC_Vb2_c1)*Kw_Vb2_c1+((2.0*eVb2c1VDC_Vb2_c1))*Kw_Vb2_c1+(2.0*eVb2c1VDC)*(+0.0+Kw_Vb2_c1_Vb2_c1))/(1.0+Kw)/(1.0+Kw)+2*(2.0*eVb2c1VDC)*Kw_Vb2_c1*Kw_Vb2_c1/(1.0+Kw)/(1.0+Kw)/(1.0+Kw));
  pW_Vb2_c1_Vdt_GND=((+0.0*eVb2c1VDC+0.0*eVb2c1VDC_Vdt_GND+0.0*eVb2c1VDC_Vb2_c1+2.0*eVb2c1VDC_Vb2_c1_Vdt_GND)/(1.0+Kw)-((2.0*eVb2c1VDC_Vb2_c1)*Kw_Vdt_GND+((2.0*eVb2c1VDC_Vdt_GND))*Kw_Vb2_c1+(2.0*eVb2c1VDC)*(+0.0+Kw_Vb2_c1_Vdt_GND))/(1.0+Kw)/(1.0+Kw)+2*(2.0*eVb2c1VDC)*Kw_Vb2_c1*Kw_Vdt_GND/(1.0+Kw)/(1.0+Kw)/(1.0+Kw));
#endif
#if defined(_DERIVATE)
pW_Vdt_GND=(((2.0*eVb2c1VDC_Vdt_GND)*(1.0+Kw)-(2.0*eVb2c1VDC)*Kw_Vdt_GND)/(1.0+Kw)/(1.0+Kw));
#endif
#endif
pW=((2.0*eVb2c1VDC)/(1.0+Kw));
EXIT_IF_ISNAN(((2.0*eVb2c1VDC)/(1.0+Kw)))
{
double m00_logE(d00_logE0,((K0+1.0)/(Kw+1.0)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((K0+1.0)/(Kw+1.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1) ddxprobe=V(b,GND)V(b2,GND)V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Ec_Vdt_GND=((Vt_Vdt_GND*((K0-Kw)-d00_logE0))+(Vt*((K0_Vdt_GND-Kw_Vdt_GND)-((K0_Vdt_GND*(Kw+1.0)-(K0+1.0)*Kw_Vdt_GND)/(Kw+1.0)/(Kw+1.0))*d10_logE0)));
#endif
Ec_Vb2_c2=(Vt*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0));
#if defined(_DERIVATE2)
  Ec_Vb2_c2_Vdt_GND=(+0.0*((K0-Kw)-d00_logE0)+0.0*((K0_Vdt_GND-Kw_Vdt_GND)-((K0_Vdt_GND*(Kw+1.0)-(K0+1.0)*Kw_Vdt_GND)/(Kw+1.0)/(Kw+1.0))*d10_logE0)+Vt_Vdt_GND*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0)+Vt*(+(+K0_Vb2_c2_Vdt_GND-0.0)-(m20_logE(((K0+1.0)/(Kw+1.0)))*((K0_Vdt_GND*(Kw+1.0)-(K0+1.0)*Kw_Vdt_GND)/(Kw+1.0)/(Kw+1.0))*(K0_Vb2_c2/(Kw+1.0))+d10_logE0*((+K0_Vb2_c2_Vdt_GND+0.0)/(Kw+1.0)-(K0_Vb2_c2*Kw_Vdt_GND+K0_Vdt_GND*0.0+(K0+1.0)*(+0.0+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*0.0*Kw_Vdt_GND/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
  Ec_Vb2_c2_Vb2_c2=(+0.0*((K0-Kw)-d00_logE0)+0.0*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0)+0.0*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0)+Vt*(+(+K0_Vb2_c2_Vb2_c2-0.0)-(m20_logE(((K0+1.0)/(Kw+1.0)))*(K0_Vb2_c2/(Kw+1.0))*(K0_Vb2_c2/(Kw+1.0))+d10_logE0*((+K0_Vb2_c2_Vb2_c2+0.0)/(Kw+1.0)-(K0_Vb2_c2*0.0+K0_Vb2_c2*0.0+(K0+1.0)*(+0.0+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*0.0*0.0/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
  Ec_Vb2_c2_Vb2_c1=(+0.0*((K0-Kw)-d00_logE0)+0.0*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0)+0.0*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0)+Vt*(+(+0.0-0.0)-(m20_logE(((K0+1.0)/(Kw+1.0)))*(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*(K0_Vb2_c2/(Kw+1.0))+d10_logE0*((+0.0+0.0)/(Kw+1.0)-(K0_Vb2_c2*Kw_Vb2_c1+0.0*0.0+(K0+1.0)*(+0.0+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*0.0*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
#endif
Ec_Vb2_c1=(Vt*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0));
#if defined(_DERIVATE2)
  Ec_Vb2_c1_Vdt_GND=(+0.0*((K0-Kw)-d00_logE0)+0.0*((K0_Vdt_GND-Kw_Vdt_GND)-((K0_Vdt_GND*(Kw+1.0)-(K0+1.0)*Kw_Vdt_GND)/(Kw+1.0)/(Kw+1.0))*d10_logE0)+Vt_Vdt_GND*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0)+Vt*(+(+0.0-Kw_Vb2_c1_Vdt_GND)-(m20_logE(((K0+1.0)/(Kw+1.0)))*((K0_Vdt_GND*(Kw+1.0)-(K0+1.0)*Kw_Vdt_GND)/(Kw+1.0)/(Kw+1.0))*(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))+d10_logE0*((+0.0+0.0)/(Kw+1.0)-(0.0*Kw_Vdt_GND+K0_Vdt_GND*Kw_Vb2_c1+(K0+1.0)*(+Kw_Vb2_c1_Vdt_GND+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*Kw_Vb2_c1*Kw_Vdt_GND/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
  Ec_Vb2_c1_Vb2_c2=(+0.0*((K0-Kw)-d00_logE0)+0.0*(K0_Vb2_c2-(K0_Vb2_c2/(Kw+1.0))*d10_logE0)+0.0*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0)+Vt*(+(+0.0-0.0)-(m20_logE(((K0+1.0)/(Kw+1.0)))*(K0_Vb2_c2/(Kw+1.0))*(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))+d10_logE0*((+0.0+0.0)/(Kw+1.0)-(0.0*0.0+K0_Vb2_c2*Kw_Vb2_c1+(K0+1.0)*(+0.0+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*Kw_Vb2_c1*0.0/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
  Ec_Vb2_c1_Vb2_c1=(+0.0*((K0-Kw)-d00_logE0)+0.0*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0)+0.0*((-Kw_Vb2_c1)-(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*d10_logE0)+Vt*(+(+0.0-Kw_Vb2_c1_Vb2_c1)-(m20_logE(((K0+1.0)/(Kw+1.0)))*(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))*(-(K0+1.0)*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0))+d10_logE0*((+0.0+0.0)/(Kw+1.0)-(0.0*Kw_Vb2_c1+0.0*Kw_Vb2_c1+(K0+1.0)*(+Kw_Vb2_c1_Vb2_c1+0.0))/(Kw+1.0)/(Kw+1.0)+2*(K0+1.0)*Kw_Vb2_c1*Kw_Vb2_c1/(Kw+1.0)/(Kw+1.0)/(Kw+1.0)))));
#endif
#endif
Ec=(Vt*((K0-Kw)-d00_logE0));
EXIT_IF_ISNAN((Vt*((K0-Kw)-d00_logE0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b1,GND)V(s,GND)V(b2,GND)V(b,GND)V(e1,GND)V(c1,GND)V(c2,GND) */
#if defined(_DERIVATE)
Ic1c2_Vdt_GND=((Ec_Vdt_GND*RCV_TM-(Ec+Vc1c2)*RCV_TM_Vdt_GND)/RCV_TM/RCV_TM);
#endif
Ic1c2_Vb2_c2=(Ec_Vb2_c2/RCV_TM);
#if defined(_DERIVATE2)
  Ic1c2_Vb2_c2_Vdt_GND=((+Ec_Vb2_c2_Vdt_GND+0.0)/RCV_TM-(Ec_Vb2_c2*RCV_TM_Vdt_GND+Ec_Vdt_GND*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*RCV_TM_Vdt_GND/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c2_Vb2_c2=((+Ec_Vb2_c2_Vb2_c2+0.0)/RCV_TM-(Ec_Vb2_c2*0.0+Ec_Vb2_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c2_Vb2_c1=((+Ec_Vb2_c2_Vb2_c1+0.0)/RCV_TM-(Ec_Vb2_c2*0.0+Ec_Vb2_c1*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c2_Vc1_c2=((+0.0+0.0)/RCV_TM-(Ec_Vb2_c2*0.0+Vc1c2_Vc1_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
#endif
Ic1c2_Vb2_c1=(Ec_Vb2_c1/RCV_TM);
#if defined(_DERIVATE2)
  Ic1c2_Vb2_c1_Vdt_GND=((+Ec_Vb2_c1_Vdt_GND+0.0)/RCV_TM-(Ec_Vb2_c1*RCV_TM_Vdt_GND+Ec_Vdt_GND*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*RCV_TM_Vdt_GND/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c1_Vb2_c2=((+Ec_Vb2_c1_Vb2_c2+0.0)/RCV_TM-(Ec_Vb2_c1*0.0+Ec_Vb2_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c1_Vb2_c1=((+Ec_Vb2_c1_Vb2_c1+0.0)/RCV_TM-(Ec_Vb2_c1*0.0+Ec_Vb2_c1*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vb2_c1_Vc1_c2=((+0.0+0.0)/RCV_TM-(Ec_Vb2_c1*0.0+Vc1c2_Vc1_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
#endif
Ic1c2_Vc1_c2=(Vc1c2_Vc1_c2/RCV_TM);
#if defined(_DERIVATE2)
  Ic1c2_Vc1_c2_Vdt_GND=((+0.0+0.0)/RCV_TM-(Vc1c2_Vc1_c2*RCV_TM_Vdt_GND+Ec_Vdt_GND*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*RCV_TM_Vdt_GND/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vc1_c2_Vb2_c2=((+0.0+0.0)/RCV_TM-(Vc1c2_Vc1_c2*0.0+Ec_Vb2_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vc1_c2_Vb2_c1=((+0.0+0.0)/RCV_TM-(Vc1c2_Vc1_c2*0.0+Ec_Vb2_c1*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
  Ic1c2_Vc1_c2_Vc1_c2=((+0.0+Vc1c2_Vc1_c2_Vc1_c2)/RCV_TM-(Vc1c2_Vc1_c2*0.0+Vc1c2_Vc1_c2*0.0+(Ec+Vc1c2)*0.0)/RCV_TM/RCV_TM+2*(Ec+Vc1c2)*0.0*0.0/RCV_TM/RCV_TM/RCV_TM);
#endif
#endif
Ic1c2=((Ec+Vc1c2)/RCV_TM);
EXIT_IF_ISNAN(((Ec+Vc1c2)/RCV_TM))
if
((Ic1c2>0.0))
{
if
((Vb2c1<100.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
tmpV_Vb2_c1=Vb2c1_Vb2_c1;
#if defined(_DERIVATE2)
  tmpV_Vb2_c1_Vb2_c1=Vb2c1_Vb2_c1_Vb2_c1;
#endif
#endif
tmpV=Vb2c1;
EXIT_IF_ISNAN(Vb2c1)
}
else
{
{
double m00_logE(d00_logE0,(1.0+(Vb2c1-100.0)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0+(Vb2c1-100.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
tmpV_Vb2_c1=Vb2c1_Vb2_c1*d10_logE0;
#if defined(_DERIVATE2)
  tmpV_Vb2_c1_Vb2_c1=(+0.0+(m20_logE((1.0+(Vb2c1-100.0)))*Vb2c1_Vb2_c1*Vb2c1_Vb2_c1+d10_logE0*(+0.0+(+Vb2c1_Vb2_c1_Vb2_c1-0.0))));
#endif
#endif
tmpV=(100.0+d00_logE0);
EXIT_IF_ISNAN((100.0+d00_logE0))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
tmpV_Vb2_c1=tmpV_Vb2_c1;
#if defined(_DERIVATE2)
  tmpV_Vb2_c1_Vb2_c1=tmpV_Vb2_c1_Vb2_c1;
#endif
#endif
tmpV=tmpV;
EXIT_IF_ISNAN(tmpV)
{
double m00_logE(d00_logE0,((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND)V(b1,GND)V(s,GND) */
#if defined(_DERIVATE)
Vqs_th_Vdt_GND=(VDC_T_Vdt_GND+(((2.0*Vt_Vdt_GND)*d00_logE0)+((2.0*Vt)*(((((0.5*Ic1c2_Vdt_GND)*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND))*d10_logE0)));
#endif
Vqs_th_Vb2_c2=((2.0*Vt)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV*d10_logE0);
#if defined(_DERIVATE2)
  Vqs_th_Vb2_c2_Vdt_GND=(+(+0.0+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*d10_logE0+((2.0*Vt_Vdt_GND))*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vb2_c2_Vb2_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vb2_c2_Vb2_c1=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vb2_c2_Vc1_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
#endif
Vqs_th_Vb2_c1=(((2.0*Vt)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV*d10_logE0)-tmpV_Vb2_c1);
#if defined(_DERIVATE2)
  Vqs_th_Vb2_c1_Vdt_GND=(+(+0.0+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*d10_logE0+((2.0*Vt_Vdt_GND))*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vb2_c1_Vb2_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c1)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vb2_c1_Vb2_c1=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c1)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-tmpV_Vb2_c1_Vb2_c1);
  Vqs_th_Vb2_c1_Vc1_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vb2_c1)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vb2_c1)*RCV_TM*0.0+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
#endif
Vqs_th_Vc1_c2=((2.0*Vt)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV*d10_logE0);
#if defined(_DERIVATE2)
  Vqs_th_Vc1_c2_Vdt_GND=(+(+0.0+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*d10_logE0+((2.0*Vt_Vdt_GND))*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*VtINV)+(((0.5*Ic1c2)*RCV_TM)*VtINV_Vdt_GND)))*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vc1_c2_Vb2_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vc1_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vc1_c2_Vb2_c1=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vc1_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
  Vqs_th_Vc1_c2_Vc1_c2=(+(+0.0+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*d00_logE0+0.0*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*d10_logE0+(0.0)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV*d10_logE0+(2.0*Vt)*(m20_logE(((((0.5*Ic1c2)*RCV_TM)*VtINV)+1.0))*((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*VtINV)*(0.5*Ic1c2_Vc1_c2)*RCV_TM*VtINV+d10_logE0*(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*VtINV+(0.5*Ic1c2_Vc1_c2)*RCV_TM*0.0+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*0.0+((0.5*Ic1c2)*RCV_TM)*0.0)+0.0))))-0.0);
#endif
#endif
Vqs_th=((VDC_T+((2.0*Vt)*d00_logE0))-tmpV);
EXIT_IF_ISNAN(((VDC_T+((2.0*Vt)*d00_logE0))-tmpV))
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND)V(b,GND)V(s,GND)V(b1,GND) */
eps_VDC_Vdt_GND=(0.2*VDC_T_Vdt_GND);
#endif
eps_VDC=(0.2*VDC_T);
EXIT_IF_ISNAN((0.2*VDC_T))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eps2_Vdt_GND=((eps_VDC_Vdt_GND*eps_VDC)+(eps_VDC*eps_VDC_Vdt_GND));
#endif
eps2=(eps_VDC*eps_VDC);
EXIT_IF_ISNAN((eps_VDC*eps_VDC))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
x2_Vb_c=0.0;
#if defined(_DERIVATE2)
  x2_Vb_c_Vb_c=0.0;
  x2_Vb_c_Vb_b1=0.0;
  x2_Vb_c_Vb1_b2=0.0;
  x2_Vb_c_Vc4_c1=0.0;
  x2_Vb_c_Vc3_c1=0.0;
  x2_Vb_c_Vc3_c4=0.0;
  x2_Vb_c_Vb2_e1=0.0;
  x2_Vb_c_Vdt_GND=0.0;
  x2_Vb_c_Vb2_c2=0.0;
  x2_Vb_c_Vb2_c1=0.0;
  x2_Vb_c_Vc1_c2=0.0;
#endif
x2_Vb_b1=0.0;
#if defined(_DERIVATE2)
  x2_Vb_b1_Vb_c=0.0;
  x2_Vb_b1_Vb_b1=0.0;
  x2_Vb_b1_Vb1_b2=0.0;
  x2_Vb_b1_Vc4_c1=0.0;
  x2_Vb_b1_Vc3_c1=0.0;
  x2_Vb_b1_Vc3_c4=0.0;
  x2_Vb_b1_Vb2_e1=0.0;
  x2_Vb_b1_Vdt_GND=0.0;
  x2_Vb_b1_Vb2_c2=0.0;
  x2_Vb_b1_Vb2_c1=0.0;
  x2_Vb_b1_Vc1_c2=0.0;
#endif
x2_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  x2_Vb1_b2_Vb_c=0.0;
  x2_Vb1_b2_Vb_b1=0.0;
  x2_Vb1_b2_Vb1_b2=0.0;
  x2_Vb1_b2_Vc4_c1=0.0;
  x2_Vb1_b2_Vc3_c1=0.0;
  x2_Vb1_b2_Vc3_c4=0.0;
  x2_Vb1_b2_Vb2_e1=0.0;
  x2_Vb1_b2_Vdt_GND=0.0;
  x2_Vb1_b2_Vb2_c2=0.0;
  x2_Vb1_b2_Vb2_c1=0.0;
  x2_Vb1_b2_Vc1_c2=0.0;
#endif
x2_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc4_c1_Vb_c=0.0;
  x2_Vc4_c1_Vb_b1=0.0;
  x2_Vc4_c1_Vb1_b2=0.0;
  x2_Vc4_c1_Vc4_c1=0.0;
  x2_Vc4_c1_Vc3_c1=0.0;
  x2_Vc4_c1_Vc3_c4=0.0;
  x2_Vc4_c1_Vb2_e1=0.0;
  x2_Vc4_c1_Vdt_GND=0.0;
  x2_Vc4_c1_Vb2_c2=0.0;
  x2_Vc4_c1_Vb2_c1=0.0;
  x2_Vc4_c1_Vc1_c2=0.0;
#endif
x2_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc3_c1_Vb_c=0.0;
  x2_Vc3_c1_Vb_b1=0.0;
  x2_Vc3_c1_Vb1_b2=0.0;
  x2_Vc3_c1_Vc4_c1=0.0;
  x2_Vc3_c1_Vc3_c1=0.0;
  x2_Vc3_c1_Vc3_c4=0.0;
  x2_Vc3_c1_Vb2_e1=0.0;
  x2_Vc3_c1_Vdt_GND=0.0;
  x2_Vc3_c1_Vb2_c2=0.0;
  x2_Vc3_c1_Vb2_c1=0.0;
  x2_Vc3_c1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
x2_Vc3_c4=0.0;
#endif
x2_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  x2_Vb2_e1_Vb_c=0.0;
  x2_Vb2_e1_Vb_b1=0.0;
  x2_Vb2_e1_Vb1_b2=0.0;
  x2_Vb2_e1_Vc4_c1=0.0;
  x2_Vb2_e1_Vc3_c1=0.0;
  x2_Vb2_e1_Vc3_c4=0.0;
  x2_Vb2_e1_Vb2_e1=0.0;
  x2_Vb2_e1_Vdt_GND=0.0;
  x2_Vb2_e1_Vb2_c2=0.0;
  x2_Vb2_e1_Vb2_c1=0.0;
  x2_Vb2_e1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
x2_Vdt_GND=((Vqs_th_Vdt_GND*Vqs_th)+(Vqs_th*Vqs_th_Vdt_GND));
#endif
x2_Vb2_c2=((Vqs_th_Vb2_c2*Vqs_th)+(Vqs_th*Vqs_th_Vb2_c2));
#if defined(_DERIVATE2)
  x2_Vb2_c2_Vb_c=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vb_b1=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vb1_b2=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vc4_c1=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vc3_c1=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vc3_c4=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vb2_e1=(+0.0*Vqs_th+Vqs_th_Vb2_c2*0.0+0.0*Vqs_th_Vb2_c2+Vqs_th*0.0);
  x2_Vb2_c2_Vdt_GND=(+Vqs_th_Vb2_c2_Vdt_GND*Vqs_th+Vqs_th_Vb2_c2*Vqs_th_Vdt_GND+Vqs_th_Vdt_GND*Vqs_th_Vb2_c2+Vqs_th*Vqs_th_Vb2_c2_Vdt_GND);
  x2_Vb2_c2_Vb2_c2=(+Vqs_th_Vb2_c2_Vb2_c2*Vqs_th+Vqs_th_Vb2_c2*Vqs_th_Vb2_c2+Vqs_th_Vb2_c2*Vqs_th_Vb2_c2+Vqs_th*Vqs_th_Vb2_c2_Vb2_c2);
  x2_Vb2_c2_Vb2_c1=(+Vqs_th_Vb2_c2_Vb2_c1*Vqs_th+Vqs_th_Vb2_c2*Vqs_th_Vb2_c1+Vqs_th_Vb2_c1*Vqs_th_Vb2_c2+Vqs_th*Vqs_th_Vb2_c2_Vb2_c1);
  x2_Vb2_c2_Vc1_c2=(+Vqs_th_Vb2_c2_Vc1_c2*Vqs_th+Vqs_th_Vb2_c2*Vqs_th_Vc1_c2+Vqs_th_Vc1_c2*Vqs_th_Vb2_c2+Vqs_th*Vqs_th_Vb2_c2_Vc1_c2);
#endif
x2_Vb2_c1=((Vqs_th_Vb2_c1*Vqs_th)+(Vqs_th*Vqs_th_Vb2_c1));
#if defined(_DERIVATE2)
  x2_Vb2_c1_Vb_c=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vb_b1=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vb1_b2=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vc4_c1=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vc3_c1=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vc3_c4=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vb2_e1=(+0.0*Vqs_th+Vqs_th_Vb2_c1*0.0+0.0*Vqs_th_Vb2_c1+Vqs_th*0.0);
  x2_Vb2_c1_Vdt_GND=(+Vqs_th_Vb2_c1_Vdt_GND*Vqs_th+Vqs_th_Vb2_c1*Vqs_th_Vdt_GND+Vqs_th_Vdt_GND*Vqs_th_Vb2_c1+Vqs_th*Vqs_th_Vb2_c1_Vdt_GND);
  x2_Vb2_c1_Vb2_c2=(+Vqs_th_Vb2_c1_Vb2_c2*Vqs_th+Vqs_th_Vb2_c1*Vqs_th_Vb2_c2+Vqs_th_Vb2_c2*Vqs_th_Vb2_c1+Vqs_th*Vqs_th_Vb2_c1_Vb2_c2);
  x2_Vb2_c1_Vb2_c1=(+Vqs_th_Vb2_c1_Vb2_c1*Vqs_th+Vqs_th_Vb2_c1*Vqs_th_Vb2_c1+Vqs_th_Vb2_c1*Vqs_th_Vb2_c1+Vqs_th*Vqs_th_Vb2_c1_Vb2_c1);
  x2_Vb2_c1_Vc1_c2=(+Vqs_th_Vb2_c1_Vc1_c2*Vqs_th+Vqs_th_Vb2_c1*Vqs_th_Vc1_c2+Vqs_th_Vc1_c2*Vqs_th_Vb2_c1+Vqs_th*Vqs_th_Vb2_c1_Vc1_c2);
#endif
x2_Vc1_c2=((Vqs_th_Vc1_c2*Vqs_th)+(Vqs_th*Vqs_th_Vc1_c2));
#if defined(_DERIVATE2)
  x2_Vc1_c2_Vb_c=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vb_b1=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vb1_b2=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vc4_c1=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vc3_c1=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vc3_c4=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vb2_e1=(+0.0*Vqs_th+Vqs_th_Vc1_c2*0.0+0.0*Vqs_th_Vc1_c2+Vqs_th*0.0);
  x2_Vc1_c2_Vdt_GND=(+Vqs_th_Vc1_c2_Vdt_GND*Vqs_th+Vqs_th_Vc1_c2*Vqs_th_Vdt_GND+Vqs_th_Vdt_GND*Vqs_th_Vc1_c2+Vqs_th*Vqs_th_Vc1_c2_Vdt_GND);
  x2_Vc1_c2_Vb2_c2=(+Vqs_th_Vc1_c2_Vb2_c2*Vqs_th+Vqs_th_Vc1_c2*Vqs_th_Vb2_c2+Vqs_th_Vb2_c2*Vqs_th_Vc1_c2+Vqs_th*Vqs_th_Vc1_c2_Vb2_c2);
  x2_Vc1_c2_Vb2_c1=(+Vqs_th_Vc1_c2_Vb2_c1*Vqs_th+Vqs_th_Vc1_c2*Vqs_th_Vb2_c1+Vqs_th_Vb2_c1*Vqs_th_Vc1_c2+Vqs_th*Vqs_th_Vc1_c2_Vb2_c1);
  x2_Vc1_c2_Vc1_c2=(+Vqs_th_Vc1_c2_Vc1_c2*Vqs_th+Vqs_th_Vc1_c2*Vqs_th_Vc1_c2+Vqs_th_Vc1_c2*Vqs_th_Vc1_c2+Vqs_th*Vqs_th_Vc1_c2_Vc1_c2);
#endif
#endif
x2=(Vqs_th*Vqs_th);
EXIT_IF_ISNAN((Vqs_th*Vqs_th))
if
((Vqs_th<0.0))
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Vqs_Vdt_GND=(((0.5*eps2_Vdt_GND)*(d00_sqrt0-Vqs_th)-(0.5*eps2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#endif
Vqs_Vb2_c2=(-(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#if defined(_DERIVATE2)
  Vqs_Vb2_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))-Vqs_th_Vb2_c2_Vdt_GND))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))-Vqs_th_Vb2_c2_Vb2_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.0)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))-Vqs_th_Vb2_c2_Vb2_c1))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))-Vqs_th_Vb2_c2_Vc1_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#endif
Vqs_Vb2_c1=(-(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#if defined(_DERIVATE2)
  Vqs_Vb2_c1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))-Vqs_th_Vb2_c1_Vdt_GND))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))-Vqs_th_Vb2_c1_Vb2_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.0)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))-Vqs_th_Vb2_c1_Vb2_c1))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vb2_c1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))-Vqs_th_Vb2_c1_Vc1_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#endif
Vqs_Vc1_c2=(-(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#if defined(_DERIVATE2)
  Vqs_Vc1_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))-Vqs_th_Vc1_c2_Vdt_GND))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-Vqs_th_Vdt_GND)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vc1_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))-Vqs_th_Vc1_c2_Vb2_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)*(x2_Vb2_c2*d10_sqrt0-Vqs_th_Vb2_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vc1_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)+(0.0)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))-Vqs_th_Vc1_c2_Vb2_c1))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)*(x2_Vb2_c1*d10_sqrt0-Vqs_th_Vb2_c1)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
  Vqs_Vc1_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-Vqs_th)-(0.0*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))-Vqs_th_Vc1_c2_Vc1_c2))/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)*(x2_Vc1_c2*d10_sqrt0-Vqs_th_Vc1_c2)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th)/(d00_sqrt0-Vqs_th));
#endif
#endif
Vqs=((0.5*eps2)/(d00_sqrt0-Vqs_th));
EXIT_IF_ISNAN(((0.5*eps2)/(d00_sqrt0-Vqs_th)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Vqs_Vdt_GND=(0.5*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+Vqs_th_Vdt_GND));
#endif
Vqs_Vb2_c2=(0.5*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2));
#if defined(_DERIVATE2)
  Vqs_Vb2_c2_Vdt_GND=(+0.0*(d00_sqrt0+Vqs_th)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+Vqs_th_Vdt_GND)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))+Vqs_th_Vb2_c2_Vdt_GND));
  Vqs_Vb2_c2_Vb2_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))+Vqs_th_Vb2_c2_Vb2_c2));
  Vqs_Vb2_c2_Vb2_c1=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))+Vqs_th_Vb2_c2_Vb2_c1));
  Vqs_Vb2_c2_Vc1_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))+Vqs_th_Vb2_c2_Vc1_c2));
#endif
Vqs_Vb2_c1=(0.5*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1));
#if defined(_DERIVATE2)
  Vqs_Vb2_c1_Vdt_GND=(+0.0*(d00_sqrt0+Vqs_th)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+Vqs_th_Vdt_GND)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))+Vqs_th_Vb2_c1_Vdt_GND));
  Vqs_Vb2_c1_Vb2_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))+Vqs_th_Vb2_c1_Vb2_c2));
  Vqs_Vb2_c1_Vb2_c1=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))+Vqs_th_Vb2_c1_Vb2_c1));
  Vqs_Vb2_c1_Vc1_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))+Vqs_th_Vb2_c1_Vc1_c2));
#endif
Vqs_Vc1_c2=(0.5*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2));
#if defined(_DERIVATE2)
  Vqs_Vc1_c2_Vdt_GND=(+0.0*(d00_sqrt0+Vqs_th)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+Vqs_th_Vdt_GND)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))+Vqs_th_Vc1_c2_Vdt_GND));
  Vqs_Vc1_c2_Vb2_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c2*d10_sqrt0+Vqs_th_Vb2_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))+Vqs_th_Vc1_c2_Vb2_c2));
  Vqs_Vc1_c2_Vb2_c1=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vb2_c1*d10_sqrt0+Vqs_th_Vb2_c1)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))+Vqs_th_Vc1_c2_Vb2_c1));
  Vqs_Vc1_c2_Vc1_c2=(+0.0*(d00_sqrt0+Vqs_th)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+Vqs_th_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))+Vqs_th_Vc1_c2_Vc1_c2));
#endif
#endif
Vqs=(0.5*(d00_sqrt0+Vqs_th));
EXIT_IF_ISNAN((0.5*(d00_sqrt0+Vqs_th)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Vqs_Vdt_GND=Vqs_Vdt_GND;
#endif
Vqs_Vb2_c2=Vqs_Vb2_c2;
#if defined(_DERIVATE2)
  Vqs_Vb2_c2_Vdt_GND=Vqs_Vb2_c2_Vdt_GND;
  Vqs_Vb2_c2_Vb2_c2=Vqs_Vb2_c2_Vb2_c2;
  Vqs_Vb2_c2_Vb2_c1=Vqs_Vb2_c2_Vb2_c1;
  Vqs_Vb2_c2_Vc1_c2=Vqs_Vb2_c2_Vc1_c2;
#endif
Vqs_Vb2_c1=Vqs_Vb2_c1;
#if defined(_DERIVATE2)
  Vqs_Vb2_c1_Vdt_GND=Vqs_Vb2_c1_Vdt_GND;
  Vqs_Vb2_c1_Vb2_c2=Vqs_Vb2_c1_Vb2_c2;
  Vqs_Vb2_c1_Vb2_c1=Vqs_Vb2_c1_Vb2_c1;
  Vqs_Vb2_c1_Vc1_c2=Vqs_Vb2_c1_Vc1_c2;
#endif
Vqs_Vc1_c2=Vqs_Vc1_c2;
#if defined(_DERIVATE2)
  Vqs_Vc1_c2_Vdt_GND=Vqs_Vc1_c2_Vdt_GND;
  Vqs_Vc1_c2_Vb2_c2=Vqs_Vc1_c2_Vb2_c2;
  Vqs_Vc1_c2_Vb2_c1=Vqs_Vc1_c2_Vb2_c1;
  Vqs_Vc1_c2_Vc1_c2=Vqs_Vc1_c2_Vc1_c2;
#endif
#endif
Vqs=Vqs;
EXIT_IF_ISNAN(Vqs)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b1,GND)V(s,GND) */
#if defined(_DERIVATE)
Iqs_Vdt_GND=((((Vqs_Vdt_GND*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vdt_GND))*(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*(Vqs_Vdt_GND+(IHC_M*RCV_TM_Vdt_GND))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#endif
Iqs_Vb2_c2=((((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c2))*(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c2))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#if defined(_DERIVATE2)
  Iqs_Vb2_c2_Vdt_GND=((+Vqs_Vb2_c2_Vdt_GND*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c2*(Vqs_Vdt_GND+(0.0))+Vqs_Vdt_GND*Vqs_Vb2_c2+Vqs*(+Vqs_Vb2_c2_Vdt_GND+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c2))*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))+(((Vqs_Vdt_GND*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vdt_GND+(0.0)))))*(SCRCV_M*Vqs_Vb2_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))+0.0*Vqs_Vb2_c2+SCRCV_M*(+Vqs_Vb2_c2_Vdt_GND+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c2)*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c2_Vb2_c2=((+Vqs_Vb2_c2_Vb2_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c2*(Vqs_Vb2_c2+(0.0))+Vqs_Vb2_c2*Vqs_Vb2_c2+Vqs*(+Vqs_Vb2_c2_Vb2_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c2))*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))+(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c2+(0.0)))))*(SCRCV_M*Vqs_Vb2_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c2+(0.0))+0.0*Vqs_Vb2_c2+SCRCV_M*(+Vqs_Vb2_c2_Vb2_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c2)*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c2_Vb2_c1=((+Vqs_Vb2_c2_Vb2_c1*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c2*(Vqs_Vb2_c1+(0.0))+Vqs_Vb2_c1*Vqs_Vb2_c2+Vqs*(+Vqs_Vb2_c2_Vb2_c1+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c2))*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))+(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c1+(0.0)))))*(SCRCV_M*Vqs_Vb2_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c1+(0.0))+0.0*Vqs_Vb2_c2+SCRCV_M*(+Vqs_Vb2_c2_Vb2_c1+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c2)*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c2_Vc1_c2=((+Vqs_Vb2_c2_Vc1_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c2*(Vqs_Vc1_c2+(0.0))+Vqs_Vc1_c2*Vqs_Vb2_c2+Vqs*(+Vqs_Vb2_c2_Vc1_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c2))*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))+(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vc1_c2+(0.0)))))*(SCRCV_M*Vqs_Vb2_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vc1_c2+(0.0))+0.0*Vqs_Vb2_c2+SCRCV_M*(+Vqs_Vb2_c2_Vc1_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c2)*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#endif
Iqs_Vb2_c1=((((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c1))*(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c1))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#if defined(_DERIVATE2)
  Iqs_Vb2_c1_Vdt_GND=((+Vqs_Vb2_c1_Vdt_GND*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c1*(Vqs_Vdt_GND+(0.0))+Vqs_Vdt_GND*Vqs_Vb2_c1+Vqs*(+Vqs_Vb2_c1_Vdt_GND+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c1))*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))+(((Vqs_Vdt_GND*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vdt_GND+(0.0)))))*(SCRCV_M*Vqs_Vb2_c1)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))+0.0*Vqs_Vb2_c1+SCRCV_M*(+Vqs_Vb2_c1_Vdt_GND+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c1)*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c1_Vb2_c2=((+Vqs_Vb2_c1_Vb2_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c1*(Vqs_Vb2_c2+(0.0))+Vqs_Vb2_c2*Vqs_Vb2_c1+Vqs*(+Vqs_Vb2_c1_Vb2_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c1))*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))+(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c2+(0.0)))))*(SCRCV_M*Vqs_Vb2_c1)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c2+(0.0))+0.0*Vqs_Vb2_c1+SCRCV_M*(+Vqs_Vb2_c1_Vb2_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c1)*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c1_Vb2_c1=((+Vqs_Vb2_c1_Vb2_c1*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c1*(Vqs_Vb2_c1+(0.0))+Vqs_Vb2_c1*Vqs_Vb2_c1+Vqs*(+Vqs_Vb2_c1_Vb2_c1+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c1))*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))+(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c1+(0.0)))))*(SCRCV_M*Vqs_Vb2_c1)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c1+(0.0))+0.0*Vqs_Vb2_c1+SCRCV_M*(+Vqs_Vb2_c1_Vb2_c1+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c1)*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vb2_c1_Vc1_c2=((+Vqs_Vb2_c1_Vc1_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vb2_c1*(Vqs_Vc1_c2+(0.0))+Vqs_Vc1_c2*Vqs_Vb2_c1+Vqs*(+Vqs_Vb2_c1_Vc1_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vb2_c1))*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))+(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vc1_c2+(0.0)))))*(SCRCV_M*Vqs_Vb2_c1)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vc1_c2+(0.0))+0.0*Vqs_Vb2_c1+SCRCV_M*(+Vqs_Vb2_c1_Vc1_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vb2_c1)*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#endif
Iqs_Vc1_c2=((((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vc1_c2))*(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vc1_c2))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#if defined(_DERIVATE2)
  Iqs_Vc1_c2_Vdt_GND=((+Vqs_Vc1_c2_Vdt_GND*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vc1_c2*(Vqs_Vdt_GND+(0.0))+Vqs_Vdt_GND*Vqs_Vc1_c2+Vqs*(+Vqs_Vc1_c2_Vdt_GND+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vc1_c2))*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))+(((Vqs_Vdt_GND*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vdt_GND+(0.0)))))*(SCRCV_M*Vqs_Vc1_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))+0.0*Vqs_Vc1_c2+SCRCV_M*(+Vqs_Vc1_c2_Vdt_GND+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vc1_c2)*((SCRCV_M*(Vqs_Vdt_GND+((IHC_M*RCV_TM_Vdt_GND)))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vc1_c2_Vb2_c2=((+Vqs_Vc1_c2_Vb2_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vc1_c2*(Vqs_Vb2_c2+(0.0))+Vqs_Vb2_c2*Vqs_Vc1_c2+Vqs*(+Vqs_Vc1_c2_Vb2_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vc1_c2))*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))+(((Vqs_Vb2_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c2+(0.0)))))*(SCRCV_M*Vqs_Vc1_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c2+(0.0))+0.0*Vqs_Vc1_c2+SCRCV_M*(+Vqs_Vc1_c2_Vb2_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vc1_c2)*((SCRCV_M*(Vqs_Vb2_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vc1_c2_Vb2_c1=((+Vqs_Vc1_c2_Vb2_c1*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vc1_c2*(Vqs_Vb2_c1+(0.0))+Vqs_Vb2_c1*Vqs_Vc1_c2+Vqs*(+Vqs_Vc1_c2_Vb2_c1+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vc1_c2))*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))+(((Vqs_Vb2_c1*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vb2_c1+(0.0)))))*(SCRCV_M*Vqs_Vc1_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vb2_c1+(0.0))+0.0*Vqs_Vc1_c2+SCRCV_M*(+Vqs_Vc1_c2_Vb2_c1+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vc1_c2)*((SCRCV_M*(Vqs_Vb2_c1+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
  Iqs_Vc1_c2_Vc1_c2=((+Vqs_Vc1_c2_Vc1_c2*(Vqs+(IHC_M*SCRCV_M))+Vqs_Vc1_c2*(Vqs_Vc1_c2+(0.0))+Vqs_Vc1_c2*Vqs_Vc1_c2+Vqs*(+Vqs_Vc1_c2_Vc1_c2+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))-(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*Vqs_Vc1_c2))*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))+(((Vqs_Vc1_c2*(Vqs+(IHC_M*SCRCV_M)))+(Vqs*(Vqs_Vc1_c2+(0.0)))))*(SCRCV_M*Vqs_Vc1_c2)+(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(+0.0*(Vqs+(IHC_M*RCV_TM))+0.0*(Vqs_Vc1_c2+(0.0))+0.0*Vqs_Vc1_c2+SCRCV_M*(+Vqs_Vc1_c2_Vc1_c2+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+IHC_M*0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))+2*(Vqs*(Vqs+(IHC_M*SCRCV_M)))*(SCRCV_M*Vqs_Vc1_c2)*((SCRCV_M*(Vqs_Vc1_c2+(0.0))))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
#endif
#endif
Iqs=((Vqs*(Vqs+(IHC_M*SCRCV_M)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM))));
EXIT_IF_ISNAN(((Vqs*(Vqs+(IHC_M*SCRCV_M)))/(SCRCV_M*(Vqs+(IHC_M*RCV_TM)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b,GND)V(b2,GND)V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Ic1c2_Iqs_Vdt_GND=((Ic1c2_Vdt_GND*Iqs-Ic1c2*Iqs_Vdt_GND)/Iqs/Iqs);
#endif
Ic1c2_Iqs_Vb2_c2=((Ic1c2_Vb2_c2*Iqs-Ic1c2*Iqs_Vb2_c2)/Iqs/Iqs);
#if defined(_DERIVATE2)
  Ic1c2_Iqs_Vb2_c2_Vdt_GND=(Ic1c2_Vb2_c2_Vdt_GND/Iqs-(Ic1c2_Vb2_c2*Iqs_Vdt_GND+Ic1c2_Vdt_GND*Iqs_Vb2_c2+Ic1c2*Iqs_Vb2_c2_Vdt_GND)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c2*Iqs_Vdt_GND/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c2_Vb2_c2=(Ic1c2_Vb2_c2_Vb2_c2/Iqs-(Ic1c2_Vb2_c2*Iqs_Vb2_c2+Ic1c2_Vb2_c2*Iqs_Vb2_c2+Ic1c2*Iqs_Vb2_c2_Vb2_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c2*Iqs_Vb2_c2/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c2_Vb2_c1=(Ic1c2_Vb2_c2_Vb2_c1/Iqs-(Ic1c2_Vb2_c2*Iqs_Vb2_c1+Ic1c2_Vb2_c1*Iqs_Vb2_c2+Ic1c2*Iqs_Vb2_c2_Vb2_c1)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c2*Iqs_Vb2_c1/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c2_Vc1_c2=(Ic1c2_Vb2_c2_Vc1_c2/Iqs-(Ic1c2_Vb2_c2*Iqs_Vc1_c2+Ic1c2_Vc1_c2*Iqs_Vb2_c2+Ic1c2*Iqs_Vb2_c2_Vc1_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c2*Iqs_Vc1_c2/Iqs/Iqs/Iqs);
#endif
Ic1c2_Iqs_Vb2_c1=((Ic1c2_Vb2_c1*Iqs-Ic1c2*Iqs_Vb2_c1)/Iqs/Iqs);
#if defined(_DERIVATE2)
  Ic1c2_Iqs_Vb2_c1_Vdt_GND=(Ic1c2_Vb2_c1_Vdt_GND/Iqs-(Ic1c2_Vb2_c1*Iqs_Vdt_GND+Ic1c2_Vdt_GND*Iqs_Vb2_c1+Ic1c2*Iqs_Vb2_c1_Vdt_GND)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c1*Iqs_Vdt_GND/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c1_Vb2_c2=(Ic1c2_Vb2_c1_Vb2_c2/Iqs-(Ic1c2_Vb2_c1*Iqs_Vb2_c2+Ic1c2_Vb2_c2*Iqs_Vb2_c1+Ic1c2*Iqs_Vb2_c1_Vb2_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c1*Iqs_Vb2_c2/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c1_Vb2_c1=(Ic1c2_Vb2_c1_Vb2_c1/Iqs-(Ic1c2_Vb2_c1*Iqs_Vb2_c1+Ic1c2_Vb2_c1*Iqs_Vb2_c1+Ic1c2*Iqs_Vb2_c1_Vb2_c1)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c1*Iqs_Vb2_c1/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vb2_c1_Vc1_c2=(Ic1c2_Vb2_c1_Vc1_c2/Iqs-(Ic1c2_Vb2_c1*Iqs_Vc1_c2+Ic1c2_Vc1_c2*Iqs_Vb2_c1+Ic1c2*Iqs_Vb2_c1_Vc1_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vb2_c1*Iqs_Vc1_c2/Iqs/Iqs/Iqs);
#endif
Ic1c2_Iqs_Vc1_c2=((Ic1c2_Vc1_c2*Iqs-Ic1c2*Iqs_Vc1_c2)/Iqs/Iqs);
#if defined(_DERIVATE2)
  Ic1c2_Iqs_Vc1_c2_Vdt_GND=(Ic1c2_Vc1_c2_Vdt_GND/Iqs-(Ic1c2_Vc1_c2*Iqs_Vdt_GND+Ic1c2_Vdt_GND*Iqs_Vc1_c2+Ic1c2*Iqs_Vc1_c2_Vdt_GND)/Iqs/Iqs+2*Ic1c2*Iqs_Vc1_c2*Iqs_Vdt_GND/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vc1_c2_Vb2_c2=(Ic1c2_Vc1_c2_Vb2_c2/Iqs-(Ic1c2_Vc1_c2*Iqs_Vb2_c2+Ic1c2_Vb2_c2*Iqs_Vc1_c2+Ic1c2*Iqs_Vc1_c2_Vb2_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vc1_c2*Iqs_Vb2_c2/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vc1_c2_Vb2_c1=(Ic1c2_Vc1_c2_Vb2_c1/Iqs-(Ic1c2_Vc1_c2*Iqs_Vb2_c1+Ic1c2_Vb2_c1*Iqs_Vc1_c2+Ic1c2*Iqs_Vc1_c2_Vb2_c1)/Iqs/Iqs+2*Ic1c2*Iqs_Vc1_c2*Iqs_Vb2_c1/Iqs/Iqs/Iqs);
  Ic1c2_Iqs_Vc1_c2_Vc1_c2=(Ic1c2_Vc1_c2_Vc1_c2/Iqs-(Ic1c2_Vc1_c2*Iqs_Vc1_c2+Ic1c2_Vc1_c2*Iqs_Vc1_c2+Ic1c2*Iqs_Vc1_c2_Vc1_c2)/Iqs/Iqs+2*Ic1c2*Iqs_Vc1_c2*Iqs_Vc1_c2/Iqs/Iqs/Iqs);
#endif
#endif
Ic1c2_Iqs=(Ic1c2/Iqs);
EXIT_IF_ISNAN((Ic1c2/Iqs))
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=(Ic1c2_Iqs_Vb2_c2/pModel->AXI);
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb_c=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb_b1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vc3_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vc3_c4=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb1_b2=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vc4_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb1_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb2_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb2_c2=((+Ic1c2_Iqs_Vb2_c2_Vb2_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+Ic1c2_Iqs_Vb2_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vb2_c1=((+Ic1c2_Iqs_Vb2_c2_Vb2_c1-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+Ic1c2_Iqs_Vb2_c1*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vc1_c2=((+Ic1c2_Iqs_Vb2_c2_Vc1_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+Ic1c2_Iqs_Vc1_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c2_Vdt_GND=((+Ic1c2_Iqs_Vb2_c2_Vdt_GND-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c2*0.0+Ic1c2_Iqs_Vdt_GND*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
#endif
dxa_Vb2_c1=(Ic1c2_Iqs_Vb2_c1/pModel->AXI);
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb_c=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb_b1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vc3_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vc3_c4=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb1_b2=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vc4_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb1_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb2_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb2_c2=((+Ic1c2_Iqs_Vb2_c1_Vb2_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+Ic1c2_Iqs_Vb2_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vb2_c1=((+Ic1c2_Iqs_Vb2_c1_Vb2_c1-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+Ic1c2_Iqs_Vb2_c1*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vc1_c2=((+Ic1c2_Iqs_Vb2_c1_Vc1_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+Ic1c2_Iqs_Vc1_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vb2_c1_Vdt_GND=((+Ic1c2_Iqs_Vb2_c1_Vdt_GND-0.0)/pModel->AXI-(Ic1c2_Iqs_Vb2_c1*0.0+Ic1c2_Iqs_Vdt_GND*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
#endif
dxa_Vc1_c2=(Ic1c2_Iqs_Vc1_c2/pModel->AXI);
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb_c=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb_b1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vc3_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vc3_c4=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb1_b2=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vc4_c1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb1_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb2_e1=((+0.0-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+0.0*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb2_c2=((+Ic1c2_Iqs_Vc1_c2_Vb2_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+Ic1c2_Iqs_Vb2_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vb2_c1=((+Ic1c2_Iqs_Vc1_c2_Vb2_c1-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+Ic1c2_Iqs_Vb2_c1*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vc1_c2=((+Ic1c2_Iqs_Vc1_c2_Vc1_c2-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+Ic1c2_Iqs_Vc1_c2*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
  dxa_Vc1_c2_Vdt_GND=((+Ic1c2_Iqs_Vc1_c2_Vdt_GND-0.0)/pModel->AXI-(Ic1c2_Iqs_Vc1_c2*0.0+Ic1c2_Iqs_Vdt_GND*0.0+(Ic1c2_Iqs-1.0)*0.0)/pModel->AXI/pModel->AXI+2*(Ic1c2_Iqs-1.0)*0.0*0.0/pModel->AXI/pModel->AXI/pModel->AXI);
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(Ic1c2_Iqs_Vdt_GND/pModel->AXI);
#endif
#endif
dxa=((Ic1c2_Iqs-1.0)/pModel->AXI);
EXIT_IF_ISNAN(((Ic1c2_Iqs-1.0)/pModel->AXI))
if
((Ic1c2_Iqs<1.0))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
alpha1_Vb2_c2=(pModel->AXI*dxa_Vb2_c2*d10_exp0*d10_logE1);
#if defined(_DERIVATE2)
  alpha1_Vb2_c2_Vb2_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c2)))));
  alpha1_Vb2_c2_Vb2_c1=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c1)))));
  alpha1_Vb2_c2_Vc1_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vc1_c2)))));
  alpha1_Vb2_c2_Vdt_GND=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vdt_GND)))));
#endif
alpha1_Vb2_c1=(pModel->AXI*dxa_Vb2_c1*d10_exp0*d10_logE1);
#if defined(_DERIVATE2)
  alpha1_Vb2_c1_Vb2_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c2)))));
  alpha1_Vb2_c1_Vb2_c1=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c1)))));
  alpha1_Vb2_c1_Vc1_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vc1_c2)))));
  alpha1_Vb2_c1_Vdt_GND=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vdt_GND)))));
#endif
alpha1_Vc1_c2=(pModel->AXI*dxa_Vc1_c2*d10_exp0*d10_logE1);
#if defined(_DERIVATE2)
  alpha1_Vc1_c2_Vb2_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c2)))));
  alpha1_Vc1_c2_Vb2_c1=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c1)))));
  alpha1_Vc1_c2_Vc1_c2=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vc1_c2)))));
  alpha1_Vc1_c2_Vdt_GND=(+0.0+(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vdt_GND)))));
#endif
#if defined(_DERIVATE)
alpha1_Vdt_GND=(pModel->AXI*dxa_Vdt_GND*d10_exp0*d10_logE1);
#endif
#endif
alpha1=(1.0+(pModel->AXI*d00_logE1));
EXIT_IF_ISNAN((1.0+(pModel->AXI*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
alpha1_Vb2_c2=(Ic1c2_Iqs_Vb2_c2+(pModel->AXI*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  alpha1_Vb2_c2_Vb2_c2=(+Ic1c2_Iqs_Vb2_c2_Vb2_c2+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  alpha1_Vb2_c2_Vb2_c1=(+Ic1c2_Iqs_Vb2_c2_Vb2_c1+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  alpha1_Vb2_c2_Vc1_c2=(+Ic1c2_Iqs_Vb2_c2_Vc1_c2+(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  alpha1_Vb2_c2_Vdt_GND=(+Ic1c2_Iqs_Vb2_c2_Vdt_GND+(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
#endif
alpha1_Vb2_c1=(Ic1c2_Iqs_Vb2_c1+(pModel->AXI*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  alpha1_Vb2_c1_Vb2_c2=(+Ic1c2_Iqs_Vb2_c1_Vb2_c2+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  alpha1_Vb2_c1_Vb2_c1=(+Ic1c2_Iqs_Vb2_c1_Vb2_c1+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  alpha1_Vb2_c1_Vc1_c2=(+Ic1c2_Iqs_Vb2_c1_Vc1_c2+(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  alpha1_Vb2_c1_Vdt_GND=(+Ic1c2_Iqs_Vb2_c1_Vdt_GND+(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
#endif
alpha1_Vc1_c2=(Ic1c2_Iqs_Vc1_c2+(pModel->AXI*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  alpha1_Vc1_c2_Vb2_c2=(+Ic1c2_Iqs_Vc1_c2_Vb2_c2+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  alpha1_Vc1_c2_Vb2_c1=(+Ic1c2_Iqs_Vc1_c2_Vb2_c1+(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  alpha1_Vc1_c2_Vc1_c2=(+Ic1c2_Iqs_Vc1_c2_Vc1_c2+(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  alpha1_Vc1_c2_Vdt_GND=(+Ic1c2_Iqs_Vc1_c2_Vdt_GND+(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+pModel->AXI*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
alpha1_Vdt_GND=(Ic1c2_Iqs_Vdt_GND+(pModel->AXI*(-dxa_Vdt_GND)*d10_exp0*d10_logE1));
#endif
#endif
alpha1=(Ic1c2_Iqs+(pModel->AXI*d00_logE1));
EXIT_IF_ISNAN((Ic1c2_Iqs+(pModel->AXI*d00_logE1)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
alpha1_Vb2_c2=alpha1_Vb2_c2;
#if defined(_DERIVATE2)
  alpha1_Vb2_c2_Vb2_c2=alpha1_Vb2_c2_Vb2_c2;
  alpha1_Vb2_c2_Vb2_c1=alpha1_Vb2_c2_Vb2_c1;
  alpha1_Vb2_c2_Vc1_c2=alpha1_Vb2_c2_Vc1_c2;
  alpha1_Vb2_c2_Vdt_GND=alpha1_Vb2_c2_Vdt_GND;
#endif
alpha1_Vb2_c1=alpha1_Vb2_c1;
#if defined(_DERIVATE2)
  alpha1_Vb2_c1_Vb2_c2=alpha1_Vb2_c1_Vb2_c2;
  alpha1_Vb2_c1_Vb2_c1=alpha1_Vb2_c1_Vb2_c1;
  alpha1_Vb2_c1_Vc1_c2=alpha1_Vb2_c1_Vc1_c2;
  alpha1_Vb2_c1_Vdt_GND=alpha1_Vb2_c1_Vdt_GND;
#endif
alpha1_Vc1_c2=alpha1_Vc1_c2;
#if defined(_DERIVATE2)
  alpha1_Vc1_c2_Vb2_c2=alpha1_Vc1_c2_Vb2_c2;
  alpha1_Vc1_c2_Vb2_c1=alpha1_Vc1_c2_Vb2_c1;
  alpha1_Vc1_c2_Vc1_c2=alpha1_Vc1_c2_Vc1_c2;
  alpha1_Vc1_c2_Vdt_GND=alpha1_Vc1_c2_Vdt_GND;
#endif
#if defined(_DERIVATE)
alpha1_Vdt_GND=alpha1_Vdt_GND;
#endif
#endif
alpha1=alpha1;
EXIT_IF_ISNAN(alpha1)
{
double m00_exp(d00_exp0,((-1.0)/pModel->AXI))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
alpha_Vb2_c2=(alpha1_Vb2_c2/(1.0+(pModel->AXI*d00_logE1)));
#if defined(_DERIVATE2)
  alpha_Vb2_c2_Vb2_c2=(alpha1_Vb2_c2_Vb2_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c2*(0.0)+alpha1_Vb2_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c2_Vb2_c1=(alpha1_Vb2_c2_Vb2_c1/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c2*(0.0)+alpha1_Vb2_c1*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c2_Vc1_c2=(alpha1_Vb2_c2_Vc1_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c2*(0.0)+alpha1_Vc1_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c2_Vdt_GND=(alpha1_Vb2_c2_Vdt_GND/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c2*(0.0)+alpha1_Vdt_GND*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
#endif
alpha_Vb2_c1=(alpha1_Vb2_c1/(1.0+(pModel->AXI*d00_logE1)));
#if defined(_DERIVATE2)
  alpha_Vb2_c1_Vb2_c2=(alpha1_Vb2_c1_Vb2_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c1*(0.0)+alpha1_Vb2_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c1_Vb2_c1=(alpha1_Vb2_c1_Vb2_c1/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c1*(0.0)+alpha1_Vb2_c1*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c1_Vc1_c2=(alpha1_Vb2_c1_Vc1_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c1*(0.0)+alpha1_Vc1_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vb2_c1_Vdt_GND=(alpha1_Vb2_c1_Vdt_GND/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vb2_c1*(0.0)+alpha1_Vdt_GND*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
#endif
alpha_Vc1_c2=(alpha1_Vc1_c2/(1.0+(pModel->AXI*d00_logE1)));
#if defined(_DERIVATE2)
  alpha_Vc1_c2_Vb2_c2=(alpha1_Vc1_c2_Vb2_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vc1_c2*(0.0)+alpha1_Vb2_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vc1_c2_Vb2_c1=(alpha1_Vc1_c2_Vb2_c1/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vc1_c2*(0.0)+alpha1_Vb2_c1*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vc1_c2_Vc1_c2=(alpha1_Vc1_c2_Vc1_c2/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vc1_c2*(0.0)+alpha1_Vc1_c2*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
  alpha_Vc1_c2_Vdt_GND=(alpha1_Vc1_c2_Vdt_GND/(1.0+(pModel->AXI*d00_logE1))-(alpha1_Vc1_c2*(0.0)+alpha1_Vdt_GND*0.0+alpha1*(+0.0+(+0.0*d00_logE1+0.0*0.0+0.0*0.0+pModel->AXI*0.0)))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))+2*alpha1*0.0*(0.0)/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1))/(1.0+(pModel->AXI*d00_logE1)));
#endif
#if defined(_DERIVATE)
alpha_Vdt_GND=(alpha1_Vdt_GND/(1.0+(pModel->AXI*d00_logE1)));
#endif
#endif
alpha=(alpha1/(1.0+(pModel->AXI*d00_logE1)));
EXIT_IF_ISNAN((alpha1/(1.0+(pModel->AXI*d00_logE1))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
vyi_Vdt_GND=(Vqs_Vdt_GND/(IHC_M*SCRCV_M));
#endif
vyi_Vb2_c2=(Vqs_Vb2_c2/(IHC_M*SCRCV_M));
#if defined(_DERIVATE2)
  vyi_Vb2_c2_Vdt_GND=(Vqs_Vb2_c2_Vdt_GND/(IHC_M*SCRCV_M)-(Vqs_Vb2_c2*(0.0)+Vqs_Vdt_GND*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c2_Vb2_c2=(Vqs_Vb2_c2_Vb2_c2/(IHC_M*SCRCV_M)-(Vqs_Vb2_c2*(0.0)+Vqs_Vb2_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c2_Vb2_c1=(Vqs_Vb2_c2_Vb2_c1/(IHC_M*SCRCV_M)-(Vqs_Vb2_c2*(0.0)+Vqs_Vb2_c1*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c2_Vc1_c2=(Vqs_Vb2_c2_Vc1_c2/(IHC_M*SCRCV_M)-(Vqs_Vb2_c2*(0.0)+Vqs_Vc1_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
#endif
vyi_Vb2_c1=(Vqs_Vb2_c1/(IHC_M*SCRCV_M));
#if defined(_DERIVATE2)
  vyi_Vb2_c1_Vdt_GND=(Vqs_Vb2_c1_Vdt_GND/(IHC_M*SCRCV_M)-(Vqs_Vb2_c1*(0.0)+Vqs_Vdt_GND*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c1_Vb2_c2=(Vqs_Vb2_c1_Vb2_c2/(IHC_M*SCRCV_M)-(Vqs_Vb2_c1*(0.0)+Vqs_Vb2_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c1_Vb2_c1=(Vqs_Vb2_c1_Vb2_c1/(IHC_M*SCRCV_M)-(Vqs_Vb2_c1*(0.0)+Vqs_Vb2_c1*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vb2_c1_Vc1_c2=(Vqs_Vb2_c1_Vc1_c2/(IHC_M*SCRCV_M)-(Vqs_Vb2_c1*(0.0)+Vqs_Vc1_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
#endif
vyi_Vc1_c2=(Vqs_Vc1_c2/(IHC_M*SCRCV_M));
#if defined(_DERIVATE2)
  vyi_Vc1_c2_Vdt_GND=(Vqs_Vc1_c2_Vdt_GND/(IHC_M*SCRCV_M)-(Vqs_Vc1_c2*(0.0)+Vqs_Vdt_GND*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vc1_c2_Vb2_c2=(Vqs_Vc1_c2_Vb2_c2/(IHC_M*SCRCV_M)-(Vqs_Vc1_c2*(0.0)+Vqs_Vb2_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vc1_c2_Vb2_c1=(Vqs_Vc1_c2_Vb2_c1/(IHC_M*SCRCV_M)-(Vqs_Vc1_c2*(0.0)+Vqs_Vb2_c1*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
  vyi_Vc1_c2_Vc1_c2=(Vqs_Vc1_c2_Vc1_c2/(IHC_M*SCRCV_M)-(Vqs_Vc1_c2*(0.0)+Vqs_Vc1_c2*0.0+Vqs*(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+IHC_M*0.0))/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)+2*Vqs*0.0*(0.0)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M)/(IHC_M*SCRCV_M));
#endif
#endif
vyi=(Vqs/(IHC_M*SCRCV_M));
EXIT_IF_ISNAN((Vqs/(IHC_M*SCRCV_M)))
{
double m00_sqrt(d00_sqrt0,(1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
yi_Vb2_c2=(((((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))*d10_sqrt0*((2.0*alpha)*(1.0+vyi))-(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#if defined(_DERIVATE2)
  yi_Vb2_c2_Vb2_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*(((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vb2_c2+4.0*alpha_Vb2_c2_Vb2_c2)*vyi+(4.0*alpha_Vb2_c2)*vyi_Vb2_c2+((4.0*alpha_Vb2_c2))*vyi_Vb2_c2+(4.0*alpha)*vyi_Vb2_c2_Vb2_c2)*(1.0+vyi)+(((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*vyi_Vb2_c2+(((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*vyi_Vb2_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c2_Vb2_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))*d10_sqrt0*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))+((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*d10_sqrt0*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vb2_c2+2.0*alpha_Vb2_c2_Vb2_c2)*(1.0+vyi)+(2.0*alpha_Vb2_c2)*vyi_Vb2_c2+((2.0*alpha_Vb2_c2))*vyi_Vb2_c2+(2.0*alpha)*(+0.0+vyi_Vb2_c2_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c2_Vb2_c1=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*(((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vb2_c2+4.0*alpha_Vb2_c2_Vb2_c1)*vyi+(4.0*alpha_Vb2_c2)*vyi_Vb2_c1+((4.0*alpha_Vb2_c1))*vyi_Vb2_c2+(4.0*alpha)*vyi_Vb2_c2_Vb2_c1)*(1.0+vyi)+(((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*vyi_Vb2_c1+(((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*vyi_Vb2_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c2_Vb2_c1)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))*d10_sqrt0*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))+((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*d10_sqrt0*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vb2_c2+2.0*alpha_Vb2_c2_Vb2_c1)*(1.0+vyi)+(2.0*alpha_Vb2_c2)*vyi_Vb2_c1+((2.0*alpha_Vb2_c1))*vyi_Vb2_c2+(2.0*alpha)*(+0.0+vyi_Vb2_c2_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c2_Vc1_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*(((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vb2_c2+4.0*alpha_Vb2_c2_Vc1_c2)*vyi+(4.0*alpha_Vb2_c2)*vyi_Vc1_c2+((4.0*alpha_Vc1_c2))*vyi_Vb2_c2+(4.0*alpha)*vyi_Vb2_c2_Vc1_c2)*(1.0+vyi)+(((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*vyi_Vc1_c2+(((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*vyi_Vb2_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c2_Vc1_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))*d10_sqrt0*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))+((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*d10_sqrt0*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vb2_c2+2.0*alpha_Vb2_c2_Vc1_c2)*(1.0+vyi)+(2.0*alpha_Vb2_c2)*vyi_Vc1_c2+((2.0*alpha_Vc1_c2))*vyi_Vb2_c2+(2.0*alpha)*(+0.0+vyi_Vb2_c2_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c2_Vdt_GND=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*(((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vb2_c2+4.0*alpha_Vb2_c2_Vdt_GND)*vyi+(4.0*alpha_Vb2_c2)*vyi_Vdt_GND+((4.0*alpha_Vdt_GND))*vyi_Vb2_c2+(4.0*alpha)*vyi_Vb2_c2_Vdt_GND)*(1.0+vyi)+(((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*vyi_Vdt_GND+(((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*vyi_Vb2_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c2_Vdt_GND)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c2)*vyi)+((4.0*alpha)*vyi_Vb2_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2))*d10_sqrt0*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))+((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*d10_sqrt0*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vb2_c2+2.0*alpha_Vb2_c2_Vdt_GND)*(1.0+vyi)+(2.0*alpha_Vb2_c2)*vyi_Vdt_GND+((2.0*alpha_Vdt_GND))*vyi_Vb2_c2+(2.0*alpha)*(+0.0+vyi_Vb2_c2_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2))*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#endif
yi_Vb2_c1=(((((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))*d10_sqrt0*((2.0*alpha)*(1.0+vyi))-(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#if defined(_DERIVATE2)
  yi_Vb2_c1_Vb2_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*(((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vb2_c1+4.0*alpha_Vb2_c1_Vb2_c2)*vyi+(4.0*alpha_Vb2_c1)*vyi_Vb2_c2+((4.0*alpha_Vb2_c2))*vyi_Vb2_c1+(4.0*alpha)*vyi_Vb2_c1_Vb2_c2)*(1.0+vyi)+(((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*vyi_Vb2_c2+(((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*vyi_Vb2_c1+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c1_Vb2_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))*d10_sqrt0*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))+((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*d10_sqrt0*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vb2_c1+2.0*alpha_Vb2_c1_Vb2_c2)*(1.0+vyi)+(2.0*alpha_Vb2_c1)*vyi_Vb2_c2+((2.0*alpha_Vb2_c2))*vyi_Vb2_c1+(2.0*alpha)*(+0.0+vyi_Vb2_c1_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c1_Vb2_c1=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*(((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vb2_c1+4.0*alpha_Vb2_c1_Vb2_c1)*vyi+(4.0*alpha_Vb2_c1)*vyi_Vb2_c1+((4.0*alpha_Vb2_c1))*vyi_Vb2_c1+(4.0*alpha)*vyi_Vb2_c1_Vb2_c1)*(1.0+vyi)+(((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*vyi_Vb2_c1+(((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*vyi_Vb2_c1+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c1_Vb2_c1)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))*d10_sqrt0*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))+((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*d10_sqrt0*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vb2_c1+2.0*alpha_Vb2_c1_Vb2_c1)*(1.0+vyi)+(2.0*alpha_Vb2_c1)*vyi_Vb2_c1+((2.0*alpha_Vb2_c1))*vyi_Vb2_c1+(2.0*alpha)*(+0.0+vyi_Vb2_c1_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c1_Vc1_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*(((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vb2_c1+4.0*alpha_Vb2_c1_Vc1_c2)*vyi+(4.0*alpha_Vb2_c1)*vyi_Vc1_c2+((4.0*alpha_Vc1_c2))*vyi_Vb2_c1+(4.0*alpha)*vyi_Vb2_c1_Vc1_c2)*(1.0+vyi)+(((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*vyi_Vc1_c2+(((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*vyi_Vb2_c1+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c1_Vc1_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))*d10_sqrt0*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))+((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*d10_sqrt0*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vb2_c1+2.0*alpha_Vb2_c1_Vc1_c2)*(1.0+vyi)+(2.0*alpha_Vb2_c1)*vyi_Vc1_c2+((2.0*alpha_Vc1_c2))*vyi_Vb2_c1+(2.0*alpha)*(+0.0+vyi_Vb2_c1_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vb2_c1_Vdt_GND=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*(((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vb2_c1+4.0*alpha_Vb2_c1_Vdt_GND)*vyi+(4.0*alpha_Vb2_c1)*vyi_Vdt_GND+((4.0*alpha_Vdt_GND))*vyi_Vb2_c1+(4.0*alpha)*vyi_Vb2_c1_Vdt_GND)*(1.0+vyi)+(((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*vyi_Vdt_GND+(((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*vyi_Vb2_c1+((4.0*alpha)*vyi)*(+0.0+vyi_Vb2_c1_Vdt_GND)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vb2_c1)*vyi)+((4.0*alpha)*vyi_Vb2_c1))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1))*d10_sqrt0*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))+((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*d10_sqrt0*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vb2_c1+2.0*alpha_Vb2_c1_Vdt_GND)*(1.0+vyi)+(2.0*alpha_Vb2_c1)*vyi_Vdt_GND+((2.0*alpha_Vdt_GND))*vyi_Vb2_c1+(2.0*alpha)*(+0.0+vyi_Vb2_c1_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vb2_c1)*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1))*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#endif
yi_Vc1_c2=(((((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))*d10_sqrt0*((2.0*alpha)*(1.0+vyi))-(1.0+d00_sqrt0)*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#if defined(_DERIVATE2)
  yi_Vc1_c2_Vb2_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*(((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vc1_c2+4.0*alpha_Vc1_c2_Vb2_c2)*vyi+(4.0*alpha_Vc1_c2)*vyi_Vb2_c2+((4.0*alpha_Vb2_c2))*vyi_Vc1_c2+(4.0*alpha)*vyi_Vc1_c2_Vb2_c2)*(1.0+vyi)+(((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*vyi_Vb2_c2+(((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*vyi_Vc1_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vc1_c2_Vb2_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))*d10_sqrt0*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))+((((((((4.0*alpha_Vb2_c2))*vyi)+((4.0*alpha)*vyi_Vb2_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c2)))*d10_sqrt0*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c2+0.0*alpha_Vc1_c2+2.0*alpha_Vc1_c2_Vb2_c2)*(1.0+vyi)+(2.0*alpha_Vc1_c2)*vyi_Vb2_c2+((2.0*alpha_Vb2_c2))*vyi_Vc1_c2+(2.0*alpha)*(+0.0+vyi_Vc1_c2_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))*(((((2.0*alpha_Vb2_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vc1_c2_Vb2_c1=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*(((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vc1_c2+4.0*alpha_Vc1_c2_Vb2_c1)*vyi+(4.0*alpha_Vc1_c2)*vyi_Vb2_c1+((4.0*alpha_Vb2_c1))*vyi_Vc1_c2+(4.0*alpha)*vyi_Vc1_c2_Vb2_c1)*(1.0+vyi)+(((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*vyi_Vb2_c1+(((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*vyi_Vc1_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vc1_c2_Vb2_c1)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))*d10_sqrt0*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))+((((((((4.0*alpha_Vb2_c1))*vyi)+((4.0*alpha)*vyi_Vb2_c1)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vb2_c1)))*d10_sqrt0*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vb2_c1+0.0*alpha_Vc1_c2+2.0*alpha_Vc1_c2_Vb2_c1)*(1.0+vyi)+(2.0*alpha_Vc1_c2)*vyi_Vb2_c1+((2.0*alpha_Vb2_c1))*vyi_Vc1_c2+(2.0*alpha)*(+0.0+vyi_Vc1_c2_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))*(((((2.0*alpha_Vb2_c1))*(1.0+vyi))+((2.0*alpha)*vyi_Vb2_c1)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vc1_c2_Vc1_c2=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*(((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vc1_c2+4.0*alpha_Vc1_c2_Vc1_c2)*vyi+(4.0*alpha_Vc1_c2)*vyi_Vc1_c2+((4.0*alpha_Vc1_c2))*vyi_Vc1_c2+(4.0*alpha)*vyi_Vc1_c2_Vc1_c2)*(1.0+vyi)+(((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*vyi_Vc1_c2+(((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*vyi_Vc1_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vc1_c2_Vc1_c2)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))*d10_sqrt0*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))+((((((((4.0*alpha_Vc1_c2))*vyi)+((4.0*alpha)*vyi_Vc1_c2)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2)))*d10_sqrt0*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vc1_c2+0.0*alpha_Vc1_c2+2.0*alpha_Vc1_c2_Vc1_c2)*(1.0+vyi)+(2.0*alpha_Vc1_c2)*vyi_Vc1_c2+((2.0*alpha_Vc1_c2))*vyi_Vc1_c2+(2.0*alpha)*(+0.0+vyi_Vc1_c2_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))*(((((2.0*alpha_Vc1_c2))*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
  yi_Vc1_c2_Vdt_GND=((+0.0+(m20_sqrt((1.0+(((4.0*alpha)*vyi)*(1.0+vyi))))*((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*(((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))+d10_sqrt0*(+0.0+(+(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vc1_c2+4.0*alpha_Vc1_c2_Vdt_GND)*vyi+(4.0*alpha_Vc1_c2)*vyi_Vdt_GND+((4.0*alpha_Vdt_GND))*vyi_Vc1_c2+(4.0*alpha)*vyi_Vc1_c2_Vdt_GND)*(1.0+vyi)+(((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*vyi_Vdt_GND+(((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*vyi_Vc1_c2+((4.0*alpha)*vyi)*(+0.0+vyi_Vc1_c2_Vdt_GND)))))/((2.0*alpha)*(1.0+vyi))-((((((4.0*alpha_Vc1_c2)*vyi)+((4.0*alpha)*vyi_Vc1_c2))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vc1_c2))*d10_sqrt0*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))+((((((((4.0*alpha_Vdt_GND))*vyi)+((4.0*alpha)*vyi_Vdt_GND)))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND)))*d10_sqrt0*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))+(1.0+d00_sqrt0)*(+(+0.0*alpha+0.0*alpha_Vdt_GND+0.0*alpha_Vc1_c2+2.0*alpha_Vc1_c2_Vdt_GND)*(1.0+vyi)+(2.0*alpha_Vc1_c2)*vyi_Vdt_GND+((2.0*alpha_Vdt_GND))*vyi_Vc1_c2+(2.0*alpha)*(+0.0+vyi_Vc1_c2_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))+2*(1.0+d00_sqrt0)*(((2.0*alpha_Vc1_c2)*(1.0+vyi))+((2.0*alpha)*vyi_Vc1_c2))*(((((2.0*alpha_Vdt_GND))*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#endif
#if defined(_DERIVATE)
yi_Vdt_GND=(((((((4.0*alpha_Vdt_GND)*vyi)+((4.0*alpha)*vyi_Vdt_GND))*(1.0+vyi))+(((4.0*alpha)*vyi)*vyi_Vdt_GND))*d10_sqrt0*((2.0*alpha)*(1.0+vyi))-(1.0+d00_sqrt0)*(((2.0*alpha_Vdt_GND)*(1.0+vyi))+((2.0*alpha)*vyi_Vdt_GND)))/((2.0*alpha)*(1.0+vyi))/((2.0*alpha)*(1.0+vyi)));
#endif
#endif
yi=((1.0+d00_sqrt0)/((2.0*alpha)*(1.0+vyi)));
EXIT_IF_ISNAN(((1.0+d00_sqrt0)/((2.0*alpha)*(1.0+vyi))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
xi_w_Vb2_c2=((((-yi_Vb2_c2)+(pW*yi_Vb2_c2))*(1.0+(pW*yi))-((1.0-yi)+(pW*yi))*(pW*yi_Vb2_c2))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#if defined(_DERIVATE2)
  xi_w_Vb2_c2_Vb2_c2=((+(+0.0-yi_Vb2_c2_Vb2_c2)+(+0.0*yi+0.0*yi_Vb2_c2+0.0*yi_Vb2_c2+pW*yi_Vb2_c2_Vb2_c2))/(1.0+(pW*yi))-(((-yi_Vb2_c2)+(pW*yi_Vb2_c2))*((pW*yi_Vb2_c2))+((-yi_Vb2_c2)+((pW*yi_Vb2_c2)))*(pW*yi_Vb2_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vb2_c2+0.0*yi_Vb2_c2+pW*yi_Vb2_c2_Vb2_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vb2_c2)*((pW*yi_Vb2_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c2_Vb2_c1=((+(+0.0-yi_Vb2_c2_Vb2_c1)+(+0.0*yi+0.0*yi_Vb2_c1+pW_Vb2_c1*yi_Vb2_c2+pW*yi_Vb2_c2_Vb2_c1))/(1.0+(pW*yi))-(((-yi_Vb2_c2)+(pW*yi_Vb2_c2))*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))+((-yi_Vb2_c1)+(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))))*(pW*yi_Vb2_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vb2_c1+pW_Vb2_c1*yi_Vb2_c2+pW*yi_Vb2_c2_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vb2_c2)*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c2_Vc1_c2=((+(+0.0-yi_Vb2_c2_Vc1_c2)+(+0.0*yi+0.0*yi_Vc1_c2+0.0*yi_Vb2_c2+pW*yi_Vb2_c2_Vc1_c2))/(1.0+(pW*yi))-(((-yi_Vb2_c2)+(pW*yi_Vb2_c2))*((pW*yi_Vc1_c2))+((-yi_Vc1_c2)+((pW*yi_Vc1_c2)))*(pW*yi_Vb2_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vc1_c2+0.0*yi_Vb2_c2+pW*yi_Vb2_c2_Vc1_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vb2_c2)*((pW*yi_Vc1_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c2_Vdt_GND=((+(+0.0-yi_Vb2_c2_Vdt_GND)+(+0.0*yi+0.0*yi_Vdt_GND+pW_Vdt_GND*yi_Vb2_c2+pW*yi_Vb2_c2_Vdt_GND))/(1.0+(pW*yi))-(((-yi_Vb2_c2)+(pW*yi_Vb2_c2))*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))+((-yi_Vdt_GND)+(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND))))*(pW*yi_Vb2_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vdt_GND+pW_Vdt_GND*yi_Vb2_c2+pW*yi_Vb2_c2_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vb2_c2)*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#endif
xi_w_Vb2_c1=((((-yi_Vb2_c1)+((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))*(1.0+(pW*yi))-((1.0-yi)+(pW*yi))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#if defined(_DERIVATE2)
  xi_w_Vb2_c1_Vb2_c2=((+(+0.0-yi_Vb2_c1_Vb2_c2)+(+0.0*yi+pW_Vb2_c1*yi_Vb2_c2+0.0*yi_Vb2_c1+pW*yi_Vb2_c1_Vb2_c2))/(1.0+(pW*yi))-(((-yi_Vb2_c1)+((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))*((pW*yi_Vb2_c2))+((-yi_Vb2_c2)+((pW*yi_Vb2_c2)))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+pW_Vb2_c1*yi_Vb2_c2+0.0*yi_Vb2_c1+pW*yi_Vb2_c1_Vb2_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))*((pW*yi_Vb2_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c1_Vb2_c1=((+(+0.0-yi_Vb2_c1_Vb2_c1)+(+pW_Vb2_c1_Vb2_c1*yi+pW_Vb2_c1*yi_Vb2_c1+pW_Vb2_c1*yi_Vb2_c1+pW*yi_Vb2_c1_Vb2_c1))/(1.0+(pW*yi))-(((-yi_Vb2_c1)+((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))+((-yi_Vb2_c1)+(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))+((1.0-yi)+(pW*yi))*(+0.0+(+pW_Vb2_c1_Vb2_c1*yi+pW_Vb2_c1*yi_Vb2_c1+pW_Vb2_c1*yi_Vb2_c1+pW*yi_Vb2_c1_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c1_Vc1_c2=((+(+0.0-yi_Vb2_c1_Vc1_c2)+(+0.0*yi+pW_Vb2_c1*yi_Vc1_c2+0.0*yi_Vb2_c1+pW*yi_Vb2_c1_Vc1_c2))/(1.0+(pW*yi))-(((-yi_Vb2_c1)+((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))*((pW*yi_Vc1_c2))+((-yi_Vc1_c2)+((pW*yi_Vc1_c2)))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+pW_Vb2_c1*yi_Vc1_c2+0.0*yi_Vb2_c1+pW*yi_Vb2_c1_Vc1_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))*((pW*yi_Vc1_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vb2_c1_Vdt_GND=((+(+0.0-yi_Vb2_c1_Vdt_GND)+(+pW_Vb2_c1_Vdt_GND*yi+pW_Vb2_c1*yi_Vdt_GND+pW_Vdt_GND*yi_Vb2_c1+pW*yi_Vb2_c1_Vdt_GND))/(1.0+(pW*yi))-(((-yi_Vb2_c1)+((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))+((-yi_Vdt_GND)+(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND))))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))+((1.0-yi)+(pW*yi))*(+0.0+(+pW_Vb2_c1_Vdt_GND*yi+pW_Vb2_c1*yi_Vdt_GND+pW_Vdt_GND*yi_Vb2_c1+pW*yi_Vb2_c1_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#endif
xi_w_Vc1_c2=((((-yi_Vc1_c2)+(pW*yi_Vc1_c2))*(1.0+(pW*yi))-((1.0-yi)+(pW*yi))*(pW*yi_Vc1_c2))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#if defined(_DERIVATE2)
  xi_w_Vc1_c2_Vb2_c2=((+(+0.0-yi_Vc1_c2_Vb2_c2)+(+0.0*yi+0.0*yi_Vb2_c2+0.0*yi_Vc1_c2+pW*yi_Vc1_c2_Vb2_c2))/(1.0+(pW*yi))-(((-yi_Vc1_c2)+(pW*yi_Vc1_c2))*((pW*yi_Vb2_c2))+((-yi_Vb2_c2)+((pW*yi_Vb2_c2)))*(pW*yi_Vc1_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vb2_c2+0.0*yi_Vc1_c2+pW*yi_Vc1_c2_Vb2_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vc1_c2)*((pW*yi_Vb2_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vc1_c2_Vb2_c1=((+(+0.0-yi_Vc1_c2_Vb2_c1)+(+0.0*yi+0.0*yi_Vb2_c1+pW_Vb2_c1*yi_Vc1_c2+pW*yi_Vc1_c2_Vb2_c1))/(1.0+(pW*yi))-(((-yi_Vc1_c2)+(pW*yi_Vc1_c2))*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))+((-yi_Vb2_c1)+(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1))))*(pW*yi_Vc1_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vb2_c1+pW_Vb2_c1*yi_Vc1_c2+pW*yi_Vc1_c2_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vc1_c2)*(((pW_Vb2_c1*yi)+(pW*yi_Vb2_c1)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vc1_c2_Vc1_c2=((+(+0.0-yi_Vc1_c2_Vc1_c2)+(+0.0*yi+0.0*yi_Vc1_c2+0.0*yi_Vc1_c2+pW*yi_Vc1_c2_Vc1_c2))/(1.0+(pW*yi))-(((-yi_Vc1_c2)+(pW*yi_Vc1_c2))*((pW*yi_Vc1_c2))+((-yi_Vc1_c2)+((pW*yi_Vc1_c2)))*(pW*yi_Vc1_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vc1_c2+0.0*yi_Vc1_c2+pW*yi_Vc1_c2_Vc1_c2)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vc1_c2)*((pW*yi_Vc1_c2))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
  xi_w_Vc1_c2_Vdt_GND=((+(+0.0-yi_Vc1_c2_Vdt_GND)+(+0.0*yi+0.0*yi_Vdt_GND+pW_Vdt_GND*yi_Vc1_c2+pW*yi_Vc1_c2_Vdt_GND))/(1.0+(pW*yi))-(((-yi_Vc1_c2)+(pW*yi_Vc1_c2))*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))+((-yi_Vdt_GND)+(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND))))*(pW*yi_Vc1_c2)+((1.0-yi)+(pW*yi))*(+0.0+(+0.0*yi+0.0*yi_Vdt_GND+pW_Vdt_GND*yi_Vc1_c2+pW*yi_Vc1_c2_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))+2*((1.0-yi)+(pW*yi))*(pW*yi_Vc1_c2)*(((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#endif
#if defined(_DERIVATE)
xi_w_Vdt_GND=((((-yi_Vdt_GND)+((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))*(1.0+(pW*yi))-((1.0-yi)+(pW*yi))*((pW_Vdt_GND*yi)+(pW*yi_Vdt_GND)))/(1.0+(pW*yi))/(1.0+(pW*yi)));
#endif
#endif
xi_w=(((1.0-yi)+(pW*yi))/(1.0+(pW*yi)));
EXIT_IF_ISNAN((((1.0-yi)+(pW*yi))/(1.0+(pW*yi))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
gp0_Vdt_GND=(((((((0.5*Ic1c2_Vdt_GND)*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND))*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vdt_GND))*VtINV)+((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV_Vdt_GND));
#endif
gp0_Vb2_c2=(((0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2))*VtINV;
#if defined(_DERIVATE2)
  gp0_Vb2_c2_Vdt_GND=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w_Vb2_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2_Vdt_GND)*VtINV+(((0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2))*VtINV_Vdt_GND+((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vdt_GND)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c2_Vb2_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w_Vb2_c2+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w_Vb2_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2_Vb2_c2)*VtINV+(((0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2))*0.0+((((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c2_Vb2_c1=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w_Vb2_c1+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w_Vb2_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2_Vb2_c1)*VtINV+(((0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2))*0.0+((((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c2_Vc1_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c2+0.5*Ic1c2_Vb2_c2_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c2)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w_Vc1_c2+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w_Vb2_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2_Vc1_c2)*VtINV+(((0.5*Ic1c2_Vb2_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2))*0.0+((((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
#endif
gp0_Vb2_c1=(((0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1))*VtINV;
#if defined(_DERIVATE2)
  gp0_Vb2_c1_Vdt_GND=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w_Vb2_c1+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1_Vdt_GND)*VtINV+(((0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1))*VtINV_Vdt_GND+((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vdt_GND)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c1_Vb2_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w_Vb2_c2+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w_Vb2_c1+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1_Vb2_c2)*VtINV+(((0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1))*0.0+((((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c1_Vb2_c1=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w_Vb2_c1+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w_Vb2_c1+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1_Vb2_c1)*VtINV+(((0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1))*0.0+((((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vb2_c1_Vc1_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c1+0.5*Ic1c2_Vb2_c1_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vb2_c1)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w_Vc1_c2+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w_Vb2_c1+((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1_Vc1_c2)*VtINV+(((0.5*Ic1c2_Vb2_c1)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1))*0.0+((((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
#endif
gp0_Vc1_c2=(((0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2))*VtINV;
#if defined(_DERIVATE2)
  gp0_Vc1_c2_Vdt_GND=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vdt_GND)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*RCV_TM_Vdt_GND+((0.5*Ic1c2_Vdt_GND))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w_Vdt_GND+(((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w_Vc1_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2_Vdt_GND)*VtINV+(((0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2))*VtINV_Vdt_GND+((((((((0.5*Ic1c2_Vdt_GND))*RCV_TM)+((0.5*Ic1c2)*RCV_TM_Vdt_GND)))*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vdt_GND)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vc1_c2_Vb2_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vb2_c2)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vb2_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w_Vb2_c2+(((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w_Vc1_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2_Vb2_c2)*VtINV+(((0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2))*0.0+((((((0.5*Ic1c2_Vb2_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vc1_c2_Vb2_c1=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vb2_c1)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vb2_c1))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w_Vb2_c1+(((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w_Vc1_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2_Vb2_c1)*VtINV+(((0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2))*0.0+((((((0.5*Ic1c2_Vb2_c1))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vb2_c1)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
  gp0_Vc1_c2_Vc1_c2=(+(+(+(+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vc1_c2+0.5*Ic1c2_Vc1_c2_Vc1_c2)*RCV_TM+(0.5*Ic1c2_Vc1_c2)*0.0+((0.5*Ic1c2_Vc1_c2))*0.0+(0.5*Ic1c2)*0.0)*xi_w+(0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w_Vc1_c2+(((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w_Vc1_c2+((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2_Vc1_c2)*VtINV+(((0.5*Ic1c2_Vc1_c2)*RCV_TM*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2))*0.0+((((((0.5*Ic1c2_Vc1_c2))*RCV_TM)*xi_w)+(((0.5*Ic1c2)*RCV_TM)*xi_w_Vc1_c2)))*0.0+(((0.5*Ic1c2)*RCV_TM)*xi_w)*0.0);
#endif
#endif
gp0=((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV);
EXIT_IF_ISNAN(((((0.5*Ic1c2)*RCV_TM)*xi_w)*VtINV))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
gp0_help_Vdt_GND=((2.0*gp0_Vdt_GND)+((pW_Vdt_GND*((pW+gp0)+1.0))+(pW*(pW_Vdt_GND+gp0_Vdt_GND))));
#endif
gp0_help_Vb2_c2=((2.0*gp0_Vb2_c2)+(pW*gp0_Vb2_c2));
#if defined(_DERIVATE2)
  gp0_help_Vb2_c2_Vdt_GND=(+(+0.0*gp0+0.0*gp0_Vdt_GND+0.0*gp0_Vb2_c2+2.0*gp0_Vb2_c2_Vdt_GND)+(+0.0*((pW+gp0)+1.0)+0.0*(pW_Vdt_GND+gp0_Vdt_GND)+pW_Vdt_GND*gp0_Vb2_c2+pW*(+(+0.0+gp0_Vb2_c2_Vdt_GND)+0.0)));
  gp0_help_Vb2_c2_Vb2_c2=(+(+0.0*gp0+0.0*gp0_Vb2_c2+0.0*gp0_Vb2_c2+2.0*gp0_Vb2_c2_Vb2_c2)+(+0.0*((pW+gp0)+1.0)+0.0*gp0_Vb2_c2+0.0*gp0_Vb2_c2+pW*(+(+0.0+gp0_Vb2_c2_Vb2_c2)+0.0)));
  gp0_help_Vb2_c2_Vb2_c1=(+(+0.0*gp0+0.0*gp0_Vb2_c1+0.0*gp0_Vb2_c2+2.0*gp0_Vb2_c2_Vb2_c1)+(+0.0*((pW+gp0)+1.0)+0.0*(pW_Vb2_c1+gp0_Vb2_c1)+pW_Vb2_c1*gp0_Vb2_c2+pW*(+(+0.0+gp0_Vb2_c2_Vb2_c1)+0.0)));
  gp0_help_Vb2_c2_Vc1_c2=(+(+0.0*gp0+0.0*gp0_Vc1_c2+0.0*gp0_Vb2_c2+2.0*gp0_Vb2_c2_Vc1_c2)+(+0.0*((pW+gp0)+1.0)+0.0*gp0_Vc1_c2+0.0*gp0_Vb2_c2+pW*(+(+0.0+gp0_Vb2_c2_Vc1_c2)+0.0)));
#endif
gp0_help_Vb2_c1=((2.0*gp0_Vb2_c1)+((pW_Vb2_c1*((pW+gp0)+1.0))+(pW*(pW_Vb2_c1+gp0_Vb2_c1))));
#if defined(_DERIVATE2)
  gp0_help_Vb2_c1_Vdt_GND=(+(+0.0*gp0+0.0*gp0_Vdt_GND+0.0*gp0_Vb2_c1+2.0*gp0_Vb2_c1_Vdt_GND)+(+pW_Vb2_c1_Vdt_GND*((pW+gp0)+1.0)+pW_Vb2_c1*(pW_Vdt_GND+gp0_Vdt_GND)+pW_Vdt_GND*(pW_Vb2_c1+gp0_Vb2_c1)+pW*(+(+pW_Vb2_c1_Vdt_GND+gp0_Vb2_c1_Vdt_GND)+0.0)));
  gp0_help_Vb2_c1_Vb2_c2=(+(+0.0*gp0+0.0*gp0_Vb2_c2+0.0*gp0_Vb2_c1+2.0*gp0_Vb2_c1_Vb2_c2)+(+0.0*((pW+gp0)+1.0)+pW_Vb2_c1*gp0_Vb2_c2+0.0*(pW_Vb2_c1+gp0_Vb2_c1)+pW*(+(+0.0+gp0_Vb2_c1_Vb2_c2)+0.0)));
  gp0_help_Vb2_c1_Vb2_c1=(+(+0.0*gp0+0.0*gp0_Vb2_c1+0.0*gp0_Vb2_c1+2.0*gp0_Vb2_c1_Vb2_c1)+(+pW_Vb2_c1_Vb2_c1*((pW+gp0)+1.0)+pW_Vb2_c1*(pW_Vb2_c1+gp0_Vb2_c1)+pW_Vb2_c1*(pW_Vb2_c1+gp0_Vb2_c1)+pW*(+(+pW_Vb2_c1_Vb2_c1+gp0_Vb2_c1_Vb2_c1)+0.0)));
  gp0_help_Vb2_c1_Vc1_c2=(+(+0.0*gp0+0.0*gp0_Vc1_c2+0.0*gp0_Vb2_c1+2.0*gp0_Vb2_c1_Vc1_c2)+(+0.0*((pW+gp0)+1.0)+pW_Vb2_c1*gp0_Vc1_c2+0.0*(pW_Vb2_c1+gp0_Vb2_c1)+pW*(+(+0.0+gp0_Vb2_c1_Vc1_c2)+0.0)));
#endif
gp0_help_Vc1_c2=((2.0*gp0_Vc1_c2)+(pW*gp0_Vc1_c2));
#if defined(_DERIVATE2)
  gp0_help_Vc1_c2_Vdt_GND=(+(+0.0*gp0+0.0*gp0_Vdt_GND+0.0*gp0_Vc1_c2+2.0*gp0_Vc1_c2_Vdt_GND)+(+0.0*((pW+gp0)+1.0)+0.0*(pW_Vdt_GND+gp0_Vdt_GND)+pW_Vdt_GND*gp0_Vc1_c2+pW*(+(+0.0+gp0_Vc1_c2_Vdt_GND)+0.0)));
  gp0_help_Vc1_c2_Vb2_c2=(+(+0.0*gp0+0.0*gp0_Vb2_c2+0.0*gp0_Vc1_c2+2.0*gp0_Vc1_c2_Vb2_c2)+(+0.0*((pW+gp0)+1.0)+0.0*gp0_Vb2_c2+0.0*gp0_Vc1_c2+pW*(+(+0.0+gp0_Vc1_c2_Vb2_c2)+0.0)));
  gp0_help_Vc1_c2_Vb2_c1=(+(+0.0*gp0+0.0*gp0_Vb2_c1+0.0*gp0_Vc1_c2+2.0*gp0_Vc1_c2_Vb2_c1)+(+0.0*((pW+gp0)+1.0)+0.0*(pW_Vb2_c1+gp0_Vb2_c1)+pW_Vb2_c1*gp0_Vc1_c2+pW*(+(+0.0+gp0_Vc1_c2_Vb2_c1)+0.0)));
  gp0_help_Vc1_c2_Vc1_c2=(+(+0.0*gp0+0.0*gp0_Vc1_c2+0.0*gp0_Vc1_c2+2.0*gp0_Vc1_c2_Vc1_c2)+(+0.0*((pW+gp0)+1.0)+0.0*gp0_Vc1_c2+0.0*gp0_Vc1_c2+pW*(+(+0.0+gp0_Vc1_c2_Vc1_c2)+0.0)));
#endif
#endif
gp0_help=((2.0*gp0)+(pW*((pW+gp0)+1.0)));
EXIT_IF_ISNAN(((2.0*gp0)+(pW*((pW+gp0)+1.0))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
gp02_Vdt_GND=(0.5*gp0_Vdt_GND);
#endif
gp02_Vb2_c2=(0.5*gp0_Vb2_c2);
#if defined(_DERIVATE2)
  gp02_Vb2_c2_Vdt_GND=(+0.0*(gp0-1.0)+0.0*gp0_Vdt_GND+0.0*gp0_Vb2_c2+0.5*(+gp0_Vb2_c2_Vdt_GND-0.0));
  gp02_Vb2_c2_Vb2_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c2+0.0*gp0_Vb2_c2+0.5*(+gp0_Vb2_c2_Vb2_c2-0.0));
  gp02_Vb2_c2_Vb2_c1=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c1+0.0*gp0_Vb2_c2+0.5*(+gp0_Vb2_c2_Vb2_c1-0.0));
  gp02_Vb2_c2_Vc1_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vc1_c2+0.0*gp0_Vb2_c2+0.5*(+gp0_Vb2_c2_Vc1_c2-0.0));
#endif
gp02_Vb2_c1=(0.5*gp0_Vb2_c1);
#if defined(_DERIVATE2)
  gp02_Vb2_c1_Vdt_GND=(+0.0*(gp0-1.0)+0.0*gp0_Vdt_GND+0.0*gp0_Vb2_c1+0.5*(+gp0_Vb2_c1_Vdt_GND-0.0));
  gp02_Vb2_c1_Vb2_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c2+0.0*gp0_Vb2_c1+0.5*(+gp0_Vb2_c1_Vb2_c2-0.0));
  gp02_Vb2_c1_Vb2_c1=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c1+0.0*gp0_Vb2_c1+0.5*(+gp0_Vb2_c1_Vb2_c1-0.0));
  gp02_Vb2_c1_Vc1_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vc1_c2+0.0*gp0_Vb2_c1+0.5*(+gp0_Vb2_c1_Vc1_c2-0.0));
#endif
gp02_Vc1_c2=(0.5*gp0_Vc1_c2);
#if defined(_DERIVATE2)
  gp02_Vc1_c2_Vdt_GND=(+0.0*(gp0-1.0)+0.0*gp0_Vdt_GND+0.0*gp0_Vc1_c2+0.5*(+gp0_Vc1_c2_Vdt_GND-0.0));
  gp02_Vc1_c2_Vb2_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c2+0.0*gp0_Vc1_c2+0.5*(+gp0_Vc1_c2_Vb2_c2-0.0));
  gp02_Vc1_c2_Vb2_c1=(+0.0*(gp0-1.0)+0.0*gp0_Vb2_c1+0.0*gp0_Vc1_c2+0.5*(+gp0_Vc1_c2_Vb2_c1-0.0));
  gp02_Vc1_c2_Vc1_c2=(+0.0*(gp0-1.0)+0.0*gp0_Vc1_c2+0.0*gp0_Vc1_c2+0.5*(+gp0_Vc1_c2_Vc1_c2-0.0));
#endif
#endif
gp02=(0.5*(gp0-1.0));
EXIT_IF_ISNAN((0.5*(gp0-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
sqr_arg_Vdt_GND=(((gp02_Vdt_GND*gp02)+(gp02*gp02_Vdt_GND))+gp0_help_Vdt_GND);
#endif
sqr_arg_Vb2_c2=(((gp02_Vb2_c2*gp02)+(gp02*gp02_Vb2_c2))+gp0_help_Vb2_c2);
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c2_Vdt_GND=(+(+gp02_Vb2_c2_Vdt_GND*gp02+gp02_Vb2_c2*gp02_Vdt_GND+gp02_Vdt_GND*gp02_Vb2_c2+gp02*gp02_Vb2_c2_Vdt_GND)+gp0_help_Vb2_c2_Vdt_GND);
  sqr_arg_Vb2_c2_Vb2_c2=(+(+gp02_Vb2_c2_Vb2_c2*gp02+gp02_Vb2_c2*gp02_Vb2_c2+gp02_Vb2_c2*gp02_Vb2_c2+gp02*gp02_Vb2_c2_Vb2_c2)+gp0_help_Vb2_c2_Vb2_c2);
  sqr_arg_Vb2_c2_Vb2_c1=(+(+gp02_Vb2_c2_Vb2_c1*gp02+gp02_Vb2_c2*gp02_Vb2_c1+gp02_Vb2_c1*gp02_Vb2_c2+gp02*gp02_Vb2_c2_Vb2_c1)+gp0_help_Vb2_c2_Vb2_c1);
  sqr_arg_Vb2_c2_Vc1_c2=(+(+gp02_Vb2_c2_Vc1_c2*gp02+gp02_Vb2_c2*gp02_Vc1_c2+gp02_Vc1_c2*gp02_Vb2_c2+gp02*gp02_Vb2_c2_Vc1_c2)+gp0_help_Vb2_c2_Vc1_c2);
#endif
sqr_arg_Vb2_c1=(((gp02_Vb2_c1*gp02)+(gp02*gp02_Vb2_c1))+gp0_help_Vb2_c1);
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c1_Vdt_GND=(+(+gp02_Vb2_c1_Vdt_GND*gp02+gp02_Vb2_c1*gp02_Vdt_GND+gp02_Vdt_GND*gp02_Vb2_c1+gp02*gp02_Vb2_c1_Vdt_GND)+gp0_help_Vb2_c1_Vdt_GND);
  sqr_arg_Vb2_c1_Vb2_c2=(+(+gp02_Vb2_c1_Vb2_c2*gp02+gp02_Vb2_c1*gp02_Vb2_c2+gp02_Vb2_c2*gp02_Vb2_c1+gp02*gp02_Vb2_c1_Vb2_c2)+gp0_help_Vb2_c1_Vb2_c2);
  sqr_arg_Vb2_c1_Vb2_c1=(+(+gp02_Vb2_c1_Vb2_c1*gp02+gp02_Vb2_c1*gp02_Vb2_c1+gp02_Vb2_c1*gp02_Vb2_c1+gp02*gp02_Vb2_c1_Vb2_c1)+gp0_help_Vb2_c1_Vb2_c1);
  sqr_arg_Vb2_c1_Vc1_c2=(+(+gp02_Vb2_c1_Vc1_c2*gp02+gp02_Vb2_c1*gp02_Vc1_c2+gp02_Vc1_c2*gp02_Vb2_c1+gp02*gp02_Vb2_c1_Vc1_c2)+gp0_help_Vb2_c1_Vc1_c2);
#endif
sqr_arg_Vc1_c2=(((gp02_Vc1_c2*gp02)+(gp02*gp02_Vc1_c2))+gp0_help_Vc1_c2);
#if defined(_DERIVATE2)
  sqr_arg_Vc1_c2_Vdt_GND=(+(+gp02_Vc1_c2_Vdt_GND*gp02+gp02_Vc1_c2*gp02_Vdt_GND+gp02_Vdt_GND*gp02_Vc1_c2+gp02*gp02_Vc1_c2_Vdt_GND)+gp0_help_Vc1_c2_Vdt_GND);
  sqr_arg_Vc1_c2_Vb2_c2=(+(+gp02_Vc1_c2_Vb2_c2*gp02+gp02_Vc1_c2*gp02_Vb2_c2+gp02_Vb2_c2*gp02_Vc1_c2+gp02*gp02_Vc1_c2_Vb2_c2)+gp0_help_Vc1_c2_Vb2_c2);
  sqr_arg_Vc1_c2_Vb2_c1=(+(+gp02_Vc1_c2_Vb2_c1*gp02+gp02_Vc1_c2*gp02_Vb2_c1+gp02_Vb2_c1*gp02_Vc1_c2+gp02*gp02_Vc1_c2_Vb2_c1)+gp0_help_Vc1_c2_Vb2_c1);
  sqr_arg_Vc1_c2_Vc1_c2=(+(+gp02_Vc1_c2_Vc1_c2*gp02+gp02_Vc1_c2*gp02_Vc1_c2+gp02_Vc1_c2*gp02_Vc1_c2+gp02*gp02_Vc1_c2_Vc1_c2)+gp0_help_Vc1_c2_Vc1_c2);
#endif
#endif
sqr_arg=((gp02*gp02)+gp0_help);
EXIT_IF_ISNAN(((gp02*gp02)+gp0_help))
if
((gp0>=1.0))
{
{
double m00_sqrt(d00_sqrt0,sqr_arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,sqr_arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
p0star_Vdt_GND=(gp02_Vdt_GND+sqr_arg_Vdt_GND*d10_sqrt0);
#endif
p0star_Vb2_c2=(gp02_Vb2_c2+sqr_arg_Vb2_c2*d10_sqrt0);
#if defined(_DERIVATE2)
  p0star_Vb2_c2_Vdt_GND=(+gp02_Vb2_c2_Vdt_GND+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vdt_GND));
  p0star_Vb2_c2_Vb2_c2=(+gp02_Vb2_c2_Vb2_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c2));
  p0star_Vb2_c2_Vb2_c1=(+gp02_Vb2_c2_Vb2_c1+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c1));
  p0star_Vb2_c2_Vc1_c2=(+gp02_Vb2_c2_Vc1_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vc1_c2));
#endif
p0star_Vb2_c1=(gp02_Vb2_c1+sqr_arg_Vb2_c1*d10_sqrt0);
#if defined(_DERIVATE2)
  p0star_Vb2_c1_Vdt_GND=(+gp02_Vb2_c1_Vdt_GND+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vdt_GND));
  p0star_Vb2_c1_Vb2_c2=(+gp02_Vb2_c1_Vb2_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c2));
  p0star_Vb2_c1_Vb2_c1=(+gp02_Vb2_c1_Vb2_c1+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c1));
  p0star_Vb2_c1_Vc1_c2=(+gp02_Vb2_c1_Vc1_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vc1_c2));
#endif
p0star_Vc1_c2=(gp02_Vc1_c2+sqr_arg_Vc1_c2*d10_sqrt0);
#if defined(_DERIVATE2)
  p0star_Vc1_c2_Vdt_GND=(+gp02_Vc1_c2_Vdt_GND+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vdt_GND));
  p0star_Vc1_c2_Vb2_c2=(+gp02_Vc1_c2_Vb2_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c2));
  p0star_Vc1_c2_Vb2_c1=(+gp02_Vc1_c2_Vb2_c1+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c1));
  p0star_Vc1_c2_Vc1_c2=(+gp02_Vc1_c2_Vc1_c2+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vc1_c2));
#endif
#endif
p0star=(gp02+d00_sqrt0);
EXIT_IF_ISNAN((gp02+d00_sqrt0))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,sqr_arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,sqr_arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
p0star_Vdt_GND=((gp0_help_Vdt_GND*(d00_sqrt0-gp02)-gp0_help*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#endif
p0star_Vb2_c2=((gp0_help_Vb2_c2*(d00_sqrt0-gp02)-gp0_help*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#if defined(_DERIVATE2)
  p0star_Vb2_c2_Vdt_GND=(gp0_help_Vb2_c2_Vdt_GND/(d00_sqrt0-gp02)-(gp0_help_Vb2_c2*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)+gp0_help_Vdt_GND*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vdt_GND)-gp02_Vb2_c2_Vdt_GND))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c2_Vb2_c2=(gp0_help_Vb2_c2_Vb2_c2/(d00_sqrt0-gp02)-(gp0_help_Vb2_c2*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help_Vb2_c2*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c2)-gp02_Vb2_c2_Vb2_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c2_Vb2_c1=(gp0_help_Vb2_c2_Vb2_c1/(d00_sqrt0-gp02)-(gp0_help_Vb2_c2*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help_Vb2_c1*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c1)-gp02_Vb2_c2_Vb2_c1))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c2_Vc1_c2=(gp0_help_Vb2_c2_Vc1_c2/(d00_sqrt0-gp02)-(gp0_help_Vb2_c2*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help_Vc1_c2*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vc1_c2)-gp02_Vb2_c2_Vc1_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#endif
p0star_Vb2_c1=((gp0_help_Vb2_c1*(d00_sqrt0-gp02)-gp0_help*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#if defined(_DERIVATE2)
  p0star_Vb2_c1_Vdt_GND=(gp0_help_Vb2_c1_Vdt_GND/(d00_sqrt0-gp02)-(gp0_help_Vb2_c1*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)+gp0_help_Vdt_GND*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vdt_GND)-gp02_Vb2_c1_Vdt_GND))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c1_Vb2_c2=(gp0_help_Vb2_c1_Vb2_c2/(d00_sqrt0-gp02)-(gp0_help_Vb2_c1*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help_Vb2_c2*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c2)-gp02_Vb2_c1_Vb2_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c1_Vb2_c1=(gp0_help_Vb2_c1_Vb2_c1/(d00_sqrt0-gp02)-(gp0_help_Vb2_c1*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help_Vb2_c1*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c1)-gp02_Vb2_c1_Vb2_c1))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vb2_c1_Vc1_c2=(gp0_help_Vb2_c1_Vc1_c2/(d00_sqrt0-gp02)-(gp0_help_Vb2_c1*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help_Vc1_c2*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vc1_c2)-gp02_Vb2_c1_Vc1_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#endif
p0star_Vc1_c2=((gp0_help_Vc1_c2*(d00_sqrt0-gp02)-gp0_help*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#if defined(_DERIVATE2)
  p0star_Vc1_c2_Vdt_GND=(gp0_help_Vc1_c2_Vdt_GND/(d00_sqrt0-gp02)-(gp0_help_Vc1_c2*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)+gp0_help_Vdt_GND*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vdt_GND)-gp02_Vc1_c2_Vdt_GND))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)*(sqr_arg_Vdt_GND*d10_sqrt0-gp02_Vdt_GND)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vc1_c2_Vb2_c2=(gp0_help_Vc1_c2_Vb2_c2/(d00_sqrt0-gp02)-(gp0_help_Vc1_c2*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)+gp0_help_Vb2_c2*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c2)-gp02_Vc1_c2_Vb2_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)*(sqr_arg_Vb2_c2*d10_sqrt0-gp02_Vb2_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vc1_c2_Vb2_c1=(gp0_help_Vc1_c2_Vb2_c1/(d00_sqrt0-gp02)-(gp0_help_Vc1_c2*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)+gp0_help_Vb2_c1*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c1)-gp02_Vc1_c2_Vb2_c1))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)*(sqr_arg_Vb2_c1*d10_sqrt0-gp02_Vb2_c1)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
  p0star_Vc1_c2_Vc1_c2=(gp0_help_Vc1_c2_Vc1_c2/(d00_sqrt0-gp02)-(gp0_help_Vc1_c2*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help_Vc1_c2*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)+gp0_help*(+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vc1_c2)-gp02_Vc1_c2_Vc1_c2))/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)+2*gp0_help*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)*(sqr_arg_Vc1_c2*d10_sqrt0-gp02_Vc1_c2)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02)/(d00_sqrt0-gp02));
#endif
#endif
p0star=(gp0_help/(d00_sqrt0-gp02));
EXIT_IF_ISNAN((gp0_help/(d00_sqrt0-gp02)))
}
}
{
double m00_exp(d00_exp0,(VDC_T*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
eVb2c2star_Vdt_GND=((((p0star_Vdt_GND*(p0star+1.0))+(p0star*p0star_Vdt_GND))*d00_exp0)+((p0star*(p0star+1.0))*((VDC_T_Vdt_GND*VtINV)+(VDC_T*VtINV_Vdt_GND))*d10_exp0));
#endif
eVb2c2star_Vb2_c2=((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2))*d00_exp0;
#if defined(_DERIVATE2)
  eVb2c2star_Vb2_c2_Vdt_GND=(+(+p0star_Vb2_c2_Vdt_GND*(p0star+1.0)+p0star_Vb2_c2*p0star_Vdt_GND+p0star_Vdt_GND*p0star_Vb2_c2+p0star*(+p0star_Vb2_c2_Vdt_GND+0.0))*d00_exp0+((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2))*(((VDC_T_Vdt_GND*VtINV)+(VDC_T*VtINV_Vdt_GND)))*d10_exp0+(((p0star_Vdt_GND*(p0star+1.0))+(p0star*p0star_Vdt_GND)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c2_Vb2_c2=(+(+p0star_Vb2_c2_Vb2_c2*(p0star+1.0)+p0star_Vb2_c2*p0star_Vb2_c2+p0star_Vb2_c2*p0star_Vb2_c2+p0star*(+p0star_Vb2_c2_Vb2_c2+0.0))*d00_exp0+((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2))*(0.0)*d10_exp0+(((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c2_Vb2_c1=(+(+p0star_Vb2_c2_Vb2_c1*(p0star+1.0)+p0star_Vb2_c2*p0star_Vb2_c1+p0star_Vb2_c1*p0star_Vb2_c2+p0star*(+p0star_Vb2_c2_Vb2_c1+0.0))*d00_exp0+((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2))*(0.0)*d10_exp0+(((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c2_Vc1_c2=(+(+p0star_Vb2_c2_Vc1_c2*(p0star+1.0)+p0star_Vb2_c2*p0star_Vc1_c2+p0star_Vc1_c2*p0star_Vb2_c2+p0star*(+p0star_Vb2_c2_Vc1_c2+0.0))*d00_exp0+((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2))*(0.0)*d10_exp0+(((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
#endif
eVb2c2star_Vb2_c1=((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1))*d00_exp0;
#if defined(_DERIVATE2)
  eVb2c2star_Vb2_c1_Vdt_GND=(+(+p0star_Vb2_c1_Vdt_GND*(p0star+1.0)+p0star_Vb2_c1*p0star_Vdt_GND+p0star_Vdt_GND*p0star_Vb2_c1+p0star*(+p0star_Vb2_c1_Vdt_GND+0.0))*d00_exp0+((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1))*(((VDC_T_Vdt_GND*VtINV)+(VDC_T*VtINV_Vdt_GND)))*d10_exp0+(((p0star_Vdt_GND*(p0star+1.0))+(p0star*p0star_Vdt_GND)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c1_Vb2_c2=(+(+p0star_Vb2_c1_Vb2_c2*(p0star+1.0)+p0star_Vb2_c1*p0star_Vb2_c2+p0star_Vb2_c2*p0star_Vb2_c1+p0star*(+p0star_Vb2_c1_Vb2_c2+0.0))*d00_exp0+((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1))*(0.0)*d10_exp0+(((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c1_Vb2_c1=(+(+p0star_Vb2_c1_Vb2_c1*(p0star+1.0)+p0star_Vb2_c1*p0star_Vb2_c1+p0star_Vb2_c1*p0star_Vb2_c1+p0star*(+p0star_Vb2_c1_Vb2_c1+0.0))*d00_exp0+((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1))*(0.0)*d10_exp0+(((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vb2_c1_Vc1_c2=(+(+p0star_Vb2_c1_Vc1_c2*(p0star+1.0)+p0star_Vb2_c1*p0star_Vc1_c2+p0star_Vc1_c2*p0star_Vb2_c1+p0star*(+p0star_Vb2_c1_Vc1_c2+0.0))*d00_exp0+((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1))*(0.0)*d10_exp0+(((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
#endif
eVb2c2star_Vc1_c2=((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2))*d00_exp0;
#if defined(_DERIVATE2)
  eVb2c2star_Vc1_c2_Vdt_GND=(+(+p0star_Vc1_c2_Vdt_GND*(p0star+1.0)+p0star_Vc1_c2*p0star_Vdt_GND+p0star_Vdt_GND*p0star_Vc1_c2+p0star*(+p0star_Vc1_c2_Vdt_GND+0.0))*d00_exp0+((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2))*(((VDC_T_Vdt_GND*VtINV)+(VDC_T*VtINV_Vdt_GND)))*d10_exp0+(((p0star_Vdt_GND*(p0star+1.0))+(p0star*p0star_Vdt_GND)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vc1_c2_Vb2_c2=(+(+p0star_Vc1_c2_Vb2_c2*(p0star+1.0)+p0star_Vc1_c2*p0star_Vb2_c2+p0star_Vb2_c2*p0star_Vc1_c2+p0star*(+p0star_Vc1_c2_Vb2_c2+0.0))*d00_exp0+((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2))*(0.0)*d10_exp0+(((p0star_Vb2_c2*(p0star+1.0))+(p0star*p0star_Vb2_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vc1_c2_Vb2_c1=(+(+p0star_Vc1_c2_Vb2_c1*(p0star+1.0)+p0star_Vc1_c2*p0star_Vb2_c1+p0star_Vb2_c1*p0star_Vc1_c2+p0star*(+p0star_Vc1_c2_Vb2_c1+0.0))*d00_exp0+((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2))*(0.0)*d10_exp0+(((p0star_Vb2_c1*(p0star+1.0))+(p0star*p0star_Vb2_c1)))*0.0+(p0star*(p0star+1.0))*0.0);
  eVb2c2star_Vc1_c2_Vc1_c2=(+(+p0star_Vc1_c2_Vc1_c2*(p0star+1.0)+p0star_Vc1_c2*p0star_Vc1_c2+p0star_Vc1_c2*p0star_Vc1_c2+p0star*(+p0star_Vc1_c2_Vc1_c2+0.0))*d00_exp0+((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2))*(0.0)*d10_exp0+(((p0star_Vc1_c2*(p0star+1.0))+(p0star*p0star_Vc1_c2)))*0.0+(p0star*(p0star+1.0))*0.0);
#endif
#endif
eVb2c2star=((p0star*(p0star+1.0))*d00_exp0);
EXIT_IF_ISNAN(((p0star*(p0star+1.0))*d00_exp0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
B1_Vdt_GND=((0.5*SCRCV_M)*Ic1c2_Vdt_GND);
#endif
B1_Vb2_c2=((0.5*SCRCV_M)*Ic1c2_Vb2_c2);
#if defined(_DERIVATE2)
  B1_Vb2_c2_Vdt_GND=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vdt_GND+(0.0)*Ic1c2_Vb2_c2+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c2_Vdt_GND-0.0));
  B1_Vb2_c2_Vb2_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c2+(0.0)*Ic1c2_Vb2_c2+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c2_Vb2_c2-0.0));
  B1_Vb2_c2_Vb2_c1=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c1+(0.0)*Ic1c2_Vb2_c2+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c2_Vb2_c1-0.0));
  B1_Vb2_c2_Vc1_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vc1_c2+(0.0)*Ic1c2_Vb2_c2+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c2_Vc1_c2-0.0));
#endif
B1_Vb2_c1=((0.5*SCRCV_M)*Ic1c2_Vb2_c1);
#if defined(_DERIVATE2)
  B1_Vb2_c1_Vdt_GND=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vdt_GND+(0.0)*Ic1c2_Vb2_c1+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c1_Vdt_GND-0.0));
  B1_Vb2_c1_Vb2_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c2+(0.0)*Ic1c2_Vb2_c1+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c1_Vb2_c2-0.0));
  B1_Vb2_c1_Vb2_c1=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c1+(0.0)*Ic1c2_Vb2_c1+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c1_Vb2_c1-0.0));
  B1_Vb2_c1_Vc1_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vc1_c2+(0.0)*Ic1c2_Vb2_c1+(0.5*SCRCV_M)*(+Ic1c2_Vb2_c1_Vc1_c2-0.0));
#endif
B1_Vc1_c2=((0.5*SCRCV_M)*Ic1c2_Vc1_c2);
#if defined(_DERIVATE2)
  B1_Vc1_c2_Vdt_GND=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vdt_GND+(0.0)*Ic1c2_Vc1_c2+(0.5*SCRCV_M)*(+Ic1c2_Vc1_c2_Vdt_GND-0.0));
  B1_Vc1_c2_Vb2_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c2+(0.0)*Ic1c2_Vc1_c2+(0.5*SCRCV_M)*(+Ic1c2_Vc1_c2_Vb2_c2-0.0));
  B1_Vc1_c2_Vb2_c1=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vb2_c1+(0.0)*Ic1c2_Vc1_c2+(0.5*SCRCV_M)*(+Ic1c2_Vc1_c2_Vb2_c1-0.0));
  B1_Vc1_c2_Vc1_c2=(+(+0.0*SCRCV_M+0.0*0.0+0.0*0.0+0.5*0.0)*(Ic1c2-IHC_M)+0.0*Ic1c2_Vc1_c2+(0.0)*Ic1c2_Vc1_c2+(0.5*SCRCV_M)*(+Ic1c2_Vc1_c2_Vc1_c2-0.0));
#endif
#endif
B1=((0.5*SCRCV_M)*(Ic1c2-IHC_M));
EXIT_IF_ISNAN(((0.5*SCRCV_M)*(Ic1c2-IHC_M)))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
B2_Vdt_GND=(((SCRCV_M*RCV_TM_Vdt_GND)*IHC_M*Ic1c2)+(((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vdt_GND));
#endif
B2_Vb2_c2=(((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c2);
#if defined(_DERIVATE2)
  B2_Vb2_c2_Vdt_GND=(+(+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+((SCRCV_M*RCV_TM_Vdt_GND))*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vdt_GND+(((SCRCV_M*RCV_TM_Vdt_GND))*IHC_M)*Ic1c2_Vb2_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c2_Vdt_GND);
  B2_Vb2_c2_Vb2_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c2+((0.0)*IHC_M)*Ic1c2_Vb2_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c2_Vb2_c2);
  B2_Vb2_c2_Vb2_c1=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c1+((0.0)*IHC_M)*Ic1c2_Vb2_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c2_Vb2_c1);
  B2_Vb2_c2_Vc1_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vc1_c2+((0.0)*IHC_M)*Ic1c2_Vb2_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c2_Vc1_c2);
#endif
B2_Vb2_c1=(((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c1);
#if defined(_DERIVATE2)
  B2_Vb2_c1_Vdt_GND=(+(+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+((SCRCV_M*RCV_TM_Vdt_GND))*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vdt_GND+(((SCRCV_M*RCV_TM_Vdt_GND))*IHC_M)*Ic1c2_Vb2_c1+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c1_Vdt_GND);
  B2_Vb2_c1_Vb2_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c2+((0.0)*IHC_M)*Ic1c2_Vb2_c1+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c1_Vb2_c2);
  B2_Vb2_c1_Vb2_c1=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c1+((0.0)*IHC_M)*Ic1c2_Vb2_c1+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c1_Vb2_c1);
  B2_Vb2_c1_Vc1_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vc1_c2+((0.0)*IHC_M)*Ic1c2_Vb2_c1+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vb2_c1_Vc1_c2);
#endif
B2_Vc1_c2=(((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vc1_c2);
#if defined(_DERIVATE2)
  B2_Vc1_c2_Vdt_GND=(+(+(+0.0*RCV_TM+0.0*RCV_TM_Vdt_GND+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+((SCRCV_M*RCV_TM_Vdt_GND))*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vdt_GND+(((SCRCV_M*RCV_TM_Vdt_GND))*IHC_M)*Ic1c2_Vc1_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vc1_c2_Vdt_GND);
  B2_Vc1_c2_Vb2_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c2+((0.0)*IHC_M)*Ic1c2_Vc1_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vc1_c2_Vb2_c2);
  B2_Vc1_c2_Vb2_c1=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vb2_c1+((0.0)*IHC_M)*Ic1c2_Vc1_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vc1_c2_Vb2_c1);
  B2_Vc1_c2_Vc1_c2=(+(+(+0.0*RCV_TM+0.0*0.0+0.0*0.0+SCRCV_M*0.0)*IHC_M+0.0*0.0+(0.0)*0.0+(SCRCV_M*RCV_TM)*0.0)*Ic1c2+0.0*Ic1c2_Vc1_c2+((0.0)*IHC_M)*Ic1c2_Vc1_c2+((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2_Vc1_c2_Vc1_c2);
#endif
#endif
B2=(((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2);
EXIT_IF_ISNAN((((SCRCV_M*RCV_TM)*IHC_M)*Ic1c2))
{
double m00_sqrt(d00_sqrt0,((B1*B1)+B2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((B1*B1)+B2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND)V(b,GND)V(b1,GND)V(s,GND) */
#if defined(_DERIVATE)
Vxi0_Vdt_GND=(B1_Vdt_GND+(((B1_Vdt_GND*B1)+(B1*B1_Vdt_GND))+B2_Vdt_GND)*d10_sqrt0);
#endif
Vxi0_Vb2_c2=(B1_Vb2_c2+(((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2))+B2_Vb2_c2)*d10_sqrt0);
#if defined(_DERIVATE2)
  Vxi0_Vb2_c2_Vdt_GND=(+B1_Vb2_c2_Vdt_GND+(m20_sqrt(((B1*B1)+B2))*((((B1_Vdt_GND*B1)+(B1*B1_Vdt_GND)))+B2_Vdt_GND)*(((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2))+B2_Vb2_c2)+d10_sqrt0*(+(+B1_Vb2_c2_Vdt_GND*B1+B1_Vb2_c2*B1_Vdt_GND+B1_Vdt_GND*B1_Vb2_c2+B1*B1_Vb2_c2_Vdt_GND)+B2_Vb2_c2_Vdt_GND)));
  Vxi0_Vb2_c2_Vb2_c2=(+B1_Vb2_c2_Vb2_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2)))+B2_Vb2_c2)*(((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2))+B2_Vb2_c2)+d10_sqrt0*(+(+B1_Vb2_c2_Vb2_c2*B1+B1_Vb2_c2*B1_Vb2_c2+B1_Vb2_c2*B1_Vb2_c2+B1*B1_Vb2_c2_Vb2_c2)+B2_Vb2_c2_Vb2_c2)));
  Vxi0_Vb2_c2_Vb2_c1=(+B1_Vb2_c2_Vb2_c1+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1)))+B2_Vb2_c1)*(((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2))+B2_Vb2_c2)+d10_sqrt0*(+(+B1_Vb2_c2_Vb2_c1*B1+B1_Vb2_c2*B1_Vb2_c1+B1_Vb2_c1*B1_Vb2_c2+B1*B1_Vb2_c2_Vb2_c1)+B2_Vb2_c2_Vb2_c1)));
  Vxi0_Vb2_c2_Vc1_c2=(+B1_Vb2_c2_Vc1_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2)))+B2_Vc1_c2)*(((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2))+B2_Vb2_c2)+d10_sqrt0*(+(+B1_Vb2_c2_Vc1_c2*B1+B1_Vb2_c2*B1_Vc1_c2+B1_Vc1_c2*B1_Vb2_c2+B1*B1_Vb2_c2_Vc1_c2)+B2_Vb2_c2_Vc1_c2)));
#endif
Vxi0_Vb2_c1=(B1_Vb2_c1+(((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1))+B2_Vb2_c1)*d10_sqrt0);
#if defined(_DERIVATE2)
  Vxi0_Vb2_c1_Vdt_GND=(+B1_Vb2_c1_Vdt_GND+(m20_sqrt(((B1*B1)+B2))*((((B1_Vdt_GND*B1)+(B1*B1_Vdt_GND)))+B2_Vdt_GND)*(((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1))+B2_Vb2_c1)+d10_sqrt0*(+(+B1_Vb2_c1_Vdt_GND*B1+B1_Vb2_c1*B1_Vdt_GND+B1_Vdt_GND*B1_Vb2_c1+B1*B1_Vb2_c1_Vdt_GND)+B2_Vb2_c1_Vdt_GND)));
  Vxi0_Vb2_c1_Vb2_c2=(+B1_Vb2_c1_Vb2_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2)))+B2_Vb2_c2)*(((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1))+B2_Vb2_c1)+d10_sqrt0*(+(+B1_Vb2_c1_Vb2_c2*B1+B1_Vb2_c1*B1_Vb2_c2+B1_Vb2_c2*B1_Vb2_c1+B1*B1_Vb2_c1_Vb2_c2)+B2_Vb2_c1_Vb2_c2)));
  Vxi0_Vb2_c1_Vb2_c1=(+B1_Vb2_c1_Vb2_c1+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1)))+B2_Vb2_c1)*(((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1))+B2_Vb2_c1)+d10_sqrt0*(+(+B1_Vb2_c1_Vb2_c1*B1+B1_Vb2_c1*B1_Vb2_c1+B1_Vb2_c1*B1_Vb2_c1+B1*B1_Vb2_c1_Vb2_c1)+B2_Vb2_c1_Vb2_c1)));
  Vxi0_Vb2_c1_Vc1_c2=(+B1_Vb2_c1_Vc1_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2)))+B2_Vc1_c2)*(((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1))+B2_Vb2_c1)+d10_sqrt0*(+(+B1_Vb2_c1_Vc1_c2*B1+B1_Vb2_c1*B1_Vc1_c2+B1_Vc1_c2*B1_Vb2_c1+B1*B1_Vb2_c1_Vc1_c2)+B2_Vb2_c1_Vc1_c2)));
#endif
Vxi0_Vc1_c2=(B1_Vc1_c2+(((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2))+B2_Vc1_c2)*d10_sqrt0);
#if defined(_DERIVATE2)
  Vxi0_Vc1_c2_Vdt_GND=(+B1_Vc1_c2_Vdt_GND+(m20_sqrt(((B1*B1)+B2))*((((B1_Vdt_GND*B1)+(B1*B1_Vdt_GND)))+B2_Vdt_GND)*(((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2))+B2_Vc1_c2)+d10_sqrt0*(+(+B1_Vc1_c2_Vdt_GND*B1+B1_Vc1_c2*B1_Vdt_GND+B1_Vdt_GND*B1_Vc1_c2+B1*B1_Vc1_c2_Vdt_GND)+B2_Vc1_c2_Vdt_GND)));
  Vxi0_Vc1_c2_Vb2_c2=(+B1_Vc1_c2_Vb2_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c2*B1)+(B1*B1_Vb2_c2)))+B2_Vb2_c2)*(((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2))+B2_Vc1_c2)+d10_sqrt0*(+(+B1_Vc1_c2_Vb2_c2*B1+B1_Vc1_c2*B1_Vb2_c2+B1_Vb2_c2*B1_Vc1_c2+B1*B1_Vc1_c2_Vb2_c2)+B2_Vc1_c2_Vb2_c2)));
  Vxi0_Vc1_c2_Vb2_c1=(+B1_Vc1_c2_Vb2_c1+(m20_sqrt(((B1*B1)+B2))*((((B1_Vb2_c1*B1)+(B1*B1_Vb2_c1)))+B2_Vb2_c1)*(((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2))+B2_Vc1_c2)+d10_sqrt0*(+(+B1_Vc1_c2_Vb2_c1*B1+B1_Vc1_c2*B1_Vb2_c1+B1_Vb2_c1*B1_Vc1_c2+B1*B1_Vc1_c2_Vb2_c1)+B2_Vc1_c2_Vb2_c1)));
  Vxi0_Vc1_c2_Vc1_c2=(+B1_Vc1_c2_Vc1_c2+(m20_sqrt(((B1*B1)+B2))*((((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2)))+B2_Vc1_c2)*(((B1_Vc1_c2*B1)+(B1*B1_Vc1_c2))+B2_Vc1_c2)+d10_sqrt0*(+(+B1_Vc1_c2_Vc1_c2*B1+B1_Vc1_c2*B1_Vc1_c2+B1_Vc1_c2*B1_Vc1_c2+B1*B1_Vc1_c2_Vc1_c2)+B2_Vc1_c2_Vc1_c2)));
#endif
#endif
Vxi0=(B1+d00_sqrt0);
EXIT_IF_ISNAN((B1+d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND)V(b,GND) */
#if defined(_DERIVATE)
Vch_Vdt_GND=((VDC_T_Vdt_GND*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))))+(VDC_T*(((2.0*Ic1c2_Vdt_GND)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
#endif
Vch_Vb2_c2=(VDC_T*(((2.0*Ic1c2_Vb2_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
#if defined(_DERIVATE2)
  Vch_Vb2_c2_Vdt_GND=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vdt_GND))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T_Vdt_GND*(((2.0*Ic1c2_Vb2_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c2+2.0*Ic1c2_Vb2_c2_Vdt_GND)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)+((2.0*Ic1c2_Vdt_GND))*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c2_Vdt_GND+Iqs_Vb2_c2_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c2_Vb2_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c2+2.0*Ic1c2_Vb2_c2_Vb2_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+((2.0*Ic1c2_Vb2_c2))*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c2_Vb2_c2+Iqs_Vb2_c2_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c2_Vb2_c1=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c1))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c2+2.0*Ic1c2_Vb2_c2_Vb2_c1)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+((2.0*Ic1c2_Vb2_c1))*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c2_Vb2_c1+Iqs_Vb2_c2_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c2_Vc1_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vc1_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c2+2.0*Ic1c2_Vb2_c2_Vc1_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+((2.0*Ic1c2_Vc1_c2))*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c2_Vc1_c2+Iqs_Vb2_c2_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
#endif
Vch_Vb2_c1=(VDC_T*(((2.0*Ic1c2_Vb2_c1)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
#if defined(_DERIVATE2)
  Vch_Vb2_c1_Vdt_GND=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vdt_GND))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T_Vdt_GND*(((2.0*Ic1c2_Vb2_c1)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c1+2.0*Ic1c2_Vb2_c1_Vdt_GND)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c1)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)+((2.0*Ic1c2_Vdt_GND))*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c1_Vdt_GND+Iqs_Vb2_c1_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c1_Vb2_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c1)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c1+2.0*Ic1c2_Vb2_c1_Vb2_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c1)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+((2.0*Ic1c2_Vb2_c2))*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c1_Vb2_c2+Iqs_Vb2_c1_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c1_Vb2_c1=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c1))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c1)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c1+2.0*Ic1c2_Vb2_c1_Vb2_c1)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c1)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+((2.0*Ic1c2_Vb2_c1))*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c1_Vb2_c1+Iqs_Vb2_c1_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vb2_c1_Vc1_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vc1_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vb2_c1)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c1+2.0*Ic1c2_Vb2_c1_Vc1_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vb2_c1)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+((2.0*Ic1c2_Vc1_c2))*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+(2.0*Ic1c2)*(+Ic1c2_Vb2_c1_Vc1_c2+Iqs_Vb2_c1_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
#endif
Vch_Vc1_c2=(VDC_T*(((2.0*Ic1c2_Vc1_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)));
#if defined(_DERIVATE2)
  Vch_Vc1_c2_Vdt_GND=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vdt_GND))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T_Vdt_GND*(((2.0*Ic1c2_Vc1_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vc1_c2+2.0*Ic1c2_Vc1_c2_Vdt_GND)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vc1_c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)+((2.0*Ic1c2_Vdt_GND))*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+(2.0*Ic1c2)*(+Ic1c2_Vc1_c2_Vdt_GND+Iqs_Vc1_c2_Vdt_GND))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)*(Ic1c2_Vdt_GND+Iqs_Vdt_GND)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vc1_c2_Vb2_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vc1_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vc1_c2+2.0*Ic1c2_Vc1_c2_Vb2_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vc1_c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)+((2.0*Ic1c2_Vb2_c2))*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+(2.0*Ic1c2)*(+Ic1c2_Vc1_c2_Vb2_c2+Iqs_Vc1_c2_Vb2_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)*(Ic1c2_Vb2_c2+Iqs_Vb2_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vc1_c2_Vb2_c1=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vb2_c1))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vc1_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vc1_c2+2.0*Ic1c2_Vc1_c2_Vb2_c1)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vc1_c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)+((2.0*Ic1c2_Vb2_c1))*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+(2.0*Ic1c2)*(+Ic1c2_Vc1_c2_Vb2_c1+Iqs_Vc1_c2_Vb2_c1))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)*(Ic1c2_Vb2_c1+Iqs_Vb2_c1)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
  Vch_Vc1_c2_Vc1_c2=(+0.0*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))+0.0*((((2.0*Ic1c2_Vc1_c2))*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+0.0*(((2.0*Ic1c2_Vc1_c2)*(Ic1c2+Iqs)-(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs))+VDC_T*(+0.0+((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vc1_c2+2.0*Ic1c2_Vc1_c2_Vc1_c2)/(Ic1c2+Iqs)-((2.0*Ic1c2_Vc1_c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+((2.0*Ic1c2_Vc1_c2))*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)+(2.0*Ic1c2)*(+Ic1c2_Vc1_c2_Vc1_c2+Iqs_Vc1_c2_Vc1_c2))/(Ic1c2+Iqs)/(Ic1c2+Iqs)+2*(2.0*Ic1c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)*(Ic1c2_Vc1_c2+Iqs_Vc1_c2)/(Ic1c2+Iqs)/(Ic1c2+Iqs)/(Ic1c2+Iqs))));
#endif
#endif
Vch=(VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs))));
EXIT_IF_ISNAN((VDC_T*(0.1+((2.0*Ic1c2)/(Ic1c2+Iqs)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Icap_Vdt_GND=(((IHC_M*Ic1c2_Vdt_GND)*(IHC_M+Ic1c2)-(IHC_M*Ic1c2)*Ic1c2_Vdt_GND)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_Vb2_c2=(((IHC_M*Ic1c2_Vb2_c2)*(IHC_M+Ic1c2)-(IHC_M*Ic1c2)*Ic1c2_Vb2_c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_Vb2_c2_Vdt_GND=((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c2+IHC_M*Ic1c2_Vb2_c2_Vdt_GND)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c2)*Ic1c2_Vdt_GND+((IHC_M*Ic1c2_Vdt_GND))*Ic1c2_Vb2_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c2_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c2*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c2_Vb2_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c2+IHC_M*Ic1c2_Vb2_c2_Vb2_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c2)*Ic1c2_Vb2_c2+((IHC_M*Ic1c2_Vb2_c2))*Ic1c2_Vb2_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c2_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c2*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c2_Vb2_c1=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c2+IHC_M*Ic1c2_Vb2_c2_Vb2_c1)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c2)*Ic1c2_Vb2_c1+((IHC_M*Ic1c2_Vb2_c1))*Ic1c2_Vb2_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c2_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c2*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c2_Vc1_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c2+IHC_M*Ic1c2_Vb2_c2_Vc1_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c2)*Ic1c2_Vc1_c2+((IHC_M*Ic1c2_Vc1_c2))*Ic1c2_Vb2_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c2_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c2*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_Vb2_c1=(((IHC_M*Ic1c2_Vb2_c1)*(IHC_M+Ic1c2)-(IHC_M*Ic1c2)*Ic1c2_Vb2_c1)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_Vb2_c1_Vdt_GND=((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c1+IHC_M*Ic1c2_Vb2_c1_Vdt_GND)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c1)*Ic1c2_Vdt_GND+((IHC_M*Ic1c2_Vdt_GND))*Ic1c2_Vb2_c1+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c1_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c1*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c1_Vb2_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c1+IHC_M*Ic1c2_Vb2_c1_Vb2_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c1)*Ic1c2_Vb2_c2+((IHC_M*Ic1c2_Vb2_c2))*Ic1c2_Vb2_c1+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c1_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c1*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c1_Vb2_c1=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c1+IHC_M*Ic1c2_Vb2_c1_Vb2_c1)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c1)*Ic1c2_Vb2_c1+((IHC_M*Ic1c2_Vb2_c1))*Ic1c2_Vb2_c1+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c1_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c1*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vb2_c1_Vc1_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c1+IHC_M*Ic1c2_Vb2_c1_Vc1_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vb2_c1)*Ic1c2_Vc1_c2+((IHC_M*Ic1c2_Vc1_c2))*Ic1c2_Vb2_c1+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vb2_c1_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vb2_c1*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_Vc1_c2=(((IHC_M*Ic1c2_Vc1_c2)*(IHC_M+Ic1c2)-(IHC_M*Ic1c2)*Ic1c2_Vc1_c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_Vc1_c2_Vdt_GND=((+0.0*Ic1c2+0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vc1_c2+IHC_M*Ic1c2_Vc1_c2_Vdt_GND)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vc1_c2)*Ic1c2_Vdt_GND+((IHC_M*Ic1c2_Vdt_GND))*Ic1c2_Vc1_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vc1_c2_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vc1_c2*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vc1_c2_Vb2_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vc1_c2+IHC_M*Ic1c2_Vc1_c2_Vb2_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vc1_c2)*Ic1c2_Vb2_c2+((IHC_M*Ic1c2_Vb2_c2))*Ic1c2_Vc1_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vc1_c2_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vc1_c2*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vc1_c2_Vb2_c1=((+0.0*Ic1c2+0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vc1_c2+IHC_M*Ic1c2_Vc1_c2_Vb2_c1)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vc1_c2)*Ic1c2_Vb2_c1+((IHC_M*Ic1c2_Vb2_c1))*Ic1c2_Vc1_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vc1_c2_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vc1_c2*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_Vc1_c2_Vc1_c2=((+0.0*Ic1c2+0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vc1_c2+IHC_M*Ic1c2_Vc1_c2_Vc1_c2)/(IHC_M+Ic1c2)-((IHC_M*Ic1c2_Vc1_c2)*Ic1c2_Vc1_c2+((IHC_M*Ic1c2_Vc1_c2))*Ic1c2_Vc1_c2+(IHC_M*Ic1c2)*(+0.0+Ic1c2_Vc1_c2_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*(IHC_M*Ic1c2)*Ic1c2_Vc1_c2*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
#endif
Icap=((IHC_M*Ic1c2)/(IHC_M+Ic1c2));
EXIT_IF_ISNAN(((IHC_M*Ic1c2)/(IHC_M+Ic1c2)))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Icap_IHC_Vdt_GND=(-IHC_M*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_IHC_Vb2_c2=(-IHC_M*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_IHC_Vb2_c2_Vdt_GND=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c2+IHC_M*(+0.0+Ic1c2_Vb2_c2_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c2*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c2_Vb2_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c2+IHC_M*(+0.0+Ic1c2_Vb2_c2_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c2*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c2_Vb2_c1=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c2+IHC_M*(+0.0+Ic1c2_Vb2_c2_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c2*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c2_Vc1_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c2+IHC_M*(+0.0+Ic1c2_Vb2_c2_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c2*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_IHC_Vb2_c1=(-IHC_M*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_IHC_Vb2_c1_Vdt_GND=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vb2_c1+IHC_M*(+0.0+Ic1c2_Vb2_c1_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c1*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c1_Vb2_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vb2_c1+IHC_M*(+0.0+Ic1c2_Vb2_c1_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c1*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c1_Vb2_c1=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vb2_c1+IHC_M*(+0.0+Ic1c2_Vb2_c1_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c1*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vb2_c1_Vc1_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vb2_c1+IHC_M*(+0.0+Ic1c2_Vb2_c1_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vb2_c1*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
Icap_IHC_Vc1_c2=(-IHC_M*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#if defined(_DERIVATE2)
  Icap_IHC_Vc1_c2_Vdt_GND=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vdt_GND+0.0*Ic1c2_Vc1_c2+IHC_M*(+0.0+Ic1c2_Vc1_c2_Vdt_GND))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vc1_c2*Ic1c2_Vdt_GND/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vc1_c2_Vb2_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c2+0.0*Ic1c2_Vc1_c2+IHC_M*(+0.0+Ic1c2_Vc1_c2_Vb2_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vc1_c2*Ic1c2_Vb2_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vc1_c2_Vb2_c1=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vb2_c1+0.0*Ic1c2_Vc1_c2+IHC_M*(+0.0+Ic1c2_Vc1_c2_Vb2_c1))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vc1_c2*Ic1c2_Vb2_c1/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
  Icap_IHC_Vc1_c2_Vc1_c2=(0.0/(IHC_M+Ic1c2)-(0.0*Ic1c2_Vc1_c2+0.0*Ic1c2_Vc1_c2+IHC_M*(+0.0+Ic1c2_Vc1_c2_Vc1_c2))/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)+2*IHC_M*Ic1c2_Vc1_c2*Ic1c2_Vc1_c2/(IHC_M+Ic1c2)/(IHC_M+Ic1c2)/(IHC_M+Ic1c2));
#endif
#endif
Icap_IHC=(IHC_M/(IHC_M+Ic1c2));
EXIT_IF_ISNAN((IHC_M/(IHC_M+Ic1c2)))
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b1,GND)V(s,GND) */
#if defined(_DERIVATE)
Iqs_Vdt_GND=0.0;
#endif
Iqs_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Iqs_Vb2_c2_Vdt_GND=0.0;
  Iqs_Vb2_c2_Vb2_c2=0.0;
  Iqs_Vb2_c2_Vb2_c1=0.0;
  Iqs_Vb2_c2_Vc1_c2=0.0;
#endif
Iqs_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Iqs_Vb2_c1_Vdt_GND=0.0;
  Iqs_Vb2_c1_Vb2_c2=0.0;
  Iqs_Vb2_c1_Vb2_c1=0.0;
  Iqs_Vb2_c1_Vc1_c2=0.0;
#endif
Iqs_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Iqs_Vc1_c2_Vdt_GND=0.0;
  Iqs_Vc1_c2_Vb2_c2=0.0;
  Iqs_Vc1_c2_Vb2_c1=0.0;
  Iqs_Vc1_c2_Vc1_c2=0.0;
#endif
#endif
Iqs=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
p0star_Vdt_GND=(((2.0*eVb2c2VDC_Vdt_GND)*(1.0+K0)-(2.0*eVb2c2VDC)*K0_Vdt_GND)/(1.0+K0)/(1.0+K0));
#endif
p0star_Vb2_c2=(((2.0*eVb2c2VDC_Vb2_c2)*(1.0+K0)-(2.0*eVb2c2VDC)*K0_Vb2_c2)/(1.0+K0)/(1.0+K0));
#if defined(_DERIVATE2)
  p0star_Vb2_c2_Vdt_GND=((+0.0*eVb2c2VDC+0.0*eVb2c2VDC_Vdt_GND+0.0*eVb2c2VDC_Vb2_c2+2.0*eVb2c2VDC_Vb2_c2_Vdt_GND)/(1.0+K0)-((2.0*eVb2c2VDC_Vb2_c2)*K0_Vdt_GND+((2.0*eVb2c2VDC_Vdt_GND))*K0_Vb2_c2+(2.0*eVb2c2VDC)*(+0.0+K0_Vb2_c2_Vdt_GND))/(1.0+K0)/(1.0+K0)+2*(2.0*eVb2c2VDC)*K0_Vb2_c2*K0_Vdt_GND/(1.0+K0)/(1.0+K0)/(1.0+K0));
  p0star_Vb2_c2_Vb2_c2=((+0.0*eVb2c2VDC+0.0*eVb2c2VDC_Vb2_c2+0.0*eVb2c2VDC_Vb2_c2+2.0*eVb2c2VDC_Vb2_c2_Vb2_c2)/(1.0+K0)-((2.0*eVb2c2VDC_Vb2_c2)*K0_Vb2_c2+((2.0*eVb2c2VDC_Vb2_c2))*K0_Vb2_c2+(2.0*eVb2c2VDC)*(+0.0+K0_Vb2_c2_Vb2_c2))/(1.0+K0)/(1.0+K0)+2*(2.0*eVb2c2VDC)*K0_Vb2_c2*K0_Vb2_c2/(1.0+K0)/(1.0+K0)/(1.0+K0));
  p0star_Vb2_c2_Vb2_c1=((+0.0*eVb2c2VDC+0.0*0.0+0.0*eVb2c2VDC_Vb2_c2+2.0*0.0)/(1.0+K0)-((2.0*eVb2c2VDC_Vb2_c2)*0.0+(0.0)*K0_Vb2_c2+(2.0*eVb2c2VDC)*(+0.0+0.0))/(1.0+K0)/(1.0+K0)+2*(2.0*eVb2c2VDC)*K0_Vb2_c2*0.0/(1.0+K0)/(1.0+K0)/(1.0+K0));
  p0star_Vb2_c2_Vc1_c2=((+0.0*eVb2c2VDC+0.0*0.0+0.0*eVb2c2VDC_Vb2_c2+2.0*0.0)/(1.0+K0)-((2.0*eVb2c2VDC_Vb2_c2)*0.0+(0.0)*K0_Vb2_c2+(2.0*eVb2c2VDC)*(+0.0+0.0))/(1.0+K0)/(1.0+K0)+2*(2.0*eVb2c2VDC)*K0_Vb2_c2*0.0/(1.0+K0)/(1.0+K0)/(1.0+K0));
#endif
p0star_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  p0star_Vb2_c1_Vdt_GND=0.0;
  p0star_Vb2_c1_Vb2_c2=0.0;
  p0star_Vb2_c1_Vb2_c1=0.0;
  p0star_Vb2_c1_Vc1_c2=0.0;
#endif
p0star_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  p0star_Vc1_c2_Vdt_GND=0.0;
  p0star_Vc1_c2_Vb2_c2=0.0;
  p0star_Vc1_c2_Vb2_c1=0.0;
  p0star_Vc1_c2_Vc1_c2=0.0;
#endif
#endif
p0star=((2.0*eVb2c2VDC)/(1.0+K0));
EXIT_IF_ISNAN(((2.0*eVb2c2VDC)/(1.0+K0)))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
eVb2c2star_Vdt_GND=eVb2c2_Vdt_GND;
#endif
eVb2c2star_Vb2_c2=eVb2c2_Vb2_c2;
#if defined(_DERIVATE2)
  eVb2c2star_Vb2_c2_Vdt_GND=eVb2c2_Vb2_c2_Vdt_GND;
  eVb2c2star_Vb2_c2_Vb2_c2=eVb2c2_Vb2_c2_Vb2_c2;
  eVb2c2star_Vb2_c2_Vb2_c1=0.0;
  eVb2c2star_Vb2_c2_Vc1_c2=0.0;
#endif
eVb2c2star_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  eVb2c2star_Vb2_c1_Vdt_GND=0.0;
  eVb2c2star_Vb2_c1_Vb2_c2=0.0;
  eVb2c2star_Vb2_c1_Vb2_c1=0.0;
  eVb2c2star_Vb2_c1_Vc1_c2=0.0;
#endif
eVb2c2star_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  eVb2c2star_Vc1_c2_Vdt_GND=0.0;
  eVb2c2star_Vc1_c2_Vb2_c2=0.0;
  eVb2c2star_Vc1_c2_Vb2_c1=0.0;
  eVb2c2star_Vc1_c2_Vc1_c2=0.0;
#endif
#endif
eVb2c2star=eVb2c2;
EXIT_IF_ISNAN(eVb2c2)
{
double m00_fabs(d00_fabs0,Vc1c2)
double m00_fabs(d00_fabs1,Ec)
if
(((d00_fabs0<(1.0e-5*Vt))||(d00_fabs1<((1.0e-40*Vt)*(K0+Kw)))))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
pav_Vdt_GND=(0.5*(p0star_Vdt_GND+pW_Vdt_GND));
#endif
pav_Vb2_c2=(0.5*p0star_Vb2_c2);
#if defined(_DERIVATE2)
  pav_Vb2_c2_Vdt_GND=(+0.0*(p0star+pW)+0.0*(p0star_Vdt_GND+pW_Vdt_GND)+0.0*p0star_Vb2_c2+0.5*(+p0star_Vb2_c2_Vdt_GND+0.0));
  pav_Vb2_c2_Vb2_c2=(+0.0*(p0star+pW)+0.0*p0star_Vb2_c2+0.0*p0star_Vb2_c2+0.5*(+p0star_Vb2_c2_Vb2_c2+0.0));
  pav_Vb2_c2_Vb2_c1=(+0.0*(p0star+pW)+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.0*p0star_Vb2_c2+0.5*(+p0star_Vb2_c2_Vb2_c1+0.0));
  pav_Vb2_c2_Vc1_c2=(+0.0*(p0star+pW)+0.0*p0star_Vc1_c2+0.0*p0star_Vb2_c2+0.5*(+p0star_Vb2_c2_Vc1_c2+0.0));
#endif
pav_Vb2_c1=(0.5*(p0star_Vb2_c1+pW_Vb2_c1));
#if defined(_DERIVATE2)
  pav_Vb2_c1_Vdt_GND=(+0.0*(p0star+pW)+0.0*(p0star_Vdt_GND+pW_Vdt_GND)+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.5*(+p0star_Vb2_c1_Vdt_GND+pW_Vb2_c1_Vdt_GND));
  pav_Vb2_c1_Vb2_c2=(+0.0*(p0star+pW)+0.0*p0star_Vb2_c2+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.5*(+p0star_Vb2_c1_Vb2_c2+0.0));
  pav_Vb2_c1_Vb2_c1=(+0.0*(p0star+pW)+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.5*(+p0star_Vb2_c1_Vb2_c1+pW_Vb2_c1_Vb2_c1));
  pav_Vb2_c1_Vc1_c2=(+0.0*(p0star+pW)+0.0*p0star_Vc1_c2+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.5*(+p0star_Vb2_c1_Vc1_c2+0.0));
#endif
pav_Vc1_c2=(0.5*p0star_Vc1_c2);
#if defined(_DERIVATE2)
  pav_Vc1_c2_Vdt_GND=(+0.0*(p0star+pW)+0.0*(p0star_Vdt_GND+pW_Vdt_GND)+0.0*p0star_Vc1_c2+0.5*(+p0star_Vc1_c2_Vdt_GND+0.0));
  pav_Vc1_c2_Vb2_c2=(+0.0*(p0star+pW)+0.0*p0star_Vb2_c2+0.0*p0star_Vc1_c2+0.5*(+p0star_Vc1_c2_Vb2_c2+0.0));
  pav_Vc1_c2_Vb2_c1=(+0.0*(p0star+pW)+0.0*(p0star_Vb2_c1+pW_Vb2_c1)+0.0*p0star_Vc1_c2+0.5*(+p0star_Vc1_c2_Vb2_c1+0.0));
  pav_Vc1_c2_Vc1_c2=(+0.0*(p0star+pW)+0.0*p0star_Vc1_c2+0.0*p0star_Vc1_c2+0.5*(+p0star_Vc1_c2_Vc1_c2+0.0));
#endif
#endif
pav=(0.5*(p0star+pW));
EXIT_IF_ISNAN((0.5*(p0star+pW)))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
xi_w_Vb2_c2=((pav_Vb2_c2*(pav+1.0)-pav*pav_Vb2_c2)/(pav+1.0)/(pav+1.0));
#if defined(_DERIVATE2)
  xi_w_Vb2_c2_Vb2_c2=(pav_Vb2_c2_Vb2_c2/(pav+1.0)-(pav_Vb2_c2*pav_Vb2_c2+pav_Vb2_c2*pav_Vb2_c2+pav*(+pav_Vb2_c2_Vb2_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c2*pav_Vb2_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c2_Vb2_c1=(pav_Vb2_c2_Vb2_c1/(pav+1.0)-(pav_Vb2_c2*pav_Vb2_c1+pav_Vb2_c1*pav_Vb2_c2+pav*(+pav_Vb2_c2_Vb2_c1+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c2*pav_Vb2_c1/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c2_Vc1_c2=(pav_Vb2_c2_Vc1_c2/(pav+1.0)-(pav_Vb2_c2*pav_Vc1_c2+pav_Vc1_c2*pav_Vb2_c2+pav*(+pav_Vb2_c2_Vc1_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c2*pav_Vc1_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c2_Vdt_GND=(pav_Vb2_c2_Vdt_GND/(pav+1.0)-(pav_Vb2_c2*pav_Vdt_GND+pav_Vdt_GND*pav_Vb2_c2+pav*(+pav_Vb2_c2_Vdt_GND+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c2*pav_Vdt_GND/(pav+1.0)/(pav+1.0)/(pav+1.0));
#endif
xi_w_Vb2_c1=((pav_Vb2_c1*(pav+1.0)-pav*pav_Vb2_c1)/(pav+1.0)/(pav+1.0));
#if defined(_DERIVATE2)
  xi_w_Vb2_c1_Vb2_c2=(pav_Vb2_c1_Vb2_c2/(pav+1.0)-(pav_Vb2_c1*pav_Vb2_c2+pav_Vb2_c2*pav_Vb2_c1+pav*(+pav_Vb2_c1_Vb2_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c1*pav_Vb2_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c1_Vb2_c1=(pav_Vb2_c1_Vb2_c1/(pav+1.0)-(pav_Vb2_c1*pav_Vb2_c1+pav_Vb2_c1*pav_Vb2_c1+pav*(+pav_Vb2_c1_Vb2_c1+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c1*pav_Vb2_c1/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c1_Vc1_c2=(pav_Vb2_c1_Vc1_c2/(pav+1.0)-(pav_Vb2_c1*pav_Vc1_c2+pav_Vc1_c2*pav_Vb2_c1+pav*(+pav_Vb2_c1_Vc1_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c1*pav_Vc1_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vb2_c1_Vdt_GND=(pav_Vb2_c1_Vdt_GND/(pav+1.0)-(pav_Vb2_c1*pav_Vdt_GND+pav_Vdt_GND*pav_Vb2_c1+pav*(+pav_Vb2_c1_Vdt_GND+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vb2_c1*pav_Vdt_GND/(pav+1.0)/(pav+1.0)/(pav+1.0));
#endif
xi_w_Vc1_c2=((pav_Vc1_c2*(pav+1.0)-pav*pav_Vc1_c2)/(pav+1.0)/(pav+1.0));
#if defined(_DERIVATE2)
  xi_w_Vc1_c2_Vb2_c2=(pav_Vc1_c2_Vb2_c2/(pav+1.0)-(pav_Vc1_c2*pav_Vb2_c2+pav_Vb2_c2*pav_Vc1_c2+pav*(+pav_Vc1_c2_Vb2_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vc1_c2*pav_Vb2_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vc1_c2_Vb2_c1=(pav_Vc1_c2_Vb2_c1/(pav+1.0)-(pav_Vc1_c2*pav_Vb2_c1+pav_Vb2_c1*pav_Vc1_c2+pav*(+pav_Vc1_c2_Vb2_c1+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vc1_c2*pav_Vb2_c1/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vc1_c2_Vc1_c2=(pav_Vc1_c2_Vc1_c2/(pav+1.0)-(pav_Vc1_c2*pav_Vc1_c2+pav_Vc1_c2*pav_Vc1_c2+pav*(+pav_Vc1_c2_Vc1_c2+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vc1_c2*pav_Vc1_c2/(pav+1.0)/(pav+1.0)/(pav+1.0));
  xi_w_Vc1_c2_Vdt_GND=(pav_Vc1_c2_Vdt_GND/(pav+1.0)-(pav_Vc1_c2*pav_Vdt_GND+pav_Vdt_GND*pav_Vc1_c2+pav*(+pav_Vc1_c2_Vdt_GND+0.0))/(pav+1.0)/(pav+1.0)+2*pav*pav_Vc1_c2*pav_Vdt_GND/(pav+1.0)/(pav+1.0)/(pav+1.0));
#endif
#if defined(_DERIVATE)
xi_w_Vdt_GND=((pav_Vdt_GND*(pav+1.0)-pav*pav_Vdt_GND)/(pav+1.0)/(pav+1.0));
#endif
#endif
xi_w=(pav/(pav+1.0));
EXIT_IF_ISNAN((pav/(pav+1.0)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
xi_w_Vb2_c2=((Ec_Vb2_c2*((Ec+Vb2c2)-Vb2c1)-Ec*(Ec_Vb2_c2+Vb2c2_Vb2_c2))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
#if defined(_DERIVATE2)
  xi_w_Vb2_c2_Vb2_c2=(Ec_Vb2_c2_Vb2_c2/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c2*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec_Vb2_c2*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec*(+(+Ec_Vb2_c2_Vb2_c2+Vb2c2_Vb2_c2_Vb2_c2)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c2+Vb2c2_Vb2_c2)*(Ec_Vb2_c2+Vb2c2_Vb2_c2)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c2_Vb2_c1=(Ec_Vb2_c2_Vb2_c1/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c2*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec_Vb2_c1*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec*(+(+Ec_Vb2_c2_Vb2_c1+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c2+Vb2c2_Vb2_c2)*(Ec_Vb2_c1-Vb2c1_Vb2_c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c2_Vc1_c2=(0.0/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c2*0.0+0.0*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec*(+(+0.0+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c2+Vb2c2_Vb2_c2)*0.0/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c2_Vdt_GND=(Ec_Vb2_c2_Vdt_GND/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c2*Ec_Vdt_GND+Ec_Vdt_GND*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec*(+(+Ec_Vb2_c2_Vdt_GND+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c2+Vb2c2_Vb2_c2)*Ec_Vdt_GND/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
#endif
xi_w_Vb2_c1=((Ec_Vb2_c1*((Ec+Vb2c2)-Vb2c1)-Ec*(Ec_Vb2_c1-Vb2c1_Vb2_c1))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
#if defined(_DERIVATE2)
  xi_w_Vb2_c1_Vb2_c2=(Ec_Vb2_c1_Vb2_c2/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c1*(Ec_Vb2_c2+Vb2c2_Vb2_c2)+Ec_Vb2_c2*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec*(+(+Ec_Vb2_c1_Vb2_c2+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c1-Vb2c1_Vb2_c1)*(Ec_Vb2_c2+Vb2c2_Vb2_c2)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c1_Vb2_c1=(Ec_Vb2_c1_Vb2_c1/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c1*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec_Vb2_c1*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec*(+(+Ec_Vb2_c1_Vb2_c1+0.0)-Vb2c1_Vb2_c1_Vb2_c1))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c1-Vb2c1_Vb2_c1)*(Ec_Vb2_c1-Vb2c1_Vb2_c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c1_Vc1_c2=(0.0/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c1*0.0+0.0*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec*(+(+0.0+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c1-Vb2c1_Vb2_c1)*0.0/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
  xi_w_Vb2_c1_Vdt_GND=(Ec_Vb2_c1_Vdt_GND/((Ec+Vb2c2)-Vb2c1)-(Ec_Vb2_c1*Ec_Vdt_GND+Ec_Vdt_GND*(Ec_Vb2_c1-Vb2c1_Vb2_c1)+Ec*(+(+Ec_Vb2_c1_Vdt_GND+0.0)-0.0))/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)+2*Ec*(Ec_Vb2_c1-Vb2c1_Vb2_c1)*Ec_Vdt_GND/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
#endif
xi_w_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  xi_w_Vc1_c2_Vb2_c2=0.0;
  xi_w_Vc1_c2_Vb2_c1=0.0;
  xi_w_Vc1_c2_Vc1_c2=0.0;
  xi_w_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
xi_w_Vdt_GND=((Ec_Vdt_GND*((Ec+Vb2c2)-Vb2c1)-Ec*Ec_Vdt_GND)/((Ec+Vb2c2)-Vb2c1)/((Ec+Vb2c2)-Vb2c1));
#endif
#endif
xi_w=(Ec/((Ec+Vb2c2)-Vb2c1));
EXIT_IF_ISNAN((Ec/((Ec+Vb2c2)-Vb2c1)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND)V(b,GND)V(b1,GND)V(s,GND) */
#if defined(_DERIVATE)
Vxi0_Vdt_GND=0.0;
#endif
Vxi0_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Vxi0_Vb2_c2_Vdt_GND=0.0;
  Vxi0_Vb2_c2_Vb2_c2=0.0;
  Vxi0_Vb2_c2_Vb2_c1=0.0;
  Vxi0_Vb2_c2_Vc1_c2=0.0;
#endif
Vxi0_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Vxi0_Vb2_c1_Vdt_GND=0.0;
  Vxi0_Vb2_c1_Vb2_c2=0.0;
  Vxi0_Vb2_c1_Vb2_c1=0.0;
  Vxi0_Vb2_c1_Vc1_c2=0.0;
#endif
Vxi0_Vc1_c2=Vc1c2_Vc1_c2;
#if defined(_DERIVATE2)
  Vxi0_Vc1_c2_Vdt_GND=0.0;
  Vxi0_Vc1_c2_Vb2_c2=0.0;
  Vxi0_Vc1_c2_Vb2_c1=0.0;
  Vxi0_Vc1_c2_Vc1_c2=Vc1c2_Vc1_c2_Vc1_c2;
#endif
#endif
Vxi0=Vc1c2;
EXIT_IF_ISNAN(Vc1c2)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND)V(b,GND) */
#if defined(_DERIVATE)
Vch_Vdt_GND=(0.1*VDC_T_Vdt_GND);
#endif
Vch_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Vch_Vb2_c2_Vdt_GND=0.0;
  Vch_Vb2_c2_Vb2_c2=0.0;
  Vch_Vb2_c2_Vb2_c1=0.0;
  Vch_Vb2_c2_Vc1_c2=0.0;
#endif
Vch_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Vch_Vb2_c1_Vdt_GND=0.0;
  Vch_Vb2_c1_Vb2_c2=0.0;
  Vch_Vb2_c1_Vb2_c1=0.0;
  Vch_Vb2_c1_Vc1_c2=0.0;
#endif
Vch_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Vch_Vc1_c2_Vdt_GND=0.0;
  Vch_Vc1_c2_Vb2_c2=0.0;
  Vch_Vc1_c2_Vb2_c1=0.0;
  Vch_Vc1_c2_Vc1_c2=0.0;
#endif
#endif
Vch=(0.1*VDC_T);
EXIT_IF_ISNAN((0.1*VDC_T))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Icap_Vdt_GND=Ic1c2_Vdt_GND;
#endif
Icap_Vb2_c2=Ic1c2_Vb2_c2;
#if defined(_DERIVATE2)
  Icap_Vb2_c2_Vdt_GND=Ic1c2_Vb2_c2_Vdt_GND;
  Icap_Vb2_c2_Vb2_c2=Ic1c2_Vb2_c2_Vb2_c2;
  Icap_Vb2_c2_Vb2_c1=Ic1c2_Vb2_c2_Vb2_c1;
  Icap_Vb2_c2_Vc1_c2=Ic1c2_Vb2_c2_Vc1_c2;
#endif
Icap_Vb2_c1=Ic1c2_Vb2_c1;
#if defined(_DERIVATE2)
  Icap_Vb2_c1_Vdt_GND=Ic1c2_Vb2_c1_Vdt_GND;
  Icap_Vb2_c1_Vb2_c2=Ic1c2_Vb2_c1_Vb2_c2;
  Icap_Vb2_c1_Vb2_c1=Ic1c2_Vb2_c1_Vb2_c1;
  Icap_Vb2_c1_Vc1_c2=Ic1c2_Vb2_c1_Vc1_c2;
#endif
Icap_Vc1_c2=Ic1c2_Vc1_c2;
#if defined(_DERIVATE2)
  Icap_Vc1_c2_Vdt_GND=Ic1c2_Vc1_c2_Vdt_GND;
  Icap_Vc1_c2_Vb2_c2=Ic1c2_Vc1_c2_Vb2_c2;
  Icap_Vc1_c2_Vb2_c1=Ic1c2_Vc1_c2_Vb2_c1;
  Icap_Vc1_c2_Vc1_c2=Ic1c2_Vc1_c2_Vc1_c2;
#endif
#endif
Icap=Ic1c2;
EXIT_IF_ISNAN(Ic1c2)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Icap_IHC_Vdt_GND=(-(Icap_Vdt_GND/IHC_M));
#endif
Icap_IHC_Vb2_c2=(-(Icap_Vb2_c2/IHC_M));
#if defined(_DERIVATE2)
  Icap_IHC_Vb2_c2_Vdt_GND=(+0.0-(Icap_Vb2_c2_Vdt_GND/IHC_M-(Icap_Vb2_c2*0.0+Icap_Vdt_GND*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c2_Vb2_c2=(+0.0-(Icap_Vb2_c2_Vb2_c2/IHC_M-(Icap_Vb2_c2*0.0+Icap_Vb2_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c2_Vb2_c1=(+0.0-(Icap_Vb2_c2_Vb2_c1/IHC_M-(Icap_Vb2_c2*0.0+Icap_Vb2_c1*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c2_Vc1_c2=(+0.0-(Icap_Vb2_c2_Vc1_c2/IHC_M-(Icap_Vb2_c2*0.0+Icap_Vc1_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
Icap_IHC_Vb2_c1=(-(Icap_Vb2_c1/IHC_M));
#if defined(_DERIVATE2)
  Icap_IHC_Vb2_c1_Vdt_GND=(+0.0-(Icap_Vb2_c1_Vdt_GND/IHC_M-(Icap_Vb2_c1*0.0+Icap_Vdt_GND*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c1_Vb2_c2=(+0.0-(Icap_Vb2_c1_Vb2_c2/IHC_M-(Icap_Vb2_c1*0.0+Icap_Vb2_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c1_Vb2_c1=(+0.0-(Icap_Vb2_c1_Vb2_c1/IHC_M-(Icap_Vb2_c1*0.0+Icap_Vb2_c1*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vb2_c1_Vc1_c2=(+0.0-(Icap_Vb2_c1_Vc1_c2/IHC_M-(Icap_Vb2_c1*0.0+Icap_Vc1_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
Icap_IHC_Vc1_c2=(-(Icap_Vc1_c2/IHC_M));
#if defined(_DERIVATE2)
  Icap_IHC_Vc1_c2_Vdt_GND=(+0.0-(Icap_Vc1_c2_Vdt_GND/IHC_M-(Icap_Vc1_c2*0.0+Icap_Vdt_GND*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vc1_c2_Vb2_c2=(+0.0-(Icap_Vc1_c2_Vb2_c2/IHC_M-(Icap_Vc1_c2*0.0+Icap_Vb2_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vc1_c2_Vb2_c1=(+0.0-(Icap_Vc1_c2_Vb2_c1/IHC_M-(Icap_Vc1_c2*0.0+Icap_Vb2_c1*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
  Icap_IHC_Vc1_c2_Vc1_c2=(+0.0-(Icap_Vc1_c2_Vc1_c2/IHC_M-(Icap_Vc1_c2*0.0+Icap_Vc1_c2*0.0+Icap*0.0)/IHC_M/IHC_M+2*Icap*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
#endif
Icap_IHC=(1.0-(Icap/IHC_M));
EXIT_IF_ISNAN((1.0-(Icap/IHC_M)))
}
{
double m00_pow(d00_pow0,3.0,((-1.0)/pModel->PE))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b,GND)V(b1,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
Vfe_Vdt_GND=VDE_T_Vdt_GND*(1.0-d00_pow0);
#endif
Vfe=(VDE_T*(1.0-d00_pow0));
EXIT_IF_ISNAN((VDE_T*(1.0-d00_pow0)))
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(b,GND)V(b1,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
a_VDE_Vdt_GND=(0.1*VDE_T_Vdt_GND);
#endif
a_VDE=(0.1*VDE_T);
EXIT_IF_ISNAN((0.1*VDE_T))
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=(Vb2e1_Vb2_e1/a_VDE);
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb_c=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb_b1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vc3_c1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vc3_c4=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb1_b2=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vc4_c1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb1_e1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb2_e1=((+Vb2e1_Vb2_e1_Vb2_e1-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb2_c2=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vb2_c1=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vc1_c2=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+0.0*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb2_e1_Vdt_GND=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*a_VDE_Vdt_GND+(-Vfe_Vdt_GND)*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*a_VDE_Vdt_GND/a_VDE/a_VDE/a_VDE);
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-Vfe_Vdt_GND)*a_VDE-(Vb2e1-Vfe)*a_VDE_Vdt_GND)/a_VDE/a_VDE);
#endif
#endif
dxa=((Vb2e1-Vfe)/a_VDE);
EXIT_IF_ISNAN(((Vb2e1-Vfe)/a_VDE))
if
((Vb2e1<Vfe))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vje_Vb2_e1=(Vb2e1_Vb2_e1-(a_VDE*dxa_Vb2_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_e1_Vb2_e1=(+Vb2e1_Vb2_e1_Vb2_e1-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_e1)))));
  Vje_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vdt_GND)))));
  Vje_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c2)))));
  Vje_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c1)))));
  Vje_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vc1_c2)))));
#endif
#if defined(_DERIVATE)
Vje_Vdt_GND=(-((a_VDE_Vdt_GND*d00_logE1)+(a_VDE*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
Vje_Vb2_c2=(-(a_VDE*dxa_Vb2_c2*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_e1)))));
  Vje_Vb2_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vdt_GND)))));
  Vje_Vb2_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c2)))));
  Vje_Vb2_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c1)))));
  Vje_Vb2_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vc1_c2)))));
#endif
Vje_Vb2_c1=(-(a_VDE*dxa_Vb2_c1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_e1)))));
  Vje_Vb2_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vdt_GND)))));
  Vje_Vb2_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c2)))));
  Vje_Vb2_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c1)))));
  Vje_Vb2_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vc1_c2)))));
#endif
Vje_Vc1_c2=(-(a_VDE*dxa_Vc1_c2*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_e1)))));
  Vje_Vc1_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vdt_GND)))));
  Vje_Vc1_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c2)))));
  Vje_Vc1_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c1)))));
  Vje_Vc1_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vc1_c2)))));
#endif
#endif
Vje=(Vb2e1-(a_VDE*d00_logE1));
EXIT_IF_ISNAN((Vb2e1-(a_VDE*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vje_Vb2_e1=(-(a_VDE*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vje_Vdt_GND=(Vfe_Vdt_GND-((a_VDE_Vdt_GND*d00_logE1)+(a_VDE*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
Vje_Vb2_c2=(-(a_VDE*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vje_Vb2_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vje_Vb2_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vje_Vb2_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vje_Vb2_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
#endif
Vje_Vb2_c1=(-(a_VDE*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vje_Vb2_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vje_Vb2_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vje_Vb2_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vje_Vb2_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
#endif
Vje_Vc1_c2=(-(a_VDE*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vje_Vc1_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vje_Vc1_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vje_Vc1_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vje_Vc1_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
#endif
#endif
Vje=(Vfe-(a_VDE*d00_logE1));
EXIT_IF_ISNAN((Vfe-(a_VDE*d00_logE1)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vje_Vb2_e1=Vje_Vb2_e1;
#if defined(_DERIVATE2)
  Vje_Vb2_e1_Vb2_e1=Vje_Vb2_e1_Vb2_e1;
  Vje_Vb2_e1_Vdt_GND=Vje_Vb2_e1_Vdt_GND;
  Vje_Vb2_e1_Vb2_c2=Vje_Vb2_e1_Vb2_c2;
  Vje_Vb2_e1_Vb2_c1=Vje_Vb2_e1_Vb2_c1;
  Vje_Vb2_e1_Vc1_c2=Vje_Vb2_e1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Vje_Vdt_GND=Vje_Vdt_GND;
#endif
Vje_Vb2_c2=Vje_Vb2_c2;
#if defined(_DERIVATE2)
  Vje_Vb2_c2_Vb2_e1=Vje_Vb2_c2_Vb2_e1;
  Vje_Vb2_c2_Vdt_GND=Vje_Vb2_c2_Vdt_GND;
  Vje_Vb2_c2_Vb2_c2=Vje_Vb2_c2_Vb2_c2;
  Vje_Vb2_c2_Vb2_c1=Vje_Vb2_c2_Vb2_c1;
  Vje_Vb2_c2_Vc1_c2=Vje_Vb2_c2_Vc1_c2;
#endif
Vje_Vb2_c1=Vje_Vb2_c1;
#if defined(_DERIVATE2)
  Vje_Vb2_c1_Vb2_e1=Vje_Vb2_c1_Vb2_e1;
  Vje_Vb2_c1_Vdt_GND=Vje_Vb2_c1_Vdt_GND;
  Vje_Vb2_c1_Vb2_c2=Vje_Vb2_c1_Vb2_c2;
  Vje_Vb2_c1_Vb2_c1=Vje_Vb2_c1_Vb2_c1;
  Vje_Vb2_c1_Vc1_c2=Vje_Vb2_c1_Vc1_c2;
#endif
Vje_Vc1_c2=Vje_Vc1_c2;
#if defined(_DERIVATE2)
  Vje_Vc1_c2_Vb2_e1=Vje_Vc1_c2_Vb2_e1;
  Vje_Vc1_c2_Vdt_GND=Vje_Vc1_c2_Vdt_GND;
  Vje_Vc1_c2_Vb2_c2=Vje_Vc1_c2_Vb2_c2;
  Vje_Vc1_c2_Vb2_c1=Vje_Vc1_c2_Vb2_c1;
  Vje_Vc1_c2_Vc1_c2=Vje_Vc1_c2_Vc1_c2;
#endif
#endif
Vje=Vje;
EXIT_IF_ISNAN(Vje)
{
double m00_pow(d00_pow0,(1.0-(Vje*inv_VDE_T)),(1.0-pModel->PE))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vje*inv_VDE_T)),(1.0-pModel->PE))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND)V(b,GND) */
E0BE_Vb2_e1=(d10_pow0*(-Vje_Vb2_e1*inv_VDE_T));
#if defined(_DERIVATE2)
  E0BE_Vb2_e1_Vb2_e1=fixme;
  E0BE_Vb2_e1_Vdt_GND=fixme;
  E0BE_Vb2_e1_Vb2_c2=fixme;
  E0BE_Vb2_e1_Vb2_c1=fixme;
  E0BE_Vb2_e1_Vc1_c2=fixme;
#endif
#if defined(_DERIVATE)
E0BE_Vdt_GND=(d10_pow0*(-((Vje_Vdt_GND*inv_VDE_T)+(Vje*inv_VDE_T_Vdt_GND))));
#endif
E0BE_Vb2_c2=(d10_pow0*(-Vje_Vb2_c2*inv_VDE_T));
#if defined(_DERIVATE2)
  E0BE_Vb2_c2_Vb2_e1=fixme;
  E0BE_Vb2_c2_Vdt_GND=fixme;
  E0BE_Vb2_c2_Vb2_c2=fixme;
  E0BE_Vb2_c2_Vb2_c1=fixme;
  E0BE_Vb2_c2_Vc1_c2=fixme;
#endif
E0BE_Vb2_c1=(d10_pow0*(-Vje_Vb2_c1*inv_VDE_T));
#if defined(_DERIVATE2)
  E0BE_Vb2_c1_Vb2_e1=fixme;
  E0BE_Vb2_c1_Vdt_GND=fixme;
  E0BE_Vb2_c1_Vb2_c2=fixme;
  E0BE_Vb2_c1_Vb2_c1=fixme;
  E0BE_Vb2_c1_Vc1_c2=fixme;
#endif
E0BE_Vc1_c2=(d10_pow0*(-Vje_Vc1_c2*inv_VDE_T));
#if defined(_DERIVATE2)
  E0BE_Vc1_c2_Vb2_e1=fixme;
  E0BE_Vc1_c2_Vdt_GND=fixme;
  E0BE_Vc1_c2_Vb2_c2=fixme;
  E0BE_Vc1_c2_Vb2_c1=fixme;
  E0BE_Vc1_c2_Vc1_c2=fixme;
#endif
#endif
E0BE=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Vte_Vdt_GND=((((VDE_T_Vdt_GND/(1.0-pModel->PE))*(1.0-E0BE))+((VDE_T/(1.0-pModel->PE))*(-E0BE_Vdt_GND)))+(3.0*(-Vje_Vdt_GND)));
#endif
Vte_Vb2_e1=(((VDE_T/(1.0-pModel->PE))*(-E0BE_Vb2_e1))+(3.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)));
#if defined(_DERIVATE2)
  Vte_Vb2_e1_Vdt_GND=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vdt_GND)+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-E0BE_Vb2_e1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_e1_Vdt_GND))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vdt_GND)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+3.0*(+0.0-Vje_Vb2_e1_Vdt_GND)));
  Vte_Vb2_e1_Vb2_e1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_e1)+0.0*(-E0BE_Vb2_e1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_e1_Vb2_e1))+(+0.0*(Vb2e1-Vje)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+3.0*(+Vb2e1_Vb2_e1_Vb2_e1-Vje_Vb2_e1_Vb2_e1)));
  Vte_Vb2_e1_Vb2_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c2)+0.0*(-E0BE_Vb2_e1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_e1_Vb2_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c2)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+3.0*(+0.0-Vje_Vb2_e1_Vb2_c2)));
  Vte_Vb2_e1_Vb2_c1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c1)+0.0*(-E0BE_Vb2_e1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_e1_Vb2_c1))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c1)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+3.0*(+0.0-Vje_Vb2_e1_Vb2_c1)));
  Vte_Vb2_e1_Vc1_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vc1_c2)+0.0*(-E0BE_Vb2_e1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_e1_Vc1_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vc1_c2)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+3.0*(+0.0-Vje_Vb2_e1_Vc1_c2)));
#endif
Vte_Vb2_c2=(((VDE_T/(1.0-pModel->PE))*(-E0BE_Vb2_c2))+(3.0*(-Vje_Vb2_c2)));
#if defined(_DERIVATE2)
  Vte_Vb2_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vdt_GND)+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-E0BE_Vb2_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c2_Vdt_GND))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vdt_GND)+0.0*(-Vje_Vb2_c2)+3.0*(+0.0-Vje_Vb2_c2_Vdt_GND)));
  Vte_Vb2_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_e1)+0.0*(-E0BE_Vb2_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c2_Vb2_e1))+(+0.0*(Vb2e1-Vje)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+0.0*(-Vje_Vb2_c2)+3.0*(+0.0-Vje_Vb2_c2_Vb2_e1)));
  Vte_Vb2_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c2)+0.0*(-E0BE_Vb2_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c2_Vb2_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c2)+0.0*(-Vje_Vb2_c2)+3.0*(+0.0-Vje_Vb2_c2_Vb2_c2)));
  Vte_Vb2_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c1)+0.0*(-E0BE_Vb2_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c2_Vb2_c1))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c1)+0.0*(-Vje_Vb2_c2)+3.0*(+0.0-Vje_Vb2_c2_Vb2_c1)));
  Vte_Vb2_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vc1_c2)+0.0*(-E0BE_Vb2_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c2_Vc1_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vc1_c2)+0.0*(-Vje_Vb2_c2)+3.0*(+0.0-Vje_Vb2_c2_Vc1_c2)));
#endif
Vte_Vb2_c1=(((VDE_T/(1.0-pModel->PE))*(-E0BE_Vb2_c1))+(3.0*(-Vje_Vb2_c1)));
#if defined(_DERIVATE2)
  Vte_Vb2_c1_Vdt_GND=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vdt_GND)+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-E0BE_Vb2_c1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c1_Vdt_GND))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vdt_GND)+0.0*(-Vje_Vb2_c1)+3.0*(+0.0-Vje_Vb2_c1_Vdt_GND)));
  Vte_Vb2_c1_Vb2_e1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_e1)+0.0*(-E0BE_Vb2_c1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c1_Vb2_e1))+(+0.0*(Vb2e1-Vje)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+0.0*(-Vje_Vb2_c1)+3.0*(+0.0-Vje_Vb2_c1_Vb2_e1)));
  Vte_Vb2_c1_Vb2_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c2)+0.0*(-E0BE_Vb2_c1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c1_Vb2_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c2)+0.0*(-Vje_Vb2_c1)+3.0*(+0.0-Vje_Vb2_c1_Vb2_c2)));
  Vte_Vb2_c1_Vb2_c1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c1)+0.0*(-E0BE_Vb2_c1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c1_Vb2_c1))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c1)+0.0*(-Vje_Vb2_c1)+3.0*(+0.0-Vje_Vb2_c1_Vb2_c1)));
  Vte_Vb2_c1_Vc1_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vc1_c2)+0.0*(-E0BE_Vb2_c1)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vb2_c1_Vc1_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vc1_c2)+0.0*(-Vje_Vb2_c1)+3.0*(+0.0-Vje_Vb2_c1_Vc1_c2)));
#endif
Vte_Vc1_c2=(((VDE_T/(1.0-pModel->PE))*(-E0BE_Vc1_c2))+(3.0*(-Vje_Vc1_c2)));
#if defined(_DERIVATE2)
  Vte_Vc1_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vdt_GND)+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-E0BE_Vc1_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vc1_c2_Vdt_GND))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vdt_GND)+0.0*(-Vje_Vc1_c2)+3.0*(+0.0-Vje_Vc1_c2_Vdt_GND)));
  Vte_Vc1_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_e1)+0.0*(-E0BE_Vc1_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vc1_c2_Vb2_e1))+(+0.0*(Vb2e1-Vje)+0.0*(Vb2e1_Vb2_e1-Vje_Vb2_e1)+0.0*(-Vje_Vc1_c2)+3.0*(+0.0-Vje_Vc1_c2_Vb2_e1)));
  Vte_Vc1_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c2)+0.0*(-E0BE_Vc1_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vc1_c2_Vb2_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c2)+0.0*(-Vje_Vc1_c2)+3.0*(+0.0-Vje_Vc1_c2_Vb2_c2)));
  Vte_Vc1_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vb2_c1)+0.0*(-E0BE_Vc1_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vc1_c2_Vb2_c1))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vb2_c1)+0.0*(-Vje_Vc1_c2)+3.0*(+0.0-Vje_Vc1_c2_Vb2_c1)));
  Vte_Vc1_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-E0BE)+0.0*(-E0BE_Vc1_c2)+0.0*(-E0BE_Vc1_c2)+(VDE_T/(1.0-pModel->PE))*(+0.0-E0BE_Vc1_c2_Vc1_c2))+(+0.0*(Vb2e1-Vje)+0.0*(-Vje_Vc1_c2)+0.0*(-Vje_Vc1_c2)+3.0*(+0.0-Vje_Vc1_c2_Vc1_c2)));
#endif
#endif
Vte=(((VDE_T/(1.0-pModel->PE))*(1.0-E0BE))+(3.0*(Vb2e1-Vje)));
EXIT_IF_ISNAN((((VDE_T/(1.0-pModel->PE))*(1.0-E0BE))+(3.0*(Vb2e1-Vje))))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND)V(b2,c2)V(c1,c2) ddxprobe=V(s,GND)V(b1,GND)V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
Vjunc_Vb2_c1=(Vb2c1_Vb2_c1+Vxi0_Vb2_c1);
#if defined(_DERIVATE2)
  Vjunc_Vb2_c1_Vb2_c1=(+Vb2c1_Vb2_c1_Vb2_c1+Vxi0_Vb2_c1_Vb2_c1);
  Vjunc_Vb2_c1_Vdt_GND=(+0.0+Vxi0_Vb2_c1_Vdt_GND);
  Vjunc_Vb2_c1_Vb2_c2=(+0.0+Vxi0_Vb2_c1_Vb2_c2);
  Vjunc_Vb2_c1_Vc1_c2=(+0.0+Vxi0_Vb2_c1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Vjunc_Vdt_GND=Vxi0_Vdt_GND;
#endif
Vjunc_Vb2_c2=Vxi0_Vb2_c2;
#if defined(_DERIVATE2)
  Vjunc_Vb2_c2_Vb2_c1=(+0.0+Vxi0_Vb2_c2_Vb2_c1);
  Vjunc_Vb2_c2_Vdt_GND=(+0.0+Vxi0_Vb2_c2_Vdt_GND);
  Vjunc_Vb2_c2_Vb2_c2=(+0.0+Vxi0_Vb2_c2_Vb2_c2);
  Vjunc_Vb2_c2_Vc1_c2=(+0.0+Vxi0_Vb2_c2_Vc1_c2);
#endif
Vjunc_Vc1_c2=Vxi0_Vc1_c2;
#if defined(_DERIVATE2)
  Vjunc_Vc1_c2_Vb2_c1=(+0.0+Vxi0_Vc1_c2_Vb2_c1);
  Vjunc_Vc1_c2_Vdt_GND=(+0.0+Vxi0_Vc1_c2_Vdt_GND);
  Vjunc_Vc1_c2_Vb2_c2=(+0.0+Vxi0_Vc1_c2_Vb2_c2);
  Vjunc_Vc1_c2_Vc1_c2=(+0.0+Vxi0_Vc1_c2_Vc1_c2);
#endif
#endif
Vjunc=(Vb2c1+Vxi0);
EXIT_IF_ISNAN((Vb2c1+Vxi0))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND)V(c1,GND)V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND)V(b,GND) */
bjc_Vdt_GND=(((-XP_T_Vdt_GND)*(1.0-XP_T)-(2.0-XP_T)*(-XP_T_Vdt_GND))/(1.0-XP_T)/(1.0-XP_T));
#endif
bjc=((2.0-XP_T)/(1.0-XP_T));
EXIT_IF_ISNAN(((2.0-XP_T)/(1.0-XP_T)))
{
double m00_pow(d00_pow0,bjc,((-1.0)/pModel->PC))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,bjc,((-1.0)/pModel->PC))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(s,GND)V(b,GND) */
Vfc_Vdt_GND=((VDC_T_Vdt_GND*(1.0-d00_pow0))+(VDC_T*(-(d10_pow0*bjc_Vdt_GND))));
#endif
Vfc=(VDC_T*(1.0-d00_pow0));
EXIT_IF_ISNAN((VDC_T*(1.0-d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=((Vjunc_Vb2_c2*Vch-(Vjunc-Vfc)*Vch_Vb2_c2)/Vch/Vch);
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb_c=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb_b1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vc3_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vc3_c4=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb1_b2=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vc4_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb1_e1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb2_e1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c2*0.0+0.0*Vch_Vb2_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*0.0/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb2_c2=((+Vjunc_Vb2_c2_Vb2_c2-0.0)/Vch-(Vjunc_Vb2_c2*Vch_Vb2_c2+Vjunc_Vb2_c2*Vch_Vb2_c2+(Vjunc-Vfc)*Vch_Vb2_c2_Vb2_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*Vch_Vb2_c2/Vch/Vch/Vch);
  dxa_Vb2_c2_Vb2_c1=((+Vjunc_Vb2_c2_Vb2_c1-0.0)/Vch-(Vjunc_Vb2_c2*Vch_Vb2_c1+Vjunc_Vb2_c1*Vch_Vb2_c2+(Vjunc-Vfc)*Vch_Vb2_c2_Vb2_c1)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*Vch_Vb2_c1/Vch/Vch/Vch);
  dxa_Vb2_c2_Vc1_c2=((+Vjunc_Vb2_c2_Vc1_c2-0.0)/Vch-(Vjunc_Vb2_c2*Vch_Vc1_c2+Vjunc_Vc1_c2*Vch_Vb2_c2+(Vjunc-Vfc)*Vch_Vb2_c2_Vc1_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*Vch_Vc1_c2/Vch/Vch/Vch);
  dxa_Vb2_c2_Vdt_GND=((+Vjunc_Vb2_c2_Vdt_GND-0.0)/Vch-(Vjunc_Vb2_c2*Vch_Vdt_GND+(Vjunc_Vdt_GND-Vfc_Vdt_GND)*Vch_Vb2_c2+(Vjunc-Vfc)*Vch_Vb2_c2_Vdt_GND)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c2*Vch_Vdt_GND/Vch/Vch/Vch);
#endif
dxa_Vb2_c1=((Vjunc_Vb2_c1*Vch-(Vjunc-Vfc)*Vch_Vb2_c1)/Vch/Vch);
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb_c=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb_b1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vc3_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vc3_c4=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb1_b2=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vc4_c1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb1_e1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb2_e1=((+0.0-0.0)/Vch-(Vjunc_Vb2_c1*0.0+0.0*Vch_Vb2_c1+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*0.0/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb2_c2=((+Vjunc_Vb2_c1_Vb2_c2-0.0)/Vch-(Vjunc_Vb2_c1*Vch_Vb2_c2+Vjunc_Vb2_c2*Vch_Vb2_c1+(Vjunc-Vfc)*Vch_Vb2_c1_Vb2_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*Vch_Vb2_c2/Vch/Vch/Vch);
  dxa_Vb2_c1_Vb2_c1=((+Vjunc_Vb2_c1_Vb2_c1-0.0)/Vch-(Vjunc_Vb2_c1*Vch_Vb2_c1+Vjunc_Vb2_c1*Vch_Vb2_c1+(Vjunc-Vfc)*Vch_Vb2_c1_Vb2_c1)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*Vch_Vb2_c1/Vch/Vch/Vch);
  dxa_Vb2_c1_Vc1_c2=((+Vjunc_Vb2_c1_Vc1_c2-0.0)/Vch-(Vjunc_Vb2_c1*Vch_Vc1_c2+Vjunc_Vc1_c2*Vch_Vb2_c1+(Vjunc-Vfc)*Vch_Vb2_c1_Vc1_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*Vch_Vc1_c2/Vch/Vch/Vch);
  dxa_Vb2_c1_Vdt_GND=((+Vjunc_Vb2_c1_Vdt_GND-0.0)/Vch-(Vjunc_Vb2_c1*Vch_Vdt_GND+(Vjunc_Vdt_GND-Vfc_Vdt_GND)*Vch_Vb2_c1+(Vjunc-Vfc)*Vch_Vb2_c1_Vdt_GND)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vb2_c1*Vch_Vdt_GND/Vch/Vch/Vch);
#endif
dxa_Vc1_c2=((Vjunc_Vc1_c2*Vch-(Vjunc-Vfc)*Vch_Vc1_c2)/Vch/Vch);
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb_c=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb_b1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vc3_c1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vc3_c4=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb1_b2=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vc4_c1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb1_e1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb2_e1=((+0.0-0.0)/Vch-(Vjunc_Vc1_c2*0.0+0.0*Vch_Vc1_c2+(Vjunc-Vfc)*0.0)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*0.0/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb2_c2=((+Vjunc_Vc1_c2_Vb2_c2-0.0)/Vch-(Vjunc_Vc1_c2*Vch_Vb2_c2+Vjunc_Vb2_c2*Vch_Vc1_c2+(Vjunc-Vfc)*Vch_Vc1_c2_Vb2_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*Vch_Vb2_c2/Vch/Vch/Vch);
  dxa_Vc1_c2_Vb2_c1=((+Vjunc_Vc1_c2_Vb2_c1-0.0)/Vch-(Vjunc_Vc1_c2*Vch_Vb2_c1+Vjunc_Vb2_c1*Vch_Vc1_c2+(Vjunc-Vfc)*Vch_Vc1_c2_Vb2_c1)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*Vch_Vb2_c1/Vch/Vch/Vch);
  dxa_Vc1_c2_Vc1_c2=((+Vjunc_Vc1_c2_Vc1_c2-0.0)/Vch-(Vjunc_Vc1_c2*Vch_Vc1_c2+Vjunc_Vc1_c2*Vch_Vc1_c2+(Vjunc-Vfc)*Vch_Vc1_c2_Vc1_c2)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*Vch_Vc1_c2/Vch/Vch/Vch);
  dxa_Vc1_c2_Vdt_GND=((+Vjunc_Vc1_c2_Vdt_GND-0.0)/Vch-(Vjunc_Vc1_c2*Vch_Vdt_GND+(Vjunc_Vdt_GND-Vfc_Vdt_GND)*Vch_Vc1_c2+(Vjunc-Vfc)*Vch_Vc1_c2_Vdt_GND)/Vch/Vch+2*(Vjunc-Vfc)*Vch_Vc1_c2*Vch_Vdt_GND/Vch/Vch/Vch);
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((Vjunc_Vdt_GND-Vfc_Vdt_GND)*Vch-(Vjunc-Vfc)*Vch_Vdt_GND)/Vch/Vch);
#endif
#endif
dxa=((Vjunc-Vfc)/Vch);
EXIT_IF_ISNAN(((Vjunc-Vfc)/Vch))
if
((Vjunc<Vfc))
{
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND)V(b2,c2)V(c1,c2)V(b2,e1) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
Vjc_Vb2_c1=(Vjunc_Vb2_c1-((Vch_Vb2_c1*d00_logE1)+(Vch*dxa_Vb2_c1*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vb2_c1_Vb2_c1=(+Vjunc_Vb2_c1_Vb2_c1-(+Vch_Vb2_c1_Vb2_c1*d00_logE1+Vch_Vb2_c1*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch_Vb2_c1*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c1)))));
  Vjc_Vb2_c1_Vdt_GND=(+Vjunc_Vb2_c1_Vdt_GND-(+Vch_Vb2_c1_Vdt_GND*d00_logE1+Vch_Vb2_c1*dxa_Vdt_GND*d10_exp0*d10_logE1+Vch_Vdt_GND*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vdt_GND)))));
  Vjc_Vb2_c1_Vb2_c2=(+Vjunc_Vb2_c1_Vb2_c2-(+Vch_Vb2_c1_Vb2_c2*d00_logE1+Vch_Vb2_c1*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch_Vb2_c2*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c2)))));
  Vjc_Vb2_c1_Vc1_c2=(+Vjunc_Vb2_c1_Vc1_c2-(+Vch_Vb2_c1_Vc1_c2*d00_logE1+Vch_Vb2_c1*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch_Vc1_c2*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vc1_c2)))));
  Vjc_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vb2_c1*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_e1)))));
#endif
#if defined(_DERIVATE)
Vjc_Vdt_GND=(Vjunc_Vdt_GND-((Vch_Vdt_GND*d00_logE1)+(Vch*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
Vjc_Vb2_c2=(Vjunc_Vb2_c2-((Vch_Vb2_c2*d00_logE1)+(Vch*dxa_Vb2_c2*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vb2_c2_Vb2_c1=(+Vjunc_Vb2_c2_Vb2_c1-(+Vch_Vb2_c2_Vb2_c1*d00_logE1+Vch_Vb2_c2*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch_Vb2_c1*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c1)))));
  Vjc_Vb2_c2_Vdt_GND=(+Vjunc_Vb2_c2_Vdt_GND-(+Vch_Vb2_c2_Vdt_GND*d00_logE1+Vch_Vb2_c2*dxa_Vdt_GND*d10_exp0*d10_logE1+Vch_Vdt_GND*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vdt_GND)))));
  Vjc_Vb2_c2_Vb2_c2=(+Vjunc_Vb2_c2_Vb2_c2-(+Vch_Vb2_c2_Vb2_c2*d00_logE1+Vch_Vb2_c2*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch_Vb2_c2*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c2)))));
  Vjc_Vb2_c2_Vc1_c2=(+Vjunc_Vb2_c2_Vc1_c2-(+Vch_Vb2_c2_Vc1_c2*d00_logE1+Vch_Vb2_c2*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch_Vc1_c2*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vc1_c2)))));
  Vjc_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vb2_c2*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_e1)))));
#endif
Vjc_Vc1_c2=(Vjunc_Vc1_c2-((Vch_Vc1_c2*d00_logE1)+(Vch*dxa_Vc1_c2*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vc1_c2_Vb2_c1=(+Vjunc_Vc1_c2_Vb2_c1-(+Vch_Vc1_c2_Vb2_c1*d00_logE1+Vch_Vc1_c2*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch_Vb2_c1*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c1)))));
  Vjc_Vc1_c2_Vdt_GND=(+Vjunc_Vc1_c2_Vdt_GND-(+Vch_Vc1_c2_Vdt_GND*d00_logE1+Vch_Vc1_c2*dxa_Vdt_GND*d10_exp0*d10_logE1+Vch_Vdt_GND*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vdt_GND)))));
  Vjc_Vc1_c2_Vb2_c2=(+Vjunc_Vc1_c2_Vb2_c2-(+Vch_Vc1_c2_Vb2_c2*d00_logE1+Vch_Vc1_c2*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch_Vb2_c2*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c2)))));
  Vjc_Vc1_c2_Vc1_c2=(+Vjunc_Vc1_c2_Vc1_c2-(+Vch_Vc1_c2_Vc1_c2*d00_logE1+Vch_Vc1_c2*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch_Vc1_c2*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vc1_c2)))));
  Vjc_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vc1_c2*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_e1)))));
#endif
Vjc_Vb2_e1=(-(Vch*dxa_Vb2_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjc_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+Vch_Vb2_c1*dxa_Vb2_e1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c1)))));
  Vjc_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+Vch_Vdt_GND*dxa_Vb2_e1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vdt_GND)))));
  Vjc_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+Vch_Vb2_c2*dxa_Vb2_e1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c2)))));
  Vjc_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+Vch_Vc1_c2*dxa_Vb2_e1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vc1_c2)))));
  Vjc_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_e1)))));
#endif
#endif
Vjc=(Vjunc-(Vch*d00_logE1));
EXIT_IF_ISNAN((Vjunc-(Vch*d00_logE1)))
}
}
else
{
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND)V(b2,c2)V(c1,c2)V(b2,e1) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
Vjc_Vb2_c1=(-((Vch_Vb2_c1*d00_logE1)+(Vch*(-dxa_Vb2_c1)*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vb2_c1_Vb2_c1=(+0.0-(+Vch_Vb2_c1_Vb2_c1*d00_logE1+Vch_Vb2_c1*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch_Vb2_c1*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjc_Vb2_c1_Vdt_GND=(+0.0-(+Vch_Vb2_c1_Vdt_GND*d00_logE1+Vch_Vb2_c1*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+Vch_Vdt_GND*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjc_Vb2_c1_Vb2_c2=(+0.0-(+Vch_Vb2_c1_Vb2_c2*d00_logE1+Vch_Vb2_c1*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch_Vb2_c2*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjc_Vb2_c1_Vc1_c2=(+0.0-(+Vch_Vb2_c1_Vc1_c2*d00_logE1+Vch_Vb2_c1*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch_Vc1_c2*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjc_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vb2_c1*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vjc_Vdt_GND=(Vfc_Vdt_GND-((Vch_Vdt_GND*d00_logE1)+(Vch*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
Vjc_Vb2_c2=(-((Vch_Vb2_c2*d00_logE1)+(Vch*(-dxa_Vb2_c2)*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vb2_c2_Vb2_c1=(+0.0-(+Vch_Vb2_c2_Vb2_c1*d00_logE1+Vch_Vb2_c2*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch_Vb2_c1*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjc_Vb2_c2_Vdt_GND=(+0.0-(+Vch_Vb2_c2_Vdt_GND*d00_logE1+Vch_Vb2_c2*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+Vch_Vdt_GND*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjc_Vb2_c2_Vb2_c2=(+0.0-(+Vch_Vb2_c2_Vb2_c2*d00_logE1+Vch_Vb2_c2*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch_Vb2_c2*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjc_Vb2_c2_Vc1_c2=(+0.0-(+Vch_Vb2_c2_Vc1_c2*d00_logE1+Vch_Vb2_c2*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch_Vc1_c2*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjc_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vb2_c2*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
#endif
Vjc_Vc1_c2=(-((Vch_Vc1_c2*d00_logE1)+(Vch*(-dxa_Vc1_c2)*d10_exp0*d10_logE1)));
#if defined(_DERIVATE2)
  Vjc_Vc1_c2_Vb2_c1=(+0.0-(+Vch_Vc1_c2_Vb2_c1*d00_logE1+Vch_Vc1_c2*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch_Vb2_c1*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjc_Vc1_c2_Vdt_GND=(+0.0-(+Vch_Vc1_c2_Vdt_GND*d00_logE1+Vch_Vc1_c2*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+Vch_Vdt_GND*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjc_Vc1_c2_Vb2_c2=(+0.0-(+Vch_Vc1_c2_Vb2_c2*d00_logE1+Vch_Vc1_c2*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch_Vb2_c2*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjc_Vc1_c2_Vc1_c2=(+0.0-(+Vch_Vc1_c2_Vc1_c2*d00_logE1+Vch_Vc1_c2*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch_Vc1_c2*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjc_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+Vch_Vc1_c2*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
#endif
Vjc_Vb2_e1=(-(Vch*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjc_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+Vch_Vb2_c1*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjc_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+Vch_Vdt_GND*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjc_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+Vch_Vb2_c2*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjc_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+Vch_Vc1_c2*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjc_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+Vch*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
#endif
#endif
Vjc=(Vfc-(Vch*d00_logE1));
EXIT_IF_ISNAN((Vfc-(Vch*d00_logE1)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c1)V(dt,GND)V(b2,c2)V(c1,c2)V(b2,e1) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
Vjc_Vb2_c1=Vjc_Vb2_c1;
#if defined(_DERIVATE2)
  Vjc_Vb2_c1_Vb2_c1=Vjc_Vb2_c1_Vb2_c1;
  Vjc_Vb2_c1_Vdt_GND=Vjc_Vb2_c1_Vdt_GND;
  Vjc_Vb2_c1_Vb2_c2=Vjc_Vb2_c1_Vb2_c2;
  Vjc_Vb2_c1_Vc1_c2=Vjc_Vb2_c1_Vc1_c2;
  Vjc_Vb2_c1_Vb2_e1=Vjc_Vb2_c1_Vb2_e1;
#endif
#if defined(_DERIVATE)
Vjc_Vdt_GND=Vjc_Vdt_GND;
#endif
Vjc_Vb2_c2=Vjc_Vb2_c2;
#if defined(_DERIVATE2)
  Vjc_Vb2_c2_Vb2_c1=Vjc_Vb2_c2_Vb2_c1;
  Vjc_Vb2_c2_Vdt_GND=Vjc_Vb2_c2_Vdt_GND;
  Vjc_Vb2_c2_Vb2_c2=Vjc_Vb2_c2_Vb2_c2;
  Vjc_Vb2_c2_Vc1_c2=Vjc_Vb2_c2_Vc1_c2;
  Vjc_Vb2_c2_Vb2_e1=Vjc_Vb2_c2_Vb2_e1;
#endif
Vjc_Vc1_c2=Vjc_Vc1_c2;
#if defined(_DERIVATE2)
  Vjc_Vc1_c2_Vb2_c1=Vjc_Vc1_c2_Vb2_c1;
  Vjc_Vc1_c2_Vdt_GND=Vjc_Vc1_c2_Vdt_GND;
  Vjc_Vc1_c2_Vb2_c2=Vjc_Vc1_c2_Vb2_c2;
  Vjc_Vc1_c2_Vc1_c2=Vjc_Vc1_c2_Vc1_c2;
  Vjc_Vc1_c2_Vb2_e1=Vjc_Vc1_c2_Vb2_e1;
#endif
Vjc_Vb2_e1=Vjc_Vb2_e1;
#if defined(_DERIVATE2)
  Vjc_Vb2_e1_Vb2_c1=Vjc_Vb2_e1_Vb2_c1;
  Vjc_Vb2_e1_Vdt_GND=Vjc_Vb2_e1_Vdt_GND;
  Vjc_Vb2_e1_Vb2_c2=Vjc_Vb2_e1_Vb2_c2;
  Vjc_Vb2_e1_Vc1_c2=Vjc_Vb2_e1_Vc1_c2;
  Vjc_Vb2_e1_Vb2_e1=Vjc_Vb2_e1_Vb2_e1;
#endif
#endif
Vjc=Vjc;
EXIT_IF_ISNAN(Vjc)
{
double m00_pow(d00_pow0,Icap_IHC,pModel->MC)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Icap_IHC,pModel->MC)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
fI_Vdt_GND=(d10_pow0*Icap_IHC_Vdt_GND);
#endif
fI_Vb2_c2=(d10_pow0*Icap_IHC_Vb2_c2);
#if defined(_DERIVATE2)
  fI_Vb2_c2_Vdt_GND=fixme;
  fI_Vb2_c2_Vb2_c2=fixme;
  fI_Vb2_c2_Vb2_c1=fixme;
  fI_Vb2_c2_Vc1_c2=fixme;
#endif
fI_Vb2_c1=(d10_pow0*Icap_IHC_Vb2_c1);
#if defined(_DERIVATE2)
  fI_Vb2_c1_Vdt_GND=fixme;
  fI_Vb2_c1_Vb2_c2=fixme;
  fI_Vb2_c1_Vb2_c1=fixme;
  fI_Vb2_c1_Vc1_c2=fixme;
#endif
fI_Vc1_c2=(d10_pow0*Icap_IHC_Vc1_c2);
#if defined(_DERIVATE2)
  fI_Vc1_c2_Vdt_GND=fixme;
  fI_Vc1_c2_Vb2_c2=fixme;
  fI_Vc1_c2_Vb2_c1=fixme;
  fI_Vc1_c2_Vc1_c2=fixme;
#endif
#endif
fI=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0-(Vjc/VDC_T)),(1.0-pModel->PC))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vjc/VDC_T)),(1.0-pModel->PC))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(b2,GND)V(e1,GND)V(b,GND) */
#if defined(_DERIVATE)
Vcv_Vdt_GND=((((VDC_T_Vdt_GND/(1.0-pModel->PC))*(1.0-(fI*d00_pow0)))+((VDC_T/(1.0-pModel->PC))*(-((fI_Vdt_GND*d00_pow0)+(fI*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T))))))))+((((fI_Vdt_GND*bjc)+(fI*bjc_Vdt_GND))*(Vjunc-Vjc))+((fI*bjc)*(Vjunc_Vdt_GND-Vjc_Vdt_GND))));
#endif
Vcv_Vb2_c2=(((VDC_T/(1.0-pModel->PC))*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))))))+((fI_Vb2_c2*bjc*(Vjunc-Vjc))+((fI*bjc)*(Vjunc_Vb2_c2-Vjc_Vb2_c2))));
#if defined(_DERIVATE2)
  Vcv_Vb2_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vdt_GND*d00_pow0)+(fI*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c2_Vdt_GND*d00_pow0+fI_Vb2_c2*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))+fI_Vdt_GND*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c2_Vdt_GND*bjc+fI_Vb2_c2*bjc_Vdt_GND+fI_Vdt_GND*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c2*bjc*(Vjunc_Vdt_GND-Vjc_Vdt_GND)+(((fI_Vdt_GND*bjc)+(fI*bjc_Vdt_GND)))*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI*bjc)*(+Vjunc_Vb2_c2_Vdt_GND-Vjc_Vb2_c2_Vdt_GND)));
  Vcv_Vb2_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))))))+0.0*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c2_Vb2_c2*d00_pow0+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c2_Vb2_c2*bjc+fI_Vb2_c2*0.0+fI_Vb2_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c2*bjc*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI_Vb2_c2*bjc)*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI*bjc)*(+Vjunc_Vb2_c2_Vb2_c2-Vjc_Vb2_c2_Vb2_c2)));
  Vcv_Vb2_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))))))+0.0*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c2_Vb2_c1*d00_pow0+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c2_Vb2_c1*bjc+fI_Vb2_c2*0.0+fI_Vb2_c1*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c2*bjc*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI_Vb2_c1*bjc)*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI*bjc)*(+Vjunc_Vb2_c2_Vb2_c1-Vjc_Vb2_c2_Vb2_c1)));
  Vcv_Vb2_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))))))+0.0*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c2_Vc1_c2*d00_pow0+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c2_Vc1_c2*bjc+fI_Vb2_c2*0.0+fI_Vc1_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c2*bjc*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI_Vc1_c2*bjc)*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI*bjc)*(+Vjunc_Vb2_c2_Vc1_c2-Vjc_Vb2_c2_Vc1_c2)));
  Vcv_Vb2_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-((fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T))))))+0.0*(-((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+0.0*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+fI_Vb2_c2*0.0+0.0*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c2*bjc*(-Vjc_Vb2_e1)+(0.0)*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI*bjc)*(+0.0-Vjc_Vb2_c2_Vb2_e1)));
#endif
Vcv_Vb2_c1=(((VDC_T/(1.0-pModel->PC))*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))))))+((fI_Vb2_c1*bjc*(Vjunc-Vjc))+((fI*bjc)*(Vjunc_Vb2_c1-Vjc_Vb2_c1))));
#if defined(_DERIVATE2)
  Vcv_Vb2_c1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vdt_GND*d00_pow0)+(fI*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c1_Vdt_GND*d00_pow0+fI_Vb2_c1*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))+fI_Vdt_GND*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c1_Vdt_GND*bjc+fI_Vb2_c1*bjc_Vdt_GND+fI_Vdt_GND*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c1*bjc*(Vjunc_Vdt_GND-Vjc_Vdt_GND)+(((fI_Vdt_GND*bjc)+(fI*bjc_Vdt_GND)))*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI*bjc)*(+Vjunc_Vb2_c1_Vdt_GND-Vjc_Vb2_c1_Vdt_GND)));
  Vcv_Vb2_c1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))))))+0.0*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c1_Vb2_c2*d00_pow0+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c1_Vb2_c2*bjc+fI_Vb2_c1*0.0+fI_Vb2_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c1*bjc*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI_Vb2_c2*bjc)*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI*bjc)*(+Vjunc_Vb2_c1_Vb2_c2-Vjc_Vb2_c1_Vb2_c2)));
  Vcv_Vb2_c1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))))))+0.0*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c1_Vb2_c1*d00_pow0+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c1_Vb2_c1*bjc+fI_Vb2_c1*0.0+fI_Vb2_c1*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c1*bjc*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI_Vb2_c1*bjc)*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI*bjc)*(+Vjunc_Vb2_c1_Vb2_c1-Vjc_Vb2_c1_Vb2_c1)));
  Vcv_Vb2_c1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))))))+0.0*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vb2_c1_Vc1_c2*d00_pow0+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI*fixme)))+(+(+fI_Vb2_c1_Vc1_c2*bjc+fI_Vb2_c1*0.0+fI_Vc1_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c1*bjc*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI_Vc1_c2*bjc)*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI*bjc)*(+Vjunc_Vb2_c1_Vc1_c2-Vjc_Vb2_c1_Vc1_c2)));
  Vcv_Vb2_c1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-((fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T))))))+0.0*(-((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+0.0*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+fI_Vb2_c1*0.0+0.0*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vb2_c1*bjc*(-Vjc_Vb2_e1)+(0.0)*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI*bjc)*(+0.0-Vjc_Vb2_c1_Vb2_e1)));
#endif
Vcv_Vc1_c2=(((VDC_T/(1.0-pModel->PC))*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))))))+((fI_Vc1_c2*bjc*(Vjunc-Vjc))+((fI*bjc)*(Vjunc_Vc1_c2-Vjc_Vc1_c2))));
#if defined(_DERIVATE2)
  Vcv_Vc1_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vdt_GND*d00_pow0)+(fI*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vc1_c2_Vdt_GND*d00_pow0+fI_Vc1_c2*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))+fI_Vdt_GND*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vc1_c2_Vdt_GND*bjc+fI_Vc1_c2*bjc_Vdt_GND+fI_Vdt_GND*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vc1_c2*bjc*(Vjunc_Vdt_GND-Vjc_Vdt_GND)+(((fI_Vdt_GND*bjc)+(fI*bjc_Vdt_GND)))*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI*bjc)*(+Vjunc_Vc1_c2_Vdt_GND-Vjc_Vc1_c2_Vdt_GND)));
  Vcv_Vc1_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))))))+0.0*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vc1_c2_Vb2_c2*d00_pow0+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vc1_c2_Vb2_c2*bjc+fI_Vc1_c2*0.0+fI_Vb2_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vc1_c2*bjc*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI_Vb2_c2*bjc)*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI*bjc)*(+Vjunc_Vc1_c2_Vb2_c2-Vjc_Vc1_c2_Vb2_c2)));
  Vcv_Vc1_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))))))+0.0*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vc1_c2_Vb2_c1*d00_pow0+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vc1_c2_Vb2_c1*bjc+fI_Vc1_c2*0.0+fI_Vb2_c1*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vc1_c2*bjc*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI_Vb2_c1*bjc)*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI*bjc)*(+Vjunc_Vc1_c2_Vb2_c1-Vjc_Vc1_c2_Vb2_c1)));
  Vcv_Vc1_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))))))+0.0*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+fI_Vc1_c2_Vc1_c2*d00_pow0+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI*fixme)))+(+(+fI_Vc1_c2_Vc1_c2*bjc+fI_Vc1_c2*0.0+fI_Vc1_c2*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vc1_c2*bjc*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI_Vc1_c2*bjc)*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI*bjc)*(+Vjunc_Vc1_c2_Vc1_c2-Vjc_Vc1_c2_Vc1_c2)));
  Vcv_Vc1_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-((fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T))))))+0.0*(-((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T))))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+0.0*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+fI_Vc1_c2*0.0+0.0*0.0+fI*0.0)*(Vjunc-Vjc)+fI_Vc1_c2*bjc*(-Vjc_Vb2_e1)+(0.0)*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI*bjc)*(+0.0-Vjc_Vc1_c2_Vb2_e1)));
#endif
Vcv_Vb2_e1=(((VDC_T/(1.0-pModel->PC))*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T))))))+((fI*bjc)*(-Vjc_Vb2_e1)));
#if defined(_DERIVATE2)
  Vcv_Vb2_e1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vdt_GND*d00_pow0)+(fI*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+0.0*(d10_pow0*(-((Vjc_Vdt_GND*VDC_T-Vjc*VDC_T_Vdt_GND)/VDC_T/VDC_T)))+fI_Vdt_GND*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+0.0*bjc_Vdt_GND+fI_Vdt_GND*0.0+fI*0.0)*(Vjunc-Vjc)+0.0*(Vjunc_Vdt_GND-Vjc_Vdt_GND)+(((fI_Vdt_GND*bjc)+(fI*bjc_Vdt_GND)))*(-Vjc_Vb2_e1)+(fI*bjc)*(+0.0-Vjc_Vb2_e1_Vdt_GND)));
  Vcv_Vb2_e1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))))))+0.0*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+0.0*(d10_pow0*(-(Vjc_Vb2_c2/VDC_T)))+fI_Vb2_c2*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+0.0*0.0+fI_Vb2_c2*0.0+fI*0.0)*(Vjunc-Vjc)+0.0*(Vjunc_Vb2_c2-Vjc_Vb2_c2)+(fI_Vb2_c2*bjc)*(-Vjc_Vb2_e1)+(fI*bjc)*(+0.0-Vjc_Vb2_e1_Vb2_c2)));
  Vcv_Vb2_e1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vb2_c1*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))))))+0.0*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+0.0*(d10_pow0*(-(Vjc_Vb2_c1/VDC_T)))+fI_Vb2_c1*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+0.0*0.0+fI_Vb2_c1*0.0+fI*0.0)*(Vjunc-Vjc)+0.0*(Vjunc_Vb2_c1-Vjc_Vb2_c1)+(fI_Vb2_c1*bjc)*(-Vjc_Vb2_e1)+(fI*bjc)*(+0.0-Vjc_Vb2_e1_Vb2_c1)));
  Vcv_Vb2_e1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-(((fI_Vc1_c2*d00_pow0)+(fI*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))))))+0.0*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+0.0*(d10_pow0*(-(Vjc_Vc1_c2/VDC_T)))+fI_Vc1_c2*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+0.0*0.0+fI_Vc1_c2*0.0+fI*0.0)*(Vjunc-Vjc)+0.0*(Vjunc_Vc1_c2-Vjc_Vc1_c2)+(fI_Vc1_c2*bjc)*(-Vjc_Vb2_e1)+(fI*bjc)*(+0.0-Vjc_Vb2_e1_Vc1_c2)));
  Vcv_Vb2_e1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-(fI*d00_pow0))+0.0*(-((fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T))))))+0.0*(-(fI*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))))+(VDC_T/(1.0-pModel->PC))*(+0.0-(+0.0*d00_pow0+0.0*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+0.0*(d10_pow0*(-(Vjc_Vb2_e1/VDC_T)))+fI*fixme)))+(+(+0.0*bjc+0.0*0.0+0.0*0.0+fI*0.0)*(Vjunc-Vjc)+0.0*(-Vjc_Vb2_e1)+(0.0)*(-Vjc_Vb2_e1)+(fI*bjc)*(+0.0-Vjc_Vb2_e1_Vb2_e1)));
#endif
#endif
Vcv=(((VDC_T/(1.0-pModel->PC))*(1.0-(fI*d00_pow0)))+((fI*bjc)*(Vjunc-Vjc)));
EXIT_IF_ISNAN((((VDC_T/(1.0-pModel->PC))*(1.0-(fI*d00_pow0)))+((fI*bjc)*(Vjunc-Vjc))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b2,e1) ddxprobe=V(b,GND)V(e1,GND)V(b2,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Vtc_Vdt_GND=((((-XP_T_Vdt_GND)*Vcv)+((1.0-XP_T)*Vcv_Vdt_GND))+XP_T_Vdt_GND*Vb2c1);
#endif
Vtc_Vb2_c2=((1.0-XP_T)*Vcv_Vb2_c2);
#if defined(_DERIVATE2)
  Vtc_Vb2_c2_Vdt_GND=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vdt_GND+(-XP_T_Vdt_GND)*Vcv_Vb2_c2+(1.0-XP_T)*Vcv_Vb2_c2_Vdt_GND)+(+0.0*Vb2c1+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0));
  Vtc_Vb2_c2_Vb2_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c2+0.0*Vcv_Vb2_c2+(1.0-XP_T)*Vcv_Vb2_c2_Vb2_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_c2_Vb2_c1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c1+0.0*Vcv_Vb2_c2+(1.0-XP_T)*Vcv_Vb2_c2_Vb2_c1)+(+0.0*Vb2c1+0.0*Vb2c1_Vb2_c1+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_c2_Vc1_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vc1_c2+0.0*Vcv_Vb2_c2+(1.0-XP_T)*Vcv_Vb2_c2_Vc1_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_c2_Vb2_e1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_e1+0.0*Vcv_Vb2_c2+(1.0-XP_T)*Vcv_Vb2_c2_Vb2_e1)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
#endif
Vtc_Vb2_c1=(((1.0-XP_T)*Vcv_Vb2_c1)+(XP_T*Vb2c1_Vb2_c1));
#if defined(_DERIVATE2)
  Vtc_Vb2_c1_Vdt_GND=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vdt_GND+(-XP_T_Vdt_GND)*Vcv_Vb2_c1+(1.0-XP_T)*Vcv_Vb2_c1_Vdt_GND)+(+0.0*Vb2c1+0.0*0.0+XP_T_Vdt_GND*Vb2c1_Vb2_c1+XP_T*0.0));
  Vtc_Vb2_c1_Vb2_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c2+0.0*Vcv_Vb2_c1+(1.0-XP_T)*Vcv_Vb2_c1_Vb2_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*Vb2c1_Vb2_c1+XP_T*0.0));
  Vtc_Vb2_c1_Vb2_c1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c1+0.0*Vcv_Vb2_c1+(1.0-XP_T)*Vcv_Vb2_c1_Vb2_c1)+(+0.0*Vb2c1+0.0*Vb2c1_Vb2_c1+0.0*Vb2c1_Vb2_c1+XP_T*Vb2c1_Vb2_c1_Vb2_c1));
  Vtc_Vb2_c1_Vc1_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vc1_c2+0.0*Vcv_Vb2_c1+(1.0-XP_T)*Vcv_Vb2_c1_Vc1_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*Vb2c1_Vb2_c1+XP_T*0.0));
  Vtc_Vb2_c1_Vb2_e1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_e1+0.0*Vcv_Vb2_c1+(1.0-XP_T)*Vcv_Vb2_c1_Vb2_e1)+(+0.0*Vb2c1+0.0*0.0+0.0*Vb2c1_Vb2_c1+XP_T*0.0));
#endif
Vtc_Vc1_c2=((1.0-XP_T)*Vcv_Vc1_c2);
#if defined(_DERIVATE2)
  Vtc_Vc1_c2_Vdt_GND=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vdt_GND+(-XP_T_Vdt_GND)*Vcv_Vc1_c2+(1.0-XP_T)*Vcv_Vc1_c2_Vdt_GND)+(+0.0*Vb2c1+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0));
  Vtc_Vc1_c2_Vb2_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c2+0.0*Vcv_Vc1_c2+(1.0-XP_T)*Vcv_Vc1_c2_Vb2_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vc1_c2_Vb2_c1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c1+0.0*Vcv_Vc1_c2+(1.0-XP_T)*Vcv_Vc1_c2_Vb2_c1)+(+0.0*Vb2c1+0.0*Vb2c1_Vb2_c1+0.0*0.0+XP_T*0.0));
  Vtc_Vc1_c2_Vc1_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vc1_c2+0.0*Vcv_Vc1_c2+(1.0-XP_T)*Vcv_Vc1_c2_Vc1_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vc1_c2_Vb2_e1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_e1+0.0*Vcv_Vc1_c2+(1.0-XP_T)*Vcv_Vc1_c2_Vb2_e1)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
#endif
Vtc_Vb2_e1=((1.0-XP_T)*Vcv_Vb2_e1);
#if defined(_DERIVATE2)
  Vtc_Vb2_e1_Vdt_GND=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vdt_GND+(-XP_T_Vdt_GND)*Vcv_Vb2_e1+(1.0-XP_T)*Vcv_Vb2_e1_Vdt_GND)+(+0.0*Vb2c1+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0));
  Vtc_Vb2_e1_Vb2_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c2+0.0*Vcv_Vb2_e1+(1.0-XP_T)*Vcv_Vb2_e1_Vb2_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_e1_Vb2_c1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_c1+0.0*Vcv_Vb2_e1+(1.0-XP_T)*Vcv_Vb2_e1_Vb2_c1)+(+0.0*Vb2c1+0.0*Vb2c1_Vb2_c1+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_e1_Vc1_c2=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vc1_c2+0.0*Vcv_Vb2_e1+(1.0-XP_T)*Vcv_Vb2_e1_Vc1_c2)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
  Vtc_Vb2_e1_Vb2_e1=(+(+(+0.0-0.0)*Vcv+0.0*Vcv_Vb2_e1+0.0*Vcv_Vb2_e1+(1.0-XP_T)*Vcv_Vb2_e1_Vb2_e1)+(+0.0*Vb2c1+0.0*0.0+0.0*0.0+XP_T*0.0));
#endif
#endif
Vtc=(((1.0-XP_T)*Vcv)+(XP_T*Vb2c1));
EXIT_IF_ISNAN((((1.0-XP_T)*Vcv)+(XP_T*Vb2c1)))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
If0_Vdt_GND=(((4.0*IS_TM_Vdt_GND)*IK_TM-(4.0*IS_TM)*IK_TM_Vdt_GND)/IK_TM/IK_TM);
#endif
If0=((4.0*IS_TM)/IK_TM);
EXIT_IF_ISNAN(((4.0*IS_TM)/IK_TM))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
#if defined(_DERIVATE)
f1_Vdt_GND=((If0_Vdt_GND*eVb2e1)+(If0*eVb2e1_Vdt_GND));
#endif
f1_Vb2_e1=(If0*eVb2e1_Vb2_e1);
#if defined(_DERIVATE2)
  f1_Vb2_e1_Vdt_GND=(+0.0*eVb2e1+0.0*eVb2e1_Vdt_GND+If0_Vdt_GND*eVb2e1_Vb2_e1+If0*eVb2e1_Vb2_e1_Vdt_GND);
  f1_Vb2_e1_Vb2_e1=(+0.0*eVb2e1+0.0*eVb2e1_Vb2_e1+0.0*eVb2e1_Vb2_e1+If0*eVb2e1_Vb2_e1_Vb2_e1);
#endif
#endif
f1=(If0*eVb2e1);
EXIT_IF_ISNAN((If0*eVb2e1))
{
double m00_sqrt(d00_sqrt0,(1.0+f1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+f1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
n0_Vdt_GND=((f1_Vdt_GND*(1.0+d00_sqrt0)-f1*f1_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
n0_Vb2_e1=((f1_Vb2_e1*(1.0+d00_sqrt0)-f1*f1_Vb2_e1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  n0_Vb2_e1_Vdt_GND=(f1_Vb2_e1_Vdt_GND/(1.0+d00_sqrt0)-(f1_Vb2_e1*f1_Vdt_GND*d10_sqrt0+f1_Vdt_GND*f1_Vb2_e1*d10_sqrt0+f1*(+0.0+(m20_sqrt((1.0+f1))*f1_Vdt_GND*f1_Vb2_e1+d10_sqrt0*(+0.0+f1_Vb2_e1_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f1*f1_Vb2_e1*d10_sqrt0*f1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  n0_Vb2_e1_Vb2_e1=(f1_Vb2_e1_Vb2_e1/(1.0+d00_sqrt0)-(f1_Vb2_e1*f1_Vb2_e1*d10_sqrt0+f1_Vb2_e1*f1_Vb2_e1*d10_sqrt0+f1*(+0.0+(m20_sqrt((1.0+f1))*f1_Vb2_e1*f1_Vb2_e1+d10_sqrt0*(+0.0+f1_Vb2_e1_Vb2_e1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f1*f1_Vb2_e1*d10_sqrt0*f1_Vb2_e1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
n0=(f1/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((f1/(1.0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
f2_Vdt_GND=((If0_Vdt_GND*eVb2c2star)+(If0*eVb2c2star_Vdt_GND));
#endif
f2_Vb2_c2=(If0*eVb2c2star_Vb2_c2);
#if defined(_DERIVATE2)
  f2_Vb2_c2_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+If0_Vdt_GND*eVb2c2star_Vb2_c2+If0*eVb2c2star_Vb2_c2_Vdt_GND);
  f2_Vb2_c2_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c2+If0*eVb2c2star_Vb2_c2_Vb2_c2);
  f2_Vb2_c2_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c2+If0*eVb2c2star_Vb2_c2_Vb2_c1);
  f2_Vb2_c2_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c2+If0*eVb2c2star_Vb2_c2_Vc1_c2);
#endif
f2_Vb2_c1=(If0*eVb2c2star_Vb2_c1);
#if defined(_DERIVATE2)
  f2_Vb2_c1_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+If0_Vdt_GND*eVb2c2star_Vb2_c1+If0*eVb2c2star_Vb2_c1_Vdt_GND);
  f2_Vb2_c1_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c1+If0*eVb2c2star_Vb2_c1_Vb2_c2);
  f2_Vb2_c1_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c1+If0*eVb2c2star_Vb2_c1_Vb2_c1);
  f2_Vb2_c1_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c1+If0*eVb2c2star_Vb2_c1_Vc1_c2);
#endif
f2_Vc1_c2=(If0*eVb2c2star_Vc1_c2);
#if defined(_DERIVATE2)
  f2_Vc1_c2_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+If0_Vdt_GND*eVb2c2star_Vc1_c2+If0*eVb2c2star_Vc1_c2_Vdt_GND);
  f2_Vc1_c2_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vc1_c2+If0*eVb2c2star_Vc1_c2_Vb2_c2);
  f2_Vc1_c2_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vc1_c2+If0*eVb2c2star_Vc1_c2_Vb2_c1);
  f2_Vc1_c2_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vc1_c2+If0*eVb2c2star_Vc1_c2_Vc1_c2);
#endif
#endif
f2=(If0*eVb2c2star);
EXIT_IF_ISNAN((If0*eVb2c2star))
{
double m00_sqrt(d00_sqrt0,(1.0+f2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+f2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
nB_Vdt_GND=((f2_Vdt_GND*(1.0+d00_sqrt0)-f2*f2_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nB_Vb2_c2=((f2_Vb2_c2*(1.0+d00_sqrt0)-f2*f2_Vb2_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nB_Vb2_c2_Vdt_GND=(f2_Vb2_c2_Vdt_GND/(1.0+d00_sqrt0)-(f2_Vb2_c2*f2_Vdt_GND*d10_sqrt0+f2_Vdt_GND*f2_Vb2_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vdt_GND*f2_Vb2_c2+d10_sqrt0*(+0.0+f2_Vb2_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c2*d10_sqrt0*f2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c2_Vb2_c2=(f2_Vb2_c2_Vb2_c2/(1.0+d00_sqrt0)-(f2_Vb2_c2*f2_Vb2_c2*d10_sqrt0+f2_Vb2_c2*f2_Vb2_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c2*f2_Vb2_c2+d10_sqrt0*(+0.0+f2_Vb2_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c2*d10_sqrt0*f2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c2_Vb2_c1=(f2_Vb2_c2_Vb2_c1/(1.0+d00_sqrt0)-(f2_Vb2_c2*f2_Vb2_c1*d10_sqrt0+f2_Vb2_c1*f2_Vb2_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c1*f2_Vb2_c2+d10_sqrt0*(+0.0+f2_Vb2_c2_Vb2_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c2*d10_sqrt0*f2_Vb2_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c2_Vc1_c2=(f2_Vb2_c2_Vc1_c2/(1.0+d00_sqrt0)-(f2_Vb2_c2*f2_Vc1_c2*d10_sqrt0+f2_Vc1_c2*f2_Vb2_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vc1_c2*f2_Vb2_c2+d10_sqrt0*(+0.0+f2_Vb2_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c2*d10_sqrt0*f2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nB_Vb2_c1=((f2_Vb2_c1*(1.0+d00_sqrt0)-f2*f2_Vb2_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nB_Vb2_c1_Vdt_GND=(f2_Vb2_c1_Vdt_GND/(1.0+d00_sqrt0)-(f2_Vb2_c1*f2_Vdt_GND*d10_sqrt0+f2_Vdt_GND*f2_Vb2_c1*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vdt_GND*f2_Vb2_c1+d10_sqrt0*(+0.0+f2_Vb2_c1_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c1*d10_sqrt0*f2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c1_Vb2_c2=(f2_Vb2_c1_Vb2_c2/(1.0+d00_sqrt0)-(f2_Vb2_c1*f2_Vb2_c2*d10_sqrt0+f2_Vb2_c2*f2_Vb2_c1*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c2*f2_Vb2_c1+d10_sqrt0*(+0.0+f2_Vb2_c1_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c1*d10_sqrt0*f2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c1_Vb2_c1=(f2_Vb2_c1_Vb2_c1/(1.0+d00_sqrt0)-(f2_Vb2_c1*f2_Vb2_c1*d10_sqrt0+f2_Vb2_c1*f2_Vb2_c1*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c1*f2_Vb2_c1+d10_sqrt0*(+0.0+f2_Vb2_c1_Vb2_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c1*d10_sqrt0*f2_Vb2_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vb2_c1_Vc1_c2=(f2_Vb2_c1_Vc1_c2/(1.0+d00_sqrt0)-(f2_Vb2_c1*f2_Vc1_c2*d10_sqrt0+f2_Vc1_c2*f2_Vb2_c1*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vc1_c2*f2_Vb2_c1+d10_sqrt0*(+0.0+f2_Vb2_c1_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vb2_c1*d10_sqrt0*f2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nB_Vc1_c2=((f2_Vc1_c2*(1.0+d00_sqrt0)-f2*f2_Vc1_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nB_Vc1_c2_Vdt_GND=(f2_Vc1_c2_Vdt_GND/(1.0+d00_sqrt0)-(f2_Vc1_c2*f2_Vdt_GND*d10_sqrt0+f2_Vdt_GND*f2_Vc1_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vdt_GND*f2_Vc1_c2+d10_sqrt0*(+0.0+f2_Vc1_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vc1_c2*d10_sqrt0*f2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vc1_c2_Vb2_c2=(f2_Vc1_c2_Vb2_c2/(1.0+d00_sqrt0)-(f2_Vc1_c2*f2_Vb2_c2*d10_sqrt0+f2_Vb2_c2*f2_Vc1_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c2*f2_Vc1_c2+d10_sqrt0*(+0.0+f2_Vc1_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vc1_c2*d10_sqrt0*f2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vc1_c2_Vb2_c1=(f2_Vc1_c2_Vb2_c1/(1.0+d00_sqrt0)-(f2_Vc1_c2*f2_Vb2_c1*d10_sqrt0+f2_Vb2_c1*f2_Vc1_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vb2_c1*f2_Vc1_c2+d10_sqrt0*(+0.0+f2_Vc1_c2_Vb2_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vc1_c2*d10_sqrt0*f2_Vb2_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nB_Vc1_c2_Vc1_c2=(f2_Vc1_c2_Vc1_c2/(1.0+d00_sqrt0)-(f2_Vc1_c2*f2_Vc1_c2*d10_sqrt0+f2_Vc1_c2*f2_Vc1_c2*d10_sqrt0+f2*(+0.0+(m20_sqrt((1.0+f2))*f2_Vc1_c2*f2_Vc1_c2+d10_sqrt0*(+0.0+f2_Vc1_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*f2*f2_Vc1_c2*d10_sqrt0*f2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
nB=(f2/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((f2/(1.0+d00_sqrt0)))
}
if
((pModel->DEG==0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
q0I_Vdt_GND=(((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)+((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T));
#endif
q0I_Vb2_e1=((Vte_Vb2_e1/VER_T)+(Vtc_Vb2_e1/VEF_T));
#if defined(_DERIVATE2)
  q0I_Vb2_e1_Vdt_GND=(+(+0.0+(Vte_Vb2_e1_Vdt_GND/VER_T-(Vte_Vb2_e1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vdt_GND/VEF_T-(Vtc_Vb2_e1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_e1_Vb2_e1=(+(+0.0+(Vte_Vb2_e1_Vb2_e1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_e1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_e1_Vb2_c2=(+(+0.0+(Vte_Vb2_e1_Vb2_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_e1_Vb2_c1=(+(+0.0+(Vte_Vb2_e1_Vb2_c1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_c1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_e1_Vc1_c2=(+(+0.0+(Vte_Vb2_e1_Vc1_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vc1_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0I_Vb2_c2=((Vte_Vb2_c2/VER_T)+(Vtc_Vb2_c2/VEF_T));
#if defined(_DERIVATE2)
  q0I_Vb2_c2_Vdt_GND=(+(+0.0+(Vte_Vb2_c2_Vdt_GND/VER_T-(Vte_Vb2_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vdt_GND/VEF_T-(Vtc_Vb2_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c2_Vb2_e1=(+(+0.0+(Vte_Vb2_c2_Vb2_e1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_e1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c2_Vb2_c2=(+(+0.0+(Vte_Vb2_c2_Vb2_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c2_Vb2_c1=(+(+0.0+(Vte_Vb2_c2_Vb2_c1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_c1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c2_Vc1_c2=(+(+0.0+(Vte_Vb2_c2_Vc1_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vc1_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0I_Vb2_c1=((Vte_Vb2_c1/VER_T)+(Vtc_Vb2_c1/VEF_T));
#if defined(_DERIVATE2)
  q0I_Vb2_c1_Vdt_GND=(+(+0.0+(Vte_Vb2_c1_Vdt_GND/VER_T-(Vte_Vb2_c1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vdt_GND/VEF_T-(Vtc_Vb2_c1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c1_Vb2_e1=(+(+0.0+(Vte_Vb2_c1_Vb2_e1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_e1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c1_Vb2_c2=(+(+0.0+(Vte_Vb2_c1_Vb2_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c1_Vb2_c1=(+(+0.0+(Vte_Vb2_c1_Vb2_c1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_c1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vb2_c1_Vc1_c2=(+(+0.0+(Vte_Vb2_c1_Vc1_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vc1_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0I_Vc1_c2=((Vte_Vc1_c2/VER_T)+(Vtc_Vc1_c2/VEF_T));
#if defined(_DERIVATE2)
  q0I_Vc1_c2_Vdt_GND=(+(+0.0+(Vte_Vc1_c2_Vdt_GND/VER_T-(Vte_Vc1_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vdt_GND/VEF_T-(Vtc_Vc1_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0I_Vc1_c2_Vb2_e1=(+(+0.0+(Vte_Vc1_c2_Vb2_e1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_e1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vc1_c2_Vb2_c2=(+(+0.0+(Vte_Vc1_c2_Vb2_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vc1_c2_Vb2_c1=(+(+0.0+(Vte_Vc1_c2_Vb2_c1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_c1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0I_Vc1_c2_Vc1_c2=(+(+0.0+(Vte_Vc1_c2_Vc1_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vc1_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
#endif
q0I=((1.0+(Vte/VER_T))+(Vtc/VEF_T));
EXIT_IF_ISNAN(((1.0+(Vte/VER_T))+(Vtc/VEF_T)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND) */
#if defined(_DERIVATE)
termE_Vdt_GND=((((((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*DEG_T)+(((Vte/VER_T)+1.0)*DEG_T_Vdt_GND))*VtINV)+((((Vte/VER_T)+1.0)*DEG_T)*VtINV_Vdt_GND));
#endif
termE_Vb2_e1=(Vte_Vb2_e1/VER_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termE_Vb2_e1_Vdt_GND=(+(+(+(Vte_Vb2_e1_Vdt_GND/VER_T-(Vte_Vb2_e1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_e1/VER_T)*DEG_T_Vdt_GND+((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_e1/VER_T)*DEG_T*VtINV_Vdt_GND+(((((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*DEG_T)+(((Vte/VER_T)+1.0)*DEG_T_Vdt_GND)))*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_e1_Vb2_e1=(+(+(+(Vte_Vb2_e1_Vb2_e1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_e1/VER_T)*0.0+(Vte_Vb2_e1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_e1/VER_T)*DEG_T*0.0+((Vte_Vb2_e1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_e1_Vb2_c2=(+(+(+(Vte_Vb2_e1_Vb2_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_e1/VER_T)*0.0+(Vte_Vb2_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_e1/VER_T)*DEG_T*0.0+((Vte_Vb2_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_e1_Vb2_c1=(+(+(+(Vte_Vb2_e1_Vb2_c1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_e1/VER_T)*0.0+(Vte_Vb2_c1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_e1/VER_T)*DEG_T*0.0+((Vte_Vb2_c1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_e1_Vc1_c2=(+(+(+(Vte_Vb2_e1_Vc1_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_e1/VER_T)*0.0+(Vte_Vc1_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_e1/VER_T)*DEG_T*0.0+((Vte_Vc1_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
#endif
termE_Vb2_c2=(Vte_Vb2_c2/VER_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termE_Vb2_c2_Vdt_GND=(+(+(+(Vte_Vb2_c2_Vdt_GND/VER_T-(Vte_Vb2_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c2/VER_T)*DEG_T_Vdt_GND+((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c2/VER_T)*DEG_T*VtINV_Vdt_GND+(((((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*DEG_T)+(((Vte/VER_T)+1.0)*DEG_T_Vdt_GND)))*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c2_Vb2_e1=(+(+(+(Vte_Vb2_c2_Vb2_e1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c2/VER_T)*0.0+(Vte_Vb2_e1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_e1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c2_Vb2_c2=(+(+(+(Vte_Vb2_c2_Vb2_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c2/VER_T)*0.0+(Vte_Vb2_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c2_Vb2_c1=(+(+(+(Vte_Vb2_c2_Vb2_c1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c2/VER_T)*0.0+(Vte_Vb2_c1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_c1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c2_Vc1_c2=(+(+(+(Vte_Vb2_c2_Vc1_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c2/VER_T)*0.0+(Vte_Vc1_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c2/VER_T)*DEG_T*0.0+((Vte_Vc1_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
#endif
termE_Vb2_c1=(Vte_Vb2_c1/VER_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termE_Vb2_c1_Vdt_GND=(+(+(+(Vte_Vb2_c1_Vdt_GND/VER_T-(Vte_Vb2_c1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c1/VER_T)*DEG_T_Vdt_GND+((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c1/VER_T)*DEG_T*VtINV_Vdt_GND+(((((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*DEG_T)+(((Vte/VER_T)+1.0)*DEG_T_Vdt_GND)))*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c1_Vb2_e1=(+(+(+(Vte_Vb2_c1_Vb2_e1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c1/VER_T)*0.0+(Vte_Vb2_e1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c1/VER_T)*DEG_T*0.0+((Vte_Vb2_e1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c1_Vb2_c2=(+(+(+(Vte_Vb2_c1_Vb2_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c1/VER_T)*0.0+(Vte_Vb2_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c1/VER_T)*DEG_T*0.0+((Vte_Vb2_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c1_Vb2_c1=(+(+(+(Vte_Vb2_c1_Vb2_c1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c1/VER_T)*0.0+(Vte_Vb2_c1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c1/VER_T)*DEG_T*0.0+((Vte_Vb2_c1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vb2_c1_Vc1_c2=(+(+(+(Vte_Vb2_c1_Vc1_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vb2_c1/VER_T)*0.0+(Vte_Vc1_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vb2_c1/VER_T)*DEG_T*0.0+((Vte_Vc1_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
#endif
termE_Vc1_c2=(Vte_Vc1_c2/VER_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termE_Vc1_c2_Vdt_GND=(+(+(+(Vte_Vc1_c2_Vdt_GND/VER_T-(Vte_Vc1_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vc1_c2/VER_T)*DEG_T_Vdt_GND+((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vc1_c2/VER_T)*DEG_T*VtINV_Vdt_GND+(((((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)*DEG_T)+(((Vte/VER_T)+1.0)*DEG_T_Vdt_GND)))*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vc1_c2_Vb2_e1=(+(+(+(Vte_Vc1_c2_Vb2_e1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vc1_c2/VER_T)*0.0+(Vte_Vb2_e1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vc1_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_e1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vc1_c2_Vb2_c2=(+(+(+(Vte_Vc1_c2_Vb2_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vc1_c2/VER_T)*0.0+(Vte_Vb2_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vc1_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vc1_c2_Vb2_c1=(+(+(+(Vte_Vc1_c2_Vb2_c1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vc1_c2/VER_T)*0.0+(Vte_Vb2_c1/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vc1_c2/VER_T)*DEG_T*0.0+((Vte_Vb2_c1/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
  termE_Vc1_c2_Vc1_c2=(+(+(+(Vte_Vc1_c2_Vc1_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T)+0.0)*DEG_T+(Vte_Vc1_c2/VER_T)*0.0+(Vte_Vc1_c2/VER_T)*0.0+((Vte/VER_T)+1.0)*0.0)*VtINV+(Vte_Vc1_c2/VER_T)*DEG_T*0.0+((Vte_Vc1_c2/VER_T)*DEG_T)*0.0+(((Vte/VER_T)+1.0)*DEG_T)*0.0);
#endif
#endif
termE=((((Vte/VER_T)+1.0)*DEG_T)*VtINV);
EXIT_IF_ISNAN(((((Vte/VER_T)+1.0)*DEG_T)*VtINV))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b2,e1) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b,GND)V(b2,GND) */
#if defined(_DERIVATE)
termC_Vdt_GND=(((((((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*DEG_T)+(((-Vtc)/VEF_T)*DEG_T_Vdt_GND))*VtINV)+((((-Vtc)/VEF_T)*DEG_T)*VtINV_Vdt_GND));
#endif
termC_Vb2_c2=((-Vtc_Vb2_c2)/VEF_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termC_Vb2_c2_Vdt_GND=(+(+(0.0/VEF_T-((-Vtc_Vb2_c2)*VEF_T_Vdt_GND+(-Vtc_Vdt_GND)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c2)/VEF_T)*DEG_T_Vdt_GND+(((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c2)/VEF_T)*DEG_T*VtINV_Vdt_GND+((((((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*DEG_T)+(((-Vtc)/VEF_T)*DEG_T_Vdt_GND)))*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c2_Vb2_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_c2)*0.0+(-Vtc_Vb2_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c2_Vb2_c1=(+(+(0.0/VEF_T-((-Vtc_Vb2_c2)*0.0+(-Vtc_Vb2_c1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c2_Vc1_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_c2)*0.0+(-Vtc_Vc1_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vc1_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c2_Vb2_e1=(+(+(0.0/VEF_T-((-Vtc_Vb2_c2)*0.0+(-Vtc_Vb2_e1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_e1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
#endif
termC_Vb2_c1=((-Vtc_Vb2_c1)/VEF_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termC_Vb2_c1_Vdt_GND=(+(+(0.0/VEF_T-((-Vtc_Vb2_c1)*VEF_T_Vdt_GND+(-Vtc_Vdt_GND)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c1)/VEF_T)*DEG_T_Vdt_GND+(((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c1)/VEF_T)*DEG_T*VtINV_Vdt_GND+((((((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*DEG_T)+(((-Vtc)/VEF_T)*DEG_T_Vdt_GND)))*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c1_Vb2_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_c1)*0.0+(-Vtc_Vb2_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c1_Vb2_c1=(+(+(0.0/VEF_T-((-Vtc_Vb2_c1)*0.0+(-Vtc_Vb2_c1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c1_Vc1_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_c1)*0.0+(-Vtc_Vc1_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vc1_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_c1_Vb2_e1=(+(+(0.0/VEF_T-((-Vtc_Vb2_c1)*0.0+(-Vtc_Vb2_e1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_c1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_e1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
#endif
termC_Vc1_c2=((-Vtc_Vc1_c2)/VEF_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termC_Vc1_c2_Vdt_GND=(+(+(0.0/VEF_T-((-Vtc_Vc1_c2)*VEF_T_Vdt_GND+(-Vtc_Vdt_GND)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vc1_c2)/VEF_T)*DEG_T_Vdt_GND+(((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vc1_c2)/VEF_T)*DEG_T*VtINV_Vdt_GND+((((((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*DEG_T)+(((-Vtc)/VEF_T)*DEG_T_Vdt_GND)))*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vc1_c2_Vb2_c2=(+(+(0.0/VEF_T-((-Vtc_Vc1_c2)*0.0+(-Vtc_Vb2_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vc1_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vc1_c2_Vb2_c1=(+(+(0.0/VEF_T-((-Vtc_Vc1_c2)*0.0+(-Vtc_Vb2_c1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vc1_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vc1_c2_Vc1_c2=(+(+(0.0/VEF_T-((-Vtc_Vc1_c2)*0.0+(-Vtc_Vc1_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vc1_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vc1_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vc1_c2_Vb2_e1=(+(+(0.0/VEF_T-((-Vtc_Vc1_c2)*0.0+(-Vtc_Vb2_e1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vc1_c2)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_e1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
#endif
termC_Vb2_e1=((-Vtc_Vb2_e1)/VEF_T)*DEG_T*VtINV;
#if defined(_DERIVATE2)
  termC_Vb2_e1_Vdt_GND=(+(+(0.0/VEF_T-((-Vtc_Vb2_e1)*VEF_T_Vdt_GND+(-Vtc_Vdt_GND)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_e1)/VEF_T)*DEG_T_Vdt_GND+(((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_e1)/VEF_T)*DEG_T*VtINV_Vdt_GND+((((((-Vtc_Vdt_GND)*VEF_T-(-Vtc)*VEF_T_Vdt_GND)/VEF_T/VEF_T)*DEG_T)+(((-Vtc)/VEF_T)*DEG_T_Vdt_GND)))*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_e1_Vb2_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_e1)*0.0+(-Vtc_Vb2_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc_Vb2_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_e1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_e1_Vb2_c1=(+(+(0.0/VEF_T-((-Vtc_Vb2_e1)*0.0+(-Vtc_Vb2_c1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc_Vb2_c1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_e1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_c1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_e1_Vc1_c2=(+(+(0.0/VEF_T-((-Vtc_Vb2_e1)*0.0+(-Vtc_Vc1_c2)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc_Vc1_c2)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_e1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vc1_c2)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
  termC_Vb2_e1_Vb2_e1=(+(+(0.0/VEF_T-((-Vtc_Vb2_e1)*0.0+(-Vtc_Vb2_e1)*0.0+(-Vtc)*0.0)/VEF_T/VEF_T+2*(-Vtc)*0.0*0.0/VEF_T/VEF_T/VEF_T)*DEG_T+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc_Vb2_e1)/VEF_T)*0.0+((-Vtc)/VEF_T)*0.0)*VtINV+((-Vtc_Vb2_e1)/VEF_T)*DEG_T*0.0+(((-Vtc_Vb2_e1)/VEF_T)*DEG_T)*0.0+(((-Vtc)/VEF_T)*DEG_T)*0.0);
#endif
#endif
termC=((((-Vtc)/VEF_T)*DEG_T)*VtINV);
EXIT_IF_ISNAN(((((-Vtc)/VEF_T)*DEG_T)*VtINV))
{
double m00_exp(d00_exp0,termE)
double m00_exp(d00_exp1,termC)
double m00_exp(d00_exp2,(DEG_T*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#define d10_exp2 d00_exp2
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(b,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
q0I_Vdt_GND=(((termE_Vdt_GND*d10_exp0-termC_Vdt_GND*d10_exp1)*(d00_exp2-1.0)-(d00_exp0-d00_exp1)*((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND))*d10_exp2)/(d00_exp2-1.0)/(d00_exp2-1.0));
#endif
q0I_Vb2_e1=((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)/(d00_exp2-1.0));
#if defined(_DERIVATE2)
  q0I_Vb2_e1_Vdt_GND=((+(m20_exp(termE)*termE_Vdt_GND*termE_Vb2_e1+d10_exp0*termE_Vb2_e1_Vdt_GND)-(m20_exp(termC)*termC_Vdt_GND*termC_Vb2_e1+d10_exp1*termC_Vb2_e1_Vdt_GND))/(d00_exp2-1.0)-((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2+(termE_Vdt_GND*d10_exp0-termC_Vdt_GND*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_e1_Vb2_e1=((+(m20_exp(termE)*termE_Vb2_e1*termE_Vb2_e1+d10_exp0*termE_Vb2_e1_Vb2_e1)-(m20_exp(termC)*termC_Vb2_e1*termC_Vb2_e1+d10_exp1*termC_Vb2_e1_Vb2_e1))/(d00_exp2-1.0)-((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_e1_Vb2_c2=((+(m20_exp(termE)*termE_Vb2_c2*termE_Vb2_e1+d10_exp0*termE_Vb2_e1_Vb2_c2)-(m20_exp(termC)*termC_Vb2_c2*termC_Vb2_e1+d10_exp1*termC_Vb2_e1_Vb2_c2))/(d00_exp2-1.0)-((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_e1_Vb2_c1=((+(m20_exp(termE)*termE_Vb2_c1*termE_Vb2_e1+d10_exp0*termE_Vb2_e1_Vb2_c1)-(m20_exp(termC)*termC_Vb2_c1*termC_Vb2_e1+d10_exp1*termC_Vb2_e1_Vb2_c1))/(d00_exp2-1.0)-((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_e1_Vc1_c2=((+(m20_exp(termE)*termE_Vc1_c2*termE_Vb2_e1+d10_exp0*termE_Vb2_e1_Vc1_c2)-(m20_exp(termC)*termC_Vc1_c2*termC_Vb2_e1+d10_exp1*termC_Vb2_e1_Vc1_c2))/(d00_exp2-1.0)-((termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*(0.0)*d10_exp2+(termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
#endif
q0I_Vb2_c2=((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)/(d00_exp2-1.0));
#if defined(_DERIVATE2)
  q0I_Vb2_c2_Vdt_GND=((+(m20_exp(termE)*termE_Vdt_GND*termE_Vb2_c2+d10_exp0*termE_Vb2_c2_Vdt_GND)-(m20_exp(termC)*termC_Vdt_GND*termC_Vb2_c2+d10_exp1*termC_Vb2_c2_Vdt_GND))/(d00_exp2-1.0)-((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2+(termE_Vdt_GND*d10_exp0-termC_Vdt_GND*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c2_Vb2_e1=((+(m20_exp(termE)*termE_Vb2_e1*termE_Vb2_c2+d10_exp0*termE_Vb2_c2_Vb2_e1)-(m20_exp(termC)*termC_Vb2_e1*termC_Vb2_c2+d10_exp1*termC_Vb2_c2_Vb2_e1))/(d00_exp2-1.0)-((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c2_Vb2_c2=((+(m20_exp(termE)*termE_Vb2_c2*termE_Vb2_c2+d10_exp0*termE_Vb2_c2_Vb2_c2)-(m20_exp(termC)*termC_Vb2_c2*termC_Vb2_c2+d10_exp1*termC_Vb2_c2_Vb2_c2))/(d00_exp2-1.0)-((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c2_Vb2_c1=((+(m20_exp(termE)*termE_Vb2_c1*termE_Vb2_c2+d10_exp0*termE_Vb2_c2_Vb2_c1)-(m20_exp(termC)*termC_Vb2_c1*termC_Vb2_c2+d10_exp1*termC_Vb2_c2_Vb2_c1))/(d00_exp2-1.0)-((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c2_Vc1_c2=((+(m20_exp(termE)*termE_Vc1_c2*termE_Vb2_c2+d10_exp0*termE_Vb2_c2_Vc1_c2)-(m20_exp(termC)*termC_Vc1_c2*termC_Vb2_c2+d10_exp1*termC_Vb2_c2_Vc1_c2))/(d00_exp2-1.0)-((termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
#endif
q0I_Vb2_c1=((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)/(d00_exp2-1.0));
#if defined(_DERIVATE2)
  q0I_Vb2_c1_Vdt_GND=((+(m20_exp(termE)*termE_Vdt_GND*termE_Vb2_c1+d10_exp0*termE_Vb2_c1_Vdt_GND)-(m20_exp(termC)*termC_Vdt_GND*termC_Vb2_c1+d10_exp1*termC_Vb2_c1_Vdt_GND))/(d00_exp2-1.0)-((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2+(termE_Vdt_GND*d10_exp0-termC_Vdt_GND*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c1_Vb2_e1=((+(m20_exp(termE)*termE_Vb2_e1*termE_Vb2_c1+d10_exp0*termE_Vb2_c1_Vb2_e1)-(m20_exp(termC)*termC_Vb2_e1*termC_Vb2_c1+d10_exp1*termC_Vb2_c1_Vb2_e1))/(d00_exp2-1.0)-((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c1_Vb2_c2=((+(m20_exp(termE)*termE_Vb2_c2*termE_Vb2_c1+d10_exp0*termE_Vb2_c1_Vb2_c2)-(m20_exp(termC)*termC_Vb2_c2*termC_Vb2_c1+d10_exp1*termC_Vb2_c1_Vb2_c2))/(d00_exp2-1.0)-((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c1_Vb2_c1=((+(m20_exp(termE)*termE_Vb2_c1*termE_Vb2_c1+d10_exp0*termE_Vb2_c1_Vb2_c1)-(m20_exp(termC)*termC_Vb2_c1*termC_Vb2_c1+d10_exp1*termC_Vb2_c1_Vb2_c1))/(d00_exp2-1.0)-((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vb2_c1_Vc1_c2=((+(m20_exp(termE)*termE_Vc1_c2*termE_Vb2_c1+d10_exp0*termE_Vb2_c1_Vc1_c2)-(m20_exp(termC)*termC_Vc1_c2*termC_Vb2_c1+d10_exp1*termC_Vb2_c1_Vc1_c2))/(d00_exp2-1.0)-((termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*(0.0)*d10_exp2+(termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
#endif
q0I_Vc1_c2=((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)/(d00_exp2-1.0));
#if defined(_DERIVATE2)
  q0I_Vc1_c2_Vdt_GND=((+(m20_exp(termE)*termE_Vdt_GND*termE_Vc1_c2+d10_exp0*termE_Vc1_c2_Vdt_GND)-(m20_exp(termC)*termC_Vdt_GND*termC_Vc1_c2+d10_exp1*termC_Vc1_c2_Vdt_GND))/(d00_exp2-1.0)-((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2+(termE_Vdt_GND*d10_exp0-termC_Vdt_GND*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(((DEG_T_Vdt_GND*VtINV)+(DEG_T*VtINV_Vdt_GND)))*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vc1_c2_Vb2_e1=((+(m20_exp(termE)*termE_Vb2_e1*termE_Vc1_c2+d10_exp0*termE_Vc1_c2_Vb2_e1)-(m20_exp(termC)*termC_Vb2_e1*termC_Vc1_c2+d10_exp1*termC_Vc1_c2_Vb2_e1))/(d00_exp2-1.0)-((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_e1*d10_exp0-termC_Vb2_e1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vc1_c2_Vb2_c2=((+(m20_exp(termE)*termE_Vb2_c2*termE_Vc1_c2+d10_exp0*termE_Vc1_c2_Vb2_c2)-(m20_exp(termC)*termC_Vb2_c2*termC_Vc1_c2+d10_exp1*termC_Vc1_c2_Vb2_c2))/(d00_exp2-1.0)-((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c2*d10_exp0-termC_Vb2_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vc1_c2_Vb2_c1=((+(m20_exp(termE)*termE_Vb2_c1*termE_Vc1_c2+d10_exp0*termE_Vc1_c2_Vb2_c1)-(m20_exp(termC)*termC_Vb2_c1*termC_Vc1_c2+d10_exp1*termC_Vc1_c2_Vb2_c1))/(d00_exp2-1.0)-((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vb2_c1*d10_exp0-termC_Vb2_c1*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
  q0I_Vc1_c2_Vc1_c2=((+(m20_exp(termE)*termE_Vc1_c2*termE_Vc1_c2+d10_exp0*termE_Vc1_c2_Vc1_c2)-(m20_exp(termC)*termC_Vc1_c2*termC_Vc1_c2+d10_exp1*termC_Vc1_c2_Vc1_c2))/(d00_exp2-1.0)-((termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*(0.0)*d10_exp2+(termE_Vc1_c2*d10_exp0-termC_Vc1_c2*d10_exp1)*0.0+(d00_exp0-d00_exp1)*(+0.0-0.0))/(d00_exp2-1.0)/(d00_exp2-1.0)+2*(d00_exp0-d00_exp1)*0.0*(0.0)*d10_exp2/(d00_exp2-1.0)/(d00_exp2-1.0)/(d00_exp2-1.0));
#endif
#endif
q0I=((d00_exp0-d00_exp1)/(d00_exp2-1.0));
EXIT_IF_ISNAN(((d00_exp0-d00_exp1)/(d00_exp2-1.0)))
}
}
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eps2_Vdt_GND=0.0;
#endif
eps2=(0.1*0.1);
EXIT_IF_ISNAN((0.1*0.1))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
x2_Vb_c=0.0;
#if defined(_DERIVATE2)
  x2_Vb_c_Vb_c=0.0;
  x2_Vb_c_Vb_b1=0.0;
  x2_Vb_c_Vb1_b2=0.0;
  x2_Vb_c_Vc4_c1=0.0;
  x2_Vb_c_Vc3_c1=0.0;
  x2_Vb_c_Vc3_c4=0.0;
  x2_Vb_c_Vb2_e1=0.0;
  x2_Vb_c_Vdt_GND=0.0;
  x2_Vb_c_Vb2_c2=0.0;
  x2_Vb_c_Vb2_c1=0.0;
  x2_Vb_c_Vc1_c2=0.0;
#endif
x2_Vb_b1=0.0;
#if defined(_DERIVATE2)
  x2_Vb_b1_Vb_c=0.0;
  x2_Vb_b1_Vb_b1=0.0;
  x2_Vb_b1_Vb1_b2=0.0;
  x2_Vb_b1_Vc4_c1=0.0;
  x2_Vb_b1_Vc3_c1=0.0;
  x2_Vb_b1_Vc3_c4=0.0;
  x2_Vb_b1_Vb2_e1=0.0;
  x2_Vb_b1_Vdt_GND=0.0;
  x2_Vb_b1_Vb2_c2=0.0;
  x2_Vb_b1_Vb2_c1=0.0;
  x2_Vb_b1_Vc1_c2=0.0;
#endif
x2_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  x2_Vb1_b2_Vb_c=0.0;
  x2_Vb1_b2_Vb_b1=0.0;
  x2_Vb1_b2_Vb1_b2=0.0;
  x2_Vb1_b2_Vc4_c1=0.0;
  x2_Vb1_b2_Vc3_c1=0.0;
  x2_Vb1_b2_Vc3_c4=0.0;
  x2_Vb1_b2_Vb2_e1=0.0;
  x2_Vb1_b2_Vdt_GND=0.0;
  x2_Vb1_b2_Vb2_c2=0.0;
  x2_Vb1_b2_Vb2_c1=0.0;
  x2_Vb1_b2_Vc1_c2=0.0;
#endif
x2_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc4_c1_Vb_c=0.0;
  x2_Vc4_c1_Vb_b1=0.0;
  x2_Vc4_c1_Vb1_b2=0.0;
  x2_Vc4_c1_Vc4_c1=0.0;
  x2_Vc4_c1_Vc3_c1=0.0;
  x2_Vc4_c1_Vc3_c4=0.0;
  x2_Vc4_c1_Vb2_e1=0.0;
  x2_Vc4_c1_Vdt_GND=0.0;
  x2_Vc4_c1_Vb2_c2=0.0;
  x2_Vc4_c1_Vb2_c1=0.0;
  x2_Vc4_c1_Vc1_c2=0.0;
#endif
x2_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc3_c1_Vb_c=0.0;
  x2_Vc3_c1_Vb_b1=0.0;
  x2_Vc3_c1_Vb1_b2=0.0;
  x2_Vc3_c1_Vc4_c1=0.0;
  x2_Vc3_c1_Vc3_c1=0.0;
  x2_Vc3_c1_Vc3_c4=0.0;
  x2_Vc3_c1_Vb2_e1=0.0;
  x2_Vc3_c1_Vdt_GND=0.0;
  x2_Vc3_c1_Vb2_c2=0.0;
  x2_Vc3_c1_Vb2_c1=0.0;
  x2_Vc3_c1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
x2_Vc3_c4=0.0;
#endif
x2_Vb2_e1=((q0I_Vb2_e1*q0I)+(q0I*q0I_Vb2_e1));
#if defined(_DERIVATE2)
  x2_Vb2_e1_Vb_c=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vb_b1=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vb1_b2=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vc4_c1=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vc3_c1=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vc3_c4=(+0.0*q0I+q0I_Vb2_e1*0.0+0.0*q0I_Vb2_e1+q0I*0.0);
  x2_Vb2_e1_Vb2_e1=(+q0I_Vb2_e1_Vb2_e1*q0I+q0I_Vb2_e1*q0I_Vb2_e1+q0I_Vb2_e1*q0I_Vb2_e1+q0I*q0I_Vb2_e1_Vb2_e1);
  x2_Vb2_e1_Vdt_GND=(+q0I_Vb2_e1_Vdt_GND*q0I+q0I_Vb2_e1*q0I_Vdt_GND+q0I_Vdt_GND*q0I_Vb2_e1+q0I*q0I_Vb2_e1_Vdt_GND);
  x2_Vb2_e1_Vb2_c2=(+q0I_Vb2_e1_Vb2_c2*q0I+q0I_Vb2_e1*q0I_Vb2_c2+q0I_Vb2_c2*q0I_Vb2_e1+q0I*q0I_Vb2_e1_Vb2_c2);
  x2_Vb2_e1_Vb2_c1=(+q0I_Vb2_e1_Vb2_c1*q0I+q0I_Vb2_e1*q0I_Vb2_c1+q0I_Vb2_c1*q0I_Vb2_e1+q0I*q0I_Vb2_e1_Vb2_c1);
  x2_Vb2_e1_Vc1_c2=(+q0I_Vb2_e1_Vc1_c2*q0I+q0I_Vb2_e1*q0I_Vc1_c2+q0I_Vc1_c2*q0I_Vb2_e1+q0I*q0I_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
x2_Vdt_GND=((q0I_Vdt_GND*q0I)+(q0I*q0I_Vdt_GND));
#endif
x2_Vb2_c2=((q0I_Vb2_c2*q0I)+(q0I*q0I_Vb2_c2));
#if defined(_DERIVATE2)
  x2_Vb2_c2_Vb_c=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vb_b1=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vb1_b2=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vc4_c1=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vc3_c1=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vc3_c4=(+0.0*q0I+q0I_Vb2_c2*0.0+0.0*q0I_Vb2_c2+q0I*0.0);
  x2_Vb2_c2_Vb2_e1=(+q0I_Vb2_c2_Vb2_e1*q0I+q0I_Vb2_c2*q0I_Vb2_e1+q0I_Vb2_e1*q0I_Vb2_c2+q0I*q0I_Vb2_c2_Vb2_e1);
  x2_Vb2_c2_Vdt_GND=(+q0I_Vb2_c2_Vdt_GND*q0I+q0I_Vb2_c2*q0I_Vdt_GND+q0I_Vdt_GND*q0I_Vb2_c2+q0I*q0I_Vb2_c2_Vdt_GND);
  x2_Vb2_c2_Vb2_c2=(+q0I_Vb2_c2_Vb2_c2*q0I+q0I_Vb2_c2*q0I_Vb2_c2+q0I_Vb2_c2*q0I_Vb2_c2+q0I*q0I_Vb2_c2_Vb2_c2);
  x2_Vb2_c2_Vb2_c1=(+q0I_Vb2_c2_Vb2_c1*q0I+q0I_Vb2_c2*q0I_Vb2_c1+q0I_Vb2_c1*q0I_Vb2_c2+q0I*q0I_Vb2_c2_Vb2_c1);
  x2_Vb2_c2_Vc1_c2=(+q0I_Vb2_c2_Vc1_c2*q0I+q0I_Vb2_c2*q0I_Vc1_c2+q0I_Vc1_c2*q0I_Vb2_c2+q0I*q0I_Vb2_c2_Vc1_c2);
#endif
x2_Vb2_c1=((q0I_Vb2_c1*q0I)+(q0I*q0I_Vb2_c1));
#if defined(_DERIVATE2)
  x2_Vb2_c1_Vb_c=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vb_b1=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vb1_b2=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vc4_c1=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vc3_c1=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vc3_c4=(+0.0*q0I+q0I_Vb2_c1*0.0+0.0*q0I_Vb2_c1+q0I*0.0);
  x2_Vb2_c1_Vb2_e1=(+q0I_Vb2_c1_Vb2_e1*q0I+q0I_Vb2_c1*q0I_Vb2_e1+q0I_Vb2_e1*q0I_Vb2_c1+q0I*q0I_Vb2_c1_Vb2_e1);
  x2_Vb2_c1_Vdt_GND=(+q0I_Vb2_c1_Vdt_GND*q0I+q0I_Vb2_c1*q0I_Vdt_GND+q0I_Vdt_GND*q0I_Vb2_c1+q0I*q0I_Vb2_c1_Vdt_GND);
  x2_Vb2_c1_Vb2_c2=(+q0I_Vb2_c1_Vb2_c2*q0I+q0I_Vb2_c1*q0I_Vb2_c2+q0I_Vb2_c2*q0I_Vb2_c1+q0I*q0I_Vb2_c1_Vb2_c2);
  x2_Vb2_c1_Vb2_c1=(+q0I_Vb2_c1_Vb2_c1*q0I+q0I_Vb2_c1*q0I_Vb2_c1+q0I_Vb2_c1*q0I_Vb2_c1+q0I*q0I_Vb2_c1_Vb2_c1);
  x2_Vb2_c1_Vc1_c2=(+q0I_Vb2_c1_Vc1_c2*q0I+q0I_Vb2_c1*q0I_Vc1_c2+q0I_Vc1_c2*q0I_Vb2_c1+q0I*q0I_Vb2_c1_Vc1_c2);
#endif
x2_Vc1_c2=((q0I_Vc1_c2*q0I)+(q0I*q0I_Vc1_c2));
#if defined(_DERIVATE2)
  x2_Vc1_c2_Vb_c=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vb_b1=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vb1_b2=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vc4_c1=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vc3_c1=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vc3_c4=(+0.0*q0I+q0I_Vc1_c2*0.0+0.0*q0I_Vc1_c2+q0I*0.0);
  x2_Vc1_c2_Vb2_e1=(+q0I_Vc1_c2_Vb2_e1*q0I+q0I_Vc1_c2*q0I_Vb2_e1+q0I_Vb2_e1*q0I_Vc1_c2+q0I*q0I_Vc1_c2_Vb2_e1);
  x2_Vc1_c2_Vdt_GND=(+q0I_Vc1_c2_Vdt_GND*q0I+q0I_Vc1_c2*q0I_Vdt_GND+q0I_Vdt_GND*q0I_Vc1_c2+q0I*q0I_Vc1_c2_Vdt_GND);
  x2_Vc1_c2_Vb2_c2=(+q0I_Vc1_c2_Vb2_c2*q0I+q0I_Vc1_c2*q0I_Vb2_c2+q0I_Vb2_c2*q0I_Vc1_c2+q0I*q0I_Vc1_c2_Vb2_c2);
  x2_Vc1_c2_Vb2_c1=(+q0I_Vc1_c2_Vb2_c1*q0I+q0I_Vc1_c2*q0I_Vb2_c1+q0I_Vb2_c1*q0I_Vc1_c2+q0I*q0I_Vc1_c2_Vb2_c1);
  x2_Vc1_c2_Vc1_c2=(+q0I_Vc1_c2_Vc1_c2*q0I+q0I_Vc1_c2*q0I_Vc1_c2+q0I_Vc1_c2*q0I_Vc1_c2+q0I*q0I_Vc1_c2_Vc1_c2);
#endif
#endif
x2=(q0I*q0I);
EXIT_IF_ISNAN((q0I*q0I))
if
((q0I<0.0))
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
q1I_Vdt_GND=(((0.5*eps2_Vdt_GND)*(d00_sqrt0-q0I)-(0.5*eps2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#endif
q1I_Vb2_e1=(-(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#if defined(_DERIVATE2)
  q1I_Vb2_e1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vdt_GND+0.0))-q0I_Vb2_e1_Vdt_GND))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_e1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_e1+0.0))-q0I_Vb2_e1_Vb2_e1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_e1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c2+0.0))-q0I_Vb2_e1_Vb2_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_e1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c1+0.0))-q0I_Vb2_e1_Vb2_c1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_e1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc1_c2+0.0))-q0I_Vb2_e1_Vc1_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#endif
q1I_Vb2_c2=(-(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#if defined(_DERIVATE2)
  q1I_Vb2_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))-q0I_Vb2_c2_Vdt_GND))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c2_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_e1+0.0))-q0I_Vb2_c2_Vb2_e1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))-q0I_Vb2_c2_Vb2_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))-q0I_Vb2_c2_Vb2_c1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))-q0I_Vb2_c2_Vc1_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#endif
q1I_Vb2_c1=(-(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#if defined(_DERIVATE2)
  q1I_Vb2_c1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))-q0I_Vb2_c1_Vdt_GND))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_e1+0.0))-q0I_Vb2_c1_Vb2_e1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))-q0I_Vb2_c1_Vb2_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))-q0I_Vb2_c1_Vb2_c1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vb2_c1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))-q0I_Vb2_c1_Vc1_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#endif
q1I_Vc1_c2=(-(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#if defined(_DERIVATE2)
  q1I_Vc1_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))-q0I_Vc1_c2_Vdt_GND))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0I_Vdt_GND)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vc1_c2_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_e1+0.0))-q0I_Vc1_c2_Vb2_e1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)*(x2_Vb2_e1*d10_sqrt0-q0I_Vb2_e1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vc1_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))-q0I_Vc1_c2_Vb2_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)*(x2_Vb2_c2*d10_sqrt0-q0I_Vb2_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vc1_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))-q0I_Vc1_c2_Vb2_c1))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)*(x2_Vb2_c1*d10_sqrt0-q0I_Vb2_c1)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
  q1I_Vc1_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0I)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))-q0I_Vc1_c2_Vc1_c2))/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)*(x2_Vc1_c2*d10_sqrt0-q0I_Vc1_c2)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I)/(d00_sqrt0-q0I));
#endif
#endif
q1I=((0.5*eps2)/(d00_sqrt0-q0I));
EXIT_IF_ISNAN(((0.5*eps2)/(d00_sqrt0-q0I)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
q1I_Vdt_GND=(0.5*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0I_Vdt_GND));
#endif
q1I_Vb2_e1=(0.5*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1));
#if defined(_DERIVATE2)
  q1I_Vb2_e1_Vdt_GND=(+0.0*(d00_sqrt0+q0I)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0I_Vdt_GND)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vdt_GND+0.0))+q0I_Vb2_e1_Vdt_GND));
  q1I_Vb2_e1_Vb2_e1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_e1+0.0))+q0I_Vb2_e1_Vb2_e1));
  q1I_Vb2_e1_Vb2_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c2+0.0))+q0I_Vb2_e1_Vb2_c2));
  q1I_Vb2_e1_Vb2_c1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c1+0.0))+q0I_Vb2_e1_Vb2_c1));
  q1I_Vb2_e1_Vc1_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc1_c2+0.0))+q0I_Vb2_e1_Vc1_c2));
#endif
q1I_Vb2_c2=(0.5*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2));
#if defined(_DERIVATE2)
  q1I_Vb2_c2_Vdt_GND=(+0.0*(d00_sqrt0+q0I)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0I_Vdt_GND)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))+q0I_Vb2_c2_Vdt_GND));
  q1I_Vb2_c2_Vb2_e1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_e1+0.0))+q0I_Vb2_c2_Vb2_e1));
  q1I_Vb2_c2_Vb2_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))+q0I_Vb2_c2_Vb2_c2));
  q1I_Vb2_c2_Vb2_c1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))+q0I_Vb2_c2_Vb2_c1));
  q1I_Vb2_c2_Vc1_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))+q0I_Vb2_c2_Vc1_c2));
#endif
q1I_Vb2_c1=(0.5*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1));
#if defined(_DERIVATE2)
  q1I_Vb2_c1_Vdt_GND=(+0.0*(d00_sqrt0+q0I)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0I_Vdt_GND)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))+q0I_Vb2_c1_Vdt_GND));
  q1I_Vb2_c1_Vb2_e1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_e1+0.0))+q0I_Vb2_c1_Vb2_e1));
  q1I_Vb2_c1_Vb2_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))+q0I_Vb2_c1_Vb2_c2));
  q1I_Vb2_c1_Vb2_c1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))+q0I_Vb2_c1_Vb2_c1));
  q1I_Vb2_c1_Vc1_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))+q0I_Vb2_c1_Vc1_c2));
#endif
q1I_Vc1_c2=(0.5*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2));
#if defined(_DERIVATE2)
  q1I_Vc1_c2_Vdt_GND=(+0.0*(d00_sqrt0+q0I)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0I_Vdt_GND)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))+q0I_Vc1_c2_Vdt_GND));
  q1I_Vc1_c2_Vb2_e1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_e1*d10_sqrt0+q0I_Vb2_e1)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_e1+0.0))+q0I_Vc1_c2_Vb2_e1));
  q1I_Vc1_c2_Vb2_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c2*d10_sqrt0+q0I_Vb2_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))+q0I_Vc1_c2_Vb2_c2));
  q1I_Vc1_c2_Vb2_c1=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vb2_c1*d10_sqrt0+q0I_Vb2_c1)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))+q0I_Vc1_c2_Vb2_c1));
  q1I_Vc1_c2_Vc1_c2=(+0.0*(d00_sqrt0+q0I)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+q0I_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))+q0I_Vc1_c2_Vc1_c2));
#endif
#endif
q1I=(0.5*(d00_sqrt0+q0I));
EXIT_IF_ISNAN((0.5*(d00_sqrt0+q0I)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
q1I_Vdt_GND=q1I_Vdt_GND;
#endif
q1I_Vb2_e1=q1I_Vb2_e1;
#if defined(_DERIVATE2)
  q1I_Vb2_e1_Vdt_GND=q1I_Vb2_e1_Vdt_GND;
  q1I_Vb2_e1_Vb2_e1=q1I_Vb2_e1_Vb2_e1;
  q1I_Vb2_e1_Vb2_c2=q1I_Vb2_e1_Vb2_c2;
  q1I_Vb2_e1_Vb2_c1=q1I_Vb2_e1_Vb2_c1;
  q1I_Vb2_e1_Vc1_c2=q1I_Vb2_e1_Vc1_c2;
#endif
q1I_Vb2_c2=q1I_Vb2_c2;
#if defined(_DERIVATE2)
  q1I_Vb2_c2_Vdt_GND=q1I_Vb2_c2_Vdt_GND;
  q1I_Vb2_c2_Vb2_e1=q1I_Vb2_c2_Vb2_e1;
  q1I_Vb2_c2_Vb2_c2=q1I_Vb2_c2_Vb2_c2;
  q1I_Vb2_c2_Vb2_c1=q1I_Vb2_c2_Vb2_c1;
  q1I_Vb2_c2_Vc1_c2=q1I_Vb2_c2_Vc1_c2;
#endif
q1I_Vb2_c1=q1I_Vb2_c1;
#if defined(_DERIVATE2)
  q1I_Vb2_c1_Vdt_GND=q1I_Vb2_c1_Vdt_GND;
  q1I_Vb2_c1_Vb2_e1=q1I_Vb2_c1_Vb2_e1;
  q1I_Vb2_c1_Vb2_c2=q1I_Vb2_c1_Vb2_c2;
  q1I_Vb2_c1_Vb2_c1=q1I_Vb2_c1_Vb2_c1;
  q1I_Vb2_c1_Vc1_c2=q1I_Vb2_c1_Vc1_c2;
#endif
q1I_Vc1_c2=q1I_Vc1_c2;
#if defined(_DERIVATE2)
  q1I_Vc1_c2_Vdt_GND=q1I_Vc1_c2_Vdt_GND;
  q1I_Vc1_c2_Vb2_e1=q1I_Vc1_c2_Vb2_e1;
  q1I_Vc1_c2_Vb2_c2=q1I_Vc1_c2_Vb2_c2;
  q1I_Vc1_c2_Vb2_c1=q1I_Vc1_c2_Vb2_c1;
  q1I_Vc1_c2_Vc1_c2=q1I_Vc1_c2_Vc1_c2;
#endif
#endif
q1I=q1I;
EXIT_IF_ISNAN(q1I)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
qBI_Vdt_GND=((q1I_Vdt_GND*(1.0+(0.5*(n0+nB))))+(q1I*(0.5*(n0_Vdt_GND+nB_Vdt_GND))));
#endif
qBI_Vb2_e1=((q1I_Vb2_e1*(1.0+(0.5*(n0+nB))))+(q1I*(0.5*n0_Vb2_e1)));
#if defined(_DERIVATE2)
  qBI_Vb2_e1_Vdt_GND=(+q1I_Vb2_e1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1I_Vb2_e1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1I_Vdt_GND*(0.5*n0_Vb2_e1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*n0_Vb2_e1+0.5*(+n0_Vb2_e1_Vdt_GND+0.0))));
  qBI_Vb2_e1_Vb2_e1=(+q1I_Vb2_e1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_e1*((0.5*n0_Vb2_e1))+q1I_Vb2_e1*(0.5*n0_Vb2_e1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*n0_Vb2_e1+0.5*(+n0_Vb2_e1_Vb2_e1+0.0))));
  qBI_Vb2_e1_Vb2_c2=(+q1I_Vb2_e1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_e1*((0.5*nB_Vb2_c2))+q1I_Vb2_c2*(0.5*n0_Vb2_e1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBI_Vb2_e1_Vb2_c1=(+q1I_Vb2_e1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_e1*((0.5*nB_Vb2_c1))+q1I_Vb2_c1*(0.5*n0_Vb2_e1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBI_Vb2_e1_Vc1_c2=(+q1I_Vb2_e1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_e1*((0.5*nB_Vc1_c2))+q1I_Vc1_c2*(0.5*n0_Vb2_e1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
#endif
qBI_Vb2_c2=((q1I_Vb2_c2*(1.0+(0.5*(n0+nB))))+(q1I*(0.5*nB_Vb2_c2)));
#if defined(_DERIVATE2)
  qBI_Vb2_c2_Vdt_GND=(+q1I_Vb2_c2_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c2*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1I_Vdt_GND*(0.5*nB_Vb2_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vdt_GND))));
  qBI_Vb2_c2_Vb2_e1=(+q1I_Vb2_c2_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c2*((0.5*n0_Vb2_e1))+q1I_Vb2_e1*(0.5*nB_Vb2_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBI_Vb2_c2_Vb2_c2=(+q1I_Vb2_c2_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c2*((0.5*nB_Vb2_c2))+q1I_Vb2_c2*(0.5*nB_Vb2_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vb2_c2))));
  qBI_Vb2_c2_Vb2_c1=(+q1I_Vb2_c2_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c2*((0.5*nB_Vb2_c1))+q1I_Vb2_c1*(0.5*nB_Vb2_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vb2_c1))));
  qBI_Vb2_c2_Vc1_c2=(+q1I_Vb2_c2_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c2*((0.5*nB_Vc1_c2))+q1I_Vc1_c2*(0.5*nB_Vb2_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vc1_c2))));
#endif
qBI_Vb2_c1=((q1I_Vb2_c1*(1.0+(0.5*(n0+nB))))+(q1I*(0.5*nB_Vb2_c1)));
#if defined(_DERIVATE2)
  qBI_Vb2_c1_Vdt_GND=(+q1I_Vb2_c1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1I_Vdt_GND*(0.5*nB_Vb2_c1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vdt_GND))));
  qBI_Vb2_c1_Vb2_e1=(+q1I_Vb2_c1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c1*((0.5*n0_Vb2_e1))+q1I_Vb2_e1*(0.5*nB_Vb2_c1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBI_Vb2_c1_Vb2_c2=(+q1I_Vb2_c1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c1*((0.5*nB_Vb2_c2))+q1I_Vb2_c2*(0.5*nB_Vb2_c1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vb2_c2))));
  qBI_Vb2_c1_Vb2_c1=(+q1I_Vb2_c1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c1*((0.5*nB_Vb2_c1))+q1I_Vb2_c1*(0.5*nB_Vb2_c1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vb2_c1))));
  qBI_Vb2_c1_Vc1_c2=(+q1I_Vb2_c1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1I_Vb2_c1*((0.5*nB_Vc1_c2))+q1I_Vc1_c2*(0.5*nB_Vb2_c1)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vc1_c2))));
#endif
qBI_Vc1_c2=((q1I_Vc1_c2*(1.0+(0.5*(n0+nB))))+(q1I*(0.5*nB_Vc1_c2)));
#if defined(_DERIVATE2)
  qBI_Vc1_c2_Vdt_GND=(+q1I_Vc1_c2_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1I_Vc1_c2*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1I_Vdt_GND*(0.5*nB_Vc1_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vdt_GND))));
  qBI_Vc1_c2_Vb2_e1=(+q1I_Vc1_c2_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1I_Vc1_c2*((0.5*n0_Vb2_e1))+q1I_Vb2_e1*(0.5*nB_Vc1_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBI_Vc1_c2_Vb2_c2=(+q1I_Vc1_c2_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1I_Vc1_c2*((0.5*nB_Vb2_c2))+q1I_Vb2_c2*(0.5*nB_Vc1_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vb2_c2))));
  qBI_Vc1_c2_Vb2_c1=(+q1I_Vc1_c2_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1I_Vc1_c2*((0.5*nB_Vb2_c1))+q1I_Vb2_c1*(0.5*nB_Vc1_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vb2_c1))));
  qBI_Vc1_c2_Vc1_c2=(+q1I_Vc1_c2_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1I_Vc1_c2*((0.5*nB_Vc1_c2))+q1I_Vc1_c2*(0.5*nB_Vc1_c2)+q1I*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vc1_c2))));
#endif
#endif
pInst->qBI=(q1I*(1.0+(0.5*(n0+nB))));
EXIT_IF_ISNAN((q1I*(1.0+(0.5*(n0+nB)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Ir_Vdt_GND=((IS_TM_Vdt_GND*eVb2c2star)+(IS_TM*eVb2c2star_Vdt_GND));
#endif
Ir_Vb2_c2=(IS_TM*eVb2c2star_Vb2_c2);
#if defined(_DERIVATE2)
  Ir_Vb2_c2_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+IS_TM_Vdt_GND*eVb2c2star_Vb2_c2+IS_TM*eVb2c2star_Vb2_c2_Vdt_GND);
  Ir_Vb2_c2_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c2+IS_TM*eVb2c2star_Vb2_c2_Vb2_c2);
  Ir_Vb2_c2_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c2+IS_TM*eVb2c2star_Vb2_c2_Vb2_c1);
  Ir_Vb2_c2_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c2+IS_TM*eVb2c2star_Vb2_c2_Vc1_c2);
#endif
Ir_Vb2_c1=(IS_TM*eVb2c2star_Vb2_c1);
#if defined(_DERIVATE2)
  Ir_Vb2_c1_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+IS_TM_Vdt_GND*eVb2c2star_Vb2_c1+IS_TM*eVb2c2star_Vb2_c1_Vdt_GND);
  Ir_Vb2_c1_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c1+IS_TM*eVb2c2star_Vb2_c1_Vb2_c2);
  Ir_Vb2_c1_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c1+IS_TM*eVb2c2star_Vb2_c1_Vb2_c1);
  Ir_Vb2_c1_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c1+IS_TM*eVb2c2star_Vb2_c1_Vc1_c2);
#endif
Ir_Vc1_c2=(IS_TM*eVb2c2star_Vc1_c2);
#if defined(_DERIVATE2)
  Ir_Vc1_c2_Vdt_GND=(+0.0*eVb2c2star+0.0*eVb2c2star_Vdt_GND+IS_TM_Vdt_GND*eVb2c2star_Vc1_c2+IS_TM*eVb2c2star_Vc1_c2_Vdt_GND);
  Ir_Vc1_c2_Vb2_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vc1_c2+IS_TM*eVb2c2star_Vc1_c2_Vb2_c2);
  Ir_Vc1_c2_Vb2_c1=(+0.0*eVb2c2star+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vc1_c2+IS_TM*eVb2c2star_Vc1_c2_Vb2_c1);
  Ir_Vc1_c2_Vc1_c2=(+0.0*eVb2c2star+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vc1_c2+IS_TM*eVb2c2star_Vc1_c2_Vc1_c2);
#endif
#endif
pInst->Ir=(IS_TM*eVb2c2star);
EXIT_IF_ISNAN((IS_TM*eVb2c2star))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
If_Vdt_GND=((IS_TM_Vdt_GND*eVb2e1)+(IS_TM*eVb2e1_Vdt_GND));
#endif
If_Vb2_e1=(IS_TM*eVb2e1_Vb2_e1);
#if defined(_DERIVATE2)
  If_Vb2_e1_Vdt_GND=(+0.0*eVb2e1+0.0*eVb2e1_Vdt_GND+IS_TM_Vdt_GND*eVb2e1_Vb2_e1+IS_TM*eVb2e1_Vb2_e1_Vdt_GND);
  If_Vb2_e1_Vb2_e1=(+0.0*eVb2e1+0.0*eVb2e1_Vb2_e1+0.0*eVb2e1_Vb2_e1+IS_TM*eVb2e1_Vb2_e1_Vb2_e1);
#endif
#endif
pInst->If=(IS_TM*eVb2e1);
EXIT_IF_ISNAN((IS_TM*eVb2e1))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
In_Vdt_GND=(((If_Vdt_GND-Ir_Vdt_GND)*pInst->qBI-(pInst->If-pInst->Ir)*qBI_Vdt_GND)/pInst->qBI/pInst->qBI);
#endif
In_Vb2_e1=((If_Vb2_e1*pInst->qBI-(pInst->If-pInst->Ir)*qBI_Vb2_e1)/pInst->qBI/pInst->qBI);
#if defined(_DERIVATE2)
  In_Vb2_e1_Vdt_GND=((+If_Vb2_e1_Vdt_GND-0.0)/pInst->qBI-(If_Vb2_e1*qBI_Vdt_GND+(If_Vdt_GND-Ir_Vdt_GND)*qBI_Vb2_e1+(pInst->If-pInst->Ir)*qBI_Vb2_e1_Vdt_GND)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_e1*qBI_Vdt_GND/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_e1_Vb2_e1=((+If_Vb2_e1_Vb2_e1-0.0)/pInst->qBI-(If_Vb2_e1*qBI_Vb2_e1+If_Vb2_e1*qBI_Vb2_e1+(pInst->If-pInst->Ir)*qBI_Vb2_e1_Vb2_e1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_e1*qBI_Vb2_e1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_e1_Vb2_c2=((+0.0-0.0)/pInst->qBI-(If_Vb2_e1*qBI_Vb2_c2+(-Ir_Vb2_c2)*qBI_Vb2_e1+(pInst->If-pInst->Ir)*qBI_Vb2_e1_Vb2_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_e1*qBI_Vb2_c2/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_e1_Vb2_c1=((+0.0-0.0)/pInst->qBI-(If_Vb2_e1*qBI_Vb2_c1+(-Ir_Vb2_c1)*qBI_Vb2_e1+(pInst->If-pInst->Ir)*qBI_Vb2_e1_Vb2_c1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_e1*qBI_Vb2_c1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_e1_Vc1_c2=((+0.0-0.0)/pInst->qBI-(If_Vb2_e1*qBI_Vc1_c2+(-Ir_Vc1_c2)*qBI_Vb2_e1+(pInst->If-pInst->Ir)*qBI_Vb2_e1_Vc1_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_e1*qBI_Vc1_c2/pInst->qBI/pInst->qBI/pInst->qBI);
#endif
In_Vb2_c2=(((-Ir_Vb2_c2)*pInst->qBI-(pInst->If-pInst->Ir)*qBI_Vb2_c2)/pInst->qBI/pInst->qBI);
#if defined(_DERIVATE2)
  In_Vb2_c2_Vdt_GND=((+0.0-Ir_Vb2_c2_Vdt_GND)/pInst->qBI-((-Ir_Vb2_c2)*qBI_Vdt_GND+(If_Vdt_GND-Ir_Vdt_GND)*qBI_Vb2_c2+(pInst->If-pInst->Ir)*qBI_Vb2_c2_Vdt_GND)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c2*qBI_Vdt_GND/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c2_Vb2_e1=((+0.0-0.0)/pInst->qBI-((-Ir_Vb2_c2)*qBI_Vb2_e1+If_Vb2_e1*qBI_Vb2_c2+(pInst->If-pInst->Ir)*qBI_Vb2_c2_Vb2_e1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c2*qBI_Vb2_e1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c2_Vb2_c2=((+0.0-Ir_Vb2_c2_Vb2_c2)/pInst->qBI-((-Ir_Vb2_c2)*qBI_Vb2_c2+(-Ir_Vb2_c2)*qBI_Vb2_c2+(pInst->If-pInst->Ir)*qBI_Vb2_c2_Vb2_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c2*qBI_Vb2_c2/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c2_Vb2_c1=((+0.0-Ir_Vb2_c2_Vb2_c1)/pInst->qBI-((-Ir_Vb2_c2)*qBI_Vb2_c1+(-Ir_Vb2_c1)*qBI_Vb2_c2+(pInst->If-pInst->Ir)*qBI_Vb2_c2_Vb2_c1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c2*qBI_Vb2_c1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c2_Vc1_c2=((+0.0-Ir_Vb2_c2_Vc1_c2)/pInst->qBI-((-Ir_Vb2_c2)*qBI_Vc1_c2+(-Ir_Vc1_c2)*qBI_Vb2_c2+(pInst->If-pInst->Ir)*qBI_Vb2_c2_Vc1_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c2*qBI_Vc1_c2/pInst->qBI/pInst->qBI/pInst->qBI);
#endif
In_Vb2_c1=(((-Ir_Vb2_c1)*pInst->qBI-(pInst->If-pInst->Ir)*qBI_Vb2_c1)/pInst->qBI/pInst->qBI);
#if defined(_DERIVATE2)
  In_Vb2_c1_Vdt_GND=((+0.0-Ir_Vb2_c1_Vdt_GND)/pInst->qBI-((-Ir_Vb2_c1)*qBI_Vdt_GND+(If_Vdt_GND-Ir_Vdt_GND)*qBI_Vb2_c1+(pInst->If-pInst->Ir)*qBI_Vb2_c1_Vdt_GND)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c1*qBI_Vdt_GND/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c1_Vb2_e1=((+0.0-0.0)/pInst->qBI-((-Ir_Vb2_c1)*qBI_Vb2_e1+If_Vb2_e1*qBI_Vb2_c1+(pInst->If-pInst->Ir)*qBI_Vb2_c1_Vb2_e1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c1*qBI_Vb2_e1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c1_Vb2_c2=((+0.0-Ir_Vb2_c1_Vb2_c2)/pInst->qBI-((-Ir_Vb2_c1)*qBI_Vb2_c2+(-Ir_Vb2_c2)*qBI_Vb2_c1+(pInst->If-pInst->Ir)*qBI_Vb2_c1_Vb2_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c1*qBI_Vb2_c2/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c1_Vb2_c1=((+0.0-Ir_Vb2_c1_Vb2_c1)/pInst->qBI-((-Ir_Vb2_c1)*qBI_Vb2_c1+(-Ir_Vb2_c1)*qBI_Vb2_c1+(pInst->If-pInst->Ir)*qBI_Vb2_c1_Vb2_c1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c1*qBI_Vb2_c1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vb2_c1_Vc1_c2=((+0.0-Ir_Vb2_c1_Vc1_c2)/pInst->qBI-((-Ir_Vb2_c1)*qBI_Vc1_c2+(-Ir_Vc1_c2)*qBI_Vb2_c1+(pInst->If-pInst->Ir)*qBI_Vb2_c1_Vc1_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vb2_c1*qBI_Vc1_c2/pInst->qBI/pInst->qBI/pInst->qBI);
#endif
In_Vc1_c2=(((-Ir_Vc1_c2)*pInst->qBI-(pInst->If-pInst->Ir)*qBI_Vc1_c2)/pInst->qBI/pInst->qBI);
#if defined(_DERIVATE2)
  In_Vc1_c2_Vdt_GND=((+0.0-Ir_Vc1_c2_Vdt_GND)/pInst->qBI-((-Ir_Vc1_c2)*qBI_Vdt_GND+(If_Vdt_GND-Ir_Vdt_GND)*qBI_Vc1_c2+(pInst->If-pInst->Ir)*qBI_Vc1_c2_Vdt_GND)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vc1_c2*qBI_Vdt_GND/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vc1_c2_Vb2_e1=((+0.0-0.0)/pInst->qBI-((-Ir_Vc1_c2)*qBI_Vb2_e1+If_Vb2_e1*qBI_Vc1_c2+(pInst->If-pInst->Ir)*qBI_Vc1_c2_Vb2_e1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vc1_c2*qBI_Vb2_e1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vc1_c2_Vb2_c2=((+0.0-Ir_Vc1_c2_Vb2_c2)/pInst->qBI-((-Ir_Vc1_c2)*qBI_Vb2_c2+(-Ir_Vb2_c2)*qBI_Vc1_c2+(pInst->If-pInst->Ir)*qBI_Vc1_c2_Vb2_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vc1_c2*qBI_Vb2_c2/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vc1_c2_Vb2_c1=((+0.0-Ir_Vc1_c2_Vb2_c1)/pInst->qBI-((-Ir_Vc1_c2)*qBI_Vb2_c1+(-Ir_Vb2_c1)*qBI_Vc1_c2+(pInst->If-pInst->Ir)*qBI_Vc1_c2_Vb2_c1)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vc1_c2*qBI_Vb2_c1/pInst->qBI/pInst->qBI/pInst->qBI);
  In_Vc1_c2_Vc1_c2=((+0.0-Ir_Vc1_c2_Vc1_c2)/pInst->qBI-((-Ir_Vc1_c2)*qBI_Vc1_c2+(-Ir_Vc1_c2)*qBI_Vc1_c2+(pInst->If-pInst->Ir)*qBI_Vc1_c2_Vc1_c2)/pInst->qBI/pInst->qBI+2*(pInst->If-pInst->Ir)*qBI_Vc1_c2*qBI_Vc1_c2/pInst->qBI/pInst->qBI/pInst->qBI);
#endif
#endif
In=((pInst->If-pInst->Ir)/pInst->qBI);
EXIT_IF_ISNAN(((pInst->If-pInst->Ir)/pInst->qBI))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c2,GND)V(c1,GND)V(e1,GND) */
Ibf0_Vdt_GND=((IS_TM_Vdt_GND*BF_T-IS_TM*BF_T_Vdt_GND)/BF_T/BF_T);
#endif
Ibf0=(IS_TM/BF_T);
EXIT_IF_ISNAN((IS_TM/BF_T))
if
((pModel->XREC==0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
Ib1_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Ib1_Vb2_c2_Vb2_c2=0.0;
  Ib1_Vb2_c2_Vb2_c1=0.0;
  Ib1_Vb2_c2_Vc1_c2=0.0;
  Ib1_Vb2_c2_Vdt_GND=0.0;
  Ib1_Vb2_c2_Vb2_e1=0.0;
#endif
Ib1_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Ib1_Vb2_c1_Vb2_c2=0.0;
  Ib1_Vb2_c1_Vb2_c1=0.0;
  Ib1_Vb2_c1_Vc1_c2=0.0;
  Ib1_Vb2_c1_Vdt_GND=0.0;
  Ib1_Vb2_c1_Vb2_e1=0.0;
#endif
Ib1_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Ib1_Vc1_c2_Vb2_c2=0.0;
  Ib1_Vc1_c2_Vb2_c1=0.0;
  Ib1_Vc1_c2_Vc1_c2=0.0;
  Ib1_Vc1_c2_Vdt_GND=0.0;
  Ib1_Vc1_c2_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
Ib1_Vdt_GND=((((1.0-pModel->XIBI)*Ibf0_Vdt_GND)*(eVb2e1-1.0))+(((1.0-pModel->XIBI)*Ibf0)*eVb2e1_Vdt_GND));
#endif
Ib1_Vb2_e1=(((1.0-pModel->XIBI)*Ibf0)*eVb2e1_Vb2_e1);
#if defined(_DERIVATE2)
  Ib1_Vb2_e1_Vb2_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(eVb2e1-1.0)+0.0*0.0+(0.0)*eVb2e1_Vb2_e1+((1.0-pModel->XIBI)*Ibf0)*(+0.0-0.0));
  Ib1_Vb2_e1_Vb2_c1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(eVb2e1-1.0)+0.0*0.0+(0.0)*eVb2e1_Vb2_e1+((1.0-pModel->XIBI)*Ibf0)*(+0.0-0.0));
  Ib1_Vb2_e1_Vc1_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(eVb2e1-1.0)+0.0*0.0+(0.0)*eVb2e1_Vb2_e1+((1.0-pModel->XIBI)*Ibf0)*(+0.0-0.0));
  Ib1_Vb2_e1_Vdt_GND=(+(+(+0.0-0.0)*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vdt_GND+(((1.0-pModel->XIBI)*Ibf0_Vdt_GND))*eVb2e1_Vb2_e1+((1.0-pModel->XIBI)*Ibf0)*(+eVb2e1_Vb2_e1_Vdt_GND-0.0));
  Ib1_Vb2_e1_Vb2_e1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vb2_e1+(0.0)*eVb2e1_Vb2_e1+((1.0-pModel->XIBI)*Ibf0)*(+eVb2e1_Vb2_e1_Vb2_e1-0.0));
#endif
#endif
pInst->Ib1=(((1.0-pModel->XIBI)*Ibf0)*(eVb2e1-1.0));
EXIT_IF_ISNAN((((1.0-pModel->XIBI)*Ibf0)*(eVb2e1-1.0)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
Ib1_Vb2_c2=(((1.0-pModel->XIBI)*Ibf0)*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T))));
#if defined(_DERIVATE2)
  Ib1_Vb2_c2_Vb2_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c2_Vb2_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c2)*(Vtc_Vb2_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c2))*(Vtc_Vb2_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c2_Vb2_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c2_Vb2_c1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c2_Vb2_c1)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c2)*(Vtc_Vb2_c1/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c1))*(Vtc_Vb2_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c2_Vb2_c1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c2_Vc1_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vc1_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c2_Vc1_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c2)*(Vtc_Vc1_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vc1_c2))*(Vtc_Vb2_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c2_Vc1_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c2_Vdt_GND=(+(+(+0.0-0.0)*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vdt_GND))+(((((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)))))+(((1.0-pModel->XIBI)*Ibf0_Vdt_GND))*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vdt_GND+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)+0.0*eVb2c2star_Vb2_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c2_Vdt_GND)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c2)*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)+((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(Vtc_Vb2_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c2_Vdt_GND/VEF_T-(Vtc_Vb2_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c2_Vb2_e1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vb2_e1))+(((((pModel->XREC*eVb2e1_Vb2_e1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vb2_e1+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2e1_Vb2_e1+0.0*eVb2c2star_Vb2_c2+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c2)*(Vtc_Vb2_e1/VEF_T)+((pModel->XREC*eVb2e1_Vb2_e1))*(Vtc_Vb2_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c2_Vb2_e1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
#endif
Ib1_Vb2_c1=(((1.0-pModel->XIBI)*Ibf0)*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T))));
#if defined(_DERIVATE2)
  Ib1_Vb2_c1_Vb2_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vb2_c1+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c1_Vb2_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c1)*(Vtc_Vb2_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c2))*(Vtc_Vb2_c1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c1_Vb2_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c1_Vb2_c1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vb2_c1+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c1_Vb2_c1)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c1)*(Vtc_Vb2_c1/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c1))*(Vtc_Vb2_c1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c1_Vb2_c1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c1_Vc1_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vc1_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vb2_c1+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c1_Vc1_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c1)*(Vtc_Vc1_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vc1_c2))*(Vtc_Vb2_c1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c1_Vc1_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c1_Vdt_GND=(+(+(+0.0-0.0)*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vdt_GND))+(((((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)))))+(((1.0-pModel->XIBI)*Ibf0_Vdt_GND))*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vdt_GND+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)+0.0*eVb2c2star_Vb2_c1+pModel->XREC*(+(+0.0+eVb2c2star_Vb2_c1_Vdt_GND)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c1)*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)+((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(Vtc_Vb2_c1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c1_Vdt_GND/VEF_T-(Vtc_Vb2_c1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_c1_Vb2_e1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vb2_e1))+(((((pModel->XREC*eVb2e1_Vb2_e1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vb2_c1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vb2_e1+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2e1_Vb2_e1+0.0*eVb2c2star_Vb2_c1+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vb2_c1)*(Vtc_Vb2_e1/VEF_T)+((pModel->XREC*eVb2e1_Vb2_e1))*(Vtc_Vb2_c1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_c1_Vb2_e1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
#endif
Ib1_Vc1_c2=(((1.0-pModel->XIBI)*Ibf0)*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T))));
#if defined(_DERIVATE2)
  Ib1_Vc1_c2_Vb2_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c2+0.0*eVb2c2star_Vc1_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vc1_c2_Vb2_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vc1_c2)*(Vtc_Vb2_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c2))*(Vtc_Vc1_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vc1_c2_Vb2_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vc1_c2_Vb2_c1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c1+0.0*eVb2c2star_Vc1_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vc1_c2_Vb2_c1)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vc1_c2)*(Vtc_Vb2_c1/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c1))*(Vtc_Vc1_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vc1_c2_Vb2_c1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vc1_c2_Vc1_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vc1_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vc1_c2+0.0*eVb2c2star_Vc1_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vc1_c2_Vc1_c2)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vc1_c2)*(Vtc_Vc1_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vc1_c2))*(Vtc_Vc1_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vc1_c2_Vc1_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vc1_c2_Vdt_GND=(+(+(+0.0-0.0)*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vdt_GND))+(((((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)))))+(((1.0-pModel->XIBI)*Ibf0_Vdt_GND))*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vdt_GND+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)+0.0*eVb2c2star_Vc1_c2+pModel->XREC*(+(+0.0+eVb2c2star_Vc1_c2_Vdt_GND)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vc1_c2)*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)+((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(Vtc_Vc1_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vc1_c2_Vdt_GND/VEF_T-(Vtc_Vc1_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vc1_c2_Vb2_e1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vb2_e1))+(((((pModel->XREC*eVb2e1_Vb2_e1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T)))))+(0.0)*(((pModel->XREC*eVb2c2star_Vc1_c2)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vb2_e1+0.0*0.0+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2e1_Vb2_e1+0.0*eVb2c2star_Vc1_c2+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2c2star_Vc1_c2)*(Vtc_Vb2_e1/VEF_T)+((pModel->XREC*eVb2e1_Vb2_e1))*(Vtc_Vc1_c2/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vc1_c2_Vb2_e1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
#endif
#if defined(_DERIVATE)
Ib1_Vdt_GND=((((1.0-pModel->XIBI)*Ibf0_Vdt_GND)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))))+(((1.0-pModel->XIBI)*Ibf0)*(((1.0-pModel->XREC)*eVb2e1_Vdt_GND)+(((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T))))));
#endif
Ib1_Vb2_e1=(((1.0-pModel->XIBI)*Ibf0)*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T)))));
#if defined(_DERIVATE2)
  Ib1_Vb2_e1_Vb2_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c2/VEF_T)))))+(0.0)*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T))))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*eVb2e1_Vb2_e1+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c2+0.0*eVb2e1_Vb2_e1+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2e1_Vb2_e1)*(Vtc_Vb2_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c2))*(Vtc_Vb2_e1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_e1_Vb2_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_e1_Vb2_c1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vb2_c1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_c1/VEF_T)))))+(0.0)*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T))))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*eVb2e1_Vb2_e1+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vb2_c1+0.0*eVb2e1_Vb2_e1+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2e1_Vb2_e1)*(Vtc_Vb2_c1/VEF_T)+((pModel->XREC*eVb2c2star_Vb2_c1))*(Vtc_Vb2_e1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_e1_Vb2_c1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_e1_Vc1_c2=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((0.0)+(((((pModel->XREC*eVb2c2star_Vc1_c2))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vc1_c2/VEF_T)))))+(0.0)*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T))))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*0.0+0.0*eVb2e1_Vb2_e1+(1.0-pModel->XREC)*(+0.0-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2c2star_Vc1_c2+0.0*eVb2e1_Vb2_e1+pModel->XREC*(+(+0.0+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2e1_Vb2_e1)*(Vtc_Vc1_c2/VEF_T)+((pModel->XREC*eVb2c2star_Vc1_c2))*(Vtc_Vb2_e1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_e1_Vc1_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_e1_Vdt_GND=(+(+(+0.0-0.0)*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vdt_GND))+(((((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)))))+(((1.0-pModel->XIBI)*Ibf0_Vdt_GND))*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T))))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vdt_GND+0.0*eVb2e1_Vb2_e1+(1.0-pModel->XREC)*(+eVb2e1_Vb2_e1_Vdt_GND-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)+0.0*eVb2e1_Vb2_e1+pModel->XREC*(+(+eVb2e1_Vb2_e1_Vdt_GND+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2e1_Vb2_e1)*((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T)+((pModel->XREC*(eVb2e1_Vdt_GND+eVb2c2star_Vdt_GND)))*(Vtc_Vb2_e1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_e1_Vdt_GND/VEF_T-(Vtc_Vb2_e1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T)))));
  Ib1_Vb2_e1_Vb2_e1=(+(+(+0.0-0.0)*Ibf0+0.0*0.0+0.0*0.0+(1.0-pModel->XIBI)*0.0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))+0.0*((((1.0-pModel->XREC)*eVb2e1_Vb2_e1))+(((((pModel->XREC*eVb2e1_Vb2_e1))*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T)))))+(0.0)*(((1.0-pModel->XREC)*eVb2e1_Vb2_e1)+(((pModel->XREC*eVb2e1_Vb2_e1)*(1.0+(Vtc/VEF_T)))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(Vtc_Vb2_e1/VEF_T))))+((1.0-pModel->XIBI)*Ibf0)*(+(+(+0.0-0.0)*(eVb2e1-1.0)+0.0*eVb2e1_Vb2_e1+0.0*eVb2e1_Vb2_e1+(1.0-pModel->XREC)*(+eVb2e1_Vb2_e1_Vb2_e1-0.0))+(+(+0.0*((eVb2e1+eVb2c2star)-2.0)+0.0*eVb2e1_Vb2_e1+0.0*eVb2e1_Vb2_e1+pModel->XREC*(+(+eVb2e1_Vb2_e1_Vb2_e1+0.0)-0.0))*(1.0+(Vtc/VEF_T))+(pModel->XREC*eVb2e1_Vb2_e1)*(Vtc_Vb2_e1/VEF_T)+((pModel->XREC*eVb2e1_Vb2_e1))*(Vtc_Vb2_e1/VEF_T)+(pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(+0.0+(Vtc_Vb2_e1_Vb2_e1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T)))));
#endif
#endif
pInst->Ib1=(((1.0-pModel->XIBI)*Ibf0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T)))));
EXIT_IF_ISNAN((((1.0-pModel->XIBI)*Ibf0)*(((1.0-pModel->XREC)*(eVb2e1-1.0))+((pModel->XREC*((eVb2e1+eVb2c2star)-2.0))*(1.0+(Vtc/VEF_T))))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,e1) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Ib1_s_Vdt_GND=(((pModel->XIBI*Ibf0_Vdt_GND)*(eVb1e1-1.0))+((pModel->XIBI*Ibf0)*eVb1e1_Vdt_GND));
#endif
Ib1_s_Vb1_e1=((pModel->XIBI*Ibf0)*eVb1e1_Vb1_e1);
#if defined(_DERIVATE2)
  Ib1_s_Vb1_e1_Vdt_GND=(+(+0.0*Ibf0+0.0*Ibf0_Vdt_GND+0.0*0.0+pModel->XIBI*0.0)*(eVb1e1-1.0)+0.0*eVb1e1_Vdt_GND+((pModel->XIBI*Ibf0_Vdt_GND))*eVb1e1_Vb1_e1+(pModel->XIBI*Ibf0)*(+eVb1e1_Vb1_e1_Vdt_GND-0.0));
  Ib1_s_Vb1_e1_Vb1_e1=(+(+0.0*Ibf0+0.0*0.0+0.0*0.0+pModel->XIBI*0.0)*(eVb1e1-1.0)+0.0*eVb1e1_Vb1_e1+(0.0)*eVb1e1_Vb1_e1+(pModel->XIBI*Ibf0)*(+eVb1e1_Vb1_e1_Vb1_e1-0.0));
#endif
#endif
pInst->Ib1_s=((pModel->XIBI*Ibf0)*(eVb1e1-1.0));
EXIT_IF_ISNAN(((pModel->XIBI*Ibf0)*(eVb1e1-1.0)))
if
((((Vb2e1*VtINV)/pModel->MLF)<400.0))
{
{
double m00_exp(d00_exp0,((Vb2e1*VtINV)/pModel->MLF))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=0.0;
  tmpExp_Vb1_b2_Vb2_c2=0.0;
  tmpExp_Vb1_b2_Vc1_c2=0.0;
  tmpExp_Vb1_b2_Vc4_c1=0.0;
  tmpExp_Vb1_b2_Vb2_e1=0.0;
  tmpExp_Vb1_b2_Vdt_GND=0.0;
#endif
tmpExp_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=0.0;
  tmpExp_Vb2_c2_Vb2_c2=0.0;
  tmpExp_Vb2_c2_Vc1_c2=0.0;
  tmpExp_Vb2_c2_Vc4_c1=0.0;
  tmpExp_Vb2_c2_Vb2_e1=0.0;
  tmpExp_Vb2_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=0.0;
  tmpExp_Vc1_c2_Vb2_c2=0.0;
  tmpExp_Vc1_c2_Vc1_c2=0.0;
  tmpExp_Vc1_c2_Vc4_c1=0.0;
  tmpExp_Vc1_c2_Vb2_e1=0.0;
  tmpExp_Vc1_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=0.0;
  tmpExp_Vc4_c1_Vb2_c2=0.0;
  tmpExp_Vc4_c1_Vc1_c2=0.0;
  tmpExp_Vc4_c1_Vc4_c1=0.0;
  tmpExp_Vc4_c1_Vb2_e1=0.0;
  tmpExp_Vc4_c1_Vdt_GND=0.0;
#endif
tmpExp_Vb2_e1=(Vb2e1_Vb2_e1*VtINV/pModel->MLF)*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*((0.0)/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
  tmpExp_Vb2_e1_Vb2_c2=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*((0.0)/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
  tmpExp_Vb2_e1_Vc1_c2=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*((0.0)/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
  tmpExp_Vb2_e1_Vc4_c1=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*((0.0)/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
  tmpExp_Vb2_e1_Vb2_e1=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*((Vb2e1_Vb2_e1*VtINV)/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+Vb2e1_Vb2_e1_Vb2_e1*VtINV+Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(Vb2e1_Vb2_e1*VtINV)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
  tmpExp_Vb2_e1_Vdt_GND=(m20_exp(((Vb2e1*VtINV)/pModel->MLF))*(((Vb2e1*VtINV_Vdt_GND))/pModel->MLF)*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+d10_exp0*((+0.0*VtINV+Vb2e1_Vb2_e1*VtINV_Vdt_GND+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+((Vb2e1*VtINV_Vdt_GND))*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF));
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=((Vb2e1*VtINV_Vdt_GND)/pModel->MLF)*d10_exp0;
#endif
#endif
tmpExp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=0.0;
  tmpExp_Vb1_b2_Vb2_c2=0.0;
  tmpExp_Vb1_b2_Vc1_c2=0.0;
  tmpExp_Vb1_b2_Vc4_c1=0.0;
  tmpExp_Vb1_b2_Vb2_e1=0.0;
  tmpExp_Vb1_b2_Vdt_GND=0.0;
#endif
tmpExp_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=0.0;
  tmpExp_Vb2_c2_Vb2_c2=0.0;
  tmpExp_Vb2_c2_Vc1_c2=0.0;
  tmpExp_Vb2_c2_Vc4_c1=0.0;
  tmpExp_Vb2_c2_Vb2_e1=0.0;
  tmpExp_Vb2_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=0.0;
  tmpExp_Vc1_c2_Vb2_c2=0.0;
  tmpExp_Vc1_c2_Vc1_c2=0.0;
  tmpExp_Vc1_c2_Vc4_c1=0.0;
  tmpExp_Vc1_c2_Vb2_e1=0.0;
  tmpExp_Vc1_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=0.0;
  tmpExp_Vc4_c1_Vb2_c2=0.0;
  tmpExp_Vc4_c1_Vc1_c2=0.0;
  tmpExp_Vc4_c1_Vc4_c1=0.0;
  tmpExp_Vc4_c1_Vb2_e1=0.0;
  tmpExp_Vc4_c1_Vdt_GND=0.0;
#endif
tmpExp_Vb2_e1=(expl*(Vb2e1_Vb2_e1*VtINV/pModel->MLF));
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*((0.0)/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
  tmpExp_Vb2_e1_Vb2_c2=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*((0.0)/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
  tmpExp_Vb2_e1_Vc1_c2=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*((0.0)/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
  tmpExp_Vb2_e1_Vc4_c1=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*((0.0)/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+0.0*VtINV+Vb2e1_Vb2_e1*0.0+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(0.0)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
  tmpExp_Vb2_e1_Vb2_e1=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*((Vb2e1_Vb2_e1*VtINV)/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+Vb2e1_Vb2_e1_Vb2_e1*VtINV+Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+(Vb2e1_Vb2_e1*VtINV)*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
  tmpExp_Vb2_e1_Vdt_GND=(+0.0*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))+0.0*(((Vb2e1*VtINV_Vdt_GND))/pModel->MLF)+0.0*(Vb2e1_Vb2_e1*VtINV/pModel->MLF)+expl*(+0.0+(+((+0.0*VtINV+Vb2e1_Vb2_e1*VtINV_Vdt_GND+0.0*0.0+Vb2e1*0.0)/pModel->MLF-(Vb2e1_Vb2_e1*VtINV*0.0+((Vb2e1*VtINV_Vdt_GND))*0.0+(Vb2e1*VtINV)*0.0)/pModel->MLF/pModel->MLF+2*(Vb2e1*VtINV)*0.0*0.0/pModel->MLF/pModel->MLF/pModel->MLF)-0.0)));
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=(expl*((Vb2e1*VtINV_Vdt_GND)/pModel->MLF));
#endif
#endif
tmpExp=(expl*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((Vb2e1*VtINV)/pModel->MLF)-400.0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Ib2_Vdt_GND=((IBF_TM_Vdt_GND*(tmpExp-1.0))+(IBF_TM*tmpExp_Vdt_GND));
#endif
Ib2_Vb2_e1=((IBF_TM*tmpExp_Vb2_e1)+(my_gmin*Vb2e1_Vb2_e1));
#if defined(_DERIVATE2)
  Ib2_Vb2_e1_Vdt_GND=(+(+0.0*(tmpExp-1.0)+0.0*tmpExp_Vdt_GND+IBF_TM_Vdt_GND*tmpExp_Vb2_e1+IBF_TM*(+tmpExp_Vb2_e1_Vdt_GND-0.0))+(+0.0*Vb2e1+0.0*0.0+0.0*Vb2e1_Vb2_e1+my_gmin*0.0));
  Ib2_Vb2_e1_Vb2_e1=(+(+0.0*(tmpExp-1.0)+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vb2_e1+IBF_TM*(+tmpExp_Vb2_e1_Vb2_e1-0.0))+(+0.0*Vb2e1+0.0*Vb2e1_Vb2_e1+0.0*Vb2e1_Vb2_e1+my_gmin*Vb2e1_Vb2_e1_Vb2_e1));
#endif
#endif
pInst->Ib2=((IBF_TM*(tmpExp-1.0))+(my_gmin*Vb2e1));
EXIT_IF_ISNAN(((IBF_TM*(tmpExp-1.0))+(my_gmin*Vb2e1)))
if
((((0.5*Vb1c4)*VtINV)<400.0))
{
{
double m00_exp(d00_exp0,((0.5*Vb1c4)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=(0.5*Vb1c4_Vb1_b2)*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb1_b2))*VtINV)*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb1_b2_Vb2_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb2_c2))*VtINV)*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb1_b2_Vc1_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc1_c2))*VtINV)*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb1_b2_Vc4_c1=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc4_c1))*VtINV)*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb1_b2_Vb2_e1=(m20_exp(((0.5*Vb1c4)*VtINV))*((0.0)*VtINV)*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb1_b2_Vdt_GND=(m20_exp(((0.5*Vb1c4)*VtINV))*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))*(0.5*Vb1c4_Vb1_b2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb1_b2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0));
#endif
tmpExp_Vb2_c2=(0.5*Vb1c4_Vb2_c2)*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb1_b2))*VtINV)*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb2_c2_Vb2_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb2_c2))*VtINV)*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb2_c2_Vc1_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc1_c2))*VtINV)*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb2_c2_Vc4_c1=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc4_c1))*VtINV)*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb2_c2_Vb2_e1=(m20_exp(((0.5*Vb1c4)*VtINV))*((0.0)*VtINV)*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vb2_c2_Vdt_GND=(m20_exp(((0.5*Vb1c4)*VtINV))*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))*(0.5*Vb1c4_Vb2_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb2_c2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0));
#endif
tmpExp_Vc1_c2=(0.5*Vb1c4_Vc1_c2)*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb1_b2))*VtINV)*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc1_c2_Vb2_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb2_c2))*VtINV)*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc1_c2_Vc1_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc1_c2))*VtINV)*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc1_c2_Vc4_c1=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc4_c1))*VtINV)*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc1_c2_Vb2_e1=(m20_exp(((0.5*Vb1c4)*VtINV))*((0.0)*VtINV)*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc1_c2_Vdt_GND=(m20_exp(((0.5*Vb1c4)*VtINV))*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))*(0.5*Vb1c4_Vc1_c2)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc1_c2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0));
#endif
tmpExp_Vc4_c1=(0.5*Vb1c4_Vc4_c1)*VtINV*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb1_b2))*VtINV)*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vb1_b2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc4_c1_Vb2_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vb2_c2))*VtINV)*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vb2_c2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc4_c1_Vc1_c2=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc1_c2))*VtINV)*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vc1_c2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc4_c1_Vc4_c1=(m20_exp(((0.5*Vb1c4)*VtINV))*(((0.5*Vb1c4_Vc4_c1))*VtINV)*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vc4_c1)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc4_c1_Vb2_e1=(m20_exp(((0.5*Vb1c4)*VtINV))*((0.0)*VtINV)*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc4_c1+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0));
  tmpExp_Vc4_c1_Vdt_GND=(m20_exp(((0.5*Vb1c4)*VtINV))*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))*(0.5*Vb1c4_Vc4_c1)*VtINV+d10_exp0*(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc4_c1+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc4_c1)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0));
#endif
tmpExp_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=0.0;
  tmpExp_Vb2_e1_Vb2_c2=0.0;
  tmpExp_Vb2_e1_Vc1_c2=0.0;
  tmpExp_Vb2_e1_Vc4_c1=0.0;
  tmpExp_Vb2_e1_Vb2_e1=0.0;
  tmpExp_Vb2_e1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=((0.5*Vb1c4)*VtINV_Vdt_GND)*d10_exp0;
#endif
#endif
tmpExp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=(expl*(0.5*Vb1c4_Vb1_b2)*VtINV);
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb1_b2))*VtINV)+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb1_b2_Vb2_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb2_c2))*VtINV)+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb1_b2_Vc1_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc1_c2))*VtINV)+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb1_b2_Vc4_c1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc4_c1))*VtINV)+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb1_b2+0.5*Vb1c4_Vb1_b2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb1_b2_Vb2_e1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((0.0)*VtINV)+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb1_b2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb1_b2_Vdt_GND=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))+0.0*(0.5*Vb1c4_Vb1_b2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb1_b2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
#endif
tmpExp_Vb2_c2=(expl*(0.5*Vb1c4_Vb2_c2)*VtINV);
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb1_b2))*VtINV)+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb2_c2_Vb2_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb2_c2))*VtINV)+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb2_c2_Vc1_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc1_c2))*VtINV)+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb2_c2_Vc4_c1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc4_c1))*VtINV)+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb2_c2+0.5*Vb1c4_Vb2_c2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb2_c2_Vb2_e1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((0.0)*VtINV)+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb2_c2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vb2_c2_Vdt_GND=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))+0.0*(0.5*Vb1c4_Vb2_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vb2_c2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
#endif
tmpExp_Vc1_c2=(expl*(0.5*Vb1c4_Vc1_c2)*VtINV);
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb1_b2))*VtINV)+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vb1_b2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc1_c2_Vb2_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb2_c2))*VtINV)+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vb2_c2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc1_c2_Vc1_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc1_c2))*VtINV)+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vc1_c2)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc1_c2_Vc4_c1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc4_c1))*VtINV)+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc1_c2+0.5*Vb1c4_Vc1_c2_Vc4_c1)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc1_c2_Vb2_e1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((0.0)*VtINV)+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc1_c2)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc1_c2_Vdt_GND=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))+0.0*(0.5*Vb1c4_Vc1_c2)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc1_c2)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
#endif
tmpExp_Vc4_c1=(expl*(0.5*Vb1c4_Vc4_c1)*VtINV);
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb1_b2))*VtINV)+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vb1_b2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vb1_b2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc4_c1_Vb2_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vb2_c2))*VtINV)+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vb2_c2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vb2_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc4_c1_Vc1_c2=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc1_c2))*VtINV)+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vc1_c2)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vc1_c2))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc4_c1_Vc4_c1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*(((0.5*Vb1c4_Vc4_c1))*VtINV)+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc4_c1+0.5*Vb1c4_Vc4_c1_Vc4_c1)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+((0.5*Vb1c4_Vc4_c1))*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc4_c1_Vb2_e1=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((0.0)*VtINV)+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc4_c1+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc4_c1)*0.0+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
  tmpExp_Vc4_c1_Vdt_GND=(+0.0*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))+0.0*((((0.0)*VtINV)+((0.5*Vb1c4)*VtINV_Vdt_GND)))+0.0*(0.5*Vb1c4_Vc4_c1)*VtINV+expl*(+0.0+(+(+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc4_c1+0.5*0.0)*VtINV+(0.5*Vb1c4_Vc4_c1)*VtINV_Vdt_GND+(0.0)*0.0+(0.5*Vb1c4)*0.0)-0.0)));
#endif
tmpExp_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=0.0;
  tmpExp_Vb2_e1_Vb2_c2=0.0;
  tmpExp_Vb2_e1_Vc1_c2=0.0;
  tmpExp_Vb2_e1_Vc4_c1=0.0;
  tmpExp_Vb2_e1_Vb2_e1=0.0;
  tmpExp_Vb2_e1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=(expl*((0.5*Vb1c4)*VtINV_Vdt_GND));
#endif
#endif
tmpExp=(expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0)));
EXIT_IF_ISNAN((expl*(1.0+(((0.5*Vb1c4)*VtINV)-400.0))))
}
{
double m00_exp(d00_exp0,((0.5*pModel->VLR)*VtINV))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Ib3_Vdt_GND=((((IBR_TM_Vdt_GND*(eVb1c4-1.0))+(IBR_TM*eVb1c4_Vdt_GND))*(tmpExp+d00_exp0)-(IBR_TM*(eVb1c4-1.0))*(tmpExp_Vdt_GND+((0.5*pModel->VLR)*VtINV_Vdt_GND)*d10_exp0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0));
#endif
Ib3_Vb1_b2=((((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp+d00_exp0)-(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(my_gmin*Vb1c4_Vb1_b2));
#if defined(_DERIVATE2)
  Ib3_Vb1_b2_Vdt_GND=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vdt_GND+IBR_TM_Vdt_GND*eVb1c4_Vb1_b2+IBR_TM*(+eVb1c4_Vb1_b2_Vdt_GND-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)+(((IBR_TM_Vdt_GND*(eVb1c4-1.0))+(IBR_TM*eVb1c4_Vdt_GND)))*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vdt_GND+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+my_gmin*0.0));
  Ib3_Vb1_b2_Vb1_b2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vb1_b2+IBR_TM*(+eVb1c4_Vb1_b2_Vb1_b2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb1_b2))*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vb1_b2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb1_b2+my_gmin*Vb1c4_Vb1_b2_Vb1_b2));
  Ib3_Vb1_b2_Vb2_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vb1_b2+IBR_TM*(+eVb1c4_Vb1_b2_Vb2_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb2_c2))*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vb2_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb1_b2+my_gmin*Vb1c4_Vb1_b2_Vb2_c2));
  Ib3_Vb1_b2_Vc1_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vb1_b2+IBR_TM*(+eVb1c4_Vb1_b2_Vc1_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc1_c2))*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vc1_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb1_b2+my_gmin*Vb1c4_Vb1_b2_Vc1_c2));
  Ib3_Vb1_b2_Vc4_c1=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vb1_b2+IBR_TM*(+eVb1c4_Vb1_b2_Vc4_c1-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc4_c1))*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vc4_c1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb1_b2+my_gmin*Vb1c4_Vb1_b2_Vc4_c1));
  Ib3_Vb1_b2_Vb2_e1=(+((+0.0*(eVb1c4-1.0)+0.0*0.0+0.0*eVb1c4_Vb1_b2+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb1_b2)*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)+(0.0)*tmpExp_Vb1_b2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb1_b2_Vb2_e1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb1_b2*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+my_gmin*0.0));
#endif
Ib3_Vb2_c2=((((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp+d00_exp0)-(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(my_gmin*Vb1c4_Vb2_c2));
#if defined(_DERIVATE2)
  Ib3_Vb2_c2_Vdt_GND=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vdt_GND+IBR_TM_Vdt_GND*eVb1c4_Vb2_c2+IBR_TM*(+eVb1c4_Vb2_c2_Vdt_GND-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)+(((IBR_TM_Vdt_GND*(eVb1c4-1.0))+(IBR_TM*eVb1c4_Vdt_GND)))*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vdt_GND+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+my_gmin*0.0));
  Ib3_Vb2_c2_Vb1_b2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vb2_c2+IBR_TM*(+eVb1c4_Vb2_c2_Vb1_b2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb1_b2))*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vb1_b2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb2_c2+my_gmin*Vb1c4_Vb2_c2_Vb1_b2));
  Ib3_Vb2_c2_Vb2_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vb2_c2+IBR_TM*(+eVb1c4_Vb2_c2_Vb2_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb2_c2))*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vb2_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb2_c2+my_gmin*Vb1c4_Vb2_c2_Vb2_c2));
  Ib3_Vb2_c2_Vc1_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vb2_c2+IBR_TM*(+eVb1c4_Vb2_c2_Vc1_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc1_c2))*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vc1_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb2_c2+my_gmin*Vb1c4_Vb2_c2_Vc1_c2));
  Ib3_Vb2_c2_Vc4_c1=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vb2_c2+IBR_TM*(+eVb1c4_Vb2_c2_Vc4_c1-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc4_c1))*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vc4_c1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb2_c2+my_gmin*Vb1c4_Vb2_c2_Vc4_c1));
  Ib3_Vb2_c2_Vb2_e1=(+((+0.0*(eVb1c4-1.0)+0.0*0.0+0.0*eVb1c4_Vb2_c2+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vb2_c2)*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)+(0.0)*tmpExp_Vb2_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_c2_Vb2_e1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_c2*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+my_gmin*0.0));
#endif
Ib3_Vc1_c2=((((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp+d00_exp0)-(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(my_gmin*Vb1c4_Vc1_c2));
#if defined(_DERIVATE2)
  Ib3_Vc1_c2_Vdt_GND=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vdt_GND+IBR_TM_Vdt_GND*eVb1c4_Vc1_c2+IBR_TM*(+eVb1c4_Vc1_c2_Vdt_GND-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)+(((IBR_TM_Vdt_GND*(eVb1c4-1.0))+(IBR_TM*eVb1c4_Vdt_GND)))*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vdt_GND+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+my_gmin*0.0));
  Ib3_Vc1_c2_Vb1_b2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vc1_c2+IBR_TM*(+eVb1c4_Vc1_c2_Vb1_b2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb1_b2))*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vb1_b2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc1_c2+my_gmin*Vb1c4_Vc1_c2_Vb1_b2));
  Ib3_Vc1_c2_Vb2_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vc1_c2+IBR_TM*(+eVb1c4_Vc1_c2_Vb2_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb2_c2))*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vb2_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc1_c2+my_gmin*Vb1c4_Vc1_c2_Vb2_c2));
  Ib3_Vc1_c2_Vc1_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vc1_c2+IBR_TM*(+eVb1c4_Vc1_c2_Vc1_c2-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc1_c2))*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vc1_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc1_c2+my_gmin*Vb1c4_Vc1_c2_Vc1_c2));
  Ib3_Vc1_c2_Vc4_c1=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vc1_c2+IBR_TM*(+eVb1c4_Vc1_c2_Vc4_c1-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc4_c1))*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vc4_c1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc1_c2+my_gmin*Vb1c4_Vc1_c2_Vc4_c1));
  Ib3_Vc1_c2_Vb2_e1=(+((+0.0*(eVb1c4-1.0)+0.0*0.0+0.0*eVb1c4_Vc1_c2+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-((IBR_TM*eVb1c4_Vc1_c2)*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)+(0.0)*tmpExp_Vc1_c2+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vc1_c2_Vb2_e1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc1_c2*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+my_gmin*0.0));
#endif
#if defined(_DERIVATE)
Ib3_Vc4_c1=((((IBR_TM*eVb1c4_Vc4_c1)*(tmpExp+d00_exp0)-(IBR_TM*(eVb1c4-1.0))*tmpExp_Vc4_c1)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(my_gmin*Vb1c4_Vc4_c1));
#endif
Ib3_Vb2_e1=(-(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1/(tmpExp+d00_exp0)/(tmpExp+d00_exp0));
#if defined(_DERIVATE2)
  Ib3_Vb2_e1_Vdt_GND=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vdt_GND+IBR_TM_Vdt_GND*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)+(((IBR_TM_Vdt_GND*(eVb1c4-1.0))+(IBR_TM*eVb1c4_Vdt_GND)))*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vdt_GND+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vdt_GND+((((0.0)*VtINV)+((0.5*pModel->VLR)*VtINV_Vdt_GND)))*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+my_gmin*0.0));
  Ib3_Vb2_e1_Vb1_b2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb1_b2+0.0*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb1_b2))*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vb1_b2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vb1_b2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*0.0+my_gmin*0.0));
  Ib3_Vb2_e1_Vb2_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vb2_c2+0.0*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vb2_c2))*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vb2_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vb2_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*0.0+my_gmin*0.0));
  Ib3_Vb2_e1_Vc1_c2=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc1_c2+0.0*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc1_c2))*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vc1_c2+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vc1_c2+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*0.0+my_gmin*0.0));
  Ib3_Vb2_e1_Vc4_c1=(+((+0.0*(eVb1c4-1.0)+0.0*eVb1c4_Vc4_c1+0.0*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)+((IBR_TM*eVb1c4_Vc4_c1))*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vc4_c1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vc4_c1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*0.0+my_gmin*0.0));
  Ib3_Vb2_e1_Vb2_e1=(+((+0.0*(eVb1c4-1.0)+0.0*0.0+0.0*0.0+IBR_TM*(+0.0-0.0))/(tmpExp+d00_exp0)-(0.0*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)+(0.0)*tmpExp_Vb2_e1+(IBR_TM*(eVb1c4-1.0))*(+tmpExp_Vb2_e1_Vb2_e1+0.0))/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)+2*(IBR_TM*(eVb1c4-1.0))*tmpExp_Vb2_e1*(tmpExp_Vb2_e1+((0.0)*VtINV)*d10_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0)/(tmpExp+d00_exp0))+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+my_gmin*0.0));
#endif
#endif
pInst->Ib3=(((IBR_TM*(eVb1c4-1.0))/(tmpExp+d00_exp0))+(my_gmin*Vb1c4));
EXIT_IF_ISNAN((((IBR_TM*(eVb1c4-1.0))/(tmpExp+d00_exp0))+(my_gmin*Vb1c4)))
}
if
((((pModel->IZEB>0.0)&&(pModel->NZEB>0.0))&&(Vb2e1<0)))
{
if
(((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))<400.0))
{
{
double m00_exp(d00_exp0,(nZEB_T*(1-(pow2_2mPE/(2.0*E0BE)))))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
eZEB_Vdt_GND=((nZEB_T_Vdt_GND*(1-(pow2_2mPE/(2.0*E0BE))))+(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vdt_GND)/(2.0*E0BE)/(2.0*E0BE)))))*d10_exp0;
eZEB_Vb2_e1=(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_e1)/(2.0*E0BE)/(2.0*E0BE))))*d10_exp0;
eZEB_Vb2_c2=(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_c2)/(2.0*E0BE)/(2.0*E0BE))))*d10_exp0;
eZEB_Vb2_c1=(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_c1)/(2.0*E0BE)/(2.0*E0BE))))*d10_exp0;
eZEB_Vc1_c2=(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vc1_c2)/(2.0*E0BE)/(2.0*E0BE))))*d10_exp0;
#endif
eZEB=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
eZEB_Vdt_GND=(expl*((nZEB_T_Vdt_GND*(1-(pow2_2mPE/(2.0*E0BE))))+(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vdt_GND)/(2.0*E0BE)/(2.0*E0BE))))));
eZEB_Vb2_e1=(expl*(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_e1)/(2.0*E0BE)/(2.0*E0BE)))));
eZEB_Vb2_c2=(expl*(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_c2)/(2.0*E0BE)/(2.0*E0BE)))));
eZEB_Vb2_c1=(expl*(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vb2_c1)/(2.0*E0BE)/(2.0*E0BE)))));
eZEB_Vc1_c2=(expl*(nZEB_T*(-(-pow2_2mPE*(2.0*E0BE_Vc1_c2)/(2.0*E0BE)/(2.0*E0BE)))));
#endif
eZEB=(expl*(1.0+((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((nZEB_T*(1-(pow2_2mPE/(2.0*E0BE))))-400.0))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND)V(b,GND) */
x_Vb2_e1=Vb2e1_Vb2_e1*inv_VDE_T;
#if defined(_DERIVATE2)
  x_Vb2_e1_Vb2_e1=(+Vb2e1_Vb2_e1_Vb2_e1*inv_VDE_T+Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+Vb2e1*0.0);
  x_Vb2_e1_Vdt_GND=(+0.0*inv_VDE_T+Vb2e1_Vb2_e1*inv_VDE_T_Vdt_GND+0.0*0.0+Vb2e1*0.0);
#endif
#if defined(_DERIVATE)
x_Vdt_GND=(Vb2e1*inv_VDE_T_Vdt_GND);
#endif
#endif
x=(Vb2e1*inv_VDE_T);
EXIT_IF_ISNAN((Vb2e1*inv_VDE_T))
{
double m00_pow(d00_pow0,(-x),((-2.0)-pModel->PE))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(-x),((-2.0)-pModel->PE))
#endif
#if defined(_DERIVATE) /* probe=V(b2,e1)V(dt,GND) ddxprobe= */
dE0BE_Vb2_e1=(((d10_pow0*(-x_Vb2_e1))*((pModel->PE*((1-(pModel->PE*pModel->PE))-((3*x)*(pModel->PE-1))))-(((6*x)*x)*((pModel->PE-1)+x))))+(d00_pow0*((pModel->PE*(-(3*x_Vb2_e1)*(pModel->PE-1)))-(((((6*x_Vb2_e1)*x)+((6*x)*x_Vb2_e1))*((pModel->PE-1)+x))+(((6*x)*x)*x_Vb2_e1)))))*0.16666666666666666667;
dE0BE_Vdt_GND=(((d10_pow0*(-x_Vdt_GND))*((pModel->PE*((1-(pModel->PE*pModel->PE))-((3*x)*(pModel->PE-1))))-(((6*x)*x)*((pModel->PE-1)+x))))+(d00_pow0*((pModel->PE*(-(3*x_Vdt_GND)*(pModel->PE-1)))-(((((6*x_Vdt_GND)*x)+((6*x)*x_Vdt_GND))*((pModel->PE-1)+x))+(((6*x)*x)*x_Vdt_GND)))))*0.16666666666666666667;
#endif
dE0BE=((d00_pow0*((pModel->PE*((1-(pModel->PE*pModel->PE))-((3*x)*(pModel->PE-1))))-(((6*x)*x)*((pModel->PE-1)+x))))*0.16666666666666666667);
EXIT_IF_ISNAN(((d00_pow0*((pModel->PE*((1-(pModel->PE*pModel->PE))-((3*x)*(pModel->PE-1))))-(((6*x)*x)*((pModel->PE-1)+x))))*0.16666666666666666667))
}
if
(((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))<400.0))
{
{
double m00_exp(d00_exp0,(((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE)))
#if defined(_DERIVATE)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATE) /* probe=V(b2,e1)V(dt,GND) ddxprobe= */
edZEB_Vb2_e1=((Vb2e1_Vb2_e1*pow2_2mPE*nZEB_T*(VGZEB_T*dE0BE)-((Vb2e1*pow2_2mPE)*nZEB_T)*(VGZEB_T*dE0BE_Vb2_e1))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE))*d10_exp0;
edZEB_Vdt_GND=((((Vb2e1*pow2_2mPE)*nZEB_T_Vdt_GND)*(VGZEB_T*dE0BE)-((Vb2e1*pow2_2mPE)*nZEB_T)*((VGZEB_T_Vdt_GND*dE0BE)+(VGZEB_T*dE0BE_Vdt_GND)))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE))*d10_exp0;
#endif
edZEB=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
else
{
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#if defined(_DERIVATE) /* probe=V(b2,e1)V(dt,GND) ddxprobe= */
edZEB_Vb2_e1=(expl*((Vb2e1_Vb2_e1*pow2_2mPE*nZEB_T*(VGZEB_T*dE0BE)-((Vb2e1*pow2_2mPE)*nZEB_T)*(VGZEB_T*dE0BE_Vb2_e1))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE)));
edZEB_Vdt_GND=(expl*((((Vb2e1*pow2_2mPE)*nZEB_T_Vdt_GND)*(VGZEB_T*dE0BE)-((Vb2e1*pow2_2mPE)*nZEB_T)*((VGZEB_T_Vdt_GND*dE0BE)+(VGZEB_T*dE0BE_Vdt_GND)))/(VGZEB_T*dE0BE)/(VGZEB_T*dE0BE)));
#endif
edZEB=(expl*(1.0+((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((((Vb2e1*pow2_2mPE)*nZEB_T)/(VGZEB_T*dE0BE))-400.0))))
}
#if defined(_DERIVATE) /* probe=V(b2,e1)V(dt,GND) ddxprobe= */
DZEB_Vb2_e1=((-Vb2e1_Vb2_e1)-((((VGZEB_T*dE0BE_Vb2_e1)*(1-edZEB))+((VGZEB_T*dE0BE)*(-edZEB_Vb2_e1)))/(pow2_2mPE*nZEB_T)));
DZEB_Vdt_GND=(-((((((VGZEB_T_Vdt_GND*dE0BE)+(VGZEB_T*dE0BE_Vdt_GND))*(1-edZEB))+((VGZEB_T*dE0BE)*(-edZEB_Vdt_GND)))*(pow2_2mPE*nZEB_T)-((VGZEB_T*dE0BE)*(1-edZEB))*(pow2_2mPE*nZEB_T_Vdt_GND))/(pow2_2mPE*nZEB_T)/(pow2_2mPE*nZEB_T)));
#endif
DZEB=((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(pow2_2mPE*nZEB_T)));
EXIT_IF_ISNAN(((-Vb2e1)-(((VGZEB_T*dE0BE)*(1-edZEB))/(pow2_2mPE*nZEB_T))))
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Izteb_Vdt_GND=(((((((((2.0*IZEB_TM_Vdt_GND)*DZEB)+((2.0*IZEB_TM)*DZEB_Vdt_GND))*E0BE)+(((2.0*IZEB_TM)*DZEB)*E0BE_Vdt_GND))*eZEB)+((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB_Vdt_GND))*inv_VDE_T)+(((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T_Vdt_GND))*pow2_PEm2;
Izteb_Vb2_e1=((((((2.0*IZEB_TM)*DZEB_Vb2_e1)*E0BE)+(((2.0*IZEB_TM)*DZEB)*E0BE_Vb2_e1))*eZEB)+((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB_Vb2_e1))*inv_VDE_T*pow2_PEm2;
Izteb_Vb2_c2=(((((2.0*IZEB_TM)*DZEB)*E0BE_Vb2_c2)*eZEB)+((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB_Vb2_c2))*inv_VDE_T*pow2_PEm2;
Izteb_Vb2_c1=(((((2.0*IZEB_TM)*DZEB)*E0BE_Vb2_c1)*eZEB)+((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB_Vb2_c1))*inv_VDE_T*pow2_PEm2;
Izteb_Vc1_c2=(((((2.0*IZEB_TM)*DZEB)*E0BE_Vc1_c2)*eZEB)+((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB_Vc1_c2))*inv_VDE_T*pow2_PEm2;
#endif
pInst->Izteb=((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*pow2_PEm2);
EXIT_IF_ISNAN(((((((2.0*IZEB_TM)*DZEB)*E0BE)*eZEB)*inv_VDE_T)*pow2_PEm2))
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(b2,e1)V(dt,GND) ddxprobe= */
DZEB_Vb2_e1=0.0;
DZEB_Vdt_GND=0.0;
#endif
DZEB=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Izteb_Vdt_GND=0.0;
Izteb_Vb2_e1=0.0;
Izteb_Vb2_c2=0.0;
Izteb_Vb2_c1=0.0;
Izteb_Vc1_c2=0.0;
#endif
pInst->Izteb=0;
EXIT_IF_ISNAN(0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
g1_Vdt_GND=((If0_Vdt_GND*eVb1c4)+(If0*eVb1c4_Vdt_GND));
#endif
g1_Vb1_b2=(If0*eVb1c4_Vb1_b2);
#if defined(_DERIVATE2)
  g1_Vb1_b2_Vdt_GND=(+0.0*eVb1c4+0.0*eVb1c4_Vdt_GND+If0_Vdt_GND*eVb1c4_Vb1_b2+If0*eVb1c4_Vb1_b2_Vdt_GND);
  g1_Vb1_b2_Vb1_b2=(+0.0*eVb1c4+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vb1_b2+If0*eVb1c4_Vb1_b2_Vb1_b2);
  g1_Vb1_b2_Vb2_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vb1_b2+If0*eVb1c4_Vb1_b2_Vb2_c2);
  g1_Vb1_b2_Vc1_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vb1_b2+If0*eVb1c4_Vb1_b2_Vc1_c2);
  g1_Vb1_b2_Vc4_c1=(+0.0*eVb1c4+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vb1_b2+If0*eVb1c4_Vb1_b2_Vc4_c1);
#endif
g1_Vb2_c2=(If0*eVb1c4_Vb2_c2);
#if defined(_DERIVATE2)
  g1_Vb2_c2_Vdt_GND=(+0.0*eVb1c4+0.0*eVb1c4_Vdt_GND+If0_Vdt_GND*eVb1c4_Vb2_c2+If0*eVb1c4_Vb2_c2_Vdt_GND);
  g1_Vb2_c2_Vb1_b2=(+0.0*eVb1c4+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vb2_c2+If0*eVb1c4_Vb2_c2_Vb1_b2);
  g1_Vb2_c2_Vb2_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vb2_c2+If0*eVb1c4_Vb2_c2_Vb2_c2);
  g1_Vb2_c2_Vc1_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vb2_c2+If0*eVb1c4_Vb2_c2_Vc1_c2);
  g1_Vb2_c2_Vc4_c1=(+0.0*eVb1c4+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vb2_c2+If0*eVb1c4_Vb2_c2_Vc4_c1);
#endif
g1_Vc1_c2=(If0*eVb1c4_Vc1_c2);
#if defined(_DERIVATE2)
  g1_Vc1_c2_Vdt_GND=(+0.0*eVb1c4+0.0*eVb1c4_Vdt_GND+If0_Vdt_GND*eVb1c4_Vc1_c2+If0*eVb1c4_Vc1_c2_Vdt_GND);
  g1_Vc1_c2_Vb1_b2=(+0.0*eVb1c4+0.0*eVb1c4_Vb1_b2+0.0*eVb1c4_Vc1_c2+If0*eVb1c4_Vc1_c2_Vb1_b2);
  g1_Vc1_c2_Vb2_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vb2_c2+0.0*eVb1c4_Vc1_c2+If0*eVb1c4_Vc1_c2_Vb2_c2);
  g1_Vc1_c2_Vc1_c2=(+0.0*eVb1c4+0.0*eVb1c4_Vc1_c2+0.0*eVb1c4_Vc1_c2+If0*eVb1c4_Vc1_c2_Vc1_c2);
  g1_Vc1_c2_Vc4_c1=(+0.0*eVb1c4+0.0*eVb1c4_Vc4_c1+0.0*eVb1c4_Vc1_c2+If0*eVb1c4_Vc1_c2_Vc4_c1);
#endif
#if defined(_DERIVATE)
g1_Vc4_c1=(If0*eVb1c4_Vc4_c1);
#endif
#endif
g1=(If0*eVb1c4);
EXIT_IF_ISNAN((If0*eVb1c4))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
g2_Vb1_b2=(4.0*eVb1c4VDC_Vb1_b2);
#if defined(_DERIVATE2)
  g2_Vb1_b2_Vb1_b2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb1_b2+0.0*eVb1c4VDC_Vb1_b2+4.0*eVb1c4VDC_Vb1_b2_Vb1_b2);
  g2_Vb1_b2_Vb2_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb2_c2+0.0*eVb1c4VDC_Vb1_b2+4.0*eVb1c4VDC_Vb1_b2_Vb2_c2);
  g2_Vb1_b2_Vc1_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc1_c2+0.0*eVb1c4VDC_Vb1_b2+4.0*eVb1c4VDC_Vb1_b2_Vc1_c2);
  g2_Vb1_b2_Vc4_c1=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc4_c1+0.0*eVb1c4VDC_Vb1_b2+4.0*eVb1c4VDC_Vb1_b2_Vc4_c1);
  g2_Vb1_b2_Vdt_GND=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vdt_GND+0.0*eVb1c4VDC_Vb1_b2+4.0*eVb1c4VDC_Vb1_b2_Vdt_GND);
#endif
g2_Vb2_c2=(4.0*eVb1c4VDC_Vb2_c2);
#if defined(_DERIVATE2)
  g2_Vb2_c2_Vb1_b2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb1_b2+0.0*eVb1c4VDC_Vb2_c2+4.0*eVb1c4VDC_Vb2_c2_Vb1_b2);
  g2_Vb2_c2_Vb2_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb2_c2+0.0*eVb1c4VDC_Vb2_c2+4.0*eVb1c4VDC_Vb2_c2_Vb2_c2);
  g2_Vb2_c2_Vc1_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc1_c2+0.0*eVb1c4VDC_Vb2_c2+4.0*eVb1c4VDC_Vb2_c2_Vc1_c2);
  g2_Vb2_c2_Vc4_c1=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc4_c1+0.0*eVb1c4VDC_Vb2_c2+4.0*eVb1c4VDC_Vb2_c2_Vc4_c1);
  g2_Vb2_c2_Vdt_GND=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vdt_GND+0.0*eVb1c4VDC_Vb2_c2+4.0*eVb1c4VDC_Vb2_c2_Vdt_GND);
#endif
g2_Vc1_c2=(4.0*eVb1c4VDC_Vc1_c2);
#if defined(_DERIVATE2)
  g2_Vc1_c2_Vb1_b2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb1_b2+0.0*eVb1c4VDC_Vc1_c2+4.0*eVb1c4VDC_Vc1_c2_Vb1_b2);
  g2_Vc1_c2_Vb2_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vb2_c2+0.0*eVb1c4VDC_Vc1_c2+4.0*eVb1c4VDC_Vc1_c2_Vb2_c2);
  g2_Vc1_c2_Vc1_c2=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc1_c2+0.0*eVb1c4VDC_Vc1_c2+4.0*eVb1c4VDC_Vc1_c2_Vc1_c2);
  g2_Vc1_c2_Vc4_c1=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vc4_c1+0.0*eVb1c4VDC_Vc1_c2+4.0*eVb1c4VDC_Vc1_c2_Vc4_c1);
  g2_Vc1_c2_Vdt_GND=(+0.0*eVb1c4VDC+0.0*eVb1c4VDC_Vdt_GND+0.0*eVb1c4VDC_Vc1_c2+4.0*eVb1c4VDC_Vc1_c2_Vdt_GND);
#endif
#if defined(_DERIVATE)
g2_Vc4_c1=(4.0*eVb1c4VDC_Vc4_c1);
#endif
#if defined(_DERIVATE)
g2_Vdt_GND=(4.0*eVb1c4VDC_Vdt_GND);
#endif
#endif
g2=(4.0*eVb1c4VDC);
EXIT_IF_ISNAN((4.0*eVb1c4VDC))
#endif
{
double m00_sqrt(d00_sqrt0,(1.0+g1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+g1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
#if defined(_DERIVATE)
nBex_Vdt_GND=(((g1_Vdt_GND-If0_Vdt_GND)*(1.0+d00_sqrt0)-(g1-If0)*g1_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nBex_Vb1_b2=((g1_Vb1_b2*(1.0+d00_sqrt0)-(g1-If0)*g1_Vb1_b2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nBex_Vb1_b2_Vdt_GND=((+g1_Vb1_b2_Vdt_GND-0.0)/(1.0+d00_sqrt0)-(g1_Vb1_b2*g1_Vdt_GND*d10_sqrt0+(g1_Vdt_GND-If0_Vdt_GND)*g1_Vb1_b2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vdt_GND*g1_Vb1_b2+d10_sqrt0*(+0.0+g1_Vb1_b2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb1_b2*d10_sqrt0*g1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb1_b2_Vb1_b2=((+g1_Vb1_b2_Vb1_b2-0.0)/(1.0+d00_sqrt0)-(g1_Vb1_b2*g1_Vb1_b2*d10_sqrt0+g1_Vb1_b2*g1_Vb1_b2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb1_b2*g1_Vb1_b2+d10_sqrt0*(+0.0+g1_Vb1_b2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb1_b2*d10_sqrt0*g1_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb1_b2_Vb2_c2=((+g1_Vb1_b2_Vb2_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vb1_b2*g1_Vb2_c2*d10_sqrt0+g1_Vb2_c2*g1_Vb1_b2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb2_c2*g1_Vb1_b2+d10_sqrt0*(+0.0+g1_Vb1_b2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb1_b2*d10_sqrt0*g1_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb1_b2_Vc1_c2=((+g1_Vb1_b2_Vc1_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vb1_b2*g1_Vc1_c2*d10_sqrt0+g1_Vc1_c2*g1_Vb1_b2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc1_c2*g1_Vb1_b2+d10_sqrt0*(+0.0+g1_Vb1_b2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb1_b2*d10_sqrt0*g1_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb1_b2_Vc4_c1=((+g1_Vb1_b2_Vc4_c1-0.0)/(1.0+d00_sqrt0)-(g1_Vb1_b2*g1_Vc4_c1*d10_sqrt0+g1_Vc4_c1*g1_Vb1_b2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc4_c1*g1_Vb1_b2+d10_sqrt0*(+0.0+g1_Vb1_b2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb1_b2*d10_sqrt0*g1_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nBex_Vb2_c2=((g1_Vb2_c2*(1.0+d00_sqrt0)-(g1-If0)*g1_Vb2_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nBex_Vb2_c2_Vdt_GND=((+g1_Vb2_c2_Vdt_GND-0.0)/(1.0+d00_sqrt0)-(g1_Vb2_c2*g1_Vdt_GND*d10_sqrt0+(g1_Vdt_GND-If0_Vdt_GND)*g1_Vb2_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vdt_GND*g1_Vb2_c2+d10_sqrt0*(+0.0+g1_Vb2_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb2_c2*d10_sqrt0*g1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb2_c2_Vb1_b2=((+g1_Vb2_c2_Vb1_b2-0.0)/(1.0+d00_sqrt0)-(g1_Vb2_c2*g1_Vb1_b2*d10_sqrt0+g1_Vb1_b2*g1_Vb2_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb1_b2*g1_Vb2_c2+d10_sqrt0*(+0.0+g1_Vb2_c2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb2_c2*d10_sqrt0*g1_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb2_c2_Vb2_c2=((+g1_Vb2_c2_Vb2_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vb2_c2*g1_Vb2_c2*d10_sqrt0+g1_Vb2_c2*g1_Vb2_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb2_c2*g1_Vb2_c2+d10_sqrt0*(+0.0+g1_Vb2_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb2_c2*d10_sqrt0*g1_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb2_c2_Vc1_c2=((+g1_Vb2_c2_Vc1_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vb2_c2*g1_Vc1_c2*d10_sqrt0+g1_Vc1_c2*g1_Vb2_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc1_c2*g1_Vb2_c2+d10_sqrt0*(+0.0+g1_Vb2_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb2_c2*d10_sqrt0*g1_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vb2_c2_Vc4_c1=((+g1_Vb2_c2_Vc4_c1-0.0)/(1.0+d00_sqrt0)-(g1_Vb2_c2*g1_Vc4_c1*d10_sqrt0+g1_Vc4_c1*g1_Vb2_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc4_c1*g1_Vb2_c2+d10_sqrt0*(+0.0+g1_Vb2_c2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vb2_c2*d10_sqrt0*g1_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
nBex_Vc1_c2=((g1_Vc1_c2*(1.0+d00_sqrt0)-(g1-If0)*g1_Vc1_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  nBex_Vc1_c2_Vdt_GND=((+g1_Vc1_c2_Vdt_GND-0.0)/(1.0+d00_sqrt0)-(g1_Vc1_c2*g1_Vdt_GND*d10_sqrt0+(g1_Vdt_GND-If0_Vdt_GND)*g1_Vc1_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vdt_GND*g1_Vc1_c2+d10_sqrt0*(+0.0+g1_Vc1_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vc1_c2*d10_sqrt0*g1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vc1_c2_Vb1_b2=((+g1_Vc1_c2_Vb1_b2-0.0)/(1.0+d00_sqrt0)-(g1_Vc1_c2*g1_Vb1_b2*d10_sqrt0+g1_Vb1_b2*g1_Vc1_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb1_b2*g1_Vc1_c2+d10_sqrt0*(+0.0+g1_Vc1_c2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vc1_c2*d10_sqrt0*g1_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vc1_c2_Vb2_c2=((+g1_Vc1_c2_Vb2_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vc1_c2*g1_Vb2_c2*d10_sqrt0+g1_Vb2_c2*g1_Vc1_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vb2_c2*g1_Vc1_c2+d10_sqrt0*(+0.0+g1_Vc1_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vc1_c2*d10_sqrt0*g1_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vc1_c2_Vc1_c2=((+g1_Vc1_c2_Vc1_c2-0.0)/(1.0+d00_sqrt0)-(g1_Vc1_c2*g1_Vc1_c2*d10_sqrt0+g1_Vc1_c2*g1_Vc1_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc1_c2*g1_Vc1_c2+d10_sqrt0*(+0.0+g1_Vc1_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vc1_c2*d10_sqrt0*g1_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  nBex_Vc1_c2_Vc4_c1=((+g1_Vc1_c2_Vc4_c1-0.0)/(1.0+d00_sqrt0)-(g1_Vc1_c2*g1_Vc4_c1*d10_sqrt0+g1_Vc4_c1*g1_Vc1_c2*d10_sqrt0+(g1-If0)*(+0.0+(m20_sqrt((1.0+g1))*g1_Vc4_c1*g1_Vc1_c2+d10_sqrt0*(+0.0+g1_Vc1_c2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(g1-If0)*g1_Vc1_c2*d10_sqrt0*g1_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
nBex_Vc4_c1=((g1_Vc4_c1*(1.0+d00_sqrt0)-(g1-If0)*g1_Vc4_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
nBex=((g1-If0)/(1.0+d00_sqrt0));
EXIT_IF_ISNAN(((g1-If0)/(1.0+d00_sqrt0)))
}
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0+g2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+g2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
pWex_Vb1_b2=((g2_Vb1_b2*(1.0+d00_sqrt0)-g2*g2_Vb1_b2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  pWex_Vb1_b2_Vb1_b2=(g2_Vb1_b2_Vb1_b2/(1.0+d00_sqrt0)-(g2_Vb1_b2*g2_Vb1_b2*d10_sqrt0+g2_Vb1_b2*g2_Vb1_b2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb1_b2*g2_Vb1_b2+d10_sqrt0*(+0.0+g2_Vb1_b2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb1_b2*d10_sqrt0*g2_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb1_b2_Vb2_c2=(g2_Vb1_b2_Vb2_c2/(1.0+d00_sqrt0)-(g2_Vb1_b2*g2_Vb2_c2*d10_sqrt0+g2_Vb2_c2*g2_Vb1_b2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb2_c2*g2_Vb1_b2+d10_sqrt0*(+0.0+g2_Vb1_b2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb1_b2*d10_sqrt0*g2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb1_b2_Vc1_c2=(g2_Vb1_b2_Vc1_c2/(1.0+d00_sqrt0)-(g2_Vb1_b2*g2_Vc1_c2*d10_sqrt0+g2_Vc1_c2*g2_Vb1_b2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc1_c2*g2_Vb1_b2+d10_sqrt0*(+0.0+g2_Vb1_b2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb1_b2*d10_sqrt0*g2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb1_b2_Vc4_c1=(g2_Vb1_b2_Vc4_c1/(1.0+d00_sqrt0)-(g2_Vb1_b2*g2_Vc4_c1*d10_sqrt0+g2_Vc4_c1*g2_Vb1_b2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc4_c1*g2_Vb1_b2+d10_sqrt0*(+0.0+g2_Vb1_b2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb1_b2*d10_sqrt0*g2_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb1_b2_Vdt_GND=(g2_Vb1_b2_Vdt_GND/(1.0+d00_sqrt0)-(g2_Vb1_b2*g2_Vdt_GND*d10_sqrt0+g2_Vdt_GND*g2_Vb1_b2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vdt_GND*g2_Vb1_b2+d10_sqrt0*(+0.0+g2_Vb1_b2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb1_b2*d10_sqrt0*g2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
pWex_Vb2_c2=((g2_Vb2_c2*(1.0+d00_sqrt0)-g2*g2_Vb2_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  pWex_Vb2_c2_Vb1_b2=(g2_Vb2_c2_Vb1_b2/(1.0+d00_sqrt0)-(g2_Vb2_c2*g2_Vb1_b2*d10_sqrt0+g2_Vb1_b2*g2_Vb2_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb1_b2*g2_Vb2_c2+d10_sqrt0*(+0.0+g2_Vb2_c2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb2_c2*d10_sqrt0*g2_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb2_c2_Vb2_c2=(g2_Vb2_c2_Vb2_c2/(1.0+d00_sqrt0)-(g2_Vb2_c2*g2_Vb2_c2*d10_sqrt0+g2_Vb2_c2*g2_Vb2_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb2_c2*g2_Vb2_c2+d10_sqrt0*(+0.0+g2_Vb2_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb2_c2*d10_sqrt0*g2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb2_c2_Vc1_c2=(g2_Vb2_c2_Vc1_c2/(1.0+d00_sqrt0)-(g2_Vb2_c2*g2_Vc1_c2*d10_sqrt0+g2_Vc1_c2*g2_Vb2_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc1_c2*g2_Vb2_c2+d10_sqrt0*(+0.0+g2_Vb2_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb2_c2*d10_sqrt0*g2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb2_c2_Vc4_c1=(g2_Vb2_c2_Vc4_c1/(1.0+d00_sqrt0)-(g2_Vb2_c2*g2_Vc4_c1*d10_sqrt0+g2_Vc4_c1*g2_Vb2_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc4_c1*g2_Vb2_c2+d10_sqrt0*(+0.0+g2_Vb2_c2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb2_c2*d10_sqrt0*g2_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vb2_c2_Vdt_GND=(g2_Vb2_c2_Vdt_GND/(1.0+d00_sqrt0)-(g2_Vb2_c2*g2_Vdt_GND*d10_sqrt0+g2_Vdt_GND*g2_Vb2_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vdt_GND*g2_Vb2_c2+d10_sqrt0*(+0.0+g2_Vb2_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vb2_c2*d10_sqrt0*g2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
pWex_Vc1_c2=((g2_Vc1_c2*(1.0+d00_sqrt0)-g2*g2_Vc1_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  pWex_Vc1_c2_Vb1_b2=(g2_Vc1_c2_Vb1_b2/(1.0+d00_sqrt0)-(g2_Vc1_c2*g2_Vb1_b2*d10_sqrt0+g2_Vb1_b2*g2_Vc1_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb1_b2*g2_Vc1_c2+d10_sqrt0*(+0.0+g2_Vc1_c2_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vc1_c2*d10_sqrt0*g2_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vc1_c2_Vb2_c2=(g2_Vc1_c2_Vb2_c2/(1.0+d00_sqrt0)-(g2_Vc1_c2*g2_Vb2_c2*d10_sqrt0+g2_Vb2_c2*g2_Vc1_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vb2_c2*g2_Vc1_c2+d10_sqrt0*(+0.0+g2_Vc1_c2_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vc1_c2*d10_sqrt0*g2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vc1_c2_Vc1_c2=(g2_Vc1_c2_Vc1_c2/(1.0+d00_sqrt0)-(g2_Vc1_c2*g2_Vc1_c2*d10_sqrt0+g2_Vc1_c2*g2_Vc1_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc1_c2*g2_Vc1_c2+d10_sqrt0*(+0.0+g2_Vc1_c2_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vc1_c2*d10_sqrt0*g2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vc1_c2_Vc4_c1=(g2_Vc1_c2_Vc4_c1/(1.0+d00_sqrt0)-(g2_Vc1_c2*g2_Vc4_c1*d10_sqrt0+g2_Vc4_c1*g2_Vc1_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vc4_c1*g2_Vc1_c2+d10_sqrt0*(+0.0+g2_Vc1_c2_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vc1_c2*d10_sqrt0*g2_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  pWex_Vc1_c2_Vdt_GND=(g2_Vc1_c2_Vdt_GND/(1.0+d00_sqrt0)-(g2_Vc1_c2*g2_Vdt_GND*d10_sqrt0+g2_Vdt_GND*g2_Vc1_c2*d10_sqrt0+g2*(+0.0+(m20_sqrt((1.0+g2))*g2_Vdt_GND*g2_Vc1_c2+d10_sqrt0*(+0.0+g2_Vc1_c2_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*g2*g2_Vc1_c2*d10_sqrt0*g2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
pWex_Vc4_c1=((g2_Vc4_c1*(1.0+d00_sqrt0)-g2*g2_Vc4_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
pWex_Vdt_GND=((g2_Vdt_GND*(1.0+d00_sqrt0)-g2*g2_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
pWex=(g2/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((g2/(1.0+d00_sqrt0)))
}
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Iex_Vdt_GND=((((IK_TM_Vdt_GND*nBex)+(IK_TM*nBex_Vdt_GND))*(2.0*BRI_T)-(IK_TM*nBex)*(2.0*BRI_T_Vdt_GND))/(2.0*BRI_T)/(2.0*BRI_T));
#endif
Iex_Vb1_b2=((IK_TM*nBex_Vb1_b2)/(2.0*BRI_T));
#if defined(_DERIVATE2)
  Iex_Vb1_b2_Vdt_GND=((+0.0*nBex+0.0*nBex_Vdt_GND+IK_TM_Vdt_GND*nBex_Vb1_b2+IK_TM*nBex_Vb1_b2_Vdt_GND)/(2.0*BRI_T)-((IK_TM*nBex_Vb1_b2)*((2.0*BRI_T_Vdt_GND))+(((IK_TM_Vdt_GND*nBex)+(IK_TM*nBex_Vdt_GND)))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*BRI_T_Vdt_GND+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*((2.0*BRI_T_Vdt_GND))/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb1_b2_Vb1_b2=((+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vb1_b2+IK_TM*nBex_Vb1_b2_Vb1_b2)/(2.0*BRI_T)-((IK_TM*nBex_Vb1_b2)*(0.0)+((IK_TM*nBex_Vb1_b2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb1_b2_Vb2_c2=((+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vb1_b2+IK_TM*nBex_Vb1_b2_Vb2_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vb1_b2)*(0.0)+((IK_TM*nBex_Vb2_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb1_b2_Vc1_c2=((+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vb1_b2+IK_TM*nBex_Vb1_b2_Vc1_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vb1_b2)*(0.0)+((IK_TM*nBex_Vc1_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb1_b2_Vc4_c1=((+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vb1_b2+IK_TM*nBex_Vb1_b2_Vc4_c1)/(2.0*BRI_T)-((IK_TM*nBex_Vb1_b2)*(0.0)+((IK_TM*nBex_Vc4_c1))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
#endif
Iex_Vb2_c2=((IK_TM*nBex_Vb2_c2)/(2.0*BRI_T));
#if defined(_DERIVATE2)
  Iex_Vb2_c2_Vdt_GND=((+0.0*nBex+0.0*nBex_Vdt_GND+IK_TM_Vdt_GND*nBex_Vb2_c2+IK_TM*nBex_Vb2_c2_Vdt_GND)/(2.0*BRI_T)-((IK_TM*nBex_Vb2_c2)*((2.0*BRI_T_Vdt_GND))+(((IK_TM_Vdt_GND*nBex)+(IK_TM*nBex_Vdt_GND)))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*BRI_T_Vdt_GND+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*((2.0*BRI_T_Vdt_GND))/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb2_c2_Vb1_b2=((+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vb2_c2+IK_TM*nBex_Vb2_c2_Vb1_b2)/(2.0*BRI_T)-((IK_TM*nBex_Vb2_c2)*(0.0)+((IK_TM*nBex_Vb1_b2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb2_c2_Vb2_c2=((+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vb2_c2+IK_TM*nBex_Vb2_c2_Vb2_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vb2_c2)*(0.0)+((IK_TM*nBex_Vb2_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb2_c2_Vc1_c2=((+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vb2_c2+IK_TM*nBex_Vb2_c2_Vc1_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vb2_c2)*(0.0)+((IK_TM*nBex_Vc1_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vb2_c2_Vc4_c1=((+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vb2_c2+IK_TM*nBex_Vb2_c2_Vc4_c1)/(2.0*BRI_T)-((IK_TM*nBex_Vb2_c2)*(0.0)+((IK_TM*nBex_Vc4_c1))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
#endif
Iex_Vc1_c2=((IK_TM*nBex_Vc1_c2)/(2.0*BRI_T));
#if defined(_DERIVATE2)
  Iex_Vc1_c2_Vdt_GND=((+0.0*nBex+0.0*nBex_Vdt_GND+IK_TM_Vdt_GND*nBex_Vc1_c2+IK_TM*nBex_Vc1_c2_Vdt_GND)/(2.0*BRI_T)-((IK_TM*nBex_Vc1_c2)*((2.0*BRI_T_Vdt_GND))+(((IK_TM_Vdt_GND*nBex)+(IK_TM*nBex_Vdt_GND)))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*BRI_T_Vdt_GND+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*((2.0*BRI_T_Vdt_GND))/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vc1_c2_Vb1_b2=((+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vc1_c2+IK_TM*nBex_Vc1_c2_Vb1_b2)/(2.0*BRI_T)-((IK_TM*nBex_Vc1_c2)*(0.0)+((IK_TM*nBex_Vb1_b2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vc1_c2_Vb2_c2=((+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vc1_c2+IK_TM*nBex_Vc1_c2_Vb2_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vc1_c2)*(0.0)+((IK_TM*nBex_Vb2_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vc1_c2_Vc1_c2=((+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vc1_c2+IK_TM*nBex_Vc1_c2_Vc1_c2)/(2.0*BRI_T)-((IK_TM*nBex_Vc1_c2)*(0.0)+((IK_TM*nBex_Vc1_c2))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
  Iex_Vc1_c2_Vc4_c1=((+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vc1_c2+IK_TM*nBex_Vc1_c2_Vc4_c1)/(2.0*BRI_T)-((IK_TM*nBex_Vc1_c2)*(0.0)+((IK_TM*nBex_Vc4_c1))*0.0+(IK_TM*nBex)*(+0.0*BRI_T+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*BRI_T)/(2.0*BRI_T)+2*(IK_TM*nBex)*0.0*(0.0)/(2.0*BRI_T)/(2.0*BRI_T)/(2.0*BRI_T));
#endif
#if defined(_DERIVATE)
Iex_Vc4_c1=((IK_TM*nBex_Vc4_c1)/(2.0*BRI_T));
#endif
#endif
pInst->Iex=((IK_TM*nBex)/(2.0*BRI_T));
EXIT_IF_ISNAN(((IK_TM*nBex)/(2.0*BRI_T)))
if
((pModel->EXSUB==1.0))
{
{
double m00_sqrt(d00_sqrt0,(1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(s,c1) ddxprobe=V(b1,GND) */
#if defined(_DERIVATE)
Isub_Vdt_GND=(((((2.0*ISS_TM_Vdt_GND)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*(eVb1c4_Vdt_GND-eVsc4_Vdt_GND)))*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*(((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND))*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
Isub_Vb1_b2=((((2.0*ISS_TM)*eVb1c4_Vb1_b2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  Isub_Vb1_b2_Vdt_GND=((+(+0.0*ISS_TM+0.0*ISS_TM_Vdt_GND+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*(eVb1c4_Vdt_GND-eVsc4_Vdt_GND)+((2.0*ISS_TM_Vdt_GND))*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vdt_GND-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*d10_sqrt0+(((((2.0*ISS_TM_Vdt_GND))*(eVb1c4-eVsc4))+((2.0*ISS_TM)*(eVb1c4_Vdt_GND-eVsc4_Vdt_GND))))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*IKS_TM_Vdt_GND+IS_TM_Vdt_GND*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*IKS_TM_Vdt_GND/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vdt_GND+((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vb1_b2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*eVb1c4_Vb1_b2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vb1_b2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*d10_sqrt0+((((0.0)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*eVb1c4_Vb1_b2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vb1_b2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vb2_c2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*eVb1c4_Vb2_c2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vb2_c2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*d10_sqrt0+((((0.0)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*eVb1c4_Vb2_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vb2_c2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vc1_c2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*eVb1c4_Vc1_c2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vc1_c2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*d10_sqrt0+((((0.0)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*eVb1c4_Vc1_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vc1_c2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vc4_c1=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*(eVb1c4_Vc4_c1-eVsc4_Vc4_c1)+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vc4_c1-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*d10_sqrt0+((((0.0)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*(eVb1c4_Vc4_c1-eVsc4_Vc4_c1))))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vc4_c1+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vs_c1=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-eVsc4)+0.0*(-eVsc4_Vs_c1)+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((0.0)*eVb1c4)*d10_sqrt0+((((0.0)*(eVb1c4-eVsc4))+((2.0*ISS_TM)*(-eVsc4_Vs_c1))))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-eVsc4))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((0.0)*eVb1c4)*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*0.0+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((0.0)*eVb1c4)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vb2_c2=((((2.0*ISS_TM)*eVb1c4_Vb2_c2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vc1_c2=((((2.0*ISS_TM)*eVb1c4_Vc1_c2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vc4_c1=((((2.0*ISS_TM)*(eVb1c4_Vc4_c1-eVsc4_Vc4_c1))*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-eVsc4))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vs_c1=(((2.0*ISS_TM)*(-eVsc4_Vs_c1))/(1.0+d00_sqrt0));
#endif
#endif
pInst->Isub=(((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((((2.0*ISS_TM)*(eVb1c4-eVsc4))/(1.0+d00_sqrt0)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(s,c1) ddxprobe=V(b1,GND) */
#if defined(_DERIVATE)
Isub_Vdt_GND=(((((2.0*ISS_TM_Vdt_GND)*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vdt_GND))*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-1.0))*(((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND))*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
Isub_Vb1_b2=((((2.0*ISS_TM)*eVb1c4_Vb1_b2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  Isub_Vb1_b2_Vdt_GND=((+(+0.0*ISS_TM+0.0*ISS_TM_Vdt_GND+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*eVb1c4_Vdt_GND+((2.0*ISS_TM_Vdt_GND))*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vdt_GND-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*d10_sqrt0+(((((2.0*ISS_TM_Vdt_GND))*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vdt_GND)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*IKS_TM_Vdt_GND+IS_TM_Vdt_GND*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*IKS_TM_Vdt_GND/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vdt_GND+((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*(((((4.0*((IS_TM_Vdt_GND*IKS_TM-IS_TM*IKS_TM_Vdt_GND)/IKS_TM/IKS_TM)))*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vb1_b2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*eVb1c4_Vb1_b2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vb1_b2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*d10_sqrt0+((((0.0)*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vb1_b2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vb1_b2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vb2_c2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*eVb1c4_Vb2_c2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vb2_c2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*d10_sqrt0+((((0.0)*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vb2_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vb2_c2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vc1_c2=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*eVb1c4_Vc1_c2+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vc1_c2-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*d10_sqrt0+((((0.0)*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vc1_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vc1_c2+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vc4_c1=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*eVb1c4_Vc4_c1+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+eVb1c4_Vb1_b2_Vc4_c1-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*d10_sqrt0+((((0.0)*(eVb1c4-1.0))+((2.0*ISS_TM)*eVb1c4_Vc4_c1)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*eVb1c4_Vc4_c1+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((((0.0)*eVb1c4)+((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  Isub_Vb1_b2_Vs_c1=((+(+0.0*ISS_TM+0.0*0.0+0.0*0.0+2.0*0.0)*(eVb1c4-1.0)+0.0*0.0+(0.0)*eVb1c4_Vb1_b2+(2.0*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-(((2.0*ISS_TM)*eVb1c4_Vb1_b2)*((0.0)*eVb1c4)*d10_sqrt0+((0.0)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0+((2.0*ISS_TM)*(eVb1c4-1.0))*(+0.0+(m20_sqrt((1.0+((4.0*(IS_TM/IKS_TM))*eVb1c4)))*((0.0)*eVb1c4)*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)+d10_sqrt0*(+0.0+(+(+0.0*(IS_TM/IKS_TM)+0.0*0.0+0.0*0.0+4.0*(0.0/IKS_TM-(0.0*0.0+0.0*0.0+IS_TM*0.0)/IKS_TM/IKS_TM+2*IS_TM*0.0*0.0/IKS_TM/IKS_TM/IKS_TM))*eVb1c4+0.0*0.0+(0.0)*eVb1c4_Vb1_b2+(4.0*(IS_TM/IKS_TM))*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb1_b2)*d10_sqrt0*((0.0)*eVb1c4)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vb2_c2=((((2.0*ISS_TM)*eVb1c4_Vb2_c2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vb2_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vc1_c2=((((2.0*ISS_TM)*eVb1c4_Vc1_c2)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc1_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vc4_c1=((((2.0*ISS_TM)*eVb1c4_Vc4_c1)*(1.0+d00_sqrt0)-((2.0*ISS_TM)*(eVb1c4-1.0))*((4.0*(IS_TM/IKS_TM))*eVb1c4_Vc4_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
Isub_Vs_c1=0.0;
#endif
#endif
pInst->Isub=(((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((((2.0*ISS_TM)*(eVb1c4-1.0))/(1.0+d00_sqrt0)))
}
}
if
((pModel->ICSS<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(s,c1) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
Isf_Vdt_GND=((ISS_TM_Vdt_GND*(eVsc1-1.0))+(ISS_TM*eVsc1_Vdt_GND));
#endif
Isf_Vs_c1=(ISS_TM*eVsc1_Vs_c1);
#if defined(_DERIVATE2)
  Isf_Vs_c1_Vdt_GND=(+0.0*(eVsc1-1.0)+0.0*eVsc1_Vdt_GND+ISS_TM_Vdt_GND*eVsc1_Vs_c1+ISS_TM*(+eVsc1_Vs_c1_Vdt_GND-0.0));
  Isf_Vs_c1_Vs_c1=(+0.0*(eVsc1-1.0)+0.0*eVsc1_Vs_c1+0.0*eVsc1_Vs_c1+ISS_TM*(+eVsc1_Vs_c1_Vs_c1-0.0));
#endif
#endif
Isf=(ISS_TM*(eVsc1-1.0));
EXIT_IF_ISNAN((ISS_TM*(eVsc1-1.0)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(s,c1) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
Isf_Vdt_GND=((ICSS_TM_Vdt_GND*(eVsc1-1.0))+(ICSS_TM*eVsc1_Vdt_GND));
#endif
Isf_Vs_c1=(ICSS_TM*eVsc1_Vs_c1);
#if defined(_DERIVATE2)
  Isf_Vs_c1_Vdt_GND=(+0.0*(eVsc1-1.0)+0.0*eVsc1_Vdt_GND+ICSS_TM_Vdt_GND*eVsc1_Vs_c1+ICSS_TM*(+eVsc1_Vs_c1_Vdt_GND-0.0));
  Isf_Vs_c1_Vs_c1=(+0.0*(eVsc1-1.0)+0.0*eVsc1_Vs_c1+0.0*eVsc1_Vs_c1+ICSS_TM*(+eVsc1_Vs_c1_Vs_c1-0.0));
#endif
#endif
Isf=(ICSS_TM*(eVsc1-1.0));
EXIT_IF_ISNAN((ICSS_TM*(eVsc1-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIex_Vdt_GND=0.0;
#endif
XIex_Vb_c=0.0;
#if defined(_DERIVATE2)
  XIex_Vb_c_Vdt_GND=0.0;
  XIex_Vb_c_Vb_c=0.0;
  XIex_Vb_c_Vb_b1=0.0;
  XIex_Vb_c_Vb1_b2=0.0;
  XIex_Vb_c_Vc4_c1=0.0;
  XIex_Vb_c_Vc3_c1=0.0;
  XIex_Vb_c_Vc3_c4=0.0;
  XIex_Vb_c_Vb2_e1=0.0;
  XIex_Vb_c_Vb2_c2=0.0;
  XIex_Vb_c_Vb2_c1=0.0;
  XIex_Vb_c_Vc1_c2=0.0;
  XIex_Vb_c_Vs_c1=0.0;
#endif
XIex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  XIex_Vb_b1_Vdt_GND=0.0;
  XIex_Vb_b1_Vb_c=0.0;
  XIex_Vb_b1_Vb_b1=0.0;
  XIex_Vb_b1_Vb1_b2=0.0;
  XIex_Vb_b1_Vc4_c1=0.0;
  XIex_Vb_b1_Vc3_c1=0.0;
  XIex_Vb_b1_Vc3_c4=0.0;
  XIex_Vb_b1_Vb2_e1=0.0;
  XIex_Vb_b1_Vb2_c2=0.0;
  XIex_Vb_b1_Vb2_c1=0.0;
  XIex_Vb_b1_Vc1_c2=0.0;
  XIex_Vb_b1_Vs_c1=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
XIex_Vs_c1=0.0;
#endif
#endif
pInst->XIex=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIsub_Vdt_GND=0.0;
#endif
XIsub_Vb_c=0.0;
#if defined(_DERIVATE2)
  XIsub_Vb_c_Vdt_GND=0.0;
  XIsub_Vb_c_Vb_c=0.0;
  XIsub_Vb_c_Vb_b1=0.0;
  XIsub_Vb_c_Vb1_b2=0.0;
  XIsub_Vb_c_Vc4_c1=0.0;
  XIsub_Vb_c_Vc3_c1=0.0;
  XIsub_Vb_c_Vc3_c4=0.0;
  XIsub_Vb_c_Vb2_e1=0.0;
  XIsub_Vb_c_Vb2_c2=0.0;
  XIsub_Vb_c_Vb2_c1=0.0;
  XIsub_Vb_c_Vc1_c2=0.0;
  XIsub_Vb_c_Vs_c1=0.0;
#endif
XIsub_Vb_b1=0.0;
#if defined(_DERIVATE2)
  XIsub_Vb_b1_Vdt_GND=0.0;
  XIsub_Vb_b1_Vb_c=0.0;
  XIsub_Vb_b1_Vb_b1=0.0;
  XIsub_Vb_b1_Vb1_b2=0.0;
  XIsub_Vb_b1_Vc4_c1=0.0;
  XIsub_Vb_b1_Vc3_c1=0.0;
  XIsub_Vb_b1_Vc3_c4=0.0;
  XIsub_Vb_b1_Vb2_e1=0.0;
  XIsub_Vb_b1_Vb2_c2=0.0;
  XIsub_Vb_b1_Vb2_c1=0.0;
  XIsub_Vb_b1_Vc1_c2=0.0;
  XIsub_Vb_b1_Vs_c1=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
XIsub_Vs_c1=0.0;
#endif
#endif
pInst->XIsub=0.0;
EXIT_IF_ISNAN(0.0)
if
(((pModel->EXMOD==1)||(pModel->EXMOD==2)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Iex_Vdt_GND=Iex_Vdt_GND*Xext1;
#endif
Iex_Vb1_b2=Iex_Vb1_b2*Xext1;
#if defined(_DERIVATE2)
  Iex_Vb1_b2_Vdt_GND=(+Iex_Vb1_b2_Vdt_GND*Xext1+Iex_Vb1_b2*0.0+Iex_Vdt_GND*0.0+pInst->Iex*0.0);
  Iex_Vb1_b2_Vb1_b2=(+Iex_Vb1_b2_Vb1_b2*Xext1+Iex_Vb1_b2*0.0+Iex_Vb1_b2*0.0+pInst->Iex*0.0);
  Iex_Vb1_b2_Vb2_c2=(+Iex_Vb1_b2_Vb2_c2*Xext1+Iex_Vb1_b2*0.0+Iex_Vb2_c2*0.0+pInst->Iex*0.0);
  Iex_Vb1_b2_Vc1_c2=(+Iex_Vb1_b2_Vc1_c2*Xext1+Iex_Vb1_b2*0.0+Iex_Vc1_c2*0.0+pInst->Iex*0.0);
  Iex_Vb1_b2_Vc4_c1=(+Iex_Vb1_b2_Vc4_c1*Xext1+Iex_Vb1_b2*0.0+Iex_Vc4_c1*0.0+pInst->Iex*0.0);
#endif
Iex_Vb2_c2=Iex_Vb2_c2*Xext1;
#if defined(_DERIVATE2)
  Iex_Vb2_c2_Vdt_GND=(+Iex_Vb2_c2_Vdt_GND*Xext1+Iex_Vb2_c2*0.0+Iex_Vdt_GND*0.0+pInst->Iex*0.0);
  Iex_Vb2_c2_Vb1_b2=(+Iex_Vb2_c2_Vb1_b2*Xext1+Iex_Vb2_c2*0.0+Iex_Vb1_b2*0.0+pInst->Iex*0.0);
  Iex_Vb2_c2_Vb2_c2=(+Iex_Vb2_c2_Vb2_c2*Xext1+Iex_Vb2_c2*0.0+Iex_Vb2_c2*0.0+pInst->Iex*0.0);
  Iex_Vb2_c2_Vc1_c2=(+Iex_Vb2_c2_Vc1_c2*Xext1+Iex_Vb2_c2*0.0+Iex_Vc1_c2*0.0+pInst->Iex*0.0);
  Iex_Vb2_c2_Vc4_c1=(+Iex_Vb2_c2_Vc4_c1*Xext1+Iex_Vb2_c2*0.0+Iex_Vc4_c1*0.0+pInst->Iex*0.0);
#endif
Iex_Vc1_c2=Iex_Vc1_c2*Xext1;
#if defined(_DERIVATE2)
  Iex_Vc1_c2_Vdt_GND=(+Iex_Vc1_c2_Vdt_GND*Xext1+Iex_Vc1_c2*0.0+Iex_Vdt_GND*0.0+pInst->Iex*0.0);
  Iex_Vc1_c2_Vb1_b2=(+Iex_Vc1_c2_Vb1_b2*Xext1+Iex_Vc1_c2*0.0+Iex_Vb1_b2*0.0+pInst->Iex*0.0);
  Iex_Vc1_c2_Vb2_c2=(+Iex_Vc1_c2_Vb2_c2*Xext1+Iex_Vc1_c2*0.0+Iex_Vb2_c2*0.0+pInst->Iex*0.0);
  Iex_Vc1_c2_Vc1_c2=(+Iex_Vc1_c2_Vc1_c2*Xext1+Iex_Vc1_c2*0.0+Iex_Vc1_c2*0.0+pInst->Iex*0.0);
  Iex_Vc1_c2_Vc4_c1=(+Iex_Vc1_c2_Vc4_c1*Xext1+Iex_Vc1_c2*0.0+Iex_Vc4_c1*0.0+pInst->Iex*0.0);
#endif
#if defined(_DERIVATE)
Iex_Vc4_c1=Iex_Vc4_c1*Xext1;
#endif
#endif
pInst->Iex=(pInst->Iex*Xext1);
EXIT_IF_ISNAN((pInst->Iex*Xext1))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(s,c1) ddxprobe=V(b1,GND) */
#if defined(_DERIVATE)
Isub_Vdt_GND=Isub_Vdt_GND*Xext1;
#endif
Isub_Vb1_b2=Isub_Vb1_b2*Xext1;
#if defined(_DERIVATE2)
  Isub_Vb1_b2_Vdt_GND=(+Isub_Vb1_b2_Vdt_GND*Xext1+Isub_Vb1_b2*0.0+Isub_Vdt_GND*0.0+pInst->Isub*0.0);
  Isub_Vb1_b2_Vb1_b2=(+Isub_Vb1_b2_Vb1_b2*Xext1+Isub_Vb1_b2*0.0+Isub_Vb1_b2*0.0+pInst->Isub*0.0);
  Isub_Vb1_b2_Vb2_c2=(+Isub_Vb1_b2_Vb2_c2*Xext1+Isub_Vb1_b2*0.0+Isub_Vb2_c2*0.0+pInst->Isub*0.0);
  Isub_Vb1_b2_Vc1_c2=(+Isub_Vb1_b2_Vc1_c2*Xext1+Isub_Vb1_b2*0.0+Isub_Vc1_c2*0.0+pInst->Isub*0.0);
  Isub_Vb1_b2_Vc4_c1=(+Isub_Vb1_b2_Vc4_c1*Xext1+Isub_Vb1_b2*0.0+Isub_Vc4_c1*0.0+pInst->Isub*0.0);
  Isub_Vb1_b2_Vs_c1=(+Isub_Vb1_b2_Vs_c1*Xext1+Isub_Vb1_b2*0.0+Isub_Vs_c1*0.0+pInst->Isub*0.0);
#endif
#if defined(_DERIVATE)
Isub_Vb2_c2=Isub_Vb2_c2*Xext1;
#endif
#if defined(_DERIVATE)
Isub_Vc1_c2=Isub_Vc1_c2*Xext1;
#endif
#if defined(_DERIVATE)
Isub_Vc4_c1=Isub_Vc4_c1*Xext1;
#endif
#if defined(_DERIVATE)
Isub_Vs_c1=Isub_Vs_c1*Xext1;
#endif
#endif
pInst->Isub=(pInst->Isub*Xext1);
EXIT_IF_ISNAN((pInst->Isub*Xext1))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
Xg1_Vdt_GND=((If0_Vdt_GND*eVbc3)+(If0*eVbc3_Vdt_GND));
#endif
Xg1_Vb_c=(If0*eVbc3_Vb_c);
#if defined(_DERIVATE2)
  Xg1_Vb_c_Vdt_GND=(+0.0*eVbc3+0.0*eVbc3_Vdt_GND+If0_Vdt_GND*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vdt_GND);
  Xg1_Vb_c_Vb_c=(+0.0*eVbc3+0.0*eVbc3_Vb_c+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vb_c);
  Xg1_Vb_c_Vb_b1=(+0.0*eVbc3+0.0*eVbc3_Vb_b1+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vb_b1);
  Xg1_Vb_c_Vb1_b2=(+0.0*eVbc3+0.0*eVbc3_Vb1_b2+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vb1_b2);
  Xg1_Vb_c_Vb2_c2=(+0.0*eVbc3+0.0*eVbc3_Vb2_c2+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vb2_c2);
  Xg1_Vb_c_Vc1_c2=(+0.0*eVbc3+0.0*eVbc3_Vc1_c2+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vc1_c2);
  Xg1_Vb_c_Vc4_c1=(+0.0*eVbc3+0.0*eVbc3_Vc4_c1+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vc4_c1);
  Xg1_Vb_c_Vc3_c1=(+0.0*eVbc3+0.0*eVbc3_Vc3_c1+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vc3_c1);
  Xg1_Vb_c_Vc3_c4=(+0.0*eVbc3+0.0*eVbc3_Vc3_c4+0.0*eVbc3_Vb_c+If0*eVbc3_Vb_c_Vc3_c4);
#endif
Xg1_Vb_b1=(If0*eVbc3_Vb_b1);
#if defined(_DERIVATE2)
  Xg1_Vb_b1_Vdt_GND=(+0.0*eVbc3+0.0*eVbc3_Vdt_GND+If0_Vdt_GND*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vdt_GND);
  Xg1_Vb_b1_Vb_c=(+0.0*eVbc3+0.0*eVbc3_Vb_c+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vb_c);
  Xg1_Vb_b1_Vb_b1=(+0.0*eVbc3+0.0*eVbc3_Vb_b1+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vb_b1);
  Xg1_Vb_b1_Vb1_b2=(+0.0*eVbc3+0.0*eVbc3_Vb1_b2+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vb1_b2);
  Xg1_Vb_b1_Vb2_c2=(+0.0*eVbc3+0.0*eVbc3_Vb2_c2+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vb2_c2);
  Xg1_Vb_b1_Vc1_c2=(+0.0*eVbc3+0.0*eVbc3_Vc1_c2+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vc1_c2);
  Xg1_Vb_b1_Vc4_c1=(+0.0*eVbc3+0.0*eVbc3_Vc4_c1+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vc4_c1);
  Xg1_Vb_b1_Vc3_c1=(+0.0*eVbc3+0.0*eVbc3_Vc3_c1+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vc3_c1);
  Xg1_Vb_b1_Vc3_c4=(+0.0*eVbc3+0.0*eVbc3_Vc3_c4+0.0*eVbc3_Vb_b1+If0*eVbc3_Vb_b1_Vc3_c4);
#endif
#if defined(_DERIVATE)
Xg1_Vb1_b2=(If0*eVbc3_Vb1_b2);
#endif
#if defined(_DERIVATE)
Xg1_Vb2_c2=(If0*eVbc3_Vb2_c2);
#endif
#if defined(_DERIVATE)
Xg1_Vc1_c2=(If0*eVbc3_Vc1_c2);
#endif
#if defined(_DERIVATE)
Xg1_Vc4_c1=(If0*eVbc3_Vc4_c1);
#endif
#if defined(_DERIVATE)
Xg1_Vc3_c1=(If0*eVbc3_Vc3_c1);
#endif
#if defined(_DERIVATE)
Xg1_Vc3_c4=(If0*eVbc3_Vc3_c4);
#endif
#endif
Xg1=(If0*eVbc3);
EXIT_IF_ISNAN((If0*eVbc3))
{
double m00_sqrt(d00_sqrt0,(1.0+Xg1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+Xg1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XnBex_Vdt_GND=(((Xg1_Vdt_GND-If0_Vdt_GND)*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XnBex_Vb_c=((Xg1_Vb_c*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vb_c*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XnBex_Vb_c_Vdt_GND=((+Xg1_Vb_c_Vdt_GND-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vdt_GND*d10_sqrt0+(Xg1_Vdt_GND-If0_Vdt_GND)*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vdt_GND*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vb_c=((+Xg1_Vb_c_Vb_c-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vb_c*d10_sqrt0+Xg1_Vb_c*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb_c*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vb_c))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vb_c*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vb_b1=((+Xg1_Vb_c_Vb_b1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vb_b1*d10_sqrt0+Xg1_Vb_b1*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb_b1*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vb_b1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vb_b1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vb1_b2=((+Xg1_Vb_c_Vb1_b2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vb1_b2*d10_sqrt0+Xg1_Vb1_b2*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb1_b2*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vb2_c2=((+Xg1_Vb_c_Vb2_c2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vb2_c2*d10_sqrt0+Xg1_Vb2_c2*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb2_c2*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vc1_c2=((+Xg1_Vb_c_Vc1_c2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vc1_c2*d10_sqrt0+Xg1_Vc1_c2*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc1_c2*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vc4_c1=((+Xg1_Vb_c_Vc4_c1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vc4_c1*d10_sqrt0+Xg1_Vc4_c1*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc4_c1*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vc3_c1=((+Xg1_Vb_c_Vc3_c1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vc3_c1*d10_sqrt0+Xg1_Vc3_c1*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc3_c1*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vc3_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vc3_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_c_Vc3_c4=((+Xg1_Vb_c_Vc3_c4-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_c*Xg1_Vc3_c4*d10_sqrt0+Xg1_Vc3_c4*Xg1_Vb_c*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc3_c4*Xg1_Vb_c+d10_sqrt0*(+0.0+Xg1_Vb_c_Vc3_c4))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_c*d10_sqrt0*Xg1_Vc3_c4*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XnBex_Vb_b1=((Xg1_Vb_b1*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XnBex_Vb_b1_Vdt_GND=((+Xg1_Vb_b1_Vdt_GND-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vdt_GND*d10_sqrt0+(Xg1_Vdt_GND-If0_Vdt_GND)*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vdt_GND*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vb_c=((+Xg1_Vb_b1_Vb_c-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vb_c*d10_sqrt0+Xg1_Vb_c*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb_c*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vb_c))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vb_c*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vb_b1=((+Xg1_Vb_b1_Vb_b1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vb_b1*d10_sqrt0+Xg1_Vb_b1*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb_b1*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vb_b1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vb_b1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vb1_b2=((+Xg1_Vb_b1_Vb1_b2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vb1_b2*d10_sqrt0+Xg1_Vb1_b2*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb1_b2*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vb2_c2=((+Xg1_Vb_b1_Vb2_c2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vb2_c2*d10_sqrt0+Xg1_Vb2_c2*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vb2_c2*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vc1_c2=((+Xg1_Vb_b1_Vc1_c2-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vc1_c2*d10_sqrt0+Xg1_Vc1_c2*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc1_c2*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vc4_c1=((+Xg1_Vb_b1_Vc4_c1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vc4_c1*d10_sqrt0+Xg1_Vc4_c1*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc4_c1*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vc3_c1=((+Xg1_Vb_b1_Vc3_c1-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vc3_c1*d10_sqrt0+Xg1_Vc3_c1*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc3_c1*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vc3_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vc3_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XnBex_Vb_b1_Vc3_c4=((+Xg1_Vb_b1_Vc3_c4-0.0)/(1.0+d00_sqrt0)-(Xg1_Vb_b1*Xg1_Vc3_c4*d10_sqrt0+Xg1_Vc3_c4*Xg1_Vb_b1*d10_sqrt0+(Xg1-If0)*(+0.0+(m20_sqrt((1.0+Xg1))*Xg1_Vc3_c4*Xg1_Vb_b1+d10_sqrt0*(+0.0+Xg1_Vb_b1_Vc3_c4))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(Xg1-If0)*Xg1_Vb_b1*d10_sqrt0*Xg1_Vc3_c4*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vb1_b2=((Xg1_Vb1_b2*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vb1_b2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vb2_c2=((Xg1_Vb2_c2*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vb2_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vc1_c2=((Xg1_Vc1_c2*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vc1_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vc4_c1=((Xg1_Vc4_c1*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vc4_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vc3_c1=((Xg1_Vc3_c1*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vc3_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XnBex_Vc3_c4=((Xg1_Vc3_c4*(1.0+d00_sqrt0)-(Xg1-If0)*Xg1_Vc3_c4*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
XnBex=((Xg1-If0)/(1.0+d00_sqrt0));
EXIT_IF_ISNAN(((Xg1-If0)/(1.0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIMex_Vdt_GND=((((((pModel->XEXT*0.5)*IK_TM_Vdt_GND)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vdt_GND))*BRI_T-(((pModel->XEXT*0.5)*IK_TM)*XnBex)*BRI_T_Vdt_GND)/BRI_T/BRI_T);
#endif
XIMex_Vb_c=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)/BRI_T);
#if defined(_DERIVATE2)
  XIMex_Vb_c_Vdt_GND=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*IK_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vdt_GND+((((0.0)*IK_TM)+((pModel->XEXT*0.5)*IK_TM_Vdt_GND)))*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vdt_GND)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*BRI_T_Vdt_GND+(((((((0.0)*IK_TM)+((pModel->XEXT*0.5)*IK_TM_Vdt_GND)))*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vdt_GND)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*BRI_T_Vdt_GND/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vb_c=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb_c+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vb_c)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vb_b1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb_b1+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vb_b1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vb1_b2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb1_b2+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vb1_b2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb1_b2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vb2_c2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb2_c2+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vb2_c2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb2_c2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vc1_c2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc1_c2+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vc1_c2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc1_c2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vc4_c1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc4_c1+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vc4_c1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc4_c1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vc3_c1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc3_c1+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vc3_c1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_c_Vc3_c4=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc3_c4+((0.0)*IK_TM)*XnBex_Vb_c+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c_Vc3_c4)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c4)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
#endif
XIMex_Vb_b1=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)/BRI_T);
#if defined(_DERIVATE2)
  XIMex_Vb_b1_Vdt_GND=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*IK_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vdt_GND+((((0.0)*IK_TM)+((pModel->XEXT*0.5)*IK_TM_Vdt_GND)))*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vdt_GND)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*BRI_T_Vdt_GND+(((((((0.0)*IK_TM)+((pModel->XEXT*0.5)*IK_TM_Vdt_GND)))*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vdt_GND)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*BRI_T_Vdt_GND/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vb_c=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb_c+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vb_c)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_c)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vb_b1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb_b1+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vb_b1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vb1_b2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb1_b2+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vb1_b2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb1_b2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vb2_c2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vb2_c2+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vb2_c2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb2_c2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vc1_c2=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc1_c2+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vc1_c2)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc1_c2)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vc4_c1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc4_c1+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vc4_c1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc4_c1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vc3_c1=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc3_c1+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vc3_c1)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c1)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
  XIMex_Vb_b1_Vc3_c4=((+(+(+0.0*0.5+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*IK_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*0.5)*0.0)*XnBex+0.0*XnBex_Vc3_c4+((0.0)*IK_TM)*XnBex_Vb_b1+((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1_Vc3_c4)/BRI_T-((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb_b1)*0.0+(((((0.0)*IK_TM)*XnBex)+(((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c4)))*0.0+(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0)/BRI_T/BRI_T+2*(((pModel->XEXT*0.5)*IK_TM)*XnBex)*0.0*0.0/BRI_T/BRI_T/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vb1_b2=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb1_b2)/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vb2_c2=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vb2_c2)/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vc1_c2=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc1_c2)/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vc4_c1=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc4_c1)/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vc3_c1=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c1)/BRI_T);
#endif
#if defined(_DERIVATE)
XIMex_Vc3_c4=((((pModel->XEXT*0.5)*IK_TM)*XnBex_Vc3_c4)/BRI_T);
#endif
#endif
XIMex=((((pModel->XEXT*0.5)*IK_TM)*XnBex)/BRI_T);
EXIT_IF_ISNAN(((((pModel->XEXT*0.5)*IK_TM)*XnBex)/BRI_T))
if
((pModel->EXSUB==1.0))
{
{
double m00_sqrt(d00_sqrt0,(1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIMsub_Vdt_GND=((((((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vdt_GND-eVsc3_Vdt_GND)))*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((((4.0*IS_T_Vdt_GND)*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND))*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XIMsub_Vb_c=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XIMsub_Vb_c_Vdt_GND=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*ISS_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vdt_GND-eVsc3_Vdt_GND)+((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vdt_GND-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0+(((((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vdt_GND-eVsc3_Vdt_GND))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*IS_T_Vdt_GND+0.0*0.0+4.0*0.0)/IKS_T-(0.0*IKS_T_Vdt_GND+((4.0*IS_T_Vdt_GND))*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*IKS_T_Vdt_GND/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vdt_GND+((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb_c=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb_c+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb_c-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_c+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb_c)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb_b1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb_b1+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb_b1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_b1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb_b1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb1_b2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb1_b2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb1_b2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb1_b2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb2_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb2_c2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb2_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb2_c2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc1_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vc1_c2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc1_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc1_c2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc4_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc4_c1-eVsc3_Vc4_c1)+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc4_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc4_c1-eVsc3_Vc4_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc4_c1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc3_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc3_c1-eVsc3_Vc3_c1)+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc3_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c1-eVsc3_Vc3_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc3_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc3_c4=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc3_c4-eVsc3_Vc3_c4)+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc3_c4-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c4-eVsc3_Vc3_c4))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c4+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc3_c4)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vs_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(-eVsc3_Vs_c1)+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(-eVsc3_Vs_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((0.0)/IKS_T)*eVbc3)*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*0.0+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XIMsub_Vb_b1=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XIMsub_Vb_b1_Vdt_GND=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*ISS_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vdt_GND-eVsc3_Vdt_GND)+((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vdt_GND-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0+(((((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vdt_GND-eVsc3_Vdt_GND))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*IS_T_Vdt_GND+0.0*0.0+4.0*0.0)/IKS_T-(0.0*IKS_T_Vdt_GND+((4.0*IS_T_Vdt_GND))*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*IKS_T_Vdt_GND/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vdt_GND+((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb_c=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb_c+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb_c-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_c+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb_c)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb_b1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb_b1+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb_b1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_b1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb_b1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb1_b2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb1_b2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb1_b2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb1_b2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb2_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vb2_c2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb2_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb2_c2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc1_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*eVbc3_Vc1_c2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc1_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc1_c2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc4_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc4_c1-eVsc3_Vc4_c1)+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc4_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc4_c1-eVsc3_Vc4_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc4_c1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc3_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc3_c1-eVsc3_Vc3_c1)+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc3_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c1-eVsc3_Vc3_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc3_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc3_c4=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(eVbc3_Vc3_c4-eVsc3_Vc3_c4)+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc3_c4-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c4-eVsc3_Vc3_c4))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c4+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc3_c4)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vs_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-eVsc3)+0.0*(-eVsc3_Vs_c1)+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-eVsc3))+(((pModel->XEXT*2.0)*ISS_TM)*(-eVsc3_Vs_c1))))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((0.0)/IKS_T)*eVbc3)*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*0.0+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vb1_b2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vb2_c2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc1_c2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc4_c1=(((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc4_c1-eVsc3_Vc4_c1))*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc3_c1=(((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c1-eVsc3_Vc3_c1))*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc3_c4=(((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3_Vc3_c4-eVsc3_Vc3_c4))*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vs_c1=((((pModel->XEXT*2.0)*ISS_TM)*(-eVsc3_Vs_c1))/(1.0+d00_sqrt0));
#endif
#endif
XIMsub=((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+d00_sqrt0));
EXIT_IF_ISNAN(((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-eVsc3))/(1.0+d00_sqrt0)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIMsub_Vdt_GND=((((((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vdt_GND))*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((((4.0*IS_T_Vdt_GND)*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND))*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XIMsub_Vb_c=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XIMsub_Vb_c_Vdt_GND=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*ISS_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vdt_GND+((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vdt_GND-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0+(((((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*IS_T_Vdt_GND+0.0*0.0+4.0*0.0)/IKS_T-(0.0*IKS_T_Vdt_GND+((4.0*IS_T_Vdt_GND))*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*IKS_T_Vdt_GND/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vdt_GND+((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb_c=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb_c+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb_c-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_c+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb_c)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb_b1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb_b1+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb_b1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_b1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb_b1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb1_b2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb1_b2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb1_b2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb1_b2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vb2_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb2_c2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vb2_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb2_c2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc1_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc1_c2+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc1_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc1_c2+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc4_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc4_c1+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc4_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc4_c1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc3_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc3_c1+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc3_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c1+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc3_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vc3_c4=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc3_c4+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_c_Vc3_c4-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c4+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*eVbc3_Vb_c_Vc3_c4)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_c_Vs_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*0.0+((0.0)*ISS_TM)*eVbc3_Vb_c+((pModel->XEXT*2.0)*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0+(((0.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((0.0)/IKS_T)*eVbc3)*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*0.0+((0.0)/IKS_T)*eVbc3_Vb_c+((4.0*IS_T)/IKS_T)*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)*d10_sqrt0*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XIMsub_Vb_b1=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XIMsub_Vb_b1_Vdt_GND=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*ISS_TM_Vdt_GND+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vdt_GND+((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vdt_GND-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0+(((((((0.0)*ISS_TM)+((pModel->XEXT*2.0)*ISS_TM_Vdt_GND)))*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*IS_T_Vdt_GND+0.0*0.0+4.0*0.0)/IKS_T-(0.0*IKS_T_Vdt_GND+((4.0*IS_T_Vdt_GND))*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*IKS_T_Vdt_GND/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vdt_GND+((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vdt_GND)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((((4.0*IS_T_Vdt_GND))*IKS_T-(4.0*IS_T)*IKS_T_Vdt_GND)/IKS_T/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vdt_GND)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb_c=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb_c+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb_c-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_c+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb_c)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_c)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb_b1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb_b1+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb_b1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb_b1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb_b1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb1_b2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb1_b2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb1_b2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb1_b2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb1_b2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vb2_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vb2_c2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vb2_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vb2_c2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vb2_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc1_c2=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc1_c2+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc1_c2-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc1_c2+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc1_c2)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc4_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc4_c1+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc4_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc4_c1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc4_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc3_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc3_c1+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc3_c1-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c1+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc3_c1)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vc3_c4=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*eVbc3_Vc3_c4+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+eVbc3_Vb_b1_Vc3_c4-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0+(((((0.0)*ISS_TM)*(eVbc3-1.0))+(((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*eVbc3_Vc3_c4+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1_Vc3_c4)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((((0.0)/IKS_T)*eVbc3)+(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)))*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XIMsub_Vb_b1_Vs_c1=((+(+(+0.0*2.0+0.0*0.0+0.0*0.0+pModel->XEXT*0.0)*ISS_TM+0.0*0.0+(0.0)*0.0+(pModel->XEXT*2.0)*0.0)*(eVbc3-1.0)+0.0*0.0+((0.0)*ISS_TM)*eVbc3_Vb_b1+((pModel->XEXT*2.0)*ISS_TM)*(+0.0-0.0))/(1.0+d00_sqrt0)-((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb_b1)*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0+(((0.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0+(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(+0.0+(m20_sqrt((1.0+(((4.0*IS_T)/IKS_T)*eVbc3)))*(((0.0)/IKS_T)*eVbc3)*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)+d10_sqrt0*(+0.0+(+((+0.0*IS_T+0.0*0.0+0.0*0.0+4.0*0.0)/IKS_T-(0.0*0.0+(0.0)*0.0+(4.0*IS_T)*0.0)/IKS_T/IKS_T+2*(4.0*IS_T)*0.0*0.0/IKS_T/IKS_T/IKS_T)*eVbc3+0.0*0.0+((0.0)/IKS_T)*eVbc3_Vb_b1+((4.0*IS_T)/IKS_T)*0.0)))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb_b1)*d10_sqrt0*(((0.0)/IKS_T)*eVbc3)*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vb1_b2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb1_b2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb1_b2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vb2_c2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vb2_c2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vb2_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc1_c2=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc1_c2)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc1_c2)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc4_c1=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc4_c1)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc4_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc3_c1=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c1)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c1)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vc3_c4=(((((pModel->XEXT*2.0)*ISS_TM)*eVbc3_Vc3_c4)*(1.0+d00_sqrt0)-(((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))*(((4.0*IS_T)/IKS_T)*eVbc3_Vc3_c4)*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XIMsub_Vs_c1=0.0;
#endif
#endif
XIMsub=((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+d00_sqrt0));
EXIT_IF_ISNAN(((((pModel->XEXT*2.0)*ISS_TM)*(eVbc3-1.0))/(1.0+d00_sqrt0)))
}
}
if
((pModel->EXMOD==1))
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND)V(b,GND) */
Vex_bias_Vdt_GND=(((pModel->XEXT*(((IS_TM_Vdt_GND*BRI_T-IS_TM*BRI_T_Vdt_GND)/BRI_T/BRI_T)+ISS_TM_Vdt_GND))*RCCxx_TM)+((pModel->XEXT*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM_Vdt_GND));
#endif
Vex_bias=((pModel->XEXT*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM);
EXIT_IF_ISNAN(((pModel->XEXT*((IS_TM/BRI_T)+ISS_TM))*RCCxx_TM))
{
double m00_logE(d00_logE0,(Vex_bias*VtINV))
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,(Vex_bias*VtINV))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
Vex_Vdt_GND=((Vt_Vdt_GND*(2.0-d00_logE0))+(Vt*(-((Vex_bias_Vdt_GND*VtINV)+(Vex_bias*VtINV_Vdt_GND))*d10_logE0)));
#endif
Vex=(Vt*(2.0-d00_logE0));
EXIT_IF_ISNAN((Vt*(2.0-d00_logE0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND)V(b,GND) */
vdif_Vb_c=Vbc3_Vb_c;
#if defined(_DERIVATE2)
  vdif_Vb_c_Vb_c=(+Vbc3_Vb_c_Vb_c-0.0);
  vdif_Vb_c_Vb_b1=(+Vbc3_Vb_c_Vb_b1-0.0);
  vdif_Vb_c_Vb1_b2=(+Vbc3_Vb_c_Vb1_b2-0.0);
  vdif_Vb_c_Vb2_c2=(+Vbc3_Vb_c_Vb2_c2-0.0);
  vdif_Vb_c_Vc1_c2=(+Vbc3_Vb_c_Vc1_c2-0.0);
  vdif_Vb_c_Vc4_c1=(+Vbc3_Vb_c_Vc4_c1-0.0);
  vdif_Vb_c_Vc3_c1=(+Vbc3_Vb_c_Vc3_c1-0.0);
  vdif_Vb_c_Vc3_c4=(+Vbc3_Vb_c_Vc3_c4-0.0);
  vdif_Vb_c_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vb_b1=Vbc3_Vb_b1;
#if defined(_DERIVATE2)
  vdif_Vb_b1_Vb_c=(+Vbc3_Vb_b1_Vb_c-0.0);
  vdif_Vb_b1_Vb_b1=(+Vbc3_Vb_b1_Vb_b1-0.0);
  vdif_Vb_b1_Vb1_b2=(+Vbc3_Vb_b1_Vb1_b2-0.0);
  vdif_Vb_b1_Vb2_c2=(+Vbc3_Vb_b1_Vb2_c2-0.0);
  vdif_Vb_b1_Vc1_c2=(+Vbc3_Vb_b1_Vc1_c2-0.0);
  vdif_Vb_b1_Vc4_c1=(+Vbc3_Vb_b1_Vc4_c1-0.0);
  vdif_Vb_b1_Vc3_c1=(+Vbc3_Vb_b1_Vc3_c1-0.0);
  vdif_Vb_b1_Vc3_c4=(+Vbc3_Vb_b1_Vc3_c4-0.0);
  vdif_Vb_b1_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vb1_b2=Vbc3_Vb1_b2;
#if defined(_DERIVATE2)
  vdif_Vb1_b2_Vb_c=(+Vbc3_Vb1_b2_Vb_c-0.0);
  vdif_Vb1_b2_Vb_b1=(+Vbc3_Vb1_b2_Vb_b1-0.0);
  vdif_Vb1_b2_Vb1_b2=(+Vbc3_Vb1_b2_Vb1_b2-0.0);
  vdif_Vb1_b2_Vb2_c2=(+Vbc3_Vb1_b2_Vb2_c2-0.0);
  vdif_Vb1_b2_Vc1_c2=(+Vbc3_Vb1_b2_Vc1_c2-0.0);
  vdif_Vb1_b2_Vc4_c1=(+Vbc3_Vb1_b2_Vc4_c1-0.0);
  vdif_Vb1_b2_Vc3_c1=(+Vbc3_Vb1_b2_Vc3_c1-0.0);
  vdif_Vb1_b2_Vc3_c4=(+Vbc3_Vb1_b2_Vc3_c4-0.0);
  vdif_Vb1_b2_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vb2_c2=Vbc3_Vb2_c2;
#if defined(_DERIVATE2)
  vdif_Vb2_c2_Vb_c=(+Vbc3_Vb2_c2_Vb_c-0.0);
  vdif_Vb2_c2_Vb_b1=(+Vbc3_Vb2_c2_Vb_b1-0.0);
  vdif_Vb2_c2_Vb1_b2=(+Vbc3_Vb2_c2_Vb1_b2-0.0);
  vdif_Vb2_c2_Vb2_c2=(+Vbc3_Vb2_c2_Vb2_c2-0.0);
  vdif_Vb2_c2_Vc1_c2=(+Vbc3_Vb2_c2_Vc1_c2-0.0);
  vdif_Vb2_c2_Vc4_c1=(+Vbc3_Vb2_c2_Vc4_c1-0.0);
  vdif_Vb2_c2_Vc3_c1=(+Vbc3_Vb2_c2_Vc3_c1-0.0);
  vdif_Vb2_c2_Vc3_c4=(+Vbc3_Vb2_c2_Vc3_c4-0.0);
  vdif_Vb2_c2_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vc1_c2=Vbc3_Vc1_c2;
#if defined(_DERIVATE2)
  vdif_Vc1_c2_Vb_c=(+Vbc3_Vc1_c2_Vb_c-0.0);
  vdif_Vc1_c2_Vb_b1=(+Vbc3_Vc1_c2_Vb_b1-0.0);
  vdif_Vc1_c2_Vb1_b2=(+Vbc3_Vc1_c2_Vb1_b2-0.0);
  vdif_Vc1_c2_Vb2_c2=(+Vbc3_Vc1_c2_Vb2_c2-0.0);
  vdif_Vc1_c2_Vc1_c2=(+Vbc3_Vc1_c2_Vc1_c2-0.0);
  vdif_Vc1_c2_Vc4_c1=(+Vbc3_Vc1_c2_Vc4_c1-0.0);
  vdif_Vc1_c2_Vc3_c1=(+Vbc3_Vc1_c2_Vc3_c1-0.0);
  vdif_Vc1_c2_Vc3_c4=(+Vbc3_Vc1_c2_Vc3_c4-0.0);
  vdif_Vc1_c2_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vc4_c1=Vbc3_Vc4_c1;
#if defined(_DERIVATE2)
  vdif_Vc4_c1_Vb_c=(+Vbc3_Vc4_c1_Vb_c-0.0);
  vdif_Vc4_c1_Vb_b1=(+Vbc3_Vc4_c1_Vb_b1-0.0);
  vdif_Vc4_c1_Vb1_b2=(+Vbc3_Vc4_c1_Vb1_b2-0.0);
  vdif_Vc4_c1_Vb2_c2=(+Vbc3_Vc4_c1_Vb2_c2-0.0);
  vdif_Vc4_c1_Vc1_c2=(+Vbc3_Vc4_c1_Vc1_c2-0.0);
  vdif_Vc4_c1_Vc4_c1=(+Vbc3_Vc4_c1_Vc4_c1-0.0);
  vdif_Vc4_c1_Vc3_c1=(+Vbc3_Vc4_c1_Vc3_c1-0.0);
  vdif_Vc4_c1_Vc3_c4=(+Vbc3_Vc4_c1_Vc3_c4-0.0);
  vdif_Vc4_c1_Vdt_GND=(+0.0-0.0);
#endif
vdif_Vc3_c1=Vbc3_Vc3_c1;
#if defined(_DERIVATE2)
  vdif_Vc3_c1_Vb_c=(+Vbc3_Vc3_c1_Vb_c-0.0);
  vdif_Vc3_c1_Vb_b1=(+Vbc3_Vc3_c1_Vb_b1-0.0);
  vdif_Vc3_c1_Vb1_b2=(+Vbc3_Vc3_c1_Vb1_b2-0.0);
  vdif_Vc3_c1_Vb2_c2=(+Vbc3_Vc3_c1_Vb2_c2-0.0);
  vdif_Vc3_c1_Vc1_c2=(+Vbc3_Vc3_c1_Vc1_c2-0.0);
  vdif_Vc3_c1_Vc4_c1=(+Vbc3_Vc3_c1_Vc4_c1-0.0);
  vdif_Vc3_c1_Vc3_c1=(+Vbc3_Vc3_c1_Vc3_c1-0.0);
  vdif_Vc3_c1_Vc3_c4=(+Vbc3_Vc3_c1_Vc3_c4-0.0);
  vdif_Vc3_c1_Vdt_GND=(+0.0-0.0);
#endif
#if defined(_DERIVATE)
vdif_Vc3_c4=Vbc3_Vc3_c4;
#endif
#if defined(_DERIVATE)
vdif_Vdt_GND=(-Vex_Vdt_GND);
#endif
#endif
vdif=(Vbc3-Vex);
EXIT_IF_ISNAN((Vbc3-Vex))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eps2_Vdt_GND=0.0;
#endif
eps2=(0.11*0.11);
EXIT_IF_ISNAN((0.11*0.11))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
x2_Vb_c=((vdif_Vb_c*vdif)+(vdif*vdif_Vb_c));
#if defined(_DERIVATE2)
  x2_Vb_c_Vb_c=(+vdif_Vb_c_Vb_c*vdif+vdif_Vb_c*vdif_Vb_c+vdif_Vb_c*vdif_Vb_c+vdif*vdif_Vb_c_Vb_c);
  x2_Vb_c_Vb_b1=(+vdif_Vb_c_Vb_b1*vdif+vdif_Vb_c*vdif_Vb_b1+vdif_Vb_b1*vdif_Vb_c+vdif*vdif_Vb_c_Vb_b1);
  x2_Vb_c_Vb1_b2=(+vdif_Vb_c_Vb1_b2*vdif+vdif_Vb_c*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vb_c+vdif*vdif_Vb_c_Vb1_b2);
  x2_Vb_c_Vc4_c1=(+vdif_Vb_c_Vc4_c1*vdif+vdif_Vb_c*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vb_c+vdif*vdif_Vb_c_Vc4_c1);
  x2_Vb_c_Vc3_c1=(+vdif_Vb_c_Vc3_c1*vdif+vdif_Vb_c*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vb_c+vdif*vdif_Vb_c_Vc3_c1);
  x2_Vb_c_Vc3_c4=(+vdif_Vb_c_Vc3_c4*vdif+vdif_Vb_c*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vb_c+vdif*vdif_Vb_c_Vc3_c4);
  x2_Vb_c_Vb2_e1=(+0.0*vdif+vdif_Vb_c*0.0+0.0*vdif_Vb_c+vdif*0.0);
  x2_Vb_c_Vdt_GND=(+vdif_Vb_c_Vdt_GND*vdif+vdif_Vb_c*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vb_c+vdif*vdif_Vb_c_Vdt_GND);
  x2_Vb_c_Vb2_c2=(+vdif_Vb_c_Vb2_c2*vdif+vdif_Vb_c*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vb_c+vdif*vdif_Vb_c_Vb2_c2);
  x2_Vb_c_Vb2_c1=(+0.0*vdif+vdif_Vb_c*0.0+0.0*vdif_Vb_c+vdif*0.0);
  x2_Vb_c_Vc1_c2=(+vdif_Vb_c_Vc1_c2*vdif+vdif_Vb_c*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vb_c+vdif*vdif_Vb_c_Vc1_c2);
#endif
x2_Vb_b1=((vdif_Vb_b1*vdif)+(vdif*vdif_Vb_b1));
#if defined(_DERIVATE2)
  x2_Vb_b1_Vb_c=(+vdif_Vb_b1_Vb_c*vdif+vdif_Vb_b1*vdif_Vb_c+vdif_Vb_c*vdif_Vb_b1+vdif*vdif_Vb_b1_Vb_c);
  x2_Vb_b1_Vb_b1=(+vdif_Vb_b1_Vb_b1*vdif+vdif_Vb_b1*vdif_Vb_b1+vdif_Vb_b1*vdif_Vb_b1+vdif*vdif_Vb_b1_Vb_b1);
  x2_Vb_b1_Vb1_b2=(+vdif_Vb_b1_Vb1_b2*vdif+vdif_Vb_b1*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vb_b1+vdif*vdif_Vb_b1_Vb1_b2);
  x2_Vb_b1_Vc4_c1=(+vdif_Vb_b1_Vc4_c1*vdif+vdif_Vb_b1*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vb_b1+vdif*vdif_Vb_b1_Vc4_c1);
  x2_Vb_b1_Vc3_c1=(+vdif_Vb_b1_Vc3_c1*vdif+vdif_Vb_b1*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vb_b1+vdif*vdif_Vb_b1_Vc3_c1);
  x2_Vb_b1_Vc3_c4=(+vdif_Vb_b1_Vc3_c4*vdif+vdif_Vb_b1*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vb_b1+vdif*vdif_Vb_b1_Vc3_c4);
  x2_Vb_b1_Vb2_e1=(+0.0*vdif+vdif_Vb_b1*0.0+0.0*vdif_Vb_b1+vdif*0.0);
  x2_Vb_b1_Vdt_GND=(+vdif_Vb_b1_Vdt_GND*vdif+vdif_Vb_b1*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vb_b1+vdif*vdif_Vb_b1_Vdt_GND);
  x2_Vb_b1_Vb2_c2=(+vdif_Vb_b1_Vb2_c2*vdif+vdif_Vb_b1*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vb_b1+vdif*vdif_Vb_b1_Vb2_c2);
  x2_Vb_b1_Vb2_c1=(+0.0*vdif+vdif_Vb_b1*0.0+0.0*vdif_Vb_b1+vdif*0.0);
  x2_Vb_b1_Vc1_c2=(+vdif_Vb_b1_Vc1_c2*vdif+vdif_Vb_b1*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vb_b1+vdif*vdif_Vb_b1_Vc1_c2);
#endif
x2_Vb1_b2=((vdif_Vb1_b2*vdif)+(vdif*vdif_Vb1_b2));
#if defined(_DERIVATE2)
  x2_Vb1_b2_Vb_c=(+vdif_Vb1_b2_Vb_c*vdif+vdif_Vb1_b2*vdif_Vb_c+vdif_Vb_c*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vb_c);
  x2_Vb1_b2_Vb_b1=(+vdif_Vb1_b2_Vb_b1*vdif+vdif_Vb1_b2*vdif_Vb_b1+vdif_Vb_b1*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vb_b1);
  x2_Vb1_b2_Vb1_b2=(+vdif_Vb1_b2_Vb1_b2*vdif+vdif_Vb1_b2*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vb1_b2);
  x2_Vb1_b2_Vc4_c1=(+vdif_Vb1_b2_Vc4_c1*vdif+vdif_Vb1_b2*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vc4_c1);
  x2_Vb1_b2_Vc3_c1=(+vdif_Vb1_b2_Vc3_c1*vdif+vdif_Vb1_b2*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vc3_c1);
  x2_Vb1_b2_Vc3_c4=(+vdif_Vb1_b2_Vc3_c4*vdif+vdif_Vb1_b2*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vc3_c4);
  x2_Vb1_b2_Vb2_e1=(+0.0*vdif+vdif_Vb1_b2*0.0+0.0*vdif_Vb1_b2+vdif*0.0);
  x2_Vb1_b2_Vdt_GND=(+vdif_Vb1_b2_Vdt_GND*vdif+vdif_Vb1_b2*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vdt_GND);
  x2_Vb1_b2_Vb2_c2=(+vdif_Vb1_b2_Vb2_c2*vdif+vdif_Vb1_b2*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vb2_c2);
  x2_Vb1_b2_Vb2_c1=(+0.0*vdif+vdif_Vb1_b2*0.0+0.0*vdif_Vb1_b2+vdif*0.0);
  x2_Vb1_b2_Vc1_c2=(+vdif_Vb1_b2_Vc1_c2*vdif+vdif_Vb1_b2*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vb1_b2+vdif*vdif_Vb1_b2_Vc1_c2);
#endif
x2_Vc4_c1=((vdif_Vc4_c1*vdif)+(vdif*vdif_Vc4_c1));
#if defined(_DERIVATE2)
  x2_Vc4_c1_Vb_c=(+vdif_Vc4_c1_Vb_c*vdif+vdif_Vc4_c1*vdif_Vb_c+vdif_Vb_c*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vb_c);
  x2_Vc4_c1_Vb_b1=(+vdif_Vc4_c1_Vb_b1*vdif+vdif_Vc4_c1*vdif_Vb_b1+vdif_Vb_b1*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vb_b1);
  x2_Vc4_c1_Vb1_b2=(+vdif_Vc4_c1_Vb1_b2*vdif+vdif_Vc4_c1*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vb1_b2);
  x2_Vc4_c1_Vc4_c1=(+vdif_Vc4_c1_Vc4_c1*vdif+vdif_Vc4_c1*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vc4_c1);
  x2_Vc4_c1_Vc3_c1=(+vdif_Vc4_c1_Vc3_c1*vdif+vdif_Vc4_c1*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vc3_c1);
  x2_Vc4_c1_Vc3_c4=(+vdif_Vc4_c1_Vc3_c4*vdif+vdif_Vc4_c1*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vc3_c4);
  x2_Vc4_c1_Vb2_e1=(+0.0*vdif+vdif_Vc4_c1*0.0+0.0*vdif_Vc4_c1+vdif*0.0);
  x2_Vc4_c1_Vdt_GND=(+vdif_Vc4_c1_Vdt_GND*vdif+vdif_Vc4_c1*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vdt_GND);
  x2_Vc4_c1_Vb2_c2=(+vdif_Vc4_c1_Vb2_c2*vdif+vdif_Vc4_c1*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vb2_c2);
  x2_Vc4_c1_Vb2_c1=(+0.0*vdif+vdif_Vc4_c1*0.0+0.0*vdif_Vc4_c1+vdif*0.0);
  x2_Vc4_c1_Vc1_c2=(+vdif_Vc4_c1_Vc1_c2*vdif+vdif_Vc4_c1*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vc4_c1+vdif*vdif_Vc4_c1_Vc1_c2);
#endif
x2_Vc3_c1=((vdif_Vc3_c1*vdif)+(vdif*vdif_Vc3_c1));
#if defined(_DERIVATE2)
  x2_Vc3_c1_Vb_c=(+vdif_Vc3_c1_Vb_c*vdif+vdif_Vc3_c1*vdif_Vb_c+vdif_Vb_c*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vb_c);
  x2_Vc3_c1_Vb_b1=(+vdif_Vc3_c1_Vb_b1*vdif+vdif_Vc3_c1*vdif_Vb_b1+vdif_Vb_b1*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vb_b1);
  x2_Vc3_c1_Vb1_b2=(+vdif_Vc3_c1_Vb1_b2*vdif+vdif_Vc3_c1*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vb1_b2);
  x2_Vc3_c1_Vc4_c1=(+vdif_Vc3_c1_Vc4_c1*vdif+vdif_Vc3_c1*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vc4_c1);
  x2_Vc3_c1_Vc3_c1=(+vdif_Vc3_c1_Vc3_c1*vdif+vdif_Vc3_c1*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vc3_c1);
  x2_Vc3_c1_Vc3_c4=(+vdif_Vc3_c1_Vc3_c4*vdif+vdif_Vc3_c1*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vc3_c4);
  x2_Vc3_c1_Vb2_e1=(+0.0*vdif+vdif_Vc3_c1*0.0+0.0*vdif_Vc3_c1+vdif*0.0);
  x2_Vc3_c1_Vdt_GND=(+vdif_Vc3_c1_Vdt_GND*vdif+vdif_Vc3_c1*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vdt_GND);
  x2_Vc3_c1_Vb2_c2=(+vdif_Vc3_c1_Vb2_c2*vdif+vdif_Vc3_c1*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vb2_c2);
  x2_Vc3_c1_Vb2_c1=(+0.0*vdif+vdif_Vc3_c1*0.0+0.0*vdif_Vc3_c1+vdif*0.0);
  x2_Vc3_c1_Vc1_c2=(+vdif_Vc3_c1_Vc1_c2*vdif+vdif_Vc3_c1*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vc3_c1+vdif*vdif_Vc3_c1_Vc1_c2);
#endif
#if defined(_DERIVATE)
x2_Vc3_c4=((vdif_Vc3_c4*vdif)+(vdif*vdif_Vc3_c4));
#endif
x2_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  x2_Vb2_e1_Vb_c=0.0;
  x2_Vb2_e1_Vb_b1=0.0;
  x2_Vb2_e1_Vb1_b2=0.0;
  x2_Vb2_e1_Vc4_c1=0.0;
  x2_Vb2_e1_Vc3_c1=0.0;
  x2_Vb2_e1_Vc3_c4=0.0;
  x2_Vb2_e1_Vb2_e1=0.0;
  x2_Vb2_e1_Vdt_GND=0.0;
  x2_Vb2_e1_Vb2_c2=0.0;
  x2_Vb2_e1_Vb2_c1=0.0;
  x2_Vb2_e1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
x2_Vdt_GND=((vdif_Vdt_GND*vdif)+(vdif*vdif_Vdt_GND));
#endif
x2_Vb2_c2=((vdif_Vb2_c2*vdif)+(vdif*vdif_Vb2_c2));
#if defined(_DERIVATE2)
  x2_Vb2_c2_Vb_c=(+vdif_Vb2_c2_Vb_c*vdif+vdif_Vb2_c2*vdif_Vb_c+vdif_Vb_c*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vb_c);
  x2_Vb2_c2_Vb_b1=(+vdif_Vb2_c2_Vb_b1*vdif+vdif_Vb2_c2*vdif_Vb_b1+vdif_Vb_b1*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vb_b1);
  x2_Vb2_c2_Vb1_b2=(+vdif_Vb2_c2_Vb1_b2*vdif+vdif_Vb2_c2*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vb1_b2);
  x2_Vb2_c2_Vc4_c1=(+vdif_Vb2_c2_Vc4_c1*vdif+vdif_Vb2_c2*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vc4_c1);
  x2_Vb2_c2_Vc3_c1=(+vdif_Vb2_c2_Vc3_c1*vdif+vdif_Vb2_c2*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vc3_c1);
  x2_Vb2_c2_Vc3_c4=(+vdif_Vb2_c2_Vc3_c4*vdif+vdif_Vb2_c2*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vc3_c4);
  x2_Vb2_c2_Vb2_e1=(+0.0*vdif+vdif_Vb2_c2*0.0+0.0*vdif_Vb2_c2+vdif*0.0);
  x2_Vb2_c2_Vdt_GND=(+vdif_Vb2_c2_Vdt_GND*vdif+vdif_Vb2_c2*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vdt_GND);
  x2_Vb2_c2_Vb2_c2=(+vdif_Vb2_c2_Vb2_c2*vdif+vdif_Vb2_c2*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vb2_c2);
  x2_Vb2_c2_Vb2_c1=(+0.0*vdif+vdif_Vb2_c2*0.0+0.0*vdif_Vb2_c2+vdif*0.0);
  x2_Vb2_c2_Vc1_c2=(+vdif_Vb2_c2_Vc1_c2*vdif+vdif_Vb2_c2*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vb2_c2+vdif*vdif_Vb2_c2_Vc1_c2);
#endif
x2_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vb2_c1_Vb_c=0.0;
  x2_Vb2_c1_Vb_b1=0.0;
  x2_Vb2_c1_Vb1_b2=0.0;
  x2_Vb2_c1_Vc4_c1=0.0;
  x2_Vb2_c1_Vc3_c1=0.0;
  x2_Vb2_c1_Vc3_c4=0.0;
  x2_Vb2_c1_Vb2_e1=0.0;
  x2_Vb2_c1_Vdt_GND=0.0;
  x2_Vb2_c1_Vb2_c2=0.0;
  x2_Vb2_c1_Vb2_c1=0.0;
  x2_Vb2_c1_Vc1_c2=0.0;
#endif
x2_Vc1_c2=((vdif_Vc1_c2*vdif)+(vdif*vdif_Vc1_c2));
#if defined(_DERIVATE2)
  x2_Vc1_c2_Vb_c=(+vdif_Vc1_c2_Vb_c*vdif+vdif_Vc1_c2*vdif_Vb_c+vdif_Vb_c*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vb_c);
  x2_Vc1_c2_Vb_b1=(+vdif_Vc1_c2_Vb_b1*vdif+vdif_Vc1_c2*vdif_Vb_b1+vdif_Vb_b1*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vb_b1);
  x2_Vc1_c2_Vb1_b2=(+vdif_Vc1_c2_Vb1_b2*vdif+vdif_Vc1_c2*vdif_Vb1_b2+vdif_Vb1_b2*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vb1_b2);
  x2_Vc1_c2_Vc4_c1=(+vdif_Vc1_c2_Vc4_c1*vdif+vdif_Vc1_c2*vdif_Vc4_c1+vdif_Vc4_c1*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vc4_c1);
  x2_Vc1_c2_Vc3_c1=(+vdif_Vc1_c2_Vc3_c1*vdif+vdif_Vc1_c2*vdif_Vc3_c1+vdif_Vc3_c1*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vc3_c1);
  x2_Vc1_c2_Vc3_c4=(+vdif_Vc1_c2_Vc3_c4*vdif+vdif_Vc1_c2*vdif_Vc3_c4+vdif_Vc3_c4*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vc3_c4);
  x2_Vc1_c2_Vb2_e1=(+0.0*vdif+vdif_Vc1_c2*0.0+0.0*vdif_Vc1_c2+vdif*0.0);
  x2_Vc1_c2_Vdt_GND=(+vdif_Vc1_c2_Vdt_GND*vdif+vdif_Vc1_c2*vdif_Vdt_GND+vdif_Vdt_GND*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vdt_GND);
  x2_Vc1_c2_Vb2_c2=(+vdif_Vc1_c2_Vb2_c2*vdif+vdif_Vc1_c2*vdif_Vb2_c2+vdif_Vb2_c2*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vb2_c2);
  x2_Vc1_c2_Vb2_c1=(+0.0*vdif+vdif_Vc1_c2*0.0+0.0*vdif_Vc1_c2+vdif*0.0);
  x2_Vc1_c2_Vc1_c2=(+vdif_Vc1_c2_Vc1_c2*vdif+vdif_Vc1_c2*vdif_Vc1_c2+vdif_Vc1_c2*vdif_Vc1_c2+vdif*vdif_Vc1_c2_Vc1_c2);
#endif
#endif
x2=(vdif*vdif);
EXIT_IF_ISNAN((vdif*vdif))
if
((vdif<0.0))
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
VBex_Vdt_GND=(((0.5*eps2_Vdt_GND)*(d00_sqrt0-vdif)-(0.5*eps2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-vdif_Vdt_GND))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
VBex_Vb_c=(-(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#if defined(_DERIVATE2)
  VBex_Vb_c_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-vdif_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vdt_GND+0.0))-vdif_Vb_c_Vdt_GND))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-vdif_Vdt_GND)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb_c+0.0))-vdif_Vb_c_Vb_c))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb_b1+0.0))-vdif_Vb_c_Vb_b1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb1_b2*d10_sqrt0-vdif_Vb1_b2)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb1_b2+0.0))-vdif_Vb_c_Vb1_b2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vb1_b2*d10_sqrt0-vdif_Vb1_b2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc4_c1*d10_sqrt0-vdif_Vc4_c1)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc4_c1+0.0))-vdif_Vb_c_Vc4_c1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vc4_c1*d10_sqrt0-vdif_Vc4_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc3_c1*d10_sqrt0-vdif_Vc3_c1)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc3_c1+0.0))-vdif_Vb_c_Vc3_c1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vc3_c1*d10_sqrt0-vdif_Vc3_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc3_c4*d10_sqrt0-vdif_Vc3_c4)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc3_c4+0.0))-vdif_Vb_c_Vc3_c4))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vc3_c4*d10_sqrt0-vdif_Vc3_c4)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*x2_Vb2_e1*d10_sqrt0+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_e1+0.0))-0.0))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*x2_Vb2_e1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb2_c2*d10_sqrt0-vdif_Vb2_c2)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_c2+0.0))-vdif_Vb_c_Vb2_c2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vb2_c2*d10_sqrt0-vdif_Vb2_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*x2_Vb2_c1*d10_sqrt0+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_c1+0.0))-0.0))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*x2_Vb2_c1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_c_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc1_c2*d10_sqrt0-vdif_Vc1_c2)+(0.0)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc1_c2+0.0))-vdif_Vb_c_Vc1_c2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)*(x2_Vc1_c2*d10_sqrt0-vdif_Vc1_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
VBex_Vb_b1=(-(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#if defined(_DERIVATE2)
  VBex_Vb_b1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-vdif_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vdt_GND+0.0))-vdif_Vb_b1_Vdt_GND))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-vdif_Vdt_GND)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb_c+0.0))-vdif_Vb_b1_Vb_c))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vb_c*d10_sqrt0-vdif_Vb_c)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb_b1+0.0))-vdif_Vb_b1_Vb_b1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb1_b2*d10_sqrt0-vdif_Vb1_b2)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb1_b2+0.0))-vdif_Vb_b1_Vb1_b2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vb1_b2*d10_sqrt0-vdif_Vb1_b2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc4_c1*d10_sqrt0-vdif_Vc4_c1)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc4_c1+0.0))-vdif_Vb_b1_Vc4_c1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vc4_c1*d10_sqrt0-vdif_Vc4_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc3_c1*d10_sqrt0-vdif_Vc3_c1)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc3_c1+0.0))-vdif_Vb_b1_Vc3_c1))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vc3_c1*d10_sqrt0-vdif_Vc3_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc3_c4*d10_sqrt0-vdif_Vc3_c4)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc3_c4+0.0))-vdif_Vb_b1_Vc3_c4))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vc3_c4*d10_sqrt0-vdif_Vc3_c4)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*x2_Vb2_e1*d10_sqrt0+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_e1+0.0))-0.0))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*x2_Vb2_e1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vb2_c2*d10_sqrt0-vdif_Vb2_c2)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_c2+0.0))-vdif_Vb_b1_Vb2_c2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vb2_c2*d10_sqrt0-vdif_Vb2_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*x2_Vb2_c1*d10_sqrt0+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_c1+0.0))-0.0))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*x2_Vb2_c1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
  VBex_Vb_b1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-vdif)-(0.0*(x2_Vc1_c2*d10_sqrt0-vdif_Vc1_c2)+(0.0)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc1_c2+0.0))-vdif_Vb_b1_Vc1_c2))/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)+2*(0.5*eps2)*(x2_Vb_b1*d10_sqrt0-vdif_Vb_b1)*(x2_Vc1_c2*d10_sqrt0-vdif_Vc1_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vb1_b2=(-(0.5*eps2)*(x2_Vb1_b2*d10_sqrt0-vdif_Vb1_b2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vc4_c1=(-(0.5*eps2)*(x2_Vc4_c1*d10_sqrt0-vdif_Vc4_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vc3_c1=(-(0.5*eps2)*(x2_Vc3_c1*d10_sqrt0-vdif_Vc3_c1)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vc3_c4=(-(0.5*eps2)*(x2_Vc3_c4*d10_sqrt0-vdif_Vc3_c4)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vb2_e1=(-(0.5*eps2)*x2_Vb2_e1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vb2_c2=(-(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-vdif_Vb2_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vb2_c1=(-(0.5*eps2)*x2_Vb2_c1*d10_sqrt0/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#if defined(_DERIVATE)
VBex_Vc1_c2=(-(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-vdif_Vc1_c2)/(d00_sqrt0-vdif)/(d00_sqrt0-vdif));
#endif
#endif
VBex=((0.5*eps2)/(d00_sqrt0-vdif));
EXIT_IF_ISNAN(((0.5*eps2)/(d00_sqrt0-vdif)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
VBex_Vdt_GND=(0.5*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+vdif_Vdt_GND));
#endif
VBex_Vb_c=(0.5*(x2_Vb_c*d10_sqrt0+vdif_Vb_c));
#if defined(_DERIVATE2)
  VBex_Vb_c_Vdt_GND=(+0.0*(d00_sqrt0+vdif)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+vdif_Vdt_GND)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vdt_GND+0.0))+vdif_Vb_c_Vdt_GND));
  VBex_Vb_c_Vb_c=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb_c+0.0))+vdif_Vb_c_Vb_c));
  VBex_Vb_c_Vb_b1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb_b1+0.0))+vdif_Vb_c_Vb_b1));
  VBex_Vb_c_Vb1_b2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb1_b2*d10_sqrt0+vdif_Vb1_b2)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb1_b2+0.0))+vdif_Vb_c_Vb1_b2));
  VBex_Vb_c_Vc4_c1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc4_c1*d10_sqrt0+vdif_Vc4_c1)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc4_c1+0.0))+vdif_Vb_c_Vc4_c1));
  VBex_Vb_c_Vc3_c1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc3_c1*d10_sqrt0+vdif_Vc3_c1)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc3_c1+0.0))+vdif_Vb_c_Vc3_c1));
  VBex_Vb_c_Vc3_c4=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc3_c4*d10_sqrt0+vdif_Vc3_c4)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc3_c4+0.0))+vdif_Vb_c_Vc3_c4));
  VBex_Vb_c_Vb2_e1=(+0.0*(d00_sqrt0+vdif)+0.0*x2_Vb2_e1*d10_sqrt0+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_e1+0.0))+0.0));
  VBex_Vb_c_Vb2_c2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb2_c2*d10_sqrt0+vdif_Vb2_c2)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_c2+0.0))+vdif_Vb_c_Vb2_c2));
  VBex_Vb_c_Vb2_c1=(+0.0*(d00_sqrt0+vdif)+0.0*x2_Vb2_c1*d10_sqrt0+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vb2_c1+0.0))+0.0));
  VBex_Vb_c_Vc1_c2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc1_c2*d10_sqrt0+vdif_Vc1_c2)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb_c+d10_sqrt0*(+x2_Vb_c_Vc1_c2+0.0))+vdif_Vb_c_Vc1_c2));
#endif
VBex_Vb_b1=(0.5*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1));
#if defined(_DERIVATE2)
  VBex_Vb_b1_Vdt_GND=(+0.0*(d00_sqrt0+vdif)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+vdif_Vdt_GND)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vdt_GND+0.0))+vdif_Vb_b1_Vdt_GND));
  VBex_Vb_b1_Vb_c=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb_c*d10_sqrt0+vdif_Vb_c)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb_c+0.0))+vdif_Vb_b1_Vb_c));
  VBex_Vb_b1_Vb_b1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb_b1+0.0))+vdif_Vb_b1_Vb_b1));
  VBex_Vb_b1_Vb1_b2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb1_b2*d10_sqrt0+vdif_Vb1_b2)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb1_b2+0.0))+vdif_Vb_b1_Vb1_b2));
  VBex_Vb_b1_Vc4_c1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc4_c1*d10_sqrt0+vdif_Vc4_c1)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc4_c1+0.0))+vdif_Vb_b1_Vc4_c1));
  VBex_Vb_b1_Vc3_c1=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc3_c1*d10_sqrt0+vdif_Vc3_c1)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc3_c1+0.0))+vdif_Vb_b1_Vc3_c1));
  VBex_Vb_b1_Vc3_c4=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc3_c4*d10_sqrt0+vdif_Vc3_c4)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc3_c4+0.0))+vdif_Vb_b1_Vc3_c4));
  VBex_Vb_b1_Vb2_e1=(+0.0*(d00_sqrt0+vdif)+0.0*x2_Vb2_e1*d10_sqrt0+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_e1+0.0))+0.0));
  VBex_Vb_b1_Vb2_c2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vb2_c2*d10_sqrt0+vdif_Vb2_c2)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_c2+0.0))+vdif_Vb_b1_Vb2_c2));
  VBex_Vb_b1_Vb2_c1=(+0.0*(d00_sqrt0+vdif)+0.0*x2_Vb2_c1*d10_sqrt0+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vb2_c1+0.0))+0.0));
  VBex_Vb_b1_Vc1_c2=(+0.0*(d00_sqrt0+vdif)+0.0*(x2_Vc1_c2*d10_sqrt0+vdif_Vc1_c2)+0.0*(x2_Vb_b1*d10_sqrt0+vdif_Vb_b1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb_b1+d10_sqrt0*(+x2_Vb_b1_Vc1_c2+0.0))+vdif_Vb_b1_Vc1_c2));
#endif
#if defined(_DERIVATE)
VBex_Vb1_b2=(0.5*(x2_Vb1_b2*d10_sqrt0+vdif_Vb1_b2));
#endif
#if defined(_DERIVATE)
VBex_Vc4_c1=(0.5*(x2_Vc4_c1*d10_sqrt0+vdif_Vc4_c1));
#endif
#if defined(_DERIVATE)
VBex_Vc3_c1=(0.5*(x2_Vc3_c1*d10_sqrt0+vdif_Vc3_c1));
#endif
#if defined(_DERIVATE)
VBex_Vc3_c4=(0.5*(x2_Vc3_c4*d10_sqrt0+vdif_Vc3_c4));
#endif
#if defined(_DERIVATE)
VBex_Vb2_e1=(0.5*x2_Vb2_e1*d10_sqrt0);
#endif
#if defined(_DERIVATE)
VBex_Vb2_c2=(0.5*(x2_Vb2_c2*d10_sqrt0+vdif_Vb2_c2));
#endif
#if defined(_DERIVATE)
VBex_Vb2_c1=(0.5*x2_Vb2_c1*d10_sqrt0);
#endif
#if defined(_DERIVATE)
VBex_Vc1_c2=(0.5*(x2_Vc1_c2*d10_sqrt0+vdif_Vc1_c2));
#endif
#endif
VBex=(0.5*(d00_sqrt0+vdif));
EXIT_IF_ISNAN((0.5*(d00_sqrt0+vdif)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
VBex_Vdt_GND=VBex_Vdt_GND;
#endif
VBex_Vb_c=VBex_Vb_c;
#if defined(_DERIVATE2)
  VBex_Vb_c_Vdt_GND=VBex_Vb_c_Vdt_GND;
  VBex_Vb_c_Vb_c=VBex_Vb_c_Vb_c;
  VBex_Vb_c_Vb_b1=VBex_Vb_c_Vb_b1;
  VBex_Vb_c_Vb1_b2=VBex_Vb_c_Vb1_b2;
  VBex_Vb_c_Vc4_c1=VBex_Vb_c_Vc4_c1;
  VBex_Vb_c_Vc3_c1=VBex_Vb_c_Vc3_c1;
  VBex_Vb_c_Vc3_c4=VBex_Vb_c_Vc3_c4;
  VBex_Vb_c_Vb2_e1=VBex_Vb_c_Vb2_e1;
  VBex_Vb_c_Vb2_c2=VBex_Vb_c_Vb2_c2;
  VBex_Vb_c_Vb2_c1=VBex_Vb_c_Vb2_c1;
  VBex_Vb_c_Vc1_c2=VBex_Vb_c_Vc1_c2;
#endif
VBex_Vb_b1=VBex_Vb_b1;
#if defined(_DERIVATE2)
  VBex_Vb_b1_Vdt_GND=VBex_Vb_b1_Vdt_GND;
  VBex_Vb_b1_Vb_c=VBex_Vb_b1_Vb_c;
  VBex_Vb_b1_Vb_b1=VBex_Vb_b1_Vb_b1;
  VBex_Vb_b1_Vb1_b2=VBex_Vb_b1_Vb1_b2;
  VBex_Vb_b1_Vc4_c1=VBex_Vb_b1_Vc4_c1;
  VBex_Vb_b1_Vc3_c1=VBex_Vb_b1_Vc3_c1;
  VBex_Vb_b1_Vc3_c4=VBex_Vb_b1_Vc3_c4;
  VBex_Vb_b1_Vb2_e1=VBex_Vb_b1_Vb2_e1;
  VBex_Vb_b1_Vb2_c2=VBex_Vb_b1_Vb2_c2;
  VBex_Vb_b1_Vb2_c1=VBex_Vb_b1_Vb2_c1;
  VBex_Vb_b1_Vc1_c2=VBex_Vb_b1_Vc1_c2;
#endif
#if defined(_DERIVATE)
VBex_Vb1_b2=VBex_Vb1_b2;
#endif
#if defined(_DERIVATE)
VBex_Vc4_c1=VBex_Vc4_c1;
#endif
#if defined(_DERIVATE)
VBex_Vc3_c1=VBex_Vc3_c1;
#endif
#if defined(_DERIVATE)
VBex_Vc3_c4=VBex_Vc3_c4;
#endif
#if defined(_DERIVATE)
VBex_Vb2_e1=VBex_Vb2_e1;
#endif
#if defined(_DERIVATE)
VBex_Vb2_c2=VBex_Vb2_c2;
#endif
#if defined(_DERIVATE)
VBex_Vb2_c1=VBex_Vb2_c1;
#endif
#if defined(_DERIVATE)
VBex_Vc1_c2=VBex_Vc1_c2;
#endif
#endif
VBex=VBex;
EXIT_IF_ISNAN(VBex)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
Fex_Vdt_GND=((VBex_Vdt_GND*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((Vex_bias_Vdt_GND+(((XIMex_Vdt_GND+XIMsub_Vdt_GND)*RCCxx_TM)+((XIMex+XIMsub)*RCCxx_TM_Vdt_GND)))+VBex_Vdt_GND))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
Fex_Vb_c=((VBex_Vb_c*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#if defined(_DERIVATE2)
  Fex_Vb_c_Vdt_GND=(VBex_Vb_c_Vdt_GND/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*((Vex_bias_Vdt_GND+((((XIMex_Vdt_GND+XIMsub_Vdt_GND)*RCCxx_TM)+((XIMex+XIMsub)*RCCxx_TM_Vdt_GND))))+VBex_Vdt_GND)+VBex_Vdt_GND*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vdt_GND+XIMsub_Vb_c_Vdt_GND)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM_Vdt_GND+(XIMex_Vdt_GND+XIMsub_Vdt_GND)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vdt_GND))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*((Vex_bias_Vdt_GND+((((XIMex_Vdt_GND+XIMsub_Vdt_GND)*RCCxx_TM)+((XIMex+XIMsub)*RCCxx_TM_Vdt_GND))))+VBex_Vdt_GND)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb_c=(VBex_Vb_c_Vb_c/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM)+VBex_Vb_c)+VBex_Vb_c*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vb_c+XIMsub_Vb_c_Vb_c)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb_c))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM)+VBex_Vb_c)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb_b1=(VBex_Vb_c_Vb_b1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM)+VBex_Vb_b1)+VBex_Vb_b1*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vb_b1+XIMsub_Vb_c_Vb_b1)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb_b1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM)+VBex_Vb_b1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb1_b2=(VBex_Vb_c_Vb1_b2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vb1_b2+XIMsub_Vb1_b2)*RCCxx_TM)+VBex_Vb1_b2)+VBex_Vb1_b2*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vb1_b2+XIMsub_Vb_c_Vb1_b2)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vb1_b2+XIMsub_Vb1_b2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb1_b2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vb1_b2+XIMsub_Vb1_b2)*RCCxx_TM)+VBex_Vb1_b2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vc4_c1=(VBex_Vb_c_Vc4_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vc4_c1+XIMsub_Vc4_c1)*RCCxx_TM)+VBex_Vc4_c1)+VBex_Vc4_c1*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vc4_c1+XIMsub_Vb_c_Vc4_c1)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vc4_c1+XIMsub_Vc4_c1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vc4_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vc4_c1+XIMsub_Vc4_c1)*RCCxx_TM)+VBex_Vc4_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vc3_c1=(VBex_Vb_c_Vc3_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vc3_c1+XIMsub_Vc3_c1)*RCCxx_TM)+VBex_Vc3_c1)+VBex_Vc3_c1*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vc3_c1+XIMsub_Vb_c_Vc3_c1)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vc3_c1+XIMsub_Vc3_c1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vc3_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vc3_c1+XIMsub_Vc3_c1)*RCCxx_TM)+VBex_Vc3_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vc3_c4=(VBex_Vb_c_Vc3_c4/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vc3_c4+XIMsub_Vc3_c4)*RCCxx_TM)+VBex_Vc3_c4)+VBex_Vc3_c4*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vc3_c4+XIMsub_Vb_c_Vc3_c4)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vc3_c4+XIMsub_Vc3_c4)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vc3_c4))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vc3_c4+XIMsub_Vc3_c4)*RCCxx_TM)+VBex_Vc3_c4)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb2_e1=(VBex_Vb_c_Vb2_e1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*((0.0)+VBex_Vb2_e1)+VBex_Vb2_e1*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+0.0+0.0)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+0.0*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb2_e1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*((0.0)+VBex_Vb2_e1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb2_c2=(VBex_Vb_c_Vb2_c2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vb2_c2+XIMsub_Vb2_c2)*RCCxx_TM)+VBex_Vb2_c2)+VBex_Vb2_c2*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vb2_c2+XIMsub_Vb_c_Vb2_c2)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vb2_c2+XIMsub_Vb2_c2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb2_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vb2_c2+XIMsub_Vb2_c2)*RCCxx_TM)+VBex_Vb2_c2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vb2_c1=(VBex_Vb_c_Vb2_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*((0.0)+VBex_Vb2_c1)+VBex_Vb2_c1*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+0.0+0.0)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+0.0*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vb2_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*((0.0)+VBex_Vb2_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vc1_c2=(VBex_Vb_c_Vc1_c2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(((XIMex_Vc1_c2+XIMsub_Vc1_c2)*RCCxx_TM)+VBex_Vc1_c2)+VBex_Vc1_c2*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+XIMex_Vb_c_Vc1_c2+XIMsub_Vb_c_Vc1_c2)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex_Vc1_c2+XIMsub_Vc1_c2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_c_Vc1_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(((XIMex_Vc1_c2+XIMsub_Vc1_c2)*RCCxx_TM)+VBex_Vc1_c2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_c_Vs_c1=(0.0/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_c*(XIMsub_Vs_c1*RCCxx_TM)+0.0*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)+VBex*(+(+0.0+(+(+0.0+XIMsub_Vb_c_Vs_c1)*RCCxx_TM+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+XIMsub_Vs_c1*0.0+(XIMex+XIMsub)*0.0))+0.0))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM+VBex_Vb_c)*(XIMsub_Vs_c1*RCCxx_TM)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
Fex_Vb_b1=((VBex_Vb_b1*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#if defined(_DERIVATE2)
  Fex_Vb_b1_Vdt_GND=(VBex_Vb_b1_Vdt_GND/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*((Vex_bias_Vdt_GND+((((XIMex_Vdt_GND+XIMsub_Vdt_GND)*RCCxx_TM)+((XIMex+XIMsub)*RCCxx_TM_Vdt_GND))))+VBex_Vdt_GND)+VBex_Vdt_GND*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vdt_GND+XIMsub_Vb_b1_Vdt_GND)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM_Vdt_GND+(XIMex_Vdt_GND+XIMsub_Vdt_GND)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vdt_GND))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*((Vex_bias_Vdt_GND+((((XIMex_Vdt_GND+XIMsub_Vdt_GND)*RCCxx_TM)+((XIMex+XIMsub)*RCCxx_TM_Vdt_GND))))+VBex_Vdt_GND)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb_c=(VBex_Vb_b1_Vb_c/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM)+VBex_Vb_c)+VBex_Vb_c*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vb_c+XIMsub_Vb_b1_Vb_c)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vb_c+XIMsub_Vb_c)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb_c))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vb_c+XIMsub_Vb_c)*RCCxx_TM)+VBex_Vb_c)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb_b1=(VBex_Vb_b1_Vb_b1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM)+VBex_Vb_b1)+VBex_Vb_b1*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vb_b1+XIMsub_Vb_b1_Vb_b1)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb_b1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM)+VBex_Vb_b1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb1_b2=(VBex_Vb_b1_Vb1_b2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vb1_b2+XIMsub_Vb1_b2)*RCCxx_TM)+VBex_Vb1_b2)+VBex_Vb1_b2*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vb1_b2+XIMsub_Vb_b1_Vb1_b2)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vb1_b2+XIMsub_Vb1_b2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb1_b2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vb1_b2+XIMsub_Vb1_b2)*RCCxx_TM)+VBex_Vb1_b2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vc4_c1=(VBex_Vb_b1_Vc4_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vc4_c1+XIMsub_Vc4_c1)*RCCxx_TM)+VBex_Vc4_c1)+VBex_Vc4_c1*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vc4_c1+XIMsub_Vb_b1_Vc4_c1)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vc4_c1+XIMsub_Vc4_c1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vc4_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vc4_c1+XIMsub_Vc4_c1)*RCCxx_TM)+VBex_Vc4_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vc3_c1=(VBex_Vb_b1_Vc3_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vc3_c1+XIMsub_Vc3_c1)*RCCxx_TM)+VBex_Vc3_c1)+VBex_Vc3_c1*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vc3_c1+XIMsub_Vb_b1_Vc3_c1)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vc3_c1+XIMsub_Vc3_c1)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vc3_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vc3_c1+XIMsub_Vc3_c1)*RCCxx_TM)+VBex_Vc3_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vc3_c4=(VBex_Vb_b1_Vc3_c4/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vc3_c4+XIMsub_Vc3_c4)*RCCxx_TM)+VBex_Vc3_c4)+VBex_Vc3_c4*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vc3_c4+XIMsub_Vb_b1_Vc3_c4)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vc3_c4+XIMsub_Vc3_c4)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vc3_c4))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vc3_c4+XIMsub_Vc3_c4)*RCCxx_TM)+VBex_Vc3_c4)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb2_e1=(VBex_Vb_b1_Vb2_e1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*((0.0)+VBex_Vb2_e1)+VBex_Vb2_e1*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+0.0+0.0)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+0.0*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb2_e1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*((0.0)+VBex_Vb2_e1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb2_c2=(VBex_Vb_b1_Vb2_c2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vb2_c2+XIMsub_Vb2_c2)*RCCxx_TM)+VBex_Vb2_c2)+VBex_Vb2_c2*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vb2_c2+XIMsub_Vb_b1_Vb2_c2)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vb2_c2+XIMsub_Vb2_c2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb2_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vb2_c2+XIMsub_Vb2_c2)*RCCxx_TM)+VBex_Vb2_c2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vb2_c1=(VBex_Vb_b1_Vb2_c1/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*((0.0)+VBex_Vb2_c1)+VBex_Vb2_c1*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+0.0+0.0)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+0.0*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vb2_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*((0.0)+VBex_Vb2_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vc1_c2=(VBex_Vb_b1_Vc1_c2/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(((XIMex_Vc1_c2+XIMsub_Vc1_c2)*RCCxx_TM)+VBex_Vc1_c2)+VBex_Vc1_c2*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+XIMex_Vb_b1_Vc1_c2+XIMsub_Vb_b1_Vc1_c2)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+(XIMex_Vc1_c2+XIMsub_Vc1_c2)*0.0+(XIMex+XIMsub)*0.0))+VBex_Vb_b1_Vc1_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(((XIMex_Vc1_c2+XIMsub_Vc1_c2)*RCCxx_TM)+VBex_Vc1_c2)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
  Fex_Vb_b1_Vs_c1=(0.0/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-(VBex_Vb_b1*(XIMsub_Vs_c1*RCCxx_TM)+0.0*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)+VBex*(+(+0.0+(+(+0.0+XIMsub_Vb_b1_Vs_c1)*RCCxx_TM+(XIMex_Vb_b1+XIMsub_Vb_b1)*0.0+XIMsub_Vs_c1*0.0+(XIMex+XIMsub)*0.0))+0.0))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)+2*VBex*((XIMex_Vb_b1+XIMsub_Vb_b1)*RCCxx_TM+VBex_Vb_b1)*(XIMsub_Vs_c1*RCCxx_TM)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vb1_b2=((VBex_Vb1_b2*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vb1_b2+XIMsub_Vb1_b2)*RCCxx_TM+VBex_Vb1_b2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vc4_c1=((VBex_Vc4_c1*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vc4_c1+XIMsub_Vc4_c1)*RCCxx_TM+VBex_Vc4_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vc3_c1=((VBex_Vc3_c1*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vc3_c1+XIMsub_Vc3_c1)*RCCxx_TM+VBex_Vc3_c1))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vc3_c4=((VBex_Vc3_c4*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vc3_c4+XIMsub_Vc3_c4)*RCCxx_TM+VBex_Vc3_c4))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vb2_e1=((VBex_Vb2_e1*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*VBex_Vb2_e1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vb2_c2=((VBex_Vb2_c2*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vb2_c2+XIMsub_Vb2_c2)*RCCxx_TM+VBex_Vb2_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vb2_c1=((VBex_Vb2_c1*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*VBex_Vb2_c1)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vc1_c2=((VBex_Vc1_c2*((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)-VBex*((XIMex_Vc1_c2+XIMsub_Vc1_c2)*RCCxx_TM+VBex_Vc1_c2))/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#if defined(_DERIVATE)
Fex_Vs_c1=(-VBex*XIMsub_Vs_c1*RCCxx_TM/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
#endif
#endif
Fex=(VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex));
EXIT_IF_ISNAN((VBex/((Vex_bias+((XIMex+XIMsub)*RCCxx_TM))+VBex)))
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
Vex_Vdt_GND=0.0;
#endif
Vex=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND)V(b,GND) */
vdif_Vb_c=0.0;
#if defined(_DERIVATE2)
  vdif_Vb_c_Vb_c=0.0;
  vdif_Vb_c_Vb_b1=0.0;
  vdif_Vb_c_Vb1_b2=0.0;
  vdif_Vb_c_Vb2_c2=0.0;
  vdif_Vb_c_Vc1_c2=0.0;
  vdif_Vb_c_Vc4_c1=0.0;
  vdif_Vb_c_Vc3_c1=0.0;
  vdif_Vb_c_Vc3_c4=0.0;
  vdif_Vb_c_Vdt_GND=0.0;
#endif
vdif_Vb_b1=0.0;
#if defined(_DERIVATE2)
  vdif_Vb_b1_Vb_c=0.0;
  vdif_Vb_b1_Vb_b1=0.0;
  vdif_Vb_b1_Vb1_b2=0.0;
  vdif_Vb_b1_Vb2_c2=0.0;
  vdif_Vb_b1_Vc1_c2=0.0;
  vdif_Vb_b1_Vc4_c1=0.0;
  vdif_Vb_b1_Vc3_c1=0.0;
  vdif_Vb_b1_Vc3_c4=0.0;
  vdif_Vb_b1_Vdt_GND=0.0;
#endif
vdif_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  vdif_Vb1_b2_Vb_c=0.0;
  vdif_Vb1_b2_Vb_b1=0.0;
  vdif_Vb1_b2_Vb1_b2=0.0;
  vdif_Vb1_b2_Vb2_c2=0.0;
  vdif_Vb1_b2_Vc1_c2=0.0;
  vdif_Vb1_b2_Vc4_c1=0.0;
  vdif_Vb1_b2_Vc3_c1=0.0;
  vdif_Vb1_b2_Vc3_c4=0.0;
  vdif_Vb1_b2_Vdt_GND=0.0;
#endif
vdif_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  vdif_Vb2_c2_Vb_c=0.0;
  vdif_Vb2_c2_Vb_b1=0.0;
  vdif_Vb2_c2_Vb1_b2=0.0;
  vdif_Vb2_c2_Vb2_c2=0.0;
  vdif_Vb2_c2_Vc1_c2=0.0;
  vdif_Vb2_c2_Vc4_c1=0.0;
  vdif_Vb2_c2_Vc3_c1=0.0;
  vdif_Vb2_c2_Vc3_c4=0.0;
  vdif_Vb2_c2_Vdt_GND=0.0;
#endif
vdif_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  vdif_Vc1_c2_Vb_c=0.0;
  vdif_Vc1_c2_Vb_b1=0.0;
  vdif_Vc1_c2_Vb1_b2=0.0;
  vdif_Vc1_c2_Vb2_c2=0.0;
  vdif_Vc1_c2_Vc1_c2=0.0;
  vdif_Vc1_c2_Vc4_c1=0.0;
  vdif_Vc1_c2_Vc3_c1=0.0;
  vdif_Vc1_c2_Vc3_c4=0.0;
  vdif_Vc1_c2_Vdt_GND=0.0;
#endif
vdif_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  vdif_Vc4_c1_Vb_c=0.0;
  vdif_Vc4_c1_Vb_b1=0.0;
  vdif_Vc4_c1_Vb1_b2=0.0;
  vdif_Vc4_c1_Vb2_c2=0.0;
  vdif_Vc4_c1_Vc1_c2=0.0;
  vdif_Vc4_c1_Vc4_c1=0.0;
  vdif_Vc4_c1_Vc3_c1=0.0;
  vdif_Vc4_c1_Vc3_c4=0.0;
  vdif_Vc4_c1_Vdt_GND=0.0;
#endif
vdif_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  vdif_Vc3_c1_Vb_c=0.0;
  vdif_Vc3_c1_Vb_b1=0.0;
  vdif_Vc3_c1_Vb1_b2=0.0;
  vdif_Vc3_c1_Vb2_c2=0.0;
  vdif_Vc3_c1_Vc1_c2=0.0;
  vdif_Vc3_c1_Vc4_c1=0.0;
  vdif_Vc3_c1_Vc3_c1=0.0;
  vdif_Vc3_c1_Vc3_c4=0.0;
  vdif_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
vdif_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
vdif_Vdt_GND=0.0;
#endif
#endif
vdif=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
VBex_Vdt_GND=0.0;
#endif
VBex_Vb_c=0.0;
#if defined(_DERIVATE2)
  VBex_Vb_c_Vdt_GND=0.0;
  VBex_Vb_c_Vb_c=0.0;
  VBex_Vb_c_Vb_b1=0.0;
  VBex_Vb_c_Vb1_b2=0.0;
  VBex_Vb_c_Vc4_c1=0.0;
  VBex_Vb_c_Vc3_c1=0.0;
  VBex_Vb_c_Vc3_c4=0.0;
  VBex_Vb_c_Vb2_e1=0.0;
  VBex_Vb_c_Vb2_c2=0.0;
  VBex_Vb_c_Vb2_c1=0.0;
  VBex_Vb_c_Vc1_c2=0.0;
#endif
VBex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  VBex_Vb_b1_Vdt_GND=0.0;
  VBex_Vb_b1_Vb_c=0.0;
  VBex_Vb_b1_Vb_b1=0.0;
  VBex_Vb_b1_Vb1_b2=0.0;
  VBex_Vb_b1_Vc4_c1=0.0;
  VBex_Vb_b1_Vc3_c1=0.0;
  VBex_Vb_b1_Vc3_c4=0.0;
  VBex_Vb_b1_Vb2_e1=0.0;
  VBex_Vb_b1_Vb2_c2=0.0;
  VBex_Vb_b1_Vb2_c1=0.0;
  VBex_Vb_b1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
VBex_Vc1_c2=0.0;
#endif
#endif
VBex=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
Fex_Vdt_GND=0.0;
#endif
Fex_Vb_c=0.0;
#if defined(_DERIVATE2)
  Fex_Vb_c_Vdt_GND=0.0;
  Fex_Vb_c_Vb_c=0.0;
  Fex_Vb_c_Vb_b1=0.0;
  Fex_Vb_c_Vb1_b2=0.0;
  Fex_Vb_c_Vc4_c1=0.0;
  Fex_Vb_c_Vc3_c1=0.0;
  Fex_Vb_c_Vc3_c4=0.0;
  Fex_Vb_c_Vb2_e1=0.0;
  Fex_Vb_c_Vb2_c2=0.0;
  Fex_Vb_c_Vb2_c1=0.0;
  Fex_Vb_c_Vc1_c2=0.0;
  Fex_Vb_c_Vs_c1=0.0;
#endif
Fex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  Fex_Vb_b1_Vdt_GND=0.0;
  Fex_Vb_b1_Vb_c=0.0;
  Fex_Vb_b1_Vb_b1=0.0;
  Fex_Vb_b1_Vb1_b2=0.0;
  Fex_Vb_b1_Vc4_c1=0.0;
  Fex_Vb_b1_Vc3_c1=0.0;
  Fex_Vb_b1_Vc3_c4=0.0;
  Fex_Vb_b1_Vb2_e1=0.0;
  Fex_Vb_b1_Vb2_c2=0.0;
  Fex_Vb_b1_Vb2_c1=0.0;
  Fex_Vb_b1_Vc1_c2=0.0;
  Fex_Vb_b1_Vs_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vs_c1=0.0;
#endif
#endif
Fex=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIex_Vdt_GND=((Fex_Vdt_GND*XIMex)+(Fex*XIMex_Vdt_GND));
#endif
XIex_Vb_c=((Fex_Vb_c*XIMex)+(Fex*XIMex_Vb_c));
#if defined(_DERIVATE2)
  XIex_Vb_c_Vdt_GND=(+Fex_Vb_c_Vdt_GND*XIMex+Fex_Vb_c*XIMex_Vdt_GND+Fex_Vdt_GND*XIMex_Vb_c+Fex*XIMex_Vb_c_Vdt_GND);
  XIex_Vb_c_Vb_c=(+Fex_Vb_c_Vb_c*XIMex+Fex_Vb_c*XIMex_Vb_c+Fex_Vb_c*XIMex_Vb_c+Fex*XIMex_Vb_c_Vb_c);
  XIex_Vb_c_Vb_b1=(+Fex_Vb_c_Vb_b1*XIMex+Fex_Vb_c*XIMex_Vb_b1+Fex_Vb_b1*XIMex_Vb_c+Fex*XIMex_Vb_c_Vb_b1);
  XIex_Vb_c_Vb1_b2=(+Fex_Vb_c_Vb1_b2*XIMex+Fex_Vb_c*XIMex_Vb1_b2+Fex_Vb1_b2*XIMex_Vb_c+Fex*XIMex_Vb_c_Vb1_b2);
  XIex_Vb_c_Vc4_c1=(+Fex_Vb_c_Vc4_c1*XIMex+Fex_Vb_c*XIMex_Vc4_c1+Fex_Vc4_c1*XIMex_Vb_c+Fex*XIMex_Vb_c_Vc4_c1);
  XIex_Vb_c_Vc3_c1=(+Fex_Vb_c_Vc3_c1*XIMex+Fex_Vb_c*XIMex_Vc3_c1+Fex_Vc3_c1*XIMex_Vb_c+Fex*XIMex_Vb_c_Vc3_c1);
  XIex_Vb_c_Vc3_c4=(+Fex_Vb_c_Vc3_c4*XIMex+Fex_Vb_c*XIMex_Vc3_c4+Fex_Vc3_c4*XIMex_Vb_c+Fex*XIMex_Vb_c_Vc3_c4);
  XIex_Vb_c_Vb2_e1=(+Fex_Vb_c_Vb2_e1*XIMex+Fex_Vb_c*0.0+Fex_Vb2_e1*XIMex_Vb_c+Fex*0.0);
  XIex_Vb_c_Vb2_c2=(+Fex_Vb_c_Vb2_c2*XIMex+Fex_Vb_c*XIMex_Vb2_c2+Fex_Vb2_c2*XIMex_Vb_c+Fex*XIMex_Vb_c_Vb2_c2);
  XIex_Vb_c_Vb2_c1=(+Fex_Vb_c_Vb2_c1*XIMex+Fex_Vb_c*0.0+Fex_Vb2_c1*XIMex_Vb_c+Fex*0.0);
  XIex_Vb_c_Vc1_c2=(+Fex_Vb_c_Vc1_c2*XIMex+Fex_Vb_c*XIMex_Vc1_c2+Fex_Vc1_c2*XIMex_Vb_c+Fex*XIMex_Vb_c_Vc1_c2);
  XIex_Vb_c_Vs_c1=(+Fex_Vb_c_Vs_c1*XIMex+Fex_Vb_c*0.0+Fex_Vs_c1*XIMex_Vb_c+Fex*0.0);
#endif
XIex_Vb_b1=((Fex_Vb_b1*XIMex)+(Fex*XIMex_Vb_b1));
#if defined(_DERIVATE2)
  XIex_Vb_b1_Vdt_GND=(+Fex_Vb_b1_Vdt_GND*XIMex+Fex_Vb_b1*XIMex_Vdt_GND+Fex_Vdt_GND*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vdt_GND);
  XIex_Vb_b1_Vb_c=(+Fex_Vb_b1_Vb_c*XIMex+Fex_Vb_b1*XIMex_Vb_c+Fex_Vb_c*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vb_c);
  XIex_Vb_b1_Vb_b1=(+Fex_Vb_b1_Vb_b1*XIMex+Fex_Vb_b1*XIMex_Vb_b1+Fex_Vb_b1*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vb_b1);
  XIex_Vb_b1_Vb1_b2=(+Fex_Vb_b1_Vb1_b2*XIMex+Fex_Vb_b1*XIMex_Vb1_b2+Fex_Vb1_b2*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vb1_b2);
  XIex_Vb_b1_Vc4_c1=(+Fex_Vb_b1_Vc4_c1*XIMex+Fex_Vb_b1*XIMex_Vc4_c1+Fex_Vc4_c1*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vc4_c1);
  XIex_Vb_b1_Vc3_c1=(+Fex_Vb_b1_Vc3_c1*XIMex+Fex_Vb_b1*XIMex_Vc3_c1+Fex_Vc3_c1*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vc3_c1);
  XIex_Vb_b1_Vc3_c4=(+Fex_Vb_b1_Vc3_c4*XIMex+Fex_Vb_b1*XIMex_Vc3_c4+Fex_Vc3_c4*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vc3_c4);
  XIex_Vb_b1_Vb2_e1=(+Fex_Vb_b1_Vb2_e1*XIMex+Fex_Vb_b1*0.0+Fex_Vb2_e1*XIMex_Vb_b1+Fex*0.0);
  XIex_Vb_b1_Vb2_c2=(+Fex_Vb_b1_Vb2_c2*XIMex+Fex_Vb_b1*XIMex_Vb2_c2+Fex_Vb2_c2*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vb2_c2);
  XIex_Vb_b1_Vb2_c1=(+Fex_Vb_b1_Vb2_c1*XIMex+Fex_Vb_b1*0.0+Fex_Vb2_c1*XIMex_Vb_b1+Fex*0.0);
  XIex_Vb_b1_Vc1_c2=(+Fex_Vb_b1_Vc1_c2*XIMex+Fex_Vb_b1*XIMex_Vc1_c2+Fex_Vc1_c2*XIMex_Vb_b1+Fex*XIMex_Vb_b1_Vc1_c2);
  XIex_Vb_b1_Vs_c1=(+Fex_Vb_b1_Vs_c1*XIMex+Fex_Vb_b1*0.0+Fex_Vs_c1*XIMex_Vb_b1+Fex*0.0);
#endif
#if defined(_DERIVATE)
XIex_Vb1_b2=((Fex_Vb1_b2*XIMex)+(Fex*XIMex_Vb1_b2));
#endif
#if defined(_DERIVATE)
XIex_Vc4_c1=((Fex_Vc4_c1*XIMex)+(Fex*XIMex_Vc4_c1));
#endif
#if defined(_DERIVATE)
XIex_Vc3_c1=((Fex_Vc3_c1*XIMex)+(Fex*XIMex_Vc3_c1));
#endif
#if defined(_DERIVATE)
XIex_Vc3_c4=((Fex_Vc3_c4*XIMex)+(Fex*XIMex_Vc3_c4));
#endif
#if defined(_DERIVATE)
XIex_Vb2_e1=Fex_Vb2_e1*XIMex;
#endif
#if defined(_DERIVATE)
XIex_Vb2_c2=((Fex_Vb2_c2*XIMex)+(Fex*XIMex_Vb2_c2));
#endif
#if defined(_DERIVATE)
XIex_Vb2_c1=Fex_Vb2_c1*XIMex;
#endif
#if defined(_DERIVATE)
XIex_Vc1_c2=((Fex_Vc1_c2*XIMex)+(Fex*XIMex_Vc1_c2));
#endif
#if defined(_DERIVATE)
XIex_Vs_c1=Fex_Vs_c1*XIMex;
#endif
#endif
pInst->XIex=(Fex*XIMex);
EXIT_IF_ISNAN((Fex*XIMex))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XIsub_Vdt_GND=((Fex_Vdt_GND*XIMsub)+(Fex*XIMsub_Vdt_GND));
#endif
XIsub_Vb_c=((Fex_Vb_c*XIMsub)+(Fex*XIMsub_Vb_c));
#if defined(_DERIVATE2)
  XIsub_Vb_c_Vdt_GND=(+Fex_Vb_c_Vdt_GND*XIMsub+Fex_Vb_c*XIMsub_Vdt_GND+Fex_Vdt_GND*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vdt_GND);
  XIsub_Vb_c_Vb_c=(+Fex_Vb_c_Vb_c*XIMsub+Fex_Vb_c*XIMsub_Vb_c+Fex_Vb_c*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vb_c);
  XIsub_Vb_c_Vb_b1=(+Fex_Vb_c_Vb_b1*XIMsub+Fex_Vb_c*XIMsub_Vb_b1+Fex_Vb_b1*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vb_b1);
  XIsub_Vb_c_Vb1_b2=(+Fex_Vb_c_Vb1_b2*XIMsub+Fex_Vb_c*XIMsub_Vb1_b2+Fex_Vb1_b2*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vb1_b2);
  XIsub_Vb_c_Vc4_c1=(+Fex_Vb_c_Vc4_c1*XIMsub+Fex_Vb_c*XIMsub_Vc4_c1+Fex_Vc4_c1*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vc4_c1);
  XIsub_Vb_c_Vc3_c1=(+Fex_Vb_c_Vc3_c1*XIMsub+Fex_Vb_c*XIMsub_Vc3_c1+Fex_Vc3_c1*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vc3_c1);
  XIsub_Vb_c_Vc3_c4=(+Fex_Vb_c_Vc3_c4*XIMsub+Fex_Vb_c*XIMsub_Vc3_c4+Fex_Vc3_c4*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vc3_c4);
  XIsub_Vb_c_Vb2_e1=(+Fex_Vb_c_Vb2_e1*XIMsub+Fex_Vb_c*0.0+Fex_Vb2_e1*XIMsub_Vb_c+Fex*0.0);
  XIsub_Vb_c_Vb2_c2=(+Fex_Vb_c_Vb2_c2*XIMsub+Fex_Vb_c*XIMsub_Vb2_c2+Fex_Vb2_c2*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vb2_c2);
  XIsub_Vb_c_Vb2_c1=(+Fex_Vb_c_Vb2_c1*XIMsub+Fex_Vb_c*0.0+Fex_Vb2_c1*XIMsub_Vb_c+Fex*0.0);
  XIsub_Vb_c_Vc1_c2=(+Fex_Vb_c_Vc1_c2*XIMsub+Fex_Vb_c*XIMsub_Vc1_c2+Fex_Vc1_c2*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vc1_c2);
  XIsub_Vb_c_Vs_c1=(+Fex_Vb_c_Vs_c1*XIMsub+Fex_Vb_c*XIMsub_Vs_c1+Fex_Vs_c1*XIMsub_Vb_c+Fex*XIMsub_Vb_c_Vs_c1);
#endif
XIsub_Vb_b1=((Fex_Vb_b1*XIMsub)+(Fex*XIMsub_Vb_b1));
#if defined(_DERIVATE2)
  XIsub_Vb_b1_Vdt_GND=(+Fex_Vb_b1_Vdt_GND*XIMsub+Fex_Vb_b1*XIMsub_Vdt_GND+Fex_Vdt_GND*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vdt_GND);
  XIsub_Vb_b1_Vb_c=(+Fex_Vb_b1_Vb_c*XIMsub+Fex_Vb_b1*XIMsub_Vb_c+Fex_Vb_c*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vb_c);
  XIsub_Vb_b1_Vb_b1=(+Fex_Vb_b1_Vb_b1*XIMsub+Fex_Vb_b1*XIMsub_Vb_b1+Fex_Vb_b1*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vb_b1);
  XIsub_Vb_b1_Vb1_b2=(+Fex_Vb_b1_Vb1_b2*XIMsub+Fex_Vb_b1*XIMsub_Vb1_b2+Fex_Vb1_b2*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vb1_b2);
  XIsub_Vb_b1_Vc4_c1=(+Fex_Vb_b1_Vc4_c1*XIMsub+Fex_Vb_b1*XIMsub_Vc4_c1+Fex_Vc4_c1*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vc4_c1);
  XIsub_Vb_b1_Vc3_c1=(+Fex_Vb_b1_Vc3_c1*XIMsub+Fex_Vb_b1*XIMsub_Vc3_c1+Fex_Vc3_c1*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vc3_c1);
  XIsub_Vb_b1_Vc3_c4=(+Fex_Vb_b1_Vc3_c4*XIMsub+Fex_Vb_b1*XIMsub_Vc3_c4+Fex_Vc3_c4*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vc3_c4);
  XIsub_Vb_b1_Vb2_e1=(+Fex_Vb_b1_Vb2_e1*XIMsub+Fex_Vb_b1*0.0+Fex_Vb2_e1*XIMsub_Vb_b1+Fex*0.0);
  XIsub_Vb_b1_Vb2_c2=(+Fex_Vb_b1_Vb2_c2*XIMsub+Fex_Vb_b1*XIMsub_Vb2_c2+Fex_Vb2_c2*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vb2_c2);
  XIsub_Vb_b1_Vb2_c1=(+Fex_Vb_b1_Vb2_c1*XIMsub+Fex_Vb_b1*0.0+Fex_Vb2_c1*XIMsub_Vb_b1+Fex*0.0);
  XIsub_Vb_b1_Vc1_c2=(+Fex_Vb_b1_Vc1_c2*XIMsub+Fex_Vb_b1*XIMsub_Vc1_c2+Fex_Vc1_c2*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vc1_c2);
  XIsub_Vb_b1_Vs_c1=(+Fex_Vb_b1_Vs_c1*XIMsub+Fex_Vb_b1*XIMsub_Vs_c1+Fex_Vs_c1*XIMsub_Vb_b1+Fex*XIMsub_Vb_b1_Vs_c1);
#endif
#if defined(_DERIVATE)
XIsub_Vb1_b2=((Fex_Vb1_b2*XIMsub)+(Fex*XIMsub_Vb1_b2));
#endif
#if defined(_DERIVATE)
XIsub_Vc4_c1=((Fex_Vc4_c1*XIMsub)+(Fex*XIMsub_Vc4_c1));
#endif
#if defined(_DERIVATE)
XIsub_Vc3_c1=((Fex_Vc3_c1*XIMsub)+(Fex*XIMsub_Vc3_c1));
#endif
#if defined(_DERIVATE)
XIsub_Vc3_c4=((Fex_Vc3_c4*XIMsub)+(Fex*XIMsub_Vc3_c4));
#endif
#if defined(_DERIVATE)
XIsub_Vb2_e1=Fex_Vb2_e1*XIMsub;
#endif
#if defined(_DERIVATE)
XIsub_Vb2_c2=((Fex_Vb2_c2*XIMsub)+(Fex*XIMsub_Vb2_c2));
#endif
#if defined(_DERIVATE)
XIsub_Vb2_c1=Fex_Vb2_c1*XIMsub;
#endif
#if defined(_DERIVATE)
XIsub_Vc1_c2=((Fex_Vc1_c2*XIMsub)+(Fex*XIMsub_Vc1_c2));
#endif
#if defined(_DERIVATE)
XIsub_Vs_c1=((Fex_Vs_c1*XIMsub)+(Fex*XIMsub_Vs_c1));
#endif
#endif
pInst->XIsub=(Fex*XIMsub);
EXIT_IF_ISNAN((Fex*XIMsub))
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
Fex_Vdt_GND=0.0;
#endif
Fex_Vb_c=0.0;
#if defined(_DERIVATE2)
  Fex_Vb_c_Vdt_GND=0.0;
  Fex_Vb_c_Vb_c=0.0;
  Fex_Vb_c_Vb_b1=0.0;
  Fex_Vb_c_Vb1_b2=0.0;
  Fex_Vb_c_Vc4_c1=0.0;
  Fex_Vb_c_Vc3_c1=0.0;
  Fex_Vb_c_Vc3_c4=0.0;
  Fex_Vb_c_Vb2_e1=0.0;
  Fex_Vb_c_Vb2_c2=0.0;
  Fex_Vb_c_Vb2_c1=0.0;
  Fex_Vb_c_Vc1_c2=0.0;
  Fex_Vb_c_Vs_c1=0.0;
#endif
Fex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  Fex_Vb_b1_Vdt_GND=0.0;
  Fex_Vb_b1_Vb_c=0.0;
  Fex_Vb_b1_Vb_b1=0.0;
  Fex_Vb_b1_Vb1_b2=0.0;
  Fex_Vb_b1_Vc4_c1=0.0;
  Fex_Vb_b1_Vc3_c1=0.0;
  Fex_Vb_b1_Vc3_c4=0.0;
  Fex_Vb_b1_Vb2_e1=0.0;
  Fex_Vb_b1_Vb2_c2=0.0;
  Fex_Vb_b1_Vb2_c1=0.0;
  Fex_Vb_b1_Vc1_c2=0.0;
  Fex_Vb_b1_Vs_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
Fex_Vs_c1=0.0;
#endif
#endif
Fex=0;
EXIT_IF_ISNAN(0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XnBex_Vdt_GND=0.0;
#endif
XnBex_Vb_c=0.0;
#if defined(_DERIVATE2)
  XnBex_Vb_c_Vdt_GND=0.0;
  XnBex_Vb_c_Vb_c=0.0;
  XnBex_Vb_c_Vb_b1=0.0;
  XnBex_Vb_c_Vb1_b2=0.0;
  XnBex_Vb_c_Vb2_c2=0.0;
  XnBex_Vb_c_Vc1_c2=0.0;
  XnBex_Vb_c_Vc4_c1=0.0;
  XnBex_Vb_c_Vc3_c1=0.0;
  XnBex_Vb_c_Vc3_c4=0.0;
#endif
XnBex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  XnBex_Vb_b1_Vdt_GND=0.0;
  XnBex_Vb_b1_Vb_c=0.0;
  XnBex_Vb_b1_Vb_b1=0.0;
  XnBex_Vb_b1_Vb1_b2=0.0;
  XnBex_Vb_b1_Vb2_c2=0.0;
  XnBex_Vb_b1_Vc1_c2=0.0;
  XnBex_Vb_b1_Vc4_c1=0.0;
  XnBex_Vb_b1_Vc3_c1=0.0;
  XnBex_Vb_b1_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
XnBex_Vc3_c4=0.0;
#endif
#endif
XnBex=0;
EXIT_IF_ISNAN(0)
#endif
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
#if defined(_DERIVATE)
q0Q_Vdt_GND=(((Vte_Vdt_GND*VER_T-Vte*VER_T_Vdt_GND)/VER_T/VER_T)+((Vtc_Vdt_GND*VEF_T-Vtc*VEF_T_Vdt_GND)/VEF_T/VEF_T));
#endif
q0Q_Vb2_e1=((Vte_Vb2_e1/VER_T)+(Vtc_Vb2_e1/VEF_T));
#if defined(_DERIVATE2)
  q0Q_Vb2_e1_Vdt_GND=(+(+0.0+(Vte_Vb2_e1_Vdt_GND/VER_T-(Vte_Vb2_e1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vdt_GND/VEF_T-(Vtc_Vb2_e1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_e1_Vb2_e1=(+(+0.0+(Vte_Vb2_e1_Vb2_e1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_e1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_e1_Vb2_c2=(+(+0.0+(Vte_Vb2_e1_Vb2_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_e1_Vb2_c1=(+(+0.0+(Vte_Vb2_e1_Vb2_c1/VER_T-(Vte_Vb2_e1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vb2_c1/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_e1_Vc1_c2=(+(+0.0+(Vte_Vb2_e1_Vc1_c2/VER_T-(Vte_Vb2_e1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_e1_Vc1_c2/VEF_T-(Vtc_Vb2_e1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0Q_Vb2_c2=((Vte_Vb2_c2/VER_T)+(Vtc_Vb2_c2/VEF_T));
#if defined(_DERIVATE2)
  q0Q_Vb2_c2_Vdt_GND=(+(+0.0+(Vte_Vb2_c2_Vdt_GND/VER_T-(Vte_Vb2_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vdt_GND/VEF_T-(Vtc_Vb2_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c2_Vb2_e1=(+(+0.0+(Vte_Vb2_c2_Vb2_e1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_e1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c2_Vb2_c2=(+(+0.0+(Vte_Vb2_c2_Vb2_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c2_Vb2_c1=(+(+0.0+(Vte_Vb2_c2_Vb2_c1/VER_T-(Vte_Vb2_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vb2_c1/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c2_Vc1_c2=(+(+0.0+(Vte_Vb2_c2_Vc1_c2/VER_T-(Vte_Vb2_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c2_Vc1_c2/VEF_T-(Vtc_Vb2_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0Q_Vb2_c1=((Vte_Vb2_c1/VER_T)+(Vtc_Vb2_c1/VEF_T));
#if defined(_DERIVATE2)
  q0Q_Vb2_c1_Vdt_GND=(+(+0.0+(Vte_Vb2_c1_Vdt_GND/VER_T-(Vte_Vb2_c1*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vdt_GND/VEF_T-(Vtc_Vb2_c1*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c1_Vb2_e1=(+(+0.0+(Vte_Vb2_c1_Vb2_e1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_e1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c1_Vb2_c2=(+(+0.0+(Vte_Vb2_c1_Vb2_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c1_Vb2_c1=(+(+0.0+(Vte_Vb2_c1_Vb2_c1/VER_T-(Vte_Vb2_c1*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vb2_c1/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vb2_c1_Vc1_c2=(+(+0.0+(Vte_Vb2_c1_Vc1_c2/VER_T-(Vte_Vb2_c1*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vb2_c1_Vc1_c2/VEF_T-(Vtc_Vb2_c1*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
q0Q_Vc1_c2=((Vte_Vc1_c2/VER_T)+(Vtc_Vc1_c2/VEF_T));
#if defined(_DERIVATE2)
  q0Q_Vc1_c2_Vdt_GND=(+(+0.0+(Vte_Vc1_c2_Vdt_GND/VER_T-(Vte_Vc1_c2*VER_T_Vdt_GND+Vte_Vdt_GND*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*VER_T_Vdt_GND/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vdt_GND/VEF_T-(Vtc_Vc1_c2*VEF_T_Vdt_GND+Vtc_Vdt_GND*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*VEF_T_Vdt_GND/VEF_T/VEF_T/VEF_T));
  q0Q_Vc1_c2_Vb2_e1=(+(+0.0+(Vte_Vc1_c2_Vb2_e1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_e1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_e1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_e1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vc1_c2_Vb2_c2=(+(+0.0+(Vte_Vc1_c2_Vb2_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vc1_c2_Vb2_c1=(+(+0.0+(Vte_Vc1_c2_Vb2_c1/VER_T-(Vte_Vc1_c2*0.0+Vte_Vb2_c1*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vb2_c1/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vb2_c1*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
  q0Q_Vc1_c2_Vc1_c2=(+(+0.0+(Vte_Vc1_c2_Vc1_c2/VER_T-(Vte_Vc1_c2*0.0+Vte_Vc1_c2*0.0+Vte*0.0)/VER_T/VER_T+2*Vte*0.0*0.0/VER_T/VER_T/VER_T))+(Vtc_Vc1_c2_Vc1_c2/VEF_T-(Vtc_Vc1_c2*0.0+Vtc_Vc1_c2*0.0+Vtc*0.0)/VEF_T/VEF_T+2*Vtc*0.0*0.0/VEF_T/VEF_T/VEF_T));
#endif
#endif
q0Q=((1.0+(Vte/VER_T))+(Vtc/VEF_T));
EXIT_IF_ISNAN(((1.0+(Vte/VER_T))+(Vtc/VEF_T)))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
eps2_Vdt_GND=0.0;
#endif
eps2=(0.1*0.1);
EXIT_IF_ISNAN((0.1*0.1))
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b1,GND)V(s,GND)V(b,GND)V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
x2_Vb_c=0.0;
#if defined(_DERIVATE2)
  x2_Vb_c_Vb_c=0.0;
  x2_Vb_c_Vb_b1=0.0;
  x2_Vb_c_Vb1_b2=0.0;
  x2_Vb_c_Vc4_c1=0.0;
  x2_Vb_c_Vc3_c1=0.0;
  x2_Vb_c_Vc3_c4=0.0;
  x2_Vb_c_Vb2_e1=0.0;
  x2_Vb_c_Vdt_GND=0.0;
  x2_Vb_c_Vb2_c2=0.0;
  x2_Vb_c_Vb2_c1=0.0;
  x2_Vb_c_Vc1_c2=0.0;
#endif
x2_Vb_b1=0.0;
#if defined(_DERIVATE2)
  x2_Vb_b1_Vb_c=0.0;
  x2_Vb_b1_Vb_b1=0.0;
  x2_Vb_b1_Vb1_b2=0.0;
  x2_Vb_b1_Vc4_c1=0.0;
  x2_Vb_b1_Vc3_c1=0.0;
  x2_Vb_b1_Vc3_c4=0.0;
  x2_Vb_b1_Vb2_e1=0.0;
  x2_Vb_b1_Vdt_GND=0.0;
  x2_Vb_b1_Vb2_c2=0.0;
  x2_Vb_b1_Vb2_c1=0.0;
  x2_Vb_b1_Vc1_c2=0.0;
#endif
x2_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  x2_Vb1_b2_Vb_c=0.0;
  x2_Vb1_b2_Vb_b1=0.0;
  x2_Vb1_b2_Vb1_b2=0.0;
  x2_Vb1_b2_Vc4_c1=0.0;
  x2_Vb1_b2_Vc3_c1=0.0;
  x2_Vb1_b2_Vc3_c4=0.0;
  x2_Vb1_b2_Vb2_e1=0.0;
  x2_Vb1_b2_Vdt_GND=0.0;
  x2_Vb1_b2_Vb2_c2=0.0;
  x2_Vb1_b2_Vb2_c1=0.0;
  x2_Vb1_b2_Vc1_c2=0.0;
#endif
x2_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc4_c1_Vb_c=0.0;
  x2_Vc4_c1_Vb_b1=0.0;
  x2_Vc4_c1_Vb1_b2=0.0;
  x2_Vc4_c1_Vc4_c1=0.0;
  x2_Vc4_c1_Vc3_c1=0.0;
  x2_Vc4_c1_Vc3_c4=0.0;
  x2_Vc4_c1_Vb2_e1=0.0;
  x2_Vc4_c1_Vdt_GND=0.0;
  x2_Vc4_c1_Vb2_c2=0.0;
  x2_Vc4_c1_Vb2_c1=0.0;
  x2_Vc4_c1_Vc1_c2=0.0;
#endif
x2_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  x2_Vc3_c1_Vb_c=0.0;
  x2_Vc3_c1_Vb_b1=0.0;
  x2_Vc3_c1_Vb1_b2=0.0;
  x2_Vc3_c1_Vc4_c1=0.0;
  x2_Vc3_c1_Vc3_c1=0.0;
  x2_Vc3_c1_Vc3_c4=0.0;
  x2_Vc3_c1_Vb2_e1=0.0;
  x2_Vc3_c1_Vdt_GND=0.0;
  x2_Vc3_c1_Vb2_c2=0.0;
  x2_Vc3_c1_Vb2_c1=0.0;
  x2_Vc3_c1_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
x2_Vc3_c4=0.0;
#endif
x2_Vb2_e1=((q0Q_Vb2_e1*q0Q)+(q0Q*q0Q_Vb2_e1));
#if defined(_DERIVATE2)
  x2_Vb2_e1_Vb_c=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vb_b1=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vb1_b2=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vc4_c1=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vc3_c1=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vc3_c4=(+0.0*q0Q+q0Q_Vb2_e1*0.0+0.0*q0Q_Vb2_e1+q0Q*0.0);
  x2_Vb2_e1_Vb2_e1=(+q0Q_Vb2_e1_Vb2_e1*q0Q+q0Q_Vb2_e1*q0Q_Vb2_e1+q0Q_Vb2_e1*q0Q_Vb2_e1+q0Q*q0Q_Vb2_e1_Vb2_e1);
  x2_Vb2_e1_Vdt_GND=(+q0Q_Vb2_e1_Vdt_GND*q0Q+q0Q_Vb2_e1*q0Q_Vdt_GND+q0Q_Vdt_GND*q0Q_Vb2_e1+q0Q*q0Q_Vb2_e1_Vdt_GND);
  x2_Vb2_e1_Vb2_c2=(+q0Q_Vb2_e1_Vb2_c2*q0Q+q0Q_Vb2_e1*q0Q_Vb2_c2+q0Q_Vb2_c2*q0Q_Vb2_e1+q0Q*q0Q_Vb2_e1_Vb2_c2);
  x2_Vb2_e1_Vb2_c1=(+q0Q_Vb2_e1_Vb2_c1*q0Q+q0Q_Vb2_e1*q0Q_Vb2_c1+q0Q_Vb2_c1*q0Q_Vb2_e1+q0Q*q0Q_Vb2_e1_Vb2_c1);
  x2_Vb2_e1_Vc1_c2=(+q0Q_Vb2_e1_Vc1_c2*q0Q+q0Q_Vb2_e1*q0Q_Vc1_c2+q0Q_Vc1_c2*q0Q_Vb2_e1+q0Q*q0Q_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
x2_Vdt_GND=((q0Q_Vdt_GND*q0Q)+(q0Q*q0Q_Vdt_GND));
#endif
x2_Vb2_c2=((q0Q_Vb2_c2*q0Q)+(q0Q*q0Q_Vb2_c2));
#if defined(_DERIVATE2)
  x2_Vb2_c2_Vb_c=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vb_b1=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vb1_b2=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vc4_c1=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vc3_c1=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vc3_c4=(+0.0*q0Q+q0Q_Vb2_c2*0.0+0.0*q0Q_Vb2_c2+q0Q*0.0);
  x2_Vb2_c2_Vb2_e1=(+q0Q_Vb2_c2_Vb2_e1*q0Q+q0Q_Vb2_c2*q0Q_Vb2_e1+q0Q_Vb2_e1*q0Q_Vb2_c2+q0Q*q0Q_Vb2_c2_Vb2_e1);
  x2_Vb2_c2_Vdt_GND=(+q0Q_Vb2_c2_Vdt_GND*q0Q+q0Q_Vb2_c2*q0Q_Vdt_GND+q0Q_Vdt_GND*q0Q_Vb2_c2+q0Q*q0Q_Vb2_c2_Vdt_GND);
  x2_Vb2_c2_Vb2_c2=(+q0Q_Vb2_c2_Vb2_c2*q0Q+q0Q_Vb2_c2*q0Q_Vb2_c2+q0Q_Vb2_c2*q0Q_Vb2_c2+q0Q*q0Q_Vb2_c2_Vb2_c2);
  x2_Vb2_c2_Vb2_c1=(+q0Q_Vb2_c2_Vb2_c1*q0Q+q0Q_Vb2_c2*q0Q_Vb2_c1+q0Q_Vb2_c1*q0Q_Vb2_c2+q0Q*q0Q_Vb2_c2_Vb2_c1);
  x2_Vb2_c2_Vc1_c2=(+q0Q_Vb2_c2_Vc1_c2*q0Q+q0Q_Vb2_c2*q0Q_Vc1_c2+q0Q_Vc1_c2*q0Q_Vb2_c2+q0Q*q0Q_Vb2_c2_Vc1_c2);
#endif
x2_Vb2_c1=((q0Q_Vb2_c1*q0Q)+(q0Q*q0Q_Vb2_c1));
#if defined(_DERIVATE2)
  x2_Vb2_c1_Vb_c=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vb_b1=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vb1_b2=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vc4_c1=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vc3_c1=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vc3_c4=(+0.0*q0Q+q0Q_Vb2_c1*0.0+0.0*q0Q_Vb2_c1+q0Q*0.0);
  x2_Vb2_c1_Vb2_e1=(+q0Q_Vb2_c1_Vb2_e1*q0Q+q0Q_Vb2_c1*q0Q_Vb2_e1+q0Q_Vb2_e1*q0Q_Vb2_c1+q0Q*q0Q_Vb2_c1_Vb2_e1);
  x2_Vb2_c1_Vdt_GND=(+q0Q_Vb2_c1_Vdt_GND*q0Q+q0Q_Vb2_c1*q0Q_Vdt_GND+q0Q_Vdt_GND*q0Q_Vb2_c1+q0Q*q0Q_Vb2_c1_Vdt_GND);
  x2_Vb2_c1_Vb2_c2=(+q0Q_Vb2_c1_Vb2_c2*q0Q+q0Q_Vb2_c1*q0Q_Vb2_c2+q0Q_Vb2_c2*q0Q_Vb2_c1+q0Q*q0Q_Vb2_c1_Vb2_c2);
  x2_Vb2_c1_Vb2_c1=(+q0Q_Vb2_c1_Vb2_c1*q0Q+q0Q_Vb2_c1*q0Q_Vb2_c1+q0Q_Vb2_c1*q0Q_Vb2_c1+q0Q*q0Q_Vb2_c1_Vb2_c1);
  x2_Vb2_c1_Vc1_c2=(+q0Q_Vb2_c1_Vc1_c2*q0Q+q0Q_Vb2_c1*q0Q_Vc1_c2+q0Q_Vc1_c2*q0Q_Vb2_c1+q0Q*q0Q_Vb2_c1_Vc1_c2);
#endif
x2_Vc1_c2=((q0Q_Vc1_c2*q0Q)+(q0Q*q0Q_Vc1_c2));
#if defined(_DERIVATE2)
  x2_Vc1_c2_Vb_c=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vb_b1=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vb1_b2=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vc4_c1=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vc3_c1=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vc3_c4=(+0.0*q0Q+q0Q_Vc1_c2*0.0+0.0*q0Q_Vc1_c2+q0Q*0.0);
  x2_Vc1_c2_Vb2_e1=(+q0Q_Vc1_c2_Vb2_e1*q0Q+q0Q_Vc1_c2*q0Q_Vb2_e1+q0Q_Vb2_e1*q0Q_Vc1_c2+q0Q*q0Q_Vc1_c2_Vb2_e1);
  x2_Vc1_c2_Vdt_GND=(+q0Q_Vc1_c2_Vdt_GND*q0Q+q0Q_Vc1_c2*q0Q_Vdt_GND+q0Q_Vdt_GND*q0Q_Vc1_c2+q0Q*q0Q_Vc1_c2_Vdt_GND);
  x2_Vc1_c2_Vb2_c2=(+q0Q_Vc1_c2_Vb2_c2*q0Q+q0Q_Vc1_c2*q0Q_Vb2_c2+q0Q_Vb2_c2*q0Q_Vc1_c2+q0Q*q0Q_Vc1_c2_Vb2_c2);
  x2_Vc1_c2_Vb2_c1=(+q0Q_Vc1_c2_Vb2_c1*q0Q+q0Q_Vc1_c2*q0Q_Vb2_c1+q0Q_Vb2_c1*q0Q_Vc1_c2+q0Q*q0Q_Vc1_c2_Vb2_c1);
  x2_Vc1_c2_Vc1_c2=(+q0Q_Vc1_c2_Vc1_c2*q0Q+q0Q_Vc1_c2*q0Q_Vc1_c2+q0Q_Vc1_c2*q0Q_Vc1_c2+q0Q*q0Q_Vc1_c2_Vc1_c2);
#endif
#endif
x2=(q0Q*q0Q);
EXIT_IF_ISNAN((q0Q*q0Q))
if
((q0Q<0.0))
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
#if defined(_DERIVATE)
q1Q_Vdt_GND=(((0.5*eps2_Vdt_GND)*(d00_sqrt0-q0Q)-(0.5*eps2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
#if defined(_DERIVATE)
q1Q_Vb_c=(-(0.5*eps2)*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
#if defined(_DERIVATE)
q1Q_Vb_b1=(-(0.5*eps2)*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vb1_b2=(-(0.5*eps2)*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vb1_b2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vdt_GND+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_e1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb1_b2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*x2_Vb1_b2*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc1_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vb1_b2*d10_sqrt0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vc4_c1=(-(0.5*eps2)*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vc4_c1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vdt_GND+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_e1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc4_c1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*x2_Vc4_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc1_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc4_c1*d10_sqrt0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vc3_c1=(-(0.5*eps2)*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vc3_c1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vdt_GND+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_e1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc3_c1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*x2_Vc3_c1*d10_sqrt0+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc1_c2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*x2_Vc3_c1*d10_sqrt0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
#if defined(_DERIVATE)
q1Q_Vc3_c4=(-(0.5*eps2)*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vb2_e1=(-(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vb2_e1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vdt_GND+0.0))-q0Q_Vb2_e1_Vdt_GND))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_e1+0.0))-q0Q_Vb2_e1_Vb2_e1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c2+0.0))-q0Q_Vb2_e1_Vb2_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c1+0.0))-q0Q_Vb2_e1_Vb2_c1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_e1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc1_c2+0.0))-q0Q_Vb2_e1_Vc1_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vb2_c2=(-(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vb2_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))-q0Q_Vb2_c2_Vdt_GND))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_e1+0.0))-q0Q_Vb2_c2_Vb2_e1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))-q0Q_Vb2_c2_Vb2_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))-q0Q_Vb2_c2_Vb2_c1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))-q0Q_Vb2_c2_Vc1_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vb2_c1=(-(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vb2_c1_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))-q0Q_Vb2_c1_Vdt_GND))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_e1+0.0))-q0Q_Vb2_c1_Vb2_e1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))-q0Q_Vb2_c1_Vb2_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))-q0Q_Vb2_c1_Vb2_c1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vb2_c1_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))-q0Q_Vb2_c1_Vc1_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
q1Q_Vc1_c2=(-(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#if defined(_DERIVATE2)
  q1Q_Vc1_c2_Vdt_GND=((+0.0*eps2+0.0*eps2_Vdt_GND+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)+((0.5*eps2_Vdt_GND))*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))-q0Q_Vc1_c2_Vdt_GND))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0-q0Q_Vdt_GND)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb_c=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_c*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb_c+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vb_c*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb_b1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb_b1*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb_b1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vb_b1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb1_b2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vb1_b2*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb1_b2+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vb1_b2*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vc4_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc4_c1*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc4_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vc4_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vc3_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c1*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc3_c1+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vc3_c1*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vc3_c4=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*x2_Vc3_c4*d10_sqrt0+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc3_c4+0.0))-0.0))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*x2_Vc3_c4*d10_sqrt0/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb2_e1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_e1+0.0))-q0Q_Vc1_c2_Vb2_e1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*(x2_Vb2_e1*d10_sqrt0-q0Q_Vb2_e1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb2_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))-q0Q_Vc1_c2_Vb2_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*(x2_Vb2_c2*d10_sqrt0-q0Q_Vb2_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vb2_c1=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))-q0Q_Vc1_c2_Vb2_c1))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*(x2_Vb2_c1*d10_sqrt0-q0Q_Vb2_c1)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
  q1Q_Vc1_c2_Vc1_c2=((+0.0*eps2+0.0*0.0+0.0*0.0+0.5*0.0)/(d00_sqrt0-q0Q)-(0.0*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.0)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)+(0.5*eps2)*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))-q0Q_Vc1_c2_Vc1_c2))/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)+2*(0.5*eps2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)*(x2_Vc1_c2*d10_sqrt0-q0Q_Vc1_c2)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q)/(d00_sqrt0-q0Q));
#endif
#endif
pInst->q1Q=((0.5*eps2)/(d00_sqrt0-q0Q));
EXIT_IF_ISNAN(((0.5*eps2)/(d00_sqrt0-q0Q)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(x2+eps2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(x2+eps2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
#if defined(_DERIVATE)
q1Q_Vdt_GND=(0.5*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND));
#endif
#if defined(_DERIVATE)
q1Q_Vb_c=(0.5*x2_Vb_c*d10_sqrt0);
#endif
#if defined(_DERIVATE)
q1Q_Vb_b1=(0.5*x2_Vb_b1*d10_sqrt0);
#endif
q1Q_Vb1_b2=(0.5*x2_Vb1_b2*d10_sqrt0);
#if defined(_DERIVATE2)
  q1Q_Vb1_b2_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vdt_GND+0.0))+0.0));
  q1Q_Vb1_b2_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb_c+0.0))+0.0));
  q1Q_Vb1_b2_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb_b1+0.0))+0.0));
  q1Q_Vb1_b2_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb1_b2+0.0))+0.0));
  q1Q_Vb1_b2_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc4_c1+0.0))+0.0));
  q1Q_Vb1_b2_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc3_c1+0.0))+0.0));
  q1Q_Vb1_b2_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc3_c4+0.0))+0.0));
  q1Q_Vb1_b2_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_e1+0.0))+0.0));
  q1Q_Vb1_b2_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_c2+0.0))+0.0));
  q1Q_Vb1_b2_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vb2_c1+0.0))+0.0));
  q1Q_Vb1_b2_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*x2_Vb1_b2*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb1_b2+d10_sqrt0*(+x2_Vb1_b2_Vc1_c2+0.0))+0.0));
#endif
q1Q_Vc4_c1=(0.5*x2_Vc4_c1*d10_sqrt0);
#if defined(_DERIVATE2)
  q1Q_Vc4_c1_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vdt_GND+0.0))+0.0));
  q1Q_Vc4_c1_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb_c+0.0))+0.0));
  q1Q_Vc4_c1_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb_b1+0.0))+0.0));
  q1Q_Vc4_c1_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb1_b2+0.0))+0.0));
  q1Q_Vc4_c1_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc4_c1+0.0))+0.0));
  q1Q_Vc4_c1_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc3_c1+0.0))+0.0));
  q1Q_Vc4_c1_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc3_c4+0.0))+0.0));
  q1Q_Vc4_c1_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_e1+0.0))+0.0));
  q1Q_Vc4_c1_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_c2+0.0))+0.0));
  q1Q_Vc4_c1_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vb2_c1+0.0))+0.0));
  q1Q_Vc4_c1_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*x2_Vc4_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc4_c1+d10_sqrt0*(+x2_Vc4_c1_Vc1_c2+0.0))+0.0));
#endif
q1Q_Vc3_c1=(0.5*x2_Vc3_c1*d10_sqrt0);
#if defined(_DERIVATE2)
  q1Q_Vc3_c1_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vdt_GND+0.0))+0.0));
  q1Q_Vc3_c1_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb_c+0.0))+0.0));
  q1Q_Vc3_c1_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb_b1+0.0))+0.0));
  q1Q_Vc3_c1_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb1_b2+0.0))+0.0));
  q1Q_Vc3_c1_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc4_c1+0.0))+0.0));
  q1Q_Vc3_c1_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc3_c1+0.0))+0.0));
  q1Q_Vc3_c1_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc3_c4+0.0))+0.0));
  q1Q_Vc3_c1_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_e1+0.0))+0.0));
  q1Q_Vc3_c1_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_c2+0.0))+0.0));
  q1Q_Vc3_c1_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vb2_c1+0.0))+0.0));
  q1Q_Vc3_c1_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*x2_Vc3_c1*d10_sqrt0+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc3_c1+d10_sqrt0*(+x2_Vc3_c1_Vc1_c2+0.0))+0.0));
#endif
#if defined(_DERIVATE)
q1Q_Vc3_c4=(0.5*x2_Vc3_c4*d10_sqrt0);
#endif
q1Q_Vb2_e1=(0.5*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1));
#if defined(_DERIVATE2)
  q1Q_Vb2_e1_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vdt_GND+0.0))+q0Q_Vb2_e1_Vdt_GND));
  q1Q_Vb2_e1_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb_c+0.0))+0.0));
  q1Q_Vb2_e1_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb_b1+0.0))+0.0));
  q1Q_Vb2_e1_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb1_b2+0.0))+0.0));
  q1Q_Vb2_e1_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc4_c1+0.0))+0.0));
  q1Q_Vb2_e1_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc3_c1+0.0))+0.0));
  q1Q_Vb2_e1_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc3_c4+0.0))+0.0));
  q1Q_Vb2_e1_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_e1+0.0))+q0Q_Vb2_e1_Vb2_e1));
  q1Q_Vb2_e1_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c2+0.0))+q0Q_Vb2_e1_Vb2_c2));
  q1Q_Vb2_e1_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vb2_c1+0.0))+q0Q_Vb2_e1_Vb2_c1));
  q1Q_Vb2_e1_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_e1+d10_sqrt0*(+x2_Vb2_e1_Vc1_c2+0.0))+q0Q_Vb2_e1_Vc1_c2));
#endif
q1Q_Vb2_c2=(0.5*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2));
#if defined(_DERIVATE2)
  q1Q_Vb2_c2_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vdt_GND+0.0))+q0Q_Vb2_c2_Vdt_GND));
  q1Q_Vb2_c2_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb_c+0.0))+0.0));
  q1Q_Vb2_c2_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb_b1+0.0))+0.0));
  q1Q_Vb2_c2_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb1_b2+0.0))+0.0));
  q1Q_Vb2_c2_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc4_c1+0.0))+0.0));
  q1Q_Vb2_c2_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc3_c1+0.0))+0.0));
  q1Q_Vb2_c2_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc3_c4+0.0))+0.0));
  q1Q_Vb2_c2_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_e1+0.0))+q0Q_Vb2_c2_Vb2_e1));
  q1Q_Vb2_c2_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c2+0.0))+q0Q_Vb2_c2_Vb2_c2));
  q1Q_Vb2_c2_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vb2_c1+0.0))+q0Q_Vb2_c2_Vb2_c1));
  q1Q_Vb2_c2_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c2+d10_sqrt0*(+x2_Vb2_c2_Vc1_c2+0.0))+q0Q_Vb2_c2_Vc1_c2));
#endif
q1Q_Vb2_c1=(0.5*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1));
#if defined(_DERIVATE2)
  q1Q_Vb2_c1_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vdt_GND+0.0))+q0Q_Vb2_c1_Vdt_GND));
  q1Q_Vb2_c1_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb_c+0.0))+0.0));
  q1Q_Vb2_c1_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb_b1+0.0))+0.0));
  q1Q_Vb2_c1_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb1_b2+0.0))+0.0));
  q1Q_Vb2_c1_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc4_c1+0.0))+0.0));
  q1Q_Vb2_c1_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc3_c1+0.0))+0.0));
  q1Q_Vb2_c1_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc3_c4+0.0))+0.0));
  q1Q_Vb2_c1_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_e1+0.0))+q0Q_Vb2_c1_Vb2_e1));
  q1Q_Vb2_c1_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c2+0.0))+q0Q_Vb2_c1_Vb2_c2));
  q1Q_Vb2_c1_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vb2_c1+0.0))+q0Q_Vb2_c1_Vb2_c1));
  q1Q_Vb2_c1_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vb2_c1+d10_sqrt0*(+x2_Vb2_c1_Vc1_c2+0.0))+q0Q_Vb2_c1_Vc1_c2));
#endif
q1Q_Vc1_c2=(0.5*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2));
#if defined(_DERIVATE2)
  q1Q_Vc1_c2_Vdt_GND=(+0.0*(d00_sqrt0+q0Q)+0.0*((x2_Vdt_GND+eps2_Vdt_GND)*d10_sqrt0+q0Q_Vdt_GND)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*(x2_Vdt_GND+eps2_Vdt_GND)*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vdt_GND+0.0))+q0Q_Vc1_c2_Vdt_GND));
  q1Q_Vc1_c2_Vb_c=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_c*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_c*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb_c+0.0))+0.0));
  q1Q_Vc1_c2_Vb_b1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb_b1*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb_b1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb_b1+0.0))+0.0));
  q1Q_Vc1_c2_Vb1_b2=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vb1_b2*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb1_b2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb1_b2+0.0))+0.0));
  q1Q_Vc1_c2_Vc4_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc4_c1*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc4_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc4_c1+0.0))+0.0));
  q1Q_Vc1_c2_Vc3_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c1*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc3_c1+0.0))+0.0));
  q1Q_Vc1_c2_Vc3_c4=(+0.0*(d00_sqrt0+q0Q)+0.0*x2_Vc3_c4*d10_sqrt0+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc3_c4*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc3_c4+0.0))+0.0));
  q1Q_Vc1_c2_Vb2_e1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_e1*d10_sqrt0+q0Q_Vb2_e1)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_e1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_e1+0.0))+q0Q_Vc1_c2_Vb2_e1));
  q1Q_Vc1_c2_Vb2_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c2*d10_sqrt0+q0Q_Vb2_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c2+0.0))+q0Q_Vc1_c2_Vb2_c2));
  q1Q_Vc1_c2_Vb2_c1=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vb2_c1*d10_sqrt0+q0Q_Vb2_c1)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vb2_c1*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vb2_c1+0.0))+q0Q_Vc1_c2_Vb2_c1));
  q1Q_Vc1_c2_Vc1_c2=(+0.0*(d00_sqrt0+q0Q)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.0*(x2_Vc1_c2*d10_sqrt0+q0Q_Vc1_c2)+0.5*(+(m20_sqrt((x2+eps2))*x2_Vc1_c2*x2_Vc1_c2+d10_sqrt0*(+x2_Vc1_c2_Vc1_c2+0.0))+q0Q_Vc1_c2_Vc1_c2));
#endif
#endif
pInst->q1Q=(0.5*(d00_sqrt0+q0Q));
EXIT_IF_ISNAN((0.5*(d00_sqrt0+q0Q)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
#if defined(_DERIVATE)
q1Q_Vdt_GND=q1Q_Vdt_GND;
#endif
#if defined(_DERIVATE)
q1Q_Vb_c=q1Q_Vb_c;
#endif
#if defined(_DERIVATE)
q1Q_Vb_b1=q1Q_Vb_b1;
#endif
q1Q_Vb1_b2=q1Q_Vb1_b2;
#if defined(_DERIVATE2)
  q1Q_Vb1_b2_Vdt_GND=q1Q_Vb1_b2_Vdt_GND;
  q1Q_Vb1_b2_Vb_c=q1Q_Vb1_b2_Vb_c;
  q1Q_Vb1_b2_Vb_b1=q1Q_Vb1_b2_Vb_b1;
  q1Q_Vb1_b2_Vb1_b2=q1Q_Vb1_b2_Vb1_b2;
  q1Q_Vb1_b2_Vc4_c1=q1Q_Vb1_b2_Vc4_c1;
  q1Q_Vb1_b2_Vc3_c1=q1Q_Vb1_b2_Vc3_c1;
  q1Q_Vb1_b2_Vc3_c4=q1Q_Vb1_b2_Vc3_c4;
  q1Q_Vb1_b2_Vb2_e1=q1Q_Vb1_b2_Vb2_e1;
  q1Q_Vb1_b2_Vb2_c2=q1Q_Vb1_b2_Vb2_c2;
  q1Q_Vb1_b2_Vb2_c1=q1Q_Vb1_b2_Vb2_c1;
  q1Q_Vb1_b2_Vc1_c2=q1Q_Vb1_b2_Vc1_c2;
#endif
q1Q_Vc4_c1=q1Q_Vc4_c1;
#if defined(_DERIVATE2)
  q1Q_Vc4_c1_Vdt_GND=q1Q_Vc4_c1_Vdt_GND;
  q1Q_Vc4_c1_Vb_c=q1Q_Vc4_c1_Vb_c;
  q1Q_Vc4_c1_Vb_b1=q1Q_Vc4_c1_Vb_b1;
  q1Q_Vc4_c1_Vb1_b2=q1Q_Vc4_c1_Vb1_b2;
  q1Q_Vc4_c1_Vc4_c1=q1Q_Vc4_c1_Vc4_c1;
  q1Q_Vc4_c1_Vc3_c1=q1Q_Vc4_c1_Vc3_c1;
  q1Q_Vc4_c1_Vc3_c4=q1Q_Vc4_c1_Vc3_c4;
  q1Q_Vc4_c1_Vb2_e1=q1Q_Vc4_c1_Vb2_e1;
  q1Q_Vc4_c1_Vb2_c2=q1Q_Vc4_c1_Vb2_c2;
  q1Q_Vc4_c1_Vb2_c1=q1Q_Vc4_c1_Vb2_c1;
  q1Q_Vc4_c1_Vc1_c2=q1Q_Vc4_c1_Vc1_c2;
#endif
q1Q_Vc3_c1=q1Q_Vc3_c1;
#if defined(_DERIVATE2)
  q1Q_Vc3_c1_Vdt_GND=q1Q_Vc3_c1_Vdt_GND;
  q1Q_Vc3_c1_Vb_c=q1Q_Vc3_c1_Vb_c;
  q1Q_Vc3_c1_Vb_b1=q1Q_Vc3_c1_Vb_b1;
  q1Q_Vc3_c1_Vb1_b2=q1Q_Vc3_c1_Vb1_b2;
  q1Q_Vc3_c1_Vc4_c1=q1Q_Vc3_c1_Vc4_c1;
  q1Q_Vc3_c1_Vc3_c1=q1Q_Vc3_c1_Vc3_c1;
  q1Q_Vc3_c1_Vc3_c4=q1Q_Vc3_c1_Vc3_c4;
  q1Q_Vc3_c1_Vb2_e1=q1Q_Vc3_c1_Vb2_e1;
  q1Q_Vc3_c1_Vb2_c2=q1Q_Vc3_c1_Vb2_c2;
  q1Q_Vc3_c1_Vb2_c1=q1Q_Vc3_c1_Vb2_c1;
  q1Q_Vc3_c1_Vc1_c2=q1Q_Vc3_c1_Vc1_c2;
#endif
#if defined(_DERIVATE)
q1Q_Vc3_c4=q1Q_Vc3_c4;
#endif
q1Q_Vb2_e1=q1Q_Vb2_e1;
#if defined(_DERIVATE2)
  q1Q_Vb2_e1_Vdt_GND=q1Q_Vb2_e1_Vdt_GND;
  q1Q_Vb2_e1_Vb_c=q1Q_Vb2_e1_Vb_c;
  q1Q_Vb2_e1_Vb_b1=q1Q_Vb2_e1_Vb_b1;
  q1Q_Vb2_e1_Vb1_b2=q1Q_Vb2_e1_Vb1_b2;
  q1Q_Vb2_e1_Vc4_c1=q1Q_Vb2_e1_Vc4_c1;
  q1Q_Vb2_e1_Vc3_c1=q1Q_Vb2_e1_Vc3_c1;
  q1Q_Vb2_e1_Vc3_c4=q1Q_Vb2_e1_Vc3_c4;
  q1Q_Vb2_e1_Vb2_e1=q1Q_Vb2_e1_Vb2_e1;
  q1Q_Vb2_e1_Vb2_c2=q1Q_Vb2_e1_Vb2_c2;
  q1Q_Vb2_e1_Vb2_c1=q1Q_Vb2_e1_Vb2_c1;
  q1Q_Vb2_e1_Vc1_c2=q1Q_Vb2_e1_Vc1_c2;
#endif
q1Q_Vb2_c2=q1Q_Vb2_c2;
#if defined(_DERIVATE2)
  q1Q_Vb2_c2_Vdt_GND=q1Q_Vb2_c2_Vdt_GND;
  q1Q_Vb2_c2_Vb_c=q1Q_Vb2_c2_Vb_c;
  q1Q_Vb2_c2_Vb_b1=q1Q_Vb2_c2_Vb_b1;
  q1Q_Vb2_c2_Vb1_b2=q1Q_Vb2_c2_Vb1_b2;
  q1Q_Vb2_c2_Vc4_c1=q1Q_Vb2_c2_Vc4_c1;
  q1Q_Vb2_c2_Vc3_c1=q1Q_Vb2_c2_Vc3_c1;
  q1Q_Vb2_c2_Vc3_c4=q1Q_Vb2_c2_Vc3_c4;
  q1Q_Vb2_c2_Vb2_e1=q1Q_Vb2_c2_Vb2_e1;
  q1Q_Vb2_c2_Vb2_c2=q1Q_Vb2_c2_Vb2_c2;
  q1Q_Vb2_c2_Vb2_c1=q1Q_Vb2_c2_Vb2_c1;
  q1Q_Vb2_c2_Vc1_c2=q1Q_Vb2_c2_Vc1_c2;
#endif
q1Q_Vb2_c1=q1Q_Vb2_c1;
#if defined(_DERIVATE2)
  q1Q_Vb2_c1_Vdt_GND=q1Q_Vb2_c1_Vdt_GND;
  q1Q_Vb2_c1_Vb_c=q1Q_Vb2_c1_Vb_c;
  q1Q_Vb2_c1_Vb_b1=q1Q_Vb2_c1_Vb_b1;
  q1Q_Vb2_c1_Vb1_b2=q1Q_Vb2_c1_Vb1_b2;
  q1Q_Vb2_c1_Vc4_c1=q1Q_Vb2_c1_Vc4_c1;
  q1Q_Vb2_c1_Vc3_c1=q1Q_Vb2_c1_Vc3_c1;
  q1Q_Vb2_c1_Vc3_c4=q1Q_Vb2_c1_Vc3_c4;
  q1Q_Vb2_c1_Vb2_e1=q1Q_Vb2_c1_Vb2_e1;
  q1Q_Vb2_c1_Vb2_c2=q1Q_Vb2_c1_Vb2_c2;
  q1Q_Vb2_c1_Vb2_c1=q1Q_Vb2_c1_Vb2_c1;
  q1Q_Vb2_c1_Vc1_c2=q1Q_Vb2_c1_Vc1_c2;
#endif
q1Q_Vc1_c2=q1Q_Vc1_c2;
#if defined(_DERIVATE2)
  q1Q_Vc1_c2_Vdt_GND=q1Q_Vc1_c2_Vdt_GND;
  q1Q_Vc1_c2_Vb_c=q1Q_Vc1_c2_Vb_c;
  q1Q_Vc1_c2_Vb_b1=q1Q_Vc1_c2_Vb_b1;
  q1Q_Vc1_c2_Vb1_b2=q1Q_Vc1_c2_Vb1_b2;
  q1Q_Vc1_c2_Vc4_c1=q1Q_Vc1_c2_Vc4_c1;
  q1Q_Vc1_c2_Vc3_c1=q1Q_Vc1_c2_Vc3_c1;
  q1Q_Vc1_c2_Vc3_c4=q1Q_Vc1_c2_Vc3_c4;
  q1Q_Vc1_c2_Vb2_e1=q1Q_Vc1_c2_Vb2_e1;
  q1Q_Vc1_c2_Vb2_c2=q1Q_Vc1_c2_Vb2_c2;
  q1Q_Vc1_c2_Vb2_c1=q1Q_Vc1_c2_Vb2_c1;
  q1Q_Vc1_c2_Vc1_c2=q1Q_Vc1_c2_Vc1_c2;
#endif
#endif
pInst->q1Q=pInst->q1Q;
EXIT_IF_ISNAN(pInst->q1Q)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
qBQ_Vdt_GND=((q1Q_Vdt_GND*(1.0+(0.5*(n0+nB))))+(pInst->q1Q*(0.5*(n0_Vdt_GND+nB_Vdt_GND))));
#endif
#if defined(_DERIVATE)
qBQ_Vb_c=q1Q_Vb_c*(1.0+(0.5*(n0+nB)));
#endif
#if defined(_DERIVATE)
qBQ_Vb_b1=q1Q_Vb_b1*(1.0+(0.5*(n0+nB)));
#endif
#if defined(_DERIVATE)
qBQ_Vb1_b2=q1Q_Vb1_b2*(1.0+(0.5*(n0+nB)));
#endif
qBQ_Vc4_c1=q1Q_Vc4_c1*(1.0+(0.5*(n0+nB)));
#if defined(_DERIVATE2)
  qBQ_Vc4_c1_Vdt_GND=(+q1Q_Vc4_c1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb_c=(+q1Q_Vc4_c1_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vb_c*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb_b1=(+q1Q_Vc4_c1_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vb_b1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb1_b2=(+q1Q_Vc4_c1_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vb1_b2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vc4_c1=(+q1Q_Vc4_c1_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vc4_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vc3_c1=(+q1Q_Vc4_c1_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vc3_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vc3_c4=(+q1Q_Vc4_c1_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*(0.0)+q1Q_Vc3_c4*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb2_e1=(+q1Q_Vc4_c1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb2_c2=(+q1Q_Vc4_c1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vb2_c1=(+q1Q_Vc4_c1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc4_c1_Vc1_c2=(+q1Q_Vc4_c1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc4_c1*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*0.0+0.5*(+0.0+0.0))));
#endif
qBQ_Vc3_c1=q1Q_Vc3_c1*(1.0+(0.5*(n0+nB)));
#if defined(_DERIVATE2)
  qBQ_Vc3_c1_Vdt_GND=(+q1Q_Vc3_c1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb_c=(+q1Q_Vc3_c1_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vb_c*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb_b1=(+q1Q_Vc3_c1_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vb_b1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb1_b2=(+q1Q_Vc3_c1_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vb1_b2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vc4_c1=(+q1Q_Vc3_c1_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vc4_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vc3_c1=(+q1Q_Vc3_c1_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vc3_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vc3_c4=(+q1Q_Vc3_c1_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*(0.0)+q1Q_Vc3_c4*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb2_e1=(+q1Q_Vc3_c1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb2_c2=(+q1Q_Vc3_c1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vb2_c1=(+q1Q_Vc3_c1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*0.0+0.5*(+0.0+0.0))));
  qBQ_Vc3_c1_Vc1_c2=(+q1Q_Vc3_c1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc3_c1*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*0.0+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*0.0+0.5*(+0.0+0.0))));
#endif
#if defined(_DERIVATE)
qBQ_Vc3_c4=q1Q_Vc3_c4*(1.0+(0.5*(n0+nB)));
#endif
qBQ_Vb2_e1=((q1Q_Vb2_e1*(1.0+(0.5*(n0+nB))))+(pInst->q1Q*(0.5*n0_Vb2_e1)));
#if defined(_DERIVATE2)
  qBQ_Vb2_e1_Vdt_GND=(+q1Q_Vb2_e1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*n0_Vb2_e1+0.5*(+n0_Vb2_e1_Vdt_GND+0.0))));
  qBQ_Vb2_e1_Vb_c=(+q1Q_Vb2_e1_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vb_c*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vb_b1=(+q1Q_Vb2_e1_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vb_b1*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vb1_b2=(+q1Q_Vb2_e1_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vb1_b2*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vc4_c1=(+q1Q_Vb2_e1_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vc4_c1*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vc3_c1=(+q1Q_Vb2_e1_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vc3_c1*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vc3_c4=(+q1Q_Vb2_e1_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*(0.0)+q1Q_Vc3_c4*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vb2_e1=(+q1Q_Vb2_e1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*n0_Vb2_e1+0.5*(+n0_Vb2_e1_Vb2_e1+0.0))));
  qBQ_Vb2_e1_Vb2_c2=(+q1Q_Vb2_e1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vb2_c1=(+q1Q_Vb2_e1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
  qBQ_Vb2_e1_Vc1_c2=(+q1Q_Vb2_e1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_e1*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*(0.5*n0_Vb2_e1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*n0_Vb2_e1+0.5*(+0.0+0.0))));
#endif
qBQ_Vb2_c2=((q1Q_Vb2_c2*(1.0+(0.5*(n0+nB))))+(pInst->q1Q*(0.5*nB_Vb2_c2)));
#if defined(_DERIVATE2)
  qBQ_Vb2_c2_Vdt_GND=(+q1Q_Vb2_c2_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vdt_GND))));
  qBQ_Vb2_c2_Vb_c=(+q1Q_Vb2_c2_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vb_c*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vb_b1=(+q1Q_Vb2_c2_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vb_b1*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vb1_b2=(+q1Q_Vb2_c2_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vb1_b2*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vc4_c1=(+q1Q_Vb2_c2_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vc4_c1*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vc3_c1=(+q1Q_Vb2_c2_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vc3_c1*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vc3_c4=(+q1Q_Vb2_c2_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*(0.0)+q1Q_Vc3_c4*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vb2_e1=(+q1Q_Vb2_c2_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vb2_c2+0.5*(+0.0+0.0))));
  qBQ_Vb2_c2_Vb2_c2=(+q1Q_Vb2_c2_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vb2_c2))));
  qBQ_Vb2_c2_Vb2_c1=(+q1Q_Vb2_c2_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vb2_c1))));
  qBQ_Vb2_c2_Vc1_c2=(+q1Q_Vb2_c2_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c2*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*(0.5*nB_Vb2_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vb2_c2+0.5*(+0.0+nB_Vb2_c2_Vc1_c2))));
#endif
qBQ_Vb2_c1=((q1Q_Vb2_c1*(1.0+(0.5*(n0+nB))))+(pInst->q1Q*(0.5*nB_Vb2_c1)));
#if defined(_DERIVATE2)
  qBQ_Vb2_c1_Vdt_GND=(+q1Q_Vb2_c1_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vdt_GND))));
  qBQ_Vb2_c1_Vb_c=(+q1Q_Vb2_c1_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vb_c*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vb_b1=(+q1Q_Vb2_c1_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vb_b1*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vb1_b2=(+q1Q_Vb2_c1_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vb1_b2*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vc4_c1=(+q1Q_Vb2_c1_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vc4_c1*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vc3_c1=(+q1Q_Vb2_c1_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vc3_c1*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vc3_c4=(+q1Q_Vb2_c1_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*(0.0)+q1Q_Vc3_c4*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vb2_e1=(+q1Q_Vb2_c1_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vb2_c1+0.5*(+0.0+0.0))));
  qBQ_Vb2_c1_Vb2_c2=(+q1Q_Vb2_c1_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vb2_c2))));
  qBQ_Vb2_c1_Vb2_c1=(+q1Q_Vb2_c1_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vb2_c1))));
  qBQ_Vb2_c1_Vc1_c2=(+q1Q_Vb2_c1_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vb2_c1*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*(0.5*nB_Vb2_c1)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vb2_c1+0.5*(+0.0+nB_Vb2_c1_Vc1_c2))));
#endif
qBQ_Vc1_c2=((q1Q_Vc1_c2*(1.0+(0.5*(n0+nB))))+(pInst->q1Q*(0.5*nB_Vc1_c2)));
#if defined(_DERIVATE2)
  qBQ_Vc1_c2_Vdt_GND=(+q1Q_Vc1_c2_Vdt_GND*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*((0.5*(n0_Vdt_GND+nB_Vdt_GND)))+q1Q_Vdt_GND*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*(n0_Vdt_GND+nB_Vdt_GND)+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vdt_GND))));
  qBQ_Vc1_c2_Vb_c=(+q1Q_Vc1_c2_Vb_c*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vb_c*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vb_b1=(+q1Q_Vc1_c2_Vb_b1*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vb_b1*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vb1_b2=(+q1Q_Vc1_c2_Vb1_b2*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vb1_b2*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vc4_c1=(+q1Q_Vc1_c2_Vc4_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vc4_c1*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vc3_c1=(+q1Q_Vc1_c2_Vc3_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vc3_c1*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vc3_c4=(+q1Q_Vc1_c2_Vc3_c4*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*(0.0)+q1Q_Vc3_c4*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*0.0+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vb2_e1=(+q1Q_Vc1_c2_Vb2_e1*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*((0.5*n0_Vb2_e1))+q1Q_Vb2_e1*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*n0_Vb2_e1+0.0*nB_Vc1_c2+0.5*(+0.0+0.0))));
  qBQ_Vc1_c2_Vb2_c2=(+q1Q_Vc1_c2_Vb2_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*((0.5*nB_Vb2_c2))+q1Q_Vb2_c2*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c2+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vb2_c2))));
  qBQ_Vc1_c2_Vb2_c1=(+q1Q_Vc1_c2_Vb2_c1*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*((0.5*nB_Vb2_c1))+q1Q_Vb2_c1*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vb2_c1+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vb2_c1))));
  qBQ_Vc1_c2_Vc1_c2=(+q1Q_Vc1_c2_Vc1_c2*(1.0+(0.5*(n0+nB)))+q1Q_Vc1_c2*((0.5*nB_Vc1_c2))+q1Q_Vc1_c2*(0.5*nB_Vc1_c2)+pInst->q1Q*(+0.0+(+0.0*(n0+nB)+0.0*nB_Vc1_c2+0.0*nB_Vc1_c2+0.5*(+0.0+nB_Vc1_c2_Vc1_c2))));
#endif
#endif
qBQ=(pInst->q1Q*(1.0+(0.5*(n0+nB))));
EXIT_IF_ISNAN((pInst->q1Q*(1.0+(0.5*(n0+nB)))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Rb2_Vdt_GND=(((3.0*RBV_TM_Vdt_GND)*qBQ-(3.0*RBV_TM)*qBQ_Vdt_GND)/qBQ/qBQ);
#endif
#if defined(_DERIVATE)
Rb2_Vb_c=(-(3.0*RBV_TM)*qBQ_Vb_c/qBQ/qBQ);
#endif
#if defined(_DERIVATE)
Rb2_Vb_b1=(-(3.0*RBV_TM)*qBQ_Vb_b1/qBQ/qBQ);
#endif
#if defined(_DERIVATE)
Rb2_Vb1_b2=(-(3.0*RBV_TM)*qBQ_Vb1_b2/qBQ/qBQ);
#endif
Rb2_Vc4_c1=(-(3.0*RBV_TM)*qBQ_Vc4_c1/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vc4_c1_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vc4_c1_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vc4_c1+(3.0*RBV_TM)*qBQ_Vc4_c1_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc4_c1*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
Rb2_Vc3_c1=(-(3.0*RBV_TM)*qBQ_Vc3_c1/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vc3_c1_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vc3_c1_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vc3_c1+(3.0*RBV_TM)*qBQ_Vc3_c1_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc3_c1*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
#if defined(_DERIVATE)
Rb2_Vc3_c4=(-(3.0*RBV_TM)*qBQ_Vc3_c4/qBQ/qBQ);
#endif
Rb2_Vb2_e1=(-(3.0*RBV_TM)*qBQ_Vb2_e1/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vb2_e1_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_e1_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vb2_e1+(3.0*RBV_TM)*qBQ_Vb2_e1_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_e1*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
Rb2_Vb2_c2=(-(3.0*RBV_TM)*qBQ_Vb2_c2/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vb2_c2_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c2_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vb2_c2+(3.0*RBV_TM)*qBQ_Vb2_c2_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c2*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
Rb2_Vb2_c1=(-(3.0*RBV_TM)*qBQ_Vb2_c1/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vb2_c1_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vb2_c1_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vb2_c1+(3.0*RBV_TM)*qBQ_Vb2_c1_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vb2_c1*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
Rb2_Vc1_c2=(-(3.0*RBV_TM)*qBQ_Vc1_c2/qBQ/qBQ);
#if defined(_DERIVATE2)
  Rb2_Vc1_c2_Vdt_GND=((+0.0*RBV_TM+0.0*RBV_TM_Vdt_GND+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vdt_GND+((3.0*RBV_TM_Vdt_GND))*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vdt_GND)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vdt_GND/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb_c=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_c+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb_c)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb_c/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb_b1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb_b1+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb_b1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb_b1/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb1_b2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb1_b2+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb1_b2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb1_b2/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vc4_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc4_c1+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vc4_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vc4_c1/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vc3_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c1+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vc3_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vc3_c1/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vc3_c4=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc3_c4+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vc3_c4)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vc3_c4/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb2_e1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_e1+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb2_e1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb2_e1/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb2_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c2+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb2_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb2_c2/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vb2_c1=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vb2_c1+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vb2_c1)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vb2_c1/qBQ/qBQ/qBQ);
  Rb2_Vc1_c2_Vc1_c2=((+0.0*RBV_TM+0.0*0.0+0.0*0.0+3.0*0.0)/qBQ-(0.0*qBQ_Vc1_c2+(0.0)*qBQ_Vc1_c2+(3.0*RBV_TM)*qBQ_Vc1_c2_Vc1_c2)/qBQ/qBQ+2*(3.0*RBV_TM)*qBQ_Vc1_c2*qBQ_Vc1_c2/qBQ/qBQ/qBQ);
#endif
#endif
pInst->Rb2=((3.0*RBV_TM)/qBQ);
EXIT_IF_ISNAN(((3.0*RBV_TM)/qBQ))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b,c)V(b,b1)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Ib1b2_Vdt_GND=(((((2.0*Vt_Vdt_GND)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND))*pInst->Rb2-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vdt_GND)/pInst->Rb2/pInst->Rb2);
#endif
#if defined(_DERIVATE)
Ib1b2_Vb1_b2=(((((2.0*Vt)*eVb1b2_Vb1_b2)+Vb1b2_Vb1_b2)*pInst->Rb2-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb1_b2)/pInst->Rb2/pInst->Rb2);
#endif
#if defined(_DERIVATE)
Ib1b2_Vb_c=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb_c/pInst->Rb2/pInst->Rb2);
#endif
#if defined(_DERIVATE)
Ib1b2_Vb_b1=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vc4_c1=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vc4_c1_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc4_c1_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc4_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc4_c1*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vc3_c1=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vc3_c1_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc3_c1_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc3_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c1*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
#if defined(_DERIVATE)
Ib1b2_Vc3_c4=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vb2_e1=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vb2_e1_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_e1_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_e1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_e1*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vb2_c2=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vb2_c2_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c2_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c2*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vb2_c1=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vb2_c1_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vb2_c1_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vb2_c1+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vb2_c1*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
Ib1b2_Vc1_c2=(-(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2);
#if defined(_DERIVATE2)
  Ib1b2_Vc1_c2_Vdt_GND=((+(+(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vdt_GND+((2.0*Vt_Vdt_GND))*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vdt_GND+(((((2.0*Vt_Vdt_GND))*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vdt_GND)))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vdt_GND)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vdt_GND/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb1_b2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*eVb1b2_Vb1_b2+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb1_b2+(((((0.0)*(pInst->eVb1b2-1.0))+((2.0*Vt)*eVb1b2_Vb1_b2)))+Vb1b2_Vb1_b2)*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb1_b2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb_c=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_c+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb_c)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb_c/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb_b1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb_b1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb_b1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vc4_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc4_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vc4_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vc3_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vc3_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vc3_c4=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc3_c4+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vc3_c4)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb2_e1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_e1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb2_e1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb2_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb2_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vb2_c1=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vb2_c1+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vb2_c1)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2/pInst->Rb2);
  Ib1b2_Vc1_c2_Vc1_c2=((+(+(+0.0*Vt+0.0*0.0+0.0*0.0+2.0*0.0)*(pInst->eVb1b2-1.0)+0.0*0.0+(0.0)*0.0+(2.0*Vt)*(+0.0-0.0))+0.0)/pInst->Rb2-(0.0*Rb2_Vc1_c2+((0.0)*(pInst->eVb1b2-1.0))*Rb2_Vc1_c2+(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2_Vc1_c2)/pInst->Rb2/pInst->Rb2+2*(((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)*Rb2_Vc1_c2*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2/pInst->Rb2);
#endif
#endif
Ib1b2=((((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)/pInst->Rb2);
EXIT_IF_ISNAN(((((2.0*Vt)*(pInst->eVb1b2-1.0))+Vb1b2)/pInst->Rb2))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Iavl_Vdt_GND=0.0;
#endif
Iavl_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Iavl_Vb2_c2_Vdt_GND=0.0;
  Iavl_Vb2_c2_Vb2_c2=0.0;
  Iavl_Vb2_c2_Vb2_c1=0.0;
  Iavl_Vb2_c2_Vc1_c2=0.0;
  Iavl_Vb2_c2_Vb_c=0.0;
  Iavl_Vb2_c2_Vb_b1=0.0;
  Iavl_Vb2_c2_Vb1_b2=0.0;
  Iavl_Vb2_c2_Vc4_c1=0.0;
  Iavl_Vb2_c2_Vc3_c1=0.0;
  Iavl_Vb2_c2_Vc3_c4=0.0;
  Iavl_Vb2_c2_Vb2_e1=0.0;
#endif
Iavl_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Iavl_Vb2_c1_Vdt_GND=0.0;
  Iavl_Vb2_c1_Vb2_c2=0.0;
  Iavl_Vb2_c1_Vb2_c1=0.0;
  Iavl_Vb2_c1_Vc1_c2=0.0;
  Iavl_Vb2_c1_Vb_c=0.0;
  Iavl_Vb2_c1_Vb_b1=0.0;
  Iavl_Vb2_c1_Vb1_b2=0.0;
  Iavl_Vb2_c1_Vc4_c1=0.0;
  Iavl_Vb2_c1_Vc3_c1=0.0;
  Iavl_Vb2_c1_Vc3_c4=0.0;
  Iavl_Vb2_c1_Vb2_e1=0.0;
#endif
Iavl_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Iavl_Vc1_c2_Vdt_GND=0.0;
  Iavl_Vc1_c2_Vb2_c2=0.0;
  Iavl_Vc1_c2_Vb2_c1=0.0;
  Iavl_Vc1_c2_Vc1_c2=0.0;
  Iavl_Vc1_c2_Vb_c=0.0;
  Iavl_Vc1_c2_Vb_b1=0.0;
  Iavl_Vc1_c2_Vb1_b2=0.0;
  Iavl_Vc1_c2_Vc4_c1=0.0;
  Iavl_Vc1_c2_Vc3_c1=0.0;
  Iavl_Vc1_c2_Vc3_c4=0.0;
  Iavl_Vc1_c2_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
Iavl_Vb_c=0.0;
#endif
#if defined(_DERIVATE)
Iavl_Vb_b1=0.0;
#endif
#if defined(_DERIVATE)
Iavl_Vb1_b2=0.0;
#endif
Iavl_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  Iavl_Vc4_c1_Vdt_GND=0.0;
  Iavl_Vc4_c1_Vb2_c2=0.0;
  Iavl_Vc4_c1_Vb2_c1=0.0;
  Iavl_Vc4_c1_Vc1_c2=0.0;
  Iavl_Vc4_c1_Vb_c=0.0;
  Iavl_Vc4_c1_Vb_b1=0.0;
  Iavl_Vc4_c1_Vb1_b2=0.0;
  Iavl_Vc4_c1_Vc4_c1=0.0;
  Iavl_Vc4_c1_Vc3_c1=0.0;
  Iavl_Vc4_c1_Vc3_c4=0.0;
  Iavl_Vc4_c1_Vb2_e1=0.0;
#endif
Iavl_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  Iavl_Vc3_c1_Vdt_GND=0.0;
  Iavl_Vc3_c1_Vb2_c2=0.0;
  Iavl_Vc3_c1_Vb2_c1=0.0;
  Iavl_Vc3_c1_Vc1_c2=0.0;
  Iavl_Vc3_c1_Vb_c=0.0;
  Iavl_Vc3_c1_Vb_b1=0.0;
  Iavl_Vc3_c1_Vb1_b2=0.0;
  Iavl_Vc3_c1_Vc4_c1=0.0;
  Iavl_Vc3_c1_Vc3_c1=0.0;
  Iavl_Vc3_c1_Vc3_c4=0.0;
  Iavl_Vc3_c1_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
Iavl_Vc3_c4=0.0;
#endif
Iavl_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  Iavl_Vb2_e1_Vdt_GND=0.0;
  Iavl_Vb2_e1_Vb2_c2=0.0;
  Iavl_Vb2_e1_Vb2_c1=0.0;
  Iavl_Vb2_e1_Vc1_c2=0.0;
  Iavl_Vb2_e1_Vb_c=0.0;
  Iavl_Vb2_e1_Vb_b1=0.0;
  Iavl_Vb2_e1_Vb1_b2=0.0;
  Iavl_Vb2_e1_Vc4_c1=0.0;
  Iavl_Vb2_e1_Vc3_c1=0.0;
  Iavl_Vb2_e1_Vc3_c4=0.0;
  Iavl_Vb2_e1_Vb2_e1=0.0;
#endif
#endif
pInst->Iavl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Gem_Vdt_GND=0.0;
#endif
Gem_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Gem_Vb2_c1_Vdt_GND=0.0;
  Gem_Vb2_c1_Vb2_c1=0.0;
  Gem_Vb2_c1_Vb2_c2=0.0;
  Gem_Vb2_c1_Vc1_c2=0.0;
#endif
Gem_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Gem_Vb2_c2_Vdt_GND=0.0;
  Gem_Vb2_c2_Vb2_c1=0.0;
  Gem_Vb2_c2_Vb2_c2=0.0;
  Gem_Vb2_c2_Vc1_c2=0.0;
#endif
Gem_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Gem_Vc1_c2_Vdt_GND=0.0;
  Gem_Vc1_c2_Vb2_c1=0.0;
  Gem_Vc1_c2_Vb2_c2=0.0;
  Gem_Vc1_c2_Vc1_c2=0.0;
#endif
#endif
Gem=0.0;
EXIT_IF_ISNAN(0.0)
if
(((Ic1c2>0.0)&&(Vb2c1<VDC_T)))
{
dEdx0=((2.0*pModel->VAVL)/(pModel->WAVL*pModel->WAVL));
EXIT_IF_ISNAN(((2.0*pModel->VAVL)/(pModel->WAVL*pModel->WAVL)))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
sqr_arg_Vdt_GND=((VDC_T_Vdt_GND*Icap_IHC-(VDC_T-Vb2c1)*Icap_IHC_Vdt_GND)/Icap_IHC/Icap_IHC);
#endif
sqr_arg_Vb2_c2=(-(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2/Icap_IHC/Icap_IHC);
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c2_Vdt_GND=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vdt_GND+VDC_T_Vdt_GND*Icap_IHC_Vb2_c2+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2_Vdt_GND)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2*Icap_IHC_Vdt_GND/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c2_Vb2_c2=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vb2_c2+0.0*Icap_IHC_Vb2_c2+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2_Vb2_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2*Icap_IHC_Vb2_c2/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c2_Vb2_c1=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vb2_c1+(-Vb2c1_Vb2_c1)*Icap_IHC_Vb2_c2+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2_Vb2_c1)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2*Icap_IHC_Vb2_c1/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c2_Vc1_c2=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vc1_c2+0.0*Icap_IHC_Vb2_c2+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2_Vc1_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c2*Icap_IHC_Vc1_c2/Icap_IHC/Icap_IHC/Icap_IHC);
#endif
sqr_arg_Vb2_c1=(((-Vb2c1_Vb2_c1)*Icap_IHC-(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1)/Icap_IHC/Icap_IHC);
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c1_Vdt_GND=((+0.0-0.0)/Icap_IHC-((-Vb2c1_Vb2_c1)*Icap_IHC_Vdt_GND+VDC_T_Vdt_GND*Icap_IHC_Vb2_c1+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1_Vdt_GND)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1*Icap_IHC_Vdt_GND/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c1_Vb2_c2=((+0.0-0.0)/Icap_IHC-((-Vb2c1_Vb2_c1)*Icap_IHC_Vb2_c2+0.0*Icap_IHC_Vb2_c1+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1_Vb2_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1*Icap_IHC_Vb2_c2/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c1_Vb2_c1=((+0.0-Vb2c1_Vb2_c1_Vb2_c1)/Icap_IHC-((-Vb2c1_Vb2_c1)*Icap_IHC_Vb2_c1+(-Vb2c1_Vb2_c1)*Icap_IHC_Vb2_c1+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1_Vb2_c1)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1*Icap_IHC_Vb2_c1/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vb2_c1_Vc1_c2=((+0.0-0.0)/Icap_IHC-((-Vb2c1_Vb2_c1)*Icap_IHC_Vc1_c2+0.0*Icap_IHC_Vb2_c1+(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1_Vc1_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vb2_c1*Icap_IHC_Vc1_c2/Icap_IHC/Icap_IHC/Icap_IHC);
#endif
sqr_arg_Vc1_c2=(-(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2/Icap_IHC/Icap_IHC);
#if defined(_DERIVATE2)
  sqr_arg_Vc1_c2_Vdt_GND=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vdt_GND+VDC_T_Vdt_GND*Icap_IHC_Vc1_c2+(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2_Vdt_GND)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2*Icap_IHC_Vdt_GND/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vc1_c2_Vb2_c2=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vb2_c2+0.0*Icap_IHC_Vc1_c2+(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2_Vb2_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2*Icap_IHC_Vb2_c2/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vc1_c2_Vb2_c1=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vb2_c1+(-Vb2c1_Vb2_c1)*Icap_IHC_Vc1_c2+(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2_Vb2_c1)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2*Icap_IHC_Vb2_c1/Icap_IHC/Icap_IHC/Icap_IHC);
  sqr_arg_Vc1_c2_Vc1_c2=((+0.0-0.0)/Icap_IHC-(0.0*Icap_IHC_Vc1_c2+0.0*Icap_IHC_Vc1_c2+(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2_Vc1_c2)/Icap_IHC/Icap_IHC+2*(VDC_T-Vb2c1)*Icap_IHC_Vc1_c2*Icap_IHC_Vc1_c2/Icap_IHC/Icap_IHC/Icap_IHC);
#endif
#endif
sqr_arg=((VDC_T-Vb2c1)/Icap_IHC);
EXIT_IF_ISNAN(((VDC_T-Vb2c1)/Icap_IHC))
{
double m00_sqrt(d00_sqrt0,((2.0*sqr_arg)/dEdx0))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((2.0*sqr_arg)/dEdx0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
xd_Vdt_GND=((2.0*sqr_arg_Vdt_GND)/dEdx0)*d10_sqrt0;
#endif
xd_Vb2_c2=((2.0*sqr_arg_Vb2_c2)/dEdx0)*d10_sqrt0;
#if defined(_DERIVATE2)
  xd_Vb2_c2_Vdt_GND=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vdt_GND))/dEdx0)*((2.0*sqr_arg_Vb2_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vdt_GND+0.0*sqr_arg_Vb2_c2+2.0*sqr_arg_Vb2_c2_Vdt_GND)/dEdx0-((2.0*sqr_arg_Vb2_c2)*0.0+((2.0*sqr_arg_Vdt_GND))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c2_Vb2_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c2))/dEdx0)*((2.0*sqr_arg_Vb2_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c2+0.0*sqr_arg_Vb2_c2+2.0*sqr_arg_Vb2_c2_Vb2_c2)/dEdx0-((2.0*sqr_arg_Vb2_c2)*0.0+((2.0*sqr_arg_Vb2_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c2_Vb2_c1=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c1))/dEdx0)*((2.0*sqr_arg_Vb2_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c1+0.0*sqr_arg_Vb2_c2+2.0*sqr_arg_Vb2_c2_Vb2_c1)/dEdx0-((2.0*sqr_arg_Vb2_c2)*0.0+((2.0*sqr_arg_Vb2_c1))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c2_Vc1_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vc1_c2))/dEdx0)*((2.0*sqr_arg_Vb2_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vc1_c2+0.0*sqr_arg_Vb2_c2+2.0*sqr_arg_Vb2_c2_Vc1_c2)/dEdx0-((2.0*sqr_arg_Vb2_c2)*0.0+((2.0*sqr_arg_Vc1_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
#endif
xd_Vb2_c1=((2.0*sqr_arg_Vb2_c1)/dEdx0)*d10_sqrt0;
#if defined(_DERIVATE2)
  xd_Vb2_c1_Vdt_GND=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vdt_GND))/dEdx0)*((2.0*sqr_arg_Vb2_c1)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vdt_GND+0.0*sqr_arg_Vb2_c1+2.0*sqr_arg_Vb2_c1_Vdt_GND)/dEdx0-((2.0*sqr_arg_Vb2_c1)*0.0+((2.0*sqr_arg_Vdt_GND))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c1_Vb2_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c2))/dEdx0)*((2.0*sqr_arg_Vb2_c1)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c2+0.0*sqr_arg_Vb2_c1+2.0*sqr_arg_Vb2_c1_Vb2_c2)/dEdx0-((2.0*sqr_arg_Vb2_c1)*0.0+((2.0*sqr_arg_Vb2_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c1_Vb2_c1=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c1))/dEdx0)*((2.0*sqr_arg_Vb2_c1)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c1+0.0*sqr_arg_Vb2_c1+2.0*sqr_arg_Vb2_c1_Vb2_c1)/dEdx0-((2.0*sqr_arg_Vb2_c1)*0.0+((2.0*sqr_arg_Vb2_c1))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vb2_c1_Vc1_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vc1_c2))/dEdx0)*((2.0*sqr_arg_Vb2_c1)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vc1_c2+0.0*sqr_arg_Vb2_c1+2.0*sqr_arg_Vb2_c1_Vc1_c2)/dEdx0-((2.0*sqr_arg_Vb2_c1)*0.0+((2.0*sqr_arg_Vc1_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
#endif
xd_Vc1_c2=((2.0*sqr_arg_Vc1_c2)/dEdx0)*d10_sqrt0;
#if defined(_DERIVATE2)
  xd_Vc1_c2_Vdt_GND=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vdt_GND))/dEdx0)*((2.0*sqr_arg_Vc1_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vdt_GND+0.0*sqr_arg_Vc1_c2+2.0*sqr_arg_Vc1_c2_Vdt_GND)/dEdx0-((2.0*sqr_arg_Vc1_c2)*0.0+((2.0*sqr_arg_Vdt_GND))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vc1_c2_Vb2_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c2))/dEdx0)*((2.0*sqr_arg_Vc1_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c2+0.0*sqr_arg_Vc1_c2+2.0*sqr_arg_Vc1_c2_Vb2_c2)/dEdx0-((2.0*sqr_arg_Vc1_c2)*0.0+((2.0*sqr_arg_Vb2_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vc1_c2_Vb2_c1=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vb2_c1))/dEdx0)*((2.0*sqr_arg_Vc1_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vb2_c1+0.0*sqr_arg_Vc1_c2+2.0*sqr_arg_Vc1_c2_Vb2_c1)/dEdx0-((2.0*sqr_arg_Vc1_c2)*0.0+((2.0*sqr_arg_Vb2_c1))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
  xd_Vc1_c2_Vc1_c2=(m20_sqrt(((2.0*sqr_arg)/dEdx0))*(((2.0*sqr_arg_Vc1_c2))/dEdx0)*((2.0*sqr_arg_Vc1_c2)/dEdx0)+d10_sqrt0*((+0.0*sqr_arg+0.0*sqr_arg_Vc1_c2+0.0*sqr_arg_Vc1_c2+2.0*sqr_arg_Vc1_c2_Vc1_c2)/dEdx0-((2.0*sqr_arg_Vc1_c2)*0.0+((2.0*sqr_arg_Vc1_c2))*0.0+(2.0*sqr_arg)*0.0)/dEdx0/dEdx0+2*(2.0*sqr_arg)*0.0*0.0/dEdx0/dEdx0/dEdx0));
#endif
#endif
xd=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pModel->EXAVL==0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
Weff_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Weff_Vb2_c2_Vb2_c2=0.0;
  Weff_Vb2_c2_Vb2_c1=0.0;
  Weff_Vb2_c2_Vc1_c2=0.0;
  Weff_Vb2_c2_Vdt_GND=0.0;
#endif
Weff_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Weff_Vb2_c1_Vb2_c2=0.0;
  Weff_Vb2_c1_Vb2_c1=0.0;
  Weff_Vb2_c1_Vc1_c2=0.0;
  Weff_Vb2_c1_Vdt_GND=0.0;
#endif
Weff_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Weff_Vc1_c2_Vb2_c2=0.0;
  Weff_Vc1_c2_Vb2_c1=0.0;
  Weff_Vc1_c2_Vc1_c2=0.0;
  Weff_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
Weff_Vdt_GND=0.0;
#endif
#endif
Weff=pModel->WAVL;
EXIT_IF_ISNAN(pModel->WAVL)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
xi_w1_Vb2_c2=(-(0.5*xi_w_Vb2_c2));
#if defined(_DERIVATE2)
  xi_w1_Vb2_c2_Vb2_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vb2_c2+0.5*xi_w_Vb2_c2_Vb2_c2));
  xi_w1_Vb2_c2_Vb2_c1=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vb2_c2+0.5*xi_w_Vb2_c2_Vb2_c1));
  xi_w1_Vb2_c2_Vc1_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vb2_c2+0.5*xi_w_Vb2_c2_Vc1_c2));
  xi_w1_Vb2_c2_Vdt_GND=(+0.0-(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vb2_c2+0.5*xi_w_Vb2_c2_Vdt_GND));
#endif
xi_w1_Vb2_c1=(-(0.5*xi_w_Vb2_c1));
#if defined(_DERIVATE2)
  xi_w1_Vb2_c1_Vb2_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vb2_c1+0.5*xi_w_Vb2_c1_Vb2_c2));
  xi_w1_Vb2_c1_Vb2_c1=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vb2_c1+0.5*xi_w_Vb2_c1_Vb2_c1));
  xi_w1_Vb2_c1_Vc1_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vb2_c1+0.5*xi_w_Vb2_c1_Vc1_c2));
  xi_w1_Vb2_c1_Vdt_GND=(+0.0-(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vb2_c1+0.5*xi_w_Vb2_c1_Vdt_GND));
#endif
xi_w1_Vc1_c2=(-(0.5*xi_w_Vc1_c2));
#if defined(_DERIVATE2)
  xi_w1_Vc1_c2_Vb2_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vc1_c2+0.5*xi_w_Vc1_c2_Vb2_c2));
  xi_w1_Vc1_c2_Vb2_c1=(+0.0-(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vc1_c2+0.5*xi_w_Vc1_c2_Vb2_c1));
  xi_w1_Vc1_c2_Vc1_c2=(+0.0-(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vc1_c2+0.5*xi_w_Vc1_c2_Vc1_c2));
  xi_w1_Vc1_c2_Vdt_GND=(+0.0-(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vc1_c2+0.5*xi_w_Vc1_c2_Vdt_GND));
#endif
#if defined(_DERIVATE)
xi_w1_Vdt_GND=(-(0.5*xi_w_Vdt_GND));
#endif
#endif
xi_w1=(1.0-(0.5*xi_w));
EXIT_IF_ISNAN((1.0-(0.5*xi_w)))
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
Weff_Vb2_c2=(((pModel->WAVL*xi_w1_Vb2_c2)*xi_w1)+((pModel->WAVL*xi_w1)*xi_w1_Vb2_c2));
#if defined(_DERIVATE2)
  Weff_Vb2_c2_Vb2_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c2+0.0*xi_w1_Vb2_c2+pModel->WAVL*xi_w1_Vb2_c2_Vb2_c2)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c2)*xi_w1_Vb2_c2+((pModel->WAVL*xi_w1_Vb2_c2))*xi_w1_Vb2_c2+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c2_Vb2_c2);
  Weff_Vb2_c2_Vb2_c1=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c1+0.0*xi_w1_Vb2_c2+pModel->WAVL*xi_w1_Vb2_c2_Vb2_c1)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c2)*xi_w1_Vb2_c1+((pModel->WAVL*xi_w1_Vb2_c1))*xi_w1_Vb2_c2+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c2_Vb2_c1);
  Weff_Vb2_c2_Vc1_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vc1_c2+0.0*xi_w1_Vb2_c2+pModel->WAVL*xi_w1_Vb2_c2_Vc1_c2)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c2)*xi_w1_Vc1_c2+((pModel->WAVL*xi_w1_Vc1_c2))*xi_w1_Vb2_c2+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c2_Vc1_c2);
  Weff_Vb2_c2_Vdt_GND=(+(+0.0*xi_w1+0.0*xi_w1_Vdt_GND+0.0*xi_w1_Vb2_c2+pModel->WAVL*xi_w1_Vb2_c2_Vdt_GND)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c2)*xi_w1_Vdt_GND+((pModel->WAVL*xi_w1_Vdt_GND))*xi_w1_Vb2_c2+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c2_Vdt_GND);
#endif
Weff_Vb2_c1=(((pModel->WAVL*xi_w1_Vb2_c1)*xi_w1)+((pModel->WAVL*xi_w1)*xi_w1_Vb2_c1));
#if defined(_DERIVATE2)
  Weff_Vb2_c1_Vb2_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c2+0.0*xi_w1_Vb2_c1+pModel->WAVL*xi_w1_Vb2_c1_Vb2_c2)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c1)*xi_w1_Vb2_c2+((pModel->WAVL*xi_w1_Vb2_c2))*xi_w1_Vb2_c1+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c1_Vb2_c2);
  Weff_Vb2_c1_Vb2_c1=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c1+0.0*xi_w1_Vb2_c1+pModel->WAVL*xi_w1_Vb2_c1_Vb2_c1)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c1)*xi_w1_Vb2_c1+((pModel->WAVL*xi_w1_Vb2_c1))*xi_w1_Vb2_c1+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c1_Vb2_c1);
  Weff_Vb2_c1_Vc1_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vc1_c2+0.0*xi_w1_Vb2_c1+pModel->WAVL*xi_w1_Vb2_c1_Vc1_c2)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c1)*xi_w1_Vc1_c2+((pModel->WAVL*xi_w1_Vc1_c2))*xi_w1_Vb2_c1+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c1_Vc1_c2);
  Weff_Vb2_c1_Vdt_GND=(+(+0.0*xi_w1+0.0*xi_w1_Vdt_GND+0.0*xi_w1_Vb2_c1+pModel->WAVL*xi_w1_Vb2_c1_Vdt_GND)*xi_w1+(pModel->WAVL*xi_w1_Vb2_c1)*xi_w1_Vdt_GND+((pModel->WAVL*xi_w1_Vdt_GND))*xi_w1_Vb2_c1+(pModel->WAVL*xi_w1)*xi_w1_Vb2_c1_Vdt_GND);
#endif
Weff_Vc1_c2=(((pModel->WAVL*xi_w1_Vc1_c2)*xi_w1)+((pModel->WAVL*xi_w1)*xi_w1_Vc1_c2));
#if defined(_DERIVATE2)
  Weff_Vc1_c2_Vb2_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c2+0.0*xi_w1_Vc1_c2+pModel->WAVL*xi_w1_Vc1_c2_Vb2_c2)*xi_w1+(pModel->WAVL*xi_w1_Vc1_c2)*xi_w1_Vb2_c2+((pModel->WAVL*xi_w1_Vb2_c2))*xi_w1_Vc1_c2+(pModel->WAVL*xi_w1)*xi_w1_Vc1_c2_Vb2_c2);
  Weff_Vc1_c2_Vb2_c1=(+(+0.0*xi_w1+0.0*xi_w1_Vb2_c1+0.0*xi_w1_Vc1_c2+pModel->WAVL*xi_w1_Vc1_c2_Vb2_c1)*xi_w1+(pModel->WAVL*xi_w1_Vc1_c2)*xi_w1_Vb2_c1+((pModel->WAVL*xi_w1_Vb2_c1))*xi_w1_Vc1_c2+(pModel->WAVL*xi_w1)*xi_w1_Vc1_c2_Vb2_c1);
  Weff_Vc1_c2_Vc1_c2=(+(+0.0*xi_w1+0.0*xi_w1_Vc1_c2+0.0*xi_w1_Vc1_c2+pModel->WAVL*xi_w1_Vc1_c2_Vc1_c2)*xi_w1+(pModel->WAVL*xi_w1_Vc1_c2)*xi_w1_Vc1_c2+((pModel->WAVL*xi_w1_Vc1_c2))*xi_w1_Vc1_c2+(pModel->WAVL*xi_w1)*xi_w1_Vc1_c2_Vc1_c2);
  Weff_Vc1_c2_Vdt_GND=(+(+0.0*xi_w1+0.0*xi_w1_Vdt_GND+0.0*xi_w1_Vc1_c2+pModel->WAVL*xi_w1_Vc1_c2_Vdt_GND)*xi_w1+(pModel->WAVL*xi_w1_Vc1_c2)*xi_w1_Vdt_GND+((pModel->WAVL*xi_w1_Vdt_GND))*xi_w1_Vc1_c2+(pModel->WAVL*xi_w1)*xi_w1_Vc1_c2_Vdt_GND);
#endif
#if defined(_DERIVATE)
Weff_Vdt_GND=(((pModel->WAVL*xi_w1_Vdt_GND)*xi_w1)+((pModel->WAVL*xi_w1)*xi_w1_Vdt_GND));
#endif
#endif
Weff=((pModel->WAVL*xi_w1)*xi_w1);
EXIT_IF_ISNAN(((pModel->WAVL*xi_w1)*xi_w1))
}
{
double m00_sqrt(d00_sqrt0,((xd*xd)+(Weff*Weff)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((xd*xd)+(Weff*Weff)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Wd_Vdt_GND=((((xd_Vdt_GND*Weff)+(xd*Weff_Vdt_GND))*d00_sqrt0-(xd*Weff)*(((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND))+((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#endif
Wd_Vb2_c2=((((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2))*d00_sqrt0-(xd*Weff)*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  Wd_Vb2_c2_Vdt_GND=((+xd_Vb2_c2_Vdt_GND*Weff+xd_Vb2_c2*Weff_Vdt_GND+xd_Vdt_GND*Weff_Vb2_c2+xd*Weff_Vb2_c2_Vdt_GND)/d00_sqrt0-(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0+(((xd_Vdt_GND*Weff)+(xd*Weff_Vdt_GND)))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))+d10_sqrt0*(+(+xd_Vb2_c2_Vdt_GND*xd+xd_Vb2_c2*xd_Vdt_GND+xd_Vdt_GND*xd_Vb2_c2+xd*xd_Vb2_c2_Vdt_GND)+(+Weff_Vb2_c2_Vdt_GND*Weff+Weff_Vb2_c2*Weff_Vdt_GND+Weff_Vdt_GND*Weff_Vb2_c2+Weff*Weff_Vb2_c2_Vdt_GND))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c2_Vb2_c2=((+xd_Vb2_c2_Vb2_c2*Weff+xd_Vb2_c2*Weff_Vb2_c2+xd_Vb2_c2*Weff_Vb2_c2+xd*Weff_Vb2_c2_Vb2_c2)/d00_sqrt0-(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0+(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2)))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))+d10_sqrt0*(+(+xd_Vb2_c2_Vb2_c2*xd+xd_Vb2_c2*xd_Vb2_c2+xd_Vb2_c2*xd_Vb2_c2+xd*xd_Vb2_c2_Vb2_c2)+(+Weff_Vb2_c2_Vb2_c2*Weff+Weff_Vb2_c2*Weff_Vb2_c2+Weff_Vb2_c2*Weff_Vb2_c2+Weff*Weff_Vb2_c2_Vb2_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c2_Vb2_c1=((+xd_Vb2_c2_Vb2_c1*Weff+xd_Vb2_c2*Weff_Vb2_c1+xd_Vb2_c1*Weff_Vb2_c2+xd*Weff_Vb2_c2_Vb2_c1)/d00_sqrt0-(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0+(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1)))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))+d10_sqrt0*(+(+xd_Vb2_c2_Vb2_c1*xd+xd_Vb2_c2*xd_Vb2_c1+xd_Vb2_c1*xd_Vb2_c2+xd*xd_Vb2_c2_Vb2_c1)+(+Weff_Vb2_c2_Vb2_c1*Weff+Weff_Vb2_c2*Weff_Vb2_c1+Weff_Vb2_c1*Weff_Vb2_c2+Weff*Weff_Vb2_c2_Vb2_c1))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c2_Vc1_c2=((+xd_Vb2_c2_Vc1_c2*Weff+xd_Vb2_c2*Weff_Vc1_c2+xd_Vc1_c2*Weff_Vb2_c2+xd*Weff_Vb2_c2_Vc1_c2)/d00_sqrt0-(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0+(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2)))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))+d10_sqrt0*(+(+xd_Vb2_c2_Vc1_c2*xd+xd_Vb2_c2*xd_Vc1_c2+xd_Vc1_c2*xd_Vb2_c2+xd*xd_Vb2_c2_Vc1_c2)+(+Weff_Vb2_c2_Vc1_c2*Weff+Weff_Vb2_c2*Weff_Vc1_c2+Weff_Vc1_c2*Weff_Vb2_c2+Weff*Weff_Vb2_c2_Vc1_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2))+((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2)))*d10_sqrt0*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
Wd_Vb2_c1=((((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1))*d00_sqrt0-(xd*Weff)*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  Wd_Vb2_c1_Vdt_GND=((+xd_Vb2_c1_Vdt_GND*Weff+xd_Vb2_c1*Weff_Vdt_GND+xd_Vdt_GND*Weff_Vb2_c1+xd*Weff_Vb2_c1_Vdt_GND)/d00_sqrt0-(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0+(((xd_Vdt_GND*Weff)+(xd*Weff_Vdt_GND)))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))+d10_sqrt0*(+(+xd_Vb2_c1_Vdt_GND*xd+xd_Vb2_c1*xd_Vdt_GND+xd_Vdt_GND*xd_Vb2_c1+xd*xd_Vb2_c1_Vdt_GND)+(+Weff_Vb2_c1_Vdt_GND*Weff+Weff_Vb2_c1*Weff_Vdt_GND+Weff_Vdt_GND*Weff_Vb2_c1+Weff*Weff_Vb2_c1_Vdt_GND))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c1_Vb2_c2=((+xd_Vb2_c1_Vb2_c2*Weff+xd_Vb2_c1*Weff_Vb2_c2+xd_Vb2_c2*Weff_Vb2_c1+xd*Weff_Vb2_c1_Vb2_c2)/d00_sqrt0-(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0+(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2)))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))+d10_sqrt0*(+(+xd_Vb2_c1_Vb2_c2*xd+xd_Vb2_c1*xd_Vb2_c2+xd_Vb2_c2*xd_Vb2_c1+xd*xd_Vb2_c1_Vb2_c2)+(+Weff_Vb2_c1_Vb2_c2*Weff+Weff_Vb2_c1*Weff_Vb2_c2+Weff_Vb2_c2*Weff_Vb2_c1+Weff*Weff_Vb2_c1_Vb2_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c1_Vb2_c1=((+xd_Vb2_c1_Vb2_c1*Weff+xd_Vb2_c1*Weff_Vb2_c1+xd_Vb2_c1*Weff_Vb2_c1+xd*Weff_Vb2_c1_Vb2_c1)/d00_sqrt0-(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0+(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1)))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))+d10_sqrt0*(+(+xd_Vb2_c1_Vb2_c1*xd+xd_Vb2_c1*xd_Vb2_c1+xd_Vb2_c1*xd_Vb2_c1+xd*xd_Vb2_c1_Vb2_c1)+(+Weff_Vb2_c1_Vb2_c1*Weff+Weff_Vb2_c1*Weff_Vb2_c1+Weff_Vb2_c1*Weff_Vb2_c1+Weff*Weff_Vb2_c1_Vb2_c1))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vb2_c1_Vc1_c2=((+xd_Vb2_c1_Vc1_c2*Weff+xd_Vb2_c1*Weff_Vc1_c2+xd_Vc1_c2*Weff_Vb2_c1+xd*Weff_Vb2_c1_Vc1_c2)/d00_sqrt0-(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0+(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2)))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))+d10_sqrt0*(+(+xd_Vb2_c1_Vc1_c2*xd+xd_Vb2_c1*xd_Vc1_c2+xd_Vc1_c2*xd_Vb2_c1+xd*xd_Vb2_c1_Vc1_c2)+(+Weff_Vb2_c1_Vc1_c2*Weff+Weff_Vb2_c1*Weff_Vc1_c2+Weff_Vc1_c2*Weff_Vb2_c1+Weff*Weff_Vb2_c1_Vc1_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1))+((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1)))*d10_sqrt0*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
Wd_Vc1_c2=((((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2))*d00_sqrt0-(xd*Weff)*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  Wd_Vc1_c2_Vdt_GND=((+xd_Vc1_c2_Vdt_GND*Weff+xd_Vc1_c2*Weff_Vdt_GND+xd_Vdt_GND*Weff_Vc1_c2+xd*Weff_Vc1_c2_Vdt_GND)/d00_sqrt0-(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0+(((xd_Vdt_GND*Weff)+(xd*Weff_Vdt_GND)))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))+d10_sqrt0*(+(+xd_Vc1_c2_Vdt_GND*xd+xd_Vc1_c2*xd_Vdt_GND+xd_Vdt_GND*xd_Vc1_c2+xd*xd_Vc1_c2_Vdt_GND)+(+Weff_Vc1_c2_Vdt_GND*Weff+Weff_Vc1_c2*Weff_Vdt_GND+Weff_Vdt_GND*Weff_Vc1_c2+Weff*Weff_Vc1_c2_Vdt_GND))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0*((((xd_Vdt_GND*xd)+(xd*xd_Vdt_GND)))+(((Weff_Vdt_GND*Weff)+(Weff*Weff_Vdt_GND))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vc1_c2_Vb2_c2=((+xd_Vc1_c2_Vb2_c2*Weff+xd_Vc1_c2*Weff_Vb2_c2+xd_Vb2_c2*Weff_Vc1_c2+xd*Weff_Vc1_c2_Vb2_c2)/d00_sqrt0-(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0+(((xd_Vb2_c2*Weff)+(xd*Weff_Vb2_c2)))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))+d10_sqrt0*(+(+xd_Vc1_c2_Vb2_c2*xd+xd_Vc1_c2*xd_Vb2_c2+xd_Vb2_c2*xd_Vc1_c2+xd*xd_Vc1_c2_Vb2_c2)+(+Weff_Vc1_c2_Vb2_c2*Weff+Weff_Vc1_c2*Weff_Vb2_c2+Weff_Vb2_c2*Weff_Vc1_c2+Weff*Weff_Vc1_c2_Vb2_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0*((((xd_Vb2_c2*xd)+(xd*xd_Vb2_c2)))+(((Weff_Vb2_c2*Weff)+(Weff*Weff_Vb2_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vc1_c2_Vb2_c1=((+xd_Vc1_c2_Vb2_c1*Weff+xd_Vc1_c2*Weff_Vb2_c1+xd_Vb2_c1*Weff_Vc1_c2+xd*Weff_Vc1_c2_Vb2_c1)/d00_sqrt0-(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0+(((xd_Vb2_c1*Weff)+(xd*Weff_Vb2_c1)))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))+d10_sqrt0*(+(+xd_Vc1_c2_Vb2_c1*xd+xd_Vc1_c2*xd_Vb2_c1+xd_Vb2_c1*xd_Vc1_c2+xd*xd_Vc1_c2_Vb2_c1)+(+Weff_Vc1_c2_Vb2_c1*Weff+Weff_Vc1_c2*Weff_Vb2_c1+Weff_Vb2_c1*Weff_Vc1_c2+Weff*Weff_Vc1_c2_Vb2_c1))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0*((((xd_Vb2_c1*xd)+(xd*xd_Vb2_c1)))+(((Weff_Vb2_c1*Weff)+(Weff*Weff_Vb2_c1))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  Wd_Vc1_c2_Vc1_c2=((+xd_Vc1_c2_Vc1_c2*Weff+xd_Vc1_c2*Weff_Vc1_c2+xd_Vc1_c2*Weff_Vc1_c2+xd*Weff_Vc1_c2_Vc1_c2)/d00_sqrt0-(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0+(((xd_Vc1_c2*Weff)+(xd*Weff_Vc1_c2)))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0+(xd*Weff)*(m20_sqrt(((xd*xd)+(Weff*Weff)))*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))+d10_sqrt0*(+(+xd_Vc1_c2_Vc1_c2*xd+xd_Vc1_c2*xd_Vc1_c2+xd_Vc1_c2*xd_Vc1_c2+xd*xd_Vc1_c2_Vc1_c2)+(+Weff_Vc1_c2_Vc1_c2*Weff+Weff_Vc1_c2*Weff_Vc1_c2+Weff_Vc1_c2*Weff_Vc1_c2+Weff*Weff_Vc1_c2_Vc1_c2))))/d00_sqrt0/d00_sqrt0+2*(xd*Weff)*(((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2))+((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2)))*d10_sqrt0*((((xd_Vc1_c2*xd)+(xd*xd_Vc1_c2)))+(((Weff_Vc1_c2*Weff)+(Weff*Weff_Vc1_c2))))*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
Wd=((xd*Weff)/d00_sqrt0);
EXIT_IF_ISNAN(((xd*Weff)/d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Eav_Vdt_GND=((VDC_T_Vdt_GND*Wd-(VDC_T-Vb2c1)*Wd_Vdt_GND)/Wd/Wd);
#endif
Eav_Vb2_c1=(((-Vb2c1_Vb2_c1)*Wd-(VDC_T-Vb2c1)*Wd_Vb2_c1)/Wd/Wd);
#if defined(_DERIVATE2)
  Eav_Vb2_c1_Vdt_GND=((+0.0-0.0)/Wd-((-Vb2c1_Vb2_c1)*Wd_Vdt_GND+VDC_T_Vdt_GND*Wd_Vb2_c1+(VDC_T-Vb2c1)*Wd_Vb2_c1_Vdt_GND)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c1*Wd_Vdt_GND/Wd/Wd/Wd);
  Eav_Vb2_c1_Vb2_c1=((+0.0-Vb2c1_Vb2_c1_Vb2_c1)/Wd-((-Vb2c1_Vb2_c1)*Wd_Vb2_c1+(-Vb2c1_Vb2_c1)*Wd_Vb2_c1+(VDC_T-Vb2c1)*Wd_Vb2_c1_Vb2_c1)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c1*Wd_Vb2_c1/Wd/Wd/Wd);
  Eav_Vb2_c1_Vb2_c2=((+0.0-0.0)/Wd-((-Vb2c1_Vb2_c1)*Wd_Vb2_c2+0.0*Wd_Vb2_c1+(VDC_T-Vb2c1)*Wd_Vb2_c1_Vb2_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c1*Wd_Vb2_c2/Wd/Wd/Wd);
  Eav_Vb2_c1_Vc1_c2=((+0.0-0.0)/Wd-((-Vb2c1_Vb2_c1)*Wd_Vc1_c2+0.0*Wd_Vb2_c1+(VDC_T-Vb2c1)*Wd_Vb2_c1_Vc1_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c1*Wd_Vc1_c2/Wd/Wd/Wd);
#endif
Eav_Vb2_c2=(-(VDC_T-Vb2c1)*Wd_Vb2_c2/Wd/Wd);
#if defined(_DERIVATE2)
  Eav_Vb2_c2_Vdt_GND=((+0.0-0.0)/Wd-(0.0*Wd_Vdt_GND+VDC_T_Vdt_GND*Wd_Vb2_c2+(VDC_T-Vb2c1)*Wd_Vb2_c2_Vdt_GND)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c2*Wd_Vdt_GND/Wd/Wd/Wd);
  Eav_Vb2_c2_Vb2_c1=((+0.0-0.0)/Wd-(0.0*Wd_Vb2_c1+(-Vb2c1_Vb2_c1)*Wd_Vb2_c2+(VDC_T-Vb2c1)*Wd_Vb2_c2_Vb2_c1)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c2*Wd_Vb2_c1/Wd/Wd/Wd);
  Eav_Vb2_c2_Vb2_c2=((+0.0-0.0)/Wd-(0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c2+(VDC_T-Vb2c1)*Wd_Vb2_c2_Vb2_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c2*Wd_Vb2_c2/Wd/Wd/Wd);
  Eav_Vb2_c2_Vc1_c2=((+0.0-0.0)/Wd-(0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c2+(VDC_T-Vb2c1)*Wd_Vb2_c2_Vc1_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vb2_c2*Wd_Vc1_c2/Wd/Wd/Wd);
#endif
Eav_Vc1_c2=(-(VDC_T-Vb2c1)*Wd_Vc1_c2/Wd/Wd);
#if defined(_DERIVATE2)
  Eav_Vc1_c2_Vdt_GND=((+0.0-0.0)/Wd-(0.0*Wd_Vdt_GND+VDC_T_Vdt_GND*Wd_Vc1_c2+(VDC_T-Vb2c1)*Wd_Vc1_c2_Vdt_GND)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vc1_c2*Wd_Vdt_GND/Wd/Wd/Wd);
  Eav_Vc1_c2_Vb2_c1=((+0.0-0.0)/Wd-(0.0*Wd_Vb2_c1+(-Vb2c1_Vb2_c1)*Wd_Vc1_c2+(VDC_T-Vb2c1)*Wd_Vc1_c2_Vb2_c1)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vc1_c2*Wd_Vb2_c1/Wd/Wd/Wd);
  Eav_Vc1_c2_Vb2_c2=((+0.0-0.0)/Wd-(0.0*Wd_Vb2_c2+0.0*Wd_Vc1_c2+(VDC_T-Vb2c1)*Wd_Vc1_c2_Vb2_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vc1_c2*Wd_Vb2_c2/Wd/Wd/Wd);
  Eav_Vc1_c2_Vc1_c2=((+0.0-0.0)/Wd-(0.0*Wd_Vc1_c2+0.0*Wd_Vc1_c2+(VDC_T-Vb2c1)*Wd_Vc1_c2_Vc1_c2)/Wd/Wd+2*(VDC_T-Vb2c1)*Wd_Vc1_c2*Wd_Vc1_c2/Wd/Wd/Wd);
#endif
#endif
Eav=((VDC_T-Vb2c1)/Wd);
EXIT_IF_ISNAN(((VDC_T-Vb2c1)/Wd))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
E0_Vdt_GND=(Eav_Vdt_GND+(((0.5*Wd_Vdt_GND)*dEdx0*Icap_IHC)+(((0.5*Wd)*dEdx0)*Icap_IHC_Vdt_GND)));
#endif
E0_Vb2_c1=(Eav_Vb2_c1+(((0.5*Wd_Vb2_c1)*dEdx0*Icap_IHC)+(((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c1)));
#if defined(_DERIVATE2)
  E0_Vb2_c1_Vdt_GND=(+Eav_Vb2_c1_Vdt_GND+(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vdt_GND)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c1)*dEdx0*Icap_IHC_Vdt_GND+(((0.5*Wd_Vdt_GND))*dEdx0)*Icap_IHC_Vb2_c1+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c1_Vdt_GND));
  E0_Vb2_c1_Vb2_c1=(+Eav_Vb2_c1_Vb2_c1+(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c1)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c1)*dEdx0*Icap_IHC_Vb2_c1+(((0.5*Wd_Vb2_c1))*dEdx0)*Icap_IHC_Vb2_c1+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c1_Vb2_c1));
  E0_Vb2_c1_Vb2_c2=(+Eav_Vb2_c1_Vb2_c2+(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c2)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c1)*dEdx0*Icap_IHC_Vb2_c2+(((0.5*Wd_Vb2_c2))*dEdx0)*Icap_IHC_Vb2_c1+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c1_Vb2_c2));
  E0_Vb2_c1_Vc1_c2=(+Eav_Vb2_c1_Vc1_c2+(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vc1_c2)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c1)*dEdx0*Icap_IHC_Vc1_c2+(((0.5*Wd_Vc1_c2))*dEdx0)*Icap_IHC_Vb2_c1+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c1_Vc1_c2));
#endif
E0_Vb2_c2=(Eav_Vb2_c2+(((0.5*Wd_Vb2_c2)*dEdx0*Icap_IHC)+(((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c2)));
#if defined(_DERIVATE2)
  E0_Vb2_c2_Vdt_GND=(+Eav_Vb2_c2_Vdt_GND+(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vdt_GND)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c2)*dEdx0*Icap_IHC_Vdt_GND+(((0.5*Wd_Vdt_GND))*dEdx0)*Icap_IHC_Vb2_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c2_Vdt_GND));
  E0_Vb2_c2_Vb2_c1=(+Eav_Vb2_c2_Vb2_c1+(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c1)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c2)*dEdx0*Icap_IHC_Vb2_c1+(((0.5*Wd_Vb2_c1))*dEdx0)*Icap_IHC_Vb2_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c2_Vb2_c1));
  E0_Vb2_c2_Vb2_c2=(+Eav_Vb2_c2_Vb2_c2+(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c2)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c2)*dEdx0*Icap_IHC_Vb2_c2+(((0.5*Wd_Vb2_c2))*dEdx0)*Icap_IHC_Vb2_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c2_Vb2_c2));
  E0_Vb2_c2_Vc1_c2=(+Eav_Vb2_c2_Vc1_c2+(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vc1_c2)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vb2_c2)*dEdx0*Icap_IHC_Vc1_c2+(((0.5*Wd_Vc1_c2))*dEdx0)*Icap_IHC_Vb2_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vb2_c2_Vc1_c2));
#endif
E0_Vc1_c2=(Eav_Vc1_c2+(((0.5*Wd_Vc1_c2)*dEdx0*Icap_IHC)+(((0.5*Wd)*dEdx0)*Icap_IHC_Vc1_c2)));
#if defined(_DERIVATE2)
  E0_Vc1_c2_Vdt_GND=(+Eav_Vc1_c2_Vdt_GND+(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vdt_GND)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vc1_c2)*dEdx0*Icap_IHC_Vdt_GND+(((0.5*Wd_Vdt_GND))*dEdx0)*Icap_IHC_Vc1_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vc1_c2_Vdt_GND));
  E0_Vc1_c2_Vb2_c1=(+Eav_Vc1_c2_Vb2_c1+(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c1)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vc1_c2)*dEdx0*Icap_IHC_Vb2_c1+(((0.5*Wd_Vb2_c1))*dEdx0)*Icap_IHC_Vc1_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vc1_c2_Vb2_c1));
  E0_Vc1_c2_Vb2_c2=(+Eav_Vc1_c2_Vb2_c2+(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c2)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vc1_c2)*dEdx0*Icap_IHC_Vb2_c2+(((0.5*Wd_Vb2_c2))*dEdx0)*Icap_IHC_Vc1_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vc1_c2_Vb2_c2));
  E0_Vc1_c2_Vc1_c2=(+Eav_Vc1_c2_Vc1_c2+(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vc1_c2)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*Icap_IHC+(0.5*Wd_Vc1_c2)*dEdx0*Icap_IHC_Vc1_c2+(((0.5*Wd_Vc1_c2))*dEdx0)*Icap_IHC_Vc1_c2+((0.5*Wd)*dEdx0)*Icap_IHC_Vc1_c2_Vc1_c2));
#endif
#endif
E0=(Eav+(((0.5*Wd)*dEdx0)*Icap_IHC));
EXIT_IF_ISNAN((Eav+(((0.5*Wd)*dEdx0)*Icap_IHC)))
if
((pModel->EXAVL==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Em_Vdt_GND=E0_Vdt_GND;
#endif
Em_Vb2_c1=E0_Vb2_c1;
#if defined(_DERIVATE2)
  Em_Vb2_c1_Vdt_GND=E0_Vb2_c1_Vdt_GND;
  Em_Vb2_c1_Vb2_c1=E0_Vb2_c1_Vb2_c1;
  Em_Vb2_c1_Vb2_c2=E0_Vb2_c1_Vb2_c2;
  Em_Vb2_c1_Vc1_c2=E0_Vb2_c1_Vc1_c2;
#endif
Em_Vb2_c2=E0_Vb2_c2;
#if defined(_DERIVATE2)
  Em_Vb2_c2_Vdt_GND=E0_Vb2_c2_Vdt_GND;
  Em_Vb2_c2_Vb2_c1=E0_Vb2_c2_Vb2_c1;
  Em_Vb2_c2_Vb2_c2=E0_Vb2_c2_Vb2_c2;
  Em_Vb2_c2_Vc1_c2=E0_Vb2_c2_Vc1_c2;
#endif
Em_Vc1_c2=E0_Vc1_c2;
#if defined(_DERIVATE2)
  Em_Vc1_c2_Vdt_GND=E0_Vc1_c2_Vdt_GND;
  Em_Vc1_c2_Vb2_c1=E0_Vc1_c2_Vb2_c1;
  Em_Vc1_c2_Vb2_c2=E0_Vc1_c2_Vb2_c2;
  Em_Vc1_c2_Vc1_c2=E0_Vc1_c2_Vc1_c2;
#endif
#endif
Em=E0;
EXIT_IF_ISNAN(E0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
SHw_Vb2_c2=((2.0*pModel->SFH)*(2.0*xi_w_Vb2_c2));
#if defined(_DERIVATE2)
  SHw_Vb2_c2_Vb2_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c2))+(0.0)*(2.0*xi_w_Vb2_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vb2_c2+2.0*xi_w_Vb2_c2_Vb2_c2))));
  SHw_Vb2_c2_Vb2_c1=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c1))+(0.0)*(2.0*xi_w_Vb2_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vb2_c2+2.0*xi_w_Vb2_c2_Vb2_c1))));
  SHw_Vb2_c2_Vc1_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vc1_c2))+(0.0)*(2.0*xi_w_Vb2_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vb2_c2+2.0*xi_w_Vb2_c2_Vc1_c2))));
  SHw_Vb2_c2_Vdt_GND=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vdt_GND))+(0.0)*(2.0*xi_w_Vb2_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vb2_c2+2.0*xi_w_Vb2_c2_Vdt_GND))));
#endif
SHw_Vb2_c1=((2.0*pModel->SFH)*(2.0*xi_w_Vb2_c1));
#if defined(_DERIVATE2)
  SHw_Vb2_c1_Vb2_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c2))+(0.0)*(2.0*xi_w_Vb2_c1)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vb2_c1+2.0*xi_w_Vb2_c1_Vb2_c2))));
  SHw_Vb2_c1_Vb2_c1=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c1))+(0.0)*(2.0*xi_w_Vb2_c1)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vb2_c1+2.0*xi_w_Vb2_c1_Vb2_c1))));
  SHw_Vb2_c1_Vc1_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vc1_c2))+(0.0)*(2.0*xi_w_Vb2_c1)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vb2_c1+2.0*xi_w_Vb2_c1_Vc1_c2))));
  SHw_Vb2_c1_Vdt_GND=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vdt_GND))+(0.0)*(2.0*xi_w_Vb2_c1)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vb2_c1+2.0*xi_w_Vb2_c1_Vdt_GND))));
#endif
SHw_Vc1_c2=((2.0*pModel->SFH)*(2.0*xi_w_Vc1_c2));
#if defined(_DERIVATE2)
  SHw_Vc1_c2_Vb2_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c2))+(0.0)*(2.0*xi_w_Vc1_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c2+0.0*xi_w_Vc1_c2+2.0*xi_w_Vc1_c2_Vb2_c2))));
  SHw_Vc1_c2_Vb2_c1=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vb2_c1))+(0.0)*(2.0*xi_w_Vc1_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vb2_c1+0.0*xi_w_Vc1_c2+2.0*xi_w_Vc1_c2_Vb2_c1))));
  SHw_Vc1_c2_Vc1_c2=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vc1_c2))+(0.0)*(2.0*xi_w_Vc1_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vc1_c2+0.0*xi_w_Vc1_c2+2.0*xi_w_Vc1_c2_Vc1_c2))));
  SHw_Vc1_c2_Vdt_GND=(+0.0+(+(+0.0*pModel->SFH+0.0*0.0+0.0*0.0+2.0*0.0)*(1.0+(2.0*xi_w))+0.0*((2.0*xi_w_Vdt_GND))+(0.0)*(2.0*xi_w_Vc1_c2)+(2.0*pModel->SFH)*(+0.0+(+0.0*xi_w+0.0*xi_w_Vdt_GND+0.0*xi_w_Vc1_c2+2.0*xi_w_Vc1_c2_Vdt_GND))));
#endif
#if defined(_DERIVATE)
SHw_Vdt_GND=((2.0*pModel->SFH)*(2.0*xi_w_Vdt_GND));
#endif
#endif
SHw=(1.0+((2.0*pModel->SFH)*(1.0+(2.0*xi_w))));
EXIT_IF_ISNAN((1.0+((2.0*pModel->SFH)*(1.0+(2.0*xi_w)))))
Efi=((1.0+pModel->SFH)/(1.0+(2.0*pModel->SFH)));
EXIT_IF_ISNAN(((1.0+pModel->SFH)/(1.0+(2.0*pModel->SFH))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Ew_Vdt_GND=(Eav_Vdt_GND-(((0.5*Wd_Vdt_GND)*dEdx0*(Efi-(Ic1c2/(IHC_M*SHw))))+(((0.5*Wd)*dEdx0)*(-((Ic1c2_Vdt_GND*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw))))));
#endif
Ew_Vb2_c1=(Eav_Vb2_c1-(((0.5*Wd_Vb2_c1)*dEdx0*(Efi-(Ic1c2/(IHC_M*SHw))))+(((0.5*Wd)*dEdx0)*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw))))));
#if defined(_DERIVATE2)
  Ew_Vb2_c1_Vdt_GND=(+Eav_Vb2_c1_Vdt_GND-(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vdt_GND)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c1)*dEdx0*(-((Ic1c2_Vdt_GND*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vdt_GND)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vdt_GND))*dEdx0)*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c1_Vdt_GND/(IHC_M*SHw)-(Ic1c2_Vb2_c1*((IHC_M*SHw_Vdt_GND))+Ic1c2_Vdt_GND*(IHC_M*SHw_Vb2_c1)+Ic1c2*(+0.0*SHw+0.0*SHw_Vdt_GND+0.0*SHw_Vb2_c1+IHC_M*SHw_Vb2_c1_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c1)*((IHC_M*SHw_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c1_Vb2_c1=(+Eav_Vb2_c1_Vb2_c1-(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c1)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c1)*dEdx0*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c1)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c1))*dEdx0)*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c1_Vb2_c1/(IHC_M*SHw)-(Ic1c2_Vb2_c1*((IHC_M*SHw_Vb2_c1))+Ic1c2_Vb2_c1*(IHC_M*SHw_Vb2_c1)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c1+0.0*SHw_Vb2_c1+IHC_M*SHw_Vb2_c1_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c1)*((IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c1_Vb2_c2=(+Eav_Vb2_c1_Vb2_c2-(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c2)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c1)*dEdx0*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c2))*dEdx0)*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c1_Vb2_c2/(IHC_M*SHw)-(Ic1c2_Vb2_c1*((IHC_M*SHw_Vb2_c2))+Ic1c2_Vb2_c2*(IHC_M*SHw_Vb2_c1)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c2+0.0*SHw_Vb2_c1+IHC_M*SHw_Vb2_c1_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c1)*((IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c1_Vc1_c2=(+Eav_Vb2_c1_Vc1_c2-(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vc1_c2)*dEdx0+(0.5*Wd_Vb2_c1)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c1)*dEdx0*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vc1_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vc1_c2))*dEdx0)*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c1_Vc1_c2/(IHC_M*SHw)-(Ic1c2_Vb2_c1*((IHC_M*SHw_Vc1_c2))+Ic1c2_Vc1_c2*(IHC_M*SHw_Vb2_c1)+Ic1c2*(+0.0*SHw+0.0*SHw_Vc1_c2+0.0*SHw_Vb2_c1+IHC_M*SHw_Vb2_c1_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c1)*((IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
#endif
Ew_Vb2_c2=(Eav_Vb2_c2-(((0.5*Wd_Vb2_c2)*dEdx0*(Efi-(Ic1c2/(IHC_M*SHw))))+(((0.5*Wd)*dEdx0)*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw))))));
#if defined(_DERIVATE2)
  Ew_Vb2_c2_Vdt_GND=(+Eav_Vb2_c2_Vdt_GND-(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vdt_GND)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c2)*dEdx0*(-((Ic1c2_Vdt_GND*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vdt_GND)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vdt_GND))*dEdx0)*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c2_Vdt_GND/(IHC_M*SHw)-(Ic1c2_Vb2_c2*((IHC_M*SHw_Vdt_GND))+Ic1c2_Vdt_GND*(IHC_M*SHw_Vb2_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vdt_GND+0.0*SHw_Vb2_c2+IHC_M*SHw_Vb2_c2_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c2)*((IHC_M*SHw_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c2_Vb2_c1=(+Eav_Vb2_c2_Vb2_c1-(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c1)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c2)*dEdx0*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c1)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c1))*dEdx0)*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c2_Vb2_c1/(IHC_M*SHw)-(Ic1c2_Vb2_c2*((IHC_M*SHw_Vb2_c1))+Ic1c2_Vb2_c1*(IHC_M*SHw_Vb2_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c1+0.0*SHw_Vb2_c2+IHC_M*SHw_Vb2_c2_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c2)*((IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c2_Vb2_c2=(+Eav_Vb2_c2_Vb2_c2-(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c2)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c2)*dEdx0*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c2))*dEdx0)*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c2_Vb2_c2/(IHC_M*SHw)-(Ic1c2_Vb2_c2*((IHC_M*SHw_Vb2_c2))+Ic1c2_Vb2_c2*(IHC_M*SHw_Vb2_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c2+0.0*SHw_Vb2_c2+IHC_M*SHw_Vb2_c2_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c2)*((IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vb2_c2_Vc1_c2=(+Eav_Vb2_c2_Vc1_c2-(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vc1_c2)*dEdx0+(0.5*Wd_Vb2_c2)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vb2_c2)*dEdx0*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vc1_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vc1_c2))*dEdx0)*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vb2_c2_Vc1_c2/(IHC_M*SHw)-(Ic1c2_Vb2_c2*((IHC_M*SHw_Vc1_c2))+Ic1c2_Vc1_c2*(IHC_M*SHw_Vb2_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vc1_c2+0.0*SHw_Vb2_c2+IHC_M*SHw_Vb2_c2_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vb2_c2)*((IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
#endif
Ew_Vc1_c2=(Eav_Vc1_c2-(((0.5*Wd_Vc1_c2)*dEdx0*(Efi-(Ic1c2/(IHC_M*SHw))))+(((0.5*Wd)*dEdx0)*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw))))));
#if defined(_DERIVATE2)
  Ew_Vc1_c2_Vdt_GND=(+Eav_Vc1_c2_Vdt_GND-(+(+(+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vdt_GND)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vdt_GND))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vc1_c2)*dEdx0*(-((Ic1c2_Vdt_GND*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vdt_GND)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vdt_GND))*dEdx0)*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vc1_c2_Vdt_GND/(IHC_M*SHw)-(Ic1c2_Vc1_c2*((IHC_M*SHw_Vdt_GND))+Ic1c2_Vdt_GND*(IHC_M*SHw_Vc1_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vdt_GND+0.0*SHw_Vc1_c2+IHC_M*SHw_Vc1_c2_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vc1_c2)*((IHC_M*SHw_Vdt_GND))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vc1_c2_Vb2_c1=(+Eav_Vc1_c2_Vb2_c1-(+(+(+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c1)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vb2_c1))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vc1_c2)*dEdx0*(-((Ic1c2_Vb2_c1*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c1)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c1))*dEdx0)*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vc1_c2_Vb2_c1/(IHC_M*SHw)-(Ic1c2_Vc1_c2*((IHC_M*SHw_Vb2_c1))+Ic1c2_Vb2_c1*(IHC_M*SHw_Vc1_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c1+0.0*SHw_Vc1_c2+IHC_M*SHw_Vc1_c2_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vc1_c2)*((IHC_M*SHw_Vb2_c1))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vc1_c2_Vb2_c2=(+Eav_Vc1_c2_Vb2_c2-(+(+(+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c2)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vb2_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vc1_c2)*dEdx0*(-((Ic1c2_Vb2_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vb2_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vb2_c2))*dEdx0)*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vc1_c2_Vb2_c2/(IHC_M*SHw)-(Ic1c2_Vc1_c2*((IHC_M*SHw_Vb2_c2))+Ic1c2_Vb2_c2*(IHC_M*SHw_Vc1_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vb2_c2+0.0*SHw_Vc1_c2+IHC_M*SHw_Vc1_c2_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vc1_c2)*((IHC_M*SHw_Vb2_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
  Ew_Vc1_c2_Vc1_c2=(+Eav_Vc1_c2_Vc1_c2-(+(+(+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vc1_c2)*dEdx0+(0.5*Wd_Vc1_c2)*0.0+((0.5*Wd_Vc1_c2))*0.0+(0.5*Wd)*0.0)*(Efi-(Ic1c2/(IHC_M*SHw)))+(0.5*Wd_Vc1_c2)*dEdx0*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*((IHC_M*SHw_Vc1_c2)))/(IHC_M*SHw)/(IHC_M*SHw)))+(((0.5*Wd_Vc1_c2))*dEdx0)*(-((Ic1c2_Vc1_c2*(IHC_M*SHw)-Ic1c2*(IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)))+((0.5*Wd)*dEdx0)*(+0.0-(Ic1c2_Vc1_c2_Vc1_c2/(IHC_M*SHw)-(Ic1c2_Vc1_c2*((IHC_M*SHw_Vc1_c2))+Ic1c2_Vc1_c2*(IHC_M*SHw_Vc1_c2)+Ic1c2*(+0.0*SHw+0.0*SHw_Vc1_c2+0.0*SHw_Vc1_c2+IHC_M*SHw_Vc1_c2_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)+2*Ic1c2*(IHC_M*SHw_Vc1_c2)*((IHC_M*SHw_Vc1_c2))/(IHC_M*SHw)/(IHC_M*SHw)/(IHC_M*SHw)))));
#endif
#endif
Ew=(Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw)))));
EXIT_IF_ISNAN((Eav-(((0.5*Wd)*dEdx0)*(Efi-(Ic1c2/(IHC_M*SHw))))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
sqr_arg_Vdt_GND=((((Ew_Vdt_GND-E0_Vdt_GND)*(Ew-E0))+((Ew-E0)*(Ew_Vdt_GND-E0_Vdt_GND)))+((((((0.1*Eav_Vdt_GND)*Eav)+((0.1*Eav)*Eav_Vdt_GND))*Icap)+(((0.1*Eav)*Eav)*Icap_Vdt_GND))/IHC_M));
#endif
sqr_arg_Vb2_c2=((((Ew_Vb2_c2-E0_Vb2_c2)*(Ew-E0))+((Ew-E0)*(Ew_Vb2_c2-E0_Vb2_c2)))+((((((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2))/IHC_M));
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c2_Vdt_GND=(+(+(+Ew_Vb2_c2_Vdt_GND-E0_Vb2_c2_Vdt_GND)*(Ew-E0)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vdt_GND-E0_Vdt_GND)+(Ew_Vdt_GND-E0_Vdt_GND)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew-E0)*(+Ew_Vb2_c2_Vdt_GND-E0_Vb2_c2_Vdt_GND))+((+(+(+0.0*Eav+0.0*Eav_Vdt_GND+0.0*Eav_Vb2_c2+0.1*Eav_Vb2_c2_Vdt_GND)*Eav+(0.1*Eav_Vb2_c2)*Eav_Vdt_GND+((0.1*Eav_Vdt_GND))*Eav_Vb2_c2+(0.1*Eav)*Eav_Vb2_c2_Vdt_GND)*Icap+(((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap_Vdt_GND+(((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap_Vb2_c2+((0.1*Eav)*Eav)*Icap_Vb2_c2_Vdt_GND)/IHC_M-((((((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2))*0.0+((((((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vdt_GND)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c2_Vb2_c2=(+(+(+Ew_Vb2_c2_Vb2_c2-E0_Vb2_c2_Vb2_c2)*(Ew-E0)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew-E0)*(+Ew_Vb2_c2_Vb2_c2-E0_Vb2_c2_Vb2_c2))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c2+0.0*Eav_Vb2_c2+0.1*Eav_Vb2_c2_Vb2_c2)*Eav+(0.1*Eav_Vb2_c2)*Eav_Vb2_c2+((0.1*Eav_Vb2_c2))*Eav_Vb2_c2+(0.1*Eav)*Eav_Vb2_c2_Vb2_c2)*Icap+(((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap_Vb2_c2+(((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap_Vb2_c2+((0.1*Eav)*Eav)*Icap_Vb2_c2_Vb2_c2)/IHC_M-((((((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2))*0.0+((((((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c2_Vb2_c1=(+(+(+Ew_Vb2_c2_Vb2_c1-E0_Vb2_c2_Vb2_c1)*(Ew-E0)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew-E0)*(+Ew_Vb2_c2_Vb2_c1-E0_Vb2_c2_Vb2_c1))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c1+0.0*Eav_Vb2_c2+0.1*Eav_Vb2_c2_Vb2_c1)*Eav+(0.1*Eav_Vb2_c2)*Eav_Vb2_c1+((0.1*Eav_Vb2_c1))*Eav_Vb2_c2+(0.1*Eav)*Eav_Vb2_c2_Vb2_c1)*Icap+(((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap_Vb2_c1+(((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap_Vb2_c2+((0.1*Eav)*Eav)*Icap_Vb2_c2_Vb2_c1)/IHC_M-((((((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2))*0.0+((((((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c2_Vc1_c2=(+(+(+Ew_Vb2_c2_Vc1_c2-E0_Vb2_c2_Vc1_c2)*(Ew-E0)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew-E0)*(+Ew_Vb2_c2_Vc1_c2-E0_Vb2_c2_Vc1_c2))+((+(+(+0.0*Eav+0.0*Eav_Vc1_c2+0.0*Eav_Vb2_c2+0.1*Eav_Vb2_c2_Vc1_c2)*Eav+(0.1*Eav_Vb2_c2)*Eav_Vc1_c2+((0.1*Eav_Vc1_c2))*Eav_Vb2_c2+(0.1*Eav)*Eav_Vb2_c2_Vc1_c2)*Icap+(((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap_Vc1_c2+(((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap_Vb2_c2+((0.1*Eav)*Eav)*Icap_Vb2_c2_Vc1_c2)/IHC_M-((((((0.1*Eav_Vb2_c2)*Eav)+((0.1*Eav)*Eav_Vb2_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2))*0.0+((((((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
sqr_arg_Vb2_c1=((((Ew_Vb2_c1-E0_Vb2_c1)*(Ew-E0))+((Ew-E0)*(Ew_Vb2_c1-E0_Vb2_c1)))+((((((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1))/IHC_M));
#if defined(_DERIVATE2)
  sqr_arg_Vb2_c1_Vdt_GND=(+(+(+Ew_Vb2_c1_Vdt_GND-E0_Vb2_c1_Vdt_GND)*(Ew-E0)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vdt_GND-E0_Vdt_GND)+(Ew_Vdt_GND-E0_Vdt_GND)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew-E0)*(+Ew_Vb2_c1_Vdt_GND-E0_Vb2_c1_Vdt_GND))+((+(+(+0.0*Eav+0.0*Eav_Vdt_GND+0.0*Eav_Vb2_c1+0.1*Eav_Vb2_c1_Vdt_GND)*Eav+(0.1*Eav_Vb2_c1)*Eav_Vdt_GND+((0.1*Eav_Vdt_GND))*Eav_Vb2_c1+(0.1*Eav)*Eav_Vb2_c1_Vdt_GND)*Icap+(((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap_Vdt_GND+(((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap_Vb2_c1+((0.1*Eav)*Eav)*Icap_Vb2_c1_Vdt_GND)/IHC_M-((((((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1))*0.0+((((((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vdt_GND)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c1_Vb2_c2=(+(+(+Ew_Vb2_c1_Vb2_c2-E0_Vb2_c1_Vb2_c2)*(Ew-E0)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew-E0)*(+Ew_Vb2_c1_Vb2_c2-E0_Vb2_c1_Vb2_c2))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c2+0.0*Eav_Vb2_c1+0.1*Eav_Vb2_c1_Vb2_c2)*Eav+(0.1*Eav_Vb2_c1)*Eav_Vb2_c2+((0.1*Eav_Vb2_c2))*Eav_Vb2_c1+(0.1*Eav)*Eav_Vb2_c1_Vb2_c2)*Icap+(((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap_Vb2_c2+(((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap_Vb2_c1+((0.1*Eav)*Eav)*Icap_Vb2_c1_Vb2_c2)/IHC_M-((((((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1))*0.0+((((((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c1_Vb2_c1=(+(+(+Ew_Vb2_c1_Vb2_c1-E0_Vb2_c1_Vb2_c1)*(Ew-E0)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew-E0)*(+Ew_Vb2_c1_Vb2_c1-E0_Vb2_c1_Vb2_c1))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c1+0.0*Eav_Vb2_c1+0.1*Eav_Vb2_c1_Vb2_c1)*Eav+(0.1*Eav_Vb2_c1)*Eav_Vb2_c1+((0.1*Eav_Vb2_c1))*Eav_Vb2_c1+(0.1*Eav)*Eav_Vb2_c1_Vb2_c1)*Icap+(((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap_Vb2_c1+(((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap_Vb2_c1+((0.1*Eav)*Eav)*Icap_Vb2_c1_Vb2_c1)/IHC_M-((((((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1))*0.0+((((((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vb2_c1_Vc1_c2=(+(+(+Ew_Vb2_c1_Vc1_c2-E0_Vb2_c1_Vc1_c2)*(Ew-E0)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew-E0)*(+Ew_Vb2_c1_Vc1_c2-E0_Vb2_c1_Vc1_c2))+((+(+(+0.0*Eav+0.0*Eav_Vc1_c2+0.0*Eav_Vb2_c1+0.1*Eav_Vb2_c1_Vc1_c2)*Eav+(0.1*Eav_Vb2_c1)*Eav_Vc1_c2+((0.1*Eav_Vc1_c2))*Eav_Vb2_c1+(0.1*Eav)*Eav_Vb2_c1_Vc1_c2)*Icap+(((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap_Vc1_c2+(((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap_Vb2_c1+((0.1*Eav)*Eav)*Icap_Vb2_c1_Vc1_c2)/IHC_M-((((((0.1*Eav_Vb2_c1)*Eav)+((0.1*Eav)*Eav_Vb2_c1))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1))*0.0+((((((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
sqr_arg_Vc1_c2=((((Ew_Vc1_c2-E0_Vc1_c2)*(Ew-E0))+((Ew-E0)*(Ew_Vc1_c2-E0_Vc1_c2)))+((((((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2))/IHC_M));
#if defined(_DERIVATE2)
  sqr_arg_Vc1_c2_Vdt_GND=(+(+(+Ew_Vc1_c2_Vdt_GND-E0_Vc1_c2_Vdt_GND)*(Ew-E0)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vdt_GND-E0_Vdt_GND)+(Ew_Vdt_GND-E0_Vdt_GND)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew-E0)*(+Ew_Vc1_c2_Vdt_GND-E0_Vc1_c2_Vdt_GND))+((+(+(+0.0*Eav+0.0*Eav_Vdt_GND+0.0*Eav_Vc1_c2+0.1*Eav_Vc1_c2_Vdt_GND)*Eav+(0.1*Eav_Vc1_c2)*Eav_Vdt_GND+((0.1*Eav_Vdt_GND))*Eav_Vc1_c2+(0.1*Eav)*Eav_Vc1_c2_Vdt_GND)*Icap+(((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap_Vdt_GND+(((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap_Vc1_c2+((0.1*Eav)*Eav)*Icap_Vc1_c2_Vdt_GND)/IHC_M-((((((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2))*0.0+((((((((0.1*Eav_Vdt_GND))*Eav)+((0.1*Eav)*Eav_Vdt_GND)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vdt_GND)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vc1_c2_Vb2_c2=(+(+(+Ew_Vc1_c2_Vb2_c2-E0_Vc1_c2_Vb2_c2)*(Ew-E0)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vb2_c2-E0_Vb2_c2)+(Ew_Vb2_c2-E0_Vb2_c2)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew-E0)*(+Ew_Vc1_c2_Vb2_c2-E0_Vc1_c2_Vb2_c2))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c2+0.0*Eav_Vc1_c2+0.1*Eav_Vc1_c2_Vb2_c2)*Eav+(0.1*Eav_Vc1_c2)*Eav_Vb2_c2+((0.1*Eav_Vb2_c2))*Eav_Vc1_c2+(0.1*Eav)*Eav_Vc1_c2_Vb2_c2)*Icap+(((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap_Vb2_c2+(((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap_Vc1_c2+((0.1*Eav)*Eav)*Icap_Vc1_c2_Vb2_c2)/IHC_M-((((((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2))*0.0+((((((((0.1*Eav_Vb2_c2))*Eav)+((0.1*Eav)*Eav_Vb2_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vc1_c2_Vb2_c1=(+(+(+Ew_Vc1_c2_Vb2_c1-E0_Vc1_c2_Vb2_c1)*(Ew-E0)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vb2_c1-E0_Vb2_c1)+(Ew_Vb2_c1-E0_Vb2_c1)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew-E0)*(+Ew_Vc1_c2_Vb2_c1-E0_Vc1_c2_Vb2_c1))+((+(+(+0.0*Eav+0.0*Eav_Vb2_c1+0.0*Eav_Vc1_c2+0.1*Eav_Vc1_c2_Vb2_c1)*Eav+(0.1*Eav_Vc1_c2)*Eav_Vb2_c1+((0.1*Eav_Vb2_c1))*Eav_Vc1_c2+(0.1*Eav)*Eav_Vc1_c2_Vb2_c1)*Icap+(((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap_Vb2_c1+(((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap_Vc1_c2+((0.1*Eav)*Eav)*Icap_Vc1_c2_Vb2_c1)/IHC_M-((((((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2))*0.0+((((((((0.1*Eav_Vb2_c1))*Eav)+((0.1*Eav)*Eav_Vb2_c1)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vb2_c1)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
  sqr_arg_Vc1_c2_Vc1_c2=(+(+(+Ew_Vc1_c2_Vc1_c2-E0_Vc1_c2_Vc1_c2)*(Ew-E0)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew_Vc1_c2-E0_Vc1_c2)*(Ew_Vc1_c2-E0_Vc1_c2)+(Ew-E0)*(+Ew_Vc1_c2_Vc1_c2-E0_Vc1_c2_Vc1_c2))+((+(+(+0.0*Eav+0.0*Eav_Vc1_c2+0.0*Eav_Vc1_c2+0.1*Eav_Vc1_c2_Vc1_c2)*Eav+(0.1*Eav_Vc1_c2)*Eav_Vc1_c2+((0.1*Eav_Vc1_c2))*Eav_Vc1_c2+(0.1*Eav)*Eav_Vc1_c2_Vc1_c2)*Icap+(((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap_Vc1_c2+(((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap_Vc1_c2+((0.1*Eav)*Eav)*Icap_Vc1_c2_Vc1_c2)/IHC_M-((((((0.1*Eav_Vc1_c2)*Eav)+((0.1*Eav)*Eav_Vc1_c2))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2))*0.0+((((((((0.1*Eav_Vc1_c2))*Eav)+((0.1*Eav)*Eav_Vc1_c2)))*Icap)+(((0.1*Eav)*Eav)*Icap_Vc1_c2)))*0.0+(((0.1*Eav)*Eav)*Icap)*0.0)/IHC_M/IHC_M+2*(((0.1*Eav)*Eav)*Icap)*0.0*0.0/IHC_M/IHC_M/IHC_M));
#endif
#endif
sqr_arg=(((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M));
EXIT_IF_ISNAN((((Ew-E0)*(Ew-E0))+((((0.1*Eav)*Eav)*Icap)/IHC_M)))
{
double m00_sqrt(d00_sqrt0,sqr_arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,sqr_arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Em_Vdt_GND=(0.5*((Ew_Vdt_GND+E0_Vdt_GND)+sqr_arg_Vdt_GND*d10_sqrt0));
#endif
Em_Vb2_c1=(0.5*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0));
#if defined(_DERIVATE2)
  Em_Vb2_c1_Vdt_GND=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vdt_GND+E0_Vdt_GND)+sqr_arg_Vdt_GND*d10_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.5*(+(+Ew_Vb2_c1_Vdt_GND+E0_Vb2_c1_Vdt_GND)+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vdt_GND)));
  Em_Vb2_c1_Vb2_c1=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.5*(+(+Ew_Vb2_c1_Vb2_c1+E0_Vb2_c1_Vb2_c1)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c1)));
  Em_Vb2_c1_Vb2_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.5*(+(+Ew_Vb2_c1_Vb2_c2+E0_Vb2_c1_Vb2_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vb2_c2)));
  Em_Vb2_c1_Vc1_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.5*(+(+Ew_Vb2_c1_Vc1_c2+E0_Vb2_c1_Vc1_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c1+d10_sqrt0*sqr_arg_Vb2_c1_Vc1_c2)));
#endif
Em_Vb2_c2=(0.5*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0));
#if defined(_DERIVATE2)
  Em_Vb2_c2_Vdt_GND=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vdt_GND+E0_Vdt_GND)+sqr_arg_Vdt_GND*d10_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.5*(+(+Ew_Vb2_c2_Vdt_GND+E0_Vb2_c2_Vdt_GND)+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vdt_GND)));
  Em_Vb2_c2_Vb2_c1=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.5*(+(+Ew_Vb2_c2_Vb2_c1+E0_Vb2_c2_Vb2_c1)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c1)));
  Em_Vb2_c2_Vb2_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.5*(+(+Ew_Vb2_c2_Vb2_c2+E0_Vb2_c2_Vb2_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vb2_c2)));
  Em_Vb2_c2_Vc1_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.5*(+(+Ew_Vb2_c2_Vc1_c2+E0_Vb2_c2_Vc1_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vb2_c2+d10_sqrt0*sqr_arg_Vb2_c2_Vc1_c2)));
#endif
Em_Vc1_c2=(0.5*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0));
#if defined(_DERIVATE2)
  Em_Vc1_c2_Vdt_GND=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vdt_GND+E0_Vdt_GND)+sqr_arg_Vdt_GND*d10_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.5*(+(+Ew_Vc1_c2_Vdt_GND+E0_Vc1_c2_Vdt_GND)+(m20_sqrt(sqr_arg)*sqr_arg_Vdt_GND*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vdt_GND)));
  Em_Vc1_c2_Vb2_c1=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c1+E0_Vb2_c1)+sqr_arg_Vb2_c1*d10_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.5*(+(+Ew_Vc1_c2_Vb2_c1+E0_Vc1_c2_Vb2_c1)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c1*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c1)));
  Em_Vc1_c2_Vb2_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vb2_c2+E0_Vb2_c2)+sqr_arg_Vb2_c2*d10_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.5*(+(+Ew_Vc1_c2_Vb2_c2+E0_Vc1_c2_Vb2_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vb2_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vb2_c2)));
  Em_Vc1_c2_Vc1_c2=(+0.0*((Ew+E0)+d00_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.0*((Ew_Vc1_c2+E0_Vc1_c2)+sqr_arg_Vc1_c2*d10_sqrt0)+0.5*(+(+Ew_Vc1_c2_Vc1_c2+E0_Vc1_c2_Vc1_c2)+(m20_sqrt(sqr_arg)*sqr_arg_Vc1_c2*sqr_arg_Vc1_c2+d10_sqrt0*sqr_arg_Vc1_c2_Vc1_c2)));
#endif
#endif
Em=(0.5*((Ew+E0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((Ew+E0)+d00_sqrt0)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
EmEav_Em_Vdt_GND=(((Em_Vdt_GND-Eav_Vdt_GND)*Em-(Em-Eav)*Em_Vdt_GND)/Em/Em);
#endif
EmEav_Em_Vb2_c1=(((Em_Vb2_c1-Eav_Vb2_c1)*Em-(Em-Eav)*Em_Vb2_c1)/Em/Em);
#if defined(_DERIVATE2)
  EmEav_Em_Vb2_c1_Vdt_GND=((+Em_Vb2_c1_Vdt_GND-Eav_Vb2_c1_Vdt_GND)/Em-((Em_Vb2_c1-Eav_Vb2_c1)*Em_Vdt_GND+(Em_Vdt_GND-Eav_Vdt_GND)*Em_Vb2_c1+(Em-Eav)*Em_Vb2_c1_Vdt_GND)/Em/Em+2*(Em-Eav)*Em_Vb2_c1*Em_Vdt_GND/Em/Em/Em);
  EmEav_Em_Vb2_c1_Vb2_c1=((+Em_Vb2_c1_Vb2_c1-Eav_Vb2_c1_Vb2_c1)/Em-((Em_Vb2_c1-Eav_Vb2_c1)*Em_Vb2_c1+(Em_Vb2_c1-Eav_Vb2_c1)*Em_Vb2_c1+(Em-Eav)*Em_Vb2_c1_Vb2_c1)/Em/Em+2*(Em-Eav)*Em_Vb2_c1*Em_Vb2_c1/Em/Em/Em);
  EmEav_Em_Vb2_c1_Vb2_c2=((+Em_Vb2_c1_Vb2_c2-Eav_Vb2_c1_Vb2_c2)/Em-((Em_Vb2_c1-Eav_Vb2_c1)*Em_Vb2_c2+(Em_Vb2_c2-Eav_Vb2_c2)*Em_Vb2_c1+(Em-Eav)*Em_Vb2_c1_Vb2_c2)/Em/Em+2*(Em-Eav)*Em_Vb2_c1*Em_Vb2_c2/Em/Em/Em);
  EmEav_Em_Vb2_c1_Vc1_c2=((+Em_Vb2_c1_Vc1_c2-Eav_Vb2_c1_Vc1_c2)/Em-((Em_Vb2_c1-Eav_Vb2_c1)*Em_Vc1_c2+(Em_Vc1_c2-Eav_Vc1_c2)*Em_Vb2_c1+(Em-Eav)*Em_Vb2_c1_Vc1_c2)/Em/Em+2*(Em-Eav)*Em_Vb2_c1*Em_Vc1_c2/Em/Em/Em);
#endif
EmEav_Em_Vb2_c2=(((Em_Vb2_c2-Eav_Vb2_c2)*Em-(Em-Eav)*Em_Vb2_c2)/Em/Em);
#if defined(_DERIVATE2)
  EmEav_Em_Vb2_c2_Vdt_GND=((+Em_Vb2_c2_Vdt_GND-Eav_Vb2_c2_Vdt_GND)/Em-((Em_Vb2_c2-Eav_Vb2_c2)*Em_Vdt_GND+(Em_Vdt_GND-Eav_Vdt_GND)*Em_Vb2_c2+(Em-Eav)*Em_Vb2_c2_Vdt_GND)/Em/Em+2*(Em-Eav)*Em_Vb2_c2*Em_Vdt_GND/Em/Em/Em);
  EmEav_Em_Vb2_c2_Vb2_c1=((+Em_Vb2_c2_Vb2_c1-Eav_Vb2_c2_Vb2_c1)/Em-((Em_Vb2_c2-Eav_Vb2_c2)*Em_Vb2_c1+(Em_Vb2_c1-Eav_Vb2_c1)*Em_Vb2_c2+(Em-Eav)*Em_Vb2_c2_Vb2_c1)/Em/Em+2*(Em-Eav)*Em_Vb2_c2*Em_Vb2_c1/Em/Em/Em);
  EmEav_Em_Vb2_c2_Vb2_c2=((+Em_Vb2_c2_Vb2_c2-Eav_Vb2_c2_Vb2_c2)/Em-((Em_Vb2_c2-Eav_Vb2_c2)*Em_Vb2_c2+(Em_Vb2_c2-Eav_Vb2_c2)*Em_Vb2_c2+(Em-Eav)*Em_Vb2_c2_Vb2_c2)/Em/Em+2*(Em-Eav)*Em_Vb2_c2*Em_Vb2_c2/Em/Em/Em);
  EmEav_Em_Vb2_c2_Vc1_c2=((+Em_Vb2_c2_Vc1_c2-Eav_Vb2_c2_Vc1_c2)/Em-((Em_Vb2_c2-Eav_Vb2_c2)*Em_Vc1_c2+(Em_Vc1_c2-Eav_Vc1_c2)*Em_Vb2_c2+(Em-Eav)*Em_Vb2_c2_Vc1_c2)/Em/Em+2*(Em-Eav)*Em_Vb2_c2*Em_Vc1_c2/Em/Em/Em);
#endif
EmEav_Em_Vc1_c2=(((Em_Vc1_c2-Eav_Vc1_c2)*Em-(Em-Eav)*Em_Vc1_c2)/Em/Em);
#if defined(_DERIVATE2)
  EmEav_Em_Vc1_c2_Vdt_GND=((+Em_Vc1_c2_Vdt_GND-Eav_Vc1_c2_Vdt_GND)/Em-((Em_Vc1_c2-Eav_Vc1_c2)*Em_Vdt_GND+(Em_Vdt_GND-Eav_Vdt_GND)*Em_Vc1_c2+(Em-Eav)*Em_Vc1_c2_Vdt_GND)/Em/Em+2*(Em-Eav)*Em_Vc1_c2*Em_Vdt_GND/Em/Em/Em);
  EmEav_Em_Vc1_c2_Vb2_c1=((+Em_Vc1_c2_Vb2_c1-Eav_Vc1_c2_Vb2_c1)/Em-((Em_Vc1_c2-Eav_Vc1_c2)*Em_Vb2_c1+(Em_Vb2_c1-Eav_Vb2_c1)*Em_Vc1_c2+(Em-Eav)*Em_Vc1_c2_Vb2_c1)/Em/Em+2*(Em-Eav)*Em_Vc1_c2*Em_Vb2_c1/Em/Em/Em);
  EmEav_Em_Vc1_c2_Vb2_c2=((+Em_Vc1_c2_Vb2_c2-Eav_Vc1_c2_Vb2_c2)/Em-((Em_Vc1_c2-Eav_Vc1_c2)*Em_Vb2_c2+(Em_Vb2_c2-Eav_Vb2_c2)*Em_Vc1_c2+(Em-Eav)*Em_Vc1_c2_Vb2_c2)/Em/Em+2*(Em-Eav)*Em_Vc1_c2*Em_Vb2_c2/Em/Em/Em);
  EmEav_Em_Vc1_c2_Vc1_c2=((+Em_Vc1_c2_Vc1_c2-Eav_Vc1_c2_Vc1_c2)/Em-((Em_Vc1_c2-Eav_Vc1_c2)*Em_Vc1_c2+(Em_Vc1_c2-Eav_Vc1_c2)*Em_Vc1_c2+(Em-Eav)*Em_Vc1_c2_Vc1_c2)/Em/Em+2*(Em-Eav)*Em_Vc1_c2*Em_Vc1_c2/Em/Em/Em);
#endif
#endif
EmEav_Em=((Em-Eav)/Em);
EXIT_IF_ISNAN(((Em-Eav)/Em))
{
double m00_fabs(d00_fabs0,EmEav_Em)
if
((d00_fabs0>1.0e-7))
{
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
lambda_Vdt_GND=(((0.5*Wd_Vdt_GND)*EmEav_Em-(0.5*Wd)*EmEav_Em_Vdt_GND)/EmEav_Em/EmEav_Em);
#endif
lambda_Vb2_c2=(((0.5*Wd_Vb2_c2)*EmEav_Em-(0.5*Wd)*EmEav_Em_Vb2_c2)/EmEav_Em/EmEav_Em);
#if defined(_DERIVATE2)
  lambda_Vb2_c2_Vdt_GND=((+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vdt_GND)/EmEav_Em-((0.5*Wd_Vb2_c2)*EmEav_Em_Vdt_GND+((0.5*Wd_Vdt_GND))*EmEav_Em_Vb2_c2+(0.5*Wd)*EmEav_Em_Vb2_c2_Vdt_GND)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c2*EmEav_Em_Vdt_GND/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c2_Vb2_c2=((+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c2)/EmEav_Em-((0.5*Wd_Vb2_c2)*EmEav_Em_Vb2_c2+((0.5*Wd_Vb2_c2))*EmEav_Em_Vb2_c2+(0.5*Wd)*EmEav_Em_Vb2_c2_Vb2_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c2*EmEav_Em_Vb2_c2/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c2_Vb2_c1=((+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vb2_c1)/EmEav_Em-((0.5*Wd_Vb2_c2)*EmEav_Em_Vb2_c1+((0.5*Wd_Vb2_c1))*EmEav_Em_Vb2_c2+(0.5*Wd)*EmEav_Em_Vb2_c2_Vb2_c1)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c2*EmEav_Em_Vb2_c1/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c2_Vc1_c2=((+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c2+0.5*Wd_Vb2_c2_Vc1_c2)/EmEav_Em-((0.5*Wd_Vb2_c2)*EmEav_Em_Vc1_c2+((0.5*Wd_Vc1_c2))*EmEav_Em_Vb2_c2+(0.5*Wd)*EmEav_Em_Vb2_c2_Vc1_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c2*EmEav_Em_Vc1_c2/EmEav_Em/EmEav_Em/EmEav_Em);
#endif
lambda_Vb2_c1=(((0.5*Wd_Vb2_c1)*EmEav_Em-(0.5*Wd)*EmEav_Em_Vb2_c1)/EmEav_Em/EmEav_Em);
#if defined(_DERIVATE2)
  lambda_Vb2_c1_Vdt_GND=((+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vdt_GND)/EmEav_Em-((0.5*Wd_Vb2_c1)*EmEav_Em_Vdt_GND+((0.5*Wd_Vdt_GND))*EmEav_Em_Vb2_c1+(0.5*Wd)*EmEav_Em_Vb2_c1_Vdt_GND)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c1*EmEav_Em_Vdt_GND/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c1_Vb2_c2=((+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c2)/EmEav_Em-((0.5*Wd_Vb2_c1)*EmEav_Em_Vb2_c2+((0.5*Wd_Vb2_c2))*EmEav_Em_Vb2_c1+(0.5*Wd)*EmEav_Em_Vb2_c1_Vb2_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c1*EmEav_Em_Vb2_c2/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c1_Vb2_c1=((+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vb2_c1)/EmEav_Em-((0.5*Wd_Vb2_c1)*EmEav_Em_Vb2_c1+((0.5*Wd_Vb2_c1))*EmEav_Em_Vb2_c1+(0.5*Wd)*EmEav_Em_Vb2_c1_Vb2_c1)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c1*EmEav_Em_Vb2_c1/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vb2_c1_Vc1_c2=((+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vb2_c1+0.5*Wd_Vb2_c1_Vc1_c2)/EmEav_Em-((0.5*Wd_Vb2_c1)*EmEav_Em_Vc1_c2+((0.5*Wd_Vc1_c2))*EmEav_Em_Vb2_c1+(0.5*Wd)*EmEav_Em_Vb2_c1_Vc1_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vb2_c1*EmEav_Em_Vc1_c2/EmEav_Em/EmEav_Em/EmEav_Em);
#endif
lambda_Vc1_c2=(((0.5*Wd_Vc1_c2)*EmEav_Em-(0.5*Wd)*EmEav_Em_Vc1_c2)/EmEav_Em/EmEav_Em);
#if defined(_DERIVATE2)
  lambda_Vc1_c2_Vdt_GND=((+0.0*Wd+0.0*Wd_Vdt_GND+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vdt_GND)/EmEav_Em-((0.5*Wd_Vc1_c2)*EmEav_Em_Vdt_GND+((0.5*Wd_Vdt_GND))*EmEav_Em_Vc1_c2+(0.5*Wd)*EmEav_Em_Vc1_c2_Vdt_GND)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vc1_c2*EmEav_Em_Vdt_GND/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vc1_c2_Vb2_c2=((+0.0*Wd+0.0*Wd_Vb2_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c2)/EmEav_Em-((0.5*Wd_Vc1_c2)*EmEav_Em_Vb2_c2+((0.5*Wd_Vb2_c2))*EmEav_Em_Vc1_c2+(0.5*Wd)*EmEav_Em_Vc1_c2_Vb2_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vc1_c2*EmEav_Em_Vb2_c2/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vc1_c2_Vb2_c1=((+0.0*Wd+0.0*Wd_Vb2_c1+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vb2_c1)/EmEav_Em-((0.5*Wd_Vc1_c2)*EmEav_Em_Vb2_c1+((0.5*Wd_Vb2_c1))*EmEav_Em_Vc1_c2+(0.5*Wd)*EmEav_Em_Vc1_c2_Vb2_c1)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vc1_c2*EmEav_Em_Vb2_c1/EmEav_Em/EmEav_Em/EmEav_Em);
  lambda_Vc1_c2_Vc1_c2=((+0.0*Wd+0.0*Wd_Vc1_c2+0.0*Wd_Vc1_c2+0.5*Wd_Vc1_c2_Vc1_c2)/EmEav_Em-((0.5*Wd_Vc1_c2)*EmEav_Em_Vc1_c2+((0.5*Wd_Vc1_c2))*EmEav_Em_Vc1_c2+(0.5*Wd)*EmEav_Em_Vc1_c2_Vc1_c2)/EmEav_Em/EmEav_Em+2*(0.5*Wd)*EmEav_Em_Vc1_c2*EmEav_Em_Vc1_c2/EmEav_Em/EmEav_Em/EmEav_Em);
#endif
#endif
lambda=((0.5*Wd)/EmEav_Em);
EXIT_IF_ISNAN(((0.5*Wd)/EmEav_Em))
{
double m00_exp(d00_exp0,((-BnT)/Em))
double m00_exp(d00_exp1,(((-BnT)/Em)*(1.0+(Weff/lambda))))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Gem_Vdt_GND=(((((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND))*lambda)+(((An/BnT)*Em)*lambda_Vdt_GND))*(d00_exp0-d00_exp1))+((((An/BnT)*Em)*lambda)*((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0-(((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda)))*d10_exp1)));
#endif
Gem_Vb2_c1=((((((An/BnT)*Em_Vb2_c1)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1))*(d00_exp0-d00_exp1))+((((An/BnT)*Em)*lambda)*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))*d10_exp1)));
#if defined(_DERIVATE2)
  Gem_Vb2_c1_Vdt_GND=(+(+(+(0.0/BnT-(0.0*BnT_Vdt_GND+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*BnT_Vdt_GND/BnT/BnT/BnT)*Em+0.0*Em_Vdt_GND+(-An*BnT_Vdt_GND/BnT/BnT)*Em_Vb2_c1+(An/BnT)*Em_Vb2_c1_Vdt_GND)*lambda+((An/BnT)*Em_Vb2_c1)*lambda_Vdt_GND+((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda_Vb2_c1+((An/BnT)*Em)*lambda_Vb2_c1_Vdt_GND)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c1)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1))*((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0-((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*d10_exp1)+(((((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda)+(((An/BnT)*Em)*lambda_Vdt_GND)))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vdt_GND/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vdt_GND/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda)+(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c1_Vdt_GND/lambda-(Weff_Vb2_c1*lambda_Vdt_GND+Weff_Vdt_GND*lambda_Vb2_c1+Weff*lambda_Vb2_c1_Vdt_GND)/lambda/lambda+2*Weff*lambda_Vb2_c1*lambda_Vdt_GND/lambda/lambda/lambda))))));
  Gem_Vb2_c1_Vb2_c1=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c1+0.0*Em_Vb2_c1+(An/BnT)*Em_Vb2_c1_Vb2_c1)*lambda+((An/BnT)*Em_Vb2_c1)*lambda_Vb2_c1+(((An/BnT)*Em_Vb2_c1))*lambda_Vb2_c1+((An/BnT)*Em)*lambda_Vb2_c1_Vb2_c1)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c1)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c1))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1)))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c1/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c1/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c1_Vb2_c1/lambda-(Weff_Vb2_c1*lambda_Vb2_c1+Weff_Vb2_c1*lambda_Vb2_c1+Weff*lambda_Vb2_c1_Vb2_c1)/lambda/lambda+2*Weff*lambda_Vb2_c1*lambda_Vb2_c1/lambda/lambda/lambda))))));
  Gem_Vb2_c1_Vb2_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c2+0.0*Em_Vb2_c1+(An/BnT)*Em_Vb2_c1_Vb2_c2)*lambda+((An/BnT)*Em_Vb2_c1)*lambda_Vb2_c2+(((An/BnT)*Em_Vb2_c2))*lambda_Vb2_c1+((An/BnT)*Em)*lambda_Vb2_c1_Vb2_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c1)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c2))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2)))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c1_Vb2_c2/lambda-(Weff_Vb2_c1*lambda_Vb2_c2+Weff_Vb2_c2*lambda_Vb2_c1+Weff*lambda_Vb2_c1_Vb2_c2)/lambda/lambda+2*Weff*lambda_Vb2_c1*lambda_Vb2_c2/lambda/lambda/lambda))))));
  Gem_Vb2_c1_Vc1_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vc1_c2+0.0*Em_Vb2_c1+(An/BnT)*Em_Vb2_c1_Vc1_c2)*lambda+((An/BnT)*Em_Vb2_c1)*lambda_Vc1_c2+(((An/BnT)*Em_Vc1_c2))*lambda_Vb2_c1+((An/BnT)*Em)*lambda_Vb2_c1_Vc1_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c1)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vc1_c2))*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2)))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vc1_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vc1_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c1_Vc1_c2/lambda-(Weff_Vb2_c1*lambda_Vc1_c2+Weff_Vc1_c2*lambda_Vb2_c1+Weff*lambda_Vb2_c1_Vc1_c2)/lambda/lambda+2*Weff*lambda_Vb2_c1*lambda_Vc1_c2/lambda/lambda/lambda))))));
#endif
Gem_Vb2_c2=((((((An/BnT)*Em_Vb2_c2)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2))*(d00_exp0-d00_exp1))+((((An/BnT)*Em)*lambda)*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))*d10_exp1)));
#if defined(_DERIVATE2)
  Gem_Vb2_c2_Vdt_GND=(+(+(+(0.0/BnT-(0.0*BnT_Vdt_GND+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*BnT_Vdt_GND/BnT/BnT/BnT)*Em+0.0*Em_Vdt_GND+(-An*BnT_Vdt_GND/BnT/BnT)*Em_Vb2_c2+(An/BnT)*Em_Vb2_c2_Vdt_GND)*lambda+((An/BnT)*Em_Vb2_c2)*lambda_Vdt_GND+((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda_Vb2_c2+((An/BnT)*Em)*lambda_Vb2_c2_Vdt_GND)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c2)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2))*((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0-((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*d10_exp1)+(((((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda)+(((An/BnT)*Em)*lambda_Vdt_GND)))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vdt_GND/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vdt_GND/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda)+(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c2_Vdt_GND/lambda-(Weff_Vb2_c2*lambda_Vdt_GND+Weff_Vdt_GND*lambda_Vb2_c2+Weff*lambda_Vb2_c2_Vdt_GND)/lambda/lambda+2*Weff*lambda_Vb2_c2*lambda_Vdt_GND/lambda/lambda/lambda))))));
  Gem_Vb2_c2_Vb2_c1=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c1+0.0*Em_Vb2_c2+(An/BnT)*Em_Vb2_c2_Vb2_c1)*lambda+((An/BnT)*Em_Vb2_c2)*lambda_Vb2_c1+(((An/BnT)*Em_Vb2_c1))*lambda_Vb2_c2+((An/BnT)*Em)*lambda_Vb2_c2_Vb2_c1)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c2)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c1))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1)))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c1/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c1/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c2_Vb2_c1/lambda-(Weff_Vb2_c2*lambda_Vb2_c1+Weff_Vb2_c1*lambda_Vb2_c2+Weff*lambda_Vb2_c2_Vb2_c1)/lambda/lambda+2*Weff*lambda_Vb2_c2*lambda_Vb2_c1/lambda/lambda/lambda))))));
  Gem_Vb2_c2_Vb2_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c2+0.0*Em_Vb2_c2+(An/BnT)*Em_Vb2_c2_Vb2_c2)*lambda+((An/BnT)*Em_Vb2_c2)*lambda_Vb2_c2+(((An/BnT)*Em_Vb2_c2))*lambda_Vb2_c2+((An/BnT)*Em)*lambda_Vb2_c2_Vb2_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c2)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c2))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2)))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c2_Vb2_c2/lambda-(Weff_Vb2_c2*lambda_Vb2_c2+Weff_Vb2_c2*lambda_Vb2_c2+Weff*lambda_Vb2_c2_Vb2_c2)/lambda/lambda+2*Weff*lambda_Vb2_c2*lambda_Vb2_c2/lambda/lambda/lambda))))));
  Gem_Vb2_c2_Vc1_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vc1_c2+0.0*Em_Vb2_c2+(An/BnT)*Em_Vb2_c2_Vc1_c2)*lambda+((An/BnT)*Em_Vb2_c2)*lambda_Vc1_c2+(((An/BnT)*Em_Vc1_c2))*lambda_Vb2_c2+((An/BnT)*Em)*lambda_Vb2_c2_Vc1_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vb2_c2)*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vc1_c2))*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2)))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vc1_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vc1_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vb2_c2_Vc1_c2/lambda-(Weff_Vb2_c2*lambda_Vc1_c2+Weff_Vc1_c2*lambda_Vb2_c2+Weff*lambda_Vb2_c2_Vc1_c2)/lambda/lambda+2*Weff*lambda_Vb2_c2*lambda_Vc1_c2/lambda/lambda/lambda))))));
#endif
Gem_Vc1_c2=((((((An/BnT)*Em_Vc1_c2)*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2))*(d00_exp0-d00_exp1))+((((An/BnT)*Em)*lambda)*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))*d10_exp1)));
#if defined(_DERIVATE2)
  Gem_Vc1_c2_Vdt_GND=(+(+(+(0.0/BnT-(0.0*BnT_Vdt_GND+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*BnT_Vdt_GND/BnT/BnT/BnT)*Em+0.0*Em_Vdt_GND+(-An*BnT_Vdt_GND/BnT/BnT)*Em_Vc1_c2+(An/BnT)*Em_Vc1_c2_Vdt_GND)*lambda+((An/BnT)*Em_Vc1_c2)*lambda_Vdt_GND+((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda_Vc1_c2+((An/BnT)*Em)*lambda_Vc1_c2_Vdt_GND)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vc1_c2)*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2))*((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0-((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*d10_exp1)+(((((((-An*BnT_Vdt_GND/BnT/BnT)*Em)+((An/BnT)*Em_Vdt_GND)))*lambda)+(((An/BnT)*Em)*lambda_Vdt_GND)))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vdt_GND/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda))))*(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vdt_GND/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vdt_GND*lambda-Weff*lambda_Vdt_GND)/lambda/lambda)+(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vc1_c2_Vdt_GND/lambda-(Weff_Vc1_c2*lambda_Vdt_GND+Weff_Vdt_GND*lambda_Vc1_c2+Weff*lambda_Vc1_c2_Vdt_GND)/lambda/lambda+2*Weff*lambda_Vc1_c2*lambda_Vdt_GND/lambda/lambda/lambda))))));
  Gem_Vc1_c2_Vb2_c1=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c1+0.0*Em_Vc1_c2+(An/BnT)*Em_Vc1_c2_Vb2_c1)*lambda+((An/BnT)*Em_Vc1_c2)*lambda_Vb2_c1+(((An/BnT)*Em_Vb2_c1))*lambda_Vc1_c2+((An/BnT)*Em)*lambda_Vc1_c2_Vb2_c1)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vc1_c2)*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2))*((-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c1))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c1)))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c1/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c1/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda))))*(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c1/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vb2_c1*lambda-Weff*lambda_Vb2_c1)/lambda/lambda)+(-(-BnT)*Em_Vb2_c1/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vc1_c2_Vb2_c1/lambda-(Weff_Vc1_c2*lambda_Vb2_c1+Weff_Vb2_c1*lambda_Vc1_c2+Weff*lambda_Vc1_c2_Vb2_c1)/lambda/lambda+2*Weff*lambda_Vc1_c2*lambda_Vb2_c1/lambda/lambda/lambda))))));
  Gem_Vc1_c2_Vb2_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vb2_c2+0.0*Em_Vc1_c2+(An/BnT)*Em_Vc1_c2_Vb2_c2)*lambda+((An/BnT)*Em_Vc1_c2)*lambda_Vb2_c2+(((An/BnT)*Em_Vb2_c2))*lambda_Vc1_c2+((An/BnT)*Em)*lambda_Vc1_c2_Vb2_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vc1_c2)*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2))*((-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vb2_c2))*lambda)+(((An/BnT)*Em)*lambda_Vb2_c2)))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vb2_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vb2_c2*lambda-Weff*lambda_Vb2_c2)/lambda/lambda)+(-(-BnT)*Em_Vb2_c2/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vc1_c2_Vb2_c2/lambda-(Weff_Vc1_c2*lambda_Vb2_c2+Weff_Vb2_c2*lambda_Vc1_c2+Weff*lambda_Vc1_c2_Vb2_c2)/lambda/lambda+2*Weff*lambda_Vc1_c2*lambda_Vb2_c2/lambda/lambda/lambda))))));
  Gem_Vc1_c2_Vc1_c2=(+(+(+(0.0/BnT-(0.0*0.0+0.0*0.0+An*0.0)/BnT/BnT+2*An*0.0*0.0/BnT/BnT/BnT)*Em+0.0*Em_Vc1_c2+0.0*Em_Vc1_c2+(An/BnT)*Em_Vc1_c2_Vc1_c2)*lambda+((An/BnT)*Em_Vc1_c2)*lambda_Vc1_c2+(((An/BnT)*Em_Vc1_c2))*lambda_Vc1_c2+((An/BnT)*Em)*lambda_Vc1_c2_Vc1_c2)*(d00_exp0-d00_exp1)+((((An/BnT)*Em_Vc1_c2)*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*d10_exp1)+((((((An/BnT)*Em_Vc1_c2))*lambda)+(((An/BnT)*Em)*lambda_Vc1_c2)))*((-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0-(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))*d10_exp1)+(((An/BnT)*Em)*lambda)*(+(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vc1_c2/Em/Em/Em))-(m20_exp((((-BnT)/Em)*(1.0+(Weff/lambda))))*((((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda))))*(((-(-BnT)*Em_Vc1_c2/Em/Em)*(1.0+(Weff/lambda)))+(((-BnT)/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)))+d10_exp1*(+(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vc1_c2/Em/Em/Em)*(1.0+(Weff/lambda))+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+(-(-BnT)*Em_Vc1_c2/Em/Em)*((Weff_Vc1_c2*lambda-Weff*lambda_Vc1_c2)/lambda/lambda)+((-BnT)/Em)*(+0.0+(Weff_Vc1_c2_Vc1_c2/lambda-(Weff_Vc1_c2*lambda_Vc1_c2+Weff_Vc1_c2*lambda_Vc1_c2+Weff*lambda_Vc1_c2_Vc1_c2)/lambda/lambda+2*Weff*lambda_Vc1_c2*lambda_Vc1_c2/lambda/lambda/lambda))))));
#endif
#endif
Gem=((((An/BnT)*Em)*lambda)*(d00_exp0-d00_exp1));
EXIT_IF_ISNAN(((((An/BnT)*Em)*lambda)*(d00_exp0-d00_exp1)))
}
}
else
{
{
double m00_exp(d00_exp0,((-BnT)/Em))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c1)V(b2,c2)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Gem_Vdt_GND=(((An*Weff_Vdt_GND)*d00_exp0)+((An*Weff)*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0));
#endif
Gem_Vb2_c1=(((An*Weff_Vb2_c1)*d00_exp0)+((An*Weff)*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0));
#if defined(_DERIVATE2)
  Gem_Vb2_c1_Vdt_GND=(+(+0.0*Weff+0.0*Weff_Vdt_GND+0.0*Weff_Vb2_c1+An*Weff_Vb2_c1_Vdt_GND)*d00_exp0+(An*Weff_Vb2_c1)*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0+((An*Weff_Vdt_GND))*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vdt_GND/Em/Em/Em)));
  Gem_Vb2_c1_Vb2_c1=(+(+0.0*Weff+0.0*Weff_Vb2_c1+0.0*Weff_Vb2_c1+An*Weff_Vb2_c1_Vb2_c1)*d00_exp0+(An*Weff_Vb2_c1)*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+((An*Weff_Vb2_c1))*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c1/Em/Em/Em)));
  Gem_Vb2_c1_Vb2_c2=(+(+0.0*Weff+0.0*Weff_Vb2_c2+0.0*Weff_Vb2_c1+An*Weff_Vb2_c1_Vb2_c2)*d00_exp0+(An*Weff_Vb2_c1)*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+((An*Weff_Vb2_c2))*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vb2_c2/Em/Em/Em)));
  Gem_Vb2_c1_Vc1_c2=(+(+0.0*Weff+0.0*Weff_Vc1_c2+0.0*Weff_Vb2_c1+An*Weff_Vb2_c1_Vc1_c2)*d00_exp0+(An*Weff_Vb2_c1)*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+((An*Weff_Vc1_c2))*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vb2_c1/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c1+(-BnT)*Em_Vb2_c1_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c1*Em_Vc1_c2/Em/Em/Em)));
#endif
Gem_Vb2_c2=(((An*Weff_Vb2_c2)*d00_exp0)+((An*Weff)*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0));
#if defined(_DERIVATE2)
  Gem_Vb2_c2_Vdt_GND=(+(+0.0*Weff+0.0*Weff_Vdt_GND+0.0*Weff_Vb2_c2+An*Weff_Vb2_c2_Vdt_GND)*d00_exp0+(An*Weff_Vb2_c2)*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0+((An*Weff_Vdt_GND))*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vdt_GND/Em/Em/Em)));
  Gem_Vb2_c2_Vb2_c1=(+(+0.0*Weff+0.0*Weff_Vb2_c1+0.0*Weff_Vb2_c2+An*Weff_Vb2_c2_Vb2_c1)*d00_exp0+(An*Weff_Vb2_c2)*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+((An*Weff_Vb2_c1))*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c1/Em/Em/Em)));
  Gem_Vb2_c2_Vb2_c2=(+(+0.0*Weff+0.0*Weff_Vb2_c2+0.0*Weff_Vb2_c2+An*Weff_Vb2_c2_Vb2_c2)*d00_exp0+(An*Weff_Vb2_c2)*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+((An*Weff_Vb2_c2))*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vb2_c2/Em/Em/Em)));
  Gem_Vb2_c2_Vc1_c2=(+(+0.0*Weff+0.0*Weff_Vc1_c2+0.0*Weff_Vb2_c2+An*Weff_Vb2_c2_Vc1_c2)*d00_exp0+(An*Weff_Vb2_c2)*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+((An*Weff_Vc1_c2))*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vb2_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vb2_c2+(-BnT)*Em_Vb2_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vb2_c2*Em_Vc1_c2/Em/Em/Em)));
#endif
Gem_Vc1_c2=(((An*Weff_Vc1_c2)*d00_exp0)+((An*Weff)*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0));
#if defined(_DERIVATE2)
  Gem_Vc1_c2_Vdt_GND=(+(+0.0*Weff+0.0*Weff_Vdt_GND+0.0*Weff_Vc1_c2+An*Weff_Vc1_c2_Vdt_GND)*d00_exp0+(An*Weff_Vc1_c2)*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*d10_exp0+((An*Weff_Vdt_GND))*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(((-BnT_Vdt_GND)*Em-(-BnT)*Em_Vdt_GND)/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vdt_GND+(-BnT_Vdt_GND)*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vdt_GND)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vdt_GND/Em/Em/Em)));
  Gem_Vc1_c2_Vb2_c1=(+(+0.0*Weff+0.0*Weff_Vb2_c1+0.0*Weff_Vc1_c2+An*Weff_Vc1_c2_Vb2_c1)*d00_exp0+(An*Weff_Vc1_c2)*(-(-BnT)*Em_Vb2_c1/Em/Em)*d10_exp0+((An*Weff_Vb2_c1))*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c1/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c1+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c1)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c1/Em/Em/Em)));
  Gem_Vc1_c2_Vb2_c2=(+(+0.0*Weff+0.0*Weff_Vb2_c2+0.0*Weff_Vc1_c2+An*Weff_Vc1_c2_Vb2_c2)*d00_exp0+(An*Weff_Vc1_c2)*(-(-BnT)*Em_Vb2_c2/Em/Em)*d10_exp0+((An*Weff_Vb2_c2))*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vb2_c2/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vb2_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vb2_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vb2_c2/Em/Em/Em)));
  Gem_Vc1_c2_Vc1_c2=(+(+0.0*Weff+0.0*Weff_Vc1_c2+0.0*Weff_Vc1_c2+An*Weff_Vc1_c2_Vc1_c2)*d00_exp0+(An*Weff_Vc1_c2)*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+((An*Weff_Vc1_c2))*(-(-BnT)*Em_Vc1_c2/Em/Em)*d10_exp0+(An*Weff)*(m20_exp(((-BnT)/Em))*(-(-BnT)*Em_Vc1_c2/Em/Em)*(-(-BnT)*Em_Vc1_c2/Em/Em)+d10_exp0*(0.0/Em-(0.0*Em_Vc1_c2+0.0*Em_Vc1_c2+(-BnT)*Em_Vc1_c2_Vc1_c2)/Em/Em+2*(-BnT)*Em_Vc1_c2*Em_Vc1_c2/Em/Em/Em)));
#endif
#endif
Gem=((An*Weff)*d00_exp0);
EXIT_IF_ISNAN(((An*Weff)*d00_exp0))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Gmax_Vdt_GND=((((Vt_Vdt_GND*(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-Vt*((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+((qBI_Vdt_GND*BF_T-pInst->qBI*BF_T_Vdt_GND)/BF_T/BF_T))+((RE_TM_Vdt_GND*(pInst->RBC_TM+pInst->Rb2)-pInst->RE_TM*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vb2_c2=(((-Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2/BF_T))+(-pInst->RE_TM*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vb2_c2_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+Ic1c2_Vb2_c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2_Vdt_GND/BF_T-(qBI_Vb2_c2*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+Ic1c2_Vb2_c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2_Vb2_c2/BF_T-(qBI_Vb2_c2*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+Ic1c2_Vb2_c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2_Vb2_c1/BF_T-(qBI_Vb2_c2*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+Ic1c2_Vb2_c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2_Vc1_c2/BF_T-(qBI_Vb2_c2*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb_c+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb_b1+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb1_b2+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vc4_c1+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vc3_c1+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vc3_c4+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c2_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c2*Rb2_Vb2_e1+0.0*Rb2_Vb2_c2+Ic1c2*(+0.0+Rb2_Vb2_c2_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2))*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c2_Vb2_e1/BF_T-(qBI_Vb2_c2*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vb2_c2+pInst->RE_TM*(+0.0+Rb2_Vb2_c2_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c2*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vb2_c1=(((-Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1/BF_T))+(-pInst->RE_TM*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vb2_c1_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+Ic1c2_Vb2_c1_Vdt_GND*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1_Vdt_GND/BF_T-(qBI_Vb2_c1*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+Ic1c2_Vb2_c1_Vb2_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1_Vb2_c2/BF_T-(qBI_Vb2_c1*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+Ic1c2_Vb2_c1_Vb2_c1*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1_Vb2_c1/BF_T-(qBI_Vb2_c1*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+Ic1c2_Vb2_c1_Vc1_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1_Vc1_c2/BF_T-(qBI_Vb2_c1*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb_c+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb_b1+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb1_b2+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vc4_c1+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vc3_c1+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vc3_c4+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_c1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_c1_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vb2_c1*Rb2_Vb2_e1+0.0*Rb2_Vb2_c1+Ic1c2*(+0.0+Rb2_Vb2_c1_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1))*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_c1_Vb2_e1/BF_T-(qBI_Vb2_c1*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vb2_c1+pInst->RE_TM*(+0.0+Rb2_Vb2_c1_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_c1*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vc1_c2=(((-Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2/BF_T))+(-pInst->RE_TM*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vc1_c2_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+Ic1c2_Vc1_c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2_Vdt_GND/BF_T-(qBI_Vc1_c2*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+Ic1c2_Vc1_c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2_Vb2_c2/BF_T-(qBI_Vc1_c2*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+Ic1c2_Vc1_c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2_Vb2_c1/BF_T-(qBI_Vc1_c2*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+Ic1c2_Vc1_c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2_Vc1_c2/BF_T-(qBI_Vc1_c2*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb_c+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb_b1+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb1_b2+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vc4_c1+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vc3_c1+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vc3_c4+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vc1_c2*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc1_c2_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+Ic1c2_Vc1_c2*Rb2_Vb2_e1+0.0*Rb2_Vc1_c2+Ic1c2*(+0.0+Rb2_Vc1_c2_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2))*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vc1_c2_Vb2_e1/BF_T-(qBI_Vc1_c2*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vc1_c2+pInst->RE_TM*(+0.0+Rb2_Vc1_c2_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc1_c2*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
#if defined(_DERIVATE)
Gmax_Vb_c=((-Vt*(Ic1c2*Rb2_Vb_c)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
#if defined(_DERIVATE)
Gmax_Vb_b1=((-Vt*(Ic1c2*Rb2_Vb_b1)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
#if defined(_DERIVATE)
Gmax_Vb1_b2=((-Vt*(Ic1c2*Rb2_Vb1_b2)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vc4_c1=((-Vt*(Ic1c2*Rb2_Vc4_c1)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vc4_c1_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_c+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_b1+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb1_b2+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc4_c1+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c1+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c4+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc4_c1_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*(Ic1c2*Rb2_Vc4_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_e1+0.0*Rb2_Vc4_c1+Ic1c2*(+0.0+Rb2_Vc4_c1_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc4_c1)*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vc4_c1+pInst->RE_TM*(+0.0+Rb2_Vc4_c1_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc4_c1*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vc3_c1=((-Vt*(Ic1c2*Rb2_Vc3_c1)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vc3_c1_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_c+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_b1+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb1_b2+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc4_c1+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c1+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c4+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vc3_c1_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*(Ic1c2*Rb2_Vc3_c1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_e1+0.0*Rb2_Vc3_c1+Ic1c2*(+0.0+Rb2_Vc3_c1_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vc3_c1)*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(0.0*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vc3_c1+pInst->RE_TM*(+0.0+Rb2_Vc3_c1_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vc3_c1*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
#if defined(_DERIVATE)
Gmax_Vc3_c4=((-Vt*(Ic1c2*Rb2_Vc3_c4)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(-pInst->RE_TM*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
Gmax_Vb2_e1=(((-Vt*(Ic1c2*Rb2_Vb2_e1)/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1/BF_T))+(-pInst->RE_TM*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#if defined(_DERIVATE2)
  Gmax_Vb2_e1_Vdt_GND=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))+Vt_Vdt_GND*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+Ic1c2_Vdt_GND*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vdt_GND)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*(((Ic1c2_Vdt_GND*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*(RBC_TM_Vdt_GND+Rb2_Vdt_GND))))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1_Vdt_GND/BF_T-(qBI_Vb2_e1*BF_T_Vdt_GND+qBI_Vdt_GND*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*BF_T_Vdt_GND/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)+RE_TM_Vdt_GND*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vdt_GND))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*(RBC_TM_Vdt_GND+Rb2_Vdt_GND)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb2_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c2+Ic1c2_Vb2_c2*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*(((Ic1c2_Vb2_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1_Vb2_c2/BF_T-(qBI_Vb2_e1*0.0+qBI_Vb2_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c2+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb2_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb2_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb2_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_c1+Ic1c2_Vb2_c1*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*(((Ic1c2_Vb2_c1*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vb2_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1_Vb2_c1/BF_T-(qBI_Vb2_e1*0.0+qBI_Vb2_c1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_c1+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb2_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb2_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vc1_c2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc1_c2+Ic1c2_Vc1_c2*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*(((Ic1c2_Vc1_c2*(pInst->RBC_TM+pInst->Rb2))+(Ic1c2*Rb2_Vc1_c2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1_Vc1_c2/BF_T-(qBI_Vb2_e1*0.0+qBI_Vc1_c2*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc1_c2+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vc1_c2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vc1_c2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb_c=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_c))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_c+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb_c)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vb_c))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_c+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb_c))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb_c/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb_b1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb_b1))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb_b1+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb_b1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vb_b1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb_b1+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb_b1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb_b1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb1_b2=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb1_b2))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb1_b2+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb1_b2)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vb1_b2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb1_b2+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb1_b2))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb1_b2/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vc4_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc4_c1))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc4_c1+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vc4_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vc4_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc4_c1+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vc4_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vc4_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vc3_c1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c1))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c1+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vc3_c1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vc3_c1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c1+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vc3_c1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vc3_c1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vc3_c4=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vc3_c4))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vc3_c4+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vc3_c4)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vc3_c4))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(0.0/BF_T-(qBI_Vb2_e1*0.0+0.0*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vc3_c4+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vc3_c4))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vc3_c4/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
  Gmax_Vb2_e1_Vb2_e1=(+(+(0.0/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))-(0.0*((Ic1c2*Rb2_Vb2_e1))+0.0*(Ic1c2*Rb2_Vb2_e1)+Vt*(+0.0*(pInst->RBC_TM+pInst->Rb2)+0.0*Rb2_Vb2_e1+0.0*Rb2_Vb2_e1+Ic1c2*(+0.0+Rb2_Vb2_e1_Vb2_e1)))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))+2*Vt*(Ic1c2*Rb2_Vb2_e1)*((Ic1c2*Rb2_Vb2_e1))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2))/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(qBI_Vb2_e1_Vb2_e1/BF_T-(qBI_Vb2_e1*0.0+qBI_Vb2_e1*0.0+pInst->qBI*0.0)/BF_T/BF_T+2*pInst->qBI*0.0*0.0/BF_T/BF_T/BF_T))+(0.0/(pInst->RBC_TM+pInst->Rb2)-(0.0*Rb2_Vb2_e1+0.0*Rb2_Vb2_e1+pInst->RE_TM*(+0.0+Rb2_Vb2_e1_Vb2_e1))/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)+2*pInst->RE_TM*Rb2_Vb2_e1*Rb2_Vb2_e1/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)/(pInst->RBC_TM+pInst->Rb2)));
#endif
#endif
Gmax=(((Vt/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(pInst->qBI/BF_T))+(pInst->RE_TM/(pInst->RBC_TM+pInst->Rb2)));
EXIT_IF_ISNAN((((Vt/(Ic1c2*(pInst->RBC_TM+pInst->Rb2)))+(pInst->qBI/BF_T))+(pInst->RE_TM/(pInst->RBC_TM+pInst->Rb2))))
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Iavl_Vdt_GND=((((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND))*((Gem+(Gem/Gmax))+1.0)-(Ic1c2*Gem)*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vb2_c2=((((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*((Gem+(Gem/Gmax))+1.0)-(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vb2_c2_Vdt_GND=((+Ic1c2_Vb2_c2_Vdt_GND*Gem+Ic1c2_Vb2_c2*Gem_Vdt_GND+Ic1c2_Vdt_GND*Gem_Vb2_c2+Ic1c2*Gem_Vb2_c2_Vdt_GND)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c2_Vdt_GND+(Gem_Vb2_c2_Vdt_GND/Gmax-(Gem_Vb2_c2*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb2_c2=((+Ic1c2_Vb2_c2_Vb2_c2*Gem+Ic1c2_Vb2_c2*Gem_Vb2_c2+Ic1c2_Vb2_c2*Gem_Vb2_c2+Ic1c2*Gem_Vb2_c2_Vb2_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c2_Vb2_c2+(Gem_Vb2_c2_Vb2_c2/Gmax-(Gem_Vb2_c2*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb2_c1=((+Ic1c2_Vb2_c2_Vb2_c1*Gem+Ic1c2_Vb2_c2*Gem_Vb2_c1+Ic1c2_Vb2_c1*Gem_Vb2_c2+Ic1c2*Gem_Vb2_c2_Vb2_c1)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c2_Vb2_c1+(Gem_Vb2_c2_Vb2_c1/Gmax-(Gem_Vb2_c2*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vc1_c2=((+Ic1c2_Vb2_c2_Vc1_c2*Gem+Ic1c2_Vb2_c2*Gem_Vc1_c2+Ic1c2_Vc1_c2*Gem_Vb2_c2+Ic1c2*Gem_Vb2_c2_Vc1_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c2_Vc1_c2+(Gem_Vb2_c2_Vc1_c2/Gmax-(Gem_Vb2_c2*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb_c=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vb_c+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb_b1=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vb_b1+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb1_b2=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vb1_b2+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vc4_c1=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vc4_c1+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vc3_c1=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vc3_c1+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vc3_c4=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vc3_c4+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c2_Vb2_e1=((+0.0*Gem+Ic1c2_Vb2_c2*0.0+0.0*Gem_Vb2_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c2*Gmax_Vb2_e1+0.0*Gmax_Vb2_c2+Gem*Gmax_Vb2_c2_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c2*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vb2_c1=((((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*((Gem+(Gem/Gmax))+1.0)-(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vb2_c1_Vdt_GND=((+Ic1c2_Vb2_c1_Vdt_GND*Gem+Ic1c2_Vb2_c1*Gem_Vdt_GND+Ic1c2_Vdt_GND*Gem_Vb2_c1+Ic1c2*Gem_Vb2_c1_Vdt_GND)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c1_Vdt_GND+(Gem_Vb2_c1_Vdt_GND/Gmax-(Gem_Vb2_c1*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb2_c2=((+Ic1c2_Vb2_c1_Vb2_c2*Gem+Ic1c2_Vb2_c1*Gem_Vb2_c2+Ic1c2_Vb2_c2*Gem_Vb2_c1+Ic1c2*Gem_Vb2_c1_Vb2_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c1_Vb2_c2+(Gem_Vb2_c1_Vb2_c2/Gmax-(Gem_Vb2_c1*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb2_c1=((+Ic1c2_Vb2_c1_Vb2_c1*Gem+Ic1c2_Vb2_c1*Gem_Vb2_c1+Ic1c2_Vb2_c1*Gem_Vb2_c1+Ic1c2*Gem_Vb2_c1_Vb2_c1)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c1_Vb2_c1+(Gem_Vb2_c1_Vb2_c1/Gmax-(Gem_Vb2_c1*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vc1_c2=((+Ic1c2_Vb2_c1_Vc1_c2*Gem+Ic1c2_Vb2_c1*Gem_Vc1_c2+Ic1c2_Vc1_c2*Gem_Vb2_c1+Ic1c2*Gem_Vb2_c1_Vc1_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vb2_c1_Vc1_c2+(Gem_Vb2_c1_Vc1_c2/Gmax-(Gem_Vb2_c1*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb_c=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vb_c+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb_b1=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vb_b1+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb1_b2=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vb1_b2+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vc4_c1=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vc4_c1+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vc3_c1=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vc3_c1+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vc3_c4=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vc3_c4+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_c1_Vb2_e1=((+0.0*Gem+Ic1c2_Vb2_c1*0.0+0.0*Gem_Vb2_c1+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vb2_c1*Gmax_Vb2_e1+0.0*Gmax_Vb2_c1+Gem*Gmax_Vb2_c1_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vb2_c1*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vc1_c2=((((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*((Gem+(Gem/Gmax))+1.0)-(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax)))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vc1_c2_Vdt_GND=((+Ic1c2_Vc1_c2_Vdt_GND*Gem+Ic1c2_Vc1_c2*Gem_Vdt_GND+Ic1c2_Vdt_GND*Gem_Vc1_c2+Ic1c2*Gem_Vc1_c2_Vdt_GND)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vc1_c2_Vdt_GND+(Gem_Vc1_c2_Vdt_GND/Gmax-(Gem_Vc1_c2*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb2_c2=((+Ic1c2_Vc1_c2_Vb2_c2*Gem+Ic1c2_Vc1_c2*Gem_Vb2_c2+Ic1c2_Vb2_c2*Gem_Vc1_c2+Ic1c2*Gem_Vc1_c2_Vb2_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vc1_c2_Vb2_c2+(Gem_Vc1_c2_Vb2_c2/Gmax-(Gem_Vc1_c2*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb2_c1=((+Ic1c2_Vc1_c2_Vb2_c1*Gem+Ic1c2_Vc1_c2*Gem_Vb2_c1+Ic1c2_Vb2_c1*Gem_Vc1_c2+Ic1c2*Gem_Vc1_c2_Vb2_c1)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vc1_c2_Vb2_c1+(Gem_Vc1_c2_Vb2_c1/Gmax-(Gem_Vc1_c2*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vc1_c2=((+Ic1c2_Vc1_c2_Vc1_c2*Gem+Ic1c2_Vc1_c2*Gem_Vc1_c2+Ic1c2_Vc1_c2*Gem_Vc1_c2+Ic1c2*Gem_Vc1_c2_Vc1_c2)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+Gem_Vc1_c2_Vc1_c2+(Gem_Vc1_c2_Vc1_c2/Gmax-(Gem_Vc1_c2*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb_c=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vb_c+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb_b1=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vb_b1+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb1_b2=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vb1_b2+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vc4_c1=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vc4_c1+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vc3_c1=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vc3_c1+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vc3_c4=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vc3_c4+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc1_c2_Vb2_e1=((+0.0*Gem+Ic1c2_Vc1_c2*0.0+0.0*Gem_Vc1_c2+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(Gem_Vc1_c2*Gmax_Vb2_e1+0.0*Gmax_Vc1_c2+Gem*Gmax_Vc1_c2_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vc1_c2*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
#if defined(_DERIVATE)
Iavl_Vb_c=(-(Ic1c2*Gem)*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
#if defined(_DERIVATE)
Iavl_Vb_b1=(-(Ic1c2*Gem)*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
#if defined(_DERIVATE)
Iavl_Vb1_b2=(-(Ic1c2*Gem)*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vc4_c1=(-(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vc4_c1_Vdt_GND=((+0.0*Gem+0.0*Gem_Vdt_GND+Ic1c2_Vdt_GND*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb2_c2=((+0.0*Gem+0.0*Gem_Vb2_c2+Ic1c2_Vb2_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb2_c1=((+0.0*Gem+0.0*Gem_Vb2_c1+Ic1c2_Vb2_c1*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vc1_c2=((+0.0*Gem+0.0*Gem_Vc1_c2+Ic1c2_Vc1_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb_c=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_c+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb_b1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_b1+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb1_b2=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb1_b2+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vc4_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc4_c1+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vc3_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c1+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vc3_c4=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c4+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc4_c1_Vb2_e1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_e1+0.0*Gmax_Vc4_c1+Gem*Gmax_Vc4_c1_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vc4_c1*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vc3_c1=(-(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vc3_c1_Vdt_GND=((+0.0*Gem+0.0*Gem_Vdt_GND+Ic1c2_Vdt_GND*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb2_c2=((+0.0*Gem+0.0*Gem_Vb2_c2+Ic1c2_Vb2_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb2_c1=((+0.0*Gem+0.0*Gem_Vb2_c1+Ic1c2_Vb2_c1*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vc1_c2=((+0.0*Gem+0.0*Gem_Vc1_c2+Ic1c2_Vc1_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb_c=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_c+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb_b1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_b1+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb1_b2=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb1_b2+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vc4_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc4_c1+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vc3_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c1+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vc3_c4=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c4+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vc3_c1_Vb2_e1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_e1+0.0*Gmax_Vc3_c1+Gem*Gmax_Vc3_c1_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vc3_c1*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
#if defined(_DERIVATE)
Iavl_Vc3_c4=(-(Ic1c2*Gem)*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
Iavl_Vb2_e1=(-(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#if defined(_DERIVATE2)
  Iavl_Vb2_e1_Vdt_GND=((+0.0*Gem+0.0*Gem_Vdt_GND+Ic1c2_Vdt_GND*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))+(((Ic1c2_Vdt_GND*Gem)+(Ic1c2*Gem_Vdt_GND)))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vdt_GND+Gem_Vdt_GND*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vdt_GND)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vdt_GND/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(Gem_Vdt_GND+((Gem_Vdt_GND*Gmax-Gem*Gmax_Vdt_GND)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb2_c2=((+0.0*Gem+0.0*Gem_Vb2_c2+Ic1c2_Vb2_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))+(((Ic1c2_Vb2_c2*Gem)+(Ic1c2*Gem_Vb2_c2)))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c2+Gem_Vb2_c2*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb2_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb2_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(Gem_Vb2_c2+((Gem_Vb2_c2*Gmax-Gem*Gmax_Vb2_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb2_c1=((+0.0*Gem+0.0*Gem_Vb2_c1+Ic1c2_Vb2_c1*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))+(((Ic1c2_Vb2_c1*Gem)+(Ic1c2*Gem_Vb2_c1)))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_c1+Gem_Vb2_c1*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb2_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb2_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(Gem_Vb2_c1+((Gem_Vb2_c1*Gmax-Gem*Gmax_Vb2_c1)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vc1_c2=((+0.0*Gem+0.0*Gem_Vc1_c2+Ic1c2_Vc1_c2*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))+(((Ic1c2_Vc1_c2*Gem)+(Ic1c2*Gem_Vc1_c2)))*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc1_c2+Gem_Vc1_c2*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vc1_c2)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vc1_c2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(Gem_Vc1_c2+((Gem_Vc1_c2*Gmax-Gem*Gmax_Vc1_c2)/Gmax/Gmax))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb_c=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_c/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_c+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb_c)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb_c/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vb_c/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb_b1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb_b1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb_b1+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb_b1)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb_b1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vb_b1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb1_b2=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb1_b2+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb1_b2)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb1_b2/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vb1_b2/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vc4_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc4_c1+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vc4_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vc4_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vc4_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vc3_c1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c1+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vc3_c1)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vc3_c1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vc3_c4=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vc3_c4+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vc3_c4)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vc3_c4/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vc3_c4/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
  Iavl_Vb2_e1_Vb2_e1=((+0.0*Gem+0.0*0.0+0.0*0.0+Ic1c2*0.0)/((Gem+(Gem/Gmax))+1.0)-(0.0*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(0.0)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)+(Ic1c2*Gem)*(+(+0.0+(0.0/Gmax-(0.0*Gmax_Vb2_e1+0.0*Gmax_Vb2_e1+Gem*Gmax_Vb2_e1_Vb2_e1)/Gmax/Gmax+2*Gem*Gmax_Vb2_e1*Gmax_Vb2_e1/Gmax/Gmax/Gmax))+0.0))/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)+2*(Ic1c2*Gem)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)*(-Gem*Gmax_Vb2_e1/Gmax/Gmax)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0)/((Gem+(Gem/Gmax))+1.0));
#endif
#endif
pInst->Iavl=((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0));
EXIT_IF_ISNAN(((Ic1c2*Gem)/((Gem+(Gem/Gmax))+1.0)))
}
if
((eVb2c2star>0.0))
{
{
double m00_logE(d00_logE0,eVb2c2star)
#if defined(_DERIVATE)
double m10_logE(d10_logE0,d00_logE0,eVb2c2star)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Vb2c2star_Vdt_GND=((Vt_Vdt_GND*d00_logE0)+(Vt*eVb2c2star_Vdt_GND*d10_logE0));
Vb2c2star_Vb2_c2=(Vt*eVb2c2star_Vb2_c2*d10_logE0);
Vb2c2star_Vb2_c1=(Vt*eVb2c2star_Vb2_c1*d10_logE0);
Vb2c2star_Vc1_c2=(Vt*eVb2c2star_Vc1_c2*d10_logE0);
#endif
Vb2c2star=(Vt*d00_logE0);
EXIT_IF_ISNAN((Vt*d00_logE0))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Vb2c2star_Vdt_GND=0.0;
Vb2c2star_Vb2_c2=Vb2c2_Vb2_c2;
Vb2c2star_Vb2_c1=0.0;
Vb2c2star_Vc1_c2=0.0;
#endif
Vb2c2star=Vb2c2;
EXIT_IF_ISNAN(Vb2c2)
}
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(e,e1)V(b1,e1)V(s,c1) ddxprobe= */
power_dis_Vdt_GND=(((((((((((((((((In_Vdt_GND*(Vb2e1-Vb2c2star))+(In*(-Vb2c2star_Vdt_GND)))+((Ic1c2_Vdt_GND*(Vb2c2star-Vb2c1))+(Ic1c2*Vb2c2star_Vdt_GND)))-((Iavl_Vdt_GND*Vb2c2star)+(pInst->Iavl*Vb2c2star_Vdt_GND)))+(-(Vee1*Vee1)*RE_TM_Vdt_GND/pInst->RE_TM/pInst->RE_TM))+((Vcc3*Vcc3)*GCCxx_TM_Vdt_GND))+((Vc3c4*Vc3c4)*GCCex_TM_Vdt_GND))+((Vc4c1*Vc4c1)*GCCin_TM_Vdt_GND))+(-(Vbb1*Vbb1)*RBC_TM_Vdt_GND/pInst->RBC_TM/pInst->RBC_TM))+Ib1b2_Vdt_GND*Vb1b2)+((Ib1_Vdt_GND+Ib2_Vdt_GND)-Izteb_Vdt_GND)*Vb2e1)+Ib1_s_Vdt_GND*Vb1e1)+(Iex_Vdt_GND+Ib3_Vdt_GND)*Vb1c4)+XIex_Vdt_GND*Vbc3)+Isub_Vdt_GND*(Vb1c4-Vsc4))+XIsub_Vdt_GND*(Vbc3-Vsc3))+Isf_Vdt_GND*Vsc1);
power_dis_Vb2_e1=((((((((In_Vb2_e1*(Vb2e1-Vb2c2star))+(In*Vb2e1_Vb2_e1))-Iavl_Vb2_e1*Vb2c2star)+Ib1b2_Vb2_e1*Vb1b2)+((((Ib1_Vb2_e1+Ib2_Vb2_e1)-Izteb_Vb2_e1)*Vb2e1)+(((pInst->Ib1+pInst->Ib2)-pInst->Izteb)*Vb2e1_Vb2_e1)))+Ib3_Vb2_e1*Vb1c4)+XIex_Vb2_e1*Vbc3)+XIsub_Vb2_e1*(Vbc3-Vsc3));
power_dis_Vb2_c2=(((((((((((In_Vb2_c2*(Vb2e1-Vb2c2star))+(In*(-Vb2c2star_Vb2_c2)))+((Ic1c2_Vb2_c2*(Vb2c2star-Vb2c1))+(Ic1c2*Vb2c2star_Vb2_c2)))-((Iavl_Vb2_c2*Vb2c2star)+(pInst->Iavl*Vb2c2star_Vb2_c2)))+((Vcc3_Vb2_c2*Vcc3)+(Vcc3*Vcc3_Vb2_c2))*pInst->GCCxx_TM)+Ib1b2_Vb2_c2*Vb1b2)+(Ib1_Vb2_c2-Izteb_Vb2_c2)*Vb2e1)+(((Iex_Vb2_c2+Ib3_Vb2_c2)*Vb1c4)+((pInst->Iex+pInst->Ib3)*Vb1c4_Vb2_c2)))+((XIex_Vb2_c2*Vbc3)+(pInst->XIex*Vbc3_Vb2_c2)))+((Isub_Vb2_c2*(Vb1c4-Vsc4))+(pInst->Isub*Vb1c4_Vb2_c2)))+((XIsub_Vb2_c2*(Vbc3-Vsc3))+(pInst->XIsub*Vbc3_Vb2_c2)));
power_dis_Vb2_c1=((((((((In_Vb2_c1*(Vb2e1-Vb2c2star))+(In*(-Vb2c2star_Vb2_c1)))+((Ic1c2_Vb2_c1*(Vb2c2star-Vb2c1))+(Ic1c2*(Vb2c2star_Vb2_c1-Vb2c1_Vb2_c1))))-((Iavl_Vb2_c1*Vb2c2star)+(pInst->Iavl*Vb2c2star_Vb2_c1)))+Ib1b2_Vb2_c1*Vb1b2)+(Ib1_Vb2_c1-Izteb_Vb2_c1)*Vb2e1)+XIex_Vb2_c1*Vbc3)+XIsub_Vb2_c1*(Vbc3-Vsc3));
power_dis_Vc1_c2=(((((((((((In_Vc1_c2*(Vb2e1-Vb2c2star))+(In*(-Vb2c2star_Vc1_c2)))+((Ic1c2_Vc1_c2*(Vb2c2star-Vb2c1))+(Ic1c2*Vb2c2star_Vc1_c2)))-((Iavl_Vc1_c2*Vb2c2star)+(pInst->Iavl*Vb2c2star_Vc1_c2)))+((Vcc3_Vc1_c2*Vcc3)+(Vcc3*Vcc3_Vc1_c2))*pInst->GCCxx_TM)+Ib1b2_Vc1_c2*Vb1b2)+(Ib1_Vc1_c2-Izteb_Vc1_c2)*Vb2e1)+(((Iex_Vc1_c2+Ib3_Vc1_c2)*Vb1c4)+((pInst->Iex+pInst->Ib3)*Vb1c4_Vc1_c2)))+((XIex_Vc1_c2*Vbc3)+(pInst->XIex*Vbc3_Vc1_c2)))+((Isub_Vc1_c2*(Vb1c4-Vsc4))+(pInst->Isub*Vb1c4_Vc1_c2)))+((XIsub_Vc1_c2*(Vbc3-Vsc3))+(pInst->XIsub*Vbc3_Vc1_c2)));
power_dis_Vb_c=(((((-Iavl_Vb_c*Vb2c2star)+((Vcc3_Vb_c*Vcc3)+(Vcc3*Vcc3_Vb_c))*pInst->GCCxx_TM)+Ib1b2_Vb_c*Vb1b2)+((XIex_Vb_c*Vbc3)+(pInst->XIex*Vbc3_Vb_c)))+((XIsub_Vb_c*(Vbc3-Vsc3))+(pInst->XIsub*Vbc3_Vb_c)));
power_dis_Vb_b1=((((((-Iavl_Vb_b1*Vb2c2star)+((Vcc3_Vb_b1*Vcc3)+(Vcc3*Vcc3_Vb_b1))*pInst->GCCxx_TM)+(((Vbb1_Vb_b1*Vbb1)+(Vbb1*Vbb1_Vb_b1))/pInst->RBC_TM))+Ib1b2_Vb_b1*Vb1b2)+((XIex_Vb_b1*Vbc3)+(pInst->XIex*Vbc3_Vb_b1)))+((XIsub_Vb_b1*(Vbc3-Vsc3))+(pInst->XIsub*Vbc3_Vb_b1)));
power_dis_Vb1_b2=(((((((-Iavl_Vb1_b2*Vb2c2star)+((Vcc3_Vb1_b2*Vcc3)+(Vcc3*Vcc3_Vb1_b2))*pInst->GCCxx_TM)+((Ib1b2_Vb1_b2*Vb1b2)+(Ib1b2*Vb1b2_Vb1_b2)))+(((Iex_Vb1_b2+Ib3_Vb1_b2)*Vb1c4)+((pInst->Iex+pInst->Ib3)*Vb1c4_Vb1_b2)))+((XIex_Vb1_b2*Vbc3)+(pInst->XIex*Vbc3_Vb1_b2)))+((Isub_Vb1_b2*(Vb1c4-Vsc4))+(pInst->Isub*Vb1c4_Vb1_b2)))+((XIsub_Vb1_b2*(Vbc3-Vsc3))+(pInst->XIsub*Vbc3_Vb1_b2)));
power_dis_Vc4_c1=((((((((-Iavl_Vc4_c1*Vb2c2star)+((Vcc3_Vc4_c1*Vcc3)+(Vcc3*Vcc3_Vc4_c1))*pInst->GCCxx_TM)+((Vc4c1_Vc4_c1*Vc4c1)+(Vc4c1*Vc4c1_Vc4_c1))*pInst->GCCin_TM)+Ib1b2_Vc4_c1*Vb1b2)+(((Iex_Vc4_c1+Ib3_Vc4_c1)*Vb1c4)+((pInst->Iex+pInst->Ib3)*Vb1c4_Vc4_c1)))+((XIex_Vc4_c1*Vbc3)+(pInst->XIex*Vbc3_Vc4_c1)))+((Isub_Vc4_c1*(Vb1c4-Vsc4))+(pInst->Isub*(Vb1c4_Vc4_c1-Vsc4_Vc4_c1))))+((XIsub_Vc4_c1*(Vbc3-Vsc3))+(pInst->XIsub*(Vbc3_Vc4_c1-Vsc3_Vc4_c1))));
power_dis_Vc3_c1=((((((-Iavl_Vc3_c1*Vb2c2star)+((Vcc3_Vc3_c1*Vcc3)+(Vcc3*Vcc3_Vc3_c1))*pInst->GCCxx_TM)+((Vc3c4_Vc3_c1*Vc3c4)+(Vc3c4*Vc3c4_Vc3_c1))*pInst->GCCex_TM)+Ib1b2_Vc3_c1*Vb1b2)+((XIex_Vc3_c1*Vbc3)+(pInst->XIex*Vbc3_Vc3_c1)))+((XIsub_Vc3_c1*(Vbc3-Vsc3))+(pInst->XIsub*(Vbc3_Vc3_c1-Vsc3_Vc3_c1))));
power_dis_Vc3_c4=((((((-Iavl_Vc3_c4*Vb2c2star)+((Vcc3_Vc3_c4*Vcc3)+(Vcc3*Vcc3_Vc3_c4))*pInst->GCCxx_TM)+((Vc3c4_Vc3_c4*Vc3c4)+(Vc3c4*Vc3c4_Vc3_c4))*pInst->GCCex_TM)+Ib1b2_Vc3_c4*Vb1b2)+((XIex_Vc3_c4*Vbc3)+(pInst->XIex*Vbc3_Vc3_c4)))+((XIsub_Vc3_c4*(Vbc3-Vsc3))+(pInst->XIsub*(Vbc3_Vc3_c4-Vsc3_Vc3_c4))));
power_dis_Ve_e1=(((Vee1_Ve_e1*Vee1)+(Vee1*Vee1_Ve_e1))/pInst->RE_TM);
power_dis_Vb1_e1=((Ib1_s_Vb1_e1*Vb1e1)+(pInst->Ib1_s*Vb1e1_Vb1_e1));
power_dis_Vs_c1=(((XIex_Vs_c1*Vbc3+((Isub_Vs_c1*(Vb1c4-Vsc4))+(pInst->Isub*(-Vsc4_Vs_c1))))+((XIsub_Vs_c1*(Vbc3-Vsc3))+(pInst->XIsub*(-Vsc3_Vs_c1))))+((Isf_Vs_c1*Vsc1)+(Isf*Vsc1_Vs_c1)));
#endif
power_dis=((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(pInst->Iavl*Vb2c2star))+((Vee1*Vee1)/pInst->RE_TM))+((Vcc3*Vcc3)*pInst->GCCxx_TM))+((Vc3c4*Vc3c4)*pInst->GCCex_TM))+((Vc4c1*Vc4c1)*pInst->GCCin_TM))+((Vbb1*Vbb1)/pInst->RBC_TM))+(Ib1b2*Vb1b2))+(((pInst->Ib1+pInst->Ib2)-pInst->Izteb)*Vb2e1))+(pInst->Ib1_s*Vb1e1))+((pInst->Iex+pInst->Ib3)*Vb1c4))+(pInst->XIex*Vbc3))+(pInst->Isub*(Vb1c4-Vsc4)))+(pInst->XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1));
EXIT_IF_ISNAN(((((((((((((((((In*(Vb2e1-Vb2c2star))+(Ic1c2*(Vb2c2star-Vb2c1)))-(pInst->Iavl*Vb2c2star))+((Vee1*Vee1)/pInst->RE_TM))+((Vcc3*Vcc3)*pInst->GCCxx_TM))+((Vc3c4*Vc3c4)*pInst->GCCex_TM))+((Vc4c1*Vc4c1)*pInst->GCCin_TM))+((Vbb1*Vbb1)/pInst->RBC_TM))+(Ib1b2*Vb1b2))+(((pInst->Ib1+pInst->Ib2)-pInst->Izteb)*Vb2e1))+(pInst->Ib1_s*Vb1e1))+((pInst->Iex+pInst->Ib3)*Vb1c4))+(pInst->XIex*Vbc3))+(pInst->Isub*(Vb1c4-Vsc4)))+(pInst->XIsub*(Vbc3-Vsc3)))+(Isf*Vsc1)))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Qte_Vdt_GND=((((1.0-pModel->XCJE)*CJE_TM_Vdt_GND)*Vte)+(((1.0-pModel->XCJE)*CJE_TM)*Vte_Vdt_GND));
#endif
Qte_Vb2_e1=(((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1);
#if defined(_DERIVATE2)
  Qte_Vb2_e1_Vdt_GND=(+(+(+0.0-0.0)*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+(1.0-pModel->XCJE)*0.0)*Vte+0.0*Vte_Vdt_GND+(((1.0-pModel->XCJE)*CJE_TM_Vdt_GND))*Vte_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1_Vdt_GND);
  Qte_Vb2_e1_Vb2_e1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*Vte+0.0*Vte_Vb2_e1+(0.0)*Vte_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1_Vb2_e1);
  Qte_Vb2_e1_Vb2_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*Vte+0.0*Vte_Vb2_c2+(0.0)*Vte_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1_Vb2_c2);
  Qte_Vb2_e1_Vb2_c1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*Vte+0.0*Vte_Vb2_c1+(0.0)*Vte_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1_Vb2_c1);
  Qte_Vb2_e1_Vc1_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*Vte+0.0*Vte_Vc1_c2+(0.0)*Vte_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qte_Vb2_c2=(((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_c2);
#endif
#if defined(_DERIVATE)
Qte_Vb2_c1=(((1.0-pModel->XCJE)*CJE_TM)*Vte_Vb2_c1);
#endif
#if defined(_DERIVATE)
Qte_Vc1_c2=(((1.0-pModel->XCJE)*CJE_TM)*Vte_Vc1_c2);
#endif
#endif
Qte=(((1.0-pModel->XCJE)*CJE_TM)*Vte);
EXIT_IF_ISNAN((((1.0-pModel->XCJE)*CJE_TM)*Vte))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=(Vb1e1_Vb1_e1/a_VDE);
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb_c=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb_b1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vc3_c1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vc3_c4=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb1_b2=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vc4_c1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb1_e1=((+Vb1e1_Vb1_e1_Vb1_e1-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+Vb1e1_Vb1_e1*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb2_e1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb2_c2=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vb2_c1=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vc1_c2=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*0.0+0.0*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  dxa_Vb1_e1_Vdt_GND=((+0.0-0.0)/a_VDE-(Vb1e1_Vb1_e1*a_VDE_Vdt_GND+(-Vfe_Vdt_GND)*0.0+(Vb1e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb1e1-Vfe)*0.0*a_VDE_Vdt_GND/a_VDE/a_VDE/a_VDE);
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-Vfe_Vdt_GND)*a_VDE-(Vb1e1-Vfe)*a_VDE_Vdt_GND)/a_VDE/a_VDE);
#endif
#endif
dxa=((Vb1e1-Vfe)/a_VDE);
EXIT_IF_ISNAN(((Vb1e1-Vfe)/a_VDE))
#endif
#ifdef _DYNAMIC
if
((Vb1e1<Vfe))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1)V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND) */
Vje_s_Vb1_e1=(Vb1e1_Vb1_e1-(a_VDE*dxa_Vb1_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_s_Vb1_e1_Vb1_e1=(+Vb1e1_Vb1_e1_Vb1_e1-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb1_e1)))));
  Vje_s_Vb1_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vdt_GND)))));
  Vje_s_Vb1_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_e1)))));
  Vje_s_Vb1_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_c2)))));
  Vje_s_Vb1_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_c1)))));
  Vje_s_Vb1_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vc1_c2)))));
#endif
#if defined(_DERIVATE)
Vje_s_Vdt_GND=(-((a_VDE_Vdt_GND*d00_logE1)+(a_VDE*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
Vje_s_Vb2_e1=(-(a_VDE*dxa_Vb2_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_s_Vb2_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb1_e1)))));
  Vje_s_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDE_Vdt_GND*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vdt_GND)))));
  Vje_s_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_e1)))));
  Vje_s_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c2)))));
  Vje_s_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c1)))));
  Vje_s_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vc1_c2)))));
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c2=(-(a_VDE*dxa_Vb2_c2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c1=(-(a_VDE*dxa_Vb2_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vje_s_Vc1_c2=(-(a_VDE*dxa_Vc1_c2*d10_exp0*d10_logE1));
#endif
#endif
Vje_s=(Vb1e1-(a_VDE*d00_logE1));
EXIT_IF_ISNAN((Vb1e1-(a_VDE*d00_logE1)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1)V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND) */
Vje_s_Vb1_e1=(-(a_VDE*(-dxa_Vb1_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_s_Vb1_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vje_s_Vb1_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vje_s_Vb1_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vje_s_Vb1_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vje_s_Vb1_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vje_s_Vb1_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vje_s_Vdt_GND=(Vfe_Vdt_GND-((a_VDE_Vdt_GND*d00_logE1)+(a_VDE*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
Vje_s_Vb2_e1=(-(a_VDE*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vje_s_Vb2_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_s_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDE_Vdt_GND*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_s_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_s_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_s_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vje_s_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDE*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c2=(-(a_VDE*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c1=(-(a_VDE*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vje_s_Vc1_c2=(-(a_VDE*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#endif
#endif
Vje_s=(Vfe-(a_VDE*d00_logE1));
EXIT_IF_ISNAN((Vfe-(a_VDE*d00_logE1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,e1)V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND) */
Vje_s_Vb1_e1=Vje_s_Vb1_e1;
#if defined(_DERIVATE2)
  Vje_s_Vb1_e1_Vb1_e1=Vje_s_Vb1_e1_Vb1_e1;
  Vje_s_Vb1_e1_Vdt_GND=Vje_s_Vb1_e1_Vdt_GND;
  Vje_s_Vb1_e1_Vb2_e1=Vje_s_Vb1_e1_Vb2_e1;
  Vje_s_Vb1_e1_Vb2_c2=Vje_s_Vb1_e1_Vb2_c2;
  Vje_s_Vb1_e1_Vb2_c1=Vje_s_Vb1_e1_Vb2_c1;
  Vje_s_Vb1_e1_Vc1_c2=Vje_s_Vb1_e1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Vje_s_Vdt_GND=Vje_s_Vdt_GND;
#endif
Vje_s_Vb2_e1=Vje_s_Vb2_e1;
#if defined(_DERIVATE2)
  Vje_s_Vb2_e1_Vb1_e1=Vje_s_Vb2_e1_Vb1_e1;
  Vje_s_Vb2_e1_Vdt_GND=Vje_s_Vb2_e1_Vdt_GND;
  Vje_s_Vb2_e1_Vb2_e1=Vje_s_Vb2_e1_Vb2_e1;
  Vje_s_Vb2_e1_Vb2_c2=Vje_s_Vb2_e1_Vb2_c2;
  Vje_s_Vb2_e1_Vb2_c1=Vje_s_Vb2_e1_Vb2_c1;
  Vje_s_Vb2_e1_Vc1_c2=Vje_s_Vb2_e1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c2=Vje_s_Vb2_c2;
#endif
#if defined(_DERIVATE)
Vje_s_Vb2_c1=Vje_s_Vb2_c1;
#endif
#if defined(_DERIVATE)
Vje_s_Vc1_c2=Vje_s_Vc1_c2;
#endif
#endif
Vje_s=Vje_s;
EXIT_IF_ISNAN(Vje_s)
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1.0-(Vje_s*inv_VDE_T)),(1.0-pModel->PE))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vje_s*inv_VDE_T)),(1.0-pModel->PE))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Qte_s_Vdt_GND=(((pModel->XCJE*CJE_TM_Vdt_GND)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s))))+((pModel->XCJE*CJE_TM)*((((VDE_T_Vdt_GND/(1.0-pModel->PE))*(1.0-d00_pow0))+((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-((Vje_s_Vdt_GND*inv_VDE_T)+(Vje_s*inv_VDE_T_Vdt_GND)))))))+(3.0*(-Vje_s_Vdt_GND)))));
#endif
Qte_s_Vb1_e1=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1))));
#if defined(_DERIVATE2)
  Qte_s_Vb1_e1_Vdt_GND=(+(+0.0*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*(((((VDE_T_Vdt_GND/(1.0-pModel->PE))*(1.0-d00_pow0))+((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(((Vje_s_Vdt_GND*inv_VDE_T)+(Vje_s*inv_VDE_T_Vdt_GND)))))))))+((3.0*(-Vje_s_Vdt_GND))))+((pModel->XCJE*CJE_TM_Vdt_GND))*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(((Vje_s_Vdt_GND*inv_VDE_T)+(Vje_s*inv_VDE_T_Vdt_GND))))))+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vdt_GND)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+0.0-Vje_s_Vb1_e1_Vdt_GND))));
  Qte_s_Vb1_e1_Vb1_e1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb1_e1*inv_VDE_T))))))+((3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb1_e1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+Vb1e1_Vb1_e1_Vb1_e1-Vje_s_Vb1_e1_Vb1_e1))));
  Qte_s_Vb1_e1_Vb2_e1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_e1*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_e1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_e1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_e1)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+0.0-Vje_s_Vb1_e1_Vb2_e1))));
  Qte_s_Vb1_e1_Vb2_c2=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_c2*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_c2))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_c2*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_c2)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+0.0-Vje_s_Vb1_e1_Vb2_c2))));
  Qte_s_Vb1_e1_Vb2_c1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_c1*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_c1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_c1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_c1)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+0.0-Vje_s_Vb1_e1_Vb2_c1))));
  Qte_s_Vb1_e1_Vc1_c2=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vc1_c2*inv_VDE_T))))))+((3.0*(-Vje_s_Vc1_c2))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T))))+(3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vc1_c2*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb1_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vc1_c2)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+3.0*(+0.0-Vje_s_Vb1_e1_Vc1_c2))));
#endif
Qte_s_Vb2_e1=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1))));
#if defined(_DERIVATE2)
  Qte_s_Vb2_e1_Vdt_GND=(+(+0.0*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*(((((VDE_T_Vdt_GND/(1.0-pModel->PE))*(1.0-d00_pow0))+((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(((Vje_s_Vdt_GND*inv_VDE_T)+(Vje_s*inv_VDE_T_Vdt_GND)))))))))+((3.0*(-Vje_s_Vdt_GND))))+((pModel->XCJE*CJE_TM_Vdt_GND))*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+VDE_T_Vdt_GND*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(((Vje_s_Vdt_GND*inv_VDE_T)+(Vje_s*inv_VDE_T_Vdt_GND))))))+(VDE_T_Vdt_GND/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vdt_GND)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vdt_GND))));
  Qte_s_Vb2_e1_Vb1_e1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb1_e1*inv_VDE_T))))))+((3.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb1_e1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(Vb1e1_Vb1_e1-Vje_s_Vb1_e1)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vb1_e1))));
  Qte_s_Vb2_e1_Vb2_e1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_e1*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_e1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_e1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_e1)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vb2_e1))));
  Qte_s_Vb2_e1_Vb2_c2=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_c2*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_c2))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_c2*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_c2)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vb2_c2))));
  Qte_s_Vb2_e1_Vb2_c1=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vb2_c1*inv_VDE_T))))))+((3.0*(-Vje_s_Vb2_c1))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vb2_c1*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vb2_c1)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vb2_c1))));
  Qte_s_Vb2_e1_Vc1_c2=(+(+0.0*CJE_TM+0.0*0.0+0.0*0.0+pModel->XCJE*0.0)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))+0.0*((((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-(Vje_s_Vc1_c2*inv_VDE_T))))))+((3.0*(-Vje_s_Vc1_c2))))+(0.0)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_e1)))+(pModel->XCJE*CJE_TM)*(+(+(0.0/(1.0-pModel->PE)-(0.0*0.0+0.0*0.0+VDE_T*(+0.0-0.0))/(1.0-pModel->PE)/(1.0-pModel->PE)+2*VDE_T*0.0*0.0/(1.0-pModel->PE)/(1.0-pModel->PE)/(1.0-pModel->PE))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vje_s_Vc1_c2*inv_VDE_T))))+0.0*(-(d10_pow0*(-Vje_s_Vb2_e1*inv_VDE_T)))+(VDE_T/(1.0-pModel->PE))*(+0.0-fixme))+(+0.0*(Vb1e1-Vje_s)+0.0*(-Vje_s_Vc1_c2)+0.0*(-Vje_s_Vb2_e1)+3.0*(+0.0-Vje_s_Vb2_e1_Vc1_c2))));
#endif
#if defined(_DERIVATE)
Qte_s_Vb2_c2=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_c2*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_c2))));
#endif
#if defined(_DERIVATE)
Qte_s_Vb2_c1=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vb2_c1*inv_VDE_T))))+(3.0*(-Vje_s_Vb2_c1))));
#endif
#if defined(_DERIVATE)
Qte_s_Vc1_c2=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(-(d10_pow0*(-Vje_s_Vc1_c2*inv_VDE_T))))+(3.0*(-Vje_s_Vc1_c2))));
#endif
#endif
Qte_s=((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s))));
EXIT_IF_ISNAN(((pModel->XCJE*CJE_TM)*(((VDE_T/(1.0-pModel->PE))*(1.0-d00_pow0))+(3.0*(Vb1e1-Vje_s)))))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b2,e1) ddxprobe=V(c1,GND)V(c2,GND) */
#if defined(_DERIVATE)
Qtc_Vdt_GND=(((pModel->XCJC*CJC_TM_Vdt_GND)*Vtc)+((pModel->XCJC*CJC_TM)*Vtc_Vdt_GND));
#endif
Qtc_Vb2_c2=((pModel->XCJC*CJC_TM)*Vtc_Vb2_c2);
#if defined(_DERIVATE2)
  Qtc_Vb2_c2_Vdt_GND=(+(+0.0*CJC_TM+0.0*CJC_TM_Vdt_GND+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vdt_GND+((pModel->XCJC*CJC_TM_Vdt_GND))*Vtc_Vb2_c2+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c2_Vdt_GND);
  Qtc_Vb2_c2_Vb2_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c2+(0.0)*Vtc_Vb2_c2+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c2_Vb2_c2);
  Qtc_Vb2_c2_Vb2_c1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c1+(0.0)*Vtc_Vb2_c2+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c2_Vb2_c1);
  Qtc_Vb2_c2_Vc1_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vc1_c2+(0.0)*Vtc_Vb2_c2+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c2_Vc1_c2);
  Qtc_Vb2_c2_Vb2_e1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_e1+(0.0)*Vtc_Vb2_c2+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c2_Vb2_e1);
#endif
Qtc_Vb2_c1=((pModel->XCJC*CJC_TM)*Vtc_Vb2_c1);
#if defined(_DERIVATE2)
  Qtc_Vb2_c1_Vdt_GND=(+(+0.0*CJC_TM+0.0*CJC_TM_Vdt_GND+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vdt_GND+((pModel->XCJC*CJC_TM_Vdt_GND))*Vtc_Vb2_c1+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c1_Vdt_GND);
  Qtc_Vb2_c1_Vb2_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c2+(0.0)*Vtc_Vb2_c1+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c1_Vb2_c2);
  Qtc_Vb2_c1_Vb2_c1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c1+(0.0)*Vtc_Vb2_c1+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c1_Vb2_c1);
  Qtc_Vb2_c1_Vc1_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vc1_c2+(0.0)*Vtc_Vb2_c1+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c1_Vc1_c2);
  Qtc_Vb2_c1_Vb2_e1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_e1+(0.0)*Vtc_Vb2_c1+(pModel->XCJC*CJC_TM)*Vtc_Vb2_c1_Vb2_e1);
#endif
Qtc_Vc1_c2=((pModel->XCJC*CJC_TM)*Vtc_Vc1_c2);
#if defined(_DERIVATE2)
  Qtc_Vc1_c2_Vdt_GND=(+(+0.0*CJC_TM+0.0*CJC_TM_Vdt_GND+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vdt_GND+((pModel->XCJC*CJC_TM_Vdt_GND))*Vtc_Vc1_c2+(pModel->XCJC*CJC_TM)*Vtc_Vc1_c2_Vdt_GND);
  Qtc_Vc1_c2_Vb2_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c2+(0.0)*Vtc_Vc1_c2+(pModel->XCJC*CJC_TM)*Vtc_Vc1_c2_Vb2_c2);
  Qtc_Vc1_c2_Vb2_c1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_c1+(0.0)*Vtc_Vc1_c2+(pModel->XCJC*CJC_TM)*Vtc_Vc1_c2_Vb2_c1);
  Qtc_Vc1_c2_Vc1_c2=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vc1_c2+(0.0)*Vtc_Vc1_c2+(pModel->XCJC*CJC_TM)*Vtc_Vc1_c2_Vc1_c2);
  Qtc_Vc1_c2_Vb2_e1=(+(+0.0*CJC_TM+0.0*0.0+0.0*0.0+pModel->XCJC*0.0)*Vtc+0.0*Vtc_Vb2_e1+(0.0)*Vtc_Vc1_c2+(pModel->XCJC*CJC_TM)*Vtc_Vc1_c2_Vb2_e1);
#endif
#if defined(_DERIVATE)
Qtc_Vb2_e1=((pModel->XCJC*CJC_TM)*Vtc_Vb2_e1);
#endif
#endif
Qtc=((pModel->XCJC*CJC_TM)*Vtc);
EXIT_IF_ISNAN(((pModel->XCJC*CJC_TM)*Vtc))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b,GND)V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Qb0_Vdt_GND=((TAUB_T_Vdt_GND*IK_TM)+(pInst->TAUB_T*IK_TM_Vdt_GND));
#endif
Qb0=(pInst->TAUB_T*IK_TM);
EXIT_IF_ISNAN((pInst->TAUB_T*IK_TM))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Qbe_qs_Vdt_GND=(((((0.5*Qb0_Vdt_GND)*n0)+((0.5*Qb0)*n0_Vdt_GND))*pInst->q1Q)+(((0.5*Qb0)*n0)*q1Q_Vdt_GND));
#endif
Qbe_qs_Vb2_e1=((((0.5*Qb0)*n0_Vb2_e1)*pInst->q1Q)+(((0.5*Qb0)*n0)*q1Q_Vb2_e1));
#if defined(_DERIVATE2)
  Qbe_qs_Vb2_e1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*n0_Vb2_e1+(0.5*Qb0)*n0_Vb2_e1_Vdt_GND)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vdt_GND);
  Qbe_qs_Vb2_e1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*n0_Vb2_e1+(0.5*Qb0)*n0_Vb2_e1_Vb2_e1)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb2_e1);
  Qbe_qs_Vb2_e1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb_c+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb_c);
  Qbe_qs_Vb2_e1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb_b1);
  Qbe_qs_Vb2_e1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb1_b2);
  Qbe_qs_Vb2_e1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vc4_c1);
  Qbe_qs_Vb2_e1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vc3_c1);
  Qbe_qs_Vb2_e1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vc3_c4);
  Qbe_qs_Vb2_e1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb2_c2);
  Qbe_qs_Vb2_e1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vb2_c1);
  Qbe_qs_Vb2_e1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*n0_Vb2_e1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*n0_Vb2_e1)*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vb2_e1+((0.5*Qb0)*n0)*q1Q_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbe_qs_Vb_c=(((0.5*Qb0)*n0)*q1Q_Vb_c);
#endif
#if defined(_DERIVATE)
Qbe_qs_Vb_b1=(((0.5*Qb0)*n0)*q1Q_Vb_b1);
#endif
#if defined(_DERIVATE)
Qbe_qs_Vb1_b2=(((0.5*Qb0)*n0)*q1Q_Vb1_b2);
#endif
Qbe_qs_Vc4_c1=(((0.5*Qb0)*n0)*q1Q_Vc4_c1);
#if defined(_DERIVATE2)
  Qbe_qs_Vc4_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vdt_GND);
  Qbe_qs_Vc4_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb2_e1);
  Qbe_qs_Vc4_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb_c);
  Qbe_qs_Vc4_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb_b1);
  Qbe_qs_Vc4_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb1_b2);
  Qbe_qs_Vc4_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vc4_c1);
  Qbe_qs_Vc4_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vc3_c1);
  Qbe_qs_Vc4_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vc3_c4);
  Qbe_qs_Vc4_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb2_c2);
  Qbe_qs_Vc4_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vb2_c1);
  Qbe_qs_Vc4_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vc4_c1+((0.5*Qb0)*n0)*q1Q_Vc4_c1_Vc1_c2);
#endif
Qbe_qs_Vc3_c1=(((0.5*Qb0)*n0)*q1Q_Vc3_c1);
#if defined(_DERIVATE2)
  Qbe_qs_Vc3_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vdt_GND);
  Qbe_qs_Vc3_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb2_e1);
  Qbe_qs_Vc3_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb_c);
  Qbe_qs_Vc3_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb_b1);
  Qbe_qs_Vc3_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb1_b2);
  Qbe_qs_Vc3_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vc4_c1);
  Qbe_qs_Vc3_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vc3_c1);
  Qbe_qs_Vc3_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vc3_c4);
  Qbe_qs_Vc3_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb2_c2);
  Qbe_qs_Vc3_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vb2_c1);
  Qbe_qs_Vc3_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vc3_c1+((0.5*Qb0)*n0)*q1Q_Vc3_c1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbe_qs_Vc3_c4=(((0.5*Qb0)*n0)*q1Q_Vc3_c4);
#endif
Qbe_qs_Vb2_c2=(((0.5*Qb0)*n0)*q1Q_Vb2_c2);
#if defined(_DERIVATE2)
  Qbe_qs_Vb2_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vdt_GND);
  Qbe_qs_Vb2_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb2_e1);
  Qbe_qs_Vb2_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb_c);
  Qbe_qs_Vb2_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb_b1);
  Qbe_qs_Vb2_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb1_b2);
  Qbe_qs_Vb2_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vc4_c1);
  Qbe_qs_Vb2_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vc3_c1);
  Qbe_qs_Vb2_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vc3_c4);
  Qbe_qs_Vb2_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb2_c2);
  Qbe_qs_Vb2_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vb2_c1);
  Qbe_qs_Vb2_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vb2_c2+((0.5*Qb0)*n0)*q1Q_Vb2_c2_Vc1_c2);
#endif
Qbe_qs_Vb2_c1=(((0.5*Qb0)*n0)*q1Q_Vb2_c1);
#if defined(_DERIVATE2)
  Qbe_qs_Vb2_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vdt_GND);
  Qbe_qs_Vb2_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb2_e1);
  Qbe_qs_Vb2_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb_c);
  Qbe_qs_Vb2_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb_b1);
  Qbe_qs_Vb2_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb1_b2);
  Qbe_qs_Vb2_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vc4_c1);
  Qbe_qs_Vb2_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vc3_c1);
  Qbe_qs_Vb2_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vc3_c4);
  Qbe_qs_Vb2_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb2_c2);
  Qbe_qs_Vb2_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vb2_c1);
  Qbe_qs_Vb2_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vb2_c1+((0.5*Qb0)*n0)*q1Q_Vb2_c1_Vc1_c2);
#endif
Qbe_qs_Vc1_c2=(((0.5*Qb0)*n0)*q1Q_Vc1_c2);
#if defined(_DERIVATE2)
  Qbe_qs_Vc1_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*n0)+((0.5*Qb0)*n0_Vdt_GND)))*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vdt_GND);
  Qbe_qs_Vc1_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*n0_Vb2_e1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((((0.0)*n0)+((0.5*Qb0)*n0_Vb2_e1)))*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb2_e1);
  Qbe_qs_Vc1_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb_c);
  Qbe_qs_Vc1_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb_b1);
  Qbe_qs_Vc1_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb1_b2);
  Qbe_qs_Vc1_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vc4_c1);
  Qbe_qs_Vc1_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vc3_c1);
  Qbe_qs_Vc1_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vc3_c4);
  Qbe_qs_Vc1_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb2_c2);
  Qbe_qs_Vc1_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vb2_c1);
  Qbe_qs_Vc1_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*n0+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((0.0)*n0)*q1Q_Vc1_c2+((0.5*Qb0)*n0)*q1Q_Vc1_c2_Vc1_c2);
#endif
#endif
Qbe_qs=(((0.5*Qb0)*n0)*pInst->q1Q);
EXIT_IF_ISNAN((((0.5*Qb0)*n0)*pInst->q1Q))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Qbc_qs_Vdt_GND=(((((0.5*Qb0_Vdt_GND)*nB)+((0.5*Qb0)*nB_Vdt_GND))*pInst->q1Q)+(((0.5*Qb0)*nB)*q1Q_Vdt_GND));
#endif
Qbc_qs_Vb2_c2=((((0.5*Qb0)*nB_Vb2_c2)*pInst->q1Q)+(((0.5*Qb0)*nB)*q1Q_Vb2_c2));
#if defined(_DERIVATE2)
  Qbc_qs_Vb2_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*nB_Vb2_c2+(0.5*Qb0)*nB_Vb2_c2_Vdt_GND)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vdt_GND);
  Qbc_qs_Vb2_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*nB_Vb2_c2+(0.5*Qb0)*nB_Vb2_c2_Vb2_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb2_c2);
  Qbc_qs_Vb2_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*nB_Vb2_c2+(0.5*Qb0)*nB_Vb2_c2_Vb2_c1)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb2_c1);
  Qbc_qs_Vb2_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*nB_Vb2_c2+(0.5*Qb0)*nB_Vb2_c2_Vc1_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vc1_c2);
  Qbc_qs_Vb2_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb_c+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb_c);
  Qbc_qs_Vb2_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb_b1);
  Qbc_qs_Vb2_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb1_b2);
  Qbc_qs_Vb2_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vc4_c1);
  Qbc_qs_Vb2_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vc3_c1);
  Qbc_qs_Vb2_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vc3_c4);
  Qbc_qs_Vb2_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c2)*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vb2_c2+((0.5*Qb0)*nB)*q1Q_Vb2_c2_Vb2_e1);
#endif
Qbc_qs_Vb2_c1=((((0.5*Qb0)*nB_Vb2_c1)*pInst->q1Q)+(((0.5*Qb0)*nB)*q1Q_Vb2_c1));
#if defined(_DERIVATE2)
  Qbc_qs_Vb2_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*nB_Vb2_c1+(0.5*Qb0)*nB_Vb2_c1_Vdt_GND)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vdt_GND);
  Qbc_qs_Vb2_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*nB_Vb2_c1+(0.5*Qb0)*nB_Vb2_c1_Vb2_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb2_c2);
  Qbc_qs_Vb2_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*nB_Vb2_c1+(0.5*Qb0)*nB_Vb2_c1_Vb2_c1)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb2_c1);
  Qbc_qs_Vb2_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*nB_Vb2_c1+(0.5*Qb0)*nB_Vb2_c1_Vc1_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vc1_c2);
  Qbc_qs_Vb2_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb_c+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb_c);
  Qbc_qs_Vb2_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb_b1);
  Qbc_qs_Vb2_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb1_b2);
  Qbc_qs_Vb2_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vc4_c1);
  Qbc_qs_Vb2_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vc3_c1);
  Qbc_qs_Vb2_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vc3_c4);
  Qbc_qs_Vb2_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vb2_c1+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vb2_c1)*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vb2_c1+((0.5*Qb0)*nB)*q1Q_Vb2_c1_Vb2_e1);
#endif
Qbc_qs_Vc1_c2=((((0.5*Qb0)*nB_Vc1_c2)*pInst->q1Q)+(((0.5*Qb0)*nB)*q1Q_Vc1_c2));
#if defined(_DERIVATE2)
  Qbc_qs_Vc1_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*nB_Vc1_c2+(0.5*Qb0)*nB_Vc1_c2_Vdt_GND)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vdt_GND);
  Qbc_qs_Vc1_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*nB_Vc1_c2+(0.5*Qb0)*nB_Vc1_c2_Vb2_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb2_c2);
  Qbc_qs_Vc1_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*nB_Vc1_c2+(0.5*Qb0)*nB_Vc1_c2_Vb2_c1)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb2_c1);
  Qbc_qs_Vc1_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*nB_Vc1_c2+(0.5*Qb0)*nB_Vc1_c2_Vc1_c2)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vc1_c2);
  Qbc_qs_Vc1_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb_c+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb_c);
  Qbc_qs_Vc1_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb_b1);
  Qbc_qs_Vc1_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb1_b2);
  Qbc_qs_Vc1_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vc4_c1);
  Qbc_qs_Vc1_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vc3_c1);
  Qbc_qs_Vc1_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vc3_c4);
  Qbc_qs_Vc1_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*nB_Vc1_c2+(0.5*Qb0)*0.0)*pInst->q1Q+((0.5*Qb0)*nB_Vc1_c2)*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vc1_c2+((0.5*Qb0)*nB)*q1Q_Vc1_c2_Vb2_e1);
#endif
#if defined(_DERIVATE)
Qbc_qs_Vb_c=(((0.5*Qb0)*nB)*q1Q_Vb_c);
#endif
#if defined(_DERIVATE)
Qbc_qs_Vb_b1=(((0.5*Qb0)*nB)*q1Q_Vb_b1);
#endif
#if defined(_DERIVATE)
Qbc_qs_Vb1_b2=(((0.5*Qb0)*nB)*q1Q_Vb1_b2);
#endif
Qbc_qs_Vc4_c1=(((0.5*Qb0)*nB)*q1Q_Vc4_c1);
#if defined(_DERIVATE2)
  Qbc_qs_Vc4_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vdt_GND);
  Qbc_qs_Vc4_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb2_c2);
  Qbc_qs_Vc4_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb2_c1);
  Qbc_qs_Vc4_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vc1_c2);
  Qbc_qs_Vc4_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb_c);
  Qbc_qs_Vc4_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb_b1);
  Qbc_qs_Vc4_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb1_b2);
  Qbc_qs_Vc4_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vc4_c1);
  Qbc_qs_Vc4_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vc3_c1);
  Qbc_qs_Vc4_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vc3_c4);
  Qbc_qs_Vc4_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vc4_c1+((0.5*Qb0)*nB)*q1Q_Vc4_c1_Vb2_e1);
#endif
Qbc_qs_Vc3_c1=(((0.5*Qb0)*nB)*q1Q_Vc3_c1);
#if defined(_DERIVATE2)
  Qbc_qs_Vc3_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vdt_GND);
  Qbc_qs_Vc3_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb2_c2);
  Qbc_qs_Vc3_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb2_c1);
  Qbc_qs_Vc3_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vc1_c2);
  Qbc_qs_Vc3_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb_c);
  Qbc_qs_Vc3_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb_b1);
  Qbc_qs_Vc3_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb1_b2);
  Qbc_qs_Vc3_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vc4_c1);
  Qbc_qs_Vc3_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vc3_c1);
  Qbc_qs_Vc3_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vc3_c4);
  Qbc_qs_Vc3_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vc3_c1+((0.5*Qb0)*nB)*q1Q_Vc3_c1_Vb2_e1);
#endif
#if defined(_DERIVATE)
Qbc_qs_Vc3_c4=(((0.5*Qb0)*nB)*q1Q_Vc3_c4);
#endif
Qbc_qs_Vb2_e1=(((0.5*Qb0)*nB)*q1Q_Vb2_e1);
#if defined(_DERIVATE2)
  Qbc_qs_Vb2_e1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vdt_GND+((0.5*Qb0_Vdt_GND))*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*nB)+((0.5*Qb0)*nB_Vdt_GND)))*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vdt_GND);
  Qbc_qs_Vb2_e1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c2)))*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb2_c2);
  Qbc_qs_Vb2_e1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vb2_c1+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+((((0.0)*nB)+((0.5*Qb0)*nB_Vb2_c1)))*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb2_c1);
  Qbc_qs_Vb2_e1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*nB_Vc1_c2+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+((((0.0)*nB)+((0.5*Qb0)*nB_Vc1_c2)))*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vc1_c2);
  Qbc_qs_Vb2_e1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb_c);
  Qbc_qs_Vb2_e1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb_b1);
  Qbc_qs_Vb2_e1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb1_b2);
  Qbc_qs_Vb2_e1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vc4_c1);
  Qbc_qs_Vb2_e1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vc3_c1);
  Qbc_qs_Vb2_e1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vc3_c4);
  Qbc_qs_Vb2_e1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*nB+0.0*0.0+(0.0)*0.0+(0.5*Qb0)*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+((0.0)*nB)*q1Q_Vb2_e1+((0.5*Qb0)*nB)*q1Q_Vb2_e1_Vb2_e1);
#endif
#endif
Qbc_qs=(((0.5*Qb0)*nB)*pInst->q1Q);
EXIT_IF_ISNAN((((0.5*Qb0)*nB)*pInst->q1Q))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(s,GND)V(b,GND) */
a_VDC_Vdt_GND=(0.1*VDC_T_Vdt_GND);
#endif
a_VDC=(0.1*VDC_T);
EXIT_IF_ISNAN((0.1*VDC_T))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=(Vb1c4_Vb1_b2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb_c=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb_b1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc3_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc3_c4=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb1_b2=((+Vb1c4_Vb1_b2_Vb1_b2-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc4_c1=((+Vb1c4_Vb1_b2_Vc4_c1-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_c2=((+Vb1c4_Vb1_b2_Vb2_c2-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc1_c2=((+Vb1c4_Vb1_b2_Vc1_c2-0.0)/a_VDC-(Vb1c4_Vb1_b2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vb1c4_Vb1_b2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vc4_c1=(Vb1c4_Vc4_c1/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb_c=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb_b1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc3_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc3_c4=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb1_b2=((+Vb1c4_Vc4_c1_Vb1_b2-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc4_c1=((+Vb1c4_Vc4_c1_Vc4_c1-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb1_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_c2=((+Vb1c4_Vc4_c1_Vb2_c2-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc1_c2=((+Vb1c4_Vc4_c1_Vc1_c2-0.0)/a_VDC-(Vb1c4_Vc4_c1*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vdt_GND=((+0.0-0.0)/a_VDC-(Vb1c4_Vc4_c1*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=(Vb1c4_Vb2_c2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb_c=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb_b1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc3_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc3_c4=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb1_b2=((+Vb1c4_Vb2_c2_Vb1_b2-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc4_c1=((+Vb1c4_Vb2_c2_Vc4_c1-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_c2=((+Vb1c4_Vb2_c2_Vb2_c2-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc1_c2=((+Vb1c4_Vb2_c2_Vc1_c2-0.0)/a_VDC-(Vb1c4_Vb2_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vb1c4_Vb2_c2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=(Vb1c4_Vc1_c2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb_c=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb_b1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc3_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc3_c4=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb1_b2=((+Vb1c4_Vc1_c2_Vb1_b2-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+Vb1c4_Vb1_b2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc4_c1=((+Vb1c4_Vc1_c2_Vc4_c1-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+Vb1c4_Vc4_c1*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_c2=((+Vb1c4_Vc1_c2_Vb2_c2-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+Vb1c4_Vb2_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+0.0*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc1_c2=((+Vb1c4_Vc1_c2_Vc1_c2-0.0)/a_VDC-(Vb1c4_Vc1_c2*0.0+Vb1c4_Vc1_c2*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vb1c4_Vc1_c2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vb1c4-Vfc)*0.0)/a_VDC/a_VDC+2*(Vb1c4-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-Vfc_Vdt_GND)*a_VDC-(Vb1c4-Vfc)*a_VDC_Vdt_GND)/a_VDC/a_VDC);
#endif
#endif
dxa=((Vb1c4-Vfc)/a_VDC);
EXIT_IF_ISNAN(((Vb1c4-Vfc)/a_VDC))
#endif
#ifdef _DYNAMIC
if
((Vb1c4<Vfc))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
Vjcex_Vb1_b2=(Vb1c4_Vb1_b2-(a_VDC*dxa_Vb1_b2*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb1_b2_Vb1_b2=(+Vb1c4_Vb1_b2_Vb1_b2-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vb1_b2)))));
  Vjcex_Vb1_b2_Vb2_c2=(+Vb1c4_Vb1_b2_Vb2_c2-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vb2_c2)))));
  Vjcex_Vb1_b2_Vc1_c2=(+Vb1c4_Vb1_b2_Vc1_c2-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vc1_c2)))));
  Vjcex_Vb1_b2_Vc4_c1=(+Vb1c4_Vb1_b2_Vc4_c1-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vc4_c1)))));
  Vjcex_Vb1_b2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vdt_GND)))));
  Vjcex_Vb1_b2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vb1_e1)))));
  Vjcex_Vb1_b2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vb2_e1)))));
  Vjcex_Vb1_b2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb1_b2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb1_b2+d10_exp0*dxa_Vb1_b2_Vb2_c1)))));
#endif
Vjcex_Vb2_c2=(Vb1c4_Vb2_c2-(a_VDC*dxa_Vb2_c2*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_c2_Vb1_b2=(+Vb1c4_Vb2_c2_Vb1_b2-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb1_b2)))));
  Vjcex_Vb2_c2_Vb2_c2=(+Vb1c4_Vb2_c2_Vb2_c2-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c2)))));
  Vjcex_Vb2_c2_Vc1_c2=(+Vb1c4_Vb2_c2_Vc1_c2-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vc1_c2)))));
  Vjcex_Vb2_c2_Vc4_c1=(+Vb1c4_Vb2_c2_Vc4_c1-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vc4_c1)))));
  Vjcex_Vb2_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vdt_GND)))));
  Vjcex_Vb2_c2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb1_e1)))));
  Vjcex_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_e1)))));
  Vjcex_Vb2_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c2+d10_exp0*dxa_Vb2_c2_Vb2_c1)))));
#endif
Vjcex_Vc1_c2=(Vb1c4_Vc1_c2-(a_VDC*dxa_Vc1_c2*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vc1_c2_Vb1_b2=(+Vb1c4_Vc1_c2_Vb1_b2-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb1_b2)))));
  Vjcex_Vc1_c2_Vb2_c2=(+Vb1c4_Vc1_c2_Vb2_c2-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c2)))));
  Vjcex_Vc1_c2_Vc1_c2=(+Vb1c4_Vc1_c2_Vc1_c2-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vc1_c2)))));
  Vjcex_Vc1_c2_Vc4_c1=(+Vb1c4_Vc1_c2_Vc4_c1-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vc4_c1)))));
  Vjcex_Vc1_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vdt_GND)))));
  Vjcex_Vc1_c2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb1_e1)))));
  Vjcex_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_e1)))));
  Vjcex_Vc1_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vc1_c2*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vc1_c2+d10_exp0*dxa_Vc1_c2_Vb2_c1)))));
#endif
#if defined(_DERIVATE)
Vjcex_Vc4_c1=(Vb1c4_Vc4_c1-(a_VDC*dxa_Vc4_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjcex_Vdt_GND=(-((a_VDC_Vdt_GND*d00_logE1)+(a_VDC*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
Vjcex_Vb1_e1=(-(a_VDC*dxa_Vb1_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb1_e1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb1_b2)))));
  Vjcex_Vb1_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_c2)))));
  Vjcex_Vb1_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vc1_c2)))));
  Vjcex_Vb1_e1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vc4_c1)))));
  Vjcex_Vb1_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vdt_GND)))));
  Vjcex_Vb1_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb1_e1)))));
  Vjcex_Vb1_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_e1)))));
  Vjcex_Vb1_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb1_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb1_e1+d10_exp0*dxa_Vb1_e1_Vb2_c1)))));
#endif
Vjcex_Vb2_e1=(-(a_VDC*dxa_Vb2_e1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_e1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb1_b2)))));
  Vjcex_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c2)))));
  Vjcex_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vc1_c2)))));
  Vjcex_Vb2_e1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vc4_c1)))));
  Vjcex_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vdt_GND)))));
  Vjcex_Vb2_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb1_e1)))));
  Vjcex_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_e1)))));
  Vjcex_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_e1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_e1+d10_exp0*dxa_Vb2_e1_Vb2_c1)))));
#endif
Vjcex_Vb2_c1=(-(a_VDC*dxa_Vb2_c1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_c1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb1_b2)))));
  Vjcex_Vb2_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c2)))));
  Vjcex_Vb2_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vc1_c2)))));
  Vjcex_Vb2_c1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vc4_c1)))));
  Vjcex_Vb2_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vdt_GND)))));
  Vjcex_Vb2_c1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb1_e1)))));
  Vjcex_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_e1)))));
  Vjcex_Vb2_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb2_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb2_c1+d10_exp0*dxa_Vb2_c1_Vb2_c1)))));
#endif
#endif
Vjcex=(Vb1c4-(a_VDC*d00_logE1));
EXIT_IF_ISNAN((Vb1c4-(a_VDC*d00_logE1)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
Vjcex_Vb1_b2=(-(a_VDC*(-dxa_Vb1_b2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb1_b2_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
  Vjcex_Vb1_b2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb1_b2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb1_b2)+d10_exp0*0.0)))));
#endif
Vjcex_Vb2_c2=(-(a_VDC*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_c2_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
  Vjcex_Vb2_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c2)+d10_exp0*0.0)))));
#endif
Vjcex_Vc1_c2=(-(a_VDC*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vc1_c2_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
  Vjcex_Vc1_c2_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vc1_c2)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vc1_c2)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vjcex_Vc4_c1=(-(a_VDC*(-dxa_Vc4_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjcex_Vdt_GND=(Vfc_Vdt_GND-((a_VDC_Vdt_GND*d00_logE1)+(a_VDC*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
Vjcex_Vb1_e1=(-(a_VDC*(-dxa_Vb1_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb1_e1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
  Vjcex_Vb1_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb1_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb1_e1)+d10_exp0*0.0)))));
#endif
Vjcex_Vb2_e1=(-(a_VDC*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_e1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
  Vjcex_Vb2_e1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_e1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_e1)+d10_exp0*0.0)))));
#endif
Vjcex_Vb2_c1=(-(a_VDC*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjcex_Vb2_c1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
  Vjcex_Vb2_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb2_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb2_c1)+d10_exp0*0.0)))));
#endif
#endif
Vjcex=(Vfc-(a_VDC*d00_logE1));
EXIT_IF_ISNAN((Vfc-(a_VDC*d00_logE1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
Vjcex_Vb1_b2=Vjcex_Vb1_b2;
#if defined(_DERIVATE2)
  Vjcex_Vb1_b2_Vb1_b2=Vjcex_Vb1_b2_Vb1_b2;
  Vjcex_Vb1_b2_Vb2_c2=Vjcex_Vb1_b2_Vb2_c2;
  Vjcex_Vb1_b2_Vc1_c2=Vjcex_Vb1_b2_Vc1_c2;
  Vjcex_Vb1_b2_Vc4_c1=Vjcex_Vb1_b2_Vc4_c1;
  Vjcex_Vb1_b2_Vdt_GND=Vjcex_Vb1_b2_Vdt_GND;
  Vjcex_Vb1_b2_Vb1_e1=Vjcex_Vb1_b2_Vb1_e1;
  Vjcex_Vb1_b2_Vb2_e1=Vjcex_Vb1_b2_Vb2_e1;
  Vjcex_Vb1_b2_Vb2_c1=Vjcex_Vb1_b2_Vb2_c1;
#endif
Vjcex_Vb2_c2=Vjcex_Vb2_c2;
#if defined(_DERIVATE2)
  Vjcex_Vb2_c2_Vb1_b2=Vjcex_Vb2_c2_Vb1_b2;
  Vjcex_Vb2_c2_Vb2_c2=Vjcex_Vb2_c2_Vb2_c2;
  Vjcex_Vb2_c2_Vc1_c2=Vjcex_Vb2_c2_Vc1_c2;
  Vjcex_Vb2_c2_Vc4_c1=Vjcex_Vb2_c2_Vc4_c1;
  Vjcex_Vb2_c2_Vdt_GND=Vjcex_Vb2_c2_Vdt_GND;
  Vjcex_Vb2_c2_Vb1_e1=Vjcex_Vb2_c2_Vb1_e1;
  Vjcex_Vb2_c2_Vb2_e1=Vjcex_Vb2_c2_Vb2_e1;
  Vjcex_Vb2_c2_Vb2_c1=Vjcex_Vb2_c2_Vb2_c1;
#endif
Vjcex_Vc1_c2=Vjcex_Vc1_c2;
#if defined(_DERIVATE2)
  Vjcex_Vc1_c2_Vb1_b2=Vjcex_Vc1_c2_Vb1_b2;
  Vjcex_Vc1_c2_Vb2_c2=Vjcex_Vc1_c2_Vb2_c2;
  Vjcex_Vc1_c2_Vc1_c2=Vjcex_Vc1_c2_Vc1_c2;
  Vjcex_Vc1_c2_Vc4_c1=Vjcex_Vc1_c2_Vc4_c1;
  Vjcex_Vc1_c2_Vdt_GND=Vjcex_Vc1_c2_Vdt_GND;
  Vjcex_Vc1_c2_Vb1_e1=Vjcex_Vc1_c2_Vb1_e1;
  Vjcex_Vc1_c2_Vb2_e1=Vjcex_Vc1_c2_Vb2_e1;
  Vjcex_Vc1_c2_Vb2_c1=Vjcex_Vc1_c2_Vb2_c1;
#endif
#if defined(_DERIVATE)
Vjcex_Vc4_c1=Vjcex_Vc4_c1;
#endif
#if defined(_DERIVATE)
Vjcex_Vdt_GND=Vjcex_Vdt_GND;
#endif
Vjcex_Vb1_e1=Vjcex_Vb1_e1;
#if defined(_DERIVATE2)
  Vjcex_Vb1_e1_Vb1_b2=Vjcex_Vb1_e1_Vb1_b2;
  Vjcex_Vb1_e1_Vb2_c2=Vjcex_Vb1_e1_Vb2_c2;
  Vjcex_Vb1_e1_Vc1_c2=Vjcex_Vb1_e1_Vc1_c2;
  Vjcex_Vb1_e1_Vc4_c1=Vjcex_Vb1_e1_Vc4_c1;
  Vjcex_Vb1_e1_Vdt_GND=Vjcex_Vb1_e1_Vdt_GND;
  Vjcex_Vb1_e1_Vb1_e1=Vjcex_Vb1_e1_Vb1_e1;
  Vjcex_Vb1_e1_Vb2_e1=Vjcex_Vb1_e1_Vb2_e1;
  Vjcex_Vb1_e1_Vb2_c1=Vjcex_Vb1_e1_Vb2_c1;
#endif
Vjcex_Vb2_e1=Vjcex_Vb2_e1;
#if defined(_DERIVATE2)
  Vjcex_Vb2_e1_Vb1_b2=Vjcex_Vb2_e1_Vb1_b2;
  Vjcex_Vb2_e1_Vb2_c2=Vjcex_Vb2_e1_Vb2_c2;
  Vjcex_Vb2_e1_Vc1_c2=Vjcex_Vb2_e1_Vc1_c2;
  Vjcex_Vb2_e1_Vc4_c1=Vjcex_Vb2_e1_Vc4_c1;
  Vjcex_Vb2_e1_Vdt_GND=Vjcex_Vb2_e1_Vdt_GND;
  Vjcex_Vb2_e1_Vb1_e1=Vjcex_Vb2_e1_Vb1_e1;
  Vjcex_Vb2_e1_Vb2_e1=Vjcex_Vb2_e1_Vb2_e1;
  Vjcex_Vb2_e1_Vb2_c1=Vjcex_Vb2_e1_Vb2_c1;
#endif
Vjcex_Vb2_c1=Vjcex_Vb2_c1;
#if defined(_DERIVATE2)
  Vjcex_Vb2_c1_Vb1_b2=Vjcex_Vb2_c1_Vb1_b2;
  Vjcex_Vb2_c1_Vb2_c2=Vjcex_Vb2_c1_Vb2_c2;
  Vjcex_Vb2_c1_Vc1_c2=Vjcex_Vb2_c1_Vc1_c2;
  Vjcex_Vb2_c1_Vc4_c1=Vjcex_Vb2_c1_Vc4_c1;
  Vjcex_Vb2_c1_Vdt_GND=Vjcex_Vb2_c1_Vdt_GND;
  Vjcex_Vb2_c1_Vb1_e1=Vjcex_Vb2_c1_Vb1_e1;
  Vjcex_Vb2_c1_Vb2_e1=Vjcex_Vb2_c1_Vb2_e1;
  Vjcex_Vb2_c1_Vb2_c1=Vjcex_Vb2_c1_Vb2_c1;
#endif
#endif
Vjcex=Vjcex;
EXIT_IF_ISNAN(Vjcex)
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1.0-(Vjcex/VDC_T)),(1.0-pModel->PC))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vjcex/VDC_T)),(1.0-pModel->PC))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND) */
#if defined(_DERIVATE)
Vtexv_Vdt_GND=((((VDC_T_Vdt_GND/(1.0-pModel->PC))*(1.0-d00_pow0))+((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))))+((bjc_Vdt_GND*(Vb1c4-Vjcex))+(bjc*(-Vjcex_Vdt_GND))));
#endif
Vtexv_Vb1_b2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T)))))+(bjc*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)));
#if defined(_DERIVATE2)
  Vtexv_Vb1_b2_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+0.0-Vjcex_Vb1_b2_Vdt_GND)));
  Vtexv_Vb1_b2_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+Vb1c4_Vb1_b2_Vb1_b2-Vjcex_Vb1_b2_Vb1_b2)));
  Vtexv_Vb1_b2_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+Vb1c4_Vb1_b2_Vb2_c2-Vjcex_Vb1_b2_Vb2_c2)));
  Vtexv_Vb1_b2_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+Vb1c4_Vb1_b2_Vc1_c2-Vjcex_Vb1_b2_Vc1_c2)));
  Vtexv_Vb1_b2_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+Vb1c4_Vb1_b2_Vc4_c1-Vjcex_Vb1_b2_Vc4_c1)));
  Vtexv_Vb1_b2_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+0.0-Vjcex_Vb1_b2_Vb1_e1)));
  Vtexv_Vb1_b2_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+0.0-Vjcex_Vb1_b2_Vb2_e1)));
  Vtexv_Vb1_b2_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+bjc*(+0.0-Vjcex_Vb1_b2_Vb2_c1)));
#endif
Vtexv_Vb2_c2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T)))))+(bjc*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)));
#if defined(_DERIVATE2)
  Vtexv_Vb2_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+0.0-Vjcex_Vb2_c2_Vdt_GND)));
  Vtexv_Vb2_c2_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+Vb1c4_Vb2_c2_Vb1_b2-Vjcex_Vb2_c2_Vb1_b2)));
  Vtexv_Vb2_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+Vb1c4_Vb2_c2_Vb2_c2-Vjcex_Vb2_c2_Vb2_c2)));
  Vtexv_Vb2_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+Vb1c4_Vb2_c2_Vc1_c2-Vjcex_Vb2_c2_Vc1_c2)));
  Vtexv_Vb2_c2_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+Vb1c4_Vb2_c2_Vc4_c1-Vjcex_Vb2_c2_Vc4_c1)));
  Vtexv_Vb2_c2_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+0.0-Vjcex_Vb2_c2_Vb1_e1)));
  Vtexv_Vb2_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+0.0-Vjcex_Vb2_c2_Vb2_e1)));
  Vtexv_Vb2_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+bjc*(+0.0-Vjcex_Vb2_c2_Vb2_c1)));
#endif
Vtexv_Vc1_c2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T)))))+(bjc*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)));
#if defined(_DERIVATE2)
  Vtexv_Vc1_c2_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+0.0-Vjcex_Vc1_c2_Vdt_GND)));
  Vtexv_Vc1_c2_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+Vb1c4_Vc1_c2_Vb1_b2-Vjcex_Vc1_c2_Vb1_b2)));
  Vtexv_Vc1_c2_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+Vb1c4_Vc1_c2_Vb2_c2-Vjcex_Vc1_c2_Vb2_c2)));
  Vtexv_Vc1_c2_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+Vb1c4_Vc1_c2_Vc1_c2-Vjcex_Vc1_c2_Vc1_c2)));
  Vtexv_Vc1_c2_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+Vb1c4_Vc1_c2_Vc4_c1-Vjcex_Vc1_c2_Vc4_c1)));
  Vtexv_Vc1_c2_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+0.0-Vjcex_Vc1_c2_Vb1_e1)));
  Vtexv_Vc1_c2_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+0.0-Vjcex_Vc1_c2_Vb2_e1)));
  Vtexv_Vc1_c2_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+bjc*(+0.0-Vjcex_Vc1_c2_Vb2_c1)));
#endif
#if defined(_DERIVATE)
Vtexv_Vc4_c1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T)))))+(bjc*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)));
#endif
Vtexv_Vb1_e1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T)))))+(bjc*(-Vjcex_Vb1_e1)));
#if defined(_DERIVATE2)
  Vtexv_Vb1_e1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vdt_GND)));
  Vtexv_Vb1_e1_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vb1_b2)));
  Vtexv_Vb1_e1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vb2_c2)));
  Vtexv_Vb1_e1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vc1_c2)));
  Vtexv_Vb1_e1_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vc4_c1)));
  Vtexv_Vb1_e1_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vb1_e1)));
  Vtexv_Vb1_e1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vb2_e1)));
  Vtexv_Vb1_e1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(-Vjcex_Vb1_e1)+bjc*(+0.0-Vjcex_Vb1_e1_Vb2_c1)));
#endif
Vtexv_Vb2_e1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T)))))+(bjc*(-Vjcex_Vb2_e1)));
#if defined(_DERIVATE2)
  Vtexv_Vb2_e1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vdt_GND)));
  Vtexv_Vb2_e1_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vb1_b2)));
  Vtexv_Vb2_e1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vb2_c2)));
  Vtexv_Vb2_e1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vc1_c2)));
  Vtexv_Vb2_e1_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vc4_c1)));
  Vtexv_Vb2_e1_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vb1_e1)));
  Vtexv_Vb2_e1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vb2_e1)));
  Vtexv_Vb2_e1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(-Vjcex_Vb2_e1)+bjc*(+0.0-Vjcex_Vb2_e1_Vb2_c1)));
#endif
Vtexv_Vb2_c1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T)))))+(bjc*(-Vjcex_Vb2_c1)));
#if defined(_DERIVATE2)
  Vtexv_Vb2_c1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjcex_Vdt_GND*VDC_T-Vjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vdt_GND)+bjc_Vdt_GND*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vdt_GND)));
  Vtexv_Vb2_c1_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb1_b2-Vjcex_Vb1_b2)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vb1_b2)));
  Vtexv_Vb2_c1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vb2_c2-Vjcex_Vb2_c2)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vb2_c2)));
  Vtexv_Vb2_c1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc1_c2-Vjcex_Vc1_c2)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vc1_c2)));
  Vtexv_Vb2_c1_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(Vb1c4_Vc4_c1-Vjcex_Vc4_c1)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vc4_c1)));
  Vtexv_Vb2_c1_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb1_e1)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vb1_e1)));
  Vtexv_Vb2_c1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_e1)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vb2_e1)));
  Vtexv_Vb2_c1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(Vjcex_Vb2_c1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vb1c4-Vjcex)+0.0*(-Vjcex_Vb2_c1)+0.0*(-Vjcex_Vb2_c1)+bjc*(+0.0-Vjcex_Vb2_c1_Vb2_c1)));
#endif
#endif
Vtexv=(((VDC_T/(1.0-pModel->PC))*(1.0-d00_pow0))+(bjc*(Vb1c4-Vjcex)));
EXIT_IF_ISNAN((((VDC_T/(1.0-pModel->PC))*(1.0-d00_pow0))+(bjc*(Vb1c4-Vjcex))))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Qtex_Vdt_GND=((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND))+XP_T_Vdt_GND*Vb1c4)))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#endif
Qtex_Vb1_b2=(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vb1_b2_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*Vb1c4_Vb1_b2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb1_b2+XP_T*Vb1c4_Vb1_b2_Vb1_b2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb1_b2+XP_T*Vb1c4_Vb1_b2_Vb2_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb1_b2+XP_T*Vb1c4_Vb1_b2_Vc1_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb1_b2+XP_T*Vb1c4_Vb1_b2_Vc4_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_b2_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vb1_b2+(1.0-XP_T)*Vtexv_Vb1_b2_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb1_b2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb1_b2)+(XP_T*Vb1c4_Vb1_b2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
Qtex_Vb2_c2=(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vb2_c2_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*Vb1c4_Vb2_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vb2_c2+XP_T*Vb1c4_Vb2_c2_Vb1_b2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vb2_c2+XP_T*Vb1c4_Vb2_c2_Vb2_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vb2_c2+XP_T*Vb1c4_Vb2_c2_Vc1_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vb2_c2+XP_T*Vb1c4_Vb2_c2_Vc4_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c2_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vb2_c2+(1.0-XP_T)*Vtexv_Vb2_c2_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vb2_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vb2_c2)+(XP_T*Vb1c4_Vb2_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
Qtex_Vc1_c2=(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vc1_c2_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*Vb1c4_Vc1_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*Vb1c4_Vc1_c2+XP_T*Vb1c4_Vc1_c2_Vb1_b2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*Vb1c4_Vc1_c2+XP_T*Vb1c4_Vc1_c2_Vb2_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*Vb1c4_Vc1_c2+XP_T*Vb1c4_Vc1_c2_Vc1_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*Vb1c4_Vc1_c2+XP_T*Vb1c4_Vc1_c2_Vc4_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vc1_c2_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2))+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vc1_c2+(1.0-XP_T)*Vtexv_Vc1_c2_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*Vb1c4_Vc1_c2+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*(((1.0-XP_T)*Vtexv_Vc1_c2)+(XP_T*Vb1c4_Vc1_c2)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
#if defined(_DERIVATE)
Qtex_Vc4_c1=(CJC_TM*(((1.0-XP_T)*Vtexv_Vc4_c1)+(XP_T*Vb1c4_Vc4_c1)))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#endif
Qtex_Vb1_e1=(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vb1_e1_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb1_e1_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb1_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vb1_e1+(1.0-XP_T)*Vtexv_Vb1_e1_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb1_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
Qtex_Vb2_e1=(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vb2_e1_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_e1_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_e1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vb2_e1+(1.0-XP_T)*Vtexv_Vb2_e1_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_e1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
Qtex_Vb2_c1=(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qtex_Vb2_c1_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4))+CJC_TM_Vdt_GND*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vdt_GND+(-XP_T_Vdt_GND)*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vdt_GND)+(+0.0*Vb1c4+0.0*0.0+XP_T_Vdt_GND*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))+(CJC_TM*(((((-XP_T_Vdt_GND)*Vtexv)+((1.0-XP_T)*Vtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vb1c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_b2+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vb1_b2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb1_b2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_b2))+((XP_T*Vb1c4_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c2+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vb2_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vb2_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c2))+((XP_T*Vb1c4_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc1_c2+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vc1_c2)+(+0.0*Vb1c4+0.0*Vb1c4_Vc1_c2+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc1_c2))+((XP_T*Vb1c4_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vc4_c1+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vc4_c1)+(+0.0*Vb1c4+0.0*Vb1c4_Vc4_c1+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vc4_c1))+((XP_T*Vb1c4_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb1_e1+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vb1_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_e1+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vb2_e1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
  Qtex_Vb2_c1_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4))+0.0*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))+0.0*((1.0-XP_T)*Vtexv_Vb2_c1)+CJC_TM*(+(+(+0.0-0.0)*Vtexv+0.0*Vtexv_Vb2_c1+0.0*Vtexv_Vb2_c1+(1.0-XP_T)*Vtexv_Vb2_c1_Vb2_c1)+(+0.0*Vb1c4+0.0*0.0+0.0*0.0+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*0.0+((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(+0.0-0.0))*(1.0-pModel->XEXT)+(CJC_TM*((1.0-XP_T)*Vtexv_Vb2_c1))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*Vtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(+0.0-0.0));
#endif
#endif
Qtex=(((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(1.0-pModel->XEXT));
EXIT_IF_ISNAN((((CJC_TM*(((1.0-XP_T)*Vtexv)+(XP_T*Vb1c4)))*(1.0-pModel->XCJC))*(1.0-pModel->XEXT)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=0.0;
  dxa_Vs_c1_Vb_c=0.0;
  dxa_Vs_c1_Vb_b1=0.0;
  dxa_Vs_c1_Vc3_c1=0.0;
  dxa_Vs_c1_Vc3_c4=0.0;
  dxa_Vs_c1_Vb1_b2=0.0;
  dxa_Vs_c1_Vc4_c1=0.0;
  dxa_Vs_c1_Vb1_e1=0.0;
  dxa_Vs_c1_Vb2_e1=0.0;
  dxa_Vs_c1_Vb2_c2=0.0;
  dxa_Vs_c1_Vb2_c1=0.0;
  dxa_Vs_c1_Vc1_c2=0.0;
  dxa_Vs_c1_Vdt_GND=0.0;
#endif
dxa_Vb_c=(Vbc3_Vb_c/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_c*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb_c=((+Vbc3_Vb_c_Vb_c-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb_b1=((+Vbc3_Vb_c_Vb_b1-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vc3_c1=((+Vbc3_Vb_c_Vc3_c1-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vc3_c4=((+Vbc3_Vb_c_Vc3_c4-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb1_b2=((+Vbc3_Vb_c_Vb1_b2-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vc4_c1=((+Vbc3_Vb_c_Vc4_c1-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_c*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_c*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb2_c2=((+Vbc3_Vb_c_Vb2_c2-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_c*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vc1_c2=((+Vbc3_Vb_c_Vc1_c2-0.0)/a_VDC-(Vbc3_Vb_c*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_c_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vb_c*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vb_b1=(Vbc3_Vb_b1/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb_c=((+Vbc3_Vb_b1_Vb_c-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb_b1=((+Vbc3_Vb_b1_Vb_b1-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vc3_c1=((+Vbc3_Vb_b1_Vc3_c1-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vc3_c4=((+Vbc3_Vb_b1_Vc3_c4-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb1_b2=((+Vbc3_Vb_b1_Vb1_b2-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vc4_c1=((+Vbc3_Vb_b1_Vc4_c1-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb2_c2=((+Vbc3_Vb_b1_Vb2_c2-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vc1_c2=((+Vbc3_Vb_b1_Vc1_c2-0.0)/a_VDC-(Vbc3_Vb_b1*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb_b1_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vb_b1*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vc3_c1=(Vbc3_Vc3_c1/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb_c=((+Vbc3_Vc3_c1_Vb_c-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb_b1=((+Vbc3_Vc3_c1_Vb_b1-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vc3_c1=((+Vbc3_Vc3_c1_Vc3_c1-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vc3_c4=((+Vbc3_Vc3_c1_Vc3_c4-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb1_b2=((+Vbc3_Vc3_c1_Vb1_b2-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vc4_c1=((+Vbc3_Vc3_c1_Vc4_c1-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb2_c2=((+Vbc3_Vc3_c1_Vb2_c2-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vc1_c2=((+Vbc3_Vc3_c1_Vc1_c2-0.0)/a_VDC-(Vbc3_Vc3_c1*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc3_c1_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vc3_c1*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=(Vbc3_Vc3_c4/a_VDC);
#endif
dxa_Vb1_b2=(Vbc3_Vb1_b2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb_c=((+Vbc3_Vb1_b2_Vb_c-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb_b1=((+Vbc3_Vb1_b2_Vb_b1-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc3_c1=((+Vbc3_Vb1_b2_Vc3_c1-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc3_c4=((+Vbc3_Vb1_b2_Vc3_c4-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb1_b2=((+Vbc3_Vb1_b2_Vb1_b2-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc4_c1=((+Vbc3_Vb1_b2_Vc4_c1-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_c2=((+Vbc3_Vb1_b2_Vb2_c2-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vc1_c2=((+Vbc3_Vb1_b2_Vc1_c2-0.0)/a_VDC-(Vbc3_Vb1_b2*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb1_b2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vb1_b2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vc4_c1=(Vbc3_Vc4_c1/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb_c=((+Vbc3_Vc4_c1_Vb_c-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb_b1=((+Vbc3_Vc4_c1_Vb_b1-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc3_c1=((+Vbc3_Vc4_c1_Vc3_c1-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc3_c4=((+Vbc3_Vc4_c1_Vc3_c4-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb1_b2=((+Vbc3_Vc4_c1_Vb1_b2-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc4_c1=((+Vbc3_Vc4_c1_Vc4_c1-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_c2=((+Vbc3_Vc4_c1_Vb2_c2-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vc1_c2=((+Vbc3_Vc4_c1_Vc1_c2-0.0)/a_VDC-(Vbc3_Vc4_c1*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc4_c1_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vc4_c1*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=(Vbc3_Vb2_c2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb_c=((+Vbc3_Vb2_c2_Vb_c-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb_b1=((+Vbc3_Vb2_c2_Vb_b1-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc3_c1=((+Vbc3_Vb2_c2_Vc3_c1-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc3_c4=((+Vbc3_Vb2_c2_Vc3_c4-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb1_b2=((+Vbc3_Vb2_c2_Vb1_b2-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc4_c1=((+Vbc3_Vb2_c2_Vc4_c1-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_c2=((+Vbc3_Vb2_c2_Vb2_c2-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vc1_c2=((+Vbc3_Vb2_c2_Vc1_c2-0.0)/a_VDC-(Vbc3_Vb2_c2*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vb2_c2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vb2_c2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=(Vbc3_Vc1_c2/a_VDC);
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb_c=((+Vbc3_Vc1_c2_Vb_c-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vb_c*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb_b1=((+Vbc3_Vc1_c2_Vb_b1-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vb_b1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc3_c1=((+Vbc3_Vc1_c2_Vc3_c1-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vc3_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc3_c4=((+Vbc3_Vc1_c2_Vc3_c4-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vc3_c4*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb1_b2=((+Vbc3_Vc1_c2_Vb1_b2-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vb1_b2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc4_c1=((+Vbc3_Vc1_c2_Vc4_c1-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vc4_c1*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb1_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_e1=((+0.0-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_c2=((+Vbc3_Vc1_c2_Vb2_c2-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vb2_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vb2_c1=((+0.0-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+0.0*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vc1_c2=((+Vbc3_Vc1_c2_Vc1_c2-0.0)/a_VDC-(Vbc3_Vc1_c2*0.0+Vbc3_Vc1_c2*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*0.0/a_VDC/a_VDC/a_VDC);
  dxa_Vc1_c2_Vdt_GND=((+0.0-0.0)/a_VDC-(Vbc3_Vc1_c2*a_VDC_Vdt_GND+(-Vfc_Vdt_GND)*0.0+(Vbc3-Vfc)*0.0)/a_VDC/a_VDC+2*(Vbc3-Vfc)*0.0*a_VDC_Vdt_GND/a_VDC/a_VDC/a_VDC);
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-Vfc_Vdt_GND)*a_VDC-(Vbc3-Vfc)*a_VDC_Vdt_GND)/a_VDC/a_VDC);
#endif
#endif
dxa=((Vbc3-Vfc)/a_VDC);
EXIT_IF_ISNAN(((Vbc3-Vfc)/a_VDC))
#endif
#ifdef _DYNAMIC
if
((Vbc3<Vfc))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b,GND) */
XVjcex_Vb_c=(Vbc3_Vb_c-(a_VDC*dxa_Vb_c*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  XVjcex_Vb_c_Vb_c=(+Vbc3_Vb_c_Vb_c-(+0.0*d00_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb_c*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_c*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb_c)))));
  XVjcex_Vb_c_Vb_b1=(+Vbc3_Vb_c_Vb_b1-(+0.0*d00_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb_b1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_b1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb_b1)))));
  XVjcex_Vb_c_Vb1_b2=(+Vbc3_Vb_c_Vb1_b2-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb1_b2)))));
  XVjcex_Vb_c_Vb2_c2=(+Vbc3_Vb_c_Vb2_c2-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb2_c2)))));
  XVjcex_Vb_c_Vc1_c2=(+Vbc3_Vb_c_Vc1_c2-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vc1_c2)))));
  XVjcex_Vb_c_Vc4_c1=(+Vbc3_Vb_c_Vc4_c1-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vc4_c1)))));
  XVjcex_Vb_c_Vc3_c1=(+Vbc3_Vb_c_Vc3_c1-(+0.0*d00_logE1+0.0*dxa_Vc3_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vc3_c1)))));
  XVjcex_Vb_c_Vc3_c4=(+Vbc3_Vb_c_Vc3_c4-(+0.0*d00_logE1+0.0*dxa_Vc3_c4*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c4*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c4*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vc3_c4)))));
  XVjcex_Vb_c_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vdt_GND)))));
  XVjcex_Vb_c_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb1_e1)))));
  XVjcex_Vb_c_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb2_e1)))));
  XVjcex_Vb_c_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb_c*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb_c+d10_exp0*dxa_Vb_c_Vb2_c1)))));
#endif
XVjcex_Vb_b1=(Vbc3_Vb_b1-(a_VDC*dxa_Vb_b1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  XVjcex_Vb_b1_Vb_c=(+Vbc3_Vb_b1_Vb_c-(+0.0*d00_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb_c*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_c*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb_c)))));
  XVjcex_Vb_b1_Vb_b1=(+Vbc3_Vb_b1_Vb_b1-(+0.0*d00_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb_b1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_b1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb_b1)))));
  XVjcex_Vb_b1_Vb1_b2=(+Vbc3_Vb_b1_Vb1_b2-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb1_b2)))));
  XVjcex_Vb_b1_Vb2_c2=(+Vbc3_Vb_b1_Vb2_c2-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb2_c2)))));
  XVjcex_Vb_b1_Vc1_c2=(+Vbc3_Vb_b1_Vc1_c2-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vc1_c2)))));
  XVjcex_Vb_b1_Vc4_c1=(+Vbc3_Vb_b1_Vc4_c1-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vc4_c1)))));
  XVjcex_Vb_b1_Vc3_c1=(+Vbc3_Vb_b1_Vc3_c1-(+0.0*d00_logE1+0.0*dxa_Vc3_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vc3_c1)))));
  XVjcex_Vb_b1_Vc3_c4=(+Vbc3_Vb_b1_Vc3_c4-(+0.0*d00_logE1+0.0*dxa_Vc3_c4*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c4*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c4*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vc3_c4)))));
  XVjcex_Vb_b1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDC_Vdt_GND*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vdt_GND)))));
  XVjcex_Vb_b1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb1_e1)))));
  XVjcex_Vb_b1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb2_e1)))));
  XVjcex_Vb_b1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vb_b1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vb_b1+d10_exp0*dxa_Vb_b1_Vb2_c1)))));
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_b2=(Vbc3_Vb1_b2-(a_VDC*dxa_Vb1_b2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c2=(Vbc3_Vb2_c2-(a_VDC*dxa_Vb2_c2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc1_c2=(Vbc3_Vc1_c2-(a_VDC*dxa_Vc1_c2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc4_c1=(Vbc3_Vc4_c1-(a_VDC*dxa_Vc4_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c1=(Vbc3_Vc3_c1-(a_VDC*dxa_Vc3_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c4=(Vbc3_Vc3_c4-(a_VDC*dxa_Vc3_c4*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vdt_GND=(-((a_VDC_Vdt_GND*d00_logE1)+(a_VDC*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_e1=(-(a_VDC*dxa_Vb1_e1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_e1=(-(a_VDC*dxa_Vb2_e1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c1=(-(a_VDC*dxa_Vb2_c1*d10_exp0*d10_logE1));
#endif
#endif
XVjcex=(Vbc3-(a_VDC*d00_logE1));
EXIT_IF_ISNAN((Vbc3-(a_VDC*d00_logE1)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b,GND) */
XVjcex_Vb_c=(-(a_VDC*(-dxa_Vb_c)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  XVjcex_Vb_c_Vb_c=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_c)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_c)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb_b1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_b1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_b1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vc3_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vc3_c4=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c4)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c4)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c4)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
  XVjcex_Vb_c_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb_c)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb_c)+d10_exp0*0.0)))));
#endif
XVjcex_Vb_b1=(-(a_VDC*(-dxa_Vb_b1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  XVjcex_Vb_b1_Vb_c=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_c)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_c)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb_b1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_b1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_b1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vc3_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vc3_c4=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c4)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c4)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c4)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDC_Vdt_GND*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
  XVjcex_Vb_b1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+a_VDC*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vb_b1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vb_b1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_b2=(-(a_VDC*(-dxa_Vb1_b2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c2=(-(a_VDC*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc1_c2=(-(a_VDC*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc4_c1=(-(a_VDC*(-dxa_Vc4_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c1=(-(a_VDC*(-dxa_Vc3_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c4=(-(a_VDC*(-dxa_Vc3_c4)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vdt_GND=(Vfc_Vdt_GND-((a_VDC_Vdt_GND*d00_logE1)+(a_VDC*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_e1=(-(a_VDC*(-dxa_Vb1_e1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_e1=(-(a_VDC*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c1=(-(a_VDC*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#endif
#endif
XVjcex=(Vfc-(a_VDC*d00_logE1));
EXIT_IF_ISNAN((Vfc-(a_VDC*d00_logE1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b,GND) */
XVjcex_Vb_c=XVjcex_Vb_c;
#if defined(_DERIVATE2)
  XVjcex_Vb_c_Vb_c=XVjcex_Vb_c_Vb_c;
  XVjcex_Vb_c_Vb_b1=XVjcex_Vb_c_Vb_b1;
  XVjcex_Vb_c_Vb1_b2=XVjcex_Vb_c_Vb1_b2;
  XVjcex_Vb_c_Vb2_c2=XVjcex_Vb_c_Vb2_c2;
  XVjcex_Vb_c_Vc1_c2=XVjcex_Vb_c_Vc1_c2;
  XVjcex_Vb_c_Vc4_c1=XVjcex_Vb_c_Vc4_c1;
  XVjcex_Vb_c_Vc3_c1=XVjcex_Vb_c_Vc3_c1;
  XVjcex_Vb_c_Vc3_c4=XVjcex_Vb_c_Vc3_c4;
  XVjcex_Vb_c_Vdt_GND=XVjcex_Vb_c_Vdt_GND;
  XVjcex_Vb_c_Vb1_e1=XVjcex_Vb_c_Vb1_e1;
  XVjcex_Vb_c_Vb2_e1=XVjcex_Vb_c_Vb2_e1;
  XVjcex_Vb_c_Vb2_c1=XVjcex_Vb_c_Vb2_c1;
#endif
XVjcex_Vb_b1=XVjcex_Vb_b1;
#if defined(_DERIVATE2)
  XVjcex_Vb_b1_Vb_c=XVjcex_Vb_b1_Vb_c;
  XVjcex_Vb_b1_Vb_b1=XVjcex_Vb_b1_Vb_b1;
  XVjcex_Vb_b1_Vb1_b2=XVjcex_Vb_b1_Vb1_b2;
  XVjcex_Vb_b1_Vb2_c2=XVjcex_Vb_b1_Vb2_c2;
  XVjcex_Vb_b1_Vc1_c2=XVjcex_Vb_b1_Vc1_c2;
  XVjcex_Vb_b1_Vc4_c1=XVjcex_Vb_b1_Vc4_c1;
  XVjcex_Vb_b1_Vc3_c1=XVjcex_Vb_b1_Vc3_c1;
  XVjcex_Vb_b1_Vc3_c4=XVjcex_Vb_b1_Vc3_c4;
  XVjcex_Vb_b1_Vdt_GND=XVjcex_Vb_b1_Vdt_GND;
  XVjcex_Vb_b1_Vb1_e1=XVjcex_Vb_b1_Vb1_e1;
  XVjcex_Vb_b1_Vb2_e1=XVjcex_Vb_b1_Vb2_e1;
  XVjcex_Vb_b1_Vb2_c1=XVjcex_Vb_b1_Vb2_c1;
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_b2=XVjcex_Vb1_b2;
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c2=XVjcex_Vb2_c2;
#endif
#if defined(_DERIVATE)
XVjcex_Vc1_c2=XVjcex_Vc1_c2;
#endif
#if defined(_DERIVATE)
XVjcex_Vc4_c1=XVjcex_Vc4_c1;
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c1=XVjcex_Vc3_c1;
#endif
#if defined(_DERIVATE)
XVjcex_Vc3_c4=XVjcex_Vc3_c4;
#endif
#if defined(_DERIVATE)
XVjcex_Vdt_GND=XVjcex_Vdt_GND;
#endif
#if defined(_DERIVATE)
XVjcex_Vb1_e1=XVjcex_Vb1_e1;
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_e1=XVjcex_Vb2_e1;
#endif
#if defined(_DERIVATE)
XVjcex_Vb2_c1=XVjcex_Vb2_c1;
#endif
#endif
XVjcex=XVjcex;
EXIT_IF_ISNAN(XVjcex)
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1.0-(XVjcex/VDC_T)),(1.0-pModel->PC))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(XVjcex/VDC_T)),(1.0-pModel->PC))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XVtexv_Vdt_GND=((((VDC_T_Vdt_GND/(1.0-pModel->PC))*(1.0-d00_pow0))+((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-((XVjcex_Vdt_GND*VDC_T-XVjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))))+((bjc_Vdt_GND*(Vbc3-XVjcex))+(bjc*(-XVjcex_Vdt_GND))));
#endif
XVtexv_Vb_c=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T)))))+(bjc*(Vbc3_Vb_c-XVjcex_Vb_c)));
#if defined(_DERIVATE2)
  XVtexv_Vb_c_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((XVjcex_Vdt_GND*VDC_T-XVjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vdt_GND)+bjc_Vdt_GND*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+0.0-XVjcex_Vb_c_Vdt_GND)));
  XVtexv_Vb_c_Vb_c=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vb_c-XVjcex_Vb_c_Vb_c)));
  XVtexv_Vb_c_Vb_b1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vb_b1-XVjcex_Vb_c_Vb_b1)));
  XVtexv_Vb_c_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb1_b2-XVjcex_Vb1_b2)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vb1_b2-XVjcex_Vb_c_Vb1_b2)));
  XVtexv_Vb_c_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb2_c2-XVjcex_Vb2_c2)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vb2_c2-XVjcex_Vb_c_Vb2_c2)));
  XVtexv_Vb_c_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc1_c2-XVjcex_Vc1_c2)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vc1_c2-XVjcex_Vb_c_Vc1_c2)));
  XVtexv_Vb_c_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc4_c1-XVjcex_Vc4_c1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vc4_c1-XVjcex_Vb_c_Vc4_c1)));
  XVtexv_Vb_c_Vc3_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc3_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc3_c1-XVjcex_Vc3_c1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vc3_c1-XVjcex_Vb_c_Vc3_c1)));
  XVtexv_Vb_c_Vc3_c4=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc3_c4/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc3_c4-XVjcex_Vc3_c4)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+Vbc3_Vb_c_Vc3_c4-XVjcex_Vb_c_Vc3_c4)));
  XVtexv_Vb_c_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb1_e1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+0.0-XVjcex_Vb_c_Vb1_e1)));
  XVtexv_Vb_c_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb2_e1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+0.0-XVjcex_Vb_c_Vb2_e1)));
  XVtexv_Vb_c_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb2_c1)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+bjc*(+0.0-XVjcex_Vb_c_Vb2_c1)));
#endif
XVtexv_Vb_b1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T)))))+(bjc*(Vbc3_Vb_b1-XVjcex_Vb_b1)));
#if defined(_DERIVATE2)
  XVtexv_Vb_b1_Vdt_GND=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+VDC_T_Vdt_GND*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((XVjcex_Vdt_GND*VDC_T-XVjcex*VDC_T_Vdt_GND)/VDC_T/VDC_T))))+(VDC_T_Vdt_GND/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vdt_GND)+bjc_Vdt_GND*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+0.0-XVjcex_Vb_b1_Vdt_GND)));
  XVtexv_Vb_b1_Vb_c=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb_c/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb_c-XVjcex_Vb_c)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vb_c-XVjcex_Vb_b1_Vb_c)));
  XVtexv_Vb_b1_Vb_b1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vb_b1-XVjcex_Vb_b1_Vb_b1)));
  XVtexv_Vb_b1_Vb1_b2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb1_b2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb1_b2-XVjcex_Vb1_b2)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vb1_b2-XVjcex_Vb_b1_Vb1_b2)));
  XVtexv_Vb_b1_Vb2_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_c2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vb2_c2-XVjcex_Vb2_c2)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vb2_c2-XVjcex_Vb_b1_Vb2_c2)));
  XVtexv_Vb_b1_Vc1_c2=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc1_c2/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc1_c2-XVjcex_Vc1_c2)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vc1_c2-XVjcex_Vb_b1_Vc1_c2)));
  XVtexv_Vb_b1_Vc4_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc4_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc4_c1-XVjcex_Vc4_c1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vc4_c1-XVjcex_Vb_b1_Vc4_c1)));
  XVtexv_Vb_b1_Vc3_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc3_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc3_c1-XVjcex_Vc3_c1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vc3_c1-XVjcex_Vb_b1_Vc3_c1)));
  XVtexv_Vb_b1_Vc3_c4=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vc3_c4/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(Vbc3_Vc3_c4-XVjcex_Vc3_c4)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+Vbc3_Vb_b1_Vc3_c4-XVjcex_Vb_b1_Vc3_c4)));
  XVtexv_Vb_b1_Vb1_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb1_e1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb1_e1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+0.0-XVjcex_Vb_b1_Vb1_e1)));
  XVtexv_Vb_b1_Vb2_e1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_e1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb2_e1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+0.0-XVjcex_Vb_b1_Vb2_e1)));
  XVtexv_Vb_b1_Vb2_c1=(+(+(0.0/(1.0-pModel->PC)-(0.0*0.0+0.0*0.0+VDC_T*(+0.0-0.0))/(1.0-pModel->PC)/(1.0-pModel->PC)+2*VDC_T*0.0*0.0/(1.0-pModel->PC)/(1.0-pModel->PC)/(1.0-pModel->PC))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(XVjcex_Vb2_c1/VDC_T))))+0.0*(-(d10_pow0*(-(XVjcex_Vb_b1/VDC_T))))+(VDC_T/(1.0-pModel->PC))*(+0.0-fixme))+(+0.0*(Vbc3-XVjcex)+0.0*(-XVjcex_Vb2_c1)+0.0*(Vbc3_Vb_b1-XVjcex_Vb_b1)+bjc*(+0.0-XVjcex_Vb_b1_Vb2_c1)));
#endif
#if defined(_DERIVATE)
XVtexv_Vb1_b2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb1_b2/VDC_T)))))+(bjc*(Vbc3_Vb1_b2-XVjcex_Vb1_b2)));
#endif
#if defined(_DERIVATE)
XVtexv_Vb2_c2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb2_c2/VDC_T)))))+(bjc*(Vbc3_Vb2_c2-XVjcex_Vb2_c2)));
#endif
#if defined(_DERIVATE)
XVtexv_Vc1_c2=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vc1_c2/VDC_T)))))+(bjc*(Vbc3_Vc1_c2-XVjcex_Vc1_c2)));
#endif
#if defined(_DERIVATE)
XVtexv_Vc4_c1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vc4_c1/VDC_T)))))+(bjc*(Vbc3_Vc4_c1-XVjcex_Vc4_c1)));
#endif
#if defined(_DERIVATE)
XVtexv_Vc3_c1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vc3_c1/VDC_T)))))+(bjc*(Vbc3_Vc3_c1-XVjcex_Vc3_c1)));
#endif
#if defined(_DERIVATE)
XVtexv_Vc3_c4=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vc3_c4/VDC_T)))))+(bjc*(Vbc3_Vc3_c4-XVjcex_Vc3_c4)));
#endif
#if defined(_DERIVATE)
XVtexv_Vb1_e1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb1_e1/VDC_T)))))+(bjc*(-XVjcex_Vb1_e1)));
#endif
#if defined(_DERIVATE)
XVtexv_Vb2_e1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb2_e1/VDC_T)))))+(bjc*(-XVjcex_Vb2_e1)));
#endif
#if defined(_DERIVATE)
XVtexv_Vb2_c1=(((VDC_T/(1.0-pModel->PC))*(-(d10_pow0*(-(XVjcex_Vb2_c1/VDC_T)))))+(bjc*(-XVjcex_Vb2_c1)));
#endif
#endif
XVtexv=(((VDC_T/(1.0-pModel->PC))*(1.0-d00_pow0))+(bjc*(Vbc3-XVjcex)));
EXIT_IF_ISNAN((((VDC_T/(1.0-pModel->PC))*(1.0-d00_pow0))+(bjc*(Vbc3-XVjcex))))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(b1,e1)V(b2,e1)V(b2,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XQtex_Vdt_GND=((CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))+(CJC_TM*((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND))+XP_T_Vdt_GND*Vbc3)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
XQtex_Vb_c=(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*pModel->XEXT;
#if defined(_DERIVATE2)
  XQtex_Vb_c_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3))+CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vdt_GND+(-XP_T_Vdt_GND)*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vdt_GND)+(+0.0*Vbc3+0.0*0.0+XP_T_Vdt_GND*Vbc3_Vb_c+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))+(CJC_TM*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))+(CJC_TM*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb_c=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb_c+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb_c)+(+0.0*Vbc3+0.0*Vbc3_Vb_c+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vb_c)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb_b1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb_b1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb_b1)+(+0.0*Vbc3+0.0*Vbc3_Vb_b1+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vb_b1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb1_b2+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb1_b2)+(+0.0*Vbc3+0.0*Vbc3_Vb1_b2+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vb1_b2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_c2+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb2_c2)+(+0.0*Vbc3+0.0*Vbc3_Vb2_c2+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vb2_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc1_c2+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vc1_c2)+(+0.0*Vbc3+0.0*Vbc3_Vc1_c2+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vc1_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc4_c1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vc4_c1)+(+0.0*Vbc3+0.0*Vbc3_Vc4_c1+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vc4_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vc3_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc3_c1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vc3_c1)+(+0.0*Vbc3+0.0*Vbc3_Vc3_c1+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vc3_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vc3_c4=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc3_c4+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vc3_c4)+(+0.0*Vbc3+0.0*Vbc3_Vc3_c4+0.0*Vbc3_Vb_c+XP_T*Vbc3_Vb_c_Vc3_c4)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb1_e1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb1_e1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_c+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_e1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb2_e1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_c+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_c_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_c1+0.0*XVtexv_Vb_c+(1.0-XP_T)*XVtexv_Vb_c_Vb2_c1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_c+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_c)+(XP_T*Vbc3_Vb_c)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
#endif
XQtex_Vb_b1=(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*pModel->XEXT;
#if defined(_DERIVATE2)
  XQtex_Vb_b1_Vdt_GND=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3))+CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vdt_GND+(-XP_T_Vdt_GND)*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vdt_GND)+(+0.0*Vbc3+0.0*0.0+XP_T_Vdt_GND*Vbc3_Vb_b1+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+(((CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))+(CJC_TM*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+((((CJC_TM_Vdt_GND*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))+(CJC_TM*(((((-XP_T_Vdt_GND)*XVtexv)+((1.0-XP_T)*XVtexv_Vdt_GND)))+(XP_T_Vdt_GND*Vbc3)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb_c=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb_c+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb_c)+(+0.0*Vbc3+0.0*Vbc3_Vb_c+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vb_c)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_c))+((XP_T*Vbc3_Vb_c)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb_b1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb_b1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb_b1)+(+0.0*Vbc3+0.0*Vbc3_Vb_b1+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vb_b1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb_b1))+((XP_T*Vbc3_Vb_b1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb1_b2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb1_b2+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb1_b2)+(+0.0*Vbc3+0.0*Vbc3_Vb1_b2+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vb1_b2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_b2))+((XP_T*Vbc3_Vb1_b2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb2_c2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_c2+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb2_c2)+(+0.0*Vbc3+0.0*Vbc3_Vb2_c2+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vb2_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c2))+((XP_T*Vbc3_Vb2_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vc1_c2=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc1_c2+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vc1_c2)+(+0.0*Vbc3+0.0*Vbc3_Vc1_c2+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vc1_c2)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc1_c2))+((XP_T*Vbc3_Vc1_c2)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vc4_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc4_c1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vc4_c1)+(+0.0*Vbc3+0.0*Vbc3_Vc4_c1+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vc4_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc4_c1))+((XP_T*Vbc3_Vc4_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vc3_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc3_c1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vc3_c1)+(+0.0*Vbc3+0.0*Vbc3_Vc3_c1+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vc3_c1)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c1))+((XP_T*Vbc3_Vc3_c1)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vc3_c4=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vc3_c4+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vc3_c4)+(+0.0*Vbc3+0.0*Vbc3_Vc3_c4+0.0*Vbc3_Vb_b1+XP_T*Vbc3_Vb_b1_Vc3_c4)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vc3_c4))+((XP_T*Vbc3_Vc3_c4)))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb1_e1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb1_e1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb1_e1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_b1+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb1_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb2_e1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_e1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb2_e1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_b1+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_e1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
  XQtex_Vb_b1_Vb2_c1=(+(+(+0.0*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3))+0.0*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))+0.0*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1))+CJC_TM*(+(+(+0.0-0.0)*XVtexv+0.0*XVtexv_Vb2_c1+0.0*XVtexv_Vb_b1+(1.0-XP_T)*XVtexv_Vb_b1_Vb2_c1)+(+0.0*Vbc3+0.0*0.0+0.0*Vbc3_Vb_b1+XP_T*0.0)))*(1.0-pModel->XCJC)+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*0.0+((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))))*0.0+(CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(+0.0-0.0))*pModel->XEXT+(CJC_TM*(((1.0-XP_T)*XVtexv_Vb_b1)+(XP_T*Vbc3_Vb_b1)))*(1.0-pModel->XCJC)*0.0+(((CJC_TM*((((1.0-XP_T)*XVtexv_Vb2_c1))+(0.0))))*(1.0-pModel->XCJC))*0.0+((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*0.0);
#endif
#if defined(_DERIVATE)
XQtex_Vb1_b2=(CJC_TM*(((1.0-XP_T)*XVtexv_Vb1_b2)+(XP_T*Vbc3_Vb1_b2)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vb2_c2=(CJC_TM*(((1.0-XP_T)*XVtexv_Vb2_c2)+(XP_T*Vbc3_Vb2_c2)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vc1_c2=(CJC_TM*(((1.0-XP_T)*XVtexv_Vc1_c2)+(XP_T*Vbc3_Vc1_c2)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vc4_c1=(CJC_TM*(((1.0-XP_T)*XVtexv_Vc4_c1)+(XP_T*Vbc3_Vc4_c1)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vc3_c1=(CJC_TM*(((1.0-XP_T)*XVtexv_Vc3_c1)+(XP_T*Vbc3_Vc3_c1)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vc3_c4=(CJC_TM*(((1.0-XP_T)*XVtexv_Vc3_c4)+(XP_T*Vbc3_Vc3_c4)))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vb1_e1=(CJC_TM*((1.0-XP_T)*XVtexv_Vb1_e1))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vb2_e1=(CJC_TM*((1.0-XP_T)*XVtexv_Vb2_e1))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#if defined(_DERIVATE)
XQtex_Vb2_c1=(CJC_TM*((1.0-XP_T)*XVtexv_Vb2_c1))*(1.0-pModel->XCJC)*pModel->XEXT;
#endif
#endif
XQtex=(((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*pModel->XEXT);
EXIT_IF_ISNAN((((CJC_TM*(((1.0-XP_T)*XVtexv)+(XP_T*Vbc3)))*(1.0-pModel->XCJC))*pModel->XEXT))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
a_VDS_Vdt_GND=(0.1*VDS_T_Vdt_GND);
#endif
a_VDS=(0.1*VDS_T);
EXIT_IF_ISNAN((0.1*VDS_T))
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,2.0,((-1.0)/pModel->PS))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(s,GND) */
Vfs_Vdt_GND=VDS_T_Vdt_GND*(1.0-d00_pow0);
#endif
Vfs=(VDS_T*(1.0-d00_pow0));
EXIT_IF_ISNAN((VDS_T*(1.0-d00_pow0)))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND)V(s,GND) */
dxa_Vs_c1=(Vsc1_Vs_c1/a_VDS);
#if defined(_DERIVATE2)
  dxa_Vs_c1_Vs_c1=((+Vsc1_Vs_c1_Vs_c1-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+Vsc1_Vs_c1*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb_c=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb_b1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vc3_c1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vc3_c4=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb1_b2=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vc4_c1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb1_e1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb2_e1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb2_c2=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vb2_c1=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vc1_c2=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*0.0+0.0*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*0.0/a_VDS/a_VDS/a_VDS);
  dxa_Vs_c1_Vdt_GND=((+0.0-0.0)/a_VDS-(Vsc1_Vs_c1*a_VDS_Vdt_GND+(-Vfs_Vdt_GND)*0.0+(Vsc1-Vfs)*0.0)/a_VDS/a_VDS+2*(Vsc1-Vfs)*0.0*a_VDS_Vdt_GND/a_VDS/a_VDS/a_VDS);
#endif
dxa_Vb_c=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_c_Vs_c1=0.0;
  dxa_Vb_c_Vb_c=0.0;
  dxa_Vb_c_Vb_b1=0.0;
  dxa_Vb_c_Vc3_c1=0.0;
  dxa_Vb_c_Vc3_c4=0.0;
  dxa_Vb_c_Vb1_b2=0.0;
  dxa_Vb_c_Vc4_c1=0.0;
  dxa_Vb_c_Vb1_e1=0.0;
  dxa_Vb_c_Vb2_e1=0.0;
  dxa_Vb_c_Vb2_c2=0.0;
  dxa_Vb_c_Vb2_c1=0.0;
  dxa_Vb_c_Vc1_c2=0.0;
  dxa_Vb_c_Vdt_GND=0.0;
#endif
dxa_Vb_b1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb_b1_Vs_c1=0.0;
  dxa_Vb_b1_Vb_c=0.0;
  dxa_Vb_b1_Vb_b1=0.0;
  dxa_Vb_b1_Vc3_c1=0.0;
  dxa_Vb_b1_Vc3_c4=0.0;
  dxa_Vb_b1_Vb1_b2=0.0;
  dxa_Vb_b1_Vc4_c1=0.0;
  dxa_Vb_b1_Vb1_e1=0.0;
  dxa_Vb_b1_Vb2_e1=0.0;
  dxa_Vb_b1_Vb2_c2=0.0;
  dxa_Vb_b1_Vb2_c1=0.0;
  dxa_Vb_b1_Vc1_c2=0.0;
  dxa_Vb_b1_Vdt_GND=0.0;
#endif
dxa_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc3_c1_Vs_c1=0.0;
  dxa_Vc3_c1_Vb_c=0.0;
  dxa_Vc3_c1_Vb_b1=0.0;
  dxa_Vc3_c1_Vc3_c1=0.0;
  dxa_Vc3_c1_Vc3_c4=0.0;
  dxa_Vc3_c1_Vb1_b2=0.0;
  dxa_Vc3_c1_Vc4_c1=0.0;
  dxa_Vc3_c1_Vb1_e1=0.0;
  dxa_Vc3_c1_Vb2_e1=0.0;
  dxa_Vc3_c1_Vb2_c2=0.0;
  dxa_Vc3_c1_Vb2_c1=0.0;
  dxa_Vc3_c1_Vc1_c2=0.0;
  dxa_Vc3_c1_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vc3_c4=0.0;
#endif
dxa_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_b2_Vs_c1=0.0;
  dxa_Vb1_b2_Vb_c=0.0;
  dxa_Vb1_b2_Vb_b1=0.0;
  dxa_Vb1_b2_Vc3_c1=0.0;
  dxa_Vb1_b2_Vc3_c4=0.0;
  dxa_Vb1_b2_Vb1_b2=0.0;
  dxa_Vb1_b2_Vc4_c1=0.0;
  dxa_Vb1_b2_Vb1_e1=0.0;
  dxa_Vb1_b2_Vb2_e1=0.0;
  dxa_Vb1_b2_Vb2_c2=0.0;
  dxa_Vb1_b2_Vb2_c1=0.0;
  dxa_Vb1_b2_Vc1_c2=0.0;
  dxa_Vb1_b2_Vdt_GND=0.0;
#endif
dxa_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vc4_c1_Vs_c1=0.0;
  dxa_Vc4_c1_Vb_c=0.0;
  dxa_Vc4_c1_Vb_b1=0.0;
  dxa_Vc4_c1_Vc3_c1=0.0;
  dxa_Vc4_c1_Vc3_c4=0.0;
  dxa_Vc4_c1_Vb1_b2=0.0;
  dxa_Vc4_c1_Vc4_c1=0.0;
  dxa_Vc4_c1_Vb1_e1=0.0;
  dxa_Vc4_c1_Vb2_e1=0.0;
  dxa_Vc4_c1_Vb2_c2=0.0;
  dxa_Vc4_c1_Vb2_c1=0.0;
  dxa_Vc4_c1_Vc1_c2=0.0;
  dxa_Vc4_c1_Vdt_GND=0.0;
#endif
dxa_Vb1_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb1_e1_Vs_c1=0.0;
  dxa_Vb1_e1_Vb_c=0.0;
  dxa_Vb1_e1_Vb_b1=0.0;
  dxa_Vb1_e1_Vc3_c1=0.0;
  dxa_Vb1_e1_Vc3_c4=0.0;
  dxa_Vb1_e1_Vb1_b2=0.0;
  dxa_Vb1_e1_Vc4_c1=0.0;
  dxa_Vb1_e1_Vb1_e1=0.0;
  dxa_Vb1_e1_Vb2_e1=0.0;
  dxa_Vb1_e1_Vb2_c2=0.0;
  dxa_Vb1_e1_Vb2_c1=0.0;
  dxa_Vb1_e1_Vc1_c2=0.0;
  dxa_Vb1_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_e1_Vs_c1=0.0;
  dxa_Vb2_e1_Vb_c=0.0;
  dxa_Vb2_e1_Vb_b1=0.0;
  dxa_Vb2_e1_Vc3_c1=0.0;
  dxa_Vb2_e1_Vc3_c4=0.0;
  dxa_Vb2_e1_Vb1_b2=0.0;
  dxa_Vb2_e1_Vc4_c1=0.0;
  dxa_Vb2_e1_Vb1_e1=0.0;
  dxa_Vb2_e1_Vb2_e1=0.0;
  dxa_Vb2_e1_Vb2_c2=0.0;
  dxa_Vb2_e1_Vb2_c1=0.0;
  dxa_Vb2_e1_Vc1_c2=0.0;
  dxa_Vb2_e1_Vdt_GND=0.0;
#endif
dxa_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c2_Vs_c1=0.0;
  dxa_Vb2_c2_Vb_c=0.0;
  dxa_Vb2_c2_Vb_b1=0.0;
  dxa_Vb2_c2_Vc3_c1=0.0;
  dxa_Vb2_c2_Vc3_c4=0.0;
  dxa_Vb2_c2_Vb1_b2=0.0;
  dxa_Vb2_c2_Vc4_c1=0.0;
  dxa_Vb2_c2_Vb1_e1=0.0;
  dxa_Vb2_c2_Vb2_e1=0.0;
  dxa_Vb2_c2_Vb2_c2=0.0;
  dxa_Vb2_c2_Vb2_c1=0.0;
  dxa_Vb2_c2_Vc1_c2=0.0;
  dxa_Vb2_c2_Vdt_GND=0.0;
#endif
dxa_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  dxa_Vb2_c1_Vs_c1=0.0;
  dxa_Vb2_c1_Vb_c=0.0;
  dxa_Vb2_c1_Vb_b1=0.0;
  dxa_Vb2_c1_Vc3_c1=0.0;
  dxa_Vb2_c1_Vc3_c4=0.0;
  dxa_Vb2_c1_Vb1_b2=0.0;
  dxa_Vb2_c1_Vc4_c1=0.0;
  dxa_Vb2_c1_Vb1_e1=0.0;
  dxa_Vb2_c1_Vb2_e1=0.0;
  dxa_Vb2_c1_Vb2_c2=0.0;
  dxa_Vb2_c1_Vb2_c1=0.0;
  dxa_Vb2_c1_Vc1_c2=0.0;
  dxa_Vb2_c1_Vdt_GND=0.0;
#endif
dxa_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  dxa_Vc1_c2_Vs_c1=0.0;
  dxa_Vc1_c2_Vb_c=0.0;
  dxa_Vc1_c2_Vb_b1=0.0;
  dxa_Vc1_c2_Vc3_c1=0.0;
  dxa_Vc1_c2_Vc3_c4=0.0;
  dxa_Vc1_c2_Vb1_b2=0.0;
  dxa_Vc1_c2_Vc4_c1=0.0;
  dxa_Vc1_c2_Vb1_e1=0.0;
  dxa_Vc1_c2_Vb2_e1=0.0;
  dxa_Vc1_c2_Vb2_c2=0.0;
  dxa_Vc1_c2_Vb2_c1=0.0;
  dxa_Vc1_c2_Vc1_c2=0.0;
  dxa_Vc1_c2_Vdt_GND=0.0;
#endif
#if defined(_DERIVATE)
dxa_Vdt_GND=(((-Vfs_Vdt_GND)*a_VDS-(Vsc1-Vfs)*a_VDS_Vdt_GND)/a_VDS/a_VDS);
#endif
#endif
dxa=((Vsc1-Vfs)/a_VDS);
EXIT_IF_ISNAN(((Vsc1-Vfs)/a_VDS))
#endif
#ifdef _DYNAMIC
if
((Vsc1<Vfs))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,dxa)
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(dt,GND)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND) */
Vjs_Vs_c1=(Vsc1_Vs_c1-(a_VDS*dxa_Vs_c1*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjs_Vs_c1_Vs_c1=(+Vsc1_Vs_c1_Vs_c1-(+0.0*d00_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vs_c1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vs_c1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vs_c1)))));
  Vjs_Vs_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vdt_GND*d10_exp0*d10_logE1+a_VDS_Vdt_GND*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vdt_GND*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vdt_GND*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vdt_GND)))));
  Vjs_Vs_c1_Vb_c=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb_c*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb_c*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_c*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb_c)))));
  Vjs_Vs_c1_Vb_b1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb_b1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb_b1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb_b1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb_b1)))));
  Vjs_Vs_c1_Vc3_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc3_c1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vc3_c1)))));
  Vjs_Vs_c1_Vc3_c4=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc3_c4*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vc3_c4*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc3_c4*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vc3_c4)))));
  Vjs_Vs_c1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_b2*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb1_b2*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_b2*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb1_b2)))));
  Vjs_Vs_c1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc4_c1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vc4_c1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc4_c1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vc4_c1)))));
  Vjs_Vs_c1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb1_e1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb1_e1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb1_e1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb1_e1)))));
  Vjs_Vs_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_e1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb2_e1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_e1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb2_e1)))));
  Vjs_Vs_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c2*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c2*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c2*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb2_c2)))));
  Vjs_Vs_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vb2_c1*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vb2_c1*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vb2_c1*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vb2_c1)))));
  Vjs_Vs_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*dxa_Vc1_c2*d10_exp0*d10_logE1+0.0*dxa_Vs_c1*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*dxa_Vc1_c2*d10_exp0*dxa_Vs_c1*d10_exp0+d10_logE1*(+0.0+(m20_exp(dxa)*dxa_Vc1_c2*dxa_Vs_c1+d10_exp0*dxa_Vs_c1_Vc1_c2)))));
#endif
#if defined(_DERIVATE)
Vjs_Vdt_GND=(-((a_VDS_Vdt_GND*d00_logE1)+(a_VDS*dxa_Vdt_GND*d10_exp0*d10_logE1)));
#endif
#if defined(_DERIVATE)
Vjs_Vb_c=(-(a_VDS*dxa_Vb_c*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb_b1=(-(a_VDS*dxa_Vb_b1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c1=(-(a_VDS*dxa_Vc3_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c4=(-(a_VDS*dxa_Vc3_c4*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb1_b2=(-(a_VDS*dxa_Vb1_b2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc4_c1=(-(a_VDS*dxa_Vc4_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb1_e1=(-(a_VDS*dxa_Vb1_e1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_e1=(-(a_VDS*dxa_Vb2_e1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c2=(-(a_VDS*dxa_Vb2_c2*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c1=(-(a_VDS*dxa_Vb2_c1*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc1_c2=(-(a_VDS*dxa_Vc1_c2*d10_exp0*d10_logE1));
#endif
#endif
Vjs=(Vsc1-(a_VDS*d00_logE1));
EXIT_IF_ISNAN((Vsc1-(a_VDS*d00_logE1)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-dxa))
double m00_logE(d00_logE1,(1.0+d00_exp0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(1.0+d00_exp0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(dt,GND)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND) */
Vjs_Vs_c1=(-(a_VDS*(-dxa_Vs_c1)*d10_exp0*d10_logE1));
#if defined(_DERIVATE2)
  Vjs_Vs_c1_Vs_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vs_c1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vs_c1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vdt_GND=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vdt_GND)*d10_exp0*d10_logE1+a_VDS_Vdt_GND*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vdt_GND)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vdt_GND)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb_c=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_c)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_c)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_c)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb_b1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb_b1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb_b1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb_b1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vc3_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vc3_c4=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc3_c4)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vc3_c4)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc3_c4)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb1_b2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_b2)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_b2)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_b2)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vc4_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc4_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vc4_c1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc4_c1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb1_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb1_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb1_e1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb1_e1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb2_e1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_e1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_e1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_e1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb2_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c2)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c2)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vb2_c1=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vb2_c1)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vb2_c1)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vb2_c1)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
  Vjs_Vs_c1_Vc1_c2=(+0.0-(+0.0*d00_logE1+0.0*(-dxa_Vc1_c2)*d10_exp0*d10_logE1+0.0*(-dxa_Vs_c1)*d10_exp0*d10_logE1+a_VDS*(m20_logE((1.0+d00_exp0))*(-dxa_Vc1_c2)*d10_exp0*(-dxa_Vs_c1)*d10_exp0+d10_logE1*(+0.0+(m20_exp((-dxa))*(-dxa_Vc1_c2)*(-dxa_Vs_c1)+d10_exp0*0.0)))));
#endif
#if defined(_DERIVATE)
Vjs_Vdt_GND=(Vfs_Vdt_GND-((a_VDS_Vdt_GND*d00_logE1)+(a_VDS*(-dxa_Vdt_GND)*d10_exp0*d10_logE1)));
#endif
#if defined(_DERIVATE)
Vjs_Vb_c=(-(a_VDS*(-dxa_Vb_c)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb_b1=(-(a_VDS*(-dxa_Vb_b1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c1=(-(a_VDS*(-dxa_Vc3_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c4=(-(a_VDS*(-dxa_Vc3_c4)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb1_b2=(-(a_VDS*(-dxa_Vb1_b2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc4_c1=(-(a_VDS*(-dxa_Vc4_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb1_e1=(-(a_VDS*(-dxa_Vb1_e1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_e1=(-(a_VDS*(-dxa_Vb2_e1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c2=(-(a_VDS*(-dxa_Vb2_c2)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c1=(-(a_VDS*(-dxa_Vb2_c1)*d10_exp0*d10_logE1));
#endif
#if defined(_DERIVATE)
Vjs_Vc1_c2=(-(a_VDS*(-dxa_Vc1_c2)*d10_exp0*d10_logE1));
#endif
#endif
Vjs=(Vfs-(a_VDS*d00_logE1));
EXIT_IF_ISNAN((Vfs-(a_VDS*d00_logE1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(s,c1)V(dt,GND)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND) */
Vjs_Vs_c1=Vjs_Vs_c1;
#if defined(_DERIVATE2)
  Vjs_Vs_c1_Vs_c1=Vjs_Vs_c1_Vs_c1;
  Vjs_Vs_c1_Vdt_GND=Vjs_Vs_c1_Vdt_GND;
  Vjs_Vs_c1_Vb_c=Vjs_Vs_c1_Vb_c;
  Vjs_Vs_c1_Vb_b1=Vjs_Vs_c1_Vb_b1;
  Vjs_Vs_c1_Vc3_c1=Vjs_Vs_c1_Vc3_c1;
  Vjs_Vs_c1_Vc3_c4=Vjs_Vs_c1_Vc3_c4;
  Vjs_Vs_c1_Vb1_b2=Vjs_Vs_c1_Vb1_b2;
  Vjs_Vs_c1_Vc4_c1=Vjs_Vs_c1_Vc4_c1;
  Vjs_Vs_c1_Vb1_e1=Vjs_Vs_c1_Vb1_e1;
  Vjs_Vs_c1_Vb2_e1=Vjs_Vs_c1_Vb2_e1;
  Vjs_Vs_c1_Vb2_c2=Vjs_Vs_c1_Vb2_c2;
  Vjs_Vs_c1_Vb2_c1=Vjs_Vs_c1_Vb2_c1;
  Vjs_Vs_c1_Vc1_c2=Vjs_Vs_c1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Vjs_Vdt_GND=Vjs_Vdt_GND;
#endif
#if defined(_DERIVATE)
Vjs_Vb_c=Vjs_Vb_c;
#endif
#if defined(_DERIVATE)
Vjs_Vb_b1=Vjs_Vb_b1;
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c1=Vjs_Vc3_c1;
#endif
#if defined(_DERIVATE)
Vjs_Vc3_c4=Vjs_Vc3_c4;
#endif
#if defined(_DERIVATE)
Vjs_Vb1_b2=Vjs_Vb1_b2;
#endif
#if defined(_DERIVATE)
Vjs_Vc4_c1=Vjs_Vc4_c1;
#endif
#if defined(_DERIVATE)
Vjs_Vb1_e1=Vjs_Vb1_e1;
#endif
#if defined(_DERIVATE)
Vjs_Vb2_e1=Vjs_Vb2_e1;
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c2=Vjs_Vb2_c2;
#endif
#if defined(_DERIVATE)
Vjs_Vb2_c1=Vjs_Vb2_c1;
#endif
#if defined(_DERIVATE)
Vjs_Vc1_c2=Vjs_Vc1_c2;
#endif
#endif
Vjs=Vjs;
EXIT_IF_ISNAN(Vjs)
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1.0-(Vjs/VDS_T)),(1.0-pModel->PS))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vjs/VDS_T)),(1.0-pModel->PS))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(s,c1)V(b,c)V(b,b1)V(c3,c1)V(c3,c4)V(b1,b2)V(c4,c1)V(b1,e1)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(s,GND) */
#if defined(_DERIVATE)
Qts_Vdt_GND=((CJS_TM_Vdt_GND*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs))))+(CJS_TM*((((VDS_T_Vdt_GND/(1.0-pModel->PS))*(1.0-d00_pow0))+((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-((Vjs_Vdt_GND*VDS_T-Vjs*VDS_T_Vdt_GND)/VDS_T/VDS_T))))))+(2.0*(-Vjs_Vdt_GND)))));
#endif
Qts_Vs_c1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1))));
#if defined(_DERIVATE2)
  Qts_Vs_c1_Vdt_GND=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*(((((VDS_T_Vdt_GND/(1.0-pModel->PS))*(1.0-d00_pow0))+((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-((Vjs_Vdt_GND*VDS_T-Vjs*VDS_T_Vdt_GND)/VDS_T/VDS_T)))))))+((2.0*(-Vjs_Vdt_GND))))+CJS_TM_Vdt_GND*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+VDS_T_Vdt_GND*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-((Vjs_Vdt_GND*VDS_T-Vjs*VDS_T_Vdt_GND)/VDS_T/VDS_T))))+(VDS_T_Vdt_GND/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vdt_GND)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vdt_GND))));
  Qts_Vs_c1_Vs_c1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))))+((2.0*(Vsc1_Vs_c1-Vjs_Vs_c1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+Vsc1_Vs_c1_Vs_c1-Vjs_Vs_c1_Vs_c1))));
  Qts_Vs_c1_Vb_c=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb_c/VDS_T))))))+((2.0*(-Vjs_Vb_c))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb_c/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb_c)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb_c))));
  Qts_Vs_c1_Vb_b1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb_b1/VDS_T))))))+((2.0*(-Vjs_Vb_b1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb_b1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb_b1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb_b1))));
  Qts_Vs_c1_Vc3_c1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc3_c1/VDS_T))))))+((2.0*(-Vjs_Vc3_c1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vc3_c1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vc3_c1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vc3_c1))));
  Qts_Vs_c1_Vc3_c4=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc3_c4/VDS_T))))))+((2.0*(-Vjs_Vc3_c4))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vc3_c4/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vc3_c4)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vc3_c4))));
  Qts_Vs_c1_Vb1_b2=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb1_b2/VDS_T))))))+((2.0*(-Vjs_Vb1_b2))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb1_b2/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb1_b2)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb1_b2))));
  Qts_Vs_c1_Vc4_c1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc4_c1/VDS_T))))))+((2.0*(-Vjs_Vc4_c1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vc4_c1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vc4_c1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vc4_c1))));
  Qts_Vs_c1_Vb1_e1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb1_e1/VDS_T))))))+((2.0*(-Vjs_Vb1_e1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb1_e1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb1_e1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb1_e1))));
  Qts_Vs_c1_Vb2_e1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_e1/VDS_T))))))+((2.0*(-Vjs_Vb2_e1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb2_e1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb2_e1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb2_e1))));
  Qts_Vs_c1_Vb2_c2=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_c2/VDS_T))))))+((2.0*(-Vjs_Vb2_c2))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb2_c2/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb2_c2)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb2_c2))));
  Qts_Vs_c1_Vb2_c1=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_c1/VDS_T))))))+((2.0*(-Vjs_Vb2_c1))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vb2_c1/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vb2_c1)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vb2_c1))));
  Qts_Vs_c1_Vc1_c2=(+0.0*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))+0.0*((((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc1_c2/VDS_T))))))+((2.0*(-Vjs_Vc1_c2))))+0.0*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T)))))+(2.0*(Vsc1_Vs_c1-Vjs_Vs_c1)))+CJS_TM*(+(+(0.0/(1.0-pModel->PS)-(0.0*0.0+0.0*0.0+VDS_T*(+0.0-0.0))/(1.0-pModel->PS)/(1.0-pModel->PS)+2*VDS_T*0.0*0.0/(1.0-pModel->PS)/(1.0-pModel->PS)/(1.0-pModel->PS))*(1.0-d00_pow0)+0.0*(-(d10_pow0*(-(Vjs_Vc1_c2/VDS_T))))+0.0*(-(d10_pow0*(-(Vjs_Vs_c1/VDS_T))))+(VDS_T/(1.0-pModel->PS))*(+0.0-fixme))+(+0.0*(Vsc1-Vjs)+0.0*(-Vjs_Vc1_c2)+0.0*(Vsc1_Vs_c1-Vjs_Vs_c1)+2.0*(+0.0-Vjs_Vs_c1_Vc1_c2))));
#endif
#if defined(_DERIVATE)
Qts_Vb_c=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb_c/VDS_T)))))+(2.0*(-Vjs_Vb_c))));
#endif
#if defined(_DERIVATE)
Qts_Vb_b1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb_b1/VDS_T)))))+(2.0*(-Vjs_Vb_b1))));
#endif
#if defined(_DERIVATE)
Qts_Vc3_c1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc3_c1/VDS_T)))))+(2.0*(-Vjs_Vc3_c1))));
#endif
#if defined(_DERIVATE)
Qts_Vc3_c4=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc3_c4/VDS_T)))))+(2.0*(-Vjs_Vc3_c4))));
#endif
#if defined(_DERIVATE)
Qts_Vb1_b2=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb1_b2/VDS_T)))))+(2.0*(-Vjs_Vb1_b2))));
#endif
#if defined(_DERIVATE)
Qts_Vc4_c1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc4_c1/VDS_T)))))+(2.0*(-Vjs_Vc4_c1))));
#endif
#if defined(_DERIVATE)
Qts_Vb1_e1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb1_e1/VDS_T)))))+(2.0*(-Vjs_Vb1_e1))));
#endif
#if defined(_DERIVATE)
Qts_Vb2_e1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_e1/VDS_T)))))+(2.0*(-Vjs_Vb2_e1))));
#endif
#if defined(_DERIVATE)
Qts_Vb2_c2=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_c2/VDS_T)))))+(2.0*(-Vjs_Vb2_c2))));
#endif
#if defined(_DERIVATE)
Qts_Vb2_c1=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vb2_c1/VDS_T)))))+(2.0*(-Vjs_Vb2_c1))));
#endif
#if defined(_DERIVATE)
Qts_Vc1_c2=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(-(d10_pow0*(-(Vjs_Vc1_c2/VDS_T)))))+(2.0*(-Vjs_Vc1_c2))));
#endif
#endif
Qts=(CJS_TM*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs))));
EXIT_IF_ISNAN((CJS_TM*(((VDS_T/(1.0-pModel->PS))*(1.0-d00_pow0))+(2.0*(Vsc1-Vjs)))))
}
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(IS_TM/IK_TM),(1.0/pModel->MTAU))
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(IS_TM/IK_TM),(1.0/pModel->MTAU))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
Qe0_Vdt_GND=((((TAUE_T_Vdt_GND*IK_TM)+(TAUE_T*IK_TM_Vdt_GND))*d00_pow0)+((TAUE_T*IK_TM)*(d10_pow0*((IS_TM_Vdt_GND*IK_TM-IS_TM*IK_TM_Vdt_GND)/IK_TM/IK_TM))));
#endif
Qe0=((TAUE_T*IK_TM)*d00_pow0);
EXIT_IF_ISNAN(((TAUE_T*IK_TM)*d00_pow0))
}
#endif
#ifdef _DYNAMIC
if
(((Vb2e1/(pModel->MTAU*Vt))<400.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(Vb2e1/(pModel->MTAU*Vt)))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=0.0;
  tmpExp_Vb1_b2_Vb2_c2=0.0;
  tmpExp_Vb1_b2_Vc1_c2=0.0;
  tmpExp_Vb1_b2_Vc4_c1=0.0;
  tmpExp_Vb1_b2_Vb2_e1=0.0;
  tmpExp_Vb1_b2_Vdt_GND=0.0;
#endif
tmpExp_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=0.0;
  tmpExp_Vb2_c2_Vb2_c2=0.0;
  tmpExp_Vb2_c2_Vc1_c2=0.0;
  tmpExp_Vb2_c2_Vc4_c1=0.0;
  tmpExp_Vb2_c2_Vb2_e1=0.0;
  tmpExp_Vb2_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=0.0;
  tmpExp_Vc1_c2_Vb2_c2=0.0;
  tmpExp_Vc1_c2_Vc1_c2=0.0;
  tmpExp_Vc1_c2_Vc4_c1=0.0;
  tmpExp_Vc1_c2_Vb2_e1=0.0;
  tmpExp_Vc1_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=0.0;
  tmpExp_Vc4_c1_Vb2_c2=0.0;
  tmpExp_Vc4_c1_Vc1_c2=0.0;
  tmpExp_Vc4_c1_Vc4_c1=0.0;
  tmpExp_Vc4_c1_Vb2_e1=0.0;
  tmpExp_Vc4_c1_Vdt_GND=0.0;
#endif
tmpExp_Vb2_e1=(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))*d10_exp0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
  tmpExp_Vb2_e1_Vb2_c2=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
  tmpExp_Vb2_e1_Vc1_c2=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
  tmpExp_Vb2_e1_Vc4_c1=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
  tmpExp_Vb2_e1_Vb2_e1=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*((Vb2e1_Vb2_e1*(pModel->MTAU*Vt)-Vb2e1*(0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(Vb2e1_Vb2_e1_Vb2_e1/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+Vb2e1_Vb2_e1*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
  tmpExp_Vb2_e1_Vdt_GND=(m20_exp((Vb2e1/(pModel->MTAU*Vt)))*(-Vb2e1*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+d10_exp0*(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*((pModel->MTAU*Vt_Vdt_GND))+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=(-Vb2e1*(pModel->MTAU*Vt_Vdt_GND)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))*d10_exp0;
#endif
#endif
tmpExp=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,400.0)
expl=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1)V(dt,GND) ddxprobe=V(b1,GND)V(e1,GND)V(c2,GND)V(c1,GND)V(b2,GND) */
tmpExp_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb1_b2_Vb1_b2=0.0;
  tmpExp_Vb1_b2_Vb2_c2=0.0;
  tmpExp_Vb1_b2_Vc1_c2=0.0;
  tmpExp_Vb1_b2_Vc4_c1=0.0;
  tmpExp_Vb1_b2_Vb2_e1=0.0;
  tmpExp_Vb1_b2_Vdt_GND=0.0;
#endif
tmpExp_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vb2_c2_Vb1_b2=0.0;
  tmpExp_Vb2_c2_Vb2_c2=0.0;
  tmpExp_Vb2_c2_Vc1_c2=0.0;
  tmpExp_Vb2_c2_Vc4_c1=0.0;
  tmpExp_Vb2_c2_Vb2_e1=0.0;
  tmpExp_Vb2_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc1_c2_Vb1_b2=0.0;
  tmpExp_Vc1_c2_Vb2_c2=0.0;
  tmpExp_Vc1_c2_Vc1_c2=0.0;
  tmpExp_Vc1_c2_Vc4_c1=0.0;
  tmpExp_Vc1_c2_Vb2_e1=0.0;
  tmpExp_Vc1_c2_Vdt_GND=0.0;
#endif
tmpExp_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  tmpExp_Vc4_c1_Vb1_b2=0.0;
  tmpExp_Vc4_c1_Vb2_c2=0.0;
  tmpExp_Vc4_c1_Vc1_c2=0.0;
  tmpExp_Vc4_c1_Vc4_c1=0.0;
  tmpExp_Vc4_c1_Vb2_e1=0.0;
  tmpExp_Vc4_c1_Vdt_GND=0.0;
#endif
tmpExp_Vb2_e1=(expl*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt)));
#if defined(_DERIVATE2)
  tmpExp_Vb2_e1_Vb1_b2=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
  tmpExp_Vb2_e1_Vb2_c2=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
  tmpExp_Vb2_e1_Vc1_c2=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
  tmpExp_Vb2_e1_Vc4_c1=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*(-Vb2e1*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
  tmpExp_Vb2_e1_Vb2_e1=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*((Vb2e1_Vb2_e1*(pModel->MTAU*Vt)-Vb2e1*(0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(Vb2e1_Vb2_e1_Vb2_e1/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*(0.0)+Vb2e1_Vb2_e1*0.0+Vb2e1*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
  tmpExp_Vb2_e1_Vdt_GND=(+0.0*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))+0.0*(-Vb2e1*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))+0.0*(Vb2e1_Vb2_e1/(pModel->MTAU*Vt))+expl*(+0.0+(+(0.0/(pModel->MTAU*Vt)-(Vb2e1_Vb2_e1*((pModel->MTAU*Vt_Vdt_GND))+0.0*0.0+Vb2e1*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Vb2e1*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt))-0.0)));
#endif
#if defined(_DERIVATE)
tmpExp_Vdt_GND=(expl*(-Vb2e1*(pModel->MTAU*Vt_Vdt_GND)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)));
#endif
#endif
tmpExp=(expl*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0)));
EXIT_IF_ISNAN((expl*(1.0+((Vb2e1/(pModel->MTAU*Vt))-400.0))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe=V(b2,GND)V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Qe_qs_Vdt_GND=((Qe0_Vdt_GND*tmpExp)+(Qe0*tmpExp_Vdt_GND));
#endif
Qe_qs_Vb1_b2=(Qe0*tmpExp_Vb1_b2);
#if defined(_DERIVATE2)
  Qe_qs_Vb1_b2_Vdt_GND=(+0.0*tmpExp+0.0*tmpExp_Vdt_GND+Qe0_Vdt_GND*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vdt_GND);
  Qe_qs_Vb1_b2_Vb1_b2=(+0.0*tmpExp+0.0*tmpExp_Vb1_b2+0.0*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vb1_b2);
  Qe_qs_Vb1_b2_Vb2_c2=(+0.0*tmpExp+0.0*tmpExp_Vb2_c2+0.0*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vb2_c2);
  Qe_qs_Vb1_b2_Vc1_c2=(+0.0*tmpExp+0.0*tmpExp_Vc1_c2+0.0*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vc1_c2);
  Qe_qs_Vb1_b2_Vc4_c1=(+0.0*tmpExp+0.0*tmpExp_Vc4_c1+0.0*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vc4_c1);
  Qe_qs_Vb1_b2_Vb2_e1=(+0.0*tmpExp+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vb1_b2+Qe0*tmpExp_Vb1_b2_Vb2_e1);
#endif
Qe_qs_Vb2_c2=(Qe0*tmpExp_Vb2_c2);
#if defined(_DERIVATE2)
  Qe_qs_Vb2_c2_Vdt_GND=(+0.0*tmpExp+0.0*tmpExp_Vdt_GND+Qe0_Vdt_GND*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vdt_GND);
  Qe_qs_Vb2_c2_Vb1_b2=(+0.0*tmpExp+0.0*tmpExp_Vb1_b2+0.0*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vb1_b2);
  Qe_qs_Vb2_c2_Vb2_c2=(+0.0*tmpExp+0.0*tmpExp_Vb2_c2+0.0*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vb2_c2);
  Qe_qs_Vb2_c2_Vc1_c2=(+0.0*tmpExp+0.0*tmpExp_Vc1_c2+0.0*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vc1_c2);
  Qe_qs_Vb2_c2_Vc4_c1=(+0.0*tmpExp+0.0*tmpExp_Vc4_c1+0.0*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vc4_c1);
  Qe_qs_Vb2_c2_Vb2_e1=(+0.0*tmpExp+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vb2_c2+Qe0*tmpExp_Vb2_c2_Vb2_e1);
#endif
Qe_qs_Vc1_c2=(Qe0*tmpExp_Vc1_c2);
#if defined(_DERIVATE2)
  Qe_qs_Vc1_c2_Vdt_GND=(+0.0*tmpExp+0.0*tmpExp_Vdt_GND+Qe0_Vdt_GND*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vdt_GND);
  Qe_qs_Vc1_c2_Vb1_b2=(+0.0*tmpExp+0.0*tmpExp_Vb1_b2+0.0*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vb1_b2);
  Qe_qs_Vc1_c2_Vb2_c2=(+0.0*tmpExp+0.0*tmpExp_Vb2_c2+0.0*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vb2_c2);
  Qe_qs_Vc1_c2_Vc1_c2=(+0.0*tmpExp+0.0*tmpExp_Vc1_c2+0.0*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vc1_c2);
  Qe_qs_Vc1_c2_Vc4_c1=(+0.0*tmpExp+0.0*tmpExp_Vc4_c1+0.0*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vc4_c1);
  Qe_qs_Vc1_c2_Vb2_e1=(+0.0*tmpExp+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vc1_c2+Qe0*tmpExp_Vc1_c2_Vb2_e1);
#endif
Qe_qs_Vc4_c1=(Qe0*tmpExp_Vc4_c1);
#if defined(_DERIVATE2)
  Qe_qs_Vc4_c1_Vdt_GND=(+0.0*tmpExp+0.0*tmpExp_Vdt_GND+Qe0_Vdt_GND*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vdt_GND);
  Qe_qs_Vc4_c1_Vb1_b2=(+0.0*tmpExp+0.0*tmpExp_Vb1_b2+0.0*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vb1_b2);
  Qe_qs_Vc4_c1_Vb2_c2=(+0.0*tmpExp+0.0*tmpExp_Vb2_c2+0.0*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vb2_c2);
  Qe_qs_Vc4_c1_Vc1_c2=(+0.0*tmpExp+0.0*tmpExp_Vc1_c2+0.0*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vc1_c2);
  Qe_qs_Vc4_c1_Vc4_c1=(+0.0*tmpExp+0.0*tmpExp_Vc4_c1+0.0*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vc4_c1);
  Qe_qs_Vc4_c1_Vb2_e1=(+0.0*tmpExp+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vc4_c1+Qe0*tmpExp_Vc4_c1_Vb2_e1);
#endif
Qe_qs_Vb2_e1=(Qe0*tmpExp_Vb2_e1);
#if defined(_DERIVATE2)
  Qe_qs_Vb2_e1_Vdt_GND=(+0.0*tmpExp+0.0*tmpExp_Vdt_GND+Qe0_Vdt_GND*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vdt_GND);
  Qe_qs_Vb2_e1_Vb1_b2=(+0.0*tmpExp+0.0*tmpExp_Vb1_b2+0.0*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vb1_b2);
  Qe_qs_Vb2_e1_Vb2_c2=(+0.0*tmpExp+0.0*tmpExp_Vb2_c2+0.0*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vb2_c2);
  Qe_qs_Vb2_e1_Vc1_c2=(+0.0*tmpExp+0.0*tmpExp_Vc1_c2+0.0*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vc1_c2);
  Qe_qs_Vb2_e1_Vc4_c1=(+0.0*tmpExp+0.0*tmpExp_Vc4_c1+0.0*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vc4_c1);
  Qe_qs_Vb2_e1_Vb2_e1=(+0.0*tmpExp+0.0*tmpExp_Vb2_e1+0.0*tmpExp_Vb2_e1+Qe0*tmpExp_Vb2_e1_Vb2_e1);
#endif
#endif
Qe_qs=(Qe0*tmpExp);
EXIT_IF_ISNAN((Qe0*tmpExp))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe=V(c1,GND)V(b1,GND)V(b2,GND)V(e1,GND)V(c2,GND)V(b,GND) */
Qepi0_Vdt_GND=(((((4.0*TEPI_T_Vdt_GND)*Vt)+((4.0*TEPI_T)*Vt_Vdt_GND))*RCV_TM-((4.0*TEPI_T)*Vt)*RCV_TM_Vdt_GND)/RCV_TM/RCV_TM);
#endif
Qepi0=(((4.0*TEPI_T)*Vt)/RCV_TM);
EXIT_IF_ISNAN((((4.0*TEPI_T)*Vt)/RCV_TM))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND) */
#if defined(_DERIVATE)
Qepi_Vdt_GND=(((((0.5*Qepi0_Vdt_GND)*xi_w)+((0.5*Qepi0)*xi_w_Vdt_GND))*((p0star+pW)+2.0))+(((0.5*Qepi0)*xi_w)*(p0star_Vdt_GND+pW_Vdt_GND)));
#endif
Qepi_Vb2_c2=((((0.5*Qepi0)*xi_w_Vb2_c2)*((p0star+pW)+2.0))+(((0.5*Qepi0)*xi_w)*p0star_Vb2_c2));
#if defined(_DERIVATE2)
  Qepi_Vb2_c2_Vdt_GND=(+(+(+0.0*Qepi0+0.0*Qepi0_Vdt_GND+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vdt_GND+((0.5*Qepi0_Vdt_GND))*xi_w_Vb2_c2+(0.5*Qepi0)*xi_w_Vb2_c2_Vdt_GND)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c2)*(p0star_Vdt_GND+pW_Vdt_GND)+(((((0.5*Qepi0_Vdt_GND))*xi_w)+((0.5*Qepi0)*xi_w_Vdt_GND)))*p0star_Vb2_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c2_Vdt_GND+0.0)+0.0));
  Qepi_Vb2_c2_Vb2_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c2+(0.0)*xi_w_Vb2_c2+(0.5*Qepi0)*xi_w_Vb2_c2_Vb2_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c2)*p0star_Vb2_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c2)))*p0star_Vb2_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c2_Vb2_c2+0.0)+0.0));
  Qepi_Vb2_c2_Vb2_c1=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c1+(0.0)*xi_w_Vb2_c2+(0.5*Qepi0)*xi_w_Vb2_c2_Vb2_c1)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c2)*(p0star_Vb2_c1+pW_Vb2_c1)+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c1)))*p0star_Vb2_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c2_Vb2_c1+0.0)+0.0));
  Qepi_Vb2_c2_Vc1_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vc1_c2+(0.0)*xi_w_Vb2_c2+(0.5*Qepi0)*xi_w_Vb2_c2_Vc1_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c2)*p0star_Vc1_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vc1_c2)))*p0star_Vb2_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c2_Vc1_c2+0.0)+0.0));
#endif
Qepi_Vb2_c1=((((0.5*Qepi0)*xi_w_Vb2_c1)*((p0star+pW)+2.0))+(((0.5*Qepi0)*xi_w)*(p0star_Vb2_c1+pW_Vb2_c1)));
#if defined(_DERIVATE2)
  Qepi_Vb2_c1_Vdt_GND=(+(+(+0.0*Qepi0+0.0*Qepi0_Vdt_GND+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vdt_GND+((0.5*Qepi0_Vdt_GND))*xi_w_Vb2_c1+(0.5*Qepi0)*xi_w_Vb2_c1_Vdt_GND)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c1)*(p0star_Vdt_GND+pW_Vdt_GND)+(((((0.5*Qepi0_Vdt_GND))*xi_w)+((0.5*Qepi0)*xi_w_Vdt_GND)))*(p0star_Vb2_c1+pW_Vb2_c1)+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c1_Vdt_GND+pW_Vb2_c1_Vdt_GND)+0.0));
  Qepi_Vb2_c1_Vb2_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c2+(0.0)*xi_w_Vb2_c1+(0.5*Qepi0)*xi_w_Vb2_c1_Vb2_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c1)*p0star_Vb2_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c2)))*(p0star_Vb2_c1+pW_Vb2_c1)+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c1_Vb2_c2+0.0)+0.0));
  Qepi_Vb2_c1_Vb2_c1=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c1+(0.0)*xi_w_Vb2_c1+(0.5*Qepi0)*xi_w_Vb2_c1_Vb2_c1)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c1)*(p0star_Vb2_c1+pW_Vb2_c1)+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c1)))*(p0star_Vb2_c1+pW_Vb2_c1)+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c1_Vb2_c1+pW_Vb2_c1_Vb2_c1)+0.0));
  Qepi_Vb2_c1_Vc1_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vc1_c2+(0.0)*xi_w_Vb2_c1+(0.5*Qepi0)*xi_w_Vb2_c1_Vc1_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vb2_c1)*p0star_Vc1_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vc1_c2)))*(p0star_Vb2_c1+pW_Vb2_c1)+((0.5*Qepi0)*xi_w)*(+(+p0star_Vb2_c1_Vc1_c2+0.0)+0.0));
#endif
Qepi_Vc1_c2=((((0.5*Qepi0)*xi_w_Vc1_c2)*((p0star+pW)+2.0))+(((0.5*Qepi0)*xi_w)*p0star_Vc1_c2));
#if defined(_DERIVATE2)
  Qepi_Vc1_c2_Vdt_GND=(+(+(+0.0*Qepi0+0.0*Qepi0_Vdt_GND+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vdt_GND+((0.5*Qepi0_Vdt_GND))*xi_w_Vc1_c2+(0.5*Qepi0)*xi_w_Vc1_c2_Vdt_GND)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vc1_c2)*(p0star_Vdt_GND+pW_Vdt_GND)+(((((0.5*Qepi0_Vdt_GND))*xi_w)+((0.5*Qepi0)*xi_w_Vdt_GND)))*p0star_Vc1_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vc1_c2_Vdt_GND+0.0)+0.0));
  Qepi_Vc1_c2_Vb2_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c2+(0.0)*xi_w_Vc1_c2+(0.5*Qepi0)*xi_w_Vc1_c2_Vb2_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vc1_c2)*p0star_Vb2_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c2)))*p0star_Vc1_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vc1_c2_Vb2_c2+0.0)+0.0));
  Qepi_Vc1_c2_Vb2_c1=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vb2_c1+(0.0)*xi_w_Vc1_c2+(0.5*Qepi0)*xi_w_Vc1_c2_Vb2_c1)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vc1_c2)*(p0star_Vb2_c1+pW_Vb2_c1)+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vb2_c1)))*p0star_Vc1_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vc1_c2_Vb2_c1+0.0)+0.0));
  Qepi_Vc1_c2_Vc1_c2=(+(+(+0.0*Qepi0+0.0*0.0+0.0*0.0+0.5*0.0)*xi_w+0.0*xi_w_Vc1_c2+(0.0)*xi_w_Vc1_c2+(0.5*Qepi0)*xi_w_Vc1_c2_Vc1_c2)*((p0star+pW)+2.0)+((0.5*Qepi0)*xi_w_Vc1_c2)*p0star_Vc1_c2+((((0.0)*xi_w)+((0.5*Qepi0)*xi_w_Vc1_c2)))*p0star_Vc1_c2+((0.5*Qepi0)*xi_w)*(+(+p0star_Vc1_c2_Vc1_c2+0.0)+0.0));
#endif
#endif
Qepi=(((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0));
EXIT_IF_ISNAN((((0.5*Qepi0)*xi_w)*((p0star+pW)+2.0)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Qex_Vdt_GND=((((TAUR_T_Vdt_GND*0.5*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND))+((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND)))))*(pInst->TAUB_T+TEPI_T)-((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
Qex_Vb1_b2=(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))/(pInst->TAUB_T+TEPI_T));
#if defined(_DERIVATE2)
  Qex_Vb1_b2_Vdt_GND=((+(+0.0*0.5+0.0*0.0+TAUR_T_Vdt_GND*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND))))+(TAUR_T_Vdt_GND*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vdt_GND+Qb0_Vdt_GND*nBex_Vb1_b2+Qb0*nBex_Vb1_b2_Vdt_GND)+(+0.0*pWex+0.0*pWex_Vdt_GND+Qepi0_Vdt_GND*pWex_Vb1_b2+Qepi0*pWex_Vb1_b2_Vdt_GND)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)+((((TAUR_T_Vdt_GND*0.5)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND)))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb1_b2_Vb1_b2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2)))+(0.0)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vb1_b2+Qb0*nBex_Vb1_b2_Vb1_b2)+(+0.0*pWex+0.0*pWex_Vb1_b2+0.0*pWex_Vb1_b2+Qepi0*pWex_Vb1_b2_Vb1_b2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb1_b2_Vb2_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2)))+(0.0)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vb1_b2+Qb0*nBex_Vb1_b2_Vb2_c2)+(+0.0*pWex+0.0*pWex_Vb2_c2+0.0*pWex_Vb1_b2+Qepi0*pWex_Vb1_b2_Vb2_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb1_b2_Vc1_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2)))+(0.0)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vb1_b2+Qb0*nBex_Vb1_b2_Vc1_c2)+(+0.0*pWex+0.0*pWex_Vc1_c2+0.0*pWex_Vb1_b2+Qepi0*pWex_Vb1_b2_Vc1_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb1_b2_Vc4_c1=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1)))+(0.0)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vb1_b2+Qb0*nBex_Vb1_b2_Vc4_c1)+(+0.0*pWex+0.0*pWex_Vc4_c1+0.0*pWex_Vb1_b2+Qepi0*pWex_Vb1_b2_Vc4_c1)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb1_b2)+(Qepi0*pWex_Vb1_b2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
Qex_Vb2_c2=(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))/(pInst->TAUB_T+TEPI_T));
#if defined(_DERIVATE2)
  Qex_Vb2_c2_Vdt_GND=((+(+0.0*0.5+0.0*0.0+TAUR_T_Vdt_GND*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND))))+(TAUR_T_Vdt_GND*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vdt_GND+Qb0_Vdt_GND*nBex_Vb2_c2+Qb0*nBex_Vb2_c2_Vdt_GND)+(+0.0*pWex+0.0*pWex_Vdt_GND+Qepi0_Vdt_GND*pWex_Vb2_c2+Qepi0*pWex_Vb2_c2_Vdt_GND)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)+((((TAUR_T_Vdt_GND*0.5)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND)))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb2_c2_Vb1_b2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2)))+(0.0)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vb2_c2+Qb0*nBex_Vb2_c2_Vb1_b2)+(+0.0*pWex+0.0*pWex_Vb1_b2+0.0*pWex_Vb2_c2+Qepi0*pWex_Vb2_c2_Vb1_b2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb2_c2_Vb2_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2)))+(0.0)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vb2_c2+Qb0*nBex_Vb2_c2_Vb2_c2)+(+0.0*pWex+0.0*pWex_Vb2_c2+0.0*pWex_Vb2_c2+Qepi0*pWex_Vb2_c2_Vb2_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb2_c2_Vc1_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2)))+(0.0)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vb2_c2+Qb0*nBex_Vb2_c2_Vc1_c2)+(+0.0*pWex+0.0*pWex_Vc1_c2+0.0*pWex_Vb2_c2+Qepi0*pWex_Vb2_c2_Vc1_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vb2_c2_Vc4_c1=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1)))+(0.0)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vb2_c2+Qb0*nBex_Vb2_c2_Vc4_c1)+(+0.0*pWex+0.0*pWex_Vc4_c1+0.0*pWex_Vb2_c2+Qepi0*pWex_Vb2_c2_Vc4_c1)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vb2_c2)+(Qepi0*pWex_Vb2_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
Qex_Vc1_c2=(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))/(pInst->TAUB_T+TEPI_T));
#if defined(_DERIVATE2)
  Qex_Vc1_c2_Vdt_GND=((+(+0.0*0.5+0.0*0.0+TAUR_T_Vdt_GND*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND))))+(TAUR_T_Vdt_GND*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vdt_GND+Qb0_Vdt_GND*nBex_Vc1_c2+Qb0*nBex_Vc1_c2_Vdt_GND)+(+0.0*pWex+0.0*pWex_Vdt_GND+Qepi0_Vdt_GND*pWex_Vc1_c2+Qepi0*pWex_Vc1_c2_Vdt_GND)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)+((((TAUR_T_Vdt_GND*0.5)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*((((Qb0_Vdt_GND*nBex)+(Qb0*nBex_Vdt_GND)))+(((Qepi0_Vdt_GND*pWex)+(Qepi0*pWex_Vdt_GND)))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vc1_c2_Vb1_b2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2)))+(0.0)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb1_b2+0.0*nBex_Vc1_c2+Qb0*nBex_Vc1_c2_Vb1_b2)+(+0.0*pWex+0.0*pWex_Vb1_b2+0.0*pWex_Vc1_c2+Qepi0*pWex_Vc1_c2_Vb1_b2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb1_b2))+((Qepi0*pWex_Vb1_b2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vc1_c2_Vb2_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2)))+(0.0)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vb2_c2+0.0*nBex_Vc1_c2+Qb0*nBex_Vc1_c2_Vb2_c2)+(+0.0*pWex+0.0*pWex_Vb2_c2+0.0*pWex_Vc1_c2+Qepi0*pWex_Vc1_c2_Vb2_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vb2_c2))+((Qepi0*pWex_Vb2_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vc1_c2_Vc1_c2=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2)))+(0.0)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc1_c2+0.0*nBex_Vc1_c2+Qb0*nBex_Vc1_c2_Vc1_c2)+(+0.0*pWex+0.0*pWex_Vc1_c2+0.0*pWex_Vc1_c2+Qepi0*pWex_Vc1_c2_Vc1_c2)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc1_c2))+((Qepi0*pWex_Vc1_c2))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  Qex_Vc1_c2_Vc4_c1=((+(+0.0*0.5+0.0*0.0+0.0*0.0+TAUR_T*0.0)*((Qb0*nBex)+(Qepi0*pWex))+0.0*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1)))+(0.0)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2))+(TAUR_T*0.5)*(+(+0.0*nBex+0.0*nBex_Vc4_c1+0.0*nBex_Vc1_c2+Qb0*nBex_Vc1_c2_Vc4_c1)+(+0.0*pWex+0.0*pWex_Vc4_c1+0.0*pWex_Vc1_c2+Qepi0*pWex_Vc1_c2_Vc4_c1)))/(pInst->TAUB_T+TEPI_T)-(((TAUR_T*0.5)*((Qb0*nBex_Vc1_c2)+(Qepi0*pWex_Vc1_c2)))*0.0+((((0.0)*((Qb0*nBex)+(Qepi0*pWex)))+((TAUR_T*0.5)*(((Qb0*nBex_Vc4_c1))+((Qepi0*pWex_Vc4_c1))))))*0.0+((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
Qex_Vc4_c1=(((TAUR_T*0.5)*((Qb0*nBex_Vc4_c1)+(Qepi0*pWex_Vc4_c1)))/(pInst->TAUB_T+TEPI_T));
#endif
#endif
Qex=(((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(pInst->TAUB_T+TEPI_T));
EXIT_IF_ISNAN((((TAUR_T*0.5)*((Qb0*nBex)+(Qepi0*pWex)))/(pInst->TAUB_T+TEPI_T)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XQex_Vdt_GND=0.0;
#endif
XQex_Vb_c=0.0;
#if defined(_DERIVATE2)
  XQex_Vb_c_Vdt_GND=0.0;
  XQex_Vb_c_Vb_c=0.0;
  XQex_Vb_c_Vb_b1=0.0;
  XQex_Vb_c_Vb1_b2=0.0;
  XQex_Vb_c_Vc4_c1=0.0;
  XQex_Vb_c_Vc3_c1=0.0;
  XQex_Vb_c_Vc3_c4=0.0;
  XQex_Vb_c_Vb2_e1=0.0;
  XQex_Vb_c_Vb2_c2=0.0;
  XQex_Vb_c_Vb2_c1=0.0;
  XQex_Vb_c_Vc1_c2=0.0;
  XQex_Vb_c_Vs_c1=0.0;
#endif
XQex_Vb_b1=0.0;
#if defined(_DERIVATE2)
  XQex_Vb_b1_Vdt_GND=0.0;
  XQex_Vb_b1_Vb_c=0.0;
  XQex_Vb_b1_Vb_b1=0.0;
  XQex_Vb_b1_Vb1_b2=0.0;
  XQex_Vb_b1_Vc4_c1=0.0;
  XQex_Vb_b1_Vc3_c1=0.0;
  XQex_Vb_b1_Vc3_c4=0.0;
  XQex_Vb_b1_Vb2_e1=0.0;
  XQex_Vb_b1_Vb2_c2=0.0;
  XQex_Vb_b1_Vb2_c1=0.0;
  XQex_Vb_b1_Vc1_c2=0.0;
  XQex_Vb_b1_Vs_c1=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vb1_b2=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vc4_c1=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vc3_c1=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vb2_e1=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vb2_c2=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vb2_c1=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vc1_c2=0.0;
#endif
#if defined(_DERIVATE)
XQex_Vs_c1=0.0;
#endif
#endif
XQex=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#ifdef _DYNAMIC
if
((pModel->EXMOD==1))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe=V(c2,GND)V(e1,GND)V(b2,GND)V(b1,GND) */
#if defined(_DERIVATE)
Qex_Vdt_GND=Qex_Vdt_GND*(1.0-pModel->XEXT);
#endif
Qex_Vb1_b2=Qex_Vb1_b2*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qex_Vb1_b2_Vdt_GND=(+Qex_Vb1_b2_Vdt_GND*(1.0-pModel->XEXT)+Qex_Vb1_b2*0.0+Qex_Vdt_GND*0.0+Qex*(+0.0-0.0));
  Qex_Vb1_b2_Vb1_b2=(+Qex_Vb1_b2_Vb1_b2*(1.0-pModel->XEXT)+Qex_Vb1_b2*0.0+Qex_Vb1_b2*0.0+Qex*(+0.0-0.0));
  Qex_Vb1_b2_Vb2_c2=(+Qex_Vb1_b2_Vb2_c2*(1.0-pModel->XEXT)+Qex_Vb1_b2*0.0+Qex_Vb2_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vb1_b2_Vc1_c2=(+Qex_Vb1_b2_Vc1_c2*(1.0-pModel->XEXT)+Qex_Vb1_b2*0.0+Qex_Vc1_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vb1_b2_Vc4_c1=(+Qex_Vb1_b2_Vc4_c1*(1.0-pModel->XEXT)+Qex_Vb1_b2*0.0+Qex_Vc4_c1*0.0+Qex*(+0.0-0.0));
#endif
Qex_Vb2_c2=Qex_Vb2_c2*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qex_Vb2_c2_Vdt_GND=(+Qex_Vb2_c2_Vdt_GND*(1.0-pModel->XEXT)+Qex_Vb2_c2*0.0+Qex_Vdt_GND*0.0+Qex*(+0.0-0.0));
  Qex_Vb2_c2_Vb1_b2=(+Qex_Vb2_c2_Vb1_b2*(1.0-pModel->XEXT)+Qex_Vb2_c2*0.0+Qex_Vb1_b2*0.0+Qex*(+0.0-0.0));
  Qex_Vb2_c2_Vb2_c2=(+Qex_Vb2_c2_Vb2_c2*(1.0-pModel->XEXT)+Qex_Vb2_c2*0.0+Qex_Vb2_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vb2_c2_Vc1_c2=(+Qex_Vb2_c2_Vc1_c2*(1.0-pModel->XEXT)+Qex_Vb2_c2*0.0+Qex_Vc1_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vb2_c2_Vc4_c1=(+Qex_Vb2_c2_Vc4_c1*(1.0-pModel->XEXT)+Qex_Vb2_c2*0.0+Qex_Vc4_c1*0.0+Qex*(+0.0-0.0));
#endif
Qex_Vc1_c2=Qex_Vc1_c2*(1.0-pModel->XEXT);
#if defined(_DERIVATE2)
  Qex_Vc1_c2_Vdt_GND=(+Qex_Vc1_c2_Vdt_GND*(1.0-pModel->XEXT)+Qex_Vc1_c2*0.0+Qex_Vdt_GND*0.0+Qex*(+0.0-0.0));
  Qex_Vc1_c2_Vb1_b2=(+Qex_Vc1_c2_Vb1_b2*(1.0-pModel->XEXT)+Qex_Vc1_c2*0.0+Qex_Vb1_b2*0.0+Qex*(+0.0-0.0));
  Qex_Vc1_c2_Vb2_c2=(+Qex_Vc1_c2_Vb2_c2*(1.0-pModel->XEXT)+Qex_Vc1_c2*0.0+Qex_Vb2_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vc1_c2_Vc1_c2=(+Qex_Vc1_c2_Vc1_c2*(1.0-pModel->XEXT)+Qex_Vc1_c2*0.0+Qex_Vc1_c2*0.0+Qex*(+0.0-0.0));
  Qex_Vc1_c2_Vc4_c1=(+Qex_Vc1_c2_Vc4_c1*(1.0-pModel->XEXT)+Qex_Vc1_c2*0.0+Qex_Vc4_c1*0.0+Qex*(+0.0-0.0));
#endif
#if defined(_DERIVATE)
Qex_Vc4_c1=Qex_Vc4_c1*(1.0-pModel->XEXT);
#endif
#endif
Qex=(Qex*(1.0-pModel->XEXT));
EXIT_IF_ISNAN((Qex*(1.0-pModel->XEXT)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
Xg2_Vb_c=(4.0*eVbc3VDC_Vb_c);
#if defined(_DERIVATE2)
  Xg2_Vb_c_Vb_c=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb_c+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vb_c);
  Xg2_Vb_c_Vb_b1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb_b1+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vb_b1);
  Xg2_Vb_c_Vb1_b2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb1_b2+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vb1_b2);
  Xg2_Vb_c_Vb2_c2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb2_c2+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vb2_c2);
  Xg2_Vb_c_Vc1_c2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc1_c2+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vc1_c2);
  Xg2_Vb_c_Vc4_c1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc4_c1+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vc4_c1);
  Xg2_Vb_c_Vc3_c1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc3_c1+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vc3_c1);
  Xg2_Vb_c_Vc3_c4=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc3_c4+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vc3_c4);
  Xg2_Vb_c_Vdt_GND=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vdt_GND+0.0*eVbc3VDC_Vb_c+4.0*eVbc3VDC_Vb_c_Vdt_GND);
#endif
Xg2_Vb_b1=(4.0*eVbc3VDC_Vb_b1);
#if defined(_DERIVATE2)
  Xg2_Vb_b1_Vb_c=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb_c+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vb_c);
  Xg2_Vb_b1_Vb_b1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb_b1+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vb_b1);
  Xg2_Vb_b1_Vb1_b2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb1_b2+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vb1_b2);
  Xg2_Vb_b1_Vb2_c2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vb2_c2+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vb2_c2);
  Xg2_Vb_b1_Vc1_c2=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc1_c2+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vc1_c2);
  Xg2_Vb_b1_Vc4_c1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc4_c1+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vc4_c1);
  Xg2_Vb_b1_Vc3_c1=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc3_c1+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vc3_c1);
  Xg2_Vb_b1_Vc3_c4=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vc3_c4+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vc3_c4);
  Xg2_Vb_b1_Vdt_GND=(+0.0*eVbc3VDC+0.0*eVbc3VDC_Vdt_GND+0.0*eVbc3VDC_Vb_b1+4.0*eVbc3VDC_Vb_b1_Vdt_GND);
#endif
#if defined(_DERIVATE)
Xg2_Vb1_b2=(4.0*eVbc3VDC_Vb1_b2);
#endif
#if defined(_DERIVATE)
Xg2_Vb2_c2=(4.0*eVbc3VDC_Vb2_c2);
#endif
#if defined(_DERIVATE)
Xg2_Vc1_c2=(4.0*eVbc3VDC_Vc1_c2);
#endif
#if defined(_DERIVATE)
Xg2_Vc4_c1=(4.0*eVbc3VDC_Vc4_c1);
#endif
#if defined(_DERIVATE)
Xg2_Vc3_c1=(4.0*eVbc3VDC_Vc3_c1);
#endif
#if defined(_DERIVATE)
Xg2_Vc3_c4=(4.0*eVbc3VDC_Vc3_c4);
#endif
#if defined(_DERIVATE)
Xg2_Vdt_GND=(4.0*eVbc3VDC_Vdt_GND);
#endif
#endif
Xg2=(4.0*eVbc3VDC);
EXIT_IF_ISNAN((4.0*eVbc3VDC))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0+Xg2))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+Xg2))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b,c)V(b,b1)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(c3,c1)V(c3,c4)V(dt,GND) ddxprobe=V(b,GND) */
XpWex_Vb_c=((Xg2_Vb_c*(1.0+d00_sqrt0)-Xg2*Xg2_Vb_c*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XpWex_Vb_c_Vb_c=(Xg2_Vb_c_Vb_c/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vb_c*d10_sqrt0+Xg2_Vb_c*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb_c*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vb_c))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vb_c*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vb_b1=(Xg2_Vb_c_Vb_b1/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vb_b1*d10_sqrt0+Xg2_Vb_b1*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb_b1*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vb_b1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vb_b1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vb1_b2=(Xg2_Vb_c_Vb1_b2/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vb1_b2*d10_sqrt0+Xg2_Vb1_b2*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb1_b2*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vb2_c2=(Xg2_Vb_c_Vb2_c2/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vb2_c2*d10_sqrt0+Xg2_Vb2_c2*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb2_c2*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vc1_c2=(Xg2_Vb_c_Vc1_c2/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vc1_c2*d10_sqrt0+Xg2_Vc1_c2*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc1_c2*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vc4_c1=(Xg2_Vb_c_Vc4_c1/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vc4_c1*d10_sqrt0+Xg2_Vc4_c1*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc4_c1*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vc3_c1=(Xg2_Vb_c_Vc3_c1/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vc3_c1*d10_sqrt0+Xg2_Vc3_c1*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc3_c1*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vc3_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vc3_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vc3_c4=(Xg2_Vb_c_Vc3_c4/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vc3_c4*d10_sqrt0+Xg2_Vc3_c4*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc3_c4*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vc3_c4))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vc3_c4*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_c_Vdt_GND=(Xg2_Vb_c_Vdt_GND/(1.0+d00_sqrt0)-(Xg2_Vb_c*Xg2_Vdt_GND*d10_sqrt0+Xg2_Vdt_GND*Xg2_Vb_c*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vdt_GND*Xg2_Vb_c+d10_sqrt0*(+0.0+Xg2_Vb_c_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_c*d10_sqrt0*Xg2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
XpWex_Vb_b1=((Xg2_Vb_b1*(1.0+d00_sqrt0)-Xg2*Xg2_Vb_b1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#if defined(_DERIVATE2)
  XpWex_Vb_b1_Vb_c=(Xg2_Vb_b1_Vb_c/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vb_c*d10_sqrt0+Xg2_Vb_c*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb_c*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vb_c))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vb_c*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vb_b1=(Xg2_Vb_b1_Vb_b1/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vb_b1*d10_sqrt0+Xg2_Vb_b1*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb_b1*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vb_b1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vb_b1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vb1_b2=(Xg2_Vb_b1_Vb1_b2/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vb1_b2*d10_sqrt0+Xg2_Vb1_b2*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb1_b2*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vb1_b2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vb1_b2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vb2_c2=(Xg2_Vb_b1_Vb2_c2/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vb2_c2*d10_sqrt0+Xg2_Vb2_c2*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vb2_c2*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vb2_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vb2_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vc1_c2=(Xg2_Vb_b1_Vc1_c2/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vc1_c2*d10_sqrt0+Xg2_Vc1_c2*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc1_c2*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vc1_c2))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vc1_c2*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vc4_c1=(Xg2_Vb_b1_Vc4_c1/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vc4_c1*d10_sqrt0+Xg2_Vc4_c1*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc4_c1*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vc4_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vc4_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vc3_c1=(Xg2_Vb_b1_Vc3_c1/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vc3_c1*d10_sqrt0+Xg2_Vc3_c1*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc3_c1*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vc3_c1))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vc3_c1*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vc3_c4=(Xg2_Vb_b1_Vc3_c4/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vc3_c4*d10_sqrt0+Xg2_Vc3_c4*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vc3_c4*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vc3_c4))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vc3_c4*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
  XpWex_Vb_b1_Vdt_GND=(Xg2_Vb_b1_Vdt_GND/(1.0+d00_sqrt0)-(Xg2_Vb_b1*Xg2_Vdt_GND*d10_sqrt0+Xg2_Vdt_GND*Xg2_Vb_b1*d10_sqrt0+Xg2*(+0.0+(m20_sqrt((1.0+Xg2))*Xg2_Vdt_GND*Xg2_Vb_b1+d10_sqrt0*(+0.0+Xg2_Vb_b1_Vdt_GND))))/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)+2*Xg2*Xg2_Vb_b1*d10_sqrt0*Xg2_Vdt_GND*d10_sqrt0/(1.0+d00_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vb1_b2=((Xg2_Vb1_b2*(1.0+d00_sqrt0)-Xg2*Xg2_Vb1_b2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vb2_c2=((Xg2_Vb2_c2*(1.0+d00_sqrt0)-Xg2*Xg2_Vb2_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vc1_c2=((Xg2_Vc1_c2*(1.0+d00_sqrt0)-Xg2*Xg2_Vc1_c2*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vc4_c1=((Xg2_Vc4_c1*(1.0+d00_sqrt0)-Xg2*Xg2_Vc4_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vc3_c1=((Xg2_Vc3_c1*(1.0+d00_sqrt0)-Xg2*Xg2_Vc3_c1*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vc3_c4=((Xg2_Vc3_c4*(1.0+d00_sqrt0)-Xg2*Xg2_Vc3_c4*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#if defined(_DERIVATE)
XpWex_Vdt_GND=((Xg2_Vdt_GND*(1.0+d00_sqrt0)-Xg2*Xg2_Vdt_GND*d10_sqrt0)/(1.0+d00_sqrt0)/(1.0+d00_sqrt0));
#endif
#endif
XpWex=(Xg2/(1.0+d00_sqrt0));
EXIT_IF_ISNAN((Xg2/(1.0+d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe=V(b,GND) */
#if defined(_DERIVATE)
XQex_Vdt_GND=(((((((0.5*Fex_Vdt_GND)*pModel->XEXT*TAUR_T)+(((0.5*Fex)*pModel->XEXT)*TAUR_T_Vdt_GND))*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0_Vdt_GND*XnBex)+(Qb0*XnBex_Vdt_GND))+((Qepi0_Vdt_GND*XpWex)+(Qepi0*XpWex_Vdt_GND)))))*(pInst->TAUB_T+TEPI_T)-((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
XQex_Vb_c=((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))/(pInst->TAUB_T+TEPI_T));
#if defined(_DERIVATE2)
  XQex_Vb_c_Vdt_GND=((+(+(+(+0.0*Fex+0.0*Fex_Vdt_GND+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vdt_GND)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vdt_GND))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T_Vdt_GND+(((0.5*Fex_Vdt_GND))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((((Qb0_Vdt_GND*XnBex)+(Qb0*XnBex_Vdt_GND)))+(((Qepi0_Vdt_GND*XpWex)+(Qepi0*XpWex_Vdt_GND))))+((((((0.5*Fex_Vdt_GND))*pModel->XEXT)*TAUR_T)+(((0.5*Fex)*pModel->XEXT)*TAUR_T_Vdt_GND)))*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vdt_GND+Qb0_Vdt_GND*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vdt_GND)+(+0.0*XpWex+0.0*XpWex_Vdt_GND+Qepi0_Vdt_GND*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vdt_GND)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)+(((((((((0.5*Fex_Vdt_GND))*pModel->XEXT)*TAUR_T)+(((0.5*Fex)*pModel->XEXT)*TAUR_T_Vdt_GND)))*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((((Qb0_Vdt_GND*XnBex)+(Qb0*XnBex_Vdt_GND)))+(((Qepi0_Vdt_GND*XpWex)+(Qepi0*XpWex_Vdt_GND)))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb_c=((+(+(+(+0.0*Fex+0.0*Fex_Vb_c+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb_c)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb_c))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb_c))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb_c))+((Qepi0*XpWex_Vb_c)))+((((0.5*Fex_Vb_c))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb_c+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vb_c)+(+0.0*XpWex+0.0*XpWex_Vb_c+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vb_c)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb_c))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb_c))+((Qepi0*XpWex_Vb_c))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb_b1=((+(+(+(+0.0*Fex+0.0*Fex_Vb_b1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb_b1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb_b1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb_b1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb_b1))+((Qepi0*XpWex_Vb_b1)))+((((0.5*Fex_Vb_b1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb_b1+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vb_b1)+(+0.0*XpWex+0.0*XpWex_Vb_b1+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vb_b1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb_b1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb_b1))+((Qepi0*XpWex_Vb_b1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb1_b2=((+(+(+(+0.0*Fex+0.0*Fex_Vb1_b2+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb1_b2)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb1_b2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb1_b2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb1_b2))+((Qepi0*XpWex_Vb1_b2)))+((((0.5*Fex_Vb1_b2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb1_b2+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vb1_b2)+(+0.0*XpWex+0.0*XpWex_Vb1_b2+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vb1_b2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb1_b2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb1_b2))+((Qepi0*XpWex_Vb1_b2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vc4_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vc4_c1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vc4_c1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vc4_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vc4_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc4_c1))+((Qepi0*XpWex_Vc4_c1)))+((((0.5*Fex_Vc4_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc4_c1+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vc4_c1)+(+0.0*XpWex+0.0*XpWex_Vc4_c1+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vc4_c1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vc4_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc4_c1))+((Qepi0*XpWex_Vc4_c1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vc3_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vc3_c1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vc3_c1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vc3_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vc3_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc3_c1))+((Qepi0*XpWex_Vc3_c1)))+((((0.5*Fex_Vc3_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc3_c1+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vc3_c1)+(+0.0*XpWex+0.0*XpWex_Vc3_c1+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vc3_c1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vc3_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc3_c1))+((Qepi0*XpWex_Vc3_c1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vc3_c4=((+(+(+(+0.0*Fex+0.0*Fex_Vc3_c4+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vc3_c4)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vc3_c4))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vc3_c4))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc3_c4))+((Qepi0*XpWex_Vc3_c4)))+((((0.5*Fex_Vc3_c4))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc3_c4+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vc3_c4)+(+0.0*XpWex+0.0*XpWex_Vc3_c4+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vc3_c4)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vc3_c4))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc3_c4))+((Qepi0*XpWex_Vc3_c4))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb2_e1=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_e1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb2_e1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb2_e1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_e1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vb2_e1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_c+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_c+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb2_e1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb2_c2=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_c2+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb2_c2)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb2_c2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_c2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb2_c2))+((Qepi0*XpWex_Vb2_c2)))+((((0.5*Fex_Vb2_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb2_c2+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vb2_c2)+(+0.0*XpWex+0.0*XpWex_Vb2_c2+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vb2_c2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb2_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb2_c2))+((Qepi0*XpWex_Vb2_c2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vb2_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_c1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vb2_c1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vb2_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vb2_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_c+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_c+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vb2_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vc1_c2=((+(+(+(+0.0*Fex+0.0*Fex_Vc1_c2+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vc1_c2)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vc1_c2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vc1_c2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc1_c2))+((Qepi0*XpWex_Vc1_c2)))+((((0.5*Fex_Vc1_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc1_c2+0.0*XnBex_Vb_c+Qb0*XnBex_Vb_c_Vc1_c2)+(+0.0*XpWex+0.0*XpWex_Vc1_c2+0.0*XpWex_Vb_c+Qepi0*XpWex_Vb_c_Vc1_c2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vc1_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc1_c2))+((Qepi0*XpWex_Vc1_c2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_c_Vs_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vs_c1+0.0*Fex_Vb_c+0.5*Fex_Vb_c_Vs_c1)*pModel->XEXT+(0.5*Fex_Vb_c)*0.0+((0.5*Fex_Vs_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_c)*pModel->XEXT*0.0+(((0.5*Fex_Vs_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vs_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_c+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_c+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_c)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_c)+(Qepi0*XpWex_Vb_c))))*0.0+(((((((0.5*Fex_Vs_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
XQex_Vb_b1=((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))/(pInst->TAUB_T+TEPI_T));
#if defined(_DERIVATE2)
  XQex_Vb_b1_Vdt_GND=((+(+(+(+0.0*Fex+0.0*Fex_Vdt_GND+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vdt_GND)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vdt_GND))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T_Vdt_GND+(((0.5*Fex_Vdt_GND))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((((Qb0_Vdt_GND*XnBex)+(Qb0*XnBex_Vdt_GND)))+(((Qepi0_Vdt_GND*XpWex)+(Qepi0*XpWex_Vdt_GND))))+((((((0.5*Fex_Vdt_GND))*pModel->XEXT)*TAUR_T)+(((0.5*Fex)*pModel->XEXT)*TAUR_T_Vdt_GND)))*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vdt_GND+Qb0_Vdt_GND*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vdt_GND)+(+0.0*XpWex+0.0*XpWex_Vdt_GND+Qepi0_Vdt_GND*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vdt_GND)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)+(((((((((0.5*Fex_Vdt_GND))*pModel->XEXT)*TAUR_T)+(((0.5*Fex)*pModel->XEXT)*TAUR_T_Vdt_GND)))*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((((Qb0_Vdt_GND*XnBex)+(Qb0*XnBex_Vdt_GND)))+(((Qepi0_Vdt_GND*XpWex)+(Qepi0*XpWex_Vdt_GND)))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*(TAUB_T_Vdt_GND+TEPI_T_Vdt_GND)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb_c=((+(+(+(+0.0*Fex+0.0*Fex_Vb_c+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb_c)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb_c))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb_c))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb_c))+((Qepi0*XpWex_Vb_c)))+((((0.5*Fex_Vb_c))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb_c+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vb_c)+(+0.0*XpWex+0.0*XpWex_Vb_c+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vb_c)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb_c))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb_c))+((Qepi0*XpWex_Vb_c))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb_b1=((+(+(+(+0.0*Fex+0.0*Fex_Vb_b1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb_b1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb_b1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb_b1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb_b1))+((Qepi0*XpWex_Vb_b1)))+((((0.5*Fex_Vb_b1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb_b1+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vb_b1)+(+0.0*XpWex+0.0*XpWex_Vb_b1+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vb_b1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb_b1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb_b1))+((Qepi0*XpWex_Vb_b1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb1_b2=((+(+(+(+0.0*Fex+0.0*Fex_Vb1_b2+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb1_b2)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb1_b2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb1_b2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb1_b2))+((Qepi0*XpWex_Vb1_b2)))+((((0.5*Fex_Vb1_b2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb1_b2+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vb1_b2)+(+0.0*XpWex+0.0*XpWex_Vb1_b2+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vb1_b2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb1_b2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb1_b2))+((Qepi0*XpWex_Vb1_b2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vc4_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vc4_c1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vc4_c1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vc4_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vc4_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc4_c1))+((Qepi0*XpWex_Vc4_c1)))+((((0.5*Fex_Vc4_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc4_c1+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vc4_c1)+(+0.0*XpWex+0.0*XpWex_Vc4_c1+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vc4_c1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vc4_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc4_c1))+((Qepi0*XpWex_Vc4_c1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vc3_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vc3_c1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vc3_c1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vc3_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vc3_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc3_c1))+((Qepi0*XpWex_Vc3_c1)))+((((0.5*Fex_Vc3_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc3_c1+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vc3_c1)+(+0.0*XpWex+0.0*XpWex_Vc3_c1+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vc3_c1)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vc3_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc3_c1))+((Qepi0*XpWex_Vc3_c1))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vc3_c4=((+(+(+(+0.0*Fex+0.0*Fex_Vc3_c4+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vc3_c4)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vc3_c4))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vc3_c4))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc3_c4))+((Qepi0*XpWex_Vc3_c4)))+((((0.5*Fex_Vc3_c4))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc3_c4+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vc3_c4)+(+0.0*XpWex+0.0*XpWex_Vc3_c4+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vc3_c4)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vc3_c4))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc3_c4))+((Qepi0*XpWex_Vc3_c4))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb2_e1=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_e1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb2_e1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb2_e1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_e1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vb2_e1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_b1+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_b1+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb2_e1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb2_c2=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_c2+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb2_c2)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb2_c2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_c2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vb2_c2))+((Qepi0*XpWex_Vb2_c2)))+((((0.5*Fex_Vb2_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vb2_c2+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vb2_c2)+(+0.0*XpWex+0.0*XpWex_Vb2_c2+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vb2_c2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb2_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vb2_c2))+((Qepi0*XpWex_Vb2_c2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vb2_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vb2_c1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vb2_c1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vb2_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vb2_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vb2_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_b1+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_b1+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vb2_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vc1_c2=((+(+(+(+0.0*Fex+0.0*Fex_Vc1_c2+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vc1_c2)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vc1_c2))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vc1_c2))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*(((Qb0*XnBex_Vc1_c2))+((Qepi0*XpWex_Vc1_c2)))+((((0.5*Fex_Vc1_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*XnBex_Vc1_c2+0.0*XnBex_Vb_b1+Qb0*XnBex_Vb_b1_Vc1_c2)+(+0.0*XpWex+0.0*XpWex_Vc1_c2+0.0*XpWex_Vb_b1+Qepi0*XpWex_Vb_b1_Vc1_c2)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vc1_c2))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*(((Qb0*XnBex_Vc1_c2))+((Qepi0*XpWex_Vc1_c2))))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
  XQex_Vb_b1_Vs_c1=((+(+(+(+0.0*Fex+0.0*Fex_Vs_c1+0.0*Fex_Vb_b1+0.5*Fex_Vb_b1_Vs_c1)*pModel->XEXT+(0.5*Fex_Vb_b1)*0.0+((0.5*Fex_Vs_c1))*0.0+(0.5*Fex)*0.0)*TAUR_T+(0.5*Fex_Vb_b1)*pModel->XEXT*0.0+(((0.5*Fex_Vs_c1))*pModel->XEXT)*0.0+((0.5*Fex)*pModel->XEXT)*0.0)*((Qb0*XnBex)+(Qepi0*XpWex))+(0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((0.0)+(0.0))+((((0.5*Fex_Vs_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))+(((0.5*Fex)*pModel->XEXT)*TAUR_T)*(+(+0.0*XnBex+0.0*0.0+0.0*XnBex_Vb_b1+Qb0*0.0)+(+0.0*XpWex+0.0*0.0+0.0*XpWex_Vb_b1+Qepi0*0.0)))/(pInst->TAUB_T+TEPI_T)-((((0.5*Fex_Vb_b1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb_b1)+(Qepi0*XpWex_Vb_b1))))*0.0+(((((((0.5*Fex_Vs_c1))*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((0.0)+(0.0)))))*0.0+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*(+0.0+0.0))/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)+2*((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))*0.0*0.0/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T)/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vb1_b2=((((0.5*Fex_Vb1_b2)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb1_b2)+(Qepi0*XpWex_Vb1_b2))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vc4_c1=((((0.5*Fex_Vc4_c1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vc4_c1)+(Qepi0*XpWex_Vc4_c1))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vc3_c1=((((0.5*Fex_Vc3_c1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vc3_c1)+(Qepi0*XpWex_Vc3_c1))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vc3_c4=((((0.5*Fex_Vc3_c4)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vc3_c4)+(Qepi0*XpWex_Vc3_c4))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vb2_e1=((0.5*Fex_Vb2_e1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vb2_c2=((((0.5*Fex_Vb2_c2)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vb2_c2)+(Qepi0*XpWex_Vb2_c2))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vb2_c1=((0.5*Fex_Vb2_c1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vc1_c2=((((0.5*Fex_Vc1_c2)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex)))+((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex_Vc1_c2)+(Qepi0*XpWex_Vc1_c2))))/(pInst->TAUB_T+TEPI_T));
#endif
#if defined(_DERIVATE)
XQex_Vs_c1=((0.5*Fex_Vs_c1)*pModel->XEXT*TAUR_T*((Qb0*XnBex)+(Qepi0*XpWex))/(pInst->TAUB_T+TEPI_T));
#endif
#endif
XQex=(((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(pInst->TAUB_T+TEPI_T));
EXIT_IF_ISNAN((((((0.5*Fex)*pModel->XEXT)*TAUR_T)*((Qb0*XnBex)+(Qepi0*XpWex)))/(pInst->TAUB_T+TEPI_T)))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Qb1b2_Vb1_b2=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vb1_b2_Vb1_b2=0.0;
  Qb1b2_Vb1_b2_Vdt_GND=0.0;
  Qb1b2_Vb1_b2_Vb2_e1=0.0;
  Qb1b2_Vb1_b2_Vb2_c2=0.0;
  Qb1b2_Vb1_b2_Vb2_c1=0.0;
  Qb1b2_Vb1_b2_Vc1_c2=0.0;
  Qb1b2_Vb1_b2_Vb_c=0.0;
  Qb1b2_Vb1_b2_Vb_b1=0.0;
  Qb1b2_Vb1_b2_Vc4_c1=0.0;
  Qb1b2_Vb1_b2_Vc3_c1=0.0;
  Qb1b2_Vb1_b2_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Qb1b2_Vdt_GND=0.0;
#endif
Qb1b2_Vb2_e1=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vb2_e1_Vb1_b2=0.0;
  Qb1b2_Vb2_e1_Vdt_GND=0.0;
  Qb1b2_Vb2_e1_Vb2_e1=0.0;
  Qb1b2_Vb2_e1_Vb2_c2=0.0;
  Qb1b2_Vb2_e1_Vb2_c1=0.0;
  Qb1b2_Vb2_e1_Vc1_c2=0.0;
  Qb1b2_Vb2_e1_Vb_c=0.0;
  Qb1b2_Vb2_e1_Vb_b1=0.0;
  Qb1b2_Vb2_e1_Vc4_c1=0.0;
  Qb1b2_Vb2_e1_Vc3_c1=0.0;
  Qb1b2_Vb2_e1_Vc3_c4=0.0;
#endif
Qb1b2_Vb2_c2=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vb2_c2_Vb1_b2=0.0;
  Qb1b2_Vb2_c2_Vdt_GND=0.0;
  Qb1b2_Vb2_c2_Vb2_e1=0.0;
  Qb1b2_Vb2_c2_Vb2_c2=0.0;
  Qb1b2_Vb2_c2_Vb2_c1=0.0;
  Qb1b2_Vb2_c2_Vc1_c2=0.0;
  Qb1b2_Vb2_c2_Vb_c=0.0;
  Qb1b2_Vb2_c2_Vb_b1=0.0;
  Qb1b2_Vb2_c2_Vc4_c1=0.0;
  Qb1b2_Vb2_c2_Vc3_c1=0.0;
  Qb1b2_Vb2_c2_Vc3_c4=0.0;
#endif
Qb1b2_Vb2_c1=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vb2_c1_Vb1_b2=0.0;
  Qb1b2_Vb2_c1_Vdt_GND=0.0;
  Qb1b2_Vb2_c1_Vb2_e1=0.0;
  Qb1b2_Vb2_c1_Vb2_c2=0.0;
  Qb1b2_Vb2_c1_Vb2_c1=0.0;
  Qb1b2_Vb2_c1_Vc1_c2=0.0;
  Qb1b2_Vb2_c1_Vb_c=0.0;
  Qb1b2_Vb2_c1_Vb_b1=0.0;
  Qb1b2_Vb2_c1_Vc4_c1=0.0;
  Qb1b2_Vb2_c1_Vc3_c1=0.0;
  Qb1b2_Vb2_c1_Vc3_c4=0.0;
#endif
Qb1b2_Vc1_c2=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vc1_c2_Vb1_b2=0.0;
  Qb1b2_Vc1_c2_Vdt_GND=0.0;
  Qb1b2_Vc1_c2_Vb2_e1=0.0;
  Qb1b2_Vc1_c2_Vb2_c2=0.0;
  Qb1b2_Vc1_c2_Vb2_c1=0.0;
  Qb1b2_Vc1_c2_Vc1_c2=0.0;
  Qb1b2_Vc1_c2_Vb_c=0.0;
  Qb1b2_Vc1_c2_Vb_b1=0.0;
  Qb1b2_Vc1_c2_Vc4_c1=0.0;
  Qb1b2_Vc1_c2_Vc3_c1=0.0;
  Qb1b2_Vc1_c2_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Qb1b2_Vb_c=0.0;
#endif
#if defined(_DERIVATE)
Qb1b2_Vb_b1=0.0;
#endif
Qb1b2_Vc4_c1=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vc4_c1_Vb1_b2=0.0;
  Qb1b2_Vc4_c1_Vdt_GND=0.0;
  Qb1b2_Vc4_c1_Vb2_e1=0.0;
  Qb1b2_Vc4_c1_Vb2_c2=0.0;
  Qb1b2_Vc4_c1_Vb2_c1=0.0;
  Qb1b2_Vc4_c1_Vc1_c2=0.0;
  Qb1b2_Vc4_c1_Vb_c=0.0;
  Qb1b2_Vc4_c1_Vb_b1=0.0;
  Qb1b2_Vc4_c1_Vc4_c1=0.0;
  Qb1b2_Vc4_c1_Vc3_c1=0.0;
  Qb1b2_Vc4_c1_Vc3_c4=0.0;
#endif
Qb1b2_Vc3_c1=0.0;
#if defined(_DERIVATE2)
  Qb1b2_Vc3_c1_Vb1_b2=0.0;
  Qb1b2_Vc3_c1_Vdt_GND=0.0;
  Qb1b2_Vc3_c1_Vb2_e1=0.0;
  Qb1b2_Vc3_c1_Vb2_c2=0.0;
  Qb1b2_Vc3_c1_Vb2_c1=0.0;
  Qb1b2_Vc3_c1_Vc1_c2=0.0;
  Qb1b2_Vc3_c1_Vb_c=0.0;
  Qb1b2_Vc3_c1_Vb_b1=0.0;
  Qb1b2_Vc3_c1_Vc4_c1=0.0;
  Qb1b2_Vc3_c1_Vc3_c1=0.0;
  Qb1b2_Vc3_c1_Vc3_c4=0.0;
#endif
#if defined(_DERIVATE)
Qb1b2_Vc3_c4=0.0;
#endif
#endif
Qb1b2=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#ifdef _DYNAMIC
if
((pModel->EXPHI==1))
{
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,(1.0-(Vje*inv_VDE_T)),(-pModel->PE))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0-(Vje*inv_VDE_T)),(-pModel->PE))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
dVteVje_Vb2_e1=(d10_pow0*(-Vje_Vb2_e1*inv_VDE_T));
#if defined(_DERIVATE2)
  dVteVje_Vb2_e1_Vb2_e1=(+fixme-0.0);
  dVteVje_Vb2_e1_Vdt_GND=(+fixme-0.0);
  dVteVje_Vb2_e1_Vb2_c2=(+fixme-0.0);
  dVteVje_Vb2_e1_Vb2_c1=(+fixme-0.0);
  dVteVje_Vb2_e1_Vc1_c2=(+fixme-0.0);
#endif
#if defined(_DERIVATE)
dVteVje_Vdt_GND=(d10_pow0*(-((Vje_Vdt_GND*inv_VDE_T)+(Vje*inv_VDE_T_Vdt_GND))));
#endif
dVteVje_Vb2_c2=(d10_pow0*(-Vje_Vb2_c2*inv_VDE_T));
#if defined(_DERIVATE2)
  dVteVje_Vb2_c2_Vb2_e1=(+fixme-0.0);
  dVteVje_Vb2_c2_Vdt_GND=(+fixme-0.0);
  dVteVje_Vb2_c2_Vb2_c2=(+fixme-0.0);
  dVteVje_Vb2_c2_Vb2_c1=(+fixme-0.0);
  dVteVje_Vb2_c2_Vc1_c2=(+fixme-0.0);
#endif
dVteVje_Vb2_c1=(d10_pow0*(-Vje_Vb2_c1*inv_VDE_T));
#if defined(_DERIVATE2)
  dVteVje_Vb2_c1_Vb2_e1=(+fixme-0.0);
  dVteVje_Vb2_c1_Vdt_GND=(+fixme-0.0);
  dVteVje_Vb2_c1_Vb2_c2=(+fixme-0.0);
  dVteVje_Vb2_c1_Vb2_c1=(+fixme-0.0);
  dVteVje_Vb2_c1_Vc1_c2=(+fixme-0.0);
#endif
dVteVje_Vc1_c2=(d10_pow0*(-Vje_Vc1_c2*inv_VDE_T));
#if defined(_DERIVATE2)
  dVteVje_Vc1_c2_Vb2_e1=(+fixme-0.0);
  dVteVje_Vc1_c2_Vdt_GND=(+fixme-0.0);
  dVteVje_Vc1_c2_Vb2_c2=(+fixme-0.0);
  dVteVje_Vc1_c2_Vb2_c1=(+fixme-0.0);
  dVteVje_Vc1_c2_Vc1_c2=(+fixme-0.0);
#endif
#endif
dVteVje=(d00_pow0-3.0);
EXIT_IF_ISNAN((d00_pow0-3.0))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Vb2e1Vfe_Vb2_e1=(Vb2e1_Vb2_e1/a_VDE);
#if defined(_DERIVATE2)
  Vb2e1Vfe_Vb2_e1_Vb2_e1=((+Vb2e1_Vb2_e1_Vb2_e1-0.0)/a_VDE-(Vb2e1_Vb2_e1*0.0+Vb2e1_Vb2_e1*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*0.0/a_VDE/a_VDE/a_VDE);
  Vb2e1Vfe_Vb2_e1_Vdt_GND=((+0.0-0.0)/a_VDE-(Vb2e1_Vb2_e1*a_VDE_Vdt_GND+(-Vfe_Vdt_GND)*0.0+(Vb2e1-Vfe)*0.0)/a_VDE/a_VDE+2*(Vb2e1-Vfe)*0.0*a_VDE_Vdt_GND/a_VDE/a_VDE/a_VDE);
#endif
#if defined(_DERIVATE)
Vb2e1Vfe_Vdt_GND=(((-Vfe_Vdt_GND)*a_VDE-(Vb2e1-Vfe)*a_VDE_Vdt_GND)/a_VDE/a_VDE);
#endif
#endif
Vb2e1Vfe=((Vb2e1-Vfe)/a_VDE);
EXIT_IF_ISNAN(((Vb2e1-Vfe)/a_VDE))
#endif
#ifdef _DYNAMIC
if
((Vb2e1Vfe<0.0))
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,Vb2e1Vfe)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
dVjeVb2e1_Vb2_e1=(-Vb2e1Vfe_Vb2_e1*d10_exp0/(1.0+d00_exp0)/(1.0+d00_exp0));
#if defined(_DERIVATE2)
  dVjeVb2e1_Vb2_e1_Vb2_e1=(0.0/(1.0+d00_exp0)-(0.0*Vb2e1Vfe_Vb2_e1*d10_exp0+0.0*Vb2e1Vfe_Vb2_e1*d10_exp0+1.0*(+0.0+(m20_exp(Vb2e1Vfe)*Vb2e1Vfe_Vb2_e1*Vb2e1Vfe_Vb2_e1+d10_exp0*Vb2e1Vfe_Vb2_e1_Vb2_e1)))/(1.0+d00_exp0)/(1.0+d00_exp0)+2*1.0*Vb2e1Vfe_Vb2_e1*d10_exp0*Vb2e1Vfe_Vb2_e1*d10_exp0/(1.0+d00_exp0)/(1.0+d00_exp0)/(1.0+d00_exp0));
  dVjeVb2e1_Vb2_e1_Vdt_GND=(0.0/(1.0+d00_exp0)-(0.0*Vb2e1Vfe_Vdt_GND*d10_exp0+0.0*Vb2e1Vfe_Vb2_e1*d10_exp0+1.0*(+0.0+(m20_exp(Vb2e1Vfe)*Vb2e1Vfe_Vdt_GND*Vb2e1Vfe_Vb2_e1+d10_exp0*Vb2e1Vfe_Vb2_e1_Vdt_GND)))/(1.0+d00_exp0)/(1.0+d00_exp0)+2*1.0*Vb2e1Vfe_Vb2_e1*d10_exp0*Vb2e1Vfe_Vdt_GND*d10_exp0/(1.0+d00_exp0)/(1.0+d00_exp0)/(1.0+d00_exp0));
#endif
#if defined(_DERIVATE)
dVjeVb2e1_Vdt_GND=(-Vb2e1Vfe_Vdt_GND*d10_exp0/(1.0+d00_exp0)/(1.0+d00_exp0));
#endif
#endif
dVjeVb2e1=(1.0/(1.0+d00_exp0));
EXIT_IF_ISNAN((1.0/(1.0+d00_exp0)))
}
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_exp(d00_exp0,(-Vb2e1Vfe))
double m00_exp(d00_exp1,(-Vb2e1Vfe))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#define d10_exp1 d00_exp1
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
dVjeVb2e1_Vb2_e1=(((-Vb2e1Vfe_Vb2_e1)*d10_exp0*(1.0+d00_exp1)-d00_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1)/(1.0+d00_exp1)/(1.0+d00_exp1));
#if defined(_DERIVATE2)
  dVjeVb2e1_Vb2_e1_Vb2_e1=((m20_exp((-Vb2e1Vfe))*(-Vb2e1Vfe_Vb2_e1)*(-Vb2e1Vfe_Vb2_e1)+d10_exp0*0.0)/(1.0+d00_exp1)-((-Vb2e1Vfe_Vb2_e1)*d10_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1+(-Vb2e1Vfe_Vb2_e1)*d10_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1+d00_exp0*(+0.0+(m20_exp((-Vb2e1Vfe))*(-Vb2e1Vfe_Vb2_e1)*(-Vb2e1Vfe_Vb2_e1)+d10_exp1*0.0)))/(1.0+d00_exp1)/(1.0+d00_exp1)+2*d00_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1*(-Vb2e1Vfe_Vb2_e1)*d10_exp1/(1.0+d00_exp1)/(1.0+d00_exp1)/(1.0+d00_exp1));
  dVjeVb2e1_Vb2_e1_Vdt_GND=((m20_exp((-Vb2e1Vfe))*(-Vb2e1Vfe_Vdt_GND)*(-Vb2e1Vfe_Vb2_e1)+d10_exp0*0.0)/(1.0+d00_exp1)-((-Vb2e1Vfe_Vb2_e1)*d10_exp0*(-Vb2e1Vfe_Vdt_GND)*d10_exp1+(-Vb2e1Vfe_Vdt_GND)*d10_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1+d00_exp0*(+0.0+(m20_exp((-Vb2e1Vfe))*(-Vb2e1Vfe_Vdt_GND)*(-Vb2e1Vfe_Vb2_e1)+d10_exp1*0.0)))/(1.0+d00_exp1)/(1.0+d00_exp1)+2*d00_exp0*(-Vb2e1Vfe_Vb2_e1)*d10_exp1*(-Vb2e1Vfe_Vdt_GND)*d10_exp1/(1.0+d00_exp1)/(1.0+d00_exp1)/(1.0+d00_exp1));
#endif
#if defined(_DERIVATE)
dVjeVb2e1_Vdt_GND=(((-Vb2e1Vfe_Vdt_GND)*d10_exp0*(1.0+d00_exp1)-d00_exp0*(-Vb2e1Vfe_Vdt_GND)*d10_exp1)/(1.0+d00_exp1)/(1.0+d00_exp1));
#endif
#endif
dVjeVb2e1=(d00_exp0/(1.0+d00_exp1));
EXIT_IF_ISNAN((d00_exp0/(1.0+d00_exp1)))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b2,e1)V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
dVteVb2e1_Vb2_e1=((dVteVje_Vb2_e1*dVjeVb2e1)+(dVteVje*dVjeVb2e1_Vb2_e1));
#if defined(_DERIVATE2)
  dVteVb2e1_Vb2_e1_Vb2_e1=(+(+dVteVje_Vb2_e1_Vb2_e1*dVjeVb2e1+dVteVje_Vb2_e1*dVjeVb2e1_Vb2_e1+dVteVje_Vb2_e1*dVjeVb2e1_Vb2_e1+dVteVje*dVjeVb2e1_Vb2_e1_Vb2_e1)+0.0);
  dVteVb2e1_Vb2_e1_Vdt_GND=(+(+dVteVje_Vb2_e1_Vdt_GND*dVjeVb2e1+dVteVje_Vb2_e1*dVjeVb2e1_Vdt_GND+dVteVje_Vdt_GND*dVjeVb2e1_Vb2_e1+dVteVje*dVjeVb2e1_Vb2_e1_Vdt_GND)+0.0);
  dVteVb2e1_Vb2_e1_Vb2_c2=(+(+dVteVje_Vb2_e1_Vb2_c2*dVjeVb2e1+dVteVje_Vb2_e1*0.0+dVteVje_Vb2_c2*dVjeVb2e1_Vb2_e1+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_e1_Vb2_c1=(+(+dVteVje_Vb2_e1_Vb2_c1*dVjeVb2e1+dVteVje_Vb2_e1*0.0+dVteVje_Vb2_c1*dVjeVb2e1_Vb2_e1+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_e1_Vc1_c2=(+(+dVteVje_Vb2_e1_Vc1_c2*dVjeVb2e1+dVteVje_Vb2_e1*0.0+dVteVje_Vc1_c2*dVjeVb2e1_Vb2_e1+dVteVje*0.0)+0.0);
#endif
#if defined(_DERIVATE)
dVteVb2e1_Vdt_GND=((dVteVje_Vdt_GND*dVjeVb2e1)+(dVteVje*dVjeVb2e1_Vdt_GND));
#endif
dVteVb2e1_Vb2_c2=dVteVje_Vb2_c2*dVjeVb2e1;
#if defined(_DERIVATE2)
  dVteVb2e1_Vb2_c2_Vb2_e1=(+(+dVteVje_Vb2_c2_Vb2_e1*dVjeVb2e1+dVteVje_Vb2_c2*dVjeVb2e1_Vb2_e1+dVteVje_Vb2_e1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c2_Vdt_GND=(+(+dVteVje_Vb2_c2_Vdt_GND*dVjeVb2e1+dVteVje_Vb2_c2*dVjeVb2e1_Vdt_GND+dVteVje_Vdt_GND*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c2_Vb2_c2=(+(+dVteVje_Vb2_c2_Vb2_c2*dVjeVb2e1+dVteVje_Vb2_c2*0.0+dVteVje_Vb2_c2*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c2_Vb2_c1=(+(+dVteVje_Vb2_c2_Vb2_c1*dVjeVb2e1+dVteVje_Vb2_c2*0.0+dVteVje_Vb2_c1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c2_Vc1_c2=(+(+dVteVje_Vb2_c2_Vc1_c2*dVjeVb2e1+dVteVje_Vb2_c2*0.0+dVteVje_Vc1_c2*0.0+dVteVje*0.0)+0.0);
#endif
dVteVb2e1_Vb2_c1=dVteVje_Vb2_c1*dVjeVb2e1;
#if defined(_DERIVATE2)
  dVteVb2e1_Vb2_c1_Vb2_e1=(+(+dVteVje_Vb2_c1_Vb2_e1*dVjeVb2e1+dVteVje_Vb2_c1*dVjeVb2e1_Vb2_e1+dVteVje_Vb2_e1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c1_Vdt_GND=(+(+dVteVje_Vb2_c1_Vdt_GND*dVjeVb2e1+dVteVje_Vb2_c1*dVjeVb2e1_Vdt_GND+dVteVje_Vdt_GND*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c1_Vb2_c2=(+(+dVteVje_Vb2_c1_Vb2_c2*dVjeVb2e1+dVteVje_Vb2_c1*0.0+dVteVje_Vb2_c2*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c1_Vb2_c1=(+(+dVteVje_Vb2_c1_Vb2_c1*dVjeVb2e1+dVteVje_Vb2_c1*0.0+dVteVje_Vb2_c1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vb2_c1_Vc1_c2=(+(+dVteVje_Vb2_c1_Vc1_c2*dVjeVb2e1+dVteVje_Vb2_c1*0.0+dVteVje_Vc1_c2*0.0+dVteVje*0.0)+0.0);
#endif
dVteVb2e1_Vc1_c2=dVteVje_Vc1_c2*dVjeVb2e1;
#if defined(_DERIVATE2)
  dVteVb2e1_Vc1_c2_Vb2_e1=(+(+dVteVje_Vc1_c2_Vb2_e1*dVjeVb2e1+dVteVje_Vc1_c2*dVjeVb2e1_Vb2_e1+dVteVje_Vb2_e1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vc1_c2_Vdt_GND=(+(+dVteVje_Vc1_c2_Vdt_GND*dVjeVb2e1+dVteVje_Vc1_c2*dVjeVb2e1_Vdt_GND+dVteVje_Vdt_GND*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vc1_c2_Vb2_c2=(+(+dVteVje_Vc1_c2_Vb2_c2*dVjeVb2e1+dVteVje_Vc1_c2*0.0+dVteVje_Vb2_c2*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vc1_c2_Vb2_c1=(+(+dVteVje_Vc1_c2_Vb2_c1*dVjeVb2e1+dVteVje_Vc1_c2*0.0+dVteVje_Vb2_c1*0.0+dVteVje*0.0)+0.0);
  dVteVb2e1_Vc1_c2_Vc1_c2=(+(+dVteVje_Vc1_c2_Vc1_c2*dVjeVb2e1+dVteVje_Vc1_c2*0.0+dVteVje_Vc1_c2*0.0+dVteVje*0.0)+0.0);
#endif
#endif
dVteVb2e1=((dVteVje*dVjeVb2e1)+3.0);
EXIT_IF_ISNAN(((dVteVje*dVjeVb2e1)+3.0))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
#if defined(_DERIVATE)
dQteVb2e1_Vdt_GND=((((1.0-pModel->XCJE)*CJE_TM_Vdt_GND)*dVteVb2e1)+(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vdt_GND));
#endif
dQteVb2e1_Vb2_e1=(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1);
#if defined(_DERIVATE2)
  dQteVb2e1_Vb2_e1_Vdt_GND=(+(+(+0.0-0.0)*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vdt_GND+(((1.0-pModel->XCJE)*CJE_TM_Vdt_GND))*dVteVb2e1_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1_Vdt_GND);
  dQteVb2e1_Vb2_e1_Vb2_e1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_e1+(0.0)*dVteVb2e1_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1_Vb2_e1);
  dQteVb2e1_Vb2_e1_Vb2_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c2+(0.0)*dVteVb2e1_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1_Vb2_c2);
  dQteVb2e1_Vb2_e1_Vb2_c1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c1+(0.0)*dVteVb2e1_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1_Vb2_c1);
  dQteVb2e1_Vb2_e1_Vc1_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vc1_c2+(0.0)*dVteVb2e1_Vb2_e1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_e1_Vc1_c2);
#endif
dQteVb2e1_Vb2_c2=(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2);
#if defined(_DERIVATE2)
  dQteVb2e1_Vb2_c2_Vdt_GND=(+(+(+0.0-0.0)*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vdt_GND+(((1.0-pModel->XCJE)*CJE_TM_Vdt_GND))*dVteVb2e1_Vb2_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2_Vdt_GND);
  dQteVb2e1_Vb2_c2_Vb2_e1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_e1+(0.0)*dVteVb2e1_Vb2_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2_Vb2_e1);
  dQteVb2e1_Vb2_c2_Vb2_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c2+(0.0)*dVteVb2e1_Vb2_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2_Vb2_c2);
  dQteVb2e1_Vb2_c2_Vb2_c1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c1+(0.0)*dVteVb2e1_Vb2_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2_Vb2_c1);
  dQteVb2e1_Vb2_c2_Vc1_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vc1_c2+(0.0)*dVteVb2e1_Vb2_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c2_Vc1_c2);
#endif
dQteVb2e1_Vb2_c1=(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1);
#if defined(_DERIVATE2)
  dQteVb2e1_Vb2_c1_Vdt_GND=(+(+(+0.0-0.0)*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vdt_GND+(((1.0-pModel->XCJE)*CJE_TM_Vdt_GND))*dVteVb2e1_Vb2_c1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1_Vdt_GND);
  dQteVb2e1_Vb2_c1_Vb2_e1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_e1+(0.0)*dVteVb2e1_Vb2_c1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1_Vb2_e1);
  dQteVb2e1_Vb2_c1_Vb2_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c2+(0.0)*dVteVb2e1_Vb2_c1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1_Vb2_c2);
  dQteVb2e1_Vb2_c1_Vb2_c1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c1+(0.0)*dVteVb2e1_Vb2_c1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1_Vb2_c1);
  dQteVb2e1_Vb2_c1_Vc1_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vc1_c2+(0.0)*dVteVb2e1_Vb2_c1+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vb2_c1_Vc1_c2);
#endif
dQteVb2e1_Vc1_c2=(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2);
#if defined(_DERIVATE2)
  dQteVb2e1_Vc1_c2_Vdt_GND=(+(+(+0.0-0.0)*CJE_TM+0.0*CJE_TM_Vdt_GND+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vdt_GND+(((1.0-pModel->XCJE)*CJE_TM_Vdt_GND))*dVteVb2e1_Vc1_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2_Vdt_GND);
  dQteVb2e1_Vc1_c2_Vb2_e1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_e1+(0.0)*dVteVb2e1_Vc1_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2_Vb2_e1);
  dQteVb2e1_Vc1_c2_Vb2_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c2+(0.0)*dVteVb2e1_Vc1_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2_Vb2_c2);
  dQteVb2e1_Vc1_c2_Vb2_c1=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vb2_c1+(0.0)*dVteVb2e1_Vc1_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2_Vb2_c1);
  dQteVb2e1_Vc1_c2_Vc1_c2=(+(+(+0.0-0.0)*CJE_TM+0.0*0.0+0.0*0.0+(1.0-pModel->XCJE)*0.0)*dVteVb2e1+0.0*dVteVb2e1_Vc1_c2+(0.0)*dVteVb2e1_Vc1_c2+((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1_Vc1_c2_Vc1_c2);
#endif
#endif
dQteVb2e1=(((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1);
EXIT_IF_ISNAN((((1.0-pModel->XCJE)*CJE_TM)*dVteVb2e1))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0+f1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+f1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
#if defined(_DERIVATE)
dn0Vb2e1_Vdt_GND=((((((If0_Vdt_GND*eVb2e1)+(If0*eVb2e1_Vdt_GND))*VtINV)+((If0*eVb2e1)*VtINV_Vdt_GND))*(0.5/d00_sqrt0))+(((If0*eVb2e1)*VtINV)*(-0.5*f1_Vdt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0)));
#endif
dn0Vb2e1_Vb2_e1=(((If0*eVb2e1_Vb2_e1)*VtINV*(0.5/d00_sqrt0))+(((If0*eVb2e1)*VtINV)*(-0.5*f1_Vb2_e1*d10_sqrt0/d00_sqrt0/d00_sqrt0)));
#if defined(_DERIVATE2)
  dn0Vb2e1_Vb2_e1_Vdt_GND=(+(+(+0.0*eVb2e1+0.0*eVb2e1_Vdt_GND+If0_Vdt_GND*eVb2e1_Vb2_e1+If0*eVb2e1_Vb2_e1_Vdt_GND)*VtINV+(If0*eVb2e1_Vb2_e1)*VtINV_Vdt_GND+(((If0_Vdt_GND*eVb2e1)+(If0*eVb2e1_Vdt_GND)))*0.0+(If0*eVb2e1)*0.0)*(0.5/d00_sqrt0)+(If0*eVb2e1_Vb2_e1)*VtINV*(-0.5*f1_Vdt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0)+((((((If0_Vdt_GND*eVb2e1)+(If0*eVb2e1_Vdt_GND)))*VtINV)+((If0*eVb2e1)*VtINV_Vdt_GND)))*(-0.5*f1_Vb2_e1*d10_sqrt0/d00_sqrt0/d00_sqrt0)+((If0*eVb2e1)*VtINV)*(0.0/d00_sqrt0-(0.0*f1_Vdt_GND*d10_sqrt0+0.0*f1_Vb2_e1*d10_sqrt0+0.5*(m20_sqrt((1.0+f1))*f1_Vdt_GND*f1_Vb2_e1+d10_sqrt0*(+0.0+f1_Vb2_e1_Vdt_GND)))/d00_sqrt0/d00_sqrt0+2*0.5*f1_Vb2_e1*d10_sqrt0*f1_Vdt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0));
  dn0Vb2e1_Vb2_e1_Vb2_e1=(+(+(+0.0*eVb2e1+0.0*eVb2e1_Vb2_e1+0.0*eVb2e1_Vb2_e1+If0*eVb2e1_Vb2_e1_Vb2_e1)*VtINV+(If0*eVb2e1_Vb2_e1)*0.0+((If0*eVb2e1_Vb2_e1))*0.0+(If0*eVb2e1)*0.0)*(0.5/d00_sqrt0)+(If0*eVb2e1_Vb2_e1)*VtINV*(-0.5*f1_Vb2_e1*d10_sqrt0/d00_sqrt0/d00_sqrt0)+(((If0*eVb2e1_Vb2_e1))*VtINV)*(-0.5*f1_Vb2_e1*d10_sqrt0/d00_sqrt0/d00_sqrt0)+((If0*eVb2e1)*VtINV)*(0.0/d00_sqrt0-(0.0*f1_Vb2_e1*d10_sqrt0+0.0*f1_Vb2_e1*d10_sqrt0+0.5*(m20_sqrt((1.0+f1))*f1_Vb2_e1*f1_Vb2_e1+d10_sqrt0*(+0.0+f1_Vb2_e1_Vb2_e1)))/d00_sqrt0/d00_sqrt0+2*0.5*f1_Vb2_e1*d10_sqrt0*f1_Vb2_e1*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0));
#endif
#endif
dn0Vb2e1=(((If0*eVb2e1)*VtINV)*(0.5/d00_sqrt0));
EXIT_IF_ISNAN((((If0*eVb2e1)*VtINV)*(0.5/d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
#if defined(_DERIVATE)
dQbeVb2e1_Vdt_GND=(((((0.5*Qb0_Vdt_GND)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND))*dn0Vb2e1)+(((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1_Vdt_GND));
#endif
#if defined(_DERIVATE)
dQbeVb2e1_Vb_c=((0.5*Qb0)*q1Q_Vb_c)*dn0Vb2e1;
#endif
#if defined(_DERIVATE)
dQbeVb2e1_Vb_b1=((0.5*Qb0)*q1Q_Vb_b1)*dn0Vb2e1;
#endif
dQbeVb2e1_Vb1_b2=((0.5*Qb0)*q1Q_Vb1_b2)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vb1_b2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb1_b2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vb1_b2+(0.5*Qb0)*q1Q_Vb1_b2_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb1_b2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
dQbeVb2e1_Vc4_c1=((0.5*Qb0)*q1Q_Vc4_c1)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vc4_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc4_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vc4_c1+(0.5*Qb0)*q1Q_Vc4_c1_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc4_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
dQbeVb2e1_Vc3_c1=((0.5*Qb0)*q1Q_Vc3_c1)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vc3_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc3_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vc3_c1+(0.5*Qb0)*q1Q_Vc3_c1_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc3_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
#if defined(_DERIVATE)
dQbeVb2e1_Vc3_c4=((0.5*Qb0)*q1Q_Vc3_c4)*dn0Vb2e1;
#endif
dQbeVb2e1_Vb2_e1=((((0.5*Qb0)*q1Q_Vb2_e1)*dn0Vb2e1)+(((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1_Vb2_e1));
#if defined(_DERIVATE2)
  dQbeVb2e1_Vb2_e1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1_Vb2_e1_Vdt_GND);
  dQbeVb2e1_Vb2_e1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1_Vb2_e1_Vb2_e1);
  dQbeVb2e1_Vb2_e1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_e1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vb2_e1+(0.5*Qb0)*q1Q_Vb2_e1_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_e1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*dn0Vb2e1_Vb2_e1+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
dQbeVb2e1_Vb2_c2=((0.5*Qb0)*q1Q_Vb2_c2)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vb2_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vb2_c2+(0.5*Qb0)*q1Q_Vb2_c2_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
dQbeVb2e1_Vb2_c1=((0.5*Qb0)*q1Q_Vb2_c1)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vb2_c1_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vb2_c1_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vb2_c1+(0.5*Qb0)*q1Q_Vb2_c1_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vb2_c1)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
dQbeVb2e1_Vc1_c2=((0.5*Qb0)*q1Q_Vc1_c2)*dn0Vb2e1;
#if defined(_DERIVATE2)
  dQbeVb2e1_Vc1_c2_Vdt_GND=(+(+(+0.0*Qb0+0.0*Qb0_Vdt_GND+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vdt_GND+((0.5*Qb0_Vdt_GND))*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vdt_GND)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*dn0Vb2e1_Vdt_GND+(((((0.5*Qb0_Vdt_GND))*pInst->q1Q)+((0.5*Qb0)*q1Q_Vdt_GND)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb_c=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_c+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb_c)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_c)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb_b1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb_b1+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb_b1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb_b1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb1_b2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb1_b2+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb1_b2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb1_b2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vc4_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc4_c1+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vc4_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc4_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vc3_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c1+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vc3_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vc3_c4=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc3_c4+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vc3_c4)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc3_c4)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb2_e1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_e1+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb2_e1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*dn0Vb2e1_Vb2_e1+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_e1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb2_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c2+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb2_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vb2_c1=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vb2_c1+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vb2_c1)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vb2_c1)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
  dQbeVb2e1_Vc1_c2_Vc1_c2=(+(+(+0.0*Qb0+0.0*0.0+0.0*0.0+0.5*0.0)*pInst->q1Q+0.0*q1Q_Vc1_c2+(0.0)*q1Q_Vc1_c2+(0.5*Qb0)*q1Q_Vc1_c2_Vc1_c2)*dn0Vb2e1+((0.5*Qb0)*q1Q_Vc1_c2)*0.0+((((0.0)*pInst->q1Q)+((0.5*Qb0)*q1Q_Vc1_c2)))*0.0+((0.5*Qb0)*pInst->q1Q)*0.0);
#endif
#endif
dQbeVb2e1=(((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1);
EXIT_IF_ISNAN((((0.5*Qb0)*pInst->q1Q)*dn0Vb2e1))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe=V(b2,GND)V(c2,GND)V(e1,GND)V(c1,GND) */
#if defined(_DERIVATE)
dQeVb2e1_Vdt_GND=((Qe_qs_Vdt_GND*(pModel->MTAU*Vt)-Qe_qs*(pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
dQeVb2e1_Vb1_b2=(Qe_qs_Vb1_b2/(pModel->MTAU*Vt));
#if defined(_DERIVATE2)
  dQeVb2e1_Vb1_b2_Vdt_GND=(Qe_qs_Vb1_b2_Vdt_GND/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*((pModel->MTAU*Vt_Vdt_GND))+Qe_qs_Vdt_GND*0.0+Qe_qs*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb1_b2_Vb1_b2=(Qe_qs_Vb1_b2_Vb1_b2/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*(0.0)+Qe_qs_Vb1_b2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb1_b2_Vb2_c2=(Qe_qs_Vb1_b2_Vb2_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*(0.0)+Qe_qs_Vb2_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb1_b2_Vc1_c2=(Qe_qs_Vb1_b2_Vc1_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*(0.0)+Qe_qs_Vc1_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb1_b2_Vc4_c1=(Qe_qs_Vb1_b2_Vc4_c1/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*(0.0)+Qe_qs_Vc4_c1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb1_b2_Vb2_e1=(Qe_qs_Vb1_b2_Vb2_e1/(pModel->MTAU*Vt)-(Qe_qs_Vb1_b2*(0.0)+Qe_qs_Vb2_e1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
dQeVb2e1_Vb2_c2=(Qe_qs_Vb2_c2/(pModel->MTAU*Vt));
#if defined(_DERIVATE2)
  dQeVb2e1_Vb2_c2_Vdt_GND=(Qe_qs_Vb2_c2_Vdt_GND/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*((pModel->MTAU*Vt_Vdt_GND))+Qe_qs_Vdt_GND*0.0+Qe_qs*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_c2_Vb1_b2=(Qe_qs_Vb2_c2_Vb1_b2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*(0.0)+Qe_qs_Vb1_b2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_c2_Vb2_c2=(Qe_qs_Vb2_c2_Vb2_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*(0.0)+Qe_qs_Vb2_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_c2_Vc1_c2=(Qe_qs_Vb2_c2_Vc1_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*(0.0)+Qe_qs_Vc1_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_c2_Vc4_c1=(Qe_qs_Vb2_c2_Vc4_c1/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*(0.0)+Qe_qs_Vc4_c1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_c2_Vb2_e1=(Qe_qs_Vb2_c2_Vb2_e1/(pModel->MTAU*Vt)-(Qe_qs_Vb2_c2*(0.0)+Qe_qs_Vb2_e1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
dQeVb2e1_Vc1_c2=(Qe_qs_Vc1_c2/(pModel->MTAU*Vt));
#if defined(_DERIVATE2)
  dQeVb2e1_Vc1_c2_Vdt_GND=(Qe_qs_Vc1_c2_Vdt_GND/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*((pModel->MTAU*Vt_Vdt_GND))+Qe_qs_Vdt_GND*0.0+Qe_qs*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc1_c2_Vb1_b2=(Qe_qs_Vc1_c2_Vb1_b2/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*(0.0)+Qe_qs_Vb1_b2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc1_c2_Vb2_c2=(Qe_qs_Vc1_c2_Vb2_c2/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*(0.0)+Qe_qs_Vb2_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc1_c2_Vc1_c2=(Qe_qs_Vc1_c2_Vc1_c2/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*(0.0)+Qe_qs_Vc1_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc1_c2_Vc4_c1=(Qe_qs_Vc1_c2_Vc4_c1/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*(0.0)+Qe_qs_Vc4_c1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc1_c2_Vb2_e1=(Qe_qs_Vc1_c2_Vb2_e1/(pModel->MTAU*Vt)-(Qe_qs_Vc1_c2*(0.0)+Qe_qs_Vb2_e1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
dQeVb2e1_Vc4_c1=(Qe_qs_Vc4_c1/(pModel->MTAU*Vt));
#if defined(_DERIVATE2)
  dQeVb2e1_Vc4_c1_Vdt_GND=(Qe_qs_Vc4_c1_Vdt_GND/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*((pModel->MTAU*Vt_Vdt_GND))+Qe_qs_Vdt_GND*0.0+Qe_qs*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc4_c1_Vb1_b2=(Qe_qs_Vc4_c1_Vb1_b2/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*(0.0)+Qe_qs_Vb1_b2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc4_c1_Vb2_c2=(Qe_qs_Vc4_c1_Vb2_c2/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*(0.0)+Qe_qs_Vb2_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc4_c1_Vc1_c2=(Qe_qs_Vc4_c1_Vc1_c2/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*(0.0)+Qe_qs_Vc1_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc4_c1_Vc4_c1=(Qe_qs_Vc4_c1_Vc4_c1/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*(0.0)+Qe_qs_Vc4_c1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vc4_c1_Vb2_e1=(Qe_qs_Vc4_c1_Vb2_e1/(pModel->MTAU*Vt)-(Qe_qs_Vc4_c1*(0.0)+Qe_qs_Vb2_e1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
dQeVb2e1_Vb2_e1=(Qe_qs_Vb2_e1/(pModel->MTAU*Vt));
#if defined(_DERIVATE2)
  dQeVb2e1_Vb2_e1_Vdt_GND=(Qe_qs_Vb2_e1_Vdt_GND/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*((pModel->MTAU*Vt_Vdt_GND))+Qe_qs_Vdt_GND*0.0+Qe_qs*(+0.0*Vt+0.0*Vt_Vdt_GND+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*((pModel->MTAU*Vt_Vdt_GND))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_e1_Vb1_b2=(Qe_qs_Vb2_e1_Vb1_b2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*(0.0)+Qe_qs_Vb1_b2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_e1_Vb2_c2=(Qe_qs_Vb2_e1_Vb2_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*(0.0)+Qe_qs_Vb2_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_e1_Vc1_c2=(Qe_qs_Vb2_e1_Vc1_c2/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*(0.0)+Qe_qs_Vc1_c2*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_e1_Vc4_c1=(Qe_qs_Vb2_e1_Vc4_c1/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*(0.0)+Qe_qs_Vc4_c1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
  dQeVb2e1_Vb2_e1_Vb2_e1=(Qe_qs_Vb2_e1_Vb2_e1/(pModel->MTAU*Vt)-(Qe_qs_Vb2_e1*(0.0)+Qe_qs_Vb2_e1*0.0+Qe_qs*(+0.0*Vt+0.0*0.0+0.0*0.0+pModel->MTAU*0.0))/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)+2*Qe_qs*0.0*(0.0)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt)/(pModel->MTAU*Vt));
#endif
#endif
dQeVb2e1=(Qe_qs/(pModel->MTAU*Vt));
EXIT_IF_ISNAN((Qe_qs/(pModel->MTAU*Vt)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(b1,b2)V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(c4,c1)V(c3,c1)V(c3,c4) ddxprobe=V(c1,GND)V(e1,GND)V(c2,GND)V(b2,GND) */
Qb1b2_Vb1_b2=(((0.2*Vb1b2_Vb1_b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1))+((0.2*Vb1b2)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)));
#if defined(_DERIVATE2)
  Qb1b2_Vb1_b2_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*Vb1b2_Vb1_b2+0.2*Vb1b2_Vb1_b2_Vb1_b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb1_b2)+dQeVb2e1_Vb1_b2_Vb1_b2));
  Qb1b2_Vb1_b2_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vdt_GND)+dQeVb2e1_Vb1_b2_Vdt_GND));
  Qb1b2_Vb1_b2_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb2_e1)+dQeVb2e1_Vb1_b2_Vb2_e1));
  Qb1b2_Vb1_b2_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb2_c2)+dQeVb2e1_Vb1_b2_Vb2_c2));
  Qb1b2_Vb1_b2_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb2_c1)+0.0));
  Qb1b2_Vb1_b2_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vc1_c2)+dQeVb2e1_Vb1_b2_Vc1_c2));
  Qb1b2_Vb1_b2_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*dQbeVb2e1_Vb_c+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb_c)+0.0));
  Qb1b2_Vb1_b2_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*dQbeVb2e1_Vb_b1+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vb_b1)+0.0));
  Qb1b2_Vb1_b2_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vc4_c1)+dQeVb2e1_Vb1_b2_Vc4_c1));
  Qb1b2_Vb1_b2_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*dQbeVb2e1_Vc3_c1+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vc3_c1)+0.0));
  Qb1b2_Vb1_b2_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*Vb1b2_Vb1_b2+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+(0.2*Vb1b2_Vb1_b2)*dQbeVb2e1_Vc3_c4+(0.0)*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb1_b2_Vc3_c4)+0.0));
#endif
#if defined(_DERIVATE)
Qb1b2_Vdt_GND=((0.2*Vb1b2)*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND));
#endif
Qb1b2_Vb2_e1=((0.2*Vb1b2)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1));
#if defined(_DERIVATE2)
  Qb1b2_Vb2_e1_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vb1_b2)+dQeVb2e1_Vb2_e1_Vb1_b2));
  Qb1b2_Vb2_e1_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_e1_Vdt_GND+dQbeVb2e1_Vb2_e1_Vdt_GND)+dQeVb2e1_Vb2_e1_Vdt_GND));
  Qb1b2_Vb2_e1_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_e1_Vb2_e1+dQbeVb2e1_Vb2_e1_Vb2_e1)+dQeVb2e1_Vb2_e1_Vb2_e1));
  Qb1b2_Vb2_e1_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_e1_Vb2_c2+dQbeVb2e1_Vb2_e1_Vb2_c2)+dQeVb2e1_Vb2_e1_Vb2_c2));
  Qb1b2_Vb2_e1_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_e1_Vb2_c1+dQbeVb2e1_Vb2_e1_Vb2_c1)+0.0));
  Qb1b2_Vb2_e1_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_e1_Vc1_c2+dQbeVb2e1_Vb2_e1_Vc1_c2)+dQeVb2e1_Vb2_e1_Vc1_c2));
  Qb1b2_Vb2_e1_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vb_c)+0.0));
  Qb1b2_Vb2_e1_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vb_b1)+0.0));
  Qb1b2_Vb2_e1_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vc4_c1)+dQeVb2e1_Vb2_e1_Vc4_c1));
  Qb1b2_Vb2_e1_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vc3_c1)+0.0));
  Qb1b2_Vb2_e1_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_e1_Vc3_c4)+0.0));
#endif
Qb1b2_Vb2_c2=((0.2*Vb1b2)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2));
#if defined(_DERIVATE2)
  Qb1b2_Vb2_c2_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vb1_b2)+dQeVb2e1_Vb2_c2_Vb1_b2));
  Qb1b2_Vb2_c2_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c2_Vdt_GND+dQbeVb2e1_Vb2_c2_Vdt_GND)+dQeVb2e1_Vb2_c2_Vdt_GND));
  Qb1b2_Vb2_c2_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c2_Vb2_e1+dQbeVb2e1_Vb2_c2_Vb2_e1)+dQeVb2e1_Vb2_c2_Vb2_e1));
  Qb1b2_Vb2_c2_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c2_Vb2_c2+dQbeVb2e1_Vb2_c2_Vb2_c2)+dQeVb2e1_Vb2_c2_Vb2_c2));
  Qb1b2_Vb2_c2_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c2_Vb2_c1+dQbeVb2e1_Vb2_c2_Vb2_c1)+0.0));
  Qb1b2_Vb2_c2_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c2_Vc1_c2+dQbeVb2e1_Vb2_c2_Vc1_c2)+dQeVb2e1_Vb2_c2_Vc1_c2));
  Qb1b2_Vb2_c2_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vb_c)+0.0));
  Qb1b2_Vb2_c2_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vb_b1)+0.0));
  Qb1b2_Vb2_c2_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vc4_c1)+dQeVb2e1_Vb2_c2_Vc4_c1));
  Qb1b2_Vb2_c2_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vc3_c1)+0.0));
  Qb1b2_Vb2_c2_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c2_Vc3_c4)+0.0));
#endif
Qb1b2_Vb2_c1=((0.2*Vb1b2)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1));
#if defined(_DERIVATE2)
  Qb1b2_Vb2_c1_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vb1_b2)+0.0));
  Qb1b2_Vb2_c1_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c1_Vdt_GND+dQbeVb2e1_Vb2_c1_Vdt_GND)+0.0));
  Qb1b2_Vb2_c1_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c1_Vb2_e1+dQbeVb2e1_Vb2_c1_Vb2_e1)+0.0));
  Qb1b2_Vb2_c1_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c1_Vb2_c2+dQbeVb2e1_Vb2_c1_Vb2_c2)+0.0));
  Qb1b2_Vb2_c1_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c1_Vb2_c1+dQbeVb2e1_Vb2_c1_Vb2_c1)+0.0));
  Qb1b2_Vb2_c1_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vb2_c1_Vc1_c2+dQbeVb2e1_Vb2_c1_Vc1_c2)+0.0));
  Qb1b2_Vb2_c1_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vb_c)+0.0));
  Qb1b2_Vb2_c1_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vb_b1)+0.0));
  Qb1b2_Vb2_c1_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vc4_c1)+0.0));
  Qb1b2_Vb2_c1_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vc3_c1)+0.0));
  Qb1b2_Vb2_c1_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vb2_c1_Vc3_c4)+0.0));
#endif
Qb1b2_Vc1_c2=((0.2*Vb1b2)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2));
#if defined(_DERIVATE2)
  Qb1b2_Vc1_c2_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vb1_b2)+dQeVb2e1_Vc1_c2_Vb1_b2));
  Qb1b2_Vc1_c2_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vc1_c2_Vdt_GND+dQbeVb2e1_Vc1_c2_Vdt_GND)+dQeVb2e1_Vc1_c2_Vdt_GND));
  Qb1b2_Vc1_c2_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vc1_c2_Vb2_e1+dQbeVb2e1_Vc1_c2_Vb2_e1)+dQeVb2e1_Vc1_c2_Vb2_e1));
  Qb1b2_Vc1_c2_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vc1_c2_Vb2_c2+dQbeVb2e1_Vc1_c2_Vb2_c2)+dQeVb2e1_Vc1_c2_Vb2_c2));
  Qb1b2_Vc1_c2_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vc1_c2_Vb2_c1+dQbeVb2e1_Vc1_c2_Vb2_c1)+0.0));
  Qb1b2_Vc1_c2_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+dQteVb2e1_Vc1_c2_Vc1_c2+dQbeVb2e1_Vc1_c2_Vc1_c2)+dQeVb2e1_Vc1_c2_Vc1_c2));
  Qb1b2_Vc1_c2_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vb_c)+0.0));
  Qb1b2_Vc1_c2_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vb_b1)+0.0));
  Qb1b2_Vc1_c2_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vc4_c1)+dQeVb2e1_Vc1_c2_Vc4_c1));
  Qb1b2_Vc1_c2_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vc3_c1)+0.0));
  Qb1b2_Vc1_c2_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc1_c2_Vc3_c4)+0.0));
#endif
#if defined(_DERIVATE)
Qb1b2_Vb_c=((0.2*Vb1b2)*dQbeVb2e1_Vb_c);
#endif
#if defined(_DERIVATE)
Qb1b2_Vb_b1=((0.2*Vb1b2)*dQbeVb2e1_Vb_b1);
#endif
Qb1b2_Vc4_c1=((0.2*Vb1b2)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1));
#if defined(_DERIVATE2)
  Qb1b2_Vc4_c1_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb1_b2)+dQeVb2e1_Vc4_c1_Vb1_b2));
  Qb1b2_Vc4_c1_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vdt_GND)+dQeVb2e1_Vc4_c1_Vdt_GND));
  Qb1b2_Vc4_c1_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb2_e1)+dQeVb2e1_Vc4_c1_Vb2_e1));
  Qb1b2_Vc4_c1_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb2_c2)+dQeVb2e1_Vc4_c1_Vb2_c2));
  Qb1b2_Vc4_c1_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb2_c1)+0.0));
  Qb1b2_Vc4_c1_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vc1_c2)+dQeVb2e1_Vc4_c1_Vc1_c2));
  Qb1b2_Vc4_c1_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb_c)+0.0));
  Qb1b2_Vc4_c1_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vb_b1)+0.0));
  Qb1b2_Vc4_c1_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vc4_c1)+dQeVb2e1_Vc4_c1_Vc4_c1));
  Qb1b2_Vc4_c1_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vc3_c1)+0.0));
  Qb1b2_Vc4_c1_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc4_c1_Vc3_c4)+0.0));
#endif
Qb1b2_Vc3_c1=((0.2*Vb1b2)*dQbeVb2e1_Vc3_c1);
#if defined(_DERIVATE2)
  Qb1b2_Vc3_c1_Vb1_b2=(+(+0.0*Vb1b2+0.0*Vb1b2_Vb1_b2+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vb1_b2+dQeVb2e1_Vb1_b2)+((0.2*Vb1b2_Vb1_b2))*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb1_b2)+0.0));
  Qb1b2_Vc3_c1_Vdt_GND=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vdt_GND+dQbeVb2e1_Vdt_GND)+dQeVb2e1_Vdt_GND)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vdt_GND)+0.0));
  Qb1b2_Vc3_c1_Vb2_e1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_e1+dQbeVb2e1_Vb2_e1)+dQeVb2e1_Vb2_e1)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb2_e1)+0.0));
  Qb1b2_Vc3_c1_Vb2_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vb2_c2+dQbeVb2e1_Vb2_c2)+dQeVb2e1_Vb2_c2)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb2_c2)+0.0));
  Qb1b2_Vc3_c1_Vb2_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQteVb2e1_Vb2_c1+dQbeVb2e1_Vb2_c1)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb2_c1)+0.0));
  Qb1b2_Vc3_c1_Vc1_c2=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*((dQteVb2e1_Vc1_c2+dQbeVb2e1_Vc1_c2)+dQeVb2e1_Vc1_c2)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vc1_c2)+0.0));
  Qb1b2_Vc3_c1_Vb_c=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_c+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb_c)+0.0));
  Qb1b2_Vc3_c1_Vb_b1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vb_b1+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vb_b1)+0.0));
  Qb1b2_Vc3_c1_Vc4_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*(dQbeVb2e1_Vc4_c1+dQeVb2e1_Vc4_c1)+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vc4_c1)+0.0));
  Qb1b2_Vc3_c1_Vc3_c1=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c1+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vc3_c1)+0.0));
  Qb1b2_Vc3_c1_Vc3_c4=(+(+0.0*Vb1b2+0.0*0.0+0.0*0.0+0.2*0.0)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)+0.0*dQbeVb2e1_Vc3_c4+(0.0)*dQbeVb2e1_Vc3_c1+(0.2*Vb1b2)*(+(+0.0+dQbeVb2e1_Vc3_c1_Vc3_c4)+0.0));
#endif
#if defined(_DERIVATE)
Qb1b2_Vc3_c4=((0.2*Vb1b2)*dQbeVb2e1_Vc3_c4);
#endif
#endif
Qb1b2=((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1));
EXIT_IF_ISNAN(((0.2*Vb1b2)*((dQteVb2e1+dQbeVb2e1)+dQeVb2e1)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Qe_Vdt_GND=((1-pModel->KE)*Qe_qs_Vdt_GND);
#endif
#if defined(_DERIVATE)
Qe_Vb1_b2=((1-pModel->KE)*Qe_qs_Vb1_b2);
#endif
#if defined(_DERIVATE)
Qe_Vb2_c2=((1-pModel->KE)*Qe_qs_Vb2_c2);
#endif
#if defined(_DERIVATE)
Qe_Vc1_c2=((1-pModel->KE)*Qe_qs_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qe_Vc4_c1=((1-pModel->KE)*Qe_qs_Vc4_c1);
#endif
Qe_Vb2_e1=((1-pModel->KE)*Qe_qs_Vb2_e1);
#if defined(_DERIVATE2)
  Qe_Vb2_e1_Vdt_GND=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vdt_GND);
  Qe_Vb2_e1_Vb1_b2=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vb1_b2);
  Qe_Vb2_e1_Vb2_c2=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vb2_c2);
  Qe_Vb2_e1_Vc1_c2=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vc1_c2);
  Qe_Vb2_e1_Vc4_c1=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vc4_c1);
  Qe_Vb2_e1_Vb2_e1=(+(+0.0-0.0)*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*Qe_qs_Vb2_e1+(1-pModel->KE)*Qe_qs_Vb2_e1_Vb2_e1);
#endif
#endif
Qe=((1-pModel->KE)*Qe_qs);
EXIT_IF_ISNAN(((1-pModel->KE)*Qe_qs))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(e1,GND)V(c2,GND)V(c1,GND) */
#if defined(_DERIVATE)
Qbe_qs_eff_Vdt_GND=(Qbe_qs_Vdt_GND+(pModel->KE*Qe_qs_Vdt_GND));
#endif
Qbe_qs_eff_Vb2_e1=(Qbe_qs_Vb2_e1+(pModel->KE*Qe_qs_Vb2_e1));
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vb2_e1_Vdt_GND=(+Qbe_qs_Vb2_e1_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vdt_GND));
  Qbe_qs_eff_Vb2_e1_Vb2_e1=(+Qbe_qs_Vb2_e1_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vb2_e1));
  Qbe_qs_eff_Vb2_e1_Vb_c=(+Qbe_qs_Vb2_e1_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_e1+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_e1_Vb_b1=(+Qbe_qs_Vb2_e1_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_e1+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_e1_Vb1_b2=(+Qbe_qs_Vb2_e1_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vb1_b2));
  Qbe_qs_eff_Vb2_e1_Vc4_c1=(+Qbe_qs_Vb2_e1_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vc4_c1));
  Qbe_qs_eff_Vb2_e1_Vc3_c1=(+Qbe_qs_Vb2_e1_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_e1+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_e1_Vc3_c4=(+Qbe_qs_Vb2_e1_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_e1+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_e1_Vb2_c2=(+Qbe_qs_Vb2_e1_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vb2_c2));
  Qbe_qs_eff_Vb2_e1_Vb2_c1=(+Qbe_qs_Vb2_e1_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_e1+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_e1_Vc1_c2=(+Qbe_qs_Vb2_e1_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*Qe_qs_Vb2_e1+pModel->KE*Qe_qs_Vb2_e1_Vc1_c2));
#endif
#if defined(_DERIVATE)
Qbe_qs_eff_Vb_c=Qbe_qs_Vb_c;
#endif
#if defined(_DERIVATE)
Qbe_qs_eff_Vb_b1=Qbe_qs_Vb_b1;
#endif
#if defined(_DERIVATE)
Qbe_qs_eff_Vb1_b2=(Qbe_qs_Vb1_b2+(pModel->KE*Qe_qs_Vb1_b2));
#endif
Qbe_qs_eff_Vc4_c1=(Qbe_qs_Vc4_c1+(pModel->KE*Qe_qs_Vc4_c1));
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vc4_c1_Vdt_GND=(+Qbe_qs_Vc4_c1_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vdt_GND));
  Qbe_qs_eff_Vc4_c1_Vb2_e1=(+Qbe_qs_Vc4_c1_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vb2_e1));
  Qbe_qs_eff_Vc4_c1_Vb_c=(+Qbe_qs_Vc4_c1_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc4_c1+pModel->KE*0.0));
  Qbe_qs_eff_Vc4_c1_Vb_b1=(+Qbe_qs_Vc4_c1_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc4_c1+pModel->KE*0.0));
  Qbe_qs_eff_Vc4_c1_Vb1_b2=(+Qbe_qs_Vc4_c1_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vb1_b2));
  Qbe_qs_eff_Vc4_c1_Vc4_c1=(+Qbe_qs_Vc4_c1_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vc4_c1));
  Qbe_qs_eff_Vc4_c1_Vc3_c1=(+Qbe_qs_Vc4_c1_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc4_c1+pModel->KE*0.0));
  Qbe_qs_eff_Vc4_c1_Vc3_c4=(+Qbe_qs_Vc4_c1_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc4_c1+pModel->KE*0.0));
  Qbe_qs_eff_Vc4_c1_Vb2_c2=(+Qbe_qs_Vc4_c1_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vb2_c2));
  Qbe_qs_eff_Vc4_c1_Vb2_c1=(+Qbe_qs_Vc4_c1_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc4_c1+pModel->KE*0.0));
  Qbe_qs_eff_Vc4_c1_Vc1_c2=(+Qbe_qs_Vc4_c1_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*Qe_qs_Vc4_c1+pModel->KE*Qe_qs_Vc4_c1_Vc1_c2));
#endif
Qbe_qs_eff_Vc3_c1=Qbe_qs_Vc3_c1;
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vc3_c1_Vdt_GND=(+Qbe_qs_Vc3_c1_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb2_e1=(+Qbe_qs_Vc3_c1_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb_c=(+Qbe_qs_Vc3_c1_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb_b1=(+Qbe_qs_Vc3_c1_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb1_b2=(+Qbe_qs_Vc3_c1_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vc4_c1=(+Qbe_qs_Vc3_c1_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vc3_c1=(+Qbe_qs_Vc3_c1_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vc3_c4=(+Qbe_qs_Vc3_c1_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb2_c2=(+Qbe_qs_Vc3_c1_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vb2_c1=(+Qbe_qs_Vc3_c1_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vc3_c1_Vc1_c2=(+Qbe_qs_Vc3_c1_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*0.0+pModel->KE*0.0));
#endif
#if defined(_DERIVATE)
Qbe_qs_eff_Vc3_c4=Qbe_qs_Vc3_c4;
#endif
Qbe_qs_eff_Vb2_c2=(Qbe_qs_Vb2_c2+(pModel->KE*Qe_qs_Vb2_c2));
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vb2_c2_Vdt_GND=(+Qbe_qs_Vb2_c2_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vdt_GND));
  Qbe_qs_eff_Vb2_c2_Vb2_e1=(+Qbe_qs_Vb2_c2_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vb2_e1));
  Qbe_qs_eff_Vb2_c2_Vb_c=(+Qbe_qs_Vb2_c2_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c2_Vb_b1=(+Qbe_qs_Vb2_c2_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c2_Vb1_b2=(+Qbe_qs_Vb2_c2_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vb1_b2));
  Qbe_qs_eff_Vb2_c2_Vc4_c1=(+Qbe_qs_Vb2_c2_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vc4_c1));
  Qbe_qs_eff_Vb2_c2_Vc3_c1=(+Qbe_qs_Vb2_c2_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c2_Vc3_c4=(+Qbe_qs_Vb2_c2_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c2_Vb2_c2=(+Qbe_qs_Vb2_c2_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vb2_c2));
  Qbe_qs_eff_Vb2_c2_Vb2_c1=(+Qbe_qs_Vb2_c2_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vb2_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c2_Vc1_c2=(+Qbe_qs_Vb2_c2_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*Qe_qs_Vb2_c2+pModel->KE*Qe_qs_Vb2_c2_Vc1_c2));
#endif
Qbe_qs_eff_Vb2_c1=Qbe_qs_Vb2_c1;
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vb2_c1_Vdt_GND=(+Qbe_qs_Vb2_c1_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb2_e1=(+Qbe_qs_Vb2_c1_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb_c=(+Qbe_qs_Vb2_c1_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb_b1=(+Qbe_qs_Vb2_c1_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb1_b2=(+Qbe_qs_Vb2_c1_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vc4_c1=(+Qbe_qs_Vb2_c1_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vc3_c1=(+Qbe_qs_Vb2_c1_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vc3_c4=(+Qbe_qs_Vb2_c1_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb2_c2=(+Qbe_qs_Vb2_c1_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vb2_c1=(+Qbe_qs_Vb2_c1_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*0.0+pModel->KE*0.0));
  Qbe_qs_eff_Vb2_c1_Vc1_c2=(+Qbe_qs_Vb2_c1_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*0.0+pModel->KE*0.0));
#endif
Qbe_qs_eff_Vc1_c2=(Qbe_qs_Vc1_c2+(pModel->KE*Qe_qs_Vc1_c2));
#if defined(_DERIVATE2)
  Qbe_qs_eff_Vc1_c2_Vdt_GND=(+Qbe_qs_Vc1_c2_Vdt_GND+(+0.0*Qe_qs+0.0*Qe_qs_Vdt_GND+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vdt_GND));
  Qbe_qs_eff_Vc1_c2_Vb2_e1=(+Qbe_qs_Vc1_c2_Vb2_e1+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_e1+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vb2_e1));
  Qbe_qs_eff_Vc1_c2_Vb_c=(+Qbe_qs_Vc1_c2_Vb_c+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc1_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vc1_c2_Vb_b1=(+Qbe_qs_Vc1_c2_Vb_b1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc1_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vc1_c2_Vb1_b2=(+Qbe_qs_Vc1_c2_Vb1_b2+(+0.0*Qe_qs+0.0*Qe_qs_Vb1_b2+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vb1_b2));
  Qbe_qs_eff_Vc1_c2_Vc4_c1=(+Qbe_qs_Vc1_c2_Vc4_c1+(+0.0*Qe_qs+0.0*Qe_qs_Vc4_c1+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vc4_c1));
  Qbe_qs_eff_Vc1_c2_Vc3_c1=(+Qbe_qs_Vc1_c2_Vc3_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc1_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vc1_c2_Vc3_c4=(+Qbe_qs_Vc1_c2_Vc3_c4+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc1_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vc1_c2_Vb2_c2=(+Qbe_qs_Vc1_c2_Vb2_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vb2_c2+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vb2_c2));
  Qbe_qs_eff_Vc1_c2_Vb2_c1=(+Qbe_qs_Vc1_c2_Vb2_c1+(+0.0*Qe_qs+0.0*0.0+0.0*Qe_qs_Vc1_c2+pModel->KE*0.0));
  Qbe_qs_eff_Vc1_c2_Vc1_c2=(+Qbe_qs_Vc1_c2_Vc1_c2+(+0.0*Qe_qs+0.0*Qe_qs_Vc1_c2+0.0*Qe_qs_Vc1_c2+pModel->KE*Qe_qs_Vc1_c2_Vc1_c2));
#endif
#endif
Qbe_qs_eff=(Qbe_qs+(pModel->KE*Qe_qs));
EXIT_IF_ISNAN((Qbe_qs+(pModel->KE*Qe_qs)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Qbc_Vdt_GND=((pModel->XQB*Qbe_qs_eff_Vdt_GND)+Qbc_qs_Vdt_GND);
#endif
Qbc_Vb2_e1=((pModel->XQB*Qbe_qs_eff_Vb2_e1)+Qbc_qs_Vb2_e1);
#if defined(_DERIVATE2)
  Qbc_Vb2_e1_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vdt_GND)+Qbc_qs_Vb2_e1_Vdt_GND);
  Qbc_Vb2_e1_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb2_e1)+Qbc_qs_Vb2_e1_Vb2_e1);
  Qbc_Vb2_e1_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb_c)+Qbc_qs_Vb2_e1_Vb_c);
  Qbc_Vb2_e1_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb_b1)+Qbc_qs_Vb2_e1_Vb_b1);
  Qbc_Vb2_e1_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb1_b2)+Qbc_qs_Vb2_e1_Vb1_b2);
  Qbc_Vb2_e1_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vc4_c1)+Qbc_qs_Vb2_e1_Vc4_c1);
  Qbc_Vb2_e1_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vc3_c1)+Qbc_qs_Vb2_e1_Vc3_c1);
  Qbc_Vb2_e1_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vc3_c4)+Qbc_qs_Vb2_e1_Vc3_c4);
  Qbc_Vb2_e1_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb2_c2)+Qbc_qs_Vb2_e1_Vb2_c2);
  Qbc_Vb2_e1_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vb2_c1)+Qbc_qs_Vb2_e1_Vb2_c1);
  Qbc_Vb2_e1_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_e1+pModel->XQB*Qbe_qs_eff_Vb2_e1_Vc1_c2)+Qbc_qs_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbc_Vb_c=((pModel->XQB*Qbe_qs_eff_Vb_c)+Qbc_qs_Vb_c);
#endif
#if defined(_DERIVATE)
Qbc_Vb_b1=((pModel->XQB*Qbe_qs_eff_Vb_b1)+Qbc_qs_Vb_b1);
#endif
#if defined(_DERIVATE)
Qbc_Vb1_b2=((pModel->XQB*Qbe_qs_eff_Vb1_b2)+Qbc_qs_Vb1_b2);
#endif
Qbc_Vc4_c1=((pModel->XQB*Qbe_qs_eff_Vc4_c1)+Qbc_qs_Vc4_c1);
#if defined(_DERIVATE2)
  Qbc_Vc4_c1_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vdt_GND)+Qbc_qs_Vc4_c1_Vdt_GND);
  Qbc_Vc4_c1_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb2_e1)+Qbc_qs_Vc4_c1_Vb2_e1);
  Qbc_Vc4_c1_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb_c)+Qbc_qs_Vc4_c1_Vb_c);
  Qbc_Vc4_c1_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb_b1)+Qbc_qs_Vc4_c1_Vb_b1);
  Qbc_Vc4_c1_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb1_b2)+Qbc_qs_Vc4_c1_Vb1_b2);
  Qbc_Vc4_c1_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vc4_c1)+Qbc_qs_Vc4_c1_Vc4_c1);
  Qbc_Vc4_c1_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vc3_c1)+Qbc_qs_Vc4_c1_Vc3_c1);
  Qbc_Vc4_c1_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vc3_c4)+Qbc_qs_Vc4_c1_Vc3_c4);
  Qbc_Vc4_c1_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb2_c2)+Qbc_qs_Vc4_c1_Vb2_c2);
  Qbc_Vc4_c1_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vb2_c1)+Qbc_qs_Vc4_c1_Vb2_c1);
  Qbc_Vc4_c1_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc4_c1+pModel->XQB*Qbe_qs_eff_Vc4_c1_Vc1_c2)+Qbc_qs_Vc4_c1_Vc1_c2);
#endif
Qbc_Vc3_c1=((pModel->XQB*Qbe_qs_eff_Vc3_c1)+Qbc_qs_Vc3_c1);
#if defined(_DERIVATE2)
  Qbc_Vc3_c1_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vdt_GND)+Qbc_qs_Vc3_c1_Vdt_GND);
  Qbc_Vc3_c1_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb2_e1)+Qbc_qs_Vc3_c1_Vb2_e1);
  Qbc_Vc3_c1_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb_c)+Qbc_qs_Vc3_c1_Vb_c);
  Qbc_Vc3_c1_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb_b1)+Qbc_qs_Vc3_c1_Vb_b1);
  Qbc_Vc3_c1_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb1_b2)+Qbc_qs_Vc3_c1_Vb1_b2);
  Qbc_Vc3_c1_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vc4_c1)+Qbc_qs_Vc3_c1_Vc4_c1);
  Qbc_Vc3_c1_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vc3_c1)+Qbc_qs_Vc3_c1_Vc3_c1);
  Qbc_Vc3_c1_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vc3_c4)+Qbc_qs_Vc3_c1_Vc3_c4);
  Qbc_Vc3_c1_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb2_c2)+Qbc_qs_Vc3_c1_Vb2_c2);
  Qbc_Vc3_c1_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vb2_c1)+Qbc_qs_Vc3_c1_Vb2_c1);
  Qbc_Vc3_c1_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc3_c1+pModel->XQB*Qbe_qs_eff_Vc3_c1_Vc1_c2)+Qbc_qs_Vc3_c1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbc_Vc3_c4=((pModel->XQB*Qbe_qs_eff_Vc3_c4)+Qbc_qs_Vc3_c4);
#endif
Qbc_Vb2_c2=((pModel->XQB*Qbe_qs_eff_Vb2_c2)+Qbc_qs_Vb2_c2);
#if defined(_DERIVATE2)
  Qbc_Vb2_c2_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vdt_GND)+Qbc_qs_Vb2_c2_Vdt_GND);
  Qbc_Vb2_c2_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb2_e1)+Qbc_qs_Vb2_c2_Vb2_e1);
  Qbc_Vb2_c2_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb_c)+Qbc_qs_Vb2_c2_Vb_c);
  Qbc_Vb2_c2_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb_b1)+Qbc_qs_Vb2_c2_Vb_b1);
  Qbc_Vb2_c2_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb1_b2)+Qbc_qs_Vb2_c2_Vb1_b2);
  Qbc_Vb2_c2_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vc4_c1)+Qbc_qs_Vb2_c2_Vc4_c1);
  Qbc_Vb2_c2_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vc3_c1)+Qbc_qs_Vb2_c2_Vc3_c1);
  Qbc_Vb2_c2_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vc3_c4)+Qbc_qs_Vb2_c2_Vc3_c4);
  Qbc_Vb2_c2_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb2_c2)+Qbc_qs_Vb2_c2_Vb2_c2);
  Qbc_Vb2_c2_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vb2_c1)+Qbc_qs_Vb2_c2_Vb2_c1);
  Qbc_Vb2_c2_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_c2+pModel->XQB*Qbe_qs_eff_Vb2_c2_Vc1_c2)+Qbc_qs_Vb2_c2_Vc1_c2);
#endif
Qbc_Vb2_c1=((pModel->XQB*Qbe_qs_eff_Vb2_c1)+Qbc_qs_Vb2_c1);
#if defined(_DERIVATE2)
  Qbc_Vb2_c1_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vdt_GND)+Qbc_qs_Vb2_c1_Vdt_GND);
  Qbc_Vb2_c1_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb2_e1)+Qbc_qs_Vb2_c1_Vb2_e1);
  Qbc_Vb2_c1_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb_c)+Qbc_qs_Vb2_c1_Vb_c);
  Qbc_Vb2_c1_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb_b1)+Qbc_qs_Vb2_c1_Vb_b1);
  Qbc_Vb2_c1_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb1_b2)+Qbc_qs_Vb2_c1_Vb1_b2);
  Qbc_Vb2_c1_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vc4_c1)+Qbc_qs_Vb2_c1_Vc4_c1);
  Qbc_Vb2_c1_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vc3_c1)+Qbc_qs_Vb2_c1_Vc3_c1);
  Qbc_Vb2_c1_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vc3_c4)+Qbc_qs_Vb2_c1_Vc3_c4);
  Qbc_Vb2_c1_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb2_c2)+Qbc_qs_Vb2_c1_Vb2_c2);
  Qbc_Vb2_c1_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vb2_c1)+Qbc_qs_Vb2_c1_Vb2_c1);
  Qbc_Vb2_c1_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_c1+pModel->XQB*Qbe_qs_eff_Vb2_c1_Vc1_c2)+Qbc_qs_Vb2_c1_Vc1_c2);
#endif
Qbc_Vc1_c2=((pModel->XQB*Qbe_qs_eff_Vc1_c2)+Qbc_qs_Vc1_c2);
#if defined(_DERIVATE2)
  Qbc_Vc1_c2_Vdt_GND=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vdt_GND)+Qbc_qs_Vc1_c2_Vdt_GND);
  Qbc_Vc1_c2_Vb2_e1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb2_e1)+Qbc_qs_Vc1_c2_Vb2_e1);
  Qbc_Vc1_c2_Vb_c=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb_c)+Qbc_qs_Vc1_c2_Vb_c);
  Qbc_Vc1_c2_Vb_b1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb_b1)+Qbc_qs_Vc1_c2_Vb_b1);
  Qbc_Vc1_c2_Vb1_b2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb1_b2)+Qbc_qs_Vc1_c2_Vb1_b2);
  Qbc_Vc1_c2_Vc4_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vc4_c1)+Qbc_qs_Vc1_c2_Vc4_c1);
  Qbc_Vc1_c2_Vc3_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vc3_c1)+Qbc_qs_Vc1_c2_Vc3_c1);
  Qbc_Vc1_c2_Vc3_c4=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vc3_c4)+Qbc_qs_Vc1_c2_Vc3_c4);
  Qbc_Vc1_c2_Vb2_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb2_c2)+Qbc_qs_Vc1_c2_Vb2_c2);
  Qbc_Vc1_c2_Vb2_c1=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vb2_c1)+Qbc_qs_Vc1_c2_Vb2_c1);
  Qbc_Vc1_c2_Vc1_c2=(+(+0.0*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc1_c2+pModel->XQB*Qbe_qs_eff_Vc1_c2_Vc1_c2)+Qbc_qs_Vc1_c2_Vc1_c2);
#endif
#endif
pInst->Qbc=((pModel->XQB*Qbe_qs_eff)+Qbc_qs);
EXIT_IF_ISNAN(((pModel->XQB*Qbe_qs_eff)+Qbc_qs))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Qbe_Vdt_GND=((1-pModel->XQB)*Qbe_qs_eff_Vdt_GND);
#endif
Qbe_Vb2_e1=((1-pModel->XQB)*Qbe_qs_eff_Vb2_e1);
#if defined(_DERIVATE2)
  Qbe_Vb2_e1_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vdt_GND);
  Qbe_Vb2_e1_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb2_e1);
  Qbe_Vb2_e1_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb_c);
  Qbe_Vb2_e1_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb_b1);
  Qbe_Vb2_e1_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb1_b2);
  Qbe_Vb2_e1_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vc4_c1);
  Qbe_Vb2_e1_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vc3_c1);
  Qbe_Vb2_e1_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vc3_c4);
  Qbe_Vb2_e1_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb2_c2);
  Qbe_Vb2_e1_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vb2_c1);
  Qbe_Vb2_e1_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_e1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_e1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbe_Vb_c=((1-pModel->XQB)*Qbe_qs_eff_Vb_c);
#endif
#if defined(_DERIVATE)
Qbe_Vb_b1=((1-pModel->XQB)*Qbe_qs_eff_Vb_b1);
#endif
#if defined(_DERIVATE)
Qbe_Vb1_b2=((1-pModel->XQB)*Qbe_qs_eff_Vb1_b2);
#endif
Qbe_Vc4_c1=((1-pModel->XQB)*Qbe_qs_eff_Vc4_c1);
#if defined(_DERIVATE2)
  Qbe_Vc4_c1_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vdt_GND);
  Qbe_Vc4_c1_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb2_e1);
  Qbe_Vc4_c1_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb_c);
  Qbe_Vc4_c1_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb_b1);
  Qbe_Vc4_c1_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb1_b2);
  Qbe_Vc4_c1_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vc4_c1);
  Qbe_Vc4_c1_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vc3_c1);
  Qbe_Vc4_c1_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vc3_c4);
  Qbe_Vc4_c1_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb2_c2);
  Qbe_Vc4_c1_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vb2_c1);
  Qbe_Vc4_c1_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc4_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc4_c1_Vc1_c2);
#endif
Qbe_Vc3_c1=((1-pModel->XQB)*Qbe_qs_eff_Vc3_c1);
#if defined(_DERIVATE2)
  Qbe_Vc3_c1_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vdt_GND);
  Qbe_Vc3_c1_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb2_e1);
  Qbe_Vc3_c1_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb_c);
  Qbe_Vc3_c1_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb_b1);
  Qbe_Vc3_c1_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb1_b2);
  Qbe_Vc3_c1_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vc4_c1);
  Qbe_Vc3_c1_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vc3_c1);
  Qbe_Vc3_c1_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vc3_c4);
  Qbe_Vc3_c1_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb2_c2);
  Qbe_Vc3_c1_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vb2_c1);
  Qbe_Vc3_c1_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc3_c1+(1-pModel->XQB)*Qbe_qs_eff_Vc3_c1_Vc1_c2);
#endif
#if defined(_DERIVATE)
Qbe_Vc3_c4=((1-pModel->XQB)*Qbe_qs_eff_Vc3_c4);
#endif
Qbe_Vb2_c2=((1-pModel->XQB)*Qbe_qs_eff_Vb2_c2);
#if defined(_DERIVATE2)
  Qbe_Vb2_c2_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vdt_GND);
  Qbe_Vb2_c2_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb2_e1);
  Qbe_Vb2_c2_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb_c);
  Qbe_Vb2_c2_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb_b1);
  Qbe_Vb2_c2_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb1_b2);
  Qbe_Vb2_c2_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vc4_c1);
  Qbe_Vb2_c2_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vc3_c1);
  Qbe_Vb2_c2_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vc3_c4);
  Qbe_Vb2_c2_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb2_c2);
  Qbe_Vb2_c2_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vb2_c1);
  Qbe_Vb2_c2_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_c2+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c2_Vc1_c2);
#endif
Qbe_Vb2_c1=((1-pModel->XQB)*Qbe_qs_eff_Vb2_c1);
#if defined(_DERIVATE2)
  Qbe_Vb2_c1_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vdt_GND);
  Qbe_Vb2_c1_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb2_e1);
  Qbe_Vb2_c1_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb_c);
  Qbe_Vb2_c1_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb_b1);
  Qbe_Vb2_c1_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb1_b2);
  Qbe_Vb2_c1_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vc4_c1);
  Qbe_Vb2_c1_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vc3_c1);
  Qbe_Vb2_c1_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vc3_c4);
  Qbe_Vb2_c1_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb2_c2);
  Qbe_Vb2_c1_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vb2_c1);
  Qbe_Vb2_c1_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vb2_c1+(1-pModel->XQB)*Qbe_qs_eff_Vb2_c1_Vc1_c2);
#endif
Qbe_Vc1_c2=((1-pModel->XQB)*Qbe_qs_eff_Vc1_c2);
#if defined(_DERIVATE2)
  Qbe_Vc1_c2_Vdt_GND=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vdt_GND+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vdt_GND);
  Qbe_Vc1_c2_Vb2_e1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_e1+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb2_e1);
  Qbe_Vc1_c2_Vb_c=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_c+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb_c);
  Qbe_Vc1_c2_Vb_b1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb_b1+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb_b1);
  Qbe_Vc1_c2_Vb1_b2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb1_b2+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb1_b2);
  Qbe_Vc1_c2_Vc4_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc4_c1+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vc4_c1);
  Qbe_Vc1_c2_Vc3_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c1+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vc3_c1);
  Qbe_Vc1_c2_Vc3_c4=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc3_c4+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vc3_c4);
  Qbe_Vc1_c2_Vb2_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c2+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb2_c2);
  Qbe_Vc1_c2_Vb2_c1=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vb2_c1+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vb2_c1);
  Qbe_Vc1_c2_Vc1_c2=(+(+0.0-0.0)*Qbe_qs_eff+0.0*Qbe_qs_eff_Vc1_c2+0.0*Qbe_qs_eff_Vc1_c2+(1-pModel->XQB)*Qbe_qs_eff_Vc1_c2_Vc1_c2);
#endif
#endif
pInst->Qbe=((1-pModel->XQB)*Qbe_qs_eff);
EXIT_IF_ISNAN(((1-pModel->XQB)*Qbe_qs_eff))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Qbe_Vdt_GND=Qbe_qs_Vdt_GND;
#endif
Qbe_Vb2_e1=Qbe_qs_Vb2_e1;
#if defined(_DERIVATE2)
  Qbe_Vb2_e1_Vdt_GND=Qbe_qs_Vb2_e1_Vdt_GND;
  Qbe_Vb2_e1_Vb2_e1=Qbe_qs_Vb2_e1_Vb2_e1;
  Qbe_Vb2_e1_Vb_c=Qbe_qs_Vb2_e1_Vb_c;
  Qbe_Vb2_e1_Vb_b1=Qbe_qs_Vb2_e1_Vb_b1;
  Qbe_Vb2_e1_Vb1_b2=Qbe_qs_Vb2_e1_Vb1_b2;
  Qbe_Vb2_e1_Vc4_c1=Qbe_qs_Vb2_e1_Vc4_c1;
  Qbe_Vb2_e1_Vc3_c1=Qbe_qs_Vb2_e1_Vc3_c1;
  Qbe_Vb2_e1_Vc3_c4=Qbe_qs_Vb2_e1_Vc3_c4;
  Qbe_Vb2_e1_Vb2_c2=Qbe_qs_Vb2_e1_Vb2_c2;
  Qbe_Vb2_e1_Vb2_c1=Qbe_qs_Vb2_e1_Vb2_c1;
  Qbe_Vb2_e1_Vc1_c2=Qbe_qs_Vb2_e1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Qbe_Vb_c=Qbe_qs_Vb_c;
#endif
#if defined(_DERIVATE)
Qbe_Vb_b1=Qbe_qs_Vb_b1;
#endif
#if defined(_DERIVATE)
Qbe_Vb1_b2=Qbe_qs_Vb1_b2;
#endif
Qbe_Vc4_c1=Qbe_qs_Vc4_c1;
#if defined(_DERIVATE2)
  Qbe_Vc4_c1_Vdt_GND=Qbe_qs_Vc4_c1_Vdt_GND;
  Qbe_Vc4_c1_Vb2_e1=Qbe_qs_Vc4_c1_Vb2_e1;
  Qbe_Vc4_c1_Vb_c=Qbe_qs_Vc4_c1_Vb_c;
  Qbe_Vc4_c1_Vb_b1=Qbe_qs_Vc4_c1_Vb_b1;
  Qbe_Vc4_c1_Vb1_b2=Qbe_qs_Vc4_c1_Vb1_b2;
  Qbe_Vc4_c1_Vc4_c1=Qbe_qs_Vc4_c1_Vc4_c1;
  Qbe_Vc4_c1_Vc3_c1=Qbe_qs_Vc4_c1_Vc3_c1;
  Qbe_Vc4_c1_Vc3_c4=Qbe_qs_Vc4_c1_Vc3_c4;
  Qbe_Vc4_c1_Vb2_c2=Qbe_qs_Vc4_c1_Vb2_c2;
  Qbe_Vc4_c1_Vb2_c1=Qbe_qs_Vc4_c1_Vb2_c1;
  Qbe_Vc4_c1_Vc1_c2=Qbe_qs_Vc4_c1_Vc1_c2;
#endif
Qbe_Vc3_c1=Qbe_qs_Vc3_c1;
#if defined(_DERIVATE2)
  Qbe_Vc3_c1_Vdt_GND=Qbe_qs_Vc3_c1_Vdt_GND;
  Qbe_Vc3_c1_Vb2_e1=Qbe_qs_Vc3_c1_Vb2_e1;
  Qbe_Vc3_c1_Vb_c=Qbe_qs_Vc3_c1_Vb_c;
  Qbe_Vc3_c1_Vb_b1=Qbe_qs_Vc3_c1_Vb_b1;
  Qbe_Vc3_c1_Vb1_b2=Qbe_qs_Vc3_c1_Vb1_b2;
  Qbe_Vc3_c1_Vc4_c1=Qbe_qs_Vc3_c1_Vc4_c1;
  Qbe_Vc3_c1_Vc3_c1=Qbe_qs_Vc3_c1_Vc3_c1;
  Qbe_Vc3_c1_Vc3_c4=Qbe_qs_Vc3_c1_Vc3_c4;
  Qbe_Vc3_c1_Vb2_c2=Qbe_qs_Vc3_c1_Vb2_c2;
  Qbe_Vc3_c1_Vb2_c1=Qbe_qs_Vc3_c1_Vb2_c1;
  Qbe_Vc3_c1_Vc1_c2=Qbe_qs_Vc3_c1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Qbe_Vc3_c4=Qbe_qs_Vc3_c4;
#endif
Qbe_Vb2_c2=Qbe_qs_Vb2_c2;
#if defined(_DERIVATE2)
  Qbe_Vb2_c2_Vdt_GND=Qbe_qs_Vb2_c2_Vdt_GND;
  Qbe_Vb2_c2_Vb2_e1=Qbe_qs_Vb2_c2_Vb2_e1;
  Qbe_Vb2_c2_Vb_c=Qbe_qs_Vb2_c2_Vb_c;
  Qbe_Vb2_c2_Vb_b1=Qbe_qs_Vb2_c2_Vb_b1;
  Qbe_Vb2_c2_Vb1_b2=Qbe_qs_Vb2_c2_Vb1_b2;
  Qbe_Vb2_c2_Vc4_c1=Qbe_qs_Vb2_c2_Vc4_c1;
  Qbe_Vb2_c2_Vc3_c1=Qbe_qs_Vb2_c2_Vc3_c1;
  Qbe_Vb2_c2_Vc3_c4=Qbe_qs_Vb2_c2_Vc3_c4;
  Qbe_Vb2_c2_Vb2_c2=Qbe_qs_Vb2_c2_Vb2_c2;
  Qbe_Vb2_c2_Vb2_c1=Qbe_qs_Vb2_c2_Vb2_c1;
  Qbe_Vb2_c2_Vc1_c2=Qbe_qs_Vb2_c2_Vc1_c2;
#endif
Qbe_Vb2_c1=Qbe_qs_Vb2_c1;
#if defined(_DERIVATE2)
  Qbe_Vb2_c1_Vdt_GND=Qbe_qs_Vb2_c1_Vdt_GND;
  Qbe_Vb2_c1_Vb2_e1=Qbe_qs_Vb2_c1_Vb2_e1;
  Qbe_Vb2_c1_Vb_c=Qbe_qs_Vb2_c1_Vb_c;
  Qbe_Vb2_c1_Vb_b1=Qbe_qs_Vb2_c1_Vb_b1;
  Qbe_Vb2_c1_Vb1_b2=Qbe_qs_Vb2_c1_Vb1_b2;
  Qbe_Vb2_c1_Vc4_c1=Qbe_qs_Vb2_c1_Vc4_c1;
  Qbe_Vb2_c1_Vc3_c1=Qbe_qs_Vb2_c1_Vc3_c1;
  Qbe_Vb2_c1_Vc3_c4=Qbe_qs_Vb2_c1_Vc3_c4;
  Qbe_Vb2_c1_Vb2_c2=Qbe_qs_Vb2_c1_Vb2_c2;
  Qbe_Vb2_c1_Vb2_c1=Qbe_qs_Vb2_c1_Vb2_c1;
  Qbe_Vb2_c1_Vc1_c2=Qbe_qs_Vb2_c1_Vc1_c2;
#endif
Qbe_Vc1_c2=Qbe_qs_Vc1_c2;
#if defined(_DERIVATE2)
  Qbe_Vc1_c2_Vdt_GND=Qbe_qs_Vc1_c2_Vdt_GND;
  Qbe_Vc1_c2_Vb2_e1=Qbe_qs_Vc1_c2_Vb2_e1;
  Qbe_Vc1_c2_Vb_c=Qbe_qs_Vc1_c2_Vb_c;
  Qbe_Vc1_c2_Vb_b1=Qbe_qs_Vc1_c2_Vb_b1;
  Qbe_Vc1_c2_Vb1_b2=Qbe_qs_Vc1_c2_Vb1_b2;
  Qbe_Vc1_c2_Vc4_c1=Qbe_qs_Vc1_c2_Vc4_c1;
  Qbe_Vc1_c2_Vc3_c1=Qbe_qs_Vc1_c2_Vc3_c1;
  Qbe_Vc1_c2_Vc3_c4=Qbe_qs_Vc1_c2_Vc3_c4;
  Qbe_Vc1_c2_Vb2_c2=Qbe_qs_Vc1_c2_Vb2_c2;
  Qbe_Vc1_c2_Vb2_c1=Qbe_qs_Vc1_c2_Vb2_c1;
  Qbe_Vc1_c2_Vc1_c2=Qbe_qs_Vc1_c2_Vc1_c2;
#endif
#endif
pInst->Qbe=Qbe_qs;
EXIT_IF_ISNAN(Qbe_qs)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe=V(c1,GND)V(c2,GND)V(e1,GND) */
#if defined(_DERIVATE)
Qbc_Vdt_GND=Qbc_qs_Vdt_GND;
#endif
Qbc_Vb2_e1=Qbc_qs_Vb2_e1;
#if defined(_DERIVATE2)
  Qbc_Vb2_e1_Vdt_GND=Qbc_qs_Vb2_e1_Vdt_GND;
  Qbc_Vb2_e1_Vb2_e1=Qbc_qs_Vb2_e1_Vb2_e1;
  Qbc_Vb2_e1_Vb_c=Qbc_qs_Vb2_e1_Vb_c;
  Qbc_Vb2_e1_Vb_b1=Qbc_qs_Vb2_e1_Vb_b1;
  Qbc_Vb2_e1_Vb1_b2=Qbc_qs_Vb2_e1_Vb1_b2;
  Qbc_Vb2_e1_Vc4_c1=Qbc_qs_Vb2_e1_Vc4_c1;
  Qbc_Vb2_e1_Vc3_c1=Qbc_qs_Vb2_e1_Vc3_c1;
  Qbc_Vb2_e1_Vc3_c4=Qbc_qs_Vb2_e1_Vc3_c4;
  Qbc_Vb2_e1_Vb2_c2=Qbc_qs_Vb2_e1_Vb2_c2;
  Qbc_Vb2_e1_Vb2_c1=Qbc_qs_Vb2_e1_Vb2_c1;
  Qbc_Vb2_e1_Vc1_c2=Qbc_qs_Vb2_e1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Qbc_Vb_c=Qbc_qs_Vb_c;
#endif
#if defined(_DERIVATE)
Qbc_Vb_b1=Qbc_qs_Vb_b1;
#endif
#if defined(_DERIVATE)
Qbc_Vb1_b2=Qbc_qs_Vb1_b2;
#endif
Qbc_Vc4_c1=Qbc_qs_Vc4_c1;
#if defined(_DERIVATE2)
  Qbc_Vc4_c1_Vdt_GND=Qbc_qs_Vc4_c1_Vdt_GND;
  Qbc_Vc4_c1_Vb2_e1=Qbc_qs_Vc4_c1_Vb2_e1;
  Qbc_Vc4_c1_Vb_c=Qbc_qs_Vc4_c1_Vb_c;
  Qbc_Vc4_c1_Vb_b1=Qbc_qs_Vc4_c1_Vb_b1;
  Qbc_Vc4_c1_Vb1_b2=Qbc_qs_Vc4_c1_Vb1_b2;
  Qbc_Vc4_c1_Vc4_c1=Qbc_qs_Vc4_c1_Vc4_c1;
  Qbc_Vc4_c1_Vc3_c1=Qbc_qs_Vc4_c1_Vc3_c1;
  Qbc_Vc4_c1_Vc3_c4=Qbc_qs_Vc4_c1_Vc3_c4;
  Qbc_Vc4_c1_Vb2_c2=Qbc_qs_Vc4_c1_Vb2_c2;
  Qbc_Vc4_c1_Vb2_c1=Qbc_qs_Vc4_c1_Vb2_c1;
  Qbc_Vc4_c1_Vc1_c2=Qbc_qs_Vc4_c1_Vc1_c2;
#endif
Qbc_Vc3_c1=Qbc_qs_Vc3_c1;
#if defined(_DERIVATE2)
  Qbc_Vc3_c1_Vdt_GND=Qbc_qs_Vc3_c1_Vdt_GND;
  Qbc_Vc3_c1_Vb2_e1=Qbc_qs_Vc3_c1_Vb2_e1;
  Qbc_Vc3_c1_Vb_c=Qbc_qs_Vc3_c1_Vb_c;
  Qbc_Vc3_c1_Vb_b1=Qbc_qs_Vc3_c1_Vb_b1;
  Qbc_Vc3_c1_Vb1_b2=Qbc_qs_Vc3_c1_Vb1_b2;
  Qbc_Vc3_c1_Vc4_c1=Qbc_qs_Vc3_c1_Vc4_c1;
  Qbc_Vc3_c1_Vc3_c1=Qbc_qs_Vc3_c1_Vc3_c1;
  Qbc_Vc3_c1_Vc3_c4=Qbc_qs_Vc3_c1_Vc3_c4;
  Qbc_Vc3_c1_Vb2_c2=Qbc_qs_Vc3_c1_Vb2_c2;
  Qbc_Vc3_c1_Vb2_c1=Qbc_qs_Vc3_c1_Vb2_c1;
  Qbc_Vc3_c1_Vc1_c2=Qbc_qs_Vc3_c1_Vc1_c2;
#endif
#if defined(_DERIVATE)
Qbc_Vc3_c4=Qbc_qs_Vc3_c4;
#endif
Qbc_Vb2_c2=Qbc_qs_Vb2_c2;
#if defined(_DERIVATE2)
  Qbc_Vb2_c2_Vdt_GND=Qbc_qs_Vb2_c2_Vdt_GND;
  Qbc_Vb2_c2_Vb2_e1=Qbc_qs_Vb2_c2_Vb2_e1;
  Qbc_Vb2_c2_Vb_c=Qbc_qs_Vb2_c2_Vb_c;
  Qbc_Vb2_c2_Vb_b1=Qbc_qs_Vb2_c2_Vb_b1;
  Qbc_Vb2_c2_Vb1_b2=Qbc_qs_Vb2_c2_Vb1_b2;
  Qbc_Vb2_c2_Vc4_c1=Qbc_qs_Vb2_c2_Vc4_c1;
  Qbc_Vb2_c2_Vc3_c1=Qbc_qs_Vb2_c2_Vc3_c1;
  Qbc_Vb2_c2_Vc3_c4=Qbc_qs_Vb2_c2_Vc3_c4;
  Qbc_Vb2_c2_Vb2_c2=Qbc_qs_Vb2_c2_Vb2_c2;
  Qbc_Vb2_c2_Vb2_c1=Qbc_qs_Vb2_c2_Vb2_c1;
  Qbc_Vb2_c2_Vc1_c2=Qbc_qs_Vb2_c2_Vc1_c2;
#endif
Qbc_Vb2_c1=Qbc_qs_Vb2_c1;
#if defined(_DERIVATE2)
  Qbc_Vb2_c1_Vdt_GND=Qbc_qs_Vb2_c1_Vdt_GND;
  Qbc_Vb2_c1_Vb2_e1=Qbc_qs_Vb2_c1_Vb2_e1;
  Qbc_Vb2_c1_Vb_c=Qbc_qs_Vb2_c1_Vb_c;
  Qbc_Vb2_c1_Vb_b1=Qbc_qs_Vb2_c1_Vb_b1;
  Qbc_Vb2_c1_Vb1_b2=Qbc_qs_Vb2_c1_Vb1_b2;
  Qbc_Vb2_c1_Vc4_c1=Qbc_qs_Vb2_c1_Vc4_c1;
  Qbc_Vb2_c1_Vc3_c1=Qbc_qs_Vb2_c1_Vc3_c1;
  Qbc_Vb2_c1_Vc3_c4=Qbc_qs_Vb2_c1_Vc3_c4;
  Qbc_Vb2_c1_Vb2_c2=Qbc_qs_Vb2_c1_Vb2_c2;
  Qbc_Vb2_c1_Vb2_c1=Qbc_qs_Vb2_c1_Vb2_c1;
  Qbc_Vb2_c1_Vc1_c2=Qbc_qs_Vb2_c1_Vc1_c2;
#endif
Qbc_Vc1_c2=Qbc_qs_Vc1_c2;
#if defined(_DERIVATE2)
  Qbc_Vc1_c2_Vdt_GND=Qbc_qs_Vc1_c2_Vdt_GND;
  Qbc_Vc1_c2_Vb2_e1=Qbc_qs_Vc1_c2_Vb2_e1;
  Qbc_Vc1_c2_Vb_c=Qbc_qs_Vc1_c2_Vb_c;
  Qbc_Vc1_c2_Vb_b1=Qbc_qs_Vc1_c2_Vb_b1;
  Qbc_Vc1_c2_Vb1_b2=Qbc_qs_Vc1_c2_Vb1_b2;
  Qbc_Vc1_c2_Vc4_c1=Qbc_qs_Vc1_c2_Vc4_c1;
  Qbc_Vc1_c2_Vc3_c1=Qbc_qs_Vc1_c2_Vc3_c1;
  Qbc_Vc1_c2_Vc3_c4=Qbc_qs_Vc1_c2_Vc3_c4;
  Qbc_Vc1_c2_Vb2_c2=Qbc_qs_Vc1_c2_Vb2_c2;
  Qbc_Vc1_c2_Vb2_c1=Qbc_qs_Vc1_c2_Vb2_c1;
  Qbc_Vc1_c2_Vc1_c2=Qbc_qs_Vc1_c2_Vc1_c2;
#endif
#endif
pInst->Qbc=Qbc_qs;
EXIT_IF_ISNAN(Qbc_qs)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe=V(e1,GND) */
#if defined(_DERIVATE)
Qe_Vdt_GND=Qe_qs_Vdt_GND;
#endif
#if defined(_DERIVATE)
Qe_Vb1_b2=Qe_qs_Vb1_b2;
#endif
#if defined(_DERIVATE)
Qe_Vb2_c2=Qe_qs_Vb2_c2;
#endif
#if defined(_DERIVATE)
Qe_Vc1_c2=Qe_qs_Vc1_c2;
#endif
#if defined(_DERIVATE)
Qe_Vc4_c1=Qe_qs_Vc4_c1;
#endif
Qe_Vb2_e1=Qe_qs_Vb2_e1;
#if defined(_DERIVATE2)
  Qe_Vb2_e1_Vdt_GND=Qe_qs_Vb2_e1_Vdt_GND;
  Qe_Vb2_e1_Vb1_b2=Qe_qs_Vb2_e1_Vb1_b2;
  Qe_Vb2_e1_Vb2_c2=Qe_qs_Vb2_e1_Vb2_c2;
  Qe_Vb2_e1_Vc1_c2=Qe_qs_Vb2_e1_Vc1_c2;
  Qe_Vb2_e1_Vc4_c1=Qe_qs_Vb2_e1_Vc4_c1;
  Qe_Vb2_e1_Vb2_e1=Qe_qs_Vb2_e1_Vb2_e1;
#endif
#endif
Qe=Qe_qs;
EXIT_IF_ISNAN(Qe_qs)
#endif
}
#endif /* if(...) */
  _load_static_residual2(c1,c2,(pModel->TYPE*Ic1c2))
  _load_static_jacobian4(c1,c2,c1,c2,(pModel->TYPE*Ic1c2_Vc1_c2))
  _load_static_jacobian4(c1,c2,b2,c1,(pModel->TYPE*Ic1c2_Vb2_c1))
  _load_static_jacobian4(c1,c2,b2,c2,(pModel->TYPE*Ic1c2_Vb2_c2))
  _load_static_jacobian2s(c1,c2,dt,(pModel->TYPE*Ic1c2_Vdt_GND))
  _load_static_residual2(c2,e1,(pModel->TYPE*In))
  _load_static_jacobian4(c2,e1,c1,c2,(pModel->TYPE*In_Vc1_c2))
  _load_static_jacobian4(c2,e1,b2,c1,(pModel->TYPE*In_Vb2_c1))
  _load_static_jacobian4(c2,e1,b2,c2,(pModel->TYPE*In_Vb2_c2))
  _load_static_jacobian4(c2,e1,b2,e1,(pModel->TYPE*In_Vb2_e1))
  _load_static_jacobian2s(c2,e1,dt,(pModel->TYPE*In_Vdt_GND))
  _load_static_residual2(b1,e1,(pModel->TYPE*pInst->Ib1_s))
  _load_static_jacobian4(b1,e1,b1,e1,(pModel->TYPE*Ib1_s_Vb1_e1))
  _load_static_jacobian2s(b1,e1,dt,(pModel->TYPE*Ib1_s_Vdt_GND))
  _load_static_residual2(b2,e1,(pModel->TYPE*((pInst->Ib1+pInst->Ib2)-pInst->Izteb)))
  _load_static_jacobian4(b2,e1,b2,e1,(pModel->TYPE*((Ib1_Vb2_e1+Ib2_Vb2_e1)-Izteb_Vb2_e1)))
  _load_static_jacobian2s(b2,e1,dt,(pModel->TYPE*((Ib1_Vdt_GND+Ib2_Vdt_GND)-Izteb_Vdt_GND)))
  _load_static_jacobian4(b2,e1,c1,c2,(pModel->TYPE*(Ib1_Vc1_c2-Izteb_Vc1_c2)))
  _load_static_jacobian4(b2,e1,b2,c1,(pModel->TYPE*(Ib1_Vb2_c1-Izteb_Vb2_c1)))
  _load_static_jacobian4(b2,e1,b2,c2,(pModel->TYPE*(Ib1_Vb2_c2-Izteb_Vb2_c2)))
  _load_static_residual2(b1,s,(pModel->TYPE*pInst->Isub))
  _load_static_jacobian4(b1,s,s,c1,(pModel->TYPE*Isub_Vs_c1))
  _load_static_jacobian4(b1,s,c4,c1,(pModel->TYPE*Isub_Vc4_c1))
  _load_static_jacobian4(b1,s,c1,c2,(pModel->TYPE*Isub_Vc1_c2))
  _load_static_jacobian4(b1,s,b2,c2,(pModel->TYPE*Isub_Vb2_c2))
  _load_static_jacobian4(b1,s,b1,b2,(pModel->TYPE*Isub_Vb1_b2))
  _load_static_jacobian2s(b1,s,dt,(pModel->TYPE*Isub_Vdt_GND))
  _load_static_residual2(b,s,(pModel->TYPE*pInst->XIsub))
  _load_static_jacobian4(b,s,s,c1,(pModel->TYPE*XIsub_Vs_c1))
  _load_static_jacobian4(b,s,c1,c2,(pModel->TYPE*XIsub_Vc1_c2))
  _load_static_jacobian4(b,s,b2,c1,(pModel->TYPE*XIsub_Vb2_c1))
  _load_static_jacobian4(b,s,b2,c2,(pModel->TYPE*XIsub_Vb2_c2))
  _load_static_jacobian4(b,s,b2,e1,(pModel->TYPE*XIsub_Vb2_e1))
  _load_static_jacobian4(b,s,c3,c4,(pModel->TYPE*XIsub_Vc3_c4))
  _load_static_jacobian4(b,s,c3,c1,(pModel->TYPE*XIsub_Vc3_c1))
  _load_static_jacobian4(b,s,c4,c1,(pModel->TYPE*XIsub_Vc4_c1))
  _load_static_jacobian4(b,s,b1,b2,(pModel->TYPE*XIsub_Vb1_b2))
  _load_static_jacobian4(b,s,b,b1,(pModel->TYPE*XIsub_Vb_b1))
  _load_static_jacobian4(b,s,b,c,(pModel->TYPE*XIsub_Vb_c))
  _load_static_jacobian2s(b,s,dt,(pModel->TYPE*XIsub_Vdt_GND))
  _load_static_residual2(s,c1,(pModel->TYPE*Isf))
  _load_static_jacobian4(s,c1,s,c1,(pModel->TYPE*Isf_Vs_c1))
  _load_static_jacobian2s(s,c1,dt,(pModel->TYPE*Isf_Vdt_GND))
  _load_static_residual2(b1,b2,(pModel->TYPE*Ib1b2))
  _load_static_jacobian4(b1,b2,c1,c2,(pModel->TYPE*Ib1b2_Vc1_c2))
  _load_static_jacobian4(b1,b2,b2,c1,(pModel->TYPE*Ib1b2_Vb2_c1))
  _load_static_jacobian4(b1,b2,b2,c2,(pModel->TYPE*Ib1b2_Vb2_c2))
  _load_static_jacobian4(b1,b2,b2,e1,(pModel->TYPE*Ib1b2_Vb2_e1))
  _load_static_jacobian4(b1,b2,c3,c4,(pModel->TYPE*Ib1b2_Vc3_c4))
  _load_static_jacobian4(b1,b2,c3,c1,(pModel->TYPE*Ib1b2_Vc3_c1))
  _load_static_jacobian4(b1,b2,c4,c1,(pModel->TYPE*Ib1b2_Vc4_c1))
  _load_static_jacobian4(b1,b2,b,b1,(pModel->TYPE*Ib1b2_Vb_b1))
  _load_static_jacobian4(b1,b2,b,c,(pModel->TYPE*Ib1b2_Vb_c))
  _load_static_jacobian4(b1,b2,b1,b2,(pModel->TYPE*Ib1b2_Vb1_b2))
  _load_static_jacobian2s(b1,b2,dt,(pModel->TYPE*Ib1b2_Vdt_GND))
  _load_static_residual2(b2,c2,(pModel->TYPE*((-1.0)*pInst->Iavl)))
  _load_static_jacobian4(b2,c2,b2,e1,(pModel->TYPE*((-1.0)*Iavl_Vb2_e1)))
  _load_static_jacobian4(b2,c2,c3,c4,(pModel->TYPE*((-1.0)*Iavl_Vc3_c4)))
  _load_static_jacobian4(b2,c2,c3,c1,(pModel->TYPE*((-1.0)*Iavl_Vc3_c1)))
  _load_static_jacobian4(b2,c2,c4,c1,(pModel->TYPE*((-1.0)*Iavl_Vc4_c1)))
  _load_static_jacobian4(b2,c2,b1,b2,(pModel->TYPE*((-1.0)*Iavl_Vb1_b2)))
  _load_static_jacobian4(b2,c2,b,b1,(pModel->TYPE*((-1.0)*Iavl_Vb_b1)))
  _load_static_jacobian4(b2,c2,b,c,(pModel->TYPE*((-1.0)*Iavl_Vb_c)))
  _load_static_jacobian4(b2,c2,c1,c2,(pModel->TYPE*((-1.0)*Iavl_Vc1_c2)))
  _load_static_jacobian4(b2,c2,b2,c1,(pModel->TYPE*((-1.0)*Iavl_Vb2_c1)))
  _load_static_jacobian4(b2,c2,b2,c2,(pModel->TYPE*((-1.0)*Iavl_Vb2_c2)))
  _load_static_jacobian2s(b2,c2,dt,(pModel->TYPE*((-1.0)*Iavl_Vdt_GND)))
  _load_static_residual2(e,e1,((pModel->TYPE*Vee1)/pInst->RE_TM))
  _load_static_jacobian2s(e,e1,dt,(-(pModel->TYPE*Vee1)*RE_TM_Vdt_GND/pInst->RE_TM/pInst->RE_TM))
  _load_static_jacobian4(e,e1,e,e1,((pModel->TYPE*Vee1_Ve_e1)/pInst->RE_TM))
  _load_static_residual2(b,b1,((pModel->TYPE*Vbb1)/pInst->RBC_TM))
  _load_static_jacobian2s(b,b1,dt,(-(pModel->TYPE*Vbb1)*RBC_TM_Vdt_GND/pInst->RBC_TM/pInst->RBC_TM))
  _load_static_jacobian4(b,b1,b,b1,((pModel->TYPE*Vbb1_Vb_b1)/pInst->RBC_TM))
  _load_static_residual1(dt,(NP(dt)/RTH_Tamb_M))
  _load_static_jacobian1(dt,dt,(1/RTH_Tamb_M))
  _load_dynamic_residual1(dt,_DDT((CTH_M*NP(dt))))
  _load_dynamic_jacobian1(dt,dt,(CTH_M))
  _load_static_residual1(dt,((-1.0)*power_dis))
  _load_static_jacobian2p(dt,s,c1,((-1.0)*power_dis_Vs_c1))
  _load_static_jacobian2p(dt,b1,e1,((-1.0)*power_dis_Vb1_e1))
  _load_static_jacobian2p(dt,e,e1,((-1.0)*power_dis_Ve_e1))
  _load_static_jacobian2p(dt,c3,c4,((-1.0)*power_dis_Vc3_c4))
  _load_static_jacobian2p(dt,c3,c1,((-1.0)*power_dis_Vc3_c1))
  _load_static_jacobian2p(dt,c4,c1,((-1.0)*power_dis_Vc4_c1))
  _load_static_jacobian2p(dt,b1,b2,((-1.0)*power_dis_Vb1_b2))
  _load_static_jacobian2p(dt,b,b1,((-1.0)*power_dis_Vb_b1))
  _load_static_jacobian2p(dt,b,c,((-1.0)*power_dis_Vb_c))
  _load_static_jacobian2p(dt,c1,c2,((-1.0)*power_dis_Vc1_c2))
  _load_static_jacobian2p(dt,b2,c1,((-1.0)*power_dis_Vb2_c1))
  _load_static_jacobian2p(dt,b2,c2,((-1.0)*power_dis_Vb2_c2))
  _load_static_jacobian2p(dt,b2,e1,((-1.0)*power_dis_Vb2_e1))
  _load_static_jacobian1(dt,dt,((-1.0)*power_dis_Vdt_GND))
  _load_dynamic_residual2(b2,e1,_DDT((pModel->TYPE*((Qte+pInst->Qbe)+Qe))))
  _load_dynamic_jacobian4(b2,e1,c3,c4,(pModel->TYPE*Qbe_Vc3_c4))
  _load_dynamic_jacobian4(b2,e1,c3,c1,(pModel->TYPE*Qbe_Vc3_c1))
  _load_dynamic_jacobian4(b2,e1,c4,c1,(pModel->TYPE*(Qbe_Vc4_c1+Qe_Vc4_c1)))
  _load_dynamic_jacobian4(b2,e1,b1,b2,(pModel->TYPE*(Qbe_Vb1_b2+Qe_Vb1_b2)))
  _load_dynamic_jacobian4(b2,e1,b,b1,(pModel->TYPE*Qbe_Vb_b1))
  _load_dynamic_jacobian4(b2,e1,b,c,(pModel->TYPE*Qbe_Vb_c))
  _load_dynamic_jacobian4(b2,e1,c1,c2,(pModel->TYPE*((Qte_Vc1_c2+Qbe_Vc1_c2)+Qe_Vc1_c2)))
  _load_dynamic_jacobian4(b2,e1,b2,c1,(pModel->TYPE*(Qte_Vb2_c1+Qbe_Vb2_c1)))
  _load_dynamic_jacobian4(b2,e1,b2,c2,(pModel->TYPE*((Qte_Vb2_c2+Qbe_Vb2_c2)+Qe_Vb2_c2)))
  _load_dynamic_jacobian4(b2,e1,b2,e1,(pModel->TYPE*((Qte_Vb2_e1+Qbe_Vb2_e1)+Qe_Vb2_e1)))
  _load_dynamic_jacobian2s(b2,e1,dt,(pModel->TYPE*((Qte_Vdt_GND+Qbe_Vdt_GND)+Qe_Vdt_GND)))
  _load_dynamic_residual2(b1,e1,_DDT((pModel->TYPE*Qte_s)))
  _load_dynamic_jacobian4(b1,e1,c1,c2,(pModel->TYPE*Qte_s_Vc1_c2))
  _load_dynamic_jacobian4(b1,e1,b2,c1,(pModel->TYPE*Qte_s_Vb2_c1))
  _load_dynamic_jacobian4(b1,e1,b2,c2,(pModel->TYPE*Qte_s_Vb2_c2))
  _load_dynamic_jacobian4(b1,e1,b2,e1,(pModel->TYPE*Qte_s_Vb2_e1))
  _load_dynamic_jacobian4(b1,e1,b1,e1,(pModel->TYPE*Qte_s_Vb1_e1))
  _load_dynamic_jacobian2s(b1,e1,dt,(pModel->TYPE*Qte_s_Vdt_GND))
  _load_dynamic_residual2(b2,c2,_DDT((pModel->TYPE*((Qtc+pInst->Qbc)+Qepi))))
  _load_dynamic_jacobian4(b2,c2,c3,c4,(pModel->TYPE*Qbc_Vc3_c4))
  _load_dynamic_jacobian4(b2,c2,c3,c1,(pModel->TYPE*Qbc_Vc3_c1))
  _load_dynamic_jacobian4(b2,c2,c4,c1,(pModel->TYPE*Qbc_Vc4_c1))
  _load_dynamic_jacobian4(b2,c2,b1,b2,(pModel->TYPE*Qbc_Vb1_b2))
  _load_dynamic_jacobian4(b2,c2,b,b1,(pModel->TYPE*Qbc_Vb_b1))
  _load_dynamic_jacobian4(b2,c2,b,c,(pModel->TYPE*Qbc_Vb_c))
  _load_dynamic_jacobian4(b2,c2,b2,e1,(pModel->TYPE*(Qtc_Vb2_e1+Qbc_Vb2_e1)))
  _load_dynamic_jacobian4(b2,c2,c1,c2,(pModel->TYPE*((Qtc_Vc1_c2+Qbc_Vc1_c2)+Qepi_Vc1_c2)))
  _load_dynamic_jacobian4(b2,c2,b2,c1,(pModel->TYPE*((Qtc_Vb2_c1+Qbc_Vb2_c1)+Qepi_Vb2_c1)))
  _load_dynamic_jacobian4(b2,c2,b2,c2,(pModel->TYPE*((Qtc_Vb2_c2+Qbc_Vb2_c2)+Qepi_Vb2_c2)))
  _load_dynamic_jacobian2s(b2,c2,dt,(pModel->TYPE*((Qtc_Vdt_GND+Qbc_Vdt_GND)+Qepi_Vdt_GND)))
  _load_dynamic_residual2(s,c1,_DDT((pModel->TYPE*Qts)))
  _load_dynamic_jacobian4(s,c1,c1,c2,(pModel->TYPE*Qts_Vc1_c2))
  _load_dynamic_jacobian4(s,c1,b2,c1,(pModel->TYPE*Qts_Vb2_c1))
  _load_dynamic_jacobian4(s,c1,b2,c2,(pModel->TYPE*Qts_Vb2_c2))
  _load_dynamic_jacobian4(s,c1,b2,e1,(pModel->TYPE*Qts_Vb2_e1))
  _load_dynamic_jacobian4(s,c1,b1,e1,(pModel->TYPE*Qts_Vb1_e1))
  _load_dynamic_jacobian4(s,c1,c4,c1,(pModel->TYPE*Qts_Vc4_c1))
  _load_dynamic_jacobian4(s,c1,b1,b2,(pModel->TYPE*Qts_Vb1_b2))
  _load_dynamic_jacobian4(s,c1,c3,c4,(pModel->TYPE*Qts_Vc3_c4))
  _load_dynamic_jacobian4(s,c1,c3,c1,(pModel->TYPE*Qts_Vc3_c1))
  _load_dynamic_jacobian4(s,c1,b,b1,(pModel->TYPE*Qts_Vb_b1))
  _load_dynamic_jacobian4(s,c1,b,c,(pModel->TYPE*Qts_Vb_c))
  _load_dynamic_jacobian4(s,c1,s,c1,(pModel->TYPE*Qts_Vs_c1))
  _load_dynamic_jacobian2s(s,c1,dt,(pModel->TYPE*Qts_Vdt_GND))
  _load_dynamic_residual2(b1,b2,_DDT((pModel->TYPE*Qb1b2)))
  _load_dynamic_jacobian4(b1,b2,c3,c4,(pModel->TYPE*Qb1b2_Vc3_c4))
  _load_dynamic_jacobian4(b1,b2,c3,c1,(pModel->TYPE*Qb1b2_Vc3_c1))
  _load_dynamic_jacobian4(b1,b2,c4,c1,(pModel->TYPE*Qb1b2_Vc4_c1))
  _load_dynamic_jacobian4(b1,b2,b,b1,(pModel->TYPE*Qb1b2_Vb_b1))
  _load_dynamic_jacobian4(b1,b2,b,c,(pModel->TYPE*Qb1b2_Vb_c))
  _load_dynamic_jacobian4(b1,b2,c1,c2,(pModel->TYPE*Qb1b2_Vc1_c2))
  _load_dynamic_jacobian4(b1,b2,b2,c1,(pModel->TYPE*Qb1b2_Vb2_c1))
  _load_dynamic_jacobian4(b1,b2,b2,c2,(pModel->TYPE*Qb1b2_Vb2_c2))
  _load_dynamic_jacobian4(b1,b2,b2,e1,(pModel->TYPE*Qb1b2_Vb2_e1))
  _load_dynamic_jacobian2s(b1,b2,dt,(pModel->TYPE*Qb1b2_Vdt_GND))
  _load_dynamic_jacobian4(b1,b2,b1,b2,(pModel->TYPE*Qb1b2_Vb1_b2))
  _load_dynamic_residual2(b,e,_DDT(((pModel->TYPE*CBEO_M)*Vbe)))
  _load_dynamic_jacobian4(b,e,b,e,((pModel->TYPE*CBEO_M)*Vbe_Vb_e))
  _load_dynamic_residual2(b,c,_DDT(((pModel->TYPE*CBCO_M)*Vbc)))
  _load_dynamic_jacobian4(b,c,b,c,((pModel->TYPE*CBCO_M)*Vbc_Vb_c))
}
if
((pModel->RCBLX>0.0))
{
  _load_static_residual2(b,c3,(pModel->TYPE*pInst->XIex))
  _load_static_jacobian4(b,c3,s,c1,(pModel->TYPE*XIex_Vs_c1))
  _load_static_jacobian4(b,c3,c1,c2,(pModel->TYPE*XIex_Vc1_c2))
  _load_static_jacobian4(b,c3,b2,c1,(pModel->TYPE*XIex_Vb2_c1))
  _load_static_jacobian4(b,c3,b2,c2,(pModel->TYPE*XIex_Vb2_c2))
  _load_static_jacobian4(b,c3,b2,e1,(pModel->TYPE*XIex_Vb2_e1))
  _load_static_jacobian4(b,c3,c3,c4,(pModel->TYPE*XIex_Vc3_c4))
  _load_static_jacobian4(b,c3,c3,c1,(pModel->TYPE*XIex_Vc3_c1))
  _load_static_jacobian4(b,c3,c4,c1,(pModel->TYPE*XIex_Vc4_c1))
  _load_static_jacobian4(b,c3,b1,b2,(pModel->TYPE*XIex_Vb1_b2))
  _load_static_jacobian4(b,c3,b,b1,(pModel->TYPE*XIex_Vb_b1))
  _load_static_jacobian4(b,c3,b,c,(pModel->TYPE*XIex_Vb_c))
  _load_static_jacobian2s(b,c3,dt,(pModel->TYPE*XIex_Vdt_GND))
  _load_static_residual2(c,c3,((pModel->TYPE*Vcc3)*pInst->GCCxx_TM))
  _load_static_jacobian2s(c,c3,dt,((pModel->TYPE*Vcc3)*GCCxx_TM_Vdt_GND))
  _load_static_jacobian4(c,c3,c3,c4,(pModel->TYPE*Vcc3_Vc3_c4)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,c3,c1,(pModel->TYPE*Vcc3_Vc3_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,c4,c1,(pModel->TYPE*Vcc3_Vc4_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,c1,c2,(pModel->TYPE*Vcc3_Vc1_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,b2,c2,(pModel->TYPE*Vcc3_Vb2_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,b1,b2,(pModel->TYPE*Vcc3_Vb1_b2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,b,b1,(pModel->TYPE*Vcc3_Vb_b1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c3,b,c,(pModel->TYPE*Vcc3_Vb_c)*pInst->GCCxx_TM)
  _load_dynamic_residual2(b,c3,_DDT((pModel->TYPE*(XQtex+XQex))))
  _load_dynamic_jacobian4(b,c3,s,c1,(pModel->TYPE*XQex_Vs_c1))
  _load_dynamic_jacobian4(b,c3,b2,c1,(pModel->TYPE*(XQtex_Vb2_c1+XQex_Vb2_c1)))
  _load_dynamic_jacobian4(b,c3,b2,e1,(pModel->TYPE*(XQtex_Vb2_e1+XQex_Vb2_e1)))
  _load_dynamic_jacobian4(b,c3,b1,e1,(pModel->TYPE*XQtex_Vb1_e1))
  _load_dynamic_jacobian4(b,c3,c3,c4,(pModel->TYPE*(XQtex_Vc3_c4+XQex_Vc3_c4)))
  _load_dynamic_jacobian4(b,c3,c3,c1,(pModel->TYPE*(XQtex_Vc3_c1+XQex_Vc3_c1)))
  _load_dynamic_jacobian4(b,c3,c4,c1,(pModel->TYPE*(XQtex_Vc4_c1+XQex_Vc4_c1)))
  _load_dynamic_jacobian4(b,c3,c1,c2,(pModel->TYPE*(XQtex_Vc1_c2+XQex_Vc1_c2)))
  _load_dynamic_jacobian4(b,c3,b2,c2,(pModel->TYPE*(XQtex_Vb2_c2+XQex_Vb2_c2)))
  _load_dynamic_jacobian4(b,c3,b1,b2,(pModel->TYPE*(XQtex_Vb1_b2+XQex_Vb1_b2)))
  _load_dynamic_jacobian4(b,c3,b,b1,(pModel->TYPE*(XQtex_Vb_b1+XQex_Vb_b1)))
  _load_dynamic_jacobian4(b,c3,b,c,(pModel->TYPE*(XQtex_Vb_c+XQex_Vb_c)))
  _load_dynamic_jacobian2s(b,c3,dt,(pModel->TYPE*(XQtex_Vdt_GND+XQex_Vdt_GND)))
if
((pModel->RCBLI>0.0))
{
  _load_static_residual2(c4,c1,((pModel->TYPE*Vc4c1)*pInst->GCCin_TM))
  _load_static_jacobian2s(c4,c1,dt,((pModel->TYPE*Vc4c1)*GCCin_TM_Vdt_GND))
  _load_static_jacobian4(c4,c1,c4,c1,(pModel->TYPE*Vc4c1_Vc4_c1)*pInst->GCCin_TM)
  _load_static_residual2(b1,c4,(pModel->TYPE*(pInst->Ib3+pInst->Iex)))
  _load_static_jacobian4(b1,c4,b2,e1,(pModel->TYPE*Ib3_Vb2_e1))
  _load_static_jacobian4(b1,c4,c4,c1,(pModel->TYPE*(Ib3_Vc4_c1+Iex_Vc4_c1)))
  _load_static_jacobian4(b1,c4,c1,c2,(pModel->TYPE*(Ib3_Vc1_c2+Iex_Vc1_c2)))
  _load_static_jacobian4(b1,c4,b2,c2,(pModel->TYPE*(Ib3_Vb2_c2+Iex_Vb2_c2)))
  _load_static_jacobian4(b1,c4,b1,b2,(pModel->TYPE*(Ib3_Vb1_b2+Iex_Vb1_b2)))
  _load_static_jacobian2s(b1,c4,dt,(pModel->TYPE*(Ib3_Vdt_GND+Iex_Vdt_GND)))
  _load_static_residual2(c3,c4,((pModel->TYPE*Vc3c4)*pInst->GCCex_TM))
  _load_static_jacobian2s(c3,c4,dt,((pModel->TYPE*Vc3c4)*GCCex_TM_Vdt_GND))
  _load_static_jacobian4(c3,c4,c3,c4,(pModel->TYPE*Vc3c4_Vc3_c4)*pInst->GCCex_TM)
  _load_static_jacobian4(c3,c4,c3,c1,(pModel->TYPE*Vc3c4_Vc3_c1)*pInst->GCCex_TM)
  _load_dynamic_residual2(b1,c4,_DDT((pModel->TYPE*(Qtex+Qex))))
  _load_dynamic_jacobian4(b1,c4,b2,c1,(pModel->TYPE*Qtex_Vb2_c1))
  _load_dynamic_jacobian4(b1,c4,b2,e1,(pModel->TYPE*Qtex_Vb2_e1))
  _load_dynamic_jacobian4(b1,c4,b1,e1,(pModel->TYPE*Qtex_Vb1_e1))
  _load_dynamic_jacobian4(b1,c4,c4,c1,(pModel->TYPE*(Qtex_Vc4_c1+Qex_Vc4_c1)))
  _load_dynamic_jacobian4(b1,c4,c1,c2,(pModel->TYPE*(Qtex_Vc1_c2+Qex_Vc1_c2)))
  _load_dynamic_jacobian4(b1,c4,b2,c2,(pModel->TYPE*(Qtex_Vb2_c2+Qex_Vb2_c2)))
  _load_dynamic_jacobian4(b1,c4,b1,b2,(pModel->TYPE*(Qtex_Vb1_b2+Qex_Vb1_b2)))
  _load_dynamic_jacobian2s(b1,c4,dt,(pModel->TYPE*(Qtex_Vdt_GND+Qex_Vdt_GND)))
}
else
{
  _load_static_residual2(c4,c1,0.0)
  _load_static_residual2(b1,c1,(pModel->TYPE*(pInst->Ib3+pInst->Iex)))
  _load_static_jacobian4(b1,c1,b2,e1,(pModel->TYPE*Ib3_Vb2_e1))
  _load_static_jacobian4(b1,c1,c4,c1,(pModel->TYPE*(Ib3_Vc4_c1+Iex_Vc4_c1)))
  _load_static_jacobian4(b1,c1,c1,c2,(pModel->TYPE*(Ib3_Vc1_c2+Iex_Vc1_c2)))
  _load_static_jacobian4(b1,c1,b2,c2,(pModel->TYPE*(Ib3_Vb2_c2+Iex_Vb2_c2)))
  _load_static_jacobian4(b1,c1,b1,b2,(pModel->TYPE*(Ib3_Vb1_b2+Iex_Vb1_b2)))
  _load_static_jacobian2s(b1,c1,dt,(pModel->TYPE*(Ib3_Vdt_GND+Iex_Vdt_GND)))
  _load_dynamic_residual2(b1,c1,_DDT((pModel->TYPE*(Qtex+Qex))))
  _load_dynamic_jacobian4(b1,c1,b2,c1,(pModel->TYPE*Qtex_Vb2_c1))
  _load_dynamic_jacobian4(b1,c1,b2,e1,(pModel->TYPE*Qtex_Vb2_e1))
  _load_dynamic_jacobian4(b1,c1,b1,e1,(pModel->TYPE*Qtex_Vb1_e1))
  _load_dynamic_jacobian4(b1,c1,c4,c1,(pModel->TYPE*(Qtex_Vc4_c1+Qex_Vc4_c1)))
  _load_dynamic_jacobian4(b1,c1,c1,c2,(pModel->TYPE*(Qtex_Vc1_c2+Qex_Vc1_c2)))
  _load_dynamic_jacobian4(b1,c1,b2,c2,(pModel->TYPE*(Qtex_Vb2_c2+Qex_Vb2_c2)))
  _load_dynamic_jacobian4(b1,c1,b1,b2,(pModel->TYPE*(Qtex_Vb1_b2+Qex_Vb1_b2)))
  _load_dynamic_jacobian2s(b1,c1,dt,(pModel->TYPE*(Qtex_Vdt_GND+Qex_Vdt_GND)))
  _load_static_residual2(c3,c1,((pModel->TYPE*Vc3c4)*pInst->GCCex_TM))
  _load_static_jacobian2s(c3,c1,dt,((pModel->TYPE*Vc3c4)*GCCex_TM_Vdt_GND))
  _load_static_jacobian4(c3,c1,c3,c4,(pModel->TYPE*Vc3c4_Vc3_c4)*pInst->GCCex_TM)
  _load_static_jacobian4(c3,c1,c3,c1,(pModel->TYPE*Vc3c4_Vc3_c1)*pInst->GCCex_TM)
}
}
else
{
  _load_static_residual2(c3,c4,0)
if
((pModel->RCBLI>0.0))
{
  _load_static_residual2(b,c4,(pModel->TYPE*pInst->XIex))
  _load_static_jacobian4(b,c4,s,c1,(pModel->TYPE*XIex_Vs_c1))
  _load_static_jacobian4(b,c4,c1,c2,(pModel->TYPE*XIex_Vc1_c2))
  _load_static_jacobian4(b,c4,b2,c1,(pModel->TYPE*XIex_Vb2_c1))
  _load_static_jacobian4(b,c4,b2,c2,(pModel->TYPE*XIex_Vb2_c2))
  _load_static_jacobian4(b,c4,b2,e1,(pModel->TYPE*XIex_Vb2_e1))
  _load_static_jacobian4(b,c4,c3,c4,(pModel->TYPE*XIex_Vc3_c4))
  _load_static_jacobian4(b,c4,c3,c1,(pModel->TYPE*XIex_Vc3_c1))
  _load_static_jacobian4(b,c4,c4,c1,(pModel->TYPE*XIex_Vc4_c1))
  _load_static_jacobian4(b,c4,b1,b2,(pModel->TYPE*XIex_Vb1_b2))
  _load_static_jacobian4(b,c4,b,b1,(pModel->TYPE*XIex_Vb_b1))
  _load_static_jacobian4(b,c4,b,c,(pModel->TYPE*XIex_Vb_c))
  _load_static_jacobian2s(b,c4,dt,(pModel->TYPE*XIex_Vdt_GND))
  _load_static_residual2(c,c4,((pModel->TYPE*Vcc3)*pInst->GCCxx_TM))
  _load_static_jacobian2s(c,c4,dt,((pModel->TYPE*Vcc3)*GCCxx_TM_Vdt_GND))
  _load_static_jacobian4(c,c4,c3,c4,(pModel->TYPE*Vcc3_Vc3_c4)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,c3,c1,(pModel->TYPE*Vcc3_Vc3_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,c4,c1,(pModel->TYPE*Vcc3_Vc4_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,c1,c2,(pModel->TYPE*Vcc3_Vc1_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,b2,c2,(pModel->TYPE*Vcc3_Vb2_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,b1,b2,(pModel->TYPE*Vcc3_Vb1_b2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,b,b1,(pModel->TYPE*Vcc3_Vb_b1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c4,b,c,(pModel->TYPE*Vcc3_Vb_c)*pInst->GCCxx_TM)
  _load_static_residual2(c4,c1,((pModel->TYPE*Vc4c1)*pInst->GCCin_TM))
  _load_static_jacobian2s(c4,c1,dt,((pModel->TYPE*Vc4c1)*GCCin_TM_Vdt_GND))
  _load_static_jacobian4(c4,c1,c4,c1,(pModel->TYPE*Vc4c1_Vc4_c1)*pInst->GCCin_TM)
  _load_static_residual2(b1,c4,(pModel->TYPE*(pInst->Ib3+pInst->Iex)))
  _load_static_jacobian4(b1,c4,b2,e1,(pModel->TYPE*Ib3_Vb2_e1))
  _load_static_jacobian4(b1,c4,c4,c1,(pModel->TYPE*(Ib3_Vc4_c1+Iex_Vc4_c1)))
  _load_static_jacobian4(b1,c4,c1,c2,(pModel->TYPE*(Ib3_Vc1_c2+Iex_Vc1_c2)))
  _load_static_jacobian4(b1,c4,b2,c2,(pModel->TYPE*(Ib3_Vb2_c2+Iex_Vb2_c2)))
  _load_static_jacobian4(b1,c4,b1,b2,(pModel->TYPE*(Ib3_Vb1_b2+Iex_Vb1_b2)))
  _load_static_jacobian2s(b1,c4,dt,(pModel->TYPE*(Ib3_Vdt_GND+Iex_Vdt_GND)))
  _load_dynamic_residual2(b1,c4,_DDT((pModel->TYPE*(Qtex+Qex))))
  _load_dynamic_jacobian4(b1,c4,b2,c1,(pModel->TYPE*Qtex_Vb2_c1))
  _load_dynamic_jacobian4(b1,c4,b2,e1,(pModel->TYPE*Qtex_Vb2_e1))
  _load_dynamic_jacobian4(b1,c4,b1,e1,(pModel->TYPE*Qtex_Vb1_e1))
  _load_dynamic_jacobian4(b1,c4,c4,c1,(pModel->TYPE*(Qtex_Vc4_c1+Qex_Vc4_c1)))
  _load_dynamic_jacobian4(b1,c4,c1,c2,(pModel->TYPE*(Qtex_Vc1_c2+Qex_Vc1_c2)))
  _load_dynamic_jacobian4(b1,c4,b2,c2,(pModel->TYPE*(Qtex_Vb2_c2+Qex_Vb2_c2)))
  _load_dynamic_jacobian4(b1,c4,b1,b2,(pModel->TYPE*(Qtex_Vb1_b2+Qex_Vb1_b2)))
  _load_dynamic_jacobian2s(b1,c4,dt,(pModel->TYPE*(Qtex_Vdt_GND+Qex_Vdt_GND)))
  _load_dynamic_residual2(b,c4,_DDT((pModel->TYPE*(XQtex+XQex))))
  _load_dynamic_jacobian4(b,c4,s,c1,(pModel->TYPE*XQex_Vs_c1))
  _load_dynamic_jacobian4(b,c4,b2,c1,(pModel->TYPE*(XQtex_Vb2_c1+XQex_Vb2_c1)))
  _load_dynamic_jacobian4(b,c4,b2,e1,(pModel->TYPE*(XQtex_Vb2_e1+XQex_Vb2_e1)))
  _load_dynamic_jacobian4(b,c4,b1,e1,(pModel->TYPE*XQtex_Vb1_e1))
  _load_dynamic_jacobian4(b,c4,c3,c4,(pModel->TYPE*(XQtex_Vc3_c4+XQex_Vc3_c4)))
  _load_dynamic_jacobian4(b,c4,c3,c1,(pModel->TYPE*(XQtex_Vc3_c1+XQex_Vc3_c1)))
  _load_dynamic_jacobian4(b,c4,c4,c1,(pModel->TYPE*(XQtex_Vc4_c1+XQex_Vc4_c1)))
  _load_dynamic_jacobian4(b,c4,c1,c2,(pModel->TYPE*(XQtex_Vc1_c2+XQex_Vc1_c2)))
  _load_dynamic_jacobian4(b,c4,b2,c2,(pModel->TYPE*(XQtex_Vb2_c2+XQex_Vb2_c2)))
  _load_dynamic_jacobian4(b,c4,b1,b2,(pModel->TYPE*(XQtex_Vb1_b2+XQex_Vb1_b2)))
  _load_dynamic_jacobian4(b,c4,b,b1,(pModel->TYPE*(XQtex_Vb_b1+XQex_Vb_b1)))
  _load_dynamic_jacobian4(b,c4,b,c,(pModel->TYPE*(XQtex_Vb_c+XQex_Vb_c)))
  _load_dynamic_jacobian2s(b,c4,dt,(pModel->TYPE*(XQtex_Vdt_GND+XQex_Vdt_GND)))
}
else
{
  _load_static_residual2(b,c1,(pModel->TYPE*pInst->XIex))
  _load_static_jacobian4(b,c1,s,c1,(pModel->TYPE*XIex_Vs_c1))
  _load_static_jacobian4(b,c1,c1,c2,(pModel->TYPE*XIex_Vc1_c2))
  _load_static_jacobian4(b,c1,b2,c1,(pModel->TYPE*XIex_Vb2_c1))
  _load_static_jacobian4(b,c1,b2,c2,(pModel->TYPE*XIex_Vb2_c2))
  _load_static_jacobian4(b,c1,b2,e1,(pModel->TYPE*XIex_Vb2_e1))
  _load_static_jacobian4(b,c1,c3,c4,(pModel->TYPE*XIex_Vc3_c4))
  _load_static_jacobian4(b,c1,c3,c1,(pModel->TYPE*XIex_Vc3_c1))
  _load_static_jacobian4(b,c1,c4,c1,(pModel->TYPE*XIex_Vc4_c1))
  _load_static_jacobian4(b,c1,b1,b2,(pModel->TYPE*XIex_Vb1_b2))
  _load_static_jacobian4(b,c1,b,b1,(pModel->TYPE*XIex_Vb_b1))
  _load_static_jacobian4(b,c1,b,c,(pModel->TYPE*XIex_Vb_c))
  _load_static_jacobian2s(b,c1,dt,(pModel->TYPE*XIex_Vdt_GND))
  _load_static_residual2(c,c1,((pModel->TYPE*Vcc3)*pInst->GCCxx_TM))
  _load_static_jacobian2s(c,c1,dt,((pModel->TYPE*Vcc3)*GCCxx_TM_Vdt_GND))
  _load_static_jacobian4(c,c1,c3,c4,(pModel->TYPE*Vcc3_Vc3_c4)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,c3,c1,(pModel->TYPE*Vcc3_Vc3_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,c4,c1,(pModel->TYPE*Vcc3_Vc4_c1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,c1,c2,(pModel->TYPE*Vcc3_Vc1_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,b2,c2,(pModel->TYPE*Vcc3_Vb2_c2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,b1,b2,(pModel->TYPE*Vcc3_Vb1_b2)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,b,b1,(pModel->TYPE*Vcc3_Vb_b1)*pInst->GCCxx_TM)
  _load_static_jacobian4(c,c1,b,c,(pModel->TYPE*Vcc3_Vb_c)*pInst->GCCxx_TM)
  _load_static_residual2(c4,c1,0.0)
  _load_static_residual2(b1,c1,(pModel->TYPE*(pInst->Ib3+pInst->Iex)))
  _load_static_jacobian4(b1,c1,b2,e1,(pModel->TYPE*Ib3_Vb2_e1))
  _load_static_jacobian4(b1,c1,c4,c1,(pModel->TYPE*(Ib3_Vc4_c1+Iex_Vc4_c1)))
  _load_static_jacobian4(b1,c1,c1,c2,(pModel->TYPE*(Ib3_Vc1_c2+Iex_Vc1_c2)))
  _load_static_jacobian4(b1,c1,b2,c2,(pModel->TYPE*(Ib3_Vb2_c2+Iex_Vb2_c2)))
  _load_static_jacobian4(b1,c1,b1,b2,(pModel->TYPE*(Ib3_Vb1_b2+Iex_Vb1_b2)))
  _load_static_jacobian2s(b1,c1,dt,(pModel->TYPE*(Ib3_Vdt_GND+Iex_Vdt_GND)))
  _load_dynamic_residual2(b1,c1,_DDT((pModel->TYPE*(Qtex+Qex))))
  _load_dynamic_jacobian4(b1,c1,b2,c1,(pModel->TYPE*Qtex_Vb2_c1))
  _load_dynamic_jacobian4(b1,c1,b2,e1,(pModel->TYPE*Qtex_Vb2_e1))
  _load_dynamic_jacobian4(b1,c1,b1,e1,(pModel->TYPE*Qtex_Vb1_e1))
  _load_dynamic_jacobian4(b1,c1,c4,c1,(pModel->TYPE*(Qtex_Vc4_c1+Qex_Vc4_c1)))
  _load_dynamic_jacobian4(b1,c1,c1,c2,(pModel->TYPE*(Qtex_Vc1_c2+Qex_Vc1_c2)))
  _load_dynamic_jacobian4(b1,c1,b2,c2,(pModel->TYPE*(Qtex_Vb2_c2+Qex_Vb2_c2)))
  _load_dynamic_jacobian4(b1,c1,b1,b2,(pModel->TYPE*(Qtex_Vb1_b2+Qex_Vb1_b2)))
  _load_dynamic_jacobian2s(b1,c1,dt,(pModel->TYPE*(Qtex_Vdt_GND+Qex_Vdt_GND)))
  _load_dynamic_residual2(b,c1,_DDT((pModel->TYPE*(XQtex+XQex))))
  _load_dynamic_jacobian4(b,c1,s,c1,(pModel->TYPE*XQex_Vs_c1))
  _load_dynamic_jacobian4(b,c1,b2,c1,(pModel->TYPE*(XQtex_Vb2_c1+XQex_Vb2_c1)))
  _load_dynamic_jacobian4(b,c1,b2,e1,(pModel->TYPE*(XQtex_Vb2_e1+XQex_Vb2_e1)))
  _load_dynamic_jacobian4(b,c1,b1,e1,(pModel->TYPE*XQtex_Vb1_e1))
  _load_dynamic_jacobian4(b,c1,c3,c4,(pModel->TYPE*(XQtex_Vc3_c4+XQex_Vc3_c4)))
  _load_dynamic_jacobian4(b,c1,c3,c1,(pModel->TYPE*(XQtex_Vc3_c1+XQex_Vc3_c1)))
  _load_dynamic_jacobian4(b,c1,c4,c1,(pModel->TYPE*(XQtex_Vc4_c1+XQex_Vc4_c1)))
  _load_dynamic_jacobian4(b,c1,c1,c2,(pModel->TYPE*(XQtex_Vc1_c2+XQex_Vc1_c2)))
  _load_dynamic_jacobian4(b,c1,b2,c2,(pModel->TYPE*(XQtex_Vb2_c2+XQex_Vb2_c2)))
  _load_dynamic_jacobian4(b,c1,b1,b2,(pModel->TYPE*(XQtex_Vb1_b2+XQex_Vb1_b2)))
  _load_dynamic_jacobian4(b,c1,b,b1,(pModel->TYPE*(XQtex_Vb_b1+XQex_Vb_b1)))
  _load_dynamic_jacobian4(b,c1,b,c,(pModel->TYPE*(XQtex_Vb_c+XQex_Vb_c)))
  _load_dynamic_jacobian2s(b,c1,dt,(pModel->TYPE*(XQtex_Vdt_GND+XQex_Vdt_GND)))
  _load_static_residual2(c3,c1,((pModel->TYPE*Vc3c4)*pInst->GCCex_TM))
  _load_static_jacobian2s(c3,c1,dt,((pModel->TYPE*Vc3c4)*GCCex_TM_Vdt_GND))
  _load_static_jacobian4(c3,c1,c3,c4,(pModel->TYPE*Vc3c4_Vc3_c4)*pInst->GCCex_TM)
  _load_static_jacobian4(c3,c1,c3,c1,(pModel->TYPE*Vc3c4_Vc3_c1)*pInst->GCCex_TM)
}
}
{
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
common_Vdt_GND=((4.0*1.3806226e-23)*Tk_Vdt_GND);
#endif
common=((4.0*1.3806226e-23)*pInst->Tk);
EXIT_IF_ISNAN(((4.0*1.3806226e-23)*pInst->Tk))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
powerREC_Vdt_GND=((common_Vdt_GND*pInst->RE_TM-common*RE_TM_Vdt_GND)/pInst->RE_TM/pInst->RE_TM);
#endif
powerREC=(common/pInst->RE_TM);
EXIT_IF_ISNAN((common/pInst->RE_TM))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
powerRBC_Vdt_GND=((common_Vdt_GND*pInst->RBC_TM-common*RBC_TM_Vdt_GND)/pInst->RBC_TM/pInst->RBC_TM);
#endif
powerRBC=(common/pInst->RBC_TM);
EXIT_IF_ISNAN((common/pInst->RBC_TM))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
powerRCCxx_Vdt_GND=((common_Vdt_GND*pInst->GCCxx_TM)+(common*GCCxx_TM_Vdt_GND));
#endif
powerRCCxx=(common*pInst->GCCxx_TM);
EXIT_IF_ISNAN((common*pInst->GCCxx_TM))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
powerRCCex_Vdt_GND=((common_Vdt_GND*pInst->GCCex_TM)+(common*GCCex_TM_Vdt_GND));
#endif
powerRCCex=(common*pInst->GCCex_TM);
EXIT_IF_ISNAN((common*pInst->GCCex_TM))
#if defined(_DERIVATE) /* probe=V(dt,GND) ddxprobe= */
powerRCCin_Vdt_GND=((common_Vdt_GND*pInst->GCCin_TM)+(common*GCCin_TM_Vdt_GND));
#endif
powerRCCin=(common*pInst->GCCin_TM);
EXIT_IF_ISNAN((common*pInst->GCCin_TM))
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
powerRBV_Vdt_GND=((((common_Vdt_GND*pInst->Rb2-common*Rb2_Vdt_GND)/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0))+((common/pInst->Rb2)*(4.0*eVb1b2_Vdt_GND)))*0.33333333333333333333;
powerRBV_Vb_c=(-common*Rb2_Vb_c/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vb_b1=(-common*Rb2_Vb_b1/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vb1_b2=(((-common*Rb2_Vb1_b2/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0))+((common/pInst->Rb2)*(4.0*eVb1b2_Vb1_b2)))*0.33333333333333333333;
powerRBV_Vc4_c1=(-common*Rb2_Vc4_c1/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vc3_c1=(-common*Rb2_Vc3_c1/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vc3_c4=(-common*Rb2_Vc3_c4/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vb2_e1=(-common*Rb2_Vb2_e1/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vb2_c2=(-common*Rb2_Vb2_c2/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vb2_c1=(-common*Rb2_Vb2_c1/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
powerRBV_Vc1_c2=(-common*Rb2_Vc1_c2/pInst->Rb2/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0)*0.33333333333333333333;
#endif
powerRBV=(((common/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0))*0.33333333333333333333);
EXIT_IF_ISNAN((((common/pInst->Rb2)*((4.0*pInst->eVb1b2)+5.0))*0.33333333333333333333))
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
In_N_Vdt_GND=(((If_Vdt_GND+Ir_Vdt_GND)*pInst->qBI-(pInst->If+pInst->Ir)*qBI_Vdt_GND)/pInst->qBI/pInst->qBI);
In_N_Vb2_e1=((If_Vb2_e1*pInst->qBI-(pInst->If+pInst->Ir)*qBI_Vb2_e1)/pInst->qBI/pInst->qBI);
In_N_Vb2_c2=((Ir_Vb2_c2*pInst->qBI-(pInst->If+pInst->Ir)*qBI_Vb2_c2)/pInst->qBI/pInst->qBI);
In_N_Vb2_c1=((Ir_Vb2_c1*pInst->qBI-(pInst->If+pInst->Ir)*qBI_Vb2_c1)/pInst->qBI/pInst->qBI);
In_N_Vc1_c2=((Ir_Vc1_c2*pInst->qBI-(pInst->If+pInst->Ir)*qBI_Vc1_c2)/pInst->qBI/pInst->qBI);
#endif
In_N=((pInst->If+pInst->Ir)/pInst->qBI);
EXIT_IF_ISNAN(((pInst->If+pInst->Ir)/pInst->qBI))
{
double m00_fabs(d00_fabs0,In_N)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,In_N)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
powerCCS_Vdt_GND=((2.0*1.6021918e-19)*In_N_Vdt_GND*d10_fabs0);
powerCCS_Vb2_e1=((2.0*1.6021918e-19)*In_N_Vb2_e1*d10_fabs0);
powerCCS_Vb2_c2=((2.0*1.6021918e-19)*In_N_Vb2_c2*d10_fabs0);
powerCCS_Vb2_c1=((2.0*1.6021918e-19)*In_N_Vb2_c1*d10_fabs0);
powerCCS_Vc1_c2=((2.0*1.6021918e-19)*In_N_Vc1_c2*d10_fabs0);
#endif
powerCCS=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
if
((pModel->KAVL>0))
{
{
double m00_fabs(d00_fabs0,(pInst->Iavl/In_N))
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->Iavl/In_N))
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe= */
Gem_N_Vdt_GND=((Iavl_Vdt_GND*In_N-pInst->Iavl*In_N_Vdt_GND)/In_N/In_N)*d10_fabs0;
Gem_N_Vb2_c2=((Iavl_Vb2_c2*In_N-pInst->Iavl*In_N_Vb2_c2)/In_N/In_N)*d10_fabs0;
Gem_N_Vb2_c1=((Iavl_Vb2_c1*In_N-pInst->Iavl*In_N_Vb2_c1)/In_N/In_N)*d10_fabs0;
Gem_N_Vc1_c2=((Iavl_Vc1_c2*In_N-pInst->Iavl*In_N_Vc1_c2)/In_N/In_N)*d10_fabs0;
Gem_N_Vb_c=(Iavl_Vb_c/In_N)*d10_fabs0;
Gem_N_Vb_b1=(Iavl_Vb_b1/In_N)*d10_fabs0;
Gem_N_Vb1_b2=(Iavl_Vb1_b2/In_N)*d10_fabs0;
Gem_N_Vc4_c1=(Iavl_Vc4_c1/In_N)*d10_fabs0;
Gem_N_Vc3_c1=(Iavl_Vc3_c1/In_N)*d10_fabs0;
Gem_N_Vc3_c4=(Iavl_Vc3_c4/In_N)*d10_fabs0;
Gem_N_Vb2_e1=((Iavl_Vb2_e1*In_N-pInst->Iavl*In_N_Vb2_e1)/In_N/In_N)*d10_fabs0;
#endif
Gem_N=d00_fabs0;
EXIT_IF_ISNAN(d00_fabs0)
}
}
else
{
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe= */
Gem_N_Vdt_GND=0.0;
Gem_N_Vb2_c2=0.0;
Gem_N_Vb2_c1=0.0;
Gem_N_Vc1_c2=0.0;
Gem_N_Vb_c=0.0;
Gem_N_Vb_b1=0.0;
Gem_N_Vb1_b2=0.0;
Gem_N_Vc4_c1=0.0;
Gem_N_Vc3_c1=0.0;
Gem_N_Vc3_c4=0.0;
Gem_N_Vb2_e1=0.0;
#endif
Gem_N=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,c2)V(b2,c1)V(c1,c2)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1) ddxprobe= */
powerIIS_Vdt_GND=((((2.0*1.6021918e-19)*Iavl_Vdt_GND)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vdt_GND));
powerIIS_Vb2_c2=((((2.0*1.6021918e-19)*Iavl_Vb2_c2)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb2_c2));
powerIIS_Vb2_c1=((((2.0*1.6021918e-19)*Iavl_Vb2_c1)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb2_c1));
powerIIS_Vc1_c2=((((2.0*1.6021918e-19)*Iavl_Vc1_c2)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vc1_c2));
powerIIS_Vb_c=((((2.0*1.6021918e-19)*Iavl_Vb_c)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb_c));
powerIIS_Vb_b1=((((2.0*1.6021918e-19)*Iavl_Vb_b1)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb_b1));
powerIIS_Vb1_b2=((((2.0*1.6021918e-19)*Iavl_Vb1_b2)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb1_b2));
powerIIS_Vc4_c1=((((2.0*1.6021918e-19)*Iavl_Vc4_c1)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vc4_c1));
powerIIS_Vc3_c1=((((2.0*1.6021918e-19)*Iavl_Vc3_c1)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vc3_c1));
powerIIS_Vc3_c4=((((2.0*1.6021918e-19)*Iavl_Vc3_c4)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vc3_c4));
powerIIS_Vb2_e1=((((2.0*1.6021918e-19)*Iavl_Vb2_e1)*(Gem_N+1))+(((2.0*1.6021918e-19)*pInst->Iavl)*Gem_N_Vb2_e1));
#endif
powerIIS=(((2.0*1.6021918e-19)*pInst->Iavl)*(Gem_N+1));
EXIT_IF_ISNAN((((2.0*1.6021918e-19)*pInst->Iavl)*(Gem_N+1)))
#ifdef _DYNAMIC
if
((In_N>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Taub_N_Vdt_GND=(((Qbe_Vdt_GND+Qbc_Vdt_GND)*In_N-(pInst->Qbe+pInst->Qbc)*In_N_Vdt_GND)/In_N/In_N);
Taub_N_Vb2_e1=(((Qbe_Vb2_e1+Qbc_Vb2_e1)*In_N-(pInst->Qbe+pInst->Qbc)*In_N_Vb2_e1)/In_N/In_N);
Taub_N_Vb_c=((Qbe_Vb_c+Qbc_Vb_c)/In_N);
Taub_N_Vb_b1=((Qbe_Vb_b1+Qbc_Vb_b1)/In_N);
Taub_N_Vb1_b2=((Qbe_Vb1_b2+Qbc_Vb1_b2)/In_N);
Taub_N_Vc4_c1=((Qbe_Vc4_c1+Qbc_Vc4_c1)/In_N);
Taub_N_Vc3_c1=((Qbe_Vc3_c1+Qbc_Vc3_c1)/In_N);
Taub_N_Vc3_c4=((Qbe_Vc3_c4+Qbc_Vc3_c4)/In_N);
Taub_N_Vb2_c2=(((Qbe_Vb2_c2+Qbc_Vb2_c2)*In_N-(pInst->Qbe+pInst->Qbc)*In_N_Vb2_c2)/In_N/In_N);
Taub_N_Vb2_c1=(((Qbe_Vb2_c1+Qbc_Vb2_c1)*In_N-(pInst->Qbe+pInst->Qbc)*In_N_Vb2_c1)/In_N/In_N);
Taub_N_Vc1_c2=(((Qbe_Vc1_c2+Qbc_Vc1_c2)*In_N-(pInst->Qbe+pInst->Qbc)*In_N_Vc1_c2)/In_N/In_N);
#endif
Taub_N=((pInst->Qbe+pInst->Qbc)/In_N);
EXIT_IF_ISNAN(((pInst->Qbe+pInst->Qbc)/In_N))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
Taub_N_Vdt_GND=((((TAUB_T_Vdt_GND*pInst->q1Q)+(pInst->TAUB_T*q1Q_Vdt_GND))*pInst->qBI)+((pInst->TAUB_T*pInst->q1Q)*qBI_Vdt_GND));
Taub_N_Vb2_e1=(((pInst->TAUB_T*q1Q_Vb2_e1)*pInst->qBI)+((pInst->TAUB_T*pInst->q1Q)*qBI_Vb2_e1));
Taub_N_Vb_c=(pInst->TAUB_T*q1Q_Vb_c)*pInst->qBI;
Taub_N_Vb_b1=(pInst->TAUB_T*q1Q_Vb_b1)*pInst->qBI;
Taub_N_Vb1_b2=(pInst->TAUB_T*q1Q_Vb1_b2)*pInst->qBI;
Taub_N_Vc4_c1=(pInst->TAUB_T*q1Q_Vc4_c1)*pInst->qBI;
Taub_N_Vc3_c1=(pInst->TAUB_T*q1Q_Vc3_c1)*pInst->qBI;
Taub_N_Vc3_c4=(pInst->TAUB_T*q1Q_Vc3_c4)*pInst->qBI;
Taub_N_Vb2_c2=(((pInst->TAUB_T*q1Q_Vb2_c2)*pInst->qBI)+((pInst->TAUB_T*pInst->q1Q)*qBI_Vb2_c2));
Taub_N_Vb2_c1=(((pInst->TAUB_T*q1Q_Vb2_c1)*pInst->qBI)+((pInst->TAUB_T*pInst->q1Q)*qBI_Vb2_c1));
Taub_N_Vc1_c2=(((pInst->TAUB_T*q1Q_Vc1_c2)*pInst->qBI)+((pInst->TAUB_T*pInst->q1Q)*qBI_Vc1_c2));
#endif
Taub_N=((pInst->TAUB_T*pInst->q1Q)*pInst->qBI);
EXIT_IF_ISNAN(((pInst->TAUB_T*pInst->q1Q)*pInst->qBI))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->KC==1))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
taun_Vdt_GND=(pModel->XQB*Taub_N_Vdt_GND);
taun_Vb2_e1=(pModel->XQB*Taub_N_Vb2_e1);
taun_Vb_c=(pModel->XQB*Taub_N_Vb_c);
taun_Vb_b1=(pModel->XQB*Taub_N_Vb_b1);
taun_Vb1_b2=(pModel->XQB*Taub_N_Vb1_b2);
taun_Vc4_c1=(pModel->XQB*Taub_N_Vc4_c1);
taun_Vc3_c1=(pModel->XQB*Taub_N_Vc3_c1);
taun_Vc3_c4=(pModel->XQB*Taub_N_Vc3_c4);
taun_Vb2_c2=(pModel->XQB*Taub_N_Vb2_c2);
taun_Vb2_c1=(pModel->XQB*Taub_N_Vb2_c1);
taun_Vc1_c2=(pModel->XQB*Taub_N_Vc1_c2);
#endif
taun=(pModel->XQB*Taub_N);
EXIT_IF_ISNAN((pModel->XQB*Taub_N))
#endif
}
else
{
#ifdef _DYNAMIC
if
((pModel->KC==2))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
taun_Vdt_GND=(pModel->FTAUN*Taub_N_Vdt_GND);
taun_Vb2_e1=(pModel->FTAUN*Taub_N_Vb2_e1);
taun_Vb_c=(pModel->FTAUN*Taub_N_Vb_c);
taun_Vb_b1=(pModel->FTAUN*Taub_N_Vb_b1);
taun_Vb1_b2=(pModel->FTAUN*Taub_N_Vb1_b2);
taun_Vc4_c1=(pModel->FTAUN*Taub_N_Vc4_c1);
taun_Vc3_c1=(pModel->FTAUN*Taub_N_Vc3_c1);
taun_Vc3_c4=(pModel->FTAUN*Taub_N_Vc3_c4);
taun_Vb2_c2=(pModel->FTAUN*Taub_N_Vb2_c2);
taun_Vb2_c1=(pModel->FTAUN*Taub_N_Vb2_c1);
taun_Vc1_c2=(pModel->FTAUN*Taub_N_Vc1_c2);
#endif
taun=(pModel->FTAUN*Taub_N);
EXIT_IF_ISNAN((pModel->FTAUN*Taub_N))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,c2)V(b2,c1)V(c1,c2) ddxprobe= */
taun_Vdt_GND=0.0;
taun_Vb2_e1=0.0;
taun_Vb_c=0.0;
taun_Vb_b1=0.0;
taun_Vb1_b2=0.0;
taun_Vc4_c1=0.0;
taun_Vc3_c1=0.0;
taun_Vc3_c4=0.0;
taun_Vb2_c2=0.0;
taun_Vb2_c1=0.0;
taun_Vc1_c2=0.0;
#endif
taun=0;
EXIT_IF_ISNAN(0)
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
{
double m00_fabs(d00_fabs0,pInst->Ib1)
double m00_fabs(d00_fabs1,pInst->Ib2)
double m00_fabs(d00_fabs2,pInst->Izteb)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib1)
double m10_fabs(d10_fabs1,d00_fabs1,pInst->Ib2)
double m10_fabs(d10_fabs2,d00_fabs2,pInst->Izteb)
#endif
#if defined(_DERIVATE) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND)V(b2,e1) ddxprobe= */
powerFBCS_Vb2_c2=((2.0*1.6021918e-19)*(Ib1_Vb2_c2*d10_fabs0+Izteb_Vb2_c2*d10_fabs2));
powerFBCS_Vb2_c1=((2.0*1.6021918e-19)*(Ib1_Vb2_c1*d10_fabs0+Izteb_Vb2_c1*d10_fabs2));
powerFBCS_Vc1_c2=((2.0*1.6021918e-19)*(Ib1_Vc1_c2*d10_fabs0+Izteb_Vc1_c2*d10_fabs2));
powerFBCS_Vdt_GND=((2.0*1.6021918e-19)*((Ib1_Vdt_GND*d10_fabs0+Ib2_Vdt_GND*d10_fabs1)+Izteb_Vdt_GND*d10_fabs2));
powerFBCS_Vb2_e1=((2.0*1.6021918e-19)*((Ib1_Vb2_e1*d10_fabs0+Ib2_Vb2_e1*d10_fabs1)+Izteb_Vb2_e1*d10_fabs2));
#endif
powerFBCS=((2.0*1.6021918e-19)*((d00_fabs0+d00_fabs1)+d00_fabs2));
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*((d00_fabs0+d00_fabs1)+d00_fabs2)))
}
{
double m00_fabs(d00_fabs0,pInst->Ib1)
double m00_pow(d00_pow1,(d00_fabs0/(1-pModel->XIBI)),pModel->AF)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib1)
double m10_pow(d10_pow1,d00_pow1,(d00_fabs0/(1-pModel->XIBI)),pModel->AF)
#endif
#if defined(_DERIVATE) /* probe=V(b2,c2)V(b2,c1)V(c1,c2)V(dt,GND)V(b2,e1) ddxprobe= */
powerFBC1fB1_Vb2_c2=((1.0-pModel->XIBI)*(d10_pow1*(Ib1_Vb2_c2*d10_fabs0/(1-pModel->XIBI))))*pInst->KF_M;
powerFBC1fB1_Vb2_c1=((1.0-pModel->XIBI)*(d10_pow1*(Ib1_Vb2_c1*d10_fabs0/(1-pModel->XIBI))))*pInst->KF_M;
powerFBC1fB1_Vc1_c2=((1.0-pModel->XIBI)*(d10_pow1*(Ib1_Vc1_c2*d10_fabs0/(1-pModel->XIBI))))*pInst->KF_M;
powerFBC1fB1_Vdt_GND=((1.0-pModel->XIBI)*(d10_pow1*(Ib1_Vdt_GND*d10_fabs0/(1-pModel->XIBI))))*pInst->KF_M;
powerFBC1fB1_Vb2_e1=((1.0-pModel->XIBI)*(d10_pow1*(Ib1_Vb2_e1*d10_fabs0/(1-pModel->XIBI))))*pInst->KF_M;
#endif
powerFBC1fB1=(((1.0-pModel->XIBI)*d00_pow1)*pInst->KF_M);
EXIT_IF_ISNAN((((1.0-pModel->XIBI)*d00_pow1)*pInst->KF_M))
}
exponentFBC1fB2=((2.0*(pModel->MLF-1.0))+(pModel->AF*(2.0-pModel->MLF)));
EXIT_IF_ISNAN(((2.0*(pModel->MLF-1.0))+(pModel->AF*(2.0-pModel->MLF))))
{
double m00_fabs(d00_fabs0,pInst->Ib2)
double m00_pow(d00_pow1,d00_fabs0,exponentFBC1fB2)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib2)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,exponentFBC1fB2)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b2,e1) ddxprobe= */
powerFBC1fB2_Vdt_GND=(pInst->KFN_M*(d10_pow1*Ib2_Vdt_GND*d10_fabs0));
powerFBC1fB2_Vb2_e1=(pInst->KFN_M*(d10_pow1*Ib2_Vb2_e1*d10_fabs0));
#endif
powerFBC1fB2=(pInst->KFN_M*d00_pow1);
EXIT_IF_ISNAN((pInst->KFN_M*d00_pow1))
}
{
double m00_fabs(d00_fabs0,pInst->Ib1_s)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib1_s)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,e1) ddxprobe= */
powerEBSCS_Vdt_GND=((2.0*1.6021918e-19)*Ib1_s_Vdt_GND*d10_fabs0);
powerEBSCS_Vb1_e1=((2.0*1.6021918e-19)*Ib1_s_Vb1_e1*d10_fabs0);
#endif
powerEBSCS=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
if
((pModel->XIBI==0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,e1) ddxprobe= */
powerEBSC1f_Vdt_GND=0.0;
powerEBSC1f_Vb1_e1=0.0;
#endif
powerEBSC1f=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
{
double m00_fabs(d00_fabs0,(pInst->Ib1_s/pModel->XIBI))
double m00_pow(d00_pow1,d00_fabs0,pModel->AF)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->Ib1_s/pModel->XIBI))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->AF)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,e1) ddxprobe= */
powerEBSC1f_Vdt_GND=((pInst->KF_M*pModel->XIBI)*(d10_pow1*(Ib1_s_Vdt_GND/pModel->XIBI)*d10_fabs0));
powerEBSC1f_Vb1_e1=((pInst->KF_M*pModel->XIBI)*(d10_pow1*(Ib1_s_Vb1_e1/pModel->XIBI)*d10_fabs0));
#endif
powerEBSC1f=((pInst->KF_M*pModel->XIBI)*d00_pow1);
EXIT_IF_ISNAN(((pInst->KF_M*pModel->XIBI)*d00_pow1))
}
}
{
double m00_fabs(d00_fabs0,pInst->Ib3)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib3)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe= */
powerRBCS_Vdt_GND=((2.0*1.6021918e-19)*Ib3_Vdt_GND*d10_fabs0);
powerRBCS_Vb1_b2=((2.0*1.6021918e-19)*Ib3_Vb1_b2*d10_fabs0);
powerRBCS_Vb2_c2=((2.0*1.6021918e-19)*Ib3_Vb2_c2*d10_fabs0);
powerRBCS_Vc1_c2=((2.0*1.6021918e-19)*Ib3_Vc1_c2*d10_fabs0);
powerRBCS_Vc4_c1=((2.0*1.6021918e-19)*Ib3_Vc4_c1*d10_fabs0);
powerRBCS_Vb2_e1=((2.0*1.6021918e-19)*Ib3_Vb2_e1*d10_fabs0);
#endif
powerRBCS=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Ib3)
double m00_pow(d00_pow1,d00_fabs0,pModel->AF)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Ib3)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->AF)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(b2,e1) ddxprobe= */
powerRBC1f_Vdt_GND=(pInst->KF_M*(d10_pow1*Ib3_Vdt_GND*d10_fabs0));
powerRBC1f_Vb1_b2=(pInst->KF_M*(d10_pow1*Ib3_Vb1_b2*d10_fabs0));
powerRBC1f_Vb2_c2=(pInst->KF_M*(d10_pow1*Ib3_Vb2_c2*d10_fabs0));
powerRBC1f_Vc1_c2=(pInst->KF_M*(d10_pow1*Ib3_Vc1_c2*d10_fabs0));
powerRBC1f_Vc4_c1=(pInst->KF_M*(d10_pow1*Ib3_Vc4_c1*d10_fabs0));
powerRBC1f_Vb2_e1=(pInst->KF_M*(d10_pow1*Ib3_Vb2_e1*d10_fabs0));
#endif
powerRBC1f=(pInst->KF_M*d00_pow1);
EXIT_IF_ISNAN((pInst->KF_M*d00_pow1))
}
{
double m00_fabs(d00_fabs0,pInst->Iex)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Iex)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe= */
powerExCS_Vdt_GND=((2.0*1.6021918e-19)*Iex_Vdt_GND*d10_fabs0);
powerExCS_Vb1_b2=((2.0*1.6021918e-19)*Iex_Vb1_b2*d10_fabs0);
powerExCS_Vb2_c2=((2.0*1.6021918e-19)*Iex_Vb2_c2*d10_fabs0);
powerExCS_Vc1_c2=((2.0*1.6021918e-19)*Iex_Vc1_c2*d10_fabs0);
powerExCS_Vc4_c1=((2.0*1.6021918e-19)*Iex_Vc4_c1*d10_fabs0);
#endif
powerExCS=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->Iex)
double m00_pow(d00_pow1,(d00_fabs0/(1-(pModel->EXMOD*pModel->XEXT))),pModel->AF)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Iex)
double m10_pow(d10_pow1,d00_pow1,(d00_fabs0/(1-(pModel->EXMOD*pModel->XEXT))),pModel->AF)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1) ddxprobe= */
powerExC1f_Vdt_GND=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*(d10_pow1*(Iex_Vdt_GND*d10_fabs0/(1-(pModel->EXMOD*pModel->XEXT)))));
powerExC1f_Vb1_b2=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*(d10_pow1*(Iex_Vb1_b2*d10_fabs0/(1-(pModel->EXMOD*pModel->XEXT)))));
powerExC1f_Vb2_c2=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*(d10_pow1*(Iex_Vb2_c2*d10_fabs0/(1-(pModel->EXMOD*pModel->XEXT)))));
powerExC1f_Vc1_c2=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*(d10_pow1*(Iex_Vc1_c2*d10_fabs0/(1-(pModel->EXMOD*pModel->XEXT)))));
powerExC1f_Vc4_c1=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*(d10_pow1*(Iex_Vc4_c1*d10_fabs0/(1-(pModel->EXMOD*pModel->XEXT)))));
#endif
powerExC1f=((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*d00_pow1);
EXIT_IF_ISNAN(((pInst->KF_M*(1-(pModel->EXMOD*pModel->XEXT)))*d00_pow1))
}
{
double m00_fabs(d00_fabs0,pInst->XIex)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->XIex)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe= */
powerExCSMOD_Vdt_GND=((2.0*1.6021918e-19)*XIex_Vdt_GND*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb_c=((2.0*1.6021918e-19)*XIex_Vb_c*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb_b1=((2.0*1.6021918e-19)*XIex_Vb_b1*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb1_b2=((2.0*1.6021918e-19)*XIex_Vb1_b2*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vc4_c1=((2.0*1.6021918e-19)*XIex_Vc4_c1*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vc3_c1=((2.0*1.6021918e-19)*XIex_Vc3_c1*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vc3_c4=((2.0*1.6021918e-19)*XIex_Vc3_c4*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb2_e1=((2.0*1.6021918e-19)*XIex_Vb2_e1*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb2_c2=((2.0*1.6021918e-19)*XIex_Vb2_c2*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vb2_c1=((2.0*1.6021918e-19)*XIex_Vb2_c1*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vc1_c2=((2.0*1.6021918e-19)*XIex_Vc1_c2*d10_fabs0)*pModel->EXMOD;
powerExCSMOD_Vs_c1=((2.0*1.6021918e-19)*XIex_Vs_c1*d10_fabs0)*pModel->EXMOD;
#endif
powerExCSMOD=(((2.0*1.6021918e-19)*d00_fabs0)*pModel->EXMOD);
EXIT_IF_ISNAN((((2.0*1.6021918e-19)*d00_fabs0)*pModel->EXMOD))
}
if
((pModel->XEXT==0.0))
{
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe= */
powerExC1fMOD_Vdt_GND=0.0;
powerExC1fMOD_Vb_c=0.0;
powerExC1fMOD_Vb_b1=0.0;
powerExC1fMOD_Vb1_b2=0.0;
powerExC1fMOD_Vc4_c1=0.0;
powerExC1fMOD_Vc3_c1=0.0;
powerExC1fMOD_Vc3_c4=0.0;
powerExC1fMOD_Vb2_e1=0.0;
powerExC1fMOD_Vb2_c2=0.0;
powerExC1fMOD_Vb2_c1=0.0;
powerExC1fMOD_Vc1_c2=0.0;
powerExC1fMOD_Vs_c1=0.0;
#endif
powerExC1fMOD=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
{
double m00_fabs(d00_fabs0,pInst->XIex)
double m00_pow(d00_pow1,(d00_fabs0/pModel->XEXT),pModel->AF)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->XIex)
double m10_pow(d10_pow1,d00_pow1,(d00_fabs0/pModel->XEXT),pModel->AF)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe= */
powerExC1fMOD_Vdt_GND=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vdt_GND*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb_c=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb_c*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb_b1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb_b1*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb1_b2=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb1_b2*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vc4_c1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vc4_c1*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vc3_c1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vc3_c1*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vc3_c4=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vc3_c4*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb2_e1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb2_e1*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb2_c2=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb2_c2*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vb2_c1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vb2_c1*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vc1_c2=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vc1_c2*d10_fabs0/pModel->XEXT)));
powerExC1fMOD_Vs_c1=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*(d10_pow1*(XIex_Vs_c1*d10_fabs0/pModel->XEXT)));
#endif
powerExC1fMOD=(((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*d00_pow1);
EXIT_IF_ISNAN((((pInst->KF_M*pModel->EXMOD)*pModel->XEXT)*d00_pow1))
}
}
{
double m00_fabs(d00_fabs0,pInst->Isub)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->Isub)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b1,b2)V(b2,c2)V(c1,c2)V(c4,c1)V(s,c1) ddxprobe= */
powerSubsCS_B1S_Vdt_GND=((2.0*1.6021918e-19)*Isub_Vdt_GND*d10_fabs0);
powerSubsCS_B1S_Vb1_b2=((2.0*1.6021918e-19)*Isub_Vb1_b2*d10_fabs0);
powerSubsCS_B1S_Vb2_c2=((2.0*1.6021918e-19)*Isub_Vb2_c2*d10_fabs0);
powerSubsCS_B1S_Vc1_c2=((2.0*1.6021918e-19)*Isub_Vc1_c2*d10_fabs0);
powerSubsCS_B1S_Vc4_c1=((2.0*1.6021918e-19)*Isub_Vc4_c1*d10_fabs0);
powerSubsCS_B1S_Vs_c1=((2.0*1.6021918e-19)*Isub_Vs_c1*d10_fabs0);
#endif
powerSubsCS_B1S=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
{
double m00_fabs(d00_fabs0,pInst->XIsub)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,pInst->XIsub)
#endif
#if defined(_DERIVATE) /* probe=V(dt,GND)V(b,c)V(b,b1)V(b1,b2)V(c4,c1)V(c3,c1)V(c3,c4)V(b2,e1)V(b2,c2)V(b2,c1)V(c1,c2)V(s,c1) ddxprobe= */
powerSubsCS_BS_Vdt_GND=((2.0*1.6021918e-19)*XIsub_Vdt_GND*d10_fabs0);
powerSubsCS_BS_Vb_c=((2.0*1.6021918e-19)*XIsub_Vb_c*d10_fabs0);
powerSubsCS_BS_Vb_b1=((2.0*1.6021918e-19)*XIsub_Vb_b1*d10_fabs0);
powerSubsCS_BS_Vb1_b2=((2.0*1.6021918e-19)*XIsub_Vb1_b2*d10_fabs0);
powerSubsCS_BS_Vc4_c1=((2.0*1.6021918e-19)*XIsub_Vc4_c1*d10_fabs0);
powerSubsCS_BS_Vc3_c1=((2.0*1.6021918e-19)*XIsub_Vc3_c1*d10_fabs0);
powerSubsCS_BS_Vc3_c4=((2.0*1.6021918e-19)*XIsub_Vc3_c4*d10_fabs0);
powerSubsCS_BS_Vb2_e1=((2.0*1.6021918e-19)*XIsub_Vb2_e1*d10_fabs0);
powerSubsCS_BS_Vb2_c2=((2.0*1.6021918e-19)*XIsub_Vb2_c2*d10_fabs0);
powerSubsCS_BS_Vb2_c1=((2.0*1.6021918e-19)*XIsub_Vb2_c1*d10_fabs0);
powerSubsCS_BS_Vc1_c2=((2.0*1.6021918e-19)*XIsub_Vc1_c2*d10_fabs0);
powerSubsCS_BS_Vs_c1=((2.0*1.6021918e-19)*XIsub_Vs_c1*d10_fabs0);
#endif
powerSubsCS_BS=((2.0*1.6021918e-19)*d00_fabs0);
EXIT_IF_ISNAN(((2.0*1.6021918e-19)*d00_fabs0))
}
pInst->wnoise19=powerCCS;
  _load_static_residual1(noi,NP(noi))
  _load_static_jacobian1(noi,noi,1.0)
  _load_dynamic_residual2(b2,e1,(taun*_DDT(NP(noi))))
  _load_dynamic_jacobian2s(b2,e1,noi,(taun))
  _load_dynamic_jacobian4(b2,e1,c1,c2,taun_Vc1_c2*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b2,c1,taun_Vb2_c1*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b2,c2,taun_Vb2_c2*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,c3,c4,taun_Vc3_c4*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,c3,c1,taun_Vc3_c1*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,c4,c1,taun_Vc4_c1*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b1,b2,taun_Vb1_b2*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b,b1,taun_Vb_b1*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b,c,taun_Vb_c*_DDT(NP(noi)))
  _load_dynamic_jacobian4(b2,e1,b2,e1,taun_Vb2_e1*_DDT(NP(noi)))
  _load_dynamic_jacobian2s(b2,e1,dt,taun_Vdt_GND*_DDT(NP(noi)))
  _load_static_residual2(c2,b2,(Gem_N*NP(noi)))
  _load_static_jacobian2s(c2,b2,noi,(Gem_N))
  _load_static_jacobian4(c2,b2,b2,e1,Gem_N_Vb2_e1*NP(noi))
  _load_static_jacobian4(c2,b2,c3,c4,Gem_N_Vc3_c4*NP(noi))
  _load_static_jacobian4(c2,b2,c3,c1,Gem_N_Vc3_c1*NP(noi))
  _load_static_jacobian4(c2,b2,c4,c1,Gem_N_Vc4_c1*NP(noi))
  _load_static_jacobian4(c2,b2,b1,b2,Gem_N_Vb1_b2*NP(noi))
  _load_static_jacobian4(c2,b2,b,b1,Gem_N_Vb_b1*NP(noi))
  _load_static_jacobian4(c2,b2,b,c,Gem_N_Vb_c*NP(noi))
  _load_static_jacobian4(c2,b2,c1,c2,Gem_N_Vc1_c2*NP(noi))
  _load_static_jacobian4(c2,b2,b2,c1,Gem_N_Vb2_c1*NP(noi))
  _load_static_jacobian4(c2,b2,b2,c2,Gem_N_Vb2_c2*NP(noi))
  _load_static_jacobian2s(c2,b2,dt,Gem_N_Vdt_GND*NP(noi))
  _load_static_residual2(c2,e1,NP(noi))
  _load_static_jacobian2s(c2,e1,noi,1.0)
pInst->wnoise18=powerIIS;
pInst->wnoise17=powerFBCS;
pInst->wnoise16=powerREC;
pInst->wnoise15=powerRBC;
pInst->wnoise14=powerRBV;
pInst->fpnoise5=powerFBC1fB1;
pInst->fenoise5=1;
pInst->fpnoise4=powerFBC1fB2;
pInst->fenoise4=1;
pInst->wnoise13=powerEBSCS;
pInst->fpnoise3=powerEBSC1f;
pInst->fenoise3=1;
pInst->wnoise12=powerRBCS;
pInst->fpnoise2=powerRBC1f;
pInst->fenoise2=1;
pInst->wnoise11=powerExCS;
pInst->fpnoise1=powerExC1f;
pInst->fenoise1=1;
pInst->wnoise10=powerExCSMOD;
pInst->fpnoise0=powerExC1fMOD;
pInst->fenoise0=1;
pInst->wnoise9=powerSubsCS_B1S;
pInst->wnoise8=powerSubsCS_BS;
if
((pModel->RCBLX>0.0))
{
if
((pModel->RCBLI>0.0))
{
pInst->wnoise7=powerRCCxx;
pInst->wnoise6=powerRCCex;
pInst->wnoise5=powerRCCin;
}
else
{
pInst->wnoise4=powerRCCxx;
pInst->wnoise3=powerRCCex;
}
}
else
{
if
((pModel->RCBLI>0.0))
{
pInst->wnoise2=powerRCCxx;
pInst->wnoise1=powerRCCin;
}
else
{
pInst->wnoise0=powerRCCxx;
}
}
}
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ic]=(pModel->TYPE*Ic1c2);
EXIT_IF_ISNAN((pModel->TYPE*Ic1c2))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib]=(pModel->TYPE*Ib1b2);
EXIT_IF_ISNAN((pModel->TYPE*Ib1b2))
#endif
#ifdef _DYNAMIC
if
((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib]==0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_betadc]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_betadc]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ic]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib]);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ic]/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib]))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ie]=(pModel->TYPE*(In+pInst->Ib1_s));
EXIT_IF_ISNAN((pModel->TYPE*(In+pInst->Ib1_s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vbe]=(NP(b)-NP(e));
EXIT_IF_ISNAN((NP(b)-NP(e)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vce]=(NP(c)-NP(e));
EXIT_IF_ISNAN((NP(c)-NP(e)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vbc]=(NP(b)-NP(c));
EXIT_IF_ISNAN((NP(b)-NP(c)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_is]=(pModel->TYPE*pInst->Isub);
EXIT_IF_ISNAN((pModel->TYPE*pInst->Isub))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vse]=(NP(s)-NP(e));
EXIT_IF_ISNAN((NP(s)-NP(e)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vbs]=(NP(b)-NP(s));
EXIT_IF_ISNAN((NP(b)-NP(s)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vsc]=(NP(s)-NP(c));
EXIT_IF_ISNAN((NP(s)-NP(c)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vb2e1]=Vb2e1;
EXIT_IF_ISNAN(Vb2e1)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vb2c2]=Vb2c2;
EXIT_IF_ISNAN(Vb2c2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vb2c1]=Vb2c1;
EXIT_IF_ISNAN(Vb2c1)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vb1c1]=(Vb1b2+Vb2c1);
EXIT_IF_ISNAN((Vb1b2+Vb2c1))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vc4c1]=Vc4c1;
EXIT_IF_ISNAN(Vc4c1)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vc3c4]=Vc3c4;
EXIT_IF_ISNAN(Vc3c4)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ve1e]=(-Vee1);
EXIT_IF_ISNAN((-Vee1))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_in]=In;
EXIT_IF_ISNAN(In)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ic1c2]=Ic1c2;
EXIT_IF_ISNAN(Ic1c2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib1b2]=Ib1b2;
EXIT_IF_ISNAN(Ib1b2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib1]=pInst->Ib1;
EXIT_IF_ISNAN(pInst->Ib1)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sib1]=pInst->Ib1_s;
EXIT_IF_ISNAN(pInst->Ib1_s)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_izteb]=pInst->Izteb;
EXIT_IF_ISNAN(pInst->Izteb)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib2]=pInst->Ib2;
EXIT_IF_ISNAN(pInst->Ib2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ib3]=pInst->Ib3;
EXIT_IF_ISNAN(pInst->Ib3)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_iavl]=pInst->Iavl;
EXIT_IF_ISNAN(pInst->Iavl)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_iex]=pInst->Iex;
EXIT_IF_ISNAN(pInst->Iex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xiex]=pInst->XIex;
EXIT_IF_ISNAN(pInst->XIex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_isub]=pInst->Isub;
EXIT_IF_ISNAN(pInst->Isub)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xisub]=pInst->XIsub;
EXIT_IF_ISNAN(pInst->XIsub)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_isf]=Isf;
EXIT_IF_ISNAN(Isf)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ire]=((-Vee1)/pInst->RE_TM);
EXIT_IF_ISNAN(((-Vee1)/pInst->RE_TM))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_irbc]=(Vbb1/pInst->RBC_TM);
EXIT_IF_ISNAN((Vbb1/pInst->RBC_TM))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ircc]=(Vcc3*pInst->GCCxx_TM);
EXIT_IF_ISNAN((Vcc3*pInst->GCCxx_TM))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ircblx]=(Vc3c4*pInst->GCCex_TM);
EXIT_IF_ISNAN((Vc3c4*pInst->GCCex_TM))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ircbli]=(Vc4c1*pInst->GCCin_TM);
EXIT_IF_ISNAN((Vc4c1*pInst->GCCin_TM))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qe]=Qe;
EXIT_IF_ISNAN(Qe)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qte]=Qte;
EXIT_IF_ISNAN(Qte)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sqte]=Qte_s;
EXIT_IF_ISNAN(Qte_s)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qbe]=pInst->Qbe;
EXIT_IF_ISNAN(pInst->Qbe)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qbc]=pInst->Qbc;
EXIT_IF_ISNAN(pInst->Qbc)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qtc]=Qtc;
EXIT_IF_ISNAN(Qtc)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qepi]=Qepi;
EXIT_IF_ISNAN(Qepi)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qb1b2]=Qb1b2;
EXIT_IF_ISNAN(Qb1b2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qtex]=Qtex;
EXIT_IF_ISNAN(Qtex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xqtex]=XQtex;
EXIT_IF_ISNAN(XQtex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qex]=Qex;
EXIT_IF_ISNAN(Qex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xqex]=XQex;
EXIT_IF_ISNAN(XQex)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_qts]=Qts;
EXIT_IF_ISNAN(Qts)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux]=-(Iavl_Vb2_e1); /* indeed 3 */
EXIT_IF_ISNAN(OP_gmux)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy]=-(Iavl_Vb2_c2)-(Iavl_Vc1_c2); /* indeed 3 */
EXIT_IF_ISNAN(OP_gmuy)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz]=-(Iavl_Vb2_c1)+(Iavl_Vc1_c2)-(Iavl_Vc4_c1)-(Iavl_Vc3_c1); /* indeed 3 */
EXIT_IF_ISNAN(OP_gmuz)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuex]=((((+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xgmuex]=+(XIex_Vb_c)+(XIex_Vb_b1); /* indeed 3 */
EXIT_IF_ISNAN(OP_xgmuex)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]=pInst->Rb2;
EXIT_IF_ISNAN(pInst->Rb2)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvx]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvy]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvz]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_re]=pInst->RE_TM;
EXIT_IF_ISNAN(pInst->RE_TM)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbc]=pInst->RBC_TM;
EXIT_IF_ISNAN(pInst->RBC_TM)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcc]=RCCxx_TM;
EXIT_IF_ISNAN(RCCxx_TM)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcblx]=RCCex_TM;
EXIT_IF_ISNAN(RCCex_TM)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli]=RCCin_TM;
EXIT_IF_ISNAN(RCCin_TM)
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gs]=+(Isub_Vb1_b2); /* indeed 3 */
EXIT_IF_ISNAN(OP_gs)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xgs]=+(XIsub_Vb_c)+(XIsub_Vb_b1); /* indeed 3 */
EXIT_IF_ISNAN(OP_xgs)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gsf]=+(Isf_Vs_c1); /* indeed 3 */
EXIT_IF_ISNAN(OP_gsf)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_scbe]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbex]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbez]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcx]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcz]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcex]=((((+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((((+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/)+0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xcbcex]=+((XQtex_Vb_c+XQex_Vb_c))+((XQtex_Vb_b1+XQex_Vb_b1)); /* indeed 3 */
EXIT_IF_ISNAN(OP_xcbcex)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cb1b2]=((-0.0 /*ddx should be top node of expression!*/)-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN(((-0.0 /*ddx should be top node of expression!*/)-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cb1b2x]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cb1b2y]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cb1b2z]=(-0.0 /*ddx should be top node of expression!*/);
EXIT_IF_ISNAN((-0.0 /*ddx should be top node of expression!*/))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cts]=+(Qts_Vs_c1); /* indeed 3 */
EXIT_IF_ISNAN(OP_cts)
#endif
#endif
#if defined(_DYNAMIC)
dydx=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]));
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy])))
#endif
#if defined(_DYNAMIC)
dydz=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]));
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy])))
#endif
#if defined(_DYNAMIC)
gpi=(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*(dydx+dydz)));
EXIT_IF_ISNAN((((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*(dydx+dydz))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gm]=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz]))-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]*(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])))/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]));
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz]))-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]*(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])))/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy])))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_beta]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gm]/gpi);
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gm]/gpi))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gout]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz])-((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]))/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]));
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz])-((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]))/((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy])))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmu]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*dydz))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuex])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xgmuex]);
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*dydz))+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuex])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xgmuex]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rb]=(pInst->RBC_TM+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]);
EXIT_IF_ISNAN((pInst->RBC_TM+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rc]=((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcc]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcblx])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli]);
EXIT_IF_ISNAN(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcc]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcblx])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbe]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbex]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_scbe])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcx])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*dydx))+CBEO_M);
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbex]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_scbe])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcx])+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*dydx))+CBEO_M))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbc]=((((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*dydz)+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcz])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcex])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xcbcex])+CBCO_M);
EXIT_IF_ISNAN(((((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*dydz)+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcz])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcex])+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xcbcex])+CBCO_M))
#endif
#if defined(_DYNAMIC)
gammax=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvx])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]);
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvx])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]))
#endif
#if defined(_DYNAMIC)
gammay=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvy])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]);
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvy])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]))
#endif
#if defined(_DYNAMIC)
gammaz=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvz])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]);
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grbvz])*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rbv]))
#endif
#if defined(_DYNAMIC)
gbfx=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*(1.0+gammax)));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpix]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*(1.0+gammax))))
#endif
#if defined(_DYNAMIC)
gbfy=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*gammay));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiy]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*gammay)))
#endif
#if defined(_DYNAMIC)
gbfz=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*gammaz));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gpiz]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_sgpi]*gammaz)))
#endif
#if defined(_DYNAMIC)
alpha_ft=(((1.0+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydx)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rc]))+(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]+gbfx)+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]+gbfy)*dydx))*pInst->RE_TM))/((1.0-((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydz))*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rc]))-(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]+gbfz)+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]+gbfy)*dydz))*pInst->RE_TM)));
EXIT_IF_ISNAN((((1.0+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydx)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rc]))+(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gx]+gbfx)+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]+gbfy)*dydx))*pInst->RE_TM))/((1.0-((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydz))*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rc]))-(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gz]+gbfz)+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gy]+gbfy)*dydz))*pInst->RE_TM))))
#endif
#if defined(_DYNAMIC)
{
double m00_pow(d00_pow0,((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydx)+(alpha_ft*(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]*dydz)))),(-1))
rx=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#endif
#if defined(_DYNAMIC)
rz=(alpha_ft*rx);
EXIT_IF_ISNAN((alpha_ft*rx))
#endif
#if defined(_DYNAMIC)
ry=((1.0-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]*rz))/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]);
EXIT_IF_ISNAN(((1.0-(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvz]*rz))/ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_grcvy]))
#endif
#if defined(_DYNAMIC)
rb1b2=(((gammax*rx)+(gammay*ry))+(gammaz*rz));
EXIT_IF_ISNAN((((gammax*rx)+(gammay*ry))+(gammaz*rz)))
#endif
#if defined(_DYNAMIC)
rex=((rz+rb1b2)-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli]);
EXIT_IF_ISNAN(((rz+rb1b2)-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli]))
#endif
#if defined(_DYNAMIC)
xrex=((((rz+rb1b2)+(pInst->RBC_TM*((((gbfx+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])*rx)+((gbfy+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*ry))+((gbfz+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])*rz))))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcblx]);
EXIT_IF_ISNAN(((((rz+rb1b2)+(pInst->RBC_TM*((((gbfx+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmux])*rx)+((gbfy+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuy])*ry))+((gbfz+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_gmuz])*rz))))-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcbli])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_rcblx]))
#endif
#if defined(_DYNAMIC)
taut=(((((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_scbe]*(rx+rb1b2))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbex]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcx])*rx))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*ry))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbez]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcz])*rz))+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcex]*rex))+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xcbcex]*xrex))+((CBEO_M+CBCO_M)*(xrex-RCCxx_TM)));
EXIT_IF_ISNAN((((((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_scbe]*(rx+rb1b2))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbex]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcx])*rx))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbey]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcy])*ry))+((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbez]+ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcz])*rz))+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_cbcex]*rex))+(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xcbcex]*xrex))+((CBEO_M+CBCO_M)*(xrex-RCCxx_TM))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_ft]=(1.0/((2.0*3.1415926)*taut));
EXIT_IF_ISNAN((1.0/((2.0*3.1415926)*taut)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_iqs]=Iqs;
EXIT_IF_ISNAN(Iqs)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_xiwepi]=xi_w;
EXIT_IF_ISNAN(xi_w)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_vb2c2star]=Vb2c2star;
EXIT_IF_ISNAN(Vb2c2star)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_pdiss]=power_dis;
EXIT_IF_ISNAN(power_dis)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_OP_tk]=pInst->Tk;
EXIT_IF_ISNAN(pInst->Tk)
#endif
}
