

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
pInst->fpnoise0=0.0; pInst->fenoise0=0.0;
pInst->wnoise0=0.0;
pInst->wnoise1=0.0;
pInst->wnoise2=0.0;
pInst->wnoise3=0.0;
pInst->wnoise4=0.0;
pInst->wnoise5=0.0;
pInst->wnoise6=0.0;
pInst->wnoise7=0.0;
pInst->wnoise8=0.0;
pInst->wnoise9=0.0;
pInst->wnoise10=0.0;
pInst->wnoise11=0.0;
pInst->wnoise12=0.0;
double GammaGd0;
#if defined(_DERIVATE)
double GammaGd0_Vge_di;
double GammaGd0_Vdi_d;
double GammaGd0_Vsi_s;
double GammaGd0_Vge_e;
double GammaGd0_Vdi_si;
double GammaGd0_Tempt_GND;
double GammaGd0_Ve_si;
double GammaGd0_Ve_di;
double GammaGd0_Vge_si;
#endif
double noiGd0;
#if defined(_DERIVATE)
double noiGd0_Tempt_GND;
double noiGd0_Vdi_si;
double noiGd0_Ve_si;
double noiGd0_Ve_di;
double noiGd0_Vge_si;
double noiGd0_Vge_di;
double noiGd0_Vdi_d;
double noiGd0_Vsi_s;
double noiGd0_Vge_e;
#endif
double gche;
#if defined(_DERIVATE)
double gche_Tempt_GND;
double gche_Vdi_si;
double gche_Vge_di;
double gche_Vdi_d;
double gche_Vsi_s;
double gche_Vge_e;
double gche_Ve_si;
double gche_Ve_di;
double gche_Vge_si;
#endif
double npart_theta;
#if defined(_DERIVATE)
double npart_theta_Vge_e;
double npart_theta_Vdi_si;
double npart_theta_Ve_si;
double npart_theta_Ve_di;
double npart_theta_Vge_si;
double npart_theta_Tempt_GND;
#endif
double npart_beta;
#if defined(_DERIVATE)
double npart_beta_Vge_e;
double npart_beta_Vdi_si;
double npart_beta_Ve_si;
double npart_beta_Ve_di;
double npart_beta_Vge_si;
double npart_beta_Tempt_GND;
#endif
double npart_c;
#if defined(_DERIVATE)
double npart_c_Vge_e;
double npart_c_Vdi_si;
double npart_c_Ve_si;
double npart_c_Ve_di;
double npart_c_Vge_si;
double npart_c_Tempt_GND;
#endif
double epsilon;
#if defined(_DERIVATE)
double epsilon_Vge_di;
double epsilon_Vdi_d;
double epsilon_Vsi_s;
double epsilon_Vge_e;
double epsilon_Vdi_si;
double epsilon_Ve_si;
double epsilon_Ve_di;
double epsilon_Vge_si;
double epsilon_Tempt_GND;
#endif
double etaa;
#if defined(_DERIVATE)
double etaa_Vdi_si;
double etaa_Ve_si;
double etaa_Ve_di;
double etaa_Vge_si;
double etaa_Tempt_GND;
#endif
double Abulk;
double Swi;
#if defined(_DERIVATE)
double Swi_Vge_di;
double Swi_Vge_e;
double Swi_Ve_si;
double Swi_Ve_di;
double Swi_Vge_si;
double Swi_Vdi_si;
double Swi_Tempt_GND;
#endif
double Ssi;
#if defined(_DERIVATE)
double Ssi_Vge_di;
double Ssi_Vge_e;
double Ssi_Ve_si;
double Ssi_Ve_di;
double Ssi_Vge_si;
double Ssi_Vdi_si;
double Ssi_Tempt_GND;
double Ssi_Vdi_d;
double Ssi_Vsi_s;
#endif
double Nstar;
#if defined(_DERIVATE)
double Nstar_Tempt_GND;
double Nstar_Vge_e;
double Nstar_Vdi_si;
double Nstar_Ve_si;
double Nstar_Ve_di;
double Nstar_Vge_si;
#endif
double Nl;
#if defined(_DERIVATE)
double Nl_Vge_e;
double Nl_Vdi_si;
double Nl_Ve_si;
double Nl_Ve_di;
double Nl_Vge_si;
double Nl_Tempt_GND;
#endif
double N0;
#if defined(_DERIVATE)
double N0_Vge_e;
double N0_Vdi_si;
double N0_Ve_si;
double N0_Ve_di;
double N0_Vge_si;
double N0_Tempt_GND;
#endif
double DelClm;
#if defined(_DERIVATE)
double DelClm_Vge_di;
double DelClm_Vge_e;
double DelClm_Ve_si;
double DelClm_Ve_di;
double DelClm_Vge_si;
double DelClm_Vdi_si;
double DelClm_Tempt_GND;
#endif
double Leffnoisq;
double Leffnoi;
double Esatnoi;
#if defined(_DERIVATE)
double Esatnoi_Tempt_GND;
double Esatnoi_Vdi_si;
double Esatnoi_Vge_e;
double Esatnoi_Ve_si;
double Esatnoi_Ve_di;
double Esatnoi_Vge_si;
#endif
#if defined(_DYNAMIC)
double vge_overlap;
#if defined(_DERIVATEFORDDX)
double vge_overlap_Vge_di;
double vge_overlap_Vge_e;
double vge_overlap_Ve_si;
double vge_overlap_Ve_di;
double vge_overlap_Vge_si;
double vge_overlap_Vdi_si;
double vge_overlap_Tempt_GND;
#if defined(_DERIVATE2)
  double vge_overlap_Tempt_GND_Vge_di;
  double vge_overlap_Tempt_GND_Vge_e;
  double vge_overlap_Tempt_GND_Ve_si;
  double vge_overlap_Tempt_GND_Ve_di;
  double vge_overlap_Tempt_GND_Vge_si;
  double vge_overlap_Tempt_GND_Vdi_si;
  double vge_overlap_Tempt_GND_Tempt_GND;
  double vge_overlap_Vdi_si_Vge_di;
  double vge_overlap_Vdi_si_Vge_e;
  double vge_overlap_Vdi_si_Ve_si;
  double vge_overlap_Vdi_si_Ve_di;
  double vge_overlap_Vdi_si_Vge_si;
  double vge_overlap_Vdi_si_Vdi_si;
  double vge_overlap_Vdi_si_Tempt_GND;
  double vge_overlap_Vge_si_Vge_di;
  double vge_overlap_Vge_si_Vge_e;
  double vge_overlap_Vge_si_Ve_si;
  double vge_overlap_Vge_si_Ve_di;
  double vge_overlap_Vge_si_Vge_si;
  double vge_overlap_Vge_si_Vdi_si;
  double vge_overlap_Vge_si_Tempt_GND;
  double vge_overlap_Ve_di_Vge_di;
  double vge_overlap_Ve_di_Vge_e;
  double vge_overlap_Ve_di_Ve_si;
  double vge_overlap_Ve_di_Ve_di;
  double vge_overlap_Ve_di_Vge_si;
  double vge_overlap_Ve_di_Vdi_si;
  double vge_overlap_Ve_di_Tempt_GND;
  double vge_overlap_Ve_si_Vge_di;
  double vge_overlap_Ve_si_Vge_e;
  double vge_overlap_Ve_si_Ve_si;
  double vge_overlap_Ve_si_Ve_di;
  double vge_overlap_Ve_si_Vge_si;
  double vge_overlap_Ve_si_Vdi_si;
  double vge_overlap_Ve_si_Tempt_GND;
  double vge_overlap_Vge_e_Vge_di;
  double vge_overlap_Vge_e_Vge_e;
  double vge_overlap_Vge_e_Ve_si;
  double vge_overlap_Vge_e_Ve_di;
  double vge_overlap_Vge_e_Vge_si;
  double vge_overlap_Vge_e_Vdi_si;
  double vge_overlap_Vge_e_Tempt_GND;
  double vge_overlap_Vge_di_Vge_di;
  double vge_overlap_Vge_di_Vge_e;
  double vge_overlap_Vge_di_Ve_si;
  double vge_overlap_Vge_di_Ve_di;
  double vge_overlap_Vge_di_Vge_si;
  double vge_overlap_Vge_di_Vdi_si;
  double vge_overlap_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qedj3;
#if defined(_DERIVATEFORDDX)
double Qedj3_Vdi_d;
double Qedj3_Vsi_s;
double Qedj3_Tempt_GND;
double Qedj3_Vge_di;
double Qedj3_Vge_e;
double Qedj3_Ve_si;
double Qedj3_Ve_di;
double Qedj3_Vge_si;
double Qedj3_Vdi_si;
#if defined(_DERIVATE2)
  double Qedj3_Vdi_si_Vdi_d;
  double Qedj3_Vdi_si_Vsi_s;
  double Qedj3_Vdi_si_Tempt_GND;
  double Qedj3_Vdi_si_Vge_di;
  double Qedj3_Vdi_si_Vge_e;
  double Qedj3_Vdi_si_Ve_si;
  double Qedj3_Vdi_si_Ve_di;
  double Qedj3_Vdi_si_Vge_si;
  double Qedj3_Vdi_si_Vdi_si;
  double Qedj3_Vge_si_Vdi_d;
  double Qedj3_Vge_si_Vsi_s;
  double Qedj3_Vge_si_Tempt_GND;
  double Qedj3_Vge_si_Vge_di;
  double Qedj3_Vge_si_Vge_e;
  double Qedj3_Vge_si_Ve_si;
  double Qedj3_Vge_si_Ve_di;
  double Qedj3_Vge_si_Vge_si;
  double Qedj3_Vge_si_Vdi_si;
  double Qedj3_Ve_di_Vdi_d;
  double Qedj3_Ve_di_Vsi_s;
  double Qedj3_Ve_di_Tempt_GND;
  double Qedj3_Ve_di_Vge_di;
  double Qedj3_Ve_di_Vge_e;
  double Qedj3_Ve_di_Ve_si;
  double Qedj3_Ve_di_Ve_di;
  double Qedj3_Ve_di_Vge_si;
  double Qedj3_Ve_di_Vdi_si;
  double Qedj3_Ve_si_Vdi_d;
  double Qedj3_Ve_si_Vsi_s;
  double Qedj3_Ve_si_Tempt_GND;
  double Qedj3_Ve_si_Vge_di;
  double Qedj3_Ve_si_Vge_e;
  double Qedj3_Ve_si_Ve_si;
  double Qedj3_Ve_si_Ve_di;
  double Qedj3_Ve_si_Vge_si;
  double Qedj3_Ve_si_Vdi_si;
  double Qedj3_Vge_e_Vdi_d;
  double Qedj3_Vge_e_Vsi_s;
  double Qedj3_Vge_e_Tempt_GND;
  double Qedj3_Vge_e_Vge_di;
  double Qedj3_Vge_e_Vge_e;
  double Qedj3_Vge_e_Ve_si;
  double Qedj3_Vge_e_Ve_di;
  double Qedj3_Vge_e_Vge_si;
  double Qedj3_Vge_e_Vdi_si;
  double Qedj3_Vge_di_Vdi_d;
  double Qedj3_Vge_di_Vsi_s;
  double Qedj3_Vge_di_Tempt_GND;
  double Qedj3_Vge_di_Vge_di;
  double Qedj3_Vge_di_Vge_e;
  double Qedj3_Vge_di_Ve_si;
  double Qedj3_Vge_di_Ve_di;
  double Qedj3_Vge_di_Vge_si;
  double Qedj3_Vge_di_Vdi_si;
  double Qedj3_Tempt_GND_Vdi_d;
  double Qedj3_Tempt_GND_Vsi_s;
  double Qedj3_Tempt_GND_Tempt_GND;
  double Qedj3_Tempt_GND_Vge_di;
  double Qedj3_Tempt_GND_Vge_e;
  double Qedj3_Tempt_GND_Ve_si;
  double Qedj3_Tempt_GND_Ve_di;
  double Qedj3_Tempt_GND_Vge_si;
  double Qedj3_Tempt_GND_Vdi_si;
  double Qedj3_Vsi_s_Vdi_d;
  double Qedj3_Vsi_s_Vsi_s;
  double Qedj3_Vsi_s_Tempt_GND;
  double Qedj3_Vsi_s_Vge_di;
  double Qedj3_Vsi_s_Vge_e;
  double Qedj3_Vsi_s_Ve_si;
  double Qedj3_Vsi_s_Ve_di;
  double Qedj3_Vsi_s_Vge_si;
  double Qedj3_Vsi_s_Vdi_si;
  double Qedj3_Vdi_d_Vdi_d;
  double Qedj3_Vdi_d_Vsi_s;
  double Qedj3_Vdi_d_Tempt_GND;
  double Qedj3_Vdi_d_Vge_di;
  double Qedj3_Vdi_d_Vge_e;
  double Qedj3_Vdi_d_Ve_si;
  double Qedj3_Vdi_d_Ve_di;
  double Qedj3_Vdi_d_Vge_si;
  double Qedj3_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qedj2;
#if defined(_DERIVATEFORDDX)
double Qedj2_Vdi_d;
double Qedj2_Vsi_s;
double Qedj2_Tempt_GND;
double Qedj2_Vge_di;
double Qedj2_Vge_e;
double Qedj2_Ve_si;
double Qedj2_Ve_di;
double Qedj2_Vge_si;
double Qedj2_Vdi_si;
#if defined(_DERIVATE2)
  double Qedj2_Vdi_si_Vdi_d;
  double Qedj2_Vdi_si_Vsi_s;
  double Qedj2_Vdi_si_Tempt_GND;
  double Qedj2_Vdi_si_Vge_di;
  double Qedj2_Vdi_si_Vge_e;
  double Qedj2_Vdi_si_Ve_si;
  double Qedj2_Vdi_si_Ve_di;
  double Qedj2_Vdi_si_Vge_si;
  double Qedj2_Vdi_si_Vdi_si;
  double Qedj2_Vge_si_Vdi_d;
  double Qedj2_Vge_si_Vsi_s;
  double Qedj2_Vge_si_Tempt_GND;
  double Qedj2_Vge_si_Vge_di;
  double Qedj2_Vge_si_Vge_e;
  double Qedj2_Vge_si_Ve_si;
  double Qedj2_Vge_si_Ve_di;
  double Qedj2_Vge_si_Vge_si;
  double Qedj2_Vge_si_Vdi_si;
  double Qedj2_Ve_di_Vdi_d;
  double Qedj2_Ve_di_Vsi_s;
  double Qedj2_Ve_di_Tempt_GND;
  double Qedj2_Ve_di_Vge_di;
  double Qedj2_Ve_di_Vge_e;
  double Qedj2_Ve_di_Ve_si;
  double Qedj2_Ve_di_Ve_di;
  double Qedj2_Ve_di_Vge_si;
  double Qedj2_Ve_di_Vdi_si;
  double Qedj2_Ve_si_Vdi_d;
  double Qedj2_Ve_si_Vsi_s;
  double Qedj2_Ve_si_Tempt_GND;
  double Qedj2_Ve_si_Vge_di;
  double Qedj2_Ve_si_Vge_e;
  double Qedj2_Ve_si_Ve_si;
  double Qedj2_Ve_si_Ve_di;
  double Qedj2_Ve_si_Vge_si;
  double Qedj2_Ve_si_Vdi_si;
  double Qedj2_Vge_e_Vdi_d;
  double Qedj2_Vge_e_Vsi_s;
  double Qedj2_Vge_e_Tempt_GND;
  double Qedj2_Vge_e_Vge_di;
  double Qedj2_Vge_e_Vge_e;
  double Qedj2_Vge_e_Ve_si;
  double Qedj2_Vge_e_Ve_di;
  double Qedj2_Vge_e_Vge_si;
  double Qedj2_Vge_e_Vdi_si;
  double Qedj2_Vge_di_Vdi_d;
  double Qedj2_Vge_di_Vsi_s;
  double Qedj2_Vge_di_Tempt_GND;
  double Qedj2_Vge_di_Vge_di;
  double Qedj2_Vge_di_Vge_e;
  double Qedj2_Vge_di_Ve_si;
  double Qedj2_Vge_di_Ve_di;
  double Qedj2_Vge_di_Vge_si;
  double Qedj2_Vge_di_Vdi_si;
  double Qedj2_Tempt_GND_Vdi_d;
  double Qedj2_Tempt_GND_Vsi_s;
  double Qedj2_Tempt_GND_Tempt_GND;
  double Qedj2_Tempt_GND_Vge_di;
  double Qedj2_Tempt_GND_Vge_e;
  double Qedj2_Tempt_GND_Ve_si;
  double Qedj2_Tempt_GND_Ve_di;
  double Qedj2_Tempt_GND_Vge_si;
  double Qedj2_Tempt_GND_Vdi_si;
  double Qedj2_Vsi_s_Vdi_d;
  double Qedj2_Vsi_s_Vsi_s;
  double Qedj2_Vsi_s_Tempt_GND;
  double Qedj2_Vsi_s_Vge_di;
  double Qedj2_Vsi_s_Vge_e;
  double Qedj2_Vsi_s_Ve_si;
  double Qedj2_Vsi_s_Ve_di;
  double Qedj2_Vsi_s_Vge_si;
  double Qedj2_Vsi_s_Vdi_si;
  double Qedj2_Vdi_d_Vdi_d;
  double Qedj2_Vdi_d_Vsi_s;
  double Qedj2_Vdi_d_Tempt_GND;
  double Qedj2_Vdi_d_Vge_di;
  double Qedj2_Vdi_d_Vge_e;
  double Qedj2_Vdi_d_Ve_si;
  double Qedj2_Vdi_d_Ve_di;
  double Qedj2_Vdi_d_Vge_si;
  double Qedj2_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qedj1;
#if defined(_DERIVATEFORDDX)
double Qedj1_Vdi_d;
double Qedj1_Vsi_s;
double Qedj1_Tempt_GND;
double Qedj1_Vge_di;
double Qedj1_Vge_e;
double Qedj1_Ve_si;
double Qedj1_Ve_di;
double Qedj1_Vge_si;
double Qedj1_Vdi_si;
#if defined(_DERIVATE2)
  double Qedj1_Vdi_si_Vdi_d;
  double Qedj1_Vdi_si_Vsi_s;
  double Qedj1_Vdi_si_Tempt_GND;
  double Qedj1_Vdi_si_Vge_di;
  double Qedj1_Vdi_si_Vge_e;
  double Qedj1_Vdi_si_Ve_si;
  double Qedj1_Vdi_si_Ve_di;
  double Qedj1_Vdi_si_Vge_si;
  double Qedj1_Vdi_si_Vdi_si;
  double Qedj1_Vge_si_Vdi_d;
  double Qedj1_Vge_si_Vsi_s;
  double Qedj1_Vge_si_Tempt_GND;
  double Qedj1_Vge_si_Vge_di;
  double Qedj1_Vge_si_Vge_e;
  double Qedj1_Vge_si_Ve_si;
  double Qedj1_Vge_si_Ve_di;
  double Qedj1_Vge_si_Vge_si;
  double Qedj1_Vge_si_Vdi_si;
  double Qedj1_Ve_di_Vdi_d;
  double Qedj1_Ve_di_Vsi_s;
  double Qedj1_Ve_di_Tempt_GND;
  double Qedj1_Ve_di_Vge_di;
  double Qedj1_Ve_di_Vge_e;
  double Qedj1_Ve_di_Ve_si;
  double Qedj1_Ve_di_Ve_di;
  double Qedj1_Ve_di_Vge_si;
  double Qedj1_Ve_di_Vdi_si;
  double Qedj1_Ve_si_Vdi_d;
  double Qedj1_Ve_si_Vsi_s;
  double Qedj1_Ve_si_Tempt_GND;
  double Qedj1_Ve_si_Vge_di;
  double Qedj1_Ve_si_Vge_e;
  double Qedj1_Ve_si_Ve_si;
  double Qedj1_Ve_si_Ve_di;
  double Qedj1_Ve_si_Vge_si;
  double Qedj1_Ve_si_Vdi_si;
  double Qedj1_Vge_e_Vdi_d;
  double Qedj1_Vge_e_Vsi_s;
  double Qedj1_Vge_e_Tempt_GND;
  double Qedj1_Vge_e_Vge_di;
  double Qedj1_Vge_e_Vge_e;
  double Qedj1_Vge_e_Ve_si;
  double Qedj1_Vge_e_Ve_di;
  double Qedj1_Vge_e_Vge_si;
  double Qedj1_Vge_e_Vdi_si;
  double Qedj1_Vge_di_Vdi_d;
  double Qedj1_Vge_di_Vsi_s;
  double Qedj1_Vge_di_Tempt_GND;
  double Qedj1_Vge_di_Vge_di;
  double Qedj1_Vge_di_Vge_e;
  double Qedj1_Vge_di_Ve_si;
  double Qedj1_Vge_di_Ve_di;
  double Qedj1_Vge_di_Vge_si;
  double Qedj1_Vge_di_Vdi_si;
  double Qedj1_Tempt_GND_Vdi_d;
  double Qedj1_Tempt_GND_Vsi_s;
  double Qedj1_Tempt_GND_Tempt_GND;
  double Qedj1_Tempt_GND_Vge_di;
  double Qedj1_Tempt_GND_Vge_e;
  double Qedj1_Tempt_GND_Ve_si;
  double Qedj1_Tempt_GND_Ve_di;
  double Qedj1_Tempt_GND_Vge_si;
  double Qedj1_Tempt_GND_Vdi_si;
  double Qedj1_Vsi_s_Vdi_d;
  double Qedj1_Vsi_s_Vsi_s;
  double Qedj1_Vsi_s_Tempt_GND;
  double Qedj1_Vsi_s_Vge_di;
  double Qedj1_Vsi_s_Vge_e;
  double Qedj1_Vsi_s_Ve_si;
  double Qedj1_Vsi_s_Ve_di;
  double Qedj1_Vsi_s_Vge_si;
  double Qedj1_Vsi_s_Vdi_si;
  double Qedj1_Vdi_d_Vdi_d;
  double Qedj1_Vdi_d_Vsi_s;
  double Qedj1_Vdi_d_Tempt_GND;
  double Qedj1_Vdi_d_Vge_di;
  double Qedj1_Vdi_d_Vge_e;
  double Qedj1_Vdi_d_Ve_si;
  double Qedj1_Vdi_d_Ve_di;
  double Qedj1_Vdi_d_Vge_si;
  double Qedj1_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qesj3;
#if defined(_DERIVATEFORDDX)
double Qesj3_Vdi_d;
double Qesj3_Vsi_s;
double Qesj3_Tempt_GND;
double Qesj3_Vge_di;
double Qesj3_Vge_e;
double Qesj3_Ve_si;
double Qesj3_Ve_di;
double Qesj3_Vge_si;
double Qesj3_Vdi_si;
#if defined(_DERIVATE2)
  double Qesj3_Vdi_si_Vdi_d;
  double Qesj3_Vdi_si_Vsi_s;
  double Qesj3_Vdi_si_Tempt_GND;
  double Qesj3_Vdi_si_Vge_di;
  double Qesj3_Vdi_si_Vge_e;
  double Qesj3_Vdi_si_Ve_si;
  double Qesj3_Vdi_si_Ve_di;
  double Qesj3_Vdi_si_Vge_si;
  double Qesj3_Vdi_si_Vdi_si;
  double Qesj3_Vge_si_Vdi_d;
  double Qesj3_Vge_si_Vsi_s;
  double Qesj3_Vge_si_Tempt_GND;
  double Qesj3_Vge_si_Vge_di;
  double Qesj3_Vge_si_Vge_e;
  double Qesj3_Vge_si_Ve_si;
  double Qesj3_Vge_si_Ve_di;
  double Qesj3_Vge_si_Vge_si;
  double Qesj3_Vge_si_Vdi_si;
  double Qesj3_Ve_di_Vdi_d;
  double Qesj3_Ve_di_Vsi_s;
  double Qesj3_Ve_di_Tempt_GND;
  double Qesj3_Ve_di_Vge_di;
  double Qesj3_Ve_di_Vge_e;
  double Qesj3_Ve_di_Ve_si;
  double Qesj3_Ve_di_Ve_di;
  double Qesj3_Ve_di_Vge_si;
  double Qesj3_Ve_di_Vdi_si;
  double Qesj3_Ve_si_Vdi_d;
  double Qesj3_Ve_si_Vsi_s;
  double Qesj3_Ve_si_Tempt_GND;
  double Qesj3_Ve_si_Vge_di;
  double Qesj3_Ve_si_Vge_e;
  double Qesj3_Ve_si_Ve_si;
  double Qesj3_Ve_si_Ve_di;
  double Qesj3_Ve_si_Vge_si;
  double Qesj3_Ve_si_Vdi_si;
  double Qesj3_Vge_e_Vdi_d;
  double Qesj3_Vge_e_Vsi_s;
  double Qesj3_Vge_e_Tempt_GND;
  double Qesj3_Vge_e_Vge_di;
  double Qesj3_Vge_e_Vge_e;
  double Qesj3_Vge_e_Ve_si;
  double Qesj3_Vge_e_Ve_di;
  double Qesj3_Vge_e_Vge_si;
  double Qesj3_Vge_e_Vdi_si;
  double Qesj3_Vge_di_Vdi_d;
  double Qesj3_Vge_di_Vsi_s;
  double Qesj3_Vge_di_Tempt_GND;
  double Qesj3_Vge_di_Vge_di;
  double Qesj3_Vge_di_Vge_e;
  double Qesj3_Vge_di_Ve_si;
  double Qesj3_Vge_di_Ve_di;
  double Qesj3_Vge_di_Vge_si;
  double Qesj3_Vge_di_Vdi_si;
  double Qesj3_Tempt_GND_Vdi_d;
  double Qesj3_Tempt_GND_Vsi_s;
  double Qesj3_Tempt_GND_Tempt_GND;
  double Qesj3_Tempt_GND_Vge_di;
  double Qesj3_Tempt_GND_Vge_e;
  double Qesj3_Tempt_GND_Ve_si;
  double Qesj3_Tempt_GND_Ve_di;
  double Qesj3_Tempt_GND_Vge_si;
  double Qesj3_Tempt_GND_Vdi_si;
  double Qesj3_Vsi_s_Vdi_d;
  double Qesj3_Vsi_s_Vsi_s;
  double Qesj3_Vsi_s_Tempt_GND;
  double Qesj3_Vsi_s_Vge_di;
  double Qesj3_Vsi_s_Vge_e;
  double Qesj3_Vsi_s_Ve_si;
  double Qesj3_Vsi_s_Ve_di;
  double Qesj3_Vsi_s_Vge_si;
  double Qesj3_Vsi_s_Vdi_si;
  double Qesj3_Vdi_d_Vdi_d;
  double Qesj3_Vdi_d_Vsi_s;
  double Qesj3_Vdi_d_Tempt_GND;
  double Qesj3_Vdi_d_Vge_di;
  double Qesj3_Vdi_d_Vge_e;
  double Qesj3_Vdi_d_Ve_si;
  double Qesj3_Vdi_d_Ve_di;
  double Qesj3_Vdi_d_Vge_si;
  double Qesj3_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qesj2;
#if defined(_DERIVATEFORDDX)
double Qesj2_Vdi_d;
double Qesj2_Vsi_s;
double Qesj2_Tempt_GND;
double Qesj2_Vge_di;
double Qesj2_Vge_e;
double Qesj2_Ve_si;
double Qesj2_Ve_di;
double Qesj2_Vge_si;
double Qesj2_Vdi_si;
#if defined(_DERIVATE2)
  double Qesj2_Vdi_si_Vdi_d;
  double Qesj2_Vdi_si_Vsi_s;
  double Qesj2_Vdi_si_Tempt_GND;
  double Qesj2_Vdi_si_Vge_di;
  double Qesj2_Vdi_si_Vge_e;
  double Qesj2_Vdi_si_Ve_si;
  double Qesj2_Vdi_si_Ve_di;
  double Qesj2_Vdi_si_Vge_si;
  double Qesj2_Vdi_si_Vdi_si;
  double Qesj2_Vge_si_Vdi_d;
  double Qesj2_Vge_si_Vsi_s;
  double Qesj2_Vge_si_Tempt_GND;
  double Qesj2_Vge_si_Vge_di;
  double Qesj2_Vge_si_Vge_e;
  double Qesj2_Vge_si_Ve_si;
  double Qesj2_Vge_si_Ve_di;
  double Qesj2_Vge_si_Vge_si;
  double Qesj2_Vge_si_Vdi_si;
  double Qesj2_Ve_di_Vdi_d;
  double Qesj2_Ve_di_Vsi_s;
  double Qesj2_Ve_di_Tempt_GND;
  double Qesj2_Ve_di_Vge_di;
  double Qesj2_Ve_di_Vge_e;
  double Qesj2_Ve_di_Ve_si;
  double Qesj2_Ve_di_Ve_di;
  double Qesj2_Ve_di_Vge_si;
  double Qesj2_Ve_di_Vdi_si;
  double Qesj2_Ve_si_Vdi_d;
  double Qesj2_Ve_si_Vsi_s;
  double Qesj2_Ve_si_Tempt_GND;
  double Qesj2_Ve_si_Vge_di;
  double Qesj2_Ve_si_Vge_e;
  double Qesj2_Ve_si_Ve_si;
  double Qesj2_Ve_si_Ve_di;
  double Qesj2_Ve_si_Vge_si;
  double Qesj2_Ve_si_Vdi_si;
  double Qesj2_Vge_e_Vdi_d;
  double Qesj2_Vge_e_Vsi_s;
  double Qesj2_Vge_e_Tempt_GND;
  double Qesj2_Vge_e_Vge_di;
  double Qesj2_Vge_e_Vge_e;
  double Qesj2_Vge_e_Ve_si;
  double Qesj2_Vge_e_Ve_di;
  double Qesj2_Vge_e_Vge_si;
  double Qesj2_Vge_e_Vdi_si;
  double Qesj2_Vge_di_Vdi_d;
  double Qesj2_Vge_di_Vsi_s;
  double Qesj2_Vge_di_Tempt_GND;
  double Qesj2_Vge_di_Vge_di;
  double Qesj2_Vge_di_Vge_e;
  double Qesj2_Vge_di_Ve_si;
  double Qesj2_Vge_di_Ve_di;
  double Qesj2_Vge_di_Vge_si;
  double Qesj2_Vge_di_Vdi_si;
  double Qesj2_Tempt_GND_Vdi_d;
  double Qesj2_Tempt_GND_Vsi_s;
  double Qesj2_Tempt_GND_Tempt_GND;
  double Qesj2_Tempt_GND_Vge_di;
  double Qesj2_Tempt_GND_Vge_e;
  double Qesj2_Tempt_GND_Ve_si;
  double Qesj2_Tempt_GND_Ve_di;
  double Qesj2_Tempt_GND_Vge_si;
  double Qesj2_Tempt_GND_Vdi_si;
  double Qesj2_Vsi_s_Vdi_d;
  double Qesj2_Vsi_s_Vsi_s;
  double Qesj2_Vsi_s_Tempt_GND;
  double Qesj2_Vsi_s_Vge_di;
  double Qesj2_Vsi_s_Vge_e;
  double Qesj2_Vsi_s_Ve_si;
  double Qesj2_Vsi_s_Ve_di;
  double Qesj2_Vsi_s_Vge_si;
  double Qesj2_Vsi_s_Vdi_si;
  double Qesj2_Vdi_d_Vdi_d;
  double Qesj2_Vdi_d_Vsi_s;
  double Qesj2_Vdi_d_Tempt_GND;
  double Qesj2_Vdi_d_Vge_di;
  double Qesj2_Vdi_d_Vge_e;
  double Qesj2_Vdi_d_Ve_si;
  double Qesj2_Vdi_d_Ve_di;
  double Qesj2_Vdi_d_Vge_si;
  double Qesj2_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qec;
#if defined(_DERIVATEFORDDX)
double Qec_Tempt_GND;
double Qec_Vge_di;
double Qec_Vge_e;
double Qec_Ve_si;
double Qec_Ve_di;
double Qec_Vge_si;
double Qec_Vdi_si;
#if defined(_DERIVATE2)
  double Qec_Vdi_si_Tempt_GND;
  double Qec_Vdi_si_Vge_di;
  double Qec_Vdi_si_Vge_e;
  double Qec_Vdi_si_Ve_si;
  double Qec_Vdi_si_Ve_di;
  double Qec_Vdi_si_Vge_si;
  double Qec_Vdi_si_Vdi_si;
  double Qec_Vge_si_Tempt_GND;
  double Qec_Vge_si_Vge_di;
  double Qec_Vge_si_Vge_e;
  double Qec_Vge_si_Ve_si;
  double Qec_Vge_si_Ve_di;
  double Qec_Vge_si_Vge_si;
  double Qec_Vge_si_Vdi_si;
  double Qec_Ve_di_Tempt_GND;
  double Qec_Ve_di_Vge_di;
  double Qec_Ve_di_Vge_e;
  double Qec_Ve_di_Ve_si;
  double Qec_Ve_di_Ve_di;
  double Qec_Ve_di_Vge_si;
  double Qec_Ve_di_Vdi_si;
  double Qec_Ve_si_Tempt_GND;
  double Qec_Ve_si_Vge_di;
  double Qec_Ve_si_Vge_e;
  double Qec_Ve_si_Ve_si;
  double Qec_Ve_si_Ve_di;
  double Qec_Ve_si_Vge_si;
  double Qec_Ve_si_Vdi_si;
  double Qec_Vge_e_Tempt_GND;
  double Qec_Vge_e_Vge_di;
  double Qec_Vge_e_Vge_e;
  double Qec_Vge_e_Ve_si;
  double Qec_Vge_e_Ve_di;
  double Qec_Vge_e_Vge_si;
  double Qec_Vge_e_Vdi_si;
  double Qec_Vge_di_Tempt_GND;
  double Qec_Vge_di_Vge_di;
  double Qec_Vge_di_Vge_e;
  double Qec_Vge_di_Ve_si;
  double Qec_Vge_di_Ve_di;
  double Qec_Vge_di_Vge_si;
  double Qec_Vge_di_Vdi_si;
  double Qec_Tempt_GND_Tempt_GND;
  double Qec_Tempt_GND_Vge_di;
  double Qec_Tempt_GND_Vge_e;
  double Qec_Tempt_GND_Ve_si;
  double Qec_Tempt_GND_Ve_di;
  double Qec_Tempt_GND_Vge_si;
  double Qec_Tempt_GND_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qesj1;
#if defined(_DERIVATEFORDDX)
double Qesj1_Vdi_d;
double Qesj1_Vsi_s;
double Qesj1_Tempt_GND;
double Qesj1_Vge_di;
double Qesj1_Vge_e;
double Qesj1_Ve_si;
double Qesj1_Ve_di;
double Qesj1_Vge_si;
double Qesj1_Vdi_si;
#if defined(_DERIVATE2)
  double Qesj1_Vdi_si_Vdi_d;
  double Qesj1_Vdi_si_Vsi_s;
  double Qesj1_Vdi_si_Tempt_GND;
  double Qesj1_Vdi_si_Vge_di;
  double Qesj1_Vdi_si_Vge_e;
  double Qesj1_Vdi_si_Ve_si;
  double Qesj1_Vdi_si_Ve_di;
  double Qesj1_Vdi_si_Vge_si;
  double Qesj1_Vdi_si_Vdi_si;
  double Qesj1_Vge_si_Vdi_d;
  double Qesj1_Vge_si_Vsi_s;
  double Qesj1_Vge_si_Tempt_GND;
  double Qesj1_Vge_si_Vge_di;
  double Qesj1_Vge_si_Vge_e;
  double Qesj1_Vge_si_Ve_si;
  double Qesj1_Vge_si_Ve_di;
  double Qesj1_Vge_si_Vge_si;
  double Qesj1_Vge_si_Vdi_si;
  double Qesj1_Ve_di_Vdi_d;
  double Qesj1_Ve_di_Vsi_s;
  double Qesj1_Ve_di_Tempt_GND;
  double Qesj1_Ve_di_Vge_di;
  double Qesj1_Ve_di_Vge_e;
  double Qesj1_Ve_di_Ve_si;
  double Qesj1_Ve_di_Ve_di;
  double Qesj1_Ve_di_Vge_si;
  double Qesj1_Ve_di_Vdi_si;
  double Qesj1_Ve_si_Vdi_d;
  double Qesj1_Ve_si_Vsi_s;
  double Qesj1_Ve_si_Tempt_GND;
  double Qesj1_Ve_si_Vge_di;
  double Qesj1_Ve_si_Vge_e;
  double Qesj1_Ve_si_Ve_si;
  double Qesj1_Ve_si_Ve_di;
  double Qesj1_Ve_si_Vge_si;
  double Qesj1_Ve_si_Vdi_si;
  double Qesj1_Vge_e_Vdi_d;
  double Qesj1_Vge_e_Vsi_s;
  double Qesj1_Vge_e_Tempt_GND;
  double Qesj1_Vge_e_Vge_di;
  double Qesj1_Vge_e_Vge_e;
  double Qesj1_Vge_e_Ve_si;
  double Qesj1_Vge_e_Ve_di;
  double Qesj1_Vge_e_Vge_si;
  double Qesj1_Vge_e_Vdi_si;
  double Qesj1_Vge_di_Vdi_d;
  double Qesj1_Vge_di_Vsi_s;
  double Qesj1_Vge_di_Tempt_GND;
  double Qesj1_Vge_di_Vge_di;
  double Qesj1_Vge_di_Vge_e;
  double Qesj1_Vge_di_Ve_si;
  double Qesj1_Vge_di_Ve_di;
  double Qesj1_Vge_di_Vge_si;
  double Qesj1_Vge_di_Vdi_si;
  double Qesj1_Tempt_GND_Vdi_d;
  double Qesj1_Tempt_GND_Vsi_s;
  double Qesj1_Tempt_GND_Tempt_GND;
  double Qesj1_Tempt_GND_Vge_di;
  double Qesj1_Tempt_GND_Vge_e;
  double Qesj1_Tempt_GND_Ve_si;
  double Qesj1_Tempt_GND_Ve_di;
  double Qesj1_Tempt_GND_Vge_si;
  double Qesj1_Tempt_GND_Vdi_si;
  double Qesj1_Vsi_s_Vdi_d;
  double Qesj1_Vsi_s_Vsi_s;
  double Qesj1_Vsi_s_Tempt_GND;
  double Qesj1_Vsi_s_Vge_di;
  double Qesj1_Vsi_s_Vge_e;
  double Qesj1_Vsi_s_Ve_si;
  double Qesj1_Vsi_s_Ve_di;
  double Qesj1_Vsi_s_Vge_si;
  double Qesj1_Vsi_s_Vdi_si;
  double Qesj1_Vdi_d_Vdi_d;
  double Qesj1_Vdi_d_Vsi_s;
  double Qesj1_Vdi_d_Tempt_GND;
  double Qesj1_Vdi_d_Vge_di;
  double Qesj1_Vdi_d_Vge_e;
  double Qesj1_Vdi_d_Ve_si;
  double Qesj1_Vdi_d_Ve_di;
  double Qesj1_Vdi_d_Vge_si;
  double Qesj1_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double sarg;
#if defined(_DERIVATEFORDDX)
double sarg_Vge_di;
double sarg_Vge_e;
double sarg_Ve_si;
double sarg_Ve_di;
double sarg_Vge_si;
double sarg_Vdi_si;
double sarg_Tempt_GND;
#if defined(_DERIVATE2)
  double sarg_Tempt_GND_Vge_di;
  double sarg_Tempt_GND_Vge_e;
  double sarg_Tempt_GND_Ve_si;
  double sarg_Tempt_GND_Ve_di;
  double sarg_Tempt_GND_Vge_si;
  double sarg_Tempt_GND_Vdi_si;
  double sarg_Tempt_GND_Tempt_GND;
  double sarg_Vdi_si_Vge_di;
  double sarg_Vdi_si_Vge_e;
  double sarg_Vdi_si_Ve_si;
  double sarg_Vdi_si_Ve_di;
  double sarg_Vdi_si_Vge_si;
  double sarg_Vdi_si_Vdi_si;
  double sarg_Vdi_si_Tempt_GND;
  double sarg_Vge_si_Vge_di;
  double sarg_Vge_si_Vge_e;
  double sarg_Vge_si_Ve_si;
  double sarg_Vge_si_Ve_di;
  double sarg_Vge_si_Vge_si;
  double sarg_Vge_si_Vdi_si;
  double sarg_Vge_si_Tempt_GND;
  double sarg_Ve_di_Vge_di;
  double sarg_Ve_di_Vge_e;
  double sarg_Ve_di_Ve_si;
  double sarg_Ve_di_Ve_di;
  double sarg_Ve_di_Vge_si;
  double sarg_Ve_di_Vdi_si;
  double sarg_Ve_di_Tempt_GND;
  double sarg_Ve_si_Vge_di;
  double sarg_Ve_si_Vge_e;
  double sarg_Ve_si_Ve_si;
  double sarg_Ve_si_Ve_di;
  double sarg_Ve_si_Vge_si;
  double sarg_Ve_si_Vdi_si;
  double sarg_Ve_si_Tempt_GND;
  double sarg_Vge_e_Vge_di;
  double sarg_Vge_e_Vge_e;
  double sarg_Vge_e_Ve_si;
  double sarg_Vge_e_Ve_di;
  double sarg_Vge_e_Vge_si;
  double sarg_Vge_e_Vdi_si;
  double sarg_Vge_e_Tempt_GND;
  double sarg_Vge_di_Vge_di;
  double sarg_Vge_di_Vge_e;
  double sarg_Vge_di_Ve_si;
  double sarg_Vge_di_Ve_di;
  double sarg_Vge_di_Vge_si;
  double sarg_Vge_di_Vdi_si;
  double sarg_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double arg;
#if defined(_DERIVATEFORDDX)
double arg_Vge_di;
double arg_Vge_e;
double arg_Ve_si;
double arg_Ve_di;
double arg_Vge_si;
double arg_Vdi_si;
double arg_Tempt_GND;
#if defined(_DERIVATE2)
  double arg_Tempt_GND_Vge_di;
  double arg_Tempt_GND_Vge_e;
  double arg_Tempt_GND_Ve_si;
  double arg_Tempt_GND_Ve_di;
  double arg_Tempt_GND_Vge_si;
  double arg_Tempt_GND_Vdi_si;
  double arg_Tempt_GND_Tempt_GND;
  double arg_Vdi_si_Vge_di;
  double arg_Vdi_si_Vge_e;
  double arg_Vdi_si_Ve_si;
  double arg_Vdi_si_Ve_di;
  double arg_Vdi_si_Vge_si;
  double arg_Vdi_si_Vdi_si;
  double arg_Vdi_si_Tempt_GND;
  double arg_Vge_si_Vge_di;
  double arg_Vge_si_Vge_e;
  double arg_Vge_si_Ve_si;
  double arg_Vge_si_Ve_di;
  double arg_Vge_si_Vge_si;
  double arg_Vge_si_Vdi_si;
  double arg_Vge_si_Tempt_GND;
  double arg_Ve_di_Vge_di;
  double arg_Ve_di_Vge_e;
  double arg_Ve_di_Ve_si;
  double arg_Ve_di_Ve_di;
  double arg_Ve_di_Vge_si;
  double arg_Ve_di_Vdi_si;
  double arg_Ve_di_Tempt_GND;
  double arg_Ve_si_Vge_di;
  double arg_Ve_si_Vge_e;
  double arg_Ve_si_Ve_si;
  double arg_Ve_si_Ve_di;
  double arg_Ve_si_Vge_si;
  double arg_Ve_si_Vdi_si;
  double arg_Ve_si_Tempt_GND;
  double arg_Vge_e_Vge_di;
  double arg_Vge_e_Vge_e;
  double arg_Vge_e_Ve_si;
  double arg_Vge_e_Ve_di;
  double arg_Vge_e_Vge_si;
  double arg_Vge_e_Vdi_si;
  double arg_Vge_e_Tempt_GND;
  double arg_Vge_di_Vge_di;
  double arg_Vge_di_Vge_e;
  double arg_Vge_di_Ve_si;
  double arg_Vge_di_Ve_di;
  double arg_Vge_di_Vge_si;
  double arg_Vge_di_Vdi_si;
  double arg_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double pb2;
#if defined(_DERIVATEFORDDX)
double pb2_Tempt_GND;
#if defined(_DERIVATE2)
  double pb2_Tempt_GND_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double vec;
#if defined(_DERIVATEFORDDX)
double vec_Tempt_GND;
#if defined(_DERIVATE2)
  double vec_Tempt_GND_Tempt_GND;
#endif
#endif
#endif
double T4a;
#if defined(_DERIVATEFORDDX)
double T4a_Vge_di;
double T4a_Vge_e;
double T4a_Vdi_si;
double T4a_Ve_si;
double T4a_Ve_di;
double T4a_Vge_si;
double T4a_Tempt_GND;
#if defined(_DERIVATE2)
  double T4a_Tempt_GND_Vge_di;
  double T4a_Tempt_GND_Vge_e;
  double T4a_Tempt_GND_Vdi_si;
  double T4a_Tempt_GND_Ve_si;
  double T4a_Tempt_GND_Ve_di;
  double T4a_Tempt_GND_Vge_si;
  double T4a_Tempt_GND_Tempt_GND;
  double T4a_Vge_si_Vge_di;
  double T4a_Vge_si_Vge_e;
  double T4a_Vge_si_Vdi_si;
  double T4a_Vge_si_Ve_si;
  double T4a_Vge_si_Ve_di;
  double T4a_Vge_si_Vge_si;
  double T4a_Vge_si_Tempt_GND;
  double T4a_Ve_di_Vge_di;
  double T4a_Ve_di_Vge_e;
  double T4a_Ve_di_Vdi_si;
  double T4a_Ve_di_Ve_si;
  double T4a_Ve_di_Ve_di;
  double T4a_Ve_di_Vge_si;
  double T4a_Ve_di_Tempt_GND;
  double T4a_Ve_si_Vge_di;
  double T4a_Ve_si_Vge_e;
  double T4a_Ve_si_Vdi_si;
  double T4a_Ve_si_Ve_si;
  double T4a_Ve_si_Ve_di;
  double T4a_Ve_si_Vge_si;
  double T4a_Ve_si_Tempt_GND;
  double T4a_Vdi_si_Vge_di;
  double T4a_Vdi_si_Vge_e;
  double T4a_Vdi_si_Vdi_si;
  double T4a_Vdi_si_Ve_si;
  double T4a_Vdi_si_Ve_di;
  double T4a_Vdi_si_Vge_si;
  double T4a_Vdi_si_Tempt_GND;
  double T4a_Vge_e_Vge_di;
  double T4a_Vge_e_Vge_e;
  double T4a_Vge_e_Vdi_si;
  double T4a_Vge_e_Ve_si;
  double T4a_Vge_e_Ve_di;
  double T4a_Vge_e_Vge_si;
  double T4a_Vge_e_Tempt_GND;
  double T4a_Vge_di_Vge_di;
  double T4a_Vge_di_Vge_e;
  double T4a_Vge_di_Vdi_si;
  double T4a_Vge_di_Ve_si;
  double T4a_Vge_di_Ve_di;
  double T4a_Vge_di_Vge_si;
  double T4a_Vge_di_Tempt_GND;
#endif
#endif
double T1_exp;
#if defined(_DERIVATEFORDDX)
double T1_exp_Vge_di;
double T1_exp_Vge_e;
double T1_exp_Ve_si;
double T1_exp_Ve_di;
double T1_exp_Vge_si;
double T1_exp_Vdi_si;
double T1_exp_Tempt_GND;
#if defined(_DERIVATE2)
  double T1_exp_Tempt_GND_Vge_di;
  double T1_exp_Tempt_GND_Vge_e;
  double T1_exp_Tempt_GND_Ve_si;
  double T1_exp_Tempt_GND_Ve_di;
  double T1_exp_Tempt_GND_Vge_si;
  double T1_exp_Tempt_GND_Vdi_si;
  double T1_exp_Tempt_GND_Tempt_GND;
  double T1_exp_Vdi_si_Vge_di;
  double T1_exp_Vdi_si_Vge_e;
  double T1_exp_Vdi_si_Ve_si;
  double T1_exp_Vdi_si_Ve_di;
  double T1_exp_Vdi_si_Vge_si;
  double T1_exp_Vdi_si_Vdi_si;
  double T1_exp_Vdi_si_Tempt_GND;
  double T1_exp_Vge_si_Vge_di;
  double T1_exp_Vge_si_Vge_e;
  double T1_exp_Vge_si_Ve_si;
  double T1_exp_Vge_si_Ve_di;
  double T1_exp_Vge_si_Vge_si;
  double T1_exp_Vge_si_Vdi_si;
  double T1_exp_Vge_si_Tempt_GND;
  double T1_exp_Ve_di_Vge_di;
  double T1_exp_Ve_di_Vge_e;
  double T1_exp_Ve_di_Ve_si;
  double T1_exp_Ve_di_Ve_di;
  double T1_exp_Ve_di_Vge_si;
  double T1_exp_Ve_di_Vdi_si;
  double T1_exp_Ve_di_Tempt_GND;
  double T1_exp_Ve_si_Vge_di;
  double T1_exp_Ve_si_Vge_e;
  double T1_exp_Ve_si_Ve_si;
  double T1_exp_Ve_si_Ve_di;
  double T1_exp_Ve_si_Vge_si;
  double T1_exp_Ve_si_Vdi_si;
  double T1_exp_Ve_si_Tempt_GND;
  double T1_exp_Vge_e_Vge_di;
  double T1_exp_Vge_e_Vge_e;
  double T1_exp_Vge_e_Ve_si;
  double T1_exp_Vge_e_Ve_di;
  double T1_exp_Vge_e_Vge_si;
  double T1_exp_Vge_e_Vdi_si;
  double T1_exp_Vge_e_Tempt_GND;
  double T1_exp_Vge_di_Vge_di;
  double T1_exp_Vge_di_Vge_e;
  double T1_exp_Vge_di_Ve_si;
  double T1_exp_Vge_di_Ve_di;
  double T1_exp_Vge_di_Vge_si;
  double T1_exp_Vge_di_Vdi_si;
  double T1_exp_Vge_di_Tempt_GND;
#endif
#endif
double Vdseffx;
#if defined(_DERIVATEFORDDX)
double Vdseffx_Vdi_si;
double Vdseffx_Ve_si;
double Vdseffx_Ve_di;
double Vdseffx_Vge_si;
double Vdseffx_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdseffx_Tempt_GND_Vdi_si;
  double Vdseffx_Tempt_GND_Ve_si;
  double Vdseffx_Tempt_GND_Ve_di;
  double Vdseffx_Tempt_GND_Vge_si;
  double Vdseffx_Tempt_GND_Tempt_GND;
  double Vdseffx_Vge_si_Vdi_si;
  double Vdseffx_Vge_si_Ve_si;
  double Vdseffx_Vge_si_Ve_di;
  double Vdseffx_Vge_si_Vge_si;
  double Vdseffx_Vge_si_Tempt_GND;
  double Vdseffx_Ve_di_Vdi_si;
  double Vdseffx_Ve_di_Ve_si;
  double Vdseffx_Ve_di_Ve_di;
  double Vdseffx_Ve_di_Vge_si;
  double Vdseffx_Ve_di_Tempt_GND;
  double Vdseffx_Ve_si_Vdi_si;
  double Vdseffx_Ve_si_Ve_si;
  double Vdseffx_Ve_si_Ve_di;
  double Vdseffx_Ve_si_Vge_si;
  double Vdseffx_Ve_si_Tempt_GND;
  double Vdseffx_Vdi_si_Vdi_si;
  double Vdseffx_Vdi_si_Ve_si;
  double Vdseffx_Vdi_si_Ve_di;
  double Vdseffx_Vdi_si_Vge_si;
  double Vdseffx_Vdi_si_Tempt_GND;
#endif
#endif
double igc0;
#if defined(_DERIVATEFORDDX)
double igc0_Vge_di;
double igc0_Vge_e;
double igc0_Vdi_si;
double igc0_Ve_si;
double igc0_Ve_di;
double igc0_Vge_si;
double igc0_Tempt_GND;
double igc0_Vdi_d;
double igc0_Vsi_s;
#if defined(_DERIVATE2)
  double igc0_Vsi_s_Vge_di;
  double igc0_Vsi_s_Vge_e;
  double igc0_Vsi_s_Vdi_si;
  double igc0_Vsi_s_Ve_si;
  double igc0_Vsi_s_Ve_di;
  double igc0_Vsi_s_Vge_si;
  double igc0_Vsi_s_Tempt_GND;
  double igc0_Vsi_s_Vdi_d;
  double igc0_Vsi_s_Vsi_s;
  double igc0_Vdi_d_Vge_di;
  double igc0_Vdi_d_Vge_e;
  double igc0_Vdi_d_Vdi_si;
  double igc0_Vdi_d_Ve_si;
  double igc0_Vdi_d_Ve_di;
  double igc0_Vdi_d_Vge_si;
  double igc0_Vdi_d_Tempt_GND;
  double igc0_Vdi_d_Vdi_d;
  double igc0_Vdi_d_Vsi_s;
  double igc0_Tempt_GND_Vge_di;
  double igc0_Tempt_GND_Vge_e;
  double igc0_Tempt_GND_Vdi_si;
  double igc0_Tempt_GND_Ve_si;
  double igc0_Tempt_GND_Ve_di;
  double igc0_Tempt_GND_Vge_si;
  double igc0_Tempt_GND_Tempt_GND;
  double igc0_Tempt_GND_Vdi_d;
  double igc0_Tempt_GND_Vsi_s;
  double igc0_Vge_si_Vge_di;
  double igc0_Vge_si_Vge_e;
  double igc0_Vge_si_Vdi_si;
  double igc0_Vge_si_Ve_si;
  double igc0_Vge_si_Ve_di;
  double igc0_Vge_si_Vge_si;
  double igc0_Vge_si_Tempt_GND;
  double igc0_Vge_si_Vdi_d;
  double igc0_Vge_si_Vsi_s;
  double igc0_Ve_di_Vge_di;
  double igc0_Ve_di_Vge_e;
  double igc0_Ve_di_Vdi_si;
  double igc0_Ve_di_Ve_si;
  double igc0_Ve_di_Ve_di;
  double igc0_Ve_di_Vge_si;
  double igc0_Ve_di_Tempt_GND;
  double igc0_Ve_di_Vdi_d;
  double igc0_Ve_di_Vsi_s;
  double igc0_Ve_si_Vge_di;
  double igc0_Ve_si_Vge_e;
  double igc0_Ve_si_Vdi_si;
  double igc0_Ve_si_Ve_si;
  double igc0_Ve_si_Ve_di;
  double igc0_Ve_si_Vge_si;
  double igc0_Ve_si_Tempt_GND;
  double igc0_Ve_si_Vdi_d;
  double igc0_Ve_si_Vsi_s;
  double igc0_Vdi_si_Vge_di;
  double igc0_Vdi_si_Vge_e;
  double igc0_Vdi_si_Vdi_si;
  double igc0_Vdi_si_Ve_si;
  double igc0_Vdi_si_Ve_di;
  double igc0_Vdi_si_Vge_si;
  double igc0_Vdi_si_Tempt_GND;
  double igc0_Vdi_si_Vdi_d;
  double igc0_Vdi_si_Vsi_s;
  double igc0_Vge_e_Vge_di;
  double igc0_Vge_e_Vge_e;
  double igc0_Vge_e_Vdi_si;
  double igc0_Vge_e_Ve_si;
  double igc0_Vge_e_Ve_di;
  double igc0_Vge_e_Vge_si;
  double igc0_Vge_e_Tempt_GND;
  double igc0_Vge_e_Vdi_d;
  double igc0_Vge_e_Vsi_s;
  double igc0_Vge_di_Vge_di;
  double igc0_Vge_di_Vge_e;
  double igc0_Vge_di_Vdi_si;
  double igc0_Vge_di_Ve_si;
  double igc0_Vge_di_Ve_di;
  double igc0_Vge_di_Vge_si;
  double igc0_Vge_di_Tempt_GND;
  double igc0_Vge_di_Vdi_d;
  double igc0_Vge_di_Vsi_s;
#endif
#endif
double Voxacc;
#if defined(_DERIVATEFORDDX)
double Voxacc_Vge_di;
double Voxacc_Tempt_GND;
double Voxacc_Vdi_si;
double Voxacc_Vge_e;
double Voxacc_Ve_si;
double Voxacc_Ve_di;
double Voxacc_Vge_si;
#if defined(_DERIVATE2)
  double Voxacc_Vge_si_Vge_di;
  double Voxacc_Vge_si_Tempt_GND;
  double Voxacc_Vge_si_Vdi_si;
  double Voxacc_Vge_si_Vge_e;
  double Voxacc_Vge_si_Ve_si;
  double Voxacc_Vge_si_Ve_di;
  double Voxacc_Vge_si_Vge_si;
  double Voxacc_Ve_di_Vge_di;
  double Voxacc_Ve_di_Tempt_GND;
  double Voxacc_Ve_di_Vdi_si;
  double Voxacc_Ve_di_Vge_e;
  double Voxacc_Ve_di_Ve_si;
  double Voxacc_Ve_di_Ve_di;
  double Voxacc_Ve_di_Vge_si;
  double Voxacc_Ve_si_Vge_di;
  double Voxacc_Ve_si_Tempt_GND;
  double Voxacc_Ve_si_Vdi_si;
  double Voxacc_Ve_si_Vge_e;
  double Voxacc_Ve_si_Ve_si;
  double Voxacc_Ve_si_Ve_di;
  double Voxacc_Ve_si_Vge_si;
  double Voxacc_Vge_e_Vge_di;
  double Voxacc_Vge_e_Tempt_GND;
  double Voxacc_Vge_e_Vdi_si;
  double Voxacc_Vge_e_Vge_e;
  double Voxacc_Vge_e_Ve_si;
  double Voxacc_Vge_e_Ve_di;
  double Voxacc_Vge_e_Vge_si;
  double Voxacc_Vdi_si_Vge_di;
  double Voxacc_Vdi_si_Tempt_GND;
  double Voxacc_Vdi_si_Vdi_si;
  double Voxacc_Vdi_si_Vge_e;
  double Voxacc_Vdi_si_Ve_si;
  double Voxacc_Vdi_si_Ve_di;
  double Voxacc_Vdi_si_Vge_si;
  double Voxacc_Tempt_GND_Vge_di;
  double Voxacc_Tempt_GND_Tempt_GND;
  double Voxacc_Tempt_GND_Vdi_si;
  double Voxacc_Tempt_GND_Vge_e;
  double Voxacc_Tempt_GND_Ve_si;
  double Voxacc_Tempt_GND_Ve_di;
  double Voxacc_Tempt_GND_Vge_si;
  double Voxacc_Vge_di_Vge_di;
  double Voxacc_Vge_di_Tempt_GND;
  double Voxacc_Vge_di_Vdi_si;
  double Voxacc_Vge_di_Vge_e;
  double Voxacc_Vge_di_Ve_si;
  double Voxacc_Vge_di_Ve_di;
  double Voxacc_Vge_di_Vge_si;
#endif
#endif
double Vaux_Igbacc;
#if defined(_DERIVATE)
double Vaux_Igbacc_Tempt_GND;
double Vaux_Igbacc_Vge_di;
double Vaux_Igbacc_Vge_e;
double Vaux_Igbacc_Ve_si;
double Vaux_Igbacc_Ve_di;
double Vaux_Igbacc_Vge_si;
double Vaux_Igbacc_Vdi_si;
#endif
double vfbzb;
#if defined(_DERIVATEFORDDX)
double vfbzb_Tempt_GND;
#if defined(_DERIVATE2)
  double vfbzb_Tempt_GND_Tempt_GND;
#endif
#endif
double Vaux_Igbinv;
#if defined(_DERIVATE)
double Vaux_Igbinv_Tempt_GND;
double Vaux_Igbinv_Vge_di;
double Vaux_Igbinv_Vge_e;
double Vaux_Igbinv_Ve_si;
double Vaux_Igbinv_Ve_di;
double Vaux_Igbinv_Vge_si;
double Vaux_Igbinv_Vdi_si;
#endif
double Ratio;
#if defined(_DERIVATEFORDDX)
double Ratio_Tempt_GND;
double Ratio_Vdi_si;
double Ratio_Vge_di;
double Ratio_Vge_e;
double Ratio_Ve_si;
double Ratio_Ve_di;
double Ratio_Vge_si;
#if defined(_DERIVATE2)
  double Ratio_Vge_si_Tempt_GND;
  double Ratio_Vge_si_Vdi_si;
  double Ratio_Vge_si_Vge_di;
  double Ratio_Vge_si_Vge_e;
  double Ratio_Vge_si_Ve_si;
  double Ratio_Vge_si_Ve_di;
  double Ratio_Vge_si_Vge_si;
  double Ratio_Ve_di_Tempt_GND;
  double Ratio_Ve_di_Vdi_si;
  double Ratio_Ve_di_Vge_di;
  double Ratio_Ve_di_Vge_e;
  double Ratio_Ve_di_Ve_si;
  double Ratio_Ve_di_Ve_di;
  double Ratio_Ve_di_Vge_si;
  double Ratio_Ve_si_Tempt_GND;
  double Ratio_Ve_si_Vdi_si;
  double Ratio_Ve_si_Vge_di;
  double Ratio_Ve_si_Vge_e;
  double Ratio_Ve_si_Ve_si;
  double Ratio_Ve_si_Ve_di;
  double Ratio_Ve_si_Vge_si;
  double Ratio_Vge_e_Tempt_GND;
  double Ratio_Vge_e_Vdi_si;
  double Ratio_Vge_e_Vge_di;
  double Ratio_Vge_e_Vge_e;
  double Ratio_Vge_e_Ve_si;
  double Ratio_Vge_e_Ve_di;
  double Ratio_Vge_e_Vge_si;
  double Ratio_Vge_di_Tempt_GND;
  double Ratio_Vge_di_Vdi_si;
  double Ratio_Vge_di_Vge_di;
  double Ratio_Vge_di_Vge_e;
  double Ratio_Vge_di_Ve_si;
  double Ratio_Vge_di_Ve_di;
  double Ratio_Vge_di_Vge_si;
  double Ratio_Vdi_si_Tempt_GND;
  double Ratio_Vdi_si_Vdi_si;
  double Ratio_Vdi_si_Vge_di;
  double Ratio_Vdi_si_Vge_e;
  double Ratio_Vdi_si_Ve_si;
  double Ratio_Vdi_si_Ve_di;
  double Ratio_Vdi_si_Vge_si;
  double Ratio_Tempt_GND_Tempt_GND;
  double Ratio_Tempt_GND_Vdi_si;
  double Ratio_Tempt_GND_Vge_di;
  double Ratio_Tempt_GND_Vge_e;
  double Ratio_Tempt_GND_Ve_si;
  double Ratio_Tempt_GND_Ve_di;
  double Ratio_Tempt_GND_Vge_si;
#endif
#endif
double Vdiff;
#if defined(_DERIVATEFORDDX)
double Vdiff_Vdi_si;
double Vdiff_Vge_di;
double Vdiff_Vge_e;
double Vdiff_Ve_si;
double Vdiff_Ve_di;
double Vdiff_Vge_si;
double Vdiff_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdiff_Tempt_GND_Vdi_si;
  double Vdiff_Tempt_GND_Vge_di;
  double Vdiff_Tempt_GND_Vge_e;
  double Vdiff_Tempt_GND_Ve_si;
  double Vdiff_Tempt_GND_Ve_di;
  double Vdiff_Tempt_GND_Vge_si;
  double Vdiff_Tempt_GND_Tempt_GND;
  double Vdiff_Vge_si_Vdi_si;
  double Vdiff_Vge_si_Vge_di;
  double Vdiff_Vge_si_Vge_e;
  double Vdiff_Vge_si_Ve_si;
  double Vdiff_Vge_si_Ve_di;
  double Vdiff_Vge_si_Vge_si;
  double Vdiff_Vge_si_Tempt_GND;
  double Vdiff_Ve_di_Vdi_si;
  double Vdiff_Ve_di_Vge_di;
  double Vdiff_Ve_di_Vge_e;
  double Vdiff_Ve_di_Ve_si;
  double Vdiff_Ve_di_Ve_di;
  double Vdiff_Ve_di_Vge_si;
  double Vdiff_Ve_di_Tempt_GND;
  double Vdiff_Ve_si_Vdi_si;
  double Vdiff_Ve_si_Vge_di;
  double Vdiff_Ve_si_Vge_e;
  double Vdiff_Ve_si_Ve_si;
  double Vdiff_Ve_si_Ve_di;
  double Vdiff_Ve_si_Vge_si;
  double Vdiff_Ve_si_Tempt_GND;
  double Vdiff_Vge_e_Vdi_si;
  double Vdiff_Vge_e_Vge_di;
  double Vdiff_Vge_e_Vge_e;
  double Vdiff_Vge_e_Ve_si;
  double Vdiff_Vge_e_Ve_di;
  double Vdiff_Vge_e_Vge_si;
  double Vdiff_Vge_e_Tempt_GND;
  double Vdiff_Vge_di_Vdi_si;
  double Vdiff_Vge_di_Vge_di;
  double Vdiff_Vge_di_Vge_e;
  double Vdiff_Vge_di_Ve_si;
  double Vdiff_Vge_di_Ve_di;
  double Vdiff_Vge_di_Vge_si;
  double Vdiff_Vge_di_Tempt_GND;
  double Vdiff_Vdi_si_Vdi_si;
  double Vdiff_Vdi_si_Vge_di;
  double Vdiff_Vdi_si_Vge_e;
  double Vdiff_Vdi_si_Ve_si;
  double Vdiff_Vdi_si_Ve_di;
  double Vdiff_Vdi_si_Vge_si;
  double Vdiff_Vdi_si_Tempt_GND;
#endif
#endif
double Vdsatii;
#if defined(_DERIVATEFORDDX)
double Vdsatii_Vge_di;
double Vdsatii_Vge_e;
double Vdsatii_Ve_si;
double Vdsatii_Ve_di;
double Vdsatii_Vge_si;
double Vdsatii_Vdi_si;
double Vdsatii_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdsatii_Tempt_GND_Vge_di;
  double Vdsatii_Tempt_GND_Vge_e;
  double Vdsatii_Tempt_GND_Ve_si;
  double Vdsatii_Tempt_GND_Ve_di;
  double Vdsatii_Tempt_GND_Vge_si;
  double Vdsatii_Tempt_GND_Vdi_si;
  double Vdsatii_Tempt_GND_Tempt_GND;
  double Vdsatii_Vdi_si_Vge_di;
  double Vdsatii_Vdi_si_Vge_e;
  double Vdsatii_Vdi_si_Ve_si;
  double Vdsatii_Vdi_si_Ve_di;
  double Vdsatii_Vdi_si_Vge_si;
  double Vdsatii_Vdi_si_Vdi_si;
  double Vdsatii_Vdi_si_Tempt_GND;
  double Vdsatii_Vge_si_Vge_di;
  double Vdsatii_Vge_si_Vge_e;
  double Vdsatii_Vge_si_Ve_si;
  double Vdsatii_Vge_si_Ve_di;
  double Vdsatii_Vge_si_Vge_si;
  double Vdsatii_Vge_si_Vdi_si;
  double Vdsatii_Vge_si_Tempt_GND;
  double Vdsatii_Ve_di_Vge_di;
  double Vdsatii_Ve_di_Vge_e;
  double Vdsatii_Ve_di_Ve_si;
  double Vdsatii_Ve_di_Ve_di;
  double Vdsatii_Ve_di_Vge_si;
  double Vdsatii_Ve_di_Vdi_si;
  double Vdsatii_Ve_di_Tempt_GND;
  double Vdsatii_Ve_si_Vge_di;
  double Vdsatii_Ve_si_Vge_e;
  double Vdsatii_Ve_si_Ve_si;
  double Vdsatii_Ve_si_Ve_di;
  double Vdsatii_Ve_si_Vge_si;
  double Vdsatii_Ve_si_Vdi_si;
  double Vdsatii_Ve_si_Tempt_GND;
  double Vdsatii_Vge_e_Vge_di;
  double Vdsatii_Vge_e_Vge_e;
  double Vdsatii_Vge_e_Ve_si;
  double Vdsatii_Vge_e_Ve_di;
  double Vdsatii_Vge_e_Vge_si;
  double Vdsatii_Vge_e_Vdi_si;
  double Vdsatii_Vge_e_Tempt_GND;
  double Vdsatii_Vge_di_Vge_di;
  double Vdsatii_Vge_di_Vge_e;
  double Vdsatii_Vge_di_Ve_si;
  double Vdsatii_Vge_di_Ve_di;
  double Vdsatii_Vge_di_Vge_si;
  double Vdsatii_Vge_di_Vdi_si;
  double Vdsatii_Vge_di_Tempt_GND;
#endif
#endif
double VgsStep;
#if defined(_DERIVATEFORDDX)
double VgsStep_Vge_di;
double VgsStep_Vge_e;
double VgsStep_Ve_si;
double VgsStep_Ve_di;
double VgsStep_Vge_si;
double VgsStep_Vdi_si;
double VgsStep_Tempt_GND;
#if defined(_DERIVATE2)
  double VgsStep_Tempt_GND_Vge_di;
  double VgsStep_Tempt_GND_Vge_e;
  double VgsStep_Tempt_GND_Ve_si;
  double VgsStep_Tempt_GND_Ve_di;
  double VgsStep_Tempt_GND_Vge_si;
  double VgsStep_Tempt_GND_Vdi_si;
  double VgsStep_Tempt_GND_Tempt_GND;
  double VgsStep_Vdi_si_Vge_di;
  double VgsStep_Vdi_si_Vge_e;
  double VgsStep_Vdi_si_Ve_si;
  double VgsStep_Vdi_si_Ve_di;
  double VgsStep_Vdi_si_Vge_si;
  double VgsStep_Vdi_si_Vdi_si;
  double VgsStep_Vdi_si_Tempt_GND;
  double VgsStep_Vge_si_Vge_di;
  double VgsStep_Vge_si_Vge_e;
  double VgsStep_Vge_si_Ve_si;
  double VgsStep_Vge_si_Ve_di;
  double VgsStep_Vge_si_Vge_si;
  double VgsStep_Vge_si_Vdi_si;
  double VgsStep_Vge_si_Tempt_GND;
  double VgsStep_Ve_di_Vge_di;
  double VgsStep_Ve_di_Vge_e;
  double VgsStep_Ve_di_Ve_si;
  double VgsStep_Ve_di_Ve_di;
  double VgsStep_Ve_di_Vge_si;
  double VgsStep_Ve_di_Vdi_si;
  double VgsStep_Ve_di_Tempt_GND;
  double VgsStep_Ve_si_Vge_di;
  double VgsStep_Ve_si_Vge_e;
  double VgsStep_Ve_si_Ve_si;
  double VgsStep_Ve_si_Ve_di;
  double VgsStep_Ve_si_Vge_si;
  double VgsStep_Ve_si_Vdi_si;
  double VgsStep_Ve_si_Tempt_GND;
  double VgsStep_Vge_e_Vge_di;
  double VgsStep_Vge_e_Vge_e;
  double VgsStep_Vge_e_Ve_si;
  double VgsStep_Vge_e_Ve_di;
  double VgsStep_Vge_e_Vge_si;
  double VgsStep_Vge_e_Vdi_si;
  double VgsStep_Vge_e_Tempt_GND;
  double VgsStep_Vge_di_Vge_di;
  double VgsStep_Vge_di_Vge_e;
  double VgsStep_Vge_di_Ve_si;
  double VgsStep_Vge_di_Ve_di;
  double VgsStep_Vge_di_Vge_si;
  double VgsStep_Vge_di_Vdi_si;
  double VgsStep_Vge_di_Tempt_GND;
#endif
#endif
double ALPHAII;
#if defined(_DERIVATEFORDDX)
double ALPHAII_Tempt_GND;
#if defined(_DERIVATE2)
  double ALPHAII_Tempt_GND_Tempt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double cgdp;
#if defined(_DERIVATEFORDDX)
double cgdp_Vge_di;
double cgdp_Vge_e;
double cgdp_Ve_si;
double cgdp_Ve_di;
double cgdp_Vge_si;
double cgdp_Vdi_si;
double cgdp_Tempt_GND;
#if defined(_DERIVATE2)
  double cgdp_Tempt_GND_Vge_di;
  double cgdp_Tempt_GND_Vge_e;
  double cgdp_Tempt_GND_Ve_si;
  double cgdp_Tempt_GND_Ve_di;
  double cgdp_Tempt_GND_Vge_si;
  double cgdp_Tempt_GND_Vdi_si;
  double cgdp_Tempt_GND_Tempt_GND;
  double cgdp_Vdi_si_Vge_di;
  double cgdp_Vdi_si_Vge_e;
  double cgdp_Vdi_si_Ve_si;
  double cgdp_Vdi_si_Ve_di;
  double cgdp_Vdi_si_Vge_si;
  double cgdp_Vdi_si_Vdi_si;
  double cgdp_Vdi_si_Tempt_GND;
  double cgdp_Vge_si_Vge_di;
  double cgdp_Vge_si_Vge_e;
  double cgdp_Vge_si_Ve_si;
  double cgdp_Vge_si_Ve_di;
  double cgdp_Vge_si_Vge_si;
  double cgdp_Vge_si_Vdi_si;
  double cgdp_Vge_si_Tempt_GND;
  double cgdp_Ve_di_Vge_di;
  double cgdp_Ve_di_Vge_e;
  double cgdp_Ve_di_Ve_si;
  double cgdp_Ve_di_Ve_di;
  double cgdp_Ve_di_Vge_si;
  double cgdp_Ve_di_Vdi_si;
  double cgdp_Ve_di_Tempt_GND;
  double cgdp_Ve_si_Vge_di;
  double cgdp_Ve_si_Vge_e;
  double cgdp_Ve_si_Ve_si;
  double cgdp_Ve_si_Ve_di;
  double cgdp_Ve_si_Vge_si;
  double cgdp_Ve_si_Vdi_si;
  double cgdp_Ve_si_Tempt_GND;
  double cgdp_Vge_e_Vge_di;
  double cgdp_Vge_e_Vge_e;
  double cgdp_Vge_e_Ve_si;
  double cgdp_Vge_e_Ve_di;
  double cgdp_Vge_e_Vge_si;
  double cgdp_Vge_e_Vdi_si;
  double cgdp_Vge_e_Tempt_GND;
  double cgdp_Vge_di_Vge_di;
  double cgdp_Vge_di_Vge_e;
  double cgdp_Vge_di_Ve_si;
  double cgdp_Vge_di_Ve_di;
  double cgdp_Vge_di_Vge_si;
  double cgdp_Vge_di_Vdi_si;
  double cgdp_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double cgsp;
#if defined(_DERIVATEFORDDX)
double cgsp_Vge_di;
double cgsp_Vge_e;
double cgsp_Ve_si;
double cgsp_Ve_di;
double cgsp_Vge_si;
double cgsp_Vdi_si;
double cgsp_Tempt_GND;
#if defined(_DERIVATE2)
  double cgsp_Tempt_GND_Vge_di;
  double cgsp_Tempt_GND_Vge_e;
  double cgsp_Tempt_GND_Ve_si;
  double cgsp_Tempt_GND_Ve_di;
  double cgsp_Tempt_GND_Vge_si;
  double cgsp_Tempt_GND_Vdi_si;
  double cgsp_Tempt_GND_Tempt_GND;
  double cgsp_Vdi_si_Vge_di;
  double cgsp_Vdi_si_Vge_e;
  double cgsp_Vdi_si_Ve_si;
  double cgsp_Vdi_si_Ve_di;
  double cgsp_Vdi_si_Vge_si;
  double cgsp_Vdi_si_Vdi_si;
  double cgsp_Vdi_si_Tempt_GND;
  double cgsp_Vge_si_Vge_di;
  double cgsp_Vge_si_Vge_e;
  double cgsp_Vge_si_Ve_si;
  double cgsp_Vge_si_Ve_di;
  double cgsp_Vge_si_Vge_si;
  double cgsp_Vge_si_Vdi_si;
  double cgsp_Vge_si_Tempt_GND;
  double cgsp_Ve_di_Vge_di;
  double cgsp_Ve_di_Vge_e;
  double cgsp_Ve_di_Ve_si;
  double cgsp_Ve_di_Ve_di;
  double cgsp_Ve_di_Vge_si;
  double cgsp_Ve_di_Vdi_si;
  double cgsp_Ve_di_Tempt_GND;
  double cgsp_Ve_si_Vge_di;
  double cgsp_Ve_si_Vge_e;
  double cgsp_Ve_si_Ve_si;
  double cgsp_Ve_si_Ve_di;
  double cgsp_Ve_si_Vge_si;
  double cgsp_Ve_si_Vdi_si;
  double cgsp_Ve_si_Tempt_GND;
  double cgsp_Vge_e_Vge_di;
  double cgsp_Vge_e_Vge_e;
  double cgsp_Vge_e_Ve_si;
  double cgsp_Vge_e_Ve_di;
  double cgsp_Vge_e_Vge_si;
  double cgsp_Vge_e_Vdi_si;
  double cgsp_Vge_e_Tempt_GND;
  double cgsp_Vge_di_Vge_di;
  double cgsp_Vge_di_Vge_e;
  double cgsp_Vge_di_Ve_si;
  double cgsp_Vge_di_Ve_di;
  double cgsp_Vge_di_Vge_si;
  double cgsp_Vge_di_Vdi_si;
  double cgsp_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double vgd_overlap;
#if defined(_DERIVATEFORDDX)
double vgd_overlap_Vge_di;
double vgd_overlap_Vge_e;
double vgd_overlap_Ve_si;
double vgd_overlap_Ve_di;
double vgd_overlap_Vge_si;
double vgd_overlap_Vdi_si;
double vgd_overlap_Tempt_GND;
#if defined(_DERIVATE2)
  double vgd_overlap_Tempt_GND_Vge_di;
  double vgd_overlap_Tempt_GND_Vge_e;
  double vgd_overlap_Tempt_GND_Ve_si;
  double vgd_overlap_Tempt_GND_Ve_di;
  double vgd_overlap_Tempt_GND_Vge_si;
  double vgd_overlap_Tempt_GND_Vdi_si;
  double vgd_overlap_Tempt_GND_Tempt_GND;
  double vgd_overlap_Vdi_si_Vge_di;
  double vgd_overlap_Vdi_si_Vge_e;
  double vgd_overlap_Vdi_si_Ve_si;
  double vgd_overlap_Vdi_si_Ve_di;
  double vgd_overlap_Vdi_si_Vge_si;
  double vgd_overlap_Vdi_si_Vdi_si;
  double vgd_overlap_Vdi_si_Tempt_GND;
  double vgd_overlap_Vge_si_Vge_di;
  double vgd_overlap_Vge_si_Vge_e;
  double vgd_overlap_Vge_si_Ve_si;
  double vgd_overlap_Vge_si_Ve_di;
  double vgd_overlap_Vge_si_Vge_si;
  double vgd_overlap_Vge_si_Vdi_si;
  double vgd_overlap_Vge_si_Tempt_GND;
  double vgd_overlap_Ve_di_Vge_di;
  double vgd_overlap_Ve_di_Vge_e;
  double vgd_overlap_Ve_di_Ve_si;
  double vgd_overlap_Ve_di_Ve_di;
  double vgd_overlap_Ve_di_Vge_si;
  double vgd_overlap_Ve_di_Vdi_si;
  double vgd_overlap_Ve_di_Tempt_GND;
  double vgd_overlap_Ve_si_Vge_di;
  double vgd_overlap_Ve_si_Vge_e;
  double vgd_overlap_Ve_si_Ve_si;
  double vgd_overlap_Ve_si_Ve_di;
  double vgd_overlap_Ve_si_Vge_si;
  double vgd_overlap_Ve_si_Vdi_si;
  double vgd_overlap_Ve_si_Tempt_GND;
  double vgd_overlap_Vge_e_Vge_di;
  double vgd_overlap_Vge_e_Vge_e;
  double vgd_overlap_Vge_e_Ve_si;
  double vgd_overlap_Vge_e_Ve_di;
  double vgd_overlap_Vge_e_Vge_si;
  double vgd_overlap_Vge_e_Vdi_si;
  double vgd_overlap_Vge_e_Tempt_GND;
  double vgd_overlap_Vge_di_Vge_di;
  double vgd_overlap_Vge_di_Vge_e;
  double vgd_overlap_Vge_di_Ve_si;
  double vgd_overlap_Vge_di_Ve_di;
  double vgd_overlap_Vge_di_Vge_si;
  double vgd_overlap_Vge_di_Vdi_si;
  double vgd_overlap_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double vgs_overlap;
#if defined(_DERIVATEFORDDX)
double vgs_overlap_Vge_di;
double vgs_overlap_Vge_e;
double vgs_overlap_Ve_si;
double vgs_overlap_Ve_di;
double vgs_overlap_Vge_si;
double vgs_overlap_Vdi_si;
double vgs_overlap_Tempt_GND;
#if defined(_DERIVATE2)
  double vgs_overlap_Tempt_GND_Vge_di;
  double vgs_overlap_Tempt_GND_Vge_e;
  double vgs_overlap_Tempt_GND_Ve_si;
  double vgs_overlap_Tempt_GND_Ve_di;
  double vgs_overlap_Tempt_GND_Vge_si;
  double vgs_overlap_Tempt_GND_Vdi_si;
  double vgs_overlap_Tempt_GND_Tempt_GND;
  double vgs_overlap_Vdi_si_Vge_di;
  double vgs_overlap_Vdi_si_Vge_e;
  double vgs_overlap_Vdi_si_Ve_si;
  double vgs_overlap_Vdi_si_Ve_di;
  double vgs_overlap_Vdi_si_Vge_si;
  double vgs_overlap_Vdi_si_Vdi_si;
  double vgs_overlap_Vdi_si_Tempt_GND;
  double vgs_overlap_Vge_si_Vge_di;
  double vgs_overlap_Vge_si_Vge_e;
  double vgs_overlap_Vge_si_Ve_si;
  double vgs_overlap_Vge_si_Ve_di;
  double vgs_overlap_Vge_si_Vge_si;
  double vgs_overlap_Vge_si_Vdi_si;
  double vgs_overlap_Vge_si_Tempt_GND;
  double vgs_overlap_Ve_di_Vge_di;
  double vgs_overlap_Ve_di_Vge_e;
  double vgs_overlap_Ve_di_Ve_si;
  double vgs_overlap_Ve_di_Ve_di;
  double vgs_overlap_Ve_di_Vge_si;
  double vgs_overlap_Ve_di_Vdi_si;
  double vgs_overlap_Ve_di_Tempt_GND;
  double vgs_overlap_Ve_si_Vge_di;
  double vgs_overlap_Ve_si_Vge_e;
  double vgs_overlap_Ve_si_Ve_si;
  double vgs_overlap_Ve_si_Ve_di;
  double vgs_overlap_Ve_si_Vge_si;
  double vgs_overlap_Ve_si_Vdi_si;
  double vgs_overlap_Ve_si_Tempt_GND;
  double vgs_overlap_Vge_e_Vge_di;
  double vgs_overlap_Vge_e_Vge_e;
  double vgs_overlap_Vge_e_Ve_si;
  double vgs_overlap_Vge_e_Ve_di;
  double vgs_overlap_Vge_e_Vge_si;
  double vgs_overlap_Vge_e_Vdi_si;
  double vgs_overlap_Vge_e_Tempt_GND;
  double vgs_overlap_Vge_di_Vge_di;
  double vgs_overlap_Vge_di_Vge_e;
  double vgs_overlap_Vge_di_Ve_si;
  double vgs_overlap_Vge_di_Ve_di;
  double vgs_overlap_Vge_di_Vge_si;
  double vgs_overlap_Vge_di_Vdi_si;
  double vgs_overlap_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qgd_ov;
#if defined(_DERIVATEFORDDX)
double qgd_ov_Vge_di;
double qgd_ov_Vge_e;
double qgd_ov_Ve_si;
double qgd_ov_Ve_di;
double qgd_ov_Vge_si;
double qgd_ov_Vdi_si;
double qgd_ov_Tempt_GND;
#if defined(_DERIVATE2)
  double qgd_ov_Tempt_GND_Vge_di;
  double qgd_ov_Tempt_GND_Vge_e;
  double qgd_ov_Tempt_GND_Ve_si;
  double qgd_ov_Tempt_GND_Ve_di;
  double qgd_ov_Tempt_GND_Vge_si;
  double qgd_ov_Tempt_GND_Vdi_si;
  double qgd_ov_Tempt_GND_Tempt_GND;
  double qgd_ov_Vdi_si_Vge_di;
  double qgd_ov_Vdi_si_Vge_e;
  double qgd_ov_Vdi_si_Ve_si;
  double qgd_ov_Vdi_si_Ve_di;
  double qgd_ov_Vdi_si_Vge_si;
  double qgd_ov_Vdi_si_Vdi_si;
  double qgd_ov_Vdi_si_Tempt_GND;
  double qgd_ov_Vge_si_Vge_di;
  double qgd_ov_Vge_si_Vge_e;
  double qgd_ov_Vge_si_Ve_si;
  double qgd_ov_Vge_si_Ve_di;
  double qgd_ov_Vge_si_Vge_si;
  double qgd_ov_Vge_si_Vdi_si;
  double qgd_ov_Vge_si_Tempt_GND;
  double qgd_ov_Ve_di_Vge_di;
  double qgd_ov_Ve_di_Vge_e;
  double qgd_ov_Ve_di_Ve_si;
  double qgd_ov_Ve_di_Ve_di;
  double qgd_ov_Ve_di_Vge_si;
  double qgd_ov_Ve_di_Vdi_si;
  double qgd_ov_Ve_di_Tempt_GND;
  double qgd_ov_Ve_si_Vge_di;
  double qgd_ov_Ve_si_Vge_e;
  double qgd_ov_Ve_si_Ve_si;
  double qgd_ov_Ve_si_Ve_di;
  double qgd_ov_Ve_si_Vge_si;
  double qgd_ov_Ve_si_Vdi_si;
  double qgd_ov_Ve_si_Tempt_GND;
  double qgd_ov_Vge_e_Vge_di;
  double qgd_ov_Vge_e_Vge_e;
  double qgd_ov_Vge_e_Ve_si;
  double qgd_ov_Vge_e_Ve_di;
  double qgd_ov_Vge_e_Vge_si;
  double qgd_ov_Vge_e_Vdi_si;
  double qgd_ov_Vge_e_Tempt_GND;
  double qgd_ov_Vge_di_Vge_di;
  double qgd_ov_Vge_di_Vge_e;
  double qgd_ov_Vge_di_Ve_si;
  double qgd_ov_Vge_di_Ve_di;
  double qgd_ov_Vge_di_Vge_si;
  double qgd_ov_Vge_di_Vdi_si;
  double qgd_ov_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qgs_ov;
#if defined(_DERIVATEFORDDX)
double qgs_ov_Vge_di;
double qgs_ov_Vge_e;
double qgs_ov_Ve_si;
double qgs_ov_Ve_di;
double qgs_ov_Vge_si;
double qgs_ov_Vdi_si;
double qgs_ov_Tempt_GND;
#if defined(_DERIVATE2)
  double qgs_ov_Tempt_GND_Vge_di;
  double qgs_ov_Tempt_GND_Vge_e;
  double qgs_ov_Tempt_GND_Ve_si;
  double qgs_ov_Tempt_GND_Ve_di;
  double qgs_ov_Tempt_GND_Vge_si;
  double qgs_ov_Tempt_GND_Vdi_si;
  double qgs_ov_Tempt_GND_Tempt_GND;
  double qgs_ov_Vdi_si_Vge_di;
  double qgs_ov_Vdi_si_Vge_e;
  double qgs_ov_Vdi_si_Ve_si;
  double qgs_ov_Vdi_si_Ve_di;
  double qgs_ov_Vdi_si_Vge_si;
  double qgs_ov_Vdi_si_Vdi_si;
  double qgs_ov_Vdi_si_Tempt_GND;
  double qgs_ov_Vge_si_Vge_di;
  double qgs_ov_Vge_si_Vge_e;
  double qgs_ov_Vge_si_Ve_si;
  double qgs_ov_Vge_si_Ve_di;
  double qgs_ov_Vge_si_Vge_si;
  double qgs_ov_Vge_si_Vdi_si;
  double qgs_ov_Vge_si_Tempt_GND;
  double qgs_ov_Ve_di_Vge_di;
  double qgs_ov_Ve_di_Vge_e;
  double qgs_ov_Ve_di_Ve_si;
  double qgs_ov_Ve_di_Ve_di;
  double qgs_ov_Ve_di_Vge_si;
  double qgs_ov_Ve_di_Vdi_si;
  double qgs_ov_Ve_di_Tempt_GND;
  double qgs_ov_Ve_si_Vge_di;
  double qgs_ov_Ve_si_Vge_e;
  double qgs_ov_Ve_si_Ve_si;
  double qgs_ov_Ve_si_Ve_di;
  double qgs_ov_Ve_si_Vge_si;
  double qgs_ov_Ve_si_Vdi_si;
  double qgs_ov_Ve_si_Tempt_GND;
  double qgs_ov_Vge_e_Vge_di;
  double qgs_ov_Vge_e_Vge_e;
  double qgs_ov_Vge_e_Ve_si;
  double qgs_ov_Vge_e_Ve_di;
  double qgs_ov_Vge_e_Vge_si;
  double qgs_ov_Vge_e_Vdi_si;
  double qgs_ov_Vge_e_Tempt_GND;
  double qgs_ov_Vge_di_Vge_di;
  double qgs_ov_Vge_di_Vge_e;
  double qgs_ov_Vge_di_Ve_si;
  double qgs_ov_Vge_di_Ve_di;
  double qgs_ov_Vge_di_Vge_si;
  double qgs_ov_Vge_di_Vdi_si;
  double qgs_ov_Vge_di_Tempt_GND;
#endif
#endif
#endif
double qinv;
#if defined(_DERIVATE)
double qinv_Vdi_si;
double qinv_Ve_si;
double qinv_Ve_di;
double qinv_Vge_si;
double qinv_Tempt_GND;
double qinv_Vge_e;
#endif
double inv_MclmCV;
#if defined(_DERIVATEFORDDX)
double inv_MclmCV_Vdi_si;
double inv_MclmCV_Ve_si;
double inv_MclmCV_Ve_di;
double inv_MclmCV_Vge_si;
double inv_MclmCV_Tempt_GND;
double inv_MclmCV_Vge_e;
#if defined(_DERIVATE2)
  double inv_MclmCV_Vge_e_Vdi_si;
  double inv_MclmCV_Vge_e_Ve_si;
  double inv_MclmCV_Vge_e_Ve_di;
  double inv_MclmCV_Vge_e_Vge_si;
  double inv_MclmCV_Vge_e_Tempt_GND;
  double inv_MclmCV_Vge_e_Vge_e;
  double inv_MclmCV_Tempt_GND_Vdi_si;
  double inv_MclmCV_Tempt_GND_Ve_si;
  double inv_MclmCV_Tempt_GND_Ve_di;
  double inv_MclmCV_Tempt_GND_Vge_si;
  double inv_MclmCV_Tempt_GND_Tempt_GND;
  double inv_MclmCV_Tempt_GND_Vge_e;
  double inv_MclmCV_Vge_si_Vdi_si;
  double inv_MclmCV_Vge_si_Ve_si;
  double inv_MclmCV_Vge_si_Ve_di;
  double inv_MclmCV_Vge_si_Vge_si;
  double inv_MclmCV_Vge_si_Tempt_GND;
  double inv_MclmCV_Vge_si_Vge_e;
  double inv_MclmCV_Ve_di_Vdi_si;
  double inv_MclmCV_Ve_di_Ve_si;
  double inv_MclmCV_Ve_di_Ve_di;
  double inv_MclmCV_Ve_di_Vge_si;
  double inv_MclmCV_Ve_di_Tempt_GND;
  double inv_MclmCV_Ve_di_Vge_e;
  double inv_MclmCV_Ve_si_Vdi_si;
  double inv_MclmCV_Ve_si_Ve_si;
  double inv_MclmCV_Ve_si_Ve_di;
  double inv_MclmCV_Ve_si_Vge_si;
  double inv_MclmCV_Ve_si_Tempt_GND;
  double inv_MclmCV_Ve_si_Vge_e;
  double inv_MclmCV_Vdi_si_Vdi_si;
  double inv_MclmCV_Vdi_si_Ve_si;
  double inv_MclmCV_Vdi_si_Ve_di;
  double inv_MclmCV_Vdi_si_Vge_si;
  double inv_MclmCV_Vdi_si_Tempt_GND;
  double inv_MclmCV_Vdi_si_Vge_e;
#endif
#endif
double vgd_eff;
#if defined(_DERIVATEFORDDX)
double vgd_eff_Vge_di;
double vgd_eff_Vge_e;
double vgd_eff_Vge_si;
double vgd_eff_Ve_si;
double vgd_eff_Ve_di;
double vgd_eff_Vdi_si;
double vgd_eff_Tempt_GND;
#if defined(_DERIVATE2)
  double vgd_eff_Tempt_GND_Vge_di;
  double vgd_eff_Tempt_GND_Vge_e;
  double vgd_eff_Tempt_GND_Vge_si;
  double vgd_eff_Tempt_GND_Ve_si;
  double vgd_eff_Tempt_GND_Ve_di;
  double vgd_eff_Tempt_GND_Vdi_si;
  double vgd_eff_Tempt_GND_Tempt_GND;
  double vgd_eff_Vdi_si_Vge_di;
  double vgd_eff_Vdi_si_Vge_e;
  double vgd_eff_Vdi_si_Vge_si;
  double vgd_eff_Vdi_si_Ve_si;
  double vgd_eff_Vdi_si_Ve_di;
  double vgd_eff_Vdi_si_Vdi_si;
  double vgd_eff_Vdi_si_Tempt_GND;
  double vgd_eff_Ve_di_Vge_di;
  double vgd_eff_Ve_di_Vge_e;
  double vgd_eff_Ve_di_Vge_si;
  double vgd_eff_Ve_di_Ve_si;
  double vgd_eff_Ve_di_Ve_di;
  double vgd_eff_Ve_di_Vdi_si;
  double vgd_eff_Ve_di_Tempt_GND;
  double vgd_eff_Ve_si_Vge_di;
  double vgd_eff_Ve_si_Vge_e;
  double vgd_eff_Ve_si_Vge_si;
  double vgd_eff_Ve_si_Ve_si;
  double vgd_eff_Ve_si_Ve_di;
  double vgd_eff_Ve_si_Vdi_si;
  double vgd_eff_Ve_si_Tempt_GND;
  double vgd_eff_Vge_si_Vge_di;
  double vgd_eff_Vge_si_Vge_e;
  double vgd_eff_Vge_si_Vge_si;
  double vgd_eff_Vge_si_Ve_si;
  double vgd_eff_Vge_si_Ve_di;
  double vgd_eff_Vge_si_Vdi_si;
  double vgd_eff_Vge_si_Tempt_GND;
  double vgd_eff_Vge_e_Vge_di;
  double vgd_eff_Vge_e_Vge_e;
  double vgd_eff_Vge_e_Vge_si;
  double vgd_eff_Vge_e_Ve_si;
  double vgd_eff_Vge_e_Ve_di;
  double vgd_eff_Vge_e_Vdi_si;
  double vgd_eff_Vge_e_Tempt_GND;
  double vgd_eff_Vge_di_Vge_di;
  double vgd_eff_Vge_di_Vge_e;
  double vgd_eff_Vge_di_Vge_si;
  double vgd_eff_Vge_di_Ve_si;
  double vgd_eff_Vge_di_Ve_di;
  double vgd_eff_Vge_di_Vdi_si;
  double vgd_eff_Vge_di_Tempt_GND;
#endif
#endif
double vgs_eff;
#if defined(_DERIVATEFORDDX)
double vgs_eff_Vge_di;
double vgs_eff_Vge_e;
double vgs_eff_Vge_si;
double vgs_eff_Ve_si;
double vgs_eff_Ve_di;
double vgs_eff_Vdi_si;
double vgs_eff_Tempt_GND;
#if defined(_DERIVATE2)
  double vgs_eff_Tempt_GND_Vge_di;
  double vgs_eff_Tempt_GND_Vge_e;
  double vgs_eff_Tempt_GND_Vge_si;
  double vgs_eff_Tempt_GND_Ve_si;
  double vgs_eff_Tempt_GND_Ve_di;
  double vgs_eff_Tempt_GND_Vdi_si;
  double vgs_eff_Tempt_GND_Tempt_GND;
  double vgs_eff_Vdi_si_Vge_di;
  double vgs_eff_Vdi_si_Vge_e;
  double vgs_eff_Vdi_si_Vge_si;
  double vgs_eff_Vdi_si_Ve_si;
  double vgs_eff_Vdi_si_Ve_di;
  double vgs_eff_Vdi_si_Vdi_si;
  double vgs_eff_Vdi_si_Tempt_GND;
  double vgs_eff_Ve_di_Vge_di;
  double vgs_eff_Ve_di_Vge_e;
  double vgs_eff_Ve_di_Vge_si;
  double vgs_eff_Ve_di_Ve_si;
  double vgs_eff_Ve_di_Ve_di;
  double vgs_eff_Ve_di_Vdi_si;
  double vgs_eff_Ve_di_Tempt_GND;
  double vgs_eff_Ve_si_Vge_di;
  double vgs_eff_Ve_si_Vge_e;
  double vgs_eff_Ve_si_Vge_si;
  double vgs_eff_Ve_si_Ve_si;
  double vgs_eff_Ve_si_Ve_di;
  double vgs_eff_Ve_si_Vdi_si;
  double vgs_eff_Ve_si_Tempt_GND;
  double vgs_eff_Vge_si_Vge_di;
  double vgs_eff_Vge_si_Vge_e;
  double vgs_eff_Vge_si_Vge_si;
  double vgs_eff_Vge_si_Ve_si;
  double vgs_eff_Vge_si_Ve_di;
  double vgs_eff_Vge_si_Vdi_si;
  double vgs_eff_Vge_si_Tempt_GND;
  double vgs_eff_Vge_e_Vge_di;
  double vgs_eff_Vge_e_Vge_e;
  double vgs_eff_Vge_e_Vge_si;
  double vgs_eff_Vge_e_Ve_si;
  double vgs_eff_Vge_e_Ve_di;
  double vgs_eff_Vge_e_Vdi_si;
  double vgs_eff_Vge_e_Tempt_GND;
  double vgs_eff_Vge_di_Vge_di;
  double vgs_eff_Vge_di_Vge_e;
  double vgs_eff_Vge_di_Vge_si;
  double vgs_eff_Vge_di_Ve_si;
  double vgs_eff_Vge_di_Ve_di;
  double vgs_eff_Vge_di_Vdi_si;
  double vgs_eff_Vge_di_Tempt_GND;
#endif
#endif
double ids0;
#if defined(_DERIVATEFORDDX)
double ids0_Vge_e;
double ids0_Ve_si;
double ids0_Ve_di;
double ids0_Vge_si;
double ids0_Vdi_si;
double ids0_Tempt_GND;
#if defined(_DERIVATE2)
  double ids0_Tempt_GND_Vge_e;
  double ids0_Tempt_GND_Ve_si;
  double ids0_Tempt_GND_Ve_di;
  double ids0_Tempt_GND_Vge_si;
  double ids0_Tempt_GND_Vdi_si;
  double ids0_Tempt_GND_Tempt_GND;
  double ids0_Vdi_si_Vge_e;
  double ids0_Vdi_si_Ve_si;
  double ids0_Vdi_si_Ve_di;
  double ids0_Vdi_si_Vge_si;
  double ids0_Vdi_si_Vdi_si;
  double ids0_Vdi_si_Tempt_GND;
  double ids0_Vge_si_Vge_e;
  double ids0_Vge_si_Ve_si;
  double ids0_Vge_si_Ve_di;
  double ids0_Vge_si_Vge_si;
  double ids0_Vge_si_Vdi_si;
  double ids0_Vge_si_Tempt_GND;
  double ids0_Ve_di_Vge_e;
  double ids0_Ve_di_Ve_si;
  double ids0_Ve_di_Ve_di;
  double ids0_Ve_di_Vge_si;
  double ids0_Ve_di_Vdi_si;
  double ids0_Ve_di_Tempt_GND;
  double ids0_Ve_si_Vge_e;
  double ids0_Ve_si_Ve_si;
  double ids0_Ve_si_Ve_di;
  double ids0_Ve_si_Vge_si;
  double ids0_Ve_si_Vdi_si;
  double ids0_Ve_si_Tempt_GND;
  double ids0_Vge_e_Vge_e;
  double ids0_Vge_e_Ve_si;
  double ids0_Vge_e_Ve_di;
  double ids0_Vge_e_Vge_si;
  double ids0_Vge_e_Vdi_si;
  double ids0_Vge_e_Tempt_GND;
#endif
#endif
double ids0_ov_dqi;
#if defined(_DERIVATEFORDDX)
double ids0_ov_dqi_Vge_e;
double ids0_ov_dqi_Ve_si;
double ids0_ov_dqi_Ve_di;
double ids0_ov_dqi_Vge_si;
double ids0_ov_dqi_Vdi_si;
double ids0_ov_dqi_Tempt_GND;
#if defined(_DERIVATE2)
  double ids0_ov_dqi_Tempt_GND_Vge_e;
  double ids0_ov_dqi_Tempt_GND_Ve_si;
  double ids0_ov_dqi_Tempt_GND_Ve_di;
  double ids0_ov_dqi_Tempt_GND_Vge_si;
  double ids0_ov_dqi_Tempt_GND_Vdi_si;
  double ids0_ov_dqi_Tempt_GND_Tempt_GND;
  double ids0_ov_dqi_Vdi_si_Vge_e;
  double ids0_ov_dqi_Vdi_si_Ve_si;
  double ids0_ov_dqi_Vdi_si_Ve_di;
  double ids0_ov_dqi_Vdi_si_Vge_si;
  double ids0_ov_dqi_Vdi_si_Vdi_si;
  double ids0_ov_dqi_Vdi_si_Tempt_GND;
  double ids0_ov_dqi_Vge_si_Vge_e;
  double ids0_ov_dqi_Vge_si_Ve_si;
  double ids0_ov_dqi_Vge_si_Ve_di;
  double ids0_ov_dqi_Vge_si_Vge_si;
  double ids0_ov_dqi_Vge_si_Vdi_si;
  double ids0_ov_dqi_Vge_si_Tempt_GND;
  double ids0_ov_dqi_Ve_di_Vge_e;
  double ids0_ov_dqi_Ve_di_Ve_si;
  double ids0_ov_dqi_Ve_di_Ve_di;
  double ids0_ov_dqi_Ve_di_Vge_si;
  double ids0_ov_dqi_Ve_di_Vdi_si;
  double ids0_ov_dqi_Ve_di_Tempt_GND;
  double ids0_ov_dqi_Ve_si_Vge_e;
  double ids0_ov_dqi_Ve_si_Ve_si;
  double ids0_ov_dqi_Ve_si_Ve_di;
  double ids0_ov_dqi_Ve_si_Vge_si;
  double ids0_ov_dqi_Ve_si_Vdi_si;
  double ids0_ov_dqi_Ve_si_Tempt_GND;
  double ids0_ov_dqi_Vge_e_Vge_e;
  double ids0_ov_dqi_Vge_e_Ve_si;
  double ids0_ov_dqi_Vge_e_Ve_di;
  double ids0_ov_dqi_Vge_e_Vge_si;
  double ids0_ov_dqi_Vge_e_Vdi_si;
  double ids0_ov_dqi_Vge_e_Tempt_GND;
#endif
#endif
double MclmCV;
#if defined(_DERIVATEFORDDX)
double MclmCV_Vdi_si;
double MclmCV_Ve_si;
double MclmCV_Ve_di;
double MclmCV_Vge_si;
double MclmCV_Tempt_GND;
double MclmCV_Vge_e;
#if defined(_DERIVATE2)
  double MclmCV_Vge_e_Vdi_si;
  double MclmCV_Vge_e_Ve_si;
  double MclmCV_Vge_e_Ve_di;
  double MclmCV_Vge_e_Vge_si;
  double MclmCV_Vge_e_Tempt_GND;
  double MclmCV_Vge_e_Vge_e;
  double MclmCV_Tempt_GND_Vdi_si;
  double MclmCV_Tempt_GND_Ve_si;
  double MclmCV_Tempt_GND_Ve_di;
  double MclmCV_Tempt_GND_Vge_si;
  double MclmCV_Tempt_GND_Tempt_GND;
  double MclmCV_Tempt_GND_Vge_e;
  double MclmCV_Vge_si_Vdi_si;
  double MclmCV_Vge_si_Ve_si;
  double MclmCV_Vge_si_Ve_di;
  double MclmCV_Vge_si_Vge_si;
  double MclmCV_Vge_si_Tempt_GND;
  double MclmCV_Vge_si_Vge_e;
  double MclmCV_Ve_di_Vdi_si;
  double MclmCV_Ve_di_Ve_si;
  double MclmCV_Ve_di_Ve_di;
  double MclmCV_Ve_di_Vge_si;
  double MclmCV_Ve_di_Tempt_GND;
  double MclmCV_Ve_di_Vge_e;
  double MclmCV_Ve_si_Vdi_si;
  double MclmCV_Ve_si_Ve_si;
  double MclmCV_Ve_si_Ve_di;
  double MclmCV_Ve_si_Vge_si;
  double MclmCV_Ve_si_Tempt_GND;
  double MclmCV_Ve_si_Vge_e;
  double MclmCV_Vdi_si_Vdi_si;
  double MclmCV_Vdi_si_Ve_si;
  double MclmCV_Vdi_si_Ve_di;
  double MclmCV_Vdi_si_Vge_si;
  double MclmCV_Vdi_si_Tempt_GND;
  double MclmCV_Vdi_si_Vge_e;
#endif
#endif
double DvsatCV;
#if defined(_DERIVATEFORDDX)
double DvsatCV_Vge_e;
double DvsatCV_Ve_si;
double DvsatCV_Ve_di;
double DvsatCV_Vge_si;
double DvsatCV_Vdi_si;
double DvsatCV_Tempt_GND;
#if defined(_DERIVATE2)
  double DvsatCV_Tempt_GND_Vge_e;
  double DvsatCV_Tempt_GND_Ve_si;
  double DvsatCV_Tempt_GND_Ve_di;
  double DvsatCV_Tempt_GND_Vge_si;
  double DvsatCV_Tempt_GND_Vdi_si;
  double DvsatCV_Tempt_GND_Tempt_GND;
  double DvsatCV_Vdi_si_Vge_e;
  double DvsatCV_Vdi_si_Ve_si;
  double DvsatCV_Vdi_si_Ve_di;
  double DvsatCV_Vdi_si_Vge_si;
  double DvsatCV_Vdi_si_Vdi_si;
  double DvsatCV_Vdi_si_Tempt_GND;
  double DvsatCV_Vge_si_Vge_e;
  double DvsatCV_Vge_si_Ve_si;
  double DvsatCV_Vge_si_Ve_di;
  double DvsatCV_Vge_si_Vge_si;
  double DvsatCV_Vge_si_Vdi_si;
  double DvsatCV_Vge_si_Tempt_GND;
  double DvsatCV_Ve_di_Vge_e;
  double DvsatCV_Ve_di_Ve_si;
  double DvsatCV_Ve_di_Ve_di;
  double DvsatCV_Ve_di_Vge_si;
  double DvsatCV_Ve_di_Vdi_si;
  double DvsatCV_Ve_di_Tempt_GND;
  double DvsatCV_Ve_si_Vge_e;
  double DvsatCV_Ve_si_Ve_si;
  double DvsatCV_Ve_si_Ve_di;
  double DvsatCV_Ve_si_Vge_si;
  double DvsatCV_Ve_si_Vdi_si;
  double DvsatCV_Ve_si_Tempt_GND;
  double DvsatCV_Vge_e_Vge_e;
  double DvsatCV_Vge_e_Ve_si;
  double DvsatCV_Vge_e_Ve_di;
  double DvsatCV_Vge_e_Vge_si;
  double DvsatCV_Vge_e_Vdi_si;
  double DvsatCV_Vge_e_Tempt_GND;
#endif
#endif
double EsatCVL;
#if defined(_DERIVATEFORDDX)
double EsatCVL_Tempt_GND;
double EsatCVL_Vge_e;
double EsatCVL_Vdi_si;
double EsatCVL_Ve_si;
double EsatCVL_Ve_di;
double EsatCVL_Vge_si;
#if defined(_DERIVATE2)
  double EsatCVL_Vge_si_Tempt_GND;
  double EsatCVL_Vge_si_Vge_e;
  double EsatCVL_Vge_si_Vdi_si;
  double EsatCVL_Vge_si_Ve_si;
  double EsatCVL_Vge_si_Ve_di;
  double EsatCVL_Vge_si_Vge_si;
  double EsatCVL_Ve_di_Tempt_GND;
  double EsatCVL_Ve_di_Vge_e;
  double EsatCVL_Ve_di_Vdi_si;
  double EsatCVL_Ve_di_Ve_si;
  double EsatCVL_Ve_di_Ve_di;
  double EsatCVL_Ve_di_Vge_si;
  double EsatCVL_Ve_si_Tempt_GND;
  double EsatCVL_Ve_si_Vge_e;
  double EsatCVL_Ve_si_Vdi_si;
  double EsatCVL_Ve_si_Ve_si;
  double EsatCVL_Ve_si_Ve_di;
  double EsatCVL_Ve_si_Vge_si;
  double EsatCVL_Vdi_si_Tempt_GND;
  double EsatCVL_Vdi_si_Vge_e;
  double EsatCVL_Vdi_si_Vdi_si;
  double EsatCVL_Vdi_si_Ve_si;
  double EsatCVL_Vdi_si_Ve_di;
  double EsatCVL_Vdi_si_Vge_si;
  double EsatCVL_Vge_e_Tempt_GND;
  double EsatCVL_Vge_e_Vge_e;
  double EsatCVL_Vge_e_Vdi_si;
  double EsatCVL_Vge_e_Ve_si;
  double EsatCVL_Vge_e_Ve_di;
  double EsatCVL_Vge_e_Vge_si;
  double EsatCVL_Tempt_GND_Tempt_GND;
  double EsatCVL_Tempt_GND_Vge_e;
  double EsatCVL_Tempt_GND_Vdi_si;
  double EsatCVL_Tempt_GND_Ve_si;
  double EsatCVL_Tempt_GND_Ve_di;
  double EsatCVL_Tempt_GND_Vge_si;
#endif
#endif
double EsatCV;
#if defined(_DERIVATEFORDDX)
double EsatCV_Tempt_GND;
double EsatCV_Vge_e;
double EsatCV_Vdi_si;
double EsatCV_Ve_si;
double EsatCV_Ve_di;
double EsatCV_Vge_si;
#if defined(_DERIVATE2)
  double EsatCV_Vge_si_Tempt_GND;
  double EsatCV_Vge_si_Vge_e;
  double EsatCV_Vge_si_Vdi_si;
  double EsatCV_Vge_si_Ve_si;
  double EsatCV_Vge_si_Ve_di;
  double EsatCV_Vge_si_Vge_si;
  double EsatCV_Ve_di_Tempt_GND;
  double EsatCV_Ve_di_Vge_e;
  double EsatCV_Ve_di_Vdi_si;
  double EsatCV_Ve_di_Ve_si;
  double EsatCV_Ve_di_Ve_di;
  double EsatCV_Ve_di_Vge_si;
  double EsatCV_Ve_si_Tempt_GND;
  double EsatCV_Ve_si_Vge_e;
  double EsatCV_Ve_si_Vdi_si;
  double EsatCV_Ve_si_Ve_si;
  double EsatCV_Ve_si_Ve_di;
  double EsatCV_Ve_si_Vge_si;
  double EsatCV_Vdi_si_Tempt_GND;
  double EsatCV_Vdi_si_Vge_e;
  double EsatCV_Vdi_si_Vdi_si;
  double EsatCV_Vdi_si_Ve_si;
  double EsatCV_Vdi_si_Ve_di;
  double EsatCV_Vdi_si_Vge_si;
  double EsatCV_Vge_e_Tempt_GND;
  double EsatCV_Vge_e_Vge_e;
  double EsatCV_Vge_e_Vdi_si;
  double EsatCV_Vge_e_Ve_si;
  double EsatCV_Vge_e_Ve_di;
  double EsatCV_Vge_e_Vge_si;
  double EsatCV_Tempt_GND_Tempt_GND;
  double EsatCV_Tempt_GND_Vge_e;
  double EsatCV_Tempt_GND_Vdi_si;
  double EsatCV_Tempt_GND_Ve_si;
  double EsatCV_Tempt_GND_Ve_di;
  double EsatCV_Tempt_GND_Vge_si;
#endif
#endif
double Mob;
#if defined(_DERIVATEFORDDX)
double Mob_Vge_e;
double Mob_Ve_si;
double Mob_Ve_di;
double Mob_Vge_si;
double Mob_Vdi_si;
double Mob_Tempt_GND;
#if defined(_DERIVATE2)
  double Mob_Tempt_GND_Vge_e;
  double Mob_Tempt_GND_Ve_si;
  double Mob_Tempt_GND_Ve_di;
  double Mob_Tempt_GND_Vge_si;
  double Mob_Tempt_GND_Vdi_si;
  double Mob_Tempt_GND_Tempt_GND;
  double Mob_Vdi_si_Vge_e;
  double Mob_Vdi_si_Ve_si;
  double Mob_Vdi_si_Ve_di;
  double Mob_Vdi_si_Vge_si;
  double Mob_Vdi_si_Vdi_si;
  double Mob_Vdi_si_Tempt_GND;
  double Mob_Vge_si_Vge_e;
  double Mob_Vge_si_Ve_si;
  double Mob_Vge_si_Ve_di;
  double Mob_Vge_si_Vge_si;
  double Mob_Vge_si_Vdi_si;
  double Mob_Vge_si_Tempt_GND;
  double Mob_Ve_di_Vge_e;
  double Mob_Ve_di_Ve_si;
  double Mob_Ve_di_Ve_di;
  double Mob_Ve_di_Vge_si;
  double Mob_Ve_di_Vdi_si;
  double Mob_Ve_di_Tempt_GND;
  double Mob_Ve_si_Vge_e;
  double Mob_Ve_si_Ve_si;
  double Mob_Ve_si_Ve_di;
  double Mob_Ve_si_Vge_si;
  double Mob_Ve_si_Vdi_si;
  double Mob_Ve_si_Tempt_GND;
  double Mob_Vge_e_Vge_e;
  double Mob_Vge_e_Ve_si;
  double Mob_Vge_e_Ve_di;
  double Mob_Vge_e_Vge_si;
  double Mob_Vge_e_Vdi_si;
  double Mob_Vge_e_Tempt_GND;
#endif
#endif
double Mnud;
#if defined(_DERIVATEFORDDX)
double Mnud_Vge_e;
double Mnud_Ve_si;
double Mnud_Ve_di;
double Mnud_Vge_si;
double Mnud_Vdi_si;
double Mnud_Tempt_GND;
#if defined(_DERIVATE2)
  double Mnud_Tempt_GND_Vge_e;
  double Mnud_Tempt_GND_Ve_si;
  double Mnud_Tempt_GND_Ve_di;
  double Mnud_Tempt_GND_Vge_si;
  double Mnud_Tempt_GND_Vdi_si;
  double Mnud_Tempt_GND_Tempt_GND;
  double Mnud_Vdi_si_Vge_e;
  double Mnud_Vdi_si_Ve_si;
  double Mnud_Vdi_si_Ve_di;
  double Mnud_Vdi_si_Vge_si;
  double Mnud_Vdi_si_Vdi_si;
  double Mnud_Vdi_si_Tempt_GND;
  double Mnud_Vge_si_Vge_e;
  double Mnud_Vge_si_Ve_si;
  double Mnud_Vge_si_Ve_di;
  double Mnud_Vge_si_Vge_si;
  double Mnud_Vge_si_Vdi_si;
  double Mnud_Vge_si_Tempt_GND;
  double Mnud_Ve_di_Vge_e;
  double Mnud_Ve_di_Ve_si;
  double Mnud_Ve_di_Ve_di;
  double Mnud_Ve_di_Vge_si;
  double Mnud_Ve_di_Vdi_si;
  double Mnud_Ve_di_Tempt_GND;
  double Mnud_Ve_si_Vge_e;
  double Mnud_Ve_si_Ve_si;
  double Mnud_Ve_si_Ve_di;
  double Mnud_Ve_si_Vge_si;
  double Mnud_Ve_si_Vdi_si;
  double Mnud_Ve_si_Tempt_GND;
  double Mnud_Vge_e_Vge_e;
  double Mnud_Vge_e_Ve_si;
  double Mnud_Vge_e_Ve_di;
  double Mnud_Vge_e_Vge_si;
  double Mnud_Vge_e_Vdi_si;
  double Mnud_Vge_e_Tempt_GND;
#endif
#endif
double Nsat;
#if defined(_DERIVATEFORDDX)
double Nsat_Vge_e;
double Nsat_Vdi_si;
double Nsat_Ve_si;
double Nsat_Ve_di;
double Nsat_Vge_si;
double Nsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Nsat_Tempt_GND_Vge_e;
  double Nsat_Tempt_GND_Vdi_si;
  double Nsat_Tempt_GND_Ve_si;
  double Nsat_Tempt_GND_Ve_di;
  double Nsat_Tempt_GND_Vge_si;
  double Nsat_Tempt_GND_Tempt_GND;
  double Nsat_Vge_si_Vge_e;
  double Nsat_Vge_si_Vdi_si;
  double Nsat_Vge_si_Ve_si;
  double Nsat_Vge_si_Ve_di;
  double Nsat_Vge_si_Vge_si;
  double Nsat_Vge_si_Tempt_GND;
  double Nsat_Ve_di_Vge_e;
  double Nsat_Ve_di_Vdi_si;
  double Nsat_Ve_di_Ve_si;
  double Nsat_Ve_di_Ve_di;
  double Nsat_Ve_di_Vge_si;
  double Nsat_Ve_di_Tempt_GND;
  double Nsat_Ve_si_Vge_e;
  double Nsat_Ve_si_Vdi_si;
  double Nsat_Ve_si_Ve_si;
  double Nsat_Ve_si_Ve_di;
  double Nsat_Ve_si_Vge_si;
  double Nsat_Ve_si_Tempt_GND;
  double Nsat_Vdi_si_Vge_e;
  double Nsat_Vdi_si_Vdi_si;
  double Nsat_Vdi_si_Ve_si;
  double Nsat_Vdi_si_Ve_di;
  double Nsat_Vdi_si_Vge_si;
  double Nsat_Vdi_si_Tempt_GND;
  double Nsat_Vge_e_Vge_e;
  double Nsat_Vge_e_Vdi_si;
  double Nsat_Vge_e_Ve_si;
  double Nsat_Vge_e_Ve_di;
  double Nsat_Vge_e_Vge_si;
  double Nsat_Vge_e_Tempt_GND;
#endif
#endif
double Dvsat;
#if defined(_DERIVATEFORDDX)
double Dvsat_Vge_e;
double Dvsat_Ve_si;
double Dvsat_Ve_di;
double Dvsat_Vge_si;
double Dvsat_Vdi_si;
double Dvsat_Tempt_GND;
#if defined(_DERIVATE2)
  double Dvsat_Tempt_GND_Vge_e;
  double Dvsat_Tempt_GND_Ve_si;
  double Dvsat_Tempt_GND_Ve_di;
  double Dvsat_Tempt_GND_Vge_si;
  double Dvsat_Tempt_GND_Vdi_si;
  double Dvsat_Tempt_GND_Tempt_GND;
  double Dvsat_Vdi_si_Vge_e;
  double Dvsat_Vdi_si_Ve_si;
  double Dvsat_Vdi_si_Ve_di;
  double Dvsat_Vdi_si_Vge_si;
  double Dvsat_Vdi_si_Vdi_si;
  double Dvsat_Vdi_si_Tempt_GND;
  double Dvsat_Vge_si_Vge_e;
  double Dvsat_Vge_si_Ve_si;
  double Dvsat_Vge_si_Ve_di;
  double Dvsat_Vge_si_Vge_si;
  double Dvsat_Vge_si_Vdi_si;
  double Dvsat_Vge_si_Tempt_GND;
  double Dvsat_Ve_di_Vge_e;
  double Dvsat_Ve_di_Ve_si;
  double Dvsat_Ve_di_Ve_di;
  double Dvsat_Ve_di_Vge_si;
  double Dvsat_Ve_di_Vdi_si;
  double Dvsat_Ve_di_Tempt_GND;
  double Dvsat_Ve_si_Vge_e;
  double Dvsat_Ve_si_Ve_si;
  double Dvsat_Ve_si_Ve_di;
  double Dvsat_Ve_si_Vge_si;
  double Dvsat_Ve_si_Vdi_si;
  double Dvsat_Ve_si_Tempt_GND;
  double Dvsat_Vge_e_Vge_e;
  double Dvsat_Vge_e_Ve_si;
  double Dvsat_Vge_e_Ve_di;
  double Dvsat_Vge_e_Vge_si;
  double Dvsat_Vge_e_Vdi_si;
  double Dvsat_Vge_e_Tempt_GND;
#endif
#endif
double Esat1L;
#if defined(_DERIVATEFORDDX)
double Esat1L_Tempt_GND;
double Esat1L_Vdi_si;
double Esat1L_Vge_e;
double Esat1L_Ve_si;
double Esat1L_Ve_di;
double Esat1L_Vge_si;
#if defined(_DERIVATE2)
  double Esat1L_Vge_si_Tempt_GND;
  double Esat1L_Vge_si_Vdi_si;
  double Esat1L_Vge_si_Vge_e;
  double Esat1L_Vge_si_Ve_si;
  double Esat1L_Vge_si_Ve_di;
  double Esat1L_Vge_si_Vge_si;
  double Esat1L_Ve_di_Tempt_GND;
  double Esat1L_Ve_di_Vdi_si;
  double Esat1L_Ve_di_Vge_e;
  double Esat1L_Ve_di_Ve_si;
  double Esat1L_Ve_di_Ve_di;
  double Esat1L_Ve_di_Vge_si;
  double Esat1L_Ve_si_Tempt_GND;
  double Esat1L_Ve_si_Vdi_si;
  double Esat1L_Ve_si_Vge_e;
  double Esat1L_Ve_si_Ve_si;
  double Esat1L_Ve_si_Ve_di;
  double Esat1L_Ve_si_Vge_si;
  double Esat1L_Vge_e_Tempt_GND;
  double Esat1L_Vge_e_Vdi_si;
  double Esat1L_Vge_e_Vge_e;
  double Esat1L_Vge_e_Ve_si;
  double Esat1L_Vge_e_Ve_di;
  double Esat1L_Vge_e_Vge_si;
  double Esat1L_Vdi_si_Tempt_GND;
  double Esat1L_Vdi_si_Vdi_si;
  double Esat1L_Vdi_si_Vge_e;
  double Esat1L_Vdi_si_Ve_si;
  double Esat1L_Vdi_si_Ve_di;
  double Esat1L_Vdi_si_Vge_si;
  double Esat1L_Tempt_GND_Tempt_GND;
  double Esat1L_Tempt_GND_Vdi_si;
  double Esat1L_Tempt_GND_Vge_e;
  double Esat1L_Tempt_GND_Ve_si;
  double Esat1L_Tempt_GND_Ve_di;
  double Esat1L_Tempt_GND_Vge_si;
#endif
#endif
double Esat1;
#if defined(_DERIVATEFORDDX)
double Esat1_Tempt_GND;
double Esat1_Vdi_si;
double Esat1_Vge_e;
double Esat1_Ve_si;
double Esat1_Ve_di;
double Esat1_Vge_si;
#if defined(_DERIVATE2)
  double Esat1_Vge_si_Tempt_GND;
  double Esat1_Vge_si_Vdi_si;
  double Esat1_Vge_si_Vge_e;
  double Esat1_Vge_si_Ve_si;
  double Esat1_Vge_si_Ve_di;
  double Esat1_Vge_si_Vge_si;
  double Esat1_Ve_di_Tempt_GND;
  double Esat1_Ve_di_Vdi_si;
  double Esat1_Ve_di_Vge_e;
  double Esat1_Ve_di_Ve_si;
  double Esat1_Ve_di_Ve_di;
  double Esat1_Ve_di_Vge_si;
  double Esat1_Ve_si_Tempt_GND;
  double Esat1_Ve_si_Vdi_si;
  double Esat1_Ve_si_Vge_e;
  double Esat1_Ve_si_Ve_si;
  double Esat1_Ve_si_Ve_di;
  double Esat1_Ve_si_Vge_si;
  double Esat1_Vge_e_Tempt_GND;
  double Esat1_Vge_e_Vdi_si;
  double Esat1_Vge_e_Vge_e;
  double Esat1_Vge_e_Ve_si;
  double Esat1_Vge_e_Ve_di;
  double Esat1_Vge_e_Vge_si;
  double Esat1_Vdi_si_Tempt_GND;
  double Esat1_Vdi_si_Vdi_si;
  double Esat1_Vdi_si_Vge_e;
  double Esat1_Vdi_si_Ve_si;
  double Esat1_Vdi_si_Ve_di;
  double Esat1_Vdi_si_Vge_si;
  double Esat1_Tempt_GND_Tempt_GND;
  double Esat1_Tempt_GND_Vdi_si;
  double Esat1_Tempt_GND_Vge_e;
  double Esat1_Tempt_GND_Ve_si;
  double Esat1_Tempt_GND_Ve_di;
  double Esat1_Tempt_GND_Vge_si;
#endif
#endif
double Mclm;
#if defined(_DERIVATEFORDDX)
double Mclm_Vge_e;
double Mclm_Ve_si;
double Mclm_Ve_di;
double Mclm_Vge_si;
double Mclm_Vdi_si;
double Mclm_Tempt_GND;
#if defined(_DERIVATE2)
  double Mclm_Tempt_GND_Vge_e;
  double Mclm_Tempt_GND_Ve_si;
  double Mclm_Tempt_GND_Ve_di;
  double Mclm_Tempt_GND_Vge_si;
  double Mclm_Tempt_GND_Vdi_si;
  double Mclm_Tempt_GND_Tempt_GND;
  double Mclm_Vdi_si_Vge_e;
  double Mclm_Vdi_si_Ve_si;
  double Mclm_Vdi_si_Ve_di;
  double Mclm_Vdi_si_Vge_si;
  double Mclm_Vdi_si_Vdi_si;
  double Mclm_Vdi_si_Tempt_GND;
  double Mclm_Vge_si_Vge_e;
  double Mclm_Vge_si_Ve_si;
  double Mclm_Vge_si_Ve_di;
  double Mclm_Vge_si_Vge_si;
  double Mclm_Vge_si_Vdi_si;
  double Mclm_Vge_si_Tempt_GND;
  double Mclm_Ve_di_Vge_e;
  double Mclm_Ve_di_Ve_si;
  double Mclm_Ve_di_Ve_di;
  double Mclm_Ve_di_Vge_si;
  double Mclm_Ve_di_Vdi_si;
  double Mclm_Ve_di_Tempt_GND;
  double Mclm_Ve_si_Vge_e;
  double Mclm_Ve_si_Ve_si;
  double Mclm_Ve_si_Ve_di;
  double Mclm_Ve_si_Vge_si;
  double Mclm_Ve_si_Vdi_si;
  double Mclm_Ve_si_Tempt_GND;
  double Mclm_Vge_e_Vge_e;
  double Mclm_Vge_e_Ve_si;
  double Mclm_Vge_e_Ve_di;
  double Mclm_Vge_e_Vge_si;
  double Mclm_Vge_e_Vdi_si;
  double Mclm_Vge_e_Tempt_GND;
#endif
#endif
double Moc;
#if defined(_DERIVATEFORDDX)
double Moc_Vdi_si;
double Moc_Ve_si;
double Moc_Ve_di;
double Moc_Vge_si;
double Moc_Tempt_GND;
double Moc_Vge_e;
#if defined(_DERIVATE2)
  double Moc_Vge_e_Vdi_si;
  double Moc_Vge_e_Ve_si;
  double Moc_Vge_e_Ve_di;
  double Moc_Vge_e_Vge_si;
  double Moc_Vge_e_Tempt_GND;
  double Moc_Vge_e_Vge_e;
  double Moc_Tempt_GND_Vdi_si;
  double Moc_Tempt_GND_Ve_si;
  double Moc_Tempt_GND_Ve_di;
  double Moc_Tempt_GND_Vge_si;
  double Moc_Tempt_GND_Tempt_GND;
  double Moc_Tempt_GND_Vge_e;
  double Moc_Vge_si_Vdi_si;
  double Moc_Vge_si_Ve_si;
  double Moc_Vge_si_Ve_di;
  double Moc_Vge_si_Vge_si;
  double Moc_Vge_si_Tempt_GND;
  double Moc_Vge_si_Vge_e;
  double Moc_Ve_di_Vdi_si;
  double Moc_Ve_di_Ve_si;
  double Moc_Ve_di_Ve_di;
  double Moc_Ve_di_Vge_si;
  double Moc_Ve_di_Tempt_GND;
  double Moc_Ve_di_Vge_e;
  double Moc_Ve_si_Vdi_si;
  double Moc_Ve_si_Ve_si;
  double Moc_Ve_si_Ve_di;
  double Moc_Ve_si_Vge_si;
  double Moc_Ve_si_Tempt_GND;
  double Moc_Ve_si_Vge_e;
  double Moc_Vdi_si_Vdi_si;
  double Moc_Vdi_si_Ve_si;
  double Moc_Vdi_si_Ve_di;
  double Moc_Vdi_si_Vge_si;
  double Moc_Vdi_si_Tempt_GND;
  double Moc_Vdi_si_Vge_e;
#endif
#endif
double VaDIBL;
#if defined(_DERIVATEFORDDX)
double VaDIBL_Vge_e;
double VaDIBL_Ve_si;
double VaDIBL_Ve_di;
double VaDIBL_Vge_si;
double VaDIBL_Vdi_si;
double VaDIBL_Tempt_GND;
#if defined(_DERIVATE2)
  double VaDIBL_Tempt_GND_Vge_e;
  double VaDIBL_Tempt_GND_Ve_si;
  double VaDIBL_Tempt_GND_Ve_di;
  double VaDIBL_Tempt_GND_Vge_si;
  double VaDIBL_Tempt_GND_Vdi_si;
  double VaDIBL_Tempt_GND_Tempt_GND;
  double VaDIBL_Vdi_si_Vge_e;
  double VaDIBL_Vdi_si_Ve_si;
  double VaDIBL_Vdi_si_Ve_di;
  double VaDIBL_Vdi_si_Vge_si;
  double VaDIBL_Vdi_si_Vdi_si;
  double VaDIBL_Vdi_si_Tempt_GND;
  double VaDIBL_Vge_si_Vge_e;
  double VaDIBL_Vge_si_Ve_si;
  double VaDIBL_Vge_si_Ve_di;
  double VaDIBL_Vge_si_Vge_si;
  double VaDIBL_Vge_si_Vdi_si;
  double VaDIBL_Vge_si_Tempt_GND;
  double VaDIBL_Ve_di_Vge_e;
  double VaDIBL_Ve_di_Ve_si;
  double VaDIBL_Ve_di_Ve_di;
  double VaDIBL_Ve_di_Vge_si;
  double VaDIBL_Ve_di_Vdi_si;
  double VaDIBL_Ve_di_Tempt_GND;
  double VaDIBL_Ve_si_Vge_e;
  double VaDIBL_Ve_si_Ve_si;
  double VaDIBL_Ve_si_Ve_di;
  double VaDIBL_Ve_si_Vge_si;
  double VaDIBL_Ve_si_Vdi_si;
  double VaDIBL_Ve_si_Tempt_GND;
  double VaDIBL_Vge_e_Vge_e;
  double VaDIBL_Vge_e_Ve_si;
  double VaDIBL_Vge_e_Ve_di;
  double VaDIBL_Vge_e_Vge_si;
  double VaDIBL_Vge_e_Vdi_si;
  double VaDIBL_Vge_e_Tempt_GND;
#endif
#endif
double Vgst2Vtm;
#if defined(_DERIVATEFORDDX)
double Vgst2Vtm_Vdi_si;
double Vgst2Vtm_Ve_si;
double Vgst2Vtm_Ve_di;
double Vgst2Vtm_Vge_si;
double Vgst2Vtm_Tempt_GND;
#if defined(_DERIVATE2)
  double Vgst2Vtm_Tempt_GND_Vdi_si;
  double Vgst2Vtm_Tempt_GND_Ve_si;
  double Vgst2Vtm_Tempt_GND_Ve_di;
  double Vgst2Vtm_Tempt_GND_Vge_si;
  double Vgst2Vtm_Tempt_GND_Tempt_GND;
  double Vgst2Vtm_Vge_si_Vdi_si;
  double Vgst2Vtm_Vge_si_Ve_si;
  double Vgst2Vtm_Vge_si_Ve_di;
  double Vgst2Vtm_Vge_si_Vge_si;
  double Vgst2Vtm_Vge_si_Tempt_GND;
  double Vgst2Vtm_Ve_di_Vdi_si;
  double Vgst2Vtm_Ve_di_Ve_si;
  double Vgst2Vtm_Ve_di_Ve_di;
  double Vgst2Vtm_Ve_di_Vge_si;
  double Vgst2Vtm_Ve_di_Tempt_GND;
  double Vgst2Vtm_Ve_si_Vdi_si;
  double Vgst2Vtm_Ve_si_Ve_si;
  double Vgst2Vtm_Ve_si_Ve_di;
  double Vgst2Vtm_Ve_si_Vge_si;
  double Vgst2Vtm_Ve_si_Tempt_GND;
  double Vgst2Vtm_Vdi_si_Vdi_si;
  double Vgst2Vtm_Vdi_si_Ve_si;
  double Vgst2Vtm_Vdi_si_Ve_di;
  double Vgst2Vtm_Vdi_si_Vge_si;
  double Vgst2Vtm_Vdi_si_Tempt_GND;
#endif
#endif
double diffVds;
#if defined(_DERIVATEFORDDX)
double diffVds_Vdi_si;
double diffVds_Ve_si;
double diffVds_Ve_di;
double diffVds_Vge_si;
double diffVds_Tempt_GND;
#if defined(_DERIVATE2)
  double diffVds_Tempt_GND_Vdi_si;
  double diffVds_Tempt_GND_Ve_si;
  double diffVds_Tempt_GND_Ve_di;
  double diffVds_Tempt_GND_Vge_si;
  double diffVds_Tempt_GND_Tempt_GND;
  double diffVds_Vge_si_Vdi_si;
  double diffVds_Vge_si_Ve_si;
  double diffVds_Vge_si_Ve_di;
  double diffVds_Vge_si_Vge_si;
  double diffVds_Vge_si_Tempt_GND;
  double diffVds_Ve_di_Vdi_si;
  double diffVds_Ve_di_Ve_si;
  double diffVds_Ve_di_Ve_di;
  double diffVds_Ve_di_Vge_si;
  double diffVds_Ve_di_Tempt_GND;
  double diffVds_Ve_si_Vdi_si;
  double diffVds_Ve_si_Ve_si;
  double diffVds_Ve_si_Ve_di;
  double diffVds_Ve_si_Vge_si;
  double diffVds_Ve_si_Tempt_GND;
  double diffVds_Vdi_si_Vdi_si;
  double diffVds_Vdi_si_Ve_si;
  double diffVds_Vdi_si_Ve_di;
  double diffVds_Vdi_si_Vge_si;
  double diffVds_Vdi_si_Tempt_GND;
#endif
#endif
double PVAGfactor;
#if defined(_DERIVATEFORDDX)
double PVAGfactor_Vdi_si;
double PVAGfactor_Ve_si;
double PVAGfactor_Ve_di;
double PVAGfactor_Vge_si;
double PVAGfactor_Tempt_GND;
#if defined(_DERIVATE2)
  double PVAGfactor_Tempt_GND_Vdi_si;
  double PVAGfactor_Tempt_GND_Ve_si;
  double PVAGfactor_Tempt_GND_Ve_di;
  double PVAGfactor_Tempt_GND_Vge_si;
  double PVAGfactor_Tempt_GND_Tempt_GND;
  double PVAGfactor_Vge_si_Vdi_si;
  double PVAGfactor_Vge_si_Ve_si;
  double PVAGfactor_Vge_si_Ve_di;
  double PVAGfactor_Vge_si_Vge_si;
  double PVAGfactor_Vge_si_Tempt_GND;
  double PVAGfactor_Ve_di_Vdi_si;
  double PVAGfactor_Ve_di_Ve_si;
  double PVAGfactor_Ve_di_Ve_di;
  double PVAGfactor_Ve_di_Vge_si;
  double PVAGfactor_Ve_di_Tempt_GND;
  double PVAGfactor_Ve_si_Vdi_si;
  double PVAGfactor_Ve_si_Ve_si;
  double PVAGfactor_Ve_si_Ve_di;
  double PVAGfactor_Ve_si_Vge_si;
  double PVAGfactor_Ve_si_Tempt_GND;
  double PVAGfactor_Vdi_si_Vdi_si;
  double PVAGfactor_Vdi_si_Ve_si;
  double PVAGfactor_Vdi_si_Ve_di;
  double PVAGfactor_Vdi_si_Vge_si;
  double PVAGfactor_Vdi_si_Tempt_GND;
#endif
#endif
double DIBLfactor;
#if defined(_DERIVATEFORDDX)
double DIBLfactor_Vdi_si;
double DIBLfactor_Tempt_GND;
#if defined(_DERIVATE2)
  double DIBLfactor_Tempt_GND_Vdi_si;
  double DIBLfactor_Tempt_GND_Tempt_GND;
  double DIBLfactor_Vdi_si_Vdi_si;
  double DIBLfactor_Vdi_si_Tempt_GND;
#endif
#endif
double Dmob_cv;
#if defined(_DERIVATEFORDDX)
double Dmob_cv_Vge_e;
double Dmob_cv_Vdi_si;
double Dmob_cv_Ve_si;
double Dmob_cv_Ve_di;
double Dmob_cv_Vge_si;
double Dmob_cv_Tempt_GND;
#if defined(_DERIVATE2)
  double Dmob_cv_Tempt_GND_Vge_e;
  double Dmob_cv_Tempt_GND_Vdi_si;
  double Dmob_cv_Tempt_GND_Ve_si;
  double Dmob_cv_Tempt_GND_Ve_di;
  double Dmob_cv_Tempt_GND_Vge_si;
  double Dmob_cv_Tempt_GND_Tempt_GND;
  double Dmob_cv_Vge_si_Vge_e;
  double Dmob_cv_Vge_si_Vdi_si;
  double Dmob_cv_Vge_si_Ve_si;
  double Dmob_cv_Vge_si_Ve_di;
  double Dmob_cv_Vge_si_Vge_si;
  double Dmob_cv_Vge_si_Tempt_GND;
  double Dmob_cv_Ve_di_Vge_e;
  double Dmob_cv_Ve_di_Vdi_si;
  double Dmob_cv_Ve_di_Ve_si;
  double Dmob_cv_Ve_di_Ve_di;
  double Dmob_cv_Ve_di_Vge_si;
  double Dmob_cv_Ve_di_Tempt_GND;
  double Dmob_cv_Ve_si_Vge_e;
  double Dmob_cv_Ve_si_Vdi_si;
  double Dmob_cv_Ve_si_Ve_si;
  double Dmob_cv_Ve_si_Ve_di;
  double Dmob_cv_Ve_si_Vge_si;
  double Dmob_cv_Ve_si_Tempt_GND;
  double Dmob_cv_Vdi_si_Vge_e;
  double Dmob_cv_Vdi_si_Vdi_si;
  double Dmob_cv_Vdi_si_Ve_si;
  double Dmob_cv_Vdi_si_Ve_di;
  double Dmob_cv_Vdi_si_Vge_si;
  double Dmob_cv_Vdi_si_Tempt_GND;
  double Dmob_cv_Vge_e_Vge_e;
  double Dmob_cv_Vge_e_Vdi_si;
  double Dmob_cv_Vge_e_Ve_si;
  double Dmob_cv_Vge_e_Ve_di;
  double Dmob_cv_Vge_e_Vge_si;
  double Dmob_cv_Vge_e_Tempt_GND;
#endif
#endif
double Eeffm_cv;
#if defined(_DERIVATEFORDDX)
double Eeffm_cv_Tempt_GND;
double Eeffm_cv_Vdi_si;
double Eeffm_cv_Vge_e;
double Eeffm_cv_Ve_si;
double Eeffm_cv_Ve_di;
double Eeffm_cv_Vge_si;
#if defined(_DERIVATE2)
  double Eeffm_cv_Vge_si_Tempt_GND;
  double Eeffm_cv_Vge_si_Vdi_si;
  double Eeffm_cv_Vge_si_Vge_e;
  double Eeffm_cv_Vge_si_Ve_si;
  double Eeffm_cv_Vge_si_Ve_di;
  double Eeffm_cv_Vge_si_Vge_si;
  double Eeffm_cv_Ve_di_Tempt_GND;
  double Eeffm_cv_Ve_di_Vdi_si;
  double Eeffm_cv_Ve_di_Vge_e;
  double Eeffm_cv_Ve_di_Ve_si;
  double Eeffm_cv_Ve_di_Ve_di;
  double Eeffm_cv_Ve_di_Vge_si;
  double Eeffm_cv_Ve_si_Tempt_GND;
  double Eeffm_cv_Ve_si_Vdi_si;
  double Eeffm_cv_Ve_si_Vge_e;
  double Eeffm_cv_Ve_si_Ve_si;
  double Eeffm_cv_Ve_si_Ve_di;
  double Eeffm_cv_Ve_si_Vge_si;
  double Eeffm_cv_Vge_e_Tempt_GND;
  double Eeffm_cv_Vge_e_Vdi_si;
  double Eeffm_cv_Vge_e_Vge_e;
  double Eeffm_cv_Vge_e_Ve_si;
  double Eeffm_cv_Vge_e_Ve_di;
  double Eeffm_cv_Vge_e_Vge_si;
  double Eeffm_cv_Vdi_si_Tempt_GND;
  double Eeffm_cv_Vdi_si_Vdi_si;
  double Eeffm_cv_Vdi_si_Vge_e;
  double Eeffm_cv_Vdi_si_Ve_si;
  double Eeffm_cv_Vdi_si_Ve_di;
  double Eeffm_cv_Vdi_si_Vge_si;
  double Eeffm_cv_Tempt_GND_Tempt_GND;
  double Eeffm_cv_Tempt_GND_Vdi_si;
  double Eeffm_cv_Tempt_GND_Vge_e;
  double Eeffm_cv_Tempt_GND_Ve_si;
  double Eeffm_cv_Tempt_GND_Ve_di;
  double Eeffm_cv_Tempt_GND_Vge_si;
#endif
#endif
double ueff;
#if defined(_DERIVATEFORDDX)
double ueff_Tempt_GND;
double ueff_Vdi_si;
double ueff_Vge_e;
double ueff_Ve_si;
double ueff_Ve_di;
double ueff_Vge_si;
#if defined(_DERIVATE2)
  double ueff_Vge_si_Tempt_GND;
  double ueff_Vge_si_Vdi_si;
  double ueff_Vge_si_Vge_e;
  double ueff_Vge_si_Ve_si;
  double ueff_Vge_si_Ve_di;
  double ueff_Vge_si_Vge_si;
  double ueff_Ve_di_Tempt_GND;
  double ueff_Ve_di_Vdi_si;
  double ueff_Ve_di_Vge_e;
  double ueff_Ve_di_Ve_si;
  double ueff_Ve_di_Ve_di;
  double ueff_Ve_di_Vge_si;
  double ueff_Ve_si_Tempt_GND;
  double ueff_Ve_si_Vdi_si;
  double ueff_Ve_si_Vge_e;
  double ueff_Ve_si_Ve_si;
  double ueff_Ve_si_Ve_di;
  double ueff_Ve_si_Vge_si;
  double ueff_Vge_e_Tempt_GND;
  double ueff_Vge_e_Vdi_si;
  double ueff_Vge_e_Vge_e;
  double ueff_Vge_e_Ve_si;
  double ueff_Vge_e_Ve_di;
  double ueff_Vge_e_Vge_si;
  double ueff_Vdi_si_Tempt_GND;
  double ueff_Vdi_si_Vdi_si;
  double ueff_Vdi_si_Vge_e;
  double ueff_Vdi_si_Ve_si;
  double ueff_Vdi_si_Ve_di;
  double ueff_Vdi_si_Vge_si;
  double ueff_Tempt_GND_Tempt_GND;
  double ueff_Tempt_GND_Vdi_si;
  double ueff_Tempt_GND_Vge_e;
  double ueff_Tempt_GND_Ve_si;
  double ueff_Tempt_GND_Ve_di;
  double ueff_Tempt_GND_Vge_si;
#endif
#endif
double Dmob;
#if defined(_DERIVATEFORDDX)
double Dmob_Vge_e;
double Dmob_Vdi_si;
double Dmob_Ve_si;
double Dmob_Ve_di;
double Dmob_Vge_si;
double Dmob_Tempt_GND;
#if defined(_DERIVATE2)
  double Dmob_Tempt_GND_Vge_e;
  double Dmob_Tempt_GND_Vdi_si;
  double Dmob_Tempt_GND_Ve_si;
  double Dmob_Tempt_GND_Ve_di;
  double Dmob_Tempt_GND_Vge_si;
  double Dmob_Tempt_GND_Tempt_GND;
  double Dmob_Vge_si_Vge_e;
  double Dmob_Vge_si_Vdi_si;
  double Dmob_Vge_si_Ve_si;
  double Dmob_Vge_si_Ve_di;
  double Dmob_Vge_si_Vge_si;
  double Dmob_Vge_si_Tempt_GND;
  double Dmob_Ve_di_Vge_e;
  double Dmob_Ve_di_Vdi_si;
  double Dmob_Ve_di_Ve_si;
  double Dmob_Ve_di_Ve_di;
  double Dmob_Ve_di_Vge_si;
  double Dmob_Ve_di_Tempt_GND;
  double Dmob_Ve_si_Vge_e;
  double Dmob_Ve_si_Vdi_si;
  double Dmob_Ve_si_Ve_si;
  double Dmob_Ve_si_Ve_di;
  double Dmob_Ve_si_Vge_si;
  double Dmob_Ve_si_Tempt_GND;
  double Dmob_Vdi_si_Vge_e;
  double Dmob_Vdi_si_Vdi_si;
  double Dmob_Vdi_si_Ve_si;
  double Dmob_Vdi_si_Ve_di;
  double Dmob_Vdi_si_Vge_si;
  double Dmob_Vdi_si_Tempt_GND;
  double Dmob_Vge_e_Vge_e;
  double Dmob_Vge_e_Vdi_si;
  double Dmob_Vge_e_Ve_si;
  double Dmob_Vge_e_Ve_di;
  double Dmob_Vge_e_Vge_si;
  double Dmob_Vge_e_Tempt_GND;
#endif
#endif
double Eeffm;
#if defined(_DERIVATEFORDDX)
double Eeffm_Tempt_GND;
double Eeffm_Vdi_si;
double Eeffm_Vge_e;
double Eeffm_Ve_si;
double Eeffm_Ve_di;
double Eeffm_Vge_si;
#if defined(_DERIVATE2)
  double Eeffm_Vge_si_Tempt_GND;
  double Eeffm_Vge_si_Vdi_si;
  double Eeffm_Vge_si_Vge_e;
  double Eeffm_Vge_si_Ve_si;
  double Eeffm_Vge_si_Ve_di;
  double Eeffm_Vge_si_Vge_si;
  double Eeffm_Ve_di_Tempt_GND;
  double Eeffm_Ve_di_Vdi_si;
  double Eeffm_Ve_di_Vge_e;
  double Eeffm_Ve_di_Ve_si;
  double Eeffm_Ve_di_Ve_di;
  double Eeffm_Ve_di_Vge_si;
  double Eeffm_Ve_si_Tempt_GND;
  double Eeffm_Ve_si_Vdi_si;
  double Eeffm_Ve_si_Vge_e;
  double Eeffm_Ve_si_Ve_si;
  double Eeffm_Ve_si_Ve_di;
  double Eeffm_Ve_si_Vge_si;
  double Eeffm_Vge_e_Tempt_GND;
  double Eeffm_Vge_e_Vdi_si;
  double Eeffm_Vge_e_Vge_e;
  double Eeffm_Vge_e_Ve_si;
  double Eeffm_Vge_e_Ve_di;
  double Eeffm_Vge_e_Vge_si;
  double Eeffm_Vdi_si_Tempt_GND;
  double Eeffm_Vdi_si_Vdi_si;
  double Eeffm_Vdi_si_Vge_e;
  double Eeffm_Vdi_si_Ve_si;
  double Eeffm_Vdi_si_Ve_di;
  double Eeffm_Vdi_si_Vge_si;
  double Eeffm_Tempt_GND_Tempt_GND;
  double Eeffm_Tempt_GND_Vdi_si;
  double Eeffm_Tempt_GND_Vge_e;
  double Eeffm_Tempt_GND_Ve_si;
  double Eeffm_Tempt_GND_Ve_di;
  double Eeffm_Tempt_GND_Vge_si;
#endif
#endif
double beta;
#if defined(_DERIVATEFORDDX)
double beta_Tempt_GND;
double beta_Vdi_si;
#if defined(_DERIVATE2)
  double beta_Vdi_si_Tempt_GND;
  double beta_Vdi_si_Vdi_si;
  double beta_Tempt_GND_Tempt_GND;
  double beta_Tempt_GND_Vdi_si;
#endif
#endif
double coxeff;
#if defined(_DERIVATEFORDDX)
double coxeff_Vge_e;
double coxeff_Vdi_si;
double coxeff_Ve_si;
double coxeff_Ve_di;
double coxeff_Vge_si;
double coxeff_Tempt_GND;
#if defined(_DERIVATE2)
  double coxeff_Tempt_GND_Vge_e;
  double coxeff_Tempt_GND_Vdi_si;
  double coxeff_Tempt_GND_Ve_si;
  double coxeff_Tempt_GND_Ve_di;
  double coxeff_Tempt_GND_Vge_si;
  double coxeff_Tempt_GND_Tempt_GND;
  double coxeff_Vge_si_Vge_e;
  double coxeff_Vge_si_Vdi_si;
  double coxeff_Vge_si_Ve_si;
  double coxeff_Vge_si_Ve_di;
  double coxeff_Vge_si_Vge_si;
  double coxeff_Vge_si_Tempt_GND;
  double coxeff_Ve_di_Vge_e;
  double coxeff_Ve_di_Vdi_si;
  double coxeff_Ve_di_Ve_si;
  double coxeff_Ve_di_Ve_di;
  double coxeff_Ve_di_Vge_si;
  double coxeff_Ve_di_Tempt_GND;
  double coxeff_Ve_si_Vge_e;
  double coxeff_Ve_si_Vdi_si;
  double coxeff_Ve_si_Ve_si;
  double coxeff_Ve_si_Ve_di;
  double coxeff_Ve_si_Vge_si;
  double coxeff_Ve_si_Tempt_GND;
  double coxeff_Vdi_si_Vge_e;
  double coxeff_Vdi_si_Vdi_si;
  double coxeff_Vdi_si_Ve_si;
  double coxeff_Vdi_si_Ve_di;
  double coxeff_Vdi_si_Vge_si;
  double coxeff_Vdi_si_Tempt_GND;
  double coxeff_Vge_e_Vge_e;
  double coxeff_Vge_e_Vdi_si;
  double coxeff_Vge_e_Ve_si;
  double coxeff_Vge_e_Ve_di;
  double coxeff_Vge_e_Vge_si;
  double coxeff_Vge_e_Tempt_GND;
#endif
#endif
double qia2;
#if defined(_DERIVATEFORDDX)
double qia2_Vdi_si;
double qia2_Ve_si;
double qia2_Ve_di;
double qia2_Vge_si;
double qia2_Tempt_GND;
#if defined(_DERIVATE2)
  double qia2_Tempt_GND_Vdi_si;
  double qia2_Tempt_GND_Ve_si;
  double qia2_Tempt_GND_Ve_di;
  double qia2_Tempt_GND_Vge_si;
  double qia2_Tempt_GND_Tempt_GND;
  double qia2_Vge_si_Vdi_si;
  double qia2_Vge_si_Ve_si;
  double qia2_Vge_si_Ve_di;
  double qia2_Vge_si_Vge_si;
  double qia2_Vge_si_Tempt_GND;
  double qia2_Ve_di_Vdi_si;
  double qia2_Ve_di_Ve_si;
  double qia2_Ve_di_Ve_di;
  double qia2_Ve_di_Vge_si;
  double qia2_Ve_di_Tempt_GND;
  double qia2_Ve_si_Vdi_si;
  double qia2_Ve_si_Ve_si;
  double qia2_Ve_si_Ve_di;
  double qia2_Ve_si_Vge_si;
  double qia2_Ve_si_Tempt_GND;
  double qia2_Vdi_si_Vdi_si;
  double qia2_Vdi_si_Ve_si;
  double qia2_Vdi_si_Ve_di;
  double qia2_Vdi_si_Vge_si;
  double qia2_Vdi_si_Tempt_GND;
#endif
#endif
double dqi;
#if defined(_DERIVATEFORDDX)
double dqi_Vdi_si;
double dqi_Ve_si;
double dqi_Ve_di;
double dqi_Vge_si;
double dqi_Tempt_GND;
#if defined(_DERIVATE2)
  double dqi_Tempt_GND_Vdi_si;
  double dqi_Tempt_GND_Ve_si;
  double dqi_Tempt_GND_Ve_di;
  double dqi_Tempt_GND_Vge_si;
  double dqi_Tempt_GND_Tempt_GND;
  double dqi_Vge_si_Vdi_si;
  double dqi_Vge_si_Ve_si;
  double dqi_Vge_si_Ve_di;
  double dqi_Vge_si_Vge_si;
  double dqi_Vge_si_Tempt_GND;
  double dqi_Ve_di_Vdi_si;
  double dqi_Ve_di_Ve_si;
  double dqi_Ve_di_Ve_di;
  double dqi_Ve_di_Vge_si;
  double dqi_Ve_di_Tempt_GND;
  double dqi_Ve_si_Vdi_si;
  double dqi_Ve_si_Ve_si;
  double dqi_Ve_si_Ve_di;
  double dqi_Ve_si_Vge_si;
  double dqi_Ve_si_Tempt_GND;
  double dqi_Vdi_si_Vdi_si;
  double dqi_Vdi_si_Ve_si;
  double dqi_Vdi_si_Ve_di;
  double dqi_Vdi_si_Vge_si;
  double dqi_Vdi_si_Tempt_GND;
#endif
#endif
double qia;
#if defined(_DERIVATEFORDDX)
double qia_Vdi_si;
double qia_Ve_si;
double qia_Ve_di;
double qia_Vge_si;
double qia_Tempt_GND;
#if defined(_DERIVATE2)
  double qia_Tempt_GND_Vdi_si;
  double qia_Tempt_GND_Ve_si;
  double qia_Tempt_GND_Ve_di;
  double qia_Tempt_GND_Vge_si;
  double qia_Tempt_GND_Tempt_GND;
  double qia_Vge_si_Vdi_si;
  double qia_Vge_si_Ve_si;
  double qia_Vge_si_Ve_di;
  double qia_Vge_si_Vge_si;
  double qia_Vge_si_Tempt_GND;
  double qia_Ve_di_Vdi_si;
  double qia_Ve_di_Ve_si;
  double qia_Ve_di_Ve_di;
  double qia_Ve_di_Vge_si;
  double qia_Ve_di_Tempt_GND;
  double qia_Ve_si_Vdi_si;
  double qia_Ve_si_Ve_si;
  double qia_Ve_si_Ve_di;
  double qia_Ve_si_Vge_si;
  double qia_Ve_si_Tempt_GND;
  double qia_Vdi_si_Vdi_si;
  double qia_Vdi_si_Ve_si;
  double qia_Vdi_si_Ve_di;
  double qia_Vdi_si_Vge_si;
  double qia_Vdi_si_Tempt_GND;
#endif
#endif
double T10;
#if defined(_DERIVATEFORDDX)
double T10_Vge_di;
double T10_Vge_e;
double T10_Ve_si;
double T10_Ve_di;
double T10_Vge_si;
double T10_Vdi_si;
double T10_Tempt_GND;
#if defined(_DERIVATE2)
  double T10_Tempt_GND_Vge_di;
  double T10_Tempt_GND_Vge_e;
  double T10_Tempt_GND_Ve_si;
  double T10_Tempt_GND_Ve_di;
  double T10_Tempt_GND_Vge_si;
  double T10_Tempt_GND_Vdi_si;
  double T10_Tempt_GND_Tempt_GND;
  double T10_Vdi_si_Vge_di;
  double T10_Vdi_si_Vge_e;
  double T10_Vdi_si_Ve_si;
  double T10_Vdi_si_Ve_di;
  double T10_Vdi_si_Vge_si;
  double T10_Vdi_si_Vdi_si;
  double T10_Vdi_si_Tempt_GND;
  double T10_Vge_si_Vge_di;
  double T10_Vge_si_Vge_e;
  double T10_Vge_si_Ve_si;
  double T10_Vge_si_Ve_di;
  double T10_Vge_si_Vge_si;
  double T10_Vge_si_Vdi_si;
  double T10_Vge_si_Tempt_GND;
  double T10_Ve_di_Vge_di;
  double T10_Ve_di_Vge_e;
  double T10_Ve_di_Ve_si;
  double T10_Ve_di_Ve_di;
  double T10_Ve_di_Vge_si;
  double T10_Ve_di_Vdi_si;
  double T10_Ve_di_Tempt_GND;
  double T10_Ve_si_Vge_di;
  double T10_Ve_si_Vge_e;
  double T10_Ve_si_Ve_si;
  double T10_Ve_si_Ve_di;
  double T10_Ve_si_Vge_si;
  double T10_Ve_si_Vdi_si;
  double T10_Ve_si_Tempt_GND;
  double T10_Vge_e_Vge_di;
  double T10_Vge_e_Vge_e;
  double T10_Vge_e_Ve_si;
  double T10_Vge_e_Ve_di;
  double T10_Vge_e_Vge_si;
  double T10_Vge_e_Vdi_si;
  double T10_Vge_e_Tempt_GND;
  double T10_Vge_di_Vge_di;
  double T10_Vge_di_Vge_e;
  double T10_Vge_di_Ve_si;
  double T10_Vge_di_Ve_di;
  double T10_Vge_di_Vge_si;
  double T10_Vge_di_Vdi_si;
  double T10_Vge_di_Tempt_GND;
#endif
#endif
double T9;
#if defined(_DERIVATEFORDDX)
double T9_Vge_di;
double T9_Vdi_d;
double T9_Vsi_s;
double T9_Vge_e;
double T9_Ve_si;
double T9_Ve_di;
double T9_Vge_si;
double T9_Tempt_GND;
double T9_Vdi_si;
#if defined(_DERIVATE2)
  double T9_Vdi_si_Vge_di;
  double T9_Vdi_si_Vdi_d;
  double T9_Vdi_si_Vsi_s;
  double T9_Vdi_si_Vge_e;
  double T9_Vdi_si_Ve_si;
  double T9_Vdi_si_Ve_di;
  double T9_Vdi_si_Vge_si;
  double T9_Vdi_si_Tempt_GND;
  double T9_Vdi_si_Vdi_si;
  double T9_Tempt_GND_Vge_di;
  double T9_Tempt_GND_Vdi_d;
  double T9_Tempt_GND_Vsi_s;
  double T9_Tempt_GND_Vge_e;
  double T9_Tempt_GND_Ve_si;
  double T9_Tempt_GND_Ve_di;
  double T9_Tempt_GND_Vge_si;
  double T9_Tempt_GND_Tempt_GND;
  double T9_Tempt_GND_Vdi_si;
  double T9_Vge_si_Vge_di;
  double T9_Vge_si_Vdi_d;
  double T9_Vge_si_Vsi_s;
  double T9_Vge_si_Vge_e;
  double T9_Vge_si_Ve_si;
  double T9_Vge_si_Ve_di;
  double T9_Vge_si_Vge_si;
  double T9_Vge_si_Tempt_GND;
  double T9_Vge_si_Vdi_si;
  double T9_Ve_di_Vge_di;
  double T9_Ve_di_Vdi_d;
  double T9_Ve_di_Vsi_s;
  double T9_Ve_di_Vge_e;
  double T9_Ve_di_Ve_si;
  double T9_Ve_di_Ve_di;
  double T9_Ve_di_Vge_si;
  double T9_Ve_di_Tempt_GND;
  double T9_Ve_di_Vdi_si;
  double T9_Ve_si_Vge_di;
  double T9_Ve_si_Vdi_d;
  double T9_Ve_si_Vsi_s;
  double T9_Ve_si_Vge_e;
  double T9_Ve_si_Ve_si;
  double T9_Ve_si_Ve_di;
  double T9_Ve_si_Vge_si;
  double T9_Ve_si_Tempt_GND;
  double T9_Ve_si_Vdi_si;
  double T9_Vge_e_Vge_di;
  double T9_Vge_e_Vdi_d;
  double T9_Vge_e_Vsi_s;
  double T9_Vge_e_Vge_e;
  double T9_Vge_e_Ve_si;
  double T9_Vge_e_Ve_di;
  double T9_Vge_e_Vge_si;
  double T9_Vge_e_Tempt_GND;
  double T9_Vge_e_Vdi_si;
  double T9_Vsi_s_Vge_di;
  double T9_Vsi_s_Vdi_d;
  double T9_Vsi_s_Vsi_s;
  double T9_Vsi_s_Vge_e;
  double T9_Vsi_s_Ve_si;
  double T9_Vsi_s_Ve_di;
  double T9_Vsi_s_Vge_si;
  double T9_Vsi_s_Tempt_GND;
  double T9_Vsi_s_Vdi_si;
  double T9_Vdi_d_Vge_di;
  double T9_Vdi_d_Vdi_d;
  double T9_Vdi_d_Vsi_s;
  double T9_Vdi_d_Vge_e;
  double T9_Vdi_d_Ve_si;
  double T9_Vdi_d_Ve_di;
  double T9_Vdi_d_Vge_si;
  double T9_Vdi_d_Tempt_GND;
  double T9_Vdi_d_Vdi_si;
  double T9_Vge_di_Vge_di;
  double T9_Vge_di_Vdi_d;
  double T9_Vge_di_Vsi_s;
  double T9_Vge_di_Vge_e;
  double T9_Vge_di_Ve_si;
  double T9_Vge_di_Ve_di;
  double T9_Vge_di_Vge_si;
  double T9_Vge_di_Tempt_GND;
  double T9_Vge_di_Vdi_si;
#endif
#endif
double Vdseff;
#if defined(_DERIVATEFORDDX)
double Vdseff_Vdi_si;
double Vdseff_Ve_si;
double Vdseff_Ve_di;
double Vdseff_Vge_si;
double Vdseff_Tempt_GND;
#if defined(_DERIVATE2)
  double Vdseff_Tempt_GND_Vdi_si;
  double Vdseff_Tempt_GND_Ve_si;
  double Vdseff_Tempt_GND_Ve_di;
  double Vdseff_Tempt_GND_Vge_si;
  double Vdseff_Tempt_GND_Tempt_GND;
  double Vdseff_Vge_si_Vdi_si;
  double Vdseff_Vge_si_Ve_si;
  double Vdseff_Vge_si_Ve_di;
  double Vdseff_Vge_si_Vge_si;
  double Vdseff_Vge_si_Tempt_GND;
  double Vdseff_Ve_di_Vdi_si;
  double Vdseff_Ve_di_Ve_si;
  double Vdseff_Ve_di_Ve_di;
  double Vdseff_Ve_di_Vge_si;
  double Vdseff_Ve_di_Tempt_GND;
  double Vdseff_Ve_si_Vdi_si;
  double Vdseff_Ve_si_Ve_si;
  double Vdseff_Ve_si_Ve_di;
  double Vdseff_Ve_si_Vge_si;
  double Vdseff_Ve_si_Tempt_GND;
  double Vdseff_Vdi_si_Vdi_si;
  double Vdseff_Vdi_si_Ve_si;
  double Vdseff_Vdi_si_Ve_di;
  double Vdseff_Vdi_si_Vge_si;
  double Vdseff_Vdi_si_Tempt_GND;
#endif
#endif
double Tc;
#if defined(_DERIVATEFORDDX)
double Tc_Vdi_si;
double Tc_Tempt_GND;
double Tc_Ve_si;
double Tc_Ve_di;
double Tc_Vge_si;
#if defined(_DERIVATE2)
  double Tc_Vge_si_Vdi_si;
  double Tc_Vge_si_Tempt_GND;
  double Tc_Vge_si_Ve_si;
  double Tc_Vge_si_Ve_di;
  double Tc_Vge_si_Vge_si;
  double Tc_Ve_di_Vdi_si;
  double Tc_Ve_di_Tempt_GND;
  double Tc_Ve_di_Ve_si;
  double Tc_Ve_di_Ve_di;
  double Tc_Ve_di_Vge_si;
  double Tc_Ve_si_Vdi_si;
  double Tc_Ve_si_Tempt_GND;
  double Tc_Ve_si_Ve_si;
  double Tc_Ve_si_Ve_di;
  double Tc_Ve_si_Vge_si;
  double Tc_Tempt_GND_Vdi_si;
  double Tc_Tempt_GND_Tempt_GND;
  double Tc_Tempt_GND_Ve_si;
  double Tc_Tempt_GND_Ve_di;
  double Tc_Tempt_GND_Vge_si;
  double Tc_Vdi_si_Vdi_si;
  double Tc_Vdi_si_Tempt_GND;
  double Tc_Vdi_si_Ve_si;
  double Tc_Vdi_si_Ve_di;
  double Tc_Vdi_si_Vge_si;
#endif
#endif
double Ta;
#if defined(_DERIVATEFORDDX)
double Ta_Ve_si;
double Ta_Ve_di;
double Ta_Vge_si;
double Ta_Vdi_si;
double Ta_Tempt_GND;
#if defined(_DERIVATE2)
  double Ta_Tempt_GND_Ve_si;
  double Ta_Tempt_GND_Ve_di;
  double Ta_Tempt_GND_Vge_si;
  double Ta_Tempt_GND_Vdi_si;
  double Ta_Tempt_GND_Tempt_GND;
  double Ta_Vdi_si_Ve_si;
  double Ta_Vdi_si_Ve_di;
  double Ta_Vdi_si_Vge_si;
  double Ta_Vdi_si_Vdi_si;
  double Ta_Vdi_si_Tempt_GND;
  double Ta_Vge_si_Ve_si;
  double Ta_Vge_si_Ve_di;
  double Ta_Vge_si_Vge_si;
  double Ta_Vge_si_Vdi_si;
  double Ta_Vge_si_Tempt_GND;
  double Ta_Ve_di_Ve_si;
  double Ta_Ve_di_Ve_di;
  double Ta_Ve_di_Vge_si;
  double Ta_Ve_di_Vdi_si;
  double Ta_Ve_di_Tempt_GND;
  double Ta_Ve_si_Ve_si;
  double Ta_Ve_si_Ve_di;
  double Ta_Ve_si_Vge_si;
  double Ta_Ve_si_Vdi_si;
  double Ta_Ve_si_Tempt_GND;
#endif
#endif
double WVCox;
#if defined(_DERIVATEFORDDX)
double WVCox_Tempt_GND;
double WVCox_Vdi_si;
#if defined(_DERIVATE2)
  double WVCox_Vdi_si_Tempt_GND;
  double WVCox_Vdi_si_Vdi_si;
  double WVCox_Tempt_GND_Tempt_GND;
  double WVCox_Tempt_GND_Vdi_si;
#endif
#endif
double Vdsat;
#if defined(_DERIVATEFORDDX)
double Vdsat_Tempt_GND;
double Vdsat_Vdi_si;
double Vdsat_Ve_si;
double Vdsat_Ve_di;
double Vdsat_Vge_si;
#if defined(_DERIVATE2)
  double Vdsat_Vge_si_Tempt_GND;
  double Vdsat_Vge_si_Vdi_si;
  double Vdsat_Vge_si_Ve_si;
  double Vdsat_Vge_si_Ve_di;
  double Vdsat_Vge_si_Vge_si;
  double Vdsat_Ve_di_Tempt_GND;
  double Vdsat_Ve_di_Vdi_si;
  double Vdsat_Ve_di_Ve_si;
  double Vdsat_Ve_di_Ve_di;
  double Vdsat_Ve_di_Vge_si;
  double Vdsat_Ve_si_Tempt_GND;
  double Vdsat_Ve_si_Vdi_si;
  double Vdsat_Ve_si_Ve_si;
  double Vdsat_Ve_si_Ve_di;
  double Vdsat_Ve_si_Vge_si;
  double Vdsat_Vdi_si_Tempt_GND;
  double Vdsat_Vdi_si_Vdi_si;
  double Vdsat_Vdi_si_Ve_si;
  double Vdsat_Vdi_si_Ve_di;
  double Vdsat_Vdi_si_Vge_si;
  double Vdsat_Tempt_GND_Tempt_GND;
  double Vdsat_Tempt_GND_Vdi_si;
  double Vdsat_Tempt_GND_Ve_si;
  double Vdsat_Tempt_GND_Ve_di;
  double Vdsat_Tempt_GND_Vge_si;
#endif
#endif
double T6;
#if defined(_DERIVATEFORDDX)
double T6_Vge_di;
double T6_Vdi_d;
double T6_Vsi_s;
double T6_Vge_e;
double T6_Vdi_si;
double T6_Tempt_GND;
double T6_Ve_si;
double T6_Ve_di;
double T6_Vge_si;
#if defined(_DERIVATE2)
  double T6_Vge_si_Vge_di;
  double T6_Vge_si_Vdi_d;
  double T6_Vge_si_Vsi_s;
  double T6_Vge_si_Vge_e;
  double T6_Vge_si_Vdi_si;
  double T6_Vge_si_Tempt_GND;
  double T6_Vge_si_Ve_si;
  double T6_Vge_si_Ve_di;
  double T6_Vge_si_Vge_si;
  double T6_Ve_di_Vge_di;
  double T6_Ve_di_Vdi_d;
  double T6_Ve_di_Vsi_s;
  double T6_Ve_di_Vge_e;
  double T6_Ve_di_Vdi_si;
  double T6_Ve_di_Tempt_GND;
  double T6_Ve_di_Ve_si;
  double T6_Ve_di_Ve_di;
  double T6_Ve_di_Vge_si;
  double T6_Ve_si_Vge_di;
  double T6_Ve_si_Vdi_d;
  double T6_Ve_si_Vsi_s;
  double T6_Ve_si_Vge_e;
  double T6_Ve_si_Vdi_si;
  double T6_Ve_si_Tempt_GND;
  double T6_Ve_si_Ve_si;
  double T6_Ve_si_Ve_di;
  double T6_Ve_si_Vge_si;
  double T6_Tempt_GND_Vge_di;
  double T6_Tempt_GND_Vdi_d;
  double T6_Tempt_GND_Vsi_s;
  double T6_Tempt_GND_Vge_e;
  double T6_Tempt_GND_Vdi_si;
  double T6_Tempt_GND_Tempt_GND;
  double T6_Tempt_GND_Ve_si;
  double T6_Tempt_GND_Ve_di;
  double T6_Tempt_GND_Vge_si;
  double T6_Vdi_si_Vge_di;
  double T6_Vdi_si_Vdi_d;
  double T6_Vdi_si_Vsi_s;
  double T6_Vdi_si_Vge_e;
  double T6_Vdi_si_Vdi_si;
  double T6_Vdi_si_Tempt_GND;
  double T6_Vdi_si_Ve_si;
  double T6_Vdi_si_Ve_di;
  double T6_Vdi_si_Vge_si;
  double T6_Vge_e_Vge_di;
  double T6_Vge_e_Vdi_d;
  double T6_Vge_e_Vsi_s;
  double T6_Vge_e_Vge_e;
  double T6_Vge_e_Vdi_si;
  double T6_Vge_e_Tempt_GND;
  double T6_Vge_e_Ve_si;
  double T6_Vge_e_Ve_di;
  double T6_Vge_e_Vge_si;
  double T6_Vsi_s_Vge_di;
  double T6_Vsi_s_Vdi_d;
  double T6_Vsi_s_Vsi_s;
  double T6_Vsi_s_Vge_e;
  double T6_Vsi_s_Vdi_si;
  double T6_Vsi_s_Tempt_GND;
  double T6_Vsi_s_Ve_si;
  double T6_Vsi_s_Ve_di;
  double T6_Vsi_s_Vge_si;
  double T6_Vdi_d_Vge_di;
  double T6_Vdi_d_Vdi_d;
  double T6_Vdi_d_Vsi_s;
  double T6_Vdi_d_Vge_e;
  double T6_Vdi_d_Vdi_si;
  double T6_Vdi_d_Tempt_GND;
  double T6_Vdi_d_Ve_si;
  double T6_Vdi_d_Ve_di;
  double T6_Vdi_d_Vge_si;
  double T6_Vge_di_Vge_di;
  double T6_Vge_di_Vdi_d;
  double T6_Vge_di_Vsi_s;
  double T6_Vge_di_Vge_e;
  double T6_Vge_di_Vdi_si;
  double T6_Vge_di_Tempt_GND;
  double T6_Vge_di_Ve_si;
  double T6_Vge_di_Ve_di;
  double T6_Vge_di_Vge_si;
#endif
#endif
double EsatL;
#if defined(_DERIVATEFORDDX)
double EsatL_Tempt_GND;
double EsatL_Vdi_si;
double EsatL_Ve_si;
double EsatL_Ve_di;
double EsatL_Vge_si;
#if defined(_DERIVATE2)
  double EsatL_Vge_si_Tempt_GND;
  double EsatL_Vge_si_Vdi_si;
  double EsatL_Vge_si_Ve_si;
  double EsatL_Vge_si_Ve_di;
  double EsatL_Vge_si_Vge_si;
  double EsatL_Ve_di_Tempt_GND;
  double EsatL_Ve_di_Vdi_si;
  double EsatL_Ve_di_Ve_si;
  double EsatL_Ve_di_Ve_di;
  double EsatL_Ve_di_Vge_si;
  double EsatL_Ve_si_Tempt_GND;
  double EsatL_Ve_si_Vdi_si;
  double EsatL_Ve_si_Ve_si;
  double EsatL_Ve_si_Ve_di;
  double EsatL_Ve_si_Vge_si;
  double EsatL_Vdi_si_Tempt_GND;
  double EsatL_Vdi_si_Vdi_si;
  double EsatL_Vdi_si_Ve_si;
  double EsatL_Vdi_si_Ve_di;
  double EsatL_Vdi_si_Vge_si;
  double EsatL_Tempt_GND_Tempt_GND;
  double EsatL_Tempt_GND_Vdi_si;
  double EsatL_Tempt_GND_Ve_si;
  double EsatL_Tempt_GND_Ve_di;
  double EsatL_Tempt_GND_Vge_si;
#endif
#endif
double Esat;
#if defined(_DERIVATEFORDDX)
double Esat_Tempt_GND;
double Esat_Vdi_si;
double Esat_Ve_si;
double Esat_Ve_di;
double Esat_Vge_si;
#if defined(_DERIVATE2)
  double Esat_Vge_si_Tempt_GND;
  double Esat_Vge_si_Vdi_si;
  double Esat_Vge_si_Ve_si;
  double Esat_Vge_si_Ve_di;
  double Esat_Vge_si_Vge_si;
  double Esat_Ve_di_Tempt_GND;
  double Esat_Ve_di_Vdi_si;
  double Esat_Ve_di_Ve_si;
  double Esat_Ve_di_Ve_di;
  double Esat_Ve_di_Vge_si;
  double Esat_Ve_si_Tempt_GND;
  double Esat_Ve_si_Vdi_si;
  double Esat_Ve_si_Ve_si;
  double Esat_Ve_si_Ve_di;
  double Esat_Ve_si_Vge_si;
  double Esat_Vdi_si_Tempt_GND;
  double Esat_Vdi_si_Vdi_si;
  double Esat_Vdi_si_Ve_si;
  double Esat_Vdi_si_Ve_di;
  double Esat_Vdi_si_Vge_si;
  double Esat_Tempt_GND_Tempt_GND;
  double Esat_Tempt_GND_Vdi_si;
  double Esat_Tempt_GND_Ve_si;
  double Esat_Tempt_GND_Ve_di;
  double Esat_Tempt_GND_Vge_si;
#endif
#endif
double Rdss;
#if defined(_DERIVATEFORDDX)
double Rdss_Ve_si;
double Rdss_Ve_di;
double Rdss_Vge_si;
double Rdss_Vdi_si;
double Rdss_Tempt_GND;
#if defined(_DERIVATE2)
  double Rdss_Tempt_GND_Ve_si;
  double Rdss_Tempt_GND_Ve_di;
  double Rdss_Tempt_GND_Vge_si;
  double Rdss_Tempt_GND_Vdi_si;
  double Rdss_Tempt_GND_Tempt_GND;
  double Rdss_Vdi_si_Ve_si;
  double Rdss_Vdi_si_Ve_di;
  double Rdss_Vdi_si_Vge_si;
  double Rdss_Vdi_si_Vdi_si;
  double Rdss_Vdi_si_Tempt_GND;
  double Rdss_Vge_si_Ve_si;
  double Rdss_Vge_si_Ve_di;
  double Rdss_Vge_si_Vge_si;
  double Rdss_Vge_si_Vdi_si;
  double Rdss_Vge_si_Tempt_GND;
  double Rdss_Ve_di_Ve_si;
  double Rdss_Ve_di_Ve_di;
  double Rdss_Ve_di_Vge_si;
  double Rdss_Ve_di_Vdi_si;
  double Rdss_Ve_di_Tempt_GND;
  double Rdss_Ve_si_Ve_si;
  double Rdss_Ve_si_Ve_di;
  double Rdss_Ve_si_Vge_si;
  double Rdss_Ve_si_Vdi_si;
  double Rdss_Ve_si_Tempt_GND;
#endif
#endif
double Dmobs;
#if defined(_DERIVATEFORDDX)
double Dmobs_Vdi_si;
double Dmobs_Ve_si;
double Dmobs_Ve_di;
double Dmobs_Vge_si;
double Dmobs_Tempt_GND;
#if defined(_DERIVATE2)
  double Dmobs_Tempt_GND_Vdi_si;
  double Dmobs_Tempt_GND_Ve_si;
  double Dmobs_Tempt_GND_Ve_di;
  double Dmobs_Tempt_GND_Vge_si;
  double Dmobs_Tempt_GND_Tempt_GND;
  double Dmobs_Vge_si_Vdi_si;
  double Dmobs_Vge_si_Ve_si;
  double Dmobs_Vge_si_Ve_di;
  double Dmobs_Vge_si_Vge_si;
  double Dmobs_Vge_si_Tempt_GND;
  double Dmobs_Ve_di_Vdi_si;
  double Dmobs_Ve_di_Ve_si;
  double Dmobs_Ve_di_Ve_di;
  double Dmobs_Ve_di_Vge_si;
  double Dmobs_Ve_di_Tempt_GND;
  double Dmobs_Ve_si_Vdi_si;
  double Dmobs_Ve_si_Ve_si;
  double Dmobs_Ve_si_Ve_di;
  double Dmobs_Ve_si_Vge_si;
  double Dmobs_Ve_si_Tempt_GND;
  double Dmobs_Vdi_si_Vdi_si;
  double Dmobs_Vdi_si_Ve_si;
  double Dmobs_Vdi_si_Ve_di;
  double Dmobs_Vdi_si_Vge_si;
  double Dmobs_Vdi_si_Tempt_GND;
#endif
#endif
double qb0;
double Eeffs;
#if defined(_DERIVATEFORDDX)
double Eeffs_Tempt_GND;
double Eeffs_Vdi_si;
double Eeffs_Ve_si;
double Eeffs_Ve_di;
double Eeffs_Vge_si;
#if defined(_DERIVATE2)
  double Eeffs_Vge_si_Tempt_GND;
  double Eeffs_Vge_si_Vdi_si;
  double Eeffs_Vge_si_Ve_si;
  double Eeffs_Vge_si_Ve_di;
  double Eeffs_Vge_si_Vge_si;
  double Eeffs_Ve_di_Tempt_GND;
  double Eeffs_Ve_di_Vdi_si;
  double Eeffs_Ve_di_Ve_si;
  double Eeffs_Ve_di_Ve_di;
  double Eeffs_Ve_di_Vge_si;
  double Eeffs_Ve_si_Tempt_GND;
  double Eeffs_Ve_si_Vdi_si;
  double Eeffs_Ve_si_Ve_si;
  double Eeffs_Ve_si_Ve_di;
  double Eeffs_Ve_si_Vge_si;
  double Eeffs_Vdi_si_Tempt_GND;
  double Eeffs_Vdi_si_Vdi_si;
  double Eeffs_Vdi_si_Ve_si;
  double Eeffs_Vdi_si_Ve_di;
  double Eeffs_Vdi_si_Vge_si;
  double Eeffs_Tempt_GND_Tempt_GND;
  double Eeffs_Tempt_GND_Vdi_si;
  double Eeffs_Tempt_GND_Ve_si;
  double Eeffs_Tempt_GND_Ve_di;
  double Eeffs_Tempt_GND_Vge_si;
#endif
#endif
double T5;
#if defined(_DERIVATEFORDDX)
double T5_Vge_di;
double T5_Vdi_d;
double T5_Vsi_s;
double T5_Vge_e;
double T5_Vdi_si;
double T5_Ve_si;
double T5_Ve_di;
double T5_Vge_si;
double T5_Tempt_GND;
#if defined(_DERIVATE2)
  double T5_Tempt_GND_Vge_di;
  double T5_Tempt_GND_Vdi_d;
  double T5_Tempt_GND_Vsi_s;
  double T5_Tempt_GND_Vge_e;
  double T5_Tempt_GND_Vdi_si;
  double T5_Tempt_GND_Ve_si;
  double T5_Tempt_GND_Ve_di;
  double T5_Tempt_GND_Vge_si;
  double T5_Tempt_GND_Tempt_GND;
  double T5_Vge_si_Vge_di;
  double T5_Vge_si_Vdi_d;
  double T5_Vge_si_Vsi_s;
  double T5_Vge_si_Vge_e;
  double T5_Vge_si_Vdi_si;
  double T5_Vge_si_Ve_si;
  double T5_Vge_si_Ve_di;
  double T5_Vge_si_Vge_si;
  double T5_Vge_si_Tempt_GND;
  double T5_Ve_di_Vge_di;
  double T5_Ve_di_Vdi_d;
  double T5_Ve_di_Vsi_s;
  double T5_Ve_di_Vge_e;
  double T5_Ve_di_Vdi_si;
  double T5_Ve_di_Ve_si;
  double T5_Ve_di_Ve_di;
  double T5_Ve_di_Vge_si;
  double T5_Ve_di_Tempt_GND;
  double T5_Ve_si_Vge_di;
  double T5_Ve_si_Vdi_d;
  double T5_Ve_si_Vsi_s;
  double T5_Ve_si_Vge_e;
  double T5_Ve_si_Vdi_si;
  double T5_Ve_si_Ve_si;
  double T5_Ve_si_Ve_di;
  double T5_Ve_si_Vge_si;
  double T5_Ve_si_Tempt_GND;
  double T5_Vdi_si_Vge_di;
  double T5_Vdi_si_Vdi_d;
  double T5_Vdi_si_Vsi_s;
  double T5_Vdi_si_Vge_e;
  double T5_Vdi_si_Vdi_si;
  double T5_Vdi_si_Ve_si;
  double T5_Vdi_si_Ve_di;
  double T5_Vdi_si_Vge_si;
  double T5_Vdi_si_Tempt_GND;
  double T5_Vge_e_Vge_di;
  double T5_Vge_e_Vdi_d;
  double T5_Vge_e_Vsi_s;
  double T5_Vge_e_Vge_e;
  double T5_Vge_e_Vdi_si;
  double T5_Vge_e_Ve_si;
  double T5_Vge_e_Ve_di;
  double T5_Vge_e_Vge_si;
  double T5_Vge_e_Tempt_GND;
  double T5_Vsi_s_Vge_di;
  double T5_Vsi_s_Vdi_d;
  double T5_Vsi_s_Vsi_s;
  double T5_Vsi_s_Vge_e;
  double T5_Vsi_s_Vdi_si;
  double T5_Vsi_s_Ve_si;
  double T5_Vsi_s_Ve_di;
  double T5_Vsi_s_Vge_si;
  double T5_Vsi_s_Tempt_GND;
  double T5_Vdi_d_Vge_di;
  double T5_Vdi_d_Vdi_d;
  double T5_Vdi_d_Vsi_s;
  double T5_Vdi_d_Vge_e;
  double T5_Vdi_d_Vdi_si;
  double T5_Vdi_d_Ve_si;
  double T5_Vdi_d_Ve_di;
  double T5_Vdi_d_Vge_si;
  double T5_Vdi_d_Tempt_GND;
  double T5_Vge_di_Vge_di;
  double T5_Vge_di_Vdi_d;
  double T5_Vge_di_Vsi_s;
  double T5_Vge_di_Vge_e;
  double T5_Vge_di_Vdi_si;
  double T5_Vge_di_Ve_si;
  double T5_Vge_di_Ve_di;
  double T5_Vge_di_Vge_si;
  double T5_Vge_di_Tempt_GND;
#endif
#endif
double T4;
#if defined(_DERIVATEFORDDX)
double T4_Vge_di;
double T4_Vge_e;
double T4_Vdi_si;
double T4_Ve_si;
double T4_Ve_di;
double T4_Vge_si;
double T4_Tempt_GND;
#if defined(_DERIVATE2)
  double T4_Tempt_GND_Vge_di;
  double T4_Tempt_GND_Vge_e;
  double T4_Tempt_GND_Vdi_si;
  double T4_Tempt_GND_Ve_si;
  double T4_Tempt_GND_Ve_di;
  double T4_Tempt_GND_Vge_si;
  double T4_Tempt_GND_Tempt_GND;
  double T4_Vge_si_Vge_di;
  double T4_Vge_si_Vge_e;
  double T4_Vge_si_Vdi_si;
  double T4_Vge_si_Ve_si;
  double T4_Vge_si_Ve_di;
  double T4_Vge_si_Vge_si;
  double T4_Vge_si_Tempt_GND;
  double T4_Ve_di_Vge_di;
  double T4_Ve_di_Vge_e;
  double T4_Ve_di_Vdi_si;
  double T4_Ve_di_Ve_si;
  double T4_Ve_di_Ve_di;
  double T4_Ve_di_Vge_si;
  double T4_Ve_di_Tempt_GND;
  double T4_Ve_si_Vge_di;
  double T4_Ve_si_Vge_e;
  double T4_Ve_si_Vdi_si;
  double T4_Ve_si_Ve_si;
  double T4_Ve_si_Ve_di;
  double T4_Ve_si_Vge_si;
  double T4_Ve_si_Tempt_GND;
  double T4_Vdi_si_Vge_di;
  double T4_Vdi_si_Vge_e;
  double T4_Vdi_si_Vdi_si;
  double T4_Vdi_si_Ve_si;
  double T4_Vdi_si_Ve_di;
  double T4_Vdi_si_Vge_si;
  double T4_Vdi_si_Tempt_GND;
  double T4_Vge_e_Vge_di;
  double T4_Vge_e_Vge_e;
  double T4_Vge_e_Vdi_si;
  double T4_Vge_e_Ve_si;
  double T4_Vge_e_Ve_di;
  double T4_Vge_e_Vge_si;
  double T4_Vge_e_Tempt_GND;
  double T4_Vge_di_Vge_di;
  double T4_Vge_di_Vge_e;
  double T4_Vge_di_Vdi_si;
  double T4_Vge_di_Ve_si;
  double T4_Vge_di_Ve_di;
  double T4_Vge_di_Vge_si;
  double T4_Vge_di_Tempt_GND;
#endif
#endif
double T8;
#if defined(_DERIVATEFORDDX)
double T8_Vge_e;
double T8_Vdi_si;
double T8_Ve_si;
double T8_Ve_di;
double T8_Vge_si;
double T8_Tempt_GND;
#if defined(_DERIVATE2)
  double T8_Tempt_GND_Vge_e;
  double T8_Tempt_GND_Vdi_si;
  double T8_Tempt_GND_Ve_si;
  double T8_Tempt_GND_Ve_di;
  double T8_Tempt_GND_Vge_si;
  double T8_Tempt_GND_Tempt_GND;
  double T8_Vge_si_Vge_e;
  double T8_Vge_si_Vdi_si;
  double T8_Vge_si_Ve_si;
  double T8_Vge_si_Ve_di;
  double T8_Vge_si_Vge_si;
  double T8_Vge_si_Tempt_GND;
  double T8_Ve_di_Vge_e;
  double T8_Ve_di_Vdi_si;
  double T8_Ve_di_Ve_si;
  double T8_Ve_di_Ve_di;
  double T8_Ve_di_Vge_si;
  double T8_Ve_di_Tempt_GND;
  double T8_Ve_si_Vge_e;
  double T8_Ve_si_Vdi_si;
  double T8_Ve_si_Ve_si;
  double T8_Ve_si_Ve_di;
  double T8_Ve_si_Vge_si;
  double T8_Ve_si_Tempt_GND;
  double T8_Vdi_si_Vge_e;
  double T8_Vdi_si_Vdi_si;
  double T8_Vdi_si_Ve_si;
  double T8_Vdi_si_Ve_di;
  double T8_Vdi_si_Vge_si;
  double T8_Vdi_si_Tempt_GND;
  double T8_Vge_e_Vge_e;
  double T8_Vge_e_Vdi_si;
  double T8_Vge_e_Ve_si;
  double T8_Vge_e_Ve_di;
  double T8_Vge_e_Vge_si;
  double T8_Vge_e_Tempt_GND;
#endif
#endif
double T7;
#if defined(_DERIVATEFORDDX)
double T7_Vge_di;
double T7_Vdi_d;
double T7_Vsi_s;
double T7_Vge_e;
double T7_Vdi_si;
double T7_Ve_si;
double T7_Ve_di;
double T7_Vge_si;
double T7_Tempt_GND;
#if defined(_DERIVATE2)
  double T7_Tempt_GND_Vge_di;
  double T7_Tempt_GND_Vdi_d;
  double T7_Tempt_GND_Vsi_s;
  double T7_Tempt_GND_Vge_e;
  double T7_Tempt_GND_Vdi_si;
  double T7_Tempt_GND_Ve_si;
  double T7_Tempt_GND_Ve_di;
  double T7_Tempt_GND_Vge_si;
  double T7_Tempt_GND_Tempt_GND;
  double T7_Vge_si_Vge_di;
  double T7_Vge_si_Vdi_d;
  double T7_Vge_si_Vsi_s;
  double T7_Vge_si_Vge_e;
  double T7_Vge_si_Vdi_si;
  double T7_Vge_si_Ve_si;
  double T7_Vge_si_Ve_di;
  double T7_Vge_si_Vge_si;
  double T7_Vge_si_Tempt_GND;
  double T7_Ve_di_Vge_di;
  double T7_Ve_di_Vdi_d;
  double T7_Ve_di_Vsi_s;
  double T7_Ve_di_Vge_e;
  double T7_Ve_di_Vdi_si;
  double T7_Ve_di_Ve_si;
  double T7_Ve_di_Ve_di;
  double T7_Ve_di_Vge_si;
  double T7_Ve_di_Tempt_GND;
  double T7_Ve_si_Vge_di;
  double T7_Ve_si_Vdi_d;
  double T7_Ve_si_Vsi_s;
  double T7_Ve_si_Vge_e;
  double T7_Ve_si_Vdi_si;
  double T7_Ve_si_Ve_si;
  double T7_Ve_si_Ve_di;
  double T7_Ve_si_Vge_si;
  double T7_Ve_si_Tempt_GND;
  double T7_Vdi_si_Vge_di;
  double T7_Vdi_si_Vdi_d;
  double T7_Vdi_si_Vsi_s;
  double T7_Vdi_si_Vge_e;
  double T7_Vdi_si_Vdi_si;
  double T7_Vdi_si_Ve_si;
  double T7_Vdi_si_Ve_di;
  double T7_Vdi_si_Vge_si;
  double T7_Vdi_si_Tempt_GND;
  double T7_Vge_e_Vge_di;
  double T7_Vge_e_Vdi_d;
  double T7_Vge_e_Vsi_s;
  double T7_Vge_e_Vge_e;
  double T7_Vge_e_Vdi_si;
  double T7_Vge_e_Ve_si;
  double T7_Vge_e_Ve_di;
  double T7_Vge_e_Vge_si;
  double T7_Vge_e_Tempt_GND;
  double T7_Vsi_s_Vge_di;
  double T7_Vsi_s_Vdi_d;
  double T7_Vsi_s_Vsi_s;
  double T7_Vsi_s_Vge_e;
  double T7_Vsi_s_Vdi_si;
  double T7_Vsi_s_Ve_si;
  double T7_Vsi_s_Ve_di;
  double T7_Vsi_s_Vge_si;
  double T7_Vsi_s_Tempt_GND;
  double T7_Vdi_d_Vge_di;
  double T7_Vdi_d_Vdi_d;
  double T7_Vdi_d_Vsi_s;
  double T7_Vdi_d_Vge_e;
  double T7_Vdi_d_Vdi_si;
  double T7_Vdi_d_Ve_si;
  double T7_Vdi_d_Ve_di;
  double T7_Vdi_d_Vge_si;
  double T7_Vdi_d_Tempt_GND;
  double T7_Vge_di_Vge_di;
  double T7_Vge_di_Vdi_d;
  double T7_Vge_di_Vsi_s;
  double T7_Vge_di_Vge_e;
  double T7_Vge_di_Vdi_si;
  double T7_Vge_di_Ve_si;
  double T7_Vge_di_Ve_di;
  double T7_Vge_di_Vge_si;
  double T7_Vge_di_Tempt_GND;
#endif
#endif
double vch;
#if defined(_DERIVATEFORDDX)
double vch_Vdi_si;
double vch_Ve_si;
double vch_Ve_di;
double vch_Vge_si;
double vch_Tempt_GND;
#if defined(_DERIVATE2)
  double vch_Tempt_GND_Vdi_si;
  double vch_Tempt_GND_Ve_si;
  double vch_Tempt_GND_Ve_di;
  double vch_Tempt_GND_Vge_si;
  double vch_Tempt_GND_Tempt_GND;
  double vch_Vge_si_Vdi_si;
  double vch_Vge_si_Ve_si;
  double vch_Vge_si_Ve_di;
  double vch_Vge_si_Vge_si;
  double vch_Vge_si_Tempt_GND;
  double vch_Ve_di_Vdi_si;
  double vch_Ve_di_Ve_si;
  double vch_Ve_di_Ve_di;
  double vch_Ve_di_Vge_si;
  double vch_Ve_di_Tempt_GND;
  double vch_Ve_si_Vdi_si;
  double vch_Ve_si_Ve_si;
  double vch_Ve_si_Ve_di;
  double vch_Ve_si_Vge_si;
  double vch_Ve_si_Tempt_GND;
  double vch_Vdi_si_Vdi_si;
  double vch_Vdi_si_Ve_si;
  double vch_Vdi_si_Ve_di;
  double vch_Vdi_si_Vge_si;
  double vch_Vdi_si_Tempt_GND;
#endif
#endif
double vgsfbeff;
#if defined(_DERIVATEFORDDX)
double vgsfbeff_Vge_si;
double vgsfbeff_Vdi_si;
double vgsfbeff_Tempt_GND;
#if defined(_DERIVATE2)
  double vgsfbeff_Tempt_GND_Vge_si;
  double vgsfbeff_Tempt_GND_Vdi_si;
  double vgsfbeff_Tempt_GND_Tempt_GND;
  double vgsfbeff_Vdi_si_Vge_si;
  double vgsfbeff_Vdi_si_Vdi_si;
  double vgsfbeff_Vdi_si_Tempt_GND;
  double vgsfbeff_Vge_si_Vge_si;
  double vgsfbeff_Vge_si_Vdi_si;
  double vgsfbeff_Vge_si_Tempt_GND;
#endif
#endif
double beta0;
#if defined(_DERIVATEFORDDX)
double beta0_Tempt_GND;
double beta0_Vdi_si;
#if defined(_DERIVATE2)
  double beta0_Vdi_si_Tempt_GND;
  double beta0_Vdi_si_Vdi_si;
  double beta0_Tempt_GND_Tempt_GND;
  double beta0_Tempt_GND_Vdi_si;
#endif
#endif
double dvth_all;
#if defined(_DERIVATEFORDDX)
double dvth_all_Tempt_GND;
double dvth_all_Vdi_si;
#if defined(_DERIVATE2)
  double dvth_all_Vdi_si_Tempt_GND;
  double dvth_all_Vdi_si_Vdi_si;
  double dvth_all_Tempt_GND_Tempt_GND;
  double dvth_all_Tempt_GND_Vdi_si;
#endif
#endif
double dvth_rsce;
#if defined(_DERIVATEFORDDX)
double dvth_rsce_Tempt_GND;
#if defined(_DERIVATE2)
  double dvth_rsce_Tempt_GND_Tempt_GND;
#endif
#endif
double dvth_dibl;
#if defined(_DERIVATEFORDDX)
double dvth_dibl_Tempt_GND;
double dvth_dibl_Vdi_si;
#if defined(_DERIVATE2)
  double dvth_dibl_Vdi_si_Tempt_GND;
  double dvth_dibl_Vdi_si_Vdi_si;
  double dvth_dibl_Tempt_GND_Tempt_GND;
  double dvth_dibl_Tempt_GND_Vdi_si;
#endif
#endif
double dvth_vtroll;
#if defined(_DERIVATEFORDDX)
double dvth_vtroll_Tempt_GND;
#if defined(_DERIVATE2)
  double dvth_vtroll_Tempt_GND_Tempt_GND;
#endif
#endif
double nVtm;
#if defined(_DERIVATEFORDDX)
double nVtm_Tempt_GND;
double nVtm_Vdi_si;
#if defined(_DERIVATE2)
  double nVtm_Vdi_si_Tempt_GND;
  double nVtm_Vdi_si_Vdi_si;
  double nVtm_Tempt_GND_Tempt_GND;
  double nVtm_Tempt_GND_Vdi_si;
#endif
#endif
double cdsc;
#if defined(_DERIVATEFORDDX)
double cdsc_Vdi_si;
double cdsc_Tempt_GND;
#if defined(_DERIVATE2)
  double cdsc_Tempt_GND_Vdi_si;
  double cdsc_Tempt_GND_Tempt_GND;
  double cdsc_Vdi_si_Vdi_si;
  double cdsc_Vdi_si_Tempt_GND;
#endif
#endif
double phist;
#if defined(_DERIVATEFORDDX)
double phist_Tempt_GND;
#if defined(_DERIVATE2)
  double phist_Tempt_GND_Tempt_GND;
#endif
#endif
double inv_MEXP;
#if defined(_DERIVATEFORDDX)
double inv_MEXP_Tempt_GND;
double inv_MEXP_Vdi_si;
#if defined(_DERIVATE2)
  double inv_MEXP_Vdi_si_Tempt_GND;
  double inv_MEXP_Vdi_si_Vdi_si;
  double inv_MEXP_Tempt_GND_Tempt_GND;
  double inv_MEXP_Tempt_GND_Vdi_si;
#endif
#endif
double EU_a;
#if defined(_DERIVATEFORDDX)
double EU_a_Vdi_si;
double EU_a_Tempt_GND;
#if defined(_DERIVATE2)
  double EU_a_Tempt_GND_Vdi_si;
  double EU_a_Tempt_GND_Tempt_GND;
  double EU_a_Vdi_si_Vdi_si;
  double EU_a_Vdi_si_Tempt_GND;
#endif
#endif
double UC_a;
#if defined(_DERIVATEFORDDX)
double UC_a_Tempt_GND;
double UC_a_Vdi_si;
#if defined(_DERIVATE2)
  double UC_a_Vdi_si_Tempt_GND;
  double UC_a_Vdi_si_Vdi_si;
  double UC_a_Tempt_GND_Tempt_GND;
  double UC_a_Tempt_GND_Vdi_si;
#endif
#endif
double UD_a;
#if defined(_DERIVATEFORDDX)
double UD_a_Tempt_GND;
double UD_a_Vdi_si;
#if defined(_DERIVATE2)
  double UD_a_Vdi_si_Tempt_GND;
  double UD_a_Vdi_si_Vdi_si;
  double UD_a_Tempt_GND_Tempt_GND;
  double UD_a_Tempt_GND_Vdi_si;
#endif
#endif
double UA_a;
#if defined(_DERIVATEFORDDX)
double UA_a_Tempt_GND;
double UA_a_Vdi_si;
#if defined(_DERIVATE2)
  double UA_a_Vdi_si_Tempt_GND;
  double UA_a_Vdi_si_Vdi_si;
  double UA_a_Tempt_GND_Tempt_GND;
  double UA_a_Tempt_GND_Vdi_si;
#endif
#endif
double u0_a;
#if defined(_DERIVATEFORDDX)
double u0_a_Tempt_GND;
double u0_a_Vdi_si;
#if defined(_DERIVATE2)
  double u0_a_Vdi_si_Tempt_GND;
  double u0_a_Vdi_si_Vdi_si;
  double u0_a_Tempt_GND_Tempt_GND;
  double u0_a_Tempt_GND_Vdi_si;
#endif
#endif
double CIT_a;
#if defined(_DERIVATEFORDDX)
double CIT_a_Vdi_si;
double CIT_a_Tempt_GND;
#if defined(_DERIVATE2)
  double CIT_a_Tempt_GND_Vdi_si;
  double CIT_a_Tempt_GND_Tempt_GND;
  double CIT_a_Vdi_si_Vdi_si;
  double CIT_a_Vdi_si_Tempt_GND;
#endif
#endif
double DVTSHIFT_a;
#if defined(_DERIVATEFORDDX)
double DVTSHIFT_a_Vdi_si;
double DVTSHIFT_a_Tempt_GND;
#if defined(_DERIVATE2)
  double DVTSHIFT_a_Tempt_GND_Vdi_si;
  double DVTSHIFT_a_Tempt_GND_Tempt_GND;
  double DVTSHIFT_a_Vdi_si_Vdi_si;
  double DVTSHIFT_a_Vdi_si_Tempt_GND;
#endif
#endif
double KSATIV_a;
#if defined(_DERIVATEFORDDX)
double KSATIV_a_Vdi_si;
double KSATIV_a_Tempt_GND;
#if defined(_DERIVATE2)
  double KSATIV_a_Tempt_GND_Vdi_si;
  double KSATIV_a_Tempt_GND_Tempt_GND;
  double KSATIV_a_Vdi_si_Vdi_si;
  double KSATIV_a_Vdi_si_Tempt_GND;
#endif
#endif
double PCLM_a;
#if defined(_DERIVATEFORDDX)
double PCLM_a_Vdi_si;
double PCLM_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PCLM_a_Tempt_GND_Vdi_si;
  double PCLM_a_Tempt_GND_Tempt_GND;
  double PCLM_a_Vdi_si_Vdi_si;
  double PCLM_a_Vdi_si_Tempt_GND;
#endif
#endif
double RDDR_a;
#if defined(_DERIVATEFORDDX)
double RDDR_a_Tempt_GND;
double RDDR_a_Vdi_si;
#if defined(_DERIVATE2)
  double RDDR_a_Vdi_si_Tempt_GND;
  double RDDR_a_Vdi_si_Vdi_si;
  double RDDR_a_Tempt_GND_Tempt_GND;
  double RDDR_a_Tempt_GND_Vdi_si;
#endif
#endif
double RSDR_a;
#if defined(_DERIVATEFORDDX)
double RSDR_a_Tempt_GND;
double RSDR_a_Vdi_si;
#if defined(_DERIVATE2)
  double RSDR_a_Vdi_si_Tempt_GND;
  double RSDR_a_Vdi_si_Vdi_si;
  double RSDR_a_Tempt_GND_Tempt_GND;
  double RSDR_a_Tempt_GND_Vdi_si;
#endif
#endif
double VSAT1_a;
#if defined(_DERIVATEFORDDX)
double VSAT1_a_Tempt_GND;
double VSAT1_a_Vdi_si;
#if defined(_DERIVATE2)
  double VSAT1_a_Vdi_si_Tempt_GND;
  double VSAT1_a_Vdi_si_Vdi_si;
  double VSAT1_a_Tempt_GND_Tempt_GND;
  double VSAT1_a_Tempt_GND_Vdi_si;
#endif
#endif
double PTWG_a;
#if defined(_DERIVATEFORDDX)
double PTWG_a_Tempt_GND;
double PTWG_a_Vdi_si;
#if defined(_DERIVATE2)
  double PTWG_a_Vdi_si_Tempt_GND;
  double PTWG_a_Vdi_si_Vdi_si;
  double PTWG_a_Tempt_GND_Tempt_GND;
  double PTWG_a_Tempt_GND_Vdi_si;
#endif
#endif
double MEXP_a;
#if defined(_DERIVATEFORDDX)
double MEXP_a_Tempt_GND;
double MEXP_a_Vdi_si;
#if defined(_DERIVATE2)
  double MEXP_a_Vdi_si_Tempt_GND;
  double MEXP_a_Vdi_si_Vdi_si;
  double MEXP_a_Tempt_GND_Tempt_GND;
  double MEXP_a_Tempt_GND_Vdi_si;
#endif
#endif
double PDIBL2_a;
#if defined(_DERIVATEFORDDX)
double PDIBL2_a_Vdi_si;
double PDIBL2_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PDIBL2_a_Tempt_GND_Vdi_si;
  double PDIBL2_a_Tempt_GND_Tempt_GND;
  double PDIBL2_a_Vdi_si_Vdi_si;
  double PDIBL2_a_Vdi_si_Tempt_GND;
#endif
#endif
double PDIBL1_a;
#if defined(_DERIVATEFORDDX)
double PDIBL1_a_Vdi_si;
double PDIBL1_a_Tempt_GND;
#if defined(_DERIVATE2)
  double PDIBL1_a_Tempt_GND_Vdi_si;
  double PDIBL1_a_Tempt_GND_Tempt_GND;
  double PDIBL1_a_Vdi_si_Vdi_si;
  double PDIBL1_a_Vdi_si_Tempt_GND;
#endif
#endif
double ETA0_a;
#if defined(_DERIVATEFORDDX)
double ETA0_a_Tempt_GND;
double ETA0_a_Vdi_si;
#if defined(_DERIVATE2)
  double ETA0_a_Vdi_si_Tempt_GND;
  double ETA0_a_Vdi_si_Vdi_si;
  double ETA0_a_Tempt_GND_Tempt_GND;
  double ETA0_a_Tempt_GND_Vdi_si;
#endif
#endif
double CDSCD_a;
#if defined(_DERIVATEFORDDX)
double CDSCD_a_Vdi_si;
double CDSCD_a_Tempt_GND;
#if defined(_DERIVATE2)
  double CDSCD_a_Tempt_GND_Vdi_si;
  double CDSCD_a_Tempt_GND_Tempt_GND;
  double CDSCD_a_Vdi_si_Vdi_si;
  double CDSCD_a_Vdi_si_Tempt_GND;
#endif
#endif
double wr;
#if defined(_DERIVATEFORDDX)
double wr_Vdi_si;
double wr_Tempt_GND;
#if defined(_DERIVATE2)
  double wr_Tempt_GND_Vdi_si;
  double wr_Tempt_GND_Tempt_GND;
  double wr_Vdi_si_Vdi_si;
  double wr_Vdi_si_Tempt_GND;
#endif
#endif
double wf;
#if defined(_DERIVATEFORDDX)
double wf_Vdi_si;
double wf_Tempt_GND;
#if defined(_DERIVATE2)
  double wf_Tempt_GND_Vdi_si;
  double wf_Tempt_GND_Tempt_GND;
  double wf_Vdi_si_Vdi_si;
  double wf_Vdi_si_Tempt_GND;
#endif
#endif
double vesmax;
double vesx;
#if defined(_DERIVATEFORDDX)
double vesx_Ve_si;
double vesx_Ve_di;
double vesx_Vdi_si;
#if defined(_DERIVATE2)
  double vesx_Vdi_si_Ve_si;
  double vesx_Vdi_si_Ve_di;
  double vesx_Vdi_si_Vdi_si;
  double vesx_Ve_di_Ve_si;
  double vesx_Ve_di_Ve_di;
  double vesx_Ve_di_Vdi_si;
  double vesx_Ve_si_Ve_si;
  double vesx_Ve_si_Ve_di;
  double vesx_Ve_si_Vdi_si;
#endif
#endif
double vdsx;
#if defined(_DERIVATEFORDDX)
double vdsx_Vdi_si;
#if defined(_DERIVATE2)
  double vdsx_Vdi_si_Vdi_si;
#endif
#endif
#if defined(_DYNAMIC)
double Qedj;
#if defined(_DERIVATEFORDDX)
double Qedj_Vdi_d;
double Qedj_Vsi_s;
double Qedj_Tempt_GND;
double Qedj_Vge_di;
double Qedj_Vge_e;
double Qedj_Ve_si;
double Qedj_Ve_di;
double Qedj_Vge_si;
double Qedj_Vdi_si;
#if defined(_DERIVATE2)
  double Qedj_Vdi_si_Vdi_d;
  double Qedj_Vdi_si_Vsi_s;
  double Qedj_Vdi_si_Tempt_GND;
  double Qedj_Vdi_si_Vge_di;
  double Qedj_Vdi_si_Vge_e;
  double Qedj_Vdi_si_Ve_si;
  double Qedj_Vdi_si_Ve_di;
  double Qedj_Vdi_si_Vge_si;
  double Qedj_Vdi_si_Vdi_si;
  double Qedj_Vge_si_Vdi_d;
  double Qedj_Vge_si_Vsi_s;
  double Qedj_Vge_si_Tempt_GND;
  double Qedj_Vge_si_Vge_di;
  double Qedj_Vge_si_Vge_e;
  double Qedj_Vge_si_Ve_si;
  double Qedj_Vge_si_Ve_di;
  double Qedj_Vge_si_Vge_si;
  double Qedj_Vge_si_Vdi_si;
  double Qedj_Ve_di_Vdi_d;
  double Qedj_Ve_di_Vsi_s;
  double Qedj_Ve_di_Tempt_GND;
  double Qedj_Ve_di_Vge_di;
  double Qedj_Ve_di_Vge_e;
  double Qedj_Ve_di_Ve_si;
  double Qedj_Ve_di_Ve_di;
  double Qedj_Ve_di_Vge_si;
  double Qedj_Ve_di_Vdi_si;
  double Qedj_Ve_si_Vdi_d;
  double Qedj_Ve_si_Vsi_s;
  double Qedj_Ve_si_Tempt_GND;
  double Qedj_Ve_si_Vge_di;
  double Qedj_Ve_si_Vge_e;
  double Qedj_Ve_si_Ve_si;
  double Qedj_Ve_si_Ve_di;
  double Qedj_Ve_si_Vge_si;
  double Qedj_Ve_si_Vdi_si;
  double Qedj_Vge_e_Vdi_d;
  double Qedj_Vge_e_Vsi_s;
  double Qedj_Vge_e_Tempt_GND;
  double Qedj_Vge_e_Vge_di;
  double Qedj_Vge_e_Vge_e;
  double Qedj_Vge_e_Ve_si;
  double Qedj_Vge_e_Ve_di;
  double Qedj_Vge_e_Vge_si;
  double Qedj_Vge_e_Vdi_si;
  double Qedj_Vge_di_Vdi_d;
  double Qedj_Vge_di_Vsi_s;
  double Qedj_Vge_di_Tempt_GND;
  double Qedj_Vge_di_Vge_di;
  double Qedj_Vge_di_Vge_e;
  double Qedj_Vge_di_Ve_si;
  double Qedj_Vge_di_Ve_di;
  double Qedj_Vge_di_Vge_si;
  double Qedj_Vge_di_Vdi_si;
  double Qedj_Tempt_GND_Vdi_d;
  double Qedj_Tempt_GND_Vsi_s;
  double Qedj_Tempt_GND_Tempt_GND;
  double Qedj_Tempt_GND_Vge_di;
  double Qedj_Tempt_GND_Vge_e;
  double Qedj_Tempt_GND_Ve_si;
  double Qedj_Tempt_GND_Ve_di;
  double Qedj_Tempt_GND_Vge_si;
  double Qedj_Tempt_GND_Vdi_si;
  double Qedj_Vsi_s_Vdi_d;
  double Qedj_Vsi_s_Vsi_s;
  double Qedj_Vsi_s_Tempt_GND;
  double Qedj_Vsi_s_Vge_di;
  double Qedj_Vsi_s_Vge_e;
  double Qedj_Vsi_s_Ve_si;
  double Qedj_Vsi_s_Ve_di;
  double Qedj_Vsi_s_Vge_si;
  double Qedj_Vsi_s_Vdi_si;
  double Qedj_Vdi_d_Vdi_d;
  double Qedj_Vdi_d_Vsi_s;
  double Qedj_Vdi_d_Tempt_GND;
  double Qedj_Vdi_d_Vge_di;
  double Qedj_Vdi_d_Vge_e;
  double Qedj_Vdi_d_Ve_si;
  double Qedj_Vdi_d_Ve_di;
  double Qedj_Vdi_d_Vge_si;
  double Qedj_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qesj;
#if defined(_DERIVATEFORDDX)
double Qesj_Vdi_d;
double Qesj_Vsi_s;
double Qesj_Tempt_GND;
double Qesj_Vge_di;
double Qesj_Vge_e;
double Qesj_Ve_si;
double Qesj_Ve_di;
double Qesj_Vge_si;
double Qesj_Vdi_si;
#if defined(_DERIVATE2)
  double Qesj_Vdi_si_Vdi_d;
  double Qesj_Vdi_si_Vsi_s;
  double Qesj_Vdi_si_Tempt_GND;
  double Qesj_Vdi_si_Vge_di;
  double Qesj_Vdi_si_Vge_e;
  double Qesj_Vdi_si_Ve_si;
  double Qesj_Vdi_si_Ve_di;
  double Qesj_Vdi_si_Vge_si;
  double Qesj_Vdi_si_Vdi_si;
  double Qesj_Vge_si_Vdi_d;
  double Qesj_Vge_si_Vsi_s;
  double Qesj_Vge_si_Tempt_GND;
  double Qesj_Vge_si_Vge_di;
  double Qesj_Vge_si_Vge_e;
  double Qesj_Vge_si_Ve_si;
  double Qesj_Vge_si_Ve_di;
  double Qesj_Vge_si_Vge_si;
  double Qesj_Vge_si_Vdi_si;
  double Qesj_Ve_di_Vdi_d;
  double Qesj_Ve_di_Vsi_s;
  double Qesj_Ve_di_Tempt_GND;
  double Qesj_Ve_di_Vge_di;
  double Qesj_Ve_di_Vge_e;
  double Qesj_Ve_di_Ve_si;
  double Qesj_Ve_di_Ve_di;
  double Qesj_Ve_di_Vge_si;
  double Qesj_Ve_di_Vdi_si;
  double Qesj_Ve_si_Vdi_d;
  double Qesj_Ve_si_Vsi_s;
  double Qesj_Ve_si_Tempt_GND;
  double Qesj_Ve_si_Vge_di;
  double Qesj_Ve_si_Vge_e;
  double Qesj_Ve_si_Ve_si;
  double Qesj_Ve_si_Ve_di;
  double Qesj_Ve_si_Vge_si;
  double Qesj_Ve_si_Vdi_si;
  double Qesj_Vge_e_Vdi_d;
  double Qesj_Vge_e_Vsi_s;
  double Qesj_Vge_e_Tempt_GND;
  double Qesj_Vge_e_Vge_di;
  double Qesj_Vge_e_Vge_e;
  double Qesj_Vge_e_Ve_si;
  double Qesj_Vge_e_Ve_di;
  double Qesj_Vge_e_Vge_si;
  double Qesj_Vge_e_Vdi_si;
  double Qesj_Vge_di_Vdi_d;
  double Qesj_Vge_di_Vsi_s;
  double Qesj_Vge_di_Tempt_GND;
  double Qesj_Vge_di_Vge_di;
  double Qesj_Vge_di_Vge_e;
  double Qesj_Vge_di_Ve_si;
  double Qesj_Vge_di_Ve_di;
  double Qesj_Vge_di_Vge_si;
  double Qesj_Vge_di_Vdi_si;
  double Qesj_Tempt_GND_Vdi_d;
  double Qesj_Tempt_GND_Vsi_s;
  double Qesj_Tempt_GND_Tempt_GND;
  double Qesj_Tempt_GND_Vge_di;
  double Qesj_Tempt_GND_Vge_e;
  double Qesj_Tempt_GND_Ve_si;
  double Qesj_Tempt_GND_Ve_di;
  double Qesj_Tempt_GND_Vge_si;
  double Qesj_Tempt_GND_Vdi_si;
  double Qesj_Vsi_s_Vdi_d;
  double Qesj_Vsi_s_Vsi_s;
  double Qesj_Vsi_s_Tempt_GND;
  double Qesj_Vsi_s_Vge_di;
  double Qesj_Vsi_s_Vge_e;
  double Qesj_Vsi_s_Ve_si;
  double Qesj_Vsi_s_Ve_di;
  double Qesj_Vsi_s_Vge_si;
  double Qesj_Vsi_s_Vdi_si;
  double Qesj_Vdi_d_Vdi_d;
  double Qesj_Vdi_d_Vsi_s;
  double Qesj_Vdi_d_Tempt_GND;
  double Qesj_Vdi_d_Vge_di;
  double Qesj_Vdi_d_Vge_e;
  double Qesj_Vdi_d_Ve_si;
  double Qesj_Vdi_d_Ve_di;
  double Qesj_Vdi_d_Vge_si;
  double Qesj_Vdi_d_Vdi_si;
#endif
#endif
#endif
double etaiv;
#if defined(_DERIVATEFORDDX)
double etaiv_Tempt_GND;
double etaiv_Vdi_si;
double etaiv_Ve_si;
double etaiv_Ve_di;
double etaiv_Vge_si;
#if defined(_DERIVATE2)
  double etaiv_Vge_si_Tempt_GND;
  double etaiv_Vge_si_Vdi_si;
  double etaiv_Vge_si_Ve_si;
  double etaiv_Vge_si_Ve_di;
  double etaiv_Vge_si_Vge_si;
  double etaiv_Ve_di_Tempt_GND;
  double etaiv_Ve_di_Vdi_si;
  double etaiv_Ve_di_Ve_si;
  double etaiv_Ve_di_Ve_di;
  double etaiv_Ve_di_Vge_si;
  double etaiv_Ve_si_Tempt_GND;
  double etaiv_Ve_si_Vdi_si;
  double etaiv_Ve_si_Ve_si;
  double etaiv_Ve_si_Ve_di;
  double etaiv_Ve_si_Vge_si;
  double etaiv_Vdi_si_Tempt_GND;
  double etaiv_Vdi_si_Vdi_si;
  double etaiv_Vdi_si_Ve_si;
  double etaiv_Vdi_si_Ve_di;
  double etaiv_Vdi_si_Vge_si;
  double etaiv_Tempt_GND_Tempt_GND;
  double etaiv_Tempt_GND_Vdi_si;
  double etaiv_Tempt_GND_Ve_si;
  double etaiv_Tempt_GND_Ve_di;
  double etaiv_Tempt_GND_Vge_si;
#endif
#endif
double vgsfb;
#if defined(_DERIVATEFORDDX)
double vgsfb_Vge_si;
double vgsfb_Vdi_si;
double vgsfb_Tempt_GND;
#if defined(_DERIVATE2)
  double vgsfb_Tempt_GND_Vge_si;
  double vgsfb_Tempt_GND_Vdi_si;
  double vgsfb_Tempt_GND_Tempt_GND;
  double vgsfb_Vdi_si_Vge_si;
  double vgsfb_Vdi_si_Vdi_si;
  double vgsfb_Vdi_si_Tempt_GND;
  double vgsfb_Vge_si_Vge_si;
  double vgsfb_Vge_si_Vdi_si;
  double vgsfb_Vge_si_Tempt_GND;
#endif
#endif
double ves;
#if defined(_DERIVATEFORDDX)
double ves_Ve_si;
double ves_Ve_di;
#if defined(_DERIVATE2)
  double ves_Ve_di_Ve_si;
  double ves_Ve_di_Ve_di;
  double ves_Ve_si_Ve_si;
  double ves_Ve_si_Ve_di;
#endif
#endif
double vds;
#if defined(_DERIVATEFORDDX)
double vds_Vdi_si;
#if defined(_DERIVATE2)
  double vds_Vdi_si_Vdi_si;
#endif
#endif
double vgs;
#if defined(_DERIVATEFORDDX)
double vgs_Vge_si;
double vgs_Vdi_si;
#if defined(_DERIVATE2)
  double vgs_Vdi_si_Vge_si;
  double vgs_Vdi_si_Vdi_si;
  double vgs_Vge_si_Vge_si;
  double vgs_Vge_si_Vdi_si;
#endif
#endif
double vge;
#if defined(_DERIVATEFORDDX)
double vge_Vge_e;
#if defined(_DERIVATE2)
  double vge_Vge_e_Vge_e;
#endif
#endif
double ved_jct;
#if defined(_DERIVATEFORDDX)
double ved_jct_Ve_di;
#if defined(_DERIVATE2)
  double ved_jct_Ve_di_Ve_di;
#endif
#endif
double ves_jct;
#if defined(_DERIVATEFORDDX)
double ves_jct_Ve_si;
#if defined(_DERIVATE2)
  double ves_jct_Ve_si_Ve_si;
#endif
#endif
double vgd_noswap;
#if defined(_DERIVATEFORDDX)
double vgd_noswap_Vge_di;
#if defined(_DERIVATE2)
  double vgd_noswap_Vge_di_Vge_di;
#endif
#endif
double vds_noswap;
#if defined(_DERIVATEFORDDX)
double vds_noswap_Vdi_si;
#if defined(_DERIVATE2)
  double vds_noswap_Vdi_si_Vdi_si;
#endif
#endif
double vgs_noswap;
#if defined(_DERIVATEFORDDX)
double vgs_noswap_Vge_si;
#if defined(_DERIVATE2)
  double vgs_noswap_Vge_si_Vge_si;
#endif
#endif
double igentemp;
#if defined(_DERIVATE)
double igentemp_Tempt_GND;
#endif
double Tb;
#if defined(_DERIVATEFORDDX)
double Tb_Vdi_si;
double Tb_Ve_si;
double Tb_Ve_di;
double Tb_Vge_si;
double Tb_Tempt_GND;
#if defined(_DERIVATE2)
  double Tb_Tempt_GND_Vdi_si;
  double Tb_Tempt_GND_Ve_si;
  double Tb_Tempt_GND_Ve_di;
  double Tb_Tempt_GND_Vge_si;
  double Tb_Tempt_GND_Tempt_GND;
  double Tb_Vge_si_Vdi_si;
  double Tb_Vge_si_Ve_si;
  double Tb_Vge_si_Ve_di;
  double Tb_Vge_si_Vge_si;
  double Tb_Vge_si_Tempt_GND;
  double Tb_Ve_di_Vdi_si;
  double Tb_Ve_di_Ve_si;
  double Tb_Ve_di_Ve_di;
  double Tb_Ve_di_Vge_si;
  double Tb_Ve_di_Tempt_GND;
  double Tb_Ve_si_Vdi_si;
  double Tb_Ve_si_Ve_si;
  double Tb_Ve_si_Ve_di;
  double Tb_Ve_si_Vge_si;
  double Tb_Ve_si_Tempt_GND;
  double Tb_Vdi_si_Vdi_si;
  double Tb_Vdi_si_Ve_si;
  double Tb_Vdi_si_Ve_di;
  double Tb_Vdi_si_Vge_si;
  double Tb_Vdi_si_Tempt_GND;
#endif
#endif
double eta_mu_cv;
double eta_mu;
#if defined(_DERIVATEFORDDX)
double eta_mu_Tempt_GND;
#if defined(_DERIVATE2)
  double eta_mu_Tempt_GND_Tempt_GND;
#endif
#endif
double deltaPhi;
#if defined(_DERIVATEFORDDX)
double deltaPhi_Tempt_GND;
#if defined(_DERIVATE2)
  double deltaPhi_Tempt_GND_Tempt_GND;
#endif
#endif
double vbi;
#if defined(_DERIVATEFORDDX)
double vbi_Tempt_GND;
#if defined(_DERIVATE2)
  double vbi_Tempt_GND_Tempt_GND;
#endif
#endif
double phib;
#if defined(_DERIVATEFORDDX)
double phib_Tempt_GND;
#if defined(_DERIVATE2)
  double phib_Tempt_GND_Tempt_GND;
#endif
#endif
double vfbsdcv;
#if defined(_DERIVATEFORDDX)
double vfbsdcv_Tempt_GND;
#if defined(_DERIVATE2)
  double vfbsdcv_Tempt_GND_Tempt_GND;
#endif
#endif
double vfbsd;
#if defined(_DERIVATEFORDDX)
double vfbsd_Tempt_GND;
#if defined(_DERIVATE2)
  double vfbsd_Tempt_GND_Tempt_GND;
#endif
#endif
double T3;
#if defined(_DERIVATEFORDDX)
double T3_Vdi_d;
double T3_Vsi_s;
double T3_Vge_di;
double T3_Vge_e;
double T3_Vdi_si;
double T3_Ve_si;
double T3_Ve_di;
double T3_Vge_si;
double T3_Tempt_GND;
#if defined(_DERIVATE2)
  double T3_Tempt_GND_Vdi_d;
  double T3_Tempt_GND_Vsi_s;
  double T3_Tempt_GND_Vge_di;
  double T3_Tempt_GND_Vge_e;
  double T3_Tempt_GND_Vdi_si;
  double T3_Tempt_GND_Ve_si;
  double T3_Tempt_GND_Ve_di;
  double T3_Tempt_GND_Vge_si;
  double T3_Tempt_GND_Tempt_GND;
  double T3_Vge_si_Vdi_d;
  double T3_Vge_si_Vsi_s;
  double T3_Vge_si_Vge_di;
  double T3_Vge_si_Vge_e;
  double T3_Vge_si_Vdi_si;
  double T3_Vge_si_Ve_si;
  double T3_Vge_si_Ve_di;
  double T3_Vge_si_Vge_si;
  double T3_Vge_si_Tempt_GND;
  double T3_Ve_di_Vdi_d;
  double T3_Ve_di_Vsi_s;
  double T3_Ve_di_Vge_di;
  double T3_Ve_di_Vge_e;
  double T3_Ve_di_Vdi_si;
  double T3_Ve_di_Ve_si;
  double T3_Ve_di_Ve_di;
  double T3_Ve_di_Vge_si;
  double T3_Ve_di_Tempt_GND;
  double T3_Ve_si_Vdi_d;
  double T3_Ve_si_Vsi_s;
  double T3_Ve_si_Vge_di;
  double T3_Ve_si_Vge_e;
  double T3_Ve_si_Vdi_si;
  double T3_Ve_si_Ve_si;
  double T3_Ve_si_Ve_di;
  double T3_Ve_si_Vge_si;
  double T3_Ve_si_Tempt_GND;
  double T3_Vdi_si_Vdi_d;
  double T3_Vdi_si_Vsi_s;
  double T3_Vdi_si_Vge_di;
  double T3_Vdi_si_Vge_e;
  double T3_Vdi_si_Vdi_si;
  double T3_Vdi_si_Ve_si;
  double T3_Vdi_si_Ve_di;
  double T3_Vdi_si_Vge_si;
  double T3_Vdi_si_Tempt_GND;
  double T3_Vge_e_Vdi_d;
  double T3_Vge_e_Vsi_s;
  double T3_Vge_e_Vge_di;
  double T3_Vge_e_Vge_e;
  double T3_Vge_e_Vdi_si;
  double T3_Vge_e_Ve_si;
  double T3_Vge_e_Ve_di;
  double T3_Vge_e_Vge_si;
  double T3_Vge_e_Tempt_GND;
  double T3_Vge_di_Vdi_d;
  double T3_Vge_di_Vsi_s;
  double T3_Vge_di_Vge_di;
  double T3_Vge_di_Vge_e;
  double T3_Vge_di_Vdi_si;
  double T3_Vge_di_Ve_si;
  double T3_Vge_di_Ve_di;
  double T3_Vge_di_Vge_si;
  double T3_Vge_di_Tempt_GND;
  double T3_Vsi_s_Vdi_d;
  double T3_Vsi_s_Vsi_s;
  double T3_Vsi_s_Vge_di;
  double T3_Vsi_s_Vge_e;
  double T3_Vsi_s_Vdi_si;
  double T3_Vsi_s_Ve_si;
  double T3_Vsi_s_Ve_di;
  double T3_Vsi_s_Vge_si;
  double T3_Vsi_s_Tempt_GND;
  double T3_Vdi_d_Vdi_d;
  double T3_Vdi_d_Vsi_s;
  double T3_Vdi_d_Vge_di;
  double T3_Vdi_d_Vge_e;
  double T3_Vdi_d_Vdi_si;
  double T3_Vdi_d_Ve_si;
  double T3_Vdi_d_Ve_di;
  double T3_Vdi_d_Vge_si;
  double T3_Vdi_d_Tempt_GND;
#endif
#endif
double T0;
#if defined(_DERIVATEFORDDX)
double T0_Vge_di;
double T0_Vge_e;
double T0_Ve_si;
double T0_Ve_di;
double T0_Vge_si;
double T0_Vdi_si;
double T0_Tempt_GND;
#if defined(_DERIVATE2)
  double T0_Tempt_GND_Vge_di;
  double T0_Tempt_GND_Vge_e;
  double T0_Tempt_GND_Ve_si;
  double T0_Tempt_GND_Ve_di;
  double T0_Tempt_GND_Vge_si;
  double T0_Tempt_GND_Vdi_si;
  double T0_Tempt_GND_Tempt_GND;
  double T0_Vdi_si_Vge_di;
  double T0_Vdi_si_Vge_e;
  double T0_Vdi_si_Ve_si;
  double T0_Vdi_si_Ve_di;
  double T0_Vdi_si_Vge_si;
  double T0_Vdi_si_Vdi_si;
  double T0_Vdi_si_Tempt_GND;
  double T0_Vge_si_Vge_di;
  double T0_Vge_si_Vge_e;
  double T0_Vge_si_Ve_si;
  double T0_Vge_si_Ve_di;
  double T0_Vge_si_Vge_si;
  double T0_Vge_si_Vdi_si;
  double T0_Vge_si_Tempt_GND;
  double T0_Ve_di_Vge_di;
  double T0_Ve_di_Vge_e;
  double T0_Ve_di_Ve_si;
  double T0_Ve_di_Ve_di;
  double T0_Ve_di_Vge_si;
  double T0_Ve_di_Vdi_si;
  double T0_Ve_di_Tempt_GND;
  double T0_Ve_si_Vge_di;
  double T0_Ve_si_Vge_e;
  double T0_Ve_si_Ve_si;
  double T0_Ve_si_Ve_di;
  double T0_Ve_si_Vge_si;
  double T0_Ve_si_Vdi_si;
  double T0_Ve_si_Tempt_GND;
  double T0_Vge_e_Vge_di;
  double T0_Vge_e_Vge_e;
  double T0_Vge_e_Ve_si;
  double T0_Vge_e_Ve_di;
  double T0_Vge_e_Vge_si;
  double T0_Vge_e_Vdi_si;
  double T0_Vge_e_Tempt_GND;
  double T0_Vge_di_Vge_di;
  double T0_Vge_di_Vge_e;
  double T0_Vge_di_Ve_si;
  double T0_Vge_di_Ve_di;
  double T0_Vge_di_Vge_si;
  double T0_Vge_di_Vdi_si;
  double T0_Vge_di_Tempt_GND;
#endif
#endif
double igsd_mult;
#if defined(_DERIVATEFORDDX)
double igsd_mult_Tempt_GND;
#if defined(_DERIVATE2)
  double igsd_mult_Tempt_GND_Tempt_GND;
#endif
#endif
double igtemp;
#if defined(_DERIVATEFORDDX)
double igtemp_Tempt_GND;
#if defined(_DERIVATE2)
  double igtemp_Tempt_GND_Tempt_GND;
#endif
#endif
double ALPHAII1_t;
#if defined(_DERIVATEFORDDX)
double ALPHAII1_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ALPHAII1_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ALPHAII0_t;
#if defined(_DERIVATEFORDDX)
double ALPHAII0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ALPHAII0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ALPHA1_t;
#if defined(_DERIVATEFORDDX)
double ALPHA1_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ALPHA1_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ALPHA0_t;
#if defined(_DERIVATEFORDDX)
double ALPHA0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ALPHA0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double BGISL_t;
#if defined(_DERIVATEFORDDX)
double BGISL_t_Tempt_GND;
#if defined(_DERIVATE2)
  double BGISL_t_Tempt_GND_Tempt_GND;
#endif
#endif
double BGIDL_t;
#if defined(_DERIVATEFORDDX)
double BGIDL_t_Tempt_GND;
#if defined(_DERIVATE2)
  double BGIDL_t_Tempt_GND_Tempt_GND;
#endif
#endif
double AIGD_t;
#if defined(_DERIVATEFORDDX)
double AIGD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double AIGD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double AIGS_t;
#if defined(_DERIVATEFORDDX)
double AIGS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double AIGS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double AIGC_t;
#if defined(_DERIVATEFORDDX)
double AIGC_t_Tempt_GND;
#if defined(_DERIVATE2)
  double AIGC_t_Tempt_GND_Tempt_GND;
#endif
#endif
double AIGBACC_t;
#if defined(_DERIVATEFORDDX)
double AIGBACC_t_Tempt_GND;
#if defined(_DERIVATE2)
  double AIGBACC_t_Tempt_GND_Tempt_GND;
#endif
#endif
double AIGBINV_t;
#if defined(_DERIVATEFORDDX)
double AIGBINV_t_Tempt_GND;
#if defined(_DERIVATE2)
  double AIGBINV_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K2SISAT_t;
#if defined(_DERIVATEFORDDX)
double K2SISAT_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K2SISAT_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K0SISAT_t;
#if defined(_DERIVATEFORDDX)
double K0SISAT_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K0SISAT_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K2_t;
#if defined(_DERIVATEFORDDX)
double K2_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K2_t_Tempt_GND_Tempt_GND;
#endif
#endif
double A2_t;
#if defined(_DERIVATEFORDDX)
double A2_t_Tempt_GND;
#if defined(_DERIVATE2)
  double A2_t_Tempt_GND_Tempt_GND;
#endif
#endif
double A1_t;
#if defined(_DERIVATEFORDDX)
double A1_t_Tempt_GND;
#if defined(_DERIVATE2)
  double A1_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K2SAT_t;
#if defined(_DERIVATEFORDDX)
double K2SAT_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K2SAT_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K1_t;
#if defined(_DERIVATEFORDDX)
double K1_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K1_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K2SI_t;
#if defined(_DERIVATEFORDDX)
double K2SI_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K2SI_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K0SI_t;
#if defined(_DERIVATEFORDDX)
double K0SI_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K0SI_t_Tempt_GND_Tempt_GND;
#endif
#endif
double K0_t;
#if defined(_DERIVATEFORDDX)
double K0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double K0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double SII0_t;
#if defined(_DERIVATEFORDDX)
double SII0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double SII0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double BETA0_t;
#if defined(_DERIVATEFORDDX)
double BETA0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double BETA0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double dvth_temp;
#if defined(_DERIVATEFORDDX)
double dvth_temp_Tempt_GND;
#if defined(_DERIVATE2)
  double dvth_temp_Tempt_GND_Tempt_GND;
#endif
#endif
double PTWG_t;
#if defined(_DERIVATEFORDDX)
double PTWG_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PTWG_t_Tempt_GND_Tempt_GND;
#endif
#endif
double MEXP_t;
#if defined(_DERIVATEFORDDX)
double MEXP_t_Tempt_GND;
#if defined(_DERIVATE2)
  double MEXP_t_Tempt_GND_Tempt_GND;
#endif
#endif
double VSATCV_t;
#if defined(_DERIVATEFORDDX)
double VSATCV_t_Tempt_GND;
#if defined(_DERIVATE2)
  double VSATCV_t_Tempt_GND_Tempt_GND;
#endif
#endif
double VSAT1_t;
#if defined(_DERIVATEFORDDX)
double VSAT1_t_Tempt_GND;
#if defined(_DERIVATE2)
  double VSAT1_t_Tempt_GND_Tempt_GND;
#endif
#endif
double VSAT_t;
#if defined(_DERIVATEFORDDX)
double VSAT_t_Tempt_GND;
#if defined(_DERIVATE2)
  double VSAT_t_Tempt_GND_Tempt_GND;
#endif
#endif
double RDDR_t;
#if defined(_DERIVATEFORDDX)
double RDDR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double RDDR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double RSDR_t;
#if defined(_DERIVATEFORDDX)
double RSDR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double RSDR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double rdstemp;
#if defined(_DERIVATEFORDDX)
double rdstemp_Tempt_GND;
#if defined(_DERIVATE2)
  double rdstemp_Tempt_GND_Tempt_GND;
#endif
#endif
double UCS_t;
#if defined(_DERIVATEFORDDX)
double UCS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UCS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double UD_t;
#if defined(_DERIVATEFORDDX)
double UD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double UA_t;
#if defined(_DERIVATEFORDDX)
double UA_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UA_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ETAMOB_t;
#if defined(_DERIVATEFORDDX)
double ETAMOB_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ETAMOB_t_Tempt_GND_Tempt_GND;
#endif
#endif
double u0;
#if defined(_DERIVATEFORDDX)
double u0_Tempt_GND;
#if defined(_DERIVATE2)
  double u0_Tempt_GND_Tempt_GND;
#endif
#endif
double U0_t;
#if defined(_DERIVATEFORDDX)
double U0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double U0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ETA0R_t;
#if defined(_DERIVATEFORDDX)
double ETA0R_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ETA0R_t_Tempt_GND_Tempt_GND;
#endif
#endif
double ETA0_t;
#if defined(_DERIVATEFORDDX)
double ETA0_t_Tempt_GND;
#if defined(_DERIVATE2)
  double ETA0_t_Tempt_GND_Tempt_GND;
#endif
#endif
double dvch_qm;
#if defined(_DERIVATEFORDDX)
double dvch_qm_Tempt_GND;
#if defined(_DERIVATE2)
  double dvch_qm_Tempt_GND_Tempt_GND;
#endif
#endif
double T2;
#if defined(_DERIVATEFORDDX)
double T2_Vdi_d;
double T2_Vsi_s;
double T2_Vge_di;
double T2_Vge_e;
double T2_Vge_si;
double T2_Ve_si;
double T2_Ve_di;
double T2_Vdi_si;
double T2_Tempt_GND;
#if defined(_DERIVATE2)
  double T2_Tempt_GND_Vdi_d;
  double T2_Tempt_GND_Vsi_s;
  double T2_Tempt_GND_Vge_di;
  double T2_Tempt_GND_Vge_e;
  double T2_Tempt_GND_Vge_si;
  double T2_Tempt_GND_Ve_si;
  double T2_Tempt_GND_Ve_di;
  double T2_Tempt_GND_Vdi_si;
  double T2_Tempt_GND_Tempt_GND;
  double T2_Vdi_si_Vdi_d;
  double T2_Vdi_si_Vsi_s;
  double T2_Vdi_si_Vge_di;
  double T2_Vdi_si_Vge_e;
  double T2_Vdi_si_Vge_si;
  double T2_Vdi_si_Ve_si;
  double T2_Vdi_si_Ve_di;
  double T2_Vdi_si_Vdi_si;
  double T2_Vdi_si_Tempt_GND;
  double T2_Ve_di_Vdi_d;
  double T2_Ve_di_Vsi_s;
  double T2_Ve_di_Vge_di;
  double T2_Ve_di_Vge_e;
  double T2_Ve_di_Vge_si;
  double T2_Ve_di_Ve_si;
  double T2_Ve_di_Ve_di;
  double T2_Ve_di_Vdi_si;
  double T2_Ve_di_Tempt_GND;
  double T2_Ve_si_Vdi_d;
  double T2_Ve_si_Vsi_s;
  double T2_Ve_si_Vge_di;
  double T2_Ve_si_Vge_e;
  double T2_Ve_si_Vge_si;
  double T2_Ve_si_Ve_si;
  double T2_Ve_si_Ve_di;
  double T2_Ve_si_Vdi_si;
  double T2_Ve_si_Tempt_GND;
  double T2_Vge_si_Vdi_d;
  double T2_Vge_si_Vsi_s;
  double T2_Vge_si_Vge_di;
  double T2_Vge_si_Vge_e;
  double T2_Vge_si_Vge_si;
  double T2_Vge_si_Ve_si;
  double T2_Vge_si_Ve_di;
  double T2_Vge_si_Vdi_si;
  double T2_Vge_si_Tempt_GND;
  double T2_Vge_e_Vdi_d;
  double T2_Vge_e_Vsi_s;
  double T2_Vge_e_Vge_di;
  double T2_Vge_e_Vge_e;
  double T2_Vge_e_Vge_si;
  double T2_Vge_e_Ve_si;
  double T2_Vge_e_Ve_di;
  double T2_Vge_e_Vdi_si;
  double T2_Vge_e_Tempt_GND;
  double T2_Vge_di_Vdi_d;
  double T2_Vge_di_Vsi_s;
  double T2_Vge_di_Vge_di;
  double T2_Vge_di_Vge_e;
  double T2_Vge_di_Vge_si;
  double T2_Vge_di_Ve_si;
  double T2_Vge_di_Ve_di;
  double T2_Vge_di_Vdi_si;
  double T2_Vge_di_Tempt_GND;
  double T2_Vsi_s_Vdi_d;
  double T2_Vsi_s_Vsi_s;
  double T2_Vsi_s_Vge_di;
  double T2_Vsi_s_Vge_e;
  double T2_Vsi_s_Vge_si;
  double T2_Vsi_s_Ve_si;
  double T2_Vsi_s_Ve_di;
  double T2_Vsi_s_Vdi_si;
  double T2_Vsi_s_Tempt_GND;
  double T2_Vdi_d_Vdi_d;
  double T2_Vdi_d_Vsi_s;
  double T2_Vdi_d_Vge_di;
  double T2_Vdi_d_Vge_e;
  double T2_Vdi_d_Vge_si;
  double T2_Vdi_d_Ve_si;
  double T2_Vdi_d_Ve_di;
  double T2_Vdi_d_Vdi_si;
  double T2_Vdi_d_Tempt_GND;
#endif
#endif
double gam1;
#if defined(_DERIVATEFORDDX)
double gam1_Tempt_GND;
#if defined(_DERIVATE2)
  double gam1_Tempt_GND_Tempt_GND;
#endif
#endif
double gam0;
#if defined(_DERIVATEFORDDX)
double gam0_Tempt_GND;
#if defined(_DERIVATE2)
  double gam0_Tempt_GND_Tempt_GND;
#endif
#endif
double E1prime;
double E1;
double E0prime;
double E0;
double kT;
#if defined(_DERIVATEFORDDX)
double kT_Tempt_GND;
#if defined(_DERIVATE2)
  double kT_Tempt_GND_Tempt_GND;
#endif
#endif
double ThetaSS;
#if defined(_DERIVATEFORDDX)
double ThetaSS_Tempt_GND;
#if defined(_DERIVATE2)
  double ThetaSS_Tempt_GND_Tempt_GND;
#endif
#endif
double Nc;
#if defined(_DERIVATEFORDDX)
double Nc_Tempt_GND;
#if defined(_DERIVATE2)
  double Nc_Tempt_GND_Tempt_GND;
#endif
#endif
double ni;
#if defined(_DERIVATEFORDDX)
double ni_Tempt_GND;
#if defined(_DERIVATE2)
  double ni_Tempt_GND_Tempt_GND;
#endif
#endif
double T1;
#if defined(_DERIVATEFORDDX)
double T1_Vdi_d;
double T1_Vsi_s;
double T1_Vge_di;
double T1_Vge_e;
double T1_Ve_si;
double T1_Ve_di;
double T1_Vge_si;
double T1_Vdi_si;
double T1_Tempt_GND;
#if defined(_DERIVATE2)
  double T1_Tempt_GND_Vdi_d;
  double T1_Tempt_GND_Vsi_s;
  double T1_Tempt_GND_Vge_di;
  double T1_Tempt_GND_Vge_e;
  double T1_Tempt_GND_Ve_si;
  double T1_Tempt_GND_Ve_di;
  double T1_Tempt_GND_Vge_si;
  double T1_Tempt_GND_Vdi_si;
  double T1_Tempt_GND_Tempt_GND;
  double T1_Vdi_si_Vdi_d;
  double T1_Vdi_si_Vsi_s;
  double T1_Vdi_si_Vge_di;
  double T1_Vdi_si_Vge_e;
  double T1_Vdi_si_Ve_si;
  double T1_Vdi_si_Ve_di;
  double T1_Vdi_si_Vge_si;
  double T1_Vdi_si_Vdi_si;
  double T1_Vdi_si_Tempt_GND;
  double T1_Vge_si_Vdi_d;
  double T1_Vge_si_Vsi_s;
  double T1_Vge_si_Vge_di;
  double T1_Vge_si_Vge_e;
  double T1_Vge_si_Ve_si;
  double T1_Vge_si_Ve_di;
  double T1_Vge_si_Vge_si;
  double T1_Vge_si_Vdi_si;
  double T1_Vge_si_Tempt_GND;
  double T1_Ve_di_Vdi_d;
  double T1_Ve_di_Vsi_s;
  double T1_Ve_di_Vge_di;
  double T1_Ve_di_Vge_e;
  double T1_Ve_di_Ve_si;
  double T1_Ve_di_Ve_di;
  double T1_Ve_di_Vge_si;
  double T1_Ve_di_Vdi_si;
  double T1_Ve_di_Tempt_GND;
  double T1_Ve_si_Vdi_d;
  double T1_Ve_si_Vsi_s;
  double T1_Ve_si_Vge_di;
  double T1_Ve_si_Vge_e;
  double T1_Ve_si_Ve_si;
  double T1_Ve_si_Ve_di;
  double T1_Ve_si_Vge_si;
  double T1_Ve_si_Vdi_si;
  double T1_Ve_si_Tempt_GND;
  double T1_Vge_e_Vdi_d;
  double T1_Vge_e_Vsi_s;
  double T1_Vge_e_Vge_di;
  double T1_Vge_e_Vge_e;
  double T1_Vge_e_Ve_si;
  double T1_Vge_e_Ve_di;
  double T1_Vge_e_Vge_si;
  double T1_Vge_e_Vdi_si;
  double T1_Vge_e_Tempt_GND;
  double T1_Vge_di_Vdi_d;
  double T1_Vge_di_Vsi_s;
  double T1_Vge_di_Vge_di;
  double T1_Vge_di_Vge_e;
  double T1_Vge_di_Ve_si;
  double T1_Vge_di_Ve_di;
  double T1_Vge_di_Vge_si;
  double T1_Vge_di_Vdi_si;
  double T1_Vge_di_Tempt_GND;
  double T1_Vsi_s_Vdi_d;
  double T1_Vsi_s_Vsi_s;
  double T1_Vsi_s_Vge_di;
  double T1_Vsi_s_Vge_e;
  double T1_Vsi_s_Ve_si;
  double T1_Vsi_s_Ve_di;
  double T1_Vsi_s_Vge_si;
  double T1_Vsi_s_Vdi_si;
  double T1_Vsi_s_Tempt_GND;
  double T1_Vdi_d_Vdi_d;
  double T1_Vdi_d_Vsi_s;
  double T1_Vdi_d_Vge_di;
  double T1_Vdi_d_Vge_e;
  double T1_Vdi_d_Ve_si;
  double T1_Vdi_d_Ve_di;
  double T1_Vdi_d_Vge_si;
  double T1_Vdi_d_Vdi_si;
  double T1_Vdi_d_Tempt_GND;
#endif
#endif
double Eg0;
double Eg;
#if defined(_DERIVATEFORDDX)
double Eg_Tempt_GND;
#if defined(_DERIVATE2)
  double Eg_Tempt_GND_Tempt_GND;
#endif
#endif
double Vtm0;
double Vtm;
#if defined(_DERIVATEFORDDX)
double Vtm_Tempt_GND;
#if defined(_DERIVATE2)
  double Vtm_Tempt_GND_Tempt_GND;
#endif
#endif
double delTemp;
#if defined(_DERIVATEFORDDX)
double delTemp_Tempt_GND;
#if defined(_DERIVATE2)
  double delTemp_Tempt_GND_Tempt_GND;
#endif
#endif
double TRatio;
#if defined(_DERIVATEFORDDX)
double TRatio_Tempt_GND;
#if defined(_DERIVATE2)
  double TRatio_Tempt_GND_Tempt_GND;
#endif
#endif
double DevTemp;
#if defined(_DERIVATEFORDDX)
double DevTemp_Tempt_GND;
#if defined(_DERIVATE2)
  double DevTemp_Tempt_GND_Tempt_GND;
#endif
#endif
double Tnom;
double igsd_mult0;
double Toxratioedge;
double Toxratio;
double Bechvb;
double Aechvb;
double qbs;
double nbody;
double Theta_DITS;
double Theta_RSCE;
double Theta_DIBL;
double Theta_SW;
double Theta_SCE;
double tmp;
double litl;
double WeffWRFactor;
double EeffFactor;
#if defined(_DYNAMIC)
double cgbox;
#endif
#if defined(_DYNAMIC)
double cdbox;
#endif
#if defined(_DYNAMIC)
double csbox;
#endif
#if defined(_DYNAMIC)
double Ccorner;
#endif
#if defined(_DYNAMIC)
double Acorner;
#endif
#if defined(_DYNAMIC)
double Cgg_side;
#endif
#if defined(_DYNAMIC)
double Cfg;
#endif
#if defined(_DYNAMIC)
double x42_delta;
#endif
#if defined(_DYNAMIC)
double x42_Cfgsat;
#endif
#if defined(_DYNAMIC)
double x42_TT2;
#endif
#if defined(_DYNAMIC)
double x42_TT0;
#endif
#if defined(_DYNAMIC)
double x42_dcf;
#endif
#if defined(_DYNAMIC)
double x42_Cfglog;
#endif
#if defined(_DYNAMIC)
double x42_C3;
#endif
#if defined(_DYNAMIC)
double x42_C2;
#endif
#if defined(_DYNAMIC)
double x42_C1;
#endif
#if defined(_DYNAMIC)
double x42_Ccg;
#endif
#if defined(_DYNAMIC)
double x42_Ccg2;
#endif
#if defined(_DYNAMIC)
double x42_Rcf;
#endif
#if defined(_DYNAMIC)
double x42_r1cf;
#endif
#if defined(_DYNAMIC)
double x42_Ccg1;
#endif
#if defined(_DYNAMIC)
double x42_TT1;
#endif
#if defined(_DYNAMIC)
double x42_CcgSat;
#endif
#if defined(_DYNAMIC)
double x42_Cnon;
#endif
#if defined(_DYNAMIC)
double x42_x;
#endif
#if defined(_DYNAMIC)
double x42_y;
#endif
#if defined(_DYNAMIC)
double x42_Lmax;
#endif
#if defined(_DYNAMIC)
double x42_Hgdelta;
#endif
#if defined(_DYNAMIC)
double x42_Lr;
#endif
#if defined(_DYNAMIC)
double x42_Hr;
#endif
#if defined(_DYNAMIC)
double Cgg_top;
#endif
double Hrsd;
#if defined(_DYNAMIC)
double Wg;
#endif
#if defined(_DYNAMIC)
double Trsd;
#endif
#if defined(_DYNAMIC)
double Hg;
#endif
double LSP_i;
double Rdsgeo;
double Rrsd;
double Rrsdside;
double RrsdTML;
double eta;
double T0y;
double alpha;
double lt;
double prsd_total;
double arsd_total;
double Rsp;
double afin;
double thetarsp;
double mu_rsd;
double mu_max;
double rhorsd;
double Prsd;
double Arsd;
double RDrainGeo;
double RSourceGeo;
double Rgeltd;
#if defined(_DYNAMIC)
double cth;
#endif
double gth;
double T2y;
double T1y;
double NTNOI_i;
double LINTNOI_i;
double LINTIGEN_i;
double RDWMIN_i;
double RSWMIN_i;
double RDSWMIN_i;
double IGT_i;
double TGIDL_i;
double IIT_i;
double TSS_i;
double KT1_i;
double PRT_i;
double ATCV_i;
double AT_i;
double PTWGT_i;
double UCSTE_i;
double UD1_i;
double UA1_i;
double EMOBT_i;
double UTL_i;
double UTE_i;
double BIGEN_i;
double AIGEN_i;
double NTGEN_i;
#if defined(_DYNAMIC)
double CKAPPAB_i;
#endif
#if defined(_DYNAMIC)
double CKAPPAD_i;
#endif
#if defined(_DYNAMIC)
double CKAPPAS_i;
#endif
#if defined(_DYNAMIC)
double CGBL_i;
#endif
#if defined(_DYNAMIC)
double CGDL_i;
#endif
#if defined(_DYNAMIC)
double CGSL_i;
#endif
#if defined(_DYNAMIC)
double COVD_i;
#if defined(_DERIVATEFORDDX)
double COVD_i_Vge_di;
double COVD_i_Vge_e;
double COVD_i_Ve_si;
double COVD_i_Ve_di;
double COVD_i_Vge_si;
double COVD_i_Vdi_si;
double COVD_i_Tempt_GND;
#if defined(_DERIVATE2)
  double COVD_i_Tempt_GND_Vge_di;
  double COVD_i_Tempt_GND_Vge_e;
  double COVD_i_Tempt_GND_Ve_si;
  double COVD_i_Tempt_GND_Ve_di;
  double COVD_i_Tempt_GND_Vge_si;
  double COVD_i_Tempt_GND_Vdi_si;
  double COVD_i_Tempt_GND_Tempt_GND;
  double COVD_i_Vdi_si_Vge_di;
  double COVD_i_Vdi_si_Vge_e;
  double COVD_i_Vdi_si_Ve_si;
  double COVD_i_Vdi_si_Ve_di;
  double COVD_i_Vdi_si_Vge_si;
  double COVD_i_Vdi_si_Vdi_si;
  double COVD_i_Vdi_si_Tempt_GND;
  double COVD_i_Vge_si_Vge_di;
  double COVD_i_Vge_si_Vge_e;
  double COVD_i_Vge_si_Ve_si;
  double COVD_i_Vge_si_Ve_di;
  double COVD_i_Vge_si_Vge_si;
  double COVD_i_Vge_si_Vdi_si;
  double COVD_i_Vge_si_Tempt_GND;
  double COVD_i_Ve_di_Vge_di;
  double COVD_i_Ve_di_Vge_e;
  double COVD_i_Ve_di_Ve_si;
  double COVD_i_Ve_di_Ve_di;
  double COVD_i_Ve_di_Vge_si;
  double COVD_i_Ve_di_Vdi_si;
  double COVD_i_Ve_di_Tempt_GND;
  double COVD_i_Ve_si_Vge_di;
  double COVD_i_Ve_si_Vge_e;
  double COVD_i_Ve_si_Ve_si;
  double COVD_i_Ve_si_Ve_di;
  double COVD_i_Ve_si_Vge_si;
  double COVD_i_Ve_si_Vdi_si;
  double COVD_i_Ve_si_Tempt_GND;
  double COVD_i_Vge_e_Vge_di;
  double COVD_i_Vge_e_Vge_e;
  double COVD_i_Vge_e_Ve_si;
  double COVD_i_Vge_e_Ve_di;
  double COVD_i_Vge_e_Vge_si;
  double COVD_i_Vge_e_Vdi_si;
  double COVD_i_Vge_e_Tempt_GND;
  double COVD_i_Vge_di_Vge_di;
  double COVD_i_Vge_di_Vge_e;
  double COVD_i_Vge_di_Ve_si;
  double COVD_i_Vge_di_Ve_di;
  double COVD_i_Vge_di_Vge_si;
  double COVD_i_Vge_di_Vdi_si;
  double COVD_i_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double COVS_i;
#if defined(_DERIVATEFORDDX)
double COVS_i_Vge_di;
double COVS_i_Vge_e;
double COVS_i_Ve_si;
double COVS_i_Ve_di;
double COVS_i_Vge_si;
double COVS_i_Vdi_si;
double COVS_i_Tempt_GND;
#if defined(_DERIVATE2)
  double COVS_i_Tempt_GND_Vge_di;
  double COVS_i_Tempt_GND_Vge_e;
  double COVS_i_Tempt_GND_Ve_si;
  double COVS_i_Tempt_GND_Ve_di;
  double COVS_i_Tempt_GND_Vge_si;
  double COVS_i_Tempt_GND_Vdi_si;
  double COVS_i_Tempt_GND_Tempt_GND;
  double COVS_i_Vdi_si_Vge_di;
  double COVS_i_Vdi_si_Vge_e;
  double COVS_i_Vdi_si_Ve_si;
  double COVS_i_Vdi_si_Ve_di;
  double COVS_i_Vdi_si_Vge_si;
  double COVS_i_Vdi_si_Vdi_si;
  double COVS_i_Vdi_si_Tempt_GND;
  double COVS_i_Vge_si_Vge_di;
  double COVS_i_Vge_si_Vge_e;
  double COVS_i_Vge_si_Ve_si;
  double COVS_i_Vge_si_Ve_di;
  double COVS_i_Vge_si_Vge_si;
  double COVS_i_Vge_si_Vdi_si;
  double COVS_i_Vge_si_Tempt_GND;
  double COVS_i_Ve_di_Vge_di;
  double COVS_i_Ve_di_Vge_e;
  double COVS_i_Ve_di_Ve_si;
  double COVS_i_Ve_di_Ve_di;
  double COVS_i_Ve_di_Vge_si;
  double COVS_i_Ve_di_Vdi_si;
  double COVS_i_Ve_di_Tempt_GND;
  double COVS_i_Ve_si_Vge_di;
  double COVS_i_Ve_si_Vge_e;
  double COVS_i_Ve_si_Ve_si;
  double COVS_i_Ve_si_Ve_di;
  double COVS_i_Ve_si_Vge_si;
  double COVS_i_Ve_si_Vdi_si;
  double COVS_i_Ve_si_Tempt_GND;
  double COVS_i_Vge_e_Vge_di;
  double COVS_i_Vge_e_Vge_e;
  double COVS_i_Vge_e_Ve_si;
  double COVS_i_Vge_e_Ve_di;
  double COVS_i_Vge_e_Vge_si;
  double COVS_i_Vge_e_Vdi_si;
  double COVS_i_Vge_e_Tempt_GND;
  double COVS_i_Vge_di_Vge_di;
  double COVS_i_Vge_di_Vge_e;
  double COVS_i_Vge_di_Ve_si;
  double COVS_i_Vge_di_Ve_di;
  double COVS_i_Vge_di_Vge_si;
  double COVS_i_Vge_di_Vdi_si;
  double COVS_i_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double CFD_i;
#endif
#if defined(_DYNAMIC)
double CFS_i;
#endif
double TII_i;
double SIID_i;
double SII2_i;
double SII1_i;
double SII0_i;
double LII_i;
double ESATII_i;
double BETAII2_i;
double BETAII1_i;
double BETAII0_i;
double BETA0_i;
double ALPHAII1_i;
double ALPHAII0_i;
double ALPHA1_i;
double ALPHA0_i;
double PGISL_i;
double EGISL_i;
double CGISL_i;
double BGISL_i;
double AGISL_i;
double PGIDL_i;
double EGIDL_i;
double CGIDL_i;
double BGIDL_i;
double AGIDL_i;
double POXEDGE_i;
double NTOX_i;
double CIGD_i;
double BIGD_i;
double AIGD1_i;
double AIGD_i;
double CIGS_i;
double BIGS_i;
double AIGS1_i;
double AIGS_i;
double PIGCD_i;
double CIGC_i;
double BIGC_i;
double AIGC1_i;
double AIGC_i;
double NIGBACC_i;
double CIGBACC_i;
double BIGBACC_i;
double AIGBACC1_i;
double AIGBACC_i;
double NIGBINV_i;
double EIGBINV_i;
double CIGBINV_i;
double BIGBINV_i;
double AIGBINV1_i;
double AIGBINV_i;
double PVAG_i;
double DROUT_i;
double PDIBL2_i;
double PDIBL1_i;
double WR_i;
double PRWGS_i;
double PRWGD_i;
double RDW_i;
double RSW_i;
double RDSW_i;
double A21_i;
double A2_i;
double A11_i;
double A1_i;
double PCLMCV_i;
double PCLMG_i;
double PCLM_i;
double UCS_i;
double UD_i;
double EU_i;
double UA_i;
double UP_i;
double ETAMOB_i;
double U0_i;
double PTWG_i;
double MEXP_i;
double KSATIV_i;
double PSATCV_i;
double DELTAVSATCV_i;
double PSAT_i;
double DELTAVSAT_i;
double VSATCV_i;
double VSAT1_i;
double VSAT_i;
double QMTCENCVA_i;
double QMTCENCV_i;
double QMFACTOR_i;
double K2SISAT1_i;
double K2SISAT_i;
double K0SISAT1_i;
double K0SISAT_i;
double K2SI1_i;
double K2SI_i;
double K0SI1_i;
double K0SI_i;
double K01_i;
double K0_i;
double DVTSHIFT_i;
double LPE0_i;
double K1RSCE_i;
double DSUB_i;
double ETA0_i;
double PHIN_i;
double DVT1SS_i;
double DVT1_i;
double DVT0_i;
double CDSCD_i;
double CDSC_i;
double CIT_i;
double NGATE_i;
double PHIG_i;
double scl;
double cox;
double NBODY_i;
double Inv_LNFIN;
double Inv_NFIN;
double Inv_L;
double NFINtotal;
double LeffCV;
double Leff1;
double Leff;
double deltaLCV;
double deltaL1;
double deltaL;
double Lg;
double gfactor;
double gprime;
double mdprime;
double md;
double mxprime;
double mx;
double epsratio;
#if defined(_DYNAMIC)
double cbox;
#endif
double epssp;
double epssub;
int devsign;
double Qdep_ov_Cins;
double e2;
#if defined(_DERIVATEFORDDX)
double e2_Vdi_si;
double e2_Ve_si;
double e2_Ve_di;
double e2_Vge_si;
double e2_Tempt_GND;
#if defined(_DERIVATE2)
  double e2_Tempt_GND_Vdi_si;
  double e2_Tempt_GND_Ve_si;
  double e2_Tempt_GND_Ve_di;
  double e2_Tempt_GND_Vge_si;
  double e2_Tempt_GND_Tempt_GND;
  double e2_Vge_si_Vdi_si;
  double e2_Vge_si_Ve_si;
  double e2_Vge_si_Ve_di;
  double e2_Vge_si_Vge_si;
  double e2_Vge_si_Tempt_GND;
  double e2_Ve_di_Vdi_si;
  double e2_Ve_di_Ve_si;
  double e2_Ve_di_Ve_di;
  double e2_Ve_di_Vge_si;
  double e2_Ve_di_Tempt_GND;
  double e2_Ve_si_Vdi_si;
  double e2_Ve_si_Ve_si;
  double e2_Ve_si_Ve_di;
  double e2_Ve_si_Vge_si;
  double e2_Ve_si_Tempt_GND;
  double e2_Vdi_si_Vdi_si;
  double e2_Vdi_si_Ve_si;
  double e2_Vdi_si_Ve_di;
  double e2_Vdi_si_Vge_si;
  double e2_Vdi_si_Tempt_GND;
#endif
#endif
double e1;
#if defined(_DERIVATEFORDDX)
double e1_Vge_e;
double e1_Vdi_si;
double e1_Ve_si;
double e1_Ve_di;
double e1_Vge_si;
double e1_Tempt_GND;
#if defined(_DERIVATE2)
  double e1_Tempt_GND_Vge_e;
  double e1_Tempt_GND_Vdi_si;
  double e1_Tempt_GND_Ve_si;
  double e1_Tempt_GND_Ve_di;
  double e1_Tempt_GND_Vge_si;
  double e1_Tempt_GND_Tempt_GND;
  double e1_Vge_si_Vge_e;
  double e1_Vge_si_Vdi_si;
  double e1_Vge_si_Ve_si;
  double e1_Vge_si_Ve_di;
  double e1_Vge_si_Vge_si;
  double e1_Vge_si_Tempt_GND;
  double e1_Ve_di_Vge_e;
  double e1_Ve_di_Vdi_si;
  double e1_Ve_di_Ve_si;
  double e1_Ve_di_Ve_di;
  double e1_Ve_di_Vge_si;
  double e1_Ve_di_Tempt_GND;
  double e1_Ve_si_Vge_e;
  double e1_Ve_si_Vdi_si;
  double e1_Ve_si_Ve_si;
  double e1_Ve_si_Ve_di;
  double e1_Ve_si_Vge_si;
  double e1_Ve_si_Tempt_GND;
  double e1_Vdi_si_Vge_e;
  double e1_Vdi_si_Vdi_si;
  double e1_Vdi_si_Ve_si;
  double e1_Vdi_si_Ve_di;
  double e1_Vdi_si_Vge_si;
  double e1_Vdi_si_Tempt_GND;
  double e1_Vge_e_Vge_e;
  double e1_Vge_e_Vdi_si;
  double e1_Vge_e_Ve_si;
  double e1_Vge_e_Ve_di;
  double e1_Vge_e_Vge_si;
  double e1_Vge_e_Tempt_GND;
#endif
#endif
double e0;
#if defined(_DERIVATEFORDDX)
double e0_Vge_e;
double e0_Vge_si;
double e0_Ve_si;
double e0_Ve_di;
double e0_Vdi_si;
double e0_Tempt_GND;
#if defined(_DERIVATE2)
  double e0_Tempt_GND_Vge_e;
  double e0_Tempt_GND_Vge_si;
  double e0_Tempt_GND_Ve_si;
  double e0_Tempt_GND_Ve_di;
  double e0_Tempt_GND_Vdi_si;
  double e0_Tempt_GND_Tempt_GND;
  double e0_Vdi_si_Vge_e;
  double e0_Vdi_si_Vge_si;
  double e0_Vdi_si_Ve_si;
  double e0_Vdi_si_Ve_di;
  double e0_Vdi_si_Vdi_si;
  double e0_Vdi_si_Tempt_GND;
  double e0_Ve_di_Vge_e;
  double e0_Ve_di_Vge_si;
  double e0_Ve_di_Ve_si;
  double e0_Ve_di_Ve_di;
  double e0_Ve_di_Vdi_si;
  double e0_Ve_di_Tempt_GND;
  double e0_Ve_si_Vge_e;
  double e0_Ve_si_Vge_si;
  double e0_Ve_si_Ve_si;
  double e0_Ve_si_Ve_di;
  double e0_Ve_si_Vdi_si;
  double e0_Ve_si_Tempt_GND;
  double e0_Vge_si_Vge_e;
  double e0_Vge_si_Vge_si;
  double e0_Vge_si_Ve_si;
  double e0_Vge_si_Ve_di;
  double e0_Vge_si_Vdi_si;
  double e0_Vge_si_Tempt_GND;
  double e0_Vge_e_Vge_e;
  double e0_Vge_e_Vge_si;
  double e0_Vge_e_Ve_si;
  double e0_Vge_e_Ve_di;
  double e0_Vge_e_Vdi_si;
  double e0_Vge_e_Tempt_GND;
#endif
#endif
double F0;
#if defined(_DERIVATEFORDDX)
double F0_Vge_si;
double F0_Ve_si;
double F0_Ve_di;
double F0_Vdi_si;
double F0_Tempt_GND;
#if defined(_DERIVATE2)
  double F0_Tempt_GND_Vge_si;
  double F0_Tempt_GND_Ve_si;
  double F0_Tempt_GND_Ve_di;
  double F0_Tempt_GND_Vdi_si;
  double F0_Tempt_GND_Tempt_GND;
  double F0_Vdi_si_Vge_si;
  double F0_Vdi_si_Ve_si;
  double F0_Vdi_si_Ve_di;
  double F0_Vdi_si_Vdi_si;
  double F0_Vdi_si_Tempt_GND;
  double F0_Ve_di_Vge_si;
  double F0_Ve_di_Ve_si;
  double F0_Ve_di_Ve_di;
  double F0_Ve_di_Vdi_si;
  double F0_Ve_di_Tempt_GND;
  double F0_Ve_si_Vge_si;
  double F0_Ve_si_Ve_si;
  double F0_Ve_si_Ve_di;
  double F0_Ve_si_Vdi_si;
  double F0_Ve_si_Tempt_GND;
  double F0_Vge_si_Vge_si;
  double F0_Vge_si_Ve_si;
  double F0_Vge_si_Ve_di;
  double F0_Vge_si_Vdi_si;
  double F0_Vge_si_Tempt_GND;
#endif
#endif
double nq;
#if defined(_DERIVATEFORDDX)
double nq_Tempt_GND;
double nq_Vdi_si;
double nq_Vge_e;
double nq_Ve_si;
double nq_Ve_di;
double nq_Vge_si;
#if defined(_DERIVATE2)
  double nq_Vge_si_Tempt_GND;
  double nq_Vge_si_Vdi_si;
  double nq_Vge_si_Vge_e;
  double nq_Vge_si_Ve_si;
  double nq_Vge_si_Ve_di;
  double nq_Vge_si_Vge_si;
  double nq_Ve_di_Tempt_GND;
  double nq_Ve_di_Vdi_si;
  double nq_Ve_di_Vge_e;
  double nq_Ve_di_Ve_si;
  double nq_Ve_di_Ve_di;
  double nq_Ve_di_Vge_si;
  double nq_Ve_si_Tempt_GND;
  double nq_Ve_si_Vdi_si;
  double nq_Ve_si_Vge_e;
  double nq_Ve_si_Ve_si;
  double nq_Ve_si_Ve_di;
  double nq_Ve_si_Vge_si;
  double nq_Vge_e_Tempt_GND;
  double nq_Vge_e_Vdi_si;
  double nq_Vge_e_Vge_e;
  double nq_Vge_e_Ve_si;
  double nq_Vge_e_Ve_di;
  double nq_Vge_e_Vge_si;
  double nq_Vdi_si_Tempt_GND;
  double nq_Vdi_si_Vdi_si;
  double nq_Vdi_si_Vge_e;
  double nq_Vdi_si_Ve_si;
  double nq_Vdi_si_Ve_di;
  double nq_Vdi_si_Vge_si;
  double nq_Tempt_GND_Tempt_GND;
  double nq_Tempt_GND_Vdi_si;
  double nq_Tempt_GND_Vge_e;
  double nq_Tempt_GND_Ve_si;
  double nq_Tempt_GND_Ve_di;
  double nq_Tempt_GND_Vge_si;
#endif
#endif
double sqrtpsip;
#if defined(_DERIVATEFORDDX)
double sqrtpsip_Vge_e;
double sqrtpsip_Vdi_si;
double sqrtpsip_Ve_si;
double sqrtpsip_Ve_di;
double sqrtpsip_Vge_si;
double sqrtpsip_Tempt_GND;
#if defined(_DERIVATE2)
  double sqrtpsip_Tempt_GND_Vge_e;
  double sqrtpsip_Tempt_GND_Vdi_si;
  double sqrtpsip_Tempt_GND_Ve_si;
  double sqrtpsip_Tempt_GND_Ve_di;
  double sqrtpsip_Tempt_GND_Vge_si;
  double sqrtpsip_Tempt_GND_Tempt_GND;
  double sqrtpsip_Vge_si_Vge_e;
  double sqrtpsip_Vge_si_Vdi_si;
  double sqrtpsip_Vge_si_Ve_si;
  double sqrtpsip_Vge_si_Ve_di;
  double sqrtpsip_Vge_si_Vge_si;
  double sqrtpsip_Vge_si_Tempt_GND;
  double sqrtpsip_Ve_di_Vge_e;
  double sqrtpsip_Ve_di_Vdi_si;
  double sqrtpsip_Ve_di_Ve_si;
  double sqrtpsip_Ve_di_Ve_di;
  double sqrtpsip_Ve_di_Vge_si;
  double sqrtpsip_Ve_di_Tempt_GND;
  double sqrtpsip_Ve_si_Vge_e;
  double sqrtpsip_Ve_si_Vdi_si;
  double sqrtpsip_Ve_si_Ve_si;
  double sqrtpsip_Ve_si_Ve_di;
  double sqrtpsip_Ve_si_Vge_si;
  double sqrtpsip_Ve_si_Tempt_GND;
  double sqrtpsip_Vdi_si_Vge_e;
  double sqrtpsip_Vdi_si_Vdi_si;
  double sqrtpsip_Vdi_si_Ve_si;
  double sqrtpsip_Vdi_si_Ve_di;
  double sqrtpsip_Vdi_si_Vge_si;
  double sqrtpsip_Vdi_si_Tempt_GND;
  double sqrtpsip_Vge_e_Vge_e;
  double sqrtpsip_Vge_e_Vdi_si;
  double sqrtpsip_Vge_e_Ve_si;
  double sqrtpsip_Vge_e_Ve_di;
  double sqrtpsip_Vge_e_Vge_si;
  double sqrtpsip_Vge_e_Tempt_GND;
#endif
#endif
double psipclamp;
#if defined(_DERIVATEFORDDX)
double psipclamp_Vge_e;
double psipclamp_Vdi_si;
double psipclamp_Ve_si;
double psipclamp_Ve_di;
double psipclamp_Vge_si;
double psipclamp_Tempt_GND;
#if defined(_DERIVATE2)
  double psipclamp_Tempt_GND_Vge_e;
  double psipclamp_Tempt_GND_Vdi_si;
  double psipclamp_Tempt_GND_Ve_si;
  double psipclamp_Tempt_GND_Ve_di;
  double psipclamp_Tempt_GND_Vge_si;
  double psipclamp_Tempt_GND_Tempt_GND;
  double psipclamp_Vge_si_Vge_e;
  double psipclamp_Vge_si_Vdi_si;
  double psipclamp_Vge_si_Ve_si;
  double psipclamp_Vge_si_Ve_di;
  double psipclamp_Vge_si_Vge_si;
  double psipclamp_Vge_si_Tempt_GND;
  double psipclamp_Ve_di_Vge_e;
  double psipclamp_Ve_di_Vdi_si;
  double psipclamp_Ve_di_Ve_si;
  double psipclamp_Ve_di_Ve_di;
  double psipclamp_Ve_di_Vge_si;
  double psipclamp_Ve_di_Tempt_GND;
  double psipclamp_Ve_si_Vge_e;
  double psipclamp_Ve_si_Vdi_si;
  double psipclamp_Ve_si_Ve_si;
  double psipclamp_Ve_si_Ve_di;
  double psipclamp_Ve_si_Vge_si;
  double psipclamp_Ve_si_Tempt_GND;
  double psipclamp_Vdi_si_Vge_e;
  double psipclamp_Vdi_si_Vdi_si;
  double psipclamp_Vdi_si_Ve_si;
  double psipclamp_Vdi_si_Ve_di;
  double psipclamp_Vdi_si_Vge_si;
  double psipclamp_Vdi_si_Tempt_GND;
  double psipclamp_Vge_e_Vge_e;
  double psipclamp_Vge_e_Vdi_si;
  double psipclamp_Vge_e_Ve_si;
  double psipclamp_Vge_e_Ve_di;
  double psipclamp_Vge_e_Vge_si;
  double psipclamp_Vge_e_Tempt_GND;
#endif
#endif
double QMFACTORCVfinal;
#if defined(_DERIVATEFORDDX)
double QMFACTORCVfinal_Tempt_GND;
#if defined(_DERIVATE2)
  double QMFACTORCVfinal_Tempt_GND_Tempt_GND;
#endif
#endif
double auxQMfact;
double fieldnormalizationfactor;
#if defined(_DERIVATEFORDDX)
double fieldnormalizationfactor_Tempt_GND;
#if defined(_DERIVATE2)
  double fieldnormalizationfactor_Tempt_GND_Tempt_GND;
#endif
#endif
double qi_acc_for_QM;
#if defined(_DERIVATEFORDDX)
double qi_acc_for_QM_Tempt_GND;
double qi_acc_for_QM_Vdi_si;
double qi_acc_for_QM_Vge_e;
double qi_acc_for_QM_Ve_si;
double qi_acc_for_QM_Ve_di;
double qi_acc_for_QM_Vge_si;
#if defined(_DERIVATE2)
  double qi_acc_for_QM_Vge_si_Tempt_GND;
  double qi_acc_for_QM_Vge_si_Vdi_si;
  double qi_acc_for_QM_Vge_si_Vge_e;
  double qi_acc_for_QM_Vge_si_Ve_si;
  double qi_acc_for_QM_Vge_si_Ve_di;
  double qi_acc_for_QM_Vge_si_Vge_si;
  double qi_acc_for_QM_Ve_di_Tempt_GND;
  double qi_acc_for_QM_Ve_di_Vdi_si;
  double qi_acc_for_QM_Ve_di_Vge_e;
  double qi_acc_for_QM_Ve_di_Ve_si;
  double qi_acc_for_QM_Ve_di_Ve_di;
  double qi_acc_for_QM_Ve_di_Vge_si;
  double qi_acc_for_QM_Ve_si_Tempt_GND;
  double qi_acc_for_QM_Ve_si_Vdi_si;
  double qi_acc_for_QM_Ve_si_Vge_e;
  double qi_acc_for_QM_Ve_si_Ve_si;
  double qi_acc_for_QM_Ve_si_Ve_di;
  double qi_acc_for_QM_Ve_si_Vge_si;
  double qi_acc_for_QM_Vge_e_Tempt_GND;
  double qi_acc_for_QM_Vge_e_Vdi_si;
  double qi_acc_for_QM_Vge_e_Vge_e;
  double qi_acc_for_QM_Vge_e_Ve_si;
  double qi_acc_for_QM_Vge_e_Ve_di;
  double qi_acc_for_QM_Vge_e_Vge_si;
  double qi_acc_for_QM_Vdi_si_Tempt_GND;
  double qi_acc_for_QM_Vdi_si_Vdi_si;
  double qi_acc_for_QM_Vdi_si_Vge_e;
  double qi_acc_for_QM_Vdi_si_Ve_si;
  double qi_acc_for_QM_Vdi_si_Ve_di;
  double qi_acc_for_QM_Vdi_si_Vge_si;
  double qi_acc_for_QM_Tempt_GND_Tempt_GND;
  double qi_acc_for_QM_Tempt_GND_Vdi_si;
  double qi_acc_for_QM_Tempt_GND_Vge_e;
  double qi_acc_for_QM_Tempt_GND_Ve_si;
  double qi_acc_for_QM_Tempt_GND_Ve_di;
  double qi_acc_for_QM_Tempt_GND_Vge_si;
#endif
#endif
double vth_fixed_factor_SI;
#if defined(_DERIVATEFORDDX)
double vth_fixed_factor_SI_Tempt_GND;
double vth_fixed_factor_SI_Vdi_si;
#if defined(_DERIVATE2)
  double vth_fixed_factor_SI_Vdi_si_Tempt_GND;
  double vth_fixed_factor_SI_Vdi_si_Vdi_si;
  double vth_fixed_factor_SI_Tempt_GND_Tempt_GND;
  double vth_fixed_factor_SI_Tempt_GND_Vdi_si;
#endif
#endif
double vth_fixed_factor_Sub;
#if defined(_DERIVATEFORDDX)
double vth_fixed_factor_Sub_Tempt_GND;
double vth_fixed_factor_Sub_Vdi_si;
#if defined(_DERIVATE2)
  double vth_fixed_factor_Sub_Vdi_si_Tempt_GND;
  double vth_fixed_factor_Sub_Vdi_si_Vdi_si;
  double vth_fixed_factor_Sub_Tempt_GND_Tempt_GND;
  double vth_fixed_factor_Sub_Tempt_GND_Vdi_si;
#endif
#endif
double rc;
double qdep;
#if defined(_DERIVATEFORDDX)
double qdep_Tempt_GND;
double qdep_Vdi_si;
#if defined(_DERIVATE2)
  double qdep_Vdi_si_Tempt_GND;
  double qdep_Vdi_si_Vdi_si;
  double qdep_Tempt_GND_Tempt_GND;
  double qdep_Tempt_GND_Vdi_si;
#endif
#endif
double Weff_UFCM;
double Ach;
double Cins;
double qm;
#if defined(_DERIVATEFORDDX)
double qm_Vdi_si;
double qm_Ve_si;
double qm_Ve_di;
double qm_Vge_si;
double qm_Tempt_GND;
#if defined(_DERIVATE2)
  double qm_Tempt_GND_Vdi_si;
  double qm_Tempt_GND_Ve_si;
  double qm_Tempt_GND_Ve_di;
  double qm_Tempt_GND_Vge_si;
  double qm_Tempt_GND_Tempt_GND;
  double qm_Vge_si_Vdi_si;
  double qm_Vge_si_Ve_si;
  double qm_Vge_si_Ve_di;
  double qm_Vge_si_Vge_si;
  double qm_Vge_si_Tempt_GND;
  double qm_Ve_di_Vdi_si;
  double qm_Ve_di_Ve_si;
  double qm_Ve_di_Ve_di;
  double qm_Ve_di_Vge_si;
  double qm_Ve_di_Tempt_GND;
  double qm_Ve_si_Vdi_si;
  double qm_Ve_si_Ve_si;
  double qm_Ve_si_Ve_di;
  double qm_Ve_si_Vge_si;
  double qm_Ve_si_Tempt_GND;
  double qm_Vdi_si_Vdi_si;
  double qm_Vdi_si_Ve_si;
  double qm_Vdi_si_Ve_di;
  double qm_Vdi_si_Vge_si;
  double qm_Vdi_si_Tempt_GND;
#endif
#endif
double ggeltd;
double delta;
#if defined(_DERIVATE)
double delta_Vdi_d;
double delta_Vsi_s;
double delta_Vge_di;
double delta_Vge_e;
double delta_Ve_si;
double delta_Ve_di;
double delta_Vge_si;
double delta_Vdi_si;
double delta_Tempt_GND;
#endif
double gamma;
#if defined(_DERIVATE)
double gamma_Vge_di;
double gamma_Vdi_d;
double gamma_Vsi_s;
double gamma_Vge_e;
double gamma_Vdi_si;
double gamma_Tempt_GND;
double gamma_Ve_si;
double gamma_Ve_di;
double gamma_Vge_si;
#endif
#if defined(_DYNAMIC)
double C0;
#if defined(_DERIVATE)
double C0_Vge_e;
double C0_Vdi_si;
double C0_Ve_si;
double C0_Ve_di;
double C0_Vge_si;
double C0_Tempt_GND;
#endif
#endif
double sf;
#if defined(_DERIVATE)
double sf_Tempt_GND;
double sf_Vdi_si;
double sf_Ve_si;
double sf_Ve_di;
double sf_Vge_si;
double sf_Vge_di;
double sf_Vdi_d;
double sf_Vsi_s;
double sf_Vge_e;
#endif
double ctnoi;
#if defined(_DERIVATE)
double ctnoi_Vge_di;
double ctnoi_Vdi_d;
double ctnoi_Vsi_s;
double ctnoi_Vge_e;
double ctnoi_Vdi_si;
double ctnoi_Ve_si;
double ctnoi_Ve_di;
double ctnoi_Vge_si;
double ctnoi_Tempt_GND;
#endif
double sid;
#if defined(_DERIVATE)
double sid_Tempt_GND;
double sid_Vge_di;
double sid_Vge_e;
double sid_Ve_si;
double sid_Ve_di;
double sid_Vge_si;
double sid_Vdi_si;
double sid_Vdi_d;
double sid_Vsi_s;
#endif
double u0r;
#if defined(_DERIVATEFORDDX)
double u0r_Tempt_GND;
#if defined(_DERIVATE2)
  double u0r_Tempt_GND_Tempt_GND;
#endif
#endif
double VSATR_t;
#if defined(_DERIVATEFORDDX)
double VSATR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double VSATR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double VSATR_i;
double UTLR_i;
double UTER_i;
double UDR_i;
double UD1R_i;
double UCR_i;
double UC1R_i;
double UAR_i;
double UA1R_i;
double DVTSHIFTR_i;
double VSAT_a;
#if defined(_DERIVATEFORDDX)
double VSAT_a_Tempt_GND;
double VSAT_a_Vdi_si;
#if defined(_DERIVATE2)
  double VSAT_a_Vdi_si_Tempt_GND;
  double VSAT_a_Vdi_si_Vdi_si;
  double VSAT_a_Tempt_GND_Tempt_GND;
  double VSAT_a_Tempt_GND_Vdi_si;
#endif
#endif
double UDR_t;
#if defined(_DERIVATEFORDDX)
double UDR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UDR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double UCR_t;
#if defined(_DERIVATEFORDDX)
double UCR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UCR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double UAR_t;
#if defined(_DERIVATEFORDDX)
double UAR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UAR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double U0R_t;
#if defined(_DERIVATEFORDDX)
double U0R_t_Tempt_GND;
#if defined(_DERIVATE2)
  double U0R_t_Tempt_GND_Tempt_GND;
#endif
#endif
double veseff;
#if defined(_DERIVATEFORDDX)
double veseff_Ve_si;
double veseff_Ve_di;
double veseff_Vdi_si;
double veseff_Tempt_GND;
#if defined(_DERIVATE2)
  double veseff_Tempt_GND_Ve_si;
  double veseff_Tempt_GND_Ve_di;
  double veseff_Tempt_GND_Vdi_si;
  double veseff_Tempt_GND_Tempt_GND;
  double veseff_Vdi_si_Ve_si;
  double veseff_Vdi_si_Ve_di;
  double veseff_Vdi_si_Vdi_si;
  double veseff_Vdi_si_Tempt_GND;
  double veseff_Ve_di_Ve_si;
  double veseff_Ve_di_Ve_di;
  double veseff_Ve_di_Vdi_si;
  double veseff_Ve_di_Tempt_GND;
  double veseff_Ve_si_Ve_si;
  double veseff_Ve_si_Ve_di;
  double veseff_Ve_si_Vdi_si;
  double veseff_Ve_si_Tempt_GND;
#endif
#endif
double Tcen0;
double T3y;
double Rdsi;
#if defined(_DERIVATEFORDDX)
double Rdsi_Tempt_GND;
double Rdsi_Vge_di;
double Rdsi_Vge_e;
double Rdsi_Ve_si;
double Rdsi_Ve_di;
double Rdsi_Vge_si;
double Rdsi_Vdi_si;
#if defined(_DERIVATE2)
  double Rdsi_Vdi_si_Tempt_GND;
  double Rdsi_Vdi_si_Vge_di;
  double Rdsi_Vdi_si_Vge_e;
  double Rdsi_Vdi_si_Ve_si;
  double Rdsi_Vdi_si_Ve_di;
  double Rdsi_Vdi_si_Vge_si;
  double Rdsi_Vdi_si_Vdi_si;
  double Rdsi_Vge_si_Tempt_GND;
  double Rdsi_Vge_si_Vge_di;
  double Rdsi_Vge_si_Vge_e;
  double Rdsi_Vge_si_Ve_si;
  double Rdsi_Vge_si_Ve_di;
  double Rdsi_Vge_si_Vge_si;
  double Rdsi_Vge_si_Vdi_si;
  double Rdsi_Ve_di_Tempt_GND;
  double Rdsi_Ve_di_Vge_di;
  double Rdsi_Ve_di_Vge_e;
  double Rdsi_Ve_di_Ve_si;
  double Rdsi_Ve_di_Ve_di;
  double Rdsi_Ve_di_Vge_si;
  double Rdsi_Ve_di_Vdi_si;
  double Rdsi_Ve_si_Tempt_GND;
  double Rdsi_Ve_si_Vge_di;
  double Rdsi_Ve_si_Vge_e;
  double Rdsi_Ve_si_Ve_si;
  double Rdsi_Ve_si_Ve_di;
  double Rdsi_Ve_si_Vge_si;
  double Rdsi_Ve_si_Vdi_si;
  double Rdsi_Vge_e_Tempt_GND;
  double Rdsi_Vge_e_Vge_di;
  double Rdsi_Vge_e_Vge_e;
  double Rdsi_Vge_e_Ve_si;
  double Rdsi_Vge_e_Ve_di;
  double Rdsi_Vge_e_Vge_si;
  double Rdsi_Vge_e_Vdi_si;
  double Rdsi_Vge_di_Tempt_GND;
  double Rdsi_Vge_di_Vge_di;
  double Rdsi_Vge_di_Vge_e;
  double Rdsi_Vge_di_Ve_si;
  double Rdsi_Vge_di_Ve_di;
  double Rdsi_Vge_di_Vge_si;
  double Rdsi_Vge_di_Vdi_si;
  double Rdsi_Tempt_GND_Tempt_GND;
  double Rdsi_Tempt_GND_Vge_di;
  double Rdsi_Tempt_GND_Vge_e;
  double Rdsi_Tempt_GND_Ve_si;
  double Rdsi_Tempt_GND_Ve_di;
  double Rdsi_Tempt_GND_Vge_si;
  double Rdsi_Tempt_GND_Vdi_si;
#endif
#endif
double RSDRR_t;
#if defined(_DERIVATEFORDDX)
double RSDRR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double RSDRR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double RDDRR_t;
#if defined(_DERIVATEFORDDX)
double RDDRR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double RDDRR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double LeffCV_acc;
double PCLMR_i;
double DVTP1_i;
double DVTP0_i;
double CITR_i;
double ATR_i;
double EUR_i;
double UPR_i;
double U0R_i;
double UC_t;
#if defined(_DERIVATEFORDDX)
double UC_t_Tempt_GND;
#if defined(_DERIVATE2)
  double UC_t_Tempt_GND_Tempt_GND;
#endif
#endif
double UC1_i;
double UC_i;
double K21_i;
double K2_i;
double KSATIVR_i;
double K2SAT1_i;
double K2SAT_i;
double K11_i;
double K1_i;
double PHIBE_i;
double PDIBL2R_i;
double PDIBL1R_i;
double PTWGR_t;
#if defined(_DERIVATEFORDDX)
double PTWGR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PTWGR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PTWGR_i;
double MEXPR_t;
#if defined(_DERIVATEFORDDX)
double MEXPR_t_Tempt_GND;
#if defined(_DERIVATE2)
  double MEXPR_t_Tempt_GND_Tempt_GND;
#endif
#endif
double MEXPR_i;
double VSAT1R_t;
#if defined(_DERIVATEFORDDX)
double VSAT1R_t_Tempt_GND;
#if defined(_DERIVATE2)
  double VSAT1R_t_Tempt_GND_Tempt_GND;
#endif
#endif
double VSAT1R_i;
double ETA0R_i;
double CDSCDR_i;
double Dr;
#if defined(_DERIVATEFORDDX)
double Dr_Tempt_GND;
double Dr_Vdi_si;
double Dr_Vge_e;
double Dr_Ve_si;
double Dr_Ve_di;
double Dr_Vge_si;
double Dr_Vge_di;
#if defined(_DERIVATE2)
  double Dr_Vge_di_Tempt_GND;
  double Dr_Vge_di_Vdi_si;
  double Dr_Vge_di_Vge_e;
  double Dr_Vge_di_Ve_si;
  double Dr_Vge_di_Ve_di;
  double Dr_Vge_di_Vge_si;
  double Dr_Vge_di_Vge_di;
  double Dr_Vge_si_Tempt_GND;
  double Dr_Vge_si_Vdi_si;
  double Dr_Vge_si_Vge_e;
  double Dr_Vge_si_Ve_si;
  double Dr_Vge_si_Ve_di;
  double Dr_Vge_si_Vge_si;
  double Dr_Vge_si_Vge_di;
  double Dr_Ve_di_Tempt_GND;
  double Dr_Ve_di_Vdi_si;
  double Dr_Ve_di_Vge_e;
  double Dr_Ve_di_Ve_si;
  double Dr_Ve_di_Ve_di;
  double Dr_Ve_di_Vge_si;
  double Dr_Ve_di_Vge_di;
  double Dr_Ve_si_Tempt_GND;
  double Dr_Ve_si_Vdi_si;
  double Dr_Ve_si_Vge_e;
  double Dr_Ve_si_Ve_si;
  double Dr_Ve_si_Ve_di;
  double Dr_Ve_si_Vge_si;
  double Dr_Ve_si_Vge_di;
  double Dr_Vge_e_Tempt_GND;
  double Dr_Vge_e_Vdi_si;
  double Dr_Vge_e_Vge_e;
  double Dr_Vge_e_Ve_si;
  double Dr_Vge_e_Ve_di;
  double Dr_Vge_e_Vge_si;
  double Dr_Vge_e_Vge_di;
  double Dr_Vdi_si_Tempt_GND;
  double Dr_Vdi_si_Vdi_si;
  double Dr_Vdi_si_Vge_e;
  double Dr_Vdi_si_Ve_si;
  double Dr_Vdi_si_Ve_di;
  double Dr_Vdi_si_Vge_si;
  double Dr_Vdi_si_Vge_di;
  double Dr_Tempt_GND_Tempt_GND;
  double Dr_Tempt_GND_Vdi_si;
  double Dr_Tempt_GND_Vge_e;
  double Dr_Tempt_GND_Ve_si;
  double Dr_Tempt_GND_Ve_di;
  double Dr_Tempt_GND_Vge_si;
  double Dr_Tempt_GND_Vge_di;
#endif
#endif
double gdpr;
#if defined(_DERIVATE)
double gdpr_Tempt_GND;
double gdpr_Vdi_d;
double gdpr_Vsi_s;
double gdpr_Vge_e;
double gdpr_Vdi_si;
double gdpr_Ve_si;
double gdpr_Ve_di;
double gdpr_Vge_si;
double gdpr_Vge_di;
#endif
double gspr;
#if defined(_DERIVATE)
double gspr_Tempt_GND;
double gspr_Vsi_s;
double gspr_Vge_e;
double gspr_Vdi_si;
double gspr_Ve_si;
double gspr_Ve_di;
double gspr_Vge_si;
#endif
double Gtnoi;
#if defined(_DERIVATE)
double Gtnoi_Vge_di;
double Gtnoi_Vge_e;
double Gtnoi_Ve_si;
double Gtnoi_Ve_di;
double Gtnoi_Vge_si;
double Gtnoi_Vdi_si;
double Gtnoi_Tempt_GND;
double Gtnoi_Vdi_d;
double Gtnoi_Vsi_s;
#endif
double FNPowerAt1Hz;
#if defined(_DERIVATE)
double FNPowerAt1Hz_Vge_di;
double FNPowerAt1Hz_Vge_e;
double FNPowerAt1Hz_Ve_si;
double FNPowerAt1Hz_Ve_di;
double FNPowerAt1Hz_Vge_si;
double FNPowerAt1Hz_Vdi_si;
double FNPowerAt1Hz_Tempt_GND;
double FNPowerAt1Hz_Vdi_d;
double FNPowerAt1Hz_Vsi_s;
#endif
#if defined(_DYNAMIC)
double qgd_parasitic;
#if defined(_DERIVATEFORDDX)
double qgd_parasitic_Vge_d;
double qgd_parasitic_Vge_di;
double qgd_parasitic_Vge_e;
double qgd_parasitic_Ve_si;
double qgd_parasitic_Ve_di;
double qgd_parasitic_Vge_si;
double qgd_parasitic_Vdi_si;
double qgd_parasitic_Tempt_GND;
#if defined(_DERIVATE2)
  double qgd_parasitic_Tempt_GND_Vge_d;
  double qgd_parasitic_Tempt_GND_Vge_di;
  double qgd_parasitic_Tempt_GND_Vge_e;
  double qgd_parasitic_Tempt_GND_Ve_si;
  double qgd_parasitic_Tempt_GND_Ve_di;
  double qgd_parasitic_Tempt_GND_Vge_si;
  double qgd_parasitic_Tempt_GND_Vdi_si;
  double qgd_parasitic_Tempt_GND_Tempt_GND;
  double qgd_parasitic_Vdi_si_Vge_d;
  double qgd_parasitic_Vdi_si_Vge_di;
  double qgd_parasitic_Vdi_si_Vge_e;
  double qgd_parasitic_Vdi_si_Ve_si;
  double qgd_parasitic_Vdi_si_Ve_di;
  double qgd_parasitic_Vdi_si_Vge_si;
  double qgd_parasitic_Vdi_si_Vdi_si;
  double qgd_parasitic_Vdi_si_Tempt_GND;
  double qgd_parasitic_Vge_si_Vge_d;
  double qgd_parasitic_Vge_si_Vge_di;
  double qgd_parasitic_Vge_si_Vge_e;
  double qgd_parasitic_Vge_si_Ve_si;
  double qgd_parasitic_Vge_si_Ve_di;
  double qgd_parasitic_Vge_si_Vge_si;
  double qgd_parasitic_Vge_si_Vdi_si;
  double qgd_parasitic_Vge_si_Tempt_GND;
  double qgd_parasitic_Ve_di_Vge_d;
  double qgd_parasitic_Ve_di_Vge_di;
  double qgd_parasitic_Ve_di_Vge_e;
  double qgd_parasitic_Ve_di_Ve_si;
  double qgd_parasitic_Ve_di_Ve_di;
  double qgd_parasitic_Ve_di_Vge_si;
  double qgd_parasitic_Ve_di_Vdi_si;
  double qgd_parasitic_Ve_di_Tempt_GND;
  double qgd_parasitic_Ve_si_Vge_d;
  double qgd_parasitic_Ve_si_Vge_di;
  double qgd_parasitic_Ve_si_Vge_e;
  double qgd_parasitic_Ve_si_Ve_si;
  double qgd_parasitic_Ve_si_Ve_di;
  double qgd_parasitic_Ve_si_Vge_si;
  double qgd_parasitic_Ve_si_Vdi_si;
  double qgd_parasitic_Ve_si_Tempt_GND;
  double qgd_parasitic_Vge_e_Vge_d;
  double qgd_parasitic_Vge_e_Vge_di;
  double qgd_parasitic_Vge_e_Vge_e;
  double qgd_parasitic_Vge_e_Ve_si;
  double qgd_parasitic_Vge_e_Ve_di;
  double qgd_parasitic_Vge_e_Vge_si;
  double qgd_parasitic_Vge_e_Vdi_si;
  double qgd_parasitic_Vge_e_Tempt_GND;
  double qgd_parasitic_Vge_di_Vge_d;
  double qgd_parasitic_Vge_di_Vge_di;
  double qgd_parasitic_Vge_di_Vge_e;
  double qgd_parasitic_Vge_di_Ve_si;
  double qgd_parasitic_Vge_di_Ve_di;
  double qgd_parasitic_Vge_di_Vge_si;
  double qgd_parasitic_Vge_di_Vdi_si;
  double qgd_parasitic_Vge_di_Tempt_GND;
  double qgd_parasitic_Vge_d_Vge_d;
  double qgd_parasitic_Vge_d_Vge_di;
  double qgd_parasitic_Vge_d_Vge_e;
  double qgd_parasitic_Vge_d_Ve_si;
  double qgd_parasitic_Vge_d_Ve_di;
  double qgd_parasitic_Vge_d_Vge_si;
  double qgd_parasitic_Vge_d_Vdi_si;
  double qgd_parasitic_Vge_d_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qgs_parasitic;
#if defined(_DERIVATEFORDDX)
double qgs_parasitic_Vge_s;
double qgs_parasitic_Vge_di;
double qgs_parasitic_Vge_e;
double qgs_parasitic_Ve_si;
double qgs_parasitic_Ve_di;
double qgs_parasitic_Vge_si;
double qgs_parasitic_Vdi_si;
double qgs_parasitic_Tempt_GND;
#if defined(_DERIVATE2)
  double qgs_parasitic_Tempt_GND_Vge_s;
  double qgs_parasitic_Tempt_GND_Vge_di;
  double qgs_parasitic_Tempt_GND_Vge_e;
  double qgs_parasitic_Tempt_GND_Ve_si;
  double qgs_parasitic_Tempt_GND_Ve_di;
  double qgs_parasitic_Tempt_GND_Vge_si;
  double qgs_parasitic_Tempt_GND_Vdi_si;
  double qgs_parasitic_Tempt_GND_Tempt_GND;
  double qgs_parasitic_Vdi_si_Vge_s;
  double qgs_parasitic_Vdi_si_Vge_di;
  double qgs_parasitic_Vdi_si_Vge_e;
  double qgs_parasitic_Vdi_si_Ve_si;
  double qgs_parasitic_Vdi_si_Ve_di;
  double qgs_parasitic_Vdi_si_Vge_si;
  double qgs_parasitic_Vdi_si_Vdi_si;
  double qgs_parasitic_Vdi_si_Tempt_GND;
  double qgs_parasitic_Vge_si_Vge_s;
  double qgs_parasitic_Vge_si_Vge_di;
  double qgs_parasitic_Vge_si_Vge_e;
  double qgs_parasitic_Vge_si_Ve_si;
  double qgs_parasitic_Vge_si_Ve_di;
  double qgs_parasitic_Vge_si_Vge_si;
  double qgs_parasitic_Vge_si_Vdi_si;
  double qgs_parasitic_Vge_si_Tempt_GND;
  double qgs_parasitic_Ve_di_Vge_s;
  double qgs_parasitic_Ve_di_Vge_di;
  double qgs_parasitic_Ve_di_Vge_e;
  double qgs_parasitic_Ve_di_Ve_si;
  double qgs_parasitic_Ve_di_Ve_di;
  double qgs_parasitic_Ve_di_Vge_si;
  double qgs_parasitic_Ve_di_Vdi_si;
  double qgs_parasitic_Ve_di_Tempt_GND;
  double qgs_parasitic_Ve_si_Vge_s;
  double qgs_parasitic_Ve_si_Vge_di;
  double qgs_parasitic_Ve_si_Vge_e;
  double qgs_parasitic_Ve_si_Ve_si;
  double qgs_parasitic_Ve_si_Ve_di;
  double qgs_parasitic_Ve_si_Vge_si;
  double qgs_parasitic_Ve_si_Vdi_si;
  double qgs_parasitic_Ve_si_Tempt_GND;
  double qgs_parasitic_Vge_e_Vge_s;
  double qgs_parasitic_Vge_e_Vge_di;
  double qgs_parasitic_Vge_e_Vge_e;
  double qgs_parasitic_Vge_e_Ve_si;
  double qgs_parasitic_Vge_e_Ve_di;
  double qgs_parasitic_Vge_e_Vge_si;
  double qgs_parasitic_Vge_e_Vdi_si;
  double qgs_parasitic_Vge_e_Tempt_GND;
  double qgs_parasitic_Vge_di_Vge_s;
  double qgs_parasitic_Vge_di_Vge_di;
  double qgs_parasitic_Vge_di_Vge_e;
  double qgs_parasitic_Vge_di_Ve_si;
  double qgs_parasitic_Vge_di_Ve_di;
  double qgs_parasitic_Vge_di_Vge_si;
  double qgs_parasitic_Vge_di_Vdi_si;
  double qgs_parasitic_Vge_di_Tempt_GND;
  double qgs_parasitic_Vge_s_Vge_s;
  double qgs_parasitic_Vge_s_Vge_di;
  double qgs_parasitic_Vge_s_Vge_e;
  double qgs_parasitic_Vge_s_Ve_si;
  double qgs_parasitic_Vge_s_Ve_di;
  double qgs_parasitic_Vge_s_Vge_si;
  double qgs_parasitic_Vge_s_Vdi_si;
  double qgs_parasitic_Vge_s_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qds_fr;
#if defined(_DERIVATE)
double qds_fr_Vd_s;
#endif
#endif
#if defined(_DYNAMIC)
double qgd_fr;
#if defined(_DERIVATEFORDDX)
double qgd_fr_Vge_d;
double qgd_fr_Vge_di;
double qgd_fr_Vge_e;
double qgd_fr_Ve_si;
double qgd_fr_Ve_di;
double qgd_fr_Vge_si;
double qgd_fr_Vdi_si;
double qgd_fr_Tempt_GND;
#if defined(_DERIVATE2)
  double qgd_fr_Tempt_GND_Vge_d;
  double qgd_fr_Tempt_GND_Vge_di;
  double qgd_fr_Tempt_GND_Vge_e;
  double qgd_fr_Tempt_GND_Ve_si;
  double qgd_fr_Tempt_GND_Ve_di;
  double qgd_fr_Tempt_GND_Vge_si;
  double qgd_fr_Tempt_GND_Vdi_si;
  double qgd_fr_Tempt_GND_Tempt_GND;
  double qgd_fr_Vdi_si_Vge_d;
  double qgd_fr_Vdi_si_Vge_di;
  double qgd_fr_Vdi_si_Vge_e;
  double qgd_fr_Vdi_si_Ve_si;
  double qgd_fr_Vdi_si_Ve_di;
  double qgd_fr_Vdi_si_Vge_si;
  double qgd_fr_Vdi_si_Vdi_si;
  double qgd_fr_Vdi_si_Tempt_GND;
  double qgd_fr_Vge_si_Vge_d;
  double qgd_fr_Vge_si_Vge_di;
  double qgd_fr_Vge_si_Vge_e;
  double qgd_fr_Vge_si_Ve_si;
  double qgd_fr_Vge_si_Ve_di;
  double qgd_fr_Vge_si_Vge_si;
  double qgd_fr_Vge_si_Vdi_si;
  double qgd_fr_Vge_si_Tempt_GND;
  double qgd_fr_Ve_di_Vge_d;
  double qgd_fr_Ve_di_Vge_di;
  double qgd_fr_Ve_di_Vge_e;
  double qgd_fr_Ve_di_Ve_si;
  double qgd_fr_Ve_di_Ve_di;
  double qgd_fr_Ve_di_Vge_si;
  double qgd_fr_Ve_di_Vdi_si;
  double qgd_fr_Ve_di_Tempt_GND;
  double qgd_fr_Ve_si_Vge_d;
  double qgd_fr_Ve_si_Vge_di;
  double qgd_fr_Ve_si_Vge_e;
  double qgd_fr_Ve_si_Ve_si;
  double qgd_fr_Ve_si_Ve_di;
  double qgd_fr_Ve_si_Vge_si;
  double qgd_fr_Ve_si_Vdi_si;
  double qgd_fr_Ve_si_Tempt_GND;
  double qgd_fr_Vge_e_Vge_d;
  double qgd_fr_Vge_e_Vge_di;
  double qgd_fr_Vge_e_Vge_e;
  double qgd_fr_Vge_e_Ve_si;
  double qgd_fr_Vge_e_Ve_di;
  double qgd_fr_Vge_e_Vge_si;
  double qgd_fr_Vge_e_Vdi_si;
  double qgd_fr_Vge_e_Tempt_GND;
  double qgd_fr_Vge_di_Vge_d;
  double qgd_fr_Vge_di_Vge_di;
  double qgd_fr_Vge_di_Vge_e;
  double qgd_fr_Vge_di_Ve_si;
  double qgd_fr_Vge_di_Ve_di;
  double qgd_fr_Vge_di_Vge_si;
  double qgd_fr_Vge_di_Vdi_si;
  double qgd_fr_Vge_di_Tempt_GND;
  double qgd_fr_Vge_d_Vge_d;
  double qgd_fr_Vge_d_Vge_di;
  double qgd_fr_Vge_d_Vge_e;
  double qgd_fr_Vge_d_Ve_si;
  double qgd_fr_Vge_d_Ve_di;
  double qgd_fr_Vge_d_Vge_si;
  double qgd_fr_Vge_d_Vdi_si;
  double qgd_fr_Vge_d_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qgs_fr;
#if defined(_DERIVATEFORDDX)
double qgs_fr_Vge_s;
double qgs_fr_Vge_di;
double qgs_fr_Vge_e;
double qgs_fr_Ve_si;
double qgs_fr_Ve_di;
double qgs_fr_Vge_si;
double qgs_fr_Vdi_si;
double qgs_fr_Tempt_GND;
#if defined(_DERIVATE2)
  double qgs_fr_Tempt_GND_Vge_s;
  double qgs_fr_Tempt_GND_Vge_di;
  double qgs_fr_Tempt_GND_Vge_e;
  double qgs_fr_Tempt_GND_Ve_si;
  double qgs_fr_Tempt_GND_Ve_di;
  double qgs_fr_Tempt_GND_Vge_si;
  double qgs_fr_Tempt_GND_Vdi_si;
  double qgs_fr_Tempt_GND_Tempt_GND;
  double qgs_fr_Vdi_si_Vge_s;
  double qgs_fr_Vdi_si_Vge_di;
  double qgs_fr_Vdi_si_Vge_e;
  double qgs_fr_Vdi_si_Ve_si;
  double qgs_fr_Vdi_si_Ve_di;
  double qgs_fr_Vdi_si_Vge_si;
  double qgs_fr_Vdi_si_Vdi_si;
  double qgs_fr_Vdi_si_Tempt_GND;
  double qgs_fr_Vge_si_Vge_s;
  double qgs_fr_Vge_si_Vge_di;
  double qgs_fr_Vge_si_Vge_e;
  double qgs_fr_Vge_si_Ve_si;
  double qgs_fr_Vge_si_Ve_di;
  double qgs_fr_Vge_si_Vge_si;
  double qgs_fr_Vge_si_Vdi_si;
  double qgs_fr_Vge_si_Tempt_GND;
  double qgs_fr_Ve_di_Vge_s;
  double qgs_fr_Ve_di_Vge_di;
  double qgs_fr_Ve_di_Vge_e;
  double qgs_fr_Ve_di_Ve_si;
  double qgs_fr_Ve_di_Ve_di;
  double qgs_fr_Ve_di_Vge_si;
  double qgs_fr_Ve_di_Vdi_si;
  double qgs_fr_Ve_di_Tempt_GND;
  double qgs_fr_Ve_si_Vge_s;
  double qgs_fr_Ve_si_Vge_di;
  double qgs_fr_Ve_si_Vge_e;
  double qgs_fr_Ve_si_Ve_si;
  double qgs_fr_Ve_si_Ve_di;
  double qgs_fr_Ve_si_Vge_si;
  double qgs_fr_Ve_si_Vdi_si;
  double qgs_fr_Ve_si_Tempt_GND;
  double qgs_fr_Vge_e_Vge_s;
  double qgs_fr_Vge_e_Vge_di;
  double qgs_fr_Vge_e_Vge_e;
  double qgs_fr_Vge_e_Ve_si;
  double qgs_fr_Vge_e_Ve_di;
  double qgs_fr_Vge_e_Vge_si;
  double qgs_fr_Vge_e_Vdi_si;
  double qgs_fr_Vge_e_Tempt_GND;
  double qgs_fr_Vge_di_Vge_s;
  double qgs_fr_Vge_di_Vge_di;
  double qgs_fr_Vge_di_Vge_e;
  double qgs_fr_Vge_di_Ve_si;
  double qgs_fr_Vge_di_Ve_di;
  double qgs_fr_Vge_di_Vge_si;
  double qgs_fr_Vge_di_Vdi_si;
  double qgs_fr_Vge_di_Tempt_GND;
  double qgs_fr_Vge_s_Vge_s;
  double qgs_fr_Vge_s_Vge_di;
  double qgs_fr_Vge_s_Vge_e;
  double qgs_fr_Vge_s_Ve_si;
  double qgs_fr_Vge_s_Ve_di;
  double qgs_fr_Vge_s_Vge_si;
  double qgs_fr_Vge_s_Vdi_si;
  double qgs_fr_Vge_s_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qg_acc;
#if defined(_DERIVATEFORDDX)
double qg_acc_Vge_di;
double qg_acc_Vge_e;
double qg_acc_Ve_si;
double qg_acc_Ve_di;
double qg_acc_Vge_si;
double qg_acc_Vdi_si;
double qg_acc_Tempt_GND;
#if defined(_DERIVATE2)
  double qg_acc_Tempt_GND_Vge_di;
  double qg_acc_Tempt_GND_Vge_e;
  double qg_acc_Tempt_GND_Ve_si;
  double qg_acc_Tempt_GND_Ve_di;
  double qg_acc_Tempt_GND_Vge_si;
  double qg_acc_Tempt_GND_Vdi_si;
  double qg_acc_Tempt_GND_Tempt_GND;
  double qg_acc_Vdi_si_Vge_di;
  double qg_acc_Vdi_si_Vge_e;
  double qg_acc_Vdi_si_Ve_si;
  double qg_acc_Vdi_si_Ve_di;
  double qg_acc_Vdi_si_Vge_si;
  double qg_acc_Vdi_si_Vdi_si;
  double qg_acc_Vdi_si_Tempt_GND;
  double qg_acc_Vge_si_Vge_di;
  double qg_acc_Vge_si_Vge_e;
  double qg_acc_Vge_si_Ve_si;
  double qg_acc_Vge_si_Ve_di;
  double qg_acc_Vge_si_Vge_si;
  double qg_acc_Vge_si_Vdi_si;
  double qg_acc_Vge_si_Tempt_GND;
  double qg_acc_Ve_di_Vge_di;
  double qg_acc_Ve_di_Vge_e;
  double qg_acc_Ve_di_Ve_si;
  double qg_acc_Ve_di_Ve_di;
  double qg_acc_Ve_di_Vge_si;
  double qg_acc_Ve_di_Vdi_si;
  double qg_acc_Ve_di_Tempt_GND;
  double qg_acc_Ve_si_Vge_di;
  double qg_acc_Ve_si_Vge_e;
  double qg_acc_Ve_si_Ve_si;
  double qg_acc_Ve_si_Ve_di;
  double qg_acc_Ve_si_Vge_si;
  double qg_acc_Ve_si_Vdi_si;
  double qg_acc_Ve_si_Tempt_GND;
  double qg_acc_Vge_e_Vge_di;
  double qg_acc_Vge_e_Vge_e;
  double qg_acc_Vge_e_Ve_si;
  double qg_acc_Vge_e_Ve_di;
  double qg_acc_Vge_e_Vge_si;
  double qg_acc_Vge_e_Vdi_si;
  double qg_acc_Vge_e_Tempt_GND;
  double qg_acc_Vge_di_Vge_di;
  double qg_acc_Vge_di_Vge_e;
  double qg_acc_Vge_di_Ve_si;
  double qg_acc_Vge_di_Ve_di;
  double qg_acc_Vge_di_Vge_si;
  double qg_acc_Vge_di_Vdi_si;
  double qg_acc_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double qb_acc;
#if defined(_DERIVATEFORDDX)
double qb_acc_Vge_di;
double qb_acc_Vge_e;
double qb_acc_Ve_si;
double qb_acc_Ve_di;
double qb_acc_Vge_si;
double qb_acc_Vdi_si;
double qb_acc_Tempt_GND;
#if defined(_DERIVATE2)
  double qb_acc_Vdi_si_Vge_di;
  double qb_acc_Vdi_si_Vge_e;
  double qb_acc_Vdi_si_Ve_si;
  double qb_acc_Vdi_si_Ve_di;
  double qb_acc_Vdi_si_Vge_si;
  double qb_acc_Vdi_si_Vdi_si;
  double qb_acc_Vdi_si_Tempt_GND;
  double qb_acc_Vge_si_Vge_di;
  double qb_acc_Vge_si_Vge_e;
  double qb_acc_Vge_si_Ve_si;
  double qb_acc_Vge_si_Ve_di;
  double qb_acc_Vge_si_Vge_si;
  double qb_acc_Vge_si_Vdi_si;
  double qb_acc_Vge_si_Tempt_GND;
  double qb_acc_Ve_di_Vge_di;
  double qb_acc_Ve_di_Vge_e;
  double qb_acc_Ve_di_Ve_si;
  double qb_acc_Ve_di_Ve_di;
  double qb_acc_Ve_di_Vge_si;
  double qb_acc_Ve_di_Vdi_si;
  double qb_acc_Ve_di_Tempt_GND;
  double qb_acc_Ve_si_Vge_di;
  double qb_acc_Ve_si_Vge_e;
  double qb_acc_Ve_si_Ve_si;
  double qb_acc_Ve_si_Ve_di;
  double qb_acc_Ve_si_Vge_si;
  double qb_acc_Ve_si_Vdi_si;
  double qb_acc_Ve_si_Tempt_GND;
  double qb_acc_Vge_e_Vge_di;
  double qb_acc_Vge_e_Vge_e;
  double qb_acc_Vge_e_Ve_si;
  double qb_acc_Vge_e_Ve_di;
  double qb_acc_Vge_e_Vge_si;
  double qb_acc_Vge_e_Vdi_si;
  double qb_acc_Vge_e_Tempt_GND;
  double qb_acc_Vge_di_Vge_di;
  double qb_acc_Vge_di_Vge_e;
  double qb_acc_Vge_di_Ve_si;
  double qb_acc_Vge_di_Ve_di;
  double qb_acc_Vge_di_Vge_si;
  double qb_acc_Vge_di_Vdi_si;
  double qb_acc_Vge_di_Tempt_GND;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double CGDO_i;
#endif
#if defined(_DYNAMIC)
double CGSO_i;
#endif
double cox_acc;
#if defined(_DERIVATEFORDDX)
double cox_acc_Vge_e;
double cox_acc_Vdi_si;
double cox_acc_Ve_si;
double cox_acc_Ve_di;
double cox_acc_Vge_si;
double cox_acc_Tempt_GND;
#if defined(_DERIVATE2)
  double cox_acc_Tempt_GND_Vge_e;
  double cox_acc_Tempt_GND_Vdi_si;
  double cox_acc_Tempt_GND_Ve_si;
  double cox_acc_Tempt_GND_Ve_di;
  double cox_acc_Tempt_GND_Vge_si;
  double cox_acc_Tempt_GND_Tempt_GND;
  double cox_acc_Vge_si_Vge_e;
  double cox_acc_Vge_si_Vdi_si;
  double cox_acc_Vge_si_Ve_si;
  double cox_acc_Vge_si_Ve_di;
  double cox_acc_Vge_si_Vge_si;
  double cox_acc_Vge_si_Tempt_GND;
  double cox_acc_Ve_di_Vge_e;
  double cox_acc_Ve_di_Vdi_si;
  double cox_acc_Ve_di_Ve_si;
  double cox_acc_Ve_di_Ve_di;
  double cox_acc_Ve_di_Vge_si;
  double cox_acc_Ve_di_Tempt_GND;
  double cox_acc_Ve_si_Vge_e;
  double cox_acc_Ve_si_Vdi_si;
  double cox_acc_Ve_si_Ve_si;
  double cox_acc_Ve_si_Ve_di;
  double cox_acc_Ve_si_Vge_si;
  double cox_acc_Ve_si_Tempt_GND;
  double cox_acc_Vdi_si_Vge_e;
  double cox_acc_Vdi_si_Vdi_si;
  double cox_acc_Vdi_si_Ve_si;
  double cox_acc_Vdi_si_Ve_di;
  double cox_acc_Vdi_si_Vge_si;
  double cox_acc_Vdi_si_Tempt_GND;
  double cox_acc_Vge_e_Vge_e;
  double cox_acc_Vge_e_Vdi_si;
  double cox_acc_Vge_e_Ve_si;
  double cox_acc_Vge_e_Ve_di;
  double cox_acc_Vge_e_Vge_si;
  double cox_acc_Vge_e_Tempt_GND;
#endif
#endif
double igd;
#if defined(_DERIVATEFORDDX)
double igd_Tempt_GND;
double igd_Vge_si;
double igd_Vge_di;
double igd_Vge_e;
double igd_Ve_si;
double igd_Ve_di;
double igd_Vdi_si;
#if defined(_DERIVATE2)
  double igd_Vdi_si_Tempt_GND;
  double igd_Vdi_si_Vge_si;
  double igd_Vdi_si_Vge_di;
  double igd_Vdi_si_Vge_e;
  double igd_Vdi_si_Ve_si;
  double igd_Vdi_si_Ve_di;
  double igd_Vdi_si_Vdi_si;
  double igd_Ve_di_Tempt_GND;
  double igd_Ve_di_Vge_si;
  double igd_Ve_di_Vge_di;
  double igd_Ve_di_Vge_e;
  double igd_Ve_di_Ve_si;
  double igd_Ve_di_Ve_di;
  double igd_Ve_di_Vdi_si;
  double igd_Ve_si_Tempt_GND;
  double igd_Ve_si_Vge_si;
  double igd_Ve_si_Vge_di;
  double igd_Ve_si_Vge_e;
  double igd_Ve_si_Ve_si;
  double igd_Ve_si_Ve_di;
  double igd_Ve_si_Vdi_si;
  double igd_Vge_e_Tempt_GND;
  double igd_Vge_e_Vge_si;
  double igd_Vge_e_Vge_di;
  double igd_Vge_e_Vge_e;
  double igd_Vge_e_Ve_si;
  double igd_Vge_e_Ve_di;
  double igd_Vge_e_Vdi_si;
  double igd_Vge_di_Tempt_GND;
  double igd_Vge_di_Vge_si;
  double igd_Vge_di_Vge_di;
  double igd_Vge_di_Vge_e;
  double igd_Vge_di_Ve_si;
  double igd_Vge_di_Ve_di;
  double igd_Vge_di_Vdi_si;
  double igd_Vge_si_Tempt_GND;
  double igd_Vge_si_Vge_si;
  double igd_Vge_si_Vge_di;
  double igd_Vge_si_Vge_e;
  double igd_Vge_si_Ve_si;
  double igd_Vge_si_Ve_di;
  double igd_Vge_si_Vdi_si;
  double igd_Tempt_GND_Tempt_GND;
  double igd_Tempt_GND_Vge_si;
  double igd_Tempt_GND_Vge_di;
  double igd_Tempt_GND_Vge_e;
  double igd_Tempt_GND_Ve_si;
  double igd_Tempt_GND_Ve_di;
  double igd_Tempt_GND_Vdi_si;
#endif
#endif
double igs;
#if defined(_DERIVATEFORDDX)
double igs_Tempt_GND;
double igs_Vge_si;
double igs_Vge_di;
double igs_Vge_e;
double igs_Ve_si;
double igs_Ve_di;
double igs_Vdi_si;
#if defined(_DERIVATE2)
  double igs_Vdi_si_Tempt_GND;
  double igs_Vdi_si_Vge_si;
  double igs_Vdi_si_Vge_di;
  double igs_Vdi_si_Vge_e;
  double igs_Vdi_si_Ve_si;
  double igs_Vdi_si_Ve_di;
  double igs_Vdi_si_Vdi_si;
  double igs_Ve_di_Tempt_GND;
  double igs_Ve_di_Vge_si;
  double igs_Ve_di_Vge_di;
  double igs_Ve_di_Vge_e;
  double igs_Ve_di_Ve_si;
  double igs_Ve_di_Ve_di;
  double igs_Ve_di_Vdi_si;
  double igs_Ve_si_Tempt_GND;
  double igs_Ve_si_Vge_si;
  double igs_Ve_si_Vge_di;
  double igs_Ve_si_Vge_e;
  double igs_Ve_si_Ve_si;
  double igs_Ve_si_Ve_di;
  double igs_Ve_si_Vdi_si;
  double igs_Vge_e_Tempt_GND;
  double igs_Vge_e_Vge_si;
  double igs_Vge_e_Vge_di;
  double igs_Vge_e_Vge_e;
  double igs_Vge_e_Ve_si;
  double igs_Vge_e_Ve_di;
  double igs_Vge_e_Vdi_si;
  double igs_Vge_di_Tempt_GND;
  double igs_Vge_di_Vge_si;
  double igs_Vge_di_Vge_di;
  double igs_Vge_di_Vge_e;
  double igs_Vge_di_Ve_si;
  double igs_Vge_di_Ve_di;
  double igs_Vge_di_Vdi_si;
  double igs_Vge_si_Tempt_GND;
  double igs_Vge_si_Vge_si;
  double igs_Vge_si_Vge_di;
  double igs_Vge_si_Vge_e;
  double igs_Vge_si_Ve_si;
  double igs_Vge_si_Ve_di;
  double igs_Vge_si_Vdi_si;
  double igs_Tempt_GND_Tempt_GND;
  double igs_Tempt_GND_Vge_si;
  double igs_Tempt_GND_Vge_di;
  double igs_Tempt_GND_Vge_e;
  double igs_Tempt_GND_Ve_si;
  double igs_Tempt_GND_Ve_di;
  double igs_Tempt_GND_Vdi_si;
#endif
#endif
double igisl;
#if defined(_DERIVATEFORDDX)
double igisl_Vge_di;
double igisl_Vdi_d;
double igisl_Vsi_s;
double igisl_Vge_e;
double igisl_Vdi_si;
double igisl_Tempt_GND;
double igisl_Ve_si;
double igisl_Ve_di;
double igisl_Vge_si;
#if defined(_DERIVATE2)
  double igisl_Vge_si_Vge_di;
  double igisl_Vge_si_Vdi_d;
  double igisl_Vge_si_Vsi_s;
  double igisl_Vge_si_Vge_e;
  double igisl_Vge_si_Vdi_si;
  double igisl_Vge_si_Tempt_GND;
  double igisl_Vge_si_Ve_si;
  double igisl_Vge_si_Ve_di;
  double igisl_Vge_si_Vge_si;
  double igisl_Ve_di_Vge_di;
  double igisl_Ve_di_Vdi_d;
  double igisl_Ve_di_Vsi_s;
  double igisl_Ve_di_Vge_e;
  double igisl_Ve_di_Vdi_si;
  double igisl_Ve_di_Tempt_GND;
  double igisl_Ve_di_Ve_si;
  double igisl_Ve_di_Ve_di;
  double igisl_Ve_di_Vge_si;
  double igisl_Ve_si_Vge_di;
  double igisl_Ve_si_Vdi_d;
  double igisl_Ve_si_Vsi_s;
  double igisl_Ve_si_Vge_e;
  double igisl_Ve_si_Vdi_si;
  double igisl_Ve_si_Tempt_GND;
  double igisl_Ve_si_Ve_si;
  double igisl_Ve_si_Ve_di;
  double igisl_Ve_si_Vge_si;
  double igisl_Tempt_GND_Vge_di;
  double igisl_Tempt_GND_Vdi_d;
  double igisl_Tempt_GND_Vsi_s;
  double igisl_Tempt_GND_Vge_e;
  double igisl_Tempt_GND_Vdi_si;
  double igisl_Tempt_GND_Tempt_GND;
  double igisl_Tempt_GND_Ve_si;
  double igisl_Tempt_GND_Ve_di;
  double igisl_Tempt_GND_Vge_si;
  double igisl_Vdi_si_Vge_di;
  double igisl_Vdi_si_Vdi_d;
  double igisl_Vdi_si_Vsi_s;
  double igisl_Vdi_si_Vge_e;
  double igisl_Vdi_si_Vdi_si;
  double igisl_Vdi_si_Tempt_GND;
  double igisl_Vdi_si_Ve_si;
  double igisl_Vdi_si_Ve_di;
  double igisl_Vdi_si_Vge_si;
  double igisl_Vge_e_Vge_di;
  double igisl_Vge_e_Vdi_d;
  double igisl_Vge_e_Vsi_s;
  double igisl_Vge_e_Vge_e;
  double igisl_Vge_e_Vdi_si;
  double igisl_Vge_e_Tempt_GND;
  double igisl_Vge_e_Ve_si;
  double igisl_Vge_e_Ve_di;
  double igisl_Vge_e_Vge_si;
  double igisl_Vsi_s_Vge_di;
  double igisl_Vsi_s_Vdi_d;
  double igisl_Vsi_s_Vsi_s;
  double igisl_Vsi_s_Vge_e;
  double igisl_Vsi_s_Vdi_si;
  double igisl_Vsi_s_Tempt_GND;
  double igisl_Vsi_s_Ve_si;
  double igisl_Vsi_s_Ve_di;
  double igisl_Vsi_s_Vge_si;
  double igisl_Vdi_d_Vge_di;
  double igisl_Vdi_d_Vdi_d;
  double igisl_Vdi_d_Vsi_s;
  double igisl_Vdi_d_Vge_e;
  double igisl_Vdi_d_Vdi_si;
  double igisl_Vdi_d_Tempt_GND;
  double igisl_Vdi_d_Ve_si;
  double igisl_Vdi_d_Ve_di;
  double igisl_Vdi_d_Vge_si;
  double igisl_Vge_di_Vge_di;
  double igisl_Vge_di_Vdi_d;
  double igisl_Vge_di_Vsi_s;
  double igisl_Vge_di_Vge_e;
  double igisl_Vge_di_Vdi_si;
  double igisl_Vge_di_Tempt_GND;
  double igisl_Vge_di_Ve_si;
  double igisl_Vge_di_Ve_di;
  double igisl_Vge_di_Vge_si;
#endif
#endif
double igidl;
#if defined(_DERIVATEFORDDX)
double igidl_Vge_di;
double igidl_Vdi_d;
double igidl_Vsi_s;
double igidl_Vge_e;
double igidl_Vdi_si;
double igidl_Tempt_GND;
double igidl_Ve_si;
double igidl_Ve_di;
double igidl_Vge_si;
#if defined(_DERIVATE2)
  double igidl_Vge_si_Vge_di;
  double igidl_Vge_si_Vdi_d;
  double igidl_Vge_si_Vsi_s;
  double igidl_Vge_si_Vge_e;
  double igidl_Vge_si_Vdi_si;
  double igidl_Vge_si_Tempt_GND;
  double igidl_Vge_si_Ve_si;
  double igidl_Vge_si_Ve_di;
  double igidl_Vge_si_Vge_si;
  double igidl_Ve_di_Vge_di;
  double igidl_Ve_di_Vdi_d;
  double igidl_Ve_di_Vsi_s;
  double igidl_Ve_di_Vge_e;
  double igidl_Ve_di_Vdi_si;
  double igidl_Ve_di_Tempt_GND;
  double igidl_Ve_di_Ve_si;
  double igidl_Ve_di_Ve_di;
  double igidl_Ve_di_Vge_si;
  double igidl_Ve_si_Vge_di;
  double igidl_Ve_si_Vdi_d;
  double igidl_Ve_si_Vsi_s;
  double igidl_Ve_si_Vge_e;
  double igidl_Ve_si_Vdi_si;
  double igidl_Ve_si_Tempt_GND;
  double igidl_Ve_si_Ve_si;
  double igidl_Ve_si_Ve_di;
  double igidl_Ve_si_Vge_si;
  double igidl_Tempt_GND_Vge_di;
  double igidl_Tempt_GND_Vdi_d;
  double igidl_Tempt_GND_Vsi_s;
  double igidl_Tempt_GND_Vge_e;
  double igidl_Tempt_GND_Vdi_si;
  double igidl_Tempt_GND_Tempt_GND;
  double igidl_Tempt_GND_Ve_si;
  double igidl_Tempt_GND_Ve_di;
  double igidl_Tempt_GND_Vge_si;
  double igidl_Vdi_si_Vge_di;
  double igidl_Vdi_si_Vdi_d;
  double igidl_Vdi_si_Vsi_s;
  double igidl_Vdi_si_Vge_e;
  double igidl_Vdi_si_Vdi_si;
  double igidl_Vdi_si_Tempt_GND;
  double igidl_Vdi_si_Ve_si;
  double igidl_Vdi_si_Ve_di;
  double igidl_Vdi_si_Vge_si;
  double igidl_Vge_e_Vge_di;
  double igidl_Vge_e_Vdi_d;
  double igidl_Vge_e_Vsi_s;
  double igidl_Vge_e_Vge_e;
  double igidl_Vge_e_Vdi_si;
  double igidl_Vge_e_Tempt_GND;
  double igidl_Vge_e_Ve_si;
  double igidl_Vge_e_Ve_di;
  double igidl_Vge_e_Vge_si;
  double igidl_Vsi_s_Vge_di;
  double igidl_Vsi_s_Vdi_d;
  double igidl_Vsi_s_Vsi_s;
  double igidl_Vsi_s_Vge_e;
  double igidl_Vsi_s_Vdi_si;
  double igidl_Vsi_s_Tempt_GND;
  double igidl_Vsi_s_Ve_si;
  double igidl_Vsi_s_Ve_di;
  double igidl_Vsi_s_Vge_si;
  double igidl_Vdi_d_Vge_di;
  double igidl_Vdi_d_Vdi_d;
  double igidl_Vdi_d_Vsi_s;
  double igidl_Vdi_d_Vge_e;
  double igidl_Vdi_d_Vdi_si;
  double igidl_Vdi_d_Tempt_GND;
  double igidl_Vdi_d_Ve_si;
  double igidl_Vdi_d_Ve_di;
  double igidl_Vdi_d_Vge_si;
  double igidl_Vge_di_Vge_di;
  double igidl_Vge_di_Vdi_d;
  double igidl_Vge_di_Vsi_s;
  double igidl_Vge_di_Vge_e;
  double igidl_Vge_di_Vdi_si;
  double igidl_Vge_di_Tempt_GND;
  double igidl_Vge_di_Ve_si;
  double igidl_Vge_di_Ve_di;
  double igidl_Vge_di_Vge_si;
#endif
#endif
double igcd;
#if defined(_DERIVATEFORDDX)
double igcd_Vge_di;
double igcd_Vge_e;
double igcd_Vdi_si;
double igcd_Ve_si;
double igcd_Ve_di;
double igcd_Vge_si;
double igcd_Tempt_GND;
double igcd_Vdi_d;
double igcd_Vsi_s;
#if defined(_DERIVATE2)
  double igcd_Vsi_s_Vge_di;
  double igcd_Vsi_s_Vge_e;
  double igcd_Vsi_s_Vdi_si;
  double igcd_Vsi_s_Ve_si;
  double igcd_Vsi_s_Ve_di;
  double igcd_Vsi_s_Vge_si;
  double igcd_Vsi_s_Tempt_GND;
  double igcd_Vsi_s_Vdi_d;
  double igcd_Vsi_s_Vsi_s;
  double igcd_Vdi_d_Vge_di;
  double igcd_Vdi_d_Vge_e;
  double igcd_Vdi_d_Vdi_si;
  double igcd_Vdi_d_Ve_si;
  double igcd_Vdi_d_Ve_di;
  double igcd_Vdi_d_Vge_si;
  double igcd_Vdi_d_Tempt_GND;
  double igcd_Vdi_d_Vdi_d;
  double igcd_Vdi_d_Vsi_s;
  double igcd_Tempt_GND_Vge_di;
  double igcd_Tempt_GND_Vge_e;
  double igcd_Tempt_GND_Vdi_si;
  double igcd_Tempt_GND_Ve_si;
  double igcd_Tempt_GND_Ve_di;
  double igcd_Tempt_GND_Vge_si;
  double igcd_Tempt_GND_Tempt_GND;
  double igcd_Tempt_GND_Vdi_d;
  double igcd_Tempt_GND_Vsi_s;
  double igcd_Vge_si_Vge_di;
  double igcd_Vge_si_Vge_e;
  double igcd_Vge_si_Vdi_si;
  double igcd_Vge_si_Ve_si;
  double igcd_Vge_si_Ve_di;
  double igcd_Vge_si_Vge_si;
  double igcd_Vge_si_Tempt_GND;
  double igcd_Vge_si_Vdi_d;
  double igcd_Vge_si_Vsi_s;
  double igcd_Ve_di_Vge_di;
  double igcd_Ve_di_Vge_e;
  double igcd_Ve_di_Vdi_si;
  double igcd_Ve_di_Ve_si;
  double igcd_Ve_di_Ve_di;
  double igcd_Ve_di_Vge_si;
  double igcd_Ve_di_Tempt_GND;
  double igcd_Ve_di_Vdi_d;
  double igcd_Ve_di_Vsi_s;
  double igcd_Ve_si_Vge_di;
  double igcd_Ve_si_Vge_e;
  double igcd_Ve_si_Vdi_si;
  double igcd_Ve_si_Ve_si;
  double igcd_Ve_si_Ve_di;
  double igcd_Ve_si_Vge_si;
  double igcd_Ve_si_Tempt_GND;
  double igcd_Ve_si_Vdi_d;
  double igcd_Ve_si_Vsi_s;
  double igcd_Vdi_si_Vge_di;
  double igcd_Vdi_si_Vge_e;
  double igcd_Vdi_si_Vdi_si;
  double igcd_Vdi_si_Ve_si;
  double igcd_Vdi_si_Ve_di;
  double igcd_Vdi_si_Vge_si;
  double igcd_Vdi_si_Tempt_GND;
  double igcd_Vdi_si_Vdi_d;
  double igcd_Vdi_si_Vsi_s;
  double igcd_Vge_e_Vge_di;
  double igcd_Vge_e_Vge_e;
  double igcd_Vge_e_Vdi_si;
  double igcd_Vge_e_Ve_si;
  double igcd_Vge_e_Ve_di;
  double igcd_Vge_e_Vge_si;
  double igcd_Vge_e_Tempt_GND;
  double igcd_Vge_e_Vdi_d;
  double igcd_Vge_e_Vsi_s;
  double igcd_Vge_di_Vge_di;
  double igcd_Vge_di_Vge_e;
  double igcd_Vge_di_Vdi_si;
  double igcd_Vge_di_Ve_si;
  double igcd_Vge_di_Ve_di;
  double igcd_Vge_di_Vge_si;
  double igcd_Vge_di_Tempt_GND;
  double igcd_Vge_di_Vdi_d;
  double igcd_Vge_di_Vsi_s;
#endif
#endif
double igcs;
#if defined(_DERIVATEFORDDX)
double igcs_Vge_di;
double igcs_Vge_e;
double igcs_Vdi_si;
double igcs_Ve_si;
double igcs_Ve_di;
double igcs_Vge_si;
double igcs_Tempt_GND;
double igcs_Vdi_d;
double igcs_Vsi_s;
#if defined(_DERIVATE2)
  double igcs_Vsi_s_Vge_di;
  double igcs_Vsi_s_Vge_e;
  double igcs_Vsi_s_Vdi_si;
  double igcs_Vsi_s_Ve_si;
  double igcs_Vsi_s_Ve_di;
  double igcs_Vsi_s_Vge_si;
  double igcs_Vsi_s_Tempt_GND;
  double igcs_Vsi_s_Vdi_d;
  double igcs_Vsi_s_Vsi_s;
  double igcs_Vdi_d_Vge_di;
  double igcs_Vdi_d_Vge_e;
  double igcs_Vdi_d_Vdi_si;
  double igcs_Vdi_d_Ve_si;
  double igcs_Vdi_d_Ve_di;
  double igcs_Vdi_d_Vge_si;
  double igcs_Vdi_d_Tempt_GND;
  double igcs_Vdi_d_Vdi_d;
  double igcs_Vdi_d_Vsi_s;
  double igcs_Tempt_GND_Vge_di;
  double igcs_Tempt_GND_Vge_e;
  double igcs_Tempt_GND_Vdi_si;
  double igcs_Tempt_GND_Ve_si;
  double igcs_Tempt_GND_Ve_di;
  double igcs_Tempt_GND_Vge_si;
  double igcs_Tempt_GND_Tempt_GND;
  double igcs_Tempt_GND_Vdi_d;
  double igcs_Tempt_GND_Vsi_s;
  double igcs_Vge_si_Vge_di;
  double igcs_Vge_si_Vge_e;
  double igcs_Vge_si_Vdi_si;
  double igcs_Vge_si_Ve_si;
  double igcs_Vge_si_Ve_di;
  double igcs_Vge_si_Vge_si;
  double igcs_Vge_si_Tempt_GND;
  double igcs_Vge_si_Vdi_d;
  double igcs_Vge_si_Vsi_s;
  double igcs_Ve_di_Vge_di;
  double igcs_Ve_di_Vge_e;
  double igcs_Ve_di_Vdi_si;
  double igcs_Ve_di_Ve_si;
  double igcs_Ve_di_Ve_di;
  double igcs_Ve_di_Vge_si;
  double igcs_Ve_di_Tempt_GND;
  double igcs_Ve_di_Vdi_d;
  double igcs_Ve_di_Vsi_s;
  double igcs_Ve_si_Vge_di;
  double igcs_Ve_si_Vge_e;
  double igcs_Ve_si_Vdi_si;
  double igcs_Ve_si_Ve_si;
  double igcs_Ve_si_Ve_di;
  double igcs_Ve_si_Vge_si;
  double igcs_Ve_si_Tempt_GND;
  double igcs_Ve_si_Vdi_d;
  double igcs_Ve_si_Vsi_s;
  double igcs_Vdi_si_Vge_di;
  double igcs_Vdi_si_Vge_e;
  double igcs_Vdi_si_Vdi_si;
  double igcs_Vdi_si_Ve_si;
  double igcs_Vdi_si_Ve_di;
  double igcs_Vdi_si_Vge_si;
  double igcs_Vdi_si_Tempt_GND;
  double igcs_Vdi_si_Vdi_d;
  double igcs_Vdi_si_Vsi_s;
  double igcs_Vge_e_Vge_di;
  double igcs_Vge_e_Vge_e;
  double igcs_Vge_e_Vdi_si;
  double igcs_Vge_e_Ve_si;
  double igcs_Vge_e_Ve_di;
  double igcs_Vge_e_Vge_si;
  double igcs_Vge_e_Tempt_GND;
  double igcs_Vge_e_Vdi_d;
  double igcs_Vge_e_Vsi_s;
  double igcs_Vge_di_Vge_di;
  double igcs_Vge_di_Vge_e;
  double igcs_Vge_di_Vdi_si;
  double igcs_Vge_di_Ve_si;
  double igcs_Vge_di_Ve_di;
  double igcs_Vge_di_Vge_si;
  double igcs_Vge_di_Tempt_GND;
  double igcs_Vge_di_Vdi_d;
  double igcs_Vge_di_Vsi_s;
#endif
#endif
double igbacc;
#if defined(_DERIVATE)
double igbacc_Vge_e;
double igbacc_Vdi_si;
double igbacc_Tempt_GND;
double igbacc_Ve_si;
double igbacc_Ve_di;
double igbacc_Vge_si;
double igbacc_Vge_di;
double igbacc_Vdi_d;
double igbacc_Vsi_s;
#endif
double igbd;
#if defined(_DERIVATE)
double igbd_Vge_e;
double igbd_Vdi_si;
double igbd_Tempt_GND;
double igbd_Ve_si;
double igbd_Ve_di;
double igbd_Vge_si;
double igbd_Vge_di;
double igbd_Vdi_d;
double igbd_Vsi_s;
#endif
double igbs;
#if defined(_DERIVATE)
double igbs_Vge_e;
double igbs_Vdi_si;
double igbs_Tempt_GND;
double igbs_Ve_si;
double igbs_Ve_di;
double igbs_Vge_si;
double igbs_Vge_di;
double igbs_Vdi_d;
double igbs_Vsi_s;
#endif
double igbinv;
#if defined(_DERIVATE)
double igbinv_Vge_e;
double igbinv_Vdi_si;
double igbinv_Tempt_GND;
double igbinv_Ve_si;
double igbinv_Ve_di;
double igbinv_Vge_si;
double igbinv_Vge_di;
double igbinv_Vdi_d;
double igbinv_Vsi_s;
#endif
#if defined(_DYNAMIC)
double Cfr_geo;
#endif
double Rsource;
#if defined(_DERIVATE)
double Rsource_Tempt_GND;
double Rsource_Vsi_s;
double Rsource_Vge_e;
double Rsource_Vdi_si;
double Rsource_Ve_si;
double Rsource_Ve_di;
double Rsource_Vge_si;
#endif
double Rdrain;
#if defined(_DERIVATE)
double Rdrain_Tempt_GND;
double Rdrain_Vdi_d;
double Rdrain_Vsi_s;
double Rdrain_Vge_e;
double Rdrain_Vdi_si;
double Rdrain_Ve_si;
double Rdrain_Ve_di;
double Rdrain_Vge_si;
double Rdrain_Vge_di;
#endif
double MTcen;
double Tcen;
#if defined(_DERIVATEFORDDX)
double Tcen_Vge_e;
double Tcen_Vdi_si;
double Tcen_Ve_si;
double Tcen_Ve_di;
double Tcen_Vge_si;
double Tcen_Tempt_GND;
#if defined(_DERIVATE2)
  double Tcen_Tempt_GND_Vge_e;
  double Tcen_Tempt_GND_Vdi_si;
  double Tcen_Tempt_GND_Ve_si;
  double Tcen_Tempt_GND_Ve_di;
  double Tcen_Tempt_GND_Vge_si;
  double Tcen_Tempt_GND_Tempt_GND;
  double Tcen_Vge_si_Vge_e;
  double Tcen_Vge_si_Vdi_si;
  double Tcen_Vge_si_Ve_si;
  double Tcen_Vge_si_Ve_di;
  double Tcen_Vge_si_Vge_si;
  double Tcen_Vge_si_Tempt_GND;
  double Tcen_Ve_di_Vge_e;
  double Tcen_Ve_di_Vdi_si;
  double Tcen_Ve_di_Ve_si;
  double Tcen_Ve_di_Ve_di;
  double Tcen_Ve_di_Vge_si;
  double Tcen_Ve_di_Tempt_GND;
  double Tcen_Ve_si_Vge_e;
  double Tcen_Ve_si_Vdi_si;
  double Tcen_Ve_si_Ve_si;
  double Tcen_Ve_si_Ve_di;
  double Tcen_Ve_si_Vge_si;
  double Tcen_Ve_si_Tempt_GND;
  double Tcen_Vdi_si_Vge_e;
  double Tcen_Vdi_si_Vdi_si;
  double Tcen_Vdi_si_Ve_si;
  double Tcen_Vdi_si_Ve_di;
  double Tcen_Vdi_si_Vge_si;
  double Tcen_Vdi_si_Tempt_GND;
  double Tcen_Vge_e_Vge_e;
  double Tcen_Vge_e_Vdi_si;
  double Tcen_Vge_e_Ve_si;
  double Tcen_Vge_e_Ve_di;
  double Tcen_Vge_e_Vge_si;
  double Tcen_Vge_e_Tempt_GND;
#endif
#endif
double q0;
#if defined(_DERIVATEFORDDX)
double q0_Tempt_GND;
double q0_Vdi_si;
#if defined(_DERIVATE2)
  double q0_Vdi_si_Tempt_GND;
  double q0_Vdi_si_Vdi_si;
  double q0_Tempt_GND_Tempt_GND;
  double q0_Tempt_GND_Vdi_si;
#endif
#endif
double idsgen;
#if defined(_DERIVATE)
double idsgen_Tempt_GND;
double idsgen_Vge_di;
double idsgen_Vge_e;
double idsgen_Ve_si;
double idsgen_Ve_di;
double idsgen_Vge_si;
double idsgen_Vdi_si;
#endif
double XExpBVD;
#if defined(_DERIVATEFORDDX)
double XExpBVD_Tempt_GND;
#if defined(_DERIVATE2)
  double XExpBVD_Tempt_GND_Tempt_GND;
#endif
#endif
double XExpBVS;
#if defined(_DERIVATEFORDDX)
double XExpBVS_Tempt_GND;
#if defined(_DERIVATE2)
  double XExpBVS_Tempt_GND_Tempt_GND;
#endif
#endif
double VjdmFwd;
#if defined(_DERIVATEFORDDX)
double VjdmFwd_Tempt_GND;
#if defined(_DERIVATE2)
  double VjdmFwd_Tempt_GND_Tempt_GND;
#endif
#endif
double IVjdmFwd;
#if defined(_DERIVATE)
double IVjdmFwd_Tempt_GND;
#endif
double DslpFwd;
#if defined(_DERIVATE)
double DslpFwd_Tempt_GND;
#endif
double VjdmRev;
#if defined(_DERIVATEFORDDX)
double VjdmRev_Tempt_GND;
#if defined(_DERIVATE2)
  double VjdmRev_Tempt_GND_Tempt_GND;
#endif
#endif
double IVjdmRev;
#if defined(_DERIVATEFORDDX)
double IVjdmRev_Tempt_GND;
#if defined(_DERIVATE2)
  double IVjdmRev_Tempt_GND_Tempt_GND;
#endif
#endif
double DslpRev;
#if defined(_DERIVATEFORDDX)
double DslpRev_Tempt_GND;
#if defined(_DERIVATE2)
  double DslpRev_Tempt_GND_Tempt_GND;
#endif
#endif
double VjsmFwd;
#if defined(_DERIVATEFORDDX)
double VjsmFwd_Tempt_GND;
#if defined(_DERIVATE2)
  double VjsmFwd_Tempt_GND_Tempt_GND;
#endif
#endif
double IVjsmFwd;
#if defined(_DERIVATE)
double IVjsmFwd_Tempt_GND;
#endif
double SslpFwd;
#if defined(_DERIVATE)
double SslpFwd_Tempt_GND;
#endif
double VjsmRev;
#if defined(_DERIVATEFORDDX)
double VjsmRev_Tempt_GND;
#if defined(_DERIVATE2)
  double VjsmRev_Tempt_GND_Tempt_GND;
#endif
#endif
double IVjsmRev;
#if defined(_DERIVATEFORDDX)
double IVjsmRev_Tempt_GND;
#if defined(_DERIVATE2)
  double IVjsmRev_Tempt_GND_Tempt_GND;
#endif
#endif
double SslpRev;
#if defined(_DERIVATEFORDDX)
double SslpRev_Tempt_GND;
#if defined(_DERIVATE2)
  double SslpRev_Tempt_GND_Tempt_GND;
#endif
#endif
double Nvtmd;
#if defined(_DERIVATEFORDDX)
double Nvtmd_Tempt_GND;
#if defined(_DERIVATE2)
  double Nvtmd_Tempt_GND_Tempt_GND;
#endif
#endif
double Nvtms;
#if defined(_DERIVATEFORDDX)
double Nvtms_Tempt_GND;
#if defined(_DERIVATE2)
  double Nvtms_Tempt_GND_Tempt_GND;
#endif
#endif
double Isbd;
#if defined(_DERIVATEFORDDX)
double Isbd_Tempt_GND;
#if defined(_DERIVATE2)
  double Isbd_Tempt_GND_Tempt_GND;
#endif
#endif
double Isbs;
#if defined(_DERIVATEFORDDX)
double Isbs_Tempt_GND;
#if defined(_DERIVATE2)
  double Isbs_Tempt_GND_Tempt_GND;
#endif
#endif
#if defined(_DYNAMIC)
double Qeg;
#if defined(_DERIVATEFORDDX)
double Qeg_Vge_di;
double Qeg_Vge_e;
double Qeg_Vdi_si;
double Qeg_Ve_si;
double Qeg_Ve_di;
double Qeg_Vge_si;
double Qeg_Tempt_GND;
double Qeg_Ve_ge;
#if defined(_DERIVATE2)
  double Qeg_Ve_ge_Vge_di;
  double Qeg_Ve_ge_Vge_e;
  double Qeg_Ve_ge_Vdi_si;
  double Qeg_Ve_ge_Ve_si;
  double Qeg_Ve_ge_Ve_di;
  double Qeg_Ve_ge_Vge_si;
  double Qeg_Ve_ge_Tempt_GND;
  double Qeg_Ve_ge_Ve_ge;
  double Qeg_Tempt_GND_Vge_di;
  double Qeg_Tempt_GND_Vge_e;
  double Qeg_Tempt_GND_Vdi_si;
  double Qeg_Tempt_GND_Ve_si;
  double Qeg_Tempt_GND_Ve_di;
  double Qeg_Tempt_GND_Vge_si;
  double Qeg_Tempt_GND_Tempt_GND;
  double Qeg_Tempt_GND_Ve_ge;
  double Qeg_Vge_si_Vge_di;
  double Qeg_Vge_si_Vge_e;
  double Qeg_Vge_si_Vdi_si;
  double Qeg_Vge_si_Ve_si;
  double Qeg_Vge_si_Ve_di;
  double Qeg_Vge_si_Vge_si;
  double Qeg_Vge_si_Tempt_GND;
  double Qeg_Vge_si_Ve_ge;
  double Qeg_Ve_di_Vge_di;
  double Qeg_Ve_di_Vge_e;
  double Qeg_Ve_di_Vdi_si;
  double Qeg_Ve_di_Ve_si;
  double Qeg_Ve_di_Ve_di;
  double Qeg_Ve_di_Vge_si;
  double Qeg_Ve_di_Tempt_GND;
  double Qeg_Ve_di_Ve_ge;
  double Qeg_Ve_si_Vge_di;
  double Qeg_Ve_si_Vge_e;
  double Qeg_Ve_si_Vdi_si;
  double Qeg_Ve_si_Ve_si;
  double Qeg_Ve_si_Ve_di;
  double Qeg_Ve_si_Vge_si;
  double Qeg_Ve_si_Tempt_GND;
  double Qeg_Ve_si_Ve_ge;
  double Qeg_Vdi_si_Vge_di;
  double Qeg_Vdi_si_Vge_e;
  double Qeg_Vdi_si_Vdi_si;
  double Qeg_Vdi_si_Ve_si;
  double Qeg_Vdi_si_Ve_di;
  double Qeg_Vdi_si_Vge_si;
  double Qeg_Vdi_si_Tempt_GND;
  double Qeg_Vdi_si_Ve_ge;
  double Qeg_Vge_e_Vge_di;
  double Qeg_Vge_e_Vge_e;
  double Qeg_Vge_e_Vdi_si;
  double Qeg_Vge_e_Ve_si;
  double Qeg_Vge_e_Ve_di;
  double Qeg_Vge_e_Vge_si;
  double Qeg_Vge_e_Tempt_GND;
  double Qeg_Vge_e_Ve_ge;
  double Qeg_Vge_di_Vge_di;
  double Qeg_Vge_di_Vge_e;
  double Qeg_Vge_di_Vdi_si;
  double Qeg_Vge_di_Ve_si;
  double Qeg_Vge_di_Ve_di;
  double Qeg_Vge_di_Vge_si;
  double Qeg_Vge_di_Tempt_GND;
  double Qeg_Vge_di_Ve_ge;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qed;
#if defined(_DERIVATEFORDDX)
double Qed_Vdi_d;
double Qed_Vsi_s;
double Qed_Tempt_GND;
double Qed_Vge_di;
double Qed_Vge_e;
double Qed_Ve_si;
double Qed_Ve_di;
double Qed_Vge_si;
double Qed_Vdi_si;
#if defined(_DERIVATE2)
  double Qed_Vdi_si_Vdi_d;
  double Qed_Vdi_si_Vsi_s;
  double Qed_Vdi_si_Tempt_GND;
  double Qed_Vdi_si_Vge_di;
  double Qed_Vdi_si_Vge_e;
  double Qed_Vdi_si_Ve_si;
  double Qed_Vdi_si_Ve_di;
  double Qed_Vdi_si_Vge_si;
  double Qed_Vdi_si_Vdi_si;
  double Qed_Vge_si_Vdi_d;
  double Qed_Vge_si_Vsi_s;
  double Qed_Vge_si_Tempt_GND;
  double Qed_Vge_si_Vge_di;
  double Qed_Vge_si_Vge_e;
  double Qed_Vge_si_Ve_si;
  double Qed_Vge_si_Ve_di;
  double Qed_Vge_si_Vge_si;
  double Qed_Vge_si_Vdi_si;
  double Qed_Ve_di_Vdi_d;
  double Qed_Ve_di_Vsi_s;
  double Qed_Ve_di_Tempt_GND;
  double Qed_Ve_di_Vge_di;
  double Qed_Ve_di_Vge_e;
  double Qed_Ve_di_Ve_si;
  double Qed_Ve_di_Ve_di;
  double Qed_Ve_di_Vge_si;
  double Qed_Ve_di_Vdi_si;
  double Qed_Ve_si_Vdi_d;
  double Qed_Ve_si_Vsi_s;
  double Qed_Ve_si_Tempt_GND;
  double Qed_Ve_si_Vge_di;
  double Qed_Ve_si_Vge_e;
  double Qed_Ve_si_Ve_si;
  double Qed_Ve_si_Ve_di;
  double Qed_Ve_si_Vge_si;
  double Qed_Ve_si_Vdi_si;
  double Qed_Vge_e_Vdi_d;
  double Qed_Vge_e_Vsi_s;
  double Qed_Vge_e_Tempt_GND;
  double Qed_Vge_e_Vge_di;
  double Qed_Vge_e_Vge_e;
  double Qed_Vge_e_Ve_si;
  double Qed_Vge_e_Ve_di;
  double Qed_Vge_e_Vge_si;
  double Qed_Vge_e_Vdi_si;
  double Qed_Vge_di_Vdi_d;
  double Qed_Vge_di_Vsi_s;
  double Qed_Vge_di_Tempt_GND;
  double Qed_Vge_di_Vge_di;
  double Qed_Vge_di_Vge_e;
  double Qed_Vge_di_Ve_si;
  double Qed_Vge_di_Ve_di;
  double Qed_Vge_di_Vge_si;
  double Qed_Vge_di_Vdi_si;
  double Qed_Tempt_GND_Vdi_d;
  double Qed_Tempt_GND_Vsi_s;
  double Qed_Tempt_GND_Tempt_GND;
  double Qed_Tempt_GND_Vge_di;
  double Qed_Tempt_GND_Vge_e;
  double Qed_Tempt_GND_Ve_si;
  double Qed_Tempt_GND_Ve_di;
  double Qed_Tempt_GND_Vge_si;
  double Qed_Tempt_GND_Vdi_si;
  double Qed_Vsi_s_Vdi_d;
  double Qed_Vsi_s_Vsi_s;
  double Qed_Vsi_s_Tempt_GND;
  double Qed_Vsi_s_Vge_di;
  double Qed_Vsi_s_Vge_e;
  double Qed_Vsi_s_Ve_si;
  double Qed_Vsi_s_Ve_di;
  double Qed_Vsi_s_Vge_si;
  double Qed_Vsi_s_Vdi_si;
  double Qed_Vdi_d_Vdi_d;
  double Qed_Vdi_d_Vsi_s;
  double Qed_Vdi_d_Tempt_GND;
  double Qed_Vdi_d_Vge_di;
  double Qed_Vdi_d_Vge_e;
  double Qed_Vdi_d_Ve_si;
  double Qed_Vdi_d_Ve_di;
  double Qed_Vdi_d_Vge_si;
  double Qed_Vdi_d_Vdi_si;
#endif
#endif
#endif
#if defined(_DYNAMIC)
double Qes;
#if defined(_DERIVATEFORDDX)
double Qes_Vdi_d;
double Qes_Vsi_s;
double Qes_Tempt_GND;
double Qes_Vge_di;
double Qes_Vge_e;
double Qes_Ve_si;
double Qes_Ve_di;
double Qes_Vge_si;
double Qes_Vdi_si;
#if defined(_DERIVATE2)
  double Qes_Vdi_si_Vdi_d;
  double Qes_Vdi_si_Vsi_s;
  double Qes_Vdi_si_Tempt_GND;
  double Qes_Vdi_si_Vge_di;
  double Qes_Vdi_si_Vge_e;
  double Qes_Vdi_si_Ve_si;
  double Qes_Vdi_si_Ve_di;
  double Qes_Vdi_si_Vge_si;
  double Qes_Vdi_si_Vdi_si;
  double Qes_Vge_si_Vdi_d;
  double Qes_Vge_si_Vsi_s;
  double Qes_Vge_si_Tempt_GND;
  double Qes_Vge_si_Vge_di;
  double Qes_Vge_si_Vge_e;
  double Qes_Vge_si_Ve_si;
  double Qes_Vge_si_Ve_di;
  double Qes_Vge_si_Vge_si;
  double Qes_Vge_si_Vdi_si;
  double Qes_Ve_di_Vdi_d;
  double Qes_Ve_di_Vsi_s;
  double Qes_Ve_di_Tempt_GND;
  double Qes_Ve_di_Vge_di;
  double Qes_Ve_di_Vge_e;
  double Qes_Ve_di_Ve_si;
  double Qes_Ve_di_Ve_di;
  double Qes_Ve_di_Vge_si;
  double Qes_Ve_di_Vdi_si;
  double Qes_Ve_si_Vdi_d;
  double Qes_Ve_si_Vsi_s;
  double Qes_Ve_si_Tempt_GND;
  double Qes_Ve_si_Vge_di;
  double Qes_Ve_si_Vge_e;
  double Qes_Ve_si_Ve_si;
  double Qes_Ve_si_Ve_di;
  double Qes_Ve_si_Vge_si;
  double Qes_Ve_si_Vdi_si;
  double Qes_Vge_e_Vdi_d;
  double Qes_Vge_e_Vsi_s;
  double Qes_Vge_e_Tempt_GND;
  double Qes_Vge_e_Vge_di;
  double Qes_Vge_e_Vge_e;
  double Qes_Vge_e_Ve_si;
  double Qes_Vge_e_Ve_di;
  double Qes_Vge_e_Vge_si;
  double Qes_Vge_e_Vdi_si;
  double Qes_Vge_di_Vdi_d;
  double Qes_Vge_di_Vsi_s;
  double Qes_Vge_di_Tempt_GND;
  double Qes_Vge_di_Vge_di;
  double Qes_Vge_di_Vge_e;
  double Qes_Vge_di_Ve_si;
  double Qes_Vge_di_Ve_di;
  double Qes_Vge_di_Vge_si;
  double Qes_Vge_di_Vdi_si;
  double Qes_Tempt_GND_Vdi_d;
  double Qes_Tempt_GND_Vsi_s;
  double Qes_Tempt_GND_Tempt_GND;
  double Qes_Tempt_GND_Vge_di;
  double Qes_Tempt_GND_Vge_e;
  double Qes_Tempt_GND_Ve_si;
  double Qes_Tempt_GND_Ve_di;
  double Qes_Tempt_GND_Vge_si;
  double Qes_Tempt_GND_Vdi_si;
  double Qes_Vsi_s_Vdi_d;
  double Qes_Vsi_s_Vsi_s;
  double Qes_Vsi_s_Tempt_GND;
  double Qes_Vsi_s_Vge_di;
  double Qes_Vsi_s_Vge_e;
  double Qes_Vsi_s_Ve_si;
  double Qes_Vsi_s_Ve_di;
  double Qes_Vsi_s_Vge_si;
  double Qes_Vsi_s_Vdi_si;
  double Qes_Vdi_d_Vdi_d;
  double Qes_Vdi_d_Vsi_s;
  double Qes_Vdi_d_Tempt_GND;
  double Qes_Vdi_d_Vge_di;
  double Qes_Vdi_d_Vge_e;
  double Qes_Vdi_d_Ve_si;
  double Qes_Vdi_d_Ve_di;
  double Qes_Vdi_d_Vge_si;
  double Qes_Vdi_d_Vdi_si;
#endif
#endif
#endif
double Czbdswg;
#if defined(_DERIVATEFORDDX)
double Czbdswg_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbdswg_Tempt_GND_Tempt_GND;
#endif
#endif
double Czbdsw;
#if defined(_DERIVATEFORDDX)
double Czbdsw_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbdsw_Tempt_GND_Tempt_GND;
#endif
#endif
double Czbd;
#if defined(_DERIVATEFORDDX)
double Czbd_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbd_Tempt_GND_Tempt_GND;
#endif
#endif
double Czbsswg;
#if defined(_DERIVATEFORDDX)
double Czbsswg_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbsswg_Tempt_GND_Tempt_GND;
#endif
#endif
double Czbssw;
#if defined(_DERIVATEFORDDX)
double Czbssw_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbssw_Tempt_GND_Tempt_GND;
#endif
#endif
double Czbs;
#if defined(_DERIVATEFORDDX)
double Czbs_Tempt_GND;
#if defined(_DERIVATE2)
  double Czbs_Tempt_GND_Tempt_GND;
#endif
#endif
double Ied;
#if defined(_DERIVATE)
double Ied_Vge_di;
double Ied_Vge_e;
double Ied_Ve_si;
double Ied_Ve_di;
double Ied_Vge_si;
double Ied_Vdi_si;
double Ied_Tempt_GND;
#endif
double Ies;
#if defined(_DERIVATE)
double Ies_Vge_di;
double Ies_Vge_e;
double Ies_Ve_si;
double Ies_Ve_di;
double Ies_Vge_si;
double Ies_Vdi_si;
double Ies_Tempt_GND;
#endif
double NJTSSWGD_t;
#if defined(_DERIVATEFORDDX)
double NJTSSWGD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTSSWGD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double NJTSSWD_t;
#if defined(_DERIVATEFORDDX)
double NJTSSWD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTSSWD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double NJTSD_t;
#if defined(_DERIVATEFORDDX)
double NJTSD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTSD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double NJTSSWG_t;
#if defined(_DERIVATEFORDDX)
double NJTSSWG_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTSSWG_t_Tempt_GND_Tempt_GND;
#endif
#endif
double NJTSSW_t;
#if defined(_DERIVATEFORDDX)
double NJTSSW_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTSSW_t_Tempt_GND_Tempt_GND;
#endif
#endif
double NJTS_t;
#if defined(_DERIVATEFORDDX)
double NJTS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double NJTS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JTSSWGD_t;
#if defined(_DERIVATE)
double JTSSWGD_t_Tempt_GND;
#endif
double JTSSWD_t;
#if defined(_DERIVATE)
double JTSSWD_t_Tempt_GND;
#endif
double JTSD_t;
#if defined(_DERIVATE)
double JTSD_t_Tempt_GND;
#endif
double JTSSWGS_t;
#if defined(_DERIVATE)
double JTSSWGS_t_Tempt_GND;
#endif
double JTSSWS_t;
#if defined(_DERIVATE)
double JTSSWS_t_Tempt_GND;
#endif
double JTSS_t;
#if defined(_DERIVATE)
double JTSS_t_Tempt_GND;
#endif
double JSWGD_t;
#if defined(_DERIVATEFORDDX)
double JSWGD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSWGD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JSWD_t;
#if defined(_DERIVATEFORDDX)
double JSWD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSWD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JSD_t;
#if defined(_DERIVATEFORDDX)
double JSD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JSWGS_t;
#if defined(_DERIVATEFORDDX)
double JSWGS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSWGS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JSWS_t;
#if defined(_DERIVATEFORDDX)
double JSWS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSWS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double JSS_t;
#if defined(_DERIVATEFORDDX)
double JSS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double JSS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBSWGD_t;
#if defined(_DERIVATEFORDDX)
double PBSWGD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBSWGD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBSWD_t;
#if defined(_DERIVATEFORDDX)
double PBSWD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBSWD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBD_t;
#if defined(_DERIVATEFORDDX)
double PBD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBSWGS_t;
#if defined(_DERIVATEFORDDX)
double PBSWGS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBSWGS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBSWS_t;
#if defined(_DERIVATEFORDDX)
double PBSWS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBSWS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double PBS_t;
#if defined(_DERIVATEFORDDX)
double PBS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double PBS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJSWGD_t;
#if defined(_DERIVATEFORDDX)
double CJSWGD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJSWGD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJSWD_t;
#if defined(_DERIVATEFORDDX)
double CJSWD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJSWD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJD_t;
#if defined(_DERIVATEFORDDX)
double CJD_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJD_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJSWGS_t;
#if defined(_DERIVATEFORDDX)
double CJSWGS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJSWGS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJSWS_t;
#if defined(_DERIVATEFORDDX)
double CJSWS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJSWS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double CJS_t;
#if defined(_DERIVATEFORDDX)
double CJS_t_Tempt_GND;
#if defined(_DERIVATE2)
  double CJS_t_Tempt_GND_Tempt_GND;
#endif
#endif
double WeffCV0;
double Weff0;
double qb;
#if defined(_DYNAMIC)
double qs;
#if defined(_DERIVATEFORDDX)
double qs_Vge_di;
double qs_Vdi_si;
double qs_Ve_si;
double qs_Ve_di;
double qs_Vge_si;
double qs_Tempt_GND;
double qs_Vge_e;
#if defined(_DERIVATE2)
  double qs_Vge_e_Vge_di;
  double qs_Vge_e_Vdi_si;
  double qs_Vge_e_Ve_si;
  double qs_Vge_e_Ve_di;
  double qs_Vge_e_Vge_si;
  double qs_Vge_e_Tempt_GND;
  double qs_Vge_e_Vge_e;
  double qs_Tempt_GND_Vge_di;
  double qs_Tempt_GND_Vdi_si;
  double qs_Tempt_GND_Ve_si;
  double qs_Tempt_GND_Ve_di;
  double qs_Tempt_GND_Vge_si;
  double qs_Tempt_GND_Tempt_GND;
  double qs_Tempt_GND_Vge_e;
  double qs_Vge_si_Vge_di;
  double qs_Vge_si_Vdi_si;
  double qs_Vge_si_Ve_si;
  double qs_Vge_si_Ve_di;
  double qs_Vge_si_Vge_si;
  double qs_Vge_si_Tempt_GND;
  double qs_Vge_si_Vge_e;
  double qs_Ve_di_Vge_di;
  double qs_Ve_di_Vdi_si;
  double qs_Ve_di_Ve_si;
  double qs_Ve_di_Ve_di;
  double qs_Ve_di_Vge_si;
  double qs_Ve_di_Tempt_GND;
  double qs_Ve_di_Vge_e;
  double qs_Ve_si_Vge_di;
  double qs_Ve_si_Vdi_si;
  double qs_Ve_si_Ve_si;
  double qs_Ve_si_Ve_di;
  double qs_Ve_si_Vge_si;
  double qs_Ve_si_Tempt_GND;
  double qs_Ve_si_Vge_e;
  double qs_Vdi_si_Vge_di;
  double qs_Vdi_si_Vdi_si;
  double qs_Vdi_si_Ve_si;
  double qs_Vdi_si_Ve_di;
  double qs_Vdi_si_Vge_si;
  double qs_Vdi_si_Tempt_GND;
  double qs_Vdi_si_Vge_e;
  double qs_Vge_di_Vge_di;
  double qs_Vge_di_Vdi_si;
  double qs_Vge_di_Ve_si;
  double qs_Vge_di_Ve_di;
  double qs_Vge_di_Vge_si;
  double qs_Vge_di_Tempt_GND;
  double qs_Vge_di_Vge_e;
#endif
#endif
#endif
double qg;
#if defined(_DERIVATEFORDDX)
double qg_Vdi_si;
double qg_Ve_si;
double qg_Ve_di;
double qg_Vge_si;
double qg_Tempt_GND;
double qg_Vge_e;
#if defined(_DERIVATE2)
  double qg_Vge_e_Vdi_si;
  double qg_Vge_e_Ve_si;
  double qg_Vge_e_Ve_di;
  double qg_Vge_e_Vge_si;
  double qg_Vge_e_Tempt_GND;
  double qg_Vge_e_Vge_e;
  double qg_Tempt_GND_Vdi_si;
  double qg_Tempt_GND_Ve_si;
  double qg_Tempt_GND_Ve_di;
  double qg_Tempt_GND_Vge_si;
  double qg_Tempt_GND_Tempt_GND;
  double qg_Tempt_GND_Vge_e;
  double qg_Vge_si_Vdi_si;
  double qg_Vge_si_Ve_si;
  double qg_Vge_si_Ve_di;
  double qg_Vge_si_Vge_si;
  double qg_Vge_si_Tempt_GND;
  double qg_Vge_si_Vge_e;
  double qg_Ve_di_Vdi_si;
  double qg_Ve_di_Ve_si;
  double qg_Ve_di_Ve_di;
  double qg_Ve_di_Vge_si;
  double qg_Ve_di_Tempt_GND;
  double qg_Ve_di_Vge_e;
  double qg_Ve_si_Vdi_si;
  double qg_Ve_si_Ve_si;
  double qg_Ve_si_Ve_di;
  double qg_Ve_si_Vge_si;
  double qg_Ve_si_Tempt_GND;
  double qg_Ve_si_Vge_e;
  double qg_Vdi_si_Vdi_si;
  double qg_Vdi_si_Ve_si;
  double qg_Vdi_si_Ve_di;
  double qg_Vdi_si_Vge_si;
  double qg_Vdi_si_Tempt_GND;
  double qg_Vdi_si_Vge_e;
#endif
#endif
double qd;
#if defined(_DERIVATEFORDDX)
double qd_Vdi_si;
double qd_Ve_si;
double qd_Ve_di;
double qd_Vge_si;
double qd_Tempt_GND;
double qd_Vge_e;
#if defined(_DERIVATE2)
  double qd_Vge_e_Vdi_si;
  double qd_Vge_e_Ve_si;
  double qd_Vge_e_Ve_di;
  double qd_Vge_e_Vge_si;
  double qd_Vge_e_Tempt_GND;
  double qd_Vge_e_Vge_e;
  double qd_Tempt_GND_Vdi_si;
  double qd_Tempt_GND_Ve_si;
  double qd_Tempt_GND_Ve_di;
  double qd_Tempt_GND_Vge_si;
  double qd_Tempt_GND_Tempt_GND;
  double qd_Tempt_GND_Vge_e;
  double qd_Vge_si_Vdi_si;
  double qd_Vge_si_Ve_si;
  double qd_Vge_si_Ve_di;
  double qd_Vge_si_Vge_si;
  double qd_Vge_si_Tempt_GND;
  double qd_Vge_si_Vge_e;
  double qd_Ve_di_Vdi_si;
  double qd_Ve_di_Ve_si;
  double qd_Ve_di_Ve_di;
  double qd_Ve_di_Vge_si;
  double qd_Ve_di_Tempt_GND;
  double qd_Ve_di_Vge_e;
  double qd_Ve_si_Vdi_si;
  double qd_Ve_si_Ve_si;
  double qd_Ve_si_Ve_di;
  double qd_Ve_si_Vge_si;
  double qd_Ve_si_Tempt_GND;
  double qd_Ve_si_Vge_e;
  double qd_Vdi_si_Vdi_si;
  double qd_Vdi_si_Ve_si;
  double qd_Vdi_si_Ve_di;
  double qd_Vdi_si_Vge_si;
  double qd_Vdi_si_Tempt_GND;
  double qd_Vdi_si_Vge_e;
#endif
#endif
double Iii;
#if defined(_DERIVATEFORDDX)
double Iii_Vge_di;
double Iii_Vge_e;
double Iii_Ve_si;
double Iii_Ve_di;
double Iii_Vge_si;
double Iii_Vdi_si;
double Iii_Tempt_GND;
#if defined(_DERIVATE2)
  double Iii_Tempt_GND_Vge_di;
  double Iii_Tempt_GND_Vge_e;
  double Iii_Tempt_GND_Ve_si;
  double Iii_Tempt_GND_Ve_di;
  double Iii_Tempt_GND_Vge_si;
  double Iii_Tempt_GND_Vdi_si;
  double Iii_Tempt_GND_Tempt_GND;
  double Iii_Vdi_si_Vge_di;
  double Iii_Vdi_si_Vge_e;
  double Iii_Vdi_si_Ve_si;
  double Iii_Vdi_si_Ve_di;
  double Iii_Vdi_si_Vge_si;
  double Iii_Vdi_si_Vdi_si;
  double Iii_Vdi_si_Tempt_GND;
  double Iii_Vge_si_Vge_di;
  double Iii_Vge_si_Vge_e;
  double Iii_Vge_si_Ve_si;
  double Iii_Vge_si_Ve_di;
  double Iii_Vge_si_Vge_si;
  double Iii_Vge_si_Vdi_si;
  double Iii_Vge_si_Tempt_GND;
  double Iii_Ve_di_Vge_di;
  double Iii_Ve_di_Vge_e;
  double Iii_Ve_di_Ve_si;
  double Iii_Ve_di_Ve_di;
  double Iii_Ve_di_Vge_si;
  double Iii_Ve_di_Vdi_si;
  double Iii_Ve_di_Tempt_GND;
  double Iii_Ve_si_Vge_di;
  double Iii_Ve_si_Vge_e;
  double Iii_Ve_si_Ve_si;
  double Iii_Ve_si_Ve_di;
  double Iii_Ve_si_Vge_si;
  double Iii_Ve_si_Vdi_si;
  double Iii_Ve_si_Tempt_GND;
  double Iii_Vge_e_Vge_di;
  double Iii_Vge_e_Vge_e;
  double Iii_Vge_e_Ve_si;
  double Iii_Vge_e_Ve_di;
  double Iii_Vge_e_Vge_si;
  double Iii_Vge_e_Vdi_si;
  double Iii_Vge_e_Tempt_GND;
  double Iii_Vge_di_Vge_di;
  double Iii_Vge_di_Vge_e;
  double Iii_Vge_di_Ve_si;
  double Iii_Vge_di_Ve_di;
  double Iii_Vge_di_Vge_si;
  double Iii_Vge_di_Vdi_si;
  double Iii_Vge_di_Tempt_GND;
#endif
#endif
double sigvds;
double ids;
#if defined(_DERIVATEFORDDX)
double ids_Tempt_GND;
double ids_Vdi_si;
double ids_Vge_e;
double ids_Ve_si;
double ids_Ve_di;
double ids_Vge_si;
double ids_Vge_di;
#if defined(_DERIVATE2)
  double ids_Vge_di_Tempt_GND;
  double ids_Vge_di_Vdi_si;
  double ids_Vge_di_Vge_e;
  double ids_Vge_di_Ve_si;
  double ids_Vge_di_Ve_di;
  double ids_Vge_di_Vge_si;
  double ids_Vge_di_Vge_di;
  double ids_Vge_si_Tempt_GND;
  double ids_Vge_si_Vdi_si;
  double ids_Vge_si_Vge_e;
  double ids_Vge_si_Ve_si;
  double ids_Vge_si_Ve_di;
  double ids_Vge_si_Vge_si;
  double ids_Vge_si_Vge_di;
  double ids_Ve_di_Tempt_GND;
  double ids_Ve_di_Vdi_si;
  double ids_Ve_di_Vge_e;
  double ids_Ve_di_Ve_si;
  double ids_Ve_di_Ve_di;
  double ids_Ve_di_Vge_si;
  double ids_Ve_di_Vge_di;
  double ids_Ve_si_Tempt_GND;
  double ids_Ve_si_Vdi_si;
  double ids_Ve_si_Vge_e;
  double ids_Ve_si_Ve_si;
  double ids_Ve_si_Ve_di;
  double ids_Ve_si_Vge_si;
  double ids_Ve_si_Vge_di;
  double ids_Vge_e_Tempt_GND;
  double ids_Vge_e_Vdi_si;
  double ids_Vge_e_Vge_e;
  double ids_Vge_e_Ve_si;
  double ids_Vge_e_Ve_di;
  double ids_Vge_e_Vge_si;
  double ids_Vge_e_Vge_di;
  double ids_Vdi_si_Tempt_GND;
  double ids_Vdi_si_Vdi_si;
  double ids_Vdi_si_Vge_e;
  double ids_Vdi_si_Ve_si;
  double ids_Vdi_si_Ve_di;
  double ids_Vdi_si_Vge_si;
  double ids_Vdi_si_Vge_di;
  double ids_Tempt_GND_Tempt_GND;
  double ids_Tempt_GND_Vdi_si;
  double ids_Tempt_GND_Vge_e;
  double ids_Tempt_GND_Ve_si;
  double ids_Tempt_GND_Ve_di;
  double ids_Tempt_GND_Vge_si;
  double ids_Tempt_GND_Vge_di;
#endif
#endif
double T12;
#if defined(_DERIVATEFORDDX)
double T12_Vge_e;
double T12_Ve_si;
double T12_Ve_di;
double T12_Vge_si;
double T12_Vdi_si;
double T12_Tempt_GND;
#if defined(_DERIVATE2)
  double T12_Tempt_GND_Vge_e;
  double T12_Tempt_GND_Ve_si;
  double T12_Tempt_GND_Ve_di;
  double T12_Tempt_GND_Vge_si;
  double T12_Tempt_GND_Vdi_si;
  double T12_Tempt_GND_Tempt_GND;
  double T12_Vdi_si_Vge_e;
  double T12_Vdi_si_Ve_si;
  double T12_Vdi_si_Ve_di;
  double T12_Vdi_si_Vge_si;
  double T12_Vdi_si_Vdi_si;
  double T12_Vdi_si_Tempt_GND;
  double T12_Vge_si_Vge_e;
  double T12_Vge_si_Ve_si;
  double T12_Vge_si_Ve_di;
  double T12_Vge_si_Vge_si;
  double T12_Vge_si_Vdi_si;
  double T12_Vge_si_Tempt_GND;
  double T12_Ve_di_Vge_e;
  double T12_Ve_di_Ve_si;
  double T12_Ve_di_Ve_di;
  double T12_Ve_di_Vge_si;
  double T12_Ve_di_Vdi_si;
  double T12_Ve_di_Tempt_GND;
  double T12_Ve_si_Vge_e;
  double T12_Ve_si_Ve_si;
  double T12_Ve_si_Ve_di;
  double T12_Ve_si_Vge_si;
  double T12_Ve_si_Vdi_si;
  double T12_Ve_si_Tempt_GND;
  double T12_Vge_e_Vge_e;
  double T12_Vge_e_Ve_si;
  double T12_Vge_e_Ve_di;
  double T12_Vge_e_Vge_si;
  double T12_Vge_e_Vdi_si;
  double T12_Vge_e_Tempt_GND;
#endif
#endif
double T11;
#if defined(_DERIVATEFORDDX)
double T11_Vge_e;
double T11_Ve_si;
double T11_Ve_di;
double T11_Vge_si;
double T11_Vdi_si;
double T11_Tempt_GND;
#if defined(_DERIVATE2)
  double T11_Tempt_GND_Vge_e;
  double T11_Tempt_GND_Ve_si;
  double T11_Tempt_GND_Ve_di;
  double T11_Tempt_GND_Vge_si;
  double T11_Tempt_GND_Vdi_si;
  double T11_Tempt_GND_Tempt_GND;
  double T11_Vdi_si_Vge_e;
  double T11_Vdi_si_Ve_si;
  double T11_Vdi_si_Ve_di;
  double T11_Vdi_si_Vge_si;
  double T11_Vdi_si_Vdi_si;
  double T11_Vdi_si_Tempt_GND;
  double T11_Vge_si_Vge_e;
  double T11_Vge_si_Ve_si;
  double T11_Vge_si_Ve_di;
  double T11_Vge_si_Vge_si;
  double T11_Vge_si_Vdi_si;
  double T11_Vge_si_Tempt_GND;
  double T11_Ve_di_Vge_e;
  double T11_Ve_di_Ve_si;
  double T11_Ve_di_Ve_di;
  double T11_Ve_di_Vge_si;
  double T11_Ve_di_Vdi_si;
  double T11_Ve_di_Tempt_GND;
  double T11_Ve_si_Vge_e;
  double T11_Ve_si_Ve_si;
  double T11_Ve_si_Ve_di;
  double T11_Ve_si_Vge_si;
  double T11_Ve_si_Vdi_si;
  double T11_Ve_si_Tempt_GND;
  double T11_Vge_e_Vge_e;
  double T11_Vge_e_Ve_si;
  double T11_Vge_e_Ve_di;
  double T11_Vge_e_Vge_si;
  double T11_Vge_e_Vdi_si;
  double T11_Vge_e_Tempt_GND;
#endif
#endif
double qba;
#if defined(_DERIVATEFORDDX)
double qba_Tempt_GND;
double qba_Vdi_si;
double qba_Vge_e;
double qba_Ve_si;
double qba_Ve_di;
double qba_Vge_si;
#if defined(_DERIVATE2)
  double qba_Vge_si_Tempt_GND;
  double qba_Vge_si_Vdi_si;
  double qba_Vge_si_Vge_e;
  double qba_Vge_si_Ve_si;
  double qba_Vge_si_Ve_di;
  double qba_Vge_si_Vge_si;
  double qba_Ve_di_Tempt_GND;
  double qba_Ve_di_Vdi_si;
  double qba_Ve_di_Vge_e;
  double qba_Ve_di_Ve_si;
  double qba_Ve_di_Ve_di;
  double qba_Ve_di_Vge_si;
  double qba_Ve_si_Tempt_GND;
  double qba_Ve_si_Vdi_si;
  double qba_Ve_si_Vge_e;
  double qba_Ve_si_Ve_si;
  double qba_Ve_si_Ve_di;
  double qba_Ve_si_Vge_si;
  double qba_Vge_e_Tempt_GND;
  double qba_Vge_e_Vdi_si;
  double qba_Vge_e_Vge_e;
  double qba_Vge_e_Ve_si;
  double qba_Vge_e_Ve_di;
  double qba_Vge_e_Vge_si;
  double qba_Vdi_si_Tempt_GND;
  double qba_Vdi_si_Vdi_si;
  double qba_Vdi_si_Vge_e;
  double qba_Vdi_si_Ve_si;
  double qba_Vdi_si_Ve_di;
  double qba_Vdi_si_Vge_si;
  double qba_Tempt_GND_Tempt_GND;
  double qba_Tempt_GND_Vdi_si;
  double qba_Tempt_GND_Vge_e;
  double qba_Tempt_GND_Ve_si;
  double qba_Tempt_GND_Ve_di;
  double qba_Tempt_GND_Vge_si;
#endif
#endif
double qis;
#if defined(_DERIVATEFORDDX)
double qis_Vdi_si;
double qis_Ve_si;
double qis_Ve_di;
double qis_Vge_si;
double qis_Tempt_GND;
#if defined(_DERIVATE2)
  double qis_Tempt_GND_Vdi_si;
  double qis_Tempt_GND_Ve_si;
  double qis_Tempt_GND_Ve_di;
  double qis_Tempt_GND_Vge_si;
  double qis_Tempt_GND_Tempt_GND;
  double qis_Vge_si_Vdi_si;
  double qis_Vge_si_Ve_si;
  double qis_Vge_si_Ve_di;
  double qis_Vge_si_Vge_si;
  double qis_Vge_si_Tempt_GND;
  double qis_Ve_di_Vdi_si;
  double qis_Ve_di_Ve_si;
  double qis_Ve_di_Ve_di;
  double qis_Ve_di_Vge_si;
  double qis_Ve_di_Tempt_GND;
  double qis_Ve_si_Vdi_si;
  double qis_Ve_si_Ve_si;
  double qis_Ve_si_Ve_di;
  double qis_Ve_si_Vge_si;
  double qis_Ve_si_Tempt_GND;
  double qis_Vdi_si_Vdi_si;
  double qis_Vdi_si_Ve_si;
  double qis_Vdi_si_Ve_di;
  double qis_Vdi_si_Vge_si;
  double qis_Vdi_si_Tempt_GND;
#endif
#endif
double qid;
#if defined(_DERIVATEFORDDX)
double qid_Vdi_si;
double qid_Ve_si;
double qid_Ve_di;
double qid_Vge_si;
double qid_Tempt_GND;
#if defined(_DERIVATE2)
  double qid_Tempt_GND_Vdi_si;
  double qid_Tempt_GND_Ve_si;
  double qid_Tempt_GND_Ve_di;
  double qid_Tempt_GND_Vge_si;
  double qid_Tempt_GND_Tempt_GND;
  double qid_Vge_si_Vdi_si;
  double qid_Vge_si_Ve_si;
  double qid_Vge_si_Ve_di;
  double qid_Vge_si_Vge_si;
  double qid_Vge_si_Tempt_GND;
  double qid_Ve_di_Vdi_si;
  double qid_Ve_di_Ve_si;
  double qid_Ve_di_Ve_di;
  double qid_Ve_di_Vge_si;
  double qid_Ve_di_Tempt_GND;
  double qid_Ve_si_Vdi_si;
  double qid_Ve_si_Ve_si;
  double qid_Ve_si_Ve_di;
  double qid_Ve_si_Vge_si;
  double qid_Ve_si_Tempt_GND;
  double qid_Vdi_si_Vdi_si;
  double qid_Vdi_si_Ve_si;
  double qid_Vdi_si_Ve_di;
  double qid_Vdi_si_Vge_si;
  double qid_Vdi_si_Tempt_GND;
#endif
#endif
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
qid_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qid_Vdi_si_Vdi_si=0.0;
  qid_Vdi_si_Ve_si=0.0;
  qid_Vdi_si_Ve_di=0.0;
  qid_Vdi_si_Vge_si=0.0;
  qid_Vdi_si_Tempt_GND=0.0;
#endif
qid_Ve_si=0.0;
#if defined(_DERIVATE2)
  qid_Ve_si_Vdi_si=0.0;
  qid_Ve_si_Ve_si=0.0;
  qid_Ve_si_Ve_di=0.0;
  qid_Ve_si_Vge_si=0.0;
  qid_Ve_si_Tempt_GND=0.0;
#endif
qid_Ve_di=0.0;
#if defined(_DERIVATE2)
  qid_Ve_di_Vdi_si=0.0;
  qid_Ve_di_Ve_si=0.0;
  qid_Ve_di_Ve_di=0.0;
  qid_Ve_di_Vge_si=0.0;
  qid_Ve_di_Tempt_GND=0.0;
#endif
qid_Vge_si=0.0;
#if defined(_DERIVATE2)
  qid_Vge_si_Vdi_si=0.0;
  qid_Vge_si_Ve_si=0.0;
  qid_Vge_si_Ve_di=0.0;
  qid_Vge_si_Vge_si=0.0;
  qid_Vge_si_Tempt_GND=0.0;
#endif
qid_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qid_Tempt_GND_Vdi_si=0.0;
  qid_Tempt_GND_Ve_si=0.0;
  qid_Tempt_GND_Ve_di=0.0;
  qid_Tempt_GND_Vge_si=0.0;
  qid_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qis_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qis_Vdi_si_Vdi_si=0.0;
  qis_Vdi_si_Ve_si=0.0;
  qis_Vdi_si_Ve_di=0.0;
  qis_Vdi_si_Vge_si=0.0;
  qis_Vdi_si_Tempt_GND=0.0;
#endif
qis_Ve_si=0.0;
#if defined(_DERIVATE2)
  qis_Ve_si_Vdi_si=0.0;
  qis_Ve_si_Ve_si=0.0;
  qis_Ve_si_Ve_di=0.0;
  qis_Ve_si_Vge_si=0.0;
  qis_Ve_si_Tempt_GND=0.0;
#endif
qis_Ve_di=0.0;
#if defined(_DERIVATE2)
  qis_Ve_di_Vdi_si=0.0;
  qis_Ve_di_Ve_si=0.0;
  qis_Ve_di_Ve_di=0.0;
  qis_Ve_di_Vge_si=0.0;
  qis_Ve_di_Tempt_GND=0.0;
#endif
qis_Vge_si=0.0;
#if defined(_DERIVATE2)
  qis_Vge_si_Vdi_si=0.0;
  qis_Vge_si_Ve_si=0.0;
  qis_Vge_si_Ve_di=0.0;
  qis_Vge_si_Vge_si=0.0;
  qis_Vge_si_Tempt_GND=0.0;
#endif
qis_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qis_Tempt_GND_Vdi_si=0.0;
  qis_Tempt_GND_Ve_si=0.0;
  qis_Tempt_GND_Ve_di=0.0;
  qis_Tempt_GND_Vge_si=0.0;
  qis_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qis=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qba_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qba_Tempt_GND_Tempt_GND=0.0;
  qba_Tempt_GND_Vdi_si=0.0;
  qba_Tempt_GND_Vge_e=0.0;
  qba_Tempt_GND_Ve_si=0.0;
  qba_Tempt_GND_Ve_di=0.0;
  qba_Tempt_GND_Vge_si=0.0;
#endif
qba_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qba_Vdi_si_Tempt_GND=0.0;
  qba_Vdi_si_Vdi_si=0.0;
  qba_Vdi_si_Vge_e=0.0;
  qba_Vdi_si_Ve_si=0.0;
  qba_Vdi_si_Ve_di=0.0;
  qba_Vdi_si_Vge_si=0.0;
#endif
qba_Vge_e=0.0;
#if defined(_DERIVATE2)
  qba_Vge_e_Tempt_GND=0.0;
  qba_Vge_e_Vdi_si=0.0;
  qba_Vge_e_Vge_e=0.0;
  qba_Vge_e_Ve_si=0.0;
  qba_Vge_e_Ve_di=0.0;
  qba_Vge_e_Vge_si=0.0;
#endif
qba_Ve_si=0.0;
#if defined(_DERIVATE2)
  qba_Ve_si_Tempt_GND=0.0;
  qba_Ve_si_Vdi_si=0.0;
  qba_Ve_si_Vge_e=0.0;
  qba_Ve_si_Ve_si=0.0;
  qba_Ve_si_Ve_di=0.0;
  qba_Ve_si_Vge_si=0.0;
#endif
qba_Ve_di=0.0;
#if defined(_DERIVATE2)
  qba_Ve_di_Tempt_GND=0.0;
  qba_Ve_di_Vdi_si=0.0;
  qba_Ve_di_Vge_e=0.0;
  qba_Ve_di_Ve_si=0.0;
  qba_Ve_di_Ve_di=0.0;
  qba_Ve_di_Vge_si=0.0;
#endif
qba_Vge_si=0.0;
#if defined(_DERIVATE2)
  qba_Vge_si_Tempt_GND=0.0;
  qba_Vge_si_Vdi_si=0.0;
  qba_Vge_si_Vge_e=0.0;
  qba_Vge_si_Ve_si=0.0;
  qba_Vge_si_Ve_di=0.0;
  qba_Vge_si_Vge_si=0.0;
#endif
#endif
qba=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T11_Vge_e=0.0;
#if defined(_DERIVATE2)
  T11_Vge_e_Vge_e=0.0;
  T11_Vge_e_Ve_si=0.0;
  T11_Vge_e_Ve_di=0.0;
  T11_Vge_e_Vge_si=0.0;
  T11_Vge_e_Vdi_si=0.0;
  T11_Vge_e_Tempt_GND=0.0;
#endif
T11_Ve_si=0.0;
#if defined(_DERIVATE2)
  T11_Ve_si_Vge_e=0.0;
  T11_Ve_si_Ve_si=0.0;
  T11_Ve_si_Ve_di=0.0;
  T11_Ve_si_Vge_si=0.0;
  T11_Ve_si_Vdi_si=0.0;
  T11_Ve_si_Tempt_GND=0.0;
#endif
T11_Ve_di=0.0;
#if defined(_DERIVATE2)
  T11_Ve_di_Vge_e=0.0;
  T11_Ve_di_Ve_si=0.0;
  T11_Ve_di_Ve_di=0.0;
  T11_Ve_di_Vge_si=0.0;
  T11_Ve_di_Vdi_si=0.0;
  T11_Ve_di_Tempt_GND=0.0;
#endif
T11_Vge_si=0.0;
#if defined(_DERIVATE2)
  T11_Vge_si_Vge_e=0.0;
  T11_Vge_si_Ve_si=0.0;
  T11_Vge_si_Ve_di=0.0;
  T11_Vge_si_Vge_si=0.0;
  T11_Vge_si_Vdi_si=0.0;
  T11_Vge_si_Tempt_GND=0.0;
#endif
T11_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T11_Vdi_si_Vge_e=0.0;
  T11_Vdi_si_Ve_si=0.0;
  T11_Vdi_si_Ve_di=0.0;
  T11_Vdi_si_Vge_si=0.0;
  T11_Vdi_si_Vdi_si=0.0;
  T11_Vdi_si_Tempt_GND=0.0;
#endif
T11_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T11_Tempt_GND_Vge_e=0.0;
  T11_Tempt_GND_Ve_si=0.0;
  T11_Tempt_GND_Ve_di=0.0;
  T11_Tempt_GND_Vge_si=0.0;
  T11_Tempt_GND_Vdi_si=0.0;
  T11_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T11=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T12_Vge_e=0.0;
#if defined(_DERIVATE2)
  T12_Vge_e_Vge_e=0.0;
  T12_Vge_e_Ve_si=0.0;
  T12_Vge_e_Ve_di=0.0;
  T12_Vge_e_Vge_si=0.0;
  T12_Vge_e_Vdi_si=0.0;
  T12_Vge_e_Tempt_GND=0.0;
#endif
T12_Ve_si=0.0;
#if defined(_DERIVATE2)
  T12_Ve_si_Vge_e=0.0;
  T12_Ve_si_Ve_si=0.0;
  T12_Ve_si_Ve_di=0.0;
  T12_Ve_si_Vge_si=0.0;
  T12_Ve_si_Vdi_si=0.0;
  T12_Ve_si_Tempt_GND=0.0;
#endif
T12_Ve_di=0.0;
#if defined(_DERIVATE2)
  T12_Ve_di_Vge_e=0.0;
  T12_Ve_di_Ve_si=0.0;
  T12_Ve_di_Ve_di=0.0;
  T12_Ve_di_Vge_si=0.0;
  T12_Ve_di_Vdi_si=0.0;
  T12_Ve_di_Tempt_GND=0.0;
#endif
T12_Vge_si=0.0;
#if defined(_DERIVATE2)
  T12_Vge_si_Vge_e=0.0;
  T12_Vge_si_Ve_si=0.0;
  T12_Vge_si_Ve_di=0.0;
  T12_Vge_si_Vge_si=0.0;
  T12_Vge_si_Vdi_si=0.0;
  T12_Vge_si_Tempt_GND=0.0;
#endif
T12_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T12_Vdi_si_Vge_e=0.0;
  T12_Vdi_si_Ve_si=0.0;
  T12_Vdi_si_Ve_di=0.0;
  T12_Vdi_si_Vge_si=0.0;
  T12_Vdi_si_Vdi_si=0.0;
  T12_Vdi_si_Tempt_GND=0.0;
#endif
T12_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T12_Tempt_GND_Vge_e=0.0;
  T12_Tempt_GND_Ve_si=0.0;
  T12_Tempt_GND_Ve_di=0.0;
  T12_Tempt_GND_Vge_si=0.0;
  T12_Tempt_GND_Vdi_si=0.0;
  T12_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T12=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
ids_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  ids_Tempt_GND_Tempt_GND=0.0;
  ids_Tempt_GND_Vdi_si=0.0;
  ids_Tempt_GND_Vge_e=0.0;
  ids_Tempt_GND_Ve_si=0.0;
  ids_Tempt_GND_Ve_di=0.0;
  ids_Tempt_GND_Vge_si=0.0;
  ids_Tempt_GND_Vge_di=0.0;
#endif
ids_Vdi_si=0.0;
#if defined(_DERIVATE2)
  ids_Vdi_si_Tempt_GND=0.0;
  ids_Vdi_si_Vdi_si=0.0;
  ids_Vdi_si_Vge_e=0.0;
  ids_Vdi_si_Ve_si=0.0;
  ids_Vdi_si_Ve_di=0.0;
  ids_Vdi_si_Vge_si=0.0;
  ids_Vdi_si_Vge_di=0.0;
#endif
ids_Vge_e=0.0;
#if defined(_DERIVATE2)
  ids_Vge_e_Tempt_GND=0.0;
  ids_Vge_e_Vdi_si=0.0;
  ids_Vge_e_Vge_e=0.0;
  ids_Vge_e_Ve_si=0.0;
  ids_Vge_e_Ve_di=0.0;
  ids_Vge_e_Vge_si=0.0;
  ids_Vge_e_Vge_di=0.0;
#endif
ids_Ve_si=0.0;
#if defined(_DERIVATE2)
  ids_Ve_si_Tempt_GND=0.0;
  ids_Ve_si_Vdi_si=0.0;
  ids_Ve_si_Vge_e=0.0;
  ids_Ve_si_Ve_si=0.0;
  ids_Ve_si_Ve_di=0.0;
  ids_Ve_si_Vge_si=0.0;
  ids_Ve_si_Vge_di=0.0;
#endif
ids_Ve_di=0.0;
#if defined(_DERIVATE2)
  ids_Ve_di_Tempt_GND=0.0;
  ids_Ve_di_Vdi_si=0.0;
  ids_Ve_di_Vge_e=0.0;
  ids_Ve_di_Ve_si=0.0;
  ids_Ve_di_Ve_di=0.0;
  ids_Ve_di_Vge_si=0.0;
  ids_Ve_di_Vge_di=0.0;
#endif
ids_Vge_si=0.0;
#if defined(_DERIVATE2)
  ids_Vge_si_Tempt_GND=0.0;
  ids_Vge_si_Vdi_si=0.0;
  ids_Vge_si_Vge_e=0.0;
  ids_Vge_si_Ve_si=0.0;
  ids_Vge_si_Ve_di=0.0;
  ids_Vge_si_Vge_si=0.0;
  ids_Vge_si_Vge_di=0.0;
#endif
ids_Vge_di=0.0;
#if defined(_DERIVATE2)
  ids_Vge_di_Tempt_GND=0.0;
  ids_Vge_di_Vdi_si=0.0;
  ids_Vge_di_Vge_e=0.0;
  ids_Vge_di_Ve_si=0.0;
  ids_Vge_di_Ve_di=0.0;
  ids_Vge_di_Vge_si=0.0;
  ids_Vge_di_Vge_di=0.0;
#endif
#endif
ids=0.0;
EXIT_IF_ISNAN(0.0)
sigvds=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=0.0;
  Iii_Vge_di_Vge_e=0.0;
  Iii_Vge_di_Ve_si=0.0;
  Iii_Vge_di_Ve_di=0.0;
  Iii_Vge_di_Vge_si=0.0;
  Iii_Vge_di_Vdi_si=0.0;
  Iii_Vge_di_Tempt_GND=0.0;
#endif
Iii_Vge_e=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=0.0;
  Iii_Vge_e_Vge_e=0.0;
  Iii_Vge_e_Ve_si=0.0;
  Iii_Vge_e_Ve_di=0.0;
  Iii_Vge_e_Vge_si=0.0;
  Iii_Vge_e_Vdi_si=0.0;
  Iii_Vge_e_Tempt_GND=0.0;
#endif
Iii_Ve_si=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=0.0;
  Iii_Ve_si_Vge_e=0.0;
  Iii_Ve_si_Ve_si=0.0;
  Iii_Ve_si_Ve_di=0.0;
  Iii_Ve_si_Vge_si=0.0;
  Iii_Ve_si_Vdi_si=0.0;
  Iii_Ve_si_Tempt_GND=0.0;
#endif
Iii_Ve_di=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=0.0;
  Iii_Ve_di_Vge_e=0.0;
  Iii_Ve_di_Ve_si=0.0;
  Iii_Ve_di_Ve_di=0.0;
  Iii_Ve_di_Vge_si=0.0;
  Iii_Ve_di_Vdi_si=0.0;
  Iii_Ve_di_Tempt_GND=0.0;
#endif
Iii_Vge_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=0.0;
  Iii_Vge_si_Vge_e=0.0;
  Iii_Vge_si_Ve_si=0.0;
  Iii_Vge_si_Ve_di=0.0;
  Iii_Vge_si_Vge_si=0.0;
  Iii_Vge_si_Vdi_si=0.0;
  Iii_Vge_si_Tempt_GND=0.0;
#endif
Iii_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=0.0;
  Iii_Vdi_si_Vge_e=0.0;
  Iii_Vdi_si_Ve_si=0.0;
  Iii_Vdi_si_Ve_di=0.0;
  Iii_Vdi_si_Vge_si=0.0;
  Iii_Vdi_si_Vdi_si=0.0;
  Iii_Vdi_si_Tempt_GND=0.0;
#endif
Iii_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=0.0;
  Iii_Tempt_GND_Vge_e=0.0;
  Iii_Tempt_GND_Ve_si=0.0;
  Iii_Tempt_GND_Ve_di=0.0;
  Iii_Tempt_GND_Vge_si=0.0;
  Iii_Tempt_GND_Vdi_si=0.0;
  Iii_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Iii=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qd_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qd_Vdi_si_Vdi_si=0.0;
  qd_Vdi_si_Ve_si=0.0;
  qd_Vdi_si_Ve_di=0.0;
  qd_Vdi_si_Vge_si=0.0;
  qd_Vdi_si_Tempt_GND=0.0;
  qd_Vdi_si_Vge_e=0.0;
#endif
qd_Ve_si=0.0;
#if defined(_DERIVATE2)
  qd_Ve_si_Vdi_si=0.0;
  qd_Ve_si_Ve_si=0.0;
  qd_Ve_si_Ve_di=0.0;
  qd_Ve_si_Vge_si=0.0;
  qd_Ve_si_Tempt_GND=0.0;
  qd_Ve_si_Vge_e=0.0;
#endif
qd_Ve_di=0.0;
#if defined(_DERIVATE2)
  qd_Ve_di_Vdi_si=0.0;
  qd_Ve_di_Ve_si=0.0;
  qd_Ve_di_Ve_di=0.0;
  qd_Ve_di_Vge_si=0.0;
  qd_Ve_di_Tempt_GND=0.0;
  qd_Ve_di_Vge_e=0.0;
#endif
qd_Vge_si=0.0;
#if defined(_DERIVATE2)
  qd_Vge_si_Vdi_si=0.0;
  qd_Vge_si_Ve_si=0.0;
  qd_Vge_si_Ve_di=0.0;
  qd_Vge_si_Vge_si=0.0;
  qd_Vge_si_Tempt_GND=0.0;
  qd_Vge_si_Vge_e=0.0;
#endif
qd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qd_Tempt_GND_Vdi_si=0.0;
  qd_Tempt_GND_Ve_si=0.0;
  qd_Tempt_GND_Ve_di=0.0;
  qd_Tempt_GND_Vge_si=0.0;
  qd_Tempt_GND_Tempt_GND=0.0;
  qd_Tempt_GND_Vge_e=0.0;
#endif
qd_Vge_e=0.0;
#if defined(_DERIVATE2)
  qd_Vge_e_Vdi_si=0.0;
  qd_Vge_e_Ve_si=0.0;
  qd_Vge_e_Ve_di=0.0;
  qd_Vge_e_Vge_si=0.0;
  qd_Vge_e_Tempt_GND=0.0;
  qd_Vge_e_Vge_e=0.0;
#endif
#endif
qd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qg_Vdi_si_Vdi_si=0.0;
  qg_Vdi_si_Ve_si=0.0;
  qg_Vdi_si_Ve_di=0.0;
  qg_Vdi_si_Vge_si=0.0;
  qg_Vdi_si_Tempt_GND=0.0;
  qg_Vdi_si_Vge_e=0.0;
#endif
qg_Ve_si=0.0;
#if defined(_DERIVATE2)
  qg_Ve_si_Vdi_si=0.0;
  qg_Ve_si_Ve_si=0.0;
  qg_Ve_si_Ve_di=0.0;
  qg_Ve_si_Vge_si=0.0;
  qg_Ve_si_Tempt_GND=0.0;
  qg_Ve_si_Vge_e=0.0;
#endif
qg_Ve_di=0.0;
#if defined(_DERIVATE2)
  qg_Ve_di_Vdi_si=0.0;
  qg_Ve_di_Ve_si=0.0;
  qg_Ve_di_Ve_di=0.0;
  qg_Ve_di_Vge_si=0.0;
  qg_Ve_di_Tempt_GND=0.0;
  qg_Ve_di_Vge_e=0.0;
#endif
qg_Vge_si=0.0;
#if defined(_DERIVATE2)
  qg_Vge_si_Vdi_si=0.0;
  qg_Vge_si_Ve_si=0.0;
  qg_Vge_si_Ve_di=0.0;
  qg_Vge_si_Vge_si=0.0;
  qg_Vge_si_Tempt_GND=0.0;
  qg_Vge_si_Vge_e=0.0;
#endif
qg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qg_Tempt_GND_Vdi_si=0.0;
  qg_Tempt_GND_Ve_si=0.0;
  qg_Tempt_GND_Ve_di=0.0;
  qg_Tempt_GND_Vge_si=0.0;
  qg_Tempt_GND_Tempt_GND=0.0;
  qg_Tempt_GND_Vge_e=0.0;
#endif
qg_Vge_e=0.0;
#if defined(_DERIVATE2)
  qg_Vge_e_Vdi_si=0.0;
  qg_Vge_e_Ve_si=0.0;
  qg_Vge_e_Ve_di=0.0;
  qg_Vge_e_Vge_si=0.0;
  qg_Vge_e_Tempt_GND=0.0;
  qg_Vge_e_Vge_e=0.0;
#endif
#endif
qg=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qs_Vge_di=0.0;
#if defined(_DERIVATE2)
  qs_Vge_di_Vge_di=0.0;
  qs_Vge_di_Vdi_si=0.0;
  qs_Vge_di_Ve_si=0.0;
  qs_Vge_di_Ve_di=0.0;
  qs_Vge_di_Vge_si=0.0;
  qs_Vge_di_Tempt_GND=0.0;
  qs_Vge_di_Vge_e=0.0;
#endif
qs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qs_Vdi_si_Vge_di=0.0;
  qs_Vdi_si_Vdi_si=0.0;
  qs_Vdi_si_Ve_si=0.0;
  qs_Vdi_si_Ve_di=0.0;
  qs_Vdi_si_Vge_si=0.0;
  qs_Vdi_si_Tempt_GND=0.0;
  qs_Vdi_si_Vge_e=0.0;
#endif
qs_Ve_si=0.0;
#if defined(_DERIVATE2)
  qs_Ve_si_Vge_di=0.0;
  qs_Ve_si_Vdi_si=0.0;
  qs_Ve_si_Ve_si=0.0;
  qs_Ve_si_Ve_di=0.0;
  qs_Ve_si_Vge_si=0.0;
  qs_Ve_si_Tempt_GND=0.0;
  qs_Ve_si_Vge_e=0.0;
#endif
qs_Ve_di=0.0;
#if defined(_DERIVATE2)
  qs_Ve_di_Vge_di=0.0;
  qs_Ve_di_Vdi_si=0.0;
  qs_Ve_di_Ve_si=0.0;
  qs_Ve_di_Ve_di=0.0;
  qs_Ve_di_Vge_si=0.0;
  qs_Ve_di_Tempt_GND=0.0;
  qs_Ve_di_Vge_e=0.0;
#endif
qs_Vge_si=0.0;
#if defined(_DERIVATE2)
  qs_Vge_si_Vge_di=0.0;
  qs_Vge_si_Vdi_si=0.0;
  qs_Vge_si_Ve_si=0.0;
  qs_Vge_si_Ve_di=0.0;
  qs_Vge_si_Vge_si=0.0;
  qs_Vge_si_Tempt_GND=0.0;
  qs_Vge_si_Vge_e=0.0;
#endif
qs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qs_Tempt_GND_Vge_di=0.0;
  qs_Tempt_GND_Vdi_si=0.0;
  qs_Tempt_GND_Ve_si=0.0;
  qs_Tempt_GND_Ve_di=0.0;
  qs_Tempt_GND_Vge_si=0.0;
  qs_Tempt_GND_Tempt_GND=0.0;
  qs_Tempt_GND_Vge_e=0.0;
#endif
qs_Vge_e=0.0;
#if defined(_DERIVATE2)
  qs_Vge_e_Vge_di=0.0;
  qs_Vge_e_Vdi_si=0.0;
  qs_Vge_e_Ve_si=0.0;
  qs_Vge_e_Ve_di=0.0;
  qs_Vge_e_Vge_si=0.0;
  qs_Vge_e_Tempt_GND=0.0;
  qs_Vge_e_Vge_e=0.0;
#endif
#endif
qs=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
qb=0.0;
EXIT_IF_ISNAN(0.0)
#endif
Weff0=0.0;
EXIT_IF_ISNAN(0.0)
WeffCV0=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJSWS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJSWS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJSWGS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJSWGS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWGS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJSWD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJSWD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJSWGD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CJSWGD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWGD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBSWS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBSWS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBSWS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBSWGS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBSWGS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBSWGS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBSWD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBSWD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBSWD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBSWGD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PBSWGD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PBSWGD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSWS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSWS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWGS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSWGS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSWGS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSWD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSWD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWGD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  JSWGD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
JSWGD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSS_t_Tempt_GND=0.0;
#endif
JTSS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWS_t_Tempt_GND=0.0;
#endif
JTSSWS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGS_t_Tempt_GND=0.0;
#endif
JTSSWGS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSD_t_Tempt_GND=0.0;
#endif
JTSD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWD_t_Tempt_GND=0.0;
#endif
JTSSWD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGD_t_Tempt_GND=0.0;
#endif
JTSSWGD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTS_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTS_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSW_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTSSW_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTSSW_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWG_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTSSWG_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTSSWG_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTSD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTSD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTSSWD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTSSWD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWGD_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  NJTSSWGD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
NJTSSWGD_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=0.0;
Ies_Vge_e=0.0;
Ies_Ve_si=0.0;
Ies_Ve_di=0.0;
Ies_Vge_si=0.0;
Ies_Vdi_si=0.0;
Ies_Tempt_GND=0.0;
#endif
Ies=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=0.0;
Ied_Vge_e=0.0;
Ied_Ve_si=0.0;
Ied_Ve_di=0.0;
Ied_Vge_si=0.0;
Ied_Vdi_si=0.0;
Ied_Tempt_GND=0.0;
#endif
Ied=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbs_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbssw_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbssw_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbssw=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbsswg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbsswg_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbsswg=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbdsw_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbdsw_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbdsw=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbdswg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Czbdswg_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Czbdswg=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qes_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qes_Vdi_d_Vdi_d=0.0;
  Qes_Vdi_d_Vsi_s=0.0;
  Qes_Vdi_d_Tempt_GND=0.0;
  Qes_Vdi_d_Vge_di=0.0;
  Qes_Vdi_d_Vge_e=0.0;
  Qes_Vdi_d_Ve_si=0.0;
  Qes_Vdi_d_Ve_di=0.0;
  Qes_Vdi_d_Vge_si=0.0;
  Qes_Vdi_d_Vdi_si=0.0;
#endif
Qes_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qes_Vsi_s_Vdi_d=0.0;
  Qes_Vsi_s_Vsi_s=0.0;
  Qes_Vsi_s_Tempt_GND=0.0;
  Qes_Vsi_s_Vge_di=0.0;
  Qes_Vsi_s_Vge_e=0.0;
  Qes_Vsi_s_Ve_si=0.0;
  Qes_Vsi_s_Ve_di=0.0;
  Qes_Vsi_s_Vge_si=0.0;
  Qes_Vsi_s_Vdi_si=0.0;
#endif
Qes_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qes_Tempt_GND_Vdi_d=0.0;
  Qes_Tempt_GND_Vsi_s=0.0;
  Qes_Tempt_GND_Tempt_GND=0.0;
  Qes_Tempt_GND_Vge_di=0.0;
  Qes_Tempt_GND_Vge_e=0.0;
  Qes_Tempt_GND_Ve_si=0.0;
  Qes_Tempt_GND_Ve_di=0.0;
  Qes_Tempt_GND_Vge_si=0.0;
  Qes_Tempt_GND_Vdi_si=0.0;
#endif
Qes_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_di_Vdi_d=0.0;
  Qes_Vge_di_Vsi_s=0.0;
  Qes_Vge_di_Tempt_GND=0.0;
  Qes_Vge_di_Vge_di=0.0;
  Qes_Vge_di_Vge_e=0.0;
  Qes_Vge_di_Ve_si=0.0;
  Qes_Vge_di_Ve_di=0.0;
  Qes_Vge_di_Vge_si=0.0;
  Qes_Vge_di_Vdi_si=0.0;
#endif
Qes_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_e_Vdi_d=0.0;
  Qes_Vge_e_Vsi_s=0.0;
  Qes_Vge_e_Tempt_GND=0.0;
  Qes_Vge_e_Vge_di=0.0;
  Qes_Vge_e_Vge_e=0.0;
  Qes_Vge_e_Ve_si=0.0;
  Qes_Vge_e_Ve_di=0.0;
  Qes_Vge_e_Vge_si=0.0;
  Qes_Vge_e_Vdi_si=0.0;
#endif
Qes_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qes_Ve_si_Vdi_d=0.0;
  Qes_Ve_si_Vsi_s=0.0;
  Qes_Ve_si_Tempt_GND=0.0;
  Qes_Ve_si_Vge_di=0.0;
  Qes_Ve_si_Vge_e=0.0;
  Qes_Ve_si_Ve_si=0.0;
  Qes_Ve_si_Ve_di=0.0;
  Qes_Ve_si_Vge_si=0.0;
  Qes_Ve_si_Vdi_si=0.0;
#endif
Qes_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qes_Ve_di_Vdi_d=0.0;
  Qes_Ve_di_Vsi_s=0.0;
  Qes_Ve_di_Tempt_GND=0.0;
  Qes_Ve_di_Vge_di=0.0;
  Qes_Ve_di_Vge_e=0.0;
  Qes_Ve_di_Ve_si=0.0;
  Qes_Ve_di_Ve_di=0.0;
  Qes_Ve_di_Vge_si=0.0;
  Qes_Ve_di_Vdi_si=0.0;
#endif
Qes_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_si_Vdi_d=0.0;
  Qes_Vge_si_Vsi_s=0.0;
  Qes_Vge_si_Tempt_GND=0.0;
  Qes_Vge_si_Vge_di=0.0;
  Qes_Vge_si_Vge_e=0.0;
  Qes_Vge_si_Ve_si=0.0;
  Qes_Vge_si_Ve_di=0.0;
  Qes_Vge_si_Vge_si=0.0;
  Qes_Vge_si_Vdi_si=0.0;
#endif
Qes_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qes_Vdi_si_Vdi_d=0.0;
  Qes_Vdi_si_Vsi_s=0.0;
  Qes_Vdi_si_Tempt_GND=0.0;
  Qes_Vdi_si_Vge_di=0.0;
  Qes_Vdi_si_Vge_e=0.0;
  Qes_Vdi_si_Ve_si=0.0;
  Qes_Vdi_si_Ve_di=0.0;
  Qes_Vdi_si_Vge_si=0.0;
  Qes_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qes=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qed_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qed_Vdi_d_Vdi_d=0.0;
  Qed_Vdi_d_Vsi_s=0.0;
  Qed_Vdi_d_Tempt_GND=0.0;
  Qed_Vdi_d_Vge_di=0.0;
  Qed_Vdi_d_Vge_e=0.0;
  Qed_Vdi_d_Ve_si=0.0;
  Qed_Vdi_d_Ve_di=0.0;
  Qed_Vdi_d_Vge_si=0.0;
  Qed_Vdi_d_Vdi_si=0.0;
#endif
Qed_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qed_Vsi_s_Vdi_d=0.0;
  Qed_Vsi_s_Vsi_s=0.0;
  Qed_Vsi_s_Tempt_GND=0.0;
  Qed_Vsi_s_Vge_di=0.0;
  Qed_Vsi_s_Vge_e=0.0;
  Qed_Vsi_s_Ve_si=0.0;
  Qed_Vsi_s_Ve_di=0.0;
  Qed_Vsi_s_Vge_si=0.0;
  Qed_Vsi_s_Vdi_si=0.0;
#endif
Qed_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qed_Tempt_GND_Vdi_d=0.0;
  Qed_Tempt_GND_Vsi_s=0.0;
  Qed_Tempt_GND_Tempt_GND=0.0;
  Qed_Tempt_GND_Vge_di=0.0;
  Qed_Tempt_GND_Vge_e=0.0;
  Qed_Tempt_GND_Ve_si=0.0;
  Qed_Tempt_GND_Ve_di=0.0;
  Qed_Tempt_GND_Vge_si=0.0;
  Qed_Tempt_GND_Vdi_si=0.0;
#endif
Qed_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_di_Vdi_d=0.0;
  Qed_Vge_di_Vsi_s=0.0;
  Qed_Vge_di_Tempt_GND=0.0;
  Qed_Vge_di_Vge_di=0.0;
  Qed_Vge_di_Vge_e=0.0;
  Qed_Vge_di_Ve_si=0.0;
  Qed_Vge_di_Ve_di=0.0;
  Qed_Vge_di_Vge_si=0.0;
  Qed_Vge_di_Vdi_si=0.0;
#endif
Qed_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_e_Vdi_d=0.0;
  Qed_Vge_e_Vsi_s=0.0;
  Qed_Vge_e_Tempt_GND=0.0;
  Qed_Vge_e_Vge_di=0.0;
  Qed_Vge_e_Vge_e=0.0;
  Qed_Vge_e_Ve_si=0.0;
  Qed_Vge_e_Ve_di=0.0;
  Qed_Vge_e_Vge_si=0.0;
  Qed_Vge_e_Vdi_si=0.0;
#endif
Qed_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qed_Ve_si_Vdi_d=0.0;
  Qed_Ve_si_Vsi_s=0.0;
  Qed_Ve_si_Tempt_GND=0.0;
  Qed_Ve_si_Vge_di=0.0;
  Qed_Ve_si_Vge_e=0.0;
  Qed_Ve_si_Ve_si=0.0;
  Qed_Ve_si_Ve_di=0.0;
  Qed_Ve_si_Vge_si=0.0;
  Qed_Ve_si_Vdi_si=0.0;
#endif
Qed_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qed_Ve_di_Vdi_d=0.0;
  Qed_Ve_di_Vsi_s=0.0;
  Qed_Ve_di_Tempt_GND=0.0;
  Qed_Ve_di_Vge_di=0.0;
  Qed_Ve_di_Vge_e=0.0;
  Qed_Ve_di_Ve_si=0.0;
  Qed_Ve_di_Ve_di=0.0;
  Qed_Ve_di_Vge_si=0.0;
  Qed_Ve_di_Vdi_si=0.0;
#endif
Qed_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_si_Vdi_d=0.0;
  Qed_Vge_si_Vsi_s=0.0;
  Qed_Vge_si_Tempt_GND=0.0;
  Qed_Vge_si_Vge_di=0.0;
  Qed_Vge_si_Vge_e=0.0;
  Qed_Vge_si_Ve_si=0.0;
  Qed_Vge_si_Ve_di=0.0;
  Qed_Vge_si_Vge_si=0.0;
  Qed_Vge_si_Vdi_si=0.0;
#endif
Qed_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qed_Vdi_si_Vdi_d=0.0;
  Qed_Vdi_si_Vsi_s=0.0;
  Qed_Vdi_si_Tempt_GND=0.0;
  Qed_Vdi_si_Vge_di=0.0;
  Qed_Vdi_si_Vge_e=0.0;
  Qed_Vdi_si_Ve_si=0.0;
  Qed_Vdi_si_Ve_di=0.0;
  Qed_Vdi_si_Vge_si=0.0;
  Qed_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qed=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(e,ge) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Qeg_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_di_Vge_di=0.0;
  Qeg_Vge_di_Vge_e=0.0;
  Qeg_Vge_di_Vdi_si=0.0;
  Qeg_Vge_di_Ve_si=0.0;
  Qeg_Vge_di_Ve_di=0.0;
  Qeg_Vge_di_Vge_si=0.0;
  Qeg_Vge_di_Tempt_GND=0.0;
  Qeg_Vge_di_Ve_ge=0.0;
#endif
Qeg_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_e_Vge_di=0.0;
  Qeg_Vge_e_Vge_e=0.0;
  Qeg_Vge_e_Vdi_si=0.0;
  Qeg_Vge_e_Ve_si=0.0;
  Qeg_Vge_e_Ve_di=0.0;
  Qeg_Vge_e_Vge_si=0.0;
  Qeg_Vge_e_Tempt_GND=0.0;
  Qeg_Vge_e_Ve_ge=0.0;
#endif
Qeg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vdi_si_Vge_di=0.0;
  Qeg_Vdi_si_Vge_e=0.0;
  Qeg_Vdi_si_Vdi_si=0.0;
  Qeg_Vdi_si_Ve_si=0.0;
  Qeg_Vdi_si_Ve_di=0.0;
  Qeg_Vdi_si_Vge_si=0.0;
  Qeg_Vdi_si_Tempt_GND=0.0;
  Qeg_Vdi_si_Ve_ge=0.0;
#endif
Qeg_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_si_Vge_di=0.0;
  Qeg_Ve_si_Vge_e=0.0;
  Qeg_Ve_si_Vdi_si=0.0;
  Qeg_Ve_si_Ve_si=0.0;
  Qeg_Ve_si_Ve_di=0.0;
  Qeg_Ve_si_Vge_si=0.0;
  Qeg_Ve_si_Tempt_GND=0.0;
  Qeg_Ve_si_Ve_ge=0.0;
#endif
Qeg_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_di_Vge_di=0.0;
  Qeg_Ve_di_Vge_e=0.0;
  Qeg_Ve_di_Vdi_si=0.0;
  Qeg_Ve_di_Ve_si=0.0;
  Qeg_Ve_di_Ve_di=0.0;
  Qeg_Ve_di_Vge_si=0.0;
  Qeg_Ve_di_Tempt_GND=0.0;
  Qeg_Ve_di_Ve_ge=0.0;
#endif
Qeg_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_si_Vge_di=0.0;
  Qeg_Vge_si_Vge_e=0.0;
  Qeg_Vge_si_Vdi_si=0.0;
  Qeg_Vge_si_Ve_si=0.0;
  Qeg_Vge_si_Ve_di=0.0;
  Qeg_Vge_si_Vge_si=0.0;
  Qeg_Vge_si_Tempt_GND=0.0;
  Qeg_Vge_si_Ve_ge=0.0;
#endif
Qeg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qeg_Tempt_GND_Vge_di=0.0;
  Qeg_Tempt_GND_Vge_e=0.0;
  Qeg_Tempt_GND_Vdi_si=0.0;
  Qeg_Tempt_GND_Ve_si=0.0;
  Qeg_Tempt_GND_Ve_di=0.0;
  Qeg_Tempt_GND_Vge_si=0.0;
  Qeg_Tempt_GND_Tempt_GND=0.0;
  Qeg_Tempt_GND_Ve_ge=0.0;
#endif
Qeg_Ve_ge=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_ge_Vge_di=0.0;
  Qeg_Ve_ge_Vge_e=0.0;
  Qeg_Ve_ge_Vdi_si=0.0;
  Qeg_Ve_ge_Ve_si=0.0;
  Qeg_Ve_ge_Ve_di=0.0;
  Qeg_Ve_ge_Vge_si=0.0;
  Qeg_Ve_ge_Tempt_GND=0.0;
  Qeg_Ve_ge_Ve_ge=0.0;
#endif
#endif
Qeg=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Isbs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Isbs_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Isbs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Isbd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Isbd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Isbd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Nvtms_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Nvtms_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Nvtms=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Nvtmd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Nvtmd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Nvtmd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
SslpRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  SslpRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
SslpRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
IVjsmRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  IVjsmRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
IVjsmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjsmRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VjsmRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VjsmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
SslpFwd_Tempt_GND=0.0;
#endif
SslpFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjsmFwd_Tempt_GND=0.0;
#endif
IVjsmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjsmFwd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VjsmFwd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VjsmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
DslpRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  DslpRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
DslpRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
IVjdmRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  IVjdmRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
IVjdmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjdmRev_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VjdmRev_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VjdmRev=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
DslpFwd_Tempt_GND=0.0;
#endif
DslpFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjdmFwd_Tempt_GND=0.0;
#endif
IVjdmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjdmFwd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VjdmFwd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VjdmFwd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
XExpBVS_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  XExpBVS_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
XExpBVS=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
XExpBVD_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  XExpBVD_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
XExpBVD=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe= */
idsgen_Tempt_GND=0.0;
idsgen_Vge_di=0.0;
idsgen_Vge_e=0.0;
idsgen_Ve_si=0.0;
idsgen_Ve_di=0.0;
idsgen_Vge_si=0.0;
idsgen_Vdi_si=0.0;
#endif
idsgen=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
q0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  q0_Tempt_GND_Tempt_GND=0.0;
  q0_Tempt_GND_Vdi_si=0.0;
#endif
q0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  q0_Vdi_si_Tempt_GND=0.0;
  q0_Vdi_si_Vdi_si=0.0;
#endif
#endif
q0=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Tcen_Vge_e=0.0;
#if defined(_DERIVATE2)
  Tcen_Vge_e_Vge_e=0.0;
  Tcen_Vge_e_Vdi_si=0.0;
  Tcen_Vge_e_Ve_si=0.0;
  Tcen_Vge_e_Ve_di=0.0;
  Tcen_Vge_e_Vge_si=0.0;
  Tcen_Vge_e_Tempt_GND=0.0;
#endif
Tcen_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Tcen_Vdi_si_Vge_e=0.0;
  Tcen_Vdi_si_Vdi_si=0.0;
  Tcen_Vdi_si_Ve_si=0.0;
  Tcen_Vdi_si_Ve_di=0.0;
  Tcen_Vdi_si_Vge_si=0.0;
  Tcen_Vdi_si_Tempt_GND=0.0;
#endif
Tcen_Ve_si=0.0;
#if defined(_DERIVATE2)
  Tcen_Ve_si_Vge_e=0.0;
  Tcen_Ve_si_Vdi_si=0.0;
  Tcen_Ve_si_Ve_si=0.0;
  Tcen_Ve_si_Ve_di=0.0;
  Tcen_Ve_si_Vge_si=0.0;
  Tcen_Ve_si_Tempt_GND=0.0;
#endif
Tcen_Ve_di=0.0;
#if defined(_DERIVATE2)
  Tcen_Ve_di_Vge_e=0.0;
  Tcen_Ve_di_Vdi_si=0.0;
  Tcen_Ve_di_Ve_si=0.0;
  Tcen_Ve_di_Ve_di=0.0;
  Tcen_Ve_di_Vge_si=0.0;
  Tcen_Ve_di_Tempt_GND=0.0;
#endif
Tcen_Vge_si=0.0;
#if defined(_DERIVATE2)
  Tcen_Vge_si_Vge_e=0.0;
  Tcen_Vge_si_Vdi_si=0.0;
  Tcen_Vge_si_Ve_si=0.0;
  Tcen_Vge_si_Ve_di=0.0;
  Tcen_Vge_si_Vge_si=0.0;
  Tcen_Vge_si_Tempt_GND=0.0;
#endif
Tcen_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Tcen_Tempt_GND_Vge_e=0.0;
  Tcen_Tempt_GND_Vdi_si=0.0;
  Tcen_Tempt_GND_Ve_si=0.0;
  Tcen_Tempt_GND_Ve_di=0.0;
  Tcen_Tempt_GND_Vge_si=0.0;
  Tcen_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Tcen=0.0;
EXIT_IF_ISNAN(0.0)
MTcen=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vdi_d=0.0;
Rdrain_Vsi_s=0.0;
Rdrain_Vge_e=0.0;
Rdrain_Vdi_si=0.0;
Rdrain_Ve_si=0.0;
Rdrain_Ve_di=0.0;
Rdrain_Vge_si=0.0;
Rdrain_Vge_di=0.0;
#endif
Rdrain=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vsi_s=0.0;
Rsource_Vge_e=0.0;
Rsource_Vdi_si=0.0;
Rsource_Ve_si=0.0;
Rsource_Ve_di=0.0;
Rsource_Vge_si=0.0;
#endif
Rsource=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
Cfr_geo=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbinv_Vge_e=0.0;
igbinv_Vdi_si=0.0;
igbinv_Tempt_GND=0.0;
igbinv_Ve_si=0.0;
igbinv_Ve_di=0.0;
igbinv_Vge_si=0.0;
igbinv_Vge_di=0.0;
igbinv_Vdi_d=0.0;
igbinv_Vsi_s=0.0;
#endif
igbinv=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbs_Vge_e=0.0;
igbs_Vdi_si=0.0;
igbs_Tempt_GND=0.0;
igbs_Ve_si=0.0;
igbs_Ve_di=0.0;
igbs_Vge_si=0.0;
igbs_Vge_di=0.0;
igbs_Vdi_d=0.0;
igbs_Vsi_s=0.0;
#endif
igbs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbd_Vge_e=0.0;
igbd_Vdi_si=0.0;
igbd_Tempt_GND=0.0;
igbd_Ve_si=0.0;
igbd_Ve_di=0.0;
igbd_Vge_si=0.0;
igbd_Vge_di=0.0;
igbd_Vdi_d=0.0;
igbd_Vsi_s=0.0;
#endif
igbd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbacc_Vge_e=0.0;
igbacc_Vdi_si=0.0;
igbacc_Tempt_GND=0.0;
igbacc_Ve_si=0.0;
igbacc_Ve_di=0.0;
igbacc_Vge_si=0.0;
igbacc_Vge_di=0.0;
igbacc_Vdi_d=0.0;
igbacc_Vsi_s=0.0;
#endif
igbacc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcs_Vge_di=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_di_Vge_di=0.0;
  igcs_Vge_di_Vge_e=0.0;
  igcs_Vge_di_Vdi_si=0.0;
  igcs_Vge_di_Ve_si=0.0;
  igcs_Vge_di_Ve_di=0.0;
  igcs_Vge_di_Vge_si=0.0;
  igcs_Vge_di_Tempt_GND=0.0;
  igcs_Vge_di_Vdi_d=0.0;
  igcs_Vge_di_Vsi_s=0.0;
#endif
igcs_Vge_e=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_e_Vge_di=0.0;
  igcs_Vge_e_Vge_e=0.0;
  igcs_Vge_e_Vdi_si=0.0;
  igcs_Vge_e_Ve_si=0.0;
  igcs_Vge_e_Ve_di=0.0;
  igcs_Vge_e_Vge_si=0.0;
  igcs_Vge_e_Tempt_GND=0.0;
  igcs_Vge_e_Vdi_d=0.0;
  igcs_Vge_e_Vsi_s=0.0;
#endif
igcs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igcs_Vdi_si_Vge_di=0.0;
  igcs_Vdi_si_Vge_e=0.0;
  igcs_Vdi_si_Vdi_si=0.0;
  igcs_Vdi_si_Ve_si=0.0;
  igcs_Vdi_si_Ve_di=0.0;
  igcs_Vdi_si_Vge_si=0.0;
  igcs_Vdi_si_Tempt_GND=0.0;
  igcs_Vdi_si_Vdi_d=0.0;
  igcs_Vdi_si_Vsi_s=0.0;
#endif
igcs_Ve_si=0.0;
#if defined(_DERIVATE2)
  igcs_Ve_si_Vge_di=0.0;
  igcs_Ve_si_Vge_e=0.0;
  igcs_Ve_si_Vdi_si=0.0;
  igcs_Ve_si_Ve_si=0.0;
  igcs_Ve_si_Ve_di=0.0;
  igcs_Ve_si_Vge_si=0.0;
  igcs_Ve_si_Tempt_GND=0.0;
  igcs_Ve_si_Vdi_d=0.0;
  igcs_Ve_si_Vsi_s=0.0;
#endif
igcs_Ve_di=0.0;
#if defined(_DERIVATE2)
  igcs_Ve_di_Vge_di=0.0;
  igcs_Ve_di_Vge_e=0.0;
  igcs_Ve_di_Vdi_si=0.0;
  igcs_Ve_di_Ve_si=0.0;
  igcs_Ve_di_Ve_di=0.0;
  igcs_Ve_di_Vge_si=0.0;
  igcs_Ve_di_Tempt_GND=0.0;
  igcs_Ve_di_Vdi_d=0.0;
  igcs_Ve_di_Vsi_s=0.0;
#endif
igcs_Vge_si=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_si_Vge_di=0.0;
  igcs_Vge_si_Vge_e=0.0;
  igcs_Vge_si_Vdi_si=0.0;
  igcs_Vge_si_Ve_si=0.0;
  igcs_Vge_si_Ve_di=0.0;
  igcs_Vge_si_Vge_si=0.0;
  igcs_Vge_si_Tempt_GND=0.0;
  igcs_Vge_si_Vdi_d=0.0;
  igcs_Vge_si_Vsi_s=0.0;
#endif
igcs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igcs_Tempt_GND_Vge_di=0.0;
  igcs_Tempt_GND_Vge_e=0.0;
  igcs_Tempt_GND_Vdi_si=0.0;
  igcs_Tempt_GND_Ve_si=0.0;
  igcs_Tempt_GND_Ve_di=0.0;
  igcs_Tempt_GND_Vge_si=0.0;
  igcs_Tempt_GND_Tempt_GND=0.0;
  igcs_Tempt_GND_Vdi_d=0.0;
  igcs_Tempt_GND_Vsi_s=0.0;
#endif
igcs_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igcs_Vdi_d_Vge_di=0.0;
  igcs_Vdi_d_Vge_e=0.0;
  igcs_Vdi_d_Vdi_si=0.0;
  igcs_Vdi_d_Ve_si=0.0;
  igcs_Vdi_d_Ve_di=0.0;
  igcs_Vdi_d_Vge_si=0.0;
  igcs_Vdi_d_Tempt_GND=0.0;
  igcs_Vdi_d_Vdi_d=0.0;
  igcs_Vdi_d_Vsi_s=0.0;
#endif
igcs_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igcs_Vsi_s_Vge_di=0.0;
  igcs_Vsi_s_Vge_e=0.0;
  igcs_Vsi_s_Vdi_si=0.0;
  igcs_Vsi_s_Ve_si=0.0;
  igcs_Vsi_s_Ve_di=0.0;
  igcs_Vsi_s_Vge_si=0.0;
  igcs_Vsi_s_Tempt_GND=0.0;
  igcs_Vsi_s_Vdi_d=0.0;
  igcs_Vsi_s_Vsi_s=0.0;
#endif
#endif
igcs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcd_Vge_di=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_di_Vge_di=0.0;
  igcd_Vge_di_Vge_e=0.0;
  igcd_Vge_di_Vdi_si=0.0;
  igcd_Vge_di_Ve_si=0.0;
  igcd_Vge_di_Ve_di=0.0;
  igcd_Vge_di_Vge_si=0.0;
  igcd_Vge_di_Tempt_GND=0.0;
  igcd_Vge_di_Vdi_d=0.0;
  igcd_Vge_di_Vsi_s=0.0;
#endif
igcd_Vge_e=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_e_Vge_di=0.0;
  igcd_Vge_e_Vge_e=0.0;
  igcd_Vge_e_Vdi_si=0.0;
  igcd_Vge_e_Ve_si=0.0;
  igcd_Vge_e_Ve_di=0.0;
  igcd_Vge_e_Vge_si=0.0;
  igcd_Vge_e_Tempt_GND=0.0;
  igcd_Vge_e_Vdi_d=0.0;
  igcd_Vge_e_Vsi_s=0.0;
#endif
igcd_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igcd_Vdi_si_Vge_di=0.0;
  igcd_Vdi_si_Vge_e=0.0;
  igcd_Vdi_si_Vdi_si=0.0;
  igcd_Vdi_si_Ve_si=0.0;
  igcd_Vdi_si_Ve_di=0.0;
  igcd_Vdi_si_Vge_si=0.0;
  igcd_Vdi_si_Tempt_GND=0.0;
  igcd_Vdi_si_Vdi_d=0.0;
  igcd_Vdi_si_Vsi_s=0.0;
#endif
igcd_Ve_si=0.0;
#if defined(_DERIVATE2)
  igcd_Ve_si_Vge_di=0.0;
  igcd_Ve_si_Vge_e=0.0;
  igcd_Ve_si_Vdi_si=0.0;
  igcd_Ve_si_Ve_si=0.0;
  igcd_Ve_si_Ve_di=0.0;
  igcd_Ve_si_Vge_si=0.0;
  igcd_Ve_si_Tempt_GND=0.0;
  igcd_Ve_si_Vdi_d=0.0;
  igcd_Ve_si_Vsi_s=0.0;
#endif
igcd_Ve_di=0.0;
#if defined(_DERIVATE2)
  igcd_Ve_di_Vge_di=0.0;
  igcd_Ve_di_Vge_e=0.0;
  igcd_Ve_di_Vdi_si=0.0;
  igcd_Ve_di_Ve_si=0.0;
  igcd_Ve_di_Ve_di=0.0;
  igcd_Ve_di_Vge_si=0.0;
  igcd_Ve_di_Tempt_GND=0.0;
  igcd_Ve_di_Vdi_d=0.0;
  igcd_Ve_di_Vsi_s=0.0;
#endif
igcd_Vge_si=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_si_Vge_di=0.0;
  igcd_Vge_si_Vge_e=0.0;
  igcd_Vge_si_Vdi_si=0.0;
  igcd_Vge_si_Ve_si=0.0;
  igcd_Vge_si_Ve_di=0.0;
  igcd_Vge_si_Vge_si=0.0;
  igcd_Vge_si_Tempt_GND=0.0;
  igcd_Vge_si_Vdi_d=0.0;
  igcd_Vge_si_Vsi_s=0.0;
#endif
igcd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igcd_Tempt_GND_Vge_di=0.0;
  igcd_Tempt_GND_Vge_e=0.0;
  igcd_Tempt_GND_Vdi_si=0.0;
  igcd_Tempt_GND_Ve_si=0.0;
  igcd_Tempt_GND_Ve_di=0.0;
  igcd_Tempt_GND_Vge_si=0.0;
  igcd_Tempt_GND_Tempt_GND=0.0;
  igcd_Tempt_GND_Vdi_d=0.0;
  igcd_Tempt_GND_Vsi_s=0.0;
#endif
igcd_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igcd_Vdi_d_Vge_di=0.0;
  igcd_Vdi_d_Vge_e=0.0;
  igcd_Vdi_d_Vdi_si=0.0;
  igcd_Vdi_d_Ve_si=0.0;
  igcd_Vdi_d_Ve_di=0.0;
  igcd_Vdi_d_Vge_si=0.0;
  igcd_Vdi_d_Tempt_GND=0.0;
  igcd_Vdi_d_Vdi_d=0.0;
  igcd_Vdi_d_Vsi_s=0.0;
#endif
igcd_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igcd_Vsi_s_Vge_di=0.0;
  igcd_Vsi_s_Vge_e=0.0;
  igcd_Vsi_s_Vdi_si=0.0;
  igcd_Vsi_s_Ve_si=0.0;
  igcd_Vsi_s_Ve_di=0.0;
  igcd_Vsi_s_Vge_si=0.0;
  igcd_Vsi_s_Tempt_GND=0.0;
  igcd_Vsi_s_Vdi_d=0.0;
  igcd_Vsi_s_Vsi_s=0.0;
#endif
#endif
igcd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igidl_Vge_di=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_di_Vge_di=0.0;
  igidl_Vge_di_Vdi_d=0.0;
  igidl_Vge_di_Vsi_s=0.0;
  igidl_Vge_di_Vge_e=0.0;
  igidl_Vge_di_Vdi_si=0.0;
  igidl_Vge_di_Tempt_GND=0.0;
  igidl_Vge_di_Ve_si=0.0;
  igidl_Vge_di_Ve_di=0.0;
  igidl_Vge_di_Vge_si=0.0;
#endif
igidl_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igidl_Vdi_d_Vge_di=0.0;
  igidl_Vdi_d_Vdi_d=0.0;
  igidl_Vdi_d_Vsi_s=0.0;
  igidl_Vdi_d_Vge_e=0.0;
  igidl_Vdi_d_Vdi_si=0.0;
  igidl_Vdi_d_Tempt_GND=0.0;
  igidl_Vdi_d_Ve_si=0.0;
  igidl_Vdi_d_Ve_di=0.0;
  igidl_Vdi_d_Vge_si=0.0;
#endif
igidl_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igidl_Vsi_s_Vge_di=0.0;
  igidl_Vsi_s_Vdi_d=0.0;
  igidl_Vsi_s_Vsi_s=0.0;
  igidl_Vsi_s_Vge_e=0.0;
  igidl_Vsi_s_Vdi_si=0.0;
  igidl_Vsi_s_Tempt_GND=0.0;
  igidl_Vsi_s_Ve_si=0.0;
  igidl_Vsi_s_Ve_di=0.0;
  igidl_Vsi_s_Vge_si=0.0;
#endif
igidl_Vge_e=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_e_Vge_di=0.0;
  igidl_Vge_e_Vdi_d=0.0;
  igidl_Vge_e_Vsi_s=0.0;
  igidl_Vge_e_Vge_e=0.0;
  igidl_Vge_e_Vdi_si=0.0;
  igidl_Vge_e_Tempt_GND=0.0;
  igidl_Vge_e_Ve_si=0.0;
  igidl_Vge_e_Ve_di=0.0;
  igidl_Vge_e_Vge_si=0.0;
#endif
igidl_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igidl_Vdi_si_Vge_di=0.0;
  igidl_Vdi_si_Vdi_d=0.0;
  igidl_Vdi_si_Vsi_s=0.0;
  igidl_Vdi_si_Vge_e=0.0;
  igidl_Vdi_si_Vdi_si=0.0;
  igidl_Vdi_si_Tempt_GND=0.0;
  igidl_Vdi_si_Ve_si=0.0;
  igidl_Vdi_si_Ve_di=0.0;
  igidl_Vdi_si_Vge_si=0.0;
#endif
igidl_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igidl_Tempt_GND_Vge_di=0.0;
  igidl_Tempt_GND_Vdi_d=0.0;
  igidl_Tempt_GND_Vsi_s=0.0;
  igidl_Tempt_GND_Vge_e=0.0;
  igidl_Tempt_GND_Vdi_si=0.0;
  igidl_Tempt_GND_Tempt_GND=0.0;
  igidl_Tempt_GND_Ve_si=0.0;
  igidl_Tempt_GND_Ve_di=0.0;
  igidl_Tempt_GND_Vge_si=0.0;
#endif
igidl_Ve_si=0.0;
#if defined(_DERIVATE2)
  igidl_Ve_si_Vge_di=0.0;
  igidl_Ve_si_Vdi_d=0.0;
  igidl_Ve_si_Vsi_s=0.0;
  igidl_Ve_si_Vge_e=0.0;
  igidl_Ve_si_Vdi_si=0.0;
  igidl_Ve_si_Tempt_GND=0.0;
  igidl_Ve_si_Ve_si=0.0;
  igidl_Ve_si_Ve_di=0.0;
  igidl_Ve_si_Vge_si=0.0;
#endif
igidl_Ve_di=0.0;
#if defined(_DERIVATE2)
  igidl_Ve_di_Vge_di=0.0;
  igidl_Ve_di_Vdi_d=0.0;
  igidl_Ve_di_Vsi_s=0.0;
  igidl_Ve_di_Vge_e=0.0;
  igidl_Ve_di_Vdi_si=0.0;
  igidl_Ve_di_Tempt_GND=0.0;
  igidl_Ve_di_Ve_si=0.0;
  igidl_Ve_di_Ve_di=0.0;
  igidl_Ve_di_Vge_si=0.0;
#endif
igidl_Vge_si=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_si_Vge_di=0.0;
  igidl_Vge_si_Vdi_d=0.0;
  igidl_Vge_si_Vsi_s=0.0;
  igidl_Vge_si_Vge_e=0.0;
  igidl_Vge_si_Vdi_si=0.0;
  igidl_Vge_si_Tempt_GND=0.0;
  igidl_Vge_si_Ve_si=0.0;
  igidl_Vge_si_Ve_di=0.0;
  igidl_Vge_si_Vge_si=0.0;
#endif
#endif
igidl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igisl_Vge_di=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_di_Vge_di=0.0;
  igisl_Vge_di_Vdi_d=0.0;
  igisl_Vge_di_Vsi_s=0.0;
  igisl_Vge_di_Vge_e=0.0;
  igisl_Vge_di_Vdi_si=0.0;
  igisl_Vge_di_Tempt_GND=0.0;
  igisl_Vge_di_Ve_si=0.0;
  igisl_Vge_di_Ve_di=0.0;
  igisl_Vge_di_Vge_si=0.0;
#endif
igisl_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igisl_Vdi_d_Vge_di=0.0;
  igisl_Vdi_d_Vdi_d=0.0;
  igisl_Vdi_d_Vsi_s=0.0;
  igisl_Vdi_d_Vge_e=0.0;
  igisl_Vdi_d_Vdi_si=0.0;
  igisl_Vdi_d_Tempt_GND=0.0;
  igisl_Vdi_d_Ve_si=0.0;
  igisl_Vdi_d_Ve_di=0.0;
  igisl_Vdi_d_Vge_si=0.0;
#endif
igisl_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igisl_Vsi_s_Vge_di=0.0;
  igisl_Vsi_s_Vdi_d=0.0;
  igisl_Vsi_s_Vsi_s=0.0;
  igisl_Vsi_s_Vge_e=0.0;
  igisl_Vsi_s_Vdi_si=0.0;
  igisl_Vsi_s_Tempt_GND=0.0;
  igisl_Vsi_s_Ve_si=0.0;
  igisl_Vsi_s_Ve_di=0.0;
  igisl_Vsi_s_Vge_si=0.0;
#endif
igisl_Vge_e=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_e_Vge_di=0.0;
  igisl_Vge_e_Vdi_d=0.0;
  igisl_Vge_e_Vsi_s=0.0;
  igisl_Vge_e_Vge_e=0.0;
  igisl_Vge_e_Vdi_si=0.0;
  igisl_Vge_e_Tempt_GND=0.0;
  igisl_Vge_e_Ve_si=0.0;
  igisl_Vge_e_Ve_di=0.0;
  igisl_Vge_e_Vge_si=0.0;
#endif
igisl_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igisl_Vdi_si_Vge_di=0.0;
  igisl_Vdi_si_Vdi_d=0.0;
  igisl_Vdi_si_Vsi_s=0.0;
  igisl_Vdi_si_Vge_e=0.0;
  igisl_Vdi_si_Vdi_si=0.0;
  igisl_Vdi_si_Tempt_GND=0.0;
  igisl_Vdi_si_Ve_si=0.0;
  igisl_Vdi_si_Ve_di=0.0;
  igisl_Vdi_si_Vge_si=0.0;
#endif
igisl_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igisl_Tempt_GND_Vge_di=0.0;
  igisl_Tempt_GND_Vdi_d=0.0;
  igisl_Tempt_GND_Vsi_s=0.0;
  igisl_Tempt_GND_Vge_e=0.0;
  igisl_Tempt_GND_Vdi_si=0.0;
  igisl_Tempt_GND_Tempt_GND=0.0;
  igisl_Tempt_GND_Ve_si=0.0;
  igisl_Tempt_GND_Ve_di=0.0;
  igisl_Tempt_GND_Vge_si=0.0;
#endif
igisl_Ve_si=0.0;
#if defined(_DERIVATE2)
  igisl_Ve_si_Vge_di=0.0;
  igisl_Ve_si_Vdi_d=0.0;
  igisl_Ve_si_Vsi_s=0.0;
  igisl_Ve_si_Vge_e=0.0;
  igisl_Ve_si_Vdi_si=0.0;
  igisl_Ve_si_Tempt_GND=0.0;
  igisl_Ve_si_Ve_si=0.0;
  igisl_Ve_si_Ve_di=0.0;
  igisl_Ve_si_Vge_si=0.0;
#endif
igisl_Ve_di=0.0;
#if defined(_DERIVATE2)
  igisl_Ve_di_Vge_di=0.0;
  igisl_Ve_di_Vdi_d=0.0;
  igisl_Ve_di_Vsi_s=0.0;
  igisl_Ve_di_Vge_e=0.0;
  igisl_Ve_di_Vdi_si=0.0;
  igisl_Ve_di_Tempt_GND=0.0;
  igisl_Ve_di_Ve_si=0.0;
  igisl_Ve_di_Ve_di=0.0;
  igisl_Ve_di_Vge_si=0.0;
#endif
igisl_Vge_si=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_si_Vge_di=0.0;
  igisl_Vge_si_Vdi_d=0.0;
  igisl_Vge_si_Vsi_s=0.0;
  igisl_Vge_si_Vge_e=0.0;
  igisl_Vge_si_Vdi_si=0.0;
  igisl_Vge_si_Tempt_GND=0.0;
  igisl_Vge_si_Ve_si=0.0;
  igisl_Vge_si_Ve_di=0.0;
  igisl_Vge_si_Vge_si=0.0;
#endif
#endif
igisl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igs_Tempt_GND_Tempt_GND=0.0;
  igs_Tempt_GND_Vge_si=0.0;
  igs_Tempt_GND_Vge_di=0.0;
  igs_Tempt_GND_Vge_e=0.0;
  igs_Tempt_GND_Ve_si=0.0;
  igs_Tempt_GND_Ve_di=0.0;
  igs_Tempt_GND_Vdi_si=0.0;
#endif
igs_Vge_si=0.0;
#if defined(_DERIVATE2)
  igs_Vge_si_Tempt_GND=0.0;
  igs_Vge_si_Vge_si=0.0;
  igs_Vge_si_Vge_di=0.0;
  igs_Vge_si_Vge_e=0.0;
  igs_Vge_si_Ve_si=0.0;
  igs_Vge_si_Ve_di=0.0;
  igs_Vge_si_Vdi_si=0.0;
#endif
igs_Vge_di=0.0;
#if defined(_DERIVATE2)
  igs_Vge_di_Tempt_GND=0.0;
  igs_Vge_di_Vge_si=0.0;
  igs_Vge_di_Vge_di=0.0;
  igs_Vge_di_Vge_e=0.0;
  igs_Vge_di_Ve_si=0.0;
  igs_Vge_di_Ve_di=0.0;
  igs_Vge_di_Vdi_si=0.0;
#endif
igs_Vge_e=0.0;
#if defined(_DERIVATE2)
  igs_Vge_e_Tempt_GND=0.0;
  igs_Vge_e_Vge_si=0.0;
  igs_Vge_e_Vge_di=0.0;
  igs_Vge_e_Vge_e=0.0;
  igs_Vge_e_Ve_si=0.0;
  igs_Vge_e_Ve_di=0.0;
  igs_Vge_e_Vdi_si=0.0;
#endif
igs_Ve_si=0.0;
#if defined(_DERIVATE2)
  igs_Ve_si_Tempt_GND=0.0;
  igs_Ve_si_Vge_si=0.0;
  igs_Ve_si_Vge_di=0.0;
  igs_Ve_si_Vge_e=0.0;
  igs_Ve_si_Ve_si=0.0;
  igs_Ve_si_Ve_di=0.0;
  igs_Ve_si_Vdi_si=0.0;
#endif
igs_Ve_di=0.0;
#if defined(_DERIVATE2)
  igs_Ve_di_Tempt_GND=0.0;
  igs_Ve_di_Vge_si=0.0;
  igs_Ve_di_Vge_di=0.0;
  igs_Ve_di_Vge_e=0.0;
  igs_Ve_di_Ve_si=0.0;
  igs_Ve_di_Ve_di=0.0;
  igs_Ve_di_Vdi_si=0.0;
#endif
igs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igs_Vdi_si_Tempt_GND=0.0;
  igs_Vdi_si_Vge_si=0.0;
  igs_Vdi_si_Vge_di=0.0;
  igs_Vdi_si_Vge_e=0.0;
  igs_Vdi_si_Ve_si=0.0;
  igs_Vdi_si_Ve_di=0.0;
  igs_Vdi_si_Vdi_si=0.0;
#endif
#endif
igs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igd_Tempt_GND_Tempt_GND=0.0;
  igd_Tempt_GND_Vge_si=0.0;
  igd_Tempt_GND_Vge_di=0.0;
  igd_Tempt_GND_Vge_e=0.0;
  igd_Tempt_GND_Ve_si=0.0;
  igd_Tempt_GND_Ve_di=0.0;
  igd_Tempt_GND_Vdi_si=0.0;
#endif
igd_Vge_si=0.0;
#if defined(_DERIVATE2)
  igd_Vge_si_Tempt_GND=0.0;
  igd_Vge_si_Vge_si=0.0;
  igd_Vge_si_Vge_di=0.0;
  igd_Vge_si_Vge_e=0.0;
  igd_Vge_si_Ve_si=0.0;
  igd_Vge_si_Ve_di=0.0;
  igd_Vge_si_Vdi_si=0.0;
#endif
igd_Vge_di=0.0;
#if defined(_DERIVATE2)
  igd_Vge_di_Tempt_GND=0.0;
  igd_Vge_di_Vge_si=0.0;
  igd_Vge_di_Vge_di=0.0;
  igd_Vge_di_Vge_e=0.0;
  igd_Vge_di_Ve_si=0.0;
  igd_Vge_di_Ve_di=0.0;
  igd_Vge_di_Vdi_si=0.0;
#endif
igd_Vge_e=0.0;
#if defined(_DERIVATE2)
  igd_Vge_e_Tempt_GND=0.0;
  igd_Vge_e_Vge_si=0.0;
  igd_Vge_e_Vge_di=0.0;
  igd_Vge_e_Vge_e=0.0;
  igd_Vge_e_Ve_si=0.0;
  igd_Vge_e_Ve_di=0.0;
  igd_Vge_e_Vdi_si=0.0;
#endif
igd_Ve_si=0.0;
#if defined(_DERIVATE2)
  igd_Ve_si_Tempt_GND=0.0;
  igd_Ve_si_Vge_si=0.0;
  igd_Ve_si_Vge_di=0.0;
  igd_Ve_si_Vge_e=0.0;
  igd_Ve_si_Ve_si=0.0;
  igd_Ve_si_Ve_di=0.0;
  igd_Ve_si_Vdi_si=0.0;
#endif
igd_Ve_di=0.0;
#if defined(_DERIVATE2)
  igd_Ve_di_Tempt_GND=0.0;
  igd_Ve_di_Vge_si=0.0;
  igd_Ve_di_Vge_di=0.0;
  igd_Ve_di_Vge_e=0.0;
  igd_Ve_di_Ve_si=0.0;
  igd_Ve_di_Ve_di=0.0;
  igd_Ve_di_Vdi_si=0.0;
#endif
igd_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igd_Vdi_si_Tempt_GND=0.0;
  igd_Vdi_si_Vge_si=0.0;
  igd_Vdi_si_Vge_di=0.0;
  igd_Vdi_si_Vge_e=0.0;
  igd_Vdi_si_Ve_si=0.0;
  igd_Vdi_si_Ve_di=0.0;
  igd_Vdi_si_Vdi_si=0.0;
#endif
#endif
igd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
cox_acc_Vge_e=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vge_e_Vge_e=0.0;
  cox_acc_Vge_e_Vdi_si=0.0;
  cox_acc_Vge_e_Ve_si=0.0;
  cox_acc_Vge_e_Ve_di=0.0;
  cox_acc_Vge_e_Vge_si=0.0;
  cox_acc_Vge_e_Tempt_GND=0.0;
#endif
cox_acc_Vdi_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vdi_si_Vge_e=0.0;
  cox_acc_Vdi_si_Vdi_si=0.0;
  cox_acc_Vdi_si_Ve_si=0.0;
  cox_acc_Vdi_si_Ve_di=0.0;
  cox_acc_Vdi_si_Vge_si=0.0;
  cox_acc_Vdi_si_Tempt_GND=0.0;
#endif
cox_acc_Ve_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Ve_si_Vge_e=0.0;
  cox_acc_Ve_si_Vdi_si=0.0;
  cox_acc_Ve_si_Ve_si=0.0;
  cox_acc_Ve_si_Ve_di=0.0;
  cox_acc_Ve_si_Vge_si=0.0;
  cox_acc_Ve_si_Tempt_GND=0.0;
#endif
cox_acc_Ve_di=0.0;
#if defined(_DERIVATE2)
  cox_acc_Ve_di_Vge_e=0.0;
  cox_acc_Ve_di_Vdi_si=0.0;
  cox_acc_Ve_di_Ve_si=0.0;
  cox_acc_Ve_di_Ve_di=0.0;
  cox_acc_Ve_di_Vge_si=0.0;
  cox_acc_Ve_di_Tempt_GND=0.0;
#endif
cox_acc_Vge_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vge_si_Vge_e=0.0;
  cox_acc_Vge_si_Vdi_si=0.0;
  cox_acc_Vge_si_Ve_si=0.0;
  cox_acc_Vge_si_Ve_di=0.0;
  cox_acc_Vge_si_Vge_si=0.0;
  cox_acc_Vge_si_Tempt_GND=0.0;
#endif
cox_acc_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  cox_acc_Tempt_GND_Vge_e=0.0;
  cox_acc_Tempt_GND_Vdi_si=0.0;
  cox_acc_Tempt_GND_Ve_si=0.0;
  cox_acc_Tempt_GND_Ve_di=0.0;
  cox_acc_Tempt_GND_Vge_si=0.0;
  cox_acc_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
cox_acc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
CGSO_i=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
CGDO_i=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qb_acc_Vge_di=0.0;
#if defined(_DERIVATE2)
  qb_acc_Vge_di_Vge_di=0.0;
  qb_acc_Vge_di_Vge_e=0.0;
  qb_acc_Vge_di_Ve_si=0.0;
  qb_acc_Vge_di_Ve_di=0.0;
  qb_acc_Vge_di_Vge_si=0.0;
  qb_acc_Vge_di_Vdi_si=0.0;
  qb_acc_Vge_di_Tempt_GND=0.0;
#endif
qb_acc_Vge_e=0.0;
#if defined(_DERIVATE2)
  qb_acc_Vge_e_Vge_di=0.0;
  qb_acc_Vge_e_Vge_e=0.0;
  qb_acc_Vge_e_Ve_si=0.0;
  qb_acc_Vge_e_Ve_di=0.0;
  qb_acc_Vge_e_Vge_si=0.0;
  qb_acc_Vge_e_Vdi_si=0.0;
  qb_acc_Vge_e_Tempt_GND=0.0;
#endif
qb_acc_Ve_si=0.0;
#if defined(_DERIVATE2)
  qb_acc_Ve_si_Vge_di=0.0;
  qb_acc_Ve_si_Vge_e=0.0;
  qb_acc_Ve_si_Ve_si=0.0;
  qb_acc_Ve_si_Ve_di=0.0;
  qb_acc_Ve_si_Vge_si=0.0;
  qb_acc_Ve_si_Vdi_si=0.0;
  qb_acc_Ve_si_Tempt_GND=0.0;
#endif
qb_acc_Ve_di=0.0;
#if defined(_DERIVATE2)
  qb_acc_Ve_di_Vge_di=0.0;
  qb_acc_Ve_di_Vge_e=0.0;
  qb_acc_Ve_di_Ve_si=0.0;
  qb_acc_Ve_di_Ve_di=0.0;
  qb_acc_Ve_di_Vge_si=0.0;
  qb_acc_Ve_di_Vdi_si=0.0;
  qb_acc_Ve_di_Tempt_GND=0.0;
#endif
qb_acc_Vge_si=0.0;
#if defined(_DERIVATE2)
  qb_acc_Vge_si_Vge_di=0.0;
  qb_acc_Vge_si_Vge_e=0.0;
  qb_acc_Vge_si_Ve_si=0.0;
  qb_acc_Vge_si_Ve_di=0.0;
  qb_acc_Vge_si_Vge_si=0.0;
  qb_acc_Vge_si_Vdi_si=0.0;
  qb_acc_Vge_si_Tempt_GND=0.0;
#endif
qb_acc_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qb_acc_Vdi_si_Vge_di=0.0;
  qb_acc_Vdi_si_Vge_e=0.0;
  qb_acc_Vdi_si_Ve_si=0.0;
  qb_acc_Vdi_si_Ve_di=0.0;
  qb_acc_Vdi_si_Vge_si=0.0;
  qb_acc_Vdi_si_Vdi_si=0.0;
  qb_acc_Vdi_si_Tempt_GND=0.0;
#endif
#if defined(_DERIVATE)
qb_acc_Tempt_GND=0.0;
#endif
#endif
qb_acc=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_acc_Vge_di=0.0;
#if defined(_DERIVATE2)
  qg_acc_Vge_di_Vge_di=0.0;
  qg_acc_Vge_di_Vge_e=0.0;
  qg_acc_Vge_di_Ve_si=0.0;
  qg_acc_Vge_di_Ve_di=0.0;
  qg_acc_Vge_di_Vge_si=0.0;
  qg_acc_Vge_di_Vdi_si=0.0;
  qg_acc_Vge_di_Tempt_GND=0.0;
#endif
qg_acc_Vge_e=0.0;
#if defined(_DERIVATE2)
  qg_acc_Vge_e_Vge_di=0.0;
  qg_acc_Vge_e_Vge_e=0.0;
  qg_acc_Vge_e_Ve_si=0.0;
  qg_acc_Vge_e_Ve_di=0.0;
  qg_acc_Vge_e_Vge_si=0.0;
  qg_acc_Vge_e_Vdi_si=0.0;
  qg_acc_Vge_e_Tempt_GND=0.0;
#endif
qg_acc_Ve_si=0.0;
#if defined(_DERIVATE2)
  qg_acc_Ve_si_Vge_di=0.0;
  qg_acc_Ve_si_Vge_e=0.0;
  qg_acc_Ve_si_Ve_si=0.0;
  qg_acc_Ve_si_Ve_di=0.0;
  qg_acc_Ve_si_Vge_si=0.0;
  qg_acc_Ve_si_Vdi_si=0.0;
  qg_acc_Ve_si_Tempt_GND=0.0;
#endif
qg_acc_Ve_di=0.0;
#if defined(_DERIVATE2)
  qg_acc_Ve_di_Vge_di=0.0;
  qg_acc_Ve_di_Vge_e=0.0;
  qg_acc_Ve_di_Ve_si=0.0;
  qg_acc_Ve_di_Ve_di=0.0;
  qg_acc_Ve_di_Vge_si=0.0;
  qg_acc_Ve_di_Vdi_si=0.0;
  qg_acc_Ve_di_Tempt_GND=0.0;
#endif
qg_acc_Vge_si=0.0;
#if defined(_DERIVATE2)
  qg_acc_Vge_si_Vge_di=0.0;
  qg_acc_Vge_si_Vge_e=0.0;
  qg_acc_Vge_si_Ve_si=0.0;
  qg_acc_Vge_si_Ve_di=0.0;
  qg_acc_Vge_si_Vge_si=0.0;
  qg_acc_Vge_si_Vdi_si=0.0;
  qg_acc_Vge_si_Tempt_GND=0.0;
#endif
qg_acc_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qg_acc_Vdi_si_Vge_di=0.0;
  qg_acc_Vdi_si_Vge_e=0.0;
  qg_acc_Vdi_si_Ve_si=0.0;
  qg_acc_Vdi_si_Ve_di=0.0;
  qg_acc_Vdi_si_Vge_si=0.0;
  qg_acc_Vdi_si_Vdi_si=0.0;
  qg_acc_Vdi_si_Tempt_GND=0.0;
#endif
qg_acc_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qg_acc_Tempt_GND_Vge_di=0.0;
  qg_acc_Tempt_GND_Vge_e=0.0;
  qg_acc_Tempt_GND_Ve_si=0.0;
  qg_acc_Tempt_GND_Ve_di=0.0;
  qg_acc_Tempt_GND_Vge_si=0.0;
  qg_acc_Tempt_GND_Vdi_si=0.0;
  qg_acc_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qg_acc=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_fr_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_s_Vge_s=0.0;
  qgs_fr_Vge_s_Vge_di=0.0;
  qgs_fr_Vge_s_Vge_e=0.0;
  qgs_fr_Vge_s_Ve_si=0.0;
  qgs_fr_Vge_s_Ve_di=0.0;
  qgs_fr_Vge_s_Vge_si=0.0;
  qgs_fr_Vge_s_Vdi_si=0.0;
  qgs_fr_Vge_s_Tempt_GND=0.0;
#endif
qgs_fr_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_di_Vge_s=0.0;
  qgs_fr_Vge_di_Vge_di=0.0;
  qgs_fr_Vge_di_Vge_e=0.0;
  qgs_fr_Vge_di_Ve_si=0.0;
  qgs_fr_Vge_di_Ve_di=0.0;
  qgs_fr_Vge_di_Vge_si=0.0;
  qgs_fr_Vge_di_Vdi_si=0.0;
  qgs_fr_Vge_di_Tempt_GND=0.0;
#endif
qgs_fr_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_e_Vge_s=0.0;
  qgs_fr_Vge_e_Vge_di=0.0;
  qgs_fr_Vge_e_Vge_e=0.0;
  qgs_fr_Vge_e_Ve_si=0.0;
  qgs_fr_Vge_e_Ve_di=0.0;
  qgs_fr_Vge_e_Vge_si=0.0;
  qgs_fr_Vge_e_Vdi_si=0.0;
  qgs_fr_Vge_e_Tempt_GND=0.0;
#endif
qgs_fr_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Ve_si_Vge_s=0.0;
  qgs_fr_Ve_si_Vge_di=0.0;
  qgs_fr_Ve_si_Vge_e=0.0;
  qgs_fr_Ve_si_Ve_si=0.0;
  qgs_fr_Ve_si_Ve_di=0.0;
  qgs_fr_Ve_si_Vge_si=0.0;
  qgs_fr_Ve_si_Vdi_si=0.0;
  qgs_fr_Ve_si_Tempt_GND=0.0;
#endif
qgs_fr_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Ve_di_Vge_s=0.0;
  qgs_fr_Ve_di_Vge_di=0.0;
  qgs_fr_Ve_di_Vge_e=0.0;
  qgs_fr_Ve_di_Ve_si=0.0;
  qgs_fr_Ve_di_Ve_di=0.0;
  qgs_fr_Ve_di_Vge_si=0.0;
  qgs_fr_Ve_di_Vdi_si=0.0;
  qgs_fr_Ve_di_Tempt_GND=0.0;
#endif
qgs_fr_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_si_Vge_s=0.0;
  qgs_fr_Vge_si_Vge_di=0.0;
  qgs_fr_Vge_si_Vge_e=0.0;
  qgs_fr_Vge_si_Ve_si=0.0;
  qgs_fr_Vge_si_Ve_di=0.0;
  qgs_fr_Vge_si_Vge_si=0.0;
  qgs_fr_Vge_si_Vdi_si=0.0;
  qgs_fr_Vge_si_Tempt_GND=0.0;
#endif
qgs_fr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vdi_si_Vge_s=0.0;
  qgs_fr_Vdi_si_Vge_di=0.0;
  qgs_fr_Vdi_si_Vge_e=0.0;
  qgs_fr_Vdi_si_Ve_si=0.0;
  qgs_fr_Vdi_si_Ve_di=0.0;
  qgs_fr_Vdi_si_Vge_si=0.0;
  qgs_fr_Vdi_si_Vdi_si=0.0;
  qgs_fr_Vdi_si_Tempt_GND=0.0;
#endif
qgs_fr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Tempt_GND_Vge_s=0.0;
  qgs_fr_Tempt_GND_Vge_di=0.0;
  qgs_fr_Tempt_GND_Vge_e=0.0;
  qgs_fr_Tempt_GND_Ve_si=0.0;
  qgs_fr_Tempt_GND_Ve_di=0.0;
  qgs_fr_Tempt_GND_Vge_si=0.0;
  qgs_fr_Tempt_GND_Vdi_si=0.0;
  qgs_fr_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgs_fr=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_fr_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_d_Vge_d=0.0;
  qgd_fr_Vge_d_Vge_di=0.0;
  qgd_fr_Vge_d_Vge_e=0.0;
  qgd_fr_Vge_d_Ve_si=0.0;
  qgd_fr_Vge_d_Ve_di=0.0;
  qgd_fr_Vge_d_Vge_si=0.0;
  qgd_fr_Vge_d_Vdi_si=0.0;
  qgd_fr_Vge_d_Tempt_GND=0.0;
#endif
qgd_fr_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_di_Vge_d=0.0;
  qgd_fr_Vge_di_Vge_di=0.0;
  qgd_fr_Vge_di_Vge_e=0.0;
  qgd_fr_Vge_di_Ve_si=0.0;
  qgd_fr_Vge_di_Ve_di=0.0;
  qgd_fr_Vge_di_Vge_si=0.0;
  qgd_fr_Vge_di_Vdi_si=0.0;
  qgd_fr_Vge_di_Tempt_GND=0.0;
#endif
qgd_fr_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_e_Vge_d=0.0;
  qgd_fr_Vge_e_Vge_di=0.0;
  qgd_fr_Vge_e_Vge_e=0.0;
  qgd_fr_Vge_e_Ve_si=0.0;
  qgd_fr_Vge_e_Ve_di=0.0;
  qgd_fr_Vge_e_Vge_si=0.0;
  qgd_fr_Vge_e_Vdi_si=0.0;
  qgd_fr_Vge_e_Tempt_GND=0.0;
#endif
qgd_fr_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Ve_si_Vge_d=0.0;
  qgd_fr_Ve_si_Vge_di=0.0;
  qgd_fr_Ve_si_Vge_e=0.0;
  qgd_fr_Ve_si_Ve_si=0.0;
  qgd_fr_Ve_si_Ve_di=0.0;
  qgd_fr_Ve_si_Vge_si=0.0;
  qgd_fr_Ve_si_Vdi_si=0.0;
  qgd_fr_Ve_si_Tempt_GND=0.0;
#endif
qgd_fr_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Ve_di_Vge_d=0.0;
  qgd_fr_Ve_di_Vge_di=0.0;
  qgd_fr_Ve_di_Vge_e=0.0;
  qgd_fr_Ve_di_Ve_si=0.0;
  qgd_fr_Ve_di_Ve_di=0.0;
  qgd_fr_Ve_di_Vge_si=0.0;
  qgd_fr_Ve_di_Vdi_si=0.0;
  qgd_fr_Ve_di_Tempt_GND=0.0;
#endif
qgd_fr_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_si_Vge_d=0.0;
  qgd_fr_Vge_si_Vge_di=0.0;
  qgd_fr_Vge_si_Vge_e=0.0;
  qgd_fr_Vge_si_Ve_si=0.0;
  qgd_fr_Vge_si_Ve_di=0.0;
  qgd_fr_Vge_si_Vge_si=0.0;
  qgd_fr_Vge_si_Vdi_si=0.0;
  qgd_fr_Vge_si_Tempt_GND=0.0;
#endif
qgd_fr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vdi_si_Vge_d=0.0;
  qgd_fr_Vdi_si_Vge_di=0.0;
  qgd_fr_Vdi_si_Vge_e=0.0;
  qgd_fr_Vdi_si_Ve_si=0.0;
  qgd_fr_Vdi_si_Ve_di=0.0;
  qgd_fr_Vdi_si_Vge_si=0.0;
  qgd_fr_Vdi_si_Vdi_si=0.0;
  qgd_fr_Vdi_si_Tempt_GND=0.0;
#endif
qgd_fr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Tempt_GND_Vge_d=0.0;
  qgd_fr_Tempt_GND_Vge_di=0.0;
  qgd_fr_Tempt_GND_Vge_e=0.0;
  qgd_fr_Tempt_GND_Ve_si=0.0;
  qgd_fr_Tempt_GND_Ve_di=0.0;
  qgd_fr_Tempt_GND_Vge_si=0.0;
  qgd_fr_Tempt_GND_Vdi_si=0.0;
  qgd_fr_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgd_fr=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(d,s) ddxprobe= */
qds_fr_Vd_s=0.0;
#endif
qds_fr=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_parasitic_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_s_Vge_s=0.0;
  qgs_parasitic_Vge_s_Vge_di=0.0;
  qgs_parasitic_Vge_s_Vge_e=0.0;
  qgs_parasitic_Vge_s_Ve_si=0.0;
  qgs_parasitic_Vge_s_Ve_di=0.0;
  qgs_parasitic_Vge_s_Vge_si=0.0;
  qgs_parasitic_Vge_s_Vdi_si=0.0;
  qgs_parasitic_Vge_s_Tempt_GND=0.0;
#endif
qgs_parasitic_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_di_Vge_s=0.0;
  qgs_parasitic_Vge_di_Vge_di=0.0;
  qgs_parasitic_Vge_di_Vge_e=0.0;
  qgs_parasitic_Vge_di_Ve_si=0.0;
  qgs_parasitic_Vge_di_Ve_di=0.0;
  qgs_parasitic_Vge_di_Vge_si=0.0;
  qgs_parasitic_Vge_di_Vdi_si=0.0;
  qgs_parasitic_Vge_di_Tempt_GND=0.0;
#endif
qgs_parasitic_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_e_Vge_s=0.0;
  qgs_parasitic_Vge_e_Vge_di=0.0;
  qgs_parasitic_Vge_e_Vge_e=0.0;
  qgs_parasitic_Vge_e_Ve_si=0.0;
  qgs_parasitic_Vge_e_Ve_di=0.0;
  qgs_parasitic_Vge_e_Vge_si=0.0;
  qgs_parasitic_Vge_e_Vdi_si=0.0;
  qgs_parasitic_Vge_e_Tempt_GND=0.0;
#endif
qgs_parasitic_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_si_Vge_s=0.0;
  qgs_parasitic_Ve_si_Vge_di=0.0;
  qgs_parasitic_Ve_si_Vge_e=0.0;
  qgs_parasitic_Ve_si_Ve_si=0.0;
  qgs_parasitic_Ve_si_Ve_di=0.0;
  qgs_parasitic_Ve_si_Vge_si=0.0;
  qgs_parasitic_Ve_si_Vdi_si=0.0;
  qgs_parasitic_Ve_si_Tempt_GND=0.0;
#endif
qgs_parasitic_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_di_Vge_s=0.0;
  qgs_parasitic_Ve_di_Vge_di=0.0;
  qgs_parasitic_Ve_di_Vge_e=0.0;
  qgs_parasitic_Ve_di_Ve_si=0.0;
  qgs_parasitic_Ve_di_Ve_di=0.0;
  qgs_parasitic_Ve_di_Vge_si=0.0;
  qgs_parasitic_Ve_di_Vdi_si=0.0;
  qgs_parasitic_Ve_di_Tempt_GND=0.0;
#endif
qgs_parasitic_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_si_Vge_s=0.0;
  qgs_parasitic_Vge_si_Vge_di=0.0;
  qgs_parasitic_Vge_si_Vge_e=0.0;
  qgs_parasitic_Vge_si_Ve_si=0.0;
  qgs_parasitic_Vge_si_Ve_di=0.0;
  qgs_parasitic_Vge_si_Vge_si=0.0;
  qgs_parasitic_Vge_si_Vdi_si=0.0;
  qgs_parasitic_Vge_si_Tempt_GND=0.0;
#endif
qgs_parasitic_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vdi_si_Vge_s=0.0;
  qgs_parasitic_Vdi_si_Vge_di=0.0;
  qgs_parasitic_Vdi_si_Vge_e=0.0;
  qgs_parasitic_Vdi_si_Ve_si=0.0;
  qgs_parasitic_Vdi_si_Ve_di=0.0;
  qgs_parasitic_Vdi_si_Vge_si=0.0;
  qgs_parasitic_Vdi_si_Vdi_si=0.0;
  qgs_parasitic_Vdi_si_Tempt_GND=0.0;
#endif
qgs_parasitic_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Tempt_GND_Vge_s=0.0;
  qgs_parasitic_Tempt_GND_Vge_di=0.0;
  qgs_parasitic_Tempt_GND_Vge_e=0.0;
  qgs_parasitic_Tempt_GND_Ve_si=0.0;
  qgs_parasitic_Tempt_GND_Ve_di=0.0;
  qgs_parasitic_Tempt_GND_Vge_si=0.0;
  qgs_parasitic_Tempt_GND_Vdi_si=0.0;
  qgs_parasitic_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgs_parasitic=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_parasitic_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_d_Vge_d=0.0;
  qgd_parasitic_Vge_d_Vge_di=0.0;
  qgd_parasitic_Vge_d_Vge_e=0.0;
  qgd_parasitic_Vge_d_Ve_si=0.0;
  qgd_parasitic_Vge_d_Ve_di=0.0;
  qgd_parasitic_Vge_d_Vge_si=0.0;
  qgd_parasitic_Vge_d_Vdi_si=0.0;
  qgd_parasitic_Vge_d_Tempt_GND=0.0;
#endif
qgd_parasitic_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_di_Vge_d=0.0;
  qgd_parasitic_Vge_di_Vge_di=0.0;
  qgd_parasitic_Vge_di_Vge_e=0.0;
  qgd_parasitic_Vge_di_Ve_si=0.0;
  qgd_parasitic_Vge_di_Ve_di=0.0;
  qgd_parasitic_Vge_di_Vge_si=0.0;
  qgd_parasitic_Vge_di_Vdi_si=0.0;
  qgd_parasitic_Vge_di_Tempt_GND=0.0;
#endif
qgd_parasitic_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_e_Vge_d=0.0;
  qgd_parasitic_Vge_e_Vge_di=0.0;
  qgd_parasitic_Vge_e_Vge_e=0.0;
  qgd_parasitic_Vge_e_Ve_si=0.0;
  qgd_parasitic_Vge_e_Ve_di=0.0;
  qgd_parasitic_Vge_e_Vge_si=0.0;
  qgd_parasitic_Vge_e_Vdi_si=0.0;
  qgd_parasitic_Vge_e_Tempt_GND=0.0;
#endif
qgd_parasitic_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_si_Vge_d=0.0;
  qgd_parasitic_Ve_si_Vge_di=0.0;
  qgd_parasitic_Ve_si_Vge_e=0.0;
  qgd_parasitic_Ve_si_Ve_si=0.0;
  qgd_parasitic_Ve_si_Ve_di=0.0;
  qgd_parasitic_Ve_si_Vge_si=0.0;
  qgd_parasitic_Ve_si_Vdi_si=0.0;
  qgd_parasitic_Ve_si_Tempt_GND=0.0;
#endif
qgd_parasitic_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_di_Vge_d=0.0;
  qgd_parasitic_Ve_di_Vge_di=0.0;
  qgd_parasitic_Ve_di_Vge_e=0.0;
  qgd_parasitic_Ve_di_Ve_si=0.0;
  qgd_parasitic_Ve_di_Ve_di=0.0;
  qgd_parasitic_Ve_di_Vge_si=0.0;
  qgd_parasitic_Ve_di_Vdi_si=0.0;
  qgd_parasitic_Ve_di_Tempt_GND=0.0;
#endif
qgd_parasitic_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_si_Vge_d=0.0;
  qgd_parasitic_Vge_si_Vge_di=0.0;
  qgd_parasitic_Vge_si_Vge_e=0.0;
  qgd_parasitic_Vge_si_Ve_si=0.0;
  qgd_parasitic_Vge_si_Ve_di=0.0;
  qgd_parasitic_Vge_si_Vge_si=0.0;
  qgd_parasitic_Vge_si_Vdi_si=0.0;
  qgd_parasitic_Vge_si_Tempt_GND=0.0;
#endif
qgd_parasitic_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vdi_si_Vge_d=0.0;
  qgd_parasitic_Vdi_si_Vge_di=0.0;
  qgd_parasitic_Vdi_si_Vge_e=0.0;
  qgd_parasitic_Vdi_si_Ve_si=0.0;
  qgd_parasitic_Vdi_si_Ve_di=0.0;
  qgd_parasitic_Vdi_si_Vge_si=0.0;
  qgd_parasitic_Vdi_si_Vdi_si=0.0;
  qgd_parasitic_Vdi_si_Tempt_GND=0.0;
#endif
qgd_parasitic_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Tempt_GND_Vge_d=0.0;
  qgd_parasitic_Tempt_GND_Vge_di=0.0;
  qgd_parasitic_Tempt_GND_Vge_e=0.0;
  qgd_parasitic_Tempt_GND_Ve_si=0.0;
  qgd_parasitic_Tempt_GND_Ve_di=0.0;
  qgd_parasitic_Tempt_GND_Vge_si=0.0;
  qgd_parasitic_Tempt_GND_Vdi_si=0.0;
  qgd_parasitic_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgd_parasitic=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
FNPowerAt1Hz_Vge_di=0.0;
FNPowerAt1Hz_Vge_e=0.0;
FNPowerAt1Hz_Ve_si=0.0;
FNPowerAt1Hz_Ve_di=0.0;
FNPowerAt1Hz_Vge_si=0.0;
FNPowerAt1Hz_Vdi_si=0.0;
FNPowerAt1Hz_Tempt_GND=0.0;
FNPowerAt1Hz_Vdi_d=0.0;
FNPowerAt1Hz_Vsi_s=0.0;
#endif
FNPowerAt1Hz=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
Gtnoi_Vge_di=0.0;
Gtnoi_Vge_e=0.0;
Gtnoi_Ve_si=0.0;
Gtnoi_Ve_di=0.0;
Gtnoi_Vge_si=0.0;
Gtnoi_Vdi_si=0.0;
Gtnoi_Tempt_GND=0.0;
Gtnoi_Vdi_d=0.0;
Gtnoi_Vsi_s=0.0;
#endif
Gtnoi=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gspr_Tempt_GND=0.0;
gspr_Vsi_s=0.0;
gspr_Vge_e=0.0;
gspr_Vdi_si=0.0;
gspr_Ve_si=0.0;
gspr_Ve_di=0.0;
gspr_Vge_si=0.0;
#endif
gspr=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
gdpr_Tempt_GND=0.0;
gdpr_Vdi_d=0.0;
gdpr_Vsi_s=0.0;
gdpr_Vge_e=0.0;
gdpr_Vdi_si=0.0;
gdpr_Ve_si=0.0;
gdpr_Ve_di=0.0;
gdpr_Vge_si=0.0;
gdpr_Vge_di=0.0;
#endif
gdpr=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Dr_Tempt_GND_Tempt_GND=0.0;
  Dr_Tempt_GND_Vdi_si=0.0;
  Dr_Tempt_GND_Vge_e=0.0;
  Dr_Tempt_GND_Ve_si=0.0;
  Dr_Tempt_GND_Ve_di=0.0;
  Dr_Tempt_GND_Vge_si=0.0;
  Dr_Tempt_GND_Vge_di=0.0;
#endif
Dr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Dr_Vdi_si_Tempt_GND=0.0;
  Dr_Vdi_si_Vdi_si=0.0;
  Dr_Vdi_si_Vge_e=0.0;
  Dr_Vdi_si_Ve_si=0.0;
  Dr_Vdi_si_Ve_di=0.0;
  Dr_Vdi_si_Vge_si=0.0;
  Dr_Vdi_si_Vge_di=0.0;
#endif
Dr_Vge_e=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_e_Tempt_GND=0.0;
  Dr_Vge_e_Vdi_si=0.0;
  Dr_Vge_e_Vge_e=0.0;
  Dr_Vge_e_Ve_si=0.0;
  Dr_Vge_e_Ve_di=0.0;
  Dr_Vge_e_Vge_si=0.0;
  Dr_Vge_e_Vge_di=0.0;
#endif
Dr_Ve_si=0.0;
#if defined(_DERIVATE2)
  Dr_Ve_si_Tempt_GND=0.0;
  Dr_Ve_si_Vdi_si=0.0;
  Dr_Ve_si_Vge_e=0.0;
  Dr_Ve_si_Ve_si=0.0;
  Dr_Ve_si_Ve_di=0.0;
  Dr_Ve_si_Vge_si=0.0;
  Dr_Ve_si_Vge_di=0.0;
#endif
Dr_Ve_di=0.0;
#if defined(_DERIVATE2)
  Dr_Ve_di_Tempt_GND=0.0;
  Dr_Ve_di_Vdi_si=0.0;
  Dr_Ve_di_Vge_e=0.0;
  Dr_Ve_di_Ve_si=0.0;
  Dr_Ve_di_Ve_di=0.0;
  Dr_Ve_di_Vge_si=0.0;
  Dr_Ve_di_Vge_di=0.0;
#endif
Dr_Vge_si=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_si_Tempt_GND=0.0;
  Dr_Vge_si_Vdi_si=0.0;
  Dr_Vge_si_Vge_e=0.0;
  Dr_Vge_si_Ve_si=0.0;
  Dr_Vge_si_Ve_di=0.0;
  Dr_Vge_si_Vge_si=0.0;
  Dr_Vge_si_Vge_di=0.0;
#endif
Dr_Vge_di=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_di_Tempt_GND=0.0;
  Dr_Vge_di_Vdi_si=0.0;
  Dr_Vge_di_Vge_e=0.0;
  Dr_Vge_di_Ve_si=0.0;
  Dr_Vge_di_Ve_di=0.0;
  Dr_Vge_di_Vge_si=0.0;
  Dr_Vge_di_Vge_di=0.0;
#endif
#endif
Dr=1.0;
EXIT_IF_ISNAN(1.0)
CDSCDR_i=0.0;
EXIT_IF_ISNAN(0.0)
ETA0R_i=0.0;
EXIT_IF_ISNAN(0.0)
VSAT1R_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT1R_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSAT1R_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT1R_t=0.0;
EXIT_IF_ISNAN(0.0)
MEXPR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
MEXPR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  MEXPR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
MEXPR_t=0.0;
EXIT_IF_ISNAN(0.0)
PTWGR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
PTWGR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PTWGR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PTWGR_t=0.0;
EXIT_IF_ISNAN(0.0)
PDIBL1R_i=0.0;
EXIT_IF_ISNAN(0.0)
PDIBL2R_i=0.0;
EXIT_IF_ISNAN(0.0)
PHIBE_i=0.0;
EXIT_IF_ISNAN(0.0)
K1_i=0.0;
EXIT_IF_ISNAN(0.0)
K11_i=0.0;
EXIT_IF_ISNAN(0.0)
K2SAT_i=0.0;
EXIT_IF_ISNAN(0.0)
K2SAT1_i=0.0;
EXIT_IF_ISNAN(0.0)
KSATIVR_i=0.0;
EXIT_IF_ISNAN(0.0)
K2_i=0.0;
EXIT_IF_ISNAN(0.0)
K21_i=0.0;
EXIT_IF_ISNAN(0.0)
UC_i=0.0;
EXIT_IF_ISNAN(0.0)
UC1_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UC_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  UC_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UC_t=0.0;
EXIT_IF_ISNAN(0.0)
U0R_i=0.0;
EXIT_IF_ISNAN(0.0)
UPR_i=0.0;
EXIT_IF_ISNAN(0.0)
EUR_i=0.0;
EXIT_IF_ISNAN(0.0)
ATR_i=0.0;
EXIT_IF_ISNAN(0.0)
CITR_i=0.0;
EXIT_IF_ISNAN(0.0)
ETA0R_i=0.0;
EXIT_IF_ISNAN(0.0)
DVTP0_i=0.0;
EXIT_IF_ISNAN(0.0)
DVTP1_i=0.0;
EXIT_IF_ISNAN(0.0)
PDIBL2R_i=0.0;
EXIT_IF_ISNAN(0.0)
PCLMR_i=0.0;
EXIT_IF_ISNAN(0.0)
LeffCV_acc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RDDRR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  RDDRR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RDDRR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RSDRR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  RSDRR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RSDRR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Rdsi_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Rdsi_Tempt_GND_Tempt_GND=0.0;
  Rdsi_Tempt_GND_Vge_di=0.0;
  Rdsi_Tempt_GND_Vge_e=0.0;
  Rdsi_Tempt_GND_Ve_si=0.0;
  Rdsi_Tempt_GND_Ve_di=0.0;
  Rdsi_Tempt_GND_Vge_si=0.0;
  Rdsi_Tempt_GND_Vdi_si=0.0;
#endif
Rdsi_Vge_di=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_di_Tempt_GND=0.0;
  Rdsi_Vge_di_Vge_di=0.0;
  Rdsi_Vge_di_Vge_e=0.0;
  Rdsi_Vge_di_Ve_si=0.0;
  Rdsi_Vge_di_Ve_di=0.0;
  Rdsi_Vge_di_Vge_si=0.0;
  Rdsi_Vge_di_Vdi_si=0.0;
#endif
Rdsi_Vge_e=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_e_Tempt_GND=0.0;
  Rdsi_Vge_e_Vge_di=0.0;
  Rdsi_Vge_e_Vge_e=0.0;
  Rdsi_Vge_e_Ve_si=0.0;
  Rdsi_Vge_e_Ve_di=0.0;
  Rdsi_Vge_e_Vge_si=0.0;
  Rdsi_Vge_e_Vdi_si=0.0;
#endif
Rdsi_Ve_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Ve_si_Tempt_GND=0.0;
  Rdsi_Ve_si_Vge_di=0.0;
  Rdsi_Ve_si_Vge_e=0.0;
  Rdsi_Ve_si_Ve_si=0.0;
  Rdsi_Ve_si_Ve_di=0.0;
  Rdsi_Ve_si_Vge_si=0.0;
  Rdsi_Ve_si_Vdi_si=0.0;
#endif
Rdsi_Ve_di=0.0;
#if defined(_DERIVATE2)
  Rdsi_Ve_di_Tempt_GND=0.0;
  Rdsi_Ve_di_Vge_di=0.0;
  Rdsi_Ve_di_Vge_e=0.0;
  Rdsi_Ve_di_Ve_si=0.0;
  Rdsi_Ve_di_Ve_di=0.0;
  Rdsi_Ve_di_Vge_si=0.0;
  Rdsi_Ve_di_Vdi_si=0.0;
#endif
Rdsi_Vge_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_si_Tempt_GND=0.0;
  Rdsi_Vge_si_Vge_di=0.0;
  Rdsi_Vge_si_Vge_e=0.0;
  Rdsi_Vge_si_Ve_si=0.0;
  Rdsi_Vge_si_Ve_di=0.0;
  Rdsi_Vge_si_Vge_si=0.0;
  Rdsi_Vge_si_Vdi_si=0.0;
#endif
Rdsi_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vdi_si_Tempt_GND=0.0;
  Rdsi_Vdi_si_Vge_di=0.0;
  Rdsi_Vdi_si_Vge_e=0.0;
  Rdsi_Vdi_si_Ve_si=0.0;
  Rdsi_Vdi_si_Ve_di=0.0;
  Rdsi_Vdi_si_Vge_si=0.0;
  Rdsi_Vdi_si_Vdi_si=0.0;
#endif
#endif
Rdsi=0.0;
EXIT_IF_ISNAN(0.0)
T3y=0.0;
EXIT_IF_ISNAN(0.0)
Tcen0=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
veseff_Ve_si=0.0;
#if defined(_DERIVATE2)
  veseff_Ve_si_Ve_si=0.0;
  veseff_Ve_si_Ve_di=0.0;
  veseff_Ve_si_Vdi_si=0.0;
  veseff_Ve_si_Tempt_GND=0.0;
#endif
veseff_Ve_di=0.0;
#if defined(_DERIVATE2)
  veseff_Ve_di_Ve_si=0.0;
  veseff_Ve_di_Ve_di=0.0;
  veseff_Ve_di_Vdi_si=0.0;
  veseff_Ve_di_Tempt_GND=0.0;
#endif
veseff_Vdi_si=0.0;
#if defined(_DERIVATE2)
  veseff_Vdi_si_Ve_si=0.0;
  veseff_Vdi_si_Ve_di=0.0;
  veseff_Vdi_si_Vdi_si=0.0;
  veseff_Vdi_si_Tempt_GND=0.0;
#endif
veseff_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  veseff_Tempt_GND_Ve_si=0.0;
  veseff_Tempt_GND_Ve_di=0.0;
  veseff_Tempt_GND_Vdi_si=0.0;
  veseff_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
veseff=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
U0R_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  U0R_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
U0R_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UAR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  UAR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UAR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UCR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  UCR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UCR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UDR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  UDR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UDR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSAT_a_Tempt_GND_Tempt_GND=0.0;
  VSAT_a_Tempt_GND_Vdi_si=0.0;
#endif
VSAT_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  VSAT_a_Vdi_si_Tempt_GND=0.0;
  VSAT_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
VSAT_a=0.0;
EXIT_IF_ISNAN(0.0)
DVTSHIFTR_i=0.0;
EXIT_IF_ISNAN(0.0)
UA1R_i=0.0;
EXIT_IF_ISNAN(0.0)
UAR_i=0.0;
EXIT_IF_ISNAN(0.0)
UC1R_i=0.0;
EXIT_IF_ISNAN(0.0)
UCR_i=0.0;
EXIT_IF_ISNAN(0.0)
UD1R_i=0.0;
EXIT_IF_ISNAN(0.0)
UDR_i=0.0;
EXIT_IF_ISNAN(0.0)
UTER_i=0.0;
EXIT_IF_ISNAN(0.0)
UTLR_i=0.0;
EXIT_IF_ISNAN(0.0)
VSATR_i=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSATR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSATR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSATR_t=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
u0r_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  u0r_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
u0r=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)V(di,d)V(si,s) ddxprobe= */
sid_Tempt_GND=0.0;
sid_Vge_di=0.0;
sid_Vge_e=0.0;
sid_Ve_si=0.0;
sid_Ve_di=0.0;
sid_Vge_si=0.0;
sid_Vdi_si=0.0;
sid_Vdi_d=0.0;
sid_Vsi_s=0.0;
#endif
sid=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
ctnoi_Vge_di=0.0;
ctnoi_Vdi_d=0.0;
ctnoi_Vsi_s=0.0;
ctnoi_Vge_e=0.0;
ctnoi_Vdi_si=0.0;
ctnoi_Ve_si=0.0;
ctnoi_Ve_di=0.0;
ctnoi_Vge_si=0.0;
ctnoi_Tempt_GND=0.0;
#endif
ctnoi=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s)V(ge,e) ddxprobe= */
sf_Tempt_GND=0.0;
sf_Vdi_si=0.0;
sf_Ve_si=0.0;
sf_Ve_di=0.0;
sf_Vge_si=0.0;
sf_Vge_di=0.0;
sf_Vdi_d=0.0;
sf_Vsi_s=0.0;
sf_Vge_e=0.0;
#endif
sf=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
C0_Vge_e=0.0;
C0_Vdi_si=0.0;
C0_Ve_si=0.0;
C0_Ve_di=0.0;
C0_Vge_si=0.0;
C0_Tempt_GND=0.0;
#endif
C0=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gamma_Vge_di=0.0;
gamma_Vdi_d=0.0;
gamma_Vsi_s=0.0;
gamma_Vge_e=0.0;
gamma_Vdi_si=0.0;
gamma_Tempt_GND=0.0;
gamma_Ve_si=0.0;
gamma_Ve_di=0.0;
gamma_Vge_si=0.0;
#endif
gamma=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
delta_Vdi_d=0.0;
delta_Vsi_s=0.0;
delta_Vge_di=0.0;
delta_Vge_e=0.0;
delta_Ve_si=0.0;
delta_Ve_di=0.0;
delta_Vge_si=0.0;
delta_Vdi_si=0.0;
delta_Tempt_GND=0.0;
#endif
delta=0.0;
EXIT_IF_ISNAN(0.0)
ggeltd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=0.0;
  qm_Vdi_si_Ve_si=0.0;
  qm_Vdi_si_Ve_di=0.0;
  qm_Vdi_si_Vge_si=0.0;
  qm_Vdi_si_Tempt_GND=0.0;
#endif
qm_Ve_si=0.0;
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=0.0;
  qm_Ve_si_Ve_si=0.0;
  qm_Ve_si_Ve_di=0.0;
  qm_Ve_si_Vge_si=0.0;
  qm_Ve_si_Tempt_GND=0.0;
#endif
qm_Ve_di=0.0;
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=0.0;
  qm_Ve_di_Ve_si=0.0;
  qm_Ve_di_Ve_di=0.0;
  qm_Ve_di_Vge_si=0.0;
  qm_Ve_di_Tempt_GND=0.0;
#endif
qm_Vge_si=0.0;
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=0.0;
  qm_Vge_si_Ve_si=0.0;
  qm_Vge_si_Ve_di=0.0;
  qm_Vge_si_Vge_si=0.0;
  qm_Vge_si_Tempt_GND=0.0;
#endif
qm_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=0.0;
  qm_Tempt_GND_Ve_si=0.0;
  qm_Tempt_GND_Ve_di=0.0;
  qm_Tempt_GND_Vge_si=0.0;
  qm_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qm=1.0;
EXIT_IF_ISNAN(1.0)
Cins=1.0;
EXIT_IF_ISNAN(1.0)
Ach=1.0;
EXIT_IF_ISNAN(1.0)
Weff_UFCM=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qdep_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qdep_Tempt_GND_Tempt_GND=0.0;
  qdep_Tempt_GND_Vdi_si=0.0;
#endif
qdep_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qdep_Vdi_si_Tempt_GND=0.0;
  qdep_Vdi_si_Vdi_si=0.0;
#endif
#endif
qdep=(-1.0);
EXIT_IF_ISNAN((-1.0))
rc=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vth_fixed_factor_Sub_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  vth_fixed_factor_Sub_Tempt_GND_Tempt_GND=0.0;
  vth_fixed_factor_Sub_Tempt_GND_Vdi_si=0.0;
#endif
vth_fixed_factor_Sub_Vdi_si=0.0;
#if defined(_DERIVATE2)
  vth_fixed_factor_Sub_Vdi_si_Tempt_GND=0.0;
  vth_fixed_factor_Sub_Vdi_si_Vdi_si=0.0;
#endif
#endif
vth_fixed_factor_Sub=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vth_fixed_factor_SI_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  vth_fixed_factor_SI_Tempt_GND_Tempt_GND=0.0;
  vth_fixed_factor_SI_Tempt_GND_Vdi_si=0.0;
#endif
vth_fixed_factor_SI_Vdi_si=0.0;
#if defined(_DERIVATE2)
  vth_fixed_factor_SI_Vdi_si_Tempt_GND=0.0;
  vth_fixed_factor_SI_Vdi_si_Vdi_si=0.0;
#endif
#endif
vth_fixed_factor_SI=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qi_acc_for_QM_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Tempt_GND_Tempt_GND=0.0;
  qi_acc_for_QM_Tempt_GND_Vdi_si=0.0;
  qi_acc_for_QM_Tempt_GND_Vge_e=0.0;
  qi_acc_for_QM_Tempt_GND_Ve_si=0.0;
  qi_acc_for_QM_Tempt_GND_Ve_di=0.0;
  qi_acc_for_QM_Tempt_GND_Vge_si=0.0;
#endif
qi_acc_for_QM_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vdi_si_Tempt_GND=0.0;
  qi_acc_for_QM_Vdi_si_Vdi_si=0.0;
  qi_acc_for_QM_Vdi_si_Vge_e=0.0;
  qi_acc_for_QM_Vdi_si_Ve_si=0.0;
  qi_acc_for_QM_Vdi_si_Ve_di=0.0;
  qi_acc_for_QM_Vdi_si_Vge_si=0.0;
#endif
qi_acc_for_QM_Vge_e=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vge_e_Tempt_GND=0.0;
  qi_acc_for_QM_Vge_e_Vdi_si=0.0;
  qi_acc_for_QM_Vge_e_Vge_e=0.0;
  qi_acc_for_QM_Vge_e_Ve_si=0.0;
  qi_acc_for_QM_Vge_e_Ve_di=0.0;
  qi_acc_for_QM_Vge_e_Vge_si=0.0;
#endif
qi_acc_for_QM_Ve_si=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Ve_si_Tempt_GND=0.0;
  qi_acc_for_QM_Ve_si_Vdi_si=0.0;
  qi_acc_for_QM_Ve_si_Vge_e=0.0;
  qi_acc_for_QM_Ve_si_Ve_si=0.0;
  qi_acc_for_QM_Ve_si_Ve_di=0.0;
  qi_acc_for_QM_Ve_si_Vge_si=0.0;
#endif
qi_acc_for_QM_Ve_di=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Ve_di_Tempt_GND=0.0;
  qi_acc_for_QM_Ve_di_Vdi_si=0.0;
  qi_acc_for_QM_Ve_di_Vge_e=0.0;
  qi_acc_for_QM_Ve_di_Ve_si=0.0;
  qi_acc_for_QM_Ve_di_Ve_di=0.0;
  qi_acc_for_QM_Ve_di_Vge_si=0.0;
#endif
qi_acc_for_QM_Vge_si=0.0;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vge_si_Tempt_GND=0.0;
  qi_acc_for_QM_Vge_si_Vdi_si=0.0;
  qi_acc_for_QM_Vge_si_Vge_e=0.0;
  qi_acc_for_QM_Vge_si_Ve_si=0.0;
  qi_acc_for_QM_Vge_si_Ve_di=0.0;
  qi_acc_for_QM_Vge_si_Vge_si=0.0;
#endif
#endif
qi_acc_for_QM=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
fieldnormalizationfactor_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  fieldnormalizationfactor_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
fieldnormalizationfactor=0.0;
EXIT_IF_ISNAN(0.0)
auxQMfact=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
QMFACTORCVfinal_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  QMFACTORCVfinal_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
QMFACTORCVfinal=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
psipclamp_Vge_e=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vge_e_Vge_e=0.0;
  psipclamp_Vge_e_Vdi_si=0.0;
  psipclamp_Vge_e_Ve_si=0.0;
  psipclamp_Vge_e_Ve_di=0.0;
  psipclamp_Vge_e_Vge_si=0.0;
  psipclamp_Vge_e_Tempt_GND=0.0;
#endif
psipclamp_Vdi_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vdi_si_Vge_e=0.0;
  psipclamp_Vdi_si_Vdi_si=0.0;
  psipclamp_Vdi_si_Ve_si=0.0;
  psipclamp_Vdi_si_Ve_di=0.0;
  psipclamp_Vdi_si_Vge_si=0.0;
  psipclamp_Vdi_si_Tempt_GND=0.0;
#endif
psipclamp_Ve_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Ve_si_Vge_e=0.0;
  psipclamp_Ve_si_Vdi_si=0.0;
  psipclamp_Ve_si_Ve_si=0.0;
  psipclamp_Ve_si_Ve_di=0.0;
  psipclamp_Ve_si_Vge_si=0.0;
  psipclamp_Ve_si_Tempt_GND=0.0;
#endif
psipclamp_Ve_di=0.0;
#if defined(_DERIVATE2)
  psipclamp_Ve_di_Vge_e=0.0;
  psipclamp_Ve_di_Vdi_si=0.0;
  psipclamp_Ve_di_Ve_si=0.0;
  psipclamp_Ve_di_Ve_di=0.0;
  psipclamp_Ve_di_Vge_si=0.0;
  psipclamp_Ve_di_Tempt_GND=0.0;
#endif
psipclamp_Vge_si=0.0;
#if defined(_DERIVATE2)
  psipclamp_Vge_si_Vge_e=0.0;
  psipclamp_Vge_si_Vdi_si=0.0;
  psipclamp_Vge_si_Ve_si=0.0;
  psipclamp_Vge_si_Ve_di=0.0;
  psipclamp_Vge_si_Vge_si=0.0;
  psipclamp_Vge_si_Tempt_GND=0.0;
#endif
psipclamp_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  psipclamp_Tempt_GND_Vge_e=0.0;
  psipclamp_Tempt_GND_Vdi_si=0.0;
  psipclamp_Tempt_GND_Ve_si=0.0;
  psipclamp_Tempt_GND_Ve_di=0.0;
  psipclamp_Tempt_GND_Vge_si=0.0;
  psipclamp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
psipclamp=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
sqrtpsip_Vge_e=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vge_e_Vge_e=0.0;
  sqrtpsip_Vge_e_Vdi_si=0.0;
  sqrtpsip_Vge_e_Ve_si=0.0;
  sqrtpsip_Vge_e_Ve_di=0.0;
  sqrtpsip_Vge_e_Vge_si=0.0;
  sqrtpsip_Vge_e_Tempt_GND=0.0;
#endif
sqrtpsip_Vdi_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_si_Vge_e=0.0;
  sqrtpsip_Vdi_si_Vdi_si=0.0;
  sqrtpsip_Vdi_si_Ve_si=0.0;
  sqrtpsip_Vdi_si_Ve_di=0.0;
  sqrtpsip_Vdi_si_Vge_si=0.0;
  sqrtpsip_Vdi_si_Tempt_GND=0.0;
#endif
sqrtpsip_Ve_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Ve_si_Vge_e=0.0;
  sqrtpsip_Ve_si_Vdi_si=0.0;
  sqrtpsip_Ve_si_Ve_si=0.0;
  sqrtpsip_Ve_si_Ve_di=0.0;
  sqrtpsip_Ve_si_Vge_si=0.0;
  sqrtpsip_Ve_si_Tempt_GND=0.0;
#endif
sqrtpsip_Ve_di=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Ve_di_Vge_e=0.0;
  sqrtpsip_Ve_di_Vdi_si=0.0;
  sqrtpsip_Ve_di_Ve_si=0.0;
  sqrtpsip_Ve_di_Ve_di=0.0;
  sqrtpsip_Ve_di_Vge_si=0.0;
  sqrtpsip_Ve_di_Tempt_GND=0.0;
#endif
sqrtpsip_Vge_si=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Vge_si_Vge_e=0.0;
  sqrtpsip_Vge_si_Vdi_si=0.0;
  sqrtpsip_Vge_si_Ve_si=0.0;
  sqrtpsip_Vge_si_Ve_di=0.0;
  sqrtpsip_Vge_si_Vge_si=0.0;
  sqrtpsip_Vge_si_Tempt_GND=0.0;
#endif
sqrtpsip_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  sqrtpsip_Tempt_GND_Vge_e=0.0;
  sqrtpsip_Tempt_GND_Vdi_si=0.0;
  sqrtpsip_Tempt_GND_Ve_si=0.0;
  sqrtpsip_Tempt_GND_Ve_di=0.0;
  sqrtpsip_Tempt_GND_Vge_si=0.0;
  sqrtpsip_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
sqrtpsip=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
nq_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  nq_Tempt_GND_Tempt_GND=0.0;
  nq_Tempt_GND_Vdi_si=0.0;
  nq_Tempt_GND_Vge_e=0.0;
  nq_Tempt_GND_Ve_si=0.0;
  nq_Tempt_GND_Ve_di=0.0;
  nq_Tempt_GND_Vge_si=0.0;
#endif
nq_Vdi_si=0.0;
#if defined(_DERIVATE2)
  nq_Vdi_si_Tempt_GND=0.0;
  nq_Vdi_si_Vdi_si=0.0;
  nq_Vdi_si_Vge_e=0.0;
  nq_Vdi_si_Ve_si=0.0;
  nq_Vdi_si_Ve_di=0.0;
  nq_Vdi_si_Vge_si=0.0;
#endif
nq_Vge_e=0.0;
#if defined(_DERIVATE2)
  nq_Vge_e_Tempt_GND=0.0;
  nq_Vge_e_Vdi_si=0.0;
  nq_Vge_e_Vge_e=0.0;
  nq_Vge_e_Ve_si=0.0;
  nq_Vge_e_Ve_di=0.0;
  nq_Vge_e_Vge_si=0.0;
#endif
nq_Ve_si=0.0;
#if defined(_DERIVATE2)
  nq_Ve_si_Tempt_GND=0.0;
  nq_Ve_si_Vdi_si=0.0;
  nq_Ve_si_Vge_e=0.0;
  nq_Ve_si_Ve_si=0.0;
  nq_Ve_si_Ve_di=0.0;
  nq_Ve_si_Vge_si=0.0;
#endif
nq_Ve_di=0.0;
#if defined(_DERIVATE2)
  nq_Ve_di_Tempt_GND=0.0;
  nq_Ve_di_Vdi_si=0.0;
  nq_Ve_di_Vge_e=0.0;
  nq_Ve_di_Ve_si=0.0;
  nq_Ve_di_Ve_di=0.0;
  nq_Ve_di_Vge_si=0.0;
#endif
nq_Vge_si=0.0;
#if defined(_DERIVATE2)
  nq_Vge_si_Tempt_GND=0.0;
  nq_Vge_si_Vdi_si=0.0;
  nq_Vge_si_Vge_e=0.0;
  nq_Vge_si_Ve_si=0.0;
  nq_Vge_si_Ve_di=0.0;
  nq_Vge_si_Vge_si=0.0;
#endif
#endif
nq=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
F0_Vge_si=0.0;
#if defined(_DERIVATE2)
  F0_Vge_si_Vge_si=0.0;
  F0_Vge_si_Ve_si=0.0;
  F0_Vge_si_Ve_di=0.0;
  F0_Vge_si_Vdi_si=0.0;
  F0_Vge_si_Tempt_GND=0.0;
#endif
F0_Ve_si=0.0;
#if defined(_DERIVATE2)
  F0_Ve_si_Vge_si=0.0;
  F0_Ve_si_Ve_si=0.0;
  F0_Ve_si_Ve_di=0.0;
  F0_Ve_si_Vdi_si=0.0;
  F0_Ve_si_Tempt_GND=0.0;
#endif
F0_Ve_di=0.0;
#if defined(_DERIVATE2)
  F0_Ve_di_Vge_si=0.0;
  F0_Ve_di_Ve_si=0.0;
  F0_Ve_di_Ve_di=0.0;
  F0_Ve_di_Vdi_si=0.0;
  F0_Ve_di_Tempt_GND=0.0;
#endif
F0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  F0_Vdi_si_Vge_si=0.0;
  F0_Vdi_si_Ve_si=0.0;
  F0_Vdi_si_Ve_di=0.0;
  F0_Vdi_si_Vdi_si=0.0;
  F0_Vdi_si_Tempt_GND=0.0;
#endif
F0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  F0_Tempt_GND_Vge_si=0.0;
  F0_Tempt_GND_Ve_si=0.0;
  F0_Tempt_GND_Ve_di=0.0;
  F0_Tempt_GND_Vdi_si=0.0;
  F0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
F0=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=0.0;
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=0.0;
  e0_Vge_e_Vge_si=0.0;
  e0_Vge_e_Ve_si=0.0;
  e0_Vge_e_Ve_di=0.0;
  e0_Vge_e_Vdi_si=0.0;
  e0_Vge_e_Tempt_GND=0.0;
#endif
e0_Vge_si=0.0;
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=0.0;
  e0_Vge_si_Vge_si=0.0;
  e0_Vge_si_Ve_si=0.0;
  e0_Vge_si_Ve_di=0.0;
  e0_Vge_si_Vdi_si=0.0;
  e0_Vge_si_Tempt_GND=0.0;
#endif
e0_Ve_si=0.0;
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=0.0;
  e0_Ve_si_Vge_si=0.0;
  e0_Ve_si_Ve_si=0.0;
  e0_Ve_si_Ve_di=0.0;
  e0_Ve_si_Vdi_si=0.0;
  e0_Ve_si_Tempt_GND=0.0;
#endif
e0_Ve_di=0.0;
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=0.0;
  e0_Ve_di_Vge_si=0.0;
  e0_Ve_di_Ve_si=0.0;
  e0_Ve_di_Ve_di=0.0;
  e0_Ve_di_Vdi_si=0.0;
  e0_Ve_di_Tempt_GND=0.0;
#endif
e0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=0.0;
  e0_Vdi_si_Vge_si=0.0;
  e0_Vdi_si_Ve_si=0.0;
  e0_Vdi_si_Ve_di=0.0;
  e0_Vdi_si_Vdi_si=0.0;
  e0_Vdi_si_Tempt_GND=0.0;
#endif
e0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=0.0;
  e0_Tempt_GND_Vge_si=0.0;
  e0_Tempt_GND_Ve_si=0.0;
  e0_Tempt_GND_Ve_di=0.0;
  e0_Tempt_GND_Vdi_si=0.0;
  e0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
e0=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=0.0;
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=0.0;
  e1_Vge_e_Vdi_si=0.0;
  e1_Vge_e_Ve_si=0.0;
  e1_Vge_e_Ve_di=0.0;
  e1_Vge_e_Vge_si=0.0;
  e1_Vge_e_Tempt_GND=0.0;
#endif
e1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=0.0;
  e1_Vdi_si_Vdi_si=0.0;
  e1_Vdi_si_Ve_si=0.0;
  e1_Vdi_si_Ve_di=0.0;
  e1_Vdi_si_Vge_si=0.0;
  e1_Vdi_si_Tempt_GND=0.0;
#endif
e1_Ve_si=0.0;
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=0.0;
  e1_Ve_si_Vdi_si=0.0;
  e1_Ve_si_Ve_si=0.0;
  e1_Ve_si_Ve_di=0.0;
  e1_Ve_si_Vge_si=0.0;
  e1_Ve_si_Tempt_GND=0.0;
#endif
e1_Ve_di=0.0;
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=0.0;
  e1_Ve_di_Vdi_si=0.0;
  e1_Ve_di_Ve_si=0.0;
  e1_Ve_di_Ve_di=0.0;
  e1_Ve_di_Vge_si=0.0;
  e1_Ve_di_Tempt_GND=0.0;
#endif
e1_Vge_si=0.0;
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=0.0;
  e1_Vge_si_Vdi_si=0.0;
  e1_Vge_si_Ve_si=0.0;
  e1_Vge_si_Ve_di=0.0;
  e1_Vge_si_Vge_si=0.0;
  e1_Vge_si_Tempt_GND=0.0;
#endif
e1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=0.0;
  e1_Tempt_GND_Vdi_si=0.0;
  e1_Tempt_GND_Ve_si=0.0;
  e1_Tempt_GND_Ve_di=0.0;
  e1_Tempt_GND_Vge_si=0.0;
  e1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
e1=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
e2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  e2_Vdi_si_Vdi_si=0.0;
  e2_Vdi_si_Ve_si=0.0;
  e2_Vdi_si_Ve_di=0.0;
  e2_Vdi_si_Vge_si=0.0;
  e2_Vdi_si_Tempt_GND=0.0;
#endif
e2_Ve_si=0.0;
#if defined(_DERIVATE2)
  e2_Ve_si_Vdi_si=0.0;
  e2_Ve_si_Ve_si=0.0;
  e2_Ve_si_Ve_di=0.0;
  e2_Ve_si_Vge_si=0.0;
  e2_Ve_si_Tempt_GND=0.0;
#endif
e2_Ve_di=0.0;
#if defined(_DERIVATE2)
  e2_Ve_di_Vdi_si=0.0;
  e2_Ve_di_Ve_si=0.0;
  e2_Ve_di_Ve_di=0.0;
  e2_Ve_di_Vge_si=0.0;
  e2_Ve_di_Tempt_GND=0.0;
#endif
e2_Vge_si=0.0;
#if defined(_DERIVATE2)
  e2_Vge_si_Vdi_si=0.0;
  e2_Vge_si_Ve_si=0.0;
  e2_Vge_si_Ve_di=0.0;
  e2_Vge_si_Vge_si=0.0;
  e2_Vge_si_Tempt_GND=0.0;
#endif
e2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  e2_Tempt_GND_Vdi_si=0.0;
  e2_Tempt_GND_Ve_si=0.0;
  e2_Tempt_GND_Ve_di=0.0;
  e2_Tempt_GND_Vge_si=0.0;
  e2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
e2=0.0;
EXIT_IF_ISNAN(0.0)
Qdep_ov_Cins=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->TYPE==1))
{
devsign=1;
EXIT_IF_ISNAN(1)
}
else
{
devsign=(-1);
EXIT_IF_ISNAN((-1))
}
epssub=(pModel->EPSRSUB*8.8542e-12);
EXIT_IF_ISNAN((pModel->EPSRSUB*8.8542e-12))
epssp=(pModel->EPSRSP*8.8542e-12);
EXIT_IF_ISNAN((pModel->EPSRSP*8.8542e-12))
#if defined(_DYNAMIC)
cbox=((pModel->EPSROX*8.8542e-12)/pModel->EOTBOX);
EXIT_IF_ISNAN(((pModel->EPSROX*8.8542e-12)/pModel->EOTBOX))
#endif
epsratio=(pModel->EPSRSUB/pModel->EPSROX);
EXIT_IF_ISNAN((pModel->EPSRSUB/pModel->EPSROX))
if
(((here->tNode_connected /* port_connected 12 */)==1))
{
if
((pModel->SHMOD==0))
{
if
((pModel->SH_WARN==1))
{
printf("The optional 5th terminal is present but not active because SHMOD=0.");
printf("\n");
}
}
}
mx=(0.916*9.11e-31);
EXIT_IF_ISNAN((0.916*9.11e-31))
mxprime=(0.190*9.11e-31);
EXIT_IF_ISNAN((0.190*9.11e-31))
md=(0.190*9.11e-31);
EXIT_IF_ISNAN((0.190*9.11e-31))
mdprime=(0.417*9.11e-31);
EXIT_IF_ISNAN((0.417*9.11e-31))
gprime=4.0;
EXIT_IF_ISNAN(4.0)
gfactor=2.0;
EXIT_IF_ISNAN(2.0)
Lg=(pInst->L+pModel->XL);
EXIT_IF_ISNAN((pInst->L+pModel->XL))
{
double m00_pow(d00_pow0,Lg,(-pModel->LLN))
deltaL=(pModel->LINT+(pModel->LL*d00_pow0));
EXIT_IF_ISNAN((pModel->LINT+(pModel->LL*d00_pow0)))
}
{
double m00_pow(d00_pow0,(Lg+pModel->DLBIN),(-pModel->LLN))
deltaL1=(pModel->LINT+(pModel->LL*d00_pow0));
EXIT_IF_ISNAN((pModel->LINT+(pModel->LL*d00_pow0)))
}
{
double m00_pow(d00_pow0,Lg,(-pModel->LLN))
deltaLCV=(pModel->DLC+(pModel->LLC*d00_pow0));
EXIT_IF_ISNAN((pModel->DLC+(pModel->LLC*d00_pow0)))
}
Leff=(Lg-(2.0*deltaL));
EXIT_IF_ISNAN((Lg-(2.0*deltaL)))
Leff1=((Lg+pModel->DLBIN)-(2.0*deltaL1));
EXIT_IF_ISNAN(((Lg+pModel->DLBIN)-(2.0*deltaL1)))
LeffCV=(Lg-(2.0*deltaLCV));
EXIT_IF_ISNAN((Lg-(2.0*deltaLCV)))
if
((pModel->BULKMOD!=0))
{
LeffCV_acc=(LeffCV-pModel->DLCACC);
EXIT_IF_ISNAN((LeffCV-pModel->DLCACC))
}
NFINtotal=(pInst->NFIN*pInst->NF);
EXIT_IF_ISNAN((pInst->NFIN*pInst->NF))
if
((Leff<=0.0))
{
printf("Fatal: Leff = %e is not positive.",Leff);
printf("\n");
controlled_exit(0);
}
else
{
if
((Leff<=1.0e-9))
{
printf("Warning: Leff = %e <= 1.0e-9.",Leff);
printf("\n");
}
}
if
((Leff1<=0.0))
{
printf("Fatal: Leff1 = %e is not positive.",Leff1);
printf("\n");
controlled_exit(0);
}
else
{
if
((Leff1<=1.0e-9))
{
printf("Warning: Leff1 = %e <= 1.0e-9.",Leff1);
printf("\n");
}
}
Inv_L=(1.0e-6/Leff1);
EXIT_IF_ISNAN((1.0e-6/Leff1))
Inv_NFIN=(1.0/pInst->NFIN);
EXIT_IF_ISNAN((1.0/pInst->NFIN))
Inv_LNFIN=(1.0e-6/(Leff1*pInst->NFIN));
EXIT_IF_ISNAN((1.0e-6/(Leff1*pInst->NFIN)))
NBODY_i=(((pModel->NBODY+(Inv_L*pModel->LNBODY))+(Inv_NFIN*pModel->NNBODY))+(Inv_LNFIN*pModel->PNBODY));
EXIT_IF_ISNAN((((pModel->NBODY+(Inv_L*pModel->LNBODY))+(Inv_NFIN*pModel->NNBODY))+(Inv_LNFIN*pModel->PNBODY)))
if
((pModel->NBODYN1!=0.0))
{
NBODY_i=(NBODY_i*(1.0+((pModel->NBODYN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->NBODYN2))))));
EXIT_IF_ISNAN((NBODY_i*(1.0+((pModel->NBODYN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->NBODYN2)))))))
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pModel->GEOMOD)==(0)))
{
if
(((!(model->TFIN_TOP_Given))||(!(model->TFIN_BASE_Given))))
{
Weff_UFCM=(2.0*pModel->HFIN);
EXIT_IF_ISNAN((2.0*pModel->HFIN))
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=(pModel->HFIN*pInst->TFIN);
EXIT_IF_ISNAN((pModel->HFIN*pInst->TFIN))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
else
{
{
double m00_sqrt(d00_sqrt0,((pModel->HFIN*pModel->HFIN)+(((pModel->TFIN_TOP-pModel->TFIN_BASE)*(pModel->TFIN_TOP-pModel->TFIN_BASE))/4.0)))
Weff_UFCM=(2.0*d00_sqrt0);
EXIT_IF_ISNAN((2.0*d00_sqrt0))
}
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0);
EXIT_IF_ISNAN(((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
}
else
/* CASE ITEM */
if
(((pModel->GEOMOD)==(1)))
{
if
(((!(model->TFIN_TOP_Given))||(!(model->TFIN_BASE_Given))))
{
Weff_UFCM=((2.0*pModel->HFIN)+pInst->TFIN);
EXIT_IF_ISNAN(((2.0*pModel->HFIN)+pInst->TFIN))
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=(pModel->HFIN*pInst->TFIN);
EXIT_IF_ISNAN((pModel->HFIN*pInst->TFIN))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
else
{
{
double m00_sqrt(d00_sqrt0,((pModel->HFIN*pModel->HFIN)+(((pModel->TFIN_TOP-pModel->TFIN_BASE)*(pModel->TFIN_TOP-pModel->TFIN_BASE))/4.0)))
Weff_UFCM=((2.0*d00_sqrt0)+pModel->TFIN_TOP);
EXIT_IF_ISNAN(((2.0*d00_sqrt0)+pModel->TFIN_TOP))
}
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0);
EXIT_IF_ISNAN(((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
}
else
/* CASE ITEM */
if
(((pModel->GEOMOD)==(2)))
{
if
(((!(model->TFIN_TOP_Given))||(!(model->TFIN_BASE_Given))))
{
Weff_UFCM=((2.0*pModel->HFIN)+(2.0*pInst->TFIN));
EXIT_IF_ISNAN(((2.0*pModel->HFIN)+(2.0*pInst->TFIN)))
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=(pModel->HFIN*pInst->TFIN);
EXIT_IF_ISNAN((pModel->HFIN*pInst->TFIN))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
else
{
{
double m00_sqrt(d00_sqrt0,((pModel->HFIN*pModel->HFIN)+(((pModel->TFIN_TOP-pModel->TFIN_BASE)*(pModel->TFIN_TOP-pModel->TFIN_BASE))/4.0)))
Weff_UFCM=(((2.0*d00_sqrt0)+pModel->TFIN_TOP)+pModel->TFIN_BASE);
EXIT_IF_ISNAN((((2.0*d00_sqrt0)+pModel->TFIN_TOP)+pModel->TFIN_BASE))
}
Cins=(((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT);
EXIT_IF_ISNAN((((Weff_UFCM*pModel->EPSROX)*8.8542e-12)/pModel->EOT))
Ach=((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0);
EXIT_IF_ISNAN(((pModel->HFIN*(pModel->TFIN_TOP+pModel->TFIN_BASE))/2.0))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
}
else
/* CASE ITEM */
if
(((pModel->GEOMOD)==(3)))
{
Weff_UFCM=(3.14159265358979323846*pInst->D);
EXIT_IF_ISNAN((3.14159265358979323846*pInst->D))
{
double m00_logE(d00_logE0,(1.0+((2.0*pModel->EOT)/pInst->D)))
Cins=((((2.0*3.14159265358979323846)*pModel->EPSROX)*8.8542e-12)/d00_logE0);
EXIT_IF_ISNAN(((((2.0*3.14159265358979323846)*pModel->EPSROX)*8.8542e-12)/d00_logE0))
}
Ach=(((3.14159265358979323846*pInst->D)*pInst->D)/4.0);
EXIT_IF_ISNAN((((3.14159265358979323846*pInst->D)*pInst->D)/4.0))
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
else
/* CASE ITEM */
if
(((pModel->GEOMOD)==(4)))
{
Weff_UFCM=pModel->W_UFCM;
EXIT_IF_ISNAN(pModel->W_UFCM)
Cins=pModel->CINS_UFCM;
EXIT_IF_ISNAN(pModel->CINS_UFCM)
Ach=pModel->ACH_UFCM;
EXIT_IF_ISNAN(pModel->ACH_UFCM)
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
EXIT_IF_ISNAN(((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach)))
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
EXIT_IF_ISNAN(((((-1.60219e-19)*NBODY_i)*Ach)/Cins))
}
else
{ /* no default */ }
/* -- CASE END -- */;
cox=(Cins/Weff_UFCM);
EXIT_IF_ISNAN((Cins/Weff_UFCM))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
cox_acc_Vge_e=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vge_e_Vge_e=0.0;
  cox_acc_Vge_e_Vdi_si=0.0;
  cox_acc_Vge_e_Ve_si=0.0;
  cox_acc_Vge_e_Ve_di=0.0;
  cox_acc_Vge_e_Vge_si=0.0;
  cox_acc_Vge_e_Tempt_GND=0.0;
#endif
cox_acc_Vdi_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vdi_si_Vge_e=0.0;
  cox_acc_Vdi_si_Vdi_si=0.0;
  cox_acc_Vdi_si_Ve_si=0.0;
  cox_acc_Vdi_si_Ve_di=0.0;
  cox_acc_Vdi_si_Vge_si=0.0;
  cox_acc_Vdi_si_Tempt_GND=0.0;
#endif
cox_acc_Ve_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Ve_si_Vge_e=0.0;
  cox_acc_Ve_si_Vdi_si=0.0;
  cox_acc_Ve_si_Ve_si=0.0;
  cox_acc_Ve_si_Ve_di=0.0;
  cox_acc_Ve_si_Vge_si=0.0;
  cox_acc_Ve_si_Tempt_GND=0.0;
#endif
cox_acc_Ve_di=0.0;
#if defined(_DERIVATE2)
  cox_acc_Ve_di_Vge_e=0.0;
  cox_acc_Ve_di_Vdi_si=0.0;
  cox_acc_Ve_di_Ve_si=0.0;
  cox_acc_Ve_di_Ve_di=0.0;
  cox_acc_Ve_di_Vge_si=0.0;
  cox_acc_Ve_di_Tempt_GND=0.0;
#endif
cox_acc_Vge_si=0.0;
#if defined(_DERIVATE2)
  cox_acc_Vge_si_Vge_e=0.0;
  cox_acc_Vge_si_Vdi_si=0.0;
  cox_acc_Vge_si_Ve_si=0.0;
  cox_acc_Vge_si_Ve_di=0.0;
  cox_acc_Vge_si_Vge_si=0.0;
  cox_acc_Vge_si_Tempt_GND=0.0;
#endif
cox_acc_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  cox_acc_Tempt_GND_Vge_e=0.0;
  cox_acc_Tempt_GND_Vdi_si=0.0;
  cox_acc_Tempt_GND_Ve_si=0.0;
  cox_acc_Tempt_GND_Ve_di=0.0;
  cox_acc_Tempt_GND_Vge_si=0.0;
  cox_acc_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
cox_acc=((cox*pModel->EOT)/pModel->EOTACC);
EXIT_IF_ISNAN(((cox*pModel->EOT)/pModel->EOTACC))
}
Weff0=(Weff_UFCM-pModel->DELTAW);
EXIT_IF_ISNAN((Weff_UFCM-pModel->DELTAW))
WeffCV0=(Weff_UFCM-pModel->DELTAWCV);
EXIT_IF_ISNAN((Weff_UFCM-pModel->DELTAWCV))
{
double m00_sqrt(d00_sqrt0,(((epssub*Ach)/Cins)*(1.0+((Ach*Cins)/(((2.0*epssub)*Weff_UFCM)*Weff_UFCM)))))
scl=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
PHIG_i=(((pModel->PHIG+(Inv_L*pModel->LPHIG))+(Inv_NFIN*pModel->NPHIG))+(Inv_LNFIN*pModel->PPHIG));
EXIT_IF_ISNAN((((pModel->PHIG+(Inv_L*pModel->LPHIG))+(Inv_NFIN*pModel->NPHIG))+(Inv_LNFIN*pModel->PPHIG)))
NGATE_i=(((pModel->NGATE+(Inv_L*pModel->LNGATE))+(Inv_NFIN*pModel->NNGATE))+(Inv_LNFIN*pModel->PNGATE));
EXIT_IF_ISNAN((((pModel->NGATE+(Inv_L*pModel->LNGATE))+(Inv_NFIN*pModel->NNGATE))+(Inv_LNFIN*pModel->PNGATE)))
CIT_i=(((pModel->CIT+(Inv_L*pModel->LCIT))+(Inv_NFIN*pModel->NCIT))+(Inv_LNFIN*pModel->PCIT));
EXIT_IF_ISNAN((((pModel->CIT+(Inv_L*pModel->LCIT))+(Inv_NFIN*pModel->NCIT))+(Inv_LNFIN*pModel->PCIT)))
CDSC_i=(((pModel->CDSC+(Inv_L*pModel->LCDSC))+(Inv_NFIN*pModel->NCDSC))+(Inv_LNFIN*pModel->PCDSC));
EXIT_IF_ISNAN((((pModel->CDSC+(Inv_L*pModel->LCDSC))+(Inv_NFIN*pModel->NCDSC))+(Inv_LNFIN*pModel->PCDSC)))
CDSCD_i=(((pModel->CDSCD+(Inv_L*pModel->LCDSCD))+(Inv_NFIN*pModel->NCDSCD))+(Inv_LNFIN*pModel->PCDSCD));
EXIT_IF_ISNAN((((pModel->CDSCD+(Inv_L*pModel->LCDSCD))+(Inv_NFIN*pModel->NCDSCD))+(Inv_LNFIN*pModel->PCDSCD)))
DVT0_i=(((pModel->DVT0+(Inv_L*pModel->LDVT0))+(Inv_NFIN*pModel->NDVT0))+(Inv_LNFIN*pModel->PDVT0));
EXIT_IF_ISNAN((((pModel->DVT0+(Inv_L*pModel->LDVT0))+(Inv_NFIN*pModel->NDVT0))+(Inv_LNFIN*pModel->PDVT0)))
DVT1_i=(((pModel->DVT1+(Inv_L*pModel->LDVT1))+(Inv_NFIN*pModel->NDVT1))+(Inv_LNFIN*pModel->PDVT1));
EXIT_IF_ISNAN((((pModel->DVT1+(Inv_L*pModel->LDVT1))+(Inv_NFIN*pModel->NDVT1))+(Inv_LNFIN*pModel->PDVT1)))
DVT1SS_i=(((pModel->DVT1SS+(Inv_L*pModel->LDVT1SS))+(Inv_NFIN*pModel->NDVT1SS))+(Inv_LNFIN*pModel->PDVT1SS));
EXIT_IF_ISNAN((((pModel->DVT1SS+(Inv_L*pModel->LDVT1SS))+(Inv_NFIN*pModel->NDVT1SS))+(Inv_LNFIN*pModel->PDVT1SS)))
PHIN_i=(((pModel->PHIN+(Inv_L*pModel->LPHIN))+(Inv_NFIN*pModel->NPHIN))+(Inv_LNFIN*pModel->PPHIN));
EXIT_IF_ISNAN((((pModel->PHIN+(Inv_L*pModel->LPHIN))+(Inv_NFIN*pModel->NPHIN))+(Inv_LNFIN*pModel->PPHIN)))
ETA0_i=(((pModel->ETA0+(Inv_L*pModel->LETA0))+(Inv_NFIN*pModel->NETA0))+(Inv_LNFIN*pModel->PETA0));
EXIT_IF_ISNAN((((pModel->ETA0+(Inv_L*pModel->LETA0))+(Inv_NFIN*pModel->NETA0))+(Inv_LNFIN*pModel->PETA0)))
DSUB_i=(((pModel->DSUB+(Inv_L*pModel->LDSUB))+(Inv_NFIN*pModel->NDSUB))+(Inv_LNFIN*pModel->PDSUB));
EXIT_IF_ISNAN((((pModel->DSUB+(Inv_L*pModel->LDSUB))+(Inv_NFIN*pModel->NDSUB))+(Inv_LNFIN*pModel->PDSUB)))
K1RSCE_i=(((pModel->K1RSCE+(Inv_L*pModel->LK1RSCE))+(Inv_NFIN*pModel->NK1RSCE))+(Inv_LNFIN*pModel->PK1RSCE));
EXIT_IF_ISNAN((((pModel->K1RSCE+(Inv_L*pModel->LK1RSCE))+(Inv_NFIN*pModel->NK1RSCE))+(Inv_LNFIN*pModel->PK1RSCE)))
LPE0_i=(((pModel->LPE0+(Inv_L*pModel->LLPE0))+(Inv_NFIN*pModel->NLPE0))+(Inv_LNFIN*pModel->PLPE0));
EXIT_IF_ISNAN((((pModel->LPE0+(Inv_L*pModel->LLPE0))+(Inv_NFIN*pModel->NLPE0))+(Inv_LNFIN*pModel->PLPE0)))
DVTSHIFT_i=(((pModel->DVTSHIFT+(Inv_L*pModel->LDVTSHIFT))+(Inv_NFIN*pModel->NDVTSHIFT))+(Inv_LNFIN*pModel->PDVTSHIFT));
EXIT_IF_ISNAN((((pModel->DVTSHIFT+(Inv_L*pModel->LDVTSHIFT))+(Inv_NFIN*pModel->NDVTSHIFT))+(Inv_LNFIN*pModel->PDVTSHIFT)))
K0_i=(((pModel->K0+(Inv_L*pModel->LK0))+(Inv_NFIN*pModel->NK0))+(Inv_LNFIN*pModel->PK0));
EXIT_IF_ISNAN((((pModel->K0+(Inv_L*pModel->LK0))+(Inv_NFIN*pModel->NK0))+(Inv_LNFIN*pModel->PK0)))
K01_i=(((pModel->K01+(Inv_L*pModel->LK01))+(Inv_NFIN*pModel->NK01))+(Inv_LNFIN*pModel->PK01));
EXIT_IF_ISNAN((((pModel->K01+(Inv_L*pModel->LK01))+(Inv_NFIN*pModel->NK01))+(Inv_LNFIN*pModel->PK01)))
K0SI_i=(((pModel->K0SI+(Inv_L*pModel->LK0SI))+(Inv_NFIN*pModel->NK0SI))+(Inv_LNFIN*pModel->PK0SI));
EXIT_IF_ISNAN((((pModel->K0SI+(Inv_L*pModel->LK0SI))+(Inv_NFIN*pModel->NK0SI))+(Inv_LNFIN*pModel->PK0SI)))
K0SI1_i=(((pModel->K0SI1+(Inv_L*pModel->LK0SI1))+(Inv_NFIN*pModel->NK0SI1))+(Inv_LNFIN*pModel->PK0SI1));
EXIT_IF_ISNAN((((pModel->K0SI1+(Inv_L*pModel->LK0SI1))+(Inv_NFIN*pModel->NK0SI1))+(Inv_LNFIN*pModel->PK0SI1)))
K2SI_i=(((pModel->K2SI+(Inv_L*pModel->LK2SI))+(Inv_NFIN*pModel->NK2SI))+(Inv_LNFIN*pModel->PK2SI));
EXIT_IF_ISNAN((((pModel->K2SI+(Inv_L*pModel->LK2SI))+(Inv_NFIN*pModel->NK2SI))+(Inv_LNFIN*pModel->PK2SI)))
K2SI1_i=(((pModel->K2SI1+(Inv_L*pModel->LK2SI1))+(Inv_NFIN*pModel->NK2SI1))+(Inv_LNFIN*pModel->PK2SI1));
EXIT_IF_ISNAN((((pModel->K2SI1+(Inv_L*pModel->LK2SI1))+(Inv_NFIN*pModel->NK2SI1))+(Inv_LNFIN*pModel->PK2SI1)))
K0SISAT_i=(((pModel->K0SISAT+(Inv_L*pModel->LK0SISAT))+(Inv_NFIN*pModel->NK0SISAT))+(Inv_LNFIN*pModel->PK0SISAT));
EXIT_IF_ISNAN((((pModel->K0SISAT+(Inv_L*pModel->LK0SISAT))+(Inv_NFIN*pModel->NK0SISAT))+(Inv_LNFIN*pModel->PK0SISAT)))
K0SISAT1_i=(((pModel->K0SISAT1+(Inv_L*pModel->LK0SISAT1))+(Inv_NFIN*pModel->NK0SISAT1))+(Inv_LNFIN*pModel->PK0SISAT1));
EXIT_IF_ISNAN((((pModel->K0SISAT1+(Inv_L*pModel->LK0SISAT1))+(Inv_NFIN*pModel->NK0SISAT1))+(Inv_LNFIN*pModel->PK0SISAT1)))
K2SISAT_i=(((pModel->K2SISAT+(Inv_L*pModel->LK2SISAT))+(Inv_NFIN*pModel->NK2SISAT))+(Inv_LNFIN*pModel->PK2SISAT));
EXIT_IF_ISNAN((((pModel->K2SISAT+(Inv_L*pModel->LK2SISAT))+(Inv_NFIN*pModel->NK2SISAT))+(Inv_LNFIN*pModel->PK2SISAT)))
K2SISAT1_i=(((pModel->K2SISAT1+(Inv_L*pModel->LK2SISAT1))+(Inv_NFIN*pModel->NK2SISAT1))+(Inv_LNFIN*pModel->PK2SISAT1));
EXIT_IF_ISNAN((((pModel->K2SISAT1+(Inv_L*pModel->LK2SISAT1))+(Inv_NFIN*pModel->NK2SISAT1))+(Inv_LNFIN*pModel->PK2SISAT1)))
if
((pModel->BULKMOD!=0))
{
if
((pModel->BULKMOD==2))
{
K2_i=(((pModel->K2+(Inv_L*pModel->LK2))+(Inv_NFIN*pModel->NK2))+(Inv_LNFIN*pModel->PK2));
EXIT_IF_ISNAN((((pModel->K2+(Inv_L*pModel->LK2))+(Inv_NFIN*pModel->NK2))+(Inv_LNFIN*pModel->PK2)))
K21_i=(((pModel->K21+(Inv_L*pModel->LK21))+(Inv_NFIN*pModel->NK21))+(Inv_LNFIN*pModel->PK21));
EXIT_IF_ISNAN((((pModel->K21+(Inv_L*pModel->LK21))+(Inv_NFIN*pModel->NK21))+(Inv_LNFIN*pModel->PK21)))
K2SAT_i=(((pModel->K2SAT+(Inv_L*pModel->LK2SAT))+(Inv_NFIN*pModel->NK2SAT))+(Inv_LNFIN*pModel->PK2SAT));
EXIT_IF_ISNAN((((pModel->K2SAT+(Inv_L*pModel->LK2SAT))+(Inv_NFIN*pModel->NK2SAT))+(Inv_LNFIN*pModel->PK2SAT)))
K2SAT1_i=(((pModel->K2SAT1+(Inv_L*pModel->LK2SAT1))+(Inv_NFIN*pModel->NK2SAT1))+(Inv_LNFIN*pModel->PK2SAT1));
EXIT_IF_ISNAN((((pModel->K2SAT1+(Inv_L*pModel->LK2SAT1))+(Inv_NFIN*pModel->NK2SAT1))+(Inv_LNFIN*pModel->PK2SAT1)))
}
PHIBE_i=(((pModel->PHIBE+(Inv_L*pModel->LPHIBE))+(Inv_NFIN*pModel->NPHIBE))+(Inv_LNFIN*pModel->PPHIBE));
EXIT_IF_ISNAN((((pModel->PHIBE+(Inv_L*pModel->LPHIBE))+(Inv_NFIN*pModel->NPHIBE))+(Inv_LNFIN*pModel->PPHIBE)))
K1_i=(((pModel->K1+(Inv_L*pModel->LK1))+(Inv_NFIN*pModel->NK1))+(Inv_LNFIN*pModel->PK1));
EXIT_IF_ISNAN((((pModel->K1+(Inv_L*pModel->LK1))+(Inv_NFIN*pModel->NK1))+(Inv_LNFIN*pModel->PK1)))
K11_i=(((pModel->K11+(Inv_L*pModel->LK11))+(Inv_NFIN*pModel->NK11))+(Inv_LNFIN*pModel->PK11));
EXIT_IF_ISNAN((((pModel->K11+(Inv_L*pModel->LK11))+(Inv_NFIN*pModel->NK11))+(Inv_LNFIN*pModel->PK11)))
}
QMFACTOR_i=(((pModel->QMFACTOR+(Inv_L*pModel->LQMFACTOR))+(Inv_NFIN*pModel->NQMFACTOR))+(Inv_LNFIN*pModel->PQMFACTOR));
EXIT_IF_ISNAN((((pModel->QMFACTOR+(Inv_L*pModel->LQMFACTOR))+(Inv_NFIN*pModel->NQMFACTOR))+(Inv_LNFIN*pModel->PQMFACTOR)))
QMTCENCV_i=(((pModel->QMTCENCV+(Inv_L*pModel->LQMTCENCV))+(Inv_NFIN*pModel->NQMTCENCV))+(Inv_LNFIN*pModel->PQMTCENCV));
EXIT_IF_ISNAN((((pModel->QMTCENCV+(Inv_L*pModel->LQMTCENCV))+(Inv_NFIN*pModel->NQMTCENCV))+(Inv_LNFIN*pModel->PQMTCENCV)))
QMTCENCVA_i=(((pModel->QMTCENCVA+(Inv_L*pModel->LQMTCENCVA))+(Inv_NFIN*pModel->NQMTCENCVA))+(Inv_LNFIN*pModel->PQMTCENCVA));
EXIT_IF_ISNAN((((pModel->QMTCENCVA+(Inv_L*pModel->LQMTCENCVA))+(Inv_NFIN*pModel->NQMTCENCVA))+(Inv_LNFIN*pModel->PQMTCENCVA)))
VSAT_i=(((pModel->VSAT+(Inv_L*pModel->LVSAT))+(Inv_NFIN*pModel->NVSAT))+(Inv_LNFIN*pModel->PVSAT));
EXIT_IF_ISNAN((((pModel->VSAT+(Inv_L*pModel->LVSAT))+(Inv_NFIN*pModel->NVSAT))+(Inv_LNFIN*pModel->PVSAT)))
VSAT1_i=(((pModel->VSAT1+(Inv_L*pModel->LVSAT1))+(Inv_NFIN*pModel->NVSAT1))+(Inv_LNFIN*pModel->PVSAT1));
EXIT_IF_ISNAN((((pModel->VSAT1+(Inv_L*pModel->LVSAT1))+(Inv_NFIN*pModel->NVSAT1))+(Inv_LNFIN*pModel->PVSAT1)))
VSATCV_i=(((pModel->VSATCV+(Inv_L*pModel->LVSATCV))+(Inv_NFIN*pModel->NVSATCV))+(Inv_LNFIN*pModel->PVSATCV));
EXIT_IF_ISNAN((((pModel->VSATCV+(Inv_L*pModel->LVSATCV))+(Inv_NFIN*pModel->NVSATCV))+(Inv_LNFIN*pModel->PVSATCV)))
DELTAVSAT_i=(((pModel->DELTAVSAT+(Inv_L*pModel->LDELTAVSAT))+(Inv_NFIN*pModel->NDELTAVSAT))+(Inv_LNFIN*pModel->PDELTAVSAT));
EXIT_IF_ISNAN((((pModel->DELTAVSAT+(Inv_L*pModel->LDELTAVSAT))+(Inv_NFIN*pModel->NDELTAVSAT))+(Inv_LNFIN*pModel->PDELTAVSAT)))
PSAT_i=(((pModel->PSAT+(Inv_L*pModel->LPSAT))+(Inv_NFIN*pModel->NPSAT))+(Inv_LNFIN*pModel->PPSAT));
EXIT_IF_ISNAN((((pModel->PSAT+(Inv_L*pModel->LPSAT))+(Inv_NFIN*pModel->NPSAT))+(Inv_LNFIN*pModel->PPSAT)))
DELTAVSATCV_i=(((pModel->DELTAVSATCV+(Inv_L*pModel->LDELTAVSATCV))+(Inv_NFIN*pModel->NDELTAVSATCV))+(Inv_LNFIN*pModel->PDELTAVSATCV));
EXIT_IF_ISNAN((((pModel->DELTAVSATCV+(Inv_L*pModel->LDELTAVSATCV))+(Inv_NFIN*pModel->NDELTAVSATCV))+(Inv_LNFIN*pModel->PDELTAVSATCV)))
PSATCV_i=(((pModel->PSATCV+(Inv_L*pModel->LPSATCV))+(Inv_NFIN*pModel->NPSATCV))+(Inv_LNFIN*pModel->PPSATCV));
EXIT_IF_ISNAN((((pModel->PSATCV+(Inv_L*pModel->LPSATCV))+(Inv_NFIN*pModel->NPSATCV))+(Inv_LNFIN*pModel->PPSATCV)))
KSATIV_i=(((pModel->KSATIV+(Inv_L*pModel->LKSATIV))+(Inv_NFIN*pModel->NKSATIV))+(Inv_LNFIN*pModel->PKSATIV));
EXIT_IF_ISNAN((((pModel->KSATIV+(Inv_L*pModel->LKSATIV))+(Inv_NFIN*pModel->NKSATIV))+(Inv_LNFIN*pModel->PKSATIV)))
MEXP_i=(((pModel->MEXP+(Inv_L*pModel->LMEXP))+(Inv_NFIN*pModel->NMEXP))+(Inv_LNFIN*pModel->PMEXP));
EXIT_IF_ISNAN((((pModel->MEXP+(Inv_L*pModel->LMEXP))+(Inv_NFIN*pModel->NMEXP))+(Inv_LNFIN*pModel->PMEXP)))
PTWG_i=(((pModel->PTWG+(Inv_L*pModel->LPTWG))+(Inv_NFIN*pModel->NPTWG))+(Inv_LNFIN*pModel->PPTWG));
EXIT_IF_ISNAN((((pModel->PTWG+(Inv_L*pModel->LPTWG))+(Inv_NFIN*pModel->NPTWG))+(Inv_LNFIN*pModel->PPTWG)))
U0_i=(((pModel->U0+(Inv_L*pModel->LU0))+(Inv_NFIN*pModel->NU0))+(Inv_LNFIN*pModel->PU0));
EXIT_IF_ISNAN((((pModel->U0+(Inv_L*pModel->LU0))+(Inv_NFIN*pModel->NU0))+(Inv_LNFIN*pModel->PU0)))
ETAMOB_i=(((pModel->ETAMOB+(Inv_L*pModel->LETAMOB))+(Inv_NFIN*pModel->NETAMOB))+(Inv_LNFIN*pModel->PETAMOB));
EXIT_IF_ISNAN((((pModel->ETAMOB+(Inv_L*pModel->LETAMOB))+(Inv_NFIN*pModel->NETAMOB))+(Inv_LNFIN*pModel->PETAMOB)))
UP_i=(((pModel->UP+(Inv_L*pModel->LUP))+(Inv_NFIN*pModel->NUP))+(Inv_LNFIN*pModel->PUP));
EXIT_IF_ISNAN((((pModel->UP+(Inv_L*pModel->LUP))+(Inv_NFIN*pModel->NUP))+(Inv_LNFIN*pModel->PUP)))
UA_i=(((pModel->UA+(Inv_L*pModel->LUA))+(Inv_NFIN*pModel->NUA))+(Inv_LNFIN*pModel->PUA));
EXIT_IF_ISNAN((((pModel->UA+(Inv_L*pModel->LUA))+(Inv_NFIN*pModel->NUA))+(Inv_LNFIN*pModel->PUA)))
if
((pModel->BULKMOD!=0))
{
UC_i=(((pModel->UC+(Inv_L*pModel->LUC))+(Inv_NFIN*pModel->NUC))+(Inv_LNFIN*pModel->PUC));
EXIT_IF_ISNAN((((pModel->UC+(Inv_L*pModel->LUC))+(Inv_NFIN*pModel->NUC))+(Inv_LNFIN*pModel->PUC)))
}
EU_i=(((pModel->EU+(Inv_L*pModel->LEU))+(Inv_NFIN*pModel->NEU))+(Inv_LNFIN*pModel->PEU));
EXIT_IF_ISNAN((((pModel->EU+(Inv_L*pModel->LEU))+(Inv_NFIN*pModel->NEU))+(Inv_LNFIN*pModel->PEU)))
UD_i=(((pModel->UD+(Inv_L*pModel->LUD))+(Inv_NFIN*pModel->NUD))+(Inv_LNFIN*pModel->PUD));
EXIT_IF_ISNAN((((pModel->UD+(Inv_L*pModel->LUD))+(Inv_NFIN*pModel->NUD))+(Inv_LNFIN*pModel->PUD)))
UCS_i=(((pModel->UCS+(Inv_L*pModel->LUCS))+(Inv_NFIN*pModel->NUCS))+(Inv_LNFIN*pModel->PUCS));
EXIT_IF_ISNAN((((pModel->UCS+(Inv_L*pModel->LUCS))+(Inv_NFIN*pModel->NUCS))+(Inv_LNFIN*pModel->PUCS)))
PCLM_i=(((pModel->PCLM+(Inv_L*pModel->LPCLM))+(Inv_NFIN*pModel->NPCLM))+(Inv_LNFIN*pModel->PPCLM));
EXIT_IF_ISNAN((((pModel->PCLM+(Inv_L*pModel->LPCLM))+(Inv_NFIN*pModel->NPCLM))+(Inv_LNFIN*pModel->PPCLM)))
PCLMG_i=(((pModel->PCLMG+(Inv_L*pModel->LPCLMG))+(Inv_NFIN*pModel->NPCLMG))+(Inv_LNFIN*pModel->PPCLMG));
EXIT_IF_ISNAN((((pModel->PCLMG+(Inv_L*pModel->LPCLMG))+(Inv_NFIN*pModel->NPCLMG))+(Inv_LNFIN*pModel->PPCLMG)))
PCLMCV_i=(((pModel->PCLMCV+(Inv_L*pModel->LPCLMCV))+(Inv_NFIN*pModel->NPCLMCV))+(Inv_LNFIN*pModel->PPCLMCV));
EXIT_IF_ISNAN((((pModel->PCLMCV+(Inv_L*pModel->LPCLMCV))+(Inv_NFIN*pModel->NPCLMCV))+(Inv_LNFIN*pModel->PPCLMCV)))
A1_i=(((pModel->A1+(Inv_L*pModel->LA1))+(Inv_NFIN*pModel->NA1))+(Inv_LNFIN*pModel->PA1));
EXIT_IF_ISNAN((((pModel->A1+(Inv_L*pModel->LA1))+(Inv_NFIN*pModel->NA1))+(Inv_LNFIN*pModel->PA1)))
A11_i=(((pModel->A11+(Inv_L*pModel->LA11))+(Inv_NFIN*pModel->NA11))+(Inv_LNFIN*pModel->PA11));
EXIT_IF_ISNAN((((pModel->A11+(Inv_L*pModel->LA11))+(Inv_NFIN*pModel->NA11))+(Inv_LNFIN*pModel->PA11)))
A2_i=(((pModel->A2+(Inv_L*pModel->LA2))+(Inv_NFIN*pModel->NA2))+(Inv_LNFIN*pModel->PA2));
EXIT_IF_ISNAN((((pModel->A2+(Inv_L*pModel->LA2))+(Inv_NFIN*pModel->NA2))+(Inv_LNFIN*pModel->PA2)))
A21_i=(((pModel->A21+(Inv_L*pModel->LA21))+(Inv_NFIN*pModel->NA21))+(Inv_LNFIN*pModel->PA21));
EXIT_IF_ISNAN((((pModel->A21+(Inv_L*pModel->LA21))+(Inv_NFIN*pModel->NA21))+(Inv_LNFIN*pModel->PA21)))
RDSW_i=(((pModel->RDSW+(Inv_L*pModel->LRDSW))+(Inv_NFIN*pModel->NRDSW))+(Inv_LNFIN*pModel->PRDSW));
EXIT_IF_ISNAN((((pModel->RDSW+(Inv_L*pModel->LRDSW))+(Inv_NFIN*pModel->NRDSW))+(Inv_LNFIN*pModel->PRDSW)))
RSW_i=(((pModel->RSW+(Inv_L*pModel->LRSW))+(Inv_NFIN*pModel->NRSW))+(Inv_LNFIN*pModel->PRSW));
EXIT_IF_ISNAN((((pModel->RSW+(Inv_L*pModel->LRSW))+(Inv_NFIN*pModel->NRSW))+(Inv_LNFIN*pModel->PRSW)))
RDW_i=(((pModel->RDW+(Inv_L*pModel->LRDW))+(Inv_NFIN*pModel->NRDW))+(Inv_LNFIN*pModel->PRDW));
EXIT_IF_ISNAN((((pModel->RDW+(Inv_L*pModel->LRDW))+(Inv_NFIN*pModel->NRDW))+(Inv_LNFIN*pModel->PRDW)))
PRWGD_i=(((pModel->PRWGD+(Inv_L*pModel->LPRWGD))+(Inv_NFIN*pModel->NPRWGD))+(Inv_LNFIN*pModel->PPRWGD));
EXIT_IF_ISNAN((((pModel->PRWGD+(Inv_L*pModel->LPRWGD))+(Inv_NFIN*pModel->NPRWGD))+(Inv_LNFIN*pModel->PPRWGD)))
PRWGS_i=(((pModel->PRWGS+(Inv_L*pModel->LPRWGS))+(Inv_NFIN*pModel->NPRWGS))+(Inv_LNFIN*pModel->PPRWGS));
EXIT_IF_ISNAN((((pModel->PRWGS+(Inv_L*pModel->LPRWGS))+(Inv_NFIN*pModel->NPRWGS))+(Inv_LNFIN*pModel->PPRWGS)))
WR_i=(((pModel->WR+(Inv_L*pModel->LWR))+(Inv_NFIN*pModel->NWR))+(Inv_LNFIN*pModel->PWR));
EXIT_IF_ISNAN((((pModel->WR+(Inv_L*pModel->LWR))+(Inv_NFIN*pModel->NWR))+(Inv_LNFIN*pModel->PWR)))
PDIBL1_i=(((pModel->PDIBL1+(Inv_L*pModel->LPDIBL1))+(Inv_NFIN*pModel->NPDIBL1))+(Inv_LNFIN*pModel->PPDIBL1));
EXIT_IF_ISNAN((((pModel->PDIBL1+(Inv_L*pModel->LPDIBL1))+(Inv_NFIN*pModel->NPDIBL1))+(Inv_LNFIN*pModel->PPDIBL1)))
PDIBL2_i=(((pModel->PDIBL2+(Inv_L*pModel->LPDIBL2))+(Inv_NFIN*pModel->NPDIBL2))+(Inv_LNFIN*pModel->PPDIBL2));
EXIT_IF_ISNAN((((pModel->PDIBL2+(Inv_L*pModel->LPDIBL2))+(Inv_NFIN*pModel->NPDIBL2))+(Inv_LNFIN*pModel->PPDIBL2)))
DROUT_i=(((pModel->DROUT+(Inv_L*pModel->LDROUT))+(Inv_NFIN*pModel->NDROUT))+(Inv_LNFIN*pModel->PDROUT));
EXIT_IF_ISNAN((((pModel->DROUT+(Inv_L*pModel->LDROUT))+(Inv_NFIN*pModel->NDROUT))+(Inv_LNFIN*pModel->PDROUT)))
PVAG_i=(((pModel->PVAG+(Inv_L*pModel->LPVAG))+(Inv_NFIN*pModel->NPVAG))+(Inv_LNFIN*pModel->PPVAG));
EXIT_IF_ISNAN((((pModel->PVAG+(Inv_L*pModel->LPVAG))+(Inv_NFIN*pModel->NPVAG))+(Inv_LNFIN*pModel->PPVAG)))
AIGBINV_i=(((pModel->AIGBINV+(Inv_L*pModel->LAIGBINV))+(Inv_NFIN*pModel->NAIGBINV))+(Inv_LNFIN*pModel->PAIGBINV));
EXIT_IF_ISNAN((((pModel->AIGBINV+(Inv_L*pModel->LAIGBINV))+(Inv_NFIN*pModel->NAIGBINV))+(Inv_LNFIN*pModel->PAIGBINV)))
AIGBINV1_i=(((pModel->AIGBINV1+(Inv_L*pModel->LAIGBINV1))+(Inv_NFIN*pModel->NAIGBINV1))+(Inv_LNFIN*pModel->PAIGBINV1));
EXIT_IF_ISNAN((((pModel->AIGBINV1+(Inv_L*pModel->LAIGBINV1))+(Inv_NFIN*pModel->NAIGBINV1))+(Inv_LNFIN*pModel->PAIGBINV1)))
BIGBINV_i=(((pModel->BIGBINV+(Inv_L*pModel->LBIGBINV))+(Inv_NFIN*pModel->NBIGBINV))+(Inv_LNFIN*pModel->PBIGBINV));
EXIT_IF_ISNAN((((pModel->BIGBINV+(Inv_L*pModel->LBIGBINV))+(Inv_NFIN*pModel->NBIGBINV))+(Inv_LNFIN*pModel->PBIGBINV)))
CIGBINV_i=(((pModel->CIGBINV+(Inv_L*pModel->LCIGBINV))+(Inv_NFIN*pModel->NCIGBINV))+(Inv_LNFIN*pModel->PCIGBINV));
EXIT_IF_ISNAN((((pModel->CIGBINV+(Inv_L*pModel->LCIGBINV))+(Inv_NFIN*pModel->NCIGBINV))+(Inv_LNFIN*pModel->PCIGBINV)))
EIGBINV_i=(((pModel->EIGBINV+(Inv_L*pModel->LEIGBINV))+(Inv_NFIN*pModel->NEIGBINV))+(Inv_LNFIN*pModel->PEIGBINV));
EXIT_IF_ISNAN((((pModel->EIGBINV+(Inv_L*pModel->LEIGBINV))+(Inv_NFIN*pModel->NEIGBINV))+(Inv_LNFIN*pModel->PEIGBINV)))
NIGBINV_i=(((pModel->NIGBINV+(Inv_L*pModel->LNIGBINV))+(Inv_NFIN*pModel->NNIGBINV))+(Inv_LNFIN*pModel->PNIGBINV));
EXIT_IF_ISNAN((((pModel->NIGBINV+(Inv_L*pModel->LNIGBINV))+(Inv_NFIN*pModel->NNIGBINV))+(Inv_LNFIN*pModel->PNIGBINV)))
AIGBACC_i=(((pModel->AIGBACC+(Inv_L*pModel->LAIGBACC))+(Inv_NFIN*pModel->NAIGBACC))+(Inv_LNFIN*pModel->PAIGBACC));
EXIT_IF_ISNAN((((pModel->AIGBACC+(Inv_L*pModel->LAIGBACC))+(Inv_NFIN*pModel->NAIGBACC))+(Inv_LNFIN*pModel->PAIGBACC)))
AIGBACC1_i=(((pModel->AIGBACC1+(Inv_L*pModel->LAIGBACC1))+(Inv_NFIN*pModel->NAIGBACC1))+(Inv_LNFIN*pModel->PAIGBACC1));
EXIT_IF_ISNAN((((pModel->AIGBACC1+(Inv_L*pModel->LAIGBACC1))+(Inv_NFIN*pModel->NAIGBACC1))+(Inv_LNFIN*pModel->PAIGBACC1)))
BIGBACC_i=(((pModel->BIGBACC+(Inv_L*pModel->LBIGBACC))+(Inv_NFIN*pModel->NBIGBACC))+(Inv_LNFIN*pModel->PBIGBACC));
EXIT_IF_ISNAN((((pModel->BIGBACC+(Inv_L*pModel->LBIGBACC))+(Inv_NFIN*pModel->NBIGBACC))+(Inv_LNFIN*pModel->PBIGBACC)))
CIGBACC_i=(((pModel->CIGBACC+(Inv_L*pModel->LCIGBACC))+(Inv_NFIN*pModel->NCIGBACC))+(Inv_LNFIN*pModel->PCIGBACC));
EXIT_IF_ISNAN((((pModel->CIGBACC+(Inv_L*pModel->LCIGBACC))+(Inv_NFIN*pModel->NCIGBACC))+(Inv_LNFIN*pModel->PCIGBACC)))
NIGBACC_i=(((pModel->NIGBACC+(Inv_L*pModel->LNIGBACC))+(Inv_NFIN*pModel->NNIGBACC))+(Inv_LNFIN*pModel->PNIGBACC));
EXIT_IF_ISNAN((((pModel->NIGBACC+(Inv_L*pModel->LNIGBACC))+(Inv_NFIN*pModel->NNIGBACC))+(Inv_LNFIN*pModel->PNIGBACC)))
AIGC_i=(((pModel->AIGC+(Inv_L*pModel->LAIGC))+(Inv_NFIN*pModel->NAIGC))+(Inv_LNFIN*pModel->PAIGC));
EXIT_IF_ISNAN((((pModel->AIGC+(Inv_L*pModel->LAIGC))+(Inv_NFIN*pModel->NAIGC))+(Inv_LNFIN*pModel->PAIGC)))
AIGC1_i=(((pModel->AIGC1+(Inv_L*pModel->LAIGC1))+(Inv_NFIN*pModel->NAIGC1))+(Inv_LNFIN*pModel->PAIGC1));
EXIT_IF_ISNAN((((pModel->AIGC1+(Inv_L*pModel->LAIGC1))+(Inv_NFIN*pModel->NAIGC1))+(Inv_LNFIN*pModel->PAIGC1)))
BIGC_i=(((pModel->BIGC+(Inv_L*pModel->LBIGC))+(Inv_NFIN*pModel->NBIGC))+(Inv_LNFIN*pModel->PBIGC));
EXIT_IF_ISNAN((((pModel->BIGC+(Inv_L*pModel->LBIGC))+(Inv_NFIN*pModel->NBIGC))+(Inv_LNFIN*pModel->PBIGC)))
CIGC_i=(((pModel->CIGC+(Inv_L*pModel->LCIGC))+(Inv_NFIN*pModel->NCIGC))+(Inv_LNFIN*pModel->PCIGC));
EXIT_IF_ISNAN((((pModel->CIGC+(Inv_L*pModel->LCIGC))+(Inv_NFIN*pModel->NCIGC))+(Inv_LNFIN*pModel->PCIGC)))
PIGCD_i=(((pModel->PIGCD+(Inv_L*pModel->LPIGCD))+(Inv_NFIN*pModel->NPIGCD))+(Inv_LNFIN*pModel->PPIGCD));
EXIT_IF_ISNAN((((pModel->PIGCD+(Inv_L*pModel->LPIGCD))+(Inv_NFIN*pModel->NPIGCD))+(Inv_LNFIN*pModel->PPIGCD)))
AIGS_i=(((pModel->AIGS+(Inv_L*pModel->LAIGS))+(Inv_NFIN*pModel->NAIGS))+(Inv_LNFIN*pModel->PAIGS));
EXIT_IF_ISNAN((((pModel->AIGS+(Inv_L*pModel->LAIGS))+(Inv_NFIN*pModel->NAIGS))+(Inv_LNFIN*pModel->PAIGS)))
AIGS1_i=(((pModel->AIGS1+(Inv_L*pModel->LAIGS1))+(Inv_NFIN*pModel->NAIGS1))+(Inv_LNFIN*pModel->PAIGS1));
EXIT_IF_ISNAN((((pModel->AIGS1+(Inv_L*pModel->LAIGS1))+(Inv_NFIN*pModel->NAIGS1))+(Inv_LNFIN*pModel->PAIGS1)))
BIGS_i=(((pModel->BIGS+(Inv_L*pModel->LBIGS))+(Inv_NFIN*pModel->NBIGS))+(Inv_LNFIN*pModel->PBIGS));
EXIT_IF_ISNAN((((pModel->BIGS+(Inv_L*pModel->LBIGS))+(Inv_NFIN*pModel->NBIGS))+(Inv_LNFIN*pModel->PBIGS)))
CIGS_i=(((pModel->CIGS+(Inv_L*pModel->LCIGS))+(Inv_NFIN*pModel->NCIGS))+(Inv_LNFIN*pModel->PCIGS));
EXIT_IF_ISNAN((((pModel->CIGS+(Inv_L*pModel->LCIGS))+(Inv_NFIN*pModel->NCIGS))+(Inv_LNFIN*pModel->PCIGS)))
AIGD_i=(((pModel->AIGD+(Inv_L*pModel->LAIGD))+(Inv_NFIN*pModel->NAIGD))+(Inv_LNFIN*pModel->PAIGD));
EXIT_IF_ISNAN((((pModel->AIGD+(Inv_L*pModel->LAIGD))+(Inv_NFIN*pModel->NAIGD))+(Inv_LNFIN*pModel->PAIGD)))
AIGD1_i=(((pModel->AIGD1+(Inv_L*pModel->LAIGD1))+(Inv_NFIN*pModel->NAIGD1))+(Inv_LNFIN*pModel->PAIGD1));
EXIT_IF_ISNAN((((pModel->AIGD1+(Inv_L*pModel->LAIGD1))+(Inv_NFIN*pModel->NAIGD1))+(Inv_LNFIN*pModel->PAIGD1)))
BIGD_i=(((pModel->BIGD+(Inv_L*pModel->LBIGD))+(Inv_NFIN*pModel->NBIGD))+(Inv_LNFIN*pModel->PBIGD));
EXIT_IF_ISNAN((((pModel->BIGD+(Inv_L*pModel->LBIGD))+(Inv_NFIN*pModel->NBIGD))+(Inv_LNFIN*pModel->PBIGD)))
CIGD_i=(((pModel->CIGD+(Inv_L*pModel->LCIGD))+(Inv_NFIN*pModel->NCIGD))+(Inv_LNFIN*pModel->PCIGD));
EXIT_IF_ISNAN((((pModel->CIGD+(Inv_L*pModel->LCIGD))+(Inv_NFIN*pModel->NCIGD))+(Inv_LNFIN*pModel->PCIGD)))
NTOX_i=(((pModel->NTOX+(Inv_L*pModel->LNTOX))+(Inv_NFIN*pModel->NNTOX))+(Inv_LNFIN*pModel->PNTOX));
EXIT_IF_ISNAN((((pModel->NTOX+(Inv_L*pModel->LNTOX))+(Inv_NFIN*pModel->NNTOX))+(Inv_LNFIN*pModel->PNTOX)))
POXEDGE_i=(((pModel->POXEDGE+(Inv_L*pModel->LPOXEDGE))+(Inv_NFIN*pModel->NPOXEDGE))+(Inv_LNFIN*pModel->PPOXEDGE));
EXIT_IF_ISNAN((((pModel->POXEDGE+(Inv_L*pModel->LPOXEDGE))+(Inv_NFIN*pModel->NPOXEDGE))+(Inv_LNFIN*pModel->PPOXEDGE)))
AGIDL_i=(((pModel->AGIDL+(Inv_L*pModel->LAGIDL))+(Inv_NFIN*pModel->NAGIDL))+(Inv_LNFIN*pModel->PAGIDL));
EXIT_IF_ISNAN((((pModel->AGIDL+(Inv_L*pModel->LAGIDL))+(Inv_NFIN*pModel->NAGIDL))+(Inv_LNFIN*pModel->PAGIDL)))
BGIDL_i=(((pModel->BGIDL+(Inv_L*pModel->LBGIDL))+(Inv_NFIN*pModel->NBGIDL))+(Inv_LNFIN*pModel->PBGIDL));
EXIT_IF_ISNAN((((pModel->BGIDL+(Inv_L*pModel->LBGIDL))+(Inv_NFIN*pModel->NBGIDL))+(Inv_LNFIN*pModel->PBGIDL)))
CGIDL_i=(((pModel->CGIDL+(Inv_L*pModel->LCGIDL))+(Inv_NFIN*pModel->NCGIDL))+(Inv_LNFIN*pModel->PCGIDL));
EXIT_IF_ISNAN((((pModel->CGIDL+(Inv_L*pModel->LCGIDL))+(Inv_NFIN*pModel->NCGIDL))+(Inv_LNFIN*pModel->PCGIDL)))
EGIDL_i=(((pModel->EGIDL+(Inv_L*pModel->LEGIDL))+(Inv_NFIN*pModel->NEGIDL))+(Inv_LNFIN*pModel->PEGIDL));
EXIT_IF_ISNAN((((pModel->EGIDL+(Inv_L*pModel->LEGIDL))+(Inv_NFIN*pModel->NEGIDL))+(Inv_LNFIN*pModel->PEGIDL)))
PGIDL_i=(((pModel->PGIDL+(Inv_L*pModel->LPGIDL))+(Inv_NFIN*pModel->NPGIDL))+(Inv_LNFIN*pModel->PPGIDL));
EXIT_IF_ISNAN((((pModel->PGIDL+(Inv_L*pModel->LPGIDL))+(Inv_NFIN*pModel->NPGIDL))+(Inv_LNFIN*pModel->PPGIDL)))
AGISL_i=(((pModel->AGISL+(Inv_L*pModel->LAGISL))+(Inv_NFIN*pModel->NAGISL))+(Inv_LNFIN*pModel->PAGISL));
EXIT_IF_ISNAN((((pModel->AGISL+(Inv_L*pModel->LAGISL))+(Inv_NFIN*pModel->NAGISL))+(Inv_LNFIN*pModel->PAGISL)))
BGISL_i=(((pModel->BGISL+(Inv_L*pModel->LBGISL))+(Inv_NFIN*pModel->NBGISL))+(Inv_LNFIN*pModel->PBGISL));
EXIT_IF_ISNAN((((pModel->BGISL+(Inv_L*pModel->LBGISL))+(Inv_NFIN*pModel->NBGISL))+(Inv_LNFIN*pModel->PBGISL)))
CGISL_i=(((pModel->CGISL+(Inv_L*pModel->LCGISL))+(Inv_NFIN*pModel->NCGISL))+(Inv_LNFIN*pModel->PCGISL));
EXIT_IF_ISNAN((((pModel->CGISL+(Inv_L*pModel->LCGISL))+(Inv_NFIN*pModel->NCGISL))+(Inv_LNFIN*pModel->PCGISL)))
EGISL_i=(((pModel->EGISL+(Inv_L*pModel->LEGISL))+(Inv_NFIN*pModel->NEGISL))+(Inv_LNFIN*pModel->PEGISL));
EXIT_IF_ISNAN((((pModel->EGISL+(Inv_L*pModel->LEGISL))+(Inv_NFIN*pModel->NEGISL))+(Inv_LNFIN*pModel->PEGISL)))
PGISL_i=(((pModel->PGISL+(Inv_L*pModel->LPGISL))+(Inv_NFIN*pModel->NPGISL))+(Inv_LNFIN*pModel->PPGISL));
EXIT_IF_ISNAN((((pModel->PGISL+(Inv_L*pModel->LPGISL))+(Inv_NFIN*pModel->NPGISL))+(Inv_LNFIN*pModel->PPGISL)))
ALPHA0_i=(((pModel->ALPHA0+(Inv_L*pModel->LALPHA0))+(Inv_NFIN*pModel->NALPHA0))+(Inv_LNFIN*pModel->PALPHA0));
EXIT_IF_ISNAN((((pModel->ALPHA0+(Inv_L*pModel->LALPHA0))+(Inv_NFIN*pModel->NALPHA0))+(Inv_LNFIN*pModel->PALPHA0)))
ALPHA1_i=(((pModel->ALPHA1+(Inv_L*pModel->LALPHA1))+(Inv_NFIN*pModel->NALPHA1))+(Inv_LNFIN*pModel->PALPHA1));
EXIT_IF_ISNAN((((pModel->ALPHA1+(Inv_L*pModel->LALPHA1))+(Inv_NFIN*pModel->NALPHA1))+(Inv_LNFIN*pModel->PALPHA1)))
ALPHAII0_i=(((pModel->ALPHAII0+(Inv_L*pModel->LALPHAII0))+(Inv_NFIN*pModel->NALPHAII0))+(Inv_LNFIN*pModel->PALPHAII0));
EXIT_IF_ISNAN((((pModel->ALPHAII0+(Inv_L*pModel->LALPHAII0))+(Inv_NFIN*pModel->NALPHAII0))+(Inv_LNFIN*pModel->PALPHAII0)))
ALPHAII1_i=(((pModel->ALPHAII1+(Inv_L*pModel->LALPHAII1))+(Inv_NFIN*pModel->NALPHAII1))+(Inv_LNFIN*pModel->PALPHAII1));
EXIT_IF_ISNAN((((pModel->ALPHAII1+(Inv_L*pModel->LALPHAII1))+(Inv_NFIN*pModel->NALPHAII1))+(Inv_LNFIN*pModel->PALPHAII1)))
BETA0_i=(((pModel->BETA0+(Inv_L*pModel->LBETA0))+(Inv_NFIN*pModel->NBETA0))+(Inv_LNFIN*pModel->PBETA0));
EXIT_IF_ISNAN((((pModel->BETA0+(Inv_L*pModel->LBETA0))+(Inv_NFIN*pModel->NBETA0))+(Inv_LNFIN*pModel->PBETA0)))
BETAII0_i=(((pModel->BETAII0+(Inv_L*pModel->LBETAII0))+(Inv_NFIN*pModel->NBETAII0))+(Inv_LNFIN*pModel->PBETAII0));
EXIT_IF_ISNAN((((pModel->BETAII0+(Inv_L*pModel->LBETAII0))+(Inv_NFIN*pModel->NBETAII0))+(Inv_LNFIN*pModel->PBETAII0)))
BETAII1_i=(((pModel->BETAII1+(Inv_L*pModel->LBETAII1))+(Inv_NFIN*pModel->NBETAII1))+(Inv_LNFIN*pModel->PBETAII1));
EXIT_IF_ISNAN((((pModel->BETAII1+(Inv_L*pModel->LBETAII1))+(Inv_NFIN*pModel->NBETAII1))+(Inv_LNFIN*pModel->PBETAII1)))
BETAII2_i=(((pModel->BETAII2+(Inv_L*pModel->LBETAII2))+(Inv_NFIN*pModel->NBETAII2))+(Inv_LNFIN*pModel->PBETAII2));
EXIT_IF_ISNAN((((pModel->BETAII2+(Inv_L*pModel->LBETAII2))+(Inv_NFIN*pModel->NBETAII2))+(Inv_LNFIN*pModel->PBETAII2)))
ESATII_i=(((pModel->ESATII+(Inv_L*pModel->LESATII))+(Inv_NFIN*pModel->NESATII))+(Inv_LNFIN*pModel->PESATII));
EXIT_IF_ISNAN((((pModel->ESATII+(Inv_L*pModel->LESATII))+(Inv_NFIN*pModel->NESATII))+(Inv_LNFIN*pModel->PESATII)))
LII_i=(((pModel->LII+(Inv_L*pModel->LLII))+(Inv_NFIN*pModel->NLII))+(Inv_LNFIN*pModel->PLII));
EXIT_IF_ISNAN((((pModel->LII+(Inv_L*pModel->LLII))+(Inv_NFIN*pModel->NLII))+(Inv_LNFIN*pModel->PLII)))
SII0_i=(((pModel->SII0+(Inv_L*pModel->LSII0))+(Inv_NFIN*pModel->NSII0))+(Inv_LNFIN*pModel->PSII0));
EXIT_IF_ISNAN((((pModel->SII0+(Inv_L*pModel->LSII0))+(Inv_NFIN*pModel->NSII0))+(Inv_LNFIN*pModel->PSII0)))
SII1_i=(((pModel->SII1+(Inv_L*pModel->LSII1))+(Inv_NFIN*pModel->NSII1))+(Inv_LNFIN*pModel->PSII1));
EXIT_IF_ISNAN((((pModel->SII1+(Inv_L*pModel->LSII1))+(Inv_NFIN*pModel->NSII1))+(Inv_LNFIN*pModel->PSII1)))
SII2_i=(((pModel->SII2+(Inv_L*pModel->LSII2))+(Inv_NFIN*pModel->NSII2))+(Inv_LNFIN*pModel->PSII2));
EXIT_IF_ISNAN((((pModel->SII2+(Inv_L*pModel->LSII2))+(Inv_NFIN*pModel->NSII2))+(Inv_LNFIN*pModel->PSII2)))
SIID_i=(((pModel->SIID+(Inv_L*pModel->LSIID))+(Inv_NFIN*pModel->NSIID))+(Inv_LNFIN*pModel->PSIID));
EXIT_IF_ISNAN((((pModel->SIID+(Inv_L*pModel->LSIID))+(Inv_NFIN*pModel->NSIID))+(Inv_LNFIN*pModel->PSIID)))
TII_i=(((pModel->TII+(Inv_L*pModel->LTII))+(Inv_NFIN*pModel->NTII))+(Inv_LNFIN*pModel->PTII));
EXIT_IF_ISNAN((((pModel->TII+(Inv_L*pModel->LTII))+(Inv_NFIN*pModel->NTII))+(Inv_LNFIN*pModel->PTII)))
#if defined(_DYNAMIC)
CFS_i=(((pModel->CFS+(Inv_L*pModel->LCFS))+(Inv_NFIN*pModel->NCFS))+(Inv_LNFIN*pModel->PCFS));
EXIT_IF_ISNAN((((pModel->CFS+(Inv_L*pModel->LCFS))+(Inv_NFIN*pModel->NCFS))+(Inv_LNFIN*pModel->PCFS)))
#endif
#if defined(_DYNAMIC)
CFD_i=(((pModel->CFD+(Inv_L*pModel->LCFD))+(Inv_NFIN*pModel->NCFD))+(Inv_LNFIN*pModel->PCFD));
EXIT_IF_ISNAN((((pModel->CFD+(Inv_L*pModel->LCFD))+(Inv_NFIN*pModel->NCFD))+(Inv_LNFIN*pModel->PCFD)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
COVS_i_Vge_di=0.0;
#if defined(_DERIVATE2)
  COVS_i_Vge_di_Vge_di=0.0;
  COVS_i_Vge_di_Vge_e=0.0;
  COVS_i_Vge_di_Ve_si=0.0;
  COVS_i_Vge_di_Ve_di=0.0;
  COVS_i_Vge_di_Vge_si=0.0;
  COVS_i_Vge_di_Vdi_si=0.0;
  COVS_i_Vge_di_Tempt_GND=0.0;
#endif
COVS_i_Vge_e=0.0;
#if defined(_DERIVATE2)
  COVS_i_Vge_e_Vge_di=0.0;
  COVS_i_Vge_e_Vge_e=0.0;
  COVS_i_Vge_e_Ve_si=0.0;
  COVS_i_Vge_e_Ve_di=0.0;
  COVS_i_Vge_e_Vge_si=0.0;
  COVS_i_Vge_e_Vdi_si=0.0;
  COVS_i_Vge_e_Tempt_GND=0.0;
#endif
COVS_i_Ve_si=0.0;
#if defined(_DERIVATE2)
  COVS_i_Ve_si_Vge_di=0.0;
  COVS_i_Ve_si_Vge_e=0.0;
  COVS_i_Ve_si_Ve_si=0.0;
  COVS_i_Ve_si_Ve_di=0.0;
  COVS_i_Ve_si_Vge_si=0.0;
  COVS_i_Ve_si_Vdi_si=0.0;
  COVS_i_Ve_si_Tempt_GND=0.0;
#endif
COVS_i_Ve_di=0.0;
#if defined(_DERIVATE2)
  COVS_i_Ve_di_Vge_di=0.0;
  COVS_i_Ve_di_Vge_e=0.0;
  COVS_i_Ve_di_Ve_si=0.0;
  COVS_i_Ve_di_Ve_di=0.0;
  COVS_i_Ve_di_Vge_si=0.0;
  COVS_i_Ve_di_Vdi_si=0.0;
  COVS_i_Ve_di_Tempt_GND=0.0;
#endif
COVS_i_Vge_si=0.0;
#if defined(_DERIVATE2)
  COVS_i_Vge_si_Vge_di=0.0;
  COVS_i_Vge_si_Vge_e=0.0;
  COVS_i_Vge_si_Ve_si=0.0;
  COVS_i_Vge_si_Ve_di=0.0;
  COVS_i_Vge_si_Vge_si=0.0;
  COVS_i_Vge_si_Vdi_si=0.0;
  COVS_i_Vge_si_Tempt_GND=0.0;
#endif
COVS_i_Vdi_si=0.0;
#if defined(_DERIVATE2)
  COVS_i_Vdi_si_Vge_di=0.0;
  COVS_i_Vdi_si_Vge_e=0.0;
  COVS_i_Vdi_si_Ve_si=0.0;
  COVS_i_Vdi_si_Ve_di=0.0;
  COVS_i_Vdi_si_Vge_si=0.0;
  COVS_i_Vdi_si_Vdi_si=0.0;
  COVS_i_Vdi_si_Tempt_GND=0.0;
#endif
COVS_i_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  COVS_i_Tempt_GND_Vge_di=0.0;
  COVS_i_Tempt_GND_Vge_e=0.0;
  COVS_i_Tempt_GND_Ve_si=0.0;
  COVS_i_Tempt_GND_Ve_di=0.0;
  COVS_i_Tempt_GND_Vge_si=0.0;
  COVS_i_Tempt_GND_Vdi_si=0.0;
  COVS_i_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
COVS_i=(((pInst->COVS+(Inv_L*pModel->LCOVS))+(Inv_NFIN*pModel->NCOVS))+(Inv_LNFIN*pModel->PCOVS));
EXIT_IF_ISNAN((((pInst->COVS+(Inv_L*pModel->LCOVS))+(Inv_NFIN*pModel->NCOVS))+(Inv_LNFIN*pModel->PCOVS)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
COVD_i_Vge_di=0.0;
#if defined(_DERIVATE2)
  COVD_i_Vge_di_Vge_di=0.0;
  COVD_i_Vge_di_Vge_e=0.0;
  COVD_i_Vge_di_Ve_si=0.0;
  COVD_i_Vge_di_Ve_di=0.0;
  COVD_i_Vge_di_Vge_si=0.0;
  COVD_i_Vge_di_Vdi_si=0.0;
  COVD_i_Vge_di_Tempt_GND=0.0;
#endif
COVD_i_Vge_e=0.0;
#if defined(_DERIVATE2)
  COVD_i_Vge_e_Vge_di=0.0;
  COVD_i_Vge_e_Vge_e=0.0;
  COVD_i_Vge_e_Ve_si=0.0;
  COVD_i_Vge_e_Ve_di=0.0;
  COVD_i_Vge_e_Vge_si=0.0;
  COVD_i_Vge_e_Vdi_si=0.0;
  COVD_i_Vge_e_Tempt_GND=0.0;
#endif
COVD_i_Ve_si=0.0;
#if defined(_DERIVATE2)
  COVD_i_Ve_si_Vge_di=0.0;
  COVD_i_Ve_si_Vge_e=0.0;
  COVD_i_Ve_si_Ve_si=0.0;
  COVD_i_Ve_si_Ve_di=0.0;
  COVD_i_Ve_si_Vge_si=0.0;
  COVD_i_Ve_si_Vdi_si=0.0;
  COVD_i_Ve_si_Tempt_GND=0.0;
#endif
COVD_i_Ve_di=0.0;
#if defined(_DERIVATE2)
  COVD_i_Ve_di_Vge_di=0.0;
  COVD_i_Ve_di_Vge_e=0.0;
  COVD_i_Ve_di_Ve_si=0.0;
  COVD_i_Ve_di_Ve_di=0.0;
  COVD_i_Ve_di_Vge_si=0.0;
  COVD_i_Ve_di_Vdi_si=0.0;
  COVD_i_Ve_di_Tempt_GND=0.0;
#endif
COVD_i_Vge_si=0.0;
#if defined(_DERIVATE2)
  COVD_i_Vge_si_Vge_di=0.0;
  COVD_i_Vge_si_Vge_e=0.0;
  COVD_i_Vge_si_Ve_si=0.0;
  COVD_i_Vge_si_Ve_di=0.0;
  COVD_i_Vge_si_Vge_si=0.0;
  COVD_i_Vge_si_Vdi_si=0.0;
  COVD_i_Vge_si_Tempt_GND=0.0;
#endif
COVD_i_Vdi_si=0.0;
#if defined(_DERIVATE2)
  COVD_i_Vdi_si_Vge_di=0.0;
  COVD_i_Vdi_si_Vge_e=0.0;
  COVD_i_Vdi_si_Ve_si=0.0;
  COVD_i_Vdi_si_Ve_di=0.0;
  COVD_i_Vdi_si_Vge_si=0.0;
  COVD_i_Vdi_si_Vdi_si=0.0;
  COVD_i_Vdi_si_Tempt_GND=0.0;
#endif
COVD_i_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  COVD_i_Tempt_GND_Vge_di=0.0;
  COVD_i_Tempt_GND_Vge_e=0.0;
  COVD_i_Tempt_GND_Ve_si=0.0;
  COVD_i_Tempt_GND_Ve_di=0.0;
  COVD_i_Tempt_GND_Vge_si=0.0;
  COVD_i_Tempt_GND_Vdi_si=0.0;
  COVD_i_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
COVD_i=(((pInst->COVD+(Inv_L*pModel->LCOVD))+(Inv_NFIN*pModel->NCOVD))+(Inv_LNFIN*pModel->PCOVD));
EXIT_IF_ISNAN((((pInst->COVD+(Inv_L*pModel->LCOVD))+(Inv_NFIN*pModel->NCOVD))+(Inv_LNFIN*pModel->PCOVD)))
#endif
#if defined(_DYNAMIC)
CGSL_i=(((pModel->CGSL+(Inv_L*pModel->LCGSL))+(Inv_NFIN*pModel->NCGSL))+(Inv_LNFIN*pModel->PCGSL));
EXIT_IF_ISNAN((((pModel->CGSL+(Inv_L*pModel->LCGSL))+(Inv_NFIN*pModel->NCGSL))+(Inv_LNFIN*pModel->PCGSL)))
#endif
#if defined(_DYNAMIC)
CGDL_i=(((pModel->CGDL+(Inv_L*pModel->LCGDL))+(Inv_NFIN*pModel->NCGDL))+(Inv_LNFIN*pModel->PCGDL));
EXIT_IF_ISNAN((((pModel->CGDL+(Inv_L*pModel->LCGDL))+(Inv_NFIN*pModel->NCGDL))+(Inv_LNFIN*pModel->PCGDL)))
#endif
#if defined(_DYNAMIC)
CGBL_i=(((pModel->CGBL+(Inv_L*pModel->LCGBL))+(Inv_NFIN*pModel->NCGBL))+(Inv_LNFIN*pModel->PCGBL));
EXIT_IF_ISNAN((((pModel->CGBL+(Inv_L*pModel->LCGBL))+(Inv_NFIN*pModel->NCGBL))+(Inv_LNFIN*pModel->PCGBL)))
#endif
#if defined(_DYNAMIC)
CKAPPAS_i=(((pModel->CKAPPAS+(Inv_L*pModel->LCKAPPAS))+(Inv_NFIN*pModel->NCKAPPAS))+(Inv_LNFIN*pModel->PCKAPPAS));
EXIT_IF_ISNAN((((pModel->CKAPPAS+(Inv_L*pModel->LCKAPPAS))+(Inv_NFIN*pModel->NCKAPPAS))+(Inv_LNFIN*pModel->PCKAPPAS)))
#endif
#if defined(_DYNAMIC)
CKAPPAD_i=(((pModel->CKAPPAD+(Inv_L*pModel->LCKAPPAD))+(Inv_NFIN*pModel->NCKAPPAD))+(Inv_LNFIN*pModel->PCKAPPAD));
EXIT_IF_ISNAN((((pModel->CKAPPAD+(Inv_L*pModel->LCKAPPAD))+(Inv_NFIN*pModel->NCKAPPAD))+(Inv_LNFIN*pModel->PCKAPPAD)))
#endif
#if defined(_DYNAMIC)
CKAPPAB_i=(((pModel->CKAPPAB+(Inv_L*pModel->LCKAPPAB))+(Inv_NFIN*pModel->NCKAPPAB))+(Inv_LNFIN*pModel->PCKAPPAB));
EXIT_IF_ISNAN((((pModel->CKAPPAB+(Inv_L*pModel->LCKAPPAB))+(Inv_NFIN*pModel->NCKAPPAB))+(Inv_LNFIN*pModel->PCKAPPAB)))
#endif
NTGEN_i=(((pModel->NTGEN+(Inv_L*pModel->LNTGEN))+(Inv_NFIN*pModel->NNTGEN))+(Inv_LNFIN*pModel->PNTGEN));
EXIT_IF_ISNAN((((pModel->NTGEN+(Inv_L*pModel->LNTGEN))+(Inv_NFIN*pModel->NNTGEN))+(Inv_LNFIN*pModel->PNTGEN)))
AIGEN_i=(((pModel->AIGEN+(Inv_L*pModel->LAIGEN))+(Inv_NFIN*pModel->NAIGEN))+(Inv_LNFIN*pModel->PAIGEN));
EXIT_IF_ISNAN((((pModel->AIGEN+(Inv_L*pModel->LAIGEN))+(Inv_NFIN*pModel->NAIGEN))+(Inv_LNFIN*pModel->PAIGEN)))
BIGEN_i=(((pModel->BIGEN+(Inv_L*pModel->LBIGEN))+(Inv_NFIN*pModel->NBIGEN))+(Inv_LNFIN*pModel->PBIGEN));
EXIT_IF_ISNAN((((pModel->BIGEN+(Inv_L*pModel->LBIGEN))+(Inv_NFIN*pModel->NBIGEN))+(Inv_LNFIN*pModel->PBIGEN)))
if
((pModel->ASYMMOD!=0))
{
CDSCDR_i=(((pModel->CDSCDR+(Inv_L*pModel->LCDSCDR))+(Inv_NFIN*pModel->NCDSCDR))+(Inv_LNFIN*pModel->PCDSCDR));
EXIT_IF_ISNAN((((pModel->CDSCDR+(Inv_L*pModel->LCDSCDR))+(Inv_NFIN*pModel->NCDSCDR))+(Inv_LNFIN*pModel->PCDSCDR)))
CITR_i=(((pModel->CITR+(Inv_L*pModel->LCITR))+(Inv_NFIN*pModel->NCITR))+(Inv_LNFIN*pModel->PCITR));
EXIT_IF_ISNAN((((pModel->CITR+(Inv_L*pModel->LCITR))+(Inv_NFIN*pModel->NCITR))+(Inv_LNFIN*pModel->PCITR)))
ETA0R_i=(((pModel->ETA0R+(Inv_L*pModel->LETA0R))+(Inv_NFIN*pModel->NETA0R))+(Inv_LNFIN*pModel->PETA0R));
EXIT_IF_ISNAN((((pModel->ETA0R+(Inv_L*pModel->LETA0R))+(Inv_NFIN*pModel->NETA0R))+(Inv_LNFIN*pModel->PETA0R)))
VSAT1R_i=(((pModel->VSAT1R+(Inv_L*pModel->LVSAT1R))+(Inv_NFIN*pModel->NVSAT1R))+(Inv_LNFIN*pModel->PVSAT1R));
EXIT_IF_ISNAN((((pModel->VSAT1R+(Inv_L*pModel->LVSAT1R))+(Inv_NFIN*pModel->NVSAT1R))+(Inv_LNFIN*pModel->PVSAT1R)))
MEXPR_i=(((pModel->MEXPR+(Inv_L*pModel->LMEXPR))+(Inv_NFIN*pModel->NMEXPR))+(Inv_LNFIN*pModel->PMEXPR));
EXIT_IF_ISNAN((((pModel->MEXPR+(Inv_L*pModel->LMEXPR))+(Inv_NFIN*pModel->NMEXPR))+(Inv_LNFIN*pModel->PMEXPR)))
PTWGR_i=(((pModel->PTWGR+(Inv_L*pModel->LPTWGR))+(Inv_NFIN*pModel->NPTWGR))+(Inv_LNFIN*pModel->PPTWGR));
EXIT_IF_ISNAN((((pModel->PTWGR+(Inv_L*pModel->LPTWGR))+(Inv_NFIN*pModel->NPTWGR))+(Inv_LNFIN*pModel->PPTWGR)))
PDIBL1R_i=(((pModel->PDIBL1R+(Inv_L*pModel->LPDIBL1R))+(Inv_NFIN*pModel->NPDIBL1R))+(Inv_LNFIN*pModel->PPDIBL1R));
EXIT_IF_ISNAN((((pModel->PDIBL1R+(Inv_L*pModel->LPDIBL1R))+(Inv_NFIN*pModel->NPDIBL1R))+(Inv_LNFIN*pModel->PPDIBL1R)))
PDIBL2R_i=(((pModel->PDIBL2R+(Inv_L*pModel->LPDIBL2R))+(Inv_NFIN*pModel->NPDIBL2R))+(Inv_LNFIN*pModel->PPDIBL2R));
EXIT_IF_ISNAN((((pModel->PDIBL2R+(Inv_L*pModel->LPDIBL2R))+(Inv_NFIN*pModel->NPDIBL2R))+(Inv_LNFIN*pModel->PPDIBL2R)))
PCLMR_i=(((pModel->PCLMR+(Inv_L*pModel->LPCLMR))+(Inv_NFIN*pModel->NPCLMR))+(Inv_LNFIN*pModel->PPCLMR));
EXIT_IF_ISNAN((((pModel->PCLMR+(Inv_L*pModel->LPCLMR))+(Inv_NFIN*pModel->NPCLMR))+(Inv_LNFIN*pModel->PPCLMR)))
DVTSHIFTR_i=(((pModel->DVTSHIFTR+(Inv_L*pModel->LDVTSHIFTR))+(Inv_NFIN*pModel->NDVTSHIFTR))+(Inv_LNFIN*pModel->PDVTSHIFTR));
EXIT_IF_ISNAN((((pModel->DVTSHIFTR+(Inv_L*pModel->LDVTSHIFTR))+(Inv_NFIN*pModel->NDVTSHIFTR))+(Inv_LNFIN*pModel->PDVTSHIFTR)))
VSATR_i=(((pModel->VSATR+(Inv_L*pModel->LVSATR))+(Inv_NFIN*pModel->NVSATR))+(Inv_LNFIN*pModel->PVSATR));
EXIT_IF_ISNAN((((pModel->VSATR+(Inv_L*pModel->LVSATR))+(Inv_NFIN*pModel->NVSATR))+(Inv_LNFIN*pModel->PVSATR)))
KSATIVR_i=(((pModel->KSATIVR+(Inv_L*pModel->LKSATIVR))+(Inv_NFIN*pModel->NKSATIVR))+(Inv_LNFIN*pModel->PKSATIVR));
EXIT_IF_ISNAN((((pModel->KSATIVR+(Inv_L*pModel->LKSATIVR))+(Inv_NFIN*pModel->NKSATIVR))+(Inv_LNFIN*pModel->PKSATIVR)))
U0R_i=(((pModel->U0R+(Inv_L*pModel->LU0R))+(Inv_NFIN*pModel->NU0R))+(Inv_LNFIN*pModel->PU0R));
EXIT_IF_ISNAN((((pModel->U0R+(Inv_L*pModel->LU0R))+(Inv_NFIN*pModel->NU0R))+(Inv_LNFIN*pModel->PU0R)))
UAR_i=(((pModel->UAR+(Inv_L*pModel->LUAR))+(Inv_NFIN*pModel->NUAR))+(Inv_LNFIN*pModel->PUAR));
EXIT_IF_ISNAN((((pModel->UAR+(Inv_L*pModel->LUAR))+(Inv_NFIN*pModel->NUAR))+(Inv_LNFIN*pModel->PUAR)))
UPR_i=(((pModel->UPR+(Inv_L*pModel->LUPR))+(Inv_NFIN*pModel->NUPR))+(Inv_LNFIN*pModel->PUPR));
EXIT_IF_ISNAN((((pModel->UPR+(Inv_L*pModel->LUPR))+(Inv_NFIN*pModel->NUPR))+(Inv_LNFIN*pModel->PUPR)))
if
((pModel->BULKMOD!=0))
{
UCR_i=(((pModel->UCR+(Inv_L*pModel->LUCR))+(Inv_NFIN*pModel->NUCR))+(Inv_LNFIN*pModel->PUCR));
EXIT_IF_ISNAN((((pModel->UCR+(Inv_L*pModel->LUCR))+(Inv_NFIN*pModel->NUCR))+(Inv_LNFIN*pModel->PUCR)))
}
EUR_i=(((pModel->EUR+(Inv_L*pModel->LEUR))+(Inv_NFIN*pModel->NEUR))+(Inv_LNFIN*pModel->PEUR));
EXIT_IF_ISNAN((((pModel->EUR+(Inv_L*pModel->LEUR))+(Inv_NFIN*pModel->NEUR))+(Inv_LNFIN*pModel->PEUR)))
UDR_i=(((pModel->UDR+(Inv_L*pModel->LUDR))+(Inv_NFIN*pModel->NUDR))+(Inv_LNFIN*pModel->PUDR));
EXIT_IF_ISNAN((((pModel->UDR+(Inv_L*pModel->LUDR))+(Inv_NFIN*pModel->NUDR))+(Inv_LNFIN*pModel->PUDR)))
}
if
((pModel->NQSMOD==1))
{
printf(" Although the model selector NQSMOD is set to 1, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment \"`define __NQSMOD1__\" in bsimcmg.va to activate it.");
printf("\n");
}
if
((pModel->NQSMOD==2))
{
printf(" Although the model selector NQSMOD is set to 2, the NQS gate resistance model is not activated in the Verilog-A code. Please uncomment \"`define __NQSMOD2__\" in bsimcmg.va to activate it.");
printf("\n");
}
UTE_i=(((pModel->UTE+(Inv_L*pModel->LUTE))+(Inv_NFIN*pModel->NUTE))+(Inv_LNFIN*pModel->PUTE));
EXIT_IF_ISNAN((((pModel->UTE+(Inv_L*pModel->LUTE))+(Inv_NFIN*pModel->NUTE))+(Inv_LNFIN*pModel->PUTE)))
UTL_i=(((pModel->UTL+(Inv_L*pModel->LUTL))+(Inv_NFIN*pModel->NUTL))+(Inv_LNFIN*pModel->PUTL));
EXIT_IF_ISNAN((((pModel->UTL+(Inv_L*pModel->LUTL))+(Inv_NFIN*pModel->NUTL))+(Inv_LNFIN*pModel->PUTL)))
EMOBT_i=(((pModel->EMOBT+(Inv_L*pModel->LEMOBT))+(Inv_NFIN*pModel->NEMOBT))+(Inv_LNFIN*pModel->PEMOBT));
EXIT_IF_ISNAN((((pModel->EMOBT+(Inv_L*pModel->LEMOBT))+(Inv_NFIN*pModel->NEMOBT))+(Inv_LNFIN*pModel->PEMOBT)))
UA1_i=(((pModel->UA1+(Inv_L*pModel->LUA1))+(Inv_NFIN*pModel->NUA1))+(Inv_LNFIN*pModel->PUA1));
EXIT_IF_ISNAN((((pModel->UA1+(Inv_L*pModel->LUA1))+(Inv_NFIN*pModel->NUA1))+(Inv_LNFIN*pModel->PUA1)))
if
((pModel->BULKMOD!=0))
{
UC1_i=(((pModel->UC1+(Inv_L*pModel->LUC1))+(Inv_NFIN*pModel->NUC1))+(Inv_LNFIN*pModel->PUC1));
EXIT_IF_ISNAN((((pModel->UC1+(Inv_L*pModel->LUC1))+(Inv_NFIN*pModel->NUC1))+(Inv_LNFIN*pModel->PUC1)))
}
UD1_i=(((pModel->UD1+(Inv_L*pModel->LUD1))+(Inv_NFIN*pModel->NUD1))+(Inv_LNFIN*pModel->PUD1));
EXIT_IF_ISNAN((((pModel->UD1+(Inv_L*pModel->LUD1))+(Inv_NFIN*pModel->NUD1))+(Inv_LNFIN*pModel->PUD1)))
UCSTE_i=(((pModel->UCSTE+(Inv_L*pModel->LUCSTE))+(Inv_NFIN*pModel->NUCSTE))+(Inv_LNFIN*pModel->PUCSTE));
EXIT_IF_ISNAN((((pModel->UCSTE+(Inv_L*pModel->LUCSTE))+(Inv_NFIN*pModel->NUCSTE))+(Inv_LNFIN*pModel->PUCSTE)))
PTWGT_i=(((pModel->PTWGT+(Inv_L*pModel->LPTWGT))+(Inv_NFIN*pModel->NPTWGT))+(Inv_LNFIN*pModel->PPTWGT));
EXIT_IF_ISNAN((((pModel->PTWGT+(Inv_L*pModel->LPTWGT))+(Inv_NFIN*pModel->NPTWGT))+(Inv_LNFIN*pModel->PPTWGT)))
AT_i=(((pModel->AT+(Inv_L*pModel->LAT))+(Inv_NFIN*pModel->NAT))+(Inv_LNFIN*pModel->PAT));
EXIT_IF_ISNAN((((pModel->AT+(Inv_L*pModel->LAT))+(Inv_NFIN*pModel->NAT))+(Inv_LNFIN*pModel->PAT)))
ATCV_i=(((pModel->ATCV+(Inv_L*pModel->LATCV))+(Inv_NFIN*pModel->NATCV))+(Inv_LNFIN*pModel->PATCV));
EXIT_IF_ISNAN((((pModel->ATCV+(Inv_L*pModel->LATCV))+(Inv_NFIN*pModel->NATCV))+(Inv_LNFIN*pModel->PATCV)))
PRT_i=(((pModel->PRT+(Inv_L*pModel->LPRT))+(Inv_NFIN*pModel->NPRT))+(Inv_LNFIN*pModel->PPRT));
EXIT_IF_ISNAN((((pModel->PRT+(Inv_L*pModel->LPRT))+(Inv_NFIN*pModel->NPRT))+(Inv_LNFIN*pModel->PPRT)))
KT1_i=(((pModel->KT1+(Inv_L*pModel->LKT1))+(Inv_NFIN*pModel->NKT1))+(Inv_LNFIN*pModel->PKT1));
EXIT_IF_ISNAN((((pModel->KT1+(Inv_L*pModel->LKT1))+(Inv_NFIN*pModel->NKT1))+(Inv_LNFIN*pModel->PKT1)))
TSS_i=(((pModel->TSS+(Inv_L*pModel->LTSS))+(Inv_NFIN*pModel->NTSS))+(Inv_LNFIN*pModel->PTSS));
EXIT_IF_ISNAN((((pModel->TSS+(Inv_L*pModel->LTSS))+(Inv_NFIN*pModel->NTSS))+(Inv_LNFIN*pModel->PTSS)))
IIT_i=(((pModel->IIT+(Inv_L*pModel->LIIT))+(Inv_NFIN*pModel->NIIT))+(Inv_LNFIN*pModel->PIIT));
EXIT_IF_ISNAN((((pModel->IIT+(Inv_L*pModel->LIIT))+(Inv_NFIN*pModel->NIIT))+(Inv_LNFIN*pModel->PIIT)))
TGIDL_i=(((pModel->TGIDL+(Inv_L*pModel->LTGIDL))+(Inv_NFIN*pModel->NTGIDL))+(Inv_LNFIN*pModel->PTGIDL));
EXIT_IF_ISNAN((((pModel->TGIDL+(Inv_L*pModel->LTGIDL))+(Inv_NFIN*pModel->NTGIDL))+(Inv_LNFIN*pModel->PTGIDL)))
IGT_i=(((pModel->IGT+(Inv_L*pModel->LIGT))+(Inv_NFIN*pModel->NIGT))+(Inv_LNFIN*pModel->PIGT));
EXIT_IF_ISNAN((((pModel->IGT+(Inv_L*pModel->LIGT))+(Inv_NFIN*pModel->NIGT))+(Inv_LNFIN*pModel->PIGT)))
if
((pModel->ASYMMOD!=0))
{
UTER_i=(((pModel->UTER+(Inv_L*pModel->LUTER))+(Inv_NFIN*pModel->NUTER))+(Inv_LNFIN*pModel->PUTER));
EXIT_IF_ISNAN((((pModel->UTER+(Inv_L*pModel->LUTER))+(Inv_NFIN*pModel->NUTER))+(Inv_LNFIN*pModel->PUTER)))
UTLR_i=(((pModel->UTLR+(Inv_L*pModel->LUTLR))+(Inv_NFIN*pModel->NUTLR))+(Inv_LNFIN*pModel->PUTLR));
EXIT_IF_ISNAN((((pModel->UTLR+(Inv_L*pModel->LUTLR))+(Inv_NFIN*pModel->NUTLR))+(Inv_LNFIN*pModel->PUTLR)))
UA1R_i=(((pModel->UA1R+(Inv_L*pModel->LUA1R))+(Inv_NFIN*pModel->NUA1R))+(Inv_LNFIN*pModel->PUA1R));
EXIT_IF_ISNAN((((pModel->UA1R+(Inv_L*pModel->LUA1R))+(Inv_NFIN*pModel->NUA1R))+(Inv_LNFIN*pModel->PUA1R)))
UD1R_i=(((pModel->UD1R+(Inv_L*pModel->LUD1R))+(Inv_NFIN*pModel->NUD1R))+(Inv_LNFIN*pModel->PUD1R));
EXIT_IF_ISNAN((((pModel->UD1R+(Inv_L*pModel->LUD1R))+(Inv_NFIN*pModel->NUD1R))+(Inv_LNFIN*pModel->PUD1R)))
ATR_i=(((pModel->ATR+(Inv_L*pModel->LATR))+(Inv_NFIN*pModel->NATR))+(Inv_LNFIN*pModel->PATR));
EXIT_IF_ISNAN((((pModel->ATR+(Inv_L*pModel->LATR))+(Inv_NFIN*pModel->NATR))+(Inv_LNFIN*pModel->PATR)))
if
((pModel->BULKMOD!=0))
{
UC1R_i=(((pModel->UC1R+(Inv_L*pModel->LUC1R))+(Inv_NFIN*pModel->NUC1R))+(Inv_LNFIN*pModel->PUC1R));
EXIT_IF_ISNAN((((pModel->UC1R+(Inv_L*pModel->LUC1R))+(Inv_NFIN*pModel->NUC1R))+(Inv_LNFIN*pModel->PUC1R)))
}
}
if
((pModel->PHIGN1!=0.0))
{
PHIG_i=(PHIG_i*(1.0+((pModel->PHIGN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->PHIGN2))))));
EXIT_IF_ISNAN((PHIG_i*(1.0+((pModel->PHIGN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->PHIGN2)))))))
}
if
((pModel->ETA0N1!=0.0))
{
ETA0_i=(ETA0_i*(1.0+((pModel->ETA0N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->ETA0N2))))));
EXIT_IF_ISNAN((ETA0_i*(1.0+((pModel->ETA0N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->ETA0N2)))))))
}
if
((pModel->CDSCN1!=0.0))
{
CDSC_i=(CDSC_i*(1.0+((pModel->CDSCN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCN2))))));
EXIT_IF_ISNAN((CDSC_i*(1.0+((pModel->CDSCN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCN2)))))))
}
if
((pModel->CDSCDN1!=0.0))
{
CDSCD_i=(CDSCD_i*(1.0+((pModel->CDSCDN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCDN2))))));
EXIT_IF_ISNAN((CDSCD_i*(1.0+((pModel->CDSCDN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCDN2)))))))
}
if
((pModel->CDSCDRN1!=0.0))
{
CDSCDR_i=(CDSCDR_i*(1.0+((pModel->CDSCDRN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCDRN2))))));
EXIT_IF_ISNAN((CDSCDR_i*(1.0+((pModel->CDSCDRN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->CDSCDRN2)))))))
}
if
((pModel->VSATN1!=0.0))
{
VSAT_i=(VSAT_i*(1.0+((pModel->VSATN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSATN2))))));
EXIT_IF_ISNAN((VSAT_i*(1.0+((pModel->VSATN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSATN2)))))))
}
if
((pModel->VSAT1N1!=0.0))
{
VSAT1_i=(VSAT1_i*(1.0+((pModel->VSAT1N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSAT1N2))))));
EXIT_IF_ISNAN((VSAT1_i*(1.0+((pModel->VSAT1N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSAT1N2)))))))
}
if
((pModel->VSAT1RN1!=0.0))
{
VSAT1R_i=(VSAT1R_i*(1.0+((pModel->VSAT1RN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSAT1RN2))))));
EXIT_IF_ISNAN((VSAT1R_i*(1.0+((pModel->VSAT1RN1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->VSAT1RN2)))))))
}
if
((pModel->U0N1!=0.0))
{
U0_i=(U0_i*(1.0+((pModel->U0N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->U0N2))))));
EXIT_IF_ISNAN((U0_i*(1.0+((pModel->U0N1/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->U0N2)))))))
}
if
((here->NFINNOM_Given))
{
PHIG_i=(PHIG_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->PHIGLT)*Leff)));
EXIT_IF_ISNAN((PHIG_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->PHIGLT)*Leff))))
ETA0_i=(ETA0_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->ETA0LT)*Leff)));
EXIT_IF_ISNAN((ETA0_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->ETA0LT)*Leff))))
U0_i=(U0_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->U0LT)*Leff)));
EXIT_IF_ISNAN((U0_i*(1.0+(((pInst->NFIN-pInst->NFINNOM)*pModel->U0LT)*Leff))))
}
if
((pModel->U0N1R!=0.0))
{
U0R_i=(U0R_i*(1.0+((pModel->U0N1R/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->U0N2R))))));
EXIT_IF_ISNAN((U0R_i*(1.0+((pModel->U0N1R/pInst->NFIN)*bsimcmg_lln((1.0+(pInst->NFIN/pModel->U0N2R)))))))
}
PHIG_i=(PHIG_i+(pModel->PHIGL*Leff));
EXIT_IF_ISNAN((PHIG_i+(pModel->PHIGL*Leff)))
if
((pModel->LPA>0.0))
{
{
double m00_pow(d00_pow0,Leff,(-pModel->LPA))
U0_i=(U0_i*(1.0-(UP_i*d00_pow0)));
EXIT_IF_ISNAN((U0_i*(1.0-(UP_i*d00_pow0))))
}
}
else
{
U0_i=(U0_i*(1.0-UP_i));
EXIT_IF_ISNAN((U0_i*(1.0-UP_i)))
}
UA_i=(UA_i+(pModel->AUA*bsimcmg_lexp(((-Leff)/pModel->BUA))));
EXIT_IF_ISNAN((UA_i+(pModel->AUA*bsimcmg_lexp(((-Leff)/pModel->BUA)))))
UD_i=(UD_i+(pModel->AUD*bsimcmg_lexp(((-Leff)/pModel->BUD))));
EXIT_IF_ISNAN((UD_i+(pModel->AUD*bsimcmg_lexp(((-Leff)/pModel->BUD)))))
EU_i=(EU_i+(pModel->AEU*bsimcmg_lexp(((-Leff)/pModel->BEU))));
EXIT_IF_ISNAN((EU_i+(pModel->AEU*bsimcmg_lexp(((-Leff)/pModel->BEU)))))
if
((pModel->ASYMMOD!=0))
{
if
((pModel->LPAR>0.0))
{
{
double m00_pow(d00_pow0,Leff,(-pModel->LPAR))
U0R_i=(U0R_i*(1.0-(UPR_i*d00_pow0)));
EXIT_IF_ISNAN((U0R_i*(1.0-(UPR_i*d00_pow0))))
}
}
else
{
U0R_i=(U0R_i*(1.0-UPR_i));
EXIT_IF_ISNAN((U0R_i*(1.0-UPR_i)))
}
UAR_i=(UAR_i+(pModel->AUAR*bsimcmg_lexp(((-Leff)/pModel->BUAR))));
EXIT_IF_ISNAN((UAR_i+(pModel->AUAR*bsimcmg_lexp(((-Leff)/pModel->BUAR)))))
UDR_i=(UDR_i+(pModel->AUDR*bsimcmg_lexp(((-Leff)/pModel->BUDR))));
EXIT_IF_ISNAN((UDR_i+(pModel->AUDR*bsimcmg_lexp(((-Leff)/pModel->BUDR)))))
EUR_i=(EUR_i+(pModel->AEUR*bsimcmg_lexp(((-Leff)/pModel->BEUR))));
EXIT_IF_ISNAN((EUR_i+(pModel->AEUR*bsimcmg_lexp(((-Leff)/pModel->BEUR)))))
}
if
((pModel->RDSMOD==1))
{
RSW_i=(RSW_i+(pModel->ARSW*bsimcmg_lexp(((-Leff)/pModel->BRSW))));
EXIT_IF_ISNAN((RSW_i+(pModel->ARSW*bsimcmg_lexp(((-Leff)/pModel->BRSW)))))
RDW_i=(RDW_i+(pModel->ARDW*bsimcmg_lexp(((-Leff)/pModel->BRDW))));
EXIT_IF_ISNAN((RDW_i+(pModel->ARDW*bsimcmg_lexp(((-Leff)/pModel->BRDW)))))
}
else
{
RDSW_i=(RDSW_i+(pModel->ARDSW*bsimcmg_lexp(((-Leff)/pModel->BRDSW))));
EXIT_IF_ISNAN((RDSW_i+(pModel->ARDSW*bsimcmg_lexp(((-Leff)/pModel->BRDSW)))))
}
PCLM_i=(PCLM_i+(pModel->APCLM*bsimcmg_lexp(((-Leff)/pModel->BPCLM))));
EXIT_IF_ISNAN((PCLM_i+(pModel->APCLM*bsimcmg_lexp(((-Leff)/pModel->BPCLM)))))
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,Leff,(-pModel->BPCLMR))
PCLMR_i=(PCLMR_i+(pModel->APCLMR*d00_pow0));
EXIT_IF_ISNAN((PCLMR_i+(pModel->APCLMR*d00_pow0)))
}
}
{
double m00_pow(d00_pow0,Leff,(-pModel->BMEXP))
MEXP_i=(MEXP_i+(pModel->AMEXP*d00_pow0));
EXIT_IF_ISNAN((MEXP_i+(pModel->AMEXP*d00_pow0)))
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,Leff,(-pModel->BMEXPR))
MEXPR_i=(MEXPR_i+(pModel->AMEXPR*d00_pow0));
EXIT_IF_ISNAN((MEXPR_i+(pModel->AMEXPR*d00_pow0)))
}
}
PTWG_i=(PTWG_i+(pModel->APTWG*bsimcmg_lexp(((-Leff)/pModel->BPTWG))));
EXIT_IF_ISNAN((PTWG_i+(pModel->APTWG*bsimcmg_lexp(((-Leff)/pModel->BPTWG)))))
if
((pModel->ASYMMOD!=0))
{
PTWGR_i=(PTWGR_i+(pModel->APTWG*bsimcmg_lexp(((-Leff)/pModel->BPTWG))));
EXIT_IF_ISNAN((PTWGR_i+(pModel->APTWG*bsimcmg_lexp(((-Leff)/pModel->BPTWG)))))
}
VSAT_i=(VSAT_i+(pModel->AVSAT*bsimcmg_lexp(((-Leff)/pModel->BVSAT))));
EXIT_IF_ISNAN((VSAT_i+(pModel->AVSAT*bsimcmg_lexp(((-Leff)/pModel->BVSAT)))))
VSAT1_i=(VSAT1_i+(pModel->AVSAT1*bsimcmg_lexp(((-Leff)/pModel->BVSAT1))));
EXIT_IF_ISNAN((VSAT1_i+(pModel->AVSAT1*bsimcmg_lexp(((-Leff)/pModel->BVSAT1)))))
if
((pModel->ASYMMOD!=0))
{
VSAT1R_i=(VSAT1R_i+(pModel->AVSAT1*bsimcmg_lexp(((-Leff)/pModel->BVSAT1))));
EXIT_IF_ISNAN((VSAT1R_i+(pModel->AVSAT1*bsimcmg_lexp(((-Leff)/pModel->BVSAT1)))))
}
PSAT_i=(PSAT_i+(pModel->APSAT*bsimcmg_lexp(((-Leff)/pModel->BPSAT))));
EXIT_IF_ISNAN((PSAT_i+(pModel->APSAT*bsimcmg_lexp(((-Leff)/pModel->BPSAT)))))
PSATCV_i=(PSATCV_i+(pModel->APSATCV*bsimcmg_lexp(((-Leff)/pModel->BPSATCV))));
EXIT_IF_ISNAN((PSATCV_i+(pModel->APSATCV*bsimcmg_lexp(((-Leff)/pModel->BPSATCV)))))
VSATCV_i=(VSATCV_i+(pModel->AVSATCV*bsimcmg_lexp(((-LeffCV)/pModel->BVSATCV))));
EXIT_IF_ISNAN((VSATCV_i+(pModel->AVSATCV*bsimcmg_lexp(((-LeffCV)/pModel->BVSATCV)))))
DVTP0_i=(pModel->DVTP0+(pModel->ADVTP0*bsimcmg_lexp(((-Leff)/pModel->BDVTP0))));
EXIT_IF_ISNAN((pModel->DVTP0+(pModel->ADVTP0*bsimcmg_lexp(((-Leff)/pModel->BDVTP0)))))
DVTP1_i=(pModel->DVTP1+(pModel->ADVTP1*bsimcmg_lexp(((-Leff)/pModel->BDVTP1))));
EXIT_IF_ISNAN((pModel->DVTP1+(pModel->ADVTP1*bsimcmg_lexp(((-Leff)/pModel->BDVTP1)))))
if
(((QMTCENCV_i>0.0)||(QMTCENCVA_i>0.0)))
{
MTcen=(1.0+(pModel->AQMTCEN*bsimcmg_lexp(((-((2.0*Ach)/Weff_UFCM))/pModel->BQMTCEN))));
EXIT_IF_ISNAN((1.0+(pModel->AQMTCEN*bsimcmg_lexp(((-((2.0*Ach)/Weff_UFCM))/pModel->BQMTCEN)))))
Tcen0=(((2.0*Ach)/Weff_UFCM)*MTcen);
EXIT_IF_ISNAN((((2.0*Ach)/Weff_UFCM)*MTcen))
}
if
((LeffCV<=1.0e-9))
{
printf("Warning: LeffCV = %e <= 1.0e-9.",LeffCV);
printf("\n");
}
if
((pModel->BULKMOD!=0))
{
if
((LeffCV_acc<=1.0e-9))
{
printf("Warning: LeffCV_acc = %e <= 1.0e-9.",LeffCV_acc);
printf("\n");
}
}
if
((Weff0<=1.0e-9))
{
printf("Warning: Weff0 = %e <= 1.0e-9.",Weff0);
printf("\n");
}
if
((WeffCV0<=1.0e-9))
{
printf("Warning: WeffCV0 = %e <= 1.0e-9.",WeffCV0);
printf("\n");
}
if
((NBODY_i<=0.0))
{
printf("Fatal: NBODY_i = %e is not positive.",NBODY_i);
printf("\n");
controlled_exit(0);
}
else
{
if
((NBODY_i<=1.0e18))
{
printf("Warning: NBODY_i = %e m^-3 may be too small.",NBODY_i);
printf("\n");
}
}
if
((NGATE_i<0.0))
{
printf("Fatal: NGATE_i = %e is negative.",NGATE_i);
printf("\n");
controlled_exit(0);
}
else
{
if
(((NGATE_i!=0.0)&&(NGATE_i<=1.0e24)))
{
printf("Warning: NGATE_i = %e may be too small.",NGATE_i);
printf("\n");
}
else
{
if
((NGATE_i>1.0e31))
{
printf("Fatal: NGATE_i = %e is too high.",NGATE_i);
printf("\n");
controlled_exit(0);
}
}
}
if
((DVT0_i<0.0))
{
printf("Warning: DVT0_i = %e is negative.",DVT0_i);
printf("\n");
}
if
((PHIG_i<=0.0))
{
printf("Fatal: PHIG_i = %e is not positive.",PHIG_i);
printf("\n");
controlled_exit(0);
}
if
((VSAT_i<=0.0))
{
printf("Fatal: VSAT_i = %e is not positive.",VSAT_i);
printf("\n");
controlled_exit(0);
}
if
((VSAT1_i<=0.0))
{
printf("Fatal: VSAT1_i = %e is not positive.",VSAT1_i);
printf("\n");
controlled_exit(0);
}
if
(((pModel->ASYMMOD!=0)&&(VSAT1R_i<=0.0)))
{
printf("Fatal: VSAT1R_i = %e is not positive.",VSAT1R_i);
printf("\n");
controlled_exit(0);
}
if
((DVT1_i<=0.0))
{
printf("Fatal: DVT1_i = %e is not positive.",DVT1_i);
printf("\n");
controlled_exit(0);
}
if
((DVT1SS_i<=0.0))
{
printf("Fatal: DVT1SS_i = %e is not positive.",DVT1SS_i);
printf("\n");
controlled_exit(0);
}
if
((CDSC_i<0.0))
{
printf("Warning: CDSC_i = %e is negative.",CDSC_i);
printf("\n");
}
if
((CDSCD_i<0.0))
{
printf("Warning: CDSCD_i = %e is negative.",CDSCD_i);
printf("\n");
}
if
(((pModel->ASYMMOD!=0)&&(CDSCDR_i<0.0)))
{
printf("Warning: CDSCDR_i = %e is negative.",CDSCDR_i);
printf("\n");
}
if
((DSUB_i<=0.0))
{
printf("Fatal: DSUB_i = %e is not positive.",DSUB_i);
printf("\n");
controlled_exit(0);
}
if
((ETA0_i<0.0))
{
printf("Warning: ETA0_i = %e is negative, setting it to 0",ETA0_i);
printf("\n");
ETA0_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((ETA0R_i<0.0))
{
printf("Warning: ETA0R_i = %e is negative, setting it to 0",ETA0R_i);
printf("\n");
ETA0R_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((LPE0_i<(-Leff)))
{
printf("Warning: LPE0_i = %e is less than -Leff. Clipping LPE0_i to 0",LPE0_i);
printf("\n");
LPE0_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((K0SI_i<=0.0))
{
printf("Warning: K0SI_i = %e is not positive, setting it to 0.",K0SI_i);
printf("\n");
K0SI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((K2SI_i<=0.0))
{
printf("Warning: K2SI_i = %e is not positive, setting it to 0.",K2SI_i);
printf("\n");
K2SI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
(((PHIBE_i<0.2)&&(pModel->BULKMOD!=0)))
{
printf("Warning: PHIBE_i = %e is less than 0.2, setting it to 0.2.",PHIBE_i);
printf("\n");
PHIBE_i=0.2;
EXIT_IF_ISNAN(0.2)
}
if
(((PHIBE_i>1.2)&&(pModel->BULKMOD!=0)))
{
printf("Warning: PHIBE_i = %e is larger than 1.2, setting it to 1.2.",PHIBE_i);
printf("\n");
PHIBE_i=1.2;
EXIT_IF_ISNAN(1.2)
}
if
((PSAT_i<2.0))
{
printf("Warning: PSAT_i = %e is less than 2.0, setting it to 2.0.",PSAT_i);
printf("\n");
PSAT_i=2.0;
EXIT_IF_ISNAN(2.0)
}
if
((PSATCV_i<2.0))
{
printf("Warning: PSATCV_i = %e is less than 2.0, setting it to 2.0.",PSATCV_i);
printf("\n");
PSATCV_i=2.0;
EXIT_IF_ISNAN(2.0)
}
if
((U0_i<0.0))
{
printf("Warning: U0_i = %e is negative, setting it to the default value.",U0_i);
printf("\n");
U0_i=0.03;
EXIT_IF_ISNAN(0.03)
}
if
((UA_i<0.0))
{
printf("Warning: UA_i = %e is negative, setting it to 0.",UA_i);
printf("\n");
UA_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((EU_i<0.0))
{
printf("Warning: EU_i = %e is negative, setting it to 0.",EU_i);
printf("\n");
EU_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((UD_i<0.0))
{
printf("Warning: UD_i = %e is negative, setting it to 0.",UD_i);
printf("\n");
UD_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((UCS_i<0.0))
{
printf("Warning: UCS_i = %e is negative, setting it to 0.",UCS_i);
printf("\n");
UCS_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((ETAMOB_i<0.0))
{
printf("Warning: ETAMOB_i = %e is negative, setting it to 0",ETAMOB_i);
printf("\n");
ETAMOB_i=0.0;
EXIT_IF_ISNAN(0.0)
}
RDSWMIN_i=pModel->RDSWMIN;
EXIT_IF_ISNAN(pModel->RDSWMIN)
if
((RDSWMIN_i<0.0))
{
printf("Warning: RDSWMIN = %e is negative.  Set to zero",RDSWMIN_i);
printf("\n");
RDSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDSW_i<0.0))
{
printf("Warning: RDSW_i = %e is negative.  Set to zero",RDSW_i);
printf("\n");
RDSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
RSWMIN_i=pModel->RSWMIN;
EXIT_IF_ISNAN(pModel->RSWMIN)
if
((RSWMIN_i<0.0))
{
printf("Warning: RSWMIN = %e is negative.  Set to zero",RSWMIN_i);
printf("\n");
RSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RSW_i<0.0))
{
printf("Warning: RSW_i = %e is negative.  Set to zero",RSW_i);
printf("\n");
RSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
RDWMIN_i=pModel->RDWMIN;
EXIT_IF_ISNAN(pModel->RDWMIN)
if
((RDWMIN_i<0.0))
{
printf("Warning: RDWMIN = %e is negative.  Set to zero",RDWMIN_i);
printf("\n");
RDWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDW_i<0))
{
printf("Warning: RDW_i = %e is negative.  Set to zero",RDW_i);
printf("\n");
RDW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((PRWGD_i<0.0))
{
printf("Warning: PRWGD_i = %e is negative.  Set to zero",PRWGD_i);
printf("\n");
PRWGD_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((PRWGS_i<0.0))
{
printf("Warning: PRWGS_i = %e is negative.  Set to zero",PRWGS_i);
printf("\n");
PRWGS_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((PCLM_i<0))
{
printf("Warning: PCLM_i = %e is negative.",PCLM_i);
printf("\n");
}
if
((PDIBL1_i<0.0))
{
printf("Warning: PDIBL1_i = %e is negative.",PDIBL1_i);
printf("\n");
}
if
((pModel->ASYMMOD!=0))
{
if
((PDIBL1R_i<0.0))
{
printf("Warning: PDIBL1R_i = %e is negative.",PDIBL1R_i);
printf("\n");
}
if
((PDIBL2R_i<0.0))
{
printf("Warning: PDIBL2R_i = %e is negative.",PDIBL2R_i);
printf("\n");
}
if
((U0R_i<0))
{
printf("Warning: U0R_i = %e is negative, setting it to 0.",U0R_i);
printf("\n");
U0R_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((UAR_i<0.0))
{
printf("Warning: UAR_i = %e is negative, setting it to 0.",UAR_i);
printf("\n");
UAR_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((EUR_i<0.0))
{
printf("Warning: EUR_i = %e is negative, setting it to 0.",EUR_i);
printf("\n");
EUR_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((UDR_i<0.0))
{
printf("Warning: UDR_i = %e is negative, setting it to 0.",UDR_i);
printf("\n");
UDR_i=0.0;
EXIT_IF_ISNAN(0.0)
}
}
if
((PDIBL2_i<0.0))
{
printf("Warning: PDIBL2_i = %e is negative.",PDIBL2_i);
printf("\n");
}
if
((DROUT_i<=0.0))
{
printf("Fatal: DROUT_i = %e is non-positive.",DROUT_i);
printf("\n");
controlled_exit(0);
}
if
((MEXP_i<2.0))
{
printf("Warning: MEXP_i = %e < 2. Setting MEXP_i = 2.",MEXP_i);
printf("\n");
MEXP_i=2.0;
EXIT_IF_ISNAN(2.0)
}
if
((pModel->ASYMMOD!=0))
{
if
((MEXPR_i<2.0))
{
printf("Warning: MEXPR_i = %e < 2.  Setting MEXPR_i = 2.",MEXPR_i);
printf("\n");
MEXPR_i=2.0;
EXIT_IF_ISNAN(2.0)
}
}
if
((PTWG_i<0))
{
printf("Warning: PTWG_i = %e is negative, setting it to 0.",PTWG_i);
printf("\n");
PTWG_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((QMTCENCV_i>0.0))
{
if
((pModel->QM0<=0.0))
{
printf("Fatal: QM0 = %e is non-positive.",pModel->QM0);
printf("\n");
controlled_exit(0);
}
}
if
(((pModel->BULKMOD!=0)&&(QMTCENCVA_i>0.0)))
{
if
((pModel->QM0ACC<=0.0))
{
printf("Fatal: QM0ACC = %e is non-positive.",pModel->QM0ACC);
printf("\n");
controlled_exit(0);
}
}
if
((CGIDL_i<0.0))
{
printf("Warning: CGIDL_i = %e < 0.  Setting CGIDL_i = 0.",CGIDL_i);
printf("\n");
CGIDL_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((CGISL_i<0.0))
{
printf("Warning: CGISL_i = %e < 0.  Setting CGISL_i = 0.",CGISL_i);
printf("\n");
CGISL_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((pModel->IGBMOD!=0))
{
if
((NIGBINV_i<=0.0))
{
printf("Fatal: NIGBINV_i = %e is non-positive.",NIGBINV_i);
printf("\n");
controlled_exit(0);
}
if
((NIGBACC_i<=0.0))
{
printf("Fatal: NIGBACC_i = %e is non-positive.",NIGBACC_i);
printf("\n");
controlled_exit(0);
}
}
if
((pModel->IGCMOD!=0))
{
if
((POXEDGE_i<=0.0))
{
printf("Fatal: POXEDGE_i = %e is non-positive.",POXEDGE_i);
printf("\n");
controlled_exit(0);
}
if
((PIGCD_i<=0.0))
{
printf("Fatal: PIGCD_i = %e is non-positive.",PIGCD_i);
printf("\n");
controlled_exit(0);
}
}
if
(((pModel->IGCMOD!=0)||(pModel->IGBMOD!=0)))
{
if
((pModel->TOXREF<=0))
{
printf("Fatal: TOXREF = %e is non-positive.",pModel->TOXREF);
printf("\n");
controlled_exit(0);
}
}
if
((pModel->LINTIGEN>=(Leff/2.0)))
{
printf("Warning: LINTIGEN = %e is too large - Leff for r/g current is negative.  Re-setting LINTIGEN = 0.",pModel->LINTIGEN);
printf("\n");
LINTIGEN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
LINTIGEN_i=pModel->LINTIGEN;
EXIT_IF_ISNAN(pModel->LINTIGEN)
}
if
((NTGEN_i<=0.0))
{
printf("Fatal: NTGEN_i = %e is non-positive.",NTGEN_i);
printf("\n");
controlled_exit(0);
}
if
((pModel->IIMOD==2))
{
if
((BETAII0_i<0.0))
{
printf("Warning:  BETAII0_i = %e is negative.",BETAII0_i);
printf("\n");
}
if
((BETAII1_i<0.0))
{
printf("Warning:  BETAII1_i = %e is negative.",BETAII1_i);
printf("\n");
}
if
((BETAII2_i<0.0))
{
printf("Warning:  BETAII2_i = %e is negative.",BETAII2_i);
printf("\n");
}
if
((ESATII_i<0.0))
{
printf("Warning:  ESATII_i = %e is negative.",ESATII_i);
printf("\n");
}
if
((LII_i<0.0))
{
printf("Warning:  LII_i = %e is negative.",LII_i);
printf("\n");
}
if
((SII1_i<0.0))
{
printf("Warning:  SII1_i = %e is negative.",pModel->SII1);
printf("\n");
}
if
((SII2_i<0.0))
{
printf("Warning:  SII2_i = %e is negative.",SII2_i);
printf("\n");
}
if
((SIID_i<0.0))
{
printf("Warning:  SIID_i = %e is negative.",SIID_i);
printf("\n");
}
}
if
((pModel->EF<=0.0))
{
printf("Fatal: EF = %e is non-positive.",pModel->EF);
printf("\n");
controlled_exit(0);
}
else
{
if
((pModel->EF>2.0))
{
printf("Fatal: EF = %e > 2.0.",pModel->EF);
printf("\n");
controlled_exit(0);
}
}
if
((pModel->LINTNOI>=(Leff/2.0)))
{
printf("Warning: LINTNOI = %e is too large - Leff for noise is negative.  Re-setting LINTNOI = 0.",pModel->LINTNOI);
printf("\n");
LINTNOI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
LINTNOI_i=pModel->LINTNOI;
EXIT_IF_ISNAN(pModel->LINTNOI)
}
if
((pModel->NTNOI<0))
{
printf("Warning: NTNOI = %e is negative. Set to zero.",pModel->NTNOI);
printf("\n");
NTNOI_i=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
NTNOI_i=pModel->NTNOI;
EXIT_IF_ISNAN(pModel->NTNOI)
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0.0)))
{
T1y=pModel->WTH0;
EXIT_IF_ISNAN(pModel->WTH0)
if
((pModel->BSHEXP!=0.0))
{
{
double m00_pow(d00_pow0,pInst->NF,pModel->BSHEXP)
T1y=(pModel->WTH0*d00_pow0);
EXIT_IF_ISNAN((pModel->WTH0*d00_pow0))
}
}
T2y=pInst->FPITCH;
EXIT_IF_ISNAN(pInst->FPITCH)
if
((pModel->ASHEXP!=0.0))
{
{
double m00_pow(d00_pow0,NFINtotal,pModel->ASHEXP)
T2y=(pInst->FPITCH*d00_pow0);
EXIT_IF_ISNAN((pInst->FPITCH*d00_pow0))
}
}
gth=((T1y+T2y)/pModel->RTH0);
EXIT_IF_ISNAN(((T1y+T2y)/pModel->RTH0))
#if defined(_DYNAMIC)
cth=(pModel->CTH0*(T1y+T2y));
EXIT_IF_ISNAN((pModel->CTH0*(T1y+T2y)))
#endif
}
else
{
gth=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DYNAMIC)
cth=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
if
((pModel->RGATEMOD!=0))
{
Rgeltd=(((pModel->RGEXT/pInst->NGCON)+((pModel->RGFIN*pInst->NFIN)/((pInst->NGCON==2)?12.0:3.0)))/pInst->NF);
EXIT_IF_ISNAN((((pModel->RGEXT/pInst->NGCON)+((pModel->RGFIN*pInst->NFIN)/((pInst->NGCON==2)?12.0:3.0)))/pInst->NF))
{
double m00_max(d00_max0,1.0e-3,Rgeltd)
ggeltd=(1.0/d00_max0);
EXIT_IF_ISNAN((1.0/d00_max0))
}
}
if
((pModel->RGEOMOD==0))
{
RSourceGeo=(pModel->RSHS*pInst->NRS);
EXIT_IF_ISNAN((pModel->RSHS*pInst->NRS))
RDrainGeo=(pModel->RSHD*pInst->NRD);
EXIT_IF_ISNAN((pModel->RSHD*pInst->NRD))
}
else
{
if
((pModel->HEPI>0.0))
{
Arsd=((pInst->FPITCH*pModel->HFIN)+((pInst->TFIN+((pInst->FPITCH-pInst->TFIN)*pModel->CRATIO))*pModel->HEPI));
EXIT_IF_ISNAN(((pInst->FPITCH*pModel->HFIN)+((pInst->TFIN+((pInst->FPITCH-pInst->TFIN)*pModel->CRATIO))*pModel->HEPI)))
}
else
{
{
double m00_max(d00_max0,1.0e-9,(pModel->HFIN+pModel->HEPI))
Arsd=(pInst->FPITCH*d00_max0);
EXIT_IF_ISNAN((pInst->FPITCH*d00_max0))
}
}
Prsd=(pInst->FPITCH+pModel->DELTAPRSD);
EXIT_IF_ISNAN((pInst->FPITCH+pModel->DELTAPRSD))
if
((model->RHORSD_Given))
{
rhorsd=pModel->RHORSD;
EXIT_IF_ISNAN(pModel->RHORSD)
}
else
{
mu_max=((pModel->TYPE==1)?1417.0:470.5);
EXIT_IF_ISNAN(((pModel->TYPE==1)?1417.0:470.5))
if
((pModel->TYPE==1))
{
{
double m00_pow(d00_pow0,(pModel->NSD/9.68e22),0.680)
double m00_pow(d00_pow1,(3.43e26/pModel->NSD),2.0)
mu_rsd=(((52.2+((mu_max-52.2)/(1.0+d00_pow0)))-(43.4/(1.0+d00_pow1)))*1.0e-4);
EXIT_IF_ISNAN((((52.2+((mu_max-52.2)/(1.0+d00_pow0)))-(43.4/(1.0+d00_pow1)))*1.0e-4))
}
}
else
{
{
double m00_pow(d00_pow0,(pModel->NSD/2.23e22),0.719)
double m00_pow(d00_pow1,(6.10e26/pModel->NSD),2.0)
mu_rsd=(((44.9+((mu_max-44.9)/(1.0+d00_pow0)))-(29.0/(1.0+d00_pow1)))*1.0e-4);
EXIT_IF_ISNAN((((44.9+((mu_max-44.9)/(1.0+d00_pow0)))-(29.0/(1.0+d00_pow1)))*1.0e-4))
}
}
rhorsd=(1.0/((1.60219e-19*pModel->NSD)*mu_rsd));
EXIT_IF_ISNAN((1.0/((1.60219e-19*pModel->NSD)*mu_rsd)))
}
thetarsp=((55.0*3.14159265358979323846)/180.0);
EXIT_IF_ISNAN(((55.0*3.14159265358979323846)/180.0))
{
double m00_min(d00_min0,0.0,pModel->HEPI)
double m00_max(d00_max1,1.0e-18,(pInst->TFIN*(pModel->HFIN+d00_min0)))
double m00_min(d00_min2,Arsd,d00_max1)
afin=d00_min2;
EXIT_IF_ISNAN(d00_min2)
}
{
double m00_tan(d00_tan0,thetarsp)
T1y=((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/d00_tan0)));
EXIT_IF_ISNAN(((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/d00_tan0))))
}
{
double m00_sqrt(d00_sqrt0,3.14159265358979323846)
double m00_sqrt(d00_sqrt1,afin)
double m00_sqrt(d00_sqrt2,Arsd)
double m00_sqrt(d00_sqrt3,(afin/(Arsd*Arsd)))
Rsp=(((rhorsd*T1y)/(d00_sqrt0*pInst->NFIN))*(((1.0/d00_sqrt1)-(2.0/d00_sqrt2))+d00_sqrt3));
EXIT_IF_ISNAN((((rhorsd*T1y)/(d00_sqrt0*pInst->NFIN))*(((1.0/d00_sqrt1)-(2.0/d00_sqrt2))+d00_sqrt3)))
}
arsd_total=((Arsd*pInst->NFIN)+pModel->ARSDEND);
EXIT_IF_ISNAN(((Arsd*pInst->NFIN)+pModel->ARSDEND))
prsd_total=((Prsd*pInst->NFIN)+pModel->PRSDEND);
EXIT_IF_ISNAN(((Prsd*pInst->NFIN)+pModel->PRSDEND))
{
double m00_sqrt(d00_sqrt0,((pModel->RHOC*arsd_total)/(rhorsd*prsd_total)))
lt=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
alpha=(pInst->LRSD/lt);
EXIT_IF_ISNAN((pInst->LRSD/lt))
T0y=bsimcmg_lexp((alpha+alpha));
EXIT_IF_ISNAN(bsimcmg_lexp((alpha+alpha)))
if
((pModel->SDTERM==1.0))
{
eta=((rhorsd*lt)/pModel->RHOC);
EXIT_IF_ISNAN(((rhorsd*lt)/pModel->RHOC))
T1y=(T0y*(1.0+eta));
EXIT_IF_ISNAN((T0y*(1.0+eta)))
T2y=((T1y+1.0)-eta);
EXIT_IF_ISNAN(((T1y+1.0)-eta))
T3y=((T1y-1.0)+eta);
EXIT_IF_ISNAN(((T1y-1.0)+eta))
}
else
{
T2y=(T0y+1.0);
EXIT_IF_ISNAN((T0y+1.0))
T3y=(T0y-1.0);
EXIT_IF_ISNAN((T0y-1.0))
}
RrsdTML=(((rhorsd*lt)*T2y)/(arsd_total*T3y));
EXIT_IF_ISNAN((((rhorsd*lt)*T2y)/(arsd_total*T3y)))
if
((pModel->HEPI<(-1.0e-10)))
{
Rrsdside=(pModel->RHOC/(((-pModel->HEPI)*pInst->TFIN)*pInst->NFIN));
EXIT_IF_ISNAN((pModel->RHOC/(((-pModel->HEPI)*pInst->TFIN)*pInst->NFIN)))
Rrsd=(((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
EXIT_IF_ISNAN((((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside)))
}
else
{
Rrsd=(RrsdTML+Rsp);
EXIT_IF_ISNAN((RrsdTML+Rsp))
}
{
double m00_max(d00_max0,0.0,((((pModel->RGEOA+(pModel->RGEOB*pInst->TFIN))+(pModel->RGEOC*pInst->FPITCH))+(pModel->RGEOD*pInst->LRSD))+(pModel->RGEOE*pModel->HEPI)))
Rdsgeo=((Rrsd/pInst->NF)*d00_max0);
EXIT_IF_ISNAN(((Rrsd/pInst->NF)*d00_max0))
}
RSourceGeo=Rdsgeo;
EXIT_IF_ISNAN(Rdsgeo)
RDrainGeo=Rdsgeo;
EXIT_IF_ISNAN(Rdsgeo)
}
if
((RSourceGeo<=1.0e-3))
{
RSourceGeo=1.0e-3;
EXIT_IF_ISNAN(1.0e-3)
}
if
((RDrainGeo<=1.0e-3))
{
RDrainGeo=1.0e-3;
EXIT_IF_ISNAN(1.0e-3)
}
if
((pModel->RDSMOD==1))
{
if
((RSWMIN_i<=0.0))
{
RSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDWMIN_i<=0.0))
{
RDWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RSW_i<=0.0))
{
RSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDW_i<=0.0))
{
RDW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
if
((RDSWMIN_i<=0.0))
{
RDSWMIN_i=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((RDSW_i<=0.0))
{
RDSW_i=0.0;
EXIT_IF_ISNAN(0.0)
}
}
#ifdef _DYNAMIC
if
((pModel->CGEOMOD!=1))
{
#ifdef _DYNAMIC
if
((model->CGSO_Given))
{
#if defined(_DYNAMIC)
CGSO_i=pModel->CGSO;
EXIT_IF_ISNAN(pModel->CGSO)
#endif
}
else
{
#ifdef _DYNAMIC
if
(((model->DLC_Given)&&(pModel->DLC>0.0)))
{
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,((pModel->DLC*cox)-CGSL_i))
CGSO_i=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
CGSO_i=((0.3*pInst->TFIN)*cox);
EXIT_IF_ISNAN(((0.3*pInst->TFIN)*cox))
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((model->CGDO_Given))
{
#if defined(_DYNAMIC)
CGDO_i=pModel->CGDO;
EXIT_IF_ISNAN(pModel->CGDO)
#endif
}
else
{
#ifdef _DYNAMIC
if
(((model->DLC_Given)&&(pModel->DLC>0.0)))
{
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,((pModel->DLC*cox)-CGDL_i))
CGDO_i=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#endif
}
else
{
#if defined(_DYNAMIC)
CGDO_i=((0.3*pInst->TFIN)*cox);
EXIT_IF_ISNAN(((0.3*pInst->TFIN)*cox))
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
}
#endif /* if(...) */
if
((pModel->CGEOMOD==2))
{
if
((model->LSP_Given))
{
LSP_i=pModel->LSP;
EXIT_IF_ISNAN(pModel->LSP)
}
else
{
LSP_i=(0.2*(pInst->L+pModel->XL));
EXIT_IF_ISNAN((0.2*(pInst->L+pModel->XL)))
}
#if defined(_DYNAMIC)
Hg=(pModel->TGATE+pModel->TMASK);
EXIT_IF_ISNAN((pModel->TGATE+pModel->TMASK))
#endif
#if defined(_DYNAMIC)
Trsd=(0.5*(pInst->FPITCH-pInst->TFIN));
EXIT_IF_ISNAN((0.5*(pInst->FPITCH-pInst->TFIN)))
#endif
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,(Trsd-pModel->TOXP))
Wg=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#endif
{
double m00_max(d00_max0,0.0,(pModel->HEPI+pModel->TSILI))
Hrsd=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
if
((pModel->TMASK>0.0))
{
T0y=(3.467e-11*bsimcmg_lln(((1.0e-7*pModel->EPSRSP)/(3.9*LSP_i))));
EXIT_IF_ISNAN((3.467e-11*bsimcmg_lln(((1.0e-7*pModel->EPSRSP)/(3.9*LSP_i)))))
T1y=(((0.942*Hrsd)*epssp)/LSP_i);
EXIT_IF_ISNAN((((0.942*Hrsd)*epssp)/LSP_i))
#if defined(_DYNAMIC)
Cgg_top=((T0y+T1y)*(pInst->TFIN+((pInst->FPITCH-pInst->TFIN)*pModel->CRATIO)));
EXIT_IF_ISNAN(((T0y+T1y)*(pInst->TFIN+((pInst->FPITCH-pInst->TFIN)*pModel->CRATIO))))
#endif
}
else
{
{
#if defined(_DYNAMIC)
x42_Hr=(2.3+((0.2*(Hg+pModel->TOXP))/Hrsd));
EXIT_IF_ISNAN((2.3+((0.2*(Hg+pModel->TOXP))/Hrsd)))
#endif
#if defined(_DYNAMIC)
x42_Lr=1.05;
EXIT_IF_ISNAN(1.05)
#endif
#if defined(_DYNAMIC)
{
double m00_fabs(d00_fabs0,((Hg+pModel->TOXP)-Hrsd))
x42_Hgdelta=d00_fabs0;
EXIT_IF_ISNAN(d00_fabs0)
}
#endif
#if defined(_DYNAMIC)
x42_Lmax=(LSP_i*x42_Lr);
EXIT_IF_ISNAN((LSP_i*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,Hrsd,(Hg+pModel->TOXP))
x42_y=d00_min0;
EXIT_IF_ISNAN(d00_min0)
}
#endif
#if defined(_DYNAMIC)
x42_x=(LSP_i/(x42_Hr+1.0));
EXIT_IF_ISNAN((LSP_i/(x42_Hr+1.0)))
#endif
#if defined(_DYNAMIC)
x42_Cnon=1.7e12;
EXIT_IF_ISNAN(1.7e12)
#endif
#if defined(_DYNAMIC)
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
EXIT_IF_ISNAN(((epssp*(x42_y-x42_x))/LSP_i))
#endif
#if defined(_DYNAMIC)
x42_TT1=(x42_Cnon*x42_CcgSat);
EXIT_IF_ISNAN((x42_Cnon*x42_CcgSat))
#endif
#ifdef _DYNAMIC
if
((x42_TT1>80.0))
{
#if defined(_DYNAMIC)
x42_Ccg1=x42_CcgSat;
EXIT_IF_ISNAN(x42_CcgSat)
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0+bsimcmg_lexp(x42_TT1)))
x42_Ccg1=((1.0/x42_Cnon)*d00_logE0);
EXIT_IF_ISNAN(((1.0/x42_Cnon)*d00_logE0))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,(Hrsd/(Hg+pModel->TOXP)),((Hg+pModel->TOXP)/Hrsd))
x42_r1cf=(0.5*d00_min0);
EXIT_IF_ISNAN((0.5*d00_min0))
}
#endif
#if defined(_DYNAMIC)
x42_Rcf=(x42_Hgdelta*x42_r1cf);
EXIT_IF_ISNAN((x42_Hgdelta*x42_r1cf))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i))
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*d00_logE0);
EXIT_IF_ISNAN((((epssp*2)/3.14159265358979323846)*d00_logE0))
}
#endif
#if defined(_DYNAMIC)
x42_Ccg=(pInst->TFIN*(x42_Ccg1+x42_Ccg2));
EXIT_IF_ISNAN((pInst->TFIN*(x42_Ccg1+x42_Ccg2)))
#endif
#if defined(_DYNAMIC)
x42_x=(x42_Lmax/Hg);
EXIT_IF_ISNAN((x42_Lmax/Hg))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(2.0*(x42_x+1)))
x42_C1=(4.0/(d00_sqrt0*3.14159265358979323846));
EXIT_IF_ISNAN((4.0/(d00_sqrt0*3.14159265358979323846)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((pModel->TOXP*pModel->TOXP)+((2.0*Hg)*pModel->TOXP))+((Hg*Hg)*(x42_x+1))))
double m00_sqrt(d00_sqrt1,(x42_x+1))
x42_C2=((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Hg*x42_x))+Hg);
EXIT_IF_ISNAN(((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Hg*x42_x))+Hg))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_x+1)*(x42_x+4)))
x42_C3=((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2)));
EXIT_IF_ISNAN(((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2))))
}
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(x42_C2/x42_C3))
x42_Cfglog=(epssp*((x42_C1*d00_logE0)+12.27));
EXIT_IF_ISNAN((epssp*((x42_C1*d00_logE0)+12.27)))
}
#endif
#if defined(_DYNAMIC)
x42_dcf=(x42_Hr*x42_Lr);
EXIT_IF_ISNAN((x42_Hr*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_dcf*x42_dcf)+1.0))
x42_TT0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((x42_dcf*x42_dcf)+1)*((((x42_dcf*pModel->TOXP)*(x42_dcf*pModel->TOXP))+(((2*x42_dcf)*x42_Lmax)*pModel->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))
x42_TT1=(((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
EXIT_IF_ISNAN((((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax))
}
#endif
#if defined(_DYNAMIC)
x42_TT2=((x42_TT0+1.0)*(x42_dcf*pModel->TOXP));
EXIT_IF_ISNAN(((x42_TT0+1.0)*(x42_dcf*pModel->TOXP)))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,2)
double m00_logE(d00_logE1,(x42_TT1/x42_TT2))
x42_Cfgsat=(((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*d00_logE1);
EXIT_IF_ISNAN((((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*d00_logE1))
}
#endif
#if defined(_DYNAMIC)
x42_delta=1.2e-12;
EXIT_IF_ISNAN(1.2e-12)
#endif
#if defined(_DYNAMIC)
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
EXIT_IF_ISNAN(((x42_Cfgsat-x42_Cfglog)-x42_delta))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))
Cfg=(pInst->TFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0))));
EXIT_IF_ISNAN((pInst->TFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0)))))
}
#endif
#if defined(_DYNAMIC)
Cgg_top=(x42_Ccg+Cfg);
EXIT_IF_ISNAN((x42_Ccg+Cfg))
#endif
}
}
#ifdef _DYNAMIC
if
((pModel->TMASK>0))
{
{
#if defined(_DYNAMIC)
x42_Hr=(2.3+((0.2*(Wg+pModel->TOXP))/Trsd));
EXIT_IF_ISNAN((2.3+((0.2*(Wg+pModel->TOXP))/Trsd)))
#endif
#if defined(_DYNAMIC)
x42_Lr=1.05;
EXIT_IF_ISNAN(1.05)
#endif
#if defined(_DYNAMIC)
{
double m00_fabs(d00_fabs0,((Wg+pModel->TOXP)-Trsd))
x42_Hgdelta=d00_fabs0;
EXIT_IF_ISNAN(d00_fabs0)
}
#endif
#if defined(_DYNAMIC)
x42_Lmax=(LSP_i*x42_Lr);
EXIT_IF_ISNAN((LSP_i*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,Trsd,(Wg+pModel->TOXP))
x42_y=d00_min0;
EXIT_IF_ISNAN(d00_min0)
}
#endif
#if defined(_DYNAMIC)
x42_x=(LSP_i/(x42_Hr+1.0));
EXIT_IF_ISNAN((LSP_i/(x42_Hr+1.0)))
#endif
#if defined(_DYNAMIC)
x42_Cnon=1.7e12;
EXIT_IF_ISNAN(1.7e12)
#endif
#if defined(_DYNAMIC)
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
EXIT_IF_ISNAN(((epssp*(x42_y-x42_x))/LSP_i))
#endif
#if defined(_DYNAMIC)
x42_TT1=(x42_Cnon*x42_CcgSat);
EXIT_IF_ISNAN((x42_Cnon*x42_CcgSat))
#endif
#ifdef _DYNAMIC
if
((x42_TT1>80.0))
{
#if defined(_DYNAMIC)
x42_Ccg1=x42_CcgSat;
EXIT_IF_ISNAN(x42_CcgSat)
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0+bsimcmg_lexp(x42_TT1)))
x42_Ccg1=((1.0/x42_Cnon)*d00_logE0);
EXIT_IF_ISNAN(((1.0/x42_Cnon)*d00_logE0))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,(Trsd/(Wg+pModel->TOXP)),((Wg+pModel->TOXP)/Trsd))
x42_r1cf=(0.5*d00_min0);
EXIT_IF_ISNAN((0.5*d00_min0))
}
#endif
#if defined(_DYNAMIC)
x42_Rcf=(x42_Hgdelta*x42_r1cf);
EXIT_IF_ISNAN((x42_Hgdelta*x42_r1cf))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i))
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*d00_logE0);
EXIT_IF_ISNAN((((epssp*2)/3.14159265358979323846)*d00_logE0))
}
#endif
#if defined(_DYNAMIC)
x42_Ccg=(pModel->HFIN*(x42_Ccg1+x42_Ccg2));
EXIT_IF_ISNAN((pModel->HFIN*(x42_Ccg1+x42_Ccg2)))
#endif
#if defined(_DYNAMIC)
x42_x=(x42_Lmax/Wg);
EXIT_IF_ISNAN((x42_Lmax/Wg))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(2.0*(x42_x+1)))
x42_C1=(4.0/(d00_sqrt0*3.14159265358979323846));
EXIT_IF_ISNAN((4.0/(d00_sqrt0*3.14159265358979323846)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((pModel->TOXP*pModel->TOXP)+((2.0*Wg)*pModel->TOXP))+((Wg*Wg)*(x42_x+1))))
double m00_sqrt(d00_sqrt1,(x42_x+1))
x42_C2=((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Wg*x42_x))+Wg);
EXIT_IF_ISNAN(((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Wg*x42_x))+Wg))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_x+1)*(x42_x+4)))
x42_C3=((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2)));
EXIT_IF_ISNAN(((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2))))
}
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(x42_C2/x42_C3))
x42_Cfglog=(epssp*((x42_C1*d00_logE0)+12.27));
EXIT_IF_ISNAN((epssp*((x42_C1*d00_logE0)+12.27)))
}
#endif
#if defined(_DYNAMIC)
x42_dcf=(x42_Hr*x42_Lr);
EXIT_IF_ISNAN((x42_Hr*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_dcf*x42_dcf)+1.0))
x42_TT0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((x42_dcf*x42_dcf)+1)*((((x42_dcf*pModel->TOXP)*(x42_dcf*pModel->TOXP))+(((2*x42_dcf)*x42_Lmax)*pModel->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))
x42_TT1=(((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
EXIT_IF_ISNAN((((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax))
}
#endif
#if defined(_DYNAMIC)
x42_TT2=((x42_TT0+1.0)*(x42_dcf*pModel->TOXP));
EXIT_IF_ISNAN(((x42_TT0+1.0)*(x42_dcf*pModel->TOXP)))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,2)
double m00_logE(d00_logE1,(x42_TT1/x42_TT2))
x42_Cfgsat=(((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.70)*x42_dcf)/x42_TT0)*d00_logE1);
EXIT_IF_ISNAN((((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.70)*x42_dcf)/x42_TT0)*d00_logE1))
}
#endif
#if defined(_DYNAMIC)
x42_delta=1.2e-12;
EXIT_IF_ISNAN(1.2e-12)
#endif
#if defined(_DYNAMIC)
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
EXIT_IF_ISNAN(((x42_Cfgsat-x42_Cfglog)-x42_delta))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))
Cfg=(pModel->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0))));
EXIT_IF_ISNAN((pModel->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0)))))
}
#endif
#if defined(_DYNAMIC)
Cgg_side=(x42_Ccg+Cfg);
EXIT_IF_ISNAN((x42_Ccg+Cfg))
#endif
}
}
else
{
{
#if defined(_DYNAMIC)
x42_Hr=(2.3+((0.2*(Wg+pModel->TOXP))/Trsd));
EXIT_IF_ISNAN((2.3+((0.2*(Wg+pModel->TOXP))/Trsd)))
#endif
#if defined(_DYNAMIC)
x42_Lr=1.05;
EXIT_IF_ISNAN(1.05)
#endif
#if defined(_DYNAMIC)
{
double m00_fabs(d00_fabs0,((Wg+pModel->TOXP)-Trsd))
x42_Hgdelta=d00_fabs0;
EXIT_IF_ISNAN(d00_fabs0)
}
#endif
#if defined(_DYNAMIC)
x42_Lmax=(LSP_i*x42_Lr);
EXIT_IF_ISNAN((LSP_i*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,Trsd,(Wg+pModel->TOXP))
x42_y=d00_min0;
EXIT_IF_ISNAN(d00_min0)
}
#endif
#if defined(_DYNAMIC)
x42_x=(LSP_i/(x42_Hr+1.0));
EXIT_IF_ISNAN((LSP_i/(x42_Hr+1.0)))
#endif
#if defined(_DYNAMIC)
x42_Cnon=1.7e12;
EXIT_IF_ISNAN(1.7e12)
#endif
#if defined(_DYNAMIC)
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
EXIT_IF_ISNAN(((epssp*(x42_y-x42_x))/LSP_i))
#endif
#if defined(_DYNAMIC)
x42_TT1=(x42_Cnon*x42_CcgSat);
EXIT_IF_ISNAN((x42_Cnon*x42_CcgSat))
#endif
#ifdef _DYNAMIC
if
((x42_TT1>80.0))
{
#if defined(_DYNAMIC)
x42_Ccg1=x42_CcgSat;
EXIT_IF_ISNAN(x42_CcgSat)
#endif
}
else
{
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(1.0+bsimcmg_lexp(x42_TT1)))
x42_Ccg1=((1.0/x42_Cnon)*d00_logE0);
EXIT_IF_ISNAN(((1.0/x42_Cnon)*d00_logE0))
}
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
{
double m00_min(d00_min0,(Trsd/(Wg+pModel->TOXP)),((Wg+pModel->TOXP)/Trsd))
x42_r1cf=(0.5*d00_min0);
EXIT_IF_ISNAN((0.5*d00_min0))
}
#endif
#if defined(_DYNAMIC)
x42_Rcf=(x42_Hgdelta*x42_r1cf);
EXIT_IF_ISNAN((x42_Hgdelta*x42_r1cf))
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i))
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*d00_logE0);
EXIT_IF_ISNAN((((epssp*2)/3.14159265358979323846)*d00_logE0))
}
#endif
#if defined(_DYNAMIC)
x42_Ccg=(pModel->HFIN*(x42_Ccg1+x42_Ccg2));
EXIT_IF_ISNAN((pModel->HFIN*(x42_Ccg1+x42_Ccg2)))
#endif
#if defined(_DYNAMIC)
x42_x=(x42_Lmax/Wg);
EXIT_IF_ISNAN((x42_Lmax/Wg))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(2.0*(x42_x+1)))
x42_C1=(4.0/(d00_sqrt0*3.14159265358979323846));
EXIT_IF_ISNAN((4.0/(d00_sqrt0*3.14159265358979323846)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((pModel->TOXP*pModel->TOXP)+((2.0*Wg)*pModel->TOXP))+((Wg*Wg)*(x42_x+1))))
double m00_sqrt(d00_sqrt1,(x42_x+1))
x42_C2=((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Wg*x42_x))+Wg);
EXIT_IF_ISNAN(((((d00_sqrt0*d00_sqrt1)+pModel->TOXP)+(Wg*x42_x))+Wg))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_x+1)*(x42_x+4)))
x42_C3=((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2)));
EXIT_IF_ISNAN(((pModel->TOXP*d00_sqrt0)+(pModel->TOXP*(x42_x+2))))
}
#endif
#if defined(_DYNAMIC)
{
double m00_logE(d00_logE0,(x42_C2/x42_C3))
x42_Cfglog=(epssp*((x42_C1*d00_logE0)+12.27));
EXIT_IF_ISNAN((epssp*((x42_C1*d00_logE0)+12.27)))
}
#endif
#if defined(_DYNAMIC)
x42_dcf=(x42_Hr*x42_Lr);
EXIT_IF_ISNAN((x42_Hr*x42_Lr))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_dcf*x42_dcf)+1.0))
x42_TT0=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(((x42_dcf*x42_dcf)+1)*((((x42_dcf*pModel->TOXP)*(x42_dcf*pModel->TOXP))+(((2*x42_dcf)*x42_Lmax)*pModel->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))
x42_TT1=(((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
EXIT_IF_ISNAN((((d00_sqrt0+(x42_dcf*pModel->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax))
}
#endif
#if defined(_DYNAMIC)
x42_TT2=((x42_TT0+1.0)*(x42_dcf*pModel->TOXP));
EXIT_IF_ISNAN(((x42_TT0+1.0)*(x42_dcf*pModel->TOXP)))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,2)
double m00_logE(d00_logE1,(x42_TT1/x42_TT2))
x42_Cfgsat=(((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*d00_logE1);
EXIT_IF_ISNAN((((((((2.0*epssp)*d00_sqrt0)/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*d00_logE1))
}
#endif
#if defined(_DYNAMIC)
x42_delta=1.2e-12;
EXIT_IF_ISNAN(1.2e-12)
#endif
#if defined(_DYNAMIC)
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
EXIT_IF_ISNAN(((x42_Cfgsat-x42_Cfglog)-x42_delta))
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))
Cfg=(pModel->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0))));
EXIT_IF_ISNAN((pModel->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+d00_sqrt0)))))
}
#endif
#if defined(_DYNAMIC)
Cgg_side=(x42_Ccg+Cfg);
EXIT_IF_ISNAN((x42_Ccg+Cfg))
#endif
}
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->TMASK>0.0))
{
#if defined(_DYNAMIC)
Acorner=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
else
{
#ifdef _DYNAMIC
if
((pModel->HEPI>0.0))
{
#if defined(_DYNAMIC)
Acorner=((pInst->FPITCH-pInst->TFIN)*((pModel->HEPI*pModel->CRATIO)+pModel->TSILI));
EXIT_IF_ISNAN(((pInst->FPITCH-pInst->TFIN)*((pModel->HEPI*pModel->CRATIO)+pModel->TSILI)))
#endif
}
else
{
#if defined(_DYNAMIC)
Acorner=((pInst->FPITCH-pInst->TFIN)*Hrsd);
EXIT_IF_ISNAN(((pInst->FPITCH-pInst->TFIN)*Hrsd))
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
#if defined(_DYNAMIC)
Ccorner=(((((pInst->NFIN*Acorner)+pModel->ARSDEND)+pModel->ASILIEND)*epssp)/LSP_i);
EXIT_IF_ISNAN((((((pInst->NFIN*Acorner)+pModel->ARSDEND)+pModel->ASILIEND)*epssp)/LSP_i))
#endif
#if defined(_DYNAMIC)
Cfr_geo=(((Ccorner+(Cgg_top*pInst->NFIN))+(((pModel->CGEOE*Cgg_side)*pInst->NFIN)*2.0))*pInst->NF);
EXIT_IF_ISNAN((((Ccorner+(Cgg_top*pInst->NFIN))+(((pModel->CGEOE*Cgg_side)*pInst->NFIN)*2.0))*pInst->NF))
#endif
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,(((pModel->CGEOA+(pModel->CGEOB*pInst->TFIN))+(pModel->CGEOC*pInst->FPITCH))+(pModel->CGEOD*pInst->LRSD)))
Cfr_geo=(Cfr_geo*d00_max0);
EXIT_IF_ISNAN((Cfr_geo*d00_max0))
}
#endif
}
T0y=(pModel->CSDESW*bsimcmg_lln((1.0+(pModel->HFIN/pModel->EOTBOX))));
EXIT_IF_ISNAN((pModel->CSDESW*bsimcmg_lln((1.0+(pModel->HFIN/pModel->EOTBOX)))))
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,(pInst->PSEO-(pInst->FPITCH*NFINtotal)))
csbox=((cbox*pInst->ASEO)+(T0y*d00_max0));
EXIT_IF_ISNAN(((cbox*pInst->ASEO)+(T0y*d00_max0)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_max(d00_max0,0.0,(pInst->PDEO-(pInst->FPITCH*NFINtotal)))
cdbox=((cbox*pInst->ADEO)+(T0y*d00_max0));
EXIT_IF_ISNAN(((cbox*pInst->ADEO)+(T0y*d00_max0)))
}
#endif
#if defined(_DYNAMIC)
cgbox=((((pModel->CGBO*pInst->NF)*pInst->NGCON)+(pModel->CGBN*NFINtotal))*Lg);
EXIT_IF_ISNAN(((((pModel->CGBO*pInst->NF)*pInst->NGCON)+(pModel->CGBN*NFINtotal))*Lg))
#endif
EeffFactor=(1.0e-8/(epsratio*pModel->EOT));
EXIT_IF_ISNAN((1.0e-8/(epsratio*pModel->EOT)))
{
double m00_pow(d00_pow0,(Weff0*1.0e6),WR_i)
WeffWRFactor=(1.0/(d00_pow0*NFINtotal));
EXIT_IF_ISNAN((1.0/(d00_pow0*NFINtotal)))
}
{
double m00_sqrt(d00_sqrt0,(((epsratio*pModel->EOT)*0.5)*pInst->TFIN))
litl=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((!(model->THETASCE_Given)))
{
tmp=(((DVT1_i*Leff)/scl)+1.0e-6);
EXIT_IF_ISNAN((((DVT1_i*Leff)/scl)+1.0e-6))
if
((tmp<40.0))
{
{
double m00_cosh(d00_cosh0,tmp)
Theta_SCE=(0.5/(d00_cosh0-1.0));
EXIT_IF_ISNAN((0.5/(d00_cosh0-1.0)))
}
}
else
{
{
double m00_exp(d00_exp0,(-tmp))
Theta_SCE=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
}
else
{
Theta_SCE=pModel->THETASCE;
EXIT_IF_ISNAN(pModel->THETASCE)
}
if
((!(model->THETASW_Given)))
{
tmp=(((DVT1SS_i*Leff)/scl)+1.0e-6);
EXIT_IF_ISNAN((((DVT1SS_i*Leff)/scl)+1.0e-6))
if
((tmp<40.0))
{
{
double m00_cosh(d00_cosh0,tmp)
Theta_SW=(0.5/(d00_cosh0-1.0));
EXIT_IF_ISNAN((0.5/(d00_cosh0-1.0)))
}
}
else
{
{
double m00_exp(d00_exp0,(-tmp))
Theta_SW=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
}
else
{
Theta_SW=pModel->THETASW;
EXIT_IF_ISNAN(pModel->THETASW)
}
if
((!(model->THETADIBL_Given)))
{
tmp=(((DSUB_i*Leff)/scl)+1.0e-6);
EXIT_IF_ISNAN((((DSUB_i*Leff)/scl)+1.0e-6))
if
((tmp<40.0))
{
{
double m00_cosh(d00_cosh0,tmp)
Theta_DIBL=(0.5/(d00_cosh0-1.0));
EXIT_IF_ISNAN((0.5/(d00_cosh0-1.0)))
}
}
else
{
{
double m00_exp(d00_exp0,(-tmp))
Theta_DIBL=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
}
}
else
{
Theta_DIBL=pModel->THETADIBL;
EXIT_IF_ISNAN(pModel->THETADIBL)
}
{
double m00_sqrt(d00_sqrt0,(1.0+(LPE0_i/Leff)))
Theta_RSCE=(d00_sqrt0-1.0);
EXIT_IF_ISNAN((d00_sqrt0-1.0))
}
tmp=(((DSUB_i*Leff)/scl)+1.0e-6);
EXIT_IF_ISNAN((((DSUB_i*Leff)/scl)+1.0e-6))
if
((tmp<40.0))
{
{
double m00_cosh(d00_cosh0,tmp)
double m00_max(d00_max1,(1.0+(pModel->DVTP2*(d00_cosh0-2.0))),1.0e-6)
T0y=(1.0/d00_max1);
EXIT_IF_ISNAN((1.0/d00_max1))
}
}
else
{
{
double m00_exp(d00_exp0,(-tmp))
double m00_exp(d00_exp1,(-tmp))
double m00_max(d00_max2,(d00_exp1+pModel->DVTP2),1.0e-6)
T0y=(d00_exp0/d00_max2);
EXIT_IF_ISNAN((d00_exp0/d00_max2))
}
}
Theta_DITS=T0y;
EXIT_IF_ISNAN(T0y)
nbody=NBODY_i;
EXIT_IF_ISNAN(NBODY_i)
qbs=(((1.60219e-19*nbody)*Ach)/Cins);
EXIT_IF_ISNAN((((1.60219e-19*nbody)*Ach)/Cins))
if
((pModel->TYPE==1))
{
Aechvb=4.97232e-7;
EXIT_IF_ISNAN(4.97232e-7)
Bechvb=7.45669e11;
EXIT_IF_ISNAN(7.45669e11)
}
else
{
Aechvb=3.42537e-7;
EXIT_IF_ISNAN(3.42537e-7)
Bechvb=1.16645e12;
EXIT_IF_ISNAN(1.16645e12)
}
T0y=(pModel->TOXG*pModel->TOXG);
EXIT_IF_ISNAN((pModel->TOXG*pModel->TOXG))
T1y=(pModel->TOXG*POXEDGE_i);
EXIT_IF_ISNAN((pModel->TOXG*POXEDGE_i))
T2y=(T1y*T1y);
EXIT_IF_ISNAN((T1y*T1y))
Toxratio=(bsimcmg_lexp((NTOX_i*bsimcmg_lln((pModel->TOXREF/pModel->TOXG))))/T0y);
EXIT_IF_ISNAN((bsimcmg_lexp((NTOX_i*bsimcmg_lln((pModel->TOXREF/pModel->TOXG))))/T0y))
Toxratioedge=(bsimcmg_lexp((NTOX_i*bsimcmg_lln((pModel->TOXREF/T1y))))/T2y);
EXIT_IF_ISNAN((bsimcmg_lexp((NTOX_i*bsimcmg_lln((pModel->TOXREF/T1y))))/T2y))
igsd_mult0=((Weff0*Aechvb)*Toxratioedge);
EXIT_IF_ISNAN(((Weff0*Aechvb)*Toxratioedge))
if
((pModel->TNOM<(-273.15)))
{
printf("Warning: (TNOM=%e) < -`P_CELSIUS0. Set to 27 C.",pModel->TNOM);
printf("\n");
Tnom=300.15;
EXIT_IF_ISNAN(300.15)
}
else
{
Tnom=(pModel->TNOM+273.15);
EXIT_IF_ISNAN((pModel->TNOM+273.15))
}
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
DevTemp_Tempt_GND=1.0;
#if defined(_DERIVATE2)
  DevTemp_Tempt_GND_Tempt_GND=(+(+0.0+0.0)+0.0);
#endif
#endif
DevTemp=((mint_get_circuit_tempK()+NP(t))+pModel->DTEMP);
EXIT_IF_ISNAN(((mint_get_circuit_tempK()+NP(t))+pModel->DTEMP))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
DevTemp_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  DevTemp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
DevTemp=(mint_get_circuit_tempK()+pModel->DTEMP);
EXIT_IF_ISNAN((mint_get_circuit_tempK()+pModel->DTEMP))
}
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
TRatio_Tempt_GND=(DevTemp_Tempt_GND/Tnom);
#if defined(_DERIVATE2)
  TRatio_Tempt_GND_Tempt_GND=(DevTemp_Tempt_GND_Tempt_GND/Tnom-(DevTemp_Tempt_GND*0.0+DevTemp_Tempt_GND*0.0+DevTemp*0.0)/Tnom/Tnom+2*DevTemp*0.0*0.0/Tnom/Tnom/Tnom);
#endif
#endif
TRatio=(DevTemp/Tnom);
EXIT_IF_ISNAN((DevTemp/Tnom))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
delTemp_Tempt_GND=DevTemp_Tempt_GND;
#if defined(_DERIVATE2)
  delTemp_Tempt_GND_Tempt_GND=(+DevTemp_Tempt_GND_Tempt_GND-0.0);
#endif
#endif
delTemp=(DevTemp-Tnom);
EXIT_IF_ISNAN((DevTemp-Tnom))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Vtm_Tempt_GND=(8.617087e-5*DevTemp_Tempt_GND);
#if defined(_DERIVATE2)
  Vtm_Tempt_GND_Tempt_GND=(+0.0*DevTemp+0.0*DevTemp_Tempt_GND+0.0*DevTemp_Tempt_GND+8.617087e-5*DevTemp_Tempt_GND_Tempt_GND);
#endif
#endif
Vtm=(8.617087e-5*DevTemp);
EXIT_IF_ISNAN((8.617087e-5*DevTemp))
Vtm0=(8.617087e-5*Tnom);
EXIT_IF_ISNAN((8.617087e-5*Tnom))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Eg_Tempt_GND=(-(((((pModel->TBGASUB*DevTemp_Tempt_GND)*DevTemp)+((pModel->TBGASUB*DevTemp)*DevTemp_Tempt_GND))*(DevTemp+pModel->TBGBSUB)-((pModel->TBGASUB*DevTemp)*DevTemp)*DevTemp_Tempt_GND)/(DevTemp+pModel->TBGBSUB)/(DevTemp+pModel->TBGBSUB)));
#if defined(_DERIVATE2)
  Eg_Tempt_GND_Tempt_GND=(+0.0-((+(+0.0*DevTemp+0.0*DevTemp_Tempt_GND+0.0*DevTemp_Tempt_GND+pModel->TBGASUB*DevTemp_Tempt_GND_Tempt_GND)*DevTemp+(pModel->TBGASUB*DevTemp_Tempt_GND)*DevTemp_Tempt_GND+((pModel->TBGASUB*DevTemp_Tempt_GND))*DevTemp_Tempt_GND+(pModel->TBGASUB*DevTemp)*DevTemp_Tempt_GND_Tempt_GND)/(DevTemp+pModel->TBGBSUB)-((((pModel->TBGASUB*DevTemp_Tempt_GND)*DevTemp)+((pModel->TBGASUB*DevTemp)*DevTemp_Tempt_GND))*DevTemp_Tempt_GND+(((((pModel->TBGASUB*DevTemp_Tempt_GND))*DevTemp)+((pModel->TBGASUB*DevTemp)*DevTemp_Tempt_GND)))*DevTemp_Tempt_GND+((pModel->TBGASUB*DevTemp)*DevTemp)*(+DevTemp_Tempt_GND_Tempt_GND+0.0))/(DevTemp+pModel->TBGBSUB)/(DevTemp+pModel->TBGBSUB)+2*((pModel->TBGASUB*DevTemp)*DevTemp)*DevTemp_Tempt_GND*DevTemp_Tempt_GND/(DevTemp+pModel->TBGBSUB)/(DevTemp+pModel->TBGBSUB)/(DevTemp+pModel->TBGBSUB)));
#endif
#endif
Eg=(pModel->BG0SUB-(((pModel->TBGASUB*DevTemp)*DevTemp)/(DevTemp+pModel->TBGBSUB)));
EXIT_IF_ISNAN((pModel->BG0SUB-(((pModel->TBGASUB*DevTemp)*DevTemp)/(DevTemp+pModel->TBGBSUB))))
Eg0=(pModel->BG0SUB-(((pModel->TBGASUB*Tnom)*Tnom)/(Tnom+pModel->TBGBSUB)));
EXIT_IF_ISNAN((pModel->BG0SUB-(((pModel->TBGASUB*Tnom)*Tnom)/(Tnom+pModel->TBGBSUB))))
{
double m00_sqrt(d00_sqrt0,(DevTemp/300.15))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(DevTemp/300.15))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(((DevTemp_Tempt_GND/300.15)*d00_sqrt0)+((DevTemp/300.15)*(DevTemp_Tempt_GND/300.15)*d10_sqrt0));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Vsi_s=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Vge_di=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Vge_e=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Ve_si=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Ve_di=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Vge_si=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Vdi_si=(+(0.0/300.15-(DevTemp_Tempt_GND*0.0+0.0*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*0.0+0.0*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*0.0);
  T1_Tempt_GND_Tempt_GND=(+(DevTemp_Tempt_GND_Tempt_GND/300.15-(DevTemp_Tempt_GND*0.0+DevTemp_Tempt_GND*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)*d00_sqrt0+(DevTemp_Tempt_GND/300.15)*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp_Tempt_GND/300.15)*(DevTemp_Tempt_GND/300.15)*d10_sqrt0+(DevTemp/300.15)*(m20_sqrt((DevTemp/300.15))*(DevTemp_Tempt_GND/300.15)*(DevTemp_Tempt_GND/300.15)+d10_sqrt0*(DevTemp_Tempt_GND_Tempt_GND/300.15-(DevTemp_Tempt_GND*0.0+DevTemp_Tempt_GND*0.0+DevTemp*0.0)/300.15/300.15+2*DevTemp*0.0*0.0/300.15/300.15/300.15)));
#endif
#endif
T1=((DevTemp/300.15)*d00_sqrt0);
EXIT_IF_ISNAN(((DevTemp/300.15)*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ni_Tempt_GND=(((pModel->NI0SUB*T1_Tempt_GND)*bsimcmg_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))))+((pModel->NI0SUB*T1)*bsimcmg_d_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))),(-((Eg_Tempt_GND*(2.0*Vtm)-Eg*(2.0*Vtm_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm))))));
#if defined(_DERIVATE2)
  ni_Tempt_GND_Tempt_GND=(+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Tempt_GND+pModel->NI0SUB*T1_Tempt_GND_Tempt_GND)*bsimcmg_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))))+(pModel->NI0SUB*T1_Tempt_GND)*bsimcmg_d_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))),(-((Eg_Tempt_GND*(2.0*Vtm)-Eg*(2.0*Vtm_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm))))+((pModel->NI0SUB*T1_Tempt_GND))*bsimcmg_d_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))),(-((Eg_Tempt_GND*(2.0*Vtm)-Eg*(2.0*Vtm_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm))))+(pModel->NI0SUB*T1)*(+(0.0/((2.0*8.617087e-5)*300.15)-(0.0*((0.0)*300.15)+0.0*0.0+pModel->BG0SUB*(+(+0.0*8.617087e-5+0.0*0.0+0.0*0.0+2.0*0.0)*300.15+0.0*0.0+(0.0)*0.0+(2.0*8.617087e-5)*0.0))/((2.0*8.617087e-5)*300.15)/((2.0*8.617087e-5)*300.15)+2*pModel->BG0SUB*0.0*((0.0)*300.15)/((2.0*8.617087e-5)*300.15)/((2.0*8.617087e-5)*300.15)/((2.0*8.617087e-5)*300.15))-(Eg_Tempt_GND_Tempt_GND/(2.0*Vtm)-(Eg_Tempt_GND*((2.0*Vtm_Tempt_GND))+Eg_Tempt_GND*(2.0*Vtm_Tempt_GND)+Eg*(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+2.0*Vtm_Tempt_GND_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm)+2*Eg*(2.0*Vtm_Tempt_GND)*((2.0*Vtm_Tempt_GND))/(2.0*Vtm)/(2.0*Vtm)/(2.0*Vtm))));
#endif
#endif
ni=((pModel->NI0SUB*T1)*bsimcmg_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm)))));
EXIT_IF_ISNAN(((pModel->NI0SUB*T1)*bsimcmg_lexp(((pModel->BG0SUB/((2.0*8.617087e-5)*300.15))-(Eg/(2.0*Vtm))))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Nc_Tempt_GND=(pModel->NC0SUB*T1_Tempt_GND);
#if defined(_DERIVATE2)
  Nc_Tempt_GND_Tempt_GND=(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Tempt_GND+pModel->NC0SUB*T1_Tempt_GND_Tempt_GND);
#endif
#endif
Nc=(pModel->NC0SUB*T1);
EXIT_IF_ISNAN((pModel->NC0SUB*T1))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
ThetaSS_Tempt_GND=bsimcmg_d_hypsmooth(((1.0+(TSS_i*delTemp))-1.0e-6),1.0e-3,(TSS_i*delTemp_Tempt_GND),0.0);
#if defined(_DERIVATE2)
  ThetaSS_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
ThetaSS=bsimcmg_hypsmooth(((1.0+(TSS_i*delTemp))-1.0e-6),1.0e-3);
EXIT_IF_ISNAN(bsimcmg_hypsmooth(((1.0+(TSS_i*delTemp))-1.0e-6),1.0e-3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
kT_Tempt_GND=Vtm_Tempt_GND*1.60219e-19;
#if defined(_DERIVATE2)
  kT_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*1.60219e-19+Vtm_Tempt_GND*0.0+Vtm_Tempt_GND*0.0+Vtm*0.0);
#endif
#endif
kT=(Vtm*1.60219e-19);
EXIT_IF_ISNAN((Vtm*1.60219e-19))
T0y=((1.05457e-34*3.14159265358979323846)/((2*Ach)/Weff_UFCM));
EXIT_IF_ISNAN(((1.05457e-34*3.14159265358979323846)/((2*Ach)/Weff_UFCM)))
E0=((T0y*T0y)/(2.0*mx));
EXIT_IF_ISNAN(((T0y*T0y)/(2.0*mx)))
E0prime=((T0y*T0y)/(2.0*mxprime));
EXIT_IF_ISNAN(((T0y*T0y)/(2.0*mxprime)))
E1=(4.0*E0);
EXIT_IF_ISNAN((4.0*E0))
E1prime=(4.0*E0prime);
EXIT_IF_ISNAN((4.0*E0prime))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=((gprime*mdprime)/(gfactor*md));
EXIT_IF_ISNAN(((gprime*mdprime)/(gfactor*md)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
gam0_Tempt_GND=((T1_Tempt_GND*bsimcmg_lexp(((E0-E0prime)/kT)))+(T1*bsimcmg_d_lexp(((E0-E0prime)/kT),(-(E0-E0prime)*kT_Tempt_GND/kT/kT))));
#if defined(_DERIVATE2)
  gam0_Tempt_GND_Tempt_GND=(+0.0+(+T1_Tempt_GND_Tempt_GND*bsimcmg_lexp(((E0-E0prime)/kT))+T1_Tempt_GND*bsimcmg_d_lexp(((E0-E0prime)/kT),(-(E0-E0prime)*kT_Tempt_GND/kT/kT))+T1_Tempt_GND*bsimcmg_d_lexp(((E0-E0prime)/kT),(-(E0-E0prime)*kT_Tempt_GND/kT/kT))+T1*((+0.0-0.0)/kT-(0.0*kT_Tempt_GND+0.0*kT_Tempt_GND+(E0-E0prime)*kT_Tempt_GND_Tempt_GND)/kT/kT+2*(E0-E0prime)*kT_Tempt_GND*kT_Tempt_GND/kT/kT/kT)));
#endif
#endif
gam0=(1.0+(T1*bsimcmg_lexp(((E0-E0prime)/kT))));
EXIT_IF_ISNAN((1.0+(T1*bsimcmg_lexp(((E0-E0prime)/kT)))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
gam1_Tempt_GND=((gam0_Tempt_GND+bsimcmg_d_lexp(((E0-E1)/kT),(-(E0-E1)*kT_Tempt_GND/kT/kT)))+((T1_Tempt_GND*bsimcmg_lexp(((E0-E1prime)/kT)))+(T1*bsimcmg_d_lexp(((E0-E1prime)/kT),(-(E0-E1prime)*kT_Tempt_GND/kT/kT)))));
#if defined(_DERIVATE2)
  gam1_Tempt_GND_Tempt_GND=(+(+gam0_Tempt_GND_Tempt_GND+((+0.0-0.0)/kT-(0.0*kT_Tempt_GND+0.0*kT_Tempt_GND+(E0-E1)*kT_Tempt_GND_Tempt_GND)/kT/kT+2*(E0-E1)*kT_Tempt_GND*kT_Tempt_GND/kT/kT/kT))+(+T1_Tempt_GND_Tempt_GND*bsimcmg_lexp(((E0-E1prime)/kT))+T1_Tempt_GND*bsimcmg_d_lexp(((E0-E1prime)/kT),(-(E0-E1prime)*kT_Tempt_GND/kT/kT))+T1_Tempt_GND*bsimcmg_d_lexp(((E0-E1prime)/kT),(-(E0-E1prime)*kT_Tempt_GND/kT/kT))+T1*((+0.0-0.0)/kT-(0.0*kT_Tempt_GND+0.0*kT_Tempt_GND+(E0-E1prime)*kT_Tempt_GND_Tempt_GND)/kT/kT+2*(E0-E1prime)*kT_Tempt_GND*kT_Tempt_GND/kT/kT/kT)));
#endif
#endif
gam1=((gam0+bsimcmg_lexp(((E0-E1)/kT)))+(T1*bsimcmg_lexp(((E0-E1prime)/kT))));
EXIT_IF_ISNAN(((gam0+bsimcmg_lexp(((E0-E1)/kT)))+(T1*bsimcmg_lexp(((E0-E1prime)/kT)))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(((-Vtm_Tempt_GND)*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1)))+((-Vtm)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+0.0*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((0.0)*1.05457e-34)*Nc)+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*0.0+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*0.0))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((0.0)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*0.0)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*0.0+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((0.0)*1.05457e-34)*Nc))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*0.0));
  T2_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm_Tempt_GND)*bsimcmg_d_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1),((((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1)+(((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND)))+(-Vtm)*(+((+((+0.0*md+0.0*0.0+0.0*0.0+gfactor*0.0)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(0.0*(((((0.0)*1.05457e-34)*Nc)+(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)))+(0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)+(gfactor*md)*(+(+(+0.0*1.05457e-34+0.0*0.0+0.0*0.0+3.14159265358979323846*0.0)*1.05457e-34+0.0*0.0+(0.0)*0.0+(3.14159265358979323846*1.05457e-34)*0.0)*Nc+0.0*Nc_Tempt_GND+((0.0)*1.05457e-34)*Nc_Tempt_GND+((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND_Tempt_GND))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)+2*(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)*(((((0.0)*1.05457e-34)*Nc)+(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT+(-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+(((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((((0.0)*1.05457e-34)*Nc)+(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND))))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND+((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND_Tempt_GND)/((2.0*Ach)/Weff_UFCM)-((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))*((0.0)/Weff_UFCM)+((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((((0.0)*1.05457e-34)*Nc)+(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND))))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND)))*0.0+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((+0.0*Ach+0.0*0.0+0.0*0.0+2.0*0.0)/Weff_UFCM-(0.0*0.0+(0.0)*0.0+(2.0*Ach)*0.0)/Weff_UFCM/Weff_UFCM+2*(2.0*Ach)*0.0*0.0/Weff_UFCM/Weff_UFCM/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)+2*(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*0.0*((0.0)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1+((((-(gfactor*md)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND))/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((((((0.0)*(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)-(gfactor*md)*(((((0.0)*1.05457e-34)*Nc)+(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc_Tempt_GND))))/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)+(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT_Tempt_GND)))*((2.0*Ach)/Weff_UFCM)-(((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)*((0.0)/Weff_UFCM))/((2.0*Ach)/Weff_UFCM)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND+((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1_Tempt_GND_Tempt_GND));
#endif
#endif
T2=((-Vtm)*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1)));
EXIT_IF_ISNAN(((-Vtm)*bsimcmg_lln((((((gfactor*md)/(((3.14159265358979323846*1.05457e-34)*1.05457e-34)*Nc))*kT)/((2.0*Ach)/Weff_UFCM))*gam1))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
dvch_qm_Tempt_GND=(QMFACTOR_i*T2_Tempt_GND);
#if defined(_DERIVATE2)
  dvch_qm_Tempt_GND_Tempt_GND=(+0.0*((E0/1.60219e-19)+T2)+0.0*T2_Tempt_GND+0.0*T2_Tempt_GND+QMFACTOR_i*(+(0.0/1.60219e-19-(0.0*0.0+0.0*0.0+E0*0.0)/1.60219e-19/1.60219e-19+2*E0*0.0*0.0/1.60219e-19/1.60219e-19/1.60219e-19)+T2_Tempt_GND_Tempt_GND));
#endif
#endif
dvch_qm=(QMFACTOR_i*((E0/1.60219e-19)+T2));
EXIT_IF_ISNAN((QMFACTOR_i*((E0/1.60219e-19)+T2)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ETA0_t_Tempt_GND=bsimcmg_d_Tempdep(ETA0_i,pModel->TETA0,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  ETA0_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
ETA0_t=bsimcmg_Tempdep(ETA0_i,pModel->TETA0,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(ETA0_i,pModel->TETA0,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ETA0R_t_Tempt_GND=bsimcmg_d_Tempdep(ETA0R_i,pModel->TETA0R,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  ETA0R_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
ETA0R_t=bsimcmg_Tempdep(ETA0R_i,pModel->TETA0R,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(ETA0R_i,pModel->TETA0R,delTemp,pModel->TEMPMOD))
{
double m00_pow(d00_pow0,TRatio,UTE_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,UTE_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(U0_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Vsi_s=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Vge_di=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Vge_e=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Ve_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Ve_di=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Vge_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Vdi_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
  T1_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+U0_i*fixme);
#endif
#endif
T1=(U0_i*d00_pow0);
EXIT_IF_ISNAN((U0_i*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
U0_t_Tempt_GND=(T1_Tempt_GND+bsimcmg_d_hypmax((UTL_i*delTemp),((-0.9)*T1),1.0e-4,(UTL_i*delTemp_Tempt_GND),((-0.9)*T1_Tempt_GND),0.0));
#if defined(_DERIVATE2)
  U0_t_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND+0.0);
#endif
#endif
U0_t=(T1+bsimcmg_hypmax((UTL_i*delTemp),((-0.9)*T1),1.0e-4));
EXIT_IF_ISNAN((T1+bsimcmg_hypmax((UTL_i*delTemp),((-0.9)*T1),1.0e-4)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
u0_Tempt_GND=U0_t_Tempt_GND;
#if defined(_DERIVATE2)
  u0_Tempt_GND_Tempt_GND=U0_t_Tempt_GND_Tempt_GND;
#endif
#endif
u0=U0_t;
EXIT_IF_ISNAN(U0_t)
if
((pModel->ASYMMOD==1))
{
{
double m00_pow(d00_pow0,TRatio,UTER_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,UTER_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(U0R_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Vsi_s=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Vge_di=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Vge_e=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Ve_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Ve_di=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Vge_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Vdi_si=(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
  T1_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+U0R_i*fixme);
#endif
#endif
T1=(U0R_i*d00_pow0);
EXIT_IF_ISNAN((U0R_i*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
U0R_t_Tempt_GND=(T1_Tempt_GND+bsimcmg_d_hypmax((UTLR_i*delTemp),((-0.9)*T1),1.0e-4,(UTLR_i*delTemp_Tempt_GND),((-0.9)*T1_Tempt_GND),0.0));
#if defined(_DERIVATE2)
  U0R_t_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND+0.0);
#endif
#endif
U0R_t=(T1+bsimcmg_hypmax((UTLR_i*delTemp),((-0.9)*T1),1.0e-4));
EXIT_IF_ISNAN((T1+bsimcmg_hypmax((UTLR_i*delTemp),((-0.9)*T1),1.0e-4)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
u0r_Tempt_GND=U0R_t_Tempt_GND;
#if defined(_DERIVATE2)
  u0r_Tempt_GND_Tempt_GND=U0R_t_Tempt_GND_Tempt_GND;
#endif
#endif
u0r=U0R_t;
EXIT_IF_ISNAN(U0R_t)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
ETAMOB_t_Tempt_GND=bsimcmg_d_Tempdep(ETAMOB_i,EMOBT_i,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  ETAMOB_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
ETAMOB_t=bsimcmg_Tempdep(ETAMOB_i,EMOBT_i,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(ETAMOB_i,EMOBT_i,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UA_t_Tempt_GND=bsimcmg_d_hypmax((UA1_i*delTemp),(-UA_i),1.0e-6,(UA1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  UA_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
UA_t=(UA_i+bsimcmg_hypmax((UA1_i*delTemp),(-UA_i),1.0e-6));
EXIT_IF_ISNAN((UA_i+bsimcmg_hypmax((UA1_i*delTemp),(-UA_i),1.0e-6)))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UAR_t_Tempt_GND=bsimcmg_d_hypmax((UA1R_i*delTemp),(-UAR_i),1.0e-6,(UA1R_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  UAR_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
UAR_t=(UAR_i+bsimcmg_hypmax((UA1R_i*delTemp),(-UAR_i),1.0e-6));
EXIT_IF_ISNAN((UAR_i+bsimcmg_hypmax((UA1R_i*delTemp),(-UAR_i),1.0e-6)))
}
if
((pModel->BULKMOD!=0))
{
if
((pModel->TEMPMOD==0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UC_t_Tempt_GND=bsimcmg_d_Tempdep(UC_i,UC1_i,delTemp,0,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  UC_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UC_t=bsimcmg_Tempdep(UC_i,UC1_i,delTemp,0);
EXIT_IF_ISNAN(bsimcmg_Tempdep(UC_i,UC1_i,delTemp,0))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UCR_t_Tempt_GND=bsimcmg_d_Tempdep(UCR_i,UC1R_i,delTemp,0,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  UCR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
UCR_t=bsimcmg_Tempdep(UCR_i,UC1R_i,delTemp,0);
EXIT_IF_ISNAN(bsimcmg_Tempdep(UCR_i,UC1R_i,delTemp,0))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UC_t_Tempt_GND=(UC1_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  UC_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+UC1_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
UC_t=(UC_i+(UC1_i*delTemp));
EXIT_IF_ISNAN((UC_i+(UC1_i*delTemp)))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UCR_t_Tempt_GND=(UC1R_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  UCR_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+UC1R_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
UCR_t=(UCR_i+(UC1R_i*delTemp));
EXIT_IF_ISNAN((UCR_i+(UC1R_i*delTemp)))
}
}
}
{
double m00_pow(d00_pow0,TRatio,UD1_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,UD1_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UD_t_Tempt_GND=(UD_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  UD_t_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+UD_i*fixme);
#endif
#endif
UD_t=(UD_i*d00_pow0);
EXIT_IF_ISNAN((UD_i*d00_pow0))
}
if
((pModel->ASYMMOD!=0))
{
{
double m00_pow(d00_pow0,TRatio,UD1R_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,UD1R_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UDR_t_Tempt_GND=(UDR_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  UDR_t_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+UDR_i*fixme);
#endif
#endif
UDR_t=(UDR_i*d00_pow0);
EXIT_IF_ISNAN((UDR_i*d00_pow0))
}
}
{
double m00_pow(d00_pow0,TRatio,UCSTE_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,UCSTE_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
UCS_t_Tempt_GND=(UCS_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  UCS_t_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+UCS_i*fixme);
#endif
#endif
UCS_t=(UCS_i*d00_pow0);
EXIT_IF_ISNAN((UCS_i*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
rdstemp_Tempt_GND=bsimcmg_d_hypsmooth(((1.0+(PRT_i*delTemp))-1.0e-6),1.0e-3,(PRT_i*delTemp_Tempt_GND),0.0);
#if defined(_DERIVATE2)
  rdstemp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
rdstemp=bsimcmg_hypsmooth(((1.0+(PRT_i*delTemp))-1.0e-6),1.0e-3);
EXIT_IF_ISNAN(bsimcmg_hypsmooth(((1.0+(PRT_i*delTemp))-1.0e-6),1.0e-3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RSDR_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->RSDR,pModel->TRSDR,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  RSDR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RSDR_t=bsimcmg_Tempdep(pModel->RSDR,pModel->TRSDR,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->RSDR,pModel->TRSDR,delTemp,pModel->TEMPMOD))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RSDRR_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->RSDRR,pModel->TRSDR,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  RSDRR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RSDRR_t=bsimcmg_Tempdep(pModel->RSDRR,pModel->TRSDR,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->RSDRR,pModel->TRSDR,delTemp,pModel->TEMPMOD))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RDDR_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->RDDR,pModel->TRDDR,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  RDDR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RDDR_t=bsimcmg_Tempdep(pModel->RDDR,pModel->TRDDR,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->RDDR,pModel->TRDDR,delTemp,pModel->TEMPMOD))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
RDDRR_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->RDDRR,pModel->TRDDR,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  RDDRR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
RDDRR_t=bsimcmg_Tempdep(pModel->RDDRR,pModel->TRDDR,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->RDDRR,pModel->TRDDR,delTemp,pModel->TEMPMOD))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSAT_t_Tempt_GND=bsimcmg_d_Tempdep(VSAT_i,(-AT_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  VSAT_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT_t=bsimcmg_Tempdep(VSAT_i,(-AT_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(VSAT_i,(-AT_i),delTemp,pModel->TEMPMOD))
if
((VSAT_t<1000))
{
printf("Warning: VSAT(%f) = %e is less than 1K, setting it to 1K.",DevTemp,VSAT_t);
printf("\n");
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSAT_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSAT_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT_t=1000;
EXIT_IF_ISNAN(1000)
}
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSATR_t_Tempt_GND=bsimcmg_d_Tempdep(VSATR_i,(-ATR_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  VSATR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSATR_t=bsimcmg_Tempdep(VSATR_i,(-ATR_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(VSATR_i,(-ATR_i),delTemp,pModel->TEMPMOD))
if
((VSATR_t<1000))
{
printf("Warning: VSATR(%f) = %e is less than 1K, setting it to 1K.",DevTemp,VSATR_t);
printf("\n");
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSATR_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSATR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSATR_t=1000;
EXIT_IF_ISNAN(1000)
}
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT1_t_Tempt_GND=bsimcmg_d_Tempdep(VSAT1_i,(-AT_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  VSAT1_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT1_t=bsimcmg_Tempdep(VSAT1_i,(-AT_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(VSAT1_i,(-AT_i),delTemp,pModel->TEMPMOD))
if
((VSAT1_t<1000))
{
printf("Warning: VSAT1(%f) = %e is less than 1K, setting it to 1K.",DevTemp,VSAT1_t);
printf("\n");
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT1_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSAT1_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT1_t=1000;
EXIT_IF_ISNAN(1000)
}
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT1R_t_Tempt_GND=bsimcmg_d_Tempdep(VSAT1R_i,(-AT_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  VSAT1R_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT1R_t=bsimcmg_Tempdep(VSAT1R_i,(-AT_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(VSAT1R_i,(-AT_i),delTemp,pModel->TEMPMOD))
if
((VSAT1R_t<1000))
{
printf("Warning: VSAT1R(%f) = %e is less than 1K, setting it to 1K.",DevTemp,VSAT1R_t);
printf("\n");
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT1R_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSAT1R_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSAT1R_t=1000;
EXIT_IF_ISNAN(1000)
}
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
VSATCV_t_Tempt_GND=bsimcmg_d_Tempdep(VSATCV_i,(-ATCV_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  VSATCV_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSATCV_t=bsimcmg_Tempdep(VSATCV_i,(-ATCV_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(VSATCV_i,(-ATCV_i),delTemp,pModel->TEMPMOD))
if
((VSATCV_t<1000))
{
printf("Warning: VSATCV(%f) = %e is less than 1K, setting it to 1K.",DevTemp,VSATCV_t);
printf("\n");
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
VSATCV_t_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  VSATCV_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
VSATCV_t=1000;
EXIT_IF_ISNAN(1000)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
MEXP_t_Tempt_GND=bsimcmg_d_hypsmooth(((MEXP_i*(1.0+(pModel->TMEXP*delTemp)))-2.0),1.0e-3,(MEXP_i*(pModel->TMEXP*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  MEXP_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
MEXP_t=(bsimcmg_hypsmooth(((MEXP_i*(1.0+(pModel->TMEXP*delTemp)))-2.0),1.0e-3)+2.0);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((MEXP_i*(1.0+(pModel->TMEXP*delTemp)))-2.0),1.0e-3)+2.0))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
MEXPR_t_Tempt_GND=bsimcmg_d_hypsmooth(((MEXPR_i*(1.0+(pModel->TMEXPR*delTemp)))-2.0),1.0e-3,(MEXPR_i*(pModel->TMEXPR*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  MEXPR_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
MEXPR_t=(bsimcmg_hypsmooth(((MEXPR_i*(1.0+(pModel->TMEXPR*delTemp)))-2.0),1.0e-3)+2.0);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((MEXPR_i*(1.0+(pModel->TMEXPR*delTemp)))-2.0),1.0e-3)+2.0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
PTWG_t_Tempt_GND=bsimcmg_d_Tempdep(PTWG_i,(-PTWGT_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  PTWG_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PTWG_t=bsimcmg_Tempdep(PTWG_i,(-PTWGT_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(PTWG_i,(-PTWGT_i),delTemp,pModel->TEMPMOD))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
PTWGR_t_Tempt_GND=bsimcmg_d_Tempdep(PTWGR_i,(-PTWGT_i),delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  PTWGR_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PTWGR_t=bsimcmg_Tempdep(PTWGR_i,(-PTWGT_i),delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(PTWGR_i,(-PTWGT_i),delTemp,pModel->TEMPMOD))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
dvth_temp_Tempt_GND=((KT1_i+(pModel->KT1L/Leff))*TRatio_Tempt_GND);
#if defined(_DERIVATE2)
  dvth_temp_Tempt_GND_Tempt_GND=(+(+0.0+(0.0/Leff-(0.0*0.0+0.0*0.0+pModel->KT1L*0.0)/Leff/Leff+2*pModel->KT1L*0.0*0.0/Leff/Leff/Leff))*(TRatio-1.0)+0.0*TRatio_Tempt_GND+0.0*TRatio_Tempt_GND+(KT1_i+(pModel->KT1L/Leff))*(+TRatio_Tempt_GND_Tempt_GND-0.0));
#endif
#endif
dvth_temp=((KT1_i+(pModel->KT1L/Leff))*(TRatio-1.0));
EXIT_IF_ISNAN(((KT1_i+(pModel->KT1L/Leff))*(TRatio-1.0)))
{
double m00_pow(d00_pow0,TRatio,IIT_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,TRatio,IIT_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
BETA0_t_Tempt_GND=(BETA0_i*(d10_pow0*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  BETA0_t_Tempt_GND_Tempt_GND=(+0.0*d00_pow0+0.0*(d10_pow0*TRatio_Tempt_GND)+0.0*(d10_pow0*TRatio_Tempt_GND)+BETA0_i*fixme);
#endif
#endif
BETA0_t=(BETA0_i*d00_pow0);
EXIT_IF_ISNAN((BETA0_i*d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
SII0_t_Tempt_GND=(SII0_i*bsimcmg_d_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3,(TII_i*TRatio_Tempt_GND),0.0));
#if defined(_DERIVATE2)
  SII0_t_Tempt_GND_Tempt_GND=(+0.0*(bsimcmg_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3)+0.01)+0.0*bsimcmg_d_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3,(TII_i*TRatio_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3,(TII_i*TRatio_Tempt_GND),0.0)+SII0_i*(+0.0+0.0));
#endif
#endif
SII0_t=(SII0_i*(bsimcmg_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3)+0.01));
EXIT_IF_ISNAN((SII0_i*(bsimcmg_hypsmooth(((1.0+(TII_i*(TRatio-1.0)))-0.01),1.0e-3)+0.01)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
K0_t_Tempt_GND=(K01_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  K0_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+K01_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
K0_t=(K0_i+(K01_i*delTemp));
EXIT_IF_ISNAN((K0_i+(K01_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
K0SI_t_Tempt_GND=bsimcmg_d_hypmax((K0SI1_i*delTemp),(-K0SI_i),1.0e-6,(K0SI1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  K0SI_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
K0SI_t=(K0SI_i+bsimcmg_hypmax((K0SI1_i*delTemp),(-K0SI_i),1.0e-6));
EXIT_IF_ISNAN((K0SI_i+bsimcmg_hypmax((K0SI1_i*delTemp),(-K0SI_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
K2SI_t_Tempt_GND=bsimcmg_d_hypmax((K2SI1_i*delTemp),(-K2SI_i),1.0e-6,(K2SI1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  K2SI_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
K2SI_t=(K2SI_i+bsimcmg_hypmax((K2SI1_i*delTemp),(-K2SI_i),1.0e-6));
EXIT_IF_ISNAN((K2SI_i+bsimcmg_hypmax((K2SI1_i*delTemp),(-K2SI_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
K1_t_Tempt_GND=bsimcmg_d_hypmax((K11_i*delTemp),(-K1_i),1.0e-6,(K11_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  K1_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
K1_t=(K1_i+bsimcmg_hypmax((K11_i*delTemp),(-K1_i),1.0e-6));
EXIT_IF_ISNAN((K1_i+bsimcmg_hypmax((K11_i*delTemp),(-K1_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
K2SAT_t_Tempt_GND=(K2SAT1_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  K2SAT_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+K2SAT1_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
K2SAT_t=(K2SAT_i+(K2SAT1_i*delTemp));
EXIT_IF_ISNAN((K2SAT_i+(K2SAT1_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
A1_t_Tempt_GND=(A11_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  A1_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+A11_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
A1_t=(A1_i+(A11_i*delTemp));
EXIT_IF_ISNAN((A1_i+(A11_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
A2_t_Tempt_GND=(A21_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  A2_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+A21_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
A2_t=(A2_i+(A21_i*delTemp));
EXIT_IF_ISNAN((A2_i+(A21_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
K2_t_Tempt_GND=bsimcmg_d_hypmax((K21_i*delTemp),(-K2_i),1.0e-6,(K21_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  K2_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
K2_t=(K2_i+bsimcmg_hypmax((K21_i*delTemp),(-K2_i),1.0e-6));
EXIT_IF_ISNAN((K2_i+bsimcmg_hypmax((K21_i*delTemp),(-K2_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
K0SISAT_t_Tempt_GND=(K0SISAT1_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  K0SISAT_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+K0SISAT1_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
K0SISAT_t=(K0SISAT_i+(K0SISAT1_i*delTemp));
EXIT_IF_ISNAN((K0SISAT_i+(K0SISAT1_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
K2SISAT_t_Tempt_GND=(K2SISAT1_i*delTemp_Tempt_GND);
#if defined(_DERIVATE2)
  K2SISAT_t_Tempt_GND_Tempt_GND=(+0.0+(+0.0*delTemp+0.0*delTemp_Tempt_GND+0.0*delTemp_Tempt_GND+K2SISAT1_i*delTemp_Tempt_GND_Tempt_GND));
#endif
#endif
K2SISAT_t=(K2SISAT_i+(K2SISAT1_i*delTemp));
EXIT_IF_ISNAN((K2SISAT_i+(K2SISAT1_i*delTemp)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
AIGBINV_t_Tempt_GND=bsimcmg_d_hypmax((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0e-6,(AIGBINV1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  AIGBINV_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
AIGBINV_t=(AIGBINV_i+bsimcmg_hypmax((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0e-6));
EXIT_IF_ISNAN((AIGBINV_i+bsimcmg_hypmax((AIGBINV1_i*delTemp),(-AIGBINV_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
AIGBACC_t_Tempt_GND=bsimcmg_d_hypmax((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0e-6,(AIGBACC1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  AIGBACC_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
AIGBACC_t=(AIGBACC_i+bsimcmg_hypmax((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0e-6));
EXIT_IF_ISNAN((AIGBACC_i+bsimcmg_hypmax((AIGBACC1_i*delTemp),(-AIGBACC_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
AIGC_t_Tempt_GND=bsimcmg_d_hypmax((AIGC1_i*delTemp),(-AIGC_i),1.0e-6,(AIGC1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  AIGC_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
AIGC_t=(AIGC_i+bsimcmg_hypmax((AIGC1_i*delTemp),(-AIGC_i),1.0e-6));
EXIT_IF_ISNAN((AIGC_i+bsimcmg_hypmax((AIGC1_i*delTemp),(-AIGC_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
AIGS_t_Tempt_GND=bsimcmg_d_hypmax((AIGS1_i*delTemp),(-AIGS_i),1.0e-6,(AIGS1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  AIGS_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
AIGS_t=(AIGS_i+bsimcmg_hypmax((AIGS1_i*delTemp),(-AIGS_i),1.0e-6));
EXIT_IF_ISNAN((AIGS_i+bsimcmg_hypmax((AIGS1_i*delTemp),(-AIGS_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
AIGD_t_Tempt_GND=bsimcmg_d_hypmax((AIGD1_i*delTemp),(-AIGD_i),1.0e-6,(AIGD1_i*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  AIGD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
AIGD_t=(AIGD_i+bsimcmg_hypmax((AIGD1_i*delTemp),(-AIGD_i),1.0e-6));
EXIT_IF_ISNAN((AIGD_i+bsimcmg_hypmax((AIGD1_i*delTemp),(-AIGD_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
BGIDL_t_Tempt_GND=(BGIDL_i*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0));
#if defined(_DERIVATE2)
  BGIDL_t_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)+0.0*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0)+BGIDL_i*0.0);
#endif
#endif
BGIDL_t=(BGIDL_i*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((BGIDL_i*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
BGISL_t_Tempt_GND=(BGISL_i*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0));
#if defined(_DERIVATE2)
  BGISL_t_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)+0.0*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3,(TGIDL_i*delTemp_Tempt_GND),0.0)+BGISL_i*0.0);
#endif
#endif
BGISL_t=(BGISL_i*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3));
EXIT_IF_ISNAN((BGISL_i*bsimcmg_hypsmooth(((1.0+(TGIDL_i*delTemp))-1.0e-6),1.0e-3)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
ALPHA0_t_Tempt_GND=bsimcmg_d_hypmax((pModel->ALPHA01*delTemp),(-ALPHA0_i),1.0e-6,(pModel->ALPHA01*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  ALPHA0_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
ALPHA0_t=(ALPHA0_i+bsimcmg_hypmax((pModel->ALPHA01*delTemp),(-ALPHA0_i),1.0e-6));
EXIT_IF_ISNAN((ALPHA0_i+bsimcmg_hypmax((pModel->ALPHA01*delTemp),(-ALPHA0_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
ALPHA1_t_Tempt_GND=bsimcmg_d_hypmax((pModel->ALPHA11*delTemp),(-ALPHA1_i),1.0e-6,(pModel->ALPHA11*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  ALPHA1_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
ALPHA1_t=(ALPHA1_i+bsimcmg_hypmax((pModel->ALPHA11*delTemp),(-ALPHA1_i),1.0e-6));
EXIT_IF_ISNAN((ALPHA1_i+bsimcmg_hypmax((pModel->ALPHA11*delTemp),(-ALPHA1_i),1.0e-6)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
ALPHAII0_t_Tempt_GND=bsimcmg_d_hypmax((pModel->ALPHAII01*delTemp),(-ALPHAII0_i),1.0e-25,(pModel->ALPHAII01*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  ALPHAII0_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
ALPHAII0_t=(ALPHAII0_i+bsimcmg_hypmax((pModel->ALPHAII01*delTemp),(-ALPHAII0_i),1.0e-25));
EXIT_IF_ISNAN((ALPHAII0_i+bsimcmg_hypmax((pModel->ALPHAII01*delTemp),(-ALPHAII0_i),1.0e-25)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
ALPHAII1_t_Tempt_GND=bsimcmg_d_hypmax((pModel->ALPHAII11*delTemp),(-ALPHAII1_i),1.0e-20,(pModel->ALPHAII11*delTemp_Tempt_GND),0.0,0.0);
#if defined(_DERIVATE2)
  ALPHAII1_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
ALPHAII1_t=(ALPHAII1_i+bsimcmg_hypmax((pModel->ALPHAII11*delTemp),(-ALPHAII1_i),1.0e-20));
EXIT_IF_ISNAN((ALPHAII1_i+bsimcmg_hypmax((pModel->ALPHAII11*delTemp),(-ALPHAII1_i),1.0e-20)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igtemp_Tempt_GND=bsimcmg_d_lexp((IGT_i*bsimcmg_lln(TRatio)),(IGT_i*bsimcmg_d_lln(TRatio,TRatio_Tempt_GND)));
#if defined(_DERIVATE2)
  igtemp_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(TRatio)+0.0*bsimcmg_d_lln(TRatio,TRatio_Tempt_GND)+0.0*bsimcmg_d_lln(TRatio,TRatio_Tempt_GND)+IGT_i*TRatio_Tempt_GND_Tempt_GND);
#endif
#endif
igtemp=bsimcmg_lexp((IGT_i*bsimcmg_lln(TRatio)));
EXIT_IF_ISNAN(bsimcmg_lexp((IGT_i*bsimcmg_lln(TRatio))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
igsd_mult_Tempt_GND=(igsd_mult0*igtemp_Tempt_GND);
#if defined(_DERIVATE2)
  igsd_mult_Tempt_GND_Tempt_GND=(+0.0*igtemp+0.0*igtemp_Tempt_GND+0.0*igtemp_Tempt_GND+igsd_mult0*igtemp_Tempt_GND_Tempt_GND);
#endif
#endif
igsd_mult=(igsd_mult0*igtemp);
EXIT_IF_ISNAN((igsd_mult0*igtemp))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJS_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJS,pModel->TCJ,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJS_t=bsimcmg_Tempdep(pModel->CJS,pModel->TCJ,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJS,pModel->TCJ,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJD_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJD,pModel->TCJ,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJD_t=bsimcmg_Tempdep(pModel->CJD,pModel->TCJ,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJD,pModel->TCJ,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJSWS_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJSWS,pModel->TCJSW,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJSWS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWS_t=bsimcmg_Tempdep(pModel->CJSWS,pModel->TCJSW,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJSWS,pModel->TCJSW,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJSWD_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJSWD,pModel->TCJSW,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJSWD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWD_t=bsimcmg_Tempdep(pModel->CJSWD,pModel->TCJSW,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJSWD,pModel->TCJSW,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
CJSWGS_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJSWGS,pModel->TCJSWG,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJSWGS_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWGS_t=bsimcmg_Tempdep(pModel->CJSWGS,pModel->TCJSWG,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJSWGS,pModel->TCJSWG,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
CJSWGD_t_Tempt_GND=bsimcmg_d_Tempdep(pModel->CJSWGD,pModel->TCJSWG,delTemp,pModel->TEMPMOD,0.0,0.0,delTemp_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  CJSWGD_t_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CJSWGD_t=bsimcmg_Tempdep(pModel->CJSWGD,pModel->TCJSWG,delTemp,pModel->TEMPMOD);
EXIT_IF_ISNAN(bsimcmg_Tempdep(pModel->CJSWGD,pModel->TCJSWG,delTemp,pModel->TEMPMOD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBS_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3,(-(pModel->TPB*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBS_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBS_t=(bsimcmg_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBS-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3,(-(pModel->TPB*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBD_t=(bsimcmg_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBD-(pModel->TPB*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBSWS_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3,(-(pModel->TPBSW*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBSWS_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBSWS_t=(bsimcmg_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBSWS-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBSWD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3,(-(pModel->TPBSW*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBSWD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBSWD_t=(bsimcmg_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBSWD-(pModel->TPBSW*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
PBSWGS_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3,(-(pModel->TPBSWG*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBSWGS_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBSWGS_t=(bsimcmg_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBSWGS-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PBSWGD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3,(-(pModel->TPBSWG*delTemp_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  PBSWGD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
PBSWGD_t=(bsimcmg_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->PBSWGD-(pModel->TPBSWG*delTemp))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vge_e=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Ve_si=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Ve_di=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vge_si=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vdi_si=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Tempt_GND=(+(0.0/Vtm0-(0.0*0.0+0.0*0.0+Eg0*0.0)/Vtm0/Vtm0+2*Eg0*0.0*0.0/Vtm0/Vtm0/Vtm0)-(Eg_Tempt_GND_Tempt_GND/Vtm-(Eg_Tempt_GND*Vtm_Tempt_GND+Eg_Tempt_GND*Vtm_Tempt_GND+Eg*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm));
#endif
#endif
T0=((Eg0/Vtm0)-(Eg/Vtm));
EXIT_IF_ISNAN(((Eg0/Vtm0)-(Eg/Vtm)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_lln(TRatio,TRatio_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=TRatio_Tempt_GND_Tempt_GND;
#endif
#endif
T1=bsimcmg_lln(TRatio);
EXIT_IF_ISNAN(bsimcmg_lln(TRatio))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=bsimcmg_d_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS),((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))/pModel->NJS));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=((+0.0+(+0.0*T1+0.0*T1_Vdi_d+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vdi_d))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+((pModel->XTIS*T1_Vdi_d))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Vsi_s=((+0.0+(+0.0*T1+0.0*T1_Vsi_s+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vsi_s))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+((pModel->XTIS*T1_Vsi_s))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Vge_di=((+T0_Tempt_GND_Vge_di+(+0.0*T1+0.0*T1_Vge_di+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vge_di))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Vge_di+((pModel->XTIS*T1_Vge_di)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Vge_e=((+T0_Tempt_GND_Vge_e+(+0.0*T1+0.0*T1_Vge_e+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vge_e))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Vge_e+((pModel->XTIS*T1_Vge_e)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Vdi_si=((+T0_Tempt_GND_Vdi_si+(+0.0*T1+0.0*T1_Vdi_si+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vdi_si))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Vdi_si+((pModel->XTIS*T1_Vdi_si)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Ve_si=((+T0_Tempt_GND_Ve_si+(+0.0*T1+0.0*T1_Ve_si+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Ve_si))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Ve_si+((pModel->XTIS*T1_Ve_si)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Ve_di=((+T0_Tempt_GND_Ve_di+(+0.0*T1+0.0*T1_Ve_di+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Ve_di))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Ve_di+((pModel->XTIS*T1_Ve_di)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Vge_si=((+T0_Tempt_GND_Vge_si+(+0.0*T1+0.0*T1_Vge_si+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Vge_si))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Vge_si+((pModel->XTIS*T1_Vge_si)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
  T3_Tempt_GND_Tempt_GND=((+T0_Tempt_GND_Tempt_GND+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Tempt_GND+pModel->XTIS*T1_Tempt_GND_Tempt_GND))/pModel->NJS-((T0_Tempt_GND+(pModel->XTIS*T1_Tempt_GND))*0.0+(T0_Tempt_GND+((pModel->XTIS*T1_Tempt_GND)))*0.0+(T0+(pModel->XTIS*T1))*0.0)/pModel->NJS/pModel->NJS+2*(T0+(pModel->XTIS*T1))*0.0*0.0/pModel->NJS/pModel->NJS/pModel->NJS);
#endif
#endif
T3=bsimcmg_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS));
EXIT_IF_ISNAN(bsimcmg_lexp(((T0+(pModel->XTIS*T1))/pModel->NJS)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSS_t_Tempt_GND=(pModel->JSS*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSS_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSS*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSS_t=(pModel->JSS*T3);
EXIT_IF_ISNAN((pModel->JSS*T3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWS_t_Tempt_GND=(pModel->JSWS*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSWS_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSWS*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSWS_t=(pModel->JSWS*T3);
EXIT_IF_ISNAN((pModel->JSWS*T3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWGS_t_Tempt_GND=(pModel->JSWGS*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSWGS_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSWGS*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSWGS_t=(pModel->JSWGS*T3);
EXIT_IF_ISNAN((pModel->JSWGS*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=bsimcmg_d_lexp(((T0+(pModel->XTID*T1))/pModel->NJD),((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))/pModel->NJD));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=((+0.0+(+0.0*T1+0.0*T1_Vdi_d+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vdi_d))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+((pModel->XTID*T1_Vdi_d))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Vsi_s=((+0.0+(+0.0*T1+0.0*T1_Vsi_s+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vsi_s))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+((pModel->XTID*T1_Vsi_s))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Vge_di=((+T0_Tempt_GND_Vge_di+(+0.0*T1+0.0*T1_Vge_di+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vge_di))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Vge_di+((pModel->XTID*T1_Vge_di)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Vge_e=((+T0_Tempt_GND_Vge_e+(+0.0*T1+0.0*T1_Vge_e+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vge_e))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Vge_e+((pModel->XTID*T1_Vge_e)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Vdi_si=((+T0_Tempt_GND_Vdi_si+(+0.0*T1+0.0*T1_Vdi_si+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vdi_si))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Vdi_si+((pModel->XTID*T1_Vdi_si)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Ve_si=((+T0_Tempt_GND_Ve_si+(+0.0*T1+0.0*T1_Ve_si+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Ve_si))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Ve_si+((pModel->XTID*T1_Ve_si)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Ve_di=((+T0_Tempt_GND_Ve_di+(+0.0*T1+0.0*T1_Ve_di+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Ve_di))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Ve_di+((pModel->XTID*T1_Ve_di)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Vge_si=((+T0_Tempt_GND_Vge_si+(+0.0*T1+0.0*T1_Vge_si+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Vge_si))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Vge_si+((pModel->XTID*T1_Vge_si)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
  T3_Tempt_GND_Tempt_GND=((+T0_Tempt_GND_Tempt_GND+(+0.0*T1+0.0*T1_Tempt_GND+0.0*T1_Tempt_GND+pModel->XTID*T1_Tempt_GND_Tempt_GND))/pModel->NJD-((T0_Tempt_GND+(pModel->XTID*T1_Tempt_GND))*0.0+(T0_Tempt_GND+((pModel->XTID*T1_Tempt_GND)))*0.0+(T0+(pModel->XTID*T1))*0.0)/pModel->NJD/pModel->NJD+2*(T0+(pModel->XTID*T1))*0.0*0.0/pModel->NJD/pModel->NJD/pModel->NJD);
#endif
#endif
T3=bsimcmg_lexp(((T0+(pModel->XTID*T1))/pModel->NJD));
EXIT_IF_ISNAN(bsimcmg_lexp(((T0+(pModel->XTID*T1))/pModel->NJD)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSD_t_Tempt_GND=(pModel->JSD*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSD_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSD*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSD_t=(pModel->JSD*T3);
EXIT_IF_ISNAN((pModel->JSD*T3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWD_t_Tempt_GND=(pModel->JSWD*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSWD_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSWD*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSWD_t=(pModel->JSWD*T3);
EXIT_IF_ISNAN((pModel->JSWD*T3))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
JSWGD_t_Tempt_GND=(pModel->JSWGD*T3_Tempt_GND);
#if defined(_DERIVATE2)
  JSWGD_t_Tempt_GND_Tempt_GND=(+0.0*T3+0.0*T3_Tempt_GND+0.0*T3_Tempt_GND+pModel->JSWGD*T3_Tempt_GND_Tempt_GND);
#endif
#endif
JSWGD_t=(pModel->JSWGD*T3);
EXIT_IF_ISNAN((pModel->JSWGD*T3))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSS_t_Tempt_GND=(pModel->JTSS*bsimcmg_d_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSS)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSS_t=(pModel->JTSS*bsimcmg_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSS*bsimcmg_lexp((((Eg0*pModel->XTSS)*(TRatio-1.0))/Vtm))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSD_t_Tempt_GND=(pModel->JTSD*bsimcmg_d_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSD)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSD_t=(pModel->JTSD*bsimcmg_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSD*bsimcmg_lexp((((Eg0*pModel->XTSD)*(TRatio-1.0))/Vtm))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWS_t_Tempt_GND=(pModel->JTSSWS*bsimcmg_d_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWS)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWS_t=(pModel->JTSSWS*bsimcmg_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSSWS*bsimcmg_lexp((((Eg0*pModel->XTSSWS)*(TRatio-1.0))/Vtm))))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWD_t_Tempt_GND=(pModel->JTSSWD*bsimcmg_d_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWD)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWD_t=(pModel->JTSSWD*bsimcmg_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN((pModel->JTSSWD*bsimcmg_lexp((((Eg0*pModel->XTSSWD)*(TRatio-1.0))/Vtm))))
{
double m00_sqrt(d00_sqrt0,(pModel->JTWEFF/Weff0))
#if defined(_DERIVATE)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGS_t_Tempt_GND=((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimcmg_d_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWGS)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWGS)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWGS_t=((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimcmg_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN(((pModel->JTSSWGS*(d00_sqrt0+1.0))*bsimcmg_lexp((((Eg0*pModel->XTSSWGS)*(TRatio-1.0))/Vtm))))
}
{
double m00_sqrt(d00_sqrt0,(pModel->JTWEFF/Weff0))
#if defined(_DERIVATE)
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
JTSSWGD_t_Tempt_GND=((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimcmg_d_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1.0))/Vtm),((((Eg0*pModel->XTSSWGD)*TRatio_Tempt_GND)*Vtm-((Eg0*pModel->XTSSWGD)*(TRatio-1.0))*Vtm_Tempt_GND)/Vtm/Vtm)));
#endif
JTSSWGD_t=((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimcmg_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1.0))/Vtm)));
EXIT_IF_ISNAN(((pModel->JTSSWGD*(d00_sqrt0+1.0))*bsimcmg_lexp((((Eg0*pModel->XTSSWGD)*(TRatio-1.0))/Vtm))))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTS_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTS*(pModel->TNJTS*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTS_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTS_t=(bsimcmg_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTS*(1.0+(pModel->TNJTS*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSD*(pModel->TNJTSD*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTSD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTSD_t=(bsimcmg_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTSD*(1.0+(pModel->TNJTSD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSW_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSW*(pModel->TNJTSSW*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTSSW_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTSSW_t=(bsimcmg_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTSSW*(1.0+(pModel->TNJTSSW*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWD*(pModel->TNJTSSWD*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTSSWD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTSSWD_t=(bsimcmg_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTSSWD*(1.0+(pModel->TNJTSSWD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWG_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWG*(pModel->TNJTSSWG*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTSSWG_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTSSWG_t=(bsimcmg_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTSSWG*(1.0+(pModel->TNJTSSWG*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
NJTSSWGD_t_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3,(pModel->NJTSSWGD*(pModel->TNJTSSWGD*TRatio_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  NJTSSWGD_t_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
NJTSSWGD_t=(bsimcmg_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3)+0.01);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->NJTSSWGD*(1.0+(pModel->TNJTSSWGD*(TRatio-1.0))))-0.01),1.0e-3)+0.01))
}
if
((!(model->VFBSD_Given)))
{
if
((pModel->NGATE>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vfbsd_Tempt_GND=(devsign*(bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NGATE/ni)))+(Vtm*bsimcmg_d_lln((pModel->NGATE/ni),(-pModel->NGATE*ni_Tempt_GND/ni/ni))))),0.0)-((0.5*Eg_Tempt_GND)-(devsign*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))))));
#if defined(_DERIVATE2)
  vfbsd_Tempt_GND_Tempt_GND=(+0.0*(bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4)-((0.5*Eg)-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4)))))+0.0*(bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NGATE/ni)))+(Vtm*bsimcmg_d_lln((pModel->NGATE/ni),(-pModel->NGATE*ni_Tempt_GND/ni/ni))))),0.0)-(((0.5*Eg_Tempt_GND))-((devsign*(((0.5*Eg_Tempt_GND))-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))))))+0.0*(bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NGATE/ni)))+(Vtm*bsimcmg_d_lln((pModel->NGATE/ni),(-pModel->NGATE*ni_Tempt_GND/ni/ni))))),0.0)-((0.5*Eg_Tempt_GND)-(devsign*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0)))))+devsign*(+0.0-(+(+0.0*Eg+0.0*Eg_Tempt_GND+0.0*Eg_Tempt_GND+0.5*Eg_Tempt_GND_Tempt_GND)-(+0.0*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4))+0.0*(((0.5*Eg_Tempt_GND))-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))+0.0*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))+devsign*(+(+0.0*Eg+0.0*Eg_Tempt_GND+0.0*Eg_Tempt_GND+0.5*Eg_Tempt_GND_Tempt_GND)-0.0)))));
#endif
#endif
vfbsd=(devsign*(bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4)-((0.5*Eg)-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4))))));
EXIT_IF_ISNAN((devsign*(bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NGATE/ni)))),1.0e-4)-((0.5*Eg)-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vfbsd_Tempt_GND=(devsign*(-((0.5*Eg_Tempt_GND)-(devsign*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))))));
#if defined(_DERIVATE2)
  vfbsd_Tempt_GND_Tempt_GND=(+0.0*(PHIG_i-((pModel->EASUB+(0.5*Eg))-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4)))))+0.0*(-(((0.5*Eg_Tempt_GND))-((devsign*(((0.5*Eg_Tempt_GND))-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))))))+0.0*(-((0.5*Eg_Tempt_GND)-(devsign*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0)))))+devsign*(+0.0-(+(+0.0+(+0.0*Eg+0.0*Eg_Tempt_GND+0.0*Eg_Tempt_GND+0.5*Eg_Tempt_GND_Tempt_GND))-(+0.0*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4))+0.0*(((0.5*Eg_Tempt_GND))-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))+0.0*((0.5*Eg_Tempt_GND)-bsimcmg_d_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4,((0.5*Eg_Tempt_GND)-((Vtm_Tempt_GND*bsimcmg_lln((pModel->NSD/ni)))+(Vtm*bsimcmg_d_lln((pModel->NSD/ni),(-pModel->NSD*ni_Tempt_GND/ni/ni))))),0.0))+devsign*(+(+0.0*Eg+0.0*Eg_Tempt_GND+0.0*Eg_Tempt_GND+0.5*Eg_Tempt_GND_Tempt_GND)-0.0)))));
#endif
#endif
vfbsd=(devsign*(PHIG_i-((pModel->EASUB+(0.5*Eg))-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4))))));
EXIT_IF_ISNAN((devsign*(PHIG_i-((pModel->EASUB+(0.5*Eg))-(devsign*((0.5*Eg)-bsimcmg_hypsmooth(((0.5*Eg)-(Vtm*bsimcmg_lln((pModel->NSD/ni)))),1.0e-4)))))))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vfbsd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  vfbsd_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
vfbsd=pModel->VFBSD;
EXIT_IF_ISNAN(pModel->VFBSD)
}
if
((!(model->VFBSDCV_Given)))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
vfbsdcv_Tempt_GND=vfbsd_Tempt_GND;
#if defined(_DERIVATE2)
  vfbsdcv_Tempt_GND_Tempt_GND=vfbsd_Tempt_GND_Tempt_GND;
#endif
#endif
vfbsdcv=vfbsd;
EXIT_IF_ISNAN(vfbsd)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
vfbsdcv_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  vfbsdcv_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
vfbsdcv=pModel->VFBSDCV;
EXIT_IF_ISNAN(pModel->VFBSDCV)
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=((Vtm_Tempt_GND*bsimcmg_lln((nbody/ni)))+(Vtm*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+0.0*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*0.0+0.0*ni_Tempt_GND+nbody*0.0)/ni/ni+2*nbody*ni_Tempt_GND*0.0/ni/ni/ni));
  T0_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*ni_Tempt_GND+0.0*ni_Tempt_GND+nbody*ni_Tempt_GND_Tempt_GND)/ni/ni+2*nbody*ni_Tempt_GND*ni_Tempt_GND/ni/ni/ni));
#endif
#endif
T0=(Vtm*bsimcmg_lln((nbody/ni)));
EXIT_IF_ISNAN((Vtm*bsimcmg_lln((nbody/ni))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
phib_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  phib_Tempt_GND_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-6))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
phib=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
phib_Tempt_GND=((Vtm_Tempt_GND*bsimcmg_lln((nbody/ni)))+(Vtm*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))));
#if defined(_DERIVATE2)
  phib_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*bsimcmg_lln((nbody/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm_Tempt_GND*bsimcmg_d_lln((nbody/ni),(-nbody*ni_Tempt_GND/ni/ni))+Vtm*(0.0/ni-(0.0*ni_Tempt_GND+0.0*ni_Tempt_GND+nbody*ni_Tempt_GND_Tempt_GND)/ni/ni+2*nbody*ni_Tempt_GND*ni_Tempt_GND/ni/ni/ni));
#endif
#endif
phib=(Vtm*bsimcmg_lln((nbody/ni)));
EXIT_IF_ISNAN((Vtm*bsimcmg_lln((nbody/ni))))
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=((Vtm_Tempt_GND*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni))))+(Vtm*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+0.0*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(0.0)+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+0.0*ni+ni_Tempt_GND*0.0+0.0*ni_Tempt_GND+ni*0.0))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(0.0)/(ni*ni)/(ni*ni)/(ni*ni)));
  T0_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND)))+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+ni_Tempt_GND_Tempt_GND*ni+ni_Tempt_GND*ni_Tempt_GND+ni_Tempt_GND*ni_Tempt_GND+ni*ni_Tempt_GND_Tempt_GND))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND)))/(ni*ni)/(ni*ni)/(ni*ni)));
#endif
#endif
T0=(Vtm*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni))));
EXIT_IF_ISNAN((Vtm*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-6))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-6))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vbi_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  vbi_Tempt_GND_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-6))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
vbi=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vbi_Tempt_GND=((Vtm_Tempt_GND*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni))))+(Vtm*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))));
#if defined(_DERIVATE2)
  vbi_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm_Tempt_GND*bsimcmg_d_lln(((nbody*pModel->NSD)/(ni*ni)),(-(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))/(ni*ni)/(ni*ni)))+Vtm*((+0.0*pModel->NSD+0.0*0.0+0.0*0.0+nbody*0.0)/(ni*ni)-(0.0*(((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND)))+(0.0)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))+(nbody*pModel->NSD)*(+ni_Tempt_GND_Tempt_GND*ni+ni_Tempt_GND*ni_Tempt_GND+ni_Tempt_GND*ni_Tempt_GND+ni*ni_Tempt_GND_Tempt_GND))/(ni*ni)/(ni*ni)+2*(nbody*pModel->NSD)*((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND))*(((ni_Tempt_GND*ni)+(ni*ni_Tempt_GND)))/(ni*ni)/(ni*ni)/(ni*ni)));
#endif
#endif
vbi=(Vtm*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni))));
EXIT_IF_ISNAN((Vtm*bsimcmg_lln(((nbody*pModel->NSD)/(ni*ni)))))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
deltaPhi_Tempt_GND=(devsign*(-((pModel->TYPE==1)?0.0:Eg_Tempt_GND)));
#if defined(_DERIVATE2)
  deltaPhi_Tempt_GND_Tempt_GND=(+0.0*(PHIG_i-(pModel->EASUB+((pModel->TYPE==1)?0:Eg)))+0.0*(-Eg_Tempt_GND)+0.0*(-((pModel->TYPE==1)?0.0:Eg_Tempt_GND))+devsign*(+0.0-(+0.0+fixme)));
#endif
#endif
deltaPhi=(devsign*(PHIG_i-(pModel->EASUB+((pModel->TYPE==1)?0:Eg))));
EXIT_IF_ISNAN((devsign*(PHIG_i-(pModel->EASUB+((pModel->TYPE==1)?0:Eg)))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
eta_mu_Tempt_GND=(0.5*ETAMOB_t_Tempt_GND);
#if defined(_DERIVATE2)
  eta_mu_Tempt_GND_Tempt_GND=(+0.0*ETAMOB_t+0.0*ETAMOB_t_Tempt_GND+0.0*ETAMOB_t_Tempt_GND+0.5*ETAMOB_t_Tempt_GND_Tempt_GND);
#endif
#endif
eta_mu=(0.5*ETAMOB_t);
EXIT_IF_ISNAN((0.5*ETAMOB_t))
eta_mu_cv=0.5;
EXIT_IF_ISNAN(0.5)
if
((pModel->TYPE!=1))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
eta_mu_Tempt_GND=((1.0/3.0)*ETAMOB_t_Tempt_GND);
#if defined(_DERIVATE2)
  eta_mu_Tempt_GND_Tempt_GND=(+(0.0/3.0-(0.0*0.0+0.0*0.0+1.0*0.0)/3.0/3.0+2*1.0*0.0*0.0/3.0/3.0/3.0)*ETAMOB_t+0.0*ETAMOB_t_Tempt_GND+0.0*ETAMOB_t_Tempt_GND+(1.0/3.0)*ETAMOB_t_Tempt_GND_Tempt_GND);
#endif
#endif
eta_mu=((1.0/3.0)*ETAMOB_t);
EXIT_IF_ISNAN(((1.0/3.0)*ETAMOB_t))
eta_mu_cv=(1.0/3.0);
EXIT_IF_ISNAN((1.0/3.0))
}
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Isbs_Tempt_GND=(((pInst->ASEJ*JSS_t_Tempt_GND)+(pInst->PSEJ*JSWS_t_Tempt_GND))+((pInst->TFIN*NFINtotal)*JSWGS_t_Tempt_GND));
#if defined(_DERIVATE2)
  Isbs_Tempt_GND_Tempt_GND=(+(+(+0.0*JSS_t+0.0*JSS_t_Tempt_GND+0.0*JSS_t_Tempt_GND+pInst->ASEJ*JSS_t_Tempt_GND_Tempt_GND)+(+0.0*JSWS_t+0.0*JSWS_t_Tempt_GND+0.0*JSWS_t_Tempt_GND+pInst->PSEJ*JSWS_t_Tempt_GND_Tempt_GND))+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+pInst->TFIN*0.0)*JSWGS_t+0.0*JSWGS_t_Tempt_GND+(0.0)*JSWGS_t_Tempt_GND+(pInst->TFIN*NFINtotal)*JSWGS_t_Tempt_GND_Tempt_GND));
#endif
#endif
Isbs=(((pInst->ASEJ*JSS_t)+(pInst->PSEJ*JSWS_t))+((pInst->TFIN*NFINtotal)*JSWGS_t));
EXIT_IF_ISNAN((((pInst->ASEJ*JSS_t)+(pInst->PSEJ*JSWS_t))+((pInst->TFIN*NFINtotal)*JSWGS_t)))
if
((Isbs>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Nvtms_Tempt_GND=Vtm_Tempt_GND*pModel->NJS;
#if defined(_DERIVATE2)
  Nvtms_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*pModel->NJS+Vtm_Tempt_GND*0.0+Vtm_Tempt_GND*0.0+Vtm*0.0);
#endif
#endif
Nvtms=(Vtm*pModel->NJS);
EXIT_IF_ISNAN((Vtm*pModel->NJS))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
XExpBVS_Tempt_GND=bsimcmg_d_lexp(((-pModel->BVS)/Nvtms),(-(-pModel->BVS)*Nvtms_Tempt_GND/Nvtms/Nvtms))*pModel->XJBVS;
#if defined(_DERIVATE2)
  XExpBVS_Tempt_GND_Tempt_GND=(+(0.0/Nvtms-(0.0*Nvtms_Tempt_GND+0.0*Nvtms_Tempt_GND+(-pModel->BVS)*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*(-pModel->BVS)*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms)*pModel->XJBVS+bsimcmg_d_lexp(((-pModel->BVS)/Nvtms),(-(-pModel->BVS)*Nvtms_Tempt_GND/Nvtms/Nvtms))*0.0+bsimcmg_d_lexp(((-pModel->BVS)/Nvtms),(-(-pModel->BVS)*Nvtms_Tempt_GND/Nvtms/Nvtms))*0.0+bsimcmg_lexp(((-pModel->BVS)/Nvtms))*0.0);
#endif
#endif
XExpBVS=(bsimcmg_lexp(((-pModel->BVS)/Nvtms))*pModel->XJBVS);
EXIT_IF_ISNAN((bsimcmg_lexp(((-pModel->BVS)/Nvtms))*pModel->XJBVS))
{
double m00_max(d00_max0,(pModel->IJTHSFWD/Isbs),10.0)
#if defined(_DERIVATEFORDDX)
double m10_max(d10_max0,d00_max0,(pModel->IJTHSFWD/Isbs),10.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(d10_max0*(-pModel->IJTHSFWD*Isbs_Tempt_GND/Isbs/Isbs));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=fixme;
  T2_Tempt_GND_Vsi_s=fixme;
  T2_Tempt_GND_Vge_di=fixme;
  T2_Tempt_GND_Vge_e=fixme;
  T2_Tempt_GND_Vge_si=fixme;
  T2_Tempt_GND_Ve_si=fixme;
  T2_Tempt_GND_Ve_di=fixme;
  T2_Tempt_GND_Vdi_si=fixme;
  T2_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T2=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
Tb_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Tb_Vdi_si_Vdi_si=0.0;
  Tb_Vdi_si_Ve_si=0.0;
  Tb_Vdi_si_Ve_di=0.0;
  Tb_Vdi_si_Vge_si=0.0;
  Tb_Vdi_si_Tempt_GND=0.0;
#endif
Tb_Ve_si=0.0;
#if defined(_DERIVATE2)
  Tb_Ve_si_Vdi_si=0.0;
  Tb_Ve_si_Ve_si=0.0;
  Tb_Ve_si_Ve_di=0.0;
  Tb_Ve_si_Vge_si=0.0;
  Tb_Ve_si_Tempt_GND=0.0;
#endif
Tb_Ve_di=0.0;
#if defined(_DERIVATE2)
  Tb_Ve_di_Vdi_si=0.0;
  Tb_Ve_di_Ve_si=0.0;
  Tb_Ve_di_Ve_di=0.0;
  Tb_Ve_di_Vge_si=0.0;
  Tb_Ve_di_Tempt_GND=0.0;
#endif
Tb_Vge_si=0.0;
#if defined(_DERIVATE2)
  Tb_Vge_si_Vdi_si=0.0;
  Tb_Vge_si_Ve_si=0.0;
  Tb_Vge_si_Ve_di=0.0;
  Tb_Vge_si_Vge_si=0.0;
  Tb_Vge_si_Tempt_GND=0.0;
#endif
Tb_Tempt_GND=(T2_Tempt_GND-XExpBVS_Tempt_GND);
#if defined(_DERIVATE2)
  Tb_Tempt_GND_Vdi_si=(+(+0.0+T2_Tempt_GND_Vdi_si)-0.0);
  Tb_Tempt_GND_Ve_si=(+(+0.0+T2_Tempt_GND_Ve_si)-0.0);
  Tb_Tempt_GND_Ve_di=(+(+0.0+T2_Tempt_GND_Ve_di)-0.0);
  Tb_Tempt_GND_Vge_si=(+(+0.0+T2_Tempt_GND_Vge_si)-0.0);
  Tb_Tempt_GND_Tempt_GND=(+(+0.0+T2_Tempt_GND_Tempt_GND)-XExpBVS_Tempt_GND_Tempt_GND);
#endif
#endif
Tb=((1.0+T2)-XExpBVS);
EXIT_IF_ISNAN(((1.0+T2)-XExpBVS))
{
double m00_sqrt(d00_sqrt0,((Tb*Tb)+(4.0*XExpBVS)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Tb*Tb)+(4.0*XExpBVS)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjsmFwd_Tempt_GND=((Nvtms_Tempt_GND*bsimcmg_lln((0.5*(Tb+d00_sqrt0))))+(Nvtms*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))*d10_sqrt0)))));
#if defined(_DERIVATE2)
  VjsmFwd_Tempt_GND_Tempt_GND=(+Nvtms_Tempt_GND_Tempt_GND*bsimcmg_lln((0.5*(Tb+d00_sqrt0)))+Nvtms_Tempt_GND*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))*d10_sqrt0)))+Nvtms_Tempt_GND*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))*d10_sqrt0)))+Nvtms*(+0.0*(Tb+d00_sqrt0)+0.0*(Tb_Tempt_GND+((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))+((4.0*XExpBVS_Tempt_GND)))*d10_sqrt0)+0.0*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))*d10_sqrt0)+0.5*(+Tb_Tempt_GND_Tempt_GND+(m20_sqrt(((Tb*Tb)+(4.0*XExpBVS)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))+((4.0*XExpBVS_Tempt_GND)))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVS_Tempt_GND))+d10_sqrt0*(+(+Tb_Tempt_GND_Tempt_GND*Tb+Tb_Tempt_GND*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Tempt_GND)+(+0.0*XExpBVS+0.0*XExpBVS_Tempt_GND+0.0*XExpBVS_Tempt_GND+4.0*XExpBVS_Tempt_GND_Tempt_GND))))));
#endif
#endif
VjsmFwd=(Nvtms*bsimcmg_lln((0.5*(Tb+d00_sqrt0))));
EXIT_IF_ISNAN((Nvtms*bsimcmg_lln((0.5*(Tb+d00_sqrt0)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=bsimcmg_d_lexp((VjsmFwd/Nvtms),((VjsmFwd_Tempt_GND*Nvtms-VjsmFwd*Nvtms_Tempt_GND)/Nvtms/Nvtms));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_e=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_si=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_di=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_si=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtms-(VjsmFwd_Tempt_GND*0.0+0.0*Nvtms_Tempt_GND+VjsmFwd*0.0)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Tempt_GND=(VjsmFwd_Tempt_GND_Tempt_GND/Nvtms-(VjsmFwd_Tempt_GND*Nvtms_Tempt_GND+VjsmFwd_Tempt_GND*Nvtms_Tempt_GND+VjsmFwd*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*VjsmFwd*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
#endif
T0=bsimcmg_lexp((VjsmFwd/Nvtms));
EXIT_IF_ISNAN(bsimcmg_lexp((VjsmFwd/Nvtms)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjsmFwd_Tempt_GND=((Isbs_Tempt_GND*(((T0-(XExpBVS/T0))+XExpBVS)-1.0))+(Isbs*((T0_Tempt_GND-((XExpBVS_Tempt_GND*T0-XExpBVS*T0_Tempt_GND)/T0/T0))+XExpBVS_Tempt_GND)));
#endif
IVjsmFwd=(Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0));
EXIT_IF_ISNAN((Isbs*(((T0-(XExpBVS/T0))+XExpBVS)-1.0)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
SslpFwd_Tempt_GND=((((Isbs_Tempt_GND*(T0+(XExpBVS/T0)))+(Isbs*(T0_Tempt_GND+((XExpBVS_Tempt_GND*T0-XExpBVS*T0_Tempt_GND)/T0/T0))))*Nvtms-(Isbs*(T0+(XExpBVS/T0)))*Nvtms_Tempt_GND)/Nvtms/Nvtms);
#endif
SslpFwd=((Isbs*(T0+(XExpBVS/T0)))/Nvtms);
EXIT_IF_ISNAN(((Isbs*(T0+(XExpBVS/T0)))/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3,(-pModel->IJTHSREV*Isbs_Tempt_GND/Isbs/Isbs),0.0);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+0.0);
  T2_Tempt_GND_Vsi_s=(+0.0+0.0);
  T2_Tempt_GND_Vge_di=(+0.0+0.0);
  T2_Tempt_GND_Vge_e=(+0.0+0.0);
  T2_Tempt_GND_Vge_si=(+0.0+0.0);
  T2_Tempt_GND_Ve_si=(+0.0+0.0);
  T2_Tempt_GND_Ve_di=(+0.0+0.0);
  T2_Tempt_GND_Vdi_si=(+0.0+0.0);
  T2_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
T2=(bsimcmg_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3)+10.0);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->IJTHSREV/Isbs)-10.0),1.0e-3)+10.0))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjsmRev_Tempt_GND=(-((Nvtms_Tempt_GND*bsimcmg_lln(((T2-1.0)/pModel->XJBVS)))+(Nvtms*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVS),(T2_Tempt_GND/pModel->XJBVS)))));
#if defined(_DERIVATE2)
  VjsmRev_Tempt_GND_Tempt_GND=(+0.0-(+Nvtms_Tempt_GND_Tempt_GND*bsimcmg_lln(((T2-1.0)/pModel->XJBVS))+Nvtms_Tempt_GND*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVS),(T2_Tempt_GND/pModel->XJBVS))+Nvtms_Tempt_GND*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVS),(T2_Tempt_GND/pModel->XJBVS))+Nvtms*((+T2_Tempt_GND_Tempt_GND-0.0)/pModel->XJBVS-(T2_Tempt_GND*0.0+T2_Tempt_GND*0.0+(T2-1.0)*0.0)/pModel->XJBVS/pModel->XJBVS+2*(T2-1.0)*0.0*0.0/pModel->XJBVS/pModel->XJBVS/pModel->XJBVS)));
#endif
#endif
VjsmRev=((-pModel->BVS)-(Nvtms*bsimcmg_lln(((T2-1.0)/pModel->XJBVS))));
EXIT_IF_ISNAN(((-pModel->BVS)-(Nvtms*bsimcmg_lln(((T2-1.0)/pModel->XJBVS)))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(pModel->XJBVS*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Vge_di=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Vge_e=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Ve_si=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Ve_di=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Vge_si=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*0.0+0.0*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*0.0)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms));
  T1_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+0.0*bsimcmg_d_lexp(((-(pModel->BVS+VjsmRev))/Nvtms),(((-VjsmRev_Tempt_GND)*Nvtms-(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND)/Nvtms/Nvtms))+pModel->XJBVS*(0.0/Nvtms-((-VjsmRev_Tempt_GND)*Nvtms_Tempt_GND+(-VjsmRev_Tempt_GND)*Nvtms_Tempt_GND+(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*(-(pModel->BVS+VjsmRev))*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms));
#endif
#endif
T1=(pModel->XJBVS*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms)));
EXIT_IF_ISNAN((pModel->XJBVS*bsimcmg_lexp(((-(pModel->BVS+VjsmRev))/Nvtms))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
IVjsmRev_Tempt_GND=((Isbs_Tempt_GND*(1.0+T1))+(Isbs*T1_Tempt_GND));
#if defined(_DERIVATE2)
  IVjsmRev_Tempt_GND_Tempt_GND=(+Isbs_Tempt_GND_Tempt_GND*(1.0+T1)+Isbs_Tempt_GND*T1_Tempt_GND+Isbs_Tempt_GND*T1_Tempt_GND+Isbs*(+0.0+T1_Tempt_GND_Tempt_GND));
#endif
#endif
IVjsmRev=(Isbs*(1.0+T1));
EXIT_IF_ISNAN((Isbs*(1.0+T1)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
SslpRev_Tempt_GND=(((((-Isbs_Tempt_GND)*T1)+((-Isbs)*T1_Tempt_GND))*Nvtms-((-Isbs)*T1)*Nvtms_Tempt_GND)/Nvtms/Nvtms);
#if defined(_DERIVATE2)
  SslpRev_Tempt_GND_Tempt_GND=((+0.0*T1+(-Isbs_Tempt_GND)*T1_Tempt_GND+(-Isbs_Tempt_GND)*T1_Tempt_GND+(-Isbs)*T1_Tempt_GND_Tempt_GND)/Nvtms-((((-Isbs_Tempt_GND)*T1)+((-Isbs)*T1_Tempt_GND))*Nvtms_Tempt_GND+((((-Isbs_Tempt_GND)*T1)+((-Isbs)*T1_Tempt_GND)))*Nvtms_Tempt_GND+((-Isbs)*T1)*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*((-Isbs)*T1)*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
#endif
SslpRev=(((-Isbs)*T1)/Nvtms);
EXIT_IF_ISNAN((((-Isbs)*T1)/Nvtms))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Isbd_Tempt_GND=(((pInst->ADEJ*JSD_t_Tempt_GND)+(pInst->PDEJ*JSWD_t_Tempt_GND))+((pInst->TFIN*NFINtotal)*JSWGD_t_Tempt_GND));
#if defined(_DERIVATE2)
  Isbd_Tempt_GND_Tempt_GND=(+(+(+0.0*JSD_t+0.0*JSD_t_Tempt_GND+0.0*JSD_t_Tempt_GND+pInst->ADEJ*JSD_t_Tempt_GND_Tempt_GND)+(+0.0*JSWD_t+0.0*JSWD_t_Tempt_GND+0.0*JSWD_t_Tempt_GND+pInst->PDEJ*JSWD_t_Tempt_GND_Tempt_GND))+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+pInst->TFIN*0.0)*JSWGD_t+0.0*JSWGD_t_Tempt_GND+(0.0)*JSWGD_t_Tempt_GND+(pInst->TFIN*NFINtotal)*JSWGD_t_Tempt_GND_Tempt_GND));
#endif
#endif
Isbd=(((pInst->ADEJ*JSD_t)+(pInst->PDEJ*JSWD_t))+((pInst->TFIN*NFINtotal)*JSWGD_t));
EXIT_IF_ISNAN((((pInst->ADEJ*JSD_t)+(pInst->PDEJ*JSWD_t))+((pInst->TFIN*NFINtotal)*JSWGD_t)))
if
((Isbd>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Nvtmd_Tempt_GND=Vtm_Tempt_GND*pModel->NJD;
#if defined(_DERIVATE2)
  Nvtmd_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*pModel->NJD+Vtm_Tempt_GND*0.0+Vtm_Tempt_GND*0.0+Vtm*0.0);
#endif
#endif
Nvtmd=(Vtm*pModel->NJD);
EXIT_IF_ISNAN((Vtm*pModel->NJD))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
XExpBVD_Tempt_GND=bsimcmg_d_lexp(((-pModel->BVD)/Nvtmd),(-(-pModel->BVD)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd))*pModel->XJBVD;
#if defined(_DERIVATE2)
  XExpBVD_Tempt_GND_Tempt_GND=(+(0.0/Nvtmd-(0.0*Nvtmd_Tempt_GND+0.0*Nvtmd_Tempt_GND+(-pModel->BVD)*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*(-pModel->BVD)*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd)*pModel->XJBVD+bsimcmg_d_lexp(((-pModel->BVD)/Nvtmd),(-(-pModel->BVD)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd))*0.0+bsimcmg_d_lexp(((-pModel->BVD)/Nvtmd),(-(-pModel->BVD)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd))*0.0+bsimcmg_lexp(((-pModel->BVD)/Nvtmd))*0.0);
#endif
#endif
XExpBVD=(bsimcmg_lexp(((-pModel->BVD)/Nvtmd))*pModel->XJBVD);
EXIT_IF_ISNAN((bsimcmg_lexp(((-pModel->BVD)/Nvtmd))*pModel->XJBVD))
{
double m00_max(d00_max0,(pModel->IJTHDFWD/Isbd),10.0)
#if defined(_DERIVATEFORDDX)
double m10_max(d10_max0,d00_max0,(pModel->IJTHDFWD/Isbd),10.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(d10_max0*(-pModel->IJTHDFWD*Isbd_Tempt_GND/Isbd/Isbd));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=fixme;
  T2_Tempt_GND_Vsi_s=fixme;
  T2_Tempt_GND_Vge_di=fixme;
  T2_Tempt_GND_Vge_e=fixme;
  T2_Tempt_GND_Vge_si=fixme;
  T2_Tempt_GND_Ve_si=fixme;
  T2_Tempt_GND_Ve_di=fixme;
  T2_Tempt_GND_Vdi_si=fixme;
  T2_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T2=d00_max0;
EXIT_IF_ISNAN(d00_max0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
Tb_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Tb_Vdi_si_Vdi_si=0.0;
  Tb_Vdi_si_Ve_si=0.0;
  Tb_Vdi_si_Ve_di=0.0;
  Tb_Vdi_si_Vge_si=0.0;
  Tb_Vdi_si_Tempt_GND=0.0;
#endif
Tb_Ve_si=0.0;
#if defined(_DERIVATE2)
  Tb_Ve_si_Vdi_si=0.0;
  Tb_Ve_si_Ve_si=0.0;
  Tb_Ve_si_Ve_di=0.0;
  Tb_Ve_si_Vge_si=0.0;
  Tb_Ve_si_Tempt_GND=0.0;
#endif
Tb_Ve_di=0.0;
#if defined(_DERIVATE2)
  Tb_Ve_di_Vdi_si=0.0;
  Tb_Ve_di_Ve_si=0.0;
  Tb_Ve_di_Ve_di=0.0;
  Tb_Ve_di_Vge_si=0.0;
  Tb_Ve_di_Tempt_GND=0.0;
#endif
Tb_Vge_si=0.0;
#if defined(_DERIVATE2)
  Tb_Vge_si_Vdi_si=0.0;
  Tb_Vge_si_Ve_si=0.0;
  Tb_Vge_si_Ve_di=0.0;
  Tb_Vge_si_Vge_si=0.0;
  Tb_Vge_si_Tempt_GND=0.0;
#endif
Tb_Tempt_GND=(T2_Tempt_GND-XExpBVD_Tempt_GND);
#if defined(_DERIVATE2)
  Tb_Tempt_GND_Vdi_si=(+(+0.0+T2_Tempt_GND_Vdi_si)-0.0);
  Tb_Tempt_GND_Ve_si=(+(+0.0+T2_Tempt_GND_Ve_si)-0.0);
  Tb_Tempt_GND_Ve_di=(+(+0.0+T2_Tempt_GND_Ve_di)-0.0);
  Tb_Tempt_GND_Vge_si=(+(+0.0+T2_Tempt_GND_Vge_si)-0.0);
  Tb_Tempt_GND_Tempt_GND=(+(+0.0+T2_Tempt_GND_Tempt_GND)-XExpBVD_Tempt_GND_Tempt_GND);
#endif
#endif
Tb=((1.0+T2)-XExpBVD);
EXIT_IF_ISNAN(((1.0+T2)-XExpBVD))
{
double m00_sqrt(d00_sqrt0,((Tb*Tb)+(4.0*XExpBVD)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Tb*Tb)+(4.0*XExpBVD)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjdmFwd_Tempt_GND=((Nvtmd_Tempt_GND*bsimcmg_lln((0.5*(Tb+d00_sqrt0))))+(Nvtmd*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))*d10_sqrt0)))));
#if defined(_DERIVATE2)
  VjdmFwd_Tempt_GND_Tempt_GND=(+Nvtmd_Tempt_GND_Tempt_GND*bsimcmg_lln((0.5*(Tb+d00_sqrt0)))+Nvtmd_Tempt_GND*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))*d10_sqrt0)))+Nvtmd_Tempt_GND*bsimcmg_d_lln((0.5*(Tb+d00_sqrt0)),(0.5*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))*d10_sqrt0)))+Nvtmd*(+0.0*(Tb+d00_sqrt0)+0.0*(Tb_Tempt_GND+((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))+((4.0*XExpBVD_Tempt_GND)))*d10_sqrt0)+0.0*(Tb_Tempt_GND+(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))*d10_sqrt0)+0.5*(+Tb_Tempt_GND_Tempt_GND+(m20_sqrt(((Tb*Tb)+(4.0*XExpBVD)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))+((4.0*XExpBVD_Tempt_GND)))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))+(4.0*XExpBVD_Tempt_GND))+d10_sqrt0*(+(+Tb_Tempt_GND_Tempt_GND*Tb+Tb_Tempt_GND*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Tempt_GND)+(+0.0*XExpBVD+0.0*XExpBVD_Tempt_GND+0.0*XExpBVD_Tempt_GND+4.0*XExpBVD_Tempt_GND_Tempt_GND))))));
#endif
#endif
VjdmFwd=(Nvtmd*bsimcmg_lln((0.5*(Tb+d00_sqrt0))));
EXIT_IF_ISNAN((Nvtmd*bsimcmg_lln((0.5*(Tb+d00_sqrt0)))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=bsimcmg_d_lexp((VjdmFwd/Nvtmd),((VjdmFwd_Tempt_GND*Nvtmd-VjdmFwd*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_e=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_si=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_di=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_si=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtmd-(VjdmFwd_Tempt_GND*0.0+0.0*Nvtmd_Tempt_GND+VjdmFwd*0.0)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Tempt_GND=(VjdmFwd_Tempt_GND_Tempt_GND/Nvtmd-(VjdmFwd_Tempt_GND*Nvtmd_Tempt_GND+VjdmFwd_Tempt_GND*Nvtmd_Tempt_GND+VjdmFwd*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*VjdmFwd*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
#endif
T0=bsimcmg_lexp((VjdmFwd/Nvtmd));
EXIT_IF_ISNAN(bsimcmg_lexp((VjdmFwd/Nvtmd)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
IVjdmFwd_Tempt_GND=((Isbd_Tempt_GND*(((T0-(XExpBVD/T0))+XExpBVD)-1.0))+(Isbd*((T0_Tempt_GND-((XExpBVD_Tempt_GND*T0-XExpBVD*T0_Tempt_GND)/T0/T0))+XExpBVD_Tempt_GND)));
#endif
IVjdmFwd=(Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0));
EXIT_IF_ISNAN((Isbd*(((T0-(XExpBVD/T0))+XExpBVD)-1.0)))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
DslpFwd_Tempt_GND=((((Isbd_Tempt_GND*(T0+(XExpBVD/T0)))+(Isbd*(T0_Tempt_GND+((XExpBVD_Tempt_GND*T0-XExpBVD*T0_Tempt_GND)/T0/T0))))*Nvtmd-(Isbd*(T0+(XExpBVD/T0)))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd);
#endif
DslpFwd=((Isbd*(T0+(XExpBVD/T0)))/Nvtmd);
EXIT_IF_ISNAN(((Isbd*(T0+(XExpBVD/T0)))/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=bsimcmg_d_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3,(-pModel->IJTHDREV*Isbd_Tempt_GND/Isbd/Isbd),0.0);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+0.0);
  T2_Tempt_GND_Vsi_s=(+0.0+0.0);
  T2_Tempt_GND_Vge_di=(+0.0+0.0);
  T2_Tempt_GND_Vge_e=(+0.0+0.0);
  T2_Tempt_GND_Vge_si=(+0.0+0.0);
  T2_Tempt_GND_Ve_si=(+0.0+0.0);
  T2_Tempt_GND_Ve_di=(+0.0+0.0);
  T2_Tempt_GND_Vdi_si=(+0.0+0.0);
  T2_Tempt_GND_Tempt_GND=(+0.0+0.0);
#endif
#endif
T2=(bsimcmg_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3)+10.0);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(((pModel->IJTHDREV/Isbd)-10.0),1.0e-3)+10.0))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VjdmRev_Tempt_GND=(-((Nvtmd_Tempt_GND*bsimcmg_lln(((T2-1.0)/pModel->XJBVD)))+(Nvtmd*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVD),(T2_Tempt_GND/pModel->XJBVD)))));
#if defined(_DERIVATE2)
  VjdmRev_Tempt_GND_Tempt_GND=(+0.0-(+Nvtmd_Tempt_GND_Tempt_GND*bsimcmg_lln(((T2-1.0)/pModel->XJBVD))+Nvtmd_Tempt_GND*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVD),(T2_Tempt_GND/pModel->XJBVD))+Nvtmd_Tempt_GND*bsimcmg_d_lln(((T2-1.0)/pModel->XJBVD),(T2_Tempt_GND/pModel->XJBVD))+Nvtmd*((+T2_Tempt_GND_Tempt_GND-0.0)/pModel->XJBVD-(T2_Tempt_GND*0.0+T2_Tempt_GND*0.0+(T2-1.0)*0.0)/pModel->XJBVD/pModel->XJBVD+2*(T2-1.0)*0.0*0.0/pModel->XJBVD/pModel->XJBVD/pModel->XJBVD)));
#endif
#endif
VjdmRev=((-pModel->BVD)-(Nvtmd*bsimcmg_lln(((T2-1.0)/pModel->XJBVD))));
EXIT_IF_ISNAN(((-pModel->BVD)-(Nvtmd*bsimcmg_lln(((T2-1.0)/pModel->XJBVD)))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(pModel->XJBVD*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Vge_di=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Vge_e=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Ve_si=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Ve_di=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Vge_si=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*0.0+0.0*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*0.0)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd));
  T1_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+0.0*bsimcmg_d_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd),(((-VjdmRev_Tempt_GND)*Nvtmd-(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd))+pModel->XJBVD*(0.0/Nvtmd-((-VjdmRev_Tempt_GND)*Nvtmd_Tempt_GND+(-VjdmRev_Tempt_GND)*Nvtmd_Tempt_GND+(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*(-(pModel->BVD+VjdmRev))*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd));
#endif
#endif
T1=(pModel->XJBVD*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd)));
EXIT_IF_ISNAN((pModel->XJBVD*bsimcmg_lexp(((-(pModel->BVD+VjdmRev))/Nvtmd))))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
IVjdmRev_Tempt_GND=((Isbd_Tempt_GND*(1.0+T1))+(Isbd*T1_Tempt_GND));
#if defined(_DERIVATE2)
  IVjdmRev_Tempt_GND_Tempt_GND=(+Isbd_Tempt_GND_Tempt_GND*(1.0+T1)+Isbd_Tempt_GND*T1_Tempt_GND+Isbd_Tempt_GND*T1_Tempt_GND+Isbd*(+0.0+T1_Tempt_GND_Tempt_GND));
#endif
#endif
IVjdmRev=(Isbd*(1.0+T1));
EXIT_IF_ISNAN((Isbd*(1.0+T1)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
DslpRev_Tempt_GND=(((((-Isbd_Tempt_GND)*T1)+((-Isbd)*T1_Tempt_GND))*Nvtmd-((-Isbd)*T1)*Nvtmd_Tempt_GND)/Nvtmd/Nvtmd);
#if defined(_DERIVATE2)
  DslpRev_Tempt_GND_Tempt_GND=((+0.0*T1+(-Isbd_Tempt_GND)*T1_Tempt_GND+(-Isbd_Tempt_GND)*T1_Tempt_GND+(-Isbd)*T1_Tempt_GND_Tempt_GND)/Nvtmd-((((-Isbd_Tempt_GND)*T1)+((-Isbd)*T1_Tempt_GND))*Nvtmd_Tempt_GND+((((-Isbd_Tempt_GND)*T1)+((-Isbd)*T1_Tempt_GND)))*Nvtmd_Tempt_GND+((-Isbd)*T1)*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*((-Isbd)*T1)*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
#endif
DslpRev=(((-Isbd)*T1)/Nvtmd);
EXIT_IF_ISNAN((((-Isbd)*T1)/Nvtmd))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbs_Tempt_GND=CJS_t_Tempt_GND*pInst->ASEJ;
#if defined(_DERIVATE2)
  Czbs_Tempt_GND_Tempt_GND=(+CJS_t_Tempt_GND_Tempt_GND*pInst->ASEJ+CJS_t_Tempt_GND*0.0+CJS_t_Tempt_GND*0.0+CJS_t*0.0);
#endif
#endif
Czbs=(CJS_t*pInst->ASEJ);
EXIT_IF_ISNAN((CJS_t*pInst->ASEJ))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbssw_Tempt_GND=CJSWS_t_Tempt_GND*pInst->PSEJ;
#if defined(_DERIVATE2)
  Czbssw_Tempt_GND_Tempt_GND=(+CJSWS_t_Tempt_GND_Tempt_GND*pInst->PSEJ+CJSWS_t_Tempt_GND*0.0+CJSWS_t_Tempt_GND*0.0+CJSWS_t*0.0);
#endif
#endif
Czbssw=(CJSWS_t*pInst->PSEJ);
EXIT_IF_ISNAN((CJSWS_t*pInst->PSEJ))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Czbsswg_Tempt_GND=CJSWGS_t_Tempt_GND*Weff0*NFINtotal;
#if defined(_DERIVATE2)
  Czbsswg_Tempt_GND_Tempt_GND=(+(+CJSWGS_t_Tempt_GND_Tempt_GND*Weff0+CJSWGS_t_Tempt_GND*0.0+CJSWGS_t_Tempt_GND*0.0+CJSWGS_t*0.0)*NFINtotal+CJSWGS_t_Tempt_GND*Weff0*0.0+(CJSWGS_t_Tempt_GND*Weff0)*0.0+(CJSWGS_t*Weff0)*0.0);
#endif
#endif
Czbsswg=((CJSWGS_t*Weff0)*NFINtotal);
EXIT_IF_ISNAN(((CJSWGS_t*Weff0)*NFINtotal))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbd_Tempt_GND=CJD_t_Tempt_GND*pInst->ADEJ;
#if defined(_DERIVATE2)
  Czbd_Tempt_GND_Tempt_GND=(+CJD_t_Tempt_GND_Tempt_GND*pInst->ADEJ+CJD_t_Tempt_GND*0.0+CJD_t_Tempt_GND*0.0+CJD_t*0.0);
#endif
#endif
Czbd=(CJD_t*pInst->ADEJ);
EXIT_IF_ISNAN((CJD_t*pInst->ADEJ))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbdsw_Tempt_GND=CJSWD_t_Tempt_GND*pInst->PDEJ;
#if defined(_DERIVATE2)
  Czbdsw_Tempt_GND_Tempt_GND=(+CJSWD_t_Tempt_GND_Tempt_GND*pInst->PDEJ+CJSWD_t_Tempt_GND*0.0+CJSWD_t_Tempt_GND*0.0+CJSWD_t*0.0);
#endif
#endif
Czbdsw=(CJSWD_t*pInst->PDEJ);
EXIT_IF_ISNAN((CJSWD_t*pInst->PDEJ))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Czbdswg_Tempt_GND=CJSWGD_t_Tempt_GND*Weff0*NFINtotal;
#if defined(_DERIVATE2)
  Czbdswg_Tempt_GND_Tempt_GND=(+(+CJSWGD_t_Tempt_GND_Tempt_GND*Weff0+CJSWGD_t_Tempt_GND*0.0+CJSWGD_t_Tempt_GND*0.0+CJSWGD_t*0.0)*NFINtotal+CJSWGD_t_Tempt_GND*Weff0*0.0+(CJSWGD_t_Tempt_GND*Weff0)*0.0+(CJSWGD_t*Weff0)*0.0);
#endif
#endif
Czbdswg=((CJSWGD_t*Weff0)*NFINtotal);
EXIT_IF_ISNAN(((CJSWGD_t*Weff0)*NFINtotal))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=((((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*(TRatio-1.0))+((Eg/Vtm)*TRatio_Tempt_GND));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Vge_e=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Ve_si=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Ve_di=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Vge_si=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Vdi_si=(+(0.0/Vtm-(Eg_Tempt_GND*0.0+0.0*Vtm_Tempt_GND+Eg*0.0)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*0.0+0.0*TRatio_Tempt_GND+(Eg/Vtm)*(+0.0-0.0));
  T0_Tempt_GND_Tempt_GND=(+(Eg_Tempt_GND_Tempt_GND/Vtm-(Eg_Tempt_GND*Vtm_Tempt_GND+Eg_Tempt_GND*Vtm_Tempt_GND+Eg*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*Eg*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm)*(TRatio-1.0)+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*TRatio_Tempt_GND+((Eg_Tempt_GND*Vtm-Eg*Vtm_Tempt_GND)/Vtm/Vtm)*TRatio_Tempt_GND+(Eg/Vtm)*(+TRatio_Tempt_GND_Tempt_GND-0.0));
#endif
#endif
T0=((Eg/Vtm)*(TRatio-1.0));
EXIT_IF_ISNAN(((Eg/Vtm)*(TRatio-1.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(T0_Tempt_GND/NTGEN_i);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/NTGEN_i-(T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Vsi_s=(0.0/NTGEN_i-(T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Vge_di=(T0_Tempt_GND_Vge_di/NTGEN_i-(T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Vge_e=(T0_Tempt_GND_Vge_e/NTGEN_i-(T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Ve_si=(T0_Tempt_GND_Ve_si/NTGEN_i-(T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Ve_di=(T0_Tempt_GND_Ve_di/NTGEN_i-(T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Vge_si=(T0_Tempt_GND_Vge_si/NTGEN_i-(T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Vdi_si=(T0_Tempt_GND_Vdi_si/NTGEN_i-(T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
  T1_Tempt_GND_Tempt_GND=(T0_Tempt_GND_Tempt_GND/NTGEN_i-(T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/NTGEN_i/NTGEN_i+2*T0*0.0*0.0/NTGEN_i/NTGEN_i/NTGEN_i);
#endif
#endif
T1=(T0/NTGEN_i);
EXIT_IF_ISNAN((T0/NTGEN_i))
#if defined(_DERIVATE) /* probe=Temp(t,GND) ddxprobe= */
igentemp_Tempt_GND=bsimcmg_d_lexp(T1,T1_Tempt_GND);
#endif
igentemp=bsimcmg_lexp(T1);
EXIT_IF_ISNAN(bsimcmg_lexp(T1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vgs_noswap_Vge_si=(devsign);
#if defined(_DERIVATE2)
  vgs_noswap_Vge_si_Vge_si=(+0.0*(NP(ge)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
vgs_noswap=(devsign*(NP(ge)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(si))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si) ddxprobe=V(e,GND)Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
vds_noswap_Vdi_si=(devsign);
#if defined(_DERIVATE2)
  vds_noswap_Vdi_si_Vdi_si=(+0.0*(NP(di)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
vds_noswap=(devsign*(NP(di)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(di)-NP(si))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vgd_noswap_Vge_di=(devsign);
#if defined(_DERIVATE2)
  vgd_noswap_Vge_di_Vge_di=(+0.0*(NP(ge)-NP(di))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
vgd_noswap=(devsign*(NP(ge)-NP(di)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(di))))
#if defined(_DERIVATEFORDDX) /* probe=V(e,si) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
ves_jct_Ve_si=(devsign);
#if defined(_DERIVATE2)
  ves_jct_Ve_si_Ve_si=(+0.0*(NP(e)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
ves_jct=(devsign*(NP(e)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(e)-NP(si))))
#if defined(_DERIVATEFORDDX) /* probe=V(e,di) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ved_jct_Ve_di=(devsign);
#if defined(_DERIVATE2)
  ved_jct_Ve_di_Ve_di=(+0.0*(NP(e)-NP(di))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
ved_jct=(devsign*(NP(e)-NP(di)));
EXIT_IF_ISNAN((devsign*(NP(e)-NP(di))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vge_Vge_e=(devsign);
#if defined(_DERIVATE2)
  vge_Vge_e_Vge_e=(+0.0*(NP(ge)-NP(e))+0.0*1.0+0.0*1.0+devsign*0.0);
#endif
#endif
vge=(devsign*(NP(ge)-NP(e)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(e))))
sigvds=1.0;
EXIT_IF_ISNAN(1.0)
if
((vds_noswap<0.0))
{
sigvds=(-1.0);
EXIT_IF_ISNAN((-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vgs_Vge_si=vgs_noswap_Vge_si;
#if defined(_DERIVATE2)
  vgs_Vge_si_Vge_si=(+vgs_noswap_Vge_si_Vge_si-0.0);
  vgs_Vge_si_Vdi_si=(+0.0-0.0);
#endif
vgs_Vdi_si=(-vds_noswap_Vdi_si);
#if defined(_DERIVATE2)
  vgs_Vdi_si_Vge_si=(+0.0-0.0);
  vgs_Vdi_si_Vdi_si=(+0.0-vds_noswap_Vdi_si_Vdi_si);
#endif
#endif
vgs=(vgs_noswap-vds_noswap);
EXIT_IF_ISNAN((vgs_noswap-vds_noswap))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si) ddxprobe=V(e,GND)Temp(t,GND)V(ge,GND)V(si,GND)V(di,GND) */
vds_Vdi_si=((-1.0)*vds_noswap_Vdi_si);
#if defined(_DERIVATE2)
  vds_Vdi_si_Vdi_si=(+0.0*vds_noswap+0.0*vds_noswap_Vdi_si+0.0*vds_noswap_Vdi_si+(-1.0)*vds_noswap_Vdi_si_Vdi_si);
#endif
#endif
vds=((-1.0)*vds_noswap);
EXIT_IF_ISNAN(((-1.0)*vds_noswap))
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ves_Ve_si=0.0;
#if defined(_DERIVATE2)
  ves_Ve_si_Ve_si=0.0;
  ves_Ve_si_Ve_di=0.0;
#endif
ves_Ve_di=ved_jct_Ve_di;
#if defined(_DERIVATE2)
  ves_Ve_di_Ve_si=0.0;
  ves_Ve_di_Ve_di=ved_jct_Ve_di_Ve_di;
#endif
#endif
ves=ved_jct;
EXIT_IF_ISNAN(ved_jct)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vgs_Vge_si=vgs_noswap_Vge_si;
#if defined(_DERIVATE2)
  vgs_Vge_si_Vge_si=vgs_noswap_Vge_si_Vge_si;
  vgs_Vge_si_Vdi_si=0.0;
#endif
vgs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  vgs_Vdi_si_Vge_si=0.0;
  vgs_Vdi_si_Vdi_si=0.0;
#endif
#endif
vgs=vgs_noswap;
EXIT_IF_ISNAN(vgs_noswap)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si) ddxprobe=V(e,GND)Temp(t,GND)V(ge,GND)V(si,GND)V(di,GND) */
vds_Vdi_si=vds_noswap_Vdi_si;
#if defined(_DERIVATE2)
  vds_Vdi_si_Vdi_si=vds_noswap_Vdi_si_Vdi_si;
#endif
#endif
vds=vds_noswap;
EXIT_IF_ISNAN(vds_noswap)
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
ves_Ve_si=ves_jct_Ve_si;
#if defined(_DERIVATE2)
  ves_Ve_si_Ve_si=ves_jct_Ve_si_Ve_si;
  ves_Ve_si_Ve_di=0.0;
#endif
ves_Ve_di=0.0;
#if defined(_DERIVATE2)
  ves_Ve_di_Ve_si=0.0;
  ves_Ve_di_Ve_di=0.0;
#endif
#endif
ves=ves_jct;
EXIT_IF_ISNAN(ves_jct)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vgsfb_Vge_si=vgs_Vge_si;
#if defined(_DERIVATE2)
  vgsfb_Vge_si_Vge_si=(+vgs_Vge_si_Vge_si-0.0);
  vgsfb_Vge_si_Vdi_si=(+vgs_Vge_si_Vdi_si-0.0);
  vgsfb_Vge_si_Tempt_GND=(+0.0-0.0);
#endif
vgsfb_Vdi_si=vgs_Vdi_si;
#if defined(_DERIVATE2)
  vgsfb_Vdi_si_Vge_si=(+vgs_Vdi_si_Vge_si-0.0);
  vgsfb_Vdi_si_Vdi_si=(+vgs_Vdi_si_Vdi_si-0.0);
  vgsfb_Vdi_si_Tempt_GND=(+0.0-0.0);
#endif
vgsfb_Tempt_GND=(-deltaPhi_Tempt_GND);
#if defined(_DERIVATE2)
  vgsfb_Tempt_GND_Vge_si=(+0.0-0.0);
  vgsfb_Tempt_GND_Vdi_si=(+0.0-0.0);
  vgsfb_Tempt_GND_Tempt_GND=(+0.0-deltaPhi_Tempt_GND_Tempt_GND);
#endif
#endif
vgsfb=(vgs-deltaPhi);
EXIT_IF_ISNAN((vgs-deltaPhi))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
etaiv_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  etaiv_Tempt_GND_Tempt_GND=0.0;
  etaiv_Tempt_GND_Vdi_si=0.0;
  etaiv_Tempt_GND_Ve_si=0.0;
  etaiv_Tempt_GND_Ve_di=0.0;
  etaiv_Tempt_GND_Vge_si=0.0;
#endif
etaiv_Vdi_si=0.0;
#if defined(_DERIVATE2)
  etaiv_Vdi_si_Tempt_GND=0.0;
  etaiv_Vdi_si_Vdi_si=0.0;
  etaiv_Vdi_si_Ve_si=0.0;
  etaiv_Vdi_si_Ve_di=0.0;
  etaiv_Vdi_si_Vge_si=0.0;
#endif
etaiv_Ve_si=0.0;
#if defined(_DERIVATE2)
  etaiv_Ve_si_Tempt_GND=0.0;
  etaiv_Ve_si_Vdi_si=0.0;
  etaiv_Ve_si_Ve_si=0.0;
  etaiv_Ve_si_Ve_di=0.0;
  etaiv_Ve_si_Vge_si=0.0;
#endif
etaiv_Ve_di=0.0;
#if defined(_DERIVATE2)
  etaiv_Ve_di_Tempt_GND=0.0;
  etaiv_Ve_di_Vdi_si=0.0;
  etaiv_Ve_di_Ve_si=0.0;
  etaiv_Ve_di_Ve_di=0.0;
  etaiv_Ve_di_Vge_si=0.0;
#endif
etaiv_Vge_si=0.0;
#if defined(_DERIVATE2)
  etaiv_Vge_si_Tempt_GND=0.0;
  etaiv_Vge_si_Vdi_si=0.0;
  etaiv_Vge_si_Ve_si=0.0;
  etaiv_Vge_si_Ve_di=0.0;
  etaiv_Vge_si_Vge_si=0.0;
#endif
#endif
etaiv=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qes_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qes_Vdi_d_Vdi_d=0.0;
  Qes_Vdi_d_Vsi_s=0.0;
  Qes_Vdi_d_Tempt_GND=0.0;
  Qes_Vdi_d_Vge_di=0.0;
  Qes_Vdi_d_Vge_e=0.0;
  Qes_Vdi_d_Ve_si=0.0;
  Qes_Vdi_d_Ve_di=0.0;
  Qes_Vdi_d_Vge_si=0.0;
  Qes_Vdi_d_Vdi_si=0.0;
#endif
Qes_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qes_Vsi_s_Vdi_d=0.0;
  Qes_Vsi_s_Vsi_s=0.0;
  Qes_Vsi_s_Tempt_GND=0.0;
  Qes_Vsi_s_Vge_di=0.0;
  Qes_Vsi_s_Vge_e=0.0;
  Qes_Vsi_s_Ve_si=0.0;
  Qes_Vsi_s_Ve_di=0.0;
  Qes_Vsi_s_Vge_si=0.0;
  Qes_Vsi_s_Vdi_si=0.0;
#endif
Qes_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qes_Tempt_GND_Vdi_d=0.0;
  Qes_Tempt_GND_Vsi_s=0.0;
  Qes_Tempt_GND_Tempt_GND=0.0;
  Qes_Tempt_GND_Vge_di=0.0;
  Qes_Tempt_GND_Vge_e=0.0;
  Qes_Tempt_GND_Ve_si=0.0;
  Qes_Tempt_GND_Ve_di=0.0;
  Qes_Tempt_GND_Vge_si=0.0;
  Qes_Tempt_GND_Vdi_si=0.0;
#endif
Qes_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_di_Vdi_d=0.0;
  Qes_Vge_di_Vsi_s=0.0;
  Qes_Vge_di_Tempt_GND=0.0;
  Qes_Vge_di_Vge_di=0.0;
  Qes_Vge_di_Vge_e=0.0;
  Qes_Vge_di_Ve_si=0.0;
  Qes_Vge_di_Ve_di=0.0;
  Qes_Vge_di_Vge_si=0.0;
  Qes_Vge_di_Vdi_si=0.0;
#endif
Qes_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_e_Vdi_d=0.0;
  Qes_Vge_e_Vsi_s=0.0;
  Qes_Vge_e_Tempt_GND=0.0;
  Qes_Vge_e_Vge_di=0.0;
  Qes_Vge_e_Vge_e=0.0;
  Qes_Vge_e_Ve_si=0.0;
  Qes_Vge_e_Ve_di=0.0;
  Qes_Vge_e_Vge_si=0.0;
  Qes_Vge_e_Vdi_si=0.0;
#endif
Qes_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qes_Ve_si_Vdi_d=0.0;
  Qes_Ve_si_Vsi_s=0.0;
  Qes_Ve_si_Tempt_GND=0.0;
  Qes_Ve_si_Vge_di=0.0;
  Qes_Ve_si_Vge_e=0.0;
  Qes_Ve_si_Ve_si=0.0;
  Qes_Ve_si_Ve_di=0.0;
  Qes_Ve_si_Vge_si=0.0;
  Qes_Ve_si_Vdi_si=0.0;
#endif
Qes_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qes_Ve_di_Vdi_d=0.0;
  Qes_Ve_di_Vsi_s=0.0;
  Qes_Ve_di_Tempt_GND=0.0;
  Qes_Ve_di_Vge_di=0.0;
  Qes_Ve_di_Vge_e=0.0;
  Qes_Ve_di_Ve_si=0.0;
  Qes_Ve_di_Ve_di=0.0;
  Qes_Ve_di_Vge_si=0.0;
  Qes_Ve_di_Vdi_si=0.0;
#endif
Qes_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qes_Vge_si_Vdi_d=0.0;
  Qes_Vge_si_Vsi_s=0.0;
  Qes_Vge_si_Tempt_GND=0.0;
  Qes_Vge_si_Vge_di=0.0;
  Qes_Vge_si_Vge_e=0.0;
  Qes_Vge_si_Ve_si=0.0;
  Qes_Vge_si_Ve_di=0.0;
  Qes_Vge_si_Vge_si=0.0;
  Qes_Vge_si_Vdi_si=0.0;
#endif
Qes_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qes_Vdi_si_Vdi_d=0.0;
  Qes_Vdi_si_Vsi_s=0.0;
  Qes_Vdi_si_Tempt_GND=0.0;
  Qes_Vdi_si_Vge_di=0.0;
  Qes_Vdi_si_Vge_e=0.0;
  Qes_Vdi_si_Ve_si=0.0;
  Qes_Vdi_si_Ve_di=0.0;
  Qes_Vdi_si_Vge_si=0.0;
  Qes_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qes=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Qesj_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj_Vdi_d_Vdi_d=0.0;
  Qesj_Vdi_d_Vsi_s=0.0;
  Qesj_Vdi_d_Tempt_GND=0.0;
  Qesj_Vdi_d_Vge_di=0.0;
  Qesj_Vdi_d_Vge_e=0.0;
  Qesj_Vdi_d_Ve_si=0.0;
  Qesj_Vdi_d_Ve_di=0.0;
  Qesj_Vdi_d_Vge_si=0.0;
  Qesj_Vdi_d_Vdi_si=0.0;
#endif
Qesj_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj_Vsi_s_Vdi_d=0.0;
  Qesj_Vsi_s_Vsi_s=0.0;
  Qesj_Vsi_s_Tempt_GND=0.0;
  Qesj_Vsi_s_Vge_di=0.0;
  Qesj_Vsi_s_Vge_e=0.0;
  Qesj_Vsi_s_Ve_si=0.0;
  Qesj_Vsi_s_Ve_di=0.0;
  Qesj_Vsi_s_Vge_si=0.0;
  Qesj_Vsi_s_Vdi_si=0.0;
#endif
Qesj_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qesj_Tempt_GND_Vdi_d=0.0;
  Qesj_Tempt_GND_Vsi_s=0.0;
  Qesj_Tempt_GND_Tempt_GND=0.0;
  Qesj_Tempt_GND_Vge_di=0.0;
  Qesj_Tempt_GND_Vge_e=0.0;
  Qesj_Tempt_GND_Ve_si=0.0;
  Qesj_Tempt_GND_Ve_di=0.0;
  Qesj_Tempt_GND_Vge_si=0.0;
  Qesj_Tempt_GND_Vdi_si=0.0;
#endif
Qesj_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qesj_Vge_di_Vdi_d=0.0;
  Qesj_Vge_di_Vsi_s=0.0;
  Qesj_Vge_di_Tempt_GND=0.0;
  Qesj_Vge_di_Vge_di=0.0;
  Qesj_Vge_di_Vge_e=0.0;
  Qesj_Vge_di_Ve_si=0.0;
  Qesj_Vge_di_Ve_di=0.0;
  Qesj_Vge_di_Vge_si=0.0;
  Qesj_Vge_di_Vdi_si=0.0;
#endif
Qesj_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qesj_Vge_e_Vdi_d=0.0;
  Qesj_Vge_e_Vsi_s=0.0;
  Qesj_Vge_e_Tempt_GND=0.0;
  Qesj_Vge_e_Vge_di=0.0;
  Qesj_Vge_e_Vge_e=0.0;
  Qesj_Vge_e_Ve_si=0.0;
  Qesj_Vge_e_Ve_di=0.0;
  Qesj_Vge_e_Vge_si=0.0;
  Qesj_Vge_e_Vdi_si=0.0;
#endif
Qesj_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qesj_Ve_si_Vdi_d=0.0;
  Qesj_Ve_si_Vsi_s=0.0;
  Qesj_Ve_si_Tempt_GND=0.0;
  Qesj_Ve_si_Vge_di=0.0;
  Qesj_Ve_si_Vge_e=0.0;
  Qesj_Ve_si_Ve_si=0.0;
  Qesj_Ve_si_Ve_di=0.0;
  Qesj_Ve_si_Vge_si=0.0;
  Qesj_Ve_si_Vdi_si=0.0;
#endif
Qesj_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qesj_Ve_di_Vdi_d=0.0;
  Qesj_Ve_di_Vsi_s=0.0;
  Qesj_Ve_di_Tempt_GND=0.0;
  Qesj_Ve_di_Vge_di=0.0;
  Qesj_Ve_di_Vge_e=0.0;
  Qesj_Ve_di_Ve_si=0.0;
  Qesj_Ve_di_Ve_di=0.0;
  Qesj_Ve_di_Vge_si=0.0;
  Qesj_Ve_di_Vdi_si=0.0;
#endif
Qesj_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qesj_Vge_si_Vdi_d=0.0;
  Qesj_Vge_si_Vsi_s=0.0;
  Qesj_Vge_si_Tempt_GND=0.0;
  Qesj_Vge_si_Vge_di=0.0;
  Qesj_Vge_si_Vge_e=0.0;
  Qesj_Vge_si_Ve_si=0.0;
  Qesj_Vge_si_Ve_di=0.0;
  Qesj_Vge_si_Vge_si=0.0;
  Qesj_Vge_si_Vdi_si=0.0;
#endif
Qesj_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qesj_Vdi_si_Vdi_d=0.0;
  Qesj_Vdi_si_Vsi_s=0.0;
  Qesj_Vdi_si_Tempt_GND=0.0;
  Qesj_Vdi_si_Vge_di=0.0;
  Qesj_Vdi_si_Vge_e=0.0;
  Qesj_Vdi_si_Ve_si=0.0;
  Qesj_Vdi_si_Ve_di=0.0;
  Qesj_Vdi_si_Vge_si=0.0;
  Qesj_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qesj=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(e,ge) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Qeg_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_di_Vge_di=0.0;
  Qeg_Vge_di_Vge_e=0.0;
  Qeg_Vge_di_Vdi_si=0.0;
  Qeg_Vge_di_Ve_si=0.0;
  Qeg_Vge_di_Ve_di=0.0;
  Qeg_Vge_di_Vge_si=0.0;
  Qeg_Vge_di_Tempt_GND=0.0;
  Qeg_Vge_di_Ve_ge=0.0;
#endif
Qeg_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_e_Vge_di=0.0;
  Qeg_Vge_e_Vge_e=0.0;
  Qeg_Vge_e_Vdi_si=0.0;
  Qeg_Vge_e_Ve_si=0.0;
  Qeg_Vge_e_Ve_di=0.0;
  Qeg_Vge_e_Vge_si=0.0;
  Qeg_Vge_e_Tempt_GND=0.0;
  Qeg_Vge_e_Ve_ge=0.0;
#endif
Qeg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vdi_si_Vge_di=0.0;
  Qeg_Vdi_si_Vge_e=0.0;
  Qeg_Vdi_si_Vdi_si=0.0;
  Qeg_Vdi_si_Ve_si=0.0;
  Qeg_Vdi_si_Ve_di=0.0;
  Qeg_Vdi_si_Vge_si=0.0;
  Qeg_Vdi_si_Tempt_GND=0.0;
  Qeg_Vdi_si_Ve_ge=0.0;
#endif
Qeg_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_si_Vge_di=0.0;
  Qeg_Ve_si_Vge_e=0.0;
  Qeg_Ve_si_Vdi_si=0.0;
  Qeg_Ve_si_Ve_si=0.0;
  Qeg_Ve_si_Ve_di=0.0;
  Qeg_Ve_si_Vge_si=0.0;
  Qeg_Ve_si_Tempt_GND=0.0;
  Qeg_Ve_si_Ve_ge=0.0;
#endif
Qeg_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_di_Vge_di=0.0;
  Qeg_Ve_di_Vge_e=0.0;
  Qeg_Ve_di_Vdi_si=0.0;
  Qeg_Ve_di_Ve_si=0.0;
  Qeg_Ve_di_Ve_di=0.0;
  Qeg_Ve_di_Vge_si=0.0;
  Qeg_Ve_di_Tempt_GND=0.0;
  Qeg_Ve_di_Ve_ge=0.0;
#endif
Qeg_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_si_Vge_di=0.0;
  Qeg_Vge_si_Vge_e=0.0;
  Qeg_Vge_si_Vdi_si=0.0;
  Qeg_Vge_si_Ve_si=0.0;
  Qeg_Vge_si_Ve_di=0.0;
  Qeg_Vge_si_Vge_si=0.0;
  Qeg_Vge_si_Tempt_GND=0.0;
  Qeg_Vge_si_Ve_ge=0.0;
#endif
Qeg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qeg_Tempt_GND_Vge_di=0.0;
  Qeg_Tempt_GND_Vge_e=0.0;
  Qeg_Tempt_GND_Vdi_si=0.0;
  Qeg_Tempt_GND_Ve_si=0.0;
  Qeg_Tempt_GND_Ve_di=0.0;
  Qeg_Tempt_GND_Vge_si=0.0;
  Qeg_Tempt_GND_Tempt_GND=0.0;
  Qeg_Tempt_GND_Ve_ge=0.0;
#endif
Qeg_Ve_ge=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_ge_Vge_di=0.0;
  Qeg_Ve_ge_Vge_e=0.0;
  Qeg_Ve_ge_Vdi_si=0.0;
  Qeg_Ve_ge_Ve_si=0.0;
  Qeg_Ve_ge_Ve_di=0.0;
  Qeg_Ve_ge_Vge_si=0.0;
  Qeg_Ve_ge_Tempt_GND=0.0;
  Qeg_Ve_ge_Ve_ge=0.0;
#endif
#endif
Qeg=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qed_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qed_Vdi_d_Vdi_d=0.0;
  Qed_Vdi_d_Vsi_s=0.0;
  Qed_Vdi_d_Tempt_GND=0.0;
  Qed_Vdi_d_Vge_di=0.0;
  Qed_Vdi_d_Vge_e=0.0;
  Qed_Vdi_d_Ve_si=0.0;
  Qed_Vdi_d_Ve_di=0.0;
  Qed_Vdi_d_Vge_si=0.0;
  Qed_Vdi_d_Vdi_si=0.0;
#endif
Qed_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qed_Vsi_s_Vdi_d=0.0;
  Qed_Vsi_s_Vsi_s=0.0;
  Qed_Vsi_s_Tempt_GND=0.0;
  Qed_Vsi_s_Vge_di=0.0;
  Qed_Vsi_s_Vge_e=0.0;
  Qed_Vsi_s_Ve_si=0.0;
  Qed_Vsi_s_Ve_di=0.0;
  Qed_Vsi_s_Vge_si=0.0;
  Qed_Vsi_s_Vdi_si=0.0;
#endif
Qed_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qed_Tempt_GND_Vdi_d=0.0;
  Qed_Tempt_GND_Vsi_s=0.0;
  Qed_Tempt_GND_Tempt_GND=0.0;
  Qed_Tempt_GND_Vge_di=0.0;
  Qed_Tempt_GND_Vge_e=0.0;
  Qed_Tempt_GND_Ve_si=0.0;
  Qed_Tempt_GND_Ve_di=0.0;
  Qed_Tempt_GND_Vge_si=0.0;
  Qed_Tempt_GND_Vdi_si=0.0;
#endif
Qed_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_di_Vdi_d=0.0;
  Qed_Vge_di_Vsi_s=0.0;
  Qed_Vge_di_Tempt_GND=0.0;
  Qed_Vge_di_Vge_di=0.0;
  Qed_Vge_di_Vge_e=0.0;
  Qed_Vge_di_Ve_si=0.0;
  Qed_Vge_di_Ve_di=0.0;
  Qed_Vge_di_Vge_si=0.0;
  Qed_Vge_di_Vdi_si=0.0;
#endif
Qed_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_e_Vdi_d=0.0;
  Qed_Vge_e_Vsi_s=0.0;
  Qed_Vge_e_Tempt_GND=0.0;
  Qed_Vge_e_Vge_di=0.0;
  Qed_Vge_e_Vge_e=0.0;
  Qed_Vge_e_Ve_si=0.0;
  Qed_Vge_e_Ve_di=0.0;
  Qed_Vge_e_Vge_si=0.0;
  Qed_Vge_e_Vdi_si=0.0;
#endif
Qed_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qed_Ve_si_Vdi_d=0.0;
  Qed_Ve_si_Vsi_s=0.0;
  Qed_Ve_si_Tempt_GND=0.0;
  Qed_Ve_si_Vge_di=0.0;
  Qed_Ve_si_Vge_e=0.0;
  Qed_Ve_si_Ve_si=0.0;
  Qed_Ve_si_Ve_di=0.0;
  Qed_Ve_si_Vge_si=0.0;
  Qed_Ve_si_Vdi_si=0.0;
#endif
Qed_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qed_Ve_di_Vdi_d=0.0;
  Qed_Ve_di_Vsi_s=0.0;
  Qed_Ve_di_Tempt_GND=0.0;
  Qed_Ve_di_Vge_di=0.0;
  Qed_Ve_di_Vge_e=0.0;
  Qed_Ve_di_Ve_si=0.0;
  Qed_Ve_di_Ve_di=0.0;
  Qed_Ve_di_Vge_si=0.0;
  Qed_Ve_di_Vdi_si=0.0;
#endif
Qed_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qed_Vge_si_Vdi_d=0.0;
  Qed_Vge_si_Vsi_s=0.0;
  Qed_Vge_si_Tempt_GND=0.0;
  Qed_Vge_si_Vge_di=0.0;
  Qed_Vge_si_Vge_e=0.0;
  Qed_Vge_si_Ve_si=0.0;
  Qed_Vge_si_Ve_di=0.0;
  Qed_Vge_si_Vge_si=0.0;
  Qed_Vge_si_Vdi_si=0.0;
#endif
Qed_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qed_Vdi_si_Vdi_d=0.0;
  Qed_Vdi_si_Vsi_s=0.0;
  Qed_Vdi_si_Tempt_GND=0.0;
  Qed_Vdi_si_Vge_di=0.0;
  Qed_Vdi_si_Vge_e=0.0;
  Qed_Vdi_si_Ve_si=0.0;
  Qed_Vdi_si_Ve_di=0.0;
  Qed_Vdi_si_Vge_si=0.0;
  Qed_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qed=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qedj_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj_Vdi_d_Vdi_d=0.0;
  Qedj_Vdi_d_Vsi_s=0.0;
  Qedj_Vdi_d_Tempt_GND=0.0;
  Qedj_Vdi_d_Vge_di=0.0;
  Qedj_Vdi_d_Vge_e=0.0;
  Qedj_Vdi_d_Ve_si=0.0;
  Qedj_Vdi_d_Ve_di=0.0;
  Qedj_Vdi_d_Vge_si=0.0;
  Qedj_Vdi_d_Vdi_si=0.0;
#endif
Qedj_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj_Vsi_s_Vdi_d=0.0;
  Qedj_Vsi_s_Vsi_s=0.0;
  Qedj_Vsi_s_Tempt_GND=0.0;
  Qedj_Vsi_s_Vge_di=0.0;
  Qedj_Vsi_s_Vge_e=0.0;
  Qedj_Vsi_s_Ve_si=0.0;
  Qedj_Vsi_s_Ve_di=0.0;
  Qedj_Vsi_s_Vge_si=0.0;
  Qedj_Vsi_s_Vdi_si=0.0;
#endif
Qedj_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qedj_Tempt_GND_Vdi_d=0.0;
  Qedj_Tempt_GND_Vsi_s=0.0;
  Qedj_Tempt_GND_Tempt_GND=0.0;
  Qedj_Tempt_GND_Vge_di=0.0;
  Qedj_Tempt_GND_Vge_e=0.0;
  Qedj_Tempt_GND_Ve_si=0.0;
  Qedj_Tempt_GND_Ve_di=0.0;
  Qedj_Tempt_GND_Vge_si=0.0;
  Qedj_Tempt_GND_Vdi_si=0.0;
#endif
Qedj_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qedj_Vge_di_Vdi_d=0.0;
  Qedj_Vge_di_Vsi_s=0.0;
  Qedj_Vge_di_Tempt_GND=0.0;
  Qedj_Vge_di_Vge_di=0.0;
  Qedj_Vge_di_Vge_e=0.0;
  Qedj_Vge_di_Ve_si=0.0;
  Qedj_Vge_di_Ve_di=0.0;
  Qedj_Vge_di_Vge_si=0.0;
  Qedj_Vge_di_Vdi_si=0.0;
#endif
Qedj_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qedj_Vge_e_Vdi_d=0.0;
  Qedj_Vge_e_Vsi_s=0.0;
  Qedj_Vge_e_Tempt_GND=0.0;
  Qedj_Vge_e_Vge_di=0.0;
  Qedj_Vge_e_Vge_e=0.0;
  Qedj_Vge_e_Ve_si=0.0;
  Qedj_Vge_e_Ve_di=0.0;
  Qedj_Vge_e_Vge_si=0.0;
  Qedj_Vge_e_Vdi_si=0.0;
#endif
Qedj_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qedj_Ve_si_Vdi_d=0.0;
  Qedj_Ve_si_Vsi_s=0.0;
  Qedj_Ve_si_Tempt_GND=0.0;
  Qedj_Ve_si_Vge_di=0.0;
  Qedj_Ve_si_Vge_e=0.0;
  Qedj_Ve_si_Ve_si=0.0;
  Qedj_Ve_si_Ve_di=0.0;
  Qedj_Ve_si_Vge_si=0.0;
  Qedj_Ve_si_Vdi_si=0.0;
#endif
Qedj_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qedj_Ve_di_Vdi_d=0.0;
  Qedj_Ve_di_Vsi_s=0.0;
  Qedj_Ve_di_Tempt_GND=0.0;
  Qedj_Ve_di_Vge_di=0.0;
  Qedj_Ve_di_Vge_e=0.0;
  Qedj_Ve_di_Ve_si=0.0;
  Qedj_Ve_di_Ve_di=0.0;
  Qedj_Ve_di_Vge_si=0.0;
  Qedj_Ve_di_Vdi_si=0.0;
#endif
Qedj_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qedj_Vge_si_Vdi_d=0.0;
  Qedj_Vge_si_Vsi_s=0.0;
  Qedj_Vge_si_Tempt_GND=0.0;
  Qedj_Vge_si_Vge_di=0.0;
  Qedj_Vge_si_Vge_e=0.0;
  Qedj_Vge_si_Ve_si=0.0;
  Qedj_Vge_si_Ve_di=0.0;
  Qedj_Vge_si_Vge_si=0.0;
  Qedj_Vge_si_Vdi_si=0.0;
#endif
Qedj_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qedj_Vdi_si_Vdi_d=0.0;
  Qedj_Vdi_si_Vsi_s=0.0;
  Qedj_Vdi_si_Tempt_GND=0.0;
  Qedj_Vdi_si_Vge_di=0.0;
  Qedj_Vdi_si_Vge_e=0.0;
  Qedj_Vdi_si_Ve_si=0.0;
  Qedj_Vdi_si_Ve_di=0.0;
  Qedj_Vdi_si_Vge_si=0.0;
  Qedj_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qedj=0.0;
EXIT_IF_ISNAN(0.0)
#endif
{
double m00_sqrt(d00_sqrt0,((vds*vds)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((vds*vds)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vdsx_Vdi_si=((vds_Vdi_si*vds)+(vds*vds_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vdsx_Vdi_si_Vdi_si=(+(m20_sqrt(((vds*vds)+0.01))*(((vds_Vdi_si*vds)+(vds*vds_Vdi_si)))*((vds_Vdi_si*vds)+(vds*vds_Vdi_si))+d10_sqrt0*(+(+vds_Vdi_si_Vdi_si*vds+vds_Vdi_si*vds_Vdi_si+vds_Vdi_si*vds_Vdi_si+vds*vds_Vdi_si_Vdi_si)+0.0))-0.0);
#endif
#endif
vdsx=(d00_sqrt0-0.1);
EXIT_IF_ISNAN((d00_sqrt0-0.1))
}
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vesx_Ve_si=ves_Ve_si;
#if defined(_DERIVATE2)
  vesx_Ve_si_Ve_si=(+ves_Ve_si_Ve_si-(+0.0*(vds-vdsx)+0.0*0.0+0.0*0.0+0.5*(+0.0-0.0)));
  vesx_Ve_si_Ve_di=(+ves_Ve_si_Ve_di-(+0.0*(vds-vdsx)+0.0*0.0+0.0*0.0+0.5*(+0.0-0.0)));
  vesx_Ve_si_Vdi_si=(+0.0-(+0.0*(vds-vdsx)+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.0*0.0+0.5*(+0.0-0.0)));
#endif
vesx_Ve_di=ves_Ve_di;
#if defined(_DERIVATE2)
  vesx_Ve_di_Ve_si=(+ves_Ve_di_Ve_si-(+0.0*(vds-vdsx)+0.0*0.0+0.0*0.0+0.5*(+0.0-0.0)));
  vesx_Ve_di_Ve_di=(+ves_Ve_di_Ve_di-(+0.0*(vds-vdsx)+0.0*0.0+0.0*0.0+0.5*(+0.0-0.0)));
  vesx_Ve_di_Vdi_si=(+0.0-(+0.0*(vds-vdsx)+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.0*0.0+0.5*(+0.0-0.0)));
#endif
vesx_Vdi_si=(-(0.5*(vds_Vdi_si-vdsx_Vdi_si)));
#if defined(_DERIVATE2)
  vesx_Vdi_si_Ve_si=(+0.0-(+0.0*(vds-vdsx)+0.0*0.0+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.5*(+0.0-0.0)));
  vesx_Vdi_si_Ve_di=(+0.0-(+0.0*(vds-vdsx)+0.0*0.0+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.5*(+0.0-0.0)));
  vesx_Vdi_si_Vdi_si=(+0.0-(+0.0*(vds-vdsx)+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.0*(vds_Vdi_si-vdsx_Vdi_si)+0.5*(+vds_Vdi_si_Vdi_si-vdsx_Vdi_si_Vdi_si)));
#endif
#endif
vesx=(ves-(0.5*(vds-vdsx)));
EXIT_IF_ISNAN((ves-(0.5*(vds-vdsx))))
vesmax=(0.95*PHIBE_i);
EXIT_IF_ISNAN((0.95*PHIBE_i))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=(-vesx_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+0.0-0.0)-0.0);
  T2_Ve_si_Vsi_s=(+(+0.0-0.0)-0.0);
  T2_Ve_si_Vge_di=(+(+0.0-0.0)-0.0);
  T2_Ve_si_Vge_e=(+(+0.0-0.0)-0.0);
  T2_Ve_si_Vge_si=(+(+0.0-0.0)-0.0);
  T2_Ve_si_Ve_si=(+(+0.0-vesx_Ve_si_Ve_si)-0.0);
  T2_Ve_si_Ve_di=(+(+0.0-vesx_Ve_si_Ve_di)-0.0);
  T2_Ve_si_Vdi_si=(+(+0.0-vesx_Ve_si_Vdi_si)-0.0);
  T2_Ve_si_Tempt_GND=(+(+0.0-0.0)-0.0);
#endif
T2_Ve_di=(-vesx_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+0.0-0.0)-0.0);
  T2_Ve_di_Vsi_s=(+(+0.0-0.0)-0.0);
  T2_Ve_di_Vge_di=(+(+0.0-0.0)-0.0);
  T2_Ve_di_Vge_e=(+(+0.0-0.0)-0.0);
  T2_Ve_di_Vge_si=(+(+0.0-0.0)-0.0);
  T2_Ve_di_Ve_si=(+(+0.0-vesx_Ve_di_Ve_si)-0.0);
  T2_Ve_di_Ve_di=(+(+0.0-vesx_Ve_di_Ve_di)-0.0);
  T2_Ve_di_Vdi_si=(+(+0.0-vesx_Ve_di_Vdi_si)-0.0);
  T2_Ve_di_Tempt_GND=(+(+0.0-0.0)-0.0);
#endif
T2_Vdi_si=(-vesx_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+0.0-0.0)-0.0);
  T2_Vdi_si_Vsi_s=(+(+0.0-0.0)-0.0);
  T2_Vdi_si_Vge_di=(+(+0.0-0.0)-0.0);
  T2_Vdi_si_Vge_e=(+(+0.0-0.0)-0.0);
  T2_Vdi_si_Vge_si=(+(+0.0-0.0)-0.0);
  T2_Vdi_si_Ve_si=(+(+0.0-vesx_Vdi_si_Ve_si)-0.0);
  T2_Vdi_si_Ve_di=(+(+0.0-vesx_Vdi_si_Ve_di)-0.0);
  T2_Vdi_si_Vdi_si=(+(+0.0-vesx_Vdi_si_Vdi_si)-0.0);
  T2_Vdi_si_Tempt_GND=(+(+0.0-0.0)-0.0);
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=((vesmax-vesx)-1.0e-3);
EXIT_IF_ISNAN(((vesmax-vesx)-1.0e-3))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+(0.004*vesmax)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+(0.004*vesmax)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
veseff_Ve_si=(-(0.5*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)));
#if defined(_DERIVATE2)
  veseff_Ve_si_Ve_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Ve_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_si*T2+T2_Ve_si*T2_Ve_si+T2_Ve_si*T2_Ve_si+T2*T2_Ve_si_Ve_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_si_Ve_di=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Ve_di+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_di*T2+T2_Ve_si*T2_Ve_di+T2_Ve_di*T2_Ve_si+T2*T2_Ve_si_Ve_di)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_si_Vdi_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vdi_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_si*T2+T2_Ve_si*T2_Vdi_si+T2_Vdi_si*T2_Ve_si+T2*T2_Ve_si_Vdi_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_si_Tempt_GND=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Tempt_GND+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Tempt_GND*T2+T2_Ve_si*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_si+T2*T2_Ve_si_Tempt_GND)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
#endif
veseff_Ve_di=(-(0.5*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)));
#if defined(_DERIVATE2)
  veseff_Ve_di_Ve_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Ve_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_si*T2+T2_Ve_di*T2_Ve_si+T2_Ve_si*T2_Ve_di+T2*T2_Ve_di_Ve_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_di_Ve_di=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Ve_di+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_di*T2+T2_Ve_di*T2_Ve_di+T2_Ve_di*T2_Ve_di+T2*T2_Ve_di_Ve_di)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_di_Vdi_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vdi_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_si*T2+T2_Ve_di*T2_Vdi_si+T2_Vdi_si*T2_Ve_di+T2*T2_Ve_di_Vdi_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Ve_di_Tempt_GND=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Tempt_GND+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Tempt_GND*T2+T2_Ve_di*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_di+T2*T2_Ve_di_Tempt_GND)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
#endif
veseff_Vdi_si=(-(0.5*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)));
#if defined(_DERIVATE2)
  veseff_Vdi_si_Ve_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Ve_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_si*T2+T2_Vdi_si*T2_Ve_si+T2_Ve_si*T2_Vdi_si+T2*T2_Vdi_si_Ve_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Vdi_si_Ve_di=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Ve_di+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_di*T2+T2_Vdi_si*T2_Ve_di+T2_Ve_di*T2_Vdi_si+T2*T2_Vdi_si_Ve_di)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Vdi_si_Vdi_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vdi_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_si*T2+T2_Vdi_si*T2_Vdi_si+T2_Vdi_si*T2_Vdi_si+T2*T2_Vdi_si_Vdi_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Vdi_si_Tempt_GND=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Tempt_GND+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Tempt_GND*T2+T2_Vdi_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_si+T2*T2_Vdi_si_Tempt_GND)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
#endif
veseff_Tempt_GND=(-(0.5*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)));
#if defined(_DERIVATE2)
  veseff_Tempt_GND_Ve_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Ve_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_si*T2)+(T2*T2_Ve_si)))+(0.0))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_si*T2+T2_Tempt_GND*T2_Ve_si+T2_Ve_si*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Tempt_GND_Ve_di=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Ve_di+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Ve_di*T2)+(T2*T2_Ve_di)))+(0.0))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_di*T2+T2_Tempt_GND*T2_Ve_di+T2_Ve_di*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_di)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Tempt_GND_Vdi_si=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vdi_si+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))+(0.0))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_si*T2+T2_Tempt_GND*T2_Vdi_si+T2_Vdi_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_si)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
  veseff_Tempt_GND_Tempt_GND=(+0.0-(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Tempt_GND+(m20_sqrt(((T2*T2)+(0.004*vesmax)))*((((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))+(0.0))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Tempt_GND*T2+T2_Tempt_GND*T2_Tempt_GND+T2_Tempt_GND*T2_Tempt_GND+T2*T2_Tempt_GND_Tempt_GND)+(+0.0*vesmax+0.0*0.0+0.0*0.0+0.004*0.0))))));
#endif
#endif
veseff=(vesmax-(0.5*(T2+d00_sqrt0)));
EXIT_IF_ISNAN((vesmax-(0.5*(T2+d00_sqrt0))))
}
}
{
double m00_tanh(d00_tanh0,((0.6*vds_noswap)/Vtm))
#if defined(_DERIVATEFORDDX)
double m10_tanh(d10_tanh0,d00_tanh0,((0.6*vds_noswap)/Vtm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=((0.6*vds_noswap_Vdi_si)/Vtm)*d10_tanh0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Vge_e=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Ve_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Ve_di=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Vge_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Vdi_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*(((0.6*vds_noswap_Vdi_si))/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*vds_noswap_Vdi_si+0.0*vds_noswap_Vdi_si+0.6*vds_noswap_Vdi_si_Vdi_si)/Vtm-((0.6*vds_noswap_Vdi_si)*0.0+((0.6*vds_noswap_Vdi_si))*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*0.0/Vtm/Vtm/Vtm));
  T0_Vdi_si_Tempt_GND=(m20_tanh(((0.6*vds_noswap)/Vtm))*(((0.0)*Vtm-(0.6*vds_noswap)*Vtm_Tempt_GND)/Vtm/Vtm)*((0.6*vds_noswap_Vdi_si)/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*vds_noswap_Vdi_si+0.6*0.0)/Vtm-((0.6*vds_noswap_Vdi_si)*Vtm_Tempt_GND+(0.0)*0.0+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm));
#endif
T0_Tempt_GND=(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)*d10_tanh0;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vge_e=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Ve_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Ve_di=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vge_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*((0.0)/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Vdi_si=(m20_tanh(((0.6*vds_noswap)/Vtm))*(((0.6*vds_noswap_Vdi_si))/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*vds_noswap_Vdi_si+0.0*0.0+0.6*0.0)/Vtm-(0.0*0.0+((0.6*vds_noswap_Vdi_si))*Vtm_Tempt_GND+(0.6*vds_noswap)*0.0)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm));
  T0_Tempt_GND_Tempt_GND=(m20_tanh(((0.6*vds_noswap)/Vtm))*(((0.0)*Vtm-(0.6*vds_noswap)*Vtm_Tempt_GND)/Vtm/Vtm)*(-(0.6*vds_noswap)*Vtm_Tempt_GND/Vtm/Vtm)+d10_tanh0*((+0.0*vds_noswap+0.0*0.0+0.0*0.0+0.6*0.0)/Vtm-(0.0*Vtm_Tempt_GND+(0.0)*Vtm_Tempt_GND+(0.6*vds_noswap)*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*(0.6*vds_noswap)*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm));
#endif
#endif
T0=d00_tanh0;
EXIT_IF_ISNAN(d00_tanh0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
wf_Vdi_si=(0.5*T0_Vdi_si);
#if defined(_DERIVATE2)
  wf_Vdi_si_Vdi_si=(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+0.5*T0_Vdi_si_Vdi_si));
  wf_Vdi_si_Tempt_GND=(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+0.5*T0_Vdi_si_Tempt_GND));
#endif
wf_Tempt_GND=(0.5*T0_Tempt_GND);
#if defined(_DERIVATE2)
  wf_Tempt_GND_Vdi_si=(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+0.5*T0_Tempt_GND_Vdi_si));
  wf_Tempt_GND_Tempt_GND=(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+0.5*T0_Tempt_GND_Tempt_GND));
#endif
#endif
wf=(0.5+(0.5*T0));
EXIT_IF_ISNAN((0.5+(0.5*T0)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
wr_Vdi_si=(-wf_Vdi_si);
#if defined(_DERIVATE2)
  wr_Vdi_si_Vdi_si=(+0.0-wf_Vdi_si_Vdi_si);
  wr_Vdi_si_Tempt_GND=(+0.0-wf_Vdi_si_Tempt_GND);
#endif
wr_Tempt_GND=(-wf_Tempt_GND);
#if defined(_DERIVATE2)
  wr_Tempt_GND_Vdi_si=(+0.0-wf_Tempt_GND_Vdi_si);
  wr_Tempt_GND_Tempt_GND=(+0.0-wf_Tempt_GND_Tempt_GND);
#endif
#endif
wr=(1.0-wf);
EXIT_IF_ISNAN((1.0-wf))
if
((pModel->ASYMMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
CDSCD_a_Vdi_si=((CDSCDR_i*wr_Vdi_si)+(CDSCD_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  CDSCD_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+CDSCDR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+CDSCD_i*wf_Vdi_si_Vdi_si));
  CDSCD_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+CDSCDR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+CDSCD_i*wf_Vdi_si_Tempt_GND));
#endif
CDSCD_a_Tempt_GND=((CDSCDR_i*wr_Tempt_GND)+(CDSCD_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  CDSCD_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+CDSCDR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+CDSCD_i*wf_Tempt_GND_Vdi_si));
  CDSCD_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+CDSCDR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+CDSCD_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
CDSCD_a=((CDSCDR_i*wr)+(CDSCD_i*wf));
EXIT_IF_ISNAN(((CDSCDR_i*wr)+(CDSCD_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
ETA0_a_Tempt_GND=(((ETA0R_t_Tempt_GND*wr)+(ETA0R_t*wr_Tempt_GND))+((ETA0_t_Tempt_GND*wf)+(ETA0_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  ETA0_a_Tempt_GND_Tempt_GND=(+(+ETA0R_t_Tempt_GND_Tempt_GND*wr+ETA0R_t_Tempt_GND*wr_Tempt_GND+ETA0R_t_Tempt_GND*wr_Tempt_GND+ETA0R_t*wr_Tempt_GND_Tempt_GND)+(+ETA0_t_Tempt_GND_Tempt_GND*wf+ETA0_t_Tempt_GND*wf_Tempt_GND+ETA0_t_Tempt_GND*wf_Tempt_GND+ETA0_t*wf_Tempt_GND_Tempt_GND));
  ETA0_a_Tempt_GND_Vdi_si=(+(+0.0*wr+ETA0R_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+ETA0R_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+ETA0_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+ETA0_t*wf_Tempt_GND_Vdi_si));
#endif
ETA0_a_Vdi_si=((ETA0R_t*wr_Vdi_si)+(ETA0_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  ETA0_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+ETA0R_t_Tempt_GND*wr_Vdi_si+ETA0R_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+ETA0_t_Tempt_GND*wf_Vdi_si+ETA0_t*wf_Vdi_si_Tempt_GND));
  ETA0_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+ETA0R_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+ETA0_t*wf_Vdi_si_Vdi_si));
#endif
#endif
ETA0_a=((ETA0R_t*wr)+(ETA0_t*wf));
EXIT_IF_ISNAN(((ETA0R_t*wr)+(ETA0_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PDIBL1_a_Vdi_si=((PDIBL1R_i*wr_Vdi_si)+(PDIBL1_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  PDIBL1_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+PDIBL1R_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+PDIBL1_i*wf_Vdi_si_Vdi_si));
  PDIBL1_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+PDIBL1R_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+PDIBL1_i*wf_Vdi_si_Tempt_GND));
#endif
PDIBL1_a_Tempt_GND=((PDIBL1R_i*wr_Tempt_GND)+(PDIBL1_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  PDIBL1_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+PDIBL1R_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+PDIBL1_i*wf_Tempt_GND_Vdi_si));
  PDIBL1_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+PDIBL1R_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+PDIBL1_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
PDIBL1_a=((PDIBL1R_i*wr)+(PDIBL1_i*wf));
EXIT_IF_ISNAN(((PDIBL1R_i*wr)+(PDIBL1_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PDIBL2_a_Vdi_si=((PDIBL2R_i*wr_Vdi_si)+(PDIBL2_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  PDIBL2_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+PDIBL2R_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+PDIBL2_i*wf_Vdi_si_Vdi_si));
  PDIBL2_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+PDIBL2R_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+PDIBL2_i*wf_Vdi_si_Tempt_GND));
#endif
PDIBL2_a_Tempt_GND=((PDIBL2R_i*wr_Tempt_GND)+(PDIBL2_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  PDIBL2_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+PDIBL2R_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+PDIBL2_i*wf_Tempt_GND_Vdi_si));
  PDIBL2_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+PDIBL2R_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+PDIBL2_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
PDIBL2_a=((PDIBL2R_i*wr)+(PDIBL2_i*wf));
EXIT_IF_ISNAN(((PDIBL2R_i*wr)+(PDIBL2_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
MEXP_a_Tempt_GND=(((MEXPR_t_Tempt_GND*wr)+(MEXPR_t*wr_Tempt_GND))+((MEXP_t_Tempt_GND*wf)+(MEXP_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  MEXP_a_Tempt_GND_Tempt_GND=(+(+MEXPR_t_Tempt_GND_Tempt_GND*wr+MEXPR_t_Tempt_GND*wr_Tempt_GND+MEXPR_t_Tempt_GND*wr_Tempt_GND+MEXPR_t*wr_Tempt_GND_Tempt_GND)+(+MEXP_t_Tempt_GND_Tempt_GND*wf+MEXP_t_Tempt_GND*wf_Tempt_GND+MEXP_t_Tempt_GND*wf_Tempt_GND+MEXP_t*wf_Tempt_GND_Tempt_GND));
  MEXP_a_Tempt_GND_Vdi_si=(+(+0.0*wr+MEXPR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+MEXPR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+MEXP_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+MEXP_t*wf_Tempt_GND_Vdi_si));
#endif
MEXP_a_Vdi_si=((MEXPR_t*wr_Vdi_si)+(MEXP_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  MEXP_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+MEXPR_t_Tempt_GND*wr_Vdi_si+MEXPR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+MEXP_t_Tempt_GND*wf_Vdi_si+MEXP_t*wf_Vdi_si_Tempt_GND));
  MEXP_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+MEXPR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+MEXP_t*wf_Vdi_si_Vdi_si));
#endif
#endif
MEXP_a=((MEXPR_t*wr)+(MEXP_t*wf));
EXIT_IF_ISNAN(((MEXPR_t*wr)+(MEXP_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PTWG_a_Tempt_GND=(((PTWGR_t_Tempt_GND*wr)+(PTWGR_t*wr_Tempt_GND))+((PTWG_t_Tempt_GND*wf)+(PTWG_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  PTWG_a_Tempt_GND_Tempt_GND=(+(+PTWGR_t_Tempt_GND_Tempt_GND*wr+PTWGR_t_Tempt_GND*wr_Tempt_GND+PTWGR_t_Tempt_GND*wr_Tempt_GND+PTWGR_t*wr_Tempt_GND_Tempt_GND)+(+PTWG_t_Tempt_GND_Tempt_GND*wf+PTWG_t_Tempt_GND*wf_Tempt_GND+PTWG_t_Tempt_GND*wf_Tempt_GND+PTWG_t*wf_Tempt_GND_Tempt_GND));
  PTWG_a_Tempt_GND_Vdi_si=(+(+0.0*wr+PTWGR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+PTWGR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+PTWG_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+PTWG_t*wf_Tempt_GND_Vdi_si));
#endif
PTWG_a_Vdi_si=((PTWGR_t*wr_Vdi_si)+(PTWG_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  PTWG_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+PTWGR_t_Tempt_GND*wr_Vdi_si+PTWGR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+PTWG_t_Tempt_GND*wf_Vdi_si+PTWG_t*wf_Vdi_si_Tempt_GND));
  PTWG_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+PTWGR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+PTWG_t*wf_Vdi_si_Vdi_si));
#endif
#endif
PTWG_a=((PTWGR_t*wr)+(PTWG_t*wf));
EXIT_IF_ISNAN(((PTWGR_t*wr)+(PTWG_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSAT1_a_Tempt_GND=(((VSAT1R_t_Tempt_GND*wr)+(VSAT1R_t*wr_Tempt_GND))+((VSAT1_t_Tempt_GND*wf)+(VSAT1_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  VSAT1_a_Tempt_GND_Tempt_GND=(+(+VSAT1R_t_Tempt_GND_Tempt_GND*wr+VSAT1R_t_Tempt_GND*wr_Tempt_GND+VSAT1R_t_Tempt_GND*wr_Tempt_GND+VSAT1R_t*wr_Tempt_GND_Tempt_GND)+(+VSAT1_t_Tempt_GND_Tempt_GND*wf+VSAT1_t_Tempt_GND*wf_Tempt_GND+VSAT1_t_Tempt_GND*wf_Tempt_GND+VSAT1_t*wf_Tempt_GND_Tempt_GND));
  VSAT1_a_Tempt_GND_Vdi_si=(+(+0.0*wr+VSAT1R_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+VSAT1R_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+VSAT1_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+VSAT1_t*wf_Tempt_GND_Vdi_si));
#endif
VSAT1_a_Vdi_si=((VSAT1R_t*wr_Vdi_si)+(VSAT1_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  VSAT1_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+VSAT1R_t_Tempt_GND*wr_Vdi_si+VSAT1R_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+VSAT1_t_Tempt_GND*wf_Vdi_si+VSAT1_t*wf_Vdi_si_Tempt_GND));
  VSAT1_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+VSAT1R_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+VSAT1_t*wf_Vdi_si_Vdi_si));
#endif
#endif
VSAT1_a=((VSAT1R_t*wr)+(VSAT1_t*wf));
EXIT_IF_ISNAN(((VSAT1R_t*wr)+(VSAT1_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
RSDR_a_Tempt_GND=(((RSDRR_t_Tempt_GND*wr)+(RSDRR_t*wr_Tempt_GND))+((RSDR_t_Tempt_GND*wf)+(RSDR_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  RSDR_a_Tempt_GND_Tempt_GND=(+(+RSDRR_t_Tempt_GND_Tempt_GND*wr+RSDRR_t_Tempt_GND*wr_Tempt_GND+RSDRR_t_Tempt_GND*wr_Tempt_GND+RSDRR_t*wr_Tempt_GND_Tempt_GND)+(+RSDR_t_Tempt_GND_Tempt_GND*wf+RSDR_t_Tempt_GND*wf_Tempt_GND+RSDR_t_Tempt_GND*wf_Tempt_GND+RSDR_t*wf_Tempt_GND_Tempt_GND));
  RSDR_a_Tempt_GND_Vdi_si=(+(+0.0*wr+RSDRR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+RSDRR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+RSDR_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+RSDR_t*wf_Tempt_GND_Vdi_si));
#endif
RSDR_a_Vdi_si=((RSDRR_t*wr_Vdi_si)+(RSDR_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  RSDR_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+RSDRR_t_Tempt_GND*wr_Vdi_si+RSDRR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+RSDR_t_Tempt_GND*wf_Vdi_si+RSDR_t*wf_Vdi_si_Tempt_GND));
  RSDR_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+RSDRR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+RSDR_t*wf_Vdi_si_Vdi_si));
#endif
#endif
RSDR_a=((RSDRR_t*wr)+(RSDR_t*wf));
EXIT_IF_ISNAN(((RSDRR_t*wr)+(RSDR_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
RDDR_a_Tempt_GND=(((RDDRR_t_Tempt_GND*wr)+(RDDRR_t*wr_Tempt_GND))+((RDDR_t_Tempt_GND*wf)+(RDDR_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  RDDR_a_Tempt_GND_Tempt_GND=(+(+RDDRR_t_Tempt_GND_Tempt_GND*wr+RDDRR_t_Tempt_GND*wr_Tempt_GND+RDDRR_t_Tempt_GND*wr_Tempt_GND+RDDRR_t*wr_Tempt_GND_Tempt_GND)+(+RDDR_t_Tempt_GND_Tempt_GND*wf+RDDR_t_Tempt_GND*wf_Tempt_GND+RDDR_t_Tempt_GND*wf_Tempt_GND+RDDR_t*wf_Tempt_GND_Tempt_GND));
  RDDR_a_Tempt_GND_Vdi_si=(+(+0.0*wr+RDDRR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+RDDRR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+RDDR_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+RDDR_t*wf_Tempt_GND_Vdi_si));
#endif
RDDR_a_Vdi_si=((RDDRR_t*wr_Vdi_si)+(RDDR_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  RDDR_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+RDDRR_t_Tempt_GND*wr_Vdi_si+RDDRR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+RDDR_t_Tempt_GND*wf_Vdi_si+RDDR_t*wf_Vdi_si_Tempt_GND));
  RDDR_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+RDDRR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+RDDR_t*wf_Vdi_si_Vdi_si));
#endif
#endif
RDDR_a=((RDDRR_t*wr)+(RDDR_t*wf));
EXIT_IF_ISNAN(((RDDRR_t*wr)+(RDDR_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PCLM_a_Vdi_si=((PCLMR_i*wr_Vdi_si)+(PCLM_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  PCLM_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+PCLMR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+PCLM_i*wf_Vdi_si_Vdi_si));
  PCLM_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+PCLMR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+PCLM_i*wf_Vdi_si_Tempt_GND));
#endif
PCLM_a_Tempt_GND=((PCLMR_i*wr_Tempt_GND)+(PCLM_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  PCLM_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+PCLMR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+PCLM_i*wf_Tempt_GND_Vdi_si));
  PCLM_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+PCLMR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+PCLM_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
PCLM_a=((PCLMR_i*wr)+(PCLM_i*wf));
EXIT_IF_ISNAN(((PCLMR_i*wr)+(PCLM_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT_a_Tempt_GND=(((VSATR_t_Tempt_GND*wr)+(VSATR_t*wr_Tempt_GND))+((VSAT_t_Tempt_GND*wf)+(VSAT_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  VSAT_a_Tempt_GND_Tempt_GND=(+(+VSATR_t_Tempt_GND_Tempt_GND*wr+VSATR_t_Tempt_GND*wr_Tempt_GND+VSATR_t_Tempt_GND*wr_Tempt_GND+VSATR_t*wr_Tempt_GND_Tempt_GND)+(+VSAT_t_Tempt_GND_Tempt_GND*wf+VSAT_t_Tempt_GND*wf_Tempt_GND+VSAT_t_Tempt_GND*wf_Tempt_GND+VSAT_t*wf_Tempt_GND_Tempt_GND));
  VSAT_a_Tempt_GND_Vdi_si=(+(+0.0*wr+VSATR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+VSATR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+VSAT_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+VSAT_t*wf_Tempt_GND_Vdi_si));
#endif
VSAT_a_Vdi_si=((VSATR_t*wr_Vdi_si)+(VSAT_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  VSAT_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+VSATR_t_Tempt_GND*wr_Vdi_si+VSATR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+VSAT_t_Tempt_GND*wf_Vdi_si+VSAT_t*wf_Vdi_si_Tempt_GND));
  VSAT_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+VSATR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+VSAT_t*wf_Vdi_si_Vdi_si));
#endif
#endif
VSAT_a=((VSATR_t*wr)+(VSAT_t*wf));
EXIT_IF_ISNAN(((VSATR_t*wr)+(VSAT_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND)V(e,GND) */
KSATIV_a_Vdi_si=((KSATIVR_i*wr_Vdi_si)+(KSATIV_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  KSATIV_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+KSATIVR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+KSATIV_i*wf_Vdi_si_Vdi_si));
  KSATIV_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+KSATIVR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+KSATIV_i*wf_Vdi_si_Tempt_GND));
#endif
KSATIV_a_Tempt_GND=((KSATIVR_i*wr_Tempt_GND)+(KSATIV_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  KSATIV_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+KSATIVR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+KSATIV_i*wf_Tempt_GND_Vdi_si));
  KSATIV_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+KSATIVR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+KSATIV_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
KSATIV_a=((KSATIVR_i*wr)+(KSATIV_i*wf));
EXIT_IF_ISNAN(((KSATIVR_i*wr)+(KSATIV_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
DVTSHIFT_a_Vdi_si=((DVTSHIFTR_i*wr_Vdi_si)+(DVTSHIFT_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  DVTSHIFT_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+DVTSHIFTR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+DVTSHIFT_i*wf_Vdi_si_Vdi_si));
  DVTSHIFT_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+DVTSHIFTR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+DVTSHIFT_i*wf_Vdi_si_Tempt_GND));
#endif
DVTSHIFT_a_Tempt_GND=((DVTSHIFTR_i*wr_Tempt_GND)+(DVTSHIFT_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  DVTSHIFT_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+DVTSHIFTR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+DVTSHIFT_i*wf_Tempt_GND_Vdi_si));
  DVTSHIFT_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+DVTSHIFTR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+DVTSHIFT_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
DVTSHIFT_a=((DVTSHIFTR_i*wr)+(DVTSHIFT_i*wf));
EXIT_IF_ISNAN(((DVTSHIFTR_i*wr)+(DVTSHIFT_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
CIT_a_Vdi_si=((CITR_i*wr_Vdi_si)+(CIT_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  CIT_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+CITR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+CIT_i*wf_Vdi_si_Vdi_si));
  CIT_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+CITR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+CIT_i*wf_Vdi_si_Tempt_GND));
#endif
CIT_a_Tempt_GND=((CITR_i*wr_Tempt_GND)+(CIT_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  CIT_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+CITR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+CIT_i*wf_Tempt_GND_Vdi_si));
  CIT_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+CITR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+CIT_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
CIT_a=((CITR_i*wr)+(CIT_i*wf));
EXIT_IF_ISNAN(((CITR_i*wr)+(CIT_i*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
u0_a_Tempt_GND=(((u0r_Tempt_GND*wr)+(u0r*wr_Tempt_GND))+((u0_Tempt_GND*wf)+(u0*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  u0_a_Tempt_GND_Tempt_GND=(+(+u0r_Tempt_GND_Tempt_GND*wr+u0r_Tempt_GND*wr_Tempt_GND+u0r_Tempt_GND*wr_Tempt_GND+u0r*wr_Tempt_GND_Tempt_GND)+(+u0_Tempt_GND_Tempt_GND*wf+u0_Tempt_GND*wf_Tempt_GND+u0_Tempt_GND*wf_Tempt_GND+u0*wf_Tempt_GND_Tempt_GND));
  u0_a_Tempt_GND_Vdi_si=(+(+0.0*wr+u0r_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+u0r*wr_Tempt_GND_Vdi_si)+(+0.0*wf+u0_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+u0*wf_Tempt_GND_Vdi_si));
#endif
u0_a_Vdi_si=((u0r*wr_Vdi_si)+(u0*wf_Vdi_si));
#if defined(_DERIVATE2)
  u0_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+u0r_Tempt_GND*wr_Vdi_si+u0r*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+u0_Tempt_GND*wf_Vdi_si+u0*wf_Vdi_si_Tempt_GND));
  u0_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+u0r*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+u0*wf_Vdi_si_Vdi_si));
#endif
#endif
u0_a=((u0r*wr)+(u0*wf));
EXIT_IF_ISNAN(((u0r*wr)+(u0*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UA_a_Tempt_GND=(((UAR_t_Tempt_GND*wr)+(UAR_t*wr_Tempt_GND))+((UA_t_Tempt_GND*wf)+(UA_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  UA_a_Tempt_GND_Tempt_GND=(+(+UAR_t_Tempt_GND_Tempt_GND*wr+UAR_t_Tempt_GND*wr_Tempt_GND+UAR_t_Tempt_GND*wr_Tempt_GND+UAR_t*wr_Tempt_GND_Tempt_GND)+(+UA_t_Tempt_GND_Tempt_GND*wf+UA_t_Tempt_GND*wf_Tempt_GND+UA_t_Tempt_GND*wf_Tempt_GND+UA_t*wf_Tempt_GND_Tempt_GND));
  UA_a_Tempt_GND_Vdi_si=(+(+0.0*wr+UAR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+UAR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+UA_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+UA_t*wf_Tempt_GND_Vdi_si));
#endif
UA_a_Vdi_si=((UAR_t*wr_Vdi_si)+(UA_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  UA_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UAR_t_Tempt_GND*wr_Vdi_si+UAR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UA_t_Tempt_GND*wf_Vdi_si+UA_t*wf_Vdi_si_Tempt_GND));
  UA_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+UAR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+UA_t*wf_Vdi_si_Vdi_si));
#endif
#endif
UA_a=((UAR_t*wr)+(UA_t*wf));
EXIT_IF_ISNAN(((UAR_t*wr)+(UA_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UD_a_Tempt_GND=(((UDR_t_Tempt_GND*wr)+(UDR_t*wr_Tempt_GND))+((UD_t_Tempt_GND*wf)+(UD_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  UD_a_Tempt_GND_Tempt_GND=(+(+UDR_t_Tempt_GND_Tempt_GND*wr+UDR_t_Tempt_GND*wr_Tempt_GND+UDR_t_Tempt_GND*wr_Tempt_GND+UDR_t*wr_Tempt_GND_Tempt_GND)+(+UD_t_Tempt_GND_Tempt_GND*wf+UD_t_Tempt_GND*wf_Tempt_GND+UD_t_Tempt_GND*wf_Tempt_GND+UD_t*wf_Tempt_GND_Tempt_GND));
  UD_a_Tempt_GND_Vdi_si=(+(+0.0*wr+UDR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+UDR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+UD_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+UD_t*wf_Tempt_GND_Vdi_si));
#endif
UD_a_Vdi_si=((UDR_t*wr_Vdi_si)+(UD_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  UD_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UDR_t_Tempt_GND*wr_Vdi_si+UDR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UD_t_Tempt_GND*wf_Vdi_si+UD_t*wf_Vdi_si_Tempt_GND));
  UD_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+UDR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+UD_t*wf_Vdi_si_Vdi_si));
#endif
#endif
UD_a=((UDR_t*wr)+(UD_t*wf));
EXIT_IF_ISNAN(((UDR_t*wr)+(UD_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UC_a_Tempt_GND=(((UCR_t_Tempt_GND*wr)+(UCR_t*wr_Tempt_GND))+((UC_t_Tempt_GND*wf)+(UC_t*wf_Tempt_GND)));
#if defined(_DERIVATE2)
  UC_a_Tempt_GND_Tempt_GND=(+(+UCR_t_Tempt_GND_Tempt_GND*wr+UCR_t_Tempt_GND*wr_Tempt_GND+UCR_t_Tempt_GND*wr_Tempt_GND+UCR_t*wr_Tempt_GND_Tempt_GND)+(+UC_t_Tempt_GND_Tempt_GND*wf+UC_t_Tempt_GND*wf_Tempt_GND+UC_t_Tempt_GND*wf_Tempt_GND+UC_t*wf_Tempt_GND_Tempt_GND));
  UC_a_Tempt_GND_Vdi_si=(+(+0.0*wr+UCR_t_Tempt_GND*wr_Vdi_si+0.0*wr_Tempt_GND+UCR_t*wr_Tempt_GND_Vdi_si)+(+0.0*wf+UC_t_Tempt_GND*wf_Vdi_si+0.0*wf_Tempt_GND+UC_t*wf_Tempt_GND_Vdi_si));
#endif
UC_a_Vdi_si=((UCR_t*wr_Vdi_si)+(UC_t*wf_Vdi_si));
#if defined(_DERIVATE2)
  UC_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+UCR_t_Tempt_GND*wr_Vdi_si+UCR_t*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+UC_t_Tempt_GND*wf_Vdi_si+UC_t*wf_Vdi_si_Tempt_GND));
  UC_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+UCR_t*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+UC_t*wf_Vdi_si_Vdi_si));
#endif
#endif
UC_a=((UCR_t*wr)+(UC_t*wf));
EXIT_IF_ISNAN(((UCR_t*wr)+(UC_t*wf)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
EU_a_Vdi_si=((EUR_i*wr_Vdi_si)+(EU_i*wf_Vdi_si));
#if defined(_DERIVATE2)
  EU_a_Vdi_si_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Vdi_si+EUR_i*wr_Vdi_si_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Vdi_si+EU_i*wf_Vdi_si_Vdi_si));
  EU_a_Vdi_si_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Vdi_si+EUR_i*wr_Vdi_si_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Vdi_si+EU_i*wf_Vdi_si_Tempt_GND));
#endif
EU_a_Tempt_GND=((EUR_i*wr_Tempt_GND)+(EU_i*wf_Tempt_GND));
#if defined(_DERIVATE2)
  EU_a_Tempt_GND_Vdi_si=(+(+0.0*wr+0.0*wr_Vdi_si+0.0*wr_Tempt_GND+EUR_i*wr_Tempt_GND_Vdi_si)+(+0.0*wf+0.0*wf_Vdi_si+0.0*wf_Tempt_GND+EU_i*wf_Tempt_GND_Vdi_si));
  EU_a_Tempt_GND_Tempt_GND=(+(+0.0*wr+0.0*wr_Tempt_GND+0.0*wr_Tempt_GND+EUR_i*wr_Tempt_GND_Tempt_GND)+(+0.0*wf+0.0*wf_Tempt_GND+0.0*wf_Tempt_GND+EU_i*wf_Tempt_GND_Tempt_GND));
#endif
#endif
EU_a=((EUR_i*wr)+(EU_i*wf));
EXIT_IF_ISNAN(((EUR_i*wr)+(EU_i*wf)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
CDSCD_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  CDSCD_a_Vdi_si_Vdi_si=0.0;
  CDSCD_a_Vdi_si_Tempt_GND=0.0;
#endif
CDSCD_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CDSCD_a_Tempt_GND_Vdi_si=0.0;
  CDSCD_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CDSCD_a=CDSCD_i;
EXIT_IF_ISNAN(CDSCD_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
ETA0_a_Tempt_GND=ETA0_t_Tempt_GND;
#if defined(_DERIVATE2)
  ETA0_a_Tempt_GND_Tempt_GND=ETA0_t_Tempt_GND_Tempt_GND;
  ETA0_a_Tempt_GND_Vdi_si=0.0;
#endif
ETA0_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  ETA0_a_Vdi_si_Tempt_GND=0.0;
  ETA0_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
ETA0_a=ETA0_t;
EXIT_IF_ISNAN(ETA0_t)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PDIBL1_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  PDIBL1_a_Vdi_si_Vdi_si=0.0;
  PDIBL1_a_Vdi_si_Tempt_GND=0.0;
#endif
PDIBL1_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PDIBL1_a_Tempt_GND_Vdi_si=0.0;
  PDIBL1_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PDIBL1_a=PDIBL1_i;
EXIT_IF_ISNAN(PDIBL1_i)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PDIBL2_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  PDIBL2_a_Vdi_si_Vdi_si=0.0;
  PDIBL2_a_Vdi_si_Tempt_GND=0.0;
#endif
PDIBL2_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PDIBL2_a_Tempt_GND_Vdi_si=0.0;
  PDIBL2_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PDIBL2_a=PDIBL2_i;
EXIT_IF_ISNAN(PDIBL2_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
MEXP_a_Tempt_GND=MEXP_t_Tempt_GND;
#if defined(_DERIVATE2)
  MEXP_a_Tempt_GND_Tempt_GND=MEXP_t_Tempt_GND_Tempt_GND;
  MEXP_a_Tempt_GND_Vdi_si=0.0;
#endif
MEXP_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  MEXP_a_Vdi_si_Tempt_GND=0.0;
  MEXP_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
MEXP_a=MEXP_t;
EXIT_IF_ISNAN(MEXP_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
PTWG_a_Tempt_GND=PTWG_t_Tempt_GND;
#if defined(_DERIVATE2)
  PTWG_a_Tempt_GND_Tempt_GND=PTWG_t_Tempt_GND_Tempt_GND;
  PTWG_a_Tempt_GND_Vdi_si=0.0;
#endif
PTWG_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  PTWG_a_Vdi_si_Tempt_GND=0.0;
  PTWG_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
PTWG_a=PTWG_t;
EXIT_IF_ISNAN(PTWG_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
VSAT1_a_Tempt_GND=VSAT1_t_Tempt_GND;
#if defined(_DERIVATE2)
  VSAT1_a_Tempt_GND_Tempt_GND=VSAT1_t_Tempt_GND_Tempt_GND;
  VSAT1_a_Tempt_GND_Vdi_si=0.0;
#endif
VSAT1_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  VSAT1_a_Vdi_si_Tempt_GND=0.0;
  VSAT1_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
VSAT1_a=VSAT1_t;
EXIT_IF_ISNAN(VSAT1_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
RSDR_a_Tempt_GND=RSDR_t_Tempt_GND;
#if defined(_DERIVATE2)
  RSDR_a_Tempt_GND_Tempt_GND=RSDR_t_Tempt_GND_Tempt_GND;
  RSDR_a_Tempt_GND_Vdi_si=0.0;
#endif
RSDR_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  RSDR_a_Vdi_si_Tempt_GND=0.0;
  RSDR_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
RSDR_a=RSDR_t;
EXIT_IF_ISNAN(RSDR_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
RDDR_a_Tempt_GND=RDDR_t_Tempt_GND;
#if defined(_DERIVATE2)
  RDDR_a_Tempt_GND_Tempt_GND=RDDR_t_Tempt_GND_Tempt_GND;
  RDDR_a_Tempt_GND_Vdi_si=0.0;
#endif
RDDR_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  RDDR_a_Vdi_si_Tempt_GND=0.0;
  RDDR_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
RDDR_a=RDDR_t;
EXIT_IF_ISNAN(RDDR_t)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
PCLM_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  PCLM_a_Vdi_si_Vdi_si=0.0;
  PCLM_a_Vdi_si_Tempt_GND=0.0;
#endif
PCLM_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  PCLM_a_Tempt_GND_Vdi_si=0.0;
  PCLM_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
PCLM_a=PCLM_i;
EXIT_IF_ISNAN(PCLM_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
VSAT_a_Tempt_GND=VSAT_t_Tempt_GND;
#if defined(_DERIVATE2)
  VSAT_a_Tempt_GND_Tempt_GND=VSAT_t_Tempt_GND_Tempt_GND;
  VSAT_a_Tempt_GND_Vdi_si=0.0;
#endif
VSAT_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  VSAT_a_Vdi_si_Tempt_GND=0.0;
  VSAT_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
VSAT_a=VSAT_t;
EXIT_IF_ISNAN(VSAT_t)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND)V(e,GND) */
KSATIV_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  KSATIV_a_Vdi_si_Vdi_si=0.0;
  KSATIV_a_Vdi_si_Tempt_GND=0.0;
#endif
KSATIV_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  KSATIV_a_Tempt_GND_Vdi_si=0.0;
  KSATIV_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
KSATIV_a=KSATIV_i;
EXIT_IF_ISNAN(KSATIV_i)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
DVTSHIFT_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  DVTSHIFT_a_Vdi_si_Vdi_si=0.0;
  DVTSHIFT_a_Vdi_si_Tempt_GND=0.0;
#endif
DVTSHIFT_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  DVTSHIFT_a_Tempt_GND_Vdi_si=0.0;
  DVTSHIFT_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
DVTSHIFT_a=DVTSHIFT_i;
EXIT_IF_ISNAN(DVTSHIFT_i)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
CIT_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  CIT_a_Vdi_si_Vdi_si=0.0;
  CIT_a_Vdi_si_Tempt_GND=0.0;
#endif
CIT_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  CIT_a_Tempt_GND_Vdi_si=0.0;
  CIT_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
CIT_a=CIT_i;
EXIT_IF_ISNAN(CIT_i)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
u0_a_Tempt_GND=u0_Tempt_GND;
#if defined(_DERIVATE2)
  u0_a_Tempt_GND_Tempt_GND=u0_Tempt_GND_Tempt_GND;
  u0_a_Tempt_GND_Vdi_si=0.0;
#endif
u0_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  u0_a_Vdi_si_Tempt_GND=0.0;
  u0_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
u0_a=u0;
EXIT_IF_ISNAN(u0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UA_a_Tempt_GND=UA_t_Tempt_GND;
#if defined(_DERIVATE2)
  UA_a_Tempt_GND_Tempt_GND=UA_t_Tempt_GND_Tempt_GND;
  UA_a_Tempt_GND_Vdi_si=0.0;
#endif
UA_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  UA_a_Vdi_si_Tempt_GND=0.0;
  UA_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
UA_a=UA_t;
EXIT_IF_ISNAN(UA_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UD_a_Tempt_GND=UD_t_Tempt_GND;
#if defined(_DERIVATE2)
  UD_a_Tempt_GND_Tempt_GND=UD_t_Tempt_GND_Tempt_GND;
  UD_a_Tempt_GND_Vdi_si=0.0;
#endif
UD_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  UD_a_Vdi_si_Tempt_GND=0.0;
  UD_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
UD_a=UD_t;
EXIT_IF_ISNAN(UD_t)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
UC_a_Tempt_GND=UC_t_Tempt_GND;
#if defined(_DERIVATE2)
  UC_a_Tempt_GND_Tempt_GND=UC_t_Tempt_GND_Tempt_GND;
  UC_a_Tempt_GND_Vdi_si=0.0;
#endif
UC_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  UC_a_Vdi_si_Tempt_GND=0.0;
  UC_a_Vdi_si_Vdi_si=0.0;
#endif
#endif
UC_a=UC_t;
EXIT_IF_ISNAN(UC_t)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
EU_a_Vdi_si=0.0;
#if defined(_DERIVATE2)
  EU_a_Vdi_si_Vdi_si=0.0;
  EU_a_Vdi_si_Tempt_GND=0.0;
#endif
EU_a_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  EU_a_Tempt_GND_Vdi_si=0.0;
  EU_a_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
EU_a=EU_i;
EXIT_IF_ISNAN(EU_i)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
inv_MEXP_Tempt_GND=(-MEXP_a_Tempt_GND/MEXP_a/MEXP_a);
#if defined(_DERIVATE2)
  inv_MEXP_Tempt_GND_Tempt_GND=(0.0/MEXP_a-(0.0*MEXP_a_Tempt_GND+0.0*MEXP_a_Tempt_GND+1.0*MEXP_a_Tempt_GND_Tempt_GND)/MEXP_a/MEXP_a+2*1.0*MEXP_a_Tempt_GND*MEXP_a_Tempt_GND/MEXP_a/MEXP_a/MEXP_a);
  inv_MEXP_Tempt_GND_Vdi_si=(0.0/MEXP_a-(0.0*MEXP_a_Vdi_si+0.0*MEXP_a_Tempt_GND+1.0*MEXP_a_Tempt_GND_Vdi_si)/MEXP_a/MEXP_a+2*1.0*MEXP_a_Tempt_GND*MEXP_a_Vdi_si/MEXP_a/MEXP_a/MEXP_a);
#endif
inv_MEXP_Vdi_si=(-MEXP_a_Vdi_si/MEXP_a/MEXP_a);
#if defined(_DERIVATE2)
  inv_MEXP_Vdi_si_Tempt_GND=(0.0/MEXP_a-(0.0*MEXP_a_Tempt_GND+0.0*MEXP_a_Vdi_si+1.0*MEXP_a_Vdi_si_Tempt_GND)/MEXP_a/MEXP_a+2*1.0*MEXP_a_Vdi_si*MEXP_a_Tempt_GND/MEXP_a/MEXP_a/MEXP_a);
  inv_MEXP_Vdi_si_Vdi_si=(0.0/MEXP_a-(0.0*MEXP_a_Vdi_si+0.0*MEXP_a_Vdi_si+1.0*MEXP_a_Vdi_si_Vdi_si)/MEXP_a/MEXP_a+2*1.0*MEXP_a_Vdi_si*MEXP_a_Vdi_si/MEXP_a/MEXP_a/MEXP_a);
#endif
#endif
inv_MEXP=(1.0/MEXP_a);
EXIT_IF_ISNAN((1.0/MEXP_a))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
phist_Tempt_GND=phib_Tempt_GND;
#if defined(_DERIVATE2)
  phist_Tempt_GND_Tempt_GND=(+(+0.0+phib_Tempt_GND_Tempt_GND)+0.0);
#endif
#endif
phist=((0.4+phib)+PHIN_i);
EXIT_IF_ISNAN(((0.4+phib)+PHIN_i))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=((2.0*(Cins/Weff_UFCM))/(rc+2.0));
EXIT_IF_ISNAN(((2.0*(Cins/Weff_UFCM))/(rc+2.0)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
cdsc_Vdi_si=(Theta_SW*((CDSCD_a_Vdi_si*vdsx)+(CDSCD_a*vdsx_Vdi_si)));
#if defined(_DERIVATE2)
  cdsc_Vdi_si_Vdi_si=(+0.0*(CDSC_i+(CDSCD_a*vdsx))+0.0*(((CDSCD_a_Vdi_si*vdsx)+(CDSCD_a*vdsx_Vdi_si)))+0.0*((CDSCD_a_Vdi_si*vdsx)+(CDSCD_a*vdsx_Vdi_si))+Theta_SW*(+0.0+(+CDSCD_a_Vdi_si_Vdi_si*vdsx+CDSCD_a_Vdi_si*vdsx_Vdi_si+CDSCD_a_Vdi_si*vdsx_Vdi_si+CDSCD_a*vdsx_Vdi_si_Vdi_si)));
  cdsc_Vdi_si_Tempt_GND=(+0.0*(CDSC_i+(CDSCD_a*vdsx))+0.0*(CDSCD_a_Tempt_GND*vdsx)+0.0*((CDSCD_a_Vdi_si*vdsx)+(CDSCD_a*vdsx_Vdi_si))+Theta_SW*(+0.0+(+CDSCD_a_Vdi_si_Tempt_GND*vdsx+CDSCD_a_Vdi_si*0.0+CDSCD_a_Tempt_GND*vdsx_Vdi_si+CDSCD_a*0.0)));
#endif
cdsc_Tempt_GND=(Theta_SW*CDSCD_a_Tempt_GND*vdsx);
#if defined(_DERIVATE2)
  cdsc_Tempt_GND_Vdi_si=(+0.0*(CDSC_i+(CDSCD_a*vdsx))+0.0*(((CDSCD_a_Vdi_si*vdsx)+(CDSCD_a*vdsx_Vdi_si)))+0.0*CDSCD_a_Tempt_GND*vdsx+Theta_SW*(+0.0+(+CDSCD_a_Tempt_GND_Vdi_si*vdsx+CDSCD_a_Tempt_GND*vdsx_Vdi_si+CDSCD_a_Vdi_si*0.0+CDSCD_a*0.0)));
  cdsc_Tempt_GND_Tempt_GND=(+0.0*(CDSC_i+(CDSCD_a*vdsx))+0.0*(CDSCD_a_Tempt_GND*vdsx)+0.0*CDSCD_a_Tempt_GND*vdsx+Theta_SW*(+0.0+(+CDSCD_a_Tempt_GND_Tempt_GND*vdsx+CDSCD_a_Tempt_GND*0.0+CDSCD_a_Tempt_GND*0.0+CDSCD_a*0.0)));
#endif
#endif
cdsc=(Theta_SW*(CDSC_i+(CDSCD_a*vdsx)));
EXIT_IF_ISNAN((Theta_SW*(CDSC_i+(CDSCD_a*vdsx))))
if
((!(model->NVTM_Given)))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
nVtm_Tempt_GND=((((Vtm_Tempt_GND*ThetaSS)+(Vtm*ThetaSS_Tempt_GND))*(1.0+((CIT_a+cdsc)/T1)))+((Vtm*ThetaSS)*(((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1-(CIT_a+cdsc)*T1_Tempt_GND)/T1/T1)));
#if defined(_DERIVATE2)
  nVtm_Tempt_GND_Tempt_GND=(+(+Vtm_Tempt_GND_Tempt_GND*ThetaSS+Vtm_Tempt_GND*ThetaSS_Tempt_GND+Vtm_Tempt_GND*ThetaSS_Tempt_GND+Vtm*ThetaSS_Tempt_GND_Tempt_GND)*(1.0+((CIT_a+cdsc)/T1))+((Vtm_Tempt_GND*ThetaSS)+(Vtm*ThetaSS_Tempt_GND))*(((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1-(CIT_a+cdsc)*T1_Tempt_GND)/T1/T1)+(((Vtm_Tempt_GND*ThetaSS)+(Vtm*ThetaSS_Tempt_GND)))*(((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1-(CIT_a+cdsc)*T1_Tempt_GND)/T1/T1)+(Vtm*ThetaSS)*(+0.0+((+CIT_a_Tempt_GND_Tempt_GND+cdsc_Tempt_GND_Tempt_GND)/T1-((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1_Tempt_GND+(CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1_Tempt_GND+(CIT_a+cdsc)*T1_Tempt_GND_Tempt_GND)/T1/T1+2*(CIT_a+cdsc)*T1_Tempt_GND*T1_Tempt_GND/T1/T1/T1)));
  nVtm_Tempt_GND_Vdi_si=(+(+0.0*ThetaSS+Vtm_Tempt_GND*0.0+0.0*ThetaSS_Tempt_GND+Vtm*0.0)*(1.0+((CIT_a+cdsc)/T1))+((Vtm_Tempt_GND*ThetaSS)+(Vtm*ThetaSS_Tempt_GND))*(((CIT_a_Vdi_si+cdsc_Vdi_si)*T1-(CIT_a+cdsc)*T1_Vdi_si)/T1/T1)+(0.0)*(((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1-(CIT_a+cdsc)*T1_Tempt_GND)/T1/T1)+(Vtm*ThetaSS)*(+0.0+((+CIT_a_Tempt_GND_Vdi_si+cdsc_Tempt_GND_Vdi_si)/T1-((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1_Vdi_si+(CIT_a_Vdi_si+cdsc_Vdi_si)*T1_Tempt_GND+(CIT_a+cdsc)*T1_Tempt_GND_Vdi_si)/T1/T1+2*(CIT_a+cdsc)*T1_Tempt_GND*T1_Vdi_si/T1/T1/T1)));
#endif
nVtm_Vdi_si=((Vtm*ThetaSS)*(((CIT_a_Vdi_si+cdsc_Vdi_si)*T1-(CIT_a+cdsc)*T1_Vdi_si)/T1/T1));
#if defined(_DERIVATE2)
  nVtm_Vdi_si_Tempt_GND=(+(+0.0*ThetaSS+0.0*ThetaSS_Tempt_GND+Vtm_Tempt_GND*0.0+Vtm*0.0)*(1.0+((CIT_a+cdsc)/T1))+0.0*(((CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1-(CIT_a+cdsc)*T1_Tempt_GND)/T1/T1)+(((Vtm_Tempt_GND*ThetaSS)+(Vtm*ThetaSS_Tempt_GND)))*(((CIT_a_Vdi_si+cdsc_Vdi_si)*T1-(CIT_a+cdsc)*T1_Vdi_si)/T1/T1)+(Vtm*ThetaSS)*(+0.0+((+CIT_a_Vdi_si_Tempt_GND+cdsc_Vdi_si_Tempt_GND)/T1-((CIT_a_Vdi_si+cdsc_Vdi_si)*T1_Tempt_GND+(CIT_a_Tempt_GND+cdsc_Tempt_GND)*T1_Vdi_si+(CIT_a+cdsc)*T1_Vdi_si_Tempt_GND)/T1/T1+2*(CIT_a+cdsc)*T1_Vdi_si*T1_Tempt_GND/T1/T1/T1)));
  nVtm_Vdi_si_Vdi_si=(+(+0.0*ThetaSS+0.0*0.0+0.0*0.0+Vtm*0.0)*(1.0+((CIT_a+cdsc)/T1))+0.0*(((CIT_a_Vdi_si+cdsc_Vdi_si)*T1-(CIT_a+cdsc)*T1_Vdi_si)/T1/T1)+(0.0)*(((CIT_a_Vdi_si+cdsc_Vdi_si)*T1-(CIT_a+cdsc)*T1_Vdi_si)/T1/T1)+(Vtm*ThetaSS)*(+0.0+((+CIT_a_Vdi_si_Vdi_si+cdsc_Vdi_si_Vdi_si)/T1-((CIT_a_Vdi_si+cdsc_Vdi_si)*T1_Vdi_si+(CIT_a_Vdi_si+cdsc_Vdi_si)*T1_Vdi_si+(CIT_a+cdsc)*T1_Vdi_si_Vdi_si)/T1/T1+2*(CIT_a+cdsc)*T1_Vdi_si*T1_Vdi_si/T1/T1/T1)));
#endif
#endif
nVtm=((Vtm*ThetaSS)*(1.0+((CIT_a+cdsc)/T1)));
EXIT_IF_ISNAN(((Vtm*ThetaSS)*(1.0+((CIT_a+cdsc)/T1))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
nVtm_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  nVtm_Tempt_GND_Tempt_GND=0.0;
  nVtm_Tempt_GND_Vdi_si=0.0;
#endif
nVtm_Vdi_si=0.0;
#if defined(_DERIVATE2)
  nVtm_Vdi_si_Tempt_GND=0.0;
  nVtm_Vdi_si_Vdi_si=0.0;
#endif
#endif
nVtm=pModel->NVTM;
EXIT_IF_ISNAN(pModel->NVTM)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qdep_Tempt_GND=(-Qdep_ov_Cins*nVtm_Tempt_GND/nVtm/nVtm);
#if defined(_DERIVATE2)
  qdep_Tempt_GND_Tempt_GND=(0.0/nVtm-(0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+Qdep_ov_Cins*nVtm_Tempt_GND_Tempt_GND)/nVtm/nVtm+2*Qdep_ov_Cins*nVtm_Tempt_GND*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
  qdep_Tempt_GND_Vdi_si=(0.0/nVtm-(0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+Qdep_ov_Cins*nVtm_Tempt_GND_Vdi_si)/nVtm/nVtm+2*Qdep_ov_Cins*nVtm_Tempt_GND*nVtm_Vdi_si/nVtm/nVtm/nVtm);
#endif
qdep_Vdi_si=(-Qdep_ov_Cins*nVtm_Vdi_si/nVtm/nVtm);
#if defined(_DERIVATE2)
  qdep_Vdi_si_Tempt_GND=(0.0/nVtm-(0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+Qdep_ov_Cins*nVtm_Vdi_si_Tempt_GND)/nVtm/nVtm+2*Qdep_ov_Cins*nVtm_Vdi_si*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
  qdep_Vdi_si_Vdi_si=(0.0/nVtm-(0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+Qdep_ov_Cins*nVtm_Vdi_si_Vdi_si)/nVtm/nVtm+2*Qdep_ov_Cins*nVtm_Vdi_si*nVtm_Vdi_si/nVtm/nVtm/nVtm);
#endif
#endif
qdep=(Qdep_ov_Cins/nVtm);
EXIT_IF_ISNAN((Qdep_ov_Cins/nVtm))
{
double m00_logE(d00_logE0,((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vth_fixed_factor_SI_Tempt_GND=(((Cins*nVtm_Tempt_GND)*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))*d10_logE0;
#if defined(_DERIVATE2)
  vth_fixed_factor_SI_Tempt_GND_Tempt_GND=(m20_logE(((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))*((((Cins*nVtm_Tempt_GND))*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))*(((Cins*nVtm_Tempt_GND)*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))+d10_logE0*((+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+Cins*nVtm_Tempt_GND_Tempt_GND)/(((1.60219e-19*Nc)*2.0)*Ach)-((Cins*nVtm_Tempt_GND)*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach)+((Cins*nVtm_Tempt_GND))*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach+(Cins*nVtm)*(+(+(+0.0*Nc+0.0*Nc_Tempt_GND+0.0*Nc_Tempt_GND+1.60219e-19*Nc_Tempt_GND_Tempt_GND)*2.0+(1.60219e-19*Nc_Tempt_GND)*0.0+((1.60219e-19*Nc_Tempt_GND))*0.0+(1.60219e-19*Nc)*0.0)*Ach+(1.60219e-19*Nc_Tempt_GND)*2.0*0.0+(((1.60219e-19*Nc_Tempt_GND))*2.0)*0.0+((1.60219e-19*Nc)*2.0)*0.0))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)+2*(Cins*nVtm)*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)));
  vth_fixed_factor_SI_Tempt_GND_Vdi_si=(m20_logE(((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))*((((Cins*nVtm_Vdi_si))*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*(((0.0)*2.0)*Ach))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))*(((Cins*nVtm_Tempt_GND)*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))+d10_logE0*((+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+Cins*nVtm_Tempt_GND_Vdi_si)/(((1.60219e-19*Nc)*2.0)*Ach)-((Cins*nVtm_Tempt_GND)*(((0.0)*2.0)*Ach)+((Cins*nVtm_Vdi_si))*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach+(Cins*nVtm)*(+(+(+0.0*Nc+0.0*0.0+0.0*Nc_Tempt_GND+1.60219e-19*0.0)*2.0+(1.60219e-19*Nc_Tempt_GND)*0.0+(0.0)*0.0+(1.60219e-19*Nc)*0.0)*Ach+(1.60219e-19*Nc_Tempt_GND)*2.0*0.0+((0.0)*2.0)*0.0+((1.60219e-19*Nc)*2.0)*0.0))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)+2*(Cins*nVtm)*(1.60219e-19*Nc_Tempt_GND)*2.0*Ach*(((0.0)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)));
#endif
vth_fixed_factor_SI_Vdi_si=((Cins*nVtm_Vdi_si)/(((1.60219e-19*Nc)*2.0)*Ach))*d10_logE0;
#if defined(_DERIVATE2)
  vth_fixed_factor_SI_Vdi_si_Tempt_GND=(m20_logE(((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))*((((Cins*nVtm_Tempt_GND))*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))*((Cins*nVtm_Vdi_si)/(((1.60219e-19*Nc)*2.0)*Ach))+d10_logE0*((+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+Cins*nVtm_Vdi_si_Tempt_GND)/(((1.60219e-19*Nc)*2.0)*Ach)-((Cins*nVtm_Vdi_si)*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach)+((Cins*nVtm_Tempt_GND))*0.0+(Cins*nVtm)*(+(+(+0.0*Nc+0.0*Nc_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*2.0+0.0*0.0+((1.60219e-19*Nc_Tempt_GND))*0.0+(1.60219e-19*Nc)*0.0)*Ach+0.0*0.0+(((1.60219e-19*Nc_Tempt_GND))*2.0)*0.0+((1.60219e-19*Nc)*2.0)*0.0))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)+2*(Cins*nVtm)*0.0*((((1.60219e-19*Nc_Tempt_GND))*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)));
  vth_fixed_factor_SI_Vdi_si_Vdi_si=(m20_logE(((Cins*nVtm)/(((1.60219e-19*Nc)*2.0)*Ach)))*((((Cins*nVtm_Vdi_si))*(((1.60219e-19*Nc)*2.0)*Ach)-(Cins*nVtm)*(((0.0)*2.0)*Ach))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach))*((Cins*nVtm_Vdi_si)/(((1.60219e-19*Nc)*2.0)*Ach))+d10_logE0*((+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+Cins*nVtm_Vdi_si_Vdi_si)/(((1.60219e-19*Nc)*2.0)*Ach)-((Cins*nVtm_Vdi_si)*(((0.0)*2.0)*Ach)+((Cins*nVtm_Vdi_si))*0.0+(Cins*nVtm)*(+(+(+0.0*Nc+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*2.0+0.0*0.0+(0.0)*0.0+(1.60219e-19*Nc)*0.0)*Ach+0.0*0.0+((0.0)*2.0)*0.0+((1.60219e-19*Nc)*2.0)*0.0))/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)+2*(Cins*nVtm)*0.0*(((0.0)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)/(((1.60219e-19*Nc)*2.0)*Ach)));
#endif
#endif
vth_fixed_factor_SI=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_exp(d00_exp0,(qdep*rc))
double m00_logE(d00_logE1,(((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_logE(d10_logE1,d00_logE1,(((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vth_fixed_factor_Sub_Tempt_GND=(((((qdep_Tempt_GND*rc*(qdep*rc))+((qdep*rc)*qdep_Tempt_GND*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*d10_logE1+vth_fixed_factor_SI_Tempt_GND);
#if defined(_DERIVATE2)
  vth_fixed_factor_Sub_Tempt_GND_Tempt_GND=(+(m20_logE((((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))*((((((qdep_Tempt_GND*rc)*(qdep*rc))+((qdep*rc)*(qdep_Tempt_GND*rc))))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc)))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*((((qdep_Tempt_GND*rc*(qdep*rc))+((qdep*rc)*qdep_Tempt_GND*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))+d10_logE1*((+(+qdep_Tempt_GND_Tempt_GND*rc+qdep_Tempt_GND*0.0+qdep_Tempt_GND*0.0+qdep*0.0)*(qdep*rc)+qdep_Tempt_GND*rc*(qdep_Tempt_GND*rc)+(qdep_Tempt_GND*rc)*qdep_Tempt_GND*rc+(qdep*rc)*(+qdep_Tempt_GND_Tempt_GND*rc+qdep_Tempt_GND*0.0+qdep_Tempt_GND*0.0+qdep*0.0))/((d00_exp0-(qdep*rc))-1.0)-(((qdep_Tempt_GND*rc*(qdep*rc))+((qdep*rc)*qdep_Tempt_GND*rc))*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc))+((((qdep_Tempt_GND*rc)*(qdep*rc))+((qdep*rc)*(qdep_Tempt_GND*rc))))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc)+((qdep*rc)*(qdep*rc))*(+(+(m20_exp((qdep*rc))*(qdep_Tempt_GND*rc)*qdep_Tempt_GND*rc+d10_exp0*(+qdep_Tempt_GND_Tempt_GND*rc+qdep_Tempt_GND*0.0+qdep_Tempt_GND*0.0+qdep*0.0))-(+qdep_Tempt_GND_Tempt_GND*rc+qdep_Tempt_GND*0.0+qdep_Tempt_GND*0.0+qdep*0.0))-0.0))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)+2*((qdep*rc)*(qdep*rc))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc)*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)))+vth_fixed_factor_SI_Tempt_GND_Tempt_GND);
  vth_fixed_factor_Sub_Tempt_GND_Vdi_si=(+(m20_logE((((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))*((((((qdep_Vdi_si*rc)*(qdep*rc))+((qdep*rc)*(qdep_Vdi_si*rc))))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc)))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*((((qdep_Tempt_GND*rc*(qdep*rc))+((qdep*rc)*qdep_Tempt_GND*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))+d10_logE1*((+(+qdep_Tempt_GND_Vdi_si*rc+qdep_Tempt_GND*0.0+qdep_Vdi_si*0.0+qdep*0.0)*(qdep*rc)+qdep_Tempt_GND*rc*(qdep_Vdi_si*rc)+(qdep_Vdi_si*rc)*qdep_Tempt_GND*rc+(qdep*rc)*(+qdep_Tempt_GND_Vdi_si*rc+qdep_Tempt_GND*0.0+qdep_Vdi_si*0.0+qdep*0.0))/((d00_exp0-(qdep*rc))-1.0)-(((qdep_Tempt_GND*rc*(qdep*rc))+((qdep*rc)*qdep_Tempt_GND*rc))*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc))+((((qdep_Vdi_si*rc)*(qdep*rc))+((qdep*rc)*(qdep_Vdi_si*rc))))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc)+((qdep*rc)*(qdep*rc))*(+(+(m20_exp((qdep*rc))*(qdep_Vdi_si*rc)*qdep_Tempt_GND*rc+d10_exp0*(+qdep_Tempt_GND_Vdi_si*rc+qdep_Tempt_GND*0.0+qdep_Vdi_si*0.0+qdep*0.0))-(+qdep_Tempt_GND_Vdi_si*rc+qdep_Tempt_GND*0.0+qdep_Vdi_si*0.0+qdep*0.0))-0.0))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)+2*((qdep*rc)*(qdep*rc))*(qdep_Tempt_GND*rc*d10_exp0-qdep_Tempt_GND*rc)*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)))+vth_fixed_factor_SI_Tempt_GND_Vdi_si);
#endif
vth_fixed_factor_Sub_Vdi_si=(((((qdep_Vdi_si*rc*(qdep*rc))+((qdep*rc)*qdep_Vdi_si*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*d10_logE1+vth_fixed_factor_SI_Vdi_si);
#if defined(_DERIVATE2)
  vth_fixed_factor_Sub_Vdi_si_Tempt_GND=(+(m20_logE((((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))*((((((qdep_Tempt_GND*rc)*(qdep*rc))+((qdep*rc)*(qdep_Tempt_GND*rc))))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc)))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*((((qdep_Vdi_si*rc*(qdep*rc))+((qdep*rc)*qdep_Vdi_si*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))+d10_logE1*((+(+qdep_Vdi_si_Tempt_GND*rc+qdep_Vdi_si*0.0+qdep_Tempt_GND*0.0+qdep*0.0)*(qdep*rc)+qdep_Vdi_si*rc*(qdep_Tempt_GND*rc)+(qdep_Tempt_GND*rc)*qdep_Vdi_si*rc+(qdep*rc)*(+qdep_Vdi_si_Tempt_GND*rc+qdep_Vdi_si*0.0+qdep_Tempt_GND*0.0+qdep*0.0))/((d00_exp0-(qdep*rc))-1.0)-(((qdep_Vdi_si*rc*(qdep*rc))+((qdep*rc)*qdep_Vdi_si*rc))*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc))+((((qdep_Tempt_GND*rc)*(qdep*rc))+((qdep*rc)*(qdep_Tempt_GND*rc))))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc)+((qdep*rc)*(qdep*rc))*(+(+(m20_exp((qdep*rc))*(qdep_Tempt_GND*rc)*qdep_Vdi_si*rc+d10_exp0*(+qdep_Vdi_si_Tempt_GND*rc+qdep_Vdi_si*0.0+qdep_Tempt_GND*0.0+qdep*0.0))-(+qdep_Vdi_si_Tempt_GND*rc+qdep_Vdi_si*0.0+qdep_Tempt_GND*0.0+qdep*0.0))-0.0))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)+2*((qdep*rc)*(qdep*rc))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc)*((qdep_Tempt_GND*rc)*d10_exp0-(qdep_Tempt_GND*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)))+vth_fixed_factor_SI_Vdi_si_Tempt_GND);
  vth_fixed_factor_Sub_Vdi_si_Vdi_si=(+(m20_logE((((qdep*rc)*(qdep*rc))/((d00_exp0-(qdep*rc))-1.0)))*((((((qdep_Vdi_si*rc)*(qdep*rc))+((qdep*rc)*(qdep_Vdi_si*rc))))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc)))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))*((((qdep_Vdi_si*rc*(qdep*rc))+((qdep*rc)*qdep_Vdi_si*rc))*((d00_exp0-(qdep*rc))-1.0)-((qdep*rc)*(qdep*rc))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0))+d10_logE1*((+(+qdep_Vdi_si_Vdi_si*rc+qdep_Vdi_si*0.0+qdep_Vdi_si*0.0+qdep*0.0)*(qdep*rc)+qdep_Vdi_si*rc*(qdep_Vdi_si*rc)+(qdep_Vdi_si*rc)*qdep_Vdi_si*rc+(qdep*rc)*(+qdep_Vdi_si_Vdi_si*rc+qdep_Vdi_si*0.0+qdep_Vdi_si*0.0+qdep*0.0))/((d00_exp0-(qdep*rc))-1.0)-(((qdep_Vdi_si*rc*(qdep*rc))+((qdep*rc)*qdep_Vdi_si*rc))*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc))+((((qdep_Vdi_si*rc)*(qdep*rc))+((qdep*rc)*(qdep_Vdi_si*rc))))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc)+((qdep*rc)*(qdep*rc))*(+(+(m20_exp((qdep*rc))*(qdep_Vdi_si*rc)*qdep_Vdi_si*rc+d10_exp0*(+qdep_Vdi_si_Vdi_si*rc+qdep_Vdi_si*0.0+qdep_Vdi_si*0.0+qdep*0.0))-(+qdep_Vdi_si_Vdi_si*rc+qdep_Vdi_si*0.0+qdep_Vdi_si*0.0+qdep*0.0))-0.0))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)+2*((qdep*rc)*(qdep*rc))*(qdep_Vdi_si*rc*d10_exp0-qdep_Vdi_si*rc)*((qdep_Vdi_si*rc)*d10_exp0-(qdep_Vdi_si*rc))/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)/((d00_exp0-(qdep*rc))-1.0)))+vth_fixed_factor_SI_Vdi_si_Vdi_si);
#endif
#endif
vth_fixed_factor_Sub=(d00_logE1+vth_fixed_factor_SI);
EXIT_IF_ISNAN((d00_logE1+vth_fixed_factor_SI))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
q0_Tempt_GND=((10.0*nVtm_Tempt_GND)/rc);
#if defined(_DERIVATE2)
  q0_Tempt_GND_Tempt_GND=(+((+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+10.0*nVtm_Tempt_GND_Tempt_GND)/rc-((10.0*nVtm_Tempt_GND)*0.0+((10.0*nVtm_Tempt_GND))*0.0+(10.0*nVtm)*0.0)/rc/rc+2*(10.0*nVtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
  q0_Tempt_GND_Vdi_si=(+((+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+10.0*nVtm_Tempt_GND_Vdi_si)/rc-((10.0*nVtm_Tempt_GND)*0.0+((10.0*nVtm_Vdi_si))*0.0+(10.0*nVtm)*0.0)/rc/rc+2*(10.0*nVtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
#endif
q0_Vdi_si=((10.0*nVtm_Vdi_si)/rc);
#if defined(_DERIVATE2)
  q0_Vdi_si_Tempt_GND=(+((+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+10.0*nVtm_Vdi_si_Tempt_GND)/rc-((10.0*nVtm_Vdi_si)*0.0+((10.0*nVtm_Tempt_GND))*0.0+(10.0*nVtm)*0.0)/rc/rc+2*(10.0*nVtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
  q0_Vdi_si_Vdi_si=(+((+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+10.0*nVtm_Vdi_si_Vdi_si)/rc-((10.0*nVtm_Vdi_si)*0.0+((10.0*nVtm_Vdi_si))*0.0+(10.0*nVtm)*0.0)/rc/rc+2*(10.0*nVtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
#endif
#endif
q0=(((10.0*nVtm)/rc)+(2.0*qbs));
EXIT_IF_ISNAN((((10.0*nVtm)/rc)+(2.0*qbs)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
fieldnormalizationfactor_Tempt_GND=(Vtm_Tempt_GND*Cins/(Weff_UFCM*epssub));
#if defined(_DERIVATE2)
  fieldnormalizationfactor_Tempt_GND_Tempt_GND=((+Vtm_Tempt_GND_Tempt_GND*Cins+Vtm_Tempt_GND*0.0+Vtm_Tempt_GND*0.0+Vtm*0.0)/(Weff_UFCM*epssub)-(Vtm_Tempt_GND*Cins*(0.0)+(Vtm_Tempt_GND*Cins)*0.0+(Vtm*Cins)*(+0.0*epssub+0.0*0.0+0.0*0.0+Weff_UFCM*0.0))/(Weff_UFCM*epssub)/(Weff_UFCM*epssub)+2*(Vtm*Cins)*0.0*(0.0)/(Weff_UFCM*epssub)/(Weff_UFCM*epssub)/(Weff_UFCM*epssub));
#endif
#endif
fieldnormalizationfactor=((Vtm*Cins)/(Weff_UFCM*epssub));
EXIT_IF_ISNAN(((Vtm*Cins)/(Weff_UFCM*epssub)))
{
double m00_sqrt(d00_sqrt0,(2.0*mx))
double m00_pow(d00_pow1,(((((((3.0/4.0)*3.0)*1.05457e-34)*2.0)*3.14159265358979323846)*1.60219e-19)/(4.0*d00_sqrt0)),(2.0/3.0))
auxQMfact=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
{
double m00_pow(d00_pow0,fieldnormalizationfactor,(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,fieldnormalizationfactor,(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
QMFACTORCVfinal_Tempt_GND=((((pModel->QMFACTORCV*auxQMfact)*(d10_pow0*fieldnormalizationfactor_Tempt_GND))*(1/(1.60219e-19*Vtm)))+(((pModel->QMFACTORCV*auxQMfact)*d00_pow0)*(-1*(1.60219e-19*Vtm_Tempt_GND)/(1.60219e-19*Vtm)/(1.60219e-19*Vtm))));
#if defined(_DERIVATE2)
  QMFACTORCVfinal_Tempt_GND_Tempt_GND=(+(+(+0.0*auxQMfact+0.0*0.0+0.0*0.0+pModel->QMFACTORCV*0.0)*d00_pow0+0.0*(d10_pow0*fieldnormalizationfactor_Tempt_GND)+(0.0)*(d10_pow0*fieldnormalizationfactor_Tempt_GND)+(pModel->QMFACTORCV*auxQMfact)*fixme)*(1/(1.60219e-19*Vtm))+((pModel->QMFACTORCV*auxQMfact)*(d10_pow0*fieldnormalizationfactor_Tempt_GND))*(-1*((1.60219e-19*Vtm_Tempt_GND))/(1.60219e-19*Vtm)/(1.60219e-19*Vtm))+((((0.0)*d00_pow0)+((pModel->QMFACTORCV*auxQMfact)*(d10_pow0*fieldnormalizationfactor_Tempt_GND))))*(-1*(1.60219e-19*Vtm_Tempt_GND)/(1.60219e-19*Vtm)/(1.60219e-19*Vtm))+((pModel->QMFACTORCV*auxQMfact)*d00_pow0)*(0.0/(1.60219e-19*Vtm)-(0.0*((1.60219e-19*Vtm_Tempt_GND))+0.0*(1.60219e-19*Vtm_Tempt_GND)+1*(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+1.60219e-19*Vtm_Tempt_GND_Tempt_GND))/(1.60219e-19*Vtm)/(1.60219e-19*Vtm)+2*1*(1.60219e-19*Vtm_Tempt_GND)*((1.60219e-19*Vtm_Tempt_GND))/(1.60219e-19*Vtm)/(1.60219e-19*Vtm)/(1.60219e-19*Vtm)));
#endif
#endif
QMFACTORCVfinal=(((pModel->QMFACTORCV*auxQMfact)*d00_pow0)*(1/(1.60219e-19*Vtm)));
EXIT_IF_ISNAN((((pModel->QMFACTORCV*auxQMfact)*d00_pow0)*(1/(1.60219e-19*Vtm))))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
dvth_vtroll_Tempt_GND=(((-DVT0_i)*Theta_SCE)*(vbi_Tempt_GND-phist_Tempt_GND));
#if defined(_DERIVATE2)
  dvth_vtroll_Tempt_GND_Tempt_GND=(+(+0.0*Theta_SCE+0.0*0.0+0.0*0.0+(-DVT0_i)*0.0)*(vbi-phist)+0.0*(vbi_Tempt_GND-phist_Tempt_GND)+(0.0)*(vbi_Tempt_GND-phist_Tempt_GND)+((-DVT0_i)*Theta_SCE)*(+vbi_Tempt_GND_Tempt_GND-phist_Tempt_GND_Tempt_GND));
#endif
#endif
dvth_vtroll=(((-DVT0_i)*Theta_SCE)*(vbi-phist));
EXIT_IF_ISNAN((((-DVT0_i)*Theta_SCE)*(vbi-phist)))
{
double m00_pow(d00_pow0,vdsx,DVTP1_i)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,vdsx,DVTP1_i)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
dvth_dibl_Tempt_GND=(-ETA0_a_Tempt_GND)*Theta_DIBL*vdsx;
#if defined(_DERIVATE2)
  dvth_dibl_Tempt_GND_Tempt_GND=(+(+(+0.0*Theta_DIBL+(-ETA0_a_Tempt_GND)*0.0+(-ETA0_a_Tempt_GND)*0.0+(-ETA0_a)*0.0)*vdsx+(-ETA0_a_Tempt_GND)*Theta_DIBL*0.0+((-ETA0_a_Tempt_GND)*Theta_DIBL)*0.0+((-ETA0_a)*Theta_DIBL)*0.0)+(+(+0.0*Theta_DITS+0.0*0.0+0.0*0.0+DVTP0_i*0.0)*d00_pow0+0.0*0.0+(0.0)*0.0+(DVTP0_i*Theta_DITS)*fixme));
  dvth_dibl_Tempt_GND_Vdi_si=(+(+(+0.0*Theta_DIBL+(-ETA0_a_Tempt_GND)*0.0+(-ETA0_a_Vdi_si)*0.0+(-ETA0_a)*0.0)*vdsx+(-ETA0_a_Tempt_GND)*Theta_DIBL*vdsx_Vdi_si+((-ETA0_a_Vdi_si)*Theta_DIBL)*0.0+((-ETA0_a)*Theta_DIBL)*0.0)+(+(+0.0*Theta_DITS+0.0*0.0+0.0*0.0+DVTP0_i*0.0)*d00_pow0+0.0*(d10_pow0*vdsx_Vdi_si)+(0.0)*0.0+(DVTP0_i*Theta_DITS)*fixme));
#endif
dvth_dibl_Vdi_si=((((-ETA0_a_Vdi_si)*Theta_DIBL*vdsx)+(((-ETA0_a)*Theta_DIBL)*vdsx_Vdi_si))+((DVTP0_i*Theta_DITS)*(d10_pow0*vdsx_Vdi_si)));
#if defined(_DERIVATE2)
  dvth_dibl_Vdi_si_Tempt_GND=(+(+(+0.0*Theta_DIBL+(-ETA0_a_Vdi_si)*0.0+(-ETA0_a_Tempt_GND)*0.0+(-ETA0_a)*0.0)*vdsx+(-ETA0_a_Vdi_si)*Theta_DIBL*0.0+((-ETA0_a_Tempt_GND)*Theta_DIBL)*vdsx_Vdi_si+((-ETA0_a)*Theta_DIBL)*0.0)+(+(+0.0*Theta_DITS+0.0*0.0+0.0*0.0+DVTP0_i*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*vdsx_Vdi_si)+(DVTP0_i*Theta_DITS)*fixme));
  dvth_dibl_Vdi_si_Vdi_si=(+(+(+0.0*Theta_DIBL+(-ETA0_a_Vdi_si)*0.0+(-ETA0_a_Vdi_si)*0.0+(-ETA0_a)*0.0)*vdsx+(-ETA0_a_Vdi_si)*Theta_DIBL*vdsx_Vdi_si+((-ETA0_a_Vdi_si)*Theta_DIBL)*vdsx_Vdi_si+((-ETA0_a)*Theta_DIBL)*vdsx_Vdi_si_Vdi_si)+(+(+0.0*Theta_DITS+0.0*0.0+0.0*0.0+DVTP0_i*0.0)*d00_pow0+0.0*(d10_pow0*vdsx_Vdi_si)+(0.0)*(d10_pow0*vdsx_Vdi_si)+(DVTP0_i*Theta_DITS)*fixme));
#endif
#endif
dvth_dibl=((((-ETA0_a)*Theta_DIBL)*vdsx)+((DVTP0_i*Theta_DITS)*d00_pow0));
EXIT_IF_ISNAN(((((-ETA0_a)*Theta_DIBL)*vdsx)+((DVTP0_i*Theta_DITS)*d00_pow0)))
}
{
double m00_sqrt(d00_sqrt0,phist)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,phist)
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
dvth_rsce_Tempt_GND=((K1RSCE_i*Theta_RSCE)*phist_Tempt_GND*d10_sqrt0);
#if defined(_DERIVATE2)
  dvth_rsce_Tempt_GND_Tempt_GND=(+(+0.0*Theta_RSCE+0.0*0.0+0.0*0.0+K1RSCE_i*0.0)*d00_sqrt0+0.0*phist_Tempt_GND*d10_sqrt0+(0.0)*phist_Tempt_GND*d10_sqrt0+(K1RSCE_i*Theta_RSCE)*(m20_sqrt(phist)*phist_Tempt_GND*phist_Tempt_GND+d10_sqrt0*phist_Tempt_GND_Tempt_GND));
#endif
#endif
dvth_rsce=((K1RSCE_i*Theta_RSCE)*d00_sqrt0);
EXIT_IF_ISNAN(((K1RSCE_i*Theta_RSCE)*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
dvth_all_Tempt_GND=((((dvth_vtroll_Tempt_GND+dvth_dibl_Tempt_GND)+dvth_rsce_Tempt_GND)+dvth_temp_Tempt_GND)+DVTSHIFT_a_Tempt_GND);
#if defined(_DERIVATE2)
  dvth_all_Tempt_GND_Tempt_GND=(+(+(+(+dvth_vtroll_Tempt_GND_Tempt_GND+dvth_dibl_Tempt_GND_Tempt_GND)+dvth_rsce_Tempt_GND_Tempt_GND)+dvth_temp_Tempt_GND_Tempt_GND)+DVTSHIFT_a_Tempt_GND_Tempt_GND);
  dvth_all_Tempt_GND_Vdi_si=(+(+(+(+0.0+dvth_dibl_Tempt_GND_Vdi_si)+0.0)+0.0)+DVTSHIFT_a_Tempt_GND_Vdi_si);
#endif
dvth_all_Vdi_si=(dvth_dibl_Vdi_si+DVTSHIFT_a_Vdi_si);
#if defined(_DERIVATE2)
  dvth_all_Vdi_si_Tempt_GND=(+(+(+(+0.0+dvth_dibl_Vdi_si_Tempt_GND)+0.0)+0.0)+DVTSHIFT_a_Vdi_si_Tempt_GND);
  dvth_all_Vdi_si_Vdi_si=(+(+(+(+0.0+dvth_dibl_Vdi_si_Vdi_si)+0.0)+0.0)+DVTSHIFT_a_Vdi_si_Vdi_si);
#endif
#endif
dvth_all=((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_a);
EXIT_IF_ISNAN(((((dvth_vtroll+dvth_dibl)+dvth_rsce)+dvth_temp)+DVTSHIFT_a))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
vgsfb_Vge_si=vgsfb_Vge_si;
#if defined(_DERIVATE2)
  vgsfb_Vge_si_Vge_si=(+vgsfb_Vge_si_Vge_si-0.0);
  vgsfb_Vge_si_Vdi_si=(+vgsfb_Vge_si_Vdi_si-0.0);
  vgsfb_Vge_si_Tempt_GND=(+vgsfb_Vge_si_Tempt_GND-0.0);
#endif
vgsfb_Vdi_si=(vgsfb_Vdi_si-dvth_all_Vdi_si);
#if defined(_DERIVATE2)
  vgsfb_Vdi_si_Vge_si=(+vgsfb_Vdi_si_Vge_si-0.0);
  vgsfb_Vdi_si_Vdi_si=(+vgsfb_Vdi_si_Vdi_si-dvth_all_Vdi_si_Vdi_si);
  vgsfb_Vdi_si_Tempt_GND=(+vgsfb_Vdi_si_Tempt_GND-dvth_all_Vdi_si_Tempt_GND);
#endif
vgsfb_Tempt_GND=(vgsfb_Tempt_GND-dvth_all_Tempt_GND);
#if defined(_DERIVATE2)
  vgsfb_Tempt_GND_Vge_si=(+vgsfb_Tempt_GND_Vge_si-0.0);
  vgsfb_Tempt_GND_Vdi_si=(+vgsfb_Tempt_GND_Vdi_si-dvth_all_Tempt_GND_Vdi_si);
  vgsfb_Tempt_GND_Tempt_GND=(+vgsfb_Tempt_GND_Tempt_GND-dvth_all_Tempt_GND_Tempt_GND);
#endif
#endif
vgsfb=(vgsfb-dvth_all);
EXIT_IF_ISNAN((vgsfb-dvth_all))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
beta0_Tempt_GND=(u0_a_Tempt_GND*cox*Weff0/Leff);
#if defined(_DERIVATE2)
  beta0_Tempt_GND_Tempt_GND=((+(+u0_a_Tempt_GND_Tempt_GND*cox+u0_a_Tempt_GND*0.0+u0_a_Tempt_GND*0.0+u0_a*0.0)*Weff0+u0_a_Tempt_GND*cox*0.0+(u0_a_Tempt_GND*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Tempt_GND*cox*Weff0*0.0+((u0_a_Tempt_GND*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  beta0_Tempt_GND_Vdi_si=((+(+u0_a_Tempt_GND_Vdi_si*cox+u0_a_Tempt_GND*0.0+u0_a_Vdi_si*0.0+u0_a*0.0)*Weff0+u0_a_Tempt_GND*cox*0.0+(u0_a_Vdi_si*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Tempt_GND*cox*Weff0*0.0+((u0_a_Vdi_si*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
beta0_Vdi_si=(u0_a_Vdi_si*cox*Weff0/Leff);
#if defined(_DERIVATE2)
  beta0_Vdi_si_Tempt_GND=((+(+u0_a_Vdi_si_Tempt_GND*cox+u0_a_Vdi_si*0.0+u0_a_Tempt_GND*0.0+u0_a*0.0)*Weff0+u0_a_Vdi_si*cox*0.0+(u0_a_Tempt_GND*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Vdi_si*cox*Weff0*0.0+((u0_a_Tempt_GND*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  beta0_Vdi_si_Vdi_si=((+(+u0_a_Vdi_si_Vdi_si*cox+u0_a_Vdi_si*0.0+u0_a_Vdi_si*0.0+u0_a*0.0)*Weff0+u0_a_Vdi_si*cox*0.0+(u0_a_Vdi_si*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Vdi_si*cox*Weff0*0.0+((u0_a_Vdi_si*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
#endif
beta0=(((u0_a*cox)*Weff0)/Leff);
EXIT_IF_ISNAN((((u0_a*cox)*Weff0)/Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=(-((nVtm_Vdi_si*bsimcmg_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN))))+(nVtm*bsimcmg_d_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)),(-((2.0*cox)*pModel->Imin)*((beta0_Vdi_si*nVtm)+(beta0*nVtm_Vdi_si))*1.60219e-19*Nc*pInst->TFIN/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN))))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-(dvch_qm_Tempt_GND+((nVtm_Tempt_GND*bsimcmg_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN))))+(nVtm*bsimcmg_d_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)),(-((2.0*cox)*pModel->Imin)*((((beta0_Tempt_GND*nVtm)+(beta0*nVtm_Tempt_GND))*1.60219e-19*Nc)+(((beta0*nVtm)*1.60219e-19)*Nc_Tempt_GND))*pInst->TFIN/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)))))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=(-(dvch_qm+(nVtm*bsimcmg_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN))))));
EXIT_IF_ISNAN((-(dvch_qm+(nVtm*bsimcmg_lln((((2.0*cox)*pModel->Imin)/((((beta0*nVtm)*1.60219e-19)*Nc)*pInst->TFIN)))))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=(vgsfb_Vge_si+T0_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0+0.0)+0.0);
  T1_Vge_si_Vsi_s=(+(+0.0+0.0)+0.0);
  T1_Vge_si_Vge_di=(+(+0.0+T0_Vge_si_Vge_di)+0.0);
  T1_Vge_si_Vge_e=(+(+0.0+T0_Vge_si_Vge_e)+0.0);
  T1_Vge_si_Ve_si=(+(+0.0+T0_Vge_si_Ve_si)+0.0);
  T1_Vge_si_Ve_di=(+(+0.0+T0_Vge_si_Ve_di)+0.0);
  T1_Vge_si_Vge_si=(+(+vgsfb_Vge_si_Vge_si+T0_Vge_si_Vge_si)+0.0);
  T1_Vge_si_Vdi_si=(+(+vgsfb_Vge_si_Vdi_si+T0_Vge_si_Vdi_si)+0.0);
  T1_Vge_si_Tempt_GND=(+(+vgsfb_Vge_si_Tempt_GND+T0_Vge_si_Tempt_GND)+0.0);
#endif
T1_Vdi_si=(vgsfb_Vdi_si+T0_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0+0.0)+0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0+0.0)+0.0);
  T1_Vdi_si_Vge_di=(+(+0.0+T0_Vdi_si_Vge_di)+0.0);
  T1_Vdi_si_Vge_e=(+(+0.0+T0_Vdi_si_Vge_e)+0.0);
  T1_Vdi_si_Ve_si=(+(+0.0+T0_Vdi_si_Ve_si)+0.0);
  T1_Vdi_si_Ve_di=(+(+0.0+T0_Vdi_si_Ve_di)+0.0);
  T1_Vdi_si_Vge_si=(+(+vgsfb_Vdi_si_Vge_si+T0_Vdi_si_Vge_si)+0.0);
  T1_Vdi_si_Vdi_si=(+(+vgsfb_Vdi_si_Vdi_si+T0_Vdi_si_Vdi_si)+0.0);
  T1_Vdi_si_Tempt_GND=(+(+vgsfb_Vdi_si_Tempt_GND+T0_Vdi_si_Tempt_GND)+0.0);
#endif
T1_Tempt_GND=(vgsfb_Tempt_GND+T0_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0+0.0)+0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0+0.0)+0.0);
  T1_Tempt_GND_Vge_di=(+(+0.0+T0_Tempt_GND_Vge_di)+0.0);
  T1_Tempt_GND_Vge_e=(+(+0.0+T0_Tempt_GND_Vge_e)+0.0);
  T1_Tempt_GND_Ve_si=(+(+0.0+T0_Tempt_GND_Ve_si)+0.0);
  T1_Tempt_GND_Ve_di=(+(+0.0+T0_Tempt_GND_Ve_di)+0.0);
  T1_Tempt_GND_Vge_si=(+(+vgsfb_Tempt_GND_Vge_si+T0_Tempt_GND_Vge_si)+0.0);
  T1_Tempt_GND_Vdi_si=(+(+vgsfb_Tempt_GND_Vdi_si+T0_Tempt_GND_Vdi_si)+0.0);
  T1_Tempt_GND_Tempt_GND=(+(+vgsfb_Tempt_GND_Tempt_GND+T0_Tempt_GND_Tempt_GND)+0.0);
#endif
#endif
T1=((vgsfb+T0)+pModel->DELVTRAND);
EXIT_IF_ISNAN(((vgsfb+T0)+pModel->DELVTRAND))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vgsfbeff_Vge_si=(bsimcmg_d_hypsmooth(T1,1.0e-4,T1_Vge_si,0.0)-T0_Vge_si);
#if defined(_DERIVATE2)
  vgsfbeff_Vge_si_Vge_si=(+0.0-T0_Vge_si_Vge_si);
  vgsfbeff_Vge_si_Vdi_si=(+0.0-T0_Vge_si_Vdi_si);
  vgsfbeff_Vge_si_Tempt_GND=(+0.0-T0_Vge_si_Tempt_GND);
#endif
vgsfbeff_Vdi_si=(bsimcmg_d_hypsmooth(T1,1.0e-4,T1_Vdi_si,0.0)-T0_Vdi_si);
#if defined(_DERIVATE2)
  vgsfbeff_Vdi_si_Vge_si=(+0.0-T0_Vdi_si_Vge_si);
  vgsfbeff_Vdi_si_Vdi_si=(+0.0-T0_Vdi_si_Vdi_si);
  vgsfbeff_Vdi_si_Tempt_GND=(+0.0-T0_Vdi_si_Tempt_GND);
#endif
vgsfbeff_Tempt_GND=(bsimcmg_d_hypsmooth(T1,1.0e-4,T1_Tempt_GND,0.0)-T0_Tempt_GND);
#if defined(_DERIVATE2)
  vgsfbeff_Tempt_GND_Vge_si=(+0.0-T0_Tempt_GND_Vge_si);
  vgsfbeff_Tempt_GND_Vdi_si=(+0.0-T0_Tempt_GND_Vdi_si);
  vgsfbeff_Tempt_GND_Tempt_GND=(+0.0-T0_Tempt_GND_Tempt_GND);
#endif
#endif
vgsfbeff=(bsimcmg_hypsmooth(T1,1.0e-4)-T0);
EXIT_IF_ISNAN((bsimcmg_hypsmooth(T1,1.0e-4)-T0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vch_Vdi_si=0.0;
#if defined(_DERIVATE2)
  vch_Vdi_si_Vdi_si=0.0;
  vch_Vdi_si_Ve_si=0.0;
  vch_Vdi_si_Ve_di=0.0;
  vch_Vdi_si_Vge_si=0.0;
  vch_Vdi_si_Tempt_GND=0.0;
#endif
vch_Ve_si=0.0;
#if defined(_DERIVATE2)
  vch_Ve_si_Vdi_si=0.0;
  vch_Ve_si_Ve_si=0.0;
  vch_Ve_si_Ve_di=0.0;
  vch_Ve_si_Vge_si=0.0;
  vch_Ve_si_Tempt_GND=0.0;
#endif
vch_Ve_di=0.0;
#if defined(_DERIVATE2)
  vch_Ve_di_Vdi_si=0.0;
  vch_Ve_di_Ve_si=0.0;
  vch_Ve_di_Ve_di=0.0;
  vch_Ve_di_Vge_si=0.0;
  vch_Ve_di_Tempt_GND=0.0;
#endif
vch_Vge_si=0.0;
#if defined(_DERIVATE2)
  vch_Vge_si_Vdi_si=0.0;
  vch_Vge_si_Ve_si=0.0;
  vch_Vge_si_Ve_di=0.0;
  vch_Vge_si_Vge_si=0.0;
  vch_Vge_si_Tempt_GND=0.0;
#endif
vch_Tempt_GND=dvch_qm_Tempt_GND;
#if defined(_DERIVATE2)
  vch_Tempt_GND_Vdi_si=(+0.0+0.0);
  vch_Tempt_GND_Ve_si=(+0.0+0.0);
  vch_Tempt_GND_Ve_di=(+0.0+0.0);
  vch_Tempt_GND_Vge_si=(+0.0+0.0);
  vch_Tempt_GND_Tempt_GND=(+0.0+dvch_qm_Tempt_GND_Tempt_GND);
#endif
#endif
vch=(+dvch_qm);
EXIT_IF_ISNAN((+dvch_qm))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,(vch_Ve_si-ves_Ve_si),0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,(vch_Ve_di-ves_Ve_di),0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,((2.0*phib_Tempt_GND)+vch_Tempt_GND),0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth((((2.0*phib)+vch)-ves),0.1);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((((2.0*phib)+vch)-ves),0.1))
{
double m00_sqrt(d00_sqrt0,T1)
double m00_sqrt(d00_sqrt1,(2.0*phib))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T1)
double m10_sqrt(d10_sqrt1,d00_sqrt1,(2.0*phib))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(((-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1))+(((-K1_t)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vdi_d)-0.0));
  T3_Vdi_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vsi_s)-0.0));
  T3_Vdi_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_di)-0.0));
  T3_Vdi_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_e)-0.0));
  T3_Vdi_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vdi_si)-0.0));
  T3_Vdi_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Ve_si)-0.0));
  T3_Vdi_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Ve_di)-0.0));
  T3_Vdi_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_si)-0.0));
  T3_Vdi_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Tempt_GND)-0.0));
#endif
T3_Ve_si=(((-K1_t)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vdi_d)-0.0));
  T3_Ve_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vsi_s)-0.0));
  T3_Ve_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_di)-0.0));
  T3_Ve_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_e)-0.0));
  T3_Ve_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vdi_si)-0.0));
  T3_Ve_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Ve_si)-0.0));
  T3_Ve_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Ve_si+d10_sqrt0*T1_Ve_si_Ve_di)-0.0));
  T3_Ve_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_si)-0.0));
  T3_Ve_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Ve_si+d10_sqrt0*T1_Ve_si_Tempt_GND)-0.0));
#endif
T3_Ve_di=(((-K1_t)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vdi_d)-0.0));
  T3_Ve_di_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vsi_s)-0.0));
  T3_Ve_di_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_di)-0.0));
  T3_Ve_di_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_e)-0.0));
  T3_Ve_di_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vdi_si)-0.0));
  T3_Ve_di_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Ve_si)-0.0));
  T3_Ve_di_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Ve_di+d10_sqrt0*T1_Ve_di_Ve_di)-0.0));
  T3_Ve_di_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_si)-0.0));
  T3_Ve_di_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Ve_di+d10_sqrt0*T1_Ve_di_Tempt_GND)-0.0));
#endif
T3_Vge_si=(((-K1_t)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vdi_d)-0.0));
  T3_Vge_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vsi_s)-0.0));
  T3_Vge_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_di)-0.0));
  T3_Vge_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_e)-0.0));
  T3_Vge_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vdi_si)-0.0));
  T3_Vge_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Ve_si)-0.0));
  T3_Vge_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Vge_si+d10_sqrt0*T1_Vge_si_Ve_di)-0.0));
  T3_Vge_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_si)-0.0));
  T3_Vge_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Vge_si+d10_sqrt0*T1_Vge_si_Tempt_GND)-0.0));
#endif
T3_Tempt_GND=(((((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1))+(((-K1_t)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vdi_d)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vsi_s=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vsi_s)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_di=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_di)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_e=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_e)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vdi_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vdi_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Ve_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Ve_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Ve_di=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Ve_di)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Tempt_GND=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Tempt_GND)-(m20_sqrt((2.0*phib))*((2.0*phib_Tempt_GND))*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*phib_Tempt_GND+0.0*phib_Tempt_GND+2.0*phib_Tempt_GND_Tempt_GND))));
#endif
#endif
T3=(((-K1_t)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1));
EXIT_IF_ISNAN((((-K1_t)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)))
}
{
double m00_pow(d00_pow0,(-qdep),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-qdep),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(-T3_Ve_si);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+(+(+0.0-T3_Ve_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vge_e=(+(+(+0.0-T3_Ve_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Ve_si=(+(+(+0.0-T3_Ve_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Ve_di=(+(+(+0.0-T3_Ve_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vge_si=(+(+(+0.0-T3_Ve_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vdi_si=(+(+(+0.0-T3_Ve_si_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Tempt_GND=(+(+(+0.0-T3_Ve_si_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Ve_di=(-T3_Ve_di);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+(+(+0.0-T3_Ve_di_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vge_e=(+(+(+0.0-T3_Ve_di_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Ve_si=(+(+(+0.0-T3_Ve_di_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Ve_di=(+(+(+0.0-T3_Ve_di_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vge_si=(+(+(+0.0-T3_Ve_di_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vdi_si=(+(+(+0.0-T3_Ve_di_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Tempt_GND=(+(+(+0.0-T3_Ve_di_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Vge_si=(-T3_Vge_si);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+(+(+0.0-T3_Vge_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vge_e=(+(+(+0.0-T3_Vge_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Ve_si=(+(+(+0.0-T3_Vge_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Ve_di=(+(+(+0.0-T3_Vge_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vge_si=(+(+(+0.0-T3_Vge_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vdi_si=(+(+(+0.0-T3_Vge_si_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Tempt_GND=(+(+(+0.0-T3_Vge_si_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Vdi_si=((((-qdep_Vdi_si)-T3_Vdi_si)+vth_fixed_factor_Sub_Vdi_si)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Vdi_si))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+(+0.0-T3_Vdi_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_e=(+(+(+0.0-T3_Vdi_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_si=(+(+(+0.0-T3_Vdi_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_di=(+(+(+0.0-T3_Vdi_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_si=(+(+(+0.0-T3_Vdi_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vdi_si=(+(+(+0.0-T3_Vdi_si_Vdi_si)+vth_fixed_factor_Sub_Vdi_si_Vdi_si)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Tempt_GND=(+(+(+0.0-T3_Vdi_si_Tempt_GND)+vth_fixed_factor_Sub_Vdi_si_Tempt_GND)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
#endif
T0_Tempt_GND=((((-qdep_Tempt_GND)-T3_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND)+((QMFACTORCVfinal_Tempt_GND*d00_pow0)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Tempt_GND)))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+(+0.0-T3_Tempt_GND_Vge_di)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_e=(+(+(+0.0-T3_Tempt_GND_Vge_e)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_si=(+(+(+0.0-T3_Tempt_GND_Ve_si)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_di=(+(+(+0.0-T3_Tempt_GND_Ve_di)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_si=(+(+(+0.0-T3_Tempt_GND_Vge_si)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vdi_si=(+(+(+0.0-T3_Tempt_GND_Vdi_si)+vth_fixed_factor_Sub_Tempt_GND_Vdi_si)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Tempt_GND=(+(+(+0.0-T3_Tempt_GND_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND_Tempt_GND)+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
#endif
#endif
T0=((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0));
EXIT_IF_ISNAN(((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-T3_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0-T3_Ve_si_Vdi_d)+0.0);
  T1_Ve_si_Vsi_s=(+(+0.0-T3_Ve_si_Vsi_s)+0.0);
  T1_Ve_si_Vge_di=(+(+0.0-T3_Ve_si_Vge_di)+0.0);
  T1_Ve_si_Vge_e=(+(+0.0-T3_Ve_si_Vge_e)+0.0);
  T1_Ve_si_Ve_si=(+(+0.0-T3_Ve_si_Ve_si)+0.0);
  T1_Ve_si_Ve_di=(+(+0.0-T3_Ve_si_Ve_di)+0.0);
  T1_Ve_si_Vge_si=(+(+0.0-T3_Ve_si_Vge_si)+0.0);
  T1_Ve_si_Vdi_si=(+(+0.0-T3_Ve_si_Vdi_si)+0.0);
  T1_Ve_si_Tempt_GND=(+(+0.0-T3_Ve_si_Tempt_GND)+0.0);
#endif
T1_Ve_di=(-T3_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0-T3_Ve_di_Vdi_d)+0.0);
  T1_Ve_di_Vsi_s=(+(+0.0-T3_Ve_di_Vsi_s)+0.0);
  T1_Ve_di_Vge_di=(+(+0.0-T3_Ve_di_Vge_di)+0.0);
  T1_Ve_di_Vge_e=(+(+0.0-T3_Ve_di_Vge_e)+0.0);
  T1_Ve_di_Ve_si=(+(+0.0-T3_Ve_di_Ve_si)+0.0);
  T1_Ve_di_Ve_di=(+(+0.0-T3_Ve_di_Ve_di)+0.0);
  T1_Ve_di_Vge_si=(+(+0.0-T3_Ve_di_Vge_si)+0.0);
  T1_Ve_di_Vdi_si=(+(+0.0-T3_Ve_di_Vdi_si)+0.0);
  T1_Ve_di_Tempt_GND=(+(+0.0-T3_Ve_di_Tempt_GND)+0.0);
#endif
T1_Vge_si=(-T3_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0-T3_Vge_si_Vdi_d)+0.0);
  T1_Vge_si_Vsi_s=(+(+0.0-T3_Vge_si_Vsi_s)+0.0);
  T1_Vge_si_Vge_di=(+(+0.0-T3_Vge_si_Vge_di)+0.0);
  T1_Vge_si_Vge_e=(+(+0.0-T3_Vge_si_Vge_e)+0.0);
  T1_Vge_si_Ve_si=(+(+0.0-T3_Vge_si_Ve_si)+0.0);
  T1_Vge_si_Ve_di=(+(+0.0-T3_Vge_si_Ve_di)+0.0);
  T1_Vge_si_Vge_si=(+(+0.0-T3_Vge_si_Vge_si)+0.0);
  T1_Vge_si_Vdi_si=(+(+0.0-T3_Vge_si_Vdi_si)+0.0);
  T1_Vge_si_Tempt_GND=(+(+0.0-T3_Vge_si_Tempt_GND)+0.0);
#endif
T1_Vdi_si=(((-qdep_Vdi_si)-T3_Vdi_si)+vth_fixed_factor_SI_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0-T3_Vdi_si_Vdi_d)+0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0-T3_Vdi_si_Vsi_s)+0.0);
  T1_Vdi_si_Vge_di=(+(+0.0-T3_Vdi_si_Vge_di)+0.0);
  T1_Vdi_si_Vge_e=(+(+0.0-T3_Vdi_si_Vge_e)+0.0);
  T1_Vdi_si_Ve_si=(+(+0.0-T3_Vdi_si_Ve_si)+0.0);
  T1_Vdi_si_Ve_di=(+(+0.0-T3_Vdi_si_Ve_di)+0.0);
  T1_Vdi_si_Vge_si=(+(+0.0-T3_Vdi_si_Vge_si)+0.0);
  T1_Vdi_si_Vdi_si=(+(+0.0-T3_Vdi_si_Vdi_si)+vth_fixed_factor_SI_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(+0.0-T3_Vdi_si_Tempt_GND)+vth_fixed_factor_SI_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(((-qdep_Tempt_GND)-T3_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0-T3_Tempt_GND_Vdi_d)+0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0-T3_Tempt_GND_Vsi_s)+0.0);
  T1_Tempt_GND_Vge_di=(+(+0.0-T3_Tempt_GND_Vge_di)+0.0);
  T1_Tempt_GND_Vge_e=(+(+0.0-T3_Tempt_GND_Vge_e)+0.0);
  T1_Tempt_GND_Ve_si=(+(+0.0-T3_Tempt_GND_Ve_si)+0.0);
  T1_Tempt_GND_Ve_di=(+(+0.0-T3_Tempt_GND_Ve_di)+0.0);
  T1_Tempt_GND_Vge_si=(+(+0.0-T3_Tempt_GND_Vge_si)+0.0);
  T1_Tempt_GND_Vdi_si=(+(+0.0-T3_Tempt_GND_Vdi_si)+vth_fixed_factor_SI_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(+0.0-T3_Tempt_GND_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(((-qdep)-T3)+vth_fixed_factor_SI);
EXIT_IF_ISNAN((((-qdep)-T3)+vth_fixed_factor_SI))
}
else
{
{
double m00_pow(d00_pow0,(-qdep),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-qdep),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=(((-qdep_Vdi_si)+vth_fixed_factor_Sub_Vdi_si)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Vdi_si))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_e=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_si=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_di=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_si=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vdi_si=(+(+0.0+vth_fixed_factor_Sub_Vdi_si_Vdi_si)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Tempt_GND=(+(+0.0+vth_fixed_factor_Sub_Vdi_si_Tempt_GND)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
#endif
T0_Tempt_GND=(((-qdep_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND)+((QMFACTORCVfinal_Tempt_GND*d00_pow0)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Tempt_GND)))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_e=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_si=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_di=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_si=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vdi_si=(+(+0.0+vth_fixed_factor_Sub_Tempt_GND_Vdi_si)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Tempt_GND=(+(+0.0+vth_fixed_factor_Sub_Tempt_GND_Tempt_GND)+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
#endif
#endif
T0=(((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0));
EXIT_IF_ISNAN((((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=((-qdep_Vdi_si)+vth_fixed_factor_SI_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0+0.0);
  T1_Vdi_si_Vsi_s=(+0.0+0.0);
  T1_Vdi_si_Vge_di=(+0.0+0.0);
  T1_Vdi_si_Vge_e=(+0.0+0.0);
  T1_Vdi_si_Ve_si=(+0.0+0.0);
  T1_Vdi_si_Ve_di=(+0.0+0.0);
  T1_Vdi_si_Vge_si=(+0.0+0.0);
  T1_Vdi_si_Vdi_si=(+0.0+vth_fixed_factor_SI_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+0.0+vth_fixed_factor_SI_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=((-qdep_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0+0.0);
  T1_Tempt_GND_Vsi_s=(+0.0+0.0);
  T1_Tempt_GND_Vge_di=(+0.0+0.0);
  T1_Tempt_GND_Vge_e=(+0.0+0.0);
  T1_Tempt_GND_Ve_si=(+0.0+0.0);
  T1_Tempt_GND_Ve_di=(+0.0+0.0);
  T1_Tempt_GND_Vge_si=(+0.0+0.0);
  T1_Tempt_GND_Vdi_si=(+0.0+vth_fixed_factor_SI_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+0.0+vth_fixed_factor_SI_Tempt_GND_Tempt_GND);
#endif
#endif
T1=((-qdep)+vth_fixed_factor_SI);
EXIT_IF_ISNAN(((-qdep)+vth_fixed_factor_SI))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=((vgsfbeff_Vge_si-vch_Vge_si)/nVtm);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_si=((+vgsfbeff_Vge_si_Vge_si-vch_Vge_si_Vge_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Ve_si=((+0.0-vch_Vge_si_Ve_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(-vch_Ve_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Ve_di=((+0.0-vch_Vge_si_Ve_di)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(-vch_Ve_di)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vdi_si=((+vgsfbeff_Vge_si_Vdi_si-vch_Vge_si_Vdi_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Vge_si_Tempt_GND=((+vgsfbeff_Vge_si_Tempt_GND-vch_Vge_si_Tempt_GND)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=(((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm-(vgsfbeff-vch)*nVtm_Vdi_si)/nVtm/nVtm);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_si=((+vgsfbeff_Vdi_si_Vge_si-vch_Vdi_si_Vge_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Ve_si=((+0.0-vch_Vdi_si_Ve_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(-vch_Ve_si)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Ve_di=((+0.0-vch_Vdi_si_Ve_di)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(-vch_Ve_di)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vdi_si=((+vgsfbeff_Vdi_si_Vdi_si-vch_Vdi_si_Vdi_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Vdi_si+(vgsfbeff-vch)*nVtm_Vdi_si_Vdi_si)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Vdi_si_Tempt_GND=((+vgsfbeff_Vdi_si_Tempt_GND-vch_Vdi_si_Tempt_GND)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Vdi_si+(vgsfbeff-vch)*nVtm_Vdi_si_Tempt_GND)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Tempt_GND=(((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm-(vgsfbeff-vch)*nVtm_Tempt_GND)/nVtm/nVtm);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_si=((+vgsfbeff_Tempt_GND_Vge_si-vch_Tempt_GND_Vge_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Ve_si=((+0.0-vch_Tempt_GND_Ve_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(-vch_Ve_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Ve_di=((+0.0-vch_Tempt_GND_Ve_di)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(-vch_Ve_di)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vdi_si=((+vgsfbeff_Tempt_GND_Vdi_si-vch_Tempt_GND_Vdi_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*nVtm_Tempt_GND_Vdi_si)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Tempt_GND=((+vgsfbeff_Tempt_GND_Tempt_GND-vch_Tempt_GND_Tempt_GND)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Tempt_GND+(vgsfbeff-vch)*nVtm_Tempt_GND_Tempt_GND)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
#endif
T2=((vgsfbeff-vch)/nVtm);
EXIT_IF_ISNAN(((vgsfbeff-vch)/nVtm))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
F0_Vge_si=((-T2_Vge_si)+T1_Vge_si);
#if defined(_DERIVATE2)
  F0_Vge_si_Vge_si=(+0.0+T1_Vge_si_Vge_si);
  F0_Vge_si_Ve_si=(+0.0+T1_Vge_si_Ve_si);
  F0_Vge_si_Ve_di=(+0.0+T1_Vge_si_Ve_di);
  F0_Vge_si_Vdi_si=(+0.0+T1_Vge_si_Vdi_si);
  F0_Vge_si_Tempt_GND=(+0.0+T1_Vge_si_Tempt_GND);
#endif
F0_Ve_si=((-T2_Ve_si)+T1_Ve_si);
#if defined(_DERIVATE2)
  F0_Ve_si_Vge_si=(+0.0+T1_Ve_si_Vge_si);
  F0_Ve_si_Ve_si=(+0.0+T1_Ve_si_Ve_si);
  F0_Ve_si_Ve_di=(+0.0+T1_Ve_si_Ve_di);
  F0_Ve_si_Vdi_si=(+0.0+T1_Ve_si_Vdi_si);
  F0_Ve_si_Tempt_GND=(+0.0+T1_Ve_si_Tempt_GND);
#endif
F0_Ve_di=((-T2_Ve_di)+T1_Ve_di);
#if defined(_DERIVATE2)
  F0_Ve_di_Vge_si=(+0.0+T1_Ve_di_Vge_si);
  F0_Ve_di_Ve_si=(+0.0+T1_Ve_di_Ve_si);
  F0_Ve_di_Ve_di=(+0.0+T1_Ve_di_Ve_di);
  F0_Ve_di_Vdi_si=(+0.0+T1_Ve_di_Vdi_si);
  F0_Ve_di_Tempt_GND=(+0.0+T1_Ve_di_Tempt_GND);
#endif
F0_Vdi_si=((-T2_Vdi_si)+T1_Vdi_si);
#if defined(_DERIVATE2)
  F0_Vdi_si_Vge_si=(+0.0+T1_Vdi_si_Vge_si);
  F0_Vdi_si_Ve_si=(+0.0+T1_Vdi_si_Ve_si);
  F0_Vdi_si_Ve_di=(+0.0+T1_Vdi_si_Ve_di);
  F0_Vdi_si_Vdi_si=(+0.0+T1_Vdi_si_Vdi_si);
  F0_Vdi_si_Tempt_GND=(+0.0+T1_Vdi_si_Tempt_GND);
#endif
F0_Tempt_GND=((-T2_Tempt_GND)+T1_Tempt_GND);
#if defined(_DERIVATE2)
  F0_Tempt_GND_Vge_si=(+0.0+T1_Tempt_GND_Vge_si);
  F0_Tempt_GND_Ve_si=(+0.0+T1_Tempt_GND_Ve_si);
  F0_Tempt_GND_Ve_di=(+0.0+T1_Tempt_GND_Ve_di);
  F0_Tempt_GND_Vdi_si=(+0.0+T1_Tempt_GND_Vdi_si);
  F0_Tempt_GND_Tempt_GND=(+0.0+T1_Tempt_GND_Tempt_GND);
#endif
#endif
F0=((-T2)+T1);
EXIT_IF_ISNAN(((-T2)+T1))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(0.5*(T2_Vdi_si-T0_Vdi_si));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0*(T2-T0)+0.0*T2_Vdi_d+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vdi_d-0.0));
  T3_Vdi_si_Vsi_s=(+0.0*(T2-T0)+0.0*T2_Vsi_s+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vsi_s-0.0));
  T3_Vdi_si_Vge_di=(+0.0*(T2-T0)+0.0*(T2_Vge_di-T0_Vge_di)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vge_di-T0_Vdi_si_Vge_di));
  T3_Vdi_si_Vge_e=(+0.0*(T2-T0)+0.0*(T2_Vge_e-T0_Vge_e)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vge_e-T0_Vdi_si_Vge_e));
  T3_Vdi_si_Vdi_si=(+0.0*(T2-T0)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vdi_si-T0_Vdi_si_Vdi_si));
  T3_Vdi_si_Ve_si=(+0.0*(T2-T0)+0.0*(T2_Ve_si-T0_Ve_si)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Ve_si-T0_Vdi_si_Ve_si));
  T3_Vdi_si_Ve_di=(+0.0*(T2-T0)+0.0*(T2_Ve_di-T0_Ve_di)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Ve_di-T0_Vdi_si_Ve_di));
  T3_Vdi_si_Vge_si=(+0.0*(T2-T0)+0.0*(T2_Vge_si-T0_Vge_si)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Vge_si-T0_Vdi_si_Vge_si));
  T3_Vdi_si_Tempt_GND=(+0.0*(T2-T0)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.5*(+T2_Vdi_si_Tempt_GND-T0_Vdi_si_Tempt_GND));
#endif
T3_Ve_si=(0.5*(T2_Ve_si-T0_Ve_si));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0*(T2-T0)+0.0*T2_Vdi_d+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vdi_d-0.0));
  T3_Ve_si_Vsi_s=(+0.0*(T2-T0)+0.0*T2_Vsi_s+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vsi_s-0.0));
  T3_Ve_si_Vge_di=(+0.0*(T2-T0)+0.0*(T2_Vge_di-T0_Vge_di)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vge_di-T0_Ve_si_Vge_di));
  T3_Ve_si_Vge_e=(+0.0*(T2-T0)+0.0*(T2_Vge_e-T0_Vge_e)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vge_e-T0_Ve_si_Vge_e));
  T3_Ve_si_Vdi_si=(+0.0*(T2-T0)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vdi_si-T0_Ve_si_Vdi_si));
  T3_Ve_si_Ve_si=(+0.0*(T2-T0)+0.0*(T2_Ve_si-T0_Ve_si)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Ve_si-T0_Ve_si_Ve_si));
  T3_Ve_si_Ve_di=(+0.0*(T2-T0)+0.0*(T2_Ve_di-T0_Ve_di)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Ve_di-T0_Ve_si_Ve_di));
  T3_Ve_si_Vge_si=(+0.0*(T2-T0)+0.0*(T2_Vge_si-T0_Vge_si)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Vge_si-T0_Ve_si_Vge_si));
  T3_Ve_si_Tempt_GND=(+0.0*(T2-T0)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.0*(T2_Ve_si-T0_Ve_si)+0.5*(+T2_Ve_si_Tempt_GND-T0_Ve_si_Tempt_GND));
#endif
T3_Ve_di=(0.5*(T2_Ve_di-T0_Ve_di));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0*(T2-T0)+0.0*T2_Vdi_d+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vdi_d-0.0));
  T3_Ve_di_Vsi_s=(+0.0*(T2-T0)+0.0*T2_Vsi_s+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vsi_s-0.0));
  T3_Ve_di_Vge_di=(+0.0*(T2-T0)+0.0*(T2_Vge_di-T0_Vge_di)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vge_di-T0_Ve_di_Vge_di));
  T3_Ve_di_Vge_e=(+0.0*(T2-T0)+0.0*(T2_Vge_e-T0_Vge_e)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vge_e-T0_Ve_di_Vge_e));
  T3_Ve_di_Vdi_si=(+0.0*(T2-T0)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vdi_si-T0_Ve_di_Vdi_si));
  T3_Ve_di_Ve_si=(+0.0*(T2-T0)+0.0*(T2_Ve_si-T0_Ve_si)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Ve_si-T0_Ve_di_Ve_si));
  T3_Ve_di_Ve_di=(+0.0*(T2-T0)+0.0*(T2_Ve_di-T0_Ve_di)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Ve_di-T0_Ve_di_Ve_di));
  T3_Ve_di_Vge_si=(+0.0*(T2-T0)+0.0*(T2_Vge_si-T0_Vge_si)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Vge_si-T0_Ve_di_Vge_si));
  T3_Ve_di_Tempt_GND=(+0.0*(T2-T0)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.0*(T2_Ve_di-T0_Ve_di)+0.5*(+T2_Ve_di_Tempt_GND-T0_Ve_di_Tempt_GND));
#endif
T3_Vge_si=(0.5*(T2_Vge_si-T0_Vge_si));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0*(T2-T0)+0.0*T2_Vdi_d+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vdi_d-0.0));
  T3_Vge_si_Vsi_s=(+0.0*(T2-T0)+0.0*T2_Vsi_s+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vsi_s-0.0));
  T3_Vge_si_Vge_di=(+0.0*(T2-T0)+0.0*(T2_Vge_di-T0_Vge_di)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vge_di-T0_Vge_si_Vge_di));
  T3_Vge_si_Vge_e=(+0.0*(T2-T0)+0.0*(T2_Vge_e-T0_Vge_e)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vge_e-T0_Vge_si_Vge_e));
  T3_Vge_si_Vdi_si=(+0.0*(T2-T0)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vdi_si-T0_Vge_si_Vdi_si));
  T3_Vge_si_Ve_si=(+0.0*(T2-T0)+0.0*(T2_Ve_si-T0_Ve_si)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Ve_si-T0_Vge_si_Ve_si));
  T3_Vge_si_Ve_di=(+0.0*(T2-T0)+0.0*(T2_Ve_di-T0_Ve_di)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Ve_di-T0_Vge_si_Ve_di));
  T3_Vge_si_Vge_si=(+0.0*(T2-T0)+0.0*(T2_Vge_si-T0_Vge_si)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Vge_si-T0_Vge_si_Vge_si));
  T3_Vge_si_Tempt_GND=(+0.0*(T2-T0)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.0*(T2_Vge_si-T0_Vge_si)+0.5*(+T2_Vge_si_Tempt_GND-T0_Vge_si_Tempt_GND));
#endif
T3_Tempt_GND=(0.5*(T2_Tempt_GND-T0_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0*(T2-T0)+0.0*T2_Vdi_d+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vdi_d-0.0));
  T3_Tempt_GND_Vsi_s=(+0.0*(T2-T0)+0.0*T2_Vsi_s+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vsi_s-0.0));
  T3_Tempt_GND_Vge_di=(+0.0*(T2-T0)+0.0*(T2_Vge_di-T0_Vge_di)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_di-T0_Tempt_GND_Vge_di));
  T3_Tempt_GND_Vge_e=(+0.0*(T2-T0)+0.0*(T2_Vge_e-T0_Vge_e)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_e-T0_Tempt_GND_Vge_e));
  T3_Tempt_GND_Vdi_si=(+0.0*(T2-T0)+0.0*(T2_Vdi_si-T0_Vdi_si)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vdi_si-T0_Tempt_GND_Vdi_si));
  T3_Tempt_GND_Ve_si=(+0.0*(T2-T0)+0.0*(T2_Ve_si-T0_Ve_si)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_si-T0_Tempt_GND_Ve_si));
  T3_Tempt_GND_Ve_di=(+0.0*(T2-T0)+0.0*(T2_Ve_di-T0_Ve_di)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_di-T0_Tempt_GND_Ve_di));
  T3_Tempt_GND_Vge_si=(+0.0*(T2-T0)+0.0*(T2_Vge_si-T0_Vge_si)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_si-T0_Tempt_GND_Vge_si));
  T3_Tempt_GND_Tempt_GND=(+0.0*(T2-T0)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.0*(T2_Tempt_GND-T0_Tempt_GND)+0.5*(+T2_Tempt_GND_Tempt_GND-T0_Tempt_GND_Tempt_GND));
#endif
#endif
T3=(0.5*(T2-T0));
EXIT_IF_ISNAN((0.5*(T2-T0)))
{
double m00_exp(d00_exp0,T3)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=T3_Vdi_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Vdi_si);
  qm_Vdi_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Ve_si);
  qm_Vdi_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Vdi_si+d10_exp0*T3_Vdi_si_Ve_di);
  qm_Vdi_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Vge_si);
  qm_Vdi_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Vdi_si+d10_exp0*T3_Vdi_si_Tempt_GND);
#endif
qm_Ve_si=T3_Ve_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Ve_si+d10_exp0*T3_Ve_si_Vdi_si);
  qm_Ve_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Ve_si+d10_exp0*T3_Ve_si_Ve_si);
  qm_Ve_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Ve_si+d10_exp0*T3_Ve_si_Ve_di);
  qm_Ve_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Ve_si+d10_exp0*T3_Ve_si_Vge_si);
  qm_Ve_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Ve_si+d10_exp0*T3_Ve_si_Tempt_GND);
#endif
qm_Ve_di=T3_Ve_di*d10_exp0;
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Ve_di+d10_exp0*T3_Ve_di_Vdi_si);
  qm_Ve_di_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Ve_di+d10_exp0*T3_Ve_di_Ve_si);
  qm_Ve_di_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Ve_di+d10_exp0*T3_Ve_di_Ve_di);
  qm_Ve_di_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Ve_di+d10_exp0*T3_Ve_di_Vge_si);
  qm_Ve_di_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Ve_di+d10_exp0*T3_Ve_di_Tempt_GND);
#endif
qm_Vge_si=T3_Vge_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Vge_si+d10_exp0*T3_Vge_si_Vdi_si);
  qm_Vge_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Vge_si+d10_exp0*T3_Vge_si_Ve_si);
  qm_Vge_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Vge_si+d10_exp0*T3_Vge_si_Ve_di);
  qm_Vge_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Vge_si+d10_exp0*T3_Vge_si_Vge_si);
  qm_Vge_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Vge_si+d10_exp0*T3_Vge_si_Tempt_GND);
#endif
qm_Tempt_GND=T3_Tempt_GND*d10_exp0;
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Vdi_si);
  qm_Tempt_GND_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Ve_si);
  qm_Tempt_GND_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Ve_di);
  qm_Tempt_GND_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Vge_si);
  qm_Tempt_GND_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Tempt_GND);
#endif
#endif
qm=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
if
((qm>1.0e-7))
{
{
double m00_logE(d00_logE0,(1.0+qm))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0+qm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=0.0;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=0.0;
  T7_Vge_e_Vdi_d=0.0;
  T7_Vge_e_Vsi_s=0.0;
  T7_Vge_e_Vge_e=0.0;
  T7_Vge_e_Vdi_si=0.0;
  T7_Vge_e_Ve_si=0.0;
  T7_Vge_e_Ve_di=0.0;
  T7_Vge_e_Vge_si=0.0;
  T7_Vge_e_Tempt_GND=0.0;
#endif
T7_Vdi_si=qm_Vdi_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=0.0;
  T7_Vdi_si_Vdi_d=0.0;
  T7_Vdi_si_Vsi_s=0.0;
  T7_Vdi_si_Vge_e=0.0;
  T7_Vdi_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Vdi_si));
  T7_Vdi_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Ve_si));
  T7_Vdi_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Ve_di));
  T7_Vdi_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Vge_si));
  T7_Vdi_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Tempt_GND));
#endif
T7_Ve_si=qm_Ve_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=0.0;
  T7_Ve_si_Vdi_d=0.0;
  T7_Ve_si_Vsi_s=0.0;
  T7_Ve_si_Vge_e=0.0;
  T7_Ve_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Vdi_si));
  T7_Ve_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Ve_si));
  T7_Ve_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Ve_di));
  T7_Ve_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Vge_si));
  T7_Ve_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Tempt_GND));
#endif
T7_Ve_di=qm_Ve_di*d10_logE0;
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=0.0;
  T7_Ve_di_Vdi_d=0.0;
  T7_Ve_di_Vsi_s=0.0;
  T7_Ve_di_Vge_e=0.0;
  T7_Ve_di_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Vdi_si));
  T7_Ve_di_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Ve_si));
  T7_Ve_di_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Ve_di));
  T7_Ve_di_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Vge_si));
  T7_Ve_di_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Tempt_GND));
#endif
T7_Vge_si=qm_Vge_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=0.0;
  T7_Vge_si_Vdi_d=0.0;
  T7_Vge_si_Vsi_s=0.0;
  T7_Vge_si_Vge_e=0.0;
  T7_Vge_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Vdi_si));
  T7_Vge_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Ve_si));
  T7_Vge_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Ve_di));
  T7_Vge_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Vge_si));
  T7_Vge_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Tempt_GND));
#endif
T7_Tempt_GND=qm_Tempt_GND*d10_logE0;
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=0.0;
  T7_Tempt_GND_Vdi_d=0.0;
  T7_Tempt_GND_Vsi_s=0.0;
  T7_Tempt_GND_Vge_e=0.0;
  T7_Tempt_GND_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Vdi_si));
  T7_Tempt_GND_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Ve_si));
  T7_Tempt_GND_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Ve_di));
  T7_Tempt_GND_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Vge_si));
  T7_Tempt_GND_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Tempt_GND));
#endif
#endif
T7=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_sqrt(d00_sqrt0,(1.0+(T7*T7)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T7*T7)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(2.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Vdi_si*T7+T7_Vdi_si*T7_Vdi_si+T7_Vdi_si*T7_Vdi_si+T7*T7_Vdi_si_Vdi_si)))));
  qm_Vdi_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Ve_si*T7+T7_Vdi_si*T7_Ve_si+T7_Ve_si*T7_Vdi_si+T7*T7_Vdi_si_Ve_si)))));
  qm_Vdi_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Ve_di*T7+T7_Vdi_si*T7_Ve_di+T7_Ve_di*T7_Vdi_si+T7*T7_Vdi_si_Ve_di)))));
  qm_Vdi_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Vge_si*T7+T7_Vdi_si*T7_Vge_si+T7_Vge_si*T7_Vdi_si+T7*T7_Vdi_si_Vge_si)))));
  qm_Vdi_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Tempt_GND*T7+T7_Vdi_si*T7_Tempt_GND+T7_Tempt_GND*T7_Vdi_si+T7*T7_Vdi_si_Tempt_GND)))));
#endif
qm_Ve_si=(2.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Vdi_si*T7+T7_Ve_si*T7_Vdi_si+T7_Vdi_si*T7_Ve_si+T7*T7_Ve_si_Vdi_si)))));
  qm_Ve_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Ve_si*T7+T7_Ve_si*T7_Ve_si+T7_Ve_si*T7_Ve_si+T7*T7_Ve_si_Ve_si)))));
  qm_Ve_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Ve_di*T7+T7_Ve_si*T7_Ve_di+T7_Ve_di*T7_Ve_si+T7*T7_Ve_si_Ve_di)))));
  qm_Ve_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Vge_si*T7+T7_Ve_si*T7_Vge_si+T7_Vge_si*T7_Ve_si+T7*T7_Ve_si_Vge_si)))));
  qm_Ve_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Tempt_GND*T7+T7_Ve_si*T7_Tempt_GND+T7_Tempt_GND*T7_Ve_si+T7*T7_Ve_si_Tempt_GND)))));
#endif
qm_Ve_di=(2.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Vdi_si*T7+T7_Ve_di*T7_Vdi_si+T7_Vdi_si*T7_Ve_di+T7*T7_Ve_di_Vdi_si)))));
  qm_Ve_di_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Ve_si*T7+T7_Ve_di*T7_Ve_si+T7_Ve_si*T7_Ve_di+T7*T7_Ve_di_Ve_si)))));
  qm_Ve_di_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Ve_di*T7+T7_Ve_di*T7_Ve_di+T7_Ve_di*T7_Ve_di+T7*T7_Ve_di_Ve_di)))));
  qm_Ve_di_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Vge_si*T7+T7_Ve_di*T7_Vge_si+T7_Vge_si*T7_Ve_di+T7*T7_Ve_di_Vge_si)))));
  qm_Ve_di_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Tempt_GND*T7+T7_Ve_di*T7_Tempt_GND+T7_Tempt_GND*T7_Ve_di+T7*T7_Ve_di_Tempt_GND)))));
#endif
qm_Vge_si=(2.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Vdi_si*T7+T7_Vge_si*T7_Vdi_si+T7_Vdi_si*T7_Vge_si+T7*T7_Vge_si_Vdi_si)))));
  qm_Vge_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Ve_si*T7+T7_Vge_si*T7_Ve_si+T7_Ve_si*T7_Vge_si+T7*T7_Vge_si_Ve_si)))));
  qm_Vge_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Ve_di*T7+T7_Vge_si*T7_Ve_di+T7_Ve_di*T7_Vge_si+T7*T7_Vge_si_Ve_di)))));
  qm_Vge_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Vge_si*T7+T7_Vge_si*T7_Vge_si+T7_Vge_si*T7_Vge_si+T7*T7_Vge_si_Vge_si)))));
  qm_Vge_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Tempt_GND*T7+T7_Vge_si*T7_Tempt_GND+T7_Tempt_GND*T7_Vge_si+T7*T7_Vge_si_Tempt_GND)))));
#endif
qm_Tempt_GND=(2.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Vdi_si*T7+T7_Tempt_GND*T7_Vdi_si+T7_Vdi_si*T7_Tempt_GND+T7*T7_Tempt_GND_Vdi_si)))));
  qm_Tempt_GND_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Ve_si*T7+T7_Tempt_GND*T7_Ve_si+T7_Ve_si*T7_Tempt_GND+T7*T7_Tempt_GND_Ve_si)))));
  qm_Tempt_GND_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Ve_di*T7+T7_Tempt_GND*T7_Ve_di+T7_Ve_di*T7_Tempt_GND+T7*T7_Tempt_GND_Ve_di)))));
  qm_Tempt_GND_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Vge_si*T7+T7_Tempt_GND*T7_Vge_si+T7_Vge_si*T7_Tempt_GND+T7*T7_Tempt_GND_Vge_si)))));
  qm_Tempt_GND_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Tempt_GND*T7+T7_Tempt_GND*T7_Tempt_GND+T7_Tempt_GND*T7_Tempt_GND+T7*T7_Tempt_GND_Tempt_GND)))));
#endif
#endif
qm=(2.0*(1.0-d00_sqrt0));
EXIT_IF_ISNAN((2.0*(1.0-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*rc;
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vdi_si=(+(+(+qm_Vdi_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Vdi_si_Vdi_si)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_si=(+(+(+qm_Vdi_si_Ve_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_di=(+(+(+qm_Vdi_si_Ve_di*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vge_si=(+(+(+qm_Vdi_si_Vge_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Tempt_GND=(+(+(+qm_Vdi_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Vdi_si_Tempt_GND)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_si=qm_Ve_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vdi_si=(+(+(+qm_Ve_si_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_si=(+(+(+qm_Ve_si_Ve_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_di=(+(+(+qm_Ve_si_Ve_di*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vge_si=(+(+(+qm_Ve_si_Vge_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Tempt_GND=(+(+(+qm_Ve_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_di=qm_Ve_di*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_di*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vdi_si=(+(+(+qm_Ve_di_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_si=(+(+(+qm_Ve_di_Ve_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_di=(+(+(+qm_Ve_di_Ve_di*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vge_si=(+(+(+qm_Ve_di_Vge_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Tempt_GND=(+(+(+qm_Ve_di_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Vge_si=qm_Vge_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vge_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vdi_si=(+(+(+qm_Vge_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_si=(+(+(+qm_Vge_si_Ve_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_di=(+(+(+qm_Vge_si_Ve_di*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vge_si=(+(+(+qm_Vge_si_Vge_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Tempt_GND=(+(+(+qm_Vge_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Tempt_GND=(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*rc;
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vdi_si=(+(+(+qm_Tempt_GND_Vdi_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Tempt_GND_Vdi_si)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_si=(+(+(+qm_Tempt_GND_Ve_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_di=(+(+(+qm_Tempt_GND_Ve_di*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vge_si=(+(+(+qm_Tempt_GND_Vge_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Tempt_GND=(+(+(+qm_Tempt_GND_Tempt_GND*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Tempt_GND_Tempt_GND)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
#endif
T8=(((qm*pModel->ALPHA_UFCM)+qdep)*rc);
EXIT_IF_ISNAN((((qm*pModel->ALPHA_UFCM)+qdep)*rc))
{
double m00_exp(d00_exp0,T8)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=((T8_Vdi_si*((d00_exp0-T8)-1.0)-T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vdi_si*0.0+0.0*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_e=(T8_Vdi_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_e)-T8_Vdi_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vdi_si=(T8_Vdi_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vdi_si)-T8_Vdi_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_si=(T8_Vdi_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_si)-T8_Vdi_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_di=(T8_Vdi_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_di)-T8_Vdi_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_si=(T8_Vdi_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_si)-T8_Vdi_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Tempt_GND=(T8_Vdi_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vdi_si+d10_exp0*T8_Vdi_si_Tempt_GND)-T8_Vdi_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_si=((T8_Ve_si*((d00_exp0-T8)-1.0)-T8*(T8_Ve_si*d10_exp0-T8_Ve_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_si*0.0+0.0*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_e=(T8_Ve_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_e)-T8_Ve_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vdi_si=(T8_Ve_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vdi_si)-T8_Ve_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_si=(T8_Ve_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_si)-T8_Ve_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_di=(T8_Ve_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_di)-T8_Ve_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_si=(T8_Ve_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_si)-T8_Ve_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Tempt_GND=(T8_Ve_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_si+d10_exp0*T8_Ve_si_Tempt_GND)-T8_Ve_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_di=((T8_Ve_di*((d00_exp0-T8)-1.0)-T8*(T8_Ve_di*d10_exp0-T8_Ve_di))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_di*0.0+0.0*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_e=(T8_Ve_di_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_e)-T8_Ve_di_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vdi_si=(T8_Ve_di_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vdi_si)-T8_Ve_di_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_si=(T8_Ve_di_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_si)-T8_Ve_di_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_di=(T8_Ve_di_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_di)-T8_Ve_di_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_si=(T8_Ve_di_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_si)-T8_Ve_di_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Tempt_GND=(T8_Ve_di_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_di+d10_exp0*T8_Ve_di_Tempt_GND)-T8_Ve_di_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Vge_si=((T8_Vge_si*((d00_exp0-T8)-1.0)-T8*(T8_Vge_si*d10_exp0-T8_Vge_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vge_si*0.0+0.0*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_e=(T8_Vge_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_e)-T8_Vge_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vdi_si=(T8_Vge_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vdi_si)-T8_Vge_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_si=(T8_Vge_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_si)-T8_Vge_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_di=(T8_Vge_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_di)-T8_Vge_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_si=(T8_Vge_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_si)-T8_Vge_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Tempt_GND=(T8_Vge_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vge_si+d10_exp0*T8_Vge_si_Tempt_GND)-T8_Vge_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Tempt_GND=((T8_Tempt_GND*((d00_exp0-T8)-1.0)-T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*0.0+0.0*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_e=(T8_Tempt_GND_Vge_e/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_e)-T8_Tempt_GND_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vdi_si=(T8_Tempt_GND_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vdi_si)-T8_Tempt_GND_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_si=(T8_Tempt_GND_Ve_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_si)-T8_Tempt_GND_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_di=(T8_Tempt_GND_Ve_di/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_di)-T8_Tempt_GND_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_si=(T8_Tempt_GND_Vge_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_si)-T8_Tempt_GND_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Tempt_GND=(T8_Tempt_GND_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Tempt_GND)-T8_Tempt_GND_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
#endif
T4=(T8/((d00_exp0-T8)-1.0));
EXIT_IF_ISNAN((T8/((d00_exp0-T8)-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=((T8_Vdi_si*T4)+(T8*T4_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*T4+T8_Vdi_si*T4_Vge_di+0.0*T4_Vdi_si+T8*T4_Vdi_si_Vge_di);
  T5_Vdi_si_Vdi_d=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vsi_s=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vge_e=(+T8_Vdi_si_Vge_e*T4+T8_Vdi_si*T4_Vge_e+T8_Vge_e*T4_Vdi_si+T8*T4_Vdi_si_Vge_e);
  T5_Vdi_si_Vdi_si=(+T8_Vdi_si_Vdi_si*T4+T8_Vdi_si*T4_Vdi_si+T8_Vdi_si*T4_Vdi_si+T8*T4_Vdi_si_Vdi_si);
  T5_Vdi_si_Ve_si=(+T8_Vdi_si_Ve_si*T4+T8_Vdi_si*T4_Ve_si+T8_Ve_si*T4_Vdi_si+T8*T4_Vdi_si_Ve_si);
  T5_Vdi_si_Ve_di=(+T8_Vdi_si_Ve_di*T4+T8_Vdi_si*T4_Ve_di+T8_Ve_di*T4_Vdi_si+T8*T4_Vdi_si_Ve_di);
  T5_Vdi_si_Vge_si=(+T8_Vdi_si_Vge_si*T4+T8_Vdi_si*T4_Vge_si+T8_Vge_si*T4_Vdi_si+T8*T4_Vdi_si_Vge_si);
  T5_Vdi_si_Tempt_GND=(+T8_Vdi_si_Tempt_GND*T4+T8_Vdi_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vdi_si+T8*T4_Vdi_si_Tempt_GND);
#endif
T5_Ve_si=((T8_Ve_si*T4)+(T8*T4_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0*T4+T8_Ve_si*T4_Vge_di+0.0*T4_Ve_si+T8*T4_Ve_si_Vge_di);
  T5_Ve_si_Vdi_d=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vsi_s=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vge_e=(+T8_Ve_si_Vge_e*T4+T8_Ve_si*T4_Vge_e+T8_Vge_e*T4_Ve_si+T8*T4_Ve_si_Vge_e);
  T5_Ve_si_Vdi_si=(+T8_Ve_si_Vdi_si*T4+T8_Ve_si*T4_Vdi_si+T8_Vdi_si*T4_Ve_si+T8*T4_Ve_si_Vdi_si);
  T5_Ve_si_Ve_si=(+T8_Ve_si_Ve_si*T4+T8_Ve_si*T4_Ve_si+T8_Ve_si*T4_Ve_si+T8*T4_Ve_si_Ve_si);
  T5_Ve_si_Ve_di=(+T8_Ve_si_Ve_di*T4+T8_Ve_si*T4_Ve_di+T8_Ve_di*T4_Ve_si+T8*T4_Ve_si_Ve_di);
  T5_Ve_si_Vge_si=(+T8_Ve_si_Vge_si*T4+T8_Ve_si*T4_Vge_si+T8_Vge_si*T4_Ve_si+T8*T4_Ve_si_Vge_si);
  T5_Ve_si_Tempt_GND=(+T8_Ve_si_Tempt_GND*T4+T8_Ve_si*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_si+T8*T4_Ve_si_Tempt_GND);
#endif
T5_Ve_di=((T8_Ve_di*T4)+(T8*T4_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0*T4+T8_Ve_di*T4_Vge_di+0.0*T4_Ve_di+T8*T4_Ve_di_Vge_di);
  T5_Ve_di_Vdi_d=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vsi_s=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vge_e=(+T8_Ve_di_Vge_e*T4+T8_Ve_di*T4_Vge_e+T8_Vge_e*T4_Ve_di+T8*T4_Ve_di_Vge_e);
  T5_Ve_di_Vdi_si=(+T8_Ve_di_Vdi_si*T4+T8_Ve_di*T4_Vdi_si+T8_Vdi_si*T4_Ve_di+T8*T4_Ve_di_Vdi_si);
  T5_Ve_di_Ve_si=(+T8_Ve_di_Ve_si*T4+T8_Ve_di*T4_Ve_si+T8_Ve_si*T4_Ve_di+T8*T4_Ve_di_Ve_si);
  T5_Ve_di_Ve_di=(+T8_Ve_di_Ve_di*T4+T8_Ve_di*T4_Ve_di+T8_Ve_di*T4_Ve_di+T8*T4_Ve_di_Ve_di);
  T5_Ve_di_Vge_si=(+T8_Ve_di_Vge_si*T4+T8_Ve_di*T4_Vge_si+T8_Vge_si*T4_Ve_di+T8*T4_Ve_di_Vge_si);
  T5_Ve_di_Tempt_GND=(+T8_Ve_di_Tempt_GND*T4+T8_Ve_di*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_di+T8*T4_Ve_di_Tempt_GND);
#endif
T5_Vge_si=((T8_Vge_si*T4)+(T8*T4_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0*T4+T8_Vge_si*T4_Vge_di+0.0*T4_Vge_si+T8*T4_Vge_si_Vge_di);
  T5_Vge_si_Vdi_d=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vsi_s=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vge_e=(+T8_Vge_si_Vge_e*T4+T8_Vge_si*T4_Vge_e+T8_Vge_e*T4_Vge_si+T8*T4_Vge_si_Vge_e);
  T5_Vge_si_Vdi_si=(+T8_Vge_si_Vdi_si*T4+T8_Vge_si*T4_Vdi_si+T8_Vdi_si*T4_Vge_si+T8*T4_Vge_si_Vdi_si);
  T5_Vge_si_Ve_si=(+T8_Vge_si_Ve_si*T4+T8_Vge_si*T4_Ve_si+T8_Ve_si*T4_Vge_si+T8*T4_Vge_si_Ve_si);
  T5_Vge_si_Ve_di=(+T8_Vge_si_Ve_di*T4+T8_Vge_si*T4_Ve_di+T8_Ve_di*T4_Vge_si+T8*T4_Vge_si_Ve_di);
  T5_Vge_si_Vge_si=(+T8_Vge_si_Vge_si*T4+T8_Vge_si*T4_Vge_si+T8_Vge_si*T4_Vge_si+T8*T4_Vge_si_Vge_si);
  T5_Vge_si_Tempt_GND=(+T8_Vge_si_Tempt_GND*T4+T8_Vge_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vge_si+T8*T4_Vge_si_Tempt_GND);
#endif
T5_Tempt_GND=((T8_Tempt_GND*T4)+(T8*T4_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*T4+T8_Tempt_GND*T4_Vge_di+0.0*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_di);
  T5_Tempt_GND_Vdi_d=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vsi_s=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vge_e=(+T8_Tempt_GND_Vge_e*T4+T8_Tempt_GND*T4_Vge_e+T8_Vge_e*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_e);
  T5_Tempt_GND_Vdi_si=(+T8_Tempt_GND_Vdi_si*T4+T8_Tempt_GND*T4_Vdi_si+T8_Vdi_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vdi_si);
  T5_Tempt_GND_Ve_si=(+T8_Tempt_GND_Ve_si*T4+T8_Tempt_GND*T4_Ve_si+T8_Ve_si*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_si);
  T5_Tempt_GND_Ve_di=(+T8_Tempt_GND_Ve_di*T4+T8_Tempt_GND*T4_Ve_di+T8_Ve_di*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_di);
  T5_Tempt_GND_Vge_si=(+T8_Tempt_GND_Vge_si*T4+T8_Tempt_GND*T4_Vge_si+T8_Vge_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_si);
  T5_Tempt_GND_Tempt_GND=(+T8_Tempt_GND_Tempt_GND*T4+T8_Tempt_GND*T4_Tempt_GND+T8_Tempt_GND*T4_Tempt_GND+T8*T4_Tempt_GND_Tempt_GND);
#endif
#endif
T5=(T8*T4);
EXIT_IF_ISNAN((T8*T4))
{
double m00_logE(d00_logE0,(-qm))
double m00_logE(d00_logE1,T5)
double m00_pow(d00_pow2,(-(qm+qdep)),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-qm))
double m10_logE(d10_logE1,d00_logE1,T5)
double m10_pow(d10_pow2,d00_pow2,(-(qm+qdep)),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=0.0;
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=0.0;
  e0_Vge_e_Vge_si=0.0;
  e0_Vge_e_Ve_si=0.0;
  e0_Vge_e_Ve_di=0.0;
  e0_Vge_e_Vdi_si=0.0;
  e0_Vge_e_Tempt_GND=0.0;
#endif
e0_Vge_si=((((F0_Vge_si-qm_Vge_si)+(-qm_Vge_si)*d10_logE0)+T5_Vge_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vge_si=(+(+(+(+F0_Vge_si_Vge_si-qm_Vge_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_si=(+(+(+(+F0_Vge_si_Ve_si-qm_Vge_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_di=(+(+(+(+F0_Vge_si_Ve_di-qm_Vge_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vdi_si=(+(+(+(+F0_Vge_si_Vdi_si-qm_Vge_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Tempt_GND=(+(+(+(+F0_Vge_si_Tempt_GND-qm_Vge_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vge_si+d10_logE1*T5_Vge_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_si=((((F0_Ve_si-qm_Ve_si)+(-qm_Ve_si)*d10_logE0)+T5_Ve_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vge_si=(+(+(+(+F0_Ve_si_Vge_si-qm_Ve_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_si=(+(+(+(+F0_Ve_si_Ve_si-qm_Ve_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_di=(+(+(+(+F0_Ve_si_Ve_di-qm_Ve_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vdi_si=(+(+(+(+F0_Ve_si_Vdi_si-qm_Ve_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Tempt_GND=(+(+(+(+F0_Ve_si_Tempt_GND-qm_Ve_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_si+d10_logE1*T5_Ve_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_di=((((F0_Ve_di-qm_Ve_di)+(-qm_Ve_di)*d10_logE0)+T5_Ve_di*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vge_si=(+(+(+(+F0_Ve_di_Vge_si-qm_Ve_di_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_si=(+(+(+(+F0_Ve_di_Ve_si-qm_Ve_di_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_di=(+(+(+(+F0_Ve_di_Ve_di-qm_Ve_di_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vdi_si=(+(+(+(+F0_Ve_di_Vdi_si-qm_Ve_di_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Tempt_GND=(+(+(+(+F0_Ve_di_Tempt_GND-qm_Ve_di_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_di+d10_logE1*T5_Ve_di_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
#endif
e0_Vdi_si=((((F0_Vdi_si-qm_Vdi_si)+(-qm_Vdi_si)*d10_logE0)+T5_Vdi_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vge_si=(+(+(+(+F0_Vdi_si_Vge_si-qm_Vdi_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_si=(+(+(+(+F0_Vdi_si_Ve_si-qm_Vdi_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_di=(+(+(+(+F0_Vdi_si_Ve_di-qm_Vdi_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vdi_si=(+(+(+(+F0_Vdi_si_Vdi_si-qm_Vdi_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Tempt_GND=(+(+(+(+F0_Vdi_si_Tempt_GND-qm_Vdi_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vdi_si+d10_logE1*T5_Vdi_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
#endif
e0_Tempt_GND=((((F0_Tempt_GND-qm_Tempt_GND)+(-qm_Tempt_GND)*d10_logE0)+T5_Tempt_GND*d10_logE1)+((QMFACTORCVfinal_Tempt_GND*d00_pow2)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_e))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vge_si=(+(+(+(+F0_Tempt_GND_Vge_si-qm_Tempt_GND_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_si=(+(+(+(+F0_Tempt_GND_Ve_si-qm_Tempt_GND_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_di=(+(+(+(+F0_Tempt_GND_Ve_di-qm_Tempt_GND_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_di))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vdi_si=(+(+(+(+F0_Tempt_GND_Vdi_si-qm_Tempt_GND_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vdi_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Tempt_GND=(+(+(+(+F0_Tempt_GND_Tempt_GND-qm_Tempt_GND_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Tempt_GND))+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
#endif
#endif
e0=((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2));
EXIT_IF_ISNAN(((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=0.0;
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=0.0;
  e1_Vge_e_Vdi_si=0.0;
  e1_Vge_e_Ve_si=0.0;
  e1_Vge_e_Ve_di=0.0;
  e1_Vge_e_Vge_si=0.0;
  e1_Vge_e_Tempt_GND=0.0;
#endif
e1_Vdi_si=(((-qm_Vdi_si/qm/qm)+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vdi_si+1.0*0.0)/qm/qm+2*1.0*qm_Vdi_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_e)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_e/T8/T8/T8)-T4_Vdi_si_Vge_e)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vdi_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vdi_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vdi_si/T8/T8/T8)-T4_Vdi_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_si/T8/T8/T8)-T4_Vdi_si_Ve_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_di)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_di)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_di/T8/T8/T8)-T4_Vdi_si_Ve_di)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vge_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_si/T8/T8/T8)-T4_Vdi_si_Vge_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Tempt_GND)/qm/qm+2*1.0*qm_Vdi_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Tempt_GND)/T8/T8+2*2.0*T8_Vdi_si*T8_Tempt_GND/T8/T8/T8)-T4_Vdi_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_si=(((-qm_Ve_si/qm/qm)+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_si+1.0*0.0)/qm/qm+2*1.0*qm_Ve_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_e)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_e/T8/T8/T8)-T4_Ve_si_Vge_e)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vdi_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vdi_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vdi_si/T8/T8/T8)-T4_Ve_si_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_si)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_si)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_si/T8/T8/T8)-T4_Ve_si_Ve_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_di)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_di)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_di/T8/T8/T8)-T4_Ve_si_Ve_di)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vge_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_si/T8/T8/T8)-T4_Ve_si_Vge_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_si+1.0*qm_Ve_si_Tempt_GND)/qm/qm+2*1.0*qm_Ve_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_si+2.0*T8_Ve_si_Tempt_GND)/T8/T8+2*2.0*T8_Ve_si*T8_Tempt_GND/T8/T8/T8)-T4_Ve_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_di=(((-qm_Ve_di/qm/qm)+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_di+1.0*0.0)/qm/qm+2*1.0*qm_Ve_di*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_e)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_e/T8/T8/T8)-T4_Ve_di_Vge_e)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vdi_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vdi_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vdi_si/T8/T8/T8)-T4_Ve_di_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_si)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_si)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_si/T8/T8/T8)-T4_Ve_di_Ve_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_di)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_di)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_di/T8/T8/T8)-T4_Ve_di_Ve_di)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vge_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_si/T8/T8/T8)-T4_Ve_di_Vge_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_di+1.0*qm_Ve_di_Tempt_GND)/qm/qm+2*1.0*qm_Ve_di*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_di+2.0*T8_Ve_di_Tempt_GND)/T8/T8+2*2.0*T8_Ve_di*T8_Tempt_GND/T8/T8/T8)-T4_Ve_di_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Vge_si=(((-qm_Vge_si/qm/qm)+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vge_si+1.0*0.0)/qm/qm+2*1.0*qm_Vge_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_e)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_e/T8/T8/T8)-T4_Vge_si_Vge_e)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vdi_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vdi_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vdi_si/T8/T8/T8)-T4_Vge_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_si)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_si)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_si/T8/T8/T8)-T4_Vge_si_Ve_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_di)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_di)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_di/T8/T8/T8)-T4_Vge_si_Ve_di)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vge_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_si/T8/T8/T8)-T4_Vge_si_Vge_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vge_si+1.0*qm_Vge_si_Tempt_GND)/qm/qm+2*1.0*qm_Vge_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vge_si+2.0*T8_Vge_si_Tempt_GND)/T8/T8+2*2.0*T8_Vge_si*T8_Tempt_GND/T8/T8/T8)-T4_Vge_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Tempt_GND=(((-qm_Tempt_GND/qm/qm)+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*rc)-((((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Tempt_GND+1.0*0.0)/qm/qm+2*1.0*qm_Tempt_GND*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_e)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_e/T8/T8/T8)-T4_Tempt_GND_Vge_e)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*0.0+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vdi_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vdi_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vdi_si/T8/T8/T8)-T4_Tempt_GND_Vdi_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_si/T8/T8/T8)-T4_Tempt_GND_Ve_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_di)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_di)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_di/T8/T8/T8)-T4_Tempt_GND_Ve_di)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vge_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_si/T8/T8/T8)-T4_Tempt_GND_Vge_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Tempt_GND)/qm/qm+2*1.0*qm_Tempt_GND*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Tempt_GND)/T8/T8+2*2.0*T8_Tempt_GND*T8_Tempt_GND/T8/T8/T8)-T4_Tempt_GND_Tempt_GND)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e1=((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN(((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
e2_Vdi_si=((-(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e2_Vdi_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vdi_si*qm+qm_Vdi_si*qm_Vdi_si+qm_Vdi_si*qm_Vdi_si+qm*qm_Vdi_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_si*qm+qm_Vdi_si*qm_Ve_si+qm_Ve_si*qm_Vdi_si+qm*qm_Vdi_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_di*qm+qm_Vdi_si*qm_Ve_di+qm_Ve_di*qm_Vdi_si+qm*qm_Vdi_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vge_si*qm+qm_Vdi_si*qm_Vge_si+qm_Vge_si*qm_Vdi_si+qm*qm_Vdi_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Tempt_GND*qm+qm_Vdi_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vdi_si+qm*qm_Vdi_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_si=((-(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e2_Ve_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vdi_si*qm+qm_Ve_si*qm_Vdi_si+qm_Vdi_si*qm_Ve_si+qm*qm_Ve_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_si*qm+qm_Ve_si*qm_Ve_si+qm_Ve_si*qm_Ve_si+qm*qm_Ve_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_di*qm+qm_Ve_si*qm_Ve_di+qm_Ve_di*qm_Ve_si+qm*qm_Ve_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vge_si*qm+qm_Ve_si*qm_Vge_si+qm_Vge_si*qm_Ve_si+qm*qm_Ve_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Tempt_GND*qm+qm_Ve_si*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_si+qm*qm_Ve_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_di=((-(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e2_Ve_di_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vdi_si*qm+qm_Ve_di*qm_Vdi_si+qm_Vdi_si*qm_Ve_di+qm*qm_Ve_di_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_si*qm+qm_Ve_di*qm_Ve_si+qm_Ve_si*qm_Ve_di+qm*qm_Ve_di_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_di*qm+qm_Ve_di*qm_Ve_di+qm_Ve_di*qm_Ve_di+qm*qm_Ve_di_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vge_si*qm+qm_Ve_di*qm_Vge_si+qm_Vge_si*qm_Ve_di+qm*qm_Ve_di_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Tempt_GND*qm+qm_Ve_di*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_di+qm*qm_Ve_di_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Vge_si=((-(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e2_Vge_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vdi_si*qm+qm_Vge_si*qm_Vdi_si+qm_Vdi_si*qm_Vge_si+qm*qm_Vge_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_si*qm+qm_Vge_si*qm_Ve_si+qm_Ve_si*qm_Vge_si+qm*qm_Vge_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_di*qm+qm_Vge_si*qm_Ve_di+qm_Ve_di*qm_Vge_si+qm*qm_Vge_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vge_si*qm+qm_Vge_si*qm_Vge_si+qm_Vge_si*qm_Vge_si+qm*qm_Vge_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Tempt_GND*qm+qm_Vge_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vge_si+qm*qm_Vge_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Tempt_GND=((-(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))/(qm*qm)/(qm*qm))-((((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e2_Tempt_GND_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vdi_si*qm+qm_Tempt_GND*qm_Vdi_si+qm_Vdi_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_si*qm+qm_Tempt_GND*qm_Ve_si+qm_Ve_si*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_di*qm+qm_Tempt_GND*qm_Ve_di+qm_Ve_di*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vge_si*qm+qm_Tempt_GND*qm_Vge_si+qm_Vge_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Tempt_GND*qm+qm_Tempt_GND*qm_Tempt_GND+qm_Tempt_GND*qm_Tempt_GND+qm*qm_Tempt_GND_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e2=(((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN((((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(qm_Vdi_si-((((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+qm_Vdi_si_Vdi_si-(+(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vdi_si*e2+e0_Vdi_si*e2_Vdi_si+e0_Vdi_si*e2_Vdi_si+e0*e2_Vdi_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vdi_si)*e1+(2.0*e1_Vdi_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_si=(+qm_Vdi_si_Ve_si-(+(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_si*e2+e0_Vdi_si*e2_Ve_si+e0_Ve_si*e2_Vdi_si+e0*e2_Vdi_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_si)*e1+(2.0*e1_Vdi_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_di=(+qm_Vdi_si_Ve_di-(+(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_di*e2+e0_Vdi_si*e2_Ve_di+e0_Ve_di*e2_Vdi_si+e0*e2_Vdi_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_di)*e1+(2.0*e1_Vdi_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Vge_si=(+qm_Vdi_si_Vge_si-(+(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vge_si*e2+e0_Vdi_si*e2_Vge_si+e0_Vge_si*e2_Vdi_si+e0*e2_Vdi_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vge_si)*e1+(2.0*e1_Vdi_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Tempt_GND=(+qm_Vdi_si_Tempt_GND-(+(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Tempt_GND*e2+e0_Vdi_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vdi_si+e0*e2_Vdi_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Tempt_GND)*e1+(2.0*e1_Vdi_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_si=(qm_Ve_si-((((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+qm_Ve_si_Vdi_si-(+(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vdi_si*e2+e0_Ve_si*e2_Vdi_si+e0_Vdi_si*e2_Ve_si+e0*e2_Ve_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vdi_si)*e1+(2.0*e1_Ve_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_si=(+qm_Ve_si_Ve_si-(+(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_si*e2+e0_Ve_si*e2_Ve_si+e0_Ve_si*e2_Ve_si+e0*e2_Ve_si_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_si)*e1+(2.0*e1_Ve_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_di=(+qm_Ve_si_Ve_di-(+(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_di*e2+e0_Ve_si*e2_Ve_di+e0_Ve_di*e2_Ve_si+e0*e2_Ve_si_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_di)*e1+(2.0*e1_Ve_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Vge_si=(+qm_Ve_si_Vge_si-(+(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vge_si*e2+e0_Ve_si*e2_Vge_si+e0_Vge_si*e2_Ve_si+e0*e2_Ve_si_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vge_si)*e1+(2.0*e1_Ve_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Tempt_GND=(+qm_Ve_si_Tempt_GND-(+(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Tempt_GND*e2+e0_Ve_si*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_si+e0*e2_Ve_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_si+2.0*e1_Ve_si_Tempt_GND)*e1+(2.0*e1_Ve_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_di=(qm_Ve_di-((((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+qm_Ve_di_Vdi_si-(+(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vdi_si*e2+e0_Ve_di*e2_Vdi_si+e0_Vdi_si*e2_Ve_di+e0*e2_Ve_di_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vdi_si)*e1+(2.0*e1_Ve_di)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_si=(+qm_Ve_di_Ve_si-(+(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_si*e2+e0_Ve_di*e2_Ve_si+e0_Ve_si*e2_Ve_di+e0*e2_Ve_di_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_si)*e1+(2.0*e1_Ve_di)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_di=(+qm_Ve_di_Ve_di-(+(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_di*e2+e0_Ve_di*e2_Ve_di+e0_Ve_di*e2_Ve_di+e0*e2_Ve_di_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_di)*e1+(2.0*e1_Ve_di)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Vge_si=(+qm_Ve_di_Vge_si-(+(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vge_si*e2+e0_Ve_di*e2_Vge_si+e0_Vge_si*e2_Ve_di+e0*e2_Ve_di_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vge_si)*e1+(2.0*e1_Ve_di)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Tempt_GND=(+qm_Ve_di_Tempt_GND-(+(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Tempt_GND*e2+e0_Ve_di*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_di+e0*e2_Ve_di_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_di+2.0*e1_Ve_di_Tempt_GND)*e1+(2.0*e1_Ve_di)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Vge_si=(qm_Vge_si-((((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+qm_Vge_si_Vdi_si-(+(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vdi_si*e2+e0_Vge_si*e2_Vdi_si+e0_Vdi_si*e2_Vge_si+e0*e2_Vge_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vdi_si)*e1+(2.0*e1_Vge_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_si=(+qm_Vge_si_Ve_si-(+(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_si*e2+e0_Vge_si*e2_Ve_si+e0_Ve_si*e2_Vge_si+e0*e2_Vge_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_si)*e1+(2.0*e1_Vge_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_di=(+qm_Vge_si_Ve_di-(+(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_di*e2+e0_Vge_si*e2_Ve_di+e0_Ve_di*e2_Vge_si+e0*e2_Vge_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_di)*e1+(2.0*e1_Vge_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Vge_si=(+qm_Vge_si_Vge_si-(+(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vge_si*e2+e0_Vge_si*e2_Vge_si+e0_Vge_si*e2_Vge_si+e0*e2_Vge_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vge_si)*e1+(2.0*e1_Vge_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Tempt_GND=(+qm_Vge_si_Tempt_GND-(+(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Tempt_GND*e2+e0_Vge_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vge_si+e0*e2_Vge_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vge_si+2.0*e1_Vge_si_Tempt_GND)*e1+(2.0*e1_Vge_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Tempt_GND=(qm_Tempt_GND-((((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+qm_Tempt_GND_Vdi_si-(+(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vdi_si*e2+e0_Tempt_GND*e2_Vdi_si+e0_Vdi_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vdi_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vdi_si)*e1+(2.0*e1_Tempt_GND)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_si=(+qm_Tempt_GND_Ve_si-(+(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_si*e2+e0_Tempt_GND*e2_Ve_si+e0_Ve_si*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_si)*e1+(2.0*e1_Tempt_GND)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_di=(+qm_Tempt_GND_Ve_di-(+(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_di*e2+e0_Tempt_GND*e2_Ve_di+e0_Ve_di*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_di)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_di)*e1+(2.0*e1_Tempt_GND)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Vge_si=(+qm_Tempt_GND_Vge_si-(+(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vge_si*e2+e0_Tempt_GND*e2_Vge_si+e0_Vge_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vge_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vge_si)*e1+(2.0*e1_Tempt_GND)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Tempt_GND=(+qm_Tempt_GND_Tempt_GND-(+(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Tempt_GND*e2+e0_Tempt_GND*e2_Tempt_GND+e0_Tempt_GND*e2_Tempt_GND+e0*e2_Tempt_GND_Tempt_GND)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Tempt_GND)*e1+(2.0*e1_Tempt_GND)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
#endif
qm=(qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
EXIT_IF_ISNAN((qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*rc;
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vdi_si=(+(+(+qm_Vdi_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Vdi_si_Vdi_si)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_si=(+(+(+qm_Vdi_si_Ve_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_di=(+(+(+qm_Vdi_si_Ve_di*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vge_si=(+(+(+qm_Vdi_si_Vge_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Tempt_GND=(+(+(+qm_Vdi_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Vdi_si_Tempt_GND)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_si=qm_Ve_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vdi_si=(+(+(+qm_Ve_si_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_si=(+(+(+qm_Ve_si_Ve_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_di=(+(+(+qm_Ve_si_Ve_di*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vge_si=(+(+(+qm_Ve_si_Vge_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Tempt_GND=(+(+(+qm_Ve_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_di=qm_Ve_di*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_di*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vdi_si=(+(+(+qm_Ve_di_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_si=(+(+(+qm_Ve_di_Ve_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_di=(+(+(+qm_Ve_di_Ve_di*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vge_si=(+(+(+qm_Ve_di_Vge_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Tempt_GND=(+(+(+qm_Ve_di_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Vge_si=qm_Vge_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vge_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vdi_si=(+(+(+qm_Vge_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_si=(+(+(+qm_Vge_si_Ve_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_di=(+(+(+qm_Vge_si_Ve_di*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vge_si=(+(+(+qm_Vge_si_Vge_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Tempt_GND=(+(+(+qm_Vge_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Tempt_GND=(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*rc;
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vdi_si=(+(+(+qm_Tempt_GND_Vdi_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Tempt_GND_Vdi_si)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_si=(+(+(+qm_Tempt_GND_Ve_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_di=(+(+(+qm_Tempt_GND_Ve_di*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vge_si=(+(+(+qm_Tempt_GND_Vge_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Tempt_GND=(+(+(+qm_Tempt_GND_Tempt_GND*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Tempt_GND_Tempt_GND)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
#endif
T8=(((qm*pModel->ALPHA_UFCM)+qdep)*rc);
EXIT_IF_ISNAN((((qm*pModel->ALPHA_UFCM)+qdep)*rc))
{
double m00_exp(d00_exp0,T8)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=((T8_Vdi_si*((d00_exp0-T8)-1.0)-T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vdi_si*0.0+0.0*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_e=(T8_Vdi_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_e)-T8_Vdi_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vdi_si=(T8_Vdi_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vdi_si)-T8_Vdi_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_si=(T8_Vdi_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_si)-T8_Vdi_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_di=(T8_Vdi_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_di)-T8_Vdi_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_si=(T8_Vdi_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_si)-T8_Vdi_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Tempt_GND=(T8_Vdi_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vdi_si+d10_exp0*T8_Vdi_si_Tempt_GND)-T8_Vdi_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_si=((T8_Ve_si*((d00_exp0-T8)-1.0)-T8*(T8_Ve_si*d10_exp0-T8_Ve_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_si*0.0+0.0*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_e=(T8_Ve_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_e)-T8_Ve_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vdi_si=(T8_Ve_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vdi_si)-T8_Ve_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_si=(T8_Ve_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_si)-T8_Ve_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_di=(T8_Ve_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_di)-T8_Ve_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_si=(T8_Ve_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_si)-T8_Ve_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Tempt_GND=(T8_Ve_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_si+d10_exp0*T8_Ve_si_Tempt_GND)-T8_Ve_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_di=((T8_Ve_di*((d00_exp0-T8)-1.0)-T8*(T8_Ve_di*d10_exp0-T8_Ve_di))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_di*0.0+0.0*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_e=(T8_Ve_di_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_e)-T8_Ve_di_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vdi_si=(T8_Ve_di_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vdi_si)-T8_Ve_di_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_si=(T8_Ve_di_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_si)-T8_Ve_di_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_di=(T8_Ve_di_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_di)-T8_Ve_di_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_si=(T8_Ve_di_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_si)-T8_Ve_di_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Tempt_GND=(T8_Ve_di_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_di+d10_exp0*T8_Ve_di_Tempt_GND)-T8_Ve_di_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Vge_si=((T8_Vge_si*((d00_exp0-T8)-1.0)-T8*(T8_Vge_si*d10_exp0-T8_Vge_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vge_si*0.0+0.0*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_e=(T8_Vge_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_e)-T8_Vge_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vdi_si=(T8_Vge_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vdi_si)-T8_Vge_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_si=(T8_Vge_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_si)-T8_Vge_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_di=(T8_Vge_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_di)-T8_Vge_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_si=(T8_Vge_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_si)-T8_Vge_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Tempt_GND=(T8_Vge_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vge_si+d10_exp0*T8_Vge_si_Tempt_GND)-T8_Vge_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Tempt_GND=((T8_Tempt_GND*((d00_exp0-T8)-1.0)-T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*0.0+0.0*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_e=(T8_Tempt_GND_Vge_e/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_e)-T8_Tempt_GND_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vdi_si=(T8_Tempt_GND_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vdi_si)-T8_Tempt_GND_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_si=(T8_Tempt_GND_Ve_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_si)-T8_Tempt_GND_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_di=(T8_Tempt_GND_Ve_di/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_di)-T8_Tempt_GND_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_si=(T8_Tempt_GND_Vge_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_si)-T8_Tempt_GND_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Tempt_GND=(T8_Tempt_GND_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Tempt_GND)-T8_Tempt_GND_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
#endif
T4=(T8/((d00_exp0-T8)-1.0));
EXIT_IF_ISNAN((T8/((d00_exp0-T8)-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=((T8_Vdi_si*T4)+(T8*T4_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*T4+T8_Vdi_si*T4_Vge_di+0.0*T4_Vdi_si+T8*T4_Vdi_si_Vge_di);
  T5_Vdi_si_Vdi_d=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vsi_s=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vge_e=(+T8_Vdi_si_Vge_e*T4+T8_Vdi_si*T4_Vge_e+T8_Vge_e*T4_Vdi_si+T8*T4_Vdi_si_Vge_e);
  T5_Vdi_si_Vdi_si=(+T8_Vdi_si_Vdi_si*T4+T8_Vdi_si*T4_Vdi_si+T8_Vdi_si*T4_Vdi_si+T8*T4_Vdi_si_Vdi_si);
  T5_Vdi_si_Ve_si=(+T8_Vdi_si_Ve_si*T4+T8_Vdi_si*T4_Ve_si+T8_Ve_si*T4_Vdi_si+T8*T4_Vdi_si_Ve_si);
  T5_Vdi_si_Ve_di=(+T8_Vdi_si_Ve_di*T4+T8_Vdi_si*T4_Ve_di+T8_Ve_di*T4_Vdi_si+T8*T4_Vdi_si_Ve_di);
  T5_Vdi_si_Vge_si=(+T8_Vdi_si_Vge_si*T4+T8_Vdi_si*T4_Vge_si+T8_Vge_si*T4_Vdi_si+T8*T4_Vdi_si_Vge_si);
  T5_Vdi_si_Tempt_GND=(+T8_Vdi_si_Tempt_GND*T4+T8_Vdi_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vdi_si+T8*T4_Vdi_si_Tempt_GND);
#endif
T5_Ve_si=((T8_Ve_si*T4)+(T8*T4_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0*T4+T8_Ve_si*T4_Vge_di+0.0*T4_Ve_si+T8*T4_Ve_si_Vge_di);
  T5_Ve_si_Vdi_d=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vsi_s=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vge_e=(+T8_Ve_si_Vge_e*T4+T8_Ve_si*T4_Vge_e+T8_Vge_e*T4_Ve_si+T8*T4_Ve_si_Vge_e);
  T5_Ve_si_Vdi_si=(+T8_Ve_si_Vdi_si*T4+T8_Ve_si*T4_Vdi_si+T8_Vdi_si*T4_Ve_si+T8*T4_Ve_si_Vdi_si);
  T5_Ve_si_Ve_si=(+T8_Ve_si_Ve_si*T4+T8_Ve_si*T4_Ve_si+T8_Ve_si*T4_Ve_si+T8*T4_Ve_si_Ve_si);
  T5_Ve_si_Ve_di=(+T8_Ve_si_Ve_di*T4+T8_Ve_si*T4_Ve_di+T8_Ve_di*T4_Ve_si+T8*T4_Ve_si_Ve_di);
  T5_Ve_si_Vge_si=(+T8_Ve_si_Vge_si*T4+T8_Ve_si*T4_Vge_si+T8_Vge_si*T4_Ve_si+T8*T4_Ve_si_Vge_si);
  T5_Ve_si_Tempt_GND=(+T8_Ve_si_Tempt_GND*T4+T8_Ve_si*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_si+T8*T4_Ve_si_Tempt_GND);
#endif
T5_Ve_di=((T8_Ve_di*T4)+(T8*T4_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0*T4+T8_Ve_di*T4_Vge_di+0.0*T4_Ve_di+T8*T4_Ve_di_Vge_di);
  T5_Ve_di_Vdi_d=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vsi_s=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vge_e=(+T8_Ve_di_Vge_e*T4+T8_Ve_di*T4_Vge_e+T8_Vge_e*T4_Ve_di+T8*T4_Ve_di_Vge_e);
  T5_Ve_di_Vdi_si=(+T8_Ve_di_Vdi_si*T4+T8_Ve_di*T4_Vdi_si+T8_Vdi_si*T4_Ve_di+T8*T4_Ve_di_Vdi_si);
  T5_Ve_di_Ve_si=(+T8_Ve_di_Ve_si*T4+T8_Ve_di*T4_Ve_si+T8_Ve_si*T4_Ve_di+T8*T4_Ve_di_Ve_si);
  T5_Ve_di_Ve_di=(+T8_Ve_di_Ve_di*T4+T8_Ve_di*T4_Ve_di+T8_Ve_di*T4_Ve_di+T8*T4_Ve_di_Ve_di);
  T5_Ve_di_Vge_si=(+T8_Ve_di_Vge_si*T4+T8_Ve_di*T4_Vge_si+T8_Vge_si*T4_Ve_di+T8*T4_Ve_di_Vge_si);
  T5_Ve_di_Tempt_GND=(+T8_Ve_di_Tempt_GND*T4+T8_Ve_di*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_di+T8*T4_Ve_di_Tempt_GND);
#endif
T5_Vge_si=((T8_Vge_si*T4)+(T8*T4_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0*T4+T8_Vge_si*T4_Vge_di+0.0*T4_Vge_si+T8*T4_Vge_si_Vge_di);
  T5_Vge_si_Vdi_d=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vsi_s=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vge_e=(+T8_Vge_si_Vge_e*T4+T8_Vge_si*T4_Vge_e+T8_Vge_e*T4_Vge_si+T8*T4_Vge_si_Vge_e);
  T5_Vge_si_Vdi_si=(+T8_Vge_si_Vdi_si*T4+T8_Vge_si*T4_Vdi_si+T8_Vdi_si*T4_Vge_si+T8*T4_Vge_si_Vdi_si);
  T5_Vge_si_Ve_si=(+T8_Vge_si_Ve_si*T4+T8_Vge_si*T4_Ve_si+T8_Ve_si*T4_Vge_si+T8*T4_Vge_si_Ve_si);
  T5_Vge_si_Ve_di=(+T8_Vge_si_Ve_di*T4+T8_Vge_si*T4_Ve_di+T8_Ve_di*T4_Vge_si+T8*T4_Vge_si_Ve_di);
  T5_Vge_si_Vge_si=(+T8_Vge_si_Vge_si*T4+T8_Vge_si*T4_Vge_si+T8_Vge_si*T4_Vge_si+T8*T4_Vge_si_Vge_si);
  T5_Vge_si_Tempt_GND=(+T8_Vge_si_Tempt_GND*T4+T8_Vge_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vge_si+T8*T4_Vge_si_Tempt_GND);
#endif
T5_Tempt_GND=((T8_Tempt_GND*T4)+(T8*T4_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*T4+T8_Tempt_GND*T4_Vge_di+0.0*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_di);
  T5_Tempt_GND_Vdi_d=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vsi_s=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vge_e=(+T8_Tempt_GND_Vge_e*T4+T8_Tempt_GND*T4_Vge_e+T8_Vge_e*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_e);
  T5_Tempt_GND_Vdi_si=(+T8_Tempt_GND_Vdi_si*T4+T8_Tempt_GND*T4_Vdi_si+T8_Vdi_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vdi_si);
  T5_Tempt_GND_Ve_si=(+T8_Tempt_GND_Ve_si*T4+T8_Tempt_GND*T4_Ve_si+T8_Ve_si*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_si);
  T5_Tempt_GND_Ve_di=(+T8_Tempt_GND_Ve_di*T4+T8_Tempt_GND*T4_Ve_di+T8_Ve_di*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_di);
  T5_Tempt_GND_Vge_si=(+T8_Tempt_GND_Vge_si*T4+T8_Tempt_GND*T4_Vge_si+T8_Vge_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_si);
  T5_Tempt_GND_Tempt_GND=(+T8_Tempt_GND_Tempt_GND*T4+T8_Tempt_GND*T4_Tempt_GND+T8_Tempt_GND*T4_Tempt_GND+T8*T4_Tempt_GND_Tempt_GND);
#endif
#endif
T5=(T8*T4);
EXIT_IF_ISNAN((T8*T4))
{
double m00_logE(d00_logE0,(-qm))
double m00_logE(d00_logE1,T5)
double m00_pow(d00_pow2,(-(qm+qdep)),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-qm))
double m10_logE(d10_logE1,d00_logE1,T5)
double m10_pow(d10_pow2,d00_pow2,(-(qm+qdep)),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=0.0;
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=0.0;
  e0_Vge_e_Vge_si=0.0;
  e0_Vge_e_Ve_si=0.0;
  e0_Vge_e_Ve_di=0.0;
  e0_Vge_e_Vdi_si=0.0;
  e0_Vge_e_Tempt_GND=0.0;
#endif
e0_Vge_si=((((F0_Vge_si-qm_Vge_si)+(-qm_Vge_si)*d10_logE0)+T5_Vge_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vge_si=(+(+(+(+F0_Vge_si_Vge_si-qm_Vge_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_si=(+(+(+(+F0_Vge_si_Ve_si-qm_Vge_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_di=(+(+(+(+F0_Vge_si_Ve_di-qm_Vge_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vdi_si=(+(+(+(+F0_Vge_si_Vdi_si-qm_Vge_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Tempt_GND=(+(+(+(+F0_Vge_si_Tempt_GND-qm_Vge_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vge_si+d10_logE1*T5_Vge_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_si=((((F0_Ve_si-qm_Ve_si)+(-qm_Ve_si)*d10_logE0)+T5_Ve_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vge_si=(+(+(+(+F0_Ve_si_Vge_si-qm_Ve_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_si=(+(+(+(+F0_Ve_si_Ve_si-qm_Ve_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_di=(+(+(+(+F0_Ve_si_Ve_di-qm_Ve_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vdi_si=(+(+(+(+F0_Ve_si_Vdi_si-qm_Ve_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Tempt_GND=(+(+(+(+F0_Ve_si_Tempt_GND-qm_Ve_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_si+d10_logE1*T5_Ve_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_di=((((F0_Ve_di-qm_Ve_di)+(-qm_Ve_di)*d10_logE0)+T5_Ve_di*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vge_si=(+(+(+(+F0_Ve_di_Vge_si-qm_Ve_di_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_si=(+(+(+(+F0_Ve_di_Ve_si-qm_Ve_di_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_di=(+(+(+(+F0_Ve_di_Ve_di-qm_Ve_di_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vdi_si=(+(+(+(+F0_Ve_di_Vdi_si-qm_Ve_di_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Tempt_GND=(+(+(+(+F0_Ve_di_Tempt_GND-qm_Ve_di_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_di+d10_logE1*T5_Ve_di_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
#endif
e0_Vdi_si=((((F0_Vdi_si-qm_Vdi_si)+(-qm_Vdi_si)*d10_logE0)+T5_Vdi_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vge_si=(+(+(+(+F0_Vdi_si_Vge_si-qm_Vdi_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_si=(+(+(+(+F0_Vdi_si_Ve_si-qm_Vdi_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_di=(+(+(+(+F0_Vdi_si_Ve_di-qm_Vdi_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vdi_si=(+(+(+(+F0_Vdi_si_Vdi_si-qm_Vdi_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Tempt_GND=(+(+(+(+F0_Vdi_si_Tempt_GND-qm_Vdi_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vdi_si+d10_logE1*T5_Vdi_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
#endif
e0_Tempt_GND=((((F0_Tempt_GND-qm_Tempt_GND)+(-qm_Tempt_GND)*d10_logE0)+T5_Tempt_GND*d10_logE1)+((QMFACTORCVfinal_Tempt_GND*d00_pow2)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_e))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vge_si=(+(+(+(+F0_Tempt_GND_Vge_si-qm_Tempt_GND_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_si=(+(+(+(+F0_Tempt_GND_Ve_si-qm_Tempt_GND_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_di=(+(+(+(+F0_Tempt_GND_Ve_di-qm_Tempt_GND_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_di))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vdi_si=(+(+(+(+F0_Tempt_GND_Vdi_si-qm_Tempt_GND_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vdi_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Tempt_GND=(+(+(+(+F0_Tempt_GND_Tempt_GND-qm_Tempt_GND_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Tempt_GND))+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
#endif
#endif
e0=((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2));
EXIT_IF_ISNAN(((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=0.0;
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=0.0;
  e1_Vge_e_Vdi_si=0.0;
  e1_Vge_e_Ve_si=0.0;
  e1_Vge_e_Ve_di=0.0;
  e1_Vge_e_Vge_si=0.0;
  e1_Vge_e_Tempt_GND=0.0;
#endif
e1_Vdi_si=(((-qm_Vdi_si/qm/qm)+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vdi_si+1.0*0.0)/qm/qm+2*1.0*qm_Vdi_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_e)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_e/T8/T8/T8)-T4_Vdi_si_Vge_e)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vdi_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vdi_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vdi_si/T8/T8/T8)-T4_Vdi_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_si/T8/T8/T8)-T4_Vdi_si_Ve_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_di)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_di)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_di/T8/T8/T8)-T4_Vdi_si_Ve_di)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vge_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_si/T8/T8/T8)-T4_Vdi_si_Vge_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Tempt_GND)/qm/qm+2*1.0*qm_Vdi_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Tempt_GND)/T8/T8+2*2.0*T8_Vdi_si*T8_Tempt_GND/T8/T8/T8)-T4_Vdi_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_si=(((-qm_Ve_si/qm/qm)+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_si+1.0*0.0)/qm/qm+2*1.0*qm_Ve_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_e)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_e/T8/T8/T8)-T4_Ve_si_Vge_e)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vdi_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vdi_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vdi_si/T8/T8/T8)-T4_Ve_si_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_si)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_si)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_si/T8/T8/T8)-T4_Ve_si_Ve_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_di)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_di)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_di/T8/T8/T8)-T4_Ve_si_Ve_di)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vge_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_si/T8/T8/T8)-T4_Ve_si_Vge_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_si+1.0*qm_Ve_si_Tempt_GND)/qm/qm+2*1.0*qm_Ve_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_si+2.0*T8_Ve_si_Tempt_GND)/T8/T8+2*2.0*T8_Ve_si*T8_Tempt_GND/T8/T8/T8)-T4_Ve_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_di=(((-qm_Ve_di/qm/qm)+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_di+1.0*0.0)/qm/qm+2*1.0*qm_Ve_di*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_e)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_e/T8/T8/T8)-T4_Ve_di_Vge_e)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vdi_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vdi_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vdi_si/T8/T8/T8)-T4_Ve_di_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_si)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_si)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_si/T8/T8/T8)-T4_Ve_di_Ve_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_di)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_di)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_di/T8/T8/T8)-T4_Ve_di_Ve_di)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vge_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_si/T8/T8/T8)-T4_Ve_di_Vge_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_di+1.0*qm_Ve_di_Tempt_GND)/qm/qm+2*1.0*qm_Ve_di*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_di+2.0*T8_Ve_di_Tempt_GND)/T8/T8+2*2.0*T8_Ve_di*T8_Tempt_GND/T8/T8/T8)-T4_Ve_di_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Vge_si=(((-qm_Vge_si/qm/qm)+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vge_si+1.0*0.0)/qm/qm+2*1.0*qm_Vge_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_e)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_e/T8/T8/T8)-T4_Vge_si_Vge_e)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vdi_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vdi_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vdi_si/T8/T8/T8)-T4_Vge_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_si)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_si)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_si/T8/T8/T8)-T4_Vge_si_Ve_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_di)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_di)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_di/T8/T8/T8)-T4_Vge_si_Ve_di)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vge_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_si/T8/T8/T8)-T4_Vge_si_Vge_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vge_si+1.0*qm_Vge_si_Tempt_GND)/qm/qm+2*1.0*qm_Vge_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vge_si+2.0*T8_Vge_si_Tempt_GND)/T8/T8+2*2.0*T8_Vge_si*T8_Tempt_GND/T8/T8/T8)-T4_Vge_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Tempt_GND=(((-qm_Tempt_GND/qm/qm)+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*rc)-((((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Tempt_GND+1.0*0.0)/qm/qm+2*1.0*qm_Tempt_GND*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_e)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_e/T8/T8/T8)-T4_Tempt_GND_Vge_e)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*0.0+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vdi_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vdi_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vdi_si/T8/T8/T8)-T4_Tempt_GND_Vdi_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_si/T8/T8/T8)-T4_Tempt_GND_Ve_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_di)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_di)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_di/T8/T8/T8)-T4_Tempt_GND_Ve_di)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vge_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_si/T8/T8/T8)-T4_Tempt_GND_Vge_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Tempt_GND)/qm/qm+2*1.0*qm_Tempt_GND*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Tempt_GND)/T8/T8+2*2.0*T8_Tempt_GND*T8_Tempt_GND/T8/T8/T8)-T4_Tempt_GND_Tempt_GND)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e1=((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN(((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
e2_Vdi_si=((-(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e2_Vdi_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vdi_si*qm+qm_Vdi_si*qm_Vdi_si+qm_Vdi_si*qm_Vdi_si+qm*qm_Vdi_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_si*qm+qm_Vdi_si*qm_Ve_si+qm_Ve_si*qm_Vdi_si+qm*qm_Vdi_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_di*qm+qm_Vdi_si*qm_Ve_di+qm_Ve_di*qm_Vdi_si+qm*qm_Vdi_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vge_si*qm+qm_Vdi_si*qm_Vge_si+qm_Vge_si*qm_Vdi_si+qm*qm_Vdi_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Tempt_GND*qm+qm_Vdi_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vdi_si+qm*qm_Vdi_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_si=((-(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e2_Ve_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vdi_si*qm+qm_Ve_si*qm_Vdi_si+qm_Vdi_si*qm_Ve_si+qm*qm_Ve_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_si*qm+qm_Ve_si*qm_Ve_si+qm_Ve_si*qm_Ve_si+qm*qm_Ve_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_di*qm+qm_Ve_si*qm_Ve_di+qm_Ve_di*qm_Ve_si+qm*qm_Ve_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vge_si*qm+qm_Ve_si*qm_Vge_si+qm_Vge_si*qm_Ve_si+qm*qm_Ve_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Tempt_GND*qm+qm_Ve_si*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_si+qm*qm_Ve_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_di=((-(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e2_Ve_di_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vdi_si*qm+qm_Ve_di*qm_Vdi_si+qm_Vdi_si*qm_Ve_di+qm*qm_Ve_di_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_si*qm+qm_Ve_di*qm_Ve_si+qm_Ve_si*qm_Ve_di+qm*qm_Ve_di_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_di*qm+qm_Ve_di*qm_Ve_di+qm_Ve_di*qm_Ve_di+qm*qm_Ve_di_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vge_si*qm+qm_Ve_di*qm_Vge_si+qm_Vge_si*qm_Ve_di+qm*qm_Ve_di_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Tempt_GND*qm+qm_Ve_di*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_di+qm*qm_Ve_di_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Vge_si=((-(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e2_Vge_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vdi_si*qm+qm_Vge_si*qm_Vdi_si+qm_Vdi_si*qm_Vge_si+qm*qm_Vge_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_si*qm+qm_Vge_si*qm_Ve_si+qm_Ve_si*qm_Vge_si+qm*qm_Vge_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_di*qm+qm_Vge_si*qm_Ve_di+qm_Ve_di*qm_Vge_si+qm*qm_Vge_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vge_si*qm+qm_Vge_si*qm_Vge_si+qm_Vge_si*qm_Vge_si+qm*qm_Vge_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Tempt_GND*qm+qm_Vge_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vge_si+qm*qm_Vge_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Tempt_GND=((-(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))/(qm*qm)/(qm*qm))-((((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e2_Tempt_GND_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vdi_si*qm+qm_Tempt_GND*qm_Vdi_si+qm_Vdi_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_si*qm+qm_Tempt_GND*qm_Ve_si+qm_Ve_si*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_di*qm+qm_Tempt_GND*qm_Ve_di+qm_Ve_di*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vge_si*qm+qm_Tempt_GND*qm_Vge_si+qm_Vge_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Tempt_GND*qm+qm_Tempt_GND*qm_Tempt_GND+qm_Tempt_GND*qm_Tempt_GND+qm*qm_Tempt_GND_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e2=(((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN((((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(qm_Vdi_si-((((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+qm_Vdi_si_Vdi_si-(+(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vdi_si*e2+e0_Vdi_si*e2_Vdi_si+e0_Vdi_si*e2_Vdi_si+e0*e2_Vdi_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vdi_si)*e1+(2.0*e1_Vdi_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_si=(+qm_Vdi_si_Ve_si-(+(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_si*e2+e0_Vdi_si*e2_Ve_si+e0_Ve_si*e2_Vdi_si+e0*e2_Vdi_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_si)*e1+(2.0*e1_Vdi_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_di=(+qm_Vdi_si_Ve_di-(+(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_di*e2+e0_Vdi_si*e2_Ve_di+e0_Ve_di*e2_Vdi_si+e0*e2_Vdi_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_di)*e1+(2.0*e1_Vdi_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Vge_si=(+qm_Vdi_si_Vge_si-(+(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vge_si*e2+e0_Vdi_si*e2_Vge_si+e0_Vge_si*e2_Vdi_si+e0*e2_Vdi_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vge_si)*e1+(2.0*e1_Vdi_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Tempt_GND=(+qm_Vdi_si_Tempt_GND-(+(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Tempt_GND*e2+e0_Vdi_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vdi_si+e0*e2_Vdi_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Tempt_GND)*e1+(2.0*e1_Vdi_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_si=(qm_Ve_si-((((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+qm_Ve_si_Vdi_si-(+(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vdi_si*e2+e0_Ve_si*e2_Vdi_si+e0_Vdi_si*e2_Ve_si+e0*e2_Ve_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vdi_si)*e1+(2.0*e1_Ve_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_si=(+qm_Ve_si_Ve_si-(+(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_si*e2+e0_Ve_si*e2_Ve_si+e0_Ve_si*e2_Ve_si+e0*e2_Ve_si_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_si)*e1+(2.0*e1_Ve_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_di=(+qm_Ve_si_Ve_di-(+(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_di*e2+e0_Ve_si*e2_Ve_di+e0_Ve_di*e2_Ve_si+e0*e2_Ve_si_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_di)*e1+(2.0*e1_Ve_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Vge_si=(+qm_Ve_si_Vge_si-(+(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vge_si*e2+e0_Ve_si*e2_Vge_si+e0_Vge_si*e2_Ve_si+e0*e2_Ve_si_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vge_si)*e1+(2.0*e1_Ve_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Tempt_GND=(+qm_Ve_si_Tempt_GND-(+(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Tempt_GND*e2+e0_Ve_si*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_si+e0*e2_Ve_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_si+2.0*e1_Ve_si_Tempt_GND)*e1+(2.0*e1_Ve_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_di=(qm_Ve_di-((((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+qm_Ve_di_Vdi_si-(+(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vdi_si*e2+e0_Ve_di*e2_Vdi_si+e0_Vdi_si*e2_Ve_di+e0*e2_Ve_di_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vdi_si)*e1+(2.0*e1_Ve_di)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_si=(+qm_Ve_di_Ve_si-(+(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_si*e2+e0_Ve_di*e2_Ve_si+e0_Ve_si*e2_Ve_di+e0*e2_Ve_di_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_si)*e1+(2.0*e1_Ve_di)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_di=(+qm_Ve_di_Ve_di-(+(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_di*e2+e0_Ve_di*e2_Ve_di+e0_Ve_di*e2_Ve_di+e0*e2_Ve_di_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_di)*e1+(2.0*e1_Ve_di)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Vge_si=(+qm_Ve_di_Vge_si-(+(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vge_si*e2+e0_Ve_di*e2_Vge_si+e0_Vge_si*e2_Ve_di+e0*e2_Ve_di_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vge_si)*e1+(2.0*e1_Ve_di)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Tempt_GND=(+qm_Ve_di_Tempt_GND-(+(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Tempt_GND*e2+e0_Ve_di*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_di+e0*e2_Ve_di_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_di+2.0*e1_Ve_di_Tempt_GND)*e1+(2.0*e1_Ve_di)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Vge_si=(qm_Vge_si-((((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+qm_Vge_si_Vdi_si-(+(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vdi_si*e2+e0_Vge_si*e2_Vdi_si+e0_Vdi_si*e2_Vge_si+e0*e2_Vge_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vdi_si)*e1+(2.0*e1_Vge_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_si=(+qm_Vge_si_Ve_si-(+(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_si*e2+e0_Vge_si*e2_Ve_si+e0_Ve_si*e2_Vge_si+e0*e2_Vge_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_si)*e1+(2.0*e1_Vge_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_di=(+qm_Vge_si_Ve_di-(+(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_di*e2+e0_Vge_si*e2_Ve_di+e0_Ve_di*e2_Vge_si+e0*e2_Vge_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_di)*e1+(2.0*e1_Vge_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Vge_si=(+qm_Vge_si_Vge_si-(+(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vge_si*e2+e0_Vge_si*e2_Vge_si+e0_Vge_si*e2_Vge_si+e0*e2_Vge_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vge_si)*e1+(2.0*e1_Vge_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Tempt_GND=(+qm_Vge_si_Tempt_GND-(+(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Tempt_GND*e2+e0_Vge_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vge_si+e0*e2_Vge_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vge_si+2.0*e1_Vge_si_Tempt_GND)*e1+(2.0*e1_Vge_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Tempt_GND=(qm_Tempt_GND-((((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+qm_Tempt_GND_Vdi_si-(+(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vdi_si*e2+e0_Tempt_GND*e2_Vdi_si+e0_Vdi_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vdi_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vdi_si)*e1+(2.0*e1_Tempt_GND)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_si=(+qm_Tempt_GND_Ve_si-(+(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_si*e2+e0_Tempt_GND*e2_Ve_si+e0_Ve_si*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_si)*e1+(2.0*e1_Tempt_GND)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_di=(+qm_Tempt_GND_Ve_di-(+(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_di*e2+e0_Tempt_GND*e2_Ve_di+e0_Ve_di*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_di)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_di)*e1+(2.0*e1_Tempt_GND)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Vge_si=(+qm_Tempt_GND_Vge_si-(+(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vge_si*e2+e0_Tempt_GND*e2_Vge_si+e0_Vge_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vge_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vge_si)*e1+(2.0*e1_Tempt_GND)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Tempt_GND=(+qm_Tempt_GND_Tempt_GND-(+(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Tempt_GND*e2+e0_Tempt_GND*e2_Tempt_GND+e0_Tempt_GND*e2_Tempt_GND+e0*e2_Tempt_GND_Tempt_GND)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Tempt_GND)*e1+(2.0*e1_Tempt_GND)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
#endif
qm=(qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
EXIT_IF_ISNAN((qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(((-qm_Vdi_si)*qm)+((-qm)*qm_Vdi_si));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+0.0*qm+(-qm_Vdi_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Vdi_si);
  qm_Vdi_si_Ve_si=(+0.0*qm+(-qm_Vdi_si)*qm_Ve_si+(-qm_Ve_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Ve_si);
  qm_Vdi_si_Ve_di=(+0.0*qm+(-qm_Vdi_si)*qm_Ve_di+(-qm_Ve_di)*qm_Vdi_si+(-qm)*qm_Vdi_si_Ve_di);
  qm_Vdi_si_Vge_si=(+0.0*qm+(-qm_Vdi_si)*qm_Vge_si+(-qm_Vge_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Vge_si);
  qm_Vdi_si_Tempt_GND=(+0.0*qm+(-qm_Vdi_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Vdi_si+(-qm)*qm_Vdi_si_Tempt_GND);
#endif
qm_Ve_si=(((-qm_Ve_si)*qm)+((-qm)*qm_Ve_si));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+0.0*qm+(-qm_Ve_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Ve_si+(-qm)*qm_Ve_si_Vdi_si);
  qm_Ve_si_Ve_si=(+0.0*qm+(-qm_Ve_si)*qm_Ve_si+(-qm_Ve_si)*qm_Ve_si+(-qm)*qm_Ve_si_Ve_si);
  qm_Ve_si_Ve_di=(+0.0*qm+(-qm_Ve_si)*qm_Ve_di+(-qm_Ve_di)*qm_Ve_si+(-qm)*qm_Ve_si_Ve_di);
  qm_Ve_si_Vge_si=(+0.0*qm+(-qm_Ve_si)*qm_Vge_si+(-qm_Vge_si)*qm_Ve_si+(-qm)*qm_Ve_si_Vge_si);
  qm_Ve_si_Tempt_GND=(+0.0*qm+(-qm_Ve_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Ve_si+(-qm)*qm_Ve_si_Tempt_GND);
#endif
qm_Ve_di=(((-qm_Ve_di)*qm)+((-qm)*qm_Ve_di));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+0.0*qm+(-qm_Ve_di)*qm_Vdi_si+(-qm_Vdi_si)*qm_Ve_di+(-qm)*qm_Ve_di_Vdi_si);
  qm_Ve_di_Ve_si=(+0.0*qm+(-qm_Ve_di)*qm_Ve_si+(-qm_Ve_si)*qm_Ve_di+(-qm)*qm_Ve_di_Ve_si);
  qm_Ve_di_Ve_di=(+0.0*qm+(-qm_Ve_di)*qm_Ve_di+(-qm_Ve_di)*qm_Ve_di+(-qm)*qm_Ve_di_Ve_di);
  qm_Ve_di_Vge_si=(+0.0*qm+(-qm_Ve_di)*qm_Vge_si+(-qm_Vge_si)*qm_Ve_di+(-qm)*qm_Ve_di_Vge_si);
  qm_Ve_di_Tempt_GND=(+0.0*qm+(-qm_Ve_di)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Ve_di+(-qm)*qm_Ve_di_Tempt_GND);
#endif
qm_Vge_si=(((-qm_Vge_si)*qm)+((-qm)*qm_Vge_si));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+0.0*qm+(-qm_Vge_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Vge_si+(-qm)*qm_Vge_si_Vdi_si);
  qm_Vge_si_Ve_si=(+0.0*qm+(-qm_Vge_si)*qm_Ve_si+(-qm_Ve_si)*qm_Vge_si+(-qm)*qm_Vge_si_Ve_si);
  qm_Vge_si_Ve_di=(+0.0*qm+(-qm_Vge_si)*qm_Ve_di+(-qm_Ve_di)*qm_Vge_si+(-qm)*qm_Vge_si_Ve_di);
  qm_Vge_si_Vge_si=(+0.0*qm+(-qm_Vge_si)*qm_Vge_si+(-qm_Vge_si)*qm_Vge_si+(-qm)*qm_Vge_si_Vge_si);
  qm_Vge_si_Tempt_GND=(+0.0*qm+(-qm_Vge_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Vge_si+(-qm)*qm_Vge_si_Tempt_GND);
#endif
qm_Tempt_GND=(((-qm_Tempt_GND)*qm)+((-qm)*qm_Tempt_GND));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Vdi_si+(-qm_Vdi_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Vdi_si);
  qm_Tempt_GND_Ve_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Ve_si+(-qm_Ve_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Ve_si);
  qm_Tempt_GND_Ve_di=(+0.0*qm+(-qm_Tempt_GND)*qm_Ve_di+(-qm_Ve_di)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Ve_di);
  qm_Tempt_GND_Vge_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Vge_si+(-qm_Vge_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Vge_si);
  qm_Tempt_GND_Tempt_GND=(+0.0*qm+(-qm_Tempt_GND)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Tempt_GND);
#endif
#endif
qm=((-qm)*qm);
EXIT_IF_ISNAN(((-qm)*qm))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qis_Vdi_si=(((-qm_Vdi_si)*nVtm)+((-qm)*nVtm_Vdi_si));
#if defined(_DERIVATE2)
  qis_Vdi_si_Vdi_si=(+0.0*nVtm+(-qm_Vdi_si)*nVtm_Vdi_si+(-qm_Vdi_si)*nVtm_Vdi_si+(-qm)*nVtm_Vdi_si_Vdi_si);
  qis_Vdi_si_Ve_si=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Ve_si)*nVtm_Vdi_si+(-qm)*0.0);
  qis_Vdi_si_Ve_di=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Ve_di)*nVtm_Vdi_si+(-qm)*0.0);
  qis_Vdi_si_Vge_si=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Vge_si)*nVtm_Vdi_si+(-qm)*0.0);
  qis_Vdi_si_Tempt_GND=(+0.0*nVtm+(-qm_Vdi_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*nVtm_Vdi_si+(-qm)*nVtm_Vdi_si_Tempt_GND);
#endif
qis_Ve_si=(-qm_Ve_si)*nVtm;
#if defined(_DERIVATE2)
  qis_Ve_si_Vdi_si=(+0.0*nVtm+(-qm_Ve_si)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qis_Ve_si_Ve_si=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qis_Ve_si_Ve_di=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qis_Ve_si_Vge_si=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qis_Ve_si_Tempt_GND=(+0.0*nVtm+(-qm_Ve_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qis_Ve_di=(-qm_Ve_di)*nVtm;
#if defined(_DERIVATE2)
  qis_Ve_di_Vdi_si=(+0.0*nVtm+(-qm_Ve_di)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qis_Ve_di_Ve_si=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qis_Ve_di_Ve_di=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qis_Ve_di_Vge_si=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qis_Ve_di_Tempt_GND=(+0.0*nVtm+(-qm_Ve_di)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qis_Vge_si=(-qm_Vge_si)*nVtm;
#if defined(_DERIVATE2)
  qis_Vge_si_Vdi_si=(+0.0*nVtm+(-qm_Vge_si)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qis_Vge_si_Ve_si=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qis_Vge_si_Ve_di=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qis_Vge_si_Vge_si=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qis_Vge_si_Tempt_GND=(+0.0*nVtm+(-qm_Vge_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qis_Tempt_GND=(((-qm_Tempt_GND)*nVtm)+((-qm)*nVtm_Tempt_GND));
#if defined(_DERIVATE2)
  qis_Tempt_GND_Vdi_si=(+0.0*nVtm+(-qm_Tempt_GND)*nVtm_Vdi_si+(-qm_Vdi_si)*nVtm_Tempt_GND+(-qm)*nVtm_Tempt_GND_Vdi_si);
  qis_Tempt_GND_Ve_si=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Ve_si)*nVtm_Tempt_GND+(-qm)*0.0);
  qis_Tempt_GND_Ve_di=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Ve_di)*nVtm_Tempt_GND+(-qm)*0.0);
  qis_Tempt_GND_Vge_si=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Vge_si)*nVtm_Tempt_GND+(-qm)*0.0);
  qis_Tempt_GND_Tempt_GND=(+0.0*nVtm+(-qm_Tempt_GND)*nVtm_Tempt_GND+(-qm_Tempt_GND)*nVtm_Tempt_GND+(-qm)*nVtm_Tempt_GND_Tempt_GND);
#endif
#endif
qis=((-qm)*nVtm);
EXIT_IF_ISNAN(((-qm)*nVtm))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Eeffs_Tempt_GND=(EeffFactor*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)));
#if defined(_DERIVATE2)
  Eeffs_Tempt_GND_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)))+0.0*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND))+EeffFactor*(+0.0+(+eta_mu_Tempt_GND_Tempt_GND*qis+eta_mu_Tempt_GND*qis_Tempt_GND+eta_mu_Tempt_GND*qis_Tempt_GND+eta_mu*qis_Tempt_GND_Tempt_GND)));
  Eeffs_Tempt_GND_Vdi_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vdi_si))+0.0*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND))+EeffFactor*(+0.0+(+0.0*qis+eta_mu_Tempt_GND*qis_Vdi_si+0.0*qis_Tempt_GND+eta_mu*qis_Tempt_GND_Vdi_si)));
  Eeffs_Tempt_GND_Ve_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_si))+0.0*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND))+EeffFactor*(+0.0+(+0.0*qis+eta_mu_Tempt_GND*qis_Ve_si+0.0*qis_Tempt_GND+eta_mu*qis_Tempt_GND_Ve_si)));
  Eeffs_Tempt_GND_Ve_di=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_di))+0.0*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND))+EeffFactor*(+0.0+(+0.0*qis+eta_mu_Tempt_GND*qis_Ve_di+0.0*qis_Tempt_GND+eta_mu*qis_Tempt_GND_Ve_di)));
  Eeffs_Tempt_GND_Vge_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vge_si))+0.0*((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND))+EeffFactor*(+0.0+(+0.0*qis+eta_mu_Tempt_GND*qis_Vge_si+0.0*qis_Tempt_GND+eta_mu*qis_Tempt_GND_Vge_si)));
#endif
Eeffs_Vdi_si=(EeffFactor*(eta_mu*qis_Vdi_si));
#if defined(_DERIVATE2)
  Eeffs_Vdi_si_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)))+0.0*(eta_mu*qis_Vdi_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+eta_mu_Tempt_GND*qis_Vdi_si+eta_mu*qis_Vdi_si_Tempt_GND)));
  Eeffs_Vdi_si_Vdi_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vdi_si))+0.0*(eta_mu*qis_Vdi_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vdi_si+eta_mu*qis_Vdi_si_Vdi_si)));
  Eeffs_Vdi_si_Ve_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_si))+0.0*(eta_mu*qis_Vdi_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vdi_si+eta_mu*qis_Vdi_si_Ve_si)));
  Eeffs_Vdi_si_Ve_di=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_di))+0.0*(eta_mu*qis_Vdi_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vdi_si+eta_mu*qis_Vdi_si_Ve_di)));
  Eeffs_Vdi_si_Vge_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vge_si))+0.0*(eta_mu*qis_Vdi_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vdi_si+eta_mu*qis_Vdi_si_Vge_si)));
#endif
Eeffs_Ve_si=(EeffFactor*(eta_mu*qis_Ve_si));
#if defined(_DERIVATE2)
  Eeffs_Ve_si_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)))+0.0*(eta_mu*qis_Ve_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+eta_mu_Tempt_GND*qis_Ve_si+eta_mu*qis_Ve_si_Tempt_GND)));
  Eeffs_Ve_si_Vdi_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vdi_si))+0.0*(eta_mu*qis_Ve_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_si+eta_mu*qis_Ve_si_Vdi_si)));
  Eeffs_Ve_si_Ve_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_si))+0.0*(eta_mu*qis_Ve_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_si+eta_mu*qis_Ve_si_Ve_si)));
  Eeffs_Ve_si_Ve_di=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_di))+0.0*(eta_mu*qis_Ve_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_si+eta_mu*qis_Ve_si_Ve_di)));
  Eeffs_Ve_si_Vge_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vge_si))+0.0*(eta_mu*qis_Ve_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_si+eta_mu*qis_Ve_si_Vge_si)));
#endif
Eeffs_Ve_di=(EeffFactor*(eta_mu*qis_Ve_di));
#if defined(_DERIVATE2)
  Eeffs_Ve_di_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)))+0.0*(eta_mu*qis_Ve_di)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+eta_mu_Tempt_GND*qis_Ve_di+eta_mu*qis_Ve_di_Tempt_GND)));
  Eeffs_Ve_di_Vdi_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vdi_si))+0.0*(eta_mu*qis_Ve_di)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_di+eta_mu*qis_Ve_di_Vdi_si)));
  Eeffs_Ve_di_Ve_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_si))+0.0*(eta_mu*qis_Ve_di)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_di+eta_mu*qis_Ve_di_Ve_si)));
  Eeffs_Ve_di_Ve_di=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_di))+0.0*(eta_mu*qis_Ve_di)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_di+eta_mu*qis_Ve_di_Ve_di)));
  Eeffs_Ve_di_Vge_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vge_si))+0.0*(eta_mu*qis_Ve_di)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_di+eta_mu*qis_Ve_di_Vge_si)));
#endif
Eeffs_Vge_si=(EeffFactor*(eta_mu*qis_Vge_si));
#if defined(_DERIVATE2)
  Eeffs_Vge_si_Tempt_GND=(+0.0*(qbs+(eta_mu*qis))+0.0*(((eta_mu_Tempt_GND*qis)+(eta_mu*qis_Tempt_GND)))+0.0*(eta_mu*qis_Vge_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+eta_mu_Tempt_GND*qis_Vge_si+eta_mu*qis_Vge_si_Tempt_GND)));
  Eeffs_Vge_si_Vdi_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vdi_si))+0.0*(eta_mu*qis_Vge_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vge_si+eta_mu*qis_Vge_si_Vdi_si)));
  Eeffs_Vge_si_Ve_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_si))+0.0*(eta_mu*qis_Vge_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vge_si+eta_mu*qis_Vge_si_Ve_si)));
  Eeffs_Vge_si_Ve_di=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Ve_di))+0.0*(eta_mu*qis_Vge_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vge_si+eta_mu*qis_Vge_si_Ve_di)));
  Eeffs_Vge_si_Vge_si=(+0.0*(qbs+(eta_mu*qis))+0.0*((eta_mu*qis_Vge_si))+0.0*(eta_mu*qis_Vge_si)+EeffFactor*(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vge_si+eta_mu*qis_Vge_si_Vge_si)));
#endif
#endif
Eeffs=(EeffFactor*(qbs+(eta_mu*qis)));
EXIT_IF_ISNAN((EeffFactor*(qbs+(eta_mu*qis))))
qb0=(1.0e-2/cox);
EXIT_IF_ISNAN((1.0e-2/cox))
{
double m00_fabs(d00_fabs0,(qis/qb0))
double m00_pow(d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(qis/qb0))
double m10_pow(d10_pow1,d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
double m11_pow(d11_pow1,d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(d10_pow1*(0.5*(qis_Vge_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=fixme;
  T2_Vge_si_Vsi_s=fixme;
  T2_Vge_si_Vge_di=fixme;
  T2_Vge_si_Vge_e=fixme;
  T2_Vge_si_Vge_si=fixme;
  T2_Vge_si_Ve_si=fixme;
  T2_Vge_si_Ve_di=fixme;
  T2_Vge_si_Vdi_si=fixme;
  T2_Vge_si_Tempt_GND=fixme;
#endif
T2_Ve_si=(d10_pow1*(0.5*(qis_Ve_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=fixme;
  T2_Ve_si_Vsi_s=fixme;
  T2_Ve_si_Vge_di=fixme;
  T2_Ve_si_Vge_e=fixme;
  T2_Ve_si_Vge_si=fixme;
  T2_Ve_si_Ve_si=fixme;
  T2_Ve_si_Ve_di=fixme;
  T2_Ve_si_Vdi_si=fixme;
  T2_Ve_si_Tempt_GND=fixme;
#endif
T2_Ve_di=(d10_pow1*(0.5*(qis_Ve_di/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=fixme;
  T2_Ve_di_Vsi_s=fixme;
  T2_Ve_di_Vge_di=fixme;
  T2_Ve_di_Vge_e=fixme;
  T2_Ve_di_Vge_si=fixme;
  T2_Ve_di_Ve_si=fixme;
  T2_Ve_di_Ve_di=fixme;
  T2_Ve_di_Vdi_si=fixme;
  T2_Ve_di_Tempt_GND=fixme;
#endif
T2_Vdi_si=(d10_pow1*(0.5*(qis_Vdi_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=fixme;
  T2_Vdi_si_Vsi_s=fixme;
  T2_Vdi_si_Vge_di=fixme;
  T2_Vdi_si_Vge_e=fixme;
  T2_Vdi_si_Vge_si=fixme;
  T2_Vdi_si_Ve_si=fixme;
  T2_Vdi_si_Ve_di=fixme;
  T2_Vdi_si_Vdi_si=fixme;
  T2_Vdi_si_Tempt_GND=fixme;
#endif
T2_Tempt_GND=(d10_pow1*(0.5*(qis_Tempt_GND/qb0)*d10_fabs0)+d11_pow1*UCS_t_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=fixme;
  T2_Tempt_GND_Vsi_s=fixme;
  T2_Tempt_GND_Vge_di=fixme;
  T2_Tempt_GND_Vge_e=fixme;
  T2_Tempt_GND_Vge_si=fixme;
  T2_Tempt_GND_Ve_si=fixme;
  T2_Tempt_GND_Ve_di=fixme;
  T2_Tempt_GND_Vdi_si=fixme;
  T2_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T2=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
if
((pModel->BULKMOD!=0))
{
{
double m00_fabs(d00_fabs0,Eeffs)
double m00_pow(d00_pow1,d00_fabs0,EU_a)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,Eeffs)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,EU_a)
double m11_pow(d11_pow1,d00_pow1,d00_fabs0,EU_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=((((UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)))+((UD_a_Vdi_si*T2-UD_a*T2_Vdi_si)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_d)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_d/T2/T2/T2));
  T3_Vdi_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vsi_s)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vsi_s/T2/T2/T2));
  T3_Vdi_si_Vge_di=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_di/T2/T2/T2));
  T3_Vdi_si_Vge_e=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_e+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_e)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_e/T2/T2/T2));
  T3_Vdi_si_Vdi_si=(+(+(+UA_a_Vdi_si_Vdi_si+(+UC_a_Vdi_si_Vdi_si*veseff+UC_a_Vdi_si*veseff_Vdi_si+UC_a_Vdi_si*veseff_Vdi_si+UC_a*veseff_Vdi_si_Vdi_si))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Vdi_si_Vdi_si/T2-(UD_a_Vdi_si*T2_Vdi_si+UD_a_Vdi_si*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_si/T2/T2/T2));
  T3_Vdi_si_Ve_si=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*veseff_Ve_si+0.0*veseff_Vdi_si+UC_a*veseff_Vdi_si_Ve_si))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_si/T2/T2/T2));
  T3_Vdi_si_Ve_di=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*veseff_Ve_di+0.0*veseff_Vdi_si+UC_a*veseff_Vdi_si_Ve_di))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_di/T2/T2/T2));
  T3_Vdi_si_Vge_si=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_si/T2/T2/T2));
  T3_Vdi_si_Tempt_GND=(+(+(+UA_a_Vdi_si_Tempt_GND+(+UC_a_Vdi_si_Tempt_GND*veseff+UC_a_Vdi_si*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Vdi_si+UC_a*veseff_Vdi_si_Tempt_GND))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Vdi_si_Tempt_GND/T2-(UD_a_Vdi_si*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_si+UD_a*T2_Vdi_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_si=((((UC_a*veseff_Ve_si)*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)))+(-UD_a*T2_Ve_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vdi_d)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_d/T2/T2/T2));
  T3_Ve_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vsi_s)/T2/T2+2*UD_a*T2_Ve_si*T2_Vsi_s/T2/T2/T2));
  T3_Ve_si_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_di/T2/T2/T2));
  T3_Ve_si_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_e)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_e/T2/T2/T2));
  T3_Ve_si_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*veseff_Ve_si+UC_a*veseff_Ve_si_Vdi_si))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_si+UD_a*T2_Ve_si_Vdi_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_si/T2/T2/T2));
  T3_Ve_si_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*veseff_Ve_si+UC_a*veseff_Ve_si_Ve_si))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_si/T2/T2/T2));
  T3_Ve_si_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*veseff_Ve_si+UC_a*veseff_Ve_si_Ve_di))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_di/T2/T2/T2));
  T3_Ve_si_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_si/T2/T2/T2));
  T3_Ve_si_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Ve_si+UC_a*veseff_Ve_si_Tempt_GND))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_si+UD_a*T2_Ve_si_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_di=((((UC_a*veseff_Ve_di)*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)))+(-UD_a*T2_Ve_di/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vdi_d)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_d/T2/T2/T2));
  T3_Ve_di_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vsi_s)/T2/T2+2*UD_a*T2_Ve_di*T2_Vsi_s/T2/T2/T2));
  T3_Ve_di_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_di/T2/T2/T2));
  T3_Ve_di_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_e)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_e/T2/T2/T2));
  T3_Ve_di_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*veseff_Ve_di+UC_a*veseff_Ve_di_Vdi_si))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_di+UD_a*T2_Ve_di_Vdi_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_si/T2/T2/T2));
  T3_Ve_di_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*veseff_Ve_di+UC_a*veseff_Ve_di_Ve_si))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_si/T2/T2/T2));
  T3_Ve_di_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*veseff_Ve_di+UC_a*veseff_Ve_di_Ve_di))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_di/T2/T2/T2));
  T3_Ve_di_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_si/T2/T2/T2));
  T3_Ve_di_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Ve_di+UC_a*veseff_Ve_di_Tempt_GND))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_di+UD_a*T2_Ve_di_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_di*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vge_si=(((UA_a+(UC_a*veseff))*(d10_pow1*Eeffs_Vge_si*d10_fabs0))+(-UD_a*T2_Vge_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vdi_d)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_d/T2/T2/T2));
  T3_Vge_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vsi_s)/T2/T2+2*UD_a*T2_Vge_si*T2_Vsi_s/T2/T2/T2));
  T3_Vge_si_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_di/T2/T2/T2));
  T3_Vge_si_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_e)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_e/T2/T2/T2));
  T3_Vge_si_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_si+UD_a*T2_Vge_si_Vdi_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_si/T2/T2/T2));
  T3_Vge_si_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_si/T2/T2/T2));
  T3_Vge_si_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_di/T2/T2/T2));
  T3_Vge_si_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_si/T2/T2/T2));
  T3_Vge_si_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_si+UD_a*T2_Vge_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Tempt_GND=((((UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_d)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2));
  T3_Tempt_GND_Vsi_s=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vsi_s)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2));
  T3_Tempt_GND_Vge_di=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_di/T2/T2/T2));
  T3_Tempt_GND_Vge_e=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_e+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_e)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_e/T2/T2/T2));
  T3_Tempt_GND_Vdi_si=(+(+(+UA_a_Tempt_GND_Vdi_si+(+UC_a_Tempt_GND_Vdi_si*veseff+UC_a_Tempt_GND*veseff_Vdi_si+UC_a_Vdi_si*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Vdi_si))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Tempt_GND_Vdi_si/T2-(UD_a_Tempt_GND*T2_Vdi_si+UD_a_Vdi_si*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2));
  T3_Tempt_GND_Ve_si=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*veseff_Ve_si+0.0*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Ve_si))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_si/T2/T2/T2));
  T3_Tempt_GND_Ve_di=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*veseff_Ve_di+0.0*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Ve_di))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_di/T2/T2/T2));
  T3_Tempt_GND_Vge_si=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_si/T2/T2/T2));
  T3_Tempt_GND_Tempt_GND=(+(+(+UA_a_Tempt_GND_Tempt_GND+(+UC_a_Tempt_GND_Tempt_GND*veseff+UC_a_Tempt_GND*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Tempt_GND))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Tempt_GND_Tempt_GND/T2-(UD_a_Tempt_GND*T2_Tempt_GND+UD_a_Tempt_GND*T2_Tempt_GND+UD_a*T2_Tempt_GND_Tempt_GND)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2));
#endif
#endif
T3=(((UA_a+(UC_a*veseff))*d00_pow1)+(UD_a/T2));
EXIT_IF_ISNAN((((UA_a+(UC_a*veseff))*d00_pow1)+(UD_a/T2)))
}
}
else
{
{
double m00_fabs(d00_fabs0,Eeffs)
double m00_pow(d00_pow1,d00_fabs0,EU_a)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,Eeffs)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,EU_a)
double m11_pow(d11_pow1,d00_pow1,d00_fabs0,EU_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(((UA_a_Vdi_si*d00_pow1)+(UA_a*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)))+((UD_a_Vdi_si*T2-UD_a*T2_Vdi_si)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_d)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_d/T2/T2/T2));
  T3_Vdi_si_Vsi_s=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vsi_s)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vsi_s/T2/T2/T2));
  T3_Vdi_si_Vge_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_di/T2/T2/T2));
  T3_Vdi_si_Vge_e=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_e+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_e)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_e/T2/T2/T2));
  T3_Vdi_si_Vdi_si=(+(+UA_a_Vdi_si_Vdi_si*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Vdi_si/T2-(UD_a_Vdi_si*T2_Vdi_si+UD_a_Vdi_si*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_si/T2/T2/T2));
  T3_Vdi_si_Ve_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_si/T2/T2/T2));
  T3_Vdi_si_Ve_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_di/T2/T2/T2));
  T3_Vdi_si_Vge_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_si/T2/T2/T2));
  T3_Vdi_si_Tempt_GND=(+(+UA_a_Vdi_si_Tempt_GND*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Tempt_GND/T2-(UD_a_Vdi_si*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_si+UD_a*T2_Vdi_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_si=((UA_a*(d10_pow1*Eeffs_Ve_si*d10_fabs0))+(-UD_a*T2_Ve_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vdi_d)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_d/T2/T2/T2));
  T3_Ve_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vsi_s)/T2/T2+2*UD_a*T2_Ve_si*T2_Vsi_s/T2/T2/T2));
  T3_Ve_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_di/T2/T2/T2));
  T3_Ve_si_Vge_e=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_e)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_e/T2/T2/T2));
  T3_Ve_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_si+UD_a*T2_Ve_si_Vdi_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_si/T2/T2/T2));
  T3_Ve_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_si/T2/T2/T2));
  T3_Ve_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_di/T2/T2/T2));
  T3_Ve_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_si/T2/T2/T2));
  T3_Ve_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_si+UD_a*T2_Ve_si_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_di=((UA_a*(d10_pow1*Eeffs_Ve_di*d10_fabs0))+(-UD_a*T2_Ve_di/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vdi_d)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_d/T2/T2/T2));
  T3_Ve_di_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vsi_s)/T2/T2+2*UD_a*T2_Ve_di*T2_Vsi_s/T2/T2/T2));
  T3_Ve_di_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_di/T2/T2/T2));
  T3_Ve_di_Vge_e=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_e)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_e/T2/T2/T2));
  T3_Ve_di_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_di+UD_a*T2_Ve_di_Vdi_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_si/T2/T2/T2));
  T3_Ve_di_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_si/T2/T2/T2));
  T3_Ve_di_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_di/T2/T2/T2));
  T3_Ve_di_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_si/T2/T2/T2));
  T3_Ve_di_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_di+UD_a*T2_Ve_di_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_di*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vge_si=((UA_a*(d10_pow1*Eeffs_Vge_si*d10_fabs0))+(-UD_a*T2_Vge_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vdi_d)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_d/T2/T2/T2));
  T3_Vge_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vsi_s)/T2/T2+2*UD_a*T2_Vge_si*T2_Vsi_s/T2/T2/T2));
  T3_Vge_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_di/T2/T2/T2));
  T3_Vge_si_Vge_e=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_e)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_e/T2/T2/T2));
  T3_Vge_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_si+UD_a*T2_Vge_si_Vdi_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_si/T2/T2/T2));
  T3_Vge_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_si/T2/T2/T2));
  T3_Vge_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_di/T2/T2/T2));
  T3_Vge_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_si/T2/T2/T2));
  T3_Vge_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_si+UD_a*T2_Vge_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Tempt_GND=(((UA_a_Tempt_GND*d00_pow1)+(UA_a*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_d)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2));
  T3_Tempt_GND_Vsi_s=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vsi_s)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2));
  T3_Tempt_GND_Vge_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_di/T2/T2/T2));
  T3_Tempt_GND_Vge_e=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_e+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_e)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_e/T2/T2/T2));
  T3_Tempt_GND_Vdi_si=(+(+UA_a_Tempt_GND_Vdi_si*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffs_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Vdi_si/T2-(UD_a_Tempt_GND*T2_Vdi_si+UD_a_Vdi_si*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2));
  T3_Tempt_GND_Ve_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffs_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_si/T2/T2/T2));
  T3_Tempt_GND_Ve_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffs_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_di/T2/T2/T2));
  T3_Tempt_GND_Vge_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffs_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_si/T2/T2/T2));
  T3_Tempt_GND_Tempt_GND=(+(+UA_a_Tempt_GND_Tempt_GND*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffs_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Tempt_GND/T2-(UD_a_Tempt_GND*T2_Tempt_GND+UD_a_Tempt_GND*T2_Tempt_GND+UD_a*T2_Tempt_GND_Tempt_GND)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2));
#endif
#endif
T3=((UA_a*d00_pow1)+(UD_a/T2));
EXIT_IF_ISNAN(((UA_a*d00_pow1)+(UD_a/T2)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dmobs_Vdi_si=T3_Vdi_si;
#if defined(_DERIVATE2)
  Dmobs_Vdi_si_Vdi_si=(+0.0+T3_Vdi_si_Vdi_si);
  Dmobs_Vdi_si_Ve_si=(+0.0+T3_Vdi_si_Ve_si);
  Dmobs_Vdi_si_Ve_di=(+0.0+T3_Vdi_si_Ve_di);
  Dmobs_Vdi_si_Vge_si=(+0.0+T3_Vdi_si_Vge_si);
  Dmobs_Vdi_si_Tempt_GND=(+0.0+T3_Vdi_si_Tempt_GND);
#endif
Dmobs_Ve_si=T3_Ve_si;
#if defined(_DERIVATE2)
  Dmobs_Ve_si_Vdi_si=(+0.0+T3_Ve_si_Vdi_si);
  Dmobs_Ve_si_Ve_si=(+0.0+T3_Ve_si_Ve_si);
  Dmobs_Ve_si_Ve_di=(+0.0+T3_Ve_si_Ve_di);
  Dmobs_Ve_si_Vge_si=(+0.0+T3_Ve_si_Vge_si);
  Dmobs_Ve_si_Tempt_GND=(+0.0+T3_Ve_si_Tempt_GND);
#endif
Dmobs_Ve_di=T3_Ve_di;
#if defined(_DERIVATE2)
  Dmobs_Ve_di_Vdi_si=(+0.0+T3_Ve_di_Vdi_si);
  Dmobs_Ve_di_Ve_si=(+0.0+T3_Ve_di_Ve_si);
  Dmobs_Ve_di_Ve_di=(+0.0+T3_Ve_di_Ve_di);
  Dmobs_Ve_di_Vge_si=(+0.0+T3_Ve_di_Vge_si);
  Dmobs_Ve_di_Tempt_GND=(+0.0+T3_Ve_di_Tempt_GND);
#endif
Dmobs_Vge_si=T3_Vge_si;
#if defined(_DERIVATE2)
  Dmobs_Vge_si_Vdi_si=(+0.0+T3_Vge_si_Vdi_si);
  Dmobs_Vge_si_Ve_si=(+0.0+T3_Vge_si_Ve_si);
  Dmobs_Vge_si_Ve_di=(+0.0+T3_Vge_si_Ve_di);
  Dmobs_Vge_si_Vge_si=(+0.0+T3_Vge_si_Vge_si);
  Dmobs_Vge_si_Tempt_GND=(+0.0+T3_Vge_si_Tempt_GND);
#endif
Dmobs_Tempt_GND=T3_Tempt_GND;
#if defined(_DERIVATE2)
  Dmobs_Tempt_GND_Vdi_si=(+0.0+T3_Tempt_GND_Vdi_si);
  Dmobs_Tempt_GND_Ve_si=(+0.0+T3_Tempt_GND_Ve_si);
  Dmobs_Tempt_GND_Ve_di=(+0.0+T3_Tempt_GND_Ve_di);
  Dmobs_Tempt_GND_Vge_si=(+0.0+T3_Tempt_GND_Vge_si);
  Dmobs_Tempt_GND_Tempt_GND=(+0.0+T3_Tempt_GND_Tempt_GND);
#endif
#endif
Dmobs=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dmobs_Vdi_si=(Dmobs_Vdi_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmobs_Vdi_si_Vdi_si=(Dmobs_Vdi_si_Vdi_si/pModel->U0MULT-(Dmobs_Vdi_si*0.0+Dmobs_Vdi_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vdi_si_Ve_si=(Dmobs_Vdi_si_Ve_si/pModel->U0MULT-(Dmobs_Vdi_si*0.0+Dmobs_Ve_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vdi_si_Ve_di=(Dmobs_Vdi_si_Ve_di/pModel->U0MULT-(Dmobs_Vdi_si*0.0+Dmobs_Ve_di*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vdi_si_Vge_si=(Dmobs_Vdi_si_Vge_si/pModel->U0MULT-(Dmobs_Vdi_si*0.0+Dmobs_Vge_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vdi_si_Tempt_GND=(Dmobs_Vdi_si_Tempt_GND/pModel->U0MULT-(Dmobs_Vdi_si*0.0+Dmobs_Tempt_GND*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmobs_Ve_si=(Dmobs_Ve_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmobs_Ve_si_Vdi_si=(Dmobs_Ve_si_Vdi_si/pModel->U0MULT-(Dmobs_Ve_si*0.0+Dmobs_Vdi_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_si_Ve_si=(Dmobs_Ve_si_Ve_si/pModel->U0MULT-(Dmobs_Ve_si*0.0+Dmobs_Ve_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_si_Ve_di=(Dmobs_Ve_si_Ve_di/pModel->U0MULT-(Dmobs_Ve_si*0.0+Dmobs_Ve_di*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_si_Vge_si=(Dmobs_Ve_si_Vge_si/pModel->U0MULT-(Dmobs_Ve_si*0.0+Dmobs_Vge_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_si_Tempt_GND=(Dmobs_Ve_si_Tempt_GND/pModel->U0MULT-(Dmobs_Ve_si*0.0+Dmobs_Tempt_GND*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmobs_Ve_di=(Dmobs_Ve_di/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmobs_Ve_di_Vdi_si=(Dmobs_Ve_di_Vdi_si/pModel->U0MULT-(Dmobs_Ve_di*0.0+Dmobs_Vdi_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_di_Ve_si=(Dmobs_Ve_di_Ve_si/pModel->U0MULT-(Dmobs_Ve_di*0.0+Dmobs_Ve_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_di_Ve_di=(Dmobs_Ve_di_Ve_di/pModel->U0MULT-(Dmobs_Ve_di*0.0+Dmobs_Ve_di*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_di_Vge_si=(Dmobs_Ve_di_Vge_si/pModel->U0MULT-(Dmobs_Ve_di*0.0+Dmobs_Vge_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Ve_di_Tempt_GND=(Dmobs_Ve_di_Tempt_GND/pModel->U0MULT-(Dmobs_Ve_di*0.0+Dmobs_Tempt_GND*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmobs_Vge_si=(Dmobs_Vge_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmobs_Vge_si_Vdi_si=(Dmobs_Vge_si_Vdi_si/pModel->U0MULT-(Dmobs_Vge_si*0.0+Dmobs_Vdi_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vge_si_Ve_si=(Dmobs_Vge_si_Ve_si/pModel->U0MULT-(Dmobs_Vge_si*0.0+Dmobs_Ve_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vge_si_Ve_di=(Dmobs_Vge_si_Ve_di/pModel->U0MULT-(Dmobs_Vge_si*0.0+Dmobs_Ve_di*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vge_si_Vge_si=(Dmobs_Vge_si_Vge_si/pModel->U0MULT-(Dmobs_Vge_si*0.0+Dmobs_Vge_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Vge_si_Tempt_GND=(Dmobs_Vge_si_Tempt_GND/pModel->U0MULT-(Dmobs_Vge_si*0.0+Dmobs_Tempt_GND*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmobs_Tempt_GND=(Dmobs_Tempt_GND/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmobs_Tempt_GND_Vdi_si=(Dmobs_Tempt_GND_Vdi_si/pModel->U0MULT-(Dmobs_Tempt_GND*0.0+Dmobs_Vdi_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Tempt_GND_Ve_si=(Dmobs_Tempt_GND_Ve_si/pModel->U0MULT-(Dmobs_Tempt_GND*0.0+Dmobs_Ve_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Tempt_GND_Ve_di=(Dmobs_Tempt_GND_Ve_di/pModel->U0MULT-(Dmobs_Tempt_GND*0.0+Dmobs_Ve_di*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Tempt_GND_Vge_si=(Dmobs_Tempt_GND_Vge_si/pModel->U0MULT-(Dmobs_Tempt_GND*0.0+Dmobs_Vge_si*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmobs_Tempt_GND_Tempt_GND=(Dmobs_Tempt_GND_Tempt_GND/pModel->U0MULT-(Dmobs_Tempt_GND*0.0+Dmobs_Tempt_GND*0.0+Dmobs*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmobs*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
#endif
Dmobs=(Dmobs/pModel->U0MULT);
EXIT_IF_ISNAN((Dmobs/pModel->U0MULT))
if
((pModel->RDSMOD==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Rdss_Ve_si=0.0;
#if defined(_DERIVATE2)
  Rdss_Ve_si_Ve_si=0.0;
  Rdss_Ve_si_Ve_di=0.0;
  Rdss_Ve_si_Vge_si=0.0;
  Rdss_Ve_si_Vdi_si=0.0;
  Rdss_Ve_si_Tempt_GND=0.0;
#endif
Rdss_Ve_di=0.0;
#if defined(_DERIVATE2)
  Rdss_Ve_di_Ve_si=0.0;
  Rdss_Ve_di_Ve_di=0.0;
  Rdss_Ve_di_Vge_si=0.0;
  Rdss_Ve_di_Vdi_si=0.0;
  Rdss_Ve_di_Tempt_GND=0.0;
#endif
Rdss_Vge_si=0.0;
#if defined(_DERIVATE2)
  Rdss_Vge_si_Ve_si=0.0;
  Rdss_Vge_si_Ve_di=0.0;
  Rdss_Vge_si_Vge_si=0.0;
  Rdss_Vge_si_Vdi_si=0.0;
  Rdss_Vge_si_Tempt_GND=0.0;
#endif
Rdss_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Rdss_Vdi_si_Ve_si=0.0;
  Rdss_Vdi_si_Ve_di=0.0;
  Rdss_Vdi_si_Vge_si=0.0;
  Rdss_Vdi_si_Vdi_si=0.0;
  Rdss_Vdi_si_Tempt_GND=0.0;
#endif
Rdss_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Rdss_Tempt_GND_Ve_si=0.0;
  Rdss_Tempt_GND_Ve_di=0.0;
  Rdss_Tempt_GND_Vge_si=0.0;
  Rdss_Tempt_GND_Vdi_si=0.0;
  Rdss_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Rdss=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
if
((pModel->RDSMOD==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=(PRWGS_i*qis_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGS_i*qis_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGS_i*qis_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGS_i*qis_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGS_i*qis_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGS_i*qis));
EXIT_IF_ISNAN((1.0+(PRWGS_i*qis)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Rdss_Ve_si=(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Ve_si_Ve_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Ve_di=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Vge_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Vdi_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Tempt_GND=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Ve_di=(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Ve_di_Ve_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Ve_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Ve_di=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_di))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Ve_di))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Vge_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Vge_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Vdi_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Tempt_GND=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Vge_si=(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vge_si_Ve_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Ve_di=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Vge_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Vdi_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Tempt_GND=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Vdi_si=(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vdi_si_Ve_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Ve_di=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Vge_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Vdi_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Tempt_GND=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Tempt_GND=(((RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*rdstemp)+((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND));
#if defined(_DERIVATE2)
  Rdss_Tempt_GND_Ve_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Ve_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Ve_di=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_di))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Ve_di))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Vge_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Vge_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Vdi_si=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Tempt_GND=(+(+(+(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(RDSWMIN_i+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND_Tempt_GND);
#endif
#endif
Rdss=((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
EXIT_IF_ISNAN(((((RDSWMIN_i+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=(PRWGS_i*qis_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vdi_si+PRWGS_i*qis_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGS_i*qis_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Ve_si+PRWGS_i*qis_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGS_i*qis_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Ve_di+PRWGS_i*qis_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGS_i*qis_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Vge_si+PRWGS_i*qis_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGS_i*qis_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*qis+0.0*0.0+0.0*qis_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*qis+0.0*qis_Vdi_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*qis+0.0*qis_Ve_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*qis+0.0*qis_Ve_di+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*qis+0.0*qis_Vge_si+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qis+0.0*qis_Tempt_GND+0.0*qis_Tempt_GND+PRWGS_i*qis_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGS_i*qis));
EXIT_IF_ISNAN((1.0+(PRWGS_i*qis)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Rdss_Ve_si=(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Ve_si_Ve_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Ve_di=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Vge_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Vdi_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_si_Tempt_GND=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Ve_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Ve_di=(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Ve_di_Ve_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Ve_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Ve_di=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_di))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Ve_di))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Vge_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Vge_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Vdi_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Ve_di_Tempt_GND=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Ve_di)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Ve_di)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Ve_di)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Vge_si=(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vge_si_Ve_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Ve_di=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Vge_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Vdi_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vge_si_Tempt_GND=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Vge_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vge_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vge_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Vdi_si=(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*rdstemp;
#if defined(_DERIVATE2)
  Rdss_Vdi_si_Ve_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Ve_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Ve_di=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_di))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Ve_di))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Vge_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Vge_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Vdi_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Vdi_si_Tempt_GND=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Vdi_si)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Vdi_si)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Vdi_si)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*0.0+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
#endif
Rdss_Tempt_GND=(((RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*rdstemp)+((((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND));
#if defined(_DERIVATE2)
  Rdss_Tempt_GND_Ve_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Ve_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Ve_di=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_di))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Ve_di))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Ve_di))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Ve_di))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Vge_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Vge_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Vge_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vge_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Vdi_si=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vdi_si))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Vdi_si))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Vdi_si))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*0.0+((((RDSW_i*T0_Vdi_si))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*0.0);
  Rdss_Tempt_GND_Tempt_GND=(+(+(+(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Tempt_GND))*WeffWRFactor+(RDSW_i*T0_Tempt_GND)*0.0+((RDSW_i*T0_Tempt_GND))*0.0+(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*0.0)*NFINtotal+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*0.0+(((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*0.0+((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*0.0)*rdstemp+(RDSW_i*T0_Tempt_GND)*WeffWRFactor*NFINtotal*rdstemp_Tempt_GND+((((RDSW_i*T0_Tempt_GND))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND+(((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp_Tempt_GND_Tempt_GND);
#endif
#endif
Rdss=((((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp);
EXIT_IF_ISNAN(((((((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))*WeffWRFactor)*NFINtotal)*rdstemp))
}
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Esat_Tempt_GND=(((((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs)+(((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND));
#if defined(_DERIVATE2)
  Esat_Tempt_GND_Tempt_GND=(+((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Tempt_GND+2.0*VSAT_a_Tempt_GND_Tempt_GND)/u0_a-((2.0*VSAT_a_Tempt_GND)*u0_a_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*u0_a_Tempt_GND+(2.0*VSAT_a)*u0_a_Tempt_GND_Tempt_GND)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Tempt_GND*u0_a_Tempt_GND/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Tempt_GND+((((2.0*VSAT_a_Tempt_GND))*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Tempt_GND+((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND_Tempt_GND);
  Esat_Tempt_GND_Vdi_si=(+((+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*VSAT_a_Tempt_GND+2.0*VSAT_a_Tempt_GND_Vdi_si)/u0_a-((2.0*VSAT_a_Tempt_GND)*u0_a_Vdi_si+((2.0*VSAT_a_Vdi_si))*u0_a_Tempt_GND+(2.0*VSAT_a)*u0_a_Tempt_GND_Vdi_si)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Tempt_GND*u0_a_Vdi_si/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Vdi_si+((((2.0*VSAT_a_Vdi_si))*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Tempt_GND+((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND_Vdi_si);
  Esat_Tempt_GND_Ve_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Tempt_GND+2.0*0.0)/u0_a-((2.0*VSAT_a_Tempt_GND)*0.0+(0.0)*u0_a_Tempt_GND+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Ve_si+((0.0)/u0_a)*Dmobs_Tempt_GND+((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND_Ve_si);
  Esat_Tempt_GND_Ve_di=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Tempt_GND+2.0*0.0)/u0_a-((2.0*VSAT_a_Tempt_GND)*0.0+(0.0)*u0_a_Tempt_GND+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Ve_di+((0.0)/u0_a)*Dmobs_Tempt_GND+((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND_Ve_di);
  Esat_Tempt_GND_Vge_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Tempt_GND+2.0*0.0)/u0_a-((2.0*VSAT_a_Tempt_GND)*0.0+(0.0)*u0_a_Tempt_GND+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Tempt_GND)*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Vge_si+((0.0)/u0_a)*Dmobs_Tempt_GND+((2.0*VSAT_a)/u0_a)*Dmobs_Tempt_GND_Vge_si);
#endif
Esat_Vdi_si=(((((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs)+(((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si));
#if defined(_DERIVATE2)
  Esat_Vdi_si_Tempt_GND=(+((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vdi_si+2.0*VSAT_a_Vdi_si_Tempt_GND)/u0_a-((2.0*VSAT_a_Vdi_si)*u0_a_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*u0_a_Vdi_si+(2.0*VSAT_a)*u0_a_Vdi_si_Tempt_GND)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Vdi_si*u0_a_Tempt_GND/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Tempt_GND+((((2.0*VSAT_a_Tempt_GND))*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Vdi_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si_Tempt_GND);
  Esat_Vdi_si_Vdi_si=(+((+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*VSAT_a_Vdi_si+2.0*VSAT_a_Vdi_si_Vdi_si)/u0_a-((2.0*VSAT_a_Vdi_si)*u0_a_Vdi_si+((2.0*VSAT_a_Vdi_si))*u0_a_Vdi_si+(2.0*VSAT_a)*u0_a_Vdi_si_Vdi_si)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Vdi_si*u0_a_Vdi_si/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Vdi_si+((((2.0*VSAT_a_Vdi_si))*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Vdi_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si_Vdi_si);
  Esat_Vdi_si_Ve_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_si+2.0*0.0)/u0_a-((2.0*VSAT_a_Vdi_si)*0.0+(0.0)*u0_a_Vdi_si+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Ve_si+((0.0)/u0_a)*Dmobs_Vdi_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si_Ve_si);
  Esat_Vdi_si_Ve_di=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_si+2.0*0.0)/u0_a-((2.0*VSAT_a_Vdi_si)*0.0+(0.0)*u0_a_Vdi_si+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Ve_di+((0.0)/u0_a)*Dmobs_Vdi_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si_Ve_di);
  Esat_Vdi_si_Vge_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*VSAT_a_Vdi_si+2.0*0.0)/u0_a-((2.0*VSAT_a_Vdi_si)*0.0+(0.0)*u0_a_Vdi_si+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a)*Dmobs+(((2.0*VSAT_a_Vdi_si)*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Vge_si+((0.0)/u0_a)*Dmobs_Vdi_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vdi_si_Vge_si);
#endif
Esat_Ve_si=(((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si);
#if defined(_DERIVATE2)
  Esat_Ve_si_Tempt_GND=(+((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Tempt_GND+((((2.0*VSAT_a_Tempt_GND))*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Ve_si+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si_Tempt_GND);
  Esat_Ve_si_Vdi_si=(+((+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Vdi_si+((2.0*VSAT_a_Vdi_si))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vdi_si+((((2.0*VSAT_a_Vdi_si))*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Ve_si+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si_Vdi_si);
  Esat_Ve_si_Ve_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_si+((0.0)/u0_a)*Dmobs_Ve_si+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si_Ve_si);
  Esat_Ve_si_Ve_di=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_di+((0.0)/u0_a)*Dmobs_Ve_si+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si_Ve_di);
  Esat_Ve_si_Vge_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vge_si+((0.0)/u0_a)*Dmobs_Ve_si+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_si_Vge_si);
#endif
Esat_Ve_di=(((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di);
#if defined(_DERIVATE2)
  Esat_Ve_di_Tempt_GND=(+((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Tempt_GND+((((2.0*VSAT_a_Tempt_GND))*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Ve_di+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di_Tempt_GND);
  Esat_Ve_di_Vdi_si=(+((+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Vdi_si+((2.0*VSAT_a_Vdi_si))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vdi_si+((((2.0*VSAT_a_Vdi_si))*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Ve_di+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di_Vdi_si);
  Esat_Ve_di_Ve_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_si+((0.0)/u0_a)*Dmobs_Ve_di+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di_Ve_si);
  Esat_Ve_di_Ve_di=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_di+((0.0)/u0_a)*Dmobs_Ve_di+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di_Ve_di);
  Esat_Ve_di_Vge_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vge_si+((0.0)/u0_a)*Dmobs_Ve_di+((2.0*VSAT_a)/u0_a)*Dmobs_Ve_di_Vge_si);
#endif
Esat_Vge_si=(((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si);
#if defined(_DERIVATE2)
  Esat_Vge_si_Tempt_GND=(+((+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Tempt_GND+((2.0*VSAT_a_Tempt_GND))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Tempt_GND+((((2.0*VSAT_a_Tempt_GND))*u0_a-(2.0*VSAT_a)*u0_a_Tempt_GND)/u0_a/u0_a)*Dmobs_Vge_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si_Tempt_GND);
  Esat_Vge_si_Vdi_si=(+((+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*0.0+2.0*0.0)/u0_a-(0.0*u0_a_Vdi_si+((2.0*VSAT_a_Vdi_si))*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vdi_si+((((2.0*VSAT_a_Vdi_si))*u0_a-(2.0*VSAT_a)*u0_a_Vdi_si)/u0_a/u0_a)*Dmobs_Vge_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si_Vdi_si);
  Esat_Vge_si_Ve_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_si+((0.0)/u0_a)*Dmobs_Vge_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si_Ve_si);
  Esat_Vge_si_Ve_di=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Ve_di+((0.0)/u0_a)*Dmobs_Vge_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si_Ve_di);
  Esat_Vge_si_Vge_si=(+((+0.0*VSAT_a+0.0*0.0+0.0*0.0+2.0*0.0)/u0_a-(0.0*0.0+(0.0)*0.0+(2.0*VSAT_a)*0.0)/u0_a/u0_a+2*(2.0*VSAT_a)*0.0*0.0/u0_a/u0_a/u0_a)*Dmobs+0.0*Dmobs_Vge_si+((0.0)/u0_a)*Dmobs_Vge_si+((2.0*VSAT_a)/u0_a)*Dmobs_Vge_si_Vge_si);
#endif
#endif
Esat=(((2.0*VSAT_a)/u0_a)*Dmobs);
EXIT_IF_ISNAN((((2.0*VSAT_a)/u0_a)*Dmobs))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
EsatL_Tempt_GND=Esat_Tempt_GND*Leff;
#if defined(_DERIVATE2)
  EsatL_Tempt_GND_Tempt_GND=(+Esat_Tempt_GND_Tempt_GND*Leff+Esat_Tempt_GND*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Tempt_GND_Vdi_si=(+Esat_Tempt_GND_Vdi_si*Leff+Esat_Tempt_GND*0.0+Esat_Vdi_si*0.0+Esat*0.0);
  EsatL_Tempt_GND_Ve_si=(+Esat_Tempt_GND_Ve_si*Leff+Esat_Tempt_GND*0.0+Esat_Ve_si*0.0+Esat*0.0);
  EsatL_Tempt_GND_Ve_di=(+Esat_Tempt_GND_Ve_di*Leff+Esat_Tempt_GND*0.0+Esat_Ve_di*0.0+Esat*0.0);
  EsatL_Tempt_GND_Vge_si=(+Esat_Tempt_GND_Vge_si*Leff+Esat_Tempt_GND*0.0+Esat_Vge_si*0.0+Esat*0.0);
#endif
EsatL_Vdi_si=Esat_Vdi_si*Leff;
#if defined(_DERIVATE2)
  EsatL_Vdi_si_Tempt_GND=(+Esat_Vdi_si_Tempt_GND*Leff+Esat_Vdi_si*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vdi_si_Vdi_si=(+Esat_Vdi_si_Vdi_si*Leff+Esat_Vdi_si*0.0+Esat_Vdi_si*0.0+Esat*0.0);
  EsatL_Vdi_si_Ve_si=(+Esat_Vdi_si_Ve_si*Leff+Esat_Vdi_si*0.0+Esat_Ve_si*0.0+Esat*0.0);
  EsatL_Vdi_si_Ve_di=(+Esat_Vdi_si_Ve_di*Leff+Esat_Vdi_si*0.0+Esat_Ve_di*0.0+Esat*0.0);
  EsatL_Vdi_si_Vge_si=(+Esat_Vdi_si_Vge_si*Leff+Esat_Vdi_si*0.0+Esat_Vge_si*0.0+Esat*0.0);
#endif
EsatL_Ve_si=Esat_Ve_si*Leff;
#if defined(_DERIVATE2)
  EsatL_Ve_si_Tempt_GND=(+Esat_Ve_si_Tempt_GND*Leff+Esat_Ve_si*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Ve_si_Vdi_si=(+Esat_Ve_si_Vdi_si*Leff+Esat_Ve_si*0.0+Esat_Vdi_si*0.0+Esat*0.0);
  EsatL_Ve_si_Ve_si=(+Esat_Ve_si_Ve_si*Leff+Esat_Ve_si*0.0+Esat_Ve_si*0.0+Esat*0.0);
  EsatL_Ve_si_Ve_di=(+Esat_Ve_si_Ve_di*Leff+Esat_Ve_si*0.0+Esat_Ve_di*0.0+Esat*0.0);
  EsatL_Ve_si_Vge_si=(+Esat_Ve_si_Vge_si*Leff+Esat_Ve_si*0.0+Esat_Vge_si*0.0+Esat*0.0);
#endif
EsatL_Ve_di=Esat_Ve_di*Leff;
#if defined(_DERIVATE2)
  EsatL_Ve_di_Tempt_GND=(+Esat_Ve_di_Tempt_GND*Leff+Esat_Ve_di*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Ve_di_Vdi_si=(+Esat_Ve_di_Vdi_si*Leff+Esat_Ve_di*0.0+Esat_Vdi_si*0.0+Esat*0.0);
  EsatL_Ve_di_Ve_si=(+Esat_Ve_di_Ve_si*Leff+Esat_Ve_di*0.0+Esat_Ve_si*0.0+Esat*0.0);
  EsatL_Ve_di_Ve_di=(+Esat_Ve_di_Ve_di*Leff+Esat_Ve_di*0.0+Esat_Ve_di*0.0+Esat*0.0);
  EsatL_Ve_di_Vge_si=(+Esat_Ve_di_Vge_si*Leff+Esat_Ve_di*0.0+Esat_Vge_si*0.0+Esat*0.0);
#endif
EsatL_Vge_si=Esat_Vge_si*Leff;
#if defined(_DERIVATE2)
  EsatL_Vge_si_Tempt_GND=(+Esat_Vge_si_Tempt_GND*Leff+Esat_Vge_si*0.0+Esat_Tempt_GND*0.0+Esat*0.0);
  EsatL_Vge_si_Vdi_si=(+Esat_Vge_si_Vdi_si*Leff+Esat_Vge_si*0.0+Esat_Vdi_si*0.0+Esat*0.0);
  EsatL_Vge_si_Ve_si=(+Esat_Vge_si_Ve_si*Leff+Esat_Vge_si*0.0+Esat_Ve_si*0.0+Esat*0.0);
  EsatL_Vge_si_Ve_di=(+Esat_Vge_si_Ve_di*Leff+Esat_Vge_si*0.0+Esat_Ve_di*0.0+Esat*0.0);
  EsatL_Vge_si_Vge_si=(+Esat_Vge_si_Vge_si*Leff+Esat_Vge_si*0.0+Esat_Vge_si*0.0+Esat*0.0);
#endif
#endif
EsatL=(Esat*Leff);
EXIT_IF_ISNAN((Esat*Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=((KSATIV_a_Vdi_si*(qis+(2*Vtm)))+(KSATIV_a*qis_Vdi_si));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(0.0)+0.0*qis_Vdi_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Vdi_d=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(0.0)+0.0*qis_Vdi_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Vsi_s=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(0.0)+0.0*qis_Vdi_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Vge_e=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(0.0)+0.0*qis_Vdi_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Vdi_si=(+KSATIV_a_Vdi_si_Vdi_si*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Tempt_GND=(+KSATIV_a_Vdi_si_Tempt_GND*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(qis_Tempt_GND+((2*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2*0.0)));
  T6_Vdi_si_Ve_si=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(qis_Ve_si+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Ve_di=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(qis_Ve_di+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vdi_si_Vge_si=(+0.0*(qis+(2*Vtm))+KSATIV_a_Vdi_si*(qis_Vge_si+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
#endif
T6_Tempt_GND=((KSATIV_a_Tempt_GND*(qis+(2*Vtm)))+(KSATIV_a*(qis_Tempt_GND+(2*Vtm_Tempt_GND))));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(0.0)+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Vdi_d=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(0.0)+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Vsi_s=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(0.0)+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Vge_e=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(0.0)+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Vdi_si=(+KSATIV_a_Tempt_GND_Vdi_si*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Tempt_GND=(+KSATIV_a_Tempt_GND_Tempt_GND*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(qis_Tempt_GND+((2*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+2*Vtm_Tempt_GND_Tempt_GND)));
  T6_Tempt_GND_Ve_si=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(qis_Ve_si+(0.0))+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Ve_di=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(qis_Ve_di+(0.0))+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
  T6_Tempt_GND_Vge_si=(+0.0*(qis+(2*Vtm))+KSATIV_a_Tempt_GND*(qis_Vge_si+(0.0))+0.0*(qis_Tempt_GND+(2*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2*0.0)));
#endif
T6_Ve_si=(KSATIV_a*qis_Ve_si);
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Vdi_d=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Vsi_s=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Vge_e=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Vdi_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Tempt_GND=(+0.0*(qis+(2*Vtm))+0.0*(qis_Tempt_GND+((2*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2*0.0)));
  T6_Ve_si_Ve_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Ve_di=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_si_Vge_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
#endif
T6_Ve_di=(KSATIV_a*qis_Ve_di);
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_di+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Vdi_d=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_di+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Vsi_s=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_di+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Vge_e=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Ve_di+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Vdi_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Tempt_GND=(+0.0*(qis+(2*Vtm))+0.0*(qis_Tempt_GND+((2*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2*0.0)));
  T6_Ve_di_Ve_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Ve_di=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Ve_di_Vge_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
#endif
T6_Vge_si=(KSATIV_a*qis_Vge_si);
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Vge_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Vdi_d=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Vge_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Vsi_s=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Vge_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Vge_e=(+0.0*(qis+(2*Vtm))+0.0*(0.0)+0.0*qis_Vge_si+KSATIV_a*(+0.0+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Vdi_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Tempt_GND=(+0.0*(qis+(2*Vtm))+0.0*(qis_Tempt_GND+((2*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2*0.0)));
  T6_Vge_si_Ve_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Ve_di=(+0.0*(qis+(2*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
  T6_Vge_si_Vge_si=(+0.0*(qis+(2*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2*0.0)));
#endif
#endif
T6=(KSATIV_a*(qis+(2*Vtm)));
EXIT_IF_ISNAN((KSATIV_a*(qis+(2*Vtm))))
if
((Rdss==0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
Vdsat_Tempt_GND=((((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL+T6)-(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND))/(EsatL+T6)/(EsatL+T6));
#if defined(_DERIVATE2)
  Vdsat_Tempt_GND_Tempt_GND=((+EsatL_Tempt_GND_Tempt_GND*T6+EsatL_Tempt_GND*T6_Tempt_GND+EsatL_Tempt_GND*T6_Tempt_GND+EsatL*T6_Tempt_GND_Tempt_GND)/(EsatL+T6)-(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL_Tempt_GND+T6_Tempt_GND)+(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND)))*(EsatL_Tempt_GND+T6_Tempt_GND)+(EsatL*T6)*(+EsatL_Tempt_GND_Tempt_GND+T6_Tempt_GND_Tempt_GND))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND)*(EsatL_Tempt_GND+T6_Tempt_GND)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Tempt_GND_Vdi_si=((+EsatL_Tempt_GND_Vdi_si*T6+EsatL_Tempt_GND*T6_Vdi_si+EsatL_Vdi_si*T6_Tempt_GND+EsatL*T6_Tempt_GND_Vdi_si)/(EsatL+T6)-(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL_Vdi_si+T6_Vdi_si)+(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si)))*(EsatL_Tempt_GND+T6_Tempt_GND)+(EsatL*T6)*(+EsatL_Tempt_GND_Vdi_si+T6_Tempt_GND_Vdi_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND)*(EsatL_Vdi_si+T6_Vdi_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Tempt_GND_Ve_si=((+EsatL_Tempt_GND_Ve_si*T6+EsatL_Tempt_GND*T6_Ve_si+EsatL_Ve_si*T6_Tempt_GND+EsatL*T6_Tempt_GND_Ve_si)/(EsatL+T6)-(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL_Ve_si+T6_Ve_si)+(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si)))*(EsatL_Tempt_GND+T6_Tempt_GND)+(EsatL*T6)*(+EsatL_Tempt_GND_Ve_si+T6_Tempt_GND_Ve_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND)*(EsatL_Ve_si+T6_Ve_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Tempt_GND_Ve_di=((+EsatL_Tempt_GND_Ve_di*T6+EsatL_Tempt_GND*T6_Ve_di+EsatL_Ve_di*T6_Tempt_GND+EsatL*T6_Tempt_GND_Ve_di)/(EsatL+T6)-(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL_Ve_di+T6_Ve_di)+(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di)))*(EsatL_Tempt_GND+T6_Tempt_GND)+(EsatL*T6)*(+EsatL_Tempt_GND_Ve_di+T6_Tempt_GND_Ve_di))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND)*(EsatL_Ve_di+T6_Ve_di)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Tempt_GND_Vge_si=((+EsatL_Tempt_GND_Vge_si*T6+EsatL_Tempt_GND*T6_Vge_si+EsatL_Vge_si*T6_Tempt_GND+EsatL*T6_Tempt_GND_Vge_si)/(EsatL+T6)-(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND))*(EsatL_Vge_si+T6_Vge_si)+(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si)))*(EsatL_Tempt_GND+T6_Tempt_GND)+(EsatL*T6)*(+EsatL_Tempt_GND_Vge_si+T6_Tempt_GND_Vge_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Tempt_GND+T6_Tempt_GND)*(EsatL_Vge_si+T6_Vge_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
#endif
Vdsat_Vdi_si=((((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL+T6)-(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si))/(EsatL+T6)/(EsatL+T6));
#if defined(_DERIVATE2)
  Vdsat_Vdi_si_Tempt_GND=((+EsatL_Vdi_si_Tempt_GND*T6+EsatL_Vdi_si*T6_Tempt_GND+EsatL_Tempt_GND*T6_Vdi_si+EsatL*T6_Vdi_si_Tempt_GND)/(EsatL+T6)-(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL_Tempt_GND+T6_Tempt_GND)+(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND)))*(EsatL_Vdi_si+T6_Vdi_si)+(EsatL*T6)*(+EsatL_Vdi_si_Tempt_GND+T6_Vdi_si_Tempt_GND))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si)*(EsatL_Tempt_GND+T6_Tempt_GND)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vdi_si_Vdi_si=((+EsatL_Vdi_si_Vdi_si*T6+EsatL_Vdi_si*T6_Vdi_si+EsatL_Vdi_si*T6_Vdi_si+EsatL*T6_Vdi_si_Vdi_si)/(EsatL+T6)-(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL_Vdi_si+T6_Vdi_si)+(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si)))*(EsatL_Vdi_si+T6_Vdi_si)+(EsatL*T6)*(+EsatL_Vdi_si_Vdi_si+T6_Vdi_si_Vdi_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si)*(EsatL_Vdi_si+T6_Vdi_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vdi_si_Ve_si=((+EsatL_Vdi_si_Ve_si*T6+EsatL_Vdi_si*T6_Ve_si+EsatL_Ve_si*T6_Vdi_si+EsatL*T6_Vdi_si_Ve_si)/(EsatL+T6)-(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL_Ve_si+T6_Ve_si)+(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si)))*(EsatL_Vdi_si+T6_Vdi_si)+(EsatL*T6)*(+EsatL_Vdi_si_Ve_si+T6_Vdi_si_Ve_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si)*(EsatL_Ve_si+T6_Ve_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vdi_si_Ve_di=((+EsatL_Vdi_si_Ve_di*T6+EsatL_Vdi_si*T6_Ve_di+EsatL_Ve_di*T6_Vdi_si+EsatL*T6_Vdi_si_Ve_di)/(EsatL+T6)-(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL_Ve_di+T6_Ve_di)+(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di)))*(EsatL_Vdi_si+T6_Vdi_si)+(EsatL*T6)*(+EsatL_Vdi_si_Ve_di+T6_Vdi_si_Ve_di))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si)*(EsatL_Ve_di+T6_Ve_di)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vdi_si_Vge_si=((+EsatL_Vdi_si_Vge_si*T6+EsatL_Vdi_si*T6_Vge_si+EsatL_Vge_si*T6_Vdi_si+EsatL*T6_Vdi_si_Vge_si)/(EsatL+T6)-(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si))*(EsatL_Vge_si+T6_Vge_si)+(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si)))*(EsatL_Vdi_si+T6_Vdi_si)+(EsatL*T6)*(+EsatL_Vdi_si_Vge_si+T6_Vdi_si_Vge_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vdi_si+T6_Vdi_si)*(EsatL_Vge_si+T6_Vge_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
#endif
Vdsat_Ve_si=((((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL+T6)-(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si))/(EsatL+T6)/(EsatL+T6));
#if defined(_DERIVATE2)
  Vdsat_Ve_si_Tempt_GND=((+EsatL_Ve_si_Tempt_GND*T6+EsatL_Ve_si*T6_Tempt_GND+EsatL_Tempt_GND*T6_Ve_si+EsatL*T6_Ve_si_Tempt_GND)/(EsatL+T6)-(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL_Tempt_GND+T6_Tempt_GND)+(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND)))*(EsatL_Ve_si+T6_Ve_si)+(EsatL*T6)*(+EsatL_Ve_si_Tempt_GND+T6_Ve_si_Tempt_GND))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si)*(EsatL_Tempt_GND+T6_Tempt_GND)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_si_Vdi_si=((+EsatL_Ve_si_Vdi_si*T6+EsatL_Ve_si*T6_Vdi_si+EsatL_Vdi_si*T6_Ve_si+EsatL*T6_Ve_si_Vdi_si)/(EsatL+T6)-(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL_Vdi_si+T6_Vdi_si)+(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si)))*(EsatL_Ve_si+T6_Ve_si)+(EsatL*T6)*(+EsatL_Ve_si_Vdi_si+T6_Ve_si_Vdi_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si)*(EsatL_Vdi_si+T6_Vdi_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_si_Ve_si=((+EsatL_Ve_si_Ve_si*T6+EsatL_Ve_si*T6_Ve_si+EsatL_Ve_si*T6_Ve_si+EsatL*T6_Ve_si_Ve_si)/(EsatL+T6)-(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL_Ve_si+T6_Ve_si)+(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si)))*(EsatL_Ve_si+T6_Ve_si)+(EsatL*T6)*(+EsatL_Ve_si_Ve_si+T6_Ve_si_Ve_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si)*(EsatL_Ve_si+T6_Ve_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_si_Ve_di=((+EsatL_Ve_si_Ve_di*T6+EsatL_Ve_si*T6_Ve_di+EsatL_Ve_di*T6_Ve_si+EsatL*T6_Ve_si_Ve_di)/(EsatL+T6)-(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL_Ve_di+T6_Ve_di)+(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di)))*(EsatL_Ve_si+T6_Ve_si)+(EsatL*T6)*(+EsatL_Ve_si_Ve_di+T6_Ve_si_Ve_di))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si)*(EsatL_Ve_di+T6_Ve_di)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_si_Vge_si=((+EsatL_Ve_si_Vge_si*T6+EsatL_Ve_si*T6_Vge_si+EsatL_Vge_si*T6_Ve_si+EsatL*T6_Ve_si_Vge_si)/(EsatL+T6)-(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si))*(EsatL_Vge_si+T6_Vge_si)+(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si)))*(EsatL_Ve_si+T6_Ve_si)+(EsatL*T6)*(+EsatL_Ve_si_Vge_si+T6_Ve_si_Vge_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_si+T6_Ve_si)*(EsatL_Vge_si+T6_Vge_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
#endif
Vdsat_Ve_di=((((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL+T6)-(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di))/(EsatL+T6)/(EsatL+T6));
#if defined(_DERIVATE2)
  Vdsat_Ve_di_Tempt_GND=((+EsatL_Ve_di_Tempt_GND*T6+EsatL_Ve_di*T6_Tempt_GND+EsatL_Tempt_GND*T6_Ve_di+EsatL*T6_Ve_di_Tempt_GND)/(EsatL+T6)-(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL_Tempt_GND+T6_Tempt_GND)+(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND)))*(EsatL_Ve_di+T6_Ve_di)+(EsatL*T6)*(+EsatL_Ve_di_Tempt_GND+T6_Ve_di_Tempt_GND))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di)*(EsatL_Tempt_GND+T6_Tempt_GND)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_di_Vdi_si=((+EsatL_Ve_di_Vdi_si*T6+EsatL_Ve_di*T6_Vdi_si+EsatL_Vdi_si*T6_Ve_di+EsatL*T6_Ve_di_Vdi_si)/(EsatL+T6)-(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL_Vdi_si+T6_Vdi_si)+(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si)))*(EsatL_Ve_di+T6_Ve_di)+(EsatL*T6)*(+EsatL_Ve_di_Vdi_si+T6_Ve_di_Vdi_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di)*(EsatL_Vdi_si+T6_Vdi_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_di_Ve_si=((+EsatL_Ve_di_Ve_si*T6+EsatL_Ve_di*T6_Ve_si+EsatL_Ve_si*T6_Ve_di+EsatL*T6_Ve_di_Ve_si)/(EsatL+T6)-(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL_Ve_si+T6_Ve_si)+(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si)))*(EsatL_Ve_di+T6_Ve_di)+(EsatL*T6)*(+EsatL_Ve_di_Ve_si+T6_Ve_di_Ve_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di)*(EsatL_Ve_si+T6_Ve_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_di_Ve_di=((+EsatL_Ve_di_Ve_di*T6+EsatL_Ve_di*T6_Ve_di+EsatL_Ve_di*T6_Ve_di+EsatL*T6_Ve_di_Ve_di)/(EsatL+T6)-(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL_Ve_di+T6_Ve_di)+(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di)))*(EsatL_Ve_di+T6_Ve_di)+(EsatL*T6)*(+EsatL_Ve_di_Ve_di+T6_Ve_di_Ve_di))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di)*(EsatL_Ve_di+T6_Ve_di)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Ve_di_Vge_si=((+EsatL_Ve_di_Vge_si*T6+EsatL_Ve_di*T6_Vge_si+EsatL_Vge_si*T6_Ve_di+EsatL*T6_Ve_di_Vge_si)/(EsatL+T6)-(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di))*(EsatL_Vge_si+T6_Vge_si)+(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si)))*(EsatL_Ve_di+T6_Ve_di)+(EsatL*T6)*(+EsatL_Ve_di_Vge_si+T6_Ve_di_Vge_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Ve_di+T6_Ve_di)*(EsatL_Vge_si+T6_Vge_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
#endif
Vdsat_Vge_si=((((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL+T6)-(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si))/(EsatL+T6)/(EsatL+T6));
#if defined(_DERIVATE2)
  Vdsat_Vge_si_Tempt_GND=((+EsatL_Vge_si_Tempt_GND*T6+EsatL_Vge_si*T6_Tempt_GND+EsatL_Tempt_GND*T6_Vge_si+EsatL*T6_Vge_si_Tempt_GND)/(EsatL+T6)-(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL_Tempt_GND+T6_Tempt_GND)+(((EsatL_Tempt_GND*T6)+(EsatL*T6_Tempt_GND)))*(EsatL_Vge_si+T6_Vge_si)+(EsatL*T6)*(+EsatL_Vge_si_Tempt_GND+T6_Vge_si_Tempt_GND))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si)*(EsatL_Tempt_GND+T6_Tempt_GND)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vge_si_Vdi_si=((+EsatL_Vge_si_Vdi_si*T6+EsatL_Vge_si*T6_Vdi_si+EsatL_Vdi_si*T6_Vge_si+EsatL*T6_Vge_si_Vdi_si)/(EsatL+T6)-(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL_Vdi_si+T6_Vdi_si)+(((EsatL_Vdi_si*T6)+(EsatL*T6_Vdi_si)))*(EsatL_Vge_si+T6_Vge_si)+(EsatL*T6)*(+EsatL_Vge_si_Vdi_si+T6_Vge_si_Vdi_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si)*(EsatL_Vdi_si+T6_Vdi_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vge_si_Ve_si=((+EsatL_Vge_si_Ve_si*T6+EsatL_Vge_si*T6_Ve_si+EsatL_Ve_si*T6_Vge_si+EsatL*T6_Vge_si_Ve_si)/(EsatL+T6)-(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL_Ve_si+T6_Ve_si)+(((EsatL_Ve_si*T6)+(EsatL*T6_Ve_si)))*(EsatL_Vge_si+T6_Vge_si)+(EsatL*T6)*(+EsatL_Vge_si_Ve_si+T6_Vge_si_Ve_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si)*(EsatL_Ve_si+T6_Ve_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vge_si_Ve_di=((+EsatL_Vge_si_Ve_di*T6+EsatL_Vge_si*T6_Ve_di+EsatL_Ve_di*T6_Vge_si+EsatL*T6_Vge_si_Ve_di)/(EsatL+T6)-(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL_Ve_di+T6_Ve_di)+(((EsatL_Ve_di*T6)+(EsatL*T6_Ve_di)))*(EsatL_Vge_si+T6_Vge_si)+(EsatL*T6)*(+EsatL_Vge_si_Ve_di+T6_Vge_si_Ve_di))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si)*(EsatL_Ve_di+T6_Ve_di)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
  Vdsat_Vge_si_Vge_si=((+EsatL_Vge_si_Vge_si*T6+EsatL_Vge_si*T6_Vge_si+EsatL_Vge_si*T6_Vge_si+EsatL*T6_Vge_si_Vge_si)/(EsatL+T6)-(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si))*(EsatL_Vge_si+T6_Vge_si)+(((EsatL_Vge_si*T6)+(EsatL*T6_Vge_si)))*(EsatL_Vge_si+T6_Vge_si)+(EsatL*T6)*(+EsatL_Vge_si_Vge_si+T6_Vge_si_Vge_si))/(EsatL+T6)/(EsatL+T6)+2*(EsatL*T6)*(EsatL_Vge_si+T6_Vge_si)*(EsatL_Vge_si+T6_Vge_si)/(EsatL+T6)/(EsatL+T6)/(EsatL+T6));
#endif
#endif
Vdsat=((EsatL*T6)/(EsatL+T6));
EXIT_IF_ISNAN(((EsatL*T6)/(EsatL+T6)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
WVCox_Tempt_GND=(Weff0*VSAT_a_Tempt_GND)*cox;
#if defined(_DERIVATE2)
  WVCox_Tempt_GND_Tempt_GND=(+(+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Tempt_GND+Weff0*VSAT_a_Tempt_GND_Tempt_GND)*cox+(Weff0*VSAT_a_Tempt_GND)*0.0+((Weff0*VSAT_a_Tempt_GND))*0.0+(Weff0*VSAT_a)*0.0);
  WVCox_Tempt_GND_Vdi_si=(+(+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*VSAT_a_Tempt_GND+Weff0*VSAT_a_Tempt_GND_Vdi_si)*cox+(Weff0*VSAT_a_Tempt_GND)*0.0+((Weff0*VSAT_a_Vdi_si))*0.0+(Weff0*VSAT_a)*0.0);
#endif
WVCox_Vdi_si=(Weff0*VSAT_a_Vdi_si)*cox;
#if defined(_DERIVATE2)
  WVCox_Vdi_si_Tempt_GND=(+(+0.0*VSAT_a+0.0*VSAT_a_Tempt_GND+0.0*VSAT_a_Vdi_si+Weff0*VSAT_a_Vdi_si_Tempt_GND)*cox+(Weff0*VSAT_a_Vdi_si)*0.0+((Weff0*VSAT_a_Tempt_GND))*0.0+(Weff0*VSAT_a)*0.0);
  WVCox_Vdi_si_Vdi_si=(+(+0.0*VSAT_a+0.0*VSAT_a_Vdi_si+0.0*VSAT_a_Vdi_si+Weff0*VSAT_a_Vdi_si_Vdi_si)*cox+(Weff0*VSAT_a_Vdi_si)*0.0+((Weff0*VSAT_a_Vdi_si))*0.0+(Weff0*VSAT_a)*0.0);
#endif
#endif
WVCox=((Weff0*VSAT_a)*cox);
EXIT_IF_ISNAN(((Weff0*VSAT_a)*cox))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(WVCox*Rdss_Ve_si);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Ve_si+WVCox*0.0);
  T0_Ve_si_Vge_e=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Ve_si+WVCox*0.0);
  T0_Ve_si_Ve_si=(+0.0*Rdss+0.0*Rdss_Ve_si+0.0*Rdss_Ve_si+WVCox*Rdss_Ve_si_Ve_si);
  T0_Ve_si_Ve_di=(+0.0*Rdss+0.0*Rdss_Ve_di+0.0*Rdss_Ve_si+WVCox*Rdss_Ve_si_Ve_di);
  T0_Ve_si_Vge_si=(+0.0*Rdss+0.0*Rdss_Vge_si+0.0*Rdss_Ve_si+WVCox*Rdss_Ve_si_Vge_si);
  T0_Ve_si_Vdi_si=(+0.0*Rdss+0.0*Rdss_Vdi_si+WVCox_Vdi_si*Rdss_Ve_si+WVCox*Rdss_Ve_si_Vdi_si);
  T0_Ve_si_Tempt_GND=(+0.0*Rdss+0.0*Rdss_Tempt_GND+WVCox_Tempt_GND*Rdss_Ve_si+WVCox*Rdss_Ve_si_Tempt_GND);
#endif
T0_Ve_di=(WVCox*Rdss_Ve_di);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Ve_di+WVCox*0.0);
  T0_Ve_di_Vge_e=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Ve_di+WVCox*0.0);
  T0_Ve_di_Ve_si=(+0.0*Rdss+0.0*Rdss_Ve_si+0.0*Rdss_Ve_di+WVCox*Rdss_Ve_di_Ve_si);
  T0_Ve_di_Ve_di=(+0.0*Rdss+0.0*Rdss_Ve_di+0.0*Rdss_Ve_di+WVCox*Rdss_Ve_di_Ve_di);
  T0_Ve_di_Vge_si=(+0.0*Rdss+0.0*Rdss_Vge_si+0.0*Rdss_Ve_di+WVCox*Rdss_Ve_di_Vge_si);
  T0_Ve_di_Vdi_si=(+0.0*Rdss+0.0*Rdss_Vdi_si+WVCox_Vdi_si*Rdss_Ve_di+WVCox*Rdss_Ve_di_Vdi_si);
  T0_Ve_di_Tempt_GND=(+0.0*Rdss+0.0*Rdss_Tempt_GND+WVCox_Tempt_GND*Rdss_Ve_di+WVCox*Rdss_Ve_di_Tempt_GND);
#endif
T0_Vge_si=(WVCox*Rdss_Vge_si);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Vge_si+WVCox*0.0);
  T0_Vge_si_Vge_e=(+0.0*Rdss+0.0*0.0+0.0*Rdss_Vge_si+WVCox*0.0);
  T0_Vge_si_Ve_si=(+0.0*Rdss+0.0*Rdss_Ve_si+0.0*Rdss_Vge_si+WVCox*Rdss_Vge_si_Ve_si);
  T0_Vge_si_Ve_di=(+0.0*Rdss+0.0*Rdss_Ve_di+0.0*Rdss_Vge_si+WVCox*Rdss_Vge_si_Ve_di);
  T0_Vge_si_Vge_si=(+0.0*Rdss+0.0*Rdss_Vge_si+0.0*Rdss_Vge_si+WVCox*Rdss_Vge_si_Vge_si);
  T0_Vge_si_Vdi_si=(+0.0*Rdss+0.0*Rdss_Vdi_si+WVCox_Vdi_si*Rdss_Vge_si+WVCox*Rdss_Vge_si_Vdi_si);
  T0_Vge_si_Tempt_GND=(+0.0*Rdss+0.0*Rdss_Tempt_GND+WVCox_Tempt_GND*Rdss_Vge_si+WVCox*Rdss_Vge_si_Tempt_GND);
#endif
T0_Vdi_si=((WVCox_Vdi_si*Rdss)+(WVCox*Rdss_Vdi_si));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*Rdss+WVCox_Vdi_si*0.0+0.0*Rdss_Vdi_si+WVCox*0.0);
  T0_Vdi_si_Vge_e=(+0.0*Rdss+WVCox_Vdi_si*0.0+0.0*Rdss_Vdi_si+WVCox*0.0);
  T0_Vdi_si_Ve_si=(+0.0*Rdss+WVCox_Vdi_si*Rdss_Ve_si+0.0*Rdss_Vdi_si+WVCox*Rdss_Vdi_si_Ve_si);
  T0_Vdi_si_Ve_di=(+0.0*Rdss+WVCox_Vdi_si*Rdss_Ve_di+0.0*Rdss_Vdi_si+WVCox*Rdss_Vdi_si_Ve_di);
  T0_Vdi_si_Vge_si=(+0.0*Rdss+WVCox_Vdi_si*Rdss_Vge_si+0.0*Rdss_Vdi_si+WVCox*Rdss_Vdi_si_Vge_si);
  T0_Vdi_si_Vdi_si=(+WVCox_Vdi_si_Vdi_si*Rdss+WVCox_Vdi_si*Rdss_Vdi_si+WVCox_Vdi_si*Rdss_Vdi_si+WVCox*Rdss_Vdi_si_Vdi_si);
  T0_Vdi_si_Tempt_GND=(+WVCox_Vdi_si_Tempt_GND*Rdss+WVCox_Vdi_si*Rdss_Tempt_GND+WVCox_Tempt_GND*Rdss_Vdi_si+WVCox*Rdss_Vdi_si_Tempt_GND);
#endif
T0_Tempt_GND=((WVCox_Tempt_GND*Rdss)+(WVCox*Rdss_Tempt_GND));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*Rdss+WVCox_Tempt_GND*0.0+0.0*Rdss_Tempt_GND+WVCox*0.0);
  T0_Tempt_GND_Vge_e=(+0.0*Rdss+WVCox_Tempt_GND*0.0+0.0*Rdss_Tempt_GND+WVCox*0.0);
  T0_Tempt_GND_Ve_si=(+0.0*Rdss+WVCox_Tempt_GND*Rdss_Ve_si+0.0*Rdss_Tempt_GND+WVCox*Rdss_Tempt_GND_Ve_si);
  T0_Tempt_GND_Ve_di=(+0.0*Rdss+WVCox_Tempt_GND*Rdss_Ve_di+0.0*Rdss_Tempt_GND+WVCox*Rdss_Tempt_GND_Ve_di);
  T0_Tempt_GND_Vge_si=(+0.0*Rdss+WVCox_Tempt_GND*Rdss_Vge_si+0.0*Rdss_Tempt_GND+WVCox*Rdss_Tempt_GND_Vge_si);
  T0_Tempt_GND_Vdi_si=(+WVCox_Tempt_GND_Vdi_si*Rdss+WVCox_Tempt_GND*Rdss_Vdi_si+WVCox_Vdi_si*Rdss_Tempt_GND+WVCox*Rdss_Tempt_GND_Vdi_si);
  T0_Tempt_GND_Tempt_GND=(+WVCox_Tempt_GND_Tempt_GND*Rdss+WVCox_Tempt_GND*Rdss_Tempt_GND+WVCox_Tempt_GND*Rdss_Tempt_GND+WVCox*Rdss_Tempt_GND_Tempt_GND);
#endif
#endif
T0=(WVCox*Rdss);
EXIT_IF_ISNAN((WVCox*Rdss))
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Ta_Ve_si=(2.0*T0_Ve_si);
#if defined(_DERIVATE2)
  Ta_Ve_si_Ve_si=(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+2.0*T0_Ve_si_Ve_si);
  Ta_Ve_si_Ve_di=(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+2.0*T0_Ve_si_Ve_di);
  Ta_Ve_si_Vge_si=(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+2.0*T0_Ve_si_Vge_si);
  Ta_Ve_si_Vdi_si=(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+2.0*T0_Ve_si_Vdi_si);
  Ta_Ve_si_Tempt_GND=(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+2.0*T0_Ve_si_Tempt_GND);
#endif
Ta_Ve_di=(2.0*T0_Ve_di);
#if defined(_DERIVATE2)
  Ta_Ve_di_Ve_si=(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+2.0*T0_Ve_di_Ve_si);
  Ta_Ve_di_Ve_di=(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+2.0*T0_Ve_di_Ve_di);
  Ta_Ve_di_Vge_si=(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+2.0*T0_Ve_di_Vge_si);
  Ta_Ve_di_Vdi_si=(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+2.0*T0_Ve_di_Vdi_si);
  Ta_Ve_di_Tempt_GND=(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+2.0*T0_Ve_di_Tempt_GND);
#endif
Ta_Vge_si=(2.0*T0_Vge_si);
#if defined(_DERIVATE2)
  Ta_Vge_si_Ve_si=(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+2.0*T0_Vge_si_Ve_si);
  Ta_Vge_si_Ve_di=(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+2.0*T0_Vge_si_Ve_di);
  Ta_Vge_si_Vge_si=(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+2.0*T0_Vge_si_Vge_si);
  Ta_Vge_si_Vdi_si=(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+2.0*T0_Vge_si_Vdi_si);
  Ta_Vge_si_Tempt_GND=(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+2.0*T0_Vge_si_Tempt_GND);
#endif
Ta_Vdi_si=(2.0*T0_Vdi_si);
#if defined(_DERIVATE2)
  Ta_Vdi_si_Ve_si=(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+2.0*T0_Vdi_si_Ve_si);
  Ta_Vdi_si_Ve_di=(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+2.0*T0_Vdi_si_Ve_di);
  Ta_Vdi_si_Vge_si=(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+2.0*T0_Vdi_si_Vge_si);
  Ta_Vdi_si_Vdi_si=(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+2.0*T0_Vdi_si_Vdi_si);
  Ta_Vdi_si_Tempt_GND=(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+2.0*T0_Vdi_si_Tempt_GND);
#endif
Ta_Tempt_GND=(2.0*T0_Tempt_GND);
#if defined(_DERIVATE2)
  Ta_Tempt_GND_Ve_si=(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+2.0*T0_Tempt_GND_Ve_si);
  Ta_Tempt_GND_Ve_di=(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+2.0*T0_Tempt_GND_Ve_di);
  Ta_Tempt_GND_Vge_si=(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+2.0*T0_Tempt_GND_Vge_si);
  Ta_Tempt_GND_Vdi_si=(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+2.0*T0_Tempt_GND_Vdi_si);
  Ta_Tempt_GND_Tempt_GND=(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+2.0*T0_Tempt_GND_Tempt_GND);
#endif
#endif
Ta=(2.0*T0);
EXIT_IF_ISNAN((2.0*T0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
Tb_Vdi_si=((T6_Vdi_si+EsatL_Vdi_si)+(((3.0*T6_Vdi_si)*T0)+((3.0*T6)*T0_Vdi_si)));
#if defined(_DERIVATE2)
  Tb_Vdi_si_Vdi_si=(+(+T6_Vdi_si_Vdi_si+EsatL_Vdi_si_Vdi_si)+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Vdi_si+3.0*T6_Vdi_si_Vdi_si)*T0+(3.0*T6_Vdi_si)*T0_Vdi_si+((3.0*T6_Vdi_si))*T0_Vdi_si+(3.0*T6)*T0_Vdi_si_Vdi_si));
  Tb_Vdi_si_Ve_si=(+(+T6_Vdi_si_Ve_si+EsatL_Vdi_si_Ve_si)+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Vdi_si+3.0*T6_Vdi_si_Ve_si)*T0+(3.0*T6_Vdi_si)*T0_Ve_si+((3.0*T6_Ve_si))*T0_Vdi_si+(3.0*T6)*T0_Vdi_si_Ve_si));
  Tb_Vdi_si_Ve_di=(+(+T6_Vdi_si_Ve_di+EsatL_Vdi_si_Ve_di)+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Vdi_si+3.0*T6_Vdi_si_Ve_di)*T0+(3.0*T6_Vdi_si)*T0_Ve_di+((3.0*T6_Ve_di))*T0_Vdi_si+(3.0*T6)*T0_Vdi_si_Ve_di));
  Tb_Vdi_si_Vge_si=(+(+T6_Vdi_si_Vge_si+EsatL_Vdi_si_Vge_si)+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Vdi_si+3.0*T6_Vdi_si_Vge_si)*T0+(3.0*T6_Vdi_si)*T0_Vge_si+((3.0*T6_Vge_si))*T0_Vdi_si+(3.0*T6)*T0_Vdi_si_Vge_si));
  Tb_Vdi_si_Tempt_GND=(+(+T6_Vdi_si_Tempt_GND+EsatL_Vdi_si_Tempt_GND)+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Vdi_si+3.0*T6_Vdi_si_Tempt_GND)*T0+(3.0*T6_Vdi_si)*T0_Tempt_GND+((3.0*T6_Tempt_GND))*T0_Vdi_si+(3.0*T6)*T0_Vdi_si_Tempt_GND));
#endif
Tb_Ve_si=((T6_Ve_si+EsatL_Ve_si)+(((3.0*T6_Ve_si)*T0)+((3.0*T6)*T0_Ve_si)));
#if defined(_DERIVATE2)
  Tb_Ve_si_Vdi_si=(+(+T6_Ve_si_Vdi_si+EsatL_Ve_si_Vdi_si)+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Ve_si+3.0*T6_Ve_si_Vdi_si)*T0+(3.0*T6_Ve_si)*T0_Vdi_si+((3.0*T6_Vdi_si))*T0_Ve_si+(3.0*T6)*T0_Ve_si_Vdi_si));
  Tb_Ve_si_Ve_si=(+(+T6_Ve_si_Ve_si+EsatL_Ve_si_Ve_si)+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Ve_si+3.0*T6_Ve_si_Ve_si)*T0+(3.0*T6_Ve_si)*T0_Ve_si+((3.0*T6_Ve_si))*T0_Ve_si+(3.0*T6)*T0_Ve_si_Ve_si));
  Tb_Ve_si_Ve_di=(+(+T6_Ve_si_Ve_di+EsatL_Ve_si_Ve_di)+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Ve_si+3.0*T6_Ve_si_Ve_di)*T0+(3.0*T6_Ve_si)*T0_Ve_di+((3.0*T6_Ve_di))*T0_Ve_si+(3.0*T6)*T0_Ve_si_Ve_di));
  Tb_Ve_si_Vge_si=(+(+T6_Ve_si_Vge_si+EsatL_Ve_si_Vge_si)+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Ve_si+3.0*T6_Ve_si_Vge_si)*T0+(3.0*T6_Ve_si)*T0_Vge_si+((3.0*T6_Vge_si))*T0_Ve_si+(3.0*T6)*T0_Ve_si_Vge_si));
  Tb_Ve_si_Tempt_GND=(+(+T6_Ve_si_Tempt_GND+EsatL_Ve_si_Tempt_GND)+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Ve_si+3.0*T6_Ve_si_Tempt_GND)*T0+(3.0*T6_Ve_si)*T0_Tempt_GND+((3.0*T6_Tempt_GND))*T0_Ve_si+(3.0*T6)*T0_Ve_si_Tempt_GND));
#endif
Tb_Ve_di=((T6_Ve_di+EsatL_Ve_di)+(((3.0*T6_Ve_di)*T0)+((3.0*T6)*T0_Ve_di)));
#if defined(_DERIVATE2)
  Tb_Ve_di_Vdi_si=(+(+T6_Ve_di_Vdi_si+EsatL_Ve_di_Vdi_si)+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Ve_di+3.0*T6_Ve_di_Vdi_si)*T0+(3.0*T6_Ve_di)*T0_Vdi_si+((3.0*T6_Vdi_si))*T0_Ve_di+(3.0*T6)*T0_Ve_di_Vdi_si));
  Tb_Ve_di_Ve_si=(+(+T6_Ve_di_Ve_si+EsatL_Ve_di_Ve_si)+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Ve_di+3.0*T6_Ve_di_Ve_si)*T0+(3.0*T6_Ve_di)*T0_Ve_si+((3.0*T6_Ve_si))*T0_Ve_di+(3.0*T6)*T0_Ve_di_Ve_si));
  Tb_Ve_di_Ve_di=(+(+T6_Ve_di_Ve_di+EsatL_Ve_di_Ve_di)+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Ve_di+3.0*T6_Ve_di_Ve_di)*T0+(3.0*T6_Ve_di)*T0_Ve_di+((3.0*T6_Ve_di))*T0_Ve_di+(3.0*T6)*T0_Ve_di_Ve_di));
  Tb_Ve_di_Vge_si=(+(+T6_Ve_di_Vge_si+EsatL_Ve_di_Vge_si)+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Ve_di+3.0*T6_Ve_di_Vge_si)*T0+(3.0*T6_Ve_di)*T0_Vge_si+((3.0*T6_Vge_si))*T0_Ve_di+(3.0*T6)*T0_Ve_di_Vge_si));
  Tb_Ve_di_Tempt_GND=(+(+T6_Ve_di_Tempt_GND+EsatL_Ve_di_Tempt_GND)+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Ve_di+3.0*T6_Ve_di_Tempt_GND)*T0+(3.0*T6_Ve_di)*T0_Tempt_GND+((3.0*T6_Tempt_GND))*T0_Ve_di+(3.0*T6)*T0_Ve_di_Tempt_GND));
#endif
Tb_Vge_si=((T6_Vge_si+EsatL_Vge_si)+(((3.0*T6_Vge_si)*T0)+((3.0*T6)*T0_Vge_si)));
#if defined(_DERIVATE2)
  Tb_Vge_si_Vdi_si=(+(+T6_Vge_si_Vdi_si+EsatL_Vge_si_Vdi_si)+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Vge_si+3.0*T6_Vge_si_Vdi_si)*T0+(3.0*T6_Vge_si)*T0_Vdi_si+((3.0*T6_Vdi_si))*T0_Vge_si+(3.0*T6)*T0_Vge_si_Vdi_si));
  Tb_Vge_si_Ve_si=(+(+T6_Vge_si_Ve_si+EsatL_Vge_si_Ve_si)+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Vge_si+3.0*T6_Vge_si_Ve_si)*T0+(3.0*T6_Vge_si)*T0_Ve_si+((3.0*T6_Ve_si))*T0_Vge_si+(3.0*T6)*T0_Vge_si_Ve_si));
  Tb_Vge_si_Ve_di=(+(+T6_Vge_si_Ve_di+EsatL_Vge_si_Ve_di)+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Vge_si+3.0*T6_Vge_si_Ve_di)*T0+(3.0*T6_Vge_si)*T0_Ve_di+((3.0*T6_Ve_di))*T0_Vge_si+(3.0*T6)*T0_Vge_si_Ve_di));
  Tb_Vge_si_Vge_si=(+(+T6_Vge_si_Vge_si+EsatL_Vge_si_Vge_si)+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Vge_si+3.0*T6_Vge_si_Vge_si)*T0+(3.0*T6_Vge_si)*T0_Vge_si+((3.0*T6_Vge_si))*T0_Vge_si+(3.0*T6)*T0_Vge_si_Vge_si));
  Tb_Vge_si_Tempt_GND=(+(+T6_Vge_si_Tempt_GND+EsatL_Vge_si_Tempt_GND)+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Vge_si+3.0*T6_Vge_si_Tempt_GND)*T0+(3.0*T6_Vge_si)*T0_Tempt_GND+((3.0*T6_Tempt_GND))*T0_Vge_si+(3.0*T6)*T0_Vge_si_Tempt_GND));
#endif
Tb_Tempt_GND=((T6_Tempt_GND+EsatL_Tempt_GND)+(((3.0*T6_Tempt_GND)*T0)+((3.0*T6)*T0_Tempt_GND)));
#if defined(_DERIVATE2)
  Tb_Tempt_GND_Vdi_si=(+(+T6_Tempt_GND_Vdi_si+EsatL_Tempt_GND_Vdi_si)+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Tempt_GND+3.0*T6_Tempt_GND_Vdi_si)*T0+(3.0*T6_Tempt_GND)*T0_Vdi_si+((3.0*T6_Vdi_si))*T0_Tempt_GND+(3.0*T6)*T0_Tempt_GND_Vdi_si));
  Tb_Tempt_GND_Ve_si=(+(+T6_Tempt_GND_Ve_si+EsatL_Tempt_GND_Ve_si)+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Tempt_GND+3.0*T6_Tempt_GND_Ve_si)*T0+(3.0*T6_Tempt_GND)*T0_Ve_si+((3.0*T6_Ve_si))*T0_Tempt_GND+(3.0*T6)*T0_Tempt_GND_Ve_si));
  Tb_Tempt_GND_Ve_di=(+(+T6_Tempt_GND_Ve_di+EsatL_Tempt_GND_Ve_di)+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Tempt_GND+3.0*T6_Tempt_GND_Ve_di)*T0+(3.0*T6_Tempt_GND)*T0_Ve_di+((3.0*T6_Ve_di))*T0_Tempt_GND+(3.0*T6)*T0_Tempt_GND_Ve_di));
  Tb_Tempt_GND_Vge_si=(+(+T6_Tempt_GND_Vge_si+EsatL_Tempt_GND_Vge_si)+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Tempt_GND+3.0*T6_Tempt_GND_Vge_si)*T0+(3.0*T6_Tempt_GND)*T0_Vge_si+((3.0*T6_Vge_si))*T0_Tempt_GND+(3.0*T6)*T0_Tempt_GND_Vge_si));
  Tb_Tempt_GND_Tempt_GND=(+(+T6_Tempt_GND_Tempt_GND+EsatL_Tempt_GND_Tempt_GND)+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Tempt_GND+3.0*T6_Tempt_GND_Tempt_GND)*T0+(3.0*T6_Tempt_GND)*T0_Tempt_GND+((3.0*T6_Tempt_GND))*T0_Tempt_GND+(3.0*T6)*T0_Tempt_GND_Tempt_GND));
#endif
#endif
Tb=((T6+EsatL)+((3.0*T6)*T0));
EXIT_IF_ISNAN(((T6+EsatL)+((3.0*T6)*T0)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
Tc_Vdi_si=((T6_Vdi_si*(EsatL+((2.0*T6)*T0)))+(T6*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))));
#if defined(_DERIVATE2)
  Tc_Vdi_si_Vdi_si=(+T6_Vdi_si_Vdi_si*(EsatL+((2.0*T6)*T0))+T6_Vdi_si*(EsatL_Vdi_si+(((((2.0*T6_Vdi_si))*T0)+((2.0*T6)*T0_Vdi_si))))+T6_Vdi_si*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))+T6*(+EsatL_Vdi_si_Vdi_si+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Vdi_si+2.0*T6_Vdi_si_Vdi_si)*T0+(2.0*T6_Vdi_si)*T0_Vdi_si+((2.0*T6_Vdi_si))*T0_Vdi_si+(2.0*T6)*T0_Vdi_si_Vdi_si)));
  Tc_Vdi_si_Tempt_GND=(+T6_Vdi_si_Tempt_GND*(EsatL+((2.0*T6)*T0))+T6_Vdi_si*(EsatL_Tempt_GND+(((((2.0*T6_Tempt_GND))*T0)+((2.0*T6)*T0_Tempt_GND))))+T6_Tempt_GND*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))+T6*(+EsatL_Vdi_si_Tempt_GND+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Vdi_si+2.0*T6_Vdi_si_Tempt_GND)*T0+(2.0*T6_Vdi_si)*T0_Tempt_GND+((2.0*T6_Tempt_GND))*T0_Vdi_si+(2.0*T6)*T0_Vdi_si_Tempt_GND)));
  Tc_Vdi_si_Ve_si=(+T6_Vdi_si_Ve_si*(EsatL+((2.0*T6)*T0))+T6_Vdi_si*(EsatL_Ve_si+(((((2.0*T6_Ve_si))*T0)+((2.0*T6)*T0_Ve_si))))+T6_Ve_si*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))+T6*(+EsatL_Vdi_si_Ve_si+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Vdi_si+2.0*T6_Vdi_si_Ve_si)*T0+(2.0*T6_Vdi_si)*T0_Ve_si+((2.0*T6_Ve_si))*T0_Vdi_si+(2.0*T6)*T0_Vdi_si_Ve_si)));
  Tc_Vdi_si_Ve_di=(+T6_Vdi_si_Ve_di*(EsatL+((2.0*T6)*T0))+T6_Vdi_si*(EsatL_Ve_di+(((((2.0*T6_Ve_di))*T0)+((2.0*T6)*T0_Ve_di))))+T6_Ve_di*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))+T6*(+EsatL_Vdi_si_Ve_di+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Vdi_si+2.0*T6_Vdi_si_Ve_di)*T0+(2.0*T6_Vdi_si)*T0_Ve_di+((2.0*T6_Ve_di))*T0_Vdi_si+(2.0*T6)*T0_Vdi_si_Ve_di)));
  Tc_Vdi_si_Vge_si=(+T6_Vdi_si_Vge_si*(EsatL+((2.0*T6)*T0))+T6_Vdi_si*(EsatL_Vge_si+(((((2.0*T6_Vge_si))*T0)+((2.0*T6)*T0_Vge_si))))+T6_Vge_si*(EsatL_Vdi_si+(((2.0*T6_Vdi_si)*T0)+((2.0*T6)*T0_Vdi_si)))+T6*(+EsatL_Vdi_si_Vge_si+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Vdi_si+2.0*T6_Vdi_si_Vge_si)*T0+(2.0*T6_Vdi_si)*T0_Vge_si+((2.0*T6_Vge_si))*T0_Vdi_si+(2.0*T6)*T0_Vdi_si_Vge_si)));
#endif
Tc_Tempt_GND=((T6_Tempt_GND*(EsatL+((2.0*T6)*T0)))+(T6*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))));
#if defined(_DERIVATE2)
  Tc_Tempt_GND_Vdi_si=(+T6_Tempt_GND_Vdi_si*(EsatL+((2.0*T6)*T0))+T6_Tempt_GND*(EsatL_Vdi_si+(((((2.0*T6_Vdi_si))*T0)+((2.0*T6)*T0_Vdi_si))))+T6_Vdi_si*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))+T6*(+EsatL_Tempt_GND_Vdi_si+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Tempt_GND+2.0*T6_Tempt_GND_Vdi_si)*T0+(2.0*T6_Tempt_GND)*T0_Vdi_si+((2.0*T6_Vdi_si))*T0_Tempt_GND+(2.0*T6)*T0_Tempt_GND_Vdi_si)));
  Tc_Tempt_GND_Tempt_GND=(+T6_Tempt_GND_Tempt_GND*(EsatL+((2.0*T6)*T0))+T6_Tempt_GND*(EsatL_Tempt_GND+(((((2.0*T6_Tempt_GND))*T0)+((2.0*T6)*T0_Tempt_GND))))+T6_Tempt_GND*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))+T6*(+EsatL_Tempt_GND_Tempt_GND+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Tempt_GND+2.0*T6_Tempt_GND_Tempt_GND)*T0+(2.0*T6_Tempt_GND)*T0_Tempt_GND+((2.0*T6_Tempt_GND))*T0_Tempt_GND+(2.0*T6)*T0_Tempt_GND_Tempt_GND)));
  Tc_Tempt_GND_Ve_si=(+T6_Tempt_GND_Ve_si*(EsatL+((2.0*T6)*T0))+T6_Tempt_GND*(EsatL_Ve_si+(((((2.0*T6_Ve_si))*T0)+((2.0*T6)*T0_Ve_si))))+T6_Ve_si*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))+T6*(+EsatL_Tempt_GND_Ve_si+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Tempt_GND+2.0*T6_Tempt_GND_Ve_si)*T0+(2.0*T6_Tempt_GND)*T0_Ve_si+((2.0*T6_Ve_si))*T0_Tempt_GND+(2.0*T6)*T0_Tempt_GND_Ve_si)));
  Tc_Tempt_GND_Ve_di=(+T6_Tempt_GND_Ve_di*(EsatL+((2.0*T6)*T0))+T6_Tempt_GND*(EsatL_Ve_di+(((((2.0*T6_Ve_di))*T0)+((2.0*T6)*T0_Ve_di))))+T6_Ve_di*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))+T6*(+EsatL_Tempt_GND_Ve_di+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Tempt_GND+2.0*T6_Tempt_GND_Ve_di)*T0+(2.0*T6_Tempt_GND)*T0_Ve_di+((2.0*T6_Ve_di))*T0_Tempt_GND+(2.0*T6)*T0_Tempt_GND_Ve_di)));
  Tc_Tempt_GND_Vge_si=(+T6_Tempt_GND_Vge_si*(EsatL+((2.0*T6)*T0))+T6_Tempt_GND*(EsatL_Vge_si+(((((2.0*T6_Vge_si))*T0)+((2.0*T6)*T0_Vge_si))))+T6_Vge_si*(EsatL_Tempt_GND+(((2.0*T6_Tempt_GND)*T0)+((2.0*T6)*T0_Tempt_GND)))+T6*(+EsatL_Tempt_GND_Vge_si+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Tempt_GND+2.0*T6_Tempt_GND_Vge_si)*T0+(2.0*T6_Tempt_GND)*T0_Vge_si+((2.0*T6_Vge_si))*T0_Tempt_GND+(2.0*T6)*T0_Tempt_GND_Vge_si)));
#endif
Tc_Ve_si=((T6_Ve_si*(EsatL+((2.0*T6)*T0)))+(T6*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))));
#if defined(_DERIVATE2)
  Tc_Ve_si_Vdi_si=(+T6_Ve_si_Vdi_si*(EsatL+((2.0*T6)*T0))+T6_Ve_si*(EsatL_Vdi_si+(((((2.0*T6_Vdi_si))*T0)+((2.0*T6)*T0_Vdi_si))))+T6_Vdi_si*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))+T6*(+EsatL_Ve_si_Vdi_si+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Ve_si+2.0*T6_Ve_si_Vdi_si)*T0+(2.0*T6_Ve_si)*T0_Vdi_si+((2.0*T6_Vdi_si))*T0_Ve_si+(2.0*T6)*T0_Ve_si_Vdi_si)));
  Tc_Ve_si_Tempt_GND=(+T6_Ve_si_Tempt_GND*(EsatL+((2.0*T6)*T0))+T6_Ve_si*(EsatL_Tempt_GND+(((((2.0*T6_Tempt_GND))*T0)+((2.0*T6)*T0_Tempt_GND))))+T6_Tempt_GND*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))+T6*(+EsatL_Ve_si_Tempt_GND+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Ve_si+2.0*T6_Ve_si_Tempt_GND)*T0+(2.0*T6_Ve_si)*T0_Tempt_GND+((2.0*T6_Tempt_GND))*T0_Ve_si+(2.0*T6)*T0_Ve_si_Tempt_GND)));
  Tc_Ve_si_Ve_si=(+T6_Ve_si_Ve_si*(EsatL+((2.0*T6)*T0))+T6_Ve_si*(EsatL_Ve_si+(((((2.0*T6_Ve_si))*T0)+((2.0*T6)*T0_Ve_si))))+T6_Ve_si*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))+T6*(+EsatL_Ve_si_Ve_si+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Ve_si+2.0*T6_Ve_si_Ve_si)*T0+(2.0*T6_Ve_si)*T0_Ve_si+((2.0*T6_Ve_si))*T0_Ve_si+(2.0*T6)*T0_Ve_si_Ve_si)));
  Tc_Ve_si_Ve_di=(+T6_Ve_si_Ve_di*(EsatL+((2.0*T6)*T0))+T6_Ve_si*(EsatL_Ve_di+(((((2.0*T6_Ve_di))*T0)+((2.0*T6)*T0_Ve_di))))+T6_Ve_di*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))+T6*(+EsatL_Ve_si_Ve_di+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Ve_si+2.0*T6_Ve_si_Ve_di)*T0+(2.0*T6_Ve_si)*T0_Ve_di+((2.0*T6_Ve_di))*T0_Ve_si+(2.0*T6)*T0_Ve_si_Ve_di)));
  Tc_Ve_si_Vge_si=(+T6_Ve_si_Vge_si*(EsatL+((2.0*T6)*T0))+T6_Ve_si*(EsatL_Vge_si+(((((2.0*T6_Vge_si))*T0)+((2.0*T6)*T0_Vge_si))))+T6_Vge_si*(EsatL_Ve_si+(((2.0*T6_Ve_si)*T0)+((2.0*T6)*T0_Ve_si)))+T6*(+EsatL_Ve_si_Vge_si+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Ve_si+2.0*T6_Ve_si_Vge_si)*T0+(2.0*T6_Ve_si)*T0_Vge_si+((2.0*T6_Vge_si))*T0_Ve_si+(2.0*T6)*T0_Ve_si_Vge_si)));
#endif
Tc_Ve_di=((T6_Ve_di*(EsatL+((2.0*T6)*T0)))+(T6*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))));
#if defined(_DERIVATE2)
  Tc_Ve_di_Vdi_si=(+T6_Ve_di_Vdi_si*(EsatL+((2.0*T6)*T0))+T6_Ve_di*(EsatL_Vdi_si+(((((2.0*T6_Vdi_si))*T0)+((2.0*T6)*T0_Vdi_si))))+T6_Vdi_si*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))+T6*(+EsatL_Ve_di_Vdi_si+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Ve_di+2.0*T6_Ve_di_Vdi_si)*T0+(2.0*T6_Ve_di)*T0_Vdi_si+((2.0*T6_Vdi_si))*T0_Ve_di+(2.0*T6)*T0_Ve_di_Vdi_si)));
  Tc_Ve_di_Tempt_GND=(+T6_Ve_di_Tempt_GND*(EsatL+((2.0*T6)*T0))+T6_Ve_di*(EsatL_Tempt_GND+(((((2.0*T6_Tempt_GND))*T0)+((2.0*T6)*T0_Tempt_GND))))+T6_Tempt_GND*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))+T6*(+EsatL_Ve_di_Tempt_GND+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Ve_di+2.0*T6_Ve_di_Tempt_GND)*T0+(2.0*T6_Ve_di)*T0_Tempt_GND+((2.0*T6_Tempt_GND))*T0_Ve_di+(2.0*T6)*T0_Ve_di_Tempt_GND)));
  Tc_Ve_di_Ve_si=(+T6_Ve_di_Ve_si*(EsatL+((2.0*T6)*T0))+T6_Ve_di*(EsatL_Ve_si+(((((2.0*T6_Ve_si))*T0)+((2.0*T6)*T0_Ve_si))))+T6_Ve_si*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))+T6*(+EsatL_Ve_di_Ve_si+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Ve_di+2.0*T6_Ve_di_Ve_si)*T0+(2.0*T6_Ve_di)*T0_Ve_si+((2.0*T6_Ve_si))*T0_Ve_di+(2.0*T6)*T0_Ve_di_Ve_si)));
  Tc_Ve_di_Ve_di=(+T6_Ve_di_Ve_di*(EsatL+((2.0*T6)*T0))+T6_Ve_di*(EsatL_Ve_di+(((((2.0*T6_Ve_di))*T0)+((2.0*T6)*T0_Ve_di))))+T6_Ve_di*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))+T6*(+EsatL_Ve_di_Ve_di+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Ve_di+2.0*T6_Ve_di_Ve_di)*T0+(2.0*T6_Ve_di)*T0_Ve_di+((2.0*T6_Ve_di))*T0_Ve_di+(2.0*T6)*T0_Ve_di_Ve_di)));
  Tc_Ve_di_Vge_si=(+T6_Ve_di_Vge_si*(EsatL+((2.0*T6)*T0))+T6_Ve_di*(EsatL_Vge_si+(((((2.0*T6_Vge_si))*T0)+((2.0*T6)*T0_Vge_si))))+T6_Vge_si*(EsatL_Ve_di+(((2.0*T6_Ve_di)*T0)+((2.0*T6)*T0_Ve_di)))+T6*(+EsatL_Ve_di_Vge_si+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Ve_di+2.0*T6_Ve_di_Vge_si)*T0+(2.0*T6_Ve_di)*T0_Vge_si+((2.0*T6_Vge_si))*T0_Ve_di+(2.0*T6)*T0_Ve_di_Vge_si)));
#endif
Tc_Vge_si=((T6_Vge_si*(EsatL+((2.0*T6)*T0)))+(T6*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))));
#if defined(_DERIVATE2)
  Tc_Vge_si_Vdi_si=(+T6_Vge_si_Vdi_si*(EsatL+((2.0*T6)*T0))+T6_Vge_si*(EsatL_Vdi_si+(((((2.0*T6_Vdi_si))*T0)+((2.0*T6)*T0_Vdi_si))))+T6_Vdi_si*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))+T6*(+EsatL_Vge_si_Vdi_si+(+(+0.0*T6+0.0*T6_Vdi_si+0.0*T6_Vge_si+2.0*T6_Vge_si_Vdi_si)*T0+(2.0*T6_Vge_si)*T0_Vdi_si+((2.0*T6_Vdi_si))*T0_Vge_si+(2.0*T6)*T0_Vge_si_Vdi_si)));
  Tc_Vge_si_Tempt_GND=(+T6_Vge_si_Tempt_GND*(EsatL+((2.0*T6)*T0))+T6_Vge_si*(EsatL_Tempt_GND+(((((2.0*T6_Tempt_GND))*T0)+((2.0*T6)*T0_Tempt_GND))))+T6_Tempt_GND*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))+T6*(+EsatL_Vge_si_Tempt_GND+(+(+0.0*T6+0.0*T6_Tempt_GND+0.0*T6_Vge_si+2.0*T6_Vge_si_Tempt_GND)*T0+(2.0*T6_Vge_si)*T0_Tempt_GND+((2.0*T6_Tempt_GND))*T0_Vge_si+(2.0*T6)*T0_Vge_si_Tempt_GND)));
  Tc_Vge_si_Ve_si=(+T6_Vge_si_Ve_si*(EsatL+((2.0*T6)*T0))+T6_Vge_si*(EsatL_Ve_si+(((((2.0*T6_Ve_si))*T0)+((2.0*T6)*T0_Ve_si))))+T6_Ve_si*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))+T6*(+EsatL_Vge_si_Ve_si+(+(+0.0*T6+0.0*T6_Ve_si+0.0*T6_Vge_si+2.0*T6_Vge_si_Ve_si)*T0+(2.0*T6_Vge_si)*T0_Ve_si+((2.0*T6_Ve_si))*T0_Vge_si+(2.0*T6)*T0_Vge_si_Ve_si)));
  Tc_Vge_si_Ve_di=(+T6_Vge_si_Ve_di*(EsatL+((2.0*T6)*T0))+T6_Vge_si*(EsatL_Ve_di+(((((2.0*T6_Ve_di))*T0)+((2.0*T6)*T0_Ve_di))))+T6_Ve_di*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))+T6*(+EsatL_Vge_si_Ve_di+(+(+0.0*T6+0.0*T6_Ve_di+0.0*T6_Vge_si+2.0*T6_Vge_si_Ve_di)*T0+(2.0*T6_Vge_si)*T0_Ve_di+((2.0*T6_Ve_di))*T0_Vge_si+(2.0*T6)*T0_Vge_si_Ve_di)));
  Tc_Vge_si_Vge_si=(+T6_Vge_si_Vge_si*(EsatL+((2.0*T6)*T0))+T6_Vge_si*(EsatL_Vge_si+(((((2.0*T6_Vge_si))*T0)+((2.0*T6)*T0_Vge_si))))+T6_Vge_si*(EsatL_Vge_si+(((2.0*T6_Vge_si)*T0)+((2.0*T6)*T0_Vge_si)))+T6*(+EsatL_Vge_si_Vge_si+(+(+0.0*T6+0.0*T6_Vge_si+0.0*T6_Vge_si+2.0*T6_Vge_si_Vge_si)*T0+(2.0*T6_Vge_si)*T0_Vge_si+((2.0*T6_Vge_si))*T0_Vge_si+(2.0*T6)*T0_Vge_si_Vge_si)));
#endif
#endif
Tc=(T6*(EsatL+((2.0*T6)*T0)));
EXIT_IF_ISNAN((T6*(EsatL+((2.0*T6)*T0))))
{
double m00_sqrt(d00_sqrt0,((Tb*Tb)-((2.0*Ta)*Tc)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Tb*Tb)-((2.0*Ta)*Tc)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
Vdsat_Tempt_GND=(((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta-(Tb-d00_sqrt0)*Ta_Tempt_GND)/Ta/Ta);
#if defined(_DERIVATE2)
  Vdsat_Tempt_GND_Tempt_GND=((+Tb_Tempt_GND_Tempt_GND-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))+d10_sqrt0*(+(+Tb_Tempt_GND_Tempt_GND*Tb+Tb_Tempt_GND*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Tempt_GND)-(+(+0.0*Ta+0.0*Ta_Tempt_GND+0.0*Ta_Tempt_GND+2.0*Ta_Tempt_GND_Tempt_GND)*Tc+(2.0*Ta_Tempt_GND)*Tc_Tempt_GND+((2.0*Ta_Tempt_GND))*Tc_Tempt_GND+(2.0*Ta)*Tc_Tempt_GND_Tempt_GND))))/Ta-((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta_Tempt_GND+(Tb_Tempt_GND-((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*d10_sqrt0)*Ta_Tempt_GND+(Tb-d00_sqrt0)*Ta_Tempt_GND_Tempt_GND)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Tempt_GND*Ta_Tempt_GND/Ta/Ta/Ta);
  Vdsat_Tempt_GND_Vdi_si=((+Tb_Tempt_GND_Vdi_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))+d10_sqrt0*(+(+Tb_Tempt_GND_Vdi_si*Tb+Tb_Tempt_GND*Tb_Vdi_si+Tb_Vdi_si*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Vdi_si)-(+(+0.0*Ta+0.0*Ta_Vdi_si+0.0*Ta_Tempt_GND+2.0*Ta_Tempt_GND_Vdi_si)*Tc+(2.0*Ta_Tempt_GND)*Tc_Vdi_si+((2.0*Ta_Vdi_si))*Tc_Tempt_GND+(2.0*Ta)*Tc_Tempt_GND_Vdi_si))))/Ta-((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta_Vdi_si+(Tb_Vdi_si-((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*d10_sqrt0)*Ta_Tempt_GND+(Tb-d00_sqrt0)*Ta_Tempt_GND_Vdi_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Tempt_GND*Ta_Vdi_si/Ta/Ta/Ta);
  Vdsat_Tempt_GND_Ve_si=((+Tb_Tempt_GND_Ve_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))+d10_sqrt0*(+(+Tb_Tempt_GND_Ve_si*Tb+Tb_Tempt_GND*Tb_Ve_si+Tb_Ve_si*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Ve_si)-(+(+0.0*Ta+0.0*Ta_Ve_si+0.0*Ta_Tempt_GND+2.0*Ta_Tempt_GND_Ve_si)*Tc+(2.0*Ta_Tempt_GND)*Tc_Ve_si+((2.0*Ta_Ve_si))*Tc_Tempt_GND+(2.0*Ta)*Tc_Tempt_GND_Ve_si))))/Ta-((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta_Ve_si+(Tb_Ve_si-((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*d10_sqrt0)*Ta_Tempt_GND+(Tb-d00_sqrt0)*Ta_Tempt_GND_Ve_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Tempt_GND*Ta_Ve_si/Ta/Ta/Ta);
  Vdsat_Tempt_GND_Ve_di=((+Tb_Tempt_GND_Ve_di-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))+d10_sqrt0*(+(+Tb_Tempt_GND_Ve_di*Tb+Tb_Tempt_GND*Tb_Ve_di+Tb_Ve_di*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Ve_di)-(+(+0.0*Ta+0.0*Ta_Ve_di+0.0*Ta_Tempt_GND+2.0*Ta_Tempt_GND_Ve_di)*Tc+(2.0*Ta_Tempt_GND)*Tc_Ve_di+((2.0*Ta_Ve_di))*Tc_Tempt_GND+(2.0*Ta)*Tc_Tempt_GND_Ve_di))))/Ta-((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta_Ve_di+(Tb_Ve_di-((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*d10_sqrt0)*Ta_Tempt_GND+(Tb-d00_sqrt0)*Ta_Tempt_GND_Ve_di)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Tempt_GND*Ta_Ve_di/Ta/Ta/Ta);
  Vdsat_Tempt_GND_Vge_si=((+Tb_Tempt_GND_Vge_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))+d10_sqrt0*(+(+Tb_Tempt_GND_Vge_si*Tb+Tb_Tempt_GND*Tb_Vge_si+Tb_Vge_si*Tb_Tempt_GND+Tb*Tb_Tempt_GND_Vge_si)-(+(+0.0*Ta+0.0*Ta_Vge_si+0.0*Ta_Tempt_GND+2.0*Ta_Tempt_GND_Vge_si)*Tc+(2.0*Ta_Tempt_GND)*Tc_Vge_si+((2.0*Ta_Vge_si))*Tc_Tempt_GND+(2.0*Ta)*Tc_Tempt_GND_Vge_si))))/Ta-((Tb_Tempt_GND-(((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND))-(((2.0*Ta_Tempt_GND)*Tc)+((2.0*Ta)*Tc_Tempt_GND)))*d10_sqrt0)*Ta_Vge_si+(Tb_Vge_si-((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*d10_sqrt0)*Ta_Tempt_GND+(Tb-d00_sqrt0)*Ta_Tempt_GND_Vge_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Tempt_GND*Ta_Vge_si/Ta/Ta/Ta);
#endif
Vdsat_Vdi_si=(((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta-(Tb-d00_sqrt0)*Ta_Vdi_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Vdsat_Vdi_si_Tempt_GND=((+Tb_Vdi_si_Tempt_GND-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))+d10_sqrt0*(+(+Tb_Vdi_si_Tempt_GND*Tb+Tb_Vdi_si*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Vdi_si+Tb*Tb_Vdi_si_Tempt_GND)-(+(+0.0*Ta+0.0*Ta_Tempt_GND+0.0*Ta_Vdi_si+2.0*Ta_Vdi_si_Tempt_GND)*Tc+(2.0*Ta_Vdi_si)*Tc_Tempt_GND+((2.0*Ta_Tempt_GND))*Tc_Vdi_si+(2.0*Ta)*Tc_Vdi_si_Tempt_GND))))/Ta-((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta_Tempt_GND+(Tb_Tempt_GND-((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*d10_sqrt0)*Ta_Vdi_si+(Tb-d00_sqrt0)*Ta_Vdi_si_Tempt_GND)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vdi_si*Ta_Tempt_GND/Ta/Ta/Ta);
  Vdsat_Vdi_si_Vdi_si=((+Tb_Vdi_si_Vdi_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))+d10_sqrt0*(+(+Tb_Vdi_si_Vdi_si*Tb+Tb_Vdi_si*Tb_Vdi_si+Tb_Vdi_si*Tb_Vdi_si+Tb*Tb_Vdi_si_Vdi_si)-(+(+0.0*Ta+0.0*Ta_Vdi_si+0.0*Ta_Vdi_si+2.0*Ta_Vdi_si_Vdi_si)*Tc+(2.0*Ta_Vdi_si)*Tc_Vdi_si+((2.0*Ta_Vdi_si))*Tc_Vdi_si+(2.0*Ta)*Tc_Vdi_si_Vdi_si))))/Ta-((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta_Vdi_si+(Tb_Vdi_si-((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*d10_sqrt0)*Ta_Vdi_si+(Tb-d00_sqrt0)*Ta_Vdi_si_Vdi_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vdi_si*Ta_Vdi_si/Ta/Ta/Ta);
  Vdsat_Vdi_si_Ve_si=((+Tb_Vdi_si_Ve_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))+d10_sqrt0*(+(+Tb_Vdi_si_Ve_si*Tb+Tb_Vdi_si*Tb_Ve_si+Tb_Ve_si*Tb_Vdi_si+Tb*Tb_Vdi_si_Ve_si)-(+(+0.0*Ta+0.0*Ta_Ve_si+0.0*Ta_Vdi_si+2.0*Ta_Vdi_si_Ve_si)*Tc+(2.0*Ta_Vdi_si)*Tc_Ve_si+((2.0*Ta_Ve_si))*Tc_Vdi_si+(2.0*Ta)*Tc_Vdi_si_Ve_si))))/Ta-((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta_Ve_si+(Tb_Ve_si-((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*d10_sqrt0)*Ta_Vdi_si+(Tb-d00_sqrt0)*Ta_Vdi_si_Ve_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vdi_si*Ta_Ve_si/Ta/Ta/Ta);
  Vdsat_Vdi_si_Ve_di=((+Tb_Vdi_si_Ve_di-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))+d10_sqrt0*(+(+Tb_Vdi_si_Ve_di*Tb+Tb_Vdi_si*Tb_Ve_di+Tb_Ve_di*Tb_Vdi_si+Tb*Tb_Vdi_si_Ve_di)-(+(+0.0*Ta+0.0*Ta_Ve_di+0.0*Ta_Vdi_si+2.0*Ta_Vdi_si_Ve_di)*Tc+(2.0*Ta_Vdi_si)*Tc_Ve_di+((2.0*Ta_Ve_di))*Tc_Vdi_si+(2.0*Ta)*Tc_Vdi_si_Ve_di))))/Ta-((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta_Ve_di+(Tb_Ve_di-((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*d10_sqrt0)*Ta_Vdi_si+(Tb-d00_sqrt0)*Ta_Vdi_si_Ve_di)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vdi_si*Ta_Ve_di/Ta/Ta/Ta);
  Vdsat_Vdi_si_Vge_si=((+Tb_Vdi_si_Vge_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))+d10_sqrt0*(+(+Tb_Vdi_si_Vge_si*Tb+Tb_Vdi_si*Tb_Vge_si+Tb_Vge_si*Tb_Vdi_si+Tb*Tb_Vdi_si_Vge_si)-(+(+0.0*Ta+0.0*Ta_Vge_si+0.0*Ta_Vdi_si+2.0*Ta_Vdi_si_Vge_si)*Tc+(2.0*Ta_Vdi_si)*Tc_Vge_si+((2.0*Ta_Vge_si))*Tc_Vdi_si+(2.0*Ta)*Tc_Vdi_si_Vge_si))))/Ta-((Tb_Vdi_si-(((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si))-(((2.0*Ta_Vdi_si)*Tc)+((2.0*Ta)*Tc_Vdi_si)))*d10_sqrt0)*Ta_Vge_si+(Tb_Vge_si-((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*d10_sqrt0)*Ta_Vdi_si+(Tb-d00_sqrt0)*Ta_Vdi_si_Vge_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vdi_si*Ta_Vge_si/Ta/Ta/Ta);
#endif
Vdsat_Ve_si=(((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta-(Tb-d00_sqrt0)*Ta_Ve_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Vdsat_Ve_si_Tempt_GND=((+Tb_Ve_si_Tempt_GND-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))+d10_sqrt0*(+(+Tb_Ve_si_Tempt_GND*Tb+Tb_Ve_si*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Ve_si+Tb*Tb_Ve_si_Tempt_GND)-(+(+0.0*Ta+0.0*Ta_Tempt_GND+0.0*Ta_Ve_si+2.0*Ta_Ve_si_Tempt_GND)*Tc+(2.0*Ta_Ve_si)*Tc_Tempt_GND+((2.0*Ta_Tempt_GND))*Tc_Ve_si+(2.0*Ta)*Tc_Ve_si_Tempt_GND))))/Ta-((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta_Tempt_GND+(Tb_Tempt_GND-((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*d10_sqrt0)*Ta_Ve_si+(Tb-d00_sqrt0)*Ta_Ve_si_Tempt_GND)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_si*Ta_Tempt_GND/Ta/Ta/Ta);
  Vdsat_Ve_si_Vdi_si=((+Tb_Ve_si_Vdi_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))+d10_sqrt0*(+(+Tb_Ve_si_Vdi_si*Tb+Tb_Ve_si*Tb_Vdi_si+Tb_Vdi_si*Tb_Ve_si+Tb*Tb_Ve_si_Vdi_si)-(+(+0.0*Ta+0.0*Ta_Vdi_si+0.0*Ta_Ve_si+2.0*Ta_Ve_si_Vdi_si)*Tc+(2.0*Ta_Ve_si)*Tc_Vdi_si+((2.0*Ta_Vdi_si))*Tc_Ve_si+(2.0*Ta)*Tc_Ve_si_Vdi_si))))/Ta-((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta_Vdi_si+(Tb_Vdi_si-((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*d10_sqrt0)*Ta_Ve_si+(Tb-d00_sqrt0)*Ta_Ve_si_Vdi_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_si*Ta_Vdi_si/Ta/Ta/Ta);
  Vdsat_Ve_si_Ve_si=((+Tb_Ve_si_Ve_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))+d10_sqrt0*(+(+Tb_Ve_si_Ve_si*Tb+Tb_Ve_si*Tb_Ve_si+Tb_Ve_si*Tb_Ve_si+Tb*Tb_Ve_si_Ve_si)-(+(+0.0*Ta+0.0*Ta_Ve_si+0.0*Ta_Ve_si+2.0*Ta_Ve_si_Ve_si)*Tc+(2.0*Ta_Ve_si)*Tc_Ve_si+((2.0*Ta_Ve_si))*Tc_Ve_si+(2.0*Ta)*Tc_Ve_si_Ve_si))))/Ta-((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta_Ve_si+(Tb_Ve_si-((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*d10_sqrt0)*Ta_Ve_si+(Tb-d00_sqrt0)*Ta_Ve_si_Ve_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_si*Ta_Ve_si/Ta/Ta/Ta);
  Vdsat_Ve_si_Ve_di=((+Tb_Ve_si_Ve_di-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))+d10_sqrt0*(+(+Tb_Ve_si_Ve_di*Tb+Tb_Ve_si*Tb_Ve_di+Tb_Ve_di*Tb_Ve_si+Tb*Tb_Ve_si_Ve_di)-(+(+0.0*Ta+0.0*Ta_Ve_di+0.0*Ta_Ve_si+2.0*Ta_Ve_si_Ve_di)*Tc+(2.0*Ta_Ve_si)*Tc_Ve_di+((2.0*Ta_Ve_di))*Tc_Ve_si+(2.0*Ta)*Tc_Ve_si_Ve_di))))/Ta-((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta_Ve_di+(Tb_Ve_di-((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*d10_sqrt0)*Ta_Ve_si+(Tb-d00_sqrt0)*Ta_Ve_si_Ve_di)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_si*Ta_Ve_di/Ta/Ta/Ta);
  Vdsat_Ve_si_Vge_si=((+Tb_Ve_si_Vge_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))+d10_sqrt0*(+(+Tb_Ve_si_Vge_si*Tb+Tb_Ve_si*Tb_Vge_si+Tb_Vge_si*Tb_Ve_si+Tb*Tb_Ve_si_Vge_si)-(+(+0.0*Ta+0.0*Ta_Vge_si+0.0*Ta_Ve_si+2.0*Ta_Ve_si_Vge_si)*Tc+(2.0*Ta_Ve_si)*Tc_Vge_si+((2.0*Ta_Vge_si))*Tc_Ve_si+(2.0*Ta)*Tc_Ve_si_Vge_si))))/Ta-((Tb_Ve_si-(((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si))-(((2.0*Ta_Ve_si)*Tc)+((2.0*Ta)*Tc_Ve_si)))*d10_sqrt0)*Ta_Vge_si+(Tb_Vge_si-((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*d10_sqrt0)*Ta_Ve_si+(Tb-d00_sqrt0)*Ta_Ve_si_Vge_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_si*Ta_Vge_si/Ta/Ta/Ta);
#endif
Vdsat_Ve_di=(((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta-(Tb-d00_sqrt0)*Ta_Ve_di)/Ta/Ta);
#if defined(_DERIVATE2)
  Vdsat_Ve_di_Tempt_GND=((+Tb_Ve_di_Tempt_GND-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))+d10_sqrt0*(+(+Tb_Ve_di_Tempt_GND*Tb+Tb_Ve_di*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Ve_di+Tb*Tb_Ve_di_Tempt_GND)-(+(+0.0*Ta+0.0*Ta_Tempt_GND+0.0*Ta_Ve_di+2.0*Ta_Ve_di_Tempt_GND)*Tc+(2.0*Ta_Ve_di)*Tc_Tempt_GND+((2.0*Ta_Tempt_GND))*Tc_Ve_di+(2.0*Ta)*Tc_Ve_di_Tempt_GND))))/Ta-((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta_Tempt_GND+(Tb_Tempt_GND-((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*d10_sqrt0)*Ta_Ve_di+(Tb-d00_sqrt0)*Ta_Ve_di_Tempt_GND)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_di*Ta_Tempt_GND/Ta/Ta/Ta);
  Vdsat_Ve_di_Vdi_si=((+Tb_Ve_di_Vdi_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))+d10_sqrt0*(+(+Tb_Ve_di_Vdi_si*Tb+Tb_Ve_di*Tb_Vdi_si+Tb_Vdi_si*Tb_Ve_di+Tb*Tb_Ve_di_Vdi_si)-(+(+0.0*Ta+0.0*Ta_Vdi_si+0.0*Ta_Ve_di+2.0*Ta_Ve_di_Vdi_si)*Tc+(2.0*Ta_Ve_di)*Tc_Vdi_si+((2.0*Ta_Vdi_si))*Tc_Ve_di+(2.0*Ta)*Tc_Ve_di_Vdi_si))))/Ta-((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta_Vdi_si+(Tb_Vdi_si-((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*d10_sqrt0)*Ta_Ve_di+(Tb-d00_sqrt0)*Ta_Ve_di_Vdi_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_di*Ta_Vdi_si/Ta/Ta/Ta);
  Vdsat_Ve_di_Ve_si=((+Tb_Ve_di_Ve_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))+d10_sqrt0*(+(+Tb_Ve_di_Ve_si*Tb+Tb_Ve_di*Tb_Ve_si+Tb_Ve_si*Tb_Ve_di+Tb*Tb_Ve_di_Ve_si)-(+(+0.0*Ta+0.0*Ta_Ve_si+0.0*Ta_Ve_di+2.0*Ta_Ve_di_Ve_si)*Tc+(2.0*Ta_Ve_di)*Tc_Ve_si+((2.0*Ta_Ve_si))*Tc_Ve_di+(2.0*Ta)*Tc_Ve_di_Ve_si))))/Ta-((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta_Ve_si+(Tb_Ve_si-((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*d10_sqrt0)*Ta_Ve_di+(Tb-d00_sqrt0)*Ta_Ve_di_Ve_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_di*Ta_Ve_si/Ta/Ta/Ta);
  Vdsat_Ve_di_Ve_di=((+Tb_Ve_di_Ve_di-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))+d10_sqrt0*(+(+Tb_Ve_di_Ve_di*Tb+Tb_Ve_di*Tb_Ve_di+Tb_Ve_di*Tb_Ve_di+Tb*Tb_Ve_di_Ve_di)-(+(+0.0*Ta+0.0*Ta_Ve_di+0.0*Ta_Ve_di+2.0*Ta_Ve_di_Ve_di)*Tc+(2.0*Ta_Ve_di)*Tc_Ve_di+((2.0*Ta_Ve_di))*Tc_Ve_di+(2.0*Ta)*Tc_Ve_di_Ve_di))))/Ta-((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta_Ve_di+(Tb_Ve_di-((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*d10_sqrt0)*Ta_Ve_di+(Tb-d00_sqrt0)*Ta_Ve_di_Ve_di)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_di*Ta_Ve_di/Ta/Ta/Ta);
  Vdsat_Ve_di_Vge_si=((+Tb_Ve_di_Vge_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))+d10_sqrt0*(+(+Tb_Ve_di_Vge_si*Tb+Tb_Ve_di*Tb_Vge_si+Tb_Vge_si*Tb_Ve_di+Tb*Tb_Ve_di_Vge_si)-(+(+0.0*Ta+0.0*Ta_Vge_si+0.0*Ta_Ve_di+2.0*Ta_Ve_di_Vge_si)*Tc+(2.0*Ta_Ve_di)*Tc_Vge_si+((2.0*Ta_Vge_si))*Tc_Ve_di+(2.0*Ta)*Tc_Ve_di_Vge_si))))/Ta-((Tb_Ve_di-(((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di))-(((2.0*Ta_Ve_di)*Tc)+((2.0*Ta)*Tc_Ve_di)))*d10_sqrt0)*Ta_Vge_si+(Tb_Vge_si-((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*d10_sqrt0)*Ta_Ve_di+(Tb-d00_sqrt0)*Ta_Ve_di_Vge_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Ve_di*Ta_Vge_si/Ta/Ta/Ta);
#endif
Vdsat_Vge_si=(((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta-(Tb-d00_sqrt0)*Ta_Vge_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Vdsat_Vge_si_Tempt_GND=((+Tb_Vge_si_Tempt_GND-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))+d10_sqrt0*(+(+Tb_Vge_si_Tempt_GND*Tb+Tb_Vge_si*Tb_Tempt_GND+Tb_Tempt_GND*Tb_Vge_si+Tb*Tb_Vge_si_Tempt_GND)-(+(+0.0*Ta+0.0*Ta_Tempt_GND+0.0*Ta_Vge_si+2.0*Ta_Vge_si_Tempt_GND)*Tc+(2.0*Ta_Vge_si)*Tc_Tempt_GND+((2.0*Ta_Tempt_GND))*Tc_Vge_si+(2.0*Ta)*Tc_Vge_si_Tempt_GND))))/Ta-((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta_Tempt_GND+(Tb_Tempt_GND-((((Tb_Tempt_GND*Tb)+(Tb*Tb_Tempt_GND)))-(((((2.0*Ta_Tempt_GND))*Tc)+((2.0*Ta)*Tc_Tempt_GND))))*d10_sqrt0)*Ta_Vge_si+(Tb-d00_sqrt0)*Ta_Vge_si_Tempt_GND)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vge_si*Ta_Tempt_GND/Ta/Ta/Ta);
  Vdsat_Vge_si_Vdi_si=((+Tb_Vge_si_Vdi_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))+d10_sqrt0*(+(+Tb_Vge_si_Vdi_si*Tb+Tb_Vge_si*Tb_Vdi_si+Tb_Vdi_si*Tb_Vge_si+Tb*Tb_Vge_si_Vdi_si)-(+(+0.0*Ta+0.0*Ta_Vdi_si+0.0*Ta_Vge_si+2.0*Ta_Vge_si_Vdi_si)*Tc+(2.0*Ta_Vge_si)*Tc_Vdi_si+((2.0*Ta_Vdi_si))*Tc_Vge_si+(2.0*Ta)*Tc_Vge_si_Vdi_si))))/Ta-((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta_Vdi_si+(Tb_Vdi_si-((((Tb_Vdi_si*Tb)+(Tb*Tb_Vdi_si)))-(((((2.0*Ta_Vdi_si))*Tc)+((2.0*Ta)*Tc_Vdi_si))))*d10_sqrt0)*Ta_Vge_si+(Tb-d00_sqrt0)*Ta_Vge_si_Vdi_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vge_si*Ta_Vdi_si/Ta/Ta/Ta);
  Vdsat_Vge_si_Ve_si=((+Tb_Vge_si_Ve_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))+d10_sqrt0*(+(+Tb_Vge_si_Ve_si*Tb+Tb_Vge_si*Tb_Ve_si+Tb_Ve_si*Tb_Vge_si+Tb*Tb_Vge_si_Ve_si)-(+(+0.0*Ta+0.0*Ta_Ve_si+0.0*Ta_Vge_si+2.0*Ta_Vge_si_Ve_si)*Tc+(2.0*Ta_Vge_si)*Tc_Ve_si+((2.0*Ta_Ve_si))*Tc_Vge_si+(2.0*Ta)*Tc_Vge_si_Ve_si))))/Ta-((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta_Ve_si+(Tb_Ve_si-((((Tb_Ve_si*Tb)+(Tb*Tb_Ve_si)))-(((((2.0*Ta_Ve_si))*Tc)+((2.0*Ta)*Tc_Ve_si))))*d10_sqrt0)*Ta_Vge_si+(Tb-d00_sqrt0)*Ta_Vge_si_Ve_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vge_si*Ta_Ve_si/Ta/Ta/Ta);
  Vdsat_Vge_si_Ve_di=((+Tb_Vge_si_Ve_di-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))+d10_sqrt0*(+(+Tb_Vge_si_Ve_di*Tb+Tb_Vge_si*Tb_Ve_di+Tb_Ve_di*Tb_Vge_si+Tb*Tb_Vge_si_Ve_di)-(+(+0.0*Ta+0.0*Ta_Ve_di+0.0*Ta_Vge_si+2.0*Ta_Vge_si_Ve_di)*Tc+(2.0*Ta_Vge_si)*Tc_Ve_di+((2.0*Ta_Ve_di))*Tc_Vge_si+(2.0*Ta)*Tc_Vge_si_Ve_di))))/Ta-((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta_Ve_di+(Tb_Ve_di-((((Tb_Ve_di*Tb)+(Tb*Tb_Ve_di)))-(((((2.0*Ta_Ve_di))*Tc)+((2.0*Ta)*Tc_Ve_di))))*d10_sqrt0)*Ta_Vge_si+(Tb-d00_sqrt0)*Ta_Vge_si_Ve_di)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vge_si*Ta_Ve_di/Ta/Ta/Ta);
  Vdsat_Vge_si_Vge_si=((+Tb_Vge_si_Vge_si-(m20_sqrt(((Tb*Tb)-((2.0*Ta)*Tc)))*((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))+d10_sqrt0*(+(+Tb_Vge_si_Vge_si*Tb+Tb_Vge_si*Tb_Vge_si+Tb_Vge_si*Tb_Vge_si+Tb*Tb_Vge_si_Vge_si)-(+(+0.0*Ta+0.0*Ta_Vge_si+0.0*Ta_Vge_si+2.0*Ta_Vge_si_Vge_si)*Tc+(2.0*Ta_Vge_si)*Tc_Vge_si+((2.0*Ta_Vge_si))*Tc_Vge_si+(2.0*Ta)*Tc_Vge_si_Vge_si))))/Ta-((Tb_Vge_si-(((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si))-(((2.0*Ta_Vge_si)*Tc)+((2.0*Ta)*Tc_Vge_si)))*d10_sqrt0)*Ta_Vge_si+(Tb_Vge_si-((((Tb_Vge_si*Tb)+(Tb*Tb_Vge_si)))-(((((2.0*Ta_Vge_si))*Tc)+((2.0*Ta)*Tc_Vge_si))))*d10_sqrt0)*Ta_Vge_si+(Tb-d00_sqrt0)*Ta_Vge_si_Vge_si)/Ta/Ta+2*(Tb-d00_sqrt0)*Ta_Vge_si*Ta_Vge_si/Ta/Ta/Ta);
#endif
#endif
Vdsat=((Tb-d00_sqrt0)/Ta);
EXIT_IF_ISNAN(((Tb-d00_sqrt0)/Ta))
}
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
Vdsat_Tempt_GND=bsimcmg_d_hypsmooth((Vdsat-1.0e-3),1.0e-5,Vdsat_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  Vdsat_Tempt_GND_Tempt_GND=(+0.0+0.0);
  Vdsat_Tempt_GND_Vdi_si=(+0.0+0.0);
  Vdsat_Tempt_GND_Ve_si=(+0.0+0.0);
  Vdsat_Tempt_GND_Ve_di=(+0.0+0.0);
  Vdsat_Tempt_GND_Vge_si=(+0.0+0.0);
#endif
Vdsat_Vdi_si=bsimcmg_d_hypsmooth((Vdsat-1.0e-3),1.0e-5,Vdsat_Vdi_si,0.0);
#if defined(_DERIVATE2)
  Vdsat_Vdi_si_Tempt_GND=(+0.0+0.0);
  Vdsat_Vdi_si_Vdi_si=(+0.0+0.0);
  Vdsat_Vdi_si_Ve_si=(+0.0+0.0);
  Vdsat_Vdi_si_Ve_di=(+0.0+0.0);
  Vdsat_Vdi_si_Vge_si=(+0.0+0.0);
#endif
Vdsat_Ve_si=bsimcmg_d_hypsmooth((Vdsat-1.0e-3),1.0e-5,Vdsat_Ve_si,0.0);
#if defined(_DERIVATE2)
  Vdsat_Ve_si_Tempt_GND=(+0.0+0.0);
  Vdsat_Ve_si_Vdi_si=(+0.0+0.0);
  Vdsat_Ve_si_Ve_si=(+0.0+0.0);
  Vdsat_Ve_si_Ve_di=(+0.0+0.0);
  Vdsat_Ve_si_Vge_si=(+0.0+0.0);
#endif
Vdsat_Ve_di=bsimcmg_d_hypsmooth((Vdsat-1.0e-3),1.0e-5,Vdsat_Ve_di,0.0);
#if defined(_DERIVATE2)
  Vdsat_Ve_di_Tempt_GND=(+0.0+0.0);
  Vdsat_Ve_di_Vdi_si=(+0.0+0.0);
  Vdsat_Ve_di_Ve_si=(+0.0+0.0);
  Vdsat_Ve_di_Ve_di=(+0.0+0.0);
  Vdsat_Ve_di_Vge_si=(+0.0+0.0);
#endif
Vdsat_Vge_si=bsimcmg_d_hypsmooth((Vdsat-1.0e-3),1.0e-5,Vdsat_Vge_si,0.0);
#if defined(_DERIVATE2)
  Vdsat_Vge_si_Tempt_GND=(+0.0+0.0);
  Vdsat_Vge_si_Vdi_si=(+0.0+0.0);
  Vdsat_Vge_si_Ve_si=(+0.0+0.0);
  Vdsat_Vge_si_Ve_di=(+0.0+0.0);
  Vdsat_Vge_si_Vge_si=(+0.0+0.0);
#endif
#endif
Vdsat=(bsimcmg_hypsmooth((Vdsat-1.0e-3),1.0e-5)+1.0e-3);
EXIT_IF_ISNAN((bsimcmg_hypsmooth((Vdsat-1.0e-3),1.0e-5)+1.0e-3))
{
double m00_pow(d00_pow0,(vds/Vdsat),MEXP_a)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(vds/Vdsat),MEXP_a)
double m11_pow(d11_pow0,d00_pow0,(vds/Vdsat),MEXP_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=0.0;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=0.0;
  T7_Vge_e_Vdi_d=0.0;
  T7_Vge_e_Vsi_s=0.0;
  T7_Vge_e_Vge_e=0.0;
  T7_Vge_e_Vdi_si=0.0;
  T7_Vge_e_Ve_si=0.0;
  T7_Vge_e_Ve_di=0.0;
  T7_Vge_e_Vge_si=0.0;
  T7_Vge_e_Tempt_GND=0.0;
#endif
T7_Vdi_si=(d10_pow0*((vds_Vdi_si*Vdsat-vds*Vdsat_Vdi_si)/Vdsat/Vdsat)+d11_pow0*MEXP_a_Vdi_si);
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=fixme;
  T7_Vdi_si_Vdi_d=fixme;
  T7_Vdi_si_Vsi_s=fixme;
  T7_Vdi_si_Vge_e=fixme;
  T7_Vdi_si_Vdi_si=fixme;
  T7_Vdi_si_Ve_si=fixme;
  T7_Vdi_si_Ve_di=fixme;
  T7_Vdi_si_Vge_si=fixme;
  T7_Vdi_si_Tempt_GND=fixme;
#endif
T7_Ve_si=(d10_pow0*(-vds*Vdsat_Ve_si/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=fixme;
  T7_Ve_si_Vdi_d=fixme;
  T7_Ve_si_Vsi_s=fixme;
  T7_Ve_si_Vge_e=fixme;
  T7_Ve_si_Vdi_si=fixme;
  T7_Ve_si_Ve_si=fixme;
  T7_Ve_si_Ve_di=fixme;
  T7_Ve_si_Vge_si=fixme;
  T7_Ve_si_Tempt_GND=fixme;
#endif
T7_Ve_di=(d10_pow0*(-vds*Vdsat_Ve_di/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=fixme;
  T7_Ve_di_Vdi_d=fixme;
  T7_Ve_di_Vsi_s=fixme;
  T7_Ve_di_Vge_e=fixme;
  T7_Ve_di_Vdi_si=fixme;
  T7_Ve_di_Ve_si=fixme;
  T7_Ve_di_Ve_di=fixme;
  T7_Ve_di_Vge_si=fixme;
  T7_Ve_di_Tempt_GND=fixme;
#endif
T7_Vge_si=(d10_pow0*(-vds*Vdsat_Vge_si/Vdsat/Vdsat));
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=fixme;
  T7_Vge_si_Vdi_d=fixme;
  T7_Vge_si_Vsi_s=fixme;
  T7_Vge_si_Vge_e=fixme;
  T7_Vge_si_Vdi_si=fixme;
  T7_Vge_si_Ve_si=fixme;
  T7_Vge_si_Ve_di=fixme;
  T7_Vge_si_Vge_si=fixme;
  T7_Vge_si_Tempt_GND=fixme;
#endif
T7_Tempt_GND=(d10_pow0*(-vds*Vdsat_Tempt_GND/Vdsat/Vdsat)+d11_pow0*MEXP_a_Tempt_GND);
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=fixme;
  T7_Tempt_GND_Vdi_d=fixme;
  T7_Tempt_GND_Vsi_s=fixme;
  T7_Tempt_GND_Vge_e=fixme;
  T7_Tempt_GND_Vdi_si=fixme;
  T7_Tempt_GND_Ve_si=fixme;
  T7_Tempt_GND_Ve_di=fixme;
  T7_Tempt_GND_Vge_si=fixme;
  T7_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T7=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
{
double m00_pow(d00_pow0,(1.0+T7),inv_MEXP)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(1.0+T7),inv_MEXP)
double m11_pow(d11_pow0,d00_pow0,(1.0+T7),inv_MEXP)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=(d10_pow0*T7_Vdi_si+d11_pow0*inv_MEXP_Vdi_si);
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=fixme;
  T8_Vdi_si_Vdi_si=fixme;
  T8_Vdi_si_Ve_si=fixme;
  T8_Vdi_si_Ve_di=fixme;
  T8_Vdi_si_Vge_si=fixme;
  T8_Vdi_si_Tempt_GND=fixme;
#endif
T8_Ve_si=(d10_pow0*T7_Ve_si);
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=fixme;
  T8_Ve_si_Vdi_si=fixme;
  T8_Ve_si_Ve_si=fixme;
  T8_Ve_si_Ve_di=fixme;
  T8_Ve_si_Vge_si=fixme;
  T8_Ve_si_Tempt_GND=fixme;
#endif
T8_Ve_di=(d10_pow0*T7_Ve_di);
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=fixme;
  T8_Ve_di_Vdi_si=fixme;
  T8_Ve_di_Ve_si=fixme;
  T8_Ve_di_Ve_di=fixme;
  T8_Ve_di_Vge_si=fixme;
  T8_Ve_di_Tempt_GND=fixme;
#endif
T8_Vge_si=(d10_pow0*T7_Vge_si);
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=fixme;
  T8_Vge_si_Vdi_si=fixme;
  T8_Vge_si_Ve_si=fixme;
  T8_Vge_si_Ve_di=fixme;
  T8_Vge_si_Vge_si=fixme;
  T8_Vge_si_Tempt_GND=fixme;
#endif
T8_Tempt_GND=(d10_pow0*T7_Tempt_GND+d11_pow0*inv_MEXP_Tempt_GND);
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=fixme;
  T8_Tempt_GND_Vdi_si=fixme;
  T8_Tempt_GND_Ve_si=fixme;
  T8_Tempt_GND_Ve_di=fixme;
  T8_Tempt_GND_Vge_si=fixme;
  T8_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T8=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Vdseff_Vdi_si=((vds_Vdi_si*T8-vds*T8_Vdi_si)/T8/T8);
#if defined(_DERIVATE2)
  Vdseff_Vdi_si_Vdi_si=(vds_Vdi_si_Vdi_si/T8-(vds_Vdi_si*T8_Vdi_si+vds_Vdi_si*T8_Vdi_si+vds*T8_Vdi_si_Vdi_si)/T8/T8+2*vds*T8_Vdi_si*T8_Vdi_si/T8/T8/T8);
  Vdseff_Vdi_si_Ve_si=(0.0/T8-(vds_Vdi_si*T8_Ve_si+0.0*T8_Vdi_si+vds*T8_Vdi_si_Ve_si)/T8/T8+2*vds*T8_Vdi_si*T8_Ve_si/T8/T8/T8);
  Vdseff_Vdi_si_Ve_di=(0.0/T8-(vds_Vdi_si*T8_Ve_di+0.0*T8_Vdi_si+vds*T8_Vdi_si_Ve_di)/T8/T8+2*vds*T8_Vdi_si*T8_Ve_di/T8/T8/T8);
  Vdseff_Vdi_si_Vge_si=(0.0/T8-(vds_Vdi_si*T8_Vge_si+0.0*T8_Vdi_si+vds*T8_Vdi_si_Vge_si)/T8/T8+2*vds*T8_Vdi_si*T8_Vge_si/T8/T8/T8);
  Vdseff_Vdi_si_Tempt_GND=(0.0/T8-(vds_Vdi_si*T8_Tempt_GND+0.0*T8_Vdi_si+vds*T8_Vdi_si_Tempt_GND)/T8/T8+2*vds*T8_Vdi_si*T8_Tempt_GND/T8/T8/T8);
#endif
Vdseff_Ve_si=(-vds*T8_Ve_si/T8/T8);
#if defined(_DERIVATE2)
  Vdseff_Ve_si_Vdi_si=(0.0/T8-(0.0*T8_Vdi_si+vds_Vdi_si*T8_Ve_si+vds*T8_Ve_si_Vdi_si)/T8/T8+2*vds*T8_Ve_si*T8_Vdi_si/T8/T8/T8);
  Vdseff_Ve_si_Ve_si=(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_si+vds*T8_Ve_si_Ve_si)/T8/T8+2*vds*T8_Ve_si*T8_Ve_si/T8/T8/T8);
  Vdseff_Ve_si_Ve_di=(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_si+vds*T8_Ve_si_Ve_di)/T8/T8+2*vds*T8_Ve_si*T8_Ve_di/T8/T8/T8);
  Vdseff_Ve_si_Vge_si=(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_si+vds*T8_Ve_si_Vge_si)/T8/T8+2*vds*T8_Ve_si*T8_Vge_si/T8/T8/T8);
  Vdseff_Ve_si_Tempt_GND=(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_si+vds*T8_Ve_si_Tempt_GND)/T8/T8+2*vds*T8_Ve_si*T8_Tempt_GND/T8/T8/T8);
#endif
Vdseff_Ve_di=(-vds*T8_Ve_di/T8/T8);
#if defined(_DERIVATE2)
  Vdseff_Ve_di_Vdi_si=(0.0/T8-(0.0*T8_Vdi_si+vds_Vdi_si*T8_Ve_di+vds*T8_Ve_di_Vdi_si)/T8/T8+2*vds*T8_Ve_di*T8_Vdi_si/T8/T8/T8);
  Vdseff_Ve_di_Ve_si=(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_di+vds*T8_Ve_di_Ve_si)/T8/T8+2*vds*T8_Ve_di*T8_Ve_si/T8/T8/T8);
  Vdseff_Ve_di_Ve_di=(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_di+vds*T8_Ve_di_Ve_di)/T8/T8+2*vds*T8_Ve_di*T8_Ve_di/T8/T8/T8);
  Vdseff_Ve_di_Vge_si=(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_di+vds*T8_Ve_di_Vge_si)/T8/T8+2*vds*T8_Ve_di*T8_Vge_si/T8/T8/T8);
  Vdseff_Ve_di_Tempt_GND=(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_di+vds*T8_Ve_di_Tempt_GND)/T8/T8+2*vds*T8_Ve_di*T8_Tempt_GND/T8/T8/T8);
#endif
Vdseff_Vge_si=(-vds*T8_Vge_si/T8/T8);
#if defined(_DERIVATE2)
  Vdseff_Vge_si_Vdi_si=(0.0/T8-(0.0*T8_Vdi_si+vds_Vdi_si*T8_Vge_si+vds*T8_Vge_si_Vdi_si)/T8/T8+2*vds*T8_Vge_si*T8_Vdi_si/T8/T8/T8);
  Vdseff_Vge_si_Ve_si=(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vge_si+vds*T8_Vge_si_Ve_si)/T8/T8+2*vds*T8_Vge_si*T8_Ve_si/T8/T8/T8);
  Vdseff_Vge_si_Ve_di=(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vge_si+vds*T8_Vge_si_Ve_di)/T8/T8+2*vds*T8_Vge_si*T8_Ve_di/T8/T8/T8);
  Vdseff_Vge_si_Vge_si=(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vge_si+vds*T8_Vge_si_Vge_si)/T8/T8+2*vds*T8_Vge_si*T8_Vge_si/T8/T8/T8);
  Vdseff_Vge_si_Tempt_GND=(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vge_si+vds*T8_Vge_si_Tempt_GND)/T8/T8+2*vds*T8_Vge_si*T8_Tempt_GND/T8/T8/T8);
#endif
Vdseff_Tempt_GND=(-vds*T8_Tempt_GND/T8/T8);
#if defined(_DERIVATE2)
  Vdseff_Tempt_GND_Vdi_si=(0.0/T8-(0.0*T8_Vdi_si+vds_Vdi_si*T8_Tempt_GND+vds*T8_Tempt_GND_Vdi_si)/T8/T8+2*vds*T8_Tempt_GND*T8_Vdi_si/T8/T8/T8);
  Vdseff_Tempt_GND_Ve_si=(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Tempt_GND+vds*T8_Tempt_GND_Ve_si)/T8/T8+2*vds*T8_Tempt_GND*T8_Ve_si/T8/T8/T8);
  Vdseff_Tempt_GND_Ve_di=(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Tempt_GND+vds*T8_Tempt_GND_Ve_di)/T8/T8+2*vds*T8_Tempt_GND*T8_Ve_di/T8/T8/T8);
  Vdseff_Tempt_GND_Vge_si=(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Tempt_GND+vds*T8_Tempt_GND_Vge_si)/T8/T8+2*vds*T8_Tempt_GND*T8_Vge_si/T8/T8/T8);
  Vdseff_Tempt_GND_Tempt_GND=(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Tempt_GND+vds*T8_Tempt_GND_Tempt_GND)/T8/T8+2*vds*T8_Tempt_GND*T8_Tempt_GND/T8/T8/T8);
#endif
#endif
Vdseff=(vds/T8);
EXIT_IF_ISNAN((vds/T8))
if
((Vdseff>vds))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Vdseff_Vdi_si=vds_Vdi_si;
#if defined(_DERIVATE2)
  Vdseff_Vdi_si_Vdi_si=vds_Vdi_si_Vdi_si;
  Vdseff_Vdi_si_Ve_si=0.0;
  Vdseff_Vdi_si_Ve_di=0.0;
  Vdseff_Vdi_si_Vge_si=0.0;
  Vdseff_Vdi_si_Tempt_GND=0.0;
#endif
Vdseff_Ve_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Ve_si_Vdi_si=0.0;
  Vdseff_Ve_si_Ve_si=0.0;
  Vdseff_Ve_si_Ve_di=0.0;
  Vdseff_Ve_si_Vge_si=0.0;
  Vdseff_Ve_si_Tempt_GND=0.0;
#endif
Vdseff_Ve_di=0.0;
#if defined(_DERIVATE2)
  Vdseff_Ve_di_Vdi_si=0.0;
  Vdseff_Ve_di_Ve_si=0.0;
  Vdseff_Ve_di_Ve_di=0.0;
  Vdseff_Ve_di_Vge_si=0.0;
  Vdseff_Ve_di_Tempt_GND=0.0;
#endif
Vdseff_Vge_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vge_si_Vdi_si=0.0;
  Vdseff_Vge_si_Ve_si=0.0;
  Vdseff_Vge_si_Ve_di=0.0;
  Vdseff_Vge_si_Vge_si=0.0;
  Vdseff_Vge_si_Tempt_GND=0.0;
#endif
Vdseff_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Vdseff_Tempt_GND_Vdi_si=0.0;
  Vdseff_Tempt_GND_Ve_si=0.0;
  Vdseff_Tempt_GND_Ve_di=0.0;
  Vdseff_Tempt_GND_Vge_si=0.0;
  Vdseff_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Vdseff=vds;
EXIT_IF_ISNAN(vds)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vch_Vdi_si=Vdseff_Vdi_si;
#if defined(_DERIVATE2)
  vch_Vdi_si_Vdi_si=(+Vdseff_Vdi_si_Vdi_si+0.0);
  vch_Vdi_si_Ve_si=(+Vdseff_Vdi_si_Ve_si+0.0);
  vch_Vdi_si_Ve_di=(+Vdseff_Vdi_si_Ve_di+0.0);
  vch_Vdi_si_Vge_si=(+Vdseff_Vdi_si_Vge_si+0.0);
  vch_Vdi_si_Tempt_GND=(+Vdseff_Vdi_si_Tempt_GND+0.0);
#endif
vch_Ve_si=Vdseff_Ve_si;
#if defined(_DERIVATE2)
  vch_Ve_si_Vdi_si=(+Vdseff_Ve_si_Vdi_si+0.0);
  vch_Ve_si_Ve_si=(+Vdseff_Ve_si_Ve_si+0.0);
  vch_Ve_si_Ve_di=(+Vdseff_Ve_si_Ve_di+0.0);
  vch_Ve_si_Vge_si=(+Vdseff_Ve_si_Vge_si+0.0);
  vch_Ve_si_Tempt_GND=(+Vdseff_Ve_si_Tempt_GND+0.0);
#endif
vch_Ve_di=Vdseff_Ve_di;
#if defined(_DERIVATE2)
  vch_Ve_di_Vdi_si=(+Vdseff_Ve_di_Vdi_si+0.0);
  vch_Ve_di_Ve_si=(+Vdseff_Ve_di_Ve_si+0.0);
  vch_Ve_di_Ve_di=(+Vdseff_Ve_di_Ve_di+0.0);
  vch_Ve_di_Vge_si=(+Vdseff_Ve_di_Vge_si+0.0);
  vch_Ve_di_Tempt_GND=(+Vdseff_Ve_di_Tempt_GND+0.0);
#endif
vch_Vge_si=Vdseff_Vge_si;
#if defined(_DERIVATE2)
  vch_Vge_si_Vdi_si=(+Vdseff_Vge_si_Vdi_si+0.0);
  vch_Vge_si_Ve_si=(+Vdseff_Vge_si_Ve_si+0.0);
  vch_Vge_si_Ve_di=(+Vdseff_Vge_si_Ve_di+0.0);
  vch_Vge_si_Vge_si=(+Vdseff_Vge_si_Vge_si+0.0);
  vch_Vge_si_Tempt_GND=(+Vdseff_Vge_si_Tempt_GND+0.0);
#endif
vch_Tempt_GND=(Vdseff_Tempt_GND+dvch_qm_Tempt_GND);
#if defined(_DERIVATE2)
  vch_Tempt_GND_Vdi_si=(+Vdseff_Tempt_GND_Vdi_si+0.0);
  vch_Tempt_GND_Ve_si=(+Vdseff_Tempt_GND_Ve_si+0.0);
  vch_Tempt_GND_Ve_di=(+Vdseff_Tempt_GND_Ve_di+0.0);
  vch_Tempt_GND_Vge_si=(+Vdseff_Tempt_GND_Vge_si+0.0);
  vch_Tempt_GND_Tempt_GND=(+Vdseff_Tempt_GND_Tempt_GND+dvch_qm_Tempt_GND_Tempt_GND);
#endif
#endif
vch=(Vdseff+dvch_qm);
EXIT_IF_ISNAN((Vdseff+dvch_qm))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,(vch_Ve_si-ves_Ve_si),0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,(vch_Ve_di-ves_Ve_di),0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,vch_Vge_si,0.0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,vch_Vdi_si,0.0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth((((2.0*phib)+vch)-ves),0.1,((2.0*phib_Tempt_GND)+vch_Tempt_GND),0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth((((2.0*phib)+vch)-ves),0.1);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((((2.0*phib)+vch)-ves),0.1))
{
double m00_sqrt(d00_sqrt0,T1)
double m00_sqrt(d00_sqrt1,(2.0*phib))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,T1)
double m10_sqrt(d10_sqrt1,d00_sqrt1,(2.0*phib))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(((-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1))+(((-K1_t)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vdi_d)-0.0));
  T3_Vdi_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vsi_s)-0.0));
  T3_Vdi_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_di)-0.0));
  T3_Vdi_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_e)-0.0));
  T3_Vdi_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vdi_si)-0.0));
  T3_Vdi_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Ve_si)-0.0));
  T3_Vdi_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Ve_di)-0.0));
  T3_Vdi_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Vge_si)-0.0));
  T3_Vdi_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*(2.0*nVtm_Vdi_si)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(-(-K1_t)*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Vdi_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Vdi_si+d10_sqrt0*T1_Vdi_si_Tempt_GND)-0.0));
#endif
T3_Ve_si=(((-K1_t)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vdi_d)-0.0));
  T3_Ve_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vsi_s)-0.0));
  T3_Ve_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_di)-0.0));
  T3_Ve_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_e)-0.0));
  T3_Ve_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vdi_si)-0.0));
  T3_Ve_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Ve_si)-0.0));
  T3_Ve_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Ve_si+d10_sqrt0*T1_Ve_si_Ve_di)-0.0));
  T3_Ve_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Ve_si+d10_sqrt0*T1_Ve_si_Vge_si)-0.0));
  T3_Ve_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Ve_si+d10_sqrt0*T1_Ve_si_Tempt_GND)-0.0));
#endif
T3_Ve_di=(((-K1_t)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vdi_d)-0.0));
  T3_Ve_di_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vsi_s)-0.0));
  T3_Ve_di_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_di)-0.0));
  T3_Ve_di_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_e)-0.0));
  T3_Ve_di_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vdi_si)-0.0));
  T3_Ve_di_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Ve_si)-0.0));
  T3_Ve_di_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Ve_di+d10_sqrt0*T1_Ve_di_Ve_di)-0.0));
  T3_Ve_di_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Ve_di+d10_sqrt0*T1_Ve_di_Vge_si)-0.0));
  T3_Ve_di_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Ve_di*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Ve_di+d10_sqrt0*T1_Ve_di_Tempt_GND)-0.0));
#endif
T3_Vge_si=(((-K1_t)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0);
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vdi_d)-0.0));
  T3_Vge_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vsi_s)-0.0));
  T3_Vge_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_di)-0.0));
  T3_Vge_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_e)-0.0));
  T3_Vge_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vdi_si)-0.0));
  T3_Vge_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Ve_si)-0.0));
  T3_Vge_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Vge_si+d10_sqrt0*T1_Vge_si_Ve_di)-0.0));
  T3_Vge_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*0.0+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Vge_si+d10_sqrt0*T1_Vge_si_Vge_si)-0.0));
  T3_Vge_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*0.0+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*0.0*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+0.0*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*T1_Vge_si*d10_sqrt0+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Vge_si+d10_sqrt0*T1_Vge_si_Tempt_GND)-0.0));
#endif
T3_Tempt_GND=(((((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1))+(((-K1_t)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_d*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_d*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vdi_d)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vsi_s=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vsi_s*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vsi_s*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vsi_s)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_di=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_di*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_di)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_e=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_e*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_e*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_e)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vdi_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vdi_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vdi_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vdi_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Ve_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Ve_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Ve_di=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Ve_di*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Ve_di*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Ve_di)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Vge_si=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Vge_si*d10_sqrt0-(0.0)*d10_sqrt1)+(-(-K1_t)*(0.0)/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Vge_si*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Vge_si)-(m20_sqrt((2.0*phib))*(0.0)*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*0.0+0.0*phib_Tempt_GND+2.0*0.0))));
  T3_Tempt_GND_Tempt_GND=(+(0.0/(2.0*nVtm)-((-K1_t_Tempt_GND)*((2.0*nVtm_Tempt_GND))+(-K1_t_Tempt_GND)*(2.0*nVtm_Tempt_GND)+(-K1_t)*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*(-K1_t)*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-((2.0*phib_Tempt_GND))*d10_sqrt1)+(((-K1_t_Tempt_GND)*(2.0*nVtm)-(-K1_t)*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*(T1_Tempt_GND*d10_sqrt0-(2.0*phib_Tempt_GND)*d10_sqrt1)+((-K1_t)/(2.0*nVtm))*(+(m20_sqrt(T1)*T1_Tempt_GND*T1_Tempt_GND+d10_sqrt0*T1_Tempt_GND_Tempt_GND)-(m20_sqrt((2.0*phib))*((2.0*phib_Tempt_GND))*(2.0*phib_Tempt_GND)+d10_sqrt1*(+0.0*phib+0.0*phib_Tempt_GND+0.0*phib_Tempt_GND+2.0*phib_Tempt_GND_Tempt_GND))));
#endif
#endif
T3=(((-K1_t)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1));
EXIT_IF_ISNAN((((-K1_t)/(2.0*nVtm))*(d00_sqrt0-d00_sqrt1)))
}
{
double m00_pow(d00_pow0,(-qdep),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-qdep),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(-T3_Ve_si);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+(+(+0.0-T3_Ve_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vge_e=(+(+(+0.0-T3_Ve_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Ve_si=(+(+(+0.0-T3_Ve_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Ve_di=(+(+(+0.0-T3_Ve_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vge_si=(+(+(+0.0-T3_Ve_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Vdi_si=(+(+(+0.0-T3_Ve_si_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_si_Tempt_GND=(+(+(+0.0-T3_Ve_si_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Ve_di=(-T3_Ve_di);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+(+(+0.0-T3_Ve_di_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vge_e=(+(+(+0.0-T3_Ve_di_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Ve_si=(+(+(+0.0-T3_Ve_di_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Ve_di=(+(+(+0.0-T3_Ve_di_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vge_si=(+(+(+0.0-T3_Ve_di_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Vdi_si=(+(+(+0.0-T3_Ve_di_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Ve_di_Tempt_GND=(+(+(+0.0-T3_Ve_di_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Vge_si=(-T3_Vge_si);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+(+(+0.0-T3_Vge_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vge_e=(+(+(+0.0-T3_Vge_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Ve_si=(+(+(+0.0-T3_Vge_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Ve_di=(+(+(+0.0-T3_Vge_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vge_si=(+(+(+0.0-T3_Vge_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Vdi_si=(+(+(+0.0-T3_Vge_si_Vdi_si)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*0.0+QMFACTORCVfinal*fixme));
  T0_Vge_si_Tempt_GND=(+(+(+0.0-T3_Vge_si_Tempt_GND)+0.0)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*0.0+QMFACTORCVfinal*fixme));
#endif
T0_Vdi_si=((((-qdep_Vdi_si)-T3_Vdi_si)+vth_fixed_factor_Sub_Vdi_si)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Vdi_si))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+(+0.0-T3_Vdi_si_Vge_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_e=(+(+(+0.0-T3_Vdi_si_Vge_e)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_si=(+(+(+0.0-T3_Vdi_si_Ve_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_di=(+(+(+0.0-T3_Vdi_si_Ve_di)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_si=(+(+(+0.0-T3_Vdi_si_Vge_si)+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vdi_si=(+(+(+0.0-T3_Vdi_si_Vdi_si)+vth_fixed_factor_Sub_Vdi_si_Vdi_si)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Tempt_GND=(+(+(+0.0-T3_Vdi_si_Tempt_GND)+vth_fixed_factor_Sub_Vdi_si_Tempt_GND)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
#endif
T0_Tempt_GND=((((-qdep_Tempt_GND)-T3_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND)+((QMFACTORCVfinal_Tempt_GND*d00_pow0)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Tempt_GND)))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+(+0.0-T3_Tempt_GND_Vge_di)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_e=(+(+(+0.0-T3_Tempt_GND_Vge_e)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_si=(+(+(+0.0-T3_Tempt_GND_Ve_si)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_di=(+(+(+0.0-T3_Tempt_GND_Ve_di)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_si=(+(+(+0.0-T3_Tempt_GND_Vge_si)+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vdi_si=(+(+(+0.0-T3_Tempt_GND_Vdi_si)+vth_fixed_factor_Sub_Tempt_GND_Vdi_si)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Tempt_GND=(+(+(+0.0-T3_Tempt_GND_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND_Tempt_GND)+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
#endif
#endif
T0=((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0));
EXIT_IF_ISNAN(((((-qdep)-T3)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-T3_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0-T3_Ve_si_Vdi_d)+0.0);
  T1_Ve_si_Vsi_s=(+(+0.0-T3_Ve_si_Vsi_s)+0.0);
  T1_Ve_si_Vge_di=(+(+0.0-T3_Ve_si_Vge_di)+0.0);
  T1_Ve_si_Vge_e=(+(+0.0-T3_Ve_si_Vge_e)+0.0);
  T1_Ve_si_Ve_si=(+(+0.0-T3_Ve_si_Ve_si)+0.0);
  T1_Ve_si_Ve_di=(+(+0.0-T3_Ve_si_Ve_di)+0.0);
  T1_Ve_si_Vge_si=(+(+0.0-T3_Ve_si_Vge_si)+0.0);
  T1_Ve_si_Vdi_si=(+(+0.0-T3_Ve_si_Vdi_si)+0.0);
  T1_Ve_si_Tempt_GND=(+(+0.0-T3_Ve_si_Tempt_GND)+0.0);
#endif
T1_Ve_di=(-T3_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0-T3_Ve_di_Vdi_d)+0.0);
  T1_Ve_di_Vsi_s=(+(+0.0-T3_Ve_di_Vsi_s)+0.0);
  T1_Ve_di_Vge_di=(+(+0.0-T3_Ve_di_Vge_di)+0.0);
  T1_Ve_di_Vge_e=(+(+0.0-T3_Ve_di_Vge_e)+0.0);
  T1_Ve_di_Ve_si=(+(+0.0-T3_Ve_di_Ve_si)+0.0);
  T1_Ve_di_Ve_di=(+(+0.0-T3_Ve_di_Ve_di)+0.0);
  T1_Ve_di_Vge_si=(+(+0.0-T3_Ve_di_Vge_si)+0.0);
  T1_Ve_di_Vdi_si=(+(+0.0-T3_Ve_di_Vdi_si)+0.0);
  T1_Ve_di_Tempt_GND=(+(+0.0-T3_Ve_di_Tempt_GND)+0.0);
#endif
T1_Vge_si=(-T3_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0-T3_Vge_si_Vdi_d)+0.0);
  T1_Vge_si_Vsi_s=(+(+0.0-T3_Vge_si_Vsi_s)+0.0);
  T1_Vge_si_Vge_di=(+(+0.0-T3_Vge_si_Vge_di)+0.0);
  T1_Vge_si_Vge_e=(+(+0.0-T3_Vge_si_Vge_e)+0.0);
  T1_Vge_si_Ve_si=(+(+0.0-T3_Vge_si_Ve_si)+0.0);
  T1_Vge_si_Ve_di=(+(+0.0-T3_Vge_si_Ve_di)+0.0);
  T1_Vge_si_Vge_si=(+(+0.0-T3_Vge_si_Vge_si)+0.0);
  T1_Vge_si_Vdi_si=(+(+0.0-T3_Vge_si_Vdi_si)+0.0);
  T1_Vge_si_Tempt_GND=(+(+0.0-T3_Vge_si_Tempt_GND)+0.0);
#endif
T1_Vdi_si=(((-qdep_Vdi_si)-T3_Vdi_si)+vth_fixed_factor_SI_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0-T3_Vdi_si_Vdi_d)+0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0-T3_Vdi_si_Vsi_s)+0.0);
  T1_Vdi_si_Vge_di=(+(+0.0-T3_Vdi_si_Vge_di)+0.0);
  T1_Vdi_si_Vge_e=(+(+0.0-T3_Vdi_si_Vge_e)+0.0);
  T1_Vdi_si_Ve_si=(+(+0.0-T3_Vdi_si_Ve_si)+0.0);
  T1_Vdi_si_Ve_di=(+(+0.0-T3_Vdi_si_Ve_di)+0.0);
  T1_Vdi_si_Vge_si=(+(+0.0-T3_Vdi_si_Vge_si)+0.0);
  T1_Vdi_si_Vdi_si=(+(+0.0-T3_Vdi_si_Vdi_si)+vth_fixed_factor_SI_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(+0.0-T3_Vdi_si_Tempt_GND)+vth_fixed_factor_SI_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(((-qdep_Tempt_GND)-T3_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0-T3_Tempt_GND_Vdi_d)+0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0-T3_Tempt_GND_Vsi_s)+0.0);
  T1_Tempt_GND_Vge_di=(+(+0.0-T3_Tempt_GND_Vge_di)+0.0);
  T1_Tempt_GND_Vge_e=(+(+0.0-T3_Tempt_GND_Vge_e)+0.0);
  T1_Tempt_GND_Ve_si=(+(+0.0-T3_Tempt_GND_Ve_si)+0.0);
  T1_Tempt_GND_Ve_di=(+(+0.0-T3_Tempt_GND_Ve_di)+0.0);
  T1_Tempt_GND_Vge_si=(+(+0.0-T3_Tempt_GND_Vge_si)+0.0);
  T1_Tempt_GND_Vdi_si=(+(+0.0-T3_Tempt_GND_Vdi_si)+vth_fixed_factor_SI_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(+0.0-T3_Tempt_GND_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(((-qdep)-T3)+vth_fixed_factor_SI);
EXIT_IF_ISNAN((((-qdep)-T3)+vth_fixed_factor_SI))
}
else
{
{
double m00_pow(d00_pow0,(-qdep),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-qdep),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=(((-qdep_Vdi_si)+vth_fixed_factor_Sub_Vdi_si)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Vdi_si))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_e=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_si=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Ve_di=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vge_si=(+(+0.0+0.0)+(+0.0*d00_pow0+0.0*0.0+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Vdi_si=(+(+0.0+vth_fixed_factor_Sub_Vdi_si_Vdi_si)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
  T0_Vdi_si_Tempt_GND=(+(+0.0+vth_fixed_factor_Sub_Vdi_si_Tempt_GND)+(+0.0*d00_pow0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+QMFACTORCVfinal*fixme));
#endif
T0_Tempt_GND=(((-qdep_Tempt_GND)+vth_fixed_factor_Sub_Tempt_GND)+((QMFACTORCVfinal_Tempt_GND*d00_pow0)+(QMFACTORCVfinal*(d10_pow0*(-qdep_Tempt_GND)))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_e=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_si=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Ve_di=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vge_si=(+(+0.0+0.0)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Vdi_si=(+(+0.0+vth_fixed_factor_Sub_Tempt_GND_Vdi_si)+(+0.0*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Vdi_si))+0.0*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
  T0_Tempt_GND_Tempt_GND=(+(+0.0+vth_fixed_factor_Sub_Tempt_GND_Tempt_GND)+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow0+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal_Tempt_GND*(d10_pow0*(-qdep_Tempt_GND))+QMFACTORCVfinal*fixme));
#endif
#endif
T0=(((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0));
EXIT_IF_ISNAN((((-qdep)+vth_fixed_factor_Sub)+(QMFACTORCVfinal*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=((-qdep_Vdi_si)+vth_fixed_factor_SI_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0+0.0);
  T1_Vdi_si_Vsi_s=(+0.0+0.0);
  T1_Vdi_si_Vge_di=(+0.0+0.0);
  T1_Vdi_si_Vge_e=(+0.0+0.0);
  T1_Vdi_si_Ve_si=(+0.0+0.0);
  T1_Vdi_si_Ve_di=(+0.0+0.0);
  T1_Vdi_si_Vge_si=(+0.0+0.0);
  T1_Vdi_si_Vdi_si=(+0.0+vth_fixed_factor_SI_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+0.0+vth_fixed_factor_SI_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=((-qdep_Tempt_GND)+vth_fixed_factor_SI_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0+0.0);
  T1_Tempt_GND_Vsi_s=(+0.0+0.0);
  T1_Tempt_GND_Vge_di=(+0.0+0.0);
  T1_Tempt_GND_Vge_e=(+0.0+0.0);
  T1_Tempt_GND_Ve_si=(+0.0+0.0);
  T1_Tempt_GND_Ve_di=(+0.0+0.0);
  T1_Tempt_GND_Vge_si=(+0.0+0.0);
  T1_Tempt_GND_Vdi_si=(+0.0+vth_fixed_factor_SI_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+0.0+vth_fixed_factor_SI_Tempt_GND_Tempt_GND);
#endif
#endif
T1=((-qdep)+vth_fixed_factor_SI);
EXIT_IF_ISNAN(((-qdep)+vth_fixed_factor_SI))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=((vgsfbeff_Vge_si-vch_Vge_si)/nVtm);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vge_si=((+vgsfbeff_Vge_si_Vge_si-vch_Vge_si_Vge_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Ve_si=((+0.0-vch_Vge_si_Ve_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(-vch_Ve_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Ve_di=((+0.0-vch_Vge_si_Ve_di)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*0.0+(-vch_Ve_di)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Vge_si_Vdi_si=((+vgsfbeff_Vge_si_Vdi_si-vch_Vge_si_Vdi_si)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Vge_si_Tempt_GND=((+vgsfbeff_Vge_si_Tempt_GND-vch_Vge_si_Tempt_GND)/nVtm-((vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Ve_si=((-vch_Ve_si)/nVtm);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=((+0.0-0.0)/nVtm-((-vch_Ve_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Vsi_s=((+0.0-0.0)/nVtm-((-vch_Ve_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Vge_di=((+0.0-0.0)/nVtm-((-vch_Ve_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Vge_e=((+0.0-0.0)/nVtm-((-vch_Ve_si)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Vge_si=((+0.0-vch_Ve_si_Vge_si)/nVtm-((-vch_Ve_si)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Ve_si=((+0.0-vch_Ve_si_Ve_si)/nVtm-((-vch_Ve_si)*0.0+(-vch_Ve_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Ve_di=((+0.0-vch_Ve_si_Ve_di)/nVtm-((-vch_Ve_si)*0.0+(-vch_Ve_di)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_si_Vdi_si=((+0.0-vch_Ve_si_Vdi_si)/nVtm-((-vch_Ve_si)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Ve_si_Tempt_GND=((+0.0-vch_Ve_si_Tempt_GND)/nVtm-((-vch_Ve_si)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Ve_di=((-vch_Ve_di)/nVtm);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=((+0.0-0.0)/nVtm-((-vch_Ve_di)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Vsi_s=((+0.0-0.0)/nVtm-((-vch_Ve_di)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Vge_di=((+0.0-0.0)/nVtm-((-vch_Ve_di)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Vge_e=((+0.0-0.0)/nVtm-((-vch_Ve_di)*0.0+0.0*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Vge_si=((+0.0-vch_Ve_di_Vge_si)/nVtm-((-vch_Ve_di)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Ve_si=((+0.0-vch_Ve_di_Ve_si)/nVtm-((-vch_Ve_di)*0.0+(-vch_Ve_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Ve_di=((+0.0-vch_Ve_di_Ve_di)/nVtm-((-vch_Ve_di)*0.0+(-vch_Ve_di)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*0.0/nVtm/nVtm/nVtm);
  T2_Ve_di_Vdi_si=((+0.0-vch_Ve_di_Vdi_si)/nVtm-((-vch_Ve_di)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Ve_di_Tempt_GND=((+0.0-vch_Ve_di_Tempt_GND)/nVtm-((-vch_Ve_di)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*0.0*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Vdi_si=(((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm-(vgsfbeff-vch)*nVtm_Vdi_si)/nVtm/nVtm);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vge_si=((+vgsfbeff_Vdi_si_Vge_si-vch_Vdi_si_Vge_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Ve_si=((+0.0-vch_Vdi_si_Ve_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(-vch_Ve_si)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Ve_di=((+0.0-vch_Vdi_si_Ve_di)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*0.0+(-vch_Ve_di)*nVtm_Vdi_si+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*0.0/nVtm/nVtm/nVtm);
  T2_Vdi_si_Vdi_si=((+vgsfbeff_Vdi_si_Vdi_si-vch_Vdi_si_Vdi_si)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Vdi_si+(vgsfbeff-vch)*nVtm_Vdi_si_Vdi_si)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Vdi_si_Tempt_GND=((+vgsfbeff_Vdi_si_Tempt_GND-vch_Vdi_si_Tempt_GND)/nVtm-((vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Vdi_si+(vgsfbeff-vch)*nVtm_Vdi_si_Tempt_GND)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Vdi_si*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
T2_Tempt_GND=(((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm-(vgsfbeff-vch)*nVtm_Tempt_GND)/nVtm/nVtm);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vsi_s=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_di=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_e=((+0.0-0.0)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vge_si=((+vgsfbeff_Tempt_GND_Vge_si-vch_Tempt_GND_Vge_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(vgsfbeff_Vge_si-vch_Vge_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Ve_si=((+0.0-vch_Tempt_GND_Ve_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(-vch_Ve_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Ve_di=((+0.0-vch_Tempt_GND_Ve_di)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*0.0+(-vch_Ve_di)*nVtm_Tempt_GND+(vgsfbeff-vch)*0.0)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*0.0/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Vdi_si=((+vgsfbeff_Tempt_GND_Vdi_si-vch_Tempt_GND_Vdi_si)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Vdi_si+(vgsfbeff_Vdi_si-vch_Vdi_si)*nVtm_Tempt_GND+(vgsfbeff-vch)*nVtm_Tempt_GND_Vdi_si)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*nVtm_Vdi_si/nVtm/nVtm/nVtm);
  T2_Tempt_GND_Tempt_GND=((+vgsfbeff_Tempt_GND_Tempt_GND-vch_Tempt_GND_Tempt_GND)/nVtm-((vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Tempt_GND+(vgsfbeff_Tempt_GND-vch_Tempt_GND)*nVtm_Tempt_GND+(vgsfbeff-vch)*nVtm_Tempt_GND_Tempt_GND)/nVtm/nVtm+2*(vgsfbeff-vch)*nVtm_Tempt_GND*nVtm_Tempt_GND/nVtm/nVtm/nVtm);
#endif
#endif
T2=((vgsfbeff-vch)/nVtm);
EXIT_IF_ISNAN(((vgsfbeff-vch)/nVtm))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
F0_Vge_si=((-T2_Vge_si)+T1_Vge_si);
#if defined(_DERIVATE2)
  F0_Vge_si_Vge_si=(+0.0+T1_Vge_si_Vge_si);
  F0_Vge_si_Ve_si=(+0.0+T1_Vge_si_Ve_si);
  F0_Vge_si_Ve_di=(+0.0+T1_Vge_si_Ve_di);
  F0_Vge_si_Vdi_si=(+0.0+T1_Vge_si_Vdi_si);
  F0_Vge_si_Tempt_GND=(+0.0+T1_Vge_si_Tempt_GND);
#endif
F0_Ve_si=((-T2_Ve_si)+T1_Ve_si);
#if defined(_DERIVATE2)
  F0_Ve_si_Vge_si=(+0.0+T1_Ve_si_Vge_si);
  F0_Ve_si_Ve_si=(+0.0+T1_Ve_si_Ve_si);
  F0_Ve_si_Ve_di=(+0.0+T1_Ve_si_Ve_di);
  F0_Ve_si_Vdi_si=(+0.0+T1_Ve_si_Vdi_si);
  F0_Ve_si_Tempt_GND=(+0.0+T1_Ve_si_Tempt_GND);
#endif
F0_Ve_di=((-T2_Ve_di)+T1_Ve_di);
#if defined(_DERIVATE2)
  F0_Ve_di_Vge_si=(+0.0+T1_Ve_di_Vge_si);
  F0_Ve_di_Ve_si=(+0.0+T1_Ve_di_Ve_si);
  F0_Ve_di_Ve_di=(+0.0+T1_Ve_di_Ve_di);
  F0_Ve_di_Vdi_si=(+0.0+T1_Ve_di_Vdi_si);
  F0_Ve_di_Tempt_GND=(+0.0+T1_Ve_di_Tempt_GND);
#endif
F0_Vdi_si=((-T2_Vdi_si)+T1_Vdi_si);
#if defined(_DERIVATE2)
  F0_Vdi_si_Vge_si=(+0.0+T1_Vdi_si_Vge_si);
  F0_Vdi_si_Ve_si=(+0.0+T1_Vdi_si_Ve_si);
  F0_Vdi_si_Ve_di=(+0.0+T1_Vdi_si_Ve_di);
  F0_Vdi_si_Vdi_si=(+0.0+T1_Vdi_si_Vdi_si);
  F0_Vdi_si_Tempt_GND=(+0.0+T1_Vdi_si_Tempt_GND);
#endif
F0_Tempt_GND=((-T2_Tempt_GND)+T1_Tempt_GND);
#if defined(_DERIVATE2)
  F0_Tempt_GND_Vge_si=(+0.0+T1_Tempt_GND_Vge_si);
  F0_Tempt_GND_Ve_si=(+0.0+T1_Tempt_GND_Ve_si);
  F0_Tempt_GND_Ve_di=(+0.0+T1_Tempt_GND_Ve_di);
  F0_Tempt_GND_Vdi_si=(+0.0+T1_Tempt_GND_Vdi_si);
  F0_Tempt_GND_Tempt_GND=(+0.0+T1_Tempt_GND_Tempt_GND);
#endif
#endif
F0=((-T2)+T1);
EXIT_IF_ISNAN(((-T2)+T1))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(T2_Vdi_si-T0_Vdi_si)*0.5;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+T2_Vdi_si_Vdi_d-0.0)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+T2_Vdi_d*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Vsi_s=(+(+T2_Vdi_si_Vsi_s-0.0)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+T2_Vsi_s*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di-T0_Vdi_si_Vge_di)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Vge_di-T0_Vge_di)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e-T0_Vdi_si_Vge_e)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Vge_e-T0_Vge_e)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si-T0_Vdi_si_Vdi_si)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si-T0_Vdi_si_Ve_si)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Ve_si-T0_Ve_si)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di-T0_Vdi_si_Ve_di)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Ve_di-T0_Ve_di)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si-T0_Vdi_si_Vge_si)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Vge_si-T0_Vge_si)*0.0+(T2-T0)*0.0);
  T3_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND-T0_Vdi_si_Tempt_GND)*0.5+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2-T0)*0.0);
#endif
T3_Ve_si=(T2_Ve_si-T0_Ve_si)*0.5;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+T2_Ve_si_Vdi_d-0.0)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+T2_Vdi_d*0.0+(T2-T0)*0.0);
  T3_Ve_si_Vsi_s=(+(+T2_Ve_si_Vsi_s-0.0)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+T2_Vsi_s*0.0+(T2-T0)*0.0);
  T3_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di-T0_Ve_si_Vge_di)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Vge_di-T0_Vge_di)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e-T0_Ve_si_Vge_e)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Vge_e-T0_Vge_e)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si-T0_Ve_si_Vdi_si)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si-T0_Ve_si_Ve_si)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Ve_si-T0_Ve_si)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di-T0_Ve_si_Ve_di)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Ve_di-T0_Ve_di)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si-T0_Ve_si_Vge_si)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Vge_si-T0_Vge_si)*0.0+(T2-T0)*0.0);
  T3_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND-T0_Ve_si_Tempt_GND)*0.5+(T2_Ve_si-T0_Ve_si)*0.0+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2-T0)*0.0);
#endif
T3_Ve_di=(T2_Ve_di-T0_Ve_di)*0.5;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+T2_Ve_di_Vdi_d-0.0)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+T2_Vdi_d*0.0+(T2-T0)*0.0);
  T3_Ve_di_Vsi_s=(+(+T2_Ve_di_Vsi_s-0.0)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+T2_Vsi_s*0.0+(T2-T0)*0.0);
  T3_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di-T0_Ve_di_Vge_di)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Vge_di-T0_Vge_di)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e-T0_Ve_di_Vge_e)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Vge_e-T0_Vge_e)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si-T0_Ve_di_Vdi_si)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si-T0_Ve_di_Ve_si)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Ve_si-T0_Ve_si)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di-T0_Ve_di_Ve_di)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Ve_di-T0_Ve_di)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si-T0_Ve_di_Vge_si)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Vge_si-T0_Vge_si)*0.0+(T2-T0)*0.0);
  T3_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND-T0_Ve_di_Tempt_GND)*0.5+(T2_Ve_di-T0_Ve_di)*0.0+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2-T0)*0.0);
#endif
T3_Vge_si=(T2_Vge_si-T0_Vge_si)*0.5;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+T2_Vge_si_Vdi_d-0.0)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+T2_Vdi_d*0.0+(T2-T0)*0.0);
  T3_Vge_si_Vsi_s=(+(+T2_Vge_si_Vsi_s-0.0)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+T2_Vsi_s*0.0+(T2-T0)*0.0);
  T3_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di-T0_Vge_si_Vge_di)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Vge_di-T0_Vge_di)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e-T0_Vge_si_Vge_e)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Vge_e-T0_Vge_e)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si-T0_Vge_si_Vdi_si)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si-T0_Vge_si_Ve_si)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Ve_si-T0_Ve_si)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di-T0_Vge_si_Ve_di)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Ve_di-T0_Ve_di)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si-T0_Vge_si_Vge_si)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Vge_si-T0_Vge_si)*0.0+(T2-T0)*0.0);
  T3_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND-T0_Vge_si_Tempt_GND)*0.5+(T2_Vge_si-T0_Vge_si)*0.0+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2-T0)*0.0);
#endif
T3_Tempt_GND=(T2_Tempt_GND-T0_Tempt_GND)*0.5;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+T2_Tempt_GND_Vdi_d-0.0)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+T2_Vdi_d*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Vsi_s=(+(+T2_Tempt_GND_Vsi_s-0.0)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+T2_Vsi_s*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di-T0_Tempt_GND_Vge_di)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Vge_di-T0_Vge_di)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e-T0_Tempt_GND_Vge_e)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Vge_e-T0_Vge_e)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si-T0_Tempt_GND_Vdi_si)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Vdi_si-T0_Vdi_si)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si-T0_Tempt_GND_Ve_si)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Ve_si-T0_Ve_si)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di-T0_Tempt_GND_Ve_di)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Ve_di-T0_Ve_di)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si-T0_Tempt_GND_Vge_si)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Vge_si-T0_Vge_si)*0.0+(T2-T0)*0.0);
  T3_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND-T0_Tempt_GND_Tempt_GND)*0.5+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2_Tempt_GND-T0_Tempt_GND)*0.0+(T2-T0)*0.0);
#endif
#endif
T3=((T2-T0)*0.5);
EXIT_IF_ISNAN(((T2-T0)*0.5))
{
double m00_exp(d00_exp0,T3)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=T3_Vdi_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Vdi_si);
  qm_Vdi_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Ve_si);
  qm_Vdi_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Vdi_si+d10_exp0*T3_Vdi_si_Ve_di);
  qm_Vdi_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Vdi_si+d10_exp0*T3_Vdi_si_Vge_si);
  qm_Vdi_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Vdi_si+d10_exp0*T3_Vdi_si_Tempt_GND);
#endif
qm_Ve_si=T3_Ve_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Ve_si+d10_exp0*T3_Ve_si_Vdi_si);
  qm_Ve_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Ve_si+d10_exp0*T3_Ve_si_Ve_si);
  qm_Ve_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Ve_si+d10_exp0*T3_Ve_si_Ve_di);
  qm_Ve_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Ve_si+d10_exp0*T3_Ve_si_Vge_si);
  qm_Ve_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Ve_si+d10_exp0*T3_Ve_si_Tempt_GND);
#endif
qm_Ve_di=T3_Ve_di*d10_exp0;
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Ve_di+d10_exp0*T3_Ve_di_Vdi_si);
  qm_Ve_di_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Ve_di+d10_exp0*T3_Ve_di_Ve_si);
  qm_Ve_di_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Ve_di+d10_exp0*T3_Ve_di_Ve_di);
  qm_Ve_di_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Ve_di+d10_exp0*T3_Ve_di_Vge_si);
  qm_Ve_di_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Ve_di+d10_exp0*T3_Ve_di_Tempt_GND);
#endif
qm_Vge_si=T3_Vge_si*d10_exp0;
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Vge_si+d10_exp0*T3_Vge_si_Vdi_si);
  qm_Vge_si_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Vge_si+d10_exp0*T3_Vge_si_Ve_si);
  qm_Vge_si_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Vge_si+d10_exp0*T3_Vge_si_Ve_di);
  qm_Vge_si_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Vge_si+d10_exp0*T3_Vge_si_Vge_si);
  qm_Vge_si_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Vge_si+d10_exp0*T3_Vge_si_Tempt_GND);
#endif
qm_Tempt_GND=T3_Tempt_GND*d10_exp0;
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(m20_exp(T3)*T3_Vdi_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Vdi_si);
  qm_Tempt_GND_Ve_si=(m20_exp(T3)*T3_Ve_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Ve_si);
  qm_Tempt_GND_Ve_di=(m20_exp(T3)*T3_Ve_di*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Ve_di);
  qm_Tempt_GND_Vge_si=(m20_exp(T3)*T3_Vge_si*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Vge_si);
  qm_Tempt_GND_Tempt_GND=(m20_exp(T3)*T3_Tempt_GND*T3_Tempt_GND+d10_exp0*T3_Tempt_GND_Tempt_GND);
#endif
#endif
qm=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
if
((qm>1.0e-7))
{
{
double m00_logE(d00_logE0,(1.0+qm))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(1.0+qm))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=0.0;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=0.0;
  T7_Vge_e_Vdi_d=0.0;
  T7_Vge_e_Vsi_s=0.0;
  T7_Vge_e_Vge_e=0.0;
  T7_Vge_e_Vdi_si=0.0;
  T7_Vge_e_Ve_si=0.0;
  T7_Vge_e_Ve_di=0.0;
  T7_Vge_e_Vge_si=0.0;
  T7_Vge_e_Tempt_GND=0.0;
#endif
T7_Vdi_si=qm_Vdi_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=0.0;
  T7_Vdi_si_Vdi_d=0.0;
  T7_Vdi_si_Vsi_s=0.0;
  T7_Vdi_si_Vge_e=0.0;
  T7_Vdi_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Vdi_si));
  T7_Vdi_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Ve_si));
  T7_Vdi_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Ve_di));
  T7_Vdi_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Vge_si));
  T7_Vdi_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Vdi_si+d10_logE0*(+0.0+qm_Vdi_si_Tempt_GND));
#endif
T7_Ve_si=qm_Ve_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=0.0;
  T7_Ve_si_Vdi_d=0.0;
  T7_Ve_si_Vsi_s=0.0;
  T7_Ve_si_Vge_e=0.0;
  T7_Ve_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Vdi_si));
  T7_Ve_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Ve_si));
  T7_Ve_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Ve_di));
  T7_Ve_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Vge_si));
  T7_Ve_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Ve_si+d10_logE0*(+0.0+qm_Ve_si_Tempt_GND));
#endif
T7_Ve_di=qm_Ve_di*d10_logE0;
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=0.0;
  T7_Ve_di_Vdi_d=0.0;
  T7_Ve_di_Vsi_s=0.0;
  T7_Ve_di_Vge_e=0.0;
  T7_Ve_di_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Vdi_si));
  T7_Ve_di_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Ve_si));
  T7_Ve_di_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Ve_di));
  T7_Ve_di_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Vge_si));
  T7_Ve_di_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Ve_di+d10_logE0*(+0.0+qm_Ve_di_Tempt_GND));
#endif
T7_Vge_si=qm_Vge_si*d10_logE0;
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=0.0;
  T7_Vge_si_Vdi_d=0.0;
  T7_Vge_si_Vsi_s=0.0;
  T7_Vge_si_Vge_e=0.0;
  T7_Vge_si_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Vdi_si));
  T7_Vge_si_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Ve_si));
  T7_Vge_si_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Ve_di));
  T7_Vge_si_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Vge_si));
  T7_Vge_si_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Vge_si+d10_logE0*(+0.0+qm_Vge_si_Tempt_GND));
#endif
T7_Tempt_GND=qm_Tempt_GND*d10_logE0;
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=0.0;
  T7_Tempt_GND_Vdi_d=0.0;
  T7_Tempt_GND_Vsi_s=0.0;
  T7_Tempt_GND_Vge_e=0.0;
  T7_Tempt_GND_Vdi_si=(m20_logE((1.0+qm))*qm_Vdi_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Vdi_si));
  T7_Tempt_GND_Ve_si=(m20_logE((1.0+qm))*qm_Ve_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Ve_si));
  T7_Tempt_GND_Ve_di=(m20_logE((1.0+qm))*qm_Ve_di*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Ve_di));
  T7_Tempt_GND_Vge_si=(m20_logE((1.0+qm))*qm_Vge_si*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Vge_si));
  T7_Tempt_GND_Tempt_GND=(m20_logE((1.0+qm))*qm_Tempt_GND*qm_Tempt_GND+d10_logE0*(+0.0+qm_Tempt_GND_Tempt_GND));
#endif
#endif
T7=d00_logE0;
EXIT_IF_ISNAN(d00_logE0)
}
{
double m00_sqrt(d00_sqrt0,(1.0+(T7*T7)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(T7*T7)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(2.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Vdi_si*T7+T7_Vdi_si*T7_Vdi_si+T7_Vdi_si*T7_Vdi_si+T7*T7_Vdi_si_Vdi_si)))));
  qm_Vdi_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Ve_si*T7+T7_Vdi_si*T7_Ve_si+T7_Ve_si*T7_Vdi_si+T7*T7_Vdi_si_Ve_si)))));
  qm_Vdi_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Ve_di*T7+T7_Vdi_si*T7_Ve_di+T7_Ve_di*T7_Vdi_si+T7*T7_Vdi_si_Ve_di)))));
  qm_Vdi_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Vge_si*T7+T7_Vdi_si*T7_Vge_si+T7_Vge_si*T7_Vdi_si+T7*T7_Vdi_si_Vge_si)))));
  qm_Vdi_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Vdi_si*T7)+(T7*T7_Vdi_si))+d10_sqrt0*(+0.0+(+T7_Vdi_si_Tempt_GND*T7+T7_Vdi_si*T7_Tempt_GND+T7_Tempt_GND*T7_Vdi_si+T7*T7_Vdi_si_Tempt_GND)))));
#endif
qm_Ve_si=(2.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Vdi_si*T7+T7_Ve_si*T7_Vdi_si+T7_Vdi_si*T7_Ve_si+T7*T7_Ve_si_Vdi_si)))));
  qm_Ve_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Ve_si*T7+T7_Ve_si*T7_Ve_si+T7_Ve_si*T7_Ve_si+T7*T7_Ve_si_Ve_si)))));
  qm_Ve_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Ve_di*T7+T7_Ve_si*T7_Ve_di+T7_Ve_di*T7_Ve_si+T7*T7_Ve_si_Ve_di)))));
  qm_Ve_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Vge_si*T7+T7_Ve_si*T7_Vge_si+T7_Vge_si*T7_Ve_si+T7*T7_Ve_si_Vge_si)))));
  qm_Ve_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Ve_si*T7)+(T7*T7_Ve_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Ve_si*T7)+(T7*T7_Ve_si))+d10_sqrt0*(+0.0+(+T7_Ve_si_Tempt_GND*T7+T7_Ve_si*T7_Tempt_GND+T7_Tempt_GND*T7_Ve_si+T7*T7_Ve_si_Tempt_GND)))));
#endif
qm_Ve_di=(2.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Vdi_si*T7+T7_Ve_di*T7_Vdi_si+T7_Vdi_si*T7_Ve_di+T7*T7_Ve_di_Vdi_si)))));
  qm_Ve_di_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Ve_si*T7+T7_Ve_di*T7_Ve_si+T7_Ve_si*T7_Ve_di+T7*T7_Ve_di_Ve_si)))));
  qm_Ve_di_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Ve_di*T7+T7_Ve_di*T7_Ve_di+T7_Ve_di*T7_Ve_di+T7*T7_Ve_di_Ve_di)))));
  qm_Ve_di_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Vge_si*T7+T7_Ve_di*T7_Vge_si+T7_Vge_si*T7_Ve_di+T7*T7_Ve_di_Vge_si)))));
  qm_Ve_di_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Ve_di*T7)+(T7*T7_Ve_di))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Ve_di*T7)+(T7*T7_Ve_di))+d10_sqrt0*(+0.0+(+T7_Ve_di_Tempt_GND*T7+T7_Ve_di*T7_Tempt_GND+T7_Tempt_GND*T7_Ve_di+T7*T7_Ve_di_Tempt_GND)))));
#endif
qm_Vge_si=(2.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Vdi_si*T7+T7_Vge_si*T7_Vdi_si+T7_Vdi_si*T7_Vge_si+T7*T7_Vge_si_Vdi_si)))));
  qm_Vge_si_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Ve_si*T7+T7_Vge_si*T7_Ve_si+T7_Ve_si*T7_Vge_si+T7*T7_Vge_si_Ve_si)))));
  qm_Vge_si_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Ve_di*T7+T7_Vge_si*T7_Ve_di+T7_Ve_di*T7_Vge_si+T7*T7_Vge_si_Ve_di)))));
  qm_Vge_si_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Vge_si*T7+T7_Vge_si*T7_Vge_si+T7_Vge_si*T7_Vge_si+T7*T7_Vge_si_Vge_si)))));
  qm_Vge_si_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Vge_si*T7)+(T7*T7_Vge_si))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Vge_si*T7)+(T7*T7_Vge_si))+d10_sqrt0*(+0.0+(+T7_Vge_si_Tempt_GND*T7+T7_Vge_si*T7_Tempt_GND+T7_Tempt_GND*T7_Vge_si+T7*T7_Vge_si_Tempt_GND)))));
#endif
qm_Tempt_GND=(2.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vdi_si*T7)+(T7*T7_Vdi_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Vdi_si*T7+T7_Tempt_GND*T7_Vdi_si+T7_Vdi_si*T7_Tempt_GND+T7*T7_Tempt_GND_Vdi_si)))));
  qm_Tempt_GND_Ve_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_si*T7)+(T7*T7_Ve_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Ve_si*T7+T7_Tempt_GND*T7_Ve_si+T7_Ve_si*T7_Tempt_GND+T7*T7_Tempt_GND_Ve_si)))));
  qm_Tempt_GND_Ve_di=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Ve_di*T7)+(T7*T7_Ve_di)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Ve_di*T7+T7_Tempt_GND*T7_Ve_di+T7_Ve_di*T7_Tempt_GND+T7*T7_Tempt_GND_Ve_di)))));
  qm_Tempt_GND_Vge_si=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Vge_si*T7)+(T7*T7_Vge_si)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Vge_si*T7+T7_Tempt_GND*T7_Vge_si+T7_Vge_si*T7_Tempt_GND+T7*T7_Tempt_GND_Vge_si)))));
  qm_Tempt_GND_Tempt_GND=(+0.0*(1.0-d00_sqrt0)+0.0*(-(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*d10_sqrt0)+0.0*(-((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*d10_sqrt0)+2.0*(+0.0-(m20_sqrt((1.0+(T7*T7)))*(((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND)))*((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))+d10_sqrt0*(+0.0+(+T7_Tempt_GND_Tempt_GND*T7+T7_Tempt_GND*T7_Tempt_GND+T7_Tempt_GND*T7_Tempt_GND+T7*T7_Tempt_GND_Tempt_GND)))));
#endif
#endif
qm=(2.0*(1.0-d00_sqrt0));
EXIT_IF_ISNAN((2.0*(1.0-d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*rc;
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vdi_si=(+(+(+qm_Vdi_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Vdi_si_Vdi_si)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_si=(+(+(+qm_Vdi_si_Ve_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_di=(+(+(+qm_Vdi_si_Ve_di*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vge_si=(+(+(+qm_Vdi_si_Vge_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Tempt_GND=(+(+(+qm_Vdi_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Vdi_si_Tempt_GND)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_si=qm_Ve_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vdi_si=(+(+(+qm_Ve_si_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_si=(+(+(+qm_Ve_si_Ve_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_di=(+(+(+qm_Ve_si_Ve_di*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vge_si=(+(+(+qm_Ve_si_Vge_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Tempt_GND=(+(+(+qm_Ve_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_di=qm_Ve_di*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_di*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vdi_si=(+(+(+qm_Ve_di_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_si=(+(+(+qm_Ve_di_Ve_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_di=(+(+(+qm_Ve_di_Ve_di*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vge_si=(+(+(+qm_Ve_di_Vge_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Tempt_GND=(+(+(+qm_Ve_di_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Vge_si=qm_Vge_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vge_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vdi_si=(+(+(+qm_Vge_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_si=(+(+(+qm_Vge_si_Ve_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_di=(+(+(+qm_Vge_si_Ve_di*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vge_si=(+(+(+qm_Vge_si_Vge_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Tempt_GND=(+(+(+qm_Vge_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Tempt_GND=(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*rc;
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vdi_si=(+(+(+qm_Tempt_GND_Vdi_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Tempt_GND_Vdi_si)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_si=(+(+(+qm_Tempt_GND_Ve_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_di=(+(+(+qm_Tempt_GND_Ve_di*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vge_si=(+(+(+qm_Tempt_GND_Vge_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Tempt_GND=(+(+(+qm_Tempt_GND_Tempt_GND*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Tempt_GND_Tempt_GND)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
#endif
T8=(((qm*pModel->ALPHA_UFCM)+qdep)*rc);
EXIT_IF_ISNAN((((qm*pModel->ALPHA_UFCM)+qdep)*rc))
{
double m00_exp(d00_exp0,T8)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=((T8_Vdi_si*((d00_exp0-T8)-1.0)-T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vdi_si*0.0+0.0*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_e=(T8_Vdi_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_e)-T8_Vdi_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vdi_si=(T8_Vdi_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vdi_si)-T8_Vdi_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_si=(T8_Vdi_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_si)-T8_Vdi_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_di=(T8_Vdi_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_di)-T8_Vdi_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_si=(T8_Vdi_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_si)-T8_Vdi_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Tempt_GND=(T8_Vdi_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vdi_si+d10_exp0*T8_Vdi_si_Tempt_GND)-T8_Vdi_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_si=((T8_Ve_si*((d00_exp0-T8)-1.0)-T8*(T8_Ve_si*d10_exp0-T8_Ve_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_si*0.0+0.0*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_e=(T8_Ve_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_e)-T8_Ve_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vdi_si=(T8_Ve_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vdi_si)-T8_Ve_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_si=(T8_Ve_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_si)-T8_Ve_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_di=(T8_Ve_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_di)-T8_Ve_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_si=(T8_Ve_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_si)-T8_Ve_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Tempt_GND=(T8_Ve_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_si+d10_exp0*T8_Ve_si_Tempt_GND)-T8_Ve_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_di=((T8_Ve_di*((d00_exp0-T8)-1.0)-T8*(T8_Ve_di*d10_exp0-T8_Ve_di))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_di*0.0+0.0*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_e=(T8_Ve_di_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_e)-T8_Ve_di_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vdi_si=(T8_Ve_di_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vdi_si)-T8_Ve_di_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_si=(T8_Ve_di_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_si)-T8_Ve_di_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_di=(T8_Ve_di_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_di)-T8_Ve_di_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_si=(T8_Ve_di_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_si)-T8_Ve_di_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Tempt_GND=(T8_Ve_di_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_di+d10_exp0*T8_Ve_di_Tempt_GND)-T8_Ve_di_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Vge_si=((T8_Vge_si*((d00_exp0-T8)-1.0)-T8*(T8_Vge_si*d10_exp0-T8_Vge_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vge_si*0.0+0.0*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_e=(T8_Vge_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_e)-T8_Vge_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vdi_si=(T8_Vge_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vdi_si)-T8_Vge_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_si=(T8_Vge_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_si)-T8_Vge_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_di=(T8_Vge_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_di)-T8_Vge_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_si=(T8_Vge_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_si)-T8_Vge_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Tempt_GND=(T8_Vge_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vge_si+d10_exp0*T8_Vge_si_Tempt_GND)-T8_Vge_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Tempt_GND=((T8_Tempt_GND*((d00_exp0-T8)-1.0)-T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*0.0+0.0*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_e=(T8_Tempt_GND_Vge_e/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_e)-T8_Tempt_GND_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vdi_si=(T8_Tempt_GND_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vdi_si)-T8_Tempt_GND_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_si=(T8_Tempt_GND_Ve_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_si)-T8_Tempt_GND_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_di=(T8_Tempt_GND_Ve_di/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_di)-T8_Tempt_GND_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_si=(T8_Tempt_GND_Vge_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_si)-T8_Tempt_GND_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Tempt_GND=(T8_Tempt_GND_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Tempt_GND)-T8_Tempt_GND_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
#endif
T4=(T8/((d00_exp0-T8)-1.0));
EXIT_IF_ISNAN((T8/((d00_exp0-T8)-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=((T8_Vdi_si*T4)+(T8*T4_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*T4+T8_Vdi_si*T4_Vge_di+0.0*T4_Vdi_si+T8*T4_Vdi_si_Vge_di);
  T5_Vdi_si_Vdi_d=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vsi_s=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vge_e=(+T8_Vdi_si_Vge_e*T4+T8_Vdi_si*T4_Vge_e+T8_Vge_e*T4_Vdi_si+T8*T4_Vdi_si_Vge_e);
  T5_Vdi_si_Vdi_si=(+T8_Vdi_si_Vdi_si*T4+T8_Vdi_si*T4_Vdi_si+T8_Vdi_si*T4_Vdi_si+T8*T4_Vdi_si_Vdi_si);
  T5_Vdi_si_Ve_si=(+T8_Vdi_si_Ve_si*T4+T8_Vdi_si*T4_Ve_si+T8_Ve_si*T4_Vdi_si+T8*T4_Vdi_si_Ve_si);
  T5_Vdi_si_Ve_di=(+T8_Vdi_si_Ve_di*T4+T8_Vdi_si*T4_Ve_di+T8_Ve_di*T4_Vdi_si+T8*T4_Vdi_si_Ve_di);
  T5_Vdi_si_Vge_si=(+T8_Vdi_si_Vge_si*T4+T8_Vdi_si*T4_Vge_si+T8_Vge_si*T4_Vdi_si+T8*T4_Vdi_si_Vge_si);
  T5_Vdi_si_Tempt_GND=(+T8_Vdi_si_Tempt_GND*T4+T8_Vdi_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vdi_si+T8*T4_Vdi_si_Tempt_GND);
#endif
T5_Ve_si=((T8_Ve_si*T4)+(T8*T4_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0*T4+T8_Ve_si*T4_Vge_di+0.0*T4_Ve_si+T8*T4_Ve_si_Vge_di);
  T5_Ve_si_Vdi_d=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vsi_s=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vge_e=(+T8_Ve_si_Vge_e*T4+T8_Ve_si*T4_Vge_e+T8_Vge_e*T4_Ve_si+T8*T4_Ve_si_Vge_e);
  T5_Ve_si_Vdi_si=(+T8_Ve_si_Vdi_si*T4+T8_Ve_si*T4_Vdi_si+T8_Vdi_si*T4_Ve_si+T8*T4_Ve_si_Vdi_si);
  T5_Ve_si_Ve_si=(+T8_Ve_si_Ve_si*T4+T8_Ve_si*T4_Ve_si+T8_Ve_si*T4_Ve_si+T8*T4_Ve_si_Ve_si);
  T5_Ve_si_Ve_di=(+T8_Ve_si_Ve_di*T4+T8_Ve_si*T4_Ve_di+T8_Ve_di*T4_Ve_si+T8*T4_Ve_si_Ve_di);
  T5_Ve_si_Vge_si=(+T8_Ve_si_Vge_si*T4+T8_Ve_si*T4_Vge_si+T8_Vge_si*T4_Ve_si+T8*T4_Ve_si_Vge_si);
  T5_Ve_si_Tempt_GND=(+T8_Ve_si_Tempt_GND*T4+T8_Ve_si*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_si+T8*T4_Ve_si_Tempt_GND);
#endif
T5_Ve_di=((T8_Ve_di*T4)+(T8*T4_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0*T4+T8_Ve_di*T4_Vge_di+0.0*T4_Ve_di+T8*T4_Ve_di_Vge_di);
  T5_Ve_di_Vdi_d=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vsi_s=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vge_e=(+T8_Ve_di_Vge_e*T4+T8_Ve_di*T4_Vge_e+T8_Vge_e*T4_Ve_di+T8*T4_Ve_di_Vge_e);
  T5_Ve_di_Vdi_si=(+T8_Ve_di_Vdi_si*T4+T8_Ve_di*T4_Vdi_si+T8_Vdi_si*T4_Ve_di+T8*T4_Ve_di_Vdi_si);
  T5_Ve_di_Ve_si=(+T8_Ve_di_Ve_si*T4+T8_Ve_di*T4_Ve_si+T8_Ve_si*T4_Ve_di+T8*T4_Ve_di_Ve_si);
  T5_Ve_di_Ve_di=(+T8_Ve_di_Ve_di*T4+T8_Ve_di*T4_Ve_di+T8_Ve_di*T4_Ve_di+T8*T4_Ve_di_Ve_di);
  T5_Ve_di_Vge_si=(+T8_Ve_di_Vge_si*T4+T8_Ve_di*T4_Vge_si+T8_Vge_si*T4_Ve_di+T8*T4_Ve_di_Vge_si);
  T5_Ve_di_Tempt_GND=(+T8_Ve_di_Tempt_GND*T4+T8_Ve_di*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_di+T8*T4_Ve_di_Tempt_GND);
#endif
T5_Vge_si=((T8_Vge_si*T4)+(T8*T4_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0*T4+T8_Vge_si*T4_Vge_di+0.0*T4_Vge_si+T8*T4_Vge_si_Vge_di);
  T5_Vge_si_Vdi_d=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vsi_s=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vge_e=(+T8_Vge_si_Vge_e*T4+T8_Vge_si*T4_Vge_e+T8_Vge_e*T4_Vge_si+T8*T4_Vge_si_Vge_e);
  T5_Vge_si_Vdi_si=(+T8_Vge_si_Vdi_si*T4+T8_Vge_si*T4_Vdi_si+T8_Vdi_si*T4_Vge_si+T8*T4_Vge_si_Vdi_si);
  T5_Vge_si_Ve_si=(+T8_Vge_si_Ve_si*T4+T8_Vge_si*T4_Ve_si+T8_Ve_si*T4_Vge_si+T8*T4_Vge_si_Ve_si);
  T5_Vge_si_Ve_di=(+T8_Vge_si_Ve_di*T4+T8_Vge_si*T4_Ve_di+T8_Ve_di*T4_Vge_si+T8*T4_Vge_si_Ve_di);
  T5_Vge_si_Vge_si=(+T8_Vge_si_Vge_si*T4+T8_Vge_si*T4_Vge_si+T8_Vge_si*T4_Vge_si+T8*T4_Vge_si_Vge_si);
  T5_Vge_si_Tempt_GND=(+T8_Vge_si_Tempt_GND*T4+T8_Vge_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vge_si+T8*T4_Vge_si_Tempt_GND);
#endif
T5_Tempt_GND=((T8_Tempt_GND*T4)+(T8*T4_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*T4+T8_Tempt_GND*T4_Vge_di+0.0*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_di);
  T5_Tempt_GND_Vdi_d=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vsi_s=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vge_e=(+T8_Tempt_GND_Vge_e*T4+T8_Tempt_GND*T4_Vge_e+T8_Vge_e*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_e);
  T5_Tempt_GND_Vdi_si=(+T8_Tempt_GND_Vdi_si*T4+T8_Tempt_GND*T4_Vdi_si+T8_Vdi_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vdi_si);
  T5_Tempt_GND_Ve_si=(+T8_Tempt_GND_Ve_si*T4+T8_Tempt_GND*T4_Ve_si+T8_Ve_si*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_si);
  T5_Tempt_GND_Ve_di=(+T8_Tempt_GND_Ve_di*T4+T8_Tempt_GND*T4_Ve_di+T8_Ve_di*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_di);
  T5_Tempt_GND_Vge_si=(+T8_Tempt_GND_Vge_si*T4+T8_Tempt_GND*T4_Vge_si+T8_Vge_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_si);
  T5_Tempt_GND_Tempt_GND=(+T8_Tempt_GND_Tempt_GND*T4+T8_Tempt_GND*T4_Tempt_GND+T8_Tempt_GND*T4_Tempt_GND+T8*T4_Tempt_GND_Tempt_GND);
#endif
#endif
T5=(T8*T4);
EXIT_IF_ISNAN((T8*T4))
{
double m00_logE(d00_logE0,(-qm))
double m00_logE(d00_logE1,T5)
double m00_pow(d00_pow2,(-(qm+qdep)),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-qm))
double m10_logE(d10_logE1,d00_logE1,T5)
double m10_pow(d10_pow2,d00_pow2,(-(qm+qdep)),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=0.0;
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=0.0;
  e0_Vge_e_Vge_si=0.0;
  e0_Vge_e_Ve_si=0.0;
  e0_Vge_e_Ve_di=0.0;
  e0_Vge_e_Vdi_si=0.0;
  e0_Vge_e_Tempt_GND=0.0;
#endif
e0_Vge_si=((((F0_Vge_si-qm_Vge_si)+(-qm_Vge_si)*d10_logE0)+T5_Vge_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vge_si=(+(+(+(+F0_Vge_si_Vge_si-qm_Vge_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_si=(+(+(+(+F0_Vge_si_Ve_si-qm_Vge_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_di=(+(+(+(+F0_Vge_si_Ve_di-qm_Vge_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vdi_si=(+(+(+(+F0_Vge_si_Vdi_si-qm_Vge_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Tempt_GND=(+(+(+(+F0_Vge_si_Tempt_GND-qm_Vge_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vge_si+d10_logE1*T5_Vge_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_si=((((F0_Ve_si-qm_Ve_si)+(-qm_Ve_si)*d10_logE0)+T5_Ve_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vge_si=(+(+(+(+F0_Ve_si_Vge_si-qm_Ve_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_si=(+(+(+(+F0_Ve_si_Ve_si-qm_Ve_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_di=(+(+(+(+F0_Ve_si_Ve_di-qm_Ve_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vdi_si=(+(+(+(+F0_Ve_si_Vdi_si-qm_Ve_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Tempt_GND=(+(+(+(+F0_Ve_si_Tempt_GND-qm_Ve_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_si+d10_logE1*T5_Ve_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_di=((((F0_Ve_di-qm_Ve_di)+(-qm_Ve_di)*d10_logE0)+T5_Ve_di*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vge_si=(+(+(+(+F0_Ve_di_Vge_si-qm_Ve_di_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_si=(+(+(+(+F0_Ve_di_Ve_si-qm_Ve_di_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_di=(+(+(+(+F0_Ve_di_Ve_di-qm_Ve_di_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vdi_si=(+(+(+(+F0_Ve_di_Vdi_si-qm_Ve_di_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Tempt_GND=(+(+(+(+F0_Ve_di_Tempt_GND-qm_Ve_di_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_di+d10_logE1*T5_Ve_di_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
#endif
e0_Vdi_si=((((F0_Vdi_si-qm_Vdi_si)+(-qm_Vdi_si)*d10_logE0)+T5_Vdi_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vge_si=(+(+(+(+F0_Vdi_si_Vge_si-qm_Vdi_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_si=(+(+(+(+F0_Vdi_si_Ve_si-qm_Vdi_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_di=(+(+(+(+F0_Vdi_si_Ve_di-qm_Vdi_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vdi_si=(+(+(+(+F0_Vdi_si_Vdi_si-qm_Vdi_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Tempt_GND=(+(+(+(+F0_Vdi_si_Tempt_GND-qm_Vdi_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vdi_si+d10_logE1*T5_Vdi_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
#endif
e0_Tempt_GND=((((F0_Tempt_GND-qm_Tempt_GND)+(-qm_Tempt_GND)*d10_logE0)+T5_Tempt_GND*d10_logE1)+((QMFACTORCVfinal_Tempt_GND*d00_pow2)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_e))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vge_si=(+(+(+(+F0_Tempt_GND_Vge_si-qm_Tempt_GND_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_si=(+(+(+(+F0_Tempt_GND_Ve_si-qm_Tempt_GND_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_di=(+(+(+(+F0_Tempt_GND_Ve_di-qm_Tempt_GND_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_di))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vdi_si=(+(+(+(+F0_Tempt_GND_Vdi_si-qm_Tempt_GND_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vdi_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Tempt_GND=(+(+(+(+F0_Tempt_GND_Tempt_GND-qm_Tempt_GND_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Tempt_GND))+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
#endif
#endif
e0=((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2));
EXIT_IF_ISNAN(((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=0.0;
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=0.0;
  e1_Vge_e_Vdi_si=0.0;
  e1_Vge_e_Ve_si=0.0;
  e1_Vge_e_Ve_di=0.0;
  e1_Vge_e_Vge_si=0.0;
  e1_Vge_e_Tempt_GND=0.0;
#endif
e1_Vdi_si=(((-qm_Vdi_si/qm/qm)+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vdi_si+1.0*0.0)/qm/qm+2*1.0*qm_Vdi_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_e)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_e/T8/T8/T8)-T4_Vdi_si_Vge_e)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vdi_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vdi_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vdi_si/T8/T8/T8)-T4_Vdi_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_si/T8/T8/T8)-T4_Vdi_si_Ve_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_di)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_di)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_di/T8/T8/T8)-T4_Vdi_si_Ve_di)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vge_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_si/T8/T8/T8)-T4_Vdi_si_Vge_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Tempt_GND)/qm/qm+2*1.0*qm_Vdi_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Tempt_GND)/T8/T8+2*2.0*T8_Vdi_si*T8_Tempt_GND/T8/T8/T8)-T4_Vdi_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_si=(((-qm_Ve_si/qm/qm)+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_si+1.0*0.0)/qm/qm+2*1.0*qm_Ve_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_e)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_e/T8/T8/T8)-T4_Ve_si_Vge_e)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vdi_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vdi_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vdi_si/T8/T8/T8)-T4_Ve_si_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_si)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_si)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_si/T8/T8/T8)-T4_Ve_si_Ve_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_di)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_di)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_di/T8/T8/T8)-T4_Ve_si_Ve_di)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vge_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_si/T8/T8/T8)-T4_Ve_si_Vge_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_si+1.0*qm_Ve_si_Tempt_GND)/qm/qm+2*1.0*qm_Ve_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_si+2.0*T8_Ve_si_Tempt_GND)/T8/T8+2*2.0*T8_Ve_si*T8_Tempt_GND/T8/T8/T8)-T4_Ve_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_di=(((-qm_Ve_di/qm/qm)+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_di+1.0*0.0)/qm/qm+2*1.0*qm_Ve_di*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_e)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_e/T8/T8/T8)-T4_Ve_di_Vge_e)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vdi_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vdi_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vdi_si/T8/T8/T8)-T4_Ve_di_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_si)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_si)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_si/T8/T8/T8)-T4_Ve_di_Ve_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_di)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_di)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_di/T8/T8/T8)-T4_Ve_di_Ve_di)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vge_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_si/T8/T8/T8)-T4_Ve_di_Vge_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_di+1.0*qm_Ve_di_Tempt_GND)/qm/qm+2*1.0*qm_Ve_di*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_di+2.0*T8_Ve_di_Tempt_GND)/T8/T8+2*2.0*T8_Ve_di*T8_Tempt_GND/T8/T8/T8)-T4_Ve_di_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Vge_si=(((-qm_Vge_si/qm/qm)+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vge_si+1.0*0.0)/qm/qm+2*1.0*qm_Vge_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_e)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_e/T8/T8/T8)-T4_Vge_si_Vge_e)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vdi_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vdi_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vdi_si/T8/T8/T8)-T4_Vge_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_si)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_si)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_si/T8/T8/T8)-T4_Vge_si_Ve_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_di)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_di)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_di/T8/T8/T8)-T4_Vge_si_Ve_di)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vge_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_si/T8/T8/T8)-T4_Vge_si_Vge_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vge_si+1.0*qm_Vge_si_Tempt_GND)/qm/qm+2*1.0*qm_Vge_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vge_si+2.0*T8_Vge_si_Tempt_GND)/T8/T8+2*2.0*T8_Vge_si*T8_Tempt_GND/T8/T8/T8)-T4_Vge_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Tempt_GND=(((-qm_Tempt_GND/qm/qm)+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*rc)-((((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Tempt_GND+1.0*0.0)/qm/qm+2*1.0*qm_Tempt_GND*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_e)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_e/T8/T8/T8)-T4_Tempt_GND_Vge_e)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*0.0+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vdi_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vdi_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vdi_si/T8/T8/T8)-T4_Tempt_GND_Vdi_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_si/T8/T8/T8)-T4_Tempt_GND_Ve_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_di)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_di)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_di/T8/T8/T8)-T4_Tempt_GND_Ve_di)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vge_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_si/T8/T8/T8)-T4_Tempt_GND_Vge_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Tempt_GND)/qm/qm+2*1.0*qm_Tempt_GND*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Tempt_GND)/T8/T8+2*2.0*T8_Tempt_GND*T8_Tempt_GND/T8/T8/T8)-T4_Tempt_GND_Tempt_GND)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e1=((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN(((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
e2_Vdi_si=((-(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e2_Vdi_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vdi_si*qm+qm_Vdi_si*qm_Vdi_si+qm_Vdi_si*qm_Vdi_si+qm*qm_Vdi_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_si*qm+qm_Vdi_si*qm_Ve_si+qm_Ve_si*qm_Vdi_si+qm*qm_Vdi_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_di*qm+qm_Vdi_si*qm_Ve_di+qm_Ve_di*qm_Vdi_si+qm*qm_Vdi_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vge_si*qm+qm_Vdi_si*qm_Vge_si+qm_Vge_si*qm_Vdi_si+qm*qm_Vdi_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Tempt_GND*qm+qm_Vdi_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vdi_si+qm*qm_Vdi_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_si=((-(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e2_Ve_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vdi_si*qm+qm_Ve_si*qm_Vdi_si+qm_Vdi_si*qm_Ve_si+qm*qm_Ve_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_si*qm+qm_Ve_si*qm_Ve_si+qm_Ve_si*qm_Ve_si+qm*qm_Ve_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_di*qm+qm_Ve_si*qm_Ve_di+qm_Ve_di*qm_Ve_si+qm*qm_Ve_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vge_si*qm+qm_Ve_si*qm_Vge_si+qm_Vge_si*qm_Ve_si+qm*qm_Ve_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Tempt_GND*qm+qm_Ve_si*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_si+qm*qm_Ve_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_di=((-(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e2_Ve_di_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vdi_si*qm+qm_Ve_di*qm_Vdi_si+qm_Vdi_si*qm_Ve_di+qm*qm_Ve_di_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_si*qm+qm_Ve_di*qm_Ve_si+qm_Ve_si*qm_Ve_di+qm*qm_Ve_di_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_di*qm+qm_Ve_di*qm_Ve_di+qm_Ve_di*qm_Ve_di+qm*qm_Ve_di_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vge_si*qm+qm_Ve_di*qm_Vge_si+qm_Vge_si*qm_Ve_di+qm*qm_Ve_di_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Tempt_GND*qm+qm_Ve_di*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_di+qm*qm_Ve_di_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Vge_si=((-(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e2_Vge_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vdi_si*qm+qm_Vge_si*qm_Vdi_si+qm_Vdi_si*qm_Vge_si+qm*qm_Vge_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_si*qm+qm_Vge_si*qm_Ve_si+qm_Ve_si*qm_Vge_si+qm*qm_Vge_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_di*qm+qm_Vge_si*qm_Ve_di+qm_Ve_di*qm_Vge_si+qm*qm_Vge_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vge_si*qm+qm_Vge_si*qm_Vge_si+qm_Vge_si*qm_Vge_si+qm*qm_Vge_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Tempt_GND*qm+qm_Vge_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vge_si+qm*qm_Vge_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Tempt_GND=((-(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))/(qm*qm)/(qm*qm))-((((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e2_Tempt_GND_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vdi_si*qm+qm_Tempt_GND*qm_Vdi_si+qm_Vdi_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_si*qm+qm_Tempt_GND*qm_Ve_si+qm_Ve_si*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_di*qm+qm_Tempt_GND*qm_Ve_di+qm_Ve_di*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vge_si*qm+qm_Tempt_GND*qm_Vge_si+qm_Vge_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Tempt_GND*qm+qm_Tempt_GND*qm_Tempt_GND+qm_Tempt_GND*qm_Tempt_GND+qm*qm_Tempt_GND_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e2=(((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN((((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(qm_Vdi_si-((((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+qm_Vdi_si_Vdi_si-(+(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vdi_si*e2+e0_Vdi_si*e2_Vdi_si+e0_Vdi_si*e2_Vdi_si+e0*e2_Vdi_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vdi_si)*e1+(2.0*e1_Vdi_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_si=(+qm_Vdi_si_Ve_si-(+(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_si*e2+e0_Vdi_si*e2_Ve_si+e0_Ve_si*e2_Vdi_si+e0*e2_Vdi_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_si)*e1+(2.0*e1_Vdi_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_di=(+qm_Vdi_si_Ve_di-(+(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_di*e2+e0_Vdi_si*e2_Ve_di+e0_Ve_di*e2_Vdi_si+e0*e2_Vdi_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_di)*e1+(2.0*e1_Vdi_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Vge_si=(+qm_Vdi_si_Vge_si-(+(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vge_si*e2+e0_Vdi_si*e2_Vge_si+e0_Vge_si*e2_Vdi_si+e0*e2_Vdi_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vge_si)*e1+(2.0*e1_Vdi_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Tempt_GND=(+qm_Vdi_si_Tempt_GND-(+(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Tempt_GND*e2+e0_Vdi_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vdi_si+e0*e2_Vdi_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Tempt_GND)*e1+(2.0*e1_Vdi_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_si=(qm_Ve_si-((((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+qm_Ve_si_Vdi_si-(+(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vdi_si*e2+e0_Ve_si*e2_Vdi_si+e0_Vdi_si*e2_Ve_si+e0*e2_Ve_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vdi_si)*e1+(2.0*e1_Ve_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_si=(+qm_Ve_si_Ve_si-(+(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_si*e2+e0_Ve_si*e2_Ve_si+e0_Ve_si*e2_Ve_si+e0*e2_Ve_si_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_si)*e1+(2.0*e1_Ve_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_di=(+qm_Ve_si_Ve_di-(+(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_di*e2+e0_Ve_si*e2_Ve_di+e0_Ve_di*e2_Ve_si+e0*e2_Ve_si_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_di)*e1+(2.0*e1_Ve_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Vge_si=(+qm_Ve_si_Vge_si-(+(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vge_si*e2+e0_Ve_si*e2_Vge_si+e0_Vge_si*e2_Ve_si+e0*e2_Ve_si_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vge_si)*e1+(2.0*e1_Ve_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Tempt_GND=(+qm_Ve_si_Tempt_GND-(+(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Tempt_GND*e2+e0_Ve_si*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_si+e0*e2_Ve_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_si+2.0*e1_Ve_si_Tempt_GND)*e1+(2.0*e1_Ve_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_di=(qm_Ve_di-((((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+qm_Ve_di_Vdi_si-(+(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vdi_si*e2+e0_Ve_di*e2_Vdi_si+e0_Vdi_si*e2_Ve_di+e0*e2_Ve_di_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vdi_si)*e1+(2.0*e1_Ve_di)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_si=(+qm_Ve_di_Ve_si-(+(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_si*e2+e0_Ve_di*e2_Ve_si+e0_Ve_si*e2_Ve_di+e0*e2_Ve_di_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_si)*e1+(2.0*e1_Ve_di)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_di=(+qm_Ve_di_Ve_di-(+(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_di*e2+e0_Ve_di*e2_Ve_di+e0_Ve_di*e2_Ve_di+e0*e2_Ve_di_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_di)*e1+(2.0*e1_Ve_di)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Vge_si=(+qm_Ve_di_Vge_si-(+(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vge_si*e2+e0_Ve_di*e2_Vge_si+e0_Vge_si*e2_Ve_di+e0*e2_Ve_di_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vge_si)*e1+(2.0*e1_Ve_di)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Tempt_GND=(+qm_Ve_di_Tempt_GND-(+(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Tempt_GND*e2+e0_Ve_di*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_di+e0*e2_Ve_di_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_di+2.0*e1_Ve_di_Tempt_GND)*e1+(2.0*e1_Ve_di)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Vge_si=(qm_Vge_si-((((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+qm_Vge_si_Vdi_si-(+(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vdi_si*e2+e0_Vge_si*e2_Vdi_si+e0_Vdi_si*e2_Vge_si+e0*e2_Vge_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vdi_si)*e1+(2.0*e1_Vge_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_si=(+qm_Vge_si_Ve_si-(+(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_si*e2+e0_Vge_si*e2_Ve_si+e0_Ve_si*e2_Vge_si+e0*e2_Vge_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_si)*e1+(2.0*e1_Vge_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_di=(+qm_Vge_si_Ve_di-(+(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_di*e2+e0_Vge_si*e2_Ve_di+e0_Ve_di*e2_Vge_si+e0*e2_Vge_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_di)*e1+(2.0*e1_Vge_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Vge_si=(+qm_Vge_si_Vge_si-(+(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vge_si*e2+e0_Vge_si*e2_Vge_si+e0_Vge_si*e2_Vge_si+e0*e2_Vge_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vge_si)*e1+(2.0*e1_Vge_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Tempt_GND=(+qm_Vge_si_Tempt_GND-(+(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Tempt_GND*e2+e0_Vge_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vge_si+e0*e2_Vge_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vge_si+2.0*e1_Vge_si_Tempt_GND)*e1+(2.0*e1_Vge_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Tempt_GND=(qm_Tempt_GND-((((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+qm_Tempt_GND_Vdi_si-(+(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vdi_si*e2+e0_Tempt_GND*e2_Vdi_si+e0_Vdi_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vdi_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vdi_si)*e1+(2.0*e1_Tempt_GND)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_si=(+qm_Tempt_GND_Ve_si-(+(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_si*e2+e0_Tempt_GND*e2_Ve_si+e0_Ve_si*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_si)*e1+(2.0*e1_Tempt_GND)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_di=(+qm_Tempt_GND_Ve_di-(+(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_di*e2+e0_Tempt_GND*e2_Ve_di+e0_Ve_di*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_di)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_di)*e1+(2.0*e1_Tempt_GND)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Vge_si=(+qm_Tempt_GND_Vge_si-(+(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vge_si*e2+e0_Tempt_GND*e2_Vge_si+e0_Vge_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vge_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vge_si)*e1+(2.0*e1_Tempt_GND)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Tempt_GND=(+qm_Tempt_GND_Tempt_GND-(+(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Tempt_GND*e2+e0_Tempt_GND*e2_Tempt_GND+e0_Tempt_GND*e2_Tempt_GND+e0*e2_Tempt_GND_Tempt_GND)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Tempt_GND)*e1+(2.0*e1_Tempt_GND)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
#endif
qm=(qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
EXIT_IF_ISNAN((qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*rc;
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vdi_si=(+(+(+qm_Vdi_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Vdi_si_Vdi_si)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_si=(+(+(+qm_Vdi_si_Ve_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Ve_di=(+(+(+qm_Vdi_si_Ve_di*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Vge_si=(+(+(+qm_Vdi_si_Vge_si*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vdi_si_Tempt_GND=(+(+(+qm_Vdi_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vdi_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Vdi_si_Tempt_GND)*rc+(qm_Vdi_si*pModel->ALPHA_UFCM+qdep_Vdi_si)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_si=qm_Ve_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vdi_si=(+(+(+qm_Ve_si_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_si=(+(+(+qm_Ve_si_Ve_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Ve_di=(+(+(+qm_Ve_si_Ve_di*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Vge_si=(+(+(+qm_Ve_si_Vge_si*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_si_Tempt_GND=(+(+(+qm_Ve_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Ve_di=qm_Ve_di*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Ve_di*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vdi_si=(+(+(+qm_Ve_di_Vdi_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_si=(+(+(+qm_Ve_di_Ve_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Ve_di=(+(+(+qm_Ve_di_Ve_di*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Vge_si=(+(+(+qm_Ve_di_Vge_si*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Ve_di_Tempt_GND=(+(+(+qm_Ve_di_Tempt_GND*pModel->ALPHA_UFCM+qm_Ve_di*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Ve_di*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Vge_si=qm_Vge_si*pModel->ALPHA_UFCM*rc;
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Vge_si*0.0+0.0*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vdi_si=(+(+(+qm_Vge_si_Vdi_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vdi_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_si=(+(+(+qm_Vge_si_Ve_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Ve_di=(+(+(+qm_Vge_si_Ve_di*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Vge_si=(+(+(+qm_Vge_si_Vge_si*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Vge_si_Tempt_GND=(+(+(+qm_Vge_si_Tempt_GND*pModel->ALPHA_UFCM+qm_Vge_si*0.0+qm_Tempt_GND*0.0+qm*0.0)+0.0)*rc+qm_Vge_si*pModel->ALPHA_UFCM*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
T8_Tempt_GND=(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*rc;
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+(+(+0.0*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+0.0*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(0.0)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vdi_si=(+(+(+qm_Tempt_GND_Vdi_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vdi_si*0.0+qm*0.0)+qdep_Tempt_GND_Vdi_si)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Vdi_si*pModel->ALPHA_UFCM)+qdep_Vdi_si)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_si=(+(+(+qm_Tempt_GND_Ve_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Ve_di=(+(+(+qm_Tempt_GND_Ve_di*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Ve_di*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Ve_di*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Vge_si=(+(+(+qm_Tempt_GND_Vge_si*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Vge_si*0.0+qm*0.0)+0.0)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+(qm_Vge_si*pModel->ALPHA_UFCM)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
  T8_Tempt_GND_Tempt_GND=(+(+(+qm_Tempt_GND_Tempt_GND*pModel->ALPHA_UFCM+qm_Tempt_GND*0.0+qm_Tempt_GND*0.0+qm*0.0)+qdep_Tempt_GND_Tempt_GND)*rc+(qm_Tempt_GND*pModel->ALPHA_UFCM+qdep_Tempt_GND)*0.0+((qm_Tempt_GND*pModel->ALPHA_UFCM)+qdep_Tempt_GND)*0.0+((qm*pModel->ALPHA_UFCM)+qdep)*0.0);
#endif
#endif
T8=(((qm*pModel->ALPHA_UFCM)+qdep)*rc);
EXIT_IF_ISNAN((((qm*pModel->ALPHA_UFCM)+qdep)*rc))
{
double m00_exp(d00_exp0,T8)
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=((T8_Vdi_si*((d00_exp0-T8)-1.0)-T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vdi_si*0.0+0.0*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_e=(T8_Vdi_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_e)-T8_Vdi_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vdi_si=(T8_Vdi_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vdi_si)-T8_Vdi_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_si=(T8_Vdi_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_si)-T8_Vdi_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Ve_di=(T8_Vdi_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vdi_si+d10_exp0*T8_Vdi_si_Ve_di)-T8_Vdi_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Vge_si=(T8_Vdi_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vdi_si+d10_exp0*T8_Vdi_si_Vge_si)-T8_Vdi_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vdi_si_Tempt_GND=(T8_Vdi_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vdi_si+d10_exp0*T8_Vdi_si_Tempt_GND)-T8_Vdi_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vdi_si*d10_exp0-T8_Vdi_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_si=((T8_Ve_si*((d00_exp0-T8)-1.0)-T8*(T8_Ve_si*d10_exp0-T8_Ve_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_si*0.0+0.0*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_e=(T8_Ve_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_e)-T8_Ve_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vdi_si=(T8_Ve_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vdi_si)-T8_Ve_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_si=(T8_Ve_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_si)-T8_Ve_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Ve_di=(T8_Ve_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_si+d10_exp0*T8_Ve_si_Ve_di)-T8_Ve_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Vge_si=(T8_Ve_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_si+d10_exp0*T8_Ve_si_Vge_si)-T8_Ve_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_si_Tempt_GND=(T8_Ve_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_si+d10_exp0*T8_Ve_si_Tempt_GND)-T8_Ve_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_si*d10_exp0-T8_Ve_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Ve_di=((T8_Ve_di*((d00_exp0-T8)-1.0)-T8*(T8_Ve_di*d10_exp0-T8_Ve_di))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Ve_di*0.0+0.0*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_e=(T8_Ve_di_Vge_e/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_e)-T8_Ve_di_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vdi_si=(T8_Ve_di_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vdi_si)-T8_Ve_di_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_si=(T8_Ve_di_Ve_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_si)-T8_Ve_di_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Ve_di=(T8_Ve_di_Ve_di/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Ve_di+d10_exp0*T8_Ve_di_Ve_di)-T8_Ve_di_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Vge_si=(T8_Ve_di_Vge_si/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Ve_di+d10_exp0*T8_Ve_di_Vge_si)-T8_Ve_di_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Ve_di_Tempt_GND=(T8_Ve_di_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Ve_di+d10_exp0*T8_Ve_di_Tempt_GND)-T8_Ve_di_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Ve_di*d10_exp0-T8_Ve_di)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Vge_si=((T8_Vge_si*((d00_exp0-T8)-1.0)-T8*(T8_Vge_si*d10_exp0-T8_Vge_si))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Vge_si*0.0+0.0*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_e=(T8_Vge_si_Vge_e/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_e)-T8_Vge_si_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vdi_si=(T8_Vge_si_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vdi_si)-T8_Vge_si_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_si=(T8_Vge_si_Ve_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_si)-T8_Vge_si_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Ve_di=(T8_Vge_si_Ve_di/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Vge_si+d10_exp0*T8_Vge_si_Ve_di)-T8_Vge_si_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Vge_si=(T8_Vge_si_Vge_si/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Vge_si+d10_exp0*T8_Vge_si_Vge_si)-T8_Vge_si_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Vge_si_Tempt_GND=(T8_Vge_si_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Vge_si+d10_exp0*T8_Vge_si_Tempt_GND)-T8_Vge_si_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Vge_si*d10_exp0-T8_Vge_si)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
T4_Tempt_GND=((T8_Tempt_GND*((d00_exp0-T8)-1.0)-T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(0.0/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*0.0+0.0*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+0.0-0.0)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*0.0/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_e=(T8_Tempt_GND_Vge_e/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_e*d10_exp0-T8_Vge_e)+T8_Vge_e*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_e*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_e)-T8_Tempt_GND_Vge_e)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_e*d10_exp0-T8_Vge_e)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vdi_si=(T8_Tempt_GND_Vdi_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vdi_si*d10_exp0-T8_Vdi_si)+T8_Vdi_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vdi_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vdi_si)-T8_Tempt_GND_Vdi_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vdi_si*d10_exp0-T8_Vdi_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_si=(T8_Tempt_GND_Ve_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_si*d10_exp0-T8_Ve_si)+T8_Ve_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_si)-T8_Tempt_GND_Ve_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_si*d10_exp0-T8_Ve_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Ve_di=(T8_Tempt_GND_Ve_di/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Ve_di*d10_exp0-T8_Ve_di)+T8_Ve_di*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Ve_di*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Ve_di)-T8_Tempt_GND_Ve_di)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Ve_di*d10_exp0-T8_Ve_di)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Vge_si=(T8_Tempt_GND_Vge_si/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Vge_si*d10_exp0-T8_Vge_si)+T8_Vge_si*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Vge_si*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Vge_si)-T8_Tempt_GND_Vge_si)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Vge_si*d10_exp0-T8_Vge_si)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
  T4_Tempt_GND_Tempt_GND=(T8_Tempt_GND_Tempt_GND/((d00_exp0-T8)-1.0)-(T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8_Tempt_GND*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)+T8*(+(+(m20_exp(T8)*T8_Tempt_GND*T8_Tempt_GND+d10_exp0*T8_Tempt_GND_Tempt_GND)-T8_Tempt_GND_Tempt_GND)-0.0))/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)+2*T8*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)*(T8_Tempt_GND*d10_exp0-T8_Tempt_GND)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0)/((d00_exp0-T8)-1.0));
#endif
#endif
T4=(T8/((d00_exp0-T8)-1.0));
EXIT_IF_ISNAN((T8/((d00_exp0-T8)-1.0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=((T8_Vdi_si*T4)+(T8*T4_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*T4+T8_Vdi_si*T4_Vge_di+0.0*T4_Vdi_si+T8*T4_Vdi_si_Vge_di);
  T5_Vdi_si_Vdi_d=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vsi_s=(+0.0*T4+T8_Vdi_si*0.0+0.0*T4_Vdi_si+T8*0.0);
  T5_Vdi_si_Vge_e=(+T8_Vdi_si_Vge_e*T4+T8_Vdi_si*T4_Vge_e+T8_Vge_e*T4_Vdi_si+T8*T4_Vdi_si_Vge_e);
  T5_Vdi_si_Vdi_si=(+T8_Vdi_si_Vdi_si*T4+T8_Vdi_si*T4_Vdi_si+T8_Vdi_si*T4_Vdi_si+T8*T4_Vdi_si_Vdi_si);
  T5_Vdi_si_Ve_si=(+T8_Vdi_si_Ve_si*T4+T8_Vdi_si*T4_Ve_si+T8_Ve_si*T4_Vdi_si+T8*T4_Vdi_si_Ve_si);
  T5_Vdi_si_Ve_di=(+T8_Vdi_si_Ve_di*T4+T8_Vdi_si*T4_Ve_di+T8_Ve_di*T4_Vdi_si+T8*T4_Vdi_si_Ve_di);
  T5_Vdi_si_Vge_si=(+T8_Vdi_si_Vge_si*T4+T8_Vdi_si*T4_Vge_si+T8_Vge_si*T4_Vdi_si+T8*T4_Vdi_si_Vge_si);
  T5_Vdi_si_Tempt_GND=(+T8_Vdi_si_Tempt_GND*T4+T8_Vdi_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vdi_si+T8*T4_Vdi_si_Tempt_GND);
#endif
T5_Ve_si=((T8_Ve_si*T4)+(T8*T4_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0*T4+T8_Ve_si*T4_Vge_di+0.0*T4_Ve_si+T8*T4_Ve_si_Vge_di);
  T5_Ve_si_Vdi_d=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vsi_s=(+0.0*T4+T8_Ve_si*0.0+0.0*T4_Ve_si+T8*0.0);
  T5_Ve_si_Vge_e=(+T8_Ve_si_Vge_e*T4+T8_Ve_si*T4_Vge_e+T8_Vge_e*T4_Ve_si+T8*T4_Ve_si_Vge_e);
  T5_Ve_si_Vdi_si=(+T8_Ve_si_Vdi_si*T4+T8_Ve_si*T4_Vdi_si+T8_Vdi_si*T4_Ve_si+T8*T4_Ve_si_Vdi_si);
  T5_Ve_si_Ve_si=(+T8_Ve_si_Ve_si*T4+T8_Ve_si*T4_Ve_si+T8_Ve_si*T4_Ve_si+T8*T4_Ve_si_Ve_si);
  T5_Ve_si_Ve_di=(+T8_Ve_si_Ve_di*T4+T8_Ve_si*T4_Ve_di+T8_Ve_di*T4_Ve_si+T8*T4_Ve_si_Ve_di);
  T5_Ve_si_Vge_si=(+T8_Ve_si_Vge_si*T4+T8_Ve_si*T4_Vge_si+T8_Vge_si*T4_Ve_si+T8*T4_Ve_si_Vge_si);
  T5_Ve_si_Tempt_GND=(+T8_Ve_si_Tempt_GND*T4+T8_Ve_si*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_si+T8*T4_Ve_si_Tempt_GND);
#endif
T5_Ve_di=((T8_Ve_di*T4)+(T8*T4_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0*T4+T8_Ve_di*T4_Vge_di+0.0*T4_Ve_di+T8*T4_Ve_di_Vge_di);
  T5_Ve_di_Vdi_d=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vsi_s=(+0.0*T4+T8_Ve_di*0.0+0.0*T4_Ve_di+T8*0.0);
  T5_Ve_di_Vge_e=(+T8_Ve_di_Vge_e*T4+T8_Ve_di*T4_Vge_e+T8_Vge_e*T4_Ve_di+T8*T4_Ve_di_Vge_e);
  T5_Ve_di_Vdi_si=(+T8_Ve_di_Vdi_si*T4+T8_Ve_di*T4_Vdi_si+T8_Vdi_si*T4_Ve_di+T8*T4_Ve_di_Vdi_si);
  T5_Ve_di_Ve_si=(+T8_Ve_di_Ve_si*T4+T8_Ve_di*T4_Ve_si+T8_Ve_si*T4_Ve_di+T8*T4_Ve_di_Ve_si);
  T5_Ve_di_Ve_di=(+T8_Ve_di_Ve_di*T4+T8_Ve_di*T4_Ve_di+T8_Ve_di*T4_Ve_di+T8*T4_Ve_di_Ve_di);
  T5_Ve_di_Vge_si=(+T8_Ve_di_Vge_si*T4+T8_Ve_di*T4_Vge_si+T8_Vge_si*T4_Ve_di+T8*T4_Ve_di_Vge_si);
  T5_Ve_di_Tempt_GND=(+T8_Ve_di_Tempt_GND*T4+T8_Ve_di*T4_Tempt_GND+T8_Tempt_GND*T4_Ve_di+T8*T4_Ve_di_Tempt_GND);
#endif
T5_Vge_si=((T8_Vge_si*T4)+(T8*T4_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0*T4+T8_Vge_si*T4_Vge_di+0.0*T4_Vge_si+T8*T4_Vge_si_Vge_di);
  T5_Vge_si_Vdi_d=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vsi_s=(+0.0*T4+T8_Vge_si*0.0+0.0*T4_Vge_si+T8*0.0);
  T5_Vge_si_Vge_e=(+T8_Vge_si_Vge_e*T4+T8_Vge_si*T4_Vge_e+T8_Vge_e*T4_Vge_si+T8*T4_Vge_si_Vge_e);
  T5_Vge_si_Vdi_si=(+T8_Vge_si_Vdi_si*T4+T8_Vge_si*T4_Vdi_si+T8_Vdi_si*T4_Vge_si+T8*T4_Vge_si_Vdi_si);
  T5_Vge_si_Ve_si=(+T8_Vge_si_Ve_si*T4+T8_Vge_si*T4_Ve_si+T8_Ve_si*T4_Vge_si+T8*T4_Vge_si_Ve_si);
  T5_Vge_si_Ve_di=(+T8_Vge_si_Ve_di*T4+T8_Vge_si*T4_Ve_di+T8_Ve_di*T4_Vge_si+T8*T4_Vge_si_Ve_di);
  T5_Vge_si_Vge_si=(+T8_Vge_si_Vge_si*T4+T8_Vge_si*T4_Vge_si+T8_Vge_si*T4_Vge_si+T8*T4_Vge_si_Vge_si);
  T5_Vge_si_Tempt_GND=(+T8_Vge_si_Tempt_GND*T4+T8_Vge_si*T4_Tempt_GND+T8_Tempt_GND*T4_Vge_si+T8*T4_Vge_si_Tempt_GND);
#endif
T5_Tempt_GND=((T8_Tempt_GND*T4)+(T8*T4_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*T4+T8_Tempt_GND*T4_Vge_di+0.0*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_di);
  T5_Tempt_GND_Vdi_d=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vsi_s=(+0.0*T4+T8_Tempt_GND*0.0+0.0*T4_Tempt_GND+T8*0.0);
  T5_Tempt_GND_Vge_e=(+T8_Tempt_GND_Vge_e*T4+T8_Tempt_GND*T4_Vge_e+T8_Vge_e*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_e);
  T5_Tempt_GND_Vdi_si=(+T8_Tempt_GND_Vdi_si*T4+T8_Tempt_GND*T4_Vdi_si+T8_Vdi_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vdi_si);
  T5_Tempt_GND_Ve_si=(+T8_Tempt_GND_Ve_si*T4+T8_Tempt_GND*T4_Ve_si+T8_Ve_si*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_si);
  T5_Tempt_GND_Ve_di=(+T8_Tempt_GND_Ve_di*T4+T8_Tempt_GND*T4_Ve_di+T8_Ve_di*T4_Tempt_GND+T8*T4_Tempt_GND_Ve_di);
  T5_Tempt_GND_Vge_si=(+T8_Tempt_GND_Vge_si*T4+T8_Tempt_GND*T4_Vge_si+T8_Vge_si*T4_Tempt_GND+T8*T4_Tempt_GND_Vge_si);
  T5_Tempt_GND_Tempt_GND=(+T8_Tempt_GND_Tempt_GND*T4+T8_Tempt_GND*T4_Tempt_GND+T8_Tempt_GND*T4_Tempt_GND+T8*T4_Tempt_GND_Tempt_GND);
#endif
#endif
T5=(T8*T4);
EXIT_IF_ISNAN((T8*T4))
{
double m00_logE(d00_logE0,(-qm))
double m00_logE(d00_logE1,T5)
double m00_pow(d00_pow2,(-(qm+qdep)),(2.0/3.0))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(-qm))
double m10_logE(d10_logE1,d00_logE1,T5)
double m10_pow(d10_pow2,d00_pow2,(-(qm+qdep)),(2.0/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=0.0;
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=0.0;
  e0_Vge_e_Vge_si=0.0;
  e0_Vge_e_Ve_si=0.0;
  e0_Vge_e_Ve_di=0.0;
  e0_Vge_e_Vdi_si=0.0;
  e0_Vge_e_Tempt_GND=0.0;
#endif
e0_Vge_si=((((F0_Vge_si-qm_Vge_si)+(-qm_Vge_si)*d10_logE0)+T5_Vge_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vge_si=(+(+(+(+F0_Vge_si_Vge_si-qm_Vge_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_si=(+(+(+(+F0_Vge_si_Ve_si-qm_Vge_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Ve_di=(+(+(+(+F0_Vge_si_Ve_di-qm_Vge_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vge_si+d10_logE1*T5_Vge_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Vdi_si=(+(+(+(+F0_Vge_si_Vdi_si-qm_Vge_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vge_si+d10_logE1*T5_Vge_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
  e0_Vge_si_Tempt_GND=(+(+(+(+F0_Vge_si_Tempt_GND-qm_Vge_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vge_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vge_si+d10_logE1*T5_Vge_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_si=((((F0_Ve_si-qm_Ve_si)+(-qm_Ve_si)*d10_logE0)+T5_Ve_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vge_si=(+(+(+(+F0_Ve_si_Vge_si-qm_Ve_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_si=(+(+(+(+F0_Ve_si_Ve_si-qm_Ve_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Ve_di=(+(+(+(+F0_Ve_si_Ve_di-qm_Ve_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_si+d10_logE1*T5_Ve_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Vdi_si=(+(+(+(+F0_Ve_si_Vdi_si-qm_Ve_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_si+d10_logE1*T5_Ve_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
  e0_Ve_si_Tempt_GND=(+(+(+(+F0_Ve_si_Tempt_GND-qm_Ve_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_si+d10_logE1*T5_Ve_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+QMFACTORCVfinal*fixme));
#endif
e0_Ve_di=((((F0_Ve_di-qm_Ve_di)+(-qm_Ve_di)*d10_logE0)+T5_Ve_di*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vge_si=(+(+(+(+F0_Ve_di_Vge_si-qm_Ve_di_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_si=(+(+(+(+F0_Ve_di_Ve_si-qm_Ve_di_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Ve_di=(+(+(+(+F0_Ve_di_Ve_di-qm_Ve_di_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Ve_di+d10_logE1*T5_Ve_di_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Vdi_si=(+(+(+(+F0_Ve_di_Vdi_si-qm_Ve_di_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Ve_di+d10_logE1*T5_Ve_di_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
  e0_Ve_di_Tempt_GND=(+(+(+(+F0_Ve_di_Tempt_GND-qm_Ve_di_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Ve_di)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Ve_di+d10_logE1*T5_Ve_di_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+QMFACTORCVfinal*fixme));
#endif
e0_Vdi_si=((((F0_Vdi_si-qm_Vdi_si)+(-qm_Vdi_si)*d10_logE0)+T5_Vdi_si*d10_logE1)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_e))+(+0.0*d00_pow2+0.0*0.0+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vge_si=(+(+(+(+F0_Vdi_si_Vge_si-qm_Vdi_si_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vge_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_si=(+(+(+(+F0_Vdi_si_Ve_si-qm_Vdi_si_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Ve_di=(+(+(+(+F0_Vdi_si_Ve_di-qm_Vdi_si_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Vdi_si+d10_logE1*T5_Vdi_si_Ve_di))+(+0.0*d00_pow2+0.0*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Vdi_si=(+(+(+(+F0_Vdi_si_Vdi_si-qm_Vdi_si_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Vdi_si+d10_logE1*T5_Vdi_si_Vdi_si))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
  e0_Vdi_si_Tempt_GND=(+(+(+(+F0_Vdi_si_Tempt_GND-qm_Vdi_si_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Vdi_si)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Vdi_si+d10_logE1*T5_Vdi_si_Tempt_GND))+(+0.0*d00_pow2+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+QMFACTORCVfinal*fixme));
#endif
e0_Tempt_GND=((((F0_Tempt_GND-qm_Tempt_GND)+(-qm_Tempt_GND)*d10_logE0)+T5_Tempt_GND*d10_logE1)+((QMFACTORCVfinal_Tempt_GND*d00_pow2)+(QMFACTORCVfinal*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+(+(+(+0.0-0.0)+0.0)+(m20_logE(T5)*T5_Vge_e*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_e))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*0.0+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vge_si=(+(+(+(+F0_Tempt_GND_Vge_si-qm_Tempt_GND_Vge_si)+(m20_logE((-qm))*(-qm_Vge_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vge_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vge_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Vge_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_si=(+(+(+(+F0_Tempt_GND_Ve_si-qm_Tempt_GND_Ve_si)+(m20_logE((-qm))*(-qm_Ve_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_si))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Ve_di=(+(+(+(+F0_Tempt_GND_Ve_di-qm_Tempt_GND_Ve_di)+(m20_logE((-qm))*(-qm_Ve_di)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Ve_di*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Ve_di))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-qm_Ve_di))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Vdi_si=(+(+(+(+F0_Tempt_GND_Vdi_si-qm_Tempt_GND_Vdi_si)+(m20_logE((-qm))*(-qm_Vdi_si)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Vdi_si*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Vdi_si))+(+0.0*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Vdi_si+qdep_Vdi_si)))+0.0*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
  e0_Tempt_GND_Tempt_GND=(+(+(+(+F0_Tempt_GND_Tempt_GND-qm_Tempt_GND_Tempt_GND)+(m20_logE((-qm))*(-qm_Tempt_GND)*(-qm_Tempt_GND)+d10_logE0*0.0))+(m20_logE(T5)*T5_Tempt_GND*T5_Tempt_GND+d10_logE1*T5_Tempt_GND_Tempt_GND))+(+QMFACTORCVfinal_Tempt_GND_Tempt_GND*d00_pow2+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal_Tempt_GND*(d10_pow2*(-(qm_Tempt_GND+qdep_Tempt_GND)))+QMFACTORCVfinal*fixme));
#endif
#endif
e0=((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2));
EXIT_IF_ISNAN(((((F0-qm)+d00_logE0)+d00_logE1)+(QMFACTORCVfinal*d00_pow2)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-1.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=0.0;
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=0.0;
  e1_Vge_e_Vdi_si=0.0;
  e1_Vge_e_Ve_si=0.0;
  e1_Vge_e_Ve_di=0.0;
  e1_Vge_e_Vge_si=0.0;
  e1_Vge_e_Tempt_GND=0.0;
#endif
e1_Vdi_si=(((-qm_Vdi_si/qm/qm)+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vdi_si+1.0*0.0)/qm/qm+2*1.0*qm_Vdi_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_e)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_e/T8/T8/T8)-T4_Vdi_si_Vge_e)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vdi_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vdi_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vdi_si/T8/T8/T8)-T4_Vdi_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_si/T8/T8/T8)-T4_Vdi_si_Ve_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Ve_di)/qm/qm+2*1.0*qm_Vdi_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Ve_di)/T8/T8+2*2.0*T8_Vdi_si*T8_Ve_di/T8/T8/T8)-T4_Vdi_si_Ve_di)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Vge_si)/qm/qm+2*1.0*qm_Vdi_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Vge_si)/T8/T8+2*2.0*T8_Vdi_si*T8_Vge_si/T8/T8/T8)-T4_Vdi_si_Vge_si)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vdi_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vdi_si+1.0*qm_Vdi_si_Tempt_GND)/qm/qm+2*1.0*qm_Vdi_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vdi_si+2.0*T8_Vdi_si_Tempt_GND)/T8/T8+2*2.0*T8_Vdi_si*T8_Tempt_GND/T8/T8/T8)-T4_Vdi_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_si=(((-qm_Ve_si/qm/qm)+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_si+1.0*0.0)/qm/qm+2*1.0*qm_Ve_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_e)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_e/T8/T8/T8)-T4_Ve_si_Vge_e)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vdi_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vdi_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vdi_si/T8/T8/T8)-T4_Ve_si_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_si)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_si)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_si/T8/T8/T8)-T4_Ve_si_Ve_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_si+1.0*qm_Ve_si_Ve_di)/qm/qm+2*1.0*qm_Ve_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_si+2.0*T8_Ve_si_Ve_di)/T8/T8+2*2.0*T8_Ve_si*T8_Ve_di/T8/T8/T8)-T4_Ve_si_Ve_di)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_si+1.0*qm_Ve_si_Vge_si)/qm/qm+2*1.0*qm_Ve_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_si+2.0*T8_Ve_si_Vge_si)/T8/T8+2*2.0*T8_Ve_si*T8_Vge_si/T8/T8/T8)-T4_Ve_si_Vge_si)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_si+1.0*qm_Ve_si_Tempt_GND)/qm/qm+2*1.0*qm_Ve_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_si+2.0*T8_Ve_si_Tempt_GND)/T8/T8+2*2.0*T8_Ve_si*T8_Tempt_GND/T8/T8/T8)-T4_Ve_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Ve_di=(((-qm_Ve_di/qm/qm)+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Ve_di+1.0*0.0)/qm/qm+2*1.0*qm_Ve_di*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_e)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_e/T8/T8/T8)-T4_Ve_di_Vge_e)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vdi_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vdi_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vdi_si/T8/T8/T8)-T4_Ve_di_Vdi_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_si)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_si)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_si/T8/T8/T8)-T4_Ve_di_Ve_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Ve_di+1.0*qm_Ve_di_Ve_di)/qm/qm+2*1.0*qm_Ve_di*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Ve_di+2.0*T8_Ve_di_Ve_di)/T8/T8+2*2.0*T8_Ve_di*T8_Ve_di/T8/T8/T8)-T4_Ve_di_Ve_di)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Ve_di+1.0*qm_Ve_di_Vge_si)/qm/qm+2*1.0*qm_Ve_di*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Ve_di+2.0*T8_Ve_di_Vge_si)/T8/T8+2*2.0*T8_Ve_di*T8_Vge_si/T8/T8/T8)-T4_Ve_di_Vge_si)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Ve_di_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Ve_di+1.0*qm_Ve_di_Tempt_GND)/qm/qm+2*1.0*qm_Ve_di*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Ve_di+2.0*T8_Ve_di_Tempt_GND)/T8/T8+2*2.0*T8_Ve_di*T8_Tempt_GND/T8/T8/T8)-T4_Ve_di_Tempt_GND)-0.0)*rc+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Vge_si=(((-qm_Vge_si/qm/qm)+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*rc)-(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Vge_si+1.0*0.0)/qm/qm+2*1.0*qm_Vge_si*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_e)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_e/T8/T8/T8)-T4_Vge_si_Vge_e)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*0.0+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vdi_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vdi_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vdi_si/T8/T8/T8)-T4_Vge_si_Vdi_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_si)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_si)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_si/T8/T8/T8)-T4_Vge_si_Ve_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Vge_si+1.0*qm_Vge_si_Ve_di)/qm/qm+2*1.0*qm_Vge_si*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Vge_si+2.0*T8_Vge_si_Ve_di)/T8/T8+2*2.0*T8_Vge_si*T8_Ve_di/T8/T8/T8)-T4_Vge_si_Ve_di)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Vge_si+1.0*qm_Vge_si_Vge_si)/qm/qm+2*1.0*qm_Vge_si*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Vge_si+2.0*T8_Vge_si_Vge_si)/T8/T8+2*2.0*T8_Vge_si*T8_Vge_si/T8/T8/T8)-T4_Vge_si_Vge_si)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Vge_si_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Vge_si+1.0*qm_Vge_si_Tempt_GND)/qm/qm+2*1.0*qm_Vge_si*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Vge_si+2.0*T8_Vge_si_Tempt_GND)/T8/T8+2*2.0*T8_Vge_si*T8_Tempt_GND/T8/T8/T8)-T4_Vge_si_Tempt_GND)-0.0)*rc+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/3.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
e1_Tempt_GND=(((-qm_Tempt_GND/qm/qm)+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*rc)-((((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/3.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+(+(+0.0+(0.0/qm-(0.0*0.0+0.0*qm_Tempt_GND+1.0*0.0)/qm/qm+2*1.0*qm_Tempt_GND*0.0/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_e+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_e)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_e/T8/T8/T8)-T4_Tempt_GND_Vge_e)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_e/T8/T8)-T4_Vge_e)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*0.0+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vdi_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vdi_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vdi_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vdi_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vdi_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vdi_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vdi_si/T8/T8/T8)-T4_Tempt_GND_Vdi_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vdi_si/T8/T8)-T4_Vdi_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_si/T8/T8/T8)-T4_Tempt_GND_Ve_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_si/T8/T8)-T4_Ve_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Ve_di=(+(+(+0.0+(0.0/qm-(0.0*qm_Ve_di+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Ve_di)/qm/qm+2*1.0*qm_Tempt_GND*qm_Ve_di/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Ve_di+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Ve_di)/T8/T8+2*2.0*T8_Tempt_GND*T8_Ve_di/T8/T8/T8)-T4_Tempt_GND_Ve_di)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Ve_di/T8/T8)-T4_Ve_di)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Vge_si=(+(+(+0.0+(0.0/qm-(0.0*qm_Vge_si+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Vge_si)/qm/qm+2*1.0*qm_Tempt_GND*qm_Vge_si/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Vge_si+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Vge_si)/T8/T8+2*2.0*T8_Tempt_GND*T8_Vge_si/T8/T8/T8)-T4_Tempt_GND_Vge_si)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Vge_si/T8/T8)-T4_Vge_si)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*0.0)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
  e1_Tempt_GND_Tempt_GND=(+(+(+0.0+(0.0/qm-(0.0*qm_Tempt_GND+0.0*qm_Tempt_GND+1.0*qm_Tempt_GND_Tempt_GND)/qm/qm+2*1.0*qm_Tempt_GND*qm_Tempt_GND/qm/qm/qm))+(+(+(+(0.0/T8-(0.0*T8_Tempt_GND+0.0*T8_Tempt_GND+2.0*T8_Tempt_GND_Tempt_GND)/T8/T8+2*2.0*T8_Tempt_GND*T8_Tempt_GND/T8/T8/T8)-T4_Tempt_GND_Tempt_GND)-0.0)*rc+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+((-2.0*T8_Tempt_GND/T8/T8)-T4_Tempt_GND)*0.0+(((2.0/T8)-T4)-1.0)*0.0))-(+(+(0.0/3.0-(0.0*0.0+0.0*0.0+2.0*0.0)/3.0/3.0+2*2.0*0.0*0.0/3.0/3.0/3.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/3.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/3.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/3.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/3.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e1=((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN(((((-1.0)+(1.0/qm))+((((2.0/T8)-T4)-1.0)*rc))-(((2.0/3.0)*QMFACTORCVfinal)*d00_pow0)))
}
{
double m00_pow(d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(-(qm+qdep)),((-4.0)/3.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
e2_Vdi_si=((-(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))));
#if defined(_DERIVATE2)
  e2_Vdi_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vdi_si*qm+qm_Vdi_si*qm_Vdi_si+qm_Vdi_si*qm_Vdi_si+qm*qm_Vdi_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_si*qm+qm_Vdi_si*qm_Ve_si+qm_Ve_si*qm_Vdi_si+qm*qm_Vdi_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Ve_di*qm+qm_Vdi_si*qm_Ve_di+qm_Ve_di*qm_Vdi_si+qm*qm_Vdi_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Vge_si*qm+qm_Vdi_si*qm_Vge_si+qm_Vge_si*qm_Vdi_si+qm*qm_Vdi_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vdi_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))+(-1.0)*(+qm_Vdi_si_Tempt_GND*qm+qm_Vdi_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vdi_si+qm*qm_Vdi_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vdi_si*qm)+(qm*qm_Vdi_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_si=((-(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_si))));
#if defined(_DERIVATE2)
  e2_Ve_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vdi_si*qm+qm_Ve_si*qm_Vdi_si+qm_Vdi_si*qm_Ve_si+qm*qm_Ve_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_si*qm+qm_Ve_si*qm_Ve_si+qm_Ve_si*qm_Ve_si+qm*qm_Ve_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Ve_di*qm+qm_Ve_si*qm_Ve_di+qm_Ve_di*qm_Ve_si+qm*qm_Ve_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Vge_si*qm+qm_Ve_si*qm_Vge_si+qm_Vge_si*qm_Ve_si+qm*qm_Ve_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_si*qm)+(qm*qm_Ve_si))+(-1.0)*(+qm_Ve_si_Tempt_GND*qm+qm_Ve_si*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_si+qm*qm_Ve_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_si*qm)+(qm*qm_Ve_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Ve_di=((-(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Ve_di))));
#if defined(_DERIVATE2)
  e2_Ve_di_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vdi_si*qm+qm_Ve_di*qm_Vdi_si+qm_Vdi_si*qm_Ve_di+qm*qm_Ve_di_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_si*qm+qm_Ve_di*qm_Ve_si+qm_Ve_si*qm_Ve_di+qm*qm_Ve_di_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Ve_di*qm+qm_Ve_di*qm_Ve_di+qm_Ve_di*qm_Ve_di+qm*qm_Ve_di_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Vge_si*qm+qm_Ve_di*qm_Vge_si+qm_Vge_si*qm_Ve_di+qm*qm_Ve_di_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Ve_di_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Ve_di*qm)+(qm*qm_Ve_di))+(-1.0)*(+qm_Ve_di_Tempt_GND*qm+qm_Ve_di*qm_Tempt_GND+qm_Tempt_GND*qm_Ve_di+qm*qm_Ve_di_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Ve_di*qm)+(qm*qm_Ve_di))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Ve_di))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Vge_si=((-(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))/(qm*qm)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-qm_Vge_si))));
#if defined(_DERIVATE2)
  e2_Vge_si_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vdi_si*qm+qm_Vge_si*qm_Vdi_si+qm_Vdi_si*qm_Vge_si+qm*qm_Vge_si_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_si*qm+qm_Vge_si*qm_Ve_si+qm_Ve_si*qm_Vge_si+qm*qm_Vge_si_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Ve_di*qm+qm_Vge_si*qm_Ve_di+qm_Ve_di*qm_Vge_si+qm*qm_Vge_si_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Vge_si*qm+qm_Vge_si*qm_Vge_si+qm_Vge_si*qm_Vge_si+qm*qm_Vge_si_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Vge_si_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Vge_si*qm)+(qm*qm_Vge_si))+(-1.0)*(+qm_Vge_si_Tempt_GND*qm+qm_Vge_si*qm_Tempt_GND+qm_Tempt_GND*qm_Vge_si+qm*qm_Vge_si_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Vge_si*qm)+(qm*qm_Vge_si))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*0.0+(2.0/9.0)*0.0)*d00_pow0+0.0*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-qm_Vge_si))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
e2_Tempt_GND=((-(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))/(qm*qm)/(qm*qm))-((((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*d00_pow0)+(((2.0/9.0)*QMFACTORCVfinal)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND))))));
#if defined(_DERIVATE2)
  e2_Tempt_GND_Vdi_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vdi_si*qm+qm_Tempt_GND*qm_Vdi_si+qm_Vdi_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vdi_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vdi_si*qm)+(qm*qm_Vdi_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Vdi_si+qdep_Vdi_si)))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_si=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_si*qm+qm_Tempt_GND*qm_Ve_si+qm_Ve_si*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_si*qm)+(qm*qm_Ve_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Ve_di=(+(0.0/(qm*qm)-(0.0*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Ve_di*qm+qm_Tempt_GND*qm_Ve_di+qm_Ve_di*qm_Tempt_GND+qm*qm_Tempt_GND_Ve_di))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Ve_di*qm)+(qm*qm_Ve_di)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Ve_di))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Vge_si=(+(0.0/(qm*qm)-(0.0*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Vge_si*qm+qm_Tempt_GND*qm_Vge_si+qm_Vge_si*qm_Tempt_GND+qm*qm_Tempt_GND_Vge_si))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Vge_si*qm)+(qm*qm_Vge_si)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*0.0+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*0.0)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-qm_Vge_si))+(0.0)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
  e2_Tempt_GND_Tempt_GND=(+(0.0/(qm*qm)-(0.0*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))+0.0*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))+(-1.0)*(+qm_Tempt_GND_Tempt_GND*qm+qm_Tempt_GND*qm_Tempt_GND+qm_Tempt_GND*qm_Tempt_GND+qm*qm_Tempt_GND_Tempt_GND))/(qm*qm)/(qm*qm)+2*(-1.0)*((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND))*(((qm_Tempt_GND*qm)+(qm*qm_Tempt_GND)))/(qm*qm)/(qm*qm)/(qm*qm))-(+(+(0.0/9.0-(0.0*0.0+0.0*0.0+2.0*0.0)/9.0/9.0+2*2.0*0.0*0.0/9.0/9.0/9.0)*QMFACTORCVfinal+0.0*QMFACTORCVfinal_Tempt_GND+0.0*QMFACTORCVfinal_Tempt_GND+(2.0/9.0)*QMFACTORCVfinal_Tempt_GND_Tempt_GND)*d00_pow0+((2.0/9.0)*QMFACTORCVfinal_Tempt_GND)*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+(((2.0/9.0)*QMFACTORCVfinal_Tempt_GND))*(d10_pow0*(-(qm_Tempt_GND+qdep_Tempt_GND)))+((2.0/9.0)*QMFACTORCVfinal)*fixme));
#endif
#endif
e2=(((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0));
EXIT_IF_ISNAN((((-1.0)/(qm*qm))-(((2.0/9.0)*QMFACTORCVfinal)*d00_pow0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(qm_Vdi_si-((((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+qm_Vdi_si_Vdi_si-(+(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vdi_si*e2+e0_Vdi_si*e2_Vdi_si+e0_Vdi_si*e2_Vdi_si+e0*e2_Vdi_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vdi_si)*e1+(2.0*e1_Vdi_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_si=(+qm_Vdi_si_Ve_si-(+(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_si*e2+e0_Vdi_si*e2_Ve_si+e0_Ve_si*e2_Vdi_si+e0*e2_Vdi_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_si)*e1+(2.0*e1_Vdi_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Ve_di=(+qm_Vdi_si_Ve_di-(+(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Ve_di*e2+e0_Vdi_si*e2_Ve_di+e0_Ve_di*e2_Vdi_si+e0*e2_Vdi_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Ve_di)*e1+(2.0*e1_Vdi_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Vge_si=(+qm_Vdi_si_Vge_si-(+(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Vge_si*e2+e0_Vdi_si*e2_Vge_si+e0_Vge_si*e2_Vdi_si+e0*e2_Vdi_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Vge_si)*e1+(2.0*e1_Vdi_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vdi_si_Tempt_GND=(+qm_Vdi_si_Tempt_GND-(+(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vdi_si_Tempt_GND*e2+e0_Vdi_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vdi_si+e0*e2_Vdi_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vdi_si*e2)+(e0*e2_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vdi_si+2.0*e1_Vdi_si_Tempt_GND)*e1+(2.0*e1_Vdi_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vdi_si+(2.0*e1)*e1_Vdi_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vdi_si)*e1)+((2.0*e1)*e1_Vdi_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_si=(qm_Ve_si-((((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+qm_Ve_si_Vdi_si-(+(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vdi_si*e2+e0_Ve_si*e2_Vdi_si+e0_Vdi_si*e2_Ve_si+e0*e2_Ve_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vdi_si)*e1+(2.0*e1_Ve_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_si=(+qm_Ve_si_Ve_si-(+(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_si*e2+e0_Ve_si*e2_Ve_si+e0_Ve_si*e2_Ve_si+e0*e2_Ve_si_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_si)*e1+(2.0*e1_Ve_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Ve_di=(+qm_Ve_si_Ve_di-(+(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Ve_di*e2+e0_Ve_si*e2_Ve_di+e0_Ve_di*e2_Ve_si+e0*e2_Ve_si_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_si+2.0*e1_Ve_si_Ve_di)*e1+(2.0*e1_Ve_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Vge_si=(+qm_Ve_si_Vge_si-(+(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Vge_si*e2+e0_Ve_si*e2_Vge_si+e0_Vge_si*e2_Ve_si+e0*e2_Ve_si_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_si+2.0*e1_Ve_si_Vge_si)*e1+(2.0*e1_Ve_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_si_Tempt_GND=(+qm_Ve_si_Tempt_GND-(+(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_si*e2)+(e0*e2_Ve_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_si_Tempt_GND*e2+e0_Ve_si*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_si+e0*e2_Ve_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_si*e2)+(e0*e2_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_si+2.0*e1_Ve_si_Tempt_GND)*e1+(2.0*e1_Ve_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_si+(2.0*e1)*e1_Ve_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_si)*e1)+((2.0*e1)*e1_Ve_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Ve_di=(qm_Ve_di-((((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+qm_Ve_di_Vdi_si-(+(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vdi_si*e2+e0_Ve_di*e2_Vdi_si+e0_Vdi_si*e2_Ve_di+e0*e2_Ve_di_Vdi_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vdi_si)*e1+(2.0*e1_Ve_di)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_si=(+qm_Ve_di_Ve_si-(+(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_si*e2+e0_Ve_di*e2_Ve_si+e0_Ve_si*e2_Ve_di+e0*e2_Ve_di_Ve_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_si)*e1+(2.0*e1_Ve_di)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Ve_di=(+qm_Ve_di_Ve_di-(+(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Ve_di*e2+e0_Ve_di*e2_Ve_di+e0_Ve_di*e2_Ve_di+e0*e2_Ve_di_Ve_di)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Ve_di+2.0*e1_Ve_di_Ve_di)*e1+(2.0*e1_Ve_di)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Vge_si=(+qm_Ve_di_Vge_si-(+(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Vge_si*e2+e0_Ve_di*e2_Vge_si+e0_Vge_si*e2_Ve_di+e0*e2_Ve_di_Vge_si)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Ve_di+2.0*e1_Ve_di_Vge_si)*e1+(2.0*e1_Ve_di)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Ve_di_Tempt_GND=(+qm_Ve_di_Tempt_GND-(+(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Ve_di*e2)+(e0*e2_Ve_di))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Ve_di_Tempt_GND*e2+e0_Ve_di*e2_Tempt_GND+e0_Tempt_GND*e2_Ve_di+e0*e2_Ve_di_Tempt_GND)/((2.0*e1)*e1)-(((e0_Ve_di*e2)+(e0*e2_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Ve_di+2.0*e1_Ve_di_Tempt_GND)*e1+(2.0*e1_Ve_di)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Ve_di+(2.0*e1)*e1_Ve_di_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Ve_di)*e1)+((2.0*e1)*e1_Ve_di))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Vge_si=(qm_Vge_si-((((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+qm_Vge_si_Vdi_si-(+(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vdi_si*e2+e0_Vge_si*e2_Vdi_si+e0_Vdi_si*e2_Vge_si+e0*e2_Vge_si_Vdi_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vdi_si)*e1+(2.0*e1_Vge_si)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_si=(+qm_Vge_si_Ve_si-(+(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_si*e2+e0_Vge_si*e2_Ve_si+e0_Ve_si*e2_Vge_si+e0*e2_Vge_si_Ve_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_si)*e1+(2.0*e1_Vge_si)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Ve_di=(+qm_Vge_si_Ve_di-(+(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Ve_di*e2+e0_Vge_si*e2_Ve_di+e0_Ve_di*e2_Vge_si+e0*e2_Vge_si_Ve_di)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Vge_si+2.0*e1_Vge_si_Ve_di)*e1+(2.0*e1_Vge_si)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Vge_si=(+qm_Vge_si_Vge_si-(+(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Vge_si*e2+e0_Vge_si*e2_Vge_si+e0_Vge_si*e2_Vge_si+e0*e2_Vge_si_Vge_si)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Vge_si+2.0*e1_Vge_si_Vge_si)*e1+(2.0*e1_Vge_si)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Vge_si_Tempt_GND=(+qm_Vge_si_Tempt_GND-(+(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Vge_si*e2)+(e0*e2_Vge_si))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Vge_si_Tempt_GND*e2+e0_Vge_si*e2_Tempt_GND+e0_Tempt_GND*e2_Vge_si+e0*e2_Vge_si_Tempt_GND)/((2.0*e1)*e1)-(((e0_Vge_si*e2)+(e0*e2_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Vge_si+2.0*e1_Vge_si_Tempt_GND)*e1+(2.0*e1_Vge_si)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Vge_si+(2.0*e1)*e1_Vge_si_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Vge_si)*e1)+((2.0*e1)*e1_Vge_si))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
qm_Tempt_GND=(qm_Tempt_GND-((((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))+((e0/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+qm_Tempt_GND_Vdi_si-(+(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vdi_si*e2+e0_Tempt_GND*e2_Vdi_si+e0_Vdi_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vdi_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))+(((e0_Vdi_si*e2)+(e0*e2_Vdi_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vdi_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vdi_si)*e1+(2.0*e1_Tempt_GND)*e1_Vdi_si+((2.0*e1_Vdi_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vdi_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vdi_si))*e1)+((2.0*e1)*e1_Vdi_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_si=(+qm_Tempt_GND_Ve_si-(+(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_si*e2)+(e0*e2_Ve_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_si*e2+e0_Tempt_GND*e2_Ve_si+e0_Ve_si*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))+(((e0_Ve_si*e2)+(e0*e2_Ve_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_si)*e1+(2.0*e1_Tempt_GND)*e1_Ve_si+((2.0*e1_Ve_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_si))*e1)+((2.0*e1)*e1_Ve_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Ve_di=(+qm_Tempt_GND_Ve_di-(+(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Ve_di*e2)+(e0*e2_Ve_di)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Ve_di*e2+e0_Tempt_GND*e2_Ve_di+e0_Ve_di*e2_Tempt_GND+e0*e2_Tempt_GND_Ve_di)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))+(((e0_Ve_di*e2)+(e0*e2_Ve_di)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Ve_di+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Ve_di)*e1+(2.0*e1_Tempt_GND)*e1_Ve_di+((2.0*e1_Ve_di))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Ve_di))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Ve_di))*e1)+((2.0*e1)*e1_Ve_di)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Vge_si=(+qm_Tempt_GND_Vge_si-(+(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Vge_si*e2)+(e0*e2_Vge_si)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Vge_si*e2+e0_Tempt_GND*e2_Vge_si+e0_Vge_si*e2_Tempt_GND+e0*e2_Tempt_GND_Vge_si)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))+(((e0_Vge_si*e2)+(e0*e2_Vge_si)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Vge_si+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Vge_si)*e1+(2.0*e1_Tempt_GND)*e1_Vge_si+((2.0*e1_Vge_si))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Vge_si))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Vge_si))*e1)+((2.0*e1)*e1_Vge_si)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
  qm_Tempt_GND_Tempt_GND=(+qm_Tempt_GND_Tempt_GND-(+(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*(((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*((2.0*e1)*e1)-(e0*e2)*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND))))/((2.0*e1)*e1)/((2.0*e1)*e1))+((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1)*((((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*((2.0*e1)*e1)-(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1))+(e0/e1)*(+0.0+((+e0_Tempt_GND_Tempt_GND*e2+e0_Tempt_GND*e2_Tempt_GND+e0_Tempt_GND*e2_Tempt_GND+e0*e2_Tempt_GND_Tempt_GND)/((2.0*e1)*e1)-(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))+(((e0_Tempt_GND*e2)+(e0*e2_Tempt_GND)))*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))+(e0*e2)*(+(+0.0*e1+0.0*e1_Tempt_GND+0.0*e1_Tempt_GND+2.0*e1_Tempt_GND_Tempt_GND)*e1+(2.0*e1_Tempt_GND)*e1_Tempt_GND+((2.0*e1_Tempt_GND))*e1_Tempt_GND+(2.0*e1)*e1_Tempt_GND_Tempt_GND))/((2.0*e1)*e1)/((2.0*e1)*e1)+2*(e0*e2)*(((2.0*e1_Tempt_GND)*e1)+((2.0*e1)*e1_Tempt_GND))*(((((2.0*e1_Tempt_GND))*e1)+((2.0*e1)*e1_Tempt_GND)))/((2.0*e1)*e1)/((2.0*e1)*e1)/((2.0*e1)*e1)))));
#endif
#endif
qm=(qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1)))));
EXIT_IF_ISNAN((qm-((e0/e1)*(1.0+((e0*e2)/((2.0*e1)*e1))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qm_Vdi_si=(((-qm_Vdi_si)*qm)+((-qm)*qm_Vdi_si));
#if defined(_DERIVATE2)
  qm_Vdi_si_Vdi_si=(+0.0*qm+(-qm_Vdi_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Vdi_si);
  qm_Vdi_si_Ve_si=(+0.0*qm+(-qm_Vdi_si)*qm_Ve_si+(-qm_Ve_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Ve_si);
  qm_Vdi_si_Ve_di=(+0.0*qm+(-qm_Vdi_si)*qm_Ve_di+(-qm_Ve_di)*qm_Vdi_si+(-qm)*qm_Vdi_si_Ve_di);
  qm_Vdi_si_Vge_si=(+0.0*qm+(-qm_Vdi_si)*qm_Vge_si+(-qm_Vge_si)*qm_Vdi_si+(-qm)*qm_Vdi_si_Vge_si);
  qm_Vdi_si_Tempt_GND=(+0.0*qm+(-qm_Vdi_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Vdi_si+(-qm)*qm_Vdi_si_Tempt_GND);
#endif
qm_Ve_si=(((-qm_Ve_si)*qm)+((-qm)*qm_Ve_si));
#if defined(_DERIVATE2)
  qm_Ve_si_Vdi_si=(+0.0*qm+(-qm_Ve_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Ve_si+(-qm)*qm_Ve_si_Vdi_si);
  qm_Ve_si_Ve_si=(+0.0*qm+(-qm_Ve_si)*qm_Ve_si+(-qm_Ve_si)*qm_Ve_si+(-qm)*qm_Ve_si_Ve_si);
  qm_Ve_si_Ve_di=(+0.0*qm+(-qm_Ve_si)*qm_Ve_di+(-qm_Ve_di)*qm_Ve_si+(-qm)*qm_Ve_si_Ve_di);
  qm_Ve_si_Vge_si=(+0.0*qm+(-qm_Ve_si)*qm_Vge_si+(-qm_Vge_si)*qm_Ve_si+(-qm)*qm_Ve_si_Vge_si);
  qm_Ve_si_Tempt_GND=(+0.0*qm+(-qm_Ve_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Ve_si+(-qm)*qm_Ve_si_Tempt_GND);
#endif
qm_Ve_di=(((-qm_Ve_di)*qm)+((-qm)*qm_Ve_di));
#if defined(_DERIVATE2)
  qm_Ve_di_Vdi_si=(+0.0*qm+(-qm_Ve_di)*qm_Vdi_si+(-qm_Vdi_si)*qm_Ve_di+(-qm)*qm_Ve_di_Vdi_si);
  qm_Ve_di_Ve_si=(+0.0*qm+(-qm_Ve_di)*qm_Ve_si+(-qm_Ve_si)*qm_Ve_di+(-qm)*qm_Ve_di_Ve_si);
  qm_Ve_di_Ve_di=(+0.0*qm+(-qm_Ve_di)*qm_Ve_di+(-qm_Ve_di)*qm_Ve_di+(-qm)*qm_Ve_di_Ve_di);
  qm_Ve_di_Vge_si=(+0.0*qm+(-qm_Ve_di)*qm_Vge_si+(-qm_Vge_si)*qm_Ve_di+(-qm)*qm_Ve_di_Vge_si);
  qm_Ve_di_Tempt_GND=(+0.0*qm+(-qm_Ve_di)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Ve_di+(-qm)*qm_Ve_di_Tempt_GND);
#endif
qm_Vge_si=(((-qm_Vge_si)*qm)+((-qm)*qm_Vge_si));
#if defined(_DERIVATE2)
  qm_Vge_si_Vdi_si=(+0.0*qm+(-qm_Vge_si)*qm_Vdi_si+(-qm_Vdi_si)*qm_Vge_si+(-qm)*qm_Vge_si_Vdi_si);
  qm_Vge_si_Ve_si=(+0.0*qm+(-qm_Vge_si)*qm_Ve_si+(-qm_Ve_si)*qm_Vge_si+(-qm)*qm_Vge_si_Ve_si);
  qm_Vge_si_Ve_di=(+0.0*qm+(-qm_Vge_si)*qm_Ve_di+(-qm_Ve_di)*qm_Vge_si+(-qm)*qm_Vge_si_Ve_di);
  qm_Vge_si_Vge_si=(+0.0*qm+(-qm_Vge_si)*qm_Vge_si+(-qm_Vge_si)*qm_Vge_si+(-qm)*qm_Vge_si_Vge_si);
  qm_Vge_si_Tempt_GND=(+0.0*qm+(-qm_Vge_si)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Vge_si+(-qm)*qm_Vge_si_Tempt_GND);
#endif
qm_Tempt_GND=(((-qm_Tempt_GND)*qm)+((-qm)*qm_Tempt_GND));
#if defined(_DERIVATE2)
  qm_Tempt_GND_Vdi_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Vdi_si+(-qm_Vdi_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Vdi_si);
  qm_Tempt_GND_Ve_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Ve_si+(-qm_Ve_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Ve_si);
  qm_Tempt_GND_Ve_di=(+0.0*qm+(-qm_Tempt_GND)*qm_Ve_di+(-qm_Ve_di)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Ve_di);
  qm_Tempt_GND_Vge_si=(+0.0*qm+(-qm_Tempt_GND)*qm_Vge_si+(-qm_Vge_si)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Vge_si);
  qm_Tempt_GND_Tempt_GND=(+0.0*qm+(-qm_Tempt_GND)*qm_Tempt_GND+(-qm_Tempt_GND)*qm_Tempt_GND+(-qm)*qm_Tempt_GND_Tempt_GND);
#endif
#endif
qm=((-qm)*qm);
EXIT_IF_ISNAN(((-qm)*qm))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
qid_Vdi_si=(((-qm_Vdi_si)*nVtm)+((-qm)*nVtm_Vdi_si));
#if defined(_DERIVATE2)
  qid_Vdi_si_Vdi_si=(+0.0*nVtm+(-qm_Vdi_si)*nVtm_Vdi_si+(-qm_Vdi_si)*nVtm_Vdi_si+(-qm)*nVtm_Vdi_si_Vdi_si);
  qid_Vdi_si_Ve_si=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Ve_si)*nVtm_Vdi_si+(-qm)*0.0);
  qid_Vdi_si_Ve_di=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Ve_di)*nVtm_Vdi_si+(-qm)*0.0);
  qid_Vdi_si_Vge_si=(+0.0*nVtm+(-qm_Vdi_si)*0.0+(-qm_Vge_si)*nVtm_Vdi_si+(-qm)*0.0);
  qid_Vdi_si_Tempt_GND=(+0.0*nVtm+(-qm_Vdi_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*nVtm_Vdi_si+(-qm)*nVtm_Vdi_si_Tempt_GND);
#endif
qid_Ve_si=(-qm_Ve_si)*nVtm;
#if defined(_DERIVATE2)
  qid_Ve_si_Vdi_si=(+0.0*nVtm+(-qm_Ve_si)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qid_Ve_si_Ve_si=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qid_Ve_si_Ve_di=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qid_Ve_si_Vge_si=(+0.0*nVtm+(-qm_Ve_si)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qid_Ve_si_Tempt_GND=(+0.0*nVtm+(-qm_Ve_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qid_Ve_di=(-qm_Ve_di)*nVtm;
#if defined(_DERIVATE2)
  qid_Ve_di_Vdi_si=(+0.0*nVtm+(-qm_Ve_di)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qid_Ve_di_Ve_si=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qid_Ve_di_Ve_di=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qid_Ve_di_Vge_si=(+0.0*nVtm+(-qm_Ve_di)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qid_Ve_di_Tempt_GND=(+0.0*nVtm+(-qm_Ve_di)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qid_Vge_si=(-qm_Vge_si)*nVtm;
#if defined(_DERIVATE2)
  qid_Vge_si_Vdi_si=(+0.0*nVtm+(-qm_Vge_si)*nVtm_Vdi_si+(-qm_Vdi_si)*0.0+(-qm)*0.0);
  qid_Vge_si_Ve_si=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Ve_si)*0.0+(-qm)*0.0);
  qid_Vge_si_Ve_di=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Ve_di)*0.0+(-qm)*0.0);
  qid_Vge_si_Vge_si=(+0.0*nVtm+(-qm_Vge_si)*0.0+(-qm_Vge_si)*0.0+(-qm)*0.0);
  qid_Vge_si_Tempt_GND=(+0.0*nVtm+(-qm_Vge_si)*nVtm_Tempt_GND+(-qm_Tempt_GND)*0.0+(-qm)*0.0);
#endif
qid_Tempt_GND=(((-qm_Tempt_GND)*nVtm)+((-qm)*nVtm_Tempt_GND));
#if defined(_DERIVATE2)
  qid_Tempt_GND_Vdi_si=(+0.0*nVtm+(-qm_Tempt_GND)*nVtm_Vdi_si+(-qm_Vdi_si)*nVtm_Tempt_GND+(-qm)*nVtm_Tempt_GND_Vdi_si);
  qid_Tempt_GND_Ve_si=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Ve_si)*nVtm_Tempt_GND+(-qm)*0.0);
  qid_Tempt_GND_Ve_di=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Ve_di)*nVtm_Tempt_GND+(-qm)*0.0);
  qid_Tempt_GND_Vge_si=(+0.0*nVtm+(-qm_Tempt_GND)*0.0+(-qm_Vge_si)*nVtm_Tempt_GND+(-qm)*0.0);
  qid_Tempt_GND_Tempt_GND=(+0.0*nVtm+(-qm_Tempt_GND)*nVtm_Tempt_GND+(-qm_Tempt_GND)*nVtm_Tempt_GND+(-qm)*nVtm_Tempt_GND_Tempt_GND);
#endif
#endif
qid=((-qm)*nVtm);
EXIT_IF_ISNAN(((-qm)*nVtm))
if
((pModel->BULKMOD!=0))
{
{
double m00_sqrt(d00_sqrt0,Vtm)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,Vtm)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T9_Vge_di=0.0;
#if defined(_DERIVATE2)
  T9_Vge_di_Vge_di=0.0;
  T9_Vge_di_Vdi_d=0.0;
  T9_Vge_di_Vsi_s=0.0;
  T9_Vge_di_Vge_e=0.0;
  T9_Vge_di_Ve_si=0.0;
  T9_Vge_di_Ve_di=0.0;
  T9_Vge_di_Vge_si=0.0;
  T9_Vge_di_Tempt_GND=0.0;
  T9_Vge_di_Vdi_si=0.0;
#endif
T9_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T9_Vdi_d_Vge_di=0.0;
  T9_Vdi_d_Vdi_d=0.0;
  T9_Vdi_d_Vsi_s=0.0;
  T9_Vdi_d_Vge_e=0.0;
  T9_Vdi_d_Ve_si=0.0;
  T9_Vdi_d_Ve_di=0.0;
  T9_Vdi_d_Vge_si=0.0;
  T9_Vdi_d_Tempt_GND=0.0;
  T9_Vdi_d_Vdi_si=0.0;
#endif
T9_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T9_Vsi_s_Vge_di=0.0;
  T9_Vsi_s_Vdi_d=0.0;
  T9_Vsi_s_Vsi_s=0.0;
  T9_Vsi_s_Vge_e=0.0;
  T9_Vsi_s_Ve_si=0.0;
  T9_Vsi_s_Ve_di=0.0;
  T9_Vsi_s_Vge_si=0.0;
  T9_Vsi_s_Tempt_GND=0.0;
  T9_Vsi_s_Vdi_si=0.0;
#endif
T9_Vge_e=0.0;
#if defined(_DERIVATE2)
  T9_Vge_e_Vge_di=0.0;
  T9_Vge_e_Vdi_d=0.0;
  T9_Vge_e_Vsi_s=0.0;
  T9_Vge_e_Vge_e=0.0;
  T9_Vge_e_Ve_si=0.0;
  T9_Vge_e_Ve_di=0.0;
  T9_Vge_e_Vge_si=0.0;
  T9_Vge_e_Tempt_GND=0.0;
  T9_Vge_e_Vdi_si=0.0;
#endif
T9_Ve_si=0.0;
#if defined(_DERIVATE2)
  T9_Ve_si_Vge_di=0.0;
  T9_Ve_si_Vdi_d=0.0;
  T9_Ve_si_Vsi_s=0.0;
  T9_Ve_si_Vge_e=0.0;
  T9_Ve_si_Ve_si=0.0;
  T9_Ve_si_Ve_di=0.0;
  T9_Ve_si_Vge_si=0.0;
  T9_Ve_si_Tempt_GND=0.0;
  T9_Ve_si_Vdi_si=0.0;
#endif
T9_Ve_di=0.0;
#if defined(_DERIVATE2)
  T9_Ve_di_Vge_di=0.0;
  T9_Ve_di_Vdi_d=0.0;
  T9_Ve_di_Vsi_s=0.0;
  T9_Ve_di_Vge_e=0.0;
  T9_Ve_di_Ve_si=0.0;
  T9_Ve_di_Ve_di=0.0;
  T9_Ve_di_Vge_si=0.0;
  T9_Ve_di_Tempt_GND=0.0;
  T9_Ve_di_Vdi_si=0.0;
#endif
T9_Vge_si=0.0;
#if defined(_DERIVATE2)
  T9_Vge_si_Vge_di=0.0;
  T9_Vge_si_Vdi_d=0.0;
  T9_Vge_si_Vsi_s=0.0;
  T9_Vge_si_Vge_e=0.0;
  T9_Vge_si_Ve_si=0.0;
  T9_Vge_si_Ve_di=0.0;
  T9_Vge_si_Vge_si=0.0;
  T9_Vge_si_Tempt_GND=0.0;
  T9_Vge_si_Vdi_si=0.0;
#endif
T9_Tempt_GND=((((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0)+((K1_t/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0));
#if defined(_DERIVATE2)
  T9_Tempt_GND_Vge_di=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Vdi_d=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Vsi_s=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Vge_e=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Ve_si=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Ve_di=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Vge_si=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*(0.0)+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
  T9_Tempt_GND_Tempt_GND=(+(K1_t_Tempt_GND_Tempt_GND/(2.0*nVtm)-(K1_t_Tempt_GND*((2.0*nVtm_Tempt_GND))+K1_t_Tempt_GND*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*(m20_sqrt(Vtm)*Vtm_Tempt_GND*Vtm_Tempt_GND+d10_sqrt0*Vtm_Tempt_GND_Tempt_GND));
  T9_Tempt_GND_Vdi_si=(+(0.0/(2.0*nVtm)-(K1_t_Tempt_GND*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Tempt_GND)+K1_t*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Tempt_GND)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*(2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+(K1_t/(2.0*nVtm))*0.0);
#endif
T9_Vdi_si=(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0;
#if defined(_DERIVATE2)
  T9_Vdi_si_Vge_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Vdi_d=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Vsi_s=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Vge_e=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Ve_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Ve_di=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Vge_si=(+(0.0/(2.0*nVtm)-(0.0*(0.0)+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*(0.0)/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*(0.0)/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Tempt_GND=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Tempt_GND))+K1_t_Tempt_GND*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Tempt_GND))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*Vtm_Tempt_GND*d10_sqrt0+((K1_t_Tempt_GND*(2.0*nVtm)-K1_t*((2.0*nVtm_Tempt_GND)))/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
  T9_Vdi_si_Vdi_si=(+(0.0/(2.0*nVtm)-(0.0*((2.0*nVtm_Vdi_si))+0.0*(2.0*nVtm_Vdi_si)+K1_t*(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)+2*K1_t*(2.0*nVtm_Vdi_si)*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm)/(2.0*nVtm))*d00_sqrt0+(-K1_t*(2.0*nVtm_Vdi_si)/(2.0*nVtm)/(2.0*nVtm))*0.0+(-K1_t*((2.0*nVtm_Vdi_si))/(2.0*nVtm)/(2.0*nVtm))*0.0+(K1_t/(2.0*nVtm))*0.0);
#endif
#endif
T9=((K1_t/(2.0*nVtm))*d00_sqrt0);
EXIT_IF_ISNAN(((K1_t/(2.0*nVtm))*d00_sqrt0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=(T9_Vdi_si/2.0);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(T9_Vdi_si_Vge_di/2.0-(T9_Vdi_si*0.0+T9_Vge_di*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Vge_e=(T9_Vdi_si_Vge_e/2.0-(T9_Vdi_si*0.0+T9_Vge_e*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Ve_si=(T9_Vdi_si_Ve_si/2.0-(T9_Vdi_si*0.0+T9_Ve_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Ve_di=(T9_Vdi_si_Ve_di/2.0-(T9_Vdi_si*0.0+T9_Ve_di*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Vge_si=(T9_Vdi_si_Vge_si/2.0-(T9_Vdi_si*0.0+T9_Vge_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Vdi_si=(T9_Vdi_si_Vdi_si/2.0-(T9_Vdi_si*0.0+T9_Vdi_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Vdi_si_Tempt_GND=(T9_Vdi_si_Tempt_GND/2.0-(T9_Vdi_si*0.0+T9_Tempt_GND*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
#endif
T0_Tempt_GND=(T9_Tempt_GND/2.0);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(T9_Tempt_GND_Vge_di/2.0-(T9_Tempt_GND*0.0+T9_Vge_di*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Vge_e=(T9_Tempt_GND_Vge_e/2.0-(T9_Tempt_GND*0.0+T9_Vge_e*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Ve_si=(T9_Tempt_GND_Ve_si/2.0-(T9_Tempt_GND*0.0+T9_Ve_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Ve_di=(T9_Tempt_GND_Ve_di/2.0-(T9_Tempt_GND*0.0+T9_Ve_di*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Vge_si=(T9_Tempt_GND_Vge_si/2.0-(T9_Tempt_GND*0.0+T9_Vge_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Vdi_si=(T9_Tempt_GND_Vdi_si/2.0-(T9_Tempt_GND*0.0+T9_Vdi_si*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
  T0_Tempt_GND_Tempt_GND=(T9_Tempt_GND_Tempt_GND/2.0-(T9_Tempt_GND*0.0+T9_Tempt_GND*0.0+T9*0.0)/2.0/2.0+2*T9*0.0*0.0/2.0/2.0/2.0);
#endif
#endif
T0=(T9/2.0);
EXIT_IF_ISNAN((T9/2.0))
{
double m00_logE(d00_logE0,(pModel->NBODY/Nc))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,(pModel->NBODY/Nc))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=(vge_Vge_e/Vtm);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Vsi_s=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Vge_di=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Vge_e=((+vge_Vge_e_Vge_e-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(vge_Vge_e-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Vge_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Ve_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Ve_di=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Vdi_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*0.0+0.0*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*0.0+(-(-(0.0)))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*0.0/Vtm/Vtm/Vtm);
  T2_Vge_e_Tempt_GND=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm_Tempt_GND*0.0+Vtm*0.0))+0.0))/Vtm-(vge_Vge_e*Vtm_Tempt_GND+(-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-(((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0)))))*0.0+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*Vtm-(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND)/Vtm/Vtm);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Vsi_s=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Vge_di=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Vge_e=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(vge_Vge_e-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Vge_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Ve_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Ve_di=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Vdi_si=((+0.0-(+(+(+0.0-0.0)-(+0.0*d00_logE0+Vtm_Tempt_GND*0.0+0.0*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*0.0))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*0.0+(-(-(0.0)))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*0.0)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T2_Tempt_GND_Tempt_GND=((+0.0-(+(+(+deltaPhi_Tempt_GND_Tempt_GND-Eg_Tempt_GND_Tempt_GND)-(+Vtm_Tempt_GND_Tempt_GND*d00_logE0+Vtm_Tempt_GND*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm_Tempt_GND*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0+Vtm*(m20_logE((pModel->NBODY/Nc))*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)+d10_logE0*(0.0/Nc-(0.0*Nc_Tempt_GND+0.0*Nc_Tempt_GND+pModel->NBODY*Nc_Tempt_GND_Tempt_GND)/Nc/Nc+2*pModel->NBODY*Nc_Tempt_GND*Nc_Tempt_GND/Nc/Nc/Nc))))+0.0))/Vtm-((-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0))))*Vtm_Tempt_GND+(-((deltaPhi_Tempt_GND-Eg_Tempt_GND)-(((Vtm_Tempt_GND*d00_logE0)+(Vtm*(-pModel->NBODY*Nc_Tempt_GND/Nc/Nc)*d10_logE0)))))*Vtm_Tempt_GND+(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*(vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
#endif
T2=((vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))/Vtm);
EXIT_IF_ISNAN(((vge-(((deltaPhi-Eg)-(Vtm*d00_logE0))+pModel->DELVFBACC))/Vtm))
}
{
double m00_sqrt(d00_sqrt0,(phib*Vtm))
if
(((T2*Vtm)>(phib+(T9*d00_sqrt0))))
{
{
double m00_sqrt(d00_sqrt0,((T2-1.0)+(T0*T0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2-1.0)+(T0*T0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=((T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))*d10_sqrt0-T0_Vge_e);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vdi_d-0.0)+(+0.0*T0+T0_Vge_e*0.0+0.0*T0_Vge_e+T0*0.0)))-0.0);
  T1_Vge_e_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vsi_s-0.0)+(+0.0*T0+T0_Vge_e*0.0+0.0*T0_Vge_e+T0*0.0)))-0.0);
  T1_Vge_e_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vge_di-0.0)+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)))-T0_Vge_e_Vge_di);
  T1_Vge_e_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vge_e-0.0)+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)))-T0_Vge_e_Vge_e);
  T1_Vge_e_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Ve_si-0.0)+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)))-T0_Vge_e_Ve_si);
  T1_Vge_e_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Ve_di-0.0)+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)))-T0_Vge_e_Ve_di);
  T1_Vge_e_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vge_si-0.0)+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)))-T0_Vge_e_Vge_si);
  T1_Vge_e_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Vdi_si-0.0)+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)))-T0_Vge_e_Vdi_si);
  T1_Vge_e_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+T2_Vge_e_Tempt_GND-0.0)+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)))-T0_Vge_e_Tempt_GND);
#endif
T1_Ve_si=((T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))*d10_sqrt0-T0_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vdi_d-0.0)+(+0.0*T0+T0_Ve_si*0.0+0.0*T0_Ve_si+T0*0.0)))-0.0);
  T1_Ve_si_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vsi_s-0.0)+(+0.0*T0+T0_Ve_si*0.0+0.0*T0_Ve_si+T0*0.0)))-0.0);
  T1_Ve_si_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vge_di-0.0)+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)))-T0_Ve_si_Vge_di);
  T1_Ve_si_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vge_e-0.0)+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)))-T0_Ve_si_Vge_e);
  T1_Ve_si_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Ve_si-0.0)+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)))-T0_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Ve_di-0.0)+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)))-T0_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vge_si-0.0)+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)))-T0_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Vdi_si-0.0)+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)))-T0_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+T2_Ve_si_Tempt_GND-0.0)+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)))-T0_Ve_si_Tempt_GND);
#endif
T1_Ve_di=((T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))*d10_sqrt0-T0_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vdi_d-0.0)+(+0.0*T0+T0_Ve_di*0.0+0.0*T0_Ve_di+T0*0.0)))-0.0);
  T1_Ve_di_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vsi_s-0.0)+(+0.0*T0+T0_Ve_di*0.0+0.0*T0_Ve_di+T0*0.0)))-0.0);
  T1_Ve_di_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vge_di-0.0)+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)))-T0_Ve_di_Vge_di);
  T1_Ve_di_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vge_e-0.0)+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)))-T0_Ve_di_Vge_e);
  T1_Ve_di_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Ve_si-0.0)+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)))-T0_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Ve_di-0.0)+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)))-T0_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vge_si-0.0)+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)))-T0_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Vdi_si-0.0)+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)))-T0_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+T2_Ve_di_Tempt_GND-0.0)+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)))-T0_Ve_di_Tempt_GND);
#endif
T1_Vge_si=((T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))*d10_sqrt0-T0_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vdi_d-0.0)+(+0.0*T0+T0_Vge_si*0.0+0.0*T0_Vge_si+T0*0.0)))-0.0);
  T1_Vge_si_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vsi_s-0.0)+(+0.0*T0+T0_Vge_si*0.0+0.0*T0_Vge_si+T0*0.0)))-0.0);
  T1_Vge_si_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vge_di-0.0)+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)))-T0_Vge_si_Vge_di);
  T1_Vge_si_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vge_e-0.0)+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)))-T0_Vge_si_Vge_e);
  T1_Vge_si_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Ve_si-0.0)+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)))-T0_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Ve_di-0.0)+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)))-T0_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vge_si-0.0)+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)))-T0_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Vdi_si-0.0)+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)))-T0_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+T2_Vge_si_Tempt_GND-0.0)+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)))-T0_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=((T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*d10_sqrt0-T0_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_d-0.0)+(+0.0*T0+T0_Vdi_si*0.0+0.0*T0_Vdi_si+T0*0.0)))-0.0);
  T1_Vdi_si_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vsi_s-0.0)+(+0.0*T0+T0_Vdi_si*0.0+0.0*T0_Vdi_si+T0*0.0)))-0.0);
  T1_Vdi_si_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vge_di-0.0)+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)))-T0_Vdi_si_Vge_di);
  T1_Vdi_si_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vge_e-0.0)+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)))-T0_Vdi_si_Vge_e);
  T1_Vdi_si_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Ve_si-0.0)+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)))-T0_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Ve_di-0.0)+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)))-T0_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vge_si-0.0)+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)))-T0_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_si-0.0)+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)))-T0_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+T2_Vdi_si_Tempt_GND-0.0)+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)))-T0_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=((T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*d10_sqrt0-T0_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_d+(0.0))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_d-0.0)+(+0.0*T0+T0_Tempt_GND*0.0+0.0*T0_Tempt_GND+T0*0.0)))-0.0);
  T1_Tempt_GND_Vsi_s=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vsi_s+(0.0))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vsi_s-0.0)+(+0.0*T0+T0_Tempt_GND*0.0+0.0*T0_Tempt_GND+T0*0.0)))-0.0);
  T1_Tempt_GND_Vge_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_di-0.0)+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)))-T0_Tempt_GND_Vge_di);
  T1_Tempt_GND_Vge_e=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_e+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_e-0.0)+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)))-T0_Tempt_GND_Vge_e);
  T1_Tempt_GND_Ve_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_si+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_si-0.0)+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)))-T0_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Ve_di+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_di-0.0)+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)))-T0_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vge_si+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_si-0.0)+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)))-T0_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Vdi_si+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_si-0.0)+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)))-T0_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(m20_sqrt(((T2-1.0)+(T0*T0)))*(T2_Tempt_GND+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*(T2_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+T2_Tempt_GND_Tempt_GND-0.0)+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)))-T0_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(d00_sqrt0-T0);
EXIT_IF_ISNAN((d00_sqrt0-T0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=0.0;
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=0.0;
  T10_Vge_di_Vge_e=0.0;
  T10_Vge_di_Ve_si=0.0;
  T10_Vge_di_Ve_di=0.0;
  T10_Vge_di_Vge_si=0.0;
  T10_Vge_di_Vdi_si=0.0;
  T10_Vge_di_Tempt_GND=0.0;
#endif
T10_Vge_e=((T1_Vge_e*T1)+(T1*T1_Vge_e));
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+0.0+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di));
  T10_Vge_e_Vge_e=(+0.0+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e));
  T10_Vge_e_Ve_si=(+0.0+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si));
  T10_Vge_e_Ve_di=(+0.0+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di));
  T10_Vge_e_Vge_si=(+0.0+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si));
  T10_Vge_e_Vdi_si=(+0.0+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si));
  T10_Vge_e_Tempt_GND=(+0.0+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND));
#endif
T10_Ve_si=((T1_Ve_si*T1)+(T1*T1_Ve_si));
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+0.0+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di));
  T10_Ve_si_Vge_e=(+0.0+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e));
  T10_Ve_si_Ve_si=(+0.0+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si));
  T10_Ve_si_Ve_di=(+0.0+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di));
  T10_Ve_si_Vge_si=(+0.0+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si));
  T10_Ve_si_Vdi_si=(+0.0+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si));
  T10_Ve_si_Tempt_GND=(+0.0+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND));
#endif
T10_Ve_di=((T1_Ve_di*T1)+(T1*T1_Ve_di));
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+0.0+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di));
  T10_Ve_di_Vge_e=(+0.0+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e));
  T10_Ve_di_Ve_si=(+0.0+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si));
  T10_Ve_di_Ve_di=(+0.0+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di));
  T10_Ve_di_Vge_si=(+0.0+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si));
  T10_Ve_di_Vdi_si=(+0.0+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si));
  T10_Ve_di_Tempt_GND=(+0.0+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND));
#endif
T10_Vge_si=((T1_Vge_si*T1)+(T1*T1_Vge_si));
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+0.0+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di));
  T10_Vge_si_Vge_e=(+0.0+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e));
  T10_Vge_si_Ve_si=(+0.0+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si));
  T10_Vge_si_Ve_di=(+0.0+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di));
  T10_Vge_si_Vge_si=(+0.0+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si));
  T10_Vge_si_Vdi_si=(+0.0+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si));
  T10_Vge_si_Tempt_GND=(+0.0+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND));
#endif
T10_Vdi_si=((T1_Vdi_si*T1)+(T1*T1_Vdi_si));
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+0.0+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di));
  T10_Vdi_si_Vge_e=(+0.0+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e));
  T10_Vdi_si_Ve_si=(+0.0+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si));
  T10_Vdi_si_Ve_di=(+0.0+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di));
  T10_Vdi_si_Vge_si=(+0.0+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si));
  T10_Vdi_si_Vdi_si=(+0.0+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si));
  T10_Vdi_si_Tempt_GND=(+0.0+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND));
#endif
T10_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND));
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+0.0+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di));
  T10_Tempt_GND_Vge_e=(+0.0+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e));
  T10_Tempt_GND_Ve_si=(+0.0+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si));
  T10_Tempt_GND_Ve_di=(+0.0+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di));
  T10_Tempt_GND_Vge_si=(+0.0+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si));
  T10_Tempt_GND_Vdi_si=(+0.0+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si));
  T10_Tempt_GND_Tempt_GND=(+0.0+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND));
#endif
#endif
T10=(1.0+(T1*T1));
EXIT_IF_ISNAN((1.0+(T1*T1)))
}
else
{
{
double m00_sqrt(d00_sqrt0,2.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=(T2_Vge_e*0.5-(3.0*(T9_Vge_e/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+T2_Vge_e_Vdi_d*0.5+T2_Vge_e*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vdi_d/d00_sqrt0-(T9_Vge_e*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Vsi_s=(+(+T2_Vge_e_Vsi_s*0.5+T2_Vge_e*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vsi_s/d00_sqrt0-(T9_Vge_e*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*0.5+T2_Vge_e*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vge_di/d00_sqrt0-(T9_Vge_e*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*0.5+T2_Vge_e*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vge_e/d00_sqrt0-(T9_Vge_e*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*0.5+T2_Vge_e*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vdi_si/d00_sqrt0-(T9_Vge_e*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*0.5+T2_Vge_e*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Ve_si/d00_sqrt0-(T9_Vge_e*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*0.5+T2_Vge_e*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Ve_di/d00_sqrt0-(T9_Vge_e*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*0.5+T2_Vge_e*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Vge_si/d00_sqrt0-(T9_Vge_e*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*0.5+T2_Vge_e*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Vge_e/d00_sqrt0)+3.0*(+0.0+(T9_Vge_e_Tempt_GND/d00_sqrt0-(T9_Vge_e*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
T3_Vdi_si=(T2_Vdi_si*0.5-(3.0*(T9_Vdi_si/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+T2_Vdi_si_Vdi_d*0.5+T2_Vdi_si*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vdi_d/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Vsi_s=(+(+T2_Vdi_si_Vsi_s*0.5+T2_Vdi_si*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vsi_s/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*0.5+T2_Vdi_si*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vge_di/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*0.5+T2_Vdi_si*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vge_e/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*0.5+T2_Vdi_si*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vdi_si/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*0.5+T2_Vdi_si*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Ve_si/d00_sqrt0-(T9_Vdi_si*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*0.5+T2_Vdi_si*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Ve_di/d00_sqrt0-(T9_Vdi_si*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*0.5+T2_Vdi_si*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Vge_si/d00_sqrt0-(T9_Vdi_si*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*0.5+T2_Vdi_si*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Vdi_si/d00_sqrt0)+3.0*(+0.0+(T9_Vdi_si_Tempt_GND/d00_sqrt0-(T9_Vdi_si*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
T3_Ve_si=(T2_Ve_si*0.5-(3.0*(T9_Ve_si/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+T2_Ve_si_Vdi_d*0.5+T2_Ve_si*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vdi_d/d00_sqrt0-(T9_Ve_si*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Vsi_s=(+(+T2_Ve_si_Vsi_s*0.5+T2_Ve_si*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vsi_s/d00_sqrt0-(T9_Ve_si*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*0.5+T2_Ve_si*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vge_di/d00_sqrt0-(T9_Ve_si*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*0.5+T2_Ve_si*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vge_e/d00_sqrt0-(T9_Ve_si*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*0.5+T2_Ve_si*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vdi_si/d00_sqrt0-(T9_Ve_si*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*0.5+T2_Ve_si*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Ve_si/d00_sqrt0-(T9_Ve_si*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*0.5+T2_Ve_si*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Ve_di/d00_sqrt0-(T9_Ve_si*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*0.5+T2_Ve_si*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Vge_si/d00_sqrt0-(T9_Ve_si*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*0.5+T2_Ve_si*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Ve_si/d00_sqrt0)+3.0*(+0.0+(T9_Ve_si_Tempt_GND/d00_sqrt0-(T9_Ve_si*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
T3_Ve_di=(T2_Ve_di*0.5-(3.0*(T9_Ve_di/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+T2_Ve_di_Vdi_d*0.5+T2_Ve_di*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vdi_d/d00_sqrt0-(T9_Ve_di*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Vsi_s=(+(+T2_Ve_di_Vsi_s*0.5+T2_Ve_di*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vsi_s/d00_sqrt0-(T9_Ve_di*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*0.5+T2_Ve_di*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vge_di/d00_sqrt0-(T9_Ve_di*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*0.5+T2_Ve_di*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vge_e/d00_sqrt0-(T9_Ve_di*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*0.5+T2_Ve_di*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vdi_si/d00_sqrt0-(T9_Ve_di*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*0.5+T2_Ve_di*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Ve_si/d00_sqrt0-(T9_Ve_di*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*0.5+T2_Ve_di*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Ve_di/d00_sqrt0-(T9_Ve_di*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*0.5+T2_Ve_di*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Vge_si/d00_sqrt0-(T9_Ve_di*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*0.5+T2_Ve_di*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Ve_di/d00_sqrt0)+3.0*(+0.0+(T9_Ve_di_Tempt_GND/d00_sqrt0-(T9_Ve_di*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
T3_Vge_si=(T2_Vge_si*0.5-(3.0*(T9_Vge_si/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+T2_Vge_si_Vdi_d*0.5+T2_Vge_si*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vdi_d/d00_sqrt0-(T9_Vge_si*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Vsi_s=(+(+T2_Vge_si_Vsi_s*0.5+T2_Vge_si*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vsi_s/d00_sqrt0-(T9_Vge_si*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*0.5+T2_Vge_si*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vge_di/d00_sqrt0-(T9_Vge_si*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*0.5+T2_Vge_si*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vge_e/d00_sqrt0-(T9_Vge_si*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*0.5+T2_Vge_si*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vdi_si/d00_sqrt0-(T9_Vge_si*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*0.5+T2_Vge_si*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Ve_si/d00_sqrt0-(T9_Vge_si*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*0.5+T2_Vge_si*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Ve_di/d00_sqrt0-(T9_Vge_si*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*0.5+T2_Vge_si*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Vge_si/d00_sqrt0-(T9_Vge_si*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*0.5+T2_Vge_si*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Vge_si/d00_sqrt0)+3.0*(+0.0+(T9_Vge_si_Tempt_GND/d00_sqrt0-(T9_Vge_si*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
T3_Tempt_GND=(T2_Tempt_GND*0.5-(3.0*(T9_Tempt_GND/d00_sqrt0)));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+T2_Tempt_GND_Vdi_d*0.5+T2_Tempt_GND*0.0+T2_Vdi_d*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_d/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vdi_d/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vdi_d*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Vsi_s=(+(+T2_Tempt_GND_Vsi_s*0.5+T2_Tempt_GND*0.0+T2_Vsi_s*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vsi_s/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vsi_s/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vsi_s*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*0.5+T2_Tempt_GND*0.0+T2_Vge_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_di/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vge_di/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vge_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*0.5+T2_Tempt_GND*0.0+T2_Vge_e*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_e/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vge_e/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vge_e*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*0.5+T2_Tempt_GND*0.0+T2_Vdi_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vdi_si/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vdi_si/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vdi_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*0.5+T2_Tempt_GND*0.0+T2_Ve_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_si/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Ve_si/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Ve_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*0.5+T2_Tempt_GND*0.0+T2_Ve_di*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Ve_di/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Ve_di/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Ve_di*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*0.5+T2_Tempt_GND*0.0+T2_Vge_si*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Vge_si/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Vge_si/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Vge_si*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
  T3_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*0.5+T2_Tempt_GND*0.0+T2_Tempt_GND*0.0+T2*0.0)-(+0.0*(1.0+(T9/d00_sqrt0))+0.0*(T9_Tempt_GND/d00_sqrt0)+0.0*(T9_Tempt_GND/d00_sqrt0)+3.0*(+0.0+(T9_Tempt_GND_Tempt_GND/d00_sqrt0-(T9_Tempt_GND*0.0+T9_Tempt_GND*0.0+T9*0.0)/d00_sqrt0/d00_sqrt0+2*T9*0.0*0.0/d00_sqrt0/d00_sqrt0/d00_sqrt0))));
#endif
#endif
T3=((T2*0.5)-(3.0*(1.0+(T9/d00_sqrt0))));
EXIT_IF_ISNAN(((T2*0.5)-(3.0*(1.0+(T9/d00_sqrt0)))))
}
{
double m00_sqrt(d00_sqrt0,((T3*T3)+(6.0*T2)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T3*T3)+(6.0*T2)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=0.0;
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=0.0;
  T10_Vge_di_Vge_e=0.0;
  T10_Vge_di_Ve_si=0.0;
  T10_Vge_di_Ve_di=0.0;
  T10_Vge_di_Vge_si=0.0;
  T10_Vge_di_Vdi_si=0.0;
  T10_Vge_di_Tempt_GND=0.0;
#endif
T10_Vge_e=(T3_Vge_e+(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+T3_Vge_e_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Vge_di*T3+T3_Vge_e*T3_Vge_di+T3_Vge_di*T3_Vge_e+T3*T3_Vge_e_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_e+6.0*T2_Vge_e_Vge_di))));
  T10_Vge_e_Vge_e=(+T3_Vge_e_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Vge_e*T3+T3_Vge_e*T3_Vge_e+T3_Vge_e*T3_Vge_e+T3*T3_Vge_e_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_e+6.0*T2_Vge_e_Vge_e))));
  T10_Vge_e_Ve_si=(+T3_Vge_e_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Ve_si*T3+T3_Vge_e*T3_Ve_si+T3_Ve_si*T3_Vge_e+T3*T3_Vge_e_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_e+6.0*T2_Vge_e_Ve_si))));
  T10_Vge_e_Ve_di=(+T3_Vge_e_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Ve_di*T3+T3_Vge_e*T3_Ve_di+T3_Ve_di*T3_Vge_e+T3*T3_Vge_e_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_e+6.0*T2_Vge_e_Ve_di))));
  T10_Vge_e_Vge_si=(+T3_Vge_e_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Vge_si*T3+T3_Vge_e*T3_Vge_si+T3_Vge_si*T3_Vge_e+T3*T3_Vge_e_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_e+6.0*T2_Vge_e_Vge_si))));
  T10_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Vdi_si*T3+T3_Vge_e*T3_Vdi_si+T3_Vdi_si*T3_Vge_e+T3*T3_Vge_e_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_e+6.0*T2_Vge_e_Vdi_si))));
  T10_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Vge_e*T3)+(T3*T3_Vge_e))+(6.0*T2_Vge_e))+d10_sqrt0*(+(+T3_Vge_e_Tempt_GND*T3+T3_Vge_e*T3_Tempt_GND+T3_Tempt_GND*T3_Vge_e+T3*T3_Vge_e_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_e+6.0*T2_Vge_e_Tempt_GND))));
#endif
T10_Ve_si=(T3_Ve_si+(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+T3_Ve_si_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Vge_di*T3+T3_Ve_si*T3_Vge_di+T3_Vge_di*T3_Ve_si+T3*T3_Ve_si_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_si+6.0*T2_Ve_si_Vge_di))));
  T10_Ve_si_Vge_e=(+T3_Ve_si_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Vge_e*T3+T3_Ve_si*T3_Vge_e+T3_Vge_e*T3_Ve_si+T3*T3_Ve_si_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_si+6.0*T2_Ve_si_Vge_e))));
  T10_Ve_si_Ve_si=(+T3_Ve_si_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Ve_si*T3+T3_Ve_si*T3_Ve_si+T3_Ve_si*T3_Ve_si+T3*T3_Ve_si_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_si+6.0*T2_Ve_si_Ve_si))));
  T10_Ve_si_Ve_di=(+T3_Ve_si_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Ve_di*T3+T3_Ve_si*T3_Ve_di+T3_Ve_di*T3_Ve_si+T3*T3_Ve_si_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_si+6.0*T2_Ve_si_Ve_di))));
  T10_Ve_si_Vge_si=(+T3_Ve_si_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Vge_si*T3+T3_Ve_si*T3_Vge_si+T3_Vge_si*T3_Ve_si+T3*T3_Ve_si_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_si+6.0*T2_Ve_si_Vge_si))));
  T10_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Vdi_si*T3+T3_Ve_si*T3_Vdi_si+T3_Vdi_si*T3_Ve_si+T3*T3_Ve_si_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_si+6.0*T2_Ve_si_Vdi_si))));
  T10_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Ve_si*T3)+(T3*T3_Ve_si))+(6.0*T2_Ve_si))+d10_sqrt0*(+(+T3_Ve_si_Tempt_GND*T3+T3_Ve_si*T3_Tempt_GND+T3_Tempt_GND*T3_Ve_si+T3*T3_Ve_si_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_si+6.0*T2_Ve_si_Tempt_GND))));
#endif
T10_Ve_di=(T3_Ve_di+(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+T3_Ve_di_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Vge_di*T3+T3_Ve_di*T3_Vge_di+T3_Vge_di*T3_Ve_di+T3*T3_Ve_di_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_di+6.0*T2_Ve_di_Vge_di))));
  T10_Ve_di_Vge_e=(+T3_Ve_di_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Vge_e*T3+T3_Ve_di*T3_Vge_e+T3_Vge_e*T3_Ve_di+T3*T3_Ve_di_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_di+6.0*T2_Ve_di_Vge_e))));
  T10_Ve_di_Ve_si=(+T3_Ve_di_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Ve_si*T3+T3_Ve_di*T3_Ve_si+T3_Ve_si*T3_Ve_di+T3*T3_Ve_di_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_di+6.0*T2_Ve_di_Ve_si))));
  T10_Ve_di_Ve_di=(+T3_Ve_di_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Ve_di*T3+T3_Ve_di*T3_Ve_di+T3_Ve_di*T3_Ve_di+T3*T3_Ve_di_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_di+6.0*T2_Ve_di_Ve_di))));
  T10_Ve_di_Vge_si=(+T3_Ve_di_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Vge_si*T3+T3_Ve_di*T3_Vge_si+T3_Vge_si*T3_Ve_di+T3*T3_Ve_di_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_di+6.0*T2_Ve_di_Vge_si))));
  T10_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Vdi_si*T3+T3_Ve_di*T3_Vdi_si+T3_Vdi_si*T3_Ve_di+T3*T3_Ve_di_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_di+6.0*T2_Ve_di_Vdi_si))));
  T10_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Ve_di*T3)+(T3*T3_Ve_di))+(6.0*T2_Ve_di))+d10_sqrt0*(+(+T3_Ve_di_Tempt_GND*T3+T3_Ve_di*T3_Tempt_GND+T3_Tempt_GND*T3_Ve_di+T3*T3_Ve_di_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_di+6.0*T2_Ve_di_Tempt_GND))));
#endif
T10_Vge_si=(T3_Vge_si+(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+T3_Vge_si_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Vge_di*T3+T3_Vge_si*T3_Vge_di+T3_Vge_di*T3_Vge_si+T3*T3_Vge_si_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_si+6.0*T2_Vge_si_Vge_di))));
  T10_Vge_si_Vge_e=(+T3_Vge_si_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Vge_e*T3+T3_Vge_si*T3_Vge_e+T3_Vge_e*T3_Vge_si+T3*T3_Vge_si_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_si+6.0*T2_Vge_si_Vge_e))));
  T10_Vge_si_Ve_si=(+T3_Vge_si_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Ve_si*T3+T3_Vge_si*T3_Ve_si+T3_Ve_si*T3_Vge_si+T3*T3_Vge_si_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_si+6.0*T2_Vge_si_Ve_si))));
  T10_Vge_si_Ve_di=(+T3_Vge_si_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Ve_di*T3+T3_Vge_si*T3_Ve_di+T3_Ve_di*T3_Vge_si+T3*T3_Vge_si_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_si+6.0*T2_Vge_si_Ve_di))));
  T10_Vge_si_Vge_si=(+T3_Vge_si_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Vge_si*T3+T3_Vge_si*T3_Vge_si+T3_Vge_si*T3_Vge_si+T3*T3_Vge_si_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_si+6.0*T2_Vge_si_Vge_si))));
  T10_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Vdi_si*T3+T3_Vge_si*T3_Vdi_si+T3_Vdi_si*T3_Vge_si+T3*T3_Vge_si_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_si+6.0*T2_Vge_si_Vdi_si))));
  T10_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Vge_si*T3)+(T3*T3_Vge_si))+(6.0*T2_Vge_si))+d10_sqrt0*(+(+T3_Vge_si_Tempt_GND*T3+T3_Vge_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vge_si+T3*T3_Vge_si_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_si+6.0*T2_Vge_si_Tempt_GND))));
#endif
T10_Vdi_si=(T3_Vdi_si+(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Vge_di*T3+T3_Vdi_si*T3_Vge_di+T3_Vge_di*T3_Vdi_si+T3*T3_Vdi_si_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Vge_di))));
  T10_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Vge_e*T3+T3_Vdi_si*T3_Vge_e+T3_Vge_e*T3_Vdi_si+T3*T3_Vdi_si_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Vge_e))));
  T10_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Ve_si*T3+T3_Vdi_si*T3_Ve_si+T3_Ve_si*T3_Vdi_si+T3*T3_Vdi_si_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Ve_si))));
  T10_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Ve_di*T3+T3_Vdi_si*T3_Ve_di+T3_Ve_di*T3_Vdi_si+T3*T3_Vdi_si_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Ve_di))));
  T10_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Vge_si*T3+T3_Vdi_si*T3_Vge_si+T3_Vge_si*T3_Vdi_si+T3*T3_Vdi_si_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Vge_si))));
  T10_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Vdi_si*T3+T3_Vdi_si*T3_Vdi_si+T3_Vdi_si*T3_Vdi_si+T3*T3_Vdi_si_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Vdi_si))));
  T10_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Vdi_si*T3)+(T3*T3_Vdi_si))+(6.0*T2_Vdi_si))+d10_sqrt0*(+(+T3_Vdi_si_Tempt_GND*T3+T3_Vdi_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_si+T3*T3_Vdi_si_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_si+6.0*T2_Vdi_si_Tempt_GND))));
#endif
T10_Tempt_GND=(T3_Tempt_GND+(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))*d10_sqrt0);
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_di*T3)+(T3*T3_Vge_di)))+((6.0*T2_Vge_di)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Vge_di*T3+T3_Tempt_GND*T3_Vge_di+T3_Vge_di*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_di)+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Vge_di))));
  T10_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_e*T3)+(T3*T3_Vge_e)))+((6.0*T2_Vge_e)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Vge_e*T3+T3_Tempt_GND*T3_Vge_e+T3_Vge_e*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_e)+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Vge_e))));
  T10_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_si*T3)+(T3*T3_Ve_si)))+((6.0*T2_Ve_si)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Ve_si*T3+T3_Tempt_GND*T3_Ve_si+T3_Ve_si*T3_Tempt_GND+T3*T3_Tempt_GND_Ve_si)+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Ve_si))));
  T10_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Ve_di*T3)+(T3*T3_Ve_di)))+((6.0*T2_Ve_di)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Ve_di*T3+T3_Tempt_GND*T3_Ve_di+T3_Ve_di*T3_Tempt_GND+T3*T3_Tempt_GND_Ve_di)+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Ve_di))));
  T10_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vge_si*T3)+(T3*T3_Vge_si)))+((6.0*T2_Vge_si)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Vge_si*T3+T3_Tempt_GND*T3_Vge_si+T3_Vge_si*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_si)+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Vge_si))));
  T10_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Vdi_si*T3)+(T3*T3_Vdi_si)))+((6.0*T2_Vdi_si)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Vdi_si*T3+T3_Tempt_GND*T3_Vdi_si+T3_Vdi_si*T3_Tempt_GND+T3*T3_Tempt_GND_Vdi_si)+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Vdi_si))));
  T10_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND+(m20_sqrt(((T3*T3)+(6.0*T2)))*((((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND)))+((6.0*T2_Tempt_GND)))*(((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND))+(6.0*T2_Tempt_GND))+d10_sqrt0*(+(+T3_Tempt_GND_Tempt_GND*T3+T3_Tempt_GND*T3_Tempt_GND+T3_Tempt_GND*T3_Tempt_GND+T3*T3_Tempt_GND_Tempt_GND)+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Tempt_GND+6.0*T2_Tempt_GND_Tempt_GND))));
#endif
#endif
T10=(T3+d00_sqrt0);
EXIT_IF_ISNAN((T3+d00_sqrt0))
}
if
((T2<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=(((T2_Vge_e-T10_Vge_e)*T9-(T2-T10)*T9_Vge_e)/T9/T9);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=((+T2_Vge_e_Vge_di-T10_Vge_e_Vge_di)/T9-((T2_Vge_e-T10_Vge_e)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Vge_e+(T2-T10)*T9_Vge_e_Vge_di)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Vge_di/T9/T9/T9);
  T4_Vge_e_Vge_e=((+T2_Vge_e_Vge_e-T10_Vge_e_Vge_e)/T9-((T2_Vge_e-T10_Vge_e)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Vge_e+(T2-T10)*T9_Vge_e_Vge_e)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Vge_e/T9/T9/T9);
  T4_Vge_e_Vdi_si=((+T2_Vge_e_Vdi_si-T10_Vge_e_Vdi_si)/T9-((T2_Vge_e-T10_Vge_e)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Vge_e+(T2-T10)*T9_Vge_e_Vdi_si)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Vdi_si/T9/T9/T9);
  T4_Vge_e_Ve_si=((+T2_Vge_e_Ve_si-T10_Vge_e_Ve_si)/T9-((T2_Vge_e-T10_Vge_e)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Vge_e+(T2-T10)*T9_Vge_e_Ve_si)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Ve_si/T9/T9/T9);
  T4_Vge_e_Ve_di=((+T2_Vge_e_Ve_di-T10_Vge_e_Ve_di)/T9-((T2_Vge_e-T10_Vge_e)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Vge_e+(T2-T10)*T9_Vge_e_Ve_di)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Ve_di/T9/T9/T9);
  T4_Vge_e_Vge_si=((+T2_Vge_e_Vge_si-T10_Vge_e_Vge_si)/T9-((T2_Vge_e-T10_Vge_e)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Vge_e+(T2-T10)*T9_Vge_e_Vge_si)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Vge_si/T9/T9/T9);
  T4_Vge_e_Tempt_GND=((+T2_Vge_e_Tempt_GND-T10_Vge_e_Tempt_GND)/T9-((T2_Vge_e-T10_Vge_e)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Vge_e+(T2-T10)*T9_Vge_e_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Vge_e*T9_Tempt_GND/T9/T9/T9);
#endif
T4_Vdi_si=(((T2_Vdi_si-T10_Vdi_si)*T9-(T2-T10)*T9_Vdi_si)/T9/T9);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=((+T2_Vdi_si_Vge_di-T10_Vdi_si_Vge_di)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Vge_di)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Vge_di/T9/T9/T9);
  T4_Vdi_si_Vge_e=((+T2_Vdi_si_Vge_e-T10_Vdi_si_Vge_e)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Vge_e)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Vge_e/T9/T9/T9);
  T4_Vdi_si_Vdi_si=((+T2_Vdi_si_Vdi_si-T10_Vdi_si_Vdi_si)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Vdi_si)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Vdi_si/T9/T9/T9);
  T4_Vdi_si_Ve_si=((+T2_Vdi_si_Ve_si-T10_Vdi_si_Ve_si)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Ve_si)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Ve_si/T9/T9/T9);
  T4_Vdi_si_Ve_di=((+T2_Vdi_si_Ve_di-T10_Vdi_si_Ve_di)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Ve_di)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Ve_di/T9/T9/T9);
  T4_Vdi_si_Vge_si=((+T2_Vdi_si_Vge_si-T10_Vdi_si_Vge_si)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Vge_si)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Vge_si/T9/T9/T9);
  T4_Vdi_si_Tempt_GND=((+T2_Vdi_si_Tempt_GND-T10_Vdi_si_Tempt_GND)/T9-((T2_Vdi_si-T10_Vdi_si)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Vdi_si+(T2-T10)*T9_Vdi_si_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Vdi_si*T9_Tempt_GND/T9/T9/T9);
#endif
T4_Ve_si=(((T2_Ve_si-T10_Ve_si)*T9-(T2-T10)*T9_Ve_si)/T9/T9);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=((+T2_Ve_si_Vge_di-T10_Ve_si_Vge_di)/T9-((T2_Ve_si-T10_Ve_si)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Ve_si+(T2-T10)*T9_Ve_si_Vge_di)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Vge_di/T9/T9/T9);
  T4_Ve_si_Vge_e=((+T2_Ve_si_Vge_e-T10_Ve_si_Vge_e)/T9-((T2_Ve_si-T10_Ve_si)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Ve_si+(T2-T10)*T9_Ve_si_Vge_e)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Vge_e/T9/T9/T9);
  T4_Ve_si_Vdi_si=((+T2_Ve_si_Vdi_si-T10_Ve_si_Vdi_si)/T9-((T2_Ve_si-T10_Ve_si)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Ve_si+(T2-T10)*T9_Ve_si_Vdi_si)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Vdi_si/T9/T9/T9);
  T4_Ve_si_Ve_si=((+T2_Ve_si_Ve_si-T10_Ve_si_Ve_si)/T9-((T2_Ve_si-T10_Ve_si)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Ve_si+(T2-T10)*T9_Ve_si_Ve_si)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Ve_si/T9/T9/T9);
  T4_Ve_si_Ve_di=((+T2_Ve_si_Ve_di-T10_Ve_si_Ve_di)/T9-((T2_Ve_si-T10_Ve_si)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Ve_si+(T2-T10)*T9_Ve_si_Ve_di)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Ve_di/T9/T9/T9);
  T4_Ve_si_Vge_si=((+T2_Ve_si_Vge_si-T10_Ve_si_Vge_si)/T9-((T2_Ve_si-T10_Ve_si)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Ve_si+(T2-T10)*T9_Ve_si_Vge_si)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Vge_si/T9/T9/T9);
  T4_Ve_si_Tempt_GND=((+T2_Ve_si_Tempt_GND-T10_Ve_si_Tempt_GND)/T9-((T2_Ve_si-T10_Ve_si)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Ve_si+(T2-T10)*T9_Ve_si_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Ve_si*T9_Tempt_GND/T9/T9/T9);
#endif
T4_Ve_di=(((T2_Ve_di-T10_Ve_di)*T9-(T2-T10)*T9_Ve_di)/T9/T9);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=((+T2_Ve_di_Vge_di-T10_Ve_di_Vge_di)/T9-((T2_Ve_di-T10_Ve_di)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Ve_di+(T2-T10)*T9_Ve_di_Vge_di)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Vge_di/T9/T9/T9);
  T4_Ve_di_Vge_e=((+T2_Ve_di_Vge_e-T10_Ve_di_Vge_e)/T9-((T2_Ve_di-T10_Ve_di)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Ve_di+(T2-T10)*T9_Ve_di_Vge_e)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Vge_e/T9/T9/T9);
  T4_Ve_di_Vdi_si=((+T2_Ve_di_Vdi_si-T10_Ve_di_Vdi_si)/T9-((T2_Ve_di-T10_Ve_di)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Ve_di+(T2-T10)*T9_Ve_di_Vdi_si)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Vdi_si/T9/T9/T9);
  T4_Ve_di_Ve_si=((+T2_Ve_di_Ve_si-T10_Ve_di_Ve_si)/T9-((T2_Ve_di-T10_Ve_di)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Ve_di+(T2-T10)*T9_Ve_di_Ve_si)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Ve_si/T9/T9/T9);
  T4_Ve_di_Ve_di=((+T2_Ve_di_Ve_di-T10_Ve_di_Ve_di)/T9-((T2_Ve_di-T10_Ve_di)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Ve_di+(T2-T10)*T9_Ve_di_Ve_di)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Ve_di/T9/T9/T9);
  T4_Ve_di_Vge_si=((+T2_Ve_di_Vge_si-T10_Ve_di_Vge_si)/T9-((T2_Ve_di-T10_Ve_di)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Ve_di+(T2-T10)*T9_Ve_di_Vge_si)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Vge_si/T9/T9/T9);
  T4_Ve_di_Tempt_GND=((+T2_Ve_di_Tempt_GND-T10_Ve_di_Tempt_GND)/T9-((T2_Ve_di-T10_Ve_di)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Ve_di+(T2-T10)*T9_Ve_di_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Ve_di*T9_Tempt_GND/T9/T9/T9);
#endif
T4_Vge_si=(((T2_Vge_si-T10_Vge_si)*T9-(T2-T10)*T9_Vge_si)/T9/T9);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=((+T2_Vge_si_Vge_di-T10_Vge_si_Vge_di)/T9-((T2_Vge_si-T10_Vge_si)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Vge_si+(T2-T10)*T9_Vge_si_Vge_di)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Vge_di/T9/T9/T9);
  T4_Vge_si_Vge_e=((+T2_Vge_si_Vge_e-T10_Vge_si_Vge_e)/T9-((T2_Vge_si-T10_Vge_si)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Vge_si+(T2-T10)*T9_Vge_si_Vge_e)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Vge_e/T9/T9/T9);
  T4_Vge_si_Vdi_si=((+T2_Vge_si_Vdi_si-T10_Vge_si_Vdi_si)/T9-((T2_Vge_si-T10_Vge_si)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Vge_si+(T2-T10)*T9_Vge_si_Vdi_si)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Vdi_si/T9/T9/T9);
  T4_Vge_si_Ve_si=((+T2_Vge_si_Ve_si-T10_Vge_si_Ve_si)/T9-((T2_Vge_si-T10_Vge_si)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Vge_si+(T2-T10)*T9_Vge_si_Ve_si)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Ve_si/T9/T9/T9);
  T4_Vge_si_Ve_di=((+T2_Vge_si_Ve_di-T10_Vge_si_Ve_di)/T9-((T2_Vge_si-T10_Vge_si)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Vge_si+(T2-T10)*T9_Vge_si_Ve_di)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Ve_di/T9/T9/T9);
  T4_Vge_si_Vge_si=((+T2_Vge_si_Vge_si-T10_Vge_si_Vge_si)/T9-((T2_Vge_si-T10_Vge_si)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Vge_si+(T2-T10)*T9_Vge_si_Vge_si)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Vge_si/T9/T9/T9);
  T4_Vge_si_Tempt_GND=((+T2_Vge_si_Tempt_GND-T10_Vge_si_Tempt_GND)/T9-((T2_Vge_si-T10_Vge_si)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Vge_si+(T2-T10)*T9_Vge_si_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Vge_si*T9_Tempt_GND/T9/T9/T9);
#endif
T4_Tempt_GND=(((T2_Tempt_GND-T10_Tempt_GND)*T9-(T2-T10)*T9_Tempt_GND)/T9/T9);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=((+T2_Tempt_GND_Vge_di-T10_Tempt_GND_Vge_di)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Vge_di+(T2_Vge_di-T10_Vge_di)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Vge_di)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Vge_di/T9/T9/T9);
  T4_Tempt_GND_Vge_e=((+T2_Tempt_GND_Vge_e-T10_Tempt_GND_Vge_e)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Vge_e+(T2_Vge_e-T10_Vge_e)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Vge_e)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Vge_e/T9/T9/T9);
  T4_Tempt_GND_Vdi_si=((+T2_Tempt_GND_Vdi_si-T10_Tempt_GND_Vdi_si)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Vdi_si+(T2_Vdi_si-T10_Vdi_si)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Vdi_si)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Vdi_si/T9/T9/T9);
  T4_Tempt_GND_Ve_si=((+T2_Tempt_GND_Ve_si-T10_Tempt_GND_Ve_si)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Ve_si+(T2_Ve_si-T10_Ve_si)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Ve_si)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Ve_si/T9/T9/T9);
  T4_Tempt_GND_Ve_di=((+T2_Tempt_GND_Ve_di-T10_Tempt_GND_Ve_di)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Ve_di+(T2_Ve_di-T10_Ve_di)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Ve_di)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Ve_di/T9/T9/T9);
  T4_Tempt_GND_Vge_si=((+T2_Tempt_GND_Vge_si-T10_Tempt_GND_Vge_si)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Vge_si+(T2_Vge_si-T10_Vge_si)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Vge_si)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Vge_si/T9/T9/T9);
  T4_Tempt_GND_Tempt_GND=((+T2_Tempt_GND_Tempt_GND-T10_Tempt_GND_Tempt_GND)/T9-((T2_Tempt_GND-T10_Tempt_GND)*T9_Tempt_GND+(T2_Tempt_GND-T10_Tempt_GND)*T9_Tempt_GND+(T2-T10)*T9_Tempt_GND_Tempt_GND)/T9/T9+2*(T2-T10)*T9_Tempt_GND*T9_Tempt_GND/T9/T9/T9);
#endif
#endif
T4=((T2-T10)/T9);
EXIT_IF_ISNAN(((T2-T10)/T9))
{
double m00_logE(d00_logE0,((1.0-T10)+(T4*T4)))
#if defined(_DERIVATEFORDDX)
double m10_logE(d10_logE0,d00_logE0,((1.0-T10)+(T4*T4)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=0.0;
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=0.0;
  T10_Vge_di_Vge_e=0.0;
  T10_Vge_di_Ve_si=0.0;
  T10_Vge_di_Ve_di=0.0;
  T10_Vge_di_Vge_si=0.0;
  T10_Vge_di_Vdi_si=0.0;
  T10_Vge_di_Tempt_GND=0.0;
#endif
T10_Vge_e=(-((-T10_Vge_e)+((T4_Vge_e*T4)+(T4*T4_Vge_e)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=0.0;
  T10_Vge_e_Vge_e=0.0;
  T10_Vge_e_Ve_si=0.0;
  T10_Vge_e_Ve_di=0.0;
  T10_Vge_e_Vge_si=0.0;
  T10_Vge_e_Vdi_si=0.0;
  T10_Vge_e_Tempt_GND=0.0;
#endif
T10_Ve_si=(-((-T10_Ve_si)+((T4_Ve_si*T4)+(T4*T4_Ve_si)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=0.0;
  T10_Ve_si_Vge_e=0.0;
  T10_Ve_si_Ve_si=0.0;
  T10_Ve_si_Ve_di=0.0;
  T10_Ve_si_Vge_si=0.0;
  T10_Ve_si_Vdi_si=0.0;
  T10_Ve_si_Tempt_GND=0.0;
#endif
T10_Ve_di=(-((-T10_Ve_di)+((T4_Ve_di*T4)+(T4*T4_Ve_di)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=0.0;
  T10_Ve_di_Vge_e=0.0;
  T10_Ve_di_Ve_si=0.0;
  T10_Ve_di_Ve_di=0.0;
  T10_Ve_di_Vge_si=0.0;
  T10_Ve_di_Vdi_si=0.0;
  T10_Ve_di_Tempt_GND=0.0;
#endif
T10_Vge_si=(-((-T10_Vge_si)+((T4_Vge_si*T4)+(T4*T4_Vge_si)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=0.0;
  T10_Vge_si_Vge_e=0.0;
  T10_Vge_si_Ve_si=0.0;
  T10_Vge_si_Ve_di=0.0;
  T10_Vge_si_Vge_si=0.0;
  T10_Vge_si_Vdi_si=0.0;
  T10_Vge_si_Tempt_GND=0.0;
#endif
T10_Vdi_si=(-((-T10_Vdi_si)+((T4_Vdi_si*T4)+(T4*T4_Vdi_si)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=0.0;
  T10_Vdi_si_Vge_e=0.0;
  T10_Vdi_si_Ve_si=0.0;
  T10_Vdi_si_Ve_di=0.0;
  T10_Vdi_si_Vge_si=0.0;
  T10_Vdi_si_Vdi_si=0.0;
  T10_Vdi_si_Tempt_GND=0.0;
#endif
T10_Tempt_GND=(-((-T10_Tempt_GND)+((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)))*d10_logE0);
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=0.0;
  T10_Tempt_GND_Vge_e=0.0;
  T10_Tempt_GND_Ve_si=0.0;
  T10_Tempt_GND_Ve_di=0.0;
  T10_Tempt_GND_Vge_si=0.0;
  T10_Tempt_GND_Vdi_si=0.0;
  T10_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T10=(-d00_logE0);
EXIT_IF_ISNAN((-d00_logE0))
}
}
else
{
{
double m00_exp(d00_exp0,(-T10))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T11_Vge_e=(-T10_Vge_e)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vge_e_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vge_e)+d10_exp0*0.0);
  T11_Vge_e_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vge_e)+d10_exp0*0.0);
  T11_Vge_e_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vge_e)+d10_exp0*0.0);
  T11_Vge_e_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vge_e)+d10_exp0*0.0);
  T11_Vge_e_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vge_e)+d10_exp0*0.0);
  T11_Vge_e_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vge_e)+d10_exp0*0.0);
#endif
T11_Ve_si=(-T10_Ve_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Ve_si_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Ve_si)+d10_exp0*0.0);
  T11_Ve_si_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Ve_si)+d10_exp0*0.0);
  T11_Ve_si_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Ve_si)+d10_exp0*0.0);
  T11_Ve_si_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Ve_si)+d10_exp0*0.0);
  T11_Ve_si_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Ve_si)+d10_exp0*0.0);
  T11_Ve_si_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Ve_si)+d10_exp0*0.0);
#endif
T11_Ve_di=(-T10_Ve_di)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Ve_di_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Ve_di)+d10_exp0*0.0);
  T11_Ve_di_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Ve_di)+d10_exp0*0.0);
  T11_Ve_di_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Ve_di)+d10_exp0*0.0);
  T11_Ve_di_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Ve_di)+d10_exp0*0.0);
  T11_Ve_di_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Ve_di)+d10_exp0*0.0);
  T11_Ve_di_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Ve_di)+d10_exp0*0.0);
#endif
T11_Vge_si=(-T10_Vge_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vge_si_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vge_si)+d10_exp0*0.0);
  T11_Vge_si_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vge_si)+d10_exp0*0.0);
  T11_Vge_si_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vge_si)+d10_exp0*0.0);
  T11_Vge_si_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vge_si)+d10_exp0*0.0);
  T11_Vge_si_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vge_si)+d10_exp0*0.0);
  T11_Vge_si_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vge_si)+d10_exp0*0.0);
#endif
T11_Vdi_si=(-T10_Vdi_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vdi_si_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vdi_si)+d10_exp0*0.0);
  T11_Vdi_si_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vdi_si)+d10_exp0*0.0);
  T11_Vdi_si_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vdi_si)+d10_exp0*0.0);
  T11_Vdi_si_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vdi_si)+d10_exp0*0.0);
  T11_Vdi_si_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vdi_si)+d10_exp0*0.0);
  T11_Vdi_si_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vdi_si)+d10_exp0*0.0);
#endif
T11_Tempt_GND=(-T10_Tempt_GND)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Tempt_GND_Vge_e=(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Tempt_GND)+d10_exp0*0.0);
  T11_Tempt_GND_Ve_si=(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Tempt_GND)+d10_exp0*0.0);
  T11_Tempt_GND_Ve_di=(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Tempt_GND)+d10_exp0*0.0);
  T11_Tempt_GND_Vge_si=(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Tempt_GND)+d10_exp0*0.0);
  T11_Tempt_GND_Vdi_si=(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Tempt_GND)+d10_exp0*0.0);
  T11_Tempt_GND_Tempt_GND=(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Tempt_GND)+d10_exp0*0.0);
#endif
#endif
T11=d00_exp0;
EXIT_IF_ISNAN(d00_exp0)
}
{
double m00_sqrt(d00_sqrt0,(((T2-1.0)+T11)+(T0*T0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T2-1.0)+T11)+(T0*T0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=(((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))*d10_sqrt0-T0_Vge_e);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Vge_di-0.0)+0.0)+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)))-T0_Vge_e_Vge_di);
  T4_Vge_e_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Vge_e-0.0)+T11_Vge_e_Vge_e)+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)))-T0_Vge_e_Vge_e);
  T4_Vge_e_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Vdi_si-0.0)+T11_Vge_e_Vdi_si)+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)))-T0_Vge_e_Vdi_si);
  T4_Vge_e_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Ve_si-0.0)+T11_Vge_e_Ve_si)+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)))-T0_Vge_e_Ve_si);
  T4_Vge_e_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Ve_di-0.0)+T11_Vge_e_Ve_di)+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)))-T0_Vge_e_Ve_di);
  T4_Vge_e_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Vge_si-0.0)+T11_Vge_e_Vge_si)+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)))-T0_Vge_e_Vge_si);
  T4_Vge_e_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Vge_e+T11_Vge_e)+((T0_Vge_e*T0)+(T0*T0_Vge_e)))+d10_sqrt0*(+(+(+T2_Vge_e_Tempt_GND-0.0)+T11_Vge_e_Tempt_GND)+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)))-T0_Vge_e_Tempt_GND);
#endif
T4_Vdi_si=(((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*d10_sqrt0-T0_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Vge_di-0.0)+0.0)+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)))-T0_Vdi_si_Vge_di);
  T4_Vdi_si_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Vge_e-0.0)+T11_Vdi_si_Vge_e)+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)))-T0_Vdi_si_Vge_e);
  T4_Vdi_si_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Vdi_si-0.0)+T11_Vdi_si_Vdi_si)+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)))-T0_Vdi_si_Vdi_si);
  T4_Vdi_si_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Ve_si-0.0)+T11_Vdi_si_Ve_si)+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)))-T0_Vdi_si_Ve_si);
  T4_Vdi_si_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Ve_di-0.0)+T11_Vdi_si_Ve_di)+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)))-T0_Vdi_si_Ve_di);
  T4_Vdi_si_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Vge_si-0.0)+T11_Vdi_si_Vge_si)+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)))-T0_Vdi_si_Vge_si);
  T4_Vdi_si_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Vdi_si+T11_Vdi_si)+((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+d10_sqrt0*(+(+(+T2_Vdi_si_Tempt_GND-0.0)+T11_Vdi_si_Tempt_GND)+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)))-T0_Vdi_si_Tempt_GND);
#endif
T4_Ve_si=(((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))*d10_sqrt0-T0_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Vge_di-0.0)+0.0)+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)))-T0_Ve_si_Vge_di);
  T4_Ve_si_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Vge_e-0.0)+T11_Ve_si_Vge_e)+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)))-T0_Ve_si_Vge_e);
  T4_Ve_si_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Vdi_si-0.0)+T11_Ve_si_Vdi_si)+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)))-T0_Ve_si_Vdi_si);
  T4_Ve_si_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Ve_si-0.0)+T11_Ve_si_Ve_si)+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)))-T0_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Ve_di-0.0)+T11_Ve_si_Ve_di)+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)))-T0_Ve_si_Ve_di);
  T4_Ve_si_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Vge_si-0.0)+T11_Ve_si_Vge_si)+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)))-T0_Ve_si_Vge_si);
  T4_Ve_si_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Ve_si+T11_Ve_si)+((T0_Ve_si*T0)+(T0*T0_Ve_si)))+d10_sqrt0*(+(+(+T2_Ve_si_Tempt_GND-0.0)+T11_Ve_si_Tempt_GND)+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)))-T0_Ve_si_Tempt_GND);
#endif
T4_Ve_di=(((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))*d10_sqrt0-T0_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Vge_di-0.0)+0.0)+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)))-T0_Ve_di_Vge_di);
  T4_Ve_di_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Vge_e-0.0)+T11_Ve_di_Vge_e)+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)))-T0_Ve_di_Vge_e);
  T4_Ve_di_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Vdi_si-0.0)+T11_Ve_di_Vdi_si)+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)))-T0_Ve_di_Vdi_si);
  T4_Ve_di_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Ve_si-0.0)+T11_Ve_di_Ve_si)+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)))-T0_Ve_di_Ve_si);
  T4_Ve_di_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Ve_di-0.0)+T11_Ve_di_Ve_di)+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)))-T0_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Vge_si-0.0)+T11_Ve_di_Vge_si)+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)))-T0_Ve_di_Vge_si);
  T4_Ve_di_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Ve_di+T11_Ve_di)+((T0_Ve_di*T0)+(T0*T0_Ve_di)))+d10_sqrt0*(+(+(+T2_Ve_di_Tempt_GND-0.0)+T11_Ve_di_Tempt_GND)+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)))-T0_Ve_di_Tempt_GND);
#endif
T4_Vge_si=(((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))*d10_sqrt0-T0_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Vge_di-0.0)+0.0)+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)))-T0_Vge_si_Vge_di);
  T4_Vge_si_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Vge_e-0.0)+T11_Vge_si_Vge_e)+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)))-T0_Vge_si_Vge_e);
  T4_Vge_si_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Vdi_si-0.0)+T11_Vge_si_Vdi_si)+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)))-T0_Vge_si_Vdi_si);
  T4_Vge_si_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Ve_si-0.0)+T11_Vge_si_Ve_si)+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)))-T0_Vge_si_Ve_si);
  T4_Vge_si_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Ve_di-0.0)+T11_Vge_si_Ve_di)+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)))-T0_Vge_si_Ve_di);
  T4_Vge_si_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Vge_si-0.0)+T11_Vge_si_Vge_si)+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)))-T0_Vge_si_Vge_si);
  T4_Vge_si_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Vge_si+T11_Vge_si)+((T0_Vge_si*T0)+(T0*T0_Vge_si)))+d10_sqrt0*(+(+(+T2_Vge_si_Tempt_GND-0.0)+T11_Vge_si_Tempt_GND)+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)))-T0_Vge_si_Tempt_GND);
#endif
T4_Tempt_GND=(((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*d10_sqrt0-T0_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*(T2_Vge_di+(((T0_Vge_di*T0)+(T0*T0_Vge_di))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Vge_di-0.0)+0.0)+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)))-T0_Tempt_GND_Vge_di);
  T4_Tempt_GND_Vge_e=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_e+T11_Vge_e)+(((T0_Vge_e*T0)+(T0*T0_Vge_e))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Vge_e-0.0)+T11_Tempt_GND_Vge_e)+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)))-T0_Tempt_GND_Vge_e);
  T4_Tempt_GND_Vdi_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vdi_si+T11_Vdi_si)+(((T0_Vdi_si*T0)+(T0*T0_Vdi_si))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Vdi_si-0.0)+T11_Tempt_GND_Vdi_si)+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)))-T0_Tempt_GND_Vdi_si);
  T4_Tempt_GND_Ve_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_si+T11_Ve_si)+(((T0_Ve_si*T0)+(T0*T0_Ve_si))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Ve_si-0.0)+T11_Tempt_GND_Ve_si)+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)))-T0_Tempt_GND_Ve_si);
  T4_Tempt_GND_Ve_di=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Ve_di+T11_Ve_di)+(((T0_Ve_di*T0)+(T0*T0_Ve_di))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Ve_di-0.0)+T11_Tempt_GND_Ve_di)+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)))-T0_Tempt_GND_Ve_di);
  T4_Tempt_GND_Vge_si=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Vge_si+T11_Vge_si)+(((T0_Vge_si*T0)+(T0*T0_Vge_si))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Vge_si-0.0)+T11_Tempt_GND_Vge_si)+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)))-T0_Tempt_GND_Vge_si);
  T4_Tempt_GND_Tempt_GND=(+(m20_sqrt((((T2-1.0)+T11)+(T0*T0)))*((T2_Tempt_GND+T11_Tempt_GND)+(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))))*((T2_Tempt_GND+T11_Tempt_GND)+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+d10_sqrt0*(+(+(+T2_Tempt_GND_Tempt_GND-0.0)+T11_Tempt_GND_Tempt_GND)+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)))-T0_Tempt_GND_Tempt_GND);
#endif
#endif
T4=(d00_sqrt0-T0);
EXIT_IF_ISNAN((d00_sqrt0-T0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=0.0;
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=0.0;
  T10_Vge_di_Vge_e=0.0;
  T10_Vge_di_Ve_si=0.0;
  T10_Vge_di_Ve_di=0.0;
  T10_Vge_di_Vge_si=0.0;
  T10_Vge_di_Vdi_si=0.0;
  T10_Vge_di_Tempt_GND=0.0;
#endif
T10_Vge_e=((-T11_Vge_e)+((T4_Vge_e*T4)+(T4*T4_Vge_e)));
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+(+0.0-0.0)+(+T4_Vge_e_Vge_di*T4+T4_Vge_e*T4_Vge_di+T4_Vge_di*T4_Vge_e+T4*T4_Vge_e_Vge_di));
  T10_Vge_e_Vge_e=(+(+0.0-T11_Vge_e_Vge_e)+(+T4_Vge_e_Vge_e*T4+T4_Vge_e*T4_Vge_e+T4_Vge_e*T4_Vge_e+T4*T4_Vge_e_Vge_e));
  T10_Vge_e_Ve_si=(+(+0.0-T11_Vge_e_Ve_si)+(+T4_Vge_e_Ve_si*T4+T4_Vge_e*T4_Ve_si+T4_Ve_si*T4_Vge_e+T4*T4_Vge_e_Ve_si));
  T10_Vge_e_Ve_di=(+(+0.0-T11_Vge_e_Ve_di)+(+T4_Vge_e_Ve_di*T4+T4_Vge_e*T4_Ve_di+T4_Ve_di*T4_Vge_e+T4*T4_Vge_e_Ve_di));
  T10_Vge_e_Vge_si=(+(+0.0-T11_Vge_e_Vge_si)+(+T4_Vge_e_Vge_si*T4+T4_Vge_e*T4_Vge_si+T4_Vge_si*T4_Vge_e+T4*T4_Vge_e_Vge_si));
  T10_Vge_e_Vdi_si=(+(+0.0-T11_Vge_e_Vdi_si)+(+T4_Vge_e_Vdi_si*T4+T4_Vge_e*T4_Vdi_si+T4_Vdi_si*T4_Vge_e+T4*T4_Vge_e_Vdi_si));
  T10_Vge_e_Tempt_GND=(+(+0.0-T11_Vge_e_Tempt_GND)+(+T4_Vge_e_Tempt_GND*T4+T4_Vge_e*T4_Tempt_GND+T4_Tempt_GND*T4_Vge_e+T4*T4_Vge_e_Tempt_GND));
#endif
T10_Ve_si=((-T11_Ve_si)+((T4_Ve_si*T4)+(T4*T4_Ve_si)));
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+(+0.0-0.0)+(+T4_Ve_si_Vge_di*T4+T4_Ve_si*T4_Vge_di+T4_Vge_di*T4_Ve_si+T4*T4_Ve_si_Vge_di));
  T10_Ve_si_Vge_e=(+(+0.0-T11_Ve_si_Vge_e)+(+T4_Ve_si_Vge_e*T4+T4_Ve_si*T4_Vge_e+T4_Vge_e*T4_Ve_si+T4*T4_Ve_si_Vge_e));
  T10_Ve_si_Ve_si=(+(+0.0-T11_Ve_si_Ve_si)+(+T4_Ve_si_Ve_si*T4+T4_Ve_si*T4_Ve_si+T4_Ve_si*T4_Ve_si+T4*T4_Ve_si_Ve_si));
  T10_Ve_si_Ve_di=(+(+0.0-T11_Ve_si_Ve_di)+(+T4_Ve_si_Ve_di*T4+T4_Ve_si*T4_Ve_di+T4_Ve_di*T4_Ve_si+T4*T4_Ve_si_Ve_di));
  T10_Ve_si_Vge_si=(+(+0.0-T11_Ve_si_Vge_si)+(+T4_Ve_si_Vge_si*T4+T4_Ve_si*T4_Vge_si+T4_Vge_si*T4_Ve_si+T4*T4_Ve_si_Vge_si));
  T10_Ve_si_Vdi_si=(+(+0.0-T11_Ve_si_Vdi_si)+(+T4_Ve_si_Vdi_si*T4+T4_Ve_si*T4_Vdi_si+T4_Vdi_si*T4_Ve_si+T4*T4_Ve_si_Vdi_si));
  T10_Ve_si_Tempt_GND=(+(+0.0-T11_Ve_si_Tempt_GND)+(+T4_Ve_si_Tempt_GND*T4+T4_Ve_si*T4_Tempt_GND+T4_Tempt_GND*T4_Ve_si+T4*T4_Ve_si_Tempt_GND));
#endif
T10_Ve_di=((-T11_Ve_di)+((T4_Ve_di*T4)+(T4*T4_Ve_di)));
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+(+0.0-0.0)+(+T4_Ve_di_Vge_di*T4+T4_Ve_di*T4_Vge_di+T4_Vge_di*T4_Ve_di+T4*T4_Ve_di_Vge_di));
  T10_Ve_di_Vge_e=(+(+0.0-T11_Ve_di_Vge_e)+(+T4_Ve_di_Vge_e*T4+T4_Ve_di*T4_Vge_e+T4_Vge_e*T4_Ve_di+T4*T4_Ve_di_Vge_e));
  T10_Ve_di_Ve_si=(+(+0.0-T11_Ve_di_Ve_si)+(+T4_Ve_di_Ve_si*T4+T4_Ve_di*T4_Ve_si+T4_Ve_si*T4_Ve_di+T4*T4_Ve_di_Ve_si));
  T10_Ve_di_Ve_di=(+(+0.0-T11_Ve_di_Ve_di)+(+T4_Ve_di_Ve_di*T4+T4_Ve_di*T4_Ve_di+T4_Ve_di*T4_Ve_di+T4*T4_Ve_di_Ve_di));
  T10_Ve_di_Vge_si=(+(+0.0-T11_Ve_di_Vge_si)+(+T4_Ve_di_Vge_si*T4+T4_Ve_di*T4_Vge_si+T4_Vge_si*T4_Ve_di+T4*T4_Ve_di_Vge_si));
  T10_Ve_di_Vdi_si=(+(+0.0-T11_Ve_di_Vdi_si)+(+T4_Ve_di_Vdi_si*T4+T4_Ve_di*T4_Vdi_si+T4_Vdi_si*T4_Ve_di+T4*T4_Ve_di_Vdi_si));
  T10_Ve_di_Tempt_GND=(+(+0.0-T11_Ve_di_Tempt_GND)+(+T4_Ve_di_Tempt_GND*T4+T4_Ve_di*T4_Tempt_GND+T4_Tempt_GND*T4_Ve_di+T4*T4_Ve_di_Tempt_GND));
#endif
T10_Vge_si=((-T11_Vge_si)+((T4_Vge_si*T4)+(T4*T4_Vge_si)));
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+(+0.0-0.0)+(+T4_Vge_si_Vge_di*T4+T4_Vge_si*T4_Vge_di+T4_Vge_di*T4_Vge_si+T4*T4_Vge_si_Vge_di));
  T10_Vge_si_Vge_e=(+(+0.0-T11_Vge_si_Vge_e)+(+T4_Vge_si_Vge_e*T4+T4_Vge_si*T4_Vge_e+T4_Vge_e*T4_Vge_si+T4*T4_Vge_si_Vge_e));
  T10_Vge_si_Ve_si=(+(+0.0-T11_Vge_si_Ve_si)+(+T4_Vge_si_Ve_si*T4+T4_Vge_si*T4_Ve_si+T4_Ve_si*T4_Vge_si+T4*T4_Vge_si_Ve_si));
  T10_Vge_si_Ve_di=(+(+0.0-T11_Vge_si_Ve_di)+(+T4_Vge_si_Ve_di*T4+T4_Vge_si*T4_Ve_di+T4_Ve_di*T4_Vge_si+T4*T4_Vge_si_Ve_di));
  T10_Vge_si_Vge_si=(+(+0.0-T11_Vge_si_Vge_si)+(+T4_Vge_si_Vge_si*T4+T4_Vge_si*T4_Vge_si+T4_Vge_si*T4_Vge_si+T4*T4_Vge_si_Vge_si));
  T10_Vge_si_Vdi_si=(+(+0.0-T11_Vge_si_Vdi_si)+(+T4_Vge_si_Vdi_si*T4+T4_Vge_si*T4_Vdi_si+T4_Vdi_si*T4_Vge_si+T4*T4_Vge_si_Vdi_si));
  T10_Vge_si_Tempt_GND=(+(+0.0-T11_Vge_si_Tempt_GND)+(+T4_Vge_si_Tempt_GND*T4+T4_Vge_si*T4_Tempt_GND+T4_Tempt_GND*T4_Vge_si+T4*T4_Vge_si_Tempt_GND));
#endif
T10_Vdi_si=((-T11_Vdi_si)+((T4_Vdi_si*T4)+(T4*T4_Vdi_si)));
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+(+0.0-0.0)+(+T4_Vdi_si_Vge_di*T4+T4_Vdi_si*T4_Vge_di+T4_Vge_di*T4_Vdi_si+T4*T4_Vdi_si_Vge_di));
  T10_Vdi_si_Vge_e=(+(+0.0-T11_Vdi_si_Vge_e)+(+T4_Vdi_si_Vge_e*T4+T4_Vdi_si*T4_Vge_e+T4_Vge_e*T4_Vdi_si+T4*T4_Vdi_si_Vge_e));
  T10_Vdi_si_Ve_si=(+(+0.0-T11_Vdi_si_Ve_si)+(+T4_Vdi_si_Ve_si*T4+T4_Vdi_si*T4_Ve_si+T4_Ve_si*T4_Vdi_si+T4*T4_Vdi_si_Ve_si));
  T10_Vdi_si_Ve_di=(+(+0.0-T11_Vdi_si_Ve_di)+(+T4_Vdi_si_Ve_di*T4+T4_Vdi_si*T4_Ve_di+T4_Ve_di*T4_Vdi_si+T4*T4_Vdi_si_Ve_di));
  T10_Vdi_si_Vge_si=(+(+0.0-T11_Vdi_si_Vge_si)+(+T4_Vdi_si_Vge_si*T4+T4_Vdi_si*T4_Vge_si+T4_Vge_si*T4_Vdi_si+T4*T4_Vdi_si_Vge_si));
  T10_Vdi_si_Vdi_si=(+(+0.0-T11_Vdi_si_Vdi_si)+(+T4_Vdi_si_Vdi_si*T4+T4_Vdi_si*T4_Vdi_si+T4_Vdi_si*T4_Vdi_si+T4*T4_Vdi_si_Vdi_si));
  T10_Vdi_si_Tempt_GND=(+(+0.0-T11_Vdi_si_Tempt_GND)+(+T4_Vdi_si_Tempt_GND*T4+T4_Vdi_si*T4_Tempt_GND+T4_Tempt_GND*T4_Vdi_si+T4*T4_Vdi_si_Tempt_GND));
#endif
T10_Tempt_GND=((-T11_Tempt_GND)+((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND)));
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+(+0.0-0.0)+(+T4_Tempt_GND_Vge_di*T4+T4_Tempt_GND*T4_Vge_di+T4_Vge_di*T4_Tempt_GND+T4*T4_Tempt_GND_Vge_di));
  T10_Tempt_GND_Vge_e=(+(+0.0-T11_Tempt_GND_Vge_e)+(+T4_Tempt_GND_Vge_e*T4+T4_Tempt_GND*T4_Vge_e+T4_Vge_e*T4_Tempt_GND+T4*T4_Tempt_GND_Vge_e));
  T10_Tempt_GND_Ve_si=(+(+0.0-T11_Tempt_GND_Ve_si)+(+T4_Tempt_GND_Ve_si*T4+T4_Tempt_GND*T4_Ve_si+T4_Ve_si*T4_Tempt_GND+T4*T4_Tempt_GND_Ve_si));
  T10_Tempt_GND_Ve_di=(+(+0.0-T11_Tempt_GND_Ve_di)+(+T4_Tempt_GND_Ve_di*T4+T4_Tempt_GND*T4_Ve_di+T4_Ve_di*T4_Tempt_GND+T4*T4_Tempt_GND_Ve_di));
  T10_Tempt_GND_Vge_si=(+(+0.0-T11_Tempt_GND_Vge_si)+(+T4_Tempt_GND_Vge_si*T4+T4_Tempt_GND*T4_Vge_si+T4_Vge_si*T4_Tempt_GND+T4*T4_Tempt_GND_Vge_si));
  T10_Tempt_GND_Vdi_si=(+(+0.0-T11_Tempt_GND_Vdi_si)+(+T4_Tempt_GND_Vdi_si*T4+T4_Tempt_GND*T4_Vdi_si+T4_Vdi_si*T4_Tempt_GND+T4*T4_Tempt_GND_Vdi_si));
  T10_Tempt_GND_Tempt_GND=(+(+0.0-T11_Tempt_GND_Tempt_GND)+(+T4_Tempt_GND_Tempt_GND*T4+T4_Tempt_GND*T4_Tempt_GND+T4_Tempt_GND*T4_Tempt_GND+T4*T4_Tempt_GND_Tempt_GND));
#endif
#endif
T10=((1.0-T11)+(T4*T4));
EXIT_IF_ISNAN(((1.0-T11)+(T4*T4)))
}
}
}
{
double m00_exp(d00_exp0,(-T10))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=(-T10_Vge_e)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Vdi_d=(+0.0-0.0);
  T6_Vge_e_Vsi_s=(+0.0-0.0);
  T6_Vge_e_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
  T6_Vge_e_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vge_e)+d10_exp0*0.0)-0.0);
#endif
T6_Vdi_si=(-T10_Vdi_si)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Vdi_d=(+0.0-0.0);
  T6_Vdi_si_Vsi_s=(+0.0-0.0);
  T6_Vdi_si_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
  T6_Vdi_si_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vdi_si)+d10_exp0*0.0)-0.0);
#endif
T6_Tempt_GND=(-T10_Tempt_GND)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Vdi_d=(+0.0-0.0);
  T6_Tempt_GND_Vsi_s=(+0.0-0.0);
  T6_Tempt_GND_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
  T6_Tempt_GND_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Tempt_GND)+d10_exp0*0.0)-0.0);
#endif
T6_Ve_si=(-T10_Ve_si)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Vdi_d=(+0.0-0.0);
  T6_Ve_si_Vsi_s=(+0.0-0.0);
  T6_Ve_si_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
  T6_Ve_si_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Ve_si)+d10_exp0*0.0)-0.0);
#endif
T6_Ve_di=(-T10_Ve_di)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Vdi_d=(+0.0-0.0);
  T6_Ve_di_Vsi_s=(+0.0-0.0);
  T6_Ve_di_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
  T6_Ve_di_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Ve_di)+d10_exp0*0.0)-0.0);
#endif
T6_Vge_si=(-T10_Vge_si)*d10_exp0;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(m20_exp((-T10))*(-T10_Vge_di)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Vdi_d=(+0.0-0.0);
  T6_Vge_si_Vsi_s=(+0.0-0.0);
  T6_Vge_si_Vge_e=(+(m20_exp((-T10))*(-T10_Vge_e)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Vdi_si=(+(m20_exp((-T10))*(-T10_Vdi_si)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Tempt_GND=(+(m20_exp((-T10))*(-T10_Tempt_GND)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Ve_si=(+(m20_exp((-T10))*(-T10_Ve_si)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Ve_di=(+(m20_exp((-T10))*(-T10_Ve_di)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
  T6_Vge_si_Vge_si=(+(m20_exp((-T10))*(-T10_Vge_si)*(-T10_Vge_si)+d10_exp0*0.0)-0.0);
#endif
#endif
T6=(d00_exp0-1.0);
EXIT_IF_ISNAN((d00_exp0-1.0))
}
{
double m00_sqrt(d00_sqrt0,(T6+T10))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(T6+T10))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=(T6_Vge_e+T10_Vge_e)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vge_di+T10_Vge_e_Vge_di));
  T7_Vge_e_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vdi_d+0.0));
  T7_Vge_e_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vsi_s+0.0));
  T7_Vge_e_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vge_e+T10_Vge_e_Vge_e));
  T7_Vge_e_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vdi_si+T10_Vge_e_Vdi_si));
  T7_Vge_e_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Ve_si+T10_Vge_e_Ve_si));
  T7_Vge_e_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Ve_di+T10_Vge_e_Ve_di));
  T7_Vge_e_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Vge_si+T10_Vge_e_Vge_si));
  T7_Vge_e_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Vge_e+T10_Vge_e)+d10_sqrt0*(+T6_Vge_e_Tempt_GND+T10_Vge_e_Tempt_GND));
#endif
T7_Vdi_si=(T6_Vdi_si+T10_Vdi_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vge_di+T10_Vdi_si_Vge_di));
  T7_Vdi_si_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vdi_d+0.0));
  T7_Vdi_si_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vsi_s+0.0));
  T7_Vdi_si_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vge_e+T10_Vdi_si_Vge_e));
  T7_Vdi_si_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vdi_si+T10_Vdi_si_Vdi_si));
  T7_Vdi_si_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Ve_si+T10_Vdi_si_Ve_si));
  T7_Vdi_si_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Ve_di+T10_Vdi_si_Ve_di));
  T7_Vdi_si_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Vge_si+T10_Vdi_si_Vge_si));
  T7_Vdi_si_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Vdi_si+T10_Vdi_si)+d10_sqrt0*(+T6_Vdi_si_Tempt_GND+T10_Vdi_si_Tempt_GND));
#endif
T7_Ve_si=(T6_Ve_si+T10_Ve_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vge_di+T10_Ve_si_Vge_di));
  T7_Ve_si_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vdi_d+0.0));
  T7_Ve_si_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vsi_s+0.0));
  T7_Ve_si_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vge_e+T10_Ve_si_Vge_e));
  T7_Ve_si_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vdi_si+T10_Ve_si_Vdi_si));
  T7_Ve_si_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Ve_si+T10_Ve_si_Ve_si));
  T7_Ve_si_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Ve_di+T10_Ve_si_Ve_di));
  T7_Ve_si_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Vge_si+T10_Ve_si_Vge_si));
  T7_Ve_si_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Ve_si+T10_Ve_si)+d10_sqrt0*(+T6_Ve_si_Tempt_GND+T10_Ve_si_Tempt_GND));
#endif
T7_Ve_di=(T6_Ve_di+T10_Ve_di)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vge_di+T10_Ve_di_Vge_di));
  T7_Ve_di_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vdi_d+0.0));
  T7_Ve_di_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vsi_s+0.0));
  T7_Ve_di_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vge_e+T10_Ve_di_Vge_e));
  T7_Ve_di_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vdi_si+T10_Ve_di_Vdi_si));
  T7_Ve_di_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Ve_si+T10_Ve_di_Ve_si));
  T7_Ve_di_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Ve_di+T10_Ve_di_Ve_di));
  T7_Ve_di_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Vge_si+T10_Ve_di_Vge_si));
  T7_Ve_di_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Ve_di+T10_Ve_di)+d10_sqrt0*(+T6_Ve_di_Tempt_GND+T10_Ve_di_Tempt_GND));
#endif
T7_Vge_si=(T6_Vge_si+T10_Vge_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vge_di+T10_Vge_si_Vge_di));
  T7_Vge_si_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vdi_d+0.0));
  T7_Vge_si_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vsi_s+0.0));
  T7_Vge_si_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vge_e+T10_Vge_si_Vge_e));
  T7_Vge_si_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vdi_si+T10_Vge_si_Vdi_si));
  T7_Vge_si_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Ve_si+T10_Vge_si_Ve_si));
  T7_Vge_si_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Ve_di+T10_Vge_si_Ve_di));
  T7_Vge_si_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Vge_si+T10_Vge_si_Vge_si));
  T7_Vge_si_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Vge_si+T10_Vge_si)+d10_sqrt0*(+T6_Vge_si_Tempt_GND+T10_Vge_si_Tempt_GND));
#endif
T7_Tempt_GND=(T6_Tempt_GND+T10_Tempt_GND)*d10_sqrt0;
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=(m20_sqrt((T6+T10))*(T6_Vge_di+T10_Vge_di)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vge_di+T10_Tempt_GND_Vge_di));
  T7_Tempt_GND_Vdi_d=(m20_sqrt((T6+T10))*T6_Vdi_d*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vdi_d+0.0));
  T7_Tempt_GND_Vsi_s=(m20_sqrt((T6+T10))*T6_Vsi_s*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vsi_s+0.0));
  T7_Tempt_GND_Vge_e=(m20_sqrt((T6+T10))*(T6_Vge_e+T10_Vge_e)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vge_e+T10_Tempt_GND_Vge_e));
  T7_Tempt_GND_Vdi_si=(m20_sqrt((T6+T10))*(T6_Vdi_si+T10_Vdi_si)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vdi_si+T10_Tempt_GND_Vdi_si));
  T7_Tempt_GND_Ve_si=(m20_sqrt((T6+T10))*(T6_Ve_si+T10_Ve_si)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Ve_si+T10_Tempt_GND_Ve_si));
  T7_Tempt_GND_Ve_di=(m20_sqrt((T6+T10))*(T6_Ve_di+T10_Ve_di)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Ve_di+T10_Tempt_GND_Ve_di));
  T7_Tempt_GND_Vge_si=(m20_sqrt((T6+T10))*(T6_Vge_si+T10_Vge_si)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Vge_si+T10_Tempt_GND_Vge_si));
  T7_Tempt_GND_Tempt_GND=(m20_sqrt((T6+T10))*(T6_Tempt_GND+T10_Tempt_GND)*(T6_Tempt_GND+T10_Tempt_GND)+d10_sqrt0*(+T6_Tempt_GND_Tempt_GND+T10_Tempt_GND_Tempt_GND));
#endif
#endif
T7=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((T10>1.0e-15))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=((-(T2_Vge_e-T10_Vge_e))+((T9_Vge_e*T7)+(T9*T7_Vge_e)));
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=(+0.0+(+T9_Vge_e_Vge_e*T7+T9_Vge_e*T7_Vge_e+T9_Vge_e*T7_Vge_e+T9*T7_Vge_e_Vge_e));
  e0_Vge_e_Vge_si=(+0.0+(+T9_Vge_e_Vge_si*T7+T9_Vge_e*T7_Vge_si+T9_Vge_si*T7_Vge_e+T9*T7_Vge_e_Vge_si));
  e0_Vge_e_Ve_si=(+0.0+(+T9_Vge_e_Ve_si*T7+T9_Vge_e*T7_Ve_si+T9_Ve_si*T7_Vge_e+T9*T7_Vge_e_Ve_si));
  e0_Vge_e_Ve_di=(+0.0+(+T9_Vge_e_Ve_di*T7+T9_Vge_e*T7_Ve_di+T9_Ve_di*T7_Vge_e+T9*T7_Vge_e_Ve_di));
  e0_Vge_e_Vdi_si=(+0.0+(+T9_Vge_e_Vdi_si*T7+T9_Vge_e*T7_Vdi_si+T9_Vdi_si*T7_Vge_e+T9*T7_Vge_e_Vdi_si));
  e0_Vge_e_Tempt_GND=(+0.0+(+T9_Vge_e_Tempt_GND*T7+T9_Vge_e*T7_Tempt_GND+T9_Tempt_GND*T7_Vge_e+T9*T7_Vge_e_Tempt_GND));
#endif
e0_Vge_si=((-(T2_Vge_si-T10_Vge_si))+((T9_Vge_si*T7)+(T9*T7_Vge_si)));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+0.0+(+T9_Vge_si_Vge_e*T7+T9_Vge_si*T7_Vge_e+T9_Vge_e*T7_Vge_si+T9*T7_Vge_si_Vge_e));
  e0_Vge_si_Vge_si=(+0.0+(+T9_Vge_si_Vge_si*T7+T9_Vge_si*T7_Vge_si+T9_Vge_si*T7_Vge_si+T9*T7_Vge_si_Vge_si));
  e0_Vge_si_Ve_si=(+0.0+(+T9_Vge_si_Ve_si*T7+T9_Vge_si*T7_Ve_si+T9_Ve_si*T7_Vge_si+T9*T7_Vge_si_Ve_si));
  e0_Vge_si_Ve_di=(+0.0+(+T9_Vge_si_Ve_di*T7+T9_Vge_si*T7_Ve_di+T9_Ve_di*T7_Vge_si+T9*T7_Vge_si_Ve_di));
  e0_Vge_si_Vdi_si=(+0.0+(+T9_Vge_si_Vdi_si*T7+T9_Vge_si*T7_Vdi_si+T9_Vdi_si*T7_Vge_si+T9*T7_Vge_si_Vdi_si));
  e0_Vge_si_Tempt_GND=(+0.0+(+T9_Vge_si_Tempt_GND*T7+T9_Vge_si*T7_Tempt_GND+T9_Tempt_GND*T7_Vge_si+T9*T7_Vge_si_Tempt_GND));
#endif
e0_Ve_si=((-(T2_Ve_si-T10_Ve_si))+((T9_Ve_si*T7)+(T9*T7_Ve_si)));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+0.0+(+T9_Ve_si_Vge_e*T7+T9_Ve_si*T7_Vge_e+T9_Vge_e*T7_Ve_si+T9*T7_Ve_si_Vge_e));
  e0_Ve_si_Vge_si=(+0.0+(+T9_Ve_si_Vge_si*T7+T9_Ve_si*T7_Vge_si+T9_Vge_si*T7_Ve_si+T9*T7_Ve_si_Vge_si));
  e0_Ve_si_Ve_si=(+0.0+(+T9_Ve_si_Ve_si*T7+T9_Ve_si*T7_Ve_si+T9_Ve_si*T7_Ve_si+T9*T7_Ve_si_Ve_si));
  e0_Ve_si_Ve_di=(+0.0+(+T9_Ve_si_Ve_di*T7+T9_Ve_si*T7_Ve_di+T9_Ve_di*T7_Ve_si+T9*T7_Ve_si_Ve_di));
  e0_Ve_si_Vdi_si=(+0.0+(+T9_Ve_si_Vdi_si*T7+T9_Ve_si*T7_Vdi_si+T9_Vdi_si*T7_Ve_si+T9*T7_Ve_si_Vdi_si));
  e0_Ve_si_Tempt_GND=(+0.0+(+T9_Ve_si_Tempt_GND*T7+T9_Ve_si*T7_Tempt_GND+T9_Tempt_GND*T7_Ve_si+T9*T7_Ve_si_Tempt_GND));
#endif
e0_Ve_di=((-(T2_Ve_di-T10_Ve_di))+((T9_Ve_di*T7)+(T9*T7_Ve_di)));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+0.0+(+T9_Ve_di_Vge_e*T7+T9_Ve_di*T7_Vge_e+T9_Vge_e*T7_Ve_di+T9*T7_Ve_di_Vge_e));
  e0_Ve_di_Vge_si=(+0.0+(+T9_Ve_di_Vge_si*T7+T9_Ve_di*T7_Vge_si+T9_Vge_si*T7_Ve_di+T9*T7_Ve_di_Vge_si));
  e0_Ve_di_Ve_si=(+0.0+(+T9_Ve_di_Ve_si*T7+T9_Ve_di*T7_Ve_si+T9_Ve_si*T7_Ve_di+T9*T7_Ve_di_Ve_si));
  e0_Ve_di_Ve_di=(+0.0+(+T9_Ve_di_Ve_di*T7+T9_Ve_di*T7_Ve_di+T9_Ve_di*T7_Ve_di+T9*T7_Ve_di_Ve_di));
  e0_Ve_di_Vdi_si=(+0.0+(+T9_Ve_di_Vdi_si*T7+T9_Ve_di*T7_Vdi_si+T9_Vdi_si*T7_Ve_di+T9*T7_Ve_di_Vdi_si));
  e0_Ve_di_Tempt_GND=(+0.0+(+T9_Ve_di_Tempt_GND*T7+T9_Ve_di*T7_Tempt_GND+T9_Tempt_GND*T7_Ve_di+T9*T7_Ve_di_Tempt_GND));
#endif
e0_Vdi_si=((-(T2_Vdi_si-T10_Vdi_si))+((T9_Vdi_si*T7)+(T9*T7_Vdi_si)));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+0.0+(+T9_Vdi_si_Vge_e*T7+T9_Vdi_si*T7_Vge_e+T9_Vge_e*T7_Vdi_si+T9*T7_Vdi_si_Vge_e));
  e0_Vdi_si_Vge_si=(+0.0+(+T9_Vdi_si_Vge_si*T7+T9_Vdi_si*T7_Vge_si+T9_Vge_si*T7_Vdi_si+T9*T7_Vdi_si_Vge_si));
  e0_Vdi_si_Ve_si=(+0.0+(+T9_Vdi_si_Ve_si*T7+T9_Vdi_si*T7_Ve_si+T9_Ve_si*T7_Vdi_si+T9*T7_Vdi_si_Ve_si));
  e0_Vdi_si_Ve_di=(+0.0+(+T9_Vdi_si_Ve_di*T7+T9_Vdi_si*T7_Ve_di+T9_Ve_di*T7_Vdi_si+T9*T7_Vdi_si_Ve_di));
  e0_Vdi_si_Vdi_si=(+0.0+(+T9_Vdi_si_Vdi_si*T7+T9_Vdi_si*T7_Vdi_si+T9_Vdi_si*T7_Vdi_si+T9*T7_Vdi_si_Vdi_si));
  e0_Vdi_si_Tempt_GND=(+0.0+(+T9_Vdi_si_Tempt_GND*T7+T9_Vdi_si*T7_Tempt_GND+T9_Tempt_GND*T7_Vdi_si+T9*T7_Vdi_si_Tempt_GND));
#endif
e0_Tempt_GND=((-(T2_Tempt_GND-T10_Tempt_GND))+((T9_Tempt_GND*T7)+(T9*T7_Tempt_GND)));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+0.0+(+T9_Tempt_GND_Vge_e*T7+T9_Tempt_GND*T7_Vge_e+T9_Vge_e*T7_Tempt_GND+T9*T7_Tempt_GND_Vge_e));
  e0_Tempt_GND_Vge_si=(+0.0+(+T9_Tempt_GND_Vge_si*T7+T9_Tempt_GND*T7_Vge_si+T9_Vge_si*T7_Tempt_GND+T9*T7_Tempt_GND_Vge_si));
  e0_Tempt_GND_Ve_si=(+0.0+(+T9_Tempt_GND_Ve_si*T7+T9_Tempt_GND*T7_Ve_si+T9_Ve_si*T7_Tempt_GND+T9*T7_Tempt_GND_Ve_si));
  e0_Tempt_GND_Ve_di=(+0.0+(+T9_Tempt_GND_Ve_di*T7+T9_Tempt_GND*T7_Ve_di+T9_Ve_di*T7_Tempt_GND+T9*T7_Tempt_GND_Ve_di));
  e0_Tempt_GND_Vdi_si=(+0.0+(+T9_Tempt_GND_Vdi_si*T7+T9_Tempt_GND*T7_Vdi_si+T9_Vdi_si*T7_Tempt_GND+T9*T7_Tempt_GND_Vdi_si));
  e0_Tempt_GND_Tempt_GND=(+0.0+(+T9_Tempt_GND_Tempt_GND*T7+T9_Tempt_GND*T7_Tempt_GND+T9_Tempt_GND*T7_Tempt_GND+T9*T7_Tempt_GND_Tempt_GND));
#endif
#endif
e0=((-(T2-T10))+(T9*T7));
EXIT_IF_ISNAN(((-(T2-T10))+(T9*T7)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=(-((((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7-((T9*0.5)*T6)*T7_Vge_e)/T7/T7));
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=(+0.0-((+(+T9_Vge_e_Vge_e*0.5+T9_Vge_e*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vge_e)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vge_e/T7/T7/T7));
  e1_Vge_e_Vdi_si=(+0.0-((+(+T9_Vge_e_Vdi_si*0.5+T9_Vge_e*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vdi_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vdi_si/T7/T7/T7));
  e1_Vge_e_Ve_si=(+0.0-((+(+T9_Vge_e_Ve_si*0.5+T9_Vge_e*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Ve_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Ve_si/T7/T7/T7));
  e1_Vge_e_Ve_di=(+0.0-((+(+T9_Vge_e_Ve_di*0.5+T9_Vge_e*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Ve_di)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Ve_di/T7/T7/T7));
  e1_Vge_e_Vge_si=(+0.0-((+(+T9_Vge_e_Vge_si*0.5+T9_Vge_e*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vge_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vge_si/T7/T7/T7));
  e1_Vge_e_Tempt_GND=(+0.0-((+(+T9_Vge_e_Tempt_GND*0.5+T9_Vge_e*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Tempt_GND)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Vdi_si=(-((((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7-((T9*0.5)*T6)*T7_Vdi_si)/T7/T7));
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+0.0-((+(+T9_Vdi_si_Vge_e*0.5+T9_Vdi_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vge_e)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vge_e/T7/T7/T7));
  e1_Vdi_si_Vdi_si=(+0.0-((+(+T9_Vdi_si_Vdi_si*0.5+T9_Vdi_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vdi_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vdi_si/T7/T7/T7));
  e1_Vdi_si_Ve_si=(+0.0-((+(+T9_Vdi_si_Ve_si*0.5+T9_Vdi_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Ve_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Ve_si/T7/T7/T7));
  e1_Vdi_si_Ve_di=(+0.0-((+(+T9_Vdi_si_Ve_di*0.5+T9_Vdi_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Ve_di)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Ve_di/T7/T7/T7));
  e1_Vdi_si_Vge_si=(+0.0-((+(+T9_Vdi_si_Vge_si*0.5+T9_Vdi_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vge_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vge_si/T7/T7/T7));
  e1_Vdi_si_Tempt_GND=(+0.0-((+(+T9_Vdi_si_Tempt_GND*0.5+T9_Vdi_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Tempt_GND)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Ve_si=(-((((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7-((T9*0.5)*T6)*T7_Ve_si)/T7/T7));
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+0.0-((+(+T9_Ve_si_Vge_e*0.5+T9_Ve_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vge_e)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vge_e/T7/T7/T7));
  e1_Ve_si_Vdi_si=(+0.0-((+(+T9_Ve_si_Vdi_si*0.5+T9_Ve_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vdi_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vdi_si/T7/T7/T7));
  e1_Ve_si_Ve_si=(+0.0-((+(+T9_Ve_si_Ve_si*0.5+T9_Ve_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Ve_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Ve_si/T7/T7/T7));
  e1_Ve_si_Ve_di=(+0.0-((+(+T9_Ve_si_Ve_di*0.5+T9_Ve_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Ve_di)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Ve_di/T7/T7/T7));
  e1_Ve_si_Vge_si=(+0.0-((+(+T9_Ve_si_Vge_si*0.5+T9_Ve_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vge_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vge_si/T7/T7/T7));
  e1_Ve_si_Tempt_GND=(+0.0-((+(+T9_Ve_si_Tempt_GND*0.5+T9_Ve_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Tempt_GND)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Ve_di=(-((((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7-((T9*0.5)*T6)*T7_Ve_di)/T7/T7));
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+0.0-((+(+T9_Ve_di_Vge_e*0.5+T9_Ve_di*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vge_e)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vge_e/T7/T7/T7));
  e1_Ve_di_Vdi_si=(+0.0-((+(+T9_Ve_di_Vdi_si*0.5+T9_Ve_di*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vdi_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vdi_si/T7/T7/T7));
  e1_Ve_di_Ve_si=(+0.0-((+(+T9_Ve_di_Ve_si*0.5+T9_Ve_di*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Ve_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Ve_si/T7/T7/T7));
  e1_Ve_di_Ve_di=(+0.0-((+(+T9_Ve_di_Ve_di*0.5+T9_Ve_di*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Ve_di)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Ve_di/T7/T7/T7));
  e1_Ve_di_Vge_si=(+0.0-((+(+T9_Ve_di_Vge_si*0.5+T9_Ve_di*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vge_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vge_si/T7/T7/T7));
  e1_Ve_di_Tempt_GND=(+0.0-((+(+T9_Ve_di_Tempt_GND*0.5+T9_Ve_di*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Tempt_GND)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Vge_si=(-((((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7-((T9*0.5)*T6)*T7_Vge_si)/T7/T7));
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+0.0-((+(+T9_Vge_si_Vge_e*0.5+T9_Vge_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vge_e)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vge_e/T7/T7/T7));
  e1_Vge_si_Vdi_si=(+0.0-((+(+T9_Vge_si_Vdi_si*0.5+T9_Vge_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vdi_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vdi_si/T7/T7/T7));
  e1_Vge_si_Ve_si=(+0.0-((+(+T9_Vge_si_Ve_si*0.5+T9_Vge_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Ve_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Ve_si/T7/T7/T7));
  e1_Vge_si_Ve_di=(+0.0-((+(+T9_Vge_si_Ve_di*0.5+T9_Vge_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Ve_di)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Ve_di/T7/T7/T7));
  e1_Vge_si_Vge_si=(+0.0-((+(+T9_Vge_si_Vge_si*0.5+T9_Vge_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vge_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vge_si/T7/T7/T7));
  e1_Vge_si_Tempt_GND=(+0.0-((+(+T9_Vge_si_Tempt_GND*0.5+T9_Vge_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Tempt_GND)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Tempt_GND=(-((((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7-((T9*0.5)*T6)*T7_Tempt_GND)/T7/T7));
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+0.0-((+(+T9_Tempt_GND_Vge_e*0.5+T9_Tempt_GND*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vge_e)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vge_e/T7/T7/T7));
  e1_Tempt_GND_Vdi_si=(+0.0-((+(+T9_Tempt_GND_Vdi_si*0.5+T9_Tempt_GND*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vdi_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vdi_si/T7/T7/T7));
  e1_Tempt_GND_Ve_si=(+0.0-((+(+T9_Tempt_GND_Ve_si*0.5+T9_Tempt_GND*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Ve_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Ve_si/T7/T7/T7));
  e1_Tempt_GND_Ve_di=(+0.0-((+(+T9_Tempt_GND_Ve_di*0.5+T9_Tempt_GND*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Ve_di)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Ve_di/T7/T7/T7));
  e1_Tempt_GND_Vge_si=(+0.0-((+(+T9_Tempt_GND_Vge_si*0.5+T9_Tempt_GND*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vge_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vge_si/T7/T7/T7));
  e1_Tempt_GND_Tempt_GND=(+0.0-((+(+T9_Tempt_GND_Tempt_GND*0.5+T9_Tempt_GND*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Tempt_GND)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Tempt_GND/T7/T7/T7));
#endif
#endif
e1=(1.0-(((T9*0.5)*T6)/T7));
EXIT_IF_ISNAN((1.0-(((T9*0.5)*T6)/T7)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=(T10_Vge_e-((e0_Vge_e*e1-e0*e1_Vge_e)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=(+T10_Vge_e_Vge_e-(e0_Vge_e_Vge_e/e1-(e0_Vge_e*e1_Vge_e+e0_Vge_e*e1_Vge_e+e0*e1_Vge_e_Vge_e)/e1/e1+2*e0*e1_Vge_e*e1_Vge_e/e1/e1/e1));
  T8_Vge_e_Vdi_si=(+T10_Vge_e_Vdi_si-(e0_Vge_e_Vdi_si/e1-(e0_Vge_e*e1_Vdi_si+e0_Vdi_si*e1_Vge_e+e0*e1_Vge_e_Vdi_si)/e1/e1+2*e0*e1_Vge_e*e1_Vdi_si/e1/e1/e1));
  T8_Vge_e_Ve_si=(+T10_Vge_e_Ve_si-(e0_Vge_e_Ve_si/e1-(e0_Vge_e*e1_Ve_si+e0_Ve_si*e1_Vge_e+e0*e1_Vge_e_Ve_si)/e1/e1+2*e0*e1_Vge_e*e1_Ve_si/e1/e1/e1));
  T8_Vge_e_Ve_di=(+T10_Vge_e_Ve_di-(e0_Vge_e_Ve_di/e1-(e0_Vge_e*e1_Ve_di+e0_Ve_di*e1_Vge_e+e0*e1_Vge_e_Ve_di)/e1/e1+2*e0*e1_Vge_e*e1_Ve_di/e1/e1/e1));
  T8_Vge_e_Vge_si=(+T10_Vge_e_Vge_si-(e0_Vge_e_Vge_si/e1-(e0_Vge_e*e1_Vge_si+e0_Vge_si*e1_Vge_e+e0*e1_Vge_e_Vge_si)/e1/e1+2*e0*e1_Vge_e*e1_Vge_si/e1/e1/e1));
  T8_Vge_e_Tempt_GND=(+T10_Vge_e_Tempt_GND-(e0_Vge_e_Tempt_GND/e1-(e0_Vge_e*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_e+e0*e1_Vge_e_Tempt_GND)/e1/e1+2*e0*e1_Vge_e*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Vdi_si=(T10_Vdi_si-((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+T10_Vdi_si_Vge_e-(e0_Vdi_si_Vge_e/e1-(e0_Vdi_si*e1_Vge_e+e0_Vge_e*e1_Vdi_si+e0*e1_Vdi_si_Vge_e)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_e/e1/e1/e1));
  T8_Vdi_si_Vdi_si=(+T10_Vdi_si_Vdi_si-(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1));
  T8_Vdi_si_Ve_si=(+T10_Vdi_si_Ve_si-(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1));
  T8_Vdi_si_Ve_di=(+T10_Vdi_si_Ve_di-(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1));
  T8_Vdi_si_Vge_si=(+T10_Vdi_si_Vge_si-(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1));
  T8_Vdi_si_Tempt_GND=(+T10_Vdi_si_Tempt_GND-(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Ve_si=(T10_Ve_si-((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+T10_Ve_si_Vge_e-(e0_Ve_si_Vge_e/e1-(e0_Ve_si*e1_Vge_e+e0_Vge_e*e1_Ve_si+e0*e1_Ve_si_Vge_e)/e1/e1+2*e0*e1_Ve_si*e1_Vge_e/e1/e1/e1));
  T8_Ve_si_Vdi_si=(+T10_Ve_si_Vdi_si-(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1));
  T8_Ve_si_Ve_si=(+T10_Ve_si_Ve_si-(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1));
  T8_Ve_si_Ve_di=(+T10_Ve_si_Ve_di-(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1));
  T8_Ve_si_Vge_si=(+T10_Ve_si_Vge_si-(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1));
  T8_Ve_si_Tempt_GND=(+T10_Ve_si_Tempt_GND-(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Ve_di=(T10_Ve_di-((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1));
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+T10_Ve_di_Vge_e-(e0_Ve_di_Vge_e/e1-(e0_Ve_di*e1_Vge_e+e0_Vge_e*e1_Ve_di+e0*e1_Ve_di_Vge_e)/e1/e1+2*e0*e1_Ve_di*e1_Vge_e/e1/e1/e1));
  T8_Ve_di_Vdi_si=(+T10_Ve_di_Vdi_si-(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1));
  T8_Ve_di_Ve_si=(+T10_Ve_di_Ve_si-(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1));
  T8_Ve_di_Ve_di=(+T10_Ve_di_Ve_di-(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1));
  T8_Ve_di_Vge_si=(+T10_Ve_di_Vge_si-(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1));
  T8_Ve_di_Tempt_GND=(+T10_Ve_di_Tempt_GND-(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Vge_si=(T10_Vge_si-((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+T10_Vge_si_Vge_e-(e0_Vge_si_Vge_e/e1-(e0_Vge_si*e1_Vge_e+e0_Vge_e*e1_Vge_si+e0*e1_Vge_si_Vge_e)/e1/e1+2*e0*e1_Vge_si*e1_Vge_e/e1/e1/e1));
  T8_Vge_si_Vdi_si=(+T10_Vge_si_Vdi_si-(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1));
  T8_Vge_si_Ve_si=(+T10_Vge_si_Ve_si-(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1));
  T8_Vge_si_Ve_di=(+T10_Vge_si_Ve_di-(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1));
  T8_Vge_si_Vge_si=(+T10_Vge_si_Vge_si-(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1));
  T8_Vge_si_Tempt_GND=(+T10_Vge_si_Tempt_GND-(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Tempt_GND=(T10_Tempt_GND-((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1));
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+T10_Tempt_GND_Vge_e-(e0_Tempt_GND_Vge_e/e1-(e0_Tempt_GND*e1_Vge_e+e0_Vge_e*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_e)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_e/e1/e1/e1));
  T8_Tempt_GND_Vdi_si=(+T10_Tempt_GND_Vdi_si-(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1));
  T8_Tempt_GND_Ve_si=(+T10_Tempt_GND_Ve_si-(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1));
  T8_Tempt_GND_Ve_di=(+T10_Tempt_GND_Ve_di-(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1));
  T8_Tempt_GND_Vge_si=(+T10_Tempt_GND_Vge_si-(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1));
  T8_Tempt_GND_Tempt_GND=(+T10_Tempt_GND_Tempt_GND-(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1));
#endif
#endif
T8=(T10-(e0/e1));
EXIT_IF_ISNAN((T10-(e0/e1)))
{
double m00_exp(d00_exp0,(-T8))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T11_Vge_e=(-T8_Vge_e)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vge_e_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
  T11_Vge_e_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
  T11_Vge_e_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
  T11_Vge_e_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
  T11_Vge_e_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
  T11_Vge_e_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vge_e)+d10_exp0*0.0)-0.0);
#endif
T11_Ve_si=(-T8_Ve_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Ve_si_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
  T11_Ve_si_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
  T11_Ve_si_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
  T11_Ve_si_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
  T11_Ve_si_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
  T11_Ve_si_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Ve_si)+d10_exp0*0.0)-0.0);
#endif
T11_Ve_di=(-T8_Ve_di)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Ve_di_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
  T11_Ve_di_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
  T11_Ve_di_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
  T11_Ve_di_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
  T11_Ve_di_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
  T11_Ve_di_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Ve_di)+d10_exp0*0.0)-0.0);
#endif
T11_Vge_si=(-T8_Vge_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vge_si_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
  T11_Vge_si_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
  T11_Vge_si_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
  T11_Vge_si_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
  T11_Vge_si_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
  T11_Vge_si_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vge_si)+d10_exp0*0.0)-0.0);
#endif
T11_Vdi_si=(-T8_Vdi_si)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Vdi_si_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
  T11_Vdi_si_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
  T11_Vdi_si_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
  T11_Vdi_si_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
  T11_Vdi_si_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
  T11_Vdi_si_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vdi_si)+d10_exp0*0.0)-0.0);
#endif
T11_Tempt_GND=(-T8_Tempt_GND)*d10_exp0;
#if defined(_DERIVATE2)
  T11_Tempt_GND_Vge_e=(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
  T11_Tempt_GND_Ve_si=(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
  T11_Tempt_GND_Ve_di=(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
  T11_Tempt_GND_Vge_si=(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
  T11_Tempt_GND_Vdi_si=(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
  T11_Tempt_GND_Tempt_GND=(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Tempt_GND)+d10_exp0*0.0)-0.0);
#endif
#endif
T11=(d00_exp0-1.0);
EXIT_IF_ISNAN((d00_exp0-1.0))
}
{
double m00_sqrt(d00_sqrt0,(T11+T8))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(T11+T8))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T12_Vge_e=(T11_Vge_e+T8_Vge_e)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Vge_e_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Vge_e+T8_Vge_e_Vge_e));
  T12_Vge_e_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Ve_si+T8_Vge_e_Ve_si));
  T12_Vge_e_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Ve_di+T8_Vge_e_Ve_di));
  T12_Vge_e_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Vge_si+T8_Vge_e_Vge_si));
  T12_Vge_e_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Vdi_si+T8_Vge_e_Vdi_si));
  T12_Vge_e_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Vge_e+T8_Vge_e)+d10_sqrt0*(+T11_Vge_e_Tempt_GND+T8_Vge_e_Tempt_GND));
#endif
T12_Ve_si=(T11_Ve_si+T8_Ve_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Ve_si_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Vge_e+T8_Ve_si_Vge_e));
  T12_Ve_si_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Ve_si+T8_Ve_si_Ve_si));
  T12_Ve_si_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Ve_di+T8_Ve_si_Ve_di));
  T12_Ve_si_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Vge_si+T8_Ve_si_Vge_si));
  T12_Ve_si_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Vdi_si+T8_Ve_si_Vdi_si));
  T12_Ve_si_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Ve_si+T8_Ve_si)+d10_sqrt0*(+T11_Ve_si_Tempt_GND+T8_Ve_si_Tempt_GND));
#endif
T12_Ve_di=(T11_Ve_di+T8_Ve_di)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Ve_di_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Vge_e+T8_Ve_di_Vge_e));
  T12_Ve_di_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Ve_si+T8_Ve_di_Ve_si));
  T12_Ve_di_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Ve_di+T8_Ve_di_Ve_di));
  T12_Ve_di_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Vge_si+T8_Ve_di_Vge_si));
  T12_Ve_di_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Vdi_si+T8_Ve_di_Vdi_si));
  T12_Ve_di_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Ve_di+T8_Ve_di)+d10_sqrt0*(+T11_Ve_di_Tempt_GND+T8_Ve_di_Tempt_GND));
#endif
T12_Vge_si=(T11_Vge_si+T8_Vge_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Vge_si_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Vge_e+T8_Vge_si_Vge_e));
  T12_Vge_si_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Ve_si+T8_Vge_si_Ve_si));
  T12_Vge_si_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Ve_di+T8_Vge_si_Ve_di));
  T12_Vge_si_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Vge_si+T8_Vge_si_Vge_si));
  T12_Vge_si_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Vdi_si+T8_Vge_si_Vdi_si));
  T12_Vge_si_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Vge_si+T8_Vge_si)+d10_sqrt0*(+T11_Vge_si_Tempt_GND+T8_Vge_si_Tempt_GND));
#endif
T12_Vdi_si=(T11_Vdi_si+T8_Vdi_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Vdi_si_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Vge_e+T8_Vdi_si_Vge_e));
  T12_Vdi_si_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Ve_si+T8_Vdi_si_Ve_si));
  T12_Vdi_si_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Ve_di+T8_Vdi_si_Ve_di));
  T12_Vdi_si_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Vge_si+T8_Vdi_si_Vge_si));
  T12_Vdi_si_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Vdi_si+T8_Vdi_si_Vdi_si));
  T12_Vdi_si_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Vdi_si+T8_Vdi_si)+d10_sqrt0*(+T11_Vdi_si_Tempt_GND+T8_Vdi_si_Tempt_GND));
#endif
T12_Tempt_GND=(T11_Tempt_GND+T8_Tempt_GND)*d10_sqrt0;
#if defined(_DERIVATE2)
  T12_Tempt_GND_Vge_e=(m20_sqrt((T11+T8))*(T11_Vge_e+T8_Vge_e)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Vge_e+T8_Tempt_GND_Vge_e));
  T12_Tempt_GND_Ve_si=(m20_sqrt((T11+T8))*(T11_Ve_si+T8_Ve_si)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Ve_si+T8_Tempt_GND_Ve_si));
  T12_Tempt_GND_Ve_di=(m20_sqrt((T11+T8))*(T11_Ve_di+T8_Ve_di)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Ve_di+T8_Tempt_GND_Ve_di));
  T12_Tempt_GND_Vge_si=(m20_sqrt((T11+T8))*(T11_Vge_si+T8_Vge_si)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Vge_si+T8_Tempt_GND_Vge_si));
  T12_Tempt_GND_Vdi_si=(m20_sqrt((T11+T8))*(T11_Vdi_si+T8_Vdi_si)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Vdi_si+T8_Tempt_GND_Vdi_si));
  T12_Tempt_GND_Tempt_GND=(m20_sqrt((T11+T8))*(T11_Tempt_GND+T8_Tempt_GND)*(T11_Tempt_GND+T8_Tempt_GND)+d10_sqrt0*(+T11_Tempt_GND_Tempt_GND+T8_Tempt_GND_Tempt_GND));
#endif
#endif
T12=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qba_Tempt_GND=(((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*Vtm)+(((-T9)*T12)*Vtm_Tempt_GND));
#if defined(_DERIVATE2)
  qba_Tempt_GND_Tempt_GND=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Tempt_GND)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*Vtm_Tempt_GND+((-T9)*T12)*Vtm_Tempt_GND_Tempt_GND);
  qba_Tempt_GND_Vdi_si=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Vdi_si+(-T9_Vdi_si)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Vdi_si)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*Vtm_Tempt_GND+((-T9)*T12)*0.0);
  qba_Tempt_GND_Vge_e=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Vge_e+(-T9_Vge_e)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Vge_e)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*Vtm_Tempt_GND+((-T9)*T12)*0.0);
  qba_Tempt_GND_Ve_si=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Ve_si+(-T9_Ve_si)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Ve_si)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*Vtm_Tempt_GND+((-T9)*T12)*0.0);
  qba_Tempt_GND_Ve_di=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Ve_di+(-T9_Ve_di)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Ve_di)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*Vtm_Tempt_GND+((-T9)*T12)*0.0);
  qba_Tempt_GND_Vge_si=(+(+0.0*T12+(-T9_Tempt_GND)*T12_Vge_si+(-T9_Vge_si)*T12_Tempt_GND+(-T9)*T12_Tempt_GND_Vge_si)*Vtm+(((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*Vtm_Tempt_GND+((-T9)*T12)*0.0);
#endif
qba_Vdi_si=(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*Vtm;
#if defined(_DERIVATE2)
  qba_Vdi_si_Tempt_GND=(+(+0.0*T12+(-T9_Vdi_si)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Vdi_si+(-T9)*T12_Vdi_si_Tempt_GND)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*0.0+((-T9)*T12)*0.0);
  qba_Vdi_si_Vdi_si=(+(+0.0*T12+(-T9_Vdi_si)*T12_Vdi_si+(-T9_Vdi_si)*T12_Vdi_si+(-T9)*T12_Vdi_si_Vdi_si)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vdi_si_Vge_e=(+(+0.0*T12+(-T9_Vdi_si)*T12_Vge_e+(-T9_Vge_e)*T12_Vdi_si+(-T9)*T12_Vdi_si_Vge_e)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*0.0+((-T9)*T12)*0.0);
  qba_Vdi_si_Ve_si=(+(+0.0*T12+(-T9_Vdi_si)*T12_Ve_si+(-T9_Ve_si)*T12_Vdi_si+(-T9)*T12_Vdi_si_Ve_si)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vdi_si_Ve_di=(+(+0.0*T12+(-T9_Vdi_si)*T12_Ve_di+(-T9_Ve_di)*T12_Vdi_si+(-T9)*T12_Vdi_si_Ve_di)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*0.0+((-T9)*T12)*0.0);
  qba_Vdi_si_Vge_si=(+(+0.0*T12+(-T9_Vdi_si)*T12_Vge_si+(-T9_Vge_si)*T12_Vdi_si+(-T9)*T12_Vdi_si_Vge_si)*Vtm+(((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*0.0+((-T9)*T12)*0.0);
#endif
qba_Vge_e=(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*Vtm;
#if defined(_DERIVATE2)
  qba_Vge_e_Tempt_GND=(+(+0.0*T12+(-T9_Vge_e)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Vge_e+(-T9)*T12_Vge_e_Tempt_GND)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_e_Vdi_si=(+(+0.0*T12+(-T9_Vge_e)*T12_Vdi_si+(-T9_Vdi_si)*T12_Vge_e+(-T9)*T12_Vge_e_Vdi_si)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_e_Vge_e=(+(+0.0*T12+(-T9_Vge_e)*T12_Vge_e+(-T9_Vge_e)*T12_Vge_e+(-T9)*T12_Vge_e_Vge_e)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_e_Ve_si=(+(+0.0*T12+(-T9_Vge_e)*T12_Ve_si+(-T9_Ve_si)*T12_Vge_e+(-T9)*T12_Vge_e_Ve_si)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_e_Ve_di=(+(+0.0*T12+(-T9_Vge_e)*T12_Ve_di+(-T9_Ve_di)*T12_Vge_e+(-T9)*T12_Vge_e_Ve_di)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_e_Vge_si=(+(+0.0*T12+(-T9_Vge_e)*T12_Vge_si+(-T9_Vge_si)*T12_Vge_e+(-T9)*T12_Vge_e_Vge_si)*Vtm+(((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*0.0+((-T9)*T12)*0.0);
#endif
qba_Ve_si=(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*Vtm;
#if defined(_DERIVATE2)
  qba_Ve_si_Tempt_GND=(+(+0.0*T12+(-T9_Ve_si)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Ve_si+(-T9)*T12_Ve_si_Tempt_GND)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_si_Vdi_si=(+(+0.0*T12+(-T9_Ve_si)*T12_Vdi_si+(-T9_Vdi_si)*T12_Ve_si+(-T9)*T12_Ve_si_Vdi_si)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_si_Vge_e=(+(+0.0*T12+(-T9_Ve_si)*T12_Vge_e+(-T9_Vge_e)*T12_Ve_si+(-T9)*T12_Ve_si_Vge_e)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_si_Ve_si=(+(+0.0*T12+(-T9_Ve_si)*T12_Ve_si+(-T9_Ve_si)*T12_Ve_si+(-T9)*T12_Ve_si_Ve_si)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_si_Ve_di=(+(+0.0*T12+(-T9_Ve_si)*T12_Ve_di+(-T9_Ve_di)*T12_Ve_si+(-T9)*T12_Ve_si_Ve_di)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_si_Vge_si=(+(+0.0*T12+(-T9_Ve_si)*T12_Vge_si+(-T9_Vge_si)*T12_Ve_si+(-T9)*T12_Ve_si_Vge_si)*Vtm+(((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*0.0+((-T9)*T12)*0.0);
#endif
qba_Ve_di=(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*Vtm;
#if defined(_DERIVATE2)
  qba_Ve_di_Tempt_GND=(+(+0.0*T12+(-T9_Ve_di)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Ve_di+(-T9)*T12_Ve_di_Tempt_GND)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_di_Vdi_si=(+(+0.0*T12+(-T9_Ve_di)*T12_Vdi_si+(-T9_Vdi_si)*T12_Ve_di+(-T9)*T12_Ve_di_Vdi_si)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_di_Vge_e=(+(+0.0*T12+(-T9_Ve_di)*T12_Vge_e+(-T9_Vge_e)*T12_Ve_di+(-T9)*T12_Ve_di_Vge_e)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_di_Ve_si=(+(+0.0*T12+(-T9_Ve_di)*T12_Ve_si+(-T9_Ve_si)*T12_Ve_di+(-T9)*T12_Ve_di_Ve_si)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_di_Ve_di=(+(+0.0*T12+(-T9_Ve_di)*T12_Ve_di+(-T9_Ve_di)*T12_Ve_di+(-T9)*T12_Ve_di_Ve_di)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*0.0+((-T9)*T12)*0.0);
  qba_Ve_di_Vge_si=(+(+0.0*T12+(-T9_Ve_di)*T12_Vge_si+(-T9_Vge_si)*T12_Ve_di+(-T9)*T12_Ve_di_Vge_si)*Vtm+(((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*0.0+((-T9)*T12)*0.0);
#endif
qba_Vge_si=(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*Vtm;
#if defined(_DERIVATE2)
  qba_Vge_si_Tempt_GND=(+(+0.0*T12+(-T9_Vge_si)*T12_Tempt_GND+(-T9_Tempt_GND)*T12_Vge_si+(-T9)*T12_Vge_si_Tempt_GND)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*Vtm_Tempt_GND+((((-T9_Tempt_GND)*T12)+((-T9)*T12_Tempt_GND)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_si_Vdi_si=(+(+0.0*T12+(-T9_Vge_si)*T12_Vdi_si+(-T9_Vdi_si)*T12_Vge_si+(-T9)*T12_Vge_si_Vdi_si)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*0.0+((((-T9_Vdi_si)*T12)+((-T9)*T12_Vdi_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_si_Vge_e=(+(+0.0*T12+(-T9_Vge_si)*T12_Vge_e+(-T9_Vge_e)*T12_Vge_si+(-T9)*T12_Vge_si_Vge_e)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*0.0+((((-T9_Vge_e)*T12)+((-T9)*T12_Vge_e)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_si_Ve_si=(+(+0.0*T12+(-T9_Vge_si)*T12_Ve_si+(-T9_Ve_si)*T12_Vge_si+(-T9)*T12_Vge_si_Ve_si)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*0.0+((((-T9_Ve_si)*T12)+((-T9)*T12_Ve_si)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_si_Ve_di=(+(+0.0*T12+(-T9_Vge_si)*T12_Ve_di+(-T9_Ve_di)*T12_Vge_si+(-T9)*T12_Vge_si_Ve_di)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*0.0+((((-T9_Ve_di)*T12)+((-T9)*T12_Ve_di)))*0.0+((-T9)*T12)*0.0);
  qba_Vge_si_Vge_si=(+(+0.0*T12+(-T9_Vge_si)*T12_Vge_si+(-T9_Vge_si)*T12_Vge_si+(-T9)*T12_Vge_si_Vge_si)*Vtm+(((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si))*0.0+((((-T9_Vge_si)*T12)+((-T9)*T12_Vge_si)))*0.0+((-T9)*T12)*0.0);
#endif
#endif
qba=(((-T9)*T12)*Vtm);
EXIT_IF_ISNAN((((-T9)*T12)*Vtm))
}
else
{
if
((T10<(-1.0e-15)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e0_Vge_e=((-(T2_Vge_e-T10_Vge_e))-((T9_Vge_e*T7)+(T9*T7_Vge_e)));
#if defined(_DERIVATE2)
  e0_Vge_e_Vge_e=(+0.0-(+T9_Vge_e_Vge_e*T7+T9_Vge_e*T7_Vge_e+T9_Vge_e*T7_Vge_e+T9*T7_Vge_e_Vge_e));
  e0_Vge_e_Vge_si=(+0.0-(+T9_Vge_e_Vge_si*T7+T9_Vge_e*T7_Vge_si+T9_Vge_si*T7_Vge_e+T9*T7_Vge_e_Vge_si));
  e0_Vge_e_Ve_si=(+0.0-(+T9_Vge_e_Ve_si*T7+T9_Vge_e*T7_Ve_si+T9_Ve_si*T7_Vge_e+T9*T7_Vge_e_Ve_si));
  e0_Vge_e_Ve_di=(+0.0-(+T9_Vge_e_Ve_di*T7+T9_Vge_e*T7_Ve_di+T9_Ve_di*T7_Vge_e+T9*T7_Vge_e_Ve_di));
  e0_Vge_e_Vdi_si=(+0.0-(+T9_Vge_e_Vdi_si*T7+T9_Vge_e*T7_Vdi_si+T9_Vdi_si*T7_Vge_e+T9*T7_Vge_e_Vdi_si));
  e0_Vge_e_Tempt_GND=(+0.0-(+T9_Vge_e_Tempt_GND*T7+T9_Vge_e*T7_Tempt_GND+T9_Tempt_GND*T7_Vge_e+T9*T7_Vge_e_Tempt_GND));
#endif
e0_Vge_si=((-(T2_Vge_si-T10_Vge_si))-((T9_Vge_si*T7)+(T9*T7_Vge_si)));
#if defined(_DERIVATE2)
  e0_Vge_si_Vge_e=(+0.0-(+T9_Vge_si_Vge_e*T7+T9_Vge_si*T7_Vge_e+T9_Vge_e*T7_Vge_si+T9*T7_Vge_si_Vge_e));
  e0_Vge_si_Vge_si=(+0.0-(+T9_Vge_si_Vge_si*T7+T9_Vge_si*T7_Vge_si+T9_Vge_si*T7_Vge_si+T9*T7_Vge_si_Vge_si));
  e0_Vge_si_Ve_si=(+0.0-(+T9_Vge_si_Ve_si*T7+T9_Vge_si*T7_Ve_si+T9_Ve_si*T7_Vge_si+T9*T7_Vge_si_Ve_si));
  e0_Vge_si_Ve_di=(+0.0-(+T9_Vge_si_Ve_di*T7+T9_Vge_si*T7_Ve_di+T9_Ve_di*T7_Vge_si+T9*T7_Vge_si_Ve_di));
  e0_Vge_si_Vdi_si=(+0.0-(+T9_Vge_si_Vdi_si*T7+T9_Vge_si*T7_Vdi_si+T9_Vdi_si*T7_Vge_si+T9*T7_Vge_si_Vdi_si));
  e0_Vge_si_Tempt_GND=(+0.0-(+T9_Vge_si_Tempt_GND*T7+T9_Vge_si*T7_Tempt_GND+T9_Tempt_GND*T7_Vge_si+T9*T7_Vge_si_Tempt_GND));
#endif
e0_Ve_si=((-(T2_Ve_si-T10_Ve_si))-((T9_Ve_si*T7)+(T9*T7_Ve_si)));
#if defined(_DERIVATE2)
  e0_Ve_si_Vge_e=(+0.0-(+T9_Ve_si_Vge_e*T7+T9_Ve_si*T7_Vge_e+T9_Vge_e*T7_Ve_si+T9*T7_Ve_si_Vge_e));
  e0_Ve_si_Vge_si=(+0.0-(+T9_Ve_si_Vge_si*T7+T9_Ve_si*T7_Vge_si+T9_Vge_si*T7_Ve_si+T9*T7_Ve_si_Vge_si));
  e0_Ve_si_Ve_si=(+0.0-(+T9_Ve_si_Ve_si*T7+T9_Ve_si*T7_Ve_si+T9_Ve_si*T7_Ve_si+T9*T7_Ve_si_Ve_si));
  e0_Ve_si_Ve_di=(+0.0-(+T9_Ve_si_Ve_di*T7+T9_Ve_si*T7_Ve_di+T9_Ve_di*T7_Ve_si+T9*T7_Ve_si_Ve_di));
  e0_Ve_si_Vdi_si=(+0.0-(+T9_Ve_si_Vdi_si*T7+T9_Ve_si*T7_Vdi_si+T9_Vdi_si*T7_Ve_si+T9*T7_Ve_si_Vdi_si));
  e0_Ve_si_Tempt_GND=(+0.0-(+T9_Ve_si_Tempt_GND*T7+T9_Ve_si*T7_Tempt_GND+T9_Tempt_GND*T7_Ve_si+T9*T7_Ve_si_Tempt_GND));
#endif
e0_Ve_di=((-(T2_Ve_di-T10_Ve_di))-((T9_Ve_di*T7)+(T9*T7_Ve_di)));
#if defined(_DERIVATE2)
  e0_Ve_di_Vge_e=(+0.0-(+T9_Ve_di_Vge_e*T7+T9_Ve_di*T7_Vge_e+T9_Vge_e*T7_Ve_di+T9*T7_Ve_di_Vge_e));
  e0_Ve_di_Vge_si=(+0.0-(+T9_Ve_di_Vge_si*T7+T9_Ve_di*T7_Vge_si+T9_Vge_si*T7_Ve_di+T9*T7_Ve_di_Vge_si));
  e0_Ve_di_Ve_si=(+0.0-(+T9_Ve_di_Ve_si*T7+T9_Ve_di*T7_Ve_si+T9_Ve_si*T7_Ve_di+T9*T7_Ve_di_Ve_si));
  e0_Ve_di_Ve_di=(+0.0-(+T9_Ve_di_Ve_di*T7+T9_Ve_di*T7_Ve_di+T9_Ve_di*T7_Ve_di+T9*T7_Ve_di_Ve_di));
  e0_Ve_di_Vdi_si=(+0.0-(+T9_Ve_di_Vdi_si*T7+T9_Ve_di*T7_Vdi_si+T9_Vdi_si*T7_Ve_di+T9*T7_Ve_di_Vdi_si));
  e0_Ve_di_Tempt_GND=(+0.0-(+T9_Ve_di_Tempt_GND*T7+T9_Ve_di*T7_Tempt_GND+T9_Tempt_GND*T7_Ve_di+T9*T7_Ve_di_Tempt_GND));
#endif
e0_Vdi_si=((-(T2_Vdi_si-T10_Vdi_si))-((T9_Vdi_si*T7)+(T9*T7_Vdi_si)));
#if defined(_DERIVATE2)
  e0_Vdi_si_Vge_e=(+0.0-(+T9_Vdi_si_Vge_e*T7+T9_Vdi_si*T7_Vge_e+T9_Vge_e*T7_Vdi_si+T9*T7_Vdi_si_Vge_e));
  e0_Vdi_si_Vge_si=(+0.0-(+T9_Vdi_si_Vge_si*T7+T9_Vdi_si*T7_Vge_si+T9_Vge_si*T7_Vdi_si+T9*T7_Vdi_si_Vge_si));
  e0_Vdi_si_Ve_si=(+0.0-(+T9_Vdi_si_Ve_si*T7+T9_Vdi_si*T7_Ve_si+T9_Ve_si*T7_Vdi_si+T9*T7_Vdi_si_Ve_si));
  e0_Vdi_si_Ve_di=(+0.0-(+T9_Vdi_si_Ve_di*T7+T9_Vdi_si*T7_Ve_di+T9_Ve_di*T7_Vdi_si+T9*T7_Vdi_si_Ve_di));
  e0_Vdi_si_Vdi_si=(+0.0-(+T9_Vdi_si_Vdi_si*T7+T9_Vdi_si*T7_Vdi_si+T9_Vdi_si*T7_Vdi_si+T9*T7_Vdi_si_Vdi_si));
  e0_Vdi_si_Tempt_GND=(+0.0-(+T9_Vdi_si_Tempt_GND*T7+T9_Vdi_si*T7_Tempt_GND+T9_Tempt_GND*T7_Vdi_si+T9*T7_Vdi_si_Tempt_GND));
#endif
e0_Tempt_GND=((-(T2_Tempt_GND-T10_Tempt_GND))-((T9_Tempt_GND*T7)+(T9*T7_Tempt_GND)));
#if defined(_DERIVATE2)
  e0_Tempt_GND_Vge_e=(+0.0-(+T9_Tempt_GND_Vge_e*T7+T9_Tempt_GND*T7_Vge_e+T9_Vge_e*T7_Tempt_GND+T9*T7_Tempt_GND_Vge_e));
  e0_Tempt_GND_Vge_si=(+0.0-(+T9_Tempt_GND_Vge_si*T7+T9_Tempt_GND*T7_Vge_si+T9_Vge_si*T7_Tempt_GND+T9*T7_Tempt_GND_Vge_si));
  e0_Tempt_GND_Ve_si=(+0.0-(+T9_Tempt_GND_Ve_si*T7+T9_Tempt_GND*T7_Ve_si+T9_Ve_si*T7_Tempt_GND+T9*T7_Tempt_GND_Ve_si));
  e0_Tempt_GND_Ve_di=(+0.0-(+T9_Tempt_GND_Ve_di*T7+T9_Tempt_GND*T7_Ve_di+T9_Ve_di*T7_Tempt_GND+T9*T7_Tempt_GND_Ve_di));
  e0_Tempt_GND_Vdi_si=(+0.0-(+T9_Tempt_GND_Vdi_si*T7+T9_Tempt_GND*T7_Vdi_si+T9_Vdi_si*T7_Tempt_GND+T9*T7_Tempt_GND_Vdi_si));
  e0_Tempt_GND_Tempt_GND=(+0.0-(+T9_Tempt_GND_Tempt_GND*T7+T9_Tempt_GND*T7_Tempt_GND+T9_Tempt_GND*T7_Tempt_GND+T9*T7_Tempt_GND_Tempt_GND));
#endif
#endif
e0=((-(T2-T10))-(T9*T7));
EXIT_IF_ISNAN(((-(T2-T10))-(T9*T7)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
e1_Vge_e=((((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7-((T9*0.5)*T6)*T7_Vge_e)/T7/T7);
#if defined(_DERIVATE2)
  e1_Vge_e_Vge_e=(+0.0+((+(+T9_Vge_e_Vge_e*0.5+T9_Vge_e*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vge_e)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vge_e/T7/T7/T7));
  e1_Vge_e_Vdi_si=(+0.0+((+(+T9_Vge_e_Vdi_si*0.5+T9_Vge_e*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vdi_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vdi_si/T7/T7/T7));
  e1_Vge_e_Ve_si=(+0.0+((+(+T9_Vge_e_Ve_si*0.5+T9_Vge_e*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Ve_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Ve_si/T7/T7/T7));
  e1_Vge_e_Ve_di=(+0.0+((+(+T9_Vge_e_Ve_di*0.5+T9_Vge_e*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Ve_di)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Ve_di/T7/T7/T7));
  e1_Vge_e_Vge_si=(+0.0+((+(+T9_Vge_e_Vge_si*0.5+T9_Vge_e*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Vge_si)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Vge_si/T7/T7/T7));
  e1_Vge_e_Tempt_GND=(+0.0+((+(+T9_Vge_e_Tempt_GND*0.5+T9_Vge_e*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vge_e*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vge_e+(T9*0.5)*T6_Vge_e_Tempt_GND)/T7-(((T9_Vge_e*0.5*T6)+((T9*0.5)*T6_Vge_e))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vge_e+((T9*0.5)*T6)*T7_Vge_e_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_e*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Vdi_si=((((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7-((T9*0.5)*T6)*T7_Vdi_si)/T7/T7);
#if defined(_DERIVATE2)
  e1_Vdi_si_Vge_e=(+0.0+((+(+T9_Vdi_si_Vge_e*0.5+T9_Vdi_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vge_e)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vge_e/T7/T7/T7));
  e1_Vdi_si_Vdi_si=(+0.0+((+(+T9_Vdi_si_Vdi_si*0.5+T9_Vdi_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vdi_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vdi_si/T7/T7/T7));
  e1_Vdi_si_Ve_si=(+0.0+((+(+T9_Vdi_si_Ve_si*0.5+T9_Vdi_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Ve_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Ve_si/T7/T7/T7));
  e1_Vdi_si_Ve_di=(+0.0+((+(+T9_Vdi_si_Ve_di*0.5+T9_Vdi_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Ve_di)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Ve_di/T7/T7/T7));
  e1_Vdi_si_Vge_si=(+0.0+((+(+T9_Vdi_si_Vge_si*0.5+T9_Vdi_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Vge_si)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Vge_si/T7/T7/T7));
  e1_Vdi_si_Tempt_GND=(+0.0+((+(+T9_Vdi_si_Tempt_GND*0.5+T9_Vdi_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vdi_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vdi_si+(T9*0.5)*T6_Vdi_si_Tempt_GND)/T7-(((T9_Vdi_si*0.5*T6)+((T9*0.5)*T6_Vdi_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vdi_si+((T9*0.5)*T6)*T7_Vdi_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vdi_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Ve_si=((((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7-((T9*0.5)*T6)*T7_Ve_si)/T7/T7);
#if defined(_DERIVATE2)
  e1_Ve_si_Vge_e=(+0.0+((+(+T9_Ve_si_Vge_e*0.5+T9_Ve_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vge_e)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vge_e/T7/T7/T7));
  e1_Ve_si_Vdi_si=(+0.0+((+(+T9_Ve_si_Vdi_si*0.5+T9_Ve_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vdi_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vdi_si/T7/T7/T7));
  e1_Ve_si_Ve_si=(+0.0+((+(+T9_Ve_si_Ve_si*0.5+T9_Ve_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Ve_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Ve_si/T7/T7/T7));
  e1_Ve_si_Ve_di=(+0.0+((+(+T9_Ve_si_Ve_di*0.5+T9_Ve_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Ve_di)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Ve_di/T7/T7/T7));
  e1_Ve_si_Vge_si=(+0.0+((+(+T9_Ve_si_Vge_si*0.5+T9_Ve_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Vge_si)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Vge_si/T7/T7/T7));
  e1_Ve_si_Tempt_GND=(+0.0+((+(+T9_Ve_si_Tempt_GND*0.5+T9_Ve_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Ve_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Ve_si+(T9*0.5)*T6_Ve_si_Tempt_GND)/T7-(((T9_Ve_si*0.5*T6)+((T9*0.5)*T6_Ve_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Ve_si+((T9*0.5)*T6)*T7_Ve_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Ve_di=((((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7-((T9*0.5)*T6)*T7_Ve_di)/T7/T7);
#if defined(_DERIVATE2)
  e1_Ve_di_Vge_e=(+0.0+((+(+T9_Ve_di_Vge_e*0.5+T9_Ve_di*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vge_e)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vge_e/T7/T7/T7));
  e1_Ve_di_Vdi_si=(+0.0+((+(+T9_Ve_di_Vdi_si*0.5+T9_Ve_di*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vdi_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vdi_si/T7/T7/T7));
  e1_Ve_di_Ve_si=(+0.0+((+(+T9_Ve_di_Ve_si*0.5+T9_Ve_di*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Ve_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Ve_si/T7/T7/T7));
  e1_Ve_di_Ve_di=(+0.0+((+(+T9_Ve_di_Ve_di*0.5+T9_Ve_di*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Ve_di)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Ve_di/T7/T7/T7));
  e1_Ve_di_Vge_si=(+0.0+((+(+T9_Ve_di_Vge_si*0.5+T9_Ve_di*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Vge_si)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Vge_si/T7/T7/T7));
  e1_Ve_di_Tempt_GND=(+0.0+((+(+T9_Ve_di_Tempt_GND*0.5+T9_Ve_di*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Ve_di*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Ve_di+(T9*0.5)*T6_Ve_di_Tempt_GND)/T7-(((T9_Ve_di*0.5*T6)+((T9*0.5)*T6_Ve_di))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Ve_di+((T9*0.5)*T6)*T7_Ve_di_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Ve_di*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Vge_si=((((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7-((T9*0.5)*T6)*T7_Vge_si)/T7/T7);
#if defined(_DERIVATE2)
  e1_Vge_si_Vge_e=(+0.0+((+(+T9_Vge_si_Vge_e*0.5+T9_Vge_si*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vge_e)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vge_e/T7/T7/T7));
  e1_Vge_si_Vdi_si=(+0.0+((+(+T9_Vge_si_Vdi_si*0.5+T9_Vge_si*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vdi_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vdi_si/T7/T7/T7));
  e1_Vge_si_Ve_si=(+0.0+((+(+T9_Vge_si_Ve_si*0.5+T9_Vge_si*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Ve_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Ve_si/T7/T7/T7));
  e1_Vge_si_Ve_di=(+0.0+((+(+T9_Vge_si_Ve_di*0.5+T9_Vge_si*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Ve_di)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Ve_di/T7/T7/T7));
  e1_Vge_si_Vge_si=(+0.0+((+(+T9_Vge_si_Vge_si*0.5+T9_Vge_si*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Vge_si)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Vge_si/T7/T7/T7));
  e1_Vge_si_Tempt_GND=(+0.0+((+(+T9_Vge_si_Tempt_GND*0.5+T9_Vge_si*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Vge_si*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Vge_si+(T9*0.5)*T6_Vge_si_Tempt_GND)/T7-(((T9_Vge_si*0.5*T6)+((T9*0.5)*T6_Vge_si))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Vge_si+((T9*0.5)*T6)*T7_Vge_si_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Vge_si*T7_Tempt_GND/T7/T7/T7));
#endif
e1_Tempt_GND=((((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7-((T9*0.5)*T6)*T7_Tempt_GND)/T7/T7);
#if defined(_DERIVATE2)
  e1_Tempt_GND_Vge_e=(+0.0+((+(+T9_Tempt_GND_Vge_e*0.5+T9_Tempt_GND*0.0+T9_Vge_e*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vge_e+(T9_Vge_e*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vge_e)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vge_e+((((T9_Vge_e*0.5)*T6)+((T9*0.5)*T6_Vge_e)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vge_e)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vge_e/T7/T7/T7));
  e1_Tempt_GND_Vdi_si=(+0.0+((+(+T9_Tempt_GND_Vdi_si*0.5+T9_Tempt_GND*0.0+T9_Vdi_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vdi_si+(T9_Vdi_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vdi_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vdi_si+((((T9_Vdi_si*0.5)*T6)+((T9*0.5)*T6_Vdi_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vdi_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vdi_si/T7/T7/T7));
  e1_Tempt_GND_Ve_si=(+0.0+((+(+T9_Tempt_GND_Ve_si*0.5+T9_Tempt_GND*0.0+T9_Ve_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Ve_si+(T9_Ve_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Ve_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Ve_si+((((T9_Ve_si*0.5)*T6)+((T9*0.5)*T6_Ve_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Ve_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Ve_si/T7/T7/T7));
  e1_Tempt_GND_Ve_di=(+0.0+((+(+T9_Tempt_GND_Ve_di*0.5+T9_Tempt_GND*0.0+T9_Ve_di*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Ve_di+(T9_Ve_di*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Ve_di)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Ve_di+((((T9_Ve_di*0.5)*T6)+((T9*0.5)*T6_Ve_di)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Ve_di)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Ve_di/T7/T7/T7));
  e1_Tempt_GND_Vge_si=(+0.0+((+(+T9_Tempt_GND_Vge_si*0.5+T9_Tempt_GND*0.0+T9_Vge_si*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Vge_si+(T9_Vge_si*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Vge_si)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Vge_si+((((T9_Vge_si*0.5)*T6)+((T9*0.5)*T6_Vge_si)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Vge_si)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Vge_si/T7/T7/T7));
  e1_Tempt_GND_Tempt_GND=(+0.0+((+(+T9_Tempt_GND_Tempt_GND*0.5+T9_Tempt_GND*0.0+T9_Tempt_GND*0.0+T9*0.0)*T6+T9_Tempt_GND*0.5*T6_Tempt_GND+(T9_Tempt_GND*0.5)*T6_Tempt_GND+(T9*0.5)*T6_Tempt_GND_Tempt_GND)/T7-(((T9_Tempt_GND*0.5*T6)+((T9*0.5)*T6_Tempt_GND))*T7_Tempt_GND+((((T9_Tempt_GND*0.5)*T6)+((T9*0.5)*T6_Tempt_GND)))*T7_Tempt_GND+((T9*0.5)*T6)*T7_Tempt_GND_Tempt_GND)/T7/T7+2*((T9*0.5)*T6)*T7_Tempt_GND*T7_Tempt_GND/T7/T7/T7));
#endif
#endif
e1=(1.0+(((T9*0.5)*T6)/T7));
EXIT_IF_ISNAN((1.0+(((T9*0.5)*T6)/T7)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=(T10_Vge_e-((e0_Vge_e*e1-e0*e1_Vge_e)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=(+T10_Vge_e_Vge_e-(e0_Vge_e_Vge_e/e1-(e0_Vge_e*e1_Vge_e+e0_Vge_e*e1_Vge_e+e0*e1_Vge_e_Vge_e)/e1/e1+2*e0*e1_Vge_e*e1_Vge_e/e1/e1/e1));
  T8_Vge_e_Vdi_si=(+T10_Vge_e_Vdi_si-(e0_Vge_e_Vdi_si/e1-(e0_Vge_e*e1_Vdi_si+e0_Vdi_si*e1_Vge_e+e0*e1_Vge_e_Vdi_si)/e1/e1+2*e0*e1_Vge_e*e1_Vdi_si/e1/e1/e1));
  T8_Vge_e_Ve_si=(+T10_Vge_e_Ve_si-(e0_Vge_e_Ve_si/e1-(e0_Vge_e*e1_Ve_si+e0_Ve_si*e1_Vge_e+e0*e1_Vge_e_Ve_si)/e1/e1+2*e0*e1_Vge_e*e1_Ve_si/e1/e1/e1));
  T8_Vge_e_Ve_di=(+T10_Vge_e_Ve_di-(e0_Vge_e_Ve_di/e1-(e0_Vge_e*e1_Ve_di+e0_Ve_di*e1_Vge_e+e0*e1_Vge_e_Ve_di)/e1/e1+2*e0*e1_Vge_e*e1_Ve_di/e1/e1/e1));
  T8_Vge_e_Vge_si=(+T10_Vge_e_Vge_si-(e0_Vge_e_Vge_si/e1-(e0_Vge_e*e1_Vge_si+e0_Vge_si*e1_Vge_e+e0*e1_Vge_e_Vge_si)/e1/e1+2*e0*e1_Vge_e*e1_Vge_si/e1/e1/e1));
  T8_Vge_e_Tempt_GND=(+T10_Vge_e_Tempt_GND-(e0_Vge_e_Tempt_GND/e1-(e0_Vge_e*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_e+e0*e1_Vge_e_Tempt_GND)/e1/e1+2*e0*e1_Vge_e*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Vdi_si=(T10_Vdi_si-((e0_Vdi_si*e1-e0*e1_Vdi_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+T10_Vdi_si_Vge_e-(e0_Vdi_si_Vge_e/e1-(e0_Vdi_si*e1_Vge_e+e0_Vge_e*e1_Vdi_si+e0*e1_Vdi_si_Vge_e)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_e/e1/e1/e1));
  T8_Vdi_si_Vdi_si=(+T10_Vdi_si_Vdi_si-(e0_Vdi_si_Vdi_si/e1-(e0_Vdi_si*e1_Vdi_si+e0_Vdi_si*e1_Vdi_si+e0*e1_Vdi_si_Vdi_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vdi_si/e1/e1/e1));
  T8_Vdi_si_Ve_si=(+T10_Vdi_si_Ve_si-(e0_Vdi_si_Ve_si/e1-(e0_Vdi_si*e1_Ve_si+e0_Ve_si*e1_Vdi_si+e0*e1_Vdi_si_Ve_si)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_si/e1/e1/e1));
  T8_Vdi_si_Ve_di=(+T10_Vdi_si_Ve_di-(e0_Vdi_si_Ve_di/e1-(e0_Vdi_si*e1_Ve_di+e0_Ve_di*e1_Vdi_si+e0*e1_Vdi_si_Ve_di)/e1/e1+2*e0*e1_Vdi_si*e1_Ve_di/e1/e1/e1));
  T8_Vdi_si_Vge_si=(+T10_Vdi_si_Vge_si-(e0_Vdi_si_Vge_si/e1-(e0_Vdi_si*e1_Vge_si+e0_Vge_si*e1_Vdi_si+e0*e1_Vdi_si_Vge_si)/e1/e1+2*e0*e1_Vdi_si*e1_Vge_si/e1/e1/e1));
  T8_Vdi_si_Tempt_GND=(+T10_Vdi_si_Tempt_GND-(e0_Vdi_si_Tempt_GND/e1-(e0_Vdi_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vdi_si+e0*e1_Vdi_si_Tempt_GND)/e1/e1+2*e0*e1_Vdi_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Ve_si=(T10_Ve_si-((e0_Ve_si*e1-e0*e1_Ve_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+T10_Ve_si_Vge_e-(e0_Ve_si_Vge_e/e1-(e0_Ve_si*e1_Vge_e+e0_Vge_e*e1_Ve_si+e0*e1_Ve_si_Vge_e)/e1/e1+2*e0*e1_Ve_si*e1_Vge_e/e1/e1/e1));
  T8_Ve_si_Vdi_si=(+T10_Ve_si_Vdi_si-(e0_Ve_si_Vdi_si/e1-(e0_Ve_si*e1_Vdi_si+e0_Vdi_si*e1_Ve_si+e0*e1_Ve_si_Vdi_si)/e1/e1+2*e0*e1_Ve_si*e1_Vdi_si/e1/e1/e1));
  T8_Ve_si_Ve_si=(+T10_Ve_si_Ve_si-(e0_Ve_si_Ve_si/e1-(e0_Ve_si*e1_Ve_si+e0_Ve_si*e1_Ve_si+e0*e1_Ve_si_Ve_si)/e1/e1+2*e0*e1_Ve_si*e1_Ve_si/e1/e1/e1));
  T8_Ve_si_Ve_di=(+T10_Ve_si_Ve_di-(e0_Ve_si_Ve_di/e1-(e0_Ve_si*e1_Ve_di+e0_Ve_di*e1_Ve_si+e0*e1_Ve_si_Ve_di)/e1/e1+2*e0*e1_Ve_si*e1_Ve_di/e1/e1/e1));
  T8_Ve_si_Vge_si=(+T10_Ve_si_Vge_si-(e0_Ve_si_Vge_si/e1-(e0_Ve_si*e1_Vge_si+e0_Vge_si*e1_Ve_si+e0*e1_Ve_si_Vge_si)/e1/e1+2*e0*e1_Ve_si*e1_Vge_si/e1/e1/e1));
  T8_Ve_si_Tempt_GND=(+T10_Ve_si_Tempt_GND-(e0_Ve_si_Tempt_GND/e1-(e0_Ve_si*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_si+e0*e1_Ve_si_Tempt_GND)/e1/e1+2*e0*e1_Ve_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Ve_di=(T10_Ve_di-((e0_Ve_di*e1-e0*e1_Ve_di)/e1/e1));
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+T10_Ve_di_Vge_e-(e0_Ve_di_Vge_e/e1-(e0_Ve_di*e1_Vge_e+e0_Vge_e*e1_Ve_di+e0*e1_Ve_di_Vge_e)/e1/e1+2*e0*e1_Ve_di*e1_Vge_e/e1/e1/e1));
  T8_Ve_di_Vdi_si=(+T10_Ve_di_Vdi_si-(e0_Ve_di_Vdi_si/e1-(e0_Ve_di*e1_Vdi_si+e0_Vdi_si*e1_Ve_di+e0*e1_Ve_di_Vdi_si)/e1/e1+2*e0*e1_Ve_di*e1_Vdi_si/e1/e1/e1));
  T8_Ve_di_Ve_si=(+T10_Ve_di_Ve_si-(e0_Ve_di_Ve_si/e1-(e0_Ve_di*e1_Ve_si+e0_Ve_si*e1_Ve_di+e0*e1_Ve_di_Ve_si)/e1/e1+2*e0*e1_Ve_di*e1_Ve_si/e1/e1/e1));
  T8_Ve_di_Ve_di=(+T10_Ve_di_Ve_di-(e0_Ve_di_Ve_di/e1-(e0_Ve_di*e1_Ve_di+e0_Ve_di*e1_Ve_di+e0*e1_Ve_di_Ve_di)/e1/e1+2*e0*e1_Ve_di*e1_Ve_di/e1/e1/e1));
  T8_Ve_di_Vge_si=(+T10_Ve_di_Vge_si-(e0_Ve_di_Vge_si/e1-(e0_Ve_di*e1_Vge_si+e0_Vge_si*e1_Ve_di+e0*e1_Ve_di_Vge_si)/e1/e1+2*e0*e1_Ve_di*e1_Vge_si/e1/e1/e1));
  T8_Ve_di_Tempt_GND=(+T10_Ve_di_Tempt_GND-(e0_Ve_di_Tempt_GND/e1-(e0_Ve_di*e1_Tempt_GND+e0_Tempt_GND*e1_Ve_di+e0*e1_Ve_di_Tempt_GND)/e1/e1+2*e0*e1_Ve_di*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Vge_si=(T10_Vge_si-((e0_Vge_si*e1-e0*e1_Vge_si)/e1/e1));
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+T10_Vge_si_Vge_e-(e0_Vge_si_Vge_e/e1-(e0_Vge_si*e1_Vge_e+e0_Vge_e*e1_Vge_si+e0*e1_Vge_si_Vge_e)/e1/e1+2*e0*e1_Vge_si*e1_Vge_e/e1/e1/e1));
  T8_Vge_si_Vdi_si=(+T10_Vge_si_Vdi_si-(e0_Vge_si_Vdi_si/e1-(e0_Vge_si*e1_Vdi_si+e0_Vdi_si*e1_Vge_si+e0*e1_Vge_si_Vdi_si)/e1/e1+2*e0*e1_Vge_si*e1_Vdi_si/e1/e1/e1));
  T8_Vge_si_Ve_si=(+T10_Vge_si_Ve_si-(e0_Vge_si_Ve_si/e1-(e0_Vge_si*e1_Ve_si+e0_Ve_si*e1_Vge_si+e0*e1_Vge_si_Ve_si)/e1/e1+2*e0*e1_Vge_si*e1_Ve_si/e1/e1/e1));
  T8_Vge_si_Ve_di=(+T10_Vge_si_Ve_di-(e0_Vge_si_Ve_di/e1-(e0_Vge_si*e1_Ve_di+e0_Ve_di*e1_Vge_si+e0*e1_Vge_si_Ve_di)/e1/e1+2*e0*e1_Vge_si*e1_Ve_di/e1/e1/e1));
  T8_Vge_si_Vge_si=(+T10_Vge_si_Vge_si-(e0_Vge_si_Vge_si/e1-(e0_Vge_si*e1_Vge_si+e0_Vge_si*e1_Vge_si+e0*e1_Vge_si_Vge_si)/e1/e1+2*e0*e1_Vge_si*e1_Vge_si/e1/e1/e1));
  T8_Vge_si_Tempt_GND=(+T10_Vge_si_Tempt_GND-(e0_Vge_si_Tempt_GND/e1-(e0_Vge_si*e1_Tempt_GND+e0_Tempt_GND*e1_Vge_si+e0*e1_Vge_si_Tempt_GND)/e1/e1+2*e0*e1_Vge_si*e1_Tempt_GND/e1/e1/e1));
#endif
T8_Tempt_GND=(T10_Tempt_GND-((e0_Tempt_GND*e1-e0*e1_Tempt_GND)/e1/e1));
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+T10_Tempt_GND_Vge_e-(e0_Tempt_GND_Vge_e/e1-(e0_Tempt_GND*e1_Vge_e+e0_Vge_e*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_e)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_e/e1/e1/e1));
  T8_Tempt_GND_Vdi_si=(+T10_Tempt_GND_Vdi_si-(e0_Tempt_GND_Vdi_si/e1-(e0_Tempt_GND*e1_Vdi_si+e0_Vdi_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vdi_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vdi_si/e1/e1/e1));
  T8_Tempt_GND_Ve_si=(+T10_Tempt_GND_Ve_si-(e0_Tempt_GND_Ve_si/e1-(e0_Tempt_GND*e1_Ve_si+e0_Ve_si*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_si/e1/e1/e1));
  T8_Tempt_GND_Ve_di=(+T10_Tempt_GND_Ve_di-(e0_Tempt_GND_Ve_di/e1-(e0_Tempt_GND*e1_Ve_di+e0_Ve_di*e1_Tempt_GND+e0*e1_Tempt_GND_Ve_di)/e1/e1+2*e0*e1_Tempt_GND*e1_Ve_di/e1/e1/e1));
  T8_Tempt_GND_Vge_si=(+T10_Tempt_GND_Vge_si-(e0_Tempt_GND_Vge_si/e1-(e0_Tempt_GND*e1_Vge_si+e0_Vge_si*e1_Tempt_GND+e0*e1_Tempt_GND_Vge_si)/e1/e1+2*e0*e1_Tempt_GND*e1_Vge_si/e1/e1/e1));
  T8_Tempt_GND_Tempt_GND=(+T10_Tempt_GND_Tempt_GND-(e0_Tempt_GND_Tempt_GND/e1-(e0_Tempt_GND*e1_Tempt_GND+e0_Tempt_GND*e1_Tempt_GND+e0*e1_Tempt_GND_Tempt_GND)/e1/e1+2*e0*e1_Tempt_GND*e1_Tempt_GND/e1/e1/e1));
#endif
#endif
T8=(T10-(e0/e1));
EXIT_IF_ISNAN((T10-(e0/e1)))
{
double m00_exp(d00_exp0,(-T8))
double m00_sqrt(d00_sqrt1,((d00_exp0+T8)-1.0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
double m10_sqrt(d10_sqrt1,d00_sqrt1,((d00_exp0+T8)-1.0))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T12_Vge_e=((T9_Vge_e*d00_sqrt1)+(T9*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Vge_e_Vge_e=(+T9_Vge_e_Vge_e*d00_sqrt1+T9_Vge_e*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Vge_e)-0.0)));
  T12_Vge_e_Ve_si=(+T9_Vge_e_Ve_si*d00_sqrt1+T9_Vge_e*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Ve_si)-0.0)));
  T12_Vge_e_Ve_di=(+T9_Vge_e_Ve_di*d00_sqrt1+T9_Vge_e*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Ve_di)-0.0)));
  T12_Vge_e_Vge_si=(+T9_Vge_e_Vge_si*d00_sqrt1+T9_Vge_e*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Vge_si)-0.0)));
  T12_Vge_e_Vdi_si=(+T9_Vge_e_Vdi_si*d00_sqrt1+T9_Vge_e*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Vdi_si)-0.0)));
  T12_Vge_e_Tempt_GND=(+T9_Vge_e_Tempt_GND*d00_sqrt1+T9_Vge_e*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Vge_e)*d10_exp0+T8_Vge_e)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vge_e)+d10_exp0*0.0)+T8_Vge_e_Tempt_GND)-0.0)));
#endif
T12_Ve_si=((T9_Ve_si*d00_sqrt1)+(T9*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Ve_si_Vge_e=(+T9_Ve_si_Vge_e*d00_sqrt1+T9_Ve_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Vge_e)-0.0)));
  T12_Ve_si_Ve_si=(+T9_Ve_si_Ve_si*d00_sqrt1+T9_Ve_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Ve_si)-0.0)));
  T12_Ve_si_Ve_di=(+T9_Ve_si_Ve_di*d00_sqrt1+T9_Ve_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Ve_di)-0.0)));
  T12_Ve_si_Vge_si=(+T9_Ve_si_Vge_si*d00_sqrt1+T9_Ve_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Vge_si)-0.0)));
  T12_Ve_si_Vdi_si=(+T9_Ve_si_Vdi_si*d00_sqrt1+T9_Ve_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Vdi_si)-0.0)));
  T12_Ve_si_Tempt_GND=(+T9_Ve_si_Tempt_GND*d00_sqrt1+T9_Ve_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Ve_si)*d10_exp0+T8_Ve_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Ve_si)+d10_exp0*0.0)+T8_Ve_si_Tempt_GND)-0.0)));
#endif
T12_Ve_di=((T9_Ve_di*d00_sqrt1)+(T9*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Ve_di_Vge_e=(+T9_Ve_di_Vge_e*d00_sqrt1+T9_Ve_di*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Vge_e)-0.0)));
  T12_Ve_di_Ve_si=(+T9_Ve_di_Ve_si*d00_sqrt1+T9_Ve_di*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Ve_si)-0.0)));
  T12_Ve_di_Ve_di=(+T9_Ve_di_Ve_di*d00_sqrt1+T9_Ve_di*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Ve_di)-0.0)));
  T12_Ve_di_Vge_si=(+T9_Ve_di_Vge_si*d00_sqrt1+T9_Ve_di*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Vge_si)-0.0)));
  T12_Ve_di_Vdi_si=(+T9_Ve_di_Vdi_si*d00_sqrt1+T9_Ve_di*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Vdi_si)-0.0)));
  T12_Ve_di_Tempt_GND=(+T9_Ve_di_Tempt_GND*d00_sqrt1+T9_Ve_di*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Ve_di)*d10_exp0+T8_Ve_di)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Ve_di)+d10_exp0*0.0)+T8_Ve_di_Tempt_GND)-0.0)));
#endif
T12_Vge_si=((T9_Vge_si*d00_sqrt1)+(T9*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Vge_si_Vge_e=(+T9_Vge_si_Vge_e*d00_sqrt1+T9_Vge_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Vge_e)-0.0)));
  T12_Vge_si_Ve_si=(+T9_Vge_si_Ve_si*d00_sqrt1+T9_Vge_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Ve_si)-0.0)));
  T12_Vge_si_Ve_di=(+T9_Vge_si_Ve_di*d00_sqrt1+T9_Vge_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Ve_di)-0.0)));
  T12_Vge_si_Vge_si=(+T9_Vge_si_Vge_si*d00_sqrt1+T9_Vge_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Vge_si)-0.0)));
  T12_Vge_si_Vdi_si=(+T9_Vge_si_Vdi_si*d00_sqrt1+T9_Vge_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Vdi_si)-0.0)));
  T12_Vge_si_Tempt_GND=(+T9_Vge_si_Tempt_GND*d00_sqrt1+T9_Vge_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Vge_si)*d10_exp0+T8_Vge_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vge_si)+d10_exp0*0.0)+T8_Vge_si_Tempt_GND)-0.0)));
#endif
T12_Vdi_si=((T9_Vdi_si*d00_sqrt1)+(T9*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Vdi_si_Vge_e=(+T9_Vdi_si_Vge_e*d00_sqrt1+T9_Vdi_si*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Vge_e)-0.0)));
  T12_Vdi_si_Ve_si=(+T9_Vdi_si_Ve_si*d00_sqrt1+T9_Vdi_si*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Ve_si)-0.0)));
  T12_Vdi_si_Ve_di=(+T9_Vdi_si_Ve_di*d00_sqrt1+T9_Vdi_si*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Ve_di)-0.0)));
  T12_Vdi_si_Vge_si=(+T9_Vdi_si_Vge_si*d00_sqrt1+T9_Vdi_si*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Vge_si)-0.0)));
  T12_Vdi_si_Vdi_si=(+T9_Vdi_si_Vdi_si*d00_sqrt1+T9_Vdi_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Vdi_si)-0.0)));
  T12_Vdi_si_Tempt_GND=(+T9_Vdi_si_Tempt_GND*d00_sqrt1+T9_Vdi_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Vdi_si)+d10_exp0*0.0)+T8_Vdi_si_Tempt_GND)-0.0)));
#endif
T12_Tempt_GND=((T9_Tempt_GND*d00_sqrt1)+(T9*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1));
#if defined(_DERIVATE2)
  T12_Tempt_GND_Vge_e=(+T9_Tempt_GND_Vge_e*d00_sqrt1+T9_Tempt_GND*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*d10_sqrt1+T9_Vge_e*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_e)*d10_exp0+T8_Vge_e)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_e)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Vge_e)-0.0)));
  T12_Tempt_GND_Ve_si=(+T9_Tempt_GND_Ve_si*d00_sqrt1+T9_Tempt_GND*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*d10_sqrt1+T9_Ve_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_si)*d10_exp0+T8_Ve_si)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_si)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Ve_si)-0.0)));
  T12_Tempt_GND_Ve_di=(+T9_Tempt_GND_Ve_di*d00_sqrt1+T9_Tempt_GND*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*d10_sqrt1+T9_Ve_di*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Ve_di)*d10_exp0+T8_Ve_di)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Ve_di)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Ve_di)-0.0)));
  T12_Tempt_GND_Vge_si=(+T9_Tempt_GND_Vge_si*d00_sqrt1+T9_Tempt_GND*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*d10_sqrt1+T9_Vge_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vge_si)*d10_exp0+T8_Vge_si)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vge_si)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Vge_si)-0.0)));
  T12_Tempt_GND_Vdi_si=(+T9_Tempt_GND_Vdi_si*d00_sqrt1+T9_Tempt_GND*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*d10_sqrt1+T9_Vdi_si*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Vdi_si)*d10_exp0+T8_Vdi_si)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Vdi_si)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Vdi_si)-0.0)));
  T12_Tempt_GND_Tempt_GND=(+T9_Tempt_GND_Tempt_GND*d00_sqrt1+T9_Tempt_GND*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9_Tempt_GND*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*d10_sqrt1+T9*(m20_sqrt(((d00_exp0+T8)-1.0))*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)*((-T8_Tempt_GND)*d10_exp0+T8_Tempt_GND)+d10_sqrt1*(+(+(m20_exp((-T8))*(-T8_Tempt_GND)*(-T8_Tempt_GND)+d10_exp0*0.0)+T8_Tempt_GND_Tempt_GND)-0.0)));
#endif
#endif
T12=(T9*d00_sqrt1);
EXIT_IF_ISNAN((T9*d00_sqrt1))
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T12_Vge_e=0.0;
#if defined(_DERIVATE2)
  T12_Vge_e_Vge_e=0.0;
  T12_Vge_e_Ve_si=0.0;
  T12_Vge_e_Ve_di=0.0;
  T12_Vge_e_Vge_si=0.0;
  T12_Vge_e_Vdi_si=0.0;
  T12_Vge_e_Tempt_GND=0.0;
#endif
T12_Ve_si=0.0;
#if defined(_DERIVATE2)
  T12_Ve_si_Vge_e=0.0;
  T12_Ve_si_Ve_si=0.0;
  T12_Ve_si_Ve_di=0.0;
  T12_Ve_si_Vge_si=0.0;
  T12_Ve_si_Vdi_si=0.0;
  T12_Ve_si_Tempt_GND=0.0;
#endif
T12_Ve_di=0.0;
#if defined(_DERIVATE2)
  T12_Ve_di_Vge_e=0.0;
  T12_Ve_di_Ve_si=0.0;
  T12_Ve_di_Ve_di=0.0;
  T12_Ve_di_Vge_si=0.0;
  T12_Ve_di_Vdi_si=0.0;
  T12_Ve_di_Tempt_GND=0.0;
#endif
T12_Vge_si=0.0;
#if defined(_DERIVATE2)
  T12_Vge_si_Vge_e=0.0;
  T12_Vge_si_Ve_si=0.0;
  T12_Vge_si_Ve_di=0.0;
  T12_Vge_si_Vge_si=0.0;
  T12_Vge_si_Vdi_si=0.0;
  T12_Vge_si_Tempt_GND=0.0;
#endif
T12_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T12_Vdi_si_Vge_e=0.0;
  T12_Vdi_si_Ve_si=0.0;
  T12_Vdi_si_Ve_di=0.0;
  T12_Vdi_si_Vge_si=0.0;
  T12_Vdi_si_Vdi_si=0.0;
  T12_Vdi_si_Tempt_GND=0.0;
#endif
T12_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T12_Tempt_GND_Vge_e=0.0;
  T12_Tempt_GND_Ve_si=0.0;
  T12_Tempt_GND_Ve_di=0.0;
  T12_Tempt_GND_Vge_si=0.0;
  T12_Tempt_GND_Vdi_si=0.0;
  T12_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T12=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=0.0;
  T8_Vdi_si_Vdi_si=0.0;
  T8_Vdi_si_Ve_si=0.0;
  T8_Vdi_si_Ve_di=0.0;
  T8_Vdi_si_Vge_si=0.0;
  T8_Vdi_si_Tempt_GND=0.0;
#endif
T8_Ve_si=0.0;
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=0.0;
  T8_Ve_si_Vdi_si=0.0;
  T8_Ve_si_Ve_si=0.0;
  T8_Ve_si_Ve_di=0.0;
  T8_Ve_si_Vge_si=0.0;
  T8_Ve_si_Tempt_GND=0.0;
#endif
T8_Ve_di=0.0;
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=0.0;
  T8_Ve_di_Vdi_si=0.0;
  T8_Ve_di_Ve_si=0.0;
  T8_Ve_di_Ve_di=0.0;
  T8_Ve_di_Vge_si=0.0;
  T8_Ve_di_Tempt_GND=0.0;
#endif
T8_Vge_si=0.0;
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=0.0;
  T8_Vge_si_Vdi_si=0.0;
  T8_Vge_si_Ve_si=0.0;
  T8_Vge_si_Ve_di=0.0;
  T8_Vge_si_Vge_si=0.0;
  T8_Vge_si_Tempt_GND=0.0;
#endif
T8_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=0.0;
  T8_Tempt_GND_Vdi_si=0.0;
  T8_Tempt_GND_Ve_si=0.0;
  T8_Tempt_GND_Ve_di=0.0;
  T8_Tempt_GND_Vge_si=0.0;
  T8_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T8=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qba_Tempt_GND=((T12_Tempt_GND*Vtm)+(T12*Vtm_Tempt_GND));
#if defined(_DERIVATE2)
  qba_Tempt_GND_Tempt_GND=(+T12_Tempt_GND_Tempt_GND*Vtm+T12_Tempt_GND*Vtm_Tempt_GND+T12_Tempt_GND*Vtm_Tempt_GND+T12*Vtm_Tempt_GND_Tempt_GND);
  qba_Tempt_GND_Vdi_si=(+T12_Tempt_GND_Vdi_si*Vtm+T12_Tempt_GND*0.0+T12_Vdi_si*Vtm_Tempt_GND+T12*0.0);
  qba_Tempt_GND_Vge_e=(+T12_Tempt_GND_Vge_e*Vtm+T12_Tempt_GND*0.0+T12_Vge_e*Vtm_Tempt_GND+T12*0.0);
  qba_Tempt_GND_Ve_si=(+T12_Tempt_GND_Ve_si*Vtm+T12_Tempt_GND*0.0+T12_Ve_si*Vtm_Tempt_GND+T12*0.0);
  qba_Tempt_GND_Ve_di=(+T12_Tempt_GND_Ve_di*Vtm+T12_Tempt_GND*0.0+T12_Ve_di*Vtm_Tempt_GND+T12*0.0);
  qba_Tempt_GND_Vge_si=(+T12_Tempt_GND_Vge_si*Vtm+T12_Tempt_GND*0.0+T12_Vge_si*Vtm_Tempt_GND+T12*0.0);
#endif
qba_Vdi_si=T12_Vdi_si*Vtm;
#if defined(_DERIVATE2)
  qba_Vdi_si_Tempt_GND=(+T12_Vdi_si_Tempt_GND*Vtm+T12_Vdi_si*Vtm_Tempt_GND+T12_Tempt_GND*0.0+T12*0.0);
  qba_Vdi_si_Vdi_si=(+T12_Vdi_si_Vdi_si*Vtm+T12_Vdi_si*0.0+T12_Vdi_si*0.0+T12*0.0);
  qba_Vdi_si_Vge_e=(+T12_Vdi_si_Vge_e*Vtm+T12_Vdi_si*0.0+T12_Vge_e*0.0+T12*0.0);
  qba_Vdi_si_Ve_si=(+T12_Vdi_si_Ve_si*Vtm+T12_Vdi_si*0.0+T12_Ve_si*0.0+T12*0.0);
  qba_Vdi_si_Ve_di=(+T12_Vdi_si_Ve_di*Vtm+T12_Vdi_si*0.0+T12_Ve_di*0.0+T12*0.0);
  qba_Vdi_si_Vge_si=(+T12_Vdi_si_Vge_si*Vtm+T12_Vdi_si*0.0+T12_Vge_si*0.0+T12*0.0);
#endif
qba_Vge_e=T12_Vge_e*Vtm;
#if defined(_DERIVATE2)
  qba_Vge_e_Tempt_GND=(+T12_Vge_e_Tempt_GND*Vtm+T12_Vge_e*Vtm_Tempt_GND+T12_Tempt_GND*0.0+T12*0.0);
  qba_Vge_e_Vdi_si=(+T12_Vge_e_Vdi_si*Vtm+T12_Vge_e*0.0+T12_Vdi_si*0.0+T12*0.0);
  qba_Vge_e_Vge_e=(+T12_Vge_e_Vge_e*Vtm+T12_Vge_e*0.0+T12_Vge_e*0.0+T12*0.0);
  qba_Vge_e_Ve_si=(+T12_Vge_e_Ve_si*Vtm+T12_Vge_e*0.0+T12_Ve_si*0.0+T12*0.0);
  qba_Vge_e_Ve_di=(+T12_Vge_e_Ve_di*Vtm+T12_Vge_e*0.0+T12_Ve_di*0.0+T12*0.0);
  qba_Vge_e_Vge_si=(+T12_Vge_e_Vge_si*Vtm+T12_Vge_e*0.0+T12_Vge_si*0.0+T12*0.0);
#endif
qba_Ve_si=T12_Ve_si*Vtm;
#if defined(_DERIVATE2)
  qba_Ve_si_Tempt_GND=(+T12_Ve_si_Tempt_GND*Vtm+T12_Ve_si*Vtm_Tempt_GND+T12_Tempt_GND*0.0+T12*0.0);
  qba_Ve_si_Vdi_si=(+T12_Ve_si_Vdi_si*Vtm+T12_Ve_si*0.0+T12_Vdi_si*0.0+T12*0.0);
  qba_Ve_si_Vge_e=(+T12_Ve_si_Vge_e*Vtm+T12_Ve_si*0.0+T12_Vge_e*0.0+T12*0.0);
  qba_Ve_si_Ve_si=(+T12_Ve_si_Ve_si*Vtm+T12_Ve_si*0.0+T12_Ve_si*0.0+T12*0.0);
  qba_Ve_si_Ve_di=(+T12_Ve_si_Ve_di*Vtm+T12_Ve_si*0.0+T12_Ve_di*0.0+T12*0.0);
  qba_Ve_si_Vge_si=(+T12_Ve_si_Vge_si*Vtm+T12_Ve_si*0.0+T12_Vge_si*0.0+T12*0.0);
#endif
qba_Ve_di=T12_Ve_di*Vtm;
#if defined(_DERIVATE2)
  qba_Ve_di_Tempt_GND=(+T12_Ve_di_Tempt_GND*Vtm+T12_Ve_di*Vtm_Tempt_GND+T12_Tempt_GND*0.0+T12*0.0);
  qba_Ve_di_Vdi_si=(+T12_Ve_di_Vdi_si*Vtm+T12_Ve_di*0.0+T12_Vdi_si*0.0+T12*0.0);
  qba_Ve_di_Vge_e=(+T12_Ve_di_Vge_e*Vtm+T12_Ve_di*0.0+T12_Vge_e*0.0+T12*0.0);
  qba_Ve_di_Ve_si=(+T12_Ve_di_Ve_si*Vtm+T12_Ve_di*0.0+T12_Ve_si*0.0+T12*0.0);
  qba_Ve_di_Ve_di=(+T12_Ve_di_Ve_di*Vtm+T12_Ve_di*0.0+T12_Ve_di*0.0+T12*0.0);
  qba_Ve_di_Vge_si=(+T12_Ve_di_Vge_si*Vtm+T12_Ve_di*0.0+T12_Vge_si*0.0+T12*0.0);
#endif
qba_Vge_si=T12_Vge_si*Vtm;
#if defined(_DERIVATE2)
  qba_Vge_si_Tempt_GND=(+T12_Vge_si_Tempt_GND*Vtm+T12_Vge_si*Vtm_Tempt_GND+T12_Tempt_GND*0.0+T12*0.0);
  qba_Vge_si_Vdi_si=(+T12_Vge_si_Vdi_si*Vtm+T12_Vge_si*0.0+T12_Vdi_si*0.0+T12*0.0);
  qba_Vge_si_Vge_e=(+T12_Vge_si_Vge_e*Vtm+T12_Vge_si*0.0+T12_Vge_e*0.0+T12*0.0);
  qba_Vge_si_Ve_si=(+T12_Vge_si_Ve_si*Vtm+T12_Vge_si*0.0+T12_Ve_si*0.0+T12*0.0);
  qba_Vge_si_Ve_di=(+T12_Vge_si_Ve_di*Vtm+T12_Vge_si*0.0+T12_Ve_di*0.0+T12*0.0);
  qba_Vge_si_Vge_si=(+T12_Vge_si_Vge_si*Vtm+T12_Vge_si*0.0+T12_Vge_si*0.0+T12*0.0);
#endif
#endif
qba=(T12*Vtm);
EXIT_IF_ISNAN((T12*Vtm))
}
{
double m00_exp(d00_exp0,((-T8)/2.0))
#if defined(_DERIVATEFORDDX)
#define d10_exp0 d00_exp0
#endif
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qi_acc_for_QM_Tempt_GND=((((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*Vtm)+((T9*d00_exp0)*Vtm_Tempt_GND));
#if defined(_DERIVATE2)
  qi_acc_for_QM_Tempt_GND_Tempt_GND=(+(+T9_Tempt_GND_Tempt_GND*d00_exp0+T9_Tempt_GND*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*Vtm_Tempt_GND_Tempt_GND);
  qi_acc_for_QM_Tempt_GND_Vdi_si=(+(+T9_Tempt_GND_Vdi_si*d00_exp0+T9_Tempt_GND*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Tempt_GND_Vge_e=(+(+T9_Tempt_GND_Vge_e*d00_exp0+T9_Tempt_GND*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Tempt_GND_Ve_si=(+(+T9_Tempt_GND_Ve_si*d00_exp0+T9_Tempt_GND*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Tempt_GND_Ve_di=(+(+T9_Tempt_GND_Ve_di*d00_exp0+T9_Tempt_GND*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Tempt_GND_Vge_si=(+(+T9_Tempt_GND_Vge_si*d00_exp0+T9_Tempt_GND*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Tempt_GND)/2.0)+d10_exp0*(0.0/2.0-((-T8_Tempt_GND)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*Vtm_Tempt_GND+(T9*d00_exp0)*0.0);
#endif
qi_acc_for_QM_Vdi_si=((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*Vtm;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vdi_si_Tempt_GND=(+(+T9_Vdi_si_Tempt_GND*d00_exp0+T9_Vdi_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vdi_si_Vdi_si=(+(+T9_Vdi_si_Vdi_si*d00_exp0+T9_Vdi_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vdi_si_Vge_e=(+(+T9_Vdi_si_Vge_e*d00_exp0+T9_Vdi_si*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vdi_si_Ve_si=(+(+T9_Vdi_si_Ve_si*d00_exp0+T9_Vdi_si*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vdi_si_Ve_di=(+(+T9_Vdi_si_Ve_di*d00_exp0+T9_Vdi_si*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vdi_si_Vge_si=(+(+T9_Vdi_si_Vge_si*d00_exp0+T9_Vdi_si*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Vdi_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vdi_si)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
#endif
qi_acc_for_QM_Vge_e=((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*Vtm;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vge_e_Tempt_GND=(+(+T9_Vge_e_Tempt_GND*d00_exp0+T9_Vge_e*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_e_Vdi_si=(+(+T9_Vge_e_Vdi_si*d00_exp0+T9_Vge_e*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_e_Vge_e=(+(+T9_Vge_e_Vge_e*d00_exp0+T9_Vge_e*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_e_Ve_si=(+(+T9_Vge_e_Ve_si*d00_exp0+T9_Vge_e*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_e_Ve_di=(+(+T9_Vge_e_Ve_di*d00_exp0+T9_Vge_e*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_e_Vge_si=(+(+T9_Vge_e_Vge_si*d00_exp0+T9_Vge_e*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Vge_e)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Vge_e)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_e)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
#endif
qi_acc_for_QM_Ve_si=((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*Vtm;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Ve_si_Tempt_GND=(+(+T9_Ve_si_Tempt_GND*d00_exp0+T9_Ve_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_si_Vdi_si=(+(+T9_Ve_si_Vdi_si*d00_exp0+T9_Ve_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_si_Vge_e=(+(+T9_Ve_si_Vge_e*d00_exp0+T9_Ve_si*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_si_Ve_si=(+(+T9_Ve_si_Ve_si*d00_exp0+T9_Ve_si*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_si_Ve_di=(+(+T9_Ve_si_Ve_di*d00_exp0+T9_Ve_si*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_si_Vge_si=(+(+T9_Ve_si_Vge_si*d00_exp0+T9_Ve_si*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Ve_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Ve_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_si)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
#endif
qi_acc_for_QM_Ve_di=((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*Vtm;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Ve_di_Tempt_GND=(+(+T9_Ve_di_Tempt_GND*d00_exp0+T9_Ve_di*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_di_Vdi_si=(+(+T9_Ve_di_Vdi_si*d00_exp0+T9_Ve_di*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_di_Vge_e=(+(+T9_Ve_di_Vge_e*d00_exp0+T9_Ve_di*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_di_Ve_si=(+(+T9_Ve_di_Ve_si*d00_exp0+T9_Ve_di*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_di_Ve_di=(+(+T9_Ve_di_Ve_di*d00_exp0+T9_Ve_di*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Ve_di_Vge_si=(+(+T9_Ve_di_Vge_si*d00_exp0+T9_Ve_di*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Ve_di)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Ve_di)/2.0)+d10_exp0*(0.0/2.0-((-T8_Ve_di)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
#endif
qi_acc_for_QM_Vge_si=((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*Vtm;
#if defined(_DERIVATE2)
  qi_acc_for_QM_Vge_si_Tempt_GND=(+(+T9_Vge_si_Tempt_GND*d00_exp0+T9_Vge_si*((-T8_Tempt_GND)/2.0)*d10_exp0+T9_Tempt_GND*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Tempt_GND)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Tempt_GND)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*Vtm_Tempt_GND+(((T9_Tempt_GND*d00_exp0)+(T9*((-T8_Tempt_GND)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_si_Vdi_si=(+(+T9_Vge_si_Vdi_si*d00_exp0+T9_Vge_si*((-T8_Vdi_si)/2.0)*d10_exp0+T9_Vdi_si*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vdi_si)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Vdi_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*0.0+(((T9_Vdi_si*d00_exp0)+(T9*((-T8_Vdi_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_si_Vge_e=(+(+T9_Vge_si_Vge_e*d00_exp0+T9_Vge_si*((-T8_Vge_e)/2.0)*d10_exp0+T9_Vge_e*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_e)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Vge_e)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_e*d00_exp0)+(T9*((-T8_Vge_e)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_si_Ve_si=(+(+T9_Vge_si_Ve_si*d00_exp0+T9_Vge_si*((-T8_Ve_si)/2.0)*d10_exp0+T9_Ve_si*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_si)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Ve_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_si*d00_exp0)+(T9*((-T8_Ve_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_si_Ve_di=(+(+T9_Vge_si_Ve_di*d00_exp0+T9_Vge_si*((-T8_Ve_di)/2.0)*d10_exp0+T9_Ve_di*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Ve_di)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Ve_di)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*0.0+(((T9_Ve_di*d00_exp0)+(T9*((-T8_Ve_di)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
  qi_acc_for_QM_Vge_si_Vge_si=(+(+T9_Vge_si_Vge_si*d00_exp0+T9_Vge_si*((-T8_Vge_si)/2.0)*d10_exp0+T9_Vge_si*((-T8_Vge_si)/2.0)*d10_exp0+T9*(m20_exp(((-T8)/2.0))*((-T8_Vge_si)/2.0)*((-T8_Vge_si)/2.0)+d10_exp0*(0.0/2.0-((-T8_Vge_si)*0.0+(-T8_Vge_si)*0.0+(-T8)*0.0)/2.0/2.0+2*(-T8)*0.0*0.0/2.0/2.0/2.0)))*Vtm+((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0))*0.0+(((T9_Vge_si*d00_exp0)+(T9*((-T8_Vge_si)/2.0)*d10_exp0)))*0.0+(T9*d00_exp0)*0.0);
#endif
#endif
qi_acc_for_QM=((T9*d00_exp0)*Vtm);
EXIT_IF_ISNAN(((T9*d00_exp0)*Vtm))
}
{
double m00_sqrt(d00_sqrt0,(((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
psipclamp_Vge_e=(0.5*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vge_e_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Vge_e-0.0)*(T8-1.0)+T8_Vge_e*T8_Vge_e+T8_Vge_e*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_e_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Vdi_si-0.0)*(T8-1.0)+T8_Vge_e*T8_Vdi_si+T8_Vdi_si*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_e_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Ve_si-0.0)*(T8-1.0)+T8_Vge_e*T8_Ve_si+T8_Ve_si*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_e_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Ve_di-0.0)*(T8-1.0)+T8_Vge_e*T8_Ve_di+T8_Ve_di*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_e_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Vge_si-0.0)*(T8-1.0)+T8_Vge_e*T8_Vge_si+T8_Vge_si*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_e_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_e+((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))*d10_sqrt0)+0.5*(+(+T8_Vge_e_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e))+d10_sqrt0*(+(+(+T8_Vge_e_Tempt_GND-0.0)*(T8-1.0)+T8_Vge_e*T8_Tempt_GND+T8_Tempt_GND*T8_Vge_e+(T8-1.0)*(+T8_Vge_e_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vdi_si=(0.5*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vdi_si_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Vge_e-0.0)*(T8-1.0)+T8_Vdi_si*T8_Vge_e+T8_Vge_e*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_si_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Vdi_si-0.0)*(T8-1.0)+T8_Vdi_si*T8_Vdi_si+T8_Vdi_si*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_si_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Ve_si-0.0)*(T8-1.0)+T8_Vdi_si*T8_Ve_si+T8_Ve_si*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_si_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Ve_di-0.0)*(T8-1.0)+T8_Vdi_si*T8_Ve_di+T8_Ve_di*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_si_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Vge_si-0.0)*(T8-1.0)+T8_Vdi_si*T8_Vge_si+T8_Vge_si*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vdi_si_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vdi_si+((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))*d10_sqrt0)+0.5*(+(+T8_Vdi_si_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si))+d10_sqrt0*(+(+(+T8_Vdi_si_Tempt_GND-0.0)*(T8-1.0)+T8_Vdi_si*T8_Tempt_GND+T8_Tempt_GND*T8_Vdi_si+(T8-1.0)*(+T8_Vdi_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Ve_si=(0.5*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Ve_si_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Vge_e-0.0)*(T8-1.0)+T8_Ve_si*T8_Vge_e+T8_Vge_e*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_si_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Vdi_si-0.0)*(T8-1.0)+T8_Ve_si*T8_Vdi_si+T8_Vdi_si*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_si_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Ve_si-0.0)*(T8-1.0)+T8_Ve_si*T8_Ve_si+T8_Ve_si*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_si_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Ve_di-0.0)*(T8-1.0)+T8_Ve_si*T8_Ve_di+T8_Ve_di*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_si_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Vge_si-0.0)*(T8-1.0)+T8_Ve_si*T8_Vge_si+T8_Vge_si*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_si_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_si+((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))*d10_sqrt0)+0.5*(+(+T8_Ve_si_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si))+d10_sqrt0*(+(+(+T8_Ve_si_Tempt_GND-0.0)*(T8-1.0)+T8_Ve_si*T8_Tempt_GND+T8_Tempt_GND*T8_Ve_si+(T8-1.0)*(+T8_Ve_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Ve_di=(0.5*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Ve_di_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Vge_e-0.0)*(T8-1.0)+T8_Ve_di*T8_Vge_e+T8_Vge_e*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_di_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Vdi_si-0.0)*(T8-1.0)+T8_Ve_di*T8_Vdi_si+T8_Vdi_si*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_di_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Ve_si-0.0)*(T8-1.0)+T8_Ve_di*T8_Ve_si+T8_Ve_si*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_di_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Ve_di-0.0)*(T8-1.0)+T8_Ve_di*T8_Ve_di+T8_Ve_di*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_di_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Vge_si-0.0)*(T8-1.0)+T8_Ve_di*T8_Vge_si+T8_Vge_si*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Ve_di_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Ve_di+((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))*d10_sqrt0)+0.5*(+(+T8_Ve_di_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di))+d10_sqrt0*(+(+(+T8_Ve_di_Tempt_GND-0.0)*(T8-1.0)+T8_Ve_di*T8_Tempt_GND+T8_Tempt_GND*T8_Ve_di+(T8-1.0)*(+T8_Ve_di_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Vge_si=(0.5*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Vge_si_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Vge_e-0.0)*(T8-1.0)+T8_Vge_si*T8_Vge_e+T8_Vge_e*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_si_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Vdi_si-0.0)*(T8-1.0)+T8_Vge_si*T8_Vdi_si+T8_Vdi_si*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_si_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Ve_si-0.0)*(T8-1.0)+T8_Vge_si*T8_Ve_si+T8_Ve_si*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_si_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Ve_di-0.0)*(T8-1.0)+T8_Vge_si*T8_Ve_di+T8_Ve_di*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_si_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Vge_si-0.0)*(T8-1.0)+T8_Vge_si*T8_Vge_si+T8_Vge_si*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Vge_si_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Vge_si+((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))*d10_sqrt0)+0.5*(+(+T8_Vge_si_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si))+d10_sqrt0*(+(+(+T8_Vge_si_Tempt_GND-0.0)*(T8-1.0)+T8_Vge_si*T8_Tempt_GND+T8_Tempt_GND*T8_Vge_si+(T8-1.0)*(+T8_Vge_si_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
psipclamp_Tempt_GND=(0.5*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  psipclamp_Tempt_GND_Vge_e=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_e+((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Vge_e+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_e*(T8-1.0))+((T8-1.0)*T8_Vge_e)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Vge_e-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Vge_e+T8_Vge_e*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Vge_e-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Tempt_GND_Vdi_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vdi_si+((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Vdi_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vdi_si*(T8-1.0))+((T8-1.0)*T8_Vdi_si)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Vdi_si-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Vdi_si+T8_Vdi_si*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Vdi_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Tempt_GND_Ve_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_si+((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Ve_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_si*(T8-1.0))+((T8-1.0)*T8_Ve_si)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Ve_si-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Ve_si+T8_Ve_si*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Ve_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Tempt_GND_Ve_di=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Ve_di+((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Ve_di+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Ve_di*(T8-1.0))+((T8-1.0)*T8_Ve_di)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Ve_di-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Ve_di+T8_Ve_di*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Ve_di-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Tempt_GND_Vge_si=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Vge_si+((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Vge_si+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Vge_si*(T8-1.0))+((T8-1.0)*T8_Vge_si)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Vge_si-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Vge_si+T8_Vge_si*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Vge_si-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
  psipclamp_Tempt_GND_Tempt_GND=(+0.0*((T8+1.0)+d00_sqrt0)+0.0*(T8_Tempt_GND+((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*d10_sqrt0)+0.0*(T8_Tempt_GND+((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))*d10_sqrt0)+0.5*(+(+T8_Tempt_GND_Tempt_GND+0.0)+(m20_sqrt((((T8-1.0)*(T8-1.0))+((0.25*2.0)*2.0)))*((((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND)))+((0.0)*2.0))*((T8_Tempt_GND*(T8-1.0))+((T8-1.0)*T8_Tempt_GND))+d10_sqrt0*(+(+(+T8_Tempt_GND_Tempt_GND-0.0)*(T8-1.0)+T8_Tempt_GND*T8_Tempt_GND+T8_Tempt_GND*T8_Tempt_GND+(T8-1.0)*(+T8_Tempt_GND_Tempt_GND-0.0))+(+(+0.0*2.0+0.0*0.0+0.0*0.0+0.25*0.0)*2.0+0.0*0.0+(0.0)*0.0+(0.25*2.0)*0.0)))));
#endif
#endif
psipclamp=(0.5*((T8+1.0)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T8+1.0)+d00_sqrt0)))
}
{
double m00_sqrt(d00_sqrt0,psipclamp)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,psipclamp)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
sqrtpsip_Vge_e=psipclamp_Vge_e*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vge_e_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Vge_e);
  sqrtpsip_Vge_e_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Vdi_si);
  sqrtpsip_Vge_e_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Ve_si);
  sqrtpsip_Vge_e_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Ve_di);
  sqrtpsip_Vge_e_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Vge_si);
  sqrtpsip_Vge_e_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vge_e+d10_sqrt0*psipclamp_Vge_e_Tempt_GND);
#endif
sqrtpsip_Vdi_si=psipclamp_Vdi_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vdi_si_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Vge_e);
  sqrtpsip_Vdi_si_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Vdi_si);
  sqrtpsip_Vdi_si_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Ve_si);
  sqrtpsip_Vdi_si_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Ve_di);
  sqrtpsip_Vdi_si_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Vge_si);
  sqrtpsip_Vdi_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vdi_si+d10_sqrt0*psipclamp_Vdi_si_Tempt_GND);
#endif
sqrtpsip_Ve_si=psipclamp_Ve_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Ve_si_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Vge_e);
  sqrtpsip_Ve_si_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Vdi_si);
  sqrtpsip_Ve_si_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Ve_si);
  sqrtpsip_Ve_si_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Ve_di);
  sqrtpsip_Ve_si_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Vge_si);
  sqrtpsip_Ve_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Ve_si+d10_sqrt0*psipclamp_Ve_si_Tempt_GND);
#endif
sqrtpsip_Ve_di=psipclamp_Ve_di*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Ve_di_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Vge_e);
  sqrtpsip_Ve_di_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Vdi_si);
  sqrtpsip_Ve_di_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Ve_si);
  sqrtpsip_Ve_di_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Ve_di);
  sqrtpsip_Ve_di_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Vge_si);
  sqrtpsip_Ve_di_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Ve_di+d10_sqrt0*psipclamp_Ve_di_Tempt_GND);
#endif
sqrtpsip_Vge_si=psipclamp_Vge_si*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Vge_si_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Vge_e);
  sqrtpsip_Vge_si_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Vdi_si);
  sqrtpsip_Vge_si_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Ve_si);
  sqrtpsip_Vge_si_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Ve_di);
  sqrtpsip_Vge_si_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Vge_si);
  sqrtpsip_Vge_si_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Vge_si+d10_sqrt0*psipclamp_Vge_si_Tempt_GND);
#endif
sqrtpsip_Tempt_GND=psipclamp_Tempt_GND*d10_sqrt0;
#if defined(_DERIVATE2)
  sqrtpsip_Tempt_GND_Vge_e=(m20_sqrt(psipclamp)*psipclamp_Vge_e*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Vge_e);
  sqrtpsip_Tempt_GND_Vdi_si=(m20_sqrt(psipclamp)*psipclamp_Vdi_si*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Vdi_si);
  sqrtpsip_Tempt_GND_Ve_si=(m20_sqrt(psipclamp)*psipclamp_Ve_si*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Ve_si);
  sqrtpsip_Tempt_GND_Ve_di=(m20_sqrt(psipclamp)*psipclamp_Ve_di*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Ve_di);
  sqrtpsip_Tempt_GND_Vge_si=(m20_sqrt(psipclamp)*psipclamp_Vge_si*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Vge_si);
  sqrtpsip_Tempt_GND_Tempt_GND=(m20_sqrt(psipclamp)*psipclamp_Tempt_GND*psipclamp_Tempt_GND+d10_sqrt0*psipclamp_Tempt_GND_Tempt_GND);
#endif
#endif
sqrtpsip=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
nq_Tempt_GND=((T9_Tempt_GND*sqrtpsip-T9*sqrtpsip_Tempt_GND)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Tempt_GND_Tempt_GND=(+0.0+(T9_Tempt_GND_Tempt_GND/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Tempt_GND_Vdi_si=(+0.0+(T9_Tempt_GND_Vdi_si/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Tempt_GND_Vge_e=(+0.0+(T9_Tempt_GND_Vge_e/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Tempt_GND_Ve_si=(+0.0+(T9_Tempt_GND_Ve_si/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Tempt_GND_Ve_di=(+0.0+(T9_Tempt_GND_Ve_di/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Tempt_GND_Vge_si=(+0.0+(T9_Tempt_GND_Vge_si/sqrtpsip-(T9_Tempt_GND*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Tempt_GND+T9*sqrtpsip_Tempt_GND_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Tempt_GND*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
nq_Vdi_si=((T9_Vdi_si*sqrtpsip-T9*sqrtpsip_Vdi_si)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Vdi_si_Tempt_GND=(+0.0+(T9_Vdi_si_Tempt_GND/sqrtpsip-(T9_Vdi_si*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vdi_si_Vdi_si=(+0.0+(T9_Vdi_si_Vdi_si/sqrtpsip-(T9_Vdi_si*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vdi_si_Vge_e=(+0.0+(T9_Vdi_si_Vge_e/sqrtpsip-(T9_Vdi_si*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vdi_si_Ve_si=(+0.0+(T9_Vdi_si_Ve_si/sqrtpsip-(T9_Vdi_si*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vdi_si_Ve_di=(+0.0+(T9_Vdi_si_Ve_di/sqrtpsip-(T9_Vdi_si*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vdi_si_Vge_si=(+0.0+(T9_Vdi_si_Vge_si/sqrtpsip-(T9_Vdi_si*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Vdi_si+T9*sqrtpsip_Vdi_si_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vdi_si*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
nq_Vge_e=((T9_Vge_e*sqrtpsip-T9*sqrtpsip_Vge_e)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Vge_e_Tempt_GND=(+0.0+(T9_Vge_e_Tempt_GND/sqrtpsip-(T9_Vge_e*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_e_Vdi_si=(+0.0+(T9_Vge_e_Vdi_si/sqrtpsip-(T9_Vge_e*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_e_Vge_e=(+0.0+(T9_Vge_e_Vge_e/sqrtpsip-(T9_Vge_e*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_e_Ve_si=(+0.0+(T9_Vge_e_Ve_si/sqrtpsip-(T9_Vge_e*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_e_Ve_di=(+0.0+(T9_Vge_e_Ve_di/sqrtpsip-(T9_Vge_e*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_e_Vge_si=(+0.0+(T9_Vge_e_Vge_si/sqrtpsip-(T9_Vge_e*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Vge_e+T9*sqrtpsip_Vge_e_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_e*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
nq_Ve_si=((T9_Ve_si*sqrtpsip-T9*sqrtpsip_Ve_si)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Ve_si_Tempt_GND=(+0.0+(T9_Ve_si_Tempt_GND/sqrtpsip-(T9_Ve_si*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_si_Vdi_si=(+0.0+(T9_Ve_si_Vdi_si/sqrtpsip-(T9_Ve_si*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_si_Vge_e=(+0.0+(T9_Ve_si_Vge_e/sqrtpsip-(T9_Ve_si*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_si_Ve_si=(+0.0+(T9_Ve_si_Ve_si/sqrtpsip-(T9_Ve_si*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_si_Ve_di=(+0.0+(T9_Ve_si_Ve_di/sqrtpsip-(T9_Ve_si*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_si_Vge_si=(+0.0+(T9_Ve_si_Vge_si/sqrtpsip-(T9_Ve_si*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Ve_si+T9*sqrtpsip_Ve_si_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_si*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
nq_Ve_di=((T9_Ve_di*sqrtpsip-T9*sqrtpsip_Ve_di)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Ve_di_Tempt_GND=(+0.0+(T9_Ve_di_Tempt_GND/sqrtpsip-(T9_Ve_di*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_di_Vdi_si=(+0.0+(T9_Ve_di_Vdi_si/sqrtpsip-(T9_Ve_di*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_di_Vge_e=(+0.0+(T9_Ve_di_Vge_e/sqrtpsip-(T9_Ve_di*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_di_Ve_si=(+0.0+(T9_Ve_di_Ve_si/sqrtpsip-(T9_Ve_di*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_di_Ve_di=(+0.0+(T9_Ve_di_Ve_di/sqrtpsip-(T9_Ve_di*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Ve_di_Vge_si=(+0.0+(T9_Ve_di_Vge_si/sqrtpsip-(T9_Ve_di*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Ve_di+T9*sqrtpsip_Ve_di_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Ve_di*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
nq_Vge_si=((T9_Vge_si*sqrtpsip-T9*sqrtpsip_Vge_si)/sqrtpsip/sqrtpsip);
#if defined(_DERIVATE2)
  nq_Vge_si_Tempt_GND=(+0.0+(T9_Vge_si_Tempt_GND/sqrtpsip-(T9_Vge_si*sqrtpsip_Tempt_GND+T9_Tempt_GND*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Tempt_GND)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Tempt_GND/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_si_Vdi_si=(+0.0+(T9_Vge_si_Vdi_si/sqrtpsip-(T9_Vge_si*sqrtpsip_Vdi_si+T9_Vdi_si*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Vdi_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Vdi_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_si_Vge_e=(+0.0+(T9_Vge_si_Vge_e/sqrtpsip-(T9_Vge_si*sqrtpsip_Vge_e+T9_Vge_e*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Vge_e)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Vge_e/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_si_Ve_si=(+0.0+(T9_Vge_si_Ve_si/sqrtpsip-(T9_Vge_si*sqrtpsip_Ve_si+T9_Ve_si*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Ve_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Ve_si/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_si_Ve_di=(+0.0+(T9_Vge_si_Ve_di/sqrtpsip-(T9_Vge_si*sqrtpsip_Ve_di+T9_Ve_di*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Ve_di)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Ve_di/sqrtpsip/sqrtpsip/sqrtpsip));
  nq_Vge_si_Vge_si=(+0.0+(T9_Vge_si_Vge_si/sqrtpsip-(T9_Vge_si*sqrtpsip_Vge_si+T9_Vge_si*sqrtpsip_Vge_si+T9*sqrtpsip_Vge_si_Vge_si)/sqrtpsip/sqrtpsip+2*T9*sqrtpsip_Vge_si*sqrtpsip_Vge_si/sqrtpsip/sqrtpsip/sqrtpsip));
#endif
#endif
nq=(1.0+(T9/sqrtpsip));
EXIT_IF_ISNAN((1.0+(T9/sqrtpsip)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
qia_Vdi_si=(0.5*(qis_Vdi_si+qid_Vdi_si));
#if defined(_DERIVATE2)
  qia_Vdi_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vdi_si+qid_Vdi_si_Vdi_si));
  qia_Vdi_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_si+qid_Vdi_si_Ve_si));
  qia_Vdi_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_di+qid_Vdi_si_Ve_di));
  qia_Vdi_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vge_si+qid_Vdi_si_Vge_si));
  qia_Vdi_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Tempt_GND+qid_Vdi_si_Tempt_GND));
#endif
qia_Ve_si=(0.5*(qis_Ve_si+qid_Ve_si));
#if defined(_DERIVATE2)
  qia_Ve_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vdi_si+qid_Ve_si_Vdi_si));
  qia_Ve_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_si+qid_Ve_si_Ve_si));
  qia_Ve_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_di+qid_Ve_si_Ve_di));
  qia_Ve_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vge_si+qid_Ve_si_Vge_si));
  qia_Ve_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Tempt_GND+qid_Ve_si_Tempt_GND));
#endif
qia_Ve_di=(0.5*(qis_Ve_di+qid_Ve_di));
#if defined(_DERIVATE2)
  qia_Ve_di_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vdi_si+qid_Ve_di_Vdi_si));
  qia_Ve_di_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_si+qid_Ve_di_Ve_si));
  qia_Ve_di_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_di+qid_Ve_di_Ve_di));
  qia_Ve_di_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vge_si+qid_Ve_di_Vge_si));
  qia_Ve_di_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Tempt_GND+qid_Ve_di_Tempt_GND));
#endif
qia_Vge_si=(0.5*(qis_Vge_si+qid_Vge_si));
#if defined(_DERIVATE2)
  qia_Vge_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vdi_si+qid_Vge_si_Vdi_si));
  qia_Vge_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_si+qid_Vge_si_Ve_si));
  qia_Vge_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_di+qid_Vge_si_Ve_di));
  qia_Vge_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vge_si+qid_Vge_si_Vge_si));
  qia_Vge_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Tempt_GND+qid_Vge_si_Tempt_GND));
#endif
qia_Tempt_GND=(0.5*(qis_Tempt_GND+qid_Tempt_GND));
#if defined(_DERIVATE2)
  qia_Tempt_GND_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vdi_si+qid_Tempt_GND_Vdi_si));
  qia_Tempt_GND_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_si+qid_Tempt_GND_Ve_si));
  qia_Tempt_GND_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_di+qid_Tempt_GND_Ve_di));
  qia_Tempt_GND_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vge_si+qid_Tempt_GND_Vge_si));
  qia_Tempt_GND_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Tempt_GND+qid_Tempt_GND_Tempt_GND));
#endif
#endif
qia=(0.5*(qis+qid));
EXIT_IF_ISNAN((0.5*(qis+qid)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
dqi_Vdi_si=(qis_Vdi_si-qid_Vdi_si);
#if defined(_DERIVATE2)
  dqi_Vdi_si_Vdi_si=(+qis_Vdi_si_Vdi_si-qid_Vdi_si_Vdi_si);
  dqi_Vdi_si_Ve_si=(+qis_Vdi_si_Ve_si-qid_Vdi_si_Ve_si);
  dqi_Vdi_si_Ve_di=(+qis_Vdi_si_Ve_di-qid_Vdi_si_Ve_di);
  dqi_Vdi_si_Vge_si=(+qis_Vdi_si_Vge_si-qid_Vdi_si_Vge_si);
  dqi_Vdi_si_Tempt_GND=(+qis_Vdi_si_Tempt_GND-qid_Vdi_si_Tempt_GND);
#endif
dqi_Ve_si=(qis_Ve_si-qid_Ve_si);
#if defined(_DERIVATE2)
  dqi_Ve_si_Vdi_si=(+qis_Ve_si_Vdi_si-qid_Ve_si_Vdi_si);
  dqi_Ve_si_Ve_si=(+qis_Ve_si_Ve_si-qid_Ve_si_Ve_si);
  dqi_Ve_si_Ve_di=(+qis_Ve_si_Ve_di-qid_Ve_si_Ve_di);
  dqi_Ve_si_Vge_si=(+qis_Ve_si_Vge_si-qid_Ve_si_Vge_si);
  dqi_Ve_si_Tempt_GND=(+qis_Ve_si_Tempt_GND-qid_Ve_si_Tempt_GND);
#endif
dqi_Ve_di=(qis_Ve_di-qid_Ve_di);
#if defined(_DERIVATE2)
  dqi_Ve_di_Vdi_si=(+qis_Ve_di_Vdi_si-qid_Ve_di_Vdi_si);
  dqi_Ve_di_Ve_si=(+qis_Ve_di_Ve_si-qid_Ve_di_Ve_si);
  dqi_Ve_di_Ve_di=(+qis_Ve_di_Ve_di-qid_Ve_di_Ve_di);
  dqi_Ve_di_Vge_si=(+qis_Ve_di_Vge_si-qid_Ve_di_Vge_si);
  dqi_Ve_di_Tempt_GND=(+qis_Ve_di_Tempt_GND-qid_Ve_di_Tempt_GND);
#endif
dqi_Vge_si=(qis_Vge_si-qid_Vge_si);
#if defined(_DERIVATE2)
  dqi_Vge_si_Vdi_si=(+qis_Vge_si_Vdi_si-qid_Vge_si_Vdi_si);
  dqi_Vge_si_Ve_si=(+qis_Vge_si_Ve_si-qid_Vge_si_Ve_si);
  dqi_Vge_si_Ve_di=(+qis_Vge_si_Ve_di-qid_Vge_si_Ve_di);
  dqi_Vge_si_Vge_si=(+qis_Vge_si_Vge_si-qid_Vge_si_Vge_si);
  dqi_Vge_si_Tempt_GND=(+qis_Vge_si_Tempt_GND-qid_Vge_si_Tempt_GND);
#endif
dqi_Tempt_GND=(qis_Tempt_GND-qid_Tempt_GND);
#if defined(_DERIVATE2)
  dqi_Tempt_GND_Vdi_si=(+qis_Tempt_GND_Vdi_si-qid_Tempt_GND_Vdi_si);
  dqi_Tempt_GND_Ve_si=(+qis_Tempt_GND_Ve_si-qid_Tempt_GND_Ve_si);
  dqi_Tempt_GND_Ve_di=(+qis_Tempt_GND_Ve_di-qid_Tempt_GND_Ve_di);
  dqi_Tempt_GND_Vge_si=(+qis_Tempt_GND_Vge_si-qid_Tempt_GND_Vge_si);
  dqi_Tempt_GND_Tempt_GND=(+qis_Tempt_GND_Tempt_GND-qid_Tempt_GND_Tempt_GND);
#endif
#endif
dqi=(qis-qid);
EXIT_IF_ISNAN((qis-qid))
{
double m00_pow(d00_pow0,Vdseff,2.0)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,Vdseff,2.0)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=((d10_pow0*Vdseff_Ve_si)/6.25e-4);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Vge_e=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Ve_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+(d10_pow0*Vdseff_Ve_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Ve_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+(d10_pow0*Vdseff_Ve_di)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Vge_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+(d10_pow0*Vdseff_Vge_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Vdi_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+(d10_pow0*Vdseff_Vdi_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_si_Tempt_GND=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_si)*0.0+(d10_pow0*Vdseff_Tempt_GND)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
#endif
T0_Ve_di=((d10_pow0*Vdseff_Ve_di)/6.25e-4);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Vge_e=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Ve_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+(d10_pow0*Vdseff_Ve_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Ve_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+(d10_pow0*Vdseff_Ve_di)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Vge_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+(d10_pow0*Vdseff_Vge_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Vdi_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+(d10_pow0*Vdseff_Vdi_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Ve_di_Tempt_GND=(fixme/6.25e-4-((d10_pow0*Vdseff_Ve_di)*0.0+(d10_pow0*Vdseff_Tempt_GND)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
#endif
T0_Vge_si=((d10_pow0*Vdseff_Vge_si)/6.25e-4);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Vge_e=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Ve_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+(d10_pow0*Vdseff_Ve_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Ve_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+(d10_pow0*Vdseff_Ve_di)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Vge_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+(d10_pow0*Vdseff_Vge_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Vdi_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+(d10_pow0*Vdseff_Vdi_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vge_si_Tempt_GND=(fixme/6.25e-4-((d10_pow0*Vdseff_Vge_si)*0.0+(d10_pow0*Vdseff_Tempt_GND)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
#endif
T0_Vdi_si=((d10_pow0*Vdseff_Vdi_si)/6.25e-4);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Vge_e=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Ve_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+(d10_pow0*Vdseff_Ve_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Ve_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+(d10_pow0*Vdseff_Ve_di)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Vge_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+(d10_pow0*Vdseff_Vge_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Vdi_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+(d10_pow0*Vdseff_Vdi_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Vdi_si_Tempt_GND=(fixme/6.25e-4-((d10_pow0*Vdseff_Vdi_si)*0.0+(d10_pow0*Vdseff_Tempt_GND)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
#endif
T0_Tempt_GND=((d10_pow0*Vdseff_Tempt_GND)/6.25e-4);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Vge_e=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+0.0*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Ve_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+(d10_pow0*Vdseff_Ve_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Ve_di=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+(d10_pow0*Vdseff_Ve_di)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Vge_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+(d10_pow0*Vdseff_Vge_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Vdi_si=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+(d10_pow0*Vdseff_Vdi_si)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
  T0_Tempt_GND_Tempt_GND=(fixme/6.25e-4-((d10_pow0*Vdseff_Tempt_GND)*0.0+(d10_pow0*Vdseff_Tempt_GND)*0.0+d00_pow0*0.0)/6.25e-4/6.25e-4+2*d00_pow0*0.0*0.0/6.25e-4/6.25e-4/6.25e-4);
#endif
#endif
T0=(d00_pow0/6.25e-4);
EXIT_IF_ISNAN((d00_pow0/6.25e-4))
}
if
((pModel->CHARGEWF!=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qia2_Vdi_si=((0.5*(qis_Vdi_si+qid_Vdi_si))+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi)+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si)));
#if defined(_DERIVATE2)
  qia2_Vdi_si_Vdi_si=(+(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vdi_si+qid_Vdi_si_Vdi_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi_Vdi_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.5)*dqi_Vdi_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si_Vdi_si));
  qia2_Vdi_si_Ve_si=(+(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_si+qid_Vdi_si_Ve_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi_Ve_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.5)*dqi_Vdi_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si_Ve_si));
  qia2_Vdi_si_Ve_di=(+(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_di+qid_Vdi_si_Ve_di))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi_Ve_di+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.5)*dqi_Vdi_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si_Ve_di));
  qia2_Vdi_si_Vge_si=(+(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vge_si+qid_Vdi_si_Vge_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi_Vge_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.5)*dqi_Vdi_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si_Vge_si));
  qia2_Vdi_si_Tempt_GND=(+(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Tempt_GND+qid_Vdi_si_Tempt_GND))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si))))*0.5*dqi_Tempt_GND+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vdi_si)))))*0.5)*dqi_Vdi_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vdi_si_Tempt_GND));
#endif
qia2_Ve_si=((0.5*(qis_Ve_si+qid_Ve_si))+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi)+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si)));
#if defined(_DERIVATE2)
  qia2_Ve_si_Vdi_si=(+(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vdi_si+qid_Ve_si_Vdi_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi_Vdi_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.5)*dqi_Ve_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si_Vdi_si));
  qia2_Ve_si_Ve_si=(+(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_si+qid_Ve_si_Ve_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi_Ve_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.5)*dqi_Ve_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si_Ve_si));
  qia2_Ve_si_Ve_di=(+(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_di+qid_Ve_si_Ve_di))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi_Ve_di+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.5)*dqi_Ve_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si_Ve_di));
  qia2_Ve_si_Vge_si=(+(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vge_si+qid_Ve_si_Vge_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi_Vge_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.5)*dqi_Ve_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si_Vge_si));
  qia2_Ve_si_Tempt_GND=(+(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Tempt_GND+qid_Ve_si_Tempt_GND))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si))))*0.5*dqi_Tempt_GND+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_si)))))*0.5)*dqi_Ve_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_si_Tempt_GND));
#endif
qia2_Ve_di=((0.5*(qis_Ve_di+qid_Ve_di))+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi)+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di)));
#if defined(_DERIVATE2)
  qia2_Ve_di_Vdi_si=(+(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vdi_si+qid_Ve_di_Vdi_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi_Vdi_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.5)*dqi_Ve_di+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di_Vdi_si));
  qia2_Ve_di_Ve_si=(+(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_si+qid_Ve_di_Ve_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi_Ve_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.5)*dqi_Ve_di+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di_Ve_si));
  qia2_Ve_di_Ve_di=(+(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_di+qid_Ve_di_Ve_di))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi_Ve_di+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.5)*dqi_Ve_di+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di_Ve_di));
  qia2_Ve_di_Vge_si=(+(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vge_si+qid_Ve_di_Vge_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi_Vge_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.5)*dqi_Ve_di+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di_Vge_si));
  qia2_Ve_di_Tempt_GND=(+(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Tempt_GND+qid_Ve_di_Tempt_GND))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di))))*0.5*dqi_Tempt_GND+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Ve_di)))))*0.5)*dqi_Ve_di+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Ve_di_Tempt_GND));
#endif
qia2_Vge_si=((0.5*(qis_Vge_si+qid_Vge_si))+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi)+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si)));
#if defined(_DERIVATE2)
  qia2_Vge_si_Vdi_si=(+(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vdi_si+qid_Vge_si_Vdi_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi_Vdi_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.5)*dqi_Vge_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si_Vdi_si));
  qia2_Vge_si_Ve_si=(+(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_si+qid_Vge_si_Ve_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi_Ve_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.5)*dqi_Vge_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si_Ve_si));
  qia2_Vge_si_Ve_di=(+(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_di+qid_Vge_si_Ve_di))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi_Ve_di+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.5)*dqi_Vge_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si_Ve_di));
  qia2_Vge_si_Vge_si=(+(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vge_si+qid_Vge_si_Vge_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi_Vge_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.5)*dqi_Vge_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si_Vge_si));
  qia2_Vge_si_Tempt_GND=(+(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Tempt_GND+qid_Vge_si_Tempt_GND))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si))))*0.5*dqi_Tempt_GND+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Vge_si)))))*0.5)*dqi_Vge_si+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Vge_si_Tempt_GND));
#endif
qia2_Tempt_GND=((0.5*(qis_Tempt_GND+qid_Tempt_GND))+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi)+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND)));
#if defined(_DERIVATE2)
  qia2_Tempt_GND_Vdi_si=(+(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vdi_si+qid_Tempt_GND_Vdi_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi_Vdi_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.5)*dqi_Tempt_GND+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND_Vdi_si));
  qia2_Tempt_GND_Ve_si=(+(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_si+qid_Tempt_GND_Ve_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi_Ve_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.5)*dqi_Tempt_GND+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND_Ve_si));
  qia2_Tempt_GND_Ve_di=(+(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_di+qid_Tempt_GND_Ve_di))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi_Ve_di+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.5)*dqi_Tempt_GND+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND_Ve_di));
  qia2_Tempt_GND_Vge_si=(+(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vge_si+qid_Tempt_GND_Vge_si))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi_Vge_si+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.5)*dqi_Tempt_GND+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND_Vge_si));
  qia2_Tempt_GND_Tempt_GND=(+(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Tempt_GND+qid_Tempt_GND_Tempt_GND))+(+(+(+0.0*(1.0-bsimcmg_lexp((-T0)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+0.0*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))+pModel->CHARGEWF*(+0.0-0.0))*0.5+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.0+((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.0+(pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.0)*dqi+(pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND))))*0.5*dqi_Tempt_GND+(((pModel->CHARGEWF*(-bsimcmg_d_lexp((-T0),(-T0_Tempt_GND)))))*0.5)*dqi_Tempt_GND+((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi_Tempt_GND_Tempt_GND));
#endif
#endif
qia2=((0.5*(qis+qid))+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi));
EXIT_IF_ISNAN(((0.5*(qis+qid))+(((pModel->CHARGEWF*(1.0-bsimcmg_lexp((-T0))))*0.5)*dqi)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
qia2_Vdi_si=(0.5*(qis_Vdi_si+qid_Vdi_si));
#if defined(_DERIVATE2)
  qia2_Vdi_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vdi_si+qid_Vdi_si_Vdi_si));
  qia2_Vdi_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_si+qid_Vdi_si_Ve_si));
  qia2_Vdi_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Ve_di+qid_Vdi_si_Ve_di));
  qia2_Vdi_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Vge_si+qid_Vdi_si_Vge_si));
  qia2_Vdi_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.5*(+qis_Vdi_si_Tempt_GND+qid_Vdi_si_Tempt_GND));
#endif
qia2_Ve_si=(0.5*(qis_Ve_si+qid_Ve_si));
#if defined(_DERIVATE2)
  qia2_Ve_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vdi_si+qid_Ve_si_Vdi_si));
  qia2_Ve_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_si+qid_Ve_si_Ve_si));
  qia2_Ve_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Ve_di+qid_Ve_si_Ve_di));
  qia2_Ve_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Vge_si+qid_Ve_si_Vge_si));
  qia2_Ve_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_si+qid_Ve_si)+0.5*(+qis_Ve_si_Tempt_GND+qid_Ve_si_Tempt_GND));
#endif
qia2_Ve_di=(0.5*(qis_Ve_di+qid_Ve_di));
#if defined(_DERIVATE2)
  qia2_Ve_di_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vdi_si+qid_Ve_di_Vdi_si));
  qia2_Ve_di_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_si+qid_Ve_di_Ve_si));
  qia2_Ve_di_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Ve_di+qid_Ve_di_Ve_di));
  qia2_Ve_di_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Vge_si+qid_Ve_di_Vge_si));
  qia2_Ve_di_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Ve_di+qid_Ve_di)+0.5*(+qis_Ve_di_Tempt_GND+qid_Ve_di_Tempt_GND));
#endif
qia2_Vge_si=(0.5*(qis_Vge_si+qid_Vge_si));
#if defined(_DERIVATE2)
  qia2_Vge_si_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vdi_si+qid_Vge_si_Vdi_si));
  qia2_Vge_si_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_si+qid_Vge_si_Ve_si));
  qia2_Vge_si_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Ve_di+qid_Vge_si_Ve_di));
  qia2_Vge_si_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Vge_si+qid_Vge_si_Vge_si));
  qia2_Vge_si_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Vge_si+qid_Vge_si)+0.5*(+qis_Vge_si_Tempt_GND+qid_Vge_si_Tempt_GND));
#endif
qia2_Tempt_GND=(0.5*(qis_Tempt_GND+qid_Tempt_GND));
#if defined(_DERIVATE2)
  qia2_Tempt_GND_Vdi_si=(+0.0*(qis+qid)+0.0*(qis_Vdi_si+qid_Vdi_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vdi_si+qid_Tempt_GND_Vdi_si));
  qia2_Tempt_GND_Ve_si=(+0.0*(qis+qid)+0.0*(qis_Ve_si+qid_Ve_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_si+qid_Tempt_GND_Ve_si));
  qia2_Tempt_GND_Ve_di=(+0.0*(qis+qid)+0.0*(qis_Ve_di+qid_Ve_di)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Ve_di+qid_Tempt_GND_Ve_di));
  qia2_Tempt_GND_Vge_si=(+0.0*(qis+qid)+0.0*(qis_Vge_si+qid_Vge_si)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Vge_si+qid_Tempt_GND_Vge_si));
  qia2_Tempt_GND_Tempt_GND=(+0.0*(qis+qid)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.0*(qis_Tempt_GND+qid_Tempt_GND)+0.5*(+qis_Tempt_GND_Tempt_GND+qid_Tempt_GND_Tempt_GND));
#endif
#endif
qia2=(0.5*(qis+qid));
EXIT_IF_ISNAN((0.5*(qis+qid)))
}
if
((qis<0.0))
{
printf("Warning: negative source-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qis=%e",(NP(g)-NP(s)),(NP(d)-NP(s)),(NP(e)-NP(s)),qis);
printf("\n");
}
if
((qid<0.0))
{
printf("Warning: negative drain-side inversion carrier density.  Vgs=%f  Vds=%f  Vbs=%f qid=%e",(NP(g)-NP(s)),(NP(d)-NP(s)),(NP(e)-NP(s)),qid);
printf("\n");
}
if
((QMTCENCV_i>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=(qia_Vdi_si/pModel->QM0);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(0.0/pModel->QM0-(qia_Vdi_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Vge_e=(0.0/pModel->QM0-(qia_Vdi_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Vdi_si=(qia_Vdi_si_Vdi_si/pModel->QM0-(qia_Vdi_si*0.0+qia_Vdi_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Ve_si=(qia_Vdi_si_Ve_si/pModel->QM0-(qia_Vdi_si*0.0+qia_Ve_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Ve_di=(qia_Vdi_si_Ve_di/pModel->QM0-(qia_Vdi_si*0.0+qia_Ve_di*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Vge_si=(qia_Vdi_si_Vge_si/pModel->QM0-(qia_Vdi_si*0.0+qia_Vge_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vdi_si_Tempt_GND=(qia_Vdi_si_Tempt_GND/pModel->QM0-(qia_Vdi_si*0.0+qia_Tempt_GND*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T4_Ve_si=(qia_Ve_si/pModel->QM0);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(0.0/pModel->QM0-(qia_Ve_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Vge_e=(0.0/pModel->QM0-(qia_Ve_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Vdi_si=(qia_Ve_si_Vdi_si/pModel->QM0-(qia_Ve_si*0.0+qia_Vdi_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Ve_si=(qia_Ve_si_Ve_si/pModel->QM0-(qia_Ve_si*0.0+qia_Ve_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Ve_di=(qia_Ve_si_Ve_di/pModel->QM0-(qia_Ve_si*0.0+qia_Ve_di*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Vge_si=(qia_Ve_si_Vge_si/pModel->QM0-(qia_Ve_si*0.0+qia_Vge_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_si_Tempt_GND=(qia_Ve_si_Tempt_GND/pModel->QM0-(qia_Ve_si*0.0+qia_Tempt_GND*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T4_Ve_di=(qia_Ve_di/pModel->QM0);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(0.0/pModel->QM0-(qia_Ve_di*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Vge_e=(0.0/pModel->QM0-(qia_Ve_di*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Vdi_si=(qia_Ve_di_Vdi_si/pModel->QM0-(qia_Ve_di*0.0+qia_Vdi_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Ve_si=(qia_Ve_di_Ve_si/pModel->QM0-(qia_Ve_di*0.0+qia_Ve_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Ve_di=(qia_Ve_di_Ve_di/pModel->QM0-(qia_Ve_di*0.0+qia_Ve_di*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Vge_si=(qia_Ve_di_Vge_si/pModel->QM0-(qia_Ve_di*0.0+qia_Vge_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Ve_di_Tempt_GND=(qia_Ve_di_Tempt_GND/pModel->QM0-(qia_Ve_di*0.0+qia_Tempt_GND*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T4_Vge_si=(qia_Vge_si/pModel->QM0);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(0.0/pModel->QM0-(qia_Vge_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Vge_e=(0.0/pModel->QM0-(qia_Vge_si*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Vdi_si=(qia_Vge_si_Vdi_si/pModel->QM0-(qia_Vge_si*0.0+qia_Vdi_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Ve_si=(qia_Vge_si_Ve_si/pModel->QM0-(qia_Vge_si*0.0+qia_Ve_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Ve_di=(qia_Vge_si_Ve_di/pModel->QM0-(qia_Vge_si*0.0+qia_Ve_di*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Vge_si=(qia_Vge_si_Vge_si/pModel->QM0-(qia_Vge_si*0.0+qia_Vge_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Vge_si_Tempt_GND=(qia_Vge_si_Tempt_GND/pModel->QM0-(qia_Vge_si*0.0+qia_Tempt_GND*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
T4_Tempt_GND=(qia_Tempt_GND/pModel->QM0);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(0.0/pModel->QM0-(qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Vge_e=(0.0/pModel->QM0-(qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Vdi_si=(qia_Tempt_GND_Vdi_si/pModel->QM0-(qia_Tempt_GND*0.0+qia_Vdi_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Ve_si=(qia_Tempt_GND_Ve_si/pModel->QM0-(qia_Tempt_GND*0.0+qia_Ve_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Ve_di=(qia_Tempt_GND_Ve_di/pModel->QM0-(qia_Tempt_GND*0.0+qia_Ve_di*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Vge_si=(qia_Tempt_GND_Vge_si/pModel->QM0-(qia_Tempt_GND*0.0+qia_Vge_si*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
  T4_Tempt_GND_Tempt_GND=(qia_Tempt_GND_Tempt_GND/pModel->QM0-(qia_Tempt_GND*0.0+qia_Tempt_GND*0.0+qia*0.0)/pModel->QM0/pModel->QM0+2*qia*0.0*0.0/pModel->QM0/pModel->QM0/pModel->QM0);
#endif
#endif
T4=(qia/pModel->QM0);
EXIT_IF_ISNAN((qia/pModel->QM0))
{
double m00_pow(d00_pow0,T4,pModel->PQM)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,T4,pModel->PQM)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=(d10_pow0*T4_Vge_e);
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+0.0+fixme);
  T5_Vge_e_Vdi_d=(+0.0+fixme);
  T5_Vge_e_Vsi_s=(+0.0+fixme);
  T5_Vge_e_Vge_e=(+0.0+fixme);
  T5_Vge_e_Vdi_si=(+0.0+fixme);
  T5_Vge_e_Ve_si=(+0.0+fixme);
  T5_Vge_e_Ve_di=(+0.0+fixme);
  T5_Vge_e_Vge_si=(+0.0+fixme);
  T5_Vge_e_Tempt_GND=(+0.0+fixme);
#endif
T5_Vdi_si=(d10_pow0*T4_Vdi_si);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0+fixme);
  T5_Vdi_si_Vdi_d=(+0.0+fixme);
  T5_Vdi_si_Vsi_s=(+0.0+fixme);
  T5_Vdi_si_Vge_e=(+0.0+fixme);
  T5_Vdi_si_Vdi_si=(+0.0+fixme);
  T5_Vdi_si_Ve_si=(+0.0+fixme);
  T5_Vdi_si_Ve_di=(+0.0+fixme);
  T5_Vdi_si_Vge_si=(+0.0+fixme);
  T5_Vdi_si_Tempt_GND=(+0.0+fixme);
#endif
T5_Ve_si=(d10_pow0*T4_Ve_si);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0+fixme);
  T5_Ve_si_Vdi_d=(+0.0+fixme);
  T5_Ve_si_Vsi_s=(+0.0+fixme);
  T5_Ve_si_Vge_e=(+0.0+fixme);
  T5_Ve_si_Vdi_si=(+0.0+fixme);
  T5_Ve_si_Ve_si=(+0.0+fixme);
  T5_Ve_si_Ve_di=(+0.0+fixme);
  T5_Ve_si_Vge_si=(+0.0+fixme);
  T5_Ve_si_Tempt_GND=(+0.0+fixme);
#endif
T5_Ve_di=(d10_pow0*T4_Ve_di);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0+fixme);
  T5_Ve_di_Vdi_d=(+0.0+fixme);
  T5_Ve_di_Vsi_s=(+0.0+fixme);
  T5_Ve_di_Vge_e=(+0.0+fixme);
  T5_Ve_di_Vdi_si=(+0.0+fixme);
  T5_Ve_di_Ve_si=(+0.0+fixme);
  T5_Ve_di_Ve_di=(+0.0+fixme);
  T5_Ve_di_Vge_si=(+0.0+fixme);
  T5_Ve_di_Tempt_GND=(+0.0+fixme);
#endif
T5_Vge_si=(d10_pow0*T4_Vge_si);
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0+fixme);
  T5_Vge_si_Vdi_d=(+0.0+fixme);
  T5_Vge_si_Vsi_s=(+0.0+fixme);
  T5_Vge_si_Vge_e=(+0.0+fixme);
  T5_Vge_si_Vdi_si=(+0.0+fixme);
  T5_Vge_si_Ve_si=(+0.0+fixme);
  T5_Vge_si_Ve_di=(+0.0+fixme);
  T5_Vge_si_Vge_si=(+0.0+fixme);
  T5_Vge_si_Tempt_GND=(+0.0+fixme);
#endif
T5_Tempt_GND=(d10_pow0*T4_Tempt_GND);
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0+fixme);
  T5_Tempt_GND_Vdi_d=(+0.0+fixme);
  T5_Tempt_GND_Vsi_s=(+0.0+fixme);
  T5_Tempt_GND_Vge_e=(+0.0+fixme);
  T5_Tempt_GND_Vdi_si=(+0.0+fixme);
  T5_Tempt_GND_Ve_si=(+0.0+fixme);
  T5_Tempt_GND_Ve_di=(+0.0+fixme);
  T5_Tempt_GND_Vge_si=(+0.0+fixme);
  T5_Tempt_GND_Tempt_GND=(+0.0+fixme);
#endif
#endif
T5=(1.0+d00_pow0);
EXIT_IF_ISNAN((1.0+d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Tcen_Vge_e=(-Tcen0*T5_Vge_e/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Vge_e_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Vge_e)/T5/T5+2*Tcen0*T5_Vge_e*T5_Vge_e/T5/T5/T5);
  Tcen_Vge_e_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Vdi_si)/T5/T5+2*Tcen0*T5_Vge_e*T5_Vdi_si/T5/T5/T5);
  Tcen_Vge_e_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Ve_si)/T5/T5+2*Tcen0*T5_Vge_e*T5_Ve_si/T5/T5/T5);
  Tcen_Vge_e_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Ve_di)/T5/T5+2*Tcen0*T5_Vge_e*T5_Ve_di/T5/T5/T5);
  Tcen_Vge_e_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Vge_si)/T5/T5+2*Tcen0*T5_Vge_e*T5_Vge_si/T5/T5/T5);
  Tcen_Vge_e_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vge_e+Tcen0*T5_Vge_e_Tempt_GND)/T5/T5+2*Tcen0*T5_Vge_e*T5_Tempt_GND/T5/T5/T5);
#endif
Tcen_Vdi_si=(-Tcen0*T5_Vdi_si/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Vdi_si_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Vge_e)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Vge_e/T5/T5/T5);
  Tcen_Vdi_si_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Vdi_si)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Vdi_si/T5/T5/T5);
  Tcen_Vdi_si_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Ve_si)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Ve_si/T5/T5/T5);
  Tcen_Vdi_si_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Ve_di)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Ve_di/T5/T5/T5);
  Tcen_Vdi_si_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Vge_si)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Vge_si/T5/T5/T5);
  Tcen_Vdi_si_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vdi_si+Tcen0*T5_Vdi_si_Tempt_GND)/T5/T5+2*Tcen0*T5_Vdi_si*T5_Tempt_GND/T5/T5/T5);
#endif
Tcen_Ve_si=(-Tcen0*T5_Ve_si/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Ve_si_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Vge_e)/T5/T5+2*Tcen0*T5_Ve_si*T5_Vge_e/T5/T5/T5);
  Tcen_Ve_si_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Vdi_si)/T5/T5+2*Tcen0*T5_Ve_si*T5_Vdi_si/T5/T5/T5);
  Tcen_Ve_si_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Ve_si)/T5/T5+2*Tcen0*T5_Ve_si*T5_Ve_si/T5/T5/T5);
  Tcen_Ve_si_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Ve_di)/T5/T5+2*Tcen0*T5_Ve_si*T5_Ve_di/T5/T5/T5);
  Tcen_Ve_si_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Vge_si)/T5/T5+2*Tcen0*T5_Ve_si*T5_Vge_si/T5/T5/T5);
  Tcen_Ve_si_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Ve_si+Tcen0*T5_Ve_si_Tempt_GND)/T5/T5+2*Tcen0*T5_Ve_si*T5_Tempt_GND/T5/T5/T5);
#endif
Tcen_Ve_di=(-Tcen0*T5_Ve_di/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Ve_di_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Vge_e)/T5/T5+2*Tcen0*T5_Ve_di*T5_Vge_e/T5/T5/T5);
  Tcen_Ve_di_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Vdi_si)/T5/T5+2*Tcen0*T5_Ve_di*T5_Vdi_si/T5/T5/T5);
  Tcen_Ve_di_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Ve_si)/T5/T5+2*Tcen0*T5_Ve_di*T5_Ve_si/T5/T5/T5);
  Tcen_Ve_di_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Ve_di)/T5/T5+2*Tcen0*T5_Ve_di*T5_Ve_di/T5/T5/T5);
  Tcen_Ve_di_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Vge_si)/T5/T5+2*Tcen0*T5_Ve_di*T5_Vge_si/T5/T5/T5);
  Tcen_Ve_di_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Ve_di+Tcen0*T5_Ve_di_Tempt_GND)/T5/T5+2*Tcen0*T5_Ve_di*T5_Tempt_GND/T5/T5/T5);
#endif
Tcen_Vge_si=(-Tcen0*T5_Vge_si/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Vge_si_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Vge_e)/T5/T5+2*Tcen0*T5_Vge_si*T5_Vge_e/T5/T5/T5);
  Tcen_Vge_si_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Vdi_si)/T5/T5+2*Tcen0*T5_Vge_si*T5_Vdi_si/T5/T5/T5);
  Tcen_Vge_si_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Ve_si)/T5/T5+2*Tcen0*T5_Vge_si*T5_Ve_si/T5/T5/T5);
  Tcen_Vge_si_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Ve_di)/T5/T5+2*Tcen0*T5_Vge_si*T5_Ve_di/T5/T5/T5);
  Tcen_Vge_si_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Vge_si)/T5/T5+2*Tcen0*T5_Vge_si*T5_Vge_si/T5/T5/T5);
  Tcen_Vge_si_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Vge_si+Tcen0*T5_Vge_si_Tempt_GND)/T5/T5+2*Tcen0*T5_Vge_si*T5_Tempt_GND/T5/T5/T5);
#endif
Tcen_Tempt_GND=(-Tcen0*T5_Tempt_GND/T5/T5);
#if defined(_DERIVATE2)
  Tcen_Tempt_GND_Vge_e=(0.0/T5-(0.0*T5_Vge_e+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Vge_e)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Vge_e/T5/T5/T5);
  Tcen_Tempt_GND_Vdi_si=(0.0/T5-(0.0*T5_Vdi_si+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Vdi_si)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Vdi_si/T5/T5/T5);
  Tcen_Tempt_GND_Ve_si=(0.0/T5-(0.0*T5_Ve_si+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Ve_si)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Ve_si/T5/T5/T5);
  Tcen_Tempt_GND_Ve_di=(0.0/T5-(0.0*T5_Ve_di+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Ve_di)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Ve_di/T5/T5/T5);
  Tcen_Tempt_GND_Vge_si=(0.0/T5-(0.0*T5_Vge_si+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Vge_si)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Vge_si/T5/T5/T5);
  Tcen_Tempt_GND_Tempt_GND=(0.0/T5-(0.0*T5_Tempt_GND+0.0*T5_Tempt_GND+Tcen0*T5_Tempt_GND_Tempt_GND)/T5/T5+2*Tcen0*T5_Tempt_GND*T5_Tempt_GND/T5/T5/T5);
#endif
#endif
Tcen=(Tcen0/T5);
EXIT_IF_ISNAN((Tcen0/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND)V(e,GND) */
coxeff_Vge_e=(-(Tcen_Vge_e*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Vge_e_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Vge_e*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_e_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Vdi_si*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_e_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Ve_si*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_e_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Ve_di*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_e_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Vge_si*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_e_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_e*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_e_Tempt_GND*QMTCENCV_i+Tcen_Vge_e*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_e*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
coxeff_Vdi_si=(-(Tcen_Vdi_si*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Vdi_si_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Vge_e*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vdi_si_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Vdi_si*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vdi_si_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Ve_si*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vdi_si_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Ve_di*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vdi_si_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Vge_si*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vdi_si_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vdi_si_Tempt_GND*QMTCENCV_i+Tcen_Vdi_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vdi_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
coxeff_Ve_si=(-(Tcen_Ve_si*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Ve_si_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Vge_e*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_si_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Vdi_si*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_si_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Ve_si*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_si_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Ve_di*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_si_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Vge_si*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_si_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_si_Tempt_GND*QMTCENCV_i+Tcen_Ve_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
coxeff_Ve_di=(-(Tcen_Ve_di*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Ve_di_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Vge_e*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_di_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Vdi_si*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_di_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Ve_si*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_di_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Ve_di*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_di_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Vge_si*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Ve_di_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Ve_di*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Ve_di_Tempt_GND*QMTCENCV_i+Tcen_Ve_di*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Ve_di*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
coxeff_Vge_si=(-(Tcen_Vge_si*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Vge_si_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Vge_e*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_si_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Vdi_si*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_si_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Ve_si*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_si_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Ve_di*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_si_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Vge_si*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Vge_si_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Vge_si*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Vge_si_Tempt_GND*QMTCENCV_i+Tcen_Vge_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Vge_si*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
coxeff_Tempt_GND=(-(Tcen_Tempt_GND*QMTCENCV_i/epssub)/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#if defined(_DERIVATE2)
  coxeff_Tempt_GND_Vge_e=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Vge_e*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Vge_e*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_e*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Tempt_GND_Vdi_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Vdi_si*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Vdi_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vdi_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Tempt_GND_Ve_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Ve_si*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Ve_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Tempt_GND_Ve_di=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Ve_di*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Ve_di*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Ve_di*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Tempt_GND_Vge_si=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Vge_si*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Vge_si*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Vge_si*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
  coxeff_Tempt_GND_Tempt_GND=(0.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))-(0.0*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))+0.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)+1.0*(+(0.0/((cox*pModel->EOT)/pModel->TOXP)-(0.0*((0.0)/pModel->TOXP)+0.0*0.0+1.0*((+0.0*pModel->EOT+0.0*0.0+0.0*0.0+cox*0.0)/pModel->TOXP-(0.0*0.0+(0.0)*0.0+(cox*pModel->EOT)*0.0)/pModel->TOXP/pModel->TOXP+2*(cox*pModel->EOT)*0.0*0.0/pModel->TOXP/pModel->TOXP/pModel->TOXP))/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)+2*1.0*0.0*((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((+Tcen_Tempt_GND_Tempt_GND*QMTCENCV_i+Tcen_Tempt_GND*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCV_i*0.0+(Tcen_Tempt_GND*QMTCENCV_i)*0.0+(Tcen*QMTCENCV_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCV_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))+2*1.0*(Tcen_Tempt_GND*QMTCENCV_i/epssub)*((-((0.0)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP)/((cox*pModel->EOT)/pModel->TOXP))+((Tcen_Tempt_GND*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
#endif
#endif
coxeff=(1.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub)));
EXIT_IF_ISNAN((1.0/((1.0/((cox*pModel->EOT)/pModel->TOXP))+((Tcen*QMTCENCV_i)/epssub))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND)V(e,GND) */
coxeff_Vge_e=0.0;
#if defined(_DERIVATE2)
  coxeff_Vge_e_Vge_e=0.0;
  coxeff_Vge_e_Vdi_si=0.0;
  coxeff_Vge_e_Ve_si=0.0;
  coxeff_Vge_e_Ve_di=0.0;
  coxeff_Vge_e_Vge_si=0.0;
  coxeff_Vge_e_Tempt_GND=0.0;
#endif
coxeff_Vdi_si=0.0;
#if defined(_DERIVATE2)
  coxeff_Vdi_si_Vge_e=0.0;
  coxeff_Vdi_si_Vdi_si=0.0;
  coxeff_Vdi_si_Ve_si=0.0;
  coxeff_Vdi_si_Ve_di=0.0;
  coxeff_Vdi_si_Vge_si=0.0;
  coxeff_Vdi_si_Tempt_GND=0.0;
#endif
coxeff_Ve_si=0.0;
#if defined(_DERIVATE2)
  coxeff_Ve_si_Vge_e=0.0;
  coxeff_Ve_si_Vdi_si=0.0;
  coxeff_Ve_si_Ve_si=0.0;
  coxeff_Ve_si_Ve_di=0.0;
  coxeff_Ve_si_Vge_si=0.0;
  coxeff_Ve_si_Tempt_GND=0.0;
#endif
coxeff_Ve_di=0.0;
#if defined(_DERIVATE2)
  coxeff_Ve_di_Vge_e=0.0;
  coxeff_Ve_di_Vdi_si=0.0;
  coxeff_Ve_di_Ve_si=0.0;
  coxeff_Ve_di_Ve_di=0.0;
  coxeff_Ve_di_Vge_si=0.0;
  coxeff_Ve_di_Tempt_GND=0.0;
#endif
coxeff_Vge_si=0.0;
#if defined(_DERIVATE2)
  coxeff_Vge_si_Vge_e=0.0;
  coxeff_Vge_si_Vdi_si=0.0;
  coxeff_Vge_si_Ve_si=0.0;
  coxeff_Vge_si_Ve_di=0.0;
  coxeff_Vge_si_Vge_si=0.0;
  coxeff_Vge_si_Tempt_GND=0.0;
#endif
coxeff_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  coxeff_Tempt_GND_Vge_e=0.0;
  coxeff_Tempt_GND_Vdi_si=0.0;
  coxeff_Tempt_GND_Ve_si=0.0;
  coxeff_Tempt_GND_Ve_di=0.0;
  coxeff_Tempt_GND_Vge_si=0.0;
  coxeff_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
coxeff=cox;
EXIT_IF_ISNAN(cox)
}
if
(((pModel->BULKMOD!=0)&&(QMTCENCVA_i!=0.0)))
{
{
double m00_pow(d00_pow0,(qi_acc_for_QM/pModel->QM0ACC),pModel->PQMACC)
#if defined(_DERIVATEFORDDX)
double m10_pow(d10_pow0,d00_pow0,(qi_acc_for_QM/pModel->QM0ACC),pModel->PQMACC)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=(d10_pow0*(qi_acc_for_QM_Vge_e/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+0.0+fixme);
  T6_Vge_e_Vdi_d=(+0.0+fixme);
  T6_Vge_e_Vsi_s=(+0.0+fixme);
  T6_Vge_e_Vge_e=(+0.0+fixme);
  T6_Vge_e_Vdi_si=(+0.0+fixme);
  T6_Vge_e_Tempt_GND=(+0.0+fixme);
  T6_Vge_e_Ve_si=(+0.0+fixme);
  T6_Vge_e_Ve_di=(+0.0+fixme);
  T6_Vge_e_Vge_si=(+0.0+fixme);
#endif
T6_Vdi_si=(d10_pow0*(qi_acc_for_QM_Vdi_si/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+0.0+fixme);
  T6_Vdi_si_Vdi_d=(+0.0+fixme);
  T6_Vdi_si_Vsi_s=(+0.0+fixme);
  T6_Vdi_si_Vge_e=(+0.0+fixme);
  T6_Vdi_si_Vdi_si=(+0.0+fixme);
  T6_Vdi_si_Tempt_GND=(+0.0+fixme);
  T6_Vdi_si_Ve_si=(+0.0+fixme);
  T6_Vdi_si_Ve_di=(+0.0+fixme);
  T6_Vdi_si_Vge_si=(+0.0+fixme);
#endif
T6_Tempt_GND=(d10_pow0*(qi_acc_for_QM_Tempt_GND/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+0.0+fixme);
  T6_Tempt_GND_Vdi_d=(+0.0+fixme);
  T6_Tempt_GND_Vsi_s=(+0.0+fixme);
  T6_Tempt_GND_Vge_e=(+0.0+fixme);
  T6_Tempt_GND_Vdi_si=(+0.0+fixme);
  T6_Tempt_GND_Tempt_GND=(+0.0+fixme);
  T6_Tempt_GND_Ve_si=(+0.0+fixme);
  T6_Tempt_GND_Ve_di=(+0.0+fixme);
  T6_Tempt_GND_Vge_si=(+0.0+fixme);
#endif
T6_Ve_si=(d10_pow0*(qi_acc_for_QM_Ve_si/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+0.0+fixme);
  T6_Ve_si_Vdi_d=(+0.0+fixme);
  T6_Ve_si_Vsi_s=(+0.0+fixme);
  T6_Ve_si_Vge_e=(+0.0+fixme);
  T6_Ve_si_Vdi_si=(+0.0+fixme);
  T6_Ve_si_Tempt_GND=(+0.0+fixme);
  T6_Ve_si_Ve_si=(+0.0+fixme);
  T6_Ve_si_Ve_di=(+0.0+fixme);
  T6_Ve_si_Vge_si=(+0.0+fixme);
#endif
T6_Ve_di=(d10_pow0*(qi_acc_for_QM_Ve_di/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+0.0+fixme);
  T6_Ve_di_Vdi_d=(+0.0+fixme);
  T6_Ve_di_Vsi_s=(+0.0+fixme);
  T6_Ve_di_Vge_e=(+0.0+fixme);
  T6_Ve_di_Vdi_si=(+0.0+fixme);
  T6_Ve_di_Tempt_GND=(+0.0+fixme);
  T6_Ve_di_Ve_si=(+0.0+fixme);
  T6_Ve_di_Ve_di=(+0.0+fixme);
  T6_Ve_di_Vge_si=(+0.0+fixme);
#endif
T6_Vge_si=(d10_pow0*(qi_acc_for_QM_Vge_si/pModel->QM0ACC));
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+0.0+fixme);
  T6_Vge_si_Vdi_d=(+0.0+fixme);
  T6_Vge_si_Vsi_s=(+0.0+fixme);
  T6_Vge_si_Vge_e=(+0.0+fixme);
  T6_Vge_si_Vdi_si=(+0.0+fixme);
  T6_Vge_si_Tempt_GND=(+0.0+fixme);
  T6_Vge_si_Ve_si=(+0.0+fixme);
  T6_Vge_si_Ve_di=(+0.0+fixme);
  T6_Vge_si_Vge_si=(+0.0+fixme);
#endif
#endif
T6=(1.0+d00_pow0);
EXIT_IF_ISNAN((1.0+d00_pow0))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Tcen_Vge_e=(-Tcen0*T6_Vge_e/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Vge_e_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Vge_e)/T6/T6+2*Tcen0*T6_Vge_e*T6_Vge_e/T6/T6/T6);
  Tcen_Vge_e_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Vdi_si)/T6/T6+2*Tcen0*T6_Vge_e*T6_Vdi_si/T6/T6/T6);
  Tcen_Vge_e_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Ve_si)/T6/T6+2*Tcen0*T6_Vge_e*T6_Ve_si/T6/T6/T6);
  Tcen_Vge_e_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Ve_di)/T6/T6+2*Tcen0*T6_Vge_e*T6_Ve_di/T6/T6/T6);
  Tcen_Vge_e_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Vge_si)/T6/T6+2*Tcen0*T6_Vge_e*T6_Vge_si/T6/T6/T6);
  Tcen_Vge_e_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Vge_e+Tcen0*T6_Vge_e_Tempt_GND)/T6/T6+2*Tcen0*T6_Vge_e*T6_Tempt_GND/T6/T6/T6);
#endif
Tcen_Vdi_si=(-Tcen0*T6_Vdi_si/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Vdi_si_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Vge_e)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Vge_e/T6/T6/T6);
  Tcen_Vdi_si_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Vdi_si)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Vdi_si/T6/T6/T6);
  Tcen_Vdi_si_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Ve_si)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Ve_si/T6/T6/T6);
  Tcen_Vdi_si_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Ve_di)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Ve_di/T6/T6/T6);
  Tcen_Vdi_si_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Vge_si)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Vge_si/T6/T6/T6);
  Tcen_Vdi_si_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Vdi_si+Tcen0*T6_Vdi_si_Tempt_GND)/T6/T6+2*Tcen0*T6_Vdi_si*T6_Tempt_GND/T6/T6/T6);
#endif
Tcen_Ve_si=(-Tcen0*T6_Ve_si/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Ve_si_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Vge_e)/T6/T6+2*Tcen0*T6_Ve_si*T6_Vge_e/T6/T6/T6);
  Tcen_Ve_si_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Vdi_si)/T6/T6+2*Tcen0*T6_Ve_si*T6_Vdi_si/T6/T6/T6);
  Tcen_Ve_si_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Ve_si)/T6/T6+2*Tcen0*T6_Ve_si*T6_Ve_si/T6/T6/T6);
  Tcen_Ve_si_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Ve_di)/T6/T6+2*Tcen0*T6_Ve_si*T6_Ve_di/T6/T6/T6);
  Tcen_Ve_si_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Vge_si)/T6/T6+2*Tcen0*T6_Ve_si*T6_Vge_si/T6/T6/T6);
  Tcen_Ve_si_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Ve_si+Tcen0*T6_Ve_si_Tempt_GND)/T6/T6+2*Tcen0*T6_Ve_si*T6_Tempt_GND/T6/T6/T6);
#endif
Tcen_Ve_di=(-Tcen0*T6_Ve_di/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Ve_di_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Vge_e)/T6/T6+2*Tcen0*T6_Ve_di*T6_Vge_e/T6/T6/T6);
  Tcen_Ve_di_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Vdi_si)/T6/T6+2*Tcen0*T6_Ve_di*T6_Vdi_si/T6/T6/T6);
  Tcen_Ve_di_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Ve_si)/T6/T6+2*Tcen0*T6_Ve_di*T6_Ve_si/T6/T6/T6);
  Tcen_Ve_di_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Ve_di)/T6/T6+2*Tcen0*T6_Ve_di*T6_Ve_di/T6/T6/T6);
  Tcen_Ve_di_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Vge_si)/T6/T6+2*Tcen0*T6_Ve_di*T6_Vge_si/T6/T6/T6);
  Tcen_Ve_di_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Ve_di+Tcen0*T6_Ve_di_Tempt_GND)/T6/T6+2*Tcen0*T6_Ve_di*T6_Tempt_GND/T6/T6/T6);
#endif
Tcen_Vge_si=(-Tcen0*T6_Vge_si/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Vge_si_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Vge_e)/T6/T6+2*Tcen0*T6_Vge_si*T6_Vge_e/T6/T6/T6);
  Tcen_Vge_si_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Vdi_si)/T6/T6+2*Tcen0*T6_Vge_si*T6_Vdi_si/T6/T6/T6);
  Tcen_Vge_si_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Ve_si)/T6/T6+2*Tcen0*T6_Vge_si*T6_Ve_si/T6/T6/T6);
  Tcen_Vge_si_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Ve_di)/T6/T6+2*Tcen0*T6_Vge_si*T6_Ve_di/T6/T6/T6);
  Tcen_Vge_si_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Vge_si)/T6/T6+2*Tcen0*T6_Vge_si*T6_Vge_si/T6/T6/T6);
  Tcen_Vge_si_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Vge_si+Tcen0*T6_Vge_si_Tempt_GND)/T6/T6+2*Tcen0*T6_Vge_si*T6_Tempt_GND/T6/T6/T6);
#endif
Tcen_Tempt_GND=(-Tcen0*T6_Tempt_GND/T6/T6);
#if defined(_DERIVATE2)
  Tcen_Tempt_GND_Vge_e=(0.0/T6-(0.0*T6_Vge_e+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Vge_e)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Vge_e/T6/T6/T6);
  Tcen_Tempt_GND_Vdi_si=(0.0/T6-(0.0*T6_Vdi_si+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Vdi_si)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Vdi_si/T6/T6/T6);
  Tcen_Tempt_GND_Ve_si=(0.0/T6-(0.0*T6_Ve_si+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Ve_si)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Ve_si/T6/T6/T6);
  Tcen_Tempt_GND_Ve_di=(0.0/T6-(0.0*T6_Ve_di+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Ve_di)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Ve_di/T6/T6/T6);
  Tcen_Tempt_GND_Vge_si=(0.0/T6-(0.0*T6_Vge_si+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Vge_si)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Vge_si/T6/T6/T6);
  Tcen_Tempt_GND_Tempt_GND=(0.0/T6-(0.0*T6_Tempt_GND+0.0*T6_Tempt_GND+Tcen0*T6_Tempt_GND_Tempt_GND)/T6/T6+2*Tcen0*T6_Tempt_GND*T6_Tempt_GND/T6/T6/T6);
#endif
#endif
Tcen=(Tcen0/T6);
EXIT_IF_ISNAN((Tcen0/T6))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
cox_acc_Vge_e=(-((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Vge_e_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Vge_e*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_e_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Vdi_si*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_e_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Ve_si*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_e_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Ve_di*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_e_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Vge_si*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_e_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Vge_e+1.0*cox_acc_Vge_e_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_e*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_e_Tempt_GND*QMTCENCVA_i+Tcen_Vge_e*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vge_e*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+(Tcen_Vge_e*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
cox_acc_Vdi_si=(-((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Vdi_si_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Vge_e*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vdi_si_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Vdi_si*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vdi_si_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Ve_si*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vdi_si_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Ve_di*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vdi_si_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Vge_si*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vdi_si_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Vdi_si+1.0*cox_acc_Vdi_si_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Vdi_si*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Vdi_si_Tempt_GND*QMTCENCVA_i+Tcen_Vdi_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vdi_si*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+(Tcen_Vdi_si*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
cox_acc_Ve_si=(-((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Ve_si_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Vge_e*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_si_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Vdi_si*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_si_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Ve_si*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_si_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Ve_di*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_si_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Vge_si*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_si_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Ve_si+1.0*cox_acc_Ve_si_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_si*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_si_Tempt_GND*QMTCENCVA_i+Tcen_Ve_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Ve_si*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+(Tcen_Ve_si*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
cox_acc_Ve_di=(-((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Ve_di_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Vge_e*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_di_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Vdi_si*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_di_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Ve_si*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_di_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Ve_di*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_di_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Vge_si*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Ve_di_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Ve_di+1.0*cox_acc_Ve_di_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Ve_di*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Ve_di_Tempt_GND*QMTCENCVA_i+Tcen_Ve_di*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Ve_di*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+(Tcen_Ve_di*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
cox_acc_Vge_si=(-((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Vge_si_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Vge_e*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_si_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Vdi_si*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_si_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Ve_si*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_si_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Ve_di*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_si_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Vge_si*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Vge_si_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Vge_si+1.0*cox_acc_Vge_si_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Vge_si*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Vge_si_Tempt_GND*QMTCENCVA_i+Tcen_Vge_si*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Vge_si*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+(Tcen_Vge_si*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
cox_acc_Tempt_GND=(-((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#if defined(_DERIVATE2)
  cox_acc_Tempt_GND_Vge_e=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_e+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Vge_e)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Vge_e/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Vge_e*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Vge_e*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Vge_e*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Vge_e/cox_acc/cox_acc)+((Tcen_Vge_e*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Tempt_GND_Vdi_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vdi_si+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Vdi_si)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Vdi_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Vdi_si*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Vdi_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Vdi_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Vdi_si/cox_acc/cox_acc)+((Tcen_Vdi_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Tempt_GND_Ve_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_si+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Ve_si)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Ve_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Ve_si*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Ve_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Ve_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Ve_si/cox_acc/cox_acc)+((Tcen_Ve_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Tempt_GND_Ve_di=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Ve_di+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Ve_di)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Ve_di/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Ve_di*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Ve_di*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Ve_di*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Ve_di/cox_acc/cox_acc)+((Tcen_Ve_di*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Tempt_GND_Vge_si=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Vge_si+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Vge_si)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Vge_si/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Vge_si*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Vge_si*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Vge_si*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Vge_si/cox_acc/cox_acc)+((Tcen_Vge_si*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
  cox_acc_Tempt_GND_Tempt_GND=(0.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))-(0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))+0.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))+1.0*(+(0.0/cox_acc-(0.0*cox_acc_Tempt_GND+0.0*cox_acc_Tempt_GND+1.0*cox_acc_Tempt_GND_Tempt_GND)/cox_acc/cox_acc+2*1.0*cox_acc_Tempt_GND*cox_acc_Tempt_GND/cox_acc/cox_acc/cox_acc)+((+Tcen_Tempt_GND_Tempt_GND*QMTCENCVA_i+Tcen_Tempt_GND*0.0+Tcen_Tempt_GND*0.0+Tcen*0.0)/epssub-(Tcen_Tempt_GND*QMTCENCVA_i*0.0+(Tcen_Tempt_GND*QMTCENCVA_i)*0.0+(Tcen*QMTCENCVA_i)*0.0)/epssub/epssub+2*(Tcen*QMTCENCVA_i)*0.0*0.0/epssub/epssub/epssub)))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))+2*1.0*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+(Tcen_Tempt_GND*QMTCENCVA_i/epssub))*((-cox_acc_Tempt_GND/cox_acc/cox_acc)+((Tcen_Tempt_GND*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
#endif
#endif
cox_acc=(1.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub)));
EXIT_IF_ISNAN((1.0/((1.0/cox_acc)+((Tcen*QMTCENCVA_i)/epssub))))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
beta_Tempt_GND=(u0_a_Tempt_GND*cox*Weff0/Leff);
#if defined(_DERIVATE2)
  beta_Tempt_GND_Tempt_GND=((+(+u0_a_Tempt_GND_Tempt_GND*cox+u0_a_Tempt_GND*0.0+u0_a_Tempt_GND*0.0+u0_a*0.0)*Weff0+u0_a_Tempt_GND*cox*0.0+(u0_a_Tempt_GND*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Tempt_GND*cox*Weff0*0.0+((u0_a_Tempt_GND*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  beta_Tempt_GND_Vdi_si=((+(+u0_a_Tempt_GND_Vdi_si*cox+u0_a_Tempt_GND*0.0+u0_a_Vdi_si*0.0+u0_a*0.0)*Weff0+u0_a_Tempt_GND*cox*0.0+(u0_a_Vdi_si*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Tempt_GND*cox*Weff0*0.0+((u0_a_Vdi_si*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
beta_Vdi_si=(u0_a_Vdi_si*cox*Weff0/Leff);
#if defined(_DERIVATE2)
  beta_Vdi_si_Tempt_GND=((+(+u0_a_Vdi_si_Tempt_GND*cox+u0_a_Vdi_si*0.0+u0_a_Tempt_GND*0.0+u0_a*0.0)*Weff0+u0_a_Vdi_si*cox*0.0+(u0_a_Tempt_GND*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Vdi_si*cox*Weff0*0.0+((u0_a_Tempt_GND*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  beta_Vdi_si_Vdi_si=((+(+u0_a_Vdi_si_Vdi_si*cox+u0_a_Vdi_si*0.0+u0_a_Vdi_si*0.0+u0_a*0.0)*Weff0+u0_a_Vdi_si*cox*0.0+(u0_a_Vdi_si*cox)*0.0+(u0_a*cox)*0.0)/Leff-(u0_a_Vdi_si*cox*Weff0*0.0+((u0_a_Vdi_si*cox)*Weff0)*0.0+((u0_a*cox)*Weff0)*0.0)/Leff/Leff+2*((u0_a*cox)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
#endif
beta=(((u0_a*cox)*Weff0)/Leff);
EXIT_IF_ISNAN((((u0_a*cox)*Weff0)/Leff))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Eeffm_Tempt_GND=(EeffFactor*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))));
#if defined(_DERIVATE2)
  Eeffm_Tempt_GND_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Tempt_GND+(+eta_mu_Tempt_GND_Tempt_GND*qia2+eta_mu_Tempt_GND*qia2_Tempt_GND+eta_mu_Tempt_GND*qia2_Tempt_GND+eta_mu*qia2_Tempt_GND_Tempt_GND)));
  Eeffm_Tempt_GND_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Vdi_si+(+0.0*qia2+eta_mu_Tempt_GND*qia2_Vdi_si+0.0*qia2_Tempt_GND+eta_mu*qia2_Tempt_GND_Vdi_si)));
  Eeffm_Tempt_GND_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Vge_e+(+0.0*qia2+eta_mu_Tempt_GND*0.0+0.0*qia2_Tempt_GND+eta_mu*0.0)));
  Eeffm_Tempt_GND_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Ve_si+(+0.0*qia2+eta_mu_Tempt_GND*qia2_Ve_si+0.0*qia2_Tempt_GND+eta_mu*qia2_Tempt_GND_Ve_si)));
  Eeffm_Tempt_GND_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Ve_di+(+0.0*qia2+eta_mu_Tempt_GND*qia2_Ve_di+0.0*qia2_Tempt_GND+eta_mu*qia2_Tempt_GND_Ve_di)));
  Eeffm_Tempt_GND_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*(qba_Tempt_GND+((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND)))+EeffFactor*(+qba_Tempt_GND_Vge_si+(+0.0*qia2+eta_mu_Tempt_GND*qia2_Vge_si+0.0*qia2_Tempt_GND+eta_mu*qia2_Tempt_GND_Vge_si)));
#endif
Eeffm_Vdi_si=(EeffFactor*(qba_Vdi_si+(eta_mu*qia2_Vdi_si)));
#if defined(_DERIVATE2)
  Eeffm_Vdi_si_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+eta_mu_Tempt_GND*qia2_Vdi_si+eta_mu*qia2_Vdi_si_Tempt_GND)));
  Eeffm_Vdi_si_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Vdi_si+eta_mu*qia2_Vdi_si_Vdi_si)));
  Eeffm_Vdi_si_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Vdi_si+eta_mu*0.0)));
  Eeffm_Vdi_si_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Vdi_si+eta_mu*qia2_Vdi_si_Ve_si)));
  Eeffm_Vdi_si_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Vdi_si+eta_mu*qia2_Vdi_si_Ve_di)));
  Eeffm_Vdi_si_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*(qba_Vdi_si+(eta_mu*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Vdi_si+eta_mu*qia2_Vdi_si_Vge_si)));
#endif
Eeffm_Vge_e=(EeffFactor*qba_Vge_e);
#if defined(_DERIVATE2)
  Eeffm_Vge_e_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+eta_mu_Tempt_GND*0.0+eta_mu*0.0)));
  Eeffm_Vge_e_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*0.0+eta_mu*0.0)));
  Eeffm_Vge_e_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vge_e+(+0.0*qia2+0.0*0.0+0.0*0.0+eta_mu*0.0)));
  Eeffm_Vge_e_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*0.0+eta_mu*0.0)));
  Eeffm_Vge_e_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*0.0+eta_mu*0.0)));
  Eeffm_Vge_e_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*0.0+eta_mu*0.0)));
#endif
Eeffm_Ve_si=(EeffFactor*(qba_Ve_si+(eta_mu*qia2_Ve_si)));
#if defined(_DERIVATE2)
  Eeffm_Ve_si_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+eta_mu_Tempt_GND*qia2_Ve_si+eta_mu*qia2_Ve_si_Tempt_GND)));
  Eeffm_Ve_si_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Ve_si+eta_mu*qia2_Ve_si_Vdi_si)));
  Eeffm_Ve_si_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Ve_si+eta_mu*0.0)));
  Eeffm_Ve_si_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Ve_si+eta_mu*qia2_Ve_si_Ve_si)));
  Eeffm_Ve_si_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Ve_si+eta_mu*qia2_Ve_si_Ve_di)));
  Eeffm_Ve_si_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*(qba_Ve_si+(eta_mu*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Ve_si+eta_mu*qia2_Ve_si_Vge_si)));
#endif
Eeffm_Ve_di=(EeffFactor*(qba_Ve_di+(eta_mu*qia2_Ve_di)));
#if defined(_DERIVATE2)
  Eeffm_Ve_di_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+eta_mu_Tempt_GND*qia2_Ve_di+eta_mu*qia2_Ve_di_Tempt_GND)));
  Eeffm_Ve_di_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Ve_di+eta_mu*qia2_Ve_di_Vdi_si)));
  Eeffm_Ve_di_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Ve_di+eta_mu*0.0)));
  Eeffm_Ve_di_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Ve_di+eta_mu*qia2_Ve_di_Ve_si)));
  Eeffm_Ve_di_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Ve_di+eta_mu*qia2_Ve_di_Ve_di)));
  Eeffm_Ve_di_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*(qba_Ve_di+(eta_mu*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Ve_di+eta_mu*qia2_Ve_di_Vge_si)));
#endif
Eeffm_Vge_si=(EeffFactor*(qba_Vge_si+(eta_mu*qia2_Vge_si)));
#if defined(_DERIVATE2)
  Eeffm_Vge_si_Tempt_GND=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Tempt_GND+(((eta_mu_Tempt_GND*qia2)+(eta_mu*qia2_Tempt_GND))))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+eta_mu_Tempt_GND*qia2_Vge_si+eta_mu*qia2_Vge_si_Tempt_GND)));
  Eeffm_Vge_si_Vdi_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vdi_si+((eta_mu*qia2_Vdi_si)))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Vge_si+eta_mu*qia2_Vge_si_Vdi_si)));
  Eeffm_Vge_si_Vge_e=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Vge_si+eta_mu*0.0)));
  Eeffm_Vge_si_Ve_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_si+((eta_mu*qia2_Ve_si)))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Vge_si+eta_mu*qia2_Vge_si_Ve_si)));
  Eeffm_Vge_si_Ve_di=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Ve_di+((eta_mu*qia2_Ve_di)))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Vge_si+eta_mu*qia2_Vge_si_Ve_di)));
  Eeffm_Vge_si_Vge_si=(+0.0*(qba+(eta_mu*qia2))+0.0*(qba_Vge_si+((eta_mu*qia2_Vge_si)))+0.0*(qba_Vge_si+(eta_mu*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Vge_si+eta_mu*qia2_Vge_si_Vge_si)));
#endif
#endif
Eeffm=(EeffFactor*(qba+(eta_mu*qia2)));
EXIT_IF_ISNAN((EeffFactor*(qba+(eta_mu*qia2))))
{
double m00_fabs(d00_fabs0,(qia2/qb0))
double m00_pow(d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,(qia2/qb0))
double m10_pow(d10_pow1,d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
double m11_pow(d11_pow1,d00_pow1,(0.5*(1.0+d00_fabs0)),UCS_t)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(d10_pow1*(0.5*(qia2_Vge_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=fixme;
  T2_Vge_si_Vsi_s=fixme;
  T2_Vge_si_Vge_di=fixme;
  T2_Vge_si_Vge_e=fixme;
  T2_Vge_si_Vge_si=fixme;
  T2_Vge_si_Ve_si=fixme;
  T2_Vge_si_Ve_di=fixme;
  T2_Vge_si_Vdi_si=fixme;
  T2_Vge_si_Tempt_GND=fixme;
#endif
T2_Ve_si=(d10_pow1*(0.5*(qia2_Ve_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=fixme;
  T2_Ve_si_Vsi_s=fixme;
  T2_Ve_si_Vge_di=fixme;
  T2_Ve_si_Vge_e=fixme;
  T2_Ve_si_Vge_si=fixme;
  T2_Ve_si_Ve_si=fixme;
  T2_Ve_si_Ve_di=fixme;
  T2_Ve_si_Vdi_si=fixme;
  T2_Ve_si_Tempt_GND=fixme;
#endif
T2_Ve_di=(d10_pow1*(0.5*(qia2_Ve_di/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=fixme;
  T2_Ve_di_Vsi_s=fixme;
  T2_Ve_di_Vge_di=fixme;
  T2_Ve_di_Vge_e=fixme;
  T2_Ve_di_Vge_si=fixme;
  T2_Ve_di_Ve_si=fixme;
  T2_Ve_di_Ve_di=fixme;
  T2_Ve_di_Vdi_si=fixme;
  T2_Ve_di_Tempt_GND=fixme;
#endif
T2_Vdi_si=(d10_pow1*(0.5*(qia2_Vdi_si/qb0)*d10_fabs0));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=fixme;
  T2_Vdi_si_Vsi_s=fixme;
  T2_Vdi_si_Vge_di=fixme;
  T2_Vdi_si_Vge_e=fixme;
  T2_Vdi_si_Vge_si=fixme;
  T2_Vdi_si_Ve_si=fixme;
  T2_Vdi_si_Ve_di=fixme;
  T2_Vdi_si_Vdi_si=fixme;
  T2_Vdi_si_Tempt_GND=fixme;
#endif
T2_Tempt_GND=(d10_pow1*(0.5*(qia2_Tempt_GND/qb0)*d10_fabs0)+d11_pow1*UCS_t_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=fixme;
  T2_Tempt_GND_Vsi_s=fixme;
  T2_Tempt_GND_Vge_di=fixme;
  T2_Tempt_GND_Vge_e=fixme;
  T2_Tempt_GND_Vge_si=fixme;
  T2_Tempt_GND_Ve_si=fixme;
  T2_Tempt_GND_Ve_di=fixme;
  T2_Tempt_GND_Vdi_si=fixme;
  T2_Tempt_GND_Tempt_GND=fixme;
#endif
#endif
T2=d00_pow1;
EXIT_IF_ISNAN(d00_pow1)
}
if
((pModel->BULKMOD!=0))
{
{
double m00_fabs(d00_fabs0,Eeffm)
double m00_pow(d00_pow1,d00_fabs0,EU_a)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,Eeffm)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,EU_a)
double m11_pow(d11_pow1,d00_pow1,d00_fabs0,EU_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=(((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Vge_e*d10_fabs0))+(-UD_a*T2_Vge_e/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vdi_d)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_d/T2/T2/T2));
  T3_Vge_e_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vsi_s)/T2/T2+2*UD_a*T2_Vge_e*T2_Vsi_s/T2/T2/T2));
  T3_Vge_e_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_di/T2/T2/T2));
  T3_Vge_e_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_e)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_e/T2/T2/T2));
  T3_Vge_e_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_e+UD_a*T2_Vge_e_Vdi_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_si/T2/T2/T2));
  T3_Vge_e_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_si/T2/T2/T2));
  T3_Vge_e_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_di/T2/T2/T2));
  T3_Vge_e_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_si/T2/T2/T2));
  T3_Vge_e_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_e+UD_a*T2_Vge_e_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_e*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_si=((((UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)))+((UD_a_Vdi_si*T2-UD_a*T2_Vdi_si)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_d)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_d/T2/T2/T2));
  T3_Vdi_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vsi_s)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vsi_s/T2/T2/T2));
  T3_Vdi_si_Vge_di=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*0.0+(0.0)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_di/T2/T2/T2));
  T3_Vdi_si_Vge_e=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_e+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_e)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_e/T2/T2/T2));
  T3_Vdi_si_Vdi_si=(+(+(+UA_a_Vdi_si_Vdi_si+(+UC_a_Vdi_si_Vdi_si*veseff+UC_a_Vdi_si*veseff_Vdi_si+UC_a_Vdi_si*veseff_Vdi_si+UC_a*veseff_Vdi_si_Vdi_si))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Vdi_si_Vdi_si/T2-(UD_a_Vdi_si*T2_Vdi_si+UD_a_Vdi_si*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_si/T2/T2/T2));
  T3_Vdi_si_Ve_si=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*veseff_Ve_si+0.0*veseff_Vdi_si+UC_a*veseff_Vdi_si_Ve_si))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_si/T2/T2/T2));
  T3_Vdi_si_Ve_di=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*veseff_Ve_di+0.0*veseff_Vdi_si+UC_a*veseff_Vdi_si_Ve_di))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_di/T2/T2/T2));
  T3_Vdi_si_Vge_si=(+(+(+0.0+(+0.0*veseff+UC_a_Vdi_si*0.0+0.0*veseff_Vdi_si+UC_a*0.0))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_si/T2/T2/T2));
  T3_Vdi_si_Tempt_GND=(+(+(+UA_a_Vdi_si_Tempt_GND+(+UC_a_Vdi_si_Tempt_GND*veseff+UC_a_Vdi_si*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Vdi_si+UC_a*veseff_Vdi_si_Tempt_GND))*d00_pow1+(UA_a_Vdi_si+((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si)))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Vdi_si_Tempt_GND/T2-(UD_a_Vdi_si*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_si+UD_a*T2_Vdi_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_si=((((UC_a*veseff_Ve_si)*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)))+(-UD_a*T2_Ve_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vdi_d)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_d/T2/T2/T2));
  T3_Ve_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vsi_s)/T2/T2+2*UD_a*T2_Ve_si*T2_Vsi_s/T2/T2/T2));
  T3_Ve_si_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_di/T2/T2/T2));
  T3_Ve_si_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_e)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_e/T2/T2/T2));
  T3_Ve_si_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*veseff_Ve_si+UC_a*veseff_Ve_si_Vdi_si))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_si+UD_a*T2_Ve_si_Vdi_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_si/T2/T2/T2));
  T3_Ve_si_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*veseff_Ve_si+UC_a*veseff_Ve_si_Ve_si))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_si/T2/T2/T2));
  T3_Ve_si_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*veseff_Ve_si+UC_a*veseff_Ve_si_Ve_di))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_di/T2/T2/T2));
  T3_Ve_si_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_si+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_si/T2/T2/T2));
  T3_Ve_si_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Ve_si+UC_a*veseff_Ve_si_Tempt_GND))*d00_pow1+(UC_a*veseff_Ve_si)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_si+UD_a*T2_Ve_si_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_di=((((UC_a*veseff_Ve_di)*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)))+(-UD_a*T2_Ve_di/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vdi_d)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_d/T2/T2/T2));
  T3_Ve_di_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vsi_s)/T2/T2+2*UD_a*T2_Ve_di*T2_Vsi_s/T2/T2/T2));
  T3_Ve_di_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*0.0+(0.0)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_di/T2/T2/T2));
  T3_Ve_di_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_e)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_e/T2/T2/T2));
  T3_Ve_di_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*veseff_Ve_di+UC_a*veseff_Ve_di_Vdi_si))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_di+UD_a*T2_Ve_di_Vdi_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_si/T2/T2/T2));
  T3_Ve_di_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*veseff_Ve_di+UC_a*veseff_Ve_di_Ve_si))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_si/T2/T2/T2));
  T3_Ve_di_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*veseff_Ve_di+UC_a*veseff_Ve_di_Ve_di))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_di/T2/T2/T2));
  T3_Ve_di_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*veseff_Ve_di+UC_a*0.0))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_si/T2/T2/T2));
  T3_Ve_di_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Ve_di+UC_a*veseff_Ve_di_Tempt_GND))*d00_pow1+(UC_a*veseff_Ve_di)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_di+UD_a*T2_Ve_di_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_di*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vge_si=(((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Vge_si*d10_fabs0))+(-UD_a*T2_Vge_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vdi_d)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_d/T2/T2/T2));
  T3_Vge_si_Vsi_s=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vsi_s)/T2/T2+2*UD_a*T2_Vge_si*T2_Vsi_s/T2/T2/T2));
  T3_Vge_si_Vge_di=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*0.0+(0.0)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_di/T2/T2/T2));
  T3_Vge_si_Vge_e=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_e)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_e/T2/T2/T2));
  T3_Vge_si_Vdi_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Vdi_si+UC_a_Vdi_si*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_si+UD_a*T2_Vge_si_Vdi_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_si/T2/T2/T2));
  T3_Vge_si_Ve_si=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_si+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_si/T2/T2/T2));
  T3_Vge_si_Ve_di=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Ve_di+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_di/T2/T2/T2));
  T3_Vge_si_Vge_si=(+(+(+0.0+(+0.0*veseff+0.0*0.0+0.0*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_si/T2/T2/T2));
  T3_Vge_si_Tempt_GND=(+(+(+0.0+(+0.0*veseff+0.0*veseff_Tempt_GND+UC_a_Tempt_GND*0.0+UC_a*0.0))*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_si+UD_a*T2_Vge_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Tempt_GND=((((UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*d00_pow1)+((UA_a+(UC_a*veseff))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_d)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2));
  T3_Tempt_GND_Vsi_s=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vsi_s)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2));
  T3_Tempt_GND_Vge_di=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*0.0+(0.0)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_di/T2/T2/T2));
  T3_Tempt_GND_Vge_e=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_e+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_e)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_e/T2/T2/T2));
  T3_Tempt_GND_Vdi_si=(+(+(+UA_a_Tempt_GND_Vdi_si+(+UC_a_Tempt_GND_Vdi_si*veseff+UC_a_Tempt_GND*veseff_Vdi_si+UC_a_Vdi_si*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Vdi_si))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+(UA_a_Vdi_si+(((UC_a_Vdi_si*veseff)+(UC_a*veseff_Vdi_si))))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Tempt_GND_Vdi_si/T2-(UD_a_Tempt_GND*T2_Vdi_si+UD_a_Vdi_si*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2));
  T3_Tempt_GND_Ve_si=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*veseff_Ve_si+0.0*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Ve_si))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+((UC_a*veseff_Ve_si))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_si/T2/T2/T2));
  T3_Tempt_GND_Ve_di=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*veseff_Ve_di+0.0*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Ve_di))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+((UC_a*veseff_Ve_di))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_di/T2/T2/T2));
  T3_Tempt_GND_Vge_si=(+(+(+0.0+(+0.0*veseff+UC_a_Tempt_GND*0.0+0.0*veseff_Tempt_GND+UC_a*0.0))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+(0.0)*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_si/T2/T2/T2));
  T3_Tempt_GND_Tempt_GND=(+(+(+UA_a_Tempt_GND_Tempt_GND+(+UC_a_Tempt_GND_Tempt_GND*veseff+UC_a_Tempt_GND*veseff_Tempt_GND+UC_a_Tempt_GND*veseff_Tempt_GND+UC_a*veseff_Tempt_GND_Tempt_GND))*d00_pow1+(UA_a_Tempt_GND+((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND)))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a_Tempt_GND+(((UC_a_Tempt_GND*veseff)+(UC_a*veseff_Tempt_GND))))*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+(UA_a+(UC_a*veseff))*fixme)+(UD_a_Tempt_GND_Tempt_GND/T2-(UD_a_Tempt_GND*T2_Tempt_GND+UD_a_Tempt_GND*T2_Tempt_GND+UD_a*T2_Tempt_GND_Tempt_GND)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2));
#endif
#endif
T3=(((UA_a+(UC_a*veseff))*d00_pow1)+(UD_a/T2));
EXIT_IF_ISNAN((((UA_a+(UC_a*veseff))*d00_pow1)+(UD_a/T2)))
}
}
else
{
{
double m00_fabs(d00_fabs0,Eeffm)
double m00_pow(d00_pow1,d00_fabs0,EU_a)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,Eeffm)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,EU_a)
double m11_pow(d11_pow1,d00_pow1,d00_fabs0,EU_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=((UA_a*(d10_pow1*Eeffm_Vge_e*d10_fabs0))+(-UD_a*T2_Vge_e/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vdi_d)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_d/T2/T2/T2));
  T3_Vge_e_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vsi_s)/T2/T2+2*UD_a*T2_Vge_e*T2_Vsi_s/T2/T2/T2));
  T3_Vge_e_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_di/T2/T2/T2));
  T3_Vge_e_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_e)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_e/T2/T2/T2));
  T3_Vge_e_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_e+UD_a*T2_Vge_e_Vdi_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_si/T2/T2/T2));
  T3_Vge_e_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_si/T2/T2/T2));
  T3_Vge_e_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_di/T2/T2/T2));
  T3_Vge_e_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_si/T2/T2/T2));
  T3_Vge_e_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_e+UD_a*T2_Vge_e_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_e*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_si=(((UA_a_Vdi_si*d00_pow1)+(UA_a*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)))+((UD_a_Vdi_si*T2-UD_a*T2_Vdi_si)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_d)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_d/T2/T2/T2));
  T3_Vdi_si_Vsi_s=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vsi_s)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vsi_s/T2/T2/T2));
  T3_Vdi_si_Vge_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_di/T2/T2/T2));
  T3_Vdi_si_Vge_e=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_e+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_e)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_e/T2/T2/T2));
  T3_Vdi_si_Vdi_si=(+(+UA_a_Vdi_si_Vdi_si*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Vdi_si/T2-(UD_a_Vdi_si*T2_Vdi_si+UD_a_Vdi_si*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_si/T2/T2/T2));
  T3_Vdi_si_Ve_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_si/T2/T2/T2));
  T3_Vdi_si_Ve_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_di/T2/T2/T2));
  T3_Vdi_si_Vge_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_si/T2/T2/T2));
  T3_Vdi_si_Tempt_GND=(+(+UA_a_Vdi_si_Tempt_GND*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Tempt_GND/T2-(UD_a_Vdi_si*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_si+UD_a*T2_Vdi_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_si=((UA_a*(d10_pow1*Eeffm_Ve_si*d10_fabs0))+(-UD_a*T2_Ve_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vdi_d)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_d/T2/T2/T2));
  T3_Ve_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vsi_s)/T2/T2+2*UD_a*T2_Ve_si*T2_Vsi_s/T2/T2/T2));
  T3_Ve_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_di/T2/T2/T2));
  T3_Ve_si_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_e)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_e/T2/T2/T2));
  T3_Ve_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_si+UD_a*T2_Ve_si_Vdi_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_si/T2/T2/T2));
  T3_Ve_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_si/T2/T2/T2));
  T3_Ve_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_di/T2/T2/T2));
  T3_Ve_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_si/T2/T2/T2));
  T3_Ve_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_si+UD_a*T2_Ve_si_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_di=((UA_a*(d10_pow1*Eeffm_Ve_di*d10_fabs0))+(-UD_a*T2_Ve_di/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vdi_d)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_d/T2/T2/T2));
  T3_Ve_di_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vsi_s)/T2/T2+2*UD_a*T2_Ve_di*T2_Vsi_s/T2/T2/T2));
  T3_Ve_di_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_di/T2/T2/T2));
  T3_Ve_di_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_e)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_e/T2/T2/T2));
  T3_Ve_di_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_di+UD_a*T2_Ve_di_Vdi_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_si/T2/T2/T2));
  T3_Ve_di_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_si/T2/T2/T2));
  T3_Ve_di_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_di/T2/T2/T2));
  T3_Ve_di_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_si/T2/T2/T2));
  T3_Ve_di_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_di+UD_a*T2_Ve_di_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_di*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vge_si=((UA_a*(d10_pow1*Eeffm_Vge_si*d10_fabs0))+(-UD_a*T2_Vge_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vdi_d)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_d/T2/T2/T2));
  T3_Vge_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vsi_s)/T2/T2+2*UD_a*T2_Vge_si*T2_Vsi_s/T2/T2/T2));
  T3_Vge_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_di/T2/T2/T2));
  T3_Vge_si_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_e)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_e/T2/T2/T2));
  T3_Vge_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_si+UD_a*T2_Vge_si_Vdi_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_si/T2/T2/T2));
  T3_Vge_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_si/T2/T2/T2));
  T3_Vge_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_di/T2/T2/T2));
  T3_Vge_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_si/T2/T2/T2));
  T3_Vge_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_si+UD_a*T2_Vge_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Tempt_GND=(((UA_a_Tempt_GND*d00_pow1)+(UA_a*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_d)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2));
  T3_Tempt_GND_Vsi_s=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vsi_s)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2));
  T3_Tempt_GND_Vge_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_di/T2/T2/T2));
  T3_Tempt_GND_Vge_e=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_e+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_e)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_e/T2/T2/T2));
  T3_Tempt_GND_Vdi_si=(+(+UA_a_Tempt_GND_Vdi_si*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Vdi_si/T2-(UD_a_Tempt_GND*T2_Vdi_si+UD_a_Vdi_si*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2));
  T3_Tempt_GND_Ve_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_si/T2/T2/T2));
  T3_Tempt_GND_Ve_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_di/T2/T2/T2));
  T3_Tempt_GND_Vge_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_si/T2/T2/T2));
  T3_Tempt_GND_Tempt_GND=(+(+UA_a_Tempt_GND_Tempt_GND*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Tempt_GND/T2-(UD_a_Tempt_GND*T2_Tempt_GND+UD_a_Tempt_GND*T2_Tempt_GND+UD_a*T2_Tempt_GND_Tempt_GND)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2));
#endif
#endif
T3=((UA_a*d00_pow1)+(UD_a/T2));
EXIT_IF_ISNAN(((UA_a*d00_pow1)+(UD_a/T2)))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dmob_Vge_e=T3_Vge_e;
#if defined(_DERIVATE2)
  Dmob_Vge_e_Vge_e=(+0.0+T3_Vge_e_Vge_e);
  Dmob_Vge_e_Vdi_si=(+0.0+T3_Vge_e_Vdi_si);
  Dmob_Vge_e_Ve_si=(+0.0+T3_Vge_e_Ve_si);
  Dmob_Vge_e_Ve_di=(+0.0+T3_Vge_e_Ve_di);
  Dmob_Vge_e_Vge_si=(+0.0+T3_Vge_e_Vge_si);
  Dmob_Vge_e_Tempt_GND=(+0.0+T3_Vge_e_Tempt_GND);
#endif
Dmob_Vdi_si=T3_Vdi_si;
#if defined(_DERIVATE2)
  Dmob_Vdi_si_Vge_e=(+0.0+T3_Vdi_si_Vge_e);
  Dmob_Vdi_si_Vdi_si=(+0.0+T3_Vdi_si_Vdi_si);
  Dmob_Vdi_si_Ve_si=(+0.0+T3_Vdi_si_Ve_si);
  Dmob_Vdi_si_Ve_di=(+0.0+T3_Vdi_si_Ve_di);
  Dmob_Vdi_si_Vge_si=(+0.0+T3_Vdi_si_Vge_si);
  Dmob_Vdi_si_Tempt_GND=(+0.0+T3_Vdi_si_Tempt_GND);
#endif
Dmob_Ve_si=T3_Ve_si;
#if defined(_DERIVATE2)
  Dmob_Ve_si_Vge_e=(+0.0+T3_Ve_si_Vge_e);
  Dmob_Ve_si_Vdi_si=(+0.0+T3_Ve_si_Vdi_si);
  Dmob_Ve_si_Ve_si=(+0.0+T3_Ve_si_Ve_si);
  Dmob_Ve_si_Ve_di=(+0.0+T3_Ve_si_Ve_di);
  Dmob_Ve_si_Vge_si=(+0.0+T3_Ve_si_Vge_si);
  Dmob_Ve_si_Tempt_GND=(+0.0+T3_Ve_si_Tempt_GND);
#endif
Dmob_Ve_di=T3_Ve_di;
#if defined(_DERIVATE2)
  Dmob_Ve_di_Vge_e=(+0.0+T3_Ve_di_Vge_e);
  Dmob_Ve_di_Vdi_si=(+0.0+T3_Ve_di_Vdi_si);
  Dmob_Ve_di_Ve_si=(+0.0+T3_Ve_di_Ve_si);
  Dmob_Ve_di_Ve_di=(+0.0+T3_Ve_di_Ve_di);
  Dmob_Ve_di_Vge_si=(+0.0+T3_Ve_di_Vge_si);
  Dmob_Ve_di_Tempt_GND=(+0.0+T3_Ve_di_Tempt_GND);
#endif
Dmob_Vge_si=T3_Vge_si;
#if defined(_DERIVATE2)
  Dmob_Vge_si_Vge_e=(+0.0+T3_Vge_si_Vge_e);
  Dmob_Vge_si_Vdi_si=(+0.0+T3_Vge_si_Vdi_si);
  Dmob_Vge_si_Ve_si=(+0.0+T3_Vge_si_Ve_si);
  Dmob_Vge_si_Ve_di=(+0.0+T3_Vge_si_Ve_di);
  Dmob_Vge_si_Vge_si=(+0.0+T3_Vge_si_Vge_si);
  Dmob_Vge_si_Tempt_GND=(+0.0+T3_Vge_si_Tempt_GND);
#endif
Dmob_Tempt_GND=T3_Tempt_GND;
#if defined(_DERIVATE2)
  Dmob_Tempt_GND_Vge_e=(+0.0+T3_Tempt_GND_Vge_e);
  Dmob_Tempt_GND_Vdi_si=(+0.0+T3_Tempt_GND_Vdi_si);
  Dmob_Tempt_GND_Ve_si=(+0.0+T3_Tempt_GND_Ve_si);
  Dmob_Tempt_GND_Ve_di=(+0.0+T3_Tempt_GND_Ve_di);
  Dmob_Tempt_GND_Vge_si=(+0.0+T3_Tempt_GND_Vge_si);
  Dmob_Tempt_GND_Tempt_GND=(+0.0+T3_Tempt_GND_Tempt_GND);
#endif
#endif
Dmob=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dmob_Vge_e=(Dmob_Vge_e/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Vge_e_Vge_e=(Dmob_Vge_e_Vge_e/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_e_Vdi_si=(Dmob_Vge_e_Vdi_si/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_e_Ve_si=(Dmob_Vge_e_Ve_si/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_e_Ve_di=(Dmob_Vge_e_Ve_di/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_e_Vge_si=(Dmob_Vge_e_Vge_si/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_e_Tempt_GND=(Dmob_Vge_e_Tempt_GND/pModel->U0MULT-(Dmob_Vge_e*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_Vdi_si=(Dmob_Vdi_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Vdi_si_Vge_e=(Dmob_Vdi_si_Vge_e/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vdi_si_Vdi_si=(Dmob_Vdi_si_Vdi_si/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vdi_si_Ve_si=(Dmob_Vdi_si_Ve_si/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vdi_si_Ve_di=(Dmob_Vdi_si_Ve_di/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vdi_si_Vge_si=(Dmob_Vdi_si_Vge_si/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vdi_si_Tempt_GND=(Dmob_Vdi_si_Tempt_GND/pModel->U0MULT-(Dmob_Vdi_si*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_Ve_si=(Dmob_Ve_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Ve_si_Vge_e=(Dmob_Ve_si_Vge_e/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_si_Vdi_si=(Dmob_Ve_si_Vdi_si/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_si_Ve_si=(Dmob_Ve_si_Ve_si/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_si_Ve_di=(Dmob_Ve_si_Ve_di/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_si_Vge_si=(Dmob_Ve_si_Vge_si/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_si_Tempt_GND=(Dmob_Ve_si_Tempt_GND/pModel->U0MULT-(Dmob_Ve_si*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_Ve_di=(Dmob_Ve_di/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Ve_di_Vge_e=(Dmob_Ve_di_Vge_e/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_di_Vdi_si=(Dmob_Ve_di_Vdi_si/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_di_Ve_si=(Dmob_Ve_di_Ve_si/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_di_Ve_di=(Dmob_Ve_di_Ve_di/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_di_Vge_si=(Dmob_Ve_di_Vge_si/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Ve_di_Tempt_GND=(Dmob_Ve_di_Tempt_GND/pModel->U0MULT-(Dmob_Ve_di*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_Vge_si=(Dmob_Vge_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Vge_si_Vge_e=(Dmob_Vge_si_Vge_e/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_si_Vdi_si=(Dmob_Vge_si_Vdi_si/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_si_Ve_si=(Dmob_Vge_si_Ve_si/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_si_Ve_di=(Dmob_Vge_si_Ve_di/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_si_Vge_si=(Dmob_Vge_si_Vge_si/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Vge_si_Tempt_GND=(Dmob_Vge_si_Tempt_GND/pModel->U0MULT-(Dmob_Vge_si*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_Tempt_GND=(Dmob_Tempt_GND/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_Tempt_GND_Vge_e=(Dmob_Tempt_GND_Vge_e/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Vge_e*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Tempt_GND_Vdi_si=(Dmob_Tempt_GND_Vdi_si/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Vdi_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Tempt_GND_Ve_si=(Dmob_Tempt_GND_Ve_si/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Ve_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Tempt_GND_Ve_di=(Dmob_Tempt_GND_Ve_di/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Ve_di*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Tempt_GND_Vge_si=(Dmob_Tempt_GND_Vge_si/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Vge_si*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_Tempt_GND_Tempt_GND=(Dmob_Tempt_GND_Tempt_GND/pModel->U0MULT-(Dmob_Tempt_GND*0.0+Dmob_Tempt_GND*0.0+Dmob*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
#endif
Dmob=(Dmob/pModel->U0MULT);
EXIT_IF_ISNAN((Dmob/pModel->U0MULT))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
ueff_Tempt_GND=((u0_a_Tempt_GND*Dmob-u0_a*Dmob_Tempt_GND)/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Tempt_GND_Tempt_GND=(u0_a_Tempt_GND_Tempt_GND/Dmob-(u0_a_Tempt_GND*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Tempt_GND_Vdi_si=(u0_a_Tempt_GND_Vdi_si/Dmob-(u0_a_Tempt_GND*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Tempt_GND_Vge_e=(0.0/Dmob-(u0_a_Tempt_GND*Dmob_Vge_e+0.0*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Tempt_GND_Ve_si=(0.0/Dmob-(u0_a_Tempt_GND*Dmob_Ve_si+0.0*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Tempt_GND_Ve_di=(0.0/Dmob-(u0_a_Tempt_GND*Dmob_Ve_di+0.0*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Tempt_GND_Vge_si=(0.0/Dmob-(u0_a_Tempt_GND*Dmob_Vge_si+0.0*Dmob_Tempt_GND+u0_a*Dmob_Tempt_GND_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Tempt_GND*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
ueff_Vdi_si=((u0_a_Vdi_si*Dmob-u0_a*Dmob_Vdi_si)/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Vdi_si_Tempt_GND=(u0_a_Vdi_si_Tempt_GND/Dmob-(u0_a_Vdi_si*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Vdi_si_Vdi_si=(u0_a_Vdi_si_Vdi_si/Dmob-(u0_a_Vdi_si*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Vdi_si_Vge_e=(0.0/Dmob-(u0_a_Vdi_si*Dmob_Vge_e+0.0*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Vdi_si_Ve_si=(0.0/Dmob-(u0_a_Vdi_si*Dmob_Ve_si+0.0*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Vdi_si_Ve_di=(0.0/Dmob-(u0_a_Vdi_si*Dmob_Ve_di+0.0*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Vdi_si_Vge_si=(0.0/Dmob-(u0_a_Vdi_si*Dmob_Vge_si+0.0*Dmob_Vdi_si+u0_a*Dmob_Vdi_si_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Vdi_si*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
ueff_Vge_e=(-u0_a*Dmob_Vge_e/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Vge_e_Tempt_GND=(0.0/Dmob-(0.0*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Vge_e+u0_a*Dmob_Vge_e_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Vge_e_Vdi_si=(0.0/Dmob-(0.0*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Vge_e+u0_a*Dmob_Vge_e_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Vge_e_Vge_e=(0.0/Dmob-(0.0*Dmob_Vge_e+0.0*Dmob_Vge_e+u0_a*Dmob_Vge_e_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Vge_e_Ve_si=(0.0/Dmob-(0.0*Dmob_Ve_si+0.0*Dmob_Vge_e+u0_a*Dmob_Vge_e_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Vge_e_Ve_di=(0.0/Dmob-(0.0*Dmob_Ve_di+0.0*Dmob_Vge_e+u0_a*Dmob_Vge_e_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Vge_e_Vge_si=(0.0/Dmob-(0.0*Dmob_Vge_si+0.0*Dmob_Vge_e+u0_a*Dmob_Vge_e_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_e*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
ueff_Ve_si=(-u0_a*Dmob_Ve_si/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Ve_si_Tempt_GND=(0.0/Dmob-(0.0*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Ve_si+u0_a*Dmob_Ve_si_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Ve_si_Vdi_si=(0.0/Dmob-(0.0*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Ve_si+u0_a*Dmob_Ve_si_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Ve_si_Vge_e=(0.0/Dmob-(0.0*Dmob_Vge_e+0.0*Dmob_Ve_si+u0_a*Dmob_Ve_si_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Ve_si_Ve_si=(0.0/Dmob-(0.0*Dmob_Ve_si+0.0*Dmob_Ve_si+u0_a*Dmob_Ve_si_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Ve_si_Ve_di=(0.0/Dmob-(0.0*Dmob_Ve_di+0.0*Dmob_Ve_si+u0_a*Dmob_Ve_si_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Ve_si_Vge_si=(0.0/Dmob-(0.0*Dmob_Vge_si+0.0*Dmob_Ve_si+u0_a*Dmob_Ve_si_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_si*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
ueff_Ve_di=(-u0_a*Dmob_Ve_di/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Ve_di_Tempt_GND=(0.0/Dmob-(0.0*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Ve_di+u0_a*Dmob_Ve_di_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Ve_di_Vdi_si=(0.0/Dmob-(0.0*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Ve_di+u0_a*Dmob_Ve_di_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Ve_di_Vge_e=(0.0/Dmob-(0.0*Dmob_Vge_e+0.0*Dmob_Ve_di+u0_a*Dmob_Ve_di_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Ve_di_Ve_si=(0.0/Dmob-(0.0*Dmob_Ve_si+0.0*Dmob_Ve_di+u0_a*Dmob_Ve_di_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Ve_di_Ve_di=(0.0/Dmob-(0.0*Dmob_Ve_di+0.0*Dmob_Ve_di+u0_a*Dmob_Ve_di_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Ve_di_Vge_si=(0.0/Dmob-(0.0*Dmob_Vge_si+0.0*Dmob_Ve_di+u0_a*Dmob_Ve_di_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Ve_di*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
ueff_Vge_si=(-u0_a*Dmob_Vge_si/Dmob/Dmob);
#if defined(_DERIVATE2)
  ueff_Vge_si_Tempt_GND=(0.0/Dmob-(0.0*Dmob_Tempt_GND+u0_a_Tempt_GND*Dmob_Vge_si+u0_a*Dmob_Vge_si_Tempt_GND)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Tempt_GND/Dmob/Dmob/Dmob);
  ueff_Vge_si_Vdi_si=(0.0/Dmob-(0.0*Dmob_Vdi_si+u0_a_Vdi_si*Dmob_Vge_si+u0_a*Dmob_Vge_si_Vdi_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Vdi_si/Dmob/Dmob/Dmob);
  ueff_Vge_si_Vge_e=(0.0/Dmob-(0.0*Dmob_Vge_e+0.0*Dmob_Vge_si+u0_a*Dmob_Vge_si_Vge_e)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Vge_e/Dmob/Dmob/Dmob);
  ueff_Vge_si_Ve_si=(0.0/Dmob-(0.0*Dmob_Ve_si+0.0*Dmob_Vge_si+u0_a*Dmob_Vge_si_Ve_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Ve_si/Dmob/Dmob/Dmob);
  ueff_Vge_si_Ve_di=(0.0/Dmob-(0.0*Dmob_Ve_di+0.0*Dmob_Vge_si+u0_a*Dmob_Vge_si_Ve_di)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Ve_di/Dmob/Dmob/Dmob);
  ueff_Vge_si_Vge_si=(0.0/Dmob-(0.0*Dmob_Vge_si+0.0*Dmob_Vge_si+u0_a*Dmob_Vge_si_Vge_si)/Dmob/Dmob+2*u0_a*Dmob_Vge_si*Dmob_Vge_si/Dmob/Dmob/Dmob);
#endif
#endif
ueff=(u0_a/Dmob);
EXIT_IF_ISNAN((u0_a/Dmob))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Eeffm_cv_Tempt_GND=(EeffFactor*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND)));
#if defined(_DERIVATE2)
  Eeffm_cv_Tempt_GND_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*qia2_Tempt_GND+eta_mu_cv*qia2_Tempt_GND_Tempt_GND)));
  Eeffm_cv_Tempt_GND_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Tempt_GND+eta_mu_cv*qia2_Tempt_GND_Vdi_si)));
  Eeffm_cv_Tempt_GND_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Tempt_GND+eta_mu_cv*0.0)));
  Eeffm_cv_Tempt_GND_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Tempt_GND+eta_mu_cv*qia2_Tempt_GND_Ve_si)));
  Eeffm_cv_Tempt_GND_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Tempt_GND+eta_mu_cv*qia2_Tempt_GND_Ve_di)));
  Eeffm_cv_Tempt_GND_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*(qba_Tempt_GND+(eta_mu_cv*qia2_Tempt_GND))+EeffFactor*(+qba_Tempt_GND_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Tempt_GND+eta_mu_cv*qia2_Tempt_GND_Vge_si)));
#endif
Eeffm_cv_Vdi_si=(EeffFactor*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si)));
#if defined(_DERIVATE2)
  Eeffm_cv_Vdi_si_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*qia2_Vdi_si+eta_mu_cv*qia2_Vdi_si_Tempt_GND)));
  Eeffm_cv_Vdi_si_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Vdi_si+eta_mu_cv*qia2_Vdi_si_Vdi_si)));
  Eeffm_cv_Vdi_si_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Vdi_si+eta_mu_cv*0.0)));
  Eeffm_cv_Vdi_si_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Vdi_si+eta_mu_cv*qia2_Vdi_si_Ve_si)));
  Eeffm_cv_Vdi_si_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Vdi_si+eta_mu_cv*qia2_Vdi_si_Ve_di)));
  Eeffm_cv_Vdi_si_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*(qba_Vdi_si+(eta_mu_cv*qia2_Vdi_si))+EeffFactor*(+qba_Vdi_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Vdi_si+eta_mu_cv*qia2_Vdi_si_Vge_si)));
#endif
Eeffm_cv_Vge_e=(EeffFactor*qba_Vge_e);
#if defined(_DERIVATE2)
  Eeffm_cv_Vge_e_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*0.0+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_e_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*0.0+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_e_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vge_e+(+0.0*qia2+0.0*0.0+0.0*0.0+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_e_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*0.0+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_e_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*0.0+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_e_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*qba_Vge_e+EeffFactor*(+qba_Vge_e_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*0.0+eta_mu_cv*0.0)));
#endif
Eeffm_cv_Ve_si=(EeffFactor*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si)));
#if defined(_DERIVATE2)
  Eeffm_cv_Ve_si_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*qia2_Ve_si+eta_mu_cv*qia2_Ve_si_Tempt_GND)));
  Eeffm_cv_Ve_si_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Ve_si+eta_mu_cv*qia2_Ve_si_Vdi_si)));
  Eeffm_cv_Ve_si_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Ve_si+eta_mu_cv*0.0)));
  Eeffm_cv_Ve_si_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Ve_si+eta_mu_cv*qia2_Ve_si_Ve_si)));
  Eeffm_cv_Ve_si_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Ve_si+eta_mu_cv*qia2_Ve_si_Ve_di)));
  Eeffm_cv_Ve_si_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*(qba_Ve_si+(eta_mu_cv*qia2_Ve_si))+EeffFactor*(+qba_Ve_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Ve_si+eta_mu_cv*qia2_Ve_si_Vge_si)));
#endif
Eeffm_cv_Ve_di=(EeffFactor*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di)));
#if defined(_DERIVATE2)
  Eeffm_cv_Ve_di_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*qia2_Ve_di+eta_mu_cv*qia2_Ve_di_Tempt_GND)));
  Eeffm_cv_Ve_di_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Ve_di+eta_mu_cv*qia2_Ve_di_Vdi_si)));
  Eeffm_cv_Ve_di_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Ve_di+eta_mu_cv*0.0)));
  Eeffm_cv_Ve_di_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Ve_di+eta_mu_cv*qia2_Ve_di_Ve_si)));
  Eeffm_cv_Ve_di_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Ve_di+eta_mu_cv*qia2_Ve_di_Ve_di)));
  Eeffm_cv_Ve_di_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*(qba_Ve_di+(eta_mu_cv*qia2_Ve_di))+EeffFactor*(+qba_Ve_di_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Ve_di+eta_mu_cv*qia2_Ve_di_Vge_si)));
#endif
Eeffm_cv_Vge_si=(EeffFactor*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si)));
#if defined(_DERIVATE2)
  Eeffm_cv_Vge_si_Tempt_GND=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Tempt_GND+((eta_mu_cv*qia2_Tempt_GND)))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Tempt_GND+(+0.0*qia2+0.0*qia2_Tempt_GND+0.0*qia2_Vge_si+eta_mu_cv*qia2_Vge_si_Tempt_GND)));
  Eeffm_cv_Vge_si_Vdi_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vdi_si+((eta_mu_cv*qia2_Vdi_si)))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vdi_si+(+0.0*qia2+0.0*qia2_Vdi_si+0.0*qia2_Vge_si+eta_mu_cv*qia2_Vge_si_Vdi_si)));
  Eeffm_cv_Vge_si_Vge_e=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_e+(0.0))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vge_e+(+0.0*qia2+0.0*0.0+0.0*qia2_Vge_si+eta_mu_cv*0.0)));
  Eeffm_cv_Vge_si_Ve_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_si+((eta_mu_cv*qia2_Ve_si)))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Ve_si+(+0.0*qia2+0.0*qia2_Ve_si+0.0*qia2_Vge_si+eta_mu_cv*qia2_Vge_si_Ve_si)));
  Eeffm_cv_Vge_si_Ve_di=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Ve_di+((eta_mu_cv*qia2_Ve_di)))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Ve_di+(+0.0*qia2+0.0*qia2_Ve_di+0.0*qia2_Vge_si+eta_mu_cv*qia2_Vge_si_Ve_di)));
  Eeffm_cv_Vge_si_Vge_si=(+0.0*(qba+(eta_mu_cv*qia2))+0.0*(qba_Vge_si+((eta_mu_cv*qia2_Vge_si)))+0.0*(qba_Vge_si+(eta_mu_cv*qia2_Vge_si))+EeffFactor*(+qba_Vge_si_Vge_si+(+0.0*qia2+0.0*qia2_Vge_si+0.0*qia2_Vge_si+eta_mu_cv*qia2_Vge_si_Vge_si)));
#endif
#endif
Eeffm_cv=(EeffFactor*(qba+(eta_mu_cv*qia2)));
EXIT_IF_ISNAN((EeffFactor*(qba+(eta_mu_cv*qia2))))
{
double m00_fabs(d00_fabs0,Eeffm_cv)
double m00_pow(d00_pow1,d00_fabs0,EU_a)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,Eeffm_cv)
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,EU_a)
double m11_pow(d11_pow1,d00_pow1,d00_fabs0,EU_a)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=((UA_a*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0))+(-UD_a*T2_Vge_e/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vdi_d)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_d/T2/T2/T2));
  T3_Vge_e_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vsi_s)/T2/T2+2*UD_a*T2_Vge_e*T2_Vsi_s/T2/T2/T2));
  T3_Vge_e_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_di/T2/T2/T2));
  T3_Vge_e_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_e)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_e/T2/T2/T2));
  T3_Vge_e_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_e+UD_a*T2_Vge_e_Vdi_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vdi_si/T2/T2/T2));
  T3_Vge_e_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_si/T2/T2/T2));
  T3_Vge_e_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_e+UD_a*T2_Vge_e_Ve_di)/T2/T2+2*UD_a*T2_Vge_e*T2_Ve_di/T2/T2/T2));
  T3_Vge_e_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_e+UD_a*T2_Vge_e_Vge_si)/T2/T2+2*UD_a*T2_Vge_e*T2_Vge_si/T2/T2/T2));
  T3_Vge_e_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_e+UD_a*T2_Vge_e_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_e*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vdi_si=(((UA_a_Vdi_si*d00_pow1)+(UA_a*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)))+((UD_a_Vdi_si*T2-UD_a*T2_Vdi_si)/T2/T2));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_d)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_d/T2/T2/T2));
  T3_Vdi_si_Vsi_s=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vsi_s)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vsi_s/T2/T2/T2));
  T3_Vdi_si_Vge_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*0.0+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_di/T2/T2/T2));
  T3_Vdi_si_Vge_e=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_e+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_e)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_e/T2/T2/T2));
  T3_Vdi_si_Vdi_si=(+(+UA_a_Vdi_si_Vdi_si*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Vdi_si/T2-(UD_a_Vdi_si*T2_Vdi_si+UD_a_Vdi_si*T2_Vdi_si+UD_a*T2_Vdi_si_Vdi_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vdi_si/T2/T2/T2));
  T3_Vdi_si_Ve_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_si/T2/T2/T2));
  T3_Vdi_si_Ve_di=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Ve_di+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Ve_di)/T2/T2+2*UD_a*T2_Vdi_si*T2_Ve_di/T2/T2/T2));
  T3_Vdi_si_Vge_si=(+(+0.0*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(0.0/T2-(UD_a_Vdi_si*T2_Vge_si+0.0*T2_Vdi_si+UD_a*T2_Vdi_si_Vge_si)/T2/T2+2*UD_a*T2_Vdi_si*T2_Vge_si/T2/T2/T2));
  T3_Vdi_si_Tempt_GND=(+(+UA_a_Vdi_si_Tempt_GND*d00_pow1+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a*fixme)+(UD_a_Vdi_si_Tempt_GND/T2-(UD_a_Vdi_si*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vdi_si+UD_a*T2_Vdi_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_si=((UA_a*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0))+(-UD_a*T2_Ve_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vdi_d)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_d/T2/T2/T2));
  T3_Ve_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vsi_s)/T2/T2+2*UD_a*T2_Ve_si*T2_Vsi_s/T2/T2/T2));
  T3_Ve_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_di/T2/T2/T2));
  T3_Ve_si_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_e)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_e/T2/T2/T2));
  T3_Ve_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_si+UD_a*T2_Ve_si_Vdi_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vdi_si/T2/T2/T2));
  T3_Ve_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_si/T2/T2/T2));
  T3_Ve_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_si+UD_a*T2_Ve_si_Ve_di)/T2/T2+2*UD_a*T2_Ve_si*T2_Ve_di/T2/T2/T2));
  T3_Ve_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_si+UD_a*T2_Ve_si_Vge_si)/T2/T2+2*UD_a*T2_Ve_si*T2_Vge_si/T2/T2/T2));
  T3_Ve_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_si+UD_a*T2_Ve_si_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Ve_di=((UA_a*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0))+(-UD_a*T2_Ve_di/T2/T2));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vdi_d)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_d/T2/T2/T2));
  T3_Ve_di_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vsi_s)/T2/T2+2*UD_a*T2_Ve_di*T2_Vsi_s/T2/T2/T2));
  T3_Ve_di_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_di/T2/T2/T2));
  T3_Ve_di_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_e)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_e/T2/T2/T2));
  T3_Ve_di_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Ve_di+UD_a*T2_Ve_di_Vdi_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vdi_si/T2/T2/T2));
  T3_Ve_di_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_si/T2/T2/T2));
  T3_Ve_di_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Ve_di+UD_a*T2_Ve_di_Ve_di)/T2/T2+2*UD_a*T2_Ve_di*T2_Ve_di/T2/T2/T2));
  T3_Ve_di_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Ve_di+UD_a*T2_Ve_di_Vge_si)/T2/T2+2*UD_a*T2_Ve_di*T2_Vge_si/T2/T2/T2));
  T3_Ve_di_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Ve_di+UD_a*T2_Ve_di_Tempt_GND)/T2/T2+2*UD_a*T2_Ve_di*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Vge_si=((UA_a*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0))+(-UD_a*T2_Vge_si/T2/T2));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vdi_d)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_d/T2/T2/T2));
  T3_Vge_si_Vsi_s=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vsi_s)/T2/T2+2*UD_a*T2_Vge_si*T2_Vsi_s/T2/T2/T2));
  T3_Vge_si_Vge_di=(+(+0.0*d00_pow1+0.0*0.0+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_di/T2/T2/T2));
  T3_Vge_si_Vge_e=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_e+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_e)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_e/T2/T2/T2));
  T3_Vge_si_Vdi_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vdi_si+UD_a_Vdi_si*T2_Vge_si+UD_a*T2_Vge_si_Vdi_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vdi_si/T2/T2/T2));
  T3_Vge_si_Ve_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_si/T2/T2/T2));
  T3_Vge_si_Ve_di=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Ve_di+0.0*T2_Vge_si+UD_a*T2_Vge_si_Ve_di)/T2/T2+2*UD_a*T2_Vge_si*T2_Ve_di/T2/T2/T2));
  T3_Vge_si_Vge_si=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Vge_si+0.0*T2_Vge_si+UD_a*T2_Vge_si_Vge_si)/T2/T2+2*UD_a*T2_Vge_si*T2_Vge_si/T2/T2/T2));
  T3_Vge_si_Tempt_GND=(+(+0.0*d00_pow1+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+UA_a*fixme)+(0.0/T2-(0.0*T2_Tempt_GND+UD_a_Tempt_GND*T2_Vge_si+UD_a*T2_Vge_si_Tempt_GND)/T2/T2+2*UD_a*T2_Vge_si*T2_Tempt_GND/T2/T2/T2));
#endif
T3_Tempt_GND=(((UA_a_Tempt_GND*d00_pow1)+(UA_a*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)))+((UD_a_Tempt_GND*T2-UD_a*T2_Tempt_GND)/T2/T2));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_d)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2));
  T3_Tempt_GND_Vsi_s=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vsi_s)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2));
  T3_Tempt_GND_Vge_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*0.0+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_di/T2/T2/T2));
  T3_Tempt_GND_Vge_e=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vge_e*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_e+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_e)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_e/T2/T2/T2));
  T3_Tempt_GND_Vdi_si=(+(+UA_a_Tempt_GND_Vdi_si*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vdi_si*d10_fabs0+d11_pow1*EU_a_Vdi_si)+UA_a_Vdi_si*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Vdi_si/T2-(UD_a_Tempt_GND*T2_Vdi_si+UD_a_Vdi_si*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vdi_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2));
  T3_Tempt_GND_Ve_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Ve_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_si/T2/T2/T2));
  T3_Tempt_GND_Ve_di=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Ve_di*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Ve_di+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Ve_di)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Ve_di/T2/T2/T2));
  T3_Tempt_GND_Vge_si=(+(+0.0*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Vge_si*d10_fabs0)+0.0*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(0.0/T2-(UD_a_Tempt_GND*T2_Vge_si+0.0*T2_Tempt_GND+UD_a*T2_Tempt_GND_Vge_si)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Vge_si/T2/T2/T2));
  T3_Tempt_GND_Tempt_GND=(+(+UA_a_Tempt_GND_Tempt_GND*d00_pow1+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a_Tempt_GND*(d10_pow1*Eeffm_cv_Tempt_GND*d10_fabs0+d11_pow1*EU_a_Tempt_GND)+UA_a*fixme)+(UD_a_Tempt_GND_Tempt_GND/T2-(UD_a_Tempt_GND*T2_Tempt_GND+UD_a_Tempt_GND*T2_Tempt_GND+UD_a*T2_Tempt_GND_Tempt_GND)/T2/T2+2*UD_a*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2));
#endif
#endif
T3=((UA_a*d00_pow1)+(UD_a/T2));
EXIT_IF_ISNAN(((UA_a*d00_pow1)+(UD_a/T2)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
Dmob_cv_Vge_e=T3_Vge_e;
#if defined(_DERIVATE2)
  Dmob_cv_Vge_e_Vge_e=(+0.0+T3_Vge_e_Vge_e);
  Dmob_cv_Vge_e_Vdi_si=(+0.0+T3_Vge_e_Vdi_si);
  Dmob_cv_Vge_e_Ve_si=(+0.0+T3_Vge_e_Ve_si);
  Dmob_cv_Vge_e_Ve_di=(+0.0+T3_Vge_e_Ve_di);
  Dmob_cv_Vge_e_Vge_si=(+0.0+T3_Vge_e_Vge_si);
  Dmob_cv_Vge_e_Tempt_GND=(+0.0+T3_Vge_e_Tempt_GND);
#endif
Dmob_cv_Vdi_si=T3_Vdi_si;
#if defined(_DERIVATE2)
  Dmob_cv_Vdi_si_Vge_e=(+0.0+T3_Vdi_si_Vge_e);
  Dmob_cv_Vdi_si_Vdi_si=(+0.0+T3_Vdi_si_Vdi_si);
  Dmob_cv_Vdi_si_Ve_si=(+0.0+T3_Vdi_si_Ve_si);
  Dmob_cv_Vdi_si_Ve_di=(+0.0+T3_Vdi_si_Ve_di);
  Dmob_cv_Vdi_si_Vge_si=(+0.0+T3_Vdi_si_Vge_si);
  Dmob_cv_Vdi_si_Tempt_GND=(+0.0+T3_Vdi_si_Tempt_GND);
#endif
Dmob_cv_Ve_si=T3_Ve_si;
#if defined(_DERIVATE2)
  Dmob_cv_Ve_si_Vge_e=(+0.0+T3_Ve_si_Vge_e);
  Dmob_cv_Ve_si_Vdi_si=(+0.0+T3_Ve_si_Vdi_si);
  Dmob_cv_Ve_si_Ve_si=(+0.0+T3_Ve_si_Ve_si);
  Dmob_cv_Ve_si_Ve_di=(+0.0+T3_Ve_si_Ve_di);
  Dmob_cv_Ve_si_Vge_si=(+0.0+T3_Ve_si_Vge_si);
  Dmob_cv_Ve_si_Tempt_GND=(+0.0+T3_Ve_si_Tempt_GND);
#endif
Dmob_cv_Ve_di=T3_Ve_di;
#if defined(_DERIVATE2)
  Dmob_cv_Ve_di_Vge_e=(+0.0+T3_Ve_di_Vge_e);
  Dmob_cv_Ve_di_Vdi_si=(+0.0+T3_Ve_di_Vdi_si);
  Dmob_cv_Ve_di_Ve_si=(+0.0+T3_Ve_di_Ve_si);
  Dmob_cv_Ve_di_Ve_di=(+0.0+T3_Ve_di_Ve_di);
  Dmob_cv_Ve_di_Vge_si=(+0.0+T3_Ve_di_Vge_si);
  Dmob_cv_Ve_di_Tempt_GND=(+0.0+T3_Ve_di_Tempt_GND);
#endif
Dmob_cv_Vge_si=T3_Vge_si;
#if defined(_DERIVATE2)
  Dmob_cv_Vge_si_Vge_e=(+0.0+T3_Vge_si_Vge_e);
  Dmob_cv_Vge_si_Vdi_si=(+0.0+T3_Vge_si_Vdi_si);
  Dmob_cv_Vge_si_Ve_si=(+0.0+T3_Vge_si_Ve_si);
  Dmob_cv_Vge_si_Ve_di=(+0.0+T3_Vge_si_Ve_di);
  Dmob_cv_Vge_si_Vge_si=(+0.0+T3_Vge_si_Vge_si);
  Dmob_cv_Vge_si_Tempt_GND=(+0.0+T3_Vge_si_Tempt_GND);
#endif
Dmob_cv_Tempt_GND=T3_Tempt_GND;
#if defined(_DERIVATE2)
  Dmob_cv_Tempt_GND_Vge_e=(+0.0+T3_Tempt_GND_Vge_e);
  Dmob_cv_Tempt_GND_Vdi_si=(+0.0+T3_Tempt_GND_Vdi_si);
  Dmob_cv_Tempt_GND_Ve_si=(+0.0+T3_Tempt_GND_Ve_si);
  Dmob_cv_Tempt_GND_Ve_di=(+0.0+T3_Tempt_GND_Ve_di);
  Dmob_cv_Tempt_GND_Vge_si=(+0.0+T3_Tempt_GND_Vge_si);
  Dmob_cv_Tempt_GND_Tempt_GND=(+0.0+T3_Tempt_GND_Tempt_GND);
#endif
#endif
Dmob_cv=(1.0+T3);
EXIT_IF_ISNAN((1.0+T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
Dmob_cv_Vge_e=(Dmob_cv_Vge_e/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Vge_e_Vge_e=(Dmob_cv_Vge_e_Vge_e/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_e_Vdi_si=(Dmob_cv_Vge_e_Vdi_si/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_e_Ve_si=(Dmob_cv_Vge_e_Ve_si/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_e_Ve_di=(Dmob_cv_Vge_e_Ve_di/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_e_Vge_si=(Dmob_cv_Vge_e_Vge_si/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_e_Tempt_GND=(Dmob_cv_Vge_e_Tempt_GND/pModel->U0MULT-(Dmob_cv_Vge_e*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_cv_Vdi_si=(Dmob_cv_Vdi_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Vdi_si_Vge_e=(Dmob_cv_Vdi_si_Vge_e/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vdi_si_Vdi_si=(Dmob_cv_Vdi_si_Vdi_si/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vdi_si_Ve_si=(Dmob_cv_Vdi_si_Ve_si/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vdi_si_Ve_di=(Dmob_cv_Vdi_si_Ve_di/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vdi_si_Vge_si=(Dmob_cv_Vdi_si_Vge_si/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vdi_si_Tempt_GND=(Dmob_cv_Vdi_si_Tempt_GND/pModel->U0MULT-(Dmob_cv_Vdi_si*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_cv_Ve_si=(Dmob_cv_Ve_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Ve_si_Vge_e=(Dmob_cv_Ve_si_Vge_e/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_si_Vdi_si=(Dmob_cv_Ve_si_Vdi_si/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_si_Ve_si=(Dmob_cv_Ve_si_Ve_si/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_si_Ve_di=(Dmob_cv_Ve_si_Ve_di/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_si_Vge_si=(Dmob_cv_Ve_si_Vge_si/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_si_Tempt_GND=(Dmob_cv_Ve_si_Tempt_GND/pModel->U0MULT-(Dmob_cv_Ve_si*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_cv_Ve_di=(Dmob_cv_Ve_di/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Ve_di_Vge_e=(Dmob_cv_Ve_di_Vge_e/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_di_Vdi_si=(Dmob_cv_Ve_di_Vdi_si/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_di_Ve_si=(Dmob_cv_Ve_di_Ve_si/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_di_Ve_di=(Dmob_cv_Ve_di_Ve_di/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_di_Vge_si=(Dmob_cv_Ve_di_Vge_si/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Ve_di_Tempt_GND=(Dmob_cv_Ve_di_Tempt_GND/pModel->U0MULT-(Dmob_cv_Ve_di*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_cv_Vge_si=(Dmob_cv_Vge_si/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Vge_si_Vge_e=(Dmob_cv_Vge_si_Vge_e/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_si_Vdi_si=(Dmob_cv_Vge_si_Vdi_si/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_si_Ve_si=(Dmob_cv_Vge_si_Ve_si/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_si_Ve_di=(Dmob_cv_Vge_si_Ve_di/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_si_Vge_si=(Dmob_cv_Vge_si_Vge_si/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Vge_si_Tempt_GND=(Dmob_cv_Vge_si_Tempt_GND/pModel->U0MULT-(Dmob_cv_Vge_si*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
Dmob_cv_Tempt_GND=(Dmob_cv_Tempt_GND/pModel->U0MULT);
#if defined(_DERIVATE2)
  Dmob_cv_Tempt_GND_Vge_e=(Dmob_cv_Tempt_GND_Vge_e/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Vge_e*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Tempt_GND_Vdi_si=(Dmob_cv_Tempt_GND_Vdi_si/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Vdi_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Tempt_GND_Ve_si=(Dmob_cv_Tempt_GND_Ve_si/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Ve_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Tempt_GND_Ve_di=(Dmob_cv_Tempt_GND_Ve_di/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Ve_di*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Tempt_GND_Vge_si=(Dmob_cv_Tempt_GND_Vge_si/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Vge_si*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
  Dmob_cv_Tempt_GND_Tempt_GND=(Dmob_cv_Tempt_GND_Tempt_GND/pModel->U0MULT-(Dmob_cv_Tempt_GND*0.0+Dmob_cv_Tempt_GND*0.0+Dmob_cv*0.0)/pModel->U0MULT/pModel->U0MULT+2*Dmob_cv*0.0*0.0/pModel->U0MULT/pModel->U0MULT/pModel->U0MULT);
#endif
#endif
Dmob_cv=(Dmob_cv/pModel->U0MULT);
EXIT_IF_ISNAN((Dmob_cv/pModel->U0MULT))
tmp=(((DROUT_i*Leff)/scl)+1.0e-6);
EXIT_IF_ISNAN((((DROUT_i*Leff)/scl)+1.0e-6))
if
((tmp<40.0))
{
{
double m00_cosh(d00_cosh0,tmp)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
DIBLfactor_Vdi_si=(((0.5*PDIBL1_a_Vdi_si)/(d00_cosh0-1.0))+PDIBL2_a_Vdi_si);
#if defined(_DERIVATE2)
  DIBLfactor_Vdi_si_Vdi_si=(+((+0.0*PDIBL1_a+0.0*PDIBL1_a_Vdi_si+0.0*PDIBL1_a_Vdi_si+0.5*PDIBL1_a_Vdi_si_Vdi_si)/(d00_cosh0-1.0)-((0.5*PDIBL1_a_Vdi_si)*0.0+((0.5*PDIBL1_a_Vdi_si))*0.0+(0.5*PDIBL1_a)*(+0.0-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*PDIBL1_a)*0.0*0.0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0))+PDIBL2_a_Vdi_si_Vdi_si);
  DIBLfactor_Vdi_si_Tempt_GND=(+((+0.0*PDIBL1_a+0.0*PDIBL1_a_Tempt_GND+0.0*PDIBL1_a_Vdi_si+0.5*PDIBL1_a_Vdi_si_Tempt_GND)/(d00_cosh0-1.0)-((0.5*PDIBL1_a_Vdi_si)*0.0+((0.5*PDIBL1_a_Tempt_GND))*0.0+(0.5*PDIBL1_a)*(+0.0-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*PDIBL1_a)*0.0*0.0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0))+PDIBL2_a_Vdi_si_Tempt_GND);
#endif
DIBLfactor_Tempt_GND=(((0.5*PDIBL1_a_Tempt_GND)/(d00_cosh0-1.0))+PDIBL2_a_Tempt_GND);
#if defined(_DERIVATE2)
  DIBLfactor_Tempt_GND_Vdi_si=(+((+0.0*PDIBL1_a+0.0*PDIBL1_a_Vdi_si+0.0*PDIBL1_a_Tempt_GND+0.5*PDIBL1_a_Tempt_GND_Vdi_si)/(d00_cosh0-1.0)-((0.5*PDIBL1_a_Tempt_GND)*0.0+((0.5*PDIBL1_a_Vdi_si))*0.0+(0.5*PDIBL1_a)*(+0.0-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*PDIBL1_a)*0.0*0.0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0))+PDIBL2_a_Tempt_GND_Vdi_si);
  DIBLfactor_Tempt_GND_Tempt_GND=(+((+0.0*PDIBL1_a+0.0*PDIBL1_a_Tempt_GND+0.0*PDIBL1_a_Tempt_GND+0.5*PDIBL1_a_Tempt_GND_Tempt_GND)/(d00_cosh0-1.0)-((0.5*PDIBL1_a_Tempt_GND)*0.0+((0.5*PDIBL1_a_Tempt_GND))*0.0+(0.5*PDIBL1_a)*(+0.0-0.0))/(d00_cosh0-1.0)/(d00_cosh0-1.0)+2*(0.5*PDIBL1_a)*0.0*0.0/(d00_cosh0-1.0)/(d00_cosh0-1.0)/(d00_cosh0-1.0))+PDIBL2_a_Tempt_GND_Tempt_GND);
#endif
#endif
DIBLfactor=(((0.5*PDIBL1_a)/(d00_cosh0-1.0))+PDIBL2_a);
EXIT_IF_ISNAN((((0.5*PDIBL1_a)/(d00_cosh0-1.0))+PDIBL2_a))
}
}
else
{
{
double m00_exp(d00_exp0,(-tmp))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
DIBLfactor_Vdi_si=(PDIBL1_a_Vdi_si*d00_exp0+PDIBL2_a_Vdi_si);
#if defined(_DERIVATE2)
  DIBLfactor_Vdi_si_Vdi_si=(+(+PDIBL1_a_Vdi_si_Vdi_si*d00_exp0+PDIBL1_a_Vdi_si*0.0+PDIBL1_a_Vdi_si*0.0+PDIBL1_a*0.0)+PDIBL2_a_Vdi_si_Vdi_si);
  DIBLfactor_Vdi_si_Tempt_GND=(+(+PDIBL1_a_Vdi_si_Tempt_GND*d00_exp0+PDIBL1_a_Vdi_si*0.0+PDIBL1_a_Tempt_GND*0.0+PDIBL1_a*0.0)+PDIBL2_a_Vdi_si_Tempt_GND);
#endif
DIBLfactor_Tempt_GND=(PDIBL1_a_Tempt_GND*d00_exp0+PDIBL2_a_Tempt_GND);
#if defined(_DERIVATE2)
  DIBLfactor_Tempt_GND_Vdi_si=(+(+PDIBL1_a_Tempt_GND_Vdi_si*d00_exp0+PDIBL1_a_Tempt_GND*0.0+PDIBL1_a_Vdi_si*0.0+PDIBL1_a*0.0)+PDIBL2_a_Tempt_GND_Vdi_si);
  DIBLfactor_Tempt_GND_Tempt_GND=(+(+PDIBL1_a_Tempt_GND_Tempt_GND*d00_exp0+PDIBL1_a_Tempt_GND*0.0+PDIBL1_a_Tempt_GND*0.0+PDIBL1_a*0.0)+PDIBL2_a_Tempt_GND_Tempt_GND);
#endif
#endif
DIBLfactor=((PDIBL1_a*d00_exp0)+PDIBL2_a);
EXIT_IF_ISNAN(((PDIBL1_a*d00_exp0)+PDIBL2_a))
}
}
if
((PVAG_i>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
PVAGfactor_Vdi_si=(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Vdi_si_Vdi_si=(+0.0+((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Vdi_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Vdi_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_si_Ve_si=(+0.0+((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Ve_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Ve_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_si_Ve_di=(+0.0+((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Ve_di)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Ve_di/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_si_Vge_si=(+0.0+((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Vge_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Vge_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vdi_si_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Tempt_GND)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
#endif
PVAGfactor_Ve_si=(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Ve_si_Vdi_si=(+0.0+((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Vdi_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Vdi_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_si_Ve_si=(+0.0+((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Ve_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Ve_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_si_Ve_di=(+0.0+((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Ve_di)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Ve_di/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_si_Vge_si=(+0.0+((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Vge_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Vge_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_si_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Tempt_GND)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
#endif
PVAGfactor_Ve_di=(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Ve_di_Vdi_si=(+0.0+((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Vdi_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Vdi_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_di_Ve_si=(+0.0+((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Ve_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Ve_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_di_Ve_di=(+0.0+((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Ve_di)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Ve_di/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_di_Vge_si=(+0.0+((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Vge_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Vge_si/EsatL/EsatL/EsatL));
  PVAGfactor_Ve_di_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Tempt_GND)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
#endif
PVAGfactor_Vge_si=(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Vge_si_Vdi_si=(+0.0+((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Vdi_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Vdi_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vge_si_Ve_si=(+0.0+((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Ve_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Ve_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vge_si_Ve_di=(+0.0+((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Ve_di)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Ve_di/EsatL/EsatL/EsatL));
  PVAGfactor_Vge_si_Vge_si=(+0.0+((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Vge_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Vge_si/EsatL/EsatL/EsatL));
  PVAGfactor_Vge_si_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Tempt_GND)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
#endif
PVAGfactor_Tempt_GND=(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL);
#if defined(_DERIVATE2)
  PVAGfactor_Tempt_GND_Vdi_si=(+0.0+((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Vdi_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Vdi_si/EsatL/EsatL/EsatL));
  PVAGfactor_Tempt_GND_Ve_si=(+0.0+((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Ve_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Ve_si/EsatL/EsatL/EsatL));
  PVAGfactor_Tempt_GND_Ve_di=(+0.0+((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Ve_di)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Ve_di/EsatL/EsatL/EsatL));
  PVAGfactor_Tempt_GND_Vge_si=(+0.0+((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Vge_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Vge_si/EsatL/EsatL/EsatL));
  PVAGfactor_Tempt_GND_Tempt_GND=(+0.0+((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Tempt_GND)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Tempt_GND/EsatL/EsatL/EsatL));
#endif
#endif
PVAGfactor=(1.0+((PVAG_i*qia)/EsatL));
EXIT_IF_ISNAN((1.0+((PVAG_i*qia)/EsatL)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
PVAGfactor_Vdi_si=(-(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Vdi_si_Vdi_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Vdi_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_si_Ve_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Ve_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_si_Ve_di=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Ve_di)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_si_Vge_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Vge_si)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vdi_si_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PVAG_i*qia_Vdi_si_Tempt_GND)/EsatL-((PVAG_i*qia_Vdi_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vdi_si+(PVAG_i*qia)*EsatL_Vdi_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vdi_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vdi_si)*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Ve_si=(-(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Ve_si_Vdi_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Vdi_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_si_Ve_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Ve_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_si_Ve_di=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Ve_di)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_si_Vge_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Vge_si)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_si_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PVAG_i*qia_Ve_si_Tempt_GND)/EsatL-((PVAG_i*qia_Ve_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Ve_si+(PVAG_i*qia)*EsatL_Ve_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_si)*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Ve_di=(-(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Ve_di_Vdi_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Vdi_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_di_Ve_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Ve_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_di_Ve_di=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Ve_di)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_di_Vge_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Vge_si)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Ve_di_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PVAG_i*qia_Ve_di_Tempt_GND)/EsatL-((PVAG_i*qia_Ve_di)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Ve_di+(PVAG_i*qia)*EsatL_Ve_di_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Ve_di*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Ve_di)*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Vge_si=(-(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Vge_si_Vdi_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Vdi_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vge_si_Ve_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Ve_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vge_si_Ve_di=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Ve_di)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vge_si_Vge_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Vge_si)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Vge_si_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PVAG_i*qia_Vge_si_Tempt_GND)/EsatL-((PVAG_i*qia_Vge_si)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Vge_si+(PVAG_i*qia)*EsatL_Vge_si_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Vge_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Vge_si)*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
PVAGfactor_Tempt_GND=(-(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#if defined(_DERIVATE2)
  PVAGfactor_Tempt_GND_Vdi_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Vdi_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Vdi_si+((PVAG_i*qia_Vdi_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Vdi_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))*(-((((PVAG_i*qia_Vdi_si))*EsatL-(PVAG_i*qia)*EsatL_Vdi_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Tempt_GND_Ve_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Ve_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Ve_si+((PVAG_i*qia_Ve_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Ve_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_si))*EsatL-(PVAG_i*qia)*EsatL_Ve_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Tempt_GND_Ve_di=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Ve_di)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Ve_di+((PVAG_i*qia_Ve_di))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Ve_di)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))*(-((((PVAG_i*qia_Ve_di))*EsatL-(PVAG_i*qia)*EsatL_Ve_di)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Tempt_GND_Vge_si=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Vge_si)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Vge_si+((PVAG_i*qia_Vge_si))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Vge_si)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))*(-((((PVAG_i*qia_Vge_si))*EsatL-(PVAG_i*qia)*EsatL_Vge_si)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
  PVAGfactor_Tempt_GND_Tempt_GND=(0.0/(1.0-((PVAG_i*qia)/EsatL))-(0.0*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+0.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))+1.0*(+0.0-((+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PVAG_i*qia_Tempt_GND_Tempt_GND)/EsatL-((PVAG_i*qia_Tempt_GND)*EsatL_Tempt_GND+((PVAG_i*qia_Tempt_GND))*EsatL_Tempt_GND+(PVAG_i*qia)*EsatL_Tempt_GND_Tempt_GND)/EsatL/EsatL+2*(PVAG_i*qia)*EsatL_Tempt_GND*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))+2*1.0*(-(((PVAG_i*qia_Tempt_GND)*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))*(-((((PVAG_i*qia_Tempt_GND))*EsatL-(PVAG_i*qia)*EsatL_Tempt_GND)/EsatL/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL))/(1.0-((PVAG_i*qia)/EsatL)));
#endif
#endif
PVAGfactor=(1.0/(1.0-((PVAG_i*qia)/EsatL)));
EXIT_IF_ISNAN((1.0/(1.0-((PVAG_i*qia)/EsatL))))
}
if
((Vdseff>vds))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Vdseff_Vdi_si=vds_Vdi_si;
#if defined(_DERIVATE2)
  Vdseff_Vdi_si_Vdi_si=vds_Vdi_si_Vdi_si;
  Vdseff_Vdi_si_Ve_si=0.0;
  Vdseff_Vdi_si_Ve_di=0.0;
  Vdseff_Vdi_si_Vge_si=0.0;
  Vdseff_Vdi_si_Tempt_GND=0.0;
#endif
Vdseff_Ve_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Ve_si_Vdi_si=0.0;
  Vdseff_Ve_si_Ve_si=0.0;
  Vdseff_Ve_si_Ve_di=0.0;
  Vdseff_Ve_si_Vge_si=0.0;
  Vdseff_Ve_si_Tempt_GND=0.0;
#endif
Vdseff_Ve_di=0.0;
#if defined(_DERIVATE2)
  Vdseff_Ve_di_Vdi_si=0.0;
  Vdseff_Ve_di_Ve_si=0.0;
  Vdseff_Ve_di_Ve_di=0.0;
  Vdseff_Ve_di_Vge_si=0.0;
  Vdseff_Ve_di_Tempt_GND=0.0;
#endif
Vdseff_Vge_si=0.0;
#if defined(_DERIVATE2)
  Vdseff_Vge_si_Vdi_si=0.0;
  Vdseff_Vge_si_Ve_si=0.0;
  Vdseff_Vge_si_Ve_di=0.0;
  Vdseff_Vge_si_Vge_si=0.0;
  Vdseff_Vge_si_Tempt_GND=0.0;
#endif
Vdseff_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Vdseff_Tempt_GND_Vdi_si=0.0;
  Vdseff_Tempt_GND_Ve_si=0.0;
  Vdseff_Tempt_GND_Ve_di=0.0;
  Vdseff_Tempt_GND_Vge_si=0.0;
  Vdseff_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Vdseff=vds;
EXIT_IF_ISNAN(vds)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
diffVds_Vdi_si=(vds_Vdi_si-Vdseff_Vdi_si);
#if defined(_DERIVATE2)
  diffVds_Vdi_si_Vdi_si=(+vds_Vdi_si_Vdi_si-Vdseff_Vdi_si_Vdi_si);
  diffVds_Vdi_si_Ve_si=(+0.0-Vdseff_Vdi_si_Ve_si);
  diffVds_Vdi_si_Ve_di=(+0.0-Vdseff_Vdi_si_Ve_di);
  diffVds_Vdi_si_Vge_si=(+0.0-Vdseff_Vdi_si_Vge_si);
  diffVds_Vdi_si_Tempt_GND=(+0.0-Vdseff_Vdi_si_Tempt_GND);
#endif
diffVds_Ve_si=(-Vdseff_Ve_si);
#if defined(_DERIVATE2)
  diffVds_Ve_si_Vdi_si=(+0.0-Vdseff_Ve_si_Vdi_si);
  diffVds_Ve_si_Ve_si=(+0.0-Vdseff_Ve_si_Ve_si);
  diffVds_Ve_si_Ve_di=(+0.0-Vdseff_Ve_si_Ve_di);
  diffVds_Ve_si_Vge_si=(+0.0-Vdseff_Ve_si_Vge_si);
  diffVds_Ve_si_Tempt_GND=(+0.0-Vdseff_Ve_si_Tempt_GND);
#endif
diffVds_Ve_di=(-Vdseff_Ve_di);
#if defined(_DERIVATE2)
  diffVds_Ve_di_Vdi_si=(+0.0-Vdseff_Ve_di_Vdi_si);
  diffVds_Ve_di_Ve_si=(+0.0-Vdseff_Ve_di_Ve_si);
  diffVds_Ve_di_Ve_di=(+0.0-Vdseff_Ve_di_Ve_di);
  diffVds_Ve_di_Vge_si=(+0.0-Vdseff_Ve_di_Vge_si);
  diffVds_Ve_di_Tempt_GND=(+0.0-Vdseff_Ve_di_Tempt_GND);
#endif
diffVds_Vge_si=(-Vdseff_Vge_si);
#if defined(_DERIVATE2)
  diffVds_Vge_si_Vdi_si=(+0.0-Vdseff_Vge_si_Vdi_si);
  diffVds_Vge_si_Ve_si=(+0.0-Vdseff_Vge_si_Ve_si);
  diffVds_Vge_si_Ve_di=(+0.0-Vdseff_Vge_si_Ve_di);
  diffVds_Vge_si_Vge_si=(+0.0-Vdseff_Vge_si_Vge_si);
  diffVds_Vge_si_Tempt_GND=(+0.0-Vdseff_Vge_si_Tempt_GND);
#endif
diffVds_Tempt_GND=(-Vdseff_Tempt_GND);
#if defined(_DERIVATE2)
  diffVds_Tempt_GND_Vdi_si=(+0.0-Vdseff_Tempt_GND_Vdi_si);
  diffVds_Tempt_GND_Ve_si=(+0.0-Vdseff_Tempt_GND_Ve_si);
  diffVds_Tempt_GND_Ve_di=(+0.0-Vdseff_Tempt_GND_Ve_di);
  diffVds_Tempt_GND_Vge_si=(+0.0-Vdseff_Tempt_GND_Vge_si);
  diffVds_Tempt_GND_Tempt_GND=(+0.0-Vdseff_Tempt_GND_Tempt_GND);
#endif
#endif
diffVds=(vds-Vdseff);
EXIT_IF_ISNAN((vds-Vdseff))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Vgst2Vtm_Vdi_si=qia_Vdi_si;
#if defined(_DERIVATE2)
  Vgst2Vtm_Vdi_si_Vdi_si=(+qia_Vdi_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vdi_si_Ve_si=(+qia_Vdi_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vdi_si_Ve_di=(+qia_Vdi_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vdi_si_Vge_si=(+qia_Vdi_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vdi_si_Tempt_GND=(+qia_Vdi_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
Vgst2Vtm_Ve_si=qia_Ve_si;
#if defined(_DERIVATE2)
  Vgst2Vtm_Ve_si_Vdi_si=(+qia_Ve_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_si_Ve_si=(+qia_Ve_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_si_Ve_di=(+qia_Ve_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_si_Vge_si=(+qia_Ve_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_si_Tempt_GND=(+qia_Ve_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
Vgst2Vtm_Ve_di=qia_Ve_di;
#if defined(_DERIVATE2)
  Vgst2Vtm_Ve_di_Vdi_si=(+qia_Ve_di_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_di_Ve_si=(+qia_Ve_di_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_di_Ve_di=(+qia_Ve_di_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_di_Vge_si=(+qia_Ve_di_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Ve_di_Tempt_GND=(+qia_Ve_di_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
Vgst2Vtm_Vge_si=qia_Vge_si;
#if defined(_DERIVATE2)
  Vgst2Vtm_Vge_si_Vdi_si=(+qia_Vge_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vge_si_Ve_si=(+qia_Vge_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vge_si_Ve_di=(+qia_Vge_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vge_si_Vge_si=(+qia_Vge_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0));
  Vgst2Vtm_Vge_si_Tempt_GND=(+qia_Vge_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0));
#endif
Vgst2Vtm_Tempt_GND=(qia_Tempt_GND+(2.0*Vtm_Tempt_GND));
#if defined(_DERIVATE2)
  Vgst2Vtm_Tempt_GND_Vdi_si=(+qia_Tempt_GND_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0));
  Vgst2Vtm_Tempt_GND_Ve_si=(+qia_Tempt_GND_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0));
  Vgst2Vtm_Tempt_GND_Ve_di=(+qia_Tempt_GND_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0));
  Vgst2Vtm_Tempt_GND_Vge_si=(+qia_Tempt_GND_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0));
  Vgst2Vtm_Tempt_GND_Tempt_GND=(+qia_Tempt_GND_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+2.0*Vtm_Tempt_GND_Tempt_GND));
#endif
#endif
Vgst2Vtm=(qia+(2.0*Vtm));
EXIT_IF_ISNAN((qia+(2.0*Vtm)))
if
((DIBLfactor>0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=Vgst2Vtm_Ve_si;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=Vgst2Vtm_Ve_si_Ve_si;
  T1_Ve_si_Ve_di=Vgst2Vtm_Ve_si_Ve_di;
  T1_Ve_si_Vge_si=Vgst2Vtm_Ve_si_Vge_si;
  T1_Ve_si_Vdi_si=Vgst2Vtm_Ve_si_Vdi_si;
  T1_Ve_si_Tempt_GND=Vgst2Vtm_Ve_si_Tempt_GND;
#endif
T1_Ve_di=Vgst2Vtm_Ve_di;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=Vgst2Vtm_Ve_di_Ve_si;
  T1_Ve_di_Ve_di=Vgst2Vtm_Ve_di_Ve_di;
  T1_Ve_di_Vge_si=Vgst2Vtm_Ve_di_Vge_si;
  T1_Ve_di_Vdi_si=Vgst2Vtm_Ve_di_Vdi_si;
  T1_Ve_di_Tempt_GND=Vgst2Vtm_Ve_di_Tempt_GND;
#endif
T1_Vge_si=Vgst2Vtm_Vge_si;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=Vgst2Vtm_Vge_si_Ve_si;
  T1_Vge_si_Ve_di=Vgst2Vtm_Vge_si_Ve_di;
  T1_Vge_si_Vge_si=Vgst2Vtm_Vge_si_Vge_si;
  T1_Vge_si_Vdi_si=Vgst2Vtm_Vge_si_Vdi_si;
  T1_Vge_si_Tempt_GND=Vgst2Vtm_Vge_si_Tempt_GND;
#endif
T1_Vdi_si=Vgst2Vtm_Vdi_si;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=Vgst2Vtm_Vdi_si_Ve_si;
  T1_Vdi_si_Ve_di=Vgst2Vtm_Vdi_si_Ve_di;
  T1_Vdi_si_Vge_si=Vgst2Vtm_Vdi_si_Vge_si;
  T1_Vdi_si_Vdi_si=Vgst2Vtm_Vdi_si_Vdi_si;
  T1_Vdi_si_Tempt_GND=Vgst2Vtm_Vdi_si_Tempt_GND;
#endif
T1_Tempt_GND=Vgst2Vtm_Tempt_GND;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=Vgst2Vtm_Tempt_GND_Ve_si;
  T1_Tempt_GND_Ve_di=Vgst2Vtm_Tempt_GND_Ve_di;
  T1_Tempt_GND_Vge_si=Vgst2Vtm_Tempt_GND_Vge_si;
  T1_Tempt_GND_Vdi_si=Vgst2Vtm_Tempt_GND_Vdi_si;
  T1_Tempt_GND_Tempt_GND=Vgst2Vtm_Tempt_GND_Tempt_GND;
#endif
#endif
T1=Vgst2Vtm;
EXIT_IF_ISNAN(Vgst2Vtm)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=((T1_Vge_e*(Vdsat+T1)-T1*T1_Vge_e)/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(T1_Vge_e_Vdi_d/(Vdsat+T1)-(T1_Vge_e*T1_Vdi_d+T1_Vdi_d*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Vsi_s=(T1_Vge_e_Vsi_s/(Vdsat+T1)-(T1_Vge_e*T1_Vsi_s+T1_Vsi_s*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Vge_di=(T1_Vge_e_Vge_di/(Vdsat+T1)-(T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Vge_e=(T1_Vge_e_Vge_e/(Vdsat+T1)-(T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Vdi_si=(T1_Vge_e_Vdi_si/(Vdsat+T1)-(T1_Vge_e*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Ve_si=(T1_Vge_e_Ve_si/(Vdsat+T1)-(T1_Vge_e*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*T1_Vge_e+T1*(+0.0+T1_Vge_e_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Ve_di=(T1_Vge_e_Ve_di/(Vdsat+T1)-(T1_Vge_e*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*T1_Vge_e+T1*(+0.0+T1_Vge_e_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Vge_si=(T1_Vge_e_Vge_si/(Vdsat+T1)-(T1_Vge_e*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*T1_Vge_e+T1*(+0.0+T1_Vge_e_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_e_Tempt_GND=(T1_Vge_e_Tempt_GND/(Vdsat+T1)-(T1_Vge_e*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*T1_Vge_e+T1*(+0.0+T1_Vge_e_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*T1_Vge_e*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
T3_Vdi_si=((T1_Vdi_si*(Vdsat+T1)-T1*(Vdsat_Vdi_si+T1_Vdi_si))/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(T1_Vdi_si_Vdi_d/(Vdsat+T1)-(T1_Vdi_si*T1_Vdi_d+T1_Vdi_d*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+0.0+T1_Vdi_si_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Vsi_s=(T1_Vdi_si_Vsi_s/(Vdsat+T1)-(T1_Vdi_si*T1_Vsi_s+T1_Vsi_s*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+0.0+T1_Vdi_si_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Vge_di=(T1_Vdi_si_Vge_di/(Vdsat+T1)-(T1_Vdi_si*T1_Vge_di+T1_Vge_di*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+0.0+T1_Vdi_si_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Vge_e=(T1_Vdi_si_Vge_e/(Vdsat+T1)-(T1_Vdi_si*T1_Vge_e+T1_Vge_e*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+0.0+T1_Vdi_si_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Vdi_si=(T1_Vdi_si_Vdi_si/(Vdsat+T1)-(T1_Vdi_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+Vdsat_Vdi_si_Vdi_si+T1_Vdi_si_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Ve_si=(T1_Vdi_si_Ve_si/(Vdsat+T1)-(T1_Vdi_si*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+Vdsat_Vdi_si_Ve_si+T1_Vdi_si_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Ve_di=(T1_Vdi_si_Ve_di/(Vdsat+T1)-(T1_Vdi_si*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+Vdsat_Vdi_si_Ve_di+T1_Vdi_si_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Vge_si=(T1_Vdi_si_Vge_si/(Vdsat+T1)-(T1_Vdi_si*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+Vdsat_Vdi_si_Vge_si+T1_Vdi_si_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vdi_si_Tempt_GND=(T1_Vdi_si_Tempt_GND/(Vdsat+T1)-(T1_Vdi_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*(Vdsat_Vdi_si+T1_Vdi_si)+T1*(+Vdsat_Vdi_si_Tempt_GND+T1_Vdi_si_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vdi_si+T1_Vdi_si)*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
T3_Ve_si=((T1_Ve_si*(Vdsat+T1)-T1*(Vdsat_Ve_si+T1_Ve_si))/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(T1_Ve_si_Vdi_d/(Vdsat+T1)-(T1_Ve_si*T1_Vdi_d+T1_Vdi_d*(Vdsat_Ve_si+T1_Ve_si)+T1*(+0.0+T1_Ve_si_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Vsi_s=(T1_Ve_si_Vsi_s/(Vdsat+T1)-(T1_Ve_si*T1_Vsi_s+T1_Vsi_s*(Vdsat_Ve_si+T1_Ve_si)+T1*(+0.0+T1_Ve_si_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Vge_di=(T1_Ve_si_Vge_di/(Vdsat+T1)-(T1_Ve_si*T1_Vge_di+T1_Vge_di*(Vdsat_Ve_si+T1_Ve_si)+T1*(+0.0+T1_Ve_si_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Vge_e=(T1_Ve_si_Vge_e/(Vdsat+T1)-(T1_Ve_si*T1_Vge_e+T1_Vge_e*(Vdsat_Ve_si+T1_Ve_si)+T1*(+0.0+T1_Ve_si_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Vdi_si=(T1_Ve_si_Vdi_si/(Vdsat+T1)-(T1_Ve_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*(Vdsat_Ve_si+T1_Ve_si)+T1*(+Vdsat_Ve_si_Vdi_si+T1_Ve_si_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Ve_si=(T1_Ve_si_Ve_si/(Vdsat+T1)-(T1_Ve_si*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*(Vdsat_Ve_si+T1_Ve_si)+T1*(+Vdsat_Ve_si_Ve_si+T1_Ve_si_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Ve_di=(T1_Ve_si_Ve_di/(Vdsat+T1)-(T1_Ve_si*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*(Vdsat_Ve_si+T1_Ve_si)+T1*(+Vdsat_Ve_si_Ve_di+T1_Ve_si_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Vge_si=(T1_Ve_si_Vge_si/(Vdsat+T1)-(T1_Ve_si*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*(Vdsat_Ve_si+T1_Ve_si)+T1*(+Vdsat_Ve_si_Vge_si+T1_Ve_si_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_si_Tempt_GND=(T1_Ve_si_Tempt_GND/(Vdsat+T1)-(T1_Ve_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*(Vdsat_Ve_si+T1_Ve_si)+T1*(+Vdsat_Ve_si_Tempt_GND+T1_Ve_si_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_si+T1_Ve_si)*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
T3_Ve_di=((T1_Ve_di*(Vdsat+T1)-T1*(Vdsat_Ve_di+T1_Ve_di))/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(T1_Ve_di_Vdi_d/(Vdsat+T1)-(T1_Ve_di*T1_Vdi_d+T1_Vdi_d*(Vdsat_Ve_di+T1_Ve_di)+T1*(+0.0+T1_Ve_di_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Vsi_s=(T1_Ve_di_Vsi_s/(Vdsat+T1)-(T1_Ve_di*T1_Vsi_s+T1_Vsi_s*(Vdsat_Ve_di+T1_Ve_di)+T1*(+0.0+T1_Ve_di_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Vge_di=(T1_Ve_di_Vge_di/(Vdsat+T1)-(T1_Ve_di*T1_Vge_di+T1_Vge_di*(Vdsat_Ve_di+T1_Ve_di)+T1*(+0.0+T1_Ve_di_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Vge_e=(T1_Ve_di_Vge_e/(Vdsat+T1)-(T1_Ve_di*T1_Vge_e+T1_Vge_e*(Vdsat_Ve_di+T1_Ve_di)+T1*(+0.0+T1_Ve_di_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Vdi_si=(T1_Ve_di_Vdi_si/(Vdsat+T1)-(T1_Ve_di*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*(Vdsat_Ve_di+T1_Ve_di)+T1*(+Vdsat_Ve_di_Vdi_si+T1_Ve_di_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Ve_si=(T1_Ve_di_Ve_si/(Vdsat+T1)-(T1_Ve_di*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*(Vdsat_Ve_di+T1_Ve_di)+T1*(+Vdsat_Ve_di_Ve_si+T1_Ve_di_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Ve_di=(T1_Ve_di_Ve_di/(Vdsat+T1)-(T1_Ve_di*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*(Vdsat_Ve_di+T1_Ve_di)+T1*(+Vdsat_Ve_di_Ve_di+T1_Ve_di_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Vge_si=(T1_Ve_di_Vge_si/(Vdsat+T1)-(T1_Ve_di*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*(Vdsat_Ve_di+T1_Ve_di)+T1*(+Vdsat_Ve_di_Vge_si+T1_Ve_di_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Ve_di_Tempt_GND=(T1_Ve_di_Tempt_GND/(Vdsat+T1)-(T1_Ve_di*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*(Vdsat_Ve_di+T1_Ve_di)+T1*(+Vdsat_Ve_di_Tempt_GND+T1_Ve_di_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Ve_di+T1_Ve_di)*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
T3_Vge_si=((T1_Vge_si*(Vdsat+T1)-T1*(Vdsat_Vge_si+T1_Vge_si))/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(T1_Vge_si_Vdi_d/(Vdsat+T1)-(T1_Vge_si*T1_Vdi_d+T1_Vdi_d*(Vdsat_Vge_si+T1_Vge_si)+T1*(+0.0+T1_Vge_si_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Vsi_s=(T1_Vge_si_Vsi_s/(Vdsat+T1)-(T1_Vge_si*T1_Vsi_s+T1_Vsi_s*(Vdsat_Vge_si+T1_Vge_si)+T1*(+0.0+T1_Vge_si_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Vge_di=(T1_Vge_si_Vge_di/(Vdsat+T1)-(T1_Vge_si*T1_Vge_di+T1_Vge_di*(Vdsat_Vge_si+T1_Vge_si)+T1*(+0.0+T1_Vge_si_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Vge_e=(T1_Vge_si_Vge_e/(Vdsat+T1)-(T1_Vge_si*T1_Vge_e+T1_Vge_e*(Vdsat_Vge_si+T1_Vge_si)+T1*(+0.0+T1_Vge_si_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Vdi_si=(T1_Vge_si_Vdi_si/(Vdsat+T1)-(T1_Vge_si*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*(Vdsat_Vge_si+T1_Vge_si)+T1*(+Vdsat_Vge_si_Vdi_si+T1_Vge_si_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Ve_si=(T1_Vge_si_Ve_si/(Vdsat+T1)-(T1_Vge_si*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*(Vdsat_Vge_si+T1_Vge_si)+T1*(+Vdsat_Vge_si_Ve_si+T1_Vge_si_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Ve_di=(T1_Vge_si_Ve_di/(Vdsat+T1)-(T1_Vge_si*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*(Vdsat_Vge_si+T1_Vge_si)+T1*(+Vdsat_Vge_si_Ve_di+T1_Vge_si_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Vge_si=(T1_Vge_si_Vge_si/(Vdsat+T1)-(T1_Vge_si*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*(Vdsat_Vge_si+T1_Vge_si)+T1*(+Vdsat_Vge_si_Vge_si+T1_Vge_si_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Vge_si_Tempt_GND=(T1_Vge_si_Tempt_GND/(Vdsat+T1)-(T1_Vge_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*(Vdsat_Vge_si+T1_Vge_si)+T1*(+Vdsat_Vge_si_Tempt_GND+T1_Vge_si_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Vge_si+T1_Vge_si)*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
T3_Tempt_GND=((T1_Tempt_GND*(Vdsat+T1)-T1*(Vdsat_Tempt_GND+T1_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(T1_Tempt_GND_Vdi_d/(Vdsat+T1)-(T1_Tempt_GND*T1_Vdi_d+T1_Vdi_d*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+0.0+T1_Tempt_GND_Vdi_d))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*T1_Vdi_d/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Vsi_s=(T1_Tempt_GND_Vsi_s/(Vdsat+T1)-(T1_Tempt_GND*T1_Vsi_s+T1_Vsi_s*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+0.0+T1_Tempt_GND_Vsi_s))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*T1_Vsi_s/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Vge_di=(T1_Tempt_GND_Vge_di/(Vdsat+T1)-(T1_Tempt_GND*T1_Vge_di+T1_Vge_di*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+0.0+T1_Tempt_GND_Vge_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*T1_Vge_di/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Vge_e=(T1_Tempt_GND_Vge_e/(Vdsat+T1)-(T1_Tempt_GND*T1_Vge_e+T1_Vge_e*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+0.0+T1_Tempt_GND_Vge_e))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*T1_Vge_e/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Vdi_si=(T1_Tempt_GND_Vdi_si/(Vdsat+T1)-(T1_Tempt_GND*(Vdsat_Vdi_si+T1_Vdi_si)+T1_Vdi_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+Vdsat_Tempt_GND_Vdi_si+T1_Tempt_GND_Vdi_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*(Vdsat_Vdi_si+T1_Vdi_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Ve_si=(T1_Tempt_GND_Ve_si/(Vdsat+T1)-(T1_Tempt_GND*(Vdsat_Ve_si+T1_Ve_si)+T1_Ve_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+Vdsat_Tempt_GND_Ve_si+T1_Tempt_GND_Ve_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*(Vdsat_Ve_si+T1_Ve_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Ve_di=(T1_Tempt_GND_Ve_di/(Vdsat+T1)-(T1_Tempt_GND*(Vdsat_Ve_di+T1_Ve_di)+T1_Ve_di*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+Vdsat_Tempt_GND_Ve_di+T1_Tempt_GND_Ve_di))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*(Vdsat_Ve_di+T1_Ve_di)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Vge_si=(T1_Tempt_GND_Vge_si/(Vdsat+T1)-(T1_Tempt_GND*(Vdsat_Vge_si+T1_Vge_si)+T1_Vge_si*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+Vdsat_Tempt_GND_Vge_si+T1_Tempt_GND_Vge_si))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*(Vdsat_Vge_si+T1_Vge_si)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
  T3_Tempt_GND_Tempt_GND=(T1_Tempt_GND_Tempt_GND/(Vdsat+T1)-(T1_Tempt_GND*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1_Tempt_GND*(Vdsat_Tempt_GND+T1_Tempt_GND)+T1*(+Vdsat_Tempt_GND_Tempt_GND+T1_Tempt_GND_Tempt_GND))/(Vdsat+T1)/(Vdsat+T1)+2*T1*(Vdsat_Tempt_GND+T1_Tempt_GND)*(Vdsat_Tempt_GND+T1_Tempt_GND)/(Vdsat+T1)/(Vdsat+T1)/(Vdsat+T1));
#endif
#endif
T3=(T1/(Vdsat+T1));
EXIT_IF_ISNAN((T1/(Vdsat+T1)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
VaDIBL_Vge_e=(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor;
#if defined(_DERIVATE2)
  VaDIBL_Vge_e_Vge_e=(+(+(T1_Vge_e_Vge_e/DIBLfactor-(T1_Vge_e*0.0+T1_Vge_e*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Vge_e)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*0.0+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_e_Ve_si=(+(+(T1_Vge_e_Ve_si/DIBLfactor-(T1_Vge_e*0.0+T1_Ve_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Ve_si)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*0.0+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_e_Ve_di=(+(+(T1_Vge_e_Ve_di/DIBLfactor-(T1_Vge_e*0.0+T1_Ve_di*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Ve_di)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*0.0+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_e_Vge_si=(+(+(T1_Vge_e_Vge_si/DIBLfactor-(T1_Vge_e*0.0+T1_Vge_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Vge_si)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*0.0+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_e_Vdi_si=(+(+(T1_Vge_e_Vdi_si/DIBLfactor-(T1_Vge_e*DIBLfactor_Vdi_si+T1_Vdi_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Vdi_si)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*0.0+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_e_Tempt_GND=(+(+(T1_Vge_e_Tempt_GND/DIBLfactor-(T1_Vge_e*DIBLfactor_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_e/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vge_e+(T1/DIBLfactor)*T3_Vge_e_Tempt_GND)*PVAGfactor+(((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*0.0+((T1/DIBLfactor)*T3)*0.0);
#endif
VaDIBL_Ve_si=(((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor)+(((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si));
#if defined(_DERIVATE2)
  VaDIBL_Ve_si_Vge_e=(+(+(T1_Ve_si_Vge_e/DIBLfactor-(T1_Ve_si*0.0+T1_Vge_e*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Vge_e)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Ve_si_Ve_si=(+(+(T1_Ve_si_Ve_si/DIBLfactor-(T1_Ve_si*0.0+T1_Ve_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Ve_si)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si_Ve_si);
  VaDIBL_Ve_si_Ve_di=(+(+(T1_Ve_si_Ve_di/DIBLfactor-(T1_Ve_si*0.0+T1_Ve_di*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Ve_di)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si_Ve_di);
  VaDIBL_Ve_si_Vge_si=(+(+(T1_Ve_si_Vge_si/DIBLfactor-(T1_Ve_si*0.0+T1_Vge_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Vge_si)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si_Vge_si);
  VaDIBL_Ve_si_Vdi_si=(+(+(T1_Ve_si_Vdi_si/DIBLfactor-(T1_Ve_si*DIBLfactor_Vdi_si+T1_Vdi_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Vdi_si)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si_Vdi_si);
  VaDIBL_Ve_si_Tempt_GND=(+(+(T1_Ve_si_Tempt_GND/DIBLfactor-(T1_Ve_si*DIBLfactor_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_si/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Ve_si+(T1/DIBLfactor)*T3_Ve_si_Tempt_GND)*PVAGfactor+(((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Ve_si+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_si_Tempt_GND);
#endif
VaDIBL_Ve_di=(((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor)+(((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di));
#if defined(_DERIVATE2)
  VaDIBL_Ve_di_Vge_e=(+(+(T1_Ve_di_Vge_e/DIBLfactor-(T1_Ve_di*0.0+T1_Vge_e*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Vge_e)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Ve_di_Ve_si=(+(+(T1_Ve_di_Ve_si/DIBLfactor-(T1_Ve_di*0.0+T1_Ve_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Ve_si)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di_Ve_si);
  VaDIBL_Ve_di_Ve_di=(+(+(T1_Ve_di_Ve_di/DIBLfactor-(T1_Ve_di*0.0+T1_Ve_di*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Ve_di)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di_Ve_di);
  VaDIBL_Ve_di_Vge_si=(+(+(T1_Ve_di_Vge_si/DIBLfactor-(T1_Ve_di*0.0+T1_Vge_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Vge_si)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di_Vge_si);
  VaDIBL_Ve_di_Vdi_si=(+(+(T1_Ve_di_Vdi_si/DIBLfactor-(T1_Ve_di*DIBLfactor_Vdi_si+T1_Vdi_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Vdi_si)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di_Vdi_si);
  VaDIBL_Ve_di_Tempt_GND=(+(+(T1_Ve_di_Tempt_GND/DIBLfactor-(T1_Ve_di*DIBLfactor_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Ve_di/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Ve_di+(T1/DIBLfactor)*T3_Ve_di_Tempt_GND)*PVAGfactor+(((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Ve_di+((T1/DIBLfactor)*T3)*PVAGfactor_Ve_di_Tempt_GND);
#endif
VaDIBL_Vge_si=(((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor)+(((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si));
#if defined(_DERIVATE2)
  VaDIBL_Vge_si_Vge_e=(+(+(T1_Vge_si_Vge_e/DIBLfactor-(T1_Vge_si*0.0+T1_Vge_e*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Vge_e)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vge_si_Ve_si=(+(+(T1_Vge_si_Ve_si/DIBLfactor-(T1_Vge_si*0.0+T1_Ve_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Ve_si)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si_Ve_si);
  VaDIBL_Vge_si_Ve_di=(+(+(T1_Vge_si_Ve_di/DIBLfactor-(T1_Vge_si*0.0+T1_Ve_di*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Ve_di)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si_Ve_di);
  VaDIBL_Vge_si_Vge_si=(+(+(T1_Vge_si_Vge_si/DIBLfactor-(T1_Vge_si*0.0+T1_Vge_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Vge_si)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si_Vge_si);
  VaDIBL_Vge_si_Vdi_si=(+(+(T1_Vge_si_Vdi_si/DIBLfactor-(T1_Vge_si*DIBLfactor_Vdi_si+T1_Vdi_si*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Vdi_si)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si_Vdi_si);
  VaDIBL_Vge_si_Tempt_GND=(+(+(T1_Vge_si_Tempt_GND/DIBLfactor-(T1_Vge_si*DIBLfactor_Tempt_GND+T1_Tempt_GND*0.0+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*0.0*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+(T1_Vge_si/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vge_si+(T1/DIBLfactor)*T3_Vge_si_Tempt_GND)*PVAGfactor+(((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Vge_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vge_si_Tempt_GND);
#endif
VaDIBL_Vdi_si=((((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor)+(((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si));
#if defined(_DERIVATE2)
  VaDIBL_Vdi_si_Vge_e=(+(+(T1_Vdi_si_Vge_e/DIBLfactor-(T1_Vdi_si*0.0+T1_Vge_e*DIBLfactor_Vdi_si+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Vge_e)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Vdi_si_Ve_si=(+(+(T1_Vdi_si_Ve_si/DIBLfactor-(T1_Vdi_si*0.0+T1_Ve_si*DIBLfactor_Vdi_si+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Ve_si)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si_Ve_si);
  VaDIBL_Vdi_si_Ve_di=(+(+(T1_Vdi_si_Ve_di/DIBLfactor-(T1_Vdi_si*0.0+T1_Ve_di*DIBLfactor_Vdi_si+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Ve_di)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si_Ve_di);
  VaDIBL_Vdi_si_Vge_si=(+(+(T1_Vdi_si_Vge_si/DIBLfactor-(T1_Vdi_si*0.0+T1_Vge_si*DIBLfactor_Vdi_si+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Vge_si)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si_Vge_si);
  VaDIBL_Vdi_si_Vdi_si=(+(+(T1_Vdi_si_Vdi_si/DIBLfactor-(T1_Vdi_si*DIBLfactor_Vdi_si+T1_Vdi_si*DIBLfactor_Vdi_si+T1*DIBLfactor_Vdi_si_Vdi_si)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Vdi_si)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si_Vdi_si);
  VaDIBL_Vdi_si_Tempt_GND=(+(+(T1_Vdi_si_Tempt_GND/DIBLfactor-(T1_Vdi_si*DIBLfactor_Tempt_GND+T1_Tempt_GND*DIBLfactor_Vdi_si+T1*DIBLfactor_Vdi_si_Tempt_GND)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Vdi_si*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vdi_si+(T1/DIBLfactor)*T3_Vdi_si_Tempt_GND)*PVAGfactor+((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Vdi_si+((T1/DIBLfactor)*T3)*PVAGfactor_Vdi_si_Tempt_GND);
#endif
VaDIBL_Tempt_GND=((((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor)+(((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND));
#if defined(_DERIVATE2)
  VaDIBL_Tempt_GND_Vge_e=(+(+(T1_Tempt_GND_Vge_e/DIBLfactor-(T1_Tempt_GND*0.0+T1_Vge_e*DIBLfactor_Tempt_GND+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vge_e+(T1_Vge_e/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Vge_e)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*0.0+((((T1_Vge_e/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_e)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*0.0);
  VaDIBL_Tempt_GND_Ve_si=(+(+(T1_Tempt_GND_Ve_si/DIBLfactor-(T1_Tempt_GND*0.0+T1_Ve_si*DIBLfactor_Tempt_GND+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Ve_si+(T1_Ve_si/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Ve_si)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor_Ve_si+((((T1_Ve_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_si)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND_Ve_si);
  VaDIBL_Tempt_GND_Ve_di=(+(+(T1_Tempt_GND_Ve_di/DIBLfactor-(T1_Tempt_GND*0.0+T1_Ve_di*DIBLfactor_Tempt_GND+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Ve_di+(T1_Ve_di/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Ve_di)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor_Ve_di+((((T1_Ve_di/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Ve_di)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND_Ve_di);
  VaDIBL_Tempt_GND_Vge_si=(+(+(T1_Tempt_GND_Vge_si/DIBLfactor-(T1_Tempt_GND*0.0+T1_Vge_si*DIBLfactor_Tempt_GND+T1*0.0)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*0.0/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vge_si+(T1_Vge_si/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Vge_si)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor_Vge_si+((((T1_Vge_si/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vge_si)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND_Vge_si);
  VaDIBL_Tempt_GND_Vdi_si=(+(+(T1_Tempt_GND_Vdi_si/DIBLfactor-(T1_Tempt_GND*DIBLfactor_Vdi_si+T1_Vdi_si*DIBLfactor_Tempt_GND+T1*DIBLfactor_Tempt_GND_Vdi_si)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*DIBLfactor_Vdi_si/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Vdi_si+((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Vdi_si)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor_Vdi_si+(((((T1_Vdi_si*DIBLfactor-T1*DIBLfactor_Vdi_si)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Vdi_si)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND_Vdi_si);
  VaDIBL_Tempt_GND_Tempt_GND=(+(+(T1_Tempt_GND_Tempt_GND/DIBLfactor-(T1_Tempt_GND*DIBLfactor_Tempt_GND+T1_Tempt_GND*DIBLfactor_Tempt_GND+T1*DIBLfactor_Tempt_GND_Tempt_GND)/DIBLfactor/DIBLfactor+2*T1*DIBLfactor_Tempt_GND*DIBLfactor_Tempt_GND/DIBLfactor/DIBLfactor/DIBLfactor)*T3+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3_Tempt_GND+(T1/DIBLfactor)*T3_Tempt_GND_Tempt_GND)*PVAGfactor+((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND))*PVAGfactor_Tempt_GND+(((((T1_Tempt_GND*DIBLfactor-T1*DIBLfactor_Tempt_GND)/DIBLfactor/DIBLfactor)*T3)+((T1/DIBLfactor)*T3_Tempt_GND)))*PVAGfactor_Tempt_GND+((T1/DIBLfactor)*T3)*PVAGfactor_Tempt_GND_Tempt_GND);
#endif
#endif
VaDIBL=(((T1/DIBLfactor)*T3)*PVAGfactor);
EXIT_IF_ISNAN((((T1/DIBLfactor)*T3)*PVAGfactor))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Moc_Vdi_si=((diffVds_Vdi_si*VaDIBL-diffVds*VaDIBL_Vdi_si)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vdi_si_Vdi_si=(+0.0+(diffVds_Vdi_si_Vdi_si/VaDIBL-(diffVds_Vdi_si*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_si_Ve_si=(+0.0+(diffVds_Vdi_si_Ve_si/VaDIBL-(diffVds_Vdi_si*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_si_Ve_di=(+0.0+(diffVds_Vdi_si_Ve_di/VaDIBL-(diffVds_Vdi_si*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_si_Vge_si=(+0.0+(diffVds_Vdi_si_Vge_si/VaDIBL-(diffVds_Vdi_si*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_si_Tempt_GND=(+0.0+(diffVds_Vdi_si_Tempt_GND/VaDIBL-(diffVds_Vdi_si*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vdi_si_Vge_e=(+0.0+(0.0/VaDIBL-(diffVds_Vdi_si*VaDIBL_Vge_e+0.0*VaDIBL_Vdi_si+diffVds*VaDIBL_Vdi_si_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vdi_si*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Ve_si=((diffVds_Ve_si*VaDIBL-diffVds*VaDIBL_Ve_si)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Ve_si_Vdi_si=(+0.0+(diffVds_Ve_si_Vdi_si/VaDIBL-(diffVds_Ve_si*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_si_Ve_si=(+0.0+(diffVds_Ve_si_Ve_si/VaDIBL-(diffVds_Ve_si*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_si_Ve_di=(+0.0+(diffVds_Ve_si_Ve_di/VaDIBL-(diffVds_Ve_si*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_si_Vge_si=(+0.0+(diffVds_Ve_si_Vge_si/VaDIBL-(diffVds_Ve_si*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_si_Tempt_GND=(+0.0+(diffVds_Ve_si_Tempt_GND/VaDIBL-(diffVds_Ve_si*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_si_Vge_e=(+0.0+(0.0/VaDIBL-(diffVds_Ve_si*VaDIBL_Vge_e+0.0*VaDIBL_Ve_si+diffVds*VaDIBL_Ve_si_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_si*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Ve_di=((diffVds_Ve_di*VaDIBL-diffVds*VaDIBL_Ve_di)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Ve_di_Vdi_si=(+0.0+(diffVds_Ve_di_Vdi_si/VaDIBL-(diffVds_Ve_di*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_di_Ve_si=(+0.0+(diffVds_Ve_di_Ve_si/VaDIBL-(diffVds_Ve_di*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_di_Ve_di=(+0.0+(diffVds_Ve_di_Ve_di/VaDIBL-(diffVds_Ve_di*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_di_Vge_si=(+0.0+(diffVds_Ve_di_Vge_si/VaDIBL-(diffVds_Ve_di*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_di_Tempt_GND=(+0.0+(diffVds_Ve_di_Tempt_GND/VaDIBL-(diffVds_Ve_di*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Ve_di_Vge_e=(+0.0+(0.0/VaDIBL-(diffVds_Ve_di*VaDIBL_Vge_e+0.0*VaDIBL_Ve_di+diffVds*VaDIBL_Ve_di_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Ve_di*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Vge_si=((diffVds_Vge_si*VaDIBL-diffVds*VaDIBL_Vge_si)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vge_si_Vdi_si=(+0.0+(diffVds_Vge_si_Vdi_si/VaDIBL-(diffVds_Vge_si*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_si_Ve_si=(+0.0+(diffVds_Vge_si_Ve_si/VaDIBL-(diffVds_Vge_si*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_si_Ve_di=(+0.0+(diffVds_Vge_si_Ve_di/VaDIBL-(diffVds_Vge_si*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_si_Vge_si=(+0.0+(diffVds_Vge_si_Vge_si/VaDIBL-(diffVds_Vge_si*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_si_Tempt_GND=(+0.0+(diffVds_Vge_si_Tempt_GND/VaDIBL-(diffVds_Vge_si*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_si_Vge_e=(+0.0+(0.0/VaDIBL-(diffVds_Vge_si*VaDIBL_Vge_e+0.0*VaDIBL_Vge_si+diffVds*VaDIBL_Vge_si_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_si*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Tempt_GND=((diffVds_Tempt_GND*VaDIBL-diffVds*VaDIBL_Tempt_GND)/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Tempt_GND_Vdi_si=(+0.0+(diffVds_Tempt_GND_Vdi_si/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Tempt_GND_Ve_si=(+0.0+(diffVds_Tempt_GND_Ve_si/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Tempt_GND_Ve_di=(+0.0+(diffVds_Tempt_GND_Ve_di/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Tempt_GND_Vge_si=(+0.0+(diffVds_Tempt_GND_Vge_si/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Tempt_GND_Tempt_GND=(+0.0+(diffVds_Tempt_GND_Tempt_GND/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Tempt_GND_Vge_e=(+0.0+(0.0/VaDIBL-(diffVds_Tempt_GND*VaDIBL_Vge_e+0.0*VaDIBL_Tempt_GND+diffVds*VaDIBL_Tempt_GND_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Tempt_GND*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
Moc_Vge_e=(-diffVds*VaDIBL_Vge_e/VaDIBL/VaDIBL);
#if defined(_DERIVATE2)
  Moc_Vge_e_Vdi_si=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Vdi_si+diffVds_Vdi_si*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Vdi_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Vdi_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_e_Ve_si=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Ve_si+diffVds_Ve_si*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Ve_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Ve_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_e_Ve_di=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Ve_di+diffVds_Ve_di*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Ve_di)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Ve_di/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_e_Vge_si=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Vge_si+diffVds_Vge_si*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Vge_si)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Vge_si/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_e_Tempt_GND=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Tempt_GND+diffVds_Tempt_GND*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Tempt_GND)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Tempt_GND/VaDIBL/VaDIBL/VaDIBL));
  Moc_Vge_e_Vge_e=(+0.0+(0.0/VaDIBL-(0.0*VaDIBL_Vge_e+0.0*VaDIBL_Vge_e+diffVds*VaDIBL_Vge_e_Vge_e)/VaDIBL/VaDIBL+2*diffVds*VaDIBL_Vge_e*VaDIBL_Vge_e/VaDIBL/VaDIBL/VaDIBL));
#endif
#endif
Moc=(1.0+(diffVds/VaDIBL));
EXIT_IF_ISNAN((1.0+(diffVds/VaDIBL)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Moc_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Moc_Vdi_si_Vdi_si=0.0;
  Moc_Vdi_si_Ve_si=0.0;
  Moc_Vdi_si_Ve_di=0.0;
  Moc_Vdi_si_Vge_si=0.0;
  Moc_Vdi_si_Tempt_GND=0.0;
  Moc_Vdi_si_Vge_e=0.0;
#endif
Moc_Ve_si=0.0;
#if defined(_DERIVATE2)
  Moc_Ve_si_Vdi_si=0.0;
  Moc_Ve_si_Ve_si=0.0;
  Moc_Ve_si_Ve_di=0.0;
  Moc_Ve_si_Vge_si=0.0;
  Moc_Ve_si_Tempt_GND=0.0;
  Moc_Ve_si_Vge_e=0.0;
#endif
Moc_Ve_di=0.0;
#if defined(_DERIVATE2)
  Moc_Ve_di_Vdi_si=0.0;
  Moc_Ve_di_Ve_si=0.0;
  Moc_Ve_di_Ve_di=0.0;
  Moc_Ve_di_Vge_si=0.0;
  Moc_Ve_di_Tempt_GND=0.0;
  Moc_Ve_di_Vge_e=0.0;
#endif
Moc_Vge_si=0.0;
#if defined(_DERIVATE2)
  Moc_Vge_si_Vdi_si=0.0;
  Moc_Vge_si_Ve_si=0.0;
  Moc_Vge_si_Ve_di=0.0;
  Moc_Vge_si_Vge_si=0.0;
  Moc_Vge_si_Tempt_GND=0.0;
  Moc_Vge_si_Vge_e=0.0;
#endif
Moc_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Moc_Tempt_GND_Vdi_si=0.0;
  Moc_Tempt_GND_Ve_si=0.0;
  Moc_Tempt_GND_Ve_di=0.0;
  Moc_Tempt_GND_Vge_si=0.0;
  Moc_Tempt_GND_Tempt_GND=0.0;
  Moc_Tempt_GND_Vge_e=0.0;
#endif
Moc_Vge_e=0.0;
#if defined(_DERIVATE2)
  Moc_Vge_e_Vdi_si=0.0;
  Moc_Vge_e_Ve_si=0.0;
  Moc_Vge_e_Ve_di=0.0;
  Moc_Vge_e_Vge_si=0.0;
  Moc_Vge_e_Tempt_GND=0.0;
  Moc_Vge_e_Vge_e=0.0;
#endif
#endif
Moc=1.0;
EXIT_IF_ISNAN(1.0)
}
if
((PCLM_a>0.0))
{
if
((PCLMG_i<0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-(-(PCLMG_i*qia_Ve_si))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Vsi_s=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Vge_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Vge_e=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Ve_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_si)))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-((PCLMG_i*qia_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Ve_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_di)))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-((PCLMG_i*qia_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Vge_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Vge_si)))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*(-((PCLMG_i*qia_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Vdi_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Vdi_si+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Vdi_si/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_si_Tempt_GND=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))+0.0*(-(PCLMG_i*qia_Ve_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Tempt_GND+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Tempt_GND/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_si))*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#endif
T1_Ve_di=(-(-(PCLMG_i*qia_Ve_di))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Vsi_s=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Vge_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Vge_e=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Ve_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_si)))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-((PCLMG_i*qia_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Ve_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_di)))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-((PCLMG_i*qia_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Vge_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Vge_si)))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*(-((PCLMG_i*qia_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Vdi_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Vdi_si+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Vdi_si/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Ve_di_Tempt_GND=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))+0.0*(-(PCLMG_i*qia_Ve_di))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Tempt_GND+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Tempt_GND/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Ve_di))*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#endif
T1_Vge_si=(-(-(PCLMG_i*qia_Vge_si))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Vsi_s=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Vge_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Vge_e=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Ve_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_si)))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-((PCLMG_i*qia_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Ve_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_di)))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-((PCLMG_i*qia_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Vge_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Vge_si)))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*(-((PCLMG_i*qia_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Vdi_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Vdi_si+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Vdi_si/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vge_si_Tempt_GND=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))+0.0*(-(PCLMG_i*qia_Vge_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Tempt_GND+0.0*0.0+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*0.0*PCLM_a_Tempt_GND/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*(-(PCLMG_i*qia_Vge_si))*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#endif
T1_Vdi_si=(-((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Vsi_s=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Vge_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Vge_e=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Ve_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_si)))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-((PCLMG_i*qia_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Ve_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_di)))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-((PCLMG_i*qia_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Vge_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Vge_si)))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Vdi_si+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*(-((PCLMG_i*qia_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Vdi_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Vdi_si+0.0*PCLM_a_Vdi_si+1.0*PCLM_a_Vdi_si_Vdi_si)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*PCLM_a_Vdi_si/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Vdi_si_Tempt_GND=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))+0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Tempt_GND+0.0*PCLM_a_Vdi_si+1.0*PCLM_a_Vdi_si_Tempt_GND)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Vdi_si*PCLM_a_Tempt_GND/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-(PCLMG_i*qia_Vdi_si))*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#endif
T1_Tempt_GND=(-((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Vsi_s=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Vge_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Vge_e=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-(0.0))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-(0.0))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Ve_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_si)))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-((PCLMG_i*qia_Ve_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Ve_di=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Ve_di)))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-((PCLMG_i*qia_Ve_di)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Vge_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*(-((PCLMG_i*qia_Vge_si)))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*0.0+0.0*PCLM_a_Tempt_GND+1.0*0.0)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*0.0/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*(-((PCLMG_i*qia_Vge_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Vdi_si=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Vdi_si+0.0*PCLM_a_Tempt_GND+1.0*PCLM_a_Tempt_GND_Vdi_si)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*PCLM_a_Vdi_si/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*((-PCLM_a_Vdi_si/PCLM_a/PCLM_a)-((PCLMG_i*qia_Vdi_si)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
  T1_Tempt_GND_Tempt_GND=(0.0/((1.0/PCLM_a)-(PCLMG_i*qia))-(0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))+0.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))+1.0*(+(0.0/PCLM_a-(0.0*PCLM_a_Tempt_GND+0.0*PCLM_a_Tempt_GND+1.0*PCLM_a_Tempt_GND_Tempt_GND)/PCLM_a/PCLM_a+2*1.0*PCLM_a_Tempt_GND*PCLM_a_Tempt_GND/PCLM_a/PCLM_a/PCLM_a)-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))+2*1.0*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-(PCLMG_i*qia_Tempt_GND))*((-PCLM_a_Tempt_GND/PCLM_a/PCLM_a)-((PCLMG_i*qia_Tempt_GND)))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia))/((1.0/PCLM_a)-(PCLMG_i*qia)));
#endif
#endif
T1=(1.0/((1.0/PCLM_a)-(PCLMG_i*qia)));
EXIT_IF_ISNAN((1.0/((1.0/PCLM_a)-(PCLMG_i*qia))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(PCLMG_i*qia_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0));
  T1_Ve_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0));
  T1_Ve_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0));
  T1_Ve_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PCLMG_i*0.0));
  T1_Ve_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Ve_si));
  T1_Ve_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Ve_di));
  T1_Ve_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Vge_si));
  T1_Ve_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Vdi_si));
  T1_Ve_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PCLMG_i*qia_Ve_si_Tempt_GND));
#endif
T1_Ve_di=(PCLMG_i*qia_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0));
  T1_Ve_di_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0));
  T1_Ve_di_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0));
  T1_Ve_di_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PCLMG_i*0.0));
  T1_Ve_di_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Ve_si));
  T1_Ve_di_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Ve_di));
  T1_Ve_di_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Vge_si));
  T1_Ve_di_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Vdi_si));
  T1_Ve_di_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PCLMG_i*qia_Ve_di_Tempt_GND));
#endif
T1_Vge_si=(PCLMG_i*qia_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0));
  T1_Vge_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0));
  T1_Vge_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0));
  T1_Vge_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PCLMG_i*0.0));
  T1_Vge_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Ve_si));
  T1_Vge_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Ve_di));
  T1_Vge_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Vge_si));
  T1_Vge_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Vdi_si));
  T1_Vge_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PCLMG_i*qia_Vge_si_Tempt_GND));
#endif
T1_Vdi_si=(PCLM_a_Vdi_si+(PCLMG_i*qia_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0));
  T1_Vdi_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0));
  T1_Vdi_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0));
  T1_Vdi_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PCLMG_i*0.0));
  T1_Vdi_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Ve_si));
  T1_Vdi_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Ve_di));
  T1_Vdi_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Vge_si));
  T1_Vdi_si_Vdi_si=(+PCLM_a_Vdi_si_Vdi_si+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Vdi_si));
  T1_Vdi_si_Tempt_GND=(+PCLM_a_Vdi_si_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PCLMG_i*qia_Vdi_si_Tempt_GND));
#endif
T1_Tempt_GND=(PCLM_a_Tempt_GND+(PCLMG_i*qia_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0));
  T1_Tempt_GND_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0));
  T1_Tempt_GND_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0));
  T1_Tempt_GND_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PCLMG_i*0.0));
  T1_Tempt_GND_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Ve_si));
  T1_Tempt_GND_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Ve_di));
  T1_Tempt_GND_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Vge_si));
  T1_Tempt_GND_Vdi_si=(+PCLM_a_Tempt_GND_Vdi_si+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Vdi_si));
  T1_Tempt_GND_Tempt_GND=(+PCLM_a_Tempt_GND_Tempt_GND+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PCLMG_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T1=(PCLM_a+(PCLMG_i*qia));
EXIT_IF_ISNAN((PCLM_a+(PCLMG_i*qia)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Mclm_Vge_e=((T1_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Vge_e_Vge_e=(+0.0+(+T1_Vge_e_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Vge_e+0.0*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_e_Ve_si=(+0.0+(+T1_Vge_e_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Ve_si+(-Vdseff_Ve_si)*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_e_Ve_di=(+0.0+(+T1_Vge_e_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Ve_di+(-Vdseff_Ve_di)*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_e_Vge_si=(+0.0+(+T1_Vge_e_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Vge_si+(-Vdseff_Vge_si)*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_e_Vdi_si=(+0.0+(+T1_Vge_e_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_e_Tempt_GND=(+0.0+(+T1_Vge_e_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),((-(vds-Vdseff)*T1_Vge_e/T1/T1)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-(0.0*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Vge_e+(vds-Vdseff)*T1_Vge_e_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Vge_e*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*0.0+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*0.0*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
Mclm_Ve_si=((T1_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Ve_si_Vge_e=(+0.0+(+T1_Ve_si_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-((-Vdseff_Ve_si)*T1_Vge_e+0.0*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_si_Ve_si=(+0.0+(+T1_Ve_si_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_si_Ve_si)/T1-((-Vdseff_Ve_si)*T1_Ve_si+(-Vdseff_Ve_si)*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+Vdsat_Ve_si_Ve_si+EsatL_Ve_si_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_si_Ve_di=(+0.0+(+T1_Ve_si_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_si_Ve_di)/T1-((-Vdseff_Ve_si)*T1_Ve_di+(-Vdseff_Ve_di)*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+Vdsat_Ve_si_Ve_di+EsatL_Ve_si_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_si_Vge_si=(+0.0+(+T1_Ve_si_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_si_Vge_si)/T1-((-Vdseff_Ve_si)*T1_Vge_si+(-Vdseff_Vge_si)*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+Vdsat_Ve_si_Vge_si+EsatL_Ve_si_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_si_Vdi_si=(+0.0+(+T1_Ve_si_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_si_Vdi_si)/T1-((-Vdseff_Ve_si)*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+Vdsat_Ve_si_Vdi_si+EsatL_Ve_si_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_si_Tempt_GND=(+0.0+(+T1_Ve_si_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_si_Tempt_GND)/T1-((-Vdseff_Ve_si)*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Ve_si+(vds-Vdseff)*T1_Ve_si_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Ve_si*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+((vds-Vdseff)/T1)*(+Vdsat_Ve_si_Tempt_GND+EsatL_Ve_si_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_si+EsatL_Ve_si)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
Mclm_Ve_di=((T1_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Ve_di_Vge_e=(+0.0+(+T1_Ve_di_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-((-Vdseff_Ve_di)*T1_Vge_e+0.0*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_di_Ve_si=(+0.0+(+T1_Ve_di_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_di_Ve_si)/T1-((-Vdseff_Ve_di)*T1_Ve_si+(-Vdseff_Ve_si)*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+Vdsat_Ve_di_Ve_si+EsatL_Ve_di_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_di_Ve_di=(+0.0+(+T1_Ve_di_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_di_Ve_di)/T1-((-Vdseff_Ve_di)*T1_Ve_di+(-Vdseff_Ve_di)*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+Vdsat_Ve_di_Ve_di+EsatL_Ve_di_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_di_Vge_si=(+0.0+(+T1_Ve_di_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_di_Vge_si)/T1-((-Vdseff_Ve_di)*T1_Vge_si+(-Vdseff_Vge_si)*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+Vdsat_Ve_di_Vge_si+EsatL_Ve_di_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_di_Vdi_si=(+0.0+(+T1_Ve_di_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_di_Vdi_si)/T1-((-Vdseff_Ve_di)*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+Vdsat_Ve_di_Vdi_si+EsatL_Ve_di_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Ve_di_Tempt_GND=(+0.0+(+T1_Ve_di_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Ve_di_Tempt_GND)/T1-((-Vdseff_Ve_di)*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Ve_di+(vds-Vdseff)*T1_Ve_di_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Ve_di*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+((vds-Vdseff)/T1)*(+Vdsat_Ve_di_Tempt_GND+EsatL_Ve_di_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Ve_di+EsatL_Ve_di)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
Mclm_Vge_si=((T1_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Vge_si_Vge_e=(+0.0+(+T1_Vge_si_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-((-Vdseff_Vge_si)*T1_Vge_e+0.0*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_si_Ve_si=(+0.0+(+T1_Vge_si_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vge_si_Ve_si)/T1-((-Vdseff_Vge_si)*T1_Ve_si+(-Vdseff_Ve_si)*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+Vdsat_Vge_si_Ve_si+EsatL_Vge_si_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_si_Ve_di=(+0.0+(+T1_Vge_si_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vge_si_Ve_di)/T1-((-Vdseff_Vge_si)*T1_Ve_di+(-Vdseff_Ve_di)*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+Vdsat_Vge_si_Ve_di+EsatL_Vge_si_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_si_Vge_si=(+0.0+(+T1_Vge_si_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vge_si_Vge_si)/T1-((-Vdseff_Vge_si)*T1_Vge_si+(-Vdseff_Vge_si)*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+Vdsat_Vge_si_Vge_si+EsatL_Vge_si_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_si_Vdi_si=(+0.0+(+T1_Vge_si_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vge_si_Vdi_si)/T1-((-Vdseff_Vge_si)*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+Vdsat_Vge_si_Vdi_si+EsatL_Vge_si_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vge_si_Tempt_GND=(+0.0+(+T1_Vge_si_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vge_si_Tempt_GND)/T1-((-Vdseff_Vge_si)*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Vge_si+(vds-Vdseff)*T1_Vge_si_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Vge_si*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+((vds-Vdseff)/T1)*(+Vdsat_Vge_si_Tempt_GND+EsatL_Vge_si_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vge_si+EsatL_Vge_si)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
Mclm_Vdi_si=((T1_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Vdi_si_Vge_e=(+0.0+(+T1_Vdi_si_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Vge_e+0.0*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vdi_si_Ve_si=(+0.0+(+T1_Vdi_si_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vdi_si_Ve_si)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Ve_si+(-Vdseff_Ve_si)*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+Vdsat_Vdi_si_Ve_si+EsatL_Vdi_si_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vdi_si_Ve_di=(+0.0+(+T1_Vdi_si_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vdi_si_Ve_di)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Ve_di+(-Vdseff_Ve_di)*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+Vdsat_Vdi_si_Ve_di+EsatL_Vdi_si_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vdi_si_Vge_si=(+0.0+(+T1_Vdi_si_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vdi_si_Vge_si)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Vge_si+(-Vdseff_Vge_si)*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+Vdsat_Vdi_si_Vge_si+EsatL_Vdi_si_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vdi_si_Vdi_si=(+0.0+(+T1_Vdi_si_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+vds_Vdi_si_Vdi_si-Vdseff_Vdi_si_Vdi_si)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+Vdsat_Vdi_si_Vdi_si+EsatL_Vdi_si_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Vdi_si_Tempt_GND=(+0.0+(+T1_Vdi_si_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Vdi_si_Tempt_GND)/T1-((vds_Vdi_si-Vdseff_Vdi_si)*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Vdi_si+(vds-Vdseff)*T1_Vdi_si_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Vdi_si*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+((vds-Vdseff)/T1)*(+Vdsat_Vdi_si_Tempt_GND+EsatL_Vdi_si_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
Mclm_Tempt_GND=((T1_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))+(T1*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#if defined(_DERIVATE2)
  Mclm_Tempt_GND_Vge_e=(+0.0+(+T1_Tempt_GND_Vge_e*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_e*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-0.0)/T1-((-Vdseff_Tempt_GND)*T1_Vge_e+0.0*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Vge_e)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Vge_e/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*0.0+(-(vds-Vdseff)*T1_Vge_e/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+0.0+0.0))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*0.0/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Tempt_GND_Ve_si=(+0.0+(+T1_Tempt_GND_Ve_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Tempt_GND_Ve_si)/T1-((-Vdseff_Tempt_GND)*T1_Ve_si+(-Vdseff_Ve_si)*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Ve_si)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Ve_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Ve_si+EsatL_Ve_si)+(((-Vdseff_Ve_si)*T1-(vds-Vdseff)*T1_Ve_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+Vdsat_Tempt_GND_Ve_si+EsatL_Tempt_GND_Ve_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*(Vdsat_Ve_si+EsatL_Ve_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Tempt_GND_Ve_di=(+0.0+(+T1_Tempt_GND_Ve_di*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Ve_di*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Tempt_GND_Ve_di)/T1-((-Vdseff_Tempt_GND)*T1_Ve_di+(-Vdseff_Ve_di)*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Ve_di)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Ve_di/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Ve_di+EsatL_Ve_di)+(((-Vdseff_Ve_di)*T1-(vds-Vdseff)*T1_Ve_di)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+Vdsat_Tempt_GND_Ve_di+EsatL_Tempt_GND_Ve_di))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*(Vdsat_Ve_di+EsatL_Ve_di)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Tempt_GND_Vge_si=(+0.0+(+T1_Tempt_GND_Vge_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vge_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Tempt_GND_Vge_si)/T1-((-Vdseff_Tempt_GND)*T1_Vge_si+(-Vdseff_Vge_si)*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Vge_si)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Vge_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Vge_si+EsatL_Vge_si)+(((-Vdseff_Vge_si)*T1-(vds-Vdseff)*T1_Vge_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+Vdsat_Tempt_GND_Vge_si+EsatL_Tempt_GND_Vge_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*(Vdsat_Vge_si+EsatL_Vge_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Tempt_GND_Vdi_si=(+0.0+(+T1_Tempt_GND_Vdi_si*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Vdi_si*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Tempt_GND_Vdi_si)/T1-((-Vdseff_Tempt_GND)*T1_Vdi_si+(vds_Vdi_si-Vdseff_Vdi_si)*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Vdi_si)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Vdi_si/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Vdi_si+EsatL_Vdi_si)+(((vds_Vdi_si-Vdseff_Vdi_si)*T1-(vds-Vdseff)*T1_Vdi_si)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+Vdsat_Tempt_GND_Vdi_si+EsatL_Tempt_GND_Vdi_si))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*(Vdsat_Vdi_si+EsatL_Vdi_si)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
  Mclm_Tempt_GND_Tempt_GND=(+0.0+(+T1_Tempt_GND_Tempt_GND*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1_Tempt_GND*bsimcmg_d_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))),(((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat+EsatL)-((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)))+T1*(+0.0+(((+0.0-Vdseff_Tempt_GND_Tempt_GND)/T1-((-Vdseff_Tempt_GND)*T1_Tempt_GND+(-Vdseff_Tempt_GND)*T1_Tempt_GND+(vds-Vdseff)*T1_Tempt_GND_Tempt_GND)/T1/T1+2*(vds-Vdseff)*T1_Tempt_GND*T1_Tempt_GND/T1/T1/T1)/(Vdsat+EsatL)-((((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+(((-Vdseff_Tempt_GND)*T1-(vds-Vdseff)*T1_Tempt_GND)/T1/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)+((vds-Vdseff)/T1)*(+Vdsat_Tempt_GND_Tempt_GND+EsatL_Tempt_GND_Tempt_GND))/(Vdsat+EsatL)/(Vdsat+EsatL)+2*((vds-Vdseff)/T1)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)*(Vdsat_Tempt_GND+EsatL_Tempt_GND)/(Vdsat+EsatL)/(Vdsat+EsatL)/(Vdsat+EsatL)))));
#endif
#endif
Mclm=(1.0+(T1*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL))))));
EXIT_IF_ISNAN((1.0+(T1*bsimcmg_lln((1.0+(((vds-Vdseff)/T1)/(Vdsat+EsatL)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Mclm_Vge_e=0.0;
#if defined(_DERIVATE2)
  Mclm_Vge_e_Vge_e=0.0;
  Mclm_Vge_e_Ve_si=0.0;
  Mclm_Vge_e_Ve_di=0.0;
  Mclm_Vge_e_Vge_si=0.0;
  Mclm_Vge_e_Vdi_si=0.0;
  Mclm_Vge_e_Tempt_GND=0.0;
#endif
Mclm_Ve_si=0.0;
#if defined(_DERIVATE2)
  Mclm_Ve_si_Vge_e=0.0;
  Mclm_Ve_si_Ve_si=0.0;
  Mclm_Ve_si_Ve_di=0.0;
  Mclm_Ve_si_Vge_si=0.0;
  Mclm_Ve_si_Vdi_si=0.0;
  Mclm_Ve_si_Tempt_GND=0.0;
#endif
Mclm_Ve_di=0.0;
#if defined(_DERIVATE2)
  Mclm_Ve_di_Vge_e=0.0;
  Mclm_Ve_di_Ve_si=0.0;
  Mclm_Ve_di_Ve_di=0.0;
  Mclm_Ve_di_Vge_si=0.0;
  Mclm_Ve_di_Vdi_si=0.0;
  Mclm_Ve_di_Tempt_GND=0.0;
#endif
Mclm_Vge_si=0.0;
#if defined(_DERIVATE2)
  Mclm_Vge_si_Vge_e=0.0;
  Mclm_Vge_si_Ve_si=0.0;
  Mclm_Vge_si_Ve_di=0.0;
  Mclm_Vge_si_Vge_si=0.0;
  Mclm_Vge_si_Vdi_si=0.0;
  Mclm_Vge_si_Tempt_GND=0.0;
#endif
Mclm_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Mclm_Vdi_si_Vge_e=0.0;
  Mclm_Vdi_si_Ve_si=0.0;
  Mclm_Vdi_si_Ve_di=0.0;
  Mclm_Vdi_si_Vge_si=0.0;
  Mclm_Vdi_si_Vdi_si=0.0;
  Mclm_Vdi_si_Tempt_GND=0.0;
#endif
Mclm_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Mclm_Tempt_GND_Vge_e=0.0;
  Mclm_Tempt_GND_Ve_si=0.0;
  Mclm_Tempt_GND_Ve_di=0.0;
  Mclm_Tempt_GND_Vge_si=0.0;
  Mclm_Tempt_GND_Vdi_si=0.0;
  Mclm_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Mclm=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Moc_Vdi_si=((Moc_Vdi_si*Mclm)+(Moc*Mclm_Vdi_si));
#if defined(_DERIVATE2)
  Moc_Vdi_si_Vdi_si=(+Moc_Vdi_si_Vdi_si*Mclm+Moc_Vdi_si*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Vdi_si);
  Moc_Vdi_si_Ve_si=(+Moc_Vdi_si_Ve_si*Mclm+Moc_Vdi_si*Mclm_Ve_si+Moc_Ve_si*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Ve_si);
  Moc_Vdi_si_Ve_di=(+Moc_Vdi_si_Ve_di*Mclm+Moc_Vdi_si*Mclm_Ve_di+Moc_Ve_di*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Ve_di);
  Moc_Vdi_si_Vge_si=(+Moc_Vdi_si_Vge_si*Mclm+Moc_Vdi_si*Mclm_Vge_si+Moc_Vge_si*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Vge_si);
  Moc_Vdi_si_Tempt_GND=(+Moc_Vdi_si_Tempt_GND*Mclm+Moc_Vdi_si*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Tempt_GND);
  Moc_Vdi_si_Vge_e=(+Moc_Vdi_si_Vge_e*Mclm+Moc_Vdi_si*Mclm_Vge_e+Moc_Vge_e*Mclm_Vdi_si+Moc*Mclm_Vdi_si_Vge_e);
#endif
Moc_Ve_si=((Moc_Ve_si*Mclm)+(Moc*Mclm_Ve_si));
#if defined(_DERIVATE2)
  Moc_Ve_si_Vdi_si=(+Moc_Ve_si_Vdi_si*Mclm+Moc_Ve_si*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Ve_si+Moc*Mclm_Ve_si_Vdi_si);
  Moc_Ve_si_Ve_si=(+Moc_Ve_si_Ve_si*Mclm+Moc_Ve_si*Mclm_Ve_si+Moc_Ve_si*Mclm_Ve_si+Moc*Mclm_Ve_si_Ve_si);
  Moc_Ve_si_Ve_di=(+Moc_Ve_si_Ve_di*Mclm+Moc_Ve_si*Mclm_Ve_di+Moc_Ve_di*Mclm_Ve_si+Moc*Mclm_Ve_si_Ve_di);
  Moc_Ve_si_Vge_si=(+Moc_Ve_si_Vge_si*Mclm+Moc_Ve_si*Mclm_Vge_si+Moc_Vge_si*Mclm_Ve_si+Moc*Mclm_Ve_si_Vge_si);
  Moc_Ve_si_Tempt_GND=(+Moc_Ve_si_Tempt_GND*Mclm+Moc_Ve_si*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Ve_si+Moc*Mclm_Ve_si_Tempt_GND);
  Moc_Ve_si_Vge_e=(+Moc_Ve_si_Vge_e*Mclm+Moc_Ve_si*Mclm_Vge_e+Moc_Vge_e*Mclm_Ve_si+Moc*Mclm_Ve_si_Vge_e);
#endif
Moc_Ve_di=((Moc_Ve_di*Mclm)+(Moc*Mclm_Ve_di));
#if defined(_DERIVATE2)
  Moc_Ve_di_Vdi_si=(+Moc_Ve_di_Vdi_si*Mclm+Moc_Ve_di*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Ve_di+Moc*Mclm_Ve_di_Vdi_si);
  Moc_Ve_di_Ve_si=(+Moc_Ve_di_Ve_si*Mclm+Moc_Ve_di*Mclm_Ve_si+Moc_Ve_si*Mclm_Ve_di+Moc*Mclm_Ve_di_Ve_si);
  Moc_Ve_di_Ve_di=(+Moc_Ve_di_Ve_di*Mclm+Moc_Ve_di*Mclm_Ve_di+Moc_Ve_di*Mclm_Ve_di+Moc*Mclm_Ve_di_Ve_di);
  Moc_Ve_di_Vge_si=(+Moc_Ve_di_Vge_si*Mclm+Moc_Ve_di*Mclm_Vge_si+Moc_Vge_si*Mclm_Ve_di+Moc*Mclm_Ve_di_Vge_si);
  Moc_Ve_di_Tempt_GND=(+Moc_Ve_di_Tempt_GND*Mclm+Moc_Ve_di*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Ve_di+Moc*Mclm_Ve_di_Tempt_GND);
  Moc_Ve_di_Vge_e=(+Moc_Ve_di_Vge_e*Mclm+Moc_Ve_di*Mclm_Vge_e+Moc_Vge_e*Mclm_Ve_di+Moc*Mclm_Ve_di_Vge_e);
#endif
Moc_Vge_si=((Moc_Vge_si*Mclm)+(Moc*Mclm_Vge_si));
#if defined(_DERIVATE2)
  Moc_Vge_si_Vdi_si=(+Moc_Vge_si_Vdi_si*Mclm+Moc_Vge_si*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Vge_si+Moc*Mclm_Vge_si_Vdi_si);
  Moc_Vge_si_Ve_si=(+Moc_Vge_si_Ve_si*Mclm+Moc_Vge_si*Mclm_Ve_si+Moc_Ve_si*Mclm_Vge_si+Moc*Mclm_Vge_si_Ve_si);
  Moc_Vge_si_Ve_di=(+Moc_Vge_si_Ve_di*Mclm+Moc_Vge_si*Mclm_Ve_di+Moc_Ve_di*Mclm_Vge_si+Moc*Mclm_Vge_si_Ve_di);
  Moc_Vge_si_Vge_si=(+Moc_Vge_si_Vge_si*Mclm+Moc_Vge_si*Mclm_Vge_si+Moc_Vge_si*Mclm_Vge_si+Moc*Mclm_Vge_si_Vge_si);
  Moc_Vge_si_Tempt_GND=(+Moc_Vge_si_Tempt_GND*Mclm+Moc_Vge_si*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Vge_si+Moc*Mclm_Vge_si_Tempt_GND);
  Moc_Vge_si_Vge_e=(+Moc_Vge_si_Vge_e*Mclm+Moc_Vge_si*Mclm_Vge_e+Moc_Vge_e*Mclm_Vge_si+Moc*Mclm_Vge_si_Vge_e);
#endif
Moc_Tempt_GND=((Moc_Tempt_GND*Mclm)+(Moc*Mclm_Tempt_GND));
#if defined(_DERIVATE2)
  Moc_Tempt_GND_Vdi_si=(+Moc_Tempt_GND_Vdi_si*Mclm+Moc_Tempt_GND*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Vdi_si);
  Moc_Tempt_GND_Ve_si=(+Moc_Tempt_GND_Ve_si*Mclm+Moc_Tempt_GND*Mclm_Ve_si+Moc_Ve_si*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Ve_si);
  Moc_Tempt_GND_Ve_di=(+Moc_Tempt_GND_Ve_di*Mclm+Moc_Tempt_GND*Mclm_Ve_di+Moc_Ve_di*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Ve_di);
  Moc_Tempt_GND_Vge_si=(+Moc_Tempt_GND_Vge_si*Mclm+Moc_Tempt_GND*Mclm_Vge_si+Moc_Vge_si*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Vge_si);
  Moc_Tempt_GND_Tempt_GND=(+Moc_Tempt_GND_Tempt_GND*Mclm+Moc_Tempt_GND*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Tempt_GND);
  Moc_Tempt_GND_Vge_e=(+Moc_Tempt_GND_Vge_e*Mclm+Moc_Tempt_GND*Mclm_Vge_e+Moc_Vge_e*Mclm_Tempt_GND+Moc*Mclm_Tempt_GND_Vge_e);
#endif
Moc_Vge_e=((Moc_Vge_e*Mclm)+(Moc*Mclm_Vge_e));
#if defined(_DERIVATE2)
  Moc_Vge_e_Vdi_si=(+Moc_Vge_e_Vdi_si*Mclm+Moc_Vge_e*Mclm_Vdi_si+Moc_Vdi_si*Mclm_Vge_e+Moc*Mclm_Vge_e_Vdi_si);
  Moc_Vge_e_Ve_si=(+Moc_Vge_e_Ve_si*Mclm+Moc_Vge_e*Mclm_Ve_si+Moc_Ve_si*Mclm_Vge_e+Moc*Mclm_Vge_e_Ve_si);
  Moc_Vge_e_Ve_di=(+Moc_Vge_e_Ve_di*Mclm+Moc_Vge_e*Mclm_Ve_di+Moc_Ve_di*Mclm_Vge_e+Moc*Mclm_Vge_e_Ve_di);
  Moc_Vge_e_Vge_si=(+Moc_Vge_e_Vge_si*Mclm+Moc_Vge_e*Mclm_Vge_si+Moc_Vge_si*Mclm_Vge_e+Moc*Mclm_Vge_e_Vge_si);
  Moc_Vge_e_Tempt_GND=(+Moc_Vge_e_Tempt_GND*Mclm+Moc_Vge_e*Mclm_Tempt_GND+Moc_Tempt_GND*Mclm_Vge_e+Moc*Mclm_Vge_e_Tempt_GND);
  Moc_Vge_e_Vge_e=(+Moc_Vge_e_Vge_e*Mclm+Moc_Vge_e*Mclm_Vge_e+Moc_Vge_e*Mclm_Vge_e+Moc*Mclm_Vge_e_Vge_e);
#endif
#endif
Moc=(Moc*Mclm);
EXIT_IF_ISNAN((Moc*Mclm))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Esat1_Tempt_GND=(((2.0*VSAT1_a_Tempt_GND)*ueff-(2.0*VSAT1_a)*ueff_Tempt_GND)/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Tempt_GND_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*VSAT1_a_Tempt_GND+2.0*VSAT1_a_Tempt_GND_Tempt_GND)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Tempt_GND_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*VSAT1_a_Tempt_GND+2.0*VSAT1_a_Tempt_GND_Vdi_si)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Tempt_GND_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Tempt_GND+2.0*0.0)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Vge_e+(0.0)*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Tempt_GND_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Tempt_GND+2.0*0.0)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Ve_si+(0.0)*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Tempt_GND_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Tempt_GND+2.0*0.0)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Ve_di+(0.0)*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Tempt_GND_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Tempt_GND+2.0*0.0)/ueff-((2.0*VSAT1_a_Tempt_GND)*ueff_Vge_si+(0.0)*ueff_Tempt_GND+(2.0*VSAT1_a)*ueff_Tempt_GND_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Tempt_GND*ueff_Vge_si/ueff/ueff/ueff);
#endif
Esat1_Vdi_si=(((2.0*VSAT1_a_Vdi_si)*ueff-(2.0*VSAT1_a)*ueff_Vdi_si)/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Vdi_si_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*VSAT1_a_Vdi_si+2.0*VSAT1_a_Vdi_si_Tempt_GND)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Vdi_si_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*VSAT1_a_Vdi_si+2.0*VSAT1_a_Vdi_si_Vdi_si)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Vdi_si_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Vdi_si+2.0*0.0)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Vge_e+(0.0)*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Vdi_si_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Vdi_si+2.0*0.0)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Ve_si+(0.0)*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Vdi_si_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Vdi_si+2.0*0.0)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Ve_di+(0.0)*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Vdi_si_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*VSAT1_a_Vdi_si+2.0*0.0)/ueff-((2.0*VSAT1_a_Vdi_si)*ueff_Vge_si+(0.0)*ueff_Vdi_si+(2.0*VSAT1_a)*ueff_Vdi_si_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vdi_si*ueff_Vge_si/ueff/ueff/ueff);
#endif
Esat1_Vge_e=(-(2.0*VSAT1_a)*ueff_Vge_e/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Vge_e_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Vge_e_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Vge_e_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_e+(0.0)*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Vge_e_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_si+(0.0)*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Vge_e_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_di+(0.0)*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Vge_e_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_si+(0.0)*ueff_Vge_e+(2.0*VSAT1_a)*ueff_Vge_e_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_e*ueff_Vge_si/ueff/ueff/ueff);
#endif
Esat1_Ve_si=(-(2.0*VSAT1_a)*ueff_Ve_si/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Ve_si_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Ve_si_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Ve_si_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_e+(0.0)*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Ve_si_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_si+(0.0)*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Ve_si_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_di+(0.0)*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Ve_si_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_si+(0.0)*ueff_Ve_si+(2.0*VSAT1_a)*ueff_Ve_si_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_si*ueff_Vge_si/ueff/ueff/ueff);
#endif
Esat1_Ve_di=(-(2.0*VSAT1_a)*ueff_Ve_di/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Ve_di_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Ve_di_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Ve_di_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_e+(0.0)*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Ve_di_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_si+(0.0)*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Ve_di_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_di+(0.0)*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Ve_di_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_si+(0.0)*ueff_Ve_di+(2.0*VSAT1_a)*ueff_Ve_di_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Ve_di*ueff_Vge_si/ueff/ueff/ueff);
#endif
Esat1_Vge_si=(-(2.0*VSAT1_a)*ueff_Vge_si/ueff/ueff);
#if defined(_DERIVATE2)
  Esat1_Vge_si_Tempt_GND=((+0.0*VSAT1_a+0.0*VSAT1_a_Tempt_GND+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Tempt_GND+((2.0*VSAT1_a_Tempt_GND))*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Tempt_GND)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Tempt_GND/ueff/ueff/ueff);
  Esat1_Vge_si_Vdi_si=((+0.0*VSAT1_a+0.0*VSAT1_a_Vdi_si+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vdi_si+((2.0*VSAT1_a_Vdi_si))*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Vdi_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Vdi_si/ueff/ueff/ueff);
  Esat1_Vge_si_Vge_e=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_e+(0.0)*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Vge_e)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Vge_e/ueff/ueff/ueff);
  Esat1_Vge_si_Ve_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_si+(0.0)*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Ve_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Ve_si/ueff/ueff/ueff);
  Esat1_Vge_si_Ve_di=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Ve_di+(0.0)*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Ve_di)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Ve_di/ueff/ueff/ueff);
  Esat1_Vge_si_Vge_si=((+0.0*VSAT1_a+0.0*0.0+0.0*0.0+2.0*0.0)/ueff-(0.0*ueff_Vge_si+(0.0)*ueff_Vge_si+(2.0*VSAT1_a)*ueff_Vge_si_Vge_si)/ueff/ueff+2*(2.0*VSAT1_a)*ueff_Vge_si*ueff_Vge_si/ueff/ueff/ueff);
#endif
#endif
Esat1=((2.0*VSAT1_a)/ueff);
EXIT_IF_ISNAN(((2.0*VSAT1_a)/ueff))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Esat1L_Tempt_GND=Esat1_Tempt_GND*Leff;
#if defined(_DERIVATE2)
  Esat1L_Tempt_GND_Tempt_GND=(+Esat1_Tempt_GND_Tempt_GND*Leff+Esat1_Tempt_GND*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Tempt_GND_Vdi_si=(+Esat1_Tempt_GND_Vdi_si*Leff+Esat1_Tempt_GND*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Tempt_GND_Vge_e=(+Esat1_Tempt_GND_Vge_e*Leff+Esat1_Tempt_GND*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Tempt_GND_Ve_si=(+Esat1_Tempt_GND_Ve_si*Leff+Esat1_Tempt_GND*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Tempt_GND_Ve_di=(+Esat1_Tempt_GND_Ve_di*Leff+Esat1_Tempt_GND*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Tempt_GND_Vge_si=(+Esat1_Tempt_GND_Vge_si*Leff+Esat1_Tempt_GND*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
Esat1L_Vdi_si=Esat1_Vdi_si*Leff;
#if defined(_DERIVATE2)
  Esat1L_Vdi_si_Tempt_GND=(+Esat1_Vdi_si_Tempt_GND*Leff+Esat1_Vdi_si*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Vdi_si_Vdi_si=(+Esat1_Vdi_si_Vdi_si*Leff+Esat1_Vdi_si*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Vdi_si_Vge_e=(+Esat1_Vdi_si_Vge_e*Leff+Esat1_Vdi_si*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Vdi_si_Ve_si=(+Esat1_Vdi_si_Ve_si*Leff+Esat1_Vdi_si*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Vdi_si_Ve_di=(+Esat1_Vdi_si_Ve_di*Leff+Esat1_Vdi_si*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Vdi_si_Vge_si=(+Esat1_Vdi_si_Vge_si*Leff+Esat1_Vdi_si*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
Esat1L_Vge_e=Esat1_Vge_e*Leff;
#if defined(_DERIVATE2)
  Esat1L_Vge_e_Tempt_GND=(+Esat1_Vge_e_Tempt_GND*Leff+Esat1_Vge_e*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Vge_e_Vdi_si=(+Esat1_Vge_e_Vdi_si*Leff+Esat1_Vge_e*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Vge_e_Vge_e=(+Esat1_Vge_e_Vge_e*Leff+Esat1_Vge_e*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Vge_e_Ve_si=(+Esat1_Vge_e_Ve_si*Leff+Esat1_Vge_e*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Vge_e_Ve_di=(+Esat1_Vge_e_Ve_di*Leff+Esat1_Vge_e*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Vge_e_Vge_si=(+Esat1_Vge_e_Vge_si*Leff+Esat1_Vge_e*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
Esat1L_Ve_si=Esat1_Ve_si*Leff;
#if defined(_DERIVATE2)
  Esat1L_Ve_si_Tempt_GND=(+Esat1_Ve_si_Tempt_GND*Leff+Esat1_Ve_si*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Ve_si_Vdi_si=(+Esat1_Ve_si_Vdi_si*Leff+Esat1_Ve_si*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Ve_si_Vge_e=(+Esat1_Ve_si_Vge_e*Leff+Esat1_Ve_si*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Ve_si_Ve_si=(+Esat1_Ve_si_Ve_si*Leff+Esat1_Ve_si*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Ve_si_Ve_di=(+Esat1_Ve_si_Ve_di*Leff+Esat1_Ve_si*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Ve_si_Vge_si=(+Esat1_Ve_si_Vge_si*Leff+Esat1_Ve_si*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
Esat1L_Ve_di=Esat1_Ve_di*Leff;
#if defined(_DERIVATE2)
  Esat1L_Ve_di_Tempt_GND=(+Esat1_Ve_di_Tempt_GND*Leff+Esat1_Ve_di*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Ve_di_Vdi_si=(+Esat1_Ve_di_Vdi_si*Leff+Esat1_Ve_di*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Ve_di_Vge_e=(+Esat1_Ve_di_Vge_e*Leff+Esat1_Ve_di*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Ve_di_Ve_si=(+Esat1_Ve_di_Ve_si*Leff+Esat1_Ve_di*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Ve_di_Ve_di=(+Esat1_Ve_di_Ve_di*Leff+Esat1_Ve_di*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Ve_di_Vge_si=(+Esat1_Ve_di_Vge_si*Leff+Esat1_Ve_di*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
Esat1L_Vge_si=Esat1_Vge_si*Leff;
#if defined(_DERIVATE2)
  Esat1L_Vge_si_Tempt_GND=(+Esat1_Vge_si_Tempt_GND*Leff+Esat1_Vge_si*0.0+Esat1_Tempt_GND*0.0+Esat1*0.0);
  Esat1L_Vge_si_Vdi_si=(+Esat1_Vge_si_Vdi_si*Leff+Esat1_Vge_si*0.0+Esat1_Vdi_si*0.0+Esat1*0.0);
  Esat1L_Vge_si_Vge_e=(+Esat1_Vge_si_Vge_e*Leff+Esat1_Vge_si*0.0+Esat1_Vge_e*0.0+Esat1*0.0);
  Esat1L_Vge_si_Ve_si=(+Esat1_Vge_si_Ve_si*Leff+Esat1_Vge_si*0.0+Esat1_Ve_si*0.0+Esat1*0.0);
  Esat1L_Vge_si_Ve_di=(+Esat1_Vge_si_Ve_di*Leff+Esat1_Vge_si*0.0+Esat1_Ve_di*0.0+Esat1*0.0);
  Esat1L_Vge_si_Vge_si=(+Esat1_Vge_si_Vge_si*Leff+Esat1_Vge_si*0.0+Esat1_Vge_si*0.0+Esat1*0.0);
#endif
#endif
Esat1L=(Esat1*Leff);
EXIT_IF_ISNAN((Esat1*Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*0.0+0.0*Esat1L_Vge_e+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*0.0/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Vge_e+0.0*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),(-dqi*Esat1L_Vge_e/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(0.0*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Vge_e+dqi*Esat1L_Vge_e_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_e*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
T0_Ve_si=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Ve_si*0.0+0.0*Esat1L_Ve_si+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*0.0/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Ve_si*Esat1L_Vge_e+0.0*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_si_Ve_si/Esat1L-(dqi_Ve_si*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_si_Ve_di/Esat1L-(dqi_Ve_si*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_si_Vge_si/Esat1L-(dqi_Ve_si*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_si_Vdi_si/Esat1L-(dqi_Ve_si*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_si*Esat1L-dqi*Esat1L_Ve_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_si_Tempt_GND/Esat1L-(dqi_Ve_si*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Ve_si+dqi*Esat1L_Ve_si_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_si*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
T0_Ve_di=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Ve_di*0.0+0.0*Esat1L_Ve_di+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*0.0/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Ve_di*Esat1L_Vge_e+0.0*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_di_Ve_si/Esat1L-(dqi_Ve_di*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_di_Ve_di/Esat1L-(dqi_Ve_di*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_di_Vge_si/Esat1L-(dqi_Ve_di*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_di_Vdi_si/Esat1L-(dqi_Ve_di*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Ve_di*Esat1L-dqi*Esat1L_Ve_di)/Esat1L/Esat1L))+PSAT_i*(dqi_Ve_di_Tempt_GND/Esat1L-(dqi_Ve_di*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Ve_di+dqi*Esat1L_Ve_di_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Ve_di*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
T0_Vge_si=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Vge_si*0.0+0.0*Esat1L_Vge_si+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*0.0/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Vge_si*Esat1L_Vge_e+0.0*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vge_si_Ve_si/Esat1L-(dqi_Vge_si*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vge_si_Ve_di/Esat1L-(dqi_Vge_si*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vge_si_Vge_si/Esat1L-(dqi_Vge_si*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vge_si_Vdi_si/Esat1L-(dqi_Vge_si*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vge_si*Esat1L-dqi*Esat1L_Vge_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vge_si_Tempt_GND/Esat1L-(dqi_Vge_si*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Vge_si+dqi*Esat1L_Vge_si_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Vge_si*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
T0_Vdi_si=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Vdi_si*0.0+0.0*Esat1L_Vdi_si+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*0.0/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Vdi_si*Esat1L_Vge_e+0.0*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vdi_si_Ve_si/Esat1L-(dqi_Vdi_si*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vdi_si_Ve_di/Esat1L-(dqi_Vdi_si*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vdi_si_Vge_si/Esat1L-(dqi_Vdi_si*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vdi_si_Vdi_si/Esat1L-(dqi_Vdi_si*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Vdi_si*Esat1L-dqi*Esat1L_Vdi_si)/Esat1L/Esat1L))+PSAT_i*(dqi_Vdi_si_Tempt_GND/Esat1L-(dqi_Vdi_si*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Vdi_si+dqi*Esat1L_Vdi_si_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Vdi_si*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
T0_Tempt_GND=bsimcmg_d_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))),(PSAT_i*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Tempt_GND*0.0+0.0*Esat1L_Tempt_GND+dqi*0.0)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*0.0/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(0.0/Esat1L-(dqi_Tempt_GND*Esat1L_Vge_e+0.0*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Vge_e)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Vge_e/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(dqi_Tempt_GND_Ve_si/Esat1L-(dqi_Tempt_GND*Esat1L_Ve_si+dqi_Ve_si*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Ve_si)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Ve_si/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(dqi_Tempt_GND_Ve_di/Esat1L-(dqi_Tempt_GND*Esat1L_Ve_di+dqi_Ve_di*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Ve_di)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Ve_di/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(dqi_Tempt_GND_Vge_si/Esat1L-(dqi_Tempt_GND*Esat1L_Vge_si+dqi_Vge_si*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Vge_si)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Vge_si/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(dqi_Tempt_GND_Vdi_si/Esat1L-(dqi_Tempt_GND*Esat1L_Vdi_si+dqi_Vdi_si*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Vdi_si)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Vdi_si/Esat1L/Esat1L/Esat1L));
  T0_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln((dqi/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+0.0*bsimcmg_d_lln((dqi/Esat1L),((dqi_Tempt_GND*Esat1L-dqi*Esat1L_Tempt_GND)/Esat1L/Esat1L))+PSAT_i*(dqi_Tempt_GND_Tempt_GND/Esat1L-(dqi_Tempt_GND*Esat1L_Tempt_GND+dqi_Tempt_GND*Esat1L_Tempt_GND+dqi*Esat1L_Tempt_GND_Tempt_GND)/Esat1L/Esat1L+2*dqi*Esat1L_Tempt_GND*Esat1L_Tempt_GND/Esat1L/Esat1L/Esat1L));
#endif
#endif
T0=bsimcmg_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L))));
EXIT_IF_ISNAN(bsimcmg_lexp((PSAT_i*bsimcmg_lln((dqi/Esat1L)))))
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Ta_Ve_si=0.0;
#if defined(_DERIVATE2)
  Ta_Ve_si_Ve_si=0.0;
  Ta_Ve_si_Ve_di=0.0;
  Ta_Ve_si_Vge_si=0.0;
  Ta_Ve_si_Vdi_si=0.0;
  Ta_Ve_si_Tempt_GND=0.0;
#endif
Ta_Ve_di=0.0;
#if defined(_DERIVATE2)
  Ta_Ve_di_Ve_si=0.0;
  Ta_Ve_di_Ve_di=0.0;
  Ta_Ve_di_Vge_si=0.0;
  Ta_Ve_di_Vdi_si=0.0;
  Ta_Ve_di_Tempt_GND=0.0;
#endif
Ta_Vge_si=0.0;
#if defined(_DERIVATE2)
  Ta_Vge_si_Ve_si=0.0;
  Ta_Vge_si_Ve_di=0.0;
  Ta_Vge_si_Vge_si=0.0;
  Ta_Vge_si_Vdi_si=0.0;
  Ta_Vge_si_Tempt_GND=0.0;
#endif
Ta_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Ta_Vdi_si_Ve_si=0.0;
  Ta_Vdi_si_Ve_di=0.0;
  Ta_Vdi_si_Vge_si=0.0;
  Ta_Vdi_si_Vdi_si=0.0;
  Ta_Vdi_si_Tempt_GND=0.0;
#endif
Ta_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Ta_Tempt_GND_Ve_si=0.0;
  Ta_Tempt_GND_Ve_di=0.0;
  Ta_Tempt_GND_Vge_si=0.0;
  Ta_Tempt_GND_Vdi_si=0.0;
  Ta_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Ta=(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln(DELTAVSAT_i))));
EXIT_IF_ISNAN((1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln(DELTAVSAT_i)))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dvsat_Vge_e=(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))/Ta);
#if defined(_DERIVATE2)
  Dvsat_Vge_e_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*0.0/Ta/Ta/Ta);
  Dvsat_Vge_e_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Vge_e_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Vge_e_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Vge_e_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Vge_e_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)+(1.0/PSAT_i)*(+0.0+T0_Vge_e_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
Dvsat_Ve_si=((bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Dvsat_Ve_si_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*0.0/Ta/Ta/Ta);
  Dvsat_Ve_si_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Ve_si_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Ve_si_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Ve_si_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Ve_si_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)+(1.0/PSAT_i)*(+0.0+T0_Ve_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
Dvsat_Ve_di=((bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di)/Ta/Ta);
#if defined(_DERIVATE2)
  Dvsat_Ve_di_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*0.0/Ta/Ta/Ta);
  Dvsat_Ve_di_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Ve_di_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Ve_di_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Ve_di_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Ve_di_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)+(1.0/PSAT_i)*(+0.0+T0_Ve_di_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Ve_di*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
Dvsat_Vge_si=((bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Dvsat_Vge_si_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*0.0/Ta/Ta/Ta);
  Dvsat_Vge_si_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Vge_si_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Vge_si_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Vge_si_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Vge_si_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)+(1.0/PSAT_i)*(+0.0+T0_Vge_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vge_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
Dvsat_Vdi_si=((bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si)/Ta/Ta);
#if defined(_DERIVATE2)
  Dvsat_Vdi_si_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*0.0/Ta/Ta/Ta);
  Dvsat_Vdi_si_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Vdi_si_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Vdi_si_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Vdi_si_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Vdi_si_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)+(1.0/PSAT_i)*(+0.0+T0_Vdi_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Vdi_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
Dvsat_Tempt_GND=((bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND)/Ta/Ta);
#if defined(_DERIVATE2)
  Dvsat_Tempt_GND_Vge_e=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*0.0+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*0.0/Ta/Ta/Ta);
  Dvsat_Tempt_GND_Ve_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*Ta_Ve_si/Ta/Ta/Ta);
  Dvsat_Tempt_GND_Ve_di=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*Ta_Ve_di/Ta/Ta/Ta);
  Dvsat_Tempt_GND_Vge_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*Ta_Vge_si/Ta/Ta/Ta);
  Dvsat_Tempt_GND_Vdi_si=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*Ta_Vdi_si/Ta/Ta/Ta);
  Dvsat_Tempt_GND_Tempt_GND=((+0.0+(+(0.0/PSAT_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSAT_i/PSAT_i+2*1.0*0.0*0.0/PSAT_i/PSAT_i/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)+(1.0/PSAT_i)*(+0.0+T0_Tempt_GND_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0))),((1.0/PSAT_i)*bsimcmg_d_lln((DELTAVSAT_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))*Ta_Tempt_GND*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
#endif
Dvsat=((1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))/Ta);
EXIT_IF_ISNAN(((1.0+bsimcmg_lexp(((1.0/PSAT_i)*bsimcmg_lln((DELTAVSAT_i+T0)))))/Ta))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dvsat_Vge_e=Dvsat_Vge_e;
#if defined(_DERIVATE2)
  Dvsat_Vge_e_Vge_e=(+Dvsat_Vge_e_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*0.0+(0.0)*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*0.0+((0.0)*qia)*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*0.0+(((0.0)*qia)*dqi)*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_e_Ve_si=(+Dvsat_Vge_e_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_si+(0.0)*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_e_Ve_di=(+Dvsat_Vge_e_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_di+(0.0)*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_e_Vge_si=(+Dvsat_Vge_e_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vge_si+(0.0)*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_e_Vdi_si=(+Dvsat_Vge_e_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_e_Tempt_GND=(+Dvsat_Vge_e_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*0.0+0.5*0.0)*qia+0.0*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*0.0+(0.5*PTWG_a)*0.0)*dqi+0.0*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*0.0+((0.5*PTWG_a)*qia)*0.0)*dqi+0.0*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*0.0+(((0.5*PTWG_a)*qia)*dqi)*0.0));
#endif
Dvsat_Ve_si=(Dvsat_Ve_si+((((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi)+((((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si)));
#if defined(_DERIVATE2)
  Dvsat_Ve_si_Vge_e=(+Dvsat_Ve_si_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*0.0+(0.0)*qia_Ve_si+(0.5*PTWG_a)*0.0)*dqi+((0.5*PTWG_a)*qia_Ve_si)*0.0+((0.0)*qia)*dqi_Ve_si+((0.5*PTWG_a)*qia)*0.0)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*0.0+(((0.0)*qia)*dqi)*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Ve_si_Ve_si=(+Dvsat_Ve_si_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_si+(0.0)*qia_Ve_si+(0.5*PTWG_a)*qia_Ve_si_Ve_si)*dqi+((0.5*PTWG_a)*qia_Ve_si)*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi_Ve_si+((0.5*PTWG_a)*qia)*dqi_Ve_si_Ve_si)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si_Ve_si));
  Dvsat_Ve_si_Ve_di=(+Dvsat_Ve_si_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_di+(0.0)*qia_Ve_si+(0.5*PTWG_a)*qia_Ve_si_Ve_di)*dqi+((0.5*PTWG_a)*qia_Ve_si)*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi_Ve_si+((0.5*PTWG_a)*qia)*dqi_Ve_si_Ve_di)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si_Ve_di));
  Dvsat_Ve_si_Vge_si=(+Dvsat_Ve_si_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vge_si+(0.0)*qia_Ve_si+(0.5*PTWG_a)*qia_Ve_si_Vge_si)*dqi+((0.5*PTWG_a)*qia_Ve_si)*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi_Ve_si+((0.5*PTWG_a)*qia)*dqi_Ve_si_Vge_si)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si_Vge_si));
  Dvsat_Ve_si_Vdi_si=(+Dvsat_Ve_si_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*qia_Ve_si+(0.5*PTWG_a)*qia_Ve_si_Vdi_si)*dqi+((0.5*PTWG_a)*qia_Ve_si)*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi_Ve_si+((0.5*PTWG_a)*qia)*dqi_Ve_si_Vdi_si)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si_Vdi_si));
  Dvsat_Ve_si_Tempt_GND=(+Dvsat_Ve_si_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*0.0+0.5*0.0)*qia+0.0*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*qia_Ve_si+(0.5*PTWG_a)*qia_Ve_si_Tempt_GND)*dqi+((0.5*PTWG_a)*qia_Ve_si)*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi_Ve_si+((0.5*PTWG_a)*qia)*dqi_Ve_si_Tempt_GND)*dqi+((((0.5*PTWG_a)*qia_Ve_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si))*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*dqi_Ve_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_si_Tempt_GND));
#endif
Dvsat_Ve_di=(Dvsat_Ve_di+((((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi)+((((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di)));
#if defined(_DERIVATE2)
  Dvsat_Ve_di_Vge_e=(+Dvsat_Ve_di_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*0.0+(0.0)*qia_Ve_di+(0.5*PTWG_a)*0.0)*dqi+((0.5*PTWG_a)*qia_Ve_di)*0.0+((0.0)*qia)*dqi_Ve_di+((0.5*PTWG_a)*qia)*0.0)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*0.0+(((0.0)*qia)*dqi)*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Ve_di_Ve_si=(+Dvsat_Ve_di_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_si+(0.0)*qia_Ve_di+(0.5*PTWG_a)*qia_Ve_di_Ve_si)*dqi+((0.5*PTWG_a)*qia_Ve_di)*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi_Ve_di+((0.5*PTWG_a)*qia)*dqi_Ve_di_Ve_si)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di_Ve_si));
  Dvsat_Ve_di_Ve_di=(+Dvsat_Ve_di_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_di+(0.0)*qia_Ve_di+(0.5*PTWG_a)*qia_Ve_di_Ve_di)*dqi+((0.5*PTWG_a)*qia_Ve_di)*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi_Ve_di+((0.5*PTWG_a)*qia)*dqi_Ve_di_Ve_di)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di_Ve_di));
  Dvsat_Ve_di_Vge_si=(+Dvsat_Ve_di_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vge_si+(0.0)*qia_Ve_di+(0.5*PTWG_a)*qia_Ve_di_Vge_si)*dqi+((0.5*PTWG_a)*qia_Ve_di)*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi_Ve_di+((0.5*PTWG_a)*qia)*dqi_Ve_di_Vge_si)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di_Vge_si));
  Dvsat_Ve_di_Vdi_si=(+Dvsat_Ve_di_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*qia_Ve_di+(0.5*PTWG_a)*qia_Ve_di_Vdi_si)*dqi+((0.5*PTWG_a)*qia_Ve_di)*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi_Ve_di+((0.5*PTWG_a)*qia)*dqi_Ve_di_Vdi_si)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di_Vdi_si));
  Dvsat_Ve_di_Tempt_GND=(+Dvsat_Ve_di_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*0.0+0.5*0.0)*qia+0.0*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*qia_Ve_di+(0.5*PTWG_a)*qia_Ve_di_Tempt_GND)*dqi+((0.5*PTWG_a)*qia_Ve_di)*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi_Ve_di+((0.5*PTWG_a)*qia)*dqi_Ve_di_Tempt_GND)*dqi+((((0.5*PTWG_a)*qia_Ve_di)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di))*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*dqi_Ve_di+(((0.5*PTWG_a)*qia)*dqi)*dqi_Ve_di_Tempt_GND));
#endif
Dvsat_Vge_si=(Dvsat_Vge_si+((((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi)+((((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si)));
#if defined(_DERIVATE2)
  Dvsat_Vge_si_Vge_e=(+Dvsat_Vge_si_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*0.0+(0.0)*qia_Vge_si+(0.5*PTWG_a)*0.0)*dqi+((0.5*PTWG_a)*qia_Vge_si)*0.0+((0.0)*qia)*dqi_Vge_si+((0.5*PTWG_a)*qia)*0.0)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*0.0+(((0.0)*qia)*dqi)*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vge_si_Ve_si=(+Dvsat_Vge_si_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_si+(0.0)*qia_Vge_si+(0.5*PTWG_a)*qia_Vge_si_Ve_si)*dqi+((0.5*PTWG_a)*qia_Vge_si)*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi_Vge_si+((0.5*PTWG_a)*qia)*dqi_Vge_si_Ve_si)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si_Ve_si));
  Dvsat_Vge_si_Ve_di=(+Dvsat_Vge_si_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Ve_di+(0.0)*qia_Vge_si+(0.5*PTWG_a)*qia_Vge_si_Ve_di)*dqi+((0.5*PTWG_a)*qia_Vge_si)*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi_Vge_si+((0.5*PTWG_a)*qia)*dqi_Vge_si_Ve_di)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si_Ve_di));
  Dvsat_Vge_si_Vge_si=(+Dvsat_Vge_si_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vge_si+(0.0)*qia_Vge_si+(0.5*PTWG_a)*qia_Vge_si_Vge_si)*dqi+((0.5*PTWG_a)*qia_Vge_si)*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi_Vge_si+((0.5*PTWG_a)*qia)*dqi_Vge_si_Vge_si)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si_Vge_si));
  Dvsat_Vge_si_Vdi_si=(+Dvsat_Vge_si_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*0.0+0.5*0.0)*qia+0.0*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*qia_Vge_si+(0.5*PTWG_a)*qia_Vge_si_Vdi_si)*dqi+((0.5*PTWG_a)*qia_Vge_si)*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi_Vge_si+((0.5*PTWG_a)*qia)*dqi_Vge_si_Vdi_si)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si_Vdi_si));
  Dvsat_Vge_si_Tempt_GND=(+Dvsat_Vge_si_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*0.0+0.5*0.0)*qia+0.0*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*qia_Vge_si+(0.5*PTWG_a)*qia_Vge_si_Tempt_GND)*dqi+((0.5*PTWG_a)*qia_Vge_si)*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi_Vge_si+((0.5*PTWG_a)*qia)*dqi_Vge_si_Tempt_GND)*dqi+((((0.5*PTWG_a)*qia_Vge_si)*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si))*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*dqi_Vge_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vge_si_Tempt_GND));
#endif
Dvsat_Vdi_si=(Dvsat_Vdi_si+(((((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi)+((((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si)));
#if defined(_DERIVATE2)
  Dvsat_Vdi_si_Vge_e=(+Dvsat_Vdi_si_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Vdi_si+0.5*0.0)*qia+(0.5*PTWG_a_Vdi_si)*0.0+(0.0)*qia_Vdi_si+(0.5*PTWG_a)*0.0)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*0.0+((0.0)*qia)*dqi_Vdi_si+((0.5*PTWG_a)*qia)*0.0)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*0.0+(((0.0)*qia)*dqi)*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Vdi_si_Ve_si=(+Dvsat_Vdi_si_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Vdi_si+0.5*0.0)*qia+(0.5*PTWG_a_Vdi_si)*qia_Ve_si+(0.0)*qia_Vdi_si+(0.5*PTWG_a)*qia_Vdi_si_Ve_si)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi_Vdi_si+((0.5*PTWG_a)*qia)*dqi_Vdi_si_Ve_si)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si_Ve_si));
  Dvsat_Vdi_si_Ve_di=(+Dvsat_Vdi_si_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Vdi_si+0.5*0.0)*qia+(0.5*PTWG_a_Vdi_si)*qia_Ve_di+(0.0)*qia_Vdi_si+(0.5*PTWG_a)*qia_Vdi_si_Ve_di)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi_Vdi_si+((0.5*PTWG_a)*qia)*dqi_Vdi_si_Ve_di)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si_Ve_di));
  Dvsat_Vdi_si_Vge_si=(+Dvsat_Vdi_si_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Vdi_si+0.5*0.0)*qia+(0.5*PTWG_a_Vdi_si)*qia_Vge_si+(0.0)*qia_Vdi_si+(0.5*PTWG_a)*qia_Vdi_si_Vge_si)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi_Vdi_si+((0.5*PTWG_a)*qia)*dqi_Vdi_si_Vge_si)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si_Vge_si));
  Dvsat_Vdi_si_Vdi_si=(+Dvsat_Vdi_si_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*PTWG_a_Vdi_si+0.5*PTWG_a_Vdi_si_Vdi_si)*qia+(0.5*PTWG_a_Vdi_si)*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*qia_Vdi_si+(0.5*PTWG_a)*qia_Vdi_si_Vdi_si)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi_Vdi_si+((0.5*PTWG_a)*qia)*dqi_Vdi_si_Vdi_si)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si_Vdi_si));
  Dvsat_Vdi_si_Tempt_GND=(+Dvsat_Vdi_si_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*PTWG_a_Vdi_si+0.5*PTWG_a_Vdi_si_Tempt_GND)*qia+(0.5*PTWG_a_Vdi_si)*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*qia_Vdi_si+(0.5*PTWG_a)*qia_Vdi_si_Tempt_GND)*dqi+(((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi_Vdi_si+((0.5*PTWG_a)*qia)*dqi_Vdi_si_Tempt_GND)*dqi+(((((0.5*PTWG_a_Vdi_si)*qia)+((0.5*PTWG_a)*qia_Vdi_si))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si))*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*dqi_Vdi_si+(((0.5*PTWG_a)*qia)*dqi)*dqi_Vdi_si_Tempt_GND));
#endif
Dvsat_Tempt_GND=(Dvsat_Tempt_GND+(((((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi)+((((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND)));
#if defined(_DERIVATE2)
  Dvsat_Tempt_GND_Vge_e=(+Dvsat_Tempt_GND_Vge_e+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Tempt_GND+0.5*0.0)*qia+(0.5*PTWG_a_Tempt_GND)*0.0+(0.0)*qia_Tempt_GND+(0.5*PTWG_a)*0.0)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*0.0+((0.0)*qia)*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*0.0)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*0.0+(((0.0)*qia)*dqi)*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*0.0));
  Dvsat_Tempt_GND_Ve_si=(+Dvsat_Tempt_GND_Ve_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Tempt_GND+0.5*0.0)*qia+(0.5*PTWG_a_Tempt_GND)*qia_Ve_si+(0.0)*qia_Tempt_GND+(0.5*PTWG_a)*qia_Tempt_GND_Ve_si)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi_Ve_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*dqi_Tempt_GND_Ve_si)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi_Ve_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_si)))*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND_Ve_si));
  Dvsat_Tempt_GND_Ve_di=(+Dvsat_Tempt_GND_Ve_di+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Tempt_GND+0.5*0.0)*qia+(0.5*PTWG_a_Tempt_GND)*qia_Ve_di+(0.0)*qia_Tempt_GND+(0.5*PTWG_a)*qia_Tempt_GND_Ve_di)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi_Ve_di+((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*dqi_Tempt_GND_Ve_di)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi_Ve_di+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Ve_di)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Ve_di)))*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND_Ve_di));
  Dvsat_Tempt_GND_Vge_si=(+Dvsat_Tempt_GND_Vge_si+(+(+(+(+0.0*PTWG_a+0.0*0.0+0.0*PTWG_a_Tempt_GND+0.5*0.0)*qia+(0.5*PTWG_a_Tempt_GND)*qia_Vge_si+(0.0)*qia_Tempt_GND+(0.5*PTWG_a)*qia_Tempt_GND_Vge_si)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi_Vge_si+((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*dqi_Tempt_GND_Vge_si)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi_Vge_si+(((((((0.0)*qia)+((0.5*PTWG_a)*qia_Vge_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vge_si)))*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND_Vge_si));
  Dvsat_Tempt_GND_Vdi_si=(+Dvsat_Tempt_GND_Vdi_si+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Vdi_si+0.0*PTWG_a_Tempt_GND+0.5*PTWG_a_Tempt_GND_Vdi_si)*qia+(0.5*PTWG_a_Tempt_GND)*qia_Vdi_si+((0.5*PTWG_a_Vdi_si))*qia_Tempt_GND+(0.5*PTWG_a)*qia_Tempt_GND_Vdi_si)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi_Vdi_si+(((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*dqi_Tempt_GND_Vdi_si)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi_Vdi_si+((((((((0.5*PTWG_a_Vdi_si))*qia)+((0.5*PTWG_a)*qia_Vdi_si)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Vdi_si)))*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND_Vdi_si));
  Dvsat_Tempt_GND_Tempt_GND=(+Dvsat_Tempt_GND_Tempt_GND+(+(+(+(+0.0*PTWG_a+0.0*PTWG_a_Tempt_GND+0.0*PTWG_a_Tempt_GND+0.5*PTWG_a_Tempt_GND_Tempt_GND)*qia+(0.5*PTWG_a_Tempt_GND)*qia_Tempt_GND+((0.5*PTWG_a_Tempt_GND))*qia_Tempt_GND+(0.5*PTWG_a)*qia_Tempt_GND_Tempt_GND)*dqi+(((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi_Tempt_GND+(((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi_Tempt_GND+((0.5*PTWG_a)*qia)*dqi_Tempt_GND_Tempt_GND)*dqi+(((((0.5*PTWG_a_Tempt_GND)*qia)+((0.5*PTWG_a)*qia_Tempt_GND))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND))*dqi_Tempt_GND+((((((((0.5*PTWG_a_Tempt_GND))*qia)+((0.5*PTWG_a)*qia_Tempt_GND)))*dqi)+(((0.5*PTWG_a)*qia)*dqi_Tempt_GND)))*dqi_Tempt_GND+(((0.5*PTWG_a)*qia)*dqi)*dqi_Tempt_GND_Tempt_GND));
#endif
#endif
Dvsat=(Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi));
EXIT_IF_ISNAN((Dvsat+((((0.5*PTWG_a)*qia)*dqi)*dqi)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(-A2_t*qia_Ve_si/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Ve_si+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Vge_e=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Ve_si+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Ve_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_si+(0.0))+0.0*qia_Ve_si+A2_t*(+qia_Ve_si_Ve_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(qia_Ve_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Ve_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_di+(0.0))+0.0*qia_Ve_si+A2_t*(+qia_Ve_si_Ve_di+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(qia_Ve_di+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Vge_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vge_si+(0.0))+0.0*qia_Ve_si+A2_t*(+qia_Ve_si_Vge_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(qia_Vge_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Vdi_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))+0.0*qia_Ve_si+A2_t*(+qia_Ve_si_Vdi_si+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_si_Tempt_GND=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))+A2_t_Tempt_GND*qia_Ve_si+A2_t*(+qia_Ve_si_Tempt_GND+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_si*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#endif
T0_Ve_di=(-A2_t*qia_Ve_di/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Ve_di+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Vge_e=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Ve_di+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Ve_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_si+(0.0))+0.0*qia_Ve_di+A2_t*(+qia_Ve_di_Ve_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(qia_Ve_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Ve_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_di+(0.0))+0.0*qia_Ve_di+A2_t*(+qia_Ve_di_Ve_di+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(qia_Ve_di+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Vge_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vge_si+(0.0))+0.0*qia_Ve_di+A2_t*(+qia_Ve_di_Vge_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(qia_Vge_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Vdi_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))+0.0*qia_Ve_di+A2_t*(+qia_Ve_di_Vdi_si+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Ve_di_Tempt_GND=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))+A2_t_Tempt_GND*qia_Ve_di+A2_t*(+qia_Ve_di_Tempt_GND+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Ve_di*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#endif
T0_Vge_si=(-A2_t*qia_Vge_si/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Vge_si+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Vge_e=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*qia_Vge_si+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Ve_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_si+(0.0))+0.0*qia_Vge_si+A2_t*(+qia_Vge_si_Ve_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(qia_Ve_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Ve_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_di+(0.0))+0.0*qia_Vge_si+A2_t*(+qia_Vge_si_Ve_di+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(qia_Ve_di+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Vge_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vge_si+(0.0))+0.0*qia_Vge_si+A2_t*(+qia_Vge_si_Vge_si+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(qia_Vge_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Vdi_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))+0.0*qia_Vge_si+A2_t*(+qia_Vge_si_Vdi_si+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vge_si_Tempt_GND=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))+A2_t_Tempt_GND*qia_Vge_si+A2_t*(+qia_Vge_si_Tempt_GND+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*qia_Vge_si*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#endif
T0_Vdi_si=(-A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Vge_e=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(0.0)+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Ve_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_si+(0.0))+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+qia_Vdi_si_Ve_si+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(qia_Ve_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Ve_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Ve_di+(0.0))+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+qia_Vdi_si_Ve_di+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(qia_Ve_di+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Vge_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vge_si+(0.0))+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+qia_Vdi_si_Vge_si+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(qia_Vge_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Vdi_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))+0.0*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+qia_Vdi_si_Vdi_si+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Vdi_si_Tempt_GND=(+0.0+(0.0/(qia+(2.0*nVtm))-(0.0*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))+A2_t_Tempt_GND*(qia_Vdi_si+(2.0*nVtm_Vdi_si))+A2_t*(+qia_Vdi_si_Tempt_GND+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Vdi_si+(2.0*nVtm_Vdi_si))*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#endif
T0_Tempt_GND=(A1_t_Tempt_GND+((A2_t_Tempt_GND*(qia+(2.0*nVtm))-A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(0.0)+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Vge_e=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(0.0)+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+0.0+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(0.0)/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Ve_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(qia_Ve_si+(0.0))+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+qia_Tempt_GND_Ve_si+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(qia_Ve_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Ve_di=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(qia_Ve_di+(0.0))+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+qia_Tempt_GND_Ve_di+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(qia_Ve_di+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Vge_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(qia_Vge_si+(0.0))+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+qia_Tempt_GND_Vge_si+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(qia_Vge_si+(0.0))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Vdi_si=(+0.0+(0.0/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))+0.0*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+qia_Tempt_GND_Vdi_si+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(qia_Vdi_si+((2.0*nVtm_Vdi_si)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
  T0_Tempt_GND_Tempt_GND=(+A1_t_Tempt_GND_Tempt_GND+(A2_t_Tempt_GND_Tempt_GND/(qia+(2.0*nVtm))-(A2_t_Tempt_GND*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))+A2_t_Tempt_GND*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))+A2_t*(+qia_Tempt_GND_Tempt_GND+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))+2*A2_t*(qia_Tempt_GND+(2.0*nVtm_Tempt_GND))*(qia_Tempt_GND+((2.0*nVtm_Tempt_GND)))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))/(qia+(2.0*nVtm))));
#endif
#endif
T0=(A1_t+(A2_t/(qia+(2.0*nVtm))));
EXIT_IF_ISNAN((A1_t+(A2_t/(qia+(2.0*nVtm)))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=T0_Vge_e*dqi*dqi;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*dqi+T0_Vge_e*0.0+0.0*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*0.0+(0.0)*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*dqi+T0_Vge_e*0.0+0.0*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*0.0+(0.0)*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*dqi+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*0.0+(T0_Vge_di*dqi)*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*dqi+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*0.0+(T0_Vge_e*dqi)*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*dqi+T0_Vge_e*dqi_Ve_si+T0_Ve_si*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*dqi+T0_Vge_e*dqi_Ve_di+T0_Ve_di*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*dqi+T0_Vge_e*dqi_Vge_si+T0_Vge_si*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*dqi+T0_Vge_e*dqi_Vdi_si+T0_Vdi_si*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*0.0+(T0*dqi)*0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*dqi+T0_Vge_e*dqi_Tempt_GND+T0_Tempt_GND*0.0+T0*0.0)*dqi+T0_Vge_e*dqi*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*0.0+(T0*dqi)*0.0);
#endif
T1_Ve_si=((((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi)+((T0*dqi)*dqi_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*dqi+T0_Ve_si*0.0+0.0*dqi_Ve_si+T0*0.0)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*0.0+(0.0)*dqi_Ve_si+(T0*dqi)*0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*dqi+T0_Ve_si*0.0+0.0*dqi_Ve_si+T0*0.0)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*0.0+(0.0)*dqi_Ve_si+(T0*dqi)*0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*dqi+T0_Ve_si*0.0+T0_Vge_di*dqi_Ve_si+T0*0.0)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*0.0+(T0_Vge_di*dqi)*dqi_Ve_si+(T0*dqi)*0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*dqi+T0_Ve_si*0.0+T0_Vge_e*dqi_Ve_si+T0*0.0)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*0.0+(T0_Vge_e*dqi)*dqi_Ve_si+(T0*dqi)*0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*dqi+T0_Ve_si*dqi_Ve_si+T0_Ve_si*dqi_Ve_si+T0*dqi_Ve_si_Ve_si)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*dqi_Ve_si+(T0*dqi)*dqi_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*dqi+T0_Ve_si*dqi_Ve_di+T0_Ve_di*dqi_Ve_si+T0*dqi_Ve_si_Ve_di)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*dqi_Ve_si+(T0*dqi)*dqi_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*dqi+T0_Ve_si*dqi_Vge_si+T0_Vge_si*dqi_Ve_si+T0*dqi_Ve_si_Vge_si)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*dqi_Ve_si+(T0*dqi)*dqi_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*dqi+T0_Ve_si*dqi_Vdi_si+T0_Vdi_si*dqi_Ve_si+T0*dqi_Ve_si_Vdi_si)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*dqi_Ve_si+(T0*dqi)*dqi_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*dqi+T0_Ve_si*dqi_Tempt_GND+T0_Tempt_GND*dqi_Ve_si+T0*dqi_Ve_si_Tempt_GND)*dqi+((T0_Ve_si*dqi)+(T0*dqi_Ve_si))*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*dqi_Ve_si+(T0*dqi)*dqi_Ve_si_Tempt_GND);
#endif
T1_Ve_di=((((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi)+((T0*dqi)*dqi_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*dqi+T0_Ve_di*0.0+0.0*dqi_Ve_di+T0*0.0)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*0.0+(0.0)*dqi_Ve_di+(T0*dqi)*0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*dqi+T0_Ve_di*0.0+0.0*dqi_Ve_di+T0*0.0)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*0.0+(0.0)*dqi_Ve_di+(T0*dqi)*0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*dqi+T0_Ve_di*0.0+T0_Vge_di*dqi_Ve_di+T0*0.0)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*0.0+(T0_Vge_di*dqi)*dqi_Ve_di+(T0*dqi)*0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*dqi+T0_Ve_di*0.0+T0_Vge_e*dqi_Ve_di+T0*0.0)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*0.0+(T0_Vge_e*dqi)*dqi_Ve_di+(T0*dqi)*0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*dqi+T0_Ve_di*dqi_Ve_si+T0_Ve_si*dqi_Ve_di+T0*dqi_Ve_di_Ve_si)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*dqi_Ve_di+(T0*dqi)*dqi_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*dqi+T0_Ve_di*dqi_Ve_di+T0_Ve_di*dqi_Ve_di+T0*dqi_Ve_di_Ve_di)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*dqi_Ve_di+(T0*dqi)*dqi_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*dqi+T0_Ve_di*dqi_Vge_si+T0_Vge_si*dqi_Ve_di+T0*dqi_Ve_di_Vge_si)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*dqi_Ve_di+(T0*dqi)*dqi_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*dqi+T0_Ve_di*dqi_Vdi_si+T0_Vdi_si*dqi_Ve_di+T0*dqi_Ve_di_Vdi_si)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*dqi_Ve_di+(T0*dqi)*dqi_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*dqi+T0_Ve_di*dqi_Tempt_GND+T0_Tempt_GND*dqi_Ve_di+T0*dqi_Ve_di_Tempt_GND)*dqi+((T0_Ve_di*dqi)+(T0*dqi_Ve_di))*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*dqi_Ve_di+(T0*dqi)*dqi_Ve_di_Tempt_GND);
#endif
T1_Vge_si=((((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi)+((T0*dqi)*dqi_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*dqi+T0_Vge_si*0.0+0.0*dqi_Vge_si+T0*0.0)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*0.0+(0.0)*dqi_Vge_si+(T0*dqi)*0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*dqi+T0_Vge_si*0.0+0.0*dqi_Vge_si+T0*0.0)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*0.0+(0.0)*dqi_Vge_si+(T0*dqi)*0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*dqi+T0_Vge_si*0.0+T0_Vge_di*dqi_Vge_si+T0*0.0)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*0.0+(T0_Vge_di*dqi)*dqi_Vge_si+(T0*dqi)*0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*dqi+T0_Vge_si*0.0+T0_Vge_e*dqi_Vge_si+T0*0.0)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*0.0+(T0_Vge_e*dqi)*dqi_Vge_si+(T0*dqi)*0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*dqi+T0_Vge_si*dqi_Ve_si+T0_Ve_si*dqi_Vge_si+T0*dqi_Vge_si_Ve_si)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*dqi_Vge_si+(T0*dqi)*dqi_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*dqi+T0_Vge_si*dqi_Ve_di+T0_Ve_di*dqi_Vge_si+T0*dqi_Vge_si_Ve_di)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*dqi_Vge_si+(T0*dqi)*dqi_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*dqi+T0_Vge_si*dqi_Vge_si+T0_Vge_si*dqi_Vge_si+T0*dqi_Vge_si_Vge_si)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*dqi_Vge_si+(T0*dqi)*dqi_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*dqi+T0_Vge_si*dqi_Vdi_si+T0_Vdi_si*dqi_Vge_si+T0*dqi_Vge_si_Vdi_si)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*dqi_Vge_si+(T0*dqi)*dqi_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*dqi+T0_Vge_si*dqi_Tempt_GND+T0_Tempt_GND*dqi_Vge_si+T0*dqi_Vge_si_Tempt_GND)*dqi+((T0_Vge_si*dqi)+(T0*dqi_Vge_si))*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*dqi_Vge_si+(T0*dqi)*dqi_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=((((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi)+((T0*dqi)*dqi_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*dqi+T0_Vdi_si*0.0+0.0*dqi_Vdi_si+T0*0.0)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*0.0+(0.0)*dqi_Vdi_si+(T0*dqi)*0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*dqi+T0_Vdi_si*0.0+0.0*dqi_Vdi_si+T0*0.0)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*0.0+(0.0)*dqi_Vdi_si+(T0*dqi)*0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*dqi+T0_Vdi_si*0.0+T0_Vge_di*dqi_Vdi_si+T0*0.0)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*0.0+(T0_Vge_di*dqi)*dqi_Vdi_si+(T0*dqi)*0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*dqi+T0_Vdi_si*0.0+T0_Vge_e*dqi_Vdi_si+T0*0.0)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*0.0+(T0_Vge_e*dqi)*dqi_Vdi_si+(T0*dqi)*0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*dqi+T0_Vdi_si*dqi_Ve_si+T0_Ve_si*dqi_Vdi_si+T0*dqi_Vdi_si_Ve_si)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*dqi_Vdi_si+(T0*dqi)*dqi_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*dqi+T0_Vdi_si*dqi_Ve_di+T0_Ve_di*dqi_Vdi_si+T0*dqi_Vdi_si_Ve_di)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*dqi_Vdi_si+(T0*dqi)*dqi_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*dqi+T0_Vdi_si*dqi_Vge_si+T0_Vge_si*dqi_Vdi_si+T0*dqi_Vdi_si_Vge_si)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*dqi_Vdi_si+(T0*dqi)*dqi_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*dqi+T0_Vdi_si*dqi_Vdi_si+T0_Vdi_si*dqi_Vdi_si+T0*dqi_Vdi_si_Vdi_si)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*dqi_Vdi_si+(T0*dqi)*dqi_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*dqi+T0_Vdi_si*dqi_Tempt_GND+T0_Tempt_GND*dqi_Vdi_si+T0*dqi_Vdi_si_Tempt_GND)*dqi+((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si))*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*dqi_Vdi_si+(T0*dqi)*dqi_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=((((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi)+((T0*dqi)*dqi_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*dqi+T0_Tempt_GND*0.0+0.0*dqi_Tempt_GND+T0*0.0)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*0.0+(0.0)*dqi_Tempt_GND+(T0*dqi)*0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*dqi+T0_Tempt_GND*0.0+0.0*dqi_Tempt_GND+T0*0.0)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*0.0+(0.0)*dqi_Tempt_GND+(T0*dqi)*0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*dqi+T0_Tempt_GND*0.0+T0_Vge_di*dqi_Tempt_GND+T0*0.0)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*0.0+(T0_Vge_di*dqi)*dqi_Tempt_GND+(T0*dqi)*0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*dqi+T0_Tempt_GND*0.0+T0_Vge_e*dqi_Tempt_GND+T0*0.0)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*0.0+(T0_Vge_e*dqi)*dqi_Tempt_GND+(T0*dqi)*0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*dqi+T0_Tempt_GND*dqi_Ve_si+T0_Ve_si*dqi_Tempt_GND+T0*dqi_Tempt_GND_Ve_si)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi_Ve_si+(((T0_Ve_si*dqi)+(T0*dqi_Ve_si)))*dqi_Tempt_GND+(T0*dqi)*dqi_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*dqi+T0_Tempt_GND*dqi_Ve_di+T0_Ve_di*dqi_Tempt_GND+T0*dqi_Tempt_GND_Ve_di)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi_Ve_di+(((T0_Ve_di*dqi)+(T0*dqi_Ve_di)))*dqi_Tempt_GND+(T0*dqi)*dqi_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*dqi+T0_Tempt_GND*dqi_Vge_si+T0_Vge_si*dqi_Tempt_GND+T0*dqi_Tempt_GND_Vge_si)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi_Vge_si+(((T0_Vge_si*dqi)+(T0*dqi_Vge_si)))*dqi_Tempt_GND+(T0*dqi)*dqi_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*dqi+T0_Tempt_GND*dqi_Vdi_si+T0_Vdi_si*dqi_Tempt_GND+T0*dqi_Tempt_GND_Vdi_si)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi_Vdi_si+(((T0_Vdi_si*dqi)+(T0*dqi_Vdi_si)))*dqi_Tempt_GND+(T0*dqi)*dqi_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*dqi+T0_Tempt_GND*dqi_Tempt_GND+T0_Tempt_GND*dqi_Tempt_GND+T0*dqi_Tempt_GND_Tempt_GND)*dqi+((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND))*dqi_Tempt_GND+(((T0_Tempt_GND*dqi)+(T0*dqi_Tempt_GND)))*dqi_Tempt_GND+(T0*dqi)*dqi_Tempt_GND_Tempt_GND);
#endif
#endif
T1=((T0*dqi)*dqi);
EXIT_IF_ISNAN(((T0*dqi)*dqi))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=T1_Vge_e;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+(+T1_Vge_e_Vdi_d+0.0)-0.0);
  T2_Vge_e_Vsi_s=(+(+T1_Vge_e_Vsi_s+0.0)-0.0);
  T2_Vge_e_Vge_di=(+(+T1_Vge_e_Vge_di+0.0)-0.0);
  T2_Vge_e_Vge_e=(+(+T1_Vge_e_Vge_e+0.0)-0.0);
  T2_Vge_e_Vge_si=(+(+T1_Vge_e_Vge_si+0.0)-0.0);
  T2_Vge_e_Ve_si=(+(+T1_Vge_e_Ve_si+0.0)-0.0);
  T2_Vge_e_Ve_di=(+(+T1_Vge_e_Ve_di+0.0)-0.0);
  T2_Vge_e_Vdi_si=(+(+T1_Vge_e_Vdi_si+0.0)-0.0);
  T2_Vge_e_Tempt_GND=(+(+T1_Vge_e_Tempt_GND+0.0)-0.0);
#endif
T2_Vge_si=T1_Vge_si;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+(+T1_Vge_si_Vdi_d+0.0)-0.0);
  T2_Vge_si_Vsi_s=(+(+T1_Vge_si_Vsi_s+0.0)-0.0);
  T2_Vge_si_Vge_di=(+(+T1_Vge_si_Vge_di+0.0)-0.0);
  T2_Vge_si_Vge_e=(+(+T1_Vge_si_Vge_e+0.0)-0.0);
  T2_Vge_si_Vge_si=(+(+T1_Vge_si_Vge_si+0.0)-0.0);
  T2_Vge_si_Ve_si=(+(+T1_Vge_si_Ve_si+0.0)-0.0);
  T2_Vge_si_Ve_di=(+(+T1_Vge_si_Ve_di+0.0)-0.0);
  T2_Vge_si_Vdi_si=(+(+T1_Vge_si_Vdi_si+0.0)-0.0);
  T2_Vge_si_Tempt_GND=(+(+T1_Vge_si_Tempt_GND+0.0)-0.0);
#endif
T2_Ve_si=T1_Ve_si;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+T1_Ve_si_Vdi_d+0.0)-0.0);
  T2_Ve_si_Vsi_s=(+(+T1_Ve_si_Vsi_s+0.0)-0.0);
  T2_Ve_si_Vge_di=(+(+T1_Ve_si_Vge_di+0.0)-0.0);
  T2_Ve_si_Vge_e=(+(+T1_Ve_si_Vge_e+0.0)-0.0);
  T2_Ve_si_Vge_si=(+(+T1_Ve_si_Vge_si+0.0)-0.0);
  T2_Ve_si_Ve_si=(+(+T1_Ve_si_Ve_si+0.0)-0.0);
  T2_Ve_si_Ve_di=(+(+T1_Ve_si_Ve_di+0.0)-0.0);
  T2_Ve_si_Vdi_si=(+(+T1_Ve_si_Vdi_si+0.0)-0.0);
  T2_Ve_si_Tempt_GND=(+(+T1_Ve_si_Tempt_GND+0.0)-0.0);
#endif
T2_Ve_di=T1_Ve_di;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+T1_Ve_di_Vdi_d+0.0)-0.0);
  T2_Ve_di_Vsi_s=(+(+T1_Ve_di_Vsi_s+0.0)-0.0);
  T2_Ve_di_Vge_di=(+(+T1_Ve_di_Vge_di+0.0)-0.0);
  T2_Ve_di_Vge_e=(+(+T1_Ve_di_Vge_e+0.0)-0.0);
  T2_Ve_di_Vge_si=(+(+T1_Ve_di_Vge_si+0.0)-0.0);
  T2_Ve_di_Ve_si=(+(+T1_Ve_di_Ve_si+0.0)-0.0);
  T2_Ve_di_Ve_di=(+(+T1_Ve_di_Ve_di+0.0)-0.0);
  T2_Ve_di_Vdi_si=(+(+T1_Ve_di_Vdi_si+0.0)-0.0);
  T2_Ve_di_Tempt_GND=(+(+T1_Ve_di_Tempt_GND+0.0)-0.0);
#endif
T2_Vdi_si=T1_Vdi_si;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+T1_Vdi_si_Vdi_d+0.0)-0.0);
  T2_Vdi_si_Vsi_s=(+(+T1_Vdi_si_Vsi_s+0.0)-0.0);
  T2_Vdi_si_Vge_di=(+(+T1_Vdi_si_Vge_di+0.0)-0.0);
  T2_Vdi_si_Vge_e=(+(+T1_Vdi_si_Vge_e+0.0)-0.0);
  T2_Vdi_si_Vge_si=(+(+T1_Vdi_si_Vge_si+0.0)-0.0);
  T2_Vdi_si_Ve_si=(+(+T1_Vdi_si_Ve_si+0.0)-0.0);
  T2_Vdi_si_Ve_di=(+(+T1_Vdi_si_Ve_di+0.0)-0.0);
  T2_Vdi_si_Vdi_si=(+(+T1_Vdi_si_Vdi_si+0.0)-0.0);
  T2_Vdi_si_Tempt_GND=(+(+T1_Vdi_si_Tempt_GND+0.0)-0.0);
#endif
T2_Tempt_GND=T1_Tempt_GND;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+(+T1_Tempt_GND_Vdi_d+0.0)-0.0);
  T2_Tempt_GND_Vsi_s=(+(+T1_Tempt_GND_Vsi_s+0.0)-0.0);
  T2_Tempt_GND_Vge_di=(+(+T1_Tempt_GND_Vge_di+0.0)-0.0);
  T2_Tempt_GND_Vge_e=(+(+T1_Tempt_GND_Vge_e+0.0)-0.0);
  T2_Tempt_GND_Vge_si=(+(+T1_Tempt_GND_Vge_si+0.0)-0.0);
  T2_Tempt_GND_Ve_si=(+(+T1_Tempt_GND_Ve_si+0.0)-0.0);
  T2_Tempt_GND_Ve_di=(+(+T1_Tempt_GND_Ve_di+0.0)-0.0);
  T2_Tempt_GND_Vdi_si=(+(+T1_Tempt_GND_Vdi_si+0.0)-0.0);
  T2_Tempt_GND_Tempt_GND=(+(+T1_Tempt_GND_Tempt_GND+0.0)-0.0);
#endif
#endif
T2=((T1+1.0)-0.001);
EXIT_IF_ISNAN(((T1+1.0)-0.001))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+0.004))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+0.004))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=(0.5*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_d*T2+T2_Vge_e*T2_Vdi_d+T2_Vdi_d*T2_Vge_e+T2*T2_Vge_e_Vdi_d)+0.0)))));
  T3_Vge_e_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vsi_s*T2+T2_Vge_e*T2_Vsi_s+T2_Vsi_s*T2_Vge_e+T2*T2_Vge_e_Vsi_s)+0.0)))));
  T3_Vge_e_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_di*T2+T2_Vge_e*T2_Vge_di+T2_Vge_di*T2_Vge_e+T2*T2_Vge_e_Vge_di)+0.0)))));
  T3_Vge_e_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_e*T2+T2_Vge_e*T2_Vge_e+T2_Vge_e*T2_Vge_e+T2*T2_Vge_e_Vge_e)+0.0)))));
  T3_Vge_e_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_si*T2+T2_Vge_e*T2_Vdi_si+T2_Vdi_si*T2_Vge_e+T2*T2_Vge_e_Vdi_si)+0.0)))));
  T3_Vge_e_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_si*T2+T2_Vge_e*T2_Ve_si+T2_Ve_si*T2_Vge_e+T2*T2_Vge_e_Ve_si)+0.0)))));
  T3_Vge_e_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_di*T2+T2_Vge_e*T2_Ve_di+T2_Ve_di*T2_Vge_e+T2*T2_Vge_e_Ve_di)+0.0)))));
  T3_Vge_e_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_si*T2+T2_Vge_e*T2_Vge_si+T2_Vge_si*T2_Vge_e+T2*T2_Vge_e_Vge_si)+0.0)))));
  T3_Vge_e_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vge_e+((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0)+0.5*(+T2_Vge_e_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Tempt_GND*T2+T2_Vge_e*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_e+T2*T2_Vge_e_Tempt_GND)+0.0)))));
#endif
T3_Vdi_si=(0.5*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_d*T2+T2_Vdi_si*T2_Vdi_d+T2_Vdi_d*T2_Vdi_si+T2*T2_Vdi_si_Vdi_d)+0.0)))));
  T3_Vdi_si_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vsi_s*T2+T2_Vdi_si*T2_Vsi_s+T2_Vsi_s*T2_Vdi_si+T2*T2_Vdi_si_Vsi_s)+0.0)))));
  T3_Vdi_si_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_di*T2+T2_Vdi_si*T2_Vge_di+T2_Vge_di*T2_Vdi_si+T2*T2_Vdi_si_Vge_di)+0.0)))));
  T3_Vdi_si_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_e*T2+T2_Vdi_si*T2_Vge_e+T2_Vge_e*T2_Vdi_si+T2*T2_Vdi_si_Vge_e)+0.0)))));
  T3_Vdi_si_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_si*T2+T2_Vdi_si*T2_Vdi_si+T2_Vdi_si*T2_Vdi_si+T2*T2_Vdi_si_Vdi_si)+0.0)))));
  T3_Vdi_si_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_si*T2+T2_Vdi_si*T2_Ve_si+T2_Ve_si*T2_Vdi_si+T2*T2_Vdi_si_Ve_si)+0.0)))));
  T3_Vdi_si_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_di*T2+T2_Vdi_si*T2_Ve_di+T2_Ve_di*T2_Vdi_si+T2*T2_Vdi_si_Ve_di)+0.0)))));
  T3_Vdi_si_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_si*T2+T2_Vdi_si*T2_Vge_si+T2_Vge_si*T2_Vdi_si+T2*T2_Vdi_si_Vge_si)+0.0)))));
  T3_Vdi_si_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vdi_si+((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0)+0.5*(+T2_Vdi_si_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Tempt_GND*T2+T2_Vdi_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_si+T2*T2_Vdi_si_Tempt_GND)+0.0)))));
#endif
T3_Ve_si=(0.5*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_d*T2+T2_Ve_si*T2_Vdi_d+T2_Vdi_d*T2_Ve_si+T2*T2_Ve_si_Vdi_d)+0.0)))));
  T3_Ve_si_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vsi_s*T2+T2_Ve_si*T2_Vsi_s+T2_Vsi_s*T2_Ve_si+T2*T2_Ve_si_Vsi_s)+0.0)))));
  T3_Ve_si_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_di*T2+T2_Ve_si*T2_Vge_di+T2_Vge_di*T2_Ve_si+T2*T2_Ve_si_Vge_di)+0.0)))));
  T3_Ve_si_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_e*T2+T2_Ve_si*T2_Vge_e+T2_Vge_e*T2_Ve_si+T2*T2_Ve_si_Vge_e)+0.0)))));
  T3_Ve_si_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_si*T2+T2_Ve_si*T2_Vdi_si+T2_Vdi_si*T2_Ve_si+T2*T2_Ve_si_Vdi_si)+0.0)))));
  T3_Ve_si_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_si*T2+T2_Ve_si*T2_Ve_si+T2_Ve_si*T2_Ve_si+T2*T2_Ve_si_Ve_si)+0.0)))));
  T3_Ve_si_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_di*T2+T2_Ve_si*T2_Ve_di+T2_Ve_di*T2_Ve_si+T2*T2_Ve_si_Ve_di)+0.0)))));
  T3_Ve_si_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_si*T2+T2_Ve_si*T2_Vge_si+T2_Vge_si*T2_Ve_si+T2*T2_Ve_si_Vge_si)+0.0)))));
  T3_Ve_si_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Ve_si+((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0)+0.5*(+T2_Ve_si_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Tempt_GND*T2+T2_Ve_si*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_si+T2*T2_Ve_si_Tempt_GND)+0.0)))));
#endif
T3_Ve_di=(0.5*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_d*T2+T2_Ve_di*T2_Vdi_d+T2_Vdi_d*T2_Ve_di+T2*T2_Ve_di_Vdi_d)+0.0)))));
  T3_Ve_di_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vsi_s*T2+T2_Ve_di*T2_Vsi_s+T2_Vsi_s*T2_Ve_di+T2*T2_Ve_di_Vsi_s)+0.0)))));
  T3_Ve_di_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_di*T2+T2_Ve_di*T2_Vge_di+T2_Vge_di*T2_Ve_di+T2*T2_Ve_di_Vge_di)+0.0)))));
  T3_Ve_di_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_e*T2+T2_Ve_di*T2_Vge_e+T2_Vge_e*T2_Ve_di+T2*T2_Ve_di_Vge_e)+0.0)))));
  T3_Ve_di_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_si*T2+T2_Ve_di*T2_Vdi_si+T2_Vdi_si*T2_Ve_di+T2*T2_Ve_di_Vdi_si)+0.0)))));
  T3_Ve_di_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_si*T2+T2_Ve_di*T2_Ve_si+T2_Ve_si*T2_Ve_di+T2*T2_Ve_di_Ve_si)+0.0)))));
  T3_Ve_di_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_di*T2+T2_Ve_di*T2_Ve_di+T2_Ve_di*T2_Ve_di+T2*T2_Ve_di_Ve_di)+0.0)))));
  T3_Ve_di_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_si*T2+T2_Ve_di*T2_Vge_si+T2_Vge_si*T2_Ve_di+T2*T2_Ve_di_Vge_si)+0.0)))));
  T3_Ve_di_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Ve_di+((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0)+0.5*(+T2_Ve_di_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Tempt_GND*T2+T2_Ve_di*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_di+T2*T2_Ve_di_Tempt_GND)+0.0)))));
#endif
T3_Vge_si=(0.5*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_d*T2+T2_Vge_si*T2_Vdi_d+T2_Vdi_d*T2_Vge_si+T2*T2_Vge_si_Vdi_d)+0.0)))));
  T3_Vge_si_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vsi_s*T2+T2_Vge_si*T2_Vsi_s+T2_Vsi_s*T2_Vge_si+T2*T2_Vge_si_Vsi_s)+0.0)))));
  T3_Vge_si_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_di*T2+T2_Vge_si*T2_Vge_di+T2_Vge_di*T2_Vge_si+T2*T2_Vge_si_Vge_di)+0.0)))));
  T3_Vge_si_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_e*T2+T2_Vge_si*T2_Vge_e+T2_Vge_e*T2_Vge_si+T2*T2_Vge_si_Vge_e)+0.0)))));
  T3_Vge_si_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_si*T2+T2_Vge_si*T2_Vdi_si+T2_Vdi_si*T2_Vge_si+T2*T2_Vge_si_Vdi_si)+0.0)))));
  T3_Vge_si_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_si*T2+T2_Vge_si*T2_Ve_si+T2_Ve_si*T2_Vge_si+T2*T2_Vge_si_Ve_si)+0.0)))));
  T3_Vge_si_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_di*T2+T2_Vge_si*T2_Ve_di+T2_Ve_di*T2_Vge_si+T2*T2_Vge_si_Ve_di)+0.0)))));
  T3_Vge_si_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_si*T2+T2_Vge_si*T2_Vge_si+T2_Vge_si*T2_Vge_si+T2*T2_Vge_si_Vge_si)+0.0)))));
  T3_Vge_si_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Vge_si+((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0)+0.5*(+T2_Vge_si_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Tempt_GND*T2+T2_Vge_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_si+T2*T2_Vge_si_Tempt_GND)+0.0)))));
#endif
T3_Tempt_GND=(0.5*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_d+(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vdi_d+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_d*T2+T2_Tempt_GND*T2_Vdi_d+T2_Vdi_d*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_d)+0.0)))));
  T3_Tempt_GND_Vsi_s=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vsi_s+(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vsi_s+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vsi_s*T2+T2_Tempt_GND*T2_Vsi_s+T2_Vsi_s*T2_Tempt_GND+T2*T2_Tempt_GND_Vsi_s)+0.0)))));
  T3_Tempt_GND_Vge_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_di+(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vge_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_di*T2+T2_Tempt_GND*T2_Vge_di+T2_Vge_di*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_di)+0.0)))));
  T3_Tempt_GND_Vge_e=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_e+(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vge_e+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_e*T2+T2_Tempt_GND*T2_Vge_e+T2_Vge_e*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_e)+0.0)))));
  T3_Tempt_GND_Vdi_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vdi_si+(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vdi_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_si*T2+T2_Tempt_GND*T2_Vdi_si+T2_Vdi_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_si)+0.0)))));
  T3_Tempt_GND_Ve_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_si+(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Ve_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_si*T2+T2_Tempt_GND*T2_Ve_si+T2_Ve_si*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_si)+0.0)))));
  T3_Tempt_GND_Ve_di=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Ve_di+(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Ve_di+(m20_sqrt(((T2*T2)+0.004))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_di*T2+T2_Tempt_GND*T2_Ve_di+T2_Ve_di*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_di)+0.0)))));
  T3_Tempt_GND_Vge_si=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Vge_si+(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Vge_si+(m20_sqrt(((T2*T2)+0.004))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_si*T2+T2_Tempt_GND*T2_Vge_si+T2_Vge_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_si)+0.0)))));
  T3_Tempt_GND_Tempt_GND=(+0.0+(+0.0*(T2+d00_sqrt0)+0.0*(T2_Tempt_GND+(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*d10_sqrt0)+0.0*(T2_Tempt_GND+((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0)+0.5*(+T2_Tempt_GND_Tempt_GND+(m20_sqrt(((T2*T2)+0.004))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Tempt_GND*T2+T2_Tempt_GND*T2_Tempt_GND+T2_Tempt_GND*T2_Tempt_GND+T2*T2_Tempt_GND_Tempt_GND)+0.0)))));
#endif
#endif
T3=((-1.0)+(0.5*(T2+d00_sqrt0)));
EXIT_IF_ISNAN(((-1.0)+(0.5*(T2+d00_sqrt0))))
}
{
double m00_sqrt(d00_sqrt0,(1.0+T3))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+T3))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Nsat_Vge_e=(0.5*T3_Vge_e*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vge_e_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Vge_e))));
  Nsat_Vge_e_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Vdi_si))));
  Nsat_Vge_e_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Ve_si))));
  Nsat_Vge_e_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Ve_di))));
  Nsat_Vge_e_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Vge_si))));
  Nsat_Vge_e_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vge_e*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vge_e+d10_sqrt0*(+0.0+T3_Vge_e_Tempt_GND))));
#endif
Nsat_Vdi_si=(0.5*T3_Vdi_si*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vdi_si_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Vge_e))));
  Nsat_Vdi_si_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Vdi_si))));
  Nsat_Vdi_si_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Ve_si))));
  Nsat_Vdi_si_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Ve_di))));
  Nsat_Vdi_si_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Vge_si))));
  Nsat_Vdi_si_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vdi_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vdi_si+d10_sqrt0*(+0.0+T3_Vdi_si_Tempt_GND))));
#endif
Nsat_Ve_si=(0.5*T3_Ve_si*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Ve_si_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Vge_e))));
  Nsat_Ve_si_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Vdi_si))));
  Nsat_Ve_si_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Ve_si))));
  Nsat_Ve_si_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Ve_di))));
  Nsat_Ve_si_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Vge_si))));
  Nsat_Ve_si_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Ve_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Ve_si+d10_sqrt0*(+0.0+T3_Ve_si_Tempt_GND))));
#endif
Nsat_Ve_di=(0.5*T3_Ve_di*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Ve_di_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Vge_e))));
  Nsat_Ve_di_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Vdi_si))));
  Nsat_Ve_di_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Ve_si))));
  Nsat_Ve_di_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Ve_di))));
  Nsat_Ve_di_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Vge_si))));
  Nsat_Ve_di_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Ve_di*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Ve_di+d10_sqrt0*(+0.0+T3_Ve_di_Tempt_GND))));
#endif
Nsat_Vge_si=(0.5*T3_Vge_si*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Vge_si_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Vge_e))));
  Nsat_Vge_si_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Vdi_si))));
  Nsat_Vge_si_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Ve_si))));
  Nsat_Vge_si_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Ve_di))));
  Nsat_Vge_si_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Vge_si))));
  Nsat_Vge_si_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Vge_si*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Vge_si+d10_sqrt0*(+0.0+T3_Vge_si_Tempt_GND))));
#endif
Nsat_Tempt_GND=(0.5*T3_Tempt_GND*d10_sqrt0);
#if defined(_DERIVATE2)
  Nsat_Tempt_GND_Vge_e=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_e*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_e*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Vge_e))));
  Nsat_Tempt_GND_Vdi_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vdi_si*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vdi_si*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Vdi_si))));
  Nsat_Tempt_GND_Ve_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_si*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_si*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Ve_si))));
  Nsat_Tempt_GND_Ve_di=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Ve_di*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Ve_di*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Ve_di))));
  Nsat_Tempt_GND_Vge_si=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Vge_si*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Vge_si*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Vge_si))));
  Nsat_Tempt_GND_Tempt_GND=(+0.0*(1.0+d00_sqrt0)+0.0*T3_Tempt_GND*d10_sqrt0+0.0*T3_Tempt_GND*d10_sqrt0+0.5*(+0.0+(m20_sqrt((1.0+T3))*T3_Tempt_GND*T3_Tempt_GND+d10_sqrt0*(+0.0+T3_Tempt_GND_Tempt_GND))));
#endif
#endif
Nsat=(0.5*(1.0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(1.0+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dvsat_Vge_e=((Dvsat_Vge_e*Nsat)+(Dvsat*Nsat_Vge_e));
#if defined(_DERIVATE2)
  Dvsat_Vge_e_Vge_e=(+Dvsat_Vge_e_Vge_e*Nsat+Dvsat_Vge_e*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Vge_e);
  Dvsat_Vge_e_Ve_si=(+Dvsat_Vge_e_Ve_si*Nsat+Dvsat_Vge_e*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Ve_si);
  Dvsat_Vge_e_Ve_di=(+Dvsat_Vge_e_Ve_di*Nsat+Dvsat_Vge_e*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Ve_di);
  Dvsat_Vge_e_Vge_si=(+Dvsat_Vge_e_Vge_si*Nsat+Dvsat_Vge_e*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Vge_si);
  Dvsat_Vge_e_Vdi_si=(+Dvsat_Vge_e_Vdi_si*Nsat+Dvsat_Vge_e*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Vdi_si);
  Dvsat_Vge_e_Tempt_GND=(+Dvsat_Vge_e_Tempt_GND*Nsat+Dvsat_Vge_e*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Vge_e+Dvsat*Nsat_Vge_e_Tempt_GND);
#endif
Dvsat_Ve_si=((Dvsat_Ve_si*Nsat)+(Dvsat*Nsat_Ve_si));
#if defined(_DERIVATE2)
  Dvsat_Ve_si_Vge_e=(+Dvsat_Ve_si_Vge_e*Nsat+Dvsat_Ve_si*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Vge_e);
  Dvsat_Ve_si_Ve_si=(+Dvsat_Ve_si_Ve_si*Nsat+Dvsat_Ve_si*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Ve_si);
  Dvsat_Ve_si_Ve_di=(+Dvsat_Ve_si_Ve_di*Nsat+Dvsat_Ve_si*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Ve_di);
  Dvsat_Ve_si_Vge_si=(+Dvsat_Ve_si_Vge_si*Nsat+Dvsat_Ve_si*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Vge_si);
  Dvsat_Ve_si_Vdi_si=(+Dvsat_Ve_si_Vdi_si*Nsat+Dvsat_Ve_si*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Vdi_si);
  Dvsat_Ve_si_Tempt_GND=(+Dvsat_Ve_si_Tempt_GND*Nsat+Dvsat_Ve_si*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Ve_si+Dvsat*Nsat_Ve_si_Tempt_GND);
#endif
Dvsat_Ve_di=((Dvsat_Ve_di*Nsat)+(Dvsat*Nsat_Ve_di));
#if defined(_DERIVATE2)
  Dvsat_Ve_di_Vge_e=(+Dvsat_Ve_di_Vge_e*Nsat+Dvsat_Ve_di*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Vge_e);
  Dvsat_Ve_di_Ve_si=(+Dvsat_Ve_di_Ve_si*Nsat+Dvsat_Ve_di*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Ve_si);
  Dvsat_Ve_di_Ve_di=(+Dvsat_Ve_di_Ve_di*Nsat+Dvsat_Ve_di*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Ve_di);
  Dvsat_Ve_di_Vge_si=(+Dvsat_Ve_di_Vge_si*Nsat+Dvsat_Ve_di*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Vge_si);
  Dvsat_Ve_di_Vdi_si=(+Dvsat_Ve_di_Vdi_si*Nsat+Dvsat_Ve_di*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Vdi_si);
  Dvsat_Ve_di_Tempt_GND=(+Dvsat_Ve_di_Tempt_GND*Nsat+Dvsat_Ve_di*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Ve_di+Dvsat*Nsat_Ve_di_Tempt_GND);
#endif
Dvsat_Vge_si=((Dvsat_Vge_si*Nsat)+(Dvsat*Nsat_Vge_si));
#if defined(_DERIVATE2)
  Dvsat_Vge_si_Vge_e=(+Dvsat_Vge_si_Vge_e*Nsat+Dvsat_Vge_si*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Vge_e);
  Dvsat_Vge_si_Ve_si=(+Dvsat_Vge_si_Ve_si*Nsat+Dvsat_Vge_si*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Ve_si);
  Dvsat_Vge_si_Ve_di=(+Dvsat_Vge_si_Ve_di*Nsat+Dvsat_Vge_si*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Ve_di);
  Dvsat_Vge_si_Vge_si=(+Dvsat_Vge_si_Vge_si*Nsat+Dvsat_Vge_si*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Vge_si);
  Dvsat_Vge_si_Vdi_si=(+Dvsat_Vge_si_Vdi_si*Nsat+Dvsat_Vge_si*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Vdi_si);
  Dvsat_Vge_si_Tempt_GND=(+Dvsat_Vge_si_Tempt_GND*Nsat+Dvsat_Vge_si*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Vge_si+Dvsat*Nsat_Vge_si_Tempt_GND);
#endif
Dvsat_Vdi_si=((Dvsat_Vdi_si*Nsat)+(Dvsat*Nsat_Vdi_si));
#if defined(_DERIVATE2)
  Dvsat_Vdi_si_Vge_e=(+Dvsat_Vdi_si_Vge_e*Nsat+Dvsat_Vdi_si*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Vge_e);
  Dvsat_Vdi_si_Ve_si=(+Dvsat_Vdi_si_Ve_si*Nsat+Dvsat_Vdi_si*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Ve_si);
  Dvsat_Vdi_si_Ve_di=(+Dvsat_Vdi_si_Ve_di*Nsat+Dvsat_Vdi_si*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Ve_di);
  Dvsat_Vdi_si_Vge_si=(+Dvsat_Vdi_si_Vge_si*Nsat+Dvsat_Vdi_si*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Vge_si);
  Dvsat_Vdi_si_Vdi_si=(+Dvsat_Vdi_si_Vdi_si*Nsat+Dvsat_Vdi_si*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Vdi_si);
  Dvsat_Vdi_si_Tempt_GND=(+Dvsat_Vdi_si_Tempt_GND*Nsat+Dvsat_Vdi_si*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Vdi_si+Dvsat*Nsat_Vdi_si_Tempt_GND);
#endif
Dvsat_Tempt_GND=((Dvsat_Tempt_GND*Nsat)+(Dvsat*Nsat_Tempt_GND));
#if defined(_DERIVATE2)
  Dvsat_Tempt_GND_Vge_e=(+Dvsat_Tempt_GND_Vge_e*Nsat+Dvsat_Tempt_GND*Nsat_Vge_e+Dvsat_Vge_e*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Vge_e);
  Dvsat_Tempt_GND_Ve_si=(+Dvsat_Tempt_GND_Ve_si*Nsat+Dvsat_Tempt_GND*Nsat_Ve_si+Dvsat_Ve_si*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Ve_si);
  Dvsat_Tempt_GND_Ve_di=(+Dvsat_Tempt_GND_Ve_di*Nsat+Dvsat_Tempt_GND*Nsat_Ve_di+Dvsat_Ve_di*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Ve_di);
  Dvsat_Tempt_GND_Vge_si=(+Dvsat_Tempt_GND_Vge_si*Nsat+Dvsat_Tempt_GND*Nsat_Vge_si+Dvsat_Vge_si*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Vge_si);
  Dvsat_Tempt_GND_Vdi_si=(+Dvsat_Tempt_GND_Vdi_si*Nsat+Dvsat_Tempt_GND*Nsat_Vdi_si+Dvsat_Vdi_si*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Vdi_si);
  Dvsat_Tempt_GND_Tempt_GND=(+Dvsat_Tempt_GND_Tempt_GND*Nsat+Dvsat_Tempt_GND*Nsat_Tempt_GND+Dvsat_Tempt_GND*Nsat_Tempt_GND+Dvsat*Nsat_Tempt_GND_Tempt_GND);
#endif
#endif
Dvsat=(Dvsat*Nsat);
EXIT_IF_ISNAN((Dvsat*Nsat))
if
((K0_t!=0))
{
{
double m00_max(d00_max0,0,(K0SI_t+((K0SISAT_t*dqi)*dqi)))
#if defined(_DERIVATEFORDDX)
double m11_max(d11_max0,d00_max0,0,(K0SI_t+((K0SISAT_t*dqi)*dqi)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_e=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Ve_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia_Ve_si+(d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Ve_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia_Ve_di+(d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia_Ve_si+d00_max0*qia_Ve_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia_Vge_si+(d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vdi_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia_Vdi_si+(d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Tempt_GND=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+K0_t_Tempt_GND*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia_Tempt_GND+(d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Ve_si+d00_max0*qia_Ve_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_si)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Ve_di=(-K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_e=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Ve_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia_Ve_si+(d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Ve_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia_Ve_di+(d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia_Ve_di+d00_max0*qia_Ve_di_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia_Vge_si+(d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vdi_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia_Vdi_si+(d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Tempt_GND=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+K0_t_Tempt_GND*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia_Tempt_GND+(d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Ve_di+d00_max0*qia_Ve_di_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Ve_di)*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Vge_si=(-K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_e=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Ve_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia_Ve_si+(d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Ve_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia_Ve_di+(d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia_Vge_si+d00_max0*qia_Vge_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia_Vge_si+(d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vdi_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+0.0*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia_Vdi_si+(d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Tempt_GND=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+K0_t_Tempt_GND*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia_Tempt_GND+(d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Vge_si+d00_max0*qia_Vge_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*(((d11_max0*(((K0SISAT_t*dqi_Vge_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Vdi_si=(-K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_e=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Ve_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia_Ve_si+(d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Ve_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia_Ve_di+(d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia_Vge_si+(d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vdi_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+0.0*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia_Vdi_si+(d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Tempt_GND=(0.0/((d00_max0*qia)+(2.0*nVtm))-(0.0*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+K0_t_Tempt_GND*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+K0_t*(+(+fixme*qia+(d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia_Tempt_GND+(d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(((K0SISAT_t*dqi_Vdi_si)*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Tempt_GND=((K0_t_Tempt_GND*((d00_max0*qia)+(2.0*nVtm))-K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_e=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Ve_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Ve_si+(d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_si))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Ve_di=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Ve_di+(d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K0SISAT_t*dqi_Ve_di))*dqi)+((K0SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Vge_si+(d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K0SISAT_t*dqi_Vge_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vdi_si=(0.0/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+0.0*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Vdi_si+(d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K0SISAT_t*dqi_Vdi_si))*dqi)+((K0SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Tempt_GND=(K0_t_Tempt_GND_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(K0_t_Tempt_GND*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+K0_t_Tempt_GND*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+K0_t*(+(+fixme*qia+(d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Tempt_GND+(d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*K0_t*((((d11_max0*(K0SI_t_Tempt_GND+((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(K0SI_t_Tempt_GND+((((((K0SISAT_t_Tempt_GND*dqi)+(K0SISAT_t*dqi_Tempt_GND)))*dqi)+((K0SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
#endif
T1=(K0_t/((d00_max0*qia)+(2.0*nVtm)));
EXIT_IF_ISNAN((K0_t/((d00_max0*qia)+(2.0*nVtm))))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Mnud_Vge_e=bsimcmg_d_lexp((-T1),(-T1_Vge_e));
#if defined(_DERIVATE2)
  Mnud_Vge_e_Vge_e=0.0;
  Mnud_Vge_e_Ve_si=0.0;
  Mnud_Vge_e_Ve_di=0.0;
  Mnud_Vge_e_Vge_si=0.0;
  Mnud_Vge_e_Vdi_si=0.0;
  Mnud_Vge_e_Tempt_GND=0.0;
#endif
Mnud_Ve_si=bsimcmg_d_lexp((-T1),(-T1_Ve_si));
#if defined(_DERIVATE2)
  Mnud_Ve_si_Vge_e=0.0;
  Mnud_Ve_si_Ve_si=0.0;
  Mnud_Ve_si_Ve_di=0.0;
  Mnud_Ve_si_Vge_si=0.0;
  Mnud_Ve_si_Vdi_si=0.0;
  Mnud_Ve_si_Tempt_GND=0.0;
#endif
Mnud_Ve_di=bsimcmg_d_lexp((-T1),(-T1_Ve_di));
#if defined(_DERIVATE2)
  Mnud_Ve_di_Vge_e=0.0;
  Mnud_Ve_di_Ve_si=0.0;
  Mnud_Ve_di_Ve_di=0.0;
  Mnud_Ve_di_Vge_si=0.0;
  Mnud_Ve_di_Vdi_si=0.0;
  Mnud_Ve_di_Tempt_GND=0.0;
#endif
Mnud_Vge_si=bsimcmg_d_lexp((-T1),(-T1_Vge_si));
#if defined(_DERIVATE2)
  Mnud_Vge_si_Vge_e=0.0;
  Mnud_Vge_si_Ve_si=0.0;
  Mnud_Vge_si_Ve_di=0.0;
  Mnud_Vge_si_Vge_si=0.0;
  Mnud_Vge_si_Vdi_si=0.0;
  Mnud_Vge_si_Tempt_GND=0.0;
#endif
Mnud_Vdi_si=bsimcmg_d_lexp((-T1),(-T1_Vdi_si));
#if defined(_DERIVATE2)
  Mnud_Vdi_si_Vge_e=0.0;
  Mnud_Vdi_si_Ve_si=0.0;
  Mnud_Vdi_si_Ve_di=0.0;
  Mnud_Vdi_si_Vge_si=0.0;
  Mnud_Vdi_si_Vdi_si=0.0;
  Mnud_Vdi_si_Tempt_GND=0.0;
#endif
Mnud_Tempt_GND=bsimcmg_d_lexp((-T1),(-T1_Tempt_GND));
#if defined(_DERIVATE2)
  Mnud_Tempt_GND_Vge_e=0.0;
  Mnud_Tempt_GND_Ve_si=0.0;
  Mnud_Tempt_GND_Ve_di=0.0;
  Mnud_Tempt_GND_Vge_si=0.0;
  Mnud_Tempt_GND_Vdi_si=0.0;
  Mnud_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Mnud=bsimcmg_lexp((-T1));
EXIT_IF_ISNAN(bsimcmg_lexp((-T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Mnud_Vge_e=0.0;
#if defined(_DERIVATE2)
  Mnud_Vge_e_Vge_e=0.0;
  Mnud_Vge_e_Ve_si=0.0;
  Mnud_Vge_e_Ve_di=0.0;
  Mnud_Vge_e_Vge_si=0.0;
  Mnud_Vge_e_Vdi_si=0.0;
  Mnud_Vge_e_Tempt_GND=0.0;
#endif
Mnud_Ve_si=0.0;
#if defined(_DERIVATE2)
  Mnud_Ve_si_Vge_e=0.0;
  Mnud_Ve_si_Ve_si=0.0;
  Mnud_Ve_si_Ve_di=0.0;
  Mnud_Ve_si_Vge_si=0.0;
  Mnud_Ve_si_Vdi_si=0.0;
  Mnud_Ve_si_Tempt_GND=0.0;
#endif
Mnud_Ve_di=0.0;
#if defined(_DERIVATE2)
  Mnud_Ve_di_Vge_e=0.0;
  Mnud_Ve_di_Ve_si=0.0;
  Mnud_Ve_di_Ve_di=0.0;
  Mnud_Ve_di_Vge_si=0.0;
  Mnud_Ve_di_Vdi_si=0.0;
  Mnud_Ve_di_Tempt_GND=0.0;
#endif
Mnud_Vge_si=0.0;
#if defined(_DERIVATE2)
  Mnud_Vge_si_Vge_e=0.0;
  Mnud_Vge_si_Ve_si=0.0;
  Mnud_Vge_si_Ve_di=0.0;
  Mnud_Vge_si_Vge_si=0.0;
  Mnud_Vge_si_Vdi_si=0.0;
  Mnud_Vge_si_Tempt_GND=0.0;
#endif
Mnud_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Mnud_Vdi_si_Vge_e=0.0;
  Mnud_Vdi_si_Ve_si=0.0;
  Mnud_Vdi_si_Ve_di=0.0;
  Mnud_Vdi_si_Vge_si=0.0;
  Mnud_Vdi_si_Vdi_si=0.0;
  Mnud_Vdi_si_Tempt_GND=0.0;
#endif
Mnud_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Mnud_Tempt_GND_Vge_e=0.0;
  Mnud_Tempt_GND_Ve_si=0.0;
  Mnud_Tempt_GND_Ve_di=0.0;
  Mnud_Tempt_GND_Vge_si=0.0;
  Mnud_Tempt_GND_Vdi_si=0.0;
  Mnud_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Mnud=1.0;
EXIT_IF_ISNAN(1.0)
}
if
((pModel->BULKMOD==2))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=bsimcmg_d_hypsmooth((K2_t+(K2SAT_t*vdsx)),1.0e-6,(K2SAT_t*vdsx_Vdi_si),0.0);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=bsimcmg_d_hypsmooth((K2_t+(K2SAT_t*vdsx)),1.0e-6,(K2_t_Tempt_GND+K2SAT_t_Tempt_GND*vdsx),0.0);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=bsimcmg_hypsmooth((K2_t+(K2SAT_t*vdsx)),1.0e-6);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((K2_t+(K2SAT_t*vdsx)),1.0e-6))
{
double m00_max(d00_max0,0,(K2SI_t+((K2SISAT_t*dqi)*dqi)))
#if defined(_DERIVATEFORDDX)
double m11_max(d11_max0,d00_max0,0,(K2SI_t+((K2SISAT_t*dqi)*dqi)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=(T0_Vge_e/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*0.0+T0*(+(+fixme*qia+0.0*0.0+(d11_max0*((0.0)*dqi))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*0.0+T0*(+(+fixme*qia+0.0*0.0+(d11_max0*((0.0)*dqi))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Vge_di=(T0_Vge_e_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*0.0+T0*(+(+fixme*qia+0.0*0.0+(d11_max0*((0.0)*dqi))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Vge_e=(T0_Vge_e_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*0.0+T0*(+(+fixme*qia+0.0*0.0+(d11_max0*((0.0)*dqi))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Ve_si=(T0_Vge_e_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*0.0+T0*(+(+fixme*qia+0.0*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Ve_di=(T0_Vge_e_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*0.0+T0*(+(+fixme*qia+0.0*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Vge_si=(T0_Vge_e_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*0.0+T0*(+(+fixme*qia+0.0*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Vdi_si=(T0_Vge_e_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*0.0+T0*(+(+fixme*qia+0.0*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_e_Tempt_GND=(T0_Vge_e_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_e*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*0.0+T0*(+(+fixme*qia+0.0*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*0.0+d00_max0*0.0)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*0.0*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Ve_si=((T0_Ve_si*((d00_max0*qia)+(2.0*nVtm))-T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_di=(T0_Ve_si_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_e=(T0_Ve_si_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Ve_si=(T0_Ve_si_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Ve_di=(T0_Ve_si_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia_Ve_si+d00_max0*qia_Ve_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vge_si=(T0_Ve_si_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Vdi_si=(T0_Ve_si_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia_Ve_si+d00_max0*qia_Ve_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_si_Tempt_GND=(T0_Ve_si_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_si*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Ve_si+d00_max0*qia_Ve_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_si)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si)))*qia)+(d00_max0*qia_Ve_si))*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Ve_di=((T0_Ve_di*((d00_max0*qia)+(2.0*nVtm))-T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_di=(T0_Ve_di_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_e=(T0_Ve_di_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*0.0+(d11_max0*((0.0)*dqi))*qia_Ve_di+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Ve_si=(T0_Ve_di_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Ve_di=(T0_Ve_di_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia_Ve_di+d00_max0*qia_Ve_di_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vge_si=(T0_Ve_di_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Vdi_si=(T0_Ve_di_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia_Ve_di+d00_max0*qia_Ve_di_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Ve_di_Tempt_GND=(T0_Ve_di_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Ve_di*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Ve_di+d00_max0*qia_Ve_di_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Ve_di)*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di)))*qia)+(d00_max0*qia_Ve_di))*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Vge_si=((T0_Vge_si*((d00_max0*qia)+(2.0*nVtm))-T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_di=(T0_Vge_si_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_e=(T0_Vge_si_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vge_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Ve_si=(T0_Vge_si_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Ve_di=(T0_Vge_si_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia_Vge_si+d00_max0*qia_Vge_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vge_si=(T0_Vge_si_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Vdi_si=(T0_Vge_si_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia_Vge_si+d00_max0*qia_Vge_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vge_si_Tempt_GND=(T0_Vge_si_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Vge_si*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Vge_si+d00_max0*qia_Vge_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*0.0+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*(((d11_max0*(((K2SISAT_t*dqi_Vge_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si)))*qia)+(d00_max0*qia_Vge_si))*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Vdi_si=((T0_Vdi_si*((d00_max0*qia)+(2.0*nVtm))-T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_di=(T0_Vdi_si_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_e=(T0_Vdi_si_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*0.0+(d11_max0*((0.0)*dqi))*qia_Vdi_si+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Ve_si=(T0_Vdi_si_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Ve_di=(T0_Vdi_si_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vge_si=(T0_Vdi_si_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Vdi_si+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Vdi_si=(T0_Vdi_si_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Vdi_si_Tempt_GND=(T0_Vdi_si_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Vdi_si*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))+T0*(+(+fixme*qia+(d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Vdi_si+d00_max0*qia_Vdi_si_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Vdi_si+2.0*nVtm_Vdi_si_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(((K2SISAT_t*dqi_Vdi_si)*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si)))*qia)+(d00_max0*qia_Vdi_si))+(2.0*nVtm_Vdi_si))*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
T1_Tempt_GND=((T0_Tempt_GND*((d00_max0*qia)+(2.0*nVtm))-T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vsi_s=(0.0/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+0.0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_di=(T0_Tempt_GND_Vge_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_di*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_e=(T0_Tempt_GND_Vge_e/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((d11_max0*((0.0)*dqi))*qia)+(0.0))+T0_Vge_e*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*0.0+(d11_max0*((0.0)*dqi))*qia_Tempt_GND+d00_max0*0.0)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((d11_max0*((0.0)*dqi))*qia)+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Ve_si=(T0_Tempt_GND_Ve_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))+T0_Ve_si*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Ve_si+(d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Ve_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_si))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_si))))*qia)+(d00_max0*qia_Ve_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Ve_di=(T0_Tempt_GND_Ve_di/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))+T0_Ve_di*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Ve_di+(d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Ve_di)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K2SISAT_t*dqi_Ve_di))*dqi)+((K2SISAT_t*dqi)*dqi_Ve_di))))*qia)+(d00_max0*qia_Ve_di)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vge_si=(T0_Tempt_GND_Vge_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))+T0_Vge_si*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Vge_si+(d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Vge_si)+(+0.0*nVtm+0.0*0.0+0.0*nVtm_Tempt_GND+2.0*0.0)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K2SISAT_t*dqi_Vge_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vge_si))))*qia)+(d00_max0*qia_Vge_si)))+(0.0))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Vdi_si=(T0_Tempt_GND_Vdi_si/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))+T0_Vdi_si*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Vdi_si+(d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Vdi_si)+(+0.0*nVtm+0.0*nVtm_Vdi_si+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(((((K2SISAT_t*dqi_Vdi_si))*dqi)+((K2SISAT_t*dqi)*dqi_Vdi_si))))*qia)+(d00_max0*qia_Vdi_si)))+((2.0*nVtm_Vdi_si)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
  T1_Tempt_GND_Tempt_GND=(T0_Tempt_GND_Tempt_GND/((d00_max0*qia)+(2.0*nVtm))-(T0_Tempt_GND*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))+T0_Tempt_GND*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))+T0*(+(+fixme*qia+(d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia_Tempt_GND+(d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia_Tempt_GND+d00_max0*qia_Tempt_GND_Tempt_GND)+(+0.0*nVtm+0.0*nVtm_Tempt_GND+0.0*nVtm_Tempt_GND+2.0*nVtm_Tempt_GND_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))+2*T0*((((d11_max0*(K2SI_t_Tempt_GND+((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND))))*qia)+(d00_max0*qia_Tempt_GND))+(2.0*nVtm_Tempt_GND))*(((((d11_max0*(K2SI_t_Tempt_GND+((((((K2SISAT_t_Tempt_GND*dqi)+(K2SISAT_t*dqi_Tempt_GND)))*dqi)+((K2SISAT_t*dqi)*dqi_Tempt_GND)))))*qia)+(d00_max0*qia_Tempt_GND)))+((2.0*nVtm_Tempt_GND)))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm))/((d00_max0*qia)+(2.0*nVtm)));
#endif
#endif
T1=(T0/((d00_max0*qia)+(2.0*nVtm)));
EXIT_IF_ISNAN((T0/((d00_max0*qia)+(2.0*nVtm))))
}
{
double m00_sqrt(d00_sqrt0,(PHIBE_i-veseff))
double m00_sqrt(d00_sqrt1,PHIBE_i)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(PHIBE_i-veseff))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(-veseff_Vdi_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0-0.0);
  T3_Vdi_si_Vsi_s=(+0.0-0.0);
  T3_Vdi_si_Vge_di=(+0.0-0.0);
  T3_Vdi_si_Vge_e=(+0.0-0.0);
  T3_Vdi_si_Vdi_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Vdi_si)*(-veseff_Vdi_si)+d10_sqrt0*(+0.0-veseff_Vdi_si_Vdi_si))-0.0);
  T3_Vdi_si_Ve_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_si)*(-veseff_Vdi_si)+d10_sqrt0*(+0.0-veseff_Vdi_si_Ve_si))-0.0);
  T3_Vdi_si_Ve_di=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_di)*(-veseff_Vdi_si)+d10_sqrt0*(+0.0-veseff_Vdi_si_Ve_di))-0.0);
  T3_Vdi_si_Vge_si=(+0.0-0.0);
  T3_Vdi_si_Tempt_GND=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Tempt_GND)*(-veseff_Vdi_si)+d10_sqrt0*(+0.0-veseff_Vdi_si_Tempt_GND))-0.0);
#endif
T3_Ve_si=(-veseff_Ve_si)*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0-0.0);
  T3_Ve_si_Vsi_s=(+0.0-0.0);
  T3_Ve_si_Vge_di=(+0.0-0.0);
  T3_Ve_si_Vge_e=(+0.0-0.0);
  T3_Ve_si_Vdi_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Vdi_si)*(-veseff_Ve_si)+d10_sqrt0*(+0.0-veseff_Ve_si_Vdi_si))-0.0);
  T3_Ve_si_Ve_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_si)*(-veseff_Ve_si)+d10_sqrt0*(+0.0-veseff_Ve_si_Ve_si))-0.0);
  T3_Ve_si_Ve_di=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_di)*(-veseff_Ve_si)+d10_sqrt0*(+0.0-veseff_Ve_si_Ve_di))-0.0);
  T3_Ve_si_Vge_si=(+0.0-0.0);
  T3_Ve_si_Tempt_GND=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Tempt_GND)*(-veseff_Ve_si)+d10_sqrt0*(+0.0-veseff_Ve_si_Tempt_GND))-0.0);
#endif
T3_Ve_di=(-veseff_Ve_di)*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0-0.0);
  T3_Ve_di_Vsi_s=(+0.0-0.0);
  T3_Ve_di_Vge_di=(+0.0-0.0);
  T3_Ve_di_Vge_e=(+0.0-0.0);
  T3_Ve_di_Vdi_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Vdi_si)*(-veseff_Ve_di)+d10_sqrt0*(+0.0-veseff_Ve_di_Vdi_si))-0.0);
  T3_Ve_di_Ve_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_si)*(-veseff_Ve_di)+d10_sqrt0*(+0.0-veseff_Ve_di_Ve_si))-0.0);
  T3_Ve_di_Ve_di=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_di)*(-veseff_Ve_di)+d10_sqrt0*(+0.0-veseff_Ve_di_Ve_di))-0.0);
  T3_Ve_di_Vge_si=(+0.0-0.0);
  T3_Ve_di_Tempt_GND=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Tempt_GND)*(-veseff_Ve_di)+d10_sqrt0*(+0.0-veseff_Ve_di_Tempt_GND))-0.0);
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=(-veseff_Tempt_GND)*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0-0.0);
  T3_Tempt_GND_Vsi_s=(+0.0-0.0);
  T3_Tempt_GND_Vge_di=(+0.0-0.0);
  T3_Tempt_GND_Vge_e=(+0.0-0.0);
  T3_Tempt_GND_Vdi_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Vdi_si)*(-veseff_Tempt_GND)+d10_sqrt0*(+0.0-veseff_Tempt_GND_Vdi_si))-0.0);
  T3_Tempt_GND_Ve_si=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_si)*(-veseff_Tempt_GND)+d10_sqrt0*(+0.0-veseff_Tempt_GND_Ve_si))-0.0);
  T3_Tempt_GND_Ve_di=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Ve_di)*(-veseff_Tempt_GND)+d10_sqrt0*(+0.0-veseff_Tempt_GND_Ve_di))-0.0);
  T3_Tempt_GND_Vge_si=(+0.0-0.0);
  T3_Tempt_GND_Tempt_GND=(+(m20_sqrt((PHIBE_i-veseff))*(-veseff_Tempt_GND)*(-veseff_Tempt_GND)+d10_sqrt0*(+0.0-veseff_Tempt_GND_Tempt_GND))-0.0);
#endif
#endif
T3=(d00_sqrt0-d00_sqrt1);
EXIT_IF_ISNAN((d00_sqrt0-d00_sqrt1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Mob_Vge_e=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Vge_e)*T3)+((-T1)*T3_Vge_e)));
#if defined(_DERIVATE2)
  Mob_Vge_e_Vge_e=(+0.0*T3+(-T1_Vge_e)*T3_Vge_e+(-T1_Vge_e)*T3_Vge_e+(-T1)*T3_Vge_e_Vge_e);
  Mob_Vge_e_Ve_si=(+0.0*T3+(-T1_Vge_e)*T3_Ve_si+(-T1_Ve_si)*T3_Vge_e+(-T1)*T3_Vge_e_Ve_si);
  Mob_Vge_e_Ve_di=(+0.0*T3+(-T1_Vge_e)*T3_Ve_di+(-T1_Ve_di)*T3_Vge_e+(-T1)*T3_Vge_e_Ve_di);
  Mob_Vge_e_Vge_si=(+0.0*T3+(-T1_Vge_e)*T3_Vge_si+(-T1_Vge_si)*T3_Vge_e+(-T1)*T3_Vge_e_Vge_si);
  Mob_Vge_e_Vdi_si=(+0.0*T3+(-T1_Vge_e)*T3_Vdi_si+(-T1_Vdi_si)*T3_Vge_e+(-T1)*T3_Vge_e_Vdi_si);
  Mob_Vge_e_Tempt_GND=(+0.0*T3+(-T1_Vge_e)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Vge_e+(-T1)*T3_Vge_e_Tempt_GND);
#endif
Mob_Ve_si=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Ve_si)*T3)+((-T1)*T3_Ve_si)));
#if defined(_DERIVATE2)
  Mob_Ve_si_Vge_e=(+0.0*T3+(-T1_Ve_si)*T3_Vge_e+(-T1_Vge_e)*T3_Ve_si+(-T1)*T3_Ve_si_Vge_e);
  Mob_Ve_si_Ve_si=(+0.0*T3+(-T1_Ve_si)*T3_Ve_si+(-T1_Ve_si)*T3_Ve_si+(-T1)*T3_Ve_si_Ve_si);
  Mob_Ve_si_Ve_di=(+0.0*T3+(-T1_Ve_si)*T3_Ve_di+(-T1_Ve_di)*T3_Ve_si+(-T1)*T3_Ve_si_Ve_di);
  Mob_Ve_si_Vge_si=(+0.0*T3+(-T1_Ve_si)*T3_Vge_si+(-T1_Vge_si)*T3_Ve_si+(-T1)*T3_Ve_si_Vge_si);
  Mob_Ve_si_Vdi_si=(+0.0*T3+(-T1_Ve_si)*T3_Vdi_si+(-T1_Vdi_si)*T3_Ve_si+(-T1)*T3_Ve_si_Vdi_si);
  Mob_Ve_si_Tempt_GND=(+0.0*T3+(-T1_Ve_si)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Ve_si+(-T1)*T3_Ve_si_Tempt_GND);
#endif
Mob_Ve_di=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Ve_di)*T3)+((-T1)*T3_Ve_di)));
#if defined(_DERIVATE2)
  Mob_Ve_di_Vge_e=(+0.0*T3+(-T1_Ve_di)*T3_Vge_e+(-T1_Vge_e)*T3_Ve_di+(-T1)*T3_Ve_di_Vge_e);
  Mob_Ve_di_Ve_si=(+0.0*T3+(-T1_Ve_di)*T3_Ve_si+(-T1_Ve_si)*T3_Ve_di+(-T1)*T3_Ve_di_Ve_si);
  Mob_Ve_di_Ve_di=(+0.0*T3+(-T1_Ve_di)*T3_Ve_di+(-T1_Ve_di)*T3_Ve_di+(-T1)*T3_Ve_di_Ve_di);
  Mob_Ve_di_Vge_si=(+0.0*T3+(-T1_Ve_di)*T3_Vge_si+(-T1_Vge_si)*T3_Ve_di+(-T1)*T3_Ve_di_Vge_si);
  Mob_Ve_di_Vdi_si=(+0.0*T3+(-T1_Ve_di)*T3_Vdi_si+(-T1_Vdi_si)*T3_Ve_di+(-T1)*T3_Ve_di_Vdi_si);
  Mob_Ve_di_Tempt_GND=(+0.0*T3+(-T1_Ve_di)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Ve_di+(-T1)*T3_Ve_di_Tempt_GND);
#endif
Mob_Vge_si=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Vge_si)*T3)+((-T1)*T3_Vge_si)));
#if defined(_DERIVATE2)
  Mob_Vge_si_Vge_e=(+0.0*T3+(-T1_Vge_si)*T3_Vge_e+(-T1_Vge_e)*T3_Vge_si+(-T1)*T3_Vge_si_Vge_e);
  Mob_Vge_si_Ve_si=(+0.0*T3+(-T1_Vge_si)*T3_Ve_si+(-T1_Ve_si)*T3_Vge_si+(-T1)*T3_Vge_si_Ve_si);
  Mob_Vge_si_Ve_di=(+0.0*T3+(-T1_Vge_si)*T3_Ve_di+(-T1_Ve_di)*T3_Vge_si+(-T1)*T3_Vge_si_Ve_di);
  Mob_Vge_si_Vge_si=(+0.0*T3+(-T1_Vge_si)*T3_Vge_si+(-T1_Vge_si)*T3_Vge_si+(-T1)*T3_Vge_si_Vge_si);
  Mob_Vge_si_Vdi_si=(+0.0*T3+(-T1_Vge_si)*T3_Vdi_si+(-T1_Vdi_si)*T3_Vge_si+(-T1)*T3_Vge_si_Vdi_si);
  Mob_Vge_si_Tempt_GND=(+0.0*T3+(-T1_Vge_si)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Vge_si+(-T1)*T3_Vge_si_Tempt_GND);
#endif
Mob_Vdi_si=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Vdi_si)*T3)+((-T1)*T3_Vdi_si)));
#if defined(_DERIVATE2)
  Mob_Vdi_si_Vge_e=(+0.0*T3+(-T1_Vdi_si)*T3_Vge_e+(-T1_Vge_e)*T3_Vdi_si+(-T1)*T3_Vdi_si_Vge_e);
  Mob_Vdi_si_Ve_si=(+0.0*T3+(-T1_Vdi_si)*T3_Ve_si+(-T1_Ve_si)*T3_Vdi_si+(-T1)*T3_Vdi_si_Ve_si);
  Mob_Vdi_si_Ve_di=(+0.0*T3+(-T1_Vdi_si)*T3_Ve_di+(-T1_Ve_di)*T3_Vdi_si+(-T1)*T3_Vdi_si_Ve_di);
  Mob_Vdi_si_Vge_si=(+0.0*T3+(-T1_Vdi_si)*T3_Vge_si+(-T1_Vge_si)*T3_Vdi_si+(-T1)*T3_Vdi_si_Vge_si);
  Mob_Vdi_si_Vdi_si=(+0.0*T3+(-T1_Vdi_si)*T3_Vdi_si+(-T1_Vdi_si)*T3_Vdi_si+(-T1)*T3_Vdi_si_Vdi_si);
  Mob_Vdi_si_Tempt_GND=(+0.0*T3+(-T1_Vdi_si)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Vdi_si+(-T1)*T3_Vdi_si_Tempt_GND);
#endif
Mob_Tempt_GND=bsimcmg_d_lexp(((-T1)*T3),(((-T1_Tempt_GND)*T3)+((-T1)*T3_Tempt_GND)));
#if defined(_DERIVATE2)
  Mob_Tempt_GND_Vge_e=(+0.0*T3+(-T1_Tempt_GND)*T3_Vge_e+(-T1_Vge_e)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Vge_e);
  Mob_Tempt_GND_Ve_si=(+0.0*T3+(-T1_Tempt_GND)*T3_Ve_si+(-T1_Ve_si)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Ve_si);
  Mob_Tempt_GND_Ve_di=(+0.0*T3+(-T1_Tempt_GND)*T3_Ve_di+(-T1_Ve_di)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Ve_di);
  Mob_Tempt_GND_Vge_si=(+0.0*T3+(-T1_Tempt_GND)*T3_Vge_si+(-T1_Vge_si)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Vge_si);
  Mob_Tempt_GND_Vdi_si=(+0.0*T3+(-T1_Tempt_GND)*T3_Vdi_si+(-T1_Vdi_si)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Vdi_si);
  Mob_Tempt_GND_Tempt_GND=(+0.0*T3+(-T1_Tempt_GND)*T3_Tempt_GND+(-T1_Tempt_GND)*T3_Tempt_GND+(-T1)*T3_Tempt_GND_Tempt_GND);
#endif
#endif
Mob=bsimcmg_lexp(((-T1)*T3));
EXIT_IF_ISNAN(bsimcmg_lexp(((-T1)*T3)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Mob_Vge_e=0.0;
#if defined(_DERIVATE2)
  Mob_Vge_e_Vge_e=0.0;
  Mob_Vge_e_Ve_si=0.0;
  Mob_Vge_e_Ve_di=0.0;
  Mob_Vge_e_Vge_si=0.0;
  Mob_Vge_e_Vdi_si=0.0;
  Mob_Vge_e_Tempt_GND=0.0;
#endif
Mob_Ve_si=0.0;
#if defined(_DERIVATE2)
  Mob_Ve_si_Vge_e=0.0;
  Mob_Ve_si_Ve_si=0.0;
  Mob_Ve_si_Ve_di=0.0;
  Mob_Ve_si_Vge_si=0.0;
  Mob_Ve_si_Vdi_si=0.0;
  Mob_Ve_si_Tempt_GND=0.0;
#endif
Mob_Ve_di=0.0;
#if defined(_DERIVATE2)
  Mob_Ve_di_Vge_e=0.0;
  Mob_Ve_di_Ve_si=0.0;
  Mob_Ve_di_Ve_di=0.0;
  Mob_Ve_di_Vge_si=0.0;
  Mob_Ve_di_Vdi_si=0.0;
  Mob_Ve_di_Tempt_GND=0.0;
#endif
Mob_Vge_si=0.0;
#if defined(_DERIVATE2)
  Mob_Vge_si_Vge_e=0.0;
  Mob_Vge_si_Ve_si=0.0;
  Mob_Vge_si_Ve_di=0.0;
  Mob_Vge_si_Vge_si=0.0;
  Mob_Vge_si_Vdi_si=0.0;
  Mob_Vge_si_Tempt_GND=0.0;
#endif
Mob_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Mob_Vdi_si_Vge_e=0.0;
  Mob_Vdi_si_Ve_si=0.0;
  Mob_Vdi_si_Ve_di=0.0;
  Mob_Vdi_si_Vge_si=0.0;
  Mob_Vdi_si_Vdi_si=0.0;
  Mob_Vdi_si_Tempt_GND=0.0;
#endif
Mob_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Mob_Tempt_GND_Vge_e=0.0;
  Mob_Tempt_GND_Ve_si=0.0;
  Mob_Tempt_GND_Ve_di=0.0;
  Mob_Tempt_GND_Vge_si=0.0;
  Mob_Tempt_GND_Vdi_si=0.0;
  Mob_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Mob=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
EsatCV_Tempt_GND=(((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*u0_a-((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND)/u0_a/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Tempt_GND_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*VSATCV_t_Tempt_GND+2.0*VSATCV_t_Tempt_GND_Tempt_GND)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Tempt_GND)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND_Tempt_GND)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Tempt_GND_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*VSATCV_t_Tempt_GND+2.0*0.0)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Vge_e)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a);
  EsatCV_Tempt_GND_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*VSATCV_t_Tempt_GND+2.0*0.0)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Vdi_si)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND_Vdi_si)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Tempt_GND_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*VSATCV_t_Tempt_GND+2.0*0.0)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Ve_si)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a);
  EsatCV_Tempt_GND_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*VSATCV_t_Tempt_GND+2.0*0.0)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Ve_di)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a);
  EsatCV_Tempt_GND_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*VSATCV_t_Tempt_GND+2.0*0.0)*Dmob_cv+(2.0*VSATCV_t_Tempt_GND)*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Tempt_GND+(2.0*VSATCV_t)*Dmob_cv_Tempt_GND_Vge_si)/u0_a-((((2.0*VSATCV_t_Tempt_GND)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND))*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*u0_a_Tempt_GND+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Tempt_GND*0.0/u0_a/u0_a/u0_a);
#endif
EsatCV_Vge_e=(((2.0*VSATCV_t)*Dmob_cv_Vge_e)/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Vge_e_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Tempt_GND)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Vge_e_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Vge_e)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_e_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Vdi_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Vge_e_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Ve_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_e_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Ve_di)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_e_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Vge_e+(2.0*VSATCV_t)*Dmob_cv_Vge_e_Vge_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_e)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
#endif
EsatCV_Vdi_si=((((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*u0_a-((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si)/u0_a/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Vdi_si_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Tempt_GND)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si_Tempt_GND)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Vdi_si_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Vge_e)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vdi_si_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Vdi_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si_Vdi_si)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Vdi_si_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Ve_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vdi_si_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Ve_di)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vdi_si_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Vdi_si+(2.0*VSATCV_t)*Dmob_cv_Vdi_si_Vge_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vdi_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*u0_a_Vdi_si+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*u0_a_Vdi_si*0.0/u0_a/u0_a/u0_a);
#endif
EsatCV_Ve_si=(((2.0*VSATCV_t)*Dmob_cv_Ve_si)/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Ve_si_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Tempt_GND)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Ve_si_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Vge_e)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_si_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Vdi_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Ve_si_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Ve_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_si_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Ve_di)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_si_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Ve_si+(2.0*VSATCV_t)*Dmob_cv_Ve_si_Vge_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
#endif
EsatCV_Ve_di=(((2.0*VSATCV_t)*Dmob_cv_Ve_di)/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Ve_di_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Tempt_GND)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Ve_di_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Vge_e)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_di_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Vdi_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Ve_di_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Ve_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_di_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Ve_di)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Ve_di_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Ve_di+(2.0*VSATCV_t)*Dmob_cv_Ve_di_Vge_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Ve_di)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
#endif
EsatCV_Vge_si=(((2.0*VSATCV_t)*Dmob_cv_Vge_si)/u0_a);
#if defined(_DERIVATE2)
  EsatCV_Vge_si_Tempt_GND=((+(+0.0*VSATCV_t+0.0*VSATCV_t_Tempt_GND+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Tempt_GND+((2.0*VSATCV_t_Tempt_GND))*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Tempt_GND)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*u0_a_Tempt_GND+(((((2.0*VSATCV_t_Tempt_GND))*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Tempt_GND)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Tempt_GND/u0_a/u0_a/u0_a);
  EsatCV_Vge_si_Vge_e=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_e+(0.0)*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Vge_e)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_e)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_si_Vdi_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vdi_si+(0.0)*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Vdi_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*u0_a_Vdi_si+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vdi_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*u0_a_Vdi_si/u0_a/u0_a/u0_a);
  EsatCV_Vge_si_Ve_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_si+(0.0)*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Ve_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_si_Ve_di=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Ve_di+(0.0)*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Ve_di)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Ve_di)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
  EsatCV_Vge_si_Vge_si=((+(+0.0*VSATCV_t+0.0*0.0+0.0*0.0+2.0*0.0)*Dmob_cv+0.0*Dmob_cv_Vge_si+(0.0)*Dmob_cv_Vge_si+(2.0*VSATCV_t)*Dmob_cv_Vge_si_Vge_si)/u0_a-(((2.0*VSATCV_t)*Dmob_cv_Vge_si)*0.0+((((0.0)*Dmob_cv)+((2.0*VSATCV_t)*Dmob_cv_Vge_si)))*0.0+((2.0*VSATCV_t)*Dmob_cv)*0.0)/u0_a/u0_a+2*((2.0*VSATCV_t)*Dmob_cv)*0.0*0.0/u0_a/u0_a/u0_a);
#endif
#endif
EsatCV=(((2.0*VSATCV_t)*Dmob_cv)/u0_a);
EXIT_IF_ISNAN((((2.0*VSATCV_t)*Dmob_cv)/u0_a))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
EsatCVL_Tempt_GND=EsatCV_Tempt_GND*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Tempt_GND_Tempt_GND=(+EsatCV_Tempt_GND_Tempt_GND*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Tempt_GND_Vge_e=(+EsatCV_Tempt_GND_Vge_e*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Tempt_GND_Vdi_si=(+EsatCV_Tempt_GND_Vdi_si*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Tempt_GND_Ve_si=(+EsatCV_Tempt_GND_Ve_si*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Tempt_GND_Ve_di=(+EsatCV_Tempt_GND_Ve_di*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Tempt_GND_Vge_si=(+EsatCV_Tempt_GND_Vge_si*LeffCV+EsatCV_Tempt_GND*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
EsatCVL_Vge_e=EsatCV_Vge_e*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Vge_e_Tempt_GND=(+EsatCV_Vge_e_Tempt_GND*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Vge_e_Vge_e=(+EsatCV_Vge_e_Vge_e*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Vge_e_Vdi_si=(+EsatCV_Vge_e_Vdi_si*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Vge_e_Ve_si=(+EsatCV_Vge_e_Ve_si*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Vge_e_Ve_di=(+EsatCV_Vge_e_Ve_di*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Vge_e_Vge_si=(+EsatCV_Vge_e_Vge_si*LeffCV+EsatCV_Vge_e*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
EsatCVL_Vdi_si=EsatCV_Vdi_si*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Vdi_si_Tempt_GND=(+EsatCV_Vdi_si_Tempt_GND*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Vdi_si_Vge_e=(+EsatCV_Vdi_si_Vge_e*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Vdi_si_Vdi_si=(+EsatCV_Vdi_si_Vdi_si*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Vdi_si_Ve_si=(+EsatCV_Vdi_si_Ve_si*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Vdi_si_Ve_di=(+EsatCV_Vdi_si_Ve_di*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Vdi_si_Vge_si=(+EsatCV_Vdi_si_Vge_si*LeffCV+EsatCV_Vdi_si*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
EsatCVL_Ve_si=EsatCV_Ve_si*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Ve_si_Tempt_GND=(+EsatCV_Ve_si_Tempt_GND*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Ve_si_Vge_e=(+EsatCV_Ve_si_Vge_e*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Ve_si_Vdi_si=(+EsatCV_Ve_si_Vdi_si*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Ve_si_Ve_si=(+EsatCV_Ve_si_Ve_si*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Ve_si_Ve_di=(+EsatCV_Ve_si_Ve_di*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Ve_si_Vge_si=(+EsatCV_Ve_si_Vge_si*LeffCV+EsatCV_Ve_si*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
EsatCVL_Ve_di=EsatCV_Ve_di*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Ve_di_Tempt_GND=(+EsatCV_Ve_di_Tempt_GND*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Ve_di_Vge_e=(+EsatCV_Ve_di_Vge_e*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Ve_di_Vdi_si=(+EsatCV_Ve_di_Vdi_si*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Ve_di_Ve_si=(+EsatCV_Ve_di_Ve_si*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Ve_di_Ve_di=(+EsatCV_Ve_di_Ve_di*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Ve_di_Vge_si=(+EsatCV_Ve_di_Vge_si*LeffCV+EsatCV_Ve_di*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
EsatCVL_Vge_si=EsatCV_Vge_si*LeffCV;
#if defined(_DERIVATE2)
  EsatCVL_Vge_si_Tempt_GND=(+EsatCV_Vge_si_Tempt_GND*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Tempt_GND*0.0+EsatCV*0.0);
  EsatCVL_Vge_si_Vge_e=(+EsatCV_Vge_si_Vge_e*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Vge_e*0.0+EsatCV*0.0);
  EsatCVL_Vge_si_Vdi_si=(+EsatCV_Vge_si_Vdi_si*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Vdi_si*0.0+EsatCV*0.0);
  EsatCVL_Vge_si_Ve_si=(+EsatCV_Vge_si_Ve_si*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Ve_si*0.0+EsatCV*0.0);
  EsatCVL_Vge_si_Ve_di=(+EsatCV_Vge_si_Ve_di*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Ve_di*0.0+EsatCV*0.0);
  EsatCVL_Vge_si_Vge_si=(+EsatCV_Vge_si_Vge_si*LeffCV+EsatCV_Vge_si*0.0+EsatCV_Vge_si*0.0+EsatCV*0.0);
#endif
#endif
EsatCVL=(EsatCV*LeffCV);
EXIT_IF_ISNAN((EsatCV*LeffCV))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*0.0+0.0*EsatCVL_Vge_e+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Vge_e+0.0*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),(-dqi*EsatCVL_Vge_e/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(0.0*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Vge_e+dqi*EsatCVL_Vge_e_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_e*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
T0_Ve_si=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Ve_si*0.0+0.0*EsatCVL_Ve_si+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Ve_si*EsatCVL_Vge_e+0.0*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_si_Ve_si/EsatCVL-(dqi_Ve_si*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_si_Ve_di/EsatCVL-(dqi_Ve_si*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_si_Vge_si/EsatCVL-(dqi_Ve_si*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_si_Vdi_si/EsatCVL-(dqi_Ve_si*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_si*EsatCVL-dqi*EsatCVL_Ve_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_si_Tempt_GND/EsatCVL-(dqi_Ve_si*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Ve_si+dqi*EsatCVL_Ve_si_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_si*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
T0_Ve_di=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Ve_di*0.0+0.0*EsatCVL_Ve_di+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Ve_di*EsatCVL_Vge_e+0.0*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_di_Ve_si/EsatCVL-(dqi_Ve_di*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_di_Ve_di/EsatCVL-(dqi_Ve_di*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_di_Vge_si/EsatCVL-(dqi_Ve_di*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_di_Vdi_si/EsatCVL-(dqi_Ve_di*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Ve_di*EsatCVL-dqi*EsatCVL_Ve_di)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Ve_di_Tempt_GND/EsatCVL-(dqi_Ve_di*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Ve_di+dqi*EsatCVL_Ve_di_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Ve_di*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
T0_Vge_si=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Vge_si*0.0+0.0*EsatCVL_Vge_si+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Vge_si*EsatCVL_Vge_e+0.0*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vge_si_Ve_si/EsatCVL-(dqi_Vge_si*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vge_si_Ve_di/EsatCVL-(dqi_Vge_si*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vge_si_Vge_si/EsatCVL-(dqi_Vge_si*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vge_si_Vdi_si/EsatCVL-(dqi_Vge_si*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vge_si*EsatCVL-dqi*EsatCVL_Vge_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vge_si_Tempt_GND/EsatCVL-(dqi_Vge_si*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Vge_si+dqi*EsatCVL_Vge_si_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vge_si*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
T0_Vdi_si=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Vdi_si*0.0+0.0*EsatCVL_Vdi_si+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Vdi_si*EsatCVL_Vge_e+0.0*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vdi_si_Ve_si/EsatCVL-(dqi_Vdi_si*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vdi_si_Ve_di/EsatCVL-(dqi_Vdi_si*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vdi_si_Vge_si/EsatCVL-(dqi_Vdi_si*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vdi_si_Vdi_si/EsatCVL-(dqi_Vdi_si*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Vdi_si*EsatCVL-dqi*EsatCVL_Vdi_si)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Vdi_si_Tempt_GND/EsatCVL-(dqi_Vdi_si*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Vdi_si+dqi*EsatCVL_Vdi_si_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Vdi_si*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
T0_Tempt_GND=bsimcmg_d_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))),(PSATCV_i*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Tempt_GND*0.0+0.0*EsatCVL_Tempt_GND+dqi*0.0)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*0.0/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(0.0/EsatCVL-(dqi_Tempt_GND*EsatCVL_Vge_e+0.0*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Vge_e)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Vge_e/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Tempt_GND_Ve_si/EsatCVL-(dqi_Tempt_GND*EsatCVL_Ve_si+dqi_Ve_si*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Ve_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Ve_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Tempt_GND_Ve_di/EsatCVL-(dqi_Tempt_GND*EsatCVL_Ve_di+dqi_Ve_di*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Ve_di)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Ve_di/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Tempt_GND_Vge_si/EsatCVL-(dqi_Tempt_GND*EsatCVL_Vge_si+dqi_Vge_si*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Vge_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Vge_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Tempt_GND_Vdi_si/EsatCVL-(dqi_Tempt_GND*EsatCVL_Vdi_si+dqi_Vdi_si*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Vdi_si)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Vdi_si/EsatCVL/EsatCVL/EsatCVL));
  T0_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln((dqi/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+0.0*bsimcmg_d_lln((dqi/EsatCVL),((dqi_Tempt_GND*EsatCVL-dqi*EsatCVL_Tempt_GND)/EsatCVL/EsatCVL))+PSATCV_i*(dqi_Tempt_GND_Tempt_GND/EsatCVL-(dqi_Tempt_GND*EsatCVL_Tempt_GND+dqi_Tempt_GND*EsatCVL_Tempt_GND+dqi*EsatCVL_Tempt_GND_Tempt_GND)/EsatCVL/EsatCVL+2*dqi*EsatCVL_Tempt_GND*EsatCVL_Tempt_GND/EsatCVL/EsatCVL/EsatCVL));
#endif
#endif
T0=bsimcmg_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL))));
EXIT_IF_ISNAN(bsimcmg_lexp((PSATCV_i*bsimcmg_lln((dqi/EsatCVL)))))
#if defined(_DERIVATEFORDDX) /* probe=V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Ta_Ve_si=0.0;
#if defined(_DERIVATE2)
  Ta_Ve_si_Ve_si=0.0;
  Ta_Ve_si_Ve_di=0.0;
  Ta_Ve_si_Vge_si=0.0;
  Ta_Ve_si_Vdi_si=0.0;
  Ta_Ve_si_Tempt_GND=0.0;
#endif
Ta_Ve_di=0.0;
#if defined(_DERIVATE2)
  Ta_Ve_di_Ve_si=0.0;
  Ta_Ve_di_Ve_di=0.0;
  Ta_Ve_di_Vge_si=0.0;
  Ta_Ve_di_Vdi_si=0.0;
  Ta_Ve_di_Tempt_GND=0.0;
#endif
Ta_Vge_si=0.0;
#if defined(_DERIVATE2)
  Ta_Vge_si_Ve_si=0.0;
  Ta_Vge_si_Ve_di=0.0;
  Ta_Vge_si_Vge_si=0.0;
  Ta_Vge_si_Vdi_si=0.0;
  Ta_Vge_si_Tempt_GND=0.0;
#endif
Ta_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Ta_Vdi_si_Ve_si=0.0;
  Ta_Vdi_si_Ve_di=0.0;
  Ta_Vdi_si_Vge_si=0.0;
  Ta_Vdi_si_Vdi_si=0.0;
  Ta_Vdi_si_Tempt_GND=0.0;
#endif
Ta_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Ta_Tempt_GND_Ve_si=0.0;
  Ta_Tempt_GND_Ve_di=0.0;
  Ta_Tempt_GND_Vge_si=0.0;
  Ta_Tempt_GND_Vdi_si=0.0;
  Ta_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Ta=(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln(DELTAVSATCV_i))));
EXIT_IF_ISNAN((1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln(DELTAVSATCV_i)))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
DvsatCV_Vge_e=(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Vge_e_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*0.0/Ta/Ta/Ta);
  DvsatCV_Vge_e_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Vge_e_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Vge_e_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Vge_e_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Vge_e_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)+(1.0/PSATCV_i)*(+0.0+T0_Vge_e_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_e)))*0.0+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
DvsatCV_Ve_si=((bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si)/Ta/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Ve_si_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*0.0/Ta/Ta/Ta);
  DvsatCV_Ve_si_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Ve_si_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Ve_si_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Ve_si_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Ve_si_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)+(1.0/PSATCV_i)*(+0.0+T0_Ve_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_si)))*Ta_Ve_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
DvsatCV_Ve_di=((bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di)/Ta/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Ve_di_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*0.0/Ta/Ta/Ta);
  DvsatCV_Ve_di_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Ve_di_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Ve_di_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Ve_di_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Ve_di_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)+(1.0/PSATCV_i)*(+0.0+T0_Ve_di_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Ve_di)))*Ta_Ve_di+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Ve_di*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
DvsatCV_Vge_si=((bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si)/Ta/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Vge_si_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*0.0/Ta/Ta/Ta);
  DvsatCV_Vge_si_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Vge_si_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Vge_si_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Vge_si_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Vge_si_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)+(1.0/PSATCV_i)*(+0.0+T0_Vge_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vge_si)))*Ta_Vge_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vge_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
DvsatCV_Vdi_si=((bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si)/Ta/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Vdi_si_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*0.0/Ta/Ta/Ta);
  DvsatCV_Vdi_si_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Vdi_si_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Vdi_si_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Vdi_si_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Vdi_si_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)+(1.0/PSATCV_i)*(+0.0+T0_Vdi_si_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Vdi_si)))*Ta_Vdi_si+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Vdi_si*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
DvsatCV_Tempt_GND=((bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta-(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND)/Ta/Ta);
#if defined(_DERIVATE2)
  DvsatCV_Tempt_GND_Vge_e=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Vge_e)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*0.0+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*0.0)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*0.0/Ta/Ta/Ta);
  DvsatCV_Tempt_GND_Ve_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Ve_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Ve_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND_Ve_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*Ta_Ve_si/Ta/Ta/Ta);
  DvsatCV_Tempt_GND_Ve_di=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Ve_di)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Ve_di+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND_Ve_di)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*Ta_Ve_di/Ta/Ta/Ta);
  DvsatCV_Tempt_GND_Vge_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Vge_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Vge_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND_Vge_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*Ta_Vge_si/Ta/Ta/Ta);
  DvsatCV_Tempt_GND_Vdi_si=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Vdi_si)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Vdi_si+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND_Vdi_si)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*Ta_Vdi_si/Ta/Ta/Ta);
  DvsatCV_Tempt_GND_Tempt_GND=((+0.0+(+(0.0/PSATCV_i-(0.0*0.0+0.0*0.0+1.0*0.0)/PSATCV_i/PSATCV_i+2*1.0*0.0*0.0/PSATCV_i/PSATCV_i/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+0.0*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)+(1.0/PSATCV_i)*(+0.0+T0_Tempt_GND_Tempt_GND)))/Ta-(bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+bsimcmg_d_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0))),((1.0/PSATCV_i)*bsimcmg_d_lln((DELTAVSATCV_i+T0),T0_Tempt_GND)))*Ta_Tempt_GND+(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND_Tempt_GND)/Ta/Ta+2*(1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))*Ta_Tempt_GND*Ta_Tempt_GND/Ta/Ta/Ta);
#endif
#endif
DvsatCV=((1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))/Ta);
EXIT_IF_ISNAN(((1.0+bsimcmg_lexp(((1.0/PSATCV_i)*bsimcmg_lln((DELTAVSATCV_i+T0)))))/Ta))
if
((PCLMCV_i!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
MclmCV_Vdi_si=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Vdi_si_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+vds_Vdi_si_Vdi_si-Vdseff_Vdi_si_Vdi_si)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vdi_si_Vdi_si+EsatCVL_Vdi_si_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vdi_si_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vdi_si_Ve_si)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vdi_si_Ve_si+EsatCVL_Vdi_si_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vdi_si_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vdi_si_Ve_di)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vdi_si_Ve_di+EsatCVL_Vdi_si_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vdi_si_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vdi_si_Vge_si)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vdi_si_Vge_si+EsatCVL_Vdi_si_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vdi_si_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vdi_si_Tempt_GND)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vdi_si_Tempt_GND+EsatCVL_Vdi_si_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vdi_si_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-((vds_Vdi_si-Vdseff_Vdi_si)*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*EsatCVL_Vge_e+0.0*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vdi_si_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
MclmCV_Ve_si=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Ve_si_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_si_Vdi_si)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_si_Vdi_si+EsatCVL_Ve_si_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_si_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_si_Ve_si)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_si_Ve_si+EsatCVL_Ve_si_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_si_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_si_Ve_di)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_si_Ve_di+EsatCVL_Ve_si_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_si_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_si_Vge_si)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_si_Vge_si+EsatCVL_Ve_si_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_si_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_si_Tempt_GND)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_si_Tempt_GND+EsatCVL_Ve_si_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_si_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-((-Vdseff_Ve_si)*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_si)/PCLMCV_i)*EsatCVL_Vge_e+0.0*(Vdsat_Ve_si+EsatCVL_Ve_si)+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Ve_si_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
MclmCV_Ve_di=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Ve_di_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_di_Vdi_si)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_di_Vdi_si+EsatCVL_Ve_di_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_di_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_di_Ve_si)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_di_Ve_si+EsatCVL_Ve_di_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_di_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_di_Ve_di)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_di_Ve_di+EsatCVL_Ve_di_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_di_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_di_Vge_si)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_di_Vge_si+EsatCVL_Ve_di_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_di_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Ve_di_Tempt_GND)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Ve_di_Tempt_GND+EsatCVL_Ve_di_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Ve_di_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-((-Vdseff_Ve_di)*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Ve_di)/PCLMCV_i)*EsatCVL_Vge_e+0.0*(Vdsat_Ve_di+EsatCVL_Ve_di)+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Ve_di_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
MclmCV_Vge_si=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Vge_si_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vge_si_Vdi_si)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vge_si_Vdi_si+EsatCVL_Vge_si_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_si_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vge_si_Ve_si)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vge_si_Ve_si+EsatCVL_Vge_si_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_si_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vge_si_Ve_di)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vge_si_Ve_di+EsatCVL_Vge_si_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_si_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vge_si_Vge_si)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vge_si_Vge_si+EsatCVL_Vge_si_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_si_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Vge_si_Tempt_GND)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Vge_si_Tempt_GND+EsatCVL_Vge_si_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_si_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-((-Vdseff_Vge_si)*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Vge_si)/PCLMCV_i)*EsatCVL_Vge_e+0.0*(Vdsat_Vge_si+EsatCVL_Vge_si)+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_si_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
MclmCV_Tempt_GND=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Tempt_GND_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Tempt_GND_Vdi_si)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Tempt_GND_Vdi_si+EsatCVL_Tempt_GND_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Tempt_GND_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Tempt_GND_Ve_si)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Tempt_GND_Ve_si+EsatCVL_Tempt_GND_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Tempt_GND_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Tempt_GND_Ve_di)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Tempt_GND_Ve_di+EsatCVL_Tempt_GND_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Tempt_GND_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Tempt_GND_Vge_si)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Tempt_GND_Vge_si+EsatCVL_Tempt_GND_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Tempt_GND_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-Vdseff_Tempt_GND_Tempt_GND)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+Vdsat_Tempt_GND_Tempt_GND+EsatCVL_Tempt_GND_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Tempt_GND_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),((((-Vdseff_Tempt_GND)/PCLMCV_i)*(Vdsat+EsatCVL)-((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-((-Vdseff_Tempt_GND)*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(((-Vdseff_Tempt_GND)/PCLMCV_i)*EsatCVL_Vge_e+0.0*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Tempt_GND_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
MclmCV_Vge_e=(PCLMCV_i*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL))));
#if defined(_DERIVATE2)
  MclmCV_Vge_e_Vdi_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+(vds_Vdi_si-Vdseff_Vdi_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*(Vdsat_Vdi_si+EsatCVL_Vdi_si)+((vds_Vdi_si-Vdseff_Vdi_si)/PCLMCV_i)*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Vdi_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*(Vdsat_Vdi_si+EsatCVL_Vdi_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_e_Ve_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+(-Vdseff_Ve_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*(Vdsat_Ve_si+EsatCVL_Ve_si)+((-Vdseff_Ve_si)/PCLMCV_i)*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Ve_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*(Vdsat_Ve_si+EsatCVL_Ve_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_e_Ve_di=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+(-Vdseff_Ve_di)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*(Vdsat_Ve_di+EsatCVL_Ve_di)+((-Vdseff_Ve_di)/PCLMCV_i)*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Ve_di))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*(Vdsat_Ve_di+EsatCVL_Ve_di)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_e_Vge_si=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+(-Vdseff_Vge_si)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*(Vdsat_Vge_si+EsatCVL_Vge_si)+((-Vdseff_Vge_si)/PCLMCV_i)*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Vge_si))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*(Vdsat_Vge_si+EsatCVL_Vge_si)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_e_Tempt_GND=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+(-Vdseff_Tempt_GND)*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)+((-Vdseff_Tempt_GND)/PCLMCV_i)*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Tempt_GND))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*(Vdsat_Tempt_GND+EsatCVL_Tempt_GND)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
  MclmCV_Vge_e_Vge_e=(+0.0+(+0.0*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+0.0*bsimcmg_d_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))),(-((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))+PCLMCV_i*(+0.0+(((+0.0-0.0)/PCLMCV_i-(0.0*0.0+0.0*0.0+(vds-Vdseff)*0.0)/PCLMCV_i/PCLMCV_i+2*(vds-Vdseff)*0.0*0.0/PCLMCV_i/PCLMCV_i/PCLMCV_i)/(Vdsat+EsatCVL)-(0.0*EsatCVL_Vge_e+0.0*EsatCVL_Vge_e+((vds-Vdseff)/PCLMCV_i)*(+0.0+EsatCVL_Vge_e_Vge_e))/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)+2*((vds-Vdseff)/PCLMCV_i)*EsatCVL_Vge_e*EsatCVL_Vge_e/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)/(Vdsat+EsatCVL)))));
#endif
#endif
MclmCV=(1.0+(PCLMCV_i*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL))))));
EXIT_IF_ISNAN((1.0+(PCLMCV_i*bsimcmg_lln((1.0+(((vds-Vdseff)/PCLMCV_i)/(Vdsat+EsatCVL)))))))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
MclmCV_Vdi_si=0.0;
#if defined(_DERIVATE2)
  MclmCV_Vdi_si_Vdi_si=0.0;
  MclmCV_Vdi_si_Ve_si=0.0;
  MclmCV_Vdi_si_Ve_di=0.0;
  MclmCV_Vdi_si_Vge_si=0.0;
  MclmCV_Vdi_si_Tempt_GND=0.0;
  MclmCV_Vdi_si_Vge_e=0.0;
#endif
MclmCV_Ve_si=0.0;
#if defined(_DERIVATE2)
  MclmCV_Ve_si_Vdi_si=0.0;
  MclmCV_Ve_si_Ve_si=0.0;
  MclmCV_Ve_si_Ve_di=0.0;
  MclmCV_Ve_si_Vge_si=0.0;
  MclmCV_Ve_si_Tempt_GND=0.0;
  MclmCV_Ve_si_Vge_e=0.0;
#endif
MclmCV_Ve_di=0.0;
#if defined(_DERIVATE2)
  MclmCV_Ve_di_Vdi_si=0.0;
  MclmCV_Ve_di_Ve_si=0.0;
  MclmCV_Ve_di_Ve_di=0.0;
  MclmCV_Ve_di_Vge_si=0.0;
  MclmCV_Ve_di_Tempt_GND=0.0;
  MclmCV_Ve_di_Vge_e=0.0;
#endif
MclmCV_Vge_si=0.0;
#if defined(_DERIVATE2)
  MclmCV_Vge_si_Vdi_si=0.0;
  MclmCV_Vge_si_Ve_si=0.0;
  MclmCV_Vge_si_Ve_di=0.0;
  MclmCV_Vge_si_Vge_si=0.0;
  MclmCV_Vge_si_Tempt_GND=0.0;
  MclmCV_Vge_si_Vge_e=0.0;
#endif
MclmCV_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  MclmCV_Tempt_GND_Vdi_si=0.0;
  MclmCV_Tempt_GND_Ve_si=0.0;
  MclmCV_Tempt_GND_Ve_di=0.0;
  MclmCV_Tempt_GND_Vge_si=0.0;
  MclmCV_Tempt_GND_Tempt_GND=0.0;
  MclmCV_Tempt_GND_Vge_e=0.0;
#endif
MclmCV_Vge_e=0.0;
#if defined(_DERIVATE2)
  MclmCV_Vge_e_Vdi_si=0.0;
  MclmCV_Vge_e_Ve_si=0.0;
  MclmCV_Vge_e_Ve_di=0.0;
  MclmCV_Vge_e_Vge_si=0.0;
  MclmCV_Vge_e_Tempt_GND=0.0;
  MclmCV_Vge_e_Vge_e=0.0;
#endif
#endif
MclmCV=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DYNAMIC)
qb=((((-1.60219e-19)*nbody)*Ach)*LeffCV);
EXIT_IF_ISNAN(((((-1.60219e-19)*nbody)*Ach)*LeffCV))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=qia_Ve_si;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=qia_Ve_si_Ve_si;
  T1_Ve_si_Ve_di=qia_Ve_si_Ve_di;
  T1_Ve_si_Vge_si=qia_Ve_si_Vge_si;
  T1_Ve_si_Vdi_si=qia_Ve_si_Vdi_si;
  T1_Ve_si_Tempt_GND=qia_Ve_si_Tempt_GND;
#endif
T1_Ve_di=qia_Ve_di;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=qia_Ve_di_Ve_si;
  T1_Ve_di_Ve_di=qia_Ve_di_Ve_di;
  T1_Ve_di_Vge_si=qia_Ve_di_Vge_si;
  T1_Ve_di_Vdi_si=qia_Ve_di_Vdi_si;
  T1_Ve_di_Tempt_GND=qia_Ve_di_Tempt_GND;
#endif
T1_Vge_si=qia_Vge_si;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=qia_Vge_si_Ve_si;
  T1_Vge_si_Ve_di=qia_Vge_si_Ve_di;
  T1_Vge_si_Vge_si=qia_Vge_si_Vge_si;
  T1_Vge_si_Vdi_si=qia_Vge_si_Vdi_si;
  T1_Vge_si_Tempt_GND=qia_Vge_si_Tempt_GND;
#endif
T1_Vdi_si=qia_Vdi_si;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=qia_Vdi_si_Ve_si;
  T1_Vdi_si_Ve_di=qia_Vdi_si_Ve_di;
  T1_Vdi_si_Vge_si=qia_Vdi_si_Vge_si;
  T1_Vdi_si_Vdi_si=qia_Vdi_si_Vdi_si;
  T1_Vdi_si_Tempt_GND=qia_Vdi_si_Tempt_GND;
#endif
T1_Tempt_GND=qia_Tempt_GND;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=qia_Tempt_GND_Ve_si;
  T1_Tempt_GND_Ve_di=qia_Tempt_GND_Ve_di;
  T1_Tempt_GND_Vge_si=qia_Tempt_GND_Vge_si;
  T1_Tempt_GND_Vdi_si=qia_Tempt_GND_Vdi_si;
  T1_Tempt_GND_Tempt_GND=qia_Tempt_GND_Tempt_GND;
#endif
#endif
T1=qia;
EXIT_IF_ISNAN(qia)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
etaiv_Tempt_GND=((q0_Tempt_GND*(q0+qia)-q0*(q0_Tempt_GND+qia_Tempt_GND))/(q0+qia)/(q0+qia));
#if defined(_DERIVATE2)
  etaiv_Tempt_GND_Tempt_GND=(q0_Tempt_GND_Tempt_GND/(q0+qia)-(q0_Tempt_GND*(q0_Tempt_GND+qia_Tempt_GND)+q0_Tempt_GND*(q0_Tempt_GND+qia_Tempt_GND)+q0*(+q0_Tempt_GND_Tempt_GND+qia_Tempt_GND_Tempt_GND))/(q0+qia)/(q0+qia)+2*q0*(q0_Tempt_GND+qia_Tempt_GND)*(q0_Tempt_GND+qia_Tempt_GND)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Tempt_GND_Vdi_si=(q0_Tempt_GND_Vdi_si/(q0+qia)-(q0_Tempt_GND*(q0_Vdi_si+qia_Vdi_si)+q0_Vdi_si*(q0_Tempt_GND+qia_Tempt_GND)+q0*(+q0_Tempt_GND_Vdi_si+qia_Tempt_GND_Vdi_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Tempt_GND+qia_Tempt_GND)*(q0_Vdi_si+qia_Vdi_si)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Tempt_GND_Ve_si=(0.0/(q0+qia)-(q0_Tempt_GND*qia_Ve_si+0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0*(+0.0+qia_Tempt_GND_Ve_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Tempt_GND+qia_Tempt_GND)*qia_Ve_si/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Tempt_GND_Ve_di=(0.0/(q0+qia)-(q0_Tempt_GND*qia_Ve_di+0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0*(+0.0+qia_Tempt_GND_Ve_di))/(q0+qia)/(q0+qia)+2*q0*(q0_Tempt_GND+qia_Tempt_GND)*qia_Ve_di/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Tempt_GND_Vge_si=(0.0/(q0+qia)-(q0_Tempt_GND*qia_Vge_si+0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0*(+0.0+qia_Tempt_GND_Vge_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Tempt_GND+qia_Tempt_GND)*qia_Vge_si/(q0+qia)/(q0+qia)/(q0+qia));
#endif
etaiv_Vdi_si=((q0_Vdi_si*(q0+qia)-q0*(q0_Vdi_si+qia_Vdi_si))/(q0+qia)/(q0+qia));
#if defined(_DERIVATE2)
  etaiv_Vdi_si_Tempt_GND=(q0_Vdi_si_Tempt_GND/(q0+qia)-(q0_Vdi_si*(q0_Tempt_GND+qia_Tempt_GND)+q0_Tempt_GND*(q0_Vdi_si+qia_Vdi_si)+q0*(+q0_Vdi_si_Tempt_GND+qia_Vdi_si_Tempt_GND))/(q0+qia)/(q0+qia)+2*q0*(q0_Vdi_si+qia_Vdi_si)*(q0_Tempt_GND+qia_Tempt_GND)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vdi_si_Vdi_si=(q0_Vdi_si_Vdi_si/(q0+qia)-(q0_Vdi_si*(q0_Vdi_si+qia_Vdi_si)+q0_Vdi_si*(q0_Vdi_si+qia_Vdi_si)+q0*(+q0_Vdi_si_Vdi_si+qia_Vdi_si_Vdi_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Vdi_si+qia_Vdi_si)*(q0_Vdi_si+qia_Vdi_si)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vdi_si_Ve_si=(0.0/(q0+qia)-(q0_Vdi_si*qia_Ve_si+0.0*(q0_Vdi_si+qia_Vdi_si)+q0*(+0.0+qia_Vdi_si_Ve_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Vdi_si+qia_Vdi_si)*qia_Ve_si/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vdi_si_Ve_di=(0.0/(q0+qia)-(q0_Vdi_si*qia_Ve_di+0.0*(q0_Vdi_si+qia_Vdi_si)+q0*(+0.0+qia_Vdi_si_Ve_di))/(q0+qia)/(q0+qia)+2*q0*(q0_Vdi_si+qia_Vdi_si)*qia_Ve_di/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vdi_si_Vge_si=(0.0/(q0+qia)-(q0_Vdi_si*qia_Vge_si+0.0*(q0_Vdi_si+qia_Vdi_si)+q0*(+0.0+qia_Vdi_si_Vge_si))/(q0+qia)/(q0+qia)+2*q0*(q0_Vdi_si+qia_Vdi_si)*qia_Vge_si/(q0+qia)/(q0+qia)/(q0+qia));
#endif
etaiv_Ve_si=(-q0*qia_Ve_si/(q0+qia)/(q0+qia));
#if defined(_DERIVATE2)
  etaiv_Ve_si_Tempt_GND=(0.0/(q0+qia)-(0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0_Tempt_GND*qia_Ve_si+q0*(+0.0+qia_Ve_si_Tempt_GND))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_si*(q0_Tempt_GND+qia_Tempt_GND)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_si_Vdi_si=(0.0/(q0+qia)-(0.0*(q0_Vdi_si+qia_Vdi_si)+q0_Vdi_si*qia_Ve_si+q0*(+0.0+qia_Ve_si_Vdi_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_si*(q0_Vdi_si+qia_Vdi_si)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_si_Ve_si=(0.0/(q0+qia)-(0.0*qia_Ve_si+0.0*qia_Ve_si+q0*(+0.0+qia_Ve_si_Ve_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_si*qia_Ve_si/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_si_Ve_di=(0.0/(q0+qia)-(0.0*qia_Ve_di+0.0*qia_Ve_si+q0*(+0.0+qia_Ve_si_Ve_di))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_si*qia_Ve_di/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_si_Vge_si=(0.0/(q0+qia)-(0.0*qia_Vge_si+0.0*qia_Ve_si+q0*(+0.0+qia_Ve_si_Vge_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_si*qia_Vge_si/(q0+qia)/(q0+qia)/(q0+qia));
#endif
etaiv_Ve_di=(-q0*qia_Ve_di/(q0+qia)/(q0+qia));
#if defined(_DERIVATE2)
  etaiv_Ve_di_Tempt_GND=(0.0/(q0+qia)-(0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0_Tempt_GND*qia_Ve_di+q0*(+0.0+qia_Ve_di_Tempt_GND))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_di*(q0_Tempt_GND+qia_Tempt_GND)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_di_Vdi_si=(0.0/(q0+qia)-(0.0*(q0_Vdi_si+qia_Vdi_si)+q0_Vdi_si*qia_Ve_di+q0*(+0.0+qia_Ve_di_Vdi_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_di*(q0_Vdi_si+qia_Vdi_si)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_di_Ve_si=(0.0/(q0+qia)-(0.0*qia_Ve_si+0.0*qia_Ve_di+q0*(+0.0+qia_Ve_di_Ve_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_di*qia_Ve_si/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_di_Ve_di=(0.0/(q0+qia)-(0.0*qia_Ve_di+0.0*qia_Ve_di+q0*(+0.0+qia_Ve_di_Ve_di))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_di*qia_Ve_di/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Ve_di_Vge_si=(0.0/(q0+qia)-(0.0*qia_Vge_si+0.0*qia_Ve_di+q0*(+0.0+qia_Ve_di_Vge_si))/(q0+qia)/(q0+qia)+2*q0*qia_Ve_di*qia_Vge_si/(q0+qia)/(q0+qia)/(q0+qia));
#endif
etaiv_Vge_si=(-q0*qia_Vge_si/(q0+qia)/(q0+qia));
#if defined(_DERIVATE2)
  etaiv_Vge_si_Tempt_GND=(0.0/(q0+qia)-(0.0*(q0_Tempt_GND+qia_Tempt_GND)+q0_Tempt_GND*qia_Vge_si+q0*(+0.0+qia_Vge_si_Tempt_GND))/(q0+qia)/(q0+qia)+2*q0*qia_Vge_si*(q0_Tempt_GND+qia_Tempt_GND)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vge_si_Vdi_si=(0.0/(q0+qia)-(0.0*(q0_Vdi_si+qia_Vdi_si)+q0_Vdi_si*qia_Vge_si+q0*(+0.0+qia_Vge_si_Vdi_si))/(q0+qia)/(q0+qia)+2*q0*qia_Vge_si*(q0_Vdi_si+qia_Vdi_si)/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vge_si_Ve_si=(0.0/(q0+qia)-(0.0*qia_Ve_si+0.0*qia_Vge_si+q0*(+0.0+qia_Vge_si_Ve_si))/(q0+qia)/(q0+qia)+2*q0*qia_Vge_si*qia_Ve_si/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vge_si_Ve_di=(0.0/(q0+qia)-(0.0*qia_Ve_di+0.0*qia_Vge_si+q0*(+0.0+qia_Vge_si_Ve_di))/(q0+qia)/(q0+qia)+2*q0*qia_Vge_si*qia_Ve_di/(q0+qia)/(q0+qia)/(q0+qia));
  etaiv_Vge_si_Vge_si=(0.0/(q0+qia)-(0.0*qia_Vge_si+0.0*qia_Vge_si+q0*(+0.0+qia_Vge_si_Vge_si))/(q0+qia)/(q0+qia)+2*q0*qia_Vge_si*qia_Vge_si/(q0+qia)/(q0+qia)/(q0+qia));
#endif
#endif
etaiv=(q0/(q0+qia));
EXIT_IF_ISNAN((q0/(q0+qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(-etaiv_Vge_si)*nVtm;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+(+0.0-0.0)*nVtm+(-etaiv_Vge_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Vsi_s=(+(+0.0-0.0)*nVtm+(-etaiv_Vge_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Vge_di=(+(+0.0-0.0)*nVtm+(-etaiv_Vge_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Vge_e=(+(+0.0-0.0)*nVtm+(-etaiv_Vge_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Vge_si=(+(+0.0-etaiv_Vge_si_Vge_si)*nVtm+(-etaiv_Vge_si)*0.0+(-etaiv_Vge_si)*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Ve_si=(+(+0.0-etaiv_Vge_si_Ve_si)*nVtm+(-etaiv_Vge_si)*0.0+(-etaiv_Ve_si)*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Ve_di=(+(+0.0-etaiv_Vge_si_Ve_di)*nVtm+(-etaiv_Vge_si)*0.0+(-etaiv_Ve_di)*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Vdi_si=(+(+0.0-etaiv_Vge_si_Vdi_si)*nVtm+(-etaiv_Vge_si)*nVtm_Vdi_si+(-etaiv_Vdi_si)*0.0+(2.0-etaiv)*0.0);
  T2_Vge_si_Tempt_GND=(+(+0.0-etaiv_Vge_si_Tempt_GND)*nVtm+(-etaiv_Vge_si)*nVtm_Tempt_GND+(-etaiv_Tempt_GND)*0.0+(2.0-etaiv)*0.0);
#endif
T2_Ve_si=(-etaiv_Ve_si)*nVtm;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Vsi_s=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Vge_di=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Vge_e=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_si)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Vge_si=(+(+0.0-etaiv_Ve_si_Vge_si)*nVtm+(-etaiv_Ve_si)*0.0+(-etaiv_Vge_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Ve_si=(+(+0.0-etaiv_Ve_si_Ve_si)*nVtm+(-etaiv_Ve_si)*0.0+(-etaiv_Ve_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Ve_di=(+(+0.0-etaiv_Ve_si_Ve_di)*nVtm+(-etaiv_Ve_si)*0.0+(-etaiv_Ve_di)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Vdi_si=(+(+0.0-etaiv_Ve_si_Vdi_si)*nVtm+(-etaiv_Ve_si)*nVtm_Vdi_si+(-etaiv_Vdi_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_si_Tempt_GND=(+(+0.0-etaiv_Ve_si_Tempt_GND)*nVtm+(-etaiv_Ve_si)*nVtm_Tempt_GND+(-etaiv_Tempt_GND)*0.0+(2.0-etaiv)*0.0);
#endif
T2_Ve_di=(-etaiv_Ve_di)*nVtm;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_di)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Vsi_s=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_di)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Vge_di=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_di)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Vge_e=(+(+0.0-0.0)*nVtm+(-etaiv_Ve_di)*0.0+0.0*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Vge_si=(+(+0.0-etaiv_Ve_di_Vge_si)*nVtm+(-etaiv_Ve_di)*0.0+(-etaiv_Vge_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Ve_si=(+(+0.0-etaiv_Ve_di_Ve_si)*nVtm+(-etaiv_Ve_di)*0.0+(-etaiv_Ve_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Ve_di=(+(+0.0-etaiv_Ve_di_Ve_di)*nVtm+(-etaiv_Ve_di)*0.0+(-etaiv_Ve_di)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Vdi_si=(+(+0.0-etaiv_Ve_di_Vdi_si)*nVtm+(-etaiv_Ve_di)*nVtm_Vdi_si+(-etaiv_Vdi_si)*0.0+(2.0-etaiv)*0.0);
  T2_Ve_di_Tempt_GND=(+(+0.0-etaiv_Ve_di_Tempt_GND)*nVtm+(-etaiv_Ve_di)*nVtm_Tempt_GND+(-etaiv_Tempt_GND)*0.0+(2.0-etaiv)*0.0);
#endif
T2_Vdi_si=(((-etaiv_Vdi_si)*nVtm)+((2.0-etaiv)*nVtm_Vdi_si));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+0.0-0.0)*nVtm+(-etaiv_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Vsi_s=(+(+0.0-0.0)*nVtm+(-etaiv_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Vge_di=(+(+0.0-0.0)*nVtm+(-etaiv_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Vge_e=(+(+0.0-0.0)*nVtm+(-etaiv_Vdi_si)*0.0+0.0*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Vge_si=(+(+0.0-etaiv_Vdi_si_Vge_si)*nVtm+(-etaiv_Vdi_si)*0.0+(-etaiv_Vge_si)*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Ve_si=(+(+0.0-etaiv_Vdi_si_Ve_si)*nVtm+(-etaiv_Vdi_si)*0.0+(-etaiv_Ve_si)*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Ve_di=(+(+0.0-etaiv_Vdi_si_Ve_di)*nVtm+(-etaiv_Vdi_si)*0.0+(-etaiv_Ve_di)*nVtm_Vdi_si+(2.0-etaiv)*0.0);
  T2_Vdi_si_Vdi_si=(+(+0.0-etaiv_Vdi_si_Vdi_si)*nVtm+(-etaiv_Vdi_si)*nVtm_Vdi_si+(-etaiv_Vdi_si)*nVtm_Vdi_si+(2.0-etaiv)*nVtm_Vdi_si_Vdi_si);
  T2_Vdi_si_Tempt_GND=(+(+0.0-etaiv_Vdi_si_Tempt_GND)*nVtm+(-etaiv_Vdi_si)*nVtm_Tempt_GND+(-etaiv_Tempt_GND)*nVtm_Vdi_si+(2.0-etaiv)*nVtm_Vdi_si_Tempt_GND);
#endif
T2_Tempt_GND=(((-etaiv_Tempt_GND)*nVtm)+((2.0-etaiv)*nVtm_Tempt_GND));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+(+0.0-0.0)*nVtm+(-etaiv_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Vsi_s=(+(+0.0-0.0)*nVtm+(-etaiv_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Vge_di=(+(+0.0-0.0)*nVtm+(-etaiv_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Vge_e=(+(+0.0-0.0)*nVtm+(-etaiv_Tempt_GND)*0.0+0.0*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Vge_si=(+(+0.0-etaiv_Tempt_GND_Vge_si)*nVtm+(-etaiv_Tempt_GND)*0.0+(-etaiv_Vge_si)*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Ve_si=(+(+0.0-etaiv_Tempt_GND_Ve_si)*nVtm+(-etaiv_Tempt_GND)*0.0+(-etaiv_Ve_si)*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Ve_di=(+(+0.0-etaiv_Tempt_GND_Ve_di)*nVtm+(-etaiv_Tempt_GND)*0.0+(-etaiv_Ve_di)*nVtm_Tempt_GND+(2.0-etaiv)*0.0);
  T2_Tempt_GND_Vdi_si=(+(+0.0-etaiv_Tempt_GND_Vdi_si)*nVtm+(-etaiv_Tempt_GND)*nVtm_Vdi_si+(-etaiv_Vdi_si)*nVtm_Tempt_GND+(2.0-etaiv)*nVtm_Tempt_GND_Vdi_si);
  T2_Tempt_GND_Tempt_GND=(+(+0.0-etaiv_Tempt_GND_Tempt_GND)*nVtm+(-etaiv_Tempt_GND)*nVtm_Tempt_GND+(-etaiv_Tempt_GND)*nVtm_Tempt_GND+(2.0-etaiv)*nVtm_Tempt_GND_Tempt_GND);
#endif
#endif
T2=((2.0-etaiv)*nVtm);
EXIT_IF_ISNAN(((2.0-etaiv)*nVtm))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
ids0_ov_dqi_Vge_e=(T1_Vge_e+T2_Vge_e);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Vge_e_Vge_e=(+T1_Vge_e_Vge_e+T2_Vge_e_Vge_e);
  ids0_ov_dqi_Vge_e_Ve_si=(+T1_Vge_e_Ve_si+T2_Vge_e_Ve_si);
  ids0_ov_dqi_Vge_e_Ve_di=(+T1_Vge_e_Ve_di+T2_Vge_e_Ve_di);
  ids0_ov_dqi_Vge_e_Vge_si=(+T1_Vge_e_Vge_si+T2_Vge_e_Vge_si);
  ids0_ov_dqi_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si+T2_Vge_e_Vdi_si);
  ids0_ov_dqi_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND+T2_Vge_e_Tempt_GND);
#endif
ids0_ov_dqi_Ve_si=(T1_Ve_si+T2_Ve_si);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Ve_si_Vge_e=(+T1_Ve_si_Vge_e+T2_Ve_si_Vge_e);
  ids0_ov_dqi_Ve_si_Ve_si=(+T1_Ve_si_Ve_si+T2_Ve_si_Ve_si);
  ids0_ov_dqi_Ve_si_Ve_di=(+T1_Ve_si_Ve_di+T2_Ve_si_Ve_di);
  ids0_ov_dqi_Ve_si_Vge_si=(+T1_Ve_si_Vge_si+T2_Ve_si_Vge_si);
  ids0_ov_dqi_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si+T2_Ve_si_Vdi_si);
  ids0_ov_dqi_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND+T2_Ve_si_Tempt_GND);
#endif
ids0_ov_dqi_Ve_di=(T1_Ve_di+T2_Ve_di);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Ve_di_Vge_e=(+T1_Ve_di_Vge_e+T2_Ve_di_Vge_e);
  ids0_ov_dqi_Ve_di_Ve_si=(+T1_Ve_di_Ve_si+T2_Ve_di_Ve_si);
  ids0_ov_dqi_Ve_di_Ve_di=(+T1_Ve_di_Ve_di+T2_Ve_di_Ve_di);
  ids0_ov_dqi_Ve_di_Vge_si=(+T1_Ve_di_Vge_si+T2_Ve_di_Vge_si);
  ids0_ov_dqi_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si+T2_Ve_di_Vdi_si);
  ids0_ov_dqi_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND+T2_Ve_di_Tempt_GND);
#endif
ids0_ov_dqi_Vge_si=(T1_Vge_si+T2_Vge_si);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Vge_si_Vge_e=(+T1_Vge_si_Vge_e+T2_Vge_si_Vge_e);
  ids0_ov_dqi_Vge_si_Ve_si=(+T1_Vge_si_Ve_si+T2_Vge_si_Ve_si);
  ids0_ov_dqi_Vge_si_Ve_di=(+T1_Vge_si_Ve_di+T2_Vge_si_Ve_di);
  ids0_ov_dqi_Vge_si_Vge_si=(+T1_Vge_si_Vge_si+T2_Vge_si_Vge_si);
  ids0_ov_dqi_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si+T2_Vge_si_Vdi_si);
  ids0_ov_dqi_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND+T2_Vge_si_Tempt_GND);
#endif
ids0_ov_dqi_Vdi_si=(T1_Vdi_si+T2_Vdi_si);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e+T2_Vdi_si_Vge_e);
  ids0_ov_dqi_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si+T2_Vdi_si_Ve_si);
  ids0_ov_dqi_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di+T2_Vdi_si_Ve_di);
  ids0_ov_dqi_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si+T2_Vdi_si_Vge_si);
  ids0_ov_dqi_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si+T2_Vdi_si_Vdi_si);
  ids0_ov_dqi_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND+T2_Vdi_si_Tempt_GND);
#endif
ids0_ov_dqi_Tempt_GND=(T1_Tempt_GND+T2_Tempt_GND);
#if defined(_DERIVATE2)
  ids0_ov_dqi_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e+T2_Tempt_GND_Vge_e);
  ids0_ov_dqi_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si+T2_Tempt_GND_Ve_si);
  ids0_ov_dqi_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di+T2_Tempt_GND_Ve_di);
  ids0_ov_dqi_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si+T2_Tempt_GND_Vge_si);
  ids0_ov_dqi_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si+T2_Tempt_GND_Vdi_si);
  ids0_ov_dqi_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND+T2_Tempt_GND_Tempt_GND);
#endif
#endif
ids0_ov_dqi=(T1+T2);
EXIT_IF_ISNAN((T1+T2))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
ids0_Vge_e=ids0_ov_dqi_Vge_e*dqi;
#if defined(_DERIVATE2)
  ids0_Vge_e_Vge_e=(+ids0_ov_dqi_Vge_e_Vge_e*dqi+ids0_ov_dqi_Vge_e*0.0+ids0_ov_dqi_Vge_e*0.0+ids0_ov_dqi*0.0);
  ids0_Vge_e_Ve_si=(+ids0_ov_dqi_Vge_e_Ve_si*dqi+ids0_ov_dqi_Vge_e*dqi_Ve_si+ids0_ov_dqi_Ve_si*0.0+ids0_ov_dqi*0.0);
  ids0_Vge_e_Ve_di=(+ids0_ov_dqi_Vge_e_Ve_di*dqi+ids0_ov_dqi_Vge_e*dqi_Ve_di+ids0_ov_dqi_Ve_di*0.0+ids0_ov_dqi*0.0);
  ids0_Vge_e_Vge_si=(+ids0_ov_dqi_Vge_e_Vge_si*dqi+ids0_ov_dqi_Vge_e*dqi_Vge_si+ids0_ov_dqi_Vge_si*0.0+ids0_ov_dqi*0.0);
  ids0_Vge_e_Vdi_si=(+ids0_ov_dqi_Vge_e_Vdi_si*dqi+ids0_ov_dqi_Vge_e*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*0.0+ids0_ov_dqi*0.0);
  ids0_Vge_e_Tempt_GND=(+ids0_ov_dqi_Vge_e_Tempt_GND*dqi+ids0_ov_dqi_Vge_e*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*0.0+ids0_ov_dqi*0.0);
#endif
ids0_Ve_si=((ids0_ov_dqi_Ve_si*dqi)+(ids0_ov_dqi*dqi_Ve_si));
#if defined(_DERIVATE2)
  ids0_Ve_si_Vge_e=(+ids0_ov_dqi_Ve_si_Vge_e*dqi+ids0_ov_dqi_Ve_si*0.0+ids0_ov_dqi_Vge_e*dqi_Ve_si+ids0_ov_dqi*0.0);
  ids0_Ve_si_Ve_si=(+ids0_ov_dqi_Ve_si_Ve_si*dqi+ids0_ov_dqi_Ve_si*dqi_Ve_si+ids0_ov_dqi_Ve_si*dqi_Ve_si+ids0_ov_dqi*dqi_Ve_si_Ve_si);
  ids0_Ve_si_Ve_di=(+ids0_ov_dqi_Ve_si_Ve_di*dqi+ids0_ov_dqi_Ve_si*dqi_Ve_di+ids0_ov_dqi_Ve_di*dqi_Ve_si+ids0_ov_dqi*dqi_Ve_si_Ve_di);
  ids0_Ve_si_Vge_si=(+ids0_ov_dqi_Ve_si_Vge_si*dqi+ids0_ov_dqi_Ve_si*dqi_Vge_si+ids0_ov_dqi_Vge_si*dqi_Ve_si+ids0_ov_dqi*dqi_Ve_si_Vge_si);
  ids0_Ve_si_Vdi_si=(+ids0_ov_dqi_Ve_si_Vdi_si*dqi+ids0_ov_dqi_Ve_si*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*dqi_Ve_si+ids0_ov_dqi*dqi_Ve_si_Vdi_si);
  ids0_Ve_si_Tempt_GND=(+ids0_ov_dqi_Ve_si_Tempt_GND*dqi+ids0_ov_dqi_Ve_si*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*dqi_Ve_si+ids0_ov_dqi*dqi_Ve_si_Tempt_GND);
#endif
ids0_Ve_di=((ids0_ov_dqi_Ve_di*dqi)+(ids0_ov_dqi*dqi_Ve_di));
#if defined(_DERIVATE2)
  ids0_Ve_di_Vge_e=(+ids0_ov_dqi_Ve_di_Vge_e*dqi+ids0_ov_dqi_Ve_di*0.0+ids0_ov_dqi_Vge_e*dqi_Ve_di+ids0_ov_dqi*0.0);
  ids0_Ve_di_Ve_si=(+ids0_ov_dqi_Ve_di_Ve_si*dqi+ids0_ov_dqi_Ve_di*dqi_Ve_si+ids0_ov_dqi_Ve_si*dqi_Ve_di+ids0_ov_dqi*dqi_Ve_di_Ve_si);
  ids0_Ve_di_Ve_di=(+ids0_ov_dqi_Ve_di_Ve_di*dqi+ids0_ov_dqi_Ve_di*dqi_Ve_di+ids0_ov_dqi_Ve_di*dqi_Ve_di+ids0_ov_dqi*dqi_Ve_di_Ve_di);
  ids0_Ve_di_Vge_si=(+ids0_ov_dqi_Ve_di_Vge_si*dqi+ids0_ov_dqi_Ve_di*dqi_Vge_si+ids0_ov_dqi_Vge_si*dqi_Ve_di+ids0_ov_dqi*dqi_Ve_di_Vge_si);
  ids0_Ve_di_Vdi_si=(+ids0_ov_dqi_Ve_di_Vdi_si*dqi+ids0_ov_dqi_Ve_di*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*dqi_Ve_di+ids0_ov_dqi*dqi_Ve_di_Vdi_si);
  ids0_Ve_di_Tempt_GND=(+ids0_ov_dqi_Ve_di_Tempt_GND*dqi+ids0_ov_dqi_Ve_di*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*dqi_Ve_di+ids0_ov_dqi*dqi_Ve_di_Tempt_GND);
#endif
ids0_Vge_si=((ids0_ov_dqi_Vge_si*dqi)+(ids0_ov_dqi*dqi_Vge_si));
#if defined(_DERIVATE2)
  ids0_Vge_si_Vge_e=(+ids0_ov_dqi_Vge_si_Vge_e*dqi+ids0_ov_dqi_Vge_si*0.0+ids0_ov_dqi_Vge_e*dqi_Vge_si+ids0_ov_dqi*0.0);
  ids0_Vge_si_Ve_si=(+ids0_ov_dqi_Vge_si_Ve_si*dqi+ids0_ov_dqi_Vge_si*dqi_Ve_si+ids0_ov_dqi_Ve_si*dqi_Vge_si+ids0_ov_dqi*dqi_Vge_si_Ve_si);
  ids0_Vge_si_Ve_di=(+ids0_ov_dqi_Vge_si_Ve_di*dqi+ids0_ov_dqi_Vge_si*dqi_Ve_di+ids0_ov_dqi_Ve_di*dqi_Vge_si+ids0_ov_dqi*dqi_Vge_si_Ve_di);
  ids0_Vge_si_Vge_si=(+ids0_ov_dqi_Vge_si_Vge_si*dqi+ids0_ov_dqi_Vge_si*dqi_Vge_si+ids0_ov_dqi_Vge_si*dqi_Vge_si+ids0_ov_dqi*dqi_Vge_si_Vge_si);
  ids0_Vge_si_Vdi_si=(+ids0_ov_dqi_Vge_si_Vdi_si*dqi+ids0_ov_dqi_Vge_si*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*dqi_Vge_si+ids0_ov_dqi*dqi_Vge_si_Vdi_si);
  ids0_Vge_si_Tempt_GND=(+ids0_ov_dqi_Vge_si_Tempt_GND*dqi+ids0_ov_dqi_Vge_si*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*dqi_Vge_si+ids0_ov_dqi*dqi_Vge_si_Tempt_GND);
#endif
ids0_Vdi_si=((ids0_ov_dqi_Vdi_si*dqi)+(ids0_ov_dqi*dqi_Vdi_si));
#if defined(_DERIVATE2)
  ids0_Vdi_si_Vge_e=(+ids0_ov_dqi_Vdi_si_Vge_e*dqi+ids0_ov_dqi_Vdi_si*0.0+ids0_ov_dqi_Vge_e*dqi_Vdi_si+ids0_ov_dqi*0.0);
  ids0_Vdi_si_Ve_si=(+ids0_ov_dqi_Vdi_si_Ve_si*dqi+ids0_ov_dqi_Vdi_si*dqi_Ve_si+ids0_ov_dqi_Ve_si*dqi_Vdi_si+ids0_ov_dqi*dqi_Vdi_si_Ve_si);
  ids0_Vdi_si_Ve_di=(+ids0_ov_dqi_Vdi_si_Ve_di*dqi+ids0_ov_dqi_Vdi_si*dqi_Ve_di+ids0_ov_dqi_Ve_di*dqi_Vdi_si+ids0_ov_dqi*dqi_Vdi_si_Ve_di);
  ids0_Vdi_si_Vge_si=(+ids0_ov_dqi_Vdi_si_Vge_si*dqi+ids0_ov_dqi_Vdi_si*dqi_Vge_si+ids0_ov_dqi_Vge_si*dqi_Vdi_si+ids0_ov_dqi*dqi_Vdi_si_Vge_si);
  ids0_Vdi_si_Vdi_si=(+ids0_ov_dqi_Vdi_si_Vdi_si*dqi+ids0_ov_dqi_Vdi_si*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*dqi_Vdi_si+ids0_ov_dqi*dqi_Vdi_si_Vdi_si);
  ids0_Vdi_si_Tempt_GND=(+ids0_ov_dqi_Vdi_si_Tempt_GND*dqi+ids0_ov_dqi_Vdi_si*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*dqi_Vdi_si+ids0_ov_dqi*dqi_Vdi_si_Tempt_GND);
#endif
ids0_Tempt_GND=((ids0_ov_dqi_Tempt_GND*dqi)+(ids0_ov_dqi*dqi_Tempt_GND));
#if defined(_DERIVATE2)
  ids0_Tempt_GND_Vge_e=(+ids0_ov_dqi_Tempt_GND_Vge_e*dqi+ids0_ov_dqi_Tempt_GND*0.0+ids0_ov_dqi_Vge_e*dqi_Tempt_GND+ids0_ov_dqi*0.0);
  ids0_Tempt_GND_Ve_si=(+ids0_ov_dqi_Tempt_GND_Ve_si*dqi+ids0_ov_dqi_Tempt_GND*dqi_Ve_si+ids0_ov_dqi_Ve_si*dqi_Tempt_GND+ids0_ov_dqi*dqi_Tempt_GND_Ve_si);
  ids0_Tempt_GND_Ve_di=(+ids0_ov_dqi_Tempt_GND_Ve_di*dqi+ids0_ov_dqi_Tempt_GND*dqi_Ve_di+ids0_ov_dqi_Ve_di*dqi_Tempt_GND+ids0_ov_dqi*dqi_Tempt_GND_Ve_di);
  ids0_Tempt_GND_Vge_si=(+ids0_ov_dqi_Tempt_GND_Vge_si*dqi+ids0_ov_dqi_Tempt_GND*dqi_Vge_si+ids0_ov_dqi_Vge_si*dqi_Tempt_GND+ids0_ov_dqi*dqi_Tempt_GND_Vge_si);
  ids0_Tempt_GND_Vdi_si=(+ids0_ov_dqi_Tempt_GND_Vdi_si*dqi+ids0_ov_dqi_Tempt_GND*dqi_Vdi_si+ids0_ov_dqi_Vdi_si*dqi_Tempt_GND+ids0_ov_dqi*dqi_Tempt_GND_Vdi_si);
  ids0_Tempt_GND_Tempt_GND=(+ids0_ov_dqi_Tempt_GND_Tempt_GND*dqi+ids0_ov_dqi_Tempt_GND*dqi_Tempt_GND+ids0_ov_dqi_Tempt_GND*dqi_Tempt_GND+ids0_ov_dqi*dqi_Tempt_GND_Tempt_GND);
#endif
#endif
ids0=(ids0_ov_dqi*dqi);
EXIT_IF_ISNAN((ids0_ov_dqi*dqi))
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pModel->RDSMOD)==(1)))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Rdsi_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Rdsi_Tempt_GND_Tempt_GND=0.0;
  Rdsi_Tempt_GND_Vge_di=0.0;
  Rdsi_Tempt_GND_Vge_e=0.0;
  Rdsi_Tempt_GND_Ve_si=0.0;
  Rdsi_Tempt_GND_Ve_di=0.0;
  Rdsi_Tempt_GND_Vge_si=0.0;
  Rdsi_Tempt_GND_Vdi_si=0.0;
#endif
Rdsi_Vge_di=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_di_Tempt_GND=0.0;
  Rdsi_Vge_di_Vge_di=0.0;
  Rdsi_Vge_di_Vge_e=0.0;
  Rdsi_Vge_di_Ve_si=0.0;
  Rdsi_Vge_di_Ve_di=0.0;
  Rdsi_Vge_di_Vge_si=0.0;
  Rdsi_Vge_di_Vdi_si=0.0;
#endif
Rdsi_Vge_e=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_e_Tempt_GND=0.0;
  Rdsi_Vge_e_Vge_di=0.0;
  Rdsi_Vge_e_Vge_e=0.0;
  Rdsi_Vge_e_Ve_si=0.0;
  Rdsi_Vge_e_Ve_di=0.0;
  Rdsi_Vge_e_Vge_si=0.0;
  Rdsi_Vge_e_Vdi_si=0.0;
#endif
Rdsi_Ve_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Ve_si_Tempt_GND=0.0;
  Rdsi_Ve_si_Vge_di=0.0;
  Rdsi_Ve_si_Vge_e=0.0;
  Rdsi_Ve_si_Ve_si=0.0;
  Rdsi_Ve_si_Ve_di=0.0;
  Rdsi_Ve_si_Vge_si=0.0;
  Rdsi_Ve_si_Vdi_si=0.0;
#endif
Rdsi_Ve_di=0.0;
#if defined(_DERIVATE2)
  Rdsi_Ve_di_Tempt_GND=0.0;
  Rdsi_Ve_di_Vge_di=0.0;
  Rdsi_Ve_di_Vge_e=0.0;
  Rdsi_Ve_di_Ve_si=0.0;
  Rdsi_Ve_di_Ve_di=0.0;
  Rdsi_Ve_di_Vge_si=0.0;
  Rdsi_Ve_di_Vdi_si=0.0;
#endif
Rdsi_Vge_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vge_si_Tempt_GND=0.0;
  Rdsi_Vge_si_Vge_di=0.0;
  Rdsi_Vge_si_Vge_e=0.0;
  Rdsi_Vge_si_Ve_si=0.0;
  Rdsi_Vge_si_Ve_di=0.0;
  Rdsi_Vge_si_Vge_si=0.0;
  Rdsi_Vge_si_Vdi_si=0.0;
#endif
Rdsi_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Rdsi_Vdi_si_Tempt_GND=0.0;
  Rdsi_Vdi_si_Vge_di=0.0;
  Rdsi_Vdi_si_Vge_e=0.0;
  Rdsi_Vdi_si_Ve_si=0.0;
  Rdsi_Vdi_si_Ve_di=0.0;
  Rdsi_Vdi_si_Vge_si=0.0;
  Rdsi_Vdi_si_Vdi_si=0.0;
#endif
#endif
Rdsi=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Dr_Tempt_GND_Tempt_GND=0.0;
  Dr_Tempt_GND_Vdi_si=0.0;
  Dr_Tempt_GND_Vge_e=0.0;
  Dr_Tempt_GND_Ve_si=0.0;
  Dr_Tempt_GND_Ve_di=0.0;
  Dr_Tempt_GND_Vge_si=0.0;
  Dr_Tempt_GND_Vge_di=0.0;
#endif
Dr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Dr_Vdi_si_Tempt_GND=0.0;
  Dr_Vdi_si_Vdi_si=0.0;
  Dr_Vdi_si_Vge_e=0.0;
  Dr_Vdi_si_Ve_si=0.0;
  Dr_Vdi_si_Ve_di=0.0;
  Dr_Vdi_si_Vge_si=0.0;
  Dr_Vdi_si_Vge_di=0.0;
#endif
Dr_Vge_e=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_e_Tempt_GND=0.0;
  Dr_Vge_e_Vdi_si=0.0;
  Dr_Vge_e_Vge_e=0.0;
  Dr_Vge_e_Ve_si=0.0;
  Dr_Vge_e_Ve_di=0.0;
  Dr_Vge_e_Vge_si=0.0;
  Dr_Vge_e_Vge_di=0.0;
#endif
Dr_Ve_si=0.0;
#if defined(_DERIVATE2)
  Dr_Ve_si_Tempt_GND=0.0;
  Dr_Ve_si_Vdi_si=0.0;
  Dr_Ve_si_Vge_e=0.0;
  Dr_Ve_si_Ve_si=0.0;
  Dr_Ve_si_Ve_di=0.0;
  Dr_Ve_si_Vge_si=0.0;
  Dr_Ve_si_Vge_di=0.0;
#endif
Dr_Ve_di=0.0;
#if defined(_DERIVATE2)
  Dr_Ve_di_Tempt_GND=0.0;
  Dr_Ve_di_Vdi_si=0.0;
  Dr_Ve_di_Vge_e=0.0;
  Dr_Ve_di_Ve_si=0.0;
  Dr_Ve_di_Ve_di=0.0;
  Dr_Ve_di_Vge_si=0.0;
  Dr_Ve_di_Vge_di=0.0;
#endif
Dr_Vge_si=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_si_Tempt_GND=0.0;
  Dr_Vge_si_Vdi_si=0.0;
  Dr_Vge_si_Vge_e=0.0;
  Dr_Vge_si_Ve_si=0.0;
  Dr_Vge_si_Ve_di=0.0;
  Dr_Vge_si_Vge_si=0.0;
  Dr_Vge_si_Vge_di=0.0;
#endif
Dr_Vge_di=0.0;
#if defined(_DERIVATE2)
  Dr_Vge_di_Tempt_GND=0.0;
  Dr_Vge_di_Vdi_si=0.0;
  Dr_Vge_di_Vge_e=0.0;
  Dr_Vge_di_Ve_si=0.0;
  Dr_Vge_di_Ve_di=0.0;
  Dr_Vge_di_Vge_si=0.0;
  Dr_Vge_di_Vge_di=0.0;
#endif
#endif
Dr=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=vgs_noswap_Vge_si;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0-0.0);
  T2_Vge_si_Vsi_s=(+0.0-0.0);
  T2_Vge_si_Vge_di=(+0.0-0.0);
  T2_Vge_si_Vge_e=(+0.0-0.0);
  T2_Vge_si_Vge_si=(+vgs_noswap_Vge_si_Vge_si-0.0);
  T2_Vge_si_Ve_si=(+0.0-0.0);
  T2_Vge_si_Ve_di=(+0.0-0.0);
  T2_Vge_si_Vdi_si=(+0.0-0.0);
  T2_Vge_si_Tempt_GND=(+0.0-0.0);
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(-vfbsd_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0-0.0);
  T2_Tempt_GND_Vsi_s=(+0.0-0.0);
  T2_Tempt_GND_Vge_di=(+0.0-0.0);
  T2_Tempt_GND_Vge_e=(+0.0-0.0);
  T2_Tempt_GND_Vge_si=(+0.0-0.0);
  T2_Tempt_GND_Ve_si=(+0.0-0.0);
  T2_Tempt_GND_Ve_di=(+0.0-0.0);
  T2_Tempt_GND_Vdi_si=(+0.0-0.0);
  T2_Tempt_GND_Tempt_GND=(+0.0-vfbsd_Tempt_GND_Tempt_GND);
#endif
#endif
T2=(vgs_noswap-vfbsd);
EXIT_IF_ISNAN((vgs_noswap-vfbsd))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+1.0e-1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+1.0e-1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_d*T2+T2_Vge_e*T2_Vdi_d+T2_Vdi_d*T2_Vge_e+T2*T2_Vge_e_Vdi_d)+0.0));
  T3_Vge_e_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vsi_s*T2+T2_Vge_e*T2_Vsi_s+T2_Vsi_s*T2_Vge_e+T2*T2_Vge_e_Vsi_s)+0.0));
  T3_Vge_e_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_di*T2+T2_Vge_e*T2_Vge_di+T2_Vge_di*T2_Vge_e+T2*T2_Vge_e_Vge_di)+0.0));
  T3_Vge_e_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_e*T2+T2_Vge_e*T2_Vge_e+T2_Vge_e*T2_Vge_e+T2*T2_Vge_e_Vge_e)+0.0));
  T3_Vge_e_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_si*T2+T2_Vge_e*T2_Vdi_si+T2_Vdi_si*T2_Vge_e+T2*T2_Vge_e_Vdi_si)+0.0));
  T3_Vge_e_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_si*T2+T2_Vge_e*T2_Ve_si+T2_Ve_si*T2_Vge_e+T2*T2_Vge_e_Ve_si)+0.0));
  T3_Vge_e_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_di*T2+T2_Vge_e*T2_Ve_di+T2_Ve_di*T2_Vge_e+T2*T2_Vge_e_Ve_di)+0.0));
  T3_Vge_e_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_si*T2+T2_Vge_e*T2_Vge_si+T2_Vge_si*T2_Vge_e+T2*T2_Vge_e_Vge_si)+0.0));
  T3_Vge_e_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Tempt_GND*T2+T2_Vge_e*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_e+T2*T2_Vge_e_Tempt_GND)+0.0));
#endif
T3_Vdi_si=((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_d*T2+T2_Vdi_si*T2_Vdi_d+T2_Vdi_d*T2_Vdi_si+T2*T2_Vdi_si_Vdi_d)+0.0));
  T3_Vdi_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vsi_s*T2+T2_Vdi_si*T2_Vsi_s+T2_Vsi_s*T2_Vdi_si+T2*T2_Vdi_si_Vsi_s)+0.0));
  T3_Vdi_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_di*T2+T2_Vdi_si*T2_Vge_di+T2_Vge_di*T2_Vdi_si+T2*T2_Vdi_si_Vge_di)+0.0));
  T3_Vdi_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_e*T2+T2_Vdi_si*T2_Vge_e+T2_Vge_e*T2_Vdi_si+T2*T2_Vdi_si_Vge_e)+0.0));
  T3_Vdi_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_si*T2+T2_Vdi_si*T2_Vdi_si+T2_Vdi_si*T2_Vdi_si+T2*T2_Vdi_si_Vdi_si)+0.0));
  T3_Vdi_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_si*T2+T2_Vdi_si*T2_Ve_si+T2_Ve_si*T2_Vdi_si+T2*T2_Vdi_si_Ve_si)+0.0));
  T3_Vdi_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_di*T2+T2_Vdi_si*T2_Ve_di+T2_Ve_di*T2_Vdi_si+T2*T2_Vdi_si_Ve_di)+0.0));
  T3_Vdi_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_si*T2+T2_Vdi_si*T2_Vge_si+T2_Vge_si*T2_Vdi_si+T2*T2_Vdi_si_Vge_si)+0.0));
  T3_Vdi_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Tempt_GND*T2+T2_Vdi_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_si+T2*T2_Vdi_si_Tempt_GND)+0.0));
#endif
T3_Ve_si=((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_d*T2+T2_Ve_si*T2_Vdi_d+T2_Vdi_d*T2_Ve_si+T2*T2_Ve_si_Vdi_d)+0.0));
  T3_Ve_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vsi_s*T2+T2_Ve_si*T2_Vsi_s+T2_Vsi_s*T2_Ve_si+T2*T2_Ve_si_Vsi_s)+0.0));
  T3_Ve_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_di*T2+T2_Ve_si*T2_Vge_di+T2_Vge_di*T2_Ve_si+T2*T2_Ve_si_Vge_di)+0.0));
  T3_Ve_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_e*T2+T2_Ve_si*T2_Vge_e+T2_Vge_e*T2_Ve_si+T2*T2_Ve_si_Vge_e)+0.0));
  T3_Ve_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_si*T2+T2_Ve_si*T2_Vdi_si+T2_Vdi_si*T2_Ve_si+T2*T2_Ve_si_Vdi_si)+0.0));
  T3_Ve_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_si*T2+T2_Ve_si*T2_Ve_si+T2_Ve_si*T2_Ve_si+T2*T2_Ve_si_Ve_si)+0.0));
  T3_Ve_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_di*T2+T2_Ve_si*T2_Ve_di+T2_Ve_di*T2_Ve_si+T2*T2_Ve_si_Ve_di)+0.0));
  T3_Ve_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_si*T2+T2_Ve_si*T2_Vge_si+T2_Vge_si*T2_Ve_si+T2*T2_Ve_si_Vge_si)+0.0));
  T3_Ve_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Tempt_GND*T2+T2_Ve_si*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_si+T2*T2_Ve_si_Tempt_GND)+0.0));
#endif
T3_Ve_di=((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_d*T2+T2_Ve_di*T2_Vdi_d+T2_Vdi_d*T2_Ve_di+T2*T2_Ve_di_Vdi_d)+0.0));
  T3_Ve_di_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vsi_s*T2+T2_Ve_di*T2_Vsi_s+T2_Vsi_s*T2_Ve_di+T2*T2_Ve_di_Vsi_s)+0.0));
  T3_Ve_di_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_di*T2+T2_Ve_di*T2_Vge_di+T2_Vge_di*T2_Ve_di+T2*T2_Ve_di_Vge_di)+0.0));
  T3_Ve_di_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_e*T2+T2_Ve_di*T2_Vge_e+T2_Vge_e*T2_Ve_di+T2*T2_Ve_di_Vge_e)+0.0));
  T3_Ve_di_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_si*T2+T2_Ve_di*T2_Vdi_si+T2_Vdi_si*T2_Ve_di+T2*T2_Ve_di_Vdi_si)+0.0));
  T3_Ve_di_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_si*T2+T2_Ve_di*T2_Ve_si+T2_Ve_si*T2_Ve_di+T2*T2_Ve_di_Ve_si)+0.0));
  T3_Ve_di_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_di*T2+T2_Ve_di*T2_Ve_di+T2_Ve_di*T2_Ve_di+T2*T2_Ve_di_Ve_di)+0.0));
  T3_Ve_di_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_si*T2+T2_Ve_di*T2_Vge_si+T2_Vge_si*T2_Ve_di+T2*T2_Ve_di_Vge_si)+0.0));
  T3_Ve_di_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Tempt_GND*T2+T2_Ve_di*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_di+T2*T2_Ve_di_Tempt_GND)+0.0));
#endif
T3_Vge_si=((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_d*T2+T2_Vge_si*T2_Vdi_d+T2_Vdi_d*T2_Vge_si+T2*T2_Vge_si_Vdi_d)+0.0));
  T3_Vge_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vsi_s*T2+T2_Vge_si*T2_Vsi_s+T2_Vsi_s*T2_Vge_si+T2*T2_Vge_si_Vsi_s)+0.0));
  T3_Vge_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_di*T2+T2_Vge_si*T2_Vge_di+T2_Vge_di*T2_Vge_si+T2*T2_Vge_si_Vge_di)+0.0));
  T3_Vge_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_e*T2+T2_Vge_si*T2_Vge_e+T2_Vge_e*T2_Vge_si+T2*T2_Vge_si_Vge_e)+0.0));
  T3_Vge_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_si*T2+T2_Vge_si*T2_Vdi_si+T2_Vdi_si*T2_Vge_si+T2*T2_Vge_si_Vdi_si)+0.0));
  T3_Vge_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_si*T2+T2_Vge_si*T2_Ve_si+T2_Ve_si*T2_Vge_si+T2*T2_Vge_si_Ve_si)+0.0));
  T3_Vge_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_di*T2+T2_Vge_si*T2_Ve_di+T2_Ve_di*T2_Vge_si+T2*T2_Vge_si_Ve_di)+0.0));
  T3_Vge_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_si*T2+T2_Vge_si*T2_Vge_si+T2_Vge_si*T2_Vge_si+T2*T2_Vge_si_Vge_si)+0.0));
  T3_Vge_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Tempt_GND*T2+T2_Vge_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_si+T2*T2_Vge_si_Tempt_GND)+0.0));
#endif
T3_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_d*T2+T2_Tempt_GND*T2_Vdi_d+T2_Vdi_d*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_d)+0.0));
  T3_Tempt_GND_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vsi_s*T2+T2_Tempt_GND*T2_Vsi_s+T2_Vsi_s*T2_Tempt_GND+T2*T2_Tempt_GND_Vsi_s)+0.0));
  T3_Tempt_GND_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_di*T2+T2_Tempt_GND*T2_Vge_di+T2_Vge_di*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_di)+0.0));
  T3_Tempt_GND_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_e*T2+T2_Tempt_GND*T2_Vge_e+T2_Vge_e*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_e)+0.0));
  T3_Tempt_GND_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_si*T2+T2_Tempt_GND*T2_Vdi_si+T2_Vdi_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_si)+0.0));
  T3_Tempt_GND_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_si*T2+T2_Tempt_GND*T2_Ve_si+T2_Ve_si*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_si)+0.0));
  T3_Tempt_GND_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_di*T2+T2_Tempt_GND*T2_Ve_di+T2_Ve_di*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_di)+0.0));
  T3_Tempt_GND_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_si*T2+T2_Tempt_GND*T2_Vge_si+T2_Vge_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_si)+0.0));
  T3_Tempt_GND_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Tempt_GND*T2+T2_Tempt_GND*T2_Tempt_GND+T2_Tempt_GND*T2_Tempt_GND+T2*T2_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
T3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
vgs_eff_Vge_di=0.0;
#if defined(_DERIVATE2)
  vgs_eff_Vge_di_Vge_di=0.0;
  vgs_eff_Vge_di_Vge_e=0.0;
  vgs_eff_Vge_di_Vge_si=0.0;
  vgs_eff_Vge_di_Ve_si=0.0;
  vgs_eff_Vge_di_Ve_di=0.0;
  vgs_eff_Vge_di_Vdi_si=0.0;
  vgs_eff_Vge_di_Tempt_GND=0.0;
#endif
vgs_eff_Vge_e=(0.5*(T2_Vge_e+T3_Vge_e));
#if defined(_DERIVATE2)
  vgs_eff_Vge_e_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_di+T3_Vge_e_Vge_di));
  vgs_eff_Vge_e_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_e+T3_Vge_e_Vge_e));
  vgs_eff_Vge_e_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_si+T3_Vge_e_Vge_si));
  vgs_eff_Vge_e_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Ve_si+T3_Vge_e_Ve_si));
  vgs_eff_Vge_e_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Ve_di+T3_Vge_e_Ve_di));
  vgs_eff_Vge_e_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vdi_si+T3_Vge_e_Vdi_si));
  vgs_eff_Vge_e_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Tempt_GND+T3_Vge_e_Tempt_GND));
#endif
vgs_eff_Vge_si=(0.5*(T2_Vge_si+T3_Vge_si));
#if defined(_DERIVATE2)
  vgs_eff_Vge_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_di+T3_Vge_si_Vge_di));
  vgs_eff_Vge_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_e+T3_Vge_si_Vge_e));
  vgs_eff_Vge_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_si+T3_Vge_si_Vge_si));
  vgs_eff_Vge_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Ve_si+T3_Vge_si_Ve_si));
  vgs_eff_Vge_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Ve_di+T3_Vge_si_Ve_di));
  vgs_eff_Vge_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vdi_si+T3_Vge_si_Vdi_si));
  vgs_eff_Vge_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Tempt_GND+T3_Vge_si_Tempt_GND));
#endif
vgs_eff_Ve_si=(0.5*(T2_Ve_si+T3_Ve_si));
#if defined(_DERIVATE2)
  vgs_eff_Ve_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_di+T3_Ve_si_Vge_di));
  vgs_eff_Ve_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_e+T3_Ve_si_Vge_e));
  vgs_eff_Ve_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_si+T3_Ve_si_Vge_si));
  vgs_eff_Ve_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Ve_si+T3_Ve_si_Ve_si));
  vgs_eff_Ve_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Ve_di+T3_Ve_si_Ve_di));
  vgs_eff_Ve_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vdi_si+T3_Ve_si_Vdi_si));
  vgs_eff_Ve_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Tempt_GND+T3_Ve_si_Tempt_GND));
#endif
vgs_eff_Ve_di=(0.5*(T2_Ve_di+T3_Ve_di));
#if defined(_DERIVATE2)
  vgs_eff_Ve_di_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_di+T3_Ve_di_Vge_di));
  vgs_eff_Ve_di_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_e+T3_Ve_di_Vge_e));
  vgs_eff_Ve_di_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_si+T3_Ve_di_Vge_si));
  vgs_eff_Ve_di_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Ve_si+T3_Ve_di_Ve_si));
  vgs_eff_Ve_di_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Ve_di+T3_Ve_di_Ve_di));
  vgs_eff_Ve_di_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vdi_si+T3_Ve_di_Vdi_si));
  vgs_eff_Ve_di_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Tempt_GND+T3_Ve_di_Tempt_GND));
#endif
vgs_eff_Vdi_si=(0.5*(T2_Vdi_si+T3_Vdi_si));
#if defined(_DERIVATE2)
  vgs_eff_Vdi_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_di+T3_Vdi_si_Vge_di));
  vgs_eff_Vdi_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_e+T3_Vdi_si_Vge_e));
  vgs_eff_Vdi_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_si+T3_Vdi_si_Vge_si));
  vgs_eff_Vdi_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Ve_si+T3_Vdi_si_Ve_si));
  vgs_eff_Vdi_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Ve_di+T3_Vdi_si_Ve_di));
  vgs_eff_Vdi_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vdi_si+T3_Vdi_si_Vdi_si));
  vgs_eff_Vdi_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Tempt_GND+T3_Vdi_si_Tempt_GND));
#endif
vgs_eff_Tempt_GND=(0.5*(T2_Tempt_GND+T3_Tempt_GND));
#if defined(_DERIVATE2)
  vgs_eff_Tempt_GND_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_di+T3_Tempt_GND_Vge_di));
  vgs_eff_Tempt_GND_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_e+T3_Tempt_GND_Vge_e));
  vgs_eff_Tempt_GND_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_si+T3_Tempt_GND_Vge_si));
  vgs_eff_Tempt_GND_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_si+T3_Tempt_GND_Ve_si));
  vgs_eff_Tempt_GND_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_di+T3_Tempt_GND_Ve_di));
  vgs_eff_Tempt_GND_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vdi_si+T3_Tempt_GND_Vdi_si));
  vgs_eff_Tempt_GND_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Tempt_GND+T3_Tempt_GND_Tempt_GND));
#endif
#endif
vgs_eff=(0.5*(T2+T3));
EXIT_IF_ISNAN((0.5*(T2+T3)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=(PRWGS_i*vgs_eff_Vge_e);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Vge_di));
  T4_Vge_e_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Vge_e));
  T4_Vge_e_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Vdi_si));
  T4_Vge_e_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Ve_si));
  T4_Vge_e_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Ve_di));
  T4_Vge_e_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Vge_si));
  T4_Vge_e_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_e+PRWGS_i*vgs_eff_Vge_e_Tempt_GND));
#endif
T4_Vdi_si=(PRWGS_i*vgs_eff_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Vge_di));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Vge_e));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vdi_si+PRWGS_i*vgs_eff_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGS_i*vgs_eff_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Vge_di));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Vge_e));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_si+PRWGS_i*vgs_eff_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGS_i*vgs_eff_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Vge_di));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Vge_e));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_di+PRWGS_i*vgs_eff_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGS_i*vgs_eff_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Vge_di));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Vge_e));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_si+PRWGS_i*vgs_eff_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGS_i*vgs_eff_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Vge_di));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Vge_e));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Tempt_GND+PRWGS_i*vgs_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGS_i*vgs_eff));
EXIT_IF_ISNAN((1.0+(PRWGS_i*vgs_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=(-T4_Vge_e/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_di)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_di/T4/T4/T4);
  T1_Vge_e_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_e)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_e/T4/T4/T4);
  T1_Vge_e_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_si)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_si/T4/T4/T4);
  T1_Vge_e_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_di)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_di/T4/T4/T4);
  T1_Vge_e_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_si/T4/T4/T4);
  T1_Vge_e_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vdi_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vdi_si/T4/T4/T4);
  T1_Vge_e_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_e+1.0*T4_Vge_e_Tempt_GND)/T4/T4+2*1.0*T4_Vge_e*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=(0.5*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di)+0.0))));
  T0_Vge_e_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e)+0.0))));
  T0_Vge_e_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si)+0.0))));
  T0_Vge_e_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di)+0.0))));
  T0_Vge_e_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si)+0.0))));
  T0_Vge_e_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si)+0.0))));
  T0_Vge_e_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND)+0.0))));
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=(RSW_i*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))));
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Vdi_d=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Vsi_s=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*1.0+1.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Vge_e=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Vdi_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Ve_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Ve_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Vge_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vsi_s_Tempt_GND=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))))+0.0*(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s)))))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),((NP(si)-NP(s))+(NP(si)-NP(s))))+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+1.0*0.0+0.0*1.0+(NP(si)-NP(s))*0.0)+0.0)))));
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=(RSW_i*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Vdi_d=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Vsi_s=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*1.0+1.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Vge_e=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Vdi_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+RSDR_a_Vdi_si_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Ve_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Ve_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Vge_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Vdi_si_Tempt_GND=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))))+0.0*((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+RSDR_a_Vdi_si_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
#endif
T5_Ve_si=0.0;
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=0.0;
  T5_Ve_si_Vdi_d=0.0;
  T5_Ve_si_Vsi_s=0.0;
  T5_Ve_si_Vge_e=0.0;
  T5_Ve_si_Vdi_si=0.0;
  T5_Ve_si_Ve_si=0.0;
  T5_Ve_si_Ve_di=0.0;
  T5_Ve_si_Vge_si=0.0;
  T5_Ve_si_Tempt_GND=0.0;
#endif
T5_Ve_di=0.0;
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=0.0;
  T5_Ve_di_Vdi_d=0.0;
  T5_Ve_di_Vsi_s=0.0;
  T5_Ve_di_Vge_e=0.0;
  T5_Ve_di_Vdi_si=0.0;
  T5_Ve_di_Ve_si=0.0;
  T5_Ve_di_Ve_di=0.0;
  T5_Ve_di_Vge_si=0.0;
  T5_Ve_di_Tempt_GND=0.0;
#endif
T5_Vge_si=0.0;
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=0.0;
  T5_Vge_si_Vdi_d=0.0;
  T5_Vge_si_Vsi_s=0.0;
  T5_Vge_si_Vge_e=0.0;
  T5_Vge_si_Vdi_si=0.0;
  T5_Vge_si_Ve_si=0.0;
  T5_Vge_si_Ve_di=0.0;
  T5_Vge_si_Vge_si=0.0;
  T5_Vge_si_Tempt_GND=0.0;
#endif
T5_Tempt_GND=(RSW_i*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Vdi_d=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Vsi_s=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*1.0+1.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Vge_e=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Vdi_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+RSDR_a_Tempt_GND_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Ve_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Ve_di=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Vge_si=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*((RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
  T5_Tempt_GND_Tempt_GND=(+0.0*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))+0.0*(((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0))))))+0.0*((RSDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))+(RSDR_a*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))))+RSW_i*(+0.0+(+RSDR_a_Tempt_GND_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))),((0.5*pModel->PRSDR)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)))+RSDR_a*(+(+0.0*pModel->PRSDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6),0.0)+(0.5*pModel->PRSDR)*(+(+0.0*(NP(si)-NP(s))+0.0*0.0+0.0*0.0+(NP(si)-NP(s))*0.0)+0.0)))));
#endif
#endif
T5=(RSW_i*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6)))))));
EXIT_IF_ISNAN((RSW_i*(1.0+(RSDR_a*bsimcmg_lexp(((0.5*pModel->PRSDR)*bsimcmg_lln((((NP(si)-NP(s))*(NP(si)-NP(s)))+1.0E-6))))))))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Rsource_Tempt_GND=((rdstemp_Tempt_GND*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)))+(rdstemp*((T5_Tempt_GND*T0)+(T5*T0_Tempt_GND))*WeffWRFactor));
Rsource_Vsi_s=(rdstemp*T5_Vsi_s*T0*WeffWRFactor);
Rsource_Vge_e=(rdstemp*((T5_Vge_e*T0)+(T5*T0_Vge_e))*WeffWRFactor);
Rsource_Vdi_si=(rdstemp*((T5_Vdi_si*T0)+(T5*T0_Vdi_si))*WeffWRFactor);
Rsource_Ve_si=(rdstemp*((T5_Ve_si*T0)+(T5*T0_Ve_si))*WeffWRFactor);
Rsource_Ve_di=(rdstemp*((T5_Ve_di*T0)+(T5*T0_Ve_di))*WeffWRFactor);
Rsource_Vge_si=(rdstemp*((T5_Vge_si*T0)+(T5*T0_Vge_si))*WeffWRFactor);
#endif
Rsource=(rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor)));
EXIT_IF_ISNAN((rdstemp*(RSourceGeo+((RSWMIN_i+(T5*T0))*WeffWRFactor))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=vgd_noswap_Vge_di;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+0.0-0.0);
  T2_Vge_di_Vsi_s=(+0.0-0.0);
  T2_Vge_di_Vge_di=(+vgd_noswap_Vge_di_Vge_di-0.0);
  T2_Vge_di_Vge_e=(+0.0-0.0);
  T2_Vge_di_Vge_si=(+0.0-0.0);
  T2_Vge_di_Ve_si=(+0.0-0.0);
  T2_Vge_di_Ve_di=(+0.0-0.0);
  T2_Vge_di_Vdi_si=(+0.0-0.0);
  T2_Vge_di_Tempt_GND=(+0.0-0.0);
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(-vfbsd_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0-0.0);
  T2_Tempt_GND_Vsi_s=(+0.0-0.0);
  T2_Tempt_GND_Vge_di=(+0.0-0.0);
  T2_Tempt_GND_Vge_e=(+0.0-0.0);
  T2_Tempt_GND_Vge_si=(+0.0-0.0);
  T2_Tempt_GND_Ve_si=(+0.0-0.0);
  T2_Tempt_GND_Ve_di=(+0.0-0.0);
  T2_Tempt_GND_Vdi_si=(+0.0-0.0);
  T2_Tempt_GND_Tempt_GND=(+0.0-vfbsd_Tempt_GND_Tempt_GND);
#endif
#endif
T2=(vgd_noswap-vfbsd);
EXIT_IF_ISNAN((vgd_noswap-vfbsd))
{
double m00_sqrt(d00_sqrt0,((T2*T2)+1.0e-1))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T2*T2)+1.0e-1))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=((T2_Vge_di*T2)+(T2*T2_Vge_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vdi_d*T2+T2_Vge_di*T2_Vdi_d+T2_Vdi_d*T2_Vge_di+T2*T2_Vge_di_Vdi_d)+0.0));
  T3_Vge_di_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vsi_s*T2+T2_Vge_di*T2_Vsi_s+T2_Vsi_s*T2_Vge_di+T2*T2_Vge_di_Vsi_s)+0.0));
  T3_Vge_di_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vge_di*T2+T2_Vge_di*T2_Vge_di+T2_Vge_di*T2_Vge_di+T2*T2_Vge_di_Vge_di)+0.0));
  T3_Vge_di_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vge_e*T2+T2_Vge_di*T2_Vge_e+T2_Vge_e*T2_Vge_di+T2*T2_Vge_di_Vge_e)+0.0));
  T3_Vge_di_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vdi_si*T2+T2_Vge_di*T2_Vdi_si+T2_Vdi_si*T2_Vge_di+T2*T2_Vge_di_Vdi_si)+0.0));
  T3_Vge_di_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Ve_si*T2+T2_Vge_di*T2_Ve_si+T2_Ve_si*T2_Vge_di+T2*T2_Vge_di_Ve_si)+0.0));
  T3_Vge_di_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Ve_di*T2+T2_Vge_di*T2_Ve_di+T2_Ve_di*T2_Vge_di+T2*T2_Vge_di_Ve_di)+0.0));
  T3_Vge_di_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Vge_si*T2+T2_Vge_di*T2_Vge_si+T2_Vge_si*T2_Vge_di+T2*T2_Vge_di_Vge_si)+0.0));
  T3_Vge_di_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_di*T2)+(T2*T2_Vge_di))+d10_sqrt0*(+(+T2_Vge_di_Tempt_GND*T2+T2_Vge_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_di+T2*T2_Vge_di_Tempt_GND)+0.0));
#endif
T3_Vge_e=((T2_Vge_e*T2)+(T2*T2_Vge_e))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_d*T2+T2_Vge_e*T2_Vdi_d+T2_Vdi_d*T2_Vge_e+T2*T2_Vge_e_Vdi_d)+0.0));
  T3_Vge_e_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vsi_s*T2+T2_Vge_e*T2_Vsi_s+T2_Vsi_s*T2_Vge_e+T2*T2_Vge_e_Vsi_s)+0.0));
  T3_Vge_e_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_di*T2+T2_Vge_e*T2_Vge_di+T2_Vge_di*T2_Vge_e+T2*T2_Vge_e_Vge_di)+0.0));
  T3_Vge_e_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_e*T2+T2_Vge_e*T2_Vge_e+T2_Vge_e*T2_Vge_e+T2*T2_Vge_e_Vge_e)+0.0));
  T3_Vge_e_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vdi_si*T2+T2_Vge_e*T2_Vdi_si+T2_Vdi_si*T2_Vge_e+T2*T2_Vge_e_Vdi_si)+0.0));
  T3_Vge_e_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_si*T2+T2_Vge_e*T2_Ve_si+T2_Ve_si*T2_Vge_e+T2*T2_Vge_e_Ve_si)+0.0));
  T3_Vge_e_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Ve_di*T2+T2_Vge_e*T2_Ve_di+T2_Ve_di*T2_Vge_e+T2*T2_Vge_e_Ve_di)+0.0));
  T3_Vge_e_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Vge_si*T2+T2_Vge_e*T2_Vge_si+T2_Vge_si*T2_Vge_e+T2*T2_Vge_e_Vge_si)+0.0));
  T3_Vge_e_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_e*T2)+(T2*T2_Vge_e))+d10_sqrt0*(+(+T2_Vge_e_Tempt_GND*T2+T2_Vge_e*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_e+T2*T2_Vge_e_Tempt_GND)+0.0));
#endif
T3_Vdi_si=((T2_Vdi_si*T2)+(T2*T2_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_d*T2+T2_Vdi_si*T2_Vdi_d+T2_Vdi_d*T2_Vdi_si+T2*T2_Vdi_si_Vdi_d)+0.0));
  T3_Vdi_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vsi_s*T2+T2_Vdi_si*T2_Vsi_s+T2_Vsi_s*T2_Vdi_si+T2*T2_Vdi_si_Vsi_s)+0.0));
  T3_Vdi_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_di*T2+T2_Vdi_si*T2_Vge_di+T2_Vge_di*T2_Vdi_si+T2*T2_Vdi_si_Vge_di)+0.0));
  T3_Vdi_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_e*T2+T2_Vdi_si*T2_Vge_e+T2_Vge_e*T2_Vdi_si+T2*T2_Vdi_si_Vge_e)+0.0));
  T3_Vdi_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vdi_si*T2+T2_Vdi_si*T2_Vdi_si+T2_Vdi_si*T2_Vdi_si+T2*T2_Vdi_si_Vdi_si)+0.0));
  T3_Vdi_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_si*T2+T2_Vdi_si*T2_Ve_si+T2_Ve_si*T2_Vdi_si+T2*T2_Vdi_si_Ve_si)+0.0));
  T3_Vdi_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Ve_di*T2+T2_Vdi_si*T2_Ve_di+T2_Ve_di*T2_Vdi_si+T2*T2_Vdi_si_Ve_di)+0.0));
  T3_Vdi_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Vge_si*T2+T2_Vdi_si*T2_Vge_si+T2_Vge_si*T2_Vdi_si+T2*T2_Vdi_si_Vge_si)+0.0));
  T3_Vdi_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vdi_si*T2)+(T2*T2_Vdi_si))+d10_sqrt0*(+(+T2_Vdi_si_Tempt_GND*T2+T2_Vdi_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_si+T2*T2_Vdi_si_Tempt_GND)+0.0));
#endif
T3_Ve_si=((T2_Ve_si*T2)+(T2*T2_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_d*T2+T2_Ve_si*T2_Vdi_d+T2_Vdi_d*T2_Ve_si+T2*T2_Ve_si_Vdi_d)+0.0));
  T3_Ve_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vsi_s*T2+T2_Ve_si*T2_Vsi_s+T2_Vsi_s*T2_Ve_si+T2*T2_Ve_si_Vsi_s)+0.0));
  T3_Ve_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_di*T2+T2_Ve_si*T2_Vge_di+T2_Vge_di*T2_Ve_si+T2*T2_Ve_si_Vge_di)+0.0));
  T3_Ve_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_e*T2+T2_Ve_si*T2_Vge_e+T2_Vge_e*T2_Ve_si+T2*T2_Ve_si_Vge_e)+0.0));
  T3_Ve_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vdi_si*T2+T2_Ve_si*T2_Vdi_si+T2_Vdi_si*T2_Ve_si+T2*T2_Ve_si_Vdi_si)+0.0));
  T3_Ve_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_si*T2+T2_Ve_si*T2_Ve_si+T2_Ve_si*T2_Ve_si+T2*T2_Ve_si_Ve_si)+0.0));
  T3_Ve_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Ve_di*T2+T2_Ve_si*T2_Ve_di+T2_Ve_di*T2_Ve_si+T2*T2_Ve_si_Ve_di)+0.0));
  T3_Ve_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Vge_si*T2+T2_Ve_si*T2_Vge_si+T2_Vge_si*T2_Ve_si+T2*T2_Ve_si_Vge_si)+0.0));
  T3_Ve_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_si*T2)+(T2*T2_Ve_si))+d10_sqrt0*(+(+T2_Ve_si_Tempt_GND*T2+T2_Ve_si*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_si+T2*T2_Ve_si_Tempt_GND)+0.0));
#endif
T3_Ve_di=((T2_Ve_di*T2)+(T2*T2_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_d*T2+T2_Ve_di*T2_Vdi_d+T2_Vdi_d*T2_Ve_di+T2*T2_Ve_di_Vdi_d)+0.0));
  T3_Ve_di_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vsi_s*T2+T2_Ve_di*T2_Vsi_s+T2_Vsi_s*T2_Ve_di+T2*T2_Ve_di_Vsi_s)+0.0));
  T3_Ve_di_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_di*T2+T2_Ve_di*T2_Vge_di+T2_Vge_di*T2_Ve_di+T2*T2_Ve_di_Vge_di)+0.0));
  T3_Ve_di_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_e*T2+T2_Ve_di*T2_Vge_e+T2_Vge_e*T2_Ve_di+T2*T2_Ve_di_Vge_e)+0.0));
  T3_Ve_di_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vdi_si*T2+T2_Ve_di*T2_Vdi_si+T2_Vdi_si*T2_Ve_di+T2*T2_Ve_di_Vdi_si)+0.0));
  T3_Ve_di_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_si*T2+T2_Ve_di*T2_Ve_si+T2_Ve_si*T2_Ve_di+T2*T2_Ve_di_Ve_si)+0.0));
  T3_Ve_di_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Ve_di*T2+T2_Ve_di*T2_Ve_di+T2_Ve_di*T2_Ve_di+T2*T2_Ve_di_Ve_di)+0.0));
  T3_Ve_di_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Vge_si*T2+T2_Ve_di*T2_Vge_si+T2_Vge_si*T2_Ve_di+T2*T2_Ve_di_Vge_si)+0.0));
  T3_Ve_di_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Ve_di*T2)+(T2*T2_Ve_di))+d10_sqrt0*(+(+T2_Ve_di_Tempt_GND*T2+T2_Ve_di*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_di+T2*T2_Ve_di_Tempt_GND)+0.0));
#endif
T3_Vge_si=((T2_Vge_si*T2)+(T2*T2_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_d*T2+T2_Vge_si*T2_Vdi_d+T2_Vdi_d*T2_Vge_si+T2*T2_Vge_si_Vdi_d)+0.0));
  T3_Vge_si_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vsi_s*T2+T2_Vge_si*T2_Vsi_s+T2_Vsi_s*T2_Vge_si+T2*T2_Vge_si_Vsi_s)+0.0));
  T3_Vge_si_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_di*T2+T2_Vge_si*T2_Vge_di+T2_Vge_di*T2_Vge_si+T2*T2_Vge_si_Vge_di)+0.0));
  T3_Vge_si_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_e*T2+T2_Vge_si*T2_Vge_e+T2_Vge_e*T2_Vge_si+T2*T2_Vge_si_Vge_e)+0.0));
  T3_Vge_si_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vdi_si*T2+T2_Vge_si*T2_Vdi_si+T2_Vdi_si*T2_Vge_si+T2*T2_Vge_si_Vdi_si)+0.0));
  T3_Vge_si_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_si*T2+T2_Vge_si*T2_Ve_si+T2_Ve_si*T2_Vge_si+T2*T2_Vge_si_Ve_si)+0.0));
  T3_Vge_si_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Ve_di*T2+T2_Vge_si*T2_Ve_di+T2_Ve_di*T2_Vge_si+T2*T2_Vge_si_Ve_di)+0.0));
  T3_Vge_si_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Vge_si*T2+T2_Vge_si*T2_Vge_si+T2_Vge_si*T2_Vge_si+T2*T2_Vge_si_Vge_si)+0.0));
  T3_Vge_si_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Vge_si*T2)+(T2*T2_Vge_si))+d10_sqrt0*(+(+T2_Vge_si_Tempt_GND*T2+T2_Vge_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_si+T2*T2_Vge_si_Tempt_GND)+0.0));
#endif
T3_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_d*T2)+(T2*T2_Vdi_d)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_d*T2+T2_Tempt_GND*T2_Vdi_d+T2_Vdi_d*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_d)+0.0));
  T3_Tempt_GND_Vsi_s=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vsi_s*T2)+(T2*T2_Vsi_s)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vsi_s*T2+T2_Tempt_GND*T2_Vsi_s+T2_Vsi_s*T2_Tempt_GND+T2*T2_Tempt_GND_Vsi_s)+0.0));
  T3_Tempt_GND_Vge_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_di*T2)+(T2*T2_Vge_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_di*T2+T2_Tempt_GND*T2_Vge_di+T2_Vge_di*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_di)+0.0));
  T3_Tempt_GND_Vge_e=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_e*T2)+(T2*T2_Vge_e)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_e*T2+T2_Tempt_GND*T2_Vge_e+T2_Vge_e*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_e)+0.0));
  T3_Tempt_GND_Vdi_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vdi_si*T2)+(T2*T2_Vdi_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vdi_si*T2+T2_Tempt_GND*T2_Vdi_si+T2_Vdi_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_si)+0.0));
  T3_Tempt_GND_Ve_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_si*T2)+(T2*T2_Ve_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_si*T2+T2_Tempt_GND*T2_Ve_si+T2_Ve_si*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_si)+0.0));
  T3_Tempt_GND_Ve_di=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Ve_di*T2)+(T2*T2_Ve_di)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Ve_di*T2+T2_Tempt_GND*T2_Ve_di+T2_Ve_di*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_di)+0.0));
  T3_Tempt_GND_Vge_si=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Vge_si*T2)+(T2*T2_Vge_si)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Vge_si*T2+T2_Tempt_GND*T2_Vge_si+T2_Vge_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_si)+0.0));
  T3_Tempt_GND_Tempt_GND=(m20_sqrt(((T2*T2)+1.0e-1))*(((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND)))*((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND))+d10_sqrt0*(+(+T2_Tempt_GND_Tempt_GND*T2+T2_Tempt_GND*T2_Tempt_GND+T2_Tempt_GND*T2_Tempt_GND+T2*T2_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
T3=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
vgd_eff_Vge_di=(0.5*(T2_Vge_di+T3_Vge_di));
#if defined(_DERIVATE2)
  vgd_eff_Vge_di_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Vge_di+T3_Vge_di_Vge_di));
  vgd_eff_Vge_di_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Vge_e+T3_Vge_di_Vge_e));
  vgd_eff_Vge_di_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Vge_si+T3_Vge_di_Vge_si));
  vgd_eff_Vge_di_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Ve_si+T3_Vge_di_Ve_si));
  vgd_eff_Vge_di_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Ve_di+T3_Vge_di_Ve_di));
  vgd_eff_Vge_di_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Vdi_si+T3_Vge_di_Vdi_si));
  vgd_eff_Vge_di_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vge_di+T3_Vge_di)+0.5*(+T2_Vge_di_Tempt_GND+T3_Vge_di_Tempt_GND));
#endif
vgd_eff_Vge_e=(0.5*(T2_Vge_e+T3_Vge_e));
#if defined(_DERIVATE2)
  vgd_eff_Vge_e_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_di+T3_Vge_e_Vge_di));
  vgd_eff_Vge_e_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_e+T3_Vge_e_Vge_e));
  vgd_eff_Vge_e_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vge_si+T3_Vge_e_Vge_si));
  vgd_eff_Vge_e_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Ve_si+T3_Vge_e_Ve_si));
  vgd_eff_Vge_e_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Ve_di+T3_Vge_e_Ve_di));
  vgd_eff_Vge_e_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Vdi_si+T3_Vge_e_Vdi_si));
  vgd_eff_Vge_e_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vge_e+T3_Vge_e)+0.5*(+T2_Vge_e_Tempt_GND+T3_Vge_e_Tempt_GND));
#endif
vgd_eff_Vge_si=(0.5*(T2_Vge_si+T3_Vge_si));
#if defined(_DERIVATE2)
  vgd_eff_Vge_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_di+T3_Vge_si_Vge_di));
  vgd_eff_Vge_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_e+T3_Vge_si_Vge_e));
  vgd_eff_Vge_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vge_si+T3_Vge_si_Vge_si));
  vgd_eff_Vge_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Ve_si+T3_Vge_si_Ve_si));
  vgd_eff_Vge_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Ve_di+T3_Vge_si_Ve_di));
  vgd_eff_Vge_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Vdi_si+T3_Vge_si_Vdi_si));
  vgd_eff_Vge_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vge_si+T3_Vge_si)+0.5*(+T2_Vge_si_Tempt_GND+T3_Vge_si_Tempt_GND));
#endif
vgd_eff_Ve_si=(0.5*(T2_Ve_si+T3_Ve_si));
#if defined(_DERIVATE2)
  vgd_eff_Ve_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_di+T3_Ve_si_Vge_di));
  vgd_eff_Ve_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_e+T3_Ve_si_Vge_e));
  vgd_eff_Ve_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vge_si+T3_Ve_si_Vge_si));
  vgd_eff_Ve_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Ve_si+T3_Ve_si_Ve_si));
  vgd_eff_Ve_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Ve_di+T3_Ve_si_Ve_di));
  vgd_eff_Ve_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Vdi_si+T3_Ve_si_Vdi_si));
  vgd_eff_Ve_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Ve_si+T3_Ve_si)+0.5*(+T2_Ve_si_Tempt_GND+T3_Ve_si_Tempt_GND));
#endif
vgd_eff_Ve_di=(0.5*(T2_Ve_di+T3_Ve_di));
#if defined(_DERIVATE2)
  vgd_eff_Ve_di_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_di+T3_Ve_di_Vge_di));
  vgd_eff_Ve_di_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_e+T3_Ve_di_Vge_e));
  vgd_eff_Ve_di_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vge_si+T3_Ve_di_Vge_si));
  vgd_eff_Ve_di_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Ve_si+T3_Ve_di_Ve_si));
  vgd_eff_Ve_di_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Ve_di+T3_Ve_di_Ve_di));
  vgd_eff_Ve_di_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Vdi_si+T3_Ve_di_Vdi_si));
  vgd_eff_Ve_di_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Ve_di+T3_Ve_di)+0.5*(+T2_Ve_di_Tempt_GND+T3_Ve_di_Tempt_GND));
#endif
vgd_eff_Vdi_si=(0.5*(T2_Vdi_si+T3_Vdi_si));
#if defined(_DERIVATE2)
  vgd_eff_Vdi_si_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_di+T3_Vdi_si_Vge_di));
  vgd_eff_Vdi_si_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_e+T3_Vdi_si_Vge_e));
  vgd_eff_Vdi_si_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vge_si+T3_Vdi_si_Vge_si));
  vgd_eff_Vdi_si_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Ve_si+T3_Vdi_si_Ve_si));
  vgd_eff_Vdi_si_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Ve_di+T3_Vdi_si_Ve_di));
  vgd_eff_Vdi_si_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Vdi_si+T3_Vdi_si_Vdi_si));
  vgd_eff_Vdi_si_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.5*(+T2_Vdi_si_Tempt_GND+T3_Vdi_si_Tempt_GND));
#endif
vgd_eff_Tempt_GND=(0.5*(T2_Tempt_GND+T3_Tempt_GND));
#if defined(_DERIVATE2)
  vgd_eff_Tempt_GND_Vge_di=(+0.0*(T2+T3)+0.0*(T2_Vge_di+T3_Vge_di)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_di+T3_Tempt_GND_Vge_di));
  vgd_eff_Tempt_GND_Vge_e=(+0.0*(T2+T3)+0.0*(T2_Vge_e+T3_Vge_e)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_e+T3_Tempt_GND_Vge_e));
  vgd_eff_Tempt_GND_Vge_si=(+0.0*(T2+T3)+0.0*(T2_Vge_si+T3_Vge_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vge_si+T3_Tempt_GND_Vge_si));
  vgd_eff_Tempt_GND_Ve_si=(+0.0*(T2+T3)+0.0*(T2_Ve_si+T3_Ve_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_si+T3_Tempt_GND_Ve_si));
  vgd_eff_Tempt_GND_Ve_di=(+0.0*(T2+T3)+0.0*(T2_Ve_di+T3_Ve_di)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Ve_di+T3_Tempt_GND_Ve_di));
  vgd_eff_Tempt_GND_Vdi_si=(+0.0*(T2+T3)+0.0*(T2_Vdi_si+T3_Vdi_si)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Vdi_si+T3_Tempt_GND_Vdi_si));
  vgd_eff_Tempt_GND_Tempt_GND=(+0.0*(T2+T3)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.0*(T2_Tempt_GND+T3_Tempt_GND)+0.5*(+T2_Tempt_GND_Tempt_GND+T3_Tempt_GND_Tempt_GND));
#endif
#endif
vgd_eff=(0.5*(T2+T3));
EXIT_IF_ISNAN((0.5*(T2+T3)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=(PRWGD_i*vgd_eff_Vge_di);
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Vge_di));
  T4_Vge_di_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Vge_e));
  T4_Vge_di_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Vdi_si));
  T4_Vge_di_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Ve_si));
  T4_Vge_di_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Ve_di));
  T4_Vge_di_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Vge_si));
  T4_Vge_di_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_di+PRWGD_i*vgd_eff_Vge_di_Tempt_GND));
#endif
T4_Vge_e=(PRWGD_i*vgd_eff_Vge_e);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Vge_di));
  T4_Vge_e_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Vge_e));
  T4_Vge_e_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Vdi_si));
  T4_Vge_e_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Ve_si));
  T4_Vge_e_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Ve_di));
  T4_Vge_e_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Vge_si));
  T4_Vge_e_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_e+PRWGD_i*vgd_eff_Vge_e_Tempt_GND));
#endif
T4_Vdi_si=(PRWGD_i*vgd_eff_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Vge_di));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Vge_e));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vdi_si+PRWGD_i*vgd_eff_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGD_i*vgd_eff_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Vge_di));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Vge_e));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_si+PRWGD_i*vgd_eff_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGD_i*vgd_eff_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Vge_di));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Vge_e));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_di+PRWGD_i*vgd_eff_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGD_i*vgd_eff_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Vge_di));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Vge_e));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_si+PRWGD_i*vgd_eff_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGD_i*vgd_eff_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Vge_di));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Vge_e));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Tempt_GND+PRWGD_i*vgd_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGD_i*vgd_eff));
EXIT_IF_ISNAN((1.0+(PRWGD_i*vgd_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-T4_Vge_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_di)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_di/T4/T4/T4);
  T1_Vge_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_e)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_e/T4/T4/T4);
  T1_Vge_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_si)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_si/T4/T4/T4);
  T1_Vge_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_di)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_di/T4/T4/T4);
  T1_Vge_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_si/T4/T4/T4);
  T1_Vge_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vdi_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vdi_si/T4/T4/T4);
  T1_Vge_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_di+1.0*T4_Vge_di_Tempt_GND)/T4/T4+2*1.0*T4_Vge_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_e=(-T4_Vge_e/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_di)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_di/T4/T4/T4);
  T1_Vge_e_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_e)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_e/T4/T4/T4);
  T1_Vge_e_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_si)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_si/T4/T4/T4);
  T1_Vge_e_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_di)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_di/T4/T4/T4);
  T1_Vge_e_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_si/T4/T4/T4);
  T1_Vge_e_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vdi_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vdi_si/T4/T4/T4);
  T1_Vge_e_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_e+1.0*T4_Vge_e_Tempt_GND)/T4/T4+2*1.0*T4_Vge_e*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=(0.5*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_di*T1+T1_Vge_di*T1_Vge_di+T1_Vge_di*T1_Vge_di+T1*T1_Vge_di_Vge_di)+0.0))));
  T0_Vge_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_e*T1+T1_Vge_di*T1_Vge_e+T1_Vge_e*T1_Vge_di+T1*T1_Vge_di_Vge_e)+0.0))));
  T0_Vge_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_si*T1+T1_Vge_di*T1_Ve_si+T1_Ve_si*T1_Vge_di+T1*T1_Vge_di_Ve_si)+0.0))));
  T0_Vge_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_di*T1+T1_Vge_di*T1_Ve_di+T1_Ve_di*T1_Vge_di+T1*T1_Vge_di_Ve_di)+0.0))));
  T0_Vge_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_si*T1+T1_Vge_di*T1_Vge_si+T1_Vge_si*T1_Vge_di+T1*T1_Vge_di_Vge_si)+0.0))));
  T0_Vge_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vdi_si*T1+T1_Vge_di*T1_Vdi_si+T1_Vdi_si*T1_Vge_di+T1*T1_Vge_di_Vdi_si)+0.0))));
  T0_Vge_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Tempt_GND*T1+T1_Vge_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_di+T1*T1_Vge_di_Tempt_GND)+0.0))));
#endif
T0_Vge_e=(0.5*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di)+0.0))));
  T0_Vge_e_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e)+0.0))));
  T0_Vge_e_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si)+0.0))));
  T0_Vge_e_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di)+0.0))));
  T0_Vge_e_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si)+0.0))));
  T0_Vge_e_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si)+0.0))));
  T0_Vge_e_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND)+0.0))));
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=(RDW_i*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))));
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Vdi_d=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*1.0+1.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Vsi_s=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Vge_e=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Vdi_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Ve_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Ve_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Vge_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_d_Tempt_GND=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))))+0.0*(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d)))))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),((NP(di)-NP(d))+(NP(di)-NP(d))))+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+1.0*0.0+0.0*1.0+(NP(di)-NP(d))*0.0)+0.0)))));
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=0.0;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=0.0;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=0.0;
  T5_Vge_e_Vdi_si=0.0;
  T5_Vge_e_Ve_si=0.0;
  T5_Vge_e_Ve_di=0.0;
  T5_Vge_e_Vge_si=0.0;
  T5_Vge_e_Tempt_GND=0.0;
#endif
T5_Vdi_si=(RDW_i*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Vdi_d=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*1.0+1.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Vsi_s=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Vge_e=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Vdi_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+RDDR_a_Vdi_si_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Ve_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Ve_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Vge_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Vdi_si_Tempt_GND=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))))+0.0*((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+RDDR_a_Vdi_si_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
#endif
T5_Ve_si=0.0;
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=0.0;
  T5_Ve_si_Vdi_d=0.0;
  T5_Ve_si_Vsi_s=0.0;
  T5_Ve_si_Vge_e=0.0;
  T5_Ve_si_Vdi_si=0.0;
  T5_Ve_si_Ve_si=0.0;
  T5_Ve_si_Ve_di=0.0;
  T5_Ve_si_Vge_si=0.0;
  T5_Ve_si_Tempt_GND=0.0;
#endif
T5_Ve_di=0.0;
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=0.0;
  T5_Ve_di_Vdi_d=0.0;
  T5_Ve_di_Vsi_s=0.0;
  T5_Ve_di_Vge_e=0.0;
  T5_Ve_di_Vdi_si=0.0;
  T5_Ve_di_Ve_si=0.0;
  T5_Ve_di_Ve_di=0.0;
  T5_Ve_di_Vge_si=0.0;
  T5_Ve_di_Tempt_GND=0.0;
#endif
T5_Vge_si=0.0;
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=0.0;
  T5_Vge_si_Vdi_d=0.0;
  T5_Vge_si_Vsi_s=0.0;
  T5_Vge_si_Vge_e=0.0;
  T5_Vge_si_Vdi_si=0.0;
  T5_Vge_si_Ve_si=0.0;
  T5_Vge_si_Ve_di=0.0;
  T5_Vge_si_Vge_si=0.0;
  T5_Vge_si_Tempt_GND=0.0;
#endif
T5_Tempt_GND=(RDW_i*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Vdi_d=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*1.0+1.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Vsi_s=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Vge_e=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Vdi_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+RDDR_a_Tempt_GND_Vdi_si*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a_Vdi_si*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Ve_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Ve_di=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Vge_si=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*((RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+0.0*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+0.0*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
  T5_Tempt_GND_Tempt_GND=(+0.0*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))+0.0*(((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0))))))+0.0*((RDDR_a_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))+(RDDR_a*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))))+RDW_i*(+0.0+(+RDDR_a_Tempt_GND_Tempt_GND*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a_Tempt_GND*bsimcmg_d_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))),((0.5*pModel->PRDDR)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)))+RDDR_a*(+(+0.0*pModel->PRDDR+0.0*0.0+0.0*0.0+0.5*0.0)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))+0.0*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.0)*bsimcmg_d_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6),0.0)+(0.5*pModel->PRDDR)*(+(+0.0*(NP(di)-NP(d))+0.0*0.0+0.0*0.0+(NP(di)-NP(d))*0.0)+0.0)))));
#endif
#endif
T5=(RDW_i*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6)))))));
EXIT_IF_ISNAN((RDW_i*(1.0+(RDDR_a*bsimcmg_lexp(((0.5*pModel->PRDDR)*bsimcmg_lln((((NP(di)-NP(d))*(NP(di)-NP(d)))+1.0E-6))))))))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
Rdrain_Tempt_GND=((rdstemp_Tempt_GND*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)))+(rdstemp*((T5_Tempt_GND*T0)+(T5*T0_Tempt_GND))*WeffWRFactor));
Rdrain_Vdi_d=(rdstemp*T5_Vdi_d*T0*WeffWRFactor);
Rdrain_Vsi_s=(rdstemp*T5_Vsi_s*T0*WeffWRFactor);
Rdrain_Vge_e=(rdstemp*((T5_Vge_e*T0)+(T5*T0_Vge_e))*WeffWRFactor);
Rdrain_Vdi_si=(rdstemp*((T5_Vdi_si*T0)+(T5*T0_Vdi_si))*WeffWRFactor);
Rdrain_Ve_si=(rdstemp*((T5_Ve_si*T0)+(T5*T0_Ve_si))*WeffWRFactor);
Rdrain_Ve_di=(rdstemp*((T5_Ve_di*T0)+(T5*T0_Ve_di))*WeffWRFactor);
Rdrain_Vge_si=(rdstemp*((T5_Vge_si*T0)+(T5*T0_Vge_si))*WeffWRFactor);
Rdrain_Vge_di=(rdstemp*((T5_Vge_di*T0)+(T5*T0_Vge_di))*WeffWRFactor);
#endif
Rdrain=(rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor)));
EXIT_IF_ISNAN((rdstemp*(RDrainGeo+((RDWMIN_i+(T5*T0))*WeffWRFactor))))
}
else
/* CASE ITEM */
if
(((pModel->RDSMOD)==(0)))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vsi_s=0.0;
Rsource_Vge_e=0.0;
Rsource_Vdi_si=0.0;
Rsource_Ve_si=0.0;
Rsource_Ve_di=0.0;
Rsource_Vge_si=0.0;
#endif
Rsource=RSourceGeo;
EXIT_IF_ISNAN(RSourceGeo)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vdi_d=0.0;
Rdrain_Vsi_s=0.0;
Rdrain_Vge_e=0.0;
Rdrain_Vdi_si=0.0;
Rdrain_Ve_si=0.0;
Rdrain_Ve_di=0.0;
Rdrain_Vge_si=0.0;
Rdrain_Vge_di=0.0;
#endif
Rdrain=RDrainGeo;
EXIT_IF_ISNAN(RDrainGeo)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=(PRWGS_i*qia_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGS_i*qia_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGS_i*qia_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGS_i*qia_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGS_i*qia_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGS_i*qia));
EXIT_IF_ISNAN((1.0+(PRWGS_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-T4_Vge_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_di)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_di/T4/T4/T4);
  T1_Vge_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_e)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_e/T4/T4/T4);
  T1_Vge_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_si)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_si/T4/T4/T4);
  T1_Vge_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_di)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_di/T4/T4/T4);
  T1_Vge_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_si/T4/T4/T4);
  T1_Vge_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vdi_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vdi_si/T4/T4/T4);
  T1_Vge_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_di+1.0*T4_Vge_di_Tempt_GND)/T4/T4+2*1.0*T4_Vge_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_e=(-T4_Vge_e/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_di)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_di/T4/T4/T4);
  T1_Vge_e_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_e)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_e/T4/T4/T4);
  T1_Vge_e_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_si)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_si/T4/T4/T4);
  T1_Vge_e_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_di)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_di/T4/T4/T4);
  T1_Vge_e_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_si/T4/T4/T4);
  T1_Vge_e_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vdi_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vdi_si/T4/T4/T4);
  T1_Vge_e_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_e+1.0*T4_Vge_e_Tempt_GND)/T4/T4+2*1.0*T4_Vge_e*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=(0.5*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_di*T1+T1_Vge_di*T1_Vge_di+T1_Vge_di*T1_Vge_di+T1*T1_Vge_di_Vge_di)+0.0))));
  T0_Vge_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_e*T1+T1_Vge_di*T1_Vge_e+T1_Vge_e*T1_Vge_di+T1*T1_Vge_di_Vge_e)+0.0))));
  T0_Vge_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_si*T1+T1_Vge_di*T1_Ve_si+T1_Ve_si*T1_Vge_di+T1*T1_Vge_di_Ve_si)+0.0))));
  T0_Vge_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_di*T1+T1_Vge_di*T1_Ve_di+T1_Ve_di*T1_Vge_di+T1*T1_Vge_di_Ve_di)+0.0))));
  T0_Vge_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_si*T1+T1_Vge_di*T1_Vge_si+T1_Vge_si*T1_Vge_di+T1*T1_Vge_di_Vge_si)+0.0))));
  T0_Vge_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vdi_si*T1+T1_Vge_di*T1_Vdi_si+T1_Vdi_si*T1_Vge_di+T1*T1_Vge_di_Vdi_si)+0.0))));
  T0_Vge_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Tempt_GND*T1+T1_Vge_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_di+T1*T1_Vge_di_Tempt_GND)+0.0))));
#endif
T0_Vge_e=(0.5*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di)+0.0))));
  T0_Vge_e_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e)+0.0))));
  T0_Vge_e_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si)+0.0))));
  T0_Vge_e_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di)+0.0))));
  T0_Vge_e_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si)+0.0))));
  T0_Vge_e_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si)+0.0))));
  T0_Vge_e_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND)+0.0))));
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Rdsi_Tempt_GND=((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Tempt_GND_Tempt_GND=(+(+rdstemp_Tempt_GND_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Tempt_GND)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_di)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_e)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_di)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vdi_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_di=(rdstemp*(RDSW_i*T0_Vge_di))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_di_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_e=(rdstemp*(RDSW_i*T0_Vge_e))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_e_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Ve_si=(rdstemp*(RDSW_i*T0_Ve_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Ve_si_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Ve_di=(rdstemp*(RDSW_i*T0_Ve_di))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Ve_di_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_si=(rdstemp*(RDSW_i*T0_Vge_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_si_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vdi_si=(rdstemp*(RDSW_i*T0_Vdi_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vdi_si_Tempt_GND=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+(((rdstemp_Tempt_GND*(RDSWMIN_i+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_e=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Ve_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Ve_di=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vdi_si=(+(+0.0*(RDSWMIN_i+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+0.0+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*0.0);
#endif
#endif
Rdsi=((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor);
EXIT_IF_ISNAN(((rdstemp*(RDSWMIN_i+(RDSW_i*T0)))*WeffWRFactor))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dr_Tempt_GND=(((((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND));
#if defined(_DERIVATE2)
  Dr_Tempt_GND_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Tempt_GND)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Tempt_GND)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Tempt_GND*Dvsat+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Tempt_GND));
  Dr_Tempt_GND_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Vdi_si)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vdi_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vdi_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vdi_si));
  Dr_Tempt_GND_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vge_e)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vge_e*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_e));
  Dr_Tempt_GND_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Ve_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Ve_si*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Ve_si));
  Dr_Tempt_GND_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Ve_di)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Ve_di*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Ve_di));
  Dr_Tempt_GND_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vge_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vge_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_si));
  Dr_Tempt_GND_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*0.0+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Tempt_GND*0.0+0.0*Dvsat_Tempt_GND+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_di));
#endif
Dr_Vdi_si=(((((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si));
#if defined(_DERIVATE2)
  Dr_Vdi_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Tempt_GND)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Tempt_GND)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Tempt_GND*Dvsat+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Tempt_GND));
  Dr_Vdi_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Vdi_si)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vdi_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vdi_si*Dvsat+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vdi_si));
  Dr_Vdi_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vge_e)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vge_e*Dvsat+Dmob_Vdi_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_e));
  Dr_Vdi_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Ve_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Ve_si*Dvsat+Dmob_Vdi_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Ve_si));
  Dr_Vdi_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Ve_di)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Ve_di*Dvsat+Dmob_Vdi_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Ve_di));
  Dr_Vdi_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vge_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vge_si*Dvsat+Dmob_Vdi_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_si));
  Dr_Vdi_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*0.0+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vdi_si*0.0+0.0*Dvsat_Vdi_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_di));
#endif
Dr_Vge_e=((((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e));
#if defined(_DERIVATE2)
  Dr_Vge_e_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Tempt_GND*Dvsat+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Tempt_GND));
  Dr_Vge_e_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vdi_si*Dvsat+Dmob_Vge_e*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vdi_si));
  Dr_Vge_e_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vge_e*Dvsat+Dmob_Vge_e*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_e));
  Dr_Vge_e_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Ve_si*Dvsat+Dmob_Vge_e*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Ve_si));
  Dr_Vge_e_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Ve_di*Dvsat+Dmob_Vge_e*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Ve_di));
  Dr_Vge_e_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vge_si*Dvsat+Dmob_Vge_e*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_si));
  Dr_Vge_e_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vge_e*0.0+0.0*Dvsat_Vge_e+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_di));
#endif
Dr_Ve_si=((((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si));
#if defined(_DERIVATE2)
  Dr_Ve_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Tempt_GND*Dvsat+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Tempt_GND));
  Dr_Ve_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vdi_si*Dvsat+Dmob_Ve_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vdi_si));
  Dr_Ve_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vge_e*Dvsat+Dmob_Ve_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_e));
  Dr_Ve_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Ve_si*Dvsat+Dmob_Ve_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Ve_si));
  Dr_Ve_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Ve_di*Dvsat+Dmob_Ve_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Ve_di));
  Dr_Ve_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vge_si*Dvsat+Dmob_Ve_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_si));
  Dr_Ve_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Ve_si*0.0+0.0*Dvsat_Ve_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_di));
#endif
Dr_Ve_di=((((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di));
#if defined(_DERIVATE2)
  Dr_Ve_di_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Tempt_GND*Dvsat+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Tempt_GND));
  Dr_Ve_di_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vdi_si*Dvsat+Dmob_Ve_di*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vdi_si));
  Dr_Ve_di_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vge_e*Dvsat+Dmob_Ve_di*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_e));
  Dr_Ve_di_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Ve_si*Dvsat+Dmob_Ve_di*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Ve_si));
  Dr_Ve_di_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Ve_di*Dvsat+Dmob_Ve_di*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Ve_di));
  Dr_Ve_di_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vge_si*Dvsat+Dmob_Ve_di*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_si));
  Dr_Ve_di_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Ve_di*0.0+0.0*Dvsat_Ve_di+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_di));
#endif
Dr_Vge_si=((((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si));
#if defined(_DERIVATE2)
  Dr_Vge_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Tempt_GND*Dvsat+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Tempt_GND));
  Dr_Vge_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vdi_si*Dvsat+Dmob_Vge_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vdi_si));
  Dr_Vge_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vge_e*Dvsat+Dmob_Vge_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_e));
  Dr_Vge_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Ve_si*Dvsat+Dmob_Vge_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Ve_si));
  Dr_Vge_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Ve_di*Dvsat+Dmob_Vge_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Ve_di));
  Dr_Vge_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vge_si*Dvsat+Dmob_Vge_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_si));
  Dr_Vge_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vge_si*0.0+0.0*Dvsat_Vge_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_di));
#endif
Dr_Vge_di=((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di);
#if defined(_DERIVATE2)
  Dr_Vge_di_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Tempt_GND+Dmob_Tempt_GND*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Tempt_GND));
  Dr_Vge_di_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vdi_si+Dmob_Vdi_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vdi_si));
  Dr_Vge_di_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vge_e+Dmob_Vge_e*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_e));
  Dr_Vge_di_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Ve_si+Dmob_Ve_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Ve_si));
  Dr_Vge_di_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Ve_di+Dmob_Ve_di*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Ve_di));
  Dr_Vge_di_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vge_si+Dmob_Vge_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_si));
  Dr_Vge_di_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(0.0)+((0.0)*ids0_ov_dqi)*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*0.0+0.0*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_di));
#endif
#endif
Dr=(1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
EXIT_IF_ISNAN((1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi)))
}
else
/* CASE ITEM */
if
(((pModel->RDSMOD)==(2)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=(PRWGS_i*qia_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+PRWGS_i*0.0));
  T4_Vdi_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+PRWGS_i*qia_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(PRWGS_i*qia_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+PRWGS_i*0.0));
  T4_Ve_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+PRWGS_i*qia_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(PRWGS_i*qia_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+PRWGS_i*0.0));
  T4_Ve_di_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+PRWGS_i*qia_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(PRWGS_i*qia_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+PRWGS_i*0.0));
  T4_Vge_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+PRWGS_i*qia_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(PRWGS_i*qia_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+PRWGS_i*0.0));
  T4_Tempt_GND_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+PRWGS_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(1.0+(PRWGS_i*qia));
EXIT_IF_ISNAN((1.0+(PRWGS_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-T4_Vge_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_di+1.0*0.0)/T4/T4+2*1.0*T4_Vge_di*0.0/T4/T4/T4);
  T1_Vge_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_di)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_di/T4/T4/T4);
  T1_Vge_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_e)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_e/T4/T4/T4);
  T1_Vge_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_si)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_si/T4/T4/T4);
  T1_Vge_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_di+1.0*T4_Vge_di_Ve_di)/T4/T4+2*1.0*T4_Vge_di*T4_Ve_di/T4/T4/T4);
  T1_Vge_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vge_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vge_si/T4/T4/T4);
  T1_Vge_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_di+1.0*T4_Vge_di_Vdi_si)/T4/T4+2*1.0*T4_Vge_di*T4_Vdi_si/T4/T4/T4);
  T1_Vge_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_di+1.0*T4_Vge_di_Tempt_GND)/T4/T4+2*1.0*T4_Vge_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_e=(-T4_Vge_e/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_e+1.0*0.0)/T4/T4+2*1.0*T4_Vge_e*0.0/T4/T4/T4);
  T1_Vge_e_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_di)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_di/T4/T4/T4);
  T1_Vge_e_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_e)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_e/T4/T4/T4);
  T1_Vge_e_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_si)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_si/T4/T4/T4);
  T1_Vge_e_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_e+1.0*T4_Vge_e_Ve_di)/T4/T4+2*1.0*T4_Vge_e*T4_Ve_di/T4/T4/T4);
  T1_Vge_e_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vge_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vge_si/T4/T4/T4);
  T1_Vge_e_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_e+1.0*T4_Vge_e_Vdi_si)/T4/T4+2*1.0*T4_Vge_e*T4_Vdi_si/T4/T4/T4);
  T1_Vge_e_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_e+1.0*T4_Vge_e_Tempt_GND)/T4/T4+2*1.0*T4_Vge_e*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_si=(-T4_Ve_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_si+1.0*0.0)/T4/T4+2*1.0*T4_Ve_si*0.0/T4/T4/T4);
  T1_Ve_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_di)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_di/T4/T4/T4);
  T1_Ve_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_e)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_e/T4/T4/T4);
  T1_Ve_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_si)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_si/T4/T4/T4);
  T1_Ve_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_si+1.0*T4_Ve_si_Ve_di)/T4/T4+2*1.0*T4_Ve_si*T4_Ve_di/T4/T4/T4);
  T1_Ve_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vge_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vge_si/T4/T4/T4);
  T1_Ve_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_si+1.0*T4_Ve_si_Vdi_si)/T4/T4+2*1.0*T4_Ve_si*T4_Vdi_si/T4/T4/T4);
  T1_Ve_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_si+1.0*T4_Ve_si_Tempt_GND)/T4/T4+2*1.0*T4_Ve_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Ve_di=(-T4_Ve_di/T4/T4);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Ve_di+1.0*0.0)/T4/T4+2*1.0*T4_Ve_di*0.0/T4/T4/T4);
  T1_Ve_di_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_di)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_di/T4/T4/T4);
  T1_Ve_di_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_e)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_e/T4/T4/T4);
  T1_Ve_di_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_si)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_si/T4/T4/T4);
  T1_Ve_di_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Ve_di+1.0*T4_Ve_di_Ve_di)/T4/T4+2*1.0*T4_Ve_di*T4_Ve_di/T4/T4/T4);
  T1_Ve_di_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vge_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vge_si/T4/T4/T4);
  T1_Ve_di_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Ve_di+1.0*T4_Ve_di_Vdi_si)/T4/T4+2*1.0*T4_Ve_di*T4_Vdi_si/T4/T4/T4);
  T1_Ve_di_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Ve_di+1.0*T4_Ve_di_Tempt_GND)/T4/T4+2*1.0*T4_Ve_di*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vge_si=(-T4_Vge_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vge_si+1.0*0.0)/T4/T4+2*1.0*T4_Vge_si*0.0/T4/T4/T4);
  T1_Vge_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_di)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_di/T4/T4/T4);
  T1_Vge_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_e)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_e/T4/T4/T4);
  T1_Vge_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_si)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_si/T4/T4/T4);
  T1_Vge_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vge_si+1.0*T4_Vge_si_Ve_di)/T4/T4+2*1.0*T4_Vge_si*T4_Ve_di/T4/T4/T4);
  T1_Vge_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vge_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vge_si/T4/T4/T4);
  T1_Vge_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vge_si+1.0*T4_Vge_si_Vdi_si)/T4/T4+2*1.0*T4_Vge_si*T4_Vdi_si/T4/T4/T4);
  T1_Vge_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vge_si+1.0*T4_Vge_si_Tempt_GND)/T4/T4+2*1.0*T4_Vge_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Vdi_si=(-T4_Vdi_si/T4/T4);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Vdi_si+1.0*0.0)/T4/T4+2*1.0*T4_Vdi_si*0.0/T4/T4/T4);
  T1_Vdi_si_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_di/T4/T4/T4);
  T1_Vdi_si_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_e)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_e/T4/T4/T4);
  T1_Vdi_si_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_si/T4/T4/T4);
  T1_Vdi_si_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Ve_di)/T4/T4+2*1.0*T4_Vdi_si*T4_Ve_di/T4/T4/T4);
  T1_Vdi_si_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vge_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vge_si/T4/T4/T4);
  T1_Vdi_si_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Vdi_si)/T4/T4+2*1.0*T4_Vdi_si*T4_Vdi_si/T4/T4/T4);
  T1_Vdi_si_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Vdi_si+1.0*T4_Vdi_si_Tempt_GND)/T4/T4+2*1.0*T4_Vdi_si*T4_Tempt_GND/T4/T4/T4);
#endif
T1_Tempt_GND=(-T4_Tempt_GND/T4/T4);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vsi_s=(0.0/T4-(0.0*0.0+0.0*T4_Tempt_GND+1.0*0.0)/T4/T4+2*1.0*T4_Tempt_GND*0.0/T4/T4/T4);
  T1_Tempt_GND_Vge_di=(0.0/T4-(0.0*T4_Vge_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_di/T4/T4/T4);
  T1_Tempt_GND_Vge_e=(0.0/T4-(0.0*T4_Vge_e+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_e)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_e/T4/T4/T4);
  T1_Tempt_GND_Ve_si=(0.0/T4-(0.0*T4_Ve_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_si/T4/T4/T4);
  T1_Tempt_GND_Ve_di=(0.0/T4-(0.0*T4_Ve_di+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Ve_di)/T4/T4+2*1.0*T4_Tempt_GND*T4_Ve_di/T4/T4/T4);
  T1_Tempt_GND_Vge_si=(0.0/T4-(0.0*T4_Vge_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vge_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vge_si/T4/T4/T4);
  T1_Tempt_GND_Vdi_si=(0.0/T4-(0.0*T4_Vdi_si+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Vdi_si)/T4/T4+2*1.0*T4_Tempt_GND*T4_Vdi_si/T4/T4/T4);
  T1_Tempt_GND_Tempt_GND=(0.0/T4-(0.0*T4_Tempt_GND+0.0*T4_Tempt_GND+1.0*T4_Tempt_GND_Tempt_GND)/T4/T4+2*1.0*T4_Tempt_GND*T4_Tempt_GND/T4/T4/T4);
#endif
#endif
T1=(1.0/T4);
EXIT_IF_ISNAN((1.0/T4))
{
double m00_sqrt(d00_sqrt0,((T1*T1)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T1*T1)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=(0.5*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_di*T1+T1_Vge_di*T1_Vge_di+T1_Vge_di*T1_Vge_di+T1*T1_Vge_di_Vge_di)+0.0))));
  T0_Vge_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_e*T1+T1_Vge_di*T1_Vge_e+T1_Vge_e*T1_Vge_di+T1*T1_Vge_di_Vge_e)+0.0))));
  T0_Vge_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_si*T1+T1_Vge_di*T1_Ve_si+T1_Ve_si*T1_Vge_di+T1*T1_Vge_di_Ve_si)+0.0))));
  T0_Vge_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Ve_di*T1+T1_Vge_di*T1_Ve_di+T1_Ve_di*T1_Vge_di+T1*T1_Vge_di_Ve_di)+0.0))));
  T0_Vge_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vge_si*T1+T1_Vge_di*T1_Vge_si+T1_Vge_si*T1_Vge_di+T1*T1_Vge_di_Vge_si)+0.0))));
  T0_Vge_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Vdi_si*T1+T1_Vge_di*T1_Vdi_si+T1_Vdi_si*T1_Vge_di+T1*T1_Vge_di_Vdi_si)+0.0))));
  T0_Vge_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_di+((T1_Vge_di*T1)+(T1*T1_Vge_di))*d10_sqrt0)+0.5*(+T1_Vge_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_di*T1)+(T1*T1_Vge_di))+d10_sqrt0*(+(+T1_Vge_di_Tempt_GND*T1+T1_Vge_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_di+T1*T1_Vge_di_Tempt_GND)+0.0))));
#endif
T0_Vge_e=(0.5*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di)+0.0))));
  T0_Vge_e_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e)+0.0))));
  T0_Vge_e_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si)+0.0))));
  T0_Vge_e_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di)+0.0))));
  T0_Vge_e_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si)+0.0))));
  T0_Vge_e_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si)+0.0))));
  T0_Vge_e_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_e+((T1_Vge_e*T1)+(T1*T1_Vge_e))*d10_sqrt0)+0.5*(+T1_Vge_e_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_e*T1)+(T1*T1_Vge_e))+d10_sqrt0*(+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND)+0.0))));
#endif
T0_Ve_si=(0.5*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0))));
  T0_Ve_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0))));
  T0_Ve_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0))));
  T0_Ve_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0))));
  T0_Ve_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0))));
  T0_Ve_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0))));
  T0_Ve_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_si+((T1_Ve_si*T1)+(T1*T1_Ve_si))*d10_sqrt0)+0.5*(+T1_Ve_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_si*T1)+(T1*T1_Ve_si))+d10_sqrt0*(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0))));
#endif
T0_Ve_di=(0.5*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0))));
  T0_Ve_di_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0))));
  T0_Ve_di_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0))));
  T0_Ve_di_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0))));
  T0_Ve_di_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0))));
  T0_Ve_di_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0))));
  T0_Ve_di_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Ve_di+((T1_Ve_di*T1)+(T1*T1_Ve_di))*d10_sqrt0)+0.5*(+T1_Ve_di_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Ve_di*T1)+(T1*T1_Ve_di))+d10_sqrt0*(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0))));
#endif
T0_Vge_si=(0.5*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0))));
  T0_Vge_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0))));
  T0_Vge_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0))));
  T0_Vge_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0))));
  T0_Vge_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0))));
  T0_Vge_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0))));
  T0_Vge_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vge_si+((T1_Vge_si*T1)+(T1*T1_Vge_si))*d10_sqrt0)+0.5*(+T1_Vge_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vge_si*T1)+(T1*T1_Vge_si))+d10_sqrt0*(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0))));
#endif
T0_Vdi_si=(0.5*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0))));
  T0_Vdi_si_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0))));
  T0_Vdi_si_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0))));
  T0_Vdi_si_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0))));
  T0_Vdi_si_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0))));
  T0_Vdi_si_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0))));
  T0_Vdi_si_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Vdi_si+((T1_Vdi_si*T1)+(T1*T1_Vdi_si))*d10_sqrt0)+0.5*(+T1_Vdi_si_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Vdi_si*T1)+(T1*T1_Vdi_si))+d10_sqrt0*(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0))));
#endif
T0_Tempt_GND=(0.5*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_di+(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_di*T1)+(T1*T1_Vge_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0))));
  T0_Tempt_GND_Vge_e=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_e+(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_e+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_e*T1)+(T1*T1_Vge_e)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0))));
  T0_Tempt_GND_Ve_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_si+(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_si*T1)+(T1*T1_Ve_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0))));
  T0_Tempt_GND_Ve_di=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Ve_di+(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Ve_di+(m20_sqrt(((T1*T1)+0.01))*(((T1_Ve_di*T1)+(T1*T1_Ve_di)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0))));
  T0_Tempt_GND_Vge_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vge_si+(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vge_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vge_si*T1)+(T1*T1_Vge_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0))));
  T0_Tempt_GND_Vdi_si=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Vdi_si+(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Vdi_si+(m20_sqrt(((T1*T1)+0.01))*(((T1_Vdi_si*T1)+(T1*T1_Vdi_si)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0))));
  T0_Tempt_GND_Tempt_GND=(+0.0*(T1+d00_sqrt0)+0.0*(T1_Tempt_GND+(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*d10_sqrt0)+0.0*(T1_Tempt_GND+((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))*d10_sqrt0)+0.5*(+T1_Tempt_GND_Tempt_GND+(m20_sqrt(((T1*T1)+0.01))*(((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND)))*((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND))+d10_sqrt0*(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0))));
#endif
#endif
T0=(0.5*(T1+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T1+d00_sqrt0)))
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
Rdsi_Tempt_GND=((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Tempt_GND_Tempt_GND=(+(+rdstemp_Tempt_GND_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Tempt_GND)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_di)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_e)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Ve_di)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vge_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Tempt_GND_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+rdstemp_Tempt_GND*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Tempt_GND)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+RDSW_i*T0_Tempt_GND_Vdi_si)))*WeffWRFactor+((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*(RDSW_i*T0_Tempt_GND)))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_di=(rdstemp*(RDSW_i*T0_Vge_di))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_di_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_di_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_di+RDSW_i*T0_Vge_di_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_di))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_e=(rdstemp*(RDSW_i*T0_Vge_e))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_e_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_e_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_e)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_e+RDSW_i*T0_Vge_e_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_e))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Ve_si=(rdstemp*(RDSW_i*T0_Ve_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Ve_si_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_si_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Ve_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+RDSW_i*T0_Ve_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Ve_di=(rdstemp*(RDSW_i*T0_Ve_di))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Ve_di_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Ve_di_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Ve_di)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+RDSW_i*T0_Ve_di_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Ve_di))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vge_si=(rdstemp*(RDSW_i*T0_Vge_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vge_si_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vge_si_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vge_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+RDSW_i*T0_Vge_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vge_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
Rdsi_Vdi_si=(rdstemp*(RDSW_i*T0_Vdi_si))*WeffWRFactor;
#if defined(_DERIVATE2)
  Rdsi_Vdi_si_Tempt_GND=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Tempt_GND))+rdstemp_Tempt_GND*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Tempt_GND)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+(((rdstemp_Tempt_GND*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))+(rdstemp*((RDSW_i*T0_Tempt_GND)))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_di))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_e=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_e))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_e)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_e))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Ve_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Ve_di=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Ve_di))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Ve_di)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Ve_di))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vge_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vge_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vge_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vge_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
  Rdsi_Vdi_si_Vdi_si=(+(+0.0*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0))+0.0*((RDSW_i*T0_Vdi_si))+0.0*(RDSW_i*T0_Vdi_si)+rdstemp*(+(+(+0.0+0.0)+0.0)+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+RDSW_i*T0_Vdi_si_Vdi_si)))*WeffWRFactor+(rdstemp*(RDSW_i*T0_Vdi_si))*0.0+((rdstemp*((RDSW_i*T0_Vdi_si))))*0.0+(rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*0.0);
#endif
#endif
Rdsi=((rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*WeffWRFactor);
EXIT_IF_ISNAN(((rdstemp*(((RSourceGeo+RDrainGeo)+RDSWMIN_i)+(RDSW_i*T0)))*WeffWRFactor))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)V(si,GND)Temp(t,GND) */
Dr_Tempt_GND=(((((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND));
#if defined(_DERIVATE2)
  Dr_Tempt_GND_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Tempt_GND)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Tempt_GND)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Tempt_GND*Dvsat+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Tempt_GND));
  Dr_Tempt_GND_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Vdi_si)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vdi_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vdi_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vdi_si));
  Dr_Tempt_GND_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vge_e)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vge_e*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_e));
  Dr_Tempt_GND_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Ve_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Ve_si*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Ve_si));
  Dr_Tempt_GND_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Ve_di)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Ve_di*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Ve_di));
  Dr_Tempt_GND_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*ids0_ov_dqi_Tempt_GND_Vge_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Tempt_GND_Vge_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_si));
  Dr_Tempt_GND_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Tempt_GND)*0.0+(0.0)*ids0_ov_dqi_Tempt_GND+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Tempt_GND*0.0+0.0*Dvsat_Tempt_GND+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Tempt_GND)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Tempt_GND_Vge_di));
#endif
Dr_Vdi_si=(((((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si));
#if defined(_DERIVATE2)
  Dr_Vdi_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Tempt_GND)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Tempt_GND)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Tempt_GND*Dvsat+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Tempt_GND));
  Dr_Vdi_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Vdi_si)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vdi_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vdi_si*Dvsat+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vdi_si));
  Dr_Vdi_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vge_e)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vge_e*Dvsat+Dmob_Vdi_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_e));
  Dr_Vdi_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Ve_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Ve_si*Dvsat+Dmob_Vdi_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Ve_si));
  Dr_Vdi_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Ve_di)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Ve_di*Dvsat+Dmob_Vdi_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Ve_di));
  Dr_Vdi_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*ids0_ov_dqi_Vdi_si_Vge_si)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vdi_si_Vge_si*Dvsat+Dmob_Vdi_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_si));
  Dr_Vdi_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0_ov_dqi+(NFINtotal*beta_Vdi_si)*0.0+(0.0)*ids0_ov_dqi_Vdi_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vdi_si*0.0+0.0*Dvsat_Vdi_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+(((((NFINtotal*beta_Vdi_si)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vdi_si_Vge_di));
#endif
Dr_Vge_e=((((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e));
#if defined(_DERIVATE2)
  Dr_Vge_e_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Tempt_GND*Dvsat+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Tempt_GND));
  Dr_Vge_e_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vdi_si*Dvsat+Dmob_Vge_e*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vdi_si));
  Dr_Vge_e_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vge_e*Dvsat+Dmob_Vge_e*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_e));
  Dr_Vge_e_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Ve_si*Dvsat+Dmob_Vge_e*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Ve_si));
  Dr_Vge_e_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Ve_di*Dvsat+Dmob_Vge_e*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Ve_di));
  Dr_Vge_e_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*ids0_ov_dqi_Vge_e_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_e_Vge_si*Dvsat+Dmob_Vge_e*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_si));
  Dr_Vge_e_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Vge_e+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vge_e*0.0+0.0*Dvsat_Vge_e+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_e)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_e_Vge_di));
#endif
Dr_Ve_si=((((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si));
#if defined(_DERIVATE2)
  Dr_Ve_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Tempt_GND*Dvsat+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Tempt_GND));
  Dr_Ve_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vdi_si*Dvsat+Dmob_Ve_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vdi_si));
  Dr_Ve_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vge_e*Dvsat+Dmob_Ve_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_e));
  Dr_Ve_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Ve_si*Dvsat+Dmob_Ve_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Ve_si));
  Dr_Ve_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Ve_di*Dvsat+Dmob_Ve_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Ve_di));
  Dr_Ve_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*ids0_ov_dqi_Ve_si_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_si_Vge_si*Dvsat+Dmob_Ve_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_si));
  Dr_Ve_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Ve_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Ve_si*0.0+0.0*Dvsat_Ve_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_si_Vge_di));
#endif
Dr_Ve_di=((((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di));
#if defined(_DERIVATE2)
  Dr_Ve_di_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Tempt_GND*Dvsat+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Tempt_GND));
  Dr_Ve_di_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vdi_si*Dvsat+Dmob_Ve_di*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vdi_si));
  Dr_Ve_di_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vge_e*Dvsat+Dmob_Ve_di*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_e));
  Dr_Ve_di_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Ve_si*Dvsat+Dmob_Ve_di*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Ve_si));
  Dr_Ve_di_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Ve_di*Dvsat+Dmob_Ve_di*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Ve_di));
  Dr_Ve_di_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*ids0_ov_dqi_Ve_di_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Ve_di_Vge_si*Dvsat+Dmob_Ve_di*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_si));
  Dr_Ve_di_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Ve_di+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Ve_di*0.0+0.0*Dvsat_Ve_di+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Ve_di)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Ve_di_Vge_di));
#endif
Dr_Vge_si=((((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi)+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si));
#if defined(_DERIVATE2)
  Dr_Vge_si_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Tempt_GND)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Tempt_GND*Dvsat+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Tempt_GND))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Tempt_GND));
  Dr_Vge_si_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vdi_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vdi_si*Dvsat+Dmob_Vge_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vdi_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vdi_si));
  Dr_Vge_si_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vge_e)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vge_e*Dvsat+Dmob_Vge_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_e))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_e));
  Dr_Vge_si_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Ve_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Ve_si*Dvsat+Dmob_Vge_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Ve_si));
  Dr_Vge_si_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Ve_di)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Ve_di*Dvsat+Dmob_Vge_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_di))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Ve_di));
  Dr_Vge_si_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*ids0_ov_dqi_Vge_si_Vge_si)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+Dmob_Vge_si_Vge_si*Dvsat+Dmob_Vge_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_si))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_si));
  Dr_Vge_si_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*ids0_ov_dqi_Vge_si+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(0.0)+((0.0)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+Dmob_Vge_si*0.0+0.0*Dvsat_Vge_si+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+((((NFINtotal*beta)*ids0_ov_dqi_Vge_si)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_si+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_si_Vge_di));
#endif
Dr_Vge_di=((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di);
#if defined(_DERIVATE2)
  Dr_Vge_di_Tempt_GND=(+0.0+(+((+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Tempt_GND+((NFINtotal*beta_Tempt_GND))*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))+(((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Tempt_GND+Dmob_Tempt_GND*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Tempt_GND+(((((((NFINtotal*beta_Tempt_GND))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Tempt_GND)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Tempt_GND));
  Dr_Vge_di_Vdi_si=(+0.0+(+((+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vdi_si+((NFINtotal*beta_Vdi_si))*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))+(((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vdi_si+Dmob_Vdi_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vdi_si+(((((((NFINtotal*beta_Vdi_si))*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vdi_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vdi_si));
  Dr_Vge_di_Vge_e=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_e+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vge_e+Dmob_Vge_e*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_e+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_e)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_e));
  Dr_Vge_di_Ve_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_si+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Ve_si+Dmob_Ve_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Ve_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Ve_si));
  Dr_Vge_di_Ve_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Ve_di+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Ve_di+Dmob_Ve_di*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Ve_di+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Ve_di)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Ve_di));
  Dr_Vge_di_Vge_si=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*ids0_ov_dqi_Vge_si+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))+((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*Dvsat_Vge_si+Dmob_Vge_si*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_si+((((((0.0)*ids0_ov_dqi)+((NFINtotal*beta)*ids0_ov_dqi_Vge_si)))*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_si));
  Dr_Vge_di_Vge_di=(+0.0+(+((+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0_ov_dqi+0.0*0.0+(0.0)*0.0+(NFINtotal*beta)*0.0)/(Dmob*Dvsat)-(0.0*(0.0)+((0.0)*ids0_ov_dqi)*0.0+((NFINtotal*beta)*ids0_ov_dqi)*(+0.0*Dvsat+0.0*0.0+0.0*0.0+Dmob*0.0))/(Dmob*Dvsat)/(Dmob*Dvsat)+2*((NFINtotal*beta)*ids0_ov_dqi)*0.0*(0.0)/(Dmob*Dvsat)/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi+0.0*Rdsi_Vge_di+((((0.0)*ids0_ov_dqi)*(Dmob*Dvsat)-((NFINtotal*beta)*ids0_ov_dqi)*(0.0))/(Dmob*Dvsat)/(Dmob*Dvsat))*Rdsi_Vge_di+(((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi_Vge_di_Vge_di));
#endif
#endif
Dr=(1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi));
EXIT_IF_ISNAN((1.0+((((NFINtotal*beta)*ids0_ov_dqi)/(Dmob*Dvsat))*Rdsi)))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Rsource_Tempt_GND=0.0;
Rsource_Vsi_s=0.0;
Rsource_Vge_e=0.0;
Rsource_Vdi_si=0.0;
Rsource_Ve_si=0.0;
Rsource_Ve_di=0.0;
Rsource_Vge_si=0.0;
#endif
Rsource=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
Rdrain_Tempt_GND=0.0;
Rdrain_Vdi_d=0.0;
Rdrain_Vsi_s=0.0;
Rdrain_Vge_e=0.0;
Rdrain_Vdi_si=0.0;
Rdrain_Ve_si=0.0;
Rdrain_Ve_di=0.0;
Rdrain_Vge_si=0.0;
Rdrain_Vge_di=0.0;
#endif
Rdrain=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{ /* no default */ }
/* -- CASE END -- */;
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
ids_Tempt_GND=(((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Tempt_GND_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Tempt_GND)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Tempt_GND)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Tempt_GND)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Tempt_GND)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Tempt_GND)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Tempt_GND*Dvsat+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Tempt_GND)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Tempt_GND+NFINtotal*beta_Tempt_GND_Vdi_si)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Vdi_si)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Vdi_si)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Vdi_si)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Vdi_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Vdi_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vdi_si)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Vge_e+(0.0)*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Vge_e)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Vge_e)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Vge_e)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Vge_e)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Vge_e*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_e)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Ve_si+(0.0)*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Ve_si)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Ve_si)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Ve_si)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Ve_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Ve_si*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_si)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Ve_di+(0.0)*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Ve_di)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Ve_di)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Ve_di)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Ve_di)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Ve_di*Dvsat+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Ve_di)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0+(NFINtotal*beta_Tempt_GND)*ids0_Vge_si+(0.0)*ids0_Tempt_GND+(NFINtotal*beta)*ids0_Tempt_GND_Vge_si)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*Moc_Tempt_GND_Vge_si)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND_Vge_si)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND_Vge_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Tempt_GND_Vge_si*Dvsat+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob*Dvsat_Tempt_GND_Vge_si)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Tempt_GND_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Tempt_GND+NFINtotal*0.0)*ids0+(NFINtotal*beta_Tempt_GND)*0.0+(0.0)*ids0_Tempt_GND+(NFINtotal*beta)*0.0)*Moc+(((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*0.0+((0.0)*ids0)*Moc_Tempt_GND+((NFINtotal*beta)*ids0)*0.0)*Mnud+(((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*0.0+(((0.0)*ids0)*Moc)*Mnud_Tempt_GND+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+(((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Tempt_GND+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Tempt_GND)*ids0)+((NFINtotal*beta)*ids0_Tempt_GND))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Tempt_GND*0.0+0.0*Dvsat_Tempt_GND+Dmob*0.0)*Dr+((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr_Vge_di+(0.0)*Dr_Tempt_GND+(Dmob*Dvsat)*Dr_Tempt_GND_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Vdi_si=(((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Vdi_si_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Tempt_GND)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Tempt_GND)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Tempt_GND)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Tempt_GND)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Tempt_GND)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Tempt_GND*Dvsat+Dmob_Vdi_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Tempt_GND)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*beta_Vdi_si+NFINtotal*beta_Vdi_si_Vdi_si)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Vdi_si)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Vdi_si)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Vdi_si)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Vdi_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Vdi_si*Dvsat+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vdi_si)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Vge_e+(0.0)*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Vge_e)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Vge_e)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Vge_e)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Vge_e)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Vge_e*Dvsat+Dmob_Vdi_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_e)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Ve_si+(0.0)*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Ve_si)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Ve_si)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Ve_si)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Ve_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Ve_si*Dvsat+Dmob_Vdi_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_si)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Ve_di+(0.0)*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Ve_di)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Ve_di)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Ve_di)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Ve_di)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Ve_di*Dvsat+Dmob_Vdi_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Ve_di)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0+(NFINtotal*beta_Vdi_si)*ids0_Vge_si+(0.0)*ids0_Vdi_si+(NFINtotal*beta)*ids0_Vdi_si_Vge_si)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Vdi_si+((NFINtotal*beta)*ids0)*Moc_Vdi_si_Vge_si)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si_Vge_si)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si_Vge_si)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vdi_si_Vge_si*Dvsat+Dmob_Vdi_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vdi_si+Dmob*Dvsat_Vdi_si_Vge_si)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vdi_si_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*beta_Vdi_si+NFINtotal*0.0)*ids0+(NFINtotal*beta_Vdi_si)*0.0+(0.0)*ids0_Vdi_si+(NFINtotal*beta)*0.0)*Moc+(((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*0.0+((0.0)*ids0)*Moc_Vdi_si+((NFINtotal*beta)*ids0)*0.0)*Mnud+(((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*0.0+(((0.0)*ids0)*Moc)*Mnud_Vdi_si+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+(((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Vdi_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-((((((((((NFINtotal*beta_Vdi_si)*ids0)+((NFINtotal*beta)*ids0_Vdi_si))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Vdi_si*0.0+0.0*Dvsat_Vdi_si+Dmob*0.0)*Dr+((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr_Vge_di+(0.0)*Dr_Vdi_si+(Dmob*Dvsat)*Dr_Vdi_si_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Vge_e=((((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Vge_e_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Tempt_GND)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Tempt_GND)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Tempt_GND)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Tempt_GND)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Tempt_GND*Dvsat+Dmob_Vge_e*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Tempt_GND)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Vdi_si)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Vdi_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Vdi_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Vdi_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Vdi_si*Dvsat+Dmob_Vge_e*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vdi_si)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_e+(0.0)*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Vge_e)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Vge_e)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Vge_e)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Vge_e)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Vge_e*Dvsat+Dmob_Vge_e*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_e)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_si+(0.0)*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Ve_si)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Ve_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Ve_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Ve_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Ve_si*Dvsat+Dmob_Vge_e*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_si)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_di+(0.0)*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Ve_di)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Ve_di)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Ve_di)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Ve_di)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Ve_di*Dvsat+Dmob_Vge_e*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Ve_di)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_si+(0.0)*ids0_Vge_e+(NFINtotal*beta)*ids0_Vge_e_Vge_si)*Moc+((NFINtotal*beta)*ids0_Vge_e)*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Vge_e+((NFINtotal*beta)*ids0)*Moc_Vge_e_Vge_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e_Vge_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e_Vge_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_e_Vge_si*Dvsat+Dmob_Vge_e*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_e+Dmob*Dvsat_Vge_e_Vge_si)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_e_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*0.0+(0.0)*ids0_Vge_e+(NFINtotal*beta)*0.0)*Moc+((NFINtotal*beta)*ids0_Vge_e)*0.0+((0.0)*ids0)*Moc_Vge_e+((NFINtotal*beta)*ids0)*0.0)*Mnud+((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*0.0+(((0.0)*ids0)*Moc)*Mnud_Vge_e+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Vge_e+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_e)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Vge_e*0.0+0.0*Dvsat_Vge_e+Dmob*0.0)*Dr+((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr_Vge_di+(0.0)*Dr_Vge_e+(Dmob*Dvsat)*Dr_Vge_e_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e))*Dr)+((Dmob*Dvsat)*Dr_Vge_e))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Ve_si=((((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Ve_si_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Tempt_GND)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Tempt_GND)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Tempt_GND)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Tempt_GND)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Tempt_GND*Dvsat+Dmob_Ve_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Tempt_GND)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Vdi_si)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Vdi_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Vdi_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Vdi_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Vdi_si*Dvsat+Dmob_Ve_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vdi_si)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_e+(0.0)*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Vge_e)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Vge_e)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Vge_e)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Vge_e)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Vge_e*Dvsat+Dmob_Ve_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_e)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_si+(0.0)*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Ve_si)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Ve_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Ve_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Ve_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Ve_si*Dvsat+Dmob_Ve_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_si)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_di+(0.0)*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Ve_di)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Ve_di)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Ve_di)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Ve_di)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Ve_di*Dvsat+Dmob_Ve_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Ve_di)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_si+(0.0)*ids0_Ve_si+(NFINtotal*beta)*ids0_Ve_si_Vge_si)*Moc+((NFINtotal*beta)*ids0_Ve_si)*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Ve_si+((NFINtotal*beta)*ids0)*Moc_Ve_si_Vge_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si_Vge_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si_Vge_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_si_Vge_si*Dvsat+Dmob_Ve_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_si+Dmob*Dvsat_Ve_si_Vge_si)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_si_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*0.0+(0.0)*ids0_Ve_si+(NFINtotal*beta)*0.0)*Moc+((NFINtotal*beta)*ids0_Ve_si)*0.0+((0.0)*ids0)*Moc_Ve_si+((NFINtotal*beta)*ids0)*0.0)*Mnud+((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*0.0+(((0.0)*ids0)*Moc)*Mnud_Ve_si+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Ve_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Ve_si*0.0+0.0*Dvsat_Ve_si+Dmob*0.0)*Dr+((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr_Vge_di+(0.0)*Dr_Ve_si+(Dmob*Dvsat)*Dr_Ve_si_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si))*Dr)+((Dmob*Dvsat)*Dr_Ve_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Ve_di=((((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Ve_di_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Tempt_GND)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Tempt_GND)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Tempt_GND)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Tempt_GND)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Tempt_GND*Dvsat+Dmob_Ve_di*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Tempt_GND)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Vdi_si)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Vdi_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Vdi_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Vdi_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Vdi_si*Dvsat+Dmob_Ve_di*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vdi_si)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_e+(0.0)*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Vge_e)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Vge_e)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Vge_e)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Vge_e)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Vge_e*Dvsat+Dmob_Ve_di*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_e)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_si+(0.0)*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Ve_si)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Ve_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Ve_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Ve_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Ve_si*Dvsat+Dmob_Ve_di*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_si)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_di+(0.0)*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Ve_di)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Ve_di)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Ve_di)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Ve_di)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Ve_di*Dvsat+Dmob_Ve_di*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Ve_di)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_si+(0.0)*ids0_Ve_di+(NFINtotal*beta)*ids0_Ve_di_Vge_si)*Moc+((NFINtotal*beta)*ids0_Ve_di)*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Ve_di+((NFINtotal*beta)*ids0)*Moc_Ve_di_Vge_si)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di_Vge_si)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di_Vge_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Ve_di_Vge_si*Dvsat+Dmob_Ve_di*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Ve_di+Dmob*Dvsat_Ve_di_Vge_si)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Ve_di_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*0.0+(0.0)*ids0_Ve_di+(NFINtotal*beta)*0.0)*Moc+((NFINtotal*beta)*ids0_Ve_di)*0.0+((0.0)*ids0)*Moc_Ve_di+((NFINtotal*beta)*ids0)*0.0)*Mnud+((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*0.0+(((0.0)*ids0)*Moc)*Mnud_Ve_di+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Ve_di+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Ve_di)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Ve_di*0.0+0.0*Dvsat_Ve_di+Dmob*0.0)*Dr+((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr_Vge_di+(0.0)*Dr_Ve_di+(Dmob*Dvsat)*Dr_Ve_di_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di))*Dr)+((Dmob*Dvsat)*Dr_Ve_di))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Vge_si=((((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((Dmob*Dvsat)*Dr)-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Vge_si_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Tempt_GND)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Tempt_GND)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Tempt_GND)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Tempt_GND)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Tempt_GND*Dvsat+Dmob_Vge_si*Dvsat_Tempt_GND+Dmob_Tempt_GND*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Tempt_GND)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Vdi_si)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Vdi_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Vdi_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Vdi_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Vdi_si*Dvsat+Dmob_Vge_si*Dvsat_Vdi_si+Dmob_Vdi_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vdi_si)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_e+(0.0)*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Vge_e)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Vge_e)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Vge_e)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Vge_e)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Vge_e*Dvsat+Dmob_Vge_si*Dvsat_Vge_e+Dmob_Vge_e*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_e)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_si+(0.0)*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Ve_si)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Ve_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Ve_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Ve_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Ve_si*Dvsat+Dmob_Vge_si*Dvsat_Ve_si+Dmob_Ve_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_si)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_di+(0.0)*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Ve_di)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Ve_di)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Ve_di)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Ve_di)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Ve_di*Dvsat+Dmob_Vge_si*Dvsat_Ve_di+Dmob_Ve_di*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Ve_di)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_si+(0.0)*ids0_Vge_si+(NFINtotal*beta)*ids0_Vge_si_Vge_si)*Moc+((NFINtotal*beta)*ids0_Vge_si)*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc_Vge_si+((NFINtotal*beta)*ids0)*Moc_Vge_si_Vge_si)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si_Vge_si)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si_Vge_si)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+Dmob_Vge_si_Vge_si*Dvsat+Dmob_Vge_si*Dvsat_Vge_si+Dmob_Vge_si*Dvsat_Vge_si+Dmob*Dvsat_Vge_si_Vge_si)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_si_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*0.0+(0.0)*ids0_Vge_si+(NFINtotal*beta)*0.0)*Moc+((NFINtotal*beta)*ids0_Vge_si)*0.0+((0.0)*ids0)*Moc_Vge_si+((NFINtotal*beta)*ids0)*0.0)*Mnud+((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*0.0+(((0.0)*ids0)*Moc)*Mnud_Vge_si+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*0.0+((((0.0)*ids0)*Moc)*Mnud)*Mob_Vge_si+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(((((((((NFINtotal*beta)*ids0_Vge_si)*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+Dmob_Vge_si*0.0+0.0*Dvsat_Vge_si+Dmob*0.0)*Dr+((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr_Vge_di+(0.0)*Dr_Vge_si+(Dmob*Dvsat)*Dr_Vge_si_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si))*Dr)+((Dmob*Dvsat)*Dr_Vge_si))*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
ids_Vge_di=(-(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#if defined(_DERIVATE2)
  ids_Vge_di_Tempt_GND=((+(+(+(+(+0.0*beta+0.0*beta_Tempt_GND+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Tempt_GND+((NFINtotal*beta_Tempt_GND))*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Tempt_GND+(((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Tempt_GND+((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Tempt_GND+(((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))+((((((((((((((NFINtotal*beta_Tempt_GND))*ids0)+((NFINtotal*beta)*ids0_Tempt_GND)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Tempt_GND)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Tempt_GND)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Tempt_GND)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Tempt_GND+Dmob_Tempt_GND*0.0+Dmob*0.0)*Dr+0.0*Dr_Tempt_GND+(((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Tempt_GND))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Tempt_GND*Dvsat)+(Dmob*Dvsat_Tempt_GND)))*Dr)+((Dmob*Dvsat)*Dr_Tempt_GND)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Vdi_si=((+(+(+(+(+0.0*beta+0.0*beta_Vdi_si+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vdi_si+((NFINtotal*beta_Vdi_si))*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Vdi_si+(((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Vdi_si+((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Vdi_si+(((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))+((((((((((((((NFINtotal*beta_Vdi_si))*ids0)+((NFINtotal*beta)*ids0_Vdi_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vdi_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vdi_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vdi_si)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Vdi_si+Dmob_Vdi_si*0.0+Dmob*0.0)*Dr+0.0*Dr_Vdi_si+(((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Vdi_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Vdi_si*Dvsat)+(Dmob*Dvsat_Vdi_si)))*Dr)+((Dmob*Dvsat)*Dr_Vdi_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Vge_e=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_e+(0.0)*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Vge_e+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Vge_e+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Vge_e+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_e)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_e)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_e)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_e)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Vge_e+Dmob_Vge_e*0.0+Dmob*0.0)*Dr+0.0*Dr_Vge_e+(((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Vge_e))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Vge_e*Dvsat)+(Dmob*Dvsat_Vge_e)))*Dr)+((Dmob*Dvsat)*Dr_Vge_e)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Ve_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_si+(0.0)*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Ve_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Ve_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Ve_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_si)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Ve_si+Dmob_Ve_si*0.0+Dmob*0.0)*Dr+0.0*Dr_Ve_si+(((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Ve_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Ve_si*Dvsat)+(Dmob*Dvsat_Ve_si)))*Dr)+((Dmob*Dvsat)*Dr_Ve_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Ve_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Ve_di+(0.0)*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Ve_di+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Ve_di+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Ve_di+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Ve_di)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Ve_di)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Ve_di)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Ve_di)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Ve_di+Dmob_Ve_di*0.0+Dmob*0.0)*Dr+0.0*Dr_Ve_di+(((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Ve_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Ve_di*Dvsat)+(Dmob*Dvsat_Ve_di)))*Dr)+((Dmob*Dvsat)*Dr_Ve_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Vge_si=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*ids0_Vge_si+(0.0)*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*Moc_Vge_si+((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*Mnud_Vge_si+(((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*Mob_Vge_si+((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))+(((((((((((((0.0)*ids0)+((NFINtotal*beta)*ids0_Vge_si)))*Moc)+(((NFINtotal*beta)*ids0)*Moc_Vge_si)))*Mnud)+((((NFINtotal*beta)*ids0)*Moc)*Mnud_Vge_si)))*Mob)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob_Vge_si)))*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*Dvsat_Vge_si+Dmob_Vge_si*0.0+Dmob*0.0)*Dr+0.0*Dr_Vge_si+(((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Vge_si))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((((Dmob_Vge_si*Dvsat)+(Dmob*Dvsat_Vge_si)))*Dr)+((Dmob*Dvsat)*Dr_Vge_si)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
  ids_Vge_di_Vge_di=((+(+(+(+(+0.0*beta+0.0*0.0+0.0*0.0+NFINtotal*0.0)*ids0+0.0*0.0+(0.0)*0.0+(NFINtotal*beta)*0.0)*Moc+0.0*0.0+((0.0)*ids0)*0.0+((NFINtotal*beta)*ids0)*0.0)*Mnud+0.0*0.0+(((0.0)*ids0)*Moc)*0.0+(((NFINtotal*beta)*ids0)*Moc)*0.0)*Mob+0.0*0.0+((((0.0)*ids0)*Moc)*Mnud)*0.0+((((NFINtotal*beta)*ids0)*Moc)*Mnud)*0.0)/((Dmob*Dvsat)*Dr)-(0.0*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))+(((((0.0)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)+(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*(+(+0.0*Dvsat+0.0*0.0+0.0*0.0+Dmob*0.0)*Dr+0.0*Dr_Vge_di+(0.0)*Dr_Vge_di+(Dmob*Dvsat)*Dr_Vge_di_Vge_di))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)+2*(((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)*((Dmob*Dvsat)*Dr_Vge_di)*((((0.0)*Dr)+((Dmob*Dvsat)*Dr_Vge_di)))/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr)/((Dmob*Dvsat)*Dr));
#endif
#endif
ids=((((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)/((Dmob*Dvsat)*Dr));
EXIT_IF_ISNAN(((((((NFINtotal*beta)*ids0)*Moc)*Mnud)*Mob)/((Dmob*Dvsat)*Dr)))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe=Temp(t,GND)V(si,GND)V(e,GND)V(di,GND)V(ge,GND) */
ids_Tempt_GND=ids_Tempt_GND*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Tempt_GND_Tempt_GND=(+ids_Tempt_GND_Tempt_GND*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Tempt_GND_Vdi_si=(+ids_Tempt_GND_Vdi_si*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Tempt_GND_Vge_e=(+ids_Tempt_GND_Vge_e*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Tempt_GND_Ve_si=(+ids_Tempt_GND_Ve_si*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Tempt_GND_Ve_di=(+ids_Tempt_GND_Ve_di*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Tempt_GND_Vge_si=(+ids_Tempt_GND_Vge_si*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Tempt_GND_Vge_di=(+ids_Tempt_GND_Vge_di*pModel->IDS0MULT+ids_Tempt_GND*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Vdi_si=ids_Vdi_si*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vdi_si_Tempt_GND=(+ids_Vdi_si_Tempt_GND*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vdi_si_Vdi_si=(+ids_Vdi_si_Vdi_si*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Vdi_si_Vge_e=(+ids_Vdi_si_Vge_e*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Vdi_si_Ve_si=(+ids_Vdi_si_Ve_si*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Vdi_si_Ve_di=(+ids_Vdi_si_Ve_di*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Vdi_si_Vge_si=(+ids_Vdi_si_Vge_si*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Vdi_si_Vge_di=(+ids_Vdi_si_Vge_di*pModel->IDS0MULT+ids_Vdi_si*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Vge_e=ids_Vge_e*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vge_e_Tempt_GND=(+ids_Vge_e_Tempt_GND*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vge_e_Vdi_si=(+ids_Vge_e_Vdi_si*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Vge_e_Vge_e=(+ids_Vge_e_Vge_e*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Vge_e_Ve_si=(+ids_Vge_e_Ve_si*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Vge_e_Ve_di=(+ids_Vge_e_Ve_di*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Vge_e_Vge_si=(+ids_Vge_e_Vge_si*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Vge_e_Vge_di=(+ids_Vge_e_Vge_di*pModel->IDS0MULT+ids_Vge_e*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Ve_si=ids_Ve_si*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Ve_si_Tempt_GND=(+ids_Ve_si_Tempt_GND*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Ve_si_Vdi_si=(+ids_Ve_si_Vdi_si*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Ve_si_Vge_e=(+ids_Ve_si_Vge_e*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Ve_si_Ve_si=(+ids_Ve_si_Ve_si*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Ve_si_Ve_di=(+ids_Ve_si_Ve_di*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Ve_si_Vge_si=(+ids_Ve_si_Vge_si*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Ve_si_Vge_di=(+ids_Ve_si_Vge_di*pModel->IDS0MULT+ids_Ve_si*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Ve_di=ids_Ve_di*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Ve_di_Tempt_GND=(+ids_Ve_di_Tempt_GND*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Ve_di_Vdi_si=(+ids_Ve_di_Vdi_si*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Ve_di_Vge_e=(+ids_Ve_di_Vge_e*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Ve_di_Ve_si=(+ids_Ve_di_Ve_si*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Ve_di_Ve_di=(+ids_Ve_di_Ve_di*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Ve_di_Vge_si=(+ids_Ve_di_Vge_si*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Ve_di_Vge_di=(+ids_Ve_di_Vge_di*pModel->IDS0MULT+ids_Ve_di*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Vge_si=ids_Vge_si*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vge_si_Tempt_GND=(+ids_Vge_si_Tempt_GND*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vge_si_Vdi_si=(+ids_Vge_si_Vdi_si*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Vge_si_Vge_e=(+ids_Vge_si_Vge_e*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Vge_si_Ve_si=(+ids_Vge_si_Ve_si*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Vge_si_Ve_di=(+ids_Vge_si_Ve_di*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Vge_si_Vge_si=(+ids_Vge_si_Vge_si*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Vge_si_Vge_di=(+ids_Vge_si_Vge_di*pModel->IDS0MULT+ids_Vge_si*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
ids_Vge_di=ids_Vge_di*pModel->IDS0MULT;
#if defined(_DERIVATE2)
  ids_Vge_di_Tempt_GND=(+ids_Vge_di_Tempt_GND*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Tempt_GND*0.0+ids*0.0);
  ids_Vge_di_Vdi_si=(+ids_Vge_di_Vdi_si*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Vdi_si*0.0+ids*0.0);
  ids_Vge_di_Vge_e=(+ids_Vge_di_Vge_e*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Vge_e*0.0+ids*0.0);
  ids_Vge_di_Ve_si=(+ids_Vge_di_Ve_si*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Ve_si*0.0+ids*0.0);
  ids_Vge_di_Ve_di=(+ids_Vge_di_Ve_di*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Ve_di*0.0+ids*0.0);
  ids_Vge_di_Vge_si=(+ids_Vge_di_Vge_si*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Vge_si*0.0+ids*0.0);
  ids_Vge_di_Vge_di=(+ids_Vge_di_Vge_di*pModel->IDS0MULT+ids_Vge_di*0.0+ids_Vge_di*0.0+ids*0.0);
#endif
#endif
ids=(ids*pModel->IDS0MULT);
EXIT_IF_ISNAN((ids*pModel->IDS0MULT))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T11_Vge_e=(-((2.0*qia)+nVtm)*DvsatCV_Vge_e/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Vge_e_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Vge_e+(0.0)*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_e_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_e_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_e_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_e_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_e_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*0.0+2.0*0.0)+0.0)/DvsatCV-(0.0*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Vge_e+((2.0*qia)+nVtm)*DvsatCV_Vge_e_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_e*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
T11_Ve_si=(((2.0*qia_Ve_si)*DvsatCV-((2.0*qia)+nVtm)*DvsatCV_Ve_si)/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Ve_si_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+2.0*0.0)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Vge_e+(0.0)*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_si_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+2.0*qia_Ve_si_Ve_si)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_si_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+2.0*qia_Ve_si_Ve_di)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_si_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+2.0*qia_Ve_si_Vge_si)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_si_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+2.0*qia_Ve_si_Vdi_si)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_si_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+2.0*qia_Ve_si_Tempt_GND)+0.0)/DvsatCV-((2.0*qia_Ve_si)*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Ve_si+((2.0*qia)+nVtm)*DvsatCV_Ve_si_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_si*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
T11_Ve_di=(((2.0*qia_Ve_di)*DvsatCV-((2.0*qia)+nVtm)*DvsatCV_Ve_di)/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Ve_di_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+2.0*0.0)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Vge_e+(0.0)*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_di_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+2.0*qia_Ve_di_Ve_si)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_di_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+2.0*qia_Ve_di_Ve_di)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_di_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+2.0*qia_Ve_di_Vge_si)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_di_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+2.0*qia_Ve_di_Vdi_si)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Ve_di_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+2.0*qia_Ve_di_Tempt_GND)+0.0)/DvsatCV-((2.0*qia_Ve_di)*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Ve_di+((2.0*qia)+nVtm)*DvsatCV_Ve_di_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Ve_di*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
T11_Vge_si=(((2.0*qia_Vge_si)*DvsatCV-((2.0*qia)+nVtm)*DvsatCV_Vge_si)/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Vge_si_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+2.0*0.0)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Vge_e+(0.0)*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_si_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+2.0*qia_Vge_si_Ve_si)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_si_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+2.0*qia_Vge_si_Ve_di)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_si_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+2.0*qia_Vge_si_Vge_si)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_si_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+2.0*qia_Vge_si_Vdi_si)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vge_si_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+2.0*qia_Vge_si_Tempt_GND)+0.0)/DvsatCV-((2.0*qia_Vge_si)*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Vge_si+((2.0*qia)+nVtm)*DvsatCV_Vge_si_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vge_si*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
T11_Vdi_si=((((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV-((2.0*qia)+nVtm)*DvsatCV_Vdi_si)/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Vdi_si_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+2.0*0.0)+0.0)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Vge_e+(0.0)*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Vdi_si_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+2.0*qia_Vdi_si_Ve_si)+0.0)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vdi_si_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+2.0*qia_Vdi_si_Ve_di)+0.0)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Vdi_si_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+2.0*qia_Vdi_si_Vge_si)+0.0)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vdi_si_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+2.0*qia_Vdi_si_Vdi_si)+nVtm_Vdi_si_Vdi_si)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Vdi_si_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+2.0*qia_Vdi_si_Tempt_GND)+nVtm_Vdi_si_Tempt_GND)/DvsatCV-(((2.0*qia_Vdi_si)+nVtm_Vdi_si)*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Vdi_si+((2.0*qia)+nVtm)*DvsatCV_Vdi_si_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Vdi_si*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
T11_Tempt_GND=((((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV-((2.0*qia)+nVtm)*DvsatCV_Tempt_GND)/DvsatCV/DvsatCV);
#if defined(_DERIVATE2)
  T11_Tempt_GND_Vge_e=((+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+2.0*0.0)+0.0)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Vge_e+(0.0)*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Vge_e)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Vge_e/DvsatCV/DvsatCV/DvsatCV);
  T11_Tempt_GND_Ve_si=((+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+2.0*qia_Tempt_GND_Ve_si)+0.0)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Ve_si+((2.0*qia_Ve_si))*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Ve_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Ve_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Tempt_GND_Ve_di=((+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+2.0*qia_Tempt_GND_Ve_di)+0.0)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Ve_di+((2.0*qia_Ve_di))*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Ve_di)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Ve_di/DvsatCV/DvsatCV/DvsatCV);
  T11_Tempt_GND_Vge_si=((+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+2.0*qia_Tempt_GND_Vge_si)+0.0)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Vge_si+((2.0*qia_Vge_si))*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Vge_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Vge_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Tempt_GND_Vdi_si=((+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+2.0*qia_Tempt_GND_Vdi_si)+nVtm_Tempt_GND_Vdi_si)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Vdi_si+(((2.0*qia_Vdi_si))+nVtm_Vdi_si)*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Vdi_si)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Vdi_si/DvsatCV/DvsatCV/DvsatCV);
  T11_Tempt_GND_Tempt_GND=((+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+2.0*qia_Tempt_GND_Tempt_GND)+nVtm_Tempt_GND_Tempt_GND)/DvsatCV-(((2.0*qia_Tempt_GND)+nVtm_Tempt_GND)*DvsatCV_Tempt_GND+(((2.0*qia_Tempt_GND))+nVtm_Tempt_GND)*DvsatCV_Tempt_GND+((2.0*qia)+nVtm)*DvsatCV_Tempt_GND_Tempt_GND)/DvsatCV/DvsatCV+2*((2.0*qia)+nVtm)*DvsatCV_Tempt_GND*DvsatCV_Tempt_GND/DvsatCV/DvsatCV/DvsatCV);
#endif
#endif
T11=(((2.0*qia)+nVtm)/DvsatCV);
EXIT_IF_ISNAN((((2.0*qia)+nVtm)/DvsatCV))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_Vdi_si=(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)));
#if defined(_DERIVATE2)
  qg_Vdi_si_Vdi_si=(+qia_Vdi_si_Vdi_si+((+dqi_Vdi_si_Vdi_si*dqi+dqi_Vdi_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Vdi_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vdi_si_Ve_si=(+qia_Vdi_si_Ve_si+((+dqi_Vdi_si_Ve_si*dqi+dqi_Vdi_si*dqi_Ve_si+dqi_Ve_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Ve_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vdi_si_Ve_di=(+qia_Vdi_si_Ve_di+((+dqi_Vdi_si_Ve_di*dqi+dqi_Vdi_si*dqi_Ve_di+dqi_Ve_di*dqi_Vdi_si+dqi*dqi_Vdi_si_Ve_di)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vdi_si_Vge_si=(+qia_Vdi_si_Vge_si+((+dqi_Vdi_si_Vge_si*dqi+dqi_Vdi_si*dqi_Vge_si+dqi_Vge_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Vge_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vdi_si_Tempt_GND=(+qia_Vdi_si_Tempt_GND+((+dqi_Vdi_si_Tempt_GND*dqi+dqi_Vdi_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Vdi_si+dqi*dqi_Vdi_si_Tempt_GND)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vdi_si_Vge_e=(+0.0+((+0.0*dqi+dqi_Vdi_si*0.0+0.0*dqi_Vdi_si+dqi*0.0)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
qg_Ve_si=(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)));
#if defined(_DERIVATE2)
  qg_Ve_si_Vdi_si=(+qia_Ve_si_Vdi_si+((+dqi_Ve_si_Vdi_si*dqi+dqi_Ve_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Ve_si+dqi*dqi_Ve_si_Vdi_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_si_Ve_si=(+qia_Ve_si_Ve_si+((+dqi_Ve_si_Ve_si*dqi+dqi_Ve_si*dqi_Ve_si+dqi_Ve_si*dqi_Ve_si+dqi*dqi_Ve_si_Ve_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_si_Ve_di=(+qia_Ve_si_Ve_di+((+dqi_Ve_si_Ve_di*dqi+dqi_Ve_si*dqi_Ve_di+dqi_Ve_di*dqi_Ve_si+dqi*dqi_Ve_si_Ve_di)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_si+6.0*T11_Ve_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_si_Vge_si=(+qia_Ve_si_Vge_si+((+dqi_Ve_si_Vge_si*dqi+dqi_Ve_si*dqi_Vge_si+dqi_Vge_si*dqi_Ve_si+dqi*dqi_Ve_si_Vge_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_si_Tempt_GND=(+qia_Ve_si_Tempt_GND+((+dqi_Ve_si_Tempt_GND*dqi+dqi_Ve_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Ve_si+dqi*dqi_Ve_si_Tempt_GND)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_si+6.0*T11_Ve_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_si_Vge_e=(+0.0+((+0.0*dqi+dqi_Ve_si*0.0+0.0*dqi_Ve_si+dqi*0.0)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_si+6.0*T11_Ve_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
qg_Ve_di=(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)));
#if defined(_DERIVATE2)
  qg_Ve_di_Vdi_si=(+qia_Ve_di_Vdi_si+((+dqi_Ve_di_Vdi_si*dqi+dqi_Ve_di*dqi_Vdi_si+dqi_Vdi_si*dqi_Ve_di+dqi*dqi_Ve_di_Vdi_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_di_Ve_si=(+qia_Ve_di_Ve_si+((+dqi_Ve_di_Ve_si*dqi+dqi_Ve_di*dqi_Ve_si+dqi_Ve_si*dqi_Ve_di+dqi*dqi_Ve_di_Ve_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_di_Ve_di=(+qia_Ve_di_Ve_di+((+dqi_Ve_di_Ve_di*dqi+dqi_Ve_di*dqi_Ve_di+dqi_Ve_di*dqi_Ve_di+dqi*dqi_Ve_di_Ve_di)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_di+6.0*T11_Ve_di_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_di_Vge_si=(+qia_Ve_di_Vge_si+((+dqi_Ve_di_Vge_si*dqi+dqi_Ve_di*dqi_Vge_si+dqi_Vge_si*dqi_Ve_di+dqi*dqi_Ve_di_Vge_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_di_Tempt_GND=(+qia_Ve_di_Tempt_GND+((+dqi_Ve_di_Tempt_GND*dqi+dqi_Ve_di*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Ve_di+dqi*dqi_Ve_di_Tempt_GND)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_di+6.0*T11_Ve_di_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Ve_di_Vge_e=(+0.0+((+0.0*dqi+dqi_Ve_di*0.0+0.0*dqi_Ve_di+dqi*0.0)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_di+6.0*T11_Ve_di_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
qg_Vge_si=(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)));
#if defined(_DERIVATE2)
  qg_Vge_si_Vdi_si=(+qia_Vge_si_Vdi_si+((+dqi_Vge_si_Vdi_si*dqi+dqi_Vge_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Vge_si+dqi*dqi_Vge_si_Vdi_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_si_Ve_si=(+qia_Vge_si_Ve_si+((+dqi_Vge_si_Ve_si*dqi+dqi_Vge_si*dqi_Ve_si+dqi_Ve_si*dqi_Vge_si+dqi*dqi_Vge_si_Ve_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_si_Ve_di=(+qia_Vge_si_Ve_di+((+dqi_Vge_si_Ve_di*dqi+dqi_Vge_si*dqi_Ve_di+dqi_Ve_di*dqi_Vge_si+dqi*dqi_Vge_si_Ve_di)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_si+6.0*T11_Vge_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_si_Vge_si=(+qia_Vge_si_Vge_si+((+dqi_Vge_si_Vge_si*dqi+dqi_Vge_si*dqi_Vge_si+dqi_Vge_si*dqi_Vge_si+dqi*dqi_Vge_si_Vge_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_si_Tempt_GND=(+qia_Vge_si_Tempt_GND+((+dqi_Vge_si_Tempt_GND*dqi+dqi_Vge_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Vge_si+dqi*dqi_Vge_si_Tempt_GND)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_si+6.0*T11_Vge_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_si_Vge_e=(+0.0+((+0.0*dqi+dqi_Vge_si*0.0+0.0*dqi_Vge_si+dqi*0.0)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_si+6.0*T11_Vge_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
qg_Tempt_GND=(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)));
#if defined(_DERIVATE2)
  qg_Tempt_GND_Vdi_si=(+qia_Tempt_GND_Vdi_si+((+dqi_Tempt_GND_Vdi_si*dqi+dqi_Tempt_GND*dqi_Vdi_si+dqi_Vdi_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Vdi_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Tempt_GND_Ve_si=(+qia_Tempt_GND_Ve_si+((+dqi_Tempt_GND_Ve_si*dqi+dqi_Tempt_GND*dqi_Ve_si+dqi_Ve_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Ve_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Tempt_GND_Ve_di=(+qia_Tempt_GND_Ve_di+((+dqi_Tempt_GND_Ve_di*dqi+dqi_Tempt_GND*dqi_Ve_di+dqi_Ve_di*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Ve_di)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Tempt_GND_Vge_si=(+qia_Tempt_GND_Vge_si+((+dqi_Tempt_GND_Vge_si*dqi+dqi_Tempt_GND*dqi_Vge_si+dqi_Vge_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Vge_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Tempt_GND_Tempt_GND=(+qia_Tempt_GND_Tempt_GND+((+dqi_Tempt_GND_Tempt_GND*dqi+dqi_Tempt_GND*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Tempt_GND)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Tempt_GND_Vge_e=(+0.0+((+0.0*dqi+dqi_Tempt_GND*0.0+0.0*dqi_Tempt_GND+dqi*0.0)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
qg_Vge_e=(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11));
#if defined(_DERIVATE2)
  qg_Vge_e_Vdi_si=(+0.0+((+0.0*dqi+0.0*dqi_Vdi_si+dqi_Vdi_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_e_Ve_si=(+0.0+((+0.0*dqi+0.0*dqi_Ve_si+dqi_Ve_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_e_Ve_di=(+0.0+((+0.0*dqi+0.0*dqi_Ve_di+dqi_Ve_di*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_e+6.0*T11_Vge_e_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_e_Vge_si=(+0.0+((+0.0*dqi+0.0*dqi_Vge_si+dqi_Vge_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_e_Tempt_GND=(+0.0+((+0.0*dqi+0.0*dqi_Tempt_GND+dqi_Tempt_GND*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_e+6.0*T11_Vge_e_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
  qg_Vge_e_Vge_e=(+0.0+((+0.0*dqi+0.0*0.0+0.0*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_e+6.0*T11_Vge_e_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11)));
#endif
#endif
qg=(qia+((dqi*dqi)/(6.0*T11)));
EXIT_IF_ISNAN((qia+((dqi*dqi)/(6.0*T11))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qd_Vdi_si=((-0.5)*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))))));
#if defined(_DERIVATE2)
  qd_Vdi_si_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vdi_si_Vdi_si-(+(dqi_Vdi_si_Vdi_si/6.0-(dqi_Vdi_si*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vdi_si_Vdi_si/T11-(dqi_Vdi_si*T11_Vdi_si+dqi_Vdi_si*T11_Vdi_si+dqi*T11_Vdi_si_Vdi_si)/T11/T11+2*dqi*T11_Vdi_si*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vdi_si_Vdi_si/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vdi_si_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vdi_si_Ve_si-(+(dqi_Vdi_si_Ve_si/6.0-(dqi_Vdi_si*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vdi_si_Ve_si/T11-(dqi_Vdi_si*T11_Ve_si+dqi_Ve_si*T11_Vdi_si+dqi*T11_Vdi_si_Ve_si)/T11/T11+2*dqi*T11_Vdi_si*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vdi_si_Ve_si/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vdi_si_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vdi_si_Ve_di-(+(dqi_Vdi_si_Ve_di/6.0-(dqi_Vdi_si*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vdi_si_Ve_di/T11-(dqi_Vdi_si*T11_Ve_di+dqi_Ve_di*T11_Vdi_si+dqi*T11_Vdi_si_Ve_di)/T11/T11+2*dqi*T11_Vdi_si*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vdi_si_Ve_di/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vdi_si_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vdi_si_Vge_si-(+(dqi_Vdi_si_Vge_si/6.0-(dqi_Vdi_si*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vdi_si_Vge_si/T11-(dqi_Vdi_si*T11_Vge_si+dqi_Vge_si*T11_Vdi_si+dqi*T11_Vdi_si_Vge_si)/T11/T11+2*dqi*T11_Vdi_si*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vdi_si_Vge_si/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vdi_si_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vdi_si_Tempt_GND-(+(dqi_Vdi_si_Tempt_GND/6.0-(dqi_Vdi_si*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vdi_si_Tempt_GND/T11-(dqi_Vdi_si*T11_Tempt_GND+dqi_Tempt_GND*T11_Vdi_si+dqi*T11_Vdi_si_Tempt_GND)/T11/T11+2*dqi*T11_Vdi_si*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vdi_si_Tempt_GND/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vdi_si_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(qia_Vdi_si-(((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+0.0-(+(0.0/6.0-(dqi_Vdi_si*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vdi_si/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(dqi_Vdi_si*T11_Vge_e+0.0*T11_Vdi_si+dqi*T11_Vdi_si_Vge_e)/T11/T11+2*dqi*T11_Vdi_si*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*(5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(dqi_Vdi_si*((5.0*T11_Vge_e))+0.0*(5.0*T11_Vdi_si)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vdi_si+5.0*T11_Vdi_si_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vdi_si)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
qd_Ve_si=((-0.5)*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))))));
#if defined(_DERIVATE2)
  qd_Ve_si_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_si_Vdi_si-(+(dqi_Ve_si_Vdi_si/6.0-(dqi_Ve_si*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_si_Vdi_si/T11-(dqi_Ve_si*T11_Vdi_si+dqi_Vdi_si*T11_Ve_si+dqi*T11_Ve_si_Vdi_si)/T11/T11+2*dqi*T11_Ve_si*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_si_Vdi_si/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_si+5.0*T11_Ve_si_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_si_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_si_Ve_si-(+(dqi_Ve_si_Ve_si/6.0-(dqi_Ve_si*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_si_Ve_si/T11-(dqi_Ve_si*T11_Ve_si+dqi_Ve_si*T11_Ve_si+dqi*T11_Ve_si_Ve_si)/T11/T11+2*dqi*T11_Ve_si*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_si_Ve_si/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_si+5.0*T11_Ve_si_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_si_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_si_Ve_di-(+(dqi_Ve_si_Ve_di/6.0-(dqi_Ve_si*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_si_Ve_di/T11-(dqi_Ve_si*T11_Ve_di+dqi_Ve_di*T11_Ve_si+dqi*T11_Ve_si_Ve_di)/T11/T11+2*dqi*T11_Ve_si*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_si_Ve_di/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_si+5.0*T11_Ve_si_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_si_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_si_Vge_si-(+(dqi_Ve_si_Vge_si/6.0-(dqi_Ve_si*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_si_Vge_si/T11-(dqi_Ve_si*T11_Vge_si+dqi_Vge_si*T11_Ve_si+dqi*T11_Ve_si_Vge_si)/T11/T11+2*dqi*T11_Ve_si*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_si_Vge_si/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_si+5.0*T11_Ve_si_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_si_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_si_Tempt_GND-(+(dqi_Ve_si_Tempt_GND/6.0-(dqi_Ve_si*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_si_Tempt_GND/T11-(dqi_Ve_si*T11_Tempt_GND+dqi_Tempt_GND*T11_Ve_si+dqi*T11_Ve_si_Tempt_GND)/T11/T11+2*dqi*T11_Ve_si*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_si_Tempt_GND/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_si+5.0*T11_Ve_si_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_si_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(qia_Ve_si-(((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+0.0-(+(0.0/6.0-(dqi_Ve_si*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_si/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(dqi_Ve_si*T11_Vge_e+0.0*T11_Ve_si+dqi*T11_Ve_si_Vge_e)/T11/T11+2*dqi*T11_Ve_si*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*(5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(dqi_Ve_si*((5.0*T11_Vge_e))+0.0*(5.0*T11_Ve_si)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_si+5.0*T11_Ve_si_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_si)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
qd_Ve_di=((-0.5)*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))))));
#if defined(_DERIVATE2)
  qd_Ve_di_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_di_Vdi_si-(+(dqi_Ve_di_Vdi_si/6.0-(dqi_Ve_di*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_di_Vdi_si/T11-(dqi_Ve_di*T11_Vdi_si+dqi_Vdi_si*T11_Ve_di+dqi*T11_Ve_di_Vdi_si)/T11/T11+2*dqi*T11_Ve_di*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_di_Vdi_si/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_di+5.0*T11_Ve_di_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_di_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_di_Ve_si-(+(dqi_Ve_di_Ve_si/6.0-(dqi_Ve_di*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_di_Ve_si/T11-(dqi_Ve_di*T11_Ve_si+dqi_Ve_si*T11_Ve_di+dqi*T11_Ve_di_Ve_si)/T11/T11+2*dqi*T11_Ve_di*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_di_Ve_si/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_di+5.0*T11_Ve_di_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_di_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_di_Ve_di-(+(dqi_Ve_di_Ve_di/6.0-(dqi_Ve_di*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_di_Ve_di/T11-(dqi_Ve_di*T11_Ve_di+dqi_Ve_di*T11_Ve_di+dqi*T11_Ve_di_Ve_di)/T11/T11+2*dqi*T11_Ve_di*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_di_Ve_di/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_di+5.0*T11_Ve_di_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_di_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_di_Vge_si-(+(dqi_Ve_di_Vge_si/6.0-(dqi_Ve_di*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_di_Vge_si/T11-(dqi_Ve_di*T11_Vge_si+dqi_Vge_si*T11_Ve_di+dqi*T11_Ve_di_Vge_si)/T11/T11+2*dqi*T11_Ve_di*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_di_Vge_si/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_di+5.0*T11_Ve_di_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_di_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Ve_di_Tempt_GND-(+(dqi_Ve_di_Tempt_GND/6.0-(dqi_Ve_di*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Ve_di_Tempt_GND/T11-(dqi_Ve_di*T11_Tempt_GND+dqi_Tempt_GND*T11_Ve_di+dqi*T11_Ve_di_Tempt_GND)/T11/T11+2*dqi*T11_Ve_di*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Ve_di_Tempt_GND/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_di+5.0*T11_Ve_di_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Ve_di_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(qia_Ve_di-(((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+0.0-(+(0.0/6.0-(dqi_Ve_di*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Ve_di/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(dqi_Ve_di*T11_Vge_e+0.0*T11_Ve_di+dqi*T11_Ve_di_Vge_e)/T11/T11+2*dqi*T11_Ve_di*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*(5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(dqi_Ve_di*((5.0*T11_Vge_e))+0.0*(5.0*T11_Ve_di)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_di+5.0*T11_Ve_di_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Ve_di)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
qd_Vge_si=((-0.5)*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))))));
#if defined(_DERIVATE2)
  qd_Vge_si_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vge_si_Vdi_si-(+(dqi_Vge_si_Vdi_si/6.0-(dqi_Vge_si*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vge_si_Vdi_si/T11-(dqi_Vge_si*T11_Vdi_si+dqi_Vdi_si*T11_Vge_si+dqi*T11_Vge_si_Vdi_si)/T11/T11+2*dqi*T11_Vge_si*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vge_si_Vdi_si/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_si+5.0*T11_Vge_si_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_si_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vge_si_Ve_si-(+(dqi_Vge_si_Ve_si/6.0-(dqi_Vge_si*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vge_si_Ve_si/T11-(dqi_Vge_si*T11_Ve_si+dqi_Ve_si*T11_Vge_si+dqi*T11_Vge_si_Ve_si)/T11/T11+2*dqi*T11_Vge_si*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vge_si_Ve_si/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_si+5.0*T11_Vge_si_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_si_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vge_si_Ve_di-(+(dqi_Vge_si_Ve_di/6.0-(dqi_Vge_si*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vge_si_Ve_di/T11-(dqi_Vge_si*T11_Ve_di+dqi_Ve_di*T11_Vge_si+dqi*T11_Vge_si_Ve_di)/T11/T11+2*dqi*T11_Vge_si*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vge_si_Ve_di/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_si+5.0*T11_Vge_si_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_si_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vge_si_Vge_si-(+(dqi_Vge_si_Vge_si/6.0-(dqi_Vge_si*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vge_si_Vge_si/T11-(dqi_Vge_si*T11_Vge_si+dqi_Vge_si*T11_Vge_si+dqi*T11_Vge_si_Vge_si)/T11/T11+2*dqi*T11_Vge_si*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vge_si_Vge_si/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_si+5.0*T11_Vge_si_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_si_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Vge_si_Tempt_GND-(+(dqi_Vge_si_Tempt_GND/6.0-(dqi_Vge_si*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Vge_si_Tempt_GND/T11-(dqi_Vge_si*T11_Tempt_GND+dqi_Tempt_GND*T11_Vge_si+dqi*T11_Vge_si_Tempt_GND)/T11/T11+2*dqi*T11_Vge_si*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Vge_si_Tempt_GND/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_si+5.0*T11_Vge_si_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_si_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(qia_Vge_si-(((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+0.0-(+(0.0/6.0-(dqi_Vge_si*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Vge_si/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(dqi_Vge_si*T11_Vge_e+0.0*T11_Vge_si+dqi*T11_Vge_si_Vge_e)/T11/T11+2*dqi*T11_Vge_si*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*(5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(dqi_Vge_si*((5.0*T11_Vge_e))+0.0*(5.0*T11_Vge_si)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_si+5.0*T11_Vge_si_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_si)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
qd_Tempt_GND=((-0.5)*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))))));
#if defined(_DERIVATE2)
  qd_Tempt_GND_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Tempt_GND_Vdi_si-(+(dqi_Tempt_GND_Vdi_si/6.0-(dqi_Tempt_GND*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Tempt_GND_Vdi_si/T11-(dqi_Tempt_GND*T11_Vdi_si+dqi_Vdi_si*T11_Tempt_GND+dqi*T11_Tempt_GND_Vdi_si)/T11/T11+2*dqi*T11_Tempt_GND*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Tempt_GND_Vdi_si/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Tempt_GND_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Tempt_GND_Ve_si-(+(dqi_Tempt_GND_Ve_si/6.0-(dqi_Tempt_GND*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Tempt_GND_Ve_si/T11-(dqi_Tempt_GND*T11_Ve_si+dqi_Ve_si*T11_Tempt_GND+dqi*T11_Tempt_GND_Ve_si)/T11/T11+2*dqi*T11_Tempt_GND*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Tempt_GND_Ve_si/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Tempt_GND_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Tempt_GND_Ve_di-(+(dqi_Tempt_GND_Ve_di/6.0-(dqi_Tempt_GND*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Tempt_GND_Ve_di/T11-(dqi_Tempt_GND*T11_Ve_di+dqi_Ve_di*T11_Tempt_GND+dqi*T11_Tempt_GND_Ve_di)/T11/T11+2*dqi*T11_Tempt_GND*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Tempt_GND_Ve_di/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Tempt_GND_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Tempt_GND_Vge_si-(+(dqi_Tempt_GND_Vge_si/6.0-(dqi_Tempt_GND*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Tempt_GND_Vge_si/T11-(dqi_Tempt_GND*T11_Vge_si+dqi_Vge_si*T11_Tempt_GND+dqi*T11_Tempt_GND_Vge_si)/T11/T11+2*dqi*T11_Tempt_GND*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Tempt_GND_Vge_si/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Tempt_GND_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+qia_Tempt_GND_Tempt_GND-(+(dqi_Tempt_GND_Tempt_GND/6.0-(dqi_Tempt_GND*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(dqi_Tempt_GND_Tempt_GND/T11-(dqi_Tempt_GND*T11_Tempt_GND+dqi_Tempt_GND*T11_Tempt_GND+dqi*T11_Tempt_GND_Tempt_GND)/T11/T11+2*dqi*T11_Tempt_GND*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(dqi_Tempt_GND_Tempt_GND/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Tempt_GND_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(qia_Tempt_GND-(((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))))))))+(-0.5)*(+0.0-(+(0.0/6.0-(dqi_Tempt_GND*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+(dqi_Tempt_GND/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(dqi_Tempt_GND*T11_Vge_e+0.0*T11_Tempt_GND+dqi*T11_Tempt_GND_Vge_e)/T11/T11+2*dqi*T11_Tempt_GND*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*(5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(dqi_Tempt_GND*((5.0*T11_Vge_e))+0.0*(5.0*T11_Tempt_GND)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Tempt_GND+5.0*T11_Tempt_GND_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Tempt_GND)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
qd_Vge_e=((-0.5)*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))))))));
#if defined(_DERIVATE2)
  qd_Vge_e_Vdi_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vdi_si-((((dqi_Vdi_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+dqi_Vdi_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-(((((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vdi_si/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Vdi_si+dqi_Vdi_si*T11_Vge_e+dqi*T11_Vge_e_Vdi_si)/T11/T11+2*dqi*T11_Vge_e*T11_Vdi_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Vdi_si*(5.0*T11)-dqi*((5.0*T11_Vdi_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vdi_si*T11-dqi*T11_Vdi_si)/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Vdi_si))+dqi_Vdi_si*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_e+5.0*T11_Vge_e_Vdi_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Vdi_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_e_Ve_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_si-((((dqi_Ve_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+dqi_Ve_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-(((((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_si/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Ve_si+dqi_Ve_si*T11_Vge_e+dqi*T11_Vge_e_Ve_si)/T11/T11+2*dqi*T11_Vge_e*T11_Ve_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Ve_si*(5.0*T11)-dqi*((5.0*T11_Ve_si)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_si*T11-dqi*T11_Ve_si)/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Ve_si))+dqi_Ve_si*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_e+5.0*T11_Vge_e_Ve_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Ve_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_e_Ve_di=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Ve_di-((((dqi_Ve_di/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+dqi_Ve_di*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-(((((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))))))+(dqi_Ve_di/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Ve_di+dqi_Ve_di*T11_Vge_e+dqi*T11_Vge_e_Ve_di)/T11/T11+2*dqi*T11_Vge_e*T11_Ve_di/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Ve_di*(5.0*T11)-dqi*((5.0*T11_Ve_di)))/(5.0*T11)/(5.0*T11))+((dqi_Ve_di*T11-dqi*T11_Ve_di)/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Ve_di))+dqi_Ve_di*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_e+5.0*T11_Vge_e_Ve_di))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Ve_di))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_e_Vge_si=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Vge_si-((((dqi_Vge_si/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+dqi_Vge_si*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-(((((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))))))+(dqi_Vge_si/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Vge_si+dqi_Vge_si*T11_Vge_e+dqi*T11_Vge_e_Vge_si)/T11/T11+2*dqi*T11_Vge_e*T11_Vge_si/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Vge_si*(5.0*T11)-dqi*((5.0*T11_Vge_si)))/(5.0*T11)/(5.0*T11))+((dqi_Vge_si*T11-dqi*T11_Vge_si)/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Vge_si))+dqi_Vge_si*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_e+5.0*T11_Vge_e_Vge_si))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Vge_si))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_e_Tempt_GND=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(qia_Tempt_GND-((((dqi_Tempt_GND/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))+((dqi/6.0)*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+dqi_Tempt_GND*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-(((((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))))))+(dqi_Tempt_GND/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Tempt_GND+dqi_Tempt_GND*T11_Vge_e+dqi*T11_Vge_e_Tempt_GND)/T11/T11+2*dqi*T11_Vge_e*T11_Tempt_GND/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*((dqi_Tempt_GND*(5.0*T11)-dqi*((5.0*T11_Tempt_GND)))/(5.0*T11)/(5.0*T11))+((dqi_Tempt_GND*T11-dqi*T11_Tempt_GND)/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Tempt_GND))+dqi_Tempt_GND*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_e+5.0*T11_Vge_e_Tempt_GND))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Tempt_GND))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
  qd_Vge_e_Vge_e=(+0.0*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))+0.0*(-(((dqi/6.0)*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)))))))))+0.0*(-((dqi/6.0)*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))))+(-0.5)*(+0.0-(+(0.0/6.0-(0.0*0.0+0.0*0.0+dqi*0.0)/6.0/6.0+2*dqi*0.0*0.0/6.0/6.0/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))+0.0*(-((((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))))))+0.0*(-(((-dqi*T11_Vge_e/T11/T11)*(1+(dqi/(5.0*T11))))+((dqi/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11)))))+(dqi/6.0)*(+0.0-(+(0.0/T11-(0.0*T11_Vge_e+0.0*T11_Vge_e+dqi*T11_Vge_e_Vge_e)/T11/T11+2*dqi*T11_Vge_e*T11_Vge_e/T11/T11/T11)*(1+(dqi/(5.0*T11)))+(-dqi*T11_Vge_e/T11/T11)*(-dqi*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11))+(-dqi*T11_Vge_e/T11/T11)*(-dqi*(5.0*T11_Vge_e)/(5.0*T11)/(5.0*T11))+(dqi/T11)*(+0.0+(0.0/(5.0*T11)-(0.0*((5.0*T11_Vge_e))+0.0*(5.0*T11_Vge_e)+dqi*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_e+5.0*T11_Vge_e_Vge_e))/(5.0*T11)/(5.0*T11)+2*dqi*(5.0*T11_Vge_e)*((5.0*T11_Vge_e))/(5.0*T11)/(5.0*T11)/(5.0*T11))))))));
#endif
#endif
qd=((-0.5)*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11))))))));
EXIT_IF_ISNAN(((-0.5)*(qia-((dqi/6.0)*(1.0-((dqi/T11)*(1+(dqi/(5.0*T11)))))))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
inv_MclmCV_Vdi_si=(-MclmCV_Vdi_si/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Vdi_si_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vdi_si_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vdi_si_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vdi_si_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vdi_si_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vdi_si_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Vdi_si+1.0*MclmCV_Vdi_si_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Vdi_si*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
inv_MclmCV_Ve_si=(-MclmCV_Ve_si/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Ve_si_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_si_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_si_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_si_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_si_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_si_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Ve_si+1.0*MclmCV_Ve_si_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_si*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
inv_MclmCV_Ve_di=(-MclmCV_Ve_di/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Ve_di_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_di_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_di_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_di_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_di_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Ve_di_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Ve_di+1.0*MclmCV_Ve_di_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Ve_di*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
inv_MclmCV_Vge_si=(-MclmCV_Vge_si/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Vge_si_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_si_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_si_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_si_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_si_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_si_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Vge_si+1.0*MclmCV_Vge_si_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_si*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
inv_MclmCV_Tempt_GND=(-MclmCV_Tempt_GND/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Tempt_GND_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Tempt_GND_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Tempt_GND_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Tempt_GND_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Tempt_GND_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Tempt_GND_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Tempt_GND+1.0*MclmCV_Tempt_GND_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Tempt_GND*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
inv_MclmCV_Vge_e=(-MclmCV_Vge_e/MclmCV/MclmCV);
#if defined(_DERIVATE2)
  inv_MclmCV_Vge_e_Vdi_si=(0.0/MclmCV-(0.0*MclmCV_Vdi_si+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Vdi_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Vdi_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_e_Ve_si=(0.0/MclmCV-(0.0*MclmCV_Ve_si+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Ve_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Ve_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_e_Ve_di=(0.0/MclmCV-(0.0*MclmCV_Ve_di+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Ve_di)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Ve_di/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_e_Vge_si=(0.0/MclmCV-(0.0*MclmCV_Vge_si+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Vge_si)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Vge_si/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_e_Tempt_GND=(0.0/MclmCV-(0.0*MclmCV_Tempt_GND+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Tempt_GND)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Tempt_GND/MclmCV/MclmCV/MclmCV);
  inv_MclmCV_Vge_e_Vge_e=(0.0/MclmCV-(0.0*MclmCV_Vge_e+0.0*MclmCV_Vge_e+1.0*MclmCV_Vge_e_Vge_e)/MclmCV/MclmCV+2*1.0*MclmCV_Vge_e*MclmCV_Vge_e/MclmCV/MclmCV/MclmCV);
#endif
#endif
inv_MclmCV=(1.0/MclmCV);
EXIT_IF_ISNAN((1.0/MclmCV))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_Vdi_si=(((inv_MclmCV_Vdi_si*qg)+(inv_MclmCV*qg_Vdi_si))+((MclmCV_Vdi_si*qid)+((MclmCV-1.0)*qid_Vdi_si)));
#if defined(_DERIVATE2)
  qg_Vdi_si_Vdi_si=(+(+inv_MclmCV_Vdi_si_Vdi_si*qg+inv_MclmCV_Vdi_si*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Vdi_si)+(+(+MclmCV_Vdi_si_Vdi_si-0.0)*qid+MclmCV_Vdi_si*qid_Vdi_si+MclmCV_Vdi_si*qid_Vdi_si+(MclmCV-1.0)*qid_Vdi_si_Vdi_si));
  qg_Vdi_si_Ve_si=(+(+inv_MclmCV_Vdi_si_Ve_si*qg+inv_MclmCV_Vdi_si*qg_Ve_si+inv_MclmCV_Ve_si*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Ve_si)+(+(+MclmCV_Vdi_si_Ve_si-0.0)*qid+MclmCV_Vdi_si*qid_Ve_si+MclmCV_Ve_si*qid_Vdi_si+(MclmCV-1.0)*qid_Vdi_si_Ve_si));
  qg_Vdi_si_Ve_di=(+(+inv_MclmCV_Vdi_si_Ve_di*qg+inv_MclmCV_Vdi_si*qg_Ve_di+inv_MclmCV_Ve_di*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Ve_di)+(+(+MclmCV_Vdi_si_Ve_di-0.0)*qid+MclmCV_Vdi_si*qid_Ve_di+MclmCV_Ve_di*qid_Vdi_si+(MclmCV-1.0)*qid_Vdi_si_Ve_di));
  qg_Vdi_si_Vge_si=(+(+inv_MclmCV_Vdi_si_Vge_si*qg+inv_MclmCV_Vdi_si*qg_Vge_si+inv_MclmCV_Vge_si*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Vge_si)+(+(+MclmCV_Vdi_si_Vge_si-0.0)*qid+MclmCV_Vdi_si*qid_Vge_si+MclmCV_Vge_si*qid_Vdi_si+(MclmCV-1.0)*qid_Vdi_si_Vge_si));
  qg_Vdi_si_Tempt_GND=(+(+inv_MclmCV_Vdi_si_Tempt_GND*qg+inv_MclmCV_Vdi_si*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Tempt_GND)+(+(+MclmCV_Vdi_si_Tempt_GND-0.0)*qid+MclmCV_Vdi_si*qid_Tempt_GND+MclmCV_Tempt_GND*qid_Vdi_si+(MclmCV-1.0)*qid_Vdi_si_Tempt_GND));
  qg_Vdi_si_Vge_e=(+(+inv_MclmCV_Vdi_si_Vge_e*qg+inv_MclmCV_Vdi_si*qg_Vge_e+inv_MclmCV_Vge_e*qg_Vdi_si+inv_MclmCV*qg_Vdi_si_Vge_e)+(+(+MclmCV_Vdi_si_Vge_e-0.0)*qid+MclmCV_Vdi_si*0.0+MclmCV_Vge_e*qid_Vdi_si+(MclmCV-1.0)*0.0));
#endif
qg_Ve_si=(((inv_MclmCV_Ve_si*qg)+(inv_MclmCV*qg_Ve_si))+((MclmCV_Ve_si*qid)+((MclmCV-1.0)*qid_Ve_si)));
#if defined(_DERIVATE2)
  qg_Ve_si_Vdi_si=(+(+inv_MclmCV_Ve_si_Vdi_si*qg+inv_MclmCV_Ve_si*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Ve_si+inv_MclmCV*qg_Ve_si_Vdi_si)+(+(+MclmCV_Ve_si_Vdi_si-0.0)*qid+MclmCV_Ve_si*qid_Vdi_si+MclmCV_Vdi_si*qid_Ve_si+(MclmCV-1.0)*qid_Ve_si_Vdi_si));
  qg_Ve_si_Ve_si=(+(+inv_MclmCV_Ve_si_Ve_si*qg+inv_MclmCV_Ve_si*qg_Ve_si+inv_MclmCV_Ve_si*qg_Ve_si+inv_MclmCV*qg_Ve_si_Ve_si)+(+(+MclmCV_Ve_si_Ve_si-0.0)*qid+MclmCV_Ve_si*qid_Ve_si+MclmCV_Ve_si*qid_Ve_si+(MclmCV-1.0)*qid_Ve_si_Ve_si));
  qg_Ve_si_Ve_di=(+(+inv_MclmCV_Ve_si_Ve_di*qg+inv_MclmCV_Ve_si*qg_Ve_di+inv_MclmCV_Ve_di*qg_Ve_si+inv_MclmCV*qg_Ve_si_Ve_di)+(+(+MclmCV_Ve_si_Ve_di-0.0)*qid+MclmCV_Ve_si*qid_Ve_di+MclmCV_Ve_di*qid_Ve_si+(MclmCV-1.0)*qid_Ve_si_Ve_di));
  qg_Ve_si_Vge_si=(+(+inv_MclmCV_Ve_si_Vge_si*qg+inv_MclmCV_Ve_si*qg_Vge_si+inv_MclmCV_Vge_si*qg_Ve_si+inv_MclmCV*qg_Ve_si_Vge_si)+(+(+MclmCV_Ve_si_Vge_si-0.0)*qid+MclmCV_Ve_si*qid_Vge_si+MclmCV_Vge_si*qid_Ve_si+(MclmCV-1.0)*qid_Ve_si_Vge_si));
  qg_Ve_si_Tempt_GND=(+(+inv_MclmCV_Ve_si_Tempt_GND*qg+inv_MclmCV_Ve_si*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Ve_si+inv_MclmCV*qg_Ve_si_Tempt_GND)+(+(+MclmCV_Ve_si_Tempt_GND-0.0)*qid+MclmCV_Ve_si*qid_Tempt_GND+MclmCV_Tempt_GND*qid_Ve_si+(MclmCV-1.0)*qid_Ve_si_Tempt_GND));
  qg_Ve_si_Vge_e=(+(+inv_MclmCV_Ve_si_Vge_e*qg+inv_MclmCV_Ve_si*qg_Vge_e+inv_MclmCV_Vge_e*qg_Ve_si+inv_MclmCV*qg_Ve_si_Vge_e)+(+(+MclmCV_Ve_si_Vge_e-0.0)*qid+MclmCV_Ve_si*0.0+MclmCV_Vge_e*qid_Ve_si+(MclmCV-1.0)*0.0));
#endif
qg_Ve_di=(((inv_MclmCV_Ve_di*qg)+(inv_MclmCV*qg_Ve_di))+((MclmCV_Ve_di*qid)+((MclmCV-1.0)*qid_Ve_di)));
#if defined(_DERIVATE2)
  qg_Ve_di_Vdi_si=(+(+inv_MclmCV_Ve_di_Vdi_si*qg+inv_MclmCV_Ve_di*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Ve_di+inv_MclmCV*qg_Ve_di_Vdi_si)+(+(+MclmCV_Ve_di_Vdi_si-0.0)*qid+MclmCV_Ve_di*qid_Vdi_si+MclmCV_Vdi_si*qid_Ve_di+(MclmCV-1.0)*qid_Ve_di_Vdi_si));
  qg_Ve_di_Ve_si=(+(+inv_MclmCV_Ve_di_Ve_si*qg+inv_MclmCV_Ve_di*qg_Ve_si+inv_MclmCV_Ve_si*qg_Ve_di+inv_MclmCV*qg_Ve_di_Ve_si)+(+(+MclmCV_Ve_di_Ve_si-0.0)*qid+MclmCV_Ve_di*qid_Ve_si+MclmCV_Ve_si*qid_Ve_di+(MclmCV-1.0)*qid_Ve_di_Ve_si));
  qg_Ve_di_Ve_di=(+(+inv_MclmCV_Ve_di_Ve_di*qg+inv_MclmCV_Ve_di*qg_Ve_di+inv_MclmCV_Ve_di*qg_Ve_di+inv_MclmCV*qg_Ve_di_Ve_di)+(+(+MclmCV_Ve_di_Ve_di-0.0)*qid+MclmCV_Ve_di*qid_Ve_di+MclmCV_Ve_di*qid_Ve_di+(MclmCV-1.0)*qid_Ve_di_Ve_di));
  qg_Ve_di_Vge_si=(+(+inv_MclmCV_Ve_di_Vge_si*qg+inv_MclmCV_Ve_di*qg_Vge_si+inv_MclmCV_Vge_si*qg_Ve_di+inv_MclmCV*qg_Ve_di_Vge_si)+(+(+MclmCV_Ve_di_Vge_si-0.0)*qid+MclmCV_Ve_di*qid_Vge_si+MclmCV_Vge_si*qid_Ve_di+(MclmCV-1.0)*qid_Ve_di_Vge_si));
  qg_Ve_di_Tempt_GND=(+(+inv_MclmCV_Ve_di_Tempt_GND*qg+inv_MclmCV_Ve_di*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Ve_di+inv_MclmCV*qg_Ve_di_Tempt_GND)+(+(+MclmCV_Ve_di_Tempt_GND-0.0)*qid+MclmCV_Ve_di*qid_Tempt_GND+MclmCV_Tempt_GND*qid_Ve_di+(MclmCV-1.0)*qid_Ve_di_Tempt_GND));
  qg_Ve_di_Vge_e=(+(+inv_MclmCV_Ve_di_Vge_e*qg+inv_MclmCV_Ve_di*qg_Vge_e+inv_MclmCV_Vge_e*qg_Ve_di+inv_MclmCV*qg_Ve_di_Vge_e)+(+(+MclmCV_Ve_di_Vge_e-0.0)*qid+MclmCV_Ve_di*0.0+MclmCV_Vge_e*qid_Ve_di+(MclmCV-1.0)*0.0));
#endif
qg_Vge_si=(((inv_MclmCV_Vge_si*qg)+(inv_MclmCV*qg_Vge_si))+((MclmCV_Vge_si*qid)+((MclmCV-1.0)*qid_Vge_si)));
#if defined(_DERIVATE2)
  qg_Vge_si_Vdi_si=(+(+inv_MclmCV_Vge_si_Vdi_si*qg+inv_MclmCV_Vge_si*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Vge_si+inv_MclmCV*qg_Vge_si_Vdi_si)+(+(+MclmCV_Vge_si_Vdi_si-0.0)*qid+MclmCV_Vge_si*qid_Vdi_si+MclmCV_Vdi_si*qid_Vge_si+(MclmCV-1.0)*qid_Vge_si_Vdi_si));
  qg_Vge_si_Ve_si=(+(+inv_MclmCV_Vge_si_Ve_si*qg+inv_MclmCV_Vge_si*qg_Ve_si+inv_MclmCV_Ve_si*qg_Vge_si+inv_MclmCV*qg_Vge_si_Ve_si)+(+(+MclmCV_Vge_si_Ve_si-0.0)*qid+MclmCV_Vge_si*qid_Ve_si+MclmCV_Ve_si*qid_Vge_si+(MclmCV-1.0)*qid_Vge_si_Ve_si));
  qg_Vge_si_Ve_di=(+(+inv_MclmCV_Vge_si_Ve_di*qg+inv_MclmCV_Vge_si*qg_Ve_di+inv_MclmCV_Ve_di*qg_Vge_si+inv_MclmCV*qg_Vge_si_Ve_di)+(+(+MclmCV_Vge_si_Ve_di-0.0)*qid+MclmCV_Vge_si*qid_Ve_di+MclmCV_Ve_di*qid_Vge_si+(MclmCV-1.0)*qid_Vge_si_Ve_di));
  qg_Vge_si_Vge_si=(+(+inv_MclmCV_Vge_si_Vge_si*qg+inv_MclmCV_Vge_si*qg_Vge_si+inv_MclmCV_Vge_si*qg_Vge_si+inv_MclmCV*qg_Vge_si_Vge_si)+(+(+MclmCV_Vge_si_Vge_si-0.0)*qid+MclmCV_Vge_si*qid_Vge_si+MclmCV_Vge_si*qid_Vge_si+(MclmCV-1.0)*qid_Vge_si_Vge_si));
  qg_Vge_si_Tempt_GND=(+(+inv_MclmCV_Vge_si_Tempt_GND*qg+inv_MclmCV_Vge_si*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Vge_si+inv_MclmCV*qg_Vge_si_Tempt_GND)+(+(+MclmCV_Vge_si_Tempt_GND-0.0)*qid+MclmCV_Vge_si*qid_Tempt_GND+MclmCV_Tempt_GND*qid_Vge_si+(MclmCV-1.0)*qid_Vge_si_Tempt_GND));
  qg_Vge_si_Vge_e=(+(+inv_MclmCV_Vge_si_Vge_e*qg+inv_MclmCV_Vge_si*qg_Vge_e+inv_MclmCV_Vge_e*qg_Vge_si+inv_MclmCV*qg_Vge_si_Vge_e)+(+(+MclmCV_Vge_si_Vge_e-0.0)*qid+MclmCV_Vge_si*0.0+MclmCV_Vge_e*qid_Vge_si+(MclmCV-1.0)*0.0));
#endif
qg_Tempt_GND=(((inv_MclmCV_Tempt_GND*qg)+(inv_MclmCV*qg_Tempt_GND))+((MclmCV_Tempt_GND*qid)+((MclmCV-1.0)*qid_Tempt_GND)));
#if defined(_DERIVATE2)
  qg_Tempt_GND_Vdi_si=(+(+inv_MclmCV_Tempt_GND_Vdi_si*qg+inv_MclmCV_Tempt_GND*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Vdi_si)+(+(+MclmCV_Tempt_GND_Vdi_si-0.0)*qid+MclmCV_Tempt_GND*qid_Vdi_si+MclmCV_Vdi_si*qid_Tempt_GND+(MclmCV-1.0)*qid_Tempt_GND_Vdi_si));
  qg_Tempt_GND_Ve_si=(+(+inv_MclmCV_Tempt_GND_Ve_si*qg+inv_MclmCV_Tempt_GND*qg_Ve_si+inv_MclmCV_Ve_si*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Ve_si)+(+(+MclmCV_Tempt_GND_Ve_si-0.0)*qid+MclmCV_Tempt_GND*qid_Ve_si+MclmCV_Ve_si*qid_Tempt_GND+(MclmCV-1.0)*qid_Tempt_GND_Ve_si));
  qg_Tempt_GND_Ve_di=(+(+inv_MclmCV_Tempt_GND_Ve_di*qg+inv_MclmCV_Tempt_GND*qg_Ve_di+inv_MclmCV_Ve_di*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Ve_di)+(+(+MclmCV_Tempt_GND_Ve_di-0.0)*qid+MclmCV_Tempt_GND*qid_Ve_di+MclmCV_Ve_di*qid_Tempt_GND+(MclmCV-1.0)*qid_Tempt_GND_Ve_di));
  qg_Tempt_GND_Vge_si=(+(+inv_MclmCV_Tempt_GND_Vge_si*qg+inv_MclmCV_Tempt_GND*qg_Vge_si+inv_MclmCV_Vge_si*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Vge_si)+(+(+MclmCV_Tempt_GND_Vge_si-0.0)*qid+MclmCV_Tempt_GND*qid_Vge_si+MclmCV_Vge_si*qid_Tempt_GND+(MclmCV-1.0)*qid_Tempt_GND_Vge_si));
  qg_Tempt_GND_Tempt_GND=(+(+inv_MclmCV_Tempt_GND_Tempt_GND*qg+inv_MclmCV_Tempt_GND*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Tempt_GND)+(+(+MclmCV_Tempt_GND_Tempt_GND-0.0)*qid+MclmCV_Tempt_GND*qid_Tempt_GND+MclmCV_Tempt_GND*qid_Tempt_GND+(MclmCV-1.0)*qid_Tempt_GND_Tempt_GND));
  qg_Tempt_GND_Vge_e=(+(+inv_MclmCV_Tempt_GND_Vge_e*qg+inv_MclmCV_Tempt_GND*qg_Vge_e+inv_MclmCV_Vge_e*qg_Tempt_GND+inv_MclmCV*qg_Tempt_GND_Vge_e)+(+(+MclmCV_Tempt_GND_Vge_e-0.0)*qid+MclmCV_Tempt_GND*0.0+MclmCV_Vge_e*qid_Tempt_GND+(MclmCV-1.0)*0.0));
#endif
qg_Vge_e=(((inv_MclmCV_Vge_e*qg)+(inv_MclmCV*qg_Vge_e))+MclmCV_Vge_e*qid);
#if defined(_DERIVATE2)
  qg_Vge_e_Vdi_si=(+(+inv_MclmCV_Vge_e_Vdi_si*qg+inv_MclmCV_Vge_e*qg_Vdi_si+inv_MclmCV_Vdi_si*qg_Vge_e+inv_MclmCV*qg_Vge_e_Vdi_si)+(+(+MclmCV_Vge_e_Vdi_si-0.0)*qid+MclmCV_Vge_e*qid_Vdi_si+MclmCV_Vdi_si*0.0+(MclmCV-1.0)*0.0));
  qg_Vge_e_Ve_si=(+(+inv_MclmCV_Vge_e_Ve_si*qg+inv_MclmCV_Vge_e*qg_Ve_si+inv_MclmCV_Ve_si*qg_Vge_e+inv_MclmCV*qg_Vge_e_Ve_si)+(+(+MclmCV_Vge_e_Ve_si-0.0)*qid+MclmCV_Vge_e*qid_Ve_si+MclmCV_Ve_si*0.0+(MclmCV-1.0)*0.0));
  qg_Vge_e_Ve_di=(+(+inv_MclmCV_Vge_e_Ve_di*qg+inv_MclmCV_Vge_e*qg_Ve_di+inv_MclmCV_Ve_di*qg_Vge_e+inv_MclmCV*qg_Vge_e_Ve_di)+(+(+MclmCV_Vge_e_Ve_di-0.0)*qid+MclmCV_Vge_e*qid_Ve_di+MclmCV_Ve_di*0.0+(MclmCV-1.0)*0.0));
  qg_Vge_e_Vge_si=(+(+inv_MclmCV_Vge_e_Vge_si*qg+inv_MclmCV_Vge_e*qg_Vge_si+inv_MclmCV_Vge_si*qg_Vge_e+inv_MclmCV*qg_Vge_e_Vge_si)+(+(+MclmCV_Vge_e_Vge_si-0.0)*qid+MclmCV_Vge_e*qid_Vge_si+MclmCV_Vge_si*0.0+(MclmCV-1.0)*0.0));
  qg_Vge_e_Tempt_GND=(+(+inv_MclmCV_Vge_e_Tempt_GND*qg+inv_MclmCV_Vge_e*qg_Tempt_GND+inv_MclmCV_Tempt_GND*qg_Vge_e+inv_MclmCV*qg_Vge_e_Tempt_GND)+(+(+MclmCV_Vge_e_Tempt_GND-0.0)*qid+MclmCV_Vge_e*qid_Tempt_GND+MclmCV_Tempt_GND*0.0+(MclmCV-1.0)*0.0));
  qg_Vge_e_Vge_e=(+(+inv_MclmCV_Vge_e_Vge_e*qg+inv_MclmCV_Vge_e*qg_Vge_e+inv_MclmCV_Vge_e*qg_Vge_e+inv_MclmCV*qg_Vge_e_Vge_e)+(+(+MclmCV_Vge_e_Vge_e-0.0)*qid+MclmCV_Vge_e*0.0+MclmCV_Vge_e*0.0+(MclmCV-1.0)*0.0));
#endif
#endif
qg=((inv_MclmCV*qg)+((MclmCV-1.0)*qid));
EXIT_IF_ISNAN(((inv_MclmCV*qg)+((MclmCV-1.0)*qid)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qd_Vdi_si=(((((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Vdi_si))+(((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid)+((0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si)));
#if defined(_DERIVATE2)
  qd_Vdi_si_Vdi_si=(+(+(+inv_MclmCV_Vdi_si_Vdi_si*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Vdi_si)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Vdi_si-inv_MclmCV_Vdi_si_Vdi_si))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si_Vdi_si));
  qd_Vdi_si_Ve_si=(+(+(+inv_MclmCV_Vdi_si_Ve_si*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Ve_si)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Ve_si-inv_MclmCV_Vdi_si_Ve_si))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si_Ve_si));
  qd_Vdi_si_Ve_di=(+(+(+inv_MclmCV_Vdi_si_Ve_di*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Ve_di)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Ve_di-inv_MclmCV_Vdi_si_Ve_di))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si_Ve_di));
  qd_Vdi_si_Vge_si=(+(+(+inv_MclmCV_Vdi_si_Vge_si*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Vge_si)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Vge_si-inv_MclmCV_Vdi_si_Vge_si))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si_Vge_si));
  qd_Vdi_si_Tempt_GND=(+(+(+inv_MclmCV_Vdi_si_Tempt_GND*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Tempt_GND)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Tempt_GND-inv_MclmCV_Vdi_si_Tempt_GND))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vdi_si_Tempt_GND));
  qd_Vdi_si_Vge_e=(+(+(+inv_MclmCV_Vdi_si_Vge_e*inv_MclmCV+inv_MclmCV_Vdi_si*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Vdi_si+inv_MclmCV*inv_MclmCV_Vdi_si_Vge_e)*qd+((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Vdi_si+(inv_MclmCV*inv_MclmCV)*qd_Vdi_si_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.5*(+MclmCV_Vdi_si_Vge_e-inv_MclmCV_Vdi_si_Vge_e))*qid+(0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*qid_Vdi_si+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
qd_Ve_si=(((((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Ve_si))+(((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid)+((0.5*(MclmCV-inv_MclmCV))*qid_Ve_si)));
#if defined(_DERIVATE2)
  qd_Ve_si_Vdi_si=(+(+(+inv_MclmCV_Ve_si_Vdi_si*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Vdi_si)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Vdi_si-inv_MclmCV_Ve_si_Vdi_si))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_si_Vdi_si));
  qd_Ve_si_Ve_si=(+(+(+inv_MclmCV_Ve_si_Ve_si*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Ve_si)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Ve_si-inv_MclmCV_Ve_si_Ve_si))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_si_Ve_si));
  qd_Ve_si_Ve_di=(+(+(+inv_MclmCV_Ve_si_Ve_di*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Ve_di)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Ve_di-inv_MclmCV_Ve_si_Ve_di))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_si_Ve_di));
  qd_Ve_si_Vge_si=(+(+(+inv_MclmCV_Ve_si_Vge_si*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Vge_si)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Vge_si-inv_MclmCV_Ve_si_Vge_si))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_si_Vge_si));
  qd_Ve_si_Tempt_GND=(+(+(+inv_MclmCV_Ve_si_Tempt_GND*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Tempt_GND)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Tempt_GND-inv_MclmCV_Ve_si_Tempt_GND))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_si_Tempt_GND));
  qd_Ve_si_Vge_e=(+(+(+inv_MclmCV_Ve_si_Vge_e*inv_MclmCV+inv_MclmCV_Ve_si*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Ve_si+inv_MclmCV*inv_MclmCV_Ve_si_Vge_e)*qd+((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Ve_si+(inv_MclmCV*inv_MclmCV)*qd_Ve_si_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.5*(+MclmCV_Ve_si_Vge_e-inv_MclmCV_Ve_si_Vge_e))*qid+(0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*qid_Ve_si+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
qd_Ve_di=(((((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Ve_di))+(((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid)+((0.5*(MclmCV-inv_MclmCV))*qid_Ve_di)));
#if defined(_DERIVATE2)
  qd_Ve_di_Vdi_si=(+(+(+inv_MclmCV_Ve_di_Vdi_si*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Vdi_si)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Vdi_si-inv_MclmCV_Ve_di_Vdi_si))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_di_Vdi_si));
  qd_Ve_di_Ve_si=(+(+(+inv_MclmCV_Ve_di_Ve_si*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Ve_si)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Ve_si-inv_MclmCV_Ve_di_Ve_si))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_di_Ve_si));
  qd_Ve_di_Ve_di=(+(+(+inv_MclmCV_Ve_di_Ve_di*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Ve_di)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Ve_di-inv_MclmCV_Ve_di_Ve_di))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_di_Ve_di));
  qd_Ve_di_Vge_si=(+(+(+inv_MclmCV_Ve_di_Vge_si*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Vge_si)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Vge_si-inv_MclmCV_Ve_di_Vge_si))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_di_Vge_si));
  qd_Ve_di_Tempt_GND=(+(+(+inv_MclmCV_Ve_di_Tempt_GND*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Tempt_GND)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Tempt_GND-inv_MclmCV_Ve_di_Tempt_GND))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*qid_Ve_di_Tempt_GND));
  qd_Ve_di_Vge_e=(+(+(+inv_MclmCV_Ve_di_Vge_e*inv_MclmCV+inv_MclmCV_Ve_di*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Ve_di+inv_MclmCV*inv_MclmCV_Ve_di_Vge_e)*qd+((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Ve_di+(inv_MclmCV*inv_MclmCV)*qd_Ve_di_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.5*(+MclmCV_Ve_di_Vge_e-inv_MclmCV_Ve_di_Vge_e))*qid+(0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*qid_Ve_di+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
qd_Vge_si=(((((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Vge_si))+(((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid)+((0.5*(MclmCV-inv_MclmCV))*qid_Vge_si)));
#if defined(_DERIVATE2)
  qd_Vge_si_Vdi_si=(+(+(+inv_MclmCV_Vge_si_Vdi_si*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Vdi_si)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Vdi_si-inv_MclmCV_Vge_si_Vdi_si))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vge_si_Vdi_si));
  qd_Vge_si_Ve_si=(+(+(+inv_MclmCV_Vge_si_Ve_si*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Ve_si)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Ve_si-inv_MclmCV_Vge_si_Ve_si))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vge_si_Ve_si));
  qd_Vge_si_Ve_di=(+(+(+inv_MclmCV_Vge_si_Ve_di*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Ve_di)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Ve_di-inv_MclmCV_Vge_si_Ve_di))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vge_si_Ve_di));
  qd_Vge_si_Vge_si=(+(+(+inv_MclmCV_Vge_si_Vge_si*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Vge_si)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Vge_si-inv_MclmCV_Vge_si_Vge_si))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vge_si_Vge_si));
  qd_Vge_si_Tempt_GND=(+(+(+inv_MclmCV_Vge_si_Tempt_GND*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Tempt_GND)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Tempt_GND-inv_MclmCV_Vge_si_Tempt_GND))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*qid_Vge_si_Tempt_GND));
  qd_Vge_si_Vge_e=(+(+(+inv_MclmCV_Vge_si_Vge_e*inv_MclmCV+inv_MclmCV_Vge_si*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Vge_si+inv_MclmCV*inv_MclmCV_Vge_si_Vge_e)*qd+((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Vge_si+(inv_MclmCV*inv_MclmCV)*qd_Vge_si_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.5*(+MclmCV_Vge_si_Vge_e-inv_MclmCV_Vge_si_Vge_e))*qid+(0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*qid_Vge_si+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
qd_Tempt_GND=(((((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Tempt_GND))+(((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid)+((0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND)));
#if defined(_DERIVATE2)
  qd_Tempt_GND_Vdi_si=(+(+(+inv_MclmCV_Tempt_GND_Vdi_si*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Vdi_si)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Vdi_si-inv_MclmCV_Tempt_GND_Vdi_si))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND_Vdi_si));
  qd_Tempt_GND_Ve_si=(+(+(+inv_MclmCV_Tempt_GND_Ve_si*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Ve_si)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Ve_si-inv_MclmCV_Tempt_GND_Ve_si))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND_Ve_si));
  qd_Tempt_GND_Ve_di=(+(+(+inv_MclmCV_Tempt_GND_Ve_di*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Ve_di)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Ve_di-inv_MclmCV_Tempt_GND_Ve_di))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND_Ve_di));
  qd_Tempt_GND_Vge_si=(+(+(+inv_MclmCV_Tempt_GND_Vge_si*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Vge_si)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Vge_si-inv_MclmCV_Tempt_GND_Vge_si))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND_Vge_si));
  qd_Tempt_GND_Tempt_GND=(+(+(+inv_MclmCV_Tempt_GND_Tempt_GND*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Tempt_GND)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Tempt_GND-inv_MclmCV_Tempt_GND_Tempt_GND))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*qid_Tempt_GND_Tempt_GND));
  qd_Tempt_GND_Vge_e=(+(+(+inv_MclmCV_Tempt_GND_Vge_e*inv_MclmCV+inv_MclmCV_Tempt_GND*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Tempt_GND+inv_MclmCV*inv_MclmCV_Tempt_GND_Vge_e)*qd+((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Tempt_GND+(inv_MclmCV*inv_MclmCV)*qd_Tempt_GND_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.5*(+MclmCV_Tempt_GND_Vge_e-inv_MclmCV_Tempt_GND_Vge_e))*qid+(0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*qid_Tempt_GND+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
qd_Vge_e=(((((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd)+((inv_MclmCV*inv_MclmCV)*qd_Vge_e))+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid);
#if defined(_DERIVATE2)
  qd_Vge_e_Vdi_si=(+(+(+inv_MclmCV_Vge_e_Vdi_si*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Vdi_si+inv_MclmCV_Vdi_si*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Vdi_si)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Vdi_si+(((inv_MclmCV_Vdi_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vdi_si)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Vdi_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Vdi_si-inv_MclmCV_Vge_e_Vdi_si))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid_Vdi_si+((0.5*(MclmCV_Vdi_si-inv_MclmCV_Vdi_si)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
  qd_Vge_e_Ve_si=(+(+(+inv_MclmCV_Vge_e_Ve_si*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Ve_si+inv_MclmCV_Ve_si*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Ve_si)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Ve_si+(((inv_MclmCV_Ve_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_si)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Ve_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_si-inv_MclmCV_Ve_si)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Ve_si-inv_MclmCV_Vge_e_Ve_si))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid_Ve_si+((0.5*(MclmCV_Ve_si-inv_MclmCV_Ve_si)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
  qd_Vge_e_Ve_di=(+(+(+inv_MclmCV_Vge_e_Ve_di*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Ve_di+inv_MclmCV_Ve_di*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Ve_di)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Ve_di+(((inv_MclmCV_Ve_di*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Ve_di)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Ve_di)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Ve_di-inv_MclmCV_Ve_di)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Ve_di-inv_MclmCV_Vge_e_Ve_di))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid_Ve_di+((0.5*(MclmCV_Ve_di-inv_MclmCV_Ve_di)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
  qd_Vge_e_Vge_si=(+(+(+inv_MclmCV_Vge_e_Vge_si*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Vge_si+inv_MclmCV_Vge_si*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Vge_si)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Vge_si+(((inv_MclmCV_Vge_si*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_si)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Vge_si)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_si-inv_MclmCV_Vge_si)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Vge_si-inv_MclmCV_Vge_e_Vge_si))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid_Vge_si+((0.5*(MclmCV_Vge_si-inv_MclmCV_Vge_si)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
  qd_Vge_e_Tempt_GND=(+(+(+inv_MclmCV_Vge_e_Tempt_GND*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Tempt_GND+inv_MclmCV_Tempt_GND*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Tempt_GND)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Tempt_GND+(((inv_MclmCV_Tempt_GND*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Tempt_GND)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Tempt_GND)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Tempt_GND-inv_MclmCV_Vge_e_Tempt_GND))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*qid_Tempt_GND+((0.5*(MclmCV_Tempt_GND-inv_MclmCV_Tempt_GND)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
  qd_Vge_e_Vge_e=(+(+(+inv_MclmCV_Vge_e_Vge_e*inv_MclmCV+inv_MclmCV_Vge_e*inv_MclmCV_Vge_e+inv_MclmCV_Vge_e*inv_MclmCV_Vge_e+inv_MclmCV*inv_MclmCV_Vge_e_Vge_e)*qd+((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e))*qd_Vge_e+(((inv_MclmCV_Vge_e*inv_MclmCV)+(inv_MclmCV*inv_MclmCV_Vge_e)))*qd_Vge_e+(inv_MclmCV*inv_MclmCV)*qd_Vge_e_Vge_e)+(+(+0.0*(MclmCV-inv_MclmCV)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.0*(MclmCV_Vge_e-inv_MclmCV_Vge_e)+0.5*(+MclmCV_Vge_e_Vge_e-inv_MclmCV_Vge_e_Vge_e))*qid+(0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e))*0.0+((0.5*(MclmCV_Vge_e-inv_MclmCV_Vge_e)))*0.0+(0.5*(MclmCV-inv_MclmCV))*0.0));
#endif
#endif
qd=(((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid));
EXIT_IF_ISNAN((((inv_MclmCV*inv_MclmCV)*qd)+((0.5*(MclmCV-inv_MclmCV))*qid)))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qs_Vge_di=0.0;
#if defined(_DERIVATE2)
  qs_Vge_di_Vge_di=0.0;
  qs_Vge_di_Vdi_si=0.0;
  qs_Vge_di_Ve_si=0.0;
  qs_Vge_di_Ve_di=0.0;
  qs_Vge_di_Vge_si=0.0;
  qs_Vge_di_Tempt_GND=0.0;
  qs_Vge_di_Vge_e=0.0;
#endif
qs_Vdi_si=((-qg_Vdi_si)-qd_Vdi_si);
#if defined(_DERIVATE2)
  qs_Vdi_si_Vge_di=(+0.0-0.0);
  qs_Vdi_si_Vdi_si=(+0.0-qd_Vdi_si_Vdi_si);
  qs_Vdi_si_Ve_si=(+0.0-qd_Vdi_si_Ve_si);
  qs_Vdi_si_Ve_di=(+0.0-qd_Vdi_si_Ve_di);
  qs_Vdi_si_Vge_si=(+0.0-qd_Vdi_si_Vge_si);
  qs_Vdi_si_Tempt_GND=(+0.0-qd_Vdi_si_Tempt_GND);
  qs_Vdi_si_Vge_e=(+0.0-qd_Vdi_si_Vge_e);
#endif
qs_Ve_si=((-qg_Ve_si)-qd_Ve_si);
#if defined(_DERIVATE2)
  qs_Ve_si_Vge_di=(+0.0-0.0);
  qs_Ve_si_Vdi_si=(+0.0-qd_Ve_si_Vdi_si);
  qs_Ve_si_Ve_si=(+0.0-qd_Ve_si_Ve_si);
  qs_Ve_si_Ve_di=(+0.0-qd_Ve_si_Ve_di);
  qs_Ve_si_Vge_si=(+0.0-qd_Ve_si_Vge_si);
  qs_Ve_si_Tempt_GND=(+0.0-qd_Ve_si_Tempt_GND);
  qs_Ve_si_Vge_e=(+0.0-qd_Ve_si_Vge_e);
#endif
qs_Ve_di=((-qg_Ve_di)-qd_Ve_di);
#if defined(_DERIVATE2)
  qs_Ve_di_Vge_di=(+0.0-0.0);
  qs_Ve_di_Vdi_si=(+0.0-qd_Ve_di_Vdi_si);
  qs_Ve_di_Ve_si=(+0.0-qd_Ve_di_Ve_si);
  qs_Ve_di_Ve_di=(+0.0-qd_Ve_di_Ve_di);
  qs_Ve_di_Vge_si=(+0.0-qd_Ve_di_Vge_si);
  qs_Ve_di_Tempt_GND=(+0.0-qd_Ve_di_Tempt_GND);
  qs_Ve_di_Vge_e=(+0.0-qd_Ve_di_Vge_e);
#endif
qs_Vge_si=((-qg_Vge_si)-qd_Vge_si);
#if defined(_DERIVATE2)
  qs_Vge_si_Vge_di=(+0.0-0.0);
  qs_Vge_si_Vdi_si=(+0.0-qd_Vge_si_Vdi_si);
  qs_Vge_si_Ve_si=(+0.0-qd_Vge_si_Ve_si);
  qs_Vge_si_Ve_di=(+0.0-qd_Vge_si_Ve_di);
  qs_Vge_si_Vge_si=(+0.0-qd_Vge_si_Vge_si);
  qs_Vge_si_Tempt_GND=(+0.0-qd_Vge_si_Tempt_GND);
  qs_Vge_si_Vge_e=(+0.0-qd_Vge_si_Vge_e);
#endif
qs_Tempt_GND=((-qg_Tempt_GND)-qd_Tempt_GND);
#if defined(_DERIVATE2)
  qs_Tempt_GND_Vge_di=(+0.0-0.0);
  qs_Tempt_GND_Vdi_si=(+0.0-qd_Tempt_GND_Vdi_si);
  qs_Tempt_GND_Ve_si=(+0.0-qd_Tempt_GND_Ve_si);
  qs_Tempt_GND_Ve_di=(+0.0-qd_Tempt_GND_Ve_di);
  qs_Tempt_GND_Vge_si=(+0.0-qd_Tempt_GND_Vge_si);
  qs_Tempt_GND_Tempt_GND=(+0.0-qd_Tempt_GND_Tempt_GND);
  qs_Tempt_GND_Vge_e=(+0.0-qd_Tempt_GND_Vge_e);
#endif
qs_Vge_e=((-qg_Vge_e)-qd_Vge_e);
#if defined(_DERIVATE2)
  qs_Vge_e_Vge_di=(+0.0-0.0);
  qs_Vge_e_Vdi_si=(+0.0-qd_Vge_e_Vdi_si);
  qs_Vge_e_Ve_si=(+0.0-qd_Vge_e_Ve_si);
  qs_Vge_e_Ve_di=(+0.0-qd_Vge_e_Ve_di);
  qs_Vge_e_Vge_si=(+0.0-qd_Vge_e_Vge_si);
  qs_Vge_e_Tempt_GND=(+0.0-qd_Vge_e_Tempt_GND);
  qs_Vge_e_Vge_e=(+0.0-qd_Vge_e_Vge_e);
#endif
#endif
qs=((-qg)-qd);
EXIT_IF_ISNAN(((-qg)-qd))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e);
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_e_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_e_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_e_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Vge_e);
  T6_Vge_e_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Vdi_si);
  T6_Vge_e_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Tempt_GND);
  T6_Vge_e_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Ve_si);
  T6_Vge_e_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Ve_di);
  T6_Vge_e_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Vge_e+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_e_Vge_si);
#endif
T6_Vdi_si=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si);
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vdi_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vdi_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vdi_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Vge_e);
  T6_Vdi_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Vdi_si);
  T6_Vdi_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Tempt_GND);
  T6_Vdi_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Ve_si);
  T6_Vdi_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Ve_di);
  T6_Vdi_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Vdi_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vdi_si_Vge_si);
#endif
T6_Tempt_GND=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND);
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Tempt_GND_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Tempt_GND_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Tempt_GND_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Vge_e);
  T6_Tempt_GND_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Vdi_si);
  T6_Tempt_GND_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Tempt_GND);
  T6_Tempt_GND_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Ve_si);
  T6_Tempt_GND_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Ve_di);
  T6_Tempt_GND_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Tempt_GND_Vge_si);
#endif
T6_Ve_si=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si);
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Vge_e);
  T6_Ve_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Vdi_si);
  T6_Ve_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Tempt_GND);
  T6_Ve_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Ve_si);
  T6_Ve_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Ve_di);
  T6_Ve_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Ve_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_si_Vge_si);
#endif
T6_Ve_di=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di);
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_di_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_di_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Ve_di_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Vge_e);
  T6_Ve_di_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Vdi_si);
  T6_Ve_di_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Tempt_GND);
  T6_Ve_di_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Ve_si);
  T6_Ve_di_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Ve_di);
  T6_Ve_di_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Ve_di+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Ve_di_Vge_si);
#endif
T6_Vge_si=(((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si);
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*0.0+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*0.0);
  T6_Vge_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_e+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Vge_e);
  T6_Vge_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vdi_si+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Vdi_si);
  T6_Vge_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Tempt_GND+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Tempt_GND);
  T6_Vge_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_si+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Ve_si);
  T6_Vge_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Ve_di+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Ve_di);
  T6_Vge_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*coxeff+0.0*coxeff_Vge_si+((0.0)*LeffCV)*coxeff_Vge_si+((NFINtotal*WeffCV0)*LeffCV)*coxeff_Vge_si_Vge_si);
#endif
#endif
T6=(((NFINtotal*WeffCV0)*LeffCV)*coxeff);
EXIT_IF_ISNAN((((NFINtotal*WeffCV0)*LeffCV)*coxeff))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_Vdi_si=((T6_Vdi_si*qg)+(T6*qg_Vdi_si));
#if defined(_DERIVATE2)
  qg_Vdi_si_Vdi_si=(+T6_Vdi_si_Vdi_si*qg+T6_Vdi_si*qg_Vdi_si+T6_Vdi_si*qg_Vdi_si+T6*qg_Vdi_si_Vdi_si);
  qg_Vdi_si_Ve_si=(+T6_Vdi_si_Ve_si*qg+T6_Vdi_si*qg_Ve_si+T6_Ve_si*qg_Vdi_si+T6*qg_Vdi_si_Ve_si);
  qg_Vdi_si_Ve_di=(+T6_Vdi_si_Ve_di*qg+T6_Vdi_si*qg_Ve_di+T6_Ve_di*qg_Vdi_si+T6*qg_Vdi_si_Ve_di);
  qg_Vdi_si_Vge_si=(+T6_Vdi_si_Vge_si*qg+T6_Vdi_si*qg_Vge_si+T6_Vge_si*qg_Vdi_si+T6*qg_Vdi_si_Vge_si);
  qg_Vdi_si_Tempt_GND=(+T6_Vdi_si_Tempt_GND*qg+T6_Vdi_si*qg_Tempt_GND+T6_Tempt_GND*qg_Vdi_si+T6*qg_Vdi_si_Tempt_GND);
  qg_Vdi_si_Vge_e=(+T6_Vdi_si_Vge_e*qg+T6_Vdi_si*qg_Vge_e+T6_Vge_e*qg_Vdi_si+T6*qg_Vdi_si_Vge_e);
#endif
qg_Ve_si=((T6_Ve_si*qg)+(T6*qg_Ve_si));
#if defined(_DERIVATE2)
  qg_Ve_si_Vdi_si=(+T6_Ve_si_Vdi_si*qg+T6_Ve_si*qg_Vdi_si+T6_Vdi_si*qg_Ve_si+T6*qg_Ve_si_Vdi_si);
  qg_Ve_si_Ve_si=(+T6_Ve_si_Ve_si*qg+T6_Ve_si*qg_Ve_si+T6_Ve_si*qg_Ve_si+T6*qg_Ve_si_Ve_si);
  qg_Ve_si_Ve_di=(+T6_Ve_si_Ve_di*qg+T6_Ve_si*qg_Ve_di+T6_Ve_di*qg_Ve_si+T6*qg_Ve_si_Ve_di);
  qg_Ve_si_Vge_si=(+T6_Ve_si_Vge_si*qg+T6_Ve_si*qg_Vge_si+T6_Vge_si*qg_Ve_si+T6*qg_Ve_si_Vge_si);
  qg_Ve_si_Tempt_GND=(+T6_Ve_si_Tempt_GND*qg+T6_Ve_si*qg_Tempt_GND+T6_Tempt_GND*qg_Ve_si+T6*qg_Ve_si_Tempt_GND);
  qg_Ve_si_Vge_e=(+T6_Ve_si_Vge_e*qg+T6_Ve_si*qg_Vge_e+T6_Vge_e*qg_Ve_si+T6*qg_Ve_si_Vge_e);
#endif
qg_Ve_di=((T6_Ve_di*qg)+(T6*qg_Ve_di));
#if defined(_DERIVATE2)
  qg_Ve_di_Vdi_si=(+T6_Ve_di_Vdi_si*qg+T6_Ve_di*qg_Vdi_si+T6_Vdi_si*qg_Ve_di+T6*qg_Ve_di_Vdi_si);
  qg_Ve_di_Ve_si=(+T6_Ve_di_Ve_si*qg+T6_Ve_di*qg_Ve_si+T6_Ve_si*qg_Ve_di+T6*qg_Ve_di_Ve_si);
  qg_Ve_di_Ve_di=(+T6_Ve_di_Ve_di*qg+T6_Ve_di*qg_Ve_di+T6_Ve_di*qg_Ve_di+T6*qg_Ve_di_Ve_di);
  qg_Ve_di_Vge_si=(+T6_Ve_di_Vge_si*qg+T6_Ve_di*qg_Vge_si+T6_Vge_si*qg_Ve_di+T6*qg_Ve_di_Vge_si);
  qg_Ve_di_Tempt_GND=(+T6_Ve_di_Tempt_GND*qg+T6_Ve_di*qg_Tempt_GND+T6_Tempt_GND*qg_Ve_di+T6*qg_Ve_di_Tempt_GND);
  qg_Ve_di_Vge_e=(+T6_Ve_di_Vge_e*qg+T6_Ve_di*qg_Vge_e+T6_Vge_e*qg_Ve_di+T6*qg_Ve_di_Vge_e);
#endif
qg_Vge_si=((T6_Vge_si*qg)+(T6*qg_Vge_si));
#if defined(_DERIVATE2)
  qg_Vge_si_Vdi_si=(+T6_Vge_si_Vdi_si*qg+T6_Vge_si*qg_Vdi_si+T6_Vdi_si*qg_Vge_si+T6*qg_Vge_si_Vdi_si);
  qg_Vge_si_Ve_si=(+T6_Vge_si_Ve_si*qg+T6_Vge_si*qg_Ve_si+T6_Ve_si*qg_Vge_si+T6*qg_Vge_si_Ve_si);
  qg_Vge_si_Ve_di=(+T6_Vge_si_Ve_di*qg+T6_Vge_si*qg_Ve_di+T6_Ve_di*qg_Vge_si+T6*qg_Vge_si_Ve_di);
  qg_Vge_si_Vge_si=(+T6_Vge_si_Vge_si*qg+T6_Vge_si*qg_Vge_si+T6_Vge_si*qg_Vge_si+T6*qg_Vge_si_Vge_si);
  qg_Vge_si_Tempt_GND=(+T6_Vge_si_Tempt_GND*qg+T6_Vge_si*qg_Tempt_GND+T6_Tempt_GND*qg_Vge_si+T6*qg_Vge_si_Tempt_GND);
  qg_Vge_si_Vge_e=(+T6_Vge_si_Vge_e*qg+T6_Vge_si*qg_Vge_e+T6_Vge_e*qg_Vge_si+T6*qg_Vge_si_Vge_e);
#endif
qg_Tempt_GND=((T6_Tempt_GND*qg)+(T6*qg_Tempt_GND));
#if defined(_DERIVATE2)
  qg_Tempt_GND_Vdi_si=(+T6_Tempt_GND_Vdi_si*qg+T6_Tempt_GND*qg_Vdi_si+T6_Vdi_si*qg_Tempt_GND+T6*qg_Tempt_GND_Vdi_si);
  qg_Tempt_GND_Ve_si=(+T6_Tempt_GND_Ve_si*qg+T6_Tempt_GND*qg_Ve_si+T6_Ve_si*qg_Tempt_GND+T6*qg_Tempt_GND_Ve_si);
  qg_Tempt_GND_Ve_di=(+T6_Tempt_GND_Ve_di*qg+T6_Tempt_GND*qg_Ve_di+T6_Ve_di*qg_Tempt_GND+T6*qg_Tempt_GND_Ve_di);
  qg_Tempt_GND_Vge_si=(+T6_Tempt_GND_Vge_si*qg+T6_Tempt_GND*qg_Vge_si+T6_Vge_si*qg_Tempt_GND+T6*qg_Tempt_GND_Vge_si);
  qg_Tempt_GND_Tempt_GND=(+T6_Tempt_GND_Tempt_GND*qg+T6_Tempt_GND*qg_Tempt_GND+T6_Tempt_GND*qg_Tempt_GND+T6*qg_Tempt_GND_Tempt_GND);
  qg_Tempt_GND_Vge_e=(+T6_Tempt_GND_Vge_e*qg+T6_Tempt_GND*qg_Vge_e+T6_Vge_e*qg_Tempt_GND+T6*qg_Tempt_GND_Vge_e);
#endif
qg_Vge_e=((T6_Vge_e*qg)+(T6*qg_Vge_e));
#if defined(_DERIVATE2)
  qg_Vge_e_Vdi_si=(+T6_Vge_e_Vdi_si*qg+T6_Vge_e*qg_Vdi_si+T6_Vdi_si*qg_Vge_e+T6*qg_Vge_e_Vdi_si);
  qg_Vge_e_Ve_si=(+T6_Vge_e_Ve_si*qg+T6_Vge_e*qg_Ve_si+T6_Ve_si*qg_Vge_e+T6*qg_Vge_e_Ve_si);
  qg_Vge_e_Ve_di=(+T6_Vge_e_Ve_di*qg+T6_Vge_e*qg_Ve_di+T6_Ve_di*qg_Vge_e+T6*qg_Vge_e_Ve_di);
  qg_Vge_e_Vge_si=(+T6_Vge_e_Vge_si*qg+T6_Vge_e*qg_Vge_si+T6_Vge_si*qg_Vge_e+T6*qg_Vge_e_Vge_si);
  qg_Vge_e_Tempt_GND=(+T6_Vge_e_Tempt_GND*qg+T6_Vge_e*qg_Tempt_GND+T6_Tempt_GND*qg_Vge_e+T6*qg_Vge_e_Tempt_GND);
  qg_Vge_e_Vge_e=(+T6_Vge_e_Vge_e*qg+T6_Vge_e*qg_Vge_e+T6_Vge_e*qg_Vge_e+T6*qg_Vge_e_Vge_e);
#endif
#endif
qg=(T6*qg);
EXIT_IF_ISNAN((T6*qg))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qd_Vdi_si=((T6_Vdi_si*qd)+(T6*qd_Vdi_si));
#if defined(_DERIVATE2)
  qd_Vdi_si_Vdi_si=(+T6_Vdi_si_Vdi_si*qd+T6_Vdi_si*qd_Vdi_si+T6_Vdi_si*qd_Vdi_si+T6*qd_Vdi_si_Vdi_si);
  qd_Vdi_si_Ve_si=(+T6_Vdi_si_Ve_si*qd+T6_Vdi_si*qd_Ve_si+T6_Ve_si*qd_Vdi_si+T6*qd_Vdi_si_Ve_si);
  qd_Vdi_si_Ve_di=(+T6_Vdi_si_Ve_di*qd+T6_Vdi_si*qd_Ve_di+T6_Ve_di*qd_Vdi_si+T6*qd_Vdi_si_Ve_di);
  qd_Vdi_si_Vge_si=(+T6_Vdi_si_Vge_si*qd+T6_Vdi_si*qd_Vge_si+T6_Vge_si*qd_Vdi_si+T6*qd_Vdi_si_Vge_si);
  qd_Vdi_si_Tempt_GND=(+T6_Vdi_si_Tempt_GND*qd+T6_Vdi_si*qd_Tempt_GND+T6_Tempt_GND*qd_Vdi_si+T6*qd_Vdi_si_Tempt_GND);
  qd_Vdi_si_Vge_e=(+T6_Vdi_si_Vge_e*qd+T6_Vdi_si*qd_Vge_e+T6_Vge_e*qd_Vdi_si+T6*qd_Vdi_si_Vge_e);
#endif
qd_Ve_si=((T6_Ve_si*qd)+(T6*qd_Ve_si));
#if defined(_DERIVATE2)
  qd_Ve_si_Vdi_si=(+T6_Ve_si_Vdi_si*qd+T6_Ve_si*qd_Vdi_si+T6_Vdi_si*qd_Ve_si+T6*qd_Ve_si_Vdi_si);
  qd_Ve_si_Ve_si=(+T6_Ve_si_Ve_si*qd+T6_Ve_si*qd_Ve_si+T6_Ve_si*qd_Ve_si+T6*qd_Ve_si_Ve_si);
  qd_Ve_si_Ve_di=(+T6_Ve_si_Ve_di*qd+T6_Ve_si*qd_Ve_di+T6_Ve_di*qd_Ve_si+T6*qd_Ve_si_Ve_di);
  qd_Ve_si_Vge_si=(+T6_Ve_si_Vge_si*qd+T6_Ve_si*qd_Vge_si+T6_Vge_si*qd_Ve_si+T6*qd_Ve_si_Vge_si);
  qd_Ve_si_Tempt_GND=(+T6_Ve_si_Tempt_GND*qd+T6_Ve_si*qd_Tempt_GND+T6_Tempt_GND*qd_Ve_si+T6*qd_Ve_si_Tempt_GND);
  qd_Ve_si_Vge_e=(+T6_Ve_si_Vge_e*qd+T6_Ve_si*qd_Vge_e+T6_Vge_e*qd_Ve_si+T6*qd_Ve_si_Vge_e);
#endif
qd_Ve_di=((T6_Ve_di*qd)+(T6*qd_Ve_di));
#if defined(_DERIVATE2)
  qd_Ve_di_Vdi_si=(+T6_Ve_di_Vdi_si*qd+T6_Ve_di*qd_Vdi_si+T6_Vdi_si*qd_Ve_di+T6*qd_Ve_di_Vdi_si);
  qd_Ve_di_Ve_si=(+T6_Ve_di_Ve_si*qd+T6_Ve_di*qd_Ve_si+T6_Ve_si*qd_Ve_di+T6*qd_Ve_di_Ve_si);
  qd_Ve_di_Ve_di=(+T6_Ve_di_Ve_di*qd+T6_Ve_di*qd_Ve_di+T6_Ve_di*qd_Ve_di+T6*qd_Ve_di_Ve_di);
  qd_Ve_di_Vge_si=(+T6_Ve_di_Vge_si*qd+T6_Ve_di*qd_Vge_si+T6_Vge_si*qd_Ve_di+T6*qd_Ve_di_Vge_si);
  qd_Ve_di_Tempt_GND=(+T6_Ve_di_Tempt_GND*qd+T6_Ve_di*qd_Tempt_GND+T6_Tempt_GND*qd_Ve_di+T6*qd_Ve_di_Tempt_GND);
  qd_Ve_di_Vge_e=(+T6_Ve_di_Vge_e*qd+T6_Ve_di*qd_Vge_e+T6_Vge_e*qd_Ve_di+T6*qd_Ve_di_Vge_e);
#endif
qd_Vge_si=((T6_Vge_si*qd)+(T6*qd_Vge_si));
#if defined(_DERIVATE2)
  qd_Vge_si_Vdi_si=(+T6_Vge_si_Vdi_si*qd+T6_Vge_si*qd_Vdi_si+T6_Vdi_si*qd_Vge_si+T6*qd_Vge_si_Vdi_si);
  qd_Vge_si_Ve_si=(+T6_Vge_si_Ve_si*qd+T6_Vge_si*qd_Ve_si+T6_Ve_si*qd_Vge_si+T6*qd_Vge_si_Ve_si);
  qd_Vge_si_Ve_di=(+T6_Vge_si_Ve_di*qd+T6_Vge_si*qd_Ve_di+T6_Ve_di*qd_Vge_si+T6*qd_Vge_si_Ve_di);
  qd_Vge_si_Vge_si=(+T6_Vge_si_Vge_si*qd+T6_Vge_si*qd_Vge_si+T6_Vge_si*qd_Vge_si+T6*qd_Vge_si_Vge_si);
  qd_Vge_si_Tempt_GND=(+T6_Vge_si_Tempt_GND*qd+T6_Vge_si*qd_Tempt_GND+T6_Tempt_GND*qd_Vge_si+T6*qd_Vge_si_Tempt_GND);
  qd_Vge_si_Vge_e=(+T6_Vge_si_Vge_e*qd+T6_Vge_si*qd_Vge_e+T6_Vge_e*qd_Vge_si+T6*qd_Vge_si_Vge_e);
#endif
qd_Tempt_GND=((T6_Tempt_GND*qd)+(T6*qd_Tempt_GND));
#if defined(_DERIVATE2)
  qd_Tempt_GND_Vdi_si=(+T6_Tempt_GND_Vdi_si*qd+T6_Tempt_GND*qd_Vdi_si+T6_Vdi_si*qd_Tempt_GND+T6*qd_Tempt_GND_Vdi_si);
  qd_Tempt_GND_Ve_si=(+T6_Tempt_GND_Ve_si*qd+T6_Tempt_GND*qd_Ve_si+T6_Ve_si*qd_Tempt_GND+T6*qd_Tempt_GND_Ve_si);
  qd_Tempt_GND_Ve_di=(+T6_Tempt_GND_Ve_di*qd+T6_Tempt_GND*qd_Ve_di+T6_Ve_di*qd_Tempt_GND+T6*qd_Tempt_GND_Ve_di);
  qd_Tempt_GND_Vge_si=(+T6_Tempt_GND_Vge_si*qd+T6_Tempt_GND*qd_Vge_si+T6_Vge_si*qd_Tempt_GND+T6*qd_Tempt_GND_Vge_si);
  qd_Tempt_GND_Tempt_GND=(+T6_Tempt_GND_Tempt_GND*qd+T6_Tempt_GND*qd_Tempt_GND+T6_Tempt_GND*qd_Tempt_GND+T6*qd_Tempt_GND_Tempt_GND);
  qd_Tempt_GND_Vge_e=(+T6_Tempt_GND_Vge_e*qd+T6_Tempt_GND*qd_Vge_e+T6_Vge_e*qd_Tempt_GND+T6*qd_Tempt_GND_Vge_e);
#endif
qd_Vge_e=((T6_Vge_e*qd)+(T6*qd_Vge_e));
#if defined(_DERIVATE2)
  qd_Vge_e_Vdi_si=(+T6_Vge_e_Vdi_si*qd+T6_Vge_e*qd_Vdi_si+T6_Vdi_si*qd_Vge_e+T6*qd_Vge_e_Vdi_si);
  qd_Vge_e_Ve_si=(+T6_Vge_e_Ve_si*qd+T6_Vge_e*qd_Ve_si+T6_Ve_si*qd_Vge_e+T6*qd_Vge_e_Ve_si);
  qd_Vge_e_Ve_di=(+T6_Vge_e_Ve_di*qd+T6_Vge_e*qd_Ve_di+T6_Ve_di*qd_Vge_e+T6*qd_Vge_e_Ve_di);
  qd_Vge_e_Vge_si=(+T6_Vge_e_Vge_si*qd+T6_Vge_e*qd_Vge_si+T6_Vge_si*qd_Vge_e+T6*qd_Vge_e_Vge_si);
  qd_Vge_e_Tempt_GND=(+T6_Vge_e_Tempt_GND*qd+T6_Vge_e*qd_Tempt_GND+T6_Tempt_GND*qd_Vge_e+T6*qd_Vge_e_Tempt_GND);
  qd_Vge_e_Vge_e=(+T6_Vge_e_Vge_e*qd+T6_Vge_e*qd_Vge_e+T6_Vge_e*qd_Vge_e+T6*qd_Vge_e_Vge_e);
#endif
#endif
qd=(T6*qd);
EXIT_IF_ISNAN((T6*qd))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qs_Vge_di=0.0;
#if defined(_DERIVATE2)
  qs_Vge_di_Vge_di=0.0;
  qs_Vge_di_Vdi_si=0.0;
  qs_Vge_di_Ve_si=0.0;
  qs_Vge_di_Ve_di=0.0;
  qs_Vge_di_Vge_si=0.0;
  qs_Vge_di_Tempt_GND=0.0;
  qs_Vge_di_Vge_e=0.0;
#endif
qs_Vdi_si=((T6_Vdi_si*qs)+(T6*qs_Vdi_si));
#if defined(_DERIVATE2)
  qs_Vdi_si_Vge_di=(+T6_Vdi_si_Vge_di*qs+T6_Vdi_si*qs_Vge_di+T6_Vge_di*qs_Vdi_si+T6*qs_Vdi_si_Vge_di);
  qs_Vdi_si_Vdi_si=(+T6_Vdi_si_Vdi_si*qs+T6_Vdi_si*qs_Vdi_si+T6_Vdi_si*qs_Vdi_si+T6*qs_Vdi_si_Vdi_si);
  qs_Vdi_si_Ve_si=(+T6_Vdi_si_Ve_si*qs+T6_Vdi_si*qs_Ve_si+T6_Ve_si*qs_Vdi_si+T6*qs_Vdi_si_Ve_si);
  qs_Vdi_si_Ve_di=(+T6_Vdi_si_Ve_di*qs+T6_Vdi_si*qs_Ve_di+T6_Ve_di*qs_Vdi_si+T6*qs_Vdi_si_Ve_di);
  qs_Vdi_si_Vge_si=(+T6_Vdi_si_Vge_si*qs+T6_Vdi_si*qs_Vge_si+T6_Vge_si*qs_Vdi_si+T6*qs_Vdi_si_Vge_si);
  qs_Vdi_si_Tempt_GND=(+T6_Vdi_si_Tempt_GND*qs+T6_Vdi_si*qs_Tempt_GND+T6_Tempt_GND*qs_Vdi_si+T6*qs_Vdi_si_Tempt_GND);
  qs_Vdi_si_Vge_e=(+T6_Vdi_si_Vge_e*qs+T6_Vdi_si*qs_Vge_e+T6_Vge_e*qs_Vdi_si+T6*qs_Vdi_si_Vge_e);
#endif
qs_Ve_si=((T6_Ve_si*qs)+(T6*qs_Ve_si));
#if defined(_DERIVATE2)
  qs_Ve_si_Vge_di=(+T6_Ve_si_Vge_di*qs+T6_Ve_si*qs_Vge_di+T6_Vge_di*qs_Ve_si+T6*qs_Ve_si_Vge_di);
  qs_Ve_si_Vdi_si=(+T6_Ve_si_Vdi_si*qs+T6_Ve_si*qs_Vdi_si+T6_Vdi_si*qs_Ve_si+T6*qs_Ve_si_Vdi_si);
  qs_Ve_si_Ve_si=(+T6_Ve_si_Ve_si*qs+T6_Ve_si*qs_Ve_si+T6_Ve_si*qs_Ve_si+T6*qs_Ve_si_Ve_si);
  qs_Ve_si_Ve_di=(+T6_Ve_si_Ve_di*qs+T6_Ve_si*qs_Ve_di+T6_Ve_di*qs_Ve_si+T6*qs_Ve_si_Ve_di);
  qs_Ve_si_Vge_si=(+T6_Ve_si_Vge_si*qs+T6_Ve_si*qs_Vge_si+T6_Vge_si*qs_Ve_si+T6*qs_Ve_si_Vge_si);
  qs_Ve_si_Tempt_GND=(+T6_Ve_si_Tempt_GND*qs+T6_Ve_si*qs_Tempt_GND+T6_Tempt_GND*qs_Ve_si+T6*qs_Ve_si_Tempt_GND);
  qs_Ve_si_Vge_e=(+T6_Ve_si_Vge_e*qs+T6_Ve_si*qs_Vge_e+T6_Vge_e*qs_Ve_si+T6*qs_Ve_si_Vge_e);
#endif
qs_Ve_di=((T6_Ve_di*qs)+(T6*qs_Ve_di));
#if defined(_DERIVATE2)
  qs_Ve_di_Vge_di=(+T6_Ve_di_Vge_di*qs+T6_Ve_di*qs_Vge_di+T6_Vge_di*qs_Ve_di+T6*qs_Ve_di_Vge_di);
  qs_Ve_di_Vdi_si=(+T6_Ve_di_Vdi_si*qs+T6_Ve_di*qs_Vdi_si+T6_Vdi_si*qs_Ve_di+T6*qs_Ve_di_Vdi_si);
  qs_Ve_di_Ve_si=(+T6_Ve_di_Ve_si*qs+T6_Ve_di*qs_Ve_si+T6_Ve_si*qs_Ve_di+T6*qs_Ve_di_Ve_si);
  qs_Ve_di_Ve_di=(+T6_Ve_di_Ve_di*qs+T6_Ve_di*qs_Ve_di+T6_Ve_di*qs_Ve_di+T6*qs_Ve_di_Ve_di);
  qs_Ve_di_Vge_si=(+T6_Ve_di_Vge_si*qs+T6_Ve_di*qs_Vge_si+T6_Vge_si*qs_Ve_di+T6*qs_Ve_di_Vge_si);
  qs_Ve_di_Tempt_GND=(+T6_Ve_di_Tempt_GND*qs+T6_Ve_di*qs_Tempt_GND+T6_Tempt_GND*qs_Ve_di+T6*qs_Ve_di_Tempt_GND);
  qs_Ve_di_Vge_e=(+T6_Ve_di_Vge_e*qs+T6_Ve_di*qs_Vge_e+T6_Vge_e*qs_Ve_di+T6*qs_Ve_di_Vge_e);
#endif
qs_Vge_si=((T6_Vge_si*qs)+(T6*qs_Vge_si));
#if defined(_DERIVATE2)
  qs_Vge_si_Vge_di=(+T6_Vge_si_Vge_di*qs+T6_Vge_si*qs_Vge_di+T6_Vge_di*qs_Vge_si+T6*qs_Vge_si_Vge_di);
  qs_Vge_si_Vdi_si=(+T6_Vge_si_Vdi_si*qs+T6_Vge_si*qs_Vdi_si+T6_Vdi_si*qs_Vge_si+T6*qs_Vge_si_Vdi_si);
  qs_Vge_si_Ve_si=(+T6_Vge_si_Ve_si*qs+T6_Vge_si*qs_Ve_si+T6_Ve_si*qs_Vge_si+T6*qs_Vge_si_Ve_si);
  qs_Vge_si_Ve_di=(+T6_Vge_si_Ve_di*qs+T6_Vge_si*qs_Ve_di+T6_Ve_di*qs_Vge_si+T6*qs_Vge_si_Ve_di);
  qs_Vge_si_Vge_si=(+T6_Vge_si_Vge_si*qs+T6_Vge_si*qs_Vge_si+T6_Vge_si*qs_Vge_si+T6*qs_Vge_si_Vge_si);
  qs_Vge_si_Tempt_GND=(+T6_Vge_si_Tempt_GND*qs+T6_Vge_si*qs_Tempt_GND+T6_Tempt_GND*qs_Vge_si+T6*qs_Vge_si_Tempt_GND);
  qs_Vge_si_Vge_e=(+T6_Vge_si_Vge_e*qs+T6_Vge_si*qs_Vge_e+T6_Vge_e*qs_Vge_si+T6*qs_Vge_si_Vge_e);
#endif
qs_Tempt_GND=((T6_Tempt_GND*qs)+(T6*qs_Tempt_GND));
#if defined(_DERIVATE2)
  qs_Tempt_GND_Vge_di=(+T6_Tempt_GND_Vge_di*qs+T6_Tempt_GND*qs_Vge_di+T6_Vge_di*qs_Tempt_GND+T6*qs_Tempt_GND_Vge_di);
  qs_Tempt_GND_Vdi_si=(+T6_Tempt_GND_Vdi_si*qs+T6_Tempt_GND*qs_Vdi_si+T6_Vdi_si*qs_Tempt_GND+T6*qs_Tempt_GND_Vdi_si);
  qs_Tempt_GND_Ve_si=(+T6_Tempt_GND_Ve_si*qs+T6_Tempt_GND*qs_Ve_si+T6_Ve_si*qs_Tempt_GND+T6*qs_Tempt_GND_Ve_si);
  qs_Tempt_GND_Ve_di=(+T6_Tempt_GND_Ve_di*qs+T6_Tempt_GND*qs_Ve_di+T6_Ve_di*qs_Tempt_GND+T6*qs_Tempt_GND_Ve_di);
  qs_Tempt_GND_Vge_si=(+T6_Tempt_GND_Vge_si*qs+T6_Tempt_GND*qs_Vge_si+T6_Vge_si*qs_Tempt_GND+T6*qs_Tempt_GND_Vge_si);
  qs_Tempt_GND_Tempt_GND=(+T6_Tempt_GND_Tempt_GND*qs+T6_Tempt_GND*qs_Tempt_GND+T6_Tempt_GND*qs_Tempt_GND+T6*qs_Tempt_GND_Tempt_GND);
  qs_Tempt_GND_Vge_e=(+T6_Tempt_GND_Vge_e*qs+T6_Tempt_GND*qs_Vge_e+T6_Vge_e*qs_Tempt_GND+T6*qs_Tempt_GND_Vge_e);
#endif
qs_Vge_e=((T6_Vge_e*qs)+(T6*qs_Vge_e));
#if defined(_DERIVATE2)
  qs_Vge_e_Vge_di=(+T6_Vge_e_Vge_di*qs+T6_Vge_e*qs_Vge_di+T6_Vge_di*qs_Vge_e+T6*qs_Vge_e_Vge_di);
  qs_Vge_e_Vdi_si=(+T6_Vge_e_Vdi_si*qs+T6_Vge_e*qs_Vdi_si+T6_Vdi_si*qs_Vge_e+T6*qs_Vge_e_Vdi_si);
  qs_Vge_e_Ve_si=(+T6_Vge_e_Ve_si*qs+T6_Vge_e*qs_Ve_si+T6_Ve_si*qs_Vge_e+T6*qs_Vge_e_Ve_si);
  qs_Vge_e_Ve_di=(+T6_Vge_e_Ve_di*qs+T6_Vge_e*qs_Ve_di+T6_Ve_di*qs_Vge_e+T6*qs_Vge_e_Ve_di);
  qs_Vge_e_Vge_si=(+T6_Vge_e_Vge_si*qs+T6_Vge_e*qs_Vge_si+T6_Vge_si*qs_Vge_e+T6*qs_Vge_e_Vge_si);
  qs_Vge_e_Tempt_GND=(+T6_Vge_e_Tempt_GND*qs+T6_Vge_e*qs_Tempt_GND+T6_Tempt_GND*qs_Vge_e+T6*qs_Vge_e_Tempt_GND);
  qs_Vge_e_Vge_e=(+T6_Vge_e_Vge_e*qs+T6_Vge_e*qs_Vge_e+T6_Vge_e*qs_Vge_e+T6*qs_Vge_e_Vge_e);
#endif
#endif
qs=(T6*qs);
EXIT_IF_ISNAN((T6*qs))
#endif
#if defined(_DERIVATE) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe= */
qinv_Vdi_si=qg_Vdi_si;
qinv_Ve_si=qg_Ve_si;
qinv_Ve_di=qg_Ve_di;
qinv_Vge_si=qg_Vge_si;
qinv_Tempt_GND=qg_Tempt_GND;
qinv_Vge_e=qg_Vge_e;
#endif
qinv=qg;
EXIT_IF_ISNAN(qg)
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_e_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_e_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_e_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Vge_e);
  T1_Vge_e_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Ve_si);
  T1_Vge_e_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Ve_di);
  T1_Vge_e_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Vge_si);
  T1_Vge_e_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Vdi_si);
  T1_Vge_e_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Vge_e+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_e_Tempt_GND);
#endif
T1_Ve_si=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Vge_e);
  T1_Ve_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Ve_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_si_Tempt_GND);
#endif
T1_Ve_di=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_di_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_di_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Ve_di_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Vge_e);
  T1_Ve_di_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Ve_di+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Ve_di_Tempt_GND);
#endif
T1_Vge_si=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vge_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Vge_e);
  T1_Vge_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Vge_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vdi_si_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vdi_si_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Vdi_si_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Vge_e);
  T1_Vdi_si_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Vdi_si+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Tempt_GND_Vsi_s=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Tempt_GND_Vge_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*0.0+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*0.0);
  T1_Tempt_GND_Vge_e=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_e+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Vge_e);
  T1_Tempt_GND_Ve_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_si+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Ve_di+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vge_si+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Vdi_si+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(+(+0.0*WeffCV0+0.0*0.0+0.0*0.0+NFINtotal*0.0)*LeffCV_acc+0.0*0.0+(0.0)*0.0+(NFINtotal*WeffCV0)*0.0)*cox_acc+0.0*cox_acc_Tempt_GND+((0.0)*LeffCV_acc)*cox_acc_Tempt_GND+((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc);
EXIT_IF_ISNAN((((NFINtotal*WeffCV0)*LeffCV_acc)*cox_acc))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=qi_acc_for_QM_Vge_e;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=0.0;
  T7_Vge_e_Vdi_d=0.0;
  T7_Vge_e_Vsi_s=0.0;
  T7_Vge_e_Vge_e=qi_acc_for_QM_Vge_e_Vge_e;
  T7_Vge_e_Vdi_si=qi_acc_for_QM_Vge_e_Vdi_si;
  T7_Vge_e_Ve_si=qi_acc_for_QM_Vge_e_Ve_si;
  T7_Vge_e_Ve_di=qi_acc_for_QM_Vge_e_Ve_di;
  T7_Vge_e_Vge_si=qi_acc_for_QM_Vge_e_Vge_si;
  T7_Vge_e_Tempt_GND=qi_acc_for_QM_Vge_e_Tempt_GND;
#endif
T7_Vdi_si=qi_acc_for_QM_Vdi_si;
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=0.0;
  T7_Vdi_si_Vdi_d=0.0;
  T7_Vdi_si_Vsi_s=0.0;
  T7_Vdi_si_Vge_e=qi_acc_for_QM_Vdi_si_Vge_e;
  T7_Vdi_si_Vdi_si=qi_acc_for_QM_Vdi_si_Vdi_si;
  T7_Vdi_si_Ve_si=qi_acc_for_QM_Vdi_si_Ve_si;
  T7_Vdi_si_Ve_di=qi_acc_for_QM_Vdi_si_Ve_di;
  T7_Vdi_si_Vge_si=qi_acc_for_QM_Vdi_si_Vge_si;
  T7_Vdi_si_Tempt_GND=qi_acc_for_QM_Vdi_si_Tempt_GND;
#endif
T7_Ve_si=qi_acc_for_QM_Ve_si;
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=0.0;
  T7_Ve_si_Vdi_d=0.0;
  T7_Ve_si_Vsi_s=0.0;
  T7_Ve_si_Vge_e=qi_acc_for_QM_Ve_si_Vge_e;
  T7_Ve_si_Vdi_si=qi_acc_for_QM_Ve_si_Vdi_si;
  T7_Ve_si_Ve_si=qi_acc_for_QM_Ve_si_Ve_si;
  T7_Ve_si_Ve_di=qi_acc_for_QM_Ve_si_Ve_di;
  T7_Ve_si_Vge_si=qi_acc_for_QM_Ve_si_Vge_si;
  T7_Ve_si_Tempt_GND=qi_acc_for_QM_Ve_si_Tempt_GND;
#endif
T7_Ve_di=qi_acc_for_QM_Ve_di;
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=0.0;
  T7_Ve_di_Vdi_d=0.0;
  T7_Ve_di_Vsi_s=0.0;
  T7_Ve_di_Vge_e=qi_acc_for_QM_Ve_di_Vge_e;
  T7_Ve_di_Vdi_si=qi_acc_for_QM_Ve_di_Vdi_si;
  T7_Ve_di_Ve_si=qi_acc_for_QM_Ve_di_Ve_si;
  T7_Ve_di_Ve_di=qi_acc_for_QM_Ve_di_Ve_di;
  T7_Ve_di_Vge_si=qi_acc_for_QM_Ve_di_Vge_si;
  T7_Ve_di_Tempt_GND=qi_acc_for_QM_Ve_di_Tempt_GND;
#endif
T7_Vge_si=qi_acc_for_QM_Vge_si;
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=0.0;
  T7_Vge_si_Vdi_d=0.0;
  T7_Vge_si_Vsi_s=0.0;
  T7_Vge_si_Vge_e=qi_acc_for_QM_Vge_si_Vge_e;
  T7_Vge_si_Vdi_si=qi_acc_for_QM_Vge_si_Vdi_si;
  T7_Vge_si_Ve_si=qi_acc_for_QM_Vge_si_Ve_si;
  T7_Vge_si_Ve_di=qi_acc_for_QM_Vge_si_Ve_di;
  T7_Vge_si_Vge_si=qi_acc_for_QM_Vge_si_Vge_si;
  T7_Vge_si_Tempt_GND=qi_acc_for_QM_Vge_si_Tempt_GND;
#endif
T7_Tempt_GND=qi_acc_for_QM_Tempt_GND;
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=0.0;
  T7_Tempt_GND_Vdi_d=0.0;
  T7_Tempt_GND_Vsi_s=0.0;
  T7_Tempt_GND_Vge_e=qi_acc_for_QM_Tempt_GND_Vge_e;
  T7_Tempt_GND_Vdi_si=qi_acc_for_QM_Tempt_GND_Vdi_si;
  T7_Tempt_GND_Ve_si=qi_acc_for_QM_Tempt_GND_Ve_si;
  T7_Tempt_GND_Ve_di=qi_acc_for_QM_Tempt_GND_Ve_di;
  T7_Tempt_GND_Vge_si=qi_acc_for_QM_Tempt_GND_Vge_si;
  T7_Tempt_GND_Tempt_GND=qi_acc_for_QM_Tempt_GND_Tempt_GND;
#endif
#endif
T7=qi_acc_for_QM;
EXIT_IF_ISNAN(qi_acc_for_QM)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=((T7_Vge_di*T1)+(T7*T1_Vge_di));
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=(+T7_Vge_di_Vge_di*T1+T7_Vge_di*T1_Vge_di+T7_Vge_di*T1_Vge_di+T7*T1_Vge_di_Vge_di);
  T10_Vge_di_Vge_e=(+T7_Vge_di_Vge_e*T1+T7_Vge_di*T1_Vge_e+T7_Vge_e*T1_Vge_di+T7*T1_Vge_di_Vge_e);
  T10_Vge_di_Ve_si=(+T7_Vge_di_Ve_si*T1+T7_Vge_di*T1_Ve_si+T7_Ve_si*T1_Vge_di+T7*T1_Vge_di_Ve_si);
  T10_Vge_di_Ve_di=(+T7_Vge_di_Ve_di*T1+T7_Vge_di*T1_Ve_di+T7_Ve_di*T1_Vge_di+T7*T1_Vge_di_Ve_di);
  T10_Vge_di_Vge_si=(+T7_Vge_di_Vge_si*T1+T7_Vge_di*T1_Vge_si+T7_Vge_si*T1_Vge_di+T7*T1_Vge_di_Vge_si);
  T10_Vge_di_Vdi_si=(+T7_Vge_di_Vdi_si*T1+T7_Vge_di*T1_Vdi_si+T7_Vdi_si*T1_Vge_di+T7*T1_Vge_di_Vdi_si);
  T10_Vge_di_Tempt_GND=(+T7_Vge_di_Tempt_GND*T1+T7_Vge_di*T1_Tempt_GND+T7_Tempt_GND*T1_Vge_di+T7*T1_Vge_di_Tempt_GND);
#endif
T10_Vge_e=((T7_Vge_e*T1)+(T7*T1_Vge_e));
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+T7_Vge_e_Vge_di*T1+T7_Vge_e*T1_Vge_di+T7_Vge_di*T1_Vge_e+T7*T1_Vge_e_Vge_di);
  T10_Vge_e_Vge_e=(+T7_Vge_e_Vge_e*T1+T7_Vge_e*T1_Vge_e+T7_Vge_e*T1_Vge_e+T7*T1_Vge_e_Vge_e);
  T10_Vge_e_Ve_si=(+T7_Vge_e_Ve_si*T1+T7_Vge_e*T1_Ve_si+T7_Ve_si*T1_Vge_e+T7*T1_Vge_e_Ve_si);
  T10_Vge_e_Ve_di=(+T7_Vge_e_Ve_di*T1+T7_Vge_e*T1_Ve_di+T7_Ve_di*T1_Vge_e+T7*T1_Vge_e_Ve_di);
  T10_Vge_e_Vge_si=(+T7_Vge_e_Vge_si*T1+T7_Vge_e*T1_Vge_si+T7_Vge_si*T1_Vge_e+T7*T1_Vge_e_Vge_si);
  T10_Vge_e_Vdi_si=(+T7_Vge_e_Vdi_si*T1+T7_Vge_e*T1_Vdi_si+T7_Vdi_si*T1_Vge_e+T7*T1_Vge_e_Vdi_si);
  T10_Vge_e_Tempt_GND=(+T7_Vge_e_Tempt_GND*T1+T7_Vge_e*T1_Tempt_GND+T7_Tempt_GND*T1_Vge_e+T7*T1_Vge_e_Tempt_GND);
#endif
T10_Ve_si=((T7_Ve_si*T1)+(T7*T1_Ve_si));
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+T7_Ve_si_Vge_di*T1+T7_Ve_si*T1_Vge_di+T7_Vge_di*T1_Ve_si+T7*T1_Ve_si_Vge_di);
  T10_Ve_si_Vge_e=(+T7_Ve_si_Vge_e*T1+T7_Ve_si*T1_Vge_e+T7_Vge_e*T1_Ve_si+T7*T1_Ve_si_Vge_e);
  T10_Ve_si_Ve_si=(+T7_Ve_si_Ve_si*T1+T7_Ve_si*T1_Ve_si+T7_Ve_si*T1_Ve_si+T7*T1_Ve_si_Ve_si);
  T10_Ve_si_Ve_di=(+T7_Ve_si_Ve_di*T1+T7_Ve_si*T1_Ve_di+T7_Ve_di*T1_Ve_si+T7*T1_Ve_si_Ve_di);
  T10_Ve_si_Vge_si=(+T7_Ve_si_Vge_si*T1+T7_Ve_si*T1_Vge_si+T7_Vge_si*T1_Ve_si+T7*T1_Ve_si_Vge_si);
  T10_Ve_si_Vdi_si=(+T7_Ve_si_Vdi_si*T1+T7_Ve_si*T1_Vdi_si+T7_Vdi_si*T1_Ve_si+T7*T1_Ve_si_Vdi_si);
  T10_Ve_si_Tempt_GND=(+T7_Ve_si_Tempt_GND*T1+T7_Ve_si*T1_Tempt_GND+T7_Tempt_GND*T1_Ve_si+T7*T1_Ve_si_Tempt_GND);
#endif
T10_Ve_di=((T7_Ve_di*T1)+(T7*T1_Ve_di));
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+T7_Ve_di_Vge_di*T1+T7_Ve_di*T1_Vge_di+T7_Vge_di*T1_Ve_di+T7*T1_Ve_di_Vge_di);
  T10_Ve_di_Vge_e=(+T7_Ve_di_Vge_e*T1+T7_Ve_di*T1_Vge_e+T7_Vge_e*T1_Ve_di+T7*T1_Ve_di_Vge_e);
  T10_Ve_di_Ve_si=(+T7_Ve_di_Ve_si*T1+T7_Ve_di*T1_Ve_si+T7_Ve_si*T1_Ve_di+T7*T1_Ve_di_Ve_si);
  T10_Ve_di_Ve_di=(+T7_Ve_di_Ve_di*T1+T7_Ve_di*T1_Ve_di+T7_Ve_di*T1_Ve_di+T7*T1_Ve_di_Ve_di);
  T10_Ve_di_Vge_si=(+T7_Ve_di_Vge_si*T1+T7_Ve_di*T1_Vge_si+T7_Vge_si*T1_Ve_di+T7*T1_Ve_di_Vge_si);
  T10_Ve_di_Vdi_si=(+T7_Ve_di_Vdi_si*T1+T7_Ve_di*T1_Vdi_si+T7_Vdi_si*T1_Ve_di+T7*T1_Ve_di_Vdi_si);
  T10_Ve_di_Tempt_GND=(+T7_Ve_di_Tempt_GND*T1+T7_Ve_di*T1_Tempt_GND+T7_Tempt_GND*T1_Ve_di+T7*T1_Ve_di_Tempt_GND);
#endif
T10_Vge_si=((T7_Vge_si*T1)+(T7*T1_Vge_si));
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+T7_Vge_si_Vge_di*T1+T7_Vge_si*T1_Vge_di+T7_Vge_di*T1_Vge_si+T7*T1_Vge_si_Vge_di);
  T10_Vge_si_Vge_e=(+T7_Vge_si_Vge_e*T1+T7_Vge_si*T1_Vge_e+T7_Vge_e*T1_Vge_si+T7*T1_Vge_si_Vge_e);
  T10_Vge_si_Ve_si=(+T7_Vge_si_Ve_si*T1+T7_Vge_si*T1_Ve_si+T7_Ve_si*T1_Vge_si+T7*T1_Vge_si_Ve_si);
  T10_Vge_si_Ve_di=(+T7_Vge_si_Ve_di*T1+T7_Vge_si*T1_Ve_di+T7_Ve_di*T1_Vge_si+T7*T1_Vge_si_Ve_di);
  T10_Vge_si_Vge_si=(+T7_Vge_si_Vge_si*T1+T7_Vge_si*T1_Vge_si+T7_Vge_si*T1_Vge_si+T7*T1_Vge_si_Vge_si);
  T10_Vge_si_Vdi_si=(+T7_Vge_si_Vdi_si*T1+T7_Vge_si*T1_Vdi_si+T7_Vdi_si*T1_Vge_si+T7*T1_Vge_si_Vdi_si);
  T10_Vge_si_Tempt_GND=(+T7_Vge_si_Tempt_GND*T1+T7_Vge_si*T1_Tempt_GND+T7_Tempt_GND*T1_Vge_si+T7*T1_Vge_si_Tempt_GND);
#endif
T10_Vdi_si=((T7_Vdi_si*T1)+(T7*T1_Vdi_si));
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+T7_Vdi_si_Vge_di*T1+T7_Vdi_si*T1_Vge_di+T7_Vge_di*T1_Vdi_si+T7*T1_Vdi_si_Vge_di);
  T10_Vdi_si_Vge_e=(+T7_Vdi_si_Vge_e*T1+T7_Vdi_si*T1_Vge_e+T7_Vge_e*T1_Vdi_si+T7*T1_Vdi_si_Vge_e);
  T10_Vdi_si_Ve_si=(+T7_Vdi_si_Ve_si*T1+T7_Vdi_si*T1_Ve_si+T7_Ve_si*T1_Vdi_si+T7*T1_Vdi_si_Ve_si);
  T10_Vdi_si_Ve_di=(+T7_Vdi_si_Ve_di*T1+T7_Vdi_si*T1_Ve_di+T7_Ve_di*T1_Vdi_si+T7*T1_Vdi_si_Ve_di);
  T10_Vdi_si_Vge_si=(+T7_Vdi_si_Vge_si*T1+T7_Vdi_si*T1_Vge_si+T7_Vge_si*T1_Vdi_si+T7*T1_Vdi_si_Vge_si);
  T10_Vdi_si_Vdi_si=(+T7_Vdi_si_Vdi_si*T1+T7_Vdi_si*T1_Vdi_si+T7_Vdi_si*T1_Vdi_si+T7*T1_Vdi_si_Vdi_si);
  T10_Vdi_si_Tempt_GND=(+T7_Vdi_si_Tempt_GND*T1+T7_Vdi_si*T1_Tempt_GND+T7_Tempt_GND*T1_Vdi_si+T7*T1_Vdi_si_Tempt_GND);
#endif
T10_Tempt_GND=((T7_Tempt_GND*T1)+(T7*T1_Tempt_GND));
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+T7_Tempt_GND_Vge_di*T1+T7_Tempt_GND*T1_Vge_di+T7_Vge_di*T1_Tempt_GND+T7*T1_Tempt_GND_Vge_di);
  T10_Tempt_GND_Vge_e=(+T7_Tempt_GND_Vge_e*T1+T7_Tempt_GND*T1_Vge_e+T7_Vge_e*T1_Tempt_GND+T7*T1_Tempt_GND_Vge_e);
  T10_Tempt_GND_Ve_si=(+T7_Tempt_GND_Ve_si*T1+T7_Tempt_GND*T1_Ve_si+T7_Ve_si*T1_Tempt_GND+T7*T1_Tempt_GND_Ve_si);
  T10_Tempt_GND_Ve_di=(+T7_Tempt_GND_Ve_di*T1+T7_Tempt_GND*T1_Ve_di+T7_Ve_di*T1_Tempt_GND+T7*T1_Tempt_GND_Ve_di);
  T10_Tempt_GND_Vge_si=(+T7_Tempt_GND_Vge_si*T1+T7_Tempt_GND*T1_Vge_si+T7_Vge_si*T1_Tempt_GND+T7*T1_Tempt_GND_Vge_si);
  T10_Tempt_GND_Vdi_si=(+T7_Tempt_GND_Vdi_si*T1+T7_Tempt_GND*T1_Vdi_si+T7_Vdi_si*T1_Tempt_GND+T7*T1_Tempt_GND_Vdi_si);
  T10_Tempt_GND_Tempt_GND=(+T7_Tempt_GND_Tempt_GND*T1+T7_Tempt_GND*T1_Tempt_GND+T7_Tempt_GND*T1_Tempt_GND+T7*T1_Tempt_GND_Tempt_GND);
#endif
#endif
T10=(T7*T1);
EXIT_IF_ISNAN((T7*T1))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_acc_Vge_di=(-T10_Vge_di);
#if defined(_DERIVATE2)
  qg_acc_Vge_di_Vge_di=0.0;
  qg_acc_Vge_di_Vge_e=0.0;
  qg_acc_Vge_di_Ve_si=0.0;
  qg_acc_Vge_di_Ve_di=0.0;
  qg_acc_Vge_di_Vge_si=0.0;
  qg_acc_Vge_di_Vdi_si=0.0;
  qg_acc_Vge_di_Tempt_GND=0.0;
#endif
qg_acc_Vge_e=(-T10_Vge_e);
#if defined(_DERIVATE2)
  qg_acc_Vge_e_Vge_di=0.0;
  qg_acc_Vge_e_Vge_e=0.0;
  qg_acc_Vge_e_Ve_si=0.0;
  qg_acc_Vge_e_Ve_di=0.0;
  qg_acc_Vge_e_Vge_si=0.0;
  qg_acc_Vge_e_Vdi_si=0.0;
  qg_acc_Vge_e_Tempt_GND=0.0;
#endif
qg_acc_Ve_si=(-T10_Ve_si);
#if defined(_DERIVATE2)
  qg_acc_Ve_si_Vge_di=0.0;
  qg_acc_Ve_si_Vge_e=0.0;
  qg_acc_Ve_si_Ve_si=0.0;
  qg_acc_Ve_si_Ve_di=0.0;
  qg_acc_Ve_si_Vge_si=0.0;
  qg_acc_Ve_si_Vdi_si=0.0;
  qg_acc_Ve_si_Tempt_GND=0.0;
#endif
qg_acc_Ve_di=(-T10_Ve_di);
#if defined(_DERIVATE2)
  qg_acc_Ve_di_Vge_di=0.0;
  qg_acc_Ve_di_Vge_e=0.0;
  qg_acc_Ve_di_Ve_si=0.0;
  qg_acc_Ve_di_Ve_di=0.0;
  qg_acc_Ve_di_Vge_si=0.0;
  qg_acc_Ve_di_Vdi_si=0.0;
  qg_acc_Ve_di_Tempt_GND=0.0;
#endif
qg_acc_Vge_si=(-T10_Vge_si);
#if defined(_DERIVATE2)
  qg_acc_Vge_si_Vge_di=0.0;
  qg_acc_Vge_si_Vge_e=0.0;
  qg_acc_Vge_si_Ve_si=0.0;
  qg_acc_Vge_si_Ve_di=0.0;
  qg_acc_Vge_si_Vge_si=0.0;
  qg_acc_Vge_si_Vdi_si=0.0;
  qg_acc_Vge_si_Tempt_GND=0.0;
#endif
qg_acc_Vdi_si=(-T10_Vdi_si);
#if defined(_DERIVATE2)
  qg_acc_Vdi_si_Vge_di=0.0;
  qg_acc_Vdi_si_Vge_e=0.0;
  qg_acc_Vdi_si_Ve_si=0.0;
  qg_acc_Vdi_si_Ve_di=0.0;
  qg_acc_Vdi_si_Vge_si=0.0;
  qg_acc_Vdi_si_Vdi_si=0.0;
  qg_acc_Vdi_si_Tempt_GND=0.0;
#endif
qg_acc_Tempt_GND=(-T10_Tempt_GND);
#if defined(_DERIVATE2)
  qg_acc_Tempt_GND_Vge_di=0.0;
  qg_acc_Tempt_GND_Vge_e=0.0;
  qg_acc_Tempt_GND_Ve_si=0.0;
  qg_acc_Tempt_GND_Ve_di=0.0;
  qg_acc_Tempt_GND_Vge_si=0.0;
  qg_acc_Tempt_GND_Vdi_si=0.0;
  qg_acc_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qg_acc=(-T10);
EXIT_IF_ISNAN((-T10))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qb_acc_Vge_di=T10_Vge_di;
#if defined(_DERIVATE2)
  qb_acc_Vge_di_Vge_di=T10_Vge_di_Vge_di;
  qb_acc_Vge_di_Vge_e=T10_Vge_di_Vge_e;
  qb_acc_Vge_di_Ve_si=T10_Vge_di_Ve_si;
  qb_acc_Vge_di_Ve_di=T10_Vge_di_Ve_di;
  qb_acc_Vge_di_Vge_si=T10_Vge_di_Vge_si;
  qb_acc_Vge_di_Vdi_si=T10_Vge_di_Vdi_si;
  qb_acc_Vge_di_Tempt_GND=T10_Vge_di_Tempt_GND;
#endif
qb_acc_Vge_e=T10_Vge_e;
#if defined(_DERIVATE2)
  qb_acc_Vge_e_Vge_di=T10_Vge_e_Vge_di;
  qb_acc_Vge_e_Vge_e=T10_Vge_e_Vge_e;
  qb_acc_Vge_e_Ve_si=T10_Vge_e_Ve_si;
  qb_acc_Vge_e_Ve_di=T10_Vge_e_Ve_di;
  qb_acc_Vge_e_Vge_si=T10_Vge_e_Vge_si;
  qb_acc_Vge_e_Vdi_si=T10_Vge_e_Vdi_si;
  qb_acc_Vge_e_Tempt_GND=T10_Vge_e_Tempt_GND;
#endif
qb_acc_Ve_si=T10_Ve_si;
#if defined(_DERIVATE2)
  qb_acc_Ve_si_Vge_di=T10_Ve_si_Vge_di;
  qb_acc_Ve_si_Vge_e=T10_Ve_si_Vge_e;
  qb_acc_Ve_si_Ve_si=T10_Ve_si_Ve_si;
  qb_acc_Ve_si_Ve_di=T10_Ve_si_Ve_di;
  qb_acc_Ve_si_Vge_si=T10_Ve_si_Vge_si;
  qb_acc_Ve_si_Vdi_si=T10_Ve_si_Vdi_si;
  qb_acc_Ve_si_Tempt_GND=T10_Ve_si_Tempt_GND;
#endif
qb_acc_Ve_di=T10_Ve_di;
#if defined(_DERIVATE2)
  qb_acc_Ve_di_Vge_di=T10_Ve_di_Vge_di;
  qb_acc_Ve_di_Vge_e=T10_Ve_di_Vge_e;
  qb_acc_Ve_di_Ve_si=T10_Ve_di_Ve_si;
  qb_acc_Ve_di_Ve_di=T10_Ve_di_Ve_di;
  qb_acc_Ve_di_Vge_si=T10_Ve_di_Vge_si;
  qb_acc_Ve_di_Vdi_si=T10_Ve_di_Vdi_si;
  qb_acc_Ve_di_Tempt_GND=T10_Ve_di_Tempt_GND;
#endif
qb_acc_Vge_si=T10_Vge_si;
#if defined(_DERIVATE2)
  qb_acc_Vge_si_Vge_di=T10_Vge_si_Vge_di;
  qb_acc_Vge_si_Vge_e=T10_Vge_si_Vge_e;
  qb_acc_Vge_si_Ve_si=T10_Vge_si_Ve_si;
  qb_acc_Vge_si_Ve_di=T10_Vge_si_Ve_di;
  qb_acc_Vge_si_Vge_si=T10_Vge_si_Vge_si;
  qb_acc_Vge_si_Vdi_si=T10_Vge_si_Vdi_si;
  qb_acc_Vge_si_Tempt_GND=T10_Vge_si_Tempt_GND;
#endif
qb_acc_Vdi_si=T10_Vdi_si;
#if defined(_DERIVATE2)
  qb_acc_Vdi_si_Vge_di=T10_Vdi_si_Vge_di;
  qb_acc_Vdi_si_Vge_e=T10_Vdi_si_Vge_e;
  qb_acc_Vdi_si_Ve_si=T10_Vdi_si_Ve_si;
  qb_acc_Vdi_si_Ve_di=T10_Vdi_si_Ve_di;
  qb_acc_Vdi_si_Vge_si=T10_Vdi_si_Vge_si;
  qb_acc_Vdi_si_Vdi_si=T10_Vdi_si_Vdi_si;
  qb_acc_Vdi_si_Tempt_GND=T10_Vdi_si_Tempt_GND;
#endif
#if defined(_DERIVATE)
qb_acc_Tempt_GND=T10_Tempt_GND;
#endif
#endif
qb_acc=T10;
EXIT_IF_ISNAN(T10)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=(((NFINtotal*WeffCV0)*LeffCV)*cox);
EXIT_IF_ISNAN((((NFINtotal*WeffCV0)*LeffCV)*cox))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=(qba_Vge_e-qi_acc_for_QM_Vge_e);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+0.0-0.0);
  T2_Vge_e_Vsi_s=(+0.0-0.0);
  T2_Vge_e_Vge_di=(+0.0-0.0);
  T2_Vge_e_Vge_e=(+qba_Vge_e_Vge_e-qi_acc_for_QM_Vge_e_Vge_e);
  T2_Vge_e_Vge_si=(+qba_Vge_e_Vge_si-qi_acc_for_QM_Vge_e_Vge_si);
  T2_Vge_e_Ve_si=(+qba_Vge_e_Ve_si-qi_acc_for_QM_Vge_e_Ve_si);
  T2_Vge_e_Ve_di=(+qba_Vge_e_Ve_di-qi_acc_for_QM_Vge_e_Ve_di);
  T2_Vge_e_Vdi_si=(+qba_Vge_e_Vdi_si-qi_acc_for_QM_Vge_e_Vdi_si);
  T2_Vge_e_Tempt_GND=(+qba_Vge_e_Tempt_GND-qi_acc_for_QM_Vge_e_Tempt_GND);
#endif
T2_Vge_si=(qba_Vge_si-qi_acc_for_QM_Vge_si);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0-0.0);
  T2_Vge_si_Vsi_s=(+0.0-0.0);
  T2_Vge_si_Vge_di=(+0.0-0.0);
  T2_Vge_si_Vge_e=(+qba_Vge_si_Vge_e-qi_acc_for_QM_Vge_si_Vge_e);
  T2_Vge_si_Vge_si=(+qba_Vge_si_Vge_si-qi_acc_for_QM_Vge_si_Vge_si);
  T2_Vge_si_Ve_si=(+qba_Vge_si_Ve_si-qi_acc_for_QM_Vge_si_Ve_si);
  T2_Vge_si_Ve_di=(+qba_Vge_si_Ve_di-qi_acc_for_QM_Vge_si_Ve_di);
  T2_Vge_si_Vdi_si=(+qba_Vge_si_Vdi_si-qi_acc_for_QM_Vge_si_Vdi_si);
  T2_Vge_si_Tempt_GND=(+qba_Vge_si_Tempt_GND-qi_acc_for_QM_Vge_si_Tempt_GND);
#endif
T2_Ve_si=(qba_Ve_si-qi_acc_for_QM_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0-0.0);
  T2_Ve_si_Vsi_s=(+0.0-0.0);
  T2_Ve_si_Vge_di=(+0.0-0.0);
  T2_Ve_si_Vge_e=(+qba_Ve_si_Vge_e-qi_acc_for_QM_Ve_si_Vge_e);
  T2_Ve_si_Vge_si=(+qba_Ve_si_Vge_si-qi_acc_for_QM_Ve_si_Vge_si);
  T2_Ve_si_Ve_si=(+qba_Ve_si_Ve_si-qi_acc_for_QM_Ve_si_Ve_si);
  T2_Ve_si_Ve_di=(+qba_Ve_si_Ve_di-qi_acc_for_QM_Ve_si_Ve_di);
  T2_Ve_si_Vdi_si=(+qba_Ve_si_Vdi_si-qi_acc_for_QM_Ve_si_Vdi_si);
  T2_Ve_si_Tempt_GND=(+qba_Ve_si_Tempt_GND-qi_acc_for_QM_Ve_si_Tempt_GND);
#endif
T2_Ve_di=(qba_Ve_di-qi_acc_for_QM_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0-0.0);
  T2_Ve_di_Vsi_s=(+0.0-0.0);
  T2_Ve_di_Vge_di=(+0.0-0.0);
  T2_Ve_di_Vge_e=(+qba_Ve_di_Vge_e-qi_acc_for_QM_Ve_di_Vge_e);
  T2_Ve_di_Vge_si=(+qba_Ve_di_Vge_si-qi_acc_for_QM_Ve_di_Vge_si);
  T2_Ve_di_Ve_si=(+qba_Ve_di_Ve_si-qi_acc_for_QM_Ve_di_Ve_si);
  T2_Ve_di_Ve_di=(+qba_Ve_di_Ve_di-qi_acc_for_QM_Ve_di_Ve_di);
  T2_Ve_di_Vdi_si=(+qba_Ve_di_Vdi_si-qi_acc_for_QM_Ve_di_Vdi_si);
  T2_Ve_di_Tempt_GND=(+qba_Ve_di_Tempt_GND-qi_acc_for_QM_Ve_di_Tempt_GND);
#endif
T2_Vdi_si=(qba_Vdi_si-qi_acc_for_QM_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0-0.0);
  T2_Vdi_si_Vsi_s=(+0.0-0.0);
  T2_Vdi_si_Vge_di=(+0.0-0.0);
  T2_Vdi_si_Vge_e=(+qba_Vdi_si_Vge_e-qi_acc_for_QM_Vdi_si_Vge_e);
  T2_Vdi_si_Vge_si=(+qba_Vdi_si_Vge_si-qi_acc_for_QM_Vdi_si_Vge_si);
  T2_Vdi_si_Ve_si=(+qba_Vdi_si_Ve_si-qi_acc_for_QM_Vdi_si_Ve_si);
  T2_Vdi_si_Ve_di=(+qba_Vdi_si_Ve_di-qi_acc_for_QM_Vdi_si_Ve_di);
  T2_Vdi_si_Vdi_si=(+qba_Vdi_si_Vdi_si-qi_acc_for_QM_Vdi_si_Vdi_si);
  T2_Vdi_si_Tempt_GND=(+qba_Vdi_si_Tempt_GND-qi_acc_for_QM_Vdi_si_Tempt_GND);
#endif
T2_Tempt_GND=(qba_Tempt_GND-qi_acc_for_QM_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0-0.0);
  T2_Tempt_GND_Vsi_s=(+0.0-0.0);
  T2_Tempt_GND_Vge_di=(+0.0-0.0);
  T2_Tempt_GND_Vge_e=(+qba_Tempt_GND_Vge_e-qi_acc_for_QM_Tempt_GND_Vge_e);
  T2_Tempt_GND_Vge_si=(+qba_Tempt_GND_Vge_si-qi_acc_for_QM_Tempt_GND_Vge_si);
  T2_Tempt_GND_Ve_si=(+qba_Tempt_GND_Ve_si-qi_acc_for_QM_Tempt_GND_Ve_si);
  T2_Tempt_GND_Ve_di=(+qba_Tempt_GND_Ve_di-qi_acc_for_QM_Tempt_GND_Ve_di);
  T2_Tempt_GND_Vdi_si=(+qba_Tempt_GND_Vdi_si-qi_acc_for_QM_Tempt_GND_Vdi_si);
  T2_Tempt_GND_Tempt_GND=(+qba_Tempt_GND_Tempt_GND-qi_acc_for_QM_Tempt_GND_Tempt_GND);
#endif
#endif
T2=(qba-qi_acc_for_QM);
EXIT_IF_ISNAN((qba-qi_acc_for_QM))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=((T1_Vge_di*T2)+(T1*T2_Vge_di));
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=(+T1_Vge_di_Vge_di*T2+T1_Vge_di*T2_Vge_di+T1_Vge_di*T2_Vge_di+T1*T2_Vge_di_Vge_di);
  T10_Vge_di_Vge_e=(+T1_Vge_di_Vge_e*T2+T1_Vge_di*T2_Vge_e+T1_Vge_e*T2_Vge_di+T1*T2_Vge_di_Vge_e);
  T10_Vge_di_Ve_si=(+T1_Vge_di_Ve_si*T2+T1_Vge_di*T2_Ve_si+T1_Ve_si*T2_Vge_di+T1*T2_Vge_di_Ve_si);
  T10_Vge_di_Ve_di=(+T1_Vge_di_Ve_di*T2+T1_Vge_di*T2_Ve_di+T1_Ve_di*T2_Vge_di+T1*T2_Vge_di_Ve_di);
  T10_Vge_di_Vge_si=(+T1_Vge_di_Vge_si*T2+T1_Vge_di*T2_Vge_si+T1_Vge_si*T2_Vge_di+T1*T2_Vge_di_Vge_si);
  T10_Vge_di_Vdi_si=(+T1_Vge_di_Vdi_si*T2+T1_Vge_di*T2_Vdi_si+T1_Vdi_si*T2_Vge_di+T1*T2_Vge_di_Vdi_si);
  T10_Vge_di_Tempt_GND=(+T1_Vge_di_Tempt_GND*T2+T1_Vge_di*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_di+T1*T2_Vge_di_Tempt_GND);
#endif
T10_Vge_e=((T1_Vge_e*T2)+(T1*T2_Vge_e));
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+T1_Vge_e_Vge_di*T2+T1_Vge_e*T2_Vge_di+T1_Vge_di*T2_Vge_e+T1*T2_Vge_e_Vge_di);
  T10_Vge_e_Vge_e=(+T1_Vge_e_Vge_e*T2+T1_Vge_e*T2_Vge_e+T1_Vge_e*T2_Vge_e+T1*T2_Vge_e_Vge_e);
  T10_Vge_e_Ve_si=(+T1_Vge_e_Ve_si*T2+T1_Vge_e*T2_Ve_si+T1_Ve_si*T2_Vge_e+T1*T2_Vge_e_Ve_si);
  T10_Vge_e_Ve_di=(+T1_Vge_e_Ve_di*T2+T1_Vge_e*T2_Ve_di+T1_Ve_di*T2_Vge_e+T1*T2_Vge_e_Ve_di);
  T10_Vge_e_Vge_si=(+T1_Vge_e_Vge_si*T2+T1_Vge_e*T2_Vge_si+T1_Vge_si*T2_Vge_e+T1*T2_Vge_e_Vge_si);
  T10_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si*T2+T1_Vge_e*T2_Vdi_si+T1_Vdi_si*T2_Vge_e+T1*T2_Vge_e_Vdi_si);
  T10_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND*T2+T1_Vge_e*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_e+T1*T2_Vge_e_Tempt_GND);
#endif
T10_Ve_si=((T1_Ve_si*T2)+(T1*T2_Ve_si));
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+T1_Ve_si_Vge_di*T2+T1_Ve_si*T2_Vge_di+T1_Vge_di*T2_Ve_si+T1*T2_Ve_si_Vge_di);
  T10_Ve_si_Vge_e=(+T1_Ve_si_Vge_e*T2+T1_Ve_si*T2_Vge_e+T1_Vge_e*T2_Ve_si+T1*T2_Ve_si_Vge_e);
  T10_Ve_si_Ve_si=(+T1_Ve_si_Ve_si*T2+T1_Ve_si*T2_Ve_si+T1_Ve_si*T2_Ve_si+T1*T2_Ve_si_Ve_si);
  T10_Ve_si_Ve_di=(+T1_Ve_si_Ve_di*T2+T1_Ve_si*T2_Ve_di+T1_Ve_di*T2_Ve_si+T1*T2_Ve_si_Ve_di);
  T10_Ve_si_Vge_si=(+T1_Ve_si_Vge_si*T2+T1_Ve_si*T2_Vge_si+T1_Vge_si*T2_Ve_si+T1*T2_Ve_si_Vge_si);
  T10_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si*T2+T1_Ve_si*T2_Vdi_si+T1_Vdi_si*T2_Ve_si+T1*T2_Ve_si_Vdi_si);
  T10_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND*T2+T1_Ve_si*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_si+T1*T2_Ve_si_Tempt_GND);
#endif
T10_Ve_di=((T1_Ve_di*T2)+(T1*T2_Ve_di));
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+T1_Ve_di_Vge_di*T2+T1_Ve_di*T2_Vge_di+T1_Vge_di*T2_Ve_di+T1*T2_Ve_di_Vge_di);
  T10_Ve_di_Vge_e=(+T1_Ve_di_Vge_e*T2+T1_Ve_di*T2_Vge_e+T1_Vge_e*T2_Ve_di+T1*T2_Ve_di_Vge_e);
  T10_Ve_di_Ve_si=(+T1_Ve_di_Ve_si*T2+T1_Ve_di*T2_Ve_si+T1_Ve_si*T2_Ve_di+T1*T2_Ve_di_Ve_si);
  T10_Ve_di_Ve_di=(+T1_Ve_di_Ve_di*T2+T1_Ve_di*T2_Ve_di+T1_Ve_di*T2_Ve_di+T1*T2_Ve_di_Ve_di);
  T10_Ve_di_Vge_si=(+T1_Ve_di_Vge_si*T2+T1_Ve_di*T2_Vge_si+T1_Vge_si*T2_Ve_di+T1*T2_Ve_di_Vge_si);
  T10_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si*T2+T1_Ve_di*T2_Vdi_si+T1_Vdi_si*T2_Ve_di+T1*T2_Ve_di_Vdi_si);
  T10_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND*T2+T1_Ve_di*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_di+T1*T2_Ve_di_Tempt_GND);
#endif
T10_Vge_si=((T1_Vge_si*T2)+(T1*T2_Vge_si));
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+T1_Vge_si_Vge_di*T2+T1_Vge_si*T2_Vge_di+T1_Vge_di*T2_Vge_si+T1*T2_Vge_si_Vge_di);
  T10_Vge_si_Vge_e=(+T1_Vge_si_Vge_e*T2+T1_Vge_si*T2_Vge_e+T1_Vge_e*T2_Vge_si+T1*T2_Vge_si_Vge_e);
  T10_Vge_si_Ve_si=(+T1_Vge_si_Ve_si*T2+T1_Vge_si*T2_Ve_si+T1_Ve_si*T2_Vge_si+T1*T2_Vge_si_Ve_si);
  T10_Vge_si_Ve_di=(+T1_Vge_si_Ve_di*T2+T1_Vge_si*T2_Ve_di+T1_Ve_di*T2_Vge_si+T1*T2_Vge_si_Ve_di);
  T10_Vge_si_Vge_si=(+T1_Vge_si_Vge_si*T2+T1_Vge_si*T2_Vge_si+T1_Vge_si*T2_Vge_si+T1*T2_Vge_si_Vge_si);
  T10_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si*T2+T1_Vge_si*T2_Vdi_si+T1_Vdi_si*T2_Vge_si+T1*T2_Vge_si_Vdi_si);
  T10_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND*T2+T1_Vge_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_si+T1*T2_Vge_si_Tempt_GND);
#endif
T10_Vdi_si=((T1_Vdi_si*T2)+(T1*T2_Vdi_si));
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+T1_Vdi_si_Vge_di*T2+T1_Vdi_si*T2_Vge_di+T1_Vge_di*T2_Vdi_si+T1*T2_Vdi_si_Vge_di);
  T10_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e*T2+T1_Vdi_si*T2_Vge_e+T1_Vge_e*T2_Vdi_si+T1*T2_Vdi_si_Vge_e);
  T10_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si*T2+T1_Vdi_si*T2_Ve_si+T1_Ve_si*T2_Vdi_si+T1*T2_Vdi_si_Ve_si);
  T10_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di*T2+T1_Vdi_si*T2_Ve_di+T1_Ve_di*T2_Vdi_si+T1*T2_Vdi_si_Ve_di);
  T10_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si*T2+T1_Vdi_si*T2_Vge_si+T1_Vge_si*T2_Vdi_si+T1*T2_Vdi_si_Vge_si);
  T10_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si*T2+T1_Vdi_si*T2_Vdi_si+T1_Vdi_si*T2_Vdi_si+T1*T2_Vdi_si_Vdi_si);
  T10_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND*T2+T1_Vdi_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_si+T1*T2_Vdi_si_Tempt_GND);
#endif
T10_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+T1_Tempt_GND_Vge_di*T2+T1_Tempt_GND*T2_Vge_di+T1_Vge_di*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_di);
  T10_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e*T2+T1_Tempt_GND*T2_Vge_e+T1_Vge_e*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_e);
  T10_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si*T2+T1_Tempt_GND*T2_Ve_si+T1_Ve_si*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_si);
  T10_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di*T2+T1_Tempt_GND*T2_Ve_di+T1_Ve_di*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_di);
  T10_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si*T2+T1_Tempt_GND*T2_Vge_si+T1_Vge_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_si);
  T10_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si*T2+T1_Tempt_GND*T2_Vdi_si+T1_Vdi_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vdi_si);
  T10_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND*T2+T1_Tempt_GND*T2_Tempt_GND+T1_Tempt_GND*T2_Tempt_GND+T1*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T10=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_acc_Vge_di=(qg_acc_Vge_di-T10_Vge_di);
#if defined(_DERIVATE2)
  qg_acc_Vge_di_Vge_di=(+qg_acc_Vge_di_Vge_di-T10_Vge_di_Vge_di);
  qg_acc_Vge_di_Vge_e=(+qg_acc_Vge_di_Vge_e-T10_Vge_di_Vge_e);
  qg_acc_Vge_di_Ve_si=(+qg_acc_Vge_di_Ve_si-T10_Vge_di_Ve_si);
  qg_acc_Vge_di_Ve_di=(+qg_acc_Vge_di_Ve_di-T10_Vge_di_Ve_di);
  qg_acc_Vge_di_Vge_si=(+qg_acc_Vge_di_Vge_si-T10_Vge_di_Vge_si);
  qg_acc_Vge_di_Vdi_si=(+qg_acc_Vge_di_Vdi_si-T10_Vge_di_Vdi_si);
  qg_acc_Vge_di_Tempt_GND=(+qg_acc_Vge_di_Tempt_GND-T10_Vge_di_Tempt_GND);
#endif
qg_acc_Vge_e=(qg_acc_Vge_e-T10_Vge_e);
#if defined(_DERIVATE2)
  qg_acc_Vge_e_Vge_di=(+qg_acc_Vge_e_Vge_di-T10_Vge_e_Vge_di);
  qg_acc_Vge_e_Vge_e=(+qg_acc_Vge_e_Vge_e-T10_Vge_e_Vge_e);
  qg_acc_Vge_e_Ve_si=(+qg_acc_Vge_e_Ve_si-T10_Vge_e_Ve_si);
  qg_acc_Vge_e_Ve_di=(+qg_acc_Vge_e_Ve_di-T10_Vge_e_Ve_di);
  qg_acc_Vge_e_Vge_si=(+qg_acc_Vge_e_Vge_si-T10_Vge_e_Vge_si);
  qg_acc_Vge_e_Vdi_si=(+qg_acc_Vge_e_Vdi_si-T10_Vge_e_Vdi_si);
  qg_acc_Vge_e_Tempt_GND=(+qg_acc_Vge_e_Tempt_GND-T10_Vge_e_Tempt_GND);
#endif
qg_acc_Ve_si=(qg_acc_Ve_si-T10_Ve_si);
#if defined(_DERIVATE2)
  qg_acc_Ve_si_Vge_di=(+qg_acc_Ve_si_Vge_di-T10_Ve_si_Vge_di);
  qg_acc_Ve_si_Vge_e=(+qg_acc_Ve_si_Vge_e-T10_Ve_si_Vge_e);
  qg_acc_Ve_si_Ve_si=(+qg_acc_Ve_si_Ve_si-T10_Ve_si_Ve_si);
  qg_acc_Ve_si_Ve_di=(+qg_acc_Ve_si_Ve_di-T10_Ve_si_Ve_di);
  qg_acc_Ve_si_Vge_si=(+qg_acc_Ve_si_Vge_si-T10_Ve_si_Vge_si);
  qg_acc_Ve_si_Vdi_si=(+qg_acc_Ve_si_Vdi_si-T10_Ve_si_Vdi_si);
  qg_acc_Ve_si_Tempt_GND=(+qg_acc_Ve_si_Tempt_GND-T10_Ve_si_Tempt_GND);
#endif
qg_acc_Ve_di=(qg_acc_Ve_di-T10_Ve_di);
#if defined(_DERIVATE2)
  qg_acc_Ve_di_Vge_di=(+qg_acc_Ve_di_Vge_di-T10_Ve_di_Vge_di);
  qg_acc_Ve_di_Vge_e=(+qg_acc_Ve_di_Vge_e-T10_Ve_di_Vge_e);
  qg_acc_Ve_di_Ve_si=(+qg_acc_Ve_di_Ve_si-T10_Ve_di_Ve_si);
  qg_acc_Ve_di_Ve_di=(+qg_acc_Ve_di_Ve_di-T10_Ve_di_Ve_di);
  qg_acc_Ve_di_Vge_si=(+qg_acc_Ve_di_Vge_si-T10_Ve_di_Vge_si);
  qg_acc_Ve_di_Vdi_si=(+qg_acc_Ve_di_Vdi_si-T10_Ve_di_Vdi_si);
  qg_acc_Ve_di_Tempt_GND=(+qg_acc_Ve_di_Tempt_GND-T10_Ve_di_Tempt_GND);
#endif
qg_acc_Vge_si=(qg_acc_Vge_si-T10_Vge_si);
#if defined(_DERIVATE2)
  qg_acc_Vge_si_Vge_di=(+qg_acc_Vge_si_Vge_di-T10_Vge_si_Vge_di);
  qg_acc_Vge_si_Vge_e=(+qg_acc_Vge_si_Vge_e-T10_Vge_si_Vge_e);
  qg_acc_Vge_si_Ve_si=(+qg_acc_Vge_si_Ve_si-T10_Vge_si_Ve_si);
  qg_acc_Vge_si_Ve_di=(+qg_acc_Vge_si_Ve_di-T10_Vge_si_Ve_di);
  qg_acc_Vge_si_Vge_si=(+qg_acc_Vge_si_Vge_si-T10_Vge_si_Vge_si);
  qg_acc_Vge_si_Vdi_si=(+qg_acc_Vge_si_Vdi_si-T10_Vge_si_Vdi_si);
  qg_acc_Vge_si_Tempt_GND=(+qg_acc_Vge_si_Tempt_GND-T10_Vge_si_Tempt_GND);
#endif
qg_acc_Vdi_si=(qg_acc_Vdi_si-T10_Vdi_si);
#if defined(_DERIVATE2)
  qg_acc_Vdi_si_Vge_di=(+qg_acc_Vdi_si_Vge_di-T10_Vdi_si_Vge_di);
  qg_acc_Vdi_si_Vge_e=(+qg_acc_Vdi_si_Vge_e-T10_Vdi_si_Vge_e);
  qg_acc_Vdi_si_Ve_si=(+qg_acc_Vdi_si_Ve_si-T10_Vdi_si_Ve_si);
  qg_acc_Vdi_si_Ve_di=(+qg_acc_Vdi_si_Ve_di-T10_Vdi_si_Ve_di);
  qg_acc_Vdi_si_Vge_si=(+qg_acc_Vdi_si_Vge_si-T10_Vdi_si_Vge_si);
  qg_acc_Vdi_si_Vdi_si=(+qg_acc_Vdi_si_Vdi_si-T10_Vdi_si_Vdi_si);
  qg_acc_Vdi_si_Tempt_GND=(+qg_acc_Vdi_si_Tempt_GND-T10_Vdi_si_Tempt_GND);
#endif
qg_acc_Tempt_GND=(qg_acc_Tempt_GND-T10_Tempt_GND);
#if defined(_DERIVATE2)
  qg_acc_Tempt_GND_Vge_di=(+qg_acc_Tempt_GND_Vge_di-T10_Tempt_GND_Vge_di);
  qg_acc_Tempt_GND_Vge_e=(+qg_acc_Tempt_GND_Vge_e-T10_Tempt_GND_Vge_e);
  qg_acc_Tempt_GND_Ve_si=(+qg_acc_Tempt_GND_Ve_si-T10_Tempt_GND_Ve_si);
  qg_acc_Tempt_GND_Ve_di=(+qg_acc_Tempt_GND_Ve_di-T10_Tempt_GND_Ve_di);
  qg_acc_Tempt_GND_Vge_si=(+qg_acc_Tempt_GND_Vge_si-T10_Tempt_GND_Vge_si);
  qg_acc_Tempt_GND_Vdi_si=(+qg_acc_Tempt_GND_Vdi_si-T10_Tempt_GND_Vdi_si);
  qg_acc_Tempt_GND_Tempt_GND=(+qg_acc_Tempt_GND_Tempt_GND-T10_Tempt_GND_Tempt_GND);
#endif
#endif
qg_acc=(qg_acc-T10);
EXIT_IF_ISNAN((qg_acc-T10))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qb_acc_Vge_di=(qb_acc_Vge_di+T10_Vge_di);
#if defined(_DERIVATE2)
  qb_acc_Vge_di_Vge_di=(+qb_acc_Vge_di_Vge_di+T10_Vge_di_Vge_di);
  qb_acc_Vge_di_Vge_e=(+qb_acc_Vge_di_Vge_e+T10_Vge_di_Vge_e);
  qb_acc_Vge_di_Ve_si=(+qb_acc_Vge_di_Ve_si+T10_Vge_di_Ve_si);
  qb_acc_Vge_di_Ve_di=(+qb_acc_Vge_di_Ve_di+T10_Vge_di_Ve_di);
  qb_acc_Vge_di_Vge_si=(+qb_acc_Vge_di_Vge_si+T10_Vge_di_Vge_si);
  qb_acc_Vge_di_Vdi_si=(+qb_acc_Vge_di_Vdi_si+T10_Vge_di_Vdi_si);
  qb_acc_Vge_di_Tempt_GND=(+qb_acc_Vge_di_Tempt_GND+T10_Vge_di_Tempt_GND);
#endif
qb_acc_Vge_e=(qb_acc_Vge_e+T10_Vge_e);
#if defined(_DERIVATE2)
  qb_acc_Vge_e_Vge_di=(+qb_acc_Vge_e_Vge_di+T10_Vge_e_Vge_di);
  qb_acc_Vge_e_Vge_e=(+qb_acc_Vge_e_Vge_e+T10_Vge_e_Vge_e);
  qb_acc_Vge_e_Ve_si=(+qb_acc_Vge_e_Ve_si+T10_Vge_e_Ve_si);
  qb_acc_Vge_e_Ve_di=(+qb_acc_Vge_e_Ve_di+T10_Vge_e_Ve_di);
  qb_acc_Vge_e_Vge_si=(+qb_acc_Vge_e_Vge_si+T10_Vge_e_Vge_si);
  qb_acc_Vge_e_Vdi_si=(+qb_acc_Vge_e_Vdi_si+T10_Vge_e_Vdi_si);
  qb_acc_Vge_e_Tempt_GND=(+qb_acc_Vge_e_Tempt_GND+T10_Vge_e_Tempt_GND);
#endif
qb_acc_Ve_si=(qb_acc_Ve_si+T10_Ve_si);
#if defined(_DERIVATE2)
  qb_acc_Ve_si_Vge_di=(+qb_acc_Ve_si_Vge_di+T10_Ve_si_Vge_di);
  qb_acc_Ve_si_Vge_e=(+qb_acc_Ve_si_Vge_e+T10_Ve_si_Vge_e);
  qb_acc_Ve_si_Ve_si=(+qb_acc_Ve_si_Ve_si+T10_Ve_si_Ve_si);
  qb_acc_Ve_si_Ve_di=(+qb_acc_Ve_si_Ve_di+T10_Ve_si_Ve_di);
  qb_acc_Ve_si_Vge_si=(+qb_acc_Ve_si_Vge_si+T10_Ve_si_Vge_si);
  qb_acc_Ve_si_Vdi_si=(+qb_acc_Ve_si_Vdi_si+T10_Ve_si_Vdi_si);
  qb_acc_Ve_si_Tempt_GND=(+qb_acc_Ve_si_Tempt_GND+T10_Ve_si_Tempt_GND);
#endif
qb_acc_Ve_di=(qb_acc_Ve_di+T10_Ve_di);
#if defined(_DERIVATE2)
  qb_acc_Ve_di_Vge_di=(+qb_acc_Ve_di_Vge_di+T10_Ve_di_Vge_di);
  qb_acc_Ve_di_Vge_e=(+qb_acc_Ve_di_Vge_e+T10_Ve_di_Vge_e);
  qb_acc_Ve_di_Ve_si=(+qb_acc_Ve_di_Ve_si+T10_Ve_di_Ve_si);
  qb_acc_Ve_di_Ve_di=(+qb_acc_Ve_di_Ve_di+T10_Ve_di_Ve_di);
  qb_acc_Ve_di_Vge_si=(+qb_acc_Ve_di_Vge_si+T10_Ve_di_Vge_si);
  qb_acc_Ve_di_Vdi_si=(+qb_acc_Ve_di_Vdi_si+T10_Ve_di_Vdi_si);
  qb_acc_Ve_di_Tempt_GND=(+qb_acc_Ve_di_Tempt_GND+T10_Ve_di_Tempt_GND);
#endif
qb_acc_Vge_si=(qb_acc_Vge_si+T10_Vge_si);
#if defined(_DERIVATE2)
  qb_acc_Vge_si_Vge_di=(+qb_acc_Vge_si_Vge_di+T10_Vge_si_Vge_di);
  qb_acc_Vge_si_Vge_e=(+qb_acc_Vge_si_Vge_e+T10_Vge_si_Vge_e);
  qb_acc_Vge_si_Ve_si=(+qb_acc_Vge_si_Ve_si+T10_Vge_si_Ve_si);
  qb_acc_Vge_si_Ve_di=(+qb_acc_Vge_si_Ve_di+T10_Vge_si_Ve_di);
  qb_acc_Vge_si_Vge_si=(+qb_acc_Vge_si_Vge_si+T10_Vge_si_Vge_si);
  qb_acc_Vge_si_Vdi_si=(+qb_acc_Vge_si_Vdi_si+T10_Vge_si_Vdi_si);
  qb_acc_Vge_si_Tempt_GND=(+qb_acc_Vge_si_Tempt_GND+T10_Vge_si_Tempt_GND);
#endif
qb_acc_Vdi_si=(qb_acc_Vdi_si+T10_Vdi_si);
#if defined(_DERIVATE2)
  qb_acc_Vdi_si_Vge_di=(+qb_acc_Vdi_si_Vge_di+T10_Vdi_si_Vge_di);
  qb_acc_Vdi_si_Vge_e=(+qb_acc_Vdi_si_Vge_e+T10_Vdi_si_Vge_e);
  qb_acc_Vdi_si_Ve_si=(+qb_acc_Vdi_si_Ve_si+T10_Vdi_si_Ve_si);
  qb_acc_Vdi_si_Ve_di=(+qb_acc_Vdi_si_Ve_di+T10_Vdi_si_Ve_di);
  qb_acc_Vdi_si_Vge_si=(+qb_acc_Vdi_si_Vge_si+T10_Vdi_si_Vge_si);
  qb_acc_Vdi_si_Vdi_si=(+qb_acc_Vdi_si_Vdi_si+T10_Vdi_si_Vdi_si);
  qb_acc_Vdi_si_Tempt_GND=(+qb_acc_Vdi_si_Tempt_GND+T10_Vdi_si_Tempt_GND);
#endif
#if defined(_DERIVATE)
qb_acc_Tempt_GND=(qb_acc_Tempt_GND+T10_Tempt_GND);
#endif
#endif
qb_acc=(qb_acc+T10);
EXIT_IF_ISNAN((qb_acc+T10))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=(((NFINtotal*WeffCV0)*LeffCV)*cox);
EXIT_IF_ISNAN((((NFINtotal*WeffCV0)*LeffCV)*cox))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=((nq_Vge_e*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Vge_e*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*0.0+0.0*0.0+dqi*0.0)/(6.0*T11)-(0.0*(0.0)+(0.0)*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_e+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Vge_e*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*0.0+0.0*0.0+dqi*0.0)/(6.0*T11)-(0.0*(0.0)+(0.0)*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_e+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Vge_e*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*0.0+0.0*0.0+dqi*0.0)/(6.0*T11)-(0.0*(0.0)+(0.0)*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_e+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Vge_e=(+(+(+nq_Vge_e_Vge_e-0.0)*0.5+nq_Vge_e*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*0.0+0.0*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_e+6.0*T11_Vge_e_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Vge_si=(+(+(+nq_Vge_e_Vge_si-0.0)*0.5+nq_Vge_e*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*dqi_Vge_si+dqi_Vge_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Ve_si=(+(+(+nq_Vge_e_Ve_si-0.0)*0.5+nq_Vge_e*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*dqi_Ve_si+dqi_Ve_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Ve_di=(+(+(+nq_Vge_e_Ve_di-0.0)*0.5+nq_Vge_e*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*dqi_Ve_di+dqi_Ve_di*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_e+6.0*T11_Vge_e_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Vdi_si=(+(+(+nq_Vge_e_Vdi_si-0.0)*0.5+nq_Vge_e*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*dqi_Vdi_si+dqi_Vdi_si*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_e+6.0*T11_Vge_e_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_e_Tempt_GND=(+(+(+nq_Vge_e_Tempt_GND-0.0)*0.5+nq_Vge_e*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_e*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(-(dqi*dqi)*(6.0*T11_Vge_e)/(6.0*T11)/(6.0*T11))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+0.0*dqi_Tempt_GND+dqi_Tempt_GND*0.0+dqi*0.0)/(6.0*T11)-(0.0*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vge_e)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_e+6.0*T11_Vge_e_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_e)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
T2_Vge_si=((nq_Vge_si*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Vge_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vge_si*0.0+0.0*dqi_Vge_si+dqi*0.0)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(0.0)+(0.0)*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Vge_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vge_si*0.0+0.0*dqi_Vge_si+dqi*0.0)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(0.0)+(0.0)*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Vge_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vge_si*0.0+0.0*dqi_Vge_si+dqi*0.0)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(0.0)+(0.0)*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vge_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Vge_e=(+(+(+nq_Vge_si_Vge_e-0.0)*0.5+nq_Vge_si*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vge_si*0.0+0.0*dqi_Vge_si+dqi*0.0)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vge_si+6.0*T11_Vge_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Vge_si=(+(+(+nq_Vge_si_Vge_si-0.0)*0.5+nq_Vge_si*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vge_si_Vge_si+((+dqi_Vge_si_Vge_si*dqi+dqi_Vge_si*dqi_Vge_si+dqi_Vge_si*dqi_Vge_si+dqi*dqi_Vge_si_Vge_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Ve_si=(+(+(+nq_Vge_si_Ve_si-0.0)*0.5+nq_Vge_si*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vge_si_Ve_si+((+dqi_Vge_si_Ve_si*dqi+dqi_Vge_si*dqi_Ve_si+dqi_Ve_si*dqi_Vge_si+dqi*dqi_Vge_si_Ve_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Ve_di=(+(+(+nq_Vge_si_Ve_di-0.0)*0.5+nq_Vge_si*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vge_si_Ve_di+((+dqi_Vge_si_Ve_di*dqi+dqi_Vge_si*dqi_Ve_di+dqi_Ve_di*dqi_Vge_si+dqi*dqi_Vge_si_Ve_di)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vge_si+6.0*T11_Vge_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Vdi_si=(+(+(+nq_Vge_si_Vdi_si-0.0)*0.5+nq_Vge_si*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vge_si_Vdi_si+((+dqi_Vge_si_Vdi_si*dqi+dqi_Vge_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Vge_si+dqi*dqi_Vge_si_Vdi_si)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vge_si+6.0*T11_Vge_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vge_si_Tempt_GND=(+(+(+nq_Vge_si_Tempt_GND-0.0)*0.5+nq_Vge_si*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vge_si*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(qia_Vge_si+((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vge_si_Tempt_GND+((+dqi_Vge_si_Tempt_GND*dqi+dqi_Vge_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Vge_si+dqi*dqi_Vge_si_Tempt_GND)/(6.0*T11)-(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vge_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vge_si+6.0*T11_Vge_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vge_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
T2_Ve_si=((nq_Ve_si*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Ve_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_si*0.0+0.0*dqi_Ve_si+dqi*0.0)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(0.0)+(0.0)*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Ve_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_si*0.0+0.0*dqi_Ve_si+dqi*0.0)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(0.0)+(0.0)*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Ve_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_si*0.0+0.0*dqi_Ve_si+dqi*0.0)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(0.0)+(0.0)*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Vge_e=(+(+(+nq_Ve_si_Vge_e-0.0)*0.5+nq_Ve_si*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_si*0.0+0.0*dqi_Ve_si+dqi*0.0)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_si+6.0*T11_Ve_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Vge_si=(+(+(+nq_Ve_si_Vge_si-0.0)*0.5+nq_Ve_si*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_si_Vge_si+((+dqi_Ve_si_Vge_si*dqi+dqi_Ve_si*dqi_Vge_si+dqi_Vge_si*dqi_Ve_si+dqi*dqi_Ve_si_Vge_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Ve_si=(+(+(+nq_Ve_si_Ve_si-0.0)*0.5+nq_Ve_si*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_si_Ve_si+((+dqi_Ve_si_Ve_si*dqi+dqi_Ve_si*dqi_Ve_si+dqi_Ve_si*dqi_Ve_si+dqi*dqi_Ve_si_Ve_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Ve_di=(+(+(+nq_Ve_si_Ve_di-0.0)*0.5+nq_Ve_si*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_si_Ve_di+((+dqi_Ve_si_Ve_di*dqi+dqi_Ve_si*dqi_Ve_di+dqi_Ve_di*dqi_Ve_si+dqi*dqi_Ve_si_Ve_di)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_si+6.0*T11_Ve_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Vdi_si=(+(+(+nq_Ve_si_Vdi_si-0.0)*0.5+nq_Ve_si*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_si_Vdi_si+((+dqi_Ve_si_Vdi_si*dqi+dqi_Ve_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Ve_si+dqi*dqi_Ve_si_Vdi_si)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_si+6.0*T11_Ve_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_si_Tempt_GND=(+(+(+nq_Ve_si_Tempt_GND-0.0)*0.5+nq_Ve_si*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_si*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(qia_Ve_si+((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_si_Tempt_GND+((+dqi_Ve_si_Tempt_GND*dqi+dqi_Ve_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Ve_si+dqi*dqi_Ve_si_Tempt_GND)/(6.0*T11)-(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Ve_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_si+6.0*T11_Ve_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
T2_Ve_di=((nq_Ve_di*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Ve_di*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_di*0.0+0.0*dqi_Ve_di+dqi*0.0)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(0.0)+(0.0)*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_di+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Ve_di*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_di*0.0+0.0*dqi_Ve_di+dqi*0.0)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(0.0)+(0.0)*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_di+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Ve_di*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_di*0.0+0.0*dqi_Ve_di+dqi*0.0)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(0.0)+(0.0)*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Ve_di+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Vge_e=(+(+(+nq_Ve_di_Vge_e-0.0)*0.5+nq_Ve_di*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Ve_di*0.0+0.0*dqi_Ve_di+dqi*0.0)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Ve_di+6.0*T11_Ve_di_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Vge_si=(+(+(+nq_Ve_di_Vge_si-0.0)*0.5+nq_Ve_di*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_di_Vge_si+((+dqi_Ve_di_Vge_si*dqi+dqi_Ve_di*dqi_Vge_si+dqi_Vge_si*dqi_Ve_di+dqi*dqi_Ve_di_Vge_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Ve_si=(+(+(+nq_Ve_di_Ve_si-0.0)*0.5+nq_Ve_di*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_di_Ve_si+((+dqi_Ve_di_Ve_si*dqi+dqi_Ve_di*dqi_Ve_si+dqi_Ve_si*dqi_Ve_di+dqi*dqi_Ve_di_Ve_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Ve_di=(+(+(+nq_Ve_di_Ve_di-0.0)*0.5+nq_Ve_di*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_di_Ve_di+((+dqi_Ve_di_Ve_di*dqi+dqi_Ve_di*dqi_Ve_di+dqi_Ve_di*dqi_Ve_di+dqi*dqi_Ve_di_Ve_di)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Ve_di+6.0*T11_Ve_di_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Vdi_si=(+(+(+nq_Ve_di_Vdi_si-0.0)*0.5+nq_Ve_di*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_di_Vdi_si+((+dqi_Ve_di_Vdi_si*dqi+dqi_Ve_di*dqi_Vdi_si+dqi_Vdi_si*dqi_Ve_di+dqi*dqi_Ve_di_Vdi_si)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Ve_di+6.0*T11_Ve_di_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Ve_di_Tempt_GND=(+(+(+nq_Ve_di_Tempt_GND-0.0)*0.5+nq_Ve_di*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Ve_di*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(qia_Ve_di+((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Ve_di_Tempt_GND+((+dqi_Ve_di_Tempt_GND*dqi+dqi_Ve_di*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Ve_di+dqi*dqi_Ve_di_Tempt_GND)/(6.0*T11)-(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Ve_di)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Ve_di+6.0*T11_Ve_di_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Ve_di)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
T2_Vdi_si=((nq_Vdi_si*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Vdi_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vdi_si*0.0+0.0*dqi_Vdi_si+dqi*0.0)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(0.0)+(0.0)*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vdi_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Vdi_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vdi_si*0.0+0.0*dqi_Vdi_si+dqi*0.0)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(0.0)+(0.0)*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vdi_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Vdi_si*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vdi_si*0.0+0.0*dqi_Vdi_si+dqi*0.0)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(0.0)+(0.0)*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Vdi_si+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Vge_e=(+(+(+nq_Vdi_si_Vge_e-0.0)*0.5+nq_Vdi_si*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Vdi_si*0.0+0.0*dqi_Vdi_si+dqi*0.0)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Vge_si=(+(+(+nq_Vdi_si_Vge_si-0.0)*0.5+nq_Vdi_si*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vdi_si_Vge_si+((+dqi_Vdi_si_Vge_si*dqi+dqi_Vdi_si*dqi_Vge_si+dqi_Vge_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Vge_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Ve_si=(+(+(+nq_Vdi_si_Ve_si-0.0)*0.5+nq_Vdi_si*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vdi_si_Ve_si+((+dqi_Vdi_si_Ve_si*dqi+dqi_Vdi_si*dqi_Ve_si+dqi_Ve_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Ve_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Ve_di=(+(+(+nq_Vdi_si_Ve_di-0.0)*0.5+nq_Vdi_si*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vdi_si_Ve_di+((+dqi_Vdi_si_Ve_di*dqi+dqi_Vdi_si*dqi_Ve_di+dqi_Ve_di*dqi_Vdi_si+dqi*dqi_Vdi_si_Ve_di)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Vdi_si=(+(+(+nq_Vdi_si_Vdi_si-0.0)*0.5+nq_Vdi_si*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vdi_si_Vdi_si+((+dqi_Vdi_si_Vdi_si*dqi+dqi_Vdi_si*dqi_Vdi_si+dqi_Vdi_si*dqi_Vdi_si+dqi*dqi_Vdi_si_Vdi_si)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Vdi_si_Tempt_GND=(+(+(+nq_Vdi_si_Tempt_GND-0.0)*0.5+nq_Vdi_si*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Vdi_si*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(qia_Vdi_si+((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Vdi_si_Tempt_GND+((+dqi_Vdi_si_Tempt_GND*dqi+dqi_Vdi_si*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Vdi_si+dqi*dqi_Vdi_si_Tempt_GND)/(6.0*T11)-(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Vdi_si)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Vdi_si+6.0*T11_Vdi_si_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Vdi_si)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
T2_Tempt_GND=((nq_Tempt_GND*0.5*(qia+((dqi*dqi)/(6.0*T11))))+(((nq-1.0)*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+(+(+0.0-0.0)*0.5+nq_Tempt_GND*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Tempt_GND*0.0+0.0*dqi_Tempt_GND+dqi*0.0)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(0.0)+(0.0)*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Tempt_GND+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Vsi_s=(+(+(+0.0-0.0)*0.5+nq_Tempt_GND*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Tempt_GND*0.0+0.0*dqi_Tempt_GND+dqi*0.0)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(0.0)+(0.0)*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Tempt_GND+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Vge_di=(+(+(+0.0-0.0)*0.5+nq_Tempt_GND*0.0+0.0*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*(0.0))/(6.0*T11)/(6.0*T11))+(0.0)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Tempt_GND*0.0+0.0*dqi_Tempt_GND+dqi*0.0)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(0.0)+(0.0)*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*0.0+0.0*T11_Tempt_GND+6.0*0.0))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*(0.0)/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Vge_e=(+(+(+nq_Tempt_GND_Vge_e-0.0)*0.5+nq_Tempt_GND*0.0+nq_Vge_e*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(((0.0)*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_e)))/(6.0*T11)/(6.0*T11))+(nq_Vge_e*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+0.0+((+0.0*dqi+dqi_Tempt_GND*0.0+0.0*dqi_Tempt_GND+dqi*0.0)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vge_e))+(0.0)*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_e+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vge_e))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vge_e))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Vge_si=(+(+(+nq_Tempt_GND_Vge_si-0.0)*0.5+nq_Tempt_GND*0.0+nq_Vge_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(qia_Vge_si+(((((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vge_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vge_si*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Tempt_GND_Vge_si+((+dqi_Tempt_GND_Vge_si*dqi+dqi_Tempt_GND*dqi_Vge_si+dqi_Vge_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Vge_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vge_si))+(((dqi_Vge_si*dqi)+(dqi*dqi_Vge_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vge_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vge_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vge_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Ve_si=(+(+(+nq_Tempt_GND_Ve_si-0.0)*0.5+nq_Tempt_GND*0.0+nq_Ve_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(qia_Ve_si+(((((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_si)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_si*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Tempt_GND_Ve_si+((+dqi_Tempt_GND_Ve_si*dqi+dqi_Tempt_GND*dqi_Ve_si+dqi_Ve_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Ve_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Ve_si))+(((dqi_Ve_si*dqi)+(dqi*dqi_Ve_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Ve_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Ve_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Ve_di=(+(+(+nq_Tempt_GND_Ve_di-0.0)*0.5+nq_Tempt_GND*0.0+nq_Ve_di*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(qia_Ve_di+(((((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Ve_di)))/(6.0*T11)/(6.0*T11)))+(nq_Ve_di*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Tempt_GND_Ve_di+((+dqi_Tempt_GND_Ve_di*dqi+dqi_Tempt_GND*dqi_Ve_di+dqi_Ve_di*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Ve_di)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Ve_di))+(((dqi_Ve_di*dqi)+(dqi*dqi_Ve_di)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Ve_di+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Ve_di))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Ve_di))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Vdi_si=(+(+(+nq_Tempt_GND_Vdi_si-0.0)*0.5+nq_Tempt_GND*0.0+nq_Vdi_si*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(qia_Vdi_si+(((((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Vdi_si)))/(6.0*T11)/(6.0*T11)))+(nq_Vdi_si*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Tempt_GND_Vdi_si+((+dqi_Tempt_GND_Vdi_si*dqi+dqi_Tempt_GND*dqi_Vdi_si+dqi_Vdi_si*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Vdi_si)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Vdi_si))+(((dqi_Vdi_si*dqi)+(dqi*dqi_Vdi_si)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Vdi_si+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Vdi_si))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Vdi_si))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
  T2_Tempt_GND_Tempt_GND=(+(+(+nq_Tempt_GND_Tempt_GND-0.0)*0.5+nq_Tempt_GND*0.0+nq_Tempt_GND*0.0+(nq-1.0)*0.0)*(qia+((dqi*dqi)/(6.0*T11)))+nq_Tempt_GND*0.5*(qia_Tempt_GND+(((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11)-(dqi*dqi)*((6.0*T11_Tempt_GND)))/(6.0*T11)/(6.0*T11)))+(nq_Tempt_GND*0.5)*(qia_Tempt_GND+((((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*(6.0*T11)-(dqi*dqi)*(6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)))+((nq-1.0)*0.5)*(+qia_Tempt_GND_Tempt_GND+((+dqi_Tempt_GND_Tempt_GND*dqi+dqi_Tempt_GND*dqi_Tempt_GND+dqi_Tempt_GND*dqi_Tempt_GND+dqi*dqi_Tempt_GND_Tempt_GND)/(6.0*T11)-(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND))*((6.0*T11_Tempt_GND))+(((dqi_Tempt_GND*dqi)+(dqi*dqi_Tempt_GND)))*(6.0*T11_Tempt_GND)+(dqi*dqi)*(+0.0*T11+0.0*T11_Tempt_GND+0.0*T11_Tempt_GND+6.0*T11_Tempt_GND_Tempt_GND))/(6.0*T11)/(6.0*T11)+2*(dqi*dqi)*(6.0*T11_Tempt_GND)*((6.0*T11_Tempt_GND))/(6.0*T11)/(6.0*T11)/(6.0*T11))));
#endif
#endif
T2=(((nq-1.0)*0.5)*(qia+((dqi*dqi)/(6.0*T11))));
EXIT_IF_ISNAN((((nq-1.0)*0.5)*(qia+((dqi*dqi)/(6.0*T11)))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=((T1_Vge_di*T2)+(T1*T2_Vge_di));
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=(+T1_Vge_di_Vge_di*T2+T1_Vge_di*T2_Vge_di+T1_Vge_di*T2_Vge_di+T1*T2_Vge_di_Vge_di);
  T10_Vge_di_Vge_e=(+T1_Vge_di_Vge_e*T2+T1_Vge_di*T2_Vge_e+T1_Vge_e*T2_Vge_di+T1*T2_Vge_di_Vge_e);
  T10_Vge_di_Ve_si=(+T1_Vge_di_Ve_si*T2+T1_Vge_di*T2_Ve_si+T1_Ve_si*T2_Vge_di+T1*T2_Vge_di_Ve_si);
  T10_Vge_di_Ve_di=(+T1_Vge_di_Ve_di*T2+T1_Vge_di*T2_Ve_di+T1_Ve_di*T2_Vge_di+T1*T2_Vge_di_Ve_di);
  T10_Vge_di_Vge_si=(+T1_Vge_di_Vge_si*T2+T1_Vge_di*T2_Vge_si+T1_Vge_si*T2_Vge_di+T1*T2_Vge_di_Vge_si);
  T10_Vge_di_Vdi_si=(+T1_Vge_di_Vdi_si*T2+T1_Vge_di*T2_Vdi_si+T1_Vdi_si*T2_Vge_di+T1*T2_Vge_di_Vdi_si);
  T10_Vge_di_Tempt_GND=(+T1_Vge_di_Tempt_GND*T2+T1_Vge_di*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_di+T1*T2_Vge_di_Tempt_GND);
#endif
T10_Vge_e=((T1_Vge_e*T2)+(T1*T2_Vge_e));
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=(+T1_Vge_e_Vge_di*T2+T1_Vge_e*T2_Vge_di+T1_Vge_di*T2_Vge_e+T1*T2_Vge_e_Vge_di);
  T10_Vge_e_Vge_e=(+T1_Vge_e_Vge_e*T2+T1_Vge_e*T2_Vge_e+T1_Vge_e*T2_Vge_e+T1*T2_Vge_e_Vge_e);
  T10_Vge_e_Ve_si=(+T1_Vge_e_Ve_si*T2+T1_Vge_e*T2_Ve_si+T1_Ve_si*T2_Vge_e+T1*T2_Vge_e_Ve_si);
  T10_Vge_e_Ve_di=(+T1_Vge_e_Ve_di*T2+T1_Vge_e*T2_Ve_di+T1_Ve_di*T2_Vge_e+T1*T2_Vge_e_Ve_di);
  T10_Vge_e_Vge_si=(+T1_Vge_e_Vge_si*T2+T1_Vge_e*T2_Vge_si+T1_Vge_si*T2_Vge_e+T1*T2_Vge_e_Vge_si);
  T10_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si*T2+T1_Vge_e*T2_Vdi_si+T1_Vdi_si*T2_Vge_e+T1*T2_Vge_e_Vdi_si);
  T10_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND*T2+T1_Vge_e*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_e+T1*T2_Vge_e_Tempt_GND);
#endif
T10_Ve_si=((T1_Ve_si*T2)+(T1*T2_Ve_si));
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=(+T1_Ve_si_Vge_di*T2+T1_Ve_si*T2_Vge_di+T1_Vge_di*T2_Ve_si+T1*T2_Ve_si_Vge_di);
  T10_Ve_si_Vge_e=(+T1_Ve_si_Vge_e*T2+T1_Ve_si*T2_Vge_e+T1_Vge_e*T2_Ve_si+T1*T2_Ve_si_Vge_e);
  T10_Ve_si_Ve_si=(+T1_Ve_si_Ve_si*T2+T1_Ve_si*T2_Ve_si+T1_Ve_si*T2_Ve_si+T1*T2_Ve_si_Ve_si);
  T10_Ve_si_Ve_di=(+T1_Ve_si_Ve_di*T2+T1_Ve_si*T2_Ve_di+T1_Ve_di*T2_Ve_si+T1*T2_Ve_si_Ve_di);
  T10_Ve_si_Vge_si=(+T1_Ve_si_Vge_si*T2+T1_Ve_si*T2_Vge_si+T1_Vge_si*T2_Ve_si+T1*T2_Ve_si_Vge_si);
  T10_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si*T2+T1_Ve_si*T2_Vdi_si+T1_Vdi_si*T2_Ve_si+T1*T2_Ve_si_Vdi_si);
  T10_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND*T2+T1_Ve_si*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_si+T1*T2_Ve_si_Tempt_GND);
#endif
T10_Ve_di=((T1_Ve_di*T2)+(T1*T2_Ve_di));
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=(+T1_Ve_di_Vge_di*T2+T1_Ve_di*T2_Vge_di+T1_Vge_di*T2_Ve_di+T1*T2_Ve_di_Vge_di);
  T10_Ve_di_Vge_e=(+T1_Ve_di_Vge_e*T2+T1_Ve_di*T2_Vge_e+T1_Vge_e*T2_Ve_di+T1*T2_Ve_di_Vge_e);
  T10_Ve_di_Ve_si=(+T1_Ve_di_Ve_si*T2+T1_Ve_di*T2_Ve_si+T1_Ve_si*T2_Ve_di+T1*T2_Ve_di_Ve_si);
  T10_Ve_di_Ve_di=(+T1_Ve_di_Ve_di*T2+T1_Ve_di*T2_Ve_di+T1_Ve_di*T2_Ve_di+T1*T2_Ve_di_Ve_di);
  T10_Ve_di_Vge_si=(+T1_Ve_di_Vge_si*T2+T1_Ve_di*T2_Vge_si+T1_Vge_si*T2_Ve_di+T1*T2_Ve_di_Vge_si);
  T10_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si*T2+T1_Ve_di*T2_Vdi_si+T1_Vdi_si*T2_Ve_di+T1*T2_Ve_di_Vdi_si);
  T10_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND*T2+T1_Ve_di*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_di+T1*T2_Ve_di_Tempt_GND);
#endif
T10_Vge_si=((T1_Vge_si*T2)+(T1*T2_Vge_si));
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=(+T1_Vge_si_Vge_di*T2+T1_Vge_si*T2_Vge_di+T1_Vge_di*T2_Vge_si+T1*T2_Vge_si_Vge_di);
  T10_Vge_si_Vge_e=(+T1_Vge_si_Vge_e*T2+T1_Vge_si*T2_Vge_e+T1_Vge_e*T2_Vge_si+T1*T2_Vge_si_Vge_e);
  T10_Vge_si_Ve_si=(+T1_Vge_si_Ve_si*T2+T1_Vge_si*T2_Ve_si+T1_Ve_si*T2_Vge_si+T1*T2_Vge_si_Ve_si);
  T10_Vge_si_Ve_di=(+T1_Vge_si_Ve_di*T2+T1_Vge_si*T2_Ve_di+T1_Ve_di*T2_Vge_si+T1*T2_Vge_si_Ve_di);
  T10_Vge_si_Vge_si=(+T1_Vge_si_Vge_si*T2+T1_Vge_si*T2_Vge_si+T1_Vge_si*T2_Vge_si+T1*T2_Vge_si_Vge_si);
  T10_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si*T2+T1_Vge_si*T2_Vdi_si+T1_Vdi_si*T2_Vge_si+T1*T2_Vge_si_Vdi_si);
  T10_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND*T2+T1_Vge_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_si+T1*T2_Vge_si_Tempt_GND);
#endif
T10_Vdi_si=((T1_Vdi_si*T2)+(T1*T2_Vdi_si));
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=(+T1_Vdi_si_Vge_di*T2+T1_Vdi_si*T2_Vge_di+T1_Vge_di*T2_Vdi_si+T1*T2_Vdi_si_Vge_di);
  T10_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e*T2+T1_Vdi_si*T2_Vge_e+T1_Vge_e*T2_Vdi_si+T1*T2_Vdi_si_Vge_e);
  T10_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si*T2+T1_Vdi_si*T2_Ve_si+T1_Ve_si*T2_Vdi_si+T1*T2_Vdi_si_Ve_si);
  T10_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di*T2+T1_Vdi_si*T2_Ve_di+T1_Ve_di*T2_Vdi_si+T1*T2_Vdi_si_Ve_di);
  T10_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si*T2+T1_Vdi_si*T2_Vge_si+T1_Vge_si*T2_Vdi_si+T1*T2_Vdi_si_Vge_si);
  T10_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si*T2+T1_Vdi_si*T2_Vdi_si+T1_Vdi_si*T2_Vdi_si+T1*T2_Vdi_si_Vdi_si);
  T10_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND*T2+T1_Vdi_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_si+T1*T2_Vdi_si_Tempt_GND);
#endif
T10_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+T1_Tempt_GND_Vge_di*T2+T1_Tempt_GND*T2_Vge_di+T1_Vge_di*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_di);
  T10_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e*T2+T1_Tempt_GND*T2_Vge_e+T1_Vge_e*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_e);
  T10_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si*T2+T1_Tempt_GND*T2_Ve_si+T1_Ve_si*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_si);
  T10_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di*T2+T1_Tempt_GND*T2_Ve_di+T1_Ve_di*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_di);
  T10_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si*T2+T1_Tempt_GND*T2_Vge_si+T1_Vge_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_si);
  T10_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si*T2+T1_Tempt_GND*T2_Vdi_si+T1_Vdi_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vdi_si);
  T10_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND*T2+T1_Tempt_GND*T2_Tempt_GND+T1_Tempt_GND*T2_Tempt_GND+T1*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T10=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)V(e,GND)Temp(t,GND) */
qg_acc_Vge_di=(qg_acc_Vge_di-T10_Vge_di);
#if defined(_DERIVATE2)
  qg_acc_Vge_di_Vge_di=(+qg_acc_Vge_di_Vge_di-T10_Vge_di_Vge_di);
  qg_acc_Vge_di_Vge_e=(+qg_acc_Vge_di_Vge_e-T10_Vge_di_Vge_e);
  qg_acc_Vge_di_Ve_si=(+qg_acc_Vge_di_Ve_si-T10_Vge_di_Ve_si);
  qg_acc_Vge_di_Ve_di=(+qg_acc_Vge_di_Ve_di-T10_Vge_di_Ve_di);
  qg_acc_Vge_di_Vge_si=(+qg_acc_Vge_di_Vge_si-T10_Vge_di_Vge_si);
  qg_acc_Vge_di_Vdi_si=(+qg_acc_Vge_di_Vdi_si-T10_Vge_di_Vdi_si);
  qg_acc_Vge_di_Tempt_GND=(+qg_acc_Vge_di_Tempt_GND-T10_Vge_di_Tempt_GND);
#endif
qg_acc_Vge_e=(qg_acc_Vge_e-T10_Vge_e);
#if defined(_DERIVATE2)
  qg_acc_Vge_e_Vge_di=(+qg_acc_Vge_e_Vge_di-T10_Vge_e_Vge_di);
  qg_acc_Vge_e_Vge_e=(+qg_acc_Vge_e_Vge_e-T10_Vge_e_Vge_e);
  qg_acc_Vge_e_Ve_si=(+qg_acc_Vge_e_Ve_si-T10_Vge_e_Ve_si);
  qg_acc_Vge_e_Ve_di=(+qg_acc_Vge_e_Ve_di-T10_Vge_e_Ve_di);
  qg_acc_Vge_e_Vge_si=(+qg_acc_Vge_e_Vge_si-T10_Vge_e_Vge_si);
  qg_acc_Vge_e_Vdi_si=(+qg_acc_Vge_e_Vdi_si-T10_Vge_e_Vdi_si);
  qg_acc_Vge_e_Tempt_GND=(+qg_acc_Vge_e_Tempt_GND-T10_Vge_e_Tempt_GND);
#endif
qg_acc_Ve_si=(qg_acc_Ve_si-T10_Ve_si);
#if defined(_DERIVATE2)
  qg_acc_Ve_si_Vge_di=(+qg_acc_Ve_si_Vge_di-T10_Ve_si_Vge_di);
  qg_acc_Ve_si_Vge_e=(+qg_acc_Ve_si_Vge_e-T10_Ve_si_Vge_e);
  qg_acc_Ve_si_Ve_si=(+qg_acc_Ve_si_Ve_si-T10_Ve_si_Ve_si);
  qg_acc_Ve_si_Ve_di=(+qg_acc_Ve_si_Ve_di-T10_Ve_si_Ve_di);
  qg_acc_Ve_si_Vge_si=(+qg_acc_Ve_si_Vge_si-T10_Ve_si_Vge_si);
  qg_acc_Ve_si_Vdi_si=(+qg_acc_Ve_si_Vdi_si-T10_Ve_si_Vdi_si);
  qg_acc_Ve_si_Tempt_GND=(+qg_acc_Ve_si_Tempt_GND-T10_Ve_si_Tempt_GND);
#endif
qg_acc_Ve_di=(qg_acc_Ve_di-T10_Ve_di);
#if defined(_DERIVATE2)
  qg_acc_Ve_di_Vge_di=(+qg_acc_Ve_di_Vge_di-T10_Ve_di_Vge_di);
  qg_acc_Ve_di_Vge_e=(+qg_acc_Ve_di_Vge_e-T10_Ve_di_Vge_e);
  qg_acc_Ve_di_Ve_si=(+qg_acc_Ve_di_Ve_si-T10_Ve_di_Ve_si);
  qg_acc_Ve_di_Ve_di=(+qg_acc_Ve_di_Ve_di-T10_Ve_di_Ve_di);
  qg_acc_Ve_di_Vge_si=(+qg_acc_Ve_di_Vge_si-T10_Ve_di_Vge_si);
  qg_acc_Ve_di_Vdi_si=(+qg_acc_Ve_di_Vdi_si-T10_Ve_di_Vdi_si);
  qg_acc_Ve_di_Tempt_GND=(+qg_acc_Ve_di_Tempt_GND-T10_Ve_di_Tempt_GND);
#endif
qg_acc_Vge_si=(qg_acc_Vge_si-T10_Vge_si);
#if defined(_DERIVATE2)
  qg_acc_Vge_si_Vge_di=(+qg_acc_Vge_si_Vge_di-T10_Vge_si_Vge_di);
  qg_acc_Vge_si_Vge_e=(+qg_acc_Vge_si_Vge_e-T10_Vge_si_Vge_e);
  qg_acc_Vge_si_Ve_si=(+qg_acc_Vge_si_Ve_si-T10_Vge_si_Ve_si);
  qg_acc_Vge_si_Ve_di=(+qg_acc_Vge_si_Ve_di-T10_Vge_si_Ve_di);
  qg_acc_Vge_si_Vge_si=(+qg_acc_Vge_si_Vge_si-T10_Vge_si_Vge_si);
  qg_acc_Vge_si_Vdi_si=(+qg_acc_Vge_si_Vdi_si-T10_Vge_si_Vdi_si);
  qg_acc_Vge_si_Tempt_GND=(+qg_acc_Vge_si_Tempt_GND-T10_Vge_si_Tempt_GND);
#endif
qg_acc_Vdi_si=(qg_acc_Vdi_si-T10_Vdi_si);
#if defined(_DERIVATE2)
  qg_acc_Vdi_si_Vge_di=(+qg_acc_Vdi_si_Vge_di-T10_Vdi_si_Vge_di);
  qg_acc_Vdi_si_Vge_e=(+qg_acc_Vdi_si_Vge_e-T10_Vdi_si_Vge_e);
  qg_acc_Vdi_si_Ve_si=(+qg_acc_Vdi_si_Ve_si-T10_Vdi_si_Ve_si);
  qg_acc_Vdi_si_Ve_di=(+qg_acc_Vdi_si_Ve_di-T10_Vdi_si_Ve_di);
  qg_acc_Vdi_si_Vge_si=(+qg_acc_Vdi_si_Vge_si-T10_Vdi_si_Vge_si);
  qg_acc_Vdi_si_Vdi_si=(+qg_acc_Vdi_si_Vdi_si-T10_Vdi_si_Vdi_si);
  qg_acc_Vdi_si_Tempt_GND=(+qg_acc_Vdi_si_Tempt_GND-T10_Vdi_si_Tempt_GND);
#endif
qg_acc_Tempt_GND=(qg_acc_Tempt_GND-T10_Tempt_GND);
#if defined(_DERIVATE2)
  qg_acc_Tempt_GND_Vge_di=(+qg_acc_Tempt_GND_Vge_di-T10_Tempt_GND_Vge_di);
  qg_acc_Tempt_GND_Vge_e=(+qg_acc_Tempt_GND_Vge_e-T10_Tempt_GND_Vge_e);
  qg_acc_Tempt_GND_Ve_si=(+qg_acc_Tempt_GND_Ve_si-T10_Tempt_GND_Ve_si);
  qg_acc_Tempt_GND_Ve_di=(+qg_acc_Tempt_GND_Ve_di-T10_Tempt_GND_Ve_di);
  qg_acc_Tempt_GND_Vge_si=(+qg_acc_Tempt_GND_Vge_si-T10_Tempt_GND_Vge_si);
  qg_acc_Tempt_GND_Vdi_si=(+qg_acc_Tempt_GND_Vdi_si-T10_Tempt_GND_Vdi_si);
  qg_acc_Tempt_GND_Tempt_GND=(+qg_acc_Tempt_GND_Tempt_GND-T10_Tempt_GND_Tempt_GND);
#endif
#endif
qg_acc=(qg_acc-T10);
EXIT_IF_ISNAN((qg_acc-T10))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
qb_acc_Vge_di=(qb_acc_Vge_di+T10_Vge_di);
#if defined(_DERIVATE2)
  qb_acc_Vge_di_Vge_di=(+qb_acc_Vge_di_Vge_di+T10_Vge_di_Vge_di);
  qb_acc_Vge_di_Vge_e=(+qb_acc_Vge_di_Vge_e+T10_Vge_di_Vge_e);
  qb_acc_Vge_di_Ve_si=(+qb_acc_Vge_di_Ve_si+T10_Vge_di_Ve_si);
  qb_acc_Vge_di_Ve_di=(+qb_acc_Vge_di_Ve_di+T10_Vge_di_Ve_di);
  qb_acc_Vge_di_Vge_si=(+qb_acc_Vge_di_Vge_si+T10_Vge_di_Vge_si);
  qb_acc_Vge_di_Vdi_si=(+qb_acc_Vge_di_Vdi_si+T10_Vge_di_Vdi_si);
  qb_acc_Vge_di_Tempt_GND=(+qb_acc_Vge_di_Tempt_GND+T10_Vge_di_Tempt_GND);
#endif
qb_acc_Vge_e=(qb_acc_Vge_e+T10_Vge_e);
#if defined(_DERIVATE2)
  qb_acc_Vge_e_Vge_di=(+qb_acc_Vge_e_Vge_di+T10_Vge_e_Vge_di);
  qb_acc_Vge_e_Vge_e=(+qb_acc_Vge_e_Vge_e+T10_Vge_e_Vge_e);
  qb_acc_Vge_e_Ve_si=(+qb_acc_Vge_e_Ve_si+T10_Vge_e_Ve_si);
  qb_acc_Vge_e_Ve_di=(+qb_acc_Vge_e_Ve_di+T10_Vge_e_Ve_di);
  qb_acc_Vge_e_Vge_si=(+qb_acc_Vge_e_Vge_si+T10_Vge_e_Vge_si);
  qb_acc_Vge_e_Vdi_si=(+qb_acc_Vge_e_Vdi_si+T10_Vge_e_Vdi_si);
  qb_acc_Vge_e_Tempt_GND=(+qb_acc_Vge_e_Tempt_GND+T10_Vge_e_Tempt_GND);
#endif
qb_acc_Ve_si=(qb_acc_Ve_si+T10_Ve_si);
#if defined(_DERIVATE2)
  qb_acc_Ve_si_Vge_di=(+qb_acc_Ve_si_Vge_di+T10_Ve_si_Vge_di);
  qb_acc_Ve_si_Vge_e=(+qb_acc_Ve_si_Vge_e+T10_Ve_si_Vge_e);
  qb_acc_Ve_si_Ve_si=(+qb_acc_Ve_si_Ve_si+T10_Ve_si_Ve_si);
  qb_acc_Ve_si_Ve_di=(+qb_acc_Ve_si_Ve_di+T10_Ve_si_Ve_di);
  qb_acc_Ve_si_Vge_si=(+qb_acc_Ve_si_Vge_si+T10_Ve_si_Vge_si);
  qb_acc_Ve_si_Vdi_si=(+qb_acc_Ve_si_Vdi_si+T10_Ve_si_Vdi_si);
  qb_acc_Ve_si_Tempt_GND=(+qb_acc_Ve_si_Tempt_GND+T10_Ve_si_Tempt_GND);
#endif
qb_acc_Ve_di=(qb_acc_Ve_di+T10_Ve_di);
#if defined(_DERIVATE2)
  qb_acc_Ve_di_Vge_di=(+qb_acc_Ve_di_Vge_di+T10_Ve_di_Vge_di);
  qb_acc_Ve_di_Vge_e=(+qb_acc_Ve_di_Vge_e+T10_Ve_di_Vge_e);
  qb_acc_Ve_di_Ve_si=(+qb_acc_Ve_di_Ve_si+T10_Ve_di_Ve_si);
  qb_acc_Ve_di_Ve_di=(+qb_acc_Ve_di_Ve_di+T10_Ve_di_Ve_di);
  qb_acc_Ve_di_Vge_si=(+qb_acc_Ve_di_Vge_si+T10_Ve_di_Vge_si);
  qb_acc_Ve_di_Vdi_si=(+qb_acc_Ve_di_Vdi_si+T10_Ve_di_Vdi_si);
  qb_acc_Ve_di_Tempt_GND=(+qb_acc_Ve_di_Tempt_GND+T10_Ve_di_Tempt_GND);
#endif
qb_acc_Vge_si=(qb_acc_Vge_si+T10_Vge_si);
#if defined(_DERIVATE2)
  qb_acc_Vge_si_Vge_di=(+qb_acc_Vge_si_Vge_di+T10_Vge_si_Vge_di);
  qb_acc_Vge_si_Vge_e=(+qb_acc_Vge_si_Vge_e+T10_Vge_si_Vge_e);
  qb_acc_Vge_si_Ve_si=(+qb_acc_Vge_si_Ve_si+T10_Vge_si_Ve_si);
  qb_acc_Vge_si_Ve_di=(+qb_acc_Vge_si_Ve_di+T10_Vge_si_Ve_di);
  qb_acc_Vge_si_Vge_si=(+qb_acc_Vge_si_Vge_si+T10_Vge_si_Vge_si);
  qb_acc_Vge_si_Vdi_si=(+qb_acc_Vge_si_Vdi_si+T10_Vge_si_Vdi_si);
  qb_acc_Vge_si_Tempt_GND=(+qb_acc_Vge_si_Tempt_GND+T10_Vge_si_Tempt_GND);
#endif
qb_acc_Vdi_si=(qb_acc_Vdi_si+T10_Vdi_si);
#if defined(_DERIVATE2)
  qb_acc_Vdi_si_Vge_di=(+qb_acc_Vdi_si_Vge_di+T10_Vdi_si_Vge_di);
  qb_acc_Vdi_si_Vge_e=(+qb_acc_Vdi_si_Vge_e+T10_Vdi_si_Vge_e);
  qb_acc_Vdi_si_Ve_si=(+qb_acc_Vdi_si_Ve_si+T10_Vdi_si_Ve_si);
  qb_acc_Vdi_si_Ve_di=(+qb_acc_Vdi_si_Ve_di+T10_Vdi_si_Ve_di);
  qb_acc_Vdi_si_Vge_si=(+qb_acc_Vdi_si_Vge_si+T10_Vdi_si_Vge_si);
  qb_acc_Vdi_si_Vdi_si=(+qb_acc_Vdi_si_Vdi_si+T10_Vdi_si_Vdi_si);
  qb_acc_Vdi_si_Tempt_GND=(+qb_acc_Vdi_si_Tempt_GND+T10_Vdi_si_Tempt_GND);
#endif
#if defined(_DERIVATE)
qb_acc_Tempt_GND=(qb_acc_Tempt_GND+T10_Tempt_GND);
#endif
#endif
qb_acc=(qb_acc+T10);
EXIT_IF_ISNAN((qb_acc+T10))
#endif
}
if
((sigvds<0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=qd_Vge_e;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=qd_Vge_e_Vge_e;
  T1_Vge_e_Ve_si=qd_Vge_e_Ve_si;
  T1_Vge_e_Ve_di=qd_Vge_e_Ve_di;
  T1_Vge_e_Vge_si=qd_Vge_e_Vge_si;
  T1_Vge_e_Vdi_si=qd_Vge_e_Vdi_si;
  T1_Vge_e_Tempt_GND=qd_Vge_e_Tempt_GND;
#endif
T1_Ve_si=qd_Ve_si;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=qd_Ve_si_Vge_e;
  T1_Ve_si_Ve_si=qd_Ve_si_Ve_si;
  T1_Ve_si_Ve_di=qd_Ve_si_Ve_di;
  T1_Ve_si_Vge_si=qd_Ve_si_Vge_si;
  T1_Ve_si_Vdi_si=qd_Ve_si_Vdi_si;
  T1_Ve_si_Tempt_GND=qd_Ve_si_Tempt_GND;
#endif
T1_Ve_di=qd_Ve_di;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=qd_Ve_di_Vge_e;
  T1_Ve_di_Ve_si=qd_Ve_di_Ve_si;
  T1_Ve_di_Ve_di=qd_Ve_di_Ve_di;
  T1_Ve_di_Vge_si=qd_Ve_di_Vge_si;
  T1_Ve_di_Vdi_si=qd_Ve_di_Vdi_si;
  T1_Ve_di_Tempt_GND=qd_Ve_di_Tempt_GND;
#endif
T1_Vge_si=qd_Vge_si;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=qd_Vge_si_Vge_e;
  T1_Vge_si_Ve_si=qd_Vge_si_Ve_si;
  T1_Vge_si_Ve_di=qd_Vge_si_Ve_di;
  T1_Vge_si_Vge_si=qd_Vge_si_Vge_si;
  T1_Vge_si_Vdi_si=qd_Vge_si_Vdi_si;
  T1_Vge_si_Tempt_GND=qd_Vge_si_Tempt_GND;
#endif
T1_Vdi_si=qd_Vdi_si;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=qd_Vdi_si_Vge_e;
  T1_Vdi_si_Ve_si=qd_Vdi_si_Ve_si;
  T1_Vdi_si_Ve_di=qd_Vdi_si_Ve_di;
  T1_Vdi_si_Vge_si=qd_Vdi_si_Vge_si;
  T1_Vdi_si_Vdi_si=qd_Vdi_si_Vdi_si;
  T1_Vdi_si_Tempt_GND=qd_Vdi_si_Tempt_GND;
#endif
T1_Tempt_GND=qd_Tempt_GND;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=qd_Tempt_GND_Vge_e;
  T1_Tempt_GND_Ve_si=qd_Tempt_GND_Ve_si;
  T1_Tempt_GND_Ve_di=qd_Tempt_GND_Ve_di;
  T1_Tempt_GND_Vge_si=qd_Tempt_GND_Vge_si;
  T1_Tempt_GND_Vdi_si=qd_Tempt_GND_Vdi_si;
  T1_Tempt_GND_Tempt_GND=qd_Tempt_GND_Tempt_GND;
#endif
#endif
T1=qd;
EXIT_IF_ISNAN(qd)
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qd_Vdi_si=qs_Vdi_si;
#if defined(_DERIVATE2)
  qd_Vdi_si_Vdi_si=qs_Vdi_si_Vdi_si;
  qd_Vdi_si_Ve_si=qs_Vdi_si_Ve_si;
  qd_Vdi_si_Ve_di=qs_Vdi_si_Ve_di;
  qd_Vdi_si_Vge_si=qs_Vdi_si_Vge_si;
  qd_Vdi_si_Tempt_GND=qs_Vdi_si_Tempt_GND;
  qd_Vdi_si_Vge_e=qs_Vdi_si_Vge_e;
#endif
qd_Ve_si=qs_Ve_si;
#if defined(_DERIVATE2)
  qd_Ve_si_Vdi_si=qs_Ve_si_Vdi_si;
  qd_Ve_si_Ve_si=qs_Ve_si_Ve_si;
  qd_Ve_si_Ve_di=qs_Ve_si_Ve_di;
  qd_Ve_si_Vge_si=qs_Ve_si_Vge_si;
  qd_Ve_si_Tempt_GND=qs_Ve_si_Tempt_GND;
  qd_Ve_si_Vge_e=qs_Ve_si_Vge_e;
#endif
qd_Ve_di=qs_Ve_di;
#if defined(_DERIVATE2)
  qd_Ve_di_Vdi_si=qs_Ve_di_Vdi_si;
  qd_Ve_di_Ve_si=qs_Ve_di_Ve_si;
  qd_Ve_di_Ve_di=qs_Ve_di_Ve_di;
  qd_Ve_di_Vge_si=qs_Ve_di_Vge_si;
  qd_Ve_di_Tempt_GND=qs_Ve_di_Tempt_GND;
  qd_Ve_di_Vge_e=qs_Ve_di_Vge_e;
#endif
qd_Vge_si=qs_Vge_si;
#if defined(_DERIVATE2)
  qd_Vge_si_Vdi_si=qs_Vge_si_Vdi_si;
  qd_Vge_si_Ve_si=qs_Vge_si_Ve_si;
  qd_Vge_si_Ve_di=qs_Vge_si_Ve_di;
  qd_Vge_si_Vge_si=qs_Vge_si_Vge_si;
  qd_Vge_si_Tempt_GND=qs_Vge_si_Tempt_GND;
  qd_Vge_si_Vge_e=qs_Vge_si_Vge_e;
#endif
qd_Tempt_GND=qs_Tempt_GND;
#if defined(_DERIVATE2)
  qd_Tempt_GND_Vdi_si=qs_Tempt_GND_Vdi_si;
  qd_Tempt_GND_Ve_si=qs_Tempt_GND_Ve_si;
  qd_Tempt_GND_Ve_di=qs_Tempt_GND_Ve_di;
  qd_Tempt_GND_Vge_si=qs_Tempt_GND_Vge_si;
  qd_Tempt_GND_Tempt_GND=qs_Tempt_GND_Tempt_GND;
  qd_Tempt_GND_Vge_e=qs_Tempt_GND_Vge_e;
#endif
qd_Vge_e=qs_Vge_e;
#if defined(_DERIVATE2)
  qd_Vge_e_Vdi_si=qs_Vge_e_Vdi_si;
  qd_Vge_e_Ve_si=qs_Vge_e_Ve_si;
  qd_Vge_e_Ve_di=qs_Vge_e_Ve_di;
  qd_Vge_e_Vge_si=qs_Vge_e_Vge_si;
  qd_Vge_e_Tempt_GND=qs_Vge_e_Tempt_GND;
  qd_Vge_e_Vge_e=qs_Vge_e_Vge_e;
#endif
#endif
qd=qs;
EXIT_IF_ISNAN(qs)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(ge,e) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
qs_Vge_di=T1_Vge_di;
#if defined(_DERIVATE2)
  qs_Vge_di_Vge_di=T1_Vge_di_Vge_di;
  qs_Vge_di_Vdi_si=T1_Vge_di_Vdi_si;
  qs_Vge_di_Ve_si=T1_Vge_di_Ve_si;
  qs_Vge_di_Ve_di=T1_Vge_di_Ve_di;
  qs_Vge_di_Vge_si=T1_Vge_di_Vge_si;
  qs_Vge_di_Tempt_GND=T1_Vge_di_Tempt_GND;
  qs_Vge_di_Vge_e=T1_Vge_di_Vge_e;
#endif
qs_Vdi_si=T1_Vdi_si;
#if defined(_DERIVATE2)
  qs_Vdi_si_Vge_di=T1_Vdi_si_Vge_di;
  qs_Vdi_si_Vdi_si=T1_Vdi_si_Vdi_si;
  qs_Vdi_si_Ve_si=T1_Vdi_si_Ve_si;
  qs_Vdi_si_Ve_di=T1_Vdi_si_Ve_di;
  qs_Vdi_si_Vge_si=T1_Vdi_si_Vge_si;
  qs_Vdi_si_Tempt_GND=T1_Vdi_si_Tempt_GND;
  qs_Vdi_si_Vge_e=T1_Vdi_si_Vge_e;
#endif
qs_Ve_si=T1_Ve_si;
#if defined(_DERIVATE2)
  qs_Ve_si_Vge_di=T1_Ve_si_Vge_di;
  qs_Ve_si_Vdi_si=T1_Ve_si_Vdi_si;
  qs_Ve_si_Ve_si=T1_Ve_si_Ve_si;
  qs_Ve_si_Ve_di=T1_Ve_si_Ve_di;
  qs_Ve_si_Vge_si=T1_Ve_si_Vge_si;
  qs_Ve_si_Tempt_GND=T1_Ve_si_Tempt_GND;
  qs_Ve_si_Vge_e=T1_Ve_si_Vge_e;
#endif
qs_Ve_di=T1_Ve_di;
#if defined(_DERIVATE2)
  qs_Ve_di_Vge_di=T1_Ve_di_Vge_di;
  qs_Ve_di_Vdi_si=T1_Ve_di_Vdi_si;
  qs_Ve_di_Ve_si=T1_Ve_di_Ve_si;
  qs_Ve_di_Ve_di=T1_Ve_di_Ve_di;
  qs_Ve_di_Vge_si=T1_Ve_di_Vge_si;
  qs_Ve_di_Tempt_GND=T1_Ve_di_Tempt_GND;
  qs_Ve_di_Vge_e=T1_Ve_di_Vge_e;
#endif
qs_Vge_si=T1_Vge_si;
#if defined(_DERIVATE2)
  qs_Vge_si_Vge_di=T1_Vge_si_Vge_di;
  qs_Vge_si_Vdi_si=T1_Vge_si_Vdi_si;
  qs_Vge_si_Ve_si=T1_Vge_si_Ve_si;
  qs_Vge_si_Ve_di=T1_Vge_si_Ve_di;
  qs_Vge_si_Vge_si=T1_Vge_si_Vge_si;
  qs_Vge_si_Tempt_GND=T1_Vge_si_Tempt_GND;
  qs_Vge_si_Vge_e=T1_Vge_si_Vge_e;
#endif
qs_Tempt_GND=T1_Tempt_GND;
#if defined(_DERIVATE2)
  qs_Tempt_GND_Vge_di=T1_Tempt_GND_Vge_di;
  qs_Tempt_GND_Vdi_si=T1_Tempt_GND_Vdi_si;
  qs_Tempt_GND_Ve_si=T1_Tempt_GND_Ve_si;
  qs_Tempt_GND_Ve_di=T1_Tempt_GND_Ve_di;
  qs_Tempt_GND_Vge_si=T1_Tempt_GND_Vge_si;
  qs_Tempt_GND_Tempt_GND=T1_Tempt_GND_Tempt_GND;
  qs_Tempt_GND_Vge_e=T1_Tempt_GND_Vge_e;
#endif
qs_Vge_e=T1_Vge_e;
#if defined(_DERIVATE2)
  qs_Vge_e_Vge_di=T1_Vge_e_Vge_di;
  qs_Vge_e_Vdi_si=T1_Vge_e_Vdi_si;
  qs_Vge_e_Ve_si=T1_Vge_e_Ve_si;
  qs_Vge_e_Ve_di=T1_Vge_e_Ve_di;
  qs_Vge_e_Vge_si=T1_Vge_e_Vge_si;
  qs_Vge_e_Tempt_GND=T1_Vge_e_Tempt_GND;
  qs_Vge_e_Vge_e=T1_Vge_e_Vge_e;
#endif
#endif
qs=T1;
EXIT_IF_ISNAN(T1)
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(si,GND)Temp(t,GND)V(e,GND)V(di,GND)V(ge,GND) */
qgs_ov_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Vge_di_Vge_di=0.0;
  qgs_ov_Vge_di_Vge_e=0.0;
  qgs_ov_Vge_di_Ve_si=0.0;
  qgs_ov_Vge_di_Ve_di=0.0;
  qgs_ov_Vge_di_Vge_si=0.0;
  qgs_ov_Vge_di_Vdi_si=0.0;
  qgs_ov_Vge_di_Tempt_GND=0.0;
#endif
qgs_ov_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Vge_e_Vge_di=0.0;
  qgs_ov_Vge_e_Vge_e=0.0;
  qgs_ov_Vge_e_Ve_si=0.0;
  qgs_ov_Vge_e_Ve_di=0.0;
  qgs_ov_Vge_e_Vge_si=0.0;
  qgs_ov_Vge_e_Vdi_si=0.0;
  qgs_ov_Vge_e_Tempt_GND=0.0;
#endif
qgs_ov_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Ve_si_Vge_di=0.0;
  qgs_ov_Ve_si_Vge_e=0.0;
  qgs_ov_Ve_si_Ve_si=0.0;
  qgs_ov_Ve_si_Ve_di=0.0;
  qgs_ov_Ve_si_Vge_si=0.0;
  qgs_ov_Ve_si_Vdi_si=0.0;
  qgs_ov_Ve_si_Tempt_GND=0.0;
#endif
qgs_ov_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Ve_di_Vge_di=0.0;
  qgs_ov_Ve_di_Vge_e=0.0;
  qgs_ov_Ve_di_Ve_si=0.0;
  qgs_ov_Ve_di_Ve_di=0.0;
  qgs_ov_Ve_di_Vge_si=0.0;
  qgs_ov_Ve_di_Vdi_si=0.0;
  qgs_ov_Ve_di_Tempt_GND=0.0;
#endif
qgs_ov_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Vge_si_Vge_di=0.0;
  qgs_ov_Vge_si_Vge_e=0.0;
  qgs_ov_Vge_si_Ve_si=0.0;
  qgs_ov_Vge_si_Ve_di=0.0;
  qgs_ov_Vge_si_Vge_si=0.0;
  qgs_ov_Vge_si_Vdi_si=0.0;
  qgs_ov_Vge_si_Tempt_GND=0.0;
#endif
qgs_ov_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Vdi_si_Vge_di=0.0;
  qgs_ov_Vdi_si_Vge_e=0.0;
  qgs_ov_Vdi_si_Ve_si=0.0;
  qgs_ov_Vdi_si_Ve_di=0.0;
  qgs_ov_Vdi_si_Vge_si=0.0;
  qgs_ov_Vdi_si_Vdi_si=0.0;
  qgs_ov_Vdi_si_Tempt_GND=0.0;
#endif
qgs_ov_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgs_ov_Tempt_GND_Vge_di=0.0;
  qgs_ov_Tempt_GND_Vge_e=0.0;
  qgs_ov_Tempt_GND_Ve_si=0.0;
  qgs_ov_Tempt_GND_Ve_di=0.0;
  qgs_ov_Tempt_GND_Vge_si=0.0;
  qgs_ov_Tempt_GND_Vdi_si=0.0;
  qgs_ov_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgs_ov=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)Temp(t,GND)V(e,GND)V(si,GND)V(ge,GND) */
qgd_ov_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Vge_di_Vge_di=0.0;
  qgd_ov_Vge_di_Vge_e=0.0;
  qgd_ov_Vge_di_Ve_si=0.0;
  qgd_ov_Vge_di_Ve_di=0.0;
  qgd_ov_Vge_di_Vge_si=0.0;
  qgd_ov_Vge_di_Vdi_si=0.0;
  qgd_ov_Vge_di_Tempt_GND=0.0;
#endif
qgd_ov_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Vge_e_Vge_di=0.0;
  qgd_ov_Vge_e_Vge_e=0.0;
  qgd_ov_Vge_e_Ve_si=0.0;
  qgd_ov_Vge_e_Ve_di=0.0;
  qgd_ov_Vge_e_Vge_si=0.0;
  qgd_ov_Vge_e_Vdi_si=0.0;
  qgd_ov_Vge_e_Tempt_GND=0.0;
#endif
qgd_ov_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Ve_si_Vge_di=0.0;
  qgd_ov_Ve_si_Vge_e=0.0;
  qgd_ov_Ve_si_Ve_si=0.0;
  qgd_ov_Ve_si_Ve_di=0.0;
  qgd_ov_Ve_si_Vge_si=0.0;
  qgd_ov_Ve_si_Vdi_si=0.0;
  qgd_ov_Ve_si_Tempt_GND=0.0;
#endif
qgd_ov_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Ve_di_Vge_di=0.0;
  qgd_ov_Ve_di_Vge_e=0.0;
  qgd_ov_Ve_di_Ve_si=0.0;
  qgd_ov_Ve_di_Ve_di=0.0;
  qgd_ov_Ve_di_Vge_si=0.0;
  qgd_ov_Ve_di_Vdi_si=0.0;
  qgd_ov_Ve_di_Tempt_GND=0.0;
#endif
qgd_ov_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Vge_si_Vge_di=0.0;
  qgd_ov_Vge_si_Vge_e=0.0;
  qgd_ov_Vge_si_Ve_si=0.0;
  qgd_ov_Vge_si_Ve_di=0.0;
  qgd_ov_Vge_si_Vge_si=0.0;
  qgd_ov_Vge_si_Vdi_si=0.0;
  qgd_ov_Vge_si_Tempt_GND=0.0;
#endif
qgd_ov_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Vdi_si_Vge_di=0.0;
  qgd_ov_Vdi_si_Vge_e=0.0;
  qgd_ov_Vdi_si_Ve_si=0.0;
  qgd_ov_Vdi_si_Ve_di=0.0;
  qgd_ov_Vdi_si_Vge_si=0.0;
  qgd_ov_Vdi_si_Vdi_si=0.0;
  qgd_ov_Vdi_si_Tempt_GND=0.0;
#endif
qgd_ov_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgd_ov_Tempt_GND_Vge_di=0.0;
  qgd_ov_Tempt_GND_Vge_e=0.0;
  qgd_ov_Tempt_GND_Ve_si=0.0;
  qgd_ov_Tempt_GND_Ve_di=0.0;
  qgd_ov_Tempt_GND_Vge_si=0.0;
  qgd_ov_Tempt_GND_Vdi_si=0.0;
  qgd_ov_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgd_ov=0.0;
EXIT_IF_ISNAN(0.0)
#endif
if
((pModel->CGEOMOD!=1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=((NFINtotal*WeffCV0)*devsign);
EXIT_IF_ISNAN(((NFINtotal*WeffCV0)*devsign))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(devsign);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Vsi_s=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Vge_di=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Vge_e=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Vge_si=(+0.0*(NP(ge)-NP(si))+0.0*1.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Ve_si=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Ve_di=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Vdi_si=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_si_Tempt_GND=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+devsign*0.0);
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=(devsign*(NP(ge)-NP(si)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(si))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=T2_Vge_di;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di-0.0)+0.0);
  T0_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e-0.0)+0.0);
  T0_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si-0.0)+0.0);
  T0_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di-0.0)+0.0);
  T0_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si-0.0)+0.0);
  T0_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si-0.0)+0.0);
  T0_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND-0.0)+0.0);
#endif
T0_Vge_e=T2_Vge_e;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di-0.0)+0.0);
  T0_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e-0.0)+0.0);
  T0_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si-0.0)+0.0);
  T0_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di-0.0)+0.0);
  T0_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si-0.0)+0.0);
  T0_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si-0.0)+0.0);
  T0_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND-0.0)+0.0);
#endif
T0_Ve_si=T2_Ve_si;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di-0.0)+0.0);
  T0_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e-0.0)+0.0);
  T0_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si-0.0)+0.0);
  T0_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di-0.0)+0.0);
  T0_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si-0.0)+0.0);
  T0_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si-0.0)+0.0);
  T0_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND-0.0)+0.0);
#endif
T0_Ve_di=T2_Ve_di;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di-0.0)+0.0);
  T0_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e-0.0)+0.0);
  T0_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si-0.0)+0.0);
  T0_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di-0.0)+0.0);
  T0_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si-0.0)+0.0);
  T0_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si-0.0)+0.0);
  T0_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND-0.0)+0.0);
#endif
T0_Vge_si=T2_Vge_si;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di-0.0)+0.0);
  T0_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e-0.0)+0.0);
  T0_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si-0.0)+0.0);
  T0_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di-0.0)+0.0);
  T0_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si-0.0)+0.0);
  T0_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si-0.0)+0.0);
  T0_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND-0.0)+0.0);
#endif
T0_Vdi_si=T2_Vdi_si;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di-0.0)+0.0);
  T0_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e-0.0)+0.0);
  T0_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si-0.0)+0.0);
  T0_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di-0.0)+0.0);
  T0_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si-0.0)+0.0);
  T0_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si-0.0)+0.0);
  T0_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND-0.0)+0.0);
#endif
T0_Tempt_GND=(T2_Tempt_GND-vfbsdcv_Tempt_GND);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di-0.0)+0.0);
  T0_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e-0.0)+0.0);
  T0_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si-0.0)+0.0);
  T0_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di-0.0)+0.0);
  T0_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si-0.0)+0.0);
  T0_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si-0.0)+0.0);
  T0_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND-vfbsdcv_Tempt_GND_Tempt_GND)+0.0);
#endif
#endif
T0=((T2-vfbsdcv)+0.02);
EXIT_IF_ISNAN(((T2-vfbsdcv)+0.02))
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((T0*T0)+(4.0*0.02)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+(4.0*0.02)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
vgs_overlap_Vge_di=(0.5*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Vge_di_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_di_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Vge_e=(0.5*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Vge_e_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_e_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Ve_si=(0.5*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Ve_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Ve_di=(0.5*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Ve_di_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Ve_di_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Vge_si=(0.5*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Vge_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vge_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Vdi_si=(0.5*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Vdi_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Vdi_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgs_overlap_Tempt_GND=(0.5*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgs_overlap_Tempt_GND_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgs_overlap_Tempt_GND_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
#endif
vgs_overlap=(0.5*(T0-d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0-d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0-((4.0*vgs_overlap)/CKAPPAS_i)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-((4.0*vgs_overlap)/CKAPPAS_i)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(si,GND)Temp(t,GND)V(e,GND)V(di,GND)V(ge,GND) */
qgs_ov_Vge_di=((T1_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))));
#if defined(_DERIVATE2)
  qgs_ov_Vge_di_Vge_di=(+T1_Vge_di_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Vge_di-0.0)-vgs_overlap_Vge_di_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Vge_di)));
  qgs_ov_Vge_di_Vge_e=(+T1_Vge_di_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Vge_e-0.0)-vgs_overlap_Vge_di_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Vge_e)));
  qgs_ov_Vge_di_Ve_si=(+T1_Vge_di_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Ve_si-0.0)-vgs_overlap_Vge_di_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Ve_si)));
  qgs_ov_Vge_di_Ve_di=(+T1_Vge_di_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Ve_di-0.0)-vgs_overlap_Vge_di_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Ve_di)));
  qgs_ov_Vge_di_Vge_si=(+T1_Vge_di_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Vge_si-0.0)-vgs_overlap_Vge_di_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Vge_si)));
  qgs_ov_Vge_di_Vdi_si=(+T1_Vge_di_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Vdi_si-0.0)-vgs_overlap_Vge_di_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Vdi_si)));
  qgs_ov_Vge_di_Tempt_GND=(+T1_Vge_di_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_di*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_di_Tempt_GND-0.0)-vgs_overlap_Vge_di_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Vge_di+4.0*vgs_overlap_Vge_di_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Vge_di)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_di+CGSO_i*T2_Vge_di_Tempt_GND)));
#endif
qgs_ov_Vge_e=((T1_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))));
#if defined(_DERIVATE2)
  qgs_ov_Vge_e_Vge_di=(+T1_Vge_e_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Vge_di-0.0)-vgs_overlap_Vge_e_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Vge_di)));
  qgs_ov_Vge_e_Vge_e=(+T1_Vge_e_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Vge_e-0.0)-vgs_overlap_Vge_e_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Vge_e)));
  qgs_ov_Vge_e_Ve_si=(+T1_Vge_e_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Ve_si-0.0)-vgs_overlap_Vge_e_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Ve_si)));
  qgs_ov_Vge_e_Ve_di=(+T1_Vge_e_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Ve_di-0.0)-vgs_overlap_Vge_e_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Ve_di)));
  qgs_ov_Vge_e_Vge_si=(+T1_Vge_e_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Vge_si-0.0)-vgs_overlap_Vge_e_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Vge_si)));
  qgs_ov_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Vdi_si-0.0)-vgs_overlap_Vge_e_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Vdi_si)));
  qgs_ov_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_e*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_e_Tempt_GND-0.0)-vgs_overlap_Vge_e_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_e)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Vge_e+4.0*vgs_overlap_Vge_e_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Vge_e)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_e+CGSO_i*T2_Vge_e_Tempt_GND)));
#endif
qgs_ov_Ve_si=((T1_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))));
#if defined(_DERIVATE2)
  qgs_ov_Ve_si_Vge_di=(+T1_Ve_si_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Vge_di-0.0)-vgs_overlap_Ve_si_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Vge_di)));
  qgs_ov_Ve_si_Vge_e=(+T1_Ve_si_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Vge_e-0.0)-vgs_overlap_Ve_si_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Vge_e)));
  qgs_ov_Ve_si_Ve_si=(+T1_Ve_si_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Ve_si-0.0)-vgs_overlap_Ve_si_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Ve_si)));
  qgs_ov_Ve_si_Ve_di=(+T1_Ve_si_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Ve_di-0.0)-vgs_overlap_Ve_si_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Ve_di)));
  qgs_ov_Ve_si_Vge_si=(+T1_Ve_si_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Vge_si-0.0)-vgs_overlap_Ve_si_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Vge_si)));
  qgs_ov_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Vdi_si-0.0)-vgs_overlap_Ve_si_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Vdi_si)));
  qgs_ov_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_si*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_si_Tempt_GND-0.0)-vgs_overlap_Ve_si_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Ve_si+4.0*vgs_overlap_Ve_si_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Ve_si)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_si+CGSO_i*T2_Ve_si_Tempt_GND)));
#endif
qgs_ov_Ve_di=((T1_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))));
#if defined(_DERIVATE2)
  qgs_ov_Ve_di_Vge_di=(+T1_Ve_di_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Vge_di-0.0)-vgs_overlap_Ve_di_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Vge_di)));
  qgs_ov_Ve_di_Vge_e=(+T1_Ve_di_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Vge_e-0.0)-vgs_overlap_Ve_di_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Vge_e)));
  qgs_ov_Ve_di_Ve_si=(+T1_Ve_di_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Ve_si-0.0)-vgs_overlap_Ve_di_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Ve_si)));
  qgs_ov_Ve_di_Ve_di=(+T1_Ve_di_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Ve_di-0.0)-vgs_overlap_Ve_di_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Ve_di)));
  qgs_ov_Ve_di_Vge_si=(+T1_Ve_di_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Vge_si-0.0)-vgs_overlap_Ve_di_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Vge_si)));
  qgs_ov_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Vdi_si-0.0)-vgs_overlap_Ve_di_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Vdi_si)));
  qgs_ov_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Ve_di*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Ve_di_Tempt_GND-0.0)-vgs_overlap_Ve_di_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Ve_di)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Ve_di+4.0*vgs_overlap_Ve_di_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Ve_di)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_di+CGSO_i*T2_Ve_di_Tempt_GND)));
#endif
qgs_ov_Vge_si=((T1_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))));
#if defined(_DERIVATE2)
  qgs_ov_Vge_si_Vge_di=(+T1_Vge_si_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Vge_di-0.0)-vgs_overlap_Vge_si_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Vge_di)));
  qgs_ov_Vge_si_Vge_e=(+T1_Vge_si_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Vge_e-0.0)-vgs_overlap_Vge_si_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Vge_e)));
  qgs_ov_Vge_si_Ve_si=(+T1_Vge_si_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Ve_si-0.0)-vgs_overlap_Vge_si_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Ve_si)));
  qgs_ov_Vge_si_Ve_di=(+T1_Vge_si_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Ve_di-0.0)-vgs_overlap_Vge_si_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Ve_di)));
  qgs_ov_Vge_si_Vge_si=(+T1_Vge_si_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Vge_si-0.0)-vgs_overlap_Vge_si_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Vge_si)));
  qgs_ov_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Vdi_si-0.0)-vgs_overlap_Vge_si_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Vdi_si)));
  qgs_ov_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vge_si*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vge_si_Tempt_GND-0.0)-vgs_overlap_Vge_si_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vge_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Vge_si+4.0*vgs_overlap_Vge_si_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Vge_si)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_si+CGSO_i*T2_Vge_si_Tempt_GND)));
#endif
qgs_ov_Vdi_si=((T1_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))));
#if defined(_DERIVATE2)
  qgs_ov_Vdi_si_Vge_di=(+T1_Vdi_si_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Vge_di-0.0)-vgs_overlap_Vdi_si_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Vge_di)));
  qgs_ov_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Vge_e-0.0)-vgs_overlap_Vdi_si_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Vge_e)));
  qgs_ov_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Ve_si-0.0)-vgs_overlap_Vdi_si_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Ve_si)));
  qgs_ov_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Ve_di-0.0)-vgs_overlap_Vdi_si_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Ve_di)));
  qgs_ov_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Vge_si-0.0)-vgs_overlap_Vdi_si_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Vge_si)));
  qgs_ov_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Vdi_si-0.0)-vgs_overlap_Vdi_si_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Vdi_si)));
  qgs_ov_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Vdi_si*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Vdi_si_Tempt_GND-0.0)-vgs_overlap_Vdi_si_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Vdi_si)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Vdi_si+4.0*vgs_overlap_Vdi_si_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Vdi_si)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_si+CGSO_i*T2_Vdi_si_Tempt_GND)));
#endif
qgs_ov_Tempt_GND=((T1_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)))+(T1*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  qgs_ov_Tempt_GND_Vge_di=(+T1_Tempt_GND_Vge_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_di)))+T1_Vge_di*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgs_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Vge_di-0.0)-vgs_overlap_Tempt_GND_Vge_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_di+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Vge_di)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Vge_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Vge_di)));
  qgs_ov_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_e)))+T1_Vge_e*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgs_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Vge_e-0.0)-vgs_overlap_Tempt_GND_Vge_e)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_e))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_e+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Vge_e)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Vge_e))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Vge_e)));
  qgs_ov_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_si)))+T1_Ve_si*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgs_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Ve_si-0.0)-vgs_overlap_Tempt_GND_Ve_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_si+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Ve_si)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Ve_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Ve_si)));
  qgs_ov_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Ve_di)))+T1_Ve_di*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgs_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Ve_di-0.0)-vgs_overlap_Tempt_GND_Ve_di)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Ve_di))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Ve_di+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Ve_di)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Ve_di))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Ve_di)));
  qgs_ov_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vge_si)))+T1_Vge_si*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgs_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Vge_si-0.0)-vgs_overlap_Tempt_GND_Vge_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vge_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vge_si+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Vge_si)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Vge_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Vge_si)));
  qgs_ov_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Vdi_si)))+T1_Vdi_si*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgs_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Vdi_si-0.0)-vgs_overlap_Tempt_GND_Vdi_si)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Vdi_si))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Vdi_si+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Vdi_si)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Vdi_si))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Vdi_si)));
  qgs_ov_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))+T1_Tempt_GND*(((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))))+((CGSO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGSL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0)))+(CGSO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAS_i)*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgs_overlap_Tempt_GND)-((0.5*CKAPPAS_i)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0))+CGSL_i*(+(+(+T2_Tempt_GND_Tempt_GND-vfbsdcv_Tempt_GND_Tempt_GND)-vgs_overlap_Tempt_GND_Tempt_GND)-(+(+0.0*CKAPPAS_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*d10_sqrt0+(0.0)*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))*d10_sqrt0+(0.5*CKAPPAS_i)*(+(m20_sqrt((1.0-((4.0*vgs_overlap)/CKAPPAS_i)))*(-(((4.0*vgs_overlap_Tempt_GND))/CKAPPAS_i))*(-((4.0*vgs_overlap_Tempt_GND)/CKAPPAS_i))+d10_sqrt0*(+0.0-((+0.0*vgs_overlap+0.0*vgs_overlap_Tempt_GND+0.0*vgs_overlap_Tempt_GND+4.0*vgs_overlap_Tempt_GND_Tempt_GND)/CKAPPAS_i-((4.0*vgs_overlap_Tempt_GND)*0.0+((4.0*vgs_overlap_Tempt_GND))*0.0+(4.0*vgs_overlap)*0.0)/CKAPPAS_i/CKAPPAS_i+2*(4.0*vgs_overlap)*0.0*0.0/CKAPPAS_i/CKAPPAS_i/CKAPPAS_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Tempt_GND+CGSO_i*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
qgs_ov=(T1*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2)));
EXIT_IF_ISNAN((T1*((CGSL_i*(((T2-vfbsdcv)-vgs_overlap)-((0.5*CKAPPAS_i)*(d00_sqrt0-1.0))))+(CGSO_i*T2))))
}
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(devsign);
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Vsi_s=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Vge_di=(+0.0*(NP(ge)-NP(di))+0.0*1.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Vge_e=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Vge_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Ve_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Ve_di=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Vdi_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_di_Tempt_GND=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+devsign*0.0);
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=(devsign*(NP(ge)-NP(di)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(di))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=T2_Vge_di;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di-0.0)+0.0);
  T0_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e-0.0)+0.0);
  T0_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si-0.0)+0.0);
  T0_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di-0.0)+0.0);
  T0_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si-0.0)+0.0);
  T0_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si-0.0)+0.0);
  T0_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND-0.0)+0.0);
#endif
T0_Vge_e=T2_Vge_e;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di-0.0)+0.0);
  T0_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e-0.0)+0.0);
  T0_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si-0.0)+0.0);
  T0_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di-0.0)+0.0);
  T0_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si-0.0)+0.0);
  T0_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si-0.0)+0.0);
  T0_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND-0.0)+0.0);
#endif
T0_Ve_si=T2_Ve_si;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di-0.0)+0.0);
  T0_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e-0.0)+0.0);
  T0_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si-0.0)+0.0);
  T0_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di-0.0)+0.0);
  T0_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si-0.0)+0.0);
  T0_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si-0.0)+0.0);
  T0_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND-0.0)+0.0);
#endif
T0_Ve_di=T2_Ve_di;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di-0.0)+0.0);
  T0_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e-0.0)+0.0);
  T0_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si-0.0)+0.0);
  T0_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di-0.0)+0.0);
  T0_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si-0.0)+0.0);
  T0_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si-0.0)+0.0);
  T0_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND-0.0)+0.0);
#endif
T0_Vge_si=T2_Vge_si;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di-0.0)+0.0);
  T0_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e-0.0)+0.0);
  T0_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si-0.0)+0.0);
  T0_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di-0.0)+0.0);
  T0_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si-0.0)+0.0);
  T0_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si-0.0)+0.0);
  T0_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND-0.0)+0.0);
#endif
T0_Vdi_si=T2_Vdi_si;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di-0.0)+0.0);
  T0_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e-0.0)+0.0);
  T0_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si-0.0)+0.0);
  T0_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di-0.0)+0.0);
  T0_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si-0.0)+0.0);
  T0_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si-0.0)+0.0);
  T0_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND-0.0)+0.0);
#endif
T0_Tempt_GND=(T2_Tempt_GND-vfbsdcv_Tempt_GND);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di-0.0)+0.0);
  T0_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e-0.0)+0.0);
  T0_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si-0.0)+0.0);
  T0_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di-0.0)+0.0);
  T0_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si-0.0)+0.0);
  T0_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si-0.0)+0.0);
  T0_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND-vfbsdcv_Tempt_GND_Tempt_GND)+0.0);
#endif
#endif
T0=((T2-vfbsdcv)+0.02);
EXIT_IF_ISNAN(((T2-vfbsdcv)+0.02))
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((T0*T0)+(4.0*0.02)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+(4.0*0.02)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
vgd_overlap_Vge_di=(0.5*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Vge_di_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_di_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di-((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Vge_e=(0.5*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Vge_e_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_e_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e-((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Ve_si=(0.5*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Ve_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si-((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Ve_di=(0.5*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Ve_di_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Ve_di_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di-((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Vge_si=(0.5*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Vge_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vge_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si-((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Vdi_si=(0.5*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Vdi_si_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Vdi_si_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si-((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vgd_overlap_Tempt_GND=(0.5*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  vgd_overlap_Tempt_GND_Vge_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_di-((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Vge_e=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_e-((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_e-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Ve_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_si-((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Ve_di=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Ve_di-((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_di-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Vge_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vge_si-((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Vdi_si=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Vdi_si-((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vdi_si-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vgd_overlap_Tempt_GND_Tempt_GND=(+0.0*(T0-d00_sqrt0)+0.0*(T0_Tempt_GND-((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND-((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Tempt_GND-(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
#endif
vgd_overlap=(0.5*(T0-d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0-d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0-((4.0*vgd_overlap)/CKAPPAD_i)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0-((4.0*vgd_overlap)/CKAPPAD_i)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)Temp(t,GND)V(e,GND)V(si,GND)V(ge,GND) */
qgd_ov_Vge_di=((T1_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))));
#if defined(_DERIVATE2)
  qgd_ov_Vge_di_Vge_di=(+T1_Vge_di_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Vge_di-0.0)-vgd_overlap_Vge_di_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Vge_di)));
  qgd_ov_Vge_di_Vge_e=(+T1_Vge_di_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Vge_e-0.0)-vgd_overlap_Vge_di_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Vge_e)));
  qgd_ov_Vge_di_Ve_si=(+T1_Vge_di_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Ve_si-0.0)-vgd_overlap_Vge_di_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Ve_si)));
  qgd_ov_Vge_di_Ve_di=(+T1_Vge_di_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Ve_di-0.0)-vgd_overlap_Vge_di_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Ve_di)));
  qgd_ov_Vge_di_Vge_si=(+T1_Vge_di_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Vge_si-0.0)-vgd_overlap_Vge_di_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Vge_si)));
  qgd_ov_Vge_di_Vdi_si=(+T1_Vge_di_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Vdi_si-0.0)-vgd_overlap_Vge_di_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Vdi_si)));
  qgd_ov_Vge_di_Tempt_GND=(+T1_Vge_di_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_di*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_di_Tempt_GND-0.0)-vgd_overlap_Vge_di_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Vge_di+4.0*vgd_overlap_Vge_di_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Vge_di)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_di+CGDO_i*T2_Vge_di_Tempt_GND)));
#endif
qgd_ov_Vge_e=((T1_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))));
#if defined(_DERIVATE2)
  qgd_ov_Vge_e_Vge_di=(+T1_Vge_e_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Vge_di-0.0)-vgd_overlap_Vge_e_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Vge_di)));
  qgd_ov_Vge_e_Vge_e=(+T1_Vge_e_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Vge_e-0.0)-vgd_overlap_Vge_e_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Vge_e)));
  qgd_ov_Vge_e_Ve_si=(+T1_Vge_e_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Ve_si-0.0)-vgd_overlap_Vge_e_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Ve_si)));
  qgd_ov_Vge_e_Ve_di=(+T1_Vge_e_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Ve_di-0.0)-vgd_overlap_Vge_e_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Ve_di)));
  qgd_ov_Vge_e_Vge_si=(+T1_Vge_e_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Vge_si-0.0)-vgd_overlap_Vge_e_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Vge_si)));
  qgd_ov_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Vdi_si-0.0)-vgd_overlap_Vge_e_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Vdi_si)));
  qgd_ov_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_e*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_e))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_e_Tempt_GND-0.0)-vgd_overlap_Vge_e_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_e)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Vge_e+4.0*vgd_overlap_Vge_e_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Vge_e)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_e+CGDO_i*T2_Vge_e_Tempt_GND)));
#endif
qgd_ov_Ve_si=((T1_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))));
#if defined(_DERIVATE2)
  qgd_ov_Ve_si_Vge_di=(+T1_Ve_si_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Vge_di-0.0)-vgd_overlap_Ve_si_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Vge_di)));
  qgd_ov_Ve_si_Vge_e=(+T1_Ve_si_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Vge_e-0.0)-vgd_overlap_Ve_si_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Vge_e)));
  qgd_ov_Ve_si_Ve_si=(+T1_Ve_si_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Ve_si-0.0)-vgd_overlap_Ve_si_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Ve_si)));
  qgd_ov_Ve_si_Ve_di=(+T1_Ve_si_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Ve_di-0.0)-vgd_overlap_Ve_si_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Ve_di)));
  qgd_ov_Ve_si_Vge_si=(+T1_Ve_si_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Vge_si-0.0)-vgd_overlap_Ve_si_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Vge_si)));
  qgd_ov_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Vdi_si-0.0)-vgd_overlap_Ve_si_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Vdi_si)));
  qgd_ov_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_si*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_si_Tempt_GND-0.0)-vgd_overlap_Ve_si_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Ve_si+4.0*vgd_overlap_Ve_si_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Ve_si)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_si+CGDO_i*T2_Ve_si_Tempt_GND)));
#endif
qgd_ov_Ve_di=((T1_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))));
#if defined(_DERIVATE2)
  qgd_ov_Ve_di_Vge_di=(+T1_Ve_di_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Vge_di-0.0)-vgd_overlap_Ve_di_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Vge_di)));
  qgd_ov_Ve_di_Vge_e=(+T1_Ve_di_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Vge_e-0.0)-vgd_overlap_Ve_di_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Vge_e)));
  qgd_ov_Ve_di_Ve_si=(+T1_Ve_di_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Ve_si-0.0)-vgd_overlap_Ve_di_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Ve_si)));
  qgd_ov_Ve_di_Ve_di=(+T1_Ve_di_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Ve_di-0.0)-vgd_overlap_Ve_di_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Ve_di)));
  qgd_ov_Ve_di_Vge_si=(+T1_Ve_di_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Vge_si-0.0)-vgd_overlap_Ve_di_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Vge_si)));
  qgd_ov_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Vdi_si-0.0)-vgd_overlap_Ve_di_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Vdi_si)));
  qgd_ov_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Ve_di*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Ve_di))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Ve_di_Tempt_GND-0.0)-vgd_overlap_Ve_di_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Ve_di)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Ve_di+4.0*vgd_overlap_Ve_di_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Ve_di)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Ve_di+CGDO_i*T2_Ve_di_Tempt_GND)));
#endif
qgd_ov_Vge_si=((T1_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))));
#if defined(_DERIVATE2)
  qgd_ov_Vge_si_Vge_di=(+T1_Vge_si_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Vge_di-0.0)-vgd_overlap_Vge_si_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Vge_di)));
  qgd_ov_Vge_si_Vge_e=(+T1_Vge_si_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Vge_e-0.0)-vgd_overlap_Vge_si_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Vge_e)));
  qgd_ov_Vge_si_Ve_si=(+T1_Vge_si_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Ve_si-0.0)-vgd_overlap_Vge_si_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Ve_si)));
  qgd_ov_Vge_si_Ve_di=(+T1_Vge_si_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Ve_di-0.0)-vgd_overlap_Vge_si_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Ve_di)));
  qgd_ov_Vge_si_Vge_si=(+T1_Vge_si_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Vge_si-0.0)-vgd_overlap_Vge_si_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Vge_si)));
  qgd_ov_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Vdi_si-0.0)-vgd_overlap_Vge_si_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Vdi_si)));
  qgd_ov_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vge_si*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vge_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vge_si_Tempt_GND-0.0)-vgd_overlap_Vge_si_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vge_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Vge_si+4.0*vgd_overlap_Vge_si_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Vge_si)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vge_si+CGDO_i*T2_Vge_si_Tempt_GND)));
#endif
qgd_ov_Vdi_si=((T1_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))));
#if defined(_DERIVATE2)
  qgd_ov_Vdi_si_Vge_di=(+T1_Vdi_si_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Vge_di-0.0)-vgd_overlap_Vdi_si_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Vge_di)));
  qgd_ov_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Vge_e-0.0)-vgd_overlap_Vdi_si_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Vge_e)));
  qgd_ov_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Ve_si-0.0)-vgd_overlap_Vdi_si_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Ve_si)));
  qgd_ov_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Ve_di-0.0)-vgd_overlap_Vdi_si_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Ve_di)));
  qgd_ov_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Vge_si-0.0)-vgd_overlap_Vdi_si_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Vge_si)));
  qgd_ov_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Vdi_si-0.0)-vgd_overlap_Vdi_si_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Vdi_si)));
  qgd_ov_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Vdi_si*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Vdi_si))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Vdi_si_Tempt_GND-0.0)-vgd_overlap_Vdi_si_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Vdi_si)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Vdi_si+4.0*vgd_overlap_Vdi_si_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Vdi_si)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Vdi_si+CGDO_i*T2_Vdi_si_Tempt_GND)));
#endif
qgd_ov_Tempt_GND=((T1_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)))+(T1*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  qgd_ov_Tempt_GND_Vge_di=(+T1_Tempt_GND_Vge_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_di)))+T1_Vge_di*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_di-vgd_overlap_Vge_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Vge_di-0.0)-vgd_overlap_Tempt_GND_Vge_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_di+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Vge_di)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Vge_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_di+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Vge_di)));
  qgd_ov_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_e)))+T1_Vge_e*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_e-vgd_overlap_Vge_e)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Vge_e-0.0)-vgd_overlap_Tempt_GND_Vge_e)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_e))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_e+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Vge_e)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Vge_e))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_e+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Vge_e)));
  qgd_ov_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_si)))+T1_Ve_si*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_si-vgd_overlap_Ve_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Ve_si-0.0)-vgd_overlap_Tempt_GND_Ve_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_si+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Ve_si)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Ve_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_si+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Ve_si)));
  qgd_ov_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Ve_di)))+T1_Ve_di*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Ve_di-vgd_overlap_Ve_di)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Ve_di-0.0)-vgd_overlap_Tempt_GND_Ve_di)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Ve_di))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Ve_di+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Ve_di)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Ve_di))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Ve_di+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Ve_di)));
  qgd_ov_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vge_si)))+T1_Vge_si*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vge_si-vgd_overlap_Vge_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Vge_si-0.0)-vgd_overlap_Tempt_GND_Vge_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vge_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vge_si+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Vge_si)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Vge_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vge_si+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Vge_si)));
  qgd_ov_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Vdi_si)))+T1_Vdi_si*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*((T2_Vdi_si-vgd_overlap_Vdi_si)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Vdi_si-0.0)-vgd_overlap_Tempt_GND_Vdi_si)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Vdi_si))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Vdi_si+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Vdi_si)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Vdi_si))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Vdi_si+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Vdi_si)));
  qgd_ov_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))+T1_Tempt_GND*(((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))))+((CGDO_i*T2_Tempt_GND)))+T1_Tempt_GND*((CGDL_i*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0)))+(CGDO_i*T2_Tempt_GND))+T1*(+(+0.0*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0)))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAD_i)*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0))))+0.0*(((T2_Tempt_GND-vfbsdcv_Tempt_GND)-vgd_overlap_Tempt_GND)-((0.5*CKAPPAD_i)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0))+CGDL_i*(+(+(+T2_Tempt_GND_Tempt_GND-vfbsdcv_Tempt_GND_Tempt_GND)-vgd_overlap_Tempt_GND_Tempt_GND)-(+(+0.0*CKAPPAD_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*d10_sqrt0+(0.0)*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))*d10_sqrt0+(0.5*CKAPPAD_i)*(+(m20_sqrt((1.0-((4.0*vgd_overlap)/CKAPPAD_i)))*(-(((4.0*vgd_overlap_Tempt_GND))/CKAPPAD_i))*(-((4.0*vgd_overlap_Tempt_GND)/CKAPPAD_i))+d10_sqrt0*(+0.0-((+0.0*vgd_overlap+0.0*vgd_overlap_Tempt_GND+0.0*vgd_overlap_Tempt_GND+4.0*vgd_overlap_Tempt_GND_Tempt_GND)/CKAPPAD_i-((4.0*vgd_overlap_Tempt_GND)*0.0+((4.0*vgd_overlap_Tempt_GND))*0.0+(4.0*vgd_overlap)*0.0)/CKAPPAD_i/CKAPPAD_i+2*(4.0*vgd_overlap)*0.0*0.0/CKAPPAD_i/CKAPPAD_i/CKAPPAD_i)))-0.0))))+(+0.0*T2+0.0*T2_Tempt_GND+0.0*T2_Tempt_GND+CGDO_i*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
qgd_ov=(T1*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2)));
EXIT_IF_ISNAN((T1*((CGDL_i*(((T2-vfbsdcv)-vgd_overlap)-((0.5*CKAPPAD_i)*(d00_sqrt0-1.0))))+(CGDO_i*T2))))
}
#endif
}
if
((pModel->CGEOMOD==0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=(NFINtotal*WeffCV0);
EXIT_IF_ISNAN((NFINtotal*WeffCV0))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_fr_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_s_Vge_s=0.0;
  qgs_fr_Vge_s_Vge_di=0.0;
  qgs_fr_Vge_s_Vge_e=0.0;
  qgs_fr_Vge_s_Ve_si=0.0;
  qgs_fr_Vge_s_Ve_di=0.0;
  qgs_fr_Vge_s_Vge_si=0.0;
  qgs_fr_Vge_s_Vdi_si=0.0;
  qgs_fr_Vge_s_Tempt_GND=0.0;
#endif
qgs_fr_Vge_di=T1_Vge_di*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Vge_di_Vge_s=(+(+0.0*CFS_i+T1_Vge_di*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Vge_di=(+(+T1_Vge_di_Vge_di*CFS_i+T1_Vge_di*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Vge_e=(+(+T1_Vge_di_Vge_e*CFS_i+T1_Vge_di*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Ve_si=(+(+T1_Vge_di_Ve_si*CFS_i+T1_Vge_di*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Ve_di=(+(+T1_Vge_di_Ve_di*CFS_i+T1_Vge_di*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Vge_si=(+(+T1_Vge_di_Vge_si*CFS_i+T1_Vge_di*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Vdi_si=(+(+T1_Vge_di_Vdi_si*CFS_i+T1_Vge_di*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_di_Tempt_GND=(+(+T1_Vge_di_Tempt_GND*CFS_i+T1_Vge_di*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_di*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Vge_e=T1_Vge_e*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Vge_e_Vge_s=(+(+0.0*CFS_i+T1_Vge_e*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Vge_di=(+(+T1_Vge_e_Vge_di*CFS_i+T1_Vge_e*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Vge_e=(+(+T1_Vge_e_Vge_e*CFS_i+T1_Vge_e*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Ve_si=(+(+T1_Vge_e_Ve_si*CFS_i+T1_Vge_e*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Ve_di=(+(+T1_Vge_e_Ve_di*CFS_i+T1_Vge_e*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Vge_si=(+(+T1_Vge_e_Vge_si*CFS_i+T1_Vge_e*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Vdi_si=(+(+T1_Vge_e_Vdi_si*CFS_i+T1_Vge_e*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_e_Tempt_GND=(+(+T1_Vge_e_Tempt_GND*CFS_i+T1_Vge_e*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_e*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Ve_si=T1_Ve_si*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Ve_si_Vge_s=(+(+0.0*CFS_i+T1_Ve_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Vge_di=(+(+T1_Ve_si_Vge_di*CFS_i+T1_Ve_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Vge_e=(+(+T1_Ve_si_Vge_e*CFS_i+T1_Ve_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Ve_si=(+(+T1_Ve_si_Ve_si*CFS_i+T1_Ve_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Ve_di=(+(+T1_Ve_si_Ve_di*CFS_i+T1_Ve_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Vge_si=(+(+T1_Ve_si_Vge_si*CFS_i+T1_Ve_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Vdi_si=(+(+T1_Ve_si_Vdi_si*CFS_i+T1_Ve_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_si_Tempt_GND=(+(+T1_Ve_si_Tempt_GND*CFS_i+T1_Ve_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_si*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Ve_di=T1_Ve_di*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Ve_di_Vge_s=(+(+0.0*CFS_i+T1_Ve_di*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Vge_di=(+(+T1_Ve_di_Vge_di*CFS_i+T1_Ve_di*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Vge_e=(+(+T1_Ve_di_Vge_e*CFS_i+T1_Ve_di*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Ve_si=(+(+T1_Ve_di_Ve_si*CFS_i+T1_Ve_di*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Ve_di=(+(+T1_Ve_di_Ve_di*CFS_i+T1_Ve_di*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Vge_si=(+(+T1_Ve_di_Vge_si*CFS_i+T1_Ve_di*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Vdi_si=(+(+T1_Ve_di_Vdi_si*CFS_i+T1_Ve_di*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Ve_di_Tempt_GND=(+(+T1_Ve_di_Tempt_GND*CFS_i+T1_Ve_di*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Ve_di*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Vge_si=((T1_Vge_si*CFS_i*(NP(ge)-NP(si)))+(T1*CFS_i));
#if defined(_DERIVATE2)
  qgs_fr_Vge_si_Vge_s=(+(+0.0*CFS_i+T1_Vge_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(0.0)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Vge_di=(+(+T1_Vge_si_Vge_di*CFS_i+T1_Vge_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Vge_di*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Vge_e=(+(+T1_Vge_si_Vge_e*CFS_i+T1_Vge_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Vge_e*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Ve_si=(+(+T1_Vge_si_Ve_si*CFS_i+T1_Vge_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Ve_si*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Ve_di=(+(+T1_Vge_si_Ve_di*CFS_i+T1_Vge_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Ve_di*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Vge_si=(+(+T1_Vge_si_Vge_si*CFS_i+T1_Vge_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*1.0+(T1_Vge_si*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Vdi_si=(+(+T1_Vge_si_Vdi_si*CFS_i+T1_Vge_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Vdi_si*CFS_i)*1.0+(T1*CFS_i)*0.0);
  qgs_fr_Vge_si_Tempt_GND=(+(+T1_Vge_si_Tempt_GND*CFS_i+T1_Vge_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vge_si*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*1.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Vdi_si=T1_Vdi_si*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Vdi_si_Vge_s=(+(+0.0*CFS_i+T1_Vdi_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Vge_di=(+(+T1_Vdi_si_Vge_di*CFS_i+T1_Vdi_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Vge_e=(+(+T1_Vdi_si_Vge_e*CFS_i+T1_Vdi_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Ve_si=(+(+T1_Vdi_si_Ve_si*CFS_i+T1_Vdi_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Ve_di=(+(+T1_Vdi_si_Ve_di*CFS_i+T1_Vdi_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Vge_si=(+(+T1_Vdi_si_Vge_si*CFS_i+T1_Vdi_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Vdi_si=(+(+T1_Vdi_si_Vdi_si*CFS_i+T1_Vdi_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Vdi_si_Tempt_GND=(+(+T1_Vdi_si_Tempt_GND*CFS_i+T1_Vdi_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Vdi_si*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
qgs_fr_Tempt_GND=T1_Tempt_GND*CFS_i*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_fr_Tempt_GND_Vge_s=(+(+0.0*CFS_i+T1_Tempt_GND*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(0.0)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Vge_di=(+(+T1_Tempt_GND_Vge_di*CFS_i+T1_Tempt_GND*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Vge_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Vge_e=(+(+T1_Tempt_GND_Vge_e*CFS_i+T1_Tempt_GND*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Vge_e*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Ve_si=(+(+T1_Tempt_GND_Ve_si*CFS_i+T1_Tempt_GND*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Ve_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Ve_di=(+(+T1_Tempt_GND_Ve_di*CFS_i+T1_Tempt_GND*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Ve_di*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Vge_si=(+(+T1_Tempt_GND_Vge_si*CFS_i+T1_Tempt_GND*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*1.0+(T1_Vge_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Vdi_si=(+(+T1_Tempt_GND_Vdi_si*CFS_i+T1_Tempt_GND*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Vdi_si*CFS_i)*0.0+(T1*CFS_i)*0.0);
  qgs_fr_Tempt_GND_Tempt_GND=(+(+T1_Tempt_GND_Tempt_GND*CFS_i+T1_Tempt_GND*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(si))+T1_Tempt_GND*CFS_i*0.0+(T1_Tempt_GND*CFS_i)*0.0+(T1*CFS_i)*0.0);
#endif
#endif
qgs_fr=((T1*CFS_i)*(NP(ge)-NP(si)));
EXIT_IF_ISNAN(((T1*CFS_i)*(NP(ge)-NP(si))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_fr_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_d_Vge_d=0.0;
  qgd_fr_Vge_d_Vge_di=0.0;
  qgd_fr_Vge_d_Vge_e=0.0;
  qgd_fr_Vge_d_Ve_si=0.0;
  qgd_fr_Vge_d_Ve_di=0.0;
  qgd_fr_Vge_d_Vge_si=0.0;
  qgd_fr_Vge_d_Vdi_si=0.0;
  qgd_fr_Vge_d_Tempt_GND=0.0;
#endif
qgd_fr_Vge_di=((T1_Vge_di*CFD_i*(NP(ge)-NP(di)))+(T1*CFD_i));
#if defined(_DERIVATE2)
  qgd_fr_Vge_di_Vge_d=(+(+0.0*CFD_i+T1_Vge_di*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(0.0)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Vge_di=(+(+T1_Vge_di_Vge_di*CFD_i+T1_Vge_di*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*1.0+(T1_Vge_di*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Vge_e=(+(+T1_Vge_di_Vge_e*CFD_i+T1_Vge_di*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Vge_e*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Ve_si=(+(+T1_Vge_di_Ve_si*CFD_i+T1_Vge_di*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Ve_si*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Ve_di=(+(+T1_Vge_di_Ve_di*CFD_i+T1_Vge_di*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Ve_di*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Vge_si=(+(+T1_Vge_di_Vge_si*CFD_i+T1_Vge_di*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Vge_si*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Vdi_si=(+(+T1_Vge_di_Vdi_si*CFD_i+T1_Vge_di*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Vdi_si*CFD_i)*1.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_di_Tempt_GND=(+(+T1_Vge_di_Tempt_GND*CFD_i+T1_Vge_di*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_di*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*1.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Vge_e=T1_Vge_e*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Vge_e_Vge_d=(+(+0.0*CFD_i+T1_Vge_e*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Vge_di=(+(+T1_Vge_e_Vge_di*CFD_i+T1_Vge_e*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Vge_e=(+(+T1_Vge_e_Vge_e*CFD_i+T1_Vge_e*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Ve_si=(+(+T1_Vge_e_Ve_si*CFD_i+T1_Vge_e*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Ve_di=(+(+T1_Vge_e_Ve_di*CFD_i+T1_Vge_e*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Vge_si=(+(+T1_Vge_e_Vge_si*CFD_i+T1_Vge_e*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Vdi_si=(+(+T1_Vge_e_Vdi_si*CFD_i+T1_Vge_e*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_e_Tempt_GND=(+(+T1_Vge_e_Tempt_GND*CFD_i+T1_Vge_e*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_e*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Ve_si=T1_Ve_si*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Ve_si_Vge_d=(+(+0.0*CFD_i+T1_Ve_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Vge_di=(+(+T1_Ve_si_Vge_di*CFD_i+T1_Ve_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Vge_e=(+(+T1_Ve_si_Vge_e*CFD_i+T1_Ve_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Ve_si=(+(+T1_Ve_si_Ve_si*CFD_i+T1_Ve_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Ve_di=(+(+T1_Ve_si_Ve_di*CFD_i+T1_Ve_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Vge_si=(+(+T1_Ve_si_Vge_si*CFD_i+T1_Ve_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Vdi_si=(+(+T1_Ve_si_Vdi_si*CFD_i+T1_Ve_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_si_Tempt_GND=(+(+T1_Ve_si_Tempt_GND*CFD_i+T1_Ve_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_si*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Ve_di=T1_Ve_di*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Ve_di_Vge_d=(+(+0.0*CFD_i+T1_Ve_di*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Vge_di=(+(+T1_Ve_di_Vge_di*CFD_i+T1_Ve_di*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Vge_e=(+(+T1_Ve_di_Vge_e*CFD_i+T1_Ve_di*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Ve_si=(+(+T1_Ve_di_Ve_si*CFD_i+T1_Ve_di*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Ve_di=(+(+T1_Ve_di_Ve_di*CFD_i+T1_Ve_di*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Vge_si=(+(+T1_Ve_di_Vge_si*CFD_i+T1_Ve_di*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Vdi_si=(+(+T1_Ve_di_Vdi_si*CFD_i+T1_Ve_di*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Ve_di_Tempt_GND=(+(+T1_Ve_di_Tempt_GND*CFD_i+T1_Ve_di*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Ve_di*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Vge_si=T1_Vge_si*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Vge_si_Vge_d=(+(+0.0*CFD_i+T1_Vge_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Vge_di=(+(+T1_Vge_si_Vge_di*CFD_i+T1_Vge_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Vge_e=(+(+T1_Vge_si_Vge_e*CFD_i+T1_Vge_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Ve_si=(+(+T1_Vge_si_Ve_si*CFD_i+T1_Vge_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Ve_di=(+(+T1_Vge_si_Ve_di*CFD_i+T1_Vge_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Vge_si=(+(+T1_Vge_si_Vge_si*CFD_i+T1_Vge_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Vdi_si=(+(+T1_Vge_si_Vdi_si*CFD_i+T1_Vge_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vge_si_Tempt_GND=(+(+T1_Vge_si_Tempt_GND*CFD_i+T1_Vge_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vge_si*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Vdi_si=T1_Vdi_si*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Vdi_si_Vge_d=(+(+0.0*CFD_i+T1_Vdi_si*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Vge_di=(+(+T1_Vdi_si_Vge_di*CFD_i+T1_Vdi_si*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Vge_e=(+(+T1_Vdi_si_Vge_e*CFD_i+T1_Vdi_si*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Ve_si=(+(+T1_Vdi_si_Ve_si*CFD_i+T1_Vdi_si*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Ve_di=(+(+T1_Vdi_si_Ve_di*CFD_i+T1_Vdi_si*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Vge_si=(+(+T1_Vdi_si_Vge_si*CFD_i+T1_Vdi_si*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Vdi_si=(+(+T1_Vdi_si_Vdi_si*CFD_i+T1_Vdi_si*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Vdi_si_Tempt_GND=(+(+T1_Vdi_si_Tempt_GND*CFD_i+T1_Vdi_si*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Vdi_si*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
qgd_fr_Tempt_GND=T1_Tempt_GND*CFD_i*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_fr_Tempt_GND_Vge_d=(+(+0.0*CFD_i+T1_Tempt_GND*0.0+0.0*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(0.0)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Vge_di=(+(+T1_Tempt_GND_Vge_di*CFD_i+T1_Tempt_GND*0.0+T1_Vge_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*1.0+(T1_Vge_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Vge_e=(+(+T1_Tempt_GND_Vge_e*CFD_i+T1_Tempt_GND*0.0+T1_Vge_e*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Vge_e*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Ve_si=(+(+T1_Tempt_GND_Ve_si*CFD_i+T1_Tempt_GND*0.0+T1_Ve_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Ve_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Ve_di=(+(+T1_Tempt_GND_Ve_di*CFD_i+T1_Tempt_GND*0.0+T1_Ve_di*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Ve_di*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Vge_si=(+(+T1_Tempt_GND_Vge_si*CFD_i+T1_Tempt_GND*0.0+T1_Vge_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Vge_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Vdi_si=(+(+T1_Tempt_GND_Vdi_si*CFD_i+T1_Tempt_GND*0.0+T1_Vdi_si*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Vdi_si*CFD_i)*0.0+(T1*CFD_i)*0.0);
  qgd_fr_Tempt_GND_Tempt_GND=(+(+T1_Tempt_GND_Tempt_GND*CFD_i+T1_Tempt_GND*0.0+T1_Tempt_GND*0.0+T1*0.0)*(NP(ge)-NP(di))+T1_Tempt_GND*CFD_i*0.0+(T1_Tempt_GND*CFD_i)*0.0+(T1*CFD_i)*0.0);
#endif
#endif
qgd_fr=((T1*CFD_i)*(NP(ge)-NP(di)));
EXIT_IF_ISNAN(((T1*CFD_i)*(NP(ge)-NP(di))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_parasitic_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_s_Vge_s=0.0;
  qgs_parasitic_Vge_s_Vge_di=0.0;
  qgs_parasitic_Vge_s_Vge_e=0.0;
  qgs_parasitic_Vge_s_Ve_si=0.0;
  qgs_parasitic_Vge_s_Ve_di=0.0;
  qgs_parasitic_Vge_s_Vge_si=0.0;
  qgs_parasitic_Vge_s_Vdi_si=0.0;
  qgs_parasitic_Vge_s_Tempt_GND=0.0;
#endif
qgs_parasitic_Vge_di=(qgs_ov_Vge_di+qgs_fr_Vge_di);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_di_Vge_s=(+0.0+qgs_fr_Vge_di_Vge_s);
  qgs_parasitic_Vge_di_Vge_di=(+qgs_ov_Vge_di_Vge_di+qgs_fr_Vge_di_Vge_di);
  qgs_parasitic_Vge_di_Vge_e=(+qgs_ov_Vge_di_Vge_e+qgs_fr_Vge_di_Vge_e);
  qgs_parasitic_Vge_di_Ve_si=(+qgs_ov_Vge_di_Ve_si+qgs_fr_Vge_di_Ve_si);
  qgs_parasitic_Vge_di_Ve_di=(+qgs_ov_Vge_di_Ve_di+qgs_fr_Vge_di_Ve_di);
  qgs_parasitic_Vge_di_Vge_si=(+qgs_ov_Vge_di_Vge_si+qgs_fr_Vge_di_Vge_si);
  qgs_parasitic_Vge_di_Vdi_si=(+qgs_ov_Vge_di_Vdi_si+qgs_fr_Vge_di_Vdi_si);
  qgs_parasitic_Vge_di_Tempt_GND=(+qgs_ov_Vge_di_Tempt_GND+qgs_fr_Vge_di_Tempt_GND);
#endif
qgs_parasitic_Vge_e=(qgs_ov_Vge_e+qgs_fr_Vge_e);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_e_Vge_s=(+0.0+qgs_fr_Vge_e_Vge_s);
  qgs_parasitic_Vge_e_Vge_di=(+qgs_ov_Vge_e_Vge_di+qgs_fr_Vge_e_Vge_di);
  qgs_parasitic_Vge_e_Vge_e=(+qgs_ov_Vge_e_Vge_e+qgs_fr_Vge_e_Vge_e);
  qgs_parasitic_Vge_e_Ve_si=(+qgs_ov_Vge_e_Ve_si+qgs_fr_Vge_e_Ve_si);
  qgs_parasitic_Vge_e_Ve_di=(+qgs_ov_Vge_e_Ve_di+qgs_fr_Vge_e_Ve_di);
  qgs_parasitic_Vge_e_Vge_si=(+qgs_ov_Vge_e_Vge_si+qgs_fr_Vge_e_Vge_si);
  qgs_parasitic_Vge_e_Vdi_si=(+qgs_ov_Vge_e_Vdi_si+qgs_fr_Vge_e_Vdi_si);
  qgs_parasitic_Vge_e_Tempt_GND=(+qgs_ov_Vge_e_Tempt_GND+qgs_fr_Vge_e_Tempt_GND);
#endif
qgs_parasitic_Ve_si=(qgs_ov_Ve_si+qgs_fr_Ve_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_si_Vge_s=(+0.0+qgs_fr_Ve_si_Vge_s);
  qgs_parasitic_Ve_si_Vge_di=(+qgs_ov_Ve_si_Vge_di+qgs_fr_Ve_si_Vge_di);
  qgs_parasitic_Ve_si_Vge_e=(+qgs_ov_Ve_si_Vge_e+qgs_fr_Ve_si_Vge_e);
  qgs_parasitic_Ve_si_Ve_si=(+qgs_ov_Ve_si_Ve_si+qgs_fr_Ve_si_Ve_si);
  qgs_parasitic_Ve_si_Ve_di=(+qgs_ov_Ve_si_Ve_di+qgs_fr_Ve_si_Ve_di);
  qgs_parasitic_Ve_si_Vge_si=(+qgs_ov_Ve_si_Vge_si+qgs_fr_Ve_si_Vge_si);
  qgs_parasitic_Ve_si_Vdi_si=(+qgs_ov_Ve_si_Vdi_si+qgs_fr_Ve_si_Vdi_si);
  qgs_parasitic_Ve_si_Tempt_GND=(+qgs_ov_Ve_si_Tempt_GND+qgs_fr_Ve_si_Tempt_GND);
#endif
qgs_parasitic_Ve_di=(qgs_ov_Ve_di+qgs_fr_Ve_di);
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_di_Vge_s=(+0.0+qgs_fr_Ve_di_Vge_s);
  qgs_parasitic_Ve_di_Vge_di=(+qgs_ov_Ve_di_Vge_di+qgs_fr_Ve_di_Vge_di);
  qgs_parasitic_Ve_di_Vge_e=(+qgs_ov_Ve_di_Vge_e+qgs_fr_Ve_di_Vge_e);
  qgs_parasitic_Ve_di_Ve_si=(+qgs_ov_Ve_di_Ve_si+qgs_fr_Ve_di_Ve_si);
  qgs_parasitic_Ve_di_Ve_di=(+qgs_ov_Ve_di_Ve_di+qgs_fr_Ve_di_Ve_di);
  qgs_parasitic_Ve_di_Vge_si=(+qgs_ov_Ve_di_Vge_si+qgs_fr_Ve_di_Vge_si);
  qgs_parasitic_Ve_di_Vdi_si=(+qgs_ov_Ve_di_Vdi_si+qgs_fr_Ve_di_Vdi_si);
  qgs_parasitic_Ve_di_Tempt_GND=(+qgs_ov_Ve_di_Tempt_GND+qgs_fr_Ve_di_Tempt_GND);
#endif
qgs_parasitic_Vge_si=(qgs_ov_Vge_si+qgs_fr_Vge_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_si_Vge_s=(+0.0+qgs_fr_Vge_si_Vge_s);
  qgs_parasitic_Vge_si_Vge_di=(+qgs_ov_Vge_si_Vge_di+qgs_fr_Vge_si_Vge_di);
  qgs_parasitic_Vge_si_Vge_e=(+qgs_ov_Vge_si_Vge_e+qgs_fr_Vge_si_Vge_e);
  qgs_parasitic_Vge_si_Ve_si=(+qgs_ov_Vge_si_Ve_si+qgs_fr_Vge_si_Ve_si);
  qgs_parasitic_Vge_si_Ve_di=(+qgs_ov_Vge_si_Ve_di+qgs_fr_Vge_si_Ve_di);
  qgs_parasitic_Vge_si_Vge_si=(+qgs_ov_Vge_si_Vge_si+qgs_fr_Vge_si_Vge_si);
  qgs_parasitic_Vge_si_Vdi_si=(+qgs_ov_Vge_si_Vdi_si+qgs_fr_Vge_si_Vdi_si);
  qgs_parasitic_Vge_si_Tempt_GND=(+qgs_ov_Vge_si_Tempt_GND+qgs_fr_Vge_si_Tempt_GND);
#endif
qgs_parasitic_Vdi_si=(qgs_ov_Vdi_si+qgs_fr_Vdi_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Vdi_si_Vge_s=(+0.0+qgs_fr_Vdi_si_Vge_s);
  qgs_parasitic_Vdi_si_Vge_di=(+qgs_ov_Vdi_si_Vge_di+qgs_fr_Vdi_si_Vge_di);
  qgs_parasitic_Vdi_si_Vge_e=(+qgs_ov_Vdi_si_Vge_e+qgs_fr_Vdi_si_Vge_e);
  qgs_parasitic_Vdi_si_Ve_si=(+qgs_ov_Vdi_si_Ve_si+qgs_fr_Vdi_si_Ve_si);
  qgs_parasitic_Vdi_si_Ve_di=(+qgs_ov_Vdi_si_Ve_di+qgs_fr_Vdi_si_Ve_di);
  qgs_parasitic_Vdi_si_Vge_si=(+qgs_ov_Vdi_si_Vge_si+qgs_fr_Vdi_si_Vge_si);
  qgs_parasitic_Vdi_si_Vdi_si=(+qgs_ov_Vdi_si_Vdi_si+qgs_fr_Vdi_si_Vdi_si);
  qgs_parasitic_Vdi_si_Tempt_GND=(+qgs_ov_Vdi_si_Tempt_GND+qgs_fr_Vdi_si_Tempt_GND);
#endif
qgs_parasitic_Tempt_GND=(qgs_ov_Tempt_GND+qgs_fr_Tempt_GND);
#if defined(_DERIVATE2)
  qgs_parasitic_Tempt_GND_Vge_s=(+0.0+qgs_fr_Tempt_GND_Vge_s);
  qgs_parasitic_Tempt_GND_Vge_di=(+qgs_ov_Tempt_GND_Vge_di+qgs_fr_Tempt_GND_Vge_di);
  qgs_parasitic_Tempt_GND_Vge_e=(+qgs_ov_Tempt_GND_Vge_e+qgs_fr_Tempt_GND_Vge_e);
  qgs_parasitic_Tempt_GND_Ve_si=(+qgs_ov_Tempt_GND_Ve_si+qgs_fr_Tempt_GND_Ve_si);
  qgs_parasitic_Tempt_GND_Ve_di=(+qgs_ov_Tempt_GND_Ve_di+qgs_fr_Tempt_GND_Ve_di);
  qgs_parasitic_Tempt_GND_Vge_si=(+qgs_ov_Tempt_GND_Vge_si+qgs_fr_Tempt_GND_Vge_si);
  qgs_parasitic_Tempt_GND_Vdi_si=(+qgs_ov_Tempt_GND_Vdi_si+qgs_fr_Tempt_GND_Vdi_si);
  qgs_parasitic_Tempt_GND_Tempt_GND=(+qgs_ov_Tempt_GND_Tempt_GND+qgs_fr_Tempt_GND_Tempt_GND);
#endif
#endif
qgs_parasitic=(qgs_ov+qgs_fr);
EXIT_IF_ISNAN((qgs_ov+qgs_fr))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_parasitic_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_d_Vge_d=0.0;
  qgd_parasitic_Vge_d_Vge_di=0.0;
  qgd_parasitic_Vge_d_Vge_e=0.0;
  qgd_parasitic_Vge_d_Ve_si=0.0;
  qgd_parasitic_Vge_d_Ve_di=0.0;
  qgd_parasitic_Vge_d_Vge_si=0.0;
  qgd_parasitic_Vge_d_Vdi_si=0.0;
  qgd_parasitic_Vge_d_Tempt_GND=0.0;
#endif
qgd_parasitic_Vge_di=(qgd_ov_Vge_di+qgd_fr_Vge_di);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_di_Vge_d=(+0.0+qgd_fr_Vge_di_Vge_d);
  qgd_parasitic_Vge_di_Vge_di=(+qgd_ov_Vge_di_Vge_di+qgd_fr_Vge_di_Vge_di);
  qgd_parasitic_Vge_di_Vge_e=(+qgd_ov_Vge_di_Vge_e+qgd_fr_Vge_di_Vge_e);
  qgd_parasitic_Vge_di_Ve_si=(+qgd_ov_Vge_di_Ve_si+qgd_fr_Vge_di_Ve_si);
  qgd_parasitic_Vge_di_Ve_di=(+qgd_ov_Vge_di_Ve_di+qgd_fr_Vge_di_Ve_di);
  qgd_parasitic_Vge_di_Vge_si=(+qgd_ov_Vge_di_Vge_si+qgd_fr_Vge_di_Vge_si);
  qgd_parasitic_Vge_di_Vdi_si=(+qgd_ov_Vge_di_Vdi_si+qgd_fr_Vge_di_Vdi_si);
  qgd_parasitic_Vge_di_Tempt_GND=(+qgd_ov_Vge_di_Tempt_GND+qgd_fr_Vge_di_Tempt_GND);
#endif
qgd_parasitic_Vge_e=(qgd_ov_Vge_e+qgd_fr_Vge_e);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_e_Vge_d=(+0.0+qgd_fr_Vge_e_Vge_d);
  qgd_parasitic_Vge_e_Vge_di=(+qgd_ov_Vge_e_Vge_di+qgd_fr_Vge_e_Vge_di);
  qgd_parasitic_Vge_e_Vge_e=(+qgd_ov_Vge_e_Vge_e+qgd_fr_Vge_e_Vge_e);
  qgd_parasitic_Vge_e_Ve_si=(+qgd_ov_Vge_e_Ve_si+qgd_fr_Vge_e_Ve_si);
  qgd_parasitic_Vge_e_Ve_di=(+qgd_ov_Vge_e_Ve_di+qgd_fr_Vge_e_Ve_di);
  qgd_parasitic_Vge_e_Vge_si=(+qgd_ov_Vge_e_Vge_si+qgd_fr_Vge_e_Vge_si);
  qgd_parasitic_Vge_e_Vdi_si=(+qgd_ov_Vge_e_Vdi_si+qgd_fr_Vge_e_Vdi_si);
  qgd_parasitic_Vge_e_Tempt_GND=(+qgd_ov_Vge_e_Tempt_GND+qgd_fr_Vge_e_Tempt_GND);
#endif
qgd_parasitic_Ve_si=(qgd_ov_Ve_si+qgd_fr_Ve_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_si_Vge_d=(+0.0+qgd_fr_Ve_si_Vge_d);
  qgd_parasitic_Ve_si_Vge_di=(+qgd_ov_Ve_si_Vge_di+qgd_fr_Ve_si_Vge_di);
  qgd_parasitic_Ve_si_Vge_e=(+qgd_ov_Ve_si_Vge_e+qgd_fr_Ve_si_Vge_e);
  qgd_parasitic_Ve_si_Ve_si=(+qgd_ov_Ve_si_Ve_si+qgd_fr_Ve_si_Ve_si);
  qgd_parasitic_Ve_si_Ve_di=(+qgd_ov_Ve_si_Ve_di+qgd_fr_Ve_si_Ve_di);
  qgd_parasitic_Ve_si_Vge_si=(+qgd_ov_Ve_si_Vge_si+qgd_fr_Ve_si_Vge_si);
  qgd_parasitic_Ve_si_Vdi_si=(+qgd_ov_Ve_si_Vdi_si+qgd_fr_Ve_si_Vdi_si);
  qgd_parasitic_Ve_si_Tempt_GND=(+qgd_ov_Ve_si_Tempt_GND+qgd_fr_Ve_si_Tempt_GND);
#endif
qgd_parasitic_Ve_di=(qgd_ov_Ve_di+qgd_fr_Ve_di);
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_di_Vge_d=(+0.0+qgd_fr_Ve_di_Vge_d);
  qgd_parasitic_Ve_di_Vge_di=(+qgd_ov_Ve_di_Vge_di+qgd_fr_Ve_di_Vge_di);
  qgd_parasitic_Ve_di_Vge_e=(+qgd_ov_Ve_di_Vge_e+qgd_fr_Ve_di_Vge_e);
  qgd_parasitic_Ve_di_Ve_si=(+qgd_ov_Ve_di_Ve_si+qgd_fr_Ve_di_Ve_si);
  qgd_parasitic_Ve_di_Ve_di=(+qgd_ov_Ve_di_Ve_di+qgd_fr_Ve_di_Ve_di);
  qgd_parasitic_Ve_di_Vge_si=(+qgd_ov_Ve_di_Vge_si+qgd_fr_Ve_di_Vge_si);
  qgd_parasitic_Ve_di_Vdi_si=(+qgd_ov_Ve_di_Vdi_si+qgd_fr_Ve_di_Vdi_si);
  qgd_parasitic_Ve_di_Tempt_GND=(+qgd_ov_Ve_di_Tempt_GND+qgd_fr_Ve_di_Tempt_GND);
#endif
qgd_parasitic_Vge_si=(qgd_ov_Vge_si+qgd_fr_Vge_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_si_Vge_d=(+0.0+qgd_fr_Vge_si_Vge_d);
  qgd_parasitic_Vge_si_Vge_di=(+qgd_ov_Vge_si_Vge_di+qgd_fr_Vge_si_Vge_di);
  qgd_parasitic_Vge_si_Vge_e=(+qgd_ov_Vge_si_Vge_e+qgd_fr_Vge_si_Vge_e);
  qgd_parasitic_Vge_si_Ve_si=(+qgd_ov_Vge_si_Ve_si+qgd_fr_Vge_si_Ve_si);
  qgd_parasitic_Vge_si_Ve_di=(+qgd_ov_Vge_si_Ve_di+qgd_fr_Vge_si_Ve_di);
  qgd_parasitic_Vge_si_Vge_si=(+qgd_ov_Vge_si_Vge_si+qgd_fr_Vge_si_Vge_si);
  qgd_parasitic_Vge_si_Vdi_si=(+qgd_ov_Vge_si_Vdi_si+qgd_fr_Vge_si_Vdi_si);
  qgd_parasitic_Vge_si_Tempt_GND=(+qgd_ov_Vge_si_Tempt_GND+qgd_fr_Vge_si_Tempt_GND);
#endif
qgd_parasitic_Vdi_si=(qgd_ov_Vdi_si+qgd_fr_Vdi_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Vdi_si_Vge_d=(+0.0+qgd_fr_Vdi_si_Vge_d);
  qgd_parasitic_Vdi_si_Vge_di=(+qgd_ov_Vdi_si_Vge_di+qgd_fr_Vdi_si_Vge_di);
  qgd_parasitic_Vdi_si_Vge_e=(+qgd_ov_Vdi_si_Vge_e+qgd_fr_Vdi_si_Vge_e);
  qgd_parasitic_Vdi_si_Ve_si=(+qgd_ov_Vdi_si_Ve_si+qgd_fr_Vdi_si_Ve_si);
  qgd_parasitic_Vdi_si_Ve_di=(+qgd_ov_Vdi_si_Ve_di+qgd_fr_Vdi_si_Ve_di);
  qgd_parasitic_Vdi_si_Vge_si=(+qgd_ov_Vdi_si_Vge_si+qgd_fr_Vdi_si_Vge_si);
  qgd_parasitic_Vdi_si_Vdi_si=(+qgd_ov_Vdi_si_Vdi_si+qgd_fr_Vdi_si_Vdi_si);
  qgd_parasitic_Vdi_si_Tempt_GND=(+qgd_ov_Vdi_si_Tempt_GND+qgd_fr_Vdi_si_Tempt_GND);
#endif
qgd_parasitic_Tempt_GND=(qgd_ov_Tempt_GND+qgd_fr_Tempt_GND);
#if defined(_DERIVATE2)
  qgd_parasitic_Tempt_GND_Vge_d=(+0.0+qgd_fr_Tempt_GND_Vge_d);
  qgd_parasitic_Tempt_GND_Vge_di=(+qgd_ov_Tempt_GND_Vge_di+qgd_fr_Tempt_GND_Vge_di);
  qgd_parasitic_Tempt_GND_Vge_e=(+qgd_ov_Tempt_GND_Vge_e+qgd_fr_Tempt_GND_Vge_e);
  qgd_parasitic_Tempt_GND_Ve_si=(+qgd_ov_Tempt_GND_Ve_si+qgd_fr_Tempt_GND_Ve_si);
  qgd_parasitic_Tempt_GND_Ve_di=(+qgd_ov_Tempt_GND_Ve_di+qgd_fr_Tempt_GND_Ve_di);
  qgd_parasitic_Tempt_GND_Vge_si=(+qgd_ov_Tempt_GND_Vge_si+qgd_fr_Tempt_GND_Vge_si);
  qgd_parasitic_Tempt_GND_Vdi_si=(+qgd_ov_Tempt_GND_Vdi_si+qgd_fr_Tempt_GND_Vdi_si);
  qgd_parasitic_Tempt_GND_Tempt_GND=(+qgd_ov_Tempt_GND_Tempt_GND+qgd_fr_Tempt_GND_Tempt_GND);
#endif
#endif
qgd_parasitic=(qgd_ov+qgd_fr);
EXIT_IF_ISNAN((qgd_ov+qgd_fr))
#endif
}
else
{
if
((pModel->CGEOMOD==1))
{
if
((pModel->CGEO1SW==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=(NFINtotal*WeffCV0);
EXIT_IF_ISNAN((NFINtotal*WeffCV0))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
COVS_i_Vge_di=((T0_Vge_di*COVS_i)+(T0*COVS_i_Vge_di));
#if defined(_DERIVATE2)
  COVS_i_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*COVS_i+T0_Vge_di*COVS_i_Vge_di+T0_Vge_di*COVS_i_Vge_di+T0*COVS_i_Vge_di_Vge_di);
  COVS_i_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*COVS_i+T0_Vge_di*COVS_i_Vge_e+T0_Vge_e*COVS_i_Vge_di+T0*COVS_i_Vge_di_Vge_e);
  COVS_i_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*COVS_i+T0_Vge_di*COVS_i_Ve_si+T0_Ve_si*COVS_i_Vge_di+T0*COVS_i_Vge_di_Ve_si);
  COVS_i_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*COVS_i+T0_Vge_di*COVS_i_Ve_di+T0_Ve_di*COVS_i_Vge_di+T0*COVS_i_Vge_di_Ve_di);
  COVS_i_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*COVS_i+T0_Vge_di*COVS_i_Vge_si+T0_Vge_si*COVS_i_Vge_di+T0*COVS_i_Vge_di_Vge_si);
  COVS_i_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*COVS_i+T0_Vge_di*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Vge_di+T0*COVS_i_Vge_di_Vdi_si);
  COVS_i_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*COVS_i+T0_Vge_di*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Vge_di+T0*COVS_i_Vge_di_Tempt_GND);
#endif
COVS_i_Vge_e=((T0_Vge_e*COVS_i)+(T0*COVS_i_Vge_e));
#if defined(_DERIVATE2)
  COVS_i_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*COVS_i+T0_Vge_e*COVS_i_Vge_di+T0_Vge_di*COVS_i_Vge_e+T0*COVS_i_Vge_e_Vge_di);
  COVS_i_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*COVS_i+T0_Vge_e*COVS_i_Vge_e+T0_Vge_e*COVS_i_Vge_e+T0*COVS_i_Vge_e_Vge_e);
  COVS_i_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*COVS_i+T0_Vge_e*COVS_i_Ve_si+T0_Ve_si*COVS_i_Vge_e+T0*COVS_i_Vge_e_Ve_si);
  COVS_i_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*COVS_i+T0_Vge_e*COVS_i_Ve_di+T0_Ve_di*COVS_i_Vge_e+T0*COVS_i_Vge_e_Ve_di);
  COVS_i_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*COVS_i+T0_Vge_e*COVS_i_Vge_si+T0_Vge_si*COVS_i_Vge_e+T0*COVS_i_Vge_e_Vge_si);
  COVS_i_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*COVS_i+T0_Vge_e*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Vge_e+T0*COVS_i_Vge_e_Vdi_si);
  COVS_i_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*COVS_i+T0_Vge_e*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Vge_e+T0*COVS_i_Vge_e_Tempt_GND);
#endif
COVS_i_Ve_si=((T0_Ve_si*COVS_i)+(T0*COVS_i_Ve_si));
#if defined(_DERIVATE2)
  COVS_i_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*COVS_i+T0_Ve_si*COVS_i_Vge_di+T0_Vge_di*COVS_i_Ve_si+T0*COVS_i_Ve_si_Vge_di);
  COVS_i_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*COVS_i+T0_Ve_si*COVS_i_Vge_e+T0_Vge_e*COVS_i_Ve_si+T0*COVS_i_Ve_si_Vge_e);
  COVS_i_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*COVS_i+T0_Ve_si*COVS_i_Ve_si+T0_Ve_si*COVS_i_Ve_si+T0*COVS_i_Ve_si_Ve_si);
  COVS_i_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*COVS_i+T0_Ve_si*COVS_i_Ve_di+T0_Ve_di*COVS_i_Ve_si+T0*COVS_i_Ve_si_Ve_di);
  COVS_i_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*COVS_i+T0_Ve_si*COVS_i_Vge_si+T0_Vge_si*COVS_i_Ve_si+T0*COVS_i_Ve_si_Vge_si);
  COVS_i_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*COVS_i+T0_Ve_si*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Ve_si+T0*COVS_i_Ve_si_Vdi_si);
  COVS_i_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*COVS_i+T0_Ve_si*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Ve_si+T0*COVS_i_Ve_si_Tempt_GND);
#endif
COVS_i_Ve_di=((T0_Ve_di*COVS_i)+(T0*COVS_i_Ve_di));
#if defined(_DERIVATE2)
  COVS_i_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*COVS_i+T0_Ve_di*COVS_i_Vge_di+T0_Vge_di*COVS_i_Ve_di+T0*COVS_i_Ve_di_Vge_di);
  COVS_i_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*COVS_i+T0_Ve_di*COVS_i_Vge_e+T0_Vge_e*COVS_i_Ve_di+T0*COVS_i_Ve_di_Vge_e);
  COVS_i_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*COVS_i+T0_Ve_di*COVS_i_Ve_si+T0_Ve_si*COVS_i_Ve_di+T0*COVS_i_Ve_di_Ve_si);
  COVS_i_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*COVS_i+T0_Ve_di*COVS_i_Ve_di+T0_Ve_di*COVS_i_Ve_di+T0*COVS_i_Ve_di_Ve_di);
  COVS_i_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*COVS_i+T0_Ve_di*COVS_i_Vge_si+T0_Vge_si*COVS_i_Ve_di+T0*COVS_i_Ve_di_Vge_si);
  COVS_i_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*COVS_i+T0_Ve_di*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Ve_di+T0*COVS_i_Ve_di_Vdi_si);
  COVS_i_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*COVS_i+T0_Ve_di*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Ve_di+T0*COVS_i_Ve_di_Tempt_GND);
#endif
COVS_i_Vge_si=((T0_Vge_si*COVS_i)+(T0*COVS_i_Vge_si));
#if defined(_DERIVATE2)
  COVS_i_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*COVS_i+T0_Vge_si*COVS_i_Vge_di+T0_Vge_di*COVS_i_Vge_si+T0*COVS_i_Vge_si_Vge_di);
  COVS_i_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*COVS_i+T0_Vge_si*COVS_i_Vge_e+T0_Vge_e*COVS_i_Vge_si+T0*COVS_i_Vge_si_Vge_e);
  COVS_i_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*COVS_i+T0_Vge_si*COVS_i_Ve_si+T0_Ve_si*COVS_i_Vge_si+T0*COVS_i_Vge_si_Ve_si);
  COVS_i_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*COVS_i+T0_Vge_si*COVS_i_Ve_di+T0_Ve_di*COVS_i_Vge_si+T0*COVS_i_Vge_si_Ve_di);
  COVS_i_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*COVS_i+T0_Vge_si*COVS_i_Vge_si+T0_Vge_si*COVS_i_Vge_si+T0*COVS_i_Vge_si_Vge_si);
  COVS_i_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*COVS_i+T0_Vge_si*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Vge_si+T0*COVS_i_Vge_si_Vdi_si);
  COVS_i_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*COVS_i+T0_Vge_si*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Vge_si+T0*COVS_i_Vge_si_Tempt_GND);
#endif
COVS_i_Vdi_si=((T0_Vdi_si*COVS_i)+(T0*COVS_i_Vdi_si));
#if defined(_DERIVATE2)
  COVS_i_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*COVS_i+T0_Vdi_si*COVS_i_Vge_di+T0_Vge_di*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Vge_di);
  COVS_i_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*COVS_i+T0_Vdi_si*COVS_i_Vge_e+T0_Vge_e*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Vge_e);
  COVS_i_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*COVS_i+T0_Vdi_si*COVS_i_Ve_si+T0_Ve_si*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Ve_si);
  COVS_i_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*COVS_i+T0_Vdi_si*COVS_i_Ve_di+T0_Ve_di*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Ve_di);
  COVS_i_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*COVS_i+T0_Vdi_si*COVS_i_Vge_si+T0_Vge_si*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Vge_si);
  COVS_i_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*COVS_i+T0_Vdi_si*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Vdi_si);
  COVS_i_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*COVS_i+T0_Vdi_si*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Vdi_si+T0*COVS_i_Vdi_si_Tempt_GND);
#endif
COVS_i_Tempt_GND=((T0_Tempt_GND*COVS_i)+(T0*COVS_i_Tempt_GND));
#if defined(_DERIVATE2)
  COVS_i_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*COVS_i+T0_Tempt_GND*COVS_i_Vge_di+T0_Vge_di*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Vge_di);
  COVS_i_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*COVS_i+T0_Tempt_GND*COVS_i_Vge_e+T0_Vge_e*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Vge_e);
  COVS_i_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*COVS_i+T0_Tempt_GND*COVS_i_Ve_si+T0_Ve_si*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Ve_si);
  COVS_i_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*COVS_i+T0_Tempt_GND*COVS_i_Ve_di+T0_Ve_di*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Ve_di);
  COVS_i_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*COVS_i+T0_Tempt_GND*COVS_i_Vge_si+T0_Vge_si*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Vge_si);
  COVS_i_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*COVS_i+T0_Tempt_GND*COVS_i_Vdi_si+T0_Vdi_si*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Vdi_si);
  COVS_i_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*COVS_i+T0_Tempt_GND*COVS_i_Tempt_GND+T0_Tempt_GND*COVS_i_Tempt_GND+T0*COVS_i_Tempt_GND_Tempt_GND);
#endif
#endif
COVS_i=(T0*COVS_i);
EXIT_IF_ISNAN((T0*COVS_i))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
COVD_i_Vge_di=((T0_Vge_di*COVD_i)+(T0*COVD_i_Vge_di));
#if defined(_DERIVATE2)
  COVD_i_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*COVD_i+T0_Vge_di*COVD_i_Vge_di+T0_Vge_di*COVD_i_Vge_di+T0*COVD_i_Vge_di_Vge_di);
  COVD_i_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*COVD_i+T0_Vge_di*COVD_i_Vge_e+T0_Vge_e*COVD_i_Vge_di+T0*COVD_i_Vge_di_Vge_e);
  COVD_i_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*COVD_i+T0_Vge_di*COVD_i_Ve_si+T0_Ve_si*COVD_i_Vge_di+T0*COVD_i_Vge_di_Ve_si);
  COVD_i_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*COVD_i+T0_Vge_di*COVD_i_Ve_di+T0_Ve_di*COVD_i_Vge_di+T0*COVD_i_Vge_di_Ve_di);
  COVD_i_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*COVD_i+T0_Vge_di*COVD_i_Vge_si+T0_Vge_si*COVD_i_Vge_di+T0*COVD_i_Vge_di_Vge_si);
  COVD_i_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*COVD_i+T0_Vge_di*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Vge_di+T0*COVD_i_Vge_di_Vdi_si);
  COVD_i_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*COVD_i+T0_Vge_di*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Vge_di+T0*COVD_i_Vge_di_Tempt_GND);
#endif
COVD_i_Vge_e=((T0_Vge_e*COVD_i)+(T0*COVD_i_Vge_e));
#if defined(_DERIVATE2)
  COVD_i_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*COVD_i+T0_Vge_e*COVD_i_Vge_di+T0_Vge_di*COVD_i_Vge_e+T0*COVD_i_Vge_e_Vge_di);
  COVD_i_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*COVD_i+T0_Vge_e*COVD_i_Vge_e+T0_Vge_e*COVD_i_Vge_e+T0*COVD_i_Vge_e_Vge_e);
  COVD_i_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*COVD_i+T0_Vge_e*COVD_i_Ve_si+T0_Ve_si*COVD_i_Vge_e+T0*COVD_i_Vge_e_Ve_si);
  COVD_i_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*COVD_i+T0_Vge_e*COVD_i_Ve_di+T0_Ve_di*COVD_i_Vge_e+T0*COVD_i_Vge_e_Ve_di);
  COVD_i_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*COVD_i+T0_Vge_e*COVD_i_Vge_si+T0_Vge_si*COVD_i_Vge_e+T0*COVD_i_Vge_e_Vge_si);
  COVD_i_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*COVD_i+T0_Vge_e*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Vge_e+T0*COVD_i_Vge_e_Vdi_si);
  COVD_i_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*COVD_i+T0_Vge_e*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Vge_e+T0*COVD_i_Vge_e_Tempt_GND);
#endif
COVD_i_Ve_si=((T0_Ve_si*COVD_i)+(T0*COVD_i_Ve_si));
#if defined(_DERIVATE2)
  COVD_i_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*COVD_i+T0_Ve_si*COVD_i_Vge_di+T0_Vge_di*COVD_i_Ve_si+T0*COVD_i_Ve_si_Vge_di);
  COVD_i_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*COVD_i+T0_Ve_si*COVD_i_Vge_e+T0_Vge_e*COVD_i_Ve_si+T0*COVD_i_Ve_si_Vge_e);
  COVD_i_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*COVD_i+T0_Ve_si*COVD_i_Ve_si+T0_Ve_si*COVD_i_Ve_si+T0*COVD_i_Ve_si_Ve_si);
  COVD_i_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*COVD_i+T0_Ve_si*COVD_i_Ve_di+T0_Ve_di*COVD_i_Ve_si+T0*COVD_i_Ve_si_Ve_di);
  COVD_i_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*COVD_i+T0_Ve_si*COVD_i_Vge_si+T0_Vge_si*COVD_i_Ve_si+T0*COVD_i_Ve_si_Vge_si);
  COVD_i_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*COVD_i+T0_Ve_si*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Ve_si+T0*COVD_i_Ve_si_Vdi_si);
  COVD_i_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*COVD_i+T0_Ve_si*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Ve_si+T0*COVD_i_Ve_si_Tempt_GND);
#endif
COVD_i_Ve_di=((T0_Ve_di*COVD_i)+(T0*COVD_i_Ve_di));
#if defined(_DERIVATE2)
  COVD_i_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*COVD_i+T0_Ve_di*COVD_i_Vge_di+T0_Vge_di*COVD_i_Ve_di+T0*COVD_i_Ve_di_Vge_di);
  COVD_i_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*COVD_i+T0_Ve_di*COVD_i_Vge_e+T0_Vge_e*COVD_i_Ve_di+T0*COVD_i_Ve_di_Vge_e);
  COVD_i_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*COVD_i+T0_Ve_di*COVD_i_Ve_si+T0_Ve_si*COVD_i_Ve_di+T0*COVD_i_Ve_di_Ve_si);
  COVD_i_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*COVD_i+T0_Ve_di*COVD_i_Ve_di+T0_Ve_di*COVD_i_Ve_di+T0*COVD_i_Ve_di_Ve_di);
  COVD_i_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*COVD_i+T0_Ve_di*COVD_i_Vge_si+T0_Vge_si*COVD_i_Ve_di+T0*COVD_i_Ve_di_Vge_si);
  COVD_i_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*COVD_i+T0_Ve_di*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Ve_di+T0*COVD_i_Ve_di_Vdi_si);
  COVD_i_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*COVD_i+T0_Ve_di*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Ve_di+T0*COVD_i_Ve_di_Tempt_GND);
#endif
COVD_i_Vge_si=((T0_Vge_si*COVD_i)+(T0*COVD_i_Vge_si));
#if defined(_DERIVATE2)
  COVD_i_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*COVD_i+T0_Vge_si*COVD_i_Vge_di+T0_Vge_di*COVD_i_Vge_si+T0*COVD_i_Vge_si_Vge_di);
  COVD_i_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*COVD_i+T0_Vge_si*COVD_i_Vge_e+T0_Vge_e*COVD_i_Vge_si+T0*COVD_i_Vge_si_Vge_e);
  COVD_i_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*COVD_i+T0_Vge_si*COVD_i_Ve_si+T0_Ve_si*COVD_i_Vge_si+T0*COVD_i_Vge_si_Ve_si);
  COVD_i_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*COVD_i+T0_Vge_si*COVD_i_Ve_di+T0_Ve_di*COVD_i_Vge_si+T0*COVD_i_Vge_si_Ve_di);
  COVD_i_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*COVD_i+T0_Vge_si*COVD_i_Vge_si+T0_Vge_si*COVD_i_Vge_si+T0*COVD_i_Vge_si_Vge_si);
  COVD_i_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*COVD_i+T0_Vge_si*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Vge_si+T0*COVD_i_Vge_si_Vdi_si);
  COVD_i_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*COVD_i+T0_Vge_si*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Vge_si+T0*COVD_i_Vge_si_Tempt_GND);
#endif
COVD_i_Vdi_si=((T0_Vdi_si*COVD_i)+(T0*COVD_i_Vdi_si));
#if defined(_DERIVATE2)
  COVD_i_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*COVD_i+T0_Vdi_si*COVD_i_Vge_di+T0_Vge_di*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Vge_di);
  COVD_i_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*COVD_i+T0_Vdi_si*COVD_i_Vge_e+T0_Vge_e*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Vge_e);
  COVD_i_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*COVD_i+T0_Vdi_si*COVD_i_Ve_si+T0_Ve_si*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Ve_si);
  COVD_i_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*COVD_i+T0_Vdi_si*COVD_i_Ve_di+T0_Ve_di*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Ve_di);
  COVD_i_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*COVD_i+T0_Vdi_si*COVD_i_Vge_si+T0_Vge_si*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Vge_si);
  COVD_i_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*COVD_i+T0_Vdi_si*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Vdi_si);
  COVD_i_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*COVD_i+T0_Vdi_si*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Vdi_si+T0*COVD_i_Vdi_si_Tempt_GND);
#endif
COVD_i_Tempt_GND=((T0_Tempt_GND*COVD_i)+(T0*COVD_i_Tempt_GND));
#if defined(_DERIVATE2)
  COVD_i_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*COVD_i+T0_Tempt_GND*COVD_i_Vge_di+T0_Vge_di*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Vge_di);
  COVD_i_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*COVD_i+T0_Tempt_GND*COVD_i_Vge_e+T0_Vge_e*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Vge_e);
  COVD_i_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*COVD_i+T0_Tempt_GND*COVD_i_Ve_si+T0_Ve_si*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Ve_si);
  COVD_i_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*COVD_i+T0_Tempt_GND*COVD_i_Ve_di+T0_Ve_di*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Ve_di);
  COVD_i_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*COVD_i+T0_Tempt_GND*COVD_i_Vge_si+T0_Vge_si*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Vge_si);
  COVD_i_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*COVD_i+T0_Tempt_GND*COVD_i_Vdi_si+T0_Vdi_si*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Vdi_si);
  COVD_i_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*COVD_i+T0_Tempt_GND*COVD_i_Tempt_GND+T0_Tempt_GND*COVD_i_Tempt_GND+T0*COVD_i_Tempt_GND_Tempt_GND);
#endif
#endif
COVD_i=(T0*COVD_i);
EXIT_IF_ISNAN((T0*COVD_i))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(si,GND)Temp(t,GND)V(e,GND)V(di,GND)V(ge,GND) */
cgsp_Vge_di=T0_Vge_di*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*pInst->CGSP+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*pInst->CGSP+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*pInst->CGSP+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*pInst->CGSP+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*pInst->CGSP+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*pInst->CGSP+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*pInst->CGSP+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Vge_e=T0_Vge_e*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*pInst->CGSP+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*pInst->CGSP+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*pInst->CGSP+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*pInst->CGSP+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*pInst->CGSP+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*pInst->CGSP+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*pInst->CGSP+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Ve_si=T0_Ve_si*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*pInst->CGSP+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*pInst->CGSP+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*pInst->CGSP+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*pInst->CGSP+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*pInst->CGSP+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*pInst->CGSP+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*pInst->CGSP+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Ve_di=T0_Ve_di*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*pInst->CGSP+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*pInst->CGSP+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*pInst->CGSP+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*pInst->CGSP+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*pInst->CGSP+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*pInst->CGSP+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*pInst->CGSP+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Vge_si=T0_Vge_si*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*pInst->CGSP+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*pInst->CGSP+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*pInst->CGSP+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*pInst->CGSP+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*pInst->CGSP+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*pInst->CGSP+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*pInst->CGSP+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Vdi_si=T0_Vdi_si*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*pInst->CGSP+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*pInst->CGSP+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*pInst->CGSP+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*pInst->CGSP+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*pInst->CGSP+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*pInst->CGSP+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*pInst->CGSP+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgsp_Tempt_GND=T0_Tempt_GND*pInst->CGSP;
#if defined(_DERIVATE2)
  cgsp_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*pInst->CGSP+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0);
  cgsp_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*pInst->CGSP+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0);
  cgsp_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*pInst->CGSP+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0);
  cgsp_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*pInst->CGSP+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0);
  cgsp_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*pInst->CGSP+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0);
  cgsp_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*pInst->CGSP+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgsp_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*pInst->CGSP+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
#endif
cgsp=(T0*pInst->CGSP);
EXIT_IF_ISNAN((T0*pInst->CGSP))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)Temp(t,GND)V(e,GND)V(si,GND)V(ge,GND) */
cgdp_Vge_di=T0_Vge_di*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*pInst->CGDP+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*pInst->CGDP+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*pInst->CGDP+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*pInst->CGDP+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*pInst->CGDP+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*pInst->CGDP+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*pInst->CGDP+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Vge_e=T0_Vge_e*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*pInst->CGDP+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*pInst->CGDP+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*pInst->CGDP+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*pInst->CGDP+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*pInst->CGDP+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*pInst->CGDP+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*pInst->CGDP+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Ve_si=T0_Ve_si*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*pInst->CGDP+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*pInst->CGDP+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*pInst->CGDP+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*pInst->CGDP+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*pInst->CGDP+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*pInst->CGDP+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*pInst->CGDP+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Ve_di=T0_Ve_di*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*pInst->CGDP+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*pInst->CGDP+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*pInst->CGDP+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*pInst->CGDP+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*pInst->CGDP+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*pInst->CGDP+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*pInst->CGDP+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Vge_si=T0_Vge_si*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*pInst->CGDP+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*pInst->CGDP+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*pInst->CGDP+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*pInst->CGDP+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*pInst->CGDP+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*pInst->CGDP+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*pInst->CGDP+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Vdi_si=T0_Vdi_si*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*pInst->CGDP+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*pInst->CGDP+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*pInst->CGDP+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*pInst->CGDP+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*pInst->CGDP+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*pInst->CGDP+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*pInst->CGDP+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
cgdp_Tempt_GND=T0_Tempt_GND*pInst->CGDP;
#if defined(_DERIVATE2)
  cgdp_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*pInst->CGDP+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0);
  cgdp_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*pInst->CGDP+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0);
  cgdp_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*pInst->CGDP+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0);
  cgdp_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*pInst->CGDP+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0);
  cgdp_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*pInst->CGDP+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0);
  cgdp_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*pInst->CGDP+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0);
  cgdp_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*pInst->CGDP+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0);
#endif
#endif
cgdp=(T0*pInst->CGDP);
EXIT_IF_ISNAN((T0*pInst->CGDP))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(si,GND)Temp(t,GND)V(e,GND)V(di,GND)V(ge,GND) */
cgsp_Vge_di=0.0;
#if defined(_DERIVATE2)
  cgsp_Vge_di_Vge_di=0.0;
  cgsp_Vge_di_Vge_e=0.0;
  cgsp_Vge_di_Ve_si=0.0;
  cgsp_Vge_di_Ve_di=0.0;
  cgsp_Vge_di_Vge_si=0.0;
  cgsp_Vge_di_Vdi_si=0.0;
  cgsp_Vge_di_Tempt_GND=0.0;
#endif
cgsp_Vge_e=0.0;
#if defined(_DERIVATE2)
  cgsp_Vge_e_Vge_di=0.0;
  cgsp_Vge_e_Vge_e=0.0;
  cgsp_Vge_e_Ve_si=0.0;
  cgsp_Vge_e_Ve_di=0.0;
  cgsp_Vge_e_Vge_si=0.0;
  cgsp_Vge_e_Vdi_si=0.0;
  cgsp_Vge_e_Tempt_GND=0.0;
#endif
cgsp_Ve_si=0.0;
#if defined(_DERIVATE2)
  cgsp_Ve_si_Vge_di=0.0;
  cgsp_Ve_si_Vge_e=0.0;
  cgsp_Ve_si_Ve_si=0.0;
  cgsp_Ve_si_Ve_di=0.0;
  cgsp_Ve_si_Vge_si=0.0;
  cgsp_Ve_si_Vdi_si=0.0;
  cgsp_Ve_si_Tempt_GND=0.0;
#endif
cgsp_Ve_di=0.0;
#if defined(_DERIVATE2)
  cgsp_Ve_di_Vge_di=0.0;
  cgsp_Ve_di_Vge_e=0.0;
  cgsp_Ve_di_Ve_si=0.0;
  cgsp_Ve_di_Ve_di=0.0;
  cgsp_Ve_di_Vge_si=0.0;
  cgsp_Ve_di_Vdi_si=0.0;
  cgsp_Ve_di_Tempt_GND=0.0;
#endif
cgsp_Vge_si=0.0;
#if defined(_DERIVATE2)
  cgsp_Vge_si_Vge_di=0.0;
  cgsp_Vge_si_Vge_e=0.0;
  cgsp_Vge_si_Ve_si=0.0;
  cgsp_Vge_si_Ve_di=0.0;
  cgsp_Vge_si_Vge_si=0.0;
  cgsp_Vge_si_Vdi_si=0.0;
  cgsp_Vge_si_Tempt_GND=0.0;
#endif
cgsp_Vdi_si=0.0;
#if defined(_DERIVATE2)
  cgsp_Vdi_si_Vge_di=0.0;
  cgsp_Vdi_si_Vge_e=0.0;
  cgsp_Vdi_si_Ve_si=0.0;
  cgsp_Vdi_si_Ve_di=0.0;
  cgsp_Vdi_si_Vge_si=0.0;
  cgsp_Vdi_si_Vdi_si=0.0;
  cgsp_Vdi_si_Tempt_GND=0.0;
#endif
cgsp_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  cgsp_Tempt_GND_Vge_di=0.0;
  cgsp_Tempt_GND_Vge_e=0.0;
  cgsp_Tempt_GND_Ve_si=0.0;
  cgsp_Tempt_GND_Ve_di=0.0;
  cgsp_Tempt_GND_Vge_si=0.0;
  cgsp_Tempt_GND_Vdi_si=0.0;
  cgsp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
cgsp=pInst->CGSP;
EXIT_IF_ISNAN(pInst->CGSP)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)Temp(t,GND)V(e,GND)V(si,GND)V(ge,GND) */
cgdp_Vge_di=0.0;
#if defined(_DERIVATE2)
  cgdp_Vge_di_Vge_di=0.0;
  cgdp_Vge_di_Vge_e=0.0;
  cgdp_Vge_di_Ve_si=0.0;
  cgdp_Vge_di_Ve_di=0.0;
  cgdp_Vge_di_Vge_si=0.0;
  cgdp_Vge_di_Vdi_si=0.0;
  cgdp_Vge_di_Tempt_GND=0.0;
#endif
cgdp_Vge_e=0.0;
#if defined(_DERIVATE2)
  cgdp_Vge_e_Vge_di=0.0;
  cgdp_Vge_e_Vge_e=0.0;
  cgdp_Vge_e_Ve_si=0.0;
  cgdp_Vge_e_Ve_di=0.0;
  cgdp_Vge_e_Vge_si=0.0;
  cgdp_Vge_e_Vdi_si=0.0;
  cgdp_Vge_e_Tempt_GND=0.0;
#endif
cgdp_Ve_si=0.0;
#if defined(_DERIVATE2)
  cgdp_Ve_si_Vge_di=0.0;
  cgdp_Ve_si_Vge_e=0.0;
  cgdp_Ve_si_Ve_si=0.0;
  cgdp_Ve_si_Ve_di=0.0;
  cgdp_Ve_si_Vge_si=0.0;
  cgdp_Ve_si_Vdi_si=0.0;
  cgdp_Ve_si_Tempt_GND=0.0;
#endif
cgdp_Ve_di=0.0;
#if defined(_DERIVATE2)
  cgdp_Ve_di_Vge_di=0.0;
  cgdp_Ve_di_Vge_e=0.0;
  cgdp_Ve_di_Ve_si=0.0;
  cgdp_Ve_di_Ve_di=0.0;
  cgdp_Ve_di_Vge_si=0.0;
  cgdp_Ve_di_Vdi_si=0.0;
  cgdp_Ve_di_Tempt_GND=0.0;
#endif
cgdp_Vge_si=0.0;
#if defined(_DERIVATE2)
  cgdp_Vge_si_Vge_di=0.0;
  cgdp_Vge_si_Vge_e=0.0;
  cgdp_Vge_si_Ve_si=0.0;
  cgdp_Vge_si_Ve_di=0.0;
  cgdp_Vge_si_Vge_si=0.0;
  cgdp_Vge_si_Vdi_si=0.0;
  cgdp_Vge_si_Tempt_GND=0.0;
#endif
cgdp_Vdi_si=0.0;
#if defined(_DERIVATE2)
  cgdp_Vdi_si_Vge_di=0.0;
  cgdp_Vdi_si_Vge_e=0.0;
  cgdp_Vdi_si_Ve_si=0.0;
  cgdp_Vdi_si_Ve_di=0.0;
  cgdp_Vdi_si_Vge_si=0.0;
  cgdp_Vdi_si_Vdi_si=0.0;
  cgdp_Vdi_si_Tempt_GND=0.0;
#endif
cgdp_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  cgdp_Tempt_GND_Vge_di=0.0;
  cgdp_Tempt_GND_Vge_e=0.0;
  cgdp_Tempt_GND_Ve_si=0.0;
  cgdp_Tempt_GND_Ve_di=0.0;
  cgdp_Tempt_GND_Vge_si=0.0;
  cgdp_Tempt_GND_Vdi_si=0.0;
  cgdp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
cgdp=pInst->CGDP;
EXIT_IF_ISNAN(pInst->CGDP)
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(si,GND)Temp(t,GND)V(e,GND)V(di,GND)V(ge,GND) */
qgs_ov_Vge_di=COVS_i_Vge_di*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Vge_di_Vge_di=(+COVS_i_Vge_di_Vge_di*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Vge_e=(+COVS_i_Vge_di_Vge_e*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Ve_si=(+COVS_i_Vge_di_Ve_si*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Ve_di=(+COVS_i_Vge_di_Ve_di*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Vge_si=(+COVS_i_Vge_di_Vge_si*(NP(ge)-NP(si))+COVS_i_Vge_di*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Vdi_si=(+COVS_i_Vge_di_Vdi_si*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_di_Tempt_GND=(+COVS_i_Vge_di_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Vge_di*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
qgs_ov_Vge_e=COVS_i_Vge_e*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Vge_e_Vge_di=(+COVS_i_Vge_e_Vge_di*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Vge_e=(+COVS_i_Vge_e_Vge_e*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Ve_si=(+COVS_i_Vge_e_Ve_si*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Ve_di=(+COVS_i_Vge_e_Ve_di*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Vge_si=(+COVS_i_Vge_e_Vge_si*(NP(ge)-NP(si))+COVS_i_Vge_e*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Vdi_si=(+COVS_i_Vge_e_Vdi_si*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Vge_e_Tempt_GND=(+COVS_i_Vge_e_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Vge_e*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
qgs_ov_Ve_si=COVS_i_Ve_si*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Ve_si_Vge_di=(+COVS_i_Ve_si_Vge_di*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Vge_e=(+COVS_i_Ve_si_Vge_e*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Ve_si=(+COVS_i_Ve_si_Ve_si*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Ve_di=(+COVS_i_Ve_si_Ve_di*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Vge_si=(+COVS_i_Ve_si_Vge_si*(NP(ge)-NP(si))+COVS_i_Ve_si*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Vdi_si=(+COVS_i_Ve_si_Vdi_si*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_si_Tempt_GND=(+COVS_i_Ve_si_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Ve_si*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
qgs_ov_Ve_di=COVS_i_Ve_di*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Ve_di_Vge_di=(+COVS_i_Ve_di_Vge_di*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Vge_e=(+COVS_i_Ve_di_Vge_e*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Ve_si=(+COVS_i_Ve_di_Ve_si*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Ve_di=(+COVS_i_Ve_di_Ve_di*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Vge_si=(+COVS_i_Ve_di_Vge_si*(NP(ge)-NP(si))+COVS_i_Ve_di*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Vdi_si=(+COVS_i_Ve_di_Vdi_si*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Ve_di_Tempt_GND=(+COVS_i_Ve_di_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Ve_di*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
qgs_ov_Vge_si=((COVS_i_Vge_si*(NP(ge)-NP(si)))+COVS_i);
#if defined(_DERIVATE2)
  qgs_ov_Vge_si_Vge_di=(+COVS_i_Vge_si_Vge_di*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Vge_di*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Vge_e=(+COVS_i_Vge_si_Vge_e*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Vge_e*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Ve_si=(+COVS_i_Vge_si_Ve_si*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Ve_si*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Ve_di=(+COVS_i_Vge_si_Ve_di*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Ve_di*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Vge_si=(+COVS_i_Vge_si_Vge_si*(NP(ge)-NP(si))+COVS_i_Vge_si*1.0+COVS_i_Vge_si*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Vdi_si=(+COVS_i_Vge_si_Vdi_si*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Vdi_si*1.0+COVS_i*0.0);
  qgs_ov_Vge_si_Tempt_GND=(+COVS_i_Vge_si_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Vge_si*0.0+COVS_i_Tempt_GND*1.0+COVS_i*0.0);
#endif
qgs_ov_Vdi_si=COVS_i_Vdi_si*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Vdi_si_Vge_di=(+COVS_i_Vdi_si_Vge_di*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Vge_e=(+COVS_i_Vdi_si_Vge_e*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Ve_si=(+COVS_i_Vdi_si_Ve_si*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Ve_di=(+COVS_i_Vdi_si_Ve_di*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Vge_si=(+COVS_i_Vdi_si_Vge_si*(NP(ge)-NP(si))+COVS_i_Vdi_si*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Vdi_si=(+COVS_i_Vdi_si_Vdi_si*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Vdi_si_Tempt_GND=(+COVS_i_Vdi_si_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Vdi_si*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
qgs_ov_Tempt_GND=COVS_i_Tempt_GND*(NP(ge)-NP(si));
#if defined(_DERIVATE2)
  qgs_ov_Tempt_GND_Vge_di=(+COVS_i_Tempt_GND_Vge_di*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Vge_di*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Vge_e=(+COVS_i_Tempt_GND_Vge_e*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Vge_e*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Ve_si=(+COVS_i_Tempt_GND_Ve_si*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Ve_si*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Ve_di=(+COVS_i_Tempt_GND_Ve_di*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Ve_di*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Vge_si=(+COVS_i_Tempt_GND_Vge_si*(NP(ge)-NP(si))+COVS_i_Tempt_GND*1.0+COVS_i_Vge_si*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Vdi_si=(+COVS_i_Tempt_GND_Vdi_si*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Vdi_si*0.0+COVS_i*0.0);
  qgs_ov_Tempt_GND_Tempt_GND=(+COVS_i_Tempt_GND_Tempt_GND*(NP(ge)-NP(si))+COVS_i_Tempt_GND*0.0+COVS_i_Tempt_GND*0.0+COVS_i*0.0);
#endif
#endif
qgs_ov=(COVS_i*(NP(ge)-NP(si)));
EXIT_IF_ISNAN((COVS_i*(NP(ge)-NP(si))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)Temp(t,GND)V(e,GND)V(si,GND)V(ge,GND) */
qgd_ov_Vge_di=((COVD_i_Vge_di*(NP(ge)-NP(di)))+COVD_i);
#if defined(_DERIVATE2)
  qgd_ov_Vge_di_Vge_di=(+COVD_i_Vge_di_Vge_di*(NP(ge)-NP(di))+COVD_i_Vge_di*1.0+COVD_i_Vge_di*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Vge_e=(+COVD_i_Vge_di_Vge_e*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Vge_e*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Ve_si=(+COVD_i_Vge_di_Ve_si*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Ve_si*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Ve_di=(+COVD_i_Vge_di_Ve_di*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Ve_di*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Vge_si=(+COVD_i_Vge_di_Vge_si*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Vge_si*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Vdi_si=(+COVD_i_Vge_di_Vdi_si*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Vdi_si*1.0+COVD_i*0.0);
  qgd_ov_Vge_di_Tempt_GND=(+COVD_i_Vge_di_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Vge_di*0.0+COVD_i_Tempt_GND*1.0+COVD_i*0.0);
#endif
qgd_ov_Vge_e=COVD_i_Vge_e*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Vge_e_Vge_di=(+COVD_i_Vge_e_Vge_di*(NP(ge)-NP(di))+COVD_i_Vge_e*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Vge_e=(+COVD_i_Vge_e_Vge_e*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Ve_si=(+COVD_i_Vge_e_Ve_si*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Ve_di=(+COVD_i_Vge_e_Ve_di*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Vge_si=(+COVD_i_Vge_e_Vge_si*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Vdi_si=(+COVD_i_Vge_e_Vdi_si*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_e_Tempt_GND=(+COVD_i_Vge_e_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Vge_e*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
qgd_ov_Ve_si=COVD_i_Ve_si*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Ve_si_Vge_di=(+COVD_i_Ve_si_Vge_di*(NP(ge)-NP(di))+COVD_i_Ve_si*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Vge_e=(+COVD_i_Ve_si_Vge_e*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Ve_si=(+COVD_i_Ve_si_Ve_si*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Ve_di=(+COVD_i_Ve_si_Ve_di*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Vge_si=(+COVD_i_Ve_si_Vge_si*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Vdi_si=(+COVD_i_Ve_si_Vdi_si*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_si_Tempt_GND=(+COVD_i_Ve_si_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Ve_si*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
qgd_ov_Ve_di=COVD_i_Ve_di*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Ve_di_Vge_di=(+COVD_i_Ve_di_Vge_di*(NP(ge)-NP(di))+COVD_i_Ve_di*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Vge_e=(+COVD_i_Ve_di_Vge_e*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Ve_si=(+COVD_i_Ve_di_Ve_si*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Ve_di=(+COVD_i_Ve_di_Ve_di*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Vge_si=(+COVD_i_Ve_di_Vge_si*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Vdi_si=(+COVD_i_Ve_di_Vdi_si*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Ve_di_Tempt_GND=(+COVD_i_Ve_di_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Ve_di*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
qgd_ov_Vge_si=COVD_i_Vge_si*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Vge_si_Vge_di=(+COVD_i_Vge_si_Vge_di*(NP(ge)-NP(di))+COVD_i_Vge_si*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Vge_e=(+COVD_i_Vge_si_Vge_e*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Ve_si=(+COVD_i_Vge_si_Ve_si*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Ve_di=(+COVD_i_Vge_si_Ve_di*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Vge_si=(+COVD_i_Vge_si_Vge_si*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Vdi_si=(+COVD_i_Vge_si_Vdi_si*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Vge_si_Tempt_GND=(+COVD_i_Vge_si_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Vge_si*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
qgd_ov_Vdi_si=COVD_i_Vdi_si*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Vdi_si_Vge_di=(+COVD_i_Vdi_si_Vge_di*(NP(ge)-NP(di))+COVD_i_Vdi_si*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Vge_e=(+COVD_i_Vdi_si_Vge_e*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Ve_si=(+COVD_i_Vdi_si_Ve_si*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Ve_di=(+COVD_i_Vdi_si_Ve_di*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Vge_si=(+COVD_i_Vdi_si_Vge_si*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Vdi_si=(+COVD_i_Vdi_si_Vdi_si*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Vdi_si_Tempt_GND=(+COVD_i_Vdi_si_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Vdi_si*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
qgd_ov_Tempt_GND=COVD_i_Tempt_GND*(NP(ge)-NP(di));
#if defined(_DERIVATE2)
  qgd_ov_Tempt_GND_Vge_di=(+COVD_i_Tempt_GND_Vge_di*(NP(ge)-NP(di))+COVD_i_Tempt_GND*1.0+COVD_i_Vge_di*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Vge_e=(+COVD_i_Tempt_GND_Vge_e*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Vge_e*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Ve_si=(+COVD_i_Tempt_GND_Ve_si*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Ve_si*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Ve_di=(+COVD_i_Tempt_GND_Ve_di*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Ve_di*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Vge_si=(+COVD_i_Tempt_GND_Vge_si*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Vge_si*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Vdi_si=(+COVD_i_Tempt_GND_Vdi_si*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Vdi_si*0.0+COVD_i*0.0);
  qgd_ov_Tempt_GND_Tempt_GND=(+COVD_i_Tempt_GND_Tempt_GND*(NP(ge)-NP(di))+COVD_i_Tempt_GND*0.0+COVD_i_Tempt_GND*0.0+COVD_i*0.0);
#endif
#endif
qgd_ov=(COVD_i*(NP(ge)-NP(di)));
EXIT_IF_ISNAN((COVD_i*(NP(ge)-NP(di))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_parasitic_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_s_Vge_s=0.0;
  qgs_parasitic_Vge_s_Vge_di=0.0;
  qgs_parasitic_Vge_s_Vge_e=0.0;
  qgs_parasitic_Vge_s_Ve_si=0.0;
  qgs_parasitic_Vge_s_Ve_di=0.0;
  qgs_parasitic_Vge_s_Vge_si=0.0;
  qgs_parasitic_Vge_s_Vdi_si=0.0;
  qgs_parasitic_Vge_s_Tempt_GND=0.0;
#endif
qgs_parasitic_Vge_di=qgs_ov_Vge_di;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_di_Vge_s=0.0;
  qgs_parasitic_Vge_di_Vge_di=qgs_ov_Vge_di_Vge_di;
  qgs_parasitic_Vge_di_Vge_e=qgs_ov_Vge_di_Vge_e;
  qgs_parasitic_Vge_di_Ve_si=qgs_ov_Vge_di_Ve_si;
  qgs_parasitic_Vge_di_Ve_di=qgs_ov_Vge_di_Ve_di;
  qgs_parasitic_Vge_di_Vge_si=qgs_ov_Vge_di_Vge_si;
  qgs_parasitic_Vge_di_Vdi_si=qgs_ov_Vge_di_Vdi_si;
  qgs_parasitic_Vge_di_Tempt_GND=qgs_ov_Vge_di_Tempt_GND;
#endif
qgs_parasitic_Vge_e=qgs_ov_Vge_e;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_e_Vge_s=0.0;
  qgs_parasitic_Vge_e_Vge_di=qgs_ov_Vge_e_Vge_di;
  qgs_parasitic_Vge_e_Vge_e=qgs_ov_Vge_e_Vge_e;
  qgs_parasitic_Vge_e_Ve_si=qgs_ov_Vge_e_Ve_si;
  qgs_parasitic_Vge_e_Ve_di=qgs_ov_Vge_e_Ve_di;
  qgs_parasitic_Vge_e_Vge_si=qgs_ov_Vge_e_Vge_si;
  qgs_parasitic_Vge_e_Vdi_si=qgs_ov_Vge_e_Vdi_si;
  qgs_parasitic_Vge_e_Tempt_GND=qgs_ov_Vge_e_Tempt_GND;
#endif
qgs_parasitic_Ve_si=qgs_ov_Ve_si;
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_si_Vge_s=0.0;
  qgs_parasitic_Ve_si_Vge_di=qgs_ov_Ve_si_Vge_di;
  qgs_parasitic_Ve_si_Vge_e=qgs_ov_Ve_si_Vge_e;
  qgs_parasitic_Ve_si_Ve_si=qgs_ov_Ve_si_Ve_si;
  qgs_parasitic_Ve_si_Ve_di=qgs_ov_Ve_si_Ve_di;
  qgs_parasitic_Ve_si_Vge_si=qgs_ov_Ve_si_Vge_si;
  qgs_parasitic_Ve_si_Vdi_si=qgs_ov_Ve_si_Vdi_si;
  qgs_parasitic_Ve_si_Tempt_GND=qgs_ov_Ve_si_Tempt_GND;
#endif
qgs_parasitic_Ve_di=qgs_ov_Ve_di;
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_di_Vge_s=0.0;
  qgs_parasitic_Ve_di_Vge_di=qgs_ov_Ve_di_Vge_di;
  qgs_parasitic_Ve_di_Vge_e=qgs_ov_Ve_di_Vge_e;
  qgs_parasitic_Ve_di_Ve_si=qgs_ov_Ve_di_Ve_si;
  qgs_parasitic_Ve_di_Ve_di=qgs_ov_Ve_di_Ve_di;
  qgs_parasitic_Ve_di_Vge_si=qgs_ov_Ve_di_Vge_si;
  qgs_parasitic_Ve_di_Vdi_si=qgs_ov_Ve_di_Vdi_si;
  qgs_parasitic_Ve_di_Tempt_GND=qgs_ov_Ve_di_Tempt_GND;
#endif
qgs_parasitic_Vge_si=qgs_ov_Vge_si;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_si_Vge_s=0.0;
  qgs_parasitic_Vge_si_Vge_di=qgs_ov_Vge_si_Vge_di;
  qgs_parasitic_Vge_si_Vge_e=qgs_ov_Vge_si_Vge_e;
  qgs_parasitic_Vge_si_Ve_si=qgs_ov_Vge_si_Ve_si;
  qgs_parasitic_Vge_si_Ve_di=qgs_ov_Vge_si_Ve_di;
  qgs_parasitic_Vge_si_Vge_si=qgs_ov_Vge_si_Vge_si;
  qgs_parasitic_Vge_si_Vdi_si=qgs_ov_Vge_si_Vdi_si;
  qgs_parasitic_Vge_si_Tempt_GND=qgs_ov_Vge_si_Tempt_GND;
#endif
qgs_parasitic_Vdi_si=qgs_ov_Vdi_si;
#if defined(_DERIVATE2)
  qgs_parasitic_Vdi_si_Vge_s=0.0;
  qgs_parasitic_Vdi_si_Vge_di=qgs_ov_Vdi_si_Vge_di;
  qgs_parasitic_Vdi_si_Vge_e=qgs_ov_Vdi_si_Vge_e;
  qgs_parasitic_Vdi_si_Ve_si=qgs_ov_Vdi_si_Ve_si;
  qgs_parasitic_Vdi_si_Ve_di=qgs_ov_Vdi_si_Ve_di;
  qgs_parasitic_Vdi_si_Vge_si=qgs_ov_Vdi_si_Vge_si;
  qgs_parasitic_Vdi_si_Vdi_si=qgs_ov_Vdi_si_Vdi_si;
  qgs_parasitic_Vdi_si_Tempt_GND=qgs_ov_Vdi_si_Tempt_GND;
#endif
qgs_parasitic_Tempt_GND=qgs_ov_Tempt_GND;
#if defined(_DERIVATE2)
  qgs_parasitic_Tempt_GND_Vge_s=0.0;
  qgs_parasitic_Tempt_GND_Vge_di=qgs_ov_Tempt_GND_Vge_di;
  qgs_parasitic_Tempt_GND_Vge_e=qgs_ov_Tempt_GND_Vge_e;
  qgs_parasitic_Tempt_GND_Ve_si=qgs_ov_Tempt_GND_Ve_si;
  qgs_parasitic_Tempt_GND_Ve_di=qgs_ov_Tempt_GND_Ve_di;
  qgs_parasitic_Tempt_GND_Vge_si=qgs_ov_Tempt_GND_Vge_si;
  qgs_parasitic_Tempt_GND_Vdi_si=qgs_ov_Tempt_GND_Vdi_si;
  qgs_parasitic_Tempt_GND_Tempt_GND=qgs_ov_Tempt_GND_Tempt_GND;
#endif
#endif
qgs_parasitic=qgs_ov;
EXIT_IF_ISNAN(qgs_ov)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_parasitic_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_d_Vge_d=0.0;
  qgd_parasitic_Vge_d_Vge_di=0.0;
  qgd_parasitic_Vge_d_Vge_e=0.0;
  qgd_parasitic_Vge_d_Ve_si=0.0;
  qgd_parasitic_Vge_d_Ve_di=0.0;
  qgd_parasitic_Vge_d_Vge_si=0.0;
  qgd_parasitic_Vge_d_Vdi_si=0.0;
  qgd_parasitic_Vge_d_Tempt_GND=0.0;
#endif
qgd_parasitic_Vge_di=qgd_ov_Vge_di;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_di_Vge_d=0.0;
  qgd_parasitic_Vge_di_Vge_di=qgd_ov_Vge_di_Vge_di;
  qgd_parasitic_Vge_di_Vge_e=qgd_ov_Vge_di_Vge_e;
  qgd_parasitic_Vge_di_Ve_si=qgd_ov_Vge_di_Ve_si;
  qgd_parasitic_Vge_di_Ve_di=qgd_ov_Vge_di_Ve_di;
  qgd_parasitic_Vge_di_Vge_si=qgd_ov_Vge_di_Vge_si;
  qgd_parasitic_Vge_di_Vdi_si=qgd_ov_Vge_di_Vdi_si;
  qgd_parasitic_Vge_di_Tempt_GND=qgd_ov_Vge_di_Tempt_GND;
#endif
qgd_parasitic_Vge_e=qgd_ov_Vge_e;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_e_Vge_d=0.0;
  qgd_parasitic_Vge_e_Vge_di=qgd_ov_Vge_e_Vge_di;
  qgd_parasitic_Vge_e_Vge_e=qgd_ov_Vge_e_Vge_e;
  qgd_parasitic_Vge_e_Ve_si=qgd_ov_Vge_e_Ve_si;
  qgd_parasitic_Vge_e_Ve_di=qgd_ov_Vge_e_Ve_di;
  qgd_parasitic_Vge_e_Vge_si=qgd_ov_Vge_e_Vge_si;
  qgd_parasitic_Vge_e_Vdi_si=qgd_ov_Vge_e_Vdi_si;
  qgd_parasitic_Vge_e_Tempt_GND=qgd_ov_Vge_e_Tempt_GND;
#endif
qgd_parasitic_Ve_si=qgd_ov_Ve_si;
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_si_Vge_d=0.0;
  qgd_parasitic_Ve_si_Vge_di=qgd_ov_Ve_si_Vge_di;
  qgd_parasitic_Ve_si_Vge_e=qgd_ov_Ve_si_Vge_e;
  qgd_parasitic_Ve_si_Ve_si=qgd_ov_Ve_si_Ve_si;
  qgd_parasitic_Ve_si_Ve_di=qgd_ov_Ve_si_Ve_di;
  qgd_parasitic_Ve_si_Vge_si=qgd_ov_Ve_si_Vge_si;
  qgd_parasitic_Ve_si_Vdi_si=qgd_ov_Ve_si_Vdi_si;
  qgd_parasitic_Ve_si_Tempt_GND=qgd_ov_Ve_si_Tempt_GND;
#endif
qgd_parasitic_Ve_di=qgd_ov_Ve_di;
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_di_Vge_d=0.0;
  qgd_parasitic_Ve_di_Vge_di=qgd_ov_Ve_di_Vge_di;
  qgd_parasitic_Ve_di_Vge_e=qgd_ov_Ve_di_Vge_e;
  qgd_parasitic_Ve_di_Ve_si=qgd_ov_Ve_di_Ve_si;
  qgd_parasitic_Ve_di_Ve_di=qgd_ov_Ve_di_Ve_di;
  qgd_parasitic_Ve_di_Vge_si=qgd_ov_Ve_di_Vge_si;
  qgd_parasitic_Ve_di_Vdi_si=qgd_ov_Ve_di_Vdi_si;
  qgd_parasitic_Ve_di_Tempt_GND=qgd_ov_Ve_di_Tempt_GND;
#endif
qgd_parasitic_Vge_si=qgd_ov_Vge_si;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_si_Vge_d=0.0;
  qgd_parasitic_Vge_si_Vge_di=qgd_ov_Vge_si_Vge_di;
  qgd_parasitic_Vge_si_Vge_e=qgd_ov_Vge_si_Vge_e;
  qgd_parasitic_Vge_si_Ve_si=qgd_ov_Vge_si_Ve_si;
  qgd_parasitic_Vge_si_Ve_di=qgd_ov_Vge_si_Ve_di;
  qgd_parasitic_Vge_si_Vge_si=qgd_ov_Vge_si_Vge_si;
  qgd_parasitic_Vge_si_Vdi_si=qgd_ov_Vge_si_Vdi_si;
  qgd_parasitic_Vge_si_Tempt_GND=qgd_ov_Vge_si_Tempt_GND;
#endif
qgd_parasitic_Vdi_si=qgd_ov_Vdi_si;
#if defined(_DERIVATE2)
  qgd_parasitic_Vdi_si_Vge_d=0.0;
  qgd_parasitic_Vdi_si_Vge_di=qgd_ov_Vdi_si_Vge_di;
  qgd_parasitic_Vdi_si_Vge_e=qgd_ov_Vdi_si_Vge_e;
  qgd_parasitic_Vdi_si_Ve_si=qgd_ov_Vdi_si_Ve_si;
  qgd_parasitic_Vdi_si_Ve_di=qgd_ov_Vdi_si_Ve_di;
  qgd_parasitic_Vdi_si_Vge_si=qgd_ov_Vdi_si_Vge_si;
  qgd_parasitic_Vdi_si_Vdi_si=qgd_ov_Vdi_si_Vdi_si;
  qgd_parasitic_Vdi_si_Tempt_GND=qgd_ov_Vdi_si_Tempt_GND;
#endif
qgd_parasitic_Tempt_GND=qgd_ov_Tempt_GND;
#if defined(_DERIVATE2)
  qgd_parasitic_Tempt_GND_Vge_d=0.0;
  qgd_parasitic_Tempt_GND_Vge_di=qgd_ov_Tempt_GND_Vge_di;
  qgd_parasitic_Tempt_GND_Vge_e=qgd_ov_Tempt_GND_Vge_e;
  qgd_parasitic_Tempt_GND_Ve_si=qgd_ov_Tempt_GND_Ve_si;
  qgd_parasitic_Tempt_GND_Ve_di=qgd_ov_Tempt_GND_Ve_di;
  qgd_parasitic_Tempt_GND_Vge_si=qgd_ov_Tempt_GND_Vge_si;
  qgd_parasitic_Tempt_GND_Vdi_si=qgd_ov_Tempt_GND_Vdi_si;
  qgd_parasitic_Tempt_GND_Tempt_GND=qgd_ov_Tempt_GND_Tempt_GND;
#endif
#endif
qgd_parasitic=qgd_ov;
EXIT_IF_ISNAN(qgd_ov)
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_fr_Vge_s=(cgsp);
#if defined(_DERIVATE2)
  qgs_fr_Vge_s_Vge_s=(+0.0*(NP(ge)-NP(s))+0.0*1.0+0.0*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Vge_di=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Vge_di*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Vge_e=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Vge_e*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Ve_si=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Ve_si*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Ve_di=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Ve_di*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Vge_si=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Vge_si*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Vdi_si=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Vdi_si*1.0+cgsp*0.0);
  qgs_fr_Vge_s_Tempt_GND=(+0.0*(NP(ge)-NP(s))+0.0*0.0+cgsp_Tempt_GND*1.0+cgsp*0.0);
#endif
qgs_fr_Vge_di=cgsp_Vge_di*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Vge_di_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Vge_di*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Vge_di=(+cgsp_Vge_di_Vge_di*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Vge_e=(+cgsp_Vge_di_Vge_e*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Ve_si=(+cgsp_Vge_di_Ve_si*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Ve_di=(+cgsp_Vge_di_Ve_di*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Vge_si=(+cgsp_Vge_di_Vge_si*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Vdi_si=(+cgsp_Vge_di_Vdi_si*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Vge_di_Tempt_GND=(+cgsp_Vge_di_Tempt_GND*(NP(ge)-NP(s))+cgsp_Vge_di*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Vge_e=cgsp_Vge_e*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Vge_e_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Vge_e*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Vge_di=(+cgsp_Vge_e_Vge_di*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Vge_e=(+cgsp_Vge_e_Vge_e*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Ve_si=(+cgsp_Vge_e_Ve_si*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Ve_di=(+cgsp_Vge_e_Ve_di*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Vge_si=(+cgsp_Vge_e_Vge_si*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Vdi_si=(+cgsp_Vge_e_Vdi_si*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Vge_e_Tempt_GND=(+cgsp_Vge_e_Tempt_GND*(NP(ge)-NP(s))+cgsp_Vge_e*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Ve_si=cgsp_Ve_si*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Ve_si_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Ve_si*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Vge_di=(+cgsp_Ve_si_Vge_di*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Vge_e=(+cgsp_Ve_si_Vge_e*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Ve_si=(+cgsp_Ve_si_Ve_si*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Ve_di=(+cgsp_Ve_si_Ve_di*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Vge_si=(+cgsp_Ve_si_Vge_si*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Vdi_si=(+cgsp_Ve_si_Vdi_si*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Ve_si_Tempt_GND=(+cgsp_Ve_si_Tempt_GND*(NP(ge)-NP(s))+cgsp_Ve_si*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Ve_di=cgsp_Ve_di*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Ve_di_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Ve_di*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Vge_di=(+cgsp_Ve_di_Vge_di*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Vge_e=(+cgsp_Ve_di_Vge_e*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Ve_si=(+cgsp_Ve_di_Ve_si*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Ve_di=(+cgsp_Ve_di_Ve_di*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Vge_si=(+cgsp_Ve_di_Vge_si*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Vdi_si=(+cgsp_Ve_di_Vdi_si*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Ve_di_Tempt_GND=(+cgsp_Ve_di_Tempt_GND*(NP(ge)-NP(s))+cgsp_Ve_di*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Vge_si=cgsp_Vge_si*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Vge_si_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Vge_si*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Vge_di=(+cgsp_Vge_si_Vge_di*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Vge_e=(+cgsp_Vge_si_Vge_e*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Ve_si=(+cgsp_Vge_si_Ve_si*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Ve_di=(+cgsp_Vge_si_Ve_di*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Vge_si=(+cgsp_Vge_si_Vge_si*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Vdi_si=(+cgsp_Vge_si_Vdi_si*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Vge_si_Tempt_GND=(+cgsp_Vge_si_Tempt_GND*(NP(ge)-NP(s))+cgsp_Vge_si*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Vdi_si=cgsp_Vdi_si*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Vdi_si_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Vdi_si*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Vge_di=(+cgsp_Vdi_si_Vge_di*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Vge_e=(+cgsp_Vdi_si_Vge_e*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Ve_si=(+cgsp_Vdi_si_Ve_si*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Ve_di=(+cgsp_Vdi_si_Ve_di*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Vge_si=(+cgsp_Vdi_si_Vge_si*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Vdi_si=(+cgsp_Vdi_si_Vdi_si*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Vdi_si_Tempt_GND=(+cgsp_Vdi_si_Tempt_GND*(NP(ge)-NP(s))+cgsp_Vdi_si*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
qgs_fr_Tempt_GND=cgsp_Tempt_GND*(NP(ge)-NP(s));
#if defined(_DERIVATE2)
  qgs_fr_Tempt_GND_Vge_s=(+0.0*(NP(ge)-NP(s))+cgsp_Tempt_GND*1.0+0.0*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Vge_di=(+cgsp_Tempt_GND_Vge_di*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Vge_di*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Vge_e=(+cgsp_Tempt_GND_Vge_e*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Vge_e*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Ve_si=(+cgsp_Tempt_GND_Ve_si*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Ve_si*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Ve_di=(+cgsp_Tempt_GND_Ve_di*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Ve_di*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Vge_si=(+cgsp_Tempt_GND_Vge_si*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Vge_si*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Vdi_si=(+cgsp_Tempt_GND_Vdi_si*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Vdi_si*0.0+cgsp*0.0);
  qgs_fr_Tempt_GND_Tempt_GND=(+cgsp_Tempt_GND_Tempt_GND*(NP(ge)-NP(s))+cgsp_Tempt_GND*0.0+cgsp_Tempt_GND*0.0+cgsp*0.0);
#endif
#endif
qgs_fr=(cgsp*(NP(ge)-NP(s)));
EXIT_IF_ISNAN((cgsp*(NP(ge)-NP(s))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_fr_Vge_d=(cgdp);
#if defined(_DERIVATE2)
  qgd_fr_Vge_d_Vge_d=(+0.0*(NP(ge)-NP(d))+0.0*1.0+0.0*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Vge_di=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Vge_di*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Vge_e=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Vge_e*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Ve_si=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Ve_si*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Ve_di=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Ve_di*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Vge_si=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Vge_si*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Vdi_si=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Vdi_si*1.0+cgdp*0.0);
  qgd_fr_Vge_d_Tempt_GND=(+0.0*(NP(ge)-NP(d))+0.0*0.0+cgdp_Tempt_GND*1.0+cgdp*0.0);
#endif
qgd_fr_Vge_di=cgdp_Vge_di*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Vge_di_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Vge_di*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Vge_di=(+cgdp_Vge_di_Vge_di*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Vge_e=(+cgdp_Vge_di_Vge_e*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Ve_si=(+cgdp_Vge_di_Ve_si*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Ve_di=(+cgdp_Vge_di_Ve_di*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Vge_si=(+cgdp_Vge_di_Vge_si*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Vdi_si=(+cgdp_Vge_di_Vdi_si*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Vge_di_Tempt_GND=(+cgdp_Vge_di_Tempt_GND*(NP(ge)-NP(d))+cgdp_Vge_di*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Vge_e=cgdp_Vge_e*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Vge_e_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Vge_e*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Vge_di=(+cgdp_Vge_e_Vge_di*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Vge_e=(+cgdp_Vge_e_Vge_e*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Ve_si=(+cgdp_Vge_e_Ve_si*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Ve_di=(+cgdp_Vge_e_Ve_di*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Vge_si=(+cgdp_Vge_e_Vge_si*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Vdi_si=(+cgdp_Vge_e_Vdi_si*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Vge_e_Tempt_GND=(+cgdp_Vge_e_Tempt_GND*(NP(ge)-NP(d))+cgdp_Vge_e*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Ve_si=cgdp_Ve_si*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Ve_si_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Ve_si*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Vge_di=(+cgdp_Ve_si_Vge_di*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Vge_e=(+cgdp_Ve_si_Vge_e*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Ve_si=(+cgdp_Ve_si_Ve_si*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Ve_di=(+cgdp_Ve_si_Ve_di*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Vge_si=(+cgdp_Ve_si_Vge_si*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Vdi_si=(+cgdp_Ve_si_Vdi_si*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Ve_si_Tempt_GND=(+cgdp_Ve_si_Tempt_GND*(NP(ge)-NP(d))+cgdp_Ve_si*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Ve_di=cgdp_Ve_di*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Ve_di_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Ve_di*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Vge_di=(+cgdp_Ve_di_Vge_di*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Vge_e=(+cgdp_Ve_di_Vge_e*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Ve_si=(+cgdp_Ve_di_Ve_si*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Ve_di=(+cgdp_Ve_di_Ve_di*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Vge_si=(+cgdp_Ve_di_Vge_si*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Vdi_si=(+cgdp_Ve_di_Vdi_si*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Ve_di_Tempt_GND=(+cgdp_Ve_di_Tempt_GND*(NP(ge)-NP(d))+cgdp_Ve_di*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Vge_si=cgdp_Vge_si*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Vge_si_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Vge_si*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Vge_di=(+cgdp_Vge_si_Vge_di*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Vge_e=(+cgdp_Vge_si_Vge_e*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Ve_si=(+cgdp_Vge_si_Ve_si*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Ve_di=(+cgdp_Vge_si_Ve_di*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Vge_si=(+cgdp_Vge_si_Vge_si*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Vdi_si=(+cgdp_Vge_si_Vdi_si*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Vge_si_Tempt_GND=(+cgdp_Vge_si_Tempt_GND*(NP(ge)-NP(d))+cgdp_Vge_si*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Vdi_si=cgdp_Vdi_si*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Vdi_si_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Vdi_si*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Vge_di=(+cgdp_Vdi_si_Vge_di*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Vge_e=(+cgdp_Vdi_si_Vge_e*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Ve_si=(+cgdp_Vdi_si_Ve_si*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Ve_di=(+cgdp_Vdi_si_Ve_di*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Vge_si=(+cgdp_Vdi_si_Vge_si*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Vdi_si=(+cgdp_Vdi_si_Vdi_si*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Vdi_si_Tempt_GND=(+cgdp_Vdi_si_Tempt_GND*(NP(ge)-NP(d))+cgdp_Vdi_si*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
qgd_fr_Tempt_GND=cgdp_Tempt_GND*(NP(ge)-NP(d));
#if defined(_DERIVATE2)
  qgd_fr_Tempt_GND_Vge_d=(+0.0*(NP(ge)-NP(d))+cgdp_Tempt_GND*1.0+0.0*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Vge_di=(+cgdp_Tempt_GND_Vge_di*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Vge_di*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Vge_e=(+cgdp_Tempt_GND_Vge_e*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Vge_e*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Ve_si=(+cgdp_Tempt_GND_Ve_si*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Ve_si*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Ve_di=(+cgdp_Tempt_GND_Ve_di*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Ve_di*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Vge_si=(+cgdp_Tempt_GND_Vge_si*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Vge_si*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Vdi_si=(+cgdp_Tempt_GND_Vdi_si*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Vdi_si*0.0+cgdp*0.0);
  qgd_fr_Tempt_GND_Tempt_GND=(+cgdp_Tempt_GND_Tempt_GND*(NP(ge)-NP(d))+cgdp_Tempt_GND*0.0+cgdp_Tempt_GND*0.0+cgdp*0.0);
#endif
#endif
qgd_fr=(cgdp*(NP(ge)-NP(d)));
EXIT_IF_ISNAN((cgdp*(NP(ge)-NP(d))))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_fr_Vge_s=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_s_Vge_s=0.0;
  qgs_fr_Vge_s_Vge_di=0.0;
  qgs_fr_Vge_s_Vge_e=0.0;
  qgs_fr_Vge_s_Ve_si=0.0;
  qgs_fr_Vge_s_Ve_di=0.0;
  qgs_fr_Vge_s_Vge_si=0.0;
  qgs_fr_Vge_s_Vdi_si=0.0;
  qgs_fr_Vge_s_Tempt_GND=0.0;
#endif
qgs_fr_Vge_di=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_di_Vge_s=0.0;
  qgs_fr_Vge_di_Vge_di=0.0;
  qgs_fr_Vge_di_Vge_e=0.0;
  qgs_fr_Vge_di_Ve_si=0.0;
  qgs_fr_Vge_di_Ve_di=0.0;
  qgs_fr_Vge_di_Vge_si=0.0;
  qgs_fr_Vge_di_Vdi_si=0.0;
  qgs_fr_Vge_di_Tempt_GND=0.0;
#endif
qgs_fr_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vge_e_Vge_s=0.0;
  qgs_fr_Vge_e_Vge_di=0.0;
  qgs_fr_Vge_e_Vge_e=0.0;
  qgs_fr_Vge_e_Ve_si=0.0;
  qgs_fr_Vge_e_Ve_di=0.0;
  qgs_fr_Vge_e_Vge_si=0.0;
  qgs_fr_Vge_e_Vdi_si=0.0;
  qgs_fr_Vge_e_Tempt_GND=0.0;
#endif
qgs_fr_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Ve_si_Vge_s=0.0;
  qgs_fr_Ve_si_Vge_di=0.0;
  qgs_fr_Ve_si_Vge_e=0.0;
  qgs_fr_Ve_si_Ve_si=0.0;
  qgs_fr_Ve_si_Ve_di=0.0;
  qgs_fr_Ve_si_Vge_si=0.0;
  qgs_fr_Ve_si_Vdi_si=0.0;
  qgs_fr_Ve_si_Tempt_GND=0.0;
#endif
qgs_fr_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Ve_di_Vge_s=0.0;
  qgs_fr_Ve_di_Vge_di=0.0;
  qgs_fr_Ve_di_Vge_e=0.0;
  qgs_fr_Ve_di_Ve_si=0.0;
  qgs_fr_Ve_di_Ve_di=0.0;
  qgs_fr_Ve_di_Vge_si=0.0;
  qgs_fr_Ve_di_Vdi_si=0.0;
  qgs_fr_Ve_di_Tempt_GND=0.0;
#endif
qgs_fr_Vge_si=(Cfr_geo);
#if defined(_DERIVATE2)
  qgs_fr_Vge_si_Vge_s=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Vge_di=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Vge_e=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Ve_si=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Ve_di=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Vge_si=(+0.0*(NP(ge)-NP(si))+0.0*1.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Vdi_si=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgs_fr_Vge_si_Tempt_GND=(+0.0*(NP(ge)-NP(si))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
#endif
qgs_fr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Vdi_si_Vge_s=0.0;
  qgs_fr_Vdi_si_Vge_di=0.0;
  qgs_fr_Vdi_si_Vge_e=0.0;
  qgs_fr_Vdi_si_Ve_si=0.0;
  qgs_fr_Vdi_si_Ve_di=0.0;
  qgs_fr_Vdi_si_Vge_si=0.0;
  qgs_fr_Vdi_si_Vdi_si=0.0;
  qgs_fr_Vdi_si_Tempt_GND=0.0;
#endif
qgs_fr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgs_fr_Tempt_GND_Vge_s=0.0;
  qgs_fr_Tempt_GND_Vge_di=0.0;
  qgs_fr_Tempt_GND_Vge_e=0.0;
  qgs_fr_Tempt_GND_Ve_si=0.0;
  qgs_fr_Tempt_GND_Ve_di=0.0;
  qgs_fr_Tempt_GND_Vge_si=0.0;
  qgs_fr_Tempt_GND_Vdi_si=0.0;
  qgs_fr_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgs_fr=(Cfr_geo*(NP(ge)-NP(si)));
EXIT_IF_ISNAN((Cfr_geo*(NP(ge)-NP(si))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_fr_Vge_d=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_d_Vge_d=0.0;
  qgd_fr_Vge_d_Vge_di=0.0;
  qgd_fr_Vge_d_Vge_e=0.0;
  qgd_fr_Vge_d_Ve_si=0.0;
  qgd_fr_Vge_d_Ve_di=0.0;
  qgd_fr_Vge_d_Vge_si=0.0;
  qgd_fr_Vge_d_Vdi_si=0.0;
  qgd_fr_Vge_d_Tempt_GND=0.0;
#endif
qgd_fr_Vge_di=(Cfr_geo);
#if defined(_DERIVATE2)
  qgd_fr_Vge_di_Vge_d=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Vge_di=(+0.0*(NP(ge)-NP(di))+0.0*1.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Vge_e=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Ve_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Ve_di=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Vge_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Vdi_si=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
  qgd_fr_Vge_di_Tempt_GND=(+0.0*(NP(ge)-NP(di))+0.0*0.0+0.0*1.0+Cfr_geo*0.0);
#endif
qgd_fr_Vge_e=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_e_Vge_d=0.0;
  qgd_fr_Vge_e_Vge_di=0.0;
  qgd_fr_Vge_e_Vge_e=0.0;
  qgd_fr_Vge_e_Ve_si=0.0;
  qgd_fr_Vge_e_Ve_di=0.0;
  qgd_fr_Vge_e_Vge_si=0.0;
  qgd_fr_Vge_e_Vdi_si=0.0;
  qgd_fr_Vge_e_Tempt_GND=0.0;
#endif
qgd_fr_Ve_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Ve_si_Vge_d=0.0;
  qgd_fr_Ve_si_Vge_di=0.0;
  qgd_fr_Ve_si_Vge_e=0.0;
  qgd_fr_Ve_si_Ve_si=0.0;
  qgd_fr_Ve_si_Ve_di=0.0;
  qgd_fr_Ve_si_Vge_si=0.0;
  qgd_fr_Ve_si_Vdi_si=0.0;
  qgd_fr_Ve_si_Tempt_GND=0.0;
#endif
qgd_fr_Ve_di=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Ve_di_Vge_d=0.0;
  qgd_fr_Ve_di_Vge_di=0.0;
  qgd_fr_Ve_di_Vge_e=0.0;
  qgd_fr_Ve_di_Ve_si=0.0;
  qgd_fr_Ve_di_Ve_di=0.0;
  qgd_fr_Ve_di_Vge_si=0.0;
  qgd_fr_Ve_di_Vdi_si=0.0;
  qgd_fr_Ve_di_Tempt_GND=0.0;
#endif
qgd_fr_Vge_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vge_si_Vge_d=0.0;
  qgd_fr_Vge_si_Vge_di=0.0;
  qgd_fr_Vge_si_Vge_e=0.0;
  qgd_fr_Vge_si_Ve_si=0.0;
  qgd_fr_Vge_si_Ve_di=0.0;
  qgd_fr_Vge_si_Vge_si=0.0;
  qgd_fr_Vge_si_Vdi_si=0.0;
  qgd_fr_Vge_si_Tempt_GND=0.0;
#endif
qgd_fr_Vdi_si=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Vdi_si_Vge_d=0.0;
  qgd_fr_Vdi_si_Vge_di=0.0;
  qgd_fr_Vdi_si_Vge_e=0.0;
  qgd_fr_Vdi_si_Ve_si=0.0;
  qgd_fr_Vdi_si_Ve_di=0.0;
  qgd_fr_Vdi_si_Vge_si=0.0;
  qgd_fr_Vdi_si_Vdi_si=0.0;
  qgd_fr_Vdi_si_Tempt_GND=0.0;
#endif
qgd_fr_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  qgd_fr_Tempt_GND_Vge_d=0.0;
  qgd_fr_Tempt_GND_Vge_di=0.0;
  qgd_fr_Tempt_GND_Vge_e=0.0;
  qgd_fr_Tempt_GND_Ve_si=0.0;
  qgd_fr_Tempt_GND_Ve_di=0.0;
  qgd_fr_Tempt_GND_Vge_si=0.0;
  qgd_fr_Tempt_GND_Vdi_si=0.0;
  qgd_fr_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
qgd_fr=(Cfr_geo*(NP(ge)-NP(di)));
EXIT_IF_ISNAN((Cfr_geo*(NP(ge)-NP(di))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(e,GND)Temp(t,GND)V(si,GND) */
qgs_parasitic_Vge_s=qgs_fr_Vge_s;
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_s_Vge_s=(+0.0+qgs_fr_Vge_s_Vge_s);
  qgs_parasitic_Vge_s_Vge_di=(+0.0+qgs_fr_Vge_s_Vge_di);
  qgs_parasitic_Vge_s_Vge_e=(+0.0+qgs_fr_Vge_s_Vge_e);
  qgs_parasitic_Vge_s_Ve_si=(+0.0+qgs_fr_Vge_s_Ve_si);
  qgs_parasitic_Vge_s_Ve_di=(+0.0+qgs_fr_Vge_s_Ve_di);
  qgs_parasitic_Vge_s_Vge_si=(+0.0+qgs_fr_Vge_s_Vge_si);
  qgs_parasitic_Vge_s_Vdi_si=(+0.0+qgs_fr_Vge_s_Vdi_si);
  qgs_parasitic_Vge_s_Tempt_GND=(+0.0+qgs_fr_Vge_s_Tempt_GND);
#endif
qgs_parasitic_Vge_di=(qgs_ov_Vge_di+qgs_fr_Vge_di);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_di_Vge_s=(+0.0+qgs_fr_Vge_di_Vge_s);
  qgs_parasitic_Vge_di_Vge_di=(+qgs_ov_Vge_di_Vge_di+qgs_fr_Vge_di_Vge_di);
  qgs_parasitic_Vge_di_Vge_e=(+qgs_ov_Vge_di_Vge_e+qgs_fr_Vge_di_Vge_e);
  qgs_parasitic_Vge_di_Ve_si=(+qgs_ov_Vge_di_Ve_si+qgs_fr_Vge_di_Ve_si);
  qgs_parasitic_Vge_di_Ve_di=(+qgs_ov_Vge_di_Ve_di+qgs_fr_Vge_di_Ve_di);
  qgs_parasitic_Vge_di_Vge_si=(+qgs_ov_Vge_di_Vge_si+qgs_fr_Vge_di_Vge_si);
  qgs_parasitic_Vge_di_Vdi_si=(+qgs_ov_Vge_di_Vdi_si+qgs_fr_Vge_di_Vdi_si);
  qgs_parasitic_Vge_di_Tempt_GND=(+qgs_ov_Vge_di_Tempt_GND+qgs_fr_Vge_di_Tempt_GND);
#endif
qgs_parasitic_Vge_e=(qgs_ov_Vge_e+qgs_fr_Vge_e);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_e_Vge_s=(+0.0+qgs_fr_Vge_e_Vge_s);
  qgs_parasitic_Vge_e_Vge_di=(+qgs_ov_Vge_e_Vge_di+qgs_fr_Vge_e_Vge_di);
  qgs_parasitic_Vge_e_Vge_e=(+qgs_ov_Vge_e_Vge_e+qgs_fr_Vge_e_Vge_e);
  qgs_parasitic_Vge_e_Ve_si=(+qgs_ov_Vge_e_Ve_si+qgs_fr_Vge_e_Ve_si);
  qgs_parasitic_Vge_e_Ve_di=(+qgs_ov_Vge_e_Ve_di+qgs_fr_Vge_e_Ve_di);
  qgs_parasitic_Vge_e_Vge_si=(+qgs_ov_Vge_e_Vge_si+qgs_fr_Vge_e_Vge_si);
  qgs_parasitic_Vge_e_Vdi_si=(+qgs_ov_Vge_e_Vdi_si+qgs_fr_Vge_e_Vdi_si);
  qgs_parasitic_Vge_e_Tempt_GND=(+qgs_ov_Vge_e_Tempt_GND+qgs_fr_Vge_e_Tempt_GND);
#endif
qgs_parasitic_Ve_si=(qgs_ov_Ve_si+qgs_fr_Ve_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_si_Vge_s=(+0.0+qgs_fr_Ve_si_Vge_s);
  qgs_parasitic_Ve_si_Vge_di=(+qgs_ov_Ve_si_Vge_di+qgs_fr_Ve_si_Vge_di);
  qgs_parasitic_Ve_si_Vge_e=(+qgs_ov_Ve_si_Vge_e+qgs_fr_Ve_si_Vge_e);
  qgs_parasitic_Ve_si_Ve_si=(+qgs_ov_Ve_si_Ve_si+qgs_fr_Ve_si_Ve_si);
  qgs_parasitic_Ve_si_Ve_di=(+qgs_ov_Ve_si_Ve_di+qgs_fr_Ve_si_Ve_di);
  qgs_parasitic_Ve_si_Vge_si=(+qgs_ov_Ve_si_Vge_si+qgs_fr_Ve_si_Vge_si);
  qgs_parasitic_Ve_si_Vdi_si=(+qgs_ov_Ve_si_Vdi_si+qgs_fr_Ve_si_Vdi_si);
  qgs_parasitic_Ve_si_Tempt_GND=(+qgs_ov_Ve_si_Tempt_GND+qgs_fr_Ve_si_Tempt_GND);
#endif
qgs_parasitic_Ve_di=(qgs_ov_Ve_di+qgs_fr_Ve_di);
#if defined(_DERIVATE2)
  qgs_parasitic_Ve_di_Vge_s=(+0.0+qgs_fr_Ve_di_Vge_s);
  qgs_parasitic_Ve_di_Vge_di=(+qgs_ov_Ve_di_Vge_di+qgs_fr_Ve_di_Vge_di);
  qgs_parasitic_Ve_di_Vge_e=(+qgs_ov_Ve_di_Vge_e+qgs_fr_Ve_di_Vge_e);
  qgs_parasitic_Ve_di_Ve_si=(+qgs_ov_Ve_di_Ve_si+qgs_fr_Ve_di_Ve_si);
  qgs_parasitic_Ve_di_Ve_di=(+qgs_ov_Ve_di_Ve_di+qgs_fr_Ve_di_Ve_di);
  qgs_parasitic_Ve_di_Vge_si=(+qgs_ov_Ve_di_Vge_si+qgs_fr_Ve_di_Vge_si);
  qgs_parasitic_Ve_di_Vdi_si=(+qgs_ov_Ve_di_Vdi_si+qgs_fr_Ve_di_Vdi_si);
  qgs_parasitic_Ve_di_Tempt_GND=(+qgs_ov_Ve_di_Tempt_GND+qgs_fr_Ve_di_Tempt_GND);
#endif
qgs_parasitic_Vge_si=(qgs_ov_Vge_si+qgs_fr_Vge_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Vge_si_Vge_s=(+0.0+qgs_fr_Vge_si_Vge_s);
  qgs_parasitic_Vge_si_Vge_di=(+qgs_ov_Vge_si_Vge_di+qgs_fr_Vge_si_Vge_di);
  qgs_parasitic_Vge_si_Vge_e=(+qgs_ov_Vge_si_Vge_e+qgs_fr_Vge_si_Vge_e);
  qgs_parasitic_Vge_si_Ve_si=(+qgs_ov_Vge_si_Ve_si+qgs_fr_Vge_si_Ve_si);
  qgs_parasitic_Vge_si_Ve_di=(+qgs_ov_Vge_si_Ve_di+qgs_fr_Vge_si_Ve_di);
  qgs_parasitic_Vge_si_Vge_si=(+qgs_ov_Vge_si_Vge_si+qgs_fr_Vge_si_Vge_si);
  qgs_parasitic_Vge_si_Vdi_si=(+qgs_ov_Vge_si_Vdi_si+qgs_fr_Vge_si_Vdi_si);
  qgs_parasitic_Vge_si_Tempt_GND=(+qgs_ov_Vge_si_Tempt_GND+qgs_fr_Vge_si_Tempt_GND);
#endif
qgs_parasitic_Vdi_si=(qgs_ov_Vdi_si+qgs_fr_Vdi_si);
#if defined(_DERIVATE2)
  qgs_parasitic_Vdi_si_Vge_s=(+0.0+qgs_fr_Vdi_si_Vge_s);
  qgs_parasitic_Vdi_si_Vge_di=(+qgs_ov_Vdi_si_Vge_di+qgs_fr_Vdi_si_Vge_di);
  qgs_parasitic_Vdi_si_Vge_e=(+qgs_ov_Vdi_si_Vge_e+qgs_fr_Vdi_si_Vge_e);
  qgs_parasitic_Vdi_si_Ve_si=(+qgs_ov_Vdi_si_Ve_si+qgs_fr_Vdi_si_Ve_si);
  qgs_parasitic_Vdi_si_Ve_di=(+qgs_ov_Vdi_si_Ve_di+qgs_fr_Vdi_si_Ve_di);
  qgs_parasitic_Vdi_si_Vge_si=(+qgs_ov_Vdi_si_Vge_si+qgs_fr_Vdi_si_Vge_si);
  qgs_parasitic_Vdi_si_Vdi_si=(+qgs_ov_Vdi_si_Vdi_si+qgs_fr_Vdi_si_Vdi_si);
  qgs_parasitic_Vdi_si_Tempt_GND=(+qgs_ov_Vdi_si_Tempt_GND+qgs_fr_Vdi_si_Tempt_GND);
#endif
qgs_parasitic_Tempt_GND=(qgs_ov_Tempt_GND+qgs_fr_Tempt_GND);
#if defined(_DERIVATE2)
  qgs_parasitic_Tempt_GND_Vge_s=(+0.0+qgs_fr_Tempt_GND_Vge_s);
  qgs_parasitic_Tempt_GND_Vge_di=(+qgs_ov_Tempt_GND_Vge_di+qgs_fr_Tempt_GND_Vge_di);
  qgs_parasitic_Tempt_GND_Vge_e=(+qgs_ov_Tempt_GND_Vge_e+qgs_fr_Tempt_GND_Vge_e);
  qgs_parasitic_Tempt_GND_Ve_si=(+qgs_ov_Tempt_GND_Ve_si+qgs_fr_Tempt_GND_Ve_si);
  qgs_parasitic_Tempt_GND_Ve_di=(+qgs_ov_Tempt_GND_Ve_di+qgs_fr_Tempt_GND_Ve_di);
  qgs_parasitic_Tempt_GND_Vge_si=(+qgs_ov_Tempt_GND_Vge_si+qgs_fr_Tempt_GND_Vge_si);
  qgs_parasitic_Tempt_GND_Vdi_si=(+qgs_ov_Tempt_GND_Vdi_si+qgs_fr_Tempt_GND_Vdi_si);
  qgs_parasitic_Tempt_GND_Tempt_GND=(+qgs_ov_Tempt_GND_Tempt_GND+qgs_fr_Tempt_GND_Tempt_GND);
#endif
#endif
qgs_parasitic=(qgs_ov+qgs_fr);
EXIT_IF_ISNAN((qgs_ov+qgs_fr))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,d)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(e,GND)Temp(t,GND)V(di,GND) */
qgd_parasitic_Vge_d=qgd_fr_Vge_d;
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_d_Vge_d=(+0.0+qgd_fr_Vge_d_Vge_d);
  qgd_parasitic_Vge_d_Vge_di=(+0.0+qgd_fr_Vge_d_Vge_di);
  qgd_parasitic_Vge_d_Vge_e=(+0.0+qgd_fr_Vge_d_Vge_e);
  qgd_parasitic_Vge_d_Ve_si=(+0.0+qgd_fr_Vge_d_Ve_si);
  qgd_parasitic_Vge_d_Ve_di=(+0.0+qgd_fr_Vge_d_Ve_di);
  qgd_parasitic_Vge_d_Vge_si=(+0.0+qgd_fr_Vge_d_Vge_si);
  qgd_parasitic_Vge_d_Vdi_si=(+0.0+qgd_fr_Vge_d_Vdi_si);
  qgd_parasitic_Vge_d_Tempt_GND=(+0.0+qgd_fr_Vge_d_Tempt_GND);
#endif
qgd_parasitic_Vge_di=(qgd_ov_Vge_di+qgd_fr_Vge_di);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_di_Vge_d=(+0.0+qgd_fr_Vge_di_Vge_d);
  qgd_parasitic_Vge_di_Vge_di=(+qgd_ov_Vge_di_Vge_di+qgd_fr_Vge_di_Vge_di);
  qgd_parasitic_Vge_di_Vge_e=(+qgd_ov_Vge_di_Vge_e+qgd_fr_Vge_di_Vge_e);
  qgd_parasitic_Vge_di_Ve_si=(+qgd_ov_Vge_di_Ve_si+qgd_fr_Vge_di_Ve_si);
  qgd_parasitic_Vge_di_Ve_di=(+qgd_ov_Vge_di_Ve_di+qgd_fr_Vge_di_Ve_di);
  qgd_parasitic_Vge_di_Vge_si=(+qgd_ov_Vge_di_Vge_si+qgd_fr_Vge_di_Vge_si);
  qgd_parasitic_Vge_di_Vdi_si=(+qgd_ov_Vge_di_Vdi_si+qgd_fr_Vge_di_Vdi_si);
  qgd_parasitic_Vge_di_Tempt_GND=(+qgd_ov_Vge_di_Tempt_GND+qgd_fr_Vge_di_Tempt_GND);
#endif
qgd_parasitic_Vge_e=(qgd_ov_Vge_e+qgd_fr_Vge_e);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_e_Vge_d=(+0.0+qgd_fr_Vge_e_Vge_d);
  qgd_parasitic_Vge_e_Vge_di=(+qgd_ov_Vge_e_Vge_di+qgd_fr_Vge_e_Vge_di);
  qgd_parasitic_Vge_e_Vge_e=(+qgd_ov_Vge_e_Vge_e+qgd_fr_Vge_e_Vge_e);
  qgd_parasitic_Vge_e_Ve_si=(+qgd_ov_Vge_e_Ve_si+qgd_fr_Vge_e_Ve_si);
  qgd_parasitic_Vge_e_Ve_di=(+qgd_ov_Vge_e_Ve_di+qgd_fr_Vge_e_Ve_di);
  qgd_parasitic_Vge_e_Vge_si=(+qgd_ov_Vge_e_Vge_si+qgd_fr_Vge_e_Vge_si);
  qgd_parasitic_Vge_e_Vdi_si=(+qgd_ov_Vge_e_Vdi_si+qgd_fr_Vge_e_Vdi_si);
  qgd_parasitic_Vge_e_Tempt_GND=(+qgd_ov_Vge_e_Tempt_GND+qgd_fr_Vge_e_Tempt_GND);
#endif
qgd_parasitic_Ve_si=(qgd_ov_Ve_si+qgd_fr_Ve_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_si_Vge_d=(+0.0+qgd_fr_Ve_si_Vge_d);
  qgd_parasitic_Ve_si_Vge_di=(+qgd_ov_Ve_si_Vge_di+qgd_fr_Ve_si_Vge_di);
  qgd_parasitic_Ve_si_Vge_e=(+qgd_ov_Ve_si_Vge_e+qgd_fr_Ve_si_Vge_e);
  qgd_parasitic_Ve_si_Ve_si=(+qgd_ov_Ve_si_Ve_si+qgd_fr_Ve_si_Ve_si);
  qgd_parasitic_Ve_si_Ve_di=(+qgd_ov_Ve_si_Ve_di+qgd_fr_Ve_si_Ve_di);
  qgd_parasitic_Ve_si_Vge_si=(+qgd_ov_Ve_si_Vge_si+qgd_fr_Ve_si_Vge_si);
  qgd_parasitic_Ve_si_Vdi_si=(+qgd_ov_Ve_si_Vdi_si+qgd_fr_Ve_si_Vdi_si);
  qgd_parasitic_Ve_si_Tempt_GND=(+qgd_ov_Ve_si_Tempt_GND+qgd_fr_Ve_si_Tempt_GND);
#endif
qgd_parasitic_Ve_di=(qgd_ov_Ve_di+qgd_fr_Ve_di);
#if defined(_DERIVATE2)
  qgd_parasitic_Ve_di_Vge_d=(+0.0+qgd_fr_Ve_di_Vge_d);
  qgd_parasitic_Ve_di_Vge_di=(+qgd_ov_Ve_di_Vge_di+qgd_fr_Ve_di_Vge_di);
  qgd_parasitic_Ve_di_Vge_e=(+qgd_ov_Ve_di_Vge_e+qgd_fr_Ve_di_Vge_e);
  qgd_parasitic_Ve_di_Ve_si=(+qgd_ov_Ve_di_Ve_si+qgd_fr_Ve_di_Ve_si);
  qgd_parasitic_Ve_di_Ve_di=(+qgd_ov_Ve_di_Ve_di+qgd_fr_Ve_di_Ve_di);
  qgd_parasitic_Ve_di_Vge_si=(+qgd_ov_Ve_di_Vge_si+qgd_fr_Ve_di_Vge_si);
  qgd_parasitic_Ve_di_Vdi_si=(+qgd_ov_Ve_di_Vdi_si+qgd_fr_Ve_di_Vdi_si);
  qgd_parasitic_Ve_di_Tempt_GND=(+qgd_ov_Ve_di_Tempt_GND+qgd_fr_Ve_di_Tempt_GND);
#endif
qgd_parasitic_Vge_si=(qgd_ov_Vge_si+qgd_fr_Vge_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Vge_si_Vge_d=(+0.0+qgd_fr_Vge_si_Vge_d);
  qgd_parasitic_Vge_si_Vge_di=(+qgd_ov_Vge_si_Vge_di+qgd_fr_Vge_si_Vge_di);
  qgd_parasitic_Vge_si_Vge_e=(+qgd_ov_Vge_si_Vge_e+qgd_fr_Vge_si_Vge_e);
  qgd_parasitic_Vge_si_Ve_si=(+qgd_ov_Vge_si_Ve_si+qgd_fr_Vge_si_Ve_si);
  qgd_parasitic_Vge_si_Ve_di=(+qgd_ov_Vge_si_Ve_di+qgd_fr_Vge_si_Ve_di);
  qgd_parasitic_Vge_si_Vge_si=(+qgd_ov_Vge_si_Vge_si+qgd_fr_Vge_si_Vge_si);
  qgd_parasitic_Vge_si_Vdi_si=(+qgd_ov_Vge_si_Vdi_si+qgd_fr_Vge_si_Vdi_si);
  qgd_parasitic_Vge_si_Tempt_GND=(+qgd_ov_Vge_si_Tempt_GND+qgd_fr_Vge_si_Tempt_GND);
#endif
qgd_parasitic_Vdi_si=(qgd_ov_Vdi_si+qgd_fr_Vdi_si);
#if defined(_DERIVATE2)
  qgd_parasitic_Vdi_si_Vge_d=(+0.0+qgd_fr_Vdi_si_Vge_d);
  qgd_parasitic_Vdi_si_Vge_di=(+qgd_ov_Vdi_si_Vge_di+qgd_fr_Vdi_si_Vge_di);
  qgd_parasitic_Vdi_si_Vge_e=(+qgd_ov_Vdi_si_Vge_e+qgd_fr_Vdi_si_Vge_e);
  qgd_parasitic_Vdi_si_Ve_si=(+qgd_ov_Vdi_si_Ve_si+qgd_fr_Vdi_si_Ve_si);
  qgd_parasitic_Vdi_si_Ve_di=(+qgd_ov_Vdi_si_Ve_di+qgd_fr_Vdi_si_Ve_di);
  qgd_parasitic_Vdi_si_Vge_si=(+qgd_ov_Vdi_si_Vge_si+qgd_fr_Vdi_si_Vge_si);
  qgd_parasitic_Vdi_si_Vdi_si=(+qgd_ov_Vdi_si_Vdi_si+qgd_fr_Vdi_si_Vdi_si);
  qgd_parasitic_Vdi_si_Tempt_GND=(+qgd_ov_Vdi_si_Tempt_GND+qgd_fr_Vdi_si_Tempt_GND);
#endif
qgd_parasitic_Tempt_GND=(qgd_ov_Tempt_GND+qgd_fr_Tempt_GND);
#if defined(_DERIVATE2)
  qgd_parasitic_Tempt_GND_Vge_d=(+0.0+qgd_fr_Tempt_GND_Vge_d);
  qgd_parasitic_Tempt_GND_Vge_di=(+qgd_ov_Tempt_GND_Vge_di+qgd_fr_Tempt_GND_Vge_di);
  qgd_parasitic_Tempt_GND_Vge_e=(+qgd_ov_Tempt_GND_Vge_e+qgd_fr_Tempt_GND_Vge_e);
  qgd_parasitic_Tempt_GND_Ve_si=(+qgd_ov_Tempt_GND_Ve_si+qgd_fr_Tempt_GND_Ve_si);
  qgd_parasitic_Tempt_GND_Ve_di=(+qgd_ov_Tempt_GND_Ve_di+qgd_fr_Tempt_GND_Ve_di);
  qgd_parasitic_Tempt_GND_Vge_si=(+qgd_ov_Tempt_GND_Vge_si+qgd_fr_Tempt_GND_Vge_si);
  qgd_parasitic_Tempt_GND_Vdi_si=(+qgd_ov_Tempt_GND_Vdi_si+qgd_fr_Tempt_GND_Vdi_si);
  qgd_parasitic_Tempt_GND_Tempt_GND=(+qgd_ov_Tempt_GND_Tempt_GND+qgd_fr_Tempt_GND_Tempt_GND);
#endif
#endif
qgd_parasitic=(qgd_ov+qgd_fr);
EXIT_IF_ISNAN((qgd_ov+qgd_fr))
#endif
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(d,s) ddxprobe= */
qds_fr_Vd_s=(pInst->CDSP);
#endif
qds_fr=(pInst->CDSP*(NP(d)-NP(s)));
EXIT_IF_ISNAN((pInst->CDSP*(NP(d)-NP(s))))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=0.0;
  Iii_Vge_di_Vge_e=0.0;
  Iii_Vge_di_Ve_si=0.0;
  Iii_Vge_di_Ve_di=0.0;
  Iii_Vge_di_Vge_si=0.0;
  Iii_Vge_di_Vdi_si=0.0;
  Iii_Vge_di_Tempt_GND=0.0;
#endif
Iii_Vge_e=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=0.0;
  Iii_Vge_e_Vge_e=0.0;
  Iii_Vge_e_Ve_si=0.0;
  Iii_Vge_e_Ve_di=0.0;
  Iii_Vge_e_Vge_si=0.0;
  Iii_Vge_e_Vdi_si=0.0;
  Iii_Vge_e_Tempt_GND=0.0;
#endif
Iii_Ve_si=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=0.0;
  Iii_Ve_si_Vge_e=0.0;
  Iii_Ve_si_Ve_si=0.0;
  Iii_Ve_si_Ve_di=0.0;
  Iii_Ve_si_Vge_si=0.0;
  Iii_Ve_si_Vdi_si=0.0;
  Iii_Ve_si_Tempt_GND=0.0;
#endif
Iii_Ve_di=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=0.0;
  Iii_Ve_di_Vge_e=0.0;
  Iii_Ve_di_Ve_si=0.0;
  Iii_Ve_di_Ve_di=0.0;
  Iii_Ve_di_Vge_si=0.0;
  Iii_Ve_di_Vdi_si=0.0;
  Iii_Ve_di_Tempt_GND=0.0;
#endif
Iii_Vge_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=0.0;
  Iii_Vge_si_Vge_e=0.0;
  Iii_Vge_si_Ve_si=0.0;
  Iii_Vge_si_Ve_di=0.0;
  Iii_Vge_si_Vge_si=0.0;
  Iii_Vge_si_Vdi_si=0.0;
  Iii_Vge_si_Tempt_GND=0.0;
#endif
Iii_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=0.0;
  Iii_Vdi_si_Vge_e=0.0;
  Iii_Vdi_si_Ve_si=0.0;
  Iii_Vdi_si_Ve_di=0.0;
  Iii_Vdi_si_Vge_si=0.0;
  Iii_Vdi_si_Vdi_si=0.0;
  Iii_Vdi_si_Tempt_GND=0.0;
#endif
Iii_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=0.0;
  Iii_Tempt_GND_Vge_e=0.0;
  Iii_Tempt_GND_Ve_si=0.0;
  Iii_Tempt_GND_Ve_di=0.0;
  Iii_Tempt_GND_Vge_si=0.0;
  Iii_Tempt_GND_Vdi_si=0.0;
  Iii_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Iii=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->IIMOD==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)/Leff);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vge_e=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Ve_si=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Ve_di=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vge_si=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vdi_si=((+0.0+(+0.0*Leff+ALPHA1_t_Tempt_GND*0.0+0.0*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(0.0)*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Tempt_GND=((+ALPHA0_t_Tempt_GND_Tempt_GND+(+ALPHA1_t_Tempt_GND_Tempt_GND*Leff+ALPHA1_t_Tempt_GND*0.0+ALPHA1_t_Tempt_GND*0.0+ALPHA1_t*0.0))/Leff-((ALPHA0_t_Tempt_GND+ALPHA1_t_Tempt_GND*Leff)*0.0+(ALPHA0_t_Tempt_GND+(ALPHA1_t_Tempt_GND*Leff))*0.0+(ALPHA0_t+(ALPHA1_t*Leff))*0.0)/Leff/Leff+2*(ALPHA0_t+(ALPHA1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
#endif
#endif
T0=((ALPHA0_t+(ALPHA1_t*Leff))/Leff);
EXIT_IF_ISNAN(((ALPHA0_t+(ALPHA1_t*Leff))/Leff))
if
(((T0<=0.0)||(BETA0_t<=0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=0.0;
  Iii_Vge_di_Vge_e=0.0;
  Iii_Vge_di_Ve_si=0.0;
  Iii_Vge_di_Ve_di=0.0;
  Iii_Vge_di_Vge_si=0.0;
  Iii_Vge_di_Vdi_si=0.0;
  Iii_Vge_di_Tempt_GND=0.0;
#endif
Iii_Vge_e=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=0.0;
  Iii_Vge_e_Vge_e=0.0;
  Iii_Vge_e_Ve_si=0.0;
  Iii_Vge_e_Ve_di=0.0;
  Iii_Vge_e_Vge_si=0.0;
  Iii_Vge_e_Vdi_si=0.0;
  Iii_Vge_e_Tempt_GND=0.0;
#endif
Iii_Ve_si=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=0.0;
  Iii_Ve_si_Vge_e=0.0;
  Iii_Ve_si_Ve_si=0.0;
  Iii_Ve_si_Ve_di=0.0;
  Iii_Ve_si_Vge_si=0.0;
  Iii_Ve_si_Vdi_si=0.0;
  Iii_Ve_si_Tempt_GND=0.0;
#endif
Iii_Ve_di=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=0.0;
  Iii_Ve_di_Vge_e=0.0;
  Iii_Ve_di_Ve_si=0.0;
  Iii_Ve_di_Ve_di=0.0;
  Iii_Ve_di_Vge_si=0.0;
  Iii_Ve_di_Vdi_si=0.0;
  Iii_Ve_di_Tempt_GND=0.0;
#endif
Iii_Vge_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=0.0;
  Iii_Vge_si_Vge_e=0.0;
  Iii_Vge_si_Ve_si=0.0;
  Iii_Vge_si_Ve_di=0.0;
  Iii_Vge_si_Vge_si=0.0;
  Iii_Vge_si_Vdi_si=0.0;
  Iii_Vge_si_Tempt_GND=0.0;
#endif
Iii_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=0.0;
  Iii_Vdi_si_Vge_e=0.0;
  Iii_Vdi_si_Ve_si=0.0;
  Iii_Vdi_si_Ve_di=0.0;
  Iii_Vdi_si_Vge_si=0.0;
  Iii_Vdi_si_Vdi_si=0.0;
  Iii_Vdi_si_Tempt_GND=0.0;
#endif
Iii_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=0.0;
  Iii_Tempt_GND_Vge_e=0.0;
  Iii_Tempt_GND_Ve_si=0.0;
  Iii_Tempt_GND_Ve_di=0.0;
  Iii_Tempt_GND_Vge_si=0.0;
  Iii_Tempt_GND_Vdi_si=0.0;
  Iii_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Iii=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-(-BETA0_t)*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Vsi_s=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Vge_di=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Vge_e=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Ve_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_si+0.0*diffVds_Ve_si+(-BETA0_t)*(+diffVds_Ve_si_Ve_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Ve_di=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_di+0.0*diffVds_Ve_si+(-BETA0_t)*(+diffVds_Ve_si_Ve_di+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Vge_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vge_si+0.0*diffVds_Ve_si+(-BETA0_t)*(+diffVds_Ve_si_Vge_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Vdi_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vdi_si+0.0*diffVds_Ve_si+(-BETA0_t)*(+diffVds_Ve_si_Vdi_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_si_Tempt_GND=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Ve_si+(-BETA0_t)*(+diffVds_Ve_si_Tempt_GND+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_si*diffVds_Tempt_GND/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#endif
T1_Ve_di=(-(-BETA0_t)*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_di+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Vsi_s=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_di+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Vge_di=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_di+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Vge_e=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Ve_di+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Ve_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_si+0.0*diffVds_Ve_di+(-BETA0_t)*(+diffVds_Ve_di_Ve_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Ve_di=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_di+0.0*diffVds_Ve_di+(-BETA0_t)*(+diffVds_Ve_di_Ve_di+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Vge_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vge_si+0.0*diffVds_Ve_di+(-BETA0_t)*(+diffVds_Ve_di_Vge_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Vdi_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vdi_si+0.0*diffVds_Ve_di+(-BETA0_t)*(+diffVds_Ve_di_Vdi_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Ve_di_Tempt_GND=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Ve_di+(-BETA0_t)*(+diffVds_Ve_di_Tempt_GND+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Ve_di*diffVds_Tempt_GND/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#endif
T1_Vge_si=(-(-BETA0_t)*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vge_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Vsi_s=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vge_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Vge_di=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vge_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Vge_e=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vge_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Ve_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_si+0.0*diffVds_Vge_si+(-BETA0_t)*(+diffVds_Vge_si_Ve_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Ve_di=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_di+0.0*diffVds_Vge_si+(-BETA0_t)*(+diffVds_Vge_si_Ve_di+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Vge_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vge_si+0.0*diffVds_Vge_si+(-BETA0_t)*(+diffVds_Vge_si_Vge_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Vdi_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vdi_si+0.0*diffVds_Vge_si+(-BETA0_t)*(+diffVds_Vge_si_Vdi_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vge_si_Tempt_GND=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Vge_si+(-BETA0_t)*(+diffVds_Vge_si_Tempt_GND+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vge_si*diffVds_Tempt_GND/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#endif
T1_Vdi_si=(-(-BETA0_t)*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vdi_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Vsi_s=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vdi_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Vge_di=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vdi_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Vge_e=(0.0/(diffVds+1.0e-30)-(0.0*0.0+0.0*diffVds_Vdi_si+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Ve_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_si+0.0*diffVds_Vdi_si+(-BETA0_t)*(+diffVds_Vdi_si_Ve_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Ve_di=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Ve_di+0.0*diffVds_Vdi_si+(-BETA0_t)*(+diffVds_Vdi_si_Ve_di+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Vge_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vge_si+0.0*diffVds_Vdi_si+(-BETA0_t)*(+diffVds_Vdi_si_Vge_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Vdi_si=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Vdi_si+0.0*diffVds_Vdi_si+(-BETA0_t)*(+diffVds_Vdi_si_Vdi_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Vdi_si_Tempt_GND=(0.0/(diffVds+1.0e-30)-(0.0*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Vdi_si+(-BETA0_t)*(+diffVds_Vdi_si_Tempt_GND+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Vdi_si*diffVds_Tempt_GND/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#endif
T1_Tempt_GND=(((-BETA0_t_Tempt_GND)*(diffVds+1.0e-30)-(-BETA0_t)*diffVds_Tempt_GND)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*0.0+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Vsi_s=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*0.0+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Vge_di=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*0.0+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Vge_e=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*0.0+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+0.0+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*0.0/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Ve_si=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*diffVds_Ve_si+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+diffVds_Tempt_GND_Ve_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*diffVds_Ve_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Ve_di=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*diffVds_Ve_di+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+diffVds_Tempt_GND_Ve_di+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*diffVds_Ve_di/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Vge_si=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*diffVds_Vge_si+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+diffVds_Tempt_GND_Vge_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*diffVds_Vge_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Vdi_si=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*diffVds_Vdi_si+0.0*diffVds_Tempt_GND+(-BETA0_t)*(+diffVds_Tempt_GND_Vdi_si+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*diffVds_Vdi_si/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
  T1_Tempt_GND_Tempt_GND=(0.0/(diffVds+1.0e-30)-((-BETA0_t_Tempt_GND)*diffVds_Tempt_GND+(-BETA0_t_Tempt_GND)*diffVds_Tempt_GND+(-BETA0_t)*(+diffVds_Tempt_GND_Tempt_GND+0.0))/(diffVds+1.0e-30)/(diffVds+1.0e-30)+2*(-BETA0_t)*diffVds_Tempt_GND*diffVds_Tempt_GND/(diffVds+1.0e-30)/(diffVds+1.0e-30)/(diffVds+1.0e-30));
#endif
#endif
T1=((-BETA0_t)/(diffVds+1.0e-30));
EXIT_IF_ISNAN(((-BETA0_t)/(diffVds+1.0e-30)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=((((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Vge_di)));
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=(+(+(+T0_Vge_di_Vge_di*diffVds+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Vge_di)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Vge_di);
  Iii_Vge_di_Vge_e=(+(+(+T0_Vge_di_Vge_e*diffVds+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Vge_e)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Vge_e);
  Iii_Vge_di_Ve_si=(+(+(+T0_Vge_di_Ve_si*diffVds+T0_Vge_di*diffVds_Ve_si+T0_Ve_si*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Ve_si)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Ve_si);
  Iii_Vge_di_Ve_di=(+(+(+T0_Vge_di_Ve_di*diffVds+T0_Vge_di*diffVds_Ve_di+T0_Ve_di*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Ve_di)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Ve_di);
  Iii_Vge_di_Vge_si=(+(+(+T0_Vge_di_Vge_si*diffVds+T0_Vge_di*diffVds_Vge_si+T0_Vge_si*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Vge_si)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Vge_si);
  Iii_Vge_di_Vdi_si=(+(+(+T0_Vge_di_Vdi_si*diffVds+T0_Vge_di*diffVds_Vdi_si+T0_Vdi_si*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Vdi_si)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Vdi_si);
  Iii_Vge_di_Tempt_GND=(+(+(+T0_Vge_di_Tempt_GND*diffVds+T0_Vge_di*diffVds_Tempt_GND+T0_Tempt_GND*0.0+T0*0.0)*ids+T0_Vge_di*diffVds*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Vge_di+(T0*diffVds)*ids_Vge_di_Tempt_GND)*bsimcmg_lexp(T1)+((T0_Vge_di*diffVds*ids)+((T0*diffVds)*ids_Vge_di))*bsimcmg_d_lexp(T1,T1_Vge_di)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Vge_di)+((T0*diffVds)*ids)*T1_Vge_di_Tempt_GND);
#endif
Iii_Vge_e=((((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Vge_e)));
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=(+(+(+T0_Vge_e_Vge_di*diffVds+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Vge_di)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Vge_di);
  Iii_Vge_e_Vge_e=(+(+(+T0_Vge_e_Vge_e*diffVds+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Vge_e)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Vge_e);
  Iii_Vge_e_Ve_si=(+(+(+T0_Vge_e_Ve_si*diffVds+T0_Vge_e*diffVds_Ve_si+T0_Ve_si*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Ve_si)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Ve_si);
  Iii_Vge_e_Ve_di=(+(+(+T0_Vge_e_Ve_di*diffVds+T0_Vge_e*diffVds_Ve_di+T0_Ve_di*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Ve_di)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Ve_di);
  Iii_Vge_e_Vge_si=(+(+(+T0_Vge_e_Vge_si*diffVds+T0_Vge_e*diffVds_Vge_si+T0_Vge_si*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Vge_si)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Vge_si);
  Iii_Vge_e_Vdi_si=(+(+(+T0_Vge_e_Vdi_si*diffVds+T0_Vge_e*diffVds_Vdi_si+T0_Vdi_si*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Vdi_si)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Vdi_si);
  Iii_Vge_e_Tempt_GND=(+(+(+T0_Vge_e_Tempt_GND*diffVds+T0_Vge_e*diffVds_Tempt_GND+T0_Tempt_GND*0.0+T0*0.0)*ids+T0_Vge_e*diffVds*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Vge_e+(T0*diffVds)*ids_Vge_e_Tempt_GND)*bsimcmg_lexp(T1)+((T0_Vge_e*diffVds*ids)+((T0*diffVds)*ids_Vge_e))*bsimcmg_d_lexp(T1,T1_Vge_e)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Vge_e)+((T0*diffVds)*ids)*T1_Vge_e_Tempt_GND);
#endif
Iii_Ve_si=((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Ve_si)));
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=(+(+(+T0_Ve_si_Vge_di*diffVds+T0_Ve_si*0.0+T0_Vge_di*diffVds_Ve_si+T0*0.0)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Vge_di)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Vge_di);
  Iii_Ve_si_Vge_e=(+(+(+T0_Ve_si_Vge_e*diffVds+T0_Ve_si*0.0+T0_Vge_e*diffVds_Ve_si+T0*0.0)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Vge_e)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Vge_e);
  Iii_Ve_si_Ve_si=(+(+(+T0_Ve_si_Ve_si*diffVds+T0_Ve_si*diffVds_Ve_si+T0_Ve_si*diffVds_Ve_si+T0*diffVds_Ve_si_Ve_si)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Ve_si)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Ve_si);
  Iii_Ve_si_Ve_di=(+(+(+T0_Ve_si_Ve_di*diffVds+T0_Ve_si*diffVds_Ve_di+T0_Ve_di*diffVds_Ve_si+T0*diffVds_Ve_si_Ve_di)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Ve_di)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Ve_di);
  Iii_Ve_si_Vge_si=(+(+(+T0_Ve_si_Vge_si*diffVds+T0_Ve_si*diffVds_Vge_si+T0_Vge_si*diffVds_Ve_si+T0*diffVds_Ve_si_Vge_si)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Vge_si)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Vge_si);
  Iii_Ve_si_Vdi_si=(+(+(+T0_Ve_si_Vdi_si*diffVds+T0_Ve_si*diffVds_Vdi_si+T0_Vdi_si*diffVds_Ve_si+T0*diffVds_Ve_si_Vdi_si)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Vdi_si)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Vdi_si);
  Iii_Ve_si_Tempt_GND=(+(+(+T0_Ve_si_Tempt_GND*diffVds+T0_Ve_si*diffVds_Tempt_GND+T0_Tempt_GND*diffVds_Ve_si+T0*diffVds_Ve_si_Tempt_GND)*ids+((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Ve_si+(T0*diffVds)*ids_Ve_si_Tempt_GND)*bsimcmg_lexp(T1)+((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si))*ids)+((T0*diffVds)*ids_Ve_si))*bsimcmg_d_lexp(T1,T1_Ve_si)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Ve_si)+((T0*diffVds)*ids)*T1_Ve_si_Tempt_GND);
#endif
Iii_Ve_di=((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Ve_di)));
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=(+(+(+T0_Ve_di_Vge_di*diffVds+T0_Ve_di*0.0+T0_Vge_di*diffVds_Ve_di+T0*0.0)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Vge_di)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Vge_di);
  Iii_Ve_di_Vge_e=(+(+(+T0_Ve_di_Vge_e*diffVds+T0_Ve_di*0.0+T0_Vge_e*diffVds_Ve_di+T0*0.0)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Vge_e)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Vge_e);
  Iii_Ve_di_Ve_si=(+(+(+T0_Ve_di_Ve_si*diffVds+T0_Ve_di*diffVds_Ve_si+T0_Ve_si*diffVds_Ve_di+T0*diffVds_Ve_di_Ve_si)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Ve_si)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Ve_si);
  Iii_Ve_di_Ve_di=(+(+(+T0_Ve_di_Ve_di*diffVds+T0_Ve_di*diffVds_Ve_di+T0_Ve_di*diffVds_Ve_di+T0*diffVds_Ve_di_Ve_di)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Ve_di)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Ve_di);
  Iii_Ve_di_Vge_si=(+(+(+T0_Ve_di_Vge_si*diffVds+T0_Ve_di*diffVds_Vge_si+T0_Vge_si*diffVds_Ve_di+T0*diffVds_Ve_di_Vge_si)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Vge_si)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Vge_si);
  Iii_Ve_di_Vdi_si=(+(+(+T0_Ve_di_Vdi_si*diffVds+T0_Ve_di*diffVds_Vdi_si+T0_Vdi_si*diffVds_Ve_di+T0*diffVds_Ve_di_Vdi_si)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Vdi_si)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Vdi_si);
  Iii_Ve_di_Tempt_GND=(+(+(+T0_Ve_di_Tempt_GND*diffVds+T0_Ve_di*diffVds_Tempt_GND+T0_Tempt_GND*diffVds_Ve_di+T0*diffVds_Ve_di_Tempt_GND)*ids+((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Ve_di+(T0*diffVds)*ids_Ve_di_Tempt_GND)*bsimcmg_lexp(T1)+((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di))*ids)+((T0*diffVds)*ids_Ve_di))*bsimcmg_d_lexp(T1,T1_Ve_di)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Ve_di)+((T0*diffVds)*ids)*T1_Ve_di_Tempt_GND);
#endif
Iii_Vge_si=((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Vge_si)));
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=(+(+(+T0_Vge_si_Vge_di*diffVds+T0_Vge_si*0.0+T0_Vge_di*diffVds_Vge_si+T0*0.0)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Vge_di)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Vge_di);
  Iii_Vge_si_Vge_e=(+(+(+T0_Vge_si_Vge_e*diffVds+T0_Vge_si*0.0+T0_Vge_e*diffVds_Vge_si+T0*0.0)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Vge_e)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Vge_e);
  Iii_Vge_si_Ve_si=(+(+(+T0_Vge_si_Ve_si*diffVds+T0_Vge_si*diffVds_Ve_si+T0_Ve_si*diffVds_Vge_si+T0*diffVds_Vge_si_Ve_si)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Ve_si)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Ve_si);
  Iii_Vge_si_Ve_di=(+(+(+T0_Vge_si_Ve_di*diffVds+T0_Vge_si*diffVds_Ve_di+T0_Ve_di*diffVds_Vge_si+T0*diffVds_Vge_si_Ve_di)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Ve_di)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Ve_di);
  Iii_Vge_si_Vge_si=(+(+(+T0_Vge_si_Vge_si*diffVds+T0_Vge_si*diffVds_Vge_si+T0_Vge_si*diffVds_Vge_si+T0*diffVds_Vge_si_Vge_si)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Vge_si)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Vge_si);
  Iii_Vge_si_Vdi_si=(+(+(+T0_Vge_si_Vdi_si*diffVds+T0_Vge_si*diffVds_Vdi_si+T0_Vdi_si*diffVds_Vge_si+T0*diffVds_Vge_si_Vdi_si)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Vdi_si)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Vdi_si);
  Iii_Vge_si_Tempt_GND=(+(+(+T0_Vge_si_Tempt_GND*diffVds+T0_Vge_si*diffVds_Tempt_GND+T0_Tempt_GND*diffVds_Vge_si+T0*diffVds_Vge_si_Tempt_GND)*ids+((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Vge_si+(T0*diffVds)*ids_Vge_si_Tempt_GND)*bsimcmg_lexp(T1)+((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si))*ids)+((T0*diffVds)*ids_Vge_si))*bsimcmg_d_lexp(T1,T1_Vge_si)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Vge_si)+((T0*diffVds)*ids)*T1_Vge_si_Tempt_GND);
#endif
Iii_Vdi_si=((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Vdi_si)));
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=(+(+(+T0_Vdi_si_Vge_di*diffVds+T0_Vdi_si*0.0+T0_Vge_di*diffVds_Vdi_si+T0*0.0)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Vge_di)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Vge_di);
  Iii_Vdi_si_Vge_e=(+(+(+T0_Vdi_si_Vge_e*diffVds+T0_Vdi_si*0.0+T0_Vge_e*diffVds_Vdi_si+T0*0.0)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Vge_e)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Vge_e);
  Iii_Vdi_si_Ve_si=(+(+(+T0_Vdi_si_Ve_si*diffVds+T0_Vdi_si*diffVds_Ve_si+T0_Ve_si*diffVds_Vdi_si+T0*diffVds_Vdi_si_Ve_si)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Ve_si)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Ve_si);
  Iii_Vdi_si_Ve_di=(+(+(+T0_Vdi_si_Ve_di*diffVds+T0_Vdi_si*diffVds_Ve_di+T0_Ve_di*diffVds_Vdi_si+T0*diffVds_Vdi_si_Ve_di)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Ve_di)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Ve_di);
  Iii_Vdi_si_Vge_si=(+(+(+T0_Vdi_si_Vge_si*diffVds+T0_Vdi_si*diffVds_Vge_si+T0_Vge_si*diffVds_Vdi_si+T0*diffVds_Vdi_si_Vge_si)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Vge_si)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Vge_si);
  Iii_Vdi_si_Vdi_si=(+(+(+T0_Vdi_si_Vdi_si*diffVds+T0_Vdi_si*diffVds_Vdi_si+T0_Vdi_si*diffVds_Vdi_si+T0*diffVds_Vdi_si_Vdi_si)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Vdi_si)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Vdi_si);
  Iii_Vdi_si_Tempt_GND=(+(+(+T0_Vdi_si_Tempt_GND*diffVds+T0_Vdi_si*diffVds_Tempt_GND+T0_Tempt_GND*diffVds_Vdi_si+T0*diffVds_Vdi_si_Tempt_GND)*ids+((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Vdi_si+(T0*diffVds)*ids_Vdi_si_Tempt_GND)*bsimcmg_lexp(T1)+((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si))*ids)+((T0*diffVds)*ids_Vdi_si))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Vdi_si)+((T0*diffVds)*ids)*T1_Vdi_si_Tempt_GND);
#endif
Iii_Tempt_GND=((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_lexp(T1))+(((T0*diffVds)*ids)*bsimcmg_d_lexp(T1,T1_Tempt_GND)));
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=(+(+(+T0_Tempt_GND_Vge_di*diffVds+T0_Tempt_GND*0.0+T0_Vge_di*diffVds_Tempt_GND+T0*0.0)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Vge_di+(T0_Vge_di*diffVds)*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Vge_di)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((T0_Vge_di*diffVds)*ids)+((T0*diffVds)*ids_Vge_di)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Vge_di);
  Iii_Tempt_GND_Vge_e=(+(+(+T0_Tempt_GND_Vge_e*diffVds+T0_Tempt_GND*0.0+T0_Vge_e*diffVds_Tempt_GND+T0*0.0)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Vge_e+(T0_Vge_e*diffVds)*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Vge_e)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((T0_Vge_e*diffVds)*ids)+((T0*diffVds)*ids_Vge_e)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Vge_e);
  Iii_Tempt_GND_Ve_si=(+(+(+T0_Tempt_GND_Ve_si*diffVds+T0_Tempt_GND*diffVds_Ve_si+T0_Ve_si*diffVds_Tempt_GND+T0*diffVds_Tempt_GND_Ve_si)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Ve_si+(((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Ve_si)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((((T0_Ve_si*diffVds)+(T0*diffVds_Ve_si)))*ids)+((T0*diffVds)*ids_Ve_si)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Ve_si);
  Iii_Tempt_GND_Ve_di=(+(+(+T0_Tempt_GND_Ve_di*diffVds+T0_Tempt_GND*diffVds_Ve_di+T0_Ve_di*diffVds_Tempt_GND+T0*diffVds_Tempt_GND_Ve_di)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Ve_di+(((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Ve_di)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((((T0_Ve_di*diffVds)+(T0*diffVds_Ve_di)))*ids)+((T0*diffVds)*ids_Ve_di)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Ve_di);
  Iii_Tempt_GND_Vge_si=(+(+(+T0_Tempt_GND_Vge_si*diffVds+T0_Tempt_GND*diffVds_Vge_si+T0_Vge_si*diffVds_Tempt_GND+T0*diffVds_Tempt_GND_Vge_si)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Vge_si+(((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Vge_si)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((((T0_Vge_si*diffVds)+(T0*diffVds_Vge_si)))*ids)+((T0*diffVds)*ids_Vge_si)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Vge_si);
  Iii_Tempt_GND_Vdi_si=(+(+(+T0_Tempt_GND_Vdi_si*diffVds+T0_Tempt_GND*diffVds_Vdi_si+T0_Vdi_si*diffVds_Tempt_GND+T0*diffVds_Tempt_GND_Vdi_si)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Vdi_si+(((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Vdi_si)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((((T0_Vdi_si*diffVds)+(T0*diffVds_Vdi_si)))*ids)+((T0*diffVds)*ids_Vdi_si)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Vdi_si);
  Iii_Tempt_GND_Tempt_GND=(+(+(+T0_Tempt_GND_Tempt_GND*diffVds+T0_Tempt_GND*diffVds_Tempt_GND+T0_Tempt_GND*diffVds_Tempt_GND+T0*diffVds_Tempt_GND_Tempt_GND)*ids+((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids_Tempt_GND+(((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids_Tempt_GND+(T0*diffVds)*ids_Tempt_GND_Tempt_GND)*bsimcmg_lexp(T1)+((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND))*ids)+((T0*diffVds)*ids_Tempt_GND))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((((((T0_Tempt_GND*diffVds)+(T0*diffVds_Tempt_GND)))*ids)+((T0*diffVds)*ids_Tempt_GND)))*bsimcmg_d_lexp(T1,T1_Tempt_GND)+((T0*diffVds)*ids)*T1_Tempt_GND_Tempt_GND);
#endif
#endif
Iii=(((T0*diffVds)*ids)*bsimcmg_lexp(T1));
EXIT_IF_ISNAN((((T0*diffVds)*ids)*bsimcmg_lexp(T1)))
}
}
else
{
if
((pModel->IIMOD==2))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
ALPHAII_Tempt_GND=((ALPHAII0_t_Tempt_GND+ALPHAII1_t_Tempt_GND*Leff)/Leff);
#if defined(_DERIVATE2)
  ALPHAII_Tempt_GND_Tempt_GND=((+ALPHAII0_t_Tempt_GND_Tempt_GND+(+ALPHAII1_t_Tempt_GND_Tempt_GND*Leff+ALPHAII1_t_Tempt_GND*0.0+ALPHAII1_t_Tempt_GND*0.0+ALPHAII1_t*0.0))/Leff-((ALPHAII0_t_Tempt_GND+ALPHAII1_t_Tempt_GND*Leff)*0.0+(ALPHAII0_t_Tempt_GND+(ALPHAII1_t_Tempt_GND*Leff))*0.0+(ALPHAII0_t+(ALPHAII1_t*Leff))*0.0)/Leff/Leff+2*(ALPHAII0_t+(ALPHAII1_t*Leff))*0.0*0.0/Leff/Leff/Leff);
#endif
#endif
ALPHAII=((ALPHAII0_t+(ALPHAII1_t*Leff))/Leff);
EXIT_IF_ISNAN(((ALPHAII0_t+(ALPHAII1_t*Leff))/Leff))
if
((ALPHAII<=0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=0.0;
  Iii_Vge_di_Vge_e=0.0;
  Iii_Vge_di_Ve_si=0.0;
  Iii_Vge_di_Ve_di=0.0;
  Iii_Vge_di_Vge_si=0.0;
  Iii_Vge_di_Vdi_si=0.0;
  Iii_Vge_di_Tempt_GND=0.0;
#endif
Iii_Vge_e=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=0.0;
  Iii_Vge_e_Vge_e=0.0;
  Iii_Vge_e_Ve_si=0.0;
  Iii_Vge_e_Ve_di=0.0;
  Iii_Vge_e_Vge_si=0.0;
  Iii_Vge_e_Vdi_si=0.0;
  Iii_Vge_e_Tempt_GND=0.0;
#endif
Iii_Ve_si=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=0.0;
  Iii_Ve_si_Vge_e=0.0;
  Iii_Ve_si_Ve_si=0.0;
  Iii_Ve_si_Ve_di=0.0;
  Iii_Ve_si_Vge_si=0.0;
  Iii_Ve_si_Vdi_si=0.0;
  Iii_Ve_si_Tempt_GND=0.0;
#endif
Iii_Ve_di=0.0;
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=0.0;
  Iii_Ve_di_Vge_e=0.0;
  Iii_Ve_di_Ve_si=0.0;
  Iii_Ve_di_Ve_di=0.0;
  Iii_Ve_di_Vge_si=0.0;
  Iii_Ve_di_Vdi_si=0.0;
  Iii_Ve_di_Tempt_GND=0.0;
#endif
Iii_Vge_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=0.0;
  Iii_Vge_si_Vge_e=0.0;
  Iii_Vge_si_Ve_si=0.0;
  Iii_Vge_si_Ve_di=0.0;
  Iii_Vge_si_Vge_si=0.0;
  Iii_Vge_si_Vdi_si=0.0;
  Iii_Vge_si_Tempt_GND=0.0;
#endif
Iii_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=0.0;
  Iii_Vdi_si_Vge_e=0.0;
  Iii_Vdi_si_Ve_si=0.0;
  Iii_Vdi_si_Ve_di=0.0;
  Iii_Vdi_si_Vge_si=0.0;
  Iii_Vdi_si_Vdi_si=0.0;
  Iii_Vdi_si_Tempt_GND=0.0;
#endif
Iii_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=0.0;
  Iii_Tempt_GND_Vge_e=0.0;
  Iii_Tempt_GND_Ve_si=0.0;
  Iii_Tempt_GND_Ve_di=0.0;
  Iii_Tempt_GND_Vge_si=0.0;
  Iii_Tempt_GND_Vdi_si=0.0;
  Iii_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
Iii=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=(ESATII_i*Leff);
EXIT_IF_ISNAN((ESATII_i*Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(((SII0_t*T0_Vge_di)*(1.0+T0)-(SII0_t*T0)*T0_Vge_di)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Vge_di+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_di)*0.0+(0.0)*T0_Vge_di+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Vge_di+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_di)*0.0+(0.0)*T0_Vge_di+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Vge_di)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Vge_e)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Ve_si)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Ve_di)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Vge_si)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_di+SII0_t*T0_Vge_di_Vdi_si)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_di_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Vge_di+SII0_t*T0_Vge_di_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Vge_di)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Vge_di+(SII0_t*T0)*(+0.0+T0_Vge_di_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_di*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Vge_e=(((SII0_t*T0_Vge_e)*(1.0+T0)-(SII0_t*T0)*T0_Vge_e)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Vge_e+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_e)*0.0+(0.0)*T0_Vge_e+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Vge_e+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_e)*0.0+(0.0)*T0_Vge_e+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Vge_di)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Vge_e)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Ve_si)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Ve_di)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Vge_si)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_e+SII0_t*T0_Vge_e_Vdi_si)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_e_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Vge_e+SII0_t*T0_Vge_e_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Vge_e)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Vge_e+(SII0_t*T0)*(+0.0+T0_Vge_e_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_e*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Ve_si=(((SII0_t*T0_Ve_si)*(1.0+T0)-(SII0_t*T0)*T0_Ve_si)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Ve_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Ve_si)*0.0+(0.0)*T0_Ve_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Ve_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Ve_si)*0.0+(0.0)*T0_Ve_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Vge_di)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Vge_e)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Ve_si)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Ve_di)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Vge_si)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+SII0_t*T0_Ve_si_Vdi_si)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_si_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Ve_si+SII0_t*T0_Ve_si_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Ve_si)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Ve_si+(SII0_t*T0)*(+0.0+T0_Ve_si_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_si*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Ve_di=(((SII0_t*T0_Ve_di)*(1.0+T0)-(SII0_t*T0)*T0_Ve_di)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Ve_di+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Ve_di)*0.0+(0.0)*T0_Ve_di+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Ve_di+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Ve_di)*0.0+(0.0)*T0_Ve_di+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Vge_di)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Vge_e)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Ve_si)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Ve_di)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Vge_si)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+SII0_t*T0_Ve_di_Vdi_si)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Ve_di_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Ve_di+SII0_t*T0_Ve_di_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Ve_di)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Ve_di+(SII0_t*T0)*(+0.0+T0_Ve_di_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Ve_di*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Vge_si=(((SII0_t*T0_Vge_si)*(1.0+T0)-(SII0_t*T0)*T0_Vge_si)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Vge_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_si)*0.0+(0.0)*T0_Vge_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Vge_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vge_si)*0.0+(0.0)*T0_Vge_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Vge_di)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Vge_e)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Ve_si)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Ve_di)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Vge_si)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+SII0_t*T0_Vge_si_Vdi_si)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vge_si_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Vge_si+SII0_t*T0_Vge_si_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Vge_si)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Vge_si+(SII0_t*T0)*(+0.0+T0_Vge_si_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vge_si*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Vdi_si=(((SII0_t*T0_Vdi_si)*(1.0+T0)-(SII0_t*T0)*T0_Vdi_si)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=((+0.0*T0+0.0*0.0+0.0*T0_Vdi_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vdi_si)*0.0+(0.0)*T0_Vdi_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Vsi_s=((+0.0*T0+0.0*0.0+0.0*T0_Vdi_si+SII0_t*0.0)/(1.0+T0)-((SII0_t*T0_Vdi_si)*0.0+(0.0)*T0_Vdi_si+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Vge_di=((+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Vge_di)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Vge_e=((+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Vge_e)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Ve_si=((+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Ve_si)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Ve_di=((+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Ve_di)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Vge_si=((+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Vge_si)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Vdi_si=((+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+SII0_t*T0_Vdi_si_Vdi_si)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Vdi_si_Tempt_GND=((+0.0*T0+0.0*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Vdi_si+SII0_t*T0_Vdi_si_Tempt_GND)/(1.0+T0)-((SII0_t*T0_Vdi_si)*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Vdi_si+(SII0_t*T0)*(+0.0+T0_Vdi_si_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Vdi_si*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
T1_Tempt_GND=((((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*(1.0+T0)-(SII0_t*T0)*T0_Tempt_GND)/(1.0+T0)/(1.0+T0));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((+0.0*T0+SII0_t_Tempt_GND*0.0+0.0*T0_Tempt_GND+SII0_t*0.0)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*0.0+(0.0)*T0_Tempt_GND+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Vsi_s=((+0.0*T0+SII0_t_Tempt_GND*0.0+0.0*T0_Tempt_GND+SII0_t*0.0)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*0.0+(0.0)*T0_Tempt_GND+(SII0_t*T0)*(+0.0+0.0))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*0.0/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Vge_di=((+0.0*T0+SII0_t_Tempt_GND*T0_Vge_di+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Vge_di)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Vge_di+((SII0_t*T0_Vge_di))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Vge_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Vge_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Vge_e=((+0.0*T0+SII0_t_Tempt_GND*T0_Vge_e+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Vge_e)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Vge_e+((SII0_t*T0_Vge_e))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Vge_e))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Vge_e/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Ve_si=((+0.0*T0+SII0_t_Tempt_GND*T0_Ve_si+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Ve_si)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Ve_si+((SII0_t*T0_Ve_si))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Ve_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Ve_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Ve_di=((+0.0*T0+SII0_t_Tempt_GND*T0_Ve_di+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Ve_di)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Ve_di+((SII0_t*T0_Ve_di))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Ve_di))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Ve_di/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Vge_si=((+0.0*T0+SII0_t_Tempt_GND*T0_Vge_si+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Vge_si)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Vge_si+((SII0_t*T0_Vge_si))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Vge_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Vge_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Vdi_si=((+0.0*T0+SII0_t_Tempt_GND*T0_Vdi_si+0.0*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Vdi_si)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Vdi_si+((SII0_t*T0_Vdi_si))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Vdi_si))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Vdi_si/(1.0+T0)/(1.0+T0)/(1.0+T0));
  T1_Tempt_GND_Tempt_GND=((+SII0_t_Tempt_GND_Tempt_GND*T0+SII0_t_Tempt_GND*T0_Tempt_GND+SII0_t_Tempt_GND*T0_Tempt_GND+SII0_t*T0_Tempt_GND_Tempt_GND)/(1.0+T0)-(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND))*T0_Tempt_GND+(((SII0_t_Tempt_GND*T0)+(SII0_t*T0_Tempt_GND)))*T0_Tempt_GND+(SII0_t*T0)*(+0.0+T0_Tempt_GND_Tempt_GND))/(1.0+T0)/(1.0+T0)+2*(SII0_t*T0)*T0_Tempt_GND*T0_Tempt_GND/(1.0+T0)/(1.0+T0)/(1.0+T0));
#endif
#endif
T1=((SII0_t*T0)/(1.0+T0));
EXIT_IF_ISNAN(((SII0_t*T0)/(1.0+T0)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=(-bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Vge_e=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Ve_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Ve_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Vge_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Vdi_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vge_si_Tempt_GND=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vge_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#endif
T0_Vdi_si=(-bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Vge_e=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Ve_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Ve_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Vge_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Vdi_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Vdi_si_Tempt_GND=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Vdi_si),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#endif
T0_Tempt_GND=(-bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Vge_e=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Ve_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Ve_di=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Vge_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Vdi_si=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
  T0_Tempt_GND_Tempt_GND=(0.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))-(0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+0.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)+1.0*(+0.0+0.0))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))+2*1.0*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)*bsimcmg_d_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1,(SII1_i*vgsfbeff_Tempt_GND),0.0)/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
#endif
#endif
T0=(1.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1)));
EXIT_IF_ISNAN((1.0/(1.0+bsimcmg_hypsmooth((SII1_i*vgsfbeff),pModel->IIMOD2CLAMP1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=T0_Vge_di;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+0.0+0.0);
  T3_Vge_di_Vsi_s=(+0.0+0.0);
  T3_Vge_di_Vge_di=(+T0_Vge_di_Vge_di+0.0);
  T3_Vge_di_Vge_e=(+T0_Vge_di_Vge_e+0.0);
  T3_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si+0.0);
  T3_Vge_di_Ve_si=(+T0_Vge_di_Ve_si+0.0);
  T3_Vge_di_Ve_di=(+T0_Vge_di_Ve_di+0.0);
  T3_Vge_di_Vge_si=(+T0_Vge_di_Vge_si+0.0);
  T3_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND+0.0);
#endif
T3_Vge_e=T0_Vge_e;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0+0.0);
  T3_Vge_e_Vsi_s=(+0.0+0.0);
  T3_Vge_e_Vge_di=(+T0_Vge_e_Vge_di+0.0);
  T3_Vge_e_Vge_e=(+T0_Vge_e_Vge_e+0.0);
  T3_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si+0.0);
  T3_Vge_e_Ve_si=(+T0_Vge_e_Ve_si+0.0);
  T3_Vge_e_Ve_di=(+T0_Vge_e_Ve_di+0.0);
  T3_Vge_e_Vge_si=(+T0_Vge_e_Vge_si+0.0);
  T3_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND+0.0);
#endif
T3_Vdi_si=T0_Vdi_si;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0+0.0);
  T3_Vdi_si_Vsi_s=(+0.0+0.0);
  T3_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di+0.0);
  T3_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e+0.0);
  T3_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si+0.0);
  T3_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si+0.0);
  T3_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di+0.0);
  T3_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si+0.0);
  T3_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND+0.0);
#endif
T3_Ve_si=T0_Ve_si;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0+0.0);
  T3_Ve_si_Vsi_s=(+0.0+0.0);
  T3_Ve_si_Vge_di=(+T0_Ve_si_Vge_di+0.0);
  T3_Ve_si_Vge_e=(+T0_Ve_si_Vge_e+0.0);
  T3_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si+0.0);
  T3_Ve_si_Ve_si=(+T0_Ve_si_Ve_si+0.0);
  T3_Ve_si_Ve_di=(+T0_Ve_si_Ve_di+0.0);
  T3_Ve_si_Vge_si=(+T0_Ve_si_Vge_si+0.0);
  T3_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND+0.0);
#endif
T3_Ve_di=T0_Ve_di;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0+0.0);
  T3_Ve_di_Vsi_s=(+0.0+0.0);
  T3_Ve_di_Vge_di=(+T0_Ve_di_Vge_di+0.0);
  T3_Ve_di_Vge_e=(+T0_Ve_di_Vge_e+0.0);
  T3_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si+0.0);
  T3_Ve_di_Ve_si=(+T0_Ve_di_Ve_si+0.0);
  T3_Ve_di_Ve_di=(+T0_Ve_di_Ve_di+0.0);
  T3_Ve_di_Vge_si=(+T0_Ve_di_Vge_si+0.0);
  T3_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND+0.0);
#endif
T3_Vge_si=T0_Vge_si;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0+0.0);
  T3_Vge_si_Vsi_s=(+0.0+0.0);
  T3_Vge_si_Vge_di=(+T0_Vge_si_Vge_di+0.0);
  T3_Vge_si_Vge_e=(+T0_Vge_si_Vge_e+0.0);
  T3_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si+0.0);
  T3_Vge_si_Ve_si=(+T0_Vge_si_Ve_si+0.0);
  T3_Vge_si_Ve_di=(+T0_Vge_si_Ve_di+0.0);
  T3_Vge_si_Vge_si=(+T0_Vge_si_Vge_si+0.0);
  T3_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND+0.0);
#endif
T3_Tempt_GND=T0_Tempt_GND;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0+0.0);
  T3_Tempt_GND_Vsi_s=(+0.0+0.0);
  T3_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di+0.0);
  T3_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e+0.0);
  T3_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si+0.0);
  T3_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si+0.0);
  T3_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di+0.0);
  T3_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si+0.0);
  T3_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND+0.0);
#endif
#endif
T3=(T0+SII2_i);
EXIT_IF_ISNAN((T0+SII2_i))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,(vgsfbeff*T3_Vge_di),0.0);
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,(vgsfbeff*T3_Vge_e),0.0);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,((vgsfbeff_Vge_si*T3)+(vgsfbeff*T3_Vge_si)),0.0);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,(vgsfbeff*T3_Ve_si),0.0);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,(vgsfbeff*T3_Ve_di),0.0);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,((vgsfbeff_Vdi_si*T3)+(vgsfbeff*T3_Vdi_si)),0.0);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=bsimcmg_d_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2,((vgsfbeff_Tempt_GND*T3)+(vgsfbeff*T3_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((vgsfbeff*T3),pModel->IIMOD2CLAMP2))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(-(SIID_i*vds_Vdi_si)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Vsi_s=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Vge_di=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Vge_e=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Vdi_si=(0.0/(1.0+(SIID_i*vds))-(0.0*((SIID_i*vds_Vdi_si))+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*vds_Vdi_si+0.0*vds_Vdi_si+SIID_i*vds_Vdi_si_Vdi_si)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*((SIID_i*vds_Vdi_si))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Ve_si=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Ve_di=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Vge_si=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
  T3_Vdi_si_Tempt_GND=(0.0/(1.0+(SIID_i*vds))-(0.0*(0.0)+0.0*(SIID_i*vds_Vdi_si)+1.0*(+0.0+(+0.0*vds+0.0*0.0+0.0*vds_Vdi_si+SIID_i*0.0)))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))+2*1.0*(SIID_i*vds_Vdi_si)*(0.0)/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds))/(1.0+(SIID_i*vds)));
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0+(SIID_i*vds)));
EXIT_IF_ISNAN((1.0/(1.0+(SIID_i*vds))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
VgsStep_Vge_di=((((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3)+((T1*T2)*T3_Vge_di));
#if defined(_DERIVATE2)
  VgsStep_Vge_di_Vge_di=(+(+T1_Vge_di_Vge_di*T2+T1_Vge_di*T2_Vge_di+T1_Vge_di*T2_Vge_di+T1*T2_Vge_di_Vge_di)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Vge_di);
  VgsStep_Vge_di_Vge_e=(+(+T1_Vge_di_Vge_e*T2+T1_Vge_di*T2_Vge_e+T1_Vge_e*T2_Vge_di+T1*T2_Vge_di_Vge_e)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Vge_e);
  VgsStep_Vge_di_Ve_si=(+(+T1_Vge_di_Ve_si*T2+T1_Vge_di*T2_Ve_si+T1_Ve_si*T2_Vge_di+T1*T2_Vge_di_Ve_si)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Ve_si);
  VgsStep_Vge_di_Ve_di=(+(+T1_Vge_di_Ve_di*T2+T1_Vge_di*T2_Ve_di+T1_Ve_di*T2_Vge_di+T1*T2_Vge_di_Ve_di)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Ve_di);
  VgsStep_Vge_di_Vge_si=(+(+T1_Vge_di_Vge_si*T2+T1_Vge_di*T2_Vge_si+T1_Vge_si*T2_Vge_di+T1*T2_Vge_di_Vge_si)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Vge_si);
  VgsStep_Vge_di_Vdi_si=(+(+T1_Vge_di_Vdi_si*T2+T1_Vge_di*T2_Vdi_si+T1_Vdi_si*T2_Vge_di+T1*T2_Vge_di_Vdi_si)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Vdi_si);
  VgsStep_Vge_di_Tempt_GND=(+(+T1_Vge_di_Tempt_GND*T2+T1_Vge_di*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_di+T1*T2_Vge_di_Tempt_GND)*T3+((T1_Vge_di*T2)+(T1*T2_Vge_di))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Vge_di+(T1*T2)*T3_Vge_di_Tempt_GND);
#endif
VgsStep_Vge_e=((((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3)+((T1*T2)*T3_Vge_e));
#if defined(_DERIVATE2)
  VgsStep_Vge_e_Vge_di=(+(+T1_Vge_e_Vge_di*T2+T1_Vge_e*T2_Vge_di+T1_Vge_di*T2_Vge_e+T1*T2_Vge_e_Vge_di)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Vge_di);
  VgsStep_Vge_e_Vge_e=(+(+T1_Vge_e_Vge_e*T2+T1_Vge_e*T2_Vge_e+T1_Vge_e*T2_Vge_e+T1*T2_Vge_e_Vge_e)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Vge_e);
  VgsStep_Vge_e_Ve_si=(+(+T1_Vge_e_Ve_si*T2+T1_Vge_e*T2_Ve_si+T1_Ve_si*T2_Vge_e+T1*T2_Vge_e_Ve_si)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Ve_si);
  VgsStep_Vge_e_Ve_di=(+(+T1_Vge_e_Ve_di*T2+T1_Vge_e*T2_Ve_di+T1_Ve_di*T2_Vge_e+T1*T2_Vge_e_Ve_di)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Ve_di);
  VgsStep_Vge_e_Vge_si=(+(+T1_Vge_e_Vge_si*T2+T1_Vge_e*T2_Vge_si+T1_Vge_si*T2_Vge_e+T1*T2_Vge_e_Vge_si)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Vge_si);
  VgsStep_Vge_e_Vdi_si=(+(+T1_Vge_e_Vdi_si*T2+T1_Vge_e*T2_Vdi_si+T1_Vdi_si*T2_Vge_e+T1*T2_Vge_e_Vdi_si)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Vdi_si);
  VgsStep_Vge_e_Tempt_GND=(+(+T1_Vge_e_Tempt_GND*T2+T1_Vge_e*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_e+T1*T2_Vge_e_Tempt_GND)*T3+((T1_Vge_e*T2)+(T1*T2_Vge_e))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Vge_e+(T1*T2)*T3_Vge_e_Tempt_GND);
#endif
VgsStep_Ve_si=((((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3)+((T1*T2)*T3_Ve_si));
#if defined(_DERIVATE2)
  VgsStep_Ve_si_Vge_di=(+(+T1_Ve_si_Vge_di*T2+T1_Ve_si*T2_Vge_di+T1_Vge_di*T2_Ve_si+T1*T2_Ve_si_Vge_di)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Vge_di);
  VgsStep_Ve_si_Vge_e=(+(+T1_Ve_si_Vge_e*T2+T1_Ve_si*T2_Vge_e+T1_Vge_e*T2_Ve_si+T1*T2_Ve_si_Vge_e)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Vge_e);
  VgsStep_Ve_si_Ve_si=(+(+T1_Ve_si_Ve_si*T2+T1_Ve_si*T2_Ve_si+T1_Ve_si*T2_Ve_si+T1*T2_Ve_si_Ve_si)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Ve_si);
  VgsStep_Ve_si_Ve_di=(+(+T1_Ve_si_Ve_di*T2+T1_Ve_si*T2_Ve_di+T1_Ve_di*T2_Ve_si+T1*T2_Ve_si_Ve_di)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Ve_di);
  VgsStep_Ve_si_Vge_si=(+(+T1_Ve_si_Vge_si*T2+T1_Ve_si*T2_Vge_si+T1_Vge_si*T2_Ve_si+T1*T2_Ve_si_Vge_si)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Vge_si);
  VgsStep_Ve_si_Vdi_si=(+(+T1_Ve_si_Vdi_si*T2+T1_Ve_si*T2_Vdi_si+T1_Vdi_si*T2_Ve_si+T1*T2_Ve_si_Vdi_si)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Vdi_si);
  VgsStep_Ve_si_Tempt_GND=(+(+T1_Ve_si_Tempt_GND*T2+T1_Ve_si*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_si+T1*T2_Ve_si_Tempt_GND)*T3+((T1_Ve_si*T2)+(T1*T2_Ve_si))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Ve_si+(T1*T2)*T3_Ve_si_Tempt_GND);
#endif
VgsStep_Ve_di=((((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3)+((T1*T2)*T3_Ve_di));
#if defined(_DERIVATE2)
  VgsStep_Ve_di_Vge_di=(+(+T1_Ve_di_Vge_di*T2+T1_Ve_di*T2_Vge_di+T1_Vge_di*T2_Ve_di+T1*T2_Ve_di_Vge_di)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Vge_di);
  VgsStep_Ve_di_Vge_e=(+(+T1_Ve_di_Vge_e*T2+T1_Ve_di*T2_Vge_e+T1_Vge_e*T2_Ve_di+T1*T2_Ve_di_Vge_e)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Vge_e);
  VgsStep_Ve_di_Ve_si=(+(+T1_Ve_di_Ve_si*T2+T1_Ve_di*T2_Ve_si+T1_Ve_si*T2_Ve_di+T1*T2_Ve_di_Ve_si)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Ve_si);
  VgsStep_Ve_di_Ve_di=(+(+T1_Ve_di_Ve_di*T2+T1_Ve_di*T2_Ve_di+T1_Ve_di*T2_Ve_di+T1*T2_Ve_di_Ve_di)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Ve_di);
  VgsStep_Ve_di_Vge_si=(+(+T1_Ve_di_Vge_si*T2+T1_Ve_di*T2_Vge_si+T1_Vge_si*T2_Ve_di+T1*T2_Ve_di_Vge_si)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Vge_si);
  VgsStep_Ve_di_Vdi_si=(+(+T1_Ve_di_Vdi_si*T2+T1_Ve_di*T2_Vdi_si+T1_Vdi_si*T2_Ve_di+T1*T2_Ve_di_Vdi_si)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Vdi_si);
  VgsStep_Ve_di_Tempt_GND=(+(+T1_Ve_di_Tempt_GND*T2+T1_Ve_di*T2_Tempt_GND+T1_Tempt_GND*T2_Ve_di+T1*T2_Ve_di_Tempt_GND)*T3+((T1_Ve_di*T2)+(T1*T2_Ve_di))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Ve_di+(T1*T2)*T3_Ve_di_Tempt_GND);
#endif
VgsStep_Vge_si=((((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3)+((T1*T2)*T3_Vge_si));
#if defined(_DERIVATE2)
  VgsStep_Vge_si_Vge_di=(+(+T1_Vge_si_Vge_di*T2+T1_Vge_si*T2_Vge_di+T1_Vge_di*T2_Vge_si+T1*T2_Vge_si_Vge_di)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Vge_di);
  VgsStep_Vge_si_Vge_e=(+(+T1_Vge_si_Vge_e*T2+T1_Vge_si*T2_Vge_e+T1_Vge_e*T2_Vge_si+T1*T2_Vge_si_Vge_e)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Vge_e);
  VgsStep_Vge_si_Ve_si=(+(+T1_Vge_si_Ve_si*T2+T1_Vge_si*T2_Ve_si+T1_Ve_si*T2_Vge_si+T1*T2_Vge_si_Ve_si)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Ve_si);
  VgsStep_Vge_si_Ve_di=(+(+T1_Vge_si_Ve_di*T2+T1_Vge_si*T2_Ve_di+T1_Ve_di*T2_Vge_si+T1*T2_Vge_si_Ve_di)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Ve_di);
  VgsStep_Vge_si_Vge_si=(+(+T1_Vge_si_Vge_si*T2+T1_Vge_si*T2_Vge_si+T1_Vge_si*T2_Vge_si+T1*T2_Vge_si_Vge_si)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Vge_si);
  VgsStep_Vge_si_Vdi_si=(+(+T1_Vge_si_Vdi_si*T2+T1_Vge_si*T2_Vdi_si+T1_Vdi_si*T2_Vge_si+T1*T2_Vge_si_Vdi_si)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Vdi_si);
  VgsStep_Vge_si_Tempt_GND=(+(+T1_Vge_si_Tempt_GND*T2+T1_Vge_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vge_si+T1*T2_Vge_si_Tempt_GND)*T3+((T1_Vge_si*T2)+(T1*T2_Vge_si))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Vge_si+(T1*T2)*T3_Vge_si_Tempt_GND);
#endif
VgsStep_Vdi_si=((((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3)+((T1*T2)*T3_Vdi_si));
#if defined(_DERIVATE2)
  VgsStep_Vdi_si_Vge_di=(+(+T1_Vdi_si_Vge_di*T2+T1_Vdi_si*T2_Vge_di+T1_Vge_di*T2_Vdi_si+T1*T2_Vdi_si_Vge_di)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Vge_di);
  VgsStep_Vdi_si_Vge_e=(+(+T1_Vdi_si_Vge_e*T2+T1_Vdi_si*T2_Vge_e+T1_Vge_e*T2_Vdi_si+T1*T2_Vdi_si_Vge_e)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Vge_e);
  VgsStep_Vdi_si_Ve_si=(+(+T1_Vdi_si_Ve_si*T2+T1_Vdi_si*T2_Ve_si+T1_Ve_si*T2_Vdi_si+T1*T2_Vdi_si_Ve_si)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Ve_si);
  VgsStep_Vdi_si_Ve_di=(+(+T1_Vdi_si_Ve_di*T2+T1_Vdi_si*T2_Ve_di+T1_Ve_di*T2_Vdi_si+T1*T2_Vdi_si_Ve_di)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Ve_di);
  VgsStep_Vdi_si_Vge_si=(+(+T1_Vdi_si_Vge_si*T2+T1_Vdi_si*T2_Vge_si+T1_Vge_si*T2_Vdi_si+T1*T2_Vdi_si_Vge_si)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Vge_si);
  VgsStep_Vdi_si_Vdi_si=(+(+T1_Vdi_si_Vdi_si*T2+T1_Vdi_si*T2_Vdi_si+T1_Vdi_si*T2_Vdi_si+T1*T2_Vdi_si_Vdi_si)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Vdi_si);
  VgsStep_Vdi_si_Tempt_GND=(+(+T1_Vdi_si_Tempt_GND*T2+T1_Vdi_si*T2_Tempt_GND+T1_Tempt_GND*T2_Vdi_si+T1*T2_Vdi_si_Tempt_GND)*T3+((T1_Vdi_si*T2)+(T1*T2_Vdi_si))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Vdi_si+(T1*T2)*T3_Vdi_si_Tempt_GND);
#endif
VgsStep_Tempt_GND=((((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3)+((T1*T2)*T3_Tempt_GND));
#if defined(_DERIVATE2)
  VgsStep_Tempt_GND_Vge_di=(+(+T1_Tempt_GND_Vge_di*T2+T1_Tempt_GND*T2_Vge_di+T1_Vge_di*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_di)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Vge_di+(((T1_Vge_di*T2)+(T1*T2_Vge_di)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Vge_di);
  VgsStep_Tempt_GND_Vge_e=(+(+T1_Tempt_GND_Vge_e*T2+T1_Tempt_GND*T2_Vge_e+T1_Vge_e*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_e)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Vge_e+(((T1_Vge_e*T2)+(T1*T2_Vge_e)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Vge_e);
  VgsStep_Tempt_GND_Ve_si=(+(+T1_Tempt_GND_Ve_si*T2+T1_Tempt_GND*T2_Ve_si+T1_Ve_si*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_si)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Ve_si+(((T1_Ve_si*T2)+(T1*T2_Ve_si)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Ve_si);
  VgsStep_Tempt_GND_Ve_di=(+(+T1_Tempt_GND_Ve_di*T2+T1_Tempt_GND*T2_Ve_di+T1_Ve_di*T2_Tempt_GND+T1*T2_Tempt_GND_Ve_di)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Ve_di+(((T1_Ve_di*T2)+(T1*T2_Ve_di)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Ve_di);
  VgsStep_Tempt_GND_Vge_si=(+(+T1_Tempt_GND_Vge_si*T2+T1_Tempt_GND*T2_Vge_si+T1_Vge_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vge_si)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Vge_si+(((T1_Vge_si*T2)+(T1*T2_Vge_si)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Vge_si);
  VgsStep_Tempt_GND_Vdi_si=(+(+T1_Tempt_GND_Vdi_si*T2+T1_Tempt_GND*T2_Vdi_si+T1_Vdi_si*T2_Tempt_GND+T1*T2_Tempt_GND_Vdi_si)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Vdi_si+(((T1_Vdi_si*T2)+(T1*T2_Vdi_si)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Vdi_si);
  VgsStep_Tempt_GND_Tempt_GND=(+(+T1_Tempt_GND_Tempt_GND*T2+T1_Tempt_GND*T2_Tempt_GND+T1_Tempt_GND*T2_Tempt_GND+T1*T2_Tempt_GND_Tempt_GND)*T3+((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND))*T3_Tempt_GND+(((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND)))*T3_Tempt_GND+(T1*T2)*T3_Tempt_GND_Tempt_GND);
#endif
#endif
VgsStep=((T1*T2)*T3);
EXIT_IF_ISNAN(((T1*T2)*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND)V(e,GND) */
Vdsatii_Vge_di=VgsStep_Vge_di*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Vge_di_Vge_di=(+VgsStep_Vge_di_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Vge_e=(+VgsStep_Vge_di_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Ve_si=(+VgsStep_Vge_di_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Ve_di=(+VgsStep_Vge_di_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Vge_si=(+VgsStep_Vge_di_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Vdi_si=(+VgsStep_Vge_di_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_di_Tempt_GND=(+VgsStep_Vge_di_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Vge_di*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Vge_e=VgsStep_Vge_e*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Vge_e_Vge_di=(+VgsStep_Vge_e_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Vge_e=(+VgsStep_Vge_e_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Ve_si=(+VgsStep_Vge_e_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Ve_di=(+VgsStep_Vge_e_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Vge_si=(+VgsStep_Vge_e_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Vdi_si=(+VgsStep_Vge_e_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_e_Tempt_GND=(+VgsStep_Vge_e_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Vge_e*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Ve_si=VgsStep_Ve_si*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Ve_si_Vge_di=(+VgsStep_Ve_si_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Vge_e=(+VgsStep_Ve_si_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Ve_si=(+VgsStep_Ve_si_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Ve_di=(+VgsStep_Ve_si_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Vge_si=(+VgsStep_Ve_si_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Vdi_si=(+VgsStep_Ve_si_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_si_Tempt_GND=(+VgsStep_Ve_si_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Ve_si*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Ve_di=VgsStep_Ve_di*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Ve_di_Vge_di=(+VgsStep_Ve_di_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Vge_e=(+VgsStep_Ve_di_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Ve_si=(+VgsStep_Ve_di_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Ve_di=(+VgsStep_Ve_di_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Vge_si=(+VgsStep_Ve_di_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Vdi_si=(+VgsStep_Ve_di_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Ve_di_Tempt_GND=(+VgsStep_Ve_di_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Ve_di*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Vge_si=VgsStep_Vge_si*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Vge_si_Vge_di=(+VgsStep_Vge_si_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Vge_e=(+VgsStep_Vge_si_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Ve_si=(+VgsStep_Vge_si_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Ve_di=(+VgsStep_Vge_si_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Vge_si=(+VgsStep_Vge_si_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Vdi_si=(+VgsStep_Vge_si_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vge_si_Tempt_GND=(+VgsStep_Vge_si_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Vge_si*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Vdi_si=VgsStep_Vdi_si*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Vdi_si_Vge_di=(+VgsStep_Vdi_si_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Vge_e=(+VgsStep_Vdi_si_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Ve_si=(+VgsStep_Vdi_si_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Ve_di=(+VgsStep_Vdi_si_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Vge_si=(+VgsStep_Vdi_si_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Vdi_si=(+VgsStep_Vdi_si_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Vdi_si_Tempt_GND=(+VgsStep_Vdi_si_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Vdi_si*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
Vdsatii_Tempt_GND=VgsStep_Tempt_GND*(1.0-(LII_i/Leff));
#if defined(_DERIVATE2)
  Vdsatii_Tempt_GND_Vge_di=(+VgsStep_Tempt_GND_Vge_di*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Vge_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Vge_e=(+VgsStep_Tempt_GND_Vge_e*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Vge_e*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Ve_si=(+VgsStep_Tempt_GND_Ve_si*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Ve_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Ve_di=(+VgsStep_Tempt_GND_Ve_di*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Ve_di*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Vge_si=(+VgsStep_Tempt_GND_Vge_si*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Vge_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Vdi_si=(+VgsStep_Tempt_GND_Vdi_si*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Vdi_si*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
  Vdsatii_Tempt_GND_Tempt_GND=(+VgsStep_Tempt_GND_Tempt_GND*(1.0-(LII_i/Leff))+VgsStep_Tempt_GND*0.0+VgsStep_Tempt_GND*0.0+VgsStep*(+0.0-(0.0/Leff-(0.0*0.0+0.0*0.0+LII_i*0.0)/Leff/Leff+2*LII_i*0.0*0.0/Leff/Leff/Leff)));
#endif
#endif
Vdsatii=(VgsStep*(1.0-(LII_i/Leff)));
EXIT_IF_ISNAN((VgsStep*(1.0-(LII_i/Leff))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Vdiff_Vdi_si=(vds_Vdi_si-Vdsatii_Vdi_si);
#if defined(_DERIVATE2)
  Vdiff_Vdi_si_Vdi_si=(+vds_Vdi_si_Vdi_si-Vdsatii_Vdi_si_Vdi_si);
  Vdiff_Vdi_si_Vge_di=(+0.0-Vdsatii_Vdi_si_Vge_di);
  Vdiff_Vdi_si_Vge_e=(+0.0-Vdsatii_Vdi_si_Vge_e);
  Vdiff_Vdi_si_Ve_si=(+0.0-Vdsatii_Vdi_si_Ve_si);
  Vdiff_Vdi_si_Ve_di=(+0.0-Vdsatii_Vdi_si_Ve_di);
  Vdiff_Vdi_si_Vge_si=(+0.0-Vdsatii_Vdi_si_Vge_si);
  Vdiff_Vdi_si_Tempt_GND=(+0.0-Vdsatii_Vdi_si_Tempt_GND);
#endif
Vdiff_Vge_di=(-Vdsatii_Vge_di);
#if defined(_DERIVATE2)
  Vdiff_Vge_di_Vdi_si=(+0.0-Vdsatii_Vge_di_Vdi_si);
  Vdiff_Vge_di_Vge_di=(+0.0-Vdsatii_Vge_di_Vge_di);
  Vdiff_Vge_di_Vge_e=(+0.0-Vdsatii_Vge_di_Vge_e);
  Vdiff_Vge_di_Ve_si=(+0.0-Vdsatii_Vge_di_Ve_si);
  Vdiff_Vge_di_Ve_di=(+0.0-Vdsatii_Vge_di_Ve_di);
  Vdiff_Vge_di_Vge_si=(+0.0-Vdsatii_Vge_di_Vge_si);
  Vdiff_Vge_di_Tempt_GND=(+0.0-Vdsatii_Vge_di_Tempt_GND);
#endif
Vdiff_Vge_e=(-Vdsatii_Vge_e);
#if defined(_DERIVATE2)
  Vdiff_Vge_e_Vdi_si=(+0.0-Vdsatii_Vge_e_Vdi_si);
  Vdiff_Vge_e_Vge_di=(+0.0-Vdsatii_Vge_e_Vge_di);
  Vdiff_Vge_e_Vge_e=(+0.0-Vdsatii_Vge_e_Vge_e);
  Vdiff_Vge_e_Ve_si=(+0.0-Vdsatii_Vge_e_Ve_si);
  Vdiff_Vge_e_Ve_di=(+0.0-Vdsatii_Vge_e_Ve_di);
  Vdiff_Vge_e_Vge_si=(+0.0-Vdsatii_Vge_e_Vge_si);
  Vdiff_Vge_e_Tempt_GND=(+0.0-Vdsatii_Vge_e_Tempt_GND);
#endif
Vdiff_Ve_si=(-Vdsatii_Ve_si);
#if defined(_DERIVATE2)
  Vdiff_Ve_si_Vdi_si=(+0.0-Vdsatii_Ve_si_Vdi_si);
  Vdiff_Ve_si_Vge_di=(+0.0-Vdsatii_Ve_si_Vge_di);
  Vdiff_Ve_si_Vge_e=(+0.0-Vdsatii_Ve_si_Vge_e);
  Vdiff_Ve_si_Ve_si=(+0.0-Vdsatii_Ve_si_Ve_si);
  Vdiff_Ve_si_Ve_di=(+0.0-Vdsatii_Ve_si_Ve_di);
  Vdiff_Ve_si_Vge_si=(+0.0-Vdsatii_Ve_si_Vge_si);
  Vdiff_Ve_si_Tempt_GND=(+0.0-Vdsatii_Ve_si_Tempt_GND);
#endif
Vdiff_Ve_di=(-Vdsatii_Ve_di);
#if defined(_DERIVATE2)
  Vdiff_Ve_di_Vdi_si=(+0.0-Vdsatii_Ve_di_Vdi_si);
  Vdiff_Ve_di_Vge_di=(+0.0-Vdsatii_Ve_di_Vge_di);
  Vdiff_Ve_di_Vge_e=(+0.0-Vdsatii_Ve_di_Vge_e);
  Vdiff_Ve_di_Ve_si=(+0.0-Vdsatii_Ve_di_Ve_si);
  Vdiff_Ve_di_Ve_di=(+0.0-Vdsatii_Ve_di_Ve_di);
  Vdiff_Ve_di_Vge_si=(+0.0-Vdsatii_Ve_di_Vge_si);
  Vdiff_Ve_di_Tempt_GND=(+0.0-Vdsatii_Ve_di_Tempt_GND);
#endif
Vdiff_Vge_si=(-Vdsatii_Vge_si);
#if defined(_DERIVATE2)
  Vdiff_Vge_si_Vdi_si=(+0.0-Vdsatii_Vge_si_Vdi_si);
  Vdiff_Vge_si_Vge_di=(+0.0-Vdsatii_Vge_si_Vge_di);
  Vdiff_Vge_si_Vge_e=(+0.0-Vdsatii_Vge_si_Vge_e);
  Vdiff_Vge_si_Ve_si=(+0.0-Vdsatii_Vge_si_Ve_si);
  Vdiff_Vge_si_Ve_di=(+0.0-Vdsatii_Vge_si_Ve_di);
  Vdiff_Vge_si_Vge_si=(+0.0-Vdsatii_Vge_si_Vge_si);
  Vdiff_Vge_si_Tempt_GND=(+0.0-Vdsatii_Vge_si_Tempt_GND);
#endif
Vdiff_Tempt_GND=(-Vdsatii_Tempt_GND);
#if defined(_DERIVATE2)
  Vdiff_Tempt_GND_Vdi_si=(+0.0-Vdsatii_Tempt_GND_Vdi_si);
  Vdiff_Tempt_GND_Vge_di=(+0.0-Vdsatii_Tempt_GND_Vge_di);
  Vdiff_Tempt_GND_Vge_e=(+0.0-Vdsatii_Tempt_GND_Vge_e);
  Vdiff_Tempt_GND_Ve_si=(+0.0-Vdsatii_Tempt_GND_Ve_si);
  Vdiff_Tempt_GND_Ve_di=(+0.0-Vdsatii_Tempt_GND_Ve_di);
  Vdiff_Tempt_GND_Vge_si=(+0.0-Vdsatii_Tempt_GND_Vge_si);
  Vdiff_Tempt_GND_Tempt_GND=(+0.0-Vdsatii_Tempt_GND_Tempt_GND);
#endif
#endif
Vdiff=(vds-Vdsatii);
EXIT_IF_ISNAN((vds-Vdsatii))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=((BETAII1_i*Vdiff_Vge_di)+(((BETAII0_i*Vdiff_Vge_di)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Vge_di)));
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Vge_di));
  T0_Vge_di_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Vge_e));
  T0_Vge_di_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Ve_si));
  T0_Vge_di_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Ve_di));
  T0_Vge_di_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Vge_si));
  T0_Vge_di_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Vdi_si));
  T0_Vge_di_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_di+BETAII1_i*Vdiff_Vge_di_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_di+BETAII0_i*Vdiff_Vge_di_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Vge_di)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Vge_di+(BETAII0_i*Vdiff)*Vdiff_Vge_di_Tempt_GND));
#endif
T0_Vge_e=((BETAII1_i*Vdiff_Vge_e)+(((BETAII0_i*Vdiff_Vge_e)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Vge_e)));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Vge_di));
  T0_Vge_e_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Vge_e));
  T0_Vge_e_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Ve_si));
  T0_Vge_e_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Ve_di));
  T0_Vge_e_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Vge_si));
  T0_Vge_e_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Vdi_si));
  T0_Vge_e_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_e+BETAII1_i*Vdiff_Vge_e_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_e+BETAII0_i*Vdiff_Vge_e_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Vge_e)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Vge_e+(BETAII0_i*Vdiff)*Vdiff_Vge_e_Tempt_GND));
#endif
T0_Ve_si=((BETAII1_i*Vdiff_Ve_si)+(((BETAII0_i*Vdiff_Ve_si)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Ve_si)));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Vge_di));
  T0_Ve_si_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Vge_e));
  T0_Ve_si_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Ve_si));
  T0_Ve_si_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Ve_di));
  T0_Ve_si_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Vge_si));
  T0_Ve_si_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Vdi_si));
  T0_Ve_si_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Ve_si+BETAII1_i*Vdiff_Ve_si_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Ve_si+BETAII0_i*Vdiff_Ve_si_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Ve_si)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Ve_si+(BETAII0_i*Vdiff)*Vdiff_Ve_si_Tempt_GND));
#endif
T0_Ve_di=((BETAII1_i*Vdiff_Ve_di)+(((BETAII0_i*Vdiff_Ve_di)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Ve_di)));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Vge_di));
  T0_Ve_di_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Vge_e));
  T0_Ve_di_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Ve_si));
  T0_Ve_di_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Ve_di));
  T0_Ve_di_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Vge_si));
  T0_Ve_di_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Vdi_si));
  T0_Ve_di_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Ve_di+BETAII1_i*Vdiff_Ve_di_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Ve_di+BETAII0_i*Vdiff_Ve_di_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Ve_di)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Ve_di+(BETAII0_i*Vdiff)*Vdiff_Ve_di_Tempt_GND));
#endif
T0_Vge_si=((BETAII1_i*Vdiff_Vge_si)+(((BETAII0_i*Vdiff_Vge_si)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Vge_si)));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Vge_di));
  T0_Vge_si_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Vge_e));
  T0_Vge_si_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Ve_si));
  T0_Vge_si_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Ve_di));
  T0_Vge_si_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Vge_si));
  T0_Vge_si_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Vdi_si));
  T0_Vge_si_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_si+BETAII1_i*Vdiff_Vge_si_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vge_si+BETAII0_i*Vdiff_Vge_si_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Vge_si)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Vge_si+(BETAII0_i*Vdiff)*Vdiff_Vge_si_Tempt_GND));
#endif
T0_Vdi_si=((BETAII1_i*Vdiff_Vdi_si)+(((BETAII0_i*Vdiff_Vdi_si)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Vdi_si)));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Vge_di));
  T0_Vdi_si_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Vge_e));
  T0_Vdi_si_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Ve_si));
  T0_Vdi_si_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Ve_di));
  T0_Vdi_si_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Vge_si));
  T0_Vdi_si_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Vdi_si));
  T0_Vdi_si_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vdi_si+BETAII1_i*Vdiff_Vdi_si_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Vdi_si+BETAII0_i*Vdiff_Vdi_si_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Vdi_si)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Vdi_si+(BETAII0_i*Vdiff)*Vdiff_Vdi_si_Tempt_GND));
#endif
T0_Tempt_GND=((BETAII1_i*Vdiff_Tempt_GND)+(((BETAII0_i*Vdiff_Tempt_GND)*Vdiff)+((BETAII0_i*Vdiff)*Vdiff_Tempt_GND)));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Vge_di))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_di+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Vge_di)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Vge_di+((BETAII0_i*Vdiff_Vge_di))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Vge_di));
  T0_Tempt_GND_Vge_e=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Vge_e))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_e+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Vge_e)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Vge_e+((BETAII0_i*Vdiff_Vge_e))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Vge_e));
  T0_Tempt_GND_Ve_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Ve_si))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_si+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Ve_si)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Ve_si+((BETAII0_i*Vdiff_Ve_si))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Ve_si));
  T0_Tempt_GND_Ve_di=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Ve_di))+(+(+0.0*Vdiff+0.0*Vdiff_Ve_di+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Ve_di)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Ve_di+((BETAII0_i*Vdiff_Ve_di))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Ve_di));
  T0_Tempt_GND_Vge_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Vge_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vge_si+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Vge_si)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Vge_si+((BETAII0_i*Vdiff_Vge_si))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Vge_si));
  T0_Tempt_GND_Vdi_si=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Vdi_si))+(+(+0.0*Vdiff+0.0*Vdiff_Vdi_si+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Vdi_si)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Vdi_si+((BETAII0_i*Vdiff_Vdi_si))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Vdi_si));
  T0_Tempt_GND_Tempt_GND=(+(+0.0+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Tempt_GND+BETAII1_i*Vdiff_Tempt_GND_Tempt_GND))+(+(+0.0*Vdiff+0.0*Vdiff_Tempt_GND+0.0*Vdiff_Tempt_GND+BETAII0_i*Vdiff_Tempt_GND_Tempt_GND)*Vdiff+(BETAII0_i*Vdiff_Tempt_GND)*Vdiff_Tempt_GND+((BETAII0_i*Vdiff_Tempt_GND))*Vdiff_Tempt_GND+(BETAII0_i*Vdiff)*Vdiff_Tempt_GND_Tempt_GND));
#endif
#endif
T0=((BETAII2_i+(BETAII1_i*Vdiff))+((BETAII0_i*Vdiff)*Vdiff));
EXIT_IF_ISNAN(((BETAII2_i+(BETAII1_i*Vdiff))+((BETAII0_i*Vdiff)*Vdiff)))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-10))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-10))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+0.0*T0+T0_Vge_di*0.0+0.0*T0_Vge_di+T0*0.0)+0.0));
  T1_Vge_di_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+0.0*T0+T0_Vge_di*0.0+0.0*T0_Vge_di+T0*0.0)+0.0));
  T1_Vge_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+0.0));
  T1_Vge_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+0.0));
  T1_Vge_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+0.0));
  T1_Vge_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+0.0));
  T1_Vge_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+0.0));
  T1_Vge_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+0.0));
  T1_Vge_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+0.0));
#endif
T1_Vge_e=((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+0.0*T0+T0_Vge_e*0.0+0.0*T0_Vge_e+T0*0.0)+0.0));
  T1_Vge_e_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+0.0*T0+T0_Vge_e*0.0+0.0*T0_Vge_e+T0*0.0)+0.0));
  T1_Vge_e_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+0.0));
  T1_Vge_e_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+0.0));
  T1_Vge_e_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+0.0));
  T1_Vge_e_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+0.0));
  T1_Vge_e_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+0.0));
  T1_Vge_e_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+0.0));
  T1_Vge_e_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+0.0));
#endif
T1_Ve_si=((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+0.0*T0+T0_Ve_si*0.0+0.0*T0_Ve_si+T0*0.0)+0.0));
  T1_Ve_si_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+0.0*T0+T0_Ve_si*0.0+0.0*T0_Ve_si+T0*0.0)+0.0));
  T1_Ve_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+0.0));
  T1_Ve_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+0.0));
  T1_Ve_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+0.0));
  T1_Ve_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+0.0));
  T1_Ve_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+0.0));
  T1_Ve_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+0.0));
  T1_Ve_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+0.0));
#endif
T1_Ve_di=((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+0.0*T0+T0_Ve_di*0.0+0.0*T0_Ve_di+T0*0.0)+0.0));
  T1_Ve_di_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+0.0*T0+T0_Ve_di*0.0+0.0*T0_Ve_di+T0*0.0)+0.0));
  T1_Ve_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+0.0));
  T1_Ve_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+0.0));
  T1_Ve_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+0.0));
  T1_Ve_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+0.0));
  T1_Ve_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+0.0));
  T1_Ve_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+0.0));
  T1_Ve_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+0.0));
#endif
T1_Vge_si=((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+0.0*T0+T0_Vge_si*0.0+0.0*T0_Vge_si+T0*0.0)+0.0));
  T1_Vge_si_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+0.0*T0+T0_Vge_si*0.0+0.0*T0_Vge_si+T0*0.0)+0.0));
  T1_Vge_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+0.0));
  T1_Vge_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+0.0));
  T1_Vge_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+0.0));
  T1_Vge_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+0.0));
  T1_Vge_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+0.0));
  T1_Vge_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+0.0));
  T1_Vge_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+0.0));
#endif
T1_Vdi_si=((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+0.0*T0+T0_Vdi_si*0.0+0.0*T0_Vdi_si+T0*0.0)+0.0));
  T1_Vdi_si_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+0.0*T0+T0_Vdi_si*0.0+0.0*T0_Vdi_si+T0*0.0)+0.0));
  T1_Vdi_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+0.0));
  T1_Vdi_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+0.0));
  T1_Vdi_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+0.0));
  T1_Vdi_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+0.0));
  T1_Vdi_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+0.0));
  T1_Vdi_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+0.0));
  T1_Vdi_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+0.0));
#endif
T1_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+0.0*T0+T0_Tempt_GND*0.0+0.0*T0_Tempt_GND+T0*0.0)+0.0));
  T1_Tempt_GND_Vsi_s=(m20_sqrt(((T0*T0)+1.0e-10))*(0.0)*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+0.0*T0+T0_Tempt_GND*0.0+0.0*T0_Tempt_GND+T0*0.0)+0.0));
  T1_Tempt_GND_Vge_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+0.0));
  T1_Tempt_GND_Vge_e=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+0.0));
  T1_Tempt_GND_Ve_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+0.0));
  T1_Tempt_GND_Ve_di=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+0.0));
  T1_Tempt_GND_Vge_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+0.0));
  T1_Tempt_GND_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+0.0));
  T1_Tempt_GND_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-10))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
T1=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
Ratio_Tempt_GND=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,(((-ALPHAII_Tempt_GND)*bsimcmg_lexp((Vdiff/T1)))+((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Tempt_GND*T1-Vdiff*T1_Tempt_GND)/T1/T1)))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Tempt_GND_Tempt_GND=0.0;
  Ratio_Tempt_GND_Vdi_si=0.0;
  Ratio_Tempt_GND_Vge_di=0.0;
  Ratio_Tempt_GND_Vge_e=0.0;
  Ratio_Tempt_GND_Ve_si=0.0;
  Ratio_Tempt_GND_Ve_di=0.0;
  Ratio_Tempt_GND_Vge_si=0.0;
#endif
Ratio_Vdi_si=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Vdi_si*T1-Vdiff*T1_Vdi_si)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Vdi_si_Tempt_GND=0.0;
  Ratio_Vdi_si_Vdi_si=0.0;
  Ratio_Vdi_si_Vge_di=0.0;
  Ratio_Vdi_si_Vge_e=0.0;
  Ratio_Vdi_si_Ve_si=0.0;
  Ratio_Vdi_si_Ve_di=0.0;
  Ratio_Vdi_si_Vge_si=0.0;
#endif
Ratio_Vge_di=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Vge_di*T1-Vdiff*T1_Vge_di)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Vge_di_Tempt_GND=0.0;
  Ratio_Vge_di_Vdi_si=0.0;
  Ratio_Vge_di_Vge_di=0.0;
  Ratio_Vge_di_Vge_e=0.0;
  Ratio_Vge_di_Ve_si=0.0;
  Ratio_Vge_di_Ve_di=0.0;
  Ratio_Vge_di_Vge_si=0.0;
#endif
Ratio_Vge_e=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Vge_e*T1-Vdiff*T1_Vge_e)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Vge_e_Tempt_GND=0.0;
  Ratio_Vge_e_Vdi_si=0.0;
  Ratio_Vge_e_Vge_di=0.0;
  Ratio_Vge_e_Vge_e=0.0;
  Ratio_Vge_e_Ve_si=0.0;
  Ratio_Vge_e_Ve_di=0.0;
  Ratio_Vge_e_Vge_si=0.0;
#endif
Ratio_Ve_si=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Ve_si*T1-Vdiff*T1_Ve_si)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Ve_si_Tempt_GND=0.0;
  Ratio_Ve_si_Vdi_si=0.0;
  Ratio_Ve_si_Vge_di=0.0;
  Ratio_Ve_si_Vge_e=0.0;
  Ratio_Ve_si_Ve_si=0.0;
  Ratio_Ve_si_Ve_di=0.0;
  Ratio_Ve_si_Vge_si=0.0;
#endif
Ratio_Ve_di=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Ve_di*T1-Vdiff*T1_Ve_di)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Ve_di_Tempt_GND=0.0;
  Ratio_Ve_di_Vdi_si=0.0;
  Ratio_Ve_di_Vge_di=0.0;
  Ratio_Ve_di_Vge_e=0.0;
  Ratio_Ve_di_Ve_si=0.0;
  Ratio_Ve_di_Ve_di=0.0;
  Ratio_Ve_di_Vge_si=0.0;
#endif
Ratio_Vge_si=(-bsimcmg_d_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3,((-ALPHAII)*bsimcmg_d_lexp((Vdiff/T1),((Vdiff_Vge_si*T1-Vdiff*T1_Vge_si)/T1/T1))),0.0,0.0));
#if defined(_DERIVATE2)
  Ratio_Vge_si_Tempt_GND=0.0;
  Ratio_Vge_si_Vdi_si=0.0;
  Ratio_Vge_si_Vge_di=0.0;
  Ratio_Vge_si_Vge_e=0.0;
  Ratio_Vge_si_Ve_si=0.0;
  Ratio_Vge_si_Ve_di=0.0;
  Ratio_Vge_si_Vge_si=0.0;
#endif
#endif
Ratio=(-bsimcmg_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3));
EXIT_IF_ISNAN((-bsimcmg_hypmax(((-ALPHAII)*bsimcmg_lexp((Vdiff/T1))),(-10.0),pModel->IIMOD2CLAMP3)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
Iii_Vge_di=((Ratio_Vge_di*ids)+(Ratio*ids_Vge_di));
#if defined(_DERIVATE2)
  Iii_Vge_di_Vge_di=(+Ratio_Vge_di_Vge_di*ids+Ratio_Vge_di*ids_Vge_di+Ratio_Vge_di*ids_Vge_di+Ratio*ids_Vge_di_Vge_di);
  Iii_Vge_di_Vge_e=(+Ratio_Vge_di_Vge_e*ids+Ratio_Vge_di*ids_Vge_e+Ratio_Vge_e*ids_Vge_di+Ratio*ids_Vge_di_Vge_e);
  Iii_Vge_di_Ve_si=(+Ratio_Vge_di_Ve_si*ids+Ratio_Vge_di*ids_Ve_si+Ratio_Ve_si*ids_Vge_di+Ratio*ids_Vge_di_Ve_si);
  Iii_Vge_di_Ve_di=(+Ratio_Vge_di_Ve_di*ids+Ratio_Vge_di*ids_Ve_di+Ratio_Ve_di*ids_Vge_di+Ratio*ids_Vge_di_Ve_di);
  Iii_Vge_di_Vge_si=(+Ratio_Vge_di_Vge_si*ids+Ratio_Vge_di*ids_Vge_si+Ratio_Vge_si*ids_Vge_di+Ratio*ids_Vge_di_Vge_si);
  Iii_Vge_di_Vdi_si=(+Ratio_Vge_di_Vdi_si*ids+Ratio_Vge_di*ids_Vdi_si+Ratio_Vdi_si*ids_Vge_di+Ratio*ids_Vge_di_Vdi_si);
  Iii_Vge_di_Tempt_GND=(+Ratio_Vge_di_Tempt_GND*ids+Ratio_Vge_di*ids_Tempt_GND+Ratio_Tempt_GND*ids_Vge_di+Ratio*ids_Vge_di_Tempt_GND);
#endif
Iii_Vge_e=((Ratio_Vge_e*ids)+(Ratio*ids_Vge_e));
#if defined(_DERIVATE2)
  Iii_Vge_e_Vge_di=(+Ratio_Vge_e_Vge_di*ids+Ratio_Vge_e*ids_Vge_di+Ratio_Vge_di*ids_Vge_e+Ratio*ids_Vge_e_Vge_di);
  Iii_Vge_e_Vge_e=(+Ratio_Vge_e_Vge_e*ids+Ratio_Vge_e*ids_Vge_e+Ratio_Vge_e*ids_Vge_e+Ratio*ids_Vge_e_Vge_e);
  Iii_Vge_e_Ve_si=(+Ratio_Vge_e_Ve_si*ids+Ratio_Vge_e*ids_Ve_si+Ratio_Ve_si*ids_Vge_e+Ratio*ids_Vge_e_Ve_si);
  Iii_Vge_e_Ve_di=(+Ratio_Vge_e_Ve_di*ids+Ratio_Vge_e*ids_Ve_di+Ratio_Ve_di*ids_Vge_e+Ratio*ids_Vge_e_Ve_di);
  Iii_Vge_e_Vge_si=(+Ratio_Vge_e_Vge_si*ids+Ratio_Vge_e*ids_Vge_si+Ratio_Vge_si*ids_Vge_e+Ratio*ids_Vge_e_Vge_si);
  Iii_Vge_e_Vdi_si=(+Ratio_Vge_e_Vdi_si*ids+Ratio_Vge_e*ids_Vdi_si+Ratio_Vdi_si*ids_Vge_e+Ratio*ids_Vge_e_Vdi_si);
  Iii_Vge_e_Tempt_GND=(+Ratio_Vge_e_Tempt_GND*ids+Ratio_Vge_e*ids_Tempt_GND+Ratio_Tempt_GND*ids_Vge_e+Ratio*ids_Vge_e_Tempt_GND);
#endif
Iii_Ve_si=((Ratio_Ve_si*ids)+(Ratio*ids_Ve_si));
#if defined(_DERIVATE2)
  Iii_Ve_si_Vge_di=(+Ratio_Ve_si_Vge_di*ids+Ratio_Ve_si*ids_Vge_di+Ratio_Vge_di*ids_Ve_si+Ratio*ids_Ve_si_Vge_di);
  Iii_Ve_si_Vge_e=(+Ratio_Ve_si_Vge_e*ids+Ratio_Ve_si*ids_Vge_e+Ratio_Vge_e*ids_Ve_si+Ratio*ids_Ve_si_Vge_e);
  Iii_Ve_si_Ve_si=(+Ratio_Ve_si_Ve_si*ids+Ratio_Ve_si*ids_Ve_si+Ratio_Ve_si*ids_Ve_si+Ratio*ids_Ve_si_Ve_si);
  Iii_Ve_si_Ve_di=(+Ratio_Ve_si_Ve_di*ids+Ratio_Ve_si*ids_Ve_di+Ratio_Ve_di*ids_Ve_si+Ratio*ids_Ve_si_Ve_di);
  Iii_Ve_si_Vge_si=(+Ratio_Ve_si_Vge_si*ids+Ratio_Ve_si*ids_Vge_si+Ratio_Vge_si*ids_Ve_si+Ratio*ids_Ve_si_Vge_si);
  Iii_Ve_si_Vdi_si=(+Ratio_Ve_si_Vdi_si*ids+Ratio_Ve_si*ids_Vdi_si+Ratio_Vdi_si*ids_Ve_si+Ratio*ids_Ve_si_Vdi_si);
  Iii_Ve_si_Tempt_GND=(+Ratio_Ve_si_Tempt_GND*ids+Ratio_Ve_si*ids_Tempt_GND+Ratio_Tempt_GND*ids_Ve_si+Ratio*ids_Ve_si_Tempt_GND);
#endif
Iii_Ve_di=((Ratio_Ve_di*ids)+(Ratio*ids_Ve_di));
#if defined(_DERIVATE2)
  Iii_Ve_di_Vge_di=(+Ratio_Ve_di_Vge_di*ids+Ratio_Ve_di*ids_Vge_di+Ratio_Vge_di*ids_Ve_di+Ratio*ids_Ve_di_Vge_di);
  Iii_Ve_di_Vge_e=(+Ratio_Ve_di_Vge_e*ids+Ratio_Ve_di*ids_Vge_e+Ratio_Vge_e*ids_Ve_di+Ratio*ids_Ve_di_Vge_e);
  Iii_Ve_di_Ve_si=(+Ratio_Ve_di_Ve_si*ids+Ratio_Ve_di*ids_Ve_si+Ratio_Ve_si*ids_Ve_di+Ratio*ids_Ve_di_Ve_si);
  Iii_Ve_di_Ve_di=(+Ratio_Ve_di_Ve_di*ids+Ratio_Ve_di*ids_Ve_di+Ratio_Ve_di*ids_Ve_di+Ratio*ids_Ve_di_Ve_di);
  Iii_Ve_di_Vge_si=(+Ratio_Ve_di_Vge_si*ids+Ratio_Ve_di*ids_Vge_si+Ratio_Vge_si*ids_Ve_di+Ratio*ids_Ve_di_Vge_si);
  Iii_Ve_di_Vdi_si=(+Ratio_Ve_di_Vdi_si*ids+Ratio_Ve_di*ids_Vdi_si+Ratio_Vdi_si*ids_Ve_di+Ratio*ids_Ve_di_Vdi_si);
  Iii_Ve_di_Tempt_GND=(+Ratio_Ve_di_Tempt_GND*ids+Ratio_Ve_di*ids_Tempt_GND+Ratio_Tempt_GND*ids_Ve_di+Ratio*ids_Ve_di_Tempt_GND);
#endif
Iii_Vge_si=((Ratio_Vge_si*ids)+(Ratio*ids_Vge_si));
#if defined(_DERIVATE2)
  Iii_Vge_si_Vge_di=(+Ratio_Vge_si_Vge_di*ids+Ratio_Vge_si*ids_Vge_di+Ratio_Vge_di*ids_Vge_si+Ratio*ids_Vge_si_Vge_di);
  Iii_Vge_si_Vge_e=(+Ratio_Vge_si_Vge_e*ids+Ratio_Vge_si*ids_Vge_e+Ratio_Vge_e*ids_Vge_si+Ratio*ids_Vge_si_Vge_e);
  Iii_Vge_si_Ve_si=(+Ratio_Vge_si_Ve_si*ids+Ratio_Vge_si*ids_Ve_si+Ratio_Ve_si*ids_Vge_si+Ratio*ids_Vge_si_Ve_si);
  Iii_Vge_si_Ve_di=(+Ratio_Vge_si_Ve_di*ids+Ratio_Vge_si*ids_Ve_di+Ratio_Ve_di*ids_Vge_si+Ratio*ids_Vge_si_Ve_di);
  Iii_Vge_si_Vge_si=(+Ratio_Vge_si_Vge_si*ids+Ratio_Vge_si*ids_Vge_si+Ratio_Vge_si*ids_Vge_si+Ratio*ids_Vge_si_Vge_si);
  Iii_Vge_si_Vdi_si=(+Ratio_Vge_si_Vdi_si*ids+Ratio_Vge_si*ids_Vdi_si+Ratio_Vdi_si*ids_Vge_si+Ratio*ids_Vge_si_Vdi_si);
  Iii_Vge_si_Tempt_GND=(+Ratio_Vge_si_Tempt_GND*ids+Ratio_Vge_si*ids_Tempt_GND+Ratio_Tempt_GND*ids_Vge_si+Ratio*ids_Vge_si_Tempt_GND);
#endif
Iii_Vdi_si=((Ratio_Vdi_si*ids)+(Ratio*ids_Vdi_si));
#if defined(_DERIVATE2)
  Iii_Vdi_si_Vge_di=(+Ratio_Vdi_si_Vge_di*ids+Ratio_Vdi_si*ids_Vge_di+Ratio_Vge_di*ids_Vdi_si+Ratio*ids_Vdi_si_Vge_di);
  Iii_Vdi_si_Vge_e=(+Ratio_Vdi_si_Vge_e*ids+Ratio_Vdi_si*ids_Vge_e+Ratio_Vge_e*ids_Vdi_si+Ratio*ids_Vdi_si_Vge_e);
  Iii_Vdi_si_Ve_si=(+Ratio_Vdi_si_Ve_si*ids+Ratio_Vdi_si*ids_Ve_si+Ratio_Ve_si*ids_Vdi_si+Ratio*ids_Vdi_si_Ve_si);
  Iii_Vdi_si_Ve_di=(+Ratio_Vdi_si_Ve_di*ids+Ratio_Vdi_si*ids_Ve_di+Ratio_Ve_di*ids_Vdi_si+Ratio*ids_Vdi_si_Ve_di);
  Iii_Vdi_si_Vge_si=(+Ratio_Vdi_si_Vge_si*ids+Ratio_Vdi_si*ids_Vge_si+Ratio_Vge_si*ids_Vdi_si+Ratio*ids_Vdi_si_Vge_si);
  Iii_Vdi_si_Vdi_si=(+Ratio_Vdi_si_Vdi_si*ids+Ratio_Vdi_si*ids_Vdi_si+Ratio_Vdi_si*ids_Vdi_si+Ratio*ids_Vdi_si_Vdi_si);
  Iii_Vdi_si_Tempt_GND=(+Ratio_Vdi_si_Tempt_GND*ids+Ratio_Vdi_si*ids_Tempt_GND+Ratio_Tempt_GND*ids_Vdi_si+Ratio*ids_Vdi_si_Tempt_GND);
#endif
Iii_Tempt_GND=((Ratio_Tempt_GND*ids)+(Ratio*ids_Tempt_GND));
#if defined(_DERIVATE2)
  Iii_Tempt_GND_Vge_di=(+Ratio_Tempt_GND_Vge_di*ids+Ratio_Tempt_GND*ids_Vge_di+Ratio_Vge_di*ids_Tempt_GND+Ratio*ids_Tempt_GND_Vge_di);
  Iii_Tempt_GND_Vge_e=(+Ratio_Tempt_GND_Vge_e*ids+Ratio_Tempt_GND*ids_Vge_e+Ratio_Vge_e*ids_Tempt_GND+Ratio*ids_Tempt_GND_Vge_e);
  Iii_Tempt_GND_Ve_si=(+Ratio_Tempt_GND_Ve_si*ids+Ratio_Tempt_GND*ids_Ve_si+Ratio_Ve_si*ids_Tempt_GND+Ratio*ids_Tempt_GND_Ve_si);
  Iii_Tempt_GND_Ve_di=(+Ratio_Tempt_GND_Ve_di*ids+Ratio_Tempt_GND*ids_Ve_di+Ratio_Ve_di*ids_Tempt_GND+Ratio*ids_Tempt_GND_Ve_di);
  Iii_Tempt_GND_Vge_si=(+Ratio_Tempt_GND_Vge_si*ids+Ratio_Tempt_GND*ids_Vge_si+Ratio_Vge_si*ids_Tempt_GND+Ratio*ids_Tempt_GND_Vge_si);
  Iii_Tempt_GND_Vdi_si=(+Ratio_Tempt_GND_Vdi_si*ids+Ratio_Tempt_GND*ids_Vdi_si+Ratio_Vdi_si*ids_Tempt_GND+Ratio*ids_Tempt_GND_Vdi_si);
  Iii_Tempt_GND_Tempt_GND=(+Ratio_Tempt_GND_Tempt_GND*ids+Ratio_Tempt_GND*ids_Tempt_GND+Ratio_Tempt_GND*ids_Tempt_GND+Ratio*ids_Tempt_GND_Tempt_GND);
#endif
#endif
Iii=(Ratio*ids);
EXIT_IF_ISNAN((Ratio*ids))
}
}
}
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbinv_Vge_e=0.0;
igbinv_Vdi_si=0.0;
igbinv_Tempt_GND=0.0;
igbinv_Ve_si=0.0;
igbinv_Ve_di=0.0;
igbinv_Vge_si=0.0;
igbinv_Vge_di=0.0;
igbinv_Vdi_d=0.0;
igbinv_Vsi_s=0.0;
#endif
igbinv=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbacc_Vge_e=0.0;
igbacc_Vdi_si=0.0;
igbacc_Tempt_GND=0.0;
igbacc_Ve_si=0.0;
igbacc_Ve_di=0.0;
igbacc_Vge_si=0.0;
igbacc_Vge_di=0.0;
igbacc_Vdi_d=0.0;
igbacc_Vsi_s=0.0;
#endif
igbacc=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcs_Vge_di=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_di_Vge_di=0.0;
  igcs_Vge_di_Vge_e=0.0;
  igcs_Vge_di_Vdi_si=0.0;
  igcs_Vge_di_Ve_si=0.0;
  igcs_Vge_di_Ve_di=0.0;
  igcs_Vge_di_Vge_si=0.0;
  igcs_Vge_di_Tempt_GND=0.0;
  igcs_Vge_di_Vdi_d=0.0;
  igcs_Vge_di_Vsi_s=0.0;
#endif
igcs_Vge_e=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_e_Vge_di=0.0;
  igcs_Vge_e_Vge_e=0.0;
  igcs_Vge_e_Vdi_si=0.0;
  igcs_Vge_e_Ve_si=0.0;
  igcs_Vge_e_Ve_di=0.0;
  igcs_Vge_e_Vge_si=0.0;
  igcs_Vge_e_Tempt_GND=0.0;
  igcs_Vge_e_Vdi_d=0.0;
  igcs_Vge_e_Vsi_s=0.0;
#endif
igcs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igcs_Vdi_si_Vge_di=0.0;
  igcs_Vdi_si_Vge_e=0.0;
  igcs_Vdi_si_Vdi_si=0.0;
  igcs_Vdi_si_Ve_si=0.0;
  igcs_Vdi_si_Ve_di=0.0;
  igcs_Vdi_si_Vge_si=0.0;
  igcs_Vdi_si_Tempt_GND=0.0;
  igcs_Vdi_si_Vdi_d=0.0;
  igcs_Vdi_si_Vsi_s=0.0;
#endif
igcs_Ve_si=0.0;
#if defined(_DERIVATE2)
  igcs_Ve_si_Vge_di=0.0;
  igcs_Ve_si_Vge_e=0.0;
  igcs_Ve_si_Vdi_si=0.0;
  igcs_Ve_si_Ve_si=0.0;
  igcs_Ve_si_Ve_di=0.0;
  igcs_Ve_si_Vge_si=0.0;
  igcs_Ve_si_Tempt_GND=0.0;
  igcs_Ve_si_Vdi_d=0.0;
  igcs_Ve_si_Vsi_s=0.0;
#endif
igcs_Ve_di=0.0;
#if defined(_DERIVATE2)
  igcs_Ve_di_Vge_di=0.0;
  igcs_Ve_di_Vge_e=0.0;
  igcs_Ve_di_Vdi_si=0.0;
  igcs_Ve_di_Ve_si=0.0;
  igcs_Ve_di_Ve_di=0.0;
  igcs_Ve_di_Vge_si=0.0;
  igcs_Ve_di_Tempt_GND=0.0;
  igcs_Ve_di_Vdi_d=0.0;
  igcs_Ve_di_Vsi_s=0.0;
#endif
igcs_Vge_si=0.0;
#if defined(_DERIVATE2)
  igcs_Vge_si_Vge_di=0.0;
  igcs_Vge_si_Vge_e=0.0;
  igcs_Vge_si_Vdi_si=0.0;
  igcs_Vge_si_Ve_si=0.0;
  igcs_Vge_si_Ve_di=0.0;
  igcs_Vge_si_Vge_si=0.0;
  igcs_Vge_si_Tempt_GND=0.0;
  igcs_Vge_si_Vdi_d=0.0;
  igcs_Vge_si_Vsi_s=0.0;
#endif
igcs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igcs_Tempt_GND_Vge_di=0.0;
  igcs_Tempt_GND_Vge_e=0.0;
  igcs_Tempt_GND_Vdi_si=0.0;
  igcs_Tempt_GND_Ve_si=0.0;
  igcs_Tempt_GND_Ve_di=0.0;
  igcs_Tempt_GND_Vge_si=0.0;
  igcs_Tempt_GND_Tempt_GND=0.0;
  igcs_Tempt_GND_Vdi_d=0.0;
  igcs_Tempt_GND_Vsi_s=0.0;
#endif
igcs_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igcs_Vdi_d_Vge_di=0.0;
  igcs_Vdi_d_Vge_e=0.0;
  igcs_Vdi_d_Vdi_si=0.0;
  igcs_Vdi_d_Ve_si=0.0;
  igcs_Vdi_d_Ve_di=0.0;
  igcs_Vdi_d_Vge_si=0.0;
  igcs_Vdi_d_Tempt_GND=0.0;
  igcs_Vdi_d_Vdi_d=0.0;
  igcs_Vdi_d_Vsi_s=0.0;
#endif
igcs_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igcs_Vsi_s_Vge_di=0.0;
  igcs_Vsi_s_Vge_e=0.0;
  igcs_Vsi_s_Vdi_si=0.0;
  igcs_Vsi_s_Ve_si=0.0;
  igcs_Vsi_s_Ve_di=0.0;
  igcs_Vsi_s_Vge_si=0.0;
  igcs_Vsi_s_Tempt_GND=0.0;
  igcs_Vsi_s_Vdi_d=0.0;
  igcs_Vsi_s_Vsi_s=0.0;
#endif
#endif
igcs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcd_Vge_di=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_di_Vge_di=0.0;
  igcd_Vge_di_Vge_e=0.0;
  igcd_Vge_di_Vdi_si=0.0;
  igcd_Vge_di_Ve_si=0.0;
  igcd_Vge_di_Ve_di=0.0;
  igcd_Vge_di_Vge_si=0.0;
  igcd_Vge_di_Tempt_GND=0.0;
  igcd_Vge_di_Vdi_d=0.0;
  igcd_Vge_di_Vsi_s=0.0;
#endif
igcd_Vge_e=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_e_Vge_di=0.0;
  igcd_Vge_e_Vge_e=0.0;
  igcd_Vge_e_Vdi_si=0.0;
  igcd_Vge_e_Ve_si=0.0;
  igcd_Vge_e_Ve_di=0.0;
  igcd_Vge_e_Vge_si=0.0;
  igcd_Vge_e_Tempt_GND=0.0;
  igcd_Vge_e_Vdi_d=0.0;
  igcd_Vge_e_Vsi_s=0.0;
#endif
igcd_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igcd_Vdi_si_Vge_di=0.0;
  igcd_Vdi_si_Vge_e=0.0;
  igcd_Vdi_si_Vdi_si=0.0;
  igcd_Vdi_si_Ve_si=0.0;
  igcd_Vdi_si_Ve_di=0.0;
  igcd_Vdi_si_Vge_si=0.0;
  igcd_Vdi_si_Tempt_GND=0.0;
  igcd_Vdi_si_Vdi_d=0.0;
  igcd_Vdi_si_Vsi_s=0.0;
#endif
igcd_Ve_si=0.0;
#if defined(_DERIVATE2)
  igcd_Ve_si_Vge_di=0.0;
  igcd_Ve_si_Vge_e=0.0;
  igcd_Ve_si_Vdi_si=0.0;
  igcd_Ve_si_Ve_si=0.0;
  igcd_Ve_si_Ve_di=0.0;
  igcd_Ve_si_Vge_si=0.0;
  igcd_Ve_si_Tempt_GND=0.0;
  igcd_Ve_si_Vdi_d=0.0;
  igcd_Ve_si_Vsi_s=0.0;
#endif
igcd_Ve_di=0.0;
#if defined(_DERIVATE2)
  igcd_Ve_di_Vge_di=0.0;
  igcd_Ve_di_Vge_e=0.0;
  igcd_Ve_di_Vdi_si=0.0;
  igcd_Ve_di_Ve_si=0.0;
  igcd_Ve_di_Ve_di=0.0;
  igcd_Ve_di_Vge_si=0.0;
  igcd_Ve_di_Tempt_GND=0.0;
  igcd_Ve_di_Vdi_d=0.0;
  igcd_Ve_di_Vsi_s=0.0;
#endif
igcd_Vge_si=0.0;
#if defined(_DERIVATE2)
  igcd_Vge_si_Vge_di=0.0;
  igcd_Vge_si_Vge_e=0.0;
  igcd_Vge_si_Vdi_si=0.0;
  igcd_Vge_si_Ve_si=0.0;
  igcd_Vge_si_Ve_di=0.0;
  igcd_Vge_si_Vge_si=0.0;
  igcd_Vge_si_Tempt_GND=0.0;
  igcd_Vge_si_Vdi_d=0.0;
  igcd_Vge_si_Vsi_s=0.0;
#endif
igcd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igcd_Tempt_GND_Vge_di=0.0;
  igcd_Tempt_GND_Vge_e=0.0;
  igcd_Tempt_GND_Vdi_si=0.0;
  igcd_Tempt_GND_Ve_si=0.0;
  igcd_Tempt_GND_Ve_di=0.0;
  igcd_Tempt_GND_Vge_si=0.0;
  igcd_Tempt_GND_Tempt_GND=0.0;
  igcd_Tempt_GND_Vdi_d=0.0;
  igcd_Tempt_GND_Vsi_s=0.0;
#endif
igcd_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igcd_Vdi_d_Vge_di=0.0;
  igcd_Vdi_d_Vge_e=0.0;
  igcd_Vdi_d_Vdi_si=0.0;
  igcd_Vdi_d_Ve_si=0.0;
  igcd_Vdi_d_Ve_di=0.0;
  igcd_Vdi_d_Vge_si=0.0;
  igcd_Vdi_d_Tempt_GND=0.0;
  igcd_Vdi_d_Vdi_d=0.0;
  igcd_Vdi_d_Vsi_s=0.0;
#endif
igcd_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igcd_Vsi_s_Vge_di=0.0;
  igcd_Vsi_s_Vge_e=0.0;
  igcd_Vsi_s_Vdi_si=0.0;
  igcd_Vsi_s_Ve_si=0.0;
  igcd_Vsi_s_Ve_di=0.0;
  igcd_Vsi_s_Vge_si=0.0;
  igcd_Vsi_s_Tempt_GND=0.0;
  igcd_Vsi_s_Vdi_d=0.0;
  igcd_Vsi_s_Vsi_s=0.0;
#endif
#endif
igcd=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igs_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igs_Tempt_GND_Tempt_GND=0.0;
  igs_Tempt_GND_Vge_si=0.0;
  igs_Tempt_GND_Vge_di=0.0;
  igs_Tempt_GND_Vge_e=0.0;
  igs_Tempt_GND_Ve_si=0.0;
  igs_Tempt_GND_Ve_di=0.0;
  igs_Tempt_GND_Vdi_si=0.0;
#endif
igs_Vge_si=0.0;
#if defined(_DERIVATE2)
  igs_Vge_si_Tempt_GND=0.0;
  igs_Vge_si_Vge_si=0.0;
  igs_Vge_si_Vge_di=0.0;
  igs_Vge_si_Vge_e=0.0;
  igs_Vge_si_Ve_si=0.0;
  igs_Vge_si_Ve_di=0.0;
  igs_Vge_si_Vdi_si=0.0;
#endif
igs_Vge_di=0.0;
#if defined(_DERIVATE2)
  igs_Vge_di_Tempt_GND=0.0;
  igs_Vge_di_Vge_si=0.0;
  igs_Vge_di_Vge_di=0.0;
  igs_Vge_di_Vge_e=0.0;
  igs_Vge_di_Ve_si=0.0;
  igs_Vge_di_Ve_di=0.0;
  igs_Vge_di_Vdi_si=0.0;
#endif
igs_Vge_e=0.0;
#if defined(_DERIVATE2)
  igs_Vge_e_Tempt_GND=0.0;
  igs_Vge_e_Vge_si=0.0;
  igs_Vge_e_Vge_di=0.0;
  igs_Vge_e_Vge_e=0.0;
  igs_Vge_e_Ve_si=0.0;
  igs_Vge_e_Ve_di=0.0;
  igs_Vge_e_Vdi_si=0.0;
#endif
igs_Ve_si=0.0;
#if defined(_DERIVATE2)
  igs_Ve_si_Tempt_GND=0.0;
  igs_Ve_si_Vge_si=0.0;
  igs_Ve_si_Vge_di=0.0;
  igs_Ve_si_Vge_e=0.0;
  igs_Ve_si_Ve_si=0.0;
  igs_Ve_si_Ve_di=0.0;
  igs_Ve_si_Vdi_si=0.0;
#endif
igs_Ve_di=0.0;
#if defined(_DERIVATE2)
  igs_Ve_di_Tempt_GND=0.0;
  igs_Ve_di_Vge_si=0.0;
  igs_Ve_di_Vge_di=0.0;
  igs_Ve_di_Vge_e=0.0;
  igs_Ve_di_Ve_si=0.0;
  igs_Ve_di_Ve_di=0.0;
  igs_Ve_di_Vdi_si=0.0;
#endif
igs_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igs_Vdi_si_Tempt_GND=0.0;
  igs_Vdi_si_Vge_si=0.0;
  igs_Vdi_si_Vge_di=0.0;
  igs_Vdi_si_Vge_e=0.0;
  igs_Vdi_si_Ve_si=0.0;
  igs_Vdi_si_Ve_di=0.0;
  igs_Vdi_si_Vdi_si=0.0;
#endif
#endif
igs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igd_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igd_Tempt_GND_Tempt_GND=0.0;
  igd_Tempt_GND_Vge_si=0.0;
  igd_Tempt_GND_Vge_di=0.0;
  igd_Tempt_GND_Vge_e=0.0;
  igd_Tempt_GND_Ve_si=0.0;
  igd_Tempt_GND_Ve_di=0.0;
  igd_Tempt_GND_Vdi_si=0.0;
#endif
igd_Vge_si=0.0;
#if defined(_DERIVATE2)
  igd_Vge_si_Tempt_GND=0.0;
  igd_Vge_si_Vge_si=0.0;
  igd_Vge_si_Vge_di=0.0;
  igd_Vge_si_Vge_e=0.0;
  igd_Vge_si_Ve_si=0.0;
  igd_Vge_si_Ve_di=0.0;
  igd_Vge_si_Vdi_si=0.0;
#endif
igd_Vge_di=0.0;
#if defined(_DERIVATE2)
  igd_Vge_di_Tempt_GND=0.0;
  igd_Vge_di_Vge_si=0.0;
  igd_Vge_di_Vge_di=0.0;
  igd_Vge_di_Vge_e=0.0;
  igd_Vge_di_Ve_si=0.0;
  igd_Vge_di_Ve_di=0.0;
  igd_Vge_di_Vdi_si=0.0;
#endif
igd_Vge_e=0.0;
#if defined(_DERIVATE2)
  igd_Vge_e_Tempt_GND=0.0;
  igd_Vge_e_Vge_si=0.0;
  igd_Vge_e_Vge_di=0.0;
  igd_Vge_e_Vge_e=0.0;
  igd_Vge_e_Ve_si=0.0;
  igd_Vge_e_Ve_di=0.0;
  igd_Vge_e_Vdi_si=0.0;
#endif
igd_Ve_si=0.0;
#if defined(_DERIVATE2)
  igd_Ve_si_Tempt_GND=0.0;
  igd_Ve_si_Vge_si=0.0;
  igd_Ve_si_Vge_di=0.0;
  igd_Ve_si_Vge_e=0.0;
  igd_Ve_si_Ve_si=0.0;
  igd_Ve_si_Ve_di=0.0;
  igd_Ve_si_Vdi_si=0.0;
#endif
igd_Ve_di=0.0;
#if defined(_DERIVATE2)
  igd_Ve_di_Tempt_GND=0.0;
  igd_Ve_di_Vge_si=0.0;
  igd_Ve_di_Vge_di=0.0;
  igd_Ve_di_Vge_e=0.0;
  igd_Ve_di_Ve_si=0.0;
  igd_Ve_di_Ve_di=0.0;
  igd_Ve_di_Vdi_si=0.0;
#endif
igd_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igd_Vdi_si_Tempt_GND=0.0;
  igd_Vdi_si_Vge_si=0.0;
  igd_Vdi_si_Vge_di=0.0;
  igd_Vdi_si_Vge_e=0.0;
  igd_Vdi_si_Ve_si=0.0;
  igd_Vdi_si_Ve_di=0.0;
  igd_Vdi_si_Vdi_si=0.0;
#endif
#endif
igd=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->IGBMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=((qia_Ve_si/NIGBINV_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vsi_s=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_di=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_e=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Ve_si=(((+qia_Ve_si_Ve_si-0.0)/NIGBINV_i-(qia_Ve_si*0.0+qia_Ve_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+(qia_Ve_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Ve_di=(((+qia_Ve_si_Ve_di-0.0)/NIGBINV_i-(qia_Ve_si*0.0+qia_Ve_di*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+(qia_Ve_di/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_si=(((+qia_Ve_si_Vge_si-0.0)/NIGBINV_i-(qia_Ve_si*0.0+qia_Vge_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+(qia_Vge_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vdi_si=(((+qia_Ve_si_Vdi_si-0.0)/NIGBINV_i-(qia_Ve_si*0.0+qia_Vdi_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*0.0+(qia_Vdi_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Tempt_GND=(((+qia_Ve_si_Tempt_GND-0.0)/NIGBINV_i-(qia_Ve_si*0.0+qia_Tempt_GND*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_si/NIGBINV_i)*Vtm_Tempt_GND+(qia_Tempt_GND/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Ve_di=((qia_Ve_di/NIGBINV_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_di*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vsi_s=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_di*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_di=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_di*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_e=(((+0.0-0.0)/NIGBINV_i-(qia_Ve_di*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Ve_si=(((+qia_Ve_di_Ve_si-0.0)/NIGBINV_i-(qia_Ve_di*0.0+qia_Ve_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+(qia_Ve_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Ve_di=(((+qia_Ve_di_Ve_di-0.0)/NIGBINV_i-(qia_Ve_di*0.0+qia_Ve_di*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+(qia_Ve_di/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_si=(((+qia_Ve_di_Vge_si-0.0)/NIGBINV_i-(qia_Ve_di*0.0+qia_Vge_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+(qia_Vge_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vdi_si=(((+qia_Ve_di_Vdi_si-0.0)/NIGBINV_i-(qia_Ve_di*0.0+qia_Vdi_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*0.0+(qia_Vdi_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Tempt_GND=(((+qia_Ve_di_Tempt_GND-0.0)/NIGBINV_i-(qia_Ve_di*0.0+qia_Tempt_GND*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Ve_di/NIGBINV_i)*Vtm_Tempt_GND+(qia_Tempt_GND/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Vge_si=((qia_Vge_si/NIGBINV_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(((+0.0-0.0)/NIGBINV_i-(qia_Vge_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vsi_s=(((+0.0-0.0)/NIGBINV_i-(qia_Vge_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_di=(((+0.0-0.0)/NIGBINV_i-(qia_Vge_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_e=(((+0.0-0.0)/NIGBINV_i-(qia_Vge_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Ve_si=(((+qia_Vge_si_Ve_si-0.0)/NIGBINV_i-(qia_Vge_si*0.0+qia_Ve_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+(qia_Ve_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Ve_di=(((+qia_Vge_si_Ve_di-0.0)/NIGBINV_i-(qia_Vge_si*0.0+qia_Ve_di*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+(qia_Ve_di/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_si=(((+qia_Vge_si_Vge_si-0.0)/NIGBINV_i-(qia_Vge_si*0.0+qia_Vge_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+(qia_Vge_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vdi_si=(((+qia_Vge_si_Vdi_si-0.0)/NIGBINV_i-(qia_Vge_si*0.0+qia_Vdi_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*0.0+(qia_Vdi_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Tempt_GND=(((+qia_Vge_si_Tempt_GND-0.0)/NIGBINV_i-(qia_Vge_si*0.0+qia_Tempt_GND*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vge_si/NIGBINV_i)*Vtm_Tempt_GND+(qia_Tempt_GND/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Vdi_si=((qia_Vdi_si/NIGBINV_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(((+0.0-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vsi_s=(((+0.0-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_di=(((+0.0-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_e=(((+0.0-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+0.0*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Ve_si=(((+qia_Vdi_si_Ve_si-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+qia_Ve_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+(qia_Ve_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Ve_di=(((+qia_Vdi_si_Ve_di-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+qia_Ve_di*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+(qia_Ve_di/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_si=(((+qia_Vdi_si_Vge_si-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+qia_Vge_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+(qia_Vge_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vdi_si=(((+qia_Vdi_si_Vdi_si-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+qia_Vdi_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*0.0+(qia_Vdi_si/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Tempt_GND=(((+qia_Vdi_si_Tempt_GND-0.0)/NIGBINV_i-(qia_Vdi_si*0.0+qia_Tempt_GND*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Vdi_si/NIGBINV_i)*Vtm_Tempt_GND+(qia_Tempt_GND/NIGBINV_i)*0.0+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Tempt_GND=(((qia_Tempt_GND/NIGBINV_i)*Vtm-((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND)/Vtm/Vtm);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(((+0.0-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+0.0*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vsi_s=(((+0.0-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+0.0*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_di=(((+0.0-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+0.0*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_e=(((+0.0-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+0.0*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+0.0*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Ve_si=(((+qia_Tempt_GND_Ve_si-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+qia_Ve_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+(qia_Ve_si/NIGBINV_i)*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Ve_di=(((+qia_Tempt_GND_Ve_di-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+qia_Ve_di*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+(qia_Ve_di/NIGBINV_i)*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_si=(((+qia_Tempt_GND_Vge_si-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+qia_Vge_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+(qia_Vge_si/NIGBINV_i)*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vdi_si=(((+qia_Tempt_GND_Vdi_si-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+qia_Vdi_si*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*0.0+(qia_Vdi_si/NIGBINV_i)*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*0.0)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Tempt_GND=(((+qia_Tempt_GND_Tempt_GND-0.0)/NIGBINV_i-(qia_Tempt_GND*0.0+qia_Tempt_GND*0.0+(qia-EIGBINV_i)*0.0)/NIGBINV_i/NIGBINV_i+2*(qia-EIGBINV_i)*0.0*0.0/NIGBINV_i/NIGBINV_i/NIGBINV_i)/Vtm-((qia_Tempt_GND/NIGBINV_i)*Vtm_Tempt_GND+(qia_Tempt_GND/NIGBINV_i)*Vtm_Tempt_GND+((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*((qia-EIGBINV_i)/NIGBINV_i)*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
#endif
T1=(((qia-EIGBINV_i)/NIGBINV_i)/Vtm);
EXIT_IF_ISNAN((((qia-EIGBINV_i)/NIGBINV_i)/Vtm))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe= */
Vaux_Igbinv_Tempt_GND=(((NIGBINV_i*Vtm_Tempt_GND)*bsimcmg_lln((1.0+bsimcmg_lexp(T1))))+((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Tempt_GND))));
Vaux_Igbinv_Vge_di=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_di)));
Vaux_Igbinv_Vge_e=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_e)));
Vaux_Igbinv_Ve_si=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Ve_si)));
Vaux_Igbinv_Ve_di=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Ve_di)));
Vaux_Igbinv_Vge_si=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_si)));
Vaux_Igbinv_Vdi_si=((NIGBINV_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vdi_si)));
#endif
Vaux_Igbinv=((NIGBINV_i*Vtm)*bsimcmg_lln((1.0+bsimcmg_lexp(T1))));
EXIT_IF_ISNAN(((NIGBINV_i*Vtm)*bsimcmg_lln((1.0+bsimcmg_lexp(T1)))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(-(BIGBINV_i*qia_Vge_si));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGBINV_i*0.0));
  T2_Vge_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGBINV_i*0.0));
  T2_Vge_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGBINV_i*0.0));
  T2_Vge_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGBINV_i*0.0));
  T2_Vge_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+BIGBINV_i*qia_Vge_si_Vge_si));
  T2_Vge_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+BIGBINV_i*qia_Vge_si_Ve_si));
  T2_Vge_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+BIGBINV_i*qia_Vge_si_Ve_di));
  T2_Vge_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+BIGBINV_i*qia_Vge_si_Vdi_si));
  T2_Vge_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+BIGBINV_i*qia_Vge_si_Tempt_GND));
#endif
T2_Ve_si=(-(BIGBINV_i*qia_Ve_si));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGBINV_i*0.0));
  T2_Ve_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGBINV_i*0.0));
  T2_Ve_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGBINV_i*0.0));
  T2_Ve_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGBINV_i*0.0));
  T2_Ve_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+BIGBINV_i*qia_Ve_si_Vge_si));
  T2_Ve_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+BIGBINV_i*qia_Ve_si_Ve_si));
  T2_Ve_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+BIGBINV_i*qia_Ve_si_Ve_di));
  T2_Ve_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+BIGBINV_i*qia_Ve_si_Vdi_si));
  T2_Ve_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+BIGBINV_i*qia_Ve_si_Tempt_GND));
#endif
T2_Ve_di=(-(BIGBINV_i*qia_Ve_di));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGBINV_i*0.0));
  T2_Ve_di_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGBINV_i*0.0));
  T2_Ve_di_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGBINV_i*0.0));
  T2_Ve_di_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGBINV_i*0.0));
  T2_Ve_di_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+BIGBINV_i*qia_Ve_di_Vge_si));
  T2_Ve_di_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+BIGBINV_i*qia_Ve_di_Ve_si));
  T2_Ve_di_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+BIGBINV_i*qia_Ve_di_Ve_di));
  T2_Ve_di_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+BIGBINV_i*qia_Ve_di_Vdi_si));
  T2_Ve_di_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+BIGBINV_i*qia_Ve_di_Tempt_GND));
#endif
T2_Vdi_si=(-(BIGBINV_i*qia_Vdi_si));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGBINV_i*0.0));
  T2_Vdi_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGBINV_i*0.0));
  T2_Vdi_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGBINV_i*0.0));
  T2_Vdi_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGBINV_i*0.0));
  T2_Vdi_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+BIGBINV_i*qia_Vdi_si_Vge_si));
  T2_Vdi_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+BIGBINV_i*qia_Vdi_si_Ve_si));
  T2_Vdi_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+BIGBINV_i*qia_Vdi_si_Ve_di));
  T2_Vdi_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+BIGBINV_i*qia_Vdi_si_Vdi_si));
  T2_Vdi_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+BIGBINV_i*qia_Vdi_si_Tempt_GND));
#endif
T2_Tempt_GND=(AIGBINV_t_Tempt_GND-(BIGBINV_i*qia_Tempt_GND));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGBINV_i*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGBINV_i*0.0));
  T2_Tempt_GND_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGBINV_i*0.0));
  T2_Tempt_GND_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGBINV_i*0.0));
  T2_Tempt_GND_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+BIGBINV_i*qia_Tempt_GND_Vge_si));
  T2_Tempt_GND_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+BIGBINV_i*qia_Tempt_GND_Ve_si));
  T2_Tempt_GND_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+BIGBINV_i*qia_Tempt_GND_Ve_di));
  T2_Tempt_GND_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+BIGBINV_i*qia_Tempt_GND_Vdi_si));
  T2_Tempt_GND_Tempt_GND=(+AIGBINV_t_Tempt_GND_Tempt_GND-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+BIGBINV_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T2=(AIGBINV_t-(BIGBINV_i*qia));
EXIT_IF_ISNAN((AIGBINV_t-(BIGBINV_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=(CIGBINV_i*qia_Vdi_si);
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGBINV_i*0.0));
  T3_Vdi_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGBINV_i*0.0));
  T3_Vdi_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGBINV_i*0.0));
  T3_Vdi_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGBINV_i*0.0));
  T3_Vdi_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+CIGBINV_i*qia_Vdi_si_Vdi_si));
  T3_Vdi_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+CIGBINV_i*qia_Vdi_si_Ve_si));
  T3_Vdi_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+CIGBINV_i*qia_Vdi_si_Ve_di));
  T3_Vdi_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+CIGBINV_i*qia_Vdi_si_Vge_si));
  T3_Vdi_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+CIGBINV_i*qia_Vdi_si_Tempt_GND));
#endif
T3_Ve_si=(CIGBINV_i*qia_Ve_si);
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGBINV_i*0.0));
  T3_Ve_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGBINV_i*0.0));
  T3_Ve_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGBINV_i*0.0));
  T3_Ve_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGBINV_i*0.0));
  T3_Ve_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+CIGBINV_i*qia_Ve_si_Vdi_si));
  T3_Ve_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+CIGBINV_i*qia_Ve_si_Ve_si));
  T3_Ve_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+CIGBINV_i*qia_Ve_si_Ve_di));
  T3_Ve_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+CIGBINV_i*qia_Ve_si_Vge_si));
  T3_Ve_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+CIGBINV_i*qia_Ve_si_Tempt_GND));
#endif
T3_Ve_di=(CIGBINV_i*qia_Ve_di);
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGBINV_i*0.0));
  T3_Ve_di_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGBINV_i*0.0));
  T3_Ve_di_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGBINV_i*0.0));
  T3_Ve_di_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGBINV_i*0.0));
  T3_Ve_di_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+CIGBINV_i*qia_Ve_di_Vdi_si));
  T3_Ve_di_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+CIGBINV_i*qia_Ve_di_Ve_si));
  T3_Ve_di_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+CIGBINV_i*qia_Ve_di_Ve_di));
  T3_Ve_di_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+CIGBINV_i*qia_Ve_di_Vge_si));
  T3_Ve_di_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+CIGBINV_i*qia_Ve_di_Tempt_GND));
#endif
T3_Vge_si=(CIGBINV_i*qia_Vge_si);
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGBINV_i*0.0));
  T3_Vge_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGBINV_i*0.0));
  T3_Vge_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGBINV_i*0.0));
  T3_Vge_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGBINV_i*0.0));
  T3_Vge_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+CIGBINV_i*qia_Vge_si_Vdi_si));
  T3_Vge_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+CIGBINV_i*qia_Vge_si_Ve_si));
  T3_Vge_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+CIGBINV_i*qia_Vge_si_Ve_di));
  T3_Vge_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+CIGBINV_i*qia_Vge_si_Vge_si));
  T3_Vge_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+CIGBINV_i*qia_Vge_si_Tempt_GND));
#endif
T3_Tempt_GND=(CIGBINV_i*qia_Tempt_GND);
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGBINV_i*0.0));
  T3_Tempt_GND_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGBINV_i*0.0));
  T3_Tempt_GND_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGBINV_i*0.0));
  T3_Tempt_GND_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGBINV_i*0.0));
  T3_Tempt_GND_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+CIGBINV_i*qia_Tempt_GND_Vdi_si));
  T3_Tempt_GND_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+CIGBINV_i*qia_Tempt_GND_Ve_si));
  T3_Tempt_GND_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+CIGBINV_i*qia_Tempt_GND_Ve_di));
  T3_Tempt_GND_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+CIGBINV_i*qia_Tempt_GND_Vge_si));
  T3_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+CIGBINV_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T3=(1.0+(CIGBINV_i*qia));
EXIT_IF_ISNAN((1.0+(CIGBINV_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=(((((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_di);
  T4_Vge_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_e);
  T4_Vge_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Vdi_si);
  T4_Vge_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Ve_si);
  T4_Vge_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Ve_di);
  T4_Vge_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_si);
  T4_Vge_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_di+((-9.82222e11)*pModel->TOXG)*T2_Vge_di_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_di_Tempt_GND);
#endif
T4_Vge_e=(((((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_di);
  T4_Vge_e_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_e);
  T4_Vge_e_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Vdi_si);
  T4_Vge_e_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Ve_si);
  T4_Vge_e_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Ve_di);
  T4_Vge_e_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_si);
  T4_Vge_e_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_e+((-9.82222e11)*pModel->TOXG)*T2_Vge_e_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_e+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_e_Tempt_GND);
#endif
T4_Vdi_si=(((((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_di);
  T4_Vdi_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_e);
  T4_Vdi_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vdi_si);
  T4_Vdi_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Ve_si);
  T4_Vdi_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Ve_di);
  T4_Vdi_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_si);
  T4_Vdi_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vdi_si+((-9.82222e11)*pModel->TOXG)*T2_Vdi_si_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vdi_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vdi_si_Tempt_GND);
#endif
T4_Ve_si=(((((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_di);
  T4_Ve_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_e);
  T4_Ve_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Vdi_si);
  T4_Ve_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Ve_di);
  T4_Ve_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_si);
  T4_Ve_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Ve_si+((-9.82222e11)*pModel->TOXG)*T2_Ve_si_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Ve_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_si_Tempt_GND);
#endif
T4_Ve_di=(((((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_di);
  T4_Ve_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_e);
  T4_Ve_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Vdi_si);
  T4_Ve_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Ve_si);
  T4_Ve_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_si);
  T4_Ve_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Ve_di+((-9.82222e11)*pModel->TOXG)*T2_Ve_di_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Ve_di+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Ve_di_Tempt_GND);
#endif
T4_Vge_si=(((((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_di);
  T4_Vge_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_e);
  T4_Vge_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Vdi_si);
  T4_Vge_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Ve_si);
  T4_Vge_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Ve_di);
  T4_Vge_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_si);
  T4_Vge_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_si+((-9.82222e11)*pModel->TOXG)*T2_Vge_si_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_si+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Vge_si_Tempt_GND);
#endif
T4_Tempt_GND=(((((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3)+((((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Vge_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_di)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_di);
  T4_Tempt_GND_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Vge_e)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_e+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_e)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_e);
  T4_Tempt_GND_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Vdi_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vdi_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vdi_si);
  T4_Tempt_GND_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Ve_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Ve_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_si)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Ve_si);
  T4_Tempt_GND_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Ve_di)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Ve_di+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Ve_di)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Ve_di);
  T4_Tempt_GND_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Vge_si)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_si+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Vge_si)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_si);
  T4_Tempt_GND_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-9.82222e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Tempt_GND+((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND_Tempt_GND)*T3+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Tempt_GND+((((0.0)*T2)+(((-9.82222e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Tempt_GND+(((-9.82222e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Tempt_GND);
#endif
#endif
T4=((((-9.82222e11)*pModel->TOXG)*T2)*T3);
EXIT_IF_ISNAN(((((-9.82222e11)*pModel->TOXG)*T2)*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=bsimcmg_d_lexp(T4,T4_Vge_di);
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=T4_Vge_di_Vge_di;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=T4_Vge_di_Vge_e;
  T5_Vge_di_Vdi_si=T4_Vge_di_Vdi_si;
  T5_Vge_di_Ve_si=T4_Vge_di_Ve_si;
  T5_Vge_di_Ve_di=T4_Vge_di_Ve_di;
  T5_Vge_di_Vge_si=T4_Vge_di_Vge_si;
  T5_Vge_di_Tempt_GND=T4_Vge_di_Tempt_GND;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=bsimcmg_d_lexp(T4,T4_Vge_e);
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=T4_Vge_e_Vge_di;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=T4_Vge_e_Vge_e;
  T5_Vge_e_Vdi_si=T4_Vge_e_Vdi_si;
  T5_Vge_e_Ve_si=T4_Vge_e_Ve_si;
  T5_Vge_e_Ve_di=T4_Vge_e_Ve_di;
  T5_Vge_e_Vge_si=T4_Vge_e_Vge_si;
  T5_Vge_e_Tempt_GND=T4_Vge_e_Tempt_GND;
#endif
T5_Vdi_si=bsimcmg_d_lexp(T4,T4_Vdi_si);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=T4_Vdi_si_Vge_di;
  T5_Vdi_si_Vdi_d=0.0;
  T5_Vdi_si_Vsi_s=0.0;
  T5_Vdi_si_Vge_e=T4_Vdi_si_Vge_e;
  T5_Vdi_si_Vdi_si=T4_Vdi_si_Vdi_si;
  T5_Vdi_si_Ve_si=T4_Vdi_si_Ve_si;
  T5_Vdi_si_Ve_di=T4_Vdi_si_Ve_di;
  T5_Vdi_si_Vge_si=T4_Vdi_si_Vge_si;
  T5_Vdi_si_Tempt_GND=T4_Vdi_si_Tempt_GND;
#endif
T5_Ve_si=bsimcmg_d_lexp(T4,T4_Ve_si);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=T4_Ve_si_Vge_di;
  T5_Ve_si_Vdi_d=0.0;
  T5_Ve_si_Vsi_s=0.0;
  T5_Ve_si_Vge_e=T4_Ve_si_Vge_e;
  T5_Ve_si_Vdi_si=T4_Ve_si_Vdi_si;
  T5_Ve_si_Ve_si=T4_Ve_si_Ve_si;
  T5_Ve_si_Ve_di=T4_Ve_si_Ve_di;
  T5_Ve_si_Vge_si=T4_Ve_si_Vge_si;
  T5_Ve_si_Tempt_GND=T4_Ve_si_Tempt_GND;
#endif
T5_Ve_di=bsimcmg_d_lexp(T4,T4_Ve_di);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=T4_Ve_di_Vge_di;
  T5_Ve_di_Vdi_d=0.0;
  T5_Ve_di_Vsi_s=0.0;
  T5_Ve_di_Vge_e=T4_Ve_di_Vge_e;
  T5_Ve_di_Vdi_si=T4_Ve_di_Vdi_si;
  T5_Ve_di_Ve_si=T4_Ve_di_Ve_si;
  T5_Ve_di_Ve_di=T4_Ve_di_Ve_di;
  T5_Ve_di_Vge_si=T4_Ve_di_Vge_si;
  T5_Ve_di_Tempt_GND=T4_Ve_di_Tempt_GND;
#endif
T5_Vge_si=bsimcmg_d_lexp(T4,T4_Vge_si);
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=T4_Vge_si_Vge_di;
  T5_Vge_si_Vdi_d=0.0;
  T5_Vge_si_Vsi_s=0.0;
  T5_Vge_si_Vge_e=T4_Vge_si_Vge_e;
  T5_Vge_si_Vdi_si=T4_Vge_si_Vdi_si;
  T5_Vge_si_Ve_si=T4_Vge_si_Ve_si;
  T5_Vge_si_Ve_di=T4_Vge_si_Ve_di;
  T5_Vge_si_Vge_si=T4_Vge_si_Vge_si;
  T5_Vge_si_Tempt_GND=T4_Vge_si_Tempt_GND;
#endif
T5_Tempt_GND=bsimcmg_d_lexp(T4,T4_Tempt_GND);
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=T4_Tempt_GND_Vge_di;
  T5_Tempt_GND_Vdi_d=0.0;
  T5_Tempt_GND_Vsi_s=0.0;
  T5_Tempt_GND_Vge_e=T4_Tempt_GND_Vge_e;
  T5_Tempt_GND_Vdi_si=T4_Tempt_GND_Vdi_si;
  T5_Tempt_GND_Ve_si=T4_Tempt_GND_Ve_si;
  T5_Tempt_GND_Ve_di=T4_Tempt_GND_Ve_di;
  T5_Tempt_GND_Vge_si=T4_Tempt_GND_Vge_si;
  T5_Tempt_GND_Tempt_GND=T4_Tempt_GND_Tempt_GND;
#endif
#endif
T5=bsimcmg_lexp(T4);
EXIT_IF_ISNAN(bsimcmg_lexp(T4))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=0.0;
  T6_Vdi_si_Vdi_d=0.0;
  T6_Vdi_si_Vsi_s=0.0;
  T6_Vdi_si_Vge_e=0.0;
  T6_Vdi_si_Vdi_si=0.0;
  T6_Vdi_si_Tempt_GND=0.0;
  T6_Vdi_si_Ve_si=0.0;
  T6_Vdi_si_Ve_di=0.0;
  T6_Vdi_si_Vge_si=0.0;
#endif
T6_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=0.0;
  T6_Tempt_GND_Vdi_d=0.0;
  T6_Tempt_GND_Vsi_s=0.0;
  T6_Tempt_GND_Vge_e=0.0;
  T6_Tempt_GND_Vdi_si=0.0;
  T6_Tempt_GND_Tempt_GND=0.0;
  T6_Tempt_GND_Ve_si=0.0;
  T6_Tempt_GND_Ve_di=0.0;
  T6_Tempt_GND_Vge_si=0.0;
#endif
T6_Ve_si=0.0;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=0.0;
  T6_Ve_si_Vdi_d=0.0;
  T6_Ve_si_Vsi_s=0.0;
  T6_Ve_si_Vge_e=0.0;
  T6_Ve_si_Vdi_si=0.0;
  T6_Ve_si_Tempt_GND=0.0;
  T6_Ve_si_Ve_si=0.0;
  T6_Ve_si_Ve_di=0.0;
  T6_Ve_si_Vge_si=0.0;
#endif
T6_Ve_di=0.0;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=0.0;
  T6_Ve_di_Vdi_d=0.0;
  T6_Ve_di_Vsi_s=0.0;
  T6_Ve_di_Vge_e=0.0;
  T6_Ve_di_Vdi_si=0.0;
  T6_Ve_di_Tempt_GND=0.0;
  T6_Ve_di_Ve_si=0.0;
  T6_Ve_di_Ve_di=0.0;
  T6_Ve_di_Vge_si=0.0;
#endif
T6_Vge_si=0.0;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=0.0;
  T6_Vge_si_Vdi_d=0.0;
  T6_Vge_si_Vsi_s=0.0;
  T6_Vge_si_Vge_e=0.0;
  T6_Vge_si_Vdi_si=0.0;
  T6_Vge_si_Tempt_GND=0.0;
  T6_Vge_si_Ve_si=0.0;
  T6_Vge_si_Ve_di=0.0;
  T6_Vge_si_Vge_si=0.0;
#endif
#endif
T6=3.75956e-7;
EXIT_IF_ISNAN(3.75956e-7)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbinv_Vge_e=((((((((Weff0*Leff)*T6_Vge_e)*Toxratio*vge)+((((Weff0*Leff)*T6)*Toxratio)*vge_Vge_e))*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Vge_e))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vge_e));
igbinv_Vdi_si=((((((Weff0*Leff)*T6_Vdi_si)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Vdi_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vdi_si));
igbinv_Tempt_GND=((((((Weff0*Leff)*T6_Tempt_GND)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Tempt_GND))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Tempt_GND));
igbinv_Ve_si=((((((Weff0*Leff)*T6_Ve_si)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Ve_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Ve_si));
igbinv_Ve_di=((((((Weff0*Leff)*T6_Ve_di)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Ve_di))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Ve_di));
igbinv_Vge_si=((((((Weff0*Leff)*T6_Vge_si)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Vge_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vge_si));
igbinv_Vge_di=((((((Weff0*Leff)*T6_Vge_di)*Toxratio*vge*Vaux_Igbinv)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv_Vge_di))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vge_di));
igbinv_Vdi_d=((((Weff0*Leff)*T6_Vdi_d)*Toxratio*vge*Vaux_Igbinv*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vdi_d));
igbinv_Vsi_s=((((Weff0*Leff)*T6_Vsi_s)*Toxratio*vge*Vaux_Igbinv*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5_Vsi_s));
#endif
igbinv=((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5);
EXIT_IF_ISNAN(((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbinv)*T5))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbinv_Vge_e=igbinv_Vge_e*igtemp;
igbinv_Vdi_si=igbinv_Vdi_si*igtemp;
igbinv_Tempt_GND=((igbinv_Tempt_GND*igtemp)+(igbinv*igtemp_Tempt_GND));
igbinv_Ve_si=igbinv_Ve_si*igtemp;
igbinv_Ve_di=igbinv_Ve_di*igtemp;
igbinv_Vge_si=igbinv_Vge_si*igtemp;
igbinv_Vge_di=igbinv_Vge_di*igtemp;
igbinv_Vdi_d=igbinv_Vdi_d*igtemp;
igbinv_Vsi_s=igbinv_Vsi_s*igtemp;
#endif
igbinv=(igbinv*igtemp);
EXIT_IF_ISNAN((igbinv*igtemp))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vfbzb_Tempt_GND=((deltaPhi_Tempt_GND-(Eg_Tempt_GND/2.0))-phib_Tempt_GND);
#if defined(_DERIVATE2)
  vfbzb_Tempt_GND_Tempt_GND=(+(+deltaPhi_Tempt_GND_Tempt_GND-(Eg_Tempt_GND_Tempt_GND/2.0-(Eg_Tempt_GND*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))-phib_Tempt_GND_Tempt_GND);
#endif
#endif
vfbzb=((deltaPhi-(Eg/2.0))-phib);
EXIT_IF_ISNAN(((deltaPhi-(Eg/2.0))-phib))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=(-vge_Vge_e);
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0-0.0);
  T0_Vge_e_Vge_e=(+0.0-vge_Vge_e_Vge_e);
  T0_Vge_e_Ve_si=(+0.0-0.0);
  T0_Vge_e_Ve_di=(+0.0-0.0);
  T0_Vge_e_Vge_si=(+0.0-0.0);
  T0_Vge_e_Vdi_si=(+0.0-0.0);
  T0_Vge_e_Tempt_GND=(+0.0-0.0);
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=vfbzb_Tempt_GND;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_e=(+0.0-0.0);
  T0_Tempt_GND_Ve_si=(+0.0-0.0);
  T0_Tempt_GND_Ve_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_si=(+0.0-0.0);
  T0_Tempt_GND_Vdi_si=(+0.0-0.0);
  T0_Tempt_GND_Tempt_GND=(+vfbzb_Tempt_GND_Tempt_GND-0.0);
#endif
#endif
T0=(vfbzb-vge);
EXIT_IF_ISNAN((vfbzb-vge))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=((T0_Vge_di/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=((0.0/NIGBACC_i-(T0_Vge_di*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Vsi_s=((0.0/NIGBACC_i-(T0_Vge_di*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Vge_di=((T0_Vge_di_Vge_di/NIGBACC_i-(T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Vge_e=((T0_Vge_di_Vge_e/NIGBACC_i-(T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Ve_si=((T0_Vge_di_Ve_si/NIGBACC_i-(T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Ve_di=((T0_Vge_di_Ve_di/NIGBACC_i-(T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Vge_si=((T0_Vge_di_Vge_si/NIGBACC_i-(T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Vdi_si=((T0_Vge_di_Vdi_si/NIGBACC_i-(T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_di_Tempt_GND=((T0_Vge_di_Tempt_GND/NIGBACC_i-(T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_di/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Vge_e=((T0_Vge_e/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=((0.0/NIGBACC_i-(T0_Vge_e*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Vsi_s=((0.0/NIGBACC_i-(T0_Vge_e*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Vge_di=((T0_Vge_e_Vge_di/NIGBACC_i-(T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Vge_e=((T0_Vge_e_Vge_e/NIGBACC_i-(T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Ve_si=((T0_Vge_e_Ve_si/NIGBACC_i-(T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Ve_di=((T0_Vge_e_Ve_di/NIGBACC_i-(T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Vge_si=((T0_Vge_e_Vge_si/NIGBACC_i-(T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Vdi_si=((T0_Vge_e_Vdi_si/NIGBACC_i-(T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_e_Tempt_GND=((T0_Vge_e_Tempt_GND/NIGBACC_i-(T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_e/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Ve_si=((T0_Ve_si/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=((0.0/NIGBACC_i-(T0_Ve_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vsi_s=((0.0/NIGBACC_i-(T0_Ve_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_di=((T0_Ve_si_Vge_di/NIGBACC_i-(T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_e=((T0_Ve_si_Vge_e/NIGBACC_i-(T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Ve_si=((T0_Ve_si_Ve_si/NIGBACC_i-(T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Ve_di=((T0_Ve_si_Ve_di/NIGBACC_i-(T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vge_si=((T0_Ve_si_Vge_si/NIGBACC_i-(T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Vdi_si=((T0_Ve_si_Vdi_si/NIGBACC_i-(T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_si_Tempt_GND=((T0_Ve_si_Tempt_GND/NIGBACC_i-(T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_si/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Ve_di=((T0_Ve_di/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=((0.0/NIGBACC_i-(T0_Ve_di*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vsi_s=((0.0/NIGBACC_i-(T0_Ve_di*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_di=((T0_Ve_di_Vge_di/NIGBACC_i-(T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_e=((T0_Ve_di_Vge_e/NIGBACC_i-(T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Ve_si=((T0_Ve_di_Ve_si/NIGBACC_i-(T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Ve_di=((T0_Ve_di_Ve_di/NIGBACC_i-(T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vge_si=((T0_Ve_di_Vge_si/NIGBACC_i-(T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Vdi_si=((T0_Ve_di_Vdi_si/NIGBACC_i-(T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Ve_di_Tempt_GND=((T0_Ve_di_Tempt_GND/NIGBACC_i-(T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Ve_di/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Vge_si=((T0_Vge_si/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=((0.0/NIGBACC_i-(T0_Vge_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vsi_s=((0.0/NIGBACC_i-(T0_Vge_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_di=((T0_Vge_si_Vge_di/NIGBACC_i-(T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_e=((T0_Vge_si_Vge_e/NIGBACC_i-(T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Ve_si=((T0_Vge_si_Ve_si/NIGBACC_i-(T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Ve_di=((T0_Vge_si_Ve_di/NIGBACC_i-(T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vge_si=((T0_Vge_si_Vge_si/NIGBACC_i-(T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Vdi_si=((T0_Vge_si_Vdi_si/NIGBACC_i-(T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vge_si_Tempt_GND=((T0_Vge_si_Tempt_GND/NIGBACC_i-(T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vge_si/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Vdi_si=((T0_Vdi_si/NIGBACC_i)/Vtm);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=((0.0/NIGBACC_i-(T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vsi_s=((0.0/NIGBACC_i-(T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+0.0*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_di=((T0_Vdi_si_Vge_di/NIGBACC_i-(T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_e=((T0_Vdi_si_Vge_e/NIGBACC_i-(T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Ve_si=((T0_Vdi_si_Ve_si/NIGBACC_i-(T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Ve_di=((T0_Vdi_si_Ve_di/NIGBACC_i-(T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vge_si=((T0_Vdi_si_Vge_si/NIGBACC_i-(T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Vdi_si=((T0_Vdi_si_Vdi_si/NIGBACC_i-(T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*0.0/Vtm/Vtm/Vtm);
  T1_Vdi_si_Tempt_GND=((T0_Vdi_si_Tempt_GND/NIGBACC_i-(T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Vdi_si/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*0.0+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*0.0*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
T1_Tempt_GND=(((T0_Tempt_GND/NIGBACC_i)*Vtm-(T0/NIGBACC_i)*Vtm_Tempt_GND)/Vtm/Vtm);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((0.0/NIGBACC_i-(T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+0.0*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vsi_s=((0.0/NIGBACC_i-(T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+0.0*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_di=((T0_Tempt_GND_Vge_di/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Vge_di/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_e=((T0_Tempt_GND_Vge_e/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Vge_e/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Ve_si=((T0_Tempt_GND_Ve_si/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Ve_si/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Ve_di=((T0_Tempt_GND_Ve_di/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Ve_di/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vge_si=((T0_Tempt_GND_Vge_si/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Vge_si/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Vdi_si=((T0_Tempt_GND_Vdi_si/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*0.0+(T0_Vdi_si/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*0.0)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*0.0/Vtm/Vtm/Vtm);
  T1_Tempt_GND_Tempt_GND=((T0_Tempt_GND_Tempt_GND/NIGBACC_i-(T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/NIGBACC_i/NIGBACC_i+2*T0*0.0*0.0/NIGBACC_i/NIGBACC_i/NIGBACC_i)/Vtm-((T0_Tempt_GND/NIGBACC_i)*Vtm_Tempt_GND+(T0_Tempt_GND/NIGBACC_i)*Vtm_Tempt_GND+(T0/NIGBACC_i)*Vtm_Tempt_GND_Tempt_GND)/Vtm/Vtm+2*(T0/NIGBACC_i)*Vtm_Tempt_GND*Vtm_Tempt_GND/Vtm/Vtm/Vtm);
#endif
#endif
T1=((T0/NIGBACC_i)/Vtm);
EXIT_IF_ISNAN(((T0/NIGBACC_i)/Vtm))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe= */
Vaux_Igbacc_Tempt_GND=(((NIGBACC_i*Vtm_Tempt_GND)*bsimcmg_lln((1.0+bsimcmg_lexp(T1))))+((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Tempt_GND))));
Vaux_Igbacc_Vge_di=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_di)));
Vaux_Igbacc_Vge_e=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_e)));
Vaux_Igbacc_Ve_si=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Ve_si)));
Vaux_Igbacc_Ve_di=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Ve_di)));
Vaux_Igbacc_Vge_si=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vge_si)));
Vaux_Igbacc_Vdi_si=((NIGBACC_i*Vtm)*bsimcmg_d_lln((1.0+bsimcmg_lexp(T1)),bsimcmg_d_lexp(T1,T1_Vdi_si)));
#endif
Vaux_Igbacc=((NIGBACC_i*Vtm)*bsimcmg_lln((1.0+bsimcmg_lexp(T1))));
EXIT_IF_ISNAN(((NIGBACC_i*Vtm)*bsimcmg_lln((1.0+bsimcmg_lexp(T1)))))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Voxacc_Vge_di=0.0;
#if defined(_DERIVATE2)
  Voxacc_Vge_di_Vge_di=0.0;
  Voxacc_Vge_di_Tempt_GND=0.0;
  Voxacc_Vge_di_Vdi_si=0.0;
  Voxacc_Vge_di_Vge_e=0.0;
  Voxacc_Vge_di_Ve_si=0.0;
  Voxacc_Vge_di_Ve_di=0.0;
  Voxacc_Vge_di_Vge_si=0.0;
#endif
Voxacc_Tempt_GND=qi_acc_for_QM_Tempt_GND;
#if defined(_DERIVATE2)
  Voxacc_Tempt_GND_Vge_di=0.0;
  Voxacc_Tempt_GND_Tempt_GND=qi_acc_for_QM_Tempt_GND_Tempt_GND;
  Voxacc_Tempt_GND_Vdi_si=qi_acc_for_QM_Tempt_GND_Vdi_si;
  Voxacc_Tempt_GND_Vge_e=qi_acc_for_QM_Tempt_GND_Vge_e;
  Voxacc_Tempt_GND_Ve_si=qi_acc_for_QM_Tempt_GND_Ve_si;
  Voxacc_Tempt_GND_Ve_di=qi_acc_for_QM_Tempt_GND_Ve_di;
  Voxacc_Tempt_GND_Vge_si=qi_acc_for_QM_Tempt_GND_Vge_si;
#endif
Voxacc_Vdi_si=qi_acc_for_QM_Vdi_si;
#if defined(_DERIVATE2)
  Voxacc_Vdi_si_Vge_di=0.0;
  Voxacc_Vdi_si_Tempt_GND=qi_acc_for_QM_Vdi_si_Tempt_GND;
  Voxacc_Vdi_si_Vdi_si=qi_acc_for_QM_Vdi_si_Vdi_si;
  Voxacc_Vdi_si_Vge_e=qi_acc_for_QM_Vdi_si_Vge_e;
  Voxacc_Vdi_si_Ve_si=qi_acc_for_QM_Vdi_si_Ve_si;
  Voxacc_Vdi_si_Ve_di=qi_acc_for_QM_Vdi_si_Ve_di;
  Voxacc_Vdi_si_Vge_si=qi_acc_for_QM_Vdi_si_Vge_si;
#endif
Voxacc_Vge_e=qi_acc_for_QM_Vge_e;
#if defined(_DERIVATE2)
  Voxacc_Vge_e_Vge_di=0.0;
  Voxacc_Vge_e_Tempt_GND=qi_acc_for_QM_Vge_e_Tempt_GND;
  Voxacc_Vge_e_Vdi_si=qi_acc_for_QM_Vge_e_Vdi_si;
  Voxacc_Vge_e_Vge_e=qi_acc_for_QM_Vge_e_Vge_e;
  Voxacc_Vge_e_Ve_si=qi_acc_for_QM_Vge_e_Ve_si;
  Voxacc_Vge_e_Ve_di=qi_acc_for_QM_Vge_e_Ve_di;
  Voxacc_Vge_e_Vge_si=qi_acc_for_QM_Vge_e_Vge_si;
#endif
Voxacc_Ve_si=qi_acc_for_QM_Ve_si;
#if defined(_DERIVATE2)
  Voxacc_Ve_si_Vge_di=0.0;
  Voxacc_Ve_si_Tempt_GND=qi_acc_for_QM_Ve_si_Tempt_GND;
  Voxacc_Ve_si_Vdi_si=qi_acc_for_QM_Ve_si_Vdi_si;
  Voxacc_Ve_si_Vge_e=qi_acc_for_QM_Ve_si_Vge_e;
  Voxacc_Ve_si_Ve_si=qi_acc_for_QM_Ve_si_Ve_si;
  Voxacc_Ve_si_Ve_di=qi_acc_for_QM_Ve_si_Ve_di;
  Voxacc_Ve_si_Vge_si=qi_acc_for_QM_Ve_si_Vge_si;
#endif
Voxacc_Ve_di=qi_acc_for_QM_Ve_di;
#if defined(_DERIVATE2)
  Voxacc_Ve_di_Vge_di=0.0;
  Voxacc_Ve_di_Tempt_GND=qi_acc_for_QM_Ve_di_Tempt_GND;
  Voxacc_Ve_di_Vdi_si=qi_acc_for_QM_Ve_di_Vdi_si;
  Voxacc_Ve_di_Vge_e=qi_acc_for_QM_Ve_di_Vge_e;
  Voxacc_Ve_di_Ve_si=qi_acc_for_QM_Ve_di_Ve_si;
  Voxacc_Ve_di_Ve_di=qi_acc_for_QM_Ve_di_Ve_di;
  Voxacc_Ve_di_Vge_si=qi_acc_for_QM_Ve_di_Vge_si;
#endif
Voxacc_Vge_si=qi_acc_for_QM_Vge_si;
#if defined(_DERIVATE2)
  Voxacc_Vge_si_Vge_di=0.0;
  Voxacc_Vge_si_Tempt_GND=qi_acc_for_QM_Vge_si_Tempt_GND;
  Voxacc_Vge_si_Vdi_si=qi_acc_for_QM_Vge_si_Vdi_si;
  Voxacc_Vge_si_Vge_e=qi_acc_for_QM_Vge_si_Vge_e;
  Voxacc_Vge_si_Ve_si=qi_acc_for_QM_Vge_si_Ve_si;
  Voxacc_Vge_si_Ve_di=qi_acc_for_QM_Vge_si_Ve_di;
  Voxacc_Vge_si_Vge_si=qi_acc_for_QM_Vge_si_Vge_si;
#endif
#endif
Voxacc=qi_acc_for_QM;
EXIT_IF_ISNAN(qi_acc_for_QM)
}
else
{
if
((vfbzb<=0))
{
{
double m00_sqrt(d00_sqrt0,(((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Voxacc_Vge_di=(0.5*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_di_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_di-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vdi_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_e-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Ve_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Ve_di-0.0)*(T0-0.02)+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Tempt_GND=(0.5*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Tempt_GND_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_di-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Tempt_GND-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*vfbzb_Tempt_GND+0.08*vfbzb_Tempt_GND_Tempt_GND)))));
  Voxacc_Tempt_GND_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vdi_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_e-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Ve_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Ve_di-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))-(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
#endif
Voxacc_Vdi_si=(0.5*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vdi_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_di-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Tempt_GND-0.0)*(T0-0.02)+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vdi_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_e-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Ve_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Ve_di-0.0)*(T0-0.02)+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Vge_e=(0.5*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_e_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_di-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vdi_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_e-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Ve_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Ve_di-0.0)*(T0-0.02)+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Ve_si=(0.5*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Ve_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_di-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Tempt_GND-0.0)*(T0-0.02)+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vdi_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_e-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Ve_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Ve_di-0.0)*(T0-0.02)+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Ve_di=(0.5*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Ve_di_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_di-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Tempt_GND-0.0)*(T0-0.02)+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vdi_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_e-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Ve_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Ve_di-0.0)*(T0-0.02)+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Vge_si=(0.5*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_di-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))-((0.08*vfbzb_Tempt_GND)))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Tempt_GND-0.0))-(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vdi_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vdi_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_e-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_e-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Ve_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Ve_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Ve_di-0.0)*(T0-0.02)+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Ve_di-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))-(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))-(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_si-0.0))-(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
#endif
Voxacc=(0.5*((T0-0.02)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T0-0.02)+d00_sqrt0)))
}
}
else
{
{
double m00_sqrt(d00_sqrt0,(((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Voxacc_Vge_di=(0.5*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_di_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_di-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vdi_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_e-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Ve_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Ve_di-0.0)*(T0-0.02)+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_di_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))*d10_sqrt0)+0.5*(+(+T0_Vge_di_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di))+d10_sqrt0*(+(+(+T0_Vge_di_Vge_si-0.0)*(T0-0.02)+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+(T0-0.02)*(+T0_Vge_di_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Tempt_GND=(0.5*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Tempt_GND_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_di-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Tempt_GND-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*vfbzb_Tempt_GND+0.08*vfbzb_Tempt_GND_Tempt_GND)))));
  Voxacc_Tempt_GND_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vdi_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_e-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Ve_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Ve_di-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
  Voxacc_Tempt_GND_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))*d10_sqrt0)+0.5*(+(+T0_Tempt_GND_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*(((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND))+(0.08*vfbzb_Tempt_GND))+d10_sqrt0*(+(+(+T0_Tempt_GND_Vge_si-0.0)*(T0-0.02)+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+(T0-0.02)*(+T0_Tempt_GND_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*vfbzb_Tempt_GND+0.08*0.0)))));
#endif
Voxacc_Vdi_si=(0.5*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vdi_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_di-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Tempt_GND-0.0)*(T0-0.02)+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vdi_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_e-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Ve_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Ve_di-0.0)*(T0-0.02)+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vdi_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))*d10_sqrt0)+0.5*(+(+T0_Vdi_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si))+d10_sqrt0*(+(+(+T0_Vdi_si_Vge_si-0.0)*(T0-0.02)+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+(T0-0.02)*(+T0_Vdi_si_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Vge_e=(0.5*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_e_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_di-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vdi_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_e-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Ve_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Ve_di-0.0)*(T0-0.02)+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_e_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))*d10_sqrt0)+0.5*(+(+T0_Vge_e_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e))+d10_sqrt0*(+(+(+T0_Vge_e_Vge_si-0.0)*(T0-0.02)+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+(T0-0.02)*(+T0_Vge_e_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Ve_si=(0.5*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Ve_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_di-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Tempt_GND-0.0)*(T0-0.02)+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vdi_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_e-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Ve_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Ve_di-0.0)*(T0-0.02)+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))*d10_sqrt0)+0.5*(+(+T0_Ve_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si))+d10_sqrt0*(+(+(+T0_Ve_si_Vge_si-0.0)*(T0-0.02)+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+(T0-0.02)*(+T0_Ve_si_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Ve_di=(0.5*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Ve_di_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_di-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Tempt_GND-0.0)*(T0-0.02)+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vdi_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_e-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Ve_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Ve_di-0.0)*(T0-0.02)+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Ve_di_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))*d10_sqrt0)+0.5*(+(+T0_Ve_di_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di))+d10_sqrt0*(+(+(+T0_Ve_di_Vge_si-0.0)*(T0-0.02)+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+(T0-0.02)*(+T0_Ve_di_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
Voxacc_Vge_si=(0.5*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  Voxacc_Vge_si_Vge_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_di*(T0-0.02))+((T0-0.02)*T0_Vge_di)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_di-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Tempt_GND=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Tempt_GND-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Tempt_GND*(T0-0.02))+((T0-0.02)*T0_Tempt_GND)))+((0.08*vfbzb_Tempt_GND)))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Tempt_GND-0.0)*(T0-0.02)+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Tempt_GND-0.0))+(+0.0*vfbzb+0.0*vfbzb_Tempt_GND+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vdi_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vdi_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vdi_si*(T0-0.02))+((T0-0.02)*T0_Vdi_si)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vdi_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vdi_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vge_e=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_e-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_e*(T0-0.02))+((T0-0.02)*T0_Vge_e)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_e-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_e-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Ve_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Ve_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_si*(T0-0.02))+((T0-0.02)*T0_Ve_si)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Ve_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Ve_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Ve_di=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Ve_di-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Ve_di*(T0-0.02))+((T0-0.02)*T0_Ve_di)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Ve_di-0.0)*(T0-0.02)+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Ve_di-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
  Voxacc_Vge_si_Vge_si=(+0.0*((T0-0.02)+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))*d10_sqrt0)+0.5*(+(+T0_Vge_si_Vge_si-0.0)+(m20_sqrt((((T0-0.02)*(T0-0.02))+(0.08*vfbzb)))*((((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si)))+(0.0))*((T0_Vge_si*(T0-0.02))+((T0-0.02)*T0_Vge_si))+d10_sqrt0*(+(+(+T0_Vge_si_Vge_si-0.0)*(T0-0.02)+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+(T0-0.02)*(+T0_Vge_si_Vge_si-0.0))+(+0.0*vfbzb+0.0*0.0+0.0*0.0+0.08*0.0)))));
#endif
#endif
Voxacc=(0.5*((T0-0.02)+d00_sqrt0));
EXIT_IF_ISNAN((0.5*((T0-0.02)+d00_sqrt0)))
}
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(-(BIGBACC_i*Voxacc_Vge_di));
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_di+BIGBACC_i*0.0));
  T2_Vge_di_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_di+BIGBACC_i*0.0));
  T2_Vge_di_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Vge_di));
  T2_Vge_di_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Vge_e));
  T2_Vge_di_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Vge_si));
  T2_Vge_di_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Ve_si));
  T2_Vge_di_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Ve_di));
  T2_Vge_di_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Vdi_si));
  T2_Vge_di_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_di+BIGBACC_i*Voxacc_Vge_di_Tempt_GND));
#endif
T2_Vge_e=(-(BIGBACC_i*Voxacc_Vge_e));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_e+BIGBACC_i*0.0));
  T2_Vge_e_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_e+BIGBACC_i*0.0));
  T2_Vge_e_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Vge_di));
  T2_Vge_e_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Vge_e));
  T2_Vge_e_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Vge_si));
  T2_Vge_e_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Ve_si));
  T2_Vge_e_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Ve_di));
  T2_Vge_e_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Vdi_si));
  T2_Vge_e_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_e+BIGBACC_i*Voxacc_Vge_e_Tempt_GND));
#endif
T2_Vge_si=(-(BIGBACC_i*Voxacc_Vge_si));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_si+BIGBACC_i*0.0));
  T2_Vge_si_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_si+BIGBACC_i*0.0));
  T2_Vge_si_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Vge_di));
  T2_Vge_si_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Vge_e));
  T2_Vge_si_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Vge_si));
  T2_Vge_si_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Ve_si));
  T2_Vge_si_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Ve_di));
  T2_Vge_si_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Vdi_si));
  T2_Vge_si_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_si+BIGBACC_i*Voxacc_Vge_si_Tempt_GND));
#endif
T2_Ve_si=(-(BIGBACC_i*Voxacc_Ve_si));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_si+BIGBACC_i*0.0));
  T2_Ve_si_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_si+BIGBACC_i*0.0));
  T2_Ve_si_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Vge_di));
  T2_Ve_si_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Vge_e));
  T2_Ve_si_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Vge_si));
  T2_Ve_si_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Ve_si));
  T2_Ve_si_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Ve_di));
  T2_Ve_si_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Vdi_si));
  T2_Ve_si_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Ve_si+BIGBACC_i*Voxacc_Ve_si_Tempt_GND));
#endif
T2_Ve_di=(-(BIGBACC_i*Voxacc_Ve_di));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_di+BIGBACC_i*0.0));
  T2_Ve_di_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_di+BIGBACC_i*0.0));
  T2_Ve_di_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Vge_di));
  T2_Ve_di_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Vge_e));
  T2_Ve_di_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Vge_si));
  T2_Ve_di_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Ve_si));
  T2_Ve_di_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Ve_di));
  T2_Ve_di_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Vdi_si));
  T2_Ve_di_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Ve_di+BIGBACC_i*Voxacc_Ve_di_Tempt_GND));
#endif
T2_Vdi_si=(-(BIGBACC_i*Voxacc_Vdi_si));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vdi_si+BIGBACC_i*0.0));
  T2_Vdi_si_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vdi_si+BIGBACC_i*0.0));
  T2_Vdi_si_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Vge_di));
  T2_Vdi_si_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Vge_e));
  T2_Vdi_si_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Vge_si));
  T2_Vdi_si_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Ve_si));
  T2_Vdi_si_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Ve_di));
  T2_Vdi_si_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Vdi_si));
  T2_Vdi_si_Tempt_GND=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vdi_si+BIGBACC_i*Voxacc_Vdi_si_Tempt_GND));
#endif
T2_Tempt_GND=(AIGBACC_t_Tempt_GND-(BIGBACC_i*Voxacc_Tempt_GND));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Tempt_GND+BIGBACC_i*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0-(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Tempt_GND+BIGBACC_i*0.0));
  T2_Tempt_GND_Vge_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Vge_di));
  T2_Tempt_GND_Vge_e=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Vge_e));
  T2_Tempt_GND_Vge_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Vge_si));
  T2_Tempt_GND_Ve_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Ve_si));
  T2_Tempt_GND_Ve_di=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Ve_di));
  T2_Tempt_GND_Vdi_si=(+0.0-(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Vdi_si));
  T2_Tempt_GND_Tempt_GND=(+AIGBACC_t_Tempt_GND_Tempt_GND-(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Tempt_GND+BIGBACC_i*Voxacc_Tempt_GND_Tempt_GND));
#endif
#endif
T2=(AIGBACC_t-(BIGBACC_i*Voxacc));
EXIT_IF_ISNAN((AIGBACC_t-(BIGBACC_i*Voxacc)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=(CIGBACC_i*Voxacc_Vge_di);
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_di+CIGBACC_i*0.0));
  T3_Vge_di_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_di+CIGBACC_i*0.0));
  T3_Vge_di_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Vge_di));
  T3_Vge_di_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Vge_e));
  T3_Vge_di_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Vdi_si));
  T3_Vge_di_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Ve_si));
  T3_Vge_di_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Ve_di));
  T3_Vge_di_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Vge_si));
  T3_Vge_di_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_di+CIGBACC_i*Voxacc_Vge_di_Tempt_GND));
#endif
T3_Vge_e=(CIGBACC_i*Voxacc_Vge_e);
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_e+CIGBACC_i*0.0));
  T3_Vge_e_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_e+CIGBACC_i*0.0));
  T3_Vge_e_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Vge_di));
  T3_Vge_e_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Vge_e));
  T3_Vge_e_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Vdi_si));
  T3_Vge_e_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Ve_si));
  T3_Vge_e_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Ve_di));
  T3_Vge_e_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Vge_si));
  T3_Vge_e_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_e+CIGBACC_i*Voxacc_Vge_e_Tempt_GND));
#endif
T3_Vdi_si=(CIGBACC_i*Voxacc_Vdi_si);
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vdi_si+CIGBACC_i*0.0));
  T3_Vdi_si_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vdi_si+CIGBACC_i*0.0));
  T3_Vdi_si_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Vge_di));
  T3_Vdi_si_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Vge_e));
  T3_Vdi_si_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Vdi_si));
  T3_Vdi_si_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Ve_si));
  T3_Vdi_si_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Ve_di));
  T3_Vdi_si_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Vge_si));
  T3_Vdi_si_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vdi_si+CIGBACC_i*Voxacc_Vdi_si_Tempt_GND));
#endif
T3_Ve_si=(CIGBACC_i*Voxacc_Ve_si);
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_si+CIGBACC_i*0.0));
  T3_Ve_si_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_si+CIGBACC_i*0.0));
  T3_Ve_si_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Vge_di));
  T3_Ve_si_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Vge_e));
  T3_Ve_si_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Vdi_si));
  T3_Ve_si_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Ve_si));
  T3_Ve_si_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Ve_di));
  T3_Ve_si_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Vge_si));
  T3_Ve_si_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Ve_si+CIGBACC_i*Voxacc_Ve_si_Tempt_GND));
#endif
T3_Ve_di=(CIGBACC_i*Voxacc_Ve_di);
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_di+CIGBACC_i*0.0));
  T3_Ve_di_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Ve_di+CIGBACC_i*0.0));
  T3_Ve_di_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Vge_di));
  T3_Ve_di_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Vge_e));
  T3_Ve_di_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Vdi_si));
  T3_Ve_di_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Ve_si));
  T3_Ve_di_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Ve_di));
  T3_Ve_di_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Vge_si));
  T3_Ve_di_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Ve_di+CIGBACC_i*Voxacc_Ve_di_Tempt_GND));
#endif
T3_Vge_si=(CIGBACC_i*Voxacc_Vge_si);
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_si+CIGBACC_i*0.0));
  T3_Vge_si_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Vge_si+CIGBACC_i*0.0));
  T3_Vge_si_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Vge_di));
  T3_Vge_si_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Vge_e));
  T3_Vge_si_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Vdi_si));
  T3_Vge_si_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Ve_si));
  T3_Vge_si_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Ve_di));
  T3_Vge_si_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Vge_si));
  T3_Vge_si_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Vge_si+CIGBACC_i*Voxacc_Vge_si_Tempt_GND));
#endif
T3_Tempt_GND=(CIGBACC_i*Voxacc_Tempt_GND);
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Tempt_GND+CIGBACC_i*0.0));
  T3_Tempt_GND_Vsi_s=(+0.0+(+0.0*Voxacc+0.0*0.0+0.0*Voxacc_Tempt_GND+CIGBACC_i*0.0));
  T3_Tempt_GND_Vge_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_di+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Vge_di));
  T3_Tempt_GND_Vge_e=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_e+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Vge_e));
  T3_Tempt_GND_Vdi_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vdi_si+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Vdi_si));
  T3_Tempt_GND_Ve_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_si+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Ve_si));
  T3_Tempt_GND_Ve_di=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Ve_di+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Ve_di));
  T3_Tempt_GND_Vge_si=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Vge_si+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Vge_si));
  T3_Tempt_GND_Tempt_GND=(+0.0+(+0.0*Voxacc+0.0*Voxacc_Tempt_GND+0.0*Voxacc_Tempt_GND+CIGBACC_i*Voxacc_Tempt_GND_Tempt_GND));
#endif
#endif
T3=(1.0+(CIGBACC_i*Voxacc));
EXIT_IF_ISNAN((1.0+(CIGBACC_i*Voxacc)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=(((((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_di);
  T4_Vge_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_e);
  T4_Vge_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Vdi_si);
  T4_Vge_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Ve_si);
  T4_Vge_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Ve_di);
  T4_Vge_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Vge_si);
  T4_Vge_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_di+((-7.45669e11)*pModel->TOXG)*T2_Vge_di_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_di_Tempt_GND);
#endif
T4_Vge_e=(((((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_di);
  T4_Vge_e_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_e);
  T4_Vge_e_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Vdi_si);
  T4_Vge_e_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Ve_si);
  T4_Vge_e_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Ve_di);
  T4_Vge_e_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Vge_si);
  T4_Vge_e_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_e+((-7.45669e11)*pModel->TOXG)*T2_Vge_e_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_e+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_e_Tempt_GND);
#endif
T4_Vdi_si=(((((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_di);
  T4_Vdi_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_e);
  T4_Vdi_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vdi_si);
  T4_Vdi_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Ve_si);
  T4_Vdi_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Ve_di);
  T4_Vdi_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Vge_si);
  T4_Vdi_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vdi_si+((-7.45669e11)*pModel->TOXG)*T2_Vdi_si_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vdi_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vdi_si_Tempt_GND);
#endif
T4_Ve_si=(((((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_di);
  T4_Ve_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_e);
  T4_Ve_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Vdi_si);
  T4_Ve_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Ve_di);
  T4_Ve_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Vge_si);
  T4_Ve_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Ve_si+((-7.45669e11)*pModel->TOXG)*T2_Ve_si_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Ve_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_si_Tempt_GND);
#endif
T4_Ve_di=(((((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_di);
  T4_Ve_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_e);
  T4_Ve_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Vdi_si);
  T4_Ve_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Ve_si);
  T4_Ve_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Vge_si);
  T4_Ve_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Ve_di+((-7.45669e11)*pModel->TOXG)*T2_Ve_di_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Ve_di+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Ve_di_Tempt_GND);
#endif
T4_Vge_si=(((((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_di);
  T4_Vge_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_e);
  T4_Vge_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Vdi_si);
  T4_Vge_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Ve_si);
  T4_Vge_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Ve_di);
  T4_Vge_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Vge_si);
  T4_Vge_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Vge_si+((-7.45669e11)*pModel->TOXG)*T2_Vge_si_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Vge_si+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Vge_si_Tempt_GND);
#endif
T4_Tempt_GND=(((((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3)+((((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_di+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Vge_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_di)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_di);
  T4_Tempt_GND_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_e+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Vge_e)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_e+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_e)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_e);
  T4_Tempt_GND_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vdi_si+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Vdi_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vdi_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vdi_si)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vdi_si);
  T4_Tempt_GND_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_si+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Ve_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Ve_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_si)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Ve_si);
  T4_Tempt_GND_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Ve_di+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Ve_di)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Ve_di+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Ve_di)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Ve_di);
  T4_Tempt_GND_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Vge_si+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Vge_si)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Vge_si+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Vge_si)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Vge_si);
  T4_Tempt_GND_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-7.45669e11)*0.0)*T2+0.0*T2_Tempt_GND+(0.0)*T2_Tempt_GND+((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND_Tempt_GND)*T3+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)*T3_Tempt_GND+((((0.0)*T2)+(((-7.45669e11)*pModel->TOXG)*T2_Tempt_GND)))*T3_Tempt_GND+(((-7.45669e11)*pModel->TOXG)*T2)*T3_Tempt_GND_Tempt_GND);
#endif
#endif
T4=((((-7.45669e11)*pModel->TOXG)*T2)*T3);
EXIT_IF_ISNAN(((((-7.45669e11)*pModel->TOXG)*T2)*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=bsimcmg_d_lexp(T4,T4_Vge_di);
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=T4_Vge_di_Vge_di;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=T4_Vge_di_Vge_e;
  T5_Vge_di_Vdi_si=T4_Vge_di_Vdi_si;
  T5_Vge_di_Ve_si=T4_Vge_di_Ve_si;
  T5_Vge_di_Ve_di=T4_Vge_di_Ve_di;
  T5_Vge_di_Vge_si=T4_Vge_di_Vge_si;
  T5_Vge_di_Tempt_GND=T4_Vge_di_Tempt_GND;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=bsimcmg_d_lexp(T4,T4_Vge_e);
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=T4_Vge_e_Vge_di;
  T5_Vge_e_Vdi_d=0.0;
  T5_Vge_e_Vsi_s=0.0;
  T5_Vge_e_Vge_e=T4_Vge_e_Vge_e;
  T5_Vge_e_Vdi_si=T4_Vge_e_Vdi_si;
  T5_Vge_e_Ve_si=T4_Vge_e_Ve_si;
  T5_Vge_e_Ve_di=T4_Vge_e_Ve_di;
  T5_Vge_e_Vge_si=T4_Vge_e_Vge_si;
  T5_Vge_e_Tempt_GND=T4_Vge_e_Tempt_GND;
#endif
T5_Vdi_si=bsimcmg_d_lexp(T4,T4_Vdi_si);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=T4_Vdi_si_Vge_di;
  T5_Vdi_si_Vdi_d=0.0;
  T5_Vdi_si_Vsi_s=0.0;
  T5_Vdi_si_Vge_e=T4_Vdi_si_Vge_e;
  T5_Vdi_si_Vdi_si=T4_Vdi_si_Vdi_si;
  T5_Vdi_si_Ve_si=T4_Vdi_si_Ve_si;
  T5_Vdi_si_Ve_di=T4_Vdi_si_Ve_di;
  T5_Vdi_si_Vge_si=T4_Vdi_si_Vge_si;
  T5_Vdi_si_Tempt_GND=T4_Vdi_si_Tempt_GND;
#endif
T5_Ve_si=bsimcmg_d_lexp(T4,T4_Ve_si);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=T4_Ve_si_Vge_di;
  T5_Ve_si_Vdi_d=0.0;
  T5_Ve_si_Vsi_s=0.0;
  T5_Ve_si_Vge_e=T4_Ve_si_Vge_e;
  T5_Ve_si_Vdi_si=T4_Ve_si_Vdi_si;
  T5_Ve_si_Ve_si=T4_Ve_si_Ve_si;
  T5_Ve_si_Ve_di=T4_Ve_si_Ve_di;
  T5_Ve_si_Vge_si=T4_Ve_si_Vge_si;
  T5_Ve_si_Tempt_GND=T4_Ve_si_Tempt_GND;
#endif
T5_Ve_di=bsimcmg_d_lexp(T4,T4_Ve_di);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=T4_Ve_di_Vge_di;
  T5_Ve_di_Vdi_d=0.0;
  T5_Ve_di_Vsi_s=0.0;
  T5_Ve_di_Vge_e=T4_Ve_di_Vge_e;
  T5_Ve_di_Vdi_si=T4_Ve_di_Vdi_si;
  T5_Ve_di_Ve_si=T4_Ve_di_Ve_si;
  T5_Ve_di_Ve_di=T4_Ve_di_Ve_di;
  T5_Ve_di_Vge_si=T4_Ve_di_Vge_si;
  T5_Ve_di_Tempt_GND=T4_Ve_di_Tempt_GND;
#endif
T5_Vge_si=bsimcmg_d_lexp(T4,T4_Vge_si);
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=T4_Vge_si_Vge_di;
  T5_Vge_si_Vdi_d=0.0;
  T5_Vge_si_Vsi_s=0.0;
  T5_Vge_si_Vge_e=T4_Vge_si_Vge_e;
  T5_Vge_si_Vdi_si=T4_Vge_si_Vdi_si;
  T5_Vge_si_Ve_si=T4_Vge_si_Ve_si;
  T5_Vge_si_Ve_di=T4_Vge_si_Ve_di;
  T5_Vge_si_Vge_si=T4_Vge_si_Vge_si;
  T5_Vge_si_Tempt_GND=T4_Vge_si_Tempt_GND;
#endif
T5_Tempt_GND=bsimcmg_d_lexp(T4,T4_Tempt_GND);
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=T4_Tempt_GND_Vge_di;
  T5_Tempt_GND_Vdi_d=0.0;
  T5_Tempt_GND_Vsi_s=0.0;
  T5_Tempt_GND_Vge_e=T4_Tempt_GND_Vge_e;
  T5_Tempt_GND_Vdi_si=T4_Tempt_GND_Vdi_si;
  T5_Tempt_GND_Ve_si=T4_Tempt_GND_Ve_si;
  T5_Tempt_GND_Ve_di=T4_Tempt_GND_Ve_di;
  T5_Tempt_GND_Vge_si=T4_Tempt_GND_Vge_si;
  T5_Tempt_GND_Tempt_GND=T4_Tempt_GND_Tempt_GND;
#endif
#endif
T5=bsimcmg_lexp(T4);
EXIT_IF_ISNAN(bsimcmg_lexp(T4))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=0.0;
  T6_Vdi_si_Vdi_d=0.0;
  T6_Vdi_si_Vsi_s=0.0;
  T6_Vdi_si_Vge_e=0.0;
  T6_Vdi_si_Vdi_si=0.0;
  T6_Vdi_si_Tempt_GND=0.0;
  T6_Vdi_si_Ve_si=0.0;
  T6_Vdi_si_Ve_di=0.0;
  T6_Vdi_si_Vge_si=0.0;
#endif
T6_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=0.0;
  T6_Tempt_GND_Vdi_d=0.0;
  T6_Tempt_GND_Vsi_s=0.0;
  T6_Tempt_GND_Vge_e=0.0;
  T6_Tempt_GND_Vdi_si=0.0;
  T6_Tempt_GND_Tempt_GND=0.0;
  T6_Tempt_GND_Ve_si=0.0;
  T6_Tempt_GND_Ve_di=0.0;
  T6_Tempt_GND_Vge_si=0.0;
#endif
T6_Ve_si=0.0;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=0.0;
  T6_Ve_si_Vdi_d=0.0;
  T6_Ve_si_Vsi_s=0.0;
  T6_Ve_si_Vge_e=0.0;
  T6_Ve_si_Vdi_si=0.0;
  T6_Ve_si_Tempt_GND=0.0;
  T6_Ve_si_Ve_si=0.0;
  T6_Ve_si_Ve_di=0.0;
  T6_Ve_si_Vge_si=0.0;
#endif
T6_Ve_di=0.0;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=0.0;
  T6_Ve_di_Vdi_d=0.0;
  T6_Ve_di_Vsi_s=0.0;
  T6_Ve_di_Vge_e=0.0;
  T6_Ve_di_Vdi_si=0.0;
  T6_Ve_di_Tempt_GND=0.0;
  T6_Ve_di_Ve_si=0.0;
  T6_Ve_di_Ve_di=0.0;
  T6_Ve_di_Vge_si=0.0;
#endif
T6_Vge_si=0.0;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=0.0;
  T6_Vge_si_Vdi_d=0.0;
  T6_Vge_si_Vsi_s=0.0;
  T6_Vge_si_Vge_e=0.0;
  T6_Vge_si_Vdi_si=0.0;
  T6_Vge_si_Tempt_GND=0.0;
  T6_Vge_si_Ve_si=0.0;
  T6_Vge_si_Ve_di=0.0;
  T6_Vge_si_Vge_si=0.0;
#endif
#endif
T6=4.97232e-7;
EXIT_IF_ISNAN(4.97232e-7)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbacc_Vge_e=((((((((Weff0*Leff)*T6_Vge_e)*Toxratio*vge)+((((Weff0*Leff)*T6)*Toxratio)*vge_Vge_e))*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Vge_e))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vge_e));
igbacc_Vdi_si=((((((Weff0*Leff)*T6_Vdi_si)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Vdi_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vdi_si));
igbacc_Tempt_GND=((((((Weff0*Leff)*T6_Tempt_GND)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Tempt_GND))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Tempt_GND));
igbacc_Ve_si=((((((Weff0*Leff)*T6_Ve_si)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Ve_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Ve_si));
igbacc_Ve_di=((((((Weff0*Leff)*T6_Ve_di)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Ve_di))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Ve_di));
igbacc_Vge_si=((((((Weff0*Leff)*T6_Vge_si)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Vge_si))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vge_si));
igbacc_Vge_di=((((((Weff0*Leff)*T6_Vge_di)*Toxratio*vge*Vaux_Igbacc)+(((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc_Vge_di))*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vge_di));
igbacc_Vdi_d=((((Weff0*Leff)*T6_Vdi_d)*Toxratio*vge*Vaux_Igbacc*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vdi_d));
igbacc_Vsi_s=((((Weff0*Leff)*T6_Vsi_s)*Toxratio*vge*Vaux_Igbacc*T5)+((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5_Vsi_s));
#endif
igbacc=((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5);
EXIT_IF_ISNAN(((((((Weff0*Leff)*T6)*Toxratio)*vge)*Vaux_Igbacc)*T5))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbacc_Vge_e=igbacc_Vge_e*igtemp;
igbacc_Vdi_si=igbacc_Vdi_si*igtemp;
igbacc_Tempt_GND=((igbacc_Tempt_GND*igtemp)+(igbacc*igtemp_Tempt_GND));
igbacc_Ve_si=igbacc_Ve_si*igtemp;
igbacc_Ve_di=igbacc_Ve_di*igtemp;
igbacc_Vge_si=igbacc_Vge_si*igtemp;
igbacc_Vge_di=igbacc_Vge_di*igtemp;
igbacc_Vdi_d=igbacc_Vdi_d*igtemp;
igbacc_Vsi_s=igbacc_Vsi_s*igtemp;
#endif
igbacc=(igbacc*igtemp);
EXIT_IF_ISNAN((igbacc*igtemp))
}
if
((pModel->IGCMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(-(BIGC_i*qia_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGC_i*0.0));
  T1_Ve_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGC_i*0.0));
  T1_Ve_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGC_i*0.0));
  T1_Ve_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+BIGC_i*0.0));
  T1_Ve_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+BIGC_i*qia_Ve_si_Ve_si));
  T1_Ve_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+BIGC_i*qia_Ve_si_Ve_di));
  T1_Ve_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+BIGC_i*qia_Ve_si_Vge_si));
  T1_Ve_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+BIGC_i*qia_Ve_si_Vdi_si));
  T1_Ve_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+BIGC_i*qia_Ve_si_Tempt_GND));
#endif
T1_Ve_di=(-(BIGC_i*qia_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGC_i*0.0));
  T1_Ve_di_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGC_i*0.0));
  T1_Ve_di_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGC_i*0.0));
  T1_Ve_di_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+BIGC_i*0.0));
  T1_Ve_di_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+BIGC_i*qia_Ve_di_Ve_si));
  T1_Ve_di_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+BIGC_i*qia_Ve_di_Ve_di));
  T1_Ve_di_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+BIGC_i*qia_Ve_di_Vge_si));
  T1_Ve_di_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+BIGC_i*qia_Ve_di_Vdi_si));
  T1_Ve_di_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+BIGC_i*qia_Ve_di_Tempt_GND));
#endif
T1_Vge_si=(-(BIGC_i*qia_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGC_i*0.0));
  T1_Vge_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGC_i*0.0));
  T1_Vge_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGC_i*0.0));
  T1_Vge_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+BIGC_i*0.0));
  T1_Vge_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+BIGC_i*qia_Vge_si_Ve_si));
  T1_Vge_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+BIGC_i*qia_Vge_si_Ve_di));
  T1_Vge_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+BIGC_i*qia_Vge_si_Vge_si));
  T1_Vge_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+BIGC_i*qia_Vge_si_Vdi_si));
  T1_Vge_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+BIGC_i*qia_Vge_si_Tempt_GND));
#endif
T1_Vdi_si=(-(BIGC_i*qia_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGC_i*0.0));
  T1_Vdi_si_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGC_i*0.0));
  T1_Vdi_si_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGC_i*0.0));
  T1_Vdi_si_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+BIGC_i*0.0));
  T1_Vdi_si_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+BIGC_i*qia_Vdi_si_Ve_si));
  T1_Vdi_si_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+BIGC_i*qia_Vdi_si_Ve_di));
  T1_Vdi_si_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+BIGC_i*qia_Vdi_si_Vge_si));
  T1_Vdi_si_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+BIGC_i*qia_Vdi_si_Vdi_si));
  T1_Vdi_si_Tempt_GND=(+0.0-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+BIGC_i*qia_Vdi_si_Tempt_GND));
#endif
T1_Tempt_GND=(AIGC_t_Tempt_GND-(BIGC_i*qia_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGC_i*0.0));
  T1_Tempt_GND_Vsi_s=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGC_i*0.0));
  T1_Tempt_GND_Vge_di=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGC_i*0.0));
  T1_Tempt_GND_Vge_e=(+0.0-(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+BIGC_i*0.0));
  T1_Tempt_GND_Ve_si=(+0.0-(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+BIGC_i*qia_Tempt_GND_Ve_si));
  T1_Tempt_GND_Ve_di=(+0.0-(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+BIGC_i*qia_Tempt_GND_Ve_di));
  T1_Tempt_GND_Vge_si=(+0.0-(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+BIGC_i*qia_Tempt_GND_Vge_si));
  T1_Tempt_GND_Vdi_si=(+0.0-(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+BIGC_i*qia_Tempt_GND_Vdi_si));
  T1_Tempt_GND_Tempt_GND=(+AIGC_t_Tempt_GND_Tempt_GND-(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+BIGC_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T1=(AIGC_t-(BIGC_i*qia));
EXIT_IF_ISNAN((AIGC_t-(BIGC_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=(CIGC_i*qia_Vge_si);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGC_i*0.0));
  T2_Vge_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGC_i*0.0));
  T2_Vge_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGC_i*0.0));
  T2_Vge_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vge_si+CIGC_i*0.0));
  T2_Vge_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vge_si+CIGC_i*qia_Vge_si_Vge_si));
  T2_Vge_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vge_si+CIGC_i*qia_Vge_si_Ve_si));
  T2_Vge_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vge_si+CIGC_i*qia_Vge_si_Ve_di));
  T2_Vge_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vge_si+CIGC_i*qia_Vge_si_Vdi_si));
  T2_Vge_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vge_si+CIGC_i*qia_Vge_si_Tempt_GND));
#endif
T2_Ve_si=(CIGC_i*qia_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGC_i*0.0));
  T2_Ve_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGC_i*0.0));
  T2_Ve_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGC_i*0.0));
  T2_Ve_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_si+CIGC_i*0.0));
  T2_Ve_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_si+CIGC_i*qia_Ve_si_Vge_si));
  T2_Ve_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_si+CIGC_i*qia_Ve_si_Ve_si));
  T2_Ve_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_si+CIGC_i*qia_Ve_si_Ve_di));
  T2_Ve_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_si+CIGC_i*qia_Ve_si_Vdi_si));
  T2_Ve_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_si+CIGC_i*qia_Ve_si_Tempt_GND));
#endif
T2_Ve_di=(CIGC_i*qia_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGC_i*0.0));
  T2_Ve_di_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGC_i*0.0));
  T2_Ve_di_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGC_i*0.0));
  T2_Ve_di_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Ve_di+CIGC_i*0.0));
  T2_Ve_di_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Ve_di+CIGC_i*qia_Ve_di_Vge_si));
  T2_Ve_di_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Ve_di+CIGC_i*qia_Ve_di_Ve_si));
  T2_Ve_di_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Ve_di+CIGC_i*qia_Ve_di_Ve_di));
  T2_Ve_di_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Ve_di+CIGC_i*qia_Ve_di_Vdi_si));
  T2_Ve_di_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Ve_di+CIGC_i*qia_Ve_di_Tempt_GND));
#endif
T2_Vdi_si=(CIGC_i*qia_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGC_i*0.0));
  T2_Vdi_si_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGC_i*0.0));
  T2_Vdi_si_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGC_i*0.0));
  T2_Vdi_si_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Vdi_si+CIGC_i*0.0));
  T2_Vdi_si_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Vdi_si+CIGC_i*qia_Vdi_si_Vge_si));
  T2_Vdi_si_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Vdi_si+CIGC_i*qia_Vdi_si_Ve_si));
  T2_Vdi_si_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Vdi_si+CIGC_i*qia_Vdi_si_Ve_di));
  T2_Vdi_si_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Vdi_si+CIGC_i*qia_Vdi_si_Vdi_si));
  T2_Vdi_si_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Vdi_si+CIGC_i*qia_Vdi_si_Tempt_GND));
#endif
T2_Tempt_GND=(CIGC_i*qia_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGC_i*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGC_i*0.0));
  T2_Tempt_GND_Vge_di=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGC_i*0.0));
  T2_Tempt_GND_Vge_e=(+0.0+(+0.0*qia+0.0*0.0+0.0*qia_Tempt_GND+CIGC_i*0.0));
  T2_Tempt_GND_Vge_si=(+0.0+(+0.0*qia+0.0*qia_Vge_si+0.0*qia_Tempt_GND+CIGC_i*qia_Tempt_GND_Vge_si));
  T2_Tempt_GND_Ve_si=(+0.0+(+0.0*qia+0.0*qia_Ve_si+0.0*qia_Tempt_GND+CIGC_i*qia_Tempt_GND_Ve_si));
  T2_Tempt_GND_Ve_di=(+0.0+(+0.0*qia+0.0*qia_Ve_di+0.0*qia_Tempt_GND+CIGC_i*qia_Tempt_GND_Ve_di));
  T2_Tempt_GND_Vdi_si=(+0.0+(+0.0*qia+0.0*qia_Vdi_si+0.0*qia_Tempt_GND+CIGC_i*qia_Tempt_GND_Vdi_si));
  T2_Tempt_GND_Tempt_GND=(+0.0+(+0.0*qia+0.0*qia_Tempt_GND+0.0*qia_Tempt_GND+CIGC_i*qia_Tempt_GND_Tempt_GND));
#endif
#endif
T2=(1.0+(CIGC_i*qia));
EXIT_IF_ISNAN((1.0+(CIGC_i*qia)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=(((((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+((-Bechvb)*pModel->TOXG)*T1_Vge_di_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Vge_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_di_Tempt_GND);
#endif
T3_Vge_e=(((((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+((-Bechvb)*pModel->TOXG)*T1_Vge_e_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Vge_e+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=(((((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+((-Bechvb)*pModel->TOXG)*T1_Vdi_si_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Vdi_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=(((((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+((-Bechvb)*pModel->TOXG)*T1_Ve_si_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Ve_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_si_Tempt_GND);
#endif
T3_Ve_di=(((((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+((-Bechvb)*pModel->TOXG)*T1_Ve_di_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Ve_di+(((-Bechvb)*pModel->TOXG)*T1)*T2_Ve_di_Tempt_GND);
#endif
T3_Vge_si=(((((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+((-Bechvb)*pModel->TOXG)*T1_Vge_si_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Vge_si+(((-Bechvb)*pModel->TOXG)*T1)*T2_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=(((((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2)+((((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vdi_d)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vdi_d+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_d)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vsi_s)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vsi_s+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vsi_s)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vge_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vge_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_di)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vge_e)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vge_e+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_e)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vdi_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vdi_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vdi_si)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Ve_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Ve_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_si)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Ve_di)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Ve_di+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Ve_di)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Vge_si)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Vge_si+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Vge_si)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+((-Bechvb)*pModel->TOXG)*T1_Tempt_GND_Tempt_GND)*T2+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)*T2_Tempt_GND+((((0.0)*T1)+(((-Bechvb)*pModel->TOXG)*T1_Tempt_GND)))*T2_Tempt_GND+(((-Bechvb)*pModel->TOXG)*T1)*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T3=((((-Bechvb)*pModel->TOXG)*T1)*T2);
EXIT_IF_ISNAN(((((-Bechvb)*pModel->TOXG)*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=(qia*bsimcmg_d_lexp(T3,T3_Vge_di));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Vge_di);
  T4_Vge_di_Vge_e=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Vge_e);
  T4_Vge_di_Vdi_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Vdi_si);
  T4_Vge_di_Ve_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Ve_si);
  T4_Vge_di_Ve_di=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Ve_di);
  T4_Vge_di_Vge_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Vge_si);
  T4_Vge_di_Tempt_GND=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_di)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Vge_di)+qia*T3_Vge_di_Tempt_GND);
#endif
T4_Vge_e=(qia*bsimcmg_d_lexp(T3,T3_Vge_e));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Vge_di);
  T4_Vge_e_Vge_e=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Vge_e);
  T4_Vge_e_Vdi_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Vdi_si);
  T4_Vge_e_Ve_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Ve_si);
  T4_Vge_e_Ve_di=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Ve_di);
  T4_Vge_e_Vge_si=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Vge_si);
  T4_Vge_e_Tempt_GND=(+0.0*bsimcmg_lexp(T3)+0.0*bsimcmg_d_lexp(T3,T3_Vge_e)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Vge_e)+qia*T3_Vge_e_Tempt_GND);
#endif
T4_Vdi_si=((qia_Vdi_si*bsimcmg_lexp(T3))+(qia*bsimcmg_d_lexp(T3,T3_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+0.0*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Vge_di);
  T4_Vdi_si_Vge_e=(+0.0*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+0.0*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Vge_e);
  T4_Vdi_si_Vdi_si=(+qia_Vdi_si_Vdi_si*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Vdi_si);
  T4_Vdi_si_Ve_si=(+qia_Vdi_si_Ve_si*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Ve_si);
  T4_Vdi_si_Ve_di=(+qia_Vdi_si_Ve_di*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Ve_di);
  T4_Vdi_si_Vge_si=(+qia_Vdi_si_Vge_si*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Vge_si);
  T4_Vdi_si_Tempt_GND=(+qia_Vdi_si_Tempt_GND*bsimcmg_lexp(T3)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Vdi_si)+qia*T3_Vdi_si_Tempt_GND);
#endif
T4_Ve_si=((qia_Ve_si*bsimcmg_lexp(T3))+(qia*bsimcmg_d_lexp(T3,T3_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+0.0*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Vge_di);
  T4_Ve_si_Vge_e=(+0.0*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+0.0*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Vge_e);
  T4_Ve_si_Vdi_si=(+qia_Ve_si_Vdi_si*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Vdi_si);
  T4_Ve_si_Ve_si=(+qia_Ve_si_Ve_si*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+qia_Ve_si_Ve_di*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Ve_di);
  T4_Ve_si_Vge_si=(+qia_Ve_si_Vge_si*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Vge_si);
  T4_Ve_si_Tempt_GND=(+qia_Ve_si_Tempt_GND*bsimcmg_lexp(T3)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_si)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Ve_si)+qia*T3_Ve_si_Tempt_GND);
#endif
T4_Ve_di=((qia_Ve_di*bsimcmg_lexp(T3))+(qia*bsimcmg_d_lexp(T3,T3_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+0.0*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Vge_di);
  T4_Ve_di_Vge_e=(+0.0*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+0.0*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Vge_e);
  T4_Ve_di_Vdi_si=(+qia_Ve_di_Vdi_si*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Vdi_si);
  T4_Ve_di_Ve_si=(+qia_Ve_di_Ve_si*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Ve_si);
  T4_Ve_di_Ve_di=(+qia_Ve_di_Ve_di*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+qia_Ve_di_Vge_si*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Vge_si);
  T4_Ve_di_Tempt_GND=(+qia_Ve_di_Tempt_GND*bsimcmg_lexp(T3)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Ve_di)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Ve_di)+qia*T3_Ve_di_Tempt_GND);
#endif
T4_Vge_si=((qia_Vge_si*bsimcmg_lexp(T3))+(qia*bsimcmg_d_lexp(T3,T3_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+0.0*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Vge_di);
  T4_Vge_si_Vge_e=(+0.0*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+0.0*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Vge_e);
  T4_Vge_si_Vdi_si=(+qia_Vge_si_Vdi_si*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Vdi_si);
  T4_Vge_si_Ve_si=(+qia_Vge_si_Ve_si*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Ve_si);
  T4_Vge_si_Ve_di=(+qia_Vge_si_Ve_di*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Ve_di);
  T4_Vge_si_Vge_si=(+qia_Vge_si_Vge_si*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Vge_si);
  T4_Vge_si_Tempt_GND=(+qia_Vge_si_Tempt_GND*bsimcmg_lexp(T3)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Vge_si)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Vge_si)+qia*T3_Vge_si_Tempt_GND);
#endif
T4_Tempt_GND=((qia_Tempt_GND*bsimcmg_lexp(T3))+(qia*bsimcmg_d_lexp(T3,T3_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+0.0*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Vge_di);
  T4_Tempt_GND_Vge_e=(+0.0*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+0.0*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Vge_e);
  T4_Tempt_GND_Vdi_si=(+qia_Tempt_GND_Vdi_si*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia_Vdi_si*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Vdi_si);
  T4_Tempt_GND_Ve_si=(+qia_Tempt_GND_Ve_si*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia_Ve_si*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Ve_si);
  T4_Tempt_GND_Ve_di=(+qia_Tempt_GND_Ve_di*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia_Ve_di*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Ve_di);
  T4_Tempt_GND_Vge_si=(+qia_Tempt_GND_Vge_si*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia_Vge_si*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Vge_si);
  T4_Tempt_GND_Tempt_GND=(+qia_Tempt_GND_Tempt_GND*bsimcmg_lexp(T3)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia_Tempt_GND*bsimcmg_d_lexp(T3,T3_Tempt_GND)+qia*T3_Tempt_GND_Tempt_GND);
#endif
#endif
T4=(qia*bsimcmg_lexp(T3));
EXIT_IF_ISNAN((qia*bsimcmg_lexp(T3)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=vge_Vge_e;
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Vdi_d=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Vsi_s=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Vge_e=(+(+vge_Vge_e_Vge_e+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Vdi_si=(+(+0.0+(+0.0*vdsx+0.0*vdsx_Vdi_si+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Ve_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ves_jct_Ve_si+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Ve_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ved_jct_Ve_di+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Vge_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vge_e_Tempt_GND=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
#endif
T5_Vdi_si=(0.5*vdsx_Vdi_si);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Vdi_d=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Vsi_s=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Vge_e=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Vdi_si=(+(+0.0+(+0.0*vdsx+0.0*vdsx_Vdi_si+0.0*vdsx_Vdi_si+0.5*vdsx_Vdi_si_Vdi_si))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Ve_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ves_jct_Ve_si+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Ve_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ved_jct_Ve_di+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Vge_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
  T5_Vdi_si_Tempt_GND=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*vdsx_Vdi_si+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*0.0+0.5*(+0.0+0.0)));
#endif
T5_Ve_si=(0.5*ves_jct_Ve_si);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Vdi_d=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Vsi_s=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Vge_e=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Vdi_si=(+(+0.0+(+0.0*vdsx+0.0*vdsx_Vdi_si+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Ve_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ves_jct_Ve_si+0.0*ves_jct_Ve_si+0.5*(+ves_jct_Ve_si_Ve_si+0.0)));
  T5_Ve_si_Ve_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ved_jct_Ve_di+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Vge_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
  T5_Ve_si_Tempt_GND=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ves_jct_Ve_si+0.5*(+0.0+0.0)));
#endif
T5_Ve_di=(0.5*ved_jct_Ve_di);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Vdi_d=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Vsi_s=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Vge_e=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Vdi_si=(+(+0.0+(+0.0*vdsx+0.0*vdsx_Vdi_si+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Ve_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ves_jct_Ve_si+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Ve_di=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*ved_jct_Ve_di+0.0*ved_jct_Ve_di+0.5*(+0.0+ved_jct_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
  T5_Ve_di_Tempt_GND=(+(+0.0+(+0.0*vdsx+0.0*0.0+0.0*0.0+0.5*0.0))+(+0.0*(ves_jct+ved_jct)+0.0*0.0+0.0*ved_jct_Ve_di+0.5*(+0.0+0.0)));
#endif
T5_Vge_si=0.0;
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=0.0;
  T5_Vge_si_Vdi_d=0.0;
  T5_Vge_si_Vsi_s=0.0;
  T5_Vge_si_Vge_e=0.0;
  T5_Vge_si_Vdi_si=0.0;
  T5_Vge_si_Ve_si=0.0;
  T5_Vge_si_Ve_di=0.0;
  T5_Vge_si_Vge_si=0.0;
  T5_Vge_si_Tempt_GND=0.0;
#endif
T5_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=0.0;
  T5_Tempt_GND_Vdi_d=0.0;
  T5_Tempt_GND_Vsi_s=0.0;
  T5_Tempt_GND_Vge_e=0.0;
  T5_Tempt_GND_Vdi_si=0.0;
  T5_Tempt_GND_Ve_si=0.0;
  T5_Tempt_GND_Ve_di=0.0;
  T5_Tempt_GND_Vge_si=0.0;
  T5_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T5=((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct)));
EXIT_IF_ISNAN(((vge+(0.5*vdsx))+(0.5*(ves_jct+ved_jct))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
igc0_Vge_di=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*igtemp;
#if defined(_DERIVATE2)
  igc0_Vge_di_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_di_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_di+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Vge_e=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*igtemp;
#if defined(_DERIVATE2)
  igc0_Vge_e_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_e_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_e+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_e+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Vdi_si=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*igtemp;
#if defined(_DERIVATE2)
  igc0_Vdi_si_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_si_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vdi_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vdi_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Ve_si=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*igtemp;
#if defined(_DERIVATE2)
  igc0_Ve_si_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_si_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Ve_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Ve_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Ve_di=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*igtemp;
#if defined(_DERIVATE2)
  igc0_Ve_di_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Ve_di_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Ve_di+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Ve_di+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Vge_si=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*igtemp;
#if defined(_DERIVATE2)
  igc0_Vge_si_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vge_si_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Vge_si+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vge_si+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Tempt_GND=((((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*igtemp)+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp_Tempt_GND));
#if defined(_DERIVATE2)
  igc0_Tempt_GND_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Vge_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vge_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Vge_e)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vge_e)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Vdi_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vdi_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Ve_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Ve_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Ve_di)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Ve_di)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Vge_si)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vge_si)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND_Tempt_GND)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Tempt_GND)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp_Tempt_GND_Tempt_GND);
  igc0_Tempt_GND_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vdi_d)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Tempt_GND_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*T4_Tempt_GND+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND_Vsi_s)*igtemp+((((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND))*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*igtemp_Tempt_GND+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Vdi_d=(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*igtemp;
#if defined(_DERIVATE2)
  igc0_Vdi_d_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vge_di)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vge_e)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vdi_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Ve_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Ve_di)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vge_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Tempt_GND)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vdi_d)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vdi_d_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vdi_d+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d_Vsi_s)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
igc0_Vsi_s=(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*igtemp;
#if defined(_DERIVATE2)
  igc0_Vsi_s_Vge_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_di+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vge_di)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Vge_e=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_e+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_e+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vge_e)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_e)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_e)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Vdi_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vdi_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vdi_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vdi_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vdi_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Ve_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Ve_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Ve_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Ve_di=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Ve_di+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Ve_di+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Ve_di)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Ve_di)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Ve_di)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Vge_si=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Vge_si+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vge_si+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vge_si)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Vge_si)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vge_si)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Tempt_GND=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*T4_Tempt_GND+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Tempt_GND+((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Tempt_GND)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*igtemp_Tempt_GND+(((((((((0.0)*Aechvb)*Toxratio)*T4)+((((Weff0*Leff)*Aechvb)*Toxratio)*T4_Tempt_GND)))*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Tempt_GND)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Vdi_d=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vdi_d+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vdi_d)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vdi_d)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
  igc0_Vsi_s_Vsi_s=(+(+(+(+(+(+0.0*Leff+0.0*0.0+0.0*0.0+Weff0*0.0)*Aechvb+0.0*0.0+(0.0)*0.0+(Weff0*Leff)*0.0)*Toxratio+0.0*0.0+((0.0)*Aechvb)*0.0+((Weff0*Leff)*Aechvb)*0.0)*T4+0.0*0.0+(((0.0)*Aechvb)*Toxratio)*0.0+(((Weff0*Leff)*Aechvb)*Toxratio)*0.0)*T5+0.0*T5_Vsi_s+((((0.0)*Aechvb)*Toxratio)*T4)*T5_Vsi_s+((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s_Vsi_s)*igtemp+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)*0.0+(((((((0.0)*Aechvb)*Toxratio)*T4)*T5)+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5_Vsi_s)))*0.0+(((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*0.0);
#endif
#endif
igc0=((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp);
EXIT_IF_ISNAN(((((((Weff0*Leff)*Aechvb)*Toxratio)*T4)*T5)*igtemp))
{
double m00_sqrt(d00_sqrt0,((Vdseff*Vdseff)+0.01))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((Vdseff*Vdseff)+0.01))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Vdseffx_Vdi_si=((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Vdi_si_Vdi_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si)))*((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))+d10_sqrt0*(+(+Vdseff_Vdi_si_Vdi_si*Vdseff+Vdseff_Vdi_si*Vdseff_Vdi_si+Vdseff_Vdi_si*Vdseff_Vdi_si+Vdseff*Vdseff_Vdi_si_Vdi_si)+0.0))-0.0);
  Vdseffx_Vdi_si_Ve_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si)))*((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))+d10_sqrt0*(+(+Vdseff_Vdi_si_Ve_si*Vdseff+Vdseff_Vdi_si*Vdseff_Ve_si+Vdseff_Ve_si*Vdseff_Vdi_si+Vdseff*Vdseff_Vdi_si_Ve_si)+0.0))-0.0);
  Vdseffx_Vdi_si_Ve_di=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di)))*((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))+d10_sqrt0*(+(+Vdseff_Vdi_si_Ve_di*Vdseff+Vdseff_Vdi_si*Vdseff_Ve_di+Vdseff_Ve_di*Vdseff_Vdi_si+Vdseff*Vdseff_Vdi_si_Ve_di)+0.0))-0.0);
  Vdseffx_Vdi_si_Vge_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si)))*((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))+d10_sqrt0*(+(+Vdseff_Vdi_si_Vge_si*Vdseff+Vdseff_Vdi_si*Vdseff_Vge_si+Vdseff_Vge_si*Vdseff_Vdi_si+Vdseff*Vdseff_Vdi_si_Vge_si)+0.0))-0.0);
  Vdseffx_Vdi_si_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si))+d10_sqrt0*(+(+Vdseff_Vdi_si_Tempt_GND*Vdseff+Vdseff_Vdi_si*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Vdi_si+Vdseff*Vdseff_Vdi_si_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Ve_si=((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Ve_si_Vdi_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si)))*((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))+d10_sqrt0*(+(+Vdseff_Ve_si_Vdi_si*Vdseff+Vdseff_Ve_si*Vdseff_Vdi_si+Vdseff_Vdi_si*Vdseff_Ve_si+Vdseff*Vdseff_Ve_si_Vdi_si)+0.0))-0.0);
  Vdseffx_Ve_si_Ve_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si)))*((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))+d10_sqrt0*(+(+Vdseff_Ve_si_Ve_si*Vdseff+Vdseff_Ve_si*Vdseff_Ve_si+Vdseff_Ve_si*Vdseff_Ve_si+Vdseff*Vdseff_Ve_si_Ve_si)+0.0))-0.0);
  Vdseffx_Ve_si_Ve_di=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di)))*((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))+d10_sqrt0*(+(+Vdseff_Ve_si_Ve_di*Vdseff+Vdseff_Ve_si*Vdseff_Ve_di+Vdseff_Ve_di*Vdseff_Ve_si+Vdseff*Vdseff_Ve_si_Ve_di)+0.0))-0.0);
  Vdseffx_Ve_si_Vge_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si)))*((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))+d10_sqrt0*(+(+Vdseff_Ve_si_Vge_si*Vdseff+Vdseff_Ve_si*Vdseff_Vge_si+Vdseff_Vge_si*Vdseff_Ve_si+Vdseff*Vdseff_Ve_si_Vge_si)+0.0))-0.0);
  Vdseffx_Ve_si_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si))+d10_sqrt0*(+(+Vdseff_Ve_si_Tempt_GND*Vdseff+Vdseff_Ve_si*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Ve_si+Vdseff*Vdseff_Ve_si_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Ve_di=((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Ve_di_Vdi_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si)))*((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))+d10_sqrt0*(+(+Vdseff_Ve_di_Vdi_si*Vdseff+Vdseff_Ve_di*Vdseff_Vdi_si+Vdseff_Vdi_si*Vdseff_Ve_di+Vdseff*Vdseff_Ve_di_Vdi_si)+0.0))-0.0);
  Vdseffx_Ve_di_Ve_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si)))*((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))+d10_sqrt0*(+(+Vdseff_Ve_di_Ve_si*Vdseff+Vdseff_Ve_di*Vdseff_Ve_si+Vdseff_Ve_si*Vdseff_Ve_di+Vdseff*Vdseff_Ve_di_Ve_si)+0.0))-0.0);
  Vdseffx_Ve_di_Ve_di=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di)))*((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))+d10_sqrt0*(+(+Vdseff_Ve_di_Ve_di*Vdseff+Vdseff_Ve_di*Vdseff_Ve_di+Vdseff_Ve_di*Vdseff_Ve_di+Vdseff*Vdseff_Ve_di_Ve_di)+0.0))-0.0);
  Vdseffx_Ve_di_Vge_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si)))*((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))+d10_sqrt0*(+(+Vdseff_Ve_di_Vge_si*Vdseff+Vdseff_Ve_di*Vdseff_Vge_si+Vdseff_Vge_si*Vdseff_Ve_di+Vdseff*Vdseff_Ve_di_Vge_si)+0.0))-0.0);
  Vdseffx_Ve_di_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di))+d10_sqrt0*(+(+Vdseff_Ve_di_Tempt_GND*Vdseff+Vdseff_Ve_di*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Ve_di+Vdseff*Vdseff_Ve_di_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Vge_si=((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Vge_si_Vdi_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si)))*((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))+d10_sqrt0*(+(+Vdseff_Vge_si_Vdi_si*Vdseff+Vdseff_Vge_si*Vdseff_Vdi_si+Vdseff_Vdi_si*Vdseff_Vge_si+Vdseff*Vdseff_Vge_si_Vdi_si)+0.0))-0.0);
  Vdseffx_Vge_si_Ve_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si)))*((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))+d10_sqrt0*(+(+Vdseff_Vge_si_Ve_si*Vdseff+Vdseff_Vge_si*Vdseff_Ve_si+Vdseff_Ve_si*Vdseff_Vge_si+Vdseff*Vdseff_Vge_si_Ve_si)+0.0))-0.0);
  Vdseffx_Vge_si_Ve_di=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di)))*((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))+d10_sqrt0*(+(+Vdseff_Vge_si_Ve_di*Vdseff+Vdseff_Vge_si*Vdseff_Ve_di+Vdseff_Ve_di*Vdseff_Vge_si+Vdseff*Vdseff_Vge_si_Ve_di)+0.0))-0.0);
  Vdseffx_Vge_si_Vge_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si)))*((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))+d10_sqrt0*(+(+Vdseff_Vge_si_Vge_si*Vdseff+Vdseff_Vge_si*Vdseff_Vge_si+Vdseff_Vge_si*Vdseff_Vge_si+Vdseff*Vdseff_Vge_si_Vge_si)+0.0))-0.0);
  Vdseffx_Vge_si_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si))+d10_sqrt0*(+(+Vdseff_Vge_si_Tempt_GND*Vdseff+Vdseff_Vge_si*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Vge_si+Vdseff*Vdseff_Vge_si_Tempt_GND)+0.0))-0.0);
#endif
Vdseffx_Tempt_GND=((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  Vdseffx_Tempt_GND_Vdi_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vdi_si*Vdseff)+(Vdseff*Vdseff_Vdi_si)))*((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))+d10_sqrt0*(+(+Vdseff_Tempt_GND_Vdi_si*Vdseff+Vdseff_Tempt_GND*Vdseff_Vdi_si+Vdseff_Vdi_si*Vdseff_Tempt_GND+Vdseff*Vdseff_Tempt_GND_Vdi_si)+0.0))-0.0);
  Vdseffx_Tempt_GND_Ve_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_si*Vdseff)+(Vdseff*Vdseff_Ve_si)))*((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))+d10_sqrt0*(+(+Vdseff_Tempt_GND_Ve_si*Vdseff+Vdseff_Tempt_GND*Vdseff_Ve_si+Vdseff_Ve_si*Vdseff_Tempt_GND+Vdseff*Vdseff_Tempt_GND_Ve_si)+0.0))-0.0);
  Vdseffx_Tempt_GND_Ve_di=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Ve_di*Vdseff)+(Vdseff*Vdseff_Ve_di)))*((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))+d10_sqrt0*(+(+Vdseff_Tempt_GND_Ve_di*Vdseff+Vdseff_Tempt_GND*Vdseff_Ve_di+Vdseff_Ve_di*Vdseff_Tempt_GND+Vdseff*Vdseff_Tempt_GND_Ve_di)+0.0))-0.0);
  Vdseffx_Tempt_GND_Vge_si=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Vge_si*Vdseff)+(Vdseff*Vdseff_Vge_si)))*((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))+d10_sqrt0*(+(+Vdseff_Tempt_GND_Vge_si*Vdseff+Vdseff_Tempt_GND*Vdseff_Vge_si+Vdseff_Vge_si*Vdseff_Tempt_GND+Vdseff*Vdseff_Tempt_GND_Vge_si)+0.0))-0.0);
  Vdseffx_Tempt_GND_Tempt_GND=(+(m20_sqrt(((Vdseff*Vdseff)+0.01))*(((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND)))*((Vdseff_Tempt_GND*Vdseff)+(Vdseff*Vdseff_Tempt_GND))+d10_sqrt0*(+(+Vdseff_Tempt_GND_Tempt_GND*Vdseff+Vdseff_Tempt_GND*Vdseff_Tempt_GND+Vdseff_Tempt_GND*Vdseff_Tempt_GND+Vdseff*Vdseff_Tempt_GND_Tempt_GND)+0.0))-0.0);
#endif
#endif
Vdseffx=(d00_sqrt0-0.1);
EXIT_IF_ISNAN((d00_sqrt0-0.1))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(PIGCD_i*Vdseffx_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_si+PIGCD_i*0.0);
  T1_Ve_si_Vsi_s=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_si+PIGCD_i*0.0);
  T1_Ve_si_Vge_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_si+PIGCD_i*0.0);
  T1_Ve_si_Vge_e=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_si+PIGCD_i*0.0);
  T1_Ve_si_Ve_si=(+0.0*Vdseffx+0.0*Vdseffx_Ve_si+0.0*Vdseffx_Ve_si+PIGCD_i*Vdseffx_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+0.0*Vdseffx+0.0*Vdseffx_Ve_di+0.0*Vdseffx_Ve_si+PIGCD_i*Vdseffx_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+0.0*Vdseffx+0.0*Vdseffx_Vge_si+0.0*Vdseffx_Ve_si+PIGCD_i*Vdseffx_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_si+0.0*Vdseffx_Ve_si+PIGCD_i*Vdseffx_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Ve_si+PIGCD_i*Vdseffx_Ve_si_Tempt_GND);
#endif
T1_Ve_di=(PIGCD_i*Vdseffx_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_di+PIGCD_i*0.0);
  T1_Ve_di_Vsi_s=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_di+PIGCD_i*0.0);
  T1_Ve_di_Vge_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_di+PIGCD_i*0.0);
  T1_Ve_di_Vge_e=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Ve_di+PIGCD_i*0.0);
  T1_Ve_di_Ve_si=(+0.0*Vdseffx+0.0*Vdseffx_Ve_si+0.0*Vdseffx_Ve_di+PIGCD_i*Vdseffx_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+0.0*Vdseffx+0.0*Vdseffx_Ve_di+0.0*Vdseffx_Ve_di+PIGCD_i*Vdseffx_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+0.0*Vdseffx+0.0*Vdseffx_Vge_si+0.0*Vdseffx_Ve_di+PIGCD_i*Vdseffx_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_si+0.0*Vdseffx_Ve_di+PIGCD_i*Vdseffx_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Ve_di+PIGCD_i*Vdseffx_Ve_di_Tempt_GND);
#endif
T1_Vge_si=(PIGCD_i*Vdseffx_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vge_si+PIGCD_i*0.0);
  T1_Vge_si_Vsi_s=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vge_si+PIGCD_i*0.0);
  T1_Vge_si_Vge_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vge_si+PIGCD_i*0.0);
  T1_Vge_si_Vge_e=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vge_si+PIGCD_i*0.0);
  T1_Vge_si_Ve_si=(+0.0*Vdseffx+0.0*Vdseffx_Ve_si+0.0*Vdseffx_Vge_si+PIGCD_i*Vdseffx_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+0.0*Vdseffx+0.0*Vdseffx_Ve_di+0.0*Vdseffx_Vge_si+PIGCD_i*Vdseffx_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+0.0*Vdseffx+0.0*Vdseffx_Vge_si+0.0*Vdseffx_Vge_si+PIGCD_i*Vdseffx_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_si+0.0*Vdseffx_Vge_si+PIGCD_i*Vdseffx_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Vge_si+PIGCD_i*Vdseffx_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=(PIGCD_i*Vdseffx_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_si+PIGCD_i*0.0);
  T1_Vdi_si_Vsi_s=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_si+PIGCD_i*0.0);
  T1_Vdi_si_Vge_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_si+PIGCD_i*0.0);
  T1_Vdi_si_Vge_e=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Vdi_si+PIGCD_i*0.0);
  T1_Vdi_si_Ve_si=(+0.0*Vdseffx+0.0*Vdseffx_Ve_si+0.0*Vdseffx_Vdi_si+PIGCD_i*Vdseffx_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+0.0*Vdseffx+0.0*Vdseffx_Ve_di+0.0*Vdseffx_Vdi_si+PIGCD_i*Vdseffx_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+0.0*Vdseffx+0.0*Vdseffx_Vge_si+0.0*Vdseffx_Vdi_si+PIGCD_i*Vdseffx_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_si+0.0*Vdseffx_Vdi_si+PIGCD_i*Vdseffx_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Vdi_si+PIGCD_i*Vdseffx_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(PIGCD_i*Vdseffx_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Tempt_GND+PIGCD_i*0.0);
  T1_Tempt_GND_Vsi_s=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Tempt_GND+PIGCD_i*0.0);
  T1_Tempt_GND_Vge_di=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Tempt_GND+PIGCD_i*0.0);
  T1_Tempt_GND_Vge_e=(+0.0*Vdseffx+0.0*0.0+0.0*Vdseffx_Tempt_GND+PIGCD_i*0.0);
  T1_Tempt_GND_Ve_si=(+0.0*Vdseffx+0.0*Vdseffx_Ve_si+0.0*Vdseffx_Tempt_GND+PIGCD_i*Vdseffx_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+0.0*Vdseffx+0.0*Vdseffx_Ve_di+0.0*Vdseffx_Tempt_GND+PIGCD_i*Vdseffx_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+0.0*Vdseffx+0.0*Vdseffx_Vge_si+0.0*Vdseffx_Tempt_GND+PIGCD_i*Vdseffx_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+0.0*Vdseffx+0.0*Vdseffx_Vdi_si+0.0*Vdseffx_Tempt_GND+PIGCD_i*Vdseffx_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+0.0*Vdseffx+0.0*Vdseffx_Tempt_GND+0.0*Vdseffx_Tempt_GND+PIGCD_i*Vdseffx_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(PIGCD_i*Vdseffx);
EXIT_IF_ISNAN((PIGCD_i*Vdseffx))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_exp_Vge_di=bsimcmg_d_lexp((-T1),(-T1_Vge_di));
#if defined(_DERIVATE2)
  T1_exp_Vge_di_Vge_di=0.0;
  T1_exp_Vge_di_Vge_e=0.0;
  T1_exp_Vge_di_Ve_si=0.0;
  T1_exp_Vge_di_Ve_di=0.0;
  T1_exp_Vge_di_Vge_si=0.0;
  T1_exp_Vge_di_Vdi_si=0.0;
  T1_exp_Vge_di_Tempt_GND=0.0;
#endif
T1_exp_Vge_e=bsimcmg_d_lexp((-T1),(-T1_Vge_e));
#if defined(_DERIVATE2)
  T1_exp_Vge_e_Vge_di=0.0;
  T1_exp_Vge_e_Vge_e=0.0;
  T1_exp_Vge_e_Ve_si=0.0;
  T1_exp_Vge_e_Ve_di=0.0;
  T1_exp_Vge_e_Vge_si=0.0;
  T1_exp_Vge_e_Vdi_si=0.0;
  T1_exp_Vge_e_Tempt_GND=0.0;
#endif
T1_exp_Ve_si=bsimcmg_d_lexp((-T1),(-T1_Ve_si));
#if defined(_DERIVATE2)
  T1_exp_Ve_si_Vge_di=0.0;
  T1_exp_Ve_si_Vge_e=0.0;
  T1_exp_Ve_si_Ve_si=0.0;
  T1_exp_Ve_si_Ve_di=0.0;
  T1_exp_Ve_si_Vge_si=0.0;
  T1_exp_Ve_si_Vdi_si=0.0;
  T1_exp_Ve_si_Tempt_GND=0.0;
#endif
T1_exp_Ve_di=bsimcmg_d_lexp((-T1),(-T1_Ve_di));
#if defined(_DERIVATE2)
  T1_exp_Ve_di_Vge_di=0.0;
  T1_exp_Ve_di_Vge_e=0.0;
  T1_exp_Ve_di_Ve_si=0.0;
  T1_exp_Ve_di_Ve_di=0.0;
  T1_exp_Ve_di_Vge_si=0.0;
  T1_exp_Ve_di_Vdi_si=0.0;
  T1_exp_Ve_di_Tempt_GND=0.0;
#endif
T1_exp_Vge_si=bsimcmg_d_lexp((-T1),(-T1_Vge_si));
#if defined(_DERIVATE2)
  T1_exp_Vge_si_Vge_di=0.0;
  T1_exp_Vge_si_Vge_e=0.0;
  T1_exp_Vge_si_Ve_si=0.0;
  T1_exp_Vge_si_Ve_di=0.0;
  T1_exp_Vge_si_Vge_si=0.0;
  T1_exp_Vge_si_Vdi_si=0.0;
  T1_exp_Vge_si_Tempt_GND=0.0;
#endif
T1_exp_Vdi_si=bsimcmg_d_lexp((-T1),(-T1_Vdi_si));
#if defined(_DERIVATE2)
  T1_exp_Vdi_si_Vge_di=0.0;
  T1_exp_Vdi_si_Vge_e=0.0;
  T1_exp_Vdi_si_Ve_si=0.0;
  T1_exp_Vdi_si_Ve_di=0.0;
  T1_exp_Vdi_si_Vge_si=0.0;
  T1_exp_Vdi_si_Vdi_si=0.0;
  T1_exp_Vdi_si_Tempt_GND=0.0;
#endif
T1_exp_Tempt_GND=bsimcmg_d_lexp((-T1),(-T1_Tempt_GND));
#if defined(_DERIVATE2)
  T1_exp_Tempt_GND_Vge_di=0.0;
  T1_exp_Tempt_GND_Vge_e=0.0;
  T1_exp_Tempt_GND_Ve_si=0.0;
  T1_exp_Tempt_GND_Ve_di=0.0;
  T1_exp_Tempt_GND_Vge_si=0.0;
  T1_exp_Tempt_GND_Vdi_si=0.0;
  T1_exp_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1_exp=bsimcmg_lexp((-T1));
EXIT_IF_ISNAN(bsimcmg_lexp((-T1)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=(T1_Vge_di+T1_exp_Vge_di);
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+(+(+T1_Vge_di_Vdi_d+0.0)-0.0)+0.0);
  T3_Vge_di_Vsi_s=(+(+(+T1_Vge_di_Vsi_s+0.0)-0.0)+0.0);
  T3_Vge_di_Vge_di=(+(+(+T1_Vge_di_Vge_di+T1_exp_Vge_di_Vge_di)-0.0)+0.0);
  T3_Vge_di_Vge_e=(+(+(+T1_Vge_di_Vge_e+T1_exp_Vge_di_Vge_e)-0.0)+0.0);
  T3_Vge_di_Vdi_si=(+(+(+T1_Vge_di_Vdi_si+T1_exp_Vge_di_Vdi_si)-0.0)+0.0);
  T3_Vge_di_Ve_si=(+(+(+T1_Vge_di_Ve_si+T1_exp_Vge_di_Ve_si)-0.0)+0.0);
  T3_Vge_di_Ve_di=(+(+(+T1_Vge_di_Ve_di+T1_exp_Vge_di_Ve_di)-0.0)+0.0);
  T3_Vge_di_Vge_si=(+(+(+T1_Vge_di_Vge_si+T1_exp_Vge_di_Vge_si)-0.0)+0.0);
  T3_Vge_di_Tempt_GND=(+(+(+T1_Vge_di_Tempt_GND+T1_exp_Vge_di_Tempt_GND)-0.0)+0.0);
#endif
T3_Vge_e=(T1_Vge_e+T1_exp_Vge_e);
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+T1_Vge_e_Vdi_d+0.0)-0.0)+0.0);
  T3_Vge_e_Vsi_s=(+(+(+T1_Vge_e_Vsi_s+0.0)-0.0)+0.0);
  T3_Vge_e_Vge_di=(+(+(+T1_Vge_e_Vge_di+T1_exp_Vge_e_Vge_di)-0.0)+0.0);
  T3_Vge_e_Vge_e=(+(+(+T1_Vge_e_Vge_e+T1_exp_Vge_e_Vge_e)-0.0)+0.0);
  T3_Vge_e_Vdi_si=(+(+(+T1_Vge_e_Vdi_si+T1_exp_Vge_e_Vdi_si)-0.0)+0.0);
  T3_Vge_e_Ve_si=(+(+(+T1_Vge_e_Ve_si+T1_exp_Vge_e_Ve_si)-0.0)+0.0);
  T3_Vge_e_Ve_di=(+(+(+T1_Vge_e_Ve_di+T1_exp_Vge_e_Ve_di)-0.0)+0.0);
  T3_Vge_e_Vge_si=(+(+(+T1_Vge_e_Vge_si+T1_exp_Vge_e_Vge_si)-0.0)+0.0);
  T3_Vge_e_Tempt_GND=(+(+(+T1_Vge_e_Tempt_GND+T1_exp_Vge_e_Tempt_GND)-0.0)+0.0);
#endif
T3_Vdi_si=(T1_Vdi_si+T1_exp_Vdi_si);
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+T1_Vdi_si_Vdi_d+0.0)-0.0)+0.0);
  T3_Vdi_si_Vsi_s=(+(+(+T1_Vdi_si_Vsi_s+0.0)-0.0)+0.0);
  T3_Vdi_si_Vge_di=(+(+(+T1_Vdi_si_Vge_di+T1_exp_Vdi_si_Vge_di)-0.0)+0.0);
  T3_Vdi_si_Vge_e=(+(+(+T1_Vdi_si_Vge_e+T1_exp_Vdi_si_Vge_e)-0.0)+0.0);
  T3_Vdi_si_Vdi_si=(+(+(+T1_Vdi_si_Vdi_si+T1_exp_Vdi_si_Vdi_si)-0.0)+0.0);
  T3_Vdi_si_Ve_si=(+(+(+T1_Vdi_si_Ve_si+T1_exp_Vdi_si_Ve_si)-0.0)+0.0);
  T3_Vdi_si_Ve_di=(+(+(+T1_Vdi_si_Ve_di+T1_exp_Vdi_si_Ve_di)-0.0)+0.0);
  T3_Vdi_si_Vge_si=(+(+(+T1_Vdi_si_Vge_si+T1_exp_Vdi_si_Vge_si)-0.0)+0.0);
  T3_Vdi_si_Tempt_GND=(+(+(+T1_Vdi_si_Tempt_GND+T1_exp_Vdi_si_Tempt_GND)-0.0)+0.0);
#endif
T3_Ve_si=(T1_Ve_si+T1_exp_Ve_si);
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+T1_Ve_si_Vdi_d+0.0)-0.0)+0.0);
  T3_Ve_si_Vsi_s=(+(+(+T1_Ve_si_Vsi_s+0.0)-0.0)+0.0);
  T3_Ve_si_Vge_di=(+(+(+T1_Ve_si_Vge_di+T1_exp_Ve_si_Vge_di)-0.0)+0.0);
  T3_Ve_si_Vge_e=(+(+(+T1_Ve_si_Vge_e+T1_exp_Ve_si_Vge_e)-0.0)+0.0);
  T3_Ve_si_Vdi_si=(+(+(+T1_Ve_si_Vdi_si+T1_exp_Ve_si_Vdi_si)-0.0)+0.0);
  T3_Ve_si_Ve_si=(+(+(+T1_Ve_si_Ve_si+T1_exp_Ve_si_Ve_si)-0.0)+0.0);
  T3_Ve_si_Ve_di=(+(+(+T1_Ve_si_Ve_di+T1_exp_Ve_si_Ve_di)-0.0)+0.0);
  T3_Ve_si_Vge_si=(+(+(+T1_Ve_si_Vge_si+T1_exp_Ve_si_Vge_si)-0.0)+0.0);
  T3_Ve_si_Tempt_GND=(+(+(+T1_Ve_si_Tempt_GND+T1_exp_Ve_si_Tempt_GND)-0.0)+0.0);
#endif
T3_Ve_di=(T1_Ve_di+T1_exp_Ve_di);
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+T1_Ve_di_Vdi_d+0.0)-0.0)+0.0);
  T3_Ve_di_Vsi_s=(+(+(+T1_Ve_di_Vsi_s+0.0)-0.0)+0.0);
  T3_Ve_di_Vge_di=(+(+(+T1_Ve_di_Vge_di+T1_exp_Ve_di_Vge_di)-0.0)+0.0);
  T3_Ve_di_Vge_e=(+(+(+T1_Ve_di_Vge_e+T1_exp_Ve_di_Vge_e)-0.0)+0.0);
  T3_Ve_di_Vdi_si=(+(+(+T1_Ve_di_Vdi_si+T1_exp_Ve_di_Vdi_si)-0.0)+0.0);
  T3_Ve_di_Ve_si=(+(+(+T1_Ve_di_Ve_si+T1_exp_Ve_di_Ve_si)-0.0)+0.0);
  T3_Ve_di_Ve_di=(+(+(+T1_Ve_di_Ve_di+T1_exp_Ve_di_Ve_di)-0.0)+0.0);
  T3_Ve_di_Vge_si=(+(+(+T1_Ve_di_Vge_si+T1_exp_Ve_di_Vge_si)-0.0)+0.0);
  T3_Ve_di_Tempt_GND=(+(+(+T1_Ve_di_Tempt_GND+T1_exp_Ve_di_Tempt_GND)-0.0)+0.0);
#endif
T3_Vge_si=(T1_Vge_si+T1_exp_Vge_si);
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+T1_Vge_si_Vdi_d+0.0)-0.0)+0.0);
  T3_Vge_si_Vsi_s=(+(+(+T1_Vge_si_Vsi_s+0.0)-0.0)+0.0);
  T3_Vge_si_Vge_di=(+(+(+T1_Vge_si_Vge_di+T1_exp_Vge_si_Vge_di)-0.0)+0.0);
  T3_Vge_si_Vge_e=(+(+(+T1_Vge_si_Vge_e+T1_exp_Vge_si_Vge_e)-0.0)+0.0);
  T3_Vge_si_Vdi_si=(+(+(+T1_Vge_si_Vdi_si+T1_exp_Vge_si_Vdi_si)-0.0)+0.0);
  T3_Vge_si_Ve_si=(+(+(+T1_Vge_si_Ve_si+T1_exp_Vge_si_Ve_si)-0.0)+0.0);
  T3_Vge_si_Ve_di=(+(+(+T1_Vge_si_Ve_di+T1_exp_Vge_si_Ve_di)-0.0)+0.0);
  T3_Vge_si_Vge_si=(+(+(+T1_Vge_si_Vge_si+T1_exp_Vge_si_Vge_si)-0.0)+0.0);
  T3_Vge_si_Tempt_GND=(+(+(+T1_Vge_si_Tempt_GND+T1_exp_Vge_si_Tempt_GND)-0.0)+0.0);
#endif
T3_Tempt_GND=(T1_Tempt_GND+T1_exp_Tempt_GND);
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+T1_Tempt_GND_Vdi_d+0.0)-0.0)+0.0);
  T3_Tempt_GND_Vsi_s=(+(+(+T1_Tempt_GND_Vsi_s+0.0)-0.0)+0.0);
  T3_Tempt_GND_Vge_di=(+(+(+T1_Tempt_GND_Vge_di+T1_exp_Tempt_GND_Vge_di)-0.0)+0.0);
  T3_Tempt_GND_Vge_e=(+(+(+T1_Tempt_GND_Vge_e+T1_exp_Tempt_GND_Vge_e)-0.0)+0.0);
  T3_Tempt_GND_Vdi_si=(+(+(+T1_Tempt_GND_Vdi_si+T1_exp_Tempt_GND_Vdi_si)-0.0)+0.0);
  T3_Tempt_GND_Ve_si=(+(+(+T1_Tempt_GND_Ve_si+T1_exp_Tempt_GND_Ve_si)-0.0)+0.0);
  T3_Tempt_GND_Ve_di=(+(+(+T1_Tempt_GND_Ve_di+T1_exp_Tempt_GND_Ve_di)-0.0)+0.0);
  T3_Tempt_GND_Vge_si=(+(+(+T1_Tempt_GND_Vge_si+T1_exp_Tempt_GND_Vge_si)-0.0)+0.0);
  T3_Tempt_GND_Tempt_GND=(+(+(+T1_Tempt_GND_Tempt_GND+T1_exp_Tempt_GND_Tempt_GND)-0.0)+0.0);
#endif
#endif
T3=(((T1+T1_exp)-1.0)+1.0e-4);
EXIT_IF_ISNAN((((T1+T1_exp)-1.0)+1.0e-4))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=(-((T1_Vge_di*T1_exp)+((T1+1.0)*T1_exp_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+0.0-(+(+T1_Vge_di_Vge_di+0.0)*T1_exp+T1_Vge_di*T1_exp_Vge_di+T1_Vge_di*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Vge_di))+0.0);
  T4_Vge_di_Vge_e=(+(+0.0-(+(+T1_Vge_di_Vge_e+0.0)*T1_exp+T1_Vge_di*T1_exp_Vge_e+T1_Vge_e*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Vge_e))+0.0);
  T4_Vge_di_Vdi_si=(+(+0.0-(+(+T1_Vge_di_Vdi_si+0.0)*T1_exp+T1_Vge_di*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Vdi_si))+0.0);
  T4_Vge_di_Ve_si=(+(+0.0-(+(+T1_Vge_di_Ve_si+0.0)*T1_exp+T1_Vge_di*T1_exp_Ve_si+T1_Ve_si*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Ve_si))+0.0);
  T4_Vge_di_Ve_di=(+(+0.0-(+(+T1_Vge_di_Ve_di+0.0)*T1_exp+T1_Vge_di*T1_exp_Ve_di+T1_Ve_di*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Ve_di))+0.0);
  T4_Vge_di_Vge_si=(+(+0.0-(+(+T1_Vge_di_Vge_si+0.0)*T1_exp+T1_Vge_di*T1_exp_Vge_si+T1_Vge_si*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Vge_si))+0.0);
  T4_Vge_di_Tempt_GND=(+(+0.0-(+(+T1_Vge_di_Tempt_GND+0.0)*T1_exp+T1_Vge_di*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vge_di+(T1+1.0)*T1_exp_Vge_di_Tempt_GND))+0.0);
#endif
T4_Vge_e=(-((T1_Vge_e*T1_exp)+((T1+1.0)*T1_exp_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+0.0-(+(+T1_Vge_e_Vge_di+0.0)*T1_exp+T1_Vge_e*T1_exp_Vge_di+T1_Vge_di*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Vge_di))+0.0);
  T4_Vge_e_Vge_e=(+(+0.0-(+(+T1_Vge_e_Vge_e+0.0)*T1_exp+T1_Vge_e*T1_exp_Vge_e+T1_Vge_e*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Vge_e))+0.0);
  T4_Vge_e_Vdi_si=(+(+0.0-(+(+T1_Vge_e_Vdi_si+0.0)*T1_exp+T1_Vge_e*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Vdi_si))+0.0);
  T4_Vge_e_Ve_si=(+(+0.0-(+(+T1_Vge_e_Ve_si+0.0)*T1_exp+T1_Vge_e*T1_exp_Ve_si+T1_Ve_si*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Ve_si))+0.0);
  T4_Vge_e_Ve_di=(+(+0.0-(+(+T1_Vge_e_Ve_di+0.0)*T1_exp+T1_Vge_e*T1_exp_Ve_di+T1_Ve_di*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Ve_di))+0.0);
  T4_Vge_e_Vge_si=(+(+0.0-(+(+T1_Vge_e_Vge_si+0.0)*T1_exp+T1_Vge_e*T1_exp_Vge_si+T1_Vge_si*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Vge_si))+0.0);
  T4_Vge_e_Tempt_GND=(+(+0.0-(+(+T1_Vge_e_Tempt_GND+0.0)*T1_exp+T1_Vge_e*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vge_e+(T1+1.0)*T1_exp_Vge_e_Tempt_GND))+0.0);
#endif
T4_Vdi_si=(-((T1_Vdi_si*T1_exp)+((T1+1.0)*T1_exp_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+0.0-(+(+T1_Vdi_si_Vge_di+0.0)*T1_exp+T1_Vdi_si*T1_exp_Vge_di+T1_Vge_di*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Vge_di))+0.0);
  T4_Vdi_si_Vge_e=(+(+0.0-(+(+T1_Vdi_si_Vge_e+0.0)*T1_exp+T1_Vdi_si*T1_exp_Vge_e+T1_Vge_e*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Vge_e))+0.0);
  T4_Vdi_si_Vdi_si=(+(+0.0-(+(+T1_Vdi_si_Vdi_si+0.0)*T1_exp+T1_Vdi_si*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Vdi_si))+0.0);
  T4_Vdi_si_Ve_si=(+(+0.0-(+(+T1_Vdi_si_Ve_si+0.0)*T1_exp+T1_Vdi_si*T1_exp_Ve_si+T1_Ve_si*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Ve_si))+0.0);
  T4_Vdi_si_Ve_di=(+(+0.0-(+(+T1_Vdi_si_Ve_di+0.0)*T1_exp+T1_Vdi_si*T1_exp_Ve_di+T1_Ve_di*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Ve_di))+0.0);
  T4_Vdi_si_Vge_si=(+(+0.0-(+(+T1_Vdi_si_Vge_si+0.0)*T1_exp+T1_Vdi_si*T1_exp_Vge_si+T1_Vge_si*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Vge_si))+0.0);
  T4_Vdi_si_Tempt_GND=(+(+0.0-(+(+T1_Vdi_si_Tempt_GND+0.0)*T1_exp+T1_Vdi_si*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vdi_si+(T1+1.0)*T1_exp_Vdi_si_Tempt_GND))+0.0);
#endif
T4_Ve_si=(-((T1_Ve_si*T1_exp)+((T1+1.0)*T1_exp_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+0.0-(+(+T1_Ve_si_Vge_di+0.0)*T1_exp+T1_Ve_si*T1_exp_Vge_di+T1_Vge_di*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Vge_di))+0.0);
  T4_Ve_si_Vge_e=(+(+0.0-(+(+T1_Ve_si_Vge_e+0.0)*T1_exp+T1_Ve_si*T1_exp_Vge_e+T1_Vge_e*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Vge_e))+0.0);
  T4_Ve_si_Vdi_si=(+(+0.0-(+(+T1_Ve_si_Vdi_si+0.0)*T1_exp+T1_Ve_si*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Vdi_si))+0.0);
  T4_Ve_si_Ve_si=(+(+0.0-(+(+T1_Ve_si_Ve_si+0.0)*T1_exp+T1_Ve_si*T1_exp_Ve_si+T1_Ve_si*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Ve_si))+0.0);
  T4_Ve_si_Ve_di=(+(+0.0-(+(+T1_Ve_si_Ve_di+0.0)*T1_exp+T1_Ve_si*T1_exp_Ve_di+T1_Ve_di*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Ve_di))+0.0);
  T4_Ve_si_Vge_si=(+(+0.0-(+(+T1_Ve_si_Vge_si+0.0)*T1_exp+T1_Ve_si*T1_exp_Vge_si+T1_Vge_si*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Vge_si))+0.0);
  T4_Ve_si_Tempt_GND=(+(+0.0-(+(+T1_Ve_si_Tempt_GND+0.0)*T1_exp+T1_Ve_si*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Ve_si+(T1+1.0)*T1_exp_Ve_si_Tempt_GND))+0.0);
#endif
T4_Ve_di=(-((T1_Ve_di*T1_exp)+((T1+1.0)*T1_exp_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+0.0-(+(+T1_Ve_di_Vge_di+0.0)*T1_exp+T1_Ve_di*T1_exp_Vge_di+T1_Vge_di*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Vge_di))+0.0);
  T4_Ve_di_Vge_e=(+(+0.0-(+(+T1_Ve_di_Vge_e+0.0)*T1_exp+T1_Ve_di*T1_exp_Vge_e+T1_Vge_e*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Vge_e))+0.0);
  T4_Ve_di_Vdi_si=(+(+0.0-(+(+T1_Ve_di_Vdi_si+0.0)*T1_exp+T1_Ve_di*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Vdi_si))+0.0);
  T4_Ve_di_Ve_si=(+(+0.0-(+(+T1_Ve_di_Ve_si+0.0)*T1_exp+T1_Ve_di*T1_exp_Ve_si+T1_Ve_si*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Ve_si))+0.0);
  T4_Ve_di_Ve_di=(+(+0.0-(+(+T1_Ve_di_Ve_di+0.0)*T1_exp+T1_Ve_di*T1_exp_Ve_di+T1_Ve_di*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Ve_di))+0.0);
  T4_Ve_di_Vge_si=(+(+0.0-(+(+T1_Ve_di_Vge_si+0.0)*T1_exp+T1_Ve_di*T1_exp_Vge_si+T1_Vge_si*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Vge_si))+0.0);
  T4_Ve_di_Tempt_GND=(+(+0.0-(+(+T1_Ve_di_Tempt_GND+0.0)*T1_exp+T1_Ve_di*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Ve_di+(T1+1.0)*T1_exp_Ve_di_Tempt_GND))+0.0);
#endif
T4_Vge_si=(-((T1_Vge_si*T1_exp)+((T1+1.0)*T1_exp_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+0.0-(+(+T1_Vge_si_Vge_di+0.0)*T1_exp+T1_Vge_si*T1_exp_Vge_di+T1_Vge_di*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Vge_di))+0.0);
  T4_Vge_si_Vge_e=(+(+0.0-(+(+T1_Vge_si_Vge_e+0.0)*T1_exp+T1_Vge_si*T1_exp_Vge_e+T1_Vge_e*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Vge_e))+0.0);
  T4_Vge_si_Vdi_si=(+(+0.0-(+(+T1_Vge_si_Vdi_si+0.0)*T1_exp+T1_Vge_si*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Vdi_si))+0.0);
  T4_Vge_si_Ve_si=(+(+0.0-(+(+T1_Vge_si_Ve_si+0.0)*T1_exp+T1_Vge_si*T1_exp_Ve_si+T1_Ve_si*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Ve_si))+0.0);
  T4_Vge_si_Ve_di=(+(+0.0-(+(+T1_Vge_si_Ve_di+0.0)*T1_exp+T1_Vge_si*T1_exp_Ve_di+T1_Ve_di*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Ve_di))+0.0);
  T4_Vge_si_Vge_si=(+(+0.0-(+(+T1_Vge_si_Vge_si+0.0)*T1_exp+T1_Vge_si*T1_exp_Vge_si+T1_Vge_si*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Vge_si))+0.0);
  T4_Vge_si_Tempt_GND=(+(+0.0-(+(+T1_Vge_si_Tempt_GND+0.0)*T1_exp+T1_Vge_si*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Vge_si+(T1+1.0)*T1_exp_Vge_si_Tempt_GND))+0.0);
#endif
T4_Tempt_GND=(-((T1_Tempt_GND*T1_exp)+((T1+1.0)*T1_exp_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+0.0-(+(+T1_Tempt_GND_Vge_di+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Vge_di+T1_Vge_di*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Vge_di))+0.0);
  T4_Tempt_GND_Vge_e=(+(+0.0-(+(+T1_Tempt_GND_Vge_e+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Vge_e+T1_Vge_e*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Vge_e))+0.0);
  T4_Tempt_GND_Vdi_si=(+(+0.0-(+(+T1_Tempt_GND_Vdi_si+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Vdi_si+T1_Vdi_si*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Vdi_si))+0.0);
  T4_Tempt_GND_Ve_si=(+(+0.0-(+(+T1_Tempt_GND_Ve_si+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Ve_si+T1_Ve_si*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Ve_si))+0.0);
  T4_Tempt_GND_Ve_di=(+(+0.0-(+(+T1_Tempt_GND_Ve_di+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Ve_di+T1_Ve_di*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Ve_di))+0.0);
  T4_Tempt_GND_Vge_si=(+(+0.0-(+(+T1_Tempt_GND_Vge_si+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Vge_si+T1_Vge_si*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Vge_si))+0.0);
  T4_Tempt_GND_Tempt_GND=(+(+0.0-(+(+T1_Tempt_GND_Tempt_GND+0.0)*T1_exp+T1_Tempt_GND*T1_exp_Tempt_GND+T1_Tempt_GND*T1_exp_Tempt_GND+(T1+1.0)*T1_exp_Tempt_GND_Tempt_GND))+0.0);
#endif
#endif
T4=((1.0-((T1+1.0)*T1_exp))+1.0e-4);
EXIT_IF_ISNAN(((1.0-((T1+1.0)*T1_exp))+1.0e-4))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T1_Vge_di*T1)+(T1*T1_Vge_di));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+(+T1_Vge_di_Vge_di*T1+T1_Vge_di*T1_Vge_di+T1_Vge_di*T1_Vge_di+T1*T1_Vge_di_Vge_di)+0.0);
  T5_Vge_di_Vdi_d=(+(+T1_Vge_di_Vdi_d*T1+T1_Vge_di*T1_Vdi_d+T1_Vdi_d*T1_Vge_di+T1*T1_Vge_di_Vdi_d)+0.0);
  T5_Vge_di_Vsi_s=(+(+T1_Vge_di_Vsi_s*T1+T1_Vge_di*T1_Vsi_s+T1_Vsi_s*T1_Vge_di+T1*T1_Vge_di_Vsi_s)+0.0);
  T5_Vge_di_Vge_e=(+(+T1_Vge_di_Vge_e*T1+T1_Vge_di*T1_Vge_e+T1_Vge_e*T1_Vge_di+T1*T1_Vge_di_Vge_e)+0.0);
  T5_Vge_di_Vdi_si=(+(+T1_Vge_di_Vdi_si*T1+T1_Vge_di*T1_Vdi_si+T1_Vdi_si*T1_Vge_di+T1*T1_Vge_di_Vdi_si)+0.0);
  T5_Vge_di_Ve_si=(+(+T1_Vge_di_Ve_si*T1+T1_Vge_di*T1_Ve_si+T1_Ve_si*T1_Vge_di+T1*T1_Vge_di_Ve_si)+0.0);
  T5_Vge_di_Ve_di=(+(+T1_Vge_di_Ve_di*T1+T1_Vge_di*T1_Ve_di+T1_Ve_di*T1_Vge_di+T1*T1_Vge_di_Ve_di)+0.0);
  T5_Vge_di_Vge_si=(+(+T1_Vge_di_Vge_si*T1+T1_Vge_di*T1_Vge_si+T1_Vge_si*T1_Vge_di+T1*T1_Vge_di_Vge_si)+0.0);
  T5_Vge_di_Tempt_GND=(+(+T1_Vge_di_Tempt_GND*T1+T1_Vge_di*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_di+T1*T1_Vge_di_Tempt_GND)+0.0);
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T1_Vge_e*T1)+(T1*T1_Vge_e));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+(+T1_Vge_e_Vge_di*T1+T1_Vge_e*T1_Vge_di+T1_Vge_di*T1_Vge_e+T1*T1_Vge_e_Vge_di)+0.0);
  T5_Vge_e_Vdi_d=(+(+T1_Vge_e_Vdi_d*T1+T1_Vge_e*T1_Vdi_d+T1_Vdi_d*T1_Vge_e+T1*T1_Vge_e_Vdi_d)+0.0);
  T5_Vge_e_Vsi_s=(+(+T1_Vge_e_Vsi_s*T1+T1_Vge_e*T1_Vsi_s+T1_Vsi_s*T1_Vge_e+T1*T1_Vge_e_Vsi_s)+0.0);
  T5_Vge_e_Vge_e=(+(+T1_Vge_e_Vge_e*T1+T1_Vge_e*T1_Vge_e+T1_Vge_e*T1_Vge_e+T1*T1_Vge_e_Vge_e)+0.0);
  T5_Vge_e_Vdi_si=(+(+T1_Vge_e_Vdi_si*T1+T1_Vge_e*T1_Vdi_si+T1_Vdi_si*T1_Vge_e+T1*T1_Vge_e_Vdi_si)+0.0);
  T5_Vge_e_Ve_si=(+(+T1_Vge_e_Ve_si*T1+T1_Vge_e*T1_Ve_si+T1_Ve_si*T1_Vge_e+T1*T1_Vge_e_Ve_si)+0.0);
  T5_Vge_e_Ve_di=(+(+T1_Vge_e_Ve_di*T1+T1_Vge_e*T1_Ve_di+T1_Ve_di*T1_Vge_e+T1*T1_Vge_e_Ve_di)+0.0);
  T5_Vge_e_Vge_si=(+(+T1_Vge_e_Vge_si*T1+T1_Vge_e*T1_Vge_si+T1_Vge_si*T1_Vge_e+T1*T1_Vge_e_Vge_si)+0.0);
  T5_Vge_e_Tempt_GND=(+(+T1_Vge_e_Tempt_GND*T1+T1_Vge_e*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_e+T1*T1_Vge_e_Tempt_GND)+0.0);
#endif
T5_Vdi_si=((T1_Vdi_si*T1)+(T1*T1_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+(+T1_Vdi_si_Vge_di*T1+T1_Vdi_si*T1_Vge_di+T1_Vge_di*T1_Vdi_si+T1*T1_Vdi_si_Vge_di)+0.0);
  T5_Vdi_si_Vdi_d=(+(+T1_Vdi_si_Vdi_d*T1+T1_Vdi_si*T1_Vdi_d+T1_Vdi_d*T1_Vdi_si+T1*T1_Vdi_si_Vdi_d)+0.0);
  T5_Vdi_si_Vsi_s=(+(+T1_Vdi_si_Vsi_s*T1+T1_Vdi_si*T1_Vsi_s+T1_Vsi_s*T1_Vdi_si+T1*T1_Vdi_si_Vsi_s)+0.0);
  T5_Vdi_si_Vge_e=(+(+T1_Vdi_si_Vge_e*T1+T1_Vdi_si*T1_Vge_e+T1_Vge_e*T1_Vdi_si+T1*T1_Vdi_si_Vge_e)+0.0);
  T5_Vdi_si_Vdi_si=(+(+T1_Vdi_si_Vdi_si*T1+T1_Vdi_si*T1_Vdi_si+T1_Vdi_si*T1_Vdi_si+T1*T1_Vdi_si_Vdi_si)+0.0);
  T5_Vdi_si_Ve_si=(+(+T1_Vdi_si_Ve_si*T1+T1_Vdi_si*T1_Ve_si+T1_Ve_si*T1_Vdi_si+T1*T1_Vdi_si_Ve_si)+0.0);
  T5_Vdi_si_Ve_di=(+(+T1_Vdi_si_Ve_di*T1+T1_Vdi_si*T1_Ve_di+T1_Ve_di*T1_Vdi_si+T1*T1_Vdi_si_Ve_di)+0.0);
  T5_Vdi_si_Vge_si=(+(+T1_Vdi_si_Vge_si*T1+T1_Vdi_si*T1_Vge_si+T1_Vge_si*T1_Vdi_si+T1*T1_Vdi_si_Vge_si)+0.0);
  T5_Vdi_si_Tempt_GND=(+(+T1_Vdi_si_Tempt_GND*T1+T1_Vdi_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vdi_si+T1*T1_Vdi_si_Tempt_GND)+0.0);
#endif
T5_Ve_si=((T1_Ve_si*T1)+(T1*T1_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+(+T1_Ve_si_Vge_di*T1+T1_Ve_si*T1_Vge_di+T1_Vge_di*T1_Ve_si+T1*T1_Ve_si_Vge_di)+0.0);
  T5_Ve_si_Vdi_d=(+(+T1_Ve_si_Vdi_d*T1+T1_Ve_si*T1_Vdi_d+T1_Vdi_d*T1_Ve_si+T1*T1_Ve_si_Vdi_d)+0.0);
  T5_Ve_si_Vsi_s=(+(+T1_Ve_si_Vsi_s*T1+T1_Ve_si*T1_Vsi_s+T1_Vsi_s*T1_Ve_si+T1*T1_Ve_si_Vsi_s)+0.0);
  T5_Ve_si_Vge_e=(+(+T1_Ve_si_Vge_e*T1+T1_Ve_si*T1_Vge_e+T1_Vge_e*T1_Ve_si+T1*T1_Ve_si_Vge_e)+0.0);
  T5_Ve_si_Vdi_si=(+(+T1_Ve_si_Vdi_si*T1+T1_Ve_si*T1_Vdi_si+T1_Vdi_si*T1_Ve_si+T1*T1_Ve_si_Vdi_si)+0.0);
  T5_Ve_si_Ve_si=(+(+T1_Ve_si_Ve_si*T1+T1_Ve_si*T1_Ve_si+T1_Ve_si*T1_Ve_si+T1*T1_Ve_si_Ve_si)+0.0);
  T5_Ve_si_Ve_di=(+(+T1_Ve_si_Ve_di*T1+T1_Ve_si*T1_Ve_di+T1_Ve_di*T1_Ve_si+T1*T1_Ve_si_Ve_di)+0.0);
  T5_Ve_si_Vge_si=(+(+T1_Ve_si_Vge_si*T1+T1_Ve_si*T1_Vge_si+T1_Vge_si*T1_Ve_si+T1*T1_Ve_si_Vge_si)+0.0);
  T5_Ve_si_Tempt_GND=(+(+T1_Ve_si_Tempt_GND*T1+T1_Ve_si*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_si+T1*T1_Ve_si_Tempt_GND)+0.0);
#endif
T5_Ve_di=((T1_Ve_di*T1)+(T1*T1_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+(+T1_Ve_di_Vge_di*T1+T1_Ve_di*T1_Vge_di+T1_Vge_di*T1_Ve_di+T1*T1_Ve_di_Vge_di)+0.0);
  T5_Ve_di_Vdi_d=(+(+T1_Ve_di_Vdi_d*T1+T1_Ve_di*T1_Vdi_d+T1_Vdi_d*T1_Ve_di+T1*T1_Ve_di_Vdi_d)+0.0);
  T5_Ve_di_Vsi_s=(+(+T1_Ve_di_Vsi_s*T1+T1_Ve_di*T1_Vsi_s+T1_Vsi_s*T1_Ve_di+T1*T1_Ve_di_Vsi_s)+0.0);
  T5_Ve_di_Vge_e=(+(+T1_Ve_di_Vge_e*T1+T1_Ve_di*T1_Vge_e+T1_Vge_e*T1_Ve_di+T1*T1_Ve_di_Vge_e)+0.0);
  T5_Ve_di_Vdi_si=(+(+T1_Ve_di_Vdi_si*T1+T1_Ve_di*T1_Vdi_si+T1_Vdi_si*T1_Ve_di+T1*T1_Ve_di_Vdi_si)+0.0);
  T5_Ve_di_Ve_si=(+(+T1_Ve_di_Ve_si*T1+T1_Ve_di*T1_Ve_si+T1_Ve_si*T1_Ve_di+T1*T1_Ve_di_Ve_si)+0.0);
  T5_Ve_di_Ve_di=(+(+T1_Ve_di_Ve_di*T1+T1_Ve_di*T1_Ve_di+T1_Ve_di*T1_Ve_di+T1*T1_Ve_di_Ve_di)+0.0);
  T5_Ve_di_Vge_si=(+(+T1_Ve_di_Vge_si*T1+T1_Ve_di*T1_Vge_si+T1_Vge_si*T1_Ve_di+T1*T1_Ve_di_Vge_si)+0.0);
  T5_Ve_di_Tempt_GND=(+(+T1_Ve_di_Tempt_GND*T1+T1_Ve_di*T1_Tempt_GND+T1_Tempt_GND*T1_Ve_di+T1*T1_Ve_di_Tempt_GND)+0.0);
#endif
T5_Vge_si=((T1_Vge_si*T1)+(T1*T1_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+(+T1_Vge_si_Vge_di*T1+T1_Vge_si*T1_Vge_di+T1_Vge_di*T1_Vge_si+T1*T1_Vge_si_Vge_di)+0.0);
  T5_Vge_si_Vdi_d=(+(+T1_Vge_si_Vdi_d*T1+T1_Vge_si*T1_Vdi_d+T1_Vdi_d*T1_Vge_si+T1*T1_Vge_si_Vdi_d)+0.0);
  T5_Vge_si_Vsi_s=(+(+T1_Vge_si_Vsi_s*T1+T1_Vge_si*T1_Vsi_s+T1_Vsi_s*T1_Vge_si+T1*T1_Vge_si_Vsi_s)+0.0);
  T5_Vge_si_Vge_e=(+(+T1_Vge_si_Vge_e*T1+T1_Vge_si*T1_Vge_e+T1_Vge_e*T1_Vge_si+T1*T1_Vge_si_Vge_e)+0.0);
  T5_Vge_si_Vdi_si=(+(+T1_Vge_si_Vdi_si*T1+T1_Vge_si*T1_Vdi_si+T1_Vdi_si*T1_Vge_si+T1*T1_Vge_si_Vdi_si)+0.0);
  T5_Vge_si_Ve_si=(+(+T1_Vge_si_Ve_si*T1+T1_Vge_si*T1_Ve_si+T1_Ve_si*T1_Vge_si+T1*T1_Vge_si_Ve_si)+0.0);
  T5_Vge_si_Ve_di=(+(+T1_Vge_si_Ve_di*T1+T1_Vge_si*T1_Ve_di+T1_Ve_di*T1_Vge_si+T1*T1_Vge_si_Ve_di)+0.0);
  T5_Vge_si_Vge_si=(+(+T1_Vge_si_Vge_si*T1+T1_Vge_si*T1_Vge_si+T1_Vge_si*T1_Vge_si+T1*T1_Vge_si_Vge_si)+0.0);
  T5_Vge_si_Tempt_GND=(+(+T1_Vge_si_Tempt_GND*T1+T1_Vge_si*T1_Tempt_GND+T1_Tempt_GND*T1_Vge_si+T1*T1_Vge_si_Tempt_GND)+0.0);
#endif
T5_Tempt_GND=((T1_Tempt_GND*T1)+(T1*T1_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+(+T1_Tempt_GND_Vge_di*T1+T1_Tempt_GND*T1_Vge_di+T1_Vge_di*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_di)+0.0);
  T5_Tempt_GND_Vdi_d=(+(+T1_Tempt_GND_Vdi_d*T1+T1_Tempt_GND*T1_Vdi_d+T1_Vdi_d*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_d)+0.0);
  T5_Tempt_GND_Vsi_s=(+(+T1_Tempt_GND_Vsi_s*T1+T1_Tempt_GND*T1_Vsi_s+T1_Vsi_s*T1_Tempt_GND+T1*T1_Tempt_GND_Vsi_s)+0.0);
  T5_Tempt_GND_Vge_e=(+(+T1_Tempt_GND_Vge_e*T1+T1_Tempt_GND*T1_Vge_e+T1_Vge_e*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_e)+0.0);
  T5_Tempt_GND_Vdi_si=(+(+T1_Tempt_GND_Vdi_si*T1+T1_Tempt_GND*T1_Vdi_si+T1_Vdi_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vdi_si)+0.0);
  T5_Tempt_GND_Ve_si=(+(+T1_Tempt_GND_Ve_si*T1+T1_Tempt_GND*T1_Ve_si+T1_Ve_si*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_si)+0.0);
  T5_Tempt_GND_Ve_di=(+(+T1_Tempt_GND_Ve_di*T1+T1_Tempt_GND*T1_Ve_di+T1_Ve_di*T1_Tempt_GND+T1*T1_Tempt_GND_Ve_di)+0.0);
  T5_Tempt_GND_Vge_si=(+(+T1_Tempt_GND_Vge_si*T1+T1_Tempt_GND*T1_Vge_si+T1_Vge_si*T1_Tempt_GND+T1*T1_Tempt_GND_Vge_si)+0.0);
  T5_Tempt_GND_Tempt_GND=(+(+T1_Tempt_GND_Tempt_GND*T1+T1_Tempt_GND*T1_Tempt_GND+T1_Tempt_GND*T1_Tempt_GND+T1*T1_Tempt_GND_Tempt_GND)+0.0);
#endif
#endif
T5=((T1*T1)+2.0e-4);
EXIT_IF_ISNAN(((T1*T1)+2.0e-4))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcd_Vge_di=((((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5-(igc0*T4)*T5_Vge_di)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vge_di_Vge_di=((+igc0_Vge_di_Vge_di*T4+igc0_Vge_di*T4_Vge_di+igc0_Vge_di*T4_Vge_di+igc0*T4_Vge_di_Vge_di)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vge_di/T5/T5/T5);
  igcd_Vge_di_Vge_e=((+igc0_Vge_di_Vge_e*T4+igc0_Vge_di*T4_Vge_e+igc0_Vge_e*T4_Vge_di+igc0*T4_Vge_di_Vge_e)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vge_e/T5/T5/T5);
  igcd_Vge_di_Vdi_si=((+igc0_Vge_di_Vdi_si*T4+igc0_Vge_di*T4_Vdi_si+igc0_Vdi_si*T4_Vge_di+igc0*T4_Vge_di_Vdi_si)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vdi_si/T5/T5/T5);
  igcd_Vge_di_Ve_si=((+igc0_Vge_di_Ve_si*T4+igc0_Vge_di*T4_Ve_si+igc0_Ve_si*T4_Vge_di+igc0*T4_Vge_di_Ve_si)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Ve_si/T5/T5/T5);
  igcd_Vge_di_Ve_di=((+igc0_Vge_di_Ve_di*T4+igc0_Vge_di*T4_Ve_di+igc0_Ve_di*T4_Vge_di+igc0*T4_Vge_di_Ve_di)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Ve_di/T5/T5/T5);
  igcd_Vge_di_Vge_si=((+igc0_Vge_di_Vge_si*T4+igc0_Vge_di*T4_Vge_si+igc0_Vge_si*T4_Vge_di+igc0*T4_Vge_di_Vge_si)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vge_si/T5/T5/T5);
  igcd_Vge_di_Tempt_GND=((+igc0_Vge_di_Tempt_GND*T4+igc0_Vge_di*T4_Tempt_GND+igc0_Tempt_GND*T4_Vge_di+igc0*T4_Vge_di_Tempt_GND)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vge_di+(igc0*T4)*T5_Vge_di_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Tempt_GND/T5/T5/T5);
  igcd_Vge_di_Vdi_d=((+igc0_Vge_di_Vdi_d*T4+igc0_Vge_di*0.0+igc0_Vdi_d*T4_Vge_di+igc0*0.0)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vdi_d/T5/T5/T5);
  igcd_Vge_di_Vsi_s=((+igc0_Vge_di_Vsi_s*T4+igc0_Vge_di*0.0+igc0_Vsi_s*T4_Vge_di+igc0*0.0)/T5-(((igc0_Vge_di*T4)+(igc0*T4_Vge_di))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vge_di+(igc0*T4)*T5_Vge_di_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vge_di*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Vge_e=((((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5-(igc0*T4)*T5_Vge_e)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vge_e_Vge_di=((+igc0_Vge_e_Vge_di*T4+igc0_Vge_e*T4_Vge_di+igc0_Vge_di*T4_Vge_e+igc0*T4_Vge_e_Vge_di)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vge_di/T5/T5/T5);
  igcd_Vge_e_Vge_e=((+igc0_Vge_e_Vge_e*T4+igc0_Vge_e*T4_Vge_e+igc0_Vge_e*T4_Vge_e+igc0*T4_Vge_e_Vge_e)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vge_e/T5/T5/T5);
  igcd_Vge_e_Vdi_si=((+igc0_Vge_e_Vdi_si*T4+igc0_Vge_e*T4_Vdi_si+igc0_Vdi_si*T4_Vge_e+igc0*T4_Vge_e_Vdi_si)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vdi_si/T5/T5/T5);
  igcd_Vge_e_Ve_si=((+igc0_Vge_e_Ve_si*T4+igc0_Vge_e*T4_Ve_si+igc0_Ve_si*T4_Vge_e+igc0*T4_Vge_e_Ve_si)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Ve_si/T5/T5/T5);
  igcd_Vge_e_Ve_di=((+igc0_Vge_e_Ve_di*T4+igc0_Vge_e*T4_Ve_di+igc0_Ve_di*T4_Vge_e+igc0*T4_Vge_e_Ve_di)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Ve_di/T5/T5/T5);
  igcd_Vge_e_Vge_si=((+igc0_Vge_e_Vge_si*T4+igc0_Vge_e*T4_Vge_si+igc0_Vge_si*T4_Vge_e+igc0*T4_Vge_e_Vge_si)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vge_si/T5/T5/T5);
  igcd_Vge_e_Tempt_GND=((+igc0_Vge_e_Tempt_GND*T4+igc0_Vge_e*T4_Tempt_GND+igc0_Tempt_GND*T4_Vge_e+igc0*T4_Vge_e_Tempt_GND)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vge_e+(igc0*T4)*T5_Vge_e_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Tempt_GND/T5/T5/T5);
  igcd_Vge_e_Vdi_d=((+igc0_Vge_e_Vdi_d*T4+igc0_Vge_e*0.0+igc0_Vdi_d*T4_Vge_e+igc0*0.0)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vdi_d/T5/T5/T5);
  igcd_Vge_e_Vsi_s=((+igc0_Vge_e_Vsi_s*T4+igc0_Vge_e*0.0+igc0_Vsi_s*T4_Vge_e+igc0*0.0)/T5-(((igc0_Vge_e*T4)+(igc0*T4_Vge_e))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vge_e+(igc0*T4)*T5_Vge_e_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vge_e*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Vdi_si=((((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5-(igc0*T4)*T5_Vdi_si)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vdi_si_Vge_di=((+igc0_Vdi_si_Vge_di*T4+igc0_Vdi_si*T4_Vge_di+igc0_Vge_di*T4_Vdi_si+igc0*T4_Vdi_si_Vge_di)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vge_di/T5/T5/T5);
  igcd_Vdi_si_Vge_e=((+igc0_Vdi_si_Vge_e*T4+igc0_Vdi_si*T4_Vge_e+igc0_Vge_e*T4_Vdi_si+igc0*T4_Vdi_si_Vge_e)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vge_e/T5/T5/T5);
  igcd_Vdi_si_Vdi_si=((+igc0_Vdi_si_Vdi_si*T4+igc0_Vdi_si*T4_Vdi_si+igc0_Vdi_si*T4_Vdi_si+igc0*T4_Vdi_si_Vdi_si)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vdi_si/T5/T5/T5);
  igcd_Vdi_si_Ve_si=((+igc0_Vdi_si_Ve_si*T4+igc0_Vdi_si*T4_Ve_si+igc0_Ve_si*T4_Vdi_si+igc0*T4_Vdi_si_Ve_si)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Ve_si/T5/T5/T5);
  igcd_Vdi_si_Ve_di=((+igc0_Vdi_si_Ve_di*T4+igc0_Vdi_si*T4_Ve_di+igc0_Ve_di*T4_Vdi_si+igc0*T4_Vdi_si_Ve_di)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Ve_di/T5/T5/T5);
  igcd_Vdi_si_Vge_si=((+igc0_Vdi_si_Vge_si*T4+igc0_Vdi_si*T4_Vge_si+igc0_Vge_si*T4_Vdi_si+igc0*T4_Vdi_si_Vge_si)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vge_si/T5/T5/T5);
  igcd_Vdi_si_Tempt_GND=((+igc0_Vdi_si_Tempt_GND*T4+igc0_Vdi_si*T4_Tempt_GND+igc0_Tempt_GND*T4_Vdi_si+igc0*T4_Vdi_si_Tempt_GND)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Tempt_GND/T5/T5/T5);
  igcd_Vdi_si_Vdi_d=((+igc0_Vdi_si_Vdi_d*T4+igc0_Vdi_si*0.0+igc0_Vdi_d*T4_Vdi_si+igc0*0.0)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vdi_d/T5/T5/T5);
  igcd_Vdi_si_Vsi_s=((+igc0_Vdi_si_Vsi_s*T4+igc0_Vdi_si*0.0+igc0_Vsi_s*T4_Vdi_si+igc0*0.0)/T5-(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vdi_si+(igc0*T4)*T5_Vdi_si_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vdi_si*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Ve_si=((((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5-(igc0*T4)*T5_Ve_si)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Ve_si_Vge_di=((+igc0_Ve_si_Vge_di*T4+igc0_Ve_si*T4_Vge_di+igc0_Vge_di*T4_Ve_si+igc0*T4_Ve_si_Vge_di)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vge_di)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vge_di/T5/T5/T5);
  igcd_Ve_si_Vge_e=((+igc0_Ve_si_Vge_e*T4+igc0_Ve_si*T4_Vge_e+igc0_Vge_e*T4_Ve_si+igc0*T4_Ve_si_Vge_e)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vge_e)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vge_e/T5/T5/T5);
  igcd_Ve_si_Vdi_si=((+igc0_Ve_si_Vdi_si*T4+igc0_Ve_si*T4_Vdi_si+igc0_Vdi_si*T4_Ve_si+igc0*T4_Ve_si_Vdi_si)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vdi_si/T5/T5/T5);
  igcd_Ve_si_Ve_si=((+igc0_Ve_si_Ve_si*T4+igc0_Ve_si*T4_Ve_si+igc0_Ve_si*T4_Ve_si+igc0*T4_Ve_si_Ve_si)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Ve_si)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Ve_si/T5/T5/T5);
  igcd_Ve_si_Ve_di=((+igc0_Ve_si_Ve_di*T4+igc0_Ve_si*T4_Ve_di+igc0_Ve_di*T4_Ve_si+igc0*T4_Ve_si_Ve_di)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Ve_di)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Ve_di/T5/T5/T5);
  igcd_Ve_si_Vge_si=((+igc0_Ve_si_Vge_si*T4+igc0_Ve_si*T4_Vge_si+igc0_Vge_si*T4_Ve_si+igc0*T4_Ve_si_Vge_si)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vge_si)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vge_si/T5/T5/T5);
  igcd_Ve_si_Tempt_GND=((+igc0_Ve_si_Tempt_GND*T4+igc0_Ve_si*T4_Tempt_GND+igc0_Tempt_GND*T4_Ve_si+igc0*T4_Ve_si_Tempt_GND)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Ve_si+(igc0*T4)*T5_Ve_si_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Tempt_GND/T5/T5/T5);
  igcd_Ve_si_Vdi_d=((+igc0_Ve_si_Vdi_d*T4+igc0_Ve_si*0.0+igc0_Vdi_d*T4_Ve_si+igc0*0.0)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vdi_d/T5/T5/T5);
  igcd_Ve_si_Vsi_s=((+igc0_Ve_si_Vsi_s*T4+igc0_Ve_si*0.0+igc0_Vsi_s*T4_Ve_si+igc0*0.0)/T5-(((igc0_Ve_si*T4)+(igc0*T4_Ve_si))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Ve_si+(igc0*T4)*T5_Ve_si_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Ve_si*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Ve_di=((((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5-(igc0*T4)*T5_Ve_di)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Ve_di_Vge_di=((+igc0_Ve_di_Vge_di*T4+igc0_Ve_di*T4_Vge_di+igc0_Vge_di*T4_Ve_di+igc0*T4_Ve_di_Vge_di)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vge_di)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vge_di/T5/T5/T5);
  igcd_Ve_di_Vge_e=((+igc0_Ve_di_Vge_e*T4+igc0_Ve_di*T4_Vge_e+igc0_Vge_e*T4_Ve_di+igc0*T4_Ve_di_Vge_e)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vge_e)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vge_e/T5/T5/T5);
  igcd_Ve_di_Vdi_si=((+igc0_Ve_di_Vdi_si*T4+igc0_Ve_di*T4_Vdi_si+igc0_Vdi_si*T4_Ve_di+igc0*T4_Ve_di_Vdi_si)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vdi_si/T5/T5/T5);
  igcd_Ve_di_Ve_si=((+igc0_Ve_di_Ve_si*T4+igc0_Ve_di*T4_Ve_si+igc0_Ve_si*T4_Ve_di+igc0*T4_Ve_di_Ve_si)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Ve_si)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Ve_si/T5/T5/T5);
  igcd_Ve_di_Ve_di=((+igc0_Ve_di_Ve_di*T4+igc0_Ve_di*T4_Ve_di+igc0_Ve_di*T4_Ve_di+igc0*T4_Ve_di_Ve_di)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Ve_di)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Ve_di/T5/T5/T5);
  igcd_Ve_di_Vge_si=((+igc0_Ve_di_Vge_si*T4+igc0_Ve_di*T4_Vge_si+igc0_Vge_si*T4_Ve_di+igc0*T4_Ve_di_Vge_si)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vge_si)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vge_si/T5/T5/T5);
  igcd_Ve_di_Tempt_GND=((+igc0_Ve_di_Tempt_GND*T4+igc0_Ve_di*T4_Tempt_GND+igc0_Tempt_GND*T4_Ve_di+igc0*T4_Ve_di_Tempt_GND)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Ve_di+(igc0*T4)*T5_Ve_di_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Tempt_GND/T5/T5/T5);
  igcd_Ve_di_Vdi_d=((+igc0_Ve_di_Vdi_d*T4+igc0_Ve_di*0.0+igc0_Vdi_d*T4_Ve_di+igc0*0.0)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vdi_d/T5/T5/T5);
  igcd_Ve_di_Vsi_s=((+igc0_Ve_di_Vsi_s*T4+igc0_Ve_di*0.0+igc0_Vsi_s*T4_Ve_di+igc0*0.0)/T5-(((igc0_Ve_di*T4)+(igc0*T4_Ve_di))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Ve_di+(igc0*T4)*T5_Ve_di_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Ve_di*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Vge_si=((((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5-(igc0*T4)*T5_Vge_si)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vge_si_Vge_di=((+igc0_Vge_si_Vge_di*T4+igc0_Vge_si*T4_Vge_di+igc0_Vge_di*T4_Vge_si+igc0*T4_Vge_si_Vge_di)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vge_di/T5/T5/T5);
  igcd_Vge_si_Vge_e=((+igc0_Vge_si_Vge_e*T4+igc0_Vge_si*T4_Vge_e+igc0_Vge_e*T4_Vge_si+igc0*T4_Vge_si_Vge_e)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vge_e/T5/T5/T5);
  igcd_Vge_si_Vdi_si=((+igc0_Vge_si_Vdi_si*T4+igc0_Vge_si*T4_Vdi_si+igc0_Vdi_si*T4_Vge_si+igc0*T4_Vge_si_Vdi_si)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vdi_si/T5/T5/T5);
  igcd_Vge_si_Ve_si=((+igc0_Vge_si_Ve_si*T4+igc0_Vge_si*T4_Ve_si+igc0_Ve_si*T4_Vge_si+igc0*T4_Vge_si_Ve_si)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Ve_si/T5/T5/T5);
  igcd_Vge_si_Ve_di=((+igc0_Vge_si_Ve_di*T4+igc0_Vge_si*T4_Ve_di+igc0_Ve_di*T4_Vge_si+igc0*T4_Vge_si_Ve_di)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Ve_di/T5/T5/T5);
  igcd_Vge_si_Vge_si=((+igc0_Vge_si_Vge_si*T4+igc0_Vge_si*T4_Vge_si+igc0_Vge_si*T4_Vge_si+igc0*T4_Vge_si_Vge_si)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vge_si/T5/T5/T5);
  igcd_Vge_si_Tempt_GND=((+igc0_Vge_si_Tempt_GND*T4+igc0_Vge_si*T4_Tempt_GND+igc0_Tempt_GND*T4_Vge_si+igc0*T4_Vge_si_Tempt_GND)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vge_si+(igc0*T4)*T5_Vge_si_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Tempt_GND/T5/T5/T5);
  igcd_Vge_si_Vdi_d=((+igc0_Vge_si_Vdi_d*T4+igc0_Vge_si*0.0+igc0_Vdi_d*T4_Vge_si+igc0*0.0)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vdi_d/T5/T5/T5);
  igcd_Vge_si_Vsi_s=((+igc0_Vge_si_Vsi_s*T4+igc0_Vge_si*0.0+igc0_Vsi_s*T4_Vge_si+igc0*0.0)/T5-(((igc0_Vge_si*T4)+(igc0*T4_Vge_si))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vge_si+(igc0*T4)*T5_Vge_si_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vge_si*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Tempt_GND=((((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5-(igc0*T4)*T5_Tempt_GND)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Tempt_GND_Vge_di=((+igc0_Tempt_GND_Vge_di*T4+igc0_Tempt_GND*T4_Vge_di+igc0_Vge_di*T4_Tempt_GND+igc0*T4_Tempt_GND_Vge_di)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vge_di)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vge_di/T5/T5/T5);
  igcd_Tempt_GND_Vge_e=((+igc0_Tempt_GND_Vge_e*T4+igc0_Tempt_GND*T4_Vge_e+igc0_Vge_e*T4_Tempt_GND+igc0*T4_Tempt_GND_Vge_e)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vge_e)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vge_e/T5/T5/T5);
  igcd_Tempt_GND_Vdi_si=((+igc0_Tempt_GND_Vdi_si*T4+igc0_Tempt_GND*T4_Vdi_si+igc0_Vdi_si*T4_Tempt_GND+igc0*T4_Tempt_GND_Vdi_si)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vdi_si/T5/T5/T5);
  igcd_Tempt_GND_Ve_si=((+igc0_Tempt_GND_Ve_si*T4+igc0_Tempt_GND*T4_Ve_si+igc0_Ve_si*T4_Tempt_GND+igc0*T4_Tempt_GND_Ve_si)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Ve_si)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Ve_si/T5/T5/T5);
  igcd_Tempt_GND_Ve_di=((+igc0_Tempt_GND_Ve_di*T4+igc0_Tempt_GND*T4_Ve_di+igc0_Ve_di*T4_Tempt_GND+igc0*T4_Tempt_GND_Ve_di)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Ve_di)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Ve_di/T5/T5/T5);
  igcd_Tempt_GND_Vge_si=((+igc0_Tempt_GND_Vge_si*T4+igc0_Tempt_GND*T4_Vge_si+igc0_Vge_si*T4_Tempt_GND+igc0*T4_Tempt_GND_Vge_si)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vge_si)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vge_si/T5/T5/T5);
  igcd_Tempt_GND_Tempt_GND=((+igc0_Tempt_GND_Tempt_GND*T4+igc0_Tempt_GND*T4_Tempt_GND+igc0_Tempt_GND*T4_Tempt_GND+igc0*T4_Tempt_GND_Tempt_GND)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Tempt_GND/T5/T5/T5);
  igcd_Tempt_GND_Vdi_d=((+igc0_Tempt_GND_Vdi_d*T4+igc0_Tempt_GND*0.0+igc0_Vdi_d*T4_Tempt_GND+igc0*0.0)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vdi_d/T5/T5/T5);
  igcd_Tempt_GND_Vsi_s=((+igc0_Tempt_GND_Vsi_s*T4+igc0_Tempt_GND*0.0+igc0_Vsi_s*T4_Tempt_GND+igc0*0.0)/T5-(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND))*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Tempt_GND+(igc0*T4)*T5_Tempt_GND_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Tempt_GND*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Vdi_d=((igc0_Vdi_d*T4*T5-(igc0*T4)*T5_Vdi_d)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vdi_d_Vge_di=((+igc0_Vdi_d_Vge_di*T4+igc0_Vdi_d*T4_Vge_di+igc0_Vge_di*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vge_di/T5/T5/T5);
  igcd_Vdi_d_Vge_e=((+igc0_Vdi_d_Vge_e*T4+igc0_Vdi_d*T4_Vge_e+igc0_Vge_e*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vge_e/T5/T5/T5);
  igcd_Vdi_d_Vdi_si=((+igc0_Vdi_d_Vdi_si*T4+igc0_Vdi_d*T4_Vdi_si+igc0_Vdi_si*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vdi_si/T5/T5/T5);
  igcd_Vdi_d_Ve_si=((+igc0_Vdi_d_Ve_si*T4+igc0_Vdi_d*T4_Ve_si+igc0_Ve_si*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Ve_si/T5/T5/T5);
  igcd_Vdi_d_Ve_di=((+igc0_Vdi_d_Ve_di*T4+igc0_Vdi_d*T4_Ve_di+igc0_Ve_di*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Ve_di/T5/T5/T5);
  igcd_Vdi_d_Vge_si=((+igc0_Vdi_d_Vge_si*T4+igc0_Vdi_d*T4_Vge_si+igc0_Vge_si*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vge_si/T5/T5/T5);
  igcd_Vdi_d_Tempt_GND=((+igc0_Vdi_d_Tempt_GND*T4+igc0_Vdi_d*T4_Tempt_GND+igc0_Tempt_GND*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Tempt_GND/T5/T5/T5);
  igcd_Vdi_d_Vdi_d=((+igc0_Vdi_d_Vdi_d*T4+igc0_Vdi_d*0.0+igc0_Vdi_d*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vdi_d/T5/T5/T5);
  igcd_Vdi_d_Vsi_s=((+igc0_Vdi_d_Vsi_s*T4+igc0_Vdi_d*0.0+igc0_Vsi_s*0.0+igc0*0.0)/T5-(igc0_Vdi_d*T4*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vdi_d+(igc0*T4)*T5_Vdi_d_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vdi_d*T5_Vsi_s/T5/T5/T5);
#endif
igcd_Vsi_s=((igc0_Vsi_s*T4*T5-(igc0*T4)*T5_Vsi_s)/T5/T5);
#if defined(_DERIVATE2)
  igcd_Vsi_s_Vge_di=((+igc0_Vsi_s_Vge_di*T4+igc0_Vsi_s*T4_Vge_di+igc0_Vge_di*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vge_di+(((igc0_Vge_di*T4)+(igc0*T4_Vge_di)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vge_di)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vge_di/T5/T5/T5);
  igcd_Vsi_s_Vge_e=((+igc0_Vsi_s_Vge_e*T4+igc0_Vsi_s*T4_Vge_e+igc0_Vge_e*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vge_e+(((igc0_Vge_e*T4)+(igc0*T4_Vge_e)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vge_e)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vge_e/T5/T5/T5);
  igcd_Vsi_s_Vdi_si=((+igc0_Vsi_s_Vdi_si*T4+igc0_Vsi_s*T4_Vdi_si+igc0_Vdi_si*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vdi_si+(((igc0_Vdi_si*T4)+(igc0*T4_Vdi_si)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vdi_si)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vdi_si/T5/T5/T5);
  igcd_Vsi_s_Ve_si=((+igc0_Vsi_s_Ve_si*T4+igc0_Vsi_s*T4_Ve_si+igc0_Ve_si*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Ve_si+(((igc0_Ve_si*T4)+(igc0*T4_Ve_si)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Ve_si)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Ve_si/T5/T5/T5);
  igcd_Vsi_s_Ve_di=((+igc0_Vsi_s_Ve_di*T4+igc0_Vsi_s*T4_Ve_di+igc0_Ve_di*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Ve_di+(((igc0_Ve_di*T4)+(igc0*T4_Ve_di)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Ve_di)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Ve_di/T5/T5/T5);
  igcd_Vsi_s_Vge_si=((+igc0_Vsi_s_Vge_si*T4+igc0_Vsi_s*T4_Vge_si+igc0_Vge_si*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vge_si+(((igc0_Vge_si*T4)+(igc0*T4_Vge_si)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vge_si)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vge_si/T5/T5/T5);
  igcd_Vsi_s_Tempt_GND=((+igc0_Vsi_s_Tempt_GND*T4+igc0_Vsi_s*T4_Tempt_GND+igc0_Tempt_GND*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Tempt_GND+(((igc0_Tempt_GND*T4)+(igc0*T4_Tempt_GND)))*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Tempt_GND)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Tempt_GND/T5/T5/T5);
  igcd_Vsi_s_Vdi_d=((+igc0_Vsi_s_Vdi_d*T4+igc0_Vsi_s*0.0+igc0_Vdi_d*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vdi_d+(igc0_Vdi_d*T4)*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vdi_d)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vdi_d/T5/T5/T5);
  igcd_Vsi_s_Vsi_s=((+igc0_Vsi_s_Vsi_s*T4+igc0_Vsi_s*0.0+igc0_Vsi_s*0.0+igc0*0.0)/T5-(igc0_Vsi_s*T4*T5_Vsi_s+(igc0_Vsi_s*T4)*T5_Vsi_s+(igc0*T4)*T5_Vsi_s_Vsi_s)/T5/T5+2*(igc0*T4)*T5_Vsi_s*T5_Vsi_s/T5/T5/T5);
#endif
#endif
igcd=((igc0*T4)/T5);
EXIT_IF_ISNAN(((igc0*T4)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcs_Vge_di=((((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5-(igc0*T3)*T5_Vge_di)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vge_di_Vge_di=((+igc0_Vge_di_Vge_di*T3+igc0_Vge_di*T3_Vge_di+igc0_Vge_di*T3_Vge_di+igc0*T3_Vge_di_Vge_di)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vge_di/T5/T5/T5);
  igcs_Vge_di_Vge_e=((+igc0_Vge_di_Vge_e*T3+igc0_Vge_di*T3_Vge_e+igc0_Vge_e*T3_Vge_di+igc0*T3_Vge_di_Vge_e)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vge_e/T5/T5/T5);
  igcs_Vge_di_Vdi_si=((+igc0_Vge_di_Vdi_si*T3+igc0_Vge_di*T3_Vdi_si+igc0_Vdi_si*T3_Vge_di+igc0*T3_Vge_di_Vdi_si)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vdi_si/T5/T5/T5);
  igcs_Vge_di_Ve_si=((+igc0_Vge_di_Ve_si*T3+igc0_Vge_di*T3_Ve_si+igc0_Ve_si*T3_Vge_di+igc0*T3_Vge_di_Ve_si)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Ve_si/T5/T5/T5);
  igcs_Vge_di_Ve_di=((+igc0_Vge_di_Ve_di*T3+igc0_Vge_di*T3_Ve_di+igc0_Ve_di*T3_Vge_di+igc0*T3_Vge_di_Ve_di)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Ve_di/T5/T5/T5);
  igcs_Vge_di_Vge_si=((+igc0_Vge_di_Vge_si*T3+igc0_Vge_di*T3_Vge_si+igc0_Vge_si*T3_Vge_di+igc0*T3_Vge_di_Vge_si)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vge_si/T5/T5/T5);
  igcs_Vge_di_Tempt_GND=((+igc0_Vge_di_Tempt_GND*T3+igc0_Vge_di*T3_Tempt_GND+igc0_Tempt_GND*T3_Vge_di+igc0*T3_Vge_di_Tempt_GND)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Tempt_GND/T5/T5/T5);
  igcs_Vge_di_Vdi_d=((+igc0_Vge_di_Vdi_d*T3+igc0_Vge_di*T3_Vdi_d+igc0_Vdi_d*T3_Vge_di+igc0*T3_Vge_di_Vdi_d)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vdi_d/T5/T5/T5);
  igcs_Vge_di_Vsi_s=((+igc0_Vge_di_Vsi_s*T3+igc0_Vge_di*T3_Vsi_s+igc0_Vsi_s*T3_Vge_di+igc0*T3_Vge_di_Vsi_s)/T5-(((igc0_Vge_di*T3)+(igc0*T3_Vge_di))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vge_di+(igc0*T3)*T5_Vge_di_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vge_di*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Vge_e=((((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5-(igc0*T3)*T5_Vge_e)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vge_e_Vge_di=((+igc0_Vge_e_Vge_di*T3+igc0_Vge_e*T3_Vge_di+igc0_Vge_di*T3_Vge_e+igc0*T3_Vge_e_Vge_di)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vge_di/T5/T5/T5);
  igcs_Vge_e_Vge_e=((+igc0_Vge_e_Vge_e*T3+igc0_Vge_e*T3_Vge_e+igc0_Vge_e*T3_Vge_e+igc0*T3_Vge_e_Vge_e)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vge_e/T5/T5/T5);
  igcs_Vge_e_Vdi_si=((+igc0_Vge_e_Vdi_si*T3+igc0_Vge_e*T3_Vdi_si+igc0_Vdi_si*T3_Vge_e+igc0*T3_Vge_e_Vdi_si)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vdi_si/T5/T5/T5);
  igcs_Vge_e_Ve_si=((+igc0_Vge_e_Ve_si*T3+igc0_Vge_e*T3_Ve_si+igc0_Ve_si*T3_Vge_e+igc0*T3_Vge_e_Ve_si)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Ve_si/T5/T5/T5);
  igcs_Vge_e_Ve_di=((+igc0_Vge_e_Ve_di*T3+igc0_Vge_e*T3_Ve_di+igc0_Ve_di*T3_Vge_e+igc0*T3_Vge_e_Ve_di)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Ve_di/T5/T5/T5);
  igcs_Vge_e_Vge_si=((+igc0_Vge_e_Vge_si*T3+igc0_Vge_e*T3_Vge_si+igc0_Vge_si*T3_Vge_e+igc0*T3_Vge_e_Vge_si)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vge_si/T5/T5/T5);
  igcs_Vge_e_Tempt_GND=((+igc0_Vge_e_Tempt_GND*T3+igc0_Vge_e*T3_Tempt_GND+igc0_Tempt_GND*T3_Vge_e+igc0*T3_Vge_e_Tempt_GND)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Tempt_GND/T5/T5/T5);
  igcs_Vge_e_Vdi_d=((+igc0_Vge_e_Vdi_d*T3+igc0_Vge_e*T3_Vdi_d+igc0_Vdi_d*T3_Vge_e+igc0*T3_Vge_e_Vdi_d)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vdi_d/T5/T5/T5);
  igcs_Vge_e_Vsi_s=((+igc0_Vge_e_Vsi_s*T3+igc0_Vge_e*T3_Vsi_s+igc0_Vsi_s*T3_Vge_e+igc0*T3_Vge_e_Vsi_s)/T5-(((igc0_Vge_e*T3)+(igc0*T3_Vge_e))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vge_e+(igc0*T3)*T5_Vge_e_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vge_e*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Vdi_si=((((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5-(igc0*T3)*T5_Vdi_si)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vdi_si_Vge_di=((+igc0_Vdi_si_Vge_di*T3+igc0_Vdi_si*T3_Vge_di+igc0_Vge_di*T3_Vdi_si+igc0*T3_Vdi_si_Vge_di)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vge_di/T5/T5/T5);
  igcs_Vdi_si_Vge_e=((+igc0_Vdi_si_Vge_e*T3+igc0_Vdi_si*T3_Vge_e+igc0_Vge_e*T3_Vdi_si+igc0*T3_Vdi_si_Vge_e)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vge_e/T5/T5/T5);
  igcs_Vdi_si_Vdi_si=((+igc0_Vdi_si_Vdi_si*T3+igc0_Vdi_si*T3_Vdi_si+igc0_Vdi_si*T3_Vdi_si+igc0*T3_Vdi_si_Vdi_si)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vdi_si/T5/T5/T5);
  igcs_Vdi_si_Ve_si=((+igc0_Vdi_si_Ve_si*T3+igc0_Vdi_si*T3_Ve_si+igc0_Ve_si*T3_Vdi_si+igc0*T3_Vdi_si_Ve_si)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Ve_si/T5/T5/T5);
  igcs_Vdi_si_Ve_di=((+igc0_Vdi_si_Ve_di*T3+igc0_Vdi_si*T3_Ve_di+igc0_Ve_di*T3_Vdi_si+igc0*T3_Vdi_si_Ve_di)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Ve_di/T5/T5/T5);
  igcs_Vdi_si_Vge_si=((+igc0_Vdi_si_Vge_si*T3+igc0_Vdi_si*T3_Vge_si+igc0_Vge_si*T3_Vdi_si+igc0*T3_Vdi_si_Vge_si)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vge_si/T5/T5/T5);
  igcs_Vdi_si_Tempt_GND=((+igc0_Vdi_si_Tempt_GND*T3+igc0_Vdi_si*T3_Tempt_GND+igc0_Tempt_GND*T3_Vdi_si+igc0*T3_Vdi_si_Tempt_GND)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Tempt_GND/T5/T5/T5);
  igcs_Vdi_si_Vdi_d=((+igc0_Vdi_si_Vdi_d*T3+igc0_Vdi_si*T3_Vdi_d+igc0_Vdi_d*T3_Vdi_si+igc0*T3_Vdi_si_Vdi_d)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vdi_d/T5/T5/T5);
  igcs_Vdi_si_Vsi_s=((+igc0_Vdi_si_Vsi_s*T3+igc0_Vdi_si*T3_Vsi_s+igc0_Vsi_s*T3_Vdi_si+igc0*T3_Vdi_si_Vsi_s)/T5-(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vdi_si+(igc0*T3)*T5_Vdi_si_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vdi_si*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Ve_si=((((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5-(igc0*T3)*T5_Ve_si)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Ve_si_Vge_di=((+igc0_Ve_si_Vge_di*T3+igc0_Ve_si*T3_Vge_di+igc0_Vge_di*T3_Ve_si+igc0*T3_Ve_si_Vge_di)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vge_di)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vge_di/T5/T5/T5);
  igcs_Ve_si_Vge_e=((+igc0_Ve_si_Vge_e*T3+igc0_Ve_si*T3_Vge_e+igc0_Vge_e*T3_Ve_si+igc0*T3_Ve_si_Vge_e)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vge_e)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vge_e/T5/T5/T5);
  igcs_Ve_si_Vdi_si=((+igc0_Ve_si_Vdi_si*T3+igc0_Ve_si*T3_Vdi_si+igc0_Vdi_si*T3_Ve_si+igc0*T3_Ve_si_Vdi_si)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vdi_si/T5/T5/T5);
  igcs_Ve_si_Ve_si=((+igc0_Ve_si_Ve_si*T3+igc0_Ve_si*T3_Ve_si+igc0_Ve_si*T3_Ve_si+igc0*T3_Ve_si_Ve_si)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Ve_si)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Ve_si/T5/T5/T5);
  igcs_Ve_si_Ve_di=((+igc0_Ve_si_Ve_di*T3+igc0_Ve_si*T3_Ve_di+igc0_Ve_di*T3_Ve_si+igc0*T3_Ve_si_Ve_di)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Ve_di)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Ve_di/T5/T5/T5);
  igcs_Ve_si_Vge_si=((+igc0_Ve_si_Vge_si*T3+igc0_Ve_si*T3_Vge_si+igc0_Vge_si*T3_Ve_si+igc0*T3_Ve_si_Vge_si)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vge_si)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vge_si/T5/T5/T5);
  igcs_Ve_si_Tempt_GND=((+igc0_Ve_si_Tempt_GND*T3+igc0_Ve_si*T3_Tempt_GND+igc0_Tempt_GND*T3_Ve_si+igc0*T3_Ve_si_Tempt_GND)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Tempt_GND/T5/T5/T5);
  igcs_Ve_si_Vdi_d=((+igc0_Ve_si_Vdi_d*T3+igc0_Ve_si*T3_Vdi_d+igc0_Vdi_d*T3_Ve_si+igc0*T3_Ve_si_Vdi_d)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vdi_d/T5/T5/T5);
  igcs_Ve_si_Vsi_s=((+igc0_Ve_si_Vsi_s*T3+igc0_Ve_si*T3_Vsi_s+igc0_Vsi_s*T3_Ve_si+igc0*T3_Ve_si_Vsi_s)/T5-(((igc0_Ve_si*T3)+(igc0*T3_Ve_si))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Ve_si+(igc0*T3)*T5_Ve_si_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Ve_si*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Ve_di=((((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5-(igc0*T3)*T5_Ve_di)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Ve_di_Vge_di=((+igc0_Ve_di_Vge_di*T3+igc0_Ve_di*T3_Vge_di+igc0_Vge_di*T3_Ve_di+igc0*T3_Ve_di_Vge_di)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vge_di)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vge_di/T5/T5/T5);
  igcs_Ve_di_Vge_e=((+igc0_Ve_di_Vge_e*T3+igc0_Ve_di*T3_Vge_e+igc0_Vge_e*T3_Ve_di+igc0*T3_Ve_di_Vge_e)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vge_e)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vge_e/T5/T5/T5);
  igcs_Ve_di_Vdi_si=((+igc0_Ve_di_Vdi_si*T3+igc0_Ve_di*T3_Vdi_si+igc0_Vdi_si*T3_Ve_di+igc0*T3_Ve_di_Vdi_si)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vdi_si/T5/T5/T5);
  igcs_Ve_di_Ve_si=((+igc0_Ve_di_Ve_si*T3+igc0_Ve_di*T3_Ve_si+igc0_Ve_si*T3_Ve_di+igc0*T3_Ve_di_Ve_si)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Ve_si)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Ve_si/T5/T5/T5);
  igcs_Ve_di_Ve_di=((+igc0_Ve_di_Ve_di*T3+igc0_Ve_di*T3_Ve_di+igc0_Ve_di*T3_Ve_di+igc0*T3_Ve_di_Ve_di)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Ve_di)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Ve_di/T5/T5/T5);
  igcs_Ve_di_Vge_si=((+igc0_Ve_di_Vge_si*T3+igc0_Ve_di*T3_Vge_si+igc0_Vge_si*T3_Ve_di+igc0*T3_Ve_di_Vge_si)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vge_si)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vge_si/T5/T5/T5);
  igcs_Ve_di_Tempt_GND=((+igc0_Ve_di_Tempt_GND*T3+igc0_Ve_di*T3_Tempt_GND+igc0_Tempt_GND*T3_Ve_di+igc0*T3_Ve_di_Tempt_GND)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Tempt_GND/T5/T5/T5);
  igcs_Ve_di_Vdi_d=((+igc0_Ve_di_Vdi_d*T3+igc0_Ve_di*T3_Vdi_d+igc0_Vdi_d*T3_Ve_di+igc0*T3_Ve_di_Vdi_d)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vdi_d/T5/T5/T5);
  igcs_Ve_di_Vsi_s=((+igc0_Ve_di_Vsi_s*T3+igc0_Ve_di*T3_Vsi_s+igc0_Vsi_s*T3_Ve_di+igc0*T3_Ve_di_Vsi_s)/T5-(((igc0_Ve_di*T3)+(igc0*T3_Ve_di))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Ve_di+(igc0*T3)*T5_Ve_di_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Ve_di*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Vge_si=((((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5-(igc0*T3)*T5_Vge_si)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vge_si_Vge_di=((+igc0_Vge_si_Vge_di*T3+igc0_Vge_si*T3_Vge_di+igc0_Vge_di*T3_Vge_si+igc0*T3_Vge_si_Vge_di)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vge_di/T5/T5/T5);
  igcs_Vge_si_Vge_e=((+igc0_Vge_si_Vge_e*T3+igc0_Vge_si*T3_Vge_e+igc0_Vge_e*T3_Vge_si+igc0*T3_Vge_si_Vge_e)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vge_e/T5/T5/T5);
  igcs_Vge_si_Vdi_si=((+igc0_Vge_si_Vdi_si*T3+igc0_Vge_si*T3_Vdi_si+igc0_Vdi_si*T3_Vge_si+igc0*T3_Vge_si_Vdi_si)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vdi_si/T5/T5/T5);
  igcs_Vge_si_Ve_si=((+igc0_Vge_si_Ve_si*T3+igc0_Vge_si*T3_Ve_si+igc0_Ve_si*T3_Vge_si+igc0*T3_Vge_si_Ve_si)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Ve_si/T5/T5/T5);
  igcs_Vge_si_Ve_di=((+igc0_Vge_si_Ve_di*T3+igc0_Vge_si*T3_Ve_di+igc0_Ve_di*T3_Vge_si+igc0*T3_Vge_si_Ve_di)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Ve_di/T5/T5/T5);
  igcs_Vge_si_Vge_si=((+igc0_Vge_si_Vge_si*T3+igc0_Vge_si*T3_Vge_si+igc0_Vge_si*T3_Vge_si+igc0*T3_Vge_si_Vge_si)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vge_si/T5/T5/T5);
  igcs_Vge_si_Tempt_GND=((+igc0_Vge_si_Tempt_GND*T3+igc0_Vge_si*T3_Tempt_GND+igc0_Tempt_GND*T3_Vge_si+igc0*T3_Vge_si_Tempt_GND)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Tempt_GND/T5/T5/T5);
  igcs_Vge_si_Vdi_d=((+igc0_Vge_si_Vdi_d*T3+igc0_Vge_si*T3_Vdi_d+igc0_Vdi_d*T3_Vge_si+igc0*T3_Vge_si_Vdi_d)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vdi_d/T5/T5/T5);
  igcs_Vge_si_Vsi_s=((+igc0_Vge_si_Vsi_s*T3+igc0_Vge_si*T3_Vsi_s+igc0_Vsi_s*T3_Vge_si+igc0*T3_Vge_si_Vsi_s)/T5-(((igc0_Vge_si*T3)+(igc0*T3_Vge_si))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vge_si+(igc0*T3)*T5_Vge_si_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vge_si*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Tempt_GND=((((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5-(igc0*T3)*T5_Tempt_GND)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Tempt_GND_Vge_di=((+igc0_Tempt_GND_Vge_di*T3+igc0_Tempt_GND*T3_Vge_di+igc0_Vge_di*T3_Tempt_GND+igc0*T3_Tempt_GND_Vge_di)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vge_di)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vge_di/T5/T5/T5);
  igcs_Tempt_GND_Vge_e=((+igc0_Tempt_GND_Vge_e*T3+igc0_Tempt_GND*T3_Vge_e+igc0_Vge_e*T3_Tempt_GND+igc0*T3_Tempt_GND_Vge_e)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vge_e)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vge_e/T5/T5/T5);
  igcs_Tempt_GND_Vdi_si=((+igc0_Tempt_GND_Vdi_si*T3+igc0_Tempt_GND*T3_Vdi_si+igc0_Vdi_si*T3_Tempt_GND+igc0*T3_Tempt_GND_Vdi_si)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vdi_si/T5/T5/T5);
  igcs_Tempt_GND_Ve_si=((+igc0_Tempt_GND_Ve_si*T3+igc0_Tempt_GND*T3_Ve_si+igc0_Ve_si*T3_Tempt_GND+igc0*T3_Tempt_GND_Ve_si)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Ve_si)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Ve_si/T5/T5/T5);
  igcs_Tempt_GND_Ve_di=((+igc0_Tempt_GND_Ve_di*T3+igc0_Tempt_GND*T3_Ve_di+igc0_Ve_di*T3_Tempt_GND+igc0*T3_Tempt_GND_Ve_di)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Ve_di)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Ve_di/T5/T5/T5);
  igcs_Tempt_GND_Vge_si=((+igc0_Tempt_GND_Vge_si*T3+igc0_Tempt_GND*T3_Vge_si+igc0_Vge_si*T3_Tempt_GND+igc0*T3_Tempt_GND_Vge_si)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vge_si)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vge_si/T5/T5/T5);
  igcs_Tempt_GND_Tempt_GND=((+igc0_Tempt_GND_Tempt_GND*T3+igc0_Tempt_GND*T3_Tempt_GND+igc0_Tempt_GND*T3_Tempt_GND+igc0*T3_Tempt_GND_Tempt_GND)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Tempt_GND/T5/T5/T5);
  igcs_Tempt_GND_Vdi_d=((+igc0_Tempt_GND_Vdi_d*T3+igc0_Tempt_GND*T3_Vdi_d+igc0_Vdi_d*T3_Tempt_GND+igc0*T3_Tempt_GND_Vdi_d)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vdi_d/T5/T5/T5);
  igcs_Tempt_GND_Vsi_s=((+igc0_Tempt_GND_Vsi_s*T3+igc0_Tempt_GND*T3_Vsi_s+igc0_Vsi_s*T3_Tempt_GND+igc0*T3_Tempt_GND_Vsi_s)/T5-(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Tempt_GND+(igc0*T3)*T5_Tempt_GND_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Tempt_GND*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Vdi_d=((((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5-(igc0*T3)*T5_Vdi_d)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vdi_d_Vge_di=((+igc0_Vdi_d_Vge_di*T3+igc0_Vdi_d*T3_Vge_di+igc0_Vge_di*T3_Vdi_d+igc0*T3_Vdi_d_Vge_di)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vge_di/T5/T5/T5);
  igcs_Vdi_d_Vge_e=((+igc0_Vdi_d_Vge_e*T3+igc0_Vdi_d*T3_Vge_e+igc0_Vge_e*T3_Vdi_d+igc0*T3_Vdi_d_Vge_e)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vge_e/T5/T5/T5);
  igcs_Vdi_d_Vdi_si=((+igc0_Vdi_d_Vdi_si*T3+igc0_Vdi_d*T3_Vdi_si+igc0_Vdi_si*T3_Vdi_d+igc0*T3_Vdi_d_Vdi_si)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vdi_si/T5/T5/T5);
  igcs_Vdi_d_Ve_si=((+igc0_Vdi_d_Ve_si*T3+igc0_Vdi_d*T3_Ve_si+igc0_Ve_si*T3_Vdi_d+igc0*T3_Vdi_d_Ve_si)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Ve_si/T5/T5/T5);
  igcs_Vdi_d_Ve_di=((+igc0_Vdi_d_Ve_di*T3+igc0_Vdi_d*T3_Ve_di+igc0_Ve_di*T3_Vdi_d+igc0*T3_Vdi_d_Ve_di)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Ve_di/T5/T5/T5);
  igcs_Vdi_d_Vge_si=((+igc0_Vdi_d_Vge_si*T3+igc0_Vdi_d*T3_Vge_si+igc0_Vge_si*T3_Vdi_d+igc0*T3_Vdi_d_Vge_si)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vge_si/T5/T5/T5);
  igcs_Vdi_d_Tempt_GND=((+igc0_Vdi_d_Tempt_GND*T3+igc0_Vdi_d*T3_Tempt_GND+igc0_Tempt_GND*T3_Vdi_d+igc0*T3_Vdi_d_Tempt_GND)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Tempt_GND/T5/T5/T5);
  igcs_Vdi_d_Vdi_d=((+igc0_Vdi_d_Vdi_d*T3+igc0_Vdi_d*T3_Vdi_d+igc0_Vdi_d*T3_Vdi_d+igc0*T3_Vdi_d_Vdi_d)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vdi_d/T5/T5/T5);
  igcs_Vdi_d_Vsi_s=((+igc0_Vdi_d_Vsi_s*T3+igc0_Vdi_d*T3_Vsi_s+igc0_Vsi_s*T3_Vdi_d+igc0*T3_Vdi_d_Vsi_s)/T5-(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vdi_d+(igc0*T3)*T5_Vdi_d_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vdi_d*T5_Vsi_s/T5/T5/T5);
#endif
igcs_Vsi_s=((((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5-(igc0*T3)*T5_Vsi_s)/T5/T5);
#if defined(_DERIVATE2)
  igcs_Vsi_s_Vge_di=((+igc0_Vsi_s_Vge_di*T3+igc0_Vsi_s*T3_Vge_di+igc0_Vge_di*T3_Vsi_s+igc0*T3_Vsi_s_Vge_di)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vge_di+(((igc0_Vge_di*T3)+(igc0*T3_Vge_di)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vge_di)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vge_di/T5/T5/T5);
  igcs_Vsi_s_Vge_e=((+igc0_Vsi_s_Vge_e*T3+igc0_Vsi_s*T3_Vge_e+igc0_Vge_e*T3_Vsi_s+igc0*T3_Vsi_s_Vge_e)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vge_e+(((igc0_Vge_e*T3)+(igc0*T3_Vge_e)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vge_e)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vge_e/T5/T5/T5);
  igcs_Vsi_s_Vdi_si=((+igc0_Vsi_s_Vdi_si*T3+igc0_Vsi_s*T3_Vdi_si+igc0_Vdi_si*T3_Vsi_s+igc0*T3_Vsi_s_Vdi_si)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vdi_si+(((igc0_Vdi_si*T3)+(igc0*T3_Vdi_si)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vdi_si)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vdi_si/T5/T5/T5);
  igcs_Vsi_s_Ve_si=((+igc0_Vsi_s_Ve_si*T3+igc0_Vsi_s*T3_Ve_si+igc0_Ve_si*T3_Vsi_s+igc0*T3_Vsi_s_Ve_si)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Ve_si+(((igc0_Ve_si*T3)+(igc0*T3_Ve_si)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Ve_si)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Ve_si/T5/T5/T5);
  igcs_Vsi_s_Ve_di=((+igc0_Vsi_s_Ve_di*T3+igc0_Vsi_s*T3_Ve_di+igc0_Ve_di*T3_Vsi_s+igc0*T3_Vsi_s_Ve_di)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Ve_di+(((igc0_Ve_di*T3)+(igc0*T3_Ve_di)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Ve_di)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Ve_di/T5/T5/T5);
  igcs_Vsi_s_Vge_si=((+igc0_Vsi_s_Vge_si*T3+igc0_Vsi_s*T3_Vge_si+igc0_Vge_si*T3_Vsi_s+igc0*T3_Vsi_s_Vge_si)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vge_si+(((igc0_Vge_si*T3)+(igc0*T3_Vge_si)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vge_si)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vge_si/T5/T5/T5);
  igcs_Vsi_s_Tempt_GND=((+igc0_Vsi_s_Tempt_GND*T3+igc0_Vsi_s*T3_Tempt_GND+igc0_Tempt_GND*T3_Vsi_s+igc0*T3_Vsi_s_Tempt_GND)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Tempt_GND+(((igc0_Tempt_GND*T3)+(igc0*T3_Tempt_GND)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Tempt_GND)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Tempt_GND/T5/T5/T5);
  igcs_Vsi_s_Vdi_d=((+igc0_Vsi_s_Vdi_d*T3+igc0_Vsi_s*T3_Vdi_d+igc0_Vdi_d*T3_Vsi_s+igc0*T3_Vsi_s_Vdi_d)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vdi_d+(((igc0_Vdi_d*T3)+(igc0*T3_Vdi_d)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vdi_d)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vdi_d/T5/T5/T5);
  igcs_Vsi_s_Vsi_s=((+igc0_Vsi_s_Vsi_s*T3+igc0_Vsi_s*T3_Vsi_s+igc0_Vsi_s*T3_Vsi_s+igc0*T3_Vsi_s_Vsi_s)/T5-(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s))*T5_Vsi_s+(((igc0_Vsi_s*T3)+(igc0*T3_Vsi_s)))*T5_Vsi_s+(igc0*T3)*T5_Vsi_s_Vsi_s)/T5/T5+2*(igc0*T3)*T5_Vsi_s*T5_Vsi_s/T5/T5/T5);
#endif
#endif
igcs=((igc0*T3)/T5);
EXIT_IF_ISNAN(((igc0*T3)/T5))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=vgs_noswap_Vge_si;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0-0.0);
  T0_Vge_si_Vge_e=(+0.0-0.0);
  T0_Vge_si_Ve_si=(+0.0-0.0);
  T0_Vge_si_Ve_di=(+0.0-0.0);
  T0_Vge_si_Vge_si=(+vgs_noswap_Vge_si_Vge_si-0.0);
  T0_Vge_si_Vdi_si=(+0.0-0.0);
  T0_Vge_si_Tempt_GND=(+0.0-0.0);
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-vfbsd_Tempt_GND);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_e=(+0.0-0.0);
  T0_Tempt_GND_Ve_si=(+0.0-0.0);
  T0_Tempt_GND_Ve_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_si=(+0.0-0.0);
  T0_Tempt_GND_Vdi_si=(+0.0-0.0);
  T0_Tempt_GND_Tempt_GND=(+0.0-vfbsd_Tempt_GND_Tempt_GND);
#endif
#endif
T0=(vgs_noswap-vfbsd);
EXIT_IF_ISNAN((vgs_noswap-vfbsd))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-4))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-4))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
vgs_eff_Vge_di=((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Vge_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+0.0));
  vgs_eff_Vge_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+0.0));
  vgs_eff_Vge_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+0.0));
  vgs_eff_Vge_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+0.0));
  vgs_eff_Vge_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+0.0));
  vgs_eff_Vge_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+0.0));
  vgs_eff_Vge_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+0.0));
#endif
vgs_eff_Vge_e=((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Vge_e_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+0.0));
  vgs_eff_Vge_e_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+0.0));
  vgs_eff_Vge_e_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+0.0));
  vgs_eff_Vge_e_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+0.0));
  vgs_eff_Vge_e_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+0.0));
  vgs_eff_Vge_e_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+0.0));
  vgs_eff_Vge_e_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+0.0));
#endif
vgs_eff_Vge_si=((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Vge_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+0.0));
  vgs_eff_Vge_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+0.0));
  vgs_eff_Vge_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+0.0));
  vgs_eff_Vge_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+0.0));
  vgs_eff_Vge_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+0.0));
  vgs_eff_Vge_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+0.0));
  vgs_eff_Vge_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+0.0));
#endif
vgs_eff_Ve_si=((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Ve_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+0.0));
  vgs_eff_Ve_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+0.0));
  vgs_eff_Ve_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+0.0));
  vgs_eff_Ve_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+0.0));
  vgs_eff_Ve_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+0.0));
  vgs_eff_Ve_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+0.0));
  vgs_eff_Ve_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+0.0));
#endif
vgs_eff_Ve_di=((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Ve_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+0.0));
  vgs_eff_Ve_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+0.0));
  vgs_eff_Ve_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+0.0));
  vgs_eff_Ve_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+0.0));
  vgs_eff_Ve_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+0.0));
  vgs_eff_Ve_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+0.0));
  vgs_eff_Ve_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+0.0));
#endif
vgs_eff_Vdi_si=((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Vdi_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+0.0));
  vgs_eff_Vdi_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+0.0));
  vgs_eff_Vdi_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+0.0));
  vgs_eff_Vdi_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+0.0));
  vgs_eff_Vdi_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+0.0));
  vgs_eff_Vdi_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+0.0));
  vgs_eff_Vdi_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+0.0));
#endif
vgs_eff_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgs_eff_Tempt_GND_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+0.0));
  vgs_eff_Tempt_GND_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+0.0));
  vgs_eff_Tempt_GND_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+0.0));
  vgs_eff_Tempt_GND_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+0.0));
  vgs_eff_Tempt_GND_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+0.0));
  vgs_eff_Tempt_GND_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+0.0));
  vgs_eff_Tempt_GND_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
vgs_eff=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pModel->IGCLAMP==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Vge_di)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Vge_e)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Ve_si)),0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Ve_di)),0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Vge_si)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(-(BIGS_i*vgs_eff_Vdi_si)),0.0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6,(AIGS_t_Tempt_GND-(BIGS_i*vgs_eff_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((AIGS_t-(BIGS_i*vgs_eff)),1.0e-6))
if
((CIGS_i<0.01))
{
CIGS_i=0.01;
EXIT_IF_ISNAN(0.01)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-(BIGS_i*vgs_eff_Vge_di));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_di+BIGS_i*0.0));
  T1_Vge_di_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_di+BIGS_i*0.0));
  T1_Vge_di_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Vge_di));
  T1_Vge_di_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Vge_e));
  T1_Vge_di_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Ve_si));
  T1_Vge_di_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Ve_di));
  T1_Vge_di_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Vge_si));
  T1_Vge_di_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Vdi_si));
  T1_Vge_di_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_di+BIGS_i*vgs_eff_Vge_di_Tempt_GND));
#endif
T1_Vge_e=(-(BIGS_i*vgs_eff_Vge_e));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_e+BIGS_i*0.0));
  T1_Vge_e_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_e+BIGS_i*0.0));
  T1_Vge_e_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Vge_di));
  T1_Vge_e_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Vge_e));
  T1_Vge_e_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Ve_si));
  T1_Vge_e_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Ve_di));
  T1_Vge_e_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Vge_si));
  T1_Vge_e_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Vdi_si));
  T1_Vge_e_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_e+BIGS_i*vgs_eff_Vge_e_Tempt_GND));
#endif
T1_Ve_si=(-(BIGS_i*vgs_eff_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_si+BIGS_i*0.0));
  T1_Ve_si_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_si+BIGS_i*0.0));
  T1_Ve_si_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Vge_di));
  T1_Ve_si_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Vge_e));
  T1_Ve_si_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Ve_si));
  T1_Ve_si_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Ve_di));
  T1_Ve_si_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Vge_si));
  T1_Ve_si_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Vdi_si));
  T1_Ve_si_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_si+BIGS_i*vgs_eff_Ve_si_Tempt_GND));
#endif
T1_Ve_di=(-(BIGS_i*vgs_eff_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_di+BIGS_i*0.0));
  T1_Ve_di_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_di+BIGS_i*0.0));
  T1_Ve_di_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Vge_di));
  T1_Ve_di_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Vge_e));
  T1_Ve_di_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Ve_si));
  T1_Ve_di_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Ve_di));
  T1_Ve_di_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Vge_si));
  T1_Ve_di_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Vdi_si));
  T1_Ve_di_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_di+BIGS_i*vgs_eff_Ve_di_Tempt_GND));
#endif
T1_Vge_si=(-(BIGS_i*vgs_eff_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_si+BIGS_i*0.0));
  T1_Vge_si_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_si+BIGS_i*0.0));
  T1_Vge_si_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Vge_di));
  T1_Vge_si_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Vge_e));
  T1_Vge_si_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Ve_si));
  T1_Vge_si_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Ve_di));
  T1_Vge_si_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Vge_si));
  T1_Vge_si_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Vdi_si));
  T1_Vge_si_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_si+BIGS_i*vgs_eff_Vge_si_Tempt_GND));
#endif
T1_Vdi_si=(-(BIGS_i*vgs_eff_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vdi_si+BIGS_i*0.0));
  T1_Vdi_si_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vdi_si+BIGS_i*0.0));
  T1_Vdi_si_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Vge_di));
  T1_Vdi_si_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Vge_e));
  T1_Vdi_si_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Ve_si));
  T1_Vdi_si_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Ve_di));
  T1_Vdi_si_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Vge_si));
  T1_Vdi_si_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Vdi_si));
  T1_Vdi_si_Tempt_GND=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vdi_si+BIGS_i*vgs_eff_Vdi_si_Tempt_GND));
#endif
T1_Tempt_GND=(AIGS_t_Tempt_GND-(BIGS_i*vgs_eff_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Tempt_GND+BIGS_i*0.0));
  T1_Tempt_GND_Vsi_s=(+0.0-(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Tempt_GND+BIGS_i*0.0));
  T1_Tempt_GND_Vge_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Vge_di));
  T1_Tempt_GND_Vge_e=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Vge_e));
  T1_Tempt_GND_Ve_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Ve_si));
  T1_Tempt_GND_Ve_di=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Ve_di));
  T1_Tempt_GND_Vge_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Vge_si));
  T1_Tempt_GND_Vdi_si=(+0.0-(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Vdi_si));
  T1_Tempt_GND_Tempt_GND=(+AIGS_t_Tempt_GND_Tempt_GND-(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Tempt_GND+BIGS_i*vgs_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T1=(AIGS_t-(BIGS_i*vgs_eff));
EXIT_IF_ISNAN((AIGS_t-(BIGS_i*vgs_eff)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(CIGS_i*vgs_eff_Vge_di);
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_di+CIGS_i*0.0));
  T2_Vge_di_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_di+CIGS_i*0.0));
  T2_Vge_di_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Vge_di));
  T2_Vge_di_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Vge_e));
  T2_Vge_di_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Vge_si));
  T2_Vge_di_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Ve_si));
  T2_Vge_di_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Ve_di));
  T2_Vge_di_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Vdi_si));
  T2_Vge_di_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_di+CIGS_i*vgs_eff_Vge_di_Tempt_GND));
#endif
T2_Vge_e=(CIGS_i*vgs_eff_Vge_e);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_e+CIGS_i*0.0));
  T2_Vge_e_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_e+CIGS_i*0.0));
  T2_Vge_e_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Vge_di));
  T2_Vge_e_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Vge_e));
  T2_Vge_e_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Vge_si));
  T2_Vge_e_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Ve_si));
  T2_Vge_e_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Ve_di));
  T2_Vge_e_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Vdi_si));
  T2_Vge_e_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_e+CIGS_i*vgs_eff_Vge_e_Tempt_GND));
#endif
T2_Vge_si=(CIGS_i*vgs_eff_Vge_si);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_si+CIGS_i*0.0));
  T2_Vge_si_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vge_si+CIGS_i*0.0));
  T2_Vge_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Vge_di));
  T2_Vge_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Vge_e));
  T2_Vge_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Vge_si));
  T2_Vge_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Ve_si));
  T2_Vge_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Ve_di));
  T2_Vge_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Vdi_si));
  T2_Vge_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vge_si+CIGS_i*vgs_eff_Vge_si_Tempt_GND));
#endif
T2_Ve_si=(CIGS_i*vgs_eff_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_si+CIGS_i*0.0));
  T2_Ve_si_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_si+CIGS_i*0.0));
  T2_Ve_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Vge_di));
  T2_Ve_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Vge_e));
  T2_Ve_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Vge_si));
  T2_Ve_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Ve_si));
  T2_Ve_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Ve_di));
  T2_Ve_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Vdi_si));
  T2_Ve_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_si+CIGS_i*vgs_eff_Ve_si_Tempt_GND));
#endif
T2_Ve_di=(CIGS_i*vgs_eff_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_di+CIGS_i*0.0));
  T2_Ve_di_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Ve_di+CIGS_i*0.0));
  T2_Ve_di_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Vge_di));
  T2_Ve_di_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Vge_e));
  T2_Ve_di_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Vge_si));
  T2_Ve_di_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Ve_si));
  T2_Ve_di_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Ve_di));
  T2_Ve_di_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Vdi_si));
  T2_Ve_di_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Ve_di+CIGS_i*vgs_eff_Ve_di_Tempt_GND));
#endif
T2_Vdi_si=(CIGS_i*vgs_eff_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vdi_si+CIGS_i*0.0));
  T2_Vdi_si_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Vdi_si+CIGS_i*0.0));
  T2_Vdi_si_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Vge_di));
  T2_Vdi_si_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Vge_e));
  T2_Vdi_si_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Vge_si));
  T2_Vdi_si_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Ve_si));
  T2_Vdi_si_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Ve_di));
  T2_Vdi_si_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Vdi_si));
  T2_Vdi_si_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Vdi_si+CIGS_i*vgs_eff_Vdi_si_Tempt_GND));
#endif
T2_Tempt_GND=(CIGS_i*vgs_eff_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Tempt_GND+CIGS_i*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0+(+0.0*vgs_eff+0.0*0.0+0.0*vgs_eff_Tempt_GND+CIGS_i*0.0));
  T2_Tempt_GND_Vge_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_di+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Vge_di));
  T2_Tempt_GND_Vge_e=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_e+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Vge_e));
  T2_Tempt_GND_Vge_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vge_si+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Vge_si));
  T2_Tempt_GND_Ve_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_si+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Ve_si));
  T2_Tempt_GND_Ve_di=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Ve_di+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Ve_di));
  T2_Tempt_GND_Vdi_si=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Vdi_si+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Vdi_si));
  T2_Tempt_GND_Tempt_GND=(+0.0+(+0.0*vgs_eff+0.0*vgs_eff_Tempt_GND+0.0*vgs_eff_Tempt_GND+CIGS_i*vgs_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T2=(1.0+(CIGS_i*vgs_eff));
EXIT_IF_ISNAN((1.0+(CIGS_i*vgs_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Tempt_GND);
#endif
T3_Vge_e=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Tempt_GND);
#endif
T3_Ve_di=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Tempt_GND);
#endif
T3_Vge_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T3=(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2);
EXIT_IF_ISNAN((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=bsimcmg_d_lexp(T3,T3_Vge_di);
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=T3_Vge_di_Vge_di;
  T4_Vge_di_Vge_e=T3_Vge_di_Vge_e;
  T4_Vge_di_Vdi_si=T3_Vge_di_Vdi_si;
  T4_Vge_di_Ve_si=T3_Vge_di_Ve_si;
  T4_Vge_di_Ve_di=T3_Vge_di_Ve_di;
  T4_Vge_di_Vge_si=T3_Vge_di_Vge_si;
  T4_Vge_di_Tempt_GND=T3_Vge_di_Tempt_GND;
#endif
T4_Vge_e=bsimcmg_d_lexp(T3,T3_Vge_e);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=T3_Vge_e_Vge_di;
  T4_Vge_e_Vge_e=T3_Vge_e_Vge_e;
  T4_Vge_e_Vdi_si=T3_Vge_e_Vdi_si;
  T4_Vge_e_Ve_si=T3_Vge_e_Ve_si;
  T4_Vge_e_Ve_di=T3_Vge_e_Ve_di;
  T4_Vge_e_Vge_si=T3_Vge_e_Vge_si;
  T4_Vge_e_Tempt_GND=T3_Vge_e_Tempt_GND;
#endif
T4_Vdi_si=bsimcmg_d_lexp(T3,T3_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=T3_Vdi_si_Vge_di;
  T4_Vdi_si_Vge_e=T3_Vdi_si_Vge_e;
  T4_Vdi_si_Vdi_si=T3_Vdi_si_Vdi_si;
  T4_Vdi_si_Ve_si=T3_Vdi_si_Ve_si;
  T4_Vdi_si_Ve_di=T3_Vdi_si_Ve_di;
  T4_Vdi_si_Vge_si=T3_Vdi_si_Vge_si;
  T4_Vdi_si_Tempt_GND=T3_Vdi_si_Tempt_GND;
#endif
T4_Ve_si=bsimcmg_d_lexp(T3,T3_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=T3_Ve_si_Vge_di;
  T4_Ve_si_Vge_e=T3_Ve_si_Vge_e;
  T4_Ve_si_Vdi_si=T3_Ve_si_Vdi_si;
  T4_Ve_si_Ve_si=T3_Ve_si_Ve_si;
  T4_Ve_si_Ve_di=T3_Ve_si_Ve_di;
  T4_Ve_si_Vge_si=T3_Ve_si_Vge_si;
  T4_Ve_si_Tempt_GND=T3_Ve_si_Tempt_GND;
#endif
T4_Ve_di=bsimcmg_d_lexp(T3,T3_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=T3_Ve_di_Vge_di;
  T4_Ve_di_Vge_e=T3_Ve_di_Vge_e;
  T4_Ve_di_Vdi_si=T3_Ve_di_Vdi_si;
  T4_Ve_di_Ve_si=T3_Ve_di_Ve_si;
  T4_Ve_di_Ve_di=T3_Ve_di_Ve_di;
  T4_Ve_di_Vge_si=T3_Ve_di_Vge_si;
  T4_Ve_di_Tempt_GND=T3_Ve_di_Tempt_GND;
#endif
T4_Vge_si=bsimcmg_d_lexp(T3,T3_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=T3_Vge_si_Vge_di;
  T4_Vge_si_Vge_e=T3_Vge_si_Vge_e;
  T4_Vge_si_Vdi_si=T3_Vge_si_Vdi_si;
  T4_Vge_si_Ve_si=T3_Vge_si_Ve_si;
  T4_Vge_si_Ve_di=T3_Vge_si_Ve_di;
  T4_Vge_si_Vge_si=T3_Vge_si_Vge_si;
  T4_Vge_si_Tempt_GND=T3_Vge_si_Tempt_GND;
#endif
T4_Tempt_GND=bsimcmg_d_lexp(T3,T3_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=T3_Tempt_GND_Vge_di;
  T4_Tempt_GND_Vge_e=T3_Tempt_GND_Vge_e;
  T4_Tempt_GND_Vdi_si=T3_Tempt_GND_Vdi_si;
  T4_Tempt_GND_Ve_si=T3_Tempt_GND_Ve_si;
  T4_Tempt_GND_Ve_di=T3_Tempt_GND_Ve_di;
  T4_Tempt_GND_Vge_si=T3_Tempt_GND_Vge_si;
  T4_Tempt_GND_Tempt_GND=T3_Tempt_GND_Tempt_GND;
#endif
#endif
T4=bsimcmg_lexp(T3);
EXIT_IF_ISNAN(bsimcmg_lexp(T3))
if
((sigvds>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igs_Tempt_GND=((((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND));
#if defined(_DERIVATE2)
  igs_Tempt_GND_Tempt_GND=(+(+(+(+igsd_mult_Tempt_GND_Tempt_GND*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Tempt_GND)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Tempt_GND);
  igs_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_si);
  igs_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_di);
  igs_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_e)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_e);
  igs_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Ve_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Ve_si);
  igs_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Ve_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Ve_di);
  igs_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vdi_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vdi_si);
#endif
igs_Vge_si=((((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si));
#if defined(_DERIVATE2)
  igs_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Tempt_GND)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Tempt_GND);
  igs_Vge_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si_Vge_si)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_si);
  igs_Vge_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_di)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_di);
  igs_Vge_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_e)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_e);
  igs_Vge_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Ve_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Ve_si);
  igs_Vge_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Ve_di)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Ve_di);
  igs_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vdi_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vdi_si);
#endif
igs_Vge_di=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di));
#if defined(_DERIVATE2)
  igs_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Tempt_GND);
  igs_Vge_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_si);
  igs_Vge_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_di);
  igs_Vge_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_e);
  igs_Vge_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Ve_si);
  igs_Vge_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Ve_di);
  igs_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vdi_si);
#endif
igs_Vge_e=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e));
#if defined(_DERIVATE2)
  igs_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Tempt_GND);
  igs_Vge_e_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_si);
  igs_Vge_e_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_di);
  igs_Vge_e_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_e);
  igs_Vge_e_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Ve_si);
  igs_Vge_e_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Ve_di);
  igs_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vdi_si);
#endif
igs_Ve_si=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si));
#if defined(_DERIVATE2)
  igs_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Tempt_GND);
  igs_Ve_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_si);
  igs_Ve_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_di);
  igs_Ve_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_e);
  igs_Ve_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Ve_si);
  igs_Ve_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Ve_di);
  igs_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vdi_si);
#endif
igs_Ve_di=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di));
#if defined(_DERIVATE2)
  igs_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Tempt_GND);
  igs_Ve_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_si);
  igs_Ve_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_di);
  igs_Ve_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_e);
  igs_Ve_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Ve_si);
  igs_Ve_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Ve_di);
  igs_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vdi_si);
#endif
igs_Vdi_si=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si));
#if defined(_DERIVATE2)
  igs_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Tempt_GND);
  igs_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_si);
  igs_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_di);
  igs_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_e);
  igs_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Ve_si);
  igs_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Ve_di);
  igs_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vdi_si);
#endif
#endif
igs=((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4);
EXIT_IF_ISNAN(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igd_Tempt_GND=((((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND));
#if defined(_DERIVATE2)
  igd_Tempt_GND_Tempt_GND=(+(+(+(+igsd_mult_Tempt_GND_Tempt_GND*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Tempt_GND)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Tempt_GND);
  igd_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_si);
  igd_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_di);
  igd_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vge_e)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vge_e);
  igd_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Ve_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Ve_si);
  igd_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Ve_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Ve_di);
  igd_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+igsd_mult_Tempt_GND*pModel->DLCIGS*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Tempt_GND+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND_Vdi_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGS*vgs_noswap*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND))*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Tempt_GND_Vdi_si);
#endif
igd_Vge_si=((((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si));
#if defined(_DERIVATE2)
  igd_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Tempt_GND)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Tempt_GND);
  igd_Vge_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si_Vge_si)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_si);
  igd_Vge_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_di)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_di);
  igd_Vge_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vge_e)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vge_e);
  igd_Vge_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Ve_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Ve_si);
  igd_Vge_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Ve_di)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Ve_di);
  igd_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*vgs_noswap_Vge_si+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si_Vdi_si)*T4+((((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si))*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_si_Vdi_si);
#endif
igd_Vge_di=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di));
#if defined(_DERIVATE2)
  igd_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Tempt_GND);
  igd_Vge_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_si);
  igd_Vge_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_di);
  igd_Vge_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vge_e);
  igd_Vge_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Ve_si);
  igd_Vge_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Ve_di);
  igd_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_di_Vdi_si);
#endif
igd_Vge_e=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e));
#if defined(_DERIVATE2)
  igd_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Tempt_GND);
  igd_Vge_e_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_si);
  igd_Vge_e_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_di);
  igd_Vge_e_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vge_e);
  igd_Vge_e_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Ve_si);
  igd_Vge_e_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Ve_di);
  igd_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vge_e+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vge_e_Vdi_si);
#endif
igd_Ve_si=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si));
#if defined(_DERIVATE2)
  igd_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Tempt_GND);
  igd_Ve_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_si);
  igd_Ve_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_di);
  igd_Ve_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vge_e);
  igd_Ve_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Ve_si);
  igd_Ve_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Ve_di);
  igd_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Ve_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_si_Vdi_si);
#endif
igd_Ve_di=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di));
#if defined(_DERIVATE2)
  igd_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Tempt_GND);
  igd_Ve_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_si);
  igd_Ve_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_di);
  igd_Ve_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vge_e);
  igd_Ve_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Ve_si);
  igd_Ve_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Ve_di);
  igd_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Ve_di+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Ve_di_Vdi_si);
#endif
igd_Vdi_si=(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4)+((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si));
#if defined(_DERIVATE2)
  igd_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGS)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGS)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Tempt_GND)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Tempt_GND);
  igd_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*vgs_noswap_Vge_si+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_si+((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_si+(((((((0.0)*vgs_noswap)+((igsd_mult*pModel->DLCIGS)*vgs_noswap_Vge_si)))*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_si);
  igd_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_di+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_di);
  igd_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vge_e+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vge_e+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vge_e)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vge_e);
  igd_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_si+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Ve_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Ve_si);
  igd_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Ve_di+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Ve_di+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Ve_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Ve_di);
  igd_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGS+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgs_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGS)*0.0)*vgs_eff+0.0*vgs_eff_Vdi_si+((0.0)*vgs_noswap)*vgs_eff_Vdi_si+((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)*T4_Vdi_si+(((((0.0)*vgs_noswap)*vgs_eff)+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff_Vdi_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4_Vdi_si_Vdi_si);
#endif
#endif
igd=((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4);
EXIT_IF_ISNAN(((((igsd_mult*pModel->DLCIGS)*vgs_noswap)*vgs_eff)*T4))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=vgd_noswap_Vge_di;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+vgd_noswap_Vge_di_Vge_di-0.0);
  T0_Vge_di_Vge_e=(+0.0-0.0);
  T0_Vge_di_Ve_si=(+0.0-0.0);
  T0_Vge_di_Ve_di=(+0.0-0.0);
  T0_Vge_di_Vge_si=(+0.0-0.0);
  T0_Vge_di_Vdi_si=(+0.0-0.0);
  T0_Vge_di_Tempt_GND=(+0.0-0.0);
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-vfbsd_Tempt_GND);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_e=(+0.0-0.0);
  T0_Tempt_GND_Ve_si=(+0.0-0.0);
  T0_Tempt_GND_Ve_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_si=(+0.0-0.0);
  T0_Tempt_GND_Vdi_si=(+0.0-0.0);
  T0_Tempt_GND_Tempt_GND=(+0.0-vfbsd_Tempt_GND_Tempt_GND);
#endif
#endif
T0=(vgd_noswap-vfbsd);
EXIT_IF_ISNAN((vgd_noswap-vfbsd))
{
double m00_sqrt(d00_sqrt0,((T0*T0)+1.0e-4))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+1.0e-4))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
vgd_eff_Vge_di=((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Vge_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+0.0));
  vgd_eff_Vge_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+0.0));
  vgd_eff_Vge_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+0.0));
  vgd_eff_Vge_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+0.0));
  vgd_eff_Vge_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+0.0));
  vgd_eff_Vge_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+0.0));
  vgd_eff_Vge_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+0.0));
#endif
vgd_eff_Vge_e=((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Vge_e_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+0.0));
  vgd_eff_Vge_e_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+0.0));
  vgd_eff_Vge_e_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+0.0));
  vgd_eff_Vge_e_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+0.0));
  vgd_eff_Vge_e_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+0.0));
  vgd_eff_Vge_e_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+0.0));
  vgd_eff_Vge_e_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+0.0));
#endif
vgd_eff_Vge_si=((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Vge_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+0.0));
  vgd_eff_Vge_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+0.0));
  vgd_eff_Vge_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+0.0));
  vgd_eff_Vge_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+0.0));
  vgd_eff_Vge_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+0.0));
  vgd_eff_Vge_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+0.0));
  vgd_eff_Vge_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+0.0));
#endif
vgd_eff_Ve_si=((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Ve_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+0.0));
  vgd_eff_Ve_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+0.0));
  vgd_eff_Ve_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+0.0));
  vgd_eff_Ve_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+0.0));
  vgd_eff_Ve_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+0.0));
  vgd_eff_Ve_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+0.0));
  vgd_eff_Ve_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+0.0));
#endif
vgd_eff_Ve_di=((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Ve_di_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+0.0));
  vgd_eff_Ve_di_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+0.0));
  vgd_eff_Ve_di_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+0.0));
  vgd_eff_Ve_di_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+0.0));
  vgd_eff_Ve_di_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+0.0));
  vgd_eff_Ve_di_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+0.0));
  vgd_eff_Ve_di_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+0.0));
#endif
vgd_eff_Vdi_si=((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Vdi_si_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+0.0));
  vgd_eff_Vdi_si_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+0.0));
  vgd_eff_Vdi_si_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+0.0));
  vgd_eff_Vdi_si_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+0.0));
  vgd_eff_Vdi_si_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+0.0));
  vgd_eff_Vdi_si_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+0.0));
  vgd_eff_Vdi_si_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+0.0));
#endif
vgd_eff_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0;
#if defined(_DERIVATE2)
  vgd_eff_Tempt_GND_Vge_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_di*T0)+(T0*T0_Vge_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+0.0));
  vgd_eff_Tempt_GND_Vge_e=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_e*T0)+(T0*T0_Vge_e)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+0.0));
  vgd_eff_Tempt_GND_Vge_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vge_si*T0)+(T0*T0_Vge_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+0.0));
  vgd_eff_Tempt_GND_Ve_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_si*T0)+(T0*T0_Ve_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+0.0));
  vgd_eff_Tempt_GND_Ve_di=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Ve_di*T0)+(T0*T0_Ve_di)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+0.0));
  vgd_eff_Tempt_GND_Vdi_si=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+0.0));
  vgd_eff_Tempt_GND_Tempt_GND=(m20_sqrt(((T0*T0)+1.0e-4))*(((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+0.0));
#endif
#endif
vgd_eff=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
if
((pModel->IGCLAMP==1))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Vge_di)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Vge_e)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Ve_si)),0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Ve_di)),0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Vge_si)),0.0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(-(BIGD_i*vgd_eff_Vdi_si)),0.0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6,(AIGD_t_Tempt_GND-(BIGD_i*vgd_eff_Tempt_GND)),0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6);
EXIT_IF_ISNAN(bsimcmg_hypsmooth((AIGD_t-(BIGD_i*vgd_eff)),1.0e-6))
if
((CIGD_i<0.01))
{
CIGD_i=0.01;
EXIT_IF_ISNAN(0.01)
}
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-(BIGD_i*vgd_eff_Vge_di));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_di+BIGD_i*0.0));
  T1_Vge_di_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_di+BIGD_i*0.0));
  T1_Vge_di_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Vge_di));
  T1_Vge_di_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Vge_e));
  T1_Vge_di_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Ve_si));
  T1_Vge_di_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Ve_di));
  T1_Vge_di_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Vge_si));
  T1_Vge_di_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Vdi_si));
  T1_Vge_di_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_di+BIGD_i*vgd_eff_Vge_di_Tempt_GND));
#endif
T1_Vge_e=(-(BIGD_i*vgd_eff_Vge_e));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_e+BIGD_i*0.0));
  T1_Vge_e_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_e+BIGD_i*0.0));
  T1_Vge_e_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Vge_di));
  T1_Vge_e_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Vge_e));
  T1_Vge_e_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Ve_si));
  T1_Vge_e_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Ve_di));
  T1_Vge_e_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Vge_si));
  T1_Vge_e_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Vdi_si));
  T1_Vge_e_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_e+BIGD_i*vgd_eff_Vge_e_Tempt_GND));
#endif
T1_Ve_si=(-(BIGD_i*vgd_eff_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_si+BIGD_i*0.0));
  T1_Ve_si_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_si+BIGD_i*0.0));
  T1_Ve_si_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Vge_di));
  T1_Ve_si_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Vge_e));
  T1_Ve_si_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Ve_si));
  T1_Ve_si_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Ve_di));
  T1_Ve_si_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Vge_si));
  T1_Ve_si_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Vdi_si));
  T1_Ve_si_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_si+BIGD_i*vgd_eff_Ve_si_Tempt_GND));
#endif
T1_Ve_di=(-(BIGD_i*vgd_eff_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_di+BIGD_i*0.0));
  T1_Ve_di_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_di+BIGD_i*0.0));
  T1_Ve_di_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Vge_di));
  T1_Ve_di_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Vge_e));
  T1_Ve_di_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Ve_si));
  T1_Ve_di_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Ve_di));
  T1_Ve_di_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Vge_si));
  T1_Ve_di_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Vdi_si));
  T1_Ve_di_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_di+BIGD_i*vgd_eff_Ve_di_Tempt_GND));
#endif
T1_Vge_si=(-(BIGD_i*vgd_eff_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_si+BIGD_i*0.0));
  T1_Vge_si_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_si+BIGD_i*0.0));
  T1_Vge_si_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Vge_di));
  T1_Vge_si_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Vge_e));
  T1_Vge_si_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Ve_si));
  T1_Vge_si_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Ve_di));
  T1_Vge_si_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Vge_si));
  T1_Vge_si_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Vdi_si));
  T1_Vge_si_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_si+BIGD_i*vgd_eff_Vge_si_Tempt_GND));
#endif
T1_Vdi_si=(-(BIGD_i*vgd_eff_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vdi_si+BIGD_i*0.0));
  T1_Vdi_si_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vdi_si+BIGD_i*0.0));
  T1_Vdi_si_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Vge_di));
  T1_Vdi_si_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Vge_e));
  T1_Vdi_si_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Ve_si));
  T1_Vdi_si_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Ve_di));
  T1_Vdi_si_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Vge_si));
  T1_Vdi_si_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Vdi_si));
  T1_Vdi_si_Tempt_GND=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vdi_si+BIGD_i*vgd_eff_Vdi_si_Tempt_GND));
#endif
T1_Tempt_GND=(AIGD_t_Tempt_GND-(BIGD_i*vgd_eff_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Tempt_GND+BIGD_i*0.0));
  T1_Tempt_GND_Vsi_s=(+0.0-(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Tempt_GND+BIGD_i*0.0));
  T1_Tempt_GND_Vge_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Vge_di));
  T1_Tempt_GND_Vge_e=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Vge_e));
  T1_Tempt_GND_Ve_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Ve_si));
  T1_Tempt_GND_Ve_di=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Ve_di));
  T1_Tempt_GND_Vge_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Vge_si));
  T1_Tempt_GND_Vdi_si=(+0.0-(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Vdi_si));
  T1_Tempt_GND_Tempt_GND=(+AIGD_t_Tempt_GND_Tempt_GND-(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Tempt_GND+BIGD_i*vgd_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T1=(AIGD_t-(BIGD_i*vgd_eff));
EXIT_IF_ISNAN((AIGD_t-(BIGD_i*vgd_eff)))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(CIGD_i*vgd_eff_Vge_di);
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_di+CIGD_i*0.0));
  T2_Vge_di_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_di+CIGD_i*0.0));
  T2_Vge_di_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Vge_di));
  T2_Vge_di_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Vge_e));
  T2_Vge_di_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Vge_si));
  T2_Vge_di_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Ve_si));
  T2_Vge_di_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Ve_di));
  T2_Vge_di_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Vdi_si));
  T2_Vge_di_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_di+CIGD_i*vgd_eff_Vge_di_Tempt_GND));
#endif
T2_Vge_e=(CIGD_i*vgd_eff_Vge_e);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_e+CIGD_i*0.0));
  T2_Vge_e_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_e+CIGD_i*0.0));
  T2_Vge_e_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Vge_di));
  T2_Vge_e_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Vge_e));
  T2_Vge_e_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Vge_si));
  T2_Vge_e_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Ve_si));
  T2_Vge_e_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Ve_di));
  T2_Vge_e_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Vdi_si));
  T2_Vge_e_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_e+CIGD_i*vgd_eff_Vge_e_Tempt_GND));
#endif
T2_Vge_si=(CIGD_i*vgd_eff_Vge_si);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_si+CIGD_i*0.0));
  T2_Vge_si_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vge_si+CIGD_i*0.0));
  T2_Vge_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Vge_di));
  T2_Vge_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Vge_e));
  T2_Vge_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Vge_si));
  T2_Vge_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Ve_si));
  T2_Vge_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Ve_di));
  T2_Vge_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Vdi_si));
  T2_Vge_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vge_si+CIGD_i*vgd_eff_Vge_si_Tempt_GND));
#endif
T2_Ve_si=(CIGD_i*vgd_eff_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_si+CIGD_i*0.0));
  T2_Ve_si_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_si+CIGD_i*0.0));
  T2_Ve_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Vge_di));
  T2_Ve_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Vge_e));
  T2_Ve_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Vge_si));
  T2_Ve_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Ve_si));
  T2_Ve_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Ve_di));
  T2_Ve_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Vdi_si));
  T2_Ve_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_si+CIGD_i*vgd_eff_Ve_si_Tempt_GND));
#endif
T2_Ve_di=(CIGD_i*vgd_eff_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_di+CIGD_i*0.0));
  T2_Ve_di_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Ve_di+CIGD_i*0.0));
  T2_Ve_di_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Vge_di));
  T2_Ve_di_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Vge_e));
  T2_Ve_di_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Vge_si));
  T2_Ve_di_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Ve_si));
  T2_Ve_di_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Ve_di));
  T2_Ve_di_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Vdi_si));
  T2_Ve_di_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Ve_di+CIGD_i*vgd_eff_Ve_di_Tempt_GND));
#endif
T2_Vdi_si=(CIGD_i*vgd_eff_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vdi_si+CIGD_i*0.0));
  T2_Vdi_si_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Vdi_si+CIGD_i*0.0));
  T2_Vdi_si_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Vge_di));
  T2_Vdi_si_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Vge_e));
  T2_Vdi_si_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Vge_si));
  T2_Vdi_si_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Ve_si));
  T2_Vdi_si_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Ve_di));
  T2_Vdi_si_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Vdi_si));
  T2_Vdi_si_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Vdi_si+CIGD_i*vgd_eff_Vdi_si_Tempt_GND));
#endif
T2_Tempt_GND=(CIGD_i*vgd_eff_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Tempt_GND+CIGD_i*0.0));
  T2_Tempt_GND_Vsi_s=(+0.0+(+0.0*vgd_eff+0.0*0.0+0.0*vgd_eff_Tempt_GND+CIGD_i*0.0));
  T2_Tempt_GND_Vge_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_di+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Vge_di));
  T2_Tempt_GND_Vge_e=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_e+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Vge_e));
  T2_Tempt_GND_Vge_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vge_si+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Vge_si));
  T2_Tempt_GND_Ve_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_si+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Ve_si));
  T2_Tempt_GND_Ve_di=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Ve_di+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Ve_di));
  T2_Tempt_GND_Vdi_si=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Vdi_si+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Vdi_si));
  T2_Tempt_GND_Tempt_GND=(+0.0+(+0.0*vgd_eff+0.0*vgd_eff_Tempt_GND+0.0*vgd_eff_Tempt_GND+CIGD_i*vgd_eff_Tempt_GND_Tempt_GND));
#endif
#endif
T2=(1.0+(CIGD_i*vgd_eff));
EXIT_IF_ISNAN((1.0+(CIGD_i*vgd_eff)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_di_Tempt_GND);
#endif
T3_Vge_e=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_e+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_e+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vdi_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vdi_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Ve_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Ve_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_si_Tempt_GND);
#endif
T3_Ve_di=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Ve_di+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Ve_di+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Ve_di_Tempt_GND);
#endif
T3_Vge_si=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Vge_si+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Vge_si+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2)+(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_d+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vdi_d)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vdi_d+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_d)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vsi_s+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vsi_s)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vsi_s+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vsi_s)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_di+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_di)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_e+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_e)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_e+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_e)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vdi_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vdi_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vdi_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vdi_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Ve_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Ve_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Ve_di+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Ve_di)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Ve_di+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Ve_di)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Vge_si+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Vge_si)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Vge_si+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Vge_si)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+(+(+(+0.0*pModel->TOXG+0.0*0.0+0.0*0.0+(-Bechvb)*0.0)*POXEDGE_i+0.0*0.0+(0.0)*0.0+((-Bechvb)*pModel->TOXG)*0.0)*T1+0.0*T1_Tempt_GND+((0.0)*POXEDGE_i)*T1_Tempt_GND+(((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND_Tempt_GND)*T2+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)*T2_Tempt_GND+(((((0.0)*POXEDGE_i)*T1)+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1_Tempt_GND)))*T2_Tempt_GND+((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T3=(((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2);
EXIT_IF_ISNAN((((((-Bechvb)*pModel->TOXG)*POXEDGE_i)*T1)*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=bsimcmg_d_lexp(T3,T3_Vge_di);
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=T3_Vge_di_Vge_di;
  T4_Vge_di_Vge_e=T3_Vge_di_Vge_e;
  T4_Vge_di_Vdi_si=T3_Vge_di_Vdi_si;
  T4_Vge_di_Ve_si=T3_Vge_di_Ve_si;
  T4_Vge_di_Ve_di=T3_Vge_di_Ve_di;
  T4_Vge_di_Vge_si=T3_Vge_di_Vge_si;
  T4_Vge_di_Tempt_GND=T3_Vge_di_Tempt_GND;
#endif
T4_Vge_e=bsimcmg_d_lexp(T3,T3_Vge_e);
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=T3_Vge_e_Vge_di;
  T4_Vge_e_Vge_e=T3_Vge_e_Vge_e;
  T4_Vge_e_Vdi_si=T3_Vge_e_Vdi_si;
  T4_Vge_e_Ve_si=T3_Vge_e_Ve_si;
  T4_Vge_e_Ve_di=T3_Vge_e_Ve_di;
  T4_Vge_e_Vge_si=T3_Vge_e_Vge_si;
  T4_Vge_e_Tempt_GND=T3_Vge_e_Tempt_GND;
#endif
T4_Vdi_si=bsimcmg_d_lexp(T3,T3_Vdi_si);
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=T3_Vdi_si_Vge_di;
  T4_Vdi_si_Vge_e=T3_Vdi_si_Vge_e;
  T4_Vdi_si_Vdi_si=T3_Vdi_si_Vdi_si;
  T4_Vdi_si_Ve_si=T3_Vdi_si_Ve_si;
  T4_Vdi_si_Ve_di=T3_Vdi_si_Ve_di;
  T4_Vdi_si_Vge_si=T3_Vdi_si_Vge_si;
  T4_Vdi_si_Tempt_GND=T3_Vdi_si_Tempt_GND;
#endif
T4_Ve_si=bsimcmg_d_lexp(T3,T3_Ve_si);
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=T3_Ve_si_Vge_di;
  T4_Ve_si_Vge_e=T3_Ve_si_Vge_e;
  T4_Ve_si_Vdi_si=T3_Ve_si_Vdi_si;
  T4_Ve_si_Ve_si=T3_Ve_si_Ve_si;
  T4_Ve_si_Ve_di=T3_Ve_si_Ve_di;
  T4_Ve_si_Vge_si=T3_Ve_si_Vge_si;
  T4_Ve_si_Tempt_GND=T3_Ve_si_Tempt_GND;
#endif
T4_Ve_di=bsimcmg_d_lexp(T3,T3_Ve_di);
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=T3_Ve_di_Vge_di;
  T4_Ve_di_Vge_e=T3_Ve_di_Vge_e;
  T4_Ve_di_Vdi_si=T3_Ve_di_Vdi_si;
  T4_Ve_di_Ve_si=T3_Ve_di_Ve_si;
  T4_Ve_di_Ve_di=T3_Ve_di_Ve_di;
  T4_Ve_di_Vge_si=T3_Ve_di_Vge_si;
  T4_Ve_di_Tempt_GND=T3_Ve_di_Tempt_GND;
#endif
T4_Vge_si=bsimcmg_d_lexp(T3,T3_Vge_si);
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=T3_Vge_si_Vge_di;
  T4_Vge_si_Vge_e=T3_Vge_si_Vge_e;
  T4_Vge_si_Vdi_si=T3_Vge_si_Vdi_si;
  T4_Vge_si_Ve_si=T3_Vge_si_Ve_si;
  T4_Vge_si_Ve_di=T3_Vge_si_Ve_di;
  T4_Vge_si_Vge_si=T3_Vge_si_Vge_si;
  T4_Vge_si_Tempt_GND=T3_Vge_si_Tempt_GND;
#endif
T4_Tempt_GND=bsimcmg_d_lexp(T3,T3_Tempt_GND);
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=T3_Tempt_GND_Vge_di;
  T4_Tempt_GND_Vge_e=T3_Tempt_GND_Vge_e;
  T4_Tempt_GND_Vdi_si=T3_Tempt_GND_Vdi_si;
  T4_Tempt_GND_Ve_si=T3_Tempt_GND_Ve_si;
  T4_Tempt_GND_Ve_di=T3_Tempt_GND_Ve_di;
  T4_Tempt_GND_Vge_si=T3_Tempt_GND_Vge_si;
  T4_Tempt_GND_Tempt_GND=T3_Tempt_GND_Tempt_GND;
#endif
#endif
T4=bsimcmg_lexp(T3);
EXIT_IF_ISNAN(bsimcmg_lexp(T3))
if
((sigvds>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igd_Tempt_GND=((((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND));
#if defined(_DERIVATE2)
  igd_Tempt_GND_Tempt_GND=(+(+(+(+igsd_mult_Tempt_GND_Tempt_GND*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Tempt_GND)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Tempt_GND);
  igd_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_si);
  igd_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_di);
  igd_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_e)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_e);
  igd_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Ve_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Ve_si);
  igd_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Ve_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Ve_di);
  igd_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vdi_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vdi_si);
#endif
igd_Vge_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si));
#if defined(_DERIVATE2)
  igd_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Tempt_GND);
  igd_Vge_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_si);
  igd_Vge_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_di);
  igd_Vge_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_e);
  igd_Vge_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Ve_si);
  igd_Vge_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Ve_di);
  igd_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vdi_si);
#endif
igd_Vge_di=((((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di));
#if defined(_DERIVATE2)
  igd_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Tempt_GND)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Tempt_GND);
  igd_Vge_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_si);
  igd_Vge_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di_Vge_di)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_di)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_di);
  igd_Vge_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_e)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_e);
  igd_Vge_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Ve_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Ve_si);
  igd_Vge_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Ve_di)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Ve_di);
  igd_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vdi_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vdi_si);
#endif
igd_Vge_e=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e));
#if defined(_DERIVATE2)
  igd_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Tempt_GND);
  igd_Vge_e_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_si);
  igd_Vge_e_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_di);
  igd_Vge_e_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_e);
  igd_Vge_e_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Ve_si);
  igd_Vge_e_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Ve_di);
  igd_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vdi_si);
#endif
igd_Ve_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si));
#if defined(_DERIVATE2)
  igd_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Tempt_GND);
  igd_Ve_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_si);
  igd_Ve_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_di);
  igd_Ve_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_e);
  igd_Ve_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Ve_si);
  igd_Ve_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Ve_di);
  igd_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vdi_si);
#endif
igd_Ve_di=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di));
#if defined(_DERIVATE2)
  igd_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Tempt_GND);
  igd_Ve_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_si);
  igd_Ve_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_di);
  igd_Ve_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_e);
  igd_Ve_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Ve_si);
  igd_Ve_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Ve_di);
  igd_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vdi_si);
#endif
igd_Vdi_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si));
#if defined(_DERIVATE2)
  igd_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Tempt_GND);
  igd_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_si);
  igd_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_di);
  igd_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_e);
  igd_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Ve_si);
  igd_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Ve_di);
  igd_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vdi_si);
#endif
#endif
igd=((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4);
EXIT_IF_ISNAN(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igs_Tempt_GND=((((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND));
#if defined(_DERIVATE2)
  igs_Tempt_GND_Tempt_GND=(+(+(+(+igsd_mult_Tempt_GND_Tempt_GND*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Tempt_GND)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Tempt_GND);
  igs_Tempt_GND_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_si);
  igs_Tempt_GND_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_di);
  igs_Tempt_GND_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vge_e)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vge_e);
  igs_Tempt_GND_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Ve_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Ve_si);
  igs_Tempt_GND_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Ve_di)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Ve_di);
  igs_Tempt_GND_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+igsd_mult_Tempt_GND*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+igsd_mult_Tempt_GND*pModel->DLCIGD*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Tempt_GND+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND_Vdi_si)*T4+((igsd_mult_Tempt_GND*pModel->DLCIGD*vgd_noswap*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND))*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Tempt_GND+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Tempt_GND_Vdi_si);
#endif
igs_Vge_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si));
#if defined(_DERIVATE2)
  igs_Vge_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Tempt_GND);
  igs_Vge_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_si);
  igs_Vge_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_di);
  igs_Vge_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vge_e);
  igs_Vge_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Ve_si);
  igs_Vge_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Ve_di);
  igs_Vge_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_si_Vdi_si);
#endif
igs_Vge_di=((((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di));
#if defined(_DERIVATE2)
  igs_Vge_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Tempt_GND)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Tempt_GND);
  igs_Vge_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_si);
  igs_Vge_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di_Vge_di)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_di)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_di);
  igs_Vge_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vge_e)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vge_e);
  igs_Vge_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Ve_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Ve_si);
  igs_Vge_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Ve_di)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Ve_di);
  igs_Vge_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*vgd_noswap_Vge_di+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di_Vdi_si)*T4+((((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di))*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_di_Vdi_si);
#endif
igs_Vge_e=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e));
#if defined(_DERIVATE2)
  igs_Vge_e_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Tempt_GND);
  igs_Vge_e_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_si);
  igs_Vge_e_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_di);
  igs_Vge_e_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vge_e);
  igs_Vge_e_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Ve_si);
  igs_Vge_e_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Ve_di);
  igs_Vge_e_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vge_e+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vge_e+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vge_e_Vdi_si);
#endif
igs_Ve_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si));
#if defined(_DERIVATE2)
  igs_Ve_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Tempt_GND);
  igs_Ve_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_si);
  igs_Ve_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_di);
  igs_Ve_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vge_e);
  igs_Ve_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Ve_si);
  igs_Ve_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Ve_di);
  igs_Ve_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Ve_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Ve_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_si_Vdi_si);
#endif
igs_Ve_di=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di));
#if defined(_DERIVATE2)
  igs_Ve_di_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Tempt_GND);
  igs_Ve_di_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_si);
  igs_Ve_di_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_di);
  igs_Ve_di_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vge_e);
  igs_Ve_di_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Ve_si);
  igs_Ve_di_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Ve_di);
  igs_Ve_di_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Ve_di+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Ve_di+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Ve_di_Vdi_si);
#endif
igs_Vdi_si=(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4)+((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si));
#if defined(_DERIVATE2)
  igs_Vdi_si_Tempt_GND=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+igsd_mult_Tempt_GND*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(igsd_mult_Tempt_GND*pModel->DLCIGD)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Tempt_GND+((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Tempt_GND)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Tempt_GND+(((((igsd_mult_Tempt_GND*pModel->DLCIGD)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Tempt_GND)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Tempt_GND);
  igs_Vdi_si_Vge_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_si);
  igs_Vdi_si_Vge_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*vgd_noswap_Vge_di+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_di+((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_di+(((((((0.0)*vgd_noswap)+((igsd_mult*pModel->DLCIGD)*vgd_noswap_Vge_di)))*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_di);
  igs_Vdi_si_Vge_e=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vge_e+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vge_e)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vge_e+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vge_e)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vge_e);
  igs_Vdi_si_Ve_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Ve_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Ve_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Ve_si);
  igs_Vdi_si_Ve_di=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Ve_di+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Ve_di)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Ve_di+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Ve_di)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Ve_di);
  igs_Vdi_si_Vdi_si=(+(+(+(+0.0*pModel->DLCIGD+0.0*0.0+0.0*0.0+igsd_mult*0.0)*vgd_noswap+0.0*0.0+(0.0)*0.0+(igsd_mult*pModel->DLCIGD)*0.0)*vgd_eff+0.0*vgd_eff_Vdi_si+((0.0)*vgd_noswap)*vgd_eff_Vdi_si+((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si_Vdi_si)*T4+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)*T4_Vdi_si+(((((0.0)*vgd_noswap)*vgd_eff)+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff_Vdi_si)))*T4_Vdi_si+(((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4_Vdi_si_Vdi_si);
#endif
#endif
igs=((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4);
EXIT_IF_ISNAN(((((igsd_mult*pModel->DLCIGD)*vgd_noswap)*vgd_eff)*T4))
}
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igisl_Vge_di=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_di_Vge_di=0.0;
  igisl_Vge_di_Vdi_d=0.0;
  igisl_Vge_di_Vsi_s=0.0;
  igisl_Vge_di_Vge_e=0.0;
  igisl_Vge_di_Vdi_si=0.0;
  igisl_Vge_di_Tempt_GND=0.0;
  igisl_Vge_di_Ve_si=0.0;
  igisl_Vge_di_Ve_di=0.0;
  igisl_Vge_di_Vge_si=0.0;
#endif
igisl_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igisl_Vdi_d_Vge_di=0.0;
  igisl_Vdi_d_Vdi_d=0.0;
  igisl_Vdi_d_Vsi_s=0.0;
  igisl_Vdi_d_Vge_e=0.0;
  igisl_Vdi_d_Vdi_si=0.0;
  igisl_Vdi_d_Tempt_GND=0.0;
  igisl_Vdi_d_Ve_si=0.0;
  igisl_Vdi_d_Ve_di=0.0;
  igisl_Vdi_d_Vge_si=0.0;
#endif
igisl_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igisl_Vsi_s_Vge_di=0.0;
  igisl_Vsi_s_Vdi_d=0.0;
  igisl_Vsi_s_Vsi_s=0.0;
  igisl_Vsi_s_Vge_e=0.0;
  igisl_Vsi_s_Vdi_si=0.0;
  igisl_Vsi_s_Tempt_GND=0.0;
  igisl_Vsi_s_Ve_si=0.0;
  igisl_Vsi_s_Ve_di=0.0;
  igisl_Vsi_s_Vge_si=0.0;
#endif
igisl_Vge_e=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_e_Vge_di=0.0;
  igisl_Vge_e_Vdi_d=0.0;
  igisl_Vge_e_Vsi_s=0.0;
  igisl_Vge_e_Vge_e=0.0;
  igisl_Vge_e_Vdi_si=0.0;
  igisl_Vge_e_Tempt_GND=0.0;
  igisl_Vge_e_Ve_si=0.0;
  igisl_Vge_e_Ve_di=0.0;
  igisl_Vge_e_Vge_si=0.0;
#endif
igisl_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igisl_Vdi_si_Vge_di=0.0;
  igisl_Vdi_si_Vdi_d=0.0;
  igisl_Vdi_si_Vsi_s=0.0;
  igisl_Vdi_si_Vge_e=0.0;
  igisl_Vdi_si_Vdi_si=0.0;
  igisl_Vdi_si_Tempt_GND=0.0;
  igisl_Vdi_si_Ve_si=0.0;
  igisl_Vdi_si_Ve_di=0.0;
  igisl_Vdi_si_Vge_si=0.0;
#endif
igisl_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igisl_Tempt_GND_Vge_di=0.0;
  igisl_Tempt_GND_Vdi_d=0.0;
  igisl_Tempt_GND_Vsi_s=0.0;
  igisl_Tempt_GND_Vge_e=0.0;
  igisl_Tempt_GND_Vdi_si=0.0;
  igisl_Tempt_GND_Tempt_GND=0.0;
  igisl_Tempt_GND_Ve_si=0.0;
  igisl_Tempt_GND_Ve_di=0.0;
  igisl_Tempt_GND_Vge_si=0.0;
#endif
igisl_Ve_si=0.0;
#if defined(_DERIVATE2)
  igisl_Ve_si_Vge_di=0.0;
  igisl_Ve_si_Vdi_d=0.0;
  igisl_Ve_si_Vsi_s=0.0;
  igisl_Ve_si_Vge_e=0.0;
  igisl_Ve_si_Vdi_si=0.0;
  igisl_Ve_si_Tempt_GND=0.0;
  igisl_Ve_si_Ve_si=0.0;
  igisl_Ve_si_Ve_di=0.0;
  igisl_Ve_si_Vge_si=0.0;
#endif
igisl_Ve_di=0.0;
#if defined(_DERIVATE2)
  igisl_Ve_di_Vge_di=0.0;
  igisl_Ve_di_Vdi_d=0.0;
  igisl_Ve_di_Vsi_s=0.0;
  igisl_Ve_di_Vge_e=0.0;
  igisl_Ve_di_Vdi_si=0.0;
  igisl_Ve_di_Tempt_GND=0.0;
  igisl_Ve_di_Ve_si=0.0;
  igisl_Ve_di_Ve_di=0.0;
  igisl_Ve_di_Vge_si=0.0;
#endif
igisl_Vge_si=0.0;
#if defined(_DERIVATE2)
  igisl_Vge_si_Vge_di=0.0;
  igisl_Vge_si_Vdi_d=0.0;
  igisl_Vge_si_Vsi_s=0.0;
  igisl_Vge_si_Vge_e=0.0;
  igisl_Vge_si_Vdi_si=0.0;
  igisl_Vge_si_Tempt_GND=0.0;
  igisl_Vge_si_Ve_si=0.0;
  igisl_Vge_si_Ve_di=0.0;
  igisl_Vge_si_Vge_si=0.0;
#endif
#endif
igisl=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igidl_Vge_di=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_di_Vge_di=0.0;
  igidl_Vge_di_Vdi_d=0.0;
  igidl_Vge_di_Vsi_s=0.0;
  igidl_Vge_di_Vge_e=0.0;
  igidl_Vge_di_Vdi_si=0.0;
  igidl_Vge_di_Tempt_GND=0.0;
  igidl_Vge_di_Ve_si=0.0;
  igidl_Vge_di_Ve_di=0.0;
  igidl_Vge_di_Vge_si=0.0;
#endif
igidl_Vdi_d=0.0;
#if defined(_DERIVATE2)
  igidl_Vdi_d_Vge_di=0.0;
  igidl_Vdi_d_Vdi_d=0.0;
  igidl_Vdi_d_Vsi_s=0.0;
  igidl_Vdi_d_Vge_e=0.0;
  igidl_Vdi_d_Vdi_si=0.0;
  igidl_Vdi_d_Tempt_GND=0.0;
  igidl_Vdi_d_Ve_si=0.0;
  igidl_Vdi_d_Ve_di=0.0;
  igidl_Vdi_d_Vge_si=0.0;
#endif
igidl_Vsi_s=0.0;
#if defined(_DERIVATE2)
  igidl_Vsi_s_Vge_di=0.0;
  igidl_Vsi_s_Vdi_d=0.0;
  igidl_Vsi_s_Vsi_s=0.0;
  igidl_Vsi_s_Vge_e=0.0;
  igidl_Vsi_s_Vdi_si=0.0;
  igidl_Vsi_s_Tempt_GND=0.0;
  igidl_Vsi_s_Ve_si=0.0;
  igidl_Vsi_s_Ve_di=0.0;
  igidl_Vsi_s_Vge_si=0.0;
#endif
igidl_Vge_e=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_e_Vge_di=0.0;
  igidl_Vge_e_Vdi_d=0.0;
  igidl_Vge_e_Vsi_s=0.0;
  igidl_Vge_e_Vge_e=0.0;
  igidl_Vge_e_Vdi_si=0.0;
  igidl_Vge_e_Tempt_GND=0.0;
  igidl_Vge_e_Ve_si=0.0;
  igidl_Vge_e_Ve_di=0.0;
  igidl_Vge_e_Vge_si=0.0;
#endif
igidl_Vdi_si=0.0;
#if defined(_DERIVATE2)
  igidl_Vdi_si_Vge_di=0.0;
  igidl_Vdi_si_Vdi_d=0.0;
  igidl_Vdi_si_Vsi_s=0.0;
  igidl_Vdi_si_Vge_e=0.0;
  igidl_Vdi_si_Vdi_si=0.0;
  igidl_Vdi_si_Tempt_GND=0.0;
  igidl_Vdi_si_Ve_si=0.0;
  igidl_Vdi_si_Ve_di=0.0;
  igidl_Vdi_si_Vge_si=0.0;
#endif
igidl_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  igidl_Tempt_GND_Vge_di=0.0;
  igidl_Tempt_GND_Vdi_d=0.0;
  igidl_Tempt_GND_Vsi_s=0.0;
  igidl_Tempt_GND_Vge_e=0.0;
  igidl_Tempt_GND_Vdi_si=0.0;
  igidl_Tempt_GND_Tempt_GND=0.0;
  igidl_Tempt_GND_Ve_si=0.0;
  igidl_Tempt_GND_Ve_di=0.0;
  igidl_Tempt_GND_Vge_si=0.0;
#endif
igidl_Ve_si=0.0;
#if defined(_DERIVATE2)
  igidl_Ve_si_Vge_di=0.0;
  igidl_Ve_si_Vdi_d=0.0;
  igidl_Ve_si_Vsi_s=0.0;
  igidl_Ve_si_Vge_e=0.0;
  igidl_Ve_si_Vdi_si=0.0;
  igidl_Ve_si_Tempt_GND=0.0;
  igidl_Ve_si_Ve_si=0.0;
  igidl_Ve_si_Ve_di=0.0;
  igidl_Ve_si_Vge_si=0.0;
#endif
igidl_Ve_di=0.0;
#if defined(_DERIVATE2)
  igidl_Ve_di_Vge_di=0.0;
  igidl_Ve_di_Vdi_d=0.0;
  igidl_Ve_di_Vsi_s=0.0;
  igidl_Ve_di_Vge_e=0.0;
  igidl_Ve_di_Vdi_si=0.0;
  igidl_Ve_di_Tempt_GND=0.0;
  igidl_Ve_di_Ve_si=0.0;
  igidl_Ve_di_Ve_di=0.0;
  igidl_Ve_di_Vge_si=0.0;
#endif
igidl_Vge_si=0.0;
#if defined(_DERIVATE2)
  igidl_Vge_si_Vge_di=0.0;
  igidl_Vge_si_Vdi_d=0.0;
  igidl_Vge_si_Vsi_s=0.0;
  igidl_Vge_si_Vge_e=0.0;
  igidl_Vge_si_Vdi_si=0.0;
  igidl_Vge_si_Tempt_GND=0.0;
  igidl_Vge_si_Ve_si=0.0;
  igidl_Vge_si_Ve_di=0.0;
  igidl_Vge_si_Vge_si=0.0;
#endif
#endif
igidl=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->GIDLMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=(epsratio*pModel->EOT);
EXIT_IF_ISNAN((epsratio*pModel->EOT))
if
(((AGIDL_i<=0.0)||(BGIDL_t<=0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=0.0;
  T6_Vdi_si_Vdi_d=0.0;
  T6_Vdi_si_Vsi_s=0.0;
  T6_Vdi_si_Vge_e=0.0;
  T6_Vdi_si_Vdi_si=0.0;
  T6_Vdi_si_Tempt_GND=0.0;
  T6_Vdi_si_Ve_si=0.0;
  T6_Vdi_si_Ve_di=0.0;
  T6_Vdi_si_Vge_si=0.0;
#endif
T6_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=0.0;
  T6_Tempt_GND_Vdi_d=0.0;
  T6_Tempt_GND_Vsi_s=0.0;
  T6_Tempt_GND_Vge_e=0.0;
  T6_Tempt_GND_Vdi_si=0.0;
  T6_Tempt_GND_Tempt_GND=0.0;
  T6_Tempt_GND_Ve_si=0.0;
  T6_Tempt_GND_Ve_di=0.0;
  T6_Tempt_GND_Vge_si=0.0;
#endif
T6_Ve_si=0.0;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=0.0;
  T6_Ve_si_Vdi_d=0.0;
  T6_Ve_si_Vsi_s=0.0;
  T6_Ve_si_Vge_e=0.0;
  T6_Ve_si_Vdi_si=0.0;
  T6_Ve_si_Tempt_GND=0.0;
  T6_Ve_si_Ve_si=0.0;
  T6_Ve_si_Ve_di=0.0;
  T6_Ve_si_Vge_si=0.0;
#endif
T6_Ve_di=0.0;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=0.0;
  T6_Ve_di_Vdi_d=0.0;
  T6_Ve_di_Vsi_s=0.0;
  T6_Ve_di_Vge_e=0.0;
  T6_Ve_di_Vdi_si=0.0;
  T6_Ve_di_Tempt_GND=0.0;
  T6_Ve_di_Ve_si=0.0;
  T6_Ve_di_Ve_di=0.0;
  T6_Ve_di_Vge_si=0.0;
#endif
T6_Vge_si=0.0;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=0.0;
  T6_Vge_si_Vdi_d=0.0;
  T6_Vge_si_Vsi_s=0.0;
  T6_Vge_si_Vge_e=0.0;
  T6_Vge_si_Vdi_si=0.0;
  T6_Vge_si_Tempt_GND=0.0;
  T6_Vge_si_Ve_si=0.0;
  T6_Vge_si_Ve_di=0.0;
  T6_Vge_si_Vge_si=0.0;
#endif
#endif
T6=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(((-vgd_noswap_Vge_di)*T0-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*0.0+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*0.0/T0/T0/T0);
  T1_Vge_di_Vsi_s=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*0.0+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*0.0/T0/T0/T0);
  T1_Vge_di_Vge_di=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Vge_di/T0/T0/T0);
  T1_Vge_di_Vge_e=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Vge_e+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Vge_e/T0/T0/T0);
  T1_Vge_di_Ve_si=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Ve_si+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Ve_si/T0/T0/T0);
  T1_Vge_di_Ve_di=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Ve_di+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Ve_di/T0/T0/T0);
  T1_Vge_di_Vge_si=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Vge_si+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Vge_si/T0/T0/T0);
  T1_Vge_di_Vdi_si=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Vdi_si+0.0*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Vdi_si/T0/T0/T0);
  T1_Vge_di_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-vgd_noswap_Vge_di)*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_di*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vge_e=(-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*0.0/T0/T0/T0);
  T1_Vge_e_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*0.0/T0/T0/T0);
  T1_Vge_e_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Vge_di/T0/T0/T0);
  T1_Vge_e_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Vge_e/T0/T0/T0);
  T1_Vge_e_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Ve_si/T0/T0/T0);
  T1_Vge_e_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Ve_di/T0/T0/T0);
  T1_Vge_e_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Vge_si/T0/T0/T0);
  T1_Vge_e_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Vdi_si/T0/T0/T0);
  T1_Vge_e_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_e+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_e*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Ve_si=(-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si/T0/T0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*0.0/T0/T0/T0);
  T1_Ve_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*0.0/T0/T0/T0);
  T1_Ve_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Vge_di/T0/T0/T0);
  T1_Ve_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Vge_e/T0/T0/T0);
  T1_Ve_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Ve_si/T0/T0/T0);
  T1_Ve_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Ve_di/T0/T0/T0);
  T1_Ve_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Vge_si/T0/T0/T0);
  T1_Ve_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Vdi_si/T0/T0/T0);
  T1_Ve_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Ve_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Ve_di=(-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di/T0/T0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*0.0/T0/T0/T0);
  T1_Ve_di_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*0.0/T0/T0/T0);
  T1_Ve_di_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Vge_di/T0/T0/T0);
  T1_Ve_di_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Vge_e/T0/T0/T0);
  T1_Ve_di_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Ve_si/T0/T0/T0);
  T1_Ve_di_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Ve_di/T0/T0/T0);
  T1_Ve_di_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Vge_si/T0/T0/T0);
  T1_Ve_di_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Vdi_si/T0/T0/T0);
  T1_Ve_di_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Ve_di+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Ve_di*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vge_si=(-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*0.0/T0/T0/T0);
  T1_Vge_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*0.0/T0/T0/T0);
  T1_Vge_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Vge_di/T0/T0/T0);
  T1_Vge_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Vge_e/T0/T0/T0);
  T1_Vge_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Ve_si/T0/T0/T0);
  T1_Vge_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Ve_di/T0/T0/T0);
  T1_Vge_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Vge_si/T0/T0/T0);
  T1_Vge_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Vdi_si/T0/T0/T0);
  T1_Vge_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vge_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vdi_si=(-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si/T0/T0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*0.0/T0/T0/T0);
  T1_Vdi_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*0.0/T0/T0/T0);
  T1_Vdi_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Vge_di/T0/T0/T0);
  T1_Vdi_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Vge_e/T0/T0/T0);
  T1_Vdi_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Ve_si/T0/T0/T0);
  T1_Vdi_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Ve_di/T0/T0/T0);
  T1_Vdi_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Vge_si/T0/T0/T0);
  T1_Vdi_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Vdi_si/T0/T0/T0);
  T1_Vdi_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vdi_si+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Vdi_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Tempt_GND=((vfbsd_Tempt_GND*T0-(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND)/T0/T0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*0.0+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*0.0/T0/T0/T0);
  T1_Tempt_GND_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*0.0+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*0.0/T0/T0/T0);
  T1_Tempt_GND_Vge_di=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_di+(-vgd_noswap_Vge_di)*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Vge_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_di/T0/T0/T0);
  T1_Tempt_GND_Vge_e=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_e+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Vge_e)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_e/T0/T0/T0);
  T1_Tempt_GND_Ve_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Ve_si+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Ve_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Ve_si/T0/T0/T0);
  T1_Tempt_GND_Ve_di=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Ve_di+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Ve_di)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Ve_di/T0/T0/T0);
  T1_Tempt_GND_Vge_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_si+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Vge_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_si/T0/T0/T0);
  T1_Tempt_GND_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vdi_si+0.0*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Vdi_si)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Vdi_si/T0/T0/T0);
  T1_Tempt_GND_Tempt_GND=((+(+0.0-0.0)+vfbsd_Tempt_GND_Tempt_GND)/T0-(vfbsd_Tempt_GND*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Tempt_GND+(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND_Tempt_GND)/T0/T0+2*(((-vgd_noswap)-EGIDL_i)+vfbsd)*T0_Tempt_GND*T0_Tempt_GND/T0/T0/T0);
#endif
#endif
T1=((((-vgd_noswap)-EGIDL_i)+vfbsd)/T0);
EXIT_IF_ISNAN(((((-vgd_noswap)-EGIDL_i)+vfbsd)/T0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_di,0.0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_e,0.0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Ve_si,0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Ve_di,0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_si,0.0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vdi_si,0.0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth(T1,1.0e-2);
EXIT_IF_ISNAN(bsimcmg_hypsmooth(T1,1.0e-2))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(-BGIDL_t*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vge_di+BGIDL_t*(+T1_Vge_di_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_di*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vge_e=(-BGIDL_t*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vge_e+BGIDL_t*(+T1_Vge_e_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_e*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vge_si=(-BGIDL_t*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vge_si+BGIDL_t*(+T1_Vge_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vge_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Ve_si=(-BGIDL_t*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Ve_si+BGIDL_t*(+T1_Ve_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Ve_di=(-BGIDL_t*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Ve_di+BGIDL_t*(+T1_Ve_di_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Ve_di*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vdi_si=(-BGIDL_t*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Vdi_si+BGIDL_t*(+T1_Vdi_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Vdi_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Tempt_GND=((BGIDL_t_Tempt_GND*(T1+1.0e-3)-BGIDL_t*T1_Tempt_GND)/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vdi_d+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vsi_s=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vsi_s+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_di=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vge_di+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_e=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vge_e+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_si=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vge_si+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Ve_si=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Ve_si+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Ve_di=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Ve_di+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vdi_si=(0.0/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Vdi_si+0.0*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Tempt_GND=(BGIDL_t_Tempt_GND_Tempt_GND/(T1+1.0e-3)-(BGIDL_t_Tempt_GND*T1_Tempt_GND+BGIDL_t_Tempt_GND*T1_Tempt_GND+BGIDL_t*(+T1_Tempt_GND_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGIDL_t*T1_Tempt_GND*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#endif
T2=(BGIDL_t/(T1+1.0e-3));
EXIT_IF_ISNAN((BGIDL_t/(T1+1.0e-3)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Vge_di)));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGIDL_i*T1_Vge_di_Tempt_GND);
#endif
T3_Vge_e=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Vge_e)));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGIDL_i*T1_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Vdi_si)));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGIDL_i*T1_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Ve_si)));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGIDL_i*T1_Ve_si_Tempt_GND);
#endif
T3_Ve_di=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Ve_di)));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGIDL_i*T1_Ve_di_Tempt_GND);
#endif
T3_Vge_si=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Vge_si)));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGIDL_i*T1_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=bsimcmg_d_lexp((PGIDL_i*bsimcmg_lln(T1)),(PGIDL_i*bsimcmg_d_lln(T1,T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGIDL_i*T1_Tempt_GND_Tempt_GND);
#endif
#endif
T3=bsimcmg_lexp((PGIDL_i*bsimcmg_lln(T1)));
EXIT_IF_ISNAN(bsimcmg_lexp((PGIDL_i*bsimcmg_lln(T1))))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=0.0;
  T4_Vdi_si_Vge_e=0.0;
  T4_Vdi_si_Vdi_si=0.0;
  T4_Vdi_si_Ve_si=0.0;
  T4_Vdi_si_Ve_di=0.0;
  T4_Vdi_si_Vge_si=0.0;
  T4_Vdi_si_Tempt_GND=0.0;
#endif
T4_Ve_si=0.0;
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=0.0;
  T4_Ve_si_Vge_e=0.0;
  T4_Ve_si_Vdi_si=0.0;
  T4_Ve_si_Ve_si=0.0;
  T4_Ve_si_Ve_di=0.0;
  T4_Ve_si_Vge_si=0.0;
  T4_Ve_si_Tempt_GND=0.0;
#endif
T4_Ve_di=(((((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*ved_jct)+(((-ved_jct)*ved_jct)*ved_jct_Ve_di));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
  T4_Ve_di_Vge_e=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
  T4_Ve_di_Vdi_si=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
  T4_Ve_di_Ve_si=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
  T4_Ve_di_Ve_di=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*ved_jct_Ve_di+(-ved_jct_Ve_di)*ved_jct_Ve_di+(-ved_jct)*ved_jct_Ve_di_Ve_di)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*ved_jct_Ve_di+((((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di)))*ved_jct_Ve_di+((-ved_jct)*ved_jct)*ved_jct_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
  T4_Ve_di_Tempt_GND=(+(+0.0*ved_jct+(-ved_jct_Ve_di)*0.0+0.0*ved_jct_Ve_di+(-ved_jct)*0.0)*ved_jct+(((-ved_jct_Ve_di)*ved_jct)+((-ved_jct)*ved_jct_Ve_di))*0.0+(0.0)*ved_jct_Ve_di+((-ved_jct)*ved_jct)*0.0);
#endif
T4_Vge_si=0.0;
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=0.0;
  T4_Vge_si_Vge_e=0.0;
  T4_Vge_si_Vdi_si=0.0;
  T4_Vge_si_Ve_si=0.0;
  T4_Vge_si_Ve_di=0.0;
  T4_Vge_si_Vge_si=0.0;
  T4_Vge_si_Tempt_GND=0.0;
#endif
T4_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=0.0;
  T4_Tempt_GND_Vge_e=0.0;
  T4_Tempt_GND_Vdi_si=0.0;
  T4_Tempt_GND_Ve_si=0.0;
  T4_Tempt_GND_Ve_di=0.0;
  T4_Tempt_GND_Vge_si=0.0;
  T4_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T4=(((-ved_jct)*ved_jct)*ved_jct);
EXIT_IF_ISNAN((((-ved_jct)*ved_jct)*ved_jct))
{
double m00_fabs(d00_fabs0,T4)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,T4)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T4a_Vge_di=T4_Vge_di*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_di_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_di))+0.0);
  T4a_Vge_di_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_e))+0.0);
  T4a_Vge_di_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Vdi_si))+0.0);
  T4a_Vge_di_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Ve_si))+0.0);
  T4a_Vge_di_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_di+d10_fabs0*T4_Vge_di_Ve_di))+0.0);
  T4a_Vge_di_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_si))+0.0);
  T4a_Vge_di_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_di+d10_fabs0*T4_Vge_di_Tempt_GND))+0.0);
#endif
T4a_Vge_e=T4_Vge_e*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_e_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_di))+0.0);
  T4a_Vge_e_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_e))+0.0);
  T4a_Vge_e_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Vdi_si))+0.0);
  T4a_Vge_e_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Ve_si))+0.0);
  T4a_Vge_e_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_e+d10_fabs0*T4_Vge_e_Ve_di))+0.0);
  T4a_Vge_e_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_si))+0.0);
  T4a_Vge_e_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_e+d10_fabs0*T4_Vge_e_Tempt_GND))+0.0);
#endif
T4a_Vdi_si=T4_Vdi_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vdi_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_di))+0.0);
  T4a_Vdi_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_e))+0.0);
  T4a_Vdi_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vdi_si))+0.0);
  T4a_Vdi_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Ve_si))+0.0);
  T4a_Vdi_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Ve_di))+0.0);
  T4a_Vdi_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_si))+0.0);
  T4a_Vdi_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Tempt_GND))+0.0);
#endif
T4a_Ve_si=T4_Ve_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Ve_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_di))+0.0);
  T4a_Ve_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_e))+0.0);
  T4a_Ve_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Vdi_si))+0.0);
  T4a_Ve_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Ve_si))+0.0);
  T4a_Ve_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Ve_si+d10_fabs0*T4_Ve_si_Ve_di))+0.0);
  T4a_Ve_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_si))+0.0);
  T4a_Ve_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Ve_si+d10_fabs0*T4_Ve_si_Tempt_GND))+0.0);
#endif
T4a_Ve_di=T4_Ve_di*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Ve_di_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_di))+0.0);
  T4a_Ve_di_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_e))+0.0);
  T4a_Ve_di_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Vdi_si))+0.0);
  T4a_Ve_di_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Ve_si))+0.0);
  T4a_Ve_di_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Ve_di+d10_fabs0*T4_Ve_di_Ve_di))+0.0);
  T4a_Ve_di_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_si))+0.0);
  T4a_Ve_di_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Ve_di+d10_fabs0*T4_Ve_di_Tempt_GND))+0.0);
#endif
T4a_Vge_si=T4_Vge_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_di))+0.0);
  T4a_Vge_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_e))+0.0);
  T4a_Vge_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Vdi_si))+0.0);
  T4a_Vge_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Ve_si))+0.0);
  T4a_Vge_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_si+d10_fabs0*T4_Vge_si_Ve_di))+0.0);
  T4a_Vge_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_si))+0.0);
  T4a_Vge_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_si+d10_fabs0*T4_Vge_si_Tempt_GND))+0.0);
#endif
T4a_Tempt_GND=T4_Tempt_GND*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Tempt_GND_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_di))+0.0);
  T4a_Tempt_GND_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_e))+0.0);
  T4a_Tempt_GND_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vdi_si))+0.0);
  T4a_Tempt_GND_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Ve_si))+0.0);
  T4a_Tempt_GND_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Ve_di))+0.0);
  T4a_Tempt_GND_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_si))+0.0);
  T4a_Tempt_GND_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Tempt_GND))+0.0);
#endif
#endif
T4a=((CGIDL_i+d00_fabs0)+1.0e-5);
EXIT_IF_ISNAN(((CGIDL_i+d00_fabs0)+1.0e-5))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_di*T4a-T4*T4a_Vge_di)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+0.0-0.0);
  T5_Vge_di_Vdi_d=(+0.0-0.0);
  T5_Vge_di_Vsi_s=(+0.0-0.0);
  T5_Vge_di_Vge_e=(+0.0-0.0);
  T5_Vge_di_Vdi_si=(+0.0-0.0);
  T5_Vge_di_Ve_si=(+0.0-0.0);
  T5_Vge_di_Ve_di=(+0.0-0.0);
  T5_Vge_di_Vge_si=(+0.0-0.0);
  T5_Vge_di_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_e*T4a-T4*T4a_Vge_e)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+0.0-0.0);
  T5_Vge_e_Vdi_d=(+0.0-0.0);
  T5_Vge_e_Vsi_s=(+0.0-0.0);
  T5_Vge_e_Vge_e=(+0.0-0.0);
  T5_Vge_e_Vdi_si=(+0.0-0.0);
  T5_Vge_e_Ve_si=(+0.0-0.0);
  T5_Vge_e_Ve_di=(+0.0-0.0);
  T5_Vge_e_Vge_si=(+0.0-0.0);
  T5_Vge_e_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vdi_si*T4a-T4*T4a_Vdi_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0-0.0);
  T5_Vdi_si_Vdi_d=(+0.0-0.0);
  T5_Vdi_si_Vsi_s=(+0.0-0.0);
  T5_Vdi_si_Vge_e=(+0.0-0.0);
  T5_Vdi_si_Vdi_si=(+0.0-0.0);
  T5_Vdi_si_Ve_si=(+0.0-0.0);
  T5_Vdi_si_Ve_di=(+0.0-0.0);
  T5_Vdi_si_Vge_si=(+0.0-0.0);
  T5_Vdi_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Ve_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Ve_si*T4a-T4*T4a_Ve_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0-0.0);
  T5_Ve_si_Vdi_d=(+0.0-0.0);
  T5_Ve_si_Vsi_s=(+0.0-0.0);
  T5_Ve_si_Vge_e=(+0.0-0.0);
  T5_Ve_si_Vdi_si=(+0.0-0.0);
  T5_Ve_si_Ve_si=(+0.0-0.0);
  T5_Ve_si_Ve_di=(+0.0-0.0);
  T5_Ve_si_Vge_si=(+0.0-0.0);
  T5_Ve_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Ve_di=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Ve_di*T4a-T4*T4a_Ve_di)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0-0.0);
  T5_Ve_di_Vdi_d=(+0.0-0.0);
  T5_Ve_di_Vsi_s=(+0.0-0.0);
  T5_Ve_di_Vge_e=(+0.0-0.0);
  T5_Ve_di_Vdi_si=(+0.0-0.0);
  T5_Ve_di_Ve_si=(+0.0-0.0);
  T5_Ve_di_Ve_di=(+0.0-0.0);
  T5_Ve_di_Vge_si=(+0.0-0.0);
  T5_Ve_di_Tempt_GND=(+0.0-0.0);
#endif
T5_Vge_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_si*T4a-T4*T4a_Vge_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0-0.0);
  T5_Vge_si_Vdi_d=(+0.0-0.0);
  T5_Vge_si_Vsi_s=(+0.0-0.0);
  T5_Vge_si_Vge_e=(+0.0-0.0);
  T5_Vge_si_Vdi_si=(+0.0-0.0);
  T5_Vge_si_Ve_si=(+0.0-0.0);
  T5_Vge_si_Ve_di=(+0.0-0.0);
  T5_Vge_si_Vge_si=(+0.0-0.0);
  T5_Vge_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Tempt_GND=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Tempt_GND*T4a-T4*T4a_Tempt_GND)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0-0.0);
  T5_Tempt_GND_Vdi_d=(+0.0-0.0);
  T5_Tempt_GND_Vsi_s=(+0.0-0.0);
  T5_Tempt_GND_Vge_e=(+0.0-0.0);
  T5_Tempt_GND_Vdi_si=(+0.0-0.0);
  T5_Tempt_GND_Ve_si=(+0.0-0.0);
  T5_Tempt_GND_Ve_di=(+0.0-0.0);
  T5_Tempt_GND_Vge_si=(+0.0-0.0);
  T5_Tempt_GND_Tempt_GND=(+0.0-0.0);
#endif
#endif
T5=(bsimcmg_hypsmooth((T4/T4a),1.0e-6)-1.0e-6);
EXIT_IF_ISNAN((bsimcmg_hypsmooth((T4/T4a),1.0e-6)-1.0e-6))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=((((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di));
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_di);
  T6_Vge_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vdi_d);
  T6_Vge_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vsi_s);
  T6_Vge_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_e);
  T6_Vge_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vdi_si);
  T6_Vge_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Tempt_GND);
  T6_Vge_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Ve_si);
  T6_Vge_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Ve_di);
  T6_Vge_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_si);
#endif
T6_Vdi_d=((((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d));
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_di);
  T6_Vdi_d_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vdi_d);
  T6_Vdi_d_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vsi_s);
  T6_Vdi_d_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_e);
  T6_Vdi_d_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vdi_si);
  T6_Vdi_d_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Tempt_GND);
  T6_Vdi_d_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Ve_si);
  T6_Vdi_d_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Ve_di);
  T6_Vdi_d_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_d+(AGIDL_i*Weff0)*T3_Vdi_d_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_si);
#endif
T6_Vsi_s=((((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s));
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_di);
  T6_Vsi_s_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vdi_d);
  T6_Vsi_s_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vsi_s);
  T6_Vsi_s_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_e);
  T6_Vsi_s_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vdi_si);
  T6_Vsi_s_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Tempt_GND);
  T6_Vsi_s_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Ve_si);
  T6_Vsi_s_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Ve_di);
  T6_Vsi_s_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vsi_s+(AGIDL_i*Weff0)*T3_Vsi_s_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_si);
#endif
T6_Vge_e=((((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e));
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_di);
  T6_Vge_e_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vdi_d);
  T6_Vge_e_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vsi_s);
  T6_Vge_e_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_e);
  T6_Vge_e_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vdi_si);
  T6_Vge_e_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Tempt_GND);
  T6_Vge_e_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Ve_si);
  T6_Vge_e_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Ve_di);
  T6_Vge_e_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_si);
#endif
T6_Vdi_si=((((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_di);
  T6_Vdi_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vdi_d);
  T6_Vdi_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vsi_s);
  T6_Vdi_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_e);
  T6_Vdi_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vdi_si);
  T6_Vdi_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Tempt_GND);
  T6_Vdi_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Ve_si);
  T6_Vdi_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Ve_di);
  T6_Vdi_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_si);
#endif
T6_Tempt_GND=((((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_di);
  T6_Tempt_GND_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vdi_d);
  T6_Tempt_GND_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vsi_s);
  T6_Tempt_GND_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_e);
  T6_Tempt_GND_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vdi_si);
  T6_Tempt_GND_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Tempt_GND);
  T6_Tempt_GND_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Ve_si);
  T6_Tempt_GND_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Ve_di);
  T6_Tempt_GND_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_si);
#endif
T6_Ve_si=((((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si));
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_di);
  T6_Ve_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vdi_d);
  T6_Ve_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vsi_s);
  T6_Ve_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_e);
  T6_Ve_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vdi_si);
  T6_Ve_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Tempt_GND);
  T6_Ve_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Ve_si);
  T6_Ve_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Ve_di);
  T6_Ve_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_si);
#endif
T6_Ve_di=((((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di));
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_di);
  T6_Ve_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vdi_d);
  T6_Ve_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vsi_s);
  T6_Ve_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_e);
  T6_Ve_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vdi_si);
  T6_Ve_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Tempt_GND);
  T6_Ve_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Ve_si);
  T6_Ve_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Ve_di);
  T6_Ve_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_si);
#endif
T6_Vge_si=((((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si));
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_di);
  T6_Vge_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vdi_d);
  T6_Vge_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vsi_s);
  T6_Vge_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_e);
  T6_Vge_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vdi_si);
  T6_Vge_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Tempt_GND);
  T6_Vge_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Ve_si);
  T6_Vge_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Ve_di);
  T6_Vge_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*T5+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_si);
#endif
#endif
T6=((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5);
EXIT_IF_ISNAN(((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_di+(AGIDL_i*Weff0)*T3_Vge_di_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_e+(AGIDL_i*Weff0)*T3_Vge_e_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vdi_si=((((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*vds_noswap)+((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*vds_noswap_Vdi_si));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*vds_noswap_Vdi_si_Vdi_si);
  T6_Vdi_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_si+(AGIDL_i*Weff0)*T3_Vdi_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*vds_noswap_Vdi_si+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Tempt_GND=((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Tempt_GND+(AGIDL_i*Weff0)*T3_Tempt_GND_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Ve_si=((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_si+(AGIDL_i*Weff0)*T3_Ve_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Ve_di=((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_di+(AGIDL_i*Weff0)*T3_Ve_di_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vge_si=((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*vds_noswap;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_e)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*vds_noswap_Vdi_si+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Ve_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Ve_di)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGIDL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_si+(AGIDL_i*Weff0)*T3_Vge_si_Vge_si)*bsimcmg_lexp((-T2))+((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGIDL_i*Weff0)*T3)*0.0)*vds_noswap+((((AGIDL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGIDL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGIDL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
#endif
T6=((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*vds_noswap);
EXIT_IF_ISNAN(((((AGIDL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*vds_noswap))
}
}
if
((sigvds>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igidl_Vge_di=T6_Vge_di;
#if defined(_DERIVATE2)
  igidl_Vge_di_Vge_di=T6_Vge_di_Vge_di;
  igidl_Vge_di_Vdi_d=T6_Vge_di_Vdi_d;
  igidl_Vge_di_Vsi_s=T6_Vge_di_Vsi_s;
  igidl_Vge_di_Vge_e=T6_Vge_di_Vge_e;
  igidl_Vge_di_Vdi_si=T6_Vge_di_Vdi_si;
  igidl_Vge_di_Tempt_GND=T6_Vge_di_Tempt_GND;
  igidl_Vge_di_Ve_si=T6_Vge_di_Ve_si;
  igidl_Vge_di_Ve_di=T6_Vge_di_Ve_di;
  igidl_Vge_di_Vge_si=T6_Vge_di_Vge_si;
#endif
igidl_Vdi_d=T6_Vdi_d;
#if defined(_DERIVATE2)
  igidl_Vdi_d_Vge_di=T6_Vdi_d_Vge_di;
  igidl_Vdi_d_Vdi_d=T6_Vdi_d_Vdi_d;
  igidl_Vdi_d_Vsi_s=T6_Vdi_d_Vsi_s;
  igidl_Vdi_d_Vge_e=T6_Vdi_d_Vge_e;
  igidl_Vdi_d_Vdi_si=T6_Vdi_d_Vdi_si;
  igidl_Vdi_d_Tempt_GND=T6_Vdi_d_Tempt_GND;
  igidl_Vdi_d_Ve_si=T6_Vdi_d_Ve_si;
  igidl_Vdi_d_Ve_di=T6_Vdi_d_Ve_di;
  igidl_Vdi_d_Vge_si=T6_Vdi_d_Vge_si;
#endif
igidl_Vsi_s=T6_Vsi_s;
#if defined(_DERIVATE2)
  igidl_Vsi_s_Vge_di=T6_Vsi_s_Vge_di;
  igidl_Vsi_s_Vdi_d=T6_Vsi_s_Vdi_d;
  igidl_Vsi_s_Vsi_s=T6_Vsi_s_Vsi_s;
  igidl_Vsi_s_Vge_e=T6_Vsi_s_Vge_e;
  igidl_Vsi_s_Vdi_si=T6_Vsi_s_Vdi_si;
  igidl_Vsi_s_Tempt_GND=T6_Vsi_s_Tempt_GND;
  igidl_Vsi_s_Ve_si=T6_Vsi_s_Ve_si;
  igidl_Vsi_s_Ve_di=T6_Vsi_s_Ve_di;
  igidl_Vsi_s_Vge_si=T6_Vsi_s_Vge_si;
#endif
igidl_Vge_e=T6_Vge_e;
#if defined(_DERIVATE2)
  igidl_Vge_e_Vge_di=T6_Vge_e_Vge_di;
  igidl_Vge_e_Vdi_d=T6_Vge_e_Vdi_d;
  igidl_Vge_e_Vsi_s=T6_Vge_e_Vsi_s;
  igidl_Vge_e_Vge_e=T6_Vge_e_Vge_e;
  igidl_Vge_e_Vdi_si=T6_Vge_e_Vdi_si;
  igidl_Vge_e_Tempt_GND=T6_Vge_e_Tempt_GND;
  igidl_Vge_e_Ve_si=T6_Vge_e_Ve_si;
  igidl_Vge_e_Ve_di=T6_Vge_e_Ve_di;
  igidl_Vge_e_Vge_si=T6_Vge_e_Vge_si;
#endif
igidl_Vdi_si=T6_Vdi_si;
#if defined(_DERIVATE2)
  igidl_Vdi_si_Vge_di=T6_Vdi_si_Vge_di;
  igidl_Vdi_si_Vdi_d=T6_Vdi_si_Vdi_d;
  igidl_Vdi_si_Vsi_s=T6_Vdi_si_Vsi_s;
  igidl_Vdi_si_Vge_e=T6_Vdi_si_Vge_e;
  igidl_Vdi_si_Vdi_si=T6_Vdi_si_Vdi_si;
  igidl_Vdi_si_Tempt_GND=T6_Vdi_si_Tempt_GND;
  igidl_Vdi_si_Ve_si=T6_Vdi_si_Ve_si;
  igidl_Vdi_si_Ve_di=T6_Vdi_si_Ve_di;
  igidl_Vdi_si_Vge_si=T6_Vdi_si_Vge_si;
#endif
igidl_Tempt_GND=T6_Tempt_GND;
#if defined(_DERIVATE2)
  igidl_Tempt_GND_Vge_di=T6_Tempt_GND_Vge_di;
  igidl_Tempt_GND_Vdi_d=T6_Tempt_GND_Vdi_d;
  igidl_Tempt_GND_Vsi_s=T6_Tempt_GND_Vsi_s;
  igidl_Tempt_GND_Vge_e=T6_Tempt_GND_Vge_e;
  igidl_Tempt_GND_Vdi_si=T6_Tempt_GND_Vdi_si;
  igidl_Tempt_GND_Tempt_GND=T6_Tempt_GND_Tempt_GND;
  igidl_Tempt_GND_Ve_si=T6_Tempt_GND_Ve_si;
  igidl_Tempt_GND_Ve_di=T6_Tempt_GND_Ve_di;
  igidl_Tempt_GND_Vge_si=T6_Tempt_GND_Vge_si;
#endif
igidl_Ve_si=T6_Ve_si;
#if defined(_DERIVATE2)
  igidl_Ve_si_Vge_di=T6_Ve_si_Vge_di;
  igidl_Ve_si_Vdi_d=T6_Ve_si_Vdi_d;
  igidl_Ve_si_Vsi_s=T6_Ve_si_Vsi_s;
  igidl_Ve_si_Vge_e=T6_Ve_si_Vge_e;
  igidl_Ve_si_Vdi_si=T6_Ve_si_Vdi_si;
  igidl_Ve_si_Tempt_GND=T6_Ve_si_Tempt_GND;
  igidl_Ve_si_Ve_si=T6_Ve_si_Ve_si;
  igidl_Ve_si_Ve_di=T6_Ve_si_Ve_di;
  igidl_Ve_si_Vge_si=T6_Ve_si_Vge_si;
#endif
igidl_Ve_di=T6_Ve_di;
#if defined(_DERIVATE2)
  igidl_Ve_di_Vge_di=T6_Ve_di_Vge_di;
  igidl_Ve_di_Vdi_d=T6_Ve_di_Vdi_d;
  igidl_Ve_di_Vsi_s=T6_Ve_di_Vsi_s;
  igidl_Ve_di_Vge_e=T6_Ve_di_Vge_e;
  igidl_Ve_di_Vdi_si=T6_Ve_di_Vdi_si;
  igidl_Ve_di_Tempt_GND=T6_Ve_di_Tempt_GND;
  igidl_Ve_di_Ve_si=T6_Ve_di_Ve_si;
  igidl_Ve_di_Ve_di=T6_Ve_di_Ve_di;
  igidl_Ve_di_Vge_si=T6_Ve_di_Vge_si;
#endif
igidl_Vge_si=T6_Vge_si;
#if defined(_DERIVATE2)
  igidl_Vge_si_Vge_di=T6_Vge_si_Vge_di;
  igidl_Vge_si_Vdi_d=T6_Vge_si_Vdi_d;
  igidl_Vge_si_Vsi_s=T6_Vge_si_Vsi_s;
  igidl_Vge_si_Vge_e=T6_Vge_si_Vge_e;
  igidl_Vge_si_Vdi_si=T6_Vge_si_Vdi_si;
  igidl_Vge_si_Tempt_GND=T6_Vge_si_Tempt_GND;
  igidl_Vge_si_Ve_si=T6_Vge_si_Ve_si;
  igidl_Vge_si_Ve_di=T6_Vge_si_Ve_di;
  igidl_Vge_si_Vge_si=T6_Vge_si_Vge_si;
#endif
#endif
igidl=T6;
EXIT_IF_ISNAN(T6)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igisl_Vge_di=T6_Vge_di;
#if defined(_DERIVATE2)
  igisl_Vge_di_Vge_di=T6_Vge_di_Vge_di;
  igisl_Vge_di_Vdi_d=T6_Vge_di_Vdi_d;
  igisl_Vge_di_Vsi_s=T6_Vge_di_Vsi_s;
  igisl_Vge_di_Vge_e=T6_Vge_di_Vge_e;
  igisl_Vge_di_Vdi_si=T6_Vge_di_Vdi_si;
  igisl_Vge_di_Tempt_GND=T6_Vge_di_Tempt_GND;
  igisl_Vge_di_Ve_si=T6_Vge_di_Ve_si;
  igisl_Vge_di_Ve_di=T6_Vge_di_Ve_di;
  igisl_Vge_di_Vge_si=T6_Vge_di_Vge_si;
#endif
igisl_Vdi_d=T6_Vdi_d;
#if defined(_DERIVATE2)
  igisl_Vdi_d_Vge_di=T6_Vdi_d_Vge_di;
  igisl_Vdi_d_Vdi_d=T6_Vdi_d_Vdi_d;
  igisl_Vdi_d_Vsi_s=T6_Vdi_d_Vsi_s;
  igisl_Vdi_d_Vge_e=T6_Vdi_d_Vge_e;
  igisl_Vdi_d_Vdi_si=T6_Vdi_d_Vdi_si;
  igisl_Vdi_d_Tempt_GND=T6_Vdi_d_Tempt_GND;
  igisl_Vdi_d_Ve_si=T6_Vdi_d_Ve_si;
  igisl_Vdi_d_Ve_di=T6_Vdi_d_Ve_di;
  igisl_Vdi_d_Vge_si=T6_Vdi_d_Vge_si;
#endif
igisl_Vsi_s=T6_Vsi_s;
#if defined(_DERIVATE2)
  igisl_Vsi_s_Vge_di=T6_Vsi_s_Vge_di;
  igisl_Vsi_s_Vdi_d=T6_Vsi_s_Vdi_d;
  igisl_Vsi_s_Vsi_s=T6_Vsi_s_Vsi_s;
  igisl_Vsi_s_Vge_e=T6_Vsi_s_Vge_e;
  igisl_Vsi_s_Vdi_si=T6_Vsi_s_Vdi_si;
  igisl_Vsi_s_Tempt_GND=T6_Vsi_s_Tempt_GND;
  igisl_Vsi_s_Ve_si=T6_Vsi_s_Ve_si;
  igisl_Vsi_s_Ve_di=T6_Vsi_s_Ve_di;
  igisl_Vsi_s_Vge_si=T6_Vsi_s_Vge_si;
#endif
igisl_Vge_e=T6_Vge_e;
#if defined(_DERIVATE2)
  igisl_Vge_e_Vge_di=T6_Vge_e_Vge_di;
  igisl_Vge_e_Vdi_d=T6_Vge_e_Vdi_d;
  igisl_Vge_e_Vsi_s=T6_Vge_e_Vsi_s;
  igisl_Vge_e_Vge_e=T6_Vge_e_Vge_e;
  igisl_Vge_e_Vdi_si=T6_Vge_e_Vdi_si;
  igisl_Vge_e_Tempt_GND=T6_Vge_e_Tempt_GND;
  igisl_Vge_e_Ve_si=T6_Vge_e_Ve_si;
  igisl_Vge_e_Ve_di=T6_Vge_e_Ve_di;
  igisl_Vge_e_Vge_si=T6_Vge_e_Vge_si;
#endif
igisl_Vdi_si=T6_Vdi_si;
#if defined(_DERIVATE2)
  igisl_Vdi_si_Vge_di=T6_Vdi_si_Vge_di;
  igisl_Vdi_si_Vdi_d=T6_Vdi_si_Vdi_d;
  igisl_Vdi_si_Vsi_s=T6_Vdi_si_Vsi_s;
  igisl_Vdi_si_Vge_e=T6_Vdi_si_Vge_e;
  igisl_Vdi_si_Vdi_si=T6_Vdi_si_Vdi_si;
  igisl_Vdi_si_Tempt_GND=T6_Vdi_si_Tempt_GND;
  igisl_Vdi_si_Ve_si=T6_Vdi_si_Ve_si;
  igisl_Vdi_si_Ve_di=T6_Vdi_si_Ve_di;
  igisl_Vdi_si_Vge_si=T6_Vdi_si_Vge_si;
#endif
igisl_Tempt_GND=T6_Tempt_GND;
#if defined(_DERIVATE2)
  igisl_Tempt_GND_Vge_di=T6_Tempt_GND_Vge_di;
  igisl_Tempt_GND_Vdi_d=T6_Tempt_GND_Vdi_d;
  igisl_Tempt_GND_Vsi_s=T6_Tempt_GND_Vsi_s;
  igisl_Tempt_GND_Vge_e=T6_Tempt_GND_Vge_e;
  igisl_Tempt_GND_Vdi_si=T6_Tempt_GND_Vdi_si;
  igisl_Tempt_GND_Tempt_GND=T6_Tempt_GND_Tempt_GND;
  igisl_Tempt_GND_Ve_si=T6_Tempt_GND_Ve_si;
  igisl_Tempt_GND_Ve_di=T6_Tempt_GND_Ve_di;
  igisl_Tempt_GND_Vge_si=T6_Tempt_GND_Vge_si;
#endif
igisl_Ve_si=T6_Ve_si;
#if defined(_DERIVATE2)
  igisl_Ve_si_Vge_di=T6_Ve_si_Vge_di;
  igisl_Ve_si_Vdi_d=T6_Ve_si_Vdi_d;
  igisl_Ve_si_Vsi_s=T6_Ve_si_Vsi_s;
  igisl_Ve_si_Vge_e=T6_Ve_si_Vge_e;
  igisl_Ve_si_Vdi_si=T6_Ve_si_Vdi_si;
  igisl_Ve_si_Tempt_GND=T6_Ve_si_Tempt_GND;
  igisl_Ve_si_Ve_si=T6_Ve_si_Ve_si;
  igisl_Ve_si_Ve_di=T6_Ve_si_Ve_di;
  igisl_Ve_si_Vge_si=T6_Ve_si_Vge_si;
#endif
igisl_Ve_di=T6_Ve_di;
#if defined(_DERIVATE2)
  igisl_Ve_di_Vge_di=T6_Ve_di_Vge_di;
  igisl_Ve_di_Vdi_d=T6_Ve_di_Vdi_d;
  igisl_Ve_di_Vsi_s=T6_Ve_di_Vsi_s;
  igisl_Ve_di_Vge_e=T6_Ve_di_Vge_e;
  igisl_Ve_di_Vdi_si=T6_Ve_di_Vdi_si;
  igisl_Ve_di_Tempt_GND=T6_Ve_di_Tempt_GND;
  igisl_Ve_di_Ve_si=T6_Ve_di_Ve_si;
  igisl_Ve_di_Ve_di=T6_Ve_di_Ve_di;
  igisl_Ve_di_Vge_si=T6_Ve_di_Vge_si;
#endif
igisl_Vge_si=T6_Vge_si;
#if defined(_DERIVATE2)
  igisl_Vge_si_Vge_di=T6_Vge_si_Vge_di;
  igisl_Vge_si_Vdi_d=T6_Vge_si_Vdi_d;
  igisl_Vge_si_Vsi_s=T6_Vge_si_Vsi_s;
  igisl_Vge_si_Vge_e=T6_Vge_si_Vge_e;
  igisl_Vge_si_Vdi_si=T6_Vge_si_Vdi_si;
  igisl_Vge_si_Tempt_GND=T6_Vge_si_Tempt_GND;
  igisl_Vge_si_Ve_si=T6_Vge_si_Ve_si;
  igisl_Vge_si_Ve_di=T6_Vge_si_Ve_di;
  igisl_Vge_si_Vge_si=T6_Vge_si_Vge_si;
#endif
#endif
igisl=T6;
EXIT_IF_ISNAN(T6)
}
if
(((AGISL_i<=0.0)||(BGISL_t<=0.0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=0.0;
  T6_Vdi_si_Vdi_d=0.0;
  T6_Vdi_si_Vsi_s=0.0;
  T6_Vdi_si_Vge_e=0.0;
  T6_Vdi_si_Vdi_si=0.0;
  T6_Vdi_si_Tempt_GND=0.0;
  T6_Vdi_si_Ve_si=0.0;
  T6_Vdi_si_Ve_di=0.0;
  T6_Vdi_si_Vge_si=0.0;
#endif
T6_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=0.0;
  T6_Tempt_GND_Vdi_d=0.0;
  T6_Tempt_GND_Vsi_s=0.0;
  T6_Tempt_GND_Vge_e=0.0;
  T6_Tempt_GND_Vdi_si=0.0;
  T6_Tempt_GND_Tempt_GND=0.0;
  T6_Tempt_GND_Ve_si=0.0;
  T6_Tempt_GND_Ve_di=0.0;
  T6_Tempt_GND_Vge_si=0.0;
#endif
T6_Ve_si=0.0;
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=0.0;
  T6_Ve_si_Vdi_d=0.0;
  T6_Ve_si_Vsi_s=0.0;
  T6_Ve_si_Vge_e=0.0;
  T6_Ve_si_Vdi_si=0.0;
  T6_Ve_si_Tempt_GND=0.0;
  T6_Ve_si_Ve_si=0.0;
  T6_Ve_si_Ve_di=0.0;
  T6_Ve_si_Vge_si=0.0;
#endif
T6_Ve_di=0.0;
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=0.0;
  T6_Ve_di_Vdi_d=0.0;
  T6_Ve_di_Vsi_s=0.0;
  T6_Ve_di_Vge_e=0.0;
  T6_Ve_di_Vdi_si=0.0;
  T6_Ve_di_Tempt_GND=0.0;
  T6_Ve_di_Ve_si=0.0;
  T6_Ve_di_Ve_di=0.0;
  T6_Ve_di_Vge_si=0.0;
#endif
T6_Vge_si=0.0;
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=0.0;
  T6_Vge_si_Vdi_d=0.0;
  T6_Vge_si_Vsi_s=0.0;
  T6_Vge_si_Vge_e=0.0;
  T6_Vge_si_Vdi_si=0.0;
  T6_Vge_si_Tempt_GND=0.0;
  T6_Vge_si_Ve_si=0.0;
  T6_Vge_si_Ve_di=0.0;
  T6_Vge_si_Vge_si=0.0;
#endif
#endif
T6=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=(-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*0.0/T0/T0/T0);
  T1_Vge_di_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*0.0/T0/T0/T0);
  T1_Vge_di_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Vge_di/T0/T0/T0);
  T1_Vge_di_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Vge_e/T0/T0/T0);
  T1_Vge_di_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Ve_si/T0/T0/T0);
  T1_Vge_di_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Ve_di/T0/T0/T0);
  T1_Vge_di_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Vge_si/T0/T0/T0);
  T1_Vge_di_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Vdi_si/T0/T0/T0);
  T1_Vge_di_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_di*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vge_e=(-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*0.0/T0/T0/T0);
  T1_Vge_e_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*0.0/T0/T0/T0);
  T1_Vge_e_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Vge_di/T0/T0/T0);
  T1_Vge_e_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Vge_e/T0/T0/T0);
  T1_Vge_e_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Ve_si/T0/T0/T0);
  T1_Vge_e_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Ve_di/T0/T0/T0);
  T1_Vge_e_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Vge_si/T0/T0/T0);
  T1_Vge_e_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Vdi_si/T0/T0/T0);
  T1_Vge_e_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_e+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_e*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Ve_si=(-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si/T0/T0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*0.0/T0/T0/T0);
  T1_Ve_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*0.0/T0/T0/T0);
  T1_Ve_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Vge_di/T0/T0/T0);
  T1_Ve_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Vge_e/T0/T0/T0);
  T1_Ve_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Ve_si/T0/T0/T0);
  T1_Ve_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Ve_di/T0/T0/T0);
  T1_Ve_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Vge_si/T0/T0/T0);
  T1_Ve_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Vdi_si/T0/T0/T0);
  T1_Ve_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Ve_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Ve_di=(-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di/T0/T0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*0.0/T0/T0/T0);
  T1_Ve_di_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*0.0/T0/T0/T0);
  T1_Ve_di_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Vge_di/T0/T0/T0);
  T1_Ve_di_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Vge_e/T0/T0/T0);
  T1_Ve_di_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Ve_si/T0/T0/T0);
  T1_Ve_di_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Ve_di/T0/T0/T0);
  T1_Ve_di_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Vge_si/T0/T0/T0);
  T1_Ve_di_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Vdi_si/T0/T0/T0);
  T1_Ve_di_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Ve_di+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Ve_di*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vge_si=(((-vgs_noswap_Vge_si)*T0-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si)/T0/T0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*0.0+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*0.0/T0/T0/T0);
  T1_Vge_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*0.0+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*0.0/T0/T0/T0);
  T1_Vge_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Vge_di+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Vge_di/T0/T0/T0);
  T1_Vge_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Vge_e+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Vge_e/T0/T0/T0);
  T1_Vge_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Ve_si+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Ve_si/T0/T0/T0);
  T1_Vge_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Ve_di+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Ve_di/T0/T0/T0);
  T1_Vge_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Vge_si/T0/T0/T0);
  T1_Vge_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Vdi_si+0.0*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Vdi_si/T0/T0/T0);
  T1_Vge_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-((-vgs_noswap_Vge_si)*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vge_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vge_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Vdi_si=(-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si/T0/T0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*0.0/T0/T0/T0);
  T1_Vdi_si_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(0.0*0.0+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*0.0/T0/T0/T0);
  T1_Vdi_si_Vge_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_di+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Vge_di/T0/T0/T0);
  T1_Vdi_si_Vge_e=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_e+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Vge_e/T0/T0/T0);
  T1_Vdi_si_Ve_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_si+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Ve_si/T0/T0/T0);
  T1_Vdi_si_Ve_di=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Ve_di+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Ve_di/T0/T0/T0);
  T1_Vdi_si_Vge_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Vge_si/T0/T0/T0);
  T1_Vdi_si_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Vdi_si+0.0*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Vdi_si/T0/T0/T0);
  T1_Vdi_si_Tempt_GND=((+(+0.0-0.0)+0.0)/T0-(0.0*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Vdi_si+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Vdi_si*T0_Tempt_GND/T0/T0/T0);
#endif
T1_Tempt_GND=((vfbsd_Tempt_GND*T0-(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND)/T0/T0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*0.0+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*0.0/T0/T0/T0);
  T1_Tempt_GND_Vsi_s=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*0.0+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*0.0)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*0.0/T0/T0/T0);
  T1_Tempt_GND_Vge_di=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_di+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Vge_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_di/T0/T0/T0);
  T1_Tempt_GND_Vge_e=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_e+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Vge_e)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_e/T0/T0/T0);
  T1_Tempt_GND_Ve_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Ve_si+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Ve_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Ve_si/T0/T0/T0);
  T1_Tempt_GND_Ve_di=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Ve_di+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Ve_di)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Ve_di/T0/T0/T0);
  T1_Tempt_GND_Vge_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vge_si+(-vgs_noswap_Vge_si)*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Vge_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Vge_si/T0/T0/T0);
  T1_Tempt_GND_Vdi_si=((+(+0.0-0.0)+0.0)/T0-(vfbsd_Tempt_GND*T0_Vdi_si+0.0*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Vdi_si)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Vdi_si/T0/T0/T0);
  T1_Tempt_GND_Tempt_GND=((+(+0.0-0.0)+vfbsd_Tempt_GND_Tempt_GND)/T0-(vfbsd_Tempt_GND*T0_Tempt_GND+vfbsd_Tempt_GND*T0_Tempt_GND+(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND_Tempt_GND)/T0/T0+2*(((-vgs_noswap)-EGISL_i)+vfbsd)*T0_Tempt_GND*T0_Tempt_GND/T0/T0/T0);
#endif
#endif
T1=((((-vgs_noswap)-EGISL_i)+vfbsd)/T0);
EXIT_IF_ISNAN(((((-vgs_noswap)-EGISL_i)+vfbsd)/T0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_di,0.0);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_e,0.0);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Ve_si,0.0);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Ve_di,0.0);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vge_si,0.0);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Vdi_si,0.0);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=bsimcmg_d_hypsmooth(T1,1.0e-2,T1_Tempt_GND,0.0);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=0.0;
  T1_Tempt_GND_Vsi_s=0.0;
  T1_Tempt_GND_Vge_di=0.0;
  T1_Tempt_GND_Vge_e=0.0;
  T1_Tempt_GND_Ve_si=0.0;
  T1_Tempt_GND_Ve_di=0.0;
  T1_Tempt_GND_Vge_si=0.0;
  T1_Tempt_GND_Vdi_si=0.0;
  T1_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T1=bsimcmg_hypsmooth(T1,1.0e-2);
EXIT_IF_ISNAN(bsimcmg_hypsmooth(T1,1.0e-2))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=(-BGISL_t*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_di+BGISL_t*(+T1_Vge_di_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_di_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vge_di+BGISL_t*(+T1_Vge_di_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_di*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vge_e=(-BGISL_t*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_e+BGISL_t*(+T1_Vge_e_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_e_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vge_e+BGISL_t*(+T1_Vge_e_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_e*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vge_si=(-BGISL_t*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vge_si+BGISL_t*(+T1_Vge_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vge_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vge_si+BGISL_t*(+T1_Vge_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vge_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Ve_si=(-BGISL_t*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Ve_si+BGISL_t*(+T1_Ve_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Ve_si+BGISL_t*(+T1_Ve_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Ve_di=(-BGISL_t*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Ve_di+BGISL_t*(+T1_Ve_di_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Ve_di_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Ve_di+BGISL_t*(+T1_Ve_di_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Ve_di*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Vdi_si=(-BGISL_t*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_d+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vsi_s=(0.0/(T1+1.0e-3)-(0.0*T1_Vsi_s+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_di=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_di+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_e=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_e+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vge_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vge_si+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Ve_si=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_si+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Ve_di=(0.0/(T1+1.0e-3)-(0.0*T1_Ve_di+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Vdi_si=(0.0/(T1+1.0e-3)-(0.0*T1_Vdi_si+0.0*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Vdi_si_Tempt_GND=(0.0/(T1+1.0e-3)-(0.0*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Vdi_si+BGISL_t*(+T1_Vdi_si_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Vdi_si*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
T2_Tempt_GND=((BGISL_t_Tempt_GND*(T1+1.0e-3)-BGISL_t*T1_Tempt_GND)/(T1+1.0e-3)/(T1+1.0e-3));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vdi_d+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vdi_d+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vdi_d/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vsi_s=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vsi_s+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vsi_s+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vsi_s/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_di=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vge_di+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vge_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vge_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_e=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vge_e+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vge_e+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vge_e/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vge_si=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vge_si+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vge_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vge_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Ve_si=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Ve_si+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Ve_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Ve_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Ve_di=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Ve_di+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Ve_di+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Ve_di/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Vdi_si=(0.0/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Vdi_si+0.0*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Vdi_si+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Vdi_si/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
  T2_Tempt_GND_Tempt_GND=(BGISL_t_Tempt_GND_Tempt_GND/(T1+1.0e-3)-(BGISL_t_Tempt_GND*T1_Tempt_GND+BGISL_t_Tempt_GND*T1_Tempt_GND+BGISL_t*(+T1_Tempt_GND_Tempt_GND+0.0))/(T1+1.0e-3)/(T1+1.0e-3)+2*BGISL_t*T1_Tempt_GND*T1_Tempt_GND/(T1+1.0e-3)/(T1+1.0e-3)/(T1+1.0e-3));
#endif
#endif
T2=(BGISL_t/(T1+1.0e-3));
EXIT_IF_ISNAN((BGISL_t/(T1+1.0e-3)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Vge_di)));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+0.0*bsimcmg_d_lln(T1,T1_Vge_di)+PGISL_i*T1_Vge_di_Tempt_GND);
#endif
T3_Vge_e=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Vge_e)));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+0.0*bsimcmg_d_lln(T1,T1_Vge_e)+PGISL_i*T1_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Vdi_si)));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+0.0*bsimcmg_d_lln(T1,T1_Vdi_si)+PGISL_i*T1_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Ve_si)));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+0.0*bsimcmg_d_lln(T1,T1_Ve_si)+PGISL_i*T1_Ve_si_Tempt_GND);
#endif
T3_Ve_di=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Ve_di)));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+0.0*bsimcmg_d_lln(T1,T1_Ve_di)+PGISL_i*T1_Ve_di_Tempt_GND);
#endif
T3_Vge_si=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Vge_si)));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+0.0*bsimcmg_d_lln(T1,T1_Vge_si)+PGISL_i*T1_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=bsimcmg_d_lexp((PGISL_i*bsimcmg_lln(T1)),(PGISL_i*bsimcmg_d_lln(T1,T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(T1)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+0.0*bsimcmg_d_lln(T1,T1_Tempt_GND)+PGISL_i*T1_Tempt_GND_Tempt_GND);
#endif
#endif
T3=bsimcmg_lexp((PGISL_i*bsimcmg_lln(T1)));
EXIT_IF_ISNAN(bsimcmg_lexp((PGISL_i*bsimcmg_lln(T1))))
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=0.0;
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=0.0;
  T4_Vge_e_Vge_e=0.0;
  T4_Vge_e_Vdi_si=0.0;
  T4_Vge_e_Ve_si=0.0;
  T4_Vge_e_Ve_di=0.0;
  T4_Vge_e_Vge_si=0.0;
  T4_Vge_e_Tempt_GND=0.0;
#endif
T4_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=0.0;
  T4_Vdi_si_Vge_e=0.0;
  T4_Vdi_si_Vdi_si=0.0;
  T4_Vdi_si_Ve_si=0.0;
  T4_Vdi_si_Ve_di=0.0;
  T4_Vdi_si_Vge_si=0.0;
  T4_Vdi_si_Tempt_GND=0.0;
#endif
T4_Ve_si=(((((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*ves_jct)+(((-ves_jct)*ves_jct)*ves_jct_Ve_si));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
  T4_Ve_si_Vge_e=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
  T4_Ve_si_Vdi_si=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
  T4_Ve_si_Ve_si=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*ves_jct_Ve_si+(-ves_jct_Ve_si)*ves_jct_Ve_si+(-ves_jct)*ves_jct_Ve_si_Ve_si)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*ves_jct_Ve_si+((((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si)))*ves_jct_Ve_si+((-ves_jct)*ves_jct)*ves_jct_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
  T4_Ve_si_Vge_si=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
  T4_Ve_si_Tempt_GND=(+(+0.0*ves_jct+(-ves_jct_Ve_si)*0.0+0.0*ves_jct_Ve_si+(-ves_jct)*0.0)*ves_jct+(((-ves_jct_Ve_si)*ves_jct)+((-ves_jct)*ves_jct_Ve_si))*0.0+(0.0)*ves_jct_Ve_si+((-ves_jct)*ves_jct)*0.0);
#endif
T4_Ve_di=0.0;
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=0.0;
  T4_Ve_di_Vge_e=0.0;
  T4_Ve_di_Vdi_si=0.0;
  T4_Ve_di_Ve_si=0.0;
  T4_Ve_di_Ve_di=0.0;
  T4_Ve_di_Vge_si=0.0;
  T4_Ve_di_Tempt_GND=0.0;
#endif
T4_Vge_si=0.0;
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=0.0;
  T4_Vge_si_Vge_e=0.0;
  T4_Vge_si_Vdi_si=0.0;
  T4_Vge_si_Ve_si=0.0;
  T4_Vge_si_Ve_di=0.0;
  T4_Vge_si_Vge_si=0.0;
  T4_Vge_si_Tempt_GND=0.0;
#endif
T4_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=0.0;
  T4_Tempt_GND_Vge_e=0.0;
  T4_Tempt_GND_Vdi_si=0.0;
  T4_Tempt_GND_Ve_si=0.0;
  T4_Tempt_GND_Ve_di=0.0;
  T4_Tempt_GND_Vge_si=0.0;
  T4_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T4=(((-ves_jct)*ves_jct)*ves_jct);
EXIT_IF_ISNAN((((-ves_jct)*ves_jct)*ves_jct))
{
double m00_fabs(d00_fabs0,T4)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,T4)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T4a_Vge_di=T4_Vge_di*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_di_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_di))+0.0);
  T4a_Vge_di_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_e))+0.0);
  T4a_Vge_di_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Vdi_si))+0.0);
  T4a_Vge_di_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Ve_si))+0.0);
  T4a_Vge_di_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_di+d10_fabs0*T4_Vge_di_Ve_di))+0.0);
  T4a_Vge_di_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_di+d10_fabs0*T4_Vge_di_Vge_si))+0.0);
  T4a_Vge_di_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_di+d10_fabs0*T4_Vge_di_Tempt_GND))+0.0);
#endif
T4a_Vge_e=T4_Vge_e*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_e_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_di))+0.0);
  T4a_Vge_e_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_e))+0.0);
  T4a_Vge_e_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Vdi_si))+0.0);
  T4a_Vge_e_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Ve_si))+0.0);
  T4a_Vge_e_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_e+d10_fabs0*T4_Vge_e_Ve_di))+0.0);
  T4a_Vge_e_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_e+d10_fabs0*T4_Vge_e_Vge_si))+0.0);
  T4a_Vge_e_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_e+d10_fabs0*T4_Vge_e_Tempt_GND))+0.0);
#endif
T4a_Vdi_si=T4_Vdi_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vdi_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_di))+0.0);
  T4a_Vdi_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_e))+0.0);
  T4a_Vdi_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vdi_si))+0.0);
  T4a_Vdi_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Ve_si))+0.0);
  T4a_Vdi_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Ve_di))+0.0);
  T4a_Vdi_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Vge_si))+0.0);
  T4a_Vdi_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vdi_si+d10_fabs0*T4_Vdi_si_Tempt_GND))+0.0);
#endif
T4a_Ve_si=T4_Ve_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Ve_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_di))+0.0);
  T4a_Ve_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_e))+0.0);
  T4a_Ve_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Vdi_si))+0.0);
  T4a_Ve_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Ve_si))+0.0);
  T4a_Ve_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Ve_si+d10_fabs0*T4_Ve_si_Ve_di))+0.0);
  T4a_Ve_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Ve_si+d10_fabs0*T4_Ve_si_Vge_si))+0.0);
  T4a_Ve_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Ve_si+d10_fabs0*T4_Ve_si_Tempt_GND))+0.0);
#endif
T4a_Ve_di=T4_Ve_di*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Ve_di_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_di))+0.0);
  T4a_Ve_di_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_e))+0.0);
  T4a_Ve_di_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Vdi_si))+0.0);
  T4a_Ve_di_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Ve_si))+0.0);
  T4a_Ve_di_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Ve_di+d10_fabs0*T4_Ve_di_Ve_di))+0.0);
  T4a_Ve_di_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Ve_di+d10_fabs0*T4_Ve_di_Vge_si))+0.0);
  T4a_Ve_di_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Ve_di+d10_fabs0*T4_Ve_di_Tempt_GND))+0.0);
#endif
T4a_Vge_si=T4_Vge_si*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Vge_si_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_di))+0.0);
  T4a_Vge_si_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_e))+0.0);
  T4a_Vge_si_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Vdi_si))+0.0);
  T4a_Vge_si_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Ve_si))+0.0);
  T4a_Vge_si_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Vge_si+d10_fabs0*T4_Vge_si_Ve_di))+0.0);
  T4a_Vge_si_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Vge_si+d10_fabs0*T4_Vge_si_Vge_si))+0.0);
  T4a_Vge_si_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Vge_si+d10_fabs0*T4_Vge_si_Tempt_GND))+0.0);
#endif
T4a_Tempt_GND=T4_Tempt_GND*d10_fabs0;
#if defined(_DERIVATE2)
  T4a_Tempt_GND_Vge_di=(+(+0.0+(m20_fabs(T4)*T4_Vge_di*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_di))+0.0);
  T4a_Tempt_GND_Vge_e=(+(+0.0+(m20_fabs(T4)*T4_Vge_e*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_e))+0.0);
  T4a_Tempt_GND_Vdi_si=(+(+0.0+(m20_fabs(T4)*T4_Vdi_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vdi_si))+0.0);
  T4a_Tempt_GND_Ve_si=(+(+0.0+(m20_fabs(T4)*T4_Ve_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Ve_si))+0.0);
  T4a_Tempt_GND_Ve_di=(+(+0.0+(m20_fabs(T4)*T4_Ve_di*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Ve_di))+0.0);
  T4a_Tempt_GND_Vge_si=(+(+0.0+(m20_fabs(T4)*T4_Vge_si*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Vge_si))+0.0);
  T4a_Tempt_GND_Tempt_GND=(+(+0.0+(m20_fabs(T4)*T4_Tempt_GND*T4_Tempt_GND+d10_fabs0*T4_Tempt_GND_Tempt_GND))+0.0);
#endif
#endif
T4a=((CGISL_i+d00_fabs0)+1.0e-5);
EXIT_IF_ISNAN(((CGISL_i+d00_fabs0)+1.0e-5))
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_di*T4a-T4*T4a_Vge_di)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+0.0-0.0);
  T5_Vge_di_Vdi_d=(+0.0-0.0);
  T5_Vge_di_Vsi_s=(+0.0-0.0);
  T5_Vge_di_Vge_e=(+0.0-0.0);
  T5_Vge_di_Vdi_si=(+0.0-0.0);
  T5_Vge_di_Ve_si=(+0.0-0.0);
  T5_Vge_di_Ve_di=(+0.0-0.0);
  T5_Vge_di_Vge_si=(+0.0-0.0);
  T5_Vge_di_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_e*T4a-T4*T4a_Vge_e)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+0.0-0.0);
  T5_Vge_e_Vdi_d=(+0.0-0.0);
  T5_Vge_e_Vsi_s=(+0.0-0.0);
  T5_Vge_e_Vge_e=(+0.0-0.0);
  T5_Vge_e_Vdi_si=(+0.0-0.0);
  T5_Vge_e_Ve_si=(+0.0-0.0);
  T5_Vge_e_Ve_di=(+0.0-0.0);
  T5_Vge_e_Vge_si=(+0.0-0.0);
  T5_Vge_e_Tempt_GND=(+0.0-0.0);
#endif
T5_Vdi_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vdi_si*T4a-T4*T4a_Vdi_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+0.0-0.0);
  T5_Vdi_si_Vdi_d=(+0.0-0.0);
  T5_Vdi_si_Vsi_s=(+0.0-0.0);
  T5_Vdi_si_Vge_e=(+0.0-0.0);
  T5_Vdi_si_Vdi_si=(+0.0-0.0);
  T5_Vdi_si_Ve_si=(+0.0-0.0);
  T5_Vdi_si_Ve_di=(+0.0-0.0);
  T5_Vdi_si_Vge_si=(+0.0-0.0);
  T5_Vdi_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Ve_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Ve_si*T4a-T4*T4a_Ve_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+0.0-0.0);
  T5_Ve_si_Vdi_d=(+0.0-0.0);
  T5_Ve_si_Vsi_s=(+0.0-0.0);
  T5_Ve_si_Vge_e=(+0.0-0.0);
  T5_Ve_si_Vdi_si=(+0.0-0.0);
  T5_Ve_si_Ve_si=(+0.0-0.0);
  T5_Ve_si_Ve_di=(+0.0-0.0);
  T5_Ve_si_Vge_si=(+0.0-0.0);
  T5_Ve_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Ve_di=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Ve_di*T4a-T4*T4a_Ve_di)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+0.0-0.0);
  T5_Ve_di_Vdi_d=(+0.0-0.0);
  T5_Ve_di_Vsi_s=(+0.0-0.0);
  T5_Ve_di_Vge_e=(+0.0-0.0);
  T5_Ve_di_Vdi_si=(+0.0-0.0);
  T5_Ve_di_Ve_si=(+0.0-0.0);
  T5_Ve_di_Ve_di=(+0.0-0.0);
  T5_Ve_di_Vge_si=(+0.0-0.0);
  T5_Ve_di_Tempt_GND=(+0.0-0.0);
#endif
T5_Vge_si=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Vge_si*T4a-T4*T4a_Vge_si)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+0.0-0.0);
  T5_Vge_si_Vdi_d=(+0.0-0.0);
  T5_Vge_si_Vsi_s=(+0.0-0.0);
  T5_Vge_si_Vge_e=(+0.0-0.0);
  T5_Vge_si_Vdi_si=(+0.0-0.0);
  T5_Vge_si_Ve_si=(+0.0-0.0);
  T5_Vge_si_Ve_di=(+0.0-0.0);
  T5_Vge_si_Vge_si=(+0.0-0.0);
  T5_Vge_si_Tempt_GND=(+0.0-0.0);
#endif
T5_Tempt_GND=bsimcmg_d_hypsmooth((T4/T4a),1.0e-6,((T4_Tempt_GND*T4a-T4*T4a_Tempt_GND)/T4a/T4a),0.0);
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+0.0-0.0);
  T5_Tempt_GND_Vdi_d=(+0.0-0.0);
  T5_Tempt_GND_Vsi_s=(+0.0-0.0);
  T5_Tempt_GND_Vge_e=(+0.0-0.0);
  T5_Tempt_GND_Vdi_si=(+0.0-0.0);
  T5_Tempt_GND_Ve_si=(+0.0-0.0);
  T5_Tempt_GND_Ve_di=(+0.0-0.0);
  T5_Tempt_GND_Vge_si=(+0.0-0.0);
  T5_Tempt_GND_Tempt_GND=(+0.0-0.0);
#endif
#endif
T5=(bsimcmg_hypsmooth((T4/T4a),1.0e-6)-1.0e-6);
EXIT_IF_ISNAN((bsimcmg_hypsmooth((T4/T4a),1.0e-6)-1.0e-6))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=((((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di));
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_di);
  T6_Vge_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vdi_d);
  T6_Vge_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vsi_s);
  T6_Vge_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_e);
  T6_Vge_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vdi_si);
  T6_Vge_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Tempt_GND);
  T6_Vge_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Ve_si);
  T6_Vge_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Ve_di);
  T6_Vge_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*T5_Vge_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_di_Vge_si);
#endif
T6_Vdi_d=((((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d));
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_di);
  T6_Vdi_d_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vdi_d);
  T6_Vdi_d_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vsi_s);
  T6_Vdi_d_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_e);
  T6_Vdi_d_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vdi_si);
  T6_Vdi_d_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Tempt_GND);
  T6_Vdi_d_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Ve_si);
  T6_Vdi_d_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Ve_di);
  T6_Vdi_d_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_d+(AGISL_i*Weff0)*T3_Vdi_d_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_d)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_d)))))*T5_Vdi_d+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_d_Vge_si);
#endif
T6_Vsi_s=((((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s));
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_di);
  T6_Vsi_s_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vdi_d);
  T6_Vsi_s_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vsi_s);
  T6_Vsi_s_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_e);
  T6_Vsi_s_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vdi_si);
  T6_Vsi_s_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Tempt_GND);
  T6_Vsi_s_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Ve_si);
  T6_Vsi_s_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Ve_di);
  T6_Vsi_s_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vsi_s+(AGISL_i*Weff0)*T3_Vsi_s_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vsi_s)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vsi_s)))))*T5_Vsi_s+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vsi_s_Vge_si);
#endif
T6_Vge_e=((((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e));
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_di);
  T6_Vge_e_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vdi_d);
  T6_Vge_e_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vsi_s);
  T6_Vge_e_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_e);
  T6_Vge_e_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vdi_si);
  T6_Vge_e_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Tempt_GND);
  T6_Vge_e_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Ve_si);
  T6_Vge_e_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Ve_di);
  T6_Vge_e_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*T5_Vge_e+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_e_Vge_si);
#endif
T6_Vdi_si=((((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_di);
  T6_Vdi_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vdi_d);
  T6_Vdi_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vsi_s);
  T6_Vdi_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_e);
  T6_Vdi_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vdi_si);
  T6_Vdi_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Tempt_GND);
  T6_Vdi_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Ve_si);
  T6_Vdi_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Ve_di);
  T6_Vdi_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*T5_Vdi_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vdi_si_Vge_si);
#endif
T6_Tempt_GND=((((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_di);
  T6_Tempt_GND_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vdi_d);
  T6_Tempt_GND_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vsi_s);
  T6_Tempt_GND_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_e);
  T6_Tempt_GND_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vdi_si);
  T6_Tempt_GND_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Tempt_GND);
  T6_Tempt_GND_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Ve_si);
  T6_Tempt_GND_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Ve_di);
  T6_Tempt_GND_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*T5_Tempt_GND+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Tempt_GND_Vge_si);
#endif
T6_Ve_si=((((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si));
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_di);
  T6_Ve_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vdi_d);
  T6_Ve_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vsi_s);
  T6_Ve_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_e);
  T6_Ve_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vdi_si);
  T6_Ve_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Tempt_GND);
  T6_Ve_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Ve_si);
  T6_Ve_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Ve_di);
  T6_Ve_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*T5_Ve_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_si_Vge_si);
#endif
T6_Ve_di=((((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di));
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_di);
  T6_Ve_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vdi_d);
  T6_Ve_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vsi_s);
  T6_Ve_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_e);
  T6_Ve_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vdi_si);
  T6_Ve_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Tempt_GND);
  T6_Ve_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Ve_si);
  T6_Ve_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Ve_di);
  T6_Ve_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*T5_Ve_di+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Ve_di_Vge_si);
#endif
T6_Vge_si=((((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5)+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si));
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_di);
  T6_Vge_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vdi_d+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vdi_d);
  T6_Vge_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vsi_s+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vsi_s);
  T6_Vge_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_e+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_e);
  T6_Vge_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vdi_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vdi_si);
  T6_Vge_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Tempt_GND+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Tempt_GND);
  T6_Vge_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Ve_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Ve_si);
  T6_Vge_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Ve_di+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Ve_di);
  T6_Vge_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*T5+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*T5_Vge_si+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*T5_Vge_si+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5_Vge_si_Vge_si);
#endif
#endif
T6=((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5);
EXIT_IF_ISNAN(((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*T5))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_di+(AGISL_i*Weff0)*T3_Vge_di_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_e_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_e+(AGISL_i*Weff0)*T3_Vge_e_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_e))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_e)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_e)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vdi_si=((((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*(-vds_noswap))+((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*(-vds_noswap_Vdi_si)));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vdi_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vdi_si+(AGISL_i*Weff0)*T3_Vdi_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vdi_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vdi_si)))))*(-vds_noswap_Vdi_si)+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Tempt_GND=((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Tempt_GND_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Tempt_GND+(AGISL_i*Weff0)*T3_Tempt_GND_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Tempt_GND)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Tempt_GND)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Ve_si=((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_si+(AGISL_i*Weff0)*T3_Ve_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Ve_di=((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Ve_di_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Ve_di+(AGISL_i*Weff0)*T3_Ve_di_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Ve_di))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Ve_di)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Ve_di)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
T6_Vge_si=((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*(-vds_noswap);
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_di+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vdi_d=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_d+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vdi_d)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_d)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vsi_s=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vsi_s+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vsi_s)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vsi_s)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vge_e=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_e+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_e)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_e)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vdi_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vdi_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vdi_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*(-vds_noswap_Vdi_si)+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vdi_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Tempt_GND=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Tempt_GND+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Tempt_GND)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Tempt_GND)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Ve_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Ve_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Ve_di=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Ve_di+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Ve_di)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Ve_di)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
  T6_Vge_si_Vge_si=(+(+(+(+0.0*Weff0+0.0*0.0+0.0*0.0+AGISL_i*0.0)*T3+0.0*T3_Vge_si+(0.0)*T3_Vge_si+(AGISL_i*Weff0)*T3_Vge_si_Vge_si)*bsimcmg_lexp((-T2))+((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_d_lexp((-T2),(-T2_Vge_si))+((AGISL_i*Weff0)*T3)*0.0)*(-vds_noswap)+((((AGISL_i*Weff0)*T3_Vge_si)*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si))))*0.0+(((((((0.0)*T3)+((AGISL_i*Weff0)*T3_Vge_si)))*bsimcmg_lexp((-T2)))+(((AGISL_i*Weff0)*T3)*bsimcmg_d_lexp((-T2),(-T2_Vge_si)))))*0.0+(((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*0.0);
#endif
#endif
T6=((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*(-vds_noswap));
EXIT_IF_ISNAN(((((AGISL_i*Weff0)*T3)*bsimcmg_lexp((-T2)))*(-vds_noswap)))
}
}
if
((sigvds>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igisl_Vge_di=T6_Vge_di;
#if defined(_DERIVATE2)
  igisl_Vge_di_Vge_di=T6_Vge_di_Vge_di;
  igisl_Vge_di_Vdi_d=T6_Vge_di_Vdi_d;
  igisl_Vge_di_Vsi_s=T6_Vge_di_Vsi_s;
  igisl_Vge_di_Vge_e=T6_Vge_di_Vge_e;
  igisl_Vge_di_Vdi_si=T6_Vge_di_Vdi_si;
  igisl_Vge_di_Tempt_GND=T6_Vge_di_Tempt_GND;
  igisl_Vge_di_Ve_si=T6_Vge_di_Ve_si;
  igisl_Vge_di_Ve_di=T6_Vge_di_Ve_di;
  igisl_Vge_di_Vge_si=T6_Vge_di_Vge_si;
#endif
igisl_Vdi_d=T6_Vdi_d;
#if defined(_DERIVATE2)
  igisl_Vdi_d_Vge_di=T6_Vdi_d_Vge_di;
  igisl_Vdi_d_Vdi_d=T6_Vdi_d_Vdi_d;
  igisl_Vdi_d_Vsi_s=T6_Vdi_d_Vsi_s;
  igisl_Vdi_d_Vge_e=T6_Vdi_d_Vge_e;
  igisl_Vdi_d_Vdi_si=T6_Vdi_d_Vdi_si;
  igisl_Vdi_d_Tempt_GND=T6_Vdi_d_Tempt_GND;
  igisl_Vdi_d_Ve_si=T6_Vdi_d_Ve_si;
  igisl_Vdi_d_Ve_di=T6_Vdi_d_Ve_di;
  igisl_Vdi_d_Vge_si=T6_Vdi_d_Vge_si;
#endif
igisl_Vsi_s=T6_Vsi_s;
#if defined(_DERIVATE2)
  igisl_Vsi_s_Vge_di=T6_Vsi_s_Vge_di;
  igisl_Vsi_s_Vdi_d=T6_Vsi_s_Vdi_d;
  igisl_Vsi_s_Vsi_s=T6_Vsi_s_Vsi_s;
  igisl_Vsi_s_Vge_e=T6_Vsi_s_Vge_e;
  igisl_Vsi_s_Vdi_si=T6_Vsi_s_Vdi_si;
  igisl_Vsi_s_Tempt_GND=T6_Vsi_s_Tempt_GND;
  igisl_Vsi_s_Ve_si=T6_Vsi_s_Ve_si;
  igisl_Vsi_s_Ve_di=T6_Vsi_s_Ve_di;
  igisl_Vsi_s_Vge_si=T6_Vsi_s_Vge_si;
#endif
igisl_Vge_e=T6_Vge_e;
#if defined(_DERIVATE2)
  igisl_Vge_e_Vge_di=T6_Vge_e_Vge_di;
  igisl_Vge_e_Vdi_d=T6_Vge_e_Vdi_d;
  igisl_Vge_e_Vsi_s=T6_Vge_e_Vsi_s;
  igisl_Vge_e_Vge_e=T6_Vge_e_Vge_e;
  igisl_Vge_e_Vdi_si=T6_Vge_e_Vdi_si;
  igisl_Vge_e_Tempt_GND=T6_Vge_e_Tempt_GND;
  igisl_Vge_e_Ve_si=T6_Vge_e_Ve_si;
  igisl_Vge_e_Ve_di=T6_Vge_e_Ve_di;
  igisl_Vge_e_Vge_si=T6_Vge_e_Vge_si;
#endif
igisl_Vdi_si=T6_Vdi_si;
#if defined(_DERIVATE2)
  igisl_Vdi_si_Vge_di=T6_Vdi_si_Vge_di;
  igisl_Vdi_si_Vdi_d=T6_Vdi_si_Vdi_d;
  igisl_Vdi_si_Vsi_s=T6_Vdi_si_Vsi_s;
  igisl_Vdi_si_Vge_e=T6_Vdi_si_Vge_e;
  igisl_Vdi_si_Vdi_si=T6_Vdi_si_Vdi_si;
  igisl_Vdi_si_Tempt_GND=T6_Vdi_si_Tempt_GND;
  igisl_Vdi_si_Ve_si=T6_Vdi_si_Ve_si;
  igisl_Vdi_si_Ve_di=T6_Vdi_si_Ve_di;
  igisl_Vdi_si_Vge_si=T6_Vdi_si_Vge_si;
#endif
igisl_Tempt_GND=T6_Tempt_GND;
#if defined(_DERIVATE2)
  igisl_Tempt_GND_Vge_di=T6_Tempt_GND_Vge_di;
  igisl_Tempt_GND_Vdi_d=T6_Tempt_GND_Vdi_d;
  igisl_Tempt_GND_Vsi_s=T6_Tempt_GND_Vsi_s;
  igisl_Tempt_GND_Vge_e=T6_Tempt_GND_Vge_e;
  igisl_Tempt_GND_Vdi_si=T6_Tempt_GND_Vdi_si;
  igisl_Tempt_GND_Tempt_GND=T6_Tempt_GND_Tempt_GND;
  igisl_Tempt_GND_Ve_si=T6_Tempt_GND_Ve_si;
  igisl_Tempt_GND_Ve_di=T6_Tempt_GND_Ve_di;
  igisl_Tempt_GND_Vge_si=T6_Tempt_GND_Vge_si;
#endif
igisl_Ve_si=T6_Ve_si;
#if defined(_DERIVATE2)
  igisl_Ve_si_Vge_di=T6_Ve_si_Vge_di;
  igisl_Ve_si_Vdi_d=T6_Ve_si_Vdi_d;
  igisl_Ve_si_Vsi_s=T6_Ve_si_Vsi_s;
  igisl_Ve_si_Vge_e=T6_Ve_si_Vge_e;
  igisl_Ve_si_Vdi_si=T6_Ve_si_Vdi_si;
  igisl_Ve_si_Tempt_GND=T6_Ve_si_Tempt_GND;
  igisl_Ve_si_Ve_si=T6_Ve_si_Ve_si;
  igisl_Ve_si_Ve_di=T6_Ve_si_Ve_di;
  igisl_Ve_si_Vge_si=T6_Ve_si_Vge_si;
#endif
igisl_Ve_di=T6_Ve_di;
#if defined(_DERIVATE2)
  igisl_Ve_di_Vge_di=T6_Ve_di_Vge_di;
  igisl_Ve_di_Vdi_d=T6_Ve_di_Vdi_d;
  igisl_Ve_di_Vsi_s=T6_Ve_di_Vsi_s;
  igisl_Ve_di_Vge_e=T6_Ve_di_Vge_e;
  igisl_Ve_di_Vdi_si=T6_Ve_di_Vdi_si;
  igisl_Ve_di_Tempt_GND=T6_Ve_di_Tempt_GND;
  igisl_Ve_di_Ve_si=T6_Ve_di_Ve_si;
  igisl_Ve_di_Ve_di=T6_Ve_di_Ve_di;
  igisl_Ve_di_Vge_si=T6_Ve_di_Vge_si;
#endif
igisl_Vge_si=T6_Vge_si;
#if defined(_DERIVATE2)
  igisl_Vge_si_Vge_di=T6_Vge_si_Vge_di;
  igisl_Vge_si_Vdi_d=T6_Vge_si_Vdi_d;
  igisl_Vge_si_Vsi_s=T6_Vge_si_Vsi_s;
  igisl_Vge_si_Vge_e=T6_Vge_si_Vge_e;
  igisl_Vge_si_Vdi_si=T6_Vge_si_Vdi_si;
  igisl_Vge_si_Tempt_GND=T6_Vge_si_Tempt_GND;
  igisl_Vge_si_Ve_si=T6_Vge_si_Ve_si;
  igisl_Vge_si_Ve_di=T6_Vge_si_Ve_di;
  igisl_Vge_si_Vge_si=T6_Vge_si_Vge_si;
#endif
#endif
igisl=T6;
EXIT_IF_ISNAN(T6)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igidl_Vge_di=T6_Vge_di;
#if defined(_DERIVATE2)
  igidl_Vge_di_Vge_di=T6_Vge_di_Vge_di;
  igidl_Vge_di_Vdi_d=T6_Vge_di_Vdi_d;
  igidl_Vge_di_Vsi_s=T6_Vge_di_Vsi_s;
  igidl_Vge_di_Vge_e=T6_Vge_di_Vge_e;
  igidl_Vge_di_Vdi_si=T6_Vge_di_Vdi_si;
  igidl_Vge_di_Tempt_GND=T6_Vge_di_Tempt_GND;
  igidl_Vge_di_Ve_si=T6_Vge_di_Ve_si;
  igidl_Vge_di_Ve_di=T6_Vge_di_Ve_di;
  igidl_Vge_di_Vge_si=T6_Vge_di_Vge_si;
#endif
igidl_Vdi_d=T6_Vdi_d;
#if defined(_DERIVATE2)
  igidl_Vdi_d_Vge_di=T6_Vdi_d_Vge_di;
  igidl_Vdi_d_Vdi_d=T6_Vdi_d_Vdi_d;
  igidl_Vdi_d_Vsi_s=T6_Vdi_d_Vsi_s;
  igidl_Vdi_d_Vge_e=T6_Vdi_d_Vge_e;
  igidl_Vdi_d_Vdi_si=T6_Vdi_d_Vdi_si;
  igidl_Vdi_d_Tempt_GND=T6_Vdi_d_Tempt_GND;
  igidl_Vdi_d_Ve_si=T6_Vdi_d_Ve_si;
  igidl_Vdi_d_Ve_di=T6_Vdi_d_Ve_di;
  igidl_Vdi_d_Vge_si=T6_Vdi_d_Vge_si;
#endif
igidl_Vsi_s=T6_Vsi_s;
#if defined(_DERIVATE2)
  igidl_Vsi_s_Vge_di=T6_Vsi_s_Vge_di;
  igidl_Vsi_s_Vdi_d=T6_Vsi_s_Vdi_d;
  igidl_Vsi_s_Vsi_s=T6_Vsi_s_Vsi_s;
  igidl_Vsi_s_Vge_e=T6_Vsi_s_Vge_e;
  igidl_Vsi_s_Vdi_si=T6_Vsi_s_Vdi_si;
  igidl_Vsi_s_Tempt_GND=T6_Vsi_s_Tempt_GND;
  igidl_Vsi_s_Ve_si=T6_Vsi_s_Ve_si;
  igidl_Vsi_s_Ve_di=T6_Vsi_s_Ve_di;
  igidl_Vsi_s_Vge_si=T6_Vsi_s_Vge_si;
#endif
igidl_Vge_e=T6_Vge_e;
#if defined(_DERIVATE2)
  igidl_Vge_e_Vge_di=T6_Vge_e_Vge_di;
  igidl_Vge_e_Vdi_d=T6_Vge_e_Vdi_d;
  igidl_Vge_e_Vsi_s=T6_Vge_e_Vsi_s;
  igidl_Vge_e_Vge_e=T6_Vge_e_Vge_e;
  igidl_Vge_e_Vdi_si=T6_Vge_e_Vdi_si;
  igidl_Vge_e_Tempt_GND=T6_Vge_e_Tempt_GND;
  igidl_Vge_e_Ve_si=T6_Vge_e_Ve_si;
  igidl_Vge_e_Ve_di=T6_Vge_e_Ve_di;
  igidl_Vge_e_Vge_si=T6_Vge_e_Vge_si;
#endif
igidl_Vdi_si=T6_Vdi_si;
#if defined(_DERIVATE2)
  igidl_Vdi_si_Vge_di=T6_Vdi_si_Vge_di;
  igidl_Vdi_si_Vdi_d=T6_Vdi_si_Vdi_d;
  igidl_Vdi_si_Vsi_s=T6_Vdi_si_Vsi_s;
  igidl_Vdi_si_Vge_e=T6_Vdi_si_Vge_e;
  igidl_Vdi_si_Vdi_si=T6_Vdi_si_Vdi_si;
  igidl_Vdi_si_Tempt_GND=T6_Vdi_si_Tempt_GND;
  igidl_Vdi_si_Ve_si=T6_Vdi_si_Ve_si;
  igidl_Vdi_si_Ve_di=T6_Vdi_si_Ve_di;
  igidl_Vdi_si_Vge_si=T6_Vdi_si_Vge_si;
#endif
igidl_Tempt_GND=T6_Tempt_GND;
#if defined(_DERIVATE2)
  igidl_Tempt_GND_Vge_di=T6_Tempt_GND_Vge_di;
  igidl_Tempt_GND_Vdi_d=T6_Tempt_GND_Vdi_d;
  igidl_Tempt_GND_Vsi_s=T6_Tempt_GND_Vsi_s;
  igidl_Tempt_GND_Vge_e=T6_Tempt_GND_Vge_e;
  igidl_Tempt_GND_Vdi_si=T6_Tempt_GND_Vdi_si;
  igidl_Tempt_GND_Tempt_GND=T6_Tempt_GND_Tempt_GND;
  igidl_Tempt_GND_Ve_si=T6_Tempt_GND_Ve_si;
  igidl_Tempt_GND_Ve_di=T6_Tempt_GND_Ve_di;
  igidl_Tempt_GND_Vge_si=T6_Tempt_GND_Vge_si;
#endif
igidl_Ve_si=T6_Ve_si;
#if defined(_DERIVATE2)
  igidl_Ve_si_Vge_di=T6_Ve_si_Vge_di;
  igidl_Ve_si_Vdi_d=T6_Ve_si_Vdi_d;
  igidl_Ve_si_Vsi_s=T6_Ve_si_Vsi_s;
  igidl_Ve_si_Vge_e=T6_Ve_si_Vge_e;
  igidl_Ve_si_Vdi_si=T6_Ve_si_Vdi_si;
  igidl_Ve_si_Tempt_GND=T6_Ve_si_Tempt_GND;
  igidl_Ve_si_Ve_si=T6_Ve_si_Ve_si;
  igidl_Ve_si_Ve_di=T6_Ve_si_Ve_di;
  igidl_Ve_si_Vge_si=T6_Ve_si_Vge_si;
#endif
igidl_Ve_di=T6_Ve_di;
#if defined(_DERIVATE2)
  igidl_Ve_di_Vge_di=T6_Ve_di_Vge_di;
  igidl_Ve_di_Vdi_d=T6_Ve_di_Vdi_d;
  igidl_Ve_di_Vsi_s=T6_Ve_di_Vsi_s;
  igidl_Ve_di_Vge_e=T6_Ve_di_Vge_e;
  igidl_Ve_di_Vdi_si=T6_Ve_di_Vdi_si;
  igidl_Ve_di_Tempt_GND=T6_Ve_di_Tempt_GND;
  igidl_Ve_di_Ve_si=T6_Ve_di_Ve_si;
  igidl_Ve_di_Ve_di=T6_Ve_di_Ve_di;
  igidl_Ve_di_Vge_si=T6_Ve_di_Vge_si;
#endif
igidl_Vge_si=T6_Vge_si;
#if defined(_DERIVATE2)
  igidl_Vge_si_Vge_di=T6_Vge_si_Vge_di;
  igidl_Vge_si_Vdi_d=T6_Vge_si_Vdi_d;
  igidl_Vge_si_Vsi_s=T6_Vge_si_Vsi_s;
  igidl_Vge_si_Vge_e=T6_Vge_si_Vge_e;
  igidl_Vge_si_Vdi_si=T6_Vge_si_Vdi_si;
  igidl_Vge_si_Tempt_GND=T6_Vge_si_Tempt_GND;
  igidl_Vge_si_Ve_si=T6_Vge_si_Ve_si;
  igidl_Vge_si_Ve_di=T6_Vge_si_Ve_di;
  igidl_Vge_si_Vge_si=T6_Vge_si_Vge_si;
#endif
#endif
igidl=T6;
EXIT_IF_ISNAN(T6)
}
}
if
((pModel->BULKMOD!=0))
{
if
((Isbs>0.0))
{
if
((ves_jct<VjsmRev))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(ves_jct_Ve_si/Nvtms);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vge_e=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Ve_si=(ves_jct_Ve_si_Ve_si/Nvtms-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Ve_di=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vge_si=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vdi_si=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Tempt_GND=(0.0/Nvtms-(ves_jct_Ve_si*Nvtms_Tempt_GND+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-ves_jct*Nvtms_Tempt_GND/Nvtms/Nvtms);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_e=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_si=(0.0/Nvtms-(0.0*0.0+ves_jct_Ve_si*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_di=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_si=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Tempt_GND=(0.0/Nvtms-(0.0*Nvtms_Tempt_GND+0.0*Nvtms_Tempt_GND+ves_jct*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
#endif
T0=(ves_jct/Nvtms);
EXIT_IF_ISNAN((ves_jct/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(T0,T0_Vge_di);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0-0.0);
  T1_Vge_di_Vsi_s=(+0.0-0.0);
  T1_Vge_di_Vge_di=(+T0_Vge_di_Vge_di-0.0);
  T1_Vge_di_Vge_e=(+T0_Vge_di_Vge_e-0.0);
  T1_Vge_di_Ve_si=(+T0_Vge_di_Ve_si-0.0);
  T1_Vge_di_Ve_di=(+T0_Vge_di_Ve_di-0.0);
  T1_Vge_di_Vge_si=(+T0_Vge_di_Vge_si-0.0);
  T1_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si-0.0);
  T1_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(T0,T0_Vge_e);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0-0.0);
  T1_Vge_e_Vsi_s=(+0.0-0.0);
  T1_Vge_e_Vge_di=(+T0_Vge_e_Vge_di-0.0);
  T1_Vge_e_Vge_e=(+T0_Vge_e_Vge_e-0.0);
  T1_Vge_e_Ve_si=(+T0_Vge_e_Ve_si-0.0);
  T1_Vge_e_Ve_di=(+T0_Vge_e_Ve_di-0.0);
  T1_Vge_e_Vge_si=(+T0_Vge_e_Vge_si-0.0);
  T1_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si-0.0);
  T1_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(T0,T0_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0-0.0);
  T1_Ve_si_Vsi_s=(+0.0-0.0);
  T1_Ve_si_Vge_di=(+T0_Ve_si_Vge_di-0.0);
  T1_Ve_si_Vge_e=(+T0_Ve_si_Vge_e-0.0);
  T1_Ve_si_Ve_si=(+T0_Ve_si_Ve_si-0.0);
  T1_Ve_si_Ve_di=(+T0_Ve_si_Ve_di-0.0);
  T1_Ve_si_Vge_si=(+T0_Ve_si_Vge_si-0.0);
  T1_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si-0.0);
  T1_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(T0,T0_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0-0.0);
  T1_Ve_di_Vsi_s=(+0.0-0.0);
  T1_Ve_di_Vge_di=(+T0_Ve_di_Vge_di-0.0);
  T1_Ve_di_Vge_e=(+T0_Ve_di_Vge_e-0.0);
  T1_Ve_di_Ve_si=(+T0_Ve_di_Ve_si-0.0);
  T1_Ve_di_Ve_di=(+T0_Ve_di_Ve_di-0.0);
  T1_Ve_di_Vge_si=(+T0_Ve_di_Vge_si-0.0);
  T1_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si-0.0);
  T1_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(T0,T0_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0-0.0);
  T1_Vge_si_Vsi_s=(+0.0-0.0);
  T1_Vge_si_Vge_di=(+T0_Vge_si_Vge_di-0.0);
  T1_Vge_si_Vge_e=(+T0_Vge_si_Vge_e-0.0);
  T1_Vge_si_Ve_si=(+T0_Vge_si_Ve_si-0.0);
  T1_Vge_si_Ve_di=(+T0_Vge_si_Ve_di-0.0);
  T1_Vge_si_Vge_si=(+T0_Vge_si_Vge_si-0.0);
  T1_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si-0.0);
  T1_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(T0,T0_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0-0.0);
  T1_Vdi_si_Vsi_s=(+0.0-0.0);
  T1_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di-0.0);
  T1_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e-0.0);
  T1_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si-0.0);
  T1_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di-0.0);
  T1_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si-0.0);
  T1_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si-0.0);
  T1_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(T0,T0_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0-0.0);
  T1_Tempt_GND_Vsi_s=(+0.0-0.0);
  T1_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di-0.0);
  T1_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e-0.0);
  T1_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si-0.0);
  T1_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di-0.0);
  T1_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si-0.0);
  T1_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si-0.0);
  T1_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND-0.0);
#endif
#endif
T1=(bsimcmg_lexp(T0)-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(T0)-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=(SslpRev*ves_jct_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Vsi_s=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Vge_di=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Vge_e=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Vge_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Ve_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*ves_jct_Ve_si+0.0*ves_jct_Ve_si+SslpRev*(+ves_jct_Ve_si_Ve_si-0.0)));
  T2_Ve_si_Ve_di=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Vdi_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*0.0+0.0*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
  T2_Ve_si_Tempt_GND=(+0.0+(+0.0*(ves_jct-VjsmRev)+0.0*(-VjsmRev_Tempt_GND)+SslpRev_Tempt_GND*ves_jct_Ve_si+SslpRev*(+0.0-0.0)));
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(IVjsmRev_Tempt_GND+((SslpRev_Tempt_GND*(ves_jct-VjsmRev))+(SslpRev*(-VjsmRev_Tempt_GND))));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vsi_s=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_di=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_e=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Ve_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*ves_jct_Ve_si+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Ve_di=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vdi_si=(+0.0+(+0.0*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*0.0+0.0*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Tempt_GND=(+IVjsmRev_Tempt_GND_Tempt_GND+(+SslpRev_Tempt_GND_Tempt_GND*(ves_jct-VjsmRev)+SslpRev_Tempt_GND*(-VjsmRev_Tempt_GND)+SslpRev_Tempt_GND*(-VjsmRev_Tempt_GND)+SslpRev*(+0.0-VjsmRev_Tempt_GND_Tempt_GND)));
#endif
#endif
T2=(IVjsmRev+(SslpRev*(ves_jct-VjsmRev)));
EXIT_IF_ISNAN((IVjsmRev+(SslpRev*(ves_jct-VjsmRev))))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=((T1_Vge_di*T2)+(T1*T2_Vge_di));
Ies_Vge_e=((T1_Vge_e*T2)+(T1*T2_Vge_e));
Ies_Ve_si=((T1_Ve_si*T2)+(T1*T2_Ve_si));
Ies_Ve_di=((T1_Ve_di*T2)+(T1*T2_Ve_di));
Ies_Vge_si=((T1_Vge_si*T2)+(T1*T2_Vge_si));
Ies_Vdi_si=((T1_Vdi_si*T2)+(T1*T2_Vdi_si));
Ies_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#endif
Ies=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
}
else
{
if
((ves_jct<=VjsmFwd))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(ves_jct_Ve_si/Nvtms);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vge_e=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Ve_si=(ves_jct_Ve_si_Ve_si/Nvtms-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Ve_di=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vge_si=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Vdi_si=(0.0/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T0_Ve_si_Tempt_GND=(0.0/Nvtms-(ves_jct_Ve_si*Nvtms_Tempt_GND+0.0*0.0+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-ves_jct*Nvtms_Tempt_GND/Nvtms/Nvtms);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_e=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_si=(0.0/Nvtms-(0.0*0.0+ves_jct_Ve_si*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Ve_di=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vge_si=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+ves_jct*0.0)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T0_Tempt_GND_Tempt_GND=(0.0/Nvtms-(0.0*Nvtms_Tempt_GND+0.0*Nvtms_Tempt_GND+ves_jct*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*ves_jct*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
#endif
T0=(ves_jct/Nvtms);
EXIT_IF_ISNAN((ves_jct/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(ves_jct_Ve_si/Nvtms);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Vsi_s=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Vge_di=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Vge_e=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Ve_si=((+0.0+ves_jct_Ve_si_Ve_si)/Nvtms-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Ve_di=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Vge_si=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Vdi_si=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*0.0+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*0.0/Nvtms/Nvtms/Nvtms);
  T1_Ve_si_Tempt_GND=((+0.0+0.0)/Nvtms-(ves_jct_Ve_si*Nvtms_Tempt_GND+0.0*0.0+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*0.0*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-(pModel->BVS+ves_jct)*Nvtms_Tempt_GND/Nvtms/Nvtms);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Vsi_s=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Vge_di=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Vge_e=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Ve_si=((+0.0+0.0)/Nvtms-(0.0*0.0+ves_jct_Ve_si*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Ve_di=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Vge_si=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Vdi_si=((+0.0+0.0)/Nvtms-(0.0*0.0+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*0.0)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*0.0/Nvtms/Nvtms/Nvtms);
  T1_Tempt_GND_Tempt_GND=((+0.0+0.0)/Nvtms-(0.0*Nvtms_Tempt_GND+0.0*Nvtms_Tempt_GND+(pModel->BVS+ves_jct)*Nvtms_Tempt_GND_Tempt_GND)/Nvtms/Nvtms+2*(pModel->BVS+ves_jct)*Nvtms_Tempt_GND*Nvtms_Tempt_GND/Nvtms/Nvtms/Nvtms);
#endif
#endif
T1=((pModel->BVS+ves_jct)/Nvtms);
EXIT_IF_ISNAN(((pModel->BVS+ves_jct)/Nvtms))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=bsimcmg_d_lexp((-T1),(-T1_Vge_di));
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=bsimcmg_d_lexp((-T1),(-T1_Vge_e));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=bsimcmg_d_lexp((-T1),(-T1_Vge_si));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=bsimcmg_d_lexp((-T1),(-T1_Ve_si));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=bsimcmg_d_lexp((-T1),(-T1_Ve_di));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=bsimcmg_d_lexp((-T1),(-T1_Vdi_si));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=bsimcmg_d_lexp((-T1),(-T1_Tempt_GND));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp((-T1));
EXIT_IF_ISNAN(bsimcmg_lexp((-T1)))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Isbs*(bsimcmg_d_lexp(T0,T0_Vge_di)-(pModel->XJBVS*T2_Vge_di)));
Ies_Vge_e=(Isbs*(bsimcmg_d_lexp(T0,T0_Vge_e)-(pModel->XJBVS*T2_Vge_e)));
Ies_Ve_si=(Isbs*(bsimcmg_d_lexp(T0,T0_Ve_si)-(pModel->XJBVS*T2_Ve_si)));
Ies_Ve_di=(Isbs*(bsimcmg_d_lexp(T0,T0_Ve_di)-(pModel->XJBVS*T2_Ve_di)));
Ies_Vge_si=(Isbs*(bsimcmg_d_lexp(T0,T0_Vge_si)-(pModel->XJBVS*T2_Vge_si)));
Ies_Vdi_si=(Isbs*(bsimcmg_d_lexp(T0,T0_Vdi_si)-(pModel->XJBVS*T2_Vdi_si)));
Ies_Tempt_GND=((Isbs_Tempt_GND*(((bsimcmg_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2)))+(Isbs*((bsimcmg_d_lexp(T0,T0_Tempt_GND)+XExpBVS_Tempt_GND)-(pModel->XJBVS*T2_Tempt_GND))));
#endif
Ies=(Isbs*(((bsimcmg_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2)));
EXIT_IF_ISNAN((Isbs*(((bsimcmg_lexp(T0)+XExpBVS)-1.0)-(pModel->XJBVS*T2))))
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=0.0;
Ies_Vge_e=0.0;
Ies_Ve_si=(SslpFwd*ves_jct_Ve_si);
Ies_Ve_di=0.0;
Ies_Vge_si=0.0;
Ies_Vdi_si=0.0;
Ies_Tempt_GND=(IVjsmFwd_Tempt_GND+((SslpFwd_Tempt_GND*(ves_jct-VjsmFwd))+(SslpFwd*(-VjsmFwd_Tempt_GND))));
#endif
Ies=(IVjsmFwd+(SslpFwd*(ves_jct-VjsmFwd)));
EXIT_IF_ISNAN((IVjsmFwd+(SslpFwd*(ves_jct-VjsmFwd))))
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=0.0;
Ies_Vge_e=0.0;
Ies_Ve_si=0.0;
Ies_Ve_di=0.0;
Ies_Vge_si=0.0;
Ies_Vdi_si=0.0;
Ies_Tempt_GND=0.0;
#endif
Ies=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((JTSS_t>0.0))
{
if
(((pModel->VTSS-ves_jct)<(pModel->VTSS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTS_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*NJTS_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND/NJTS_t/NJTS_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*NJTS_t_Tempt_GND+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND_Tempt_GND)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTS_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTS_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-((pInst->ASEJ*JTSS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-((pInst->ASEJ*JTSS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-((pInst->ASEJ*JTSS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-((pInst->ASEJ*JTSS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-((pInst->ASEJ*JTSS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-((pInst->ASEJ*JTSS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-(((pInst->ASEJ*JTSS_t_Tempt_GND)*T1)+((pInst->ASEJ*JTSS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-((pInst->ASEJ*JTSS_t)*T1));
EXIT_IF_ISNAN((Ies-((pInst->ASEJ*JTSS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTS_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(((-ves_jct_Ve_si)/Vtm0)*NJTS_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*0.0*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND/NJTS_t/NJTS_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*0.0+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*0.0/NJTS_t/NJTS_t/NJTS_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTS_t-(0.0*NJTS_t_Tempt_GND+0.0*NJTS_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND_Tempt_GND)/NJTS_t/NJTS_t+2*((-ves_jct)/Vtm0)*NJTS_t_Tempt_GND*NJTS_t_Tempt_GND/NJTS_t/NJTS_t/NJTS_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTS_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTS_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Vge_di*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSS+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSS+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSS+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSS+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSS+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSS+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSS+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_di*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Vge_e*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSS+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSS+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSS+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSS+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSS+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSS+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSS+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_e*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),((T0_Ve_si*pModel->VTSS*(pModel->VTSS-ves_jct)-(T0*pModel->VTSS)*(-ves_jct_Ve_si))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSS+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSS+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSS+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-ves_jct_Ve_si_Ve_si))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSS+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSS+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSS+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSS+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_si*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*(-ves_jct_Ve_si)+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Ve_di*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSS+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSS+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSS+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSS+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSS+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSS+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSS+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Ve_di*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Vge_si*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSS+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSS+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSS+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSS+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSS+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSS+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSS+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vge_si*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Vdi_si*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSS+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSS+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSS+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSS+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSS+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSS+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSS+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Vdi_si*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)),(T0_Tempt_GND*pModel->VTSS/(pModel->VTSS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(0.0)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSS+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Vge_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSS+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Vge_e*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSS+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSS+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Ve_di*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSS+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Vge_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSS+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Vdi_si*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSS+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSS-ves_jct)-(T0_Tempt_GND*pModel->VTSS*0.0+(T0_Tempt_GND*pModel->VTSS)*0.0+(T0*pModel->VTSS)*(+0.0-0.0))/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)+2*(T0*pModel->VTSS)*0.0*0.0/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct)/(pModel->VTSS-ves_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSS)/(pModel->VTSS-ves_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-((pInst->ASEJ*JTSS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-((pInst->ASEJ*JTSS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-((pInst->ASEJ*JTSS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-((pInst->ASEJ*JTSS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-((pInst->ASEJ*JTSS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-((pInst->ASEJ*JTSS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-(((pInst->ASEJ*JTSS_t_Tempt_GND)*T1)+((pInst->ASEJ*JTSS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-((pInst->ASEJ*JTSS_t)*T1));
EXIT_IF_ISNAN((Ies-((pInst->ASEJ*JTSS_t)*T1)))
}
}
if
((JTSSWS_t>0.0))
{
if
(((pModel->VTSSWS-ves_jct)<(pModel->VTSSWS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*NJTSSW_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*NJTSSW_t_Tempt_GND+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND_Tempt_GND)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTSSW_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTSSW_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-((pInst->PSEJ*JTSSWS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-((pInst->PSEJ*JTSSWS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-((pInst->PSEJ*JTSSWS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-((pInst->PSEJ*JTSSWS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-((pInst->PSEJ*JTSSWS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-((pInst->PSEJ*JTSSWS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-(((pInst->PSEJ*JTSSWS_t_Tempt_GND)*T1)+((pInst->PSEJ*JTSSWS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-((pInst->PSEJ*JTSSWS_t)*T1));
EXIT_IF_ISNAN((Ies-((pInst->PSEJ*JTSSWS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(((-ves_jct_Ve_si)/Vtm0)*NJTSSW_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*0.0*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*0.0+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*0.0/NJTSSW_t/NJTSSW_t/NJTSSW_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSW_t-(0.0*NJTSSW_t_Tempt_GND+0.0*NJTSSW_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND_Tempt_GND)/NJTSSW_t/NJTSSW_t+2*((-ves_jct)/Vtm0)*NJTSSW_t_Tempt_GND*NJTSSW_t_Tempt_GND/NJTSSW_t/NJTSSW_t/NJTSSW_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTSSW_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTSSW_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Vge_di*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSSWS+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSSWS+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSSWS+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSSWS+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSSWS+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSSWS+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSSWS+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_di*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Vge_e*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSSWS+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSSWS+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSSWS+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSSWS+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSSWS+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSSWS+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSSWS+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_e*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),((T0_Ve_si*pModel->VTSSWS*(pModel->VTSSWS-ves_jct)-(T0*pModel->VTSSWS)*(-ves_jct_Ve_si))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSSWS+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSSWS+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSSWS+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-ves_jct_Ve_si_Ve_si))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSSWS+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSSWS+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSSWS+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSSWS+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_si*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Ve_di*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSSWS+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSSWS+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSSWS+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSSWS+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSSWS+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSSWS+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSSWS+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Ve_di*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Vge_si*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSSWS+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSSWS+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSSWS+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSSWS+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSSWS+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSSWS+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSSWS+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vge_si*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Vdi_si*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSSWS+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Vdi_si*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)),(T0_Tempt_GND*pModel->VTSSWS/(pModel->VTSSWS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSSWS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSSWS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(0.0)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Vge_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Vge_e*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Ve_di*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Vge_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Vdi_si*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSSWS+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWS*0.0+(T0_Tempt_GND*pModel->VTSSWS)*0.0+(T0*pModel->VTSSWS)*(+0.0-0.0))/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)+2*(T0*pModel->VTSSWS)*0.0*0.0/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct)/(pModel->VTSSWS-ves_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSSWS)/(pModel->VTSSWS-ves_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-((pInst->PSEJ*JTSSWS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-((pInst->PSEJ*JTSSWS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-((pInst->PSEJ*JTSSWS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-((pInst->PSEJ*JTSSWS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-((pInst->PSEJ*JTSSWS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-((pInst->PSEJ*JTSSWS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-(((pInst->PSEJ*JTSSWS_t_Tempt_GND)*T1)+((pInst->PSEJ*JTSSWS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-((pInst->PSEJ*JTSSWS_t)*T1));
EXIT_IF_ISNAN((Ies-((pInst->PSEJ*JTSSWS_t)*T1)))
}
}
if
((JTSSWGS_t>0.0))
{
if
(((pModel->VTSSWGS-ves_jct)<(pModel->VTSSWGS*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*NJTSSWG_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*NJTSSWG_t_Tempt_GND+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND_Tempt_GND)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTSSWG_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTSSWG_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-((((Weff0*NFINtotal)*JTSSWGS_t_Tempt_GND)*T1)+(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
EXIT_IF_ISNAN((Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(((-ves_jct_Ve_si)/Vtm0)/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vge_e=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Ve_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct_Ve_si)/Vtm0)*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Ve_di=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vge_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Vdi_si=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*0.0+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Ve_si_Tempt_GND=((0.0/Vtm0-((-ves_jct_Ve_si)*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(((-ves_jct_Ve_si)/Vtm0)*NJTSSWG_t_Tempt_GND+0.0*0.0+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*0.0*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+(-ves_jct_Ve_si)*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+((-ves_jct_Ve_si)/Vtm0)*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*0.0+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*0.0)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*0.0/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ves_jct)*0.0)/Vtm0/Vtm0+2*(-ves_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWG_t-(0.0*NJTSSWG_t_Tempt_GND+0.0*NJTSSWG_t_Tempt_GND+((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND_Tempt_GND)/NJTSSWG_t/NJTSSWG_t+2*((-ves_jct)/Vtm0)*NJTSSWG_t_Tempt_GND*NJTSSWG_t_Tempt_GND/NJTSSWG_t/NJTSSWG_t/NJTSSWG_t);
#endif
#endif
T0=(((-ves_jct)/Vtm0)/NJTSSWG_t);
EXIT_IF_ISNAN((((-ves_jct)/Vtm0)/NJTSSWG_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Vge_di*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSSWGS+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_di*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Vge_e*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSSWGS+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_e*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),((T0_Ve_si*pModel->VTSSWGS*(pModel->VTSSWGS-ves_jct)-(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(0.0)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-ves_jct_Ve_si_Ve_si))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSSWGS+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_si*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*(-ves_jct_Ve_si)+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*(-ves_jct_Ve_si)*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Ve_di*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSSWGS+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Ve_di*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Vge_si*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSSWGS+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vge_si*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Vdi_si*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSSWGS+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Vdi_si*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)),(T0_Tempt_GND*pModel->VTSSWGS/(pModel->VTSSWGS-ves_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSSWGS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSSWGS+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(0.0)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Vge_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Vge_e*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*(-ves_jct_Ve_si)+(T0_Ve_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*(-ves_jct_Ve_si)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Ve_di*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Vge_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Vdi_si*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSSWGS+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGS-ves_jct)-(T0_Tempt_GND*pModel->VTSSWGS*0.0+(T0_Tempt_GND*pModel->VTSSWGS)*0.0+(T0*pModel->VTSSWGS)*(+0.0-0.0))/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)+2*(T0*pModel->VTSSWGS)*0.0*0.0/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct)/(pModel->VTSSWGS-ves_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSSWGS)/(pModel->VTSSWGS-ves_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ies_Vge_di=(Ies_Vge_di-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_di));
Ies_Vge_e=(Ies_Vge_e-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_e));
Ies_Ve_si=(Ies_Ve_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Ve_si));
Ies_Ve_di=(Ies_Ve_di-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Ve_di));
Ies_Vge_si=(Ies_Vge_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vge_si));
Ies_Vdi_si=(Ies_Vdi_si-(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Vdi_si));
Ies_Tempt_GND=(Ies_Tempt_GND-((((Weff0*NFINtotal)*JTSSWGS_t_Tempt_GND)*T1)+(((Weff0*NFINtotal)*JTSSWGS_t)*T1_Tempt_GND)));
#endif
Ies=(Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1));
EXIT_IF_ISNAN((Ies-(((Weff0*NFINtotal)*JTSSWGS_t)*T1)))
}
}
if
((Isbd>0.0))
{
if
((ved_jct<VjdmRev))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(ved_jct_Ve_di/Nvtmd);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vge_e=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Ve_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Ve_di=(ved_jct_Ve_di_Ve_di/Nvtmd-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vge_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vdi_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Tempt_GND=(0.0/Nvtmd-(ved_jct_Ve_di*Nvtmd_Tempt_GND+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-ved_jct*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_e=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_di=(0.0/Nvtmd-(0.0*0.0+ved_jct_Ve_di*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Tempt_GND=(0.0/Nvtmd-(0.0*Nvtmd_Tempt_GND+0.0*Nvtmd_Tempt_GND+ved_jct*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
#endif
T0=(ved_jct/Nvtmd);
EXIT_IF_ISNAN((ved_jct/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(T0,T0_Vge_di);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0-0.0);
  T1_Vge_di_Vsi_s=(+0.0-0.0);
  T1_Vge_di_Vge_di=(+T0_Vge_di_Vge_di-0.0);
  T1_Vge_di_Vge_e=(+T0_Vge_di_Vge_e-0.0);
  T1_Vge_di_Ve_si=(+T0_Vge_di_Ve_si-0.0);
  T1_Vge_di_Ve_di=(+T0_Vge_di_Ve_di-0.0);
  T1_Vge_di_Vge_si=(+T0_Vge_di_Vge_si-0.0);
  T1_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si-0.0);
  T1_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(T0,T0_Vge_e);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0-0.0);
  T1_Vge_e_Vsi_s=(+0.0-0.0);
  T1_Vge_e_Vge_di=(+T0_Vge_e_Vge_di-0.0);
  T1_Vge_e_Vge_e=(+T0_Vge_e_Vge_e-0.0);
  T1_Vge_e_Ve_si=(+T0_Vge_e_Ve_si-0.0);
  T1_Vge_e_Ve_di=(+T0_Vge_e_Ve_di-0.0);
  T1_Vge_e_Vge_si=(+T0_Vge_e_Vge_si-0.0);
  T1_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si-0.0);
  T1_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(T0,T0_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0-0.0);
  T1_Ve_si_Vsi_s=(+0.0-0.0);
  T1_Ve_si_Vge_di=(+T0_Ve_si_Vge_di-0.0);
  T1_Ve_si_Vge_e=(+T0_Ve_si_Vge_e-0.0);
  T1_Ve_si_Ve_si=(+T0_Ve_si_Ve_si-0.0);
  T1_Ve_si_Ve_di=(+T0_Ve_si_Ve_di-0.0);
  T1_Ve_si_Vge_si=(+T0_Ve_si_Vge_si-0.0);
  T1_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si-0.0);
  T1_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(T0,T0_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0-0.0);
  T1_Ve_di_Vsi_s=(+0.0-0.0);
  T1_Ve_di_Vge_di=(+T0_Ve_di_Vge_di-0.0);
  T1_Ve_di_Vge_e=(+T0_Ve_di_Vge_e-0.0);
  T1_Ve_di_Ve_si=(+T0_Ve_di_Ve_si-0.0);
  T1_Ve_di_Ve_di=(+T0_Ve_di_Ve_di-0.0);
  T1_Ve_di_Vge_si=(+T0_Ve_di_Vge_si-0.0);
  T1_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si-0.0);
  T1_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(T0,T0_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0-0.0);
  T1_Vge_si_Vsi_s=(+0.0-0.0);
  T1_Vge_si_Vge_di=(+T0_Vge_si_Vge_di-0.0);
  T1_Vge_si_Vge_e=(+T0_Vge_si_Vge_e-0.0);
  T1_Vge_si_Ve_si=(+T0_Vge_si_Ve_si-0.0);
  T1_Vge_si_Ve_di=(+T0_Vge_si_Ve_di-0.0);
  T1_Vge_si_Vge_si=(+T0_Vge_si_Vge_si-0.0);
  T1_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si-0.0);
  T1_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(T0,T0_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0-0.0);
  T1_Vdi_si_Vsi_s=(+0.0-0.0);
  T1_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di-0.0);
  T1_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e-0.0);
  T1_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si-0.0);
  T1_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di-0.0);
  T1_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si-0.0);
  T1_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si-0.0);
  T1_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(T0,T0_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0-0.0);
  T1_Tempt_GND_Vsi_s=(+0.0-0.0);
  T1_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di-0.0);
  T1_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e-0.0);
  T1_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si-0.0);
  T1_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di-0.0);
  T1_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si-0.0);
  T1_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si-0.0);
  T1_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND-0.0);
#endif
#endif
T1=(bsimcmg_lexp(T0)-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(T0)-1.0))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=(DslpRev*ved_jct_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Vsi_s=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Vge_di=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Vge_e=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Vge_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Ve_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Ve_di=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*ved_jct_Ve_di+0.0*ved_jct_Ve_di+DslpRev*(+ved_jct_Ve_di_Ve_di-0.0)));
  T2_Ve_di_Vdi_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*0.0+0.0*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
  T2_Ve_di_Tempt_GND=(+0.0+(+0.0*(ved_jct-VjdmRev)+0.0*(-VjdmRev_Tempt_GND)+DslpRev_Tempt_GND*ved_jct_Ve_di+DslpRev*(+0.0-0.0)));
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=(IVjdmRev_Tempt_GND+((DslpRev_Tempt_GND*(ved_jct-VjdmRev))+(DslpRev*(-VjdmRev_Tempt_GND))));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vsi_s=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_di=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_e=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vge_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Ve_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Ve_di=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*ved_jct_Ve_di+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Vdi_si=(+0.0+(+0.0*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*0.0+0.0*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-0.0)));
  T2_Tempt_GND_Tempt_GND=(+IVjdmRev_Tempt_GND_Tempt_GND+(+DslpRev_Tempt_GND_Tempt_GND*(ved_jct-VjdmRev)+DslpRev_Tempt_GND*(-VjdmRev_Tempt_GND)+DslpRev_Tempt_GND*(-VjdmRev_Tempt_GND)+DslpRev*(+0.0-VjdmRev_Tempt_GND_Tempt_GND)));
#endif
#endif
T2=(IVjdmRev+(DslpRev*(ved_jct-VjdmRev)));
EXIT_IF_ISNAN((IVjdmRev+(DslpRev*(ved_jct-VjdmRev))))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=((T1_Vge_di*T2)+(T1*T2_Vge_di));
Ied_Vge_e=((T1_Vge_e*T2)+(T1*T2_Vge_e));
Ied_Ve_si=((T1_Ve_si*T2)+(T1*T2_Ve_si));
Ied_Ve_di=((T1_Ve_di*T2)+(T1*T2_Ve_di));
Ied_Vge_si=((T1_Vge_si*T2)+(T1*T2_Vge_si));
Ied_Vdi_si=((T1_Vdi_si*T2)+(T1*T2_Vdi_si));
Ied_Tempt_GND=((T1_Tempt_GND*T2)+(T1*T2_Tempt_GND));
#endif
Ied=(T1*T2);
EXIT_IF_ISNAN((T1*T2))
}
else
{
if
((ved_jct<=VjdmFwd))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(ved_jct_Ve_di/Nvtmd);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vge_e=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Ve_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Ve_di=(ved_jct_Ve_di_Ve_di/Nvtmd-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vge_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Vdi_si=(0.0/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Ve_di_Tempt_GND=(0.0/Nvtmd-(ved_jct_Ve_di*Nvtmd_Tempt_GND+0.0*0.0+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-ved_jct*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_e=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Ve_di=(0.0/Nvtmd-(0.0*0.0+ved_jct_Ve_di*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vge_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Vdi_si=(0.0/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+ved_jct*0.0)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T0_Tempt_GND_Tempt_GND=(0.0/Nvtmd-(0.0*Nvtmd_Tempt_GND+0.0*Nvtmd_Tempt_GND+ved_jct*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*ved_jct*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
#endif
T0=(ved_jct/Nvtmd);
EXIT_IF_ISNAN((ved_jct/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=(ved_jct_Ve_di/Nvtmd);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Vsi_s=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Vge_di=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Vge_e=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Ve_si=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Ve_di=((+0.0+ved_jct_Ve_di_Ve_di)/Nvtmd-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Vge_si=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Vdi_si=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*0.0+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Ve_di_Tempt_GND=((+0.0+0.0)/Nvtmd-(ved_jct_Ve_di*Nvtmd_Tempt_GND+0.0*0.0+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*0.0*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND/Nvtmd/Nvtmd);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Vsi_s=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Vge_di=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Vge_e=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Ve_si=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Ve_di=((+0.0+0.0)/Nvtmd-(0.0*0.0+ved_jct_Ve_di*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Vge_si=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Vdi_si=((+0.0+0.0)/Nvtmd-(0.0*0.0+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*0.0)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*0.0/Nvtmd/Nvtmd/Nvtmd);
  T1_Tempt_GND_Tempt_GND=((+0.0+0.0)/Nvtmd-(0.0*Nvtmd_Tempt_GND+0.0*Nvtmd_Tempt_GND+(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND_Tempt_GND)/Nvtmd/Nvtmd+2*(pModel->BVD+ved_jct)*Nvtmd_Tempt_GND*Nvtmd_Tempt_GND/Nvtmd/Nvtmd/Nvtmd);
#endif
#endif
T1=((pModel->BVD+ved_jct)/Nvtmd);
EXIT_IF_ISNAN(((pModel->BVD+ved_jct)/Nvtmd))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=bsimcmg_d_lexp((-T1),(-T1_Vge_di));
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=bsimcmg_d_lexp((-T1),(-T1_Vge_e));
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=bsimcmg_d_lexp((-T1),(-T1_Vge_si));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=bsimcmg_d_lexp((-T1),(-T1_Ve_si));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=bsimcmg_d_lexp((-T1),(-T1_Ve_di));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=bsimcmg_d_lexp((-T1),(-T1_Vdi_si));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=bsimcmg_d_lexp((-T1),(-T1_Tempt_GND));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp((-T1));
EXIT_IF_ISNAN(bsimcmg_lexp((-T1)))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Isbd*(bsimcmg_d_lexp(T0,T0_Vge_di)-(pModel->XJBVD*T2_Vge_di)));
Ied_Vge_e=(Isbd*(bsimcmg_d_lexp(T0,T0_Vge_e)-(pModel->XJBVD*T2_Vge_e)));
Ied_Ve_si=(Isbd*(bsimcmg_d_lexp(T0,T0_Ve_si)-(pModel->XJBVD*T2_Ve_si)));
Ied_Ve_di=(Isbd*(bsimcmg_d_lexp(T0,T0_Ve_di)-(pModel->XJBVD*T2_Ve_di)));
Ied_Vge_si=(Isbd*(bsimcmg_d_lexp(T0,T0_Vge_si)-(pModel->XJBVD*T2_Vge_si)));
Ied_Vdi_si=(Isbd*(bsimcmg_d_lexp(T0,T0_Vdi_si)-(pModel->XJBVD*T2_Vdi_si)));
Ied_Tempt_GND=((Isbd_Tempt_GND*(((bsimcmg_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2)))+(Isbd*((bsimcmg_d_lexp(T0,T0_Tempt_GND)+XExpBVD_Tempt_GND)-(pModel->XJBVD*T2_Tempt_GND))));
#endif
Ied=(Isbd*(((bsimcmg_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2)));
EXIT_IF_ISNAN((Isbd*(((bsimcmg_lexp(T0)+XExpBVD)-1.0)-(pModel->XJBVD*T2))))
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=0.0;
Ied_Vge_e=0.0;
Ied_Ve_si=0.0;
Ied_Ve_di=(DslpFwd*ved_jct_Ve_di);
Ied_Vge_si=0.0;
Ied_Vdi_si=0.0;
Ied_Tempt_GND=(IVjdmFwd_Tempt_GND+((DslpFwd_Tempt_GND*(ved_jct-VjdmFwd))+(DslpFwd*(-VjdmFwd_Tempt_GND))));
#endif
Ied=(IVjdmFwd+(DslpFwd*(ved_jct-VjdmFwd)));
EXIT_IF_ISNAN((IVjdmFwd+(DslpFwd*(ved_jct-VjdmFwd))))
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=0.0;
Ied_Vge_e=0.0;
Ied_Ve_si=0.0;
Ied_Ve_di=0.0;
Ied_Vge_si=0.0;
Ied_Vdi_si=0.0;
Ied_Tempt_GND=0.0;
#endif
Ied=0.0;
EXIT_IF_ISNAN(0.0)
}
if
((JTSD_t>0.0))
{
if
(((pModel->VTSD-ved_jct)<(pModel->VTSD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*NJTSD_t_Tempt_GND+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND_Tempt_GND)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-((pInst->ADEJ*JTSD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-((pInst->ADEJ*JTSD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-((pInst->ADEJ*JTSD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-((pInst->ADEJ*JTSD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-((pInst->ADEJ*JTSD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-((pInst->ADEJ*JTSD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-(((pInst->ADEJ*JTSD_t_Tempt_GND)*T1)+((pInst->ADEJ*JTSD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-((pInst->ADEJ*JTSD_t)*T1));
EXIT_IF_ISNAN((Ied-((pInst->ADEJ*JTSD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*0.0+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*0.0/NJTSD_t/NJTSD_t/NJTSD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSD_t-(0.0*NJTSD_t_Tempt_GND+0.0*NJTSD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND_Tempt_GND)/NJTSD_t/NJTSD_t+2*((-ved_jct)/Vtm0)*NJTSD_t_Tempt_GND*NJTSD_t_Tempt_GND/NJTSD_t/NJTSD_t/NJTSD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Vge_di*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSD+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSD+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSD+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSD+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSD+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSD+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSD+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_di*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Vge_e*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSD+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSD+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSD+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSD+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSD+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSD+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSD+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_e*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Ve_si*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSD+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSD+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSD+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSD+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSD+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSD+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSD+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_si*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),((T0_Ve_di*pModel->VTSD*(pModel->VTSD-ved_jct)-(T0*pModel->VTSD)*(-ved_jct_Ve_di))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSD+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSD+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSD+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSD+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-ved_jct_Ve_di_Ve_di))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSD+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSD+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSD+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Ve_di*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*(-ved_jct_Ve_di)+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Vge_si*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSD+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSD+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSD+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSD+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSD+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSD+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSD+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vge_si*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Vdi_si*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSD+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSD+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSD+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSD+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSD+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSD+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSD+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Vdi_si*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)),(T0_Tempt_GND*pModel->VTSD/(pModel->VTSD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(0.0)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSD+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Vge_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSD+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Vge_e*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSD+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Ve_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSD+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSD+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Vge_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSD+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Vdi_si*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSD+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSD-ved_jct)-(T0_Tempt_GND*pModel->VTSD*0.0+(T0_Tempt_GND*pModel->VTSD)*0.0+(T0*pModel->VTSD)*(+0.0-0.0))/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)+2*(T0*pModel->VTSD)*0.0*0.0/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct)/(pModel->VTSD-ved_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSD)/(pModel->VTSD-ved_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-((pInst->ADEJ*JTSD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-((pInst->ADEJ*JTSD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-((pInst->ADEJ*JTSD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-((pInst->ADEJ*JTSD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-((pInst->ADEJ*JTSD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-((pInst->ADEJ*JTSD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-(((pInst->ADEJ*JTSD_t_Tempt_GND)*T1)+((pInst->ADEJ*JTSD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-((pInst->ADEJ*JTSD_t)*T1));
EXIT_IF_ISNAN((Ied-((pInst->ADEJ*JTSD_t)*T1)))
}
}
if
((JTSSWD_t>0.0))
{
if
(((pModel->VTSSWD-ved_jct)<(pModel->VTSSWD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSSWD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*NJTSSWD_t_Tempt_GND+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND_Tempt_GND)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSSWD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSSWD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-((pInst->PDEJ*JTSSWD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-((pInst->PDEJ*JTSSWD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-((pInst->PDEJ*JTSSWD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-((pInst->PDEJ*JTSSWD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-((pInst->PDEJ*JTSSWD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-((pInst->PDEJ*JTSSWD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-(((pInst->PDEJ*JTSSWD_t_Tempt_GND)*T1)+((pInst->PDEJ*JTSSWD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-((pInst->PDEJ*JTSSWD_t)*T1));
EXIT_IF_ISNAN((Ied-((pInst->PDEJ*JTSSWD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSSWD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*0.0+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*0.0/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWD_t-(0.0*NJTSSWD_t_Tempt_GND+0.0*NJTSSWD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND_Tempt_GND)/NJTSSWD_t/NJTSSWD_t+2*((-ved_jct)/Vtm0)*NJTSSWD_t_Tempt_GND*NJTSSWD_t_Tempt_GND/NJTSSWD_t/NJTSSWD_t/NJTSSWD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSSWD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSSWD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Vge_di*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSSWD+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSSWD+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSSWD+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSSWD+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSSWD+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSSWD+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSSWD+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_di*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Vge_e*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSSWD+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSSWD+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSSWD+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSSWD+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSSWD+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSSWD+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSSWD+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_e*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Ve_si*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSSWD+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSSWD+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSSWD+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSSWD+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSSWD+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSSWD+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSSWD+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_si*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),((T0_Ve_di*pModel->VTSSWD*(pModel->VTSSWD-ved_jct)-(T0*pModel->VTSSWD)*(-ved_jct_Ve_di))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSSWD+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSSWD+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSSWD+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSSWD+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-ved_jct_Ve_di_Ve_di))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSSWD+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSSWD+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSSWD+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Ve_di*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Vge_si*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSSWD+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSSWD+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSSWD+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSSWD+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSSWD+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSSWD+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSSWD+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vge_si*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Vdi_si*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSSWD+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Vdi_si*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)),(T0_Tempt_GND*pModel->VTSSWD/(pModel->VTSSWD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSSWD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSSWD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(0.0)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Vge_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Vge_e*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Ve_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Vge_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Vdi_si*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSSWD+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWD*0.0+(T0_Tempt_GND*pModel->VTSSWD)*0.0+(T0*pModel->VTSSWD)*(+0.0-0.0))/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)+2*(T0*pModel->VTSSWD)*0.0*0.0/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct)/(pModel->VTSSWD-ved_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSSWD)/(pModel->VTSSWD-ved_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-((pInst->PDEJ*JTSSWD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-((pInst->PDEJ*JTSSWD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-((pInst->PDEJ*JTSSWD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-((pInst->PDEJ*JTSSWD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-((pInst->PDEJ*JTSSWD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-((pInst->PDEJ*JTSSWD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-(((pInst->PDEJ*JTSSWD_t_Tempt_GND)*T1)+((pInst->PDEJ*JTSSWD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-((pInst->PDEJ*JTSSWD_t)*T1));
EXIT_IF_ISNAN((Ied-((pInst->PDEJ*JTSSWD_t)*T1)))
}
}
if
((JTSSWGD_t>0.0))
{
if
(((pModel->VTSSWGD-ved_jct)<(pModel->VTSSWGD*1.0e-3)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*NJTSSWGD_t_Tempt_GND+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND_Tempt_GND)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSSWGD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSSWGD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vsi_s=(+(+0.0*1.0e3+T0_Vge_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*1.0e3+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*1.0e3+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*1.0e3+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*1.0e3+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*1.0e3+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*1.0e3+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*1.0e3+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_e*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vsi_s=(+(+0.0*1.0e3+T0_Vge_e*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*1.0e3+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*1.0e3+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*1.0e3+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*1.0e3+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*1.0e3+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*1.0e3+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*1.0e3+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vsi_s=(+(+0.0*1.0e3+T0_Ve_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*1.0e3+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*1.0e3+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*1.0e3+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*1.0e3+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*1.0e3+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*1.0e3+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*1.0e3+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp((T0*1.0e3),T0_Ve_di*1.0e3);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vsi_s=(+(+0.0*1.0e3+T0_Ve_di*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*1.0e3+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*1.0e3+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*1.0e3+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*1.0e3+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*1.0e3+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*1.0e3+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*1.0e3+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vge_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vsi_s=(+(+0.0*1.0e3+T0_Vge_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*1.0e3+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*1.0e3+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*1.0e3+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*1.0e3+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*1.0e3+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*1.0e3+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*1.0e3+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp((T0*1.0e3),T0_Vdi_si*1.0e3);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vsi_s=(+(+0.0*1.0e3+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*1.0e3+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*1.0e3+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*1.0e3+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*1.0e3+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*1.0e3+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*1.0e3+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*1.0e3+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp((T0*1.0e3),T0_Tempt_GND*1.0e3);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vsi_s=(+(+0.0*1.0e3+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*1.0e3+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*1.0e3+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*1.0e3+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*1.0e3+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*1.0e3+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*1.0e3+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)-0.0);
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*1.0e3+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)-0.0);
#endif
#endif
T1=(bsimcmg_lexp((T0*1.0e3))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp((T0*1.0e3))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-((((Weff0*NFINtotal)*JTSSWGD_t_Tempt_GND)*T1)+(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
EXIT_IF_ISNAN((Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1)))
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=(((-ved_jct_Ve_di)/Vtm0)/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vge_e=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Ve_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Ve_di=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct_Ve_di)/Vtm0)*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vge_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Vdi_si=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*0.0+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Ve_di_Tempt_GND=((0.0/Vtm0-((-ved_jct_Ve_di)*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(((-ved_jct_Ve_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+0.0*0.0+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*0.0*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=0.0;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=(-((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vge_e=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Ve_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Ve_di=((0.0/Vtm0-(0.0*0.0+(-ved_jct_Ve_di)*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+((-ved_jct_Ve_di)/Vtm0)*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vge_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Vdi_si=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*0.0+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*0.0)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*0.0/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
  T0_Tempt_GND_Tempt_GND=((0.0/Vtm0-(0.0*0.0+0.0*0.0+(-ved_jct)*0.0)/Vtm0/Vtm0+2*(-ved_jct)*0.0*0.0/Vtm0/Vtm0/Vtm0)/NJTSSWGD_t-(0.0*NJTSSWGD_t_Tempt_GND+0.0*NJTSSWGD_t_Tempt_GND+((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND_Tempt_GND)/NJTSSWGD_t/NJTSSWGD_t+2*((-ved_jct)/Vtm0)*NJTSSWGD_t_Tempt_GND*NJTSSWGD_t_Tempt_GND/NJTSSWGD_t/NJTSSWGD_t/NJTSSWGD_t);
#endif
#endif
T0=(((-ved_jct)/Vtm0)/NJTSSWGD_t);
EXIT_IF_ISNAN((((-ved_jct)/Vtm0)/NJTSSWGD_t))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Vge_di*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Vge_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Vge_di=(+((+T0_Vge_di_Vge_di*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Vge_e=(+((+T0_Vge_di_Vge_e*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Ve_si=(+((+T0_Vge_di_Ve_si*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Ve_di=(+((+T0_Vge_di_Ve_di*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Vge_si=(+((+T0_Vge_di_Vge_si*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Vdi_si=(+((+T0_Vge_di_Vdi_si*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_di_Tempt_GND=(+((+T0_Vge_di_Tempt_GND*pModel->VTSSWGD+T0_Vge_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_di*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Vge_e=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Vge_e*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Vge_e*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Vge_di=(+((+T0_Vge_e_Vge_di*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Vge_e=(+((+T0_Vge_e_Vge_e*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Ve_si=(+((+T0_Vge_e_Ve_si*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Ve_di=(+((+T0_Vge_e_Ve_di*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Vge_si=(+((+T0_Vge_e_Vge_si*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Vdi_si=(+((+T0_Vge_e_Vdi_si*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_e_Tempt_GND=(+((+T0_Vge_e_Tempt_GND*pModel->VTSSWGD+T0_Vge_e*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_e*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Ve_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Ve_si*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Ve_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Vge_di=(+((+T0_Ve_si_Vge_di*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Vge_e=(+((+T0_Ve_si_Vge_e*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Ve_si=(+((+T0_Ve_si_Ve_si*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Ve_di=(+((+T0_Ve_si_Ve_di*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Vge_si=(+((+T0_Ve_si_Vge_si*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Vdi_si=(+((+T0_Ve_si_Vdi_si*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_si_Tempt_GND=(+((+T0_Ve_si_Tempt_GND*pModel->VTSSWGD+T0_Ve_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_si*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Ve_di=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),((T0_Ve_di*pModel->VTSSWGD*(pModel->VTSSWGD-ved_jct)-(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Ve_di*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(0.0)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Vge_di=(+((+T0_Ve_di_Vge_di*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Vge_e=(+((+T0_Ve_di_Vge_e*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Ve_si=(+((+T0_Ve_di_Ve_si*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Ve_di=(+((+T0_Ve_di_Ve_di*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-ved_jct_Ve_di_Ve_di))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Vge_si=(+((+T0_Ve_di_Vge_si*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Vdi_si=(+((+T0_Ve_di_Vdi_si*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Ve_di_Tempt_GND=(+((+T0_Ve_di_Tempt_GND*pModel->VTSSWGD+T0_Ve_di*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Ve_di*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*(-ved_jct_Ve_di)+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*(-ved_jct_Ve_di)*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Vge_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Vge_si*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Vge_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Vge_di=(+((+T0_Vge_si_Vge_di*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Vge_e=(+((+T0_Vge_si_Vge_e*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Ve_si=(+((+T0_Vge_si_Ve_si*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Ve_di=(+((+T0_Vge_si_Ve_di*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Vge_si=(+((+T0_Vge_si_Vge_si*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Vdi_si=(+((+T0_Vge_si_Vdi_si*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vge_si_Tempt_GND=(+((+T0_Vge_si_Tempt_GND*pModel->VTSSWGD+T0_Vge_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vge_si*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Vdi_si=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Vdi_si*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Vdi_si*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Vge_di=(+((+T0_Vdi_si_Vge_di*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Vge_e=(+((+T0_Vdi_si_Vge_e*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Ve_si=(+((+T0_Vdi_si_Ve_si*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Ve_di=(+((+T0_Vdi_si_Ve_di*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Vge_si=(+((+T0_Vdi_si_Vge_si*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Vdi_si=(+((+T0_Vdi_si_Vdi_si*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Vdi_si_Tempt_GND=(+((+T0_Vdi_si_Tempt_GND*pModel->VTSSWGD+T0_Vdi_si*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Vdi_si*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
T1_Tempt_GND=bsimcmg_d_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)),(T0_Tempt_GND*pModel->VTSSWGD/(pModel->VTSSWGD-ved_jct)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+((+0.0*pModel->VTSSWGD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Vsi_s=(+((+0.0*pModel->VTSSWGD+T0_Tempt_GND*0.0+0.0*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(0.0)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_di=(+((+T0_Tempt_GND_Vge_di*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Vge_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Vge_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_e=(+((+T0_Tempt_GND_Vge_e*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Vge_e*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Vge_e*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_si=(+((+T0_Tempt_GND_Ve_si*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Ve_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Ve_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Ve_di=(+((+T0_Tempt_GND_Ve_di*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Ve_di*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*(-ved_jct_Ve_di)+(T0_Ve_di*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*(-ved_jct_Ve_di)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Vge_si=(+((+T0_Tempt_GND_Vge_si*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Vge_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Vge_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Vdi_si=(+((+T0_Tempt_GND_Vdi_si*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Vdi_si*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Vdi_si*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
  T1_Tempt_GND_Tempt_GND=(+((+T0_Tempt_GND_Tempt_GND*pModel->VTSSWGD+T0_Tempt_GND*0.0+T0_Tempt_GND*0.0+T0*0.0)/(pModel->VTSSWGD-ved_jct)-(T0_Tempt_GND*pModel->VTSSWGD*0.0+(T0_Tempt_GND*pModel->VTSSWGD)*0.0+(T0*pModel->VTSSWGD)*(+0.0-0.0))/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)+2*(T0*pModel->VTSSWGD)*0.0*0.0/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct)/(pModel->VTSSWGD-ved_jct))-0.0);
#endif
#endif
T1=(bsimcmg_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)))-1.0);
EXIT_IF_ISNAN((bsimcmg_lexp(((T0*pModel->VTSSWGD)/(pModel->VTSSWGD-ved_jct)))-1.0))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Ied_Vge_di=(Ied_Vge_di-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_di));
Ied_Vge_e=(Ied_Vge_e-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_e));
Ied_Ve_si=(Ied_Ve_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Ve_si));
Ied_Ve_di=(Ied_Ve_di-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Ve_di));
Ied_Vge_si=(Ied_Vge_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vge_si));
Ied_Vdi_si=(Ied_Vdi_si-(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Vdi_si));
Ied_Tempt_GND=(Ied_Tempt_GND-((((Weff0*NFINtotal)*JTSSWGD_t_Tempt_GND)*T1)+(((Weff0*NFINtotal)*JTSSWGD_t)*T1_Tempt_GND)));
#endif
Ied=(Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1));
EXIT_IF_ISNAN((Ied-(((Weff0*NFINtotal)*JTSSWGD_t)*T1)))
}
}
{
if
((Czbs>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(ves_jct_Ve_si/PBS_t);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Vsi_s=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Vge_di=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Vge_e=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Ve_si=(ves_jct_Ve_si_Ve_si/PBS_t-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Ve_di=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Vge_si=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Vdi_si=(0.0/PBS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*0.0/PBS_t/PBS_t/PBS_t);
  T1_Ve_si_Tempt_GND=(0.0/PBS_t-(ves_jct_Ve_si*PBS_t_Tempt_GND+0.0*0.0+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*0.0*PBS_t_Tempt_GND/PBS_t/PBS_t/PBS_t);
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ves_jct*PBS_t_Tempt_GND/PBS_t/PBS_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Vge_di=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Vge_e=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Ve_si=(0.0/PBS_t-(0.0*0.0+ves_jct_Ve_si*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Ve_di=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Vge_si=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBS_t-(0.0*0.0+0.0*PBS_t_Tempt_GND+ves_jct*0.0)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBS_t-(0.0*PBS_t_Tempt_GND+0.0*PBS_t_Tempt_GND+ves_jct*PBS_t_Tempt_GND_Tempt_GND)/PBS_t/PBS_t+2*ves_jct*PBS_t_Tempt_GND*PBS_t_Tempt_GND/PBS_t/PBS_t/PBS_t);
#endif
#endif
T1=(ves_jct/PBS_t);
EXIT_IF_ISNAN((ves_jct/PBS_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJS>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBS_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))))))+(PBS_t*(-bsimcmg_d_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))),((1.0/pModel->MJS)*bsimcmg_d_lln((1.0/pModel->SJS),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBS_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS)))))+PBS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))),((1.0/pModel->MJS)*bsimcmg_d_lln((1.0/pModel->SJS),0.0))))+PBS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))),((1.0/pModel->MJS)*bsimcmg_d_lln((1.0/pModel->SJS),0.0))))+PBS_t*(+0.0-(+(0.0/pModel->MJS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJS/pModel->MJS+2*1.0*0.0*0.0/pModel->MJS/pModel->MJS/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))+0.0*bsimcmg_d_lln((1.0/pModel->SJS),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJS),0.0)+(1.0/pModel->MJS)*(0.0/pModel->SJS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJS/pModel->SJS+2*1.0*0.0*0.0/pModel->SJS/pModel->SJS/pModel->SJS))));
#endif
#endif
vec=(PBS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS))))));
EXIT_IF_ISNAN((PBS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJS)*bsimcmg_lln((1.0/pModel->SJS)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBS_t_Tempt_GND*pModel->SJS*pModel->MJS2/pModel->MJS)*bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))-(((PBS_t*pModel->SJS)*pModel->MJS2)/pModel->MJS)*bsimcmg_d_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))),((-(1.0+pModel->MJS))*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBS_t_Tempt_GND_Tempt_GND*pModel->SJS+PBS_t_Tempt_GND*0.0+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*pModel->MJS2+PBS_t_Tempt_GND*pModel->SJS*0.0+(PBS_t_Tempt_GND*pModel->SJS)*0.0+(PBS_t*pModel->SJS)*0.0)/pModel->MJS-(PBS_t_Tempt_GND*pModel->SJS*pModel->MJS2*0.0+((PBS_t_Tempt_GND*pModel->SJS)*pModel->MJS2)*0.0+((PBS_t*pModel->SJS)*pModel->MJS2)*0.0)/pModel->MJS/pModel->MJS+2*((PBS_t*pModel->SJS)*pModel->MJS2)*0.0*0.0/pModel->MJS/pModel->MJS/pModel->MJS)/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))-((PBS_t_Tempt_GND*pModel->SJS*pModel->MJS2/pModel->MJS)*bsimcmg_d_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))),((-(1.0+pModel->MJS))*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))))+(((PBS_t_Tempt_GND*pModel->SJS)*pModel->MJS2)/pModel->MJS)*bsimcmg_d_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))),((-(1.0+pModel->MJS))*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))))+(((PBS_t*pModel->SJS)*pModel->MJS2)/pModel->MJS)*(+0.0*bsimcmg_lln((1.0-(vec/PBS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))+(-(1.0+pModel->MJS))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBS_t-(vec_Tempt_GND*PBS_t_Tempt_GND+vec_Tempt_GND*PBS_t_Tempt_GND+vec*PBS_t_Tempt_GND_Tempt_GND)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*PBS_t_Tempt_GND/PBS_t/PBS_t/PBS_t))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))+2*(((PBS_t*pModel->SJS)*pModel->MJS2)/pModel->MJS)*bsimcmg_d_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))),((-(1.0+pModel->MJS))*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))),((-(1.0+pModel->MJS))*bsimcmg_d_lln((1.0-(vec/PBS_t)),(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t))))));
#endif
#endif
pb2=((((PBS_t*pModel->SJS)*pModel->MJS2)/pModel->MJS)/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t))))));
EXIT_IF_ISNAN(((((PBS_t*pModel->SJS)*pModel->MJS2)/pModel->MJS)/bsimcmg_lexp(((-(1.0+pModel->MJS))*bsimcmg_lln((1.0-(vec/PBS_t)))))))
#endif
#ifdef _DYNAMIC
if
((ves_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vdi_d_Vdi_d=0.0;
  Qesj1_Vdi_d_Vsi_s=0.0;
  Qesj1_Vdi_d_Tempt_GND=0.0;
  Qesj1_Vdi_d_Vge_di=0.0;
  Qesj1_Vdi_d_Vge_e=0.0;
  Qesj1_Vdi_d_Ve_si=0.0;
  Qesj1_Vdi_d_Ve_di=0.0;
  Qesj1_Vdi_d_Vge_si=0.0;
  Qesj1_Vdi_d_Vdi_si=0.0;
#endif
Qesj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vsi_s_Vdi_d=0.0;
  Qesj1_Vsi_s_Vsi_s=0.0;
  Qesj1_Vsi_s_Tempt_GND=0.0;
  Qesj1_Vsi_s_Vge_di=0.0;
  Qesj1_Vsi_s_Vge_e=0.0;
  Qesj1_Vsi_s_Ve_si=0.0;
  Qesj1_Vsi_s_Ve_di=0.0;
  Qesj1_Vsi_s_Vge_si=0.0;
  Qesj1_Vsi_s_Vdi_si=0.0;
#endif
Qesj1_Tempt_GND=(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Tempt_GND_Vdi_d=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vsi_s=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Tempt_GND=((+(+PBS_t_Tempt_GND_Tempt_GND*Czbs+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t*Czbs_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_e=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Ve_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Ve_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vdi_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_di=(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_di_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_e=(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_e_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Ve_si=(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Ve_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Ve_di=(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Ve_di_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_si=(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vdi_si=(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vdi_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
#endif
Qesj1=(((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS));
EXIT_IF_ISNAN((((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBS_t-vec*PBS_t_Tempt_GND)/PBS_t/PBS_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBS_t-(vec_Tempt_GND*0.0+0.0*PBS_t_Tempt_GND+vec*0.0)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*0.0/PBS_t/PBS_t/PBS_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBS_t-(vec_Tempt_GND*PBS_t_Tempt_GND+vec_Tempt_GND*PBS_t_Tempt_GND+vec*PBS_t_Tempt_GND_Tempt_GND)/PBS_t/PBS_t+2*vec*PBS_t_Tempt_GND*PBS_t_Tempt_GND/PBS_t/PBS_t/PBS_t));
#endif
#endif
arg=(1.0-(vec/PBS_t));
EXIT_IF_ISNAN((1.0-(vec/PBS_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBS_t_Tempt_GND_Tempt_GND*Czbs+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t*Czbs_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Vge_di=(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Vge_e=(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Ve_si=(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Ve_di=(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Vge_si=(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qec_Vdi_si=(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
#endif
Qec=(((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS));
EXIT_IF_ISNAN((((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=(-(ves_jct_Ve_si/pb2));
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_si=(+0.0-((+ves_jct_Ve_si_Ve_si-0.0)/pb2-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ves_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ves_jct_Ve_si*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ves_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ves_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ves_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJS2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)),((-pModel->MJS2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJS2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJS2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vdi_d_Vdi_d=0.0;
  Qesj1_Vdi_d_Vsi_s=0.0;
  Qesj1_Vdi_d_Tempt_GND=0.0;
  Qesj1_Vdi_d_Vge_di=0.0;
  Qesj1_Vdi_d_Vge_e=0.0;
  Qesj1_Vdi_d_Ve_si=0.0;
  Qesj1_Vdi_d_Ve_di=0.0;
  Qesj1_Vdi_d_Vge_si=0.0;
  Qesj1_Vdi_d_Vdi_si=0.0;
#endif
Qesj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vsi_s_Vdi_d=0.0;
  Qesj1_Vsi_s_Vsi_s=0.0;
  Qesj1_Vsi_s_Tempt_GND=0.0;
  Qesj1_Vsi_s_Vge_di=0.0;
  Qesj1_Vsi_s_Vge_e=0.0;
  Qesj1_Vsi_s_Ve_si=0.0;
  Qesj1_Vsi_s_Ve_di=0.0;
  Qesj1_Vsi_s_Vge_si=0.0;
  Qesj1_Vsi_s_Vdi_si=0.0;
#endif
Qesj1_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(0.0))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(0.0))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJS*pb2_Tempt_GND_Tempt_GND)*Czbs+(pModel->SJS*pb2_Tempt_GND)*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*Czbs_Tempt_GND+(pModel->SJS*pb2)*Czbs_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJS*0.0)*Czbs+(pModel->SJS*pb2_Tempt_GND)*0.0+(0.0)*Czbs_Tempt_GND+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJS2)-((((((pModel->SJS*pb2_Tempt_GND)*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Vge_di=(Qec_Vge_di+((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Vge_e=(Qec_Vge_e+((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Ve_si=(Qec_Ve_si+((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Ve_di=(Qec_Ve_di+((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Vge_si=(Qec_Vge_si+((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
Qesj1_Vdi_si=(Qec_Vdi_si+((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJS2)));
#if defined(_DERIVATE2)
  Qesj1_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(0.0)))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*Czbs_Tempt_GND+((pModel->SJS*pb2_Tempt_GND))*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJS*pb2_Tempt_GND))*Czbs)+((pModel->SJS*pb2)*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
  Qesj1_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJS*0.0)*Czbs+0.0*0.0+(0.0)*0.0+(pModel->SJS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJS*pb2)*Czbs)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJS2)-((((pModel->SJS*pb2)*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbs)*(1.0-(arg*sarg)))+(((pModel->SJS*pb2)*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)+2*(((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)/(1.0-pModel->MJS2)));
#endif
#endif
Qesj1=(Qec+((((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJS*pb2)*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJS)*bsimcmg_lln(arg)),((-pModel->MJS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vdi_d_Vdi_d=0.0;
  Qesj1_Vdi_d_Vsi_s=0.0;
  Qesj1_Vdi_d_Tempt_GND=0.0;
  Qesj1_Vdi_d_Vge_di=0.0;
  Qesj1_Vdi_d_Vge_e=0.0;
  Qesj1_Vdi_d_Ve_si=0.0;
  Qesj1_Vdi_d_Ve_di=0.0;
  Qesj1_Vdi_d_Vge_si=0.0;
  Qesj1_Vdi_d_Vdi_si=0.0;
#endif
Qesj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vsi_s_Vdi_d=0.0;
  Qesj1_Vsi_s_Vsi_s=0.0;
  Qesj1_Vsi_s_Tempt_GND=0.0;
  Qesj1_Vsi_s_Vge_di=0.0;
  Qesj1_Vsi_s_Vge_e=0.0;
  Qesj1_Vsi_s_Ve_si=0.0;
  Qesj1_Vsi_s_Ve_di=0.0;
  Qesj1_Vsi_s_Vge_si=0.0;
  Qesj1_Vsi_s_Vdi_si=0.0;
#endif
Qesj1_Tempt_GND=(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Tempt_GND_Vdi_d=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vsi_s=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Tempt_GND=((+(+PBS_t_Tempt_GND_Tempt_GND*Czbs+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t*Czbs_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_e=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Ve_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Ve_di=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vge_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Tempt_GND_Vdi_si=((+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(1.0-(arg*sarg))+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBS_t*Czbs)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJS)-(((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_di=(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_di_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_e=(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_e_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_e_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Ve_si=(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Ve_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Ve_di=(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Ve_di_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Ve_di_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBS_t*Czbs)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vge_si=(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vge_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vge_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
Qesj1_Vdi_si=(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJS));
#if defined(_DERIVATE2)
  Qesj1_Vdi_si_Vdi_d=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vsi_s=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(0.0)))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Tempt_GND=((+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_e=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Ve_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Ve_di=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vge_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
  Qesj1_Vdi_si_Vdi_si=((+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBS_t*Czbs)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJS)-(((PBS_t*Czbs)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBS_t*Czbs)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBS_t*Czbs)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJS)/(1.0-pModel->MJS)+2*((PBS_t*Czbs)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJS)/(1.0-pModel->MJS)/(1.0-pModel->MJS));
#endif
#endif
Qesj1=(((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS));
EXIT_IF_ISNAN((((PBS_t*Czbs)*(1.0-(arg*sarg)))/(1.0-pModel->MJS)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJS)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJS));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJS)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJS)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJS)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJS)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJS)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJS)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJS)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)))+((T2*(T1-1.0))*((5.0*pModel->MJS)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJS)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJS)*(T1-1.0))+(1.0+pModel->MJS))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Vge_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Vge_e+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Vdi_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Ve_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Ve_di+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Vge_si+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)))+(T3*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJS))*T2)+(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJS))*T2_Tempt_GND+((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJS)*(1.0+pModel->MJS))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj1_Vdi_d=((PBS_t*Czbs)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qesj1_Vdi_d_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vdi_d));
  Qesj1_Vdi_d_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vsi_s));
  Qesj1_Vdi_d_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qesj1_Vdi_d_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vge_di));
  Qesj1_Vdi_d_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vge_e));
  Qesj1_Vdi_d_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Ve_si));
  Qesj1_Vdi_d_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Ve_di));
  Qesj1_Vdi_d_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vge_si));
  Qesj1_Vdi_d_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBS_t*Czbs)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qesj1_Vsi_s=((PBS_t*Czbs)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qesj1_Vsi_s_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vdi_d));
  Qesj1_Vsi_s_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vsi_s));
  Qesj1_Vsi_s_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qesj1_Vsi_s_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vge_di));
  Qesj1_Vsi_s_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vge_e));
  Qesj1_Vsi_s_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Ve_si));
  Qesj1_Vsi_s_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Ve_di));
  Qesj1_Vsi_s_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vge_si));
  Qesj1_Vsi_s_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBS_t*Czbs)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qesj1_Tempt_GND=((((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4+T5))+((PBS_t*Czbs)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qesj1_Tempt_GND_Vdi_d=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qesj1_Tempt_GND_Vsi_s=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qesj1_Tempt_GND_Tempt_GND=(+(+PBS_t_Tempt_GND_Tempt_GND*Czbs+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t_Tempt_GND*Czbs_Tempt_GND+PBS_t*Czbs_Tempt_GND_Tempt_GND)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qesj1_Tempt_GND_Vge_di=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qesj1_Tempt_GND_Vge_e=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qesj1_Tempt_GND_Ve_si=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qesj1_Tempt_GND_Ve_di=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qesj1_Tempt_GND_Vge_si=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qesj1_Tempt_GND_Vdi_si=(+(+0.0*Czbs+PBS_t_Tempt_GND*0.0+0.0*Czbs_Tempt_GND+PBS_t*0.0)*(T4+T5)+((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBS_t*Czbs)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qesj1_Vge_di=((PBS_t*Czbs)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qesj1_Vge_di_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+0.0+T5_Vge_di_Vdi_d));
  Qesj1_Vge_di_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+0.0+T5_Vge_di_Vsi_s));
  Qesj1_Vge_di_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qesj1_Vge_di_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qesj1_Vge_di_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qesj1_Vge_di_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qesj1_Vge_di_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qesj1_Vge_di_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qesj1_Vge_di_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBS_t*Czbs)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qesj1_Vge_e=((PBS_t*Czbs)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qesj1_Vge_e_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+0.0+T5_Vge_e_Vdi_d));
  Qesj1_Vge_e_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+0.0+T5_Vge_e_Vsi_s));
  Qesj1_Vge_e_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qesj1_Vge_e_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qesj1_Vge_e_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qesj1_Vge_e_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qesj1_Vge_e_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qesj1_Vge_e_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qesj1_Vge_e_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBS_t*Czbs)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qesj1_Ve_si=((PBS_t*Czbs)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qesj1_Ve_si_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+0.0+T5_Ve_si_Vdi_d));
  Qesj1_Ve_si_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+0.0+T5_Ve_si_Vsi_s));
  Qesj1_Ve_si_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qesj1_Ve_si_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qesj1_Ve_si_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qesj1_Ve_si_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qesj1_Ve_si_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qesj1_Ve_si_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qesj1_Ve_si_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBS_t*Czbs)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qesj1_Ve_di=((PBS_t*Czbs)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qesj1_Ve_di_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+0.0+T5_Ve_di_Vdi_d));
  Qesj1_Ve_di_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+0.0+T5_Ve_di_Vsi_s));
  Qesj1_Ve_di_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qesj1_Ve_di_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qesj1_Ve_di_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qesj1_Ve_di_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qesj1_Ve_di_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qesj1_Ve_di_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qesj1_Ve_di_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBS_t*Czbs)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qesj1_Vge_si=((PBS_t*Czbs)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qesj1_Vge_si_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+0.0+T5_Vge_si_Vdi_d));
  Qesj1_Vge_si_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+0.0+T5_Vge_si_Vsi_s));
  Qesj1_Vge_si_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qesj1_Vge_si_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qesj1_Vge_si_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qesj1_Vge_si_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qesj1_Vge_si_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qesj1_Vge_si_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qesj1_Vge_si_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBS_t*Czbs)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qesj1_Vdi_si=((PBS_t*Czbs)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qesj1_Vdi_si_Vdi_d=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+0.0+T5_Vdi_si_Vdi_d));
  Qesj1_Vdi_si_Vsi_s=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+0.0+T5_Vdi_si_Vsi_s));
  Qesj1_Vdi_si_Tempt_GND=(+(+0.0*Czbs+0.0*Czbs_Tempt_GND+PBS_t_Tempt_GND*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBS_t_Tempt_GND*Czbs)+(PBS_t*Czbs_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qesj1_Vdi_si_Vge_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qesj1_Vdi_si_Vge_e=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qesj1_Vdi_si_Ve_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qesj1_Vdi_si_Ve_di=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qesj1_Vdi_si_Vge_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qesj1_Vdi_si_Vdi_si=(+(+0.0*Czbs+0.0*0.0+0.0*0.0+PBS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBS_t*Czbs)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qesj1=((PBS_t*Czbs)*(T4+T5));
EXIT_IF_ISNAN(((PBS_t*Czbs)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vdi_d_Vdi_d=0.0;
  Qesj1_Vdi_d_Vsi_s=0.0;
  Qesj1_Vdi_d_Tempt_GND=0.0;
  Qesj1_Vdi_d_Vge_di=0.0;
  Qesj1_Vdi_d_Vge_e=0.0;
  Qesj1_Vdi_d_Ve_si=0.0;
  Qesj1_Vdi_d_Ve_di=0.0;
  Qesj1_Vdi_d_Vge_si=0.0;
  Qesj1_Vdi_d_Vdi_si=0.0;
#endif
Qesj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vsi_s_Vdi_d=0.0;
  Qesj1_Vsi_s_Vsi_s=0.0;
  Qesj1_Vsi_s_Tempt_GND=0.0;
  Qesj1_Vsi_s_Vge_di=0.0;
  Qesj1_Vsi_s_Vge_e=0.0;
  Qesj1_Vsi_s_Ve_si=0.0;
  Qesj1_Vsi_s_Ve_di=0.0;
  Qesj1_Vsi_s_Vge_si=0.0;
  Qesj1_Vsi_s_Vdi_si=0.0;
#endif
Qesj1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qesj1_Tempt_GND_Vdi_d=0.0;
  Qesj1_Tempt_GND_Vsi_s=0.0;
  Qesj1_Tempt_GND_Tempt_GND=0.0;
  Qesj1_Tempt_GND_Vge_di=0.0;
  Qesj1_Tempt_GND_Vge_e=0.0;
  Qesj1_Tempt_GND_Ve_si=0.0;
  Qesj1_Tempt_GND_Ve_di=0.0;
  Qesj1_Tempt_GND_Vge_si=0.0;
  Qesj1_Tempt_GND_Vdi_si=0.0;
#endif
Qesj1_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vge_di_Vdi_d=0.0;
  Qesj1_Vge_di_Vsi_s=0.0;
  Qesj1_Vge_di_Tempt_GND=0.0;
  Qesj1_Vge_di_Vge_di=0.0;
  Qesj1_Vge_di_Vge_e=0.0;
  Qesj1_Vge_di_Ve_si=0.0;
  Qesj1_Vge_di_Ve_di=0.0;
  Qesj1_Vge_di_Vge_si=0.0;
  Qesj1_Vge_di_Vdi_si=0.0;
#endif
Qesj1_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vge_e_Vdi_d=0.0;
  Qesj1_Vge_e_Vsi_s=0.0;
  Qesj1_Vge_e_Tempt_GND=0.0;
  Qesj1_Vge_e_Vge_di=0.0;
  Qesj1_Vge_e_Vge_e=0.0;
  Qesj1_Vge_e_Ve_si=0.0;
  Qesj1_Vge_e_Ve_di=0.0;
  Qesj1_Vge_e_Vge_si=0.0;
  Qesj1_Vge_e_Vdi_si=0.0;
#endif
Qesj1_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qesj1_Ve_si_Vdi_d=0.0;
  Qesj1_Ve_si_Vsi_s=0.0;
  Qesj1_Ve_si_Tempt_GND=0.0;
  Qesj1_Ve_si_Vge_di=0.0;
  Qesj1_Ve_si_Vge_e=0.0;
  Qesj1_Ve_si_Ve_si=0.0;
  Qesj1_Ve_si_Ve_di=0.0;
  Qesj1_Ve_si_Vge_si=0.0;
  Qesj1_Ve_si_Vdi_si=0.0;
#endif
Qesj1_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qesj1_Ve_di_Vdi_d=0.0;
  Qesj1_Ve_di_Vsi_s=0.0;
  Qesj1_Ve_di_Tempt_GND=0.0;
  Qesj1_Ve_di_Vge_di=0.0;
  Qesj1_Ve_di_Vge_e=0.0;
  Qesj1_Ve_di_Ve_si=0.0;
  Qesj1_Ve_di_Ve_di=0.0;
  Qesj1_Ve_di_Vge_si=0.0;
  Qesj1_Ve_di_Vdi_si=0.0;
#endif
Qesj1_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vge_si_Vdi_d=0.0;
  Qesj1_Vge_si_Vsi_s=0.0;
  Qesj1_Vge_si_Tempt_GND=0.0;
  Qesj1_Vge_si_Vge_di=0.0;
  Qesj1_Vge_si_Vge_e=0.0;
  Qesj1_Vge_si_Ve_si=0.0;
  Qesj1_Vge_si_Ve_di=0.0;
  Qesj1_Vge_si_Vge_si=0.0;
  Qesj1_Vge_si_Vdi_si=0.0;
#endif
Qesj1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qesj1_Vdi_si_Vdi_d=0.0;
  Qesj1_Vdi_si_Vsi_s=0.0;
  Qesj1_Vdi_si_Tempt_GND=0.0;
  Qesj1_Vdi_si_Vge_di=0.0;
  Qesj1_Vdi_si_Vge_e=0.0;
  Qesj1_Vdi_si_Ve_si=0.0;
  Qesj1_Vdi_si_Ve_di=0.0;
  Qesj1_Vdi_si_Vge_si=0.0;
  Qesj1_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qesj1=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
{
if
((Czbssw>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(ves_jct_Ve_si/PBSWS_t);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Vsi_s=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Vge_di=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Vge_e=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Ve_si=(ves_jct_Ve_si_Ve_si/PBSWS_t-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Ve_di=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Vge_si=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Vdi_si=(0.0/PBSWS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Ve_si_Tempt_GND=(0.0/PBSWS_t-(ves_jct_Ve_si*PBSWS_t_Tempt_GND+0.0*0.0+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*0.0*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t/PBSWS_t);
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ves_jct*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Vge_di=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Vge_e=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Ve_si=(0.0/PBSWS_t-(0.0*0.0+ves_jct_Ve_si*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Ve_di=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Vge_si=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBSWS_t-(0.0*0.0+0.0*PBSWS_t_Tempt_GND+ves_jct*0.0)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBSWS_t-(0.0*PBSWS_t_Tempt_GND+0.0*PBSWS_t_Tempt_GND+ves_jct*PBSWS_t_Tempt_GND_Tempt_GND)/PBSWS_t/PBSWS_t+2*ves_jct*PBSWS_t_Tempt_GND*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t/PBSWS_t);
#endif
#endif
T1=(ves_jct/PBSWS_t);
EXIT_IF_ISNAN((ves_jct/PBSWS_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJSWS>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBSWS_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))))))+(PBSWS_t*(-bsimcmg_d_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))),((1.0/pModel->MJSWS)*bsimcmg_d_lln((1.0/pModel->SJSWS),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBSWS_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS)))))+PBSWS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))),((1.0/pModel->MJSWS)*bsimcmg_d_lln((1.0/pModel->SJSWS),0.0))))+PBSWS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))),((1.0/pModel->MJSWS)*bsimcmg_d_lln((1.0/pModel->SJSWS),0.0))))+PBSWS_t*(+0.0-(+(0.0/pModel->MJSWS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJSWS/pModel->MJSWS+2*1.0*0.0*0.0/pModel->MJSWS/pModel->MJSWS/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))+0.0*bsimcmg_d_lln((1.0/pModel->SJSWS),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJSWS),0.0)+(1.0/pModel->MJSWS)*(0.0/pModel->SJSWS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJSWS/pModel->SJSWS+2*1.0*0.0*0.0/pModel->SJSWS/pModel->SJSWS/pModel->SJSWS))));
#endif
#endif
vec=(PBSWS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS))))));
EXIT_IF_ISNAN((PBSWS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWS)*bsimcmg_lln((1.0/pModel->SJSWS)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBSWS_t_Tempt_GND*pModel->SJSWS*pModel->MJSWS2/pModel->MJSWS)*bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))-(((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))),((-(1.0+pModel->MJSWS))*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBSWS_t_Tempt_GND_Tempt_GND*pModel->SJSWS+PBSWS_t_Tempt_GND*0.0+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*pModel->MJSWS2+PBSWS_t_Tempt_GND*pModel->SJSWS*0.0+(PBSWS_t_Tempt_GND*pModel->SJSWS)*0.0+(PBSWS_t*pModel->SJSWS)*0.0)/pModel->MJSWS-(PBSWS_t_Tempt_GND*pModel->SJSWS*pModel->MJSWS2*0.0+((PBSWS_t_Tempt_GND*pModel->SJSWS)*pModel->MJSWS2)*0.0+((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)*0.0)/pModel->MJSWS/pModel->MJSWS+2*((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)*0.0*0.0/pModel->MJSWS/pModel->MJSWS/pModel->MJSWS)/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))-((PBSWS_t_Tempt_GND*pModel->SJSWS*pModel->MJSWS2/pModel->MJSWS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))),((-(1.0+pModel->MJSWS))*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))))+(((PBSWS_t_Tempt_GND*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))),((-(1.0+pModel->MJSWS))*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))))+(((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)*(+0.0*bsimcmg_lln((1.0-(vec/PBSWS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))+(-(1.0+pModel->MJSWS))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWS_t-(vec_Tempt_GND*PBSWS_t_Tempt_GND+vec_Tempt_GND*PBSWS_t_Tempt_GND+vec*PBSWS_t_Tempt_GND_Tempt_GND)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t/PBSWS_t))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))+2*(((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))),((-(1.0+pModel->MJSWS))*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))),((-(1.0+pModel->MJSWS))*bsimcmg_d_lln((1.0-(vec/PBSWS_t)),(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t))))));
#endif
#endif
pb2=((((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t))))));
EXIT_IF_ISNAN(((((PBSWS_t*pModel->SJSWS)*pModel->MJSWS2)/pModel->MJSWS)/bsimcmg_lexp(((-(1.0+pModel->MJSWS))*bsimcmg_lln((1.0-(vec/PBSWS_t)))))))
#endif
#ifdef _DYNAMIC
if
((ves_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vdi_d_Vdi_d=0.0;
  Qesj2_Vdi_d_Vsi_s=0.0;
  Qesj2_Vdi_d_Tempt_GND=0.0;
  Qesj2_Vdi_d_Vge_di=0.0;
  Qesj2_Vdi_d_Vge_e=0.0;
  Qesj2_Vdi_d_Ve_si=0.0;
  Qesj2_Vdi_d_Ve_di=0.0;
  Qesj2_Vdi_d_Vge_si=0.0;
  Qesj2_Vdi_d_Vdi_si=0.0;
#endif
Qesj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vsi_s_Vdi_d=0.0;
  Qesj2_Vsi_s_Vsi_s=0.0;
  Qesj2_Vsi_s_Tempt_GND=0.0;
  Qesj2_Vsi_s_Vge_di=0.0;
  Qesj2_Vsi_s_Vge_e=0.0;
  Qesj2_Vsi_s_Ve_si=0.0;
  Qesj2_Vsi_s_Ve_di=0.0;
  Qesj2_Vsi_s_Vge_si=0.0;
  Qesj2_Vsi_s_Vdi_si=0.0;
#endif
Qesj2_Tempt_GND=(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Tempt_GND_Vdi_d=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vsi_s=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Tempt_GND=((+(+PBSWS_t_Tempt_GND_Tempt_GND*Czbssw+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t*Czbssw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_e=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Ve_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Ve_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vdi_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_di=(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_di_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_e=(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_e_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Ve_si=(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Ve_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Ve_di=(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Ve_di_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_si=(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vdi_si=(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vdi_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
#endif
Qesj2=(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS));
EXIT_IF_ISNAN((((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBSWS_t-vec*PBSWS_t_Tempt_GND)/PBSWS_t/PBSWS_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBSWS_t-(vec_Tempt_GND*0.0+0.0*PBSWS_t_Tempt_GND+vec*0.0)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*0.0/PBSWS_t/PBSWS_t/PBSWS_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWS_t-(vec_Tempt_GND*PBSWS_t_Tempt_GND+vec_Tempt_GND*PBSWS_t_Tempt_GND+vec*PBSWS_t_Tempt_GND_Tempt_GND)/PBSWS_t/PBSWS_t+2*vec*PBSWS_t_Tempt_GND*PBSWS_t_Tempt_GND/PBSWS_t/PBSWS_t/PBSWS_t));
#endif
#endif
arg=(1.0-(vec/PBSWS_t));
EXIT_IF_ISNAN((1.0-(vec/PBSWS_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBSWS_t_Tempt_GND_Tempt_GND*Czbssw+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t*Czbssw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Vge_di=(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Vge_e=(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Ve_si=(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Ve_di=(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Vge_si=(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qec_Vdi_si=(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
#endif
Qec=(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS));
EXIT_IF_ISNAN((((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=(-(ves_jct_Ve_si/pb2));
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_si=(+0.0-((+ves_jct_Ve_si_Ve_si-0.0)/pb2-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ves_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ves_jct_Ve_si*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ves_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ves_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ves_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWS2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)),((-pModel->MJSWS2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWS2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vdi_d_Vdi_d=0.0;
  Qesj2_Vdi_d_Vsi_s=0.0;
  Qesj2_Vdi_d_Tempt_GND=0.0;
  Qesj2_Vdi_d_Vge_di=0.0;
  Qesj2_Vdi_d_Vge_e=0.0;
  Qesj2_Vdi_d_Ve_si=0.0;
  Qesj2_Vdi_d_Ve_di=0.0;
  Qesj2_Vdi_d_Vge_si=0.0;
  Qesj2_Vdi_d_Vdi_si=0.0;
#endif
Qesj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vsi_s_Vdi_d=0.0;
  Qesj2_Vsi_s_Vsi_s=0.0;
  Qesj2_Vsi_s_Tempt_GND=0.0;
  Qesj2_Vsi_s_Vge_di=0.0;
  Qesj2_Vsi_s_Vge_e=0.0;
  Qesj2_Vsi_s_Ve_si=0.0;
  Qesj2_Vsi_s_Ve_di=0.0;
  Qesj2_Vsi_s_Vge_si=0.0;
  Qesj2_Vsi_s_Vdi_si=0.0;
#endif
Qesj2_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(0.0))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(0.0))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJSWS*pb2_Tempt_GND_Tempt_GND)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*Czbssw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWS*0.0)*Czbssw+(pModel->SJSWS*pb2_Tempt_GND)*0.0+(0.0)*Czbssw_Tempt_GND+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWS2)-((((((pModel->SJSWS*pb2_Tempt_GND)*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Vge_di=(Qec_Vge_di+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Vge_e=(Qec_Vge_e+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Ve_si=(Qec_Ve_si+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Ve_di=(Qec_Ve_di+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Vge_si=(Qec_Vge_si+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
Qesj2_Vdi_si=(Qec_Vdi_si+((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWS2)));
#if defined(_DERIVATE2)
  Qesj2_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(0.0)))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*Czbssw_Tempt_GND+((pModel->SJSWS*pb2_Tempt_GND))*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJSWS*pb2_Tempt_GND))*Czbssw)+((pModel->SJSWS*pb2)*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
  Qesj2_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWS*0.0)*Czbssw+0.0*0.0+(0.0)*0.0+(pModel->SJSWS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWS*pb2)*Czbssw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWS2)-((((pModel->SJSWS*pb2)*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbssw)*(1.0-(arg*sarg)))+(((pModel->SJSWS*pb2)*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)+2*(((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)/(1.0-pModel->MJSWS2)));
#endif
#endif
Qesj2=(Qec+((((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJSWS*pb2)*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)),((-pModel->MJSWS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vdi_d_Vdi_d=0.0;
  Qesj2_Vdi_d_Vsi_s=0.0;
  Qesj2_Vdi_d_Tempt_GND=0.0;
  Qesj2_Vdi_d_Vge_di=0.0;
  Qesj2_Vdi_d_Vge_e=0.0;
  Qesj2_Vdi_d_Ve_si=0.0;
  Qesj2_Vdi_d_Ve_di=0.0;
  Qesj2_Vdi_d_Vge_si=0.0;
  Qesj2_Vdi_d_Vdi_si=0.0;
#endif
Qesj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vsi_s_Vdi_d=0.0;
  Qesj2_Vsi_s_Vsi_s=0.0;
  Qesj2_Vsi_s_Tempt_GND=0.0;
  Qesj2_Vsi_s_Vge_di=0.0;
  Qesj2_Vsi_s_Vge_e=0.0;
  Qesj2_Vsi_s_Ve_si=0.0;
  Qesj2_Vsi_s_Ve_di=0.0;
  Qesj2_Vsi_s_Vge_si=0.0;
  Qesj2_Vsi_s_Vdi_si=0.0;
#endif
Qesj2_Tempt_GND=(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Tempt_GND_Vdi_d=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vsi_s=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Tempt_GND=((+(+PBSWS_t_Tempt_GND_Tempt_GND*Czbssw+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t*Czbssw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_e=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Ve_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Ve_di=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vge_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Tempt_GND_Vdi_si=((+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(1.0-(arg*sarg))+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWS)-(((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_di=(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_di_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_e=(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_e_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_e_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Ve_si=(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Ve_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Ve_di=(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Ve_di_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Ve_di_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vge_si=(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vge_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vge_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
Qesj2_Vdi_si=(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWS));
#if defined(_DERIVATE2)
  Qesj2_Vdi_si_Vdi_d=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vsi_s=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(0.0)))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Tempt_GND=((+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_e=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Ve_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Ve_di=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vge_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
  Qesj2_Vdi_si_Vdi_si=((+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWS_t*Czbssw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWS)-(((PBSWS_t*Czbssw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWS_t*Czbssw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)+2*((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS)/(1.0-pModel->MJSWS));
#endif
#endif
Qesj2=(((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS));
EXIT_IF_ISNAN((((PBSWS_t*Czbssw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWS)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWS)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJSWS));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJSWS)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJSWS)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJSWS)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWS)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJSWS)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJSWS)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJSWS)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWS)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWS)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJSWS)*(T1-1.0))+(1.0+pModel->MJSWS))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_e+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Vdi_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Ve_di+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Vge_si+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)))+(T3*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWS))*T2)+(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWS))*T2_Tempt_GND+((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJSWS)*(1.0+pModel->MJSWS))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj2_Vdi_d=((PBSWS_t*Czbssw)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qesj2_Vdi_d_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vdi_d));
  Qesj2_Vdi_d_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vsi_s));
  Qesj2_Vdi_d_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qesj2_Vdi_d_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vge_di));
  Qesj2_Vdi_d_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vge_e));
  Qesj2_Vdi_d_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Ve_si));
  Qesj2_Vdi_d_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Ve_di));
  Qesj2_Vdi_d_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vge_si));
  Qesj2_Vdi_d_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qesj2_Vsi_s=((PBSWS_t*Czbssw)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qesj2_Vsi_s_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vdi_d));
  Qesj2_Vsi_s_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vsi_s));
  Qesj2_Vsi_s_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qesj2_Vsi_s_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vge_di));
  Qesj2_Vsi_s_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vge_e));
  Qesj2_Vsi_s_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Ve_si));
  Qesj2_Vsi_s_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Ve_di));
  Qesj2_Vsi_s_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vge_si));
  Qesj2_Vsi_s_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBSWS_t*Czbssw)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qesj2_Tempt_GND=((((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4+T5))+((PBSWS_t*Czbssw)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qesj2_Tempt_GND_Vdi_d=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qesj2_Tempt_GND_Vsi_s=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qesj2_Tempt_GND_Tempt_GND=(+(+PBSWS_t_Tempt_GND_Tempt_GND*Czbssw+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*Czbssw_Tempt_GND+PBSWS_t*Czbssw_Tempt_GND_Tempt_GND)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qesj2_Tempt_GND_Vge_di=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qesj2_Tempt_GND_Vge_e=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qesj2_Tempt_GND_Ve_si=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qesj2_Tempt_GND_Ve_di=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qesj2_Tempt_GND_Vge_si=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qesj2_Tempt_GND_Vdi_si=(+(+0.0*Czbssw+PBSWS_t_Tempt_GND*0.0+0.0*Czbssw_Tempt_GND+PBSWS_t*0.0)*(T4+T5)+((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWS_t*Czbssw)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qesj2_Vge_di=((PBSWS_t*Czbssw)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qesj2_Vge_di_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_di_Vdi_d));
  Qesj2_Vge_di_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_di_Vsi_s));
  Qesj2_Vge_di_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qesj2_Vge_di_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qesj2_Vge_di_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qesj2_Vge_di_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qesj2_Vge_di_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qesj2_Vge_di_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qesj2_Vge_di_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWS_t*Czbssw)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qesj2_Vge_e=((PBSWS_t*Czbssw)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qesj2_Vge_e_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_e_Vdi_d));
  Qesj2_Vge_e_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_e_Vsi_s));
  Qesj2_Vge_e_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qesj2_Vge_e_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qesj2_Vge_e_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qesj2_Vge_e_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qesj2_Vge_e_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qesj2_Vge_e_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qesj2_Vge_e_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWS_t*Czbssw)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qesj2_Ve_si=((PBSWS_t*Czbssw)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qesj2_Ve_si_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Ve_si_Vdi_d));
  Qesj2_Ve_si_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Ve_si_Vsi_s));
  Qesj2_Ve_si_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qesj2_Ve_si_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qesj2_Ve_si_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qesj2_Ve_si_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qesj2_Ve_si_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qesj2_Ve_si_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qesj2_Ve_si_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWS_t*Czbssw)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qesj2_Ve_di=((PBSWS_t*Czbssw)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qesj2_Ve_di_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+0.0+T5_Ve_di_Vdi_d));
  Qesj2_Ve_di_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+0.0+T5_Ve_di_Vsi_s));
  Qesj2_Ve_di_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qesj2_Ve_di_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qesj2_Ve_di_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qesj2_Ve_di_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qesj2_Ve_di_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qesj2_Ve_di_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qesj2_Ve_di_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWS_t*Czbssw)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qesj2_Vge_si=((PBSWS_t*Czbssw)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qesj2_Vge_si_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_si_Vdi_d));
  Qesj2_Vge_si_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Vge_si_Vsi_s));
  Qesj2_Vge_si_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qesj2_Vge_si_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qesj2_Vge_si_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qesj2_Vge_si_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qesj2_Vge_si_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qesj2_Vge_si_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qesj2_Vge_si_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWS_t*Czbssw)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qesj2_Vdi_si=((PBSWS_t*Czbssw)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qesj2_Vdi_si_Vdi_d=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_si_Vdi_d));
  Qesj2_Vdi_si_Vsi_s=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+0.0+T5_Vdi_si_Vsi_s));
  Qesj2_Vdi_si_Tempt_GND=(+(+0.0*Czbssw+0.0*Czbssw_Tempt_GND+PBSWS_t_Tempt_GND*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWS_t_Tempt_GND*Czbssw)+(PBSWS_t*Czbssw_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qesj2_Vdi_si_Vge_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qesj2_Vdi_si_Vge_e=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qesj2_Vdi_si_Ve_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qesj2_Vdi_si_Ve_di=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qesj2_Vdi_si_Vge_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qesj2_Vdi_si_Vdi_si=(+(+0.0*Czbssw+0.0*0.0+0.0*0.0+PBSWS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWS_t*Czbssw)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qesj2=((PBSWS_t*Czbssw)*(T4+T5));
EXIT_IF_ISNAN(((PBSWS_t*Czbssw)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vdi_d_Vdi_d=0.0;
  Qesj2_Vdi_d_Vsi_s=0.0;
  Qesj2_Vdi_d_Tempt_GND=0.0;
  Qesj2_Vdi_d_Vge_di=0.0;
  Qesj2_Vdi_d_Vge_e=0.0;
  Qesj2_Vdi_d_Ve_si=0.0;
  Qesj2_Vdi_d_Ve_di=0.0;
  Qesj2_Vdi_d_Vge_si=0.0;
  Qesj2_Vdi_d_Vdi_si=0.0;
#endif
Qesj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vsi_s_Vdi_d=0.0;
  Qesj2_Vsi_s_Vsi_s=0.0;
  Qesj2_Vsi_s_Tempt_GND=0.0;
  Qesj2_Vsi_s_Vge_di=0.0;
  Qesj2_Vsi_s_Vge_e=0.0;
  Qesj2_Vsi_s_Ve_si=0.0;
  Qesj2_Vsi_s_Ve_di=0.0;
  Qesj2_Vsi_s_Vge_si=0.0;
  Qesj2_Vsi_s_Vdi_si=0.0;
#endif
Qesj2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qesj2_Tempt_GND_Vdi_d=0.0;
  Qesj2_Tempt_GND_Vsi_s=0.0;
  Qesj2_Tempt_GND_Tempt_GND=0.0;
  Qesj2_Tempt_GND_Vge_di=0.0;
  Qesj2_Tempt_GND_Vge_e=0.0;
  Qesj2_Tempt_GND_Ve_si=0.0;
  Qesj2_Tempt_GND_Ve_di=0.0;
  Qesj2_Tempt_GND_Vge_si=0.0;
  Qesj2_Tempt_GND_Vdi_si=0.0;
#endif
Qesj2_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vge_di_Vdi_d=0.0;
  Qesj2_Vge_di_Vsi_s=0.0;
  Qesj2_Vge_di_Tempt_GND=0.0;
  Qesj2_Vge_di_Vge_di=0.0;
  Qesj2_Vge_di_Vge_e=0.0;
  Qesj2_Vge_di_Ve_si=0.0;
  Qesj2_Vge_di_Ve_di=0.0;
  Qesj2_Vge_di_Vge_si=0.0;
  Qesj2_Vge_di_Vdi_si=0.0;
#endif
Qesj2_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vge_e_Vdi_d=0.0;
  Qesj2_Vge_e_Vsi_s=0.0;
  Qesj2_Vge_e_Tempt_GND=0.0;
  Qesj2_Vge_e_Vge_di=0.0;
  Qesj2_Vge_e_Vge_e=0.0;
  Qesj2_Vge_e_Ve_si=0.0;
  Qesj2_Vge_e_Ve_di=0.0;
  Qesj2_Vge_e_Vge_si=0.0;
  Qesj2_Vge_e_Vdi_si=0.0;
#endif
Qesj2_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qesj2_Ve_si_Vdi_d=0.0;
  Qesj2_Ve_si_Vsi_s=0.0;
  Qesj2_Ve_si_Tempt_GND=0.0;
  Qesj2_Ve_si_Vge_di=0.0;
  Qesj2_Ve_si_Vge_e=0.0;
  Qesj2_Ve_si_Ve_si=0.0;
  Qesj2_Ve_si_Ve_di=0.0;
  Qesj2_Ve_si_Vge_si=0.0;
  Qesj2_Ve_si_Vdi_si=0.0;
#endif
Qesj2_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qesj2_Ve_di_Vdi_d=0.0;
  Qesj2_Ve_di_Vsi_s=0.0;
  Qesj2_Ve_di_Tempt_GND=0.0;
  Qesj2_Ve_di_Vge_di=0.0;
  Qesj2_Ve_di_Vge_e=0.0;
  Qesj2_Ve_di_Ve_si=0.0;
  Qesj2_Ve_di_Ve_di=0.0;
  Qesj2_Ve_di_Vge_si=0.0;
  Qesj2_Ve_di_Vdi_si=0.0;
#endif
Qesj2_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vge_si_Vdi_d=0.0;
  Qesj2_Vge_si_Vsi_s=0.0;
  Qesj2_Vge_si_Tempt_GND=0.0;
  Qesj2_Vge_si_Vge_di=0.0;
  Qesj2_Vge_si_Vge_e=0.0;
  Qesj2_Vge_si_Ve_si=0.0;
  Qesj2_Vge_si_Ve_di=0.0;
  Qesj2_Vge_si_Vge_si=0.0;
  Qesj2_Vge_si_Vdi_si=0.0;
#endif
Qesj2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qesj2_Vdi_si_Vdi_d=0.0;
  Qesj2_Vdi_si_Vsi_s=0.0;
  Qesj2_Vdi_si_Tempt_GND=0.0;
  Qesj2_Vdi_si_Vge_di=0.0;
  Qesj2_Vdi_si_Vge_e=0.0;
  Qesj2_Vdi_si_Ve_si=0.0;
  Qesj2_Vdi_si_Ve_di=0.0;
  Qesj2_Vdi_si_Vge_si=0.0;
  Qesj2_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qesj2=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
{
if
((Czbsswg>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=(ves_jct_Ve_si/PBSWGS_t);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Vsi_s=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Vge_di=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Vge_e=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Ve_si=(ves_jct_Ve_si_Ve_si/PBSWGS_t-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Ve_di=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Vge_si=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Vdi_si=(0.0/PBSWGS_t-(ves_jct_Ve_si*0.0+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Ve_si_Tempt_GND=(0.0/PBSWGS_t-(ves_jct_Ve_si*PBSWGS_t_Tempt_GND+0.0*0.0+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*0.0*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t/PBSWGS_t);
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ves_jct*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Vge_di=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Vge_e=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Ve_si=(0.0/PBSWGS_t-(0.0*0.0+ves_jct_Ve_si*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Ve_di=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Vge_si=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBSWGS_t-(0.0*0.0+0.0*PBSWGS_t_Tempt_GND+ves_jct*0.0)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBSWGS_t-(0.0*PBSWGS_t_Tempt_GND+0.0*PBSWGS_t_Tempt_GND+ves_jct*PBSWGS_t_Tempt_GND_Tempt_GND)/PBSWGS_t/PBSWGS_t+2*ves_jct*PBSWGS_t_Tempt_GND*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t/PBSWGS_t);
#endif
#endif
T1=(ves_jct/PBSWGS_t);
EXIT_IF_ISNAN((ves_jct/PBSWGS_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJSWGS>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBSWGS_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))))))+(PBSWGS_t*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))),((1.0/pModel->MJSWGS)*bsimcmg_d_lln((1.0/pModel->SJSWGS),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBSWGS_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS)))))+PBSWGS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))),((1.0/pModel->MJSWGS)*bsimcmg_d_lln((1.0/pModel->SJSWGS),0.0))))+PBSWGS_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))),((1.0/pModel->MJSWGS)*bsimcmg_d_lln((1.0/pModel->SJSWGS),0.0))))+PBSWGS_t*(+0.0-(+(0.0/pModel->MJSWGS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJSWGS/pModel->MJSWGS+2*1.0*0.0*0.0/pModel->MJSWGS/pModel->MJSWGS/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))+0.0*bsimcmg_d_lln((1.0/pModel->SJSWGS),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJSWGS),0.0)+(1.0/pModel->MJSWGS)*(0.0/pModel->SJSWGS-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJSWGS/pModel->SJSWGS+2*1.0*0.0*0.0/pModel->SJSWGS/pModel->SJSWGS/pModel->SJSWGS))));
#endif
#endif
vec=(PBSWGS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS))))));
EXIT_IF_ISNAN((PBSWGS_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGS)*bsimcmg_lln((1.0/pModel->SJSWGS)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBSWGS_t_Tempt_GND*pModel->SJSWGS*pModel->MJSWGS2/pModel->MJSWGS)*bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))-(((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))),((-(1.0+pModel->MJSWGS))*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBSWGS_t_Tempt_GND_Tempt_GND*pModel->SJSWGS+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*pModel->MJSWGS2+PBSWGS_t_Tempt_GND*pModel->SJSWGS*0.0+(PBSWGS_t_Tempt_GND*pModel->SJSWGS)*0.0+(PBSWGS_t*pModel->SJSWGS)*0.0)/pModel->MJSWGS-(PBSWGS_t_Tempt_GND*pModel->SJSWGS*pModel->MJSWGS2*0.0+((PBSWGS_t_Tempt_GND*pModel->SJSWGS)*pModel->MJSWGS2)*0.0+((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)*0.0)/pModel->MJSWGS/pModel->MJSWGS+2*((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)*0.0*0.0/pModel->MJSWGS/pModel->MJSWGS/pModel->MJSWGS)/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))-((PBSWGS_t_Tempt_GND*pModel->SJSWGS*pModel->MJSWGS2/pModel->MJSWGS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))),((-(1.0+pModel->MJSWGS))*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))))+(((PBSWGS_t_Tempt_GND*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))),((-(1.0+pModel->MJSWGS))*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))))+(((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)*(+0.0*bsimcmg_lln((1.0-(vec/PBSWGS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))+(-(1.0+pModel->MJSWGS))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWGS_t-(vec_Tempt_GND*PBSWGS_t_Tempt_GND+vec_Tempt_GND*PBSWGS_t_Tempt_GND+vec*PBSWGS_t_Tempt_GND_Tempt_GND)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t/PBSWGS_t))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))+2*(((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))),((-(1.0+pModel->MJSWGS))*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))),((-(1.0+pModel->MJSWGS))*bsimcmg_d_lln((1.0-(vec/PBSWGS_t)),(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t))))));
#endif
#endif
pb2=((((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t))))));
EXIT_IF_ISNAN(((((PBSWGS_t*pModel->SJSWGS)*pModel->MJSWGS2)/pModel->MJSWGS)/bsimcmg_lexp(((-(1.0+pModel->MJSWGS))*bsimcmg_lln((1.0-(vec/PBSWGS_t)))))))
#endif
#ifdef _DYNAMIC
if
((ves_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vdi_d_Vdi_d=0.0;
  Qesj3_Vdi_d_Vsi_s=0.0;
  Qesj3_Vdi_d_Tempt_GND=0.0;
  Qesj3_Vdi_d_Vge_di=0.0;
  Qesj3_Vdi_d_Vge_e=0.0;
  Qesj3_Vdi_d_Ve_si=0.0;
  Qesj3_Vdi_d_Ve_di=0.0;
  Qesj3_Vdi_d_Vge_si=0.0;
  Qesj3_Vdi_d_Vdi_si=0.0;
#endif
Qesj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vsi_s_Vdi_d=0.0;
  Qesj3_Vsi_s_Vsi_s=0.0;
  Qesj3_Vsi_s_Tempt_GND=0.0;
  Qesj3_Vsi_s_Vge_di=0.0;
  Qesj3_Vsi_s_Vge_e=0.0;
  Qesj3_Vsi_s_Ve_si=0.0;
  Qesj3_Vsi_s_Ve_di=0.0;
  Qesj3_Vsi_s_Vge_si=0.0;
  Qesj3_Vsi_s_Vdi_si=0.0;
#endif
Qesj3_Tempt_GND=(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Tempt_GND_Vdi_d=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vsi_s=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Tempt_GND=((+(+PBSWGS_t_Tempt_GND_Tempt_GND*Czbsswg+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t*Czbsswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_e=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Ve_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Ve_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vdi_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_di=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_di_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_e=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_e_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Ve_si=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Ve_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Ve_di=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Ve_di_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vdi_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vdi_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
#endif
Qesj3=(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS));
EXIT_IF_ISNAN((((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBSWGS_t-vec*PBSWGS_t_Tempt_GND)/PBSWGS_t/PBSWGS_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBSWGS_t-(vec_Tempt_GND*0.0+0.0*PBSWGS_t_Tempt_GND+vec*0.0)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*0.0/PBSWGS_t/PBSWGS_t/PBSWGS_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWGS_t-(vec_Tempt_GND*PBSWGS_t_Tempt_GND+vec_Tempt_GND*PBSWGS_t_Tempt_GND+vec*PBSWGS_t_Tempt_GND_Tempt_GND)/PBSWGS_t/PBSWGS_t+2*vec*PBSWGS_t_Tempt_GND*PBSWGS_t_Tempt_GND/PBSWGS_t/PBSWGS_t/PBSWGS_t));
#endif
#endif
arg=(1.0-(vec/PBSWGS_t));
EXIT_IF_ISNAN((1.0-(vec/PBSWGS_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBSWGS_t_Tempt_GND_Tempt_GND*Czbsswg+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t*Czbsswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Vge_di=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Vge_e=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Ve_si=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Ve_di=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Vge_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qec_Vdi_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
#endif
Qec=(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS));
EXIT_IF_ISNAN((((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=(-(ves_jct_Ve_si/pb2));
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_si=(+0.0-((+ves_jct_Ve_si_Ve_si-0.0)/pb2-(ves_jct_Ve_si*0.0+ves_jct_Ve_si*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Ve_di=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*0.0+0.0*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_si_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ves_jct_Ve_si*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ves_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ves_jct_Ve_si*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ves_jct-vec)*0.0)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ves_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ves_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ves_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ves_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGS2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)),((-pModel->MJSWGS2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGS2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vdi_d_Vdi_d=0.0;
  Qesj3_Vdi_d_Vsi_s=0.0;
  Qesj3_Vdi_d_Tempt_GND=0.0;
  Qesj3_Vdi_d_Vge_di=0.0;
  Qesj3_Vdi_d_Vge_e=0.0;
  Qesj3_Vdi_d_Ve_si=0.0;
  Qesj3_Vdi_d_Ve_di=0.0;
  Qesj3_Vdi_d_Vge_si=0.0;
  Qesj3_Vdi_d_Vdi_si=0.0;
#endif
Qesj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vsi_s_Vdi_d=0.0;
  Qesj3_Vsi_s_Vsi_s=0.0;
  Qesj3_Vsi_s_Tempt_GND=0.0;
  Qesj3_Vsi_s_Vge_di=0.0;
  Qesj3_Vsi_s_Vge_e=0.0;
  Qesj3_Vsi_s_Ve_si=0.0;
  Qesj3_Vsi_s_Ve_di=0.0;
  Qesj3_Vsi_s_Vge_si=0.0;
  Qesj3_Vsi_s_Vdi_si=0.0;
#endif
Qesj3_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJSWGS*pb2_Tempt_GND_Tempt_GND)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGS*0.0)*Czbsswg+(pModel->SJSWGS*pb2_Tempt_GND)*0.0+(0.0)*Czbsswg_Tempt_GND+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((((pModel->SJSWGS*pb2_Tempt_GND)*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Vge_di=(Qec_Vge_di+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Vge_e=(Qec_Vge_e+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Ve_si=(Qec_Ve_si+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Ve_di=(Qec_Ve_di+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Vge_si=(Qec_Vge_si+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
Qesj3_Vdi_si=(Qec_Vdi_si+((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGS2)));
#if defined(_DERIVATE2)
  Qesj3_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(0.0)))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*Czbsswg_Tempt_GND+((pModel->SJSWGS*pb2_Tempt_GND))*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJSWGS*pb2_Tempt_GND))*Czbsswg)+((pModel->SJSWGS*pb2)*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
  Qesj3_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGS*0.0)*Czbsswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGS*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGS*pb2)*Czbsswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGS2)-((((pModel->SJSWGS*pb2)*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbsswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGS*pb2)*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)+2*(((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)/(1.0-pModel->MJSWGS2)));
#endif
#endif
Qesj3=(Qec+((((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJSWGS*pb2)*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGS==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGS)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGS)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGS)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGS)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGS)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGS)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)),((-pModel->MJSWGS)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGS)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vdi_d_Vdi_d=0.0;
  Qesj3_Vdi_d_Vsi_s=0.0;
  Qesj3_Vdi_d_Tempt_GND=0.0;
  Qesj3_Vdi_d_Vge_di=0.0;
  Qesj3_Vdi_d_Vge_e=0.0;
  Qesj3_Vdi_d_Ve_si=0.0;
  Qesj3_Vdi_d_Ve_di=0.0;
  Qesj3_Vdi_d_Vge_si=0.0;
  Qesj3_Vdi_d_Vdi_si=0.0;
#endif
Qesj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vsi_s_Vdi_d=0.0;
  Qesj3_Vsi_s_Vsi_s=0.0;
  Qesj3_Vsi_s_Tempt_GND=0.0;
  Qesj3_Vsi_s_Vge_di=0.0;
  Qesj3_Vsi_s_Vge_e=0.0;
  Qesj3_Vsi_s_Ve_si=0.0;
  Qesj3_Vsi_s_Ve_di=0.0;
  Qesj3_Vsi_s_Vge_si=0.0;
  Qesj3_Vsi_s_Vdi_si=0.0;
#endif
Qesj3_Tempt_GND=(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Tempt_GND_Vdi_d=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vsi_s=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Tempt_GND=((+(+PBSWGS_t_Tempt_GND_Tempt_GND*Czbsswg+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t*Czbsswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_e=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Ve_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Ve_di=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vge_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Tempt_GND_Vdi_si=((+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(1.0-(arg*sarg))+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGS)-(((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_di=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_di_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_e=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_e_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_e_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Ve_si=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Ve_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Ve_di=(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Ve_di_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Ve_di_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vge_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vge_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vge_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
Qesj3_Vdi_si=(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGS));
#if defined(_DERIVATE2)
  Qesj3_Vdi_si_Vdi_d=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vsi_s=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(0.0)))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Tempt_GND=((+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_e=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Ve_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Ve_di=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vge_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
  Qesj3_Vdi_si_Vdi_si=((+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGS_t*Czbsswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGS)-(((PBSWGS_t*Czbsswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGS_t*Czbsswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)+2*((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS)/(1.0-pModel->MJSWGS));
#endif
#endif
Qesj3=(((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS));
EXIT_IF_ISNAN((((PBSWGS_t*Czbsswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGS)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGS)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJSWGS));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJSWGS)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGS)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGS)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGS)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGS)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGS)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGS)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGS)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGS)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGS)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJSWGS)*(T1-1.0))+(1.0+pModel->MJSWGS))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_e+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Vdi_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Ve_di+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Vge_si+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)))+(T3*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGS))*T2)+(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGS+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGS)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGS)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGS))*T2_Tempt_GND+((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJSWGS)*(1.0+pModel->MJSWGS))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj3_Vdi_d=((PBSWGS_t*Czbsswg)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qesj3_Vdi_d_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vdi_d));
  Qesj3_Vdi_d_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vsi_s));
  Qesj3_Vdi_d_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qesj3_Vdi_d_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vge_di));
  Qesj3_Vdi_d_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vge_e));
  Qesj3_Vdi_d_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Ve_si));
  Qesj3_Vdi_d_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Ve_di));
  Qesj3_Vdi_d_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vge_si));
  Qesj3_Vdi_d_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qesj3_Vsi_s=((PBSWGS_t*Czbsswg)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qesj3_Vsi_s_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vdi_d));
  Qesj3_Vsi_s_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vsi_s));
  Qesj3_Vsi_s_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qesj3_Vsi_s_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vge_di));
  Qesj3_Vsi_s_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vge_e));
  Qesj3_Vsi_s_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Ve_si));
  Qesj3_Vsi_s_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Ve_di));
  Qesj3_Vsi_s_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vge_si));
  Qesj3_Vsi_s_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qesj3_Tempt_GND=((((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4+T5))+((PBSWGS_t*Czbsswg)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qesj3_Tempt_GND_Vdi_d=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qesj3_Tempt_GND_Vsi_s=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qesj3_Tempt_GND_Tempt_GND=(+(+PBSWGS_t_Tempt_GND_Tempt_GND*Czbsswg+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*Czbsswg_Tempt_GND+PBSWGS_t*Czbsswg_Tempt_GND_Tempt_GND)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qesj3_Tempt_GND_Vge_di=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qesj3_Tempt_GND_Vge_e=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qesj3_Tempt_GND_Ve_si=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qesj3_Tempt_GND_Ve_di=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qesj3_Tempt_GND_Vge_si=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qesj3_Tempt_GND_Vdi_si=(+(+0.0*Czbsswg+PBSWGS_t_Tempt_GND*0.0+0.0*Czbsswg_Tempt_GND+PBSWGS_t*0.0)*(T4+T5)+((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGS_t*Czbsswg)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qesj3_Vge_di=((PBSWGS_t*Czbsswg)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qesj3_Vge_di_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_di_Vdi_d));
  Qesj3_Vge_di_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_di_Vsi_s));
  Qesj3_Vge_di_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qesj3_Vge_di_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qesj3_Vge_di_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qesj3_Vge_di_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qesj3_Vge_di_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qesj3_Vge_di_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qesj3_Vge_di_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGS_t*Czbsswg)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qesj3_Vge_e=((PBSWGS_t*Czbsswg)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qesj3_Vge_e_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_e_Vdi_d));
  Qesj3_Vge_e_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_e_Vsi_s));
  Qesj3_Vge_e_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qesj3_Vge_e_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qesj3_Vge_e_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qesj3_Vge_e_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qesj3_Vge_e_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qesj3_Vge_e_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qesj3_Vge_e_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGS_t*Czbsswg)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qesj3_Ve_si=((PBSWGS_t*Czbsswg)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qesj3_Ve_si_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Ve_si_Vdi_d));
  Qesj3_Ve_si_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Ve_si_Vsi_s));
  Qesj3_Ve_si_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qesj3_Ve_si_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qesj3_Ve_si_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qesj3_Ve_si_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qesj3_Ve_si_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qesj3_Ve_si_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qesj3_Ve_si_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGS_t*Czbsswg)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qesj3_Ve_di=((PBSWGS_t*Czbsswg)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qesj3_Ve_di_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Ve_di_Vdi_d));
  Qesj3_Ve_di_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Ve_di_Vsi_s));
  Qesj3_Ve_di_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qesj3_Ve_di_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qesj3_Ve_di_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qesj3_Ve_di_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qesj3_Ve_di_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qesj3_Ve_di_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qesj3_Ve_di_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGS_t*Czbsswg)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qesj3_Vge_si=((PBSWGS_t*Czbsswg)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qesj3_Vge_si_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_si_Vdi_d));
  Qesj3_Vge_si_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vge_si_Vsi_s));
  Qesj3_Vge_si_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qesj3_Vge_si_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qesj3_Vge_si_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qesj3_Vge_si_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qesj3_Vge_si_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qesj3_Vge_si_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qesj3_Vge_si_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGS_t*Czbsswg)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qesj3_Vdi_si=((PBSWGS_t*Czbsswg)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qesj3_Vdi_si_Vdi_d=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_si_Vdi_d));
  Qesj3_Vdi_si_Vsi_s=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+0.0+T5_Vdi_si_Vsi_s));
  Qesj3_Vdi_si_Tempt_GND=(+(+0.0*Czbsswg+0.0*Czbsswg_Tempt_GND+PBSWGS_t_Tempt_GND*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGS_t_Tempt_GND*Czbsswg)+(PBSWGS_t*Czbsswg_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qesj3_Vdi_si_Vge_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qesj3_Vdi_si_Vge_e=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qesj3_Vdi_si_Ve_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qesj3_Vdi_si_Ve_di=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qesj3_Vdi_si_Vge_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qesj3_Vdi_si_Vdi_si=(+(+0.0*Czbsswg+0.0*0.0+0.0*0.0+PBSWGS_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGS_t*Czbsswg)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qesj3=((PBSWGS_t*Czbsswg)*(T4+T5));
EXIT_IF_ISNAN(((PBSWGS_t*Czbsswg)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qesj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vdi_d_Vdi_d=0.0;
  Qesj3_Vdi_d_Vsi_s=0.0;
  Qesj3_Vdi_d_Tempt_GND=0.0;
  Qesj3_Vdi_d_Vge_di=0.0;
  Qesj3_Vdi_d_Vge_e=0.0;
  Qesj3_Vdi_d_Ve_si=0.0;
  Qesj3_Vdi_d_Ve_di=0.0;
  Qesj3_Vdi_d_Vge_si=0.0;
  Qesj3_Vdi_d_Vdi_si=0.0;
#endif
Qesj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vsi_s_Vdi_d=0.0;
  Qesj3_Vsi_s_Vsi_s=0.0;
  Qesj3_Vsi_s_Tempt_GND=0.0;
  Qesj3_Vsi_s_Vge_di=0.0;
  Qesj3_Vsi_s_Vge_e=0.0;
  Qesj3_Vsi_s_Ve_si=0.0;
  Qesj3_Vsi_s_Ve_di=0.0;
  Qesj3_Vsi_s_Vge_si=0.0;
  Qesj3_Vsi_s_Vdi_si=0.0;
#endif
Qesj3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qesj3_Tempt_GND_Vdi_d=0.0;
  Qesj3_Tempt_GND_Vsi_s=0.0;
  Qesj3_Tempt_GND_Tempt_GND=0.0;
  Qesj3_Tempt_GND_Vge_di=0.0;
  Qesj3_Tempt_GND_Vge_e=0.0;
  Qesj3_Tempt_GND_Ve_si=0.0;
  Qesj3_Tempt_GND_Ve_di=0.0;
  Qesj3_Tempt_GND_Vge_si=0.0;
  Qesj3_Tempt_GND_Vdi_si=0.0;
#endif
Qesj3_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vge_di_Vdi_d=0.0;
  Qesj3_Vge_di_Vsi_s=0.0;
  Qesj3_Vge_di_Tempt_GND=0.0;
  Qesj3_Vge_di_Vge_di=0.0;
  Qesj3_Vge_di_Vge_e=0.0;
  Qesj3_Vge_di_Ve_si=0.0;
  Qesj3_Vge_di_Ve_di=0.0;
  Qesj3_Vge_di_Vge_si=0.0;
  Qesj3_Vge_di_Vdi_si=0.0;
#endif
Qesj3_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vge_e_Vdi_d=0.0;
  Qesj3_Vge_e_Vsi_s=0.0;
  Qesj3_Vge_e_Tempt_GND=0.0;
  Qesj3_Vge_e_Vge_di=0.0;
  Qesj3_Vge_e_Vge_e=0.0;
  Qesj3_Vge_e_Ve_si=0.0;
  Qesj3_Vge_e_Ve_di=0.0;
  Qesj3_Vge_e_Vge_si=0.0;
  Qesj3_Vge_e_Vdi_si=0.0;
#endif
Qesj3_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qesj3_Ve_si_Vdi_d=0.0;
  Qesj3_Ve_si_Vsi_s=0.0;
  Qesj3_Ve_si_Tempt_GND=0.0;
  Qesj3_Ve_si_Vge_di=0.0;
  Qesj3_Ve_si_Vge_e=0.0;
  Qesj3_Ve_si_Ve_si=0.0;
  Qesj3_Ve_si_Ve_di=0.0;
  Qesj3_Ve_si_Vge_si=0.0;
  Qesj3_Ve_si_Vdi_si=0.0;
#endif
Qesj3_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qesj3_Ve_di_Vdi_d=0.0;
  Qesj3_Ve_di_Vsi_s=0.0;
  Qesj3_Ve_di_Tempt_GND=0.0;
  Qesj3_Ve_di_Vge_di=0.0;
  Qesj3_Ve_di_Vge_e=0.0;
  Qesj3_Ve_di_Ve_si=0.0;
  Qesj3_Ve_di_Ve_di=0.0;
  Qesj3_Ve_di_Vge_si=0.0;
  Qesj3_Ve_di_Vdi_si=0.0;
#endif
Qesj3_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vge_si_Vdi_d=0.0;
  Qesj3_Vge_si_Vsi_s=0.0;
  Qesj3_Vge_si_Tempt_GND=0.0;
  Qesj3_Vge_si_Vge_di=0.0;
  Qesj3_Vge_si_Vge_e=0.0;
  Qesj3_Vge_si_Ve_si=0.0;
  Qesj3_Vge_si_Ve_di=0.0;
  Qesj3_Vge_si_Vge_si=0.0;
  Qesj3_Vge_si_Vdi_si=0.0;
#endif
Qesj3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qesj3_Vdi_si_Vdi_d=0.0;
  Qesj3_Vdi_si_Vsi_s=0.0;
  Qesj3_Vdi_si_Tempt_GND=0.0;
  Qesj3_Vdi_si_Vge_di=0.0;
  Qesj3_Vdi_si_Vge_e=0.0;
  Qesj3_Vdi_si_Ve_si=0.0;
  Qesj3_Vdi_si_Ve_di=0.0;
  Qesj3_Vdi_si_Vge_si=0.0;
  Qesj3_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qesj3=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(si,GND)V(e,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
Qesj_Vdi_d=((Qesj1_Vdi_d+Qesj2_Vdi_d)+Qesj3_Vdi_d);
#if defined(_DERIVATE2)
  Qesj_Vdi_d_Vdi_d=(+(+Qesj1_Vdi_d_Vdi_d+Qesj2_Vdi_d_Vdi_d)+Qesj3_Vdi_d_Vdi_d);
  Qesj_Vdi_d_Vsi_s=(+(+Qesj1_Vdi_d_Vsi_s+Qesj2_Vdi_d_Vsi_s)+Qesj3_Vdi_d_Vsi_s);
  Qesj_Vdi_d_Tempt_GND=(+(+Qesj1_Vdi_d_Tempt_GND+Qesj2_Vdi_d_Tempt_GND)+Qesj3_Vdi_d_Tempt_GND);
  Qesj_Vdi_d_Vge_di=(+(+Qesj1_Vdi_d_Vge_di+Qesj2_Vdi_d_Vge_di)+Qesj3_Vdi_d_Vge_di);
  Qesj_Vdi_d_Vge_e=(+(+Qesj1_Vdi_d_Vge_e+Qesj2_Vdi_d_Vge_e)+Qesj3_Vdi_d_Vge_e);
  Qesj_Vdi_d_Ve_si=(+(+Qesj1_Vdi_d_Ve_si+Qesj2_Vdi_d_Ve_si)+Qesj3_Vdi_d_Ve_si);
  Qesj_Vdi_d_Ve_di=(+(+Qesj1_Vdi_d_Ve_di+Qesj2_Vdi_d_Ve_di)+Qesj3_Vdi_d_Ve_di);
  Qesj_Vdi_d_Vge_si=(+(+Qesj1_Vdi_d_Vge_si+Qesj2_Vdi_d_Vge_si)+Qesj3_Vdi_d_Vge_si);
  Qesj_Vdi_d_Vdi_si=(+(+Qesj1_Vdi_d_Vdi_si+Qesj2_Vdi_d_Vdi_si)+Qesj3_Vdi_d_Vdi_si);
#endif
Qesj_Vsi_s=((Qesj1_Vsi_s+Qesj2_Vsi_s)+Qesj3_Vsi_s);
#if defined(_DERIVATE2)
  Qesj_Vsi_s_Vdi_d=(+(+Qesj1_Vsi_s_Vdi_d+Qesj2_Vsi_s_Vdi_d)+Qesj3_Vsi_s_Vdi_d);
  Qesj_Vsi_s_Vsi_s=(+(+Qesj1_Vsi_s_Vsi_s+Qesj2_Vsi_s_Vsi_s)+Qesj3_Vsi_s_Vsi_s);
  Qesj_Vsi_s_Tempt_GND=(+(+Qesj1_Vsi_s_Tempt_GND+Qesj2_Vsi_s_Tempt_GND)+Qesj3_Vsi_s_Tempt_GND);
  Qesj_Vsi_s_Vge_di=(+(+Qesj1_Vsi_s_Vge_di+Qesj2_Vsi_s_Vge_di)+Qesj3_Vsi_s_Vge_di);
  Qesj_Vsi_s_Vge_e=(+(+Qesj1_Vsi_s_Vge_e+Qesj2_Vsi_s_Vge_e)+Qesj3_Vsi_s_Vge_e);
  Qesj_Vsi_s_Ve_si=(+(+Qesj1_Vsi_s_Ve_si+Qesj2_Vsi_s_Ve_si)+Qesj3_Vsi_s_Ve_si);
  Qesj_Vsi_s_Ve_di=(+(+Qesj1_Vsi_s_Ve_di+Qesj2_Vsi_s_Ve_di)+Qesj3_Vsi_s_Ve_di);
  Qesj_Vsi_s_Vge_si=(+(+Qesj1_Vsi_s_Vge_si+Qesj2_Vsi_s_Vge_si)+Qesj3_Vsi_s_Vge_si);
  Qesj_Vsi_s_Vdi_si=(+(+Qesj1_Vsi_s_Vdi_si+Qesj2_Vsi_s_Vdi_si)+Qesj3_Vsi_s_Vdi_si);
#endif
Qesj_Tempt_GND=((Qesj1_Tempt_GND+Qesj2_Tempt_GND)+Qesj3_Tempt_GND);
#if defined(_DERIVATE2)
  Qesj_Tempt_GND_Vdi_d=(+(+Qesj1_Tempt_GND_Vdi_d+Qesj2_Tempt_GND_Vdi_d)+Qesj3_Tempt_GND_Vdi_d);
  Qesj_Tempt_GND_Vsi_s=(+(+Qesj1_Tempt_GND_Vsi_s+Qesj2_Tempt_GND_Vsi_s)+Qesj3_Tempt_GND_Vsi_s);
  Qesj_Tempt_GND_Tempt_GND=(+(+Qesj1_Tempt_GND_Tempt_GND+Qesj2_Tempt_GND_Tempt_GND)+Qesj3_Tempt_GND_Tempt_GND);
  Qesj_Tempt_GND_Vge_di=(+(+Qesj1_Tempt_GND_Vge_di+Qesj2_Tempt_GND_Vge_di)+Qesj3_Tempt_GND_Vge_di);
  Qesj_Tempt_GND_Vge_e=(+(+Qesj1_Tempt_GND_Vge_e+Qesj2_Tempt_GND_Vge_e)+Qesj3_Tempt_GND_Vge_e);
  Qesj_Tempt_GND_Ve_si=(+(+Qesj1_Tempt_GND_Ve_si+Qesj2_Tempt_GND_Ve_si)+Qesj3_Tempt_GND_Ve_si);
  Qesj_Tempt_GND_Ve_di=(+(+Qesj1_Tempt_GND_Ve_di+Qesj2_Tempt_GND_Ve_di)+Qesj3_Tempt_GND_Ve_di);
  Qesj_Tempt_GND_Vge_si=(+(+Qesj1_Tempt_GND_Vge_si+Qesj2_Tempt_GND_Vge_si)+Qesj3_Tempt_GND_Vge_si);
  Qesj_Tempt_GND_Vdi_si=(+(+Qesj1_Tempt_GND_Vdi_si+Qesj2_Tempt_GND_Vdi_si)+Qesj3_Tempt_GND_Vdi_si);
#endif
Qesj_Vge_di=((Qesj1_Vge_di+Qesj2_Vge_di)+Qesj3_Vge_di);
#if defined(_DERIVATE2)
  Qesj_Vge_di_Vdi_d=(+(+Qesj1_Vge_di_Vdi_d+Qesj2_Vge_di_Vdi_d)+Qesj3_Vge_di_Vdi_d);
  Qesj_Vge_di_Vsi_s=(+(+Qesj1_Vge_di_Vsi_s+Qesj2_Vge_di_Vsi_s)+Qesj3_Vge_di_Vsi_s);
  Qesj_Vge_di_Tempt_GND=(+(+Qesj1_Vge_di_Tempt_GND+Qesj2_Vge_di_Tempt_GND)+Qesj3_Vge_di_Tempt_GND);
  Qesj_Vge_di_Vge_di=(+(+Qesj1_Vge_di_Vge_di+Qesj2_Vge_di_Vge_di)+Qesj3_Vge_di_Vge_di);
  Qesj_Vge_di_Vge_e=(+(+Qesj1_Vge_di_Vge_e+Qesj2_Vge_di_Vge_e)+Qesj3_Vge_di_Vge_e);
  Qesj_Vge_di_Ve_si=(+(+Qesj1_Vge_di_Ve_si+Qesj2_Vge_di_Ve_si)+Qesj3_Vge_di_Ve_si);
  Qesj_Vge_di_Ve_di=(+(+Qesj1_Vge_di_Ve_di+Qesj2_Vge_di_Ve_di)+Qesj3_Vge_di_Ve_di);
  Qesj_Vge_di_Vge_si=(+(+Qesj1_Vge_di_Vge_si+Qesj2_Vge_di_Vge_si)+Qesj3_Vge_di_Vge_si);
  Qesj_Vge_di_Vdi_si=(+(+Qesj1_Vge_di_Vdi_si+Qesj2_Vge_di_Vdi_si)+Qesj3_Vge_di_Vdi_si);
#endif
Qesj_Vge_e=((Qesj1_Vge_e+Qesj2_Vge_e)+Qesj3_Vge_e);
#if defined(_DERIVATE2)
  Qesj_Vge_e_Vdi_d=(+(+Qesj1_Vge_e_Vdi_d+Qesj2_Vge_e_Vdi_d)+Qesj3_Vge_e_Vdi_d);
  Qesj_Vge_e_Vsi_s=(+(+Qesj1_Vge_e_Vsi_s+Qesj2_Vge_e_Vsi_s)+Qesj3_Vge_e_Vsi_s);
  Qesj_Vge_e_Tempt_GND=(+(+Qesj1_Vge_e_Tempt_GND+Qesj2_Vge_e_Tempt_GND)+Qesj3_Vge_e_Tempt_GND);
  Qesj_Vge_e_Vge_di=(+(+Qesj1_Vge_e_Vge_di+Qesj2_Vge_e_Vge_di)+Qesj3_Vge_e_Vge_di);
  Qesj_Vge_e_Vge_e=(+(+Qesj1_Vge_e_Vge_e+Qesj2_Vge_e_Vge_e)+Qesj3_Vge_e_Vge_e);
  Qesj_Vge_e_Ve_si=(+(+Qesj1_Vge_e_Ve_si+Qesj2_Vge_e_Ve_si)+Qesj3_Vge_e_Ve_si);
  Qesj_Vge_e_Ve_di=(+(+Qesj1_Vge_e_Ve_di+Qesj2_Vge_e_Ve_di)+Qesj3_Vge_e_Ve_di);
  Qesj_Vge_e_Vge_si=(+(+Qesj1_Vge_e_Vge_si+Qesj2_Vge_e_Vge_si)+Qesj3_Vge_e_Vge_si);
  Qesj_Vge_e_Vdi_si=(+(+Qesj1_Vge_e_Vdi_si+Qesj2_Vge_e_Vdi_si)+Qesj3_Vge_e_Vdi_si);
#endif
Qesj_Ve_si=((Qesj1_Ve_si+Qesj2_Ve_si)+Qesj3_Ve_si);
#if defined(_DERIVATE2)
  Qesj_Ve_si_Vdi_d=(+(+Qesj1_Ve_si_Vdi_d+Qesj2_Ve_si_Vdi_d)+Qesj3_Ve_si_Vdi_d);
  Qesj_Ve_si_Vsi_s=(+(+Qesj1_Ve_si_Vsi_s+Qesj2_Ve_si_Vsi_s)+Qesj3_Ve_si_Vsi_s);
  Qesj_Ve_si_Tempt_GND=(+(+Qesj1_Ve_si_Tempt_GND+Qesj2_Ve_si_Tempt_GND)+Qesj3_Ve_si_Tempt_GND);
  Qesj_Ve_si_Vge_di=(+(+Qesj1_Ve_si_Vge_di+Qesj2_Ve_si_Vge_di)+Qesj3_Ve_si_Vge_di);
  Qesj_Ve_si_Vge_e=(+(+Qesj1_Ve_si_Vge_e+Qesj2_Ve_si_Vge_e)+Qesj3_Ve_si_Vge_e);
  Qesj_Ve_si_Ve_si=(+(+Qesj1_Ve_si_Ve_si+Qesj2_Ve_si_Ve_si)+Qesj3_Ve_si_Ve_si);
  Qesj_Ve_si_Ve_di=(+(+Qesj1_Ve_si_Ve_di+Qesj2_Ve_si_Ve_di)+Qesj3_Ve_si_Ve_di);
  Qesj_Ve_si_Vge_si=(+(+Qesj1_Ve_si_Vge_si+Qesj2_Ve_si_Vge_si)+Qesj3_Ve_si_Vge_si);
  Qesj_Ve_si_Vdi_si=(+(+Qesj1_Ve_si_Vdi_si+Qesj2_Ve_si_Vdi_si)+Qesj3_Ve_si_Vdi_si);
#endif
Qesj_Ve_di=((Qesj1_Ve_di+Qesj2_Ve_di)+Qesj3_Ve_di);
#if defined(_DERIVATE2)
  Qesj_Ve_di_Vdi_d=(+(+Qesj1_Ve_di_Vdi_d+Qesj2_Ve_di_Vdi_d)+Qesj3_Ve_di_Vdi_d);
  Qesj_Ve_di_Vsi_s=(+(+Qesj1_Ve_di_Vsi_s+Qesj2_Ve_di_Vsi_s)+Qesj3_Ve_di_Vsi_s);
  Qesj_Ve_di_Tempt_GND=(+(+Qesj1_Ve_di_Tempt_GND+Qesj2_Ve_di_Tempt_GND)+Qesj3_Ve_di_Tempt_GND);
  Qesj_Ve_di_Vge_di=(+(+Qesj1_Ve_di_Vge_di+Qesj2_Ve_di_Vge_di)+Qesj3_Ve_di_Vge_di);
  Qesj_Ve_di_Vge_e=(+(+Qesj1_Ve_di_Vge_e+Qesj2_Ve_di_Vge_e)+Qesj3_Ve_di_Vge_e);
  Qesj_Ve_di_Ve_si=(+(+Qesj1_Ve_di_Ve_si+Qesj2_Ve_di_Ve_si)+Qesj3_Ve_di_Ve_si);
  Qesj_Ve_di_Ve_di=(+(+Qesj1_Ve_di_Ve_di+Qesj2_Ve_di_Ve_di)+Qesj3_Ve_di_Ve_di);
  Qesj_Ve_di_Vge_si=(+(+Qesj1_Ve_di_Vge_si+Qesj2_Ve_di_Vge_si)+Qesj3_Ve_di_Vge_si);
  Qesj_Ve_di_Vdi_si=(+(+Qesj1_Ve_di_Vdi_si+Qesj2_Ve_di_Vdi_si)+Qesj3_Ve_di_Vdi_si);
#endif
Qesj_Vge_si=((Qesj1_Vge_si+Qesj2_Vge_si)+Qesj3_Vge_si);
#if defined(_DERIVATE2)
  Qesj_Vge_si_Vdi_d=(+(+Qesj1_Vge_si_Vdi_d+Qesj2_Vge_si_Vdi_d)+Qesj3_Vge_si_Vdi_d);
  Qesj_Vge_si_Vsi_s=(+(+Qesj1_Vge_si_Vsi_s+Qesj2_Vge_si_Vsi_s)+Qesj3_Vge_si_Vsi_s);
  Qesj_Vge_si_Tempt_GND=(+(+Qesj1_Vge_si_Tempt_GND+Qesj2_Vge_si_Tempt_GND)+Qesj3_Vge_si_Tempt_GND);
  Qesj_Vge_si_Vge_di=(+(+Qesj1_Vge_si_Vge_di+Qesj2_Vge_si_Vge_di)+Qesj3_Vge_si_Vge_di);
  Qesj_Vge_si_Vge_e=(+(+Qesj1_Vge_si_Vge_e+Qesj2_Vge_si_Vge_e)+Qesj3_Vge_si_Vge_e);
  Qesj_Vge_si_Ve_si=(+(+Qesj1_Vge_si_Ve_si+Qesj2_Vge_si_Ve_si)+Qesj3_Vge_si_Ve_si);
  Qesj_Vge_si_Ve_di=(+(+Qesj1_Vge_si_Ve_di+Qesj2_Vge_si_Ve_di)+Qesj3_Vge_si_Ve_di);
  Qesj_Vge_si_Vge_si=(+(+Qesj1_Vge_si_Vge_si+Qesj2_Vge_si_Vge_si)+Qesj3_Vge_si_Vge_si);
  Qesj_Vge_si_Vdi_si=(+(+Qesj1_Vge_si_Vdi_si+Qesj2_Vge_si_Vdi_si)+Qesj3_Vge_si_Vdi_si);
#endif
Qesj_Vdi_si=((Qesj1_Vdi_si+Qesj2_Vdi_si)+Qesj3_Vdi_si);
#if defined(_DERIVATE2)
  Qesj_Vdi_si_Vdi_d=(+(+Qesj1_Vdi_si_Vdi_d+Qesj2_Vdi_si_Vdi_d)+Qesj3_Vdi_si_Vdi_d);
  Qesj_Vdi_si_Vsi_s=(+(+Qesj1_Vdi_si_Vsi_s+Qesj2_Vdi_si_Vsi_s)+Qesj3_Vdi_si_Vsi_s);
  Qesj_Vdi_si_Tempt_GND=(+(+Qesj1_Vdi_si_Tempt_GND+Qesj2_Vdi_si_Tempt_GND)+Qesj3_Vdi_si_Tempt_GND);
  Qesj_Vdi_si_Vge_di=(+(+Qesj1_Vdi_si_Vge_di+Qesj2_Vdi_si_Vge_di)+Qesj3_Vdi_si_Vge_di);
  Qesj_Vdi_si_Vge_e=(+(+Qesj1_Vdi_si_Vge_e+Qesj2_Vdi_si_Vge_e)+Qesj3_Vdi_si_Vge_e);
  Qesj_Vdi_si_Ve_si=(+(+Qesj1_Vdi_si_Ve_si+Qesj2_Vdi_si_Ve_si)+Qesj3_Vdi_si_Ve_si);
  Qesj_Vdi_si_Ve_di=(+(+Qesj1_Vdi_si_Ve_di+Qesj2_Vdi_si_Ve_di)+Qesj3_Vdi_si_Ve_di);
  Qesj_Vdi_si_Vge_si=(+(+Qesj1_Vdi_si_Vge_si+Qesj2_Vdi_si_Vge_si)+Qesj3_Vdi_si_Vge_si);
  Qesj_Vdi_si_Vdi_si=(+(+Qesj1_Vdi_si_Vdi_si+Qesj2_Vdi_si_Vdi_si)+Qesj3_Vdi_si_Vdi_si);
#endif
#endif
Qesj=((Qesj1+Qesj2)+Qesj3);
EXIT_IF_ISNAN(((Qesj1+Qesj2)+Qesj3))
#endif
{
if
((Czbd>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=(ved_jct_Ve_di/PBD_t);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Vsi_s=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Vge_di=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Vge_e=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Ve_si=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Ve_di=(ved_jct_Ve_di_Ve_di/PBD_t-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Vge_si=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Vdi_si=(0.0/PBD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*0.0/PBD_t/PBD_t/PBD_t);
  T1_Ve_di_Tempt_GND=(0.0/PBD_t-(ved_jct_Ve_di*PBD_t_Tempt_GND+0.0*0.0+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*0.0*PBD_t_Tempt_GND/PBD_t/PBD_t/PBD_t);
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ved_jct*PBD_t_Tempt_GND/PBD_t/PBD_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Vge_di=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Vge_e=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Ve_si=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Ve_di=(0.0/PBD_t-(0.0*0.0+ved_jct_Ve_di*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Vge_si=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBD_t-(0.0*0.0+0.0*PBD_t_Tempt_GND+ved_jct*0.0)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBD_t-(0.0*PBD_t_Tempt_GND+0.0*PBD_t_Tempt_GND+ved_jct*PBD_t_Tempt_GND_Tempt_GND)/PBD_t/PBD_t+2*ved_jct*PBD_t_Tempt_GND*PBD_t_Tempt_GND/PBD_t/PBD_t/PBD_t);
#endif
#endif
T1=(ved_jct/PBD_t);
EXIT_IF_ISNAN((ved_jct/PBD_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJD>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBD_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))))))+(PBD_t*(-bsimcmg_d_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))),((1.0/pModel->MJD)*bsimcmg_d_lln((1.0/pModel->SJD),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBD_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD)))))+PBD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))),((1.0/pModel->MJD)*bsimcmg_d_lln((1.0/pModel->SJD),0.0))))+PBD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))),((1.0/pModel->MJD)*bsimcmg_d_lln((1.0/pModel->SJD),0.0))))+PBD_t*(+0.0-(+(0.0/pModel->MJD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJD/pModel->MJD+2*1.0*0.0*0.0/pModel->MJD/pModel->MJD/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))+0.0*bsimcmg_d_lln((1.0/pModel->SJD),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJD),0.0)+(1.0/pModel->MJD)*(0.0/pModel->SJD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJD/pModel->SJD+2*1.0*0.0*0.0/pModel->SJD/pModel->SJD/pModel->SJD))));
#endif
#endif
vec=(PBD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD))))));
EXIT_IF_ISNAN((PBD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJD)*bsimcmg_lln((1.0/pModel->SJD)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBD_t_Tempt_GND*pModel->SJD*pModel->MJD2/pModel->MJD)*bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))-(((PBD_t*pModel->SJD)*pModel->MJD2)/pModel->MJD)*bsimcmg_d_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))),((-(1.0+pModel->MJD))*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBD_t_Tempt_GND_Tempt_GND*pModel->SJD+PBD_t_Tempt_GND*0.0+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*pModel->MJD2+PBD_t_Tempt_GND*pModel->SJD*0.0+(PBD_t_Tempt_GND*pModel->SJD)*0.0+(PBD_t*pModel->SJD)*0.0)/pModel->MJD-(PBD_t_Tempt_GND*pModel->SJD*pModel->MJD2*0.0+((PBD_t_Tempt_GND*pModel->SJD)*pModel->MJD2)*0.0+((PBD_t*pModel->SJD)*pModel->MJD2)*0.0)/pModel->MJD/pModel->MJD+2*((PBD_t*pModel->SJD)*pModel->MJD2)*0.0*0.0/pModel->MJD/pModel->MJD/pModel->MJD)/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))-((PBD_t_Tempt_GND*pModel->SJD*pModel->MJD2/pModel->MJD)*bsimcmg_d_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))),((-(1.0+pModel->MJD))*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))))+(((PBD_t_Tempt_GND*pModel->SJD)*pModel->MJD2)/pModel->MJD)*bsimcmg_d_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))),((-(1.0+pModel->MJD))*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))))+(((PBD_t*pModel->SJD)*pModel->MJD2)/pModel->MJD)*(+0.0*bsimcmg_lln((1.0-(vec/PBD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))+(-(1.0+pModel->MJD))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBD_t-(vec_Tempt_GND*PBD_t_Tempt_GND+vec_Tempt_GND*PBD_t_Tempt_GND+vec*PBD_t_Tempt_GND_Tempt_GND)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*PBD_t_Tempt_GND/PBD_t/PBD_t/PBD_t))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))+2*(((PBD_t*pModel->SJD)*pModel->MJD2)/pModel->MJD)*bsimcmg_d_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))),((-(1.0+pModel->MJD))*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))),((-(1.0+pModel->MJD))*bsimcmg_d_lln((1.0-(vec/PBD_t)),(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t))))));
#endif
#endif
pb2=((((PBD_t*pModel->SJD)*pModel->MJD2)/pModel->MJD)/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t))))));
EXIT_IF_ISNAN(((((PBD_t*pModel->SJD)*pModel->MJD2)/pModel->MJD)/bsimcmg_lexp(((-(1.0+pModel->MJD))*bsimcmg_lln((1.0-(vec/PBD_t)))))))
#endif
#ifdef _DYNAMIC
if
((ved_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vdi_d_Vdi_d=0.0;
  Qedj1_Vdi_d_Vsi_s=0.0;
  Qedj1_Vdi_d_Tempt_GND=0.0;
  Qedj1_Vdi_d_Vge_di=0.0;
  Qedj1_Vdi_d_Vge_e=0.0;
  Qedj1_Vdi_d_Ve_si=0.0;
  Qedj1_Vdi_d_Ve_di=0.0;
  Qedj1_Vdi_d_Vge_si=0.0;
  Qedj1_Vdi_d_Vdi_si=0.0;
#endif
Qedj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vsi_s_Vdi_d=0.0;
  Qedj1_Vsi_s_Vsi_s=0.0;
  Qedj1_Vsi_s_Tempt_GND=0.0;
  Qedj1_Vsi_s_Vge_di=0.0;
  Qedj1_Vsi_s_Vge_e=0.0;
  Qedj1_Vsi_s_Ve_si=0.0;
  Qedj1_Vsi_s_Ve_di=0.0;
  Qedj1_Vsi_s_Vge_si=0.0;
  Qedj1_Vsi_s_Vdi_si=0.0;
#endif
Qedj1_Tempt_GND=(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Tempt_GND_Vdi_d=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vsi_s=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Tempt_GND=((+(+PBD_t_Tempt_GND_Tempt_GND*Czbd+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t*Czbd_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_e=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Ve_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Ve_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vdi_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_di=(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_di_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_e=(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_e_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Ve_si=(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Ve_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Ve_di=(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Ve_di_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_si=(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vdi_si=(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vdi_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
#endif
Qedj1=(((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD));
EXIT_IF_ISNAN((((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBD_t-vec*PBD_t_Tempt_GND)/PBD_t/PBD_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBD_t-(vec_Tempt_GND*0.0+0.0*PBD_t_Tempt_GND+vec*0.0)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*0.0/PBD_t/PBD_t/PBD_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBD_t-(vec_Tempt_GND*PBD_t_Tempt_GND+vec_Tempt_GND*PBD_t_Tempt_GND+vec*PBD_t_Tempt_GND_Tempt_GND)/PBD_t/PBD_t+2*vec*PBD_t_Tempt_GND*PBD_t_Tempt_GND/PBD_t/PBD_t/PBD_t));
#endif
#endif
arg=(1.0-(vec/PBD_t));
EXIT_IF_ISNAN((1.0-(vec/PBD_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBD_t_Tempt_GND_Tempt_GND*Czbd+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t*Czbd_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Vge_di=(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Vge_e=(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Ve_si=(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Ve_di=(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Vge_si=(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qec_Vdi_si=(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
#endif
Qec=(((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD));
EXIT_IF_ISNAN((((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=(-(ved_jct_Ve_di/pb2));
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_di=(+0.0-((+ved_jct_Ve_di_Ve_di-0.0)/pb2-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ved_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ved_jct_Ve_di*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ved_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ved_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ved_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJD2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)),((-pModel->MJD2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJD2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJD2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vdi_d_Vdi_d=0.0;
  Qedj1_Vdi_d_Vsi_s=0.0;
  Qedj1_Vdi_d_Tempt_GND=0.0;
  Qedj1_Vdi_d_Vge_di=0.0;
  Qedj1_Vdi_d_Vge_e=0.0;
  Qedj1_Vdi_d_Ve_si=0.0;
  Qedj1_Vdi_d_Ve_di=0.0;
  Qedj1_Vdi_d_Vge_si=0.0;
  Qedj1_Vdi_d_Vdi_si=0.0;
#endif
Qedj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vsi_s_Vdi_d=0.0;
  Qedj1_Vsi_s_Vsi_s=0.0;
  Qedj1_Vsi_s_Tempt_GND=0.0;
  Qedj1_Vsi_s_Vge_di=0.0;
  Qedj1_Vsi_s_Vge_e=0.0;
  Qedj1_Vsi_s_Ve_si=0.0;
  Qedj1_Vsi_s_Ve_di=0.0;
  Qedj1_Vsi_s_Vge_si=0.0;
  Qedj1_Vsi_s_Vdi_si=0.0;
#endif
Qedj1_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(0.0))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(0.0))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJD*pb2_Tempt_GND_Tempt_GND)*Czbd+(pModel->SJD*pb2_Tempt_GND)*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*Czbd_Tempt_GND+(pModel->SJD*pb2)*Czbd_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJD*0.0)*Czbd+(pModel->SJD*pb2_Tempt_GND)*0.0+(0.0)*Czbd_Tempt_GND+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJD2)-((((((pModel->SJD*pb2_Tempt_GND)*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Vge_di=(Qec_Vge_di+((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Vge_e=(Qec_Vge_e+((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Ve_si=(Qec_Ve_si+((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Ve_di=(Qec_Ve_di+((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Vge_si=(Qec_Vge_si+((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
Qedj1_Vdi_si=(Qec_Vdi_si+((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJD2)));
#if defined(_DERIVATE2)
  Qedj1_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(0.0)))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*Czbd_Tempt_GND+((pModel->SJD*pb2_Tempt_GND))*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJD*pb2_Tempt_GND))*Czbd)+((pModel->SJD*pb2)*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
  Qedj1_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJD*0.0)*Czbd+0.0*0.0+(0.0)*0.0+(pModel->SJD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJD*pb2)*Czbd)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJD2)-((((pModel->SJD*pb2)*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbd)*(1.0-(arg*sarg)))+(((pModel->SJD*pb2)*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)+2*(((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)/(1.0-pModel->MJD2)));
#endif
#endif
Qedj1=(Qec+((((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJD*pb2)*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJD)*bsimcmg_lln(arg)),((-pModel->MJD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vdi_d_Vdi_d=0.0;
  Qedj1_Vdi_d_Vsi_s=0.0;
  Qedj1_Vdi_d_Tempt_GND=0.0;
  Qedj1_Vdi_d_Vge_di=0.0;
  Qedj1_Vdi_d_Vge_e=0.0;
  Qedj1_Vdi_d_Ve_si=0.0;
  Qedj1_Vdi_d_Ve_di=0.0;
  Qedj1_Vdi_d_Vge_si=0.0;
  Qedj1_Vdi_d_Vdi_si=0.0;
#endif
Qedj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vsi_s_Vdi_d=0.0;
  Qedj1_Vsi_s_Vsi_s=0.0;
  Qedj1_Vsi_s_Tempt_GND=0.0;
  Qedj1_Vsi_s_Vge_di=0.0;
  Qedj1_Vsi_s_Vge_e=0.0;
  Qedj1_Vsi_s_Ve_si=0.0;
  Qedj1_Vsi_s_Ve_di=0.0;
  Qedj1_Vsi_s_Vge_si=0.0;
  Qedj1_Vsi_s_Vdi_si=0.0;
#endif
Qedj1_Tempt_GND=(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Tempt_GND_Vdi_d=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vsi_s=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Tempt_GND=((+(+PBD_t_Tempt_GND_Tempt_GND*Czbd+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t*Czbd_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_e=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Ve_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Ve_di=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vge_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Tempt_GND_Vdi_si=((+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(1.0-(arg*sarg))+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBD_t*Czbd)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJD)-(((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_di=(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_di_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_e=(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_e_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_e_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Ve_si=(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Ve_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Ve_di=(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Ve_di_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Ve_di_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBD_t*Czbd)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vge_si=(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vge_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vge_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
Qedj1_Vdi_si=(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJD));
#if defined(_DERIVATE2)
  Qedj1_Vdi_si_Vdi_d=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vsi_s=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(0.0)))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Tempt_GND=((+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_e=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Ve_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Ve_di=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vge_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
  Qedj1_Vdi_si_Vdi_si=((+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBD_t*Czbd)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJD)-(((PBD_t*Czbd)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBD_t*Czbd)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBD_t*Czbd)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJD)/(1.0-pModel->MJD)+2*((PBD_t*Czbd)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJD)/(1.0-pModel->MJD)/(1.0-pModel->MJD));
#endif
#endif
Qedj1=(((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD));
EXIT_IF_ISNAN((((PBD_t*Czbd)*(1.0-(arg*sarg)))/(1.0-pModel->MJD)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJD)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJD));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJD)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJD)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJD)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJD)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJD)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJD)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJD)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)))+((T2*(T1-1.0))*((5.0*pModel->MJD)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJD)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJD)*(T1-1.0))+(1.0+pModel->MJD))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Vge_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Vge_e+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Vdi_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Ve_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Ve_di+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Vge_si+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)))+(T3*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJD))*T2)+(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJD))*T2_Tempt_GND+((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJD)*(1.0+pModel->MJD))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj1_Vdi_d=((PBD_t*Czbd)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qedj1_Vdi_d_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vdi_d));
  Qedj1_Vdi_d_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vsi_s));
  Qedj1_Vdi_d_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qedj1_Vdi_d_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vge_di));
  Qedj1_Vdi_d_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vge_e));
  Qedj1_Vdi_d_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Ve_si));
  Qedj1_Vdi_d_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Ve_di));
  Qedj1_Vdi_d_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vge_si));
  Qedj1_Vdi_d_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBD_t*Czbd)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qedj1_Vsi_s=((PBD_t*Czbd)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qedj1_Vsi_s_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vdi_d));
  Qedj1_Vsi_s_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vsi_s));
  Qedj1_Vsi_s_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qedj1_Vsi_s_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vge_di));
  Qedj1_Vsi_s_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vge_e));
  Qedj1_Vsi_s_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Ve_si));
  Qedj1_Vsi_s_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Ve_di));
  Qedj1_Vsi_s_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vge_si));
  Qedj1_Vsi_s_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBD_t*Czbd)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qedj1_Tempt_GND=((((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4+T5))+((PBD_t*Czbd)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qedj1_Tempt_GND_Vdi_d=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qedj1_Tempt_GND_Vsi_s=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qedj1_Tempt_GND_Tempt_GND=(+(+PBD_t_Tempt_GND_Tempt_GND*Czbd+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t_Tempt_GND*Czbd_Tempt_GND+PBD_t*Czbd_Tempt_GND_Tempt_GND)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qedj1_Tempt_GND_Vge_di=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qedj1_Tempt_GND_Vge_e=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qedj1_Tempt_GND_Ve_si=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qedj1_Tempt_GND_Ve_di=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qedj1_Tempt_GND_Vge_si=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qedj1_Tempt_GND_Vdi_si=(+(+0.0*Czbd+PBD_t_Tempt_GND*0.0+0.0*Czbd_Tempt_GND+PBD_t*0.0)*(T4+T5)+((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBD_t*Czbd)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qedj1_Vge_di=((PBD_t*Czbd)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qedj1_Vge_di_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+0.0+T5_Vge_di_Vdi_d));
  Qedj1_Vge_di_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+0.0+T5_Vge_di_Vsi_s));
  Qedj1_Vge_di_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qedj1_Vge_di_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qedj1_Vge_di_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qedj1_Vge_di_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qedj1_Vge_di_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qedj1_Vge_di_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qedj1_Vge_di_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBD_t*Czbd)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qedj1_Vge_e=((PBD_t*Czbd)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qedj1_Vge_e_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+0.0+T5_Vge_e_Vdi_d));
  Qedj1_Vge_e_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+0.0+T5_Vge_e_Vsi_s));
  Qedj1_Vge_e_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qedj1_Vge_e_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qedj1_Vge_e_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qedj1_Vge_e_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qedj1_Vge_e_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qedj1_Vge_e_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qedj1_Vge_e_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBD_t*Czbd)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qedj1_Ve_si=((PBD_t*Czbd)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qedj1_Ve_si_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+0.0+T5_Ve_si_Vdi_d));
  Qedj1_Ve_si_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+0.0+T5_Ve_si_Vsi_s));
  Qedj1_Ve_si_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qedj1_Ve_si_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qedj1_Ve_si_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qedj1_Ve_si_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qedj1_Ve_si_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qedj1_Ve_si_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qedj1_Ve_si_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBD_t*Czbd)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qedj1_Ve_di=((PBD_t*Czbd)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qedj1_Ve_di_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+0.0+T5_Ve_di_Vdi_d));
  Qedj1_Ve_di_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+0.0+T5_Ve_di_Vsi_s));
  Qedj1_Ve_di_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qedj1_Ve_di_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qedj1_Ve_di_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qedj1_Ve_di_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qedj1_Ve_di_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qedj1_Ve_di_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qedj1_Ve_di_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBD_t*Czbd)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qedj1_Vge_si=((PBD_t*Czbd)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qedj1_Vge_si_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+0.0+T5_Vge_si_Vdi_d));
  Qedj1_Vge_si_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+0.0+T5_Vge_si_Vsi_s));
  Qedj1_Vge_si_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qedj1_Vge_si_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qedj1_Vge_si_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qedj1_Vge_si_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qedj1_Vge_si_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qedj1_Vge_si_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qedj1_Vge_si_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBD_t*Czbd)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qedj1_Vdi_si=((PBD_t*Czbd)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qedj1_Vdi_si_Vdi_d=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+0.0+T5_Vdi_si_Vdi_d));
  Qedj1_Vdi_si_Vsi_s=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+0.0+T5_Vdi_si_Vsi_s));
  Qedj1_Vdi_si_Tempt_GND=(+(+0.0*Czbd+0.0*Czbd_Tempt_GND+PBD_t_Tempt_GND*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBD_t_Tempt_GND*Czbd)+(PBD_t*Czbd_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qedj1_Vdi_si_Vge_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qedj1_Vdi_si_Vge_e=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qedj1_Vdi_si_Ve_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qedj1_Vdi_si_Ve_di=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qedj1_Vdi_si_Vge_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qedj1_Vdi_si_Vdi_si=(+(+0.0*Czbd+0.0*0.0+0.0*0.0+PBD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBD_t*Czbd)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qedj1=((PBD_t*Czbd)*(T4+T5));
EXIT_IF_ISNAN(((PBD_t*Czbd)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vdi_d_Vdi_d=0.0;
  Qedj1_Vdi_d_Vsi_s=0.0;
  Qedj1_Vdi_d_Tempt_GND=0.0;
  Qedj1_Vdi_d_Vge_di=0.0;
  Qedj1_Vdi_d_Vge_e=0.0;
  Qedj1_Vdi_d_Ve_si=0.0;
  Qedj1_Vdi_d_Ve_di=0.0;
  Qedj1_Vdi_d_Vge_si=0.0;
  Qedj1_Vdi_d_Vdi_si=0.0;
#endif
Qedj1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vsi_s_Vdi_d=0.0;
  Qedj1_Vsi_s_Vsi_s=0.0;
  Qedj1_Vsi_s_Tempt_GND=0.0;
  Qedj1_Vsi_s_Vge_di=0.0;
  Qedj1_Vsi_s_Vge_e=0.0;
  Qedj1_Vsi_s_Ve_si=0.0;
  Qedj1_Vsi_s_Ve_di=0.0;
  Qedj1_Vsi_s_Vge_si=0.0;
  Qedj1_Vsi_s_Vdi_si=0.0;
#endif
Qedj1_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qedj1_Tempt_GND_Vdi_d=0.0;
  Qedj1_Tempt_GND_Vsi_s=0.0;
  Qedj1_Tempt_GND_Tempt_GND=0.0;
  Qedj1_Tempt_GND_Vge_di=0.0;
  Qedj1_Tempt_GND_Vge_e=0.0;
  Qedj1_Tempt_GND_Ve_si=0.0;
  Qedj1_Tempt_GND_Ve_di=0.0;
  Qedj1_Tempt_GND_Vge_si=0.0;
  Qedj1_Tempt_GND_Vdi_si=0.0;
#endif
Qedj1_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vge_di_Vdi_d=0.0;
  Qedj1_Vge_di_Vsi_s=0.0;
  Qedj1_Vge_di_Tempt_GND=0.0;
  Qedj1_Vge_di_Vge_di=0.0;
  Qedj1_Vge_di_Vge_e=0.0;
  Qedj1_Vge_di_Ve_si=0.0;
  Qedj1_Vge_di_Ve_di=0.0;
  Qedj1_Vge_di_Vge_si=0.0;
  Qedj1_Vge_di_Vdi_si=0.0;
#endif
Qedj1_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vge_e_Vdi_d=0.0;
  Qedj1_Vge_e_Vsi_s=0.0;
  Qedj1_Vge_e_Tempt_GND=0.0;
  Qedj1_Vge_e_Vge_di=0.0;
  Qedj1_Vge_e_Vge_e=0.0;
  Qedj1_Vge_e_Ve_si=0.0;
  Qedj1_Vge_e_Ve_di=0.0;
  Qedj1_Vge_e_Vge_si=0.0;
  Qedj1_Vge_e_Vdi_si=0.0;
#endif
Qedj1_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qedj1_Ve_si_Vdi_d=0.0;
  Qedj1_Ve_si_Vsi_s=0.0;
  Qedj1_Ve_si_Tempt_GND=0.0;
  Qedj1_Ve_si_Vge_di=0.0;
  Qedj1_Ve_si_Vge_e=0.0;
  Qedj1_Ve_si_Ve_si=0.0;
  Qedj1_Ve_si_Ve_di=0.0;
  Qedj1_Ve_si_Vge_si=0.0;
  Qedj1_Ve_si_Vdi_si=0.0;
#endif
Qedj1_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qedj1_Ve_di_Vdi_d=0.0;
  Qedj1_Ve_di_Vsi_s=0.0;
  Qedj1_Ve_di_Tempt_GND=0.0;
  Qedj1_Ve_di_Vge_di=0.0;
  Qedj1_Ve_di_Vge_e=0.0;
  Qedj1_Ve_di_Ve_si=0.0;
  Qedj1_Ve_di_Ve_di=0.0;
  Qedj1_Ve_di_Vge_si=0.0;
  Qedj1_Ve_di_Vdi_si=0.0;
#endif
Qedj1_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vge_si_Vdi_d=0.0;
  Qedj1_Vge_si_Vsi_s=0.0;
  Qedj1_Vge_si_Tempt_GND=0.0;
  Qedj1_Vge_si_Vge_di=0.0;
  Qedj1_Vge_si_Vge_e=0.0;
  Qedj1_Vge_si_Ve_si=0.0;
  Qedj1_Vge_si_Ve_di=0.0;
  Qedj1_Vge_si_Vge_si=0.0;
  Qedj1_Vge_si_Vdi_si=0.0;
#endif
Qedj1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qedj1_Vdi_si_Vdi_d=0.0;
  Qedj1_Vdi_si_Vsi_s=0.0;
  Qedj1_Vdi_si_Tempt_GND=0.0;
  Qedj1_Vdi_si_Vge_di=0.0;
  Qedj1_Vdi_si_Vge_e=0.0;
  Qedj1_Vdi_si_Ve_si=0.0;
  Qedj1_Vdi_si_Ve_di=0.0;
  Qedj1_Vdi_si_Vge_si=0.0;
  Qedj1_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qedj1=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
{
if
((Czbdsw>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=(ved_jct_Ve_di/PBSWD_t);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Vsi_s=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Vge_di=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Vge_e=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Ve_si=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Ve_di=(ved_jct_Ve_di_Ve_di/PBSWD_t-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Vge_si=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Vdi_si=(0.0/PBSWD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Ve_di_Tempt_GND=(0.0/PBSWD_t-(ved_jct_Ve_di*PBSWD_t_Tempt_GND+0.0*0.0+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*0.0*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t/PBSWD_t);
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ved_jct*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Vge_di=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Vge_e=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Ve_si=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Ve_di=(0.0/PBSWD_t-(0.0*0.0+ved_jct_Ve_di*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Vge_si=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBSWD_t-(0.0*0.0+0.0*PBSWD_t_Tempt_GND+ved_jct*0.0)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBSWD_t-(0.0*PBSWD_t_Tempt_GND+0.0*PBSWD_t_Tempt_GND+ved_jct*PBSWD_t_Tempt_GND_Tempt_GND)/PBSWD_t/PBSWD_t+2*ved_jct*PBSWD_t_Tempt_GND*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t/PBSWD_t);
#endif
#endif
T1=(ved_jct/PBSWD_t);
EXIT_IF_ISNAN((ved_jct/PBSWD_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJSWD>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBSWD_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))))))+(PBSWD_t*(-bsimcmg_d_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))),((1.0/pModel->MJSWD)*bsimcmg_d_lln((1.0/pModel->SJSWD),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBSWD_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD)))))+PBSWD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))),((1.0/pModel->MJSWD)*bsimcmg_d_lln((1.0/pModel->SJSWD),0.0))))+PBSWD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))),((1.0/pModel->MJSWD)*bsimcmg_d_lln((1.0/pModel->SJSWD),0.0))))+PBSWD_t*(+0.0-(+(0.0/pModel->MJSWD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJSWD/pModel->MJSWD+2*1.0*0.0*0.0/pModel->MJSWD/pModel->MJSWD/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))+0.0*bsimcmg_d_lln((1.0/pModel->SJSWD),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJSWD),0.0)+(1.0/pModel->MJSWD)*(0.0/pModel->SJSWD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJSWD/pModel->SJSWD+2*1.0*0.0*0.0/pModel->SJSWD/pModel->SJSWD/pModel->SJSWD))));
#endif
#endif
vec=(PBSWD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD))))));
EXIT_IF_ISNAN((PBSWD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWD)*bsimcmg_lln((1.0/pModel->SJSWD)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBSWD_t_Tempt_GND*pModel->SJSWD*pModel->MJSWD2/pModel->MJSWD)*bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))-(((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))),((-(1.0+pModel->MJSWD))*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBSWD_t_Tempt_GND_Tempt_GND*pModel->SJSWD+PBSWD_t_Tempt_GND*0.0+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*pModel->MJSWD2+PBSWD_t_Tempt_GND*pModel->SJSWD*0.0+(PBSWD_t_Tempt_GND*pModel->SJSWD)*0.0+(PBSWD_t*pModel->SJSWD)*0.0)/pModel->MJSWD-(PBSWD_t_Tempt_GND*pModel->SJSWD*pModel->MJSWD2*0.0+((PBSWD_t_Tempt_GND*pModel->SJSWD)*pModel->MJSWD2)*0.0+((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)*0.0)/pModel->MJSWD/pModel->MJSWD+2*((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)*0.0*0.0/pModel->MJSWD/pModel->MJSWD/pModel->MJSWD)/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))-((PBSWD_t_Tempt_GND*pModel->SJSWD*pModel->MJSWD2/pModel->MJSWD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))),((-(1.0+pModel->MJSWD))*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))))+(((PBSWD_t_Tempt_GND*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))),((-(1.0+pModel->MJSWD))*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))))+(((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)*(+0.0*bsimcmg_lln((1.0-(vec/PBSWD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))+(-(1.0+pModel->MJSWD))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWD_t-(vec_Tempt_GND*PBSWD_t_Tempt_GND+vec_Tempt_GND*PBSWD_t_Tempt_GND+vec*PBSWD_t_Tempt_GND_Tempt_GND)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t/PBSWD_t))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))+2*(((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))),((-(1.0+pModel->MJSWD))*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))),((-(1.0+pModel->MJSWD))*bsimcmg_d_lln((1.0-(vec/PBSWD_t)),(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t))))));
#endif
#endif
pb2=((((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t))))));
EXIT_IF_ISNAN(((((PBSWD_t*pModel->SJSWD)*pModel->MJSWD2)/pModel->MJSWD)/bsimcmg_lexp(((-(1.0+pModel->MJSWD))*bsimcmg_lln((1.0-(vec/PBSWD_t)))))))
#endif
#ifdef _DYNAMIC
if
((ved_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vdi_d_Vdi_d=0.0;
  Qedj2_Vdi_d_Vsi_s=0.0;
  Qedj2_Vdi_d_Tempt_GND=0.0;
  Qedj2_Vdi_d_Vge_di=0.0;
  Qedj2_Vdi_d_Vge_e=0.0;
  Qedj2_Vdi_d_Ve_si=0.0;
  Qedj2_Vdi_d_Ve_di=0.0;
  Qedj2_Vdi_d_Vge_si=0.0;
  Qedj2_Vdi_d_Vdi_si=0.0;
#endif
Qedj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vsi_s_Vdi_d=0.0;
  Qedj2_Vsi_s_Vsi_s=0.0;
  Qedj2_Vsi_s_Tempt_GND=0.0;
  Qedj2_Vsi_s_Vge_di=0.0;
  Qedj2_Vsi_s_Vge_e=0.0;
  Qedj2_Vsi_s_Ve_si=0.0;
  Qedj2_Vsi_s_Ve_di=0.0;
  Qedj2_Vsi_s_Vge_si=0.0;
  Qedj2_Vsi_s_Vdi_si=0.0;
#endif
Qedj2_Tempt_GND=(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Tempt_GND_Vdi_d=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vsi_s=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Tempt_GND=((+(+PBSWD_t_Tempt_GND_Tempt_GND*Czbdsw+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t*Czbdsw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_e=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Ve_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Ve_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vdi_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_di=(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_di_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_e=(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_e_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Ve_si=(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Ve_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Ve_di=(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Ve_di_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_si=(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vdi_si=(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vdi_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
#endif
Qedj2=(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD));
EXIT_IF_ISNAN((((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBSWD_t-vec*PBSWD_t_Tempt_GND)/PBSWD_t/PBSWD_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBSWD_t-(vec_Tempt_GND*0.0+0.0*PBSWD_t_Tempt_GND+vec*0.0)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*0.0/PBSWD_t/PBSWD_t/PBSWD_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWD_t-(vec_Tempt_GND*PBSWD_t_Tempt_GND+vec_Tempt_GND*PBSWD_t_Tempt_GND+vec*PBSWD_t_Tempt_GND_Tempt_GND)/PBSWD_t/PBSWD_t+2*vec*PBSWD_t_Tempt_GND*PBSWD_t_Tempt_GND/PBSWD_t/PBSWD_t/PBSWD_t));
#endif
#endif
arg=(1.0-(vec/PBSWD_t));
EXIT_IF_ISNAN((1.0-(vec/PBSWD_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBSWD_t_Tempt_GND_Tempt_GND*Czbdsw+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t*Czbdsw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Vge_di=(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Vge_e=(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Ve_si=(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Ve_di=(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Vge_si=(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qec_Vdi_si=(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
#endif
Qec=(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD));
EXIT_IF_ISNAN((((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=(-(ved_jct_Ve_di/pb2));
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_di=(+0.0-((+ved_jct_Ve_di_Ve_di-0.0)/pb2-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ved_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ved_jct_Ve_di*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ved_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ved_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ved_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWD2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)),((-pModel->MJSWD2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWD2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vdi_d_Vdi_d=0.0;
  Qedj2_Vdi_d_Vsi_s=0.0;
  Qedj2_Vdi_d_Tempt_GND=0.0;
  Qedj2_Vdi_d_Vge_di=0.0;
  Qedj2_Vdi_d_Vge_e=0.0;
  Qedj2_Vdi_d_Ve_si=0.0;
  Qedj2_Vdi_d_Ve_di=0.0;
  Qedj2_Vdi_d_Vge_si=0.0;
  Qedj2_Vdi_d_Vdi_si=0.0;
#endif
Qedj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vsi_s_Vdi_d=0.0;
  Qedj2_Vsi_s_Vsi_s=0.0;
  Qedj2_Vsi_s_Tempt_GND=0.0;
  Qedj2_Vsi_s_Vge_di=0.0;
  Qedj2_Vsi_s_Vge_e=0.0;
  Qedj2_Vsi_s_Ve_si=0.0;
  Qedj2_Vsi_s_Ve_di=0.0;
  Qedj2_Vsi_s_Vge_si=0.0;
  Qedj2_Vsi_s_Vdi_si=0.0;
#endif
Qedj2_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJSWD*pb2_Tempt_GND_Tempt_GND)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*Czbdsw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWD*0.0)*Czbdsw+(pModel->SJSWD*pb2_Tempt_GND)*0.0+(0.0)*Czbdsw_Tempt_GND+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWD2)-((((((pModel->SJSWD*pb2_Tempt_GND)*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Vge_di=(Qec_Vge_di+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Vge_e=(Qec_Vge_e+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Ve_si=(Qec_Ve_si+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Ve_di=(Qec_Ve_di+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Vge_si=(Qec_Vge_si+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
Qedj2_Vdi_si=(Qec_Vdi_si+((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWD2)));
#if defined(_DERIVATE2)
  Qedj2_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(0.0)))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*Czbdsw_Tempt_GND+((pModel->SJSWD*pb2_Tempt_GND))*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJSWD*pb2_Tempt_GND))*Czbdsw)+((pModel->SJSWD*pb2)*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
  Qedj2_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWD*0.0)*Czbdsw+0.0*0.0+(0.0)*0.0+(pModel->SJSWD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWD*pb2)*Czbdsw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWD2)-((((pModel->SJSWD*pb2)*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdsw)*(1.0-(arg*sarg)))+(((pModel->SJSWD*pb2)*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)+2*(((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)/(1.0-pModel->MJSWD2)));
#endif
#endif
Qedj2=(Qec+((((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJSWD*pb2)*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)),((-pModel->MJSWD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vdi_d_Vdi_d=0.0;
  Qedj2_Vdi_d_Vsi_s=0.0;
  Qedj2_Vdi_d_Tempt_GND=0.0;
  Qedj2_Vdi_d_Vge_di=0.0;
  Qedj2_Vdi_d_Vge_e=0.0;
  Qedj2_Vdi_d_Ve_si=0.0;
  Qedj2_Vdi_d_Ve_di=0.0;
  Qedj2_Vdi_d_Vge_si=0.0;
  Qedj2_Vdi_d_Vdi_si=0.0;
#endif
Qedj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vsi_s_Vdi_d=0.0;
  Qedj2_Vsi_s_Vsi_s=0.0;
  Qedj2_Vsi_s_Tempt_GND=0.0;
  Qedj2_Vsi_s_Vge_di=0.0;
  Qedj2_Vsi_s_Vge_e=0.0;
  Qedj2_Vsi_s_Ve_si=0.0;
  Qedj2_Vsi_s_Ve_di=0.0;
  Qedj2_Vsi_s_Vge_si=0.0;
  Qedj2_Vsi_s_Vdi_si=0.0;
#endif
Qedj2_Tempt_GND=(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Tempt_GND_Vdi_d=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vsi_s=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Tempt_GND=((+(+PBSWD_t_Tempt_GND_Tempt_GND*Czbdsw+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t*Czbdsw_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_e=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Ve_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Ve_di=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vge_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Tempt_GND_Vdi_si=((+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(1.0-(arg*sarg))+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWD)-(((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_di=(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_di_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_e=(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_e_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_e_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Ve_si=(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Ve_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Ve_di=(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Ve_di_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Ve_di_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vge_si=(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vge_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vge_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
Qedj2_Vdi_si=(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWD));
#if defined(_DERIVATE2)
  Qedj2_Vdi_si_Vdi_d=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vsi_s=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(0.0)))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Tempt_GND=((+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_e=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Ve_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Ve_di=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vge_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
  Qedj2_Vdi_si_Vdi_si=((+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWD_t*Czbdsw)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWD)-(((PBSWD_t*Czbdsw)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWD_t*Czbdsw)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)+2*((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD)/(1.0-pModel->MJSWD));
#endif
#endif
Qedj2=(((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD));
EXIT_IF_ISNAN((((PBSWD_t*Czbdsw)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWD)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWD)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJSWD));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJSWD)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJSWD)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJSWD)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWD)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJSWD)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJSWD)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJSWD)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWD)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWD)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJSWD)*(T1-1.0))+(1.0+pModel->MJSWD))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_e+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Vdi_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Ve_di+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Vge_si+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)))+(T3*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWD))*T2)+(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWD))*T2_Tempt_GND+((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJSWD)*(1.0+pModel->MJSWD))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj2_Vdi_d=((PBSWD_t*Czbdsw)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qedj2_Vdi_d_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vdi_d));
  Qedj2_Vdi_d_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vsi_s));
  Qedj2_Vdi_d_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qedj2_Vdi_d_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vge_di));
  Qedj2_Vdi_d_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vge_e));
  Qedj2_Vdi_d_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Ve_si));
  Qedj2_Vdi_d_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Ve_di));
  Qedj2_Vdi_d_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vge_si));
  Qedj2_Vdi_d_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qedj2_Vsi_s=((PBSWD_t*Czbdsw)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qedj2_Vsi_s_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vdi_d));
  Qedj2_Vsi_s_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vsi_s));
  Qedj2_Vsi_s_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qedj2_Vsi_s_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vge_di));
  Qedj2_Vsi_s_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vge_e));
  Qedj2_Vsi_s_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Ve_si));
  Qedj2_Vsi_s_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Ve_di));
  Qedj2_Vsi_s_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vge_si));
  Qedj2_Vsi_s_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBSWD_t*Czbdsw)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qedj2_Tempt_GND=((((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4+T5))+((PBSWD_t*Czbdsw)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qedj2_Tempt_GND_Vdi_d=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qedj2_Tempt_GND_Vsi_s=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qedj2_Tempt_GND_Tempt_GND=(+(+PBSWD_t_Tempt_GND_Tempt_GND*Czbdsw+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*Czbdsw_Tempt_GND+PBSWD_t*Czbdsw_Tempt_GND_Tempt_GND)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qedj2_Tempt_GND_Vge_di=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qedj2_Tempt_GND_Vge_e=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qedj2_Tempt_GND_Ve_si=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qedj2_Tempt_GND_Ve_di=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qedj2_Tempt_GND_Vge_si=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qedj2_Tempt_GND_Vdi_si=(+(+0.0*Czbdsw+PBSWD_t_Tempt_GND*0.0+0.0*Czbdsw_Tempt_GND+PBSWD_t*0.0)*(T4+T5)+((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWD_t*Czbdsw)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qedj2_Vge_di=((PBSWD_t*Czbdsw)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qedj2_Vge_di_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_di_Vdi_d));
  Qedj2_Vge_di_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_di_Vsi_s));
  Qedj2_Vge_di_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qedj2_Vge_di_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qedj2_Vge_di_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qedj2_Vge_di_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qedj2_Vge_di_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qedj2_Vge_di_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qedj2_Vge_di_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWD_t*Czbdsw)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qedj2_Vge_e=((PBSWD_t*Czbdsw)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qedj2_Vge_e_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_e_Vdi_d));
  Qedj2_Vge_e_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_e_Vsi_s));
  Qedj2_Vge_e_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qedj2_Vge_e_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qedj2_Vge_e_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qedj2_Vge_e_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qedj2_Vge_e_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qedj2_Vge_e_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qedj2_Vge_e_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWD_t*Czbdsw)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qedj2_Ve_si=((PBSWD_t*Czbdsw)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qedj2_Ve_si_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Ve_si_Vdi_d));
  Qedj2_Ve_si_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Ve_si_Vsi_s));
  Qedj2_Ve_si_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qedj2_Ve_si_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qedj2_Ve_si_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qedj2_Ve_si_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qedj2_Ve_si_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qedj2_Ve_si_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qedj2_Ve_si_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWD_t*Czbdsw)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qedj2_Ve_di=((PBSWD_t*Czbdsw)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qedj2_Ve_di_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+0.0+T5_Ve_di_Vdi_d));
  Qedj2_Ve_di_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+0.0+T5_Ve_di_Vsi_s));
  Qedj2_Ve_di_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qedj2_Ve_di_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qedj2_Ve_di_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qedj2_Ve_di_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qedj2_Ve_di_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qedj2_Ve_di_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qedj2_Ve_di_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWD_t*Czbdsw)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qedj2_Vge_si=((PBSWD_t*Czbdsw)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qedj2_Vge_si_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_si_Vdi_d));
  Qedj2_Vge_si_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vge_si_Vsi_s));
  Qedj2_Vge_si_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qedj2_Vge_si_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qedj2_Vge_si_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qedj2_Vge_si_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qedj2_Vge_si_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qedj2_Vge_si_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qedj2_Vge_si_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWD_t*Czbdsw)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qedj2_Vdi_si=((PBSWD_t*Czbdsw)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qedj2_Vdi_si_Vdi_d=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_si_Vdi_d));
  Qedj2_Vdi_si_Vsi_s=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+0.0+T5_Vdi_si_Vsi_s));
  Qedj2_Vdi_si_Tempt_GND=(+(+0.0*Czbdsw+0.0*Czbdsw_Tempt_GND+PBSWD_t_Tempt_GND*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWD_t_Tempt_GND*Czbdsw)+(PBSWD_t*Czbdsw_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qedj2_Vdi_si_Vge_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qedj2_Vdi_si_Vge_e=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qedj2_Vdi_si_Ve_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qedj2_Vdi_si_Ve_di=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qedj2_Vdi_si_Vge_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qedj2_Vdi_si_Vdi_si=(+(+0.0*Czbdsw+0.0*0.0+0.0*0.0+PBSWD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWD_t*Czbdsw)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qedj2=((PBSWD_t*Czbdsw)*(T4+T5));
EXIT_IF_ISNAN(((PBSWD_t*Czbdsw)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vdi_d_Vdi_d=0.0;
  Qedj2_Vdi_d_Vsi_s=0.0;
  Qedj2_Vdi_d_Tempt_GND=0.0;
  Qedj2_Vdi_d_Vge_di=0.0;
  Qedj2_Vdi_d_Vge_e=0.0;
  Qedj2_Vdi_d_Ve_si=0.0;
  Qedj2_Vdi_d_Ve_di=0.0;
  Qedj2_Vdi_d_Vge_si=0.0;
  Qedj2_Vdi_d_Vdi_si=0.0;
#endif
Qedj2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vsi_s_Vdi_d=0.0;
  Qedj2_Vsi_s_Vsi_s=0.0;
  Qedj2_Vsi_s_Tempt_GND=0.0;
  Qedj2_Vsi_s_Vge_di=0.0;
  Qedj2_Vsi_s_Vge_e=0.0;
  Qedj2_Vsi_s_Ve_si=0.0;
  Qedj2_Vsi_s_Ve_di=0.0;
  Qedj2_Vsi_s_Vge_si=0.0;
  Qedj2_Vsi_s_Vdi_si=0.0;
#endif
Qedj2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qedj2_Tempt_GND_Vdi_d=0.0;
  Qedj2_Tempt_GND_Vsi_s=0.0;
  Qedj2_Tempt_GND_Tempt_GND=0.0;
  Qedj2_Tempt_GND_Vge_di=0.0;
  Qedj2_Tempt_GND_Vge_e=0.0;
  Qedj2_Tempt_GND_Ve_si=0.0;
  Qedj2_Tempt_GND_Ve_di=0.0;
  Qedj2_Tempt_GND_Vge_si=0.0;
  Qedj2_Tempt_GND_Vdi_si=0.0;
#endif
Qedj2_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vge_di_Vdi_d=0.0;
  Qedj2_Vge_di_Vsi_s=0.0;
  Qedj2_Vge_di_Tempt_GND=0.0;
  Qedj2_Vge_di_Vge_di=0.0;
  Qedj2_Vge_di_Vge_e=0.0;
  Qedj2_Vge_di_Ve_si=0.0;
  Qedj2_Vge_di_Ve_di=0.0;
  Qedj2_Vge_di_Vge_si=0.0;
  Qedj2_Vge_di_Vdi_si=0.0;
#endif
Qedj2_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vge_e_Vdi_d=0.0;
  Qedj2_Vge_e_Vsi_s=0.0;
  Qedj2_Vge_e_Tempt_GND=0.0;
  Qedj2_Vge_e_Vge_di=0.0;
  Qedj2_Vge_e_Vge_e=0.0;
  Qedj2_Vge_e_Ve_si=0.0;
  Qedj2_Vge_e_Ve_di=0.0;
  Qedj2_Vge_e_Vge_si=0.0;
  Qedj2_Vge_e_Vdi_si=0.0;
#endif
Qedj2_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qedj2_Ve_si_Vdi_d=0.0;
  Qedj2_Ve_si_Vsi_s=0.0;
  Qedj2_Ve_si_Tempt_GND=0.0;
  Qedj2_Ve_si_Vge_di=0.0;
  Qedj2_Ve_si_Vge_e=0.0;
  Qedj2_Ve_si_Ve_si=0.0;
  Qedj2_Ve_si_Ve_di=0.0;
  Qedj2_Ve_si_Vge_si=0.0;
  Qedj2_Ve_si_Vdi_si=0.0;
#endif
Qedj2_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qedj2_Ve_di_Vdi_d=0.0;
  Qedj2_Ve_di_Vsi_s=0.0;
  Qedj2_Ve_di_Tempt_GND=0.0;
  Qedj2_Ve_di_Vge_di=0.0;
  Qedj2_Ve_di_Vge_e=0.0;
  Qedj2_Ve_di_Ve_si=0.0;
  Qedj2_Ve_di_Ve_di=0.0;
  Qedj2_Ve_di_Vge_si=0.0;
  Qedj2_Ve_di_Vdi_si=0.0;
#endif
Qedj2_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vge_si_Vdi_d=0.0;
  Qedj2_Vge_si_Vsi_s=0.0;
  Qedj2_Vge_si_Tempt_GND=0.0;
  Qedj2_Vge_si_Vge_di=0.0;
  Qedj2_Vge_si_Vge_e=0.0;
  Qedj2_Vge_si_Ve_si=0.0;
  Qedj2_Vge_si_Ve_di=0.0;
  Qedj2_Vge_si_Vge_si=0.0;
  Qedj2_Vge_si_Vdi_si=0.0;
#endif
Qedj2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qedj2_Vdi_si_Vdi_d=0.0;
  Qedj2_Vdi_si_Vsi_s=0.0;
  Qedj2_Vdi_si_Tempt_GND=0.0;
  Qedj2_Vdi_si_Vge_di=0.0;
  Qedj2_Vdi_si_Vge_e=0.0;
  Qedj2_Vdi_si_Ve_si=0.0;
  Qedj2_Vdi_si_Ve_di=0.0;
  Qedj2_Vdi_si_Vge_si=0.0;
  Qedj2_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qedj2=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
{
if
((Czbdswg>0.0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=(ved_jct_Ve_di/PBSWGD_t);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Vsi_s=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Vge_di=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Vge_e=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Ve_si=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Ve_di=(ved_jct_Ve_di_Ve_di/PBSWGD_t-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Vge_si=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Vdi_si=(0.0/PBSWGD_t-(ved_jct_Ve_di*0.0+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Ve_di_Tempt_GND=(0.0/PBSWGD_t-(ved_jct_Ve_di*PBSWGD_t_Tempt_GND+0.0*0.0+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*0.0*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t/PBSWGD_t);
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=0.0;
  T1_Vdi_si_Vsi_s=0.0;
  T1_Vdi_si_Vge_di=0.0;
  T1_Vdi_si_Vge_e=0.0;
  T1_Vdi_si_Ve_si=0.0;
  T1_Vdi_si_Ve_di=0.0;
  T1_Vdi_si_Vge_si=0.0;
  T1_Vdi_si_Vdi_si=0.0;
  T1_Vdi_si_Tempt_GND=0.0;
#endif
T1_Tempt_GND=(-ved_jct*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Vsi_s=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Vge_di=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Vge_e=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Ve_si=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Ve_di=(0.0/PBSWGD_t-(0.0*0.0+ved_jct_Ve_di*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Vge_si=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Vdi_si=(0.0/PBSWGD_t-(0.0*0.0+0.0*PBSWGD_t_Tempt_GND+ved_jct*0.0)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t);
  T1_Tempt_GND_Tempt_GND=(0.0/PBSWGD_t-(0.0*PBSWGD_t_Tempt_GND+0.0*PBSWGD_t_Tempt_GND+ved_jct*PBSWGD_t_Tempt_GND_Tempt_GND)/PBSWGD_t/PBSWGD_t+2*ved_jct*PBSWGD_t_Tempt_GND*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t/PBSWGD_t);
#endif
#endif
T1=(ved_jct/PBSWGD_t);
EXIT_IF_ISNAN((ved_jct/PBSWGD_t))
if
((T1<0.9))
{
#ifdef _DYNAMIC
if
((pModel->SJSWGD>0.0))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
vec_Tempt_GND=((PBSWGD_t_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))))))+(PBSWGD_t*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))),((1.0/pModel->MJSWGD)*bsimcmg_d_lln((1.0/pModel->SJSWGD),0.0))))));
#if defined(_DERIVATE2)
  vec_Tempt_GND_Tempt_GND=(+PBSWGD_t_Tempt_GND_Tempt_GND*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD)))))+PBSWGD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))),((1.0/pModel->MJSWGD)*bsimcmg_d_lln((1.0/pModel->SJSWGD),0.0))))+PBSWGD_t_Tempt_GND*(-bsimcmg_d_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))),((1.0/pModel->MJSWGD)*bsimcmg_d_lln((1.0/pModel->SJSWGD),0.0))))+PBSWGD_t*(+0.0-(+(0.0/pModel->MJSWGD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->MJSWGD/pModel->MJSWGD+2*1.0*0.0*0.0/pModel->MJSWGD/pModel->MJSWGD/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))+0.0*bsimcmg_d_lln((1.0/pModel->SJSWGD),0.0)+0.0*bsimcmg_d_lln((1.0/pModel->SJSWGD),0.0)+(1.0/pModel->MJSWGD)*(0.0/pModel->SJSWGD-(0.0*0.0+0.0*0.0+1.0*0.0)/pModel->SJSWGD/pModel->SJSWGD+2*1.0*0.0*0.0/pModel->SJSWGD/pModel->SJSWGD/pModel->SJSWGD))));
#endif
#endif
vec=(PBSWGD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD))))));
EXIT_IF_ISNAN((PBSWGD_t*(1.0-bsimcmg_lexp(((1.0/pModel->MJSWGD)*bsimcmg_lln((1.0/pModel->SJSWGD)))))))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
pb2_Tempt_GND=(((PBSWGD_t_Tempt_GND*pModel->SJSWGD*pModel->MJSWGD2/pModel->MJSWGD)*bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))-(((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))),((-(1.0+pModel->MJSWGD))*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t))))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t))))));
#if defined(_DERIVATE2)
  pb2_Tempt_GND_Tempt_GND=(((+(+PBSWGD_t_Tempt_GND_Tempt_GND*pModel->SJSWGD+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*pModel->MJSWGD2+PBSWGD_t_Tempt_GND*pModel->SJSWGD*0.0+(PBSWGD_t_Tempt_GND*pModel->SJSWGD)*0.0+(PBSWGD_t*pModel->SJSWGD)*0.0)/pModel->MJSWGD-(PBSWGD_t_Tempt_GND*pModel->SJSWGD*pModel->MJSWGD2*0.0+((PBSWGD_t_Tempt_GND*pModel->SJSWGD)*pModel->MJSWGD2)*0.0+((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)*0.0)/pModel->MJSWGD/pModel->MJSWGD+2*((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)*0.0*0.0/pModel->MJSWGD/pModel->MJSWGD/pModel->MJSWGD)/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))-((PBSWGD_t_Tempt_GND*pModel->SJSWGD*pModel->MJSWGD2/pModel->MJSWGD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))),((-(1.0+pModel->MJSWGD))*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))))+(((PBSWGD_t_Tempt_GND*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))),((-(1.0+pModel->MJSWGD))*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))))+(((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)*(+0.0*bsimcmg_lln((1.0-(vec/PBSWGD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))+0.0*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))+(-(1.0+pModel->MJSWGD))*(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWGD_t-(vec_Tempt_GND*PBSWGD_t_Tempt_GND+vec_Tempt_GND*PBSWGD_t_Tempt_GND+vec*PBSWGD_t_Tempt_GND_Tempt_GND)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t/PBSWGD_t))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))+2*(((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))),((-(1.0+pModel->MJSWGD))*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))))*bsimcmg_d_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))),((-(1.0+pModel->MJSWGD))*bsimcmg_d_lln((1.0-(vec/PBSWGD_t)),(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t))))));
#endif
#endif
pb2=((((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t))))));
EXIT_IF_ISNAN(((((PBSWGD_t*pModel->SJSWGD)*pModel->MJSWGD2)/pModel->MJSWGD)/bsimcmg_lexp(((-(1.0+pModel->MJSWGD))*bsimcmg_lln((1.0-(vec/PBSWGD_t)))))))
#endif
#ifdef _DYNAMIC
if
((ved_jct>vec))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vdi_d_Vdi_d=0.0;
  Qedj3_Vdi_d_Vsi_s=0.0;
  Qedj3_Vdi_d_Tempt_GND=0.0;
  Qedj3_Vdi_d_Vge_di=0.0;
  Qedj3_Vdi_d_Vge_e=0.0;
  Qedj3_Vdi_d_Ve_si=0.0;
  Qedj3_Vdi_d_Ve_di=0.0;
  Qedj3_Vdi_d_Vge_si=0.0;
  Qedj3_Vdi_d_Vdi_si=0.0;
#endif
Qedj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vsi_s_Vdi_d=0.0;
  Qedj3_Vsi_s_Vsi_s=0.0;
  Qedj3_Vsi_s_Tempt_GND=0.0;
  Qedj3_Vsi_s_Vge_di=0.0;
  Qedj3_Vsi_s_Vge_e=0.0;
  Qedj3_Vsi_s_Ve_si=0.0;
  Qedj3_Vsi_s_Ve_di=0.0;
  Qedj3_Vsi_s_Vge_si=0.0;
  Qedj3_Vsi_s_Vdi_si=0.0;
#endif
Qedj3_Tempt_GND=(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Tempt_GND_Vdi_d=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vsi_s=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Tempt_GND=((+(+PBSWGD_t_Tempt_GND_Tempt_GND*Czbdswg+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t*Czbdswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_e=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Ve_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Ve_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vdi_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_di=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_di_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_e=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_e_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Ve_si=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Ve_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Ve_di=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Ve_di_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vdi_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vdi_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
#endif
Qedj3=(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD));
EXIT_IF_ISNAN((((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD)))
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=0.0;
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=0.0;
  arg_Ve_di_Vge_e=0.0;
  arg_Ve_di_Ve_si=0.0;
  arg_Ve_di_Ve_di=0.0;
  arg_Ve_di_Vge_si=0.0;
  arg_Ve_di_Vdi_si=0.0;
  arg_Ve_di_Tempt_GND=0.0;
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-((vec_Tempt_GND*PBSWGD_t-vec*PBSWGD_t_Tempt_GND)/PBSWGD_t/PBSWGD_t));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Vge_e=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Ve_si=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Ve_di=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Vge_si=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Vdi_si=(+0.0-(0.0/PBSWGD_t-(vec_Tempt_GND*0.0+0.0*PBSWGD_t_Tempt_GND+vec*0.0)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*0.0/PBSWGD_t/PBSWGD_t/PBSWGD_t));
  arg_Tempt_GND_Tempt_GND=(+0.0-(vec_Tempt_GND_Tempt_GND/PBSWGD_t-(vec_Tempt_GND*PBSWGD_t_Tempt_GND+vec_Tempt_GND*PBSWGD_t_Tempt_GND+vec*PBSWGD_t_Tempt_GND_Tempt_GND)/PBSWGD_t/PBSWGD_t+2*vec*PBSWGD_t_Tempt_GND*PBSWGD_t_Tempt_GND/PBSWGD_t/PBSWGD_t/PBSWGD_t));
#endif
#endif
arg=(1.0-(vec/PBSWGD_t));
EXIT_IF_ISNAN((1.0-(vec/PBSWGD_t)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qec_Tempt_GND=(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Tempt_GND_Tempt_GND=((+(+PBSWGD_t_Tempt_GND_Tempt_GND*Czbdswg+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t*Czbdswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Vge_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Vge_e=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Ve_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Ve_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Vge_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Tempt_GND_Vdi_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Vge_di=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Vge_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Vge_e=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Vge_e_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_e_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Ve_si=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Ve_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Ve_di=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Ve_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Ve_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Vge_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Vge_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vge_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qec_Vdi_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qec_Vdi_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qec_Vdi_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
#endif
Qec=(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD));
EXIT_IF_ISNAN((((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=0.0;
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=0.0;
  arg_Vge_di_Vge_e=0.0;
  arg_Vge_di_Ve_si=0.0;
  arg_Vge_di_Ve_di=0.0;
  arg_Vge_di_Vge_si=0.0;
  arg_Vge_di_Vdi_si=0.0;
  arg_Vge_di_Tempt_GND=0.0;
#endif
arg_Vge_e=0.0;
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=0.0;
  arg_Vge_e_Vge_e=0.0;
  arg_Vge_e_Ve_si=0.0;
  arg_Vge_e_Ve_di=0.0;
  arg_Vge_e_Vge_si=0.0;
  arg_Vge_e_Vdi_si=0.0;
  arg_Vge_e_Tempt_GND=0.0;
#endif
arg_Ve_si=0.0;
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=0.0;
  arg_Ve_si_Vge_e=0.0;
  arg_Ve_si_Ve_si=0.0;
  arg_Ve_si_Ve_di=0.0;
  arg_Ve_si_Vge_si=0.0;
  arg_Ve_si_Vdi_si=0.0;
  arg_Ve_si_Tempt_GND=0.0;
#endif
arg_Ve_di=(-(ved_jct_Ve_di/pb2));
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_e=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Ve_di=(+0.0-((+ved_jct_Ve_di_Ve_di-0.0)/pb2-(ved_jct_Ve_di*0.0+ved_jct_Ve_di*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vge_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Vdi_si=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*0.0+0.0*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*0.0/pb2/pb2/pb2));
  arg_Ve_di_Tempt_GND=(+0.0-((+0.0-0.0)/pb2-(ved_jct_Ve_di*pb2_Tempt_GND+(-vec_Tempt_GND)*0.0+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*0.0*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
arg_Vge_si=0.0;
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=0.0;
  arg_Vge_si_Vge_e=0.0;
  arg_Vge_si_Ve_si=0.0;
  arg_Vge_si_Ve_di=0.0;
  arg_Vge_si_Vge_si=0.0;
  arg_Vge_si_Vdi_si=0.0;
  arg_Vge_si_Tempt_GND=0.0;
#endif
arg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=0.0;
  arg_Vdi_si_Vge_e=0.0;
  arg_Vdi_si_Ve_si=0.0;
  arg_Vdi_si_Ve_di=0.0;
  arg_Vdi_si_Vge_si=0.0;
  arg_Vdi_si_Vdi_si=0.0;
  arg_Vdi_si_Tempt_GND=0.0;
#endif
arg_Tempt_GND=(-(((-vec_Tempt_GND)*pb2-(ved_jct-vec)*pb2_Tempt_GND)/pb2/pb2));
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_e=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Ve_di=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+ved_jct_Ve_di*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vge_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Vdi_si=(+0.0-((+0.0-0.0)/pb2-((-vec_Tempt_GND)*0.0+0.0*pb2_Tempt_GND+(ved_jct-vec)*0.0)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*0.0/pb2/pb2/pb2));
  arg_Tempt_GND_Tempt_GND=(+0.0-((+0.0-vec_Tempt_GND_Tempt_GND)/pb2-((-vec_Tempt_GND)*pb2_Tempt_GND+(-vec_Tempt_GND)*pb2_Tempt_GND+(ved_jct-vec)*pb2_Tempt_GND_Tempt_GND)/pb2/pb2+2*(ved_jct-vec)*pb2_Tempt_GND*pb2_Tempt_GND/pb2/pb2/pb2));
#endif
#endif
arg=(1.0-((ved_jct-vec)/pb2));
EXIT_IF_ISNAN((1.0-((ved_jct-vec)/pb2)))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGD2==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD2)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD2)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD2)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD2)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD2)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD2)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)),((-pModel->MJSWGD2)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD2)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGD2)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vdi_d_Vdi_d=0.0;
  Qedj3_Vdi_d_Vsi_s=0.0;
  Qedj3_Vdi_d_Tempt_GND=0.0;
  Qedj3_Vdi_d_Vge_di=0.0;
  Qedj3_Vdi_d_Vge_e=0.0;
  Qedj3_Vdi_d_Ve_si=0.0;
  Qedj3_Vdi_d_Ve_di=0.0;
  Qedj3_Vdi_d_Vge_si=0.0;
  Qedj3_Vdi_d_Vdi_si=0.0;
#endif
Qedj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vsi_s_Vdi_d=0.0;
  Qedj3_Vsi_s_Vsi_s=0.0;
  Qedj3_Vsi_s_Tempt_GND=0.0;
  Qedj3_Vsi_s_Vge_di=0.0;
  Qedj3_Vsi_s_Vge_e=0.0;
  Qedj3_Vsi_s_Ve_si=0.0;
  Qedj3_Vsi_s_Ve_di=0.0;
  Qedj3_Vsi_s_Vge_si=0.0;
  Qedj3_Vsi_s_Vdi_si=0.0;
#endif
Qedj3_Tempt_GND=(Qec_Tempt_GND+((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Tempt_GND_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Tempt_GND=(+Qec_Tempt_GND_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*pb2_Tempt_GND+pModel->SJSWGD*pb2_Tempt_GND_Tempt_GND)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Vge_di=(+Qec_Tempt_GND_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Vge_e=(+Qec_Tempt_GND_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Ve_si=(+Qec_Tempt_GND_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Ve_di=(+Qec_Tempt_GND_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Vge_si=(+Qec_Tempt_GND_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Tempt_GND_Vdi_si=(+Qec_Tempt_GND_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*pb2_Tempt_GND+pModel->SJSWGD*0.0)*Czbdswg+(pModel->SJSWGD*pb2_Tempt_GND)*0.0+(0.0)*Czbdswg_Tempt_GND+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+(((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((((pModel->SJSWGD*pb2_Tempt_GND)*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Vge_di=(Qec_Vge_di+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Vge_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Tempt_GND=(+Qec_Vge_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Vge_di=(+Qec_Vge_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Vge_e=(+Qec_Vge_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Ve_si=(+Qec_Vge_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Ve_di=(+Qec_Vge_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Vge_si=(+Qec_Vge_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_di_Vdi_si=(+Qec_Vge_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Vge_e=(Qec_Vge_e+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Vge_e_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Tempt_GND=(+Qec_Vge_e_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Vge_di=(+Qec_Vge_e_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Vge_e=(+Qec_Vge_e_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Ve_si=(+Qec_Vge_e_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Ve_di=(+Qec_Vge_e_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Vge_si=(+Qec_Vge_e_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_e_Vdi_si=(+Qec_Vge_e_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Ve_si=(Qec_Ve_si+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Ve_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Tempt_GND=(+Qec_Ve_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Vge_di=(+Qec_Ve_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Vge_e=(+Qec_Ve_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Ve_si=(+Qec_Ve_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Ve_di=(+Qec_Ve_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Vge_si=(+Qec_Ve_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_si_Vdi_si=(+Qec_Ve_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Ve_di=(Qec_Ve_di+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Ve_di_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Tempt_GND=(+Qec_Ve_di_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Vge_di=(+Qec_Ve_di_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Vge_e=(+Qec_Ve_di_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Ve_si=(+Qec_Ve_di_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Ve_di=(+Qec_Ve_di_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Vge_si=(+Qec_Ve_di_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Ve_di_Vdi_si=(+Qec_Ve_di_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Vge_si=(Qec_Vge_si+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Vge_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Tempt_GND=(+Qec_Vge_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Vge_di=(+Qec_Vge_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Vge_e=(+Qec_Vge_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Ve_si=(+Qec_Vge_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Ve_di=(+Qec_Vge_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Vge_si=(+Qec_Vge_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vge_si_Vdi_si=(+Qec_Vge_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
Qedj3_Vdi_si=(Qec_Vdi_si+((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGD2)));
#if defined(_DERIVATE2)
  Qedj3_Vdi_si_Vdi_d=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Vsi_s=(+0.0+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(0.0)))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Tempt_GND=(+Qec_Vdi_si_Tempt_GND+((+(+(+0.0*pb2+0.0*pb2_Tempt_GND+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*Czbdswg_Tempt_GND+((pModel->SJSWGD*pb2_Tempt_GND))*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((((pModel->SJSWGD*pb2_Tempt_GND))*Czbdswg)+((pModel->SJSWGD*pb2)*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Vge_di=(+Qec_Vdi_si_Vge_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Vge_e=(+Qec_Vdi_si_Vge_e+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Ve_si=(+Qec_Vdi_si_Ve_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Ve_di=(+Qec_Vdi_si_Ve_di+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Vge_si=(+Qec_Vdi_si_Vge_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
  Qedj3_Vdi_si_Vdi_si=(+Qec_Vdi_si_Vdi_si+((+(+(+0.0*pb2+0.0*0.0+0.0*0.0+pModel->SJSWGD*0.0)*Czbdswg+0.0*0.0+(0.0)*0.0+(pModel->SJSWGD*pb2)*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+((0.0)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+((pModel->SJSWGD*pb2)*Czbdswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGD2)-((((pModel->SJSWGD*pb2)*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+(((((0.0)*Czbdswg)*(1.0-(arg*sarg)))+(((pModel->SJSWGD*pb2)*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)+2*(((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)/(1.0-pModel->MJSWGD2)));
#endif
#endif
Qedj3=(Qec+((((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD2)));
EXIT_IF_ISNAN((Qec+((((pModel->SJSWGD*pb2)*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD2))))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
arg_Vge_di=(-T1_Vge_di);
#if defined(_DERIVATE2)
  arg_Vge_di_Vge_di=(+0.0-T1_Vge_di_Vge_di);
  arg_Vge_di_Vge_e=(+0.0-T1_Vge_di_Vge_e);
  arg_Vge_di_Ve_si=(+0.0-T1_Vge_di_Ve_si);
  arg_Vge_di_Ve_di=(+0.0-T1_Vge_di_Ve_di);
  arg_Vge_di_Vge_si=(+0.0-T1_Vge_di_Vge_si);
  arg_Vge_di_Vdi_si=(+0.0-T1_Vge_di_Vdi_si);
  arg_Vge_di_Tempt_GND=(+0.0-T1_Vge_di_Tempt_GND);
#endif
arg_Vge_e=(-T1_Vge_e);
#if defined(_DERIVATE2)
  arg_Vge_e_Vge_di=(+0.0-T1_Vge_e_Vge_di);
  arg_Vge_e_Vge_e=(+0.0-T1_Vge_e_Vge_e);
  arg_Vge_e_Ve_si=(+0.0-T1_Vge_e_Ve_si);
  arg_Vge_e_Ve_di=(+0.0-T1_Vge_e_Ve_di);
  arg_Vge_e_Vge_si=(+0.0-T1_Vge_e_Vge_si);
  arg_Vge_e_Vdi_si=(+0.0-T1_Vge_e_Vdi_si);
  arg_Vge_e_Tempt_GND=(+0.0-T1_Vge_e_Tempt_GND);
#endif
arg_Ve_si=(-T1_Ve_si);
#if defined(_DERIVATE2)
  arg_Ve_si_Vge_di=(+0.0-T1_Ve_si_Vge_di);
  arg_Ve_si_Vge_e=(+0.0-T1_Ve_si_Vge_e);
  arg_Ve_si_Ve_si=(+0.0-T1_Ve_si_Ve_si);
  arg_Ve_si_Ve_di=(+0.0-T1_Ve_si_Ve_di);
  arg_Ve_si_Vge_si=(+0.0-T1_Ve_si_Vge_si);
  arg_Ve_si_Vdi_si=(+0.0-T1_Ve_si_Vdi_si);
  arg_Ve_si_Tempt_GND=(+0.0-T1_Ve_si_Tempt_GND);
#endif
arg_Ve_di=(-T1_Ve_di);
#if defined(_DERIVATE2)
  arg_Ve_di_Vge_di=(+0.0-T1_Ve_di_Vge_di);
  arg_Ve_di_Vge_e=(+0.0-T1_Ve_di_Vge_e);
  arg_Ve_di_Ve_si=(+0.0-T1_Ve_di_Ve_si);
  arg_Ve_di_Ve_di=(+0.0-T1_Ve_di_Ve_di);
  arg_Ve_di_Vge_si=(+0.0-T1_Ve_di_Vge_si);
  arg_Ve_di_Vdi_si=(+0.0-T1_Ve_di_Vdi_si);
  arg_Ve_di_Tempt_GND=(+0.0-T1_Ve_di_Tempt_GND);
#endif
arg_Vge_si=(-T1_Vge_si);
#if defined(_DERIVATE2)
  arg_Vge_si_Vge_di=(+0.0-T1_Vge_si_Vge_di);
  arg_Vge_si_Vge_e=(+0.0-T1_Vge_si_Vge_e);
  arg_Vge_si_Ve_si=(+0.0-T1_Vge_si_Ve_si);
  arg_Vge_si_Ve_di=(+0.0-T1_Vge_si_Ve_di);
  arg_Vge_si_Vge_si=(+0.0-T1_Vge_si_Vge_si);
  arg_Vge_si_Vdi_si=(+0.0-T1_Vge_si_Vdi_si);
  arg_Vge_si_Tempt_GND=(+0.0-T1_Vge_si_Tempt_GND);
#endif
arg_Vdi_si=(-T1_Vdi_si);
#if defined(_DERIVATE2)
  arg_Vdi_si_Vge_di=(+0.0-T1_Vdi_si_Vge_di);
  arg_Vdi_si_Vge_e=(+0.0-T1_Vdi_si_Vge_e);
  arg_Vdi_si_Ve_si=(+0.0-T1_Vdi_si_Ve_si);
  arg_Vdi_si_Ve_di=(+0.0-T1_Vdi_si_Ve_di);
  arg_Vdi_si_Vge_si=(+0.0-T1_Vdi_si_Vge_si);
  arg_Vdi_si_Vdi_si=(+0.0-T1_Vdi_si_Vdi_si);
  arg_Vdi_si_Tempt_GND=(+0.0-T1_Vdi_si_Tempt_GND);
#endif
arg_Tempt_GND=(-T1_Tempt_GND);
#if defined(_DERIVATE2)
  arg_Tempt_GND_Vge_di=(+0.0-T1_Tempt_GND_Vge_di);
  arg_Tempt_GND_Vge_e=(+0.0-T1_Tempt_GND_Vge_e);
  arg_Tempt_GND_Ve_si=(+0.0-T1_Tempt_GND_Ve_si);
  arg_Tempt_GND_Ve_di=(+0.0-T1_Tempt_GND_Ve_di);
  arg_Tempt_GND_Vge_si=(+0.0-T1_Tempt_GND_Vge_si);
  arg_Tempt_GND_Vdi_si=(+0.0-T1_Tempt_GND_Vdi_si);
  arg_Tempt_GND_Tempt_GND=(+0.0-T1_Tempt_GND_Tempt_GND);
#endif
#endif
arg=(1.0-T1);
EXIT_IF_ISNAN((1.0-T1))
#endif
#ifdef _DYNAMIC
if
((pModel->MJSWGD==0.5))
{
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,arg)
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,arg)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=(-arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_di+d10_sqrt0*arg_Vge_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_di+d10_sqrt0*arg_Vge_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_di+d10_sqrt0*arg_Vge_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_e=(-arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_e+d10_sqrt0*arg_Vge_e_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_e+d10_sqrt0*arg_Vge_e_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_e_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_e*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_e+d10_sqrt0*arg_Vge_e_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_e*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_si=(-arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_si+d10_sqrt0*arg_Ve_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_si+d10_sqrt0*arg_Ve_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_si+d10_sqrt0*arg_Ve_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Ve_di=(-arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Ve_di+d10_sqrt0*arg_Ve_di_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Ve_di+d10_sqrt0*arg_Ve_di_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Ve_di_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Ve_di*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Ve_di+d10_sqrt0*arg_Ve_di_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Ve_di*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vge_si=(-arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vge_si+d10_sqrt0*arg_Vge_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vge_si+d10_sqrt0*arg_Vge_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vge_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vge_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vge_si+d10_sqrt0*arg_Vge_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vge_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Vdi_si=(-arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Vdi_si_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Vdi_si*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Vdi_si+d10_sqrt0*arg_Vdi_si_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Vdi_si*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
sarg_Tempt_GND=(-arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0);
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(0.0/d00_sqrt0-(0.0*arg_Vge_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_e=(0.0/d00_sqrt0-(0.0*arg_Vge_e*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_e*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_e))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_e*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_si=(0.0/d00_sqrt0-(0.0*arg_Ve_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Ve_di=(0.0/d00_sqrt0-(0.0*arg_Ve_di*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Ve_di*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Ve_di))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Ve_di*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vge_si=(0.0/d00_sqrt0-(0.0*arg_Vge_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vge_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vge_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vge_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Vdi_si=(0.0/d00_sqrt0-(0.0*arg_Vdi_si*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Vdi_si*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Vdi_si))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Vdi_si*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
  sarg_Tempt_GND_Tempt_GND=(0.0/d00_sqrt0-(0.0*arg_Tempt_GND*d10_sqrt0+0.0*arg_Tempt_GND*d10_sqrt0+1.0*(m20_sqrt(arg)*arg_Tempt_GND*arg_Tempt_GND+d10_sqrt0*arg_Tempt_GND_Tempt_GND))/d00_sqrt0/d00_sqrt0+2*1.0*arg_Tempt_GND*d10_sqrt0*arg_Tempt_GND*d10_sqrt0/d00_sqrt0/d00_sqrt0/d00_sqrt0);
#endif
#endif
sarg=(1.0/d00_sqrt0);
EXIT_IF_ISNAN((1.0/d00_sqrt0))
}
#endif
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
sarg_Vge_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_di)));
#if defined(_DERIVATE2)
  sarg_Vge_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_di);
  sarg_Vge_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_e);
  sarg_Vge_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_si);
  sarg_Vge_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Ve_di);
  sarg_Vge_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vge_si);
  sarg_Vge_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Vdi_si);
  sarg_Vge_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+0.0*bsimcmg_d_lln(arg,arg_Vge_di)+(-pModel->MJSWGD)*arg_Vge_di_Tempt_GND);
#endif
sarg_Vge_e=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_e)));
#if defined(_DERIVATE2)
  sarg_Vge_e_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_di);
  sarg_Vge_e_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_e);
  sarg_Vge_e_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_si);
  sarg_Vge_e_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Ve_di);
  sarg_Vge_e_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vge_si);
  sarg_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Vdi_si);
  sarg_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+0.0*bsimcmg_d_lln(arg,arg_Vge_e)+(-pModel->MJSWGD)*arg_Vge_e_Tempt_GND);
#endif
sarg_Ve_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_si)));
#if defined(_DERIVATE2)
  sarg_Ve_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_di);
  sarg_Ve_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_e);
  sarg_Ve_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_si);
  sarg_Ve_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Ve_di);
  sarg_Ve_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vge_si);
  sarg_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Vdi_si);
  sarg_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+0.0*bsimcmg_d_lln(arg,arg_Ve_si)+(-pModel->MJSWGD)*arg_Ve_si_Tempt_GND);
#endif
sarg_Ve_di=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Ve_di)));
#if defined(_DERIVATE2)
  sarg_Ve_di_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_di);
  sarg_Ve_di_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_e);
  sarg_Ve_di_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_si);
  sarg_Ve_di_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Ve_di);
  sarg_Ve_di_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vge_si);
  sarg_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Vdi_si);
  sarg_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+0.0*bsimcmg_d_lln(arg,arg_Ve_di)+(-pModel->MJSWGD)*arg_Ve_di_Tempt_GND);
#endif
sarg_Vge_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vge_si)));
#if defined(_DERIVATE2)
  sarg_Vge_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_di);
  sarg_Vge_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_e);
  sarg_Vge_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_si);
  sarg_Vge_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Ve_di);
  sarg_Vge_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vge_si);
  sarg_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Vdi_si);
  sarg_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+0.0*bsimcmg_d_lln(arg,arg_Vge_si)+(-pModel->MJSWGD)*arg_Vge_si_Tempt_GND);
#endif
sarg_Vdi_si=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Vdi_si)));
#if defined(_DERIVATE2)
  sarg_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_di);
  sarg_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_e);
  sarg_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_si);
  sarg_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Ve_di);
  sarg_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vge_si);
  sarg_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Vdi_si);
  sarg_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+0.0*bsimcmg_d_lln(arg,arg_Vdi_si)+(-pModel->MJSWGD)*arg_Vdi_si_Tempt_GND);
#endif
sarg_Tempt_GND=bsimcmg_d_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)),((-pModel->MJSWGD)*bsimcmg_d_lln(arg,arg_Tempt_GND)));
#if defined(_DERIVATE2)
  sarg_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_di);
  sarg_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_e);
  sarg_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_si);
  sarg_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Ve_di);
  sarg_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vge_si);
  sarg_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Vdi_si);
  sarg_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(arg)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+0.0*bsimcmg_d_lln(arg,arg_Tempt_GND)+(-pModel->MJSWGD)*arg_Tempt_GND_Tempt_GND);
#endif
#endif
sarg=bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(arg))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vdi_d_Vdi_d=0.0;
  Qedj3_Vdi_d_Vsi_s=0.0;
  Qedj3_Vdi_d_Tempt_GND=0.0;
  Qedj3_Vdi_d_Vge_di=0.0;
  Qedj3_Vdi_d_Vge_e=0.0;
  Qedj3_Vdi_d_Ve_si=0.0;
  Qedj3_Vdi_d_Ve_di=0.0;
  Qedj3_Vdi_d_Vge_si=0.0;
  Qedj3_Vdi_d_Vdi_si=0.0;
#endif
Qedj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vsi_s_Vdi_d=0.0;
  Qedj3_Vsi_s_Vsi_s=0.0;
  Qedj3_Vsi_s_Tempt_GND=0.0;
  Qedj3_Vsi_s_Vge_di=0.0;
  Qedj3_Vsi_s_Vge_e=0.0;
  Qedj3_Vsi_s_Ve_si=0.0;
  Qedj3_Vsi_s_Ve_di=0.0;
  Qedj3_Vsi_s_Vge_si=0.0;
  Qedj3_Vsi_s_Vdi_si=0.0;
#endif
Qedj3_Tempt_GND=(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Tempt_GND_Vdi_d=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vsi_s=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(0.0))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Tempt_GND*0.0+0.0*sarg_Tempt_GND+arg*0.0)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Tempt_GND=((+(+PBSWGD_t_Tempt_GND_Tempt_GND*Czbdswg+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t*Czbdswg_Tempt_GND_Tempt_GND)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Tempt_GND*sarg+arg_Tempt_GND*sarg_Tempt_GND+arg_Tempt_GND*sarg_Tempt_GND+arg*sarg_Tempt_GND_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_di*sarg+arg_Tempt_GND*sarg_Vge_di+arg_Vge_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_e=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_e*sarg+arg_Tempt_GND*sarg_Vge_e+arg_Vge_e*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_e)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Ve_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_si*sarg+arg_Tempt_GND*sarg_Ve_si+arg_Ve_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Ve_di=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Ve_di*sarg+arg_Tempt_GND*sarg_Ve_di+arg_Ve_di*sarg_Tempt_GND+arg*sarg_Tempt_GND_Ve_di)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vge_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vge_si*sarg+arg_Tempt_GND*sarg_Vge_si+arg_Vge_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vge_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Tempt_GND_Vdi_si=((+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(1.0-(arg*sarg))+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Tempt_GND_Vdi_si*sarg+arg_Tempt_GND*sarg_Vdi_si+arg_Vdi_si*sarg_Tempt_GND+arg*sarg_Tempt_GND_Vdi_si)))/(1.0-pModel->MJSWGD)-(((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_di=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_di_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_di*0.0+0.0*sarg_Vge_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Tempt_GND*sarg+arg_Vge_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_di+arg*sarg_Vge_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_di*sarg+arg_Vge_di*sarg_Vge_di+arg_Vge_di*sarg_Vge_di+arg*sarg_Vge_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_e*sarg+arg_Vge_di*sarg_Vge_e+arg_Vge_e*sarg_Vge_di+arg*sarg_Vge_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_si*sarg+arg_Vge_di*sarg_Ve_si+arg_Ve_si*sarg_Vge_di+arg*sarg_Vge_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Ve_di*sarg+arg_Vge_di*sarg_Ve_di+arg_Ve_di*sarg_Vge_di+arg*sarg_Vge_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vge_si*sarg+arg_Vge_di*sarg_Vge_si+arg_Vge_si*sarg_Vge_di+arg*sarg_Vge_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_di_Vdi_si*sarg+arg_Vge_di*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_di+arg*sarg_Vge_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_e=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_e_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_e*0.0+0.0*sarg_Vge_e+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Tempt_GND*sarg+arg_Vge_e*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_e+arg*sarg_Vge_e_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_di*sarg+arg_Vge_e*sarg_Vge_di+arg_Vge_di*sarg_Vge_e+arg*sarg_Vge_e_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_e*sarg+arg_Vge_e*sarg_Vge_e+arg_Vge_e*sarg_Vge_e+arg*sarg_Vge_e_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_si*sarg+arg_Vge_e*sarg_Ve_si+arg_Ve_si*sarg_Vge_e+arg*sarg_Vge_e_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Ve_di*sarg+arg_Vge_e*sarg_Ve_di+arg_Ve_di*sarg_Vge_e+arg*sarg_Vge_e_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vge_si*sarg+arg_Vge_e*sarg_Vge_si+arg_Vge_si*sarg_Vge_e+arg*sarg_Vge_e_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_e_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_e_Vdi_si*sarg+arg_Vge_e*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_e+arg*sarg_Vge_e_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Ve_si=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Ve_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_si*0.0+0.0*sarg_Ve_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Tempt_GND*sarg+arg_Ve_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_si+arg*sarg_Ve_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_di*sarg+arg_Ve_si*sarg_Vge_di+arg_Vge_di*sarg_Ve_si+arg*sarg_Ve_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_e*sarg+arg_Ve_si*sarg_Vge_e+arg_Vge_e*sarg_Ve_si+arg*sarg_Ve_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_si*sarg+arg_Ve_si*sarg_Ve_si+arg_Ve_si*sarg_Ve_si+arg*sarg_Ve_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Ve_di*sarg+arg_Ve_si*sarg_Ve_di+arg_Ve_di*sarg_Ve_si+arg*sarg_Ve_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vge_si*sarg+arg_Ve_si*sarg_Vge_si+arg_Vge_si*sarg_Ve_si+arg*sarg_Ve_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_si_Vdi_si*sarg+arg_Ve_si*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_si+arg*sarg_Ve_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Ve_di=(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Ve_di_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Ve_di*0.0+0.0*sarg_Ve_di+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Tempt_GND*sarg+arg_Ve_di*sarg_Tempt_GND+arg_Tempt_GND*sarg_Ve_di+arg*sarg_Ve_di_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_di*sarg+arg_Ve_di*sarg_Vge_di+arg_Vge_di*sarg_Ve_di+arg*sarg_Ve_di_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_e*sarg+arg_Ve_di*sarg_Vge_e+arg_Vge_e*sarg_Ve_di+arg*sarg_Ve_di_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_si*sarg+arg_Ve_di*sarg_Ve_si+arg_Ve_si*sarg_Ve_di+arg*sarg_Ve_di_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Ve_di*sarg+arg_Ve_di*sarg_Ve_di+arg_Ve_di*sarg_Ve_di+arg*sarg_Ve_di_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vge_si*sarg+arg_Ve_di*sarg_Vge_si+arg_Vge_si*sarg_Ve_di+arg*sarg_Ve_di_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Ve_di_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Ve_di_Vdi_si*sarg+arg_Ve_di*sarg_Vdi_si+arg_Vdi_si*sarg_Ve_di+arg*sarg_Ve_di_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vge_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vge_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vge_si*0.0+0.0*sarg_Vge_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Tempt_GND*sarg+arg_Vge_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vge_si+arg*sarg_Vge_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_di*sarg+arg_Vge_si*sarg_Vge_di+arg_Vge_di*sarg_Vge_si+arg*sarg_Vge_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_e*sarg+arg_Vge_si*sarg_Vge_e+arg_Vge_e*sarg_Vge_si+arg*sarg_Vge_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_si*sarg+arg_Vge_si*sarg_Ve_si+arg_Ve_si*sarg_Vge_si+arg*sarg_Vge_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Ve_di*sarg+arg_Vge_si*sarg_Ve_di+arg_Ve_di*sarg_Vge_si+arg*sarg_Vge_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vge_si*sarg+arg_Vge_si*sarg_Vge_si+arg_Vge_si*sarg_Vge_si+arg*sarg_Vge_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vge_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vge_si_Vdi_si*sarg+arg_Vge_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vge_si+arg*sarg_Vge_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
Qedj3_Vdi_si=(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))/(1.0-pModel->MJSWGD));
#if defined(_DERIVATE2)
  Qedj3_Vdi_si_Vdi_d=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vsi_s=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(0.0))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+0.0*sarg+arg_Vdi_si*0.0+0.0*sarg_Vdi_si+arg*0.0)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(0.0)))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Tempt_GND=((+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND))))+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Tempt_GND*sarg+arg_Vdi_si*sarg_Tempt_GND+arg_Tempt_GND*sarg_Vdi_si+arg*sarg_Vdi_si_Tempt_GND)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Tempt_GND*sarg)+(arg*sarg_Tempt_GND)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_di*sarg+arg_Vdi_si*sarg_Vge_di+arg_Vge_di*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_di*sarg)+(arg*sarg_Vge_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_e=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_e*sarg+arg_Vdi_si*sarg_Vge_e+arg_Vge_e*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_e)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_e*sarg)+(arg*sarg_Vge_e)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Ve_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_si*sarg+arg_Vdi_si*sarg_Ve_si+arg_Ve_si*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_si*sarg)+(arg*sarg_Ve_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Ve_di=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Ve_di*sarg+arg_Vdi_si*sarg_Ve_di+arg_Ve_di*sarg_Vdi_si+arg*sarg_Vdi_si_Ve_di)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Ve_di*sarg)+(arg*sarg_Ve_di)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vge_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vge_si*sarg+arg_Vdi_si*sarg_Vge_si+arg_Vge_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vge_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vge_si*sarg)+(arg*sarg_Vge_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
  Qedj3_Vdi_si_Vdi_si=((+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(1.0-(arg*sarg))+0.0*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))+(0.0)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))+(PBSWGD_t*Czbdswg)*(+0.0-(+arg_Vdi_si_Vdi_si*sarg+arg_Vdi_si*sarg_Vdi_si+arg_Vdi_si*sarg_Vdi_si+arg*sarg_Vdi_si_Vdi_si)))/(1.0-pModel->MJSWGD)-(((PBSWGD_t*Czbdswg)*(-((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si))))*0.0+((((0.0)*(1.0-(arg*sarg)))+((PBSWGD_t*Czbdswg)*(-(((arg_Vdi_si*sarg)+(arg*sarg_Vdi_si)))))))*0.0+((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*(+0.0-0.0))/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)+2*((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))*0.0*0.0/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD)/(1.0-pModel->MJSWGD));
#endif
#endif
Qedj3=(((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD));
EXIT_IF_ISNAN((((PBSWGD_t*Czbdswg)*(1.0-(arg*sarg)))/(1.0-pModel->MJSWGD)))
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=0.0;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=0.0;
  T2_Vge_e_Vsi_s=0.0;
  T2_Vge_e_Vge_di=0.0;
  T2_Vge_e_Vge_e=0.0;
  T2_Vge_e_Vge_si=0.0;
  T2_Vge_e_Ve_si=0.0;
  T2_Vge_e_Ve_di=0.0;
  T2_Vge_e_Vdi_si=0.0;
  T2_Vge_e_Tempt_GND=0.0;
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(0.1)));
EXIT_IF_ISNAN(bsimcmg_lexp(((-pModel->MJSWGD)*bsimcmg_lln(0.1))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=0.0;
  T3_Tempt_GND_Vsi_s=0.0;
  T3_Tempt_GND_Vge_di=0.0;
  T3_Tempt_GND_Vge_e=0.0;
  T3_Tempt_GND_Vdi_si=0.0;
  T3_Tempt_GND_Ve_si=0.0;
  T3_Tempt_GND_Ve_di=0.0;
  T3_Tempt_GND_Vge_si=0.0;
  T3_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T3=(1.0/(1.0-pModel->MJSWGD));
EXIT_IF_ISNAN((1.0/(1.0-pModel->MJSWGD)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vge_di)));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+(+T2_Vge_di_Vge_di*(T1-1.0)+T2_Vge_di*T1_Vge_di+T2_Vge_di*T1_Vge_di+T2*(+T1_Vge_di_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_e=(+(+T2_Vge_di_Vge_e*(T1-1.0)+T2_Vge_di*T1_Vge_e+T2_Vge_e*T1_Vge_di+T2*(+T1_Vge_di_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vdi_si=(+(+T2_Vge_di_Vdi_si*(T1-1.0)+T2_Vge_di*T1_Vdi_si+T2_Vdi_si*T1_Vge_di+T2*(+T1_Vge_di_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_si=(+(+T2_Vge_di_Ve_si*(T1-1.0)+T2_Vge_di*T1_Ve_si+T2_Ve_si*T1_Vge_di+T2*(+T1_Vge_di_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Ve_di=(+(+T2_Vge_di_Ve_di*(T1-1.0)+T2_Vge_di*T1_Ve_di+T2_Ve_di*T1_Vge_di+T2*(+T1_Vge_di_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_di_Vge_si=(+(+T2_Vge_di_Vge_si*(T1-1.0)+T2_Vge_di*T1_Vge_si+T2_Vge_si*T1_Vge_di+T2*(+T1_Vge_di_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_di_Tempt_GND=(+(+T2_Vge_di_Tempt_GND*(T1-1.0)+T2_Vge_di*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_di+T2*(+T1_Vge_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Vge_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(5.0*pModel->MJSWGD)*(+T1_Vge_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_e=((((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vge_e)));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+(+T2_Vge_e_Vge_di*(T1-1.0)+T2_Vge_e*T1_Vge_di+T2_Vge_di*T1_Vge_e+T2*(+T1_Vge_e_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_e=(+(+T2_Vge_e_Vge_e*(T1-1.0)+T2_Vge_e*T1_Vge_e+T2_Vge_e*T1_Vge_e+T2*(+T1_Vge_e_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vdi_si=(+(+T2_Vge_e_Vdi_si*(T1-1.0)+T2_Vge_e*T1_Vdi_si+T2_Vdi_si*T1_Vge_e+T2*(+T1_Vge_e_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_si=(+(+T2_Vge_e_Ve_si*(T1-1.0)+T2_Vge_e*T1_Ve_si+T2_Ve_si*T1_Vge_e+T2*(+T1_Vge_e_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Ve_di=(+(+T2_Vge_e_Ve_di*(T1-1.0)+T2_Vge_e*T1_Ve_di+T2_Ve_di*T1_Vge_e+T2*(+T1_Vge_e_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_e_Vge_si=(+(+T2_Vge_e_Vge_si*(T1-1.0)+T2_Vge_e*T1_Vge_si+T2_Vge_si*T1_Vge_e+T2*(+T1_Vge_e_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_e_Tempt_GND=(+(+T2_Vge_e_Tempt_GND*(T1-1.0)+T2_Vge_e*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_e+T2*(+T1_Vge_e_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Vge_e)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(5.0*pModel->MJSWGD)*(+T1_Vge_e_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vdi_si=((((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vdi_si)));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+(+T2_Vdi_si_Vge_di*(T1-1.0)+T2_Vdi_si*T1_Vge_di+T2_Vge_di*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_e=(+(+T2_Vdi_si_Vge_e*(T1-1.0)+T2_Vdi_si*T1_Vge_e+T2_Vge_e*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vdi_si=(+(+T2_Vdi_si_Vdi_si*(T1-1.0)+T2_Vdi_si*T1_Vdi_si+T2_Vdi_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_si=(+(+T2_Vdi_si_Ve_si*(T1-1.0)+T2_Vdi_si*T1_Ve_si+T2_Ve_si*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Ve_di=(+(+T2_Vdi_si_Ve_di*(T1-1.0)+T2_Vdi_si*T1_Ve_di+T2_Ve_di*T1_Vdi_si+T2*(+T1_Vdi_si_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Vge_si=(+(+T2_Vdi_si_Vge_si*(T1-1.0)+T2_Vdi_si*T1_Vge_si+T2_Vge_si*T1_Vdi_si+T2*(+T1_Vdi_si_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vdi_si_Tempt_GND=(+(+T2_Vdi_si_Tempt_GND*(T1-1.0)+T2_Vdi_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vdi_si+T2*(+T1_Vdi_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Vdi_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(5.0*pModel->MJSWGD)*(+T1_Vdi_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_si=((((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Ve_si)));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+(+T2_Ve_si_Vge_di*(T1-1.0)+T2_Ve_si*T1_Vge_di+T2_Vge_di*T1_Ve_si+T2*(+T1_Ve_si_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_e=(+(+T2_Ve_si_Vge_e*(T1-1.0)+T2_Ve_si*T1_Vge_e+T2_Vge_e*T1_Ve_si+T2*(+T1_Ve_si_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vdi_si=(+(+T2_Ve_si_Vdi_si*(T1-1.0)+T2_Ve_si*T1_Vdi_si+T2_Vdi_si*T1_Ve_si+T2*(+T1_Ve_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_si=(+(+T2_Ve_si_Ve_si*(T1-1.0)+T2_Ve_si*T1_Ve_si+T2_Ve_si*T1_Ve_si+T2*(+T1_Ve_si_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Ve_di=(+(+T2_Ve_si_Ve_di*(T1-1.0)+T2_Ve_si*T1_Ve_di+T2_Ve_di*T1_Ve_si+T2*(+T1_Ve_si_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_si_Vge_si=(+(+T2_Ve_si_Vge_si*(T1-1.0)+T2_Ve_si*T1_Vge_si+T2_Vge_si*T1_Ve_si+T2*(+T1_Ve_si_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_si_Tempt_GND=(+(+T2_Ve_si_Tempt_GND*(T1-1.0)+T2_Ve_si*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_si+T2*(+T1_Ve_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Ve_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(5.0*pModel->MJSWGD)*(+T1_Ve_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Ve_di=((((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Ve_di)));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+(+T2_Ve_di_Vge_di*(T1-1.0)+T2_Ve_di*T1_Vge_di+T2_Vge_di*T1_Ve_di+T2*(+T1_Ve_di_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Vge_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_e=(+(+T2_Ve_di_Vge_e*(T1-1.0)+T2_Ve_di*T1_Vge_e+T2_Vge_e*T1_Ve_di+T2*(+T1_Ve_di_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Vge_e-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vdi_si=(+(+T2_Ve_di_Vdi_si*(T1-1.0)+T2_Ve_di*T1_Vdi_si+T2_Vdi_si*T1_Ve_di+T2*(+T1_Ve_di_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_si=(+(+T2_Ve_di_Ve_si*(T1-1.0)+T2_Ve_di*T1_Ve_si+T2_Ve_si*T1_Ve_di+T2*(+T1_Ve_di_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Ve_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Ve_di=(+(+T2_Ve_di_Ve_di*(T1-1.0)+T2_Ve_di*T1_Ve_di+T2_Ve_di*T1_Ve_di+T2*(+T1_Ve_di_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Ve_di-0.0))+(+0.0+0.0)));
  T4_Ve_di_Vge_si=(+(+T2_Ve_di_Vge_si*(T1-1.0)+T2_Ve_di*T1_Vge_si+T2_Vge_si*T1_Ve_di+T2*(+T1_Ve_di_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Vge_si-0.0))+(+0.0+0.0)));
  T4_Ve_di_Tempt_GND=(+(+T2_Ve_di_Tempt_GND*(T1-1.0)+T2_Ve_di*T1_Tempt_GND+T2_Tempt_GND*T1_Ve_di+T2*(+T1_Ve_di_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Ve_di)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(5.0*pModel->MJSWGD)*(+T1_Ve_di_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Vge_si=((((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Vge_si)));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+(+T2_Vge_si_Vge_di*(T1-1.0)+T2_Vge_si*T1_Vge_di+T2_Vge_di*T1_Vge_si+T2*(+T1_Vge_si_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Vge_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_e=(+(+T2_Vge_si_Vge_e*(T1-1.0)+T2_Vge_si*T1_Vge_e+T2_Vge_e*T1_Vge_si+T2*(+T1_Vge_si_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Vge_e-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vdi_si=(+(+T2_Vge_si_Vdi_si*(T1-1.0)+T2_Vge_si*T1_Vdi_si+T2_Vdi_si*T1_Vge_si+T2*(+T1_Vge_si_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_si=(+(+T2_Vge_si_Ve_si*(T1-1.0)+T2_Vge_si*T1_Ve_si+T2_Ve_si*T1_Vge_si+T2*(+T1_Vge_si_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Ve_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Ve_di=(+(+T2_Vge_si_Ve_di*(T1-1.0)+T2_Vge_si*T1_Ve_di+T2_Ve_di*T1_Vge_si+T2*(+T1_Vge_si_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Ve_di-0.0))+(+0.0+0.0)));
  T4_Vge_si_Vge_si=(+(+T2_Vge_si_Vge_si*(T1-1.0)+T2_Vge_si*T1_Vge_si+T2_Vge_si*T1_Vge_si+T2*(+T1_Vge_si_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Vge_si-0.0))+(+0.0+0.0)));
  T4_Vge_si_Tempt_GND=(+(+T2_Vge_si_Tempt_GND*(T1-1.0)+T2_Vge_si*T1_Tempt_GND+T2_Tempt_GND*T1_Vge_si+T2*(+T1_Vge_si_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Vge_si)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(5.0*pModel->MJSWGD)*(+T1_Vge_si_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
T4_Tempt_GND=((((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)))+((T2*(T1-1.0))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+(+T2_Tempt_GND_Vge_di*(T1-1.0)+T2_Tempt_GND*T1_Vge_di+T2_Vge_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_di)))+(((T2_Vge_di*(T1-1.0))+(T2*T1_Vge_di)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Vge_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_e=(+(+T2_Tempt_GND_Vge_e*(T1-1.0)+T2_Tempt_GND*T1_Vge_e+T2_Vge_e*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_e-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_e)))+(((T2_Vge_e*(T1-1.0))+(T2*T1_Vge_e)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Vge_e-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vdi_si=(+(+T2_Tempt_GND_Vdi_si*(T1-1.0)+T2_Tempt_GND*T1_Vdi_si+T2_Vdi_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vdi_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vdi_si)))+(((T2_Vdi_si*(T1-1.0))+(T2*T1_Vdi_si)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Vdi_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_si=(+(+T2_Tempt_GND_Ve_si*(T1-1.0)+T2_Tempt_GND*T1_Ve_si+T2_Ve_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_si)))+(((T2_Ve_si*(T1-1.0))+(T2*T1_Ve_si)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Ve_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Ve_di=(+(+T2_Tempt_GND_Ve_di*(T1-1.0)+T2_Tempt_GND*T1_Ve_di+T2_Ve_di*T1_Tempt_GND+T2*(+T1_Tempt_GND_Ve_di-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Ve_di)))+(((T2_Ve_di*(T1-1.0))+(T2*T1_Ve_di)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Ve_di-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Vge_si=(+(+T2_Tempt_GND_Vge_si*(T1-1.0)+T2_Tempt_GND*T1_Vge_si+T2_Vge_si*T1_Tempt_GND+T2*(+T1_Tempt_GND_Vge_si-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Vge_si)))+(((T2_Vge_si*(T1-1.0))+(T2*T1_Vge_si)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Vge_si-0.0))+(+0.0+0.0)));
  T4_Tempt_GND_Tempt_GND=(+(+T2_Tempt_GND_Tempt_GND*(T1-1.0)+T2_Tempt_GND*T1_Tempt_GND+T2_Tempt_GND*T1_Tempt_GND+T2*(+T1_Tempt_GND_Tempt_GND-0.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))+((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND))*((((0.0)*(T1-1.0))+((5.0*pModel->MJSWGD)*T1_Tempt_GND)))+(((T2_Tempt_GND*(T1-1.0))+(T2*T1_Tempt_GND)))*((5.0*pModel->MJSWGD)*T1_Tempt_GND)+(T2*(T1-1.0))*(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+5.0*0.0)*(T1-1.0)+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(5.0*pModel->MJSWGD)*(+T1_Tempt_GND_Tempt_GND-0.0))+(+0.0+0.0)));
#endif
#endif
T4=((T2*(T1-1.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD)));
EXIT_IF_ISNAN(((T2*(T1-1.0))*(((5.0*pModel->MJSWGD)*(T1-1.0))+(1.0+pModel->MJSWGD))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vge_di)));
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vdi_d)));
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vsi_s)));
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vge_e)));
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vdi_si)));
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Ve_si)));
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Ve_di)));
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Vge_si)));
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di_Tempt_GND)));
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((T3_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vge_di)));
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vdi_d)));
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vsi_s)));
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_e*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_e+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((T3_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vge_di)));
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vdi_d)));
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vsi_s)));
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vdi_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Vdi_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((T3_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vge_di)));
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vdi_d)));
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vsi_s)));
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((T3_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vge_di)));
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vdi_d)));
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vsi_s)));
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Ve_di*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Ve_di+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((T3_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vge_di)));
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vdi_d)));
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vsi_s)));
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Vge_si*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Vge_si+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((T3_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)))+(T3*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_di))))+T3_Vge_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vge_di)));
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_d))))+T3_Vdi_d*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_d+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vdi_d)));
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vsi_s))))+T3_Vsi_s*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vsi_s+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vsi_s)));
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_e))))+T3_Vge_e*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_e+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vdi_si))))+T3_Vdi_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vdi_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_si))))+T3_Ve_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Ve_di))))+T3_Ve_di*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Ve_di+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Vge_si))))+T3_Vge_si*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Vge_si+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))+T3_Tempt_GND*(-(((((0.0)*(1.0+pModel->MJSWGD))*T2)+(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))))+T3_Tempt_GND*(-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND))+T3*(+0.0-(+(+(+0.0*pModel->MJSWGD+0.0*0.0+0.0*0.0+0.05*0.0)*(1.0+pModel->MJSWGD)+0.0*0.0+(0.0)*0.0+(0.05*pModel->MJSWGD)*(+0.0+0.0))*T2+0.0*T2_Tempt_GND+((0.0)*(1.0+pModel->MJSWGD))*T2_Tempt_GND+((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=(T3*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2)));
EXIT_IF_ISNAN((T3*(1.0-(((0.05*pModel->MJSWGD)*(1.0+pModel->MJSWGD))*T2))))
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj3_Vdi_d=((PBSWGD_t*Czbdswg)*T5_Vdi_d);
#if defined(_DERIVATE2)
  Qedj3_Vdi_d_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vdi_d));
  Qedj3_Vdi_d_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vsi_s));
  Qedj3_Vdi_d_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Tempt_GND));
  Qedj3_Vdi_d_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vge_di));
  Qedj3_Vdi_d_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vge_e));
  Qedj3_Vdi_d_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Ve_si));
  Qedj3_Vdi_d_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Ve_di));
  Qedj3_Vdi_d_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vge_si));
  Qedj3_Vdi_d_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vdi_d+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_d_Vdi_si));
#endif
Qedj3_Vsi_s=((PBSWGD_t*Czbdswg)*T5_Vsi_s);
#if defined(_DERIVATE2)
  Qedj3_Vsi_s_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vdi_d));
  Qedj3_Vsi_s_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vsi_s));
  Qedj3_Vsi_s_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Tempt_GND));
  Qedj3_Vsi_s_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vge_di));
  Qedj3_Vsi_s_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vge_e));
  Qedj3_Vsi_s_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Ve_si));
  Qedj3_Vsi_s_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Ve_di));
  Qedj3_Vsi_s_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vge_si));
  Qedj3_Vsi_s_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*T5_Vsi_s+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vsi_s_Vdi_si));
#endif
Qedj3_Tempt_GND=((((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4+T5))+((PBSWGD_t*Czbdswg)*(T4_Tempt_GND+T5_Tempt_GND)));
#if defined(_DERIVATE2)
  Qedj3_Tempt_GND_Vdi_d=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*T5_Vdi_d+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Tempt_GND_Vdi_d));
  Qedj3_Tempt_GND_Vsi_s=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*T5_Vsi_s+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Tempt_GND_Vsi_s));
  Qedj3_Tempt_GND_Tempt_GND=(+(+PBSWGD_t_Tempt_GND_Tempt_GND*Czbdswg+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*Czbdswg_Tempt_GND+PBSWGD_t*Czbdswg_Tempt_GND_Tempt_GND)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Tempt_GND+T5_Tempt_GND_Tempt_GND));
  Qedj3_Tempt_GND_Vge_di=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Vge_di+T5_Tempt_GND_Vge_di));
  Qedj3_Tempt_GND_Vge_e=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Vge_e+T5_Tempt_GND_Vge_e));
  Qedj3_Tempt_GND_Ve_si=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Ve_si+T5_Tempt_GND_Ve_si));
  Qedj3_Tempt_GND_Ve_di=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Ve_di+T5_Tempt_GND_Ve_di));
  Qedj3_Tempt_GND_Vge_si=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Vge_si+T5_Tempt_GND_Vge_si));
  Qedj3_Tempt_GND_Vdi_si=(+(+0.0*Czbdswg+PBSWGD_t_Tempt_GND*0.0+0.0*Czbdswg_Tempt_GND+PBSWGD_t*0.0)*(T4+T5)+((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND))*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Tempt_GND+T5_Tempt_GND)+(PBSWGD_t*Czbdswg)*(+T4_Tempt_GND_Vdi_si+T5_Tempt_GND_Vdi_si));
#endif
Qedj3_Vge_di=((PBSWGD_t*Czbdswg)*(T4_Vge_di+T5_Vge_di));
#if defined(_DERIVATE2)
  Qedj3_Vge_di_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_di_Vdi_d));
  Qedj3_Vge_di_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_di_Vsi_s));
  Qedj3_Vge_di_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Tempt_GND+T5_Vge_di_Tempt_GND));
  Qedj3_Vge_di_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Vge_di+T5_Vge_di_Vge_di));
  Qedj3_Vge_di_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Vge_e+T5_Vge_di_Vge_e));
  Qedj3_Vge_di_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Ve_si+T5_Vge_di_Ve_si));
  Qedj3_Vge_di_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Ve_di+T5_Vge_di_Ve_di));
  Qedj3_Vge_di_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Vge_si+T5_Vge_di_Vge_si));
  Qedj3_Vge_di_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_di+T5_Vge_di)+(PBSWGD_t*Czbdswg)*(+T4_Vge_di_Vdi_si+T5_Vge_di_Vdi_si));
#endif
Qedj3_Vge_e=((PBSWGD_t*Czbdswg)*(T4_Vge_e+T5_Vge_e));
#if defined(_DERIVATE2)
  Qedj3_Vge_e_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_e_Vdi_d));
  Qedj3_Vge_e_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_e_Vsi_s));
  Qedj3_Vge_e_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Tempt_GND+T5_Vge_e_Tempt_GND));
  Qedj3_Vge_e_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Vge_di+T5_Vge_e_Vge_di));
  Qedj3_Vge_e_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Vge_e+T5_Vge_e_Vge_e));
  Qedj3_Vge_e_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Ve_si+T5_Vge_e_Ve_si));
  Qedj3_Vge_e_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Ve_di+T5_Vge_e_Ve_di));
  Qedj3_Vge_e_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Vge_si+T5_Vge_e_Vge_si));
  Qedj3_Vge_e_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_e+T5_Vge_e)+(PBSWGD_t*Czbdswg)*(+T4_Vge_e_Vdi_si+T5_Vge_e_Vdi_si));
#endif
Qedj3_Ve_si=((PBSWGD_t*Czbdswg)*(T4_Ve_si+T5_Ve_si));
#if defined(_DERIVATE2)
  Qedj3_Ve_si_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Ve_si_Vdi_d));
  Qedj3_Ve_si_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Ve_si_Vsi_s));
  Qedj3_Ve_si_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Tempt_GND+T5_Ve_si_Tempt_GND));
  Qedj3_Ve_si_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Vge_di+T5_Ve_si_Vge_di));
  Qedj3_Ve_si_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Vge_e+T5_Ve_si_Vge_e));
  Qedj3_Ve_si_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Ve_si+T5_Ve_si_Ve_si));
  Qedj3_Ve_si_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Ve_di+T5_Ve_si_Ve_di));
  Qedj3_Ve_si_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Vge_si+T5_Ve_si_Vge_si));
  Qedj3_Ve_si_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_si+T5_Ve_si)+(PBSWGD_t*Czbdswg)*(+T4_Ve_si_Vdi_si+T5_Ve_si_Vdi_si));
#endif
Qedj3_Ve_di=((PBSWGD_t*Czbdswg)*(T4_Ve_di+T5_Ve_di));
#if defined(_DERIVATE2)
  Qedj3_Ve_di_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Ve_di_Vdi_d));
  Qedj3_Ve_di_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Ve_di_Vsi_s));
  Qedj3_Ve_di_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Tempt_GND+T5_Ve_di_Tempt_GND));
  Qedj3_Ve_di_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Vge_di+T5_Ve_di_Vge_di));
  Qedj3_Ve_di_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Vge_e+T5_Ve_di_Vge_e));
  Qedj3_Ve_di_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Ve_si+T5_Ve_di_Ve_si));
  Qedj3_Ve_di_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Ve_di+T5_Ve_di_Ve_di));
  Qedj3_Ve_di_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Vge_si+T5_Ve_di_Vge_si));
  Qedj3_Ve_di_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Ve_di+T5_Ve_di)+(PBSWGD_t*Czbdswg)*(+T4_Ve_di_Vdi_si+T5_Ve_di_Vdi_si));
#endif
Qedj3_Vge_si=((PBSWGD_t*Czbdswg)*(T4_Vge_si+T5_Vge_si));
#if defined(_DERIVATE2)
  Qedj3_Vge_si_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_si_Vdi_d));
  Qedj3_Vge_si_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vge_si_Vsi_s));
  Qedj3_Vge_si_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Tempt_GND+T5_Vge_si_Tempt_GND));
  Qedj3_Vge_si_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Vge_di+T5_Vge_si_Vge_di));
  Qedj3_Vge_si_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Vge_e+T5_Vge_si_Vge_e));
  Qedj3_Vge_si_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Ve_si+T5_Vge_si_Ve_si));
  Qedj3_Vge_si_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Ve_di+T5_Vge_si_Ve_di));
  Qedj3_Vge_si_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Vge_si+T5_Vge_si_Vge_si));
  Qedj3_Vge_si_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vge_si+T5_Vge_si)+(PBSWGD_t*Czbdswg)*(+T4_Vge_si_Vdi_si+T5_Vge_si_Vdi_si));
#endif
Qedj3_Vdi_si=((PBSWGD_t*Czbdswg)*(T4_Vdi_si+T5_Vdi_si));
#if defined(_DERIVATE2)
  Qedj3_Vdi_si_Vdi_d=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vdi_d+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_si_Vdi_d));
  Qedj3_Vdi_si_Vsi_s=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*T5_Vsi_s+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+0.0+T5_Vdi_si_Vsi_s));
  Qedj3_Vdi_si_Tempt_GND=(+(+0.0*Czbdswg+0.0*Czbdswg_Tempt_GND+PBSWGD_t_Tempt_GND*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Tempt_GND+T5_Tempt_GND)+(((PBSWGD_t_Tempt_GND*Czbdswg)+(PBSWGD_t*Czbdswg_Tempt_GND)))*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Tempt_GND+T5_Vdi_si_Tempt_GND));
  Qedj3_Vdi_si_Vge_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_di+T5_Vge_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Vge_di+T5_Vdi_si_Vge_di));
  Qedj3_Vdi_si_Vge_e=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_e+T5_Vge_e)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Vge_e+T5_Vdi_si_Vge_e));
  Qedj3_Vdi_si_Ve_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_si+T5_Ve_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Ve_si+T5_Vdi_si_Ve_si));
  Qedj3_Vdi_si_Ve_di=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Ve_di+T5_Ve_di)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Ve_di+T5_Vdi_si_Ve_di));
  Qedj3_Vdi_si_Vge_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vge_si+T5_Vge_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Vge_si+T5_Vdi_si_Vge_si));
  Qedj3_Vdi_si_Vdi_si=(+(+0.0*Czbdswg+0.0*0.0+0.0*0.0+PBSWGD_t*0.0)*(T4+T5)+0.0*(T4_Vdi_si+T5_Vdi_si)+(0.0)*(T4_Vdi_si+T5_Vdi_si)+(PBSWGD_t*Czbdswg)*(+T4_Vdi_si_Vdi_si+T5_Vdi_si_Vdi_si));
#endif
#endif
Qedj3=((PBSWGD_t*Czbdswg)*(T4+T5));
EXIT_IF_ISNAN(((PBSWGD_t*Czbdswg)*(T4+T5)))
#endif
}
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qedj3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vdi_d_Vdi_d=0.0;
  Qedj3_Vdi_d_Vsi_s=0.0;
  Qedj3_Vdi_d_Tempt_GND=0.0;
  Qedj3_Vdi_d_Vge_di=0.0;
  Qedj3_Vdi_d_Vge_e=0.0;
  Qedj3_Vdi_d_Ve_si=0.0;
  Qedj3_Vdi_d_Ve_di=0.0;
  Qedj3_Vdi_d_Vge_si=0.0;
  Qedj3_Vdi_d_Vdi_si=0.0;
#endif
Qedj3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vsi_s_Vdi_d=0.0;
  Qedj3_Vsi_s_Vsi_s=0.0;
  Qedj3_Vsi_s_Tempt_GND=0.0;
  Qedj3_Vsi_s_Vge_di=0.0;
  Qedj3_Vsi_s_Vge_e=0.0;
  Qedj3_Vsi_s_Ve_si=0.0;
  Qedj3_Vsi_s_Ve_di=0.0;
  Qedj3_Vsi_s_Vge_si=0.0;
  Qedj3_Vsi_s_Vdi_si=0.0;
#endif
Qedj3_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qedj3_Tempt_GND_Vdi_d=0.0;
  Qedj3_Tempt_GND_Vsi_s=0.0;
  Qedj3_Tempt_GND_Tempt_GND=0.0;
  Qedj3_Tempt_GND_Vge_di=0.0;
  Qedj3_Tempt_GND_Vge_e=0.0;
  Qedj3_Tempt_GND_Ve_si=0.0;
  Qedj3_Tempt_GND_Ve_di=0.0;
  Qedj3_Tempt_GND_Vge_si=0.0;
  Qedj3_Tempt_GND_Vdi_si=0.0;
#endif
Qedj3_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vge_di_Vdi_d=0.0;
  Qedj3_Vge_di_Vsi_s=0.0;
  Qedj3_Vge_di_Tempt_GND=0.0;
  Qedj3_Vge_di_Vge_di=0.0;
  Qedj3_Vge_di_Vge_e=0.0;
  Qedj3_Vge_di_Ve_si=0.0;
  Qedj3_Vge_di_Ve_di=0.0;
  Qedj3_Vge_di_Vge_si=0.0;
  Qedj3_Vge_di_Vdi_si=0.0;
#endif
Qedj3_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vge_e_Vdi_d=0.0;
  Qedj3_Vge_e_Vsi_s=0.0;
  Qedj3_Vge_e_Tempt_GND=0.0;
  Qedj3_Vge_e_Vge_di=0.0;
  Qedj3_Vge_e_Vge_e=0.0;
  Qedj3_Vge_e_Ve_si=0.0;
  Qedj3_Vge_e_Ve_di=0.0;
  Qedj3_Vge_e_Vge_si=0.0;
  Qedj3_Vge_e_Vdi_si=0.0;
#endif
Qedj3_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qedj3_Ve_si_Vdi_d=0.0;
  Qedj3_Ve_si_Vsi_s=0.0;
  Qedj3_Ve_si_Tempt_GND=0.0;
  Qedj3_Ve_si_Vge_di=0.0;
  Qedj3_Ve_si_Vge_e=0.0;
  Qedj3_Ve_si_Ve_si=0.0;
  Qedj3_Ve_si_Ve_di=0.0;
  Qedj3_Ve_si_Vge_si=0.0;
  Qedj3_Ve_si_Vdi_si=0.0;
#endif
Qedj3_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qedj3_Ve_di_Vdi_d=0.0;
  Qedj3_Ve_di_Vsi_s=0.0;
  Qedj3_Ve_di_Tempt_GND=0.0;
  Qedj3_Ve_di_Vge_di=0.0;
  Qedj3_Ve_di_Vge_e=0.0;
  Qedj3_Ve_di_Ve_si=0.0;
  Qedj3_Ve_di_Ve_di=0.0;
  Qedj3_Ve_di_Vge_si=0.0;
  Qedj3_Ve_di_Vdi_si=0.0;
#endif
Qedj3_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vge_si_Vdi_d=0.0;
  Qedj3_Vge_si_Vsi_s=0.0;
  Qedj3_Vge_si_Tempt_GND=0.0;
  Qedj3_Vge_si_Vge_di=0.0;
  Qedj3_Vge_si_Vge_e=0.0;
  Qedj3_Vge_si_Ve_si=0.0;
  Qedj3_Vge_si_Ve_di=0.0;
  Qedj3_Vge_si_Vge_si=0.0;
  Qedj3_Vge_si_Vdi_si=0.0;
#endif
Qedj3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qedj3_Vdi_si_Vdi_d=0.0;
  Qedj3_Vdi_si_Vsi_s=0.0;
  Qedj3_Vdi_si_Tempt_GND=0.0;
  Qedj3_Vdi_si_Vge_di=0.0;
  Qedj3_Vdi_si_Vge_e=0.0;
  Qedj3_Vdi_si_Ve_si=0.0;
  Qedj3_Vdi_si_Ve_di=0.0;
  Qedj3_Vdi_si_Vge_si=0.0;
  Qedj3_Vdi_si_Vdi_si=0.0;
#endif
#endif
Qedj3=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Qedj_Vdi_d=((Qedj1_Vdi_d+Qedj2_Vdi_d)+Qedj3_Vdi_d);
#if defined(_DERIVATE2)
  Qedj_Vdi_d_Vdi_d=(+(+Qedj1_Vdi_d_Vdi_d+Qedj2_Vdi_d_Vdi_d)+Qedj3_Vdi_d_Vdi_d);
  Qedj_Vdi_d_Vsi_s=(+(+Qedj1_Vdi_d_Vsi_s+Qedj2_Vdi_d_Vsi_s)+Qedj3_Vdi_d_Vsi_s);
  Qedj_Vdi_d_Tempt_GND=(+(+Qedj1_Vdi_d_Tempt_GND+Qedj2_Vdi_d_Tempt_GND)+Qedj3_Vdi_d_Tempt_GND);
  Qedj_Vdi_d_Vge_di=(+(+Qedj1_Vdi_d_Vge_di+Qedj2_Vdi_d_Vge_di)+Qedj3_Vdi_d_Vge_di);
  Qedj_Vdi_d_Vge_e=(+(+Qedj1_Vdi_d_Vge_e+Qedj2_Vdi_d_Vge_e)+Qedj3_Vdi_d_Vge_e);
  Qedj_Vdi_d_Ve_si=(+(+Qedj1_Vdi_d_Ve_si+Qedj2_Vdi_d_Ve_si)+Qedj3_Vdi_d_Ve_si);
  Qedj_Vdi_d_Ve_di=(+(+Qedj1_Vdi_d_Ve_di+Qedj2_Vdi_d_Ve_di)+Qedj3_Vdi_d_Ve_di);
  Qedj_Vdi_d_Vge_si=(+(+Qedj1_Vdi_d_Vge_si+Qedj2_Vdi_d_Vge_si)+Qedj3_Vdi_d_Vge_si);
  Qedj_Vdi_d_Vdi_si=(+(+Qedj1_Vdi_d_Vdi_si+Qedj2_Vdi_d_Vdi_si)+Qedj3_Vdi_d_Vdi_si);
#endif
Qedj_Vsi_s=((Qedj1_Vsi_s+Qedj2_Vsi_s)+Qedj3_Vsi_s);
#if defined(_DERIVATE2)
  Qedj_Vsi_s_Vdi_d=(+(+Qedj1_Vsi_s_Vdi_d+Qedj2_Vsi_s_Vdi_d)+Qedj3_Vsi_s_Vdi_d);
  Qedj_Vsi_s_Vsi_s=(+(+Qedj1_Vsi_s_Vsi_s+Qedj2_Vsi_s_Vsi_s)+Qedj3_Vsi_s_Vsi_s);
  Qedj_Vsi_s_Tempt_GND=(+(+Qedj1_Vsi_s_Tempt_GND+Qedj2_Vsi_s_Tempt_GND)+Qedj3_Vsi_s_Tempt_GND);
  Qedj_Vsi_s_Vge_di=(+(+Qedj1_Vsi_s_Vge_di+Qedj2_Vsi_s_Vge_di)+Qedj3_Vsi_s_Vge_di);
  Qedj_Vsi_s_Vge_e=(+(+Qedj1_Vsi_s_Vge_e+Qedj2_Vsi_s_Vge_e)+Qedj3_Vsi_s_Vge_e);
  Qedj_Vsi_s_Ve_si=(+(+Qedj1_Vsi_s_Ve_si+Qedj2_Vsi_s_Ve_si)+Qedj3_Vsi_s_Ve_si);
  Qedj_Vsi_s_Ve_di=(+(+Qedj1_Vsi_s_Ve_di+Qedj2_Vsi_s_Ve_di)+Qedj3_Vsi_s_Ve_di);
  Qedj_Vsi_s_Vge_si=(+(+Qedj1_Vsi_s_Vge_si+Qedj2_Vsi_s_Vge_si)+Qedj3_Vsi_s_Vge_si);
  Qedj_Vsi_s_Vdi_si=(+(+Qedj1_Vsi_s_Vdi_si+Qedj2_Vsi_s_Vdi_si)+Qedj3_Vsi_s_Vdi_si);
#endif
Qedj_Tempt_GND=((Qedj1_Tempt_GND+Qedj2_Tempt_GND)+Qedj3_Tempt_GND);
#if defined(_DERIVATE2)
  Qedj_Tempt_GND_Vdi_d=(+(+Qedj1_Tempt_GND_Vdi_d+Qedj2_Tempt_GND_Vdi_d)+Qedj3_Tempt_GND_Vdi_d);
  Qedj_Tempt_GND_Vsi_s=(+(+Qedj1_Tempt_GND_Vsi_s+Qedj2_Tempt_GND_Vsi_s)+Qedj3_Tempt_GND_Vsi_s);
  Qedj_Tempt_GND_Tempt_GND=(+(+Qedj1_Tempt_GND_Tempt_GND+Qedj2_Tempt_GND_Tempt_GND)+Qedj3_Tempt_GND_Tempt_GND);
  Qedj_Tempt_GND_Vge_di=(+(+Qedj1_Tempt_GND_Vge_di+Qedj2_Tempt_GND_Vge_di)+Qedj3_Tempt_GND_Vge_di);
  Qedj_Tempt_GND_Vge_e=(+(+Qedj1_Tempt_GND_Vge_e+Qedj2_Tempt_GND_Vge_e)+Qedj3_Tempt_GND_Vge_e);
  Qedj_Tempt_GND_Ve_si=(+(+Qedj1_Tempt_GND_Ve_si+Qedj2_Tempt_GND_Ve_si)+Qedj3_Tempt_GND_Ve_si);
  Qedj_Tempt_GND_Ve_di=(+(+Qedj1_Tempt_GND_Ve_di+Qedj2_Tempt_GND_Ve_di)+Qedj3_Tempt_GND_Ve_di);
  Qedj_Tempt_GND_Vge_si=(+(+Qedj1_Tempt_GND_Vge_si+Qedj2_Tempt_GND_Vge_si)+Qedj3_Tempt_GND_Vge_si);
  Qedj_Tempt_GND_Vdi_si=(+(+Qedj1_Tempt_GND_Vdi_si+Qedj2_Tempt_GND_Vdi_si)+Qedj3_Tempt_GND_Vdi_si);
#endif
Qedj_Vge_di=((Qedj1_Vge_di+Qedj2_Vge_di)+Qedj3_Vge_di);
#if defined(_DERIVATE2)
  Qedj_Vge_di_Vdi_d=(+(+Qedj1_Vge_di_Vdi_d+Qedj2_Vge_di_Vdi_d)+Qedj3_Vge_di_Vdi_d);
  Qedj_Vge_di_Vsi_s=(+(+Qedj1_Vge_di_Vsi_s+Qedj2_Vge_di_Vsi_s)+Qedj3_Vge_di_Vsi_s);
  Qedj_Vge_di_Tempt_GND=(+(+Qedj1_Vge_di_Tempt_GND+Qedj2_Vge_di_Tempt_GND)+Qedj3_Vge_di_Tempt_GND);
  Qedj_Vge_di_Vge_di=(+(+Qedj1_Vge_di_Vge_di+Qedj2_Vge_di_Vge_di)+Qedj3_Vge_di_Vge_di);
  Qedj_Vge_di_Vge_e=(+(+Qedj1_Vge_di_Vge_e+Qedj2_Vge_di_Vge_e)+Qedj3_Vge_di_Vge_e);
  Qedj_Vge_di_Ve_si=(+(+Qedj1_Vge_di_Ve_si+Qedj2_Vge_di_Ve_si)+Qedj3_Vge_di_Ve_si);
  Qedj_Vge_di_Ve_di=(+(+Qedj1_Vge_di_Ve_di+Qedj2_Vge_di_Ve_di)+Qedj3_Vge_di_Ve_di);
  Qedj_Vge_di_Vge_si=(+(+Qedj1_Vge_di_Vge_si+Qedj2_Vge_di_Vge_si)+Qedj3_Vge_di_Vge_si);
  Qedj_Vge_di_Vdi_si=(+(+Qedj1_Vge_di_Vdi_si+Qedj2_Vge_di_Vdi_si)+Qedj3_Vge_di_Vdi_si);
#endif
Qedj_Vge_e=((Qedj1_Vge_e+Qedj2_Vge_e)+Qedj3_Vge_e);
#if defined(_DERIVATE2)
  Qedj_Vge_e_Vdi_d=(+(+Qedj1_Vge_e_Vdi_d+Qedj2_Vge_e_Vdi_d)+Qedj3_Vge_e_Vdi_d);
  Qedj_Vge_e_Vsi_s=(+(+Qedj1_Vge_e_Vsi_s+Qedj2_Vge_e_Vsi_s)+Qedj3_Vge_e_Vsi_s);
  Qedj_Vge_e_Tempt_GND=(+(+Qedj1_Vge_e_Tempt_GND+Qedj2_Vge_e_Tempt_GND)+Qedj3_Vge_e_Tempt_GND);
  Qedj_Vge_e_Vge_di=(+(+Qedj1_Vge_e_Vge_di+Qedj2_Vge_e_Vge_di)+Qedj3_Vge_e_Vge_di);
  Qedj_Vge_e_Vge_e=(+(+Qedj1_Vge_e_Vge_e+Qedj2_Vge_e_Vge_e)+Qedj3_Vge_e_Vge_e);
  Qedj_Vge_e_Ve_si=(+(+Qedj1_Vge_e_Ve_si+Qedj2_Vge_e_Ve_si)+Qedj3_Vge_e_Ve_si);
  Qedj_Vge_e_Ve_di=(+(+Qedj1_Vge_e_Ve_di+Qedj2_Vge_e_Ve_di)+Qedj3_Vge_e_Ve_di);
  Qedj_Vge_e_Vge_si=(+(+Qedj1_Vge_e_Vge_si+Qedj2_Vge_e_Vge_si)+Qedj3_Vge_e_Vge_si);
  Qedj_Vge_e_Vdi_si=(+(+Qedj1_Vge_e_Vdi_si+Qedj2_Vge_e_Vdi_si)+Qedj3_Vge_e_Vdi_si);
#endif
Qedj_Ve_si=((Qedj1_Ve_si+Qedj2_Ve_si)+Qedj3_Ve_si);
#if defined(_DERIVATE2)
  Qedj_Ve_si_Vdi_d=(+(+Qedj1_Ve_si_Vdi_d+Qedj2_Ve_si_Vdi_d)+Qedj3_Ve_si_Vdi_d);
  Qedj_Ve_si_Vsi_s=(+(+Qedj1_Ve_si_Vsi_s+Qedj2_Ve_si_Vsi_s)+Qedj3_Ve_si_Vsi_s);
  Qedj_Ve_si_Tempt_GND=(+(+Qedj1_Ve_si_Tempt_GND+Qedj2_Ve_si_Tempt_GND)+Qedj3_Ve_si_Tempt_GND);
  Qedj_Ve_si_Vge_di=(+(+Qedj1_Ve_si_Vge_di+Qedj2_Ve_si_Vge_di)+Qedj3_Ve_si_Vge_di);
  Qedj_Ve_si_Vge_e=(+(+Qedj1_Ve_si_Vge_e+Qedj2_Ve_si_Vge_e)+Qedj3_Ve_si_Vge_e);
  Qedj_Ve_si_Ve_si=(+(+Qedj1_Ve_si_Ve_si+Qedj2_Ve_si_Ve_si)+Qedj3_Ve_si_Ve_si);
  Qedj_Ve_si_Ve_di=(+(+Qedj1_Ve_si_Ve_di+Qedj2_Ve_si_Ve_di)+Qedj3_Ve_si_Ve_di);
  Qedj_Ve_si_Vge_si=(+(+Qedj1_Ve_si_Vge_si+Qedj2_Ve_si_Vge_si)+Qedj3_Ve_si_Vge_si);
  Qedj_Ve_si_Vdi_si=(+(+Qedj1_Ve_si_Vdi_si+Qedj2_Ve_si_Vdi_si)+Qedj3_Ve_si_Vdi_si);
#endif
Qedj_Ve_di=((Qedj1_Ve_di+Qedj2_Ve_di)+Qedj3_Ve_di);
#if defined(_DERIVATE2)
  Qedj_Ve_di_Vdi_d=(+(+Qedj1_Ve_di_Vdi_d+Qedj2_Ve_di_Vdi_d)+Qedj3_Ve_di_Vdi_d);
  Qedj_Ve_di_Vsi_s=(+(+Qedj1_Ve_di_Vsi_s+Qedj2_Ve_di_Vsi_s)+Qedj3_Ve_di_Vsi_s);
  Qedj_Ve_di_Tempt_GND=(+(+Qedj1_Ve_di_Tempt_GND+Qedj2_Ve_di_Tempt_GND)+Qedj3_Ve_di_Tempt_GND);
  Qedj_Ve_di_Vge_di=(+(+Qedj1_Ve_di_Vge_di+Qedj2_Ve_di_Vge_di)+Qedj3_Ve_di_Vge_di);
  Qedj_Ve_di_Vge_e=(+(+Qedj1_Ve_di_Vge_e+Qedj2_Ve_di_Vge_e)+Qedj3_Ve_di_Vge_e);
  Qedj_Ve_di_Ve_si=(+(+Qedj1_Ve_di_Ve_si+Qedj2_Ve_di_Ve_si)+Qedj3_Ve_di_Ve_si);
  Qedj_Ve_di_Ve_di=(+(+Qedj1_Ve_di_Ve_di+Qedj2_Ve_di_Ve_di)+Qedj3_Ve_di_Ve_di);
  Qedj_Ve_di_Vge_si=(+(+Qedj1_Ve_di_Vge_si+Qedj2_Ve_di_Vge_si)+Qedj3_Ve_di_Vge_si);
  Qedj_Ve_di_Vdi_si=(+(+Qedj1_Ve_di_Vdi_si+Qedj2_Ve_di_Vdi_si)+Qedj3_Ve_di_Vdi_si);
#endif
Qedj_Vge_si=((Qedj1_Vge_si+Qedj2_Vge_si)+Qedj3_Vge_si);
#if defined(_DERIVATE2)
  Qedj_Vge_si_Vdi_d=(+(+Qedj1_Vge_si_Vdi_d+Qedj2_Vge_si_Vdi_d)+Qedj3_Vge_si_Vdi_d);
  Qedj_Vge_si_Vsi_s=(+(+Qedj1_Vge_si_Vsi_s+Qedj2_Vge_si_Vsi_s)+Qedj3_Vge_si_Vsi_s);
  Qedj_Vge_si_Tempt_GND=(+(+Qedj1_Vge_si_Tempt_GND+Qedj2_Vge_si_Tempt_GND)+Qedj3_Vge_si_Tempt_GND);
  Qedj_Vge_si_Vge_di=(+(+Qedj1_Vge_si_Vge_di+Qedj2_Vge_si_Vge_di)+Qedj3_Vge_si_Vge_di);
  Qedj_Vge_si_Vge_e=(+(+Qedj1_Vge_si_Vge_e+Qedj2_Vge_si_Vge_e)+Qedj3_Vge_si_Vge_e);
  Qedj_Vge_si_Ve_si=(+(+Qedj1_Vge_si_Ve_si+Qedj2_Vge_si_Ve_si)+Qedj3_Vge_si_Ve_si);
  Qedj_Vge_si_Ve_di=(+(+Qedj1_Vge_si_Ve_di+Qedj2_Vge_si_Ve_di)+Qedj3_Vge_si_Ve_di);
  Qedj_Vge_si_Vge_si=(+(+Qedj1_Vge_si_Vge_si+Qedj2_Vge_si_Vge_si)+Qedj3_Vge_si_Vge_si);
  Qedj_Vge_si_Vdi_si=(+(+Qedj1_Vge_si_Vdi_si+Qedj2_Vge_si_Vdi_si)+Qedj3_Vge_si_Vdi_si);
#endif
Qedj_Vdi_si=((Qedj1_Vdi_si+Qedj2_Vdi_si)+Qedj3_Vdi_si);
#if defined(_DERIVATE2)
  Qedj_Vdi_si_Vdi_d=(+(+Qedj1_Vdi_si_Vdi_d+Qedj2_Vdi_si_Vdi_d)+Qedj3_Vdi_si_Vdi_d);
  Qedj_Vdi_si_Vsi_s=(+(+Qedj1_Vdi_si_Vsi_s+Qedj2_Vdi_si_Vsi_s)+Qedj3_Vdi_si_Vsi_s);
  Qedj_Vdi_si_Tempt_GND=(+(+Qedj1_Vdi_si_Tempt_GND+Qedj2_Vdi_si_Tempt_GND)+Qedj3_Vdi_si_Tempt_GND);
  Qedj_Vdi_si_Vge_di=(+(+Qedj1_Vdi_si_Vge_di+Qedj2_Vdi_si_Vge_di)+Qedj3_Vdi_si_Vge_di);
  Qedj_Vdi_si_Vge_e=(+(+Qedj1_Vdi_si_Vge_e+Qedj2_Vdi_si_Vge_e)+Qedj3_Vdi_si_Vge_e);
  Qedj_Vdi_si_Ve_si=(+(+Qedj1_Vdi_si_Ve_si+Qedj2_Vdi_si_Ve_si)+Qedj3_Vdi_si_Ve_si);
  Qedj_Vdi_si_Ve_di=(+(+Qedj1_Vdi_si_Ve_di+Qedj2_Vdi_si_Ve_di)+Qedj3_Vdi_si_Ve_di);
  Qedj_Vdi_si_Vge_si=(+(+Qedj1_Vdi_si_Vge_si+Qedj2_Vdi_si_Vge_si)+Qedj3_Vdi_si_Vge_si);
  Qedj_Vdi_si_Vdi_si=(+(+Qedj1_Vdi_si_Vdi_si+Qedj2_Vdi_si_Vdi_si)+Qedj3_Vdi_si_Vdi_si);
#endif
#endif
Qedj=((Qedj1+Qedj2)+Qedj3);
EXIT_IF_ISNAN(((Qedj1+Qedj2)+Qedj3))
#endif
}
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(e,GND)V(si,GND) */
Qes_Vdi_d=Qesj_Vdi_d;
#if defined(_DERIVATE2)
  Qes_Vdi_d_Vdi_d=(+Qesj_Vdi_d_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Vsi_s=(+Qesj_Vdi_d_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Tempt_GND=(+Qesj_Vdi_d_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Vge_di=(+Qesj_Vdi_d_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Vge_e=(+Qesj_Vdi_d_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Ve_si=(+Qesj_Vdi_d_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Ve_di=(+Qesj_Vdi_d_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Vge_si=(+Qesj_Vdi_d_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_d_Vdi_si=(+Qesj_Vdi_d_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Vsi_s=Qesj_Vsi_s;
#if defined(_DERIVATE2)
  Qes_Vsi_s_Vdi_d=(+Qesj_Vsi_s_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Vsi_s=(+Qesj_Vsi_s_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Tempt_GND=(+Qesj_Vsi_s_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Vge_di=(+Qesj_Vsi_s_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Vge_e=(+Qesj_Vsi_s_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Ve_si=(+Qesj_Vsi_s_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Ve_di=(+Qesj_Vsi_s_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Vge_si=(+Qesj_Vsi_s_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vsi_s_Vdi_si=(+Qesj_Vsi_s_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Tempt_GND=Qesj_Tempt_GND;
#if defined(_DERIVATE2)
  Qes_Tempt_GND_Vdi_d=(+Qesj_Tempt_GND_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Vsi_s=(+Qesj_Tempt_GND_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Tempt_GND=(+Qesj_Tempt_GND_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Vge_di=(+Qesj_Tempt_GND_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Vge_e=(+Qesj_Tempt_GND_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Ve_si=(+Qesj_Tempt_GND_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Ve_di=(+Qesj_Tempt_GND_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Vge_si=(+Qesj_Tempt_GND_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Tempt_GND_Vdi_si=(+Qesj_Tempt_GND_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Vge_di=Qesj_Vge_di;
#if defined(_DERIVATE2)
  Qes_Vge_di_Vdi_d=(+Qesj_Vge_di_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Vsi_s=(+Qesj_Vge_di_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Tempt_GND=(+Qesj_Vge_di_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Vge_di=(+Qesj_Vge_di_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Vge_e=(+Qesj_Vge_di_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Ve_si=(+Qesj_Vge_di_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Ve_di=(+Qesj_Vge_di_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Vge_si=(+Qesj_Vge_di_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_di_Vdi_si=(+Qesj_Vge_di_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Vge_e=Qesj_Vge_e;
#if defined(_DERIVATE2)
  Qes_Vge_e_Vdi_d=(+Qesj_Vge_e_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Vsi_s=(+Qesj_Vge_e_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Tempt_GND=(+Qesj_Vge_e_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Vge_di=(+Qesj_Vge_e_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Vge_e=(+Qesj_Vge_e_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Ve_si=(+Qesj_Vge_e_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Ve_di=(+Qesj_Vge_e_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Vge_si=(+Qesj_Vge_e_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_e_Vdi_si=(+Qesj_Vge_e_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Ve_si=(Qesj_Ve_si+(csbox*ves_jct_Ve_si));
#if defined(_DERIVATE2)
  Qes_Ve_si_Vdi_d=(+Qesj_Ve_si_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Vsi_s=(+Qesj_Ve_si_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Tempt_GND=(+Qesj_Ve_si_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Vge_di=(+Qesj_Ve_si_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Vge_e=(+Qesj_Ve_si_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Ve_si=(+Qesj_Ve_si_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*ves_jct_Ve_si+csbox*ves_jct_Ve_si_Ve_si));
  Qes_Ve_si_Ve_di=(+Qesj_Ve_si_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Vge_si=(+Qesj_Ve_si_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
  Qes_Ve_si_Vdi_si=(+Qesj_Ve_si_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*ves_jct_Ve_si+csbox*0.0));
#endif
Qes_Ve_di=Qesj_Ve_di;
#if defined(_DERIVATE2)
  Qes_Ve_di_Vdi_d=(+Qesj_Ve_di_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Vsi_s=(+Qesj_Ve_di_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Tempt_GND=(+Qesj_Ve_di_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Vge_di=(+Qesj_Ve_di_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Vge_e=(+Qesj_Ve_di_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Ve_si=(+Qesj_Ve_di_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Ve_di=(+Qesj_Ve_di_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Vge_si=(+Qesj_Ve_di_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Ve_di_Vdi_si=(+Qesj_Ve_di_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Vge_si=Qesj_Vge_si;
#if defined(_DERIVATE2)
  Qes_Vge_si_Vdi_d=(+Qesj_Vge_si_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Vsi_s=(+Qesj_Vge_si_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Tempt_GND=(+Qesj_Vge_si_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Vge_di=(+Qesj_Vge_si_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Vge_e=(+Qesj_Vge_si_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Ve_si=(+Qesj_Vge_si_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Ve_di=(+Qesj_Vge_si_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Vge_si=(+Qesj_Vge_si_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vge_si_Vdi_si=(+Qesj_Vge_si_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
Qes_Vdi_si=Qesj_Vdi_si;
#if defined(_DERIVATE2)
  Qes_Vdi_si_Vdi_d=(+Qesj_Vdi_si_Vdi_d+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Vsi_s=(+Qesj_Vdi_si_Vsi_s+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Tempt_GND=(+Qesj_Vdi_si_Tempt_GND+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Vge_di=(+Qesj_Vdi_si_Vge_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Vge_e=(+Qesj_Vdi_si_Vge_e+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Ve_si=(+Qesj_Vdi_si_Ve_si+(+0.0*ves_jct+0.0*ves_jct_Ve_si+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Ve_di=(+Qesj_Vdi_si_Ve_di+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Vge_si=(+Qesj_Vdi_si_Vge_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
  Qes_Vdi_si_Vdi_si=(+Qesj_Vdi_si_Vdi_si+(+0.0*ves_jct+0.0*0.0+0.0*0.0+csbox*0.0));
#endif
#endif
Qes=(Qesj+(csbox*ves_jct));
EXIT_IF_ISNAN((Qesj+(csbox*ves_jct)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
Qed_Vdi_d=Qedj_Vdi_d;
#if defined(_DERIVATE2)
  Qed_Vdi_d_Vdi_d=(+Qedj_Vdi_d_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Vsi_s=(+Qedj_Vdi_d_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Tempt_GND=(+Qedj_Vdi_d_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Vge_di=(+Qedj_Vdi_d_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Vge_e=(+Qedj_Vdi_d_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Ve_si=(+Qedj_Vdi_d_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Ve_di=(+Qedj_Vdi_d_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Vge_si=(+Qedj_Vdi_d_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_d_Vdi_si=(+Qedj_Vdi_d_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Vsi_s=Qedj_Vsi_s;
#if defined(_DERIVATE2)
  Qed_Vsi_s_Vdi_d=(+Qedj_Vsi_s_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Vsi_s=(+Qedj_Vsi_s_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Tempt_GND=(+Qedj_Vsi_s_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Vge_di=(+Qedj_Vsi_s_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Vge_e=(+Qedj_Vsi_s_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Ve_si=(+Qedj_Vsi_s_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Ve_di=(+Qedj_Vsi_s_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Vge_si=(+Qedj_Vsi_s_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vsi_s_Vdi_si=(+Qedj_Vsi_s_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Tempt_GND=Qedj_Tempt_GND;
#if defined(_DERIVATE2)
  Qed_Tempt_GND_Vdi_d=(+Qedj_Tempt_GND_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Vsi_s=(+Qedj_Tempt_GND_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Tempt_GND=(+Qedj_Tempt_GND_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Vge_di=(+Qedj_Tempt_GND_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Vge_e=(+Qedj_Tempt_GND_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Ve_si=(+Qedj_Tempt_GND_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Ve_di=(+Qedj_Tempt_GND_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Vge_si=(+Qedj_Tempt_GND_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Tempt_GND_Vdi_si=(+Qedj_Tempt_GND_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Vge_di=Qedj_Vge_di;
#if defined(_DERIVATE2)
  Qed_Vge_di_Vdi_d=(+Qedj_Vge_di_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Vsi_s=(+Qedj_Vge_di_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Tempt_GND=(+Qedj_Vge_di_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Vge_di=(+Qedj_Vge_di_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Vge_e=(+Qedj_Vge_di_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Ve_si=(+Qedj_Vge_di_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Ve_di=(+Qedj_Vge_di_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Vge_si=(+Qedj_Vge_di_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_di_Vdi_si=(+Qedj_Vge_di_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Vge_e=Qedj_Vge_e;
#if defined(_DERIVATE2)
  Qed_Vge_e_Vdi_d=(+Qedj_Vge_e_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Vsi_s=(+Qedj_Vge_e_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Tempt_GND=(+Qedj_Vge_e_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Vge_di=(+Qedj_Vge_e_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Vge_e=(+Qedj_Vge_e_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Ve_si=(+Qedj_Vge_e_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Ve_di=(+Qedj_Vge_e_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Vge_si=(+Qedj_Vge_e_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_e_Vdi_si=(+Qedj_Vge_e_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Ve_si=Qedj_Ve_si;
#if defined(_DERIVATE2)
  Qed_Ve_si_Vdi_d=(+Qedj_Ve_si_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Vsi_s=(+Qedj_Ve_si_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Tempt_GND=(+Qedj_Ve_si_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Vge_di=(+Qedj_Ve_si_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Vge_e=(+Qedj_Ve_si_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Ve_si=(+Qedj_Ve_si_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Ve_di=(+Qedj_Ve_si_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Vge_si=(+Qedj_Ve_si_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Ve_si_Vdi_si=(+Qedj_Ve_si_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Ve_di=(Qedj_Ve_di+(cdbox*ved_jct_Ve_di));
#if defined(_DERIVATE2)
  Qed_Ve_di_Vdi_d=(+Qedj_Ve_di_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Vsi_s=(+Qedj_Ve_di_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Tempt_GND=(+Qedj_Ve_di_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Vge_di=(+Qedj_Ve_di_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Vge_e=(+Qedj_Ve_di_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Ve_si=(+Qedj_Ve_di_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Ve_di=(+Qedj_Ve_di_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*ved_jct_Ve_di+cdbox*ved_jct_Ve_di_Ve_di));
  Qed_Ve_di_Vge_si=(+Qedj_Ve_di_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
  Qed_Ve_di_Vdi_si=(+Qedj_Ve_di_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*ved_jct_Ve_di+cdbox*0.0));
#endif
Qed_Vge_si=Qedj_Vge_si;
#if defined(_DERIVATE2)
  Qed_Vge_si_Vdi_d=(+Qedj_Vge_si_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Vsi_s=(+Qedj_Vge_si_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Tempt_GND=(+Qedj_Vge_si_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Vge_di=(+Qedj_Vge_si_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Vge_e=(+Qedj_Vge_si_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Ve_si=(+Qedj_Vge_si_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Ve_di=(+Qedj_Vge_si_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Vge_si=(+Qedj_Vge_si_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vge_si_Vdi_si=(+Qedj_Vge_si_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
Qed_Vdi_si=Qedj_Vdi_si;
#if defined(_DERIVATE2)
  Qed_Vdi_si_Vdi_d=(+Qedj_Vdi_si_Vdi_d+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Vsi_s=(+Qedj_Vdi_si_Vsi_s+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Tempt_GND=(+Qedj_Vdi_si_Tempt_GND+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Vge_di=(+Qedj_Vdi_si_Vge_di+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Vge_e=(+Qedj_Vdi_si_Vge_e+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Ve_si=(+Qedj_Vdi_si_Ve_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Ve_di=(+Qedj_Vdi_si_Ve_di+(+0.0*ved_jct+0.0*ved_jct_Ve_di+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Vge_si=(+Qedj_Vdi_si_Vge_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
  Qed_Vdi_si_Vdi_si=(+Qedj_Vdi_si_Vdi_si+(+0.0*ved_jct+0.0*0.0+0.0*0.0+cdbox*0.0));
#endif
#endif
Qed=(Qedj+(cdbox*ved_jct));
EXIT_IF_ISNAN((Qedj+(cdbox*ved_jct)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(e,ge) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Qeg_Vge_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_di_Vge_di=0.0;
  Qeg_Vge_di_Vge_e=0.0;
  Qeg_Vge_di_Vdi_si=0.0;
  Qeg_Vge_di_Ve_si=0.0;
  Qeg_Vge_di_Ve_di=0.0;
  Qeg_Vge_di_Vge_si=0.0;
  Qeg_Vge_di_Tempt_GND=0.0;
  Qeg_Vge_di_Ve_ge=0.0;
#endif
Qeg_Vge_e=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_e_Vge_di=0.0;
  Qeg_Vge_e_Vge_e=0.0;
  Qeg_Vge_e_Vdi_si=0.0;
  Qeg_Vge_e_Ve_si=0.0;
  Qeg_Vge_e_Ve_di=0.0;
  Qeg_Vge_e_Vge_si=0.0;
  Qeg_Vge_e_Tempt_GND=0.0;
  Qeg_Vge_e_Ve_ge=0.0;
#endif
Qeg_Vdi_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vdi_si_Vge_di=0.0;
  Qeg_Vdi_si_Vge_e=0.0;
  Qeg_Vdi_si_Vdi_si=0.0;
  Qeg_Vdi_si_Ve_si=0.0;
  Qeg_Vdi_si_Ve_di=0.0;
  Qeg_Vdi_si_Vge_si=0.0;
  Qeg_Vdi_si_Tempt_GND=0.0;
  Qeg_Vdi_si_Ve_ge=0.0;
#endif
Qeg_Ve_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_si_Vge_di=0.0;
  Qeg_Ve_si_Vge_e=0.0;
  Qeg_Ve_si_Vdi_si=0.0;
  Qeg_Ve_si_Ve_si=0.0;
  Qeg_Ve_si_Ve_di=0.0;
  Qeg_Ve_si_Vge_si=0.0;
  Qeg_Ve_si_Tempt_GND=0.0;
  Qeg_Ve_si_Ve_ge=0.0;
#endif
Qeg_Ve_di=0.0;
#if defined(_DERIVATE2)
  Qeg_Ve_di_Vge_di=0.0;
  Qeg_Ve_di_Vge_e=0.0;
  Qeg_Ve_di_Vdi_si=0.0;
  Qeg_Ve_di_Ve_si=0.0;
  Qeg_Ve_di_Ve_di=0.0;
  Qeg_Ve_di_Vge_si=0.0;
  Qeg_Ve_di_Tempt_GND=0.0;
  Qeg_Ve_di_Ve_ge=0.0;
#endif
Qeg_Vge_si=0.0;
#if defined(_DERIVATE2)
  Qeg_Vge_si_Vge_di=0.0;
  Qeg_Vge_si_Vge_e=0.0;
  Qeg_Vge_si_Vdi_si=0.0;
  Qeg_Vge_si_Ve_si=0.0;
  Qeg_Vge_si_Ve_di=0.0;
  Qeg_Vge_si_Vge_si=0.0;
  Qeg_Vge_si_Tempt_GND=0.0;
  Qeg_Vge_si_Ve_ge=0.0;
#endif
Qeg_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  Qeg_Tempt_GND_Vge_di=0.0;
  Qeg_Tempt_GND_Vge_e=0.0;
  Qeg_Tempt_GND_Vdi_si=0.0;
  Qeg_Tempt_GND_Ve_si=0.0;
  Qeg_Tempt_GND_Ve_di=0.0;
  Qeg_Tempt_GND_Vge_si=0.0;
  Qeg_Tempt_GND_Tempt_GND=0.0;
  Qeg_Tempt_GND_Ve_ge=0.0;
#endif
Qeg_Ve_ge=((cgbox*devsign));
#if defined(_DERIVATE2)
  Qeg_Ve_ge_Vge_di=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Vge_e=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Vdi_si=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Ve_si=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Ve_di=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Vge_si=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Tempt_GND=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*0.0+(0.0)*1.0+(cgbox*devsign)*0.0);
  Qeg_Ve_ge_Ve_ge=(+(+0.0*devsign+0.0*0.0+0.0*0.0+cgbox*0.0)*(NP(e)-NP(ge))+0.0*1.0+(0.0)*1.0+(cgbox*devsign)*0.0);
#endif
#endif
Qeg=((cgbox*devsign)*(NP(e)-NP(ge)));
EXIT_IF_ISNAN(((cgbox*devsign)*(NP(e)-NP(ge))))
#endif
if
((pModel->BULKMOD!=0))
{
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=(devsign);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Vsi_s=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Vge_di=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Vge_e=(+0.0*(NP(ge)-NP(e))+0.0*1.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Vge_si=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Ve_si=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Ve_di=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Vdi_si=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
  T2_Vge_e_Tempt_GND=(+0.0*(NP(ge)-NP(e))+0.0*0.0+0.0*1.0+devsign*0.0);
#endif
T2_Vge_si=0.0;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=0.0;
  T2_Vge_si_Vsi_s=0.0;
  T2_Vge_si_Vge_di=0.0;
  T2_Vge_si_Vge_e=0.0;
  T2_Vge_si_Vge_si=0.0;
  T2_Vge_si_Ve_si=0.0;
  T2_Vge_si_Ve_di=0.0;
  T2_Vge_si_Vdi_si=0.0;
  T2_Vge_si_Tempt_GND=0.0;
#endif
T2_Ve_si=0.0;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=0.0;
  T2_Ve_si_Vsi_s=0.0;
  T2_Ve_si_Vge_di=0.0;
  T2_Ve_si_Vge_e=0.0;
  T2_Ve_si_Vge_si=0.0;
  T2_Ve_si_Ve_si=0.0;
  T2_Ve_si_Ve_di=0.0;
  T2_Ve_si_Vdi_si=0.0;
  T2_Ve_si_Tempt_GND=0.0;
#endif
T2_Ve_di=0.0;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=0.0;
  T2_Ve_di_Vsi_s=0.0;
  T2_Ve_di_Vge_di=0.0;
  T2_Ve_di_Vge_e=0.0;
  T2_Ve_di_Vge_si=0.0;
  T2_Ve_di_Ve_si=0.0;
  T2_Ve_di_Ve_di=0.0;
  T2_Ve_di_Vdi_si=0.0;
  T2_Ve_di_Tempt_GND=0.0;
#endif
T2_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=0.0;
  T2_Vdi_si_Vsi_s=0.0;
  T2_Vdi_si_Vge_di=0.0;
  T2_Vdi_si_Vge_e=0.0;
  T2_Vdi_si_Vge_si=0.0;
  T2_Vdi_si_Ve_si=0.0;
  T2_Vdi_si_Ve_di=0.0;
  T2_Vdi_si_Vdi_si=0.0;
  T2_Vdi_si_Tempt_GND=0.0;
#endif
T2_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=0.0;
  T2_Tempt_GND_Vsi_s=0.0;
  T2_Tempt_GND_Vge_di=0.0;
  T2_Tempt_GND_Vge_e=0.0;
  T2_Tempt_GND_Vge_si=0.0;
  T2_Tempt_GND_Ve_si=0.0;
  T2_Tempt_GND_Ve_di=0.0;
  T2_Tempt_GND_Vdi_si=0.0;
  T2_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T2=(devsign*(NP(ge)-NP(e)));
EXIT_IF_ISNAN((devsign*(NP(ge)-NP(e))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=T2_Vge_di;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+(+(+(+T2_Vge_di_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Vsi_s=(+(+(+(+T2_Vge_di_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Vge_di=(+(+(+(+T2_Vge_di_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Vge_e=(+(+(+(+T2_Vge_di_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Vdi_si=(+(+(+(+T2_Vge_di_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Ve_si=(+(+(+(+T2_Vge_di_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Ve_di=(+(+(+(+T2_Vge_di_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Vge_si=(+(+(+(+T2_Vge_di_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_di_Tempt_GND=(+(+(+(+T2_Vge_di_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Vge_e=T2_Vge_e;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+(+(+(+T2_Vge_e_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Vsi_s=(+(+(+(+T2_Vge_e_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Vge_di=(+(+(+(+T2_Vge_e_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Vge_e=(+(+(+(+T2_Vge_e_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Vdi_si=(+(+(+(+T2_Vge_e_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Ve_si=(+(+(+(+T2_Vge_e_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Ve_di=(+(+(+(+T2_Vge_e_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Vge_si=(+(+(+(+T2_Vge_e_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_e_Tempt_GND=(+(+(+(+T2_Vge_e_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Vdi_si=T2_Vdi_si;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+(+(+(+T2_Vdi_si_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Vsi_s=(+(+(+(+T2_Vdi_si_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Vge_di=(+(+(+(+T2_Vdi_si_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Vge_e=(+(+(+(+T2_Vdi_si_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Vdi_si=(+(+(+(+T2_Vdi_si_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Ve_si=(+(+(+(+T2_Vdi_si_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Ve_di=(+(+(+(+T2_Vdi_si_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Vge_si=(+(+(+(+T2_Vdi_si_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vdi_si_Tempt_GND=(+(+(+(+T2_Vdi_si_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Ve_si=T2_Ve_si;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+(+(+(+T2_Ve_si_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Vsi_s=(+(+(+(+T2_Ve_si_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Vge_di=(+(+(+(+T2_Ve_si_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Vge_e=(+(+(+(+T2_Ve_si_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Vdi_si=(+(+(+(+T2_Ve_si_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Ve_si=(+(+(+(+T2_Ve_si_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Ve_di=(+(+(+(+T2_Ve_si_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Vge_si=(+(+(+(+T2_Ve_si_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_si_Tempt_GND=(+(+(+(+T2_Ve_si_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Ve_di=T2_Ve_di;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+(+(+(+T2_Ve_di_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Vsi_s=(+(+(+(+T2_Ve_di_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Vge_di=(+(+(+(+T2_Ve_di_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Vge_e=(+(+(+(+T2_Ve_di_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Vdi_si=(+(+(+(+T2_Ve_di_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Ve_si=(+(+(+(+T2_Ve_di_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Ve_di=(+(+(+(+T2_Ve_di_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Vge_si=(+(+(+(+T2_Ve_di_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Ve_di_Tempt_GND=(+(+(+(+T2_Ve_di_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Vge_si=T2_Vge_si;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+(+(+(+T2_Vge_si_Vdi_d-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Vsi_s=(+(+(+(+T2_Vge_si_Vsi_s-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Vge_di=(+(+(+(+T2_Vge_si_Vge_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Vge_e=(+(+(+(+T2_Vge_si_Vge_e-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Vdi_si=(+(+(+(+T2_Vge_si_Vdi_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Ve_si=(+(+(+(+T2_Vge_si_Ve_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Ve_di=(+(+(+(+T2_Vge_si_Ve_di-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Vge_si=(+(+(+(+T2_Vge_si_Vge_si-0.0)+(0.0/2.0-(0.0*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Vge_si_Tempt_GND=(+(+(+(+T2_Vge_si_Tempt_GND-0.0)+(0.0/2.0-(0.0*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
#endif
T3_Tempt_GND=(((T2_Tempt_GND-deltaPhi_Tempt_GND)+(Eg_Tempt_GND/2.0))+phib_Tempt_GND);
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+(+T2_Tempt_GND_Vdi_d-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Vsi_s=(+(+(+(+T2_Tempt_GND_Vsi_s-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Vge_di=(+(+(+(+T2_Tempt_GND_Vge_di-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Vge_e=(+(+(+(+T2_Tempt_GND_Vge_e-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Vdi_si=(+(+(+(+T2_Tempt_GND_Vdi_si-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Ve_si=(+(+(+(+T2_Tempt_GND_Ve_si-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Ve_di=(+(+(+(+T2_Tempt_GND_Ve_di-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Vge_si=(+(+(+(+T2_Tempt_GND_Vge_si-0.0)+(0.0/2.0-(Eg_Tempt_GND*0.0+0.0*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+0.0)-0.0);
  T3_Tempt_GND_Tempt_GND=(+(+(+(+T2_Tempt_GND_Tempt_GND-deltaPhi_Tempt_GND_Tempt_GND)+(Eg_Tempt_GND_Tempt_GND/2.0-(Eg_Tempt_GND*0.0+Eg_Tempt_GND*0.0+Eg*0.0)/2.0/2.0+2*Eg*0.0*0.0/2.0/2.0/2.0))+phib_Tempt_GND_Tempt_GND)-0.0);
#endif
#endif
T3=((((T2-deltaPhi)+(Eg/2.0))+phib)-pModel->DELVFBACC);
EXIT_IF_ISNAN(((((T2-deltaPhi)+(Eg/2.0))+phib)-pModel->DELVFBACC))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=T3_Vge_di;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=(+T3_Vge_di_Vge_di+0.0);
  T0_Vge_di_Vge_e=(+T3_Vge_di_Vge_e+0.0);
  T0_Vge_di_Ve_si=(+T3_Vge_di_Ve_si+0.0);
  T0_Vge_di_Ve_di=(+T3_Vge_di_Ve_di+0.0);
  T0_Vge_di_Vge_si=(+T3_Vge_di_Vge_si+0.0);
  T0_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si+0.0);
  T0_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND+0.0);
#endif
T0_Vge_e=T3_Vge_e;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+T3_Vge_e_Vge_di+0.0);
  T0_Vge_e_Vge_e=(+T3_Vge_e_Vge_e+0.0);
  T0_Vge_e_Ve_si=(+T3_Vge_e_Ve_si+0.0);
  T0_Vge_e_Ve_di=(+T3_Vge_e_Ve_di+0.0);
  T0_Vge_e_Vge_si=(+T3_Vge_e_Vge_si+0.0);
  T0_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si+0.0);
  T0_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND+0.0);
#endif
T0_Ve_si=T3_Ve_si;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+T3_Ve_si_Vge_di+0.0);
  T0_Ve_si_Vge_e=(+T3_Ve_si_Vge_e+0.0);
  T0_Ve_si_Ve_si=(+T3_Ve_si_Ve_si+0.0);
  T0_Ve_si_Ve_di=(+T3_Ve_si_Ve_di+0.0);
  T0_Ve_si_Vge_si=(+T3_Ve_si_Vge_si+0.0);
  T0_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si+0.0);
  T0_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND+0.0);
#endif
T0_Ve_di=T3_Ve_di;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+T3_Ve_di_Vge_di+0.0);
  T0_Ve_di_Vge_e=(+T3_Ve_di_Vge_e+0.0);
  T0_Ve_di_Ve_si=(+T3_Ve_di_Ve_si+0.0);
  T0_Ve_di_Ve_di=(+T3_Ve_di_Ve_di+0.0);
  T0_Ve_di_Vge_si=(+T3_Ve_di_Vge_si+0.0);
  T0_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si+0.0);
  T0_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND+0.0);
#endif
T0_Vge_si=T3_Vge_si;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+T3_Vge_si_Vge_di+0.0);
  T0_Vge_si_Vge_e=(+T3_Vge_si_Vge_e+0.0);
  T0_Vge_si_Ve_si=(+T3_Vge_si_Ve_si+0.0);
  T0_Vge_si_Ve_di=(+T3_Vge_si_Ve_di+0.0);
  T0_Vge_si_Vge_si=(+T3_Vge_si_Vge_si+0.0);
  T0_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si+0.0);
  T0_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND+0.0);
#endif
T0_Vdi_si=T3_Vdi_si;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di+0.0);
  T0_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e+0.0);
  T0_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si+0.0);
  T0_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di+0.0);
  T0_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si+0.0);
  T0_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si+0.0);
  T0_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND+0.0);
#endif
T0_Tempt_GND=T3_Tempt_GND;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di+0.0);
  T0_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e+0.0);
  T0_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si+0.0);
  T0_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di+0.0);
  T0_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si+0.0);
  T0_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si+0.0);
  T0_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND+0.0);
#endif
#endif
T0=(T3+0.02);
EXIT_IF_ISNAN((T3+0.02))
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,((T0*T0)+(4.0*0.02)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,((T0*T0)+(4.0*0.02)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
vge_overlap_Vge_di=(0.5*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Vge_di_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_di_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_di+((T0_Vge_di*T0)+(T0*T0_Vge_di))*d10_sqrt0)+0.5*(+T0_Vge_di_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_di*T0)+(T0*T0_Vge_di))+d10_sqrt0*(+(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Vge_e=(0.5*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Vge_e_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_e_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_e+((T0_Vge_e*T0)+(T0*T0_Vge_e))*d10_sqrt0)+0.5*(+T0_Vge_e_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_e*T0)+(T0*T0_Vge_e))+d10_sqrt0*(+(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Ve_si=(0.5*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Ve_si_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_si_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_si+((T0_Ve_si*T0)+(T0*T0_Ve_si))*d10_sqrt0)+0.5*(+T0_Ve_si_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_si*T0)+(T0*T0_Ve_si))+d10_sqrt0*(+(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Ve_di=(0.5*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Ve_di_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Ve_di_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Ve_di+((T0_Ve_di*T0)+(T0*T0_Ve_di))*d10_sqrt0)+0.5*(+T0_Ve_di_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Ve_di*T0)+(T0*T0_Ve_di))+d10_sqrt0*(+(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Vge_si=(0.5*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Vge_si_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vge_si_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vge_si+((T0_Vge_si*T0)+(T0*T0_Vge_si))*d10_sqrt0)+0.5*(+T0_Vge_si_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vge_si*T0)+(T0*T0_Vge_si))+d10_sqrt0*(+(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Vdi_si=(0.5*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Vdi_si_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Vdi_si_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Vdi_si+((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*d10_sqrt0)+0.5*(+T0_Vdi_si_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Vdi_si*T0)+(T0*T0_Vdi_si))+d10_sqrt0*(+(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
vge_overlap_Tempt_GND=(0.5*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0));
#if defined(_DERIVATE2)
  vge_overlap_Tempt_GND_Vge_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_di+((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_di*T0)+(T0*T0_Vge_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Vge_e=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_e+((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_e+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_e*T0)+(T0*T0_Vge_e)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Ve_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_si+((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_si*T0)+(T0*T0_Ve_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Ve_di=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Ve_di+((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Ve_di+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Ve_di*T0)+(T0*T0_Ve_di)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Vge_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vge_si+((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vge_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vge_si*T0)+(T0*T0_Vge_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Vdi_si=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Vdi_si+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Vdi_si+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Vdi_si*T0)+(T0*T0_Vdi_si)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
  vge_overlap_Tempt_GND_Tempt_GND=(+0.0*(T0+d00_sqrt0)+0.0*(T0_Tempt_GND+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*d10_sqrt0)+0.0*(T0_Tempt_GND+((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*d10_sqrt0)+0.5*(+T0_Tempt_GND_Tempt_GND+(m20_sqrt(((T0*T0)+(4.0*0.02)))*((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND)))+(0.0))*((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))+d10_sqrt0*(+(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND)+(+0.0*0.02+0.0*0.0+0.0*0.0+4.0*0.0)))));
#endif
#endif
vge_overlap=(0.5*(T0+d00_sqrt0));
EXIT_IF_ISNAN((0.5*(T0+d00_sqrt0)))
}
#endif
#if defined(_DYNAMIC)
{
double m00_sqrt(d00_sqrt0,(1.0+((4.0*vge_overlap)/CKAPPAB_i)))
#if defined(_DERIVATEFORDDX)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+((4.0*vge_overlap)/CKAPPAB_i)))
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(e,ge) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
Qeg_Vge_di=(Qeg_Vge_di-((NFINtotal*LeffCV)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Vge_di_Vge_di=(+Qeg_Vge_di_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Vge_di-vge_overlap_Vge_di_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Vge_e=(+Qeg_Vge_di_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Vge_e-vge_overlap_Vge_di_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Vdi_si=(+Qeg_Vge_di_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Vdi_si-vge_overlap_Vge_di_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Ve_si=(+Qeg_Vge_di_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Ve_si-vge_overlap_Vge_di_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Ve_di=(+Qeg_Vge_di_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Ve_di-vge_overlap_Vge_di_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Vge_si=(+Qeg_Vge_di_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Vge_si-vge_overlap_Vge_di_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Tempt_GND=(+Qeg_Vge_di_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_di_Tempt_GND-vge_overlap_Vge_di_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Vge_di+4.0*vge_overlap_Vge_di_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_di_Ve_ge=(+Qeg_Vge_di_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Vge_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Vge_di+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Vge_di)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Vge_e=(Qeg_Vge_e-((NFINtotal*LeffCV)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Vge_e_Vge_di=(+Qeg_Vge_e_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Vge_di-vge_overlap_Vge_e_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Vge_e=(+Qeg_Vge_e_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Vge_e-vge_overlap_Vge_e_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Vdi_si=(+Qeg_Vge_e_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Vdi_si-vge_overlap_Vge_e_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Ve_si=(+Qeg_Vge_e_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Ve_si-vge_overlap_Vge_e_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Ve_di=(+Qeg_Vge_e_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Ve_di-vge_overlap_Vge_e_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Vge_si=(+Qeg_Vge_e_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Vge_si-vge_overlap_Vge_e_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Tempt_GND=(+Qeg_Vge_e_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_e_Tempt_GND-vge_overlap_Vge_e_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Vge_e+4.0*vge_overlap_Vge_e_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_e_Ve_ge=(+Qeg_Vge_e_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Vge_e)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Vge_e+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Vge_e)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Vdi_si=(Qeg_Vdi_si-((NFINtotal*LeffCV)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Vdi_si_Vge_di=(+Qeg_Vdi_si_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Vge_di-vge_overlap_Vdi_si_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Vge_e=(+Qeg_Vdi_si_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Vge_e-vge_overlap_Vdi_si_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Vdi_si=(+Qeg_Vdi_si_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Vdi_si-vge_overlap_Vdi_si_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Ve_si=(+Qeg_Vdi_si_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Ve_si-vge_overlap_Vdi_si_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Ve_di=(+Qeg_Vdi_si_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Ve_di-vge_overlap_Vdi_si_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Vge_si=(+Qeg_Vdi_si_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Vge_si-vge_overlap_Vdi_si_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Tempt_GND=(+Qeg_Vdi_si_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vdi_si_Tempt_GND-vge_overlap_Vdi_si_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Vdi_si+4.0*vge_overlap_Vdi_si_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vdi_si_Ve_ge=(+Qeg_Vdi_si_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Vdi_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Vdi_si+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Vdi_si)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Ve_si=(Qeg_Ve_si-((NFINtotal*LeffCV)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Ve_si_Vge_di=(+Qeg_Ve_si_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Vge_di-vge_overlap_Ve_si_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Vge_e=(+Qeg_Ve_si_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Vge_e-vge_overlap_Ve_si_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Vdi_si=(+Qeg_Ve_si_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Vdi_si-vge_overlap_Ve_si_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Ve_si=(+Qeg_Ve_si_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Ve_si-vge_overlap_Ve_si_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Ve_di=(+Qeg_Ve_si_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Ve_di-vge_overlap_Ve_si_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Vge_si=(+Qeg_Ve_si_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Vge_si-vge_overlap_Ve_si_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Tempt_GND=(+Qeg_Ve_si_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_si_Tempt_GND-vge_overlap_Ve_si_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Ve_si+4.0*vge_overlap_Ve_si_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_si_Ve_ge=(+Qeg_Ve_si_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Ve_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Ve_si+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Ve_si)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Ve_di=(Qeg_Ve_di-((NFINtotal*LeffCV)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Ve_di_Vge_di=(+Qeg_Ve_di_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Vge_di-vge_overlap_Ve_di_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Vge_e=(+Qeg_Ve_di_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Vge_e-vge_overlap_Ve_di_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Vdi_si=(+Qeg_Ve_di_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Vdi_si-vge_overlap_Ve_di_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Ve_si=(+Qeg_Ve_di_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Ve_si-vge_overlap_Ve_di_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Ve_di=(+Qeg_Ve_di_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Ve_di-vge_overlap_Ve_di_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Vge_si=(+Qeg_Ve_di_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Vge_si-vge_overlap_Ve_di_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Tempt_GND=(+Qeg_Ve_di_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Ve_di_Tempt_GND-vge_overlap_Ve_di_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Ve_di+4.0*vge_overlap_Ve_di_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Ve_di_Ve_ge=(+Qeg_Ve_di_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Ve_di)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Ve_di+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Ve_di)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Vge_si=(Qeg_Vge_si-((NFINtotal*LeffCV)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Vge_si_Vge_di=(+Qeg_Vge_si_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Vge_di-vge_overlap_Vge_si_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Vge_e=(+Qeg_Vge_si_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Vge_e-vge_overlap_Vge_si_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Vdi_si=(+Qeg_Vge_si_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Vdi_si-vge_overlap_Vge_si_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Ve_si=(+Qeg_Vge_si_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Ve_si-vge_overlap_Vge_si_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Ve_di=(+Qeg_Vge_si_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Ve_di-vge_overlap_Vge_si_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Vge_si=(+Qeg_Vge_si_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Vge_si-vge_overlap_Vge_si_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Tempt_GND=(+Qeg_Vge_si_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Vge_si_Tempt_GND-vge_overlap_Vge_si_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Vge_si+4.0*vge_overlap_Vge_si_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Vge_si_Ve_ge=(+Qeg_Vge_si_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Vge_si)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Vge_si+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Vge_si)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Tempt_GND=(Qeg_Tempt_GND-((NFINtotal*LeffCV)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))));
#if defined(_DERIVATE2)
  Qeg_Tempt_GND_Vge_di=(+Qeg_Tempt_GND_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Vge_di-vge_overlap_Tempt_GND_Vge_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_di+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Vge_di)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Vge_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Vge_e=(+Qeg_Tempt_GND_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Vge_e-vge_overlap_Tempt_GND_Vge_e)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_e+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Vge_e)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Vge_e))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Vdi_si=(+Qeg_Tempt_GND_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Vdi_si-vge_overlap_Tempt_GND_Vdi_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vdi_si+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Vdi_si)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Vdi_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Ve_si=(+Qeg_Tempt_GND_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Ve_si-vge_overlap_Tempt_GND_Ve_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_si+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Ve_si)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Ve_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Ve_di=(+Qeg_Tempt_GND_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Ve_di-vge_overlap_Tempt_GND_Ve_di)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Ve_di+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Ve_di)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Ve_di))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Vge_si=(+Qeg_Tempt_GND_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Vge_si-vge_overlap_Tempt_GND_Vge_si)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Vge_si+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Vge_si)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Vge_si))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Tempt_GND=(+Qeg_Tempt_GND_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+T3_Tempt_GND_Tempt_GND-vge_overlap_Tempt_GND_Tempt_GND)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*vge_overlap_Tempt_GND+0.0*vge_overlap_Tempt_GND+4.0*vge_overlap_Tempt_GND_Tempt_GND)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+((4.0*vge_overlap_Tempt_GND))*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
  Qeg_Tempt_GND_Ve_ge=(+Qeg_Tempt_GND_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*(CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0)))+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((0.5*CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0))+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)*d10_sqrt0+(0.5*CKAPPAB_i)*(+(m20_sqrt((1.0+((4.0*vge_overlap)/CKAPPAB_i)))*((0.0)/CKAPPAB_i)*((4.0*vge_overlap_Tempt_GND)/CKAPPAB_i)+d10_sqrt0*(+0.0+((+0.0*vge_overlap+0.0*0.0+0.0*vge_overlap_Tempt_GND+4.0*0.0)/CKAPPAB_i-((4.0*vge_overlap_Tempt_GND)*0.0+(0.0)*0.0+(4.0*vge_overlap)*0.0)/CKAPPAB_i/CKAPPAB_i+2*(4.0*vge_overlap)*0.0*0.0/CKAPPAB_i/CKAPPAB_i/CKAPPAB_i)))-0.0))))));
#endif
Qeg_Ve_ge=Qeg_Ve_ge;
#if defined(_DERIVATE2)
  Qeg_Ve_ge_Vge_di=(+Qeg_Ve_ge_Vge_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_di-vge_overlap_Vge_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Vge_e=(+Qeg_Ve_ge_Vge_e-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_e-vge_overlap_Vge_e)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_e))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Vdi_si=(+Qeg_Ve_ge_Vdi_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vdi_si-vge_overlap_Vdi_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vdi_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Ve_si=(+Qeg_Ve_ge_Ve_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_si-vge_overlap_Ve_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Ve_di=(+Qeg_Ve_ge_Ve_di-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Ve_di-vge_overlap_Ve_di)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Ve_di))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Vge_si=(+Qeg_Ve_ge_Vge_si-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Vge_si-vge_overlap_Vge_si)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Vge_si))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Tempt_GND=(+Qeg_Ve_ge_Tempt_GND-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((T3_Tempt_GND-vge_overlap_Tempt_GND)+((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0))))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*(((4.0*vge_overlap_Tempt_GND))/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
  Qeg_Ve_ge_Ve_ge=(+Qeg_Ve_ge_Ve_ge-(+(+0.0*LeffCV+0.0*0.0+0.0*0.0+NFINtotal*0.0)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))+0.0*((CGBL_i*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))))+(0.0)*0.0+(NFINtotal*LeffCV)*(+0.0*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))+0.0*((((0.0)*(d00_sqrt0-1.0))+((0.5*CKAPPAB_i)*((0.0)/CKAPPAB_i)*d10_sqrt0)))+0.0*0.0+CGBL_i*(+(+0.0-0.0)+(+(+0.0*CKAPPAB_i+0.0*0.0+0.0*0.0+0.5*0.0)*(d00_sqrt0-1.0)+0.0*((0.0)/CKAPPAB_i)*d10_sqrt0+(0.0)*0.0+(0.5*CKAPPAB_i)*(+0.0-0.0))))));
#endif
#endif
Qeg=(Qeg-((NFINtotal*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0))))));
EXIT_IF_ISNAN((Qeg-((NFINtotal*LeffCV)*(CGBL_i*((T3-vge_overlap)+((0.5*CKAPPAB_i)*(d00_sqrt0-1.0)))))))
}
#endif
}
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=0.0;
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=0.0;
  T0_Ve_si_Vge_e=0.0;
  T0_Ve_si_Ve_si=0.0;
  T0_Ve_si_Ve_di=0.0;
  T0_Ve_si_Vge_si=0.0;
  T0_Ve_si_Vdi_si=0.0;
  T0_Ve_si_Tempt_GND=0.0;
#endif
T0_Ve_di=0.0;
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=0.0;
  T0_Ve_di_Vge_e=0.0;
  T0_Ve_di_Ve_si=0.0;
  T0_Ve_di_Ve_di=0.0;
  T0_Ve_di_Vge_si=0.0;
  T0_Ve_di_Vdi_si=0.0;
  T0_Ve_di_Tempt_GND=0.0;
#endif
T0_Vge_si=0.0;
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=0.0;
  T0_Vge_si_Vge_e=0.0;
  T0_Vge_si_Ve_si=0.0;
  T0_Vge_si_Ve_di=0.0;
  T0_Vge_si_Vge_si=0.0;
  T0_Vge_si_Vdi_si=0.0;
  T0_Vge_si_Tempt_GND=0.0;
#endif
T0_Vdi_si=vds_Vdi_si;
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=0.0;
  T0_Vdi_si_Vge_e=0.0;
  T0_Vdi_si_Ve_si=0.0;
  T0_Vdi_si_Ve_di=0.0;
  T0_Vdi_si_Vge_si=0.0;
  T0_Vdi_si_Vdi_si=vds_Vdi_si_Vdi_si;
  T0_Vdi_si_Tempt_GND=0.0;
#endif
T0_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=0.0;
  T0_Tempt_GND_Vge_e=0.0;
  T0_Tempt_GND_Ve_si=0.0;
  T0_Tempt_GND_Ve_di=0.0;
  T0_Tempt_GND_Vge_si=0.0;
  T0_Tempt_GND_Vdi_si=0.0;
  T0_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T0=vds;
EXIT_IF_ISNAN(vds)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=((T0_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_di+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_di)*0.0+(0.0)*T0_Vge_di+(BIGEN_i*T0)*0.0)));
  T1_Vge_di_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_di+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_di)*0.0+(0.0)*T0_Vge_di+(BIGEN_i*T0)*0.0)));
  T1_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Vge_di)*T0+(BIGEN_i*T0_Vge_di)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Vge_di)));
  T1_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Vge_e)*T0+(BIGEN_i*T0_Vge_di)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Vge_e)));
  T1_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Ve_si)*T0+(BIGEN_i*T0_Vge_di)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Ve_si)));
  T1_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Ve_di)*T0+(BIGEN_i*T0_Vge_di)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Ve_di)));
  T1_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Vge_si)*T0+(BIGEN_i*T0_Vge_di)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Vge_si)));
  T1_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Vdi_si)*T0+(BIGEN_i*T0_Vge_di)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Vdi_si)));
  T1_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_di*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Vge_di)*T0)+((BIGEN_i*T0)*T0_Vge_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_di+BIGEN_i*T0_Vge_di_Tempt_GND)*T0+(BIGEN_i*T0_Vge_di)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Vge_di+(BIGEN_i*T0)*T0_Vge_di_Tempt_GND)));
#endif
T1_Vge_e=((T0_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_e+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_e)*0.0+(0.0)*T0_Vge_e+(BIGEN_i*T0)*0.0)));
  T1_Vge_e_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_e+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_e)*0.0+(0.0)*T0_Vge_e+(BIGEN_i*T0)*0.0)));
  T1_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Vge_di)*T0+(BIGEN_i*T0_Vge_e)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Vge_di)));
  T1_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Vge_e)*T0+(BIGEN_i*T0_Vge_e)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Vge_e)));
  T1_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Ve_si)*T0+(BIGEN_i*T0_Vge_e)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Ve_si)));
  T1_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Ve_di)*T0+(BIGEN_i*T0_Vge_e)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Ve_di)));
  T1_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Vge_si)*T0+(BIGEN_i*T0_Vge_e)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Vge_si)));
  T1_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Vdi_si)*T0+(BIGEN_i*T0_Vge_e)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Vdi_si)));
  T1_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_e*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Vge_e)*T0)+((BIGEN_i*T0)*T0_Vge_e))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_e+BIGEN_i*T0_Vge_e_Tempt_GND)*T0+(BIGEN_i*T0_Vge_e)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Vge_e+(BIGEN_i*T0)*T0_Vge_e_Tempt_GND)));
#endif
T1_Ve_si=((T0_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Ve_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Ve_si)*0.0+(0.0)*T0_Ve_si+(BIGEN_i*T0)*0.0)));
  T1_Ve_si_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Ve_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Ve_si)*0.0+(0.0)*T0_Ve_si+(BIGEN_i*T0)*0.0)));
  T1_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Vge_di)*T0+(BIGEN_i*T0_Ve_si)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Vge_di)));
  T1_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Vge_e)*T0+(BIGEN_i*T0_Ve_si)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Vge_e)));
  T1_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Ve_si)*T0+(BIGEN_i*T0_Ve_si)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Ve_si)));
  T1_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Ve_di)*T0+(BIGEN_i*T0_Ve_si)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Ve_di)));
  T1_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Vge_si)*T0+(BIGEN_i*T0_Ve_si)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Vge_si)));
  T1_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Vdi_si)*T0+(BIGEN_i*T0_Ve_si)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Vdi_si)));
  T1_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_si*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Ve_si)*T0)+((BIGEN_i*T0)*T0_Ve_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_si+BIGEN_i*T0_Ve_si_Tempt_GND)*T0+(BIGEN_i*T0_Ve_si)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Ve_si+(BIGEN_i*T0)*T0_Ve_si_Tempt_GND)));
#endif
T1_Ve_di=((T0_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*((0.0)*T0)+0.0*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Ve_di+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Ve_di)*0.0+(0.0)*T0_Ve_di+(BIGEN_i*T0)*0.0)));
  T1_Ve_di_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*((0.0)*T0)+0.0*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Ve_di+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Ve_di)*0.0+(0.0)*T0_Ve_di+(BIGEN_i*T0)*0.0)));
  T1_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Vge_di)*T0+(BIGEN_i*T0_Ve_di)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Vge_di)));
  T1_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Vge_e)*T0+(BIGEN_i*T0_Ve_di)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Vge_e)));
  T1_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Ve_si)*T0+(BIGEN_i*T0_Ve_di)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Ve_si)));
  T1_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Ve_di)*T0+(BIGEN_i*T0_Ve_di)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Ve_di)));
  T1_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Vge_si)*T0+(BIGEN_i*T0_Ve_di)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Vge_si)));
  T1_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Vdi_si)*T0+(BIGEN_i*T0_Ve_di)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Vdi_si)));
  T1_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Ve_di*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Ve_di)*T0)+((BIGEN_i*T0)*T0_Ve_di))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Ve_di+BIGEN_i*T0_Ve_di_Tempt_GND)*T0+(BIGEN_i*T0_Ve_di)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Ve_di+(BIGEN_i*T0)*T0_Ve_di_Tempt_GND)));
#endif
T1_Vge_si=((T0_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_si)*0.0+(0.0)*T0_Vge_si+(BIGEN_i*T0)*0.0)));
  T1_Vge_si_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vge_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vge_si)*0.0+(0.0)*T0_Vge_si+(BIGEN_i*T0)*0.0)));
  T1_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Vge_di)*T0+(BIGEN_i*T0_Vge_si)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Vge_di)));
  T1_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Vge_e)*T0+(BIGEN_i*T0_Vge_si)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Vge_e)));
  T1_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Ve_si)*T0+(BIGEN_i*T0_Vge_si)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Ve_si)));
  T1_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Ve_di)*T0+(BIGEN_i*T0_Vge_si)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Ve_di)));
  T1_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Vge_si)*T0+(BIGEN_i*T0_Vge_si)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Vge_si)));
  T1_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Vdi_si)*T0+(BIGEN_i*T0_Vge_si)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Vdi_si)));
  T1_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vge_si*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Vge_si)*T0)+((BIGEN_i*T0)*T0_Vge_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vge_si+BIGEN_i*T0_Vge_si_Tempt_GND)*T0+(BIGEN_i*T0_Vge_si)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Vge_si+(BIGEN_i*T0)*T0_Vge_si_Tempt_GND)));
#endif
T1_Vdi_si=((T0_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vdi_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vdi_si)*0.0+(0.0)*T0_Vdi_si+(BIGEN_i*T0)*0.0)));
  T1_Vdi_si_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*((0.0)*T0)+0.0*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Vdi_si+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Vdi_si)*0.0+(0.0)*T0_Vdi_si+(BIGEN_i*T0)*0.0)));
  T1_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Vge_di)*T0+(BIGEN_i*T0_Vdi_si)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Vge_di)));
  T1_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Vge_e)*T0+(BIGEN_i*T0_Vdi_si)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Vge_e)));
  T1_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Ve_si)*T0+(BIGEN_i*T0_Vdi_si)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Ve_si)));
  T1_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Ve_di)*T0+(BIGEN_i*T0_Vdi_si)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Ve_di)));
  T1_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Vge_si)*T0+(BIGEN_i*T0_Vdi_si)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Vge_si)));
  T1_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Vdi_si)*T0+(BIGEN_i*T0_Vdi_si)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Vdi_si)));
  T1_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Vdi_si*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Vdi_si)*T0)+((BIGEN_i*T0)*T0_Vdi_si))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Vdi_si+BIGEN_i*T0_Vdi_si_Tempt_GND)*T0+(BIGEN_i*T0_Vdi_si)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Vdi_si+(BIGEN_i*T0)*T0_Vdi_si_Tempt_GND)));
#endif
T1_Tempt_GND=((T0_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0)))+(T0*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*((0.0)*T0)+0.0*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Tempt_GND+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Tempt_GND)*0.0+(0.0)*T0_Tempt_GND+(BIGEN_i*T0)*0.0)));
  T1_Tempt_GND_Vsi_s=(+0.0*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*((0.0)*T0)+0.0*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*0.0+0.0*T0_Tempt_GND+BIGEN_i*0.0)*T0+(BIGEN_i*T0_Tempt_GND)*0.0+(0.0)*T0_Tempt_GND+(BIGEN_i*T0)*0.0)));
  T1_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Vge_di))*T0)+((BIGEN_i*T0)*T0_Vge_di)))+T0_Vge_di*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_di+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Vge_di)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Vge_di+((BIGEN_i*T0_Vge_di))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Vge_di)));
  T1_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Vge_e))*T0)+((BIGEN_i*T0)*T0_Vge_e)))+T0_Vge_e*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_e+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Vge_e)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Vge_e+((BIGEN_i*T0_Vge_e))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Vge_e)));
  T1_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Ve_si))*T0)+((BIGEN_i*T0)*T0_Ve_si)))+T0_Ve_si*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_si+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Ve_si)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Ve_si+((BIGEN_i*T0_Ve_si))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Ve_si)));
  T1_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Ve_di))*T0)+((BIGEN_i*T0)*T0_Ve_di)))+T0_Ve_di*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Ve_di+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Ve_di)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Ve_di+((BIGEN_i*T0_Ve_di))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Ve_di)));
  T1_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Vge_si))*T0)+((BIGEN_i*T0)*T0_Vge_si)))+T0_Vge_si*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vge_si+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Vge_si)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Vge_si+((BIGEN_i*T0_Vge_si))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Vge_si)));
  T1_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Vdi_si))*T0)+((BIGEN_i*T0)*T0_Vdi_si)))+T0_Vdi_si*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Vdi_si+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Vdi_si)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Vdi_si+((BIGEN_i*T0_Vdi_si))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Vdi_si)));
  T1_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*(AIGEN_i+((BIGEN_i*T0)*T0))+T0_Tempt_GND*(((((BIGEN_i*T0_Tempt_GND))*T0)+((BIGEN_i*T0)*T0_Tempt_GND)))+T0_Tempt_GND*(((BIGEN_i*T0_Tempt_GND)*T0)+((BIGEN_i*T0)*T0_Tempt_GND))+T0*(+0.0+(+(+0.0*T0+0.0*T0_Tempt_GND+0.0*T0_Tempt_GND+BIGEN_i*T0_Tempt_GND_Tempt_GND)*T0+(BIGEN_i*T0_Tempt_GND)*T0_Tempt_GND+((BIGEN_i*T0_Tempt_GND))*T0_Tempt_GND+(BIGEN_i*T0)*T0_Tempt_GND_Tempt_GND)));
#endif
#endif
T1=(T0*(AIGEN_i+((BIGEN_i*T0)*T0)));
EXIT_IF_ISNAN((T0*(AIGEN_i+((BIGEN_i*T0)*T0))))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe= */
idsgen_Tempt_GND=(((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp_Tempt_GND)*T1)+((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Tempt_GND));
idsgen_Vge_di=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Vge_di);
idsgen_Vge_e=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Vge_e);
idsgen_Ve_si=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Ve_si);
idsgen_Ve_di=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Ve_di);
idsgen_Vge_si=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Vge_si);
idsgen_Vdi_si=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1_Vdi_si);
#endif
idsgen=((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1);
EXIT_IF_ISNAN(((((pModel->HFIN*pInst->TFIN)*(Leff-(2.0*LINTIGEN_i)))*igentemp)*T1))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=((+(+0.0*coxeff+ueff_Vge_e*0.0+0.0*coxeff_Vge_e+ueff*0.0)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Vge_e=((+(+ueff_Vge_e_Vge_e*coxeff+ueff_Vge_e*coxeff_Vge_e+ueff_Vge_e*coxeff_Vge_e+ueff*coxeff_Vge_e_Vge_e)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Ve_si=((+(+ueff_Vge_e_Ve_si*coxeff+ueff_Vge_e*coxeff_Ve_si+ueff_Ve_si*coxeff_Vge_e+ueff*coxeff_Vge_e_Ve_si)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Ve_di=((+(+ueff_Vge_e_Ve_di*coxeff+ueff_Vge_e*coxeff_Ve_di+ueff_Ve_di*coxeff_Vge_e+ueff*coxeff_Vge_e_Ve_di)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Vge_si=((+(+ueff_Vge_e_Vge_si*coxeff+ueff_Vge_e*coxeff_Vge_si+ueff_Vge_si*coxeff_Vge_e+ueff*coxeff_Vge_e_Vge_si)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Vdi_si=((+(+ueff_Vge_e_Vdi_si*coxeff+ueff_Vge_e*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Vge_e+ueff*coxeff_Vge_e_Vdi_si)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_e_Tempt_GND=((+(+ueff_Vge_e_Tempt_GND*coxeff+ueff_Vge_e*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Vge_e+ueff*coxeff_Vge_e_Tempt_GND)*Weff0+((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Ve_si=(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((+(+0.0*coxeff+ueff_Ve_si*0.0+0.0*coxeff_Ve_si+ueff*0.0)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Vge_e=((+(+ueff_Ve_si_Vge_e*coxeff+ueff_Ve_si*coxeff_Vge_e+ueff_Vge_e*coxeff_Ve_si+ueff*coxeff_Ve_si_Vge_e)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Ve_si=((+(+ueff_Ve_si_Ve_si*coxeff+ueff_Ve_si*coxeff_Ve_si+ueff_Ve_si*coxeff_Ve_si+ueff*coxeff_Ve_si_Ve_si)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Ve_di=((+(+ueff_Ve_si_Ve_di*coxeff+ueff_Ve_si*coxeff_Ve_di+ueff_Ve_di*coxeff_Ve_si+ueff*coxeff_Ve_si_Ve_di)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Vge_si=((+(+ueff_Ve_si_Vge_si*coxeff+ueff_Ve_si*coxeff_Vge_si+ueff_Vge_si*coxeff_Ve_si+ueff*coxeff_Ve_si_Vge_si)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Vdi_si=((+(+ueff_Ve_si_Vdi_si*coxeff+ueff_Ve_si*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Ve_si+ueff*coxeff_Ve_si_Vdi_si)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_si_Tempt_GND=((+(+ueff_Ve_si_Tempt_GND*coxeff+ueff_Ve_si*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Ve_si+ueff*coxeff_Ve_si_Tempt_GND)*Weff0+((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Ve_di=(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((+(+0.0*coxeff+ueff_Ve_di*0.0+0.0*coxeff_Ve_di+ueff*0.0)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Vge_e=((+(+ueff_Ve_di_Vge_e*coxeff+ueff_Ve_di*coxeff_Vge_e+ueff_Vge_e*coxeff_Ve_di+ueff*coxeff_Ve_di_Vge_e)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Ve_si=((+(+ueff_Ve_di_Ve_si*coxeff+ueff_Ve_di*coxeff_Ve_si+ueff_Ve_si*coxeff_Ve_di+ueff*coxeff_Ve_di_Ve_si)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Ve_di=((+(+ueff_Ve_di_Ve_di*coxeff+ueff_Ve_di*coxeff_Ve_di+ueff_Ve_di*coxeff_Ve_di+ueff*coxeff_Ve_di_Ve_di)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Vge_si=((+(+ueff_Ve_di_Vge_si*coxeff+ueff_Ve_di*coxeff_Vge_si+ueff_Vge_si*coxeff_Ve_di+ueff*coxeff_Ve_di_Vge_si)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Vdi_si=((+(+ueff_Ve_di_Vdi_si*coxeff+ueff_Ve_di*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Ve_di+ueff*coxeff_Ve_di_Vdi_si)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Ve_di_Tempt_GND=((+(+ueff_Ve_di_Tempt_GND*coxeff+ueff_Ve_di*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Ve_di+ueff*coxeff_Ve_di_Tempt_GND)*Weff0+((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Vge_si=(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=((+(+0.0*coxeff+ueff_Vge_si*0.0+0.0*coxeff_Vge_si+ueff*0.0)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Vge_e=((+(+ueff_Vge_si_Vge_e*coxeff+ueff_Vge_si*coxeff_Vge_e+ueff_Vge_e*coxeff_Vge_si+ueff*coxeff_Vge_si_Vge_e)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Ve_si=((+(+ueff_Vge_si_Ve_si*coxeff+ueff_Vge_si*coxeff_Ve_si+ueff_Ve_si*coxeff_Vge_si+ueff*coxeff_Vge_si_Ve_si)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Ve_di=((+(+ueff_Vge_si_Ve_di*coxeff+ueff_Vge_si*coxeff_Ve_di+ueff_Ve_di*coxeff_Vge_si+ueff*coxeff_Vge_si_Ve_di)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Vge_si=((+(+ueff_Vge_si_Vge_si*coxeff+ueff_Vge_si*coxeff_Vge_si+ueff_Vge_si*coxeff_Vge_si+ueff*coxeff_Vge_si_Vge_si)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Vdi_si=((+(+ueff_Vge_si_Vdi_si*coxeff+ueff_Vge_si*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Vge_si+ueff*coxeff_Vge_si_Vdi_si)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vge_si_Tempt_GND=((+(+ueff_Vge_si_Tempt_GND*coxeff+ueff_Vge_si*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Vge_si+ueff*coxeff_Vge_si_Tempt_GND)*Weff0+((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Vdi_si=(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=((+(+0.0*coxeff+ueff_Vdi_si*0.0+0.0*coxeff_Vdi_si+ueff*0.0)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Vge_e=((+(+ueff_Vdi_si_Vge_e*coxeff+ueff_Vdi_si*coxeff_Vge_e+ueff_Vge_e*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Vge_e)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Ve_si=((+(+ueff_Vdi_si_Ve_si*coxeff+ueff_Vdi_si*coxeff_Ve_si+ueff_Ve_si*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Ve_si)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Ve_di=((+(+ueff_Vdi_si_Ve_di*coxeff+ueff_Vdi_si*coxeff_Ve_di+ueff_Ve_di*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Ve_di)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Vge_si=((+(+ueff_Vdi_si_Vge_si*coxeff+ueff_Vdi_si*coxeff_Vge_si+ueff_Vge_si*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Vge_si)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Vdi_si=((+(+ueff_Vdi_si_Vdi_si*coxeff+ueff_Vdi_si*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Vdi_si)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Vdi_si_Tempt_GND=((+(+ueff_Vdi_si_Tempt_GND*coxeff+ueff_Vdi_si*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Vdi_si+ueff*coxeff_Vdi_si_Tempt_GND)*Weff0+((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
T0_Tempt_GND=(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0/Leff);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((+(+0.0*coxeff+ueff_Tempt_GND*0.0+0.0*coxeff_Tempt_GND+ueff*0.0)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(0.0)*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((0.0)*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vge_e=((+(+ueff_Tempt_GND_Vge_e*coxeff+ueff_Tempt_GND*coxeff_Vge_e+ueff_Vge_e*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Vge_e)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Vge_e*coxeff)+(ueff*coxeff_Vge_e)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Ve_si=((+(+ueff_Tempt_GND_Ve_si*coxeff+ueff_Tempt_GND*coxeff_Ve_si+ueff_Ve_si*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Ve_si)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Ve_si*coxeff)+(ueff*coxeff_Ve_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Ve_di=((+(+ueff_Tempt_GND_Ve_di*coxeff+ueff_Tempt_GND*coxeff_Ve_di+ueff_Ve_di*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Ve_di)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Ve_di*coxeff)+(ueff*coxeff_Ve_di)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vge_si=((+(+ueff_Tempt_GND_Vge_si*coxeff+ueff_Tempt_GND*coxeff_Vge_si+ueff_Vge_si*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Vge_si)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Vge_si*coxeff)+(ueff*coxeff_Vge_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Vdi_si=((+(+ueff_Tempt_GND_Vdi_si*coxeff+ueff_Tempt_GND*coxeff_Vdi_si+ueff_Vdi_si*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Vdi_si)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Vdi_si*coxeff)+(ueff*coxeff_Vdi_si)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
  T0_Tempt_GND_Tempt_GND=((+(+ueff_Tempt_GND_Tempt_GND*coxeff+ueff_Tempt_GND*coxeff_Tempt_GND+ueff_Tempt_GND*coxeff_Tempt_GND+ueff*coxeff_Tempt_GND_Tempt_GND)*Weff0+((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*0.0+(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*0.0+(ueff*coxeff)*0.0)/Leff-(((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND))*Weff0*0.0+((((ueff_Tempt_GND*coxeff)+(ueff*coxeff_Tempt_GND)))*Weff0)*0.0+((ueff*coxeff)*Weff0)*0.0)/Leff/Leff+2*((ueff*coxeff)*Weff0)*0.0*0.0/Leff/Leff/Leff);
#endif
#endif
T0=(((ueff*coxeff)*Weff0)/Leff);
EXIT_IF_ISNAN((((ueff*coxeff)*Weff0)/Leff))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igidl_Vge_di=(NFINtotal*igidl_Vge_di);
#if defined(_DERIVATE2)
  igidl_Vge_di_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vge_di);
  igidl_Vge_di_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vdi_d);
  igidl_Vge_di_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vsi_s);
  igidl_Vge_di_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vge_e);
  igidl_Vge_di_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vdi_si);
  igidl_Vge_di_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Tempt_GND);
  igidl_Vge_di_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Ve_si);
  igidl_Vge_di_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Ve_di);
  igidl_Vge_di_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vge_di+NFINtotal*igidl_Vge_di_Vge_si);
#endif
igidl_Vdi_d=(NFINtotal*igidl_Vdi_d);
#if defined(_DERIVATE2)
  igidl_Vdi_d_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vge_di);
  igidl_Vdi_d_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vdi_d);
  igidl_Vdi_d_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vsi_s);
  igidl_Vdi_d_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vge_e);
  igidl_Vdi_d_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vdi_si);
  igidl_Vdi_d_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Tempt_GND);
  igidl_Vdi_d_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Ve_si);
  igidl_Vdi_d_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Ve_di);
  igidl_Vdi_d_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vdi_d+NFINtotal*igidl_Vdi_d_Vge_si);
#endif
igidl_Vsi_s=(NFINtotal*igidl_Vsi_s);
#if defined(_DERIVATE2)
  igidl_Vsi_s_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vge_di);
  igidl_Vsi_s_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vdi_d);
  igidl_Vsi_s_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vsi_s);
  igidl_Vsi_s_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vge_e);
  igidl_Vsi_s_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vdi_si);
  igidl_Vsi_s_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Tempt_GND);
  igidl_Vsi_s_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Ve_si);
  igidl_Vsi_s_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Ve_di);
  igidl_Vsi_s_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vsi_s+NFINtotal*igidl_Vsi_s_Vge_si);
#endif
igidl_Vge_e=(NFINtotal*igidl_Vge_e);
#if defined(_DERIVATE2)
  igidl_Vge_e_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vge_di);
  igidl_Vge_e_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vdi_d);
  igidl_Vge_e_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vsi_s);
  igidl_Vge_e_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vge_e);
  igidl_Vge_e_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vdi_si);
  igidl_Vge_e_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Tempt_GND);
  igidl_Vge_e_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Ve_si);
  igidl_Vge_e_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Ve_di);
  igidl_Vge_e_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vge_e+NFINtotal*igidl_Vge_e_Vge_si);
#endif
igidl_Vdi_si=(NFINtotal*igidl_Vdi_si);
#if defined(_DERIVATE2)
  igidl_Vdi_si_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vge_di);
  igidl_Vdi_si_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vdi_d);
  igidl_Vdi_si_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vsi_s);
  igidl_Vdi_si_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vge_e);
  igidl_Vdi_si_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vdi_si);
  igidl_Vdi_si_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Tempt_GND);
  igidl_Vdi_si_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Ve_si);
  igidl_Vdi_si_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Ve_di);
  igidl_Vdi_si_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vdi_si+NFINtotal*igidl_Vdi_si_Vge_si);
#endif
igidl_Tempt_GND=(NFINtotal*igidl_Tempt_GND);
#if defined(_DERIVATE2)
  igidl_Tempt_GND_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vge_di);
  igidl_Tempt_GND_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vdi_d);
  igidl_Tempt_GND_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vsi_s);
  igidl_Tempt_GND_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vge_e);
  igidl_Tempt_GND_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vdi_si);
  igidl_Tempt_GND_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Tempt_GND);
  igidl_Tempt_GND_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Ve_si);
  igidl_Tempt_GND_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Ve_di);
  igidl_Tempt_GND_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Tempt_GND+NFINtotal*igidl_Tempt_GND_Vge_si);
#endif
igidl_Ve_si=(NFINtotal*igidl_Ve_si);
#if defined(_DERIVATE2)
  igidl_Ve_si_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vge_di);
  igidl_Ve_si_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vdi_d);
  igidl_Ve_si_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vsi_s);
  igidl_Ve_si_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vge_e);
  igidl_Ve_si_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vdi_si);
  igidl_Ve_si_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Tempt_GND);
  igidl_Ve_si_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Ve_si);
  igidl_Ve_si_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Ve_di);
  igidl_Ve_si_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Ve_si+NFINtotal*igidl_Ve_si_Vge_si);
#endif
igidl_Ve_di=(NFINtotal*igidl_Ve_di);
#if defined(_DERIVATE2)
  igidl_Ve_di_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vge_di);
  igidl_Ve_di_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vdi_d);
  igidl_Ve_di_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vsi_s);
  igidl_Ve_di_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vge_e);
  igidl_Ve_di_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vdi_si);
  igidl_Ve_di_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Tempt_GND);
  igidl_Ve_di_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Ve_si);
  igidl_Ve_di_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Ve_di);
  igidl_Ve_di_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Ve_di+NFINtotal*igidl_Ve_di_Vge_si);
#endif
igidl_Vge_si=(NFINtotal*igidl_Vge_si);
#if defined(_DERIVATE2)
  igidl_Vge_si_Vge_di=(+0.0*igidl+0.0*igidl_Vge_di+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vge_di);
  igidl_Vge_si_Vdi_d=(+0.0*igidl+0.0*igidl_Vdi_d+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vdi_d);
  igidl_Vge_si_Vsi_s=(+0.0*igidl+0.0*igidl_Vsi_s+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vsi_s);
  igidl_Vge_si_Vge_e=(+0.0*igidl+0.0*igidl_Vge_e+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vge_e);
  igidl_Vge_si_Vdi_si=(+0.0*igidl+0.0*igidl_Vdi_si+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vdi_si);
  igidl_Vge_si_Tempt_GND=(+0.0*igidl+0.0*igidl_Tempt_GND+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Tempt_GND);
  igidl_Vge_si_Ve_si=(+0.0*igidl+0.0*igidl_Ve_si+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Ve_si);
  igidl_Vge_si_Ve_di=(+0.0*igidl+0.0*igidl_Ve_di+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Ve_di);
  igidl_Vge_si_Vge_si=(+0.0*igidl+0.0*igidl_Vge_si+0.0*igidl_Vge_si+NFINtotal*igidl_Vge_si_Vge_si);
#endif
#endif
igidl=(NFINtotal*igidl);
EXIT_IF_ISNAN((NFINtotal*igidl))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igisl_Vge_di=(NFINtotal*igisl_Vge_di);
#if defined(_DERIVATE2)
  igisl_Vge_di_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vge_di);
  igisl_Vge_di_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vdi_d);
  igisl_Vge_di_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vsi_s);
  igisl_Vge_di_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vge_e);
  igisl_Vge_di_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vdi_si);
  igisl_Vge_di_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Tempt_GND);
  igisl_Vge_di_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Ve_si);
  igisl_Vge_di_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Ve_di);
  igisl_Vge_di_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vge_di+NFINtotal*igisl_Vge_di_Vge_si);
#endif
igisl_Vdi_d=(NFINtotal*igisl_Vdi_d);
#if defined(_DERIVATE2)
  igisl_Vdi_d_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vge_di);
  igisl_Vdi_d_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vdi_d);
  igisl_Vdi_d_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vsi_s);
  igisl_Vdi_d_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vge_e);
  igisl_Vdi_d_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vdi_si);
  igisl_Vdi_d_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Tempt_GND);
  igisl_Vdi_d_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Ve_si);
  igisl_Vdi_d_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Ve_di);
  igisl_Vdi_d_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vdi_d+NFINtotal*igisl_Vdi_d_Vge_si);
#endif
igisl_Vsi_s=(NFINtotal*igisl_Vsi_s);
#if defined(_DERIVATE2)
  igisl_Vsi_s_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vge_di);
  igisl_Vsi_s_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vdi_d);
  igisl_Vsi_s_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vsi_s);
  igisl_Vsi_s_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vge_e);
  igisl_Vsi_s_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vdi_si);
  igisl_Vsi_s_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Tempt_GND);
  igisl_Vsi_s_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Ve_si);
  igisl_Vsi_s_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Ve_di);
  igisl_Vsi_s_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vsi_s+NFINtotal*igisl_Vsi_s_Vge_si);
#endif
igisl_Vge_e=(NFINtotal*igisl_Vge_e);
#if defined(_DERIVATE2)
  igisl_Vge_e_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vge_di);
  igisl_Vge_e_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vdi_d);
  igisl_Vge_e_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vsi_s);
  igisl_Vge_e_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vge_e);
  igisl_Vge_e_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vdi_si);
  igisl_Vge_e_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Tempt_GND);
  igisl_Vge_e_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Ve_si);
  igisl_Vge_e_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Ve_di);
  igisl_Vge_e_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vge_e+NFINtotal*igisl_Vge_e_Vge_si);
#endif
igisl_Vdi_si=(NFINtotal*igisl_Vdi_si);
#if defined(_DERIVATE2)
  igisl_Vdi_si_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vge_di);
  igisl_Vdi_si_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vdi_d);
  igisl_Vdi_si_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vsi_s);
  igisl_Vdi_si_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vge_e);
  igisl_Vdi_si_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vdi_si);
  igisl_Vdi_si_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Tempt_GND);
  igisl_Vdi_si_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Ve_si);
  igisl_Vdi_si_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Ve_di);
  igisl_Vdi_si_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vdi_si+NFINtotal*igisl_Vdi_si_Vge_si);
#endif
igisl_Tempt_GND=(NFINtotal*igisl_Tempt_GND);
#if defined(_DERIVATE2)
  igisl_Tempt_GND_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vge_di);
  igisl_Tempt_GND_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vdi_d);
  igisl_Tempt_GND_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vsi_s);
  igisl_Tempt_GND_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vge_e);
  igisl_Tempt_GND_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vdi_si);
  igisl_Tempt_GND_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Tempt_GND);
  igisl_Tempt_GND_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Ve_si);
  igisl_Tempt_GND_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Ve_di);
  igisl_Tempt_GND_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Tempt_GND+NFINtotal*igisl_Tempt_GND_Vge_si);
#endif
igisl_Ve_si=(NFINtotal*igisl_Ve_si);
#if defined(_DERIVATE2)
  igisl_Ve_si_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vge_di);
  igisl_Ve_si_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vdi_d);
  igisl_Ve_si_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vsi_s);
  igisl_Ve_si_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vge_e);
  igisl_Ve_si_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vdi_si);
  igisl_Ve_si_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Tempt_GND);
  igisl_Ve_si_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Ve_si);
  igisl_Ve_si_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Ve_di);
  igisl_Ve_si_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Ve_si+NFINtotal*igisl_Ve_si_Vge_si);
#endif
igisl_Ve_di=(NFINtotal*igisl_Ve_di);
#if defined(_DERIVATE2)
  igisl_Ve_di_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vge_di);
  igisl_Ve_di_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vdi_d);
  igisl_Ve_di_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vsi_s);
  igisl_Ve_di_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vge_e);
  igisl_Ve_di_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vdi_si);
  igisl_Ve_di_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Tempt_GND);
  igisl_Ve_di_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Ve_si);
  igisl_Ve_di_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Ve_di);
  igisl_Ve_di_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Ve_di+NFINtotal*igisl_Ve_di_Vge_si);
#endif
igisl_Vge_si=(NFINtotal*igisl_Vge_si);
#if defined(_DERIVATE2)
  igisl_Vge_si_Vge_di=(+0.0*igisl+0.0*igisl_Vge_di+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vge_di);
  igisl_Vge_si_Vdi_d=(+0.0*igisl+0.0*igisl_Vdi_d+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vdi_d);
  igisl_Vge_si_Vsi_s=(+0.0*igisl+0.0*igisl_Vsi_s+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vsi_s);
  igisl_Vge_si_Vge_e=(+0.0*igisl+0.0*igisl_Vge_e+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vge_e);
  igisl_Vge_si_Vdi_si=(+0.0*igisl+0.0*igisl_Vdi_si+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vdi_si);
  igisl_Vge_si_Tempt_GND=(+0.0*igisl+0.0*igisl_Tempt_GND+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Tempt_GND);
  igisl_Vge_si_Ve_si=(+0.0*igisl+0.0*igisl_Ve_si+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Ve_si);
  igisl_Vge_si_Ve_di=(+0.0*igisl+0.0*igisl_Ve_di+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Ve_di);
  igisl_Vge_si_Vge_si=(+0.0*igisl+0.0*igisl_Vge_si+0.0*igisl_Vge_si+NFINtotal*igisl_Vge_si_Vge_si);
#endif
#endif
igisl=(NFINtotal*igisl);
EXIT_IF_ISNAN((NFINtotal*igisl))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcd_Vge_di=(NFINtotal*igcd_Vge_di);
#if defined(_DERIVATE2)
  igcd_Vge_di_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vge_di);
  igcd_Vge_di_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vge_e);
  igcd_Vge_di_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vdi_si);
  igcd_Vge_di_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Ve_si);
  igcd_Vge_di_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Ve_di);
  igcd_Vge_di_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vge_si);
  igcd_Vge_di_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Tempt_GND);
  igcd_Vge_di_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vdi_d);
  igcd_Vge_di_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vge_di+NFINtotal*igcd_Vge_di_Vsi_s);
#endif
igcd_Vge_e=(NFINtotal*igcd_Vge_e);
#if defined(_DERIVATE2)
  igcd_Vge_e_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vge_di);
  igcd_Vge_e_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vge_e);
  igcd_Vge_e_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vdi_si);
  igcd_Vge_e_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Ve_si);
  igcd_Vge_e_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Ve_di);
  igcd_Vge_e_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vge_si);
  igcd_Vge_e_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Tempt_GND);
  igcd_Vge_e_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vdi_d);
  igcd_Vge_e_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vge_e+NFINtotal*igcd_Vge_e_Vsi_s);
#endif
igcd_Vdi_si=(NFINtotal*igcd_Vdi_si);
#if defined(_DERIVATE2)
  igcd_Vdi_si_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vge_di);
  igcd_Vdi_si_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vge_e);
  igcd_Vdi_si_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vdi_si);
  igcd_Vdi_si_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Ve_si);
  igcd_Vdi_si_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Ve_di);
  igcd_Vdi_si_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vge_si);
  igcd_Vdi_si_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Tempt_GND);
  igcd_Vdi_si_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vdi_d);
  igcd_Vdi_si_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vdi_si+NFINtotal*igcd_Vdi_si_Vsi_s);
#endif
igcd_Ve_si=(NFINtotal*igcd_Ve_si);
#if defined(_DERIVATE2)
  igcd_Ve_si_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vge_di);
  igcd_Ve_si_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vge_e);
  igcd_Ve_si_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vdi_si);
  igcd_Ve_si_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Ve_si);
  igcd_Ve_si_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Ve_di);
  igcd_Ve_si_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vge_si);
  igcd_Ve_si_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Tempt_GND);
  igcd_Ve_si_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vdi_d);
  igcd_Ve_si_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Ve_si+NFINtotal*igcd_Ve_si_Vsi_s);
#endif
igcd_Ve_di=(NFINtotal*igcd_Ve_di);
#if defined(_DERIVATE2)
  igcd_Ve_di_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vge_di);
  igcd_Ve_di_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vge_e);
  igcd_Ve_di_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vdi_si);
  igcd_Ve_di_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Ve_si);
  igcd_Ve_di_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Ve_di);
  igcd_Ve_di_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vge_si);
  igcd_Ve_di_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Tempt_GND);
  igcd_Ve_di_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vdi_d);
  igcd_Ve_di_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Ve_di+NFINtotal*igcd_Ve_di_Vsi_s);
#endif
igcd_Vge_si=(NFINtotal*igcd_Vge_si);
#if defined(_DERIVATE2)
  igcd_Vge_si_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vge_di);
  igcd_Vge_si_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vge_e);
  igcd_Vge_si_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vdi_si);
  igcd_Vge_si_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Ve_si);
  igcd_Vge_si_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Ve_di);
  igcd_Vge_si_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vge_si);
  igcd_Vge_si_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Tempt_GND);
  igcd_Vge_si_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vdi_d);
  igcd_Vge_si_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vge_si+NFINtotal*igcd_Vge_si_Vsi_s);
#endif
igcd_Tempt_GND=(NFINtotal*igcd_Tempt_GND);
#if defined(_DERIVATE2)
  igcd_Tempt_GND_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vge_di);
  igcd_Tempt_GND_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vge_e);
  igcd_Tempt_GND_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vdi_si);
  igcd_Tempt_GND_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Ve_si);
  igcd_Tempt_GND_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Ve_di);
  igcd_Tempt_GND_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vge_si);
  igcd_Tempt_GND_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Tempt_GND);
  igcd_Tempt_GND_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vdi_d);
  igcd_Tempt_GND_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Tempt_GND+NFINtotal*igcd_Tempt_GND_Vsi_s);
#endif
igcd_Vdi_d=(NFINtotal*igcd_Vdi_d);
#if defined(_DERIVATE2)
  igcd_Vdi_d_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vge_di);
  igcd_Vdi_d_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vge_e);
  igcd_Vdi_d_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vdi_si);
  igcd_Vdi_d_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Ve_si);
  igcd_Vdi_d_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Ve_di);
  igcd_Vdi_d_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vge_si);
  igcd_Vdi_d_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Tempt_GND);
  igcd_Vdi_d_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vdi_d);
  igcd_Vdi_d_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vdi_d+NFINtotal*igcd_Vdi_d_Vsi_s);
#endif
igcd_Vsi_s=(NFINtotal*igcd_Vsi_s);
#if defined(_DERIVATE2)
  igcd_Vsi_s_Vge_di=(+0.0*igcd+0.0*igcd_Vge_di+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vge_di);
  igcd_Vsi_s_Vge_e=(+0.0*igcd+0.0*igcd_Vge_e+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vge_e);
  igcd_Vsi_s_Vdi_si=(+0.0*igcd+0.0*igcd_Vdi_si+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vdi_si);
  igcd_Vsi_s_Ve_si=(+0.0*igcd+0.0*igcd_Ve_si+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Ve_si);
  igcd_Vsi_s_Ve_di=(+0.0*igcd+0.0*igcd_Ve_di+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Ve_di);
  igcd_Vsi_s_Vge_si=(+0.0*igcd+0.0*igcd_Vge_si+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vge_si);
  igcd_Vsi_s_Tempt_GND=(+0.0*igcd+0.0*igcd_Tempt_GND+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Tempt_GND);
  igcd_Vsi_s_Vdi_d=(+0.0*igcd+0.0*igcd_Vdi_d+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vdi_d);
  igcd_Vsi_s_Vsi_s=(+0.0*igcd+0.0*igcd_Vsi_s+0.0*igcd_Vsi_s+NFINtotal*igcd_Vsi_s_Vsi_s);
#endif
#endif
igcd=(NFINtotal*igcd);
EXIT_IF_ISNAN((NFINtotal*igcd))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igcs_Vge_di=(NFINtotal*igcs_Vge_di);
#if defined(_DERIVATE2)
  igcs_Vge_di_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vge_di);
  igcs_Vge_di_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vge_e);
  igcs_Vge_di_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vdi_si);
  igcs_Vge_di_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Ve_si);
  igcs_Vge_di_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Ve_di);
  igcs_Vge_di_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vge_si);
  igcs_Vge_di_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Tempt_GND);
  igcs_Vge_di_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vdi_d);
  igcs_Vge_di_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vge_di+NFINtotal*igcs_Vge_di_Vsi_s);
#endif
igcs_Vge_e=(NFINtotal*igcs_Vge_e);
#if defined(_DERIVATE2)
  igcs_Vge_e_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vge_di);
  igcs_Vge_e_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vge_e);
  igcs_Vge_e_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vdi_si);
  igcs_Vge_e_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Ve_si);
  igcs_Vge_e_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Ve_di);
  igcs_Vge_e_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vge_si);
  igcs_Vge_e_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Tempt_GND);
  igcs_Vge_e_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vdi_d);
  igcs_Vge_e_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vge_e+NFINtotal*igcs_Vge_e_Vsi_s);
#endif
igcs_Vdi_si=(NFINtotal*igcs_Vdi_si);
#if defined(_DERIVATE2)
  igcs_Vdi_si_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vge_di);
  igcs_Vdi_si_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vge_e);
  igcs_Vdi_si_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vdi_si);
  igcs_Vdi_si_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Ve_si);
  igcs_Vdi_si_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Ve_di);
  igcs_Vdi_si_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vge_si);
  igcs_Vdi_si_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Tempt_GND);
  igcs_Vdi_si_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vdi_d);
  igcs_Vdi_si_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vdi_si+NFINtotal*igcs_Vdi_si_Vsi_s);
#endif
igcs_Ve_si=(NFINtotal*igcs_Ve_si);
#if defined(_DERIVATE2)
  igcs_Ve_si_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vge_di);
  igcs_Ve_si_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vge_e);
  igcs_Ve_si_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vdi_si);
  igcs_Ve_si_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Ve_si);
  igcs_Ve_si_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Ve_di);
  igcs_Ve_si_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vge_si);
  igcs_Ve_si_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Tempt_GND);
  igcs_Ve_si_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vdi_d);
  igcs_Ve_si_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Ve_si+NFINtotal*igcs_Ve_si_Vsi_s);
#endif
igcs_Ve_di=(NFINtotal*igcs_Ve_di);
#if defined(_DERIVATE2)
  igcs_Ve_di_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vge_di);
  igcs_Ve_di_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vge_e);
  igcs_Ve_di_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vdi_si);
  igcs_Ve_di_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Ve_si);
  igcs_Ve_di_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Ve_di);
  igcs_Ve_di_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vge_si);
  igcs_Ve_di_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Tempt_GND);
  igcs_Ve_di_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vdi_d);
  igcs_Ve_di_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Ve_di+NFINtotal*igcs_Ve_di_Vsi_s);
#endif
igcs_Vge_si=(NFINtotal*igcs_Vge_si);
#if defined(_DERIVATE2)
  igcs_Vge_si_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vge_di);
  igcs_Vge_si_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vge_e);
  igcs_Vge_si_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vdi_si);
  igcs_Vge_si_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Ve_si);
  igcs_Vge_si_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Ve_di);
  igcs_Vge_si_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vge_si);
  igcs_Vge_si_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Tempt_GND);
  igcs_Vge_si_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vdi_d);
  igcs_Vge_si_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vge_si+NFINtotal*igcs_Vge_si_Vsi_s);
#endif
igcs_Tempt_GND=(NFINtotal*igcs_Tempt_GND);
#if defined(_DERIVATE2)
  igcs_Tempt_GND_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vge_di);
  igcs_Tempt_GND_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vge_e);
  igcs_Tempt_GND_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vdi_si);
  igcs_Tempt_GND_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Ve_si);
  igcs_Tempt_GND_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Ve_di);
  igcs_Tempt_GND_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vge_si);
  igcs_Tempt_GND_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Tempt_GND);
  igcs_Tempt_GND_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vdi_d);
  igcs_Tempt_GND_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Tempt_GND+NFINtotal*igcs_Tempt_GND_Vsi_s);
#endif
igcs_Vdi_d=(NFINtotal*igcs_Vdi_d);
#if defined(_DERIVATE2)
  igcs_Vdi_d_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vge_di);
  igcs_Vdi_d_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vge_e);
  igcs_Vdi_d_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vdi_si);
  igcs_Vdi_d_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Ve_si);
  igcs_Vdi_d_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Ve_di);
  igcs_Vdi_d_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vge_si);
  igcs_Vdi_d_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Tempt_GND);
  igcs_Vdi_d_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vdi_d);
  igcs_Vdi_d_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vdi_d+NFINtotal*igcs_Vdi_d_Vsi_s);
#endif
igcs_Vsi_s=(NFINtotal*igcs_Vsi_s);
#if defined(_DERIVATE2)
  igcs_Vsi_s_Vge_di=(+0.0*igcs+0.0*igcs_Vge_di+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vge_di);
  igcs_Vsi_s_Vge_e=(+0.0*igcs+0.0*igcs_Vge_e+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vge_e);
  igcs_Vsi_s_Vdi_si=(+0.0*igcs+0.0*igcs_Vdi_si+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vdi_si);
  igcs_Vsi_s_Ve_si=(+0.0*igcs+0.0*igcs_Ve_si+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Ve_si);
  igcs_Vsi_s_Ve_di=(+0.0*igcs+0.0*igcs_Ve_di+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Ve_di);
  igcs_Vsi_s_Vge_si=(+0.0*igcs+0.0*igcs_Vge_si+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vge_si);
  igcs_Vsi_s_Tempt_GND=(+0.0*igcs+0.0*igcs_Tempt_GND+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Tempt_GND);
  igcs_Vsi_s_Vdi_d=(+0.0*igcs+0.0*igcs_Vdi_d+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vdi_d);
  igcs_Vsi_s_Vsi_s=(+0.0*igcs+0.0*igcs_Vsi_s+0.0*igcs_Vsi_s+NFINtotal*igcs_Vsi_s_Vsi_s);
#endif
#endif
igcs=(NFINtotal*igcs);
EXIT_IF_ISNAN((NFINtotal*igcs))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igs_Tempt_GND=(NFINtotal*igs_Tempt_GND);
#if defined(_DERIVATE2)
  igs_Tempt_GND_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Tempt_GND);
  igs_Tempt_GND_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Vge_si);
  igs_Tempt_GND_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Vge_di);
  igs_Tempt_GND_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Vge_e);
  igs_Tempt_GND_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Ve_si);
  igs_Tempt_GND_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Ve_di);
  igs_Tempt_GND_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Tempt_GND+NFINtotal*igs_Tempt_GND_Vdi_si);
#endif
igs_Vge_si=(NFINtotal*igs_Vge_si);
#if defined(_DERIVATE2)
  igs_Vge_si_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Tempt_GND);
  igs_Vge_si_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Vge_si);
  igs_Vge_si_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Vge_di);
  igs_Vge_si_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Vge_e);
  igs_Vge_si_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Ve_si);
  igs_Vge_si_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Ve_di);
  igs_Vge_si_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Vge_si+NFINtotal*igs_Vge_si_Vdi_si);
#endif
igs_Vge_di=(NFINtotal*igs_Vge_di);
#if defined(_DERIVATE2)
  igs_Vge_di_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Tempt_GND);
  igs_Vge_di_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Vge_si);
  igs_Vge_di_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Vge_di);
  igs_Vge_di_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Vge_e);
  igs_Vge_di_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Ve_si);
  igs_Vge_di_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Ve_di);
  igs_Vge_di_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Vge_di+NFINtotal*igs_Vge_di_Vdi_si);
#endif
igs_Vge_e=(NFINtotal*igs_Vge_e);
#if defined(_DERIVATE2)
  igs_Vge_e_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Tempt_GND);
  igs_Vge_e_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Vge_si);
  igs_Vge_e_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Vge_di);
  igs_Vge_e_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Vge_e);
  igs_Vge_e_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Ve_si);
  igs_Vge_e_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Ve_di);
  igs_Vge_e_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Vge_e+NFINtotal*igs_Vge_e_Vdi_si);
#endif
igs_Ve_si=(NFINtotal*igs_Ve_si);
#if defined(_DERIVATE2)
  igs_Ve_si_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Tempt_GND);
  igs_Ve_si_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Vge_si);
  igs_Ve_si_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Vge_di);
  igs_Ve_si_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Vge_e);
  igs_Ve_si_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Ve_si);
  igs_Ve_si_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Ve_di);
  igs_Ve_si_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Ve_si+NFINtotal*igs_Ve_si_Vdi_si);
#endif
igs_Ve_di=(NFINtotal*igs_Ve_di);
#if defined(_DERIVATE2)
  igs_Ve_di_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Tempt_GND);
  igs_Ve_di_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Vge_si);
  igs_Ve_di_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Vge_di);
  igs_Ve_di_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Vge_e);
  igs_Ve_di_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Ve_si);
  igs_Ve_di_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Ve_di);
  igs_Ve_di_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Ve_di+NFINtotal*igs_Ve_di_Vdi_si);
#endif
igs_Vdi_si=(NFINtotal*igs_Vdi_si);
#if defined(_DERIVATE2)
  igs_Vdi_si_Tempt_GND=(+0.0*igs+0.0*igs_Tempt_GND+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Tempt_GND);
  igs_Vdi_si_Vge_si=(+0.0*igs+0.0*igs_Vge_si+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Vge_si);
  igs_Vdi_si_Vge_di=(+0.0*igs+0.0*igs_Vge_di+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Vge_di);
  igs_Vdi_si_Vge_e=(+0.0*igs+0.0*igs_Vge_e+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Vge_e);
  igs_Vdi_si_Ve_si=(+0.0*igs+0.0*igs_Ve_si+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Ve_si);
  igs_Vdi_si_Ve_di=(+0.0*igs+0.0*igs_Ve_di+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Ve_di);
  igs_Vdi_si_Vdi_si=(+0.0*igs+0.0*igs_Vdi_si+0.0*igs_Vdi_si+NFINtotal*igs_Vdi_si_Vdi_si);
#endif
#endif
igs=(NFINtotal*igs);
EXIT_IF_ISNAN((NFINtotal*igs))
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(ge,si)V(ge,di)V(ge,e)V(e,si)V(e,di)V(di,si) ddxprobe=Temp(t,GND)V(di,GND)V(si,GND)V(ge,GND) */
igd_Tempt_GND=(NFINtotal*igd_Tempt_GND);
#if defined(_DERIVATE2)
  igd_Tempt_GND_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Tempt_GND);
  igd_Tempt_GND_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Vge_si);
  igd_Tempt_GND_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Vge_di);
  igd_Tempt_GND_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Vge_e);
  igd_Tempt_GND_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Ve_si);
  igd_Tempt_GND_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Ve_di);
  igd_Tempt_GND_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Tempt_GND+NFINtotal*igd_Tempt_GND_Vdi_si);
#endif
igd_Vge_si=(NFINtotal*igd_Vge_si);
#if defined(_DERIVATE2)
  igd_Vge_si_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Tempt_GND);
  igd_Vge_si_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Vge_si);
  igd_Vge_si_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Vge_di);
  igd_Vge_si_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Vge_e);
  igd_Vge_si_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Ve_si);
  igd_Vge_si_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Ve_di);
  igd_Vge_si_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Vge_si+NFINtotal*igd_Vge_si_Vdi_si);
#endif
igd_Vge_di=(NFINtotal*igd_Vge_di);
#if defined(_DERIVATE2)
  igd_Vge_di_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Tempt_GND);
  igd_Vge_di_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Vge_si);
  igd_Vge_di_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Vge_di);
  igd_Vge_di_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Vge_e);
  igd_Vge_di_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Ve_si);
  igd_Vge_di_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Ve_di);
  igd_Vge_di_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Vge_di+NFINtotal*igd_Vge_di_Vdi_si);
#endif
igd_Vge_e=(NFINtotal*igd_Vge_e);
#if defined(_DERIVATE2)
  igd_Vge_e_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Tempt_GND);
  igd_Vge_e_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Vge_si);
  igd_Vge_e_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Vge_di);
  igd_Vge_e_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Vge_e);
  igd_Vge_e_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Ve_si);
  igd_Vge_e_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Ve_di);
  igd_Vge_e_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Vge_e+NFINtotal*igd_Vge_e_Vdi_si);
#endif
igd_Ve_si=(NFINtotal*igd_Ve_si);
#if defined(_DERIVATE2)
  igd_Ve_si_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Tempt_GND);
  igd_Ve_si_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Vge_si);
  igd_Ve_si_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Vge_di);
  igd_Ve_si_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Vge_e);
  igd_Ve_si_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Ve_si);
  igd_Ve_si_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Ve_di);
  igd_Ve_si_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Ve_si+NFINtotal*igd_Ve_si_Vdi_si);
#endif
igd_Ve_di=(NFINtotal*igd_Ve_di);
#if defined(_DERIVATE2)
  igd_Ve_di_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Tempt_GND);
  igd_Ve_di_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Vge_si);
  igd_Ve_di_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Vge_di);
  igd_Ve_di_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Vge_e);
  igd_Ve_di_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Ve_si);
  igd_Ve_di_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Ve_di);
  igd_Ve_di_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Ve_di+NFINtotal*igd_Ve_di_Vdi_si);
#endif
igd_Vdi_si=(NFINtotal*igd_Vdi_si);
#if defined(_DERIVATE2)
  igd_Vdi_si_Tempt_GND=(+0.0*igd+0.0*igd_Tempt_GND+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Tempt_GND);
  igd_Vdi_si_Vge_si=(+0.0*igd+0.0*igd_Vge_si+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Vge_si);
  igd_Vdi_si_Vge_di=(+0.0*igd+0.0*igd_Vge_di+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Vge_di);
  igd_Vdi_si_Vge_e=(+0.0*igd+0.0*igd_Vge_e+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Vge_e);
  igd_Vdi_si_Ve_si=(+0.0*igd+0.0*igd_Ve_si+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Ve_si);
  igd_Vdi_si_Ve_di=(+0.0*igd+0.0*igd_Ve_di+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Ve_di);
  igd_Vdi_si_Vdi_si=(+0.0*igd+0.0*igd_Vdi_si+0.0*igd_Vdi_si+NFINtotal*igd_Vdi_si_Vdi_si);
#endif
#endif
igd=(NFINtotal*igd);
EXIT_IF_ISNAN((NFINtotal*igd))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbinv_Vge_e=(NFINtotal*igbinv_Vge_e);
igbinv_Vdi_si=(NFINtotal*igbinv_Vdi_si);
igbinv_Tempt_GND=(NFINtotal*igbinv_Tempt_GND);
igbinv_Ve_si=(NFINtotal*igbinv_Ve_si);
igbinv_Ve_di=(NFINtotal*igbinv_Ve_di);
igbinv_Vge_si=(NFINtotal*igbinv_Vge_si);
igbinv_Vge_di=(NFINtotal*igbinv_Vge_di);
igbinv_Vdi_d=(NFINtotal*igbinv_Vdi_d);
igbinv_Vsi_s=(NFINtotal*igbinv_Vsi_s);
#endif
igbinv=(NFINtotal*igbinv);
EXIT_IF_ISNAN((NFINtotal*igbinv))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbacc_Vge_e=(NFINtotal*igbacc_Vge_e);
igbacc_Vdi_si=(NFINtotal*igbacc_Vdi_si);
igbacc_Tempt_GND=(NFINtotal*igbacc_Tempt_GND);
igbacc_Ve_si=(NFINtotal*igbacc_Ve_si);
igbacc_Ve_di=(NFINtotal*igbacc_Ve_di);
igbacc_Vge_si=(NFINtotal*igbacc_Vge_si);
igbacc_Vge_di=(NFINtotal*igbacc_Vge_di);
igbacc_Vdi_d=(NFINtotal*igbacc_Vdi_d);
igbacc_Vsi_s=(NFINtotal*igbacc_Vsi_s);
#endif
igbacc=(NFINtotal*igbacc);
EXIT_IF_ISNAN((NFINtotal*igbacc))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si) ddxprobe= */
idsgen_Tempt_GND=(NFINtotal*idsgen_Tempt_GND);
idsgen_Vge_di=(NFINtotal*idsgen_Vge_di);
idsgen_Vge_e=(NFINtotal*idsgen_Vge_e);
idsgen_Ve_si=(NFINtotal*idsgen_Ve_si);
idsgen_Ve_di=(NFINtotal*idsgen_Ve_di);
idsgen_Vge_si=(NFINtotal*idsgen_Vge_si);
idsgen_Vdi_si=(NFINtotal*idsgen_Vdi_si);
#endif
idsgen=(NFINtotal*idsgen);
EXIT_IF_ISNAN((NFINtotal*idsgen))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbs_Vge_e=0.0;
igbs_Vdi_si=0.0;
igbs_Tempt_GND=0.0;
igbs_Ve_si=0.0;
igbs_Ve_di=0.0;
igbs_Vge_si=0.0;
igbs_Vge_di=0.0;
igbs_Vdi_d=0.0;
igbs_Vsi_s=0.0;
#endif
igbs=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbd_Vge_e=0.0;
igbd_Vdi_si=0.0;
igbd_Tempt_GND=0.0;
igbd_Ve_si=0.0;
igbd_Ve_di=0.0;
igbd_Vge_si=0.0;
igbd_Vge_di=0.0;
igbd_Vdi_d=0.0;
igbd_Vsi_s=0.0;
#endif
igbd=0.0;
EXIT_IF_ISNAN(0.0)
if
((pModel->BULKMOD==0))
{
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbs_Vge_e=(igbinv_Vge_e+igbacc_Vge_e)*wf;
igbs_Vdi_si=(((igbinv_Vdi_si+igbacc_Vdi_si)*wf)+((igbinv+igbacc)*wf_Vdi_si));
igbs_Tempt_GND=(((igbinv_Tempt_GND+igbacc_Tempt_GND)*wf)+((igbinv+igbacc)*wf_Tempt_GND));
igbs_Ve_si=(igbinv_Ve_si+igbacc_Ve_si)*wf;
igbs_Ve_di=(igbinv_Ve_di+igbacc_Ve_di)*wf;
igbs_Vge_si=(igbinv_Vge_si+igbacc_Vge_si)*wf;
igbs_Vge_di=(igbinv_Vge_di+igbacc_Vge_di)*wf;
igbs_Vdi_d=(igbinv_Vdi_d+igbacc_Vdi_d)*wf;
igbs_Vsi_s=(igbinv_Vsi_s+igbacc_Vsi_s)*wf;
#endif
igbs=((igbinv+igbacc)*wf);
EXIT_IF_ISNAN(((igbinv+igbacc)*wf))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s) ddxprobe= */
igbd_Vge_e=(igbinv_Vge_e+igbacc_Vge_e)*wr;
igbd_Vdi_si=(((igbinv_Vdi_si+igbacc_Vdi_si)*wr)+((igbinv+igbacc)*wr_Vdi_si));
igbd_Tempt_GND=(((igbinv_Tempt_GND+igbacc_Tempt_GND)*wr)+((igbinv+igbacc)*wr_Tempt_GND));
igbd_Ve_si=(igbinv_Ve_si+igbacc_Ve_si)*wr;
igbd_Ve_di=(igbinv_Ve_di+igbacc_Ve_di)*wr;
igbd_Vge_si=(igbinv_Vge_si+igbacc_Vge_si)*wr;
igbd_Vge_di=(igbinv_Vge_di+igbacc_Vge_di)*wr;
igbd_Vdi_d=(igbinv_Vdi_d+igbacc_Vdi_d)*wr;
igbd_Vsi_s=(igbinv_Vsi_s+igbacc_Vsi_s)*wr;
#endif
igbd=((igbinv+igbacc)*wr);
EXIT_IF_ISNAN(((igbinv+igbacc)*wr))
}
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Esatnoi_Tempt_GND=(((2.0*VSAT_a_Tempt_GND)*ueff-(2.0*VSAT_a)*ueff_Tempt_GND)/ueff/ueff);
Esatnoi_Vdi_si=(((2.0*VSAT_a_Vdi_si)*ueff-(2.0*VSAT_a)*ueff_Vdi_si)/ueff/ueff);
Esatnoi_Vge_e=(-(2.0*VSAT_a)*ueff_Vge_e/ueff/ueff);
Esatnoi_Ve_si=(-(2.0*VSAT_a)*ueff_Ve_si/ueff/ueff);
Esatnoi_Ve_di=(-(2.0*VSAT_a)*ueff_Ve_di/ueff/ueff);
Esatnoi_Vge_si=(-(2.0*VSAT_a)*ueff_Vge_si/ueff/ueff);
#endif
Esatnoi=((2.0*VSAT_a)/ueff);
EXIT_IF_ISNAN(((2.0*VSAT_a)/ueff))
if
((((pModel->NOIA>0.0)||(pModel->NOIB>0.0))||(pModel->NOIC>0.0)))
{
Leffnoi=(Leff-(2.0*LINTNOI_i));
EXIT_IF_ISNAN((Leff-(2.0*LINTNOI_i)))
Leffnoisq=(Leffnoi*Leffnoi);
EXIT_IF_ISNAN((Leffnoi*Leffnoi))
if
((pModel->EM<=0.0))
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
DelClm_Vge_di=0.0;
DelClm_Vge_e=0.0;
DelClm_Ve_si=0.0;
DelClm_Ve_di=0.0;
DelClm_Vge_si=0.0;
DelClm_Vdi_si=0.0;
DelClm_Tempt_GND=0.0;
#endif
DelClm=0.0;
EXIT_IF_ISNAN(0.0)
}
else
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=(-((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=((+(0.0/litl-(0.0*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*0.0+0.0*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Vge_e=((+(0.0/litl-(0.0*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Vge_e+0.0*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Ve_si=((+(0.0/litl-(0.0*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Ve_di=((+(0.0/litl-(0.0*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Vge_si=((+(0.0/litl-(0.0*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Vdi_si=((+(0.0/litl-(0.0*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_e_Tempt_GND=((+(0.0/litl-(0.0*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-(0.0*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vge_e+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_e*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Ve_si=(((diffVds_Ve_si/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=((+(0.0/litl-(diffVds_Ve_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*0.0+0.0*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Vge_e=((+(0.0/litl-(diffVds_Ve_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Vge_e+0.0*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Ve_si=((+(diffVds_Ve_si_Ve_si/litl-(diffVds_Ve_si*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Ve_di=((+(diffVds_Ve_si_Ve_di/litl-(diffVds_Ve_si*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Vge_si=((+(diffVds_Ve_si_Vge_si/litl-(diffVds_Ve_si*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Vdi_si=((+(diffVds_Ve_si_Vdi_si/litl-(diffVds_Ve_si*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_si_Tempt_GND=((+(diffVds_Ve_si_Tempt_GND/litl-(diffVds_Ve_si*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_si/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Ve_si+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_si*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Ve_di=(((diffVds_Ve_di/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=((+(0.0/litl-(diffVds_Ve_di*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*0.0+0.0*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Vge_e=((+(0.0/litl-(diffVds_Ve_di*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Vge_e+0.0*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Ve_si=((+(diffVds_Ve_di_Ve_si/litl-(diffVds_Ve_di*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Ve_di=((+(diffVds_Ve_di_Ve_di/litl-(diffVds_Ve_di*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Vge_si=((+(diffVds_Ve_di_Vge_si/litl-(diffVds_Ve_di*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Vdi_si=((+(diffVds_Ve_di_Vdi_si/litl-(diffVds_Ve_di*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Ve_di_Tempt_GND=((+(diffVds_Ve_di_Tempt_GND/litl-(diffVds_Ve_di*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Ve_di/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Ve_di+((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Ve_di*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Vge_si=(((diffVds_Vge_si/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=((+(0.0/litl-(diffVds_Vge_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*0.0+0.0*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Vge_e=((+(0.0/litl-(diffVds_Vge_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Vge_e+0.0*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Ve_si=((+(diffVds_Vge_si_Ve_si/litl-(diffVds_Vge_si*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Ve_di=((+(diffVds_Vge_si_Ve_di/litl-(diffVds_Vge_si*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Vge_si=((+(diffVds_Vge_si_Vge_si/litl-(diffVds_Vge_si*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Vdi_si=((+(diffVds_Vge_si_Vdi_si/litl-(diffVds_Vge_si*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vge_si_Tempt_GND=((+(diffVds_Vge_si_Tempt_GND/litl-(diffVds_Vge_si*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vge_si/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vge_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vge_si*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Vdi_si=(((diffVds_Vdi_si/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=((+(0.0/litl-(diffVds_Vdi_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*0.0+0.0*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Vge_e=((+(0.0/litl-(diffVds_Vdi_si*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Vge_e+0.0*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Ve_si=((+(diffVds_Vdi_si_Ve_si/litl-(diffVds_Vdi_si*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Ve_di=((+(diffVds_Vdi_si_Ve_di/litl-(diffVds_Vdi_si*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Vge_si=((+(diffVds_Vdi_si_Vge_si/litl-(diffVds_Vdi_si*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Vdi_si=((+(diffVds_Vdi_si_Vdi_si/litl-(diffVds_Vdi_si*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Vdi_si_Tempt_GND=((+(diffVds_Vdi_si_Tempt_GND/litl-(diffVds_Vdi_si*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Vdi_si/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Vdi_si+((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Vdi_si*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
T0_Tempt_GND=(((diffVds_Tempt_GND/litl)*Esatnoi-((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND)/Esatnoi/Esatnoi);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=((+(0.0/litl-(diffVds_Tempt_GND*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*0.0+0.0*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*0.0)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*0.0/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Vge_e=((+(0.0/litl-(diffVds_Tempt_GND*0.0+0.0*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Vge_e+0.0*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Vge_e)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Vge_e/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Ve_si=((+(diffVds_Tempt_GND_Ve_si/litl-(diffVds_Tempt_GND*0.0+diffVds_Ve_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Ve_si+(diffVds_Ve_si/litl)*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Ve_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Ve_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Ve_di=((+(diffVds_Tempt_GND_Ve_di/litl-(diffVds_Tempt_GND*0.0+diffVds_Ve_di*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Ve_di+(diffVds_Ve_di/litl)*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Ve_di)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Ve_di/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Vge_si=((+(diffVds_Tempt_GND_Vge_si/litl-(diffVds_Tempt_GND*0.0+diffVds_Vge_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Vge_si+(diffVds_Vge_si/litl)*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Vge_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Vge_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Vdi_si=((+(diffVds_Tempt_GND_Vdi_si/litl-(diffVds_Tempt_GND*0.0+diffVds_Vdi_si*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Vdi_si+(diffVds_Vdi_si/litl)*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Vdi_si)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Vdi_si/Esatnoi/Esatnoi/Esatnoi);
  T0_Tempt_GND_Tempt_GND=((+(diffVds_Tempt_GND_Tempt_GND/litl-(diffVds_Tempt_GND*0.0+diffVds_Tempt_GND*0.0+diffVds*0.0)/litl/litl+2*diffVds*0.0*0.0/litl/litl/litl)+0.0)/Esatnoi-((diffVds_Tempt_GND/litl)*Esatnoi_Tempt_GND+(diffVds_Tempt_GND/litl)*Esatnoi_Tempt_GND+((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND_Tempt_GND)/Esatnoi/Esatnoi+2*((diffVds/litl)+pModel->EM)*Esatnoi_Tempt_GND*Esatnoi_Tempt_GND/Esatnoi/Esatnoi/Esatnoi);
#endif
#endif
T0=(((diffVds/litl)+pModel->EM)/Esatnoi);
EXIT_IF_ISNAN((((diffVds/litl)+pModel->EM)/Esatnoi))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
DelClm_Vge_di=(litl*bsimcmg_d_lln(T0,T0_Vge_di));
DelClm_Vge_e=(litl*bsimcmg_d_lln(T0,T0_Vge_e));
DelClm_Ve_si=(litl*bsimcmg_d_lln(T0,T0_Ve_si));
DelClm_Ve_di=(litl*bsimcmg_d_lln(T0,T0_Ve_di));
DelClm_Vge_si=(litl*bsimcmg_d_lln(T0,T0_Vge_si));
DelClm_Vdi_si=(litl*bsimcmg_d_lln(T0,T0_Vdi_si));
DelClm_Tempt_GND=(litl*bsimcmg_d_lln(T0,T0_Tempt_GND));
#endif
DelClm=(litl*bsimcmg_lln(T0));
EXIT_IF_ISNAN((litl*bsimcmg_lln(T0)))
if
((DelClm<0.0))
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
DelClm_Vge_di=0.0;
DelClm_Vge_e=0.0;
DelClm_Ve_si=0.0;
DelClm_Ve_di=0.0;
DelClm_Vge_si=0.0;
DelClm_Vdi_si=0.0;
DelClm_Tempt_GND=0.0;
#endif
DelClm=0.0;
EXIT_IF_ISNAN(0.0)
}
}
{
double m00_fabs(d00_fabs0,ids)
#if defined(_DERIVATEFORDDX)
double m10_fabs(d10_fabs0,d00_fabs0,ids)
#endif
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Vge_di+d10_fabs0*ids_Vge_di_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Vge_di+d10_fabs0*ids_Vge_di_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Vge_di+d10_fabs0*ids_Vge_di_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Vge_di+d10_fabs0*ids_Vge_di_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Vge_di+d10_fabs0*ids_Vge_di_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Vge_di+d10_fabs0*ids_Vge_di_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_di_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Vge_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vge_di+d10_fabs0*ids_Vge_di_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*0.0+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
#endif
T1_Vge_e=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_e_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_e_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Vge_e+d10_fabs0*ids_Vge_e_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_e_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Vge_e+d10_fabs0*ids_Vge_e_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Vge_e);
  T1_Vge_e_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Vge_e+d10_fabs0*ids_Vge_e_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Ve_si);
  T1_Vge_e_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Vge_e+d10_fabs0*ids_Vge_e_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Ve_di);
  T1_Vge_e_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Vge_e+d10_fabs0*ids_Vge_e_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Vge_si);
  T1_Vge_e_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Vge_e+d10_fabs0*ids_Vge_e_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Vdi_si);
  T1_Vge_e_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Vge_e*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vge_e+d10_fabs0*ids_Vge_e_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Vge_e+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_e_Tempt_GND);
#endif
T1_Ve_si=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_si_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_si_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Ve_si+d10_fabs0*ids_Ve_si_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_si_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Ve_si+d10_fabs0*ids_Ve_si_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Vge_e);
  T1_Ve_si_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Ve_si+d10_fabs0*ids_Ve_si_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Ve_si+d10_fabs0*ids_Ve_si_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Ve_si+d10_fabs0*ids_Ve_si_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Ve_si+d10_fabs0*ids_Ve_si_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Ve_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Ve_si+d10_fabs0*ids_Ve_si_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Ve_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_si_Tempt_GND);
#endif
T1_Ve_di=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_di_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_di_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Ve_di+d10_fabs0*ids_Ve_di_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Ve_di_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Ve_di+d10_fabs0*ids_Ve_di_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Vge_e);
  T1_Ve_di_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Ve_di+d10_fabs0*ids_Ve_di_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Ve_di+d10_fabs0*ids_Ve_di_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Ve_di+d10_fabs0*ids_Ve_di_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Ve_di+d10_fabs0*ids_Ve_di_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Ve_di*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Ve_di+d10_fabs0*ids_Ve_di_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Ve_di+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Ve_di_Tempt_GND);
#endif
T1_Vge_si=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_si_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_si_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Vge_si+d10_fabs0*ids_Vge_si_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vge_si_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Vge_si+d10_fabs0*ids_Vge_si_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Vge_e);
  T1_Vge_si_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Vge_si+d10_fabs0*ids_Vge_si_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Vge_si+d10_fabs0*ids_Vge_si_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Vge_si+d10_fabs0*ids_Vge_si_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Vge_si+d10_fabs0*ids_Vge_si_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Vge_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vge_si+d10_fabs0*ids_Vge_si_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Vge_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vdi_si_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vdi_si_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Vge_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Vdi_si_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Vge_e))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Vge_e);
  T1_Vdi_si_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Ve_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Ve_di))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Vge_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Vdi_si))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*0.0+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+0.0*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Vdi_si*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Vdi_si+d10_fabs0*ids_Vdi_si_Tempt_GND))*ueff+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Vdi_si+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff)+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Tempt_GND_Vsi_s=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*0.0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*0.0)*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*0.0+((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Tempt_GND_Vge_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Vge_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_di*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Vge_di))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*0.0+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_di*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*0.0);
  T1_Tempt_GND_Vge_e=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Vge_e*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_e*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Vge_e))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Vge_e+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_e*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Vge_e);
  T1_Tempt_GND_Ve_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Ve_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_si*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Ve_si))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Ve_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_si*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Ve_di*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Ve_di*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Ve_di))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Ve_di+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Ve_di*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Vge_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vge_si*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Vge_si))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Vge_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vge_si*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*0.0+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*0.0)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Vdi_si*d10_fabs0+(((0.0)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Vdi_si*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Vdi_si))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Vdi_si+((((((0.0)*1.60219e-19)*Vtm)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Vdi_si*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*1.60219e-19+0.0*0.0+(0.0)*0.0+(1.60219e-19*1.60219e-19)*0.0)*Vtm+0.0*Vtm_Tempt_GND+((0.0)*1.60219e-19)*Vtm_Tempt_GND+((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND_Tempt_GND)*d00_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*ids_Tempt_GND*d10_fabs0+(((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*ids_Tempt_GND*d10_fabs0+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*(m20_fabs(ids)*ids_Tempt_GND*ids_Tempt_GND+d10_fabs0*ids_Tempt_GND_Tempt_GND))*ueff+(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0))*ueff_Tempt_GND+((((((((0.0)*1.60219e-19)*Vtm)+(((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm_Tempt_GND)))*d00_fabs0)+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*ids_Tempt_GND*d10_fabs0)))*ueff_Tempt_GND+((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff);
EXIT_IF_ISNAN((((((1.60219e-19*1.60219e-19)*1.60219e-19)*Vtm)*d00_fabs0)*ueff))
}
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=0.0;
  T2_Vdi_d_Vsi_s=0.0;
  T2_Vdi_d_Vge_di=0.0;
  T2_Vdi_d_Vge_e=0.0;
  T2_Vdi_d_Vge_si=0.0;
  T2_Vdi_d_Ve_si=0.0;
  T2_Vdi_d_Ve_di=0.0;
  T2_Vdi_d_Vdi_si=0.0;
  T2_Vdi_d_Tempt_GND=0.0;
#endif
T2_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=0.0;
  T2_Vsi_s_Vsi_s=0.0;
  T2_Vsi_s_Vge_di=0.0;
  T2_Vsi_s_Vge_e=0.0;
  T2_Vsi_s_Vge_si=0.0;
  T2_Vsi_s_Ve_si=0.0;
  T2_Vsi_s_Ve_di=0.0;
  T2_Vsi_s_Vdi_si=0.0;
  T2_Vsi_s_Tempt_GND=0.0;
#endif
T2_Vge_di=0.0;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=0.0;
  T2_Vge_di_Vsi_s=0.0;
  T2_Vge_di_Vge_di=0.0;
  T2_Vge_di_Vge_e=0.0;
  T2_Vge_di_Vge_si=0.0;
  T2_Vge_di_Ve_si=0.0;
  T2_Vge_di_Ve_di=0.0;
  T2_Vge_di_Vdi_si=0.0;
  T2_Vge_di_Tempt_GND=0.0;
#endif
T2_Vge_e=(1.0e10*coxeff_Vge_e)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_e+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_e+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_e+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Vge_e)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Vge_si)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Ve_si)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Ve_di)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_e_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Vge_e+1.0e10*coxeff_Vge_e_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Vge_e)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
T2_Vge_si=(1.0e10*coxeff_Vge_si)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vge_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Vge_e)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Vge_si)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Ve_si)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Ve_di)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vge_si_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Vge_si+1.0e10*coxeff_Vge_si_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Vge_si)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
T2_Ve_si=(1.0e10*coxeff_Ve_si)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Vge_e)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Vge_si)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Ve_si)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Ve_di)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_si_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Ve_si+1.0e10*coxeff_Ve_si_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Ve_si)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
T2_Ve_di=(1.0e10*coxeff_Ve_di)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_di+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_di+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Ve_di+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Vge_e)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Vge_si)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Ve_si)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Ve_di)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Ve_di_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Ve_di+1.0e10*coxeff_Ve_di_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Ve_di)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
T2_Vdi_si=(1.0e10*coxeff_Vdi_si)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vdi_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vdi_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Vdi_si+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Vge_e)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Vge_si)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Ve_si)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Ve_di)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Vdi_si_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Vdi_si+1.0e10*coxeff_Vdi_si_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Vdi_si)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
T2_Tempt_GND=(1.0e10*coxeff_Tempt_GND)*Leffnoisq;
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Tempt_GND+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Vsi_s=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Tempt_GND+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Vge_di=(+(+0.0*coxeff+0.0*0.0+0.0*coxeff_Tempt_GND+1.0e10*0.0)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+(0.0)*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Vge_e=(+(+0.0*coxeff+0.0*coxeff_Vge_e+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Vge_e)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Vge_e))*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Vge_si=(+(+0.0*coxeff+0.0*coxeff_Vge_si+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Vge_si)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Vge_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Ve_si=(+(+0.0*coxeff+0.0*coxeff_Ve_si+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Ve_si)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Ve_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Ve_di=(+(+0.0*coxeff+0.0*coxeff_Ve_di+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Ve_di)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Ve_di))*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Vdi_si=(+(+0.0*coxeff+0.0*coxeff_Vdi_si+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Vdi_si)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Vdi_si))*0.0+(1.0e10*coxeff)*0.0);
  T2_Tempt_GND_Tempt_GND=(+(+0.0*coxeff+0.0*coxeff_Tempt_GND+0.0*coxeff_Tempt_GND+1.0e10*coxeff_Tempt_GND_Tempt_GND)*Leffnoisq+(1.0e10*coxeff_Tempt_GND)*0.0+((1.0e10*coxeff_Tempt_GND))*0.0+(1.0e10*coxeff)*0.0);
#endif
#endif
T2=((1.0e10*coxeff)*Leffnoisq);
EXIT_IF_ISNAN(((1.0e10*coxeff)*Leffnoisq))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
N0_Vge_e=(coxeff_Vge_e*qis/1.60219e-19);
N0_Vdi_si=(((coxeff_Vdi_si*qis)+(coxeff*qis_Vdi_si))/1.60219e-19);
N0_Ve_si=(((coxeff_Ve_si*qis)+(coxeff*qis_Ve_si))/1.60219e-19);
N0_Ve_di=(((coxeff_Ve_di*qis)+(coxeff*qis_Ve_di))/1.60219e-19);
N0_Vge_si=(((coxeff_Vge_si*qis)+(coxeff*qis_Vge_si))/1.60219e-19);
N0_Tempt_GND=(((coxeff_Tempt_GND*qis)+(coxeff*qis_Tempt_GND))/1.60219e-19);
#endif
N0=((coxeff*qis)/1.60219e-19);
EXIT_IF_ISNAN(((coxeff*qis)/1.60219e-19))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
Nl_Vge_e=(coxeff_Vge_e*qid/1.60219e-19);
Nl_Vdi_si=(((coxeff_Vdi_si*qid)+(coxeff*qid_Vdi_si))/1.60219e-19);
Nl_Ve_si=(((coxeff_Ve_si*qid)+(coxeff*qid_Ve_si))/1.60219e-19);
Nl_Ve_di=(((coxeff_Ve_di*qid)+(coxeff*qid_Ve_di))/1.60219e-19);
Nl_Vge_si=(((coxeff_Vge_si*qid)+(coxeff*qid_Vge_si))/1.60219e-19);
Nl_Tempt_GND=(((coxeff_Tempt_GND*qid)+(coxeff*qid_Tempt_GND))/1.60219e-19);
#endif
Nl=((coxeff*qid)/1.60219e-19);
EXIT_IF_ISNAN(((coxeff*qid)/1.60219e-19))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
Nstar_Tempt_GND=(((Vtm_Tempt_GND/1.60219e-19)*(coxeff+CIT_a))+((Vtm/1.60219e-19)*(coxeff_Tempt_GND+CIT_a_Tempt_GND)));
Nstar_Vge_e=((Vtm/1.60219e-19)*coxeff_Vge_e);
Nstar_Vdi_si=((Vtm/1.60219e-19)*(coxeff_Vdi_si+CIT_a_Vdi_si));
Nstar_Ve_si=((Vtm/1.60219e-19)*coxeff_Ve_si);
Nstar_Ve_di=((Vtm/1.60219e-19)*coxeff_Ve_di);
Nstar_Vge_si=((Vtm/1.60219e-19)*coxeff_Vge_si);
#endif
Nstar=((Vtm/1.60219e-19)*(coxeff+CIT_a));
EXIT_IF_ISNAN(((Vtm/1.60219e-19)*(coxeff+CIT_a)))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Vge_e+Nstar_Vge_e_Vge_e)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Vge_e+Nstar_Vge_e_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Vdi_si+Nstar_Vge_e_Vdi_si)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Vdi_si+Nstar_Vge_e_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Ve_si+Nstar_Vge_e_Ve_si)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Ve_si+Nstar_Vge_e_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Ve_di+Nstar_Vge_e_Ve_di)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Ve_di+Nstar_Vge_e_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Vge_si+Nstar_Vge_e_Vge_si)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Vge_si+Nstar_Vge_e_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_e_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_e+Nstar_Vge_e)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_e_Tempt_GND+Nstar_Vge_e_Tempt_GND)/(Nl+Nstar)-((N0_Vge_e+Nstar_Vge_e)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_e+Nstar_Vge_e)+(N0+Nstar)*(+Nl_Vge_e_Tempt_GND+Nstar_Vge_e_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_e+Nstar_Vge_e)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T3_Vdi_si=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Vge_e+Nstar_Vdi_si_Vge_e)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Vge_e+Nstar_Vdi_si_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Vdi_si+Nstar_Vdi_si_Vdi_si)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Vdi_si+Nstar_Vdi_si_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Ve_si+Nstar_Vdi_si_Ve_si)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Ve_si+Nstar_Vdi_si_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Ve_di+Nstar_Vdi_si_Ve_di)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Ve_di+Nstar_Vdi_si_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Vge_si+Nstar_Vdi_si_Vge_si)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Vge_si+Nstar_Vdi_si_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vdi_si_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vdi_si_Tempt_GND+Nstar_Vdi_si_Tempt_GND)/(Nl+Nstar)-((N0_Vdi_si+Nstar_Vdi_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0+Nstar)*(+Nl_Vdi_si_Tempt_GND+Nstar_Vdi_si_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T3_Ve_si=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Vge_e+Nstar_Ve_si_Vge_e)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Vge_e+Nstar_Ve_si_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Vdi_si+Nstar_Ve_si_Vdi_si)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Vdi_si+Nstar_Ve_si_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Ve_si+Nstar_Ve_si_Ve_si)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Ve_si+Nstar_Ve_si_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Ve_di+Nstar_Ve_si_Ve_di)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Ve_di+Nstar_Ve_si_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Vge_si+Nstar_Ve_si_Vge_si)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Vge_si+Nstar_Ve_si_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_si_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_si+Nstar_Ve_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_si_Tempt_GND+Nstar_Ve_si_Tempt_GND)/(Nl+Nstar)-((N0_Ve_si+Nstar_Ve_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_si+Nstar_Ve_si)+(N0+Nstar)*(+Nl_Ve_si_Tempt_GND+Nstar_Ve_si_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_si+Nstar_Ve_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T3_Ve_di=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Vge_e+Nstar_Ve_di_Vge_e)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Vge_e+Nstar_Ve_di_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Vdi_si+Nstar_Ve_di_Vdi_si)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Vdi_si+Nstar_Ve_di_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Ve_si+Nstar_Ve_di_Ve_si)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Ve_si+Nstar_Ve_di_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Ve_di+Nstar_Ve_di_Ve_di)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Ve_di+Nstar_Ve_di_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Vge_si+Nstar_Ve_di_Vge_si)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Vge_si+Nstar_Ve_di_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Ve_di_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Ve_di+Nstar_Ve_di)*(Nl+Nstar)-(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Ve_di_Tempt_GND+Nstar_Ve_di_Tempt_GND)/(Nl+Nstar)-((N0_Ve_di+Nstar_Ve_di)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_di+Nstar_Ve_di)+(N0+Nstar)*(+Nl_Ve_di_Tempt_GND+Nstar_Ve_di_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Ve_di+Nstar_Ve_di)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T3_Vge_si=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Vge_e+Nstar_Vge_si_Vge_e)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Vge_e+Nstar_Vge_si_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Vdi_si+Nstar_Vge_si_Vdi_si)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Vdi_si+Nstar_Vge_si_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Ve_si+Nstar_Vge_si_Ve_si)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Ve_si+Nstar_Vge_si_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Ve_di+Nstar_Vge_si_Ve_di)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Ve_di+Nstar_Vge_si_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Vge_si+Nstar_Vge_si_Vge_si)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Vge_si+Nstar_Vge_si_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Vge_si_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Vge_si+Nstar_Vge_si)*(Nl+Nstar)-(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Vge_si_Tempt_GND+Nstar_Vge_si_Tempt_GND)/(Nl+Nstar)-((N0_Vge_si+Nstar_Vge_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_si+Nstar_Vge_si)+(N0+Nstar)*(+Nl_Vge_si_Tempt_GND+Nstar_Vge_si_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Vge_si+Nstar_Vge_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
T3_Tempt_GND=(pModel->NOIA*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar))));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Vsi_s=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Vge_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+0.0+0.0)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+0.0+0.0))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Vge_e=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Vge_e+Nstar_Tempt_GND_Vge_e)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_e+Nstar_Vge_e)+(N0_Vge_e+Nstar_Vge_e)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Vge_e+Nstar_Tempt_GND_Vge_e))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_e+Nstar_Vge_e)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Vdi_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Vdi_si+Nstar_Tempt_GND_Vdi_si)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_si+Nstar_Vdi_si)+(N0_Vdi_si+Nstar_Vdi_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Vdi_si+Nstar_Tempt_GND_Vdi_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_si+Nstar_Vdi_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Ve_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Ve_si+Nstar_Tempt_GND_Ve_si)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_si+Nstar_Ve_si)+(N0_Ve_si+Nstar_Ve_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Ve_si+Nstar_Tempt_GND_Ve_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_si+Nstar_Ve_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Ve_di=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Ve_di+Nstar_Tempt_GND_Ve_di)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_di+Nstar_Ve_di)+(N0_Ve_di+Nstar_Ve_di)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Ve_di+Nstar_Tempt_GND_Ve_di))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_di+Nstar_Ve_di)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Vge_si=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Vge_si+Nstar_Tempt_GND_Vge_si)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_si+Nstar_Vge_si)+(N0_Vge_si+Nstar_Vge_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Vge_si+Nstar_Tempt_GND_Vge_si))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_si+Nstar_Vge_si)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
  T3_Tempt_GND_Tempt_GND=(+0.0*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+0.0*bsimcmg_d_lln(((N0+Nstar)/(Nl+Nstar)),(((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar)-(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)))+pModel->NOIA*((+N0_Tempt_GND_Tempt_GND+Nstar_Tempt_GND_Tempt_GND)/(Nl+Nstar)-((N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0_Tempt_GND+Nstar_Tempt_GND)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(N0+Nstar)*(+Nl_Tempt_GND_Tempt_GND+Nstar_Tempt_GND_Tempt_GND))/(Nl+Nstar)/(Nl+Nstar)+2*(N0+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Tempt_GND+Nstar_Tempt_GND)/(Nl+Nstar)/(Nl+Nstar)/(Nl+Nstar)));
#endif
#endif
T3=(pModel->NOIA*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar))));
EXIT_IF_ISNAN((pModel->NOIA*bsimcmg_lln(((N0+Nstar)/(Nl+Nstar)))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=0.0;
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=0.0;
  T4_Vge_di_Vge_e=0.0;
  T4_Vge_di_Vdi_si=0.0;
  T4_Vge_di_Ve_si=0.0;
  T4_Vge_di_Ve_di=0.0;
  T4_Vge_di_Vge_si=0.0;
  T4_Vge_di_Tempt_GND=0.0;
#endif
T4_Vge_e=(pModel->NOIB*(N0_Vge_e-Nl_Vge_e));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+0.0-0.0));
  T4_Vge_e_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Vge_e-Nl_Vge_e_Vge_e));
  T4_Vge_e_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Vdi_si-Nl_Vge_e_Vdi_si));
  T4_Vge_e_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Ve_si-Nl_Vge_e_Ve_si));
  T4_Vge_e_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Ve_di-Nl_Vge_e_Ve_di));
  T4_Vge_e_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Vge_si-Nl_Vge_e_Vge_si));
  T4_Vge_e_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vge_e-Nl_Vge_e)+pModel->NOIB*(+N0_Vge_e_Tempt_GND-Nl_Vge_e_Tempt_GND));
#endif
T4_Vdi_si=(pModel->NOIB*(N0_Vdi_si-Nl_Vdi_si));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+0.0-0.0));
  T4_Vdi_si_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Vge_e-Nl_Vdi_si_Vge_e));
  T4_Vdi_si_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Vdi_si-Nl_Vdi_si_Vdi_si));
  T4_Vdi_si_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Ve_si-Nl_Vdi_si_Ve_si));
  T4_Vdi_si_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Ve_di-Nl_Vdi_si_Ve_di));
  T4_Vdi_si_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Vge_si-Nl_Vdi_si_Vge_si));
  T4_Vdi_si_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vdi_si-Nl_Vdi_si)+pModel->NOIB*(+N0_Vdi_si_Tempt_GND-Nl_Vdi_si_Tempt_GND));
#endif
T4_Ve_si=(pModel->NOIB*(N0_Ve_si-Nl_Ve_si));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+0.0-0.0));
  T4_Ve_si_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Vge_e-Nl_Ve_si_Vge_e));
  T4_Ve_si_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Vdi_si-Nl_Ve_si_Vdi_si));
  T4_Ve_si_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Ve_si-Nl_Ve_si_Ve_si));
  T4_Ve_si_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Ve_di-Nl_Ve_si_Ve_di));
  T4_Ve_si_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Vge_si-Nl_Ve_si_Vge_si));
  T4_Ve_si_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Ve_si-Nl_Ve_si)+pModel->NOIB*(+N0_Ve_si_Tempt_GND-Nl_Ve_si_Tempt_GND));
#endif
T4_Ve_di=(pModel->NOIB*(N0_Ve_di-Nl_Ve_di));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+0.0-0.0));
  T4_Ve_di_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Vge_e-Nl_Ve_di_Vge_e));
  T4_Ve_di_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Vdi_si-Nl_Ve_di_Vdi_si));
  T4_Ve_di_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Ve_si-Nl_Ve_di_Ve_si));
  T4_Ve_di_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Ve_di-Nl_Ve_di_Ve_di));
  T4_Ve_di_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Vge_si-Nl_Ve_di_Vge_si));
  T4_Ve_di_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Ve_di-Nl_Ve_di)+pModel->NOIB*(+N0_Ve_di_Tempt_GND-Nl_Ve_di_Tempt_GND));
#endif
T4_Vge_si=(pModel->NOIB*(N0_Vge_si-Nl_Vge_si));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+0.0-0.0));
  T4_Vge_si_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Vge_e-Nl_Vge_si_Vge_e));
  T4_Vge_si_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Vdi_si-Nl_Vge_si_Vdi_si));
  T4_Vge_si_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Ve_si-Nl_Vge_si_Ve_si));
  T4_Vge_si_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Ve_di-Nl_Vge_si_Ve_di));
  T4_Vge_si_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Vge_si-Nl_Vge_si_Vge_si));
  T4_Vge_si_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Vge_si-Nl_Vge_si)+pModel->NOIB*(+N0_Vge_si_Tempt_GND-Nl_Vge_si_Tempt_GND));
#endif
T4_Tempt_GND=(pModel->NOIB*(N0_Tempt_GND-Nl_Tempt_GND));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+0.0*(N0-Nl)+0.0*0.0+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+0.0-0.0));
  T4_Tempt_GND_Vge_e=(+0.0*(N0-Nl)+0.0*(N0_Vge_e-Nl_Vge_e)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Vge_e-Nl_Tempt_GND_Vge_e));
  T4_Tempt_GND_Vdi_si=(+0.0*(N0-Nl)+0.0*(N0_Vdi_si-Nl_Vdi_si)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Vdi_si-Nl_Tempt_GND_Vdi_si));
  T4_Tempt_GND_Ve_si=(+0.0*(N0-Nl)+0.0*(N0_Ve_si-Nl_Ve_si)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Ve_si-Nl_Tempt_GND_Ve_si));
  T4_Tempt_GND_Ve_di=(+0.0*(N0-Nl)+0.0*(N0_Ve_di-Nl_Ve_di)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Ve_di-Nl_Tempt_GND_Ve_di));
  T4_Tempt_GND_Vge_si=(+0.0*(N0-Nl)+0.0*(N0_Vge_si-Nl_Vge_si)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Vge_si-Nl_Tempt_GND_Vge_si));
  T4_Tempt_GND_Tempt_GND=(+0.0*(N0-Nl)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+0.0*(N0_Tempt_GND-Nl_Tempt_GND)+pModel->NOIB*(+N0_Tempt_GND_Tempt_GND-Nl_Tempt_GND_Tempt_GND));
#endif
#endif
T4=(pModel->NOIB*(N0-Nl));
EXIT_IF_ISNAN((pModel->NOIB*(N0-Nl)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=0.0;
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=0.0;
  T5_Vge_di_Vdi_d=0.0;
  T5_Vge_di_Vsi_s=0.0;
  T5_Vge_di_Vge_e=0.0;
  T5_Vge_di_Vdi_si=0.0;
  T5_Vge_di_Ve_si=0.0;
  T5_Vge_di_Ve_di=0.0;
  T5_Vge_di_Vge_si=0.0;
  T5_Vge_di_Tempt_GND=0.0;
#endif
T5_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=0.0;
  T5_Vdi_d_Vdi_d=0.0;
  T5_Vdi_d_Vsi_s=0.0;
  T5_Vdi_d_Vge_e=0.0;
  T5_Vdi_d_Vdi_si=0.0;
  T5_Vdi_d_Ve_si=0.0;
  T5_Vdi_d_Ve_di=0.0;
  T5_Vdi_d_Vge_si=0.0;
  T5_Vdi_d_Tempt_GND=0.0;
#endif
T5_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=0.0;
  T5_Vsi_s_Vdi_d=0.0;
  T5_Vsi_s_Vsi_s=0.0;
  T5_Vsi_s_Vge_e=0.0;
  T5_Vsi_s_Vdi_si=0.0;
  T5_Vsi_s_Ve_si=0.0;
  T5_Vsi_s_Ve_di=0.0;
  T5_Vsi_s_Vge_si=0.0;
  T5_Vsi_s_Tempt_GND=0.0;
#endif
T5_Vge_e=((0.5*pModel->NOIC)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_e*0.0+0.0*N0_Vge_e+N0*0.0)-(+0.0*Nl+Nl_Vge_e*0.0+0.0*Nl_Vge_e+Nl*0.0)));
  T5_Vge_e_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_e*0.0+0.0*N0_Vge_e+N0*0.0)-(+0.0*Nl+Nl_Vge_e*0.0+0.0*Nl_Vge_e+Nl*0.0)));
  T5_Vge_e_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_e*0.0+0.0*N0_Vge_e+N0*0.0)-(+0.0*Nl+Nl_Vge_e*0.0+0.0*Nl_Vge_e+Nl*0.0)));
  T5_Vge_e_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Vge_e*N0+N0_Vge_e*N0_Vge_e+N0_Vge_e*N0_Vge_e+N0*N0_Vge_e_Vge_e)-(+Nl_Vge_e_Vge_e*Nl+Nl_Vge_e*Nl_Vge_e+Nl_Vge_e*Nl_Vge_e+Nl*Nl_Vge_e_Vge_e)));
  T5_Vge_e_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Vdi_si*N0+N0_Vge_e*N0_Vdi_si+N0_Vdi_si*N0_Vge_e+N0*N0_Vge_e_Vdi_si)-(+Nl_Vge_e_Vdi_si*Nl+Nl_Vge_e*Nl_Vdi_si+Nl_Vdi_si*Nl_Vge_e+Nl*Nl_Vge_e_Vdi_si)));
  T5_Vge_e_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Ve_si*N0+N0_Vge_e*N0_Ve_si+N0_Ve_si*N0_Vge_e+N0*N0_Vge_e_Ve_si)-(+Nl_Vge_e_Ve_si*Nl+Nl_Vge_e*Nl_Ve_si+Nl_Ve_si*Nl_Vge_e+Nl*Nl_Vge_e_Ve_si)));
  T5_Vge_e_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Ve_di*N0+N0_Vge_e*N0_Ve_di+N0_Ve_di*N0_Vge_e+N0*N0_Vge_e_Ve_di)-(+Nl_Vge_e_Ve_di*Nl+Nl_Vge_e*Nl_Ve_di+Nl_Ve_di*Nl_Vge_e+Nl*Nl_Vge_e_Ve_di)));
  T5_Vge_e_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Vge_si*N0+N0_Vge_e*N0_Vge_si+N0_Vge_si*N0_Vge_e+N0*N0_Vge_e_Vge_si)-(+Nl_Vge_e_Vge_si*Nl+Nl_Vge_e*Nl_Vge_si+Nl_Vge_si*Nl_Vge_e+Nl*Nl_Vge_e_Vge_si)));
  T5_Vge_e_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vge_e*N0)+(N0*N0_Vge_e))-((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e)))+(0.5*pModel->NOIC)*(+(+N0_Vge_e_Tempt_GND*N0+N0_Vge_e*N0_Tempt_GND+N0_Tempt_GND*N0_Vge_e+N0*N0_Vge_e_Tempt_GND)-(+Nl_Vge_e_Tempt_GND*Nl+Nl_Vge_e*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vge_e+Nl*Nl_Vge_e_Tempt_GND)));
#endif
T5_Vdi_si=((0.5*pModel->NOIC)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_si*0.0+0.0*N0_Vdi_si+N0*0.0)-(+0.0*Nl+Nl_Vdi_si*0.0+0.0*Nl_Vdi_si+Nl*0.0)));
  T5_Vdi_si_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_si*0.0+0.0*N0_Vdi_si+N0*0.0)-(+0.0*Nl+Nl_Vdi_si*0.0+0.0*Nl_Vdi_si+Nl*0.0)));
  T5_Vdi_si_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vdi_si*0.0+0.0*N0_Vdi_si+N0*0.0)-(+0.0*Nl+Nl_Vdi_si*0.0+0.0*Nl_Vdi_si+Nl*0.0)));
  T5_Vdi_si_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Vge_e*N0+N0_Vdi_si*N0_Vge_e+N0_Vge_e*N0_Vdi_si+N0*N0_Vdi_si_Vge_e)-(+Nl_Vdi_si_Vge_e*Nl+Nl_Vdi_si*Nl_Vge_e+Nl_Vge_e*Nl_Vdi_si+Nl*Nl_Vdi_si_Vge_e)));
  T5_Vdi_si_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Vdi_si*N0+N0_Vdi_si*N0_Vdi_si+N0_Vdi_si*N0_Vdi_si+N0*N0_Vdi_si_Vdi_si)-(+Nl_Vdi_si_Vdi_si*Nl+Nl_Vdi_si*Nl_Vdi_si+Nl_Vdi_si*Nl_Vdi_si+Nl*Nl_Vdi_si_Vdi_si)));
  T5_Vdi_si_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Ve_si*N0+N0_Vdi_si*N0_Ve_si+N0_Ve_si*N0_Vdi_si+N0*N0_Vdi_si_Ve_si)-(+Nl_Vdi_si_Ve_si*Nl+Nl_Vdi_si*Nl_Ve_si+Nl_Ve_si*Nl_Vdi_si+Nl*Nl_Vdi_si_Ve_si)));
  T5_Vdi_si_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Ve_di*N0+N0_Vdi_si*N0_Ve_di+N0_Ve_di*N0_Vdi_si+N0*N0_Vdi_si_Ve_di)-(+Nl_Vdi_si_Ve_di*Nl+Nl_Vdi_si*Nl_Ve_di+Nl_Ve_di*Nl_Vdi_si+Nl*Nl_Vdi_si_Ve_di)));
  T5_Vdi_si_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Vge_si*N0+N0_Vdi_si*N0_Vge_si+N0_Vge_si*N0_Vdi_si+N0*N0_Vdi_si_Vge_si)-(+Nl_Vdi_si_Vge_si*Nl+Nl_Vdi_si*Nl_Vge_si+Nl_Vge_si*Nl_Vdi_si+Nl*Nl_Vdi_si_Vge_si)));
  T5_Vdi_si_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vdi_si*N0)+(N0*N0_Vdi_si))-((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si)))+(0.5*pModel->NOIC)*(+(+N0_Vdi_si_Tempt_GND*N0+N0_Vdi_si*N0_Tempt_GND+N0_Tempt_GND*N0_Vdi_si+N0*N0_Vdi_si_Tempt_GND)-(+Nl_Vdi_si_Tempt_GND*Nl+Nl_Vdi_si*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vdi_si+Nl*Nl_Vdi_si_Tempt_GND)));
#endif
T5_Ve_si=((0.5*pModel->NOIC)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_si*0.0+0.0*N0_Ve_si+N0*0.0)-(+0.0*Nl+Nl_Ve_si*0.0+0.0*Nl_Ve_si+Nl*0.0)));
  T5_Ve_si_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_si*0.0+0.0*N0_Ve_si+N0*0.0)-(+0.0*Nl+Nl_Ve_si*0.0+0.0*Nl_Ve_si+Nl*0.0)));
  T5_Ve_si_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_si*0.0+0.0*N0_Ve_si+N0*0.0)-(+0.0*Nl+Nl_Ve_si*0.0+0.0*Nl_Ve_si+Nl*0.0)));
  T5_Ve_si_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Vge_e*N0+N0_Ve_si*N0_Vge_e+N0_Vge_e*N0_Ve_si+N0*N0_Ve_si_Vge_e)-(+Nl_Ve_si_Vge_e*Nl+Nl_Ve_si*Nl_Vge_e+Nl_Vge_e*Nl_Ve_si+Nl*Nl_Ve_si_Vge_e)));
  T5_Ve_si_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Vdi_si*N0+N0_Ve_si*N0_Vdi_si+N0_Vdi_si*N0_Ve_si+N0*N0_Ve_si_Vdi_si)-(+Nl_Ve_si_Vdi_si*Nl+Nl_Ve_si*Nl_Vdi_si+Nl_Vdi_si*Nl_Ve_si+Nl*Nl_Ve_si_Vdi_si)));
  T5_Ve_si_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Ve_si*N0+N0_Ve_si*N0_Ve_si+N0_Ve_si*N0_Ve_si+N0*N0_Ve_si_Ve_si)-(+Nl_Ve_si_Ve_si*Nl+Nl_Ve_si*Nl_Ve_si+Nl_Ve_si*Nl_Ve_si+Nl*Nl_Ve_si_Ve_si)));
  T5_Ve_si_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Ve_di*N0+N0_Ve_si*N0_Ve_di+N0_Ve_di*N0_Ve_si+N0*N0_Ve_si_Ve_di)-(+Nl_Ve_si_Ve_di*Nl+Nl_Ve_si*Nl_Ve_di+Nl_Ve_di*Nl_Ve_si+Nl*Nl_Ve_si_Ve_di)));
  T5_Ve_si_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Vge_si*N0+N0_Ve_si*N0_Vge_si+N0_Vge_si*N0_Ve_si+N0*N0_Ve_si_Vge_si)-(+Nl_Ve_si_Vge_si*Nl+Nl_Ve_si*Nl_Vge_si+Nl_Vge_si*Nl_Ve_si+Nl*Nl_Ve_si_Vge_si)));
  T5_Ve_si_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Ve_si*N0)+(N0*N0_Ve_si))-((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si)))+(0.5*pModel->NOIC)*(+(+N0_Ve_si_Tempt_GND*N0+N0_Ve_si*N0_Tempt_GND+N0_Tempt_GND*N0_Ve_si+N0*N0_Ve_si_Tempt_GND)-(+Nl_Ve_si_Tempt_GND*Nl+Nl_Ve_si*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Ve_si+Nl*Nl_Ve_si_Tempt_GND)));
#endif
T5_Ve_di=((0.5*pModel->NOIC)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_di*0.0+0.0*N0_Ve_di+N0*0.0)-(+0.0*Nl+Nl_Ve_di*0.0+0.0*Nl_Ve_di+Nl*0.0)));
  T5_Ve_di_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_di*0.0+0.0*N0_Ve_di+N0*0.0)-(+0.0*Nl+Nl_Ve_di*0.0+0.0*Nl_Ve_di+Nl*0.0)));
  T5_Ve_di_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Ve_di*0.0+0.0*N0_Ve_di+N0*0.0)-(+0.0*Nl+Nl_Ve_di*0.0+0.0*Nl_Ve_di+Nl*0.0)));
  T5_Ve_di_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Vge_e*N0+N0_Ve_di*N0_Vge_e+N0_Vge_e*N0_Ve_di+N0*N0_Ve_di_Vge_e)-(+Nl_Ve_di_Vge_e*Nl+Nl_Ve_di*Nl_Vge_e+Nl_Vge_e*Nl_Ve_di+Nl*Nl_Ve_di_Vge_e)));
  T5_Ve_di_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Vdi_si*N0+N0_Ve_di*N0_Vdi_si+N0_Vdi_si*N0_Ve_di+N0*N0_Ve_di_Vdi_si)-(+Nl_Ve_di_Vdi_si*Nl+Nl_Ve_di*Nl_Vdi_si+Nl_Vdi_si*Nl_Ve_di+Nl*Nl_Ve_di_Vdi_si)));
  T5_Ve_di_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Ve_si*N0+N0_Ve_di*N0_Ve_si+N0_Ve_si*N0_Ve_di+N0*N0_Ve_di_Ve_si)-(+Nl_Ve_di_Ve_si*Nl+Nl_Ve_di*Nl_Ve_si+Nl_Ve_si*Nl_Ve_di+Nl*Nl_Ve_di_Ve_si)));
  T5_Ve_di_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Ve_di*N0+N0_Ve_di*N0_Ve_di+N0_Ve_di*N0_Ve_di+N0*N0_Ve_di_Ve_di)-(+Nl_Ve_di_Ve_di*Nl+Nl_Ve_di*Nl_Ve_di+Nl_Ve_di*Nl_Ve_di+Nl*Nl_Ve_di_Ve_di)));
  T5_Ve_di_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Vge_si*N0+N0_Ve_di*N0_Vge_si+N0_Vge_si*N0_Ve_di+N0*N0_Ve_di_Vge_si)-(+Nl_Ve_di_Vge_si*Nl+Nl_Ve_di*Nl_Vge_si+Nl_Vge_si*Nl_Ve_di+Nl*Nl_Ve_di_Vge_si)));
  T5_Ve_di_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Ve_di*N0)+(N0*N0_Ve_di))-((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di)))+(0.5*pModel->NOIC)*(+(+N0_Ve_di_Tempt_GND*N0+N0_Ve_di*N0_Tempt_GND+N0_Tempt_GND*N0_Ve_di+N0*N0_Ve_di_Tempt_GND)-(+Nl_Ve_di_Tempt_GND*Nl+Nl_Ve_di*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Ve_di+Nl*Nl_Ve_di_Tempt_GND)));
#endif
T5_Vge_si=((0.5*pModel->NOIC)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_si*0.0+0.0*N0_Vge_si+N0*0.0)-(+0.0*Nl+Nl_Vge_si*0.0+0.0*Nl_Vge_si+Nl*0.0)));
  T5_Vge_si_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_si*0.0+0.0*N0_Vge_si+N0*0.0)-(+0.0*Nl+Nl_Vge_si*0.0+0.0*Nl_Vge_si+Nl*0.0)));
  T5_Vge_si_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Vge_si*0.0+0.0*N0_Vge_si+N0*0.0)-(+0.0*Nl+Nl_Vge_si*0.0+0.0*Nl_Vge_si+Nl*0.0)));
  T5_Vge_si_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Vge_e*N0+N0_Vge_si*N0_Vge_e+N0_Vge_e*N0_Vge_si+N0*N0_Vge_si_Vge_e)-(+Nl_Vge_si_Vge_e*Nl+Nl_Vge_si*Nl_Vge_e+Nl_Vge_e*Nl_Vge_si+Nl*Nl_Vge_si_Vge_e)));
  T5_Vge_si_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Vdi_si*N0+N0_Vge_si*N0_Vdi_si+N0_Vdi_si*N0_Vge_si+N0*N0_Vge_si_Vdi_si)-(+Nl_Vge_si_Vdi_si*Nl+Nl_Vge_si*Nl_Vdi_si+Nl_Vdi_si*Nl_Vge_si+Nl*Nl_Vge_si_Vdi_si)));
  T5_Vge_si_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Ve_si*N0+N0_Vge_si*N0_Ve_si+N0_Ve_si*N0_Vge_si+N0*N0_Vge_si_Ve_si)-(+Nl_Vge_si_Ve_si*Nl+Nl_Vge_si*Nl_Ve_si+Nl_Ve_si*Nl_Vge_si+Nl*Nl_Vge_si_Ve_si)));
  T5_Vge_si_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Ve_di*N0+N0_Vge_si*N0_Ve_di+N0_Ve_di*N0_Vge_si+N0*N0_Vge_si_Ve_di)-(+Nl_Vge_si_Ve_di*Nl+Nl_Vge_si*Nl_Ve_di+Nl_Ve_di*Nl_Vge_si+Nl*Nl_Vge_si_Ve_di)));
  T5_Vge_si_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Vge_si*N0+N0_Vge_si*N0_Vge_si+N0_Vge_si*N0_Vge_si+N0*N0_Vge_si_Vge_si)-(+Nl_Vge_si_Vge_si*Nl+Nl_Vge_si*Nl_Vge_si+Nl_Vge_si*Nl_Vge_si+Nl*Nl_Vge_si_Vge_si)));
  T5_Vge_si_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Vge_si*N0)+(N0*N0_Vge_si))-((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si)))+(0.5*pModel->NOIC)*(+(+N0_Vge_si_Tempt_GND*N0+N0_Vge_si*N0_Tempt_GND+N0_Tempt_GND*N0_Vge_si+N0*N0_Vge_si_Tempt_GND)-(+Nl_Vge_si_Tempt_GND*Nl+Nl_Vge_si*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Vge_si+Nl*Nl_Vge_si_Tempt_GND)));
#endif
T5_Tempt_GND=((0.5*pModel->NOIC)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Tempt_GND*0.0+0.0*N0_Tempt_GND+N0*0.0)-(+0.0*Nl+Nl_Tempt_GND*0.0+0.0*Nl_Tempt_GND+Nl*0.0)));
  T5_Tempt_GND_Vdi_d=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Tempt_GND*0.0+0.0*N0_Tempt_GND+N0*0.0)-(+0.0*Nl+Nl_Tempt_GND*0.0+0.0*Nl_Tempt_GND+Nl*0.0)));
  T5_Tempt_GND_Vsi_s=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((0.0)-(0.0))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+0.0*N0+N0_Tempt_GND*0.0+0.0*N0_Tempt_GND+N0*0.0)-(+0.0*Nl+Nl_Tempt_GND*0.0+0.0*Nl_Tempt_GND+Nl*0.0)));
  T5_Tempt_GND_Vge_e=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_e*N0)+(N0*N0_Vge_e)))-(((Nl_Vge_e*Nl)+(Nl*Nl_Vge_e))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Vge_e*N0+N0_Tempt_GND*N0_Vge_e+N0_Vge_e*N0_Tempt_GND+N0*N0_Tempt_GND_Vge_e)-(+Nl_Tempt_GND_Vge_e*Nl+Nl_Tempt_GND*Nl_Vge_e+Nl_Vge_e*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Vge_e)));
  T5_Tempt_GND_Vdi_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vdi_si*N0)+(N0*N0_Vdi_si)))-(((Nl_Vdi_si*Nl)+(Nl*Nl_Vdi_si))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Vdi_si*N0+N0_Tempt_GND*N0_Vdi_si+N0_Vdi_si*N0_Tempt_GND+N0*N0_Tempt_GND_Vdi_si)-(+Nl_Tempt_GND_Vdi_si*Nl+Nl_Tempt_GND*Nl_Vdi_si+Nl_Vdi_si*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Vdi_si)));
  T5_Tempt_GND_Ve_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_si*N0)+(N0*N0_Ve_si)))-(((Nl_Ve_si*Nl)+(Nl*Nl_Ve_si))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Ve_si*N0+N0_Tempt_GND*N0_Ve_si+N0_Ve_si*N0_Tempt_GND+N0*N0_Tempt_GND_Ve_si)-(+Nl_Tempt_GND_Ve_si*Nl+Nl_Tempt_GND*Nl_Ve_si+Nl_Ve_si*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Ve_si)));
  T5_Tempt_GND_Ve_di=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Ve_di*N0)+(N0*N0_Ve_di)))-(((Nl_Ve_di*Nl)+(Nl*Nl_Ve_di))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Ve_di*N0+N0_Tempt_GND*N0_Ve_di+N0_Ve_di*N0_Tempt_GND+N0*N0_Tempt_GND_Ve_di)-(+Nl_Tempt_GND_Ve_di*Nl+Nl_Tempt_GND*Nl_Ve_di+Nl_Ve_di*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Ve_di)));
  T5_Tempt_GND_Vge_si=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Vge_si*N0)+(N0*N0_Vge_si)))-(((Nl_Vge_si*Nl)+(Nl*Nl_Vge_si))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Vge_si*N0+N0_Tempt_GND*N0_Vge_si+N0_Vge_si*N0_Tempt_GND+N0*N0_Tempt_GND_Vge_si)-(+Nl_Tempt_GND_Vge_si*Nl+Nl_Tempt_GND*Nl_Vge_si+Nl_Vge_si*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Vge_si)));
  T5_Tempt_GND_Tempt_GND=(+(+0.0*pModel->NOIC+0.0*0.0+0.0*0.0+0.5*0.0)*((N0*N0)-(Nl*Nl))+0.0*((((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND)))-(((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND))))+(0.0)*(((N0_Tempt_GND*N0)+(N0*N0_Tempt_GND))-((Nl_Tempt_GND*Nl)+(Nl*Nl_Tempt_GND)))+(0.5*pModel->NOIC)*(+(+N0_Tempt_GND_Tempt_GND*N0+N0_Tempt_GND*N0_Tempt_GND+N0_Tempt_GND*N0_Tempt_GND+N0*N0_Tempt_GND_Tempt_GND)-(+Nl_Tempt_GND_Tempt_GND*Nl+Nl_Tempt_GND*Nl_Tempt_GND+Nl_Tempt_GND*Nl_Tempt_GND+Nl*Nl_Tempt_GND_Tempt_GND)));
#endif
#endif
T5=((0.5*pModel->NOIC)*((N0*N0)-(Nl*Nl)));
EXIT_IF_ISNAN(((0.5*pModel->NOIC)*((N0*N0)-(Nl*Nl))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=((((1.60219e-19*Vtm)*ids_Vge_di)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Vge_di));
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Vge_di);
  T6_Vge_di_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*0.0+((0.0)*ids)*ids_Vge_di+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_di_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*0.0+((0.0)*ids)*ids_Vge_di+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_di_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Vge_e);
  T6_Vge_di_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Vdi_si);
  T6_Vge_di_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Tempt_GND);
  T6_Vge_di_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Ve_si);
  T6_Vge_di_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Ve_di);
  T6_Vge_di_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Vge_di+(1.60219e-19*Vtm)*ids_Vge_di_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Vge_di)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Vge_di+((1.60219e-19*Vtm)*ids)*ids_Vge_di_Vge_si);
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=((((1.60219e-19*Vtm)*ids_Vge_e)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Vge_e));
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Vge_di);
  T6_Vge_e_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*0.0+((0.0)*ids)*ids_Vge_e+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_e_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*0.0+((0.0)*ids)*ids_Vge_e+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_e_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Vge_e);
  T6_Vge_e_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Vdi_si);
  T6_Vge_e_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Tempt_GND);
  T6_Vge_e_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Ve_si);
  T6_Vge_e_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Ve_di);
  T6_Vge_e_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Vge_e+(1.60219e-19*Vtm)*ids_Vge_e_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Vge_e)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Vge_e+((1.60219e-19*Vtm)*ids)*ids_Vge_e_Vge_si);
#endif
T6_Vdi_si=((((1.60219e-19*Vtm)*ids_Vdi_si)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Vdi_si));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Vge_di);
  T6_Vdi_si_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*0.0+((0.0)*ids)*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vdi_si_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*0.0+((0.0)*ids)*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vdi_si_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Vge_e);
  T6_Vdi_si_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Vdi_si);
  T6_Vdi_si_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Tempt_GND);
  T6_Vdi_si_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Ve_si);
  T6_Vdi_si_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Ve_di);
  T6_Vdi_si_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Vdi_si+(1.60219e-19*Vtm)*ids_Vdi_si_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Vdi_si)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Vdi_si+((1.60219e-19*Vtm)*ids)*ids_Vdi_si_Vge_si);
#endif
T6_Tempt_GND=(((((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids)+(((1.60219e-19*Vtm)*ids)*ids_Tempt_GND));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Vge_di+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Vge_di)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Vge_di);
  T6_Tempt_GND_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*0.0+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*0.0)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*0.0+((0.0)*ids)*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Tempt_GND_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*0.0+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*0.0)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*0.0+((0.0)*ids)*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Tempt_GND_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Vge_e+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Vge_e)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Vge_e);
  T6_Tempt_GND_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Vdi_si+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Vdi_si)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Vdi_si);
  T6_Tempt_GND_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+1.60219e-19*Vtm_Tempt_GND_Tempt_GND)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Tempt_GND)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Tempt_GND);
  T6_Tempt_GND_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Ve_si+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Ve_si)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Ve_si);
  T6_Tempt_GND_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Ve_di+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Ve_di)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Ve_di);
  T6_Tempt_GND_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+1.60219e-19*0.0)*ids+(1.60219e-19*Vtm_Tempt_GND)*ids_Vge_si+(0.0)*ids_Tempt_GND+(1.60219e-19*Vtm)*ids_Tempt_GND_Vge_si)*ids+(((1.60219e-19*Vtm_Tempt_GND)*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND))*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Tempt_GND+((1.60219e-19*Vtm)*ids)*ids_Tempt_GND_Vge_si);
#endif
T6_Ve_si=((((1.60219e-19*Vtm)*ids_Ve_si)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Ve_si));
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Vge_di);
  T6_Ve_si_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*0.0+((0.0)*ids)*ids_Ve_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Ve_si_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*0.0+((0.0)*ids)*ids_Ve_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Ve_si_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Vge_e);
  T6_Ve_si_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Vdi_si);
  T6_Ve_si_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Tempt_GND);
  T6_Ve_si_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Ve_si);
  T6_Ve_si_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Ve_di);
  T6_Ve_si_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Ve_si+(1.60219e-19*Vtm)*ids_Ve_si_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Ve_si)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Ve_si+((1.60219e-19*Vtm)*ids)*ids_Ve_si_Vge_si);
#endif
T6_Ve_di=((((1.60219e-19*Vtm)*ids_Ve_di)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Ve_di));
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Vge_di);
  T6_Ve_di_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*0.0+((0.0)*ids)*ids_Ve_di+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Ve_di_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*0.0+((0.0)*ids)*ids_Ve_di+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Ve_di_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Vge_e);
  T6_Ve_di_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Vdi_si);
  T6_Ve_di_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Tempt_GND);
  T6_Ve_di_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Ve_si);
  T6_Ve_di_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Ve_di);
  T6_Ve_di_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Ve_di+(1.60219e-19*Vtm)*ids_Ve_di_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Ve_di)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Ve_di+((1.60219e-19*Vtm)*ids)*ids_Ve_di_Vge_si);
#endif
T6_Vge_si=((((1.60219e-19*Vtm)*ids_Vge_si)*ids)+(((1.60219e-19*Vtm)*ids)*ids_Vge_si));
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_di+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Vge_di)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Vge_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_di)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Vge_di);
  T6_Vge_si_Vdi_d=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*0.0+((0.0)*ids)*ids_Vge_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_si_Vsi_s=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*0.0+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*0.0)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*0.0+((0.0)*ids)*ids_Vge_si+((1.60219e-19*Vtm)*ids)*0.0);
  T6_Vge_si_Vge_e=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_e+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Vge_e)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Vge_e+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_e)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Vge_e);
  T6_Vge_si_Vdi_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vdi_si+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Vdi_si)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Vdi_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vdi_si)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Vdi_si);
  T6_Vge_si_Tempt_GND=(+(+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Tempt_GND+((1.60219e-19*Vtm_Tempt_GND))*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Tempt_GND)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Tempt_GND+(((((1.60219e-19*Vtm_Tempt_GND))*ids)+((1.60219e-19*Vtm)*ids_Tempt_GND)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Tempt_GND);
  T6_Vge_si_Ve_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_si+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Ve_si)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Ve_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_si)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Ve_si);
  T6_Vge_si_Ve_di=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Ve_di+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Ve_di)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Ve_di+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Ve_di)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Ve_di);
  T6_Vge_si_Vge_si=(+(+(+0.0*Vtm+0.0*0.0+0.0*0.0+1.60219e-19*0.0)*ids+0.0*ids_Vge_si+(0.0)*ids_Vge_si+(1.60219e-19*Vtm)*ids_Vge_si_Vge_si)*ids+((1.60219e-19*Vtm)*ids_Vge_si)*ids_Vge_si+((((0.0)*ids)+((1.60219e-19*Vtm)*ids_Vge_si)))*ids_Vge_si+((1.60219e-19*Vtm)*ids)*ids_Vge_si_Vge_si);
#endif
#endif
T6=(((1.60219e-19*Vtm)*ids)*ids);
EXIT_IF_ISNAN((((1.60219e-19*Vtm)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=0.0;
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=0.0;
  T7_Vge_di_Vdi_d=0.0;
  T7_Vge_di_Vsi_s=0.0;
  T7_Vge_di_Vge_e=0.0;
  T7_Vge_di_Vdi_si=0.0;
  T7_Vge_di_Ve_si=0.0;
  T7_Vge_di_Ve_di=0.0;
  T7_Vge_di_Vge_si=0.0;
  T7_Vge_di_Tempt_GND=0.0;
#endif
T7_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=0.0;
  T7_Vdi_d_Vdi_d=0.0;
  T7_Vdi_d_Vsi_s=0.0;
  T7_Vdi_d_Vge_e=0.0;
  T7_Vdi_d_Vdi_si=0.0;
  T7_Vdi_d_Ve_si=0.0;
  T7_Vdi_d_Ve_di=0.0;
  T7_Vdi_d_Vge_si=0.0;
  T7_Vdi_d_Tempt_GND=0.0;
#endif
T7_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=0.0;
  T7_Vsi_s_Vdi_d=0.0;
  T7_Vsi_s_Vsi_s=0.0;
  T7_Vsi_s_Vge_e=0.0;
  T7_Vsi_s_Vdi_si=0.0;
  T7_Vsi_s_Ve_si=0.0;
  T7_Vsi_s_Ve_di=0.0;
  T7_Vsi_s_Vge_si=0.0;
  T7_Vsi_s_Tempt_GND=0.0;
#endif
T7_Vge_e=0.0;
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=0.0;
  T7_Vge_e_Vdi_d=0.0;
  T7_Vge_e_Vsi_s=0.0;
  T7_Vge_e_Vge_e=0.0;
  T7_Vge_e_Vdi_si=0.0;
  T7_Vge_e_Ve_si=0.0;
  T7_Vge_e_Ve_di=0.0;
  T7_Vge_e_Vge_si=0.0;
  T7_Vge_e_Tempt_GND=0.0;
#endif
T7_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=0.0;
  T7_Vdi_si_Vdi_d=0.0;
  T7_Vdi_si_Vsi_s=0.0;
  T7_Vdi_si_Vge_e=0.0;
  T7_Vdi_si_Vdi_si=0.0;
  T7_Vdi_si_Ve_si=0.0;
  T7_Vdi_si_Ve_di=0.0;
  T7_Vdi_si_Vge_si=0.0;
  T7_Vdi_si_Tempt_GND=0.0;
#endif
T7_Ve_si=0.0;
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=0.0;
  T7_Ve_si_Vdi_d=0.0;
  T7_Ve_si_Vsi_s=0.0;
  T7_Ve_si_Vge_e=0.0;
  T7_Ve_si_Vdi_si=0.0;
  T7_Ve_si_Ve_si=0.0;
  T7_Ve_si_Ve_di=0.0;
  T7_Ve_si_Vge_si=0.0;
  T7_Ve_si_Tempt_GND=0.0;
#endif
T7_Ve_di=0.0;
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=0.0;
  T7_Ve_di_Vdi_d=0.0;
  T7_Ve_di_Vsi_s=0.0;
  T7_Ve_di_Vge_e=0.0;
  T7_Ve_di_Vdi_si=0.0;
  T7_Ve_di_Ve_si=0.0;
  T7_Ve_di_Ve_di=0.0;
  T7_Ve_di_Vge_si=0.0;
  T7_Ve_di_Tempt_GND=0.0;
#endif
T7_Vge_si=0.0;
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=0.0;
  T7_Vge_si_Vdi_d=0.0;
  T7_Vge_si_Vsi_s=0.0;
  T7_Vge_si_Vge_e=0.0;
  T7_Vge_si_Vdi_si=0.0;
  T7_Vge_si_Ve_si=0.0;
  T7_Vge_si_Ve_di=0.0;
  T7_Vge_si_Vge_si=0.0;
  T7_Vge_si_Tempt_GND=0.0;
#endif
T7_Tempt_GND=0.0;
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=0.0;
  T7_Tempt_GND_Vdi_d=0.0;
  T7_Tempt_GND_Vsi_s=0.0;
  T7_Tempt_GND_Vge_e=0.0;
  T7_Tempt_GND_Vdi_si=0.0;
  T7_Tempt_GND_Ve_si=0.0;
  T7_Tempt_GND_Ve_di=0.0;
  T7_Tempt_GND_Vge_si=0.0;
  T7_Tempt_GND_Tempt_GND=0.0;
#endif
#endif
T7=(((1.0e10*Leffnoisq)*Weff0)*NFINtotal);
EXIT_IF_ISNAN((((1.0e10*Leffnoisq)*Weff0)*NFINtotal))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=((pModel->NOIB*Nl_Vge_e)+(((pModel->NOIC*Nl_Vge_e)*Nl)+((pModel->NOIC*Nl)*Nl_Vge_e)));
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Vge_e)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Vge_e));
  T8_Vge_e_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Vdi_si)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Vdi_si));
  T8_Vge_e_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Ve_si)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Ve_si));
  T8_Vge_e_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Ve_di)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Ve_di));
  T8_Vge_e_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Vge_si)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Vge_si));
  T8_Vge_e_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vge_e+pModel->NOIB*Nl_Vge_e_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vge_e+pModel->NOIC*Nl_Vge_e_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vge_e)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vge_e+(pModel->NOIC*Nl)*Nl_Vge_e_Tempt_GND));
#endif
T8_Vdi_si=((pModel->NOIB*Nl_Vdi_si)+(((pModel->NOIC*Nl_Vdi_si)*Nl)+((pModel->NOIC*Nl)*Nl_Vdi_si)));
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Vge_e)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Vge_e));
  T8_Vdi_si_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Vdi_si)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Vdi_si));
  T8_Vdi_si_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Ve_si)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Ve_si));
  T8_Vdi_si_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Ve_di)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Ve_di));
  T8_Vdi_si_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Vge_si)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Vge_si));
  T8_Vdi_si_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vdi_si+pModel->NOIB*Nl_Vdi_si_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vdi_si+pModel->NOIC*Nl_Vdi_si_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vdi_si)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vdi_si+(pModel->NOIC*Nl)*Nl_Vdi_si_Tempt_GND));
#endif
T8_Ve_si=((pModel->NOIB*Nl_Ve_si)+(((pModel->NOIC*Nl_Ve_si)*Nl)+((pModel->NOIC*Nl)*Nl_Ve_si)));
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Vge_e)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Vge_e));
  T8_Ve_si_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Vdi_si)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Vdi_si));
  T8_Ve_si_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Ve_si)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Ve_si));
  T8_Ve_si_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Ve_di)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Ve_di));
  T8_Ve_si_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Vge_si)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Vge_si));
  T8_Ve_si_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Ve_si+pModel->NOIB*Nl_Ve_si_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Ve_si+pModel->NOIC*Nl_Ve_si_Tempt_GND)*Nl+(pModel->NOIC*Nl_Ve_si)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Ve_si+(pModel->NOIC*Nl)*Nl_Ve_si_Tempt_GND));
#endif
T8_Ve_di=((pModel->NOIB*Nl_Ve_di)+(((pModel->NOIC*Nl_Ve_di)*Nl)+((pModel->NOIC*Nl)*Nl_Ve_di)));
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Vge_e)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Vge_e));
  T8_Ve_di_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Vdi_si)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Vdi_si));
  T8_Ve_di_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Ve_si)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Ve_si));
  T8_Ve_di_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Ve_di)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Ve_di));
  T8_Ve_di_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Vge_si)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Vge_si));
  T8_Ve_di_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Ve_di+pModel->NOIB*Nl_Ve_di_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Ve_di+pModel->NOIC*Nl_Ve_di_Tempt_GND)*Nl+(pModel->NOIC*Nl_Ve_di)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Ve_di+(pModel->NOIC*Nl)*Nl_Ve_di_Tempt_GND));
#endif
T8_Vge_si=((pModel->NOIB*Nl_Vge_si)+(((pModel->NOIC*Nl_Vge_si)*Nl)+((pModel->NOIC*Nl)*Nl_Vge_si)));
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Vge_e)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Vge_e));
  T8_Vge_si_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Vdi_si)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Vdi_si));
  T8_Vge_si_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Ve_si)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Ve_si));
  T8_Vge_si_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Ve_di)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Ve_di));
  T8_Vge_si_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Vge_si)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Vge_si));
  T8_Vge_si_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vge_si+pModel->NOIB*Nl_Vge_si_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Vge_si+pModel->NOIC*Nl_Vge_si_Tempt_GND)*Nl+(pModel->NOIC*Nl_Vge_si)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Vge_si+(pModel->NOIC*Nl)*Nl_Vge_si_Tempt_GND));
#endif
T8_Tempt_GND=((pModel->NOIB*Nl_Tempt_GND)+(((pModel->NOIC*Nl_Tempt_GND)*Nl)+((pModel->NOIC*Nl)*Nl_Tempt_GND)));
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Vge_e))+(+(+0.0*Nl+0.0*Nl_Vge_e+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Vge_e)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Vge_e+((pModel->NOIC*Nl_Vge_e))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Vge_e));
  T8_Tempt_GND_Vdi_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Vdi_si))+(+(+0.0*Nl+0.0*Nl_Vdi_si+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Vdi_si)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Vdi_si+((pModel->NOIC*Nl_Vdi_si))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Vdi_si));
  T8_Tempt_GND_Ve_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Ve_si))+(+(+0.0*Nl+0.0*Nl_Ve_si+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Ve_si)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Ve_si+((pModel->NOIC*Nl_Ve_si))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Ve_si));
  T8_Tempt_GND_Ve_di=(+(+0.0+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Ve_di))+(+(+0.0*Nl+0.0*Nl_Ve_di+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Ve_di)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Ve_di+((pModel->NOIC*Nl_Ve_di))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Ve_di));
  T8_Tempt_GND_Vge_si=(+(+0.0+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Vge_si))+(+(+0.0*Nl+0.0*Nl_Vge_si+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Vge_si)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Vge_si+((pModel->NOIC*Nl_Vge_si))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Vge_si));
  T8_Tempt_GND_Tempt_GND=(+(+0.0+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Tempt_GND+pModel->NOIB*Nl_Tempt_GND_Tempt_GND))+(+(+0.0*Nl+0.0*Nl_Tempt_GND+0.0*Nl_Tempt_GND+pModel->NOIC*Nl_Tempt_GND_Tempt_GND)*Nl+(pModel->NOIC*Nl_Tempt_GND)*Nl_Tempt_GND+((pModel->NOIC*Nl_Tempt_GND))*Nl_Tempt_GND+(pModel->NOIC*Nl)*Nl_Tempt_GND_Tempt_GND));
#endif
#endif
T8=((pModel->NOIA+(pModel->NOIB*Nl))+((pModel->NOIC*Nl)*Nl));
EXIT_IF_ISNAN(((pModel->NOIA+(pModel->NOIB*Nl))+((pModel->NOIC*Nl)*Nl)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T9_Vge_di=0.0;
#if defined(_DERIVATE2)
  T9_Vge_di_Vge_di=0.0;
  T9_Vge_di_Vdi_d=0.0;
  T9_Vge_di_Vsi_s=0.0;
  T9_Vge_di_Vge_e=0.0;
  T9_Vge_di_Ve_si=0.0;
  T9_Vge_di_Ve_di=0.0;
  T9_Vge_di_Vge_si=0.0;
  T9_Vge_di_Tempt_GND=0.0;
  T9_Vge_di_Vdi_si=0.0;
#endif
T9_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T9_Vdi_d_Vge_di=0.0;
  T9_Vdi_d_Vdi_d=0.0;
  T9_Vdi_d_Vsi_s=0.0;
  T9_Vdi_d_Vge_e=0.0;
  T9_Vdi_d_Ve_si=0.0;
  T9_Vdi_d_Ve_di=0.0;
  T9_Vdi_d_Vge_si=0.0;
  T9_Vdi_d_Tempt_GND=0.0;
  T9_Vdi_d_Vdi_si=0.0;
#endif
T9_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T9_Vsi_s_Vge_di=0.0;
  T9_Vsi_s_Vdi_d=0.0;
  T9_Vsi_s_Vsi_s=0.0;
  T9_Vsi_s_Vge_e=0.0;
  T9_Vsi_s_Ve_si=0.0;
  T9_Vsi_s_Ve_di=0.0;
  T9_Vsi_s_Vge_si=0.0;
  T9_Vsi_s_Tempt_GND=0.0;
  T9_Vsi_s_Vdi_si=0.0;
#endif
T9_Vge_e=(((Nl_Vge_e+Nstar_Vge_e)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Vge_e+Nstar_Vge_e)));
#if defined(_DERIVATE2)
  T9_Vge_e_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_e_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_e_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*0.0+0.0*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_e_Vge_e=(+(+Nl_Vge_e_Vge_e+Nstar_Vge_e_Vge_e)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Vge_e+Nstar_Vge_e_Vge_e));
  T9_Vge_e_Ve_si=(+(+Nl_Vge_e_Ve_si+Nstar_Vge_e_Ve_si)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Ve_si+Nstar_Vge_e_Ve_si));
  T9_Vge_e_Ve_di=(+(+Nl_Vge_e_Ve_di+Nstar_Vge_e_Ve_di)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Ve_di+Nstar_Vge_e_Ve_di));
  T9_Vge_e_Vge_si=(+(+Nl_Vge_e_Vge_si+Nstar_Vge_e_Vge_si)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Vge_si+Nstar_Vge_e_Vge_si));
  T9_Vge_e_Tempt_GND=(+(+Nl_Vge_e_Tempt_GND+Nstar_Vge_e_Tempt_GND)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Tempt_GND+Nstar_Vge_e_Tempt_GND));
  T9_Vge_e_Vdi_si=(+(+Nl_Vge_e_Vdi_si+Nstar_Vge_e_Vdi_si)*(Nl+Nstar)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl+Nstar)*(+Nl_Vge_e_Vdi_si+Nstar_Vge_e_Vdi_si));
#endif
T9_Ve_si=(((Nl_Ve_si+Nstar_Ve_si)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Ve_si+Nstar_Ve_si)));
#if defined(_DERIVATE2)
  T9_Ve_si_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_si_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_si_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*0.0+0.0*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_si_Vge_e=(+(+Nl_Ve_si_Vge_e+Nstar_Ve_si_Vge_e)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Vge_e+Nstar_Ve_si_Vge_e));
  T9_Ve_si_Ve_si=(+(+Nl_Ve_si_Ve_si+Nstar_Ve_si_Ve_si)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Ve_si+Nstar_Ve_si_Ve_si));
  T9_Ve_si_Ve_di=(+(+Nl_Ve_si_Ve_di+Nstar_Ve_si_Ve_di)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Ve_di+Nstar_Ve_si_Ve_di));
  T9_Ve_si_Vge_si=(+(+Nl_Ve_si_Vge_si+Nstar_Ve_si_Vge_si)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Vge_si+Nstar_Ve_si_Vge_si));
  T9_Ve_si_Tempt_GND=(+(+Nl_Ve_si_Tempt_GND+Nstar_Ve_si_Tempt_GND)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Tempt_GND+Nstar_Ve_si_Tempt_GND));
  T9_Ve_si_Vdi_si=(+(+Nl_Ve_si_Vdi_si+Nstar_Ve_si_Vdi_si)*(Nl+Nstar)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl+Nstar)*(+Nl_Ve_si_Vdi_si+Nstar_Ve_si_Vdi_si));
#endif
T9_Ve_di=(((Nl_Ve_di+Nstar_Ve_di)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Ve_di+Nstar_Ve_di)));
#if defined(_DERIVATE2)
  T9_Ve_di_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_di_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_di_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*0.0+0.0*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+0.0+0.0));
  T9_Ve_di_Vge_e=(+(+Nl_Ve_di_Vge_e+Nstar_Ve_di_Vge_e)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Vge_e+Nstar_Ve_di_Vge_e));
  T9_Ve_di_Ve_si=(+(+Nl_Ve_di_Ve_si+Nstar_Ve_di_Ve_si)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Ve_si+Nstar_Ve_di_Ve_si));
  T9_Ve_di_Ve_di=(+(+Nl_Ve_di_Ve_di+Nstar_Ve_di_Ve_di)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Ve_di+Nstar_Ve_di_Ve_di));
  T9_Ve_di_Vge_si=(+(+Nl_Ve_di_Vge_si+Nstar_Ve_di_Vge_si)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Vge_si+Nstar_Ve_di_Vge_si));
  T9_Ve_di_Tempt_GND=(+(+Nl_Ve_di_Tempt_GND+Nstar_Ve_di_Tempt_GND)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Tempt_GND+Nstar_Ve_di_Tempt_GND));
  T9_Ve_di_Vdi_si=(+(+Nl_Ve_di_Vdi_si+Nstar_Ve_di_Vdi_si)*(Nl+Nstar)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl+Nstar)*(+Nl_Ve_di_Vdi_si+Nstar_Ve_di_Vdi_si));
#endif
T9_Vge_si=(((Nl_Vge_si+Nstar_Vge_si)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Vge_si+Nstar_Vge_si)));
#if defined(_DERIVATE2)
  T9_Vge_si_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_si_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_si_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*0.0+0.0*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vge_si_Vge_e=(+(+Nl_Vge_si_Vge_e+Nstar_Vge_si_Vge_e)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Vge_e+Nstar_Vge_si_Vge_e));
  T9_Vge_si_Ve_si=(+(+Nl_Vge_si_Ve_si+Nstar_Vge_si_Ve_si)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Ve_si+Nstar_Vge_si_Ve_si));
  T9_Vge_si_Ve_di=(+(+Nl_Vge_si_Ve_di+Nstar_Vge_si_Ve_di)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Ve_di+Nstar_Vge_si_Ve_di));
  T9_Vge_si_Vge_si=(+(+Nl_Vge_si_Vge_si+Nstar_Vge_si_Vge_si)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Vge_si+Nstar_Vge_si_Vge_si));
  T9_Vge_si_Tempt_GND=(+(+Nl_Vge_si_Tempt_GND+Nstar_Vge_si_Tempt_GND)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Tempt_GND+Nstar_Vge_si_Tempt_GND));
  T9_Vge_si_Vdi_si=(+(+Nl_Vge_si_Vdi_si+Nstar_Vge_si_Vdi_si)*(Nl+Nstar)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl+Nstar)*(+Nl_Vge_si_Vdi_si+Nstar_Vge_si_Vdi_si));
#endif
T9_Tempt_GND=(((Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Tempt_GND+Nstar_Tempt_GND)));
#if defined(_DERIVATE2)
  T9_Tempt_GND_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+0.0+0.0));
  T9_Tempt_GND_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+0.0+0.0));
  T9_Tempt_GND_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*0.0+0.0*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+0.0+0.0));
  T9_Tempt_GND_Vge_e=(+(+Nl_Tempt_GND_Vge_e+Nstar_Tempt_GND_Vge_e)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Vge_e+Nstar_Tempt_GND_Vge_e));
  T9_Tempt_GND_Ve_si=(+(+Nl_Tempt_GND_Ve_si+Nstar_Tempt_GND_Ve_si)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Ve_si+Nstar_Tempt_GND_Ve_si));
  T9_Tempt_GND_Ve_di=(+(+Nl_Tempt_GND_Ve_di+Nstar_Tempt_GND_Ve_di)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Ve_di+Nstar_Tempt_GND_Ve_di));
  T9_Tempt_GND_Vge_si=(+(+Nl_Tempt_GND_Vge_si+Nstar_Tempt_GND_Vge_si)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Vge_si+Nstar_Tempt_GND_Vge_si));
  T9_Tempt_GND_Tempt_GND=(+(+Nl_Tempt_GND_Tempt_GND+Nstar_Tempt_GND_Tempt_GND)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Tempt_GND+Nstar_Tempt_GND_Tempt_GND));
  T9_Tempt_GND_Vdi_si=(+(+Nl_Tempt_GND_Vdi_si+Nstar_Tempt_GND_Vdi_si)*(Nl+Nstar)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl+Nstar)*(+Nl_Tempt_GND_Vdi_si+Nstar_Tempt_GND_Vdi_si));
#endif
T9_Vdi_si=(((Nl_Vdi_si+Nstar_Vdi_si)*(Nl+Nstar))+((Nl+Nstar)*(Nl_Vdi_si+Nstar_Vdi_si)));
#if defined(_DERIVATE2)
  T9_Vdi_si_Vge_di=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vdi_si_Vdi_d=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vdi_si_Vsi_s=(+(+0.0+0.0)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*0.0+0.0*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+0.0+0.0));
  T9_Vdi_si_Vge_e=(+(+Nl_Vdi_si_Vge_e+Nstar_Vdi_si_Vge_e)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_e+Nstar_Vge_e)+(Nl_Vge_e+Nstar_Vge_e)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Vge_e+Nstar_Vdi_si_Vge_e));
  T9_Vdi_si_Ve_si=(+(+Nl_Vdi_si_Ve_si+Nstar_Vdi_si_Ve_si)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_si+Nstar_Ve_si)+(Nl_Ve_si+Nstar_Ve_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Ve_si+Nstar_Vdi_si_Ve_si));
  T9_Vdi_si_Ve_di=(+(+Nl_Vdi_si_Ve_di+Nstar_Vdi_si_Ve_di)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Ve_di+Nstar_Ve_di)+(Nl_Ve_di+Nstar_Ve_di)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Ve_di+Nstar_Vdi_si_Ve_di));
  T9_Vdi_si_Vge_si=(+(+Nl_Vdi_si_Vge_si+Nstar_Vdi_si_Vge_si)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vge_si+Nstar_Vge_si)+(Nl_Vge_si+Nstar_Vge_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Vge_si+Nstar_Vdi_si_Vge_si));
  T9_Vdi_si_Tempt_GND=(+(+Nl_Vdi_si_Tempt_GND+Nstar_Vdi_si_Tempt_GND)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Tempt_GND+Nstar_Tempt_GND)+(Nl_Tempt_GND+Nstar_Tempt_GND)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Tempt_GND+Nstar_Vdi_si_Tempt_GND));
  T9_Vdi_si_Vdi_si=(+(+Nl_Vdi_si_Vdi_si+Nstar_Vdi_si_Vdi_si)*(Nl+Nstar)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl_Vdi_si+Nstar_Vdi_si)*(Nl_Vdi_si+Nstar_Vdi_si)+(Nl+Nstar)*(+Nl_Vdi_si_Vdi_si+Nstar_Vdi_si_Vdi_si));
#endif
#endif
T9=((Nl+Nstar)*(Nl+Nstar));
EXIT_IF_ISNAN(((Nl+Nstar)*(Nl+Nstar)))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
Ssi_Vge_di=(((((T1_Vge_di*T2-T1*T2_Vge_di)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Vge_di+T4_Vge_di)+T5_Vge_di)))+((((((T6_Vge_di*T7-T6*T7_Vge_di)/T7/T7)*DelClm)+((T6/T7)*DelClm_Vge_di))*T8*T9-(((T6/T7)*DelClm)*T8)*T9_Vge_di)/T9/T9));
Ssi_Vge_e=(((((T1_Vge_e*T2-T1*T2_Vge_e)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Vge_e+T4_Vge_e)+T5_Vge_e)))+((((((((T6_Vge_e*T7-T6*T7_Vge_e)/T7/T7)*DelClm)+((T6/T7)*DelClm_Vge_e))*T8)+(((T6/T7)*DelClm)*T8_Vge_e))*T9-(((T6/T7)*DelClm)*T8)*T9_Vge_e)/T9/T9));
Ssi_Ve_si=(((((T1_Ve_si*T2-T1*T2_Ve_si)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Ve_si+T4_Ve_si)+T5_Ve_si)))+((((((((T6_Ve_si*T7-T6*T7_Ve_si)/T7/T7)*DelClm)+((T6/T7)*DelClm_Ve_si))*T8)+(((T6/T7)*DelClm)*T8_Ve_si))*T9-(((T6/T7)*DelClm)*T8)*T9_Ve_si)/T9/T9));
Ssi_Ve_di=(((((T1_Ve_di*T2-T1*T2_Ve_di)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Ve_di+T4_Ve_di)+T5_Ve_di)))+((((((((T6_Ve_di*T7-T6*T7_Ve_di)/T7/T7)*DelClm)+((T6/T7)*DelClm_Ve_di))*T8)+(((T6/T7)*DelClm)*T8_Ve_di))*T9-(((T6/T7)*DelClm)*T8)*T9_Ve_di)/T9/T9));
Ssi_Vge_si=(((((T1_Vge_si*T2-T1*T2_Vge_si)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Vge_si+T4_Vge_si)+T5_Vge_si)))+((((((((T6_Vge_si*T7-T6*T7_Vge_si)/T7/T7)*DelClm)+((T6/T7)*DelClm_Vge_si))*T8)+(((T6/T7)*DelClm)*T8_Vge_si))*T9-(((T6/T7)*DelClm)*T8)*T9_Vge_si)/T9/T9));
Ssi_Vdi_si=(((((T1_Vdi_si*T2-T1*T2_Vdi_si)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Vdi_si+T4_Vdi_si)+T5_Vdi_si)))+((((((((T6_Vdi_si*T7-T6*T7_Vdi_si)/T7/T7)*DelClm)+((T6/T7)*DelClm_Vdi_si))*T8)+(((T6/T7)*DelClm)*T8_Vdi_si))*T9-(((T6/T7)*DelClm)*T8)*T9_Vdi_si)/T9/T9));
Ssi_Tempt_GND=(((((T1_Tempt_GND*T2-T1*T2_Tempt_GND)/T2/T2)*((T3+T4)+T5))+((T1/T2)*((T3_Tempt_GND+T4_Tempt_GND)+T5_Tempt_GND)))+((((((((T6_Tempt_GND*T7-T6*T7_Tempt_GND)/T7/T7)*DelClm)+((T6/T7)*DelClm_Tempt_GND))*T8)+(((T6/T7)*DelClm)*T8_Tempt_GND))*T9-(((T6/T7)*DelClm)*T8)*T9_Tempt_GND)/T9/T9));
Ssi_Vdi_d=(((((T1_Vdi_d*T2-T1*T2_Vdi_d)/T2/T2)*((T3+T4)+T5))+((T1/T2)*(T3_Vdi_d+T5_Vdi_d)))+((((T6_Vdi_d*T7-T6*T7_Vdi_d)/T7/T7)*DelClm*T8*T9-(((T6/T7)*DelClm)*T8)*T9_Vdi_d)/T9/T9));
Ssi_Vsi_s=(((((T1_Vsi_s*T2-T1*T2_Vsi_s)/T2/T2)*((T3+T4)+T5))+((T1/T2)*(T3_Vsi_s+T5_Vsi_s)))+((((T6_Vsi_s*T7-T6*T7_Vsi_s)/T7/T7)*DelClm*T8*T9-(((T6/T7)*DelClm)*T8)*T9_Vsi_s)/T9/T9));
#endif
Ssi=(((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9));
EXIT_IF_ISNAN((((T1/T2)*((T3+T4)+T5))+((((T6/T7)*DelClm)*T8)/T9)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(e,GND)V(si,GND)V(di,GND)V(ge,GND) */
T10_Vge_di=0.0;
#if defined(_DERIVATE2)
  T10_Vge_di_Vge_di=0.0;
  T10_Vge_di_Vge_e=0.0;
  T10_Vge_di_Ve_si=0.0;
  T10_Vge_di_Ve_di=0.0;
  T10_Vge_di_Vge_si=0.0;
  T10_Vge_di_Vdi_si=0.0;
  T10_Vge_di_Tempt_GND=0.0;
#endif
T10_Vge_e=0.0;
#if defined(_DERIVATE2)
  T10_Vge_e_Vge_di=0.0;
  T10_Vge_e_Vge_e=0.0;
  T10_Vge_e_Ve_si=0.0;
  T10_Vge_e_Ve_di=0.0;
  T10_Vge_e_Vge_si=0.0;
  T10_Vge_e_Vdi_si=0.0;
  T10_Vge_e_Tempt_GND=0.0;
#endif
T10_Ve_si=0.0;
#if defined(_DERIVATE2)
  T10_Ve_si_Vge_di=0.0;
  T10_Ve_si_Vge_e=0.0;
  T10_Ve_si_Ve_si=0.0;
  T10_Ve_si_Ve_di=0.0;
  T10_Ve_si_Vge_si=0.0;
  T10_Ve_si_Vdi_si=0.0;
  T10_Ve_si_Tempt_GND=0.0;
#endif
T10_Ve_di=0.0;
#if defined(_DERIVATE2)
  T10_Ve_di_Vge_di=0.0;
  T10_Ve_di_Vge_e=0.0;
  T10_Ve_di_Ve_si=0.0;
  T10_Ve_di_Ve_di=0.0;
  T10_Ve_di_Vge_si=0.0;
  T10_Ve_di_Vdi_si=0.0;
  T10_Ve_di_Tempt_GND=0.0;
#endif
T10_Vge_si=0.0;
#if defined(_DERIVATE2)
  T10_Vge_si_Vge_di=0.0;
  T10_Vge_si_Vge_e=0.0;
  T10_Vge_si_Ve_si=0.0;
  T10_Vge_si_Ve_di=0.0;
  T10_Vge_si_Vge_si=0.0;
  T10_Vge_si_Vdi_si=0.0;
  T10_Vge_si_Tempt_GND=0.0;
#endif
T10_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T10_Vdi_si_Vge_di=0.0;
  T10_Vdi_si_Vge_e=0.0;
  T10_Vdi_si_Ve_si=0.0;
  T10_Vdi_si_Ve_di=0.0;
  T10_Vdi_si_Vge_si=0.0;
  T10_Vdi_si_Vdi_si=0.0;
  T10_Vdi_si_Tempt_GND=0.0;
#endif
T10_Tempt_GND=((pModel->NOIA*1.60219e-19)*Vtm_Tempt_GND);
#if defined(_DERIVATE2)
  T10_Tempt_GND_Vge_di=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Vge_e=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Ve_si=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Ve_di=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Vge_si=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Vdi_si=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*0.0);
  T10_Tempt_GND_Tempt_GND=(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+pModel->NOIA*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*Vtm_Tempt_GND+(pModel->NOIA*1.60219e-19)*Vtm_Tempt_GND_Tempt_GND);
#endif
#endif
T10=((pModel->NOIA*1.60219e-19)*Vtm);
EXIT_IF_ISNAN(((pModel->NOIA*1.60219e-19)*Vtm))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T11_Vge_e=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e));
#if defined(_DERIVATE2)
  T11_Vge_e_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Vge_e);
  T11_Vge_e_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Ve_si);
  T11_Vge_e_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Ve_di);
  T11_Vge_e_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Vge_si);
  T11_Vge_e_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Vdi_si);
  T11_Vge_e_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_e+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vge_e+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_e_Tempt_GND);
#endif
T11_Ve_si=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si));
#if defined(_DERIVATE2)
  T11_Ve_si_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Vge_e);
  T11_Ve_si_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Ve_si);
  T11_Ve_si_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Ve_di);
  T11_Ve_si_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Vge_si);
  T11_Ve_si_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Vdi_si);
  T11_Ve_si_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Ve_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_si_Tempt_GND);
#endif
T11_Ve_di=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di));
#if defined(_DERIVATE2)
  T11_Ve_di_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Vge_e);
  T11_Ve_di_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Ve_si);
  T11_Ve_di_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Ve_di);
  T11_Ve_di_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Vge_si);
  T11_Ve_di_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Vdi_si);
  T11_Ve_di_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Ve_di+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Ve_di+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Ve_di_Tempt_GND);
#endif
T11_Vge_si=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si));
#if defined(_DERIVATE2)
  T11_Vge_si_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Vge_e);
  T11_Vge_si_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Ve_si);
  T11_Vge_si_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Ve_di);
  T11_Vge_si_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Vge_si);
  T11_Vge_si_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Vdi_si);
  T11_Vge_si_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vge_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vge_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vge_si_Tempt_GND);
#endif
T11_Vdi_si=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si));
#if defined(_DERIVATE2)
  T11_Vdi_si_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Vge_e);
  T11_Vdi_si_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Ve_si);
  T11_Vdi_si_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Ve_di);
  T11_Vdi_si_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Vge_si);
  T11_Vdi_si_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Vdi_si);
  T11_Vdi_si_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Vdi_si+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Vdi_si+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Vdi_si_Tempt_GND);
#endif
T11_Tempt_GND=((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar)+(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND));
#if defined(_DERIVATE2)
  T11_Tempt_GND_Vge_e=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_e+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Vge_e)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Vge_e+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_e)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Vge_e);
  T11_Tempt_GND_Ve_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Ve_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Ve_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_si)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Ve_si);
  T11_Tempt_GND_Ve_di=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Ve_di+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Ve_di)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Ve_di+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Ve_di)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Ve_di);
  T11_Tempt_GND_Vge_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vge_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Vge_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Vge_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vge_si)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Vge_si);
  T11_Tempt_GND_Vdi_si=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Vdi_si+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Vdi_si)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Vdi_si+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Vdi_si)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Vdi_si);
  T11_Tempt_GND_Tempt_GND=(+(+(+(+(+0.0*NFINtotal+0.0*0.0+0.0*0.0+Weff0*0.0)*Leffnoi+0.0*0.0+(0.0)*0.0+(Weff0*NFINtotal)*0.0)*1.0e10+0.0*0.0+((0.0)*Leffnoi)*0.0+((Weff0*NFINtotal)*Leffnoi)*0.0)*Nstar+0.0*Nstar_Tempt_GND+(((0.0)*Leffnoi)*1.0e10)*Nstar_Tempt_GND+(((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND_Tempt_GND)*Nstar+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)*Nstar_Tempt_GND+((((((0.0)*Leffnoi)*1.0e10)*Nstar)+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar_Tempt_GND)))*Nstar_Tempt_GND+((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar_Tempt_GND_Tempt_GND);
#endif
#endif
T11=(((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar);
EXIT_IF_ISNAN((((((Weff0*NFINtotal)*Leffnoi)*1.0e10)*Nstar)*Nstar))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
Swi_Vge_di=(((((T10_Vge_di/T11)*ids)+((T10/T11)*ids_Vge_di))*ids)+(((T10/T11)*ids)*ids_Vge_di));
Swi_Vge_e=((((((T10_Vge_e*T11-T10*T11_Vge_e)/T11/T11)*ids)+((T10/T11)*ids_Vge_e))*ids)+(((T10/T11)*ids)*ids_Vge_e));
Swi_Ve_si=((((((T10_Ve_si*T11-T10*T11_Ve_si)/T11/T11)*ids)+((T10/T11)*ids_Ve_si))*ids)+(((T10/T11)*ids)*ids_Ve_si));
Swi_Ve_di=((((((T10_Ve_di*T11-T10*T11_Ve_di)/T11/T11)*ids)+((T10/T11)*ids_Ve_di))*ids)+(((T10/T11)*ids)*ids_Ve_di));
Swi_Vge_si=((((((T10_Vge_si*T11-T10*T11_Vge_si)/T11/T11)*ids)+((T10/T11)*ids_Vge_si))*ids)+(((T10/T11)*ids)*ids_Vge_si));
Swi_Vdi_si=((((((T10_Vdi_si*T11-T10*T11_Vdi_si)/T11/T11)*ids)+((T10/T11)*ids_Vdi_si))*ids)+(((T10/T11)*ids)*ids_Vdi_si));
Swi_Tempt_GND=((((((T10_Tempt_GND*T11-T10*T11_Tempt_GND)/T11/T11)*ids)+((T10/T11)*ids_Tempt_GND))*ids)+(((T10/T11)*ids)*ids_Tempt_GND));
#endif
Swi=(((T10/T11)*ids)*ids);
EXIT_IF_ISNAN((((T10/T11)*ids)*ids))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=Ssi_Vdi_d;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=(+0.0+Ssi_Vdi_d_Vdi_d);
  T1_Vdi_d_Vsi_s=(+0.0+Ssi_Vdi_d_Vsi_s);
  T1_Vdi_d_Vge_di=(+0.0+Ssi_Vdi_d_Vge_di);
  T1_Vdi_d_Vge_e=(+0.0+Ssi_Vdi_d_Vge_e);
  T1_Vdi_d_Ve_si=(+0.0+Ssi_Vdi_d_Ve_si);
  T1_Vdi_d_Ve_di=(+0.0+Ssi_Vdi_d_Ve_di);
  T1_Vdi_d_Vge_si=(+0.0+Ssi_Vdi_d_Vge_si);
  T1_Vdi_d_Vdi_si=(+0.0+Ssi_Vdi_d_Vdi_si);
  T1_Vdi_d_Tempt_GND=(+0.0+Ssi_Vdi_d_Tempt_GND);
#endif
T1_Vsi_s=Ssi_Vsi_s;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=(+0.0+Ssi_Vsi_s_Vdi_d);
  T1_Vsi_s_Vsi_s=(+0.0+Ssi_Vsi_s_Vsi_s);
  T1_Vsi_s_Vge_di=(+0.0+Ssi_Vsi_s_Vge_di);
  T1_Vsi_s_Vge_e=(+0.0+Ssi_Vsi_s_Vge_e);
  T1_Vsi_s_Ve_si=(+0.0+Ssi_Vsi_s_Ve_si);
  T1_Vsi_s_Ve_di=(+0.0+Ssi_Vsi_s_Ve_di);
  T1_Vsi_s_Vge_si=(+0.0+Ssi_Vsi_s_Vge_si);
  T1_Vsi_s_Vdi_si=(+0.0+Ssi_Vsi_s_Vdi_si);
  T1_Vsi_s_Tempt_GND=(+0.0+Ssi_Vsi_s_Tempt_GND);
#endif
T1_Vge_di=(Swi_Vge_di+Ssi_Vge_di);
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+0.0+Ssi_Vge_di_Vdi_d);
  T1_Vge_di_Vsi_s=(+0.0+Ssi_Vge_di_Vsi_s);
  T1_Vge_di_Vge_di=(+Swi_Vge_di_Vge_di+Ssi_Vge_di_Vge_di);
  T1_Vge_di_Vge_e=(+Swi_Vge_di_Vge_e+Ssi_Vge_di_Vge_e);
  T1_Vge_di_Ve_si=(+Swi_Vge_di_Ve_si+Ssi_Vge_di_Ve_si);
  T1_Vge_di_Ve_di=(+Swi_Vge_di_Ve_di+Ssi_Vge_di_Ve_di);
  T1_Vge_di_Vge_si=(+Swi_Vge_di_Vge_si+Ssi_Vge_di_Vge_si);
  T1_Vge_di_Vdi_si=(+Swi_Vge_di_Vdi_si+Ssi_Vge_di_Vdi_si);
  T1_Vge_di_Tempt_GND=(+Swi_Vge_di_Tempt_GND+Ssi_Vge_di_Tempt_GND);
#endif
T1_Vge_e=(Swi_Vge_e+Ssi_Vge_e);
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+0.0+Ssi_Vge_e_Vdi_d);
  T1_Vge_e_Vsi_s=(+0.0+Ssi_Vge_e_Vsi_s);
  T1_Vge_e_Vge_di=(+Swi_Vge_e_Vge_di+Ssi_Vge_e_Vge_di);
  T1_Vge_e_Vge_e=(+Swi_Vge_e_Vge_e+Ssi_Vge_e_Vge_e);
  T1_Vge_e_Ve_si=(+Swi_Vge_e_Ve_si+Ssi_Vge_e_Ve_si);
  T1_Vge_e_Ve_di=(+Swi_Vge_e_Ve_di+Ssi_Vge_e_Ve_di);
  T1_Vge_e_Vge_si=(+Swi_Vge_e_Vge_si+Ssi_Vge_e_Vge_si);
  T1_Vge_e_Vdi_si=(+Swi_Vge_e_Vdi_si+Ssi_Vge_e_Vdi_si);
  T1_Vge_e_Tempt_GND=(+Swi_Vge_e_Tempt_GND+Ssi_Vge_e_Tempt_GND);
#endif
T1_Ve_si=(Swi_Ve_si+Ssi_Ve_si);
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0+Ssi_Ve_si_Vdi_d);
  T1_Ve_si_Vsi_s=(+0.0+Ssi_Ve_si_Vsi_s);
  T1_Ve_si_Vge_di=(+Swi_Ve_si_Vge_di+Ssi_Ve_si_Vge_di);
  T1_Ve_si_Vge_e=(+Swi_Ve_si_Vge_e+Ssi_Ve_si_Vge_e);
  T1_Ve_si_Ve_si=(+Swi_Ve_si_Ve_si+Ssi_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+Swi_Ve_si_Ve_di+Ssi_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+Swi_Ve_si_Vge_si+Ssi_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+Swi_Ve_si_Vdi_si+Ssi_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+Swi_Ve_si_Tempt_GND+Ssi_Ve_si_Tempt_GND);
#endif
T1_Ve_di=(Swi_Ve_di+Ssi_Ve_di);
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0+Ssi_Ve_di_Vdi_d);
  T1_Ve_di_Vsi_s=(+0.0+Ssi_Ve_di_Vsi_s);
  T1_Ve_di_Vge_di=(+Swi_Ve_di_Vge_di+Ssi_Ve_di_Vge_di);
  T1_Ve_di_Vge_e=(+Swi_Ve_di_Vge_e+Ssi_Ve_di_Vge_e);
  T1_Ve_di_Ve_si=(+Swi_Ve_di_Ve_si+Ssi_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+Swi_Ve_di_Ve_di+Ssi_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+Swi_Ve_di_Vge_si+Ssi_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+Swi_Ve_di_Vdi_si+Ssi_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+Swi_Ve_di_Tempt_GND+Ssi_Ve_di_Tempt_GND);
#endif
T1_Vge_si=(Swi_Vge_si+Ssi_Vge_si);
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0+Ssi_Vge_si_Vdi_d);
  T1_Vge_si_Vsi_s=(+0.0+Ssi_Vge_si_Vsi_s);
  T1_Vge_si_Vge_di=(+Swi_Vge_si_Vge_di+Ssi_Vge_si_Vge_di);
  T1_Vge_si_Vge_e=(+Swi_Vge_si_Vge_e+Ssi_Vge_si_Vge_e);
  T1_Vge_si_Ve_si=(+Swi_Vge_si_Ve_si+Ssi_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+Swi_Vge_si_Ve_di+Ssi_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+Swi_Vge_si_Vge_si+Ssi_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+Swi_Vge_si_Vdi_si+Ssi_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+Swi_Vge_si_Tempt_GND+Ssi_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=(Swi_Vdi_si+Ssi_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0+Ssi_Vdi_si_Vdi_d);
  T1_Vdi_si_Vsi_s=(+0.0+Ssi_Vdi_si_Vsi_s);
  T1_Vdi_si_Vge_di=(+Swi_Vdi_si_Vge_di+Ssi_Vdi_si_Vge_di);
  T1_Vdi_si_Vge_e=(+Swi_Vdi_si_Vge_e+Ssi_Vdi_si_Vge_e);
  T1_Vdi_si_Ve_si=(+Swi_Vdi_si_Ve_si+Ssi_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+Swi_Vdi_si_Ve_di+Ssi_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+Swi_Vdi_si_Vge_si+Ssi_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+Swi_Vdi_si_Vdi_si+Ssi_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+Swi_Vdi_si_Tempt_GND+Ssi_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=(Swi_Tempt_GND+Ssi_Tempt_GND);
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0+Ssi_Tempt_GND_Vdi_d);
  T1_Tempt_GND_Vsi_s=(+0.0+Ssi_Tempt_GND_Vsi_s);
  T1_Tempt_GND_Vge_di=(+Swi_Tempt_GND_Vge_di+Ssi_Tempt_GND_Vge_di);
  T1_Tempt_GND_Vge_e=(+Swi_Tempt_GND_Vge_e+Ssi_Tempt_GND_Vge_e);
  T1_Tempt_GND_Ve_si=(+Swi_Tempt_GND_Ve_si+Ssi_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+Swi_Tempt_GND_Ve_di+Ssi_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+Swi_Tempt_GND_Vge_si+Ssi_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+Swi_Tempt_GND_Vdi_si+Ssi_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+Swi_Tempt_GND_Tempt_GND+Ssi_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(Swi+Ssi);
EXIT_IF_ISNAN((Swi+Ssi))
if
((T1>0.0))
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
FNPowerAt1Hz_Vge_di=((((Ssi_Vge_di*Swi)+(Ssi*Swi_Vge_di))*T1-(Ssi*Swi)*T1_Vge_di)/T1/T1);
FNPowerAt1Hz_Vge_e=((((Ssi_Vge_e*Swi)+(Ssi*Swi_Vge_e))*T1-(Ssi*Swi)*T1_Vge_e)/T1/T1);
FNPowerAt1Hz_Ve_si=((((Ssi_Ve_si*Swi)+(Ssi*Swi_Ve_si))*T1-(Ssi*Swi)*T1_Ve_si)/T1/T1);
FNPowerAt1Hz_Ve_di=((((Ssi_Ve_di*Swi)+(Ssi*Swi_Ve_di))*T1-(Ssi*Swi)*T1_Ve_di)/T1/T1);
FNPowerAt1Hz_Vge_si=((((Ssi_Vge_si*Swi)+(Ssi*Swi_Vge_si))*T1-(Ssi*Swi)*T1_Vge_si)/T1/T1);
FNPowerAt1Hz_Vdi_si=((((Ssi_Vdi_si*Swi)+(Ssi*Swi_Vdi_si))*T1-(Ssi*Swi)*T1_Vdi_si)/T1/T1);
FNPowerAt1Hz_Tempt_GND=((((Ssi_Tempt_GND*Swi)+(Ssi*Swi_Tempt_GND))*T1-(Ssi*Swi)*T1_Tempt_GND)/T1/T1);
FNPowerAt1Hz_Vdi_d=((Ssi_Vdi_d*Swi*T1-(Ssi*Swi)*T1_Vdi_d)/T1/T1);
FNPowerAt1Hz_Vsi_s=((Ssi_Vsi_s*Swi*T1-(Ssi*Swi)*T1_Vsi_s)/T1/T1);
#endif
FNPowerAt1Hz=((Ssi*Swi)/T1);
EXIT_IF_ISNAN(((Ssi*Swi)/T1))
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
FNPowerAt1Hz_Vge_di=0.0;
FNPowerAt1Hz_Vge_e=0.0;
FNPowerAt1Hz_Ve_si=0.0;
FNPowerAt1Hz_Ve_di=0.0;
FNPowerAt1Hz_Vge_si=0.0;
FNPowerAt1Hz_Vdi_si=0.0;
FNPowerAt1Hz_Tempt_GND=0.0;
FNPowerAt1Hz_Vdi_d=0.0;
FNPowerAt1Hz_Vsi_s=0.0;
#endif
FNPowerAt1Hz=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
FNPowerAt1Hz_Vge_di=0.0;
FNPowerAt1Hz_Vge_e=0.0;
FNPowerAt1Hz_Ve_si=0.0;
FNPowerAt1Hz_Ve_di=0.0;
FNPowerAt1Hz_Vge_si=0.0;
FNPowerAt1Hz_Vdi_si=0.0;
FNPowerAt1Hz_Tempt_GND=0.0;
FNPowerAt1Hz_Vdi_d=0.0;
FNPowerAt1Hz_Vsi_s=0.0;
#endif
FNPowerAt1Hz=0.0;
EXIT_IF_ISNAN(0.0)
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((pModel->TNOIMOD)==(0)))
{
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=((ueff_Vge_e*qinv)+(ueff*qinv_Vge_e));
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=(+0.0*qinv+ueff_Vge_e*0.0+0.0*qinv_Vge_e+ueff*0.0);
  T0_Vge_e_Vge_e=(+ueff_Vge_e_Vge_e*qinv+ueff_Vge_e*qinv_Vge_e+ueff_Vge_e*qinv_Vge_e+ueff*qinv_Vge_e_Vge_e);
  T0_Vge_e_Ve_si=(+ueff_Vge_e_Ve_si*qinv+ueff_Vge_e*qinv_Ve_si+ueff_Ve_si*qinv_Vge_e+ueff*qinv_Vge_e_Ve_si);
  T0_Vge_e_Ve_di=(+ueff_Vge_e_Ve_di*qinv+ueff_Vge_e*qinv_Ve_di+ueff_Ve_di*qinv_Vge_e+ueff*qinv_Vge_e_Ve_di);
  T0_Vge_e_Vge_si=(+ueff_Vge_e_Vge_si*qinv+ueff_Vge_e*qinv_Vge_si+ueff_Vge_si*qinv_Vge_e+ueff*qinv_Vge_e_Vge_si);
  T0_Vge_e_Vdi_si=(+ueff_Vge_e_Vdi_si*qinv+ueff_Vge_e*qinv_Vdi_si+ueff_Vdi_si*qinv_Vge_e+ueff*qinv_Vge_e_Vdi_si);
  T0_Vge_e_Tempt_GND=(+ueff_Vge_e_Tempt_GND*qinv+ueff_Vge_e*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Vge_e+ueff*qinv_Vge_e_Tempt_GND);
#endif
T0_Ve_si=((ueff_Ve_si*qinv)+(ueff*qinv_Ve_si));
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0*qinv+ueff_Ve_si*0.0+0.0*qinv_Ve_si+ueff*0.0);
  T0_Ve_si_Vge_e=(+ueff_Ve_si_Vge_e*qinv+ueff_Ve_si*qinv_Vge_e+ueff_Vge_e*qinv_Ve_si+ueff*qinv_Ve_si_Vge_e);
  T0_Ve_si_Ve_si=(+ueff_Ve_si_Ve_si*qinv+ueff_Ve_si*qinv_Ve_si+ueff_Ve_si*qinv_Ve_si+ueff*qinv_Ve_si_Ve_si);
  T0_Ve_si_Ve_di=(+ueff_Ve_si_Ve_di*qinv+ueff_Ve_si*qinv_Ve_di+ueff_Ve_di*qinv_Ve_si+ueff*qinv_Ve_si_Ve_di);
  T0_Ve_si_Vge_si=(+ueff_Ve_si_Vge_si*qinv+ueff_Ve_si*qinv_Vge_si+ueff_Vge_si*qinv_Ve_si+ueff*qinv_Ve_si_Vge_si);
  T0_Ve_si_Vdi_si=(+ueff_Ve_si_Vdi_si*qinv+ueff_Ve_si*qinv_Vdi_si+ueff_Vdi_si*qinv_Ve_si+ueff*qinv_Ve_si_Vdi_si);
  T0_Ve_si_Tempt_GND=(+ueff_Ve_si_Tempt_GND*qinv+ueff_Ve_si*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Ve_si+ueff*qinv_Ve_si_Tempt_GND);
#endif
T0_Ve_di=((ueff_Ve_di*qinv)+(ueff*qinv_Ve_di));
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0*qinv+ueff_Ve_di*0.0+0.0*qinv_Ve_di+ueff*0.0);
  T0_Ve_di_Vge_e=(+ueff_Ve_di_Vge_e*qinv+ueff_Ve_di*qinv_Vge_e+ueff_Vge_e*qinv_Ve_di+ueff*qinv_Ve_di_Vge_e);
  T0_Ve_di_Ve_si=(+ueff_Ve_di_Ve_si*qinv+ueff_Ve_di*qinv_Ve_si+ueff_Ve_si*qinv_Ve_di+ueff*qinv_Ve_di_Ve_si);
  T0_Ve_di_Ve_di=(+ueff_Ve_di_Ve_di*qinv+ueff_Ve_di*qinv_Ve_di+ueff_Ve_di*qinv_Ve_di+ueff*qinv_Ve_di_Ve_di);
  T0_Ve_di_Vge_si=(+ueff_Ve_di_Vge_si*qinv+ueff_Ve_di*qinv_Vge_si+ueff_Vge_si*qinv_Ve_di+ueff*qinv_Ve_di_Vge_si);
  T0_Ve_di_Vdi_si=(+ueff_Ve_di_Vdi_si*qinv+ueff_Ve_di*qinv_Vdi_si+ueff_Vdi_si*qinv_Ve_di+ueff*qinv_Ve_di_Vdi_si);
  T0_Ve_di_Tempt_GND=(+ueff_Ve_di_Tempt_GND*qinv+ueff_Ve_di*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Ve_di+ueff*qinv_Ve_di_Tempt_GND);
#endif
T0_Vge_si=((ueff_Vge_si*qinv)+(ueff*qinv_Vge_si));
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0*qinv+ueff_Vge_si*0.0+0.0*qinv_Vge_si+ueff*0.0);
  T0_Vge_si_Vge_e=(+ueff_Vge_si_Vge_e*qinv+ueff_Vge_si*qinv_Vge_e+ueff_Vge_e*qinv_Vge_si+ueff*qinv_Vge_si_Vge_e);
  T0_Vge_si_Ve_si=(+ueff_Vge_si_Ve_si*qinv+ueff_Vge_si*qinv_Ve_si+ueff_Ve_si*qinv_Vge_si+ueff*qinv_Vge_si_Ve_si);
  T0_Vge_si_Ve_di=(+ueff_Vge_si_Ve_di*qinv+ueff_Vge_si*qinv_Ve_di+ueff_Ve_di*qinv_Vge_si+ueff*qinv_Vge_si_Ve_di);
  T0_Vge_si_Vge_si=(+ueff_Vge_si_Vge_si*qinv+ueff_Vge_si*qinv_Vge_si+ueff_Vge_si*qinv_Vge_si+ueff*qinv_Vge_si_Vge_si);
  T0_Vge_si_Vdi_si=(+ueff_Vge_si_Vdi_si*qinv+ueff_Vge_si*qinv_Vdi_si+ueff_Vdi_si*qinv_Vge_si+ueff*qinv_Vge_si_Vdi_si);
  T0_Vge_si_Tempt_GND=(+ueff_Vge_si_Tempt_GND*qinv+ueff_Vge_si*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Vge_si+ueff*qinv_Vge_si_Tempt_GND);
#endif
T0_Vdi_si=((ueff_Vdi_si*qinv)+(ueff*qinv_Vdi_si));
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0*qinv+ueff_Vdi_si*0.0+0.0*qinv_Vdi_si+ueff*0.0);
  T0_Vdi_si_Vge_e=(+ueff_Vdi_si_Vge_e*qinv+ueff_Vdi_si*qinv_Vge_e+ueff_Vge_e*qinv_Vdi_si+ueff*qinv_Vdi_si_Vge_e);
  T0_Vdi_si_Ve_si=(+ueff_Vdi_si_Ve_si*qinv+ueff_Vdi_si*qinv_Ve_si+ueff_Ve_si*qinv_Vdi_si+ueff*qinv_Vdi_si_Ve_si);
  T0_Vdi_si_Ve_di=(+ueff_Vdi_si_Ve_di*qinv+ueff_Vdi_si*qinv_Ve_di+ueff_Ve_di*qinv_Vdi_si+ueff*qinv_Vdi_si_Ve_di);
  T0_Vdi_si_Vge_si=(+ueff_Vdi_si_Vge_si*qinv+ueff_Vdi_si*qinv_Vge_si+ueff_Vge_si*qinv_Vdi_si+ueff*qinv_Vdi_si_Vge_si);
  T0_Vdi_si_Vdi_si=(+ueff_Vdi_si_Vdi_si*qinv+ueff_Vdi_si*qinv_Vdi_si+ueff_Vdi_si*qinv_Vdi_si+ueff*qinv_Vdi_si_Vdi_si);
  T0_Vdi_si_Tempt_GND=(+ueff_Vdi_si_Tempt_GND*qinv+ueff_Vdi_si*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Vdi_si+ueff*qinv_Vdi_si_Tempt_GND);
#endif
T0_Tempt_GND=((ueff_Tempt_GND*qinv)+(ueff*qinv_Tempt_GND));
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0*qinv+ueff_Tempt_GND*0.0+0.0*qinv_Tempt_GND+ueff*0.0);
  T0_Tempt_GND_Vge_e=(+ueff_Tempt_GND_Vge_e*qinv+ueff_Tempt_GND*qinv_Vge_e+ueff_Vge_e*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Vge_e);
  T0_Tempt_GND_Ve_si=(+ueff_Tempt_GND_Ve_si*qinv+ueff_Tempt_GND*qinv_Ve_si+ueff_Ve_si*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Ve_si);
  T0_Tempt_GND_Ve_di=(+ueff_Tempt_GND_Ve_di*qinv+ueff_Tempt_GND*qinv_Ve_di+ueff_Ve_di*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Ve_di);
  T0_Tempt_GND_Vge_si=(+ueff_Tempt_GND_Vge_si*qinv+ueff_Tempt_GND*qinv_Vge_si+ueff_Vge_si*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Vge_si);
  T0_Tempt_GND_Vdi_si=(+ueff_Tempt_GND_Vdi_si*qinv+ueff_Tempt_GND*qinv_Vdi_si+ueff_Vdi_si*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Vdi_si);
  T0_Tempt_GND_Tempt_GND=(+ueff_Tempt_GND_Tempt_GND*qinv+ueff_Tempt_GND*qinv_Tempt_GND+ueff_Tempt_GND*qinv_Tempt_GND+ueff*qinv_Tempt_GND_Tempt_GND);
#endif
#endif
T0=(ueff*qinv);
EXIT_IF_ISNAN((ueff*qinv))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=((T0_Vge_di*Rdsi)+(T0*Rdsi_Vge_di));
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=(+(+0.0*Rdsi+T0_Vge_di*0.0+0.0*Rdsi_Vge_di+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Vsi_s=(+(+0.0*Rdsi+T0_Vge_di*0.0+0.0*Rdsi_Vge_di+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Vge_di=(+(+T0_Vge_di_Vge_di*Rdsi+T0_Vge_di*Rdsi_Vge_di+T0_Vge_di*Rdsi_Vge_di+T0*Rdsi_Vge_di_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Vge_e=(+(+T0_Vge_di_Vge_e*Rdsi+T0_Vge_di*Rdsi_Vge_e+T0_Vge_e*Rdsi_Vge_di+T0*Rdsi_Vge_di_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Ve_si=(+(+T0_Vge_di_Ve_si*Rdsi+T0_Vge_di*Rdsi_Ve_si+T0_Ve_si*Rdsi_Vge_di+T0*Rdsi_Vge_di_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Ve_di=(+(+T0_Vge_di_Ve_di*Rdsi+T0_Vge_di*Rdsi_Ve_di+T0_Ve_di*Rdsi_Vge_di+T0*Rdsi_Vge_di_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Vge_si=(+(+T0_Vge_di_Vge_si*Rdsi+T0_Vge_di*Rdsi_Vge_si+T0_Vge_si*Rdsi_Vge_di+T0*Rdsi_Vge_di_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Vdi_si=(+(+T0_Vge_di_Vdi_si*Rdsi+T0_Vge_di*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Vge_di+T0*Rdsi_Vge_di_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_di_Tempt_GND=(+(+T0_Vge_di_Tempt_GND*Rdsi+T0_Vge_di*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vge_di+T0*Rdsi_Vge_di_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vge_e=((T0_Vge_e*Rdsi)+(T0*Rdsi_Vge_e));
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=(+(+0.0*Rdsi+T0_Vge_e*0.0+0.0*Rdsi_Vge_e+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Vsi_s=(+(+0.0*Rdsi+T0_Vge_e*0.0+0.0*Rdsi_Vge_e+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Vge_di=(+(+T0_Vge_e_Vge_di*Rdsi+T0_Vge_e*Rdsi_Vge_di+T0_Vge_di*Rdsi_Vge_e+T0*Rdsi_Vge_e_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Vge_e=(+(+T0_Vge_e_Vge_e*Rdsi+T0_Vge_e*Rdsi_Vge_e+T0_Vge_e*Rdsi_Vge_e+T0*Rdsi_Vge_e_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Ve_si=(+(+T0_Vge_e_Ve_si*Rdsi+T0_Vge_e*Rdsi_Ve_si+T0_Ve_si*Rdsi_Vge_e+T0*Rdsi_Vge_e_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Ve_di=(+(+T0_Vge_e_Ve_di*Rdsi+T0_Vge_e*Rdsi_Ve_di+T0_Ve_di*Rdsi_Vge_e+T0*Rdsi_Vge_e_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Vge_si=(+(+T0_Vge_e_Vge_si*Rdsi+T0_Vge_e*Rdsi_Vge_si+T0_Vge_si*Rdsi_Vge_e+T0*Rdsi_Vge_e_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Vdi_si=(+(+T0_Vge_e_Vdi_si*Rdsi+T0_Vge_e*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Vge_e+T0*Rdsi_Vge_e_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_e_Tempt_GND=(+(+T0_Vge_e_Tempt_GND*Rdsi+T0_Vge_e*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vge_e+T0*Rdsi_Vge_e_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Ve_si=((T0_Ve_si*Rdsi)+(T0*Rdsi_Ve_si));
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+(+0.0*Rdsi+T0_Ve_si*0.0+0.0*Rdsi_Ve_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Vsi_s=(+(+0.0*Rdsi+T0_Ve_si*0.0+0.0*Rdsi_Ve_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Vge_di=(+(+T0_Ve_si_Vge_di*Rdsi+T0_Ve_si*Rdsi_Vge_di+T0_Vge_di*Rdsi_Ve_si+T0*Rdsi_Ve_si_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Vge_e=(+(+T0_Ve_si_Vge_e*Rdsi+T0_Ve_si*Rdsi_Vge_e+T0_Vge_e*Rdsi_Ve_si+T0*Rdsi_Ve_si_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Ve_si=(+(+T0_Ve_si_Ve_si*Rdsi+T0_Ve_si*Rdsi_Ve_si+T0_Ve_si*Rdsi_Ve_si+T0*Rdsi_Ve_si_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Ve_di=(+(+T0_Ve_si_Ve_di*Rdsi+T0_Ve_si*Rdsi_Ve_di+T0_Ve_di*Rdsi_Ve_si+T0*Rdsi_Ve_si_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Vge_si=(+(+T0_Ve_si_Vge_si*Rdsi+T0_Ve_si*Rdsi_Vge_si+T0_Vge_si*Rdsi_Ve_si+T0*Rdsi_Ve_si_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Vdi_si=(+(+T0_Ve_si_Vdi_si*Rdsi+T0_Ve_si*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Ve_si+T0*Rdsi_Ve_si_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_si_Tempt_GND=(+(+T0_Ve_si_Tempt_GND*Rdsi+T0_Ve_si*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Ve_si+T0*Rdsi_Ve_si_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Ve_di=((T0_Ve_di*Rdsi)+(T0*Rdsi_Ve_di));
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+(+0.0*Rdsi+T0_Ve_di*0.0+0.0*Rdsi_Ve_di+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Vsi_s=(+(+0.0*Rdsi+T0_Ve_di*0.0+0.0*Rdsi_Ve_di+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Vge_di=(+(+T0_Ve_di_Vge_di*Rdsi+T0_Ve_di*Rdsi_Vge_di+T0_Vge_di*Rdsi_Ve_di+T0*Rdsi_Ve_di_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Vge_e=(+(+T0_Ve_di_Vge_e*Rdsi+T0_Ve_di*Rdsi_Vge_e+T0_Vge_e*Rdsi_Ve_di+T0*Rdsi_Ve_di_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Ve_si=(+(+T0_Ve_di_Ve_si*Rdsi+T0_Ve_di*Rdsi_Ve_si+T0_Ve_si*Rdsi_Ve_di+T0*Rdsi_Ve_di_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Ve_di=(+(+T0_Ve_di_Ve_di*Rdsi+T0_Ve_di*Rdsi_Ve_di+T0_Ve_di*Rdsi_Ve_di+T0*Rdsi_Ve_di_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Vge_si=(+(+T0_Ve_di_Vge_si*Rdsi+T0_Ve_di*Rdsi_Vge_si+T0_Vge_si*Rdsi_Ve_di+T0*Rdsi_Ve_di_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Vdi_si=(+(+T0_Ve_di_Vdi_si*Rdsi+T0_Ve_di*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Ve_di+T0*Rdsi_Ve_di_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Ve_di_Tempt_GND=(+(+T0_Ve_di_Tempt_GND*Rdsi+T0_Ve_di*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Ve_di+T0*Rdsi_Ve_di_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vge_si=((T0_Vge_si*Rdsi)+(T0*Rdsi_Vge_si));
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+(+0.0*Rdsi+T0_Vge_si*0.0+0.0*Rdsi_Vge_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Vsi_s=(+(+0.0*Rdsi+T0_Vge_si*0.0+0.0*Rdsi_Vge_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Vge_di=(+(+T0_Vge_si_Vge_di*Rdsi+T0_Vge_si*Rdsi_Vge_di+T0_Vge_di*Rdsi_Vge_si+T0*Rdsi_Vge_si_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Vge_e=(+(+T0_Vge_si_Vge_e*Rdsi+T0_Vge_si*Rdsi_Vge_e+T0_Vge_e*Rdsi_Vge_si+T0*Rdsi_Vge_si_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Ve_si=(+(+T0_Vge_si_Ve_si*Rdsi+T0_Vge_si*Rdsi_Ve_si+T0_Ve_si*Rdsi_Vge_si+T0*Rdsi_Vge_si_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Ve_di=(+(+T0_Vge_si_Ve_di*Rdsi+T0_Vge_si*Rdsi_Ve_di+T0_Ve_di*Rdsi_Vge_si+T0*Rdsi_Vge_si_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Vge_si=(+(+T0_Vge_si_Vge_si*Rdsi+T0_Vge_si*Rdsi_Vge_si+T0_Vge_si*Rdsi_Vge_si+T0*Rdsi_Vge_si_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Vdi_si=(+(+T0_Vge_si_Vdi_si*Rdsi+T0_Vge_si*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Vge_si+T0*Rdsi_Vge_si_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vge_si_Tempt_GND=(+(+T0_Vge_si_Tempt_GND*Rdsi+T0_Vge_si*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vge_si+T0*Rdsi_Vge_si_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Vdi_si=((T0_Vdi_si*Rdsi)+(T0*Rdsi_Vdi_si));
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+(+0.0*Rdsi+T0_Vdi_si*0.0+0.0*Rdsi_Vdi_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Vsi_s=(+(+0.0*Rdsi+T0_Vdi_si*0.0+0.0*Rdsi_Vdi_si+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Vge_di=(+(+T0_Vdi_si_Vge_di*Rdsi+T0_Vdi_si*Rdsi_Vge_di+T0_Vge_di*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Vge_e=(+(+T0_Vdi_si_Vge_e*Rdsi+T0_Vdi_si*Rdsi_Vge_e+T0_Vge_e*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Ve_si=(+(+T0_Vdi_si_Ve_si*Rdsi+T0_Vdi_si*Rdsi_Ve_si+T0_Ve_si*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Ve_di=(+(+T0_Vdi_si_Ve_di*Rdsi+T0_Vdi_si*Rdsi_Ve_di+T0_Ve_di*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Vge_si=(+(+T0_Vdi_si_Vge_si*Rdsi+T0_Vdi_si*Rdsi_Vge_si+T0_Vge_si*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Vdi_si=(+(+T0_Vdi_si_Vdi_si*Rdsi+T0_Vdi_si*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Vdi_si_Tempt_GND=(+(+T0_Vdi_si_Tempt_GND*Rdsi+T0_Vdi_si*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Vdi_si+T0*Rdsi_Vdi_si_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
T1_Tempt_GND=((T0_Tempt_GND*Rdsi)+(T0*Rdsi_Tempt_GND));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+(+0.0*Rdsi+T0_Tempt_GND*0.0+0.0*Rdsi_Tempt_GND+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Vsi_s=(+(+0.0*Rdsi+T0_Tempt_GND*0.0+0.0*Rdsi_Tempt_GND+T0*0.0)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Vge_di=(+(+T0_Tempt_GND_Vge_di*Rdsi+T0_Tempt_GND*Rdsi_Vge_di+T0_Vge_di*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Vge_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Vge_e=(+(+T0_Tempt_GND_Vge_e*Rdsi+T0_Tempt_GND*Rdsi_Vge_e+T0_Vge_e*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Vge_e)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Ve_si=(+(+T0_Tempt_GND_Ve_si*Rdsi+T0_Tempt_GND*Rdsi_Ve_si+T0_Ve_si*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Ve_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Ve_di=(+(+T0_Tempt_GND_Ve_di*Rdsi+T0_Tempt_GND*Rdsi_Ve_di+T0_Ve_di*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Ve_di)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Vge_si=(+(+T0_Tempt_GND_Vge_si*Rdsi+T0_Tempt_GND*Rdsi_Vge_si+T0_Vge_si*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Vge_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Vdi_si=(+(+T0_Tempt_GND_Vdi_si*Rdsi+T0_Tempt_GND*Rdsi_Vdi_si+T0_Vdi_si*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Vdi_si)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
  T1_Tempt_GND_Tempt_GND=(+(+T0_Tempt_GND_Tempt_GND*Rdsi+T0_Tempt_GND*Rdsi_Tempt_GND+T0_Tempt_GND*Rdsi_Tempt_GND+T0*Rdsi_Tempt_GND_Tempt_GND)+(+0.0*Leff+0.0*0.0+0.0*0.0+Leff*0.0));
#endif
#endif
T1=((T0*Rdsi)+(Leff*Leff));
EXIT_IF_ISNAN(((T0*Rdsi)+(Leff*Leff)))
#if defined(_DERIVATE) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND)V(di,d)V(si,s) ddxprobe= */
Gtnoi_Vge_di=((T0_Vge_di*T1-T0*T1_Vge_di)/T1/T1)*NTNOI_i;
Gtnoi_Vge_e=((T0_Vge_e*T1-T0*T1_Vge_e)/T1/T1)*NTNOI_i;
Gtnoi_Ve_si=((T0_Ve_si*T1-T0*T1_Ve_si)/T1/T1)*NTNOI_i;
Gtnoi_Ve_di=((T0_Ve_di*T1-T0*T1_Ve_di)/T1/T1)*NTNOI_i;
Gtnoi_Vge_si=((T0_Vge_si*T1-T0*T1_Vge_si)/T1/T1)*NTNOI_i;
Gtnoi_Vdi_si=((T0_Vdi_si*T1-T0*T1_Vdi_si)/T1/T1)*NTNOI_i;
Gtnoi_Tempt_GND=((T0_Tempt_GND*T1-T0*T1_Tempt_GND)/T1/T1)*NTNOI_i;
Gtnoi_Vdi_d=(-T0*T1_Vdi_d/T1/T1)*NTNOI_i;
Gtnoi_Vsi_s=(-T0*T1_Vsi_s/T1/T1)*NTNOI_i;
#endif
Gtnoi=((T0/T1)*NTNOI_i);
EXIT_IF_ISNAN(((T0/T1)*NTNOI_i))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)V(di,d)V(si,s) ddxprobe= */
sid_Tempt_GND=(((4.0*Vtm_Tempt_GND)*1.60219e-19*Gtnoi)+(((4.0*Vtm)*1.60219e-19)*Gtnoi_Tempt_GND));
sid_Vge_di=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vge_di);
sid_Vge_e=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vge_e);
sid_Ve_si=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Ve_si);
sid_Ve_di=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Ve_di);
sid_Vge_si=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vge_si);
sid_Vdi_si=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vdi_si);
sid_Vdi_d=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vdi_d);
sid_Vsi_s=(((4.0*Vtm)*1.60219e-19)*Gtnoi_Vsi_s);
#endif
sid=(((4.0*Vtm)*1.60219e-19)*Gtnoi);
EXIT_IF_ISNAN((((4.0*Vtm)*1.60219e-19)*Gtnoi))
}
else
/* CASE ITEM */
if
(((pModel->TNOIMOD)==(1)))
{
Abulk=1.0;
EXIT_IF_ISNAN(1.0)
#if defined(_DERIVATEFORDDX) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
Vgst2Vtm_Vdi_si=((KSATIV_a_Vdi_si*(qis+(2.0*Vtm)))+(KSATIV_a*qis_Vdi_si));
#if defined(_DERIVATE2)
  Vgst2Vtm_Vdi_si_Vdi_si=(+KSATIV_a_Vdi_si_Vdi_si*(qis+(2.0*Vtm))+KSATIV_a_Vdi_si*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vdi_si_Ve_si=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Vdi_si*(qis_Ve_si+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vdi_si_Ve_di=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Vdi_si*(qis_Ve_di+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vdi_si_Vge_si=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Vdi_si*(qis_Vge_si+(0.0))+0.0*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vdi_si_Tempt_GND=(+KSATIV_a_Vdi_si_Tempt_GND*(qis+(2.0*Vtm))+KSATIV_a_Vdi_si*(qis_Tempt_GND+((2.0*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Vdi_si+KSATIV_a*(+qis_Vdi_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0)));
#endif
Vgst2Vtm_Ve_si=(KSATIV_a*qis_Ve_si);
#if defined(_DERIVATE2)
  Vgst2Vtm_Ve_si_Vdi_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_si_Ve_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_si_Ve_di=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_si_Vge_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_si_Tempt_GND=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Tempt_GND+((2.0*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Ve_si+KSATIV_a*(+qis_Ve_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0)));
#endif
Vgst2Vtm_Ve_di=(KSATIV_a*qis_Ve_di);
#if defined(_DERIVATE2)
  Vgst2Vtm_Ve_di_Vdi_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_di_Ve_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_di_Ve_di=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_di_Vge_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Ve_di_Tempt_GND=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Tempt_GND+((2.0*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Ve_di+KSATIV_a*(+qis_Ve_di_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0)));
#endif
Vgst2Vtm_Vge_si=(KSATIV_a*qis_Vge_si);
#if defined(_DERIVATE2)
  Vgst2Vtm_Vge_si_Vdi_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vge_si_Ve_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_si+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vge_si_Ve_di=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Ve_di+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vge_si_Vge_si=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Vge_si+(0.0))+0.0*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*0.0+2.0*0.0)));
  Vgst2Vtm_Vge_si_Tempt_GND=(+0.0*(qis+(2.0*Vtm))+0.0*(qis_Tempt_GND+((2.0*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*qis_Vge_si+KSATIV_a*(+qis_Vge_si_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*0.0+2.0*0.0)));
#endif
Vgst2Vtm_Tempt_GND=((KSATIV_a_Tempt_GND*(qis+(2.0*Vtm)))+(KSATIV_a*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))));
#if defined(_DERIVATE2)
  Vgst2Vtm_Tempt_GND_Vdi_si=(+KSATIV_a_Tempt_GND_Vdi_si*(qis+(2.0*Vtm))+KSATIV_a_Tempt_GND*(qis_Vdi_si+(0.0))+KSATIV_a_Vdi_si*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Vdi_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0)));
  Vgst2Vtm_Tempt_GND_Ve_si=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Tempt_GND*(qis_Ve_si+(0.0))+0.0*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Ve_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0)));
  Vgst2Vtm_Tempt_GND_Ve_di=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Tempt_GND*(qis_Ve_di+(0.0))+0.0*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Ve_di+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0)));
  Vgst2Vtm_Tempt_GND_Vge_si=(+0.0*(qis+(2.0*Vtm))+KSATIV_a_Tempt_GND*(qis_Vge_si+(0.0))+0.0*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Vge_si+(+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+2.0*0.0)));
  Vgst2Vtm_Tempt_GND_Tempt_GND=(+KSATIV_a_Tempt_GND_Tempt_GND*(qis+(2.0*Vtm))+KSATIV_a_Tempt_GND*(qis_Tempt_GND+((2.0*Vtm_Tempt_GND)))+KSATIV_a_Tempt_GND*(qis_Tempt_GND+(2.0*Vtm_Tempt_GND))+KSATIV_a*(+qis_Tempt_GND_Tempt_GND+(+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+2.0*Vtm_Tempt_GND_Tempt_GND)));
#endif
#endif
Vgst2Vtm=(KSATIV_a*(qis+(2.0*Vtm)));
EXIT_IF_ISNAN((KSATIV_a*(qis+(2.0*Vtm))))
#if defined(_DERIVATE) /* probe=V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
etaa_Vdi_si=(-((Vdseff_Vdi_si*Abulk*Vgst2Vtm-(Vdseff*Abulk)*Vgst2Vtm_Vdi_si)/Vgst2Vtm/Vgst2Vtm));
etaa_Ve_si=(-((Vdseff_Ve_si*Abulk*Vgst2Vtm-(Vdseff*Abulk)*Vgst2Vtm_Ve_si)/Vgst2Vtm/Vgst2Vtm));
etaa_Ve_di=(-((Vdseff_Ve_di*Abulk*Vgst2Vtm-(Vdseff*Abulk)*Vgst2Vtm_Ve_di)/Vgst2Vtm/Vgst2Vtm));
etaa_Vge_si=(-((Vdseff_Vge_si*Abulk*Vgst2Vtm-(Vdseff*Abulk)*Vgst2Vtm_Vge_si)/Vgst2Vtm/Vgst2Vtm));
etaa_Tempt_GND=(-((Vdseff_Tempt_GND*Abulk*Vgst2Vtm-(Vdseff*Abulk)*Vgst2Vtm_Tempt_GND)/Vgst2Vtm/Vgst2Vtm));
#endif
etaa=(1.0-((Vdseff*Abulk)/Vgst2Vtm));
EXIT_IF_ISNAN((1.0-((Vdseff*Abulk)/Vgst2Vtm)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T0_Vge_di=0.0;
#if defined(_DERIVATE2)
  T0_Vge_di_Vge_di=0.0;
  T0_Vge_di_Vge_e=0.0;
  T0_Vge_di_Ve_si=0.0;
  T0_Vge_di_Ve_di=0.0;
  T0_Vge_di_Vge_si=0.0;
  T0_Vge_di_Vdi_si=0.0;
  T0_Vge_di_Tempt_GND=0.0;
#endif
T0_Vge_e=0.0;
#if defined(_DERIVATE2)
  T0_Vge_e_Vge_di=0.0;
  T0_Vge_e_Vge_e=0.0;
  T0_Vge_e_Ve_si=0.0;
  T0_Vge_e_Ve_di=0.0;
  T0_Vge_e_Vge_si=0.0;
  T0_Vge_e_Vdi_si=0.0;
  T0_Vge_e_Tempt_GND=0.0;
#endif
T0_Ve_si=(-etaa_Ve_si);
#if defined(_DERIVATE2)
  T0_Ve_si_Vge_di=(+0.0-0.0);
  T0_Ve_si_Vge_e=(+0.0-0.0);
  T0_Ve_si_Ve_si=(+0.0-etaa_Ve_si_Ve_si);
  T0_Ve_si_Ve_di=(+0.0-etaa_Ve_si_Ve_di);
  T0_Ve_si_Vge_si=(+0.0-etaa_Ve_si_Vge_si);
  T0_Ve_si_Vdi_si=(+0.0-etaa_Ve_si_Vdi_si);
  T0_Ve_si_Tempt_GND=(+0.0-etaa_Ve_si_Tempt_GND);
#endif
T0_Ve_di=(-etaa_Ve_di);
#if defined(_DERIVATE2)
  T0_Ve_di_Vge_di=(+0.0-0.0);
  T0_Ve_di_Vge_e=(+0.0-0.0);
  T0_Ve_di_Ve_si=(+0.0-etaa_Ve_di_Ve_si);
  T0_Ve_di_Ve_di=(+0.0-etaa_Ve_di_Ve_di);
  T0_Ve_di_Vge_si=(+0.0-etaa_Ve_di_Vge_si);
  T0_Ve_di_Vdi_si=(+0.0-etaa_Ve_di_Vdi_si);
  T0_Ve_di_Tempt_GND=(+0.0-etaa_Ve_di_Tempt_GND);
#endif
T0_Vge_si=(-etaa_Vge_si);
#if defined(_DERIVATE2)
  T0_Vge_si_Vge_di=(+0.0-0.0);
  T0_Vge_si_Vge_e=(+0.0-0.0);
  T0_Vge_si_Ve_si=(+0.0-etaa_Vge_si_Ve_si);
  T0_Vge_si_Ve_di=(+0.0-etaa_Vge_si_Ve_di);
  T0_Vge_si_Vge_si=(+0.0-etaa_Vge_si_Vge_si);
  T0_Vge_si_Vdi_si=(+0.0-etaa_Vge_si_Vdi_si);
  T0_Vge_si_Tempt_GND=(+0.0-etaa_Vge_si_Tempt_GND);
#endif
T0_Vdi_si=(-etaa_Vdi_si);
#if defined(_DERIVATE2)
  T0_Vdi_si_Vge_di=(+0.0-0.0);
  T0_Vdi_si_Vge_e=(+0.0-0.0);
  T0_Vdi_si_Ve_si=(+0.0-etaa_Vdi_si_Ve_si);
  T0_Vdi_si_Ve_di=(+0.0-etaa_Vdi_si_Ve_di);
  T0_Vdi_si_Vge_si=(+0.0-etaa_Vdi_si_Vge_si);
  T0_Vdi_si_Vdi_si=(+0.0-etaa_Vdi_si_Vdi_si);
  T0_Vdi_si_Tempt_GND=(+0.0-etaa_Vdi_si_Tempt_GND);
#endif
T0_Tempt_GND=(-etaa_Tempt_GND);
#if defined(_DERIVATE2)
  T0_Tempt_GND_Vge_di=(+0.0-0.0);
  T0_Tempt_GND_Vge_e=(+0.0-0.0);
  T0_Tempt_GND_Ve_si=(+0.0-etaa_Tempt_GND_Ve_si);
  T0_Tempt_GND_Ve_di=(+0.0-etaa_Tempt_GND_Ve_di);
  T0_Tempt_GND_Vge_si=(+0.0-etaa_Tempt_GND_Vge_si);
  T0_Tempt_GND_Vdi_si=(+0.0-etaa_Tempt_GND_Vdi_si);
  T0_Tempt_GND_Tempt_GND=(+0.0-etaa_Tempt_GND_Tempt_GND);
#endif
#endif
T0=(1.0-etaa);
EXIT_IF_ISNAN((1.0-etaa))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=etaa_Ve_si;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=(+0.0+0.0);
  T1_Ve_si_Vsi_s=(+0.0+0.0);
  T1_Ve_si_Vge_di=(+0.0+0.0);
  T1_Ve_si_Vge_e=(+0.0+0.0);
  T1_Ve_si_Ve_si=(+0.0+etaa_Ve_si_Ve_si);
  T1_Ve_si_Ve_di=(+0.0+etaa_Ve_si_Ve_di);
  T1_Ve_si_Vge_si=(+0.0+etaa_Ve_si_Vge_si);
  T1_Ve_si_Vdi_si=(+0.0+etaa_Ve_si_Vdi_si);
  T1_Ve_si_Tempt_GND=(+0.0+etaa_Ve_si_Tempt_GND);
#endif
T1_Ve_di=etaa_Ve_di;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=(+0.0+0.0);
  T1_Ve_di_Vsi_s=(+0.0+0.0);
  T1_Ve_di_Vge_di=(+0.0+0.0);
  T1_Ve_di_Vge_e=(+0.0+0.0);
  T1_Ve_di_Ve_si=(+0.0+etaa_Ve_di_Ve_si);
  T1_Ve_di_Ve_di=(+0.0+etaa_Ve_di_Ve_di);
  T1_Ve_di_Vge_si=(+0.0+etaa_Ve_di_Vge_si);
  T1_Ve_di_Vdi_si=(+0.0+etaa_Ve_di_Vdi_si);
  T1_Ve_di_Tempt_GND=(+0.0+etaa_Ve_di_Tempt_GND);
#endif
T1_Vge_si=etaa_Vge_si;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=(+0.0+0.0);
  T1_Vge_si_Vsi_s=(+0.0+0.0);
  T1_Vge_si_Vge_di=(+0.0+0.0);
  T1_Vge_si_Vge_e=(+0.0+0.0);
  T1_Vge_si_Ve_si=(+0.0+etaa_Vge_si_Ve_si);
  T1_Vge_si_Ve_di=(+0.0+etaa_Vge_si_Ve_di);
  T1_Vge_si_Vge_si=(+0.0+etaa_Vge_si_Vge_si);
  T1_Vge_si_Vdi_si=(+0.0+etaa_Vge_si_Vdi_si);
  T1_Vge_si_Tempt_GND=(+0.0+etaa_Vge_si_Tempt_GND);
#endif
T1_Vdi_si=etaa_Vdi_si;
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0+0.0);
  T1_Vdi_si_Vsi_s=(+0.0+0.0);
  T1_Vdi_si_Vge_di=(+0.0+0.0);
  T1_Vdi_si_Vge_e=(+0.0+0.0);
  T1_Vdi_si_Ve_si=(+0.0+etaa_Vdi_si_Ve_si);
  T1_Vdi_si_Ve_di=(+0.0+etaa_Vdi_si_Ve_di);
  T1_Vdi_si_Vge_si=(+0.0+etaa_Vdi_si_Vge_si);
  T1_Vdi_si_Vdi_si=(+0.0+etaa_Vdi_si_Vdi_si);
  T1_Vdi_si_Tempt_GND=(+0.0+etaa_Vdi_si_Tempt_GND);
#endif
T1_Tempt_GND=etaa_Tempt_GND;
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0+0.0);
  T1_Tempt_GND_Vsi_s=(+0.0+0.0);
  T1_Tempt_GND_Vge_di=(+0.0+0.0);
  T1_Tempt_GND_Vge_e=(+0.0+0.0);
  T1_Tempt_GND_Ve_si=(+0.0+etaa_Tempt_GND_Ve_si);
  T1_Tempt_GND_Ve_di=(+0.0+etaa_Tempt_GND_Ve_di);
  T1_Tempt_GND_Vge_si=(+0.0+etaa_Tempt_GND_Vge_si);
  T1_Tempt_GND_Vdi_si=(+0.0+etaa_Tempt_GND_Vdi_si);
  T1_Tempt_GND_Tempt_GND=(+0.0+etaa_Tempt_GND_Tempt_GND);
#endif
#endif
T1=(1.0+etaa);
EXIT_IF_ISNAN((1.0+etaa))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=T1_Vdi_d;
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=(+T1_Vdi_d_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Vsi_s=(+T1_Vdi_d_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Vge_di=(+T1_Vdi_d_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Vge_e=(+T1_Vdi_d_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Vge_si=(+T1_Vdi_d_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Ve_si=(+T1_Vdi_d_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Ve_di=(+T1_Vdi_d_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Vdi_si=(+T1_Vdi_d_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_d_Tempt_GND=(+T1_Vdi_d_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Vsi_s=T1_Vsi_s;
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=(+T1_Vsi_s_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Vsi_s=(+T1_Vsi_s_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Vge_di=(+T1_Vsi_s_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Vge_e=(+T1_Vsi_s_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Vge_si=(+T1_Vsi_s_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Ve_si=(+T1_Vsi_s_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Ve_di=(+T1_Vsi_s_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Vdi_si=(+T1_Vsi_s_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vsi_s_Tempt_GND=(+T1_Vsi_s_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Vge_di=T1_Vge_di;
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+T1_Vge_di_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Vsi_s=(+T1_Vge_di_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Vge_di=(+T1_Vge_di_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Vge_e=(+T1_Vge_di_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Vge_si=(+T1_Vge_di_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Ve_si=(+T1_Vge_di_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Ve_di=(+T1_Vge_di_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Vdi_si=(+T1_Vge_di_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_di_Tempt_GND=(+T1_Vge_di_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Vge_e=T1_Vge_e;
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+T1_Vge_e_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Vsi_s=(+T1_Vge_e_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Vge_di=(+T1_Vge_e_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Vge_e=(+T1_Vge_e_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Vge_si=(+T1_Vge_e_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Ve_si=(+T1_Vge_e_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Ve_di=(+T1_Vge_e_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Vdi_si=(+T1_Vge_e_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_e_Tempt_GND=(+T1_Vge_e_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*0.0+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*0.0*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Vge_si=(T1_Vge_si+(-((2.0*Abulk)*Vtm)*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)));
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+T1_Vge_si_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Vsi_s=(+T1_Vge_si_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Vge_di=(+T1_Vge_si_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Vge_e=(+T1_Vge_si_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Vge_si=(+T1_Vge_si_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+qia_Vge_si_Vge_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Ve_si=(+T1_Vge_si_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+qia_Vge_si_Ve_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Ve_di=(+T1_Vge_si_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+qia_Vge_si_Ve_di+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Vdi_si=(+T1_Vge_si_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*qia_Vge_si+((2.0*Abulk)*Vtm)*(+qia_Vge_si_Vdi_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vge_si_Tempt_GND=(+T1_Vge_si_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*qia_Vge_si+((2.0*Abulk)*Vtm)*(+qia_Vge_si_Tempt_GND+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vge_si*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Ve_si=(T1_Ve_si+(-((2.0*Abulk)*Vtm)*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)));
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+T1_Ve_si_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Vsi_s=(+T1_Ve_si_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Vge_di=(+T1_Ve_si_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Vge_e=(+T1_Ve_si_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Vge_si=(+T1_Ve_si_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+qia_Ve_si_Vge_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Ve_si=(+T1_Ve_si_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+qia_Ve_si_Ve_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Ve_di=(+T1_Ve_si_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+qia_Ve_si_Ve_di+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Vdi_si=(+T1_Ve_si_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*qia_Ve_si+((2.0*Abulk)*Vtm)*(+qia_Ve_si_Vdi_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_si_Tempt_GND=(+T1_Ve_si_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*qia_Ve_si+((2.0*Abulk)*Vtm)*(+qia_Ve_si_Tempt_GND+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_si*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Ve_di=(T1_Ve_di+(-((2.0*Abulk)*Vtm)*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)));
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+T1_Ve_di_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Vsi_s=(+T1_Ve_di_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Vge_di=(+T1_Ve_di_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Vge_e=(+T1_Ve_di_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Vge_si=(+T1_Ve_di_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+qia_Ve_di_Vge_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Ve_si=(+T1_Ve_di_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+qia_Ve_di_Ve_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Ve_di=(+T1_Ve_di_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+qia_Ve_di_Ve_di+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Vdi_si=(+T1_Ve_di_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*qia_Ve_di+((2.0*Abulk)*Vtm)*(+qia_Ve_di_Vdi_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Ve_di_Tempt_GND=(+T1_Ve_di_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*qia_Ve_di+((2.0*Abulk)*Vtm)*(+qia_Ve_di_Tempt_GND+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Ve_di*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Vdi_si=(T1_Vdi_si+(-((2.0*Abulk)*Vtm)*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)));
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+T1_Vdi_si_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Vsi_s=(+T1_Vdi_si_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Vge_di=(+T1_Vdi_si_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Vge_e=(+T1_Vdi_si_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*0.0+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Vge_si=(+T1_Vdi_si_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vge_si+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+qia_Vdi_si_Vge_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Ve_si=(+T1_Vdi_si_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_si+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+qia_Vdi_si_Ve_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Ve_di=(+T1_Vdi_si_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Ve_di+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+qia_Vdi_si_Ve_di+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Vdi_si=(+T1_Vdi_si_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Vdi_si+((0.0)*Vtm)*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+qia_Vdi_si_Vdi_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Vdi_si_Tempt_GND=(+T1_Vdi_si_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*0.0+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(0.0*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*qia_Vdi_si+((2.0*Abulk)*Vtm)*(+qia_Vdi_si_Tempt_GND+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Vdi_si*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
T2_Tempt_GND=(T1_Tempt_GND+((((2.0*Abulk)*Vtm_Tempt_GND)*(qia+1.0e-10)-((2.0*Abulk)*Vtm)*qia_Tempt_GND)/(qia+1.0e-10)/(qia+1.0e-10)));
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+T1_Tempt_GND_Vdi_d+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*0.0+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Vsi_s=(+T1_Tempt_GND_Vsi_s+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*0.0+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Vge_di=(+T1_Tempt_GND_Vge_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*0.0+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Vge_e=(+T1_Tempt_GND_Vge_e+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*0.0+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+0.0+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*0.0/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Vge_si=(+T1_Tempt_GND_Vge_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*qia_Vge_si+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+qia_Tempt_GND_Vge_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*qia_Vge_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Ve_si=(+T1_Tempt_GND_Ve_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*qia_Ve_si+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+qia_Tempt_GND_Ve_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*qia_Ve_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Ve_di=(+T1_Tempt_GND_Ve_di+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*qia_Ve_di+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+qia_Tempt_GND_Ve_di+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*qia_Ve_di/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Vdi_si=(+T1_Tempt_GND_Vdi_si+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*0.0+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*0.0)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*qia_Vdi_si+((0.0)*Vtm)*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+qia_Tempt_GND_Vdi_si+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*qia_Vdi_si/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
  T2_Tempt_GND_Tempt_GND=(+T1_Tempt_GND_Tempt_GND+((+(+0.0*Abulk+0.0*0.0+0.0*0.0+2.0*0.0)*Vtm+0.0*Vtm_Tempt_GND+(0.0)*Vtm_Tempt_GND+(2.0*Abulk)*Vtm_Tempt_GND_Tempt_GND)/(qia+1.0e-10)-(((2.0*Abulk)*Vtm_Tempt_GND)*qia_Tempt_GND+((((0.0)*Vtm)+((2.0*Abulk)*Vtm_Tempt_GND)))*qia_Tempt_GND+((2.0*Abulk)*Vtm)*(+qia_Tempt_GND_Tempt_GND+0.0))/(qia+1.0e-10)/(qia+1.0e-10)+2*((2.0*Abulk)*Vtm)*qia_Tempt_GND*qia_Tempt_GND/(qia+1.0e-10)/(qia+1.0e-10)/(qia+1.0e-10)));
#endif
#endif
T2=(T1+(((2.0*Abulk)*Vtm)/(qia+1.0e-10)));
EXIT_IF_ISNAN((T1+(((2.0*Abulk)*Vtm)/(qia+1.0e-10))))
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=((T2_Vdi_d*T2)+(T2*T2_Vdi_d));
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=(+T2_Vdi_d_Vdi_d*T2+T2_Vdi_d*T2_Vdi_d+T2_Vdi_d*T2_Vdi_d+T2*T2_Vdi_d_Vdi_d);
  T3_Vdi_d_Vsi_s=(+T2_Vdi_d_Vsi_s*T2+T2_Vdi_d*T2_Vsi_s+T2_Vsi_s*T2_Vdi_d+T2*T2_Vdi_d_Vsi_s);
  T3_Vdi_d_Vge_di=(+T2_Vdi_d_Vge_di*T2+T2_Vdi_d*T2_Vge_di+T2_Vge_di*T2_Vdi_d+T2*T2_Vdi_d_Vge_di);
  T3_Vdi_d_Vge_e=(+T2_Vdi_d_Vge_e*T2+T2_Vdi_d*T2_Vge_e+T2_Vge_e*T2_Vdi_d+T2*T2_Vdi_d_Vge_e);
  T3_Vdi_d_Vdi_si=(+T2_Vdi_d_Vdi_si*T2+T2_Vdi_d*T2_Vdi_si+T2_Vdi_si*T2_Vdi_d+T2*T2_Vdi_d_Vdi_si);
  T3_Vdi_d_Ve_si=(+T2_Vdi_d_Ve_si*T2+T2_Vdi_d*T2_Ve_si+T2_Ve_si*T2_Vdi_d+T2*T2_Vdi_d_Ve_si);
  T3_Vdi_d_Ve_di=(+T2_Vdi_d_Ve_di*T2+T2_Vdi_d*T2_Ve_di+T2_Ve_di*T2_Vdi_d+T2*T2_Vdi_d_Ve_di);
  T3_Vdi_d_Vge_si=(+T2_Vdi_d_Vge_si*T2+T2_Vdi_d*T2_Vge_si+T2_Vge_si*T2_Vdi_d+T2*T2_Vdi_d_Vge_si);
  T3_Vdi_d_Tempt_GND=(+T2_Vdi_d_Tempt_GND*T2+T2_Vdi_d*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_d+T2*T2_Vdi_d_Tempt_GND);
#endif
T3_Vsi_s=((T2_Vsi_s*T2)+(T2*T2_Vsi_s));
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=(+T2_Vsi_s_Vdi_d*T2+T2_Vsi_s*T2_Vdi_d+T2_Vdi_d*T2_Vsi_s+T2*T2_Vsi_s_Vdi_d);
  T3_Vsi_s_Vsi_s=(+T2_Vsi_s_Vsi_s*T2+T2_Vsi_s*T2_Vsi_s+T2_Vsi_s*T2_Vsi_s+T2*T2_Vsi_s_Vsi_s);
  T3_Vsi_s_Vge_di=(+T2_Vsi_s_Vge_di*T2+T2_Vsi_s*T2_Vge_di+T2_Vge_di*T2_Vsi_s+T2*T2_Vsi_s_Vge_di);
  T3_Vsi_s_Vge_e=(+T2_Vsi_s_Vge_e*T2+T2_Vsi_s*T2_Vge_e+T2_Vge_e*T2_Vsi_s+T2*T2_Vsi_s_Vge_e);
  T3_Vsi_s_Vdi_si=(+T2_Vsi_s_Vdi_si*T2+T2_Vsi_s*T2_Vdi_si+T2_Vdi_si*T2_Vsi_s+T2*T2_Vsi_s_Vdi_si);
  T3_Vsi_s_Ve_si=(+T2_Vsi_s_Ve_si*T2+T2_Vsi_s*T2_Ve_si+T2_Ve_si*T2_Vsi_s+T2*T2_Vsi_s_Ve_si);
  T3_Vsi_s_Ve_di=(+T2_Vsi_s_Ve_di*T2+T2_Vsi_s*T2_Ve_di+T2_Ve_di*T2_Vsi_s+T2*T2_Vsi_s_Ve_di);
  T3_Vsi_s_Vge_si=(+T2_Vsi_s_Vge_si*T2+T2_Vsi_s*T2_Vge_si+T2_Vge_si*T2_Vsi_s+T2*T2_Vsi_s_Vge_si);
  T3_Vsi_s_Tempt_GND=(+T2_Vsi_s_Tempt_GND*T2+T2_Vsi_s*T2_Tempt_GND+T2_Tempt_GND*T2_Vsi_s+T2*T2_Vsi_s_Tempt_GND);
#endif
T3_Vge_di=((T2_Vge_di*T2)+(T2*T2_Vge_di));
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=(+T2_Vge_di_Vdi_d*T2+T2_Vge_di*T2_Vdi_d+T2_Vdi_d*T2_Vge_di+T2*T2_Vge_di_Vdi_d);
  T3_Vge_di_Vsi_s=(+T2_Vge_di_Vsi_s*T2+T2_Vge_di*T2_Vsi_s+T2_Vsi_s*T2_Vge_di+T2*T2_Vge_di_Vsi_s);
  T3_Vge_di_Vge_di=(+T2_Vge_di_Vge_di*T2+T2_Vge_di*T2_Vge_di+T2_Vge_di*T2_Vge_di+T2*T2_Vge_di_Vge_di);
  T3_Vge_di_Vge_e=(+T2_Vge_di_Vge_e*T2+T2_Vge_di*T2_Vge_e+T2_Vge_e*T2_Vge_di+T2*T2_Vge_di_Vge_e);
  T3_Vge_di_Vdi_si=(+T2_Vge_di_Vdi_si*T2+T2_Vge_di*T2_Vdi_si+T2_Vdi_si*T2_Vge_di+T2*T2_Vge_di_Vdi_si);
  T3_Vge_di_Ve_si=(+T2_Vge_di_Ve_si*T2+T2_Vge_di*T2_Ve_si+T2_Ve_si*T2_Vge_di+T2*T2_Vge_di_Ve_si);
  T3_Vge_di_Ve_di=(+T2_Vge_di_Ve_di*T2+T2_Vge_di*T2_Ve_di+T2_Ve_di*T2_Vge_di+T2*T2_Vge_di_Ve_di);
  T3_Vge_di_Vge_si=(+T2_Vge_di_Vge_si*T2+T2_Vge_di*T2_Vge_si+T2_Vge_si*T2_Vge_di+T2*T2_Vge_di_Vge_si);
  T3_Vge_di_Tempt_GND=(+T2_Vge_di_Tempt_GND*T2+T2_Vge_di*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_di+T2*T2_Vge_di_Tempt_GND);
#endif
T3_Vge_e=((T2_Vge_e*T2)+(T2*T2_Vge_e));
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=(+T2_Vge_e_Vdi_d*T2+T2_Vge_e*T2_Vdi_d+T2_Vdi_d*T2_Vge_e+T2*T2_Vge_e_Vdi_d);
  T3_Vge_e_Vsi_s=(+T2_Vge_e_Vsi_s*T2+T2_Vge_e*T2_Vsi_s+T2_Vsi_s*T2_Vge_e+T2*T2_Vge_e_Vsi_s);
  T3_Vge_e_Vge_di=(+T2_Vge_e_Vge_di*T2+T2_Vge_e*T2_Vge_di+T2_Vge_di*T2_Vge_e+T2*T2_Vge_e_Vge_di);
  T3_Vge_e_Vge_e=(+T2_Vge_e_Vge_e*T2+T2_Vge_e*T2_Vge_e+T2_Vge_e*T2_Vge_e+T2*T2_Vge_e_Vge_e);
  T3_Vge_e_Vdi_si=(+T2_Vge_e_Vdi_si*T2+T2_Vge_e*T2_Vdi_si+T2_Vdi_si*T2_Vge_e+T2*T2_Vge_e_Vdi_si);
  T3_Vge_e_Ve_si=(+T2_Vge_e_Ve_si*T2+T2_Vge_e*T2_Ve_si+T2_Ve_si*T2_Vge_e+T2*T2_Vge_e_Ve_si);
  T3_Vge_e_Ve_di=(+T2_Vge_e_Ve_di*T2+T2_Vge_e*T2_Ve_di+T2_Ve_di*T2_Vge_e+T2*T2_Vge_e_Ve_di);
  T3_Vge_e_Vge_si=(+T2_Vge_e_Vge_si*T2+T2_Vge_e*T2_Vge_si+T2_Vge_si*T2_Vge_e+T2*T2_Vge_e_Vge_si);
  T3_Vge_e_Tempt_GND=(+T2_Vge_e_Tempt_GND*T2+T2_Vge_e*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_e+T2*T2_Vge_e_Tempt_GND);
#endif
T3_Vdi_si=((T2_Vdi_si*T2)+(T2*T2_Vdi_si));
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=(+T2_Vdi_si_Vdi_d*T2+T2_Vdi_si*T2_Vdi_d+T2_Vdi_d*T2_Vdi_si+T2*T2_Vdi_si_Vdi_d);
  T3_Vdi_si_Vsi_s=(+T2_Vdi_si_Vsi_s*T2+T2_Vdi_si*T2_Vsi_s+T2_Vsi_s*T2_Vdi_si+T2*T2_Vdi_si_Vsi_s);
  T3_Vdi_si_Vge_di=(+T2_Vdi_si_Vge_di*T2+T2_Vdi_si*T2_Vge_di+T2_Vge_di*T2_Vdi_si+T2*T2_Vdi_si_Vge_di);
  T3_Vdi_si_Vge_e=(+T2_Vdi_si_Vge_e*T2+T2_Vdi_si*T2_Vge_e+T2_Vge_e*T2_Vdi_si+T2*T2_Vdi_si_Vge_e);
  T3_Vdi_si_Vdi_si=(+T2_Vdi_si_Vdi_si*T2+T2_Vdi_si*T2_Vdi_si+T2_Vdi_si*T2_Vdi_si+T2*T2_Vdi_si_Vdi_si);
  T3_Vdi_si_Ve_si=(+T2_Vdi_si_Ve_si*T2+T2_Vdi_si*T2_Ve_si+T2_Ve_si*T2_Vdi_si+T2*T2_Vdi_si_Ve_si);
  T3_Vdi_si_Ve_di=(+T2_Vdi_si_Ve_di*T2+T2_Vdi_si*T2_Ve_di+T2_Ve_di*T2_Vdi_si+T2*T2_Vdi_si_Ve_di);
  T3_Vdi_si_Vge_si=(+T2_Vdi_si_Vge_si*T2+T2_Vdi_si*T2_Vge_si+T2_Vge_si*T2_Vdi_si+T2*T2_Vdi_si_Vge_si);
  T3_Vdi_si_Tempt_GND=(+T2_Vdi_si_Tempt_GND*T2+T2_Vdi_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vdi_si+T2*T2_Vdi_si_Tempt_GND);
#endif
T3_Ve_si=((T2_Ve_si*T2)+(T2*T2_Ve_si));
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=(+T2_Ve_si_Vdi_d*T2+T2_Ve_si*T2_Vdi_d+T2_Vdi_d*T2_Ve_si+T2*T2_Ve_si_Vdi_d);
  T3_Ve_si_Vsi_s=(+T2_Ve_si_Vsi_s*T2+T2_Ve_si*T2_Vsi_s+T2_Vsi_s*T2_Ve_si+T2*T2_Ve_si_Vsi_s);
  T3_Ve_si_Vge_di=(+T2_Ve_si_Vge_di*T2+T2_Ve_si*T2_Vge_di+T2_Vge_di*T2_Ve_si+T2*T2_Ve_si_Vge_di);
  T3_Ve_si_Vge_e=(+T2_Ve_si_Vge_e*T2+T2_Ve_si*T2_Vge_e+T2_Vge_e*T2_Ve_si+T2*T2_Ve_si_Vge_e);
  T3_Ve_si_Vdi_si=(+T2_Ve_si_Vdi_si*T2+T2_Ve_si*T2_Vdi_si+T2_Vdi_si*T2_Ve_si+T2*T2_Ve_si_Vdi_si);
  T3_Ve_si_Ve_si=(+T2_Ve_si_Ve_si*T2+T2_Ve_si*T2_Ve_si+T2_Ve_si*T2_Ve_si+T2*T2_Ve_si_Ve_si);
  T3_Ve_si_Ve_di=(+T2_Ve_si_Ve_di*T2+T2_Ve_si*T2_Ve_di+T2_Ve_di*T2_Ve_si+T2*T2_Ve_si_Ve_di);
  T3_Ve_si_Vge_si=(+T2_Ve_si_Vge_si*T2+T2_Ve_si*T2_Vge_si+T2_Vge_si*T2_Ve_si+T2*T2_Ve_si_Vge_si);
  T3_Ve_si_Tempt_GND=(+T2_Ve_si_Tempt_GND*T2+T2_Ve_si*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_si+T2*T2_Ve_si_Tempt_GND);
#endif
T3_Ve_di=((T2_Ve_di*T2)+(T2*T2_Ve_di));
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=(+T2_Ve_di_Vdi_d*T2+T2_Ve_di*T2_Vdi_d+T2_Vdi_d*T2_Ve_di+T2*T2_Ve_di_Vdi_d);
  T3_Ve_di_Vsi_s=(+T2_Ve_di_Vsi_s*T2+T2_Ve_di*T2_Vsi_s+T2_Vsi_s*T2_Ve_di+T2*T2_Ve_di_Vsi_s);
  T3_Ve_di_Vge_di=(+T2_Ve_di_Vge_di*T2+T2_Ve_di*T2_Vge_di+T2_Vge_di*T2_Ve_di+T2*T2_Ve_di_Vge_di);
  T3_Ve_di_Vge_e=(+T2_Ve_di_Vge_e*T2+T2_Ve_di*T2_Vge_e+T2_Vge_e*T2_Ve_di+T2*T2_Ve_di_Vge_e);
  T3_Ve_di_Vdi_si=(+T2_Ve_di_Vdi_si*T2+T2_Ve_di*T2_Vdi_si+T2_Vdi_si*T2_Ve_di+T2*T2_Ve_di_Vdi_si);
  T3_Ve_di_Ve_si=(+T2_Ve_di_Ve_si*T2+T2_Ve_di*T2_Ve_si+T2_Ve_si*T2_Ve_di+T2*T2_Ve_di_Ve_si);
  T3_Ve_di_Ve_di=(+T2_Ve_di_Ve_di*T2+T2_Ve_di*T2_Ve_di+T2_Ve_di*T2_Ve_di+T2*T2_Ve_di_Ve_di);
  T3_Ve_di_Vge_si=(+T2_Ve_di_Vge_si*T2+T2_Ve_di*T2_Vge_si+T2_Vge_si*T2_Ve_di+T2*T2_Ve_di_Vge_si);
  T3_Ve_di_Tempt_GND=(+T2_Ve_di_Tempt_GND*T2+T2_Ve_di*T2_Tempt_GND+T2_Tempt_GND*T2_Ve_di+T2*T2_Ve_di_Tempt_GND);
#endif
T3_Vge_si=((T2_Vge_si*T2)+(T2*T2_Vge_si));
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=(+T2_Vge_si_Vdi_d*T2+T2_Vge_si*T2_Vdi_d+T2_Vdi_d*T2_Vge_si+T2*T2_Vge_si_Vdi_d);
  T3_Vge_si_Vsi_s=(+T2_Vge_si_Vsi_s*T2+T2_Vge_si*T2_Vsi_s+T2_Vsi_s*T2_Vge_si+T2*T2_Vge_si_Vsi_s);
  T3_Vge_si_Vge_di=(+T2_Vge_si_Vge_di*T2+T2_Vge_si*T2_Vge_di+T2_Vge_di*T2_Vge_si+T2*T2_Vge_si_Vge_di);
  T3_Vge_si_Vge_e=(+T2_Vge_si_Vge_e*T2+T2_Vge_si*T2_Vge_e+T2_Vge_e*T2_Vge_si+T2*T2_Vge_si_Vge_e);
  T3_Vge_si_Vdi_si=(+T2_Vge_si_Vdi_si*T2+T2_Vge_si*T2_Vdi_si+T2_Vdi_si*T2_Vge_si+T2*T2_Vge_si_Vdi_si);
  T3_Vge_si_Ve_si=(+T2_Vge_si_Ve_si*T2+T2_Vge_si*T2_Ve_si+T2_Ve_si*T2_Vge_si+T2*T2_Vge_si_Ve_si);
  T3_Vge_si_Ve_di=(+T2_Vge_si_Ve_di*T2+T2_Vge_si*T2_Ve_di+T2_Ve_di*T2_Vge_si+T2*T2_Vge_si_Ve_di);
  T3_Vge_si_Vge_si=(+T2_Vge_si_Vge_si*T2+T2_Vge_si*T2_Vge_si+T2_Vge_si*T2_Vge_si+T2*T2_Vge_si_Vge_si);
  T3_Vge_si_Tempt_GND=(+T2_Vge_si_Tempt_GND*T2+T2_Vge_si*T2_Tempt_GND+T2_Tempt_GND*T2_Vge_si+T2*T2_Vge_si_Tempt_GND);
#endif
T3_Tempt_GND=((T2_Tempt_GND*T2)+(T2*T2_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+T2_Tempt_GND_Vdi_d*T2+T2_Tempt_GND*T2_Vdi_d+T2_Vdi_d*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_d);
  T3_Tempt_GND_Vsi_s=(+T2_Tempt_GND_Vsi_s*T2+T2_Tempt_GND*T2_Vsi_s+T2_Vsi_s*T2_Tempt_GND+T2*T2_Tempt_GND_Vsi_s);
  T3_Tempt_GND_Vge_di=(+T2_Tempt_GND_Vge_di*T2+T2_Tempt_GND*T2_Vge_di+T2_Vge_di*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_di);
  T3_Tempt_GND_Vge_e=(+T2_Tempt_GND_Vge_e*T2+T2_Tempt_GND*T2_Vge_e+T2_Vge_e*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_e);
  T3_Tempt_GND_Vdi_si=(+T2_Tempt_GND_Vdi_si*T2+T2_Tempt_GND*T2_Vdi_si+T2_Vdi_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vdi_si);
  T3_Tempt_GND_Ve_si=(+T2_Tempt_GND_Ve_si*T2+T2_Tempt_GND*T2_Ve_si+T2_Ve_si*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_si);
  T3_Tempt_GND_Ve_di=(+T2_Tempt_GND_Ve_di*T2+T2_Tempt_GND*T2_Ve_di+T2_Ve_di*T2_Tempt_GND+T2*T2_Tempt_GND_Ve_di);
  T3_Tempt_GND_Vge_si=(+T2_Tempt_GND_Vge_si*T2+T2_Tempt_GND*T2_Vge_si+T2_Vge_si*T2_Tempt_GND+T2*T2_Tempt_GND_Vge_si);
  T3_Tempt_GND_Tempt_GND=(+T2_Tempt_GND_Tempt_GND*T2+T2_Tempt_GND*T2_Tempt_GND+T2_Tempt_GND*T2_Tempt_GND+T2*T2_Tempt_GND_Tempt_GND);
#endif
#endif
T3=(T2*T2);
EXIT_IF_ISNAN((T2*T2))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T4_Vge_di=((T0_Vge_di*T0)+(T0*T0_Vge_di));
#if defined(_DERIVATE2)
  T4_Vge_di_Vge_di=(+T0_Vge_di_Vge_di*T0+T0_Vge_di*T0_Vge_di+T0_Vge_di*T0_Vge_di+T0*T0_Vge_di_Vge_di);
  T4_Vge_di_Vge_e=(+T0_Vge_di_Vge_e*T0+T0_Vge_di*T0_Vge_e+T0_Vge_e*T0_Vge_di+T0*T0_Vge_di_Vge_e);
  T4_Vge_di_Vdi_si=(+T0_Vge_di_Vdi_si*T0+T0_Vge_di*T0_Vdi_si+T0_Vdi_si*T0_Vge_di+T0*T0_Vge_di_Vdi_si);
  T4_Vge_di_Ve_si=(+T0_Vge_di_Ve_si*T0+T0_Vge_di*T0_Ve_si+T0_Ve_si*T0_Vge_di+T0*T0_Vge_di_Ve_si);
  T4_Vge_di_Ve_di=(+T0_Vge_di_Ve_di*T0+T0_Vge_di*T0_Ve_di+T0_Ve_di*T0_Vge_di+T0*T0_Vge_di_Ve_di);
  T4_Vge_di_Vge_si=(+T0_Vge_di_Vge_si*T0+T0_Vge_di*T0_Vge_si+T0_Vge_si*T0_Vge_di+T0*T0_Vge_di_Vge_si);
  T4_Vge_di_Tempt_GND=(+T0_Vge_di_Tempt_GND*T0+T0_Vge_di*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_di+T0*T0_Vge_di_Tempt_GND);
#endif
T4_Vge_e=((T0_Vge_e*T0)+(T0*T0_Vge_e));
#if defined(_DERIVATE2)
  T4_Vge_e_Vge_di=(+T0_Vge_e_Vge_di*T0+T0_Vge_e*T0_Vge_di+T0_Vge_di*T0_Vge_e+T0*T0_Vge_e_Vge_di);
  T4_Vge_e_Vge_e=(+T0_Vge_e_Vge_e*T0+T0_Vge_e*T0_Vge_e+T0_Vge_e*T0_Vge_e+T0*T0_Vge_e_Vge_e);
  T4_Vge_e_Vdi_si=(+T0_Vge_e_Vdi_si*T0+T0_Vge_e*T0_Vdi_si+T0_Vdi_si*T0_Vge_e+T0*T0_Vge_e_Vdi_si);
  T4_Vge_e_Ve_si=(+T0_Vge_e_Ve_si*T0+T0_Vge_e*T0_Ve_si+T0_Ve_si*T0_Vge_e+T0*T0_Vge_e_Ve_si);
  T4_Vge_e_Ve_di=(+T0_Vge_e_Ve_di*T0+T0_Vge_e*T0_Ve_di+T0_Ve_di*T0_Vge_e+T0*T0_Vge_e_Ve_di);
  T4_Vge_e_Vge_si=(+T0_Vge_e_Vge_si*T0+T0_Vge_e*T0_Vge_si+T0_Vge_si*T0_Vge_e+T0*T0_Vge_e_Vge_si);
  T4_Vge_e_Tempt_GND=(+T0_Vge_e_Tempt_GND*T0+T0_Vge_e*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_e+T0*T0_Vge_e_Tempt_GND);
#endif
T4_Vdi_si=((T0_Vdi_si*T0)+(T0*T0_Vdi_si));
#if defined(_DERIVATE2)
  T4_Vdi_si_Vge_di=(+T0_Vdi_si_Vge_di*T0+T0_Vdi_si*T0_Vge_di+T0_Vge_di*T0_Vdi_si+T0*T0_Vdi_si_Vge_di);
  T4_Vdi_si_Vge_e=(+T0_Vdi_si_Vge_e*T0+T0_Vdi_si*T0_Vge_e+T0_Vge_e*T0_Vdi_si+T0*T0_Vdi_si_Vge_e);
  T4_Vdi_si_Vdi_si=(+T0_Vdi_si_Vdi_si*T0+T0_Vdi_si*T0_Vdi_si+T0_Vdi_si*T0_Vdi_si+T0*T0_Vdi_si_Vdi_si);
  T4_Vdi_si_Ve_si=(+T0_Vdi_si_Ve_si*T0+T0_Vdi_si*T0_Ve_si+T0_Ve_si*T0_Vdi_si+T0*T0_Vdi_si_Ve_si);
  T4_Vdi_si_Ve_di=(+T0_Vdi_si_Ve_di*T0+T0_Vdi_si*T0_Ve_di+T0_Ve_di*T0_Vdi_si+T0*T0_Vdi_si_Ve_di);
  T4_Vdi_si_Vge_si=(+T0_Vdi_si_Vge_si*T0+T0_Vdi_si*T0_Vge_si+T0_Vge_si*T0_Vdi_si+T0*T0_Vdi_si_Vge_si);
  T4_Vdi_si_Tempt_GND=(+T0_Vdi_si_Tempt_GND*T0+T0_Vdi_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vdi_si+T0*T0_Vdi_si_Tempt_GND);
#endif
T4_Ve_si=((T0_Ve_si*T0)+(T0*T0_Ve_si));
#if defined(_DERIVATE2)
  T4_Ve_si_Vge_di=(+T0_Ve_si_Vge_di*T0+T0_Ve_si*T0_Vge_di+T0_Vge_di*T0_Ve_si+T0*T0_Ve_si_Vge_di);
  T4_Ve_si_Vge_e=(+T0_Ve_si_Vge_e*T0+T0_Ve_si*T0_Vge_e+T0_Vge_e*T0_Ve_si+T0*T0_Ve_si_Vge_e);
  T4_Ve_si_Vdi_si=(+T0_Ve_si_Vdi_si*T0+T0_Ve_si*T0_Vdi_si+T0_Vdi_si*T0_Ve_si+T0*T0_Ve_si_Vdi_si);
  T4_Ve_si_Ve_si=(+T0_Ve_si_Ve_si*T0+T0_Ve_si*T0_Ve_si+T0_Ve_si*T0_Ve_si+T0*T0_Ve_si_Ve_si);
  T4_Ve_si_Ve_di=(+T0_Ve_si_Ve_di*T0+T0_Ve_si*T0_Ve_di+T0_Ve_di*T0_Ve_si+T0*T0_Ve_si_Ve_di);
  T4_Ve_si_Vge_si=(+T0_Ve_si_Vge_si*T0+T0_Ve_si*T0_Vge_si+T0_Vge_si*T0_Ve_si+T0*T0_Ve_si_Vge_si);
  T4_Ve_si_Tempt_GND=(+T0_Ve_si_Tempt_GND*T0+T0_Ve_si*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_si+T0*T0_Ve_si_Tempt_GND);
#endif
T4_Ve_di=((T0_Ve_di*T0)+(T0*T0_Ve_di));
#if defined(_DERIVATE2)
  T4_Ve_di_Vge_di=(+T0_Ve_di_Vge_di*T0+T0_Ve_di*T0_Vge_di+T0_Vge_di*T0_Ve_di+T0*T0_Ve_di_Vge_di);
  T4_Ve_di_Vge_e=(+T0_Ve_di_Vge_e*T0+T0_Ve_di*T0_Vge_e+T0_Vge_e*T0_Ve_di+T0*T0_Ve_di_Vge_e);
  T4_Ve_di_Vdi_si=(+T0_Ve_di_Vdi_si*T0+T0_Ve_di*T0_Vdi_si+T0_Vdi_si*T0_Ve_di+T0*T0_Ve_di_Vdi_si);
  T4_Ve_di_Ve_si=(+T0_Ve_di_Ve_si*T0+T0_Ve_di*T0_Ve_si+T0_Ve_si*T0_Ve_di+T0*T0_Ve_di_Ve_si);
  T4_Ve_di_Ve_di=(+T0_Ve_di_Ve_di*T0+T0_Ve_di*T0_Ve_di+T0_Ve_di*T0_Ve_di+T0*T0_Ve_di_Ve_di);
  T4_Ve_di_Vge_si=(+T0_Ve_di_Vge_si*T0+T0_Ve_di*T0_Vge_si+T0_Vge_si*T0_Ve_di+T0*T0_Ve_di_Vge_si);
  T4_Ve_di_Tempt_GND=(+T0_Ve_di_Tempt_GND*T0+T0_Ve_di*T0_Tempt_GND+T0_Tempt_GND*T0_Ve_di+T0*T0_Ve_di_Tempt_GND);
#endif
T4_Vge_si=((T0_Vge_si*T0)+(T0*T0_Vge_si));
#if defined(_DERIVATE2)
  T4_Vge_si_Vge_di=(+T0_Vge_si_Vge_di*T0+T0_Vge_si*T0_Vge_di+T0_Vge_di*T0_Vge_si+T0*T0_Vge_si_Vge_di);
  T4_Vge_si_Vge_e=(+T0_Vge_si_Vge_e*T0+T0_Vge_si*T0_Vge_e+T0_Vge_e*T0_Vge_si+T0*T0_Vge_si_Vge_e);
  T4_Vge_si_Vdi_si=(+T0_Vge_si_Vdi_si*T0+T0_Vge_si*T0_Vdi_si+T0_Vdi_si*T0_Vge_si+T0*T0_Vge_si_Vdi_si);
  T4_Vge_si_Ve_si=(+T0_Vge_si_Ve_si*T0+T0_Vge_si*T0_Ve_si+T0_Ve_si*T0_Vge_si+T0*T0_Vge_si_Ve_si);
  T4_Vge_si_Ve_di=(+T0_Vge_si_Ve_di*T0+T0_Vge_si*T0_Ve_di+T0_Ve_di*T0_Vge_si+T0*T0_Vge_si_Ve_di);
  T4_Vge_si_Vge_si=(+T0_Vge_si_Vge_si*T0+T0_Vge_si*T0_Vge_si+T0_Vge_si*T0_Vge_si+T0*T0_Vge_si_Vge_si);
  T4_Vge_si_Tempt_GND=(+T0_Vge_si_Tempt_GND*T0+T0_Vge_si*T0_Tempt_GND+T0_Tempt_GND*T0_Vge_si+T0*T0_Vge_si_Tempt_GND);
#endif
T4_Tempt_GND=((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND));
#if defined(_DERIVATE2)
  T4_Tempt_GND_Vge_di=(+T0_Tempt_GND_Vge_di*T0+T0_Tempt_GND*T0_Vge_di+T0_Vge_di*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_di);
  T4_Tempt_GND_Vge_e=(+T0_Tempt_GND_Vge_e*T0+T0_Tempt_GND*T0_Vge_e+T0_Vge_e*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_e);
  T4_Tempt_GND_Vdi_si=(+T0_Tempt_GND_Vdi_si*T0+T0_Tempt_GND*T0_Vdi_si+T0_Vdi_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vdi_si);
  T4_Tempt_GND_Ve_si=(+T0_Tempt_GND_Ve_si*T0+T0_Tempt_GND*T0_Ve_si+T0_Ve_si*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_si);
  T4_Tempt_GND_Ve_di=(+T0_Tempt_GND_Ve_di*T0+T0_Tempt_GND*T0_Ve_di+T0_Ve_di*T0_Tempt_GND+T0*T0_Tempt_GND_Ve_di);
  T4_Tempt_GND_Vge_si=(+T0_Tempt_GND_Vge_si*T0+T0_Tempt_GND*T0_Vge_si+T0_Vge_si*T0_Tempt_GND+T0*T0_Tempt_GND_Vge_si);
  T4_Tempt_GND_Tempt_GND=(+T0_Tempt_GND_Tempt_GND*T0+T0_Tempt_GND*T0_Tempt_GND+T0_Tempt_GND*T0_Tempt_GND+T0*T0_Tempt_GND_Tempt_GND);
#endif
#endif
T4=(T0*T0);
EXIT_IF_ISNAN((T0*T0))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(di,GND)V(e,GND)V(si,GND)V(ge,GND)Temp(t,GND) */
T5_Vge_di=((T3_Vge_di*T3)+(T3*T3_Vge_di));
#if defined(_DERIVATE2)
  T5_Vge_di_Vge_di=(+T3_Vge_di_Vge_di*T3+T3_Vge_di*T3_Vge_di+T3_Vge_di*T3_Vge_di+T3*T3_Vge_di_Vge_di);
  T5_Vge_di_Vdi_d=(+T3_Vge_di_Vdi_d*T3+T3_Vge_di*T3_Vdi_d+T3_Vdi_d*T3_Vge_di+T3*T3_Vge_di_Vdi_d);
  T5_Vge_di_Vsi_s=(+T3_Vge_di_Vsi_s*T3+T3_Vge_di*T3_Vsi_s+T3_Vsi_s*T3_Vge_di+T3*T3_Vge_di_Vsi_s);
  T5_Vge_di_Vge_e=(+T3_Vge_di_Vge_e*T3+T3_Vge_di*T3_Vge_e+T3_Vge_e*T3_Vge_di+T3*T3_Vge_di_Vge_e);
  T5_Vge_di_Vdi_si=(+T3_Vge_di_Vdi_si*T3+T3_Vge_di*T3_Vdi_si+T3_Vdi_si*T3_Vge_di+T3*T3_Vge_di_Vdi_si);
  T5_Vge_di_Ve_si=(+T3_Vge_di_Ve_si*T3+T3_Vge_di*T3_Ve_si+T3_Ve_si*T3_Vge_di+T3*T3_Vge_di_Ve_si);
  T5_Vge_di_Ve_di=(+T3_Vge_di_Ve_di*T3+T3_Vge_di*T3_Ve_di+T3_Ve_di*T3_Vge_di+T3*T3_Vge_di_Ve_di);
  T5_Vge_di_Vge_si=(+T3_Vge_di_Vge_si*T3+T3_Vge_di*T3_Vge_si+T3_Vge_si*T3_Vge_di+T3*T3_Vge_di_Vge_si);
  T5_Vge_di_Tempt_GND=(+T3_Vge_di_Tempt_GND*T3+T3_Vge_di*T3_Tempt_GND+T3_Tempt_GND*T3_Vge_di+T3*T3_Vge_di_Tempt_GND);
#endif
T5_Vdi_d=((T3_Vdi_d*T3)+(T3*T3_Vdi_d));
#if defined(_DERIVATE2)
  T5_Vdi_d_Vge_di=(+T3_Vdi_d_Vge_di*T3+T3_Vdi_d*T3_Vge_di+T3_Vge_di*T3_Vdi_d+T3*T3_Vdi_d_Vge_di);
  T5_Vdi_d_Vdi_d=(+T3_Vdi_d_Vdi_d*T3+T3_Vdi_d*T3_Vdi_d+T3_Vdi_d*T3_Vdi_d+T3*T3_Vdi_d_Vdi_d);
  T5_Vdi_d_Vsi_s=(+T3_Vdi_d_Vsi_s*T3+T3_Vdi_d*T3_Vsi_s+T3_Vsi_s*T3_Vdi_d+T3*T3_Vdi_d_Vsi_s);
  T5_Vdi_d_Vge_e=(+T3_Vdi_d_Vge_e*T3+T3_Vdi_d*T3_Vge_e+T3_Vge_e*T3_Vdi_d+T3*T3_Vdi_d_Vge_e);
  T5_Vdi_d_Vdi_si=(+T3_Vdi_d_Vdi_si*T3+T3_Vdi_d*T3_Vdi_si+T3_Vdi_si*T3_Vdi_d+T3*T3_Vdi_d_Vdi_si);
  T5_Vdi_d_Ve_si=(+T3_Vdi_d_Ve_si*T3+T3_Vdi_d*T3_Ve_si+T3_Ve_si*T3_Vdi_d+T3*T3_Vdi_d_Ve_si);
  T5_Vdi_d_Ve_di=(+T3_Vdi_d_Ve_di*T3+T3_Vdi_d*T3_Ve_di+T3_Ve_di*T3_Vdi_d+T3*T3_Vdi_d_Ve_di);
  T5_Vdi_d_Vge_si=(+T3_Vdi_d_Vge_si*T3+T3_Vdi_d*T3_Vge_si+T3_Vge_si*T3_Vdi_d+T3*T3_Vdi_d_Vge_si);
  T5_Vdi_d_Tempt_GND=(+T3_Vdi_d_Tempt_GND*T3+T3_Vdi_d*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_d+T3*T3_Vdi_d_Tempt_GND);
#endif
T5_Vsi_s=((T3_Vsi_s*T3)+(T3*T3_Vsi_s));
#if defined(_DERIVATE2)
  T5_Vsi_s_Vge_di=(+T3_Vsi_s_Vge_di*T3+T3_Vsi_s*T3_Vge_di+T3_Vge_di*T3_Vsi_s+T3*T3_Vsi_s_Vge_di);
  T5_Vsi_s_Vdi_d=(+T3_Vsi_s_Vdi_d*T3+T3_Vsi_s*T3_Vdi_d+T3_Vdi_d*T3_Vsi_s+T3*T3_Vsi_s_Vdi_d);
  T5_Vsi_s_Vsi_s=(+T3_Vsi_s_Vsi_s*T3+T3_Vsi_s*T3_Vsi_s+T3_Vsi_s*T3_Vsi_s+T3*T3_Vsi_s_Vsi_s);
  T5_Vsi_s_Vge_e=(+T3_Vsi_s_Vge_e*T3+T3_Vsi_s*T3_Vge_e+T3_Vge_e*T3_Vsi_s+T3*T3_Vsi_s_Vge_e);
  T5_Vsi_s_Vdi_si=(+T3_Vsi_s_Vdi_si*T3+T3_Vsi_s*T3_Vdi_si+T3_Vdi_si*T3_Vsi_s+T3*T3_Vsi_s_Vdi_si);
  T5_Vsi_s_Ve_si=(+T3_Vsi_s_Ve_si*T3+T3_Vsi_s*T3_Ve_si+T3_Ve_si*T3_Vsi_s+T3*T3_Vsi_s_Ve_si);
  T5_Vsi_s_Ve_di=(+T3_Vsi_s_Ve_di*T3+T3_Vsi_s*T3_Ve_di+T3_Ve_di*T3_Vsi_s+T3*T3_Vsi_s_Ve_di);
  T5_Vsi_s_Vge_si=(+T3_Vsi_s_Vge_si*T3+T3_Vsi_s*T3_Vge_si+T3_Vge_si*T3_Vsi_s+T3*T3_Vsi_s_Vge_si);
  T5_Vsi_s_Tempt_GND=(+T3_Vsi_s_Tempt_GND*T3+T3_Vsi_s*T3_Tempt_GND+T3_Tempt_GND*T3_Vsi_s+T3*T3_Vsi_s_Tempt_GND);
#endif
T5_Vge_e=((T3_Vge_e*T3)+(T3*T3_Vge_e));
#if defined(_DERIVATE2)
  T5_Vge_e_Vge_di=(+T3_Vge_e_Vge_di*T3+T3_Vge_e*T3_Vge_di+T3_Vge_di*T3_Vge_e+T3*T3_Vge_e_Vge_di);
  T5_Vge_e_Vdi_d=(+T3_Vge_e_Vdi_d*T3+T3_Vge_e*T3_Vdi_d+T3_Vdi_d*T3_Vge_e+T3*T3_Vge_e_Vdi_d);
  T5_Vge_e_Vsi_s=(+T3_Vge_e_Vsi_s*T3+T3_Vge_e*T3_Vsi_s+T3_Vsi_s*T3_Vge_e+T3*T3_Vge_e_Vsi_s);
  T5_Vge_e_Vge_e=(+T3_Vge_e_Vge_e*T3+T3_Vge_e*T3_Vge_e+T3_Vge_e*T3_Vge_e+T3*T3_Vge_e_Vge_e);
  T5_Vge_e_Vdi_si=(+T3_Vge_e_Vdi_si*T3+T3_Vge_e*T3_Vdi_si+T3_Vdi_si*T3_Vge_e+T3*T3_Vge_e_Vdi_si);
  T5_Vge_e_Ve_si=(+T3_Vge_e_Ve_si*T3+T3_Vge_e*T3_Ve_si+T3_Ve_si*T3_Vge_e+T3*T3_Vge_e_Ve_si);
  T5_Vge_e_Ve_di=(+T3_Vge_e_Ve_di*T3+T3_Vge_e*T3_Ve_di+T3_Ve_di*T3_Vge_e+T3*T3_Vge_e_Ve_di);
  T5_Vge_e_Vge_si=(+T3_Vge_e_Vge_si*T3+T3_Vge_e*T3_Vge_si+T3_Vge_si*T3_Vge_e+T3*T3_Vge_e_Vge_si);
  T5_Vge_e_Tempt_GND=(+T3_Vge_e_Tempt_GND*T3+T3_Vge_e*T3_Tempt_GND+T3_Tempt_GND*T3_Vge_e+T3*T3_Vge_e_Tempt_GND);
#endif
T5_Vdi_si=((T3_Vdi_si*T3)+(T3*T3_Vdi_si));
#if defined(_DERIVATE2)
  T5_Vdi_si_Vge_di=(+T3_Vdi_si_Vge_di*T3+T3_Vdi_si*T3_Vge_di+T3_Vge_di*T3_Vdi_si+T3*T3_Vdi_si_Vge_di);
  T5_Vdi_si_Vdi_d=(+T3_Vdi_si_Vdi_d*T3+T3_Vdi_si*T3_Vdi_d+T3_Vdi_d*T3_Vdi_si+T3*T3_Vdi_si_Vdi_d);
  T5_Vdi_si_Vsi_s=(+T3_Vdi_si_Vsi_s*T3+T3_Vdi_si*T3_Vsi_s+T3_Vsi_s*T3_Vdi_si+T3*T3_Vdi_si_Vsi_s);
  T5_Vdi_si_Vge_e=(+T3_Vdi_si_Vge_e*T3+T3_Vdi_si*T3_Vge_e+T3_Vge_e*T3_Vdi_si+T3*T3_Vdi_si_Vge_e);
  T5_Vdi_si_Vdi_si=(+T3_Vdi_si_Vdi_si*T3+T3_Vdi_si*T3_Vdi_si+T3_Vdi_si*T3_Vdi_si+T3*T3_Vdi_si_Vdi_si);
  T5_Vdi_si_Ve_si=(+T3_Vdi_si_Ve_si*T3+T3_Vdi_si*T3_Ve_si+T3_Ve_si*T3_Vdi_si+T3*T3_Vdi_si_Ve_si);
  T5_Vdi_si_Ve_di=(+T3_Vdi_si_Ve_di*T3+T3_Vdi_si*T3_Ve_di+T3_Ve_di*T3_Vdi_si+T3*T3_Vdi_si_Ve_di);
  T5_Vdi_si_Vge_si=(+T3_Vdi_si_Vge_si*T3+T3_Vdi_si*T3_Vge_si+T3_Vge_si*T3_Vdi_si+T3*T3_Vdi_si_Vge_si);
  T5_Vdi_si_Tempt_GND=(+T3_Vdi_si_Tempt_GND*T3+T3_Vdi_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vdi_si+T3*T3_Vdi_si_Tempt_GND);
#endif
T5_Ve_si=((T3_Ve_si*T3)+(T3*T3_Ve_si));
#if defined(_DERIVATE2)
  T5_Ve_si_Vge_di=(+T3_Ve_si_Vge_di*T3+T3_Ve_si*T3_Vge_di+T3_Vge_di*T3_Ve_si+T3*T3_Ve_si_Vge_di);
  T5_Ve_si_Vdi_d=(+T3_Ve_si_Vdi_d*T3+T3_Ve_si*T3_Vdi_d+T3_Vdi_d*T3_Ve_si+T3*T3_Ve_si_Vdi_d);
  T5_Ve_si_Vsi_s=(+T3_Ve_si_Vsi_s*T3+T3_Ve_si*T3_Vsi_s+T3_Vsi_s*T3_Ve_si+T3*T3_Ve_si_Vsi_s);
  T5_Ve_si_Vge_e=(+T3_Ve_si_Vge_e*T3+T3_Ve_si*T3_Vge_e+T3_Vge_e*T3_Ve_si+T3*T3_Ve_si_Vge_e);
  T5_Ve_si_Vdi_si=(+T3_Ve_si_Vdi_si*T3+T3_Ve_si*T3_Vdi_si+T3_Vdi_si*T3_Ve_si+T3*T3_Ve_si_Vdi_si);
  T5_Ve_si_Ve_si=(+T3_Ve_si_Ve_si*T3+T3_Ve_si*T3_Ve_si+T3_Ve_si*T3_Ve_si+T3*T3_Ve_si_Ve_si);
  T5_Ve_si_Ve_di=(+T3_Ve_si_Ve_di*T3+T3_Ve_si*T3_Ve_di+T3_Ve_di*T3_Ve_si+T3*T3_Ve_si_Ve_di);
  T5_Ve_si_Vge_si=(+T3_Ve_si_Vge_si*T3+T3_Ve_si*T3_Vge_si+T3_Vge_si*T3_Ve_si+T3*T3_Ve_si_Vge_si);
  T5_Ve_si_Tempt_GND=(+T3_Ve_si_Tempt_GND*T3+T3_Ve_si*T3_Tempt_GND+T3_Tempt_GND*T3_Ve_si+T3*T3_Ve_si_Tempt_GND);
#endif
T5_Ve_di=((T3_Ve_di*T3)+(T3*T3_Ve_di));
#if defined(_DERIVATE2)
  T5_Ve_di_Vge_di=(+T3_Ve_di_Vge_di*T3+T3_Ve_di*T3_Vge_di+T3_Vge_di*T3_Ve_di+T3*T3_Ve_di_Vge_di);
  T5_Ve_di_Vdi_d=(+T3_Ve_di_Vdi_d*T3+T3_Ve_di*T3_Vdi_d+T3_Vdi_d*T3_Ve_di+T3*T3_Ve_di_Vdi_d);
  T5_Ve_di_Vsi_s=(+T3_Ve_di_Vsi_s*T3+T3_Ve_di*T3_Vsi_s+T3_Vsi_s*T3_Ve_di+T3*T3_Ve_di_Vsi_s);
  T5_Ve_di_Vge_e=(+T3_Ve_di_Vge_e*T3+T3_Ve_di*T3_Vge_e+T3_Vge_e*T3_Ve_di+T3*T3_Ve_di_Vge_e);
  T5_Ve_di_Vdi_si=(+T3_Ve_di_Vdi_si*T3+T3_Ve_di*T3_Vdi_si+T3_Vdi_si*T3_Ve_di+T3*T3_Ve_di_Vdi_si);
  T5_Ve_di_Ve_si=(+T3_Ve_di_Ve_si*T3+T3_Ve_di*T3_Ve_si+T3_Ve_si*T3_Ve_di+T3*T3_Ve_di_Ve_si);
  T5_Ve_di_Ve_di=(+T3_Ve_di_Ve_di*T3+T3_Ve_di*T3_Ve_di+T3_Ve_di*T3_Ve_di+T3*T3_Ve_di_Ve_di);
  T5_Ve_di_Vge_si=(+T3_Ve_di_Vge_si*T3+T3_Ve_di*T3_Vge_si+T3_Vge_si*T3_Ve_di+T3*T3_Ve_di_Vge_si);
  T5_Ve_di_Tempt_GND=(+T3_Ve_di_Tempt_GND*T3+T3_Ve_di*T3_Tempt_GND+T3_Tempt_GND*T3_Ve_di+T3*T3_Ve_di_Tempt_GND);
#endif
T5_Vge_si=((T3_Vge_si*T3)+(T3*T3_Vge_si));
#if defined(_DERIVATE2)
  T5_Vge_si_Vge_di=(+T3_Vge_si_Vge_di*T3+T3_Vge_si*T3_Vge_di+T3_Vge_di*T3_Vge_si+T3*T3_Vge_si_Vge_di);
  T5_Vge_si_Vdi_d=(+T3_Vge_si_Vdi_d*T3+T3_Vge_si*T3_Vdi_d+T3_Vdi_d*T3_Vge_si+T3*T3_Vge_si_Vdi_d);
  T5_Vge_si_Vsi_s=(+T3_Vge_si_Vsi_s*T3+T3_Vge_si*T3_Vsi_s+T3_Vsi_s*T3_Vge_si+T3*T3_Vge_si_Vsi_s);
  T5_Vge_si_Vge_e=(+T3_Vge_si_Vge_e*T3+T3_Vge_si*T3_Vge_e+T3_Vge_e*T3_Vge_si+T3*T3_Vge_si_Vge_e);
  T5_Vge_si_Vdi_si=(+T3_Vge_si_Vdi_si*T3+T3_Vge_si*T3_Vdi_si+T3_Vdi_si*T3_Vge_si+T3*T3_Vge_si_Vdi_si);
  T5_Vge_si_Ve_si=(+T3_Vge_si_Ve_si*T3+T3_Vge_si*T3_Ve_si+T3_Ve_si*T3_Vge_si+T3*T3_Vge_si_Ve_si);
  T5_Vge_si_Ve_di=(+T3_Vge_si_Ve_di*T3+T3_Vge_si*T3_Ve_di+T3_Ve_di*T3_Vge_si+T3*T3_Vge_si_Ve_di);
  T5_Vge_si_Vge_si=(+T3_Vge_si_Vge_si*T3+T3_Vge_si*T3_Vge_si+T3_Vge_si*T3_Vge_si+T3*T3_Vge_si_Vge_si);
  T5_Vge_si_Tempt_GND=(+T3_Vge_si_Tempt_GND*T3+T3_Vge_si*T3_Tempt_GND+T3_Tempt_GND*T3_Vge_si+T3*T3_Vge_si_Tempt_GND);
#endif
T5_Tempt_GND=((T3_Tempt_GND*T3)+(T3*T3_Tempt_GND));
#if defined(_DERIVATE2)
  T5_Tempt_GND_Vge_di=(+T3_Tempt_GND_Vge_di*T3+T3_Tempt_GND*T3_Vge_di+T3_Vge_di*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_di);
  T5_Tempt_GND_Vdi_d=(+T3_Tempt_GND_Vdi_d*T3+T3_Tempt_GND*T3_Vdi_d+T3_Vdi_d*T3_Tempt_GND+T3*T3_Tempt_GND_Vdi_d);
  T5_Tempt_GND_Vsi_s=(+T3_Tempt_GND_Vsi_s*T3+T3_Tempt_GND*T3_Vsi_s+T3_Vsi_s*T3_Tempt_GND+T3*T3_Tempt_GND_Vsi_s);
  T5_Tempt_GND_Vge_e=(+T3_Tempt_GND_Vge_e*T3+T3_Tempt_GND*T3_Vge_e+T3_Vge_e*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_e);
  T5_Tempt_GND_Vdi_si=(+T3_Tempt_GND_Vdi_si*T3+T3_Tempt_GND*T3_Vdi_si+T3_Vdi_si*T3_Tempt_GND+T3*T3_Tempt_GND_Vdi_si);
  T5_Tempt_GND_Ve_si=(+T3_Tempt_GND_Ve_si*T3+T3_Tempt_GND*T3_Ve_si+T3_Ve_si*T3_Tempt_GND+T3*T3_Tempt_GND_Ve_si);
  T5_Tempt_GND_Ve_di=(+T3_Tempt_GND_Ve_di*T3+T3_Tempt_GND*T3_Ve_di+T3_Ve_di*T3_Tempt_GND+T3*T3_Tempt_GND_Ve_di);
  T5_Tempt_GND_Vge_si=(+T3_Tempt_GND_Vge_si*T3+T3_Tempt_GND*T3_Vge_si+T3_Vge_si*T3_Tempt_GND+T3*T3_Tempt_GND_Vge_si);
  T5_Tempt_GND_Tempt_GND=(+T3_Tempt_GND_Tempt_GND*T3+T3_Tempt_GND*T3_Tempt_GND+T3_Tempt_GND*T3_Tempt_GND+T3*T3_Tempt_GND_Tempt_GND);
#endif
#endif
T5=(T3*T3);
EXIT_IF_ISNAN((T3*T3))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe=V(e,GND)V(ge,GND)V(si,GND)V(di,GND)Temp(t,GND) */
T6_Vge_di=0.0;
#if defined(_DERIVATE2)
  T6_Vge_di_Vge_di=0.0;
  T6_Vge_di_Vdi_d=0.0;
  T6_Vge_di_Vsi_s=0.0;
  T6_Vge_di_Vge_e=0.0;
  T6_Vge_di_Vdi_si=0.0;
  T6_Vge_di_Tempt_GND=0.0;
  T6_Vge_di_Ve_si=0.0;
  T6_Vge_di_Ve_di=0.0;
  T6_Vge_di_Vge_si=0.0;
#endif
T6_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T6_Vdi_d_Vge_di=0.0;
  T6_Vdi_d_Vdi_d=0.0;
  T6_Vdi_d_Vsi_s=0.0;
  T6_Vdi_d_Vge_e=0.0;
  T6_Vdi_d_Vdi_si=0.0;
  T6_Vdi_d_Tempt_GND=0.0;
  T6_Vdi_d_Ve_si=0.0;
  T6_Vdi_d_Ve_di=0.0;
  T6_Vdi_d_Vge_si=0.0;
#endif
T6_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T6_Vsi_s_Vge_di=0.0;
  T6_Vsi_s_Vdi_d=0.0;
  T6_Vsi_s_Vsi_s=0.0;
  T6_Vsi_s_Vge_e=0.0;
  T6_Vsi_s_Vdi_si=0.0;
  T6_Vsi_s_Tempt_GND=0.0;
  T6_Vsi_s_Ve_si=0.0;
  T6_Vsi_s_Ve_di=0.0;
  T6_Vsi_s_Vge_si=0.0;
#endif
T6_Vge_e=0.0;
#if defined(_DERIVATE2)
  T6_Vge_e_Vge_di=0.0;
  T6_Vge_e_Vdi_d=0.0;
  T6_Vge_e_Vsi_s=0.0;
  T6_Vge_e_Vge_e=0.0;
  T6_Vge_e_Vdi_si=0.0;
  T6_Vge_e_Tempt_GND=0.0;
  T6_Vge_e_Ve_si=0.0;
  T6_Vge_e_Ve_di=0.0;
  T6_Vge_e_Vge_si=0.0;
#endif
T6_Vdi_si=(-((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#if defined(_DERIVATE2)
  T6_Vdi_si_Vge_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vdi_si*0.0+0.0*EsatL_Vdi_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Vdi_d=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vdi_si*0.0+0.0*EsatL_Vdi_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Vsi_s=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vdi_si*0.0+0.0*EsatL_Vdi_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Vge_e=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vdi_si*0.0+0.0*EsatL_Vdi_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Vdi_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vdi_si_Vdi_si/EsatL-(Vdseff_Vdi_si*EsatL_Vdi_si+Vdseff_Vdi_si*EsatL_Vdi_si+Vdseff*EsatL_Vdi_si_Vdi_si)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Tempt_GND=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vdi_si_Tempt_GND/EsatL-(Vdseff_Vdi_si*EsatL_Tempt_GND+Vdseff_Tempt_GND*EsatL_Vdi_si+Vdseff*EsatL_Vdi_si_Tempt_GND)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Ve_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vdi_si_Ve_si/EsatL-(Vdseff_Vdi_si*EsatL_Ve_si+Vdseff_Ve_si*EsatL_Vdi_si+Vdseff*EsatL_Vdi_si_Ve_si)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Ve_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vdi_si_Ve_di/EsatL-(Vdseff_Vdi_si*EsatL_Ve_di+Vdseff_Ve_di*EsatL_Vdi_si+Vdseff*EsatL_Vdi_si_Ve_di)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vdi_si_Vge_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vdi_si_Vge_si/EsatL-(Vdseff_Vdi_si*EsatL_Vge_si+Vdseff_Vge_si*EsatL_Vdi_si+Vdseff*EsatL_Vdi_si_Vge_si)/EsatL/EsatL+2*Vdseff*EsatL_Vdi_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#endif
T6_Tempt_GND=(-((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#if defined(_DERIVATE2)
  T6_Tempt_GND_Vge_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Tempt_GND*0.0+0.0*EsatL_Tempt_GND+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Vdi_d=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Tempt_GND*0.0+0.0*EsatL_Tempt_GND+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Vsi_s=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Tempt_GND*0.0+0.0*EsatL_Tempt_GND+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Vge_e=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Tempt_GND*0.0+0.0*EsatL_Tempt_GND+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Vdi_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Tempt_GND_Vdi_si/EsatL-(Vdseff_Tempt_GND*EsatL_Vdi_si+Vdseff_Vdi_si*EsatL_Tempt_GND+Vdseff*EsatL_Tempt_GND_Vdi_si)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Tempt_GND=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Tempt_GND_Tempt_GND/EsatL-(Vdseff_Tempt_GND*EsatL_Tempt_GND+Vdseff_Tempt_GND*EsatL_Tempt_GND+Vdseff*EsatL_Tempt_GND_Tempt_GND)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Ve_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Tempt_GND_Ve_si/EsatL-(Vdseff_Tempt_GND*EsatL_Ve_si+Vdseff_Ve_si*EsatL_Tempt_GND+Vdseff*EsatL_Tempt_GND_Ve_si)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Ve_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Tempt_GND_Ve_di/EsatL-(Vdseff_Tempt_GND*EsatL_Ve_di+Vdseff_Ve_di*EsatL_Tempt_GND+Vdseff*EsatL_Tempt_GND_Ve_di)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Tempt_GND_Vge_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Tempt_GND_Vge_si/EsatL-(Vdseff_Tempt_GND*EsatL_Vge_si+Vdseff_Vge_si*EsatL_Tempt_GND+Vdseff*EsatL_Tempt_GND_Vge_si)/EsatL/EsatL+2*Vdseff*EsatL_Tempt_GND*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#endif
T6_Ve_si=(-((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#if defined(_DERIVATE2)
  T6_Ve_si_Vge_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_si*0.0+0.0*EsatL_Ve_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Vdi_d=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_si*0.0+0.0*EsatL_Ve_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Vsi_s=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_si*0.0+0.0*EsatL_Ve_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Vge_e=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_si*0.0+0.0*EsatL_Ve_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Vdi_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_si_Vdi_si/EsatL-(Vdseff_Ve_si*EsatL_Vdi_si+Vdseff_Vdi_si*EsatL_Ve_si+Vdseff*EsatL_Ve_si_Vdi_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Tempt_GND=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_si_Tempt_GND/EsatL-(Vdseff_Ve_si*EsatL_Tempt_GND+Vdseff_Tempt_GND*EsatL_Ve_si+Vdseff*EsatL_Ve_si_Tempt_GND)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Ve_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_si_Ve_si/EsatL-(Vdseff_Ve_si*EsatL_Ve_si+Vdseff_Ve_si*EsatL_Ve_si+Vdseff*EsatL_Ve_si_Ve_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Ve_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_si_Ve_di/EsatL-(Vdseff_Ve_si*EsatL_Ve_di+Vdseff_Ve_di*EsatL_Ve_si+Vdseff*EsatL_Ve_si_Ve_di)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_si_Vge_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_si_Vge_si/EsatL-(Vdseff_Ve_si*EsatL_Vge_si+Vdseff_Vge_si*EsatL_Ve_si+Vdseff*EsatL_Ve_si_Vge_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#endif
T6_Ve_di=(-((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#if defined(_DERIVATE2)
  T6_Ve_di_Vge_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_di*0.0+0.0*EsatL_Ve_di+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Vdi_d=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_di*0.0+0.0*EsatL_Ve_di+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Vsi_s=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_di*0.0+0.0*EsatL_Ve_di+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Vge_e=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Ve_di*0.0+0.0*EsatL_Ve_di+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Vdi_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_di_Vdi_si/EsatL-(Vdseff_Ve_di*EsatL_Vdi_si+Vdseff_Vdi_si*EsatL_Ve_di+Vdseff*EsatL_Ve_di_Vdi_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Tempt_GND=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_di_Tempt_GND/EsatL-(Vdseff_Ve_di*EsatL_Tempt_GND+Vdseff_Tempt_GND*EsatL_Ve_di+Vdseff*EsatL_Ve_di_Tempt_GND)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Ve_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_di_Ve_si/EsatL-(Vdseff_Ve_di*EsatL_Ve_si+Vdseff_Ve_si*EsatL_Ve_di+Vdseff*EsatL_Ve_di_Ve_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Ve_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_di_Ve_di/EsatL-(Vdseff_Ve_di*EsatL_Ve_di+Vdseff_Ve_di*EsatL_Ve_di+Vdseff*EsatL_Ve_di_Ve_di)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Ve_di_Vge_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Ve_di_Vge_si/EsatL-(Vdseff_Ve_di*EsatL_Vge_si+Vdseff_Vge_si*EsatL_Ve_di+Vdseff*EsatL_Ve_di_Vge_si)/EsatL/EsatL+2*Vdseff*EsatL_Ve_di*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#endif
T6_Vge_si=(-((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#if defined(_DERIVATE2)
  T6_Vge_si_Vge_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vge_si*0.0+0.0*EsatL_Vge_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Vdi_d=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vge_si*0.0+0.0*EsatL_Vge_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Vsi_s=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vge_si*0.0+0.0*EsatL_Vge_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Vge_e=(0.0/(1.0+(Vdseff/EsatL))-(0.0*0.0+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(0.0/EsatL-(Vdseff_Vge_si*0.0+0.0*EsatL_Vge_si+Vdseff*0.0)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*0.0/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*0.0/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Vdi_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vge_si_Vdi_si/EsatL-(Vdseff_Vge_si*EsatL_Vdi_si+Vdseff_Vdi_si*EsatL_Vge_si+Vdseff*EsatL_Vge_si_Vdi_si)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*EsatL_Vdi_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*((Vdseff_Vdi_si*EsatL-Vdseff*EsatL_Vdi_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Tempt_GND=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vge_si_Tempt_GND/EsatL-(Vdseff_Vge_si*EsatL_Tempt_GND+Vdseff_Tempt_GND*EsatL_Vge_si+Vdseff*EsatL_Vge_si_Tempt_GND)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*((Vdseff_Tempt_GND*EsatL-Vdseff*EsatL_Tempt_GND)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Ve_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vge_si_Ve_si/EsatL-(Vdseff_Vge_si*EsatL_Ve_si+Vdseff_Ve_si*EsatL_Vge_si+Vdseff*EsatL_Vge_si_Ve_si)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*EsatL_Ve_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*((Vdseff_Ve_si*EsatL-Vdseff*EsatL_Ve_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Ve_di=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vge_si_Ve_di/EsatL-(Vdseff_Vge_si*EsatL_Ve_di+Vdseff_Ve_di*EsatL_Vge_si+Vdseff*EsatL_Vge_si_Ve_di)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*EsatL_Ve_di/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*((Vdseff_Ve_di*EsatL-Vdseff*EsatL_Ve_di)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
  T6_Vge_si_Vge_si=(0.0/(1.0+(Vdseff/EsatL))-(0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+0.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)+1.0*(+0.0+(Vdseff_Vge_si_Vge_si/EsatL-(Vdseff_Vge_si*EsatL_Vge_si+Vdseff_Vge_si*EsatL_Vge_si+Vdseff*EsatL_Vge_si_Vge_si)/EsatL/EsatL+2*Vdseff*EsatL_Vge_si*EsatL_Vge_si/EsatL/EsatL/EsatL)))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))+2*1.0*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)*((Vdseff_Vge_si*EsatL-Vdseff*EsatL_Vge_si)/EsatL/EsatL)/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL))/(1.0+(Vdseff/EsatL)));
#endif
#endif
T6=(1.0/(1.0+(Vdseff/EsatL)));
EXIT_IF_ISNAN((1.0/(1.0+(Vdseff/EsatL))))
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gamma_Vge_di=((T6_Vge_di*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vge_di)+((((T0_Vge_di*T0)+(T0*T0_Vge_di))*(6.0*T2)-(T0*T0)*(6.0*T2_Vge_di))/(6.0*T2)/(6.0*T2)))));
gamma_Vdi_d=((T6_Vdi_d*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vdi_d)+(-(T0*T0)*(6.0*T2_Vdi_d)/(6.0*T2)/(6.0*T2)))));
gamma_Vsi_s=((T6_Vsi_s*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vsi_s)+(-(T0*T0)*(6.0*T2_Vsi_s)/(6.0*T2)/(6.0*T2)))));
gamma_Vge_e=((T6_Vge_e*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vge_e)+((((T0_Vge_e*T0)+(T0*T0_Vge_e))*(6.0*T2)-(T0*T0)*(6.0*T2_Vge_e))/(6.0*T2)/(6.0*T2)))));
gamma_Vdi_si=((T6_Vdi_si*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vdi_si)+((((T0_Vdi_si*T0)+(T0*T0_Vdi_si))*(6.0*T2)-(T0*T0)*(6.0*T2_Vdi_si))/(6.0*T2)/(6.0*T2)))));
gamma_Tempt_GND=((T6_Tempt_GND*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Tempt_GND)+((((T0_Tempt_GND*T0)+(T0*T0_Tempt_GND))*(6.0*T2)-(T0*T0)*(6.0*T2_Tempt_GND))/(6.0*T2)/(6.0*T2)))));
gamma_Ve_si=((T6_Ve_si*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Ve_si)+((((T0_Ve_si*T0)+(T0*T0_Ve_si))*(6.0*T2)-(T0*T0)*(6.0*T2_Ve_si))/(6.0*T2)/(6.0*T2)))));
gamma_Ve_di=((T6_Ve_di*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Ve_di)+((((T0_Ve_di*T0)+(T0*T0_Ve_di))*(6.0*T2)-(T0*T0)*(6.0*T2_Ve_di))/(6.0*T2)/(6.0*T2)))));
gamma_Vge_si=((T6_Vge_si*((0.5*T1)+((T0*T0)/(6.0*T2))))+(T6*((0.5*T1_Vge_si)+((((T0_Vge_si*T0)+(T0*T0_Vge_si))*(6.0*T2)-(T0*T0)*(6.0*T2_Vge_si))/(6.0*T2)/(6.0*T2)))));
#endif
gamma=(T6*((0.5*T1)+((T0*T0)/(6.0*T2))));
EXIT_IF_ISNAN((T6*((0.5*T1)+((T0*T0)/(6.0*T2)))))
#if defined(_DERIVATE) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
delta_Vdi_d=((((((T1_Vdi_d*T3-T1*T3_Vdi_d)/T3/T3)-((((5.0*T1_Vdi_d)+T2_Vdi_d)*T4*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vdi_d))/(15.0*T5)/(15.0*T5)))+(-(T4*T4)*(((9.0*T5_Vdi_d)*T2)+((9.0*T5)*T2_Vdi_d))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vdi_d)*T6)+((6.0*T6)*T6_Vdi_d))*T6)+(((6.0*T6)*T6)*T6_Vdi_d)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Vsi_s=((((((T1_Vsi_s*T3-T1*T3_Vsi_s)/T3/T3)-((((5.0*T1_Vsi_s)+T2_Vsi_s)*T4*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vsi_s))/(15.0*T5)/(15.0*T5)))+(-(T4*T4)*(((9.0*T5_Vsi_s)*T2)+((9.0*T5)*T2_Vsi_s))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vsi_s)*T6)+((6.0*T6)*T6_Vsi_s))*T6)+(((6.0*T6)*T6)*T6_Vsi_s)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Vge_di=((((((T1_Vge_di*T3-T1*T3_Vge_di)/T3/T3)-((((((5.0*T1_Vge_di)+T2_Vge_di)*T4)+(((5.0*T1)+T2)*T4_Vge_di))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vge_di))/(15.0*T5)/(15.0*T5)))+((((T4_Vge_di*T4)+(T4*T4_Vge_di))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Vge_di)*T2)+((9.0*T5)*T2_Vge_di)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vge_di)*T6)+((6.0*T6)*T6_Vge_di))*T6)+(((6.0*T6)*T6)*T6_Vge_di)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Vge_e=((((((T1_Vge_e*T3-T1*T3_Vge_e)/T3/T3)-((((((5.0*T1_Vge_e)+T2_Vge_e)*T4)+(((5.0*T1)+T2)*T4_Vge_e))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vge_e))/(15.0*T5)/(15.0*T5)))+((((T4_Vge_e*T4)+(T4*T4_Vge_e))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Vge_e)*T2)+((9.0*T5)*T2_Vge_e)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vge_e)*T6)+((6.0*T6)*T6_Vge_e))*T6)+(((6.0*T6)*T6)*T6_Vge_e)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Ve_si=((((((T1_Ve_si*T3-T1*T3_Ve_si)/T3/T3)-((((((5.0*T1_Ve_si)+T2_Ve_si)*T4)+(((5.0*T1)+T2)*T4_Ve_si))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Ve_si))/(15.0*T5)/(15.0*T5)))+((((T4_Ve_si*T4)+(T4*T4_Ve_si))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Ve_si)*T2)+((9.0*T5)*T2_Ve_si)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Ve_si)*T6)+((6.0*T6)*T6_Ve_si))*T6)+(((6.0*T6)*T6)*T6_Ve_si)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Ve_di=((((((T1_Ve_di*T3-T1*T3_Ve_di)/T3/T3)-((((((5.0*T1_Ve_di)+T2_Ve_di)*T4)+(((5.0*T1)+T2)*T4_Ve_di))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Ve_di))/(15.0*T5)/(15.0*T5)))+((((T4_Ve_di*T4)+(T4*T4_Ve_di))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Ve_di)*T2)+((9.0*T5)*T2_Ve_di)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Ve_di)*T6)+((6.0*T6)*T6_Ve_di))*T6)+(((6.0*T6)*T6)*T6_Ve_di)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Vge_si=((((((T1_Vge_si*T3-T1*T3_Vge_si)/T3/T3)-((((((5.0*T1_Vge_si)+T2_Vge_si)*T4)+(((5.0*T1)+T2)*T4_Vge_si))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vge_si))/(15.0*T5)/(15.0*T5)))+((((T4_Vge_si*T4)+(T4*T4_Vge_si))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Vge_si)*T2)+((9.0*T5)*T2_Vge_si)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vge_si)*T6)+((6.0*T6)*T6_Vge_si))*T6)+(((6.0*T6)*T6)*T6_Vge_si)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Vdi_si=((((((T1_Vdi_si*T3-T1*T3_Vdi_si)/T3/T3)-((((((5.0*T1_Vdi_si)+T2_Vdi_si)*T4)+(((5.0*T1)+T2)*T4_Vdi_si))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Vdi_si))/(15.0*T5)/(15.0*T5)))+((((T4_Vdi_si*T4)+(T4*T4_Vdi_si))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Vdi_si)*T2)+((9.0*T5)*T2_Vdi_si)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Vdi_si)*T6)+((6.0*T6)*T6_Vdi_si))*T6)+(((6.0*T6)*T6)*T6_Vdi_si)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
delta_Tempt_GND=((((((T1_Tempt_GND*T3-T1*T3_Tempt_GND)/T3/T3)-((((((5.0*T1_Tempt_GND)+T2_Tempt_GND)*T4)+(((5.0*T1)+T2)*T4_Tempt_GND))*(15.0*T5)-(((5.0*T1)+T2)*T4)*(15.0*T5_Tempt_GND))/(15.0*T5)/(15.0*T5)))+((((T4_Tempt_GND*T4)+(T4*T4_Tempt_GND))*((9.0*T5)*T2)-(T4*T4)*(((9.0*T5_Tempt_GND)*T2)+((9.0*T5)*T2_Tempt_GND)))/((9.0*T5)*T2)/((9.0*T5)*T2)))*(((6.0*T6)*T6)*T6)-(((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))*(((((6.0*T6_Tempt_GND)*T6)+((6.0*T6)*T6_Tempt_GND))*T6)+(((6.0*T6)*T6)*T6_Tempt_GND)))/(((6.0*T6)*T6)*T6)/(((6.0*T6)*T6)*T6));
#endif
delta=((((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))/(((6.0*T6)*T6)*T6));
EXIT_IF_ISNAN(((((T1/T3)-((((5.0*T1)+T2)*T4)/(15.0*T5)))+((T4*T4)/((9.0*T5)*T2)))/(((6.0*T6)*T6)*T6)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(ge,GND)V(di,GND)V(si,GND)V(e,GND)Temp(t,GND) */
T7_Vge_di=((T0_Vge_di*T2-T0*T2_Vge_di)/T2/T2);
#if defined(_DERIVATE2)
  T7_Vge_di_Vge_di=(T0_Vge_di_Vge_di/T2-(T0_Vge_di*T2_Vge_di+T0_Vge_di*T2_Vge_di+T0*T2_Vge_di_Vge_di)/T2/T2+2*T0*T2_Vge_di*T2_Vge_di/T2/T2/T2);
  T7_Vge_di_Vdi_d=(0.0/T2-(T0_Vge_di*T2_Vdi_d+0.0*T2_Vge_di+T0*T2_Vge_di_Vdi_d)/T2/T2+2*T0*T2_Vge_di*T2_Vdi_d/T2/T2/T2);
  T7_Vge_di_Vsi_s=(0.0/T2-(T0_Vge_di*T2_Vsi_s+0.0*T2_Vge_di+T0*T2_Vge_di_Vsi_s)/T2/T2+2*T0*T2_Vge_di*T2_Vsi_s/T2/T2/T2);
  T7_Vge_di_Vge_e=(T0_Vge_di_Vge_e/T2-(T0_Vge_di*T2_Vge_e+T0_Vge_e*T2_Vge_di+T0*T2_Vge_di_Vge_e)/T2/T2+2*T0*T2_Vge_di*T2_Vge_e/T2/T2/T2);
  T7_Vge_di_Vdi_si=(T0_Vge_di_Vdi_si/T2-(T0_Vge_di*T2_Vdi_si+T0_Vdi_si*T2_Vge_di+T0*T2_Vge_di_Vdi_si)/T2/T2+2*T0*T2_Vge_di*T2_Vdi_si/T2/T2/T2);
  T7_Vge_di_Ve_si=(T0_Vge_di_Ve_si/T2-(T0_Vge_di*T2_Ve_si+T0_Ve_si*T2_Vge_di+T0*T2_Vge_di_Ve_si)/T2/T2+2*T0*T2_Vge_di*T2_Ve_si/T2/T2/T2);
  T7_Vge_di_Ve_di=(T0_Vge_di_Ve_di/T2-(T0_Vge_di*T2_Ve_di+T0_Ve_di*T2_Vge_di+T0*T2_Vge_di_Ve_di)/T2/T2+2*T0*T2_Vge_di*T2_Ve_di/T2/T2/T2);
  T7_Vge_di_Vge_si=(T0_Vge_di_Vge_si/T2-(T0_Vge_di*T2_Vge_si+T0_Vge_si*T2_Vge_di+T0*T2_Vge_di_Vge_si)/T2/T2+2*T0*T2_Vge_di*T2_Vge_si/T2/T2/T2);
  T7_Vge_di_Tempt_GND=(T0_Vge_di_Tempt_GND/T2-(T0_Vge_di*T2_Tempt_GND+T0_Tempt_GND*T2_Vge_di+T0*T2_Vge_di_Tempt_GND)/T2/T2+2*T0*T2_Vge_di*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Vdi_d=(-T0*T2_Vdi_d/T2/T2);
#if defined(_DERIVATE2)
  T7_Vdi_d_Vge_di=(0.0/T2-(0.0*T2_Vge_di+T0_Vge_di*T2_Vdi_d+T0*T2_Vdi_d_Vge_di)/T2/T2+2*T0*T2_Vdi_d*T2_Vge_di/T2/T2/T2);
  T7_Vdi_d_Vdi_d=(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vdi_d+T0*T2_Vdi_d_Vdi_d)/T2/T2+2*T0*T2_Vdi_d*T2_Vdi_d/T2/T2/T2);
  T7_Vdi_d_Vsi_s=(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vdi_d+T0*T2_Vdi_d_Vsi_s)/T2/T2+2*T0*T2_Vdi_d*T2_Vsi_s/T2/T2/T2);
  T7_Vdi_d_Vge_e=(0.0/T2-(0.0*T2_Vge_e+T0_Vge_e*T2_Vdi_d+T0*T2_Vdi_d_Vge_e)/T2/T2+2*T0*T2_Vdi_d*T2_Vge_e/T2/T2/T2);
  T7_Vdi_d_Vdi_si=(0.0/T2-(0.0*T2_Vdi_si+T0_Vdi_si*T2_Vdi_d+T0*T2_Vdi_d_Vdi_si)/T2/T2+2*T0*T2_Vdi_d*T2_Vdi_si/T2/T2/T2);
  T7_Vdi_d_Ve_si=(0.0/T2-(0.0*T2_Ve_si+T0_Ve_si*T2_Vdi_d+T0*T2_Vdi_d_Ve_si)/T2/T2+2*T0*T2_Vdi_d*T2_Ve_si/T2/T2/T2);
  T7_Vdi_d_Ve_di=(0.0/T2-(0.0*T2_Ve_di+T0_Ve_di*T2_Vdi_d+T0*T2_Vdi_d_Ve_di)/T2/T2+2*T0*T2_Vdi_d*T2_Ve_di/T2/T2/T2);
  T7_Vdi_d_Vge_si=(0.0/T2-(0.0*T2_Vge_si+T0_Vge_si*T2_Vdi_d+T0*T2_Vdi_d_Vge_si)/T2/T2+2*T0*T2_Vdi_d*T2_Vge_si/T2/T2/T2);
  T7_Vdi_d_Tempt_GND=(0.0/T2-(0.0*T2_Tempt_GND+T0_Tempt_GND*T2_Vdi_d+T0*T2_Vdi_d_Tempt_GND)/T2/T2+2*T0*T2_Vdi_d*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Vsi_s=(-T0*T2_Vsi_s/T2/T2);
#if defined(_DERIVATE2)
  T7_Vsi_s_Vge_di=(0.0/T2-(0.0*T2_Vge_di+T0_Vge_di*T2_Vsi_s+T0*T2_Vsi_s_Vge_di)/T2/T2+2*T0*T2_Vsi_s*T2_Vge_di/T2/T2/T2);
  T7_Vsi_s_Vdi_d=(0.0/T2-(0.0*T2_Vdi_d+0.0*T2_Vsi_s+T0*T2_Vsi_s_Vdi_d)/T2/T2+2*T0*T2_Vsi_s*T2_Vdi_d/T2/T2/T2);
  T7_Vsi_s_Vsi_s=(0.0/T2-(0.0*T2_Vsi_s+0.0*T2_Vsi_s+T0*T2_Vsi_s_Vsi_s)/T2/T2+2*T0*T2_Vsi_s*T2_Vsi_s/T2/T2/T2);
  T7_Vsi_s_Vge_e=(0.0/T2-(0.0*T2_Vge_e+T0_Vge_e*T2_Vsi_s+T0*T2_Vsi_s_Vge_e)/T2/T2+2*T0*T2_Vsi_s*T2_Vge_e/T2/T2/T2);
  T7_Vsi_s_Vdi_si=(0.0/T2-(0.0*T2_Vdi_si+T0_Vdi_si*T2_Vsi_s+T0*T2_Vsi_s_Vdi_si)/T2/T2+2*T0*T2_Vsi_s*T2_Vdi_si/T2/T2/T2);
  T7_Vsi_s_Ve_si=(0.0/T2-(0.0*T2_Ve_si+T0_Ve_si*T2_Vsi_s+T0*T2_Vsi_s_Ve_si)/T2/T2+2*T0*T2_Vsi_s*T2_Ve_si/T2/T2/T2);
  T7_Vsi_s_Ve_di=(0.0/T2-(0.0*T2_Ve_di+T0_Ve_di*T2_Vsi_s+T0*T2_Vsi_s_Ve_di)/T2/T2+2*T0*T2_Vsi_s*T2_Ve_di/T2/T2/T2);
  T7_Vsi_s_Vge_si=(0.0/T2-(0.0*T2_Vge_si+T0_Vge_si*T2_Vsi_s+T0*T2_Vsi_s_Vge_si)/T2/T2+2*T0*T2_Vsi_s*T2_Vge_si/T2/T2/T2);
  T7_Vsi_s_Tempt_GND=(0.0/T2-(0.0*T2_Tempt_GND+T0_Tempt_GND*T2_Vsi_s+T0*T2_Vsi_s_Tempt_GND)/T2/T2+2*T0*T2_Vsi_s*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Vge_e=((T0_Vge_e*T2-T0*T2_Vge_e)/T2/T2);
#if defined(_DERIVATE2)
  T7_Vge_e_Vge_di=(T0_Vge_e_Vge_di/T2-(T0_Vge_e*T2_Vge_di+T0_Vge_di*T2_Vge_e+T0*T2_Vge_e_Vge_di)/T2/T2+2*T0*T2_Vge_e*T2_Vge_di/T2/T2/T2);
  T7_Vge_e_Vdi_d=(0.0/T2-(T0_Vge_e*T2_Vdi_d+0.0*T2_Vge_e+T0*T2_Vge_e_Vdi_d)/T2/T2+2*T0*T2_Vge_e*T2_Vdi_d/T2/T2/T2);
  T7_Vge_e_Vsi_s=(0.0/T2-(T0_Vge_e*T2_Vsi_s+0.0*T2_Vge_e+T0*T2_Vge_e_Vsi_s)/T2/T2+2*T0*T2_Vge_e*T2_Vsi_s/T2/T2/T2);
  T7_Vge_e_Vge_e=(T0_Vge_e_Vge_e/T2-(T0_Vge_e*T2_Vge_e+T0_Vge_e*T2_Vge_e+T0*T2_Vge_e_Vge_e)/T2/T2+2*T0*T2_Vge_e*T2_Vge_e/T2/T2/T2);
  T7_Vge_e_Vdi_si=(T0_Vge_e_Vdi_si/T2-(T0_Vge_e*T2_Vdi_si+T0_Vdi_si*T2_Vge_e+T0*T2_Vge_e_Vdi_si)/T2/T2+2*T0*T2_Vge_e*T2_Vdi_si/T2/T2/T2);
  T7_Vge_e_Ve_si=(T0_Vge_e_Ve_si/T2-(T0_Vge_e*T2_Ve_si+T0_Ve_si*T2_Vge_e+T0*T2_Vge_e_Ve_si)/T2/T2+2*T0*T2_Vge_e*T2_Ve_si/T2/T2/T2);
  T7_Vge_e_Ve_di=(T0_Vge_e_Ve_di/T2-(T0_Vge_e*T2_Ve_di+T0_Ve_di*T2_Vge_e+T0*T2_Vge_e_Ve_di)/T2/T2+2*T0*T2_Vge_e*T2_Ve_di/T2/T2/T2);
  T7_Vge_e_Vge_si=(T0_Vge_e_Vge_si/T2-(T0_Vge_e*T2_Vge_si+T0_Vge_si*T2_Vge_e+T0*T2_Vge_e_Vge_si)/T2/T2+2*T0*T2_Vge_e*T2_Vge_si/T2/T2/T2);
  T7_Vge_e_Tempt_GND=(T0_Vge_e_Tempt_GND/T2-(T0_Vge_e*T2_Tempt_GND+T0_Tempt_GND*T2_Vge_e+T0*T2_Vge_e_Tempt_GND)/T2/T2+2*T0*T2_Vge_e*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Vdi_si=((T0_Vdi_si*T2-T0*T2_Vdi_si)/T2/T2);
#if defined(_DERIVATE2)
  T7_Vdi_si_Vge_di=(T0_Vdi_si_Vge_di/T2-(T0_Vdi_si*T2_Vge_di+T0_Vge_di*T2_Vdi_si+T0*T2_Vdi_si_Vge_di)/T2/T2+2*T0*T2_Vdi_si*T2_Vge_di/T2/T2/T2);
  T7_Vdi_si_Vdi_d=(0.0/T2-(T0_Vdi_si*T2_Vdi_d+0.0*T2_Vdi_si+T0*T2_Vdi_si_Vdi_d)/T2/T2+2*T0*T2_Vdi_si*T2_Vdi_d/T2/T2/T2);
  T7_Vdi_si_Vsi_s=(0.0/T2-(T0_Vdi_si*T2_Vsi_s+0.0*T2_Vdi_si+T0*T2_Vdi_si_Vsi_s)/T2/T2+2*T0*T2_Vdi_si*T2_Vsi_s/T2/T2/T2);
  T7_Vdi_si_Vge_e=(T0_Vdi_si_Vge_e/T2-(T0_Vdi_si*T2_Vge_e+T0_Vge_e*T2_Vdi_si+T0*T2_Vdi_si_Vge_e)/T2/T2+2*T0*T2_Vdi_si*T2_Vge_e/T2/T2/T2);
  T7_Vdi_si_Vdi_si=(T0_Vdi_si_Vdi_si/T2-(T0_Vdi_si*T2_Vdi_si+T0_Vdi_si*T2_Vdi_si+T0*T2_Vdi_si_Vdi_si)/T2/T2+2*T0*T2_Vdi_si*T2_Vdi_si/T2/T2/T2);
  T7_Vdi_si_Ve_si=(T0_Vdi_si_Ve_si/T2-(T0_Vdi_si*T2_Ve_si+T0_Ve_si*T2_Vdi_si+T0*T2_Vdi_si_Ve_si)/T2/T2+2*T0*T2_Vdi_si*T2_Ve_si/T2/T2/T2);
  T7_Vdi_si_Ve_di=(T0_Vdi_si_Ve_di/T2-(T0_Vdi_si*T2_Ve_di+T0_Ve_di*T2_Vdi_si+T0*T2_Vdi_si_Ve_di)/T2/T2+2*T0*T2_Vdi_si*T2_Ve_di/T2/T2/T2);
  T7_Vdi_si_Vge_si=(T0_Vdi_si_Vge_si/T2-(T0_Vdi_si*T2_Vge_si+T0_Vge_si*T2_Vdi_si+T0*T2_Vdi_si_Vge_si)/T2/T2+2*T0*T2_Vdi_si*T2_Vge_si/T2/T2/T2);
  T7_Vdi_si_Tempt_GND=(T0_Vdi_si_Tempt_GND/T2-(T0_Vdi_si*T2_Tempt_GND+T0_Tempt_GND*T2_Vdi_si+T0*T2_Vdi_si_Tempt_GND)/T2/T2+2*T0*T2_Vdi_si*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Ve_si=((T0_Ve_si*T2-T0*T2_Ve_si)/T2/T2);
#if defined(_DERIVATE2)
  T7_Ve_si_Vge_di=(T0_Ve_si_Vge_di/T2-(T0_Ve_si*T2_Vge_di+T0_Vge_di*T2_Ve_si+T0*T2_Ve_si_Vge_di)/T2/T2+2*T0*T2_Ve_si*T2_Vge_di/T2/T2/T2);
  T7_Ve_si_Vdi_d=(0.0/T2-(T0_Ve_si*T2_Vdi_d+0.0*T2_Ve_si+T0*T2_Ve_si_Vdi_d)/T2/T2+2*T0*T2_Ve_si*T2_Vdi_d/T2/T2/T2);
  T7_Ve_si_Vsi_s=(0.0/T2-(T0_Ve_si*T2_Vsi_s+0.0*T2_Ve_si+T0*T2_Ve_si_Vsi_s)/T2/T2+2*T0*T2_Ve_si*T2_Vsi_s/T2/T2/T2);
  T7_Ve_si_Vge_e=(T0_Ve_si_Vge_e/T2-(T0_Ve_si*T2_Vge_e+T0_Vge_e*T2_Ve_si+T0*T2_Ve_si_Vge_e)/T2/T2+2*T0*T2_Ve_si*T2_Vge_e/T2/T2/T2);
  T7_Ve_si_Vdi_si=(T0_Ve_si_Vdi_si/T2-(T0_Ve_si*T2_Vdi_si+T0_Vdi_si*T2_Ve_si+T0*T2_Ve_si_Vdi_si)/T2/T2+2*T0*T2_Ve_si*T2_Vdi_si/T2/T2/T2);
  T7_Ve_si_Ve_si=(T0_Ve_si_Ve_si/T2-(T0_Ve_si*T2_Ve_si+T0_Ve_si*T2_Ve_si+T0*T2_Ve_si_Ve_si)/T2/T2+2*T0*T2_Ve_si*T2_Ve_si/T2/T2/T2);
  T7_Ve_si_Ve_di=(T0_Ve_si_Ve_di/T2-(T0_Ve_si*T2_Ve_di+T0_Ve_di*T2_Ve_si+T0*T2_Ve_si_Ve_di)/T2/T2+2*T0*T2_Ve_si*T2_Ve_di/T2/T2/T2);
  T7_Ve_si_Vge_si=(T0_Ve_si_Vge_si/T2-(T0_Ve_si*T2_Vge_si+T0_Vge_si*T2_Ve_si+T0*T2_Ve_si_Vge_si)/T2/T2+2*T0*T2_Ve_si*T2_Vge_si/T2/T2/T2);
  T7_Ve_si_Tempt_GND=(T0_Ve_si_Tempt_GND/T2-(T0_Ve_si*T2_Tempt_GND+T0_Tempt_GND*T2_Ve_si+T0*T2_Ve_si_Tempt_GND)/T2/T2+2*T0*T2_Ve_si*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Ve_di=((T0_Ve_di*T2-T0*T2_Ve_di)/T2/T2);
#if defined(_DERIVATE2)
  T7_Ve_di_Vge_di=(T0_Ve_di_Vge_di/T2-(T0_Ve_di*T2_Vge_di+T0_Vge_di*T2_Ve_di+T0*T2_Ve_di_Vge_di)/T2/T2+2*T0*T2_Ve_di*T2_Vge_di/T2/T2/T2);
  T7_Ve_di_Vdi_d=(0.0/T2-(T0_Ve_di*T2_Vdi_d+0.0*T2_Ve_di+T0*T2_Ve_di_Vdi_d)/T2/T2+2*T0*T2_Ve_di*T2_Vdi_d/T2/T2/T2);
  T7_Ve_di_Vsi_s=(0.0/T2-(T0_Ve_di*T2_Vsi_s+0.0*T2_Ve_di+T0*T2_Ve_di_Vsi_s)/T2/T2+2*T0*T2_Ve_di*T2_Vsi_s/T2/T2/T2);
  T7_Ve_di_Vge_e=(T0_Ve_di_Vge_e/T2-(T0_Ve_di*T2_Vge_e+T0_Vge_e*T2_Ve_di+T0*T2_Ve_di_Vge_e)/T2/T2+2*T0*T2_Ve_di*T2_Vge_e/T2/T2/T2);
  T7_Ve_di_Vdi_si=(T0_Ve_di_Vdi_si/T2-(T0_Ve_di*T2_Vdi_si+T0_Vdi_si*T2_Ve_di+T0*T2_Ve_di_Vdi_si)/T2/T2+2*T0*T2_Ve_di*T2_Vdi_si/T2/T2/T2);
  T7_Ve_di_Ve_si=(T0_Ve_di_Ve_si/T2-(T0_Ve_di*T2_Ve_si+T0_Ve_si*T2_Ve_di+T0*T2_Ve_di_Ve_si)/T2/T2+2*T0*T2_Ve_di*T2_Ve_si/T2/T2/T2);
  T7_Ve_di_Ve_di=(T0_Ve_di_Ve_di/T2-(T0_Ve_di*T2_Ve_di+T0_Ve_di*T2_Ve_di+T0*T2_Ve_di_Ve_di)/T2/T2+2*T0*T2_Ve_di*T2_Ve_di/T2/T2/T2);
  T7_Ve_di_Vge_si=(T0_Ve_di_Vge_si/T2-(T0_Ve_di*T2_Vge_si+T0_Vge_si*T2_Ve_di+T0*T2_Ve_di_Vge_si)/T2/T2+2*T0*T2_Ve_di*T2_Vge_si/T2/T2/T2);
  T7_Ve_di_Tempt_GND=(T0_Ve_di_Tempt_GND/T2-(T0_Ve_di*T2_Tempt_GND+T0_Tempt_GND*T2_Ve_di+T0*T2_Ve_di_Tempt_GND)/T2/T2+2*T0*T2_Ve_di*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Vge_si=((T0_Vge_si*T2-T0*T2_Vge_si)/T2/T2);
#if defined(_DERIVATE2)
  T7_Vge_si_Vge_di=(T0_Vge_si_Vge_di/T2-(T0_Vge_si*T2_Vge_di+T0_Vge_di*T2_Vge_si+T0*T2_Vge_si_Vge_di)/T2/T2+2*T0*T2_Vge_si*T2_Vge_di/T2/T2/T2);
  T7_Vge_si_Vdi_d=(0.0/T2-(T0_Vge_si*T2_Vdi_d+0.0*T2_Vge_si+T0*T2_Vge_si_Vdi_d)/T2/T2+2*T0*T2_Vge_si*T2_Vdi_d/T2/T2/T2);
  T7_Vge_si_Vsi_s=(0.0/T2-(T0_Vge_si*T2_Vsi_s+0.0*T2_Vge_si+T0*T2_Vge_si_Vsi_s)/T2/T2+2*T0*T2_Vge_si*T2_Vsi_s/T2/T2/T2);
  T7_Vge_si_Vge_e=(T0_Vge_si_Vge_e/T2-(T0_Vge_si*T2_Vge_e+T0_Vge_e*T2_Vge_si+T0*T2_Vge_si_Vge_e)/T2/T2+2*T0*T2_Vge_si*T2_Vge_e/T2/T2/T2);
  T7_Vge_si_Vdi_si=(T0_Vge_si_Vdi_si/T2-(T0_Vge_si*T2_Vdi_si+T0_Vdi_si*T2_Vge_si+T0*T2_Vge_si_Vdi_si)/T2/T2+2*T0*T2_Vge_si*T2_Vdi_si/T2/T2/T2);
  T7_Vge_si_Ve_si=(T0_Vge_si_Ve_si/T2-(T0_Vge_si*T2_Ve_si+T0_Ve_si*T2_Vge_si+T0*T2_Vge_si_Ve_si)/T2/T2+2*T0*T2_Vge_si*T2_Ve_si/T2/T2/T2);
  T7_Vge_si_Ve_di=(T0_Vge_si_Ve_di/T2-(T0_Vge_si*T2_Ve_di+T0_Ve_di*T2_Vge_si+T0*T2_Vge_si_Ve_di)/T2/T2+2*T0*T2_Vge_si*T2_Ve_di/T2/T2/T2);
  T7_Vge_si_Vge_si=(T0_Vge_si_Vge_si/T2-(T0_Vge_si*T2_Vge_si+T0_Vge_si*T2_Vge_si+T0*T2_Vge_si_Vge_si)/T2/T2+2*T0*T2_Vge_si*T2_Vge_si/T2/T2/T2);
  T7_Vge_si_Tempt_GND=(T0_Vge_si_Tempt_GND/T2-(T0_Vge_si*T2_Tempt_GND+T0_Tempt_GND*T2_Vge_si+T0*T2_Vge_si_Tempt_GND)/T2/T2+2*T0*T2_Vge_si*T2_Tempt_GND/T2/T2/T2);
#endif
T7_Tempt_GND=((T0_Tempt_GND*T2-T0*T2_Tempt_GND)/T2/T2);
#if defined(_DERIVATE2)
  T7_Tempt_GND_Vge_di=(T0_Tempt_GND_Vge_di/T2-(T0_Tempt_GND*T2_Vge_di+T0_Vge_di*T2_Tempt_GND+T0*T2_Tempt_GND_Vge_di)/T2/T2+2*T0*T2_Tempt_GND*T2_Vge_di/T2/T2/T2);
  T7_Tempt_GND_Vdi_d=(0.0/T2-(T0_Tempt_GND*T2_Vdi_d+0.0*T2_Tempt_GND+T0*T2_Tempt_GND_Vdi_d)/T2/T2+2*T0*T2_Tempt_GND*T2_Vdi_d/T2/T2/T2);
  T7_Tempt_GND_Vsi_s=(0.0/T2-(T0_Tempt_GND*T2_Vsi_s+0.0*T2_Tempt_GND+T0*T2_Tempt_GND_Vsi_s)/T2/T2+2*T0*T2_Tempt_GND*T2_Vsi_s/T2/T2/T2);
  T7_Tempt_GND_Vge_e=(T0_Tempt_GND_Vge_e/T2-(T0_Tempt_GND*T2_Vge_e+T0_Vge_e*T2_Tempt_GND+T0*T2_Tempt_GND_Vge_e)/T2/T2+2*T0*T2_Tempt_GND*T2_Vge_e/T2/T2/T2);
  T7_Tempt_GND_Vdi_si=(T0_Tempt_GND_Vdi_si/T2-(T0_Tempt_GND*T2_Vdi_si+T0_Vdi_si*T2_Tempt_GND+T0*T2_Tempt_GND_Vdi_si)/T2/T2+2*T0*T2_Tempt_GND*T2_Vdi_si/T2/T2/T2);
  T7_Tempt_GND_Ve_si=(T0_Tempt_GND_Ve_si/T2-(T0_Tempt_GND*T2_Ve_si+T0_Ve_si*T2_Tempt_GND+T0*T2_Tempt_GND_Ve_si)/T2/T2+2*T0*T2_Tempt_GND*T2_Ve_si/T2/T2/T2);
  T7_Tempt_GND_Ve_di=(T0_Tempt_GND_Ve_di/T2-(T0_Tempt_GND*T2_Ve_di+T0_Ve_di*T2_Tempt_GND+T0*T2_Tempt_GND_Ve_di)/T2/T2+2*T0*T2_Tempt_GND*T2_Ve_di/T2/T2/T2);
  T7_Tempt_GND_Vge_si=(T0_Tempt_GND_Vge_si/T2-(T0_Tempt_GND*T2_Vge_si+T0_Vge_si*T2_Tempt_GND+T0*T2_Tempt_GND_Vge_si)/T2/T2+2*T0*T2_Tempt_GND*T2_Vge_si/T2/T2/T2);
  T7_Tempt_GND_Tempt_GND=(T0_Tempt_GND_Tempt_GND/T2-(T0_Tempt_GND*T2_Tempt_GND+T0_Tempt_GND*T2_Tempt_GND+T0*T2_Tempt_GND_Tempt_GND)/T2/T2+2*T0*T2_Tempt_GND*T2_Tempt_GND/T2/T2/T2);
#endif
#endif
T7=(T0/T2);
EXIT_IF_ISNAN((T0/T2))
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
epsilon_Vge_di=(((T7_Vge_di+(((((T7_Vge_di*T7)+(T7*T7_Vge_di))*T7)+((T7*T7)*T7_Vge_di))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vge_di))/(6.0*T6)/(6.0*T6));
epsilon_Vdi_d=(((T7_Vdi_d+(((((T7_Vdi_d*T7)+(T7*T7_Vdi_d))*T7)+((T7*T7)*T7_Vdi_d))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vdi_d))/(6.0*T6)/(6.0*T6));
epsilon_Vsi_s=(((T7_Vsi_s+(((((T7_Vsi_s*T7)+(T7*T7_Vsi_s))*T7)+((T7*T7)*T7_Vsi_s))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vsi_s))/(6.0*T6)/(6.0*T6));
epsilon_Vge_e=(((T7_Vge_e+(((((T7_Vge_e*T7)+(T7*T7_Vge_e))*T7)+((T7*T7)*T7_Vge_e))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vge_e))/(6.0*T6)/(6.0*T6));
epsilon_Vdi_si=(((T7_Vdi_si+(((((T7_Vdi_si*T7)+(T7*T7_Vdi_si))*T7)+((T7*T7)*T7_Vdi_si))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vdi_si))/(6.0*T6)/(6.0*T6));
epsilon_Ve_si=(((T7_Ve_si+(((((T7_Ve_si*T7)+(T7*T7_Ve_si))*T7)+((T7*T7)*T7_Ve_si))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Ve_si))/(6.0*T6)/(6.0*T6));
epsilon_Ve_di=(((T7_Ve_di+(((((T7_Ve_di*T7)+(T7*T7_Ve_di))*T7)+((T7*T7)*T7_Ve_di))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Ve_di))/(6.0*T6)/(6.0*T6));
epsilon_Vge_si=(((T7_Vge_si+(((((T7_Vge_si*T7)+(T7*T7_Vge_si))*T7)+((T7*T7)*T7_Vge_si))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Vge_si))/(6.0*T6)/(6.0*T6));
epsilon_Tempt_GND=(((T7_Tempt_GND+(((((T7_Tempt_GND*T7)+(T7*T7_Tempt_GND))*T7)+((T7*T7)*T7_Tempt_GND))/3.0))*(6.0*T6)-(T7+(((T7*T7)*T7)/3.0))*(6.0*T6_Tempt_GND))/(6.0*T6)/(6.0*T6));
#endif
epsilon=((T7+(((T7*T7)*T7)/3.0))/(6.0*T6));
EXIT_IF_ISNAN(((T7+(((T7*T7)*T7)/3.0))/(6.0*T6)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=0.0;
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=0.0;
  T8_Vge_e_Vdi_si=0.0;
  T8_Vge_e_Ve_si=0.0;
  T8_Vge_e_Ve_di=0.0;
  T8_Vge_e_Vge_si=0.0;
  T8_Vge_e_Tempt_GND=0.0;
#endif
T8_Vdi_si=((qia_Vdi_si*EsatL-qia*EsatL_Vdi_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(0.0/EsatL-(qia_Vdi_si*0.0+0.0*EsatL_Vdi_si+qia*0.0)/EsatL/EsatL+2*qia*EsatL_Vdi_si*0.0/EsatL/EsatL/EsatL);
  T8_Vdi_si_Vdi_si=(qia_Vdi_si_Vdi_si/EsatL-(qia_Vdi_si*EsatL_Vdi_si+qia_Vdi_si*EsatL_Vdi_si+qia*EsatL_Vdi_si_Vdi_si)/EsatL/EsatL+2*qia*EsatL_Vdi_si*EsatL_Vdi_si/EsatL/EsatL/EsatL);
  T8_Vdi_si_Ve_si=(qia_Vdi_si_Ve_si/EsatL-(qia_Vdi_si*EsatL_Ve_si+qia_Ve_si*EsatL_Vdi_si+qia*EsatL_Vdi_si_Ve_si)/EsatL/EsatL+2*qia*EsatL_Vdi_si*EsatL_Ve_si/EsatL/EsatL/EsatL);
  T8_Vdi_si_Ve_di=(qia_Vdi_si_Ve_di/EsatL-(qia_Vdi_si*EsatL_Ve_di+qia_Ve_di*EsatL_Vdi_si+qia*EsatL_Vdi_si_Ve_di)/EsatL/EsatL+2*qia*EsatL_Vdi_si*EsatL_Ve_di/EsatL/EsatL/EsatL);
  T8_Vdi_si_Vge_si=(qia_Vdi_si_Vge_si/EsatL-(qia_Vdi_si*EsatL_Vge_si+qia_Vge_si*EsatL_Vdi_si+qia*EsatL_Vdi_si_Vge_si)/EsatL/EsatL+2*qia*EsatL_Vdi_si*EsatL_Vge_si/EsatL/EsatL/EsatL);
  T8_Vdi_si_Tempt_GND=(qia_Vdi_si_Tempt_GND/EsatL-(qia_Vdi_si*EsatL_Tempt_GND+qia_Tempt_GND*EsatL_Vdi_si+qia*EsatL_Vdi_si_Tempt_GND)/EsatL/EsatL+2*qia*EsatL_Vdi_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL);
#endif
T8_Ve_si=((qia_Ve_si*EsatL-qia*EsatL_Ve_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(0.0/EsatL-(qia_Ve_si*0.0+0.0*EsatL_Ve_si+qia*0.0)/EsatL/EsatL+2*qia*EsatL_Ve_si*0.0/EsatL/EsatL/EsatL);
  T8_Ve_si_Vdi_si=(qia_Ve_si_Vdi_si/EsatL-(qia_Ve_si*EsatL_Vdi_si+qia_Vdi_si*EsatL_Ve_si+qia*EsatL_Ve_si_Vdi_si)/EsatL/EsatL+2*qia*EsatL_Ve_si*EsatL_Vdi_si/EsatL/EsatL/EsatL);
  T8_Ve_si_Ve_si=(qia_Ve_si_Ve_si/EsatL-(qia_Ve_si*EsatL_Ve_si+qia_Ve_si*EsatL_Ve_si+qia*EsatL_Ve_si_Ve_si)/EsatL/EsatL+2*qia*EsatL_Ve_si*EsatL_Ve_si/EsatL/EsatL/EsatL);
  T8_Ve_si_Ve_di=(qia_Ve_si_Ve_di/EsatL-(qia_Ve_si*EsatL_Ve_di+qia_Ve_di*EsatL_Ve_si+qia*EsatL_Ve_si_Ve_di)/EsatL/EsatL+2*qia*EsatL_Ve_si*EsatL_Ve_di/EsatL/EsatL/EsatL);
  T8_Ve_si_Vge_si=(qia_Ve_si_Vge_si/EsatL-(qia_Ve_si*EsatL_Vge_si+qia_Vge_si*EsatL_Ve_si+qia*EsatL_Ve_si_Vge_si)/EsatL/EsatL+2*qia*EsatL_Ve_si*EsatL_Vge_si/EsatL/EsatL/EsatL);
  T8_Ve_si_Tempt_GND=(qia_Ve_si_Tempt_GND/EsatL-(qia_Ve_si*EsatL_Tempt_GND+qia_Tempt_GND*EsatL_Ve_si+qia*EsatL_Ve_si_Tempt_GND)/EsatL/EsatL+2*qia*EsatL_Ve_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL);
#endif
T8_Ve_di=((qia_Ve_di*EsatL-qia*EsatL_Ve_di)/EsatL/EsatL);
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(0.0/EsatL-(qia_Ve_di*0.0+0.0*EsatL_Ve_di+qia*0.0)/EsatL/EsatL+2*qia*EsatL_Ve_di*0.0/EsatL/EsatL/EsatL);
  T8_Ve_di_Vdi_si=(qia_Ve_di_Vdi_si/EsatL-(qia_Ve_di*EsatL_Vdi_si+qia_Vdi_si*EsatL_Ve_di+qia*EsatL_Ve_di_Vdi_si)/EsatL/EsatL+2*qia*EsatL_Ve_di*EsatL_Vdi_si/EsatL/EsatL/EsatL);
  T8_Ve_di_Ve_si=(qia_Ve_di_Ve_si/EsatL-(qia_Ve_di*EsatL_Ve_si+qia_Ve_si*EsatL_Ve_di+qia*EsatL_Ve_di_Ve_si)/EsatL/EsatL+2*qia*EsatL_Ve_di*EsatL_Ve_si/EsatL/EsatL/EsatL);
  T8_Ve_di_Ve_di=(qia_Ve_di_Ve_di/EsatL-(qia_Ve_di*EsatL_Ve_di+qia_Ve_di*EsatL_Ve_di+qia*EsatL_Ve_di_Ve_di)/EsatL/EsatL+2*qia*EsatL_Ve_di*EsatL_Ve_di/EsatL/EsatL/EsatL);
  T8_Ve_di_Vge_si=(qia_Ve_di_Vge_si/EsatL-(qia_Ve_di*EsatL_Vge_si+qia_Vge_si*EsatL_Ve_di+qia*EsatL_Ve_di_Vge_si)/EsatL/EsatL+2*qia*EsatL_Ve_di*EsatL_Vge_si/EsatL/EsatL/EsatL);
  T8_Ve_di_Tempt_GND=(qia_Ve_di_Tempt_GND/EsatL-(qia_Ve_di*EsatL_Tempt_GND+qia_Tempt_GND*EsatL_Ve_di+qia*EsatL_Ve_di_Tempt_GND)/EsatL/EsatL+2*qia*EsatL_Ve_di*EsatL_Tempt_GND/EsatL/EsatL/EsatL);
#endif
T8_Vge_si=((qia_Vge_si*EsatL-qia*EsatL_Vge_si)/EsatL/EsatL);
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(0.0/EsatL-(qia_Vge_si*0.0+0.0*EsatL_Vge_si+qia*0.0)/EsatL/EsatL+2*qia*EsatL_Vge_si*0.0/EsatL/EsatL/EsatL);
  T8_Vge_si_Vdi_si=(qia_Vge_si_Vdi_si/EsatL-(qia_Vge_si*EsatL_Vdi_si+qia_Vdi_si*EsatL_Vge_si+qia*EsatL_Vge_si_Vdi_si)/EsatL/EsatL+2*qia*EsatL_Vge_si*EsatL_Vdi_si/EsatL/EsatL/EsatL);
  T8_Vge_si_Ve_si=(qia_Vge_si_Ve_si/EsatL-(qia_Vge_si*EsatL_Ve_si+qia_Ve_si*EsatL_Vge_si+qia*EsatL_Vge_si_Ve_si)/EsatL/EsatL+2*qia*EsatL_Vge_si*EsatL_Ve_si/EsatL/EsatL/EsatL);
  T8_Vge_si_Ve_di=(qia_Vge_si_Ve_di/EsatL-(qia_Vge_si*EsatL_Ve_di+qia_Ve_di*EsatL_Vge_si+qia*EsatL_Vge_si_Ve_di)/EsatL/EsatL+2*qia*EsatL_Vge_si*EsatL_Ve_di/EsatL/EsatL/EsatL);
  T8_Vge_si_Vge_si=(qia_Vge_si_Vge_si/EsatL-(qia_Vge_si*EsatL_Vge_si+qia_Vge_si*EsatL_Vge_si+qia*EsatL_Vge_si_Vge_si)/EsatL/EsatL+2*qia*EsatL_Vge_si*EsatL_Vge_si/EsatL/EsatL/EsatL);
  T8_Vge_si_Tempt_GND=(qia_Vge_si_Tempt_GND/EsatL-(qia_Vge_si*EsatL_Tempt_GND+qia_Tempt_GND*EsatL_Vge_si+qia*EsatL_Vge_si_Tempt_GND)/EsatL/EsatL+2*qia*EsatL_Vge_si*EsatL_Tempt_GND/EsatL/EsatL/EsatL);
#endif
T8_Tempt_GND=((qia_Tempt_GND*EsatL-qia*EsatL_Tempt_GND)/EsatL/EsatL);
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(0.0/EsatL-(qia_Tempt_GND*0.0+0.0*EsatL_Tempt_GND+qia*0.0)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*0.0/EsatL/EsatL/EsatL);
  T8_Tempt_GND_Vdi_si=(qia_Tempt_GND_Vdi_si/EsatL-(qia_Tempt_GND*EsatL_Vdi_si+qia_Vdi_si*EsatL_Tempt_GND+qia*EsatL_Tempt_GND_Vdi_si)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*EsatL_Vdi_si/EsatL/EsatL/EsatL);
  T8_Tempt_GND_Ve_si=(qia_Tempt_GND_Ve_si/EsatL-(qia_Tempt_GND*EsatL_Ve_si+qia_Ve_si*EsatL_Tempt_GND+qia*EsatL_Tempt_GND_Ve_si)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*EsatL_Ve_si/EsatL/EsatL/EsatL);
  T8_Tempt_GND_Ve_di=(qia_Tempt_GND_Ve_di/EsatL-(qia_Tempt_GND*EsatL_Ve_di+qia_Ve_di*EsatL_Tempt_GND+qia*EsatL_Tempt_GND_Ve_di)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*EsatL_Ve_di/EsatL/EsatL/EsatL);
  T8_Tempt_GND_Vge_si=(qia_Tempt_GND_Vge_si/EsatL-(qia_Tempt_GND*EsatL_Vge_si+qia_Vge_si*EsatL_Tempt_GND+qia*EsatL_Tempt_GND_Vge_si)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*EsatL_Vge_si/EsatL/EsatL/EsatL);
  T8_Tempt_GND_Tempt_GND=(qia_Tempt_GND_Tempt_GND/EsatL-(qia_Tempt_GND*EsatL_Tempt_GND+qia_Tempt_GND*EsatL_Tempt_GND+qia*EsatL_Tempt_GND_Tempt_GND)/EsatL/EsatL+2*qia*EsatL_Tempt_GND*EsatL_Tempt_GND/EsatL/EsatL/EsatL);
#endif
#endif
T8=(qia/EsatL);
EXIT_IF_ISNAN((qia/EsatL))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T8_Vge_e=((T8_Vge_e*T8)+(T8*T8_Vge_e));
#if defined(_DERIVATE2)
  T8_Vge_e_Vge_e=(+T8_Vge_e_Vge_e*T8+T8_Vge_e*T8_Vge_e+T8_Vge_e*T8_Vge_e+T8*T8_Vge_e_Vge_e);
  T8_Vge_e_Vdi_si=(+T8_Vge_e_Vdi_si*T8+T8_Vge_e*T8_Vdi_si+T8_Vdi_si*T8_Vge_e+T8*T8_Vge_e_Vdi_si);
  T8_Vge_e_Ve_si=(+T8_Vge_e_Ve_si*T8+T8_Vge_e*T8_Ve_si+T8_Ve_si*T8_Vge_e+T8*T8_Vge_e_Ve_si);
  T8_Vge_e_Ve_di=(+T8_Vge_e_Ve_di*T8+T8_Vge_e*T8_Ve_di+T8_Ve_di*T8_Vge_e+T8*T8_Vge_e_Ve_di);
  T8_Vge_e_Vge_si=(+T8_Vge_e_Vge_si*T8+T8_Vge_e*T8_Vge_si+T8_Vge_si*T8_Vge_e+T8*T8_Vge_e_Vge_si);
  T8_Vge_e_Tempt_GND=(+T8_Vge_e_Tempt_GND*T8+T8_Vge_e*T8_Tempt_GND+T8_Tempt_GND*T8_Vge_e+T8*T8_Vge_e_Tempt_GND);
#endif
T8_Vdi_si=((T8_Vdi_si*T8)+(T8*T8_Vdi_si));
#if defined(_DERIVATE2)
  T8_Vdi_si_Vge_e=(+T8_Vdi_si_Vge_e*T8+T8_Vdi_si*T8_Vge_e+T8_Vge_e*T8_Vdi_si+T8*T8_Vdi_si_Vge_e);
  T8_Vdi_si_Vdi_si=(+T8_Vdi_si_Vdi_si*T8+T8_Vdi_si*T8_Vdi_si+T8_Vdi_si*T8_Vdi_si+T8*T8_Vdi_si_Vdi_si);
  T8_Vdi_si_Ve_si=(+T8_Vdi_si_Ve_si*T8+T8_Vdi_si*T8_Ve_si+T8_Ve_si*T8_Vdi_si+T8*T8_Vdi_si_Ve_si);
  T8_Vdi_si_Ve_di=(+T8_Vdi_si_Ve_di*T8+T8_Vdi_si*T8_Ve_di+T8_Ve_di*T8_Vdi_si+T8*T8_Vdi_si_Ve_di);
  T8_Vdi_si_Vge_si=(+T8_Vdi_si_Vge_si*T8+T8_Vdi_si*T8_Vge_si+T8_Vge_si*T8_Vdi_si+T8*T8_Vdi_si_Vge_si);
  T8_Vdi_si_Tempt_GND=(+T8_Vdi_si_Tempt_GND*T8+T8_Vdi_si*T8_Tempt_GND+T8_Tempt_GND*T8_Vdi_si+T8*T8_Vdi_si_Tempt_GND);
#endif
T8_Ve_si=((T8_Ve_si*T8)+(T8*T8_Ve_si));
#if defined(_DERIVATE2)
  T8_Ve_si_Vge_e=(+T8_Ve_si_Vge_e*T8+T8_Ve_si*T8_Vge_e+T8_Vge_e*T8_Ve_si+T8*T8_Ve_si_Vge_e);
  T8_Ve_si_Vdi_si=(+T8_Ve_si_Vdi_si*T8+T8_Ve_si*T8_Vdi_si+T8_Vdi_si*T8_Ve_si+T8*T8_Ve_si_Vdi_si);
  T8_Ve_si_Ve_si=(+T8_Ve_si_Ve_si*T8+T8_Ve_si*T8_Ve_si+T8_Ve_si*T8_Ve_si+T8*T8_Ve_si_Ve_si);
  T8_Ve_si_Ve_di=(+T8_Ve_si_Ve_di*T8+T8_Ve_si*T8_Ve_di+T8_Ve_di*T8_Ve_si+T8*T8_Ve_si_Ve_di);
  T8_Ve_si_Vge_si=(+T8_Ve_si_Vge_si*T8+T8_Ve_si*T8_Vge_si+T8_Vge_si*T8_Ve_si+T8*T8_Ve_si_Vge_si);
  T8_Ve_si_Tempt_GND=(+T8_Ve_si_Tempt_GND*T8+T8_Ve_si*T8_Tempt_GND+T8_Tempt_GND*T8_Ve_si+T8*T8_Ve_si_Tempt_GND);
#endif
T8_Ve_di=((T8_Ve_di*T8)+(T8*T8_Ve_di));
#if defined(_DERIVATE2)
  T8_Ve_di_Vge_e=(+T8_Ve_di_Vge_e*T8+T8_Ve_di*T8_Vge_e+T8_Vge_e*T8_Ve_di+T8*T8_Ve_di_Vge_e);
  T8_Ve_di_Vdi_si=(+T8_Ve_di_Vdi_si*T8+T8_Ve_di*T8_Vdi_si+T8_Vdi_si*T8_Ve_di+T8*T8_Ve_di_Vdi_si);
  T8_Ve_di_Ve_si=(+T8_Ve_di_Ve_si*T8+T8_Ve_di*T8_Ve_si+T8_Ve_si*T8_Ve_di+T8*T8_Ve_di_Ve_si);
  T8_Ve_di_Ve_di=(+T8_Ve_di_Ve_di*T8+T8_Ve_di*T8_Ve_di+T8_Ve_di*T8_Ve_di+T8*T8_Ve_di_Ve_di);
  T8_Ve_di_Vge_si=(+T8_Ve_di_Vge_si*T8+T8_Ve_di*T8_Vge_si+T8_Vge_si*T8_Ve_di+T8*T8_Ve_di_Vge_si);
  T8_Ve_di_Tempt_GND=(+T8_Ve_di_Tempt_GND*T8+T8_Ve_di*T8_Tempt_GND+T8_Tempt_GND*T8_Ve_di+T8*T8_Ve_di_Tempt_GND);
#endif
T8_Vge_si=((T8_Vge_si*T8)+(T8*T8_Vge_si));
#if defined(_DERIVATE2)
  T8_Vge_si_Vge_e=(+T8_Vge_si_Vge_e*T8+T8_Vge_si*T8_Vge_e+T8_Vge_e*T8_Vge_si+T8*T8_Vge_si_Vge_e);
  T8_Vge_si_Vdi_si=(+T8_Vge_si_Vdi_si*T8+T8_Vge_si*T8_Vdi_si+T8_Vdi_si*T8_Vge_si+T8*T8_Vge_si_Vdi_si);
  T8_Vge_si_Ve_si=(+T8_Vge_si_Ve_si*T8+T8_Vge_si*T8_Ve_si+T8_Ve_si*T8_Vge_si+T8*T8_Vge_si_Ve_si);
  T8_Vge_si_Ve_di=(+T8_Vge_si_Ve_di*T8+T8_Vge_si*T8_Ve_di+T8_Ve_di*T8_Vge_si+T8*T8_Vge_si_Ve_di);
  T8_Vge_si_Vge_si=(+T8_Vge_si_Vge_si*T8+T8_Vge_si*T8_Vge_si+T8_Vge_si*T8_Vge_si+T8*T8_Vge_si_Vge_si);
  T8_Vge_si_Tempt_GND=(+T8_Vge_si_Tempt_GND*T8+T8_Vge_si*T8_Tempt_GND+T8_Tempt_GND*T8_Vge_si+T8*T8_Vge_si_Tempt_GND);
#endif
T8_Tempt_GND=((T8_Tempt_GND*T8)+(T8*T8_Tempt_GND));
#if defined(_DERIVATE2)
  T8_Tempt_GND_Vge_e=(+T8_Tempt_GND_Vge_e*T8+T8_Tempt_GND*T8_Vge_e+T8_Vge_e*T8_Tempt_GND+T8*T8_Tempt_GND_Vge_e);
  T8_Tempt_GND_Vdi_si=(+T8_Tempt_GND_Vdi_si*T8+T8_Tempt_GND*T8_Vdi_si+T8_Vdi_si*T8_Tempt_GND+T8*T8_Tempt_GND_Vdi_si);
  T8_Tempt_GND_Ve_si=(+T8_Tempt_GND_Ve_si*T8+T8_Tempt_GND*T8_Ve_si+T8_Ve_si*T8_Tempt_GND+T8*T8_Tempt_GND_Ve_si);
  T8_Tempt_GND_Ve_di=(+T8_Tempt_GND_Ve_di*T8+T8_Tempt_GND*T8_Ve_di+T8_Ve_di*T8_Tempt_GND+T8*T8_Tempt_GND_Ve_di);
  T8_Tempt_GND_Vge_si=(+T8_Tempt_GND_Vge_si*T8+T8_Tempt_GND*T8_Vge_si+T8_Vge_si*T8_Tempt_GND+T8*T8_Tempt_GND_Vge_si);
  T8_Tempt_GND_Tempt_GND=(+T8_Tempt_GND_Tempt_GND*T8+T8_Tempt_GND*T8_Tempt_GND+T8_Tempt_GND*T8_Tempt_GND+T8*T8_Tempt_GND_Tempt_GND);
#endif
#endif
T8=(T8*T8);
EXIT_IF_ISNAN((T8*T8))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
npart_c_Vge_e=(pModel->RNOIC*T8_Vge_e*pModel->TNOIC*Leff);
npart_c_Vdi_si=(pModel->RNOIC*T8_Vdi_si*pModel->TNOIC*Leff);
npart_c_Ve_si=(pModel->RNOIC*T8_Ve_si*pModel->TNOIC*Leff);
npart_c_Ve_di=(pModel->RNOIC*T8_Ve_di*pModel->TNOIC*Leff);
npart_c_Vge_si=(pModel->RNOIC*T8_Vge_si*pModel->TNOIC*Leff);
npart_c_Tempt_GND=(pModel->RNOIC*T8_Tempt_GND*pModel->TNOIC*Leff);
#endif
npart_c=(pModel->RNOIC*(1.0+((T8*pModel->TNOIC)*Leff)));
EXIT_IF_ISNAN((pModel->RNOIC*(1.0+((T8*pModel->TNOIC)*Leff))))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T9_Vge_di=((gamma_Vge_di*delta)+(gamma*delta_Vge_di));
#if defined(_DERIVATE2)
  T9_Vge_di_Vge_di=(+gamma_Vge_di_Vge_di*delta+gamma_Vge_di*delta_Vge_di+gamma_Vge_di*delta_Vge_di+gamma*delta_Vge_di_Vge_di);
  T9_Vge_di_Vdi_d=(+gamma_Vge_di_Vdi_d*delta+gamma_Vge_di*delta_Vdi_d+gamma_Vdi_d*delta_Vge_di+gamma*delta_Vge_di_Vdi_d);
  T9_Vge_di_Vsi_s=(+gamma_Vge_di_Vsi_s*delta+gamma_Vge_di*delta_Vsi_s+gamma_Vsi_s*delta_Vge_di+gamma*delta_Vge_di_Vsi_s);
  T9_Vge_di_Vge_e=(+gamma_Vge_di_Vge_e*delta+gamma_Vge_di*delta_Vge_e+gamma_Vge_e*delta_Vge_di+gamma*delta_Vge_di_Vge_e);
  T9_Vge_di_Ve_si=(+gamma_Vge_di_Ve_si*delta+gamma_Vge_di*delta_Ve_si+gamma_Ve_si*delta_Vge_di+gamma*delta_Vge_di_Ve_si);
  T9_Vge_di_Ve_di=(+gamma_Vge_di_Ve_di*delta+gamma_Vge_di*delta_Ve_di+gamma_Ve_di*delta_Vge_di+gamma*delta_Vge_di_Ve_di);
  T9_Vge_di_Vge_si=(+gamma_Vge_di_Vge_si*delta+gamma_Vge_di*delta_Vge_si+gamma_Vge_si*delta_Vge_di+gamma*delta_Vge_di_Vge_si);
  T9_Vge_di_Tempt_GND=(+gamma_Vge_di_Tempt_GND*delta+gamma_Vge_di*delta_Tempt_GND+gamma_Tempt_GND*delta_Vge_di+gamma*delta_Vge_di_Tempt_GND);
  T9_Vge_di_Vdi_si=(+gamma_Vge_di_Vdi_si*delta+gamma_Vge_di*delta_Vdi_si+gamma_Vdi_si*delta_Vge_di+gamma*delta_Vge_di_Vdi_si);
#endif
T9_Vdi_d=((gamma_Vdi_d*delta)+(gamma*delta_Vdi_d));
#if defined(_DERIVATE2)
  T9_Vdi_d_Vge_di=(+gamma_Vdi_d_Vge_di*delta+gamma_Vdi_d*delta_Vge_di+gamma_Vge_di*delta_Vdi_d+gamma*delta_Vdi_d_Vge_di);
  T9_Vdi_d_Vdi_d=(+gamma_Vdi_d_Vdi_d*delta+gamma_Vdi_d*delta_Vdi_d+gamma_Vdi_d*delta_Vdi_d+gamma*delta_Vdi_d_Vdi_d);
  T9_Vdi_d_Vsi_s=(+gamma_Vdi_d_Vsi_s*delta+gamma_Vdi_d*delta_Vsi_s+gamma_Vsi_s*delta_Vdi_d+gamma*delta_Vdi_d_Vsi_s);
  T9_Vdi_d_Vge_e=(+gamma_Vdi_d_Vge_e*delta+gamma_Vdi_d*delta_Vge_e+gamma_Vge_e*delta_Vdi_d+gamma*delta_Vdi_d_Vge_e);
  T9_Vdi_d_Ve_si=(+gamma_Vdi_d_Ve_si*delta+gamma_Vdi_d*delta_Ve_si+gamma_Ve_si*delta_Vdi_d+gamma*delta_Vdi_d_Ve_si);
  T9_Vdi_d_Ve_di=(+gamma_Vdi_d_Ve_di*delta+gamma_Vdi_d*delta_Ve_di+gamma_Ve_di*delta_Vdi_d+gamma*delta_Vdi_d_Ve_di);
  T9_Vdi_d_Vge_si=(+gamma_Vdi_d_Vge_si*delta+gamma_Vdi_d*delta_Vge_si+gamma_Vge_si*delta_Vdi_d+gamma*delta_Vdi_d_Vge_si);
  T9_Vdi_d_Tempt_GND=(+gamma_Vdi_d_Tempt_GND*delta+gamma_Vdi_d*delta_Tempt_GND+gamma_Tempt_GND*delta_Vdi_d+gamma*delta_Vdi_d_Tempt_GND);
  T9_Vdi_d_Vdi_si=(+gamma_Vdi_d_Vdi_si*delta+gamma_Vdi_d*delta_Vdi_si+gamma_Vdi_si*delta_Vdi_d+gamma*delta_Vdi_d_Vdi_si);
#endif
T9_Vsi_s=((gamma_Vsi_s*delta)+(gamma*delta_Vsi_s));
#if defined(_DERIVATE2)
  T9_Vsi_s_Vge_di=(+gamma_Vsi_s_Vge_di*delta+gamma_Vsi_s*delta_Vge_di+gamma_Vge_di*delta_Vsi_s+gamma*delta_Vsi_s_Vge_di);
  T9_Vsi_s_Vdi_d=(+gamma_Vsi_s_Vdi_d*delta+gamma_Vsi_s*delta_Vdi_d+gamma_Vdi_d*delta_Vsi_s+gamma*delta_Vsi_s_Vdi_d);
  T9_Vsi_s_Vsi_s=(+gamma_Vsi_s_Vsi_s*delta+gamma_Vsi_s*delta_Vsi_s+gamma_Vsi_s*delta_Vsi_s+gamma*delta_Vsi_s_Vsi_s);
  T9_Vsi_s_Vge_e=(+gamma_Vsi_s_Vge_e*delta+gamma_Vsi_s*delta_Vge_e+gamma_Vge_e*delta_Vsi_s+gamma*delta_Vsi_s_Vge_e);
  T9_Vsi_s_Ve_si=(+gamma_Vsi_s_Ve_si*delta+gamma_Vsi_s*delta_Ve_si+gamma_Ve_si*delta_Vsi_s+gamma*delta_Vsi_s_Ve_si);
  T9_Vsi_s_Ve_di=(+gamma_Vsi_s_Ve_di*delta+gamma_Vsi_s*delta_Ve_di+gamma_Ve_di*delta_Vsi_s+gamma*delta_Vsi_s_Ve_di);
  T9_Vsi_s_Vge_si=(+gamma_Vsi_s_Vge_si*delta+gamma_Vsi_s*delta_Vge_si+gamma_Vge_si*delta_Vsi_s+gamma*delta_Vsi_s_Vge_si);
  T9_Vsi_s_Tempt_GND=(+gamma_Vsi_s_Tempt_GND*delta+gamma_Vsi_s*delta_Tempt_GND+gamma_Tempt_GND*delta_Vsi_s+gamma*delta_Vsi_s_Tempt_GND);
  T9_Vsi_s_Vdi_si=(+gamma_Vsi_s_Vdi_si*delta+gamma_Vsi_s*delta_Vdi_si+gamma_Vdi_si*delta_Vsi_s+gamma*delta_Vsi_s_Vdi_si);
#endif
T9_Vge_e=((gamma_Vge_e*delta)+(gamma*delta_Vge_e));
#if defined(_DERIVATE2)
  T9_Vge_e_Vge_di=(+gamma_Vge_e_Vge_di*delta+gamma_Vge_e*delta_Vge_di+gamma_Vge_di*delta_Vge_e+gamma*delta_Vge_e_Vge_di);
  T9_Vge_e_Vdi_d=(+gamma_Vge_e_Vdi_d*delta+gamma_Vge_e*delta_Vdi_d+gamma_Vdi_d*delta_Vge_e+gamma*delta_Vge_e_Vdi_d);
  T9_Vge_e_Vsi_s=(+gamma_Vge_e_Vsi_s*delta+gamma_Vge_e*delta_Vsi_s+gamma_Vsi_s*delta_Vge_e+gamma*delta_Vge_e_Vsi_s);
  T9_Vge_e_Vge_e=(+gamma_Vge_e_Vge_e*delta+gamma_Vge_e*delta_Vge_e+gamma_Vge_e*delta_Vge_e+gamma*delta_Vge_e_Vge_e);
  T9_Vge_e_Ve_si=(+gamma_Vge_e_Ve_si*delta+gamma_Vge_e*delta_Ve_si+gamma_Ve_si*delta_Vge_e+gamma*delta_Vge_e_Ve_si);
  T9_Vge_e_Ve_di=(+gamma_Vge_e_Ve_di*delta+gamma_Vge_e*delta_Ve_di+gamma_Ve_di*delta_Vge_e+gamma*delta_Vge_e_Ve_di);
  T9_Vge_e_Vge_si=(+gamma_Vge_e_Vge_si*delta+gamma_Vge_e*delta_Vge_si+gamma_Vge_si*delta_Vge_e+gamma*delta_Vge_e_Vge_si);
  T9_Vge_e_Tempt_GND=(+gamma_Vge_e_Tempt_GND*delta+gamma_Vge_e*delta_Tempt_GND+gamma_Tempt_GND*delta_Vge_e+gamma*delta_Vge_e_Tempt_GND);
  T9_Vge_e_Vdi_si=(+gamma_Vge_e_Vdi_si*delta+gamma_Vge_e*delta_Vdi_si+gamma_Vdi_si*delta_Vge_e+gamma*delta_Vge_e_Vdi_si);
#endif
T9_Ve_si=((gamma_Ve_si*delta)+(gamma*delta_Ve_si));
#if defined(_DERIVATE2)
  T9_Ve_si_Vge_di=(+gamma_Ve_si_Vge_di*delta+gamma_Ve_si*delta_Vge_di+gamma_Vge_di*delta_Ve_si+gamma*delta_Ve_si_Vge_di);
  T9_Ve_si_Vdi_d=(+gamma_Ve_si_Vdi_d*delta+gamma_Ve_si*delta_Vdi_d+gamma_Vdi_d*delta_Ve_si+gamma*delta_Ve_si_Vdi_d);
  T9_Ve_si_Vsi_s=(+gamma_Ve_si_Vsi_s*delta+gamma_Ve_si*delta_Vsi_s+gamma_Vsi_s*delta_Ve_si+gamma*delta_Ve_si_Vsi_s);
  T9_Ve_si_Vge_e=(+gamma_Ve_si_Vge_e*delta+gamma_Ve_si*delta_Vge_e+gamma_Vge_e*delta_Ve_si+gamma*delta_Ve_si_Vge_e);
  T9_Ve_si_Ve_si=(+gamma_Ve_si_Ve_si*delta+gamma_Ve_si*delta_Ve_si+gamma_Ve_si*delta_Ve_si+gamma*delta_Ve_si_Ve_si);
  T9_Ve_si_Ve_di=(+gamma_Ve_si_Ve_di*delta+gamma_Ve_si*delta_Ve_di+gamma_Ve_di*delta_Ve_si+gamma*delta_Ve_si_Ve_di);
  T9_Ve_si_Vge_si=(+gamma_Ve_si_Vge_si*delta+gamma_Ve_si*delta_Vge_si+gamma_Vge_si*delta_Ve_si+gamma*delta_Ve_si_Vge_si);
  T9_Ve_si_Tempt_GND=(+gamma_Ve_si_Tempt_GND*delta+gamma_Ve_si*delta_Tempt_GND+gamma_Tempt_GND*delta_Ve_si+gamma*delta_Ve_si_Tempt_GND);
  T9_Ve_si_Vdi_si=(+gamma_Ve_si_Vdi_si*delta+gamma_Ve_si*delta_Vdi_si+gamma_Vdi_si*delta_Ve_si+gamma*delta_Ve_si_Vdi_si);
#endif
T9_Ve_di=((gamma_Ve_di*delta)+(gamma*delta_Ve_di));
#if defined(_DERIVATE2)
  T9_Ve_di_Vge_di=(+gamma_Ve_di_Vge_di*delta+gamma_Ve_di*delta_Vge_di+gamma_Vge_di*delta_Ve_di+gamma*delta_Ve_di_Vge_di);
  T9_Ve_di_Vdi_d=(+gamma_Ve_di_Vdi_d*delta+gamma_Ve_di*delta_Vdi_d+gamma_Vdi_d*delta_Ve_di+gamma*delta_Ve_di_Vdi_d);
  T9_Ve_di_Vsi_s=(+gamma_Ve_di_Vsi_s*delta+gamma_Ve_di*delta_Vsi_s+gamma_Vsi_s*delta_Ve_di+gamma*delta_Ve_di_Vsi_s);
  T9_Ve_di_Vge_e=(+gamma_Ve_di_Vge_e*delta+gamma_Ve_di*delta_Vge_e+gamma_Vge_e*delta_Ve_di+gamma*delta_Ve_di_Vge_e);
  T9_Ve_di_Ve_si=(+gamma_Ve_di_Ve_si*delta+gamma_Ve_di*delta_Ve_si+gamma_Ve_si*delta_Ve_di+gamma*delta_Ve_di_Ve_si);
  T9_Ve_di_Ve_di=(+gamma_Ve_di_Ve_di*delta+gamma_Ve_di*delta_Ve_di+gamma_Ve_di*delta_Ve_di+gamma*delta_Ve_di_Ve_di);
  T9_Ve_di_Vge_si=(+gamma_Ve_di_Vge_si*delta+gamma_Ve_di*delta_Vge_si+gamma_Vge_si*delta_Ve_di+gamma*delta_Ve_di_Vge_si);
  T9_Ve_di_Tempt_GND=(+gamma_Ve_di_Tempt_GND*delta+gamma_Ve_di*delta_Tempt_GND+gamma_Tempt_GND*delta_Ve_di+gamma*delta_Ve_di_Tempt_GND);
  T9_Ve_di_Vdi_si=(+gamma_Ve_di_Vdi_si*delta+gamma_Ve_di*delta_Vdi_si+gamma_Vdi_si*delta_Ve_di+gamma*delta_Ve_di_Vdi_si);
#endif
T9_Vge_si=((gamma_Vge_si*delta)+(gamma*delta_Vge_si));
#if defined(_DERIVATE2)
  T9_Vge_si_Vge_di=(+gamma_Vge_si_Vge_di*delta+gamma_Vge_si*delta_Vge_di+gamma_Vge_di*delta_Vge_si+gamma*delta_Vge_si_Vge_di);
  T9_Vge_si_Vdi_d=(+gamma_Vge_si_Vdi_d*delta+gamma_Vge_si*delta_Vdi_d+gamma_Vdi_d*delta_Vge_si+gamma*delta_Vge_si_Vdi_d);
  T9_Vge_si_Vsi_s=(+gamma_Vge_si_Vsi_s*delta+gamma_Vge_si*delta_Vsi_s+gamma_Vsi_s*delta_Vge_si+gamma*delta_Vge_si_Vsi_s);
  T9_Vge_si_Vge_e=(+gamma_Vge_si_Vge_e*delta+gamma_Vge_si*delta_Vge_e+gamma_Vge_e*delta_Vge_si+gamma*delta_Vge_si_Vge_e);
  T9_Vge_si_Ve_si=(+gamma_Vge_si_Ve_si*delta+gamma_Vge_si*delta_Ve_si+gamma_Ve_si*delta_Vge_si+gamma*delta_Vge_si_Ve_si);
  T9_Vge_si_Ve_di=(+gamma_Vge_si_Ve_di*delta+gamma_Vge_si*delta_Ve_di+gamma_Ve_di*delta_Vge_si+gamma*delta_Vge_si_Ve_di);
  T9_Vge_si_Vge_si=(+gamma_Vge_si_Vge_si*delta+gamma_Vge_si*delta_Vge_si+gamma_Vge_si*delta_Vge_si+gamma*delta_Vge_si_Vge_si);
  T9_Vge_si_Tempt_GND=(+gamma_Vge_si_Tempt_GND*delta+gamma_Vge_si*delta_Tempt_GND+gamma_Tempt_GND*delta_Vge_si+gamma*delta_Vge_si_Tempt_GND);
  T9_Vge_si_Vdi_si=(+gamma_Vge_si_Vdi_si*delta+gamma_Vge_si*delta_Vdi_si+gamma_Vdi_si*delta_Vge_si+gamma*delta_Vge_si_Vdi_si);
#endif
T9_Tempt_GND=((gamma_Tempt_GND*delta)+(gamma*delta_Tempt_GND));
#if defined(_DERIVATE2)
  T9_Tempt_GND_Vge_di=(+gamma_Tempt_GND_Vge_di*delta+gamma_Tempt_GND*delta_Vge_di+gamma_Vge_di*delta_Tempt_GND+gamma*delta_Tempt_GND_Vge_di);
  T9_Tempt_GND_Vdi_d=(+gamma_Tempt_GND_Vdi_d*delta+gamma_Tempt_GND*delta_Vdi_d+gamma_Vdi_d*delta_Tempt_GND+gamma*delta_Tempt_GND_Vdi_d);
  T9_Tempt_GND_Vsi_s=(+gamma_Tempt_GND_Vsi_s*delta+gamma_Tempt_GND*delta_Vsi_s+gamma_Vsi_s*delta_Tempt_GND+gamma*delta_Tempt_GND_Vsi_s);
  T9_Tempt_GND_Vge_e=(+gamma_Tempt_GND_Vge_e*delta+gamma_Tempt_GND*delta_Vge_e+gamma_Vge_e*delta_Tempt_GND+gamma*delta_Tempt_GND_Vge_e);
  T9_Tempt_GND_Ve_si=(+gamma_Tempt_GND_Ve_si*delta+gamma_Tempt_GND*delta_Ve_si+gamma_Ve_si*delta_Tempt_GND+gamma*delta_Tempt_GND_Ve_si);
  T9_Tempt_GND_Ve_di=(+gamma_Tempt_GND_Ve_di*delta+gamma_Tempt_GND*delta_Ve_di+gamma_Ve_di*delta_Tempt_GND+gamma*delta_Tempt_GND_Ve_di);
  T9_Tempt_GND_Vge_si=(+gamma_Tempt_GND_Vge_si*delta+gamma_Tempt_GND*delta_Vge_si+gamma_Vge_si*delta_Tempt_GND+gamma*delta_Tempt_GND_Vge_si);
  T9_Tempt_GND_Tempt_GND=(+gamma_Tempt_GND_Tempt_GND*delta+gamma_Tempt_GND*delta_Tempt_GND+gamma_Tempt_GND*delta_Tempt_GND+gamma*delta_Tempt_GND_Tempt_GND);
  T9_Tempt_GND_Vdi_si=(+gamma_Tempt_GND_Vdi_si*delta+gamma_Tempt_GND*delta_Vdi_si+gamma_Vdi_si*delta_Tempt_GND+gamma*delta_Tempt_GND_Vdi_si);
#endif
T9_Vdi_si=((gamma_Vdi_si*delta)+(gamma*delta_Vdi_si));
#if defined(_DERIVATE2)
  T9_Vdi_si_Vge_di=(+gamma_Vdi_si_Vge_di*delta+gamma_Vdi_si*delta_Vge_di+gamma_Vge_di*delta_Vdi_si+gamma*delta_Vdi_si_Vge_di);
  T9_Vdi_si_Vdi_d=(+gamma_Vdi_si_Vdi_d*delta+gamma_Vdi_si*delta_Vdi_d+gamma_Vdi_d*delta_Vdi_si+gamma*delta_Vdi_si_Vdi_d);
  T9_Vdi_si_Vsi_s=(+gamma_Vdi_si_Vsi_s*delta+gamma_Vdi_si*delta_Vsi_s+gamma_Vsi_s*delta_Vdi_si+gamma*delta_Vdi_si_Vsi_s);
  T9_Vdi_si_Vge_e=(+gamma_Vdi_si_Vge_e*delta+gamma_Vdi_si*delta_Vge_e+gamma_Vge_e*delta_Vdi_si+gamma*delta_Vdi_si_Vge_e);
  T9_Vdi_si_Ve_si=(+gamma_Vdi_si_Ve_si*delta+gamma_Vdi_si*delta_Ve_si+gamma_Ve_si*delta_Vdi_si+gamma*delta_Vdi_si_Ve_si);
  T9_Vdi_si_Ve_di=(+gamma_Vdi_si_Ve_di*delta+gamma_Vdi_si*delta_Ve_di+gamma_Ve_di*delta_Vdi_si+gamma*delta_Vdi_si_Ve_di);
  T9_Vdi_si_Vge_si=(+gamma_Vdi_si_Vge_si*delta+gamma_Vdi_si*delta_Vge_si+gamma_Vge_si*delta_Vdi_si+gamma*delta_Vdi_si_Vge_si);
  T9_Vdi_si_Tempt_GND=(+gamma_Vdi_si_Tempt_GND*delta+gamma_Vdi_si*delta_Tempt_GND+gamma_Tempt_GND*delta_Vdi_si+gamma*delta_Vdi_si_Tempt_GND);
  T9_Vdi_si_Vdi_si=(+gamma_Vdi_si_Vdi_si*delta+gamma_Vdi_si*delta_Vdi_si+gamma_Vdi_si*delta_Vdi_si+gamma*delta_Vdi_si_Vdi_si);
#endif
#endif
T9=(gamma*delta);
EXIT_IF_ISNAN((gamma*delta))
if
((T9>0.0))
{
{
double m00_sqrt(d00_sqrt0,(gamma*delta))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(gamma*delta))
#endif
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
ctnoi_Vge_di=((epsilon_Vge_di*d00_sqrt0-epsilon*((gamma_Vge_di*delta)+(gamma*delta_Vge_di))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c);
ctnoi_Vdi_d=((epsilon_Vdi_d*d00_sqrt0-epsilon*((gamma_Vdi_d*delta)+(gamma*delta_Vdi_d))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c);
ctnoi_Vsi_s=((epsilon_Vsi_s*d00_sqrt0-epsilon*((gamma_Vsi_s*delta)+(gamma*delta_Vsi_s))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c);
ctnoi_Vge_e=((((epsilon_Vge_e*d00_sqrt0-epsilon*((gamma_Vge_e*delta)+(gamma*delta_Vge_e))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Vge_e)));
ctnoi_Vdi_si=((((epsilon_Vdi_si*d00_sqrt0-epsilon*((gamma_Vdi_si*delta)+(gamma*delta_Vdi_si))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Vdi_si)));
ctnoi_Ve_si=((((epsilon_Ve_si*d00_sqrt0-epsilon*((gamma_Ve_si*delta)+(gamma*delta_Ve_si))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Ve_si)));
ctnoi_Ve_di=((((epsilon_Ve_di*d00_sqrt0-epsilon*((gamma_Ve_di*delta)+(gamma*delta_Ve_di))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Ve_di)));
ctnoi_Vge_si=((((epsilon_Vge_si*d00_sqrt0-epsilon*((gamma_Vge_si*delta)+(gamma*delta_Vge_si))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Vge_si)));
ctnoi_Tempt_GND=((((epsilon_Tempt_GND*d00_sqrt0-epsilon*((gamma_Tempt_GND*delta)+(gamma*delta_Tempt_GND))*d10_sqrt0)/d00_sqrt0/d00_sqrt0)*(2.5316*npart_c))+((epsilon/d00_sqrt0)*(2.5316*npart_c_Tempt_GND)));
#endif
ctnoi=((epsilon/d00_sqrt0)*(2.5316*npart_c));
EXIT_IF_ISNAN(((epsilon/d00_sqrt0)*(2.5316*npart_c)))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
ctnoi_Vge_di=0.0;
ctnoi_Vdi_d=0.0;
ctnoi_Vsi_s=0.0;
ctnoi_Vge_e=0.0;
ctnoi_Vdi_si=0.0;
ctnoi_Ve_si=0.0;
ctnoi_Ve_di=0.0;
ctnoi_Vge_si=0.0;
ctnoi_Tempt_GND=0.0;
#endif
ctnoi=1.0;
EXIT_IF_ISNAN(1.0)
}
if
((ctnoi>1))
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
ctnoi_Vge_di=0.0;
ctnoi_Vdi_d=0.0;
ctnoi_Vsi_s=0.0;
ctnoi_Vge_e=0.0;
ctnoi_Vdi_si=0.0;
ctnoi_Ve_si=0.0;
ctnoi_Ve_di=0.0;
ctnoi_Vge_si=0.0;
ctnoi_Tempt_GND=0.0;
#endif
ctnoi=1.0;
EXIT_IF_ISNAN(1.0)
}
if
((ctnoi<0))
{
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
ctnoi_Vge_di=0.0;
ctnoi_Vdi_d=0.0;
ctnoi_Vsi_s=0.0;
ctnoi_Vge_e=0.0;
ctnoi_Vdi_si=0.0;
ctnoi_Ve_si=0.0;
ctnoi_Ve_di=0.0;
ctnoi_Vge_si=0.0;
ctnoi_Tempt_GND=0.0;
#endif
ctnoi=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
npart_beta_Vge_e=(pModel->RNOIA*T8_Vge_e*pModel->TNOIA*Leff);
npart_beta_Vdi_si=(pModel->RNOIA*T8_Vdi_si*pModel->TNOIA*Leff);
npart_beta_Ve_si=(pModel->RNOIA*T8_Ve_si*pModel->TNOIA*Leff);
npart_beta_Ve_di=(pModel->RNOIA*T8_Ve_di*pModel->TNOIA*Leff);
npart_beta_Vge_si=(pModel->RNOIA*T8_Vge_si*pModel->TNOIA*Leff);
npart_beta_Tempt_GND=(pModel->RNOIA*T8_Tempt_GND*pModel->TNOIA*Leff);
#endif
npart_beta=(pModel->RNOIA*(1.0+((T8*pModel->TNOIA)*Leff)));
EXIT_IF_ISNAN((pModel->RNOIA*(1.0+((T8*pModel->TNOIA)*Leff))))
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
npart_theta_Vge_e=(pModel->RNOIB*T8_Vge_e*pModel->TNOIB*Leff);
npart_theta_Vdi_si=(pModel->RNOIB*T8_Vdi_si*pModel->TNOIB*Leff);
npart_theta_Ve_si=(pModel->RNOIB*T8_Ve_si*pModel->TNOIB*Leff);
npart_theta_Ve_di=(pModel->RNOIB*T8_Ve_di*pModel->TNOIB*Leff);
npart_theta_Vge_si=(pModel->RNOIB*T8_Vge_si*pModel->TNOIB*Leff);
npart_theta_Tempt_GND=(pModel->RNOIB*T8_Tempt_GND*pModel->TNOIB*Leff);
#endif
npart_theta=(pModel->RNOIB*(1.0+((T8*pModel->TNOIB)*Leff)));
EXIT_IF_ISNAN((pModel->RNOIB*(1.0+((T8*pModel->TNOIB)*Leff))))
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gamma_Vge_di=gamma_Vge_di*((3.0*npart_beta)*npart_beta);
gamma_Vdi_d=gamma_Vdi_d*((3.0*npart_beta)*npart_beta);
gamma_Vsi_s=gamma_Vsi_s*((3.0*npart_beta)*npart_beta);
gamma_Vge_e=((gamma_Vge_e*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Vge_e)*npart_beta)+((3.0*npart_beta)*npart_beta_Vge_e))));
gamma_Vdi_si=((gamma_Vdi_si*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Vdi_si)*npart_beta)+((3.0*npart_beta)*npart_beta_Vdi_si))));
gamma_Tempt_GND=((gamma_Tempt_GND*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Tempt_GND)*npart_beta)+((3.0*npart_beta)*npart_beta_Tempt_GND))));
gamma_Ve_si=((gamma_Ve_si*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Ve_si)*npart_beta)+((3.0*npart_beta)*npart_beta_Ve_si))));
gamma_Ve_di=((gamma_Ve_di*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Ve_di)*npart_beta)+((3.0*npart_beta)*npart_beta_Ve_di))));
gamma_Vge_si=((gamma_Vge_si*((3.0*npart_beta)*npart_beta))+(gamma*(((3.0*npart_beta_Vge_si)*npart_beta)+((3.0*npart_beta)*npart_beta_Vge_si))));
#endif
gamma=(gamma*((3.0*npart_beta)*npart_beta));
EXIT_IF_ISNAN((gamma*((3.0*npart_beta)*npart_beta)))
#if defined(_DERIVATE) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe= */
delta_Vdi_d=delta_Vdi_d*((3.75*npart_theta)*npart_theta);
delta_Vsi_s=delta_Vsi_s*((3.75*npart_theta)*npart_theta);
delta_Vge_di=delta_Vge_di*((3.75*npart_theta)*npart_theta);
delta_Vge_e=((delta_Vge_e*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Vge_e)*npart_theta)+((3.75*npart_theta)*npart_theta_Vge_e))));
delta_Ve_si=((delta_Ve_si*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Ve_si)*npart_theta)+((3.75*npart_theta)*npart_theta_Ve_si))));
delta_Ve_di=((delta_Ve_di*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Ve_di)*npart_theta)+((3.75*npart_theta)*npart_theta_Ve_di))));
delta_Vge_si=((delta_Vge_si*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Vge_si)*npart_theta)+((3.75*npart_theta)*npart_theta_Vge_si))));
delta_Vdi_si=((delta_Vdi_si*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Vdi_si)*npart_theta)+((3.75*npart_theta)*npart_theta_Vdi_si))));
delta_Tempt_GND=((delta_Tempt_GND*((3.75*npart_theta)*npart_theta))+(delta*(((3.75*npart_theta_Tempt_GND)*npart_theta)+((3.75*npart_theta)*npart_theta_Tempt_GND))));
#endif
delta=(delta*((3.75*npart_theta)*npart_theta));
EXIT_IF_ISNAN((delta*((3.75*npart_theta)*npart_theta)))
#if defined(_DERIVATEFORDDX) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(e,si)V(e,di)V(ge,si)Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T9_Vge_di=((qia*0.5)*T1_Vge_di);
#if defined(_DERIVATE2)
  T9_Vge_di_Vge_di=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vge_di);
  T9_Vge_di_Vdi_d=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vdi_d);
  T9_Vge_di_Vsi_s=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vsi_s);
  T9_Vge_di_Vge_e=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vge_e);
  T9_Vge_di_Ve_si=(+(+0.0*0.5+0.0*0.0+qia_Ve_si*0.0+qia*0.0)*T1+0.0*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Ve_si);
  T9_Vge_di_Ve_di=(+(+0.0*0.5+0.0*0.0+qia_Ve_di*0.0+qia*0.0)*T1+0.0*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Ve_di);
  T9_Vge_di_Vge_si=(+(+0.0*0.5+0.0*0.0+qia_Vge_si*0.0+qia*0.0)*T1+0.0*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vge_si);
  T9_Vge_di_Tempt_GND=(+(+0.0*0.5+0.0*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+0.0*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Tempt_GND);
  T9_Vge_di_Vdi_si=(+(+0.0*0.5+0.0*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+0.0*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vge_di+(qia*0.5)*T1_Vge_di_Vdi_si);
#endif
T9_Vdi_d=((qia*0.5)*T1_Vdi_d);
#if defined(_DERIVATE2)
  T9_Vdi_d_Vge_di=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vge_di);
  T9_Vdi_d_Vdi_d=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vdi_d);
  T9_Vdi_d_Vsi_s=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vsi_s);
  T9_Vdi_d_Vge_e=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vge_e);
  T9_Vdi_d_Ve_si=(+(+0.0*0.5+0.0*0.0+qia_Ve_si*0.0+qia*0.0)*T1+0.0*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Ve_si);
  T9_Vdi_d_Ve_di=(+(+0.0*0.5+0.0*0.0+qia_Ve_di*0.0+qia*0.0)*T1+0.0*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Ve_di);
  T9_Vdi_d_Vge_si=(+(+0.0*0.5+0.0*0.0+qia_Vge_si*0.0+qia*0.0)*T1+0.0*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vge_si);
  T9_Vdi_d_Tempt_GND=(+(+0.0*0.5+0.0*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+0.0*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Tempt_GND);
  T9_Vdi_d_Vdi_si=(+(+0.0*0.5+0.0*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+0.0*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vdi_d+(qia*0.5)*T1_Vdi_d_Vdi_si);
#endif
T9_Vsi_s=((qia*0.5)*T1_Vsi_s);
#if defined(_DERIVATE2)
  T9_Vsi_s_Vge_di=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vge_di);
  T9_Vsi_s_Vdi_d=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vdi_d);
  T9_Vsi_s_Vsi_s=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vsi_s);
  T9_Vsi_s_Vge_e=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vge_e);
  T9_Vsi_s_Ve_si=(+(+0.0*0.5+0.0*0.0+qia_Ve_si*0.0+qia*0.0)*T1+0.0*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Ve_si);
  T9_Vsi_s_Ve_di=(+(+0.0*0.5+0.0*0.0+qia_Ve_di*0.0+qia*0.0)*T1+0.0*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Ve_di);
  T9_Vsi_s_Vge_si=(+(+0.0*0.5+0.0*0.0+qia_Vge_si*0.0+qia*0.0)*T1+0.0*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vge_si);
  T9_Vsi_s_Tempt_GND=(+(+0.0*0.5+0.0*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+0.0*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Tempt_GND);
  T9_Vsi_s_Vdi_si=(+(+0.0*0.5+0.0*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+0.0*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vsi_s+(qia*0.5)*T1_Vsi_s_Vdi_si);
#endif
T9_Vge_e=((qia*0.5)*T1_Vge_e);
#if defined(_DERIVATE2)
  T9_Vge_e_Vge_di=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vge_di);
  T9_Vge_e_Vdi_d=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vdi_d);
  T9_Vge_e_Vsi_s=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vsi_s);
  T9_Vge_e_Vge_e=(+(+0.0*0.5+0.0*0.0+0.0*0.0+qia*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vge_e);
  T9_Vge_e_Ve_si=(+(+0.0*0.5+0.0*0.0+qia_Ve_si*0.0+qia*0.0)*T1+0.0*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Ve_si);
  T9_Vge_e_Ve_di=(+(+0.0*0.5+0.0*0.0+qia_Ve_di*0.0+qia*0.0)*T1+0.0*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Ve_di);
  T9_Vge_e_Vge_si=(+(+0.0*0.5+0.0*0.0+qia_Vge_si*0.0+qia*0.0)*T1+0.0*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vge_si);
  T9_Vge_e_Tempt_GND=(+(+0.0*0.5+0.0*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+0.0*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Tempt_GND);
  T9_Vge_e_Vdi_si=(+(+0.0*0.5+0.0*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+0.0*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vge_e+(qia*0.5)*T1_Vge_e_Vdi_si);
#endif
T9_Ve_si=((qia_Ve_si*0.5*T1)+((qia*0.5)*T1_Ve_si));
#if defined(_DERIVATE2)
  T9_Ve_si_Vge_di=(+(+0.0*0.5+qia_Ve_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vge_di+(0.0)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vge_di);
  T9_Ve_si_Vdi_d=(+(+0.0*0.5+qia_Ve_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vdi_d+(0.0)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vdi_d);
  T9_Ve_si_Vsi_s=(+(+0.0*0.5+qia_Ve_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vsi_s+(0.0)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vsi_s);
  T9_Ve_si_Vge_e=(+(+0.0*0.5+qia_Ve_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vge_e+(0.0)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vge_e);
  T9_Ve_si_Ve_si=(+(+qia_Ve_si_Ve_si*0.5+qia_Ve_si*0.0+qia_Ve_si*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Ve_si+(qia_Ve_si*0.5)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Ve_si);
  T9_Ve_si_Ve_di=(+(+qia_Ve_si_Ve_di*0.5+qia_Ve_si*0.0+qia_Ve_di*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Ve_di+(qia_Ve_di*0.5)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Ve_di);
  T9_Ve_si_Vge_si=(+(+qia_Ve_si_Vge_si*0.5+qia_Ve_si*0.0+qia_Vge_si*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vge_si+(qia_Vge_si*0.5)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vge_si);
  T9_Ve_si_Tempt_GND=(+(+qia_Ve_si_Tempt_GND*0.5+qia_Ve_si*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Tempt_GND);
  T9_Ve_si_Vdi_si=(+(+qia_Ve_si_Vdi_si*0.5+qia_Ve_si*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+qia_Ve_si*0.5*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Ve_si+(qia*0.5)*T1_Ve_si_Vdi_si);
#endif
T9_Ve_di=((qia_Ve_di*0.5*T1)+((qia*0.5)*T1_Ve_di));
#if defined(_DERIVATE2)
  T9_Ve_di_Vge_di=(+(+0.0*0.5+qia_Ve_di*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vge_di+(0.0)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vge_di);
  T9_Ve_di_Vdi_d=(+(+0.0*0.5+qia_Ve_di*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vdi_d+(0.0)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vdi_d);
  T9_Ve_di_Vsi_s=(+(+0.0*0.5+qia_Ve_di*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vsi_s+(0.0)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vsi_s);
  T9_Ve_di_Vge_e=(+(+0.0*0.5+qia_Ve_di*0.0+0.0*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vge_e+(0.0)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vge_e);
  T9_Ve_di_Ve_si=(+(+qia_Ve_di_Ve_si*0.5+qia_Ve_di*0.0+qia_Ve_si*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Ve_si+(qia_Ve_si*0.5)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Ve_si);
  T9_Ve_di_Ve_di=(+(+qia_Ve_di_Ve_di*0.5+qia_Ve_di*0.0+qia_Ve_di*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Ve_di+(qia_Ve_di*0.5)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Ve_di);
  T9_Ve_di_Vge_si=(+(+qia_Ve_di_Vge_si*0.5+qia_Ve_di*0.0+qia_Vge_si*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vge_si+(qia_Vge_si*0.5)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vge_si);
  T9_Ve_di_Tempt_GND=(+(+qia_Ve_di_Tempt_GND*0.5+qia_Ve_di*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Tempt_GND);
  T9_Ve_di_Vdi_si=(+(+qia_Ve_di_Vdi_si*0.5+qia_Ve_di*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+qia_Ve_di*0.5*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Ve_di+(qia*0.5)*T1_Ve_di_Vdi_si);
#endif
T9_Vge_si=((qia_Vge_si*0.5*T1)+((qia*0.5)*T1_Vge_si));
#if defined(_DERIVATE2)
  T9_Vge_si_Vge_di=(+(+0.0*0.5+qia_Vge_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vge_di+(0.0)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vge_di);
  T9_Vge_si_Vdi_d=(+(+0.0*0.5+qia_Vge_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vdi_d+(0.0)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vdi_d);
  T9_Vge_si_Vsi_s=(+(+0.0*0.5+qia_Vge_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vsi_s+(0.0)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vsi_s);
  T9_Vge_si_Vge_e=(+(+0.0*0.5+qia_Vge_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vge_e+(0.0)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vge_e);
  T9_Vge_si_Ve_si=(+(+qia_Vge_si_Ve_si*0.5+qia_Vge_si*0.0+qia_Ve_si*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Ve_si);
  T9_Vge_si_Ve_di=(+(+qia_Vge_si_Ve_di*0.5+qia_Vge_si*0.0+qia_Ve_di*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Ve_di);
  T9_Vge_si_Vge_si=(+(+qia_Vge_si_Vge_si*0.5+qia_Vge_si*0.0+qia_Vge_si*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vge_si);
  T9_Vge_si_Tempt_GND=(+(+qia_Vge_si_Tempt_GND*0.5+qia_Vge_si*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Tempt_GND);
  T9_Vge_si_Vdi_si=(+(+qia_Vge_si_Vdi_si*0.5+qia_Vge_si*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+qia_Vge_si*0.5*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vge_si+(qia*0.5)*T1_Vge_si_Vdi_si);
#endif
T9_Tempt_GND=((qia_Tempt_GND*0.5*T1)+((qia*0.5)*T1_Tempt_GND));
#if defined(_DERIVATE2)
  T9_Tempt_GND_Vge_di=(+(+0.0*0.5+qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vge_di+(0.0)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vge_di);
  T9_Tempt_GND_Vdi_d=(+(+0.0*0.5+qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vdi_d+(0.0)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vdi_d);
  T9_Tempt_GND_Vsi_s=(+(+0.0*0.5+qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vsi_s+(0.0)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vsi_s);
  T9_Tempt_GND_Vge_e=(+(+0.0*0.5+qia_Tempt_GND*0.0+0.0*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vge_e+(0.0)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vge_e);
  T9_Tempt_GND_Ve_si=(+(+qia_Tempt_GND_Ve_si*0.5+qia_Tempt_GND*0.0+qia_Ve_si*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Ve_si+(qia_Ve_si*0.5)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Ve_si);
  T9_Tempt_GND_Ve_di=(+(+qia_Tempt_GND_Ve_di*0.5+qia_Tempt_GND*0.0+qia_Ve_di*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Ve_di+(qia_Ve_di*0.5)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Ve_di);
  T9_Tempt_GND_Vge_si=(+(+qia_Tempt_GND_Vge_si*0.5+qia_Tempt_GND*0.0+qia_Vge_si*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vge_si+(qia_Vge_si*0.5)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vge_si);
  T9_Tempt_GND_Tempt_GND=(+(+qia_Tempt_GND_Tempt_GND*0.5+qia_Tempt_GND*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Tempt_GND);
  T9_Tempt_GND_Vdi_si=(+(+qia_Tempt_GND_Vdi_si*0.5+qia_Tempt_GND*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+qia_Tempt_GND*0.5*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Tempt_GND+(qia*0.5)*T1_Tempt_GND_Vdi_si);
#endif
T9_Vdi_si=((qia_Vdi_si*0.5*T1)+((qia*0.5)*T1_Vdi_si));
#if defined(_DERIVATE2)
  T9_Vdi_si_Vge_di=(+(+0.0*0.5+qia_Vdi_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vge_di+(0.0)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vge_di);
  T9_Vdi_si_Vdi_d=(+(+0.0*0.5+qia_Vdi_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vdi_d+(0.0)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vdi_d);
  T9_Vdi_si_Vsi_s=(+(+0.0*0.5+qia_Vdi_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vsi_s+(0.0)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vsi_s);
  T9_Vdi_si_Vge_e=(+(+0.0*0.5+qia_Vdi_si*0.0+0.0*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vge_e+(0.0)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vge_e);
  T9_Vdi_si_Ve_si=(+(+qia_Vdi_si_Ve_si*0.5+qia_Vdi_si*0.0+qia_Ve_si*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Ve_si+(qia_Ve_si*0.5)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Ve_si);
  T9_Vdi_si_Ve_di=(+(+qia_Vdi_si_Ve_di*0.5+qia_Vdi_si*0.0+qia_Ve_di*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Ve_di+(qia_Ve_di*0.5)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Ve_di);
  T9_Vdi_si_Vge_si=(+(+qia_Vdi_si_Vge_si*0.5+qia_Vdi_si*0.0+qia_Vge_si*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vge_si+(qia_Vge_si*0.5)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vge_si);
  T9_Vdi_si_Tempt_GND=(+(+qia_Vdi_si_Tempt_GND*0.5+qia_Vdi_si*0.0+qia_Tempt_GND*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Tempt_GND+(qia_Tempt_GND*0.5)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Tempt_GND);
  T9_Vdi_si_Vdi_si=(+(+qia_Vdi_si_Vdi_si*0.5+qia_Vdi_si*0.0+qia_Vdi_si*0.0+qia*0.0)*T1+qia_Vdi_si*0.5*T1_Vdi_si+(qia_Vdi_si*0.5)*T1_Vdi_si+(qia*0.5)*T1_Vdi_si_Vdi_si);
#endif
#endif
T9=((qia*0.5)*T1);
EXIT_IF_ISNAN(((qia*0.5)*T1))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(ge,di)V(di,d)V(si,s)V(ge,e)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gche_Tempt_GND=((((beta_Tempt_GND*T9)+(beta*T9_Tempt_GND))*T6)+((beta*T9)*T6_Tempt_GND));
gche_Vdi_si=((((beta_Vdi_si*T9)+(beta*T9_Vdi_si))*T6)+((beta*T9)*T6_Vdi_si));
gche_Vge_di=(((beta*T9_Vge_di)*T6)+((beta*T9)*T6_Vge_di));
gche_Vdi_d=(((beta*T9_Vdi_d)*T6)+((beta*T9)*T6_Vdi_d));
gche_Vsi_s=(((beta*T9_Vsi_s)*T6)+((beta*T9)*T6_Vsi_s));
gche_Vge_e=(((beta*T9_Vge_e)*T6)+((beta*T9)*T6_Vge_e));
gche_Ve_si=(((beta*T9_Ve_si)*T6)+((beta*T9)*T6_Ve_si));
gche_Ve_di=(((beta*T9_Ve_di)*T6)+((beta*T9)*T6_Ve_di));
gche_Vge_si=(((beta*T9_Vge_si)*T6)+((beta*T9)*T6_Vge_si));
#endif
gche=((beta*T9)*T6);
EXIT_IF_ISNAN(((beta*T9)*T6))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s)V(ge,e) ddxprobe= */
noiGd0_Tempt_GND=(((((NFINtotal*beta_Tempt_GND)*qia)+((NFINtotal*beta)*qia_Tempt_GND))*(1.0+(gche*Rdsi))-((NFINtotal*beta)*qia)*((gche_Tempt_GND*Rdsi)+(gche*Rdsi_Tempt_GND)))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vdi_si=(((((NFINtotal*beta_Vdi_si)*qia)+((NFINtotal*beta)*qia_Vdi_si))*(1.0+(gche*Rdsi))-((NFINtotal*beta)*qia)*((gche_Vdi_si*Rdsi)+(gche*Rdsi_Vdi_si)))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Ve_si=((((NFINtotal*beta)*qia_Ve_si)*(1.0+(gche*Rdsi))-((NFINtotal*beta)*qia)*((gche_Ve_si*Rdsi)+(gche*Rdsi_Ve_si)))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Ve_di=((((NFINtotal*beta)*qia_Ve_di)*(1.0+(gche*Rdsi))-((NFINtotal*beta)*qia)*((gche_Ve_di*Rdsi)+(gche*Rdsi_Ve_di)))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vge_si=((((NFINtotal*beta)*qia_Vge_si)*(1.0+(gche*Rdsi))-((NFINtotal*beta)*qia)*((gche_Vge_si*Rdsi)+(gche*Rdsi_Vge_si)))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vge_di=(-((NFINtotal*beta)*qia)*((gche_Vge_di*Rdsi)+(gche*Rdsi_Vge_di))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vdi_d=(-((NFINtotal*beta)*qia)*gche_Vdi_d*Rdsi/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vsi_s=(-((NFINtotal*beta)*qia)*gche_Vsi_s*Rdsi/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
noiGd0_Vge_e=(-((NFINtotal*beta)*qia)*((gche_Vge_e*Rdsi)+(gche*Rdsi_Vge_e))/(1.0+(gche*Rdsi))/(1.0+(gche*Rdsi)));
#endif
noiGd0=(((NFINtotal*beta)*qia)/(1.0+(gche*Rdsi)));
EXIT_IF_ISNAN((((NFINtotal*beta)*qia)/(1.0+(gche*Rdsi))))
#if defined(_DERIVATE) /* probe=V(ge,di)V(di,d)V(si,s)V(ge,e)V(di,si)Temp(t,GND)V(e,si)V(e,di)V(ge,si) ddxprobe= */
GammaGd0_Vge_di=((gamma_Vge_di*noiGd0)+(gamma*noiGd0_Vge_di));
GammaGd0_Vdi_d=((gamma_Vdi_d*noiGd0)+(gamma*noiGd0_Vdi_d));
GammaGd0_Vsi_s=((gamma_Vsi_s*noiGd0)+(gamma*noiGd0_Vsi_s));
GammaGd0_Vge_e=((gamma_Vge_e*noiGd0)+(gamma*noiGd0_Vge_e));
GammaGd0_Vdi_si=((gamma_Vdi_si*noiGd0)+(gamma*noiGd0_Vdi_si));
GammaGd0_Tempt_GND=((gamma_Tempt_GND*noiGd0)+(gamma*noiGd0_Tempt_GND));
GammaGd0_Ve_si=((gamma_Ve_si*noiGd0)+(gamma*noiGd0_Ve_si));
GammaGd0_Ve_di=((gamma_Ve_di*noiGd0)+(gamma*noiGd0_Ve_di));
GammaGd0_Vge_si=((gamma_Vge_si*noiGd0)+(gamma*noiGd0_Vge_si));
#endif
GammaGd0=(gamma*noiGd0);
EXIT_IF_ISNAN((gamma*noiGd0))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)V(di,d)V(si,s) ddxprobe= */
sid_Tempt_GND=(((4.0*Vtm_Tempt_GND)*1.60219e-19*GammaGd0)+(((4.0*Vtm)*1.60219e-19)*GammaGd0_Tempt_GND));
sid_Vge_di=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vge_di);
sid_Vge_e=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vge_e);
sid_Ve_si=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Ve_si);
sid_Ve_di=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Ve_di);
sid_Vge_si=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vge_si);
sid_Vdi_si=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vdi_si);
sid_Vdi_d=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vdi_d);
sid_Vsi_s=(((4.0*Vtm)*1.60219e-19)*GammaGd0_Vsi_s);
#endif
sid=(((4.0*Vtm)*1.60219e-19)*GammaGd0);
EXIT_IF_ISNAN((((4.0*Vtm)*1.60219e-19)*GammaGd0))
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe= */
C0_Vge_e=(NFINtotal*coxeff_Vge_e)*WeffCV0*LeffCV;
C0_Vdi_si=(NFINtotal*coxeff_Vdi_si)*WeffCV0*LeffCV;
C0_Ve_si=(NFINtotal*coxeff_Ve_si)*WeffCV0*LeffCV;
C0_Ve_di=(NFINtotal*coxeff_Ve_di)*WeffCV0*LeffCV;
C0_Vge_si=(NFINtotal*coxeff_Vge_si)*WeffCV0*LeffCV;
C0_Tempt_GND=(NFINtotal*coxeff_Tempt_GND)*WeffCV0*LeffCV;
#endif
C0=(((NFINtotal*coxeff)*WeffCV0)*LeffCV);
EXIT_IF_ISNAN((((NFINtotal*coxeff)*WeffCV0)*LeffCV))
#endif
if
(((gamma>0.0)&&(delta>0.0)))
{
{
double m00_sqrt(d00_sqrt0,(delta/gamma))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(delta/gamma))
#endif
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s)V(ge,e) ddxprobe= */
sf_Tempt_GND=((noiGd0_Tempt_GND*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Tempt_GND*gamma-delta*gamma_Tempt_GND)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vdi_si=((noiGd0_Vdi_si*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vdi_si*gamma-delta*gamma_Vdi_si)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Ve_si=((noiGd0_Ve_si*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Ve_si*gamma-delta*gamma_Ve_si)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Ve_di=((noiGd0_Ve_di*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Ve_di*gamma-delta*gamma_Ve_di)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vge_si=((noiGd0_Vge_si*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vge_si*gamma-delta*gamma_Vge_si)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vge_di=((noiGd0_Vge_di*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vge_di*gamma-delta*gamma_Vge_di)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vdi_d=((noiGd0_Vdi_d*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vdi_d*gamma-delta*gamma_Vdi_d)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vsi_s=((noiGd0_Vsi_s*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vsi_s*gamma-delta*gamma_Vsi_s)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
sf_Vge_e=((noiGd0_Vge_e*d00_sqrt0-(noiGd0+1.0e-15)*((delta_Vge_e*gamma-delta*gamma_Vge_e)/gamma/gamma)*d10_sqrt0)/d00_sqrt0/d00_sqrt0);
#endif
sf=((noiGd0+1.0e-15)/d00_sqrt0);
EXIT_IF_ISNAN(((noiGd0+1.0e-15)/d00_sqrt0))
}
}
else
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di)V(di,d)V(si,s)V(ge,e) ddxprobe= */
sf_Tempt_GND=0.0;
sf_Vdi_si=0.0;
sf_Ve_si=0.0;
sf_Ve_di=0.0;
sf_Vge_si=0.0;
sf_Vge_di=0.0;
sf_Vdi_d=0.0;
sf_Vsi_s=0.0;
sf_Vge_e=0.0;
#endif
sf=0.0;
EXIT_IF_ISNAN(0.0)
}
}
else
{ /* no default */ }
/* -- CASE END -- */;
if
((pModel->RDSMOD!=2))
{
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si) ddxprobe= */
gspr_Tempt_GND=(-Rsource_Tempt_GND/Rsource/Rsource);
gspr_Vsi_s=(-Rsource_Vsi_s/Rsource/Rsource);
gspr_Vge_e=(-Rsource_Vge_e/Rsource/Rsource);
gspr_Vdi_si=(-Rsource_Vdi_si/Rsource/Rsource);
gspr_Ve_si=(-Rsource_Ve_si/Rsource/Rsource);
gspr_Ve_di=(-Rsource_Ve_di/Rsource/Rsource);
gspr_Vge_si=(-Rsource_Vge_si/Rsource/Rsource);
#endif
gspr=(1.0/Rsource);
EXIT_IF_ISNAN((1.0/Rsource))
#if defined(_DERIVATE) /* probe=Temp(t,GND)V(di,d)V(si,s)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)V(ge,di) ddxprobe= */
gdpr_Tempt_GND=(-Rdrain_Tempt_GND/Rdrain/Rdrain);
gdpr_Vdi_d=(-Rdrain_Vdi_d/Rdrain/Rdrain);
gdpr_Vsi_s=(-Rdrain_Vsi_s/Rdrain/Rdrain);
gdpr_Vge_e=(-Rdrain_Vge_e/Rdrain/Rdrain);
gdpr_Vdi_si=(-Rdrain_Vdi_si/Rdrain/Rdrain);
gdpr_Ve_si=(-Rdrain_Ve_si/Rdrain/Rdrain);
gdpr_Ve_di=(-Rdrain_Ve_di/Rdrain/Rdrain);
gdpr_Vge_si=(-Rdrain_Vge_si/Rdrain/Rdrain);
gdpr_Vge_di=(-Rdrain_Vge_di/Rdrain/Rdrain);
#endif
gdpr=(1.0/Rdrain);
EXIT_IF_ISNAN((1.0/Rdrain))
}
if
((sigvds>0.0))
{
  _load_static_residual2(di,si,(devsign*ids))
  _load_static_jacobian4(di,si,ge,di,(devsign*ids_Vge_di))
  _load_static_jacobian4(di,si,ge,si,(devsign*ids_Vge_si))
  _load_static_jacobian4(di,si,e,di,(devsign*ids_Ve_di))
  _load_static_jacobian4(di,si,e,si,(devsign*ids_Ve_si))
  _load_static_jacobian4(di,si,ge,e,(devsign*ids_Vge_e))
  _load_static_jacobian4(di,si,di,si,(devsign*ids_Vdi_si))
  _load_static_jacobian2s(di,si,t,(devsign*ids_Tempt_GND))
}
else
{
  _load_static_residual2(si,di,(devsign*ids))
  _load_static_jacobian4(si,di,ge,di,(devsign*ids_Vge_di))
  _load_static_jacobian4(si,di,ge,si,(devsign*ids_Vge_si))
  _load_static_jacobian4(si,di,e,di,(devsign*ids_Ve_di))
  _load_static_jacobian4(si,di,e,si,(devsign*ids_Ve_si))
  _load_static_jacobian4(si,di,ge,e,(devsign*ids_Vge_e))
  _load_static_jacobian4(si,di,di,si,(devsign*ids_Vdi_si))
  _load_static_jacobian2s(si,di,t,(devsign*ids_Tempt_GND))
}
  _load_dynamic_residual2(di,si,(devsign*_DDT(qd)))
  _load_dynamic_jacobian4(di,si,ge,e,(devsign*qd_Vge_e))
  _load_dynamic_jacobian2s(di,si,t,(devsign*qd_Tempt_GND))
  _load_dynamic_jacobian4(di,si,ge,si,(devsign*qd_Vge_si))
  _load_dynamic_jacobian4(di,si,e,di,(devsign*qd_Ve_di))
  _load_dynamic_jacobian4(di,si,e,si,(devsign*qd_Ve_si))
  _load_dynamic_jacobian4(di,si,di,si,(devsign*qd_Vdi_si))
  _load_dynamic_residual2(ge,si,(devsign*_DDT(qg)))
  _load_dynamic_jacobian4(ge,si,ge,e,(devsign*qg_Vge_e))
  _load_dynamic_jacobian2s(ge,si,t,(devsign*qg_Tempt_GND))
  _load_dynamic_jacobian4(ge,si,ge,si,(devsign*qg_Vge_si))
  _load_dynamic_jacobian4(ge,si,e,di,(devsign*qg_Ve_di))
  _load_dynamic_jacobian4(ge,si,e,si,(devsign*qg_Ve_si))
  _load_dynamic_jacobian4(ge,si,di,si,(devsign*qg_Vdi_si))
if
((sigvds>0.0))
{
  _load_static_residual2(di,si,(devsign*idsgen))
  _load_static_jacobian4(di,si,di,si,(devsign*idsgen_Vdi_si))
  _load_static_jacobian4(di,si,ge,si,(devsign*idsgen_Vge_si))
  _load_static_jacobian4(di,si,e,di,(devsign*idsgen_Ve_di))
  _load_static_jacobian4(di,si,e,si,(devsign*idsgen_Ve_si))
  _load_static_jacobian4(di,si,ge,e,(devsign*idsgen_Vge_e))
  _load_static_jacobian4(di,si,ge,di,(devsign*idsgen_Vge_di))
  _load_static_jacobian2s(di,si,t,(devsign*idsgen_Tempt_GND))
  _load_static_residual2(ge,si,(devsign*(igcs+igs)))
  _load_static_jacobian4(ge,si,si,s,(devsign*igcs_Vsi_s))
  _load_static_jacobian4(ge,si,di,d,(devsign*igcs_Vdi_d))
  _load_static_jacobian2s(ge,si,t,(devsign*(igcs_Tempt_GND+igs_Tempt_GND)))
  _load_static_jacobian4(ge,si,ge,si,(devsign*(igcs_Vge_si+igs_Vge_si)))
  _load_static_jacobian4(ge,si,e,di,(devsign*(igcs_Ve_di+igs_Ve_di)))
  _load_static_jacobian4(ge,si,e,si,(devsign*(igcs_Ve_si+igs_Ve_si)))
  _load_static_jacobian4(ge,si,di,si,(devsign*(igcs_Vdi_si+igs_Vdi_si)))
  _load_static_jacobian4(ge,si,ge,e,(devsign*(igcs_Vge_e+igs_Vge_e)))
  _load_static_jacobian4(ge,si,ge,di,(devsign*(igcs_Vge_di+igs_Vge_di)))
  _load_static_residual2(ge,di,(devsign*(igcd+igd)))
  _load_static_jacobian4(ge,di,si,s,(devsign*igcd_Vsi_s))
  _load_static_jacobian4(ge,di,di,d,(devsign*igcd_Vdi_d))
  _load_static_jacobian2s(ge,di,t,(devsign*(igcd_Tempt_GND+igd_Tempt_GND)))
  _load_static_jacobian4(ge,di,ge,si,(devsign*(igcd_Vge_si+igd_Vge_si)))
  _load_static_jacobian4(ge,di,e,di,(devsign*(igcd_Ve_di+igd_Ve_di)))
  _load_static_jacobian4(ge,di,e,si,(devsign*(igcd_Ve_si+igd_Ve_si)))
  _load_static_jacobian4(ge,di,di,si,(devsign*(igcd_Vdi_si+igd_Vdi_si)))
  _load_static_jacobian4(ge,di,ge,e,(devsign*(igcd_Vge_e+igd_Vge_e)))
  _load_static_jacobian4(ge,di,ge,di,(devsign*(igcd_Vge_di+igd_Vge_di)))
if
((pModel->BULKMOD!=0))
{
  _load_static_residual2(di,e,(devsign*(igidl+Iii)))
  _load_static_jacobian4(di,e,ge,si,(devsign*(igidl_Vge_si+Iii_Vge_si)))
  _load_static_jacobian4(di,e,e,di,(devsign*(igidl_Ve_di+Iii_Ve_di)))
  _load_static_jacobian4(di,e,e,si,(devsign*(igidl_Ve_si+Iii_Ve_si)))
  _load_static_jacobian2s(di,e,t,(devsign*(igidl_Tempt_GND+Iii_Tempt_GND)))
  _load_static_jacobian4(di,e,di,si,(devsign*(igidl_Vdi_si+Iii_Vdi_si)))
  _load_static_jacobian4(di,e,ge,e,(devsign*(igidl_Vge_e+Iii_Vge_e)))
  _load_static_jacobian4(di,e,si,s,(devsign*igidl_Vsi_s))
  _load_static_jacobian4(di,e,di,d,(devsign*igidl_Vdi_d))
  _load_static_jacobian4(di,e,ge,di,(devsign*(igidl_Vge_di+Iii_Vge_di)))
  _load_static_residual2(si,e,(devsign*igisl))
  _load_static_jacobian4(si,e,ge,si,(devsign*igisl_Vge_si))
  _load_static_jacobian4(si,e,e,di,(devsign*igisl_Ve_di))
  _load_static_jacobian4(si,e,e,si,(devsign*igisl_Ve_si))
  _load_static_jacobian2s(si,e,t,(devsign*igisl_Tempt_GND))
  _load_static_jacobian4(si,e,di,si,(devsign*igisl_Vdi_si))
  _load_static_jacobian4(si,e,ge,e,(devsign*igisl_Vge_e))
  _load_static_jacobian4(si,e,si,s,(devsign*igisl_Vsi_s))
  _load_static_jacobian4(si,e,di,d,(devsign*igisl_Vdi_d))
  _load_static_jacobian4(si,e,ge,di,(devsign*igisl_Vge_di))
  _load_static_residual2(ge,e,(devsign*(igbinv+igbacc)))
  _load_static_jacobian4(ge,e,si,s,(devsign*(igbinv_Vsi_s+igbacc_Vsi_s)))
  _load_static_jacobian4(ge,e,di,d,(devsign*(igbinv_Vdi_d+igbacc_Vdi_d)))
  _load_static_jacobian4(ge,e,ge,di,(devsign*(igbinv_Vge_di+igbacc_Vge_di)))
  _load_static_jacobian4(ge,e,ge,si,(devsign*(igbinv_Vge_si+igbacc_Vge_si)))
  _load_static_jacobian4(ge,e,e,di,(devsign*(igbinv_Ve_di+igbacc_Ve_di)))
  _load_static_jacobian4(ge,e,e,si,(devsign*(igbinv_Ve_si+igbacc_Ve_si)))
  _load_static_jacobian2s(ge,e,t,(devsign*(igbinv_Tempt_GND+igbacc_Tempt_GND)))
  _load_static_jacobian4(ge,e,di,si,(devsign*(igbinv_Vdi_si+igbacc_Vdi_si)))
  _load_static_jacobian4(ge,e,ge,e,(devsign*(igbinv_Vge_e+igbacc_Vge_e)))
}
else
{
  _load_static_residual2(di,si,(devsign*(igidl+Iii)))
  _load_static_jacobian4(di,si,ge,si,(devsign*(igidl_Vge_si+Iii_Vge_si)))
  _load_static_jacobian4(di,si,e,di,(devsign*(igidl_Ve_di+Iii_Ve_di)))
  _load_static_jacobian4(di,si,e,si,(devsign*(igidl_Ve_si+Iii_Ve_si)))
  _load_static_jacobian2s(di,si,t,(devsign*(igidl_Tempt_GND+Iii_Tempt_GND)))
  _load_static_jacobian4(di,si,di,si,(devsign*(igidl_Vdi_si+Iii_Vdi_si)))
  _load_static_jacobian4(di,si,ge,e,(devsign*(igidl_Vge_e+Iii_Vge_e)))
  _load_static_jacobian4(di,si,si,s,(devsign*igidl_Vsi_s))
  _load_static_jacobian4(di,si,di,d,(devsign*igidl_Vdi_d))
  _load_static_jacobian4(di,si,ge,di,(devsign*(igidl_Vge_di+Iii_Vge_di)))
  _load_static_residual2(si,di,(devsign*igisl))
  _load_static_jacobian4(si,di,ge,si,(devsign*igisl_Vge_si))
  _load_static_jacobian4(si,di,e,di,(devsign*igisl_Ve_di))
  _load_static_jacobian4(si,di,e,si,(devsign*igisl_Ve_si))
  _load_static_jacobian2s(si,di,t,(devsign*igisl_Tempt_GND))
  _load_static_jacobian4(si,di,di,si,(devsign*igisl_Vdi_si))
  _load_static_jacobian4(si,di,ge,e,(devsign*igisl_Vge_e))
  _load_static_jacobian4(si,di,si,s,(devsign*igisl_Vsi_s))
  _load_static_jacobian4(si,di,di,d,(devsign*igisl_Vdi_d))
  _load_static_jacobian4(si,di,ge,di,(devsign*igisl_Vge_di))
}
}
else
{
  _load_static_residual2(si,di,(devsign*idsgen))
  _load_static_jacobian4(si,di,di,si,(devsign*idsgen_Vdi_si))
  _load_static_jacobian4(si,di,ge,si,(devsign*idsgen_Vge_si))
  _load_static_jacobian4(si,di,e,di,(devsign*idsgen_Ve_di))
  _load_static_jacobian4(si,di,e,si,(devsign*idsgen_Ve_si))
  _load_static_jacobian4(si,di,ge,e,(devsign*idsgen_Vge_e))
  _load_static_jacobian4(si,di,ge,di,(devsign*idsgen_Vge_di))
  _load_static_jacobian2s(si,di,t,(devsign*idsgen_Tempt_GND))
  _load_static_residual2(ge,di,(devsign*(igcs+igs)))
  _load_static_jacobian4(ge,di,si,s,(devsign*igcs_Vsi_s))
  _load_static_jacobian4(ge,di,di,d,(devsign*igcs_Vdi_d))
  _load_static_jacobian2s(ge,di,t,(devsign*(igcs_Tempt_GND+igs_Tempt_GND)))
  _load_static_jacobian4(ge,di,ge,si,(devsign*(igcs_Vge_si+igs_Vge_si)))
  _load_static_jacobian4(ge,di,e,di,(devsign*(igcs_Ve_di+igs_Ve_di)))
  _load_static_jacobian4(ge,di,e,si,(devsign*(igcs_Ve_si+igs_Ve_si)))
  _load_static_jacobian4(ge,di,di,si,(devsign*(igcs_Vdi_si+igs_Vdi_si)))
  _load_static_jacobian4(ge,di,ge,e,(devsign*(igcs_Vge_e+igs_Vge_e)))
  _load_static_jacobian4(ge,di,ge,di,(devsign*(igcs_Vge_di+igs_Vge_di)))
  _load_static_residual2(ge,si,(devsign*(igcd+igd)))
  _load_static_jacobian4(ge,si,si,s,(devsign*igcd_Vsi_s))
  _load_static_jacobian4(ge,si,di,d,(devsign*igcd_Vdi_d))
  _load_static_jacobian2s(ge,si,t,(devsign*(igcd_Tempt_GND+igd_Tempt_GND)))
  _load_static_jacobian4(ge,si,ge,si,(devsign*(igcd_Vge_si+igd_Vge_si)))
  _load_static_jacobian4(ge,si,e,di,(devsign*(igcd_Ve_di+igd_Ve_di)))
  _load_static_jacobian4(ge,si,e,si,(devsign*(igcd_Ve_si+igd_Ve_si)))
  _load_static_jacobian4(ge,si,di,si,(devsign*(igcd_Vdi_si+igd_Vdi_si)))
  _load_static_jacobian4(ge,si,ge,e,(devsign*(igcd_Vge_e+igd_Vge_e)))
  _load_static_jacobian4(ge,si,ge,di,(devsign*(igcd_Vge_di+igd_Vge_di)))
if
((pModel->BULKMOD!=0))
{
  _load_static_residual2(si,e,(devsign*(igidl+Iii)))
  _load_static_jacobian4(si,e,ge,si,(devsign*(igidl_Vge_si+Iii_Vge_si)))
  _load_static_jacobian4(si,e,e,di,(devsign*(igidl_Ve_di+Iii_Ve_di)))
  _load_static_jacobian4(si,e,e,si,(devsign*(igidl_Ve_si+Iii_Ve_si)))
  _load_static_jacobian2s(si,e,t,(devsign*(igidl_Tempt_GND+Iii_Tempt_GND)))
  _load_static_jacobian4(si,e,di,si,(devsign*(igidl_Vdi_si+Iii_Vdi_si)))
  _load_static_jacobian4(si,e,ge,e,(devsign*(igidl_Vge_e+Iii_Vge_e)))
  _load_static_jacobian4(si,e,si,s,(devsign*igidl_Vsi_s))
  _load_static_jacobian4(si,e,di,d,(devsign*igidl_Vdi_d))
  _load_static_jacobian4(si,e,ge,di,(devsign*(igidl_Vge_di+Iii_Vge_di)))
  _load_static_residual2(di,e,(devsign*igisl))
  _load_static_jacobian4(di,e,ge,si,(devsign*igisl_Vge_si))
  _load_static_jacobian4(di,e,e,di,(devsign*igisl_Ve_di))
  _load_static_jacobian4(di,e,e,si,(devsign*igisl_Ve_si))
  _load_static_jacobian2s(di,e,t,(devsign*igisl_Tempt_GND))
  _load_static_jacobian4(di,e,di,si,(devsign*igisl_Vdi_si))
  _load_static_jacobian4(di,e,ge,e,(devsign*igisl_Vge_e))
  _load_static_jacobian4(di,e,si,s,(devsign*igisl_Vsi_s))
  _load_static_jacobian4(di,e,di,d,(devsign*igisl_Vdi_d))
  _load_static_jacobian4(di,e,ge,di,(devsign*igisl_Vge_di))
  _load_static_residual2(ge,e,(devsign*(igbinv+igbacc)))
  _load_static_jacobian4(ge,e,si,s,(devsign*(igbinv_Vsi_s+igbacc_Vsi_s)))
  _load_static_jacobian4(ge,e,di,d,(devsign*(igbinv_Vdi_d+igbacc_Vdi_d)))
  _load_static_jacobian4(ge,e,ge,di,(devsign*(igbinv_Vge_di+igbacc_Vge_di)))
  _load_static_jacobian4(ge,e,ge,si,(devsign*(igbinv_Vge_si+igbacc_Vge_si)))
  _load_static_jacobian4(ge,e,e,di,(devsign*(igbinv_Ve_di+igbacc_Ve_di)))
  _load_static_jacobian4(ge,e,e,si,(devsign*(igbinv_Ve_si+igbacc_Ve_si)))
  _load_static_jacobian2s(ge,e,t,(devsign*(igbinv_Tempt_GND+igbacc_Tempt_GND)))
  _load_static_jacobian4(ge,e,di,si,(devsign*(igbinv_Vdi_si+igbacc_Vdi_si)))
  _load_static_jacobian4(ge,e,ge,e,(devsign*(igbinv_Vge_e+igbacc_Vge_e)))
}
else
{
  _load_static_residual2(si,di,(devsign*(igidl+Iii)))
  _load_static_jacobian4(si,di,ge,si,(devsign*(igidl_Vge_si+Iii_Vge_si)))
  _load_static_jacobian4(si,di,e,di,(devsign*(igidl_Ve_di+Iii_Ve_di)))
  _load_static_jacobian4(si,di,e,si,(devsign*(igidl_Ve_si+Iii_Ve_si)))
  _load_static_jacobian2s(si,di,t,(devsign*(igidl_Tempt_GND+Iii_Tempt_GND)))
  _load_static_jacobian4(si,di,di,si,(devsign*(igidl_Vdi_si+Iii_Vdi_si)))
  _load_static_jacobian4(si,di,ge,e,(devsign*(igidl_Vge_e+Iii_Vge_e)))
  _load_static_jacobian4(si,di,si,s,(devsign*igidl_Vsi_s))
  _load_static_jacobian4(si,di,di,d,(devsign*igidl_Vdi_d))
  _load_static_jacobian4(si,di,ge,di,(devsign*(igidl_Vge_di+Iii_Vge_di)))
  _load_static_residual2(di,si,(devsign*igisl))
  _load_static_jacobian4(di,si,ge,si,(devsign*igisl_Vge_si))
  _load_static_jacobian4(di,si,e,di,(devsign*igisl_Ve_di))
  _load_static_jacobian4(di,si,e,si,(devsign*igisl_Ve_si))
  _load_static_jacobian2s(di,si,t,(devsign*igisl_Tempt_GND))
  _load_static_jacobian4(di,si,di,si,(devsign*igisl_Vdi_si))
  _load_static_jacobian4(di,si,ge,e,(devsign*igisl_Vge_e))
  _load_static_jacobian4(di,si,si,s,(devsign*igisl_Vsi_s))
  _load_static_jacobian4(di,si,di,d,(devsign*igisl_Vdi_d))
  _load_static_jacobian4(di,si,ge,di,(devsign*igisl_Vge_di))
}
}
if
((pModel->BULKMOD==0))
{
  _load_static_residual2(ge,si,(devsign*igbs))
  _load_static_jacobian4(ge,si,si,s,(devsign*igbs_Vsi_s))
  _load_static_jacobian4(ge,si,di,d,(devsign*igbs_Vdi_d))
  _load_static_jacobian4(ge,si,ge,di,(devsign*igbs_Vge_di))
  _load_static_jacobian4(ge,si,ge,si,(devsign*igbs_Vge_si))
  _load_static_jacobian4(ge,si,e,di,(devsign*igbs_Ve_di))
  _load_static_jacobian4(ge,si,e,si,(devsign*igbs_Ve_si))
  _load_static_jacobian2s(ge,si,t,(devsign*igbs_Tempt_GND))
  _load_static_jacobian4(ge,si,di,si,(devsign*igbs_Vdi_si))
  _load_static_jacobian4(ge,si,ge,e,(devsign*igbs_Vge_e))
  _load_static_residual2(ge,di,(devsign*igbd))
  _load_static_jacobian4(ge,di,si,s,(devsign*igbd_Vsi_s))
  _load_static_jacobian4(ge,di,di,d,(devsign*igbd_Vdi_d))
  _load_static_jacobian4(ge,di,ge,di,(devsign*igbd_Vge_di))
  _load_static_jacobian4(ge,di,ge,si,(devsign*igbd_Vge_si))
  _load_static_jacobian4(ge,di,e,di,(devsign*igbd_Ve_di))
  _load_static_jacobian4(ge,di,e,si,(devsign*igbd_Ve_si))
  _load_static_jacobian2s(ge,di,t,(devsign*igbd_Tempt_GND))
  _load_static_jacobian4(ge,di,di,si,(devsign*igbd_Vdi_si))
  _load_static_jacobian4(ge,di,ge,e,(devsign*igbd_Vge_e))
}
if
((pModel->BULKMOD!=0))
{
  _load_static_residual2(e,si,(devsign*Ies))
  _load_static_jacobian2s(e,si,t,(devsign*Ies_Tempt_GND))
  _load_static_jacobian4(e,si,di,si,(devsign*Ies_Vdi_si))
  _load_static_jacobian4(e,si,ge,si,(devsign*Ies_Vge_si))
  _load_static_jacobian4(e,si,e,di,(devsign*Ies_Ve_di))
  _load_static_jacobian4(e,si,e,si,(devsign*Ies_Ve_si))
  _load_static_jacobian4(e,si,ge,e,(devsign*Ies_Vge_e))
  _load_static_jacobian4(e,si,ge,di,(devsign*Ies_Vge_di))
  _load_static_residual2(e,di,(devsign*Ied))
  _load_static_jacobian2s(e,di,t,(devsign*Ied_Tempt_GND))
  _load_static_jacobian4(e,di,di,si,(devsign*Ied_Vdi_si))
  _load_static_jacobian4(e,di,ge,si,(devsign*Ied_Vge_si))
  _load_static_jacobian4(e,di,e,di,(devsign*Ied_Ve_di))
  _load_static_jacobian4(e,di,e,si,(devsign*Ied_Ve_si))
  _load_static_jacobian4(e,di,ge,e,(devsign*Ied_Vge_e))
  _load_static_jacobian4(e,di,ge,di,(devsign*Ied_Vge_di))
}
  _load_dynamic_residual2(e,si,(devsign*_DDT(Qes)))
  _load_dynamic_jacobian4(e,si,di,si,(devsign*Qes_Vdi_si))
  _load_dynamic_jacobian4(e,si,ge,si,(devsign*Qes_Vge_si))
  _load_dynamic_jacobian4(e,si,e,di,(devsign*Qes_Ve_di))
  _load_dynamic_jacobian4(e,si,e,si,(devsign*Qes_Ve_si))
  _load_dynamic_jacobian4(e,si,ge,e,(devsign*Qes_Vge_e))
  _load_dynamic_jacobian4(e,si,ge,di,(devsign*Qes_Vge_di))
  _load_dynamic_jacobian2s(e,si,t,(devsign*Qes_Tempt_GND))
  _load_dynamic_jacobian4(e,si,si,s,(devsign*Qes_Vsi_s))
  _load_dynamic_jacobian4(e,si,di,d,(devsign*Qes_Vdi_d))
  _load_dynamic_residual2(e,di,(devsign*_DDT(Qed)))
  _load_dynamic_jacobian4(e,di,di,si,(devsign*Qed_Vdi_si))
  _load_dynamic_jacobian4(e,di,ge,si,(devsign*Qed_Vge_si))
  _load_dynamic_jacobian4(e,di,e,di,(devsign*Qed_Ve_di))
  _load_dynamic_jacobian4(e,di,e,si,(devsign*Qed_Ve_si))
  _load_dynamic_jacobian4(e,di,ge,e,(devsign*Qed_Vge_e))
  _load_dynamic_jacobian4(e,di,ge,di,(devsign*Qed_Vge_di))
  _load_dynamic_jacobian2s(e,di,t,(devsign*Qed_Tempt_GND))
  _load_dynamic_jacobian4(e,di,si,s,(devsign*Qed_Vsi_s))
  _load_dynamic_jacobian4(e,di,di,d,(devsign*Qed_Vdi_d))
  _load_dynamic_residual2(e,ge,(devsign*_DDT(Qeg)))
  _load_dynamic_jacobian4(e,ge,e,ge,(devsign*Qeg_Ve_ge))
  _load_dynamic_jacobian2s(e,ge,t,(devsign*Qeg_Tempt_GND))
  _load_dynamic_jacobian4(e,ge,ge,si,(devsign*Qeg_Vge_si))
  _load_dynamic_jacobian4(e,ge,e,di,(devsign*Qeg_Ve_di))
  _load_dynamic_jacobian4(e,ge,e,si,(devsign*Qeg_Ve_si))
  _load_dynamic_jacobian4(e,ge,di,si,(devsign*Qeg_Vdi_si))
  _load_dynamic_jacobian4(e,ge,ge,e,(devsign*Qeg_Vge_e))
  _load_dynamic_jacobian4(e,ge,ge,di,(devsign*Qeg_Vge_di))
  _load_dynamic_residual2(ge,si,_DDT(qgs_parasitic))
  _load_dynamic_jacobian2s(ge,si,t,qgs_parasitic_Tempt_GND)
  _load_dynamic_jacobian4(ge,si,di,si,qgs_parasitic_Vdi_si)
  _load_dynamic_jacobian4(ge,si,ge,si,qgs_parasitic_Vge_si)
  _load_dynamic_jacobian4(ge,si,e,di,qgs_parasitic_Ve_di)
  _load_dynamic_jacobian4(ge,si,e,si,qgs_parasitic_Ve_si)
  _load_dynamic_jacobian4(ge,si,ge,e,qgs_parasitic_Vge_e)
  _load_dynamic_jacobian4(ge,si,ge,di,qgs_parasitic_Vge_di)
  _load_dynamic_jacobian4(ge,si,ge,s,qgs_parasitic_Vge_s)
  _load_dynamic_residual2(ge,di,_DDT(qgd_parasitic))
  _load_dynamic_jacobian2s(ge,di,t,qgd_parasitic_Tempt_GND)
  _load_dynamic_jacobian4(ge,di,di,si,qgd_parasitic_Vdi_si)
  _load_dynamic_jacobian4(ge,di,ge,si,qgd_parasitic_Vge_si)
  _load_dynamic_jacobian4(ge,di,e,di,qgd_parasitic_Ve_di)
  _load_dynamic_jacobian4(ge,di,e,si,qgd_parasitic_Ve_si)
  _load_dynamic_jacobian4(ge,di,ge,e,qgd_parasitic_Vge_e)
  _load_dynamic_jacobian4(ge,di,ge,di,qgd_parasitic_Vge_di)
  _load_dynamic_jacobian4(ge,di,ge,d,qgd_parasitic_Vge_d)
  _load_dynamic_residual2(d,s,_DDT(qds_fr))
  _load_dynamic_jacobian4(d,s,d,s,qds_fr_Vd_s)
#ifdef _DYNAMIC
if
((pModel->CGEOMOD==1))
{
  _load_dynamic_residual2(ge,s,_DDT(qgs_fr))
  _load_dynamic_jacobian2s(ge,s,t,qgs_fr_Tempt_GND)
  _load_dynamic_jacobian4(ge,s,di,si,qgs_fr_Vdi_si)
  _load_dynamic_jacobian4(ge,s,ge,si,qgs_fr_Vge_si)
  _load_dynamic_jacobian4(ge,s,e,di,qgs_fr_Ve_di)
  _load_dynamic_jacobian4(ge,s,e,si,qgs_fr_Ve_si)
  _load_dynamic_jacobian4(ge,s,ge,e,qgs_fr_Vge_e)
  _load_dynamic_jacobian4(ge,s,ge,di,qgs_fr_Vge_di)
  _load_dynamic_jacobian4(ge,s,ge,s,qgs_fr_Vge_s)
  _load_dynamic_residual2(ge,d,_DDT(qgd_fr))
  _load_dynamic_jacobian2s(ge,d,t,qgd_fr_Tempt_GND)
  _load_dynamic_jacobian4(ge,d,di,si,qgd_fr_Vdi_si)
  _load_dynamic_jacobian4(ge,d,ge,si,qgd_fr_Vge_si)
  _load_dynamic_jacobian4(ge,d,e,di,qgd_fr_Ve_di)
  _load_dynamic_jacobian4(ge,d,e,si,qgd_fr_Ve_si)
  _load_dynamic_jacobian4(ge,d,ge,e,qgd_fr_Vge_e)
  _load_dynamic_jacobian4(ge,d,ge,di,qgd_fr_Vge_di)
  _load_dynamic_jacobian4(ge,d,ge,d,qgd_fr_Vge_d)
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
  _load_dynamic_residual2(ge,si,(devsign*_DDT(qg_acc)))
  _load_dynamic_jacobian2s(ge,si,t,(devsign*qg_acc_Tempt_GND))
  _load_dynamic_jacobian4(ge,si,di,si,(devsign*qg_acc_Vdi_si))
  _load_dynamic_jacobian4(ge,si,ge,si,(devsign*qg_acc_Vge_si))
  _load_dynamic_jacobian4(ge,si,e,di,(devsign*qg_acc_Ve_di))
  _load_dynamic_jacobian4(ge,si,e,si,(devsign*qg_acc_Ve_si))
  _load_dynamic_jacobian4(ge,si,ge,e,(devsign*qg_acc_Vge_e))
  _load_dynamic_jacobian4(ge,si,ge,di,(devsign*qg_acc_Vge_di))
  _load_dynamic_residual2(e,si,(devsign*_DDT(qb_acc)))
  _load_dynamic_jacobian2s(e,si,t,(devsign*qb_acc_Tempt_GND))
  _load_dynamic_jacobian4(e,si,di,si,(devsign*qb_acc_Vdi_si))
  _load_dynamic_jacobian4(e,si,ge,si,(devsign*qb_acc_Vge_si))
  _load_dynamic_jacobian4(e,si,e,di,(devsign*qb_acc_Ve_di))
  _load_dynamic_jacobian4(e,si,e,si,(devsign*qb_acc_Ve_si))
  _load_dynamic_jacobian4(e,si,ge,e,(devsign*qb_acc_Vge_e))
  _load_dynamic_jacobian4(e,si,ge,di,(devsign*qb_acc_Vge_di))
}
#endif /* if(...) */
if
((pModel->RDSMOD==2))
{
  _load_static_residual2(d,di,0.0)
  _load_static_residual2(s,si,0.0)
}
else
{
  _load_static_residual2(d,di,((NP(d)-NP(di))/Rdrain))
  _load_static_jacobian4(d,di,ge,di,(-(NP(d)-NP(di))*Rdrain_Vge_di/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,ge,si,(-(NP(d)-NP(di))*Rdrain_Vge_si/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,e,di,(-(NP(d)-NP(di))*Rdrain_Ve_di/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,e,si,(-(NP(d)-NP(di))*Rdrain_Ve_si/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,di,si,(-(NP(d)-NP(di))*Rdrain_Vdi_si/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,ge,e,(-(NP(d)-NP(di))*Rdrain_Vge_e/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,si,s,(-(NP(d)-NP(di))*Rdrain_Vsi_s/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,di,d,(-(NP(d)-NP(di))*Rdrain_Vdi_d/Rdrain/Rdrain))
  _load_static_jacobian2s(d,di,t,(-(NP(d)-NP(di))*Rdrain_Tempt_GND/Rdrain/Rdrain))
  _load_static_jacobian4(d,di,d,di,(1/Rdrain))
  _load_static_residual2(s,si,((NP(s)-NP(si))/Rsource))
  _load_static_jacobian4(s,si,ge,si,(-(NP(s)-NP(si))*Rsource_Vge_si/Rsource/Rsource))
  _load_static_jacobian4(s,si,e,di,(-(NP(s)-NP(si))*Rsource_Ve_di/Rsource/Rsource))
  _load_static_jacobian4(s,si,e,si,(-(NP(s)-NP(si))*Rsource_Ve_si/Rsource/Rsource))
  _load_static_jacobian4(s,si,di,si,(-(NP(s)-NP(si))*Rsource_Vdi_si/Rsource/Rsource))
  _load_static_jacobian4(s,si,ge,e,(-(NP(s)-NP(si))*Rsource_Vge_e/Rsource/Rsource))
  _load_static_jacobian4(s,si,si,s,(-(NP(s)-NP(si))*Rsource_Vsi_s/Rsource/Rsource))
  _load_static_jacobian2s(s,si,t,(-(NP(s)-NP(si))*Rsource_Tempt_GND/Rsource/Rsource))
  _load_static_jacobian4(s,si,s,si,(1/Rsource))
}
if
((pModel->RGATEMOD!=0))
{
  _load_static_residual2(g,ge,((NP(g)-NP(ge))*ggeltd))
  _load_static_jacobian4(g,ge,g,ge,(ggeltd))
}
else
{
  _load_static_residual2(g,ge,0.0)
}
pInst->fpnoise0=FNPowerAt1Hz;
pInst->fenoise0=pModel->EF;
if
((pModel->RDSMOD!=2))
{
pInst->wnoise12=(((4.0*Vtm)*1.60219e-19)*gdpr);
pInst->wnoise11=(((4.0*Vtm)*1.60219e-19)*gspr);
}
if
((pModel->RGATEMOD!=0))
{
pInst->wnoise10=(((4.0*Vtm)*1.60219e-19)*ggeltd);
}
if
((pModel->TNOIMOD==0))
{
pInst->wnoise9=sid;
  _load_static_residual1(N,0.0)
}
else
{
pInst->wnoise8=(sid*fabs((1.0-(ctnoi*ctnoi))));
  _load_static_residual2(di,si,(((ctnoi*NP(N))*sf)*pModel->SCALEN))
  _load_static_jacobian2s(di,si,N,(ctnoi)*sf*pModel->SCALEN)
  _load_static_jacobian2s(di,si,t,((ctnoi_Tempt_GND*NP(N)*sf)+((ctnoi*NP(N))*sf_Tempt_GND))*pModel->SCALEN)
  _load_static_jacobian4(di,si,ge,si,((ctnoi_Vge_si*NP(N)*sf)+((ctnoi*NP(N))*sf_Vge_si))*pModel->SCALEN)
  _load_static_jacobian4(di,si,e,di,((ctnoi_Ve_di*NP(N)*sf)+((ctnoi*NP(N))*sf_Ve_di))*pModel->SCALEN)
  _load_static_jacobian4(di,si,e,si,((ctnoi_Ve_si*NP(N)*sf)+((ctnoi*NP(N))*sf_Ve_si))*pModel->SCALEN)
  _load_static_jacobian4(di,si,di,si,((ctnoi_Vdi_si*NP(N)*sf)+((ctnoi*NP(N))*sf_Vdi_si))*pModel->SCALEN)
  _load_static_jacobian4(di,si,ge,e,((ctnoi_Vge_e*NP(N)*sf)+((ctnoi*NP(N))*sf_Vge_e))*pModel->SCALEN)
  _load_static_jacobian4(di,si,si,s,((ctnoi_Vsi_s*NP(N)*sf)+((ctnoi*NP(N))*sf_Vsi_s))*pModel->SCALEN)
  _load_static_jacobian4(di,si,di,d,((ctnoi_Vdi_d*NP(N)*sf)+((ctnoi*NP(N))*sf_Vdi_d))*pModel->SCALEN)
  _load_static_jacobian4(di,si,ge,di,((ctnoi_Vge_di*NP(N)*sf)+((ctnoi*NP(N))*sf_Vge_di))*pModel->SCALEN)
if
(((gamma>0)&&(delta>0)))
{
  _load_static_residual1(N,((NP(N)*sf)*pModel->SCALEN))
  _load_static_jacobian2p(N,ge,e,(NP(N)*sf_Vge_e)*pModel->SCALEN)
  _load_static_jacobian2p(N,si,s,(NP(N)*sf_Vsi_s)*pModel->SCALEN)
  _load_static_jacobian2p(N,di,d,(NP(N)*sf_Vdi_d)*pModel->SCALEN)
  _load_static_jacobian2p(N,ge,di,(NP(N)*sf_Vge_di)*pModel->SCALEN)
  _load_static_jacobian2p(N,ge,si,(NP(N)*sf_Vge_si)*pModel->SCALEN)
  _load_static_jacobian2p(N,e,di,(NP(N)*sf_Ve_di)*pModel->SCALEN)
  _load_static_jacobian2p(N,e,si,(NP(N)*sf_Ve_si)*pModel->SCALEN)
  _load_static_jacobian2p(N,di,si,(NP(N)*sf_Vdi_si)*pModel->SCALEN)
  _load_static_jacobian1(N,t,(NP(N)*sf_Tempt_GND)*pModel->SCALEN)
  _load_static_jacobian1(N,N,(sf)*pModel->SCALEN)
pInst->wnoise7=(sid/(((sf*sf)*pModel->SCALEN)*pModel->SCALEN));
}
else
{
  _load_static_residual1(N,NP(N))
  _load_static_jacobian1(N,N,1.0)
}
  _load_dynamic_residual2(ge,si,_DDT((((0.5*C0)*pModel->SCALEN)*NP(N))))
  _load_dynamic_jacobian2s(ge,si,N,(((0.5*C0)*pModel->SCALEN)))
  _load_dynamic_jacobian2s(ge,si,t,(0.5*C0_Tempt_GND)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,si,ge,si,(0.5*C0_Vge_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,si,e,di,(0.5*C0_Ve_di)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,si,e,si,(0.5*C0_Ve_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,si,di,si,(0.5*C0_Vdi_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,si,ge,e,(0.5*C0_Vge_e)*pModel->SCALEN*NP(N))
  _load_dynamic_residual2(ge,di,_DDT((((0.5*C0)*pModel->SCALEN)*NP(N))))
  _load_dynamic_jacobian2s(ge,di,N,(((0.5*C0)*pModel->SCALEN)))
  _load_dynamic_jacobian2s(ge,di,t,(0.5*C0_Tempt_GND)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,di,ge,si,(0.5*C0_Vge_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,di,e,di,(0.5*C0_Ve_di)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,di,e,si,(0.5*C0_Ve_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,di,di,si,(0.5*C0_Vdi_si)*pModel->SCALEN*NP(N))
  _load_dynamic_jacobian4(ge,di,ge,e,(0.5*C0_Vge_e)*pModel->SCALEN*NP(N))
}
if
((pModel->IGCMOD!=0))
{
if
((sigvds>0))
{
pInst->wnoise6=((2.0*1.60219e-19)*fabs((igcs+igs)));
pInst->wnoise5=((2.0*1.60219e-19)*fabs((igcd+igd)));
}
else
{
pInst->wnoise4=((2.0*1.60219e-19)*fabs((igcs+igs)));
pInst->wnoise3=((2.0*1.60219e-19)*fabs((igcd+igd)));
}
}
if
((pModel->IGBMOD!=0))
{
if
((pModel->BULKMOD!=0))
{
pInst->wnoise2=((2.0*1.60219e-19)*fabs((igbinv+igbacc)));
}
else
{
pInst->wnoise1=((2.0*1.60219e-19)*fabs(igbs));
pInst->wnoise0=((2.0*1.60219e-19)*fabs(igbd));
}
}
if
(((pModel->SHMOD!=0)&&(pModel->RTH0>0)))
{
if
((pModel->RDSMOD!=2))
{
  _load_static_residual1(t,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids)+(((NP(d)-NP(di))*(NP(d)-NP(di)))/Rdrain))+(((NP(s)-NP(si))*(NP(s)-NP(si)))/Rsource))))
  _load_static_jacobian2p(t,s,si,(-(((NP(s)-NP(si))+(NP(s)-NP(si)))/Rsource)))
  _load_static_jacobian2p(t,si,s,(-((-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vsi_s/Rdrain/Rdrain)+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vsi_s/Rsource/Rsource))))
  _load_static_jacobian2p(t,di,d,(-(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vdi_d/Rdrain/Rdrain)))
  _load_static_jacobian2p(t,d,di,(-(((NP(d)-NP(di))+(NP(d)-NP(di)))/Rdrain)))
  _load_static_jacobian2p(t,ge,di,(-((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_di)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vge_di/Rdrain/Rdrain))))
  _load_static_jacobian2p(t,ge,si,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_si)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vge_si/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vge_si/Rsource/Rsource))))
  _load_static_jacobian2p(t,e,di,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Ve_di)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Ve_di/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Ve_di/Rsource/Rsource))))
  _load_static_jacobian2p(t,e,si,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Ve_si)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Ve_si/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Ve_si/Rsource/Rsource))))
  _load_static_jacobian2p(t,ge,e,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_e)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vge_e/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vge_e/Rsource/Rsource))))
  _load_static_jacobian1(t,t,(-(((((devsign*sigvds)*(NP(di)-NP(si)))*ids_Tempt_GND)+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Tempt_GND/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Tempt_GND/Rsource/Rsource))))
  _load_static_jacobian2p(t,di,si,(-((((((devsign*sigvds))*ids)+(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vdi_si))+(-((NP(d)-NP(di))*(NP(d)-NP(di)))*Rdrain_Vdi_si/Rdrain/Rdrain))+(-((NP(s)-NP(si))*(NP(s)-NP(si)))*Rsource_Vdi_si/Rsource/Rsource))))
}
else
{
  _load_static_residual1(t,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids)))
  _load_static_jacobian2p(t,ge,di,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_di)))
  _load_static_jacobian2p(t,ge,si,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_si)))
  _load_static_jacobian2p(t,e,di,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Ve_di)))
  _load_static_jacobian2p(t,e,si,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Ve_si)))
  _load_static_jacobian2p(t,ge,e,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vge_e)))
  _load_static_jacobian1(t,t,(-(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Tempt_GND)))
  _load_static_jacobian2p(t,di,si,(-((((devsign*sigvds))*ids)+(((devsign*sigvds)*(NP(di)-NP(si)))*ids_Vdi_si))))
}
}
  _load_static_residual1(t,(NP(t)*gth))
  _load_static_jacobian1(t,t,(gth))
  _load_dynamic_residual1(t,_DDT((NP(t)*cth)))
  _load_dynamic_jacobian1(t,t,(cth))
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_WEFF]=Weff0;
EXIT_IF_ISNAN(Weff0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_LEFF]=Leff;
EXIT_IF_ISNAN(Leff)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_WEFFCV]=WeffCV0;
EXIT_IF_ISNAN(WeffCV0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_LEFFCV]=LeffCV;
EXIT_IF_ISNAN(LeffCV)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]=(devsign*ids);
EXIT_IF_ISNAN((devsign*ids))
#endif
#ifdef _DYNAMIC
if
((sigvds>0))
{
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-(devsign*Ied));
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-(devsign*Ied)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=(((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ies));
EXIT_IF_ISNAN((((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ies)))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*((igd+igcd)+igbd)))+(devsign*((Iii+igidl)-igisl)));
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*((igd+igcd)+igbd)))+(devsign*((Iii+igidl)-igisl))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*((igs+igcs)+igbs)))+(devsign*(igisl-igidl)));
EXIT_IF_ISNAN(((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*((igs+igcs)+igbs)))+(devsign*(igisl-igidl))))
#endif
}
#endif /* if(...) */
}
else
{
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=(((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ied));
EXIT_IF_ISNAN((((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*(igs+igcs)))+(devsign*igisl))-(devsign*Ied)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-(devsign*Ies));
EXIT_IF_ISNAN(((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*(igd+igcd)))+(devsign*(Iii+igidl)))-(devsign*Ies)))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDEFF]=((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*((igs+igcs)+igbd)))+(devsign*(igisl-igidl)));
EXIT_IF_ISNAN(((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS])-(devsign*idsgen))-(devsign*((igs+igcs)+igbd)))+(devsign*(igisl-igidl))))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISEFF]=(((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*((igd+igcd)+igbs)))+(devsign*((Iii+igidl)-igisl)));
EXIT_IF_ISNAN((((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDS]+(devsign*idsgen))-(devsign*((igd+igcd)+igbs)))+(devsign*((Iii+igidl)-igisl))))
#endif
}
#endif /* if(...) */
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->BULKMOD==0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGTOT]=(devsign*(((((igs+igd)+igcs)+igcd)+igbs)+igbd));
EXIT_IF_ISNAN((devsign*(((((igs+igd)+igcs)+igcd)+igbs)+igbd)))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGTOT]=(devsign*(((((igs+igd)+igcs)+igcd)+igbacc)+igbinv));
EXIT_IF_ISNAN((devsign*(((((igs+igd)+igcs)+igcd)+igbacc)+igbinv)))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IDSGEN]=((sigvds*devsign)*idsgen);
EXIT_IF_ISNAN(((sigvds*devsign)*idsgen))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_III]=(devsign*Iii);
EXIT_IF_ISNAN((devsign*Iii))
#endif
#ifdef _DYNAMIC
if
((sigvds>0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]=(devsign*igidl);
EXIT_IF_ISNAN((devsign*igidl))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]=(devsign*igisl);
EXIT_IF_ISNAN((devsign*igisl))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL]=(devsign*igisl);
EXIT_IF_ISNAN((devsign*igisl))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL]=(devsign*igidl);
EXIT_IF_ISNAN((devsign*igidl))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJSB]=((-devsign)*Ies);
EXIT_IF_ISNAN(((-devsign)*Ies))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJDB]=((-devsign)*Ied);
EXIT_IF_ISNAN(((-devsign)*Ied))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJSB]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJDB]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]=((((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_III])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJSB])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJDB])-(devsign*(igbinv+igbacc)));
EXIT_IF_ISNAN(((((((-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_III])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGIDL])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGISL])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJSB])-ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IJDB])-(devsign*(igbinv+igbacc))))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ISUB]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_BETA]=beta;
EXIT_IF_ISNAN(beta)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VDSSAT]=Vdsat;
EXIT_IF_ISNAN(Vdsat)
#endif
#ifdef _DYNAMIC
if
((NGATE_i>0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VFB]=((-devsign)*(phib+(Vtm*bsimcmg_lln((NGATE_i/ni)))));
EXIT_IF_ISNAN(((-devsign)*(phib+(Vtm*bsimcmg_lln((NGATE_i/ni))))))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VFB]=(PHIG_i-((pModel->EASUB+(0.5*Eg))+(devsign*phib)));
EXIT_IF_ISNAN((PHIG_i-((pModel->EASUB+(0.5*Eg))+(devsign*phib))))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=Temp(t,GND)V(di,si) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
q0_Tempt_GND=((10.0*Vtm_Tempt_GND)/rc);
#if defined(_DERIVATE2)
  q0_Tempt_GND_Tempt_GND=(+((+0.0*Vtm+0.0*Vtm_Tempt_GND+0.0*Vtm_Tempt_GND+10.0*Vtm_Tempt_GND_Tempt_GND)/rc-((10.0*Vtm_Tempt_GND)*0.0+((10.0*Vtm_Tempt_GND))*0.0+(10.0*Vtm)*0.0)/rc/rc+2*(10.0*Vtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
  q0_Tempt_GND_Vdi_si=(+((+0.0*Vtm+0.0*0.0+0.0*Vtm_Tempt_GND+10.0*0.0)/rc-((10.0*Vtm_Tempt_GND)*0.0+(0.0)*0.0+(10.0*Vtm)*0.0)/rc/rc+2*(10.0*Vtm)*0.0*0.0/rc/rc/rc)+(+0.0*qbs+0.0*0.0+0.0*0.0+2.0*0.0));
#endif
q0_Vdi_si=0.0;
#if defined(_DERIVATE2)
  q0_Vdi_si_Tempt_GND=0.0;
  q0_Vdi_si_Vdi_si=0.0;
#endif
#endif
q0=(((10.0*Vtm)/rc)+(2.0*qbs));
EXIT_IF_ISNAN((((10.0*Vtm)/rc)+(2.0*qbs)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(e,si)V(e,di)V(ge,si)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(si,GND)V(e,GND)V(di,GND) */
T1_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T1_Vdi_d_Vdi_d=0.0;
  T1_Vdi_d_Vsi_s=0.0;
  T1_Vdi_d_Vge_di=0.0;
  T1_Vdi_d_Vge_e=0.0;
  T1_Vdi_d_Ve_si=0.0;
  T1_Vdi_d_Ve_di=0.0;
  T1_Vdi_d_Vge_si=0.0;
  T1_Vdi_d_Vdi_si=0.0;
  T1_Vdi_d_Tempt_GND=0.0;
#endif
T1_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T1_Vsi_s_Vdi_d=0.0;
  T1_Vsi_s_Vsi_s=0.0;
  T1_Vsi_s_Vge_di=0.0;
  T1_Vsi_s_Vge_e=0.0;
  T1_Vsi_s_Ve_si=0.0;
  T1_Vsi_s_Ve_di=0.0;
  T1_Vsi_s_Vge_si=0.0;
  T1_Vsi_s_Vdi_si=0.0;
  T1_Vsi_s_Tempt_GND=0.0;
#endif
T1_Vge_di=0.0;
#if defined(_DERIVATE2)
  T1_Vge_di_Vdi_d=0.0;
  T1_Vge_di_Vsi_s=0.0;
  T1_Vge_di_Vge_di=0.0;
  T1_Vge_di_Vge_e=0.0;
  T1_Vge_di_Ve_si=0.0;
  T1_Vge_di_Ve_di=0.0;
  T1_Vge_di_Vge_si=0.0;
  T1_Vge_di_Vdi_si=0.0;
  T1_Vge_di_Tempt_GND=0.0;
#endif
T1_Vge_e=0.0;
#if defined(_DERIVATE2)
  T1_Vge_e_Vdi_d=0.0;
  T1_Vge_e_Vsi_s=0.0;
  T1_Vge_e_Vge_di=0.0;
  T1_Vge_e_Vge_e=0.0;
  T1_Vge_e_Ve_si=0.0;
  T1_Vge_e_Ve_di=0.0;
  T1_Vge_e_Vge_si=0.0;
  T1_Vge_e_Vdi_si=0.0;
  T1_Vge_e_Tempt_GND=0.0;
#endif
T1_Ve_si=0.0;
#if defined(_DERIVATE2)
  T1_Ve_si_Vdi_d=0.0;
  T1_Ve_si_Vsi_s=0.0;
  T1_Ve_si_Vge_di=0.0;
  T1_Ve_si_Vge_e=0.0;
  T1_Ve_si_Ve_si=0.0;
  T1_Ve_si_Ve_di=0.0;
  T1_Ve_si_Vge_si=0.0;
  T1_Ve_si_Vdi_si=0.0;
  T1_Ve_si_Tempt_GND=0.0;
#endif
T1_Ve_di=0.0;
#if defined(_DERIVATE2)
  T1_Ve_di_Vdi_d=0.0;
  T1_Ve_di_Vsi_s=0.0;
  T1_Ve_di_Vge_di=0.0;
  T1_Ve_di_Vge_e=0.0;
  T1_Ve_di_Ve_si=0.0;
  T1_Ve_di_Ve_di=0.0;
  T1_Ve_di_Vge_si=0.0;
  T1_Ve_di_Vdi_si=0.0;
  T1_Ve_di_Tempt_GND=0.0;
#endif
T1_Vge_si=0.0;
#if defined(_DERIVATE2)
  T1_Vge_si_Vdi_d=0.0;
  T1_Vge_si_Vsi_s=0.0;
  T1_Vge_si_Vge_di=0.0;
  T1_Vge_si_Vge_e=0.0;
  T1_Vge_si_Ve_si=0.0;
  T1_Vge_si_Ve_di=0.0;
  T1_Vge_si_Vge_si=0.0;
  T1_Vge_si_Vdi_si=0.0;
  T1_Vge_si_Tempt_GND=0.0;
#endif
T1_Vdi_si=(Vtm*q0_Vdi_si);
#if defined(_DERIVATE2)
  T1_Vdi_si_Vdi_d=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Vsi_s=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Vge_di=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Vge_e=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Ve_si=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Ve_di=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Vge_si=(+0.0*(Vtm+q0)+0.0*0.0+0.0*q0_Vdi_si+Vtm*(+0.0+0.0));
  T1_Vdi_si_Vdi_si=(+0.0*(Vtm+q0)+0.0*q0_Vdi_si+0.0*q0_Vdi_si+Vtm*(+0.0+q0_Vdi_si_Vdi_si));
  T1_Vdi_si_Tempt_GND=(+0.0*(Vtm+q0)+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm_Tempt_GND*q0_Vdi_si+Vtm*(+0.0+q0_Vdi_si_Tempt_GND));
#endif
T1_Tempt_GND=((Vtm_Tempt_GND*(Vtm+q0))+(Vtm*(Vtm_Tempt_GND+q0_Tempt_GND)));
#if defined(_DERIVATE2)
  T1_Tempt_GND_Vdi_d=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Vsi_s=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Vge_di=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Vge_e=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Ve_si=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Ve_di=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Vge_si=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*0.0+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+0.0));
  T1_Tempt_GND_Vdi_si=(+0.0*(Vtm+q0)+Vtm_Tempt_GND*q0_Vdi_si+0.0*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+0.0+q0_Tempt_GND_Vdi_si));
  T1_Tempt_GND_Tempt_GND=(+Vtm_Tempt_GND_Tempt_GND*(Vtm+q0)+Vtm_Tempt_GND*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm_Tempt_GND*(Vtm_Tempt_GND+q0_Tempt_GND)+Vtm*(+Vtm_Tempt_GND_Tempt_GND+q0_Tempt_GND_Tempt_GND));
#endif
#endif
T1=(Vtm*(Vtm+q0));
EXIT_IF_ISNAN((Vtm*(Vtm+q0)))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(ge,si)V(e,si)V(e,di)V(di,si)Temp(t,GND) ddxprobe=Temp(t,GND)V(ge,GND)V(di,GND)V(si,GND)V(e,GND) */
T2_Vdi_d=((cox*cox)*T1_Vdi_d);
#if defined(_DERIVATE2)
  T2_Vdi_d_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vdi_d);
  T2_Vdi_d_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vsi_s);
  T2_Vdi_d_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vge_di);
  T2_Vdi_d_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vge_e);
  T2_Vdi_d_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vge_si);
  T2_Vdi_d_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Ve_si);
  T2_Vdi_d_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Ve_di);
  T2_Vdi_d_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Vdi_si);
  T2_Vdi_d_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_d+(cox*cox)*T1_Vdi_d_Tempt_GND);
#endif
T2_Vsi_s=((cox*cox)*T1_Vsi_s);
#if defined(_DERIVATE2)
  T2_Vsi_s_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vdi_d);
  T2_Vsi_s_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vsi_s);
  T2_Vsi_s_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vge_di);
  T2_Vsi_s_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vge_e);
  T2_Vsi_s_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vge_si);
  T2_Vsi_s_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Ve_si);
  T2_Vsi_s_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Ve_di);
  T2_Vsi_s_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Vdi_si);
  T2_Vsi_s_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vsi_s+(cox*cox)*T1_Vsi_s_Tempt_GND);
#endif
T2_Vge_di=((cox*cox)*T1_Vge_di);
#if defined(_DERIVATE2)
  T2_Vge_di_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vdi_d);
  T2_Vge_di_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vsi_s);
  T2_Vge_di_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vge_di);
  T2_Vge_di_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vge_e);
  T2_Vge_di_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vge_si);
  T2_Vge_di_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Ve_si);
  T2_Vge_di_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Ve_di);
  T2_Vge_di_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Vdi_si);
  T2_Vge_di_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_di+(cox*cox)*T1_Vge_di_Tempt_GND);
#endif
T2_Vge_e=((cox*cox)*T1_Vge_e);
#if defined(_DERIVATE2)
  T2_Vge_e_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vdi_d);
  T2_Vge_e_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vsi_s);
  T2_Vge_e_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vge_di);
  T2_Vge_e_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vge_e);
  T2_Vge_e_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vge_si);
  T2_Vge_e_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Ve_si);
  T2_Vge_e_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Ve_di);
  T2_Vge_e_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Vdi_si);
  T2_Vge_e_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_e+(cox*cox)*T1_Vge_e_Tempt_GND);
#endif
T2_Vge_si=((cox*cox)*T1_Vge_si);
#if defined(_DERIVATE2)
  T2_Vge_si_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vdi_d);
  T2_Vge_si_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vsi_s);
  T2_Vge_si_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vge_di);
  T2_Vge_si_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vge_e);
  T2_Vge_si_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vge_si);
  T2_Vge_si_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Ve_si);
  T2_Vge_si_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Ve_di);
  T2_Vge_si_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Vdi_si);
  T2_Vge_si_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vge_si+(cox*cox)*T1_Vge_si_Tempt_GND);
#endif
T2_Ve_si=((cox*cox)*T1_Ve_si);
#if defined(_DERIVATE2)
  T2_Ve_si_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vdi_d);
  T2_Ve_si_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vsi_s);
  T2_Ve_si_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vge_di);
  T2_Ve_si_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vge_e);
  T2_Ve_si_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vge_si);
  T2_Ve_si_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Ve_si);
  T2_Ve_si_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Ve_di);
  T2_Ve_si_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Vdi_si);
  T2_Ve_si_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Ve_si+(cox*cox)*T1_Ve_si_Tempt_GND);
#endif
T2_Ve_di=((cox*cox)*T1_Ve_di);
#if defined(_DERIVATE2)
  T2_Ve_di_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vdi_d);
  T2_Ve_di_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vsi_s);
  T2_Ve_di_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vge_di);
  T2_Ve_di_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vge_e);
  T2_Ve_di_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vge_si);
  T2_Ve_di_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Ve_si);
  T2_Ve_di_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Ve_di);
  T2_Ve_di_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Vdi_si);
  T2_Ve_di_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Ve_di+(cox*cox)*T1_Ve_di_Tempt_GND);
#endif
T2_Vdi_si=((cox*cox)*T1_Vdi_si);
#if defined(_DERIVATE2)
  T2_Vdi_si_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vdi_d);
  T2_Vdi_si_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vsi_s);
  T2_Vdi_si_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vge_di);
  T2_Vdi_si_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vge_e);
  T2_Vdi_si_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vge_si);
  T2_Vdi_si_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Ve_si);
  T2_Vdi_si_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Ve_di);
  T2_Vdi_si_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Vdi_si);
  T2_Vdi_si_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Vdi_si+(cox*cox)*T1_Vdi_si_Tempt_GND);
#endif
T2_Tempt_GND=((cox*cox)*T1_Tempt_GND);
#if defined(_DERIVATE2)
  T2_Tempt_GND_Vdi_d=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_d+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vdi_d);
  T2_Tempt_GND_Vsi_s=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vsi_s+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vsi_s);
  T2_Tempt_GND_Vge_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_di+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vge_di);
  T2_Tempt_GND_Vge_e=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_e+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vge_e);
  T2_Tempt_GND_Vge_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vge_si+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vge_si);
  T2_Tempt_GND_Ve_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_si+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Ve_si);
  T2_Tempt_GND_Ve_di=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Ve_di+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Ve_di);
  T2_Tempt_GND_Vdi_si=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Vdi_si+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Vdi_si);
  T2_Tempt_GND_Tempt_GND=(+(+0.0*cox+0.0*0.0+0.0*0.0+cox*0.0)*T1+0.0*T1_Tempt_GND+(0.0)*T1_Tempt_GND+(cox*cox)*T1_Tempt_GND_Tempt_GND);
#endif
#endif
T2=((cox*cox)*T1);
EXIT_IF_ISNAN(((cox*cox)*T1))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATEFORDDX) /* probe=V(di,d)V(si,s)V(ge,di)V(ge,e)V(di,si)V(e,si)V(e,di)V(ge,si)Temp(t,GND) ddxprobe=V(e,GND)V(si,GND)V(di,GND)V(ge,GND)Temp(t,GND) */
T3_Vdi_d=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_d_Vdi_d=0.0;
  T3_Vdi_d_Vsi_s=0.0;
  T3_Vdi_d_Vge_di=0.0;
  T3_Vdi_d_Vge_e=0.0;
  T3_Vdi_d_Vdi_si=0.0;
  T3_Vdi_d_Ve_si=0.0;
  T3_Vdi_d_Ve_di=0.0;
  T3_Vdi_d_Vge_si=0.0;
  T3_Vdi_d_Tempt_GND=0.0;
#endif
T3_Vsi_s=0.0;
#if defined(_DERIVATE2)
  T3_Vsi_s_Vdi_d=0.0;
  T3_Vsi_s_Vsi_s=0.0;
  T3_Vsi_s_Vge_di=0.0;
  T3_Vsi_s_Vge_e=0.0;
  T3_Vsi_s_Vdi_si=0.0;
  T3_Vsi_s_Ve_si=0.0;
  T3_Vsi_s_Ve_di=0.0;
  T3_Vsi_s_Vge_si=0.0;
  T3_Vsi_s_Tempt_GND=0.0;
#endif
T3_Vge_di=0.0;
#if defined(_DERIVATE2)
  T3_Vge_di_Vdi_d=0.0;
  T3_Vge_di_Vsi_s=0.0;
  T3_Vge_di_Vge_di=0.0;
  T3_Vge_di_Vge_e=0.0;
  T3_Vge_di_Vdi_si=0.0;
  T3_Vge_di_Ve_si=0.0;
  T3_Vge_di_Ve_di=0.0;
  T3_Vge_di_Vge_si=0.0;
  T3_Vge_di_Tempt_GND=0.0;
#endif
T3_Vge_e=0.0;
#if defined(_DERIVATE2)
  T3_Vge_e_Vdi_d=0.0;
  T3_Vge_e_Vsi_s=0.0;
  T3_Vge_e_Vge_di=0.0;
  T3_Vge_e_Vge_e=0.0;
  T3_Vge_e_Vdi_si=0.0;
  T3_Vge_e_Ve_si=0.0;
  T3_Vge_e_Ve_di=0.0;
  T3_Vge_e_Vge_si=0.0;
  T3_Vge_e_Tempt_GND=0.0;
#endif
T3_Vdi_si=0.0;
#if defined(_DERIVATE2)
  T3_Vdi_si_Vdi_d=0.0;
  T3_Vdi_si_Vsi_s=0.0;
  T3_Vdi_si_Vge_di=0.0;
  T3_Vdi_si_Vge_e=0.0;
  T3_Vdi_si_Vdi_si=0.0;
  T3_Vdi_si_Ve_si=0.0;
  T3_Vdi_si_Ve_di=0.0;
  T3_Vdi_si_Vge_si=0.0;
  T3_Vdi_si_Tempt_GND=0.0;
#endif
T3_Ve_si=0.0;
#if defined(_DERIVATE2)
  T3_Ve_si_Vdi_d=0.0;
  T3_Ve_si_Vsi_s=0.0;
  T3_Ve_si_Vge_di=0.0;
  T3_Ve_si_Vge_e=0.0;
  T3_Ve_si_Vdi_si=0.0;
  T3_Ve_si_Ve_si=0.0;
  T3_Ve_si_Ve_di=0.0;
  T3_Ve_si_Vge_si=0.0;
  T3_Ve_si_Tempt_GND=0.0;
#endif
T3_Ve_di=0.0;
#if defined(_DERIVATE2)
  T3_Ve_di_Vdi_d=0.0;
  T3_Ve_di_Vsi_s=0.0;
  T3_Ve_di_Vge_di=0.0;
  T3_Ve_di_Vge_e=0.0;
  T3_Ve_di_Vdi_si=0.0;
  T3_Ve_di_Ve_si=0.0;
  T3_Ve_di_Ve_di=0.0;
  T3_Ve_di_Vge_si=0.0;
  T3_Ve_di_Tempt_GND=0.0;
#endif
T3_Vge_si=0.0;
#if defined(_DERIVATE2)
  T3_Vge_si_Vdi_d=0.0;
  T3_Vge_si_Vsi_s=0.0;
  T3_Vge_si_Vge_di=0.0;
  T3_Vge_si_Vge_e=0.0;
  T3_Vge_si_Vdi_si=0.0;
  T3_Vge_si_Ve_si=0.0;
  T3_Vge_si_Ve_di=0.0;
  T3_Vge_si_Vge_si=0.0;
  T3_Vge_si_Tempt_GND=0.0;
#endif
T3_Tempt_GND=((((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*Vtm)+((((2.0*1.60219e-19)*ni)*epssub)*Vtm_Tempt_GND));
#if defined(_DERIVATE2)
  T3_Tempt_GND_Vdi_d=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Vsi_s=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Vge_di=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Vge_e=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Vdi_si=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Ve_si=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Ve_di=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Vge_si=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*0.0+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*0.0)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((0.0)*ni)*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*0.0+(((0.0)*ni)*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*0.0);
  T3_Tempt_GND_Tempt_GND=(+(+(+(+0.0*1.60219e-19+0.0*0.0+0.0*0.0+2.0*0.0)*ni+0.0*ni_Tempt_GND+(0.0)*ni_Tempt_GND+(2.0*1.60219e-19)*ni_Tempt_GND_Tempt_GND)*epssub+((2.0*1.60219e-19)*ni_Tempt_GND)*0.0+((((0.0)*ni)+((2.0*1.60219e-19)*ni_Tempt_GND)))*0.0+((2.0*1.60219e-19)*ni)*0.0)*Vtm+((2.0*1.60219e-19)*ni_Tempt_GND)*epssub*Vtm_Tempt_GND+(((((0.0)*ni)+((2.0*1.60219e-19)*ni_Tempt_GND)))*epssub)*Vtm_Tempt_GND+(((2.0*1.60219e-19)*ni)*epssub)*Vtm_Tempt_GND_Tempt_GND);
#endif
#endif
T3=((((2.0*1.60219e-19)*ni)*epssub)*Vtm);
EXIT_IF_ISNAN(((((2.0*1.60219e-19)*ni)*epssub)*Vtm))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VTH]=(ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VFB]+(devsign*(((((((Vtm*bsimcmg_lln((T2/T3)))+dvch_qm)+phib)+qbs)+Vtm)+dvth_all)-pModel->DELVTRAND)));
EXIT_IF_ISNAN((ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_VFB]+(devsign*(((((((Vtm*bsimcmg_lln((T2/T3)))+dvch_qm)+phib)+qbs)+Vtm)+dvth_all)-pModel->DELVTRAND))))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GM]=+((devsign*ids_Vge_e))+((devsign*ids_Vge_si))+((devsign*ids_Vge_di)); /* indeed 3 */
EXIT_IF_ISNAN(GM)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GDS]=+((devsign*ids_Vdi_si))-((devsign*ids_Ve_di))-((devsign*ids_Vge_di)); /* indeed 3 */
EXIT_IF_ISNAN(GDS)
#endif
#endif
#ifdef _DYNAMIC
if
((pModel->BULKMOD!=0))
{
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMBS]=-((devsign*ids_Vge_e))+((devsign*ids_Ve_si))+((devsign*ids_Ve_di)); /* indeed 3 */
EXIT_IF_ISNAN(GMBS)
#endif
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_GMBS]=0.0;
EXIT_IF_ISNAN(0.0)
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QGI]=((devsign*qg)+(devsign*qg_acc));
EXIT_IF_ISNAN(((devsign*qg)+(devsign*qg_acc)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QDI]=(devsign*qd);
EXIT_IF_ISNAN((devsign*qd))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QSI]=(devsign*qs);
EXIT_IF_ISNAN((devsign*qs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QBI]=(devsign*(qb+qb_acc));
EXIT_IF_ISNAN((devsign*(qb+qb_acc)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QG]=((((((devsign*qg)+qgs_parasitic)+qgd_parasitic)+((pModel->CGEOMOD==1)?(qgs_fr+qgd_fr):0))+(devsign*qg_acc))-(devsign*Qeg));
EXIT_IF_ISNAN(((((((devsign*qg)+qgs_parasitic)+qgd_parasitic)+((pModel->CGEOMOD==1)?(qgs_fr+qgd_fr):0))+(devsign*qg_acc))-(devsign*Qeg)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QD]=((((devsign*qd)-qgd_parasitic)-((pModel->CGEOMOD==1)?qgd_fr:0))-(devsign*Qed));
EXIT_IF_ISNAN(((((devsign*qd)-qgd_parasitic)-((pModel->CGEOMOD==1)?qgd_fr:0))-(devsign*Qed)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QS]=((((devsign*qs)-qgs_parasitic)-((pModel->CGEOMOD==1)?qgs_fr:0))-(devsign*Qes));
EXIT_IF_ISNAN(((((devsign*qs)-qgs_parasitic)-((pModel->CGEOMOD==1)?qgs_fr:0))-(devsign*Qes)))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_QB]=((devsign*(qb+qb_acc))+(devsign*((Qeg+Qes)+Qed)));
EXIT_IF_ISNAN(((devsign*(qb+qb_acc))+(devsign*((Qeg+Qes)+Qed))))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGGI]=+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGGI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGSI]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGSI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGDI]=+(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGDI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGEI]=+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGEI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSGI]=+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSGI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSDI]=-(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSDI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSSI]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSSI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSEI]=+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSEI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDGI]=+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDGI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDDI]=+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDDI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDSI]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDSI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDEI]=+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDEI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CEGI]=+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CEGI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CEDI]=-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CEDI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CESI]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CESI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CEEI]=-(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CEEI)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGG]=+(0.0)+(0.0)+(0.0)+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGG)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGS]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGS)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGD]=+(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGD)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGE]=+(0.0)+(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGE)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSG]=+(0.0)+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSG)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSD]=-(0.0)+(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSD)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSS]=-(0.0)-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSS)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CSE]=+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CSE)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDG]=+(0.0)+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDG)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDD]=+(0.0)-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDD)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDS]=-(0.0)-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDS)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDE]=+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDE)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CEG]=+(0.0)+(0.0)+(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CEG)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CED]=-(0.0)-(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CED)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CES]=-(0.0)-(0.0)-(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CES)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CEE]=-(0.0)+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CEE)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGSEXT]=-((-(qgs_parasitic_Ve_si+((pModel->CGEOMOD==1)?qgs_fr_Ve_si:0.0))))-((-(qgs_parasitic_Vge_si+((pModel->CGEOMOD==1)?qgs_fr_Vge_si:0.0))))-((-(qgs_parasitic_Vdi_si+((pModel->CGEOMOD==1)?qgs_fr_Vdi_si:0.0)))); /* indeed 3 */
EXIT_IF_ISNAN(CGSEXT)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGDEXT]=-((-(qgd_parasitic_Vge_di+((pModel->CGEOMOD==1)?qgd_fr_Vge_di:0.0))))-((-(qgd_parasitic_Ve_di+((pModel->CGEOMOD==1)?qgd_fr_Ve_di:0.0))))+((-(qgd_parasitic_Vdi_si+((pModel->CGEOMOD==1)?qgd_fr_Vdi_si:0.0)))); /* indeed 3 */
EXIT_IF_ISNAN(CGDEXT)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBOV]=-(Qeg_Vge_e)+(Qeg_Ve_si)+(Qeg_Ve_di)+(Qeg_Ve_ge); /* indeed 3 */
EXIT_IF_ISNAN(CGBOV)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBOV]=((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBOV]);
EXIT_IF_ISNAN(((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGBOV]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJST]=+(Qes_Vsi_s)-(Qes_Ve_si)-(Qes_Vge_si)-(Qes_Vdi_si); /* indeed 3 */
EXIT_IF_ISNAN(CJST)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJST]=((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJST]);
EXIT_IF_ISNAN(((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJST]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJDT]=+(Qed_Vdi_d)-(Qed_Vge_di)-(Qed_Ve_di)+(Qed_Vdi_si); /* indeed 3 */
EXIT_IF_ISNAN(CJDT)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJDT]=((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJDT]);
EXIT_IF_ISNAN(((-devsign)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CJDT]))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RSGEO]=RSourceGeo;
EXIT_IF_ISNAN(RSourceGeo)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_RDGEO]=RDrainGeo;
EXIT_IF_ISNAN(RDrainGeo)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CFGEO]=Cfr_geo;
EXIT_IF_ISNAN(Cfr_geo)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_TOTAL_K]=DevTemp;
EXIT_IF_ISNAN(DevTemp)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_TOTAL_C]=(DevTemp-273.15);
EXIT_IF_ISNAN((DevTemp-273.15))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_T_DELTA_SH]=NP(t);
EXIT_IF_ISNAN(NP(t))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGS]=(devsign*igs);
EXIT_IF_ISNAN((devsign*igs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGD]=(devsign*igd);
EXIT_IF_ISNAN((devsign*igd))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCS]=(devsign*igcs);
EXIT_IF_ISNAN((devsign*igcs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGCD]=(devsign*igcd);
EXIT_IF_ISNAN((devsign*igcd))
#endif
#ifdef _DYNAMIC
if
((pModel->BULKMOD==0))
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGBS]=(devsign*igbs);
EXIT_IF_ISNAN((devsign*igbs))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGBD]=(devsign*igbd);
EXIT_IF_ISNAN((devsign*igbd))
#endif
}
else
{
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGBINV]=(devsign*igbinv);
EXIT_IF_ISNAN((devsign*igbinv))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_IGBACC]=(devsign*igbacc);
EXIT_IF_ISNAN((devsign*igbacc))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVG]=+(ids_Vge_e)+(ids_Vge_si)+(ids_Vge_di); /* indeed 3 */
EXIT_IF_ISNAN(DIDSDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVG]=((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVG]);
EXIT_IF_ISNAN(((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVS]=-(ids_Vdi_si)-(ids_Ve_si)-(ids_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIDSDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVS]=((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVS]);
EXIT_IF_ISNAN(((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVD]=+(ids_Vdi_si)-(ids_Ve_di)-(ids_Vge_di); /* indeed 3 */
EXIT_IF_ISNAN(DIDSDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVD]=((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVD]);
EXIT_IF_ISNAN(((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVTH]=+(ids_Tempt_GND); /* indeed 3 */
EXIT_IF_ISNAN(DIDSDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVTH]=((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVTH]);
EXIT_IF_ISNAN(((devsign*sigvds)*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIDSDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVG]=+((igs_Vge_si+igcs_Vge_si))+((igs_Vge_di+igcs_Vge_di))+((igs_Vge_e+igcs_Vge_e)); /* indeed 3 */
EXIT_IF_ISNAN(DIGSDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVG]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVG]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVS]=-((igs_Vge_si+igcs_Vge_si))-((igs_Ve_si+igcs_Ve_si))-((igs_Vdi_si+igcs_Vdi_si))+(igcs_Vsi_s); /* indeed 3 */
EXIT_IF_ISNAN(DIGSDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVS]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVS]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVD]=-((igs_Vge_di+igcs_Vge_di))-((igs_Ve_di+igcs_Ve_di))+((igs_Vdi_si+igcs_Vdi_si))+(igcs_Vdi_d); /* indeed 3 */
EXIT_IF_ISNAN(DIGSDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVD]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVD]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVTH]=+((igs_Tempt_GND+igcs_Tempt_GND)); /* indeed 3 */
EXIT_IF_ISNAN(DIGSDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVTH]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVTH]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGSDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVG]=+((igd_Vge_si+igcd_Vge_si))+((igd_Vge_di+igcd_Vge_di))+((igd_Vge_e+igcd_Vge_e)); /* indeed 3 */
EXIT_IF_ISNAN(DIGDDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVG]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVG]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVS]=-((igd_Vge_si+igcd_Vge_si))-((igd_Ve_si+igcd_Ve_si))-((igd_Vdi_si+igcd_Vdi_si))+(igcd_Vsi_s); /* indeed 3 */
EXIT_IF_ISNAN(DIGDDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVS]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVS]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVD]=-((igd_Vge_di+igcd_Vge_di))-((igd_Ve_di+igcd_Ve_di))+((igd_Vdi_si+igcd_Vdi_si))+(igcd_Vdi_d); /* indeed 3 */
EXIT_IF_ISNAN(DIGDDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVD]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVD]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVTH]=+((igd_Tempt_GND+igcd_Tempt_GND)); /* indeed 3 */
EXIT_IF_ISNAN(DIGDDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVTH]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVTH]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGDDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVG]=+(Iii_Vge_di)+(Iii_Vge_e)+(Iii_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIIIDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVG]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVG]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVS]=-(Iii_Ve_si)-(Iii_Vge_si)-(Iii_Vdi_si); /* indeed 3 */
EXIT_IF_ISNAN(DIIIDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVS]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVS]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVD]=-(Iii_Vge_di)-(Iii_Ve_di)+(Iii_Vdi_si); /* indeed 3 */
EXIT_IF_ISNAN(DIIIDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVD]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVD]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVTH]=+(Iii_Tempt_GND); /* indeed 3 */
EXIT_IF_ISNAN(DIIIDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVTH]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVTH]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIIIDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVG]=+(igidl_Vge_di)+(igidl_Vge_e)+(igidl_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIGIDLDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVG]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVG]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVS]=+(igidl_Vsi_s)-(igidl_Vdi_si)-(igidl_Ve_si)-(igidl_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIGIDLDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVS]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVS]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVD]=-(igidl_Vge_di)+(igidl_Vdi_d)+(igidl_Vdi_si)-(igidl_Ve_di); /* indeed 3 */
EXIT_IF_ISNAN(DIGIDLDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVD]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVD]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVTH]=+(igidl_Tempt_GND); /* indeed 3 */
EXIT_IF_ISNAN(DIGIDLDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVTH]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVTH]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGIDLDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVG]=+(igisl_Vge_di)+(igisl_Vge_e)+(igisl_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIGISLDVG)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVG]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVG]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVG]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVS]=+(igisl_Vsi_s)-(igisl_Vdi_si)-(igisl_Ve_si)-(igisl_Vge_si); /* indeed 3 */
EXIT_IF_ISNAN(DIGISLDVS)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVS]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVS]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVS]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVD]=-(igisl_Vge_di)+(igisl_Vdi_d)+(igisl_Vdi_si)-(igisl_Ve_di); /* indeed 3 */
EXIT_IF_ISNAN(DIGISLDVD)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVD]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVD]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVD]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVTH]=+(igisl_Tempt_GND); /* indeed 3 */
EXIT_IF_ISNAN(DIGISLDVTH)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVTH]=(devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVTH]);
EXIT_IF_ISNAN((devsign*ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DIGISLDVTH]))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CGT]=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CGT)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CST]=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CST)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_CDT]=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(CDT)
#endif
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_ITH]=(ids*vds);
EXIT_IF_ISNAN((ids*vds))
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DITHDVTH]=+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(DITHDVTH)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DITHDVG]=+(0.0)+(0.0)+(0.0); /* indeed 3 */
EXIT_IF_ISNAN(DITHDVG)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DITHDVS]=-(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(DITHDVS)
#endif
#endif
#if defined(_DYNAMIC)
#if defined(_DDX)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_DITHDVD]=+(0.0)-(0.0)-(0.0); /* indeed 3 */
EXIT_IF_ISNAN(DITHDVD)
#endif
#endif
